# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class H235_SECURITY_MESSAGES:

    _name_  = 'H235-SECURITY-MESSAGES'
    _oid_   = []
    
    _obj_ = [
        'ChallengeString',
        'TimeStamp',
        'RandomVal',
        'Password',
        'Identifier',
        'KeyMaterial',
        'KeyMaterialExt',
        'NonStandardParameter',
        'DHset',
        'DHsetExt',
        'ECpoint',
        'ECKASDH',
        'ECGDSASignature',
        'TypedCertificate',
        'AuthenticationBES',
        'AuthenticationMechanism',
        'ClearToken',
        'ProfileElement',
        'Element',
        'SIGNED',
        'ENCRYPTED',
        'HASHED',
        'IV8',
        'IV16',
        'Params',
        'EncodedGeneralToken',
        'PwdCertToken',
        'EncodedPwdCertToken',
        'CryptoToken',
        'H235Key',
        'KeySignedMaterial',
        'EncodedKeySignedMaterial',
        'H235CertificateSignature',
        'ReturnSig',
        'EncodedReturnSig',
        'KeySyncMaterial',
        'EncodedKeySyncMaterial',
        'V3KeySyncMaterial',
        ]
    _type_ = [
        'ChallengeString',
        'TimeStamp',
        'RandomVal',
        'Password',
        'Identifier',
        'KeyMaterial',
        'KeyMaterialExt',
        'NonStandardParameter',
        'DHset',
        'DHsetExt',
        'ECpoint',
        'ECKASDH',
        'ECGDSASignature',
        'TypedCertificate',
        'AuthenticationBES',
        'AuthenticationMechanism',
        'ClearToken',
        'ProfileElement',
        'Element',
        'SIGNED',
        'ENCRYPTED',
        'HASHED',
        'IV8',
        'IV16',
        'Params',
        'EncodedGeneralToken',
        'PwdCertToken',
        'EncodedPwdCertToken',
        'CryptoToken',
        'H235Key',
        'KeySignedMaterial',
        'EncodedKeySignedMaterial',
        'H235CertificateSignature',
        'ReturnSig',
        'EncodedReturnSig',
        'KeySyncMaterial',
        'EncodedKeySyncMaterial',
        'V3KeySyncMaterial',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        'SIGNED',
        'ENCRYPTED',
        'HASHED',
        ]
    
    #-----< ChallengeString >-----#
    ChallengeString = OCT_STR(name='ChallengeString', mode=MODE_TYPE)
    ChallengeString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=128)], ev=None, er=[])
    
    #-----< TimeStamp >-----#
    TimeStamp = INT(name='TimeStamp', mode=MODE_TYPE)
    TimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    
    #-----< RandomVal >-----#
    RandomVal = INT(name='RandomVal', mode=MODE_TYPE)
    
    #-----< Password >-----#
    Password = STR_BMP(name='Password', mode=MODE_TYPE)
    Password._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< Identifier >-----#
    Identifier = STR_BMP(name='Identifier', mode=MODE_TYPE)
    Identifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< KeyMaterial >-----#
    KeyMaterial = BIT_STR(name='KeyMaterial', mode=MODE_TYPE)
    KeyMaterial._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< KeyMaterialExt >-----#
    KeyMaterialExt = BIT_STR(name='KeyMaterialExt', mode=MODE_TYPE)
    KeyMaterialExt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2049, ub=65536)], ev=None, er=[])
    
    #-----< NonStandardParameter >-----#
    NonStandardParameter = SEQ(name='NonStandardParameter', mode=MODE_TYPE)
    _NonStandardParameter_nonStandardIdentifier = OID(name='nonStandardIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NonStandardParameter_data = OCT_STR(name='data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    NonStandardParameter._cont = ASN1Dict([
        ('nonStandardIdentifier', _NonStandardParameter_nonStandardIdentifier),
        ('data', _NonStandardParameter_data),
        ])
    NonStandardParameter._ext = None
    
    #-----< DHset >-----#
    DHset = SEQ(name='DHset', mode=MODE_TYPE)
    _DHset_halfkey = BIT_STR(name='halfkey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DHset_halfkey._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2048)], ev=None, er=[])
    _DHset_modSize = BIT_STR(name='modSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DHset_modSize._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2048)], ev=None, er=[])
    _DHset_generator = BIT_STR(name='generator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DHset_generator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2048)], ev=None, er=[])
    DHset._cont = ASN1Dict([
        ('halfkey', _DHset_halfkey),
        ('modSize', _DHset_modSize),
        ('generator', _DHset_generator),
        ])
    DHset._ext = []
    
    #-----< DHsetExt >-----#
    DHsetExt = SEQ(name='DHsetExt', mode=MODE_TYPE)
    _DHsetExt_halfkey = BIT_STR(name='halfkey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DHsetExt_halfkey._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2049, ub=65536)], ev=None, er=[])
    _DHsetExt_modSize = BIT_STR(name='modSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DHsetExt_modSize._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2049, ub=65536)], ev=None, er=[])
    _DHsetExt_generator = BIT_STR(name='generator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DHsetExt_generator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2049, ub=65536)], ev=None, er=[])
    DHsetExt._cont = ASN1Dict([
        ('halfkey', _DHsetExt_halfkey),
        ('modSize', _DHsetExt_modSize),
        ('generator', _DHsetExt_generator),
        ])
    DHsetExt._ext = []
    
    #-----< ECpoint >-----#
    ECpoint = SEQ(name='ECpoint', mode=MODE_TYPE)
    _ECpoint_x = BIT_STR(name='x', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECpoint_x._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _ECpoint_y = BIT_STR(name='y', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECpoint_y._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    ECpoint._cont = ASN1Dict([
        ('x', _ECpoint_x),
        ('y', _ECpoint_y),
        ])
    ECpoint._ext = []
    
    #-----< ECKASDH >-----#
    ECKASDH = CHOICE(name='ECKASDH', mode=MODE_TYPE)
    _ECKASDH_eckasdhp = SEQ(name='eckasdhp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdhp_public_key = SEQ(name='public-key', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ECpoint')))
    __ECKASDH_eckasdhp_modulus = BIT_STR(name='modulus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdhp_modulus._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    __ECKASDH_eckasdhp_base = SEQ(name='base', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ECpoint')))
    __ECKASDH_eckasdhp_weierstrassA = BIT_STR(name='weierstrassA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdhp_weierstrassA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    __ECKASDH_eckasdhp_weierstrassB = BIT_STR(name='weierstrassB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdhp_weierstrassB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _ECKASDH_eckasdhp._cont = ASN1Dict([
        ('public-key', __ECKASDH_eckasdhp_public_key),
        ('modulus', __ECKASDH_eckasdhp_modulus),
        ('base', __ECKASDH_eckasdhp_base),
        ('weierstrassA', __ECKASDH_eckasdhp_weierstrassA),
        ('weierstrassB', __ECKASDH_eckasdhp_weierstrassB),
        ])
    _ECKASDH_eckasdhp._ext = None
    _ECKASDH_eckasdh2 = SEQ(name='eckasdh2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdh2_public_key = SEQ(name='public-key', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ECpoint')))
    __ECKASDH_eckasdh2_fieldSize = BIT_STR(name='fieldSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdh2_fieldSize._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    __ECKASDH_eckasdh2_base = SEQ(name='base', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ECpoint')))
    __ECKASDH_eckasdh2_weierstrassA = BIT_STR(name='weierstrassA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdh2_weierstrassA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    __ECKASDH_eckasdh2_weierstrassB = BIT_STR(name='weierstrassB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECKASDH_eckasdh2_weierstrassB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _ECKASDH_eckasdh2._cont = ASN1Dict([
        ('public-key', __ECKASDH_eckasdh2_public_key),
        ('fieldSize', __ECKASDH_eckasdh2_fieldSize),
        ('base', __ECKASDH_eckasdh2_base),
        ('weierstrassA', __ECKASDH_eckasdh2_weierstrassA),
        ('weierstrassB', __ECKASDH_eckasdh2_weierstrassB),
        ])
    _ECKASDH_eckasdh2._ext = None
    ECKASDH._cont = ASN1Dict([
        ('eckasdhp', _ECKASDH_eckasdhp),
        ('eckasdh2', _ECKASDH_eckasdh2),
        ])
    ECKASDH._ext = []
    
    #-----< ECGDSASignature >-----#
    ECGDSASignature = SEQ(name='ECGDSASignature', mode=MODE_TYPE)
    _ECGDSASignature_r = BIT_STR(name='r', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECGDSASignature_r._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _ECGDSASignature_s = BIT_STR(name='s', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECGDSASignature_s._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    ECGDSASignature._cont = ASN1Dict([
        ('r', _ECGDSASignature_r),
        ('s', _ECGDSASignature_s),
        ])
    ECGDSASignature._ext = None
    
    #-----< TypedCertificate >-----#
    TypedCertificate = SEQ(name='TypedCertificate', mode=MODE_TYPE)
    _TypedCertificate_type = OID(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TypedCertificate_certificate = OCT_STR(name='certificate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TypedCertificate._cont = ASN1Dict([
        ('type', _TypedCertificate_type),
        ('certificate', _TypedCertificate_certificate),
        ])
    TypedCertificate._ext = []
    
    #-----< AuthenticationBES >-----#
    AuthenticationBES = CHOICE(name='AuthenticationBES', mode=MODE_TYPE)
    _AuthenticationBES_default = NULL(name='default', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationBES_radius = NULL(name='radius', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AuthenticationBES._cont = ASN1Dict([
        ('default', _AuthenticationBES_default),
        ('radius', _AuthenticationBES_radius),
        ])
    AuthenticationBES._ext = []
    
    #-----< AuthenticationMechanism >-----#
    AuthenticationMechanism = CHOICE(name='AuthenticationMechanism', mode=MODE_TYPE)
    _AuthenticationMechanism_dhExch = NULL(name='dhExch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationMechanism_pwdSymEnc = NULL(name='pwdSymEnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationMechanism_pwdHash = NULL(name='pwdHash', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationMechanism_certSign = NULL(name='certSign', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationMechanism_ipsec = NULL(name='ipsec', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationMechanism_tls = NULL(name='tls', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationMechanism_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'NonStandardParameter')))
    _AuthenticationMechanism_authenticationBES = CHOICE(name='authenticationBES', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'AuthenticationBES')))
    _AuthenticationMechanism_keyExch = OID(name='keyExch', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AuthenticationMechanism._cont = ASN1Dict([
        ('dhExch', _AuthenticationMechanism_dhExch),
        ('pwdSymEnc', _AuthenticationMechanism_pwdSymEnc),
        ('pwdHash', _AuthenticationMechanism_pwdHash),
        ('certSign', _AuthenticationMechanism_certSign),
        ('ipsec', _AuthenticationMechanism_ipsec),
        ('tls', _AuthenticationMechanism_tls),
        ('nonStandard', _AuthenticationMechanism_nonStandard),
        ('authenticationBES', _AuthenticationMechanism_authenticationBES),
        ('keyExch', _AuthenticationMechanism_keyExch),
        ])
    AuthenticationMechanism._ext = ['authenticationBES', 'keyExch']
    
    #-----< ClearToken >-----#
    ClearToken = SEQ(name='ClearToken', mode=MODE_TYPE)
    _ClearToken_tokenOID = OID(name='tokenOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ClearToken_timeStamp = INT(name='timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'TimeStamp')), opt=True)
    _ClearToken_password = STR_BMP(name='password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Password')), opt=True)
    _ClearToken_dhkey = SEQ(name='dhkey', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'DHset')), opt=True)
    _ClearToken_challenge = OCT_STR(name='challenge', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ChallengeString')), opt=True)
    _ClearToken_random = INT(name='random', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')), opt=True)
    _ClearToken_certificate = SEQ(name='certificate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'TypedCertificate')), opt=True)
    _ClearToken_generalID = STR_BMP(name='generalID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Identifier')), opt=True)
    _ClearToken_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'NonStandardParameter')), opt=True)
    _ClearToken_eckasdhkey = CHOICE(name='eckasdhkey', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ECKASDH')), opt=True)
    _ClearToken_sendersID = STR_BMP(name='sendersID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Identifier')), opt=True)
    _ClearToken_h235Key = CHOICE(name='h235Key', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'H235Key')), opt=True)
    _ClearToken_profileInfo = SEQ_OF(name='profileInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ClearToken_profileInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ProfileElement')))
    _ClearToken_profileInfo._cont = __ClearToken_profileInfo__item_
    _ClearToken_dhkeyext = SEQ(name='dhkeyext', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'DHsetExt')), opt=True)
    ClearToken._cont = ASN1Dict([
        ('tokenOID', _ClearToken_tokenOID),
        ('timeStamp', _ClearToken_timeStamp),
        ('password', _ClearToken_password),
        ('dhkey', _ClearToken_dhkey),
        ('challenge', _ClearToken_challenge),
        ('random', _ClearToken_random),
        ('certificate', _ClearToken_certificate),
        ('generalID', _ClearToken_generalID),
        ('nonStandard', _ClearToken_nonStandard),
        ('eckasdhkey', _ClearToken_eckasdhkey),
        ('sendersID', _ClearToken_sendersID),
        ('h235Key', _ClearToken_h235Key),
        ('profileInfo', _ClearToken_profileInfo),
        ('dhkeyext', _ClearToken_dhkeyext),
        ])
    ClearToken._ext = ['eckasdhkey', 'sendersID', 'h235Key', 'profileInfo', 'dhkeyext']
    
    #-----< ProfileElement >-----#
    ProfileElement = SEQ(name='ProfileElement', mode=MODE_TYPE)
    _ProfileElement_elementID = INT(name='elementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProfileElement_elementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ProfileElement_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')), opt=True)
    _ProfileElement_element = CHOICE(name='element', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Element')), opt=True)
    ProfileElement._cont = ASN1Dict([
        ('elementID', _ProfileElement_elementID),
        ('paramS', _ProfileElement_paramS),
        ('element', _ProfileElement_element),
        ])
    ProfileElement._ext = []
    
    #-----< Element >-----#
    Element = CHOICE(name='Element', mode=MODE_TYPE)
    _Element_octets = OCT_STR(name='octets', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Element_integer = INT(name='integer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Element_bits = BIT_STR(name='bits', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Element_name = STR_BMP(name='name', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Element_flag = BOOL(name='flag', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Element._cont = ASN1Dict([
        ('octets', _Element_octets),
        ('integer', _Element_integer),
        ('bits', _Element_bits),
        ('name', _Element_name),
        ('flag', _Element_flag),
        ])
    Element._ext = []
    
    #-----< SIGNED >-----#
    SIGNED = SEQ(name='SIGNED', mode=MODE_TYPE, param=True)
    
    #-----< ENCRYPTED >-----#
    ENCRYPTED = SEQ(name='ENCRYPTED', mode=MODE_TYPE)
    _ENCRYPTED_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENCRYPTED_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    _ENCRYPTED_encryptedData = OCT_STR(name='encryptedData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ENCRYPTED._cont = ASN1Dict([
        ('algorithmOID', _ENCRYPTED_algorithmOID),
        ('paramS', _ENCRYPTED_paramS),
        ('encryptedData', _ENCRYPTED_encryptedData),
        ])
    ENCRYPTED._ext = None
    
    #-----< HASHED >-----#
    HASHED = SEQ(name='HASHED', mode=MODE_TYPE)
    _HASHED_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HASHED_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    _HASHED_hash = BIT_STR(name='hash', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    HASHED._cont = ASN1Dict([
        ('algorithmOID', _HASHED_algorithmOID),
        ('paramS', _HASHED_paramS),
        ('hash', _HASHED_hash),
        ])
    HASHED._ext = None
    
    #-----< IV8 >-----#
    IV8 = OCT_STR(name='IV8', mode=MODE_TYPE)
    IV8._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IV16 >-----#
    IV16 = OCT_STR(name='IV16', mode=MODE_TYPE)
    IV16._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< Params >-----#
    Params = SEQ(name='Params', mode=MODE_TYPE)
    _Params_ranInt = INT(name='ranInt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Params_iv8 = OCT_STR(name='iv8', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'IV8')), opt=True)
    _Params_iv16 = OCT_STR(name='iv16', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'IV16')), opt=True)
    _Params_iv = OCT_STR(name='iv', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Params_clearSalt = OCT_STR(name='clearSalt', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Params._cont = ASN1Dict([
        ('ranInt', _Params_ranInt),
        ('iv8', _Params_iv8),
        ('iv16', _Params_iv16),
        ('iv', _Params_iv),
        ('clearSalt', _Params_clearSalt),
        ])
    Params._ext = ['iv16', 'iv', 'clearSalt']
    
    #-----< EncodedGeneralToken >-----#
    EncodedGeneralToken = OPEN(name='EncodedGeneralToken', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    _EncodedGeneralToken_val_0 = SEQ(name='EncodedGeneralToken', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ClearToken')))
    EncodedGeneralToken._const_val = ASN1Set(rv=[_EncodedGeneralToken_val_0], ev=None)
    
    #-----< PwdCertToken >-----#
    PwdCertToken = SEQ(name='PwdCertToken', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ClearToken')))
    
    #-----< EncodedPwdCertToken >-----#
    EncodedPwdCertToken = OPEN(name='EncodedPwdCertToken', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    _EncodedPwdCertToken_val_0 = SEQ(name='EncodedPwdCertToken', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'PwdCertToken')))
    EncodedPwdCertToken._const_val = ASN1Set(rv=[_EncodedPwdCertToken_val_0], ev=None)
    
    #-----< CryptoToken >-----#
    CryptoToken = CHOICE(name='CryptoToken', mode=MODE_TYPE)
    _CryptoToken_cryptoEncryptedToken = SEQ(name='cryptoEncryptedToken', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoEncryptedToken_tokenOID = OID(name='tokenOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoEncryptedToken_token = SEQ(name='token', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ENCRYPTED')))
    ___CryptoToken_cryptoEncryptedToken_token_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CryptoToken_cryptoEncryptedToken_token_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    ___CryptoToken_cryptoEncryptedToken_token_encryptedData = OCT_STR(name='encryptedData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoEncryptedToken_token._cont = ASN1Dict([
        ('algorithmOID', ___CryptoToken_cryptoEncryptedToken_token_algorithmOID),
        ('paramS', ___CryptoToken_cryptoEncryptedToken_token_paramS),
        ('encryptedData', ___CryptoToken_cryptoEncryptedToken_token_encryptedData),
        ])
    __CryptoToken_cryptoEncryptedToken_token._ext = None
    _CryptoToken_cryptoEncryptedToken._cont = ASN1Dict([
        ('tokenOID', __CryptoToken_cryptoEncryptedToken_tokenOID),
        ('token', __CryptoToken_cryptoEncryptedToken_token),
        ])
    _CryptoToken_cryptoEncryptedToken._ext = None
    _CryptoToken_cryptoSignedToken = SEQ(name='cryptoSignedToken', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoSignedToken_tokenOID = OID(name='tokenOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoSignedToken_token = SEQ(name='token', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'SIGNED')))
    ___CryptoToken_cryptoSignedToken_token_toBeSigned = OPEN(name='toBeSigned', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'EncodedGeneralToken')))
    ___CryptoToken_cryptoSignedToken_token_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CryptoToken_cryptoSignedToken_token_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    ___CryptoToken_cryptoSignedToken_token_signature = BIT_STR(name='signature', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoSignedToken_token._cont = ASN1Dict([
        ('toBeSigned', ___CryptoToken_cryptoSignedToken_token_toBeSigned),
        ('algorithmOID', ___CryptoToken_cryptoSignedToken_token_algorithmOID),
        ('paramS', ___CryptoToken_cryptoSignedToken_token_paramS),
        ('signature', ___CryptoToken_cryptoSignedToken_token_signature),
        ])
    __CryptoToken_cryptoSignedToken_token._ext = None
    _CryptoToken_cryptoSignedToken._cont = ASN1Dict([
        ('tokenOID', __CryptoToken_cryptoSignedToken_tokenOID),
        ('token', __CryptoToken_cryptoSignedToken_token),
        ])
    _CryptoToken_cryptoSignedToken._ext = None
    _CryptoToken_cryptoHashedToken = SEQ(name='cryptoHashedToken', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoHashedToken_tokenOID = OID(name='tokenOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoHashedToken_hashedVals = SEQ(name='hashedVals', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ClearToken')))
    __CryptoToken_cryptoHashedToken_token = SEQ(name='token', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'HASHED')))
    ___CryptoToken_cryptoHashedToken_token_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CryptoToken_cryptoHashedToken_token_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    ___CryptoToken_cryptoHashedToken_token_hash = BIT_STR(name='hash', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoHashedToken_token._cont = ASN1Dict([
        ('algorithmOID', ___CryptoToken_cryptoHashedToken_token_algorithmOID),
        ('paramS', ___CryptoToken_cryptoHashedToken_token_paramS),
        ('hash', ___CryptoToken_cryptoHashedToken_token_hash),
        ])
    __CryptoToken_cryptoHashedToken_token._ext = None
    _CryptoToken_cryptoHashedToken._cont = ASN1Dict([
        ('tokenOID', __CryptoToken_cryptoHashedToken_tokenOID),
        ('hashedVals', __CryptoToken_cryptoHashedToken_hashedVals),
        ('token', __CryptoToken_cryptoHashedToken_token),
        ])
    _CryptoToken_cryptoHashedToken._ext = None
    _CryptoToken_cryptoPwdEncr = SEQ(name='cryptoPwdEncr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ENCRYPTED')))
    __CryptoToken_cryptoPwdEncr_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CryptoToken_cryptoPwdEncr_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    __CryptoToken_cryptoPwdEncr_encryptedData = OCT_STR(name='encryptedData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CryptoToken_cryptoPwdEncr._cont = ASN1Dict([
        ('algorithmOID', __CryptoToken_cryptoPwdEncr_algorithmOID),
        ('paramS', __CryptoToken_cryptoPwdEncr_paramS),
        ('encryptedData', __CryptoToken_cryptoPwdEncr_encryptedData),
        ])
    _CryptoToken_cryptoPwdEncr._ext = None
    CryptoToken._cont = ASN1Dict([
        ('cryptoEncryptedToken', _CryptoToken_cryptoEncryptedToken),
        ('cryptoSignedToken', _CryptoToken_cryptoSignedToken),
        ('cryptoHashedToken', _CryptoToken_cryptoHashedToken),
        ('cryptoPwdEncr', _CryptoToken_cryptoPwdEncr),
        ])
    CryptoToken._ext = []
    
    #-----< H235Key >-----#
    H235Key = CHOICE(name='H235Key', mode=MODE_TYPE)
    _H235Key_secureChannel = BIT_STR(name='secureChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'KeyMaterial')))
    _H235Key_sharedSecret = SEQ(name='sharedSecret', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ENCRYPTED')))
    __H235Key_sharedSecret_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H235Key_sharedSecret_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    __H235Key_sharedSecret_encryptedData = OCT_STR(name='encryptedData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H235Key_sharedSecret._cont = ASN1Dict([
        ('algorithmOID', __H235Key_sharedSecret_algorithmOID),
        ('paramS', __H235Key_sharedSecret_paramS),
        ('encryptedData', __H235Key_sharedSecret_encryptedData),
        ])
    _H235Key_sharedSecret._ext = None
    _H235Key_certProtectedKey = SEQ(name='certProtectedKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'SIGNED')))
    __H235Key_certProtectedKey_toBeSigned = OPEN(name='toBeSigned', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'EncodedKeySignedMaterial')))
    __H235Key_certProtectedKey_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H235Key_certProtectedKey_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    __H235Key_certProtectedKey_signature = BIT_STR(name='signature', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H235Key_certProtectedKey._cont = ASN1Dict([
        ('toBeSigned', __H235Key_certProtectedKey_toBeSigned),
        ('algorithmOID', __H235Key_certProtectedKey_algorithmOID),
        ('paramS', __H235Key_certProtectedKey_paramS),
        ('signature', __H235Key_certProtectedKey_signature),
        ])
    _H235Key_certProtectedKey._ext = None
    _H235Key_secureSharedSecret = SEQ(name='secureSharedSecret', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'V3KeySyncMaterial')))
    _H235Key_secureChannelExt = BIT_STR(name='secureChannelExt', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'KeyMaterialExt')))
    H235Key._cont = ASN1Dict([
        ('secureChannel', _H235Key_secureChannel),
        ('sharedSecret', _H235Key_sharedSecret),
        ('certProtectedKey', _H235Key_certProtectedKey),
        ('secureSharedSecret', _H235Key_secureSharedSecret),
        ('secureChannelExt', _H235Key_secureChannelExt),
        ])
    H235Key._ext = ['secureSharedSecret', 'secureChannelExt']
    
    #-----< KeySignedMaterial >-----#
    KeySignedMaterial = SEQ(name='KeySignedMaterial', mode=MODE_TYPE)
    _KeySignedMaterial_generalId = STR_BMP(name='generalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Identifier')))
    _KeySignedMaterial_mrandom = INT(name='mrandom', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')))
    _KeySignedMaterial_srandom = INT(name='srandom', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')), opt=True)
    _KeySignedMaterial_timeStamp = INT(name='timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'TimeStamp')), opt=True)
    _KeySignedMaterial_encrptval = SEQ(name='encrptval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ENCRYPTED')))
    __KeySignedMaterial_encrptval_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __KeySignedMaterial_encrptval_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    __KeySignedMaterial_encrptval_encryptedData = OCT_STR(name='encryptedData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KeySignedMaterial_encrptval._cont = ASN1Dict([
        ('algorithmOID', __KeySignedMaterial_encrptval_algorithmOID),
        ('paramS', __KeySignedMaterial_encrptval_paramS),
        ('encryptedData', __KeySignedMaterial_encrptval_encryptedData),
        ])
    _KeySignedMaterial_encrptval._ext = None
    KeySignedMaterial._cont = ASN1Dict([
        ('generalId', _KeySignedMaterial_generalId),
        ('mrandom', _KeySignedMaterial_mrandom),
        ('srandom', _KeySignedMaterial_srandom),
        ('timeStamp', _KeySignedMaterial_timeStamp),
        ('encrptval', _KeySignedMaterial_encrptval),
        ])
    KeySignedMaterial._ext = None
    
    #-----< EncodedKeySignedMaterial >-----#
    EncodedKeySignedMaterial = OPEN(name='EncodedKeySignedMaterial', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    _EncodedKeySignedMaterial_val_0 = SEQ(name='EncodedKeySignedMaterial', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'KeySignedMaterial')))
    EncodedKeySignedMaterial._const_val = ASN1Set(rv=[_EncodedKeySignedMaterial_val_0], ev=None)
    
    #-----< H235CertificateSignature >-----#
    H235CertificateSignature = SEQ(name='H235CertificateSignature', mode=MODE_TYPE)
    _H235CertificateSignature_certificate = SEQ(name='certificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'TypedCertificate')))
    _H235CertificateSignature_responseRandom = INT(name='responseRandom', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')))
    _H235CertificateSignature_requesterRandom = INT(name='requesterRandom', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')), opt=True)
    _H235CertificateSignature_signature = SEQ(name='signature', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'SIGNED')))
    __H235CertificateSignature_signature_toBeSigned = OPEN(name='toBeSigned', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'EncodedReturnSig')))
    __H235CertificateSignature_signature_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H235CertificateSignature_signature_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    __H235CertificateSignature_signature_signature = BIT_STR(name='signature', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H235CertificateSignature_signature._cont = ASN1Dict([
        ('toBeSigned', __H235CertificateSignature_signature_toBeSigned),
        ('algorithmOID', __H235CertificateSignature_signature_algorithmOID),
        ('paramS', __H235CertificateSignature_signature_paramS),
        ('signature', __H235CertificateSignature_signature_signature),
        ])
    _H235CertificateSignature_signature._ext = None
    H235CertificateSignature._cont = ASN1Dict([
        ('certificate', _H235CertificateSignature_certificate),
        ('responseRandom', _H235CertificateSignature_responseRandom),
        ('requesterRandom', _H235CertificateSignature_requesterRandom),
        ('signature', _H235CertificateSignature_signature),
        ])
    H235CertificateSignature._ext = []
    
    #-----< ReturnSig >-----#
    ReturnSig = SEQ(name='ReturnSig', mode=MODE_TYPE)
    _ReturnSig_generalId = STR_BMP(name='generalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Identifier')))
    _ReturnSig_responseRandom = INT(name='responseRandom', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')))
    _ReturnSig_requestRandom = INT(name='requestRandom', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'RandomVal')), opt=True)
    _ReturnSig_certificate = SEQ(name='certificate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'TypedCertificate')), opt=True)
    ReturnSig._cont = ASN1Dict([
        ('generalId', _ReturnSig_generalId),
        ('responseRandom', _ReturnSig_responseRandom),
        ('requestRandom', _ReturnSig_requestRandom),
        ('certificate', _ReturnSig_certificate),
        ])
    ReturnSig._ext = None
    
    #-----< EncodedReturnSig >-----#
    EncodedReturnSig = OPEN(name='EncodedReturnSig', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    _EncodedReturnSig_val_0 = SEQ(name='EncodedReturnSig', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'ReturnSig')))
    EncodedReturnSig._const_val = ASN1Set(rv=[_EncodedReturnSig_val_0], ev=None)
    
    #-----< KeySyncMaterial >-----#
    KeySyncMaterial = SEQ(name='KeySyncMaterial', mode=MODE_TYPE)
    _KeySyncMaterial_generalID = STR_BMP(name='generalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Identifier')))
    _KeySyncMaterial_keyMaterial = BIT_STR(name='keyMaterial', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'KeyMaterial')))
    KeySyncMaterial._cont = ASN1Dict([
        ('generalID', _KeySyncMaterial_generalID),
        ('keyMaterial', _KeySyncMaterial_keyMaterial),
        ])
    KeySyncMaterial._ext = []
    
    #-----< EncodedKeySyncMaterial >-----#
    EncodedKeySyncMaterial = OPEN(name='EncodedKeySyncMaterial', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    _EncodedKeySyncMaterial_val_0 = SEQ(name='EncodedKeySyncMaterial', mode=MODE_TYPE, typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'KeySyncMaterial')))
    EncodedKeySyncMaterial._const_val = ASN1Set(rv=[_EncodedKeySyncMaterial_val_0], ev=None)
    
    #-----< V3KeySyncMaterial >-----#
    V3KeySyncMaterial = SEQ(name='V3KeySyncMaterial', mode=MODE_TYPE)
    _V3KeySyncMaterial_generalID = STR_BMP(name='generalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Identifier')), opt=True)
    _V3KeySyncMaterial_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _V3KeySyncMaterial_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')))
    _V3KeySyncMaterial_encryptedSessionKey = OCT_STR(name='encryptedSessionKey', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _V3KeySyncMaterial_encryptedSaltingKey = OCT_STR(name='encryptedSaltingKey', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _V3KeySyncMaterial_clearSaltingKey = OCT_STR(name='clearSaltingKey', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _V3KeySyncMaterial_paramSsalt = SEQ(name='paramSsalt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('H235-SECURITY-MESSAGES', 'Params')), opt=True)
    _V3KeySyncMaterial_keyDerivationOID = OID(name='keyDerivationOID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _V3KeySyncMaterial_genericKeyMaterial = OCT_STR(name='genericKeyMaterial', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    V3KeySyncMaterial._cont = ASN1Dict([
        ('generalID', _V3KeySyncMaterial_generalID),
        ('algorithmOID', _V3KeySyncMaterial_algorithmOID),
        ('paramS', _V3KeySyncMaterial_paramS),
        ('encryptedSessionKey', _V3KeySyncMaterial_encryptedSessionKey),
        ('encryptedSaltingKey', _V3KeySyncMaterial_encryptedSaltingKey),
        ('clearSaltingKey', _V3KeySyncMaterial_clearSaltingKey),
        ('paramSsalt', _V3KeySyncMaterial_paramSsalt),
        ('keyDerivationOID', _V3KeySyncMaterial_keyDerivationOID),
        ('genericKeyMaterial', _V3KeySyncMaterial_genericKeyMaterial),
        ])
    V3KeySyncMaterial._ext = ['genericKeyMaterial']
    
    _all_ = [
        ChallengeString,
        TimeStamp,
        RandomVal,
        Password,
        Identifier,
        KeyMaterial,
        KeyMaterialExt,
        _NonStandardParameter_nonStandardIdentifier,
        _NonStandardParameter_data,
        NonStandardParameter,
        _DHset_halfkey,
        _DHset_modSize,
        _DHset_generator,
        DHset,
        _DHsetExt_halfkey,
        _DHsetExt_modSize,
        _DHsetExt_generator,
        DHsetExt,
        _ECpoint_x,
        _ECpoint_y,
        ECpoint,
        __ECKASDH_eckasdhp_public_key,
        __ECKASDH_eckasdhp_modulus,
        __ECKASDH_eckasdhp_base,
        __ECKASDH_eckasdhp_weierstrassA,
        __ECKASDH_eckasdhp_weierstrassB,
        _ECKASDH_eckasdhp,
        __ECKASDH_eckasdh2_public_key,
        __ECKASDH_eckasdh2_fieldSize,
        __ECKASDH_eckasdh2_base,
        __ECKASDH_eckasdh2_weierstrassA,
        __ECKASDH_eckasdh2_weierstrassB,
        _ECKASDH_eckasdh2,
        ECKASDH,
        _ECGDSASignature_r,
        _ECGDSASignature_s,
        ECGDSASignature,
        _TypedCertificate_type,
        _TypedCertificate_certificate,
        TypedCertificate,
        _AuthenticationBES_default,
        _AuthenticationBES_radius,
        AuthenticationBES,
        _AuthenticationMechanism_dhExch,
        _AuthenticationMechanism_pwdSymEnc,
        _AuthenticationMechanism_pwdHash,
        _AuthenticationMechanism_certSign,
        _AuthenticationMechanism_ipsec,
        _AuthenticationMechanism_tls,
        _AuthenticationMechanism_nonStandard,
        _AuthenticationMechanism_authenticationBES,
        _AuthenticationMechanism_keyExch,
        AuthenticationMechanism,
        _ClearToken_tokenOID,
        _ClearToken_timeStamp,
        _ClearToken_password,
        _ClearToken_dhkey,
        _ClearToken_challenge,
        _ClearToken_random,
        _ClearToken_certificate,
        _ClearToken_generalID,
        _ClearToken_nonStandard,
        _ClearToken_eckasdhkey,
        _ClearToken_sendersID,
        _ClearToken_h235Key,
        __ClearToken_profileInfo__item_,
        _ClearToken_profileInfo,
        _ClearToken_dhkeyext,
        ClearToken,
        _ProfileElement_elementID,
        _ProfileElement_paramS,
        _ProfileElement_element,
        ProfileElement,
        _Element_octets,
        _Element_integer,
        _Element_bits,
        _Element_name,
        _Element_flag,
        Element,
        _ENCRYPTED_algorithmOID,
        _ENCRYPTED_paramS,
        _ENCRYPTED_encryptedData,
        ENCRYPTED,
        _HASHED_algorithmOID,
        _HASHED_paramS,
        _HASHED_hash,
        HASHED,
        IV8,
        IV16,
        _Params_ranInt,
        _Params_iv8,
        _Params_iv16,
        _Params_iv,
        _Params_clearSalt,
        Params,
        _EncodedGeneralToken_val_0,
        EncodedGeneralToken,
        PwdCertToken,
        _EncodedPwdCertToken_val_0,
        EncodedPwdCertToken,
        __CryptoToken_cryptoEncryptedToken_tokenOID,
        ___CryptoToken_cryptoEncryptedToken_token_algorithmOID,
        ___CryptoToken_cryptoEncryptedToken_token_paramS,
        ___CryptoToken_cryptoEncryptedToken_token_encryptedData,
        __CryptoToken_cryptoEncryptedToken_token,
        _CryptoToken_cryptoEncryptedToken,
        __CryptoToken_cryptoSignedToken_tokenOID,
        ___CryptoToken_cryptoSignedToken_token_toBeSigned,
        ___CryptoToken_cryptoSignedToken_token_algorithmOID,
        ___CryptoToken_cryptoSignedToken_token_paramS,
        ___CryptoToken_cryptoSignedToken_token_signature,
        __CryptoToken_cryptoSignedToken_token,
        _CryptoToken_cryptoSignedToken,
        __CryptoToken_cryptoHashedToken_tokenOID,
        __CryptoToken_cryptoHashedToken_hashedVals,
        ___CryptoToken_cryptoHashedToken_token_algorithmOID,
        ___CryptoToken_cryptoHashedToken_token_paramS,
        ___CryptoToken_cryptoHashedToken_token_hash,
        __CryptoToken_cryptoHashedToken_token,
        _CryptoToken_cryptoHashedToken,
        __CryptoToken_cryptoPwdEncr_algorithmOID,
        __CryptoToken_cryptoPwdEncr_paramS,
        __CryptoToken_cryptoPwdEncr_encryptedData,
        _CryptoToken_cryptoPwdEncr,
        CryptoToken,
        _H235Key_secureChannel,
        __H235Key_sharedSecret_algorithmOID,
        __H235Key_sharedSecret_paramS,
        __H235Key_sharedSecret_encryptedData,
        _H235Key_sharedSecret,
        __H235Key_certProtectedKey_toBeSigned,
        __H235Key_certProtectedKey_algorithmOID,
        __H235Key_certProtectedKey_paramS,
        __H235Key_certProtectedKey_signature,
        _H235Key_certProtectedKey,
        _H235Key_secureSharedSecret,
        _H235Key_secureChannelExt,
        H235Key,
        _KeySignedMaterial_generalId,
        _KeySignedMaterial_mrandom,
        _KeySignedMaterial_srandom,
        _KeySignedMaterial_timeStamp,
        __KeySignedMaterial_encrptval_algorithmOID,
        __KeySignedMaterial_encrptval_paramS,
        __KeySignedMaterial_encrptval_encryptedData,
        _KeySignedMaterial_encrptval,
        KeySignedMaterial,
        _EncodedKeySignedMaterial_val_0,
        EncodedKeySignedMaterial,
        _H235CertificateSignature_certificate,
        _H235CertificateSignature_responseRandom,
        _H235CertificateSignature_requesterRandom,
        __H235CertificateSignature_signature_toBeSigned,
        __H235CertificateSignature_signature_algorithmOID,
        __H235CertificateSignature_signature_paramS,
        __H235CertificateSignature_signature_signature,
        _H235CertificateSignature_signature,
        H235CertificateSignature,
        _ReturnSig_generalId,
        _ReturnSig_responseRandom,
        _ReturnSig_requestRandom,
        _ReturnSig_certificate,
        ReturnSig,
        _EncodedReturnSig_val_0,
        EncodedReturnSig,
        _KeySyncMaterial_generalID,
        _KeySyncMaterial_keyMaterial,
        KeySyncMaterial,
        _EncodedKeySyncMaterial_val_0,
        EncodedKeySyncMaterial,
        _V3KeySyncMaterial_generalID,
        _V3KeySyncMaterial_algorithmOID,
        _V3KeySyncMaterial_paramS,
        _V3KeySyncMaterial_encryptedSessionKey,
        _V3KeySyncMaterial_encryptedSaltingKey,
        _V3KeySyncMaterial_clearSaltingKey,
        _V3KeySyncMaterial_paramSsalt,
        _V3KeySyncMaterial_keyDerivationOID,
        _V3KeySyncMaterial_genericKeyMaterial,
        V3KeySyncMaterial,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(H235_SECURITY_MESSAGES, _IMPL_)
