# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class Lightweight_Directory_Access_Protocol_V3:

    _name_  = 'Lightweight-Directory-Access-Protocol-V3'
    _oid_   = [1, 3, 6, 1, 1, 18]
    
    _obj_ = [
        'LDAPMessage',
        'MessageID',
        'maxInt',
        'LDAPString',
        'LDAPOID',
        'LDAPDN',
        'RelativeLDAPDN',
        'AttributeDescription',
        'AttributeValue',
        'AttributeValueAssertion',
        'AssertionValue',
        'PartialAttribute',
        'Attribute',
        'MatchingRuleId',
        'LDAPResult',
        'Referral',
        'URI',
        'Controls',
        'Control',
        'BindRequest',
        'AuthenticationChoice',
        'SaslCredentials',
        'BindResponse',
        'UnbindRequest',
        'SearchRequest',
        'AttributeSelection',
        'Filter',
        'SubstringFilter',
        'MatchingRuleAssertion',
        'SearchResultEntry',
        'PartialAttributeList',
        'SearchResultReference',
        'SearchResultDone',
        'ModifyRequest',
        'ModifyResponse',
        'AddRequest',
        'AttributeList',
        'AddResponse',
        'DelRequest',
        'DelResponse',
        'ModifyDNRequest',
        'ModifyDNResponse',
        'CompareRequest',
        'CompareResponse',
        'AbandonRequest',
        'ExtendedRequest',
        'ExtendedResponse',
        'IntermediateResponse',
        ]
    _type_ = [
        'LDAPMessage',
        'MessageID',
        'LDAPString',
        'LDAPOID',
        'LDAPDN',
        'RelativeLDAPDN',
        'AttributeDescription',
        'AttributeValue',
        'AttributeValueAssertion',
        'AssertionValue',
        'PartialAttribute',
        'Attribute',
        'MatchingRuleId',
        'LDAPResult',
        'Referral',
        'URI',
        'Controls',
        'Control',
        'BindRequest',
        'AuthenticationChoice',
        'SaslCredentials',
        'BindResponse',
        'UnbindRequest',
        'SearchRequest',
        'AttributeSelection',
        'Filter',
        'SubstringFilter',
        'MatchingRuleAssertion',
        'SearchResultEntry',
        'PartialAttributeList',
        'SearchResultReference',
        'SearchResultDone',
        'ModifyRequest',
        'ModifyResponse',
        'AddRequest',
        'AttributeList',
        'AddResponse',
        'DelRequest',
        'DelResponse',
        'ModifyDNRequest',
        'ModifyDNResponse',
        'CompareRequest',
        'CompareResponse',
        'AbandonRequest',
        'ExtendedRequest',
        'ExtendedResponse',
        'IntermediateResponse',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxInt',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LDAPMessage >-----#
    LDAPMessage = SEQ(name='LDAPMessage', mode=MODE_TYPE)
    _LDAPMessage_messageID = INT(name='messageID', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    _LDAPMessage_protocolOp = CHOICE(name='protocolOp', mode=MODE_TYPE)
    __LDAPMessage_protocolOp_bindRequest = SEQ(name='bindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindRequest')))
    __LDAPMessage_protocolOp_bindResponse = SEQ(name='bindResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindResponse')))
    __LDAPMessage_protocolOp_unbindRequest = NULL(name='unbindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'UnbindRequest')))
    __LDAPMessage_protocolOp_searchRequest = SEQ(name='searchRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchRequest')))
    __LDAPMessage_protocolOp_searchResEntry = SEQ(name='searchResEntry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultEntry')))
    __LDAPMessage_protocolOp_searchResDone = SEQ(name='searchResDone', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultDone')))
    __LDAPMessage_protocolOp_searchResRef = SEQ_OF(name='searchResRef', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultReference')))
    __LDAPMessage_protocolOp_modifyRequest = SEQ(name='modifyRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyRequest')))
    __LDAPMessage_protocolOp_modifyResponse = SEQ(name='modifyResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyResponse')))
    __LDAPMessage_protocolOp_addRequest = SEQ(name='addRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddRequest')))
    __LDAPMessage_protocolOp_addResponse = SEQ(name='addResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddResponse')))
    __LDAPMessage_protocolOp_delRequest = OCT_STR(name='delRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelRequest')))
    __LDAPMessage_protocolOp_delResponse = SEQ(name='delResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelResponse')))
    __LDAPMessage_protocolOp_modDNRequest = SEQ(name='modDNRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNRequest')))
    __LDAPMessage_protocolOp_modDNResponse = SEQ(name='modDNResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNResponse')))
    __LDAPMessage_protocolOp_compareRequest = SEQ(name='compareRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareRequest')))
    __LDAPMessage_protocolOp_compareResponse = SEQ(name='compareResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareResponse')))
    __LDAPMessage_protocolOp_abandonRequest = INT(name='abandonRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AbandonRequest')))
    __LDAPMessage_protocolOp_extendedReq = SEQ(name='extendedReq', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedRequest')))
    __LDAPMessage_protocolOp_extendedResp = SEQ(name='extendedResp', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedResponse')))
    __LDAPMessage_protocolOp_intermediateResponse = SEQ(name='intermediateResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'IntermediateResponse')))
    _LDAPMessage_protocolOp._cont = ASN1Dict([
        ('bindRequest', __LDAPMessage_protocolOp_bindRequest),
        ('bindResponse', __LDAPMessage_protocolOp_bindResponse),
        ('unbindRequest', __LDAPMessage_protocolOp_unbindRequest),
        ('searchRequest', __LDAPMessage_protocolOp_searchRequest),
        ('searchResEntry', __LDAPMessage_protocolOp_searchResEntry),
        ('searchResDone', __LDAPMessage_protocolOp_searchResDone),
        ('searchResRef', __LDAPMessage_protocolOp_searchResRef),
        ('modifyRequest', __LDAPMessage_protocolOp_modifyRequest),
        ('modifyResponse', __LDAPMessage_protocolOp_modifyResponse),
        ('addRequest', __LDAPMessage_protocolOp_addRequest),
        ('addResponse', __LDAPMessage_protocolOp_addResponse),
        ('delRequest', __LDAPMessage_protocolOp_delRequest),
        ('delResponse', __LDAPMessage_protocolOp_delResponse),
        ('modDNRequest', __LDAPMessage_protocolOp_modDNRequest),
        ('modDNResponse', __LDAPMessage_protocolOp_modDNResponse),
        ('compareRequest', __LDAPMessage_protocolOp_compareRequest),
        ('compareResponse', __LDAPMessage_protocolOp_compareResponse),
        ('abandonRequest', __LDAPMessage_protocolOp_abandonRequest),
        ('extendedReq', __LDAPMessage_protocolOp_extendedReq),
        ('extendedResp', __LDAPMessage_protocolOp_extendedResp),
        ('intermediateResponse', __LDAPMessage_protocolOp_intermediateResponse),
        ])
    _LDAPMessage_protocolOp._ext = ['intermediateResponse']
    _LDAPMessage_controls = SEQ_OF(name='controls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Controls')), opt=True)
    LDAPMessage._cont = ASN1Dict([
        ('messageID', _LDAPMessage_messageID),
        ('protocolOp', _LDAPMessage_protocolOp),
        ('controls', _LDAPMessage_controls),
        ])
    LDAPMessage._ext = []
    
    #-----< MessageID >-----#
    MessageID = INT(name='MessageID', mode=MODE_TYPE)
    MessageID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< maxInt >-----#
    maxInt = INT(name='maxInt', mode=MODE_VALUE)
    maxInt._val = 2147483647
    
    #-----< LDAPString >-----#
    LDAPString = OCT_STR(name='LDAPString', mode=MODE_TYPE)
    
    #-----< LDAPOID >-----#
    LDAPOID = OCT_STR(name='LDAPOID', mode=MODE_TYPE)
    
    #-----< LDAPDN >-----#
    LDAPDN = OCT_STR(name='LDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< RelativeLDAPDN >-----#
    RelativeLDAPDN = OCT_STR(name='RelativeLDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeDescription >-----#
    AttributeDescription = OCT_STR(name='AttributeDescription', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeValue >-----#
    AttributeValue = OCT_STR(name='AttributeValue', mode=MODE_TYPE)
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name='AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_attributeDesc = OCT_STR(name='attributeDesc', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _AttributeValueAssertion_assertionValue = OCT_STR(name='assertionValue', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    AttributeValueAssertion._cont = ASN1Dict([
        ('attributeDesc', _AttributeValueAssertion_attributeDesc),
        ('assertionValue', _AttributeValueAssertion_assertionValue),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< AssertionValue >-----#
    AssertionValue = OCT_STR(name='AssertionValue', mode=MODE_TYPE)
    
    #-----< PartialAttribute >-----#
    PartialAttribute = SEQ(name='PartialAttribute', mode=MODE_TYPE)
    _PartialAttribute_type = OCT_STR(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _PartialAttribute_vals = SET_OF(name='vals', mode=MODE_TYPE)
    __PartialAttribute_vals_value = OCT_STR(name='value', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValue')))
    _PartialAttribute_vals._cont = __PartialAttribute_vals_value
    PartialAttribute._cont = ASN1Dict([
        ('type', _PartialAttribute_type),
        ('vals', _PartialAttribute_vals),
        ])
    PartialAttribute._ext = []
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    
    #-----< MatchingRuleId >-----#
    MatchingRuleId = OCT_STR(name='MatchingRuleId', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< LDAPResult >-----#
    LDAPResult = SEQ(name='LDAPResult', mode=MODE_TYPE)
    _LDAPResult_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _LDAPResult_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _LDAPResult_resultCode._ext = []
    _LDAPResult_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _LDAPResult_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _LDAPResult_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    LDAPResult._cont = ASN1Dict([
        ('resultCode', _LDAPResult_resultCode),
        ('matchedDN', _LDAPResult_matchedDN),
        ('diagnosticMessage', _LDAPResult_diagnosticMessage),
        ('referral', _LDAPResult_referral),
        ])
    LDAPResult._ext = []
    
    #-----< Referral >-----#
    Referral = SEQ_OF(name='Referral', mode=MODE_TYPE)
    _Referral_uri = OCT_STR(name='uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    Referral._cont = _Referral_uri
    Referral._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< URI >-----#
    URI = OCT_STR(name='URI', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< Controls >-----#
    Controls = SEQ_OF(name='Controls', mode=MODE_TYPE)
    _Controls_control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Control')))
    Controls._cont = _Controls_control
    
    #-----< Control >-----#
    Control = SEQ(name='Control', mode=MODE_TYPE)
    _Control_controlType = OCT_STR(name='controlType', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _Control_criticality = BOOL(name='criticality', mode=MODE_TYPE, default=False)
    _Control_controlValue = OCT_STR(name='controlValue', mode=MODE_TYPE, opt=True)
    Control._cont = ASN1Dict([
        ('controlType', _Control_controlType),
        ('criticality', _Control_criticality),
        ('controlValue', _Control_controlValue),
        ])
    Control._ext = []
    
    #-----< BindRequest >-----#
    BindRequest = SEQ(name='BindRequest', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _BindRequest_version = INT(name='version', mode=MODE_TYPE)
    _BindRequest_version._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _BindRequest_name = OCT_STR(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindRequest_authentication = CHOICE(name='authentication', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AuthenticationChoice')))
    BindRequest._cont = ASN1Dict([
        ('version', _BindRequest_version),
        ('name', _BindRequest_name),
        ('authentication', _BindRequest_authentication),
        ])
    BindRequest._ext = []
    
    #-----< AuthenticationChoice >-----#
    AuthenticationChoice = CHOICE(name='AuthenticationChoice', mode=MODE_TYPE)
    _AuthenticationChoice_simple = OCT_STR(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationChoice_sasl = SEQ(name='sasl', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SaslCredentials')))
    AuthenticationChoice._cont = ASN1Dict([
        ('simple', _AuthenticationChoice_simple),
        ('sasl', _AuthenticationChoice_sasl),
        ])
    AuthenticationChoice._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name='SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = OCT_STR(name='mechanism', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _SaslCredentials_credentials = OCT_STR(name='credentials', mode=MODE_TYPE, opt=True)
    SaslCredentials._cont = ASN1Dict([
        ('mechanism', _SaslCredentials_mechanism),
        ('credentials', _SaslCredentials_credentials),
        ])
    SaslCredentials._ext = []
    
    #-----< BindResponse >-----#
    BindResponse = SEQ(name='BindResponse', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _BindResponse_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _BindResponse_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _BindResponse_resultCode._ext = []
    _BindResponse_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindResponse_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _BindResponse_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _BindResponse_serverSaslCreds = OCT_STR(name='serverSaslCreds', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BindResponse._cont = ASN1Dict([
        ('resultCode', _BindResponse_resultCode),
        ('matchedDN', _BindResponse_matchedDN),
        ('diagnosticMessage', _BindResponse_diagnosticMessage),
        ('referral', _BindResponse_referral),
        ('serverSaslCreds', _BindResponse_serverSaslCreds),
        ])
    BindResponse._ext = []
    
    #-----< UnbindRequest >-----#
    UnbindRequest = NULL(name='UnbindRequest', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    
    #-----< SearchRequest >-----#
    SearchRequest = SEQ(name='SearchRequest', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchRequest_baseObject = OCT_STR(name='baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchRequest_scope = ENUM(name='scope', mode=MODE_TYPE)
    _SearchRequest_scope._cont = ASN1Dict([('baseObject', 0), ('singleLevel', 1), ('wholeSubtree', 2)])
    _SearchRequest_scope._ext = []
    _SearchRequest_derefAliases = ENUM(name='derefAliases', mode=MODE_TYPE)
    _SearchRequest_derefAliases._cont = ASN1Dict([('neverDerefAliases', 0), ('derefInSearching', 1), ('derefFindingBaseObj', 2), ('derefAlways', 3)])
    _SearchRequest_derefAliases._ext = []
    _SearchRequest_sizeLimit = INT(name='sizeLimit', mode=MODE_TYPE)
    _SearchRequest_sizeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_timeLimit = INT(name='timeLimit', mode=MODE_TYPE)
    _SearchRequest_timeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_typesOnly = BOOL(name='typesOnly', mode=MODE_TYPE)
    _SearchRequest_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _SearchRequest_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeSelection')))
    SearchRequest._cont = ASN1Dict([
        ('baseObject', _SearchRequest_baseObject),
        ('scope', _SearchRequest_scope),
        ('derefAliases', _SearchRequest_derefAliases),
        ('sizeLimit', _SearchRequest_sizeLimit),
        ('timeLimit', _SearchRequest_timeLimit),
        ('typesOnly', _SearchRequest_typesOnly),
        ('filter', _SearchRequest_filter),
        ('attributes', _SearchRequest_attributes),
        ])
    SearchRequest._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SEQ_OF(name='AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection_selector = OCT_STR(name='selector', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    AttributeSelection._cont = _AttributeSelection_selector
    
    #-----< Filter >-----#
    Filter = CHOICE(name='Filter', mode=MODE_TYPE)
    _Filter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_and__filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_and_._cont = __Filter_and__filter
    _Filter_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_or__filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_or_._cont = __Filter_or__filter
    _Filter_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_equalityMatch = SEQ(name='equalityMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_substrings = SEQ(name='substrings', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SubstringFilter')))
    _Filter_greaterOrEqual = SEQ(name='greaterOrEqual', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_lessOrEqual = SEQ(name='lessOrEqual', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_present = OCT_STR(name='present', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _Filter_approxMatch = SEQ(name='approxMatch', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_extensibleMatch = SEQ(name='extensibleMatch', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleAssertion')))
    Filter._cont = ASN1Dict([
        ('and', _Filter_and_),
        ('or', _Filter_or_),
        ('not', _Filter_not_),
        ('equalityMatch', _Filter_equalityMatch),
        ('substrings', _Filter_substrings),
        ('greaterOrEqual', _Filter_greaterOrEqual),
        ('lessOrEqual', _Filter_lessOrEqual),
        ('present', _Filter_present),
        ('approxMatch', _Filter_approxMatch),
        ('extensibleMatch', _Filter_extensibleMatch),
        ])
    Filter._ext = []
    
    #-----< SubstringFilter >-----#
    SubstringFilter = SEQ(name='SubstringFilter', mode=MODE_TYPE)
    _SubstringFilter_type = OCT_STR(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _SubstringFilter_substrings = SEQ_OF(name='substrings', mode=MODE_TYPE)
    __SubstringFilter_substrings_substring = CHOICE(name='substring', mode=MODE_TYPE)
    ___SubstringFilter_substrings_substring_initial = OCT_STR(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_any = OCT_STR(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_final = OCT_STR(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    __SubstringFilter_substrings_substring._cont = ASN1Dict([
        ('initial', ___SubstringFilter_substrings_substring_initial),
        ('any', ___SubstringFilter_substrings_substring_any),
        ('final', ___SubstringFilter_substrings_substring_final),
        ])
    __SubstringFilter_substrings_substring._ext = []
    _SubstringFilter_substrings._cont = __SubstringFilter_substrings_substring
    _SubstringFilter_substrings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubstringFilter._cont = ASN1Dict([
        ('type', _SubstringFilter_type),
        ('substrings', _SubstringFilter_substrings),
        ])
    SubstringFilter._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name='MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = OCT_STR(name='matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleId')), opt=True)
    _MatchingRuleAssertion_type = OCT_STR(name='type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')), opt=True)
    _MatchingRuleAssertion_matchValue = OCT_STR(name='matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    _MatchingRuleAssertion_dnAttributes = BOOL(name='dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        ('matchingRule', _MatchingRuleAssertion_matchingRule),
        ('type', _MatchingRuleAssertion_type),
        ('matchValue', _MatchingRuleAssertion_matchValue),
        ('dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< SearchResultEntry >-----#
    SearchResultEntry = SEQ(name='SearchResultEntry', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultEntry_objectName = OCT_STR(name='objectName', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchResultEntry_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttributeList')))
    SearchResultEntry._cont = ASN1Dict([
        ('objectName', _SearchResultEntry_objectName),
        ('attributes', _SearchResultEntry_attributes),
        ])
    SearchResultEntry._ext = []
    
    #-----< PartialAttributeList >-----#
    PartialAttributeList = SEQ_OF(name='PartialAttributeList', mode=MODE_TYPE)
    _PartialAttributeList_partialAttribute = SEQ(name='partialAttribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    PartialAttributeList._cont = _PartialAttributeList_partialAttribute
    
    #-----< SearchResultReference >-----#
    SearchResultReference = SEQ_OF(name='SearchResultReference', mode=MODE_TYPE, tag=(19, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultReference_uri = OCT_STR(name='uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    SearchResultReference._cont = _SearchResultReference_uri
    SearchResultReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SearchResultDone >-----#
    SearchResultDone = SEQ(name='SearchResultDone', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyRequest >-----#
    ModifyRequest = SEQ(name='ModifyRequest', mode=MODE_TYPE, tag=(6, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyRequest_object = OCT_STR(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyRequest_changes = SEQ_OF(name='changes', mode=MODE_TYPE)
    __ModifyRequest_changes_change = SEQ(name='change', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation = ENUM(name='operation', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation._cont = ASN1Dict([('add', 0), ('delete', 1), ('replace', 2)])
    ___ModifyRequest_changes_change_operation._ext = []
    ___ModifyRequest_changes_change_modification = SEQ(name='modification', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    __ModifyRequest_changes_change._cont = ASN1Dict([
        ('operation', ___ModifyRequest_changes_change_operation),
        ('modification', ___ModifyRequest_changes_change_modification),
        ])
    __ModifyRequest_changes_change._ext = []
    _ModifyRequest_changes._cont = __ModifyRequest_changes_change
    ModifyRequest._cont = ASN1Dict([
        ('object', _ModifyRequest_object),
        ('changes', _ModifyRequest_changes),
        ])
    ModifyRequest._ext = []
    
    #-----< ModifyResponse >-----#
    ModifyResponse = SEQ(name='ModifyResponse', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AddRequest >-----#
    AddRequest = SEQ(name='AddRequest', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    _AddRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _AddRequest_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeList')))
    AddRequest._cont = ASN1Dict([
        ('entry', _AddRequest_entry),
        ('attributes', _AddRequest_attributes),
        ])
    AddRequest._ext = []
    
    #-----< AttributeList >-----#
    AttributeList = SEQ_OF(name='AttributeList', mode=MODE_TYPE)
    _AttributeList_attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Attribute')))
    AttributeList._cont = _AttributeList_attribute
    
    #-----< AddResponse >-----#
    AddResponse = SEQ(name='AddResponse', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< DelRequest >-----#
    DelRequest = OCT_STR(name='DelRequest', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    
    #-----< DelResponse >-----#
    DelResponse = SEQ(name='DelResponse', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyDNRequest >-----#
    ModifyDNRequest = SEQ(name='ModifyDNRequest', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyDNRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyDNRequest_newrdn = OCT_STR(name='newrdn', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'RelativeLDAPDN')))
    _ModifyDNRequest_deleteoldrdn = BOOL(name='deleteoldrdn', mode=MODE_TYPE)
    _ModifyDNRequest_newSuperior = OCT_STR(name='newSuperior', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')), opt=True)
    ModifyDNRequest._cont = ASN1Dict([
        ('entry', _ModifyDNRequest_entry),
        ('newrdn', _ModifyDNRequest_newrdn),
        ('deleteoldrdn', _ModifyDNRequest_deleteoldrdn),
        ('newSuperior', _ModifyDNRequest_newSuperior),
        ])
    ModifyDNRequest._ext = []
    
    #-----< ModifyDNResponse >-----#
    ModifyDNResponse = SEQ(name='ModifyDNResponse', mode=MODE_TYPE, tag=(13, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< CompareRequest >-----#
    CompareRequest = SEQ(name='CompareRequest', mode=MODE_TYPE, tag=(14, TAG_APPLICATION, TAG_IMPLICIT))
    _CompareRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _CompareRequest_ava = SEQ(name='ava', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    CompareRequest._cont = ASN1Dict([
        ('entry', _CompareRequest_entry),
        ('ava', _CompareRequest_ava),
        ])
    CompareRequest._ext = []
    
    #-----< CompareResponse >-----#
    CompareResponse = SEQ(name='CompareResponse', mode=MODE_TYPE, tag=(15, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AbandonRequest >-----#
    AbandonRequest = INT(name='AbandonRequest', mode=MODE_TYPE, tag=(16, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    
    #-----< ExtendedRequest >-----#
    ExtendedRequest = SEQ(name='ExtendedRequest', mode=MODE_TYPE, tag=(23, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedRequest_requestName = OCT_STR(name='requestName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _ExtendedRequest_requestValue = OCT_STR(name='requestValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedRequest._cont = ASN1Dict([
        ('requestName', _ExtendedRequest_requestName),
        ('requestValue', _ExtendedRequest_requestValue),
        ])
    ExtendedRequest._ext = []
    
    #-----< ExtendedResponse >-----#
    ExtendedResponse = SEQ(name='ExtendedResponse', mode=MODE_TYPE, tag=(24, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedResponse_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _ExtendedResponse_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _ExtendedResponse_resultCode._ext = []
    _ExtendedResponse_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ExtendedResponse_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _ExtendedResponse_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _ExtendedResponse_responseName = OCT_STR(name='responseName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _ExtendedResponse_responseValue = OCT_STR(name='responseValue', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedResponse._cont = ASN1Dict([
        ('resultCode', _ExtendedResponse_resultCode),
        ('matchedDN', _ExtendedResponse_matchedDN),
        ('diagnosticMessage', _ExtendedResponse_diagnosticMessage),
        ('referral', _ExtendedResponse_referral),
        ('responseName', _ExtendedResponse_responseName),
        ('responseValue', _ExtendedResponse_responseValue),
        ])
    ExtendedResponse._ext = []
    
    #-----< IntermediateResponse >-----#
    IntermediateResponse = SEQ(name='IntermediateResponse', mode=MODE_TYPE, tag=(25, TAG_APPLICATION, TAG_IMPLICIT))
    _IntermediateResponse_responseName = OCT_STR(name='responseName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _IntermediateResponse_responseValue = OCT_STR(name='responseValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IntermediateResponse._cont = ASN1Dict([
        ('responseName', _IntermediateResponse_responseName),
        ('responseValue', _IntermediateResponse_responseValue),
        ])
    IntermediateResponse._ext = []
    
    _all_ = [
        _LDAPMessage_messageID,
        __LDAPMessage_protocolOp_bindRequest,
        __LDAPMessage_protocolOp_bindResponse,
        __LDAPMessage_protocolOp_unbindRequest,
        __LDAPMessage_protocolOp_searchRequest,
        __LDAPMessage_protocolOp_searchResEntry,
        __LDAPMessage_protocolOp_searchResDone,
        __LDAPMessage_protocolOp_searchResRef,
        __LDAPMessage_protocolOp_modifyRequest,
        __LDAPMessage_protocolOp_modifyResponse,
        __LDAPMessage_protocolOp_addRequest,
        __LDAPMessage_protocolOp_addResponse,
        __LDAPMessage_protocolOp_delRequest,
        __LDAPMessage_protocolOp_delResponse,
        __LDAPMessage_protocolOp_modDNRequest,
        __LDAPMessage_protocolOp_modDNResponse,
        __LDAPMessage_protocolOp_compareRequest,
        __LDAPMessage_protocolOp_compareResponse,
        __LDAPMessage_protocolOp_abandonRequest,
        __LDAPMessage_protocolOp_extendedReq,
        __LDAPMessage_protocolOp_extendedResp,
        __LDAPMessage_protocolOp_intermediateResponse,
        _LDAPMessage_protocolOp,
        _LDAPMessage_controls,
        LDAPMessage,
        MessageID,
        maxInt,
        LDAPString,
        LDAPOID,
        LDAPDN,
        RelativeLDAPDN,
        AttributeDescription,
        AttributeValue,
        _AttributeValueAssertion_attributeDesc,
        _AttributeValueAssertion_assertionValue,
        AttributeValueAssertion,
        AssertionValue,
        _PartialAttribute_type,
        __PartialAttribute_vals_value,
        _PartialAttribute_vals,
        PartialAttribute,
        Attribute,
        MatchingRuleId,
        _LDAPResult_resultCode,
        _LDAPResult_matchedDN,
        _LDAPResult_diagnosticMessage,
        _LDAPResult_referral,
        LDAPResult,
        _Referral_uri,
        Referral,
        URI,
        _Controls_control,
        Controls,
        _Control_controlType,
        _Control_criticality,
        _Control_controlValue,
        Control,
        _BindRequest_version,
        _BindRequest_name,
        _BindRequest_authentication,
        BindRequest,
        _AuthenticationChoice_simple,
        _AuthenticationChoice_sasl,
        AuthenticationChoice,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        SaslCredentials,
        _BindResponse_resultCode,
        _BindResponse_matchedDN,
        _BindResponse_diagnosticMessage,
        _BindResponse_referral,
        _BindResponse_serverSaslCreds,
        BindResponse,
        UnbindRequest,
        _SearchRequest_baseObject,
        _SearchRequest_scope,
        _SearchRequest_derefAliases,
        _SearchRequest_sizeLimit,
        _SearchRequest_timeLimit,
        _SearchRequest_typesOnly,
        _SearchRequest_filter,
        _SearchRequest_attributes,
        SearchRequest,
        _AttributeSelection_selector,
        AttributeSelection,
        __Filter_and__filter,
        _Filter_and_,
        __Filter_or__filter,
        _Filter_or_,
        _Filter_not_,
        _Filter_equalityMatch,
        _Filter_substrings,
        _Filter_greaterOrEqual,
        _Filter_lessOrEqual,
        _Filter_present,
        _Filter_approxMatch,
        _Filter_extensibleMatch,
        Filter,
        _SubstringFilter_type,
        ___SubstringFilter_substrings_substring_initial,
        ___SubstringFilter_substrings_substring_any,
        ___SubstringFilter_substrings_substring_final,
        __SubstringFilter_substrings_substring,
        _SubstringFilter_substrings,
        SubstringFilter,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        _SearchResultEntry_objectName,
        _SearchResultEntry_attributes,
        SearchResultEntry,
        _PartialAttributeList_partialAttribute,
        PartialAttributeList,
        _SearchResultReference_uri,
        SearchResultReference,
        SearchResultDone,
        _ModifyRequest_object,
        ___ModifyRequest_changes_change_operation,
        ___ModifyRequest_changes_change_modification,
        __ModifyRequest_changes_change,
        _ModifyRequest_changes,
        ModifyRequest,
        ModifyResponse,
        _AddRequest_entry,
        _AddRequest_attributes,
        AddRequest,
        _AttributeList_attribute,
        AttributeList,
        AddResponse,
        DelRequest,
        DelResponse,
        _ModifyDNRequest_entry,
        _ModifyDNRequest_newrdn,
        _ModifyDNRequest_deleteoldrdn,
        _ModifyDNRequest_newSuperior,
        ModifyDNRequest,
        ModifyDNResponse,
        _CompareRequest_entry,
        _CompareRequest_ava,
        CompareRequest,
        CompareResponse,
        AbandonRequest,
        _ExtendedRequest_requestName,
        _ExtendedRequest_requestValue,
        ExtendedRequest,
        _ExtendedResponse_resultCode,
        _ExtendedResponse_matchedDN,
        _ExtendedResponse_diagnosticMessage,
        _ExtendedResponse_referral,
        _ExtendedResponse_responseName,
        _ExtendedResponse_responseValue,
        ExtendedResponse,
        _IntermediateResponse_responseName,
        _IntermediateResponse_responseValue,
        IntermediateResponse,
    ]

init_modules(Lightweight_Directory_Access_Protocol_V3)
