# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class RUA_CommonDataTypes:

    _name_  = 'RUA-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 5, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'Presence',
        'ProcedureCode',
        'PrivateIE-ID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'ProcedureCode',
        'PrivateIE-ID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        ProcedureCode,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class RUA_Constants:

    _name_  = 'RUA-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 5, 1, 4]
    
    _obj_ = [
        'id-Connect',
        'id-DirectTransfer',
        'id-Disconnect',
        'id-ConnectionlessTransfer',
        'id-ErrorIndication',
        'id-privateMessage',
        'maxNrOfErrors',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-Context-ID',
        'id-RANAP-Message',
        'id-IntraDomainNasNodeSelector',
        'id-Establishment-Cause',
        'id-CN-DomainIndicator',
        'id-CSGMembershipStatus',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-Connect',
        'id-DirectTransfer',
        'id-Disconnect',
        'id-ConnectionlessTransfer',
        'id-ErrorIndication',
        'id-privateMessage',
        'maxNrOfErrors',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-Context-ID',
        'id-RANAP-Message',
        'id-IntraDomainNasNodeSelector',
        'id-Establishment-Cause',
        'id-CN-DomainIndicator',
        'id-CSGMembershipStatus',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-Connect >-----#
    id_Connect = INT(name='id-Connect', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')))
    id_Connect._val = 1
    
    #-----< id-DirectTransfer >-----#
    id_DirectTransfer = INT(name='id-DirectTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')))
    id_DirectTransfer._val = 2
    
    #-----< id-Disconnect >-----#
    id_Disconnect = INT(name='id-Disconnect', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')))
    id_Disconnect._val = 3
    
    #-----< id-ConnectionlessTransfer >-----#
    id_ConnectionlessTransfer = INT(name='id-ConnectionlessTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')))
    id_ConnectionlessTransfer._val = 4
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 5
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 6
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 1
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 2
    
    #-----< id-Context-ID >-----#
    id_Context_ID = INT(name='id-Context-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Context_ID._val = 3
    
    #-----< id-RANAP-Message >-----#
    id_RANAP_Message = INT(name='id-RANAP-Message', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANAP_Message._val = 4
    
    #-----< id-IntraDomainNasNodeSelector >-----#
    id_IntraDomainNasNodeSelector = INT(name='id-IntraDomainNasNodeSelector', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntraDomainNasNodeSelector._val = 5
    
    #-----< id-Establishment-Cause >-----#
    id_Establishment_Cause = INT(name='id-Establishment-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Establishment_Cause._val = 6
    
    #-----< id-CN-DomainIndicator >-----#
    id_CN_DomainIndicator = INT(name='id-CN-DomainIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CN_DomainIndicator._val = 7
    
    #-----< id-CSGMembershipStatus >-----#
    id_CSGMembershipStatus = INT(name='id-CSGMembershipStatus', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipStatus._val = 9
    
    _all_ = [
        id_Connect,
        id_DirectTransfer,
        id_Disconnect,
        id_ConnectionlessTransfer,
        id_ErrorIndication,
        id_privateMessage,
        maxNrOfErrors,
        id_Cause,
        id_CriticalityDiagnostics,
        id_Context_ID,
        id_RANAP_Message,
        id_IntraDomainNasNodeSelector,
        id_Establishment_Cause,
        id_CN_DomainIndicator,
        id_CSGMembershipStatus,
    ]

class RUA_Containers:

    _name_  = 'RUA-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 5, 1, 5]
    
    _obj_ = [
        'RUA-PRIVATE-IES',
        'RUA-PROTOCOL-IES',
        'RUA-PROTOCOL-EXTENSION',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'RUA-PRIVATE-IES',
        'RUA-PROTOCOL-IES',
        'RUA-PROTOCOL-EXTENSION',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'RUA-PRIVATE-IES',
        'RUA-PROTOCOL-IES',
        'RUA-PROTOCOL-EXTENSION',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< RUA-PRIVATE-IES >-----#
    RUA_PRIVATE_IES = CLASS(name='RUA-PRIVATE-IES', mode=MODE_TYPE)
    _RUA_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'PrivateIE-ID')))
    _RUA_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Criticality')))
    _RUA_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _RUA_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Presence')))
    RUA_PRIVATE_IES._cont = ASN1Dict([
        ('id', _RUA_PRIVATE_IES_id),
        ('criticality', _RUA_PRIVATE_IES_criticality),
        ('Value', _RUA_PRIVATE_IES_Value),
        ('presence', _RUA_PRIVATE_IES_presence),
        ])
    
    #-----< RUA-PROTOCOL-IES >-----#
    RUA_PROTOCOL_IES = CLASS(name='RUA-PROTOCOL-IES', mode=MODE_TYPE)
    _RUA_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RUA_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Criticality')))
    _RUA_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _RUA_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Presence')))
    RUA_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _RUA_PROTOCOL_IES_id),
        ('criticality', _RUA_PROTOCOL_IES_criticality),
        ('Value', _RUA_PROTOCOL_IES_Value),
        ('presence', _RUA_PROTOCOL_IES_presence),
        ])
    
    #-----< RUA-PROTOCOL-EXTENSION >-----#
    RUA_PROTOCOL_EXTENSION = CLASS(name='RUA-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _RUA_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RUA_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Criticality')))
    _RUA_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _RUA_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Presence')))
    RUA_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _RUA_PROTOCOL_EXTENSION_id),
        ('criticality', _RUA_PROTOCOL_EXTENSION_criticality),
        ('Extension', _RUA_PROTOCOL_EXTENSION_Extension),
        ('presence', _RUA_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _RUA_PRIVATE_IES_id,
        _RUA_PRIVATE_IES_criticality,
        _RUA_PRIVATE_IES_Value,
        _RUA_PRIVATE_IES_presence,
        RUA_PRIVATE_IES,
        _RUA_PROTOCOL_IES_id,
        _RUA_PROTOCOL_IES_criticality,
        _RUA_PROTOCOL_IES_Value,
        _RUA_PROTOCOL_IES_presence,
        RUA_PROTOCOL_IES,
        _RUA_PROTOCOL_EXTENSION_id,
        _RUA_PROTOCOL_EXTENSION_criticality,
        _RUA_PROTOCOL_EXTENSION_Extension,
        _RUA_PROTOCOL_EXTENSION_presence,
        RUA_PROTOCOL_EXTENSION,
    ]

class RUA_IEs:

    _name_  = 'RUA-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 5, 1, 2]
    
    _obj_ = [
        'CN-DomainIndicator',
        'CSGMembershipStatus',
        'Establishment-Cause',
        'Context-ID',
        'IntraDomainNasNodeSelector',
        'Gsm-map-IDNNS',
        'Ansi-41-IDNNS',
        'RANAP-Message',
        'RoutingParameter',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'TypeOfError',
        ]
    _type_ = [
        'CN-DomainIndicator',
        'CSGMembershipStatus',
        'Establishment-Cause',
        'Context-ID',
        'IntraDomainNasNodeSelector',
        'Gsm-map-IDNNS',
        'Ansi-41-IDNNS',
        'RANAP-Message',
        'RoutingParameter',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'TypeOfError',
        ]
    _set_ = [
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< CN-DomainIndicator >-----#
    CN_DomainIndicator = ENUM(name='CN-DomainIndicator', mode=MODE_TYPE)
    CN_DomainIndicator._cont = ASN1Dict([('cs-domain', 0), ('ps-domain', 1)])
    CN_DomainIndicator._ext = None
    
    #-----< CSGMembershipStatus >-----#
    CSGMembershipStatus = ENUM(name='CSGMembershipStatus', mode=MODE_TYPE)
    CSGMembershipStatus._cont = ASN1Dict([('member', 0), ('non-member', 1)])
    CSGMembershipStatus._ext = []
    
    #-----< Establishment-Cause >-----#
    Establishment_Cause = ENUM(name='Establishment-Cause', mode=MODE_TYPE)
    Establishment_Cause._cont = ASN1Dict([('emergency-call', 0), ('normal-call', 1)])
    Establishment_Cause._ext = []
    
    #-----< Context-ID >-----#
    Context_ID = BIT_STR(name='Context-ID', mode=MODE_TYPE)
    Context_ID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< IntraDomainNasNodeSelector >-----#
    IntraDomainNasNodeSelector = SEQ(name='IntraDomainNasNodeSelector', mode=MODE_TYPE)
    _IntraDomainNasNodeSelector_version = CHOICE(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IntraDomainNasNodeSelector_version_release99 = SEQ(name='release99', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___IntraDomainNasNodeSelector_version_release99_cn_Type = CHOICE(name='cn-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____IntraDomainNasNodeSelector_version_release99_cn_Type_gsm_Map_IDNNS = SEQ(name='gsm-Map-IDNNS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'Gsm-map-IDNNS')))
    ____IntraDomainNasNodeSelector_version_release99_cn_Type_ansi_41_IDNNS = BIT_STR(name='ansi-41-IDNNS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'Ansi-41-IDNNS')))
    ___IntraDomainNasNodeSelector_version_release99_cn_Type._cont = ASN1Dict([
        ('gsm-Map-IDNNS', ____IntraDomainNasNodeSelector_version_release99_cn_Type_gsm_Map_IDNNS),
        ('ansi-41-IDNNS', ____IntraDomainNasNodeSelector_version_release99_cn_Type_ansi_41_IDNNS),
        ])
    ___IntraDomainNasNodeSelector_version_release99_cn_Type._ext = None
    __IntraDomainNasNodeSelector_version_release99._cont = ASN1Dict([
        ('cn-Type', ___IntraDomainNasNodeSelector_version_release99_cn_Type),
        ])
    __IntraDomainNasNodeSelector_version_release99._ext = None
    __IntraDomainNasNodeSelector_version_later = SEQ(name='later', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___IntraDomainNasNodeSelector_version_later_futurecoding = BIT_STR(name='futurecoding', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___IntraDomainNasNodeSelector_version_later_futurecoding._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    __IntraDomainNasNodeSelector_version_later._cont = ASN1Dict([
        ('futurecoding', ___IntraDomainNasNodeSelector_version_later_futurecoding),
        ])
    __IntraDomainNasNodeSelector_version_later._ext = None
    _IntraDomainNasNodeSelector_version._cont = ASN1Dict([
        ('release99', __IntraDomainNasNodeSelector_version_release99),
        ('later', __IntraDomainNasNodeSelector_version_later),
        ])
    _IntraDomainNasNodeSelector_version._ext = None
    IntraDomainNasNodeSelector._cont = ASN1Dict([
        ('version', _IntraDomainNasNodeSelector_version),
        ])
    IntraDomainNasNodeSelector._ext = None
    
    #-----< Gsm-map-IDNNS >-----#
    Gsm_map_IDNNS = SEQ(name='Gsm-map-IDNNS', mode=MODE_TYPE)
    _Gsm_map_IDNNS_routingbasis = CHOICE(name='routingbasis', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Gsm_map_IDNNS_routingbasis_localPTMSI = SEQ(name='localPTMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_localPTMSI_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_localPTMSI._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_localPTMSI_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_localPTMSI._ext = None
    __Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN = SEQ(name='tMSIofsamePLMN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN._ext = None
    __Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN = SEQ(name='tMSIofdifferentPLMN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN._ext = None
    __Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging = SEQ(name='iMSIresponsetopaging', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging._ext = None
    __Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent = SEQ(name='iMSIcauseUEinitiatedEvent', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent._ext = None
    __Gsm_map_IDNNS_routingbasis_iMEI = SEQ(name='iMEI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_iMEI_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_iMEI._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_iMEI_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_iMEI._ext = None
    __Gsm_map_IDNNS_routingbasis_spare2 = SEQ(name='spare2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_spare2_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_spare2._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_spare2_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_spare2._ext = None
    __Gsm_map_IDNNS_routingbasis_spare1 = SEQ(name='spare1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Gsm_map_IDNNS_routingbasis_spare1_routingparameter = BIT_STR(name='routingparameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'RoutingParameter')))
    __Gsm_map_IDNNS_routingbasis_spare1._cont = ASN1Dict([
        ('routingparameter', ___Gsm_map_IDNNS_routingbasis_spare1_routingparameter),
        ])
    __Gsm_map_IDNNS_routingbasis_spare1._ext = None
    _Gsm_map_IDNNS_routingbasis._cont = ASN1Dict([
        ('localPTMSI', __Gsm_map_IDNNS_routingbasis_localPTMSI),
        ('tMSIofsamePLMN', __Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN),
        ('tMSIofdifferentPLMN', __Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN),
        ('iMSIresponsetopaging', __Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging),
        ('iMSIcauseUEinitiatedEvent', __Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent),
        ('iMEI', __Gsm_map_IDNNS_routingbasis_iMEI),
        ('spare2', __Gsm_map_IDNNS_routingbasis_spare2),
        ('spare1', __Gsm_map_IDNNS_routingbasis_spare1),
        ])
    _Gsm_map_IDNNS_routingbasis._ext = None
    _Gsm_map_IDNNS_dummy = BOOL(name='dummy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Gsm_map_IDNNS._cont = ASN1Dict([
        ('routingbasis', _Gsm_map_IDNNS_routingbasis),
        ('dummy', _Gsm_map_IDNNS_dummy),
        ])
    Gsm_map_IDNNS._ext = None
    
    #-----< Ansi-41-IDNNS >-----#
    Ansi_41_IDNNS = BIT_STR(name='Ansi-41-IDNNS', mode=MODE_TYPE)
    Ansi_41_IDNNS._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< RANAP-Message >-----#
    RANAP_Message = OCT_STR(name='RANAP-Message', mode=MODE_TYPE)
    
    #-----< RoutingParameter >-----#
    RoutingParameter = BIT_STR(name='RoutingParameter', mode=MODE_TYPE)
    RoutingParameter._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('normal', 0), ('connect-failed', 1), ('network-release', 2), ('unspecified', 3)])
    CauseRadioNetwork._ext = []
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('processing-overload', 0), ('hardware-failure', 1), ('o-and-m-intervention', 2), ('unspecified', 3)])
    CauseMisc._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    _all_ = [
        CN_DomainIndicator,
        CSGMembershipStatus,
        Establishment_Cause,
        Context_ID,
        ____IntraDomainNasNodeSelector_version_release99_cn_Type_gsm_Map_IDNNS,
        ____IntraDomainNasNodeSelector_version_release99_cn_Type_ansi_41_IDNNS,
        ___IntraDomainNasNodeSelector_version_release99_cn_Type,
        __IntraDomainNasNodeSelector_version_release99,
        ___IntraDomainNasNodeSelector_version_later_futurecoding,
        __IntraDomainNasNodeSelector_version_later,
        _IntraDomainNasNodeSelector_version,
        IntraDomainNasNodeSelector,
        ___Gsm_map_IDNNS_routingbasis_localPTMSI_routingparameter,
        __Gsm_map_IDNNS_routingbasis_localPTMSI,
        ___Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN_routingparameter,
        __Gsm_map_IDNNS_routingbasis_tMSIofsamePLMN,
        ___Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN_routingparameter,
        __Gsm_map_IDNNS_routingbasis_tMSIofdifferentPLMN,
        ___Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging_routingparameter,
        __Gsm_map_IDNNS_routingbasis_iMSIresponsetopaging,
        ___Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent_routingparameter,
        __Gsm_map_IDNNS_routingbasis_iMSIcauseUEinitiatedEvent,
        ___Gsm_map_IDNNS_routingbasis_iMEI_routingparameter,
        __Gsm_map_IDNNS_routingbasis_iMEI,
        ___Gsm_map_IDNNS_routingbasis_spare2_routingparameter,
        __Gsm_map_IDNNS_routingbasis_spare2,
        ___Gsm_map_IDNNS_routingbasis_spare1_routingparameter,
        __Gsm_map_IDNNS_routingbasis_spare1,
        _Gsm_map_IDNNS_routingbasis,
        _Gsm_map_IDNNS_dummy,
        Gsm_map_IDNNS,
        Ansi_41_IDNNS,
        RANAP_Message,
        RoutingParameter,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseRadioNetwork,
        CauseTransport,
        CauseProtocol,
        CauseMisc,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        CriticalityDiagnostics_ExtIEs,
        TypeOfError,
    ]

class RUA_PDU_Contents:

    _name_  = 'RUA-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 5, 1, 1]
    
    _obj_ = [
        'Connect',
        'ConnectIEs',
        'ConnectExtensions',
        'DirectTransfer',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'Disconnect',
        'DisconnectIEs',
        'DisconnectExtensions',
        'ConnectionlessTransfer',
        'ConnectionlessTransferIEs',
        'ConnectionlessTransferExtensions',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage',
        'PrivateMessage-IEs',
        ]
    _type_ = [
        'Connect',
        'DirectTransfer',
        'Disconnect',
        'ConnectionlessTransfer',
        'ErrorIndication',
        'PrivateMessage',
        ]
    _set_ = [
        'ConnectIEs',
        'ConnectExtensions',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'DisconnectIEs',
        'DisconnectExtensions',
        'ConnectionlessTransferIEs',
        'ConnectionlessTransferExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage-IEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'ConnectIEs',
        'ConnectExtensions',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'DisconnectIEs',
        'DisconnectExtensions',
        'ConnectionlessTransferIEs',
        'ConnectionlessTransferExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage-IEs',
        ]
    _param_ = [
        ]
    
    #-----< Connect >-----#
    Connect = SEQ(name='Connect', mode=MODE_TYPE)
    _Connect_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Container')))
    __Connect_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Field')))
    ___Connect_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['id']))
    ____Connect_protocolIEs__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _____Connect_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CN-DomainIndicator')))
    _____Connect_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Context-ID')))
    _____Connect_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'IntraDomainNasNodeSelector')))
    _____Connect_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Establishment-Cause')))
    _____Connect_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    ____Connect_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Connect_protocolIEs__item__id._const_tab = ____Connect_protocolIEs__item__id_tab
    ___Connect_protocolIEs__item__id._const_tab_at = None
    ___Connect_protocolIEs__item__id._const_tab_id = 'id'
    ___Connect_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['criticality']))
    ___Connect_protocolIEs__item__criticality._const_tab = ____Connect_protocolIEs__item__id_tab
    ___Connect_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Connect_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Connect_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['Value']))
    ___Connect_protocolIEs__item__value._const_tab = ____Connect_protocolIEs__item__id_tab
    ___Connect_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Connect_protocolIEs__item__value._const_tab_id = 'Value'
    __Connect_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Connect_protocolIEs__item__id),
        ('criticality', ___Connect_protocolIEs__item__criticality),
        ('value', ___Connect_protocolIEs__item__value),
        ])
    __Connect_protocolIEs__item_._ext = None
    _Connect_protocolIEs._cont = __Connect_protocolIEs__item_
    _Connect_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Connect_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Connect_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ___Connect_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    ____Connect_protocolExtensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    _____Connect_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CSGMembershipStatus')))
    ____Connect_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Extension', _____Connect_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Connect_protocolExtensions__item__id._const_tab = ____Connect_protocolExtensions__item__id_tab
    ___Connect_protocolExtensions__item__id._const_tab_at = None
    ___Connect_protocolExtensions__item__id._const_tab_id = 'id'
    ___Connect_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    ___Connect_protocolExtensions__item__criticality._const_tab = ____Connect_protocolExtensions__item__id_tab
    ___Connect_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Connect_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Connect_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    ___Connect_protocolExtensions__item__extensionValue._const_tab = ____Connect_protocolExtensions__item__id_tab
    ___Connect_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Connect_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Connect_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Connect_protocolExtensions__item__id),
        ('criticality', ___Connect_protocolExtensions__item__criticality),
        ('extensionValue', ___Connect_protocolExtensions__item__extensionValue),
        ])
    __Connect_protocolExtensions__item_._ext = None
    _Connect_protocolExtensions._cont = __Connect_protocolExtensions__item_
    _Connect_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Connect._cont = ASN1Dict([
        ('protocolIEs', _Connect_protocolIEs),
        ('protocolExtensions', _Connect_protocolExtensions),
        ])
    Connect._ext = []
    
    #-----< ConnectIEs >-----#
    ConnectIEs = CLASS(name='ConnectIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _ConnectIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CN-DomainIndicator')))
    _ConnectIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Context-ID')))
    _ConnectIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'IntraDomainNasNodeSelector')))
    _ConnectIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Establishment-Cause')))
    _ConnectIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    ConnectIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ConnectIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ConnectExtensions >-----#
    ConnectExtensions = CLASS(name='ConnectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    _ConnectExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CSGMembershipStatus')))
    ConnectExtensions._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Extension', _ConnectExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransfer >-----#
    DirectTransfer = SEQ(name='DirectTransfer', mode=MODE_TYPE)
    _DirectTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Container')))
    __DirectTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Field')))
    ___DirectTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['id']))
    ____DirectTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CN-DomainIndicator')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Context-ID')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    ____DirectTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolIEs__item__id._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DirectTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['criticality']))
    ___DirectTransfer_protocolIEs__item__criticality._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DirectTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['Value']))
    ___DirectTransfer_protocolIEs__item__value._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DirectTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DirectTransfer_protocolIEs__item__id),
        ('criticality', ___DirectTransfer_protocolIEs__item__criticality),
        ('value', ___DirectTransfer_protocolIEs__item__value),
        ])
    __DirectTransfer_protocolIEs__item_._ext = None
    _DirectTransfer_protocolIEs._cont = __DirectTransfer_protocolIEs__item_
    _DirectTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectTransfer_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ___DirectTransfer_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    ____DirectTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____DirectTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__id._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectTransfer_protocolExtensions__item__id._const_tab_id = 'id'
    ___DirectTransfer_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DirectTransfer_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____DirectTransfer_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab = ____DirectTransfer_protocolExtensions__item__criticality_tab
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DirectTransfer_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DirectTransfer_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____DirectTransfer_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectTransfer_protocolExtensions__item__extensionValue_tab
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DirectTransfer_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DirectTransfer_protocolExtensions__item__id),
        ('criticality', ___DirectTransfer_protocolExtensions__item__criticality),
        ('extensionValue', ___DirectTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectTransfer_protocolExtensions__item_._ext = None
    _DirectTransfer_protocolExtensions._cont = __DirectTransfer_protocolExtensions__item_
    _DirectTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectTransfer._cont = ASN1Dict([
        ('protocolIEs', _DirectTransfer_protocolIEs),
        ('protocolExtensions', _DirectTransfer_protocolExtensions),
        ])
    DirectTransfer._ext = []
    
    #-----< DirectTransferIEs >-----#
    DirectTransferIEs = CLASS(name='DirectTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _DirectTransferIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CN-DomainIndicator')))
    _DirectTransferIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Context-ID')))
    _DirectTransferIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    DirectTransferIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _DirectTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DirectTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _DirectTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferExtensions >-----#
    DirectTransferExtensions = CLASS(name='DirectTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    DirectTransferExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Disconnect >-----#
    Disconnect = SEQ(name='Disconnect', mode=MODE_TYPE)
    _Disconnect_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Container')))
    __Disconnect_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Field')))
    ___Disconnect_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['id']))
    ____Disconnect_protocolIEs__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CN-DomainIndicator')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Context-ID')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Cause')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    ____Disconnect_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___Disconnect_protocolIEs__item__id._const_tab = ____Disconnect_protocolIEs__item__id_tab
    ___Disconnect_protocolIEs__item__id._const_tab_at = None
    ___Disconnect_protocolIEs__item__id._const_tab_id = 'id'
    ___Disconnect_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['criticality']))
    ___Disconnect_protocolIEs__item__criticality._const_tab = ____Disconnect_protocolIEs__item__id_tab
    ___Disconnect_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Disconnect_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Disconnect_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['Value']))
    ___Disconnect_protocolIEs__item__value._const_tab = ____Disconnect_protocolIEs__item__id_tab
    ___Disconnect_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Disconnect_protocolIEs__item__value._const_tab_id = 'Value'
    __Disconnect_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Disconnect_protocolIEs__item__id),
        ('criticality', ___Disconnect_protocolIEs__item__criticality),
        ('value', ___Disconnect_protocolIEs__item__value),
        ])
    __Disconnect_protocolIEs__item_._ext = None
    _Disconnect_protocolIEs._cont = __Disconnect_protocolIEs__item_
    _Disconnect_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Disconnect_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Disconnect_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ___Disconnect_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    ____Disconnect_protocolExtensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____Disconnect_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Disconnect_protocolExtensions__item__id._const_tab = ____Disconnect_protocolExtensions__item__id_tab
    ___Disconnect_protocolExtensions__item__id._const_tab_at = None
    ___Disconnect_protocolExtensions__item__id._const_tab_id = 'id'
    ___Disconnect_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Disconnect_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____Disconnect_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Disconnect_protocolExtensions__item__criticality._const_tab = ____Disconnect_protocolExtensions__item__criticality_tab
    ___Disconnect_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Disconnect_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Disconnect_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Disconnect_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____Disconnect_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Disconnect_protocolExtensions__item__extensionValue._const_tab = ____Disconnect_protocolExtensions__item__extensionValue_tab
    ___Disconnect_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Disconnect_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Disconnect_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Disconnect_protocolExtensions__item__id),
        ('criticality', ___Disconnect_protocolExtensions__item__criticality),
        ('extensionValue', ___Disconnect_protocolExtensions__item__extensionValue),
        ])
    __Disconnect_protocolExtensions__item_._ext = None
    _Disconnect_protocolExtensions._cont = __Disconnect_protocolExtensions__item_
    _Disconnect_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Disconnect._cont = ASN1Dict([
        ('protocolIEs', _Disconnect_protocolIEs),
        ('protocolExtensions', _Disconnect_protocolExtensions),
        ])
    Disconnect._ext = []
    
    #-----< DisconnectIEs >-----#
    DisconnectIEs = CLASS(name='DisconnectIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _DisconnectIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CN-DomainIndicator')))
    _DisconnectIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Context-ID')))
    _DisconnectIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Cause')))
    _DisconnectIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    DisconnectIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_3), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< DisconnectExtensions >-----#
    DisconnectExtensions = CLASS(name='DisconnectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    DisconnectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ConnectionlessTransfer >-----#
    ConnectionlessTransfer = SEQ(name='ConnectionlessTransfer', mode=MODE_TYPE)
    _ConnectionlessTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Container')))
    __ConnectionlessTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Field')))
    ___ConnectionlessTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['id']))
    ____ConnectionlessTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    ____ConnectionlessTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolIEs__item__id._const_tab = ____ConnectionlessTransfer_protocolIEs__item__id_tab
    ___ConnectionlessTransfer_protocolIEs__item__id._const_tab_at = None
    ___ConnectionlessTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ConnectionlessTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['criticality']))
    ___ConnectionlessTransfer_protocolIEs__item__criticality._const_tab = ____ConnectionlessTransfer_protocolIEs__item__id_tab
    ___ConnectionlessTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ConnectionlessTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['Value']))
    ___ConnectionlessTransfer_protocolIEs__item__value._const_tab = ____ConnectionlessTransfer_protocolIEs__item__id_tab
    ___ConnectionlessTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ConnectionlessTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ConnectionlessTransfer_protocolIEs__item__id),
        ('criticality', ___ConnectionlessTransfer_protocolIEs__item__criticality),
        ('value', ___ConnectionlessTransfer_protocolIEs__item__value),
        ])
    __ConnectionlessTransfer_protocolIEs__item_._ext = None
    _ConnectionlessTransfer_protocolIEs._cont = __ConnectionlessTransfer_protocolIEs__item_
    _ConnectionlessTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ConnectionlessTransfer_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConnectionlessTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ___ConnectionlessTransfer_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    ____ConnectionlessTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____ConnectionlessTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolExtensions__item__id._const_tab = ____ConnectionlessTransfer_protocolExtensions__item__id_tab
    ___ConnectionlessTransfer_protocolExtensions__item__id._const_tab_at = None
    ___ConnectionlessTransfer_protocolExtensions__item__id._const_tab_id = 'id'
    ___ConnectionlessTransfer_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolExtensions__item__criticality._const_tab = ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab
    ___ConnectionlessTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue._const_tab = ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ConnectionlessTransfer_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ConnectionlessTransfer_protocolExtensions__item__id),
        ('criticality', ___ConnectionlessTransfer_protocolExtensions__item__criticality),
        ('extensionValue', ___ConnectionlessTransfer_protocolExtensions__item__extensionValue),
        ])
    __ConnectionlessTransfer_protocolExtensions__item_._ext = None
    _ConnectionlessTransfer_protocolExtensions._cont = __ConnectionlessTransfer_protocolExtensions__item_
    _ConnectionlessTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConnectionlessTransfer._cont = ASN1Dict([
        ('protocolIEs', _ConnectionlessTransfer_protocolIEs),
        ('protocolExtensions', _ConnectionlessTransfer_protocolExtensions),
        ])
    ConnectionlessTransfer._ext = []
    
    #-----< ConnectionlessTransferIEs >-----#
    ConnectionlessTransferIEs = CLASS(name='ConnectionlessTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _ConnectionlessTransferIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'RANAP-Message')))
    ConnectionlessTransferIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _ConnectionlessTransferIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ConnectionlessTransferExtensions >-----#
    ConnectionlessTransferExtensions = CLASS(name='ConnectionlessTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ConnectionlessTransferExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ErrorIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__criticality_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RUA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__extensionValue_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolExtensions__item__id),
        ('criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ('protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-IEs', 'CriticalityDiagnostics')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndicationExtensions >-----#
    ErrorIndicationExtensions = CLASS(name='ErrorIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PROTOCOL-EXTENSION')))
    ErrorIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_RUA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_RUA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-Containers', 'RUA-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_RUA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('RUA-Containers', 'RUA-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____Connect_protocolIEs__item__id_tab,
        _____Connect_protocolIEs__item__id_tab_val_Value_0,
        _____Connect_protocolIEs__item__id_tab_val_Value_1,
        _____Connect_protocolIEs__item__id_tab_val_Value_2,
        _____Connect_protocolIEs__item__id_tab_val_Value_3,
        _____Connect_protocolIEs__item__id_tab_val_Value_4,
        ___Connect_protocolIEs__item__id,
        ___Connect_protocolIEs__item__criticality,
        ___Connect_protocolIEs__item__value,
        __Connect_protocolIEs__item_,
        _Connect_protocolIEs,
        ____Connect_protocolExtensions__item__id_tab,
        _____Connect_protocolExtensions__item__id_tab_val_Extension_0,
        ___Connect_protocolExtensions__item__id,
        ___Connect_protocolExtensions__item__criticality,
        ___Connect_protocolExtensions__item__extensionValue,
        __Connect_protocolExtensions__item_,
        _Connect_protocolExtensions,
        Connect,
        ConnectIEs,
        _ConnectIEs_val_Value_0,
        _ConnectIEs_val_Value_1,
        _ConnectIEs_val_Value_2,
        _ConnectIEs_val_Value_3,
        _ConnectIEs_val_Value_4,
        ConnectExtensions,
        _ConnectExtensions_val_Extension_0,
        ____DirectTransfer_protocolIEs__item__id_tab,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DirectTransfer_protocolIEs__item__id,
        ___DirectTransfer_protocolIEs__item__criticality,
        ___DirectTransfer_protocolIEs__item__value,
        __DirectTransfer_protocolIEs__item_,
        _DirectTransfer_protocolIEs,
        ____DirectTransfer_protocolExtensions__item__id_tab,
        ___DirectTransfer_protocolExtensions__item__id,
        ____DirectTransfer_protocolExtensions__item__criticality_tab,
        ___DirectTransfer_protocolExtensions__item__criticality,
        ____DirectTransfer_protocolExtensions__item__extensionValue_tab,
        ___DirectTransfer_protocolExtensions__item__extensionValue,
        __DirectTransfer_protocolExtensions__item_,
        _DirectTransfer_protocolExtensions,
        DirectTransfer,
        DirectTransferIEs,
        _DirectTransferIEs_val_Value_0,
        _DirectTransferIEs_val_Value_1,
        _DirectTransferIEs_val_Value_2,
        DirectTransferExtensions,
        ____Disconnect_protocolIEs__item__id_tab,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_0,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_1,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_2,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_3,
        ___Disconnect_protocolIEs__item__id,
        ___Disconnect_protocolIEs__item__criticality,
        ___Disconnect_protocolIEs__item__value,
        __Disconnect_protocolIEs__item_,
        _Disconnect_protocolIEs,
        ____Disconnect_protocolExtensions__item__id_tab,
        ___Disconnect_protocolExtensions__item__id,
        ____Disconnect_protocolExtensions__item__criticality_tab,
        ___Disconnect_protocolExtensions__item__criticality,
        ____Disconnect_protocolExtensions__item__extensionValue_tab,
        ___Disconnect_protocolExtensions__item__extensionValue,
        __Disconnect_protocolExtensions__item_,
        _Disconnect_protocolExtensions,
        Disconnect,
        DisconnectIEs,
        _DisconnectIEs_val_Value_0,
        _DisconnectIEs_val_Value_1,
        _DisconnectIEs_val_Value_2,
        _DisconnectIEs_val_Value_3,
        DisconnectExtensions,
        ____ConnectionlessTransfer_protocolIEs__item__id_tab,
        _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___ConnectionlessTransfer_protocolIEs__item__id,
        ___ConnectionlessTransfer_protocolIEs__item__criticality,
        ___ConnectionlessTransfer_protocolIEs__item__value,
        __ConnectionlessTransfer_protocolIEs__item_,
        _ConnectionlessTransfer_protocolIEs,
        ____ConnectionlessTransfer_protocolExtensions__item__id_tab,
        ___ConnectionlessTransfer_protocolExtensions__item__id,
        ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab,
        ___ConnectionlessTransfer_protocolExtensions__item__criticality,
        ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab,
        ___ConnectionlessTransfer_protocolExtensions__item__extensionValue,
        __ConnectionlessTransfer_protocolExtensions__item_,
        _ConnectionlessTransfer_protocolExtensions,
        ConnectionlessTransfer,
        ConnectionlessTransferIEs,
        _ConnectionlessTransferIEs_val_Value_0,
        ConnectionlessTransferExtensions,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        ___ErrorIndication_protocolExtensions__item__id,
        ____ErrorIndication_protocolExtensions__item__criticality_tab,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ____ErrorIndication_protocolExtensions__item__extensionValue_tab,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        ErrorIndicationExtensions,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
    ]

class RUA_PDU_Descriptions:

    _name_  = 'RUA-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 5, 1, 0]
    
    _obj_ = [
        'RUA-ELEMENTARY-PROCEDURE',
        'RUA-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'RUA-ELEMENTARY-PROCEDURES',
        'RUA-ELEMENTARY-PROCEDURES-CLASS-1',
        'RUA-ELEMENTARY-PROCEDURES-CLASS-2',
        'connectionRequest',
        'directTransfer',
        'disconnectRequest',
        'connectionlessTransfer',
        'errorIndication',
        'privateMessage',
        ]
    _type_ = [
        'RUA-ELEMENTARY-PROCEDURE',
        'RUA-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'RUA-ELEMENTARY-PROCEDURES',
        'RUA-ELEMENTARY-PROCEDURES-CLASS-1',
        'RUA-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'connectionRequest',
        'directTransfer',
        'disconnectRequest',
        'connectionlessTransfer',
        'errorIndication',
        'privateMessage',
        ]
    _class_ = [
        'RUA-ELEMENTARY-PROCEDURE',
        'RUA-ELEMENTARY-PROCEDURES',
        'RUA-ELEMENTARY-PROCEDURES-CLASS-1',
        'RUA-ELEMENTARY-PROCEDURES-CLASS-2',
        'connectionRequest',
        'directTransfer',
        'disconnectRequest',
        'connectionlessTransfer',
        'errorIndication',
        'privateMessage',
        ]
    _param_ = [
        ]
    
    #-----< RUA-ELEMENTARY-PROCEDURE >-----#
    RUA_ELEMENTARY_PROCEDURE = CLASS(name='RUA-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _RUA_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _RUA_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RUA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RUA_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _RUA_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-CommonDataTypes', 'Criticality')), default='ignore')
    RUA_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _RUA_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _RUA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _RUA_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _RUA_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< RUA-PDU >-----#
    RUA_PDU = CHOICE(name='RUA-PDU', mode=MODE_TYPE)
    _RUA_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-PDU-Descriptions', 'InitiatingMessage')))
    _RUA_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-PDU-Descriptions', 'SuccessfulOutcome')))
    _RUA_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RUA-PDU-Descriptions', 'UnsuccessfulOutcome')))
    RUA_PDU._cont = ASN1Dict([
        ('initiatingMessage', _RUA_PDU_initiatingMessage),
        ('successfulOutcome', _RUA_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _RUA_PDU_unsuccessfulOutcome),
        ])
    RUA_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_RUA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Connect')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'DirectTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Disconnect')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ConnectionlessTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'PrivateMessage')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RUA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Connect')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'DirectTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Disconnect')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ConnectionlessTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'PrivateMessage')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RUA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Connect')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'DirectTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Disconnect')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ConnectionlessTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'PrivateMessage')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< RUA-ELEMENTARY-PROCEDURES >-----#
    RUA_ELEMENTARY_PROCEDURES = CLASS(name='RUA-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Connect')))
    _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'DirectTransfer')))
    _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Disconnect')))
    _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ConnectionlessTransfer')))
    _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ErrorIndication')))
    _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'PrivateMessage')))
    RUA_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< RUA-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    RUA_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='RUA-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    RUA_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RUA-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    RUA_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='RUA-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Connect')))
    _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'DirectTransfer')))
    _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Disconnect')))
    _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ConnectionlessTransfer')))
    _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ErrorIndication')))
    _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'PrivateMessage')))
    RUA_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< connectionRequest >-----#
    connectionRequest = CLASS(name='connectionRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _connectionRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Connect')))
    connectionRequest._val = dict([('InitiatingMessage', _connectionRequest_val_InitiatingMessage), ('procedureCode', 1), ('criticality', 'ignore')])
    
    #-----< directTransfer >-----#
    directTransfer = CLASS(name='directTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _directTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'DirectTransfer')))
    directTransfer._val = dict([('InitiatingMessage', _directTransfer_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< disconnectRequest >-----#
    disconnectRequest = CLASS(name='disconnectRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _disconnectRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'Disconnect')))
    disconnectRequest._val = dict([('InitiatingMessage', _disconnectRequest_val_InitiatingMessage), ('procedureCode', 3), ('criticality', 'ignore')])
    
    #-----< connectionlessTransfer >-----#
    connectionlessTransfer = CLASS(name='connectionlessTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _connectionlessTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ConnectionlessTransfer')))
    connectionlessTransfer._val = dict([('InitiatingMessage', _connectionlessTransfer_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RUA-PDU-Descriptions', 'RUA-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RUA-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 6), ('criticality', 'ignore')])
    
    _all_ = [
        _RUA_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _RUA_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _RUA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _RUA_ELEMENTARY_PROCEDURE_procedureCode,
        _RUA_ELEMENTARY_PROCEDURE_criticality,
        RUA_ELEMENTARY_PROCEDURE,
        _RUA_PDU_initiatingMessage,
        _RUA_PDU_successfulOutcome,
        _RUA_PDU_unsuccessfulOutcome,
        RUA_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        RUA_ELEMENTARY_PROCEDURES,
        _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _RUA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        RUA_ELEMENTARY_PROCEDURES_CLASS_1,
        RUA_ELEMENTARY_PROCEDURES_CLASS_2,
        _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _RUA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        connectionRequest,
        _connectionRequest_val_InitiatingMessage,
        directTransfer,
        _directTransfer_val_InitiatingMessage,
        disconnectRequest,
        _disconnectRequest_val_InitiatingMessage,
        connectionlessTransfer,
        _connectionlessTransfer_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
    ]

init_modules(RUA_CommonDataTypes, RUA_Constants, RUA_Containers, RUA_IEs, RUA_PDU_Contents, RUA_PDU_Descriptions)
