# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class DialoguePDUs:

    _name_  = 'DialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 2, 1]
    
    _obj_ = [
        'dialogue-as-id',
        'DialoguePDU',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-source',
        'Associate-result',
        'Associate-source-diagnostic',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _type_ = [
        'DialoguePDU',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-source',
        'Associate-result',
        'Associate-source-diagnostic',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _set_ = [
        ]
    _val_ = [
        'dialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< dialogue-as-id >-----#
    dialogue_as_id = OID(name='dialogue-as-id', mode=MODE_VALUE)
    dialogue_as_id._val = (0, 0, 17, 773, 1, 1, 1)
    
    #-----< DialoguePDU >-----#
    DialoguePDU = CHOICE(name='DialoguePDU', mode=MODE_TYPE)
    _DialoguePDU_dialogueRequest = SEQ(name='dialogueRequest', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARQ-apdu')))
    _DialoguePDU_dialogueResponse = SEQ(name='dialogueResponse', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARE-apdu')))
    _DialoguePDU_dialogueAbort = SEQ(name='dialogueAbort', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'ABRT-apdu')))
    DialoguePDU._cont = ASN1Dict([
        ('dialogueRequest', _DialoguePDU_dialogueRequest),
        ('dialogueResponse', _DialoguePDU_dialogueResponse),
        ('dialogueAbort', _DialoguePDU_dialogueAbort),
        ])
    DialoguePDU._ext = None
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name='AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARQ_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARQ_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _AARQ_apdu_user_information._cont = __AARQ_apdu_user_information__item_
    AARQ_apdu._cont = ASN1Dict([
        ('protocol-version', _AARQ_apdu_protocol_version),
        ('application-context-name', _AARQ_apdu_application_context_name),
        ('user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = None
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name='AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARE_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARE_apdu_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-source-diagnostic')))
    _AARE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARE_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _AARE_apdu_user_information._cont = __AARE_apdu_user_information__item_
    AARE_apdu._cont = ASN1Dict([
        ('protocol-version', _AARE_apdu_protocol_version),
        ('application-context-name', _AARE_apdu_application_context_name),
        ('result', _AARE_apdu_result),
        ('result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        ('user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = None
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name='RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRQ_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _RLRQ_apdu_user_information._cont = __RLRQ_apdu_user_information__item_
    RLRQ_apdu._cont = ASN1Dict([
        ('reason', _RLRQ_apdu_reason),
        ('user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = None
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name='RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRE_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _RLRE_apdu_user_information._cont = __RLRE_apdu_user_information__item_
    RLRE_apdu._cont = ASN1Dict([
        ('reason', _RLRE_apdu_reason),
        ('user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = None
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name='ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name='abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'ABRT-source')))
    _ABRT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ABRT_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _ABRT_apdu_user_information._cont = __ABRT_apdu_user_information__item_
    ABRT_apdu._cont = ASN1Dict([
        ('abort-source', _ABRT_apdu_abort_source),
        ('user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name='ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([('dialogue-service-user', 0), ('dialogue-service-provider', 1)])
    
    #-----< Associate-result >-----#
    Associate_result = INT(name='Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([('accepted', 0), ('reject-permanent', 1)])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name='Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_dialogue_service_user = INT(name='dialogue-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_user._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('application-context-name-not-supported', 2)])
    _Associate_source_diagnostic_dialogue_service_provider = INT(name='dialogue-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_provider._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('no-common-dialogue-portion', 2)])
    Associate_source_diagnostic._cont = ASN1Dict([
        ('dialogue-service-user', _Associate_source_diagnostic_dialogue_service_user),
        ('dialogue-service-provider', _Associate_source_diagnostic_dialogue_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name='Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([('normal', 0), ('urgent', 1), ('user-defined', 30)])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name='Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([('normal', 0), ('not-finished', 1), ('user-defined', 30)])
    
    _all_ = [
        dialogue_as_id,
        _DialoguePDU_dialogueRequest,
        _DialoguePDU_dialogueResponse,
        _DialoguePDU_dialogueAbort,
        DialoguePDU,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        __AARQ_apdu_user_information__item_,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        __AARE_apdu_user_information__item_,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        __RLRQ_apdu_user_information__item_,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        __RLRE_apdu_user_information__item_,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        __ABRT_apdu_user_information__item_,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_source,
        Associate_result,
        _Associate_source_diagnostic_dialogue_service_user,
        _Associate_source_diagnostic_dialogue_service_provider,
        Associate_source_diagnostic,
        Release_request_reason,
        Release_response_reason,
    ]

class UnidialoguePDUs:

    _name_  = 'UnidialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 3, 1]
    
    _obj_ = [
        'uniDialogue-as-id',
        'UniDialoguePDU',
        'AUDT-apdu',
        ]
    _type_ = [
        'UniDialoguePDU',
        'AUDT-apdu',
        ]
    _set_ = [
        ]
    _val_ = [
        'uniDialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< uniDialogue-as-id >-----#
    uniDialogue_as_id = OID(name='uniDialogue-as-id', mode=MODE_VALUE)
    uniDialogue_as_id._val = (0, 0, 17, 773, 1, 2, 1)
    
    #-----< UniDialoguePDU >-----#
    UniDialoguePDU = CHOICE(name='UniDialoguePDU', mode=MODE_TYPE)
    _UniDialoguePDU_unidialoguePDU = SEQ(name='unidialoguePDU', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'AUDT-apdu')))
    UniDialoguePDU._cont = ASN1Dict([
        ('unidialoguePDU', _UniDialoguePDU_unidialoguePDU),
        ])
    UniDialoguePDU._ext = None
    
    #-----< AUDT-apdu >-----#
    AUDT_apdu = SEQ(name='AUDT-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AUDT_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AUDT_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AUDT_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AUDT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AUDT_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _AUDT_apdu_user_information._cont = __AUDT_apdu_user_information__item_
    AUDT_apdu._cont = ASN1Dict([
        ('protocol-version', _AUDT_apdu_protocol_version),
        ('application-context-name', _AUDT_apdu_application_context_name),
        ('user-information', _AUDT_apdu_user_information),
        ])
    AUDT_apdu._ext = None
    
    _all_ = [
        uniDialogue_as_id,
        _UniDialoguePDU_unidialoguePDU,
        UniDialoguePDU,
        _AUDT_apdu_protocol_version,
        _AUDT_apdu_application_context_name,
        __AUDT_apdu_user_information__item_,
        _AUDT_apdu_user_information,
        AUDT_apdu,
    ]

class Remote_Operations_Generic_ROS_PDUs:

    _name_  = 'Remote-Operations-Generic-ROS-PDUs'
    _oid_   = [2, 4, 6, 0]
    
    _obj_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Reject',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'RejectProblem',
        'InvokeId',
        'noInvokeId',
        'NoInvokeId',
        'Errors',
        'Bind',
        'Unbind',
        ]
    _type_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Reject',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'RejectProblem',
        'InvokeId',
        'Bind',
        'Unbind',
        ]
    _set_ = [
        'NoInvokeId',
        'Errors',
        ]
    _val_ = [
        'noInvokeId',
        ]
    _class_ = [
        'Errors',
        ]
    _param_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Errors',
        'Bind',
        'Unbind',
        ]
    
    #-----< ROS >-----#
    ROS = CHOICE(name='ROS', mode=MODE_TYPE, param=True)
    
    #-----< Invoke >-----#
    Invoke = SEQ(name='Invoke', mode=MODE_TYPE, param=True)
    
    #-----< ReturnResult >-----#
    ReturnResult = SEQ(name='ReturnResult', mode=MODE_TYPE, param=True)
    
    #-----< ReturnError >-----#
    ReturnError = SEQ(name='ReturnError', mode=MODE_TYPE, param=True)
    
    #-----< Reject >-----#
    Reject = SEQ(name='Reject', mode=MODE_TYPE)
    _Reject_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _Reject_problem = CHOICE(name='problem', mode=MODE_TYPE)
    __Reject_problem_general = INT(name='general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'GeneralProblem')))
    __Reject_problem_invoke = INT(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeProblem')))
    __Reject_problem_returnResult = INT(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResultProblem')))
    __Reject_problem_returnError = INT(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnErrorProblem')))
    _Reject_problem._cont = ASN1Dict([
        ('general', __Reject_problem_general),
        ('invoke', __Reject_problem_invoke),
        ('returnResult', __Reject_problem_returnResult),
        ('returnError', __Reject_problem_returnError),
        ])
    _Reject_problem._ext = None
    Reject._cont = ASN1Dict([
        ('invokeId', _Reject_invokeId),
        ('problem', _Reject_problem),
        ])
    Reject._ext = None
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name='GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([('unrecognizedPDU', 0), ('mistypedPDU', 1), ('badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name='InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([('duplicateInvocation', 0), ('unrecognizedOperation', 1), ('mistypedArgument', 2), ('resourceLimitation', 3), ('releaseInProgress', 4), ('unrecognizedLinkedId', 5), ('linkedResponseUnexpected', 6), ('unexpectedLinkedOperation', 7)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name='ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('resultResponseUnexpected', 1), ('mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name='ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('errorResponseUnexpected', 1), ('unrecognizedError', 2), ('unexpectedError', 3), ('mistypedParameter', 4)])
    
    #-----< RejectProblem >-----#
    RejectProblem = INT(name='RejectProblem', mode=MODE_TYPE)
    RejectProblem._cont = ASN1Dict([('general-unrecognizedPDU', 0), ('general-mistypedPDU', 1), ('general-badlyStructuredPDU', 2), ('invoke-duplicateInvocation', 10), ('invoke-unrecognizedOperation', 11), ('invoke-mistypedArgument', 12), ('invoke-resourceLimitation', 13), ('invoke-releaseInProgress', 14), ('invoke-unrecognizedLinkedId', 15), ('invoke-linkedResponseUnexpected', 16), ('invoke-unexpectedLinkedOperation', 17), ('returnResult-unrecognizedInvocation', 20), ('returnResult-resultResponseUnexpected', 21), ('returnResult-mistypedResult', 22), ('returnError-unrecognizedInvocation', 30), ('returnError-errorResponseUnexpected', 31), ('returnError-unrecognizedError', 32), ('returnError-unexpectedError', 33), ('returnError-mistypedParameter', 34)])
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name='InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name='present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name='absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        ('present', _InvokeId_present),
        ('absent', _InvokeId_absent),
        ])
    InvokeId._ext = None
    
    #-----< noInvokeId >-----#
    noInvokeId = CHOICE(name='noInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    noInvokeId._val = ('absent', 0)
    
    #-----< NoInvokeId >-----#
    NoInvokeId = CHOICE(name='NoInvokeId', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    NoInvokeId._val = ASN1Set(rv=[('absent', 0)], rr=[], ev=None, er=[])
    
    #-----< Errors >-----#
    Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), param=True)
    
    #-----< Bind >-----#
    Bind = CHOICE(name='Bind', mode=MODE_TYPE, param=True)
    
    #-----< Unbind >-----#
    Unbind = CHOICE(name='Unbind', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _Reject_invokeId,
        __Reject_problem_general,
        __Reject_problem_invoke,
        __Reject_problem_returnResult,
        __Reject_problem_returnError,
        _Reject_problem,
        Reject,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        RejectProblem,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        noInvokeId,
        NoInvokeId,
    ]

class Remote_Operations_Information_Objects:

    _name_  = 'Remote-Operations-Information-Objects'
    _oid_   = [2, 4, 5, 0]
    
    _obj_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'Code',
        'Priority',
        'refuse',
        'emptyBind',
        'emptyUnbind',
        ]
    _type_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'Code',
        'Priority',
        ]
    _set_ = [
        ]
    _val_ = [
        'refuse',
        'emptyBind',
        'emptyUnbind',
        ]
    _class_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'refuse',
        'emptyBind',
        'emptyUnbind',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name='OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name='ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_argumentTypeOptional = BOOL(name='argumentTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_returnResult = BOOL(name='returnResult', mode=MODE_VALUE, default=True)
    _OPERATION_ResultType = OPEN(name='ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_resultTypeOptional = BOOL(name='resultTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), opt=True)
    _OPERATION_Linked = CLASS(name='Linked', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_synchronous = BOOL(name='synchronous', mode=MODE_VALUE, default=False)
    _OPERATION_alwaysReturns = BOOL(name='alwaysReturns', mode=MODE_VALUE, default=True)
    _OPERATION_InvokePriority = INT(name='InvokePriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_ResultPriority = INT(name='ResultPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_operationCode = CHOICE(name='operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        ('ArgumentType', _OPERATION_ArgumentType),
        ('argumentTypeOptional', _OPERATION_argumentTypeOptional),
        ('returnResult', _OPERATION_returnResult),
        ('ResultType', _OPERATION_ResultType),
        ('resultTypeOptional', _OPERATION_resultTypeOptional),
        ('Errors', _OPERATION_Errors),
        ('Linked', _OPERATION_Linked),
        ('synchronous', _OPERATION_synchronous),
        ('alwaysReturns', _OPERATION_alwaysReturns),
        ('InvokePriority', _OPERATION_InvokePriority),
        ('ResultPriority', _OPERATION_ResultPriority),
        ('operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name='ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name='ParameterType', mode=MODE_TYPE, opt=True)
    _ERROR_parameterTypeOptional = BOOL(name='parameterTypeOptional', mode=MODE_VALUE, opt=True)
    _ERROR_ErrorPriority = INT(name='ErrorPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _ERROR_errorCode = CHOICE(name='errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        ('ParameterType', _ERROR_ParameterType),
        ('parameterTypeOptional', _ERROR_parameterTypeOptional),
        ('ErrorPriority', _ERROR_ErrorPriority),
        ('errorCode', _ERROR_errorCode),
        ])
    
    #-----< OPERATION-PACKAGE >-----#
    OPERATION_PACKAGE = CLASS(name='OPERATION-PACKAGE', mode=MODE_TYPE)
    _OPERATION_PACKAGE_Both = CLASS(name='Both', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Consumer = CLASS(name='Consumer', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Supplier = CLASS(name='Supplier', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    OPERATION_PACKAGE._cont = ASN1Dict([
        ('Both', _OPERATION_PACKAGE_Both),
        ('Consumer', _OPERATION_PACKAGE_Consumer),
        ('Supplier', _OPERATION_PACKAGE_Supplier),
        ('id', _OPERATION_PACKAGE_id),
        ])
    
    #-----< CONNECTION-PACKAGE >-----#
    CONNECTION_PACKAGE = CLASS(name='CONNECTION-PACKAGE', mode=MODE_TYPE)
    _CONNECTION_PACKAGE_bind = CLASS(name='bind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([('Errors', ASN1Set(rv=[dict([('errorCode', ('local', -1))])], rr=[], ev=None, er=[])), ('synchronous', True)]))
    _CONNECTION_PACKAGE_unbind = CLASS(name='unbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([('synchronous', True)]))
    _CONNECTION_PACKAGE_responderCanUnbind = BOOL(name='responderCanUnbind', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_unbindCanFail = BOOL(name='unbindCanFail', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    CONNECTION_PACKAGE._cont = ASN1Dict([
        ('bind', _CONNECTION_PACKAGE_bind),
        ('unbind', _CONNECTION_PACKAGE_unbind),
        ('responderCanUnbind', _CONNECTION_PACKAGE_responderCanUnbind),
        ('unbindCanFail', _CONNECTION_PACKAGE_unbindCanFail),
        ('id', _CONNECTION_PACKAGE_id),
        ])
    
    #-----< CONTRACT >-----#
    CONTRACT = CLASS(name='CONTRACT', mode=MODE_TYPE)
    _CONTRACT_connection = CLASS(name='connection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONNECTION-PACKAGE')), opt=True)
    _CONTRACT_OperationsOf = CLASS(name='OperationsOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorConsumerOf = CLASS(name='InitiatorConsumerOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorSupplierOf = CLASS(name='InitiatorSupplierOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    CONTRACT._cont = ASN1Dict([
        ('connection', _CONTRACT_connection),
        ('OperationsOf', _CONTRACT_OperationsOf),
        ('InitiatorConsumerOf', _CONTRACT_InitiatorConsumerOf),
        ('InitiatorSupplierOf', _CONTRACT_InitiatorSupplierOf),
        ('id', _CONTRACT_id),
        ])
    
    #-----< ROS-OBJECT-CLASS >-----#
    ROS_OBJECT_CLASS = CLASS(name='ROS-OBJECT-CLASS', mode=MODE_TYPE)
    _ROS_OBJECT_CLASS_Is = CLASS(name='Is', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')), opt=True)
    _ROS_OBJECT_CLASS_Initiates = CLASS(name='Initiates', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_Responds = CLASS(name='Responds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_InitiatesAndResponds = CLASS(name='InitiatesAndResponds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ROS_OBJECT_CLASS._cont = ASN1Dict([
        ('Is', _ROS_OBJECT_CLASS_Is),
        ('Initiates', _ROS_OBJECT_CLASS_Initiates),
        ('Responds', _ROS_OBJECT_CLASS_Responds),
        ('InitiatesAndResponds', _ROS_OBJECT_CLASS_InitiatesAndResponds),
        ('id', _ROS_OBJECT_CLASS_id),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name='Code', mode=MODE_TYPE)
    _Code_local = INT(name='local', mode=MODE_TYPE)
    _Code_global_ = OID(name='global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        ('local', _Code_local),
        ('global', _Code_global_),
        ])
    Code._ext = None
    
    #-----< Priority >-----#
    Priority = INT(name='Priority', mode=MODE_TYPE)
    Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< refuse >-----#
    refuse = CLASS(name='refuse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    refuse._val = dict([('errorCode', ('local', -1))])
    
    #-----< emptyBind >-----#
    emptyBind = CLASS(name='emptyBind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyBind._val = dict([('Errors', ASN1Set(rv=[dict([('errorCode', ('local', -1))])], rr=[], ev=None, er=[])), ('synchronous', True)])
    
    #-----< emptyUnbind >-----#
    emptyUnbind = CLASS(name='emptyUnbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyUnbind._val = dict([('synchronous', True)])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_argumentTypeOptional,
        _OPERATION_returnResult,
        _OPERATION_ResultType,
        _OPERATION_resultTypeOptional,
        _OPERATION_Errors,
        _OPERATION_Linked,
        _OPERATION_synchronous,
        _OPERATION_alwaysReturns,
        _OPERATION_InvokePriority,
        _OPERATION_ResultPriority,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_parameterTypeOptional,
        _ERROR_ErrorPriority,
        _ERROR_errorCode,
        ERROR,
        _OPERATION_PACKAGE_Both,
        _OPERATION_PACKAGE_Consumer,
        _OPERATION_PACKAGE_Supplier,
        _OPERATION_PACKAGE_id,
        OPERATION_PACKAGE,
        _CONNECTION_PACKAGE_bind,
        _CONNECTION_PACKAGE_unbind,
        _CONNECTION_PACKAGE_responderCanUnbind,
        _CONNECTION_PACKAGE_unbindCanFail,
        _CONNECTION_PACKAGE_id,
        CONNECTION_PACKAGE,
        _CONTRACT_connection,
        _CONTRACT_OperationsOf,
        _CONTRACT_InitiatorConsumerOf,
        _CONTRACT_InitiatorSupplierOf,
        _CONTRACT_id,
        CONTRACT,
        _ROS_OBJECT_CLASS_Is,
        _ROS_OBJECT_CLASS_Initiates,
        _ROS_OBJECT_CLASS_Responds,
        _ROS_OBJECT_CLASS_InitiatesAndResponds,
        _ROS_OBJECT_CLASS_id,
        ROS_OBJECT_CLASS,
        _Code_local,
        _Code_global_,
        Code,
        Priority,
        refuse,
        emptyBind,
        emptyUnbind,
    ]

class TCAPMessages:

    _name_  = 'TCAPMessages'
    _oid_   = [0, 0, 17, 773, 2, 1, 3]
    
    _obj_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'Abort',
        'DialoguePortion',
        'OrigTransactionID',
        'DestTransactionID',
        'P-AbortCause',
        'ComponentPortion',
        'Component',
        'TCInvokeIdSet',
        ]
    _type_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'Abort',
        'DialoguePortion',
        'OrigTransactionID',
        'DestTransactionID',
        'P-AbortCause',
        'ComponentPortion',
        'Component',
        ]
    _set_ = [
        'TCInvokeIdSet',
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'ComponentPortion',
        'Component',
        ]
    
    #-----< TCMessage >-----#
    TCMessage = CHOICE(name='TCMessage', mode=MODE_TYPE, param=True)
    
    #-----< Unidirectional >-----#
    Unidirectional = SEQ(name='Unidirectional', mode=MODE_TYPE, param=True)
    
    #-----< Begin >-----#
    Begin = SEQ(name='Begin', mode=MODE_TYPE, param=True)
    
    #-----< End >-----#
    End = SEQ(name='End', mode=MODE_TYPE, param=True)
    
    #-----< Continue >-----#
    Continue = SEQ(name='Continue', mode=MODE_TYPE, param=True)
    
    #-----< Abort >-----#
    Abort = SEQ(name='Abort', mode=MODE_TYPE)
    _Abort_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    _Abort_reason = CHOICE(name='reason', mode=MODE_TYPE, opt=True)
    __Abort_reason_p_abortCause = INT(name='p-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'P-AbortCause')))
    __Abort_reason_u_abortCause = SEQ(name='u-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')))
    _Abort_reason._cont = ASN1Dict([
        ('p-abortCause', __Abort_reason_p_abortCause),
        ('u-abortCause', __Abort_reason_u_abortCause),
        ])
    _Abort_reason._ext = None
    Abort._cont = ASN1Dict([
        ('dtid', _Abort_dtid),
        ('reason', _Abort_reason),
        ])
    Abort._ext = None
    
    #-----< DialoguePortion >-----#
    DialoguePortion = SEQ(name='DialoguePortion', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_EXPLICIT), typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    
    #-----< OrigTransactionID >-----#
    OrigTransactionID = OCT_STR(name='OrigTransactionID', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    OrigTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DestTransactionID >-----#
    DestTransactionID = OCT_STR(name='DestTransactionID', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT))
    DestTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< P-AbortCause >-----#
    P_AbortCause = INT(name='P-AbortCause', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT))
    P_AbortCause._cont = ASN1Dict([('unrecognizedMessageType', 0), ('unrecognizedTransactionID', 1), ('badlyFormattedTransactionPortion', 2), ('incorrectTransactionPortion', 3), ('resourceLimitation', 4)])
    P_AbortCause._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ComponentPortion >-----#
    ComponentPortion = SEQ_OF(name='ComponentPortion', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Component >-----#
    Component = CHOICE(name='Component', mode=MODE_TYPE, param=True)
    
    #-----< TCInvokeIdSet >-----#
    TCInvokeIdSet = CHOICE(name='TCInvokeIdSet', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    TCInvokeIdSet._val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    
    _all_ = [
        _Abort_dtid,
        __Abort_reason_p_abortCause,
        __Abort_reason_u_abortCause,
        _Abort_reason,
        Abort,
        DialoguePortion,
        OrigTransactionID,
        DestTransactionID,
        P_AbortCause,
        TCInvokeIdSet,
    ]

class Pycrate_TCAP_Dialogue:

    _name_  = 'Pycrate-TCAP-Dialogue'
    _oid_   = []
    
    _obj_ = [
        'TCAP-DIALOGUE-ENCODING',
        'Tcap-dialogue-encoding',
        'TcapDialogueExternal',
        ]
    _type_ = [
        'TCAP-DIALOGUE-ENCODING',
        'TcapDialogueExternal',
        ]
    _set_ = [
        'Tcap-dialogue-encoding',
        ]
    _val_ = [
        ]
    _class_ = [
        'TCAP-DIALOGUE-ENCODING',
        'Tcap-dialogue-encoding',
        ]
    _param_ = [
        ]
    
    #-----< TCAP-DIALOGUE-ENCODING >-----#
    TCAP_DIALOGUE_ENCODING = CLASS(name='TCAP-DIALOGUE-ENCODING', mode=MODE_TYPE)
    _TCAP_DIALOGUE_ENCODING_ref = OID(name='ref', mode=MODE_VALUE, uniq=True)
    _TCAP_DIALOGUE_ENCODING_Type = OPEN(name='Type', mode=MODE_TYPE)
    TCAP_DIALOGUE_ENCODING._cont = ASN1Dict([
        ('ref', _TCAP_DIALOGUE_ENCODING_ref),
        ('Type', _TCAP_DIALOGUE_ENCODING_Type),
        ])
    
    #-----< Tcap-dialogue-encoding >-----#
    Tcap_dialogue_encoding = CLASS(name='Tcap-dialogue-encoding', mode=MODE_SET, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING')))
    _Tcap_dialogue_encoding_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    _Tcap_dialogue_encoding_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    Tcap_dialogue_encoding._val = ASN1Set(rv=[dict([('ref', (0, 0, 17, 773, 1, 1, 1)), ('Type', _Tcap_dialogue_encoding_val_Type_0)]), dict([('ref', (0, 0, 17, 773, 1, 2, 1)), ('Type', _Tcap_dialogue_encoding_val_Type_1)])], rr=[], ev=[], er=[])
    
    #-----< TcapDialogueExternal >-----#
    TcapDialogueExternal = SEQ(name='TcapDialogueExternal', mode=MODE_TYPE, tag=(8, TAG_UNIVERSAL, TAG_IMPLICIT))
    _TcapDialogueExternal_direct_reference = OID(name='direct-reference', mode=MODE_TYPE, typeref=ASN1RefClassField(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING'), ['ref']), opt=True)
    __TcapDialogueExternal_direct_reference_tab = CLASS(name='_tab_TCAP-DIALOGUE-ENCODING', mode=MODE_SET, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING')))
    ___TcapDialogueExternal_direct_reference_tab_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    ___TcapDialogueExternal_direct_reference_tab_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    __TcapDialogueExternal_direct_reference_tab._val = ASN1Set(rv=[dict([('ref', (0, 0, 17, 773, 1, 1, 1)), ('Type', ___TcapDialogueExternal_direct_reference_tab_val_Type_0)]), dict([('ref', (0, 0, 17, 773, 1, 2, 1)), ('Type', ___TcapDialogueExternal_direct_reference_tab_val_Type_1)])], rr=[], ev=None, er=[])
    _TcapDialogueExternal_direct_reference._const_tab = __TcapDialogueExternal_direct_reference_tab
    _TcapDialogueExternal_direct_reference._const_tab_at = None
    _TcapDialogueExternal_direct_reference._const_tab_id = 'ref'
    _TcapDialogueExternal_indirect_reference = INT(name='indirect-reference', mode=MODE_TYPE, opt=True)
    _TcapDialogueExternal_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, opt=True)
    _TcapDialogueExternal_encoding = CHOICE(name='encoding', mode=MODE_TYPE)
    __TcapDialogueExternal_encoding_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING'), ['Type']))
    __TcapDialogueExternal_encoding_single_ASN1_type._const_tab = __TcapDialogueExternal_direct_reference_tab
    __TcapDialogueExternal_encoding_single_ASN1_type._const_tab_at = ('..', '..', 'direct-reference')
    __TcapDialogueExternal_encoding_single_ASN1_type._const_tab_id = 'Type'
    __TcapDialogueExternal_encoding_octet_aligned = OCT_STR(name='octet-aligned', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TcapDialogueExternal_encoding_arbitrary = BIT_STR(name='arbitrary', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TcapDialogueExternal_encoding._cont = ASN1Dict([
        ('single-ASN1-type', __TcapDialogueExternal_encoding_single_ASN1_type),
        ('octet-aligned', __TcapDialogueExternal_encoding_octet_aligned),
        ('arbitrary', __TcapDialogueExternal_encoding_arbitrary),
        ])
    _TcapDialogueExternal_encoding._ext = None
    TcapDialogueExternal._cont = ASN1Dict([
        ('direct-reference', _TcapDialogueExternal_direct_reference),
        ('indirect-reference', _TcapDialogueExternal_indirect_reference),
        ('data-value-descriptor', _TcapDialogueExternal_data_value_descriptor),
        ('encoding', _TcapDialogueExternal_encoding),
        ])
    TcapDialogueExternal._ext = None
    
    _all_ = [
        _TCAP_DIALOGUE_ENCODING_ref,
        _TCAP_DIALOGUE_ENCODING_Type,
        TCAP_DIALOGUE_ENCODING,
        Tcap_dialogue_encoding,
        _Tcap_dialogue_encoding_val_Type_0,
        _Tcap_dialogue_encoding_val_Type_1,
        __TcapDialogueExternal_direct_reference_tab,
        ___TcapDialogueExternal_direct_reference_tab_val_Type_0,
        ___TcapDialogueExternal_direct_reference_tab_val_Type_1,
        _TcapDialogueExternal_direct_reference,
        _TcapDialogueExternal_indirect_reference,
        _TcapDialogueExternal_data_value_descriptor,
        __TcapDialogueExternal_encoding_single_ASN1_type,
        __TcapDialogueExternal_encoding_octet_aligned,
        __TcapDialogueExternal_encoding_arbitrary,
        _TcapDialogueExternal_encoding,
        TcapDialogueExternal,
    ]

class TCAP_Messages:

    _name_  = 'TCAP-Messages'
    _oid_   = []
    
    _obj_ = [
        'TCAP-Message',
        ]
    _type_ = [
        'TCAP-Message',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TCAP-Message >-----#
    TCAP_Message = CHOICE(name='TCAP-Message', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _TCAP_Message_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __TCAP_Message_unidirectional_dialoguePortion = SEQ(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_Message_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___TCAP_Message_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_Message_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_Message_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    _______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument_tab
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____TCAP_Message_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____TCAP_Message_unidirectional_components__item__basicROS_invoke._ext = None
    _____TCAP_Message_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result_tab
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____TCAP_Message_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____TCAP_Message_unidirectional_components__item__basicROS_returnResult._ext = None
    _____TCAP_Message_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    _______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter_tab
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____TCAP_Message_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_Message_unidirectional_components__item__basicROS_returnError._ext = None
    _____TCAP_Message_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_Message_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____TCAP_Message_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____TCAP_Message_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____TCAP_Message_unidirectional_components__item__basicROS_returnError),
        ('reject', _____TCAP_Message_unidirectional_components__item__basicROS_reject),
        ])
    ____TCAP_Message_unidirectional_components__item__basicROS._ext = None
    ____TCAP_Message_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____TCAP_Message_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_Message_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode_tab
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result._const_tab = _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result_tab
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____TCAP_Message_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_Message_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____TCAP_Message_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____TCAP_Message_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____TCAP_Message_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____TCAP_Message_unidirectional_components__item__returnResultNotLast._ext = None
    ___TCAP_Message_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____TCAP_Message_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____TCAP_Message_unidirectional_components__item__returnResultNotLast),
        ])
    ___TCAP_Message_unidirectional_components__item_._ext = None
    __TCAP_Message_unidirectional_components._cont = ___TCAP_Message_unidirectional_components__item_
    __TCAP_Message_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_Message_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __TCAP_Message_unidirectional_dialoguePortion),
        ('components', __TCAP_Message_unidirectional_components),
        ])
    _TCAP_Message_unidirectional._ext = None
    _TCAP_Message_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __TCAP_Message_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __TCAP_Message_begin_dialoguePortion = SEQ(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_Message_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___TCAP_Message_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_Message_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_Message_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_Message_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______TCAP_Message_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_Message_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______TCAP_Message_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______TCAP_Message_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_Message_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_Message_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_begin_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_begin_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__basicROS_invoke_opcode._const_tab = _______TCAP_Message_begin_components__item__basicROS_invoke_opcode_tab
    ______TCAP_Message_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_Message_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    _______TCAP_Message_begin_components__item__basicROS_invoke_argument_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_begin_components__item__basicROS_invoke_argument_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__basicROS_invoke_argument._const_tab = _______TCAP_Message_begin_components__item__basicROS_invoke_argument_tab
    ______TCAP_Message_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____TCAP_Message_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______TCAP_Message_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______TCAP_Message_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______TCAP_Message_begin_components__item__basicROS_invoke_argument),
        ])
    _____TCAP_Message_begin_components__item__basicROS_invoke._ext = None
    _____TCAP_Message_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_Message_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ________TCAP_Message_begin_components__item__basicROS_returnResult_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_begin_components__item__basicROS_returnResult_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_Message_begin_components__item__basicROS_returnResult_result_result_tab
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______TCAP_Message_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______TCAP_Message_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______TCAP_Message_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_Message_begin_components__item__basicROS_returnResult_result._ext = None
    _____TCAP_Message_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______TCAP_Message_begin_components__item__basicROS_returnResult_result),
        ])
    _____TCAP_Message_begin_components__item__basicROS_returnResult._ext = None
    _____TCAP_Message_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_Message_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______TCAP_Message_begin_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_begin_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__basicROS_returnError_errcode._const_tab = _______TCAP_Message_begin_components__item__basicROS_returnError_errcode_tab
    ______TCAP_Message_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_Message_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______TCAP_Message_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    _______TCAP_Message_begin_components__item__basicROS_returnError_parameter_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_begin_components__item__basicROS_returnError_parameter_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__basicROS_returnError_parameter._const_tab = _______TCAP_Message_begin_components__item__basicROS_returnError_parameter_tab
    ______TCAP_Message_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______TCAP_Message_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____TCAP_Message_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______TCAP_Message_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______TCAP_Message_begin_components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_Message_begin_components__item__basicROS_returnError._ext = None
    _____TCAP_Message_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_Message_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____TCAP_Message_begin_components__item__basicROS_invoke),
        ('returnResult', _____TCAP_Message_begin_components__item__basicROS_returnResult),
        ('returnError', _____TCAP_Message_begin_components__item__basicROS_returnError),
        ('reject', _____TCAP_Message_begin_components__item__basicROS_reject),
        ])
    ____TCAP_Message_begin_components__item__basicROS._ext = None
    ____TCAP_Message_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____TCAP_Message_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_Message_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode._const_tab = _______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode_tab
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______TCAP_Message_begin_components__item__returnResultNotLast_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_begin_components__item__returnResultNotLast_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_result._const_tab = _______TCAP_Message_begin_components__item__returnResultNotLast_result_result_tab
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____TCAP_Message_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______TCAP_Message_begin_components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_Message_begin_components__item__returnResultNotLast_result._ext = None
    ____TCAP_Message_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____TCAP_Message_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____TCAP_Message_begin_components__item__returnResultNotLast_result),
        ])
    ____TCAP_Message_begin_components__item__returnResultNotLast._ext = None
    ___TCAP_Message_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____TCAP_Message_begin_components__item__basicROS),
        ('returnResultNotLast', ____TCAP_Message_begin_components__item__returnResultNotLast),
        ])
    ___TCAP_Message_begin_components__item_._ext = None
    __TCAP_Message_begin_components._cont = ___TCAP_Message_begin_components__item_
    __TCAP_Message_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_Message_begin._cont = ASN1Dict([
        ('otid', __TCAP_Message_begin_otid),
        ('dialoguePortion', __TCAP_Message_begin_dialoguePortion),
        ('components', __TCAP_Message_begin_components),
        ])
    _TCAP_Message_begin._ext = None
    _TCAP_Message_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __TCAP_Message_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __TCAP_Message_end_dialoguePortion = SEQ(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_Message_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___TCAP_Message_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_Message_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_Message_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_Message_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______TCAP_Message_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_Message_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______TCAP_Message_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______TCAP_Message_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_Message_end_components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_Message_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_end_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_end_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__basicROS_invoke_opcode._const_tab = _______TCAP_Message_end_components__item__basicROS_invoke_opcode_tab
    ______TCAP_Message_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_Message_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    _______TCAP_Message_end_components__item__basicROS_invoke_argument_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_end_components__item__basicROS_invoke_argument_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__basicROS_invoke_argument._const_tab = _______TCAP_Message_end_components__item__basicROS_invoke_argument_tab
    ______TCAP_Message_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____TCAP_Message_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______TCAP_Message_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______TCAP_Message_end_components__item__basicROS_invoke_opcode),
        ('argument', ______TCAP_Message_end_components__item__basicROS_invoke_argument),
        ])
    _____TCAP_Message_end_components__item__basicROS_invoke._ext = None
    _____TCAP_Message_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_Message_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________TCAP_Message_end_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_end_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_Message_end_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ________TCAP_Message_end_components__item__basicROS_returnResult_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_end_components__item__basicROS_returnResult_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_Message_end_components__item__basicROS_returnResult_result_result_tab
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______TCAP_Message_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______TCAP_Message_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______TCAP_Message_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______TCAP_Message_end_components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_Message_end_components__item__basicROS_returnResult_result._ext = None
    _____TCAP_Message_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______TCAP_Message_end_components__item__basicROS_returnResult_result),
        ])
    _____TCAP_Message_end_components__item__basicROS_returnResult._ext = None
    _____TCAP_Message_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_Message_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______TCAP_Message_end_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_end_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__basicROS_returnError_errcode._const_tab = _______TCAP_Message_end_components__item__basicROS_returnError_errcode_tab
    ______TCAP_Message_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_Message_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______TCAP_Message_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    _______TCAP_Message_end_components__item__basicROS_returnError_parameter_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_end_components__item__basicROS_returnError_parameter_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__basicROS_returnError_parameter._const_tab = _______TCAP_Message_end_components__item__basicROS_returnError_parameter_tab
    ______TCAP_Message_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______TCAP_Message_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____TCAP_Message_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______TCAP_Message_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______TCAP_Message_end_components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_Message_end_components__item__basicROS_returnError._ext = None
    _____TCAP_Message_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_Message_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____TCAP_Message_end_components__item__basicROS_invoke),
        ('returnResult', _____TCAP_Message_end_components__item__basicROS_returnResult),
        ('returnError', _____TCAP_Message_end_components__item__basicROS_returnError),
        ('reject', _____TCAP_Message_end_components__item__basicROS_reject),
        ])
    ____TCAP_Message_end_components__item__basicROS._ext = None
    ____TCAP_Message_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____TCAP_Message_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_Message_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______TCAP_Message_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_end_components__item__returnResultNotLast_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_end_components__item__returnResultNotLast_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__returnResultNotLast_result_opcode._const_tab = _______TCAP_Message_end_components__item__returnResultNotLast_result_opcode_tab
    ______TCAP_Message_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_Message_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______TCAP_Message_end_components__item__returnResultNotLast_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_end_components__item__returnResultNotLast_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_end_components__item__returnResultNotLast_result_result._const_tab = _______TCAP_Message_end_components__item__returnResultNotLast_result_result_tab
    ______TCAP_Message_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____TCAP_Message_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______TCAP_Message_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______TCAP_Message_end_components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_Message_end_components__item__returnResultNotLast_result._ext = None
    ____TCAP_Message_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____TCAP_Message_end_components__item__returnResultNotLast_invokeId),
        ('result', _____TCAP_Message_end_components__item__returnResultNotLast_result),
        ])
    ____TCAP_Message_end_components__item__returnResultNotLast._ext = None
    ___TCAP_Message_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____TCAP_Message_end_components__item__basicROS),
        ('returnResultNotLast', ____TCAP_Message_end_components__item__returnResultNotLast),
        ])
    ___TCAP_Message_end_components__item_._ext = None
    __TCAP_Message_end_components._cont = ___TCAP_Message_end_components__item_
    __TCAP_Message_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_Message_end._cont = ASN1Dict([
        ('dtid', __TCAP_Message_end_dtid),
        ('dialoguePortion', __TCAP_Message_end_dialoguePortion),
        ('components', __TCAP_Message_end_components),
        ])
    _TCAP_Message_end._ext = None
    _TCAP_Message_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __TCAP_Message_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __TCAP_Message_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __TCAP_Message_continue__dialoguePortion = SEQ(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_Message_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___TCAP_Message_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_Message_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_Message_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_Message_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______TCAP_Message_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_Message_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______TCAP_Message_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______TCAP_Message_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_Message_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_Message_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_continue__components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_continue__components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__basicROS_invoke_opcode._const_tab = _______TCAP_Message_continue__components__item__basicROS_invoke_opcode_tab
    ______TCAP_Message_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_Message_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    _______TCAP_Message_continue__components__item__basicROS_invoke_argument_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_continue__components__item__basicROS_invoke_argument_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__basicROS_invoke_argument._const_tab = _______TCAP_Message_continue__components__item__basicROS_invoke_argument_tab
    ______TCAP_Message_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____TCAP_Message_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______TCAP_Message_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______TCAP_Message_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______TCAP_Message_continue__components__item__basicROS_invoke_argument),
        ])
    _____TCAP_Message_continue__components__item__basicROS_invoke._ext = None
    _____TCAP_Message_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_Message_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ________TCAP_Message_continue__components__item__basicROS_returnResult_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_Message_continue__components__item__basicROS_returnResult_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_Message_continue__components__item__basicROS_returnResult_result_result_tab
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______TCAP_Message_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______TCAP_Message_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______TCAP_Message_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_Message_continue__components__item__basicROS_returnResult_result._ext = None
    _____TCAP_Message_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______TCAP_Message_continue__components__item__basicROS_returnResult_result),
        ])
    _____TCAP_Message_continue__components__item__basicROS_returnResult._ext = None
    _____TCAP_Message_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_Message_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_Message_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______TCAP_Message_continue__components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_continue__components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__basicROS_returnError_errcode._const_tab = _______TCAP_Message_continue__components__item__basicROS_returnError_errcode_tab
    ______TCAP_Message_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_Message_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______TCAP_Message_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    _______TCAP_Message_continue__components__item__basicROS_returnError_parameter_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _______TCAP_Message_continue__components__item__basicROS_returnError_parameter_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__basicROS_returnError_parameter._const_tab = _______TCAP_Message_continue__components__item__basicROS_returnError_parameter_tab
    ______TCAP_Message_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______TCAP_Message_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____TCAP_Message_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______TCAP_Message_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______TCAP_Message_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______TCAP_Message_continue__components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_Message_continue__components__item__basicROS_returnError._ext = None
    _____TCAP_Message_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_Message_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____TCAP_Message_continue__components__item__basicROS_invoke),
        ('returnResult', _____TCAP_Message_continue__components__item__basicROS_returnResult),
        ('returnError', _____TCAP_Message_continue__components__item__basicROS_returnError),
        ('reject', _____TCAP_Message_continue__components__item__basicROS_reject),
        ])
    ____TCAP_Message_continue__components__item__basicROS._ext = None
    ____TCAP_Message_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____TCAP_Message_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_Message_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode._const_tab = _______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode_tab
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______TCAP_Message_continue__components__item__returnResultNotLast_result_result_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _______TCAP_Message_continue__components__item__returnResultNotLast_result_result_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_result._const_tab = _______TCAP_Message_continue__components__item__returnResultNotLast_result_result_tab
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______TCAP_Message_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____TCAP_Message_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______TCAP_Message_continue__components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_Message_continue__components__item__returnResultNotLast_result._ext = None
    ____TCAP_Message_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____TCAP_Message_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____TCAP_Message_continue__components__item__returnResultNotLast_result),
        ])
    ____TCAP_Message_continue__components__item__returnResultNotLast._ext = None
    ___TCAP_Message_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____TCAP_Message_continue__components__item__basicROS),
        ('returnResultNotLast', ____TCAP_Message_continue__components__item__returnResultNotLast),
        ])
    ___TCAP_Message_continue__components__item_._ext = None
    __TCAP_Message_continue__components._cont = ___TCAP_Message_continue__components__item_
    __TCAP_Message_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_Message_continue_._cont = ASN1Dict([
        ('otid', __TCAP_Message_continue__otid),
        ('dtid', __TCAP_Message_continue__dtid),
        ('dialoguePortion', __TCAP_Message_continue__dialoguePortion),
        ('components', __TCAP_Message_continue__components),
        ])
    _TCAP_Message_continue_._ext = None
    _TCAP_Message_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    TCAP_Message._cont = ASN1Dict([
        ('unidirectional', _TCAP_Message_unidirectional),
        ('begin', _TCAP_Message_begin),
        ('end', _TCAP_Message_end),
        ('continue', _TCAP_Message_continue_),
        ('abort', _TCAP_Message_abort),
        ])
    TCAP_Message._ext = None
    
    _all_ = [
        __TCAP_Message_unidirectional_dialoguePortion,
        ______TCAP_Message_unidirectional_components__item__basicROS_invoke_invokeId,
        _______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_Message_unidirectional_components__item__basicROS_invoke_linkedId,
        _______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ______TCAP_Message_unidirectional_components__item__basicROS_invoke_opcode,
        _______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument_tab,
        ______TCAP_Message_unidirectional_components__item__basicROS_invoke_argument,
        _____TCAP_Message_unidirectional_components__item__basicROS_invoke,
        ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode,
        ________TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result_tab,
        _______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result_result,
        ______TCAP_Message_unidirectional_components__item__basicROS_returnResult_result,
        _____TCAP_Message_unidirectional_components__item__basicROS_returnResult,
        ______TCAP_Message_unidirectional_components__item__basicROS_returnError_invokeId,
        _______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ______TCAP_Message_unidirectional_components__item__basicROS_returnError_errcode,
        _______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter_tab,
        ______TCAP_Message_unidirectional_components__item__basicROS_returnError_parameter,
        _____TCAP_Message_unidirectional_components__item__basicROS_returnError,
        _____TCAP_Message_unidirectional_components__item__basicROS_reject,
        ____TCAP_Message_unidirectional_components__item__basicROS,
        _____TCAP_Message_unidirectional_components__item__returnResultNotLast_invokeId,
        _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode_tab,
        ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode,
        _______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result_tab,
        ______TCAP_Message_unidirectional_components__item__returnResultNotLast_result_result,
        _____TCAP_Message_unidirectional_components__item__returnResultNotLast_result,
        ____TCAP_Message_unidirectional_components__item__returnResultNotLast,
        ___TCAP_Message_unidirectional_components__item_,
        __TCAP_Message_unidirectional_components,
        _TCAP_Message_unidirectional,
        __TCAP_Message_begin_otid,
        __TCAP_Message_begin_dialoguePortion,
        ______TCAP_Message_begin_components__item__basicROS_invoke_invokeId,
        _______TCAP_Message_begin_components__item__basicROS_invoke_linkedId_present,
        _______TCAP_Message_begin_components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_Message_begin_components__item__basicROS_invoke_linkedId,
        _______TCAP_Message_begin_components__item__basicROS_invoke_opcode_tab,
        ______TCAP_Message_begin_components__item__basicROS_invoke_opcode,
        _______TCAP_Message_begin_components__item__basicROS_invoke_argument_tab,
        ______TCAP_Message_begin_components__item__basicROS_invoke_argument,
        _____TCAP_Message_begin_components__item__basicROS_invoke,
        ______TCAP_Message_begin_components__item__basicROS_returnResult_invokeId,
        ________TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode_tab,
        _______TCAP_Message_begin_components__item__basicROS_returnResult_result_opcode,
        ________TCAP_Message_begin_components__item__basicROS_returnResult_result_result_tab,
        _______TCAP_Message_begin_components__item__basicROS_returnResult_result_result,
        ______TCAP_Message_begin_components__item__basicROS_returnResult_result,
        _____TCAP_Message_begin_components__item__basicROS_returnResult,
        ______TCAP_Message_begin_components__item__basicROS_returnError_invokeId,
        _______TCAP_Message_begin_components__item__basicROS_returnError_errcode_tab,
        ______TCAP_Message_begin_components__item__basicROS_returnError_errcode,
        _______TCAP_Message_begin_components__item__basicROS_returnError_parameter_tab,
        ______TCAP_Message_begin_components__item__basicROS_returnError_parameter,
        _____TCAP_Message_begin_components__item__basicROS_returnError,
        _____TCAP_Message_begin_components__item__basicROS_reject,
        ____TCAP_Message_begin_components__item__basicROS,
        _____TCAP_Message_begin_components__item__returnResultNotLast_invokeId,
        _______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode_tab,
        ______TCAP_Message_begin_components__item__returnResultNotLast_result_opcode,
        _______TCAP_Message_begin_components__item__returnResultNotLast_result_result_tab,
        ______TCAP_Message_begin_components__item__returnResultNotLast_result_result,
        _____TCAP_Message_begin_components__item__returnResultNotLast_result,
        ____TCAP_Message_begin_components__item__returnResultNotLast,
        ___TCAP_Message_begin_components__item_,
        __TCAP_Message_begin_components,
        _TCAP_Message_begin,
        __TCAP_Message_end_dtid,
        __TCAP_Message_end_dialoguePortion,
        ______TCAP_Message_end_components__item__basicROS_invoke_invokeId,
        _______TCAP_Message_end_components__item__basicROS_invoke_linkedId_present,
        _______TCAP_Message_end_components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_Message_end_components__item__basicROS_invoke_linkedId,
        _______TCAP_Message_end_components__item__basicROS_invoke_opcode_tab,
        ______TCAP_Message_end_components__item__basicROS_invoke_opcode,
        _______TCAP_Message_end_components__item__basicROS_invoke_argument_tab,
        ______TCAP_Message_end_components__item__basicROS_invoke_argument,
        _____TCAP_Message_end_components__item__basicROS_invoke,
        ______TCAP_Message_end_components__item__basicROS_returnResult_invokeId,
        ________TCAP_Message_end_components__item__basicROS_returnResult_result_opcode_tab,
        _______TCAP_Message_end_components__item__basicROS_returnResult_result_opcode,
        ________TCAP_Message_end_components__item__basicROS_returnResult_result_result_tab,
        _______TCAP_Message_end_components__item__basicROS_returnResult_result_result,
        ______TCAP_Message_end_components__item__basicROS_returnResult_result,
        _____TCAP_Message_end_components__item__basicROS_returnResult,
        ______TCAP_Message_end_components__item__basicROS_returnError_invokeId,
        _______TCAP_Message_end_components__item__basicROS_returnError_errcode_tab,
        ______TCAP_Message_end_components__item__basicROS_returnError_errcode,
        _______TCAP_Message_end_components__item__basicROS_returnError_parameter_tab,
        ______TCAP_Message_end_components__item__basicROS_returnError_parameter,
        _____TCAP_Message_end_components__item__basicROS_returnError,
        _____TCAP_Message_end_components__item__basicROS_reject,
        ____TCAP_Message_end_components__item__basicROS,
        _____TCAP_Message_end_components__item__returnResultNotLast_invokeId,
        _______TCAP_Message_end_components__item__returnResultNotLast_result_opcode_tab,
        ______TCAP_Message_end_components__item__returnResultNotLast_result_opcode,
        _______TCAP_Message_end_components__item__returnResultNotLast_result_result_tab,
        ______TCAP_Message_end_components__item__returnResultNotLast_result_result,
        _____TCAP_Message_end_components__item__returnResultNotLast_result,
        ____TCAP_Message_end_components__item__returnResultNotLast,
        ___TCAP_Message_end_components__item_,
        __TCAP_Message_end_components,
        _TCAP_Message_end,
        __TCAP_Message_continue__otid,
        __TCAP_Message_continue__dtid,
        __TCAP_Message_continue__dialoguePortion,
        ______TCAP_Message_continue__components__item__basicROS_invoke_invokeId,
        _______TCAP_Message_continue__components__item__basicROS_invoke_linkedId_present,
        _______TCAP_Message_continue__components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_Message_continue__components__item__basicROS_invoke_linkedId,
        _______TCAP_Message_continue__components__item__basicROS_invoke_opcode_tab,
        ______TCAP_Message_continue__components__item__basicROS_invoke_opcode,
        _______TCAP_Message_continue__components__item__basicROS_invoke_argument_tab,
        ______TCAP_Message_continue__components__item__basicROS_invoke_argument,
        _____TCAP_Message_continue__components__item__basicROS_invoke,
        ______TCAP_Message_continue__components__item__basicROS_returnResult_invokeId,
        ________TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode_tab,
        _______TCAP_Message_continue__components__item__basicROS_returnResult_result_opcode,
        ________TCAP_Message_continue__components__item__basicROS_returnResult_result_result_tab,
        _______TCAP_Message_continue__components__item__basicROS_returnResult_result_result,
        ______TCAP_Message_continue__components__item__basicROS_returnResult_result,
        _____TCAP_Message_continue__components__item__basicROS_returnResult,
        ______TCAP_Message_continue__components__item__basicROS_returnError_invokeId,
        _______TCAP_Message_continue__components__item__basicROS_returnError_errcode_tab,
        ______TCAP_Message_continue__components__item__basicROS_returnError_errcode,
        _______TCAP_Message_continue__components__item__basicROS_returnError_parameter_tab,
        ______TCAP_Message_continue__components__item__basicROS_returnError_parameter,
        _____TCAP_Message_continue__components__item__basicROS_returnError,
        _____TCAP_Message_continue__components__item__basicROS_reject,
        ____TCAP_Message_continue__components__item__basicROS,
        _____TCAP_Message_continue__components__item__returnResultNotLast_invokeId,
        _______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode_tab,
        ______TCAP_Message_continue__components__item__returnResultNotLast_result_opcode,
        _______TCAP_Message_continue__components__item__returnResultNotLast_result_result_tab,
        ______TCAP_Message_continue__components__item__returnResultNotLast_result_result,
        _____TCAP_Message_continue__components__item__returnResultNotLast_result,
        ____TCAP_Message_continue__components__item__returnResultNotLast,
        ___TCAP_Message_continue__components__item_,
        __TCAP_Message_continue__components,
        _TCAP_Message_continue_,
        _TCAP_Message_abort,
        TCAP_Message,
    ]

init_modules(DialoguePDUs, UnidialoguePDUs, Remote_Operations_Generic_ROS_PDUs, Remote_Operations_Information_Objects, TCAPMessages, Pycrate_TCAP_Dialogue, TCAP_Messages)
