# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/channel_request_type_3_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08, release 3
# section: 10.1.8.4 Channel Request Type 3 (Iu mode only)
# top-level object: Channel Request Type 3 Message Content



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

rb_request_struct_ie = CSN1List(name='rb_request_struct_ie', list=[
  CSN1Bit(name='rb_id', bit=5),
  CSN1Bit(name='rlc_block_count', bit=6)])

relative_position_ie = CSN1List(name='relative_position_ie', list=[
  CSN1Bit(name='gps_capability_indicator'),
  CSN1Bit(name='relative_latitude', bit=12),
  CSN1Bit(name='relative_longitude', bit=13)])

enhanced_relative_position_ie = CSN1List(name='enhanced_relative_position_ie', list=[
  CSN1Bit(name='enhanced_relative_latitude', bit=19),
  CSN1Bit(name='enhanced_relative_longitude', bit=19)])

channel_request_type_3_message_content = CSN1List(name='channel_request_type_3_message_content', list=[
  CSN1Val(name='', val='0'),
  CSN1List(list=[
    CSN1Bit(name='retry_counter', bit=2),
    CSN1Bit(name='test_mode')]),
  CSN1Alt(alt={
    '0000': ('', [
    CSN1List(list=[
      CSN1Bit(name='random_s_rnti', bit=20),
      CSN1Bit(name='rrc_establishment_cause', bit=5),
      CSN1Ref(name='mes_position', obj=relative_position_ie),
      CSN1Bit(name='gmprs_terminal_type_id', bit=7),
      CSN1Bit(name='ra_indicator'),
      CSN1Bit(name='spare')])]),
    '0001': ('', [
    CSN1List(list=[
      CSN1Bit(name='s_rnti', bit=20),
      CSN1Ref(name='mes_position', obj=relative_position_ie),
      CSN1Bit(name='spare', bit=14)])]),
    '0010': ('', [
    CSN1List(list=[
      CSN1Bit(name='g_rnti', bit=32),
      CSN1Ref(name='mes_position', obj=relative_position_ie),
      CSN1Bit(name='spare', bit=2)])]),
    '0011': ('', [
    CSN1List(list=[
      CSN1Bit(name='s_rnti', bit=20),
      CSN1Bit(name='cell_update_cause', bit=3),
      CSN1Ref(name='mes_position', obj=relative_position_ie),
      CSN1Ref(name='rb_info', obj=rb_request_struct_ie)])]),
    '0100': ('', [
    CSN1List(list=[
      CSN1Bit(name='s_rnti', bit=20),
      CSN1Ref(name='mes_position', obj=relative_position_ie),
      CSN1Bit(name='rb_id', bit=5),
      CSN1Bit(name='user_data', bit=8),
      CSN1Bit(name='spare')])]),
    '0101': ('', [
    CSN1List(list=[
      CSN1Bit(name='s_rnti_or_random_s_rnti', bit=20),
      CSN1Ref(name='enhanced_mes_position', obj=enhanced_relative_position_ie),
      CSN1Bit(name='mes_rrc_mode_indicator'),
      CSN1Bit(name='spare')])])})])

