# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/ciphering_mode_info_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.3.14        Ciphering Mode Info
# top-level object: Ciphering Mode Info IE

# external references
from pycrate_gmr1_csn1.ciphering_algorithm_ie import ciphering_algorithm_ie
from pycrate_gmr1_csn1.activation_time_ie import activation_time_ie
from pycrate_gmr1_csn1.rb_activation_time_info_ie import rb_activation_time_info_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

ciphering_mode_info_ie = CSN1Alt(name='ciphering_mode_info_ie', alt={
  '0': ('ciphering_mode_command', []),
  '1': ('ciphering_mode_command', [
  CSN1List(list=[
    CSN1Ref(name='ciphering_algorithm', obj=ciphering_algorithm_ie),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='ciphering_activation_time_for_dch', obj=activation_time_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='rb_downlink_ciphering_activation_time_info', obj=rb_activation_time_info_ie)])})])])})

