# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/data_compression_parameter_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.3.59a Data Compression Parameters
# top-level object: Data Compression Parameter IE



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

spare_bit = CSN1Bit(name='spare_bit')
Spare_bit = spare_bit
Spare_Bit = spare_bit

v44_parameters_struct = CSN1List(name='v44_parameters_struct', list=[
  CSN1Bit(name='n2', bit=11),
  CSN1Bit(name='n7', bit=9),
  CSN1Bit(name='n8', bit=4),
  CSN1Bit(name='n4', bit=8),
  CSN1Bit(name='n5', bit=4),
  CSN1Bit(name='c1', bit=4),
  CSN1Bit(name='c2', bit=3),
  CSN1Bit(name='c3', bit=8),
  CSN1Bit(name='c4', bit=16),
  CSN1Bit(name='c5', bit=4)])

data_compression_parameter_ie = CSN1List(name='data_compression_parameter_ie', list=[
  CSN1Bit(name='data_compression_parameters_length', bit=6),
  CSN1Alt(alt={
    '0': ('v44_data_compression', []),
    '1': ('v44_data_compression', [
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='v44_parameters', obj=v44_parameters_struct)])})])}),
  CSN1Ref(obj=spare_bit, num=-1)])

