# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/frequency_parameters_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 12.8           Frequency parameters
# top-level object: Frequency Parameters IE



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

frequency_parameters_ie = CSN1List(name='frequency_parameters_ie', list=[
  CSN1Bit(name='downlink_bw', bit=3),
  CSN1Bit(name='downlink_arfcn', bit=11),
  CSN1Bit(name='reserved'),
  CSN1Bit(name='uplink_bw', bit=3),
  CSN1Bit(name='uplink_arfcn', bit=11),
  CSN1Bit(name='reserved')])

frequency_struct = CSN1List(name='frequency_struct', list=[
  CSN1Bit(name='bandwidth', bit=3),
  CSN1Bit(name='arfcn', bit=11),
  CSN1Bit(name='reserved')])

frequency_allocation_ie = CSN1List(name='frequency_allocation_ie', list=[
  CSN1Ref(name='downlink_frequency', obj=frequency_struct),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Ref(name='uplink_frequency', obj=frequency_struct)])})])

