# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/gbch3_ecef_information_message.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 10.1.46a GBCH3 ECEF information
# top-level object: GBCH3 ECEF Information Message



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

gbch3_ecef_information_type_1 = CSN1List(name='gbch3_ecef_information_type_1', list=[
  CSN1Bit(name='gps_time', bit=40),
  CSN1Bit(name='curve_fit_time', bit=40),
  CSN1Bit(name='frame_number', bit=19),
  CSN1Bit(name='sv_id_satellite_1', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='spare', bit=7)])

gbch3_ecef_information_type_2 = CSN1List(name='gbch3_ecef_information_type_2', list=[
  CSN1Bit(name='sv_id_satellite_1', bit=6),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_2', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='spare', bit=6)])

gbch3_ecef_information_type_3 = CSN1List(name='gbch3_ecef_information_type_3', list=[
  CSN1Bit(name='sv_id_satellite_2', bit=6),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='spare', bit=6)])

gbch3_ecef_information_type_4 = CSN1List(name='gbch3_ecef_information_type_4', list=[
  CSN1Bit(name='sv_id_satellite_2', bit=6),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_3', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='xv0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_5 = CSN1List(name='gbch3_ecef_information_type_5', list=[
  CSN1Bit(name='sv_id_satellite_2', bit=6),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_4', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_6 = CSN1List(name='gbch3_ecef_information_type_6', list=[
  CSN1Bit(name='sv_id_satellite_4', bit=6),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='spare', bit=2)])

gbch3_ecef_information_type_7 = CSN1List(name='gbch3_ecef_information_type_7', list=[
  CSN1Bit(name='sv_id_satellite_5', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='spare', bit=4)])

gbch3_ecef_information_type_8 = CSN1List(name='gbch3_ecef_information_type_8', list=[
  CSN1Bit(name='sv_id_satellite_5', bit=6),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_6', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_9 = CSN1List(name='gbch3_ecef_information_type_9', list=[
  CSN1Bit(name='sv_id_satellite_6', bit=6),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_7', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='vxo', bit=18),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_10 = CSN1List(name='gbch3_ecef_information_type_10', list=[
  CSN1Bit(name='sv_id_satellite_7', bit=6),
  CSN1Bit(name='x0', bit=24),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='spare', bit=7)])

gbch3_ecef_information_type_11 = CSN1List(name='gbch3_ecef_information_type_11', list=[
  CSN1Bit(name='sv_id_satellite_7', bit=6),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_8', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_12 = CSN1List(name='gbch3_ecef_information_type_12', list=[
  CSN1Bit(name='sv_id_satellite_8', bit=6),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_9', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_13 = CSN1List(name='gbch3_ecef_information_type_13', list=[
  CSN1Bit(name='sv_id_satellite_9', bit=6),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_10', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_14 = CSN1List(name='gbch3_ecef_information_type_14', list=[
  CSN1Bit(name='sv_id_satellite_10', bit=6),
  CSN1Bit(name='x0', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='spare', bit=10)])

gbch3_ecef_information_type_15 = CSN1List(name='gbch3_ecef_information_type_15', list=[
  CSN1Bit(name='sv_id_satellite_10', bit=6),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_11', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_16 = CSN1List(name='gbch3_ecef_information_type_16', list=[
  CSN1Bit(name='sv_id_satellite_11', bit=6),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='sv_id_satellite_12', bit=6),
  CSN1Bit(name='doppler', bit=8),
  CSN1Bit(name='code_phase', bit=22),
  CSN1Bit(name='xo', bit=24),
  CSN1Bit(name='vx0', bit=18),
  CSN1Bit(name='spare', bit=5)])

gbch3_ecef_information_type_17 = CSN1List(name='gbch3_ecef_information_type_17', list=[
  CSN1Bit(name='sv_id_satellite12', bit=6),
  CSN1Bit(name='vx1', bit=13),
  CSN1Bit(name='vx2', bit=8),
  CSN1Bit(name='y0', bit=24),
  CSN1Bit(name='vy0', bit=18),
  CSN1Bit(name='vy1', bit=13),
  CSN1Bit(name='vy2', bit=8),
  CSN1Bit(name='z0', bit=24),
  CSN1Bit(name='vz0', bit=18),
  CSN1Bit(name='vz1', bit=13),
  CSN1Bit(name='vz2', bit=8),
  CSN1Bit(name='af1', bit=11),
  CSN1Bit(name='spare', bit=20)])

gbch3_ecef_information_message = CSN1List(name='gbch3_ecef_information_message', list=[
  CSN1Bit(name='escape_coordinate_type_bit'),
  CSN1Bit(name='gbch3_ecef_sequence_number', bit=2),
  CSN1Alt(alt={
    '00000': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_1)]),
    '00001': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_2)]),
    '00010': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_3)]),
    '00011': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_4)]),
    '00100': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_5)]),
    '00101': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_6)]),
    '00110': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_7)]),
    '00111': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_8)]),
    '01000': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_9)]),
    '01001': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_10)]),
    '01010': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_11)]),
    '01011': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_12)]),
    '01100': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_13)]),
    '01101': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_14)]),
    '01110': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_15)]),
    '01111': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_16)]),
    '10000': ('', [
    CSN1Ref(obj=gbch3_ecef_information_type_17)])})])

