# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/gmr_1_spotbeam_description_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.3.7a        GMR-1 Spotbeam Description
# top-level object: GMR-1 Spotbeam Description IE



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

gmr_1_spotbeam_description_ie = CSN1List(name='gmr_1_spotbeam_description_ie', list=[
  CSN1Bit(name='bcch_arfcn', bit=11),
  CSN1Bit(name='sb_bcch_stn', bit=5),
  CSN1Bit(name='mac_forward_ts_offset', bit=2),
  CSN1Bit(name='mac_return_ts_offset', bit=5),
  CSN1Bit(name='sb_frame_ts_offset', bit=5),
  CSN1Bit(name='sb_symbol_offset', bit=6),
  CSN1Bit(name='sb_mask', bit=8),
  CSN1Bit(name='spotbeam_id', bit=10),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Bit(name='satellite_id', bit=2)])})])

