# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/initial_mes_identity_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.3.35         Initial MES Identity
# top-level object: Initial MES Identity IE



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

initial_mes_identity_ie = CSN1Alt(name='initial_mes_identity_ie', alt={
  '0000': ('mes_identity_type_gsm_map_tmsi_and_lai', [
  CSN1Bit(name='tmsi', bit=32),
  CSN1Bit(name='lai', bit=40)]),
  '0001': ('mes_identity_type_gsm_map_p_tmsi_and_rai', [
  CSN1Bit(name='ptmsi', bit=32),
  CSN1Bit(name='rai', bit=48)]),
  '0010': ('mes_identity_type_gsm_map_imsi_or_imei', [
  CSN1Bit(name='length_of_mobile_identity_contents', bit=4),
  CSN1Bit(name='mobile_identity', bit=8, num=([1], lambda x: x))]),
  '0011': ('mes_identity_type_esn_ds41', [
  CSN1Bit(name='esn', bit=32)]),
  '0100': ('mes_identity_type_imsi_ds41', [
  CSN1Bit(name='imsi_length', bit=2),
  CSN1Bit(name='imsi', bit=8, num=([1], lambda x: x + 5))]),
  '0101': ('mes_identity_type_reserved_for_imsi_and_esn_ds41', [
  CSN1Bit(name='imsi_length', bit=2),
  CSN1Bit(name='imsi', bit=8, num=([1], lambda x: x + 5)),
  CSN1Bit(name='esn', bit=32)]),
  '0110': ('mes_identity_type_reserved_for_tmsi_ds41', [
  CSN1Bit(name='tmsi_length', bit=4),
  CSN1Bit(name='tmsi_ds_41', bit=8, num=([1], lambda x: x + 2))]),
  '1': ('message_escape', [
  CSN1Bit(bit=3),
  CSN1Bit(bit=-1)])})

