# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/intra_domain_nas_node_selector_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.3.41         Intra Domain NAS Node Selector
# top-level object: Intra Domain NAS Node Selector IE



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

intra_domain_nas_node_selector_ie = CSN1List(name='intra_domain_nas_node_selector_ie', list=[
  CSN1Val(name='', val='0'),
  CSN1List(list=[
    CSN1Val(name='', val='0'),
    CSN1Alt(alt={
      '000': ('', [
      CSN1Bit(name='routing_parameter_tmsi_ptmsi', bit=10)]),
      '001': ('', [
      CSN1Bit(name='routing_parameter_tmsi_ptmsi', bit=10)]),
      '010': ('', [
      CSN1Bit(name='routing_parameter_tmsi_ptmsi', bit=10)]),
      '011': ('', [
      CSN1Bit(name='routing_parameter_imsi', bit=10)]),
      '100': ('', [
      CSN1Bit(name='routing_parameter_imsi', bit=10)]),
      '101': ('', [
      CSN1Bit(name='routing_parameter_imei', bit=10)])})])])

