# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/packet_cell_change_failure_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 11.2.3           Packet cell change failure (Iu mode only)
# top-level object: Packet Cell Change Failure message content

# external references
from pycrate_gmr1_csn1.utran_fdd_target_cell_ie import utran_fdd_target_cell_ie
from pycrate_gmr1_csn1.utran_fdd_target_cell_ie import utran_tdd_target_cell_ie
from pycrate_gmr1_csn1.padding_bits import padding_bits

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

packet_cell_change_failure_message_content = CSN1List(name='packet_cell_change_failure_message_content', list=[
  CSN1Bit(name='g_rnti', bit=32),
  CSN1Bit(name='arfcn', bit=11),
  CSN1Bit(name='spotbeam_id', bit=10),
  CSN1Bit(name='cause', bit=4),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='utran_fdd_target_cell', obj=utran_fdd_target_cell_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='utran_tdd_target_cell', obj=utran_tdd_target_cell_ie)])})])}),
  CSN1Ref(obj=padding_bits)])

