# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/packet_channel_request_64_bit_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 11.2.5         Packet channel request (A/Gb Mode only)
# top-level object: Packet channel request 64 bit message content



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

packet_channel_request_64_bit_message_content = CSN1Alt(name='packet_channel_request_64_bit_message_content', alt={
  '0': ('one_phase_access_request', [
  CSN1List(list=[
    CSN1Bit(name='tlli', bit=32),
    CSN1Bit(name='rid', bit=2),
    CSN1Bit(name='no_of_blocks', bit=6),
    CSN1Bit(name='peak_throughput_class', bit=4),
    CSN1Bit(name='radio_priority', bit=2),
    CSN1Bit(name='rlc_mode'),
    CSN1Bit(name='llc_pdu_type'),
    CSN1Bit(name='gmprs_terminal_type_identifier_bits_6_1', bit=6),
    CSN1Bit(name='sqir', bit=6),
    CSN1Bit(name='gmprs_terminal_type_identifier_bit_7'),
    CSN1Bit(name='spare', bit=2)])]),
  '10101': ('gmprs_resume_procedure', [
  CSN1List(list=[
    CSN1Bit(name='tlli', bit=32),
    CSN1Bit(name='spare', bit=27)])]),
  '10110': ('mm_procedure', [
  CSN1List(list=[
    CSN1Bit(name='tlli', bit=32),
    CSN1Bit(name='rid', bit=2),
    CSN1Bit(name='sqir', bit=6),
    CSN1Bit(name='spare', bit=19)])]),
  '10111': ('initial_correction', [
  CSN1List(list=[
    CSN1Bit(name='tfi', bit=7),
    CSN1Bit(name='rid', bit=2),
    CSN1Bit(name='sqir', bit=6),
    CSN1Bit(name='spare', bit=44)])])})

