# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/packet_dch_uplink_ack_nack_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 11.2.21b Packet DCH Uplink Ack/Nack (Iu mode only)
# top-level object: Packet DCH Uplink Ack/Nack message content

# external references
from pycrate_gmr1_csn1.time_and_frequency_correction_ie import time_and_frequency_correction_ie
from pycrate_gmr1_csn1.padding_bits import padding_bits
from pycrate_gmr1_csn1.gmprs_ack_nack_description_ie import dcch_ack_nack_description_ie
from pycrate_gmr1_csn1.pdch_mcs_ie import dch_mcs_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

packet_dch_uplink_ack_nack_message_content = CSN1List(name='packet_dch_uplink_ack_nack_message_content', list=[
  CSN1Bit(name='rb_id', bit=5),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Bit(name='g_rnti', bit=32)])}),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Ref(name='t_and_f_correction', obj=time_and_frequency_correction_ie)])}),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Ref(name='dch_channel_mcs_info', obj=dch_mcs_ie)])}),
  CSN1List(list=[
    CSN1Val(name='', val='1'),
    CSN1Ref(name='dcch_ack_nack_description', obj=dcch_ack_nack_description_ie)]),
  CSN1Ref(obj=padding_bits)])

