# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/packet_link_control_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 11.2.13 Packet link control
# top-level object: Packet Link Control message content

# external references
from pycrate_gmr1_csn1.packet_link_synchronization_ie import packet_link_synchronization_ie
from pycrate_gmr1_csn1.global_tfi_ie import global_tfi_ie
from pycrate_gmr1_csn1.padding_bits import padding_bits

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

packet_link_control_message_content = CSN1List(name='packet_link_control_message_content', list=[
  CSN1Alt(alt={
    '0': ('', [
    CSN1Alt(alt={
      '00': ('', []),
      '01': ('', [
      CSN1Ref(name='global_tfi', obj=global_tfi_ie)]),
      '10': ('', [
      CSN1Bit(name='g_rnti', bit=32)])}),
    CSN1Ref(name='packet_link_synchronization', obj=packet_link_synchronization_ie)]),
    '1': ('', [
    CSN1Alt(num=4, alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='packet_link_synchronization', obj=packet_link_synchronization_ie)])})])}),
  CSN1Ref(obj=padding_bits)])

