# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/packet_timeslot_reconfigure_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 11.2.27 Packet Timeslot Reconfigure (Iu mode only)
# top-level object: Packet Timeslot Reconfigure message content

# external references
from pycrate_gmr1_csn1.pdch_uplink_organization_ie import pdch_uplink_organization_ie
from pycrate_gmr1_csn1.frequency_parameters_ie import frequency_allocation_ie
from pycrate_gmr1_csn1.pdch_mcs_ie import pdch_mcs_ie
from pycrate_gmr1_csn1.packet_link_synchronization_parameters_ie import packet_link_synchronization_parameters_ie
from pycrate_gmr1_csn1.global_tfi_ie import global_tfi_ie
from pycrate_gmr1_csn1.padding_bits import padding_bits

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

packet_timeslot_reconfigure_message_content = CSN1List(name='packet_timeslot_reconfigure_message_content', list=[
  CSN1Val(name='', val='0'),
  CSN1Ref(name='global_tfi', obj=global_tfi_ie),
  CSN1List(list=[
    CSN1Val(name='', val='0'),
    CSN1List(list=[
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Ref(name='pdch_channel_mcs_info', obj=pdch_mcs_ie)])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Ref(name='packet_link_synchronization', obj=packet_link_synchronization_parameters_ie)])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Ref(name='frequency_allocation', obj=frequency_allocation_ie)])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='return_frequency_set')])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Ref(name='pdch_uplink_organization', obj=pdch_uplink_organization_ie)])}),
      CSN1Bit(name='downlink_rlc_mode'),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='downlink_tfi_assignment', bit=8)])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='uplink_tfi_assignment', bit=8)])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='usf', bit=8)])}),
      CSN1Bit(name='mac_slot_allocation', bit=8),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='rb_id', bit=5)])}),
      CSN1Ref(obj=padding_bits)])])])

