# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/packet_uplink_dummy_control_block_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 11.2.8a Packet uplink dummy control block
# top-level object: Packet Uplink Dummy Control Block message content

# external references
from pycrate_gmr1_csn1.global_tfi_ie import global_tfi_ie
from pycrate_gmr1_csn1.padding_bits import padding_bits

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

fqi_struct = CSN1List(name='fqi_struct', list=[
  CSN1List(num=-1, list=[
    CSN1Val(name='', val='1'),
    CSN1Bit(name='rb_id', bit=5),
    CSN1Bit(name='forward_quality_indicator', bit=6)]),
  CSN1Val(name='', val='0')])

link_quality_struct = CSN1List(name='link_quality_struct', list=[
  CSN1Bit(name='sqir', bit=6),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Bit(name='sqi_standard_deviation', bit=6)])}),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Ref(name='fqi', obj=fqi_struct)])})])

packet_uplink_dummy_control_block_message_content = CSN1List(name='packet_uplink_dummy_control_block_message_content', list=[
  CSN1Alt(alt={
    '0': ('', [
    CSN1Bit(name='tlli_g_rnti', bit=32),
    CSN1Ref(name='link_quality', obj=link_quality_struct)]),
    '10': ('', [
    CSN1Ref(name='global_tfi', obj=global_tfi_ie),
    CSN1Ref(name='link_quality', obj=link_quality_struct)]),
    '11': ('', [])}),
  CSN1Ref(obj=padding_bits)])

