# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/pdch_uplink_organization_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-12
# section: 12.37         PDCH Uplink Organization
# top-level object: PDCH Uplink Organization IE



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

uplink_arfcn_struct = CSN1List(name='uplink_arfcn_struct', list=[
  CSN1Bit(name='return_frequency_set'),
  CSN1Bit(name='uplink_bandwidth', bit=3),
  CSN1Bit(name='uplink_arfcn', bit=11),
  CSN1Bit(name='ul_frequency_plan_id')])

pdch_uplink_organization_ie = CSN1List(name='pdch_uplink_organization_ie', list=[
  CSN1Bit(name='number_of_uplinks', bit=4),
  CSN1Ref(name='uplink_arfcn_ordered_list', obj=uplink_arfcn_struct, num=([0], lambda x: x))])

