# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/rb_ciphering_synchronization_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.3.84b RB CipheringSynchronization
# top-level object: RB Ciphering Synchronization IE

# external references
from pycrate_gmr1_csn1.activation_time_ie import activation_time_ie
from pycrate_gmr1_csn1.rb_identity_ie import rb_identity_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

rb_ciphering_synchronization_ie = CSN1List(name='rb_ciphering_synchronization_ie', list=[
  CSN1Bit(name='rb_list', bit=2),
  CSN1Ref(name='rb_identity', obj=rb_identity_ie),
  CSN1List(num=([0], lambda x: x + 1), list=[
    CSN1Val(name='', val='00'),
    CSN1List(list=[
      CSN1Ref(name='activation_time', obj=activation_time_ie),
      CSN1Bit(name='hfn_at_activation_time', bit=11)]),
    CSN1Val(name='', val='01'),
    CSN1List(list=[
      CSN1Bit(name='current_bsn', bit=10),
      CSN1Bit(name='current_hfn', bit=21)]),
    CSN1Val(name='', val='10'),
    CSN1List(list=[
      CSN1Bit(name='current_bsn', bit=7),
      CSN1Bit(name='current_hfn', bit=24)]),
    CSN1Val(name='', val='11')])])

