# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/rfc_3095_context_info_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 11.1.5.3          IETF RFC 3095 CONTEXT INFO
# top-level object: RFC 3095 Context Info IE

# external references
from pycrate_gmr1_csn1.rb_identity_ie import rb_identity_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

rfc_3095_context_info_ie = CSN1List(name='rfc_3095_context_info_ie', list=[
  CSN1Bit(name='rb_with_rfc_3095_context_list', bit=5),
  CSN1List(num=([0], lambda x: x + 1), list=[
    CSN1Ref(name='rb_identity', obj=rb_identity_ie),
    CSN1Bit(name='rfc_3095_context_list', bit=14),
    CSN1List(num=([1], lambda x: x + 1), list=[
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='downlink_rfc_3095_context_identity', bit=14),
        CSN1Bit(name='dl_mode', bit=2),
        CSN1Bit(name='ref_ir', bit=24000),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='ref_time', bit=32)])}),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='syn_offset_id', bit=16)])}),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='syn_slope_ts', bit=32)])}),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [])})])}),
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='uplink_rfc_3095_context_identity', bit=14),
        CSN1Bit(name='ul_mode', bit=2),
        CSN1Bit(name='ref_ir', bit=24000),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='ref_time', bit=32)])}),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='syn_offset_id', bit=16)])}),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='syn_slope_ts', bit=32)])}),
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Bit(name='ref_sn_1', bit=15)])})])})])])])

