# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/rrc_connection_setup_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 9.2.41          RRC CONNECTION SETUP
# top-level object: RRC CONNECTION SETUP message content

# external references
from pycrate_gmr1_csn1.gps_position_ie import gps_position_ie
from pycrate_gmr1_csn1.mes_timers_and_constants_in_rrc_connected_mode_ie import mes_timers_and_constants_in_rrc_connected_mode_ie
from pycrate_gmr1_csn1.rrc_transaction_identifier_ie import rrc_transaction_identifier_ie
from pycrate_gmr1_csn1.activation_time_ie import activation_time_ie
from pycrate_gmr1_csn1.gmr_1_cell_identity_ie import gmr_1_cell_identity_ie
from pycrate_gmr1_csn1.mes_additional_timers_and_constants_in_rrc_connected_mode_ie import mes_additional_timers_and_constants_in_rrc_connected_mode_ie
from pycrate_gmr1_csn1.capability_update_requirement_ie import capability_update_requirement_ie
from pycrate_gmr1_csn1.rrc_state_indicator_ie import rrc_state_indicator_ie
from pycrate_gmr1_csn1.g_rnti_ie import g_rnti_ie
from pycrate_gmr1_csn1.signalling_rb_information_to_setup_ie import signalling_rb_information_to_setup_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

rrc_connection_setup_message_content = CSN1List(name='rrc_connection_setup_message_content', list=[
  CSN1Val(name='', val='0'),
  CSN1List(list=[
    CSN1Ref(name='rrc_transaction_identifier', obj=rrc_transaction_identifier_ie),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='activation_time', obj=activation_time_ie)])}),
    CSN1Ref(name='new_g_rnti', obj=g_rnti_ie),
    CSN1Ref(name='rrc_state_indicator', obj=rrc_state_indicator_ie),
    CSN1Ref(name='capability_update_requirement', obj=capability_update_requirement_ie),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Bit(name='signalling_rb_information_to_setup_list', bit=3),
      CSN1Ref(name='signalling_rb_information_to_setup', obj=signalling_rb_information_to_setup_ie, num=([1], lambda x: x + 1))])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='gmr_1_cell_identity', obj=gmr_1_cell_identity_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='position_update_info1', obj=gps_position_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='position_update_info2', obj=gps_position_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='mes_timers_and_constants_in_connected_mode', obj=mes_timers_and_constants_in_rrc_connected_mode_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='mes_additional_timers_and_constants_in_connected_mode', obj=mes_additional_timers_and_constants_in_rrc_connected_mode_ie)])})])])

