# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/rrc_information_target_bss_to_source_bss_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 11.1.4         RRC information, target BSS to source BSS
# top-level object: RRC Information Target BSS To Source BSS message content

# external references
from pycrate_gmr1_csn1.rrc_failure_info_message_content import rrc_failure_info_message_content
from pycrate_gmr1_csn1.activation_time_ie import activation_time_ie
from pycrate_gmr1_csn1.radio_bearer_reconfiguration_message_content import radio_bearer_reconfiguration_message_content

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

rrc_information_target_bss_to_source_bss_message_content = CSN1List(name='rrc_information_target_bss_to_source_bss_message_content', list=[
  CSN1Val(name='', val='0'),
  CSN1Alt(alt={
    '00': ('', [
    CSN1List(list=[
      CSN1Ref(name='radio_bearer_reconfiguration', obj=radio_bearer_reconfiguration_message_content),
      CSN1Ref(name='synchronization_information_transfer_time', obj=activation_time_ie)])]),
    '01': ('', [
    CSN1Ref(name='rrc_failure_info', obj=rrc_failure_info_message_content)])})])

