# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/rrc_information_to_target_geran_iu_mode_bss_message_content.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 11.1.3         RRC Information to target GERAN Iu mode BSS
# top-level object: RRC INFORMATION TO TARGET GERAN IU MODE BSS message content

# external references
from pycrate_gmr1_csn1.inter_rat_or_mode_handover_info_with_mes_capabilities_message_content import inter_rat_or_mode_handover_info_with_mes_capabilities_message_content
from pycrate_gmr1_csn1.sbss_relocation_information_message_content import sbss_relocation_information_message_content
from pycrate_gmr1_csn1.rfc_3095_context_info_ie import rfc_3095_context_info_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

rrc_information_to_target_geran_iu_mode_bss_message_content = CSN1List(name='rrc_information_to_target_geran_iu_mode_bss_message_content', list=[
  CSN1Val(name='', val='0'),
  CSN1Alt(alt={
    '00': ('', [
    CSN1Ref(name='handover_to_geran', obj=inter_rat_or_mode_handover_info_with_mes_capabilities_message_content)]),
    '01': ('', [
    CSN1Ref(name='sbss_relocation', obj=sbss_relocation_information_message_content)]),
    '10': ('', [
    CSN1Ref(name='rfc3095_context_info', obj=rfc_3095_context_info_ie)])})])

