# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/segment_1a.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08, Rel. 3
# section: 11.5.2.66         Segment 1A
# top-level object: Segment 1A



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

synchronization_info_class_1 = CSN1List(name='synchronization_info_class_1', list=[
  CSN1Bit(name='sb_frame_ts_offset', bit=5),
  CSN1Bit(name='sb_symbol_offset', bit=6),
  CSN1Bit(name='sa_freq_offset', bit=8)])

access_classes = CSN1List(name='access_classes', list=[
  CSN1Bit(name='ac15'),
  CSN1Bit(name='ac14'),
  CSN1Bit(name='ac13'),
  CSN1Bit(name='ac12'),
  CSN1Bit(name='ac11'),
  CSN1Bit(name='ac10'),
  CSN1Bit(name='ac9'),
  CSN1Bit(name='ac8'),
  CSN1Bit(name='ac7'),
  CSN1Bit(name='ac6'),
  CSN1Bit(name='ac5'),
  CSN1Bit(name='ac4'),
  CSN1Bit(name='ac3'),
  CSN1Bit(name='ac2'),
  CSN1Bit(name='ac1'),
  CSN1Bit(name='ac0')])

misc_info_class_1 = CSN1List(name='misc_info_class_1', list=[
  CSN1Bit(name='sb_reselection_hysteresis', bit=4),
  CSN1Bit(name='spare'),
  CSN1Bit(name='priority_access_ind')])

rach_control_parameters = CSN1List(name='rach_control_parameters', list=[
  CSN1Bit(name='max_retrans', bit=2),
  CSN1Ref(obj=access_classes),
  CSN1Bit(name='cell_bar_access')])

segment_1a = CSN1List(name='segment_1a', list=[
  CSN1Bit(name='class_2_version', bit=3),
  CSN1Bit(name='class_3_version', bit=4),
  CSN1Ref(obj=synchronization_info_class_1),
  CSN1Ref(obj=rach_control_parameters),
  CSN1Ref(obj=misc_info_class_1),
  CSN1Bit(name='gbch_present'),
  CSN1Bit(name='test_gs'),
  CSN1Bit(name='test_gs2'),
  CSN1Bit(name='spare', bit=3),
  CSN1Bit(name='cell_bar_access_extension2'),
  CSN1Bit(name='spare', bit=5),
  CSN1Bit(name='cell_bar_access_extension')])

