# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/segment_2a.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08
# section: 11.5.2.67 Segment 2A
# top-level object: Segment 2A



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

header_segment_2a = CSN1List(name='header_segment_2a', list=[
  CSN1Val(name='class_type_2', val='10'),
  CSN1Val(name='segment_type', val='0000')])

synch_info_class_2 = CSN1List(name='synch_info_class_2', list=[
  CSN1Bit(name='sa_sirfn_delay', bit=4),
  CSN1Bit(name='sa_bcch_stn', bit=5),
  CSN1Bit(name='superframe_number', bit=13),
  CSN1Bit(name='multiframe_number', bit=2),
  CSN1Bit(name='mffn_high_bit')])

selection_criteria_class_2 = CSN1Bit(name='selection_criteria_class_2', bit=5)

misc_information_class_2 = CSN1Bit(name='misc_information_class_2', bit=4)

la_information_class_2 = CSN1List(name='la_information_class_2', list=[
  CSN1Bit(name='sa_pch_config', bit=2),
  CSN1Bit(name='sa_bach_config', bit=8),
  CSN1Bit(name='rach_ts_offset', bit=5),
  CSN1Bit(name='n_page_occurrences', bit=2),
  CSN1Bit(name='imsi_attach_detach_ind'),
  CSN1Bit(name='ecsc_indication'),
  CSN1Bit(name='si_update_ind')])

bcch_neighbour_list1 = CSN1List(name='bcch_neighbour_list1', num=3, list=[
  CSN1Bit(name='arfcn', bit=11),
  CSN1Bit(name='sa_bcch_stn', bit=5),
  CSN1Bit(name='relative_frame_offset', bit=3)])

segment_2a = CSN1List(name='segment_2a', list=[
  CSN1Bit(name='class_4_version', bit=3),
  CSN1Ref(obj=synch_info_class_2),
  CSN1Ref(obj=selection_criteria_class_2),
  CSN1Ref(obj=misc_information_class_2),
  CSN1Ref(obj=la_information_class_2),
  CSN1Ref(obj=bcch_neighbour_list1),
  CSN1Bit(name='spare', bit=64)])

