# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/segment_2bbis.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08, Rel. 3
# section: 11.5.2.70         Segment 2Bbis
# top-level object: Segment 2Bbis



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

header_segment_2bbis = CSN1List(name='header_segment_2bbis', list=[
  CSN1Val(name='class_type_2', val='10'),
  CSN1Val(name='segment_type', val='0001')])

bcch_neighbour_list2b = CSN1List(name='bcch_neighbour_list2b', list=[
  CSN1Bit(name='arfcn', bit=11),
  CSN1Bit(name='sa_bcch_stn', bit=5),
  CSN1Bit(name='relative_frame_offset', bit=3)])

segment_2bbis = CSN1List(name='segment_2bbis', list=[
  CSN1Ref(name='bcch_neighbours', obj=bcch_neighbour_list2b, num=5),
  CSN1Bit(name='system_information_extension'),
  CSN1Bit(name='spare', bit=18)])

