# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/segment_3a.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08, Rel. 3
# section: 11.5.2.71         Segment 3A
# top-level object: Segment 3A



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

header_segment_3a = CSN1List(name='header_segment_3a', list=[
  CSN1Val(name='class_type_3', val='0'),
  CSN1Val(name='segment_type', val='0000')])

system = CSN1List(name='system', list=[
  CSN1Bit(name='satellite_id', bit=2),
  CSN1Bit(name='system_id', bit=4)])

satellite_position = CSN1List(name='satellite_position', list=[
  CSN1Bit(name='latitude', bit=8),
  CSN1Bit(name='longitude', bit=12),
  CSN1Bit(name='radius', bit=16)])

beam_center_pos_main = CSN1List(name='beam_center_pos_main', list=[
  CSN1Bit(name='latitude', bit=11),
  CSN1Bit(name='longitude', bit=12)])

misc_information_class_3 = CSN1Bit(name='misc_information_class_3', bit=6)

segment_3a = CSN1List(name='segment_3a', list=[
  CSN1Bit(name='lai', bit=40),
  CSN1Ref(obj=system),
  CSN1Ref(obj=satellite_position),
  CSN1Ref(obj=beam_center_pos_main),
  CSN1Ref(obj=misc_information_class_3),
  CSN1Bit(name='network_interface_support'),
  CSN1Bit(name='spare', bit=3)])

