# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/segment_3i.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08
# section: 11.5.2.82         Segment 3I
# top-level object: Segment 3I



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

header_segment_3i = CSN1List(name='header_segment_3i', list=[
  CSN1Val(name='class_type_3', val='0'),
  CSN1Val(name='segment_type', val='1001')])

la_information_class_3 = CSN1List(name='la_information_class_3', list=[
  CSN1Bit(name='spare', bit=2),
  CSN1Bit(name='sa_cbch_config', bit=4),
  CSN1Bit(name='sa_cbch_rf_ch', bit=11),
  CSN1Bit(name='sa_cbch_ts', bit=5),
  CSN1Bit(name='pause_time', bit=8),
  CSN1Bit(name='rach_access_timer', bit=8),
  CSN1Bit(name='alert_timer', bit=8),
  CSN1Bit(name='page_timer', bit=8),
  CSN1Bit(name='almanac_present')])

position_parameters = CSN1List(name='position_parameters', list=[
  CSN1Bit(name='rach_position_timer', bit=8),
  CSN1Bit(name='gps_update_timer', bit=8),
  CSN1Bit(name='gps_update_distance', bit=8),
  CSN1Bit(name='gps_position_age', bit=8),
  CSN1Bit(name='page_gps_position_age', bit=8),
  CSN1Bit(name='page_response_current_gps'),
  CSN1Bit(name='position_reporting_required', bit=2),
  CSN1Bit(name='power_based_access_permitted')])

segment_3i = CSN1List(name='segment_3i', list=[
  CSN1Ref(obj=la_information_class_3),
  CSN1Bit(name='periodic_lu_timer', bit=8),
  CSN1Bit(name='dual_mode_hold_timer', bit=3),
  CSN1Ref(obj=position_parameters),
  CSN1Bit(name='spare', bit=5)])

