# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/srns_context_info_ie.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-13
# section: 11.1.5.4          SRNS CONTEXT INFO
# top-level object: SRNS Context Info IE

# external references
from pycrate_gmr1_csn1.zbhc_context_info_ie import zbhc_context_info_ie
from pycrate_gmr1_csn1.rfc_3095_context_info_ie import rfc_3095_context_info_ie
from pycrate_gmr1_csn1.rb_identity_ie import rb_identity_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

srns_context_info_ie = CSN1List(name='srns_context_info_ie', list=[
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Ref(name='rfc_3095_context_info', obj=rfc_3095_context_info_ie)])}),
  CSN1Alt(alt={
    '0': ('', []),
    '1': ('', [
    CSN1Ref(name='zbhc_context_info', obj=zbhc_context_info_ie)])}),
  CSN1List(list=[
    CSN1Bit(name='dch_synchronization_info_list', bit=3),
    CSN1List(num=([0], lambda x: x), list=[
      CSN1Bit(name='lhcp_timing_offset', bit=6),
      CSN1Bit(name='rhcp_timing_offset', bit=6),
      CSN1Bit(name='lhcp_frequency_offset', bit=9),
      CSN1Bit(name='rhcp_frequency_offset', bit=9),
      CSN1Ref(name='rb_identity', obj=rb_identity_ie)])])])

