# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/system_information_type_1.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08
# section: 10.1.31        System information type 1
# top-level object: System Information Type 1

# external references
from pycrate_gmr1_csn1.segment_3c import segment_3c
from pycrate_gmr1_csn1.segment_3jbis import segment_3jbis
from pycrate_gmr1_csn1.segment_1a import segment_1a
from pycrate_gmr1_csn1.segment_2abis import segment_2abis
from pycrate_gmr1_csn1.segment_4b import segment_4b
from pycrate_gmr1_csn1.segment_4c import segment_4c
from pycrate_gmr1_csn1.segment_3i import segment_3i
from pycrate_gmr1_csn1.segment_3bbis import segment_3bbis
from pycrate_gmr1_csn1.segment_3a import segment_3a
from pycrate_gmr1_csn1.segment_4a import segment_4a
from pycrate_gmr1_csn1.segment_2bbis import segment_2bbis
from pycrate_gmr1_csn1.segment_4f import segment_4f
from pycrate_gmr1_csn1.segment_4e import segment_4e
from pycrate_gmr1_csn1.segment_4d import segment_4d

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

block_header = CSN1List(name='block_header', list=[
  CSN1Val(name='protocol_version', val='0000'),
  CSN1Bit(name='block_type'),
  CSN1Bit(name='randomization_period', bit=2),
  CSN1Bit(name='spare')])

system_information_type_1 = CSN1List(name='system_information_type_1', list=[
  CSN1Ref(obj=block_header),
  CSN1Ref(obj=segment_1a),
  CSN1Alt(alt={
    '0': ('', [
    CSN1Alt(alt={
      '0000': ('', [
      CSN1Ref(obj=segment_3a)]),
      '0001': ('', [
      CSN1Ref(obj=segment_3bbis)]),
      '0010': ('', [
      CSN1Ref(obj=segment_3c)]),
      '0011': ('', [
      CSN1Bit(name='segment_3d', bit=115)]),
      '0100': ('', [
      CSN1Bit(name='segment_3ebis', bit=115)]),
      '0101': ('', [
      CSN1Bit(name='segment_3f', bit=115)]),
      '0110': ('', [
      CSN1Bit(name='segment_3gbis', bit=115)]),
      '0111': ('', [
      CSN1Bit(name='segment_3h', bit=115)]),
      '1001': ('', [
      CSN1Ref(obj=segment_3i)]),
      '1010': ('', [
      CSN1Ref(obj=segment_3jbis)])})]),
    '1': ('', [
    CSN1Alt(alt={
      '0': ('', [
      CSN1Alt(alt={
        '0000': ('', [
        CSN1Ref(obj=segment_2abis)]),
        '0001': ('', [
        CSN1Ref(obj=segment_2bbis)])})]),
      '1': ('', [
      CSN1Alt(alt={
        '00000': ('', [
        CSN1Ref(obj=segment_4a)]),
        '00001': ('', [
        CSN1Ref(obj=segment_4b)]),
        '00010': ('', [
        CSN1Ref(obj=segment_4c)]),
        '00011': ('', [
        CSN1Ref(obj=segment_4d)]),
        '00100': ('', [
        CSN1Ref(obj=segment_4e)]),
        '00101': ('', [
        CSN1Ref(obj=segment_4f)])})])})])})])

