# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_gmr1_csn1/system_information_type_2.py
# * Created : 2023-10-24
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: ETSI TS 101 376-04-08
# section: 10.1.32        System information type 2
# top-level object: System Information Type 2

# external references
from pycrate_gmr1_csn1.segment_3e import segment_3e
from pycrate_gmr1_csn1.segment_3b import segment_3b
from pycrate_gmr1_csn1.segment_2a import segment_2a
from pycrate_gmr1_csn1.segment_3j import segment_3j
from pycrate_gmr1_csn1.segment_2b import segment_2b
from pycrate_gmr1_csn1.segment_3g import segment_3g

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

block_header = CSN1List(name='block_header', list=[
  CSN1Val(name='protocol_version', val='0000'),
  CSN1Bit(name='block_type'),
  CSN1Bit(name='spare', bit=3)])

system_information_type_2 = CSN1List(name='system_information_type_2', list=[
  CSN1Ref(obj=block_header),
  CSN1Alt(alt={
    '0': ('', [
    CSN1Alt(alt={
      '0001': ('', [
      CSN1Ref(obj=segment_3b)]),
      '0100': ('', [
      CSN1Ref(obj=segment_3e)]),
      '0110': ('', [
      CSN1Ref(obj=segment_3g)]),
      '1010': ('', [
      CSN1Ref(obj=segment_3j)])})]),
    '1': ('', [
    CSN1Alt(alt={
      '00000': ('', [
      CSN1Ref(obj=segment_2a)]),
      '00001': ('', [
      CSN1Ref(obj=segment_2b)])})])})])

