# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class DialoguePDUs:

    _name_  = 'DialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 2, 1]
    
    _obj_ = [
        'dialogue-as-id',
        'DialoguePDU',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-source',
        'Associate-result',
        'Associate-source-diagnostic',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _type_ = [
        'DialoguePDU',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-source',
        'Associate-result',
        'Associate-source-diagnostic',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _set_ = [
        ]
    _val_ = [
        'dialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< dialogue-as-id >-----#
    dialogue_as_id = OID(name='dialogue-as-id', mode=MODE_VALUE)
    dialogue_as_id._val = (0, 0, 17, 773, 1, 1, 1)
    
    #-----< DialoguePDU >-----#
    DialoguePDU = CHOICE(name='DialoguePDU', mode=MODE_TYPE)
    _DialoguePDU_dialogueRequest = SEQ(name='dialogueRequest', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARQ-apdu')))
    _DialoguePDU_dialogueResponse = SEQ(name='dialogueResponse', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARE-apdu')))
    _DialoguePDU_dialogueAbort = SEQ(name='dialogueAbort', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'ABRT-apdu')))
    DialoguePDU._cont = ASN1Dict([
        ('dialogueRequest', _DialoguePDU_dialogueRequest),
        ('dialogueResponse', _DialoguePDU_dialogueResponse),
        ('dialogueAbort', _DialoguePDU_dialogueAbort),
        ])
    DialoguePDU._ext = None
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name='AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARQ_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARQ_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AARQ_apdu_user_information._cont = __AARQ_apdu_user_information__item_
    AARQ_apdu._cont = ASN1Dict([
        ('protocol-version', _AARQ_apdu_protocol_version),
        ('application-context-name', _AARQ_apdu_application_context_name),
        ('user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = None
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name='AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARE_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARE_apdu_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-source-diagnostic')))
    _AARE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARE_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AARE_apdu_user_information._cont = __AARE_apdu_user_information__item_
    AARE_apdu._cont = ASN1Dict([
        ('protocol-version', _AARE_apdu_protocol_version),
        ('application-context-name', _AARE_apdu_application_context_name),
        ('result', _AARE_apdu_result),
        ('result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        ('user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = None
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name='RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRQ_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RLRQ_apdu_user_information._cont = __RLRQ_apdu_user_information__item_
    RLRQ_apdu._cont = ASN1Dict([
        ('reason', _RLRQ_apdu_reason),
        ('user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = None
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name='RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRE_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RLRE_apdu_user_information._cont = __RLRE_apdu_user_information__item_
    RLRE_apdu._cont = ASN1Dict([
        ('reason', _RLRE_apdu_reason),
        ('user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = None
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name='ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name='abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'ABRT-source')))
    _ABRT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ABRT_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _ABRT_apdu_user_information._cont = __ABRT_apdu_user_information__item_
    ABRT_apdu._cont = ASN1Dict([
        ('abort-source', _ABRT_apdu_abort_source),
        ('user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name='ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([('dialogue-service-user', 0), ('dialogue-service-provider', 1)])
    
    #-----< Associate-result >-----#
    Associate_result = INT(name='Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([('accepted', 0), ('reject-permanent', 1)])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name='Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_dialogue_service_user = INT(name='dialogue-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_user._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('application-context-name-not-supported', 2)])
    _Associate_source_diagnostic_dialogue_service_provider = INT(name='dialogue-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_provider._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('no-common-dialogue-portion', 2)])
    Associate_source_diagnostic._cont = ASN1Dict([
        ('dialogue-service-user', _Associate_source_diagnostic_dialogue_service_user),
        ('dialogue-service-provider', _Associate_source_diagnostic_dialogue_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name='Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([('normal', 0), ('urgent', 1), ('user-defined', 30)])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name='Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([('normal', 0), ('not-finished', 1), ('user-defined', 30)])
    
    _all_ = [
        dialogue_as_id,
        _DialoguePDU_dialogueRequest,
        _DialoguePDU_dialogueResponse,
        _DialoguePDU_dialogueAbort,
        DialoguePDU,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        __AARQ_apdu_user_information__item_,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        __AARE_apdu_user_information__item_,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        __RLRQ_apdu_user_information__item_,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        __RLRE_apdu_user_information__item_,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        __ABRT_apdu_user_information__item_,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_source,
        Associate_result,
        _Associate_source_diagnostic_dialogue_service_user,
        _Associate_source_diagnostic_dialogue_service_provider,
        Associate_source_diagnostic,
        Release_request_reason,
        Release_response_reason,
    ]

class UnidialoguePDUs:

    _name_  = 'UnidialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 3, 1]
    
    _obj_ = [
        'uniDialogue-as-id',
        'UniDialoguePDU',
        'AUDT-apdu',
        ]
    _type_ = [
        'UniDialoguePDU',
        'AUDT-apdu',
        ]
    _set_ = [
        ]
    _val_ = [
        'uniDialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< uniDialogue-as-id >-----#
    uniDialogue_as_id = OID(name='uniDialogue-as-id', mode=MODE_VALUE)
    uniDialogue_as_id._val = (0, 0, 17, 773, 1, 2, 1)
    
    #-----< UniDialoguePDU >-----#
    UniDialoguePDU = CHOICE(name='UniDialoguePDU', mode=MODE_TYPE)
    _UniDialoguePDU_unidialoguePDU = SEQ(name='unidialoguePDU', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'AUDT-apdu')))
    UniDialoguePDU._cont = ASN1Dict([
        ('unidialoguePDU', _UniDialoguePDU_unidialoguePDU),
        ])
    UniDialoguePDU._ext = None
    
    #-----< AUDT-apdu >-----#
    AUDT_apdu = SEQ(name='AUDT-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AUDT_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AUDT_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AUDT_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AUDT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AUDT_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AUDT_apdu_user_information._cont = __AUDT_apdu_user_information__item_
    AUDT_apdu._cont = ASN1Dict([
        ('protocol-version', _AUDT_apdu_protocol_version),
        ('application-context-name', _AUDT_apdu_application_context_name),
        ('user-information', _AUDT_apdu_user_information),
        ])
    AUDT_apdu._ext = None
    
    _all_ = [
        uniDialogue_as_id,
        _UniDialoguePDU_unidialoguePDU,
        UniDialoguePDU,
        _AUDT_apdu_protocol_version,
        _AUDT_apdu_application_context_name,
        __AUDT_apdu_user_information__item_,
        _AUDT_apdu_user_information,
        AUDT_apdu,
    ]

class Remote_Operations_Information_Objects:

    _name_  = 'Remote-Operations-Information-Objects'
    _oid_   = [2, 4, 5, 0]
    
    _obj_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'Code',
        'Priority',
        ]
    _type_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'Code',
        'Priority',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name='OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name='ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_argumentTypeOptional = BOOL(name='argumentTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_returnResult = BOOL(name='returnResult', mode=MODE_VALUE, default=True)
    _OPERATION_ResultType = OPEN(name='ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_resultTypeOptional = BOOL(name='resultTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), opt=True)
    _OPERATION_Linked = CLASS(name='Linked', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_synchronous = BOOL(name='synchronous', mode=MODE_VALUE, default=False)
    _OPERATION_alwaysReturns = BOOL(name='alwaysReturns', mode=MODE_VALUE, default=True)
    _OPERATION_InvokePriority = INT(name='InvokePriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_ResultPriority = INT(name='ResultPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_operationCode = CHOICE(name='operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        ('ArgumentType', _OPERATION_ArgumentType),
        ('argumentTypeOptional', _OPERATION_argumentTypeOptional),
        ('returnResult', _OPERATION_returnResult),
        ('ResultType', _OPERATION_ResultType),
        ('resultTypeOptional', _OPERATION_resultTypeOptional),
        ('Errors', _OPERATION_Errors),
        ('Linked', _OPERATION_Linked),
        ('synchronous', _OPERATION_synchronous),
        ('alwaysReturns', _OPERATION_alwaysReturns),
        ('InvokePriority', _OPERATION_InvokePriority),
        ('ResultPriority', _OPERATION_ResultPriority),
        ('operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name='ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name='ParameterType', mode=MODE_TYPE, opt=True)
    _ERROR_parameterTypeOptional = BOOL(name='parameterTypeOptional', mode=MODE_VALUE, opt=True)
    _ERROR_ErrorPriority = INT(name='ErrorPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _ERROR_errorCode = CHOICE(name='errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        ('ParameterType', _ERROR_ParameterType),
        ('parameterTypeOptional', _ERROR_parameterTypeOptional),
        ('ErrorPriority', _ERROR_ErrorPriority),
        ('errorCode', _ERROR_errorCode),
        ])
    
    #-----< OPERATION-PACKAGE >-----#
    OPERATION_PACKAGE = CLASS(name='OPERATION-PACKAGE', mode=MODE_TYPE)
    _OPERATION_PACKAGE_Both = CLASS(name='Both', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Consumer = CLASS(name='Consumer', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Supplier = CLASS(name='Supplier', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    OPERATION_PACKAGE._cont = ASN1Dict([
        ('Both', _OPERATION_PACKAGE_Both),
        ('Consumer', _OPERATION_PACKAGE_Consumer),
        ('Supplier', _OPERATION_PACKAGE_Supplier),
        ('id', _OPERATION_PACKAGE_id),
        ])
    
    #-----< CONNECTION-PACKAGE >-----#
    CONNECTION_PACKAGE = CLASS(name='CONNECTION-PACKAGE', mode=MODE_TYPE)
    _CONNECTION_PACKAGE_bind = CLASS(name='bind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([('Errors', ASN1Set(rv=[dict([('errorCode', ('local', -1))])], rr=[], ev=None, er=[])), ('synchronous', True)]))
    _CONNECTION_PACKAGE_unbind = CLASS(name='unbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([('synchronous', True)]))
    _CONNECTION_PACKAGE_responderCanUnbind = BOOL(name='responderCanUnbind', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_unbindCanFail = BOOL(name='unbindCanFail', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    CONNECTION_PACKAGE._cont = ASN1Dict([
        ('bind', _CONNECTION_PACKAGE_bind),
        ('unbind', _CONNECTION_PACKAGE_unbind),
        ('responderCanUnbind', _CONNECTION_PACKAGE_responderCanUnbind),
        ('unbindCanFail', _CONNECTION_PACKAGE_unbindCanFail),
        ('id', _CONNECTION_PACKAGE_id),
        ])
    
    #-----< CONTRACT >-----#
    CONTRACT = CLASS(name='CONTRACT', mode=MODE_TYPE)
    _CONTRACT_connection = CLASS(name='connection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONNECTION-PACKAGE')), opt=True)
    _CONTRACT_OperationsOf = CLASS(name='OperationsOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorConsumerOf = CLASS(name='InitiatorConsumerOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorSupplierOf = CLASS(name='InitiatorSupplierOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    CONTRACT._cont = ASN1Dict([
        ('connection', _CONTRACT_connection),
        ('OperationsOf', _CONTRACT_OperationsOf),
        ('InitiatorConsumerOf', _CONTRACT_InitiatorConsumerOf),
        ('InitiatorSupplierOf', _CONTRACT_InitiatorSupplierOf),
        ('id', _CONTRACT_id),
        ])
    
    #-----< ROS-OBJECT-CLASS >-----#
    ROS_OBJECT_CLASS = CLASS(name='ROS-OBJECT-CLASS', mode=MODE_TYPE)
    _ROS_OBJECT_CLASS_Is = CLASS(name='Is', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')), opt=True)
    _ROS_OBJECT_CLASS_Initiates = CLASS(name='Initiates', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_Responds = CLASS(name='Responds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_InitiatesAndResponds = CLASS(name='InitiatesAndResponds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ROS_OBJECT_CLASS._cont = ASN1Dict([
        ('Is', _ROS_OBJECT_CLASS_Is),
        ('Initiates', _ROS_OBJECT_CLASS_Initiates),
        ('Responds', _ROS_OBJECT_CLASS_Responds),
        ('InitiatesAndResponds', _ROS_OBJECT_CLASS_InitiatesAndResponds),
        ('id', _ROS_OBJECT_CLASS_id),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name='Code', mode=MODE_TYPE)
    _Code_local = INT(name='local', mode=MODE_TYPE)
    _Code_global_ = OID(name='global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        ('local', _Code_local),
        ('global', _Code_global_),
        ])
    Code._ext = None
    
    #-----< Priority >-----#
    Priority = INT(name='Priority', mode=MODE_TYPE)
    Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_argumentTypeOptional,
        _OPERATION_returnResult,
        _OPERATION_ResultType,
        _OPERATION_resultTypeOptional,
        _OPERATION_Errors,
        _OPERATION_Linked,
        _OPERATION_synchronous,
        _OPERATION_alwaysReturns,
        _OPERATION_InvokePriority,
        _OPERATION_ResultPriority,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_parameterTypeOptional,
        _ERROR_ErrorPriority,
        _ERROR_errorCode,
        ERROR,
        _OPERATION_PACKAGE_Both,
        _OPERATION_PACKAGE_Consumer,
        _OPERATION_PACKAGE_Supplier,
        _OPERATION_PACKAGE_id,
        OPERATION_PACKAGE,
        _CONNECTION_PACKAGE_bind,
        _CONNECTION_PACKAGE_unbind,
        _CONNECTION_PACKAGE_responderCanUnbind,
        _CONNECTION_PACKAGE_unbindCanFail,
        _CONNECTION_PACKAGE_id,
        CONNECTION_PACKAGE,
        _CONTRACT_connection,
        _CONTRACT_OperationsOf,
        _CONTRACT_InitiatorConsumerOf,
        _CONTRACT_InitiatorSupplierOf,
        _CONTRACT_id,
        CONTRACT,
        _ROS_OBJECT_CLASS_Is,
        _ROS_OBJECT_CLASS_Initiates,
        _ROS_OBJECT_CLASS_Responds,
        _ROS_OBJECT_CLASS_InitiatesAndResponds,
        _ROS_OBJECT_CLASS_id,
        ROS_OBJECT_CLASS,
        _Code_local,
        _Code_global_,
        Code,
        Priority,
    ]

class Remote_Operations_Generic_ROS_PDUs:

    _name_  = 'Remote-Operations-Generic-ROS-PDUs'
    _oid_   = [2, 4, 6, 0]
    
    _obj_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Reject',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'RejectProblem',
        'InvokeId',
        'noInvokeId',
        'NoInvokeId',
        'Errors',
        'Bind',
        'Unbind',
        ]
    _type_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Reject',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'RejectProblem',
        'InvokeId',
        'Bind',
        'Unbind',
        ]
    _set_ = [
        'NoInvokeId',
        'Errors',
        ]
    _val_ = [
        'noInvokeId',
        ]
    _class_ = [
        'Errors',
        ]
    _param_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Errors',
        'Bind',
        'Unbind',
        ]
    
    #-----< ROS >-----#
    ROS = CHOICE(name='ROS', mode=MODE_TYPE, param=True)
    
    #-----< Invoke >-----#
    Invoke = SEQ(name='Invoke', mode=MODE_TYPE, param=True)
    
    #-----< ReturnResult >-----#
    ReturnResult = SEQ(name='ReturnResult', mode=MODE_TYPE, param=True)
    
    #-----< ReturnError >-----#
    ReturnError = SEQ(name='ReturnError', mode=MODE_TYPE, param=True)
    
    #-----< Reject >-----#
    Reject = SEQ(name='Reject', mode=MODE_TYPE)
    _Reject_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _Reject_problem = CHOICE(name='problem', mode=MODE_TYPE)
    __Reject_problem_general = INT(name='general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'GeneralProblem')))
    __Reject_problem_invoke = INT(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeProblem')))
    __Reject_problem_returnResult = INT(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResultProblem')))
    __Reject_problem_returnError = INT(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnErrorProblem')))
    _Reject_problem._cont = ASN1Dict([
        ('general', __Reject_problem_general),
        ('invoke', __Reject_problem_invoke),
        ('returnResult', __Reject_problem_returnResult),
        ('returnError', __Reject_problem_returnError),
        ])
    _Reject_problem._ext = None
    Reject._cont = ASN1Dict([
        ('invokeId', _Reject_invokeId),
        ('problem', _Reject_problem),
        ])
    Reject._ext = None
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name='GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([('unrecognizedPDU', 0), ('mistypedPDU', 1), ('badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name='InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([('duplicateInvocation', 0), ('unrecognizedOperation', 1), ('mistypedArgument', 2), ('resourceLimitation', 3), ('releaseInProgress', 4), ('unrecognizedLinkedId', 5), ('linkedResponseUnexpected', 6), ('unexpectedLinkedOperation', 7)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name='ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('resultResponseUnexpected', 1), ('mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name='ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('errorResponseUnexpected', 1), ('unrecognizedError', 2), ('unexpectedError', 3), ('mistypedParameter', 4)])
    
    #-----< RejectProblem >-----#
    RejectProblem = INT(name='RejectProblem', mode=MODE_TYPE)
    RejectProblem._cont = ASN1Dict([('general-unrecognizedPDU', 0), ('general-mistypedPDU', 1), ('general-badlyStructuredPDU', 2), ('invoke-duplicateInvocation', 10), ('invoke-unrecognizedOperation', 11), ('invoke-mistypedArgument', 12), ('invoke-resourceLimitation', 13), ('invoke-releaseInProgress', 14), ('invoke-unrecognizedLinkedId', 15), ('invoke-linkedResponseUnexpected', 16), ('invoke-unexpectedLinkedOperation', 17), ('returnResult-unrecognizedInvocation', 20), ('returnResult-resultResponseUnexpected', 21), ('returnResult-mistypedResult', 22), ('returnError-unrecognizedInvocation', 30), ('returnError-errorResponseUnexpected', 31), ('returnError-unrecognizedError', 32), ('returnError-unexpectedError', 33), ('returnError-mistypedParameter', 34)])
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name='InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name='present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name='absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        ('present', _InvokeId_present),
        ('absent', _InvokeId_absent),
        ])
    InvokeId._ext = None
    
    #-----< noInvokeId >-----#
    noInvokeId = CHOICE(name='noInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    noInvokeId._val = ('absent', 0)
    
    #-----< NoInvokeId >-----#
    NoInvokeId = CHOICE(name='NoInvokeId', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    NoInvokeId._val = ASN1Set(rv=[('absent', 0)], rr=[], ev=None, er=[])
    
    #-----< Errors >-----#
    Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), param=True)
    
    #-----< Bind >-----#
    Bind = CHOICE(name='Bind', mode=MODE_TYPE, param=True)
    
    #-----< Unbind >-----#
    Unbind = CHOICE(name='Unbind', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _Reject_invokeId,
        __Reject_problem_general,
        __Reject_problem_invoke,
        __Reject_problem_returnResult,
        __Reject_problem_returnError,
        _Reject_problem,
        Reject,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        RejectProblem,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        noInvokeId,
        NoInvokeId,
    ]

class Remote_Operations_Useful_Definitions:

    _name_  = 'Remote-Operations-Useful-Definitions'
    _oid_   = [2, 4, 7, 0]
    
    _obj_ = [
        'emptyBind',
        'emptyUnbind',
        'refuse',
        'no-op',
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        'recode',
        'switch',
        'combine',
        'ROS-SingleAS',
        'ROS-ConsumerAS',
        'ROS-SupplierAS',
        ]
    _type_ = [
        'ROS-SingleAS',
        'ROS-ConsumerAS',
        'ROS-SupplierAS',
        ]
    _set_ = [
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        ]
    _val_ = [
        'emptyBind',
        'emptyUnbind',
        'refuse',
        'no-op',
        'recode',
        'switch',
        'combine',
        ]
    _class_ = [
        'emptyBind',
        'emptyUnbind',
        'refuse',
        'no-op',
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        'recode',
        'switch',
        'combine',
        ]
    _param_ = [
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        'recode',
        'switch',
        'combine',
        'ROS-SingleAS',
        'ROS-ConsumerAS',
        'ROS-SupplierAS',
        ]
    
    #-----< emptyBind >-----#
    emptyBind = CLASS(name='emptyBind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyBind._val = dict([('Errors', ASN1Set(rv=[dict([('errorCode', ('local', -1))])], rr=[], ev=None, er=[])), ('synchronous', True)])
    
    #-----< emptyUnbind >-----#
    emptyUnbind = CLASS(name='emptyUnbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyUnbind._val = dict([('synchronous', True)])
    
    #-----< refuse >-----#
    refuse = CLASS(name='refuse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    refuse._val = dict([('errorCode', ('local', -1))])
    
    #-----< no-op >-----#
    no_op = CLASS(name='no-op', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    no_op._val = dict([('alwaysReturns', False), ('operationCode', ('local', -1))])
    
    #-----< Forward >-----#
    Forward = CLASS(name='Forward', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< Reverse >-----#
    Reverse = CLASS(name='Reverse', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConsumerPerforms >-----#
    ConsumerPerforms = CLASS(name='ConsumerPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SupplierPerforms >-----#
    SupplierPerforms = CLASS(name='SupplierPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AllOperations >-----#
    AllOperations = CLASS(name='AllOperations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< recode >-----#
    recode = CLASS(name='recode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< switch >-----#
    switch = CLASS(name='switch', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< combine >-----#
    combine = CLASS(name='combine', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ROS-SingleAS >-----#
    ROS_SingleAS = CHOICE(name='ROS-SingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-ConsumerAS >-----#
    ROS_ConsumerAS = CHOICE(name='ROS-ConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-SupplierAS >-----#
    ROS_SupplierAS = CHOICE(name='ROS-SupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    _all_ = [
        emptyBind,
        emptyUnbind,
        refuse,
        no_op,
    ]

class TCAPMessages:

    _name_  = 'TCAPMessages'
    _oid_   = [0, 0, 17, 773, 2, 1, 3]
    
    _obj_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'Abort',
        'DialoguePortion',
        'OrigTransactionID',
        'DestTransactionID',
        'P-AbortCause',
        'ComponentPortion',
        'Component',
        'TCInvokeIdSet',
        ]
    _type_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'Abort',
        'DialoguePortion',
        'OrigTransactionID',
        'DestTransactionID',
        'P-AbortCause',
        'ComponentPortion',
        'Component',
        ]
    _set_ = [
        'TCInvokeIdSet',
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'ComponentPortion',
        'Component',
        ]
    
    #-----< TCMessage >-----#
    TCMessage = CHOICE(name='TCMessage', mode=MODE_TYPE, param=True)
    
    #-----< Unidirectional >-----#
    Unidirectional = SEQ(name='Unidirectional', mode=MODE_TYPE, param=True)
    
    #-----< Begin >-----#
    Begin = SEQ(name='Begin', mode=MODE_TYPE, param=True)
    
    #-----< End >-----#
    End = SEQ(name='End', mode=MODE_TYPE, param=True)
    
    #-----< Continue >-----#
    Continue = SEQ(name='Continue', mode=MODE_TYPE, param=True)
    
    #-----< Abort >-----#
    Abort = SEQ(name='Abort', mode=MODE_TYPE)
    _Abort_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    _Abort_reason = CHOICE(name='reason', mode=MODE_TYPE, opt=True)
    __Abort_reason_p_abortCause = INT(name='p-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'P-AbortCause')))
    __Abort_reason_u_abortCause = EXT(name='u-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')))
    _Abort_reason._cont = ASN1Dict([
        ('p-abortCause', __Abort_reason_p_abortCause),
        ('u-abortCause', __Abort_reason_u_abortCause),
        ])
    _Abort_reason._ext = None
    Abort._cont = ASN1Dict([
        ('dtid', _Abort_dtid),
        ('reason', _Abort_reason),
        ])
    Abort._ext = None
    
    #-----< DialoguePortion >-----#
    DialoguePortion = EXT(name='DialoguePortion', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    
    #-----< OrigTransactionID >-----#
    OrigTransactionID = OCT_STR(name='OrigTransactionID', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    OrigTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DestTransactionID >-----#
    DestTransactionID = OCT_STR(name='DestTransactionID', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT))
    DestTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< P-AbortCause >-----#
    P_AbortCause = INT(name='P-AbortCause', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT))
    P_AbortCause._cont = ASN1Dict([('unrecognizedMessageType', 0), ('unrecognizedTransactionID', 1), ('badlyFormattedTransactionPortion', 2), ('incorrectTransactionPortion', 3), ('resourceLimitation', 4)])
    P_AbortCause._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ComponentPortion >-----#
    ComponentPortion = SEQ_OF(name='ComponentPortion', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Component >-----#
    Component = CHOICE(name='Component', mode=MODE_TYPE, param=True)
    
    #-----< TCInvokeIdSet >-----#
    TCInvokeIdSet = CHOICE(name='TCInvokeIdSet', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    TCInvokeIdSet._val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    
    _all_ = [
        _Abort_dtid,
        __Abort_reason_p_abortCause,
        __Abort_reason_u_abortCause,
        _Abort_reason,
        Abort,
        DialoguePortion,
        OrigTransactionID,
        DestTransactionID,
        P_AbortCause,
        TCInvokeIdSet,
    ]

class TC_Notation_Extensions:

    _name_  = 'TC-Notation-Extensions'
    _oid_   = [0, 0, 17, 775, 2, 4, 1]
    
    _obj_ = [
        'APPLICATION-CONTEXT',
        'DialogueMode',
        'Termination',
        'dialogue-abstract-syntax',
        'uniDialogue-abstract-syntax',
        'TCSingleAS',
        'TCConsumerAS',
        'TCSupplierAS',
        'ConnectionAS',
        ]
    _type_ = [
        'APPLICATION-CONTEXT',
        'DialogueMode',
        'Termination',
        'TCSingleAS',
        'TCConsumerAS',
        'TCSupplierAS',
        'ConnectionAS',
        ]
    _set_ = [
        ]
    _val_ = [
        'dialogue-abstract-syntax',
        'uniDialogue-abstract-syntax',
        ]
    _class_ = [
        'APPLICATION-CONTEXT',
        'dialogue-abstract-syntax',
        'uniDialogue-abstract-syntax',
        ]
    _param_ = [
        'TCSingleAS',
        'TCConsumerAS',
        'TCSupplierAS',
        'ConnectionAS',
        ]
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name='APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_associationContract = CLASS(name='associationContract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    _APPLICATION_CONTEXT_dialogueMode = ENUM(name='dialogueMode', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'DialogueMode')))
    _APPLICATION_CONTEXT_termination = ENUM(name='termination', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'Termination')), opt=True)
    _APPLICATION_CONTEXT_componentGrouping = BOOL(name='componentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_dialogueAndComponentGrouping = BOOL(name='dialogueAndComponentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_AdditionalASEs = OID(name='AdditionalASEs', mode=MODE_SET, opt=True)
    _APPLICATION_CONTEXT_AbstractSyntaxes = CLASS(name='AbstractSyntaxes', mode=MODE_SET, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _APPLICATION_CONTEXT_applicationContextName = OID(name='applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        ('associationContract', _APPLICATION_CONTEXT_associationContract),
        ('dialogueMode', _APPLICATION_CONTEXT_dialogueMode),
        ('termination', _APPLICATION_CONTEXT_termination),
        ('componentGrouping', _APPLICATION_CONTEXT_componentGrouping),
        ('dialogueAndComponentGrouping', _APPLICATION_CONTEXT_dialogueAndComponentGrouping),
        ('AdditionalASEs', _APPLICATION_CONTEXT_AdditionalASEs),
        ('AbstractSyntaxes', _APPLICATION_CONTEXT_AbstractSyntaxes),
        ('applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< DialogueMode >-----#
    DialogueMode = ENUM(name='DialogueMode', mode=MODE_TYPE)
    DialogueMode._cont = ASN1Dict([('structured', 1), ('unstructured', 2)])
    DialogueMode._ext = None
    
    #-----< Termination >-----#
    Termination = ENUM(name='Termination', mode=MODE_TYPE)
    Termination._cont = ASN1Dict([('basic', 1), ('prearranged', 2)])
    Termination._ext = None
    
    #-----< dialogue-abstract-syntax >-----#
    dialogue_abstract_syntax = CLASS(name='dialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _dialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    dialogue_abstract_syntax._val = dict([('Type', _dialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 1, 1))])
    
    #-----< uniDialogue-abstract-syntax >-----#
    uniDialogue_abstract_syntax = CLASS(name='uniDialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _uniDialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    uniDialogue_abstract_syntax._val = dict([('Type', _uniDialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 2, 1))])
    
    #-----< TCSingleAS >-----#
    TCSingleAS = CHOICE(name='TCSingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCConsumerAS >-----#
    TCConsumerAS = CHOICE(name='TCConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCSupplierAS >-----#
    TCSupplierAS = CHOICE(name='TCSupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< ConnectionAS >-----#
    ConnectionAS = CHOICE(name='ConnectionAS', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _APPLICATION_CONTEXT_associationContract,
        _APPLICATION_CONTEXT_dialogueMode,
        _APPLICATION_CONTEXT_termination,
        _APPLICATION_CONTEXT_componentGrouping,
        _APPLICATION_CONTEXT_dialogueAndComponentGrouping,
        _APPLICATION_CONTEXT_AdditionalASEs,
        _APPLICATION_CONTEXT_AbstractSyntaxes,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        DialogueMode,
        Termination,
        dialogue_abstract_syntax,
        _dialogue_abstract_syntax_val_Type,
        uniDialogue_abstract_syntax,
        _uniDialogue_abstract_syntax_val_Type,
    ]

class CS1_DataTypes:

    _name_  = 'CS1-DataTypes'
    _oid_   = []
    
    _obj_ = [
        'Duration',
        'Integer4',
        'Interval',
        'LegID',
        'LegType',
        'ServiceKey',
        'CallingPartysCategory',
        'HighLayerCompatibility',
        'highLayerCompatibilityLength',
        'RedirectionInformation',
        ]
    _type_ = [
        'Duration',
        'Integer4',
        'Interval',
        'LegID',
        'LegType',
        'ServiceKey',
        'CallingPartysCategory',
        'HighLayerCompatibility',
        'RedirectionInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        'highLayerCompatibilityLength',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Duration >-----#
    Duration = INT(name='Duration', mode=MODE_TYPE)
    Duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2, ub=86400)], ev=None, er=[])
    
    #-----< Integer4 >-----#
    Integer4 = INT(name='Integer4', mode=MODE_TYPE)
    Integer4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< Interval >-----#
    Interval = INT(name='Interval', mode=MODE_TYPE)
    Interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=60000)], ev=None, er=[])
    
    #-----< LegID >-----#
    LegID = CHOICE(name='LegID', mode=MODE_TYPE)
    _LegID_sendingSideID = OCT_STR(name='sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    _LegID_receivingSideID = OCT_STR(name='receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    LegID._cont = ASN1Dict([
        ('sendingSideID', _LegID_sendingSideID),
        ('receivingSideID', _LegID_receivingSideID),
        ])
    LegID._ext = None
    
    #-----< LegType >-----#
    LegType = OCT_STR(name='LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name='ServiceKey', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< CallingPartysCategory >-----#
    CallingPartysCategory = OCT_STR(name='CallingPartysCategory', mode=MODE_TYPE)
    CallingPartysCategory._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< HighLayerCompatibility >-----#
    HighLayerCompatibility = OCT_STR(name='HighLayerCompatibility', mode=MODE_TYPE)
    HighLayerCompatibility._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< highLayerCompatibilityLength >-----#
    highLayerCompatibilityLength = INT(name='highLayerCompatibilityLength', mode=MODE_VALUE)
    highLayerCompatibilityLength._val = 2
    
    #-----< RedirectionInformation >-----#
    RedirectionInformation = OCT_STR(name='RedirectionInformation', mode=MODE_TYPE)
    RedirectionInformation._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    _all_ = [
        Duration,
        Integer4,
        Interval,
        _LegID_sendingSideID,
        _LegID_receivingSideID,
        LegID,
        LegType,
        ServiceKey,
        CallingPartysCategory,
        HighLayerCompatibility,
        highLayerCompatibilityLength,
        RedirectionInformation,
    ]

class CS2_datatypes:

    _name_  = 'CS2-datatypes'
    _oid_   = []
    
    _obj_ = [
        'CriticalityType',
        'BothwayThroughConnectionInd',
        'MiscCallInfo',
        ]
    _type_ = [
        'CriticalityType',
        'BothwayThroughConnectionInd',
        'MiscCallInfo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CriticalityType >-----#
    CriticalityType = ENUM(name='CriticalityType', mode=MODE_TYPE)
    CriticalityType._cont = ASN1Dict([('ignore', 0), ('abort', 1)])
    CriticalityType._ext = None
    
    #-----< BothwayThroughConnectionInd >-----#
    BothwayThroughConnectionInd = ENUM(name='BothwayThroughConnectionInd', mode=MODE_TYPE)
    BothwayThroughConnectionInd._cont = ASN1Dict([('bothwayPathRequired', 0), ('bothwayPathNotRequired', 1)])
    BothwayThroughConnectionInd._ext = None
    
    #-----< MiscCallInfo >-----#
    MiscCallInfo = SEQ(name='MiscCallInfo', mode=MODE_TYPE)
    _MiscCallInfo_messageType = ENUM(name='messageType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MiscCallInfo_messageType._cont = ASN1Dict([('request', 0), ('notification', 1)])
    _MiscCallInfo_messageType._ext = None
    _MiscCallInfo_dpAssignment = ENUM(name='dpAssignment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MiscCallInfo_dpAssignment._cont = ASN1Dict([('individualLine', 0), ('groupBased', 1), ('officeBased', 2)])
    _MiscCallInfo_dpAssignment._ext = None
    MiscCallInfo._cont = ASN1Dict([
        ('messageType', _MiscCallInfo_messageType),
        ('dpAssignment', _MiscCallInfo_dpAssignment),
        ])
    MiscCallInfo._ext = None
    
    _all_ = [
        CriticalityType,
        BothwayThroughConnectionInd,
        _MiscCallInfo_messageType,
        _MiscCallInfo_dpAssignment,
        MiscCallInfo,
    ]

class MAP_TS_Code:

    _name_  = 'MAP-TS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 19, 19]
    
    _obj_ = [
        'TeleserviceCode',
        'Ext-TeleserviceCode',
        'allTeleservices',
        'allSpeechTransmissionServices',
        'telephony',
        'emergencyCalls',
        'allShortMessageServices',
        'shortMessageMT-PP',
        'shortMessageMO-PP',
        'allFacsimileTransmissionServices',
        'facsimileGroup3AndAlterSpeech',
        'automaticFacsimileGroup3',
        'facsimileGroup4',
        'allDataTeleservices',
        'allTeleservices-ExeptSMS',
        'allVoiceGroupCallServices',
        'voiceGroupCall',
        'voiceBroadcastCall',
        'allPLMN-specificTS',
        'plmn-specificTS-1',
        'plmn-specificTS-2',
        'plmn-specificTS-3',
        'plmn-specificTS-4',
        'plmn-specificTS-5',
        'plmn-specificTS-6',
        'plmn-specificTS-7',
        'plmn-specificTS-8',
        'plmn-specificTS-9',
        'plmn-specificTS-A',
        'plmn-specificTS-B',
        'plmn-specificTS-C',
        'plmn-specificTS-D',
        'plmn-specificTS-E',
        'plmn-specificTS-F',
        ]
    _type_ = [
        'TeleserviceCode',
        'Ext-TeleserviceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        'allTeleservices',
        'allSpeechTransmissionServices',
        'telephony',
        'emergencyCalls',
        'allShortMessageServices',
        'shortMessageMT-PP',
        'shortMessageMO-PP',
        'allFacsimileTransmissionServices',
        'facsimileGroup3AndAlterSpeech',
        'automaticFacsimileGroup3',
        'facsimileGroup4',
        'allDataTeleservices',
        'allTeleservices-ExeptSMS',
        'allVoiceGroupCallServices',
        'voiceGroupCall',
        'voiceBroadcastCall',
        'allPLMN-specificTS',
        'plmn-specificTS-1',
        'plmn-specificTS-2',
        'plmn-specificTS-3',
        'plmn-specificTS-4',
        'plmn-specificTS-5',
        'plmn-specificTS-6',
        'plmn-specificTS-7',
        'plmn-specificTS-8',
        'plmn-specificTS-9',
        'plmn-specificTS-A',
        'plmn-specificTS-B',
        'plmn-specificTS-C',
        'plmn-specificTS-D',
        'plmn-specificTS-E',
        'plmn-specificTS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TeleserviceCode >-----#
    TeleserviceCode = OCT_STR(name='TeleserviceCode', mode=MODE_TYPE)
    TeleserviceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-TeleserviceCode >-----#
    Ext_TeleserviceCode = OCT_STR(name='Ext-TeleserviceCode', mode=MODE_TYPE)
    Ext_TeleserviceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allTeleservices >-----#
    allTeleservices = OCT_STR(name='allTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices._val = b'\x00'
    
    #-----< allSpeechTransmissionServices >-----#
    allSpeechTransmissionServices = OCT_STR(name='allSpeechTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allSpeechTransmissionServices._val = b'\x10'
    
    #-----< telephony >-----#
    telephony = OCT_STR(name='telephony', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    telephony._val = b'\x11'
    
    #-----< emergencyCalls >-----#
    emergencyCalls = OCT_STR(name='emergencyCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    emergencyCalls._val = b'\x12'
    
    #-----< allShortMessageServices >-----#
    allShortMessageServices = OCT_STR(name='allShortMessageServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allShortMessageServices._val = b' '
    
    #-----< shortMessageMT-PP >-----#
    shortMessageMT_PP = OCT_STR(name='shortMessageMT-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMT_PP._val = b'!'
    
    #-----< shortMessageMO-PP >-----#
    shortMessageMO_PP = OCT_STR(name='shortMessageMO-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMO_PP._val = b'"'
    
    #-----< allFacsimileTransmissionServices >-----#
    allFacsimileTransmissionServices = OCT_STR(name='allFacsimileTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allFacsimileTransmissionServices._val = b'`'
    
    #-----< facsimileGroup3AndAlterSpeech >-----#
    facsimileGroup3AndAlterSpeech = OCT_STR(name='facsimileGroup3AndAlterSpeech', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup3AndAlterSpeech._val = b'a'
    
    #-----< automaticFacsimileGroup3 >-----#
    automaticFacsimileGroup3 = OCT_STR(name='automaticFacsimileGroup3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    automaticFacsimileGroup3._val = b'b'
    
    #-----< facsimileGroup4 >-----#
    facsimileGroup4 = OCT_STR(name='facsimileGroup4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup4._val = b'c'
    
    #-----< allDataTeleservices >-----#
    allDataTeleservices = OCT_STR(name='allDataTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allDataTeleservices._val = b'p'
    
    #-----< allTeleservices-ExeptSMS >-----#
    allTeleservices_ExeptSMS = OCT_STR(name='allTeleservices-ExeptSMS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices_ExeptSMS._val = b'\x80'
    
    #-----< allVoiceGroupCallServices >-----#
    allVoiceGroupCallServices = OCT_STR(name='allVoiceGroupCallServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allVoiceGroupCallServices._val = b'\x90'
    
    #-----< voiceGroupCall >-----#
    voiceGroupCall = OCT_STR(name='voiceGroupCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceGroupCall._val = b'\x91'
    
    #-----< voiceBroadcastCall >-----#
    voiceBroadcastCall = OCT_STR(name='voiceBroadcastCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceBroadcastCall._val = b'\x92'
    
    #-----< allPLMN-specificTS >-----#
    allPLMN_specificTS = OCT_STR(name='allPLMN-specificTS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allPLMN_specificTS._val = b'\xd0'
    
    #-----< plmn-specificTS-1 >-----#
    plmn_specificTS_1 = OCT_STR(name='plmn-specificTS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_1._val = b'\xd1'
    
    #-----< plmn-specificTS-2 >-----#
    plmn_specificTS_2 = OCT_STR(name='plmn-specificTS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_2._val = b'\xd2'
    
    #-----< plmn-specificTS-3 >-----#
    plmn_specificTS_3 = OCT_STR(name='plmn-specificTS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_3._val = b'\xd3'
    
    #-----< plmn-specificTS-4 >-----#
    plmn_specificTS_4 = OCT_STR(name='plmn-specificTS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_4._val = b'\xd4'
    
    #-----< plmn-specificTS-5 >-----#
    plmn_specificTS_5 = OCT_STR(name='plmn-specificTS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_5._val = b'\xd5'
    
    #-----< plmn-specificTS-6 >-----#
    plmn_specificTS_6 = OCT_STR(name='plmn-specificTS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_6._val = b'\xd6'
    
    #-----< plmn-specificTS-7 >-----#
    plmn_specificTS_7 = OCT_STR(name='plmn-specificTS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_7._val = b'\xd7'
    
    #-----< plmn-specificTS-8 >-----#
    plmn_specificTS_8 = OCT_STR(name='plmn-specificTS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_8._val = b'\xd8'
    
    #-----< plmn-specificTS-9 >-----#
    plmn_specificTS_9 = OCT_STR(name='plmn-specificTS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_9._val = b'\xd9'
    
    #-----< plmn-specificTS-A >-----#
    plmn_specificTS_A = OCT_STR(name='plmn-specificTS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_A._val = b'\xda'
    
    #-----< plmn-specificTS-B >-----#
    plmn_specificTS_B = OCT_STR(name='plmn-specificTS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_B._val = b'\xdb'
    
    #-----< plmn-specificTS-C >-----#
    plmn_specificTS_C = OCT_STR(name='plmn-specificTS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_C._val = b'\xdc'
    
    #-----< plmn-specificTS-D >-----#
    plmn_specificTS_D = OCT_STR(name='plmn-specificTS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_D._val = b'\xdd'
    
    #-----< plmn-specificTS-E >-----#
    plmn_specificTS_E = OCT_STR(name='plmn-specificTS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_E._val = b'\xde'
    
    #-----< plmn-specificTS-F >-----#
    plmn_specificTS_F = OCT_STR(name='plmn-specificTS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_F._val = b'\xdf'
    
    _all_ = [
        TeleserviceCode,
        Ext_TeleserviceCode,
        allTeleservices,
        allSpeechTransmissionServices,
        telephony,
        emergencyCalls,
        allShortMessageServices,
        shortMessageMT_PP,
        shortMessageMO_PP,
        allFacsimileTransmissionServices,
        facsimileGroup3AndAlterSpeech,
        automaticFacsimileGroup3,
        facsimileGroup4,
        allDataTeleservices,
        allTeleservices_ExeptSMS,
        allVoiceGroupCallServices,
        voiceGroupCall,
        voiceBroadcastCall,
        allPLMN_specificTS,
        plmn_specificTS_1,
        plmn_specificTS_2,
        plmn_specificTS_3,
        plmn_specificTS_4,
        plmn_specificTS_5,
        plmn_specificTS_6,
        plmn_specificTS_7,
        plmn_specificTS_8,
        plmn_specificTS_9,
        plmn_specificTS_A,
        plmn_specificTS_B,
        plmn_specificTS_C,
        plmn_specificTS_D,
        plmn_specificTS_E,
        plmn_specificTS_F,
    ]

class MAP_BS_Code:

    _name_  = 'MAP-BS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 20, 19]
    
    _obj_ = [
        'BearerServiceCode',
        'Ext-BearerServiceCode',
        'allBearerServices',
        'allDataCDA-Services',
        'dataCDA-300bps',
        'dataCDA-1200bps',
        'dataCDA-1200-75bps',
        'dataCDA-2400bps',
        'dataCDA-4800bps',
        'dataCDA-9600bps',
        'general-dataCDA',
        'allDataCDS-Services',
        'dataCDS-1200bps',
        'dataCDS-2400bps',
        'dataCDS-4800bps',
        'dataCDS-9600bps',
        'general-dataCDS',
        'allPadAccessCA-Services',
        'padAccessCA-300bps',
        'padAccessCA-1200bps',
        'padAccessCA-1200-75bps',
        'padAccessCA-2400bps',
        'padAccessCA-4800bps',
        'padAccessCA-9600bps',
        'general-padAccessCA',
        'allDataPDS-Services',
        'dataPDS-2400bps',
        'dataPDS-4800bps',
        'dataPDS-9600bps',
        'general-dataPDS',
        'allAlternateSpeech-DataCDA',
        'allAlternateSpeech-DataCDS',
        'allSpeechFollowedByDataCDA',
        'allSpeechFollowedByDataCDS',
        'allDataCircuitAsynchronous',
        'allAsynchronousServices',
        'allDataCircuitSynchronous',
        'allSynchronousServices',
        'allPLMN-specificBS',
        'plmn-specificBS-1',
        'plmn-specificBS-2',
        'plmn-specificBS-3',
        'plmn-specificBS-4',
        'plmn-specificBS-5',
        'plmn-specificBS-6',
        'plmn-specificBS-7',
        'plmn-specificBS-8',
        'plmn-specificBS-9',
        'plmn-specificBS-A',
        'plmn-specificBS-B',
        'plmn-specificBS-C',
        'plmn-specificBS-D',
        'plmn-specificBS-E',
        'plmn-specificBS-F',
        ]
    _type_ = [
        'BearerServiceCode',
        'Ext-BearerServiceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        'allBearerServices',
        'allDataCDA-Services',
        'dataCDA-300bps',
        'dataCDA-1200bps',
        'dataCDA-1200-75bps',
        'dataCDA-2400bps',
        'dataCDA-4800bps',
        'dataCDA-9600bps',
        'general-dataCDA',
        'allDataCDS-Services',
        'dataCDS-1200bps',
        'dataCDS-2400bps',
        'dataCDS-4800bps',
        'dataCDS-9600bps',
        'general-dataCDS',
        'allPadAccessCA-Services',
        'padAccessCA-300bps',
        'padAccessCA-1200bps',
        'padAccessCA-1200-75bps',
        'padAccessCA-2400bps',
        'padAccessCA-4800bps',
        'padAccessCA-9600bps',
        'general-padAccessCA',
        'allDataPDS-Services',
        'dataPDS-2400bps',
        'dataPDS-4800bps',
        'dataPDS-9600bps',
        'general-dataPDS',
        'allAlternateSpeech-DataCDA',
        'allAlternateSpeech-DataCDS',
        'allSpeechFollowedByDataCDA',
        'allSpeechFollowedByDataCDS',
        'allDataCircuitAsynchronous',
        'allAsynchronousServices',
        'allDataCircuitSynchronous',
        'allSynchronousServices',
        'allPLMN-specificBS',
        'plmn-specificBS-1',
        'plmn-specificBS-2',
        'plmn-specificBS-3',
        'plmn-specificBS-4',
        'plmn-specificBS-5',
        'plmn-specificBS-6',
        'plmn-specificBS-7',
        'plmn-specificBS-8',
        'plmn-specificBS-9',
        'plmn-specificBS-A',
        'plmn-specificBS-B',
        'plmn-specificBS-C',
        'plmn-specificBS-D',
        'plmn-specificBS-E',
        'plmn-specificBS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BearerServiceCode >-----#
    BearerServiceCode = OCT_STR(name='BearerServiceCode', mode=MODE_TYPE)
    BearerServiceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-BearerServiceCode >-----#
    Ext_BearerServiceCode = OCT_STR(name='Ext-BearerServiceCode', mode=MODE_TYPE)
    Ext_BearerServiceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allBearerServices >-----#
    allBearerServices = OCT_STR(name='allBearerServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allBearerServices._val = b'\x00'
    
    #-----< allDataCDA-Services >-----#
    allDataCDA_Services = OCT_STR(name='allDataCDA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDA_Services._val = b'\x10'
    
    #-----< dataCDA-300bps >-----#
    dataCDA_300bps = OCT_STR(name='dataCDA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_300bps._val = b'\x11'
    
    #-----< dataCDA-1200bps >-----#
    dataCDA_1200bps = OCT_STR(name='dataCDA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200bps._val = b'\x12'
    
    #-----< dataCDA-1200-75bps >-----#
    dataCDA_1200_75bps = OCT_STR(name='dataCDA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200_75bps._val = b'\x13'
    
    #-----< dataCDA-2400bps >-----#
    dataCDA_2400bps = OCT_STR(name='dataCDA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_2400bps._val = b'\x14'
    
    #-----< dataCDA-4800bps >-----#
    dataCDA_4800bps = OCT_STR(name='dataCDA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_4800bps._val = b'\x15'
    
    #-----< dataCDA-9600bps >-----#
    dataCDA_9600bps = OCT_STR(name='dataCDA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_9600bps._val = b'\x16'
    
    #-----< general-dataCDA >-----#
    general_dataCDA = OCT_STR(name='general-dataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDA._val = b'\x17'
    
    #-----< allDataCDS-Services >-----#
    allDataCDS_Services = OCT_STR(name='allDataCDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDS_Services._val = b'\x18'
    
    #-----< dataCDS-1200bps >-----#
    dataCDS_1200bps = OCT_STR(name='dataCDS-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_1200bps._val = b'\x1a'
    
    #-----< dataCDS-2400bps >-----#
    dataCDS_2400bps = OCT_STR(name='dataCDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_2400bps._val = b'\x1c'
    
    #-----< dataCDS-4800bps >-----#
    dataCDS_4800bps = OCT_STR(name='dataCDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_4800bps._val = b'\x1d'
    
    #-----< dataCDS-9600bps >-----#
    dataCDS_9600bps = OCT_STR(name='dataCDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_9600bps._val = b'\x1e'
    
    #-----< general-dataCDS >-----#
    general_dataCDS = OCT_STR(name='general-dataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDS._val = b'\x1f'
    
    #-----< allPadAccessCA-Services >-----#
    allPadAccessCA_Services = OCT_STR(name='allPadAccessCA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPadAccessCA_Services._val = b' '
    
    #-----< padAccessCA-300bps >-----#
    padAccessCA_300bps = OCT_STR(name='padAccessCA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_300bps._val = b'!'
    
    #-----< padAccessCA-1200bps >-----#
    padAccessCA_1200bps = OCT_STR(name='padAccessCA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200bps._val = b'"'
    
    #-----< padAccessCA-1200-75bps >-----#
    padAccessCA_1200_75bps = OCT_STR(name='padAccessCA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200_75bps._val = b'#'
    
    #-----< padAccessCA-2400bps >-----#
    padAccessCA_2400bps = OCT_STR(name='padAccessCA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_2400bps._val = b'$'
    
    #-----< padAccessCA-4800bps >-----#
    padAccessCA_4800bps = OCT_STR(name='padAccessCA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_4800bps._val = b'%'
    
    #-----< padAccessCA-9600bps >-----#
    padAccessCA_9600bps = OCT_STR(name='padAccessCA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_9600bps._val = b'&'
    
    #-----< general-padAccessCA >-----#
    general_padAccessCA = OCT_STR(name='general-padAccessCA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_padAccessCA._val = b"'"
    
    #-----< allDataPDS-Services >-----#
    allDataPDS_Services = OCT_STR(name='allDataPDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataPDS_Services._val = b'('
    
    #-----< dataPDS-2400bps >-----#
    dataPDS_2400bps = OCT_STR(name='dataPDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_2400bps._val = b','
    
    #-----< dataPDS-4800bps >-----#
    dataPDS_4800bps = OCT_STR(name='dataPDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_4800bps._val = b'-'
    
    #-----< dataPDS-9600bps >-----#
    dataPDS_9600bps = OCT_STR(name='dataPDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_9600bps._val = b'.'
    
    #-----< general-dataPDS >-----#
    general_dataPDS = OCT_STR(name='general-dataPDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataPDS._val = b'/'
    
    #-----< allAlternateSpeech-DataCDA >-----#
    allAlternateSpeech_DataCDA = OCT_STR(name='allAlternateSpeech-DataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDA._val = b'0'
    
    #-----< allAlternateSpeech-DataCDS >-----#
    allAlternateSpeech_DataCDS = OCT_STR(name='allAlternateSpeech-DataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDS._val = b'8'
    
    #-----< allSpeechFollowedByDataCDA >-----#
    allSpeechFollowedByDataCDA = OCT_STR(name='allSpeechFollowedByDataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDA._val = b'@'
    
    #-----< allSpeechFollowedByDataCDS >-----#
    allSpeechFollowedByDataCDS = OCT_STR(name='allSpeechFollowedByDataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDS._val = b'H'
    
    #-----< allDataCircuitAsynchronous >-----#
    allDataCircuitAsynchronous = OCT_STR(name='allDataCircuitAsynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitAsynchronous._val = b'P'
    
    #-----< allAsynchronousServices >-----#
    allAsynchronousServices = OCT_STR(name='allAsynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAsynchronousServices._val = b'`'
    
    #-----< allDataCircuitSynchronous >-----#
    allDataCircuitSynchronous = OCT_STR(name='allDataCircuitSynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitSynchronous._val = b'X'
    
    #-----< allSynchronousServices >-----#
    allSynchronousServices = OCT_STR(name='allSynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSynchronousServices._val = b'h'
    
    #-----< allPLMN-specificBS >-----#
    allPLMN_specificBS = OCT_STR(name='allPLMN-specificBS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPLMN_specificBS._val = b'\xd0'
    
    #-----< plmn-specificBS-1 >-----#
    plmn_specificBS_1 = OCT_STR(name='plmn-specificBS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_1._val = b'\xd1'
    
    #-----< plmn-specificBS-2 >-----#
    plmn_specificBS_2 = OCT_STR(name='plmn-specificBS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_2._val = b'\xd2'
    
    #-----< plmn-specificBS-3 >-----#
    plmn_specificBS_3 = OCT_STR(name='plmn-specificBS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_3._val = b'\xd3'
    
    #-----< plmn-specificBS-4 >-----#
    plmn_specificBS_4 = OCT_STR(name='plmn-specificBS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_4._val = b'\xd4'
    
    #-----< plmn-specificBS-5 >-----#
    plmn_specificBS_5 = OCT_STR(name='plmn-specificBS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_5._val = b'\xd5'
    
    #-----< plmn-specificBS-6 >-----#
    plmn_specificBS_6 = OCT_STR(name='plmn-specificBS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_6._val = b'\xd6'
    
    #-----< plmn-specificBS-7 >-----#
    plmn_specificBS_7 = OCT_STR(name='plmn-specificBS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_7._val = b'\xd7'
    
    #-----< plmn-specificBS-8 >-----#
    plmn_specificBS_8 = OCT_STR(name='plmn-specificBS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_8._val = b'\xd8'
    
    #-----< plmn-specificBS-9 >-----#
    plmn_specificBS_9 = OCT_STR(name='plmn-specificBS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_9._val = b'\xd9'
    
    #-----< plmn-specificBS-A >-----#
    plmn_specificBS_A = OCT_STR(name='plmn-specificBS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_A._val = b'\xda'
    
    #-----< plmn-specificBS-B >-----#
    plmn_specificBS_B = OCT_STR(name='plmn-specificBS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_B._val = b'\xdb'
    
    #-----< plmn-specificBS-C >-----#
    plmn_specificBS_C = OCT_STR(name='plmn-specificBS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_C._val = b'\xdc'
    
    #-----< plmn-specificBS-D >-----#
    plmn_specificBS_D = OCT_STR(name='plmn-specificBS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_D._val = b'\xdd'
    
    #-----< plmn-specificBS-E >-----#
    plmn_specificBS_E = OCT_STR(name='plmn-specificBS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_E._val = b'\xde'
    
    #-----< plmn-specificBS-F >-----#
    plmn_specificBS_F = OCT_STR(name='plmn-specificBS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_F._val = b'\xdf'
    
    _all_ = [
        BearerServiceCode,
        Ext_BearerServiceCode,
        allBearerServices,
        allDataCDA_Services,
        dataCDA_300bps,
        dataCDA_1200bps,
        dataCDA_1200_75bps,
        dataCDA_2400bps,
        dataCDA_4800bps,
        dataCDA_9600bps,
        general_dataCDA,
        allDataCDS_Services,
        dataCDS_1200bps,
        dataCDS_2400bps,
        dataCDS_4800bps,
        dataCDS_9600bps,
        general_dataCDS,
        allPadAccessCA_Services,
        padAccessCA_300bps,
        padAccessCA_1200bps,
        padAccessCA_1200_75bps,
        padAccessCA_2400bps,
        padAccessCA_4800bps,
        padAccessCA_9600bps,
        general_padAccessCA,
        allDataPDS_Services,
        dataPDS_2400bps,
        dataPDS_4800bps,
        dataPDS_9600bps,
        general_dataPDS,
        allAlternateSpeech_DataCDA,
        allAlternateSpeech_DataCDS,
        allSpeechFollowedByDataCDA,
        allSpeechFollowedByDataCDS,
        allDataCircuitAsynchronous,
        allAsynchronousServices,
        allDataCircuitSynchronous,
        allSynchronousServices,
        allPLMN_specificBS,
        plmn_specificBS_1,
        plmn_specificBS_2,
        plmn_specificBS_3,
        plmn_specificBS_4,
        plmn_specificBS_5,
        plmn_specificBS_6,
        plmn_specificBS_7,
        plmn_specificBS_8,
        plmn_specificBS_9,
        plmn_specificBS_A,
        plmn_specificBS_B,
        plmn_specificBS_C,
        plmn_specificBS_D,
        plmn_specificBS_E,
        plmn_specificBS_F,
    ]

class MAP_SS_Code:

    _name_  = 'MAP-SS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 15, 19]
    
    _obj_ = [
        'SS-Code',
        'allSS',
        'allLineIdentificationSS',
        'clip',
        'clir',
        'colp',
        'colr',
        'mci',
        'allNameIdentificationSS',
        'cnap',
        'allForwardingSS',
        'cfu',
        'allCondForwardingSS',
        'cfb',
        'cfnry',
        'cfnrc',
        'cd',
        'allCallOfferingSS',
        'ect',
        'mah',
        'allCallCompletionSS',
        'cw',
        'hold',
        'ccbs-A',
        'ccbs-B',
        'mc',
        'allMultiPartySS',
        'multiPTY',
        'allCommunityOfInterest-SS',
        'cug',
        'allChargingSS',
        'aoci',
        'aocc',
        'allAdditionalInfoTransferSS',
        'uus1',
        'uus2',
        'uus3',
        'allBarringSS',
        'barringOfOutgoingCalls',
        'baoc',
        'boic',
        'boicExHC',
        'barringOfIncomingCalls',
        'baic',
        'bicRoam',
        'allPLMN-specificSS',
        'plmn-specificSS-1',
        'plmn-specificSS-2',
        'plmn-specificSS-3',
        'plmn-specificSS-4',
        'plmn-specificSS-5',
        'plmn-specificSS-6',
        'plmn-specificSS-7',
        'plmn-specificSS-8',
        'plmn-specificSS-9',
        'plmn-specificSS-A',
        'plmn-specificSS-B',
        'plmn-specificSS-C',
        'plmn-specificSS-D',
        'plmn-specificSS-E',
        'plmn-specificSS-F',
        'allCallPrioritySS',
        'emlpp',
        'allLCSPrivacyException',
        'universal',
        'callSessionRelated',
        'callSessionUnrelated',
        'plmnoperator',
        'serviceType',
        'allMOLR-SS',
        'basicSelfLocation',
        'autonomousSelfLocation',
        'transferToThirdParty',
        ]
    _type_ = [
        'SS-Code',
        ]
    _set_ = [
        ]
    _val_ = [
        'allSS',
        'allLineIdentificationSS',
        'clip',
        'clir',
        'colp',
        'colr',
        'mci',
        'allNameIdentificationSS',
        'cnap',
        'allForwardingSS',
        'cfu',
        'allCondForwardingSS',
        'cfb',
        'cfnry',
        'cfnrc',
        'cd',
        'allCallOfferingSS',
        'ect',
        'mah',
        'allCallCompletionSS',
        'cw',
        'hold',
        'ccbs-A',
        'ccbs-B',
        'mc',
        'allMultiPartySS',
        'multiPTY',
        'allCommunityOfInterest-SS',
        'cug',
        'allChargingSS',
        'aoci',
        'aocc',
        'allAdditionalInfoTransferSS',
        'uus1',
        'uus2',
        'uus3',
        'allBarringSS',
        'barringOfOutgoingCalls',
        'baoc',
        'boic',
        'boicExHC',
        'barringOfIncomingCalls',
        'baic',
        'bicRoam',
        'allPLMN-specificSS',
        'plmn-specificSS-1',
        'plmn-specificSS-2',
        'plmn-specificSS-3',
        'plmn-specificSS-4',
        'plmn-specificSS-5',
        'plmn-specificSS-6',
        'plmn-specificSS-7',
        'plmn-specificSS-8',
        'plmn-specificSS-9',
        'plmn-specificSS-A',
        'plmn-specificSS-B',
        'plmn-specificSS-C',
        'plmn-specificSS-D',
        'plmn-specificSS-E',
        'plmn-specificSS-F',
        'allCallPrioritySS',
        'emlpp',
        'allLCSPrivacyException',
        'universal',
        'callSessionRelated',
        'callSessionUnrelated',
        'plmnoperator',
        'serviceType',
        'allMOLR-SS',
        'basicSelfLocation',
        'autonomousSelfLocation',
        'transferToThirdParty',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SS-Code >-----#
    SS_Code = OCT_STR(name='SS-Code', mode=MODE_TYPE)
    SS_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< allSS >-----#
    allSS = OCT_STR(name='allSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allSS._val = b'\x00'
    
    #-----< allLineIdentificationSS >-----#
    allLineIdentificationSS = OCT_STR(name='allLineIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLineIdentificationSS._val = b'\x10'
    
    #-----< clip >-----#
    clip = OCT_STR(name='clip', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clip._val = b'\x11'
    
    #-----< clir >-----#
    clir = OCT_STR(name='clir', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clir._val = b'\x12'
    
    #-----< colp >-----#
    colp = OCT_STR(name='colp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colp._val = b'\x13'
    
    #-----< colr >-----#
    colr = OCT_STR(name='colr', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colr._val = b'\x14'
    
    #-----< mci >-----#
    mci = OCT_STR(name='mci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mci._val = b'\x15'
    
    #-----< allNameIdentificationSS >-----#
    allNameIdentificationSS = OCT_STR(name='allNameIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allNameIdentificationSS._val = b'\x18'
    
    #-----< cnap >-----#
    cnap = OCT_STR(name='cnap', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cnap._val = b'\x19'
    
    #-----< allForwardingSS >-----#
    allForwardingSS = OCT_STR(name='allForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allForwardingSS._val = b' '
    
    #-----< cfu >-----#
    cfu = OCT_STR(name='cfu', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfu._val = b'!'
    
    #-----< allCondForwardingSS >-----#
    allCondForwardingSS = OCT_STR(name='allCondForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCondForwardingSS._val = b'('
    
    #-----< cfb >-----#
    cfb = OCT_STR(name='cfb', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfb._val = b')'
    
    #-----< cfnry >-----#
    cfnry = OCT_STR(name='cfnry', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnry._val = b'*'
    
    #-----< cfnrc >-----#
    cfnrc = OCT_STR(name='cfnrc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnrc._val = b'+'
    
    #-----< cd >-----#
    cd = OCT_STR(name='cd', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cd._val = b'$'
    
    #-----< allCallOfferingSS >-----#
    allCallOfferingSS = OCT_STR(name='allCallOfferingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallOfferingSS._val = b'0'
    
    #-----< ect >-----#
    ect = OCT_STR(name='ect', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ect._val = b'1'
    
    #-----< mah >-----#
    mah = OCT_STR(name='mah', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mah._val = b'2'
    
    #-----< allCallCompletionSS >-----#
    allCallCompletionSS = OCT_STR(name='allCallCompletionSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallCompletionSS._val = b'@'
    
    #-----< cw >-----#
    cw = OCT_STR(name='cw', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cw._val = b'A'
    
    #-----< hold >-----#
    hold = OCT_STR(name='hold', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    hold._val = b'B'
    
    #-----< ccbs-A >-----#
    ccbs_A = OCT_STR(name='ccbs-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_A._val = b'C'
    
    #-----< ccbs-B >-----#
    ccbs_B = OCT_STR(name='ccbs-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_B._val = b'D'
    
    #-----< mc >-----#
    mc = OCT_STR(name='mc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mc._val = b'E'
    
    #-----< allMultiPartySS >-----#
    allMultiPartySS = OCT_STR(name='allMultiPartySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMultiPartySS._val = b'P'
    
    #-----< multiPTY >-----#
    multiPTY = OCT_STR(name='multiPTY', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    multiPTY._val = b'Q'
    
    #-----< allCommunityOfInterest-SS >-----#
    allCommunityOfInterest_SS = OCT_STR(name='allCommunityOfInterest-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCommunityOfInterest_SS._val = b'`'
    
    #-----< cug >-----#
    cug = OCT_STR(name='cug', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cug._val = b'a'
    
    #-----< allChargingSS >-----#
    allChargingSS = OCT_STR(name='allChargingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allChargingSS._val = b'p'
    
    #-----< aoci >-----#
    aoci = OCT_STR(name='aoci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aoci._val = b'q'
    
    #-----< aocc >-----#
    aocc = OCT_STR(name='aocc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aocc._val = b'r'
    
    #-----< allAdditionalInfoTransferSS >-----#
    allAdditionalInfoTransferSS = OCT_STR(name='allAdditionalInfoTransferSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allAdditionalInfoTransferSS._val = b'\x80'
    
    #-----< uus1 >-----#
    uus1 = OCT_STR(name='uus1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus1._val = b'\x81'
    
    #-----< uus2 >-----#
    uus2 = OCT_STR(name='uus2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus2._val = b'\x82'
    
    #-----< uus3 >-----#
    uus3 = OCT_STR(name='uus3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus3._val = b'\x83'
    
    #-----< allBarringSS >-----#
    allBarringSS = OCT_STR(name='allBarringSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allBarringSS._val = b'\x90'
    
    #-----< barringOfOutgoingCalls >-----#
    barringOfOutgoingCalls = OCT_STR(name='barringOfOutgoingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfOutgoingCalls._val = b'\x91'
    
    #-----< baoc >-----#
    baoc = OCT_STR(name='baoc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baoc._val = b'\x92'
    
    #-----< boic >-----#
    boic = OCT_STR(name='boic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boic._val = b'\x93'
    
    #-----< boicExHC >-----#
    boicExHC = OCT_STR(name='boicExHC', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boicExHC._val = b'\x94'
    
    #-----< barringOfIncomingCalls >-----#
    barringOfIncomingCalls = OCT_STR(name='barringOfIncomingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfIncomingCalls._val = b'\x99'
    
    #-----< baic >-----#
    baic = OCT_STR(name='baic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baic._val = b'\x9a'
    
    #-----< bicRoam >-----#
    bicRoam = OCT_STR(name='bicRoam', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    bicRoam._val = b'\x9b'
    
    #-----< allPLMN-specificSS >-----#
    allPLMN_specificSS = OCT_STR(name='allPLMN-specificSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allPLMN_specificSS._val = b'\xf0'
    
    #-----< plmn-specificSS-1 >-----#
    plmn_specificSS_1 = OCT_STR(name='plmn-specificSS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_1._val = b'\xf1'
    
    #-----< plmn-specificSS-2 >-----#
    plmn_specificSS_2 = OCT_STR(name='plmn-specificSS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_2._val = b'\xf2'
    
    #-----< plmn-specificSS-3 >-----#
    plmn_specificSS_3 = OCT_STR(name='plmn-specificSS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_3._val = b'\xf3'
    
    #-----< plmn-specificSS-4 >-----#
    plmn_specificSS_4 = OCT_STR(name='plmn-specificSS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_4._val = b'\xf4'
    
    #-----< plmn-specificSS-5 >-----#
    plmn_specificSS_5 = OCT_STR(name='plmn-specificSS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_5._val = b'\xf5'
    
    #-----< plmn-specificSS-6 >-----#
    plmn_specificSS_6 = OCT_STR(name='plmn-specificSS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_6._val = b'\xf6'
    
    #-----< plmn-specificSS-7 >-----#
    plmn_specificSS_7 = OCT_STR(name='plmn-specificSS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_7._val = b'\xf7'
    
    #-----< plmn-specificSS-8 >-----#
    plmn_specificSS_8 = OCT_STR(name='plmn-specificSS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_8._val = b'\xf8'
    
    #-----< plmn-specificSS-9 >-----#
    plmn_specificSS_9 = OCT_STR(name='plmn-specificSS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_9._val = b'\xf9'
    
    #-----< plmn-specificSS-A >-----#
    plmn_specificSS_A = OCT_STR(name='plmn-specificSS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_A._val = b'\xfa'
    
    #-----< plmn-specificSS-B >-----#
    plmn_specificSS_B = OCT_STR(name='plmn-specificSS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_B._val = b'\xfb'
    
    #-----< plmn-specificSS-C >-----#
    plmn_specificSS_C = OCT_STR(name='plmn-specificSS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_C._val = b'\xfc'
    
    #-----< plmn-specificSS-D >-----#
    plmn_specificSS_D = OCT_STR(name='plmn-specificSS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_D._val = b'\xfd'
    
    #-----< plmn-specificSS-E >-----#
    plmn_specificSS_E = OCT_STR(name='plmn-specificSS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_E._val = b'\xfe'
    
    #-----< plmn-specificSS-F >-----#
    plmn_specificSS_F = OCT_STR(name='plmn-specificSS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_F._val = b'\xff'
    
    #-----< allCallPrioritySS >-----#
    allCallPrioritySS = OCT_STR(name='allCallPrioritySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallPrioritySS._val = b'\xa0'
    
    #-----< emlpp >-----#
    emlpp = OCT_STR(name='emlpp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    emlpp._val = b'\xa1'
    
    #-----< allLCSPrivacyException >-----#
    allLCSPrivacyException = OCT_STR(name='allLCSPrivacyException', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLCSPrivacyException._val = b'\xb0'
    
    #-----< universal >-----#
    universal = OCT_STR(name='universal', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    universal._val = b'\xb1'
    
    #-----< callSessionRelated >-----#
    callSessionRelated = OCT_STR(name='callSessionRelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionRelated._val = b'\xb2'
    
    #-----< callSessionUnrelated >-----#
    callSessionUnrelated = OCT_STR(name='callSessionUnrelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionUnrelated._val = b'\xb3'
    
    #-----< plmnoperator >-----#
    plmnoperator = OCT_STR(name='plmnoperator', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmnoperator._val = b'\xb4'
    
    #-----< serviceType >-----#
    serviceType = OCT_STR(name='serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    serviceType._val = b'\xb5'
    
    #-----< allMOLR-SS >-----#
    allMOLR_SS = OCT_STR(name='allMOLR-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMOLR_SS._val = b'\xc0'
    
    #-----< basicSelfLocation >-----#
    basicSelfLocation = OCT_STR(name='basicSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    basicSelfLocation._val = b'\xc1'
    
    #-----< autonomousSelfLocation >-----#
    autonomousSelfLocation = OCT_STR(name='autonomousSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    autonomousSelfLocation._val = b'\xc2'
    
    #-----< transferToThirdParty >-----#
    transferToThirdParty = OCT_STR(name='transferToThirdParty', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    transferToThirdParty._val = b'\xc3'
    
    _all_ = [
        SS_Code,
        allSS,
        allLineIdentificationSS,
        clip,
        clir,
        colp,
        colr,
        mci,
        allNameIdentificationSS,
        cnap,
        allForwardingSS,
        cfu,
        allCondForwardingSS,
        cfb,
        cfnry,
        cfnrc,
        cd,
        allCallOfferingSS,
        ect,
        mah,
        allCallCompletionSS,
        cw,
        hold,
        ccbs_A,
        ccbs_B,
        mc,
        allMultiPartySS,
        multiPTY,
        allCommunityOfInterest_SS,
        cug,
        allChargingSS,
        aoci,
        aocc,
        allAdditionalInfoTransferSS,
        uus1,
        uus2,
        uus3,
        allBarringSS,
        barringOfOutgoingCalls,
        baoc,
        boic,
        boicExHC,
        barringOfIncomingCalls,
        baic,
        bicRoam,
        allPLMN_specificSS,
        plmn_specificSS_1,
        plmn_specificSS_2,
        plmn_specificSS_3,
        plmn_specificSS_4,
        plmn_specificSS_5,
        plmn_specificSS_6,
        plmn_specificSS_7,
        plmn_specificSS_8,
        plmn_specificSS_9,
        plmn_specificSS_A,
        plmn_specificSS_B,
        plmn_specificSS_C,
        plmn_specificSS_D,
        plmn_specificSS_E,
        plmn_specificSS_F,
        allCallPrioritySS,
        emlpp,
        allLCSPrivacyException,
        universal,
        callSessionRelated,
        callSessionUnrelated,
        plmnoperator,
        serviceType,
        allMOLR_SS,
        basicSelfLocation,
        autonomousSelfLocation,
        transferToThirdParty,
    ]

class MAP_CommonDataTypes:

    _name_  = 'MAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 18, 19]
    
    _obj_ = [
        'TBCD-STRING',
        'DiameterIdentity',
        'AddressString',
        'maxAddressLength',
        'ISDN-AddressString',
        'maxISDN-AddressLength',
        'FTN-AddressString',
        'maxFTN-AddressLength',
        'ISDN-SubaddressString',
        'maxISDN-SubaddressLength',
        'ExternalSignalInfo',
        'SignalInfo',
        'maxSignalInfoLength',
        'ProtocolId',
        'Ext-ExternalSignalInfo',
        'Ext-ProtocolId',
        'AccessNetworkSignalInfo',
        'LongSignalInfo',
        'maxLongSignalInfoLength',
        'AccessNetworkProtocolId',
        'AlertingPattern',
        'alertingLevel-0',
        'alertingLevel-1',
        'alertingLevel-2',
        'alertingCategory-1',
        'alertingCategory-2',
        'alertingCategory-3',
        'alertingCategory-4',
        'alertingCategory-5',
        'GSN-Address',
        'Time',
        'IMSI',
        'Identity',
        'IMSI-WithLMSI',
        'ASCI-CallReference',
        'TMSI',
        'SubscriberId',
        'IMEI',
        'HLR-Id',
        'HLR-List',
        'maxNumOfHLR-Id',
        'LMSI',
        'GlobalCellId',
        'NetworkResource',
        'AdditionalNetworkResource',
        'NAEA-PreferredCI',
        'NAEA-CIC',
        'SubscriberIdentity',
        'LCSClientExternalID',
        'LCSClientInternalID',
        'LCSServiceTypeID',
        'emergencyServices',
        'emergencyAlertServices',
        'personTracking',
        'fleetManagement',
        'assetManagement',
        'trafficCongestionReporting',
        'roadsideAssistance',
        'routingToNearestCommercialEnterprise',
        'navigation',
        'citySightseeing',
        'localizedAdvertising',
        'mobileYellowPages',
        'trafficAndPublicTransportationInfo',
        'weather',
        'assetAndServiceFinding',
        'gaming',
        'findYourFriend',
        'dating',
        'chatting',
        'routeFinding',
        'whereAmI',
        'serv64',
        'serv65',
        'serv66',
        'serv67',
        'serv68',
        'serv69',
        'serv70',
        'serv71',
        'serv72',
        'serv73',
        'serv74',
        'serv75',
        'serv76',
        'serv77',
        'serv78',
        'serv79',
        'serv80',
        'serv81',
        'serv82',
        'serv83',
        'serv84',
        'serv85',
        'serv86',
        'serv87',
        'serv88',
        'serv89',
        'serv90',
        'serv91',
        'serv92',
        'serv93',
        'serv94',
        'serv95',
        'serv96',
        'serv97',
        'serv98',
        'serv99',
        'serv100',
        'serv101',
        'serv102',
        'serv103',
        'serv104',
        'serv105',
        'serv106',
        'serv107',
        'serv108',
        'serv109',
        'serv110',
        'serv111',
        'serv112',
        'serv113',
        'serv114',
        'serv115',
        'serv116',
        'serv117',
        'serv118',
        'serv119',
        'serv120',
        'serv121',
        'serv122',
        'serv123',
        'serv124',
        'serv125',
        'serv126',
        'serv127',
        'PLMN-Id',
        'E-UTRAN-CGI',
        'NR-CGI',
        'TA-Id',
        'NR-TA-Id',
        'RAIdentity',
        'NetworkNodeDiameterAddress',
        'CellGlobalIdOrServiceAreaIdOrLAI',
        'CellGlobalIdOrServiceAreaIdFixedLength',
        'LAIFixedLength',
        'BasicServiceCode',
        'Ext-BasicServiceCode',
        'EMLPP-Info',
        'EMLPP-Priority',
        'priorityLevelA',
        'priorityLevelB',
        'priorityLevel0',
        'priorityLevel1',
        'priorityLevel2',
        'priorityLevel3',
        'priorityLevel4',
        'MC-SS-Info',
        'MaxMC-Bearers',
        'MC-Bearers',
        'maxNumOfMC-Bearers',
        'Ext-SS-Status',
        'AgeOfLocationInformation',
        ]
    _type_ = [
        'TBCD-STRING',
        'DiameterIdentity',
        'AddressString',
        'ISDN-AddressString',
        'FTN-AddressString',
        'ISDN-SubaddressString',
        'ExternalSignalInfo',
        'SignalInfo',
        'ProtocolId',
        'Ext-ExternalSignalInfo',
        'Ext-ProtocolId',
        'AccessNetworkSignalInfo',
        'LongSignalInfo',
        'AccessNetworkProtocolId',
        'AlertingPattern',
        'GSN-Address',
        'Time',
        'IMSI',
        'Identity',
        'IMSI-WithLMSI',
        'ASCI-CallReference',
        'TMSI',
        'SubscriberId',
        'IMEI',
        'HLR-Id',
        'HLR-List',
        'LMSI',
        'GlobalCellId',
        'NetworkResource',
        'AdditionalNetworkResource',
        'NAEA-PreferredCI',
        'NAEA-CIC',
        'SubscriberIdentity',
        'LCSClientExternalID',
        'LCSClientInternalID',
        'LCSServiceTypeID',
        'PLMN-Id',
        'E-UTRAN-CGI',
        'NR-CGI',
        'TA-Id',
        'NR-TA-Id',
        'RAIdentity',
        'NetworkNodeDiameterAddress',
        'CellGlobalIdOrServiceAreaIdOrLAI',
        'CellGlobalIdOrServiceAreaIdFixedLength',
        'LAIFixedLength',
        'BasicServiceCode',
        'Ext-BasicServiceCode',
        'EMLPP-Info',
        'EMLPP-Priority',
        'MC-SS-Info',
        'MaxMC-Bearers',
        'MC-Bearers',
        'Ext-SS-Status',
        'AgeOfLocationInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxAddressLength',
        'maxISDN-AddressLength',
        'maxFTN-AddressLength',
        'maxISDN-SubaddressLength',
        'maxSignalInfoLength',
        'maxLongSignalInfoLength',
        'alertingLevel-0',
        'alertingLevel-1',
        'alertingLevel-2',
        'alertingCategory-1',
        'alertingCategory-2',
        'alertingCategory-3',
        'alertingCategory-4',
        'alertingCategory-5',
        'maxNumOfHLR-Id',
        'emergencyServices',
        'emergencyAlertServices',
        'personTracking',
        'fleetManagement',
        'assetManagement',
        'trafficCongestionReporting',
        'roadsideAssistance',
        'routingToNearestCommercialEnterprise',
        'navigation',
        'citySightseeing',
        'localizedAdvertising',
        'mobileYellowPages',
        'trafficAndPublicTransportationInfo',
        'weather',
        'assetAndServiceFinding',
        'gaming',
        'findYourFriend',
        'dating',
        'chatting',
        'routeFinding',
        'whereAmI',
        'serv64',
        'serv65',
        'serv66',
        'serv67',
        'serv68',
        'serv69',
        'serv70',
        'serv71',
        'serv72',
        'serv73',
        'serv74',
        'serv75',
        'serv76',
        'serv77',
        'serv78',
        'serv79',
        'serv80',
        'serv81',
        'serv82',
        'serv83',
        'serv84',
        'serv85',
        'serv86',
        'serv87',
        'serv88',
        'serv89',
        'serv90',
        'serv91',
        'serv92',
        'serv93',
        'serv94',
        'serv95',
        'serv96',
        'serv97',
        'serv98',
        'serv99',
        'serv100',
        'serv101',
        'serv102',
        'serv103',
        'serv104',
        'serv105',
        'serv106',
        'serv107',
        'serv108',
        'serv109',
        'serv110',
        'serv111',
        'serv112',
        'serv113',
        'serv114',
        'serv115',
        'serv116',
        'serv117',
        'serv118',
        'serv119',
        'serv120',
        'serv121',
        'serv122',
        'serv123',
        'serv124',
        'serv125',
        'serv126',
        'serv127',
        'priorityLevelA',
        'priorityLevelB',
        'priorityLevel0',
        'priorityLevel1',
        'priorityLevel2',
        'priorityLevel3',
        'priorityLevel4',
        'maxNumOfMC-Bearers',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name='TBCD-STRING', mode=MODE_TYPE)
    
    #-----< DiameterIdentity >-----#
    DiameterIdentity = OCT_STR(name='DiameterIdentity', mode=MODE_TYPE)
    DiameterIdentity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< AddressString >-----#
    AddressString = OCT_STR(name='AddressString', mode=MODE_TYPE)
    AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxAddressLength >-----#
    maxAddressLength = INT(name='maxAddressLength', mode=MODE_VALUE)
    maxAddressLength._val = 20
    
    #-----< ISDN-AddressString >-----#
    ISDN_AddressString = OCT_STR(name='ISDN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    ISDN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxISDN-AddressLength >-----#
    maxISDN_AddressLength = INT(name='maxISDN-AddressLength', mode=MODE_VALUE)
    maxISDN_AddressLength._val = 9
    
    #-----< FTN-AddressString >-----#
    FTN_AddressString = OCT_STR(name='FTN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    FTN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxFTN-AddressLength >-----#
    maxFTN_AddressLength = INT(name='maxFTN-AddressLength', mode=MODE_VALUE)
    maxFTN_AddressLength._val = 15
    
    #-----< ISDN-SubaddressString >-----#
    ISDN_SubaddressString = OCT_STR(name='ISDN-SubaddressString', mode=MODE_TYPE)
    ISDN_SubaddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=21)], ev=None, er=[])
    
    #-----< maxISDN-SubaddressLength >-----#
    maxISDN_SubaddressLength = INT(name='maxISDN-SubaddressLength', mode=MODE_VALUE)
    maxISDN_SubaddressLength._val = 21
    
    #-----< ExternalSignalInfo >-----#
    ExternalSignalInfo = SEQ(name='ExternalSignalInfo', mode=MODE_TYPE)
    _ExternalSignalInfo_protocolId = ENUM(name='protocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ProtocolId')))
    _ExternalSignalInfo_signalInfo = OCT_STR(name='signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _ExternalSignalInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalSignalInfo._cont = ASN1Dict([
        ('protocolId', _ExternalSignalInfo_protocolId),
        ('signalInfo', _ExternalSignalInfo_signalInfo),
        ('extensionContainer', _ExternalSignalInfo_extensionContainer),
        ])
    ExternalSignalInfo._ext = []
    
    #-----< SignalInfo >-----#
    SignalInfo = OCT_STR(name='SignalInfo', mode=MODE_TYPE)
    SignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    
    #-----< maxSignalInfoLength >-----#
    maxSignalInfoLength = INT(name='maxSignalInfoLength', mode=MODE_VALUE)
    maxSignalInfoLength._val = 200
    
    #-----< ProtocolId >-----#
    ProtocolId = ENUM(name='ProtocolId', mode=MODE_TYPE)
    ProtocolId._cont = ASN1Dict([('gsm-0408', 1), ('gsm-0806', 2), ('gsm-BSSMAP', 3), ('ets-300102-1', 4)])
    ProtocolId._ext = None
    
    #-----< Ext-ExternalSignalInfo >-----#
    Ext_ExternalSignalInfo = SEQ(name='Ext-ExternalSignalInfo', mode=MODE_TYPE)
    _Ext_ExternalSignalInfo_ext_ProtocolId = ENUM(name='ext-ProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ProtocolId')))
    _Ext_ExternalSignalInfo_signalInfo = OCT_STR(name='signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _Ext_ExternalSignalInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ExternalSignalInfo._cont = ASN1Dict([
        ('ext-ProtocolId', _Ext_ExternalSignalInfo_ext_ProtocolId),
        ('signalInfo', _Ext_ExternalSignalInfo_signalInfo),
        ('extensionContainer', _Ext_ExternalSignalInfo_extensionContainer),
        ])
    Ext_ExternalSignalInfo._ext = []
    
    #-----< Ext-ProtocolId >-----#
    Ext_ProtocolId = ENUM(name='Ext-ProtocolId', mode=MODE_TYPE)
    Ext_ProtocolId._cont = ASN1Dict([('ets-300356', 1)])
    Ext_ProtocolId._ext = []
    
    #-----< AccessNetworkSignalInfo >-----#
    AccessNetworkSignalInfo = SEQ(name='AccessNetworkSignalInfo', mode=MODE_TYPE)
    _AccessNetworkSignalInfo_accessNetworkProtocolId = ENUM(name='accessNetworkProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkProtocolId')))
    _AccessNetworkSignalInfo_signalInfo = OCT_STR(name='signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LongSignalInfo')))
    _AccessNetworkSignalInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AccessNetworkSignalInfo._cont = ASN1Dict([
        ('accessNetworkProtocolId', _AccessNetworkSignalInfo_accessNetworkProtocolId),
        ('signalInfo', _AccessNetworkSignalInfo_signalInfo),
        ('extensionContainer', _AccessNetworkSignalInfo_extensionContainer),
        ])
    AccessNetworkSignalInfo._ext = []
    
    #-----< LongSignalInfo >-----#
    LongSignalInfo = OCT_STR(name='LongSignalInfo', mode=MODE_TYPE)
    LongSignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2560)], ev=None, er=[])
    
    #-----< maxLongSignalInfoLength >-----#
    maxLongSignalInfoLength = INT(name='maxLongSignalInfoLength', mode=MODE_VALUE)
    maxLongSignalInfoLength._val = 2560
    
    #-----< AccessNetworkProtocolId >-----#
    AccessNetworkProtocolId = ENUM(name='AccessNetworkProtocolId', mode=MODE_TYPE)
    AccessNetworkProtocolId._cont = ASN1Dict([('ts3G-48006', 1), ('ts3G-25413', 2)])
    AccessNetworkProtocolId._ext = []
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name='AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< alertingLevel-0 >-----#
    alertingLevel_0 = OCT_STR(name='alertingLevel-0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_0._val = b'\x00'
    
    #-----< alertingLevel-1 >-----#
    alertingLevel_1 = OCT_STR(name='alertingLevel-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_1._val = b'\x01'
    
    #-----< alertingLevel-2 >-----#
    alertingLevel_2 = OCT_STR(name='alertingLevel-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_2._val = b'\x02'
    
    #-----< alertingCategory-1 >-----#
    alertingCategory_1 = OCT_STR(name='alertingCategory-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_1._val = b'\x04'
    
    #-----< alertingCategory-2 >-----#
    alertingCategory_2 = OCT_STR(name='alertingCategory-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_2._val = b'\x05'
    
    #-----< alertingCategory-3 >-----#
    alertingCategory_3 = OCT_STR(name='alertingCategory-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_3._val = b'\x06'
    
    #-----< alertingCategory-4 >-----#
    alertingCategory_4 = OCT_STR(name='alertingCategory-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_4._val = b'\x07'
    
    #-----< alertingCategory-5 >-----#
    alertingCategory_5 = OCT_STR(name='alertingCategory-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_5._val = b'\x08'
    
    #-----< GSN-Address >-----#
    GSN_Address = OCT_STR(name='GSN-Address', mode=MODE_TYPE)
    GSN_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    
    #-----< Time >-----#
    Time = OCT_STR(name='Time', mode=MODE_TYPE)
    Time._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name='IMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< Identity >-----#
    Identity = CHOICE(name='Identity', mode=MODE_TYPE)
    _Identity_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _Identity_imsi_WithLMSI = SEQ(name='imsi-WithLMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI-WithLMSI')))
    Identity._cont = ASN1Dict([
        ('imsi', _Identity_imsi),
        ('imsi-WithLMSI', _Identity_imsi_WithLMSI),
        ])
    Identity._ext = None
    
    #-----< IMSI-WithLMSI >-----#
    IMSI_WithLMSI = SEQ(name='IMSI-WithLMSI', mode=MODE_TYPE)
    _IMSI_WithLMSI_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IMSI_WithLMSI_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')))
    IMSI_WithLMSI._cont = ASN1Dict([
        ('imsi', _IMSI_WithLMSI_imsi),
        ('lmsi', _IMSI_WithLMSI_lmsi),
        ])
    IMSI_WithLMSI._ext = []
    
    #-----< ASCI-CallReference >-----#
    ASCI_CallReference = OCT_STR(name='ASCI-CallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    ASCI_CallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TMSI >-----#
    TMSI = OCT_STR(name='TMSI', mode=MODE_TYPE)
    TMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< SubscriberId >-----#
    SubscriberId = CHOICE(name='SubscriberId', mode=MODE_TYPE)
    _SubscriberId_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberId_tmsi = OCT_STR(name='tmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    SubscriberId._cont = ASN1Dict([
        ('imsi', _SubscriberId_imsi),
        ('tmsi', _SubscriberId_tmsi),
        ])
    SubscriberId._ext = None
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name='IMEI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HLR-Id >-----#
    HLR_Id = OCT_STR(name='HLR-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    
    #-----< HLR-List >-----#
    HLR_List = SEQ_OF(name='HLR-List', mode=MODE_TYPE)
    _HLR_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-Id')))
    HLR_List._cont = _HLR_List__item_
    HLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfHLR-Id >-----#
    maxNumOfHLR_Id = INT(name='maxNumOfHLR-Id', mode=MODE_VALUE)
    maxNumOfHLR_Id._val = 50
    
    #-----< LMSI >-----#
    LMSI = OCT_STR(name='LMSI', mode=MODE_TYPE)
    LMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GlobalCellId >-----#
    GlobalCellId = OCT_STR(name='GlobalCellId', mode=MODE_TYPE)
    GlobalCellId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< NetworkResource >-----#
    NetworkResource = ENUM(name='NetworkResource', mode=MODE_TYPE)
    NetworkResource._cont = ASN1Dict([('plmn', 0), ('hlr', 1), ('vlr', 2), ('pvlr', 3), ('controllingMSC', 4), ('vmsc', 5), ('eir', 6), ('rss', 7)])
    NetworkResource._ext = None
    
    #-----< AdditionalNetworkResource >-----#
    AdditionalNetworkResource = ENUM(name='AdditionalNetworkResource', mode=MODE_TYPE)
    AdditionalNetworkResource._cont = ASN1Dict([('sgsn', 0), ('ggsn', 1), ('gmlc', 2), ('gsmSCF', 3), ('nplr', 4), ('auc', 5), ('ue', 6), ('mme', 7)])
    AdditionalNetworkResource._ext = ['ue', 'mme']
    
    #-----< NAEA-PreferredCI >-----#
    NAEA_PreferredCI = SEQ(name='NAEA-PreferredCI', mode=MODE_TYPE)
    _NAEA_PreferredCI_naea_PreferredCIC = OCT_STR(name='naea-PreferredCIC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-CIC')))
    _NAEA_PreferredCI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NAEA_PreferredCI._cont = ASN1Dict([
        ('naea-PreferredCIC', _NAEA_PreferredCI_naea_PreferredCIC),
        ('extensionContainer', _NAEA_PreferredCI_extensionContainer),
        ])
    NAEA_PreferredCI._ext = []
    
    #-----< NAEA-CIC >-----#
    NAEA_CIC = OCT_STR(name='NAEA-CIC', mode=MODE_TYPE)
    NAEA_CIC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SubscriberIdentity >-----#
    SubscriberIdentity = CHOICE(name='SubscriberIdentity', mode=MODE_TYPE)
    _SubscriberIdentity_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberIdentity_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SubscriberIdentity._cont = ASN1Dict([
        ('imsi', _SubscriberIdentity_imsi),
        ('msisdn', _SubscriberIdentity_msisdn),
        ])
    SubscriberIdentity._ext = None
    
    #-----< LCSClientExternalID >-----#
    LCSClientExternalID = SEQ(name='LCSClientExternalID', mode=MODE_TYPE)
    _LCSClientExternalID_externalAddress = OCT_STR(name='externalAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LCSClientExternalID_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LCSClientExternalID._cont = ASN1Dict([
        ('externalAddress', _LCSClientExternalID_externalAddress),
        ('extensionContainer', _LCSClientExternalID_extensionContainer),
        ])
    LCSClientExternalID._ext = []
    
    #-----< LCSClientInternalID >-----#
    LCSClientInternalID = ENUM(name='LCSClientInternalID', mode=MODE_TYPE)
    LCSClientInternalID._cont = ASN1Dict([('broadcastService', 0), ('o-andM-HPLMN', 1), ('o-andM-VPLMN', 2), ('anonymousLocation', 3), ('targetMSsubscribedService', 4)])
    LCSClientInternalID._ext = []
    
    #-----< LCSServiceTypeID >-----#
    LCSServiceTypeID = INT(name='LCSServiceTypeID', mode=MODE_TYPE)
    LCSServiceTypeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< emergencyServices >-----#
    emergencyServices = INT(name='emergencyServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyServices._val = 0
    
    #-----< emergencyAlertServices >-----#
    emergencyAlertServices = INT(name='emergencyAlertServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyAlertServices._val = 1
    
    #-----< personTracking >-----#
    personTracking = INT(name='personTracking', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    personTracking._val = 2
    
    #-----< fleetManagement >-----#
    fleetManagement = INT(name='fleetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    fleetManagement._val = 3
    
    #-----< assetManagement >-----#
    assetManagement = INT(name='assetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetManagement._val = 4
    
    #-----< trafficCongestionReporting >-----#
    trafficCongestionReporting = INT(name='trafficCongestionReporting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficCongestionReporting._val = 5
    
    #-----< roadsideAssistance >-----#
    roadsideAssistance = INT(name='roadsideAssistance', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    roadsideAssistance._val = 6
    
    #-----< routingToNearestCommercialEnterprise >-----#
    routingToNearestCommercialEnterprise = INT(name='routingToNearestCommercialEnterprise', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routingToNearestCommercialEnterprise._val = 7
    
    #-----< navigation >-----#
    navigation = INT(name='navigation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    navigation._val = 8
    
    #-----< citySightseeing >-----#
    citySightseeing = INT(name='citySightseeing', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    citySightseeing._val = 9
    
    #-----< localizedAdvertising >-----#
    localizedAdvertising = INT(name='localizedAdvertising', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    localizedAdvertising._val = 10
    
    #-----< mobileYellowPages >-----#
    mobileYellowPages = INT(name='mobileYellowPages', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    mobileYellowPages._val = 11
    
    #-----< trafficAndPublicTransportationInfo >-----#
    trafficAndPublicTransportationInfo = INT(name='trafficAndPublicTransportationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficAndPublicTransportationInfo._val = 12
    
    #-----< weather >-----#
    weather = INT(name='weather', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    weather._val = 13
    
    #-----< assetAndServiceFinding >-----#
    assetAndServiceFinding = INT(name='assetAndServiceFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetAndServiceFinding._val = 14
    
    #-----< gaming >-----#
    gaming = INT(name='gaming', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    gaming._val = 15
    
    #-----< findYourFriend >-----#
    findYourFriend = INT(name='findYourFriend', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    findYourFriend._val = 16
    
    #-----< dating >-----#
    dating = INT(name='dating', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    dating._val = 17
    
    #-----< chatting >-----#
    chatting = INT(name='chatting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    chatting._val = 18
    
    #-----< routeFinding >-----#
    routeFinding = INT(name='routeFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routeFinding._val = 19
    
    #-----< whereAmI >-----#
    whereAmI = INT(name='whereAmI', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    whereAmI._val = 20
    
    #-----< serv64 >-----#
    serv64 = INT(name='serv64', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv64._val = 64
    
    #-----< serv65 >-----#
    serv65 = INT(name='serv65', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv65._val = 65
    
    #-----< serv66 >-----#
    serv66 = INT(name='serv66', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv66._val = 66
    
    #-----< serv67 >-----#
    serv67 = INT(name='serv67', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv67._val = 67
    
    #-----< serv68 >-----#
    serv68 = INT(name='serv68', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv68._val = 68
    
    #-----< serv69 >-----#
    serv69 = INT(name='serv69', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv69._val = 69
    
    #-----< serv70 >-----#
    serv70 = INT(name='serv70', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv70._val = 70
    
    #-----< serv71 >-----#
    serv71 = INT(name='serv71', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv71._val = 71
    
    #-----< serv72 >-----#
    serv72 = INT(name='serv72', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv72._val = 72
    
    #-----< serv73 >-----#
    serv73 = INT(name='serv73', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv73._val = 73
    
    #-----< serv74 >-----#
    serv74 = INT(name='serv74', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv74._val = 74
    
    #-----< serv75 >-----#
    serv75 = INT(name='serv75', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv75._val = 75
    
    #-----< serv76 >-----#
    serv76 = INT(name='serv76', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv76._val = 76
    
    #-----< serv77 >-----#
    serv77 = INT(name='serv77', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv77._val = 77
    
    #-----< serv78 >-----#
    serv78 = INT(name='serv78', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv78._val = 78
    
    #-----< serv79 >-----#
    serv79 = INT(name='serv79', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv79._val = 79
    
    #-----< serv80 >-----#
    serv80 = INT(name='serv80', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv80._val = 80
    
    #-----< serv81 >-----#
    serv81 = INT(name='serv81', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv81._val = 81
    
    #-----< serv82 >-----#
    serv82 = INT(name='serv82', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv82._val = 82
    
    #-----< serv83 >-----#
    serv83 = INT(name='serv83', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv83._val = 83
    
    #-----< serv84 >-----#
    serv84 = INT(name='serv84', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv84._val = 84
    
    #-----< serv85 >-----#
    serv85 = INT(name='serv85', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv85._val = 85
    
    #-----< serv86 >-----#
    serv86 = INT(name='serv86', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv86._val = 86
    
    #-----< serv87 >-----#
    serv87 = INT(name='serv87', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv87._val = 87
    
    #-----< serv88 >-----#
    serv88 = INT(name='serv88', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv88._val = 88
    
    #-----< serv89 >-----#
    serv89 = INT(name='serv89', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv89._val = 89
    
    #-----< serv90 >-----#
    serv90 = INT(name='serv90', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv90._val = 90
    
    #-----< serv91 >-----#
    serv91 = INT(name='serv91', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv91._val = 91
    
    #-----< serv92 >-----#
    serv92 = INT(name='serv92', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv92._val = 92
    
    #-----< serv93 >-----#
    serv93 = INT(name='serv93', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv93._val = 93
    
    #-----< serv94 >-----#
    serv94 = INT(name='serv94', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv94._val = 94
    
    #-----< serv95 >-----#
    serv95 = INT(name='serv95', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv95._val = 95
    
    #-----< serv96 >-----#
    serv96 = INT(name='serv96', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv96._val = 96
    
    #-----< serv97 >-----#
    serv97 = INT(name='serv97', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv97._val = 97
    
    #-----< serv98 >-----#
    serv98 = INT(name='serv98', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv98._val = 98
    
    #-----< serv99 >-----#
    serv99 = INT(name='serv99', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv99._val = 99
    
    #-----< serv100 >-----#
    serv100 = INT(name='serv100', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv100._val = 100
    
    #-----< serv101 >-----#
    serv101 = INT(name='serv101', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv101._val = 101
    
    #-----< serv102 >-----#
    serv102 = INT(name='serv102', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv102._val = 102
    
    #-----< serv103 >-----#
    serv103 = INT(name='serv103', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv103._val = 103
    
    #-----< serv104 >-----#
    serv104 = INT(name='serv104', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv104._val = 104
    
    #-----< serv105 >-----#
    serv105 = INT(name='serv105', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv105._val = 105
    
    #-----< serv106 >-----#
    serv106 = INT(name='serv106', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv106._val = 106
    
    #-----< serv107 >-----#
    serv107 = INT(name='serv107', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv107._val = 107
    
    #-----< serv108 >-----#
    serv108 = INT(name='serv108', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv108._val = 108
    
    #-----< serv109 >-----#
    serv109 = INT(name='serv109', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv109._val = 109
    
    #-----< serv110 >-----#
    serv110 = INT(name='serv110', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv110._val = 110
    
    #-----< serv111 >-----#
    serv111 = INT(name='serv111', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv111._val = 111
    
    #-----< serv112 >-----#
    serv112 = INT(name='serv112', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv112._val = 112
    
    #-----< serv113 >-----#
    serv113 = INT(name='serv113', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv113._val = 113
    
    #-----< serv114 >-----#
    serv114 = INT(name='serv114', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv114._val = 114
    
    #-----< serv115 >-----#
    serv115 = INT(name='serv115', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv115._val = 115
    
    #-----< serv116 >-----#
    serv116 = INT(name='serv116', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv116._val = 116
    
    #-----< serv117 >-----#
    serv117 = INT(name='serv117', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv117._val = 117
    
    #-----< serv118 >-----#
    serv118 = INT(name='serv118', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv118._val = 118
    
    #-----< serv119 >-----#
    serv119 = INT(name='serv119', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv119._val = 119
    
    #-----< serv120 >-----#
    serv120 = INT(name='serv120', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv120._val = 120
    
    #-----< serv121 >-----#
    serv121 = INT(name='serv121', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv121._val = 121
    
    #-----< serv122 >-----#
    serv122 = INT(name='serv122', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv122._val = 122
    
    #-----< serv123 >-----#
    serv123 = INT(name='serv123', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv123._val = 123
    
    #-----< serv124 >-----#
    serv124 = INT(name='serv124', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv124._val = 124
    
    #-----< serv125 >-----#
    serv125 = INT(name='serv125', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv125._val = 125
    
    #-----< serv126 >-----#
    serv126 = INT(name='serv126', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv126._val = 126
    
    #-----< serv127 >-----#
    serv127 = INT(name='serv127', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv127._val = 127
    
    #-----< PLMN-Id >-----#
    PLMN_Id = OCT_STR(name='PLMN-Id', mode=MODE_TYPE)
    PLMN_Id._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< E-UTRAN-CGI >-----#
    E_UTRAN_CGI = OCT_STR(name='E-UTRAN-CGI', mode=MODE_TYPE)
    E_UTRAN_CGI._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = OCT_STR(name='NR-CGI', mode=MODE_TYPE)
    NR_CGI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TA-Id >-----#
    TA_Id = OCT_STR(name='TA-Id', mode=MODE_TYPE)
    TA_Id._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< NR-TA-Id >-----#
    NR_TA_Id = OCT_STR(name='NR-TA-Id', mode=MODE_TYPE)
    NR_TA_Id._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< RAIdentity >-----#
    RAIdentity = OCT_STR(name='RAIdentity', mode=MODE_TYPE)
    RAIdentity._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< NetworkNodeDiameterAddress >-----#
    NetworkNodeDiameterAddress = SEQ(name='NetworkNodeDiameterAddress', mode=MODE_TYPE)
    _NetworkNodeDiameterAddress_diameter_Name = OCT_STR(name='diameter-Name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    _NetworkNodeDiameterAddress_diameter_Realm = OCT_STR(name='diameter-Realm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    NetworkNodeDiameterAddress._cont = ASN1Dict([
        ('diameter-Name', _NetworkNodeDiameterAddress_diameter_Name),
        ('diameter-Realm', _NetworkNodeDiameterAddress_diameter_Realm),
        ])
    NetworkNodeDiameterAddress._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdOrLAI >-----#
    CellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name='CellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE)
    _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name='cellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength = OCT_STR(name='laiFixedLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    CellGlobalIdOrServiceAreaIdOrLAI._cont = ASN1Dict([
        ('cellGlobalIdOrServiceAreaIdFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength),
        ('laiFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength),
        ])
    CellGlobalIdOrServiceAreaIdOrLAI._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdFixedLength >-----#
    CellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name='CellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE)
    CellGlobalIdOrServiceAreaIdFixedLength._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< LAIFixedLength >-----#
    LAIFixedLength = OCT_STR(name='LAIFixedLength', mode=MODE_TYPE)
    LAIFixedLength._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< BasicServiceCode >-----#
    BasicServiceCode = CHOICE(name='BasicServiceCode', mode=MODE_TYPE)
    _BasicServiceCode_bearerService = OCT_STR(name='bearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    _BasicServiceCode_teleservice = OCT_STR(name='teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    BasicServiceCode._cont = ASN1Dict([
        ('bearerService', _BasicServiceCode_bearerService),
        ('teleservice', _BasicServiceCode_teleservice),
        ])
    BasicServiceCode._ext = None
    
    #-----< Ext-BasicServiceCode >-----#
    Ext_BasicServiceCode = CHOICE(name='Ext-BasicServiceCode', mode=MODE_TYPE)
    _Ext_BasicServiceCode_ext_BearerService = OCT_STR(name='ext-BearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    _Ext_BasicServiceCode_ext_Teleservice = OCT_STR(name='ext-Teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    Ext_BasicServiceCode._cont = ASN1Dict([
        ('ext-BearerService', _Ext_BasicServiceCode_ext_BearerService),
        ('ext-Teleservice', _Ext_BasicServiceCode_ext_Teleservice),
        ])
    Ext_BasicServiceCode._ext = None
    
    #-----< EMLPP-Info >-----#
    EMLPP_Info = SEQ(name='EMLPP-Info', mode=MODE_TYPE)
    _EMLPP_Info_maximumentitledPriority = INT(name='maximumentitledPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EMLPP_Info._cont = ASN1Dict([
        ('maximumentitledPriority', _EMLPP_Info_maximumentitledPriority),
        ('defaultPriority', _EMLPP_Info_defaultPriority),
        ('extensionContainer', _EMLPP_Info_extensionContainer),
        ])
    EMLPP_Info._ext = []
    
    #-----< EMLPP-Priority >-----#
    EMLPP_Priority = INT(name='EMLPP-Priority', mode=MODE_TYPE)
    EMLPP_Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< priorityLevelA >-----#
    priorityLevelA = INT(name='priorityLevelA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelA._val = 6
    
    #-----< priorityLevelB >-----#
    priorityLevelB = INT(name='priorityLevelB', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelB._val = 5
    
    #-----< priorityLevel0 >-----#
    priorityLevel0 = INT(name='priorityLevel0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel0._val = 0
    
    #-----< priorityLevel1 >-----#
    priorityLevel1 = INT(name='priorityLevel1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel1._val = 1
    
    #-----< priorityLevel2 >-----#
    priorityLevel2 = INT(name='priorityLevel2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel2._val = 2
    
    #-----< priorityLevel3 >-----#
    priorityLevel3 = INT(name='priorityLevel3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel3._val = 3
    
    #-----< priorityLevel4 >-----#
    priorityLevel4 = INT(name='priorityLevel4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel4._val = 4
    
    #-----< MC-SS-Info >-----#
    MC_SS_Info = SEQ(name='MC-SS-Info', mode=MODE_TYPE)
    _MC_SS_Info_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MC_SS_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MC_SS_Info_nbrSB = INT(name='nbrSB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')))
    _MC_SS_Info_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')))
    _MC_SS_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MC_SS_Info._cont = ASN1Dict([
        ('ss-Code', _MC_SS_Info_ss_Code),
        ('ss-Status', _MC_SS_Info_ss_Status),
        ('nbrSB', _MC_SS_Info_nbrSB),
        ('nbrUser', _MC_SS_Info_nbrUser),
        ('extensionContainer', _MC_SS_Info_extensionContainer),
        ])
    MC_SS_Info._ext = []
    
    #-----< MaxMC-Bearers >-----#
    MaxMC_Bearers = INT(name='MaxMC-Bearers', mode=MODE_TYPE)
    MaxMC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=7)], ev=None, er=[])
    
    #-----< MC-Bearers >-----#
    MC_Bearers = INT(name='MC-Bearers', mode=MODE_TYPE)
    MC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< maxNumOfMC-Bearers >-----#
    maxNumOfMC_Bearers = INT(name='maxNumOfMC-Bearers', mode=MODE_VALUE)
    maxNumOfMC_Bearers._val = 7
    
    #-----< Ext-SS-Status >-----#
    Ext_SS_Status = OCT_STR(name='Ext-SS-Status', mode=MODE_TYPE)
    Ext_SS_Status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AgeOfLocationInformation >-----#
    AgeOfLocationInformation = INT(name='AgeOfLocationInformation', mode=MODE_TYPE)
    AgeOfLocationInformation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    _all_ = [
        TBCD_STRING,
        DiameterIdentity,
        AddressString,
        maxAddressLength,
        ISDN_AddressString,
        maxISDN_AddressLength,
        FTN_AddressString,
        maxFTN_AddressLength,
        ISDN_SubaddressString,
        maxISDN_SubaddressLength,
        _ExternalSignalInfo_protocolId,
        _ExternalSignalInfo_signalInfo,
        _ExternalSignalInfo_extensionContainer,
        ExternalSignalInfo,
        SignalInfo,
        maxSignalInfoLength,
        ProtocolId,
        _Ext_ExternalSignalInfo_ext_ProtocolId,
        _Ext_ExternalSignalInfo_signalInfo,
        _Ext_ExternalSignalInfo_extensionContainer,
        Ext_ExternalSignalInfo,
        Ext_ProtocolId,
        _AccessNetworkSignalInfo_accessNetworkProtocolId,
        _AccessNetworkSignalInfo_signalInfo,
        _AccessNetworkSignalInfo_extensionContainer,
        AccessNetworkSignalInfo,
        LongSignalInfo,
        maxLongSignalInfoLength,
        AccessNetworkProtocolId,
        AlertingPattern,
        alertingLevel_0,
        alertingLevel_1,
        alertingLevel_2,
        alertingCategory_1,
        alertingCategory_2,
        alertingCategory_3,
        alertingCategory_4,
        alertingCategory_5,
        GSN_Address,
        Time,
        IMSI,
        _Identity_imsi,
        _Identity_imsi_WithLMSI,
        Identity,
        _IMSI_WithLMSI_imsi,
        _IMSI_WithLMSI_lmsi,
        IMSI_WithLMSI,
        ASCI_CallReference,
        TMSI,
        _SubscriberId_imsi,
        _SubscriberId_tmsi,
        SubscriberId,
        IMEI,
        HLR_Id,
        _HLR_List__item_,
        HLR_List,
        maxNumOfHLR_Id,
        LMSI,
        GlobalCellId,
        NetworkResource,
        AdditionalNetworkResource,
        _NAEA_PreferredCI_naea_PreferredCIC,
        _NAEA_PreferredCI_extensionContainer,
        NAEA_PreferredCI,
        NAEA_CIC,
        _SubscriberIdentity_imsi,
        _SubscriberIdentity_msisdn,
        SubscriberIdentity,
        _LCSClientExternalID_externalAddress,
        _LCSClientExternalID_extensionContainer,
        LCSClientExternalID,
        LCSClientInternalID,
        LCSServiceTypeID,
        emergencyServices,
        emergencyAlertServices,
        personTracking,
        fleetManagement,
        assetManagement,
        trafficCongestionReporting,
        roadsideAssistance,
        routingToNearestCommercialEnterprise,
        navigation,
        citySightseeing,
        localizedAdvertising,
        mobileYellowPages,
        trafficAndPublicTransportationInfo,
        weather,
        assetAndServiceFinding,
        gaming,
        findYourFriend,
        dating,
        chatting,
        routeFinding,
        whereAmI,
        serv64,
        serv65,
        serv66,
        serv67,
        serv68,
        serv69,
        serv70,
        serv71,
        serv72,
        serv73,
        serv74,
        serv75,
        serv76,
        serv77,
        serv78,
        serv79,
        serv80,
        serv81,
        serv82,
        serv83,
        serv84,
        serv85,
        serv86,
        serv87,
        serv88,
        serv89,
        serv90,
        serv91,
        serv92,
        serv93,
        serv94,
        serv95,
        serv96,
        serv97,
        serv98,
        serv99,
        serv100,
        serv101,
        serv102,
        serv103,
        serv104,
        serv105,
        serv106,
        serv107,
        serv108,
        serv109,
        serv110,
        serv111,
        serv112,
        serv113,
        serv114,
        serv115,
        serv116,
        serv117,
        serv118,
        serv119,
        serv120,
        serv121,
        serv122,
        serv123,
        serv124,
        serv125,
        serv126,
        serv127,
        PLMN_Id,
        E_UTRAN_CGI,
        NR_CGI,
        TA_Id,
        NR_TA_Id,
        RAIdentity,
        _NetworkNodeDiameterAddress_diameter_Name,
        _NetworkNodeDiameterAddress_diameter_Realm,
        NetworkNodeDiameterAddress,
        _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength,
        _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength,
        CellGlobalIdOrServiceAreaIdOrLAI,
        CellGlobalIdOrServiceAreaIdFixedLength,
        LAIFixedLength,
        _BasicServiceCode_bearerService,
        _BasicServiceCode_teleservice,
        BasicServiceCode,
        _Ext_BasicServiceCode_ext_BearerService,
        _Ext_BasicServiceCode_ext_Teleservice,
        Ext_BasicServiceCode,
        _EMLPP_Info_maximumentitledPriority,
        _EMLPP_Info_defaultPriority,
        _EMLPP_Info_extensionContainer,
        EMLPP_Info,
        EMLPP_Priority,
        priorityLevelA,
        priorityLevelB,
        priorityLevel0,
        priorityLevel1,
        priorityLevel2,
        priorityLevel3,
        priorityLevel4,
        _MC_SS_Info_ss_Code,
        _MC_SS_Info_ss_Status,
        _MC_SS_Info_nbrSB,
        _MC_SS_Info_nbrUser,
        _MC_SS_Info_extensionContainer,
        MC_SS_Info,
        MaxMC_Bearers,
        MC_Bearers,
        maxNumOfMC_Bearers,
        Ext_SS_Status,
        AgeOfLocationInformation,
    ]

class MAP_ExtensionDataTypes:

    _name_  = 'MAP-ExtensionDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 21, 19]
    
    _obj_ = [
        'MAP-EXTENSION',
        'ExtensionContainer',
        'SLR-ArgExtensionContainer',
        'PrivateExtensionList',
        'PrivateExtension',
        'maxNumOfPrivateExtensions',
        'ExtensionSet',
        'PCS-Extensions',
        'SLR-Arg-PCS-Extensions',
        ]
    _type_ = [
        'MAP-EXTENSION',
        'ExtensionContainer',
        'SLR-ArgExtensionContainer',
        'PrivateExtensionList',
        'PrivateExtension',
        'PCS-Extensions',
        'SLR-Arg-PCS-Extensions',
        ]
    _set_ = [
        'ExtensionSet',
        ]
    _val_ = [
        'maxNumOfPrivateExtensions',
        ]
    _class_ = [
        'MAP-EXTENSION',
        'ExtensionSet',
        ]
    _param_ = [
        ]
    
    #-----< MAP-EXTENSION >-----#
    MAP_EXTENSION = CLASS(name='MAP-EXTENSION', mode=MODE_TYPE)
    _MAP_EXTENSION_ExtensionType = OPEN(name='ExtensionType', mode=MODE_TYPE, opt=True)
    _MAP_EXTENSION_extensionId = OID(name='extensionId', mode=MODE_VALUE)
    MAP_EXTENSION._cont = ASN1Dict([
        ('ExtensionType', _MAP_EXTENSION_ExtensionType),
        ('extensionId', _MAP_EXTENSION_extensionId),
        ])
    
    #-----< ExtensionContainer >-----#
    ExtensionContainer = SEQ(name='ExtensionContainer', mode=MODE_TYPE)
    _ExtensionContainer_privateExtensionList = SEQ_OF(name='privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _ExtensionContainer_pcs_Extensions = SEQ(name='pcs-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PCS-Extensions')), opt=True)
    ExtensionContainer._cont = ASN1Dict([
        ('privateExtensionList', _ExtensionContainer_privateExtensionList),
        ('pcs-Extensions', _ExtensionContainer_pcs_Extensions),
        ])
    ExtensionContainer._ext = []
    
    #-----< SLR-ArgExtensionContainer >-----#
    SLR_ArgExtensionContainer = SEQ(name='SLR-ArgExtensionContainer', mode=MODE_TYPE)
    _SLR_ArgExtensionContainer_privateExtensionList = SEQ_OF(name='privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions = SEQ(name='slr-Arg-PCS-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'SLR-Arg-PCS-Extensions')), opt=True)
    SLR_ArgExtensionContainer._cont = ASN1Dict([
        ('privateExtensionList', _SLR_ArgExtensionContainer_privateExtensionList),
        ('slr-Arg-PCS-Extensions', _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions),
        ])
    SLR_ArgExtensionContainer._ext = []
    
    #-----< PrivateExtensionList >-----#
    PrivateExtensionList = SEQ_OF(name='PrivateExtensionList', mode=MODE_TYPE)
    _PrivateExtensionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtension')))
    PrivateExtensionList._cont = _PrivateExtensionList__item_
    PrivateExtensionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< PrivateExtension >-----#
    PrivateExtension = SEQ(name='PrivateExtension', mode=MODE_TYPE)
    _PrivateExtension_extId = OID(name='extId', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), ['extensionId']))
    __PrivateExtension_extId_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extId._const_tab = __PrivateExtension_extId_tab
    _PrivateExtension_extId._const_tab_at = None
    _PrivateExtension_extId._const_tab_id = 'extensionId'
    _PrivateExtension_extType = OPEN(name='extType', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), ['ExtensionType']), opt=True)
    __PrivateExtension_extType_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extType._const_tab = __PrivateExtension_extType_tab
    _PrivateExtension_extType._const_tab_at = ('..', 'extId')
    _PrivateExtension_extType._const_tab_id = 'ExtensionType'
    PrivateExtension._cont = ASN1Dict([
        ('extId', _PrivateExtension_extId),
        ('extType', _PrivateExtension_extType),
        ])
    PrivateExtension._ext = None
    
    #-----< maxNumOfPrivateExtensions >-----#
    maxNumOfPrivateExtensions = INT(name='maxNumOfPrivateExtensions', mode=MODE_VALUE)
    maxNumOfPrivateExtensions._val = 10
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name='ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCS-Extensions >-----#
    PCS_Extensions = SEQ(name='PCS-Extensions', mode=MODE_TYPE)
    PCS_Extensions._cont = ASN1Dict([
        ])
    PCS_Extensions._ext = []
    
    #-----< SLR-Arg-PCS-Extensions >-----#
    SLR_Arg_PCS_Extensions = SEQ(name='SLR-Arg-PCS-Extensions', mode=MODE_TYPE)
    _SLR_Arg_PCS_Extensions_na_ESRK_Request = NULL(name='na-ESRK-Request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SLR_Arg_PCS_Extensions._cont = ASN1Dict([
        ('na-ESRK-Request', _SLR_Arg_PCS_Extensions_na_ESRK_Request),
        ])
    SLR_Arg_PCS_Extensions._ext = ['na-ESRK-Request']
    
    _all_ = [
        _MAP_EXTENSION_ExtensionType,
        _MAP_EXTENSION_extensionId,
        MAP_EXTENSION,
        _ExtensionContainer_privateExtensionList,
        _ExtensionContainer_pcs_Extensions,
        ExtensionContainer,
        _SLR_ArgExtensionContainer_privateExtensionList,
        _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions,
        SLR_ArgExtensionContainer,
        _PrivateExtensionList__item_,
        PrivateExtensionList,
        __PrivateExtension_extId_tab,
        _PrivateExtension_extId,
        __PrivateExtension_extType_tab,
        _PrivateExtension_extType,
        PrivateExtension,
        maxNumOfPrivateExtensions,
        ExtensionSet,
        PCS_Extensions,
        _SLR_Arg_PCS_Extensions_na_ESRK_Request,
        SLR_Arg_PCS_Extensions,
    ]

class MAP_MS_DataTypes:

    _name_  = 'MAP-MS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 11, 19]
    
    _obj_ = [
        'UpdateLocationArg',
        'VLR-Capability',
        'SupportedRAT-Types',
        'SuperChargerInfo',
        'AgeIndicator',
        'IST-SupportIndicator',
        'SupportedLCS-CapabilitySets',
        'UpdateLocationRes',
        'ADD-Info',
        'PagingArea',
        'LocationArea',
        'LAC',
        'CancelLocationArg',
        'TypeOfUpdate',
        'CancellationType',
        'CancelLocationRes',
        'PurgeMS-Arg',
        'PurgeMS-Res',
        'SendIdentificationArg',
        'HopCounter',
        'SendIdentificationRes',
        'AuthenticationSetList',
        'TripletList',
        'QuintupletList',
        'AuthenticationTriplet',
        'AuthenticationQuintuplet',
        'CurrentSecurityContext',
        'GSM-SecurityContextData',
        'UMTS-SecurityContextData',
        'RAND',
        'SRES',
        'Kc',
        'XRES',
        'CK',
        'IK',
        'AUTN',
        'AUTS',
        'Cksn',
        'KSI',
        'AuthenticationFailureReportArg',
        'AccessType',
        'AuthenticationFailureReportRes',
        'FailureCause',
        'UpdateGprsLocationArg',
        'SMSRegisterRequest',
        'Used-RAT-Type',
        'EPS-Info',
        'PDN-GW-Update',
        'ISR-Information',
        'SGSN-Capability',
        'SupportedFeatures',
        'Ext-SupportedFeatures',
        'UE-SRVCC-Capability',
        'UpdateGprsLocationRes',
        'EPLMN-List',
        'AdjacentPLMN-List',
        'ForwardAccessSignalling-Arg',
        'AllowedGSM-Algorithms',
        'AllowedUMTS-Algorithms',
        'PermittedIntegrityProtectionAlgorithms',
        'maxPermittedIntegrityProtectionAlgorithmsLength',
        'PermittedEncryptionAlgorithms',
        'maxPermittedEncryptionAlgorithmsLength',
        'KeyStatus',
        'PrepareHO-Arg',
        'LCLS-GlobalCallReference',
        'LCLS-Negotiation',
        'LCLS-ConfigurationPreference',
        'BSSMAP-ServiceHandoverList',
        'BSSMAP-ServiceHandoverInfo',
        'maxNumOfServiceHandovers',
        'BSSMAP-ServiceHandover',
        'RANAP-ServiceHandover',
        'RadioResourceList',
        'RadioResource',
        'maxNumOfRadioResources',
        'PrepareHO-Res',
        'SelectedUMTS-Algorithms',
        'ChosenIntegrityProtectionAlgorithm',
        'ChosenEncryptionAlgorithm',
        'ChosenRadioResourceInformation',
        'ChosenChannelInfo',
        'ChosenSpeechVersion',
        'PrepareSubsequentHO-Arg',
        'PrepareSubsequentHO-Res',
        'ProcessAccessSignalling-Arg',
        'AoIPCodecsList',
        'AoIPCodec',
        'SupportedCodecsList',
        'CodecList',
        'Codec',
        'GERAN-Classmark',
        'SelectedGSM-Algorithm',
        'SendEndSignal-Arg',
        'SendEndSignal-Res',
        'RNCId',
        'RelocationNumberList',
        'MulticallBearerInfo',
        'RelocationNumber',
        'RAB-Id',
        'maxNrOfRABs',
        'maxNumOfRelocationNumber',
        'RadioResourceInformation',
        'IntegrityProtectionInformation',
        'maxNumOfIntegrityInfo',
        'EncryptionInformation',
        'maxNumOfEncryptionInfo',
        'SendAuthenticationInfoArg',
        'NumberOfRequestedVectors',
        'Re-synchronisationInfo',
        'SendAuthenticationInfoRes',
        'EPS-AuthenticationSetList',
        'UE-UsageType',
        'EPC-AV',
        'KASME',
        'RequestingNodeType',
        'CheckIMEI-Arg',
        'CheckIMEI-Res',
        'RequestedEquipmentInfo',
        'UESBI-Iu',
        'UESBI-IuA',
        'UESBI-IuB',
        'EquipmentStatus',
        'InsertSubscriberDataArg',
        'EDRX-Cycle-Length-List',
        'EDRX-Cycle-Length',
        'EDRX-Cycle-Length-Value',
        'Reset-Id-List',
        'Reset-Id',
        'DL-Buffering-Suggested-Packet-Count',
        'Group-Service-ID',
        'Local-GroupID',
        'IMSI-GroupIdList',
        'IMSI-GroupId',
        'SubscribedPeriodicRAUTAUtimer',
        'SubscribedPeriodicLAUtimer',
        'CSG-SubscriptionDataList',
        'CSG-SubscriptionData',
        'VPLMN-CSG-SubscriptionDataList',
        'CSG-Id',
        'LIPA-AllowedAPNList',
        'maxNumOfLIPAAllowedAPN',
        'EPS-SubscriptionData',
        'APN-OI-Replacement',
        'RFSP-ID',
        'APN-ConfigurationProfile',
        'EPS-DataList',
        'maxNumOfAPN-Configurations',
        'APN-Configuration',
        'PDN-ConnectionContinuity',
        'NIDD-Mechanism',
        'PDN-Type',
        'EPS-QoS-Subscribed',
        'AMBR',
        'SpecificAPNInfoList',
        'maxNumOfSpecificAPNInfos',
        'SpecificAPNInfo',
        'Bandwidth',
        'BandwidthExt',
        'QoS-Class-Identifier',
        'Allocation-Retention-Priority',
        'PDN-GW-Identity',
        'FQDN',
        'PDN-GW-AllocationType',
        'WLAN-Offloadability',
        'WLAN-Offloadability-Indication',
        'AccessRestrictionData',
        'Ext-AccessRestrictionData',
        'AdjacentAccessRestrictionDataList',
        'AdjacentAccessRestrictionData',
        'CS-AllocationRetentionPriority',
        'IST-AlertTimerValue',
        'LCSInformation',
        'GMLC-List',
        'maxNumOfGMLC',
        'NetworkAccessMode',
        'GPRSDataList',
        'maxNumOfPDP-Contexts',
        'PDP-Context',
        'Restoration-Priority',
        'SIPTO-Permission',
        'SIPTO-Local-Network-Permission',
        'LIPA-Permission',
        'ContextId',
        'GPRSSubscriptionData',
        'SGSN-CAMEL-SubscriptionInfo',
        'GPRS-CSI',
        'GPRS-CamelTDPDataList',
        'GPRS-CamelTDPData',
        'DefaultGPRS-Handling',
        'GPRS-TriggerDetectionPoint',
        'APN',
        'PDP-Type',
        'Ext-PDP-Type',
        'PDP-Address',
        'QoS-Subscribed',
        'Ext-QoS-Subscribed',
        'Ext2-QoS-Subscribed',
        'Ext3-QoS-Subscribed',
        'Ext4-QoS-Subscribed',
        'ChargingCharacteristics',
        'LSAOnlyAccessIndicator',
        'LSADataList',
        'maxNumOfLSAs',
        'LSAData',
        'LSAInformation',
        'LSAIdentity',
        'LSAAttributes',
        'SubscriberData',
        'Category',
        'SubscriberStatus',
        'BearerServiceList',
        'maxNumOfBearerServices',
        'TeleserviceList',
        'maxNumOfTeleservices',
        'ODB-Data',
        'ODB-GeneralData',
        'ODB-HPLMN-Data',
        'Ext-SS-InfoList',
        'Ext-SS-Info',
        'Ext-ForwInfo',
        'Ext-ForwFeatureList',
        'Ext-ForwFeature',
        'Ext-ForwOptions',
        'Ext-NoRepCondTime',
        'Ext-CallBarInfo',
        'Ext-CallBarFeatureList',
        'Ext-CallBarringFeature',
        'CUG-Info',
        'CUG-SubscriptionList',
        'CUG-Subscription',
        'CUG-Index',
        'CUG-Interlock',
        'IntraCUG-Options',
        'maxNumOfCUG',
        'CUG-FeatureList',
        'Ext-BasicServiceGroupList',
        'maxNumOfExt-BasicServiceGroups',
        'CUG-Feature',
        'InterCUG-Restrictions',
        'Ext-SS-Data',
        'LCS-PrivacyExceptionList',
        'maxNumOfPrivacyClass',
        'LCS-PrivacyClass',
        'ExternalClientList',
        'maxNumOfExternalClient',
        'PLMNClientList',
        'maxNumOfPLMNClient',
        'Ext-ExternalClientList',
        'maxNumOfExt-ExternalClient',
        'ExternalClient',
        'GMLC-Restriction',
        'NotificationToMSUser',
        'ServiceTypeList',
        'maxNumOfServiceType',
        'ServiceType',
        'MOLR-List',
        'maxNumOfMOLR-Class',
        'MOLR-Class',
        'ZoneCodeList',
        'ZoneCode',
        'maxNumOfZoneCodes',
        'InsertSubscriberDataRes',
        'RegionalSubscriptionResponse',
        'DeleteSubscriberDataArg',
        'SpecificCSI-Withdraw',
        'GPRSSubscriptionDataWithdraw',
        'EPS-SubscriptionDataWithdraw',
        'ContextIdList',
        'LSAInformationWithdraw',
        'LSAIdentityList',
        'BasicServiceList',
        'maxNumOfBasicServices',
        'DeleteSubscriberDataRes',
        'VlrCamelSubscriptionInfo',
        'MT-smsCAMELTDP-CriteriaList',
        'MT-smsCAMELTDP-Criteria',
        'TPDU-TypeCriterion',
        'maxNumOfTPDUTypes',
        'MT-SMS-TPDU-Type',
        'D-CSI',
        'DP-AnalysedInfoCriteriaList',
        'maxNumOfDP-AnalysedInfoCriteria',
        'DP-AnalysedInfoCriterium',
        'SS-CSI',
        'SS-CamelData',
        'SS-EventList',
        'maxNumOfCamelSSEvents',
        'O-CSI',
        'O-BcsmCamelTDPDataList',
        'maxNumOfCamelTDPData',
        'O-BcsmCamelTDPData',
        'ServiceKey',
        'O-BcsmTriggerDetectionPoint',
        'O-BcsmCamelTDPCriteriaList',
        'T-BCSM-CAMEL-TDP-CriteriaList',
        'O-BcsmCamelTDP-Criteria',
        'T-BCSM-CAMEL-TDP-Criteria',
        'DestinationNumberCriteria',
        'DestinationNumberList',
        'DestinationNumberLengthList',
        'BasicServiceCriteria',
        'maxNumOfISDN-AddressDigits',
        'maxNumOfCamelDestinationNumbers',
        'maxNumOfCamelDestinationNumberLengths',
        'maxNumOfCamelBasicServiceCriteria',
        'CallTypeCriteria',
        'MatchType',
        'O-CauseValueCriteria',
        'T-CauseValueCriteria',
        'maxNumOfCAMEL-O-CauseValueCriteria',
        'maxNumOfCAMEL-T-CauseValueCriteria',
        'CauseValue',
        'DefaultCallHandling',
        'CamelCapabilityHandling',
        'SupportedCamelPhases',
        'OfferedCamel4CSIs',
        'OfferedCamel4Functionalities',
        'SMS-CSI',
        'SMS-CAMEL-TDP-DataList',
        'SMS-CAMEL-TDP-Data',
        'SMS-TriggerDetectionPoint',
        'DefaultSMS-Handling',
        'M-CSI',
        'MG-CSI',
        'MobilityTriggers',
        'maxNumOfMobilityTriggers',
        'MM-Code',
        'T-CSI',
        'T-BcsmCamelTDPDataList',
        'T-BcsmCamelTDPData',
        'T-BcsmTriggerDetectionPoint',
        'SendRoutingInfoForGprsArg',
        'SendRoutingInfoForGprsRes',
        'FailureReportArg',
        'FailureReportRes',
        'NoteMsPresentForGprsArg',
        'NoteMsPresentForGprsRes',
        'ResetArg',
        'SendingNode-Number',
        'RestoreDataArg',
        'RestoreDataRes',
        'VBSDataList',
        'VGCSDataList',
        'maxNumOfVBSGroupIds',
        'maxNumOfVGCSGroupIds',
        'VoiceGroupCallData',
        'AdditionalInfo',
        'AdditionalSubscriptions',
        'VoiceBroadcastData',
        'GroupId',
        'Long-GroupId',
        'ProvideSubscriberInfoArg',
        'ProvideSubscriberInfoRes',
        'SubscriberInfo',
        'IMS-VoiceOverPS-SessionsInd',
        'TimeZone',
        'DaylightSavingTime',
        'MNPInfoRes',
        'RouteingNumber',
        'NumberPortabilityStatus',
        'MS-Classmark2',
        'GPRSMSClass',
        'MSNetworkCapability',
        'MSRadioAccessCapability',
        'RequestedInfo',
        'DomainType',
        'RequestedNodes',
        'LocationInformation',
        'LocationInformationEPS',
        'LocationInformationGPRS',
        'LocationInformation5GS',
        'UserCSGInformation',
        'GeographicalInformation',
        'GeodeticInformation',
        'LocationNumber',
        'SubscriberState',
        'PS-SubscriberState',
        'PDP-ContextInfoList',
        'PDP-ContextInfo',
        'NSAPI',
        'TransactionId',
        'TEID',
        'GPRSChargingID',
        'NotReachableReason',
        'AnyTimeInterrogationArg',
        'AnyTimeInterrogationRes',
        'AnyTimeSubscriptionInterrogationArg',
        'AnyTimeSubscriptionInterrogationRes',
        'CallWaitingData',
        'Ext-CwFeatureList',
        'Ext-CwFeature',
        'ClipData',
        'ClirData',
        'CallHoldData',
        'EctData',
        'RequestedSubscriptionInfo',
        'MSISDN-BS-List',
        'maxNumOfMSISDN',
        'MSISDN-BS',
        'RequestedCAMEL-SubscriptionInfo',
        'AdditionalRequestedCAMEL-SubscriptionInfo',
        'CallForwardingData',
        'CallBarringData',
        'WrongPasswordAttemptsCounter',
        'ODB-Info',
        'CAMEL-SubscriptionInfo',
        'AnyTimeModificationArg',
        'ModificationRequestFor-CW-Info',
        'ModificationRequestFor-CH-Info',
        'ModificationRequestFor-ECT-Info',
        'ModificationRequestFor-CLIR-Info',
        'ModificationRequestFor-CLIP-Info',
        'ModificationRequestFor-CSG',
        'RequestedServingNode',
        'ServingNode',
        'AnyTimeModificationRes',
        'ModificationRequestFor-CF-Info',
        'ModificationRequestFor-CB-Info',
        'ModificationRequestFor-ODB-data',
        'ModificationRequestFor-CSI',
        'ModificationRequestFor-IP-SM-GW-Data',
        'ModificationInstruction',
        'NoteSubscriberDataModifiedArg',
        'NoteSubscriberDataModifiedRes',
        'NoteMM-EventArg',
        'NoteMM-EventRes',
        'Ext-SS-InfoFor-CSE',
        'Ext-ForwardingInfoFor-CSE',
        'Ext-CallBarringInfoFor-CSE',
        'UpdateVcsgLocationArg',
        'UpdateVcsgLocationRes',
        'CancelVcsgLocationArg',
        'CancelVcsgLocationRes',
        ]
    _type_ = [
        'UpdateLocationArg',
        'VLR-Capability',
        'SupportedRAT-Types',
        'SuperChargerInfo',
        'AgeIndicator',
        'IST-SupportIndicator',
        'SupportedLCS-CapabilitySets',
        'UpdateLocationRes',
        'ADD-Info',
        'PagingArea',
        'LocationArea',
        'LAC',
        'CancelLocationArg',
        'TypeOfUpdate',
        'CancellationType',
        'CancelLocationRes',
        'PurgeMS-Arg',
        'PurgeMS-Res',
        'SendIdentificationArg',
        'HopCounter',
        'SendIdentificationRes',
        'AuthenticationSetList',
        'TripletList',
        'QuintupletList',
        'AuthenticationTriplet',
        'AuthenticationQuintuplet',
        'CurrentSecurityContext',
        'GSM-SecurityContextData',
        'UMTS-SecurityContextData',
        'RAND',
        'SRES',
        'Kc',
        'XRES',
        'CK',
        'IK',
        'AUTN',
        'AUTS',
        'Cksn',
        'KSI',
        'AuthenticationFailureReportArg',
        'AccessType',
        'AuthenticationFailureReportRes',
        'FailureCause',
        'UpdateGprsLocationArg',
        'SMSRegisterRequest',
        'Used-RAT-Type',
        'EPS-Info',
        'PDN-GW-Update',
        'ISR-Information',
        'SGSN-Capability',
        'SupportedFeatures',
        'Ext-SupportedFeatures',
        'UE-SRVCC-Capability',
        'UpdateGprsLocationRes',
        'EPLMN-List',
        'AdjacentPLMN-List',
        'ForwardAccessSignalling-Arg',
        'AllowedGSM-Algorithms',
        'AllowedUMTS-Algorithms',
        'PermittedIntegrityProtectionAlgorithms',
        'PermittedEncryptionAlgorithms',
        'KeyStatus',
        'PrepareHO-Arg',
        'LCLS-GlobalCallReference',
        'LCLS-Negotiation',
        'LCLS-ConfigurationPreference',
        'BSSMAP-ServiceHandoverList',
        'BSSMAP-ServiceHandoverInfo',
        'BSSMAP-ServiceHandover',
        'RANAP-ServiceHandover',
        'RadioResourceList',
        'RadioResource',
        'PrepareHO-Res',
        'SelectedUMTS-Algorithms',
        'ChosenIntegrityProtectionAlgorithm',
        'ChosenEncryptionAlgorithm',
        'ChosenRadioResourceInformation',
        'ChosenChannelInfo',
        'ChosenSpeechVersion',
        'PrepareSubsequentHO-Arg',
        'PrepareSubsequentHO-Res',
        'ProcessAccessSignalling-Arg',
        'AoIPCodecsList',
        'AoIPCodec',
        'SupportedCodecsList',
        'CodecList',
        'Codec',
        'GERAN-Classmark',
        'SelectedGSM-Algorithm',
        'SendEndSignal-Arg',
        'SendEndSignal-Res',
        'RNCId',
        'RelocationNumberList',
        'MulticallBearerInfo',
        'RelocationNumber',
        'RAB-Id',
        'RadioResourceInformation',
        'IntegrityProtectionInformation',
        'EncryptionInformation',
        'SendAuthenticationInfoArg',
        'NumberOfRequestedVectors',
        'Re-synchronisationInfo',
        'SendAuthenticationInfoRes',
        'EPS-AuthenticationSetList',
        'UE-UsageType',
        'EPC-AV',
        'KASME',
        'RequestingNodeType',
        'CheckIMEI-Arg',
        'CheckIMEI-Res',
        'RequestedEquipmentInfo',
        'UESBI-Iu',
        'UESBI-IuA',
        'UESBI-IuB',
        'EquipmentStatus',
        'InsertSubscriberDataArg',
        'EDRX-Cycle-Length-List',
        'EDRX-Cycle-Length',
        'EDRX-Cycle-Length-Value',
        'Reset-Id-List',
        'Reset-Id',
        'DL-Buffering-Suggested-Packet-Count',
        'Group-Service-ID',
        'Local-GroupID',
        'IMSI-GroupIdList',
        'IMSI-GroupId',
        'SubscribedPeriodicRAUTAUtimer',
        'SubscribedPeriodicLAUtimer',
        'CSG-SubscriptionDataList',
        'CSG-SubscriptionData',
        'VPLMN-CSG-SubscriptionDataList',
        'CSG-Id',
        'LIPA-AllowedAPNList',
        'EPS-SubscriptionData',
        'APN-OI-Replacement',
        'RFSP-ID',
        'APN-ConfigurationProfile',
        'EPS-DataList',
        'APN-Configuration',
        'PDN-ConnectionContinuity',
        'NIDD-Mechanism',
        'PDN-Type',
        'EPS-QoS-Subscribed',
        'AMBR',
        'SpecificAPNInfoList',
        'SpecificAPNInfo',
        'Bandwidth',
        'BandwidthExt',
        'QoS-Class-Identifier',
        'Allocation-Retention-Priority',
        'PDN-GW-Identity',
        'FQDN',
        'PDN-GW-AllocationType',
        'WLAN-Offloadability',
        'WLAN-Offloadability-Indication',
        'AccessRestrictionData',
        'Ext-AccessRestrictionData',
        'AdjacentAccessRestrictionDataList',
        'AdjacentAccessRestrictionData',
        'CS-AllocationRetentionPriority',
        'IST-AlertTimerValue',
        'LCSInformation',
        'GMLC-List',
        'NetworkAccessMode',
        'GPRSDataList',
        'PDP-Context',
        'Restoration-Priority',
        'SIPTO-Permission',
        'SIPTO-Local-Network-Permission',
        'LIPA-Permission',
        'ContextId',
        'GPRSSubscriptionData',
        'SGSN-CAMEL-SubscriptionInfo',
        'GPRS-CSI',
        'GPRS-CamelTDPDataList',
        'GPRS-CamelTDPData',
        'DefaultGPRS-Handling',
        'GPRS-TriggerDetectionPoint',
        'APN',
        'PDP-Type',
        'Ext-PDP-Type',
        'PDP-Address',
        'QoS-Subscribed',
        'Ext-QoS-Subscribed',
        'Ext2-QoS-Subscribed',
        'Ext3-QoS-Subscribed',
        'Ext4-QoS-Subscribed',
        'ChargingCharacteristics',
        'LSAOnlyAccessIndicator',
        'LSADataList',
        'LSAData',
        'LSAInformation',
        'LSAIdentity',
        'LSAAttributes',
        'SubscriberData',
        'Category',
        'SubscriberStatus',
        'BearerServiceList',
        'TeleserviceList',
        'ODB-Data',
        'ODB-GeneralData',
        'ODB-HPLMN-Data',
        'Ext-SS-InfoList',
        'Ext-SS-Info',
        'Ext-ForwInfo',
        'Ext-ForwFeatureList',
        'Ext-ForwFeature',
        'Ext-ForwOptions',
        'Ext-NoRepCondTime',
        'Ext-CallBarInfo',
        'Ext-CallBarFeatureList',
        'Ext-CallBarringFeature',
        'CUG-Info',
        'CUG-SubscriptionList',
        'CUG-Subscription',
        'CUG-Index',
        'CUG-Interlock',
        'IntraCUG-Options',
        'CUG-FeatureList',
        'Ext-BasicServiceGroupList',
        'CUG-Feature',
        'InterCUG-Restrictions',
        'Ext-SS-Data',
        'LCS-PrivacyExceptionList',
        'LCS-PrivacyClass',
        'ExternalClientList',
        'PLMNClientList',
        'Ext-ExternalClientList',
        'ExternalClient',
        'GMLC-Restriction',
        'NotificationToMSUser',
        'ServiceTypeList',
        'ServiceType',
        'MOLR-List',
        'MOLR-Class',
        'ZoneCodeList',
        'ZoneCode',
        'InsertSubscriberDataRes',
        'RegionalSubscriptionResponse',
        'DeleteSubscriberDataArg',
        'SpecificCSI-Withdraw',
        'GPRSSubscriptionDataWithdraw',
        'EPS-SubscriptionDataWithdraw',
        'ContextIdList',
        'LSAInformationWithdraw',
        'LSAIdentityList',
        'BasicServiceList',
        'DeleteSubscriberDataRes',
        'VlrCamelSubscriptionInfo',
        'MT-smsCAMELTDP-CriteriaList',
        'MT-smsCAMELTDP-Criteria',
        'TPDU-TypeCriterion',
        'MT-SMS-TPDU-Type',
        'D-CSI',
        'DP-AnalysedInfoCriteriaList',
        'DP-AnalysedInfoCriterium',
        'SS-CSI',
        'SS-CamelData',
        'SS-EventList',
        'O-CSI',
        'O-BcsmCamelTDPDataList',
        'O-BcsmCamelTDPData',
        'ServiceKey',
        'O-BcsmTriggerDetectionPoint',
        'O-BcsmCamelTDPCriteriaList',
        'T-BCSM-CAMEL-TDP-CriteriaList',
        'O-BcsmCamelTDP-Criteria',
        'T-BCSM-CAMEL-TDP-Criteria',
        'DestinationNumberCriteria',
        'DestinationNumberList',
        'DestinationNumberLengthList',
        'BasicServiceCriteria',
        'CallTypeCriteria',
        'MatchType',
        'O-CauseValueCriteria',
        'T-CauseValueCriteria',
        'CauseValue',
        'DefaultCallHandling',
        'CamelCapabilityHandling',
        'SupportedCamelPhases',
        'OfferedCamel4CSIs',
        'OfferedCamel4Functionalities',
        'SMS-CSI',
        'SMS-CAMEL-TDP-DataList',
        'SMS-CAMEL-TDP-Data',
        'SMS-TriggerDetectionPoint',
        'DefaultSMS-Handling',
        'M-CSI',
        'MG-CSI',
        'MobilityTriggers',
        'MM-Code',
        'T-CSI',
        'T-BcsmCamelTDPDataList',
        'T-BcsmCamelTDPData',
        'T-BcsmTriggerDetectionPoint',
        'SendRoutingInfoForGprsArg',
        'SendRoutingInfoForGprsRes',
        'FailureReportArg',
        'FailureReportRes',
        'NoteMsPresentForGprsArg',
        'NoteMsPresentForGprsRes',
        'ResetArg',
        'SendingNode-Number',
        'RestoreDataArg',
        'RestoreDataRes',
        'VBSDataList',
        'VGCSDataList',
        'VoiceGroupCallData',
        'AdditionalInfo',
        'AdditionalSubscriptions',
        'VoiceBroadcastData',
        'GroupId',
        'Long-GroupId',
        'ProvideSubscriberInfoArg',
        'ProvideSubscriberInfoRes',
        'SubscriberInfo',
        'IMS-VoiceOverPS-SessionsInd',
        'TimeZone',
        'DaylightSavingTime',
        'MNPInfoRes',
        'RouteingNumber',
        'NumberPortabilityStatus',
        'MS-Classmark2',
        'GPRSMSClass',
        'MSNetworkCapability',
        'MSRadioAccessCapability',
        'RequestedInfo',
        'DomainType',
        'RequestedNodes',
        'LocationInformation',
        'LocationInformationEPS',
        'LocationInformationGPRS',
        'LocationInformation5GS',
        'UserCSGInformation',
        'GeographicalInformation',
        'GeodeticInformation',
        'LocationNumber',
        'SubscriberState',
        'PS-SubscriberState',
        'PDP-ContextInfoList',
        'PDP-ContextInfo',
        'NSAPI',
        'TransactionId',
        'TEID',
        'GPRSChargingID',
        'NotReachableReason',
        'AnyTimeInterrogationArg',
        'AnyTimeInterrogationRes',
        'AnyTimeSubscriptionInterrogationArg',
        'AnyTimeSubscriptionInterrogationRes',
        'CallWaitingData',
        'Ext-CwFeatureList',
        'Ext-CwFeature',
        'ClipData',
        'ClirData',
        'CallHoldData',
        'EctData',
        'RequestedSubscriptionInfo',
        'MSISDN-BS-List',
        'MSISDN-BS',
        'RequestedCAMEL-SubscriptionInfo',
        'AdditionalRequestedCAMEL-SubscriptionInfo',
        'CallForwardingData',
        'CallBarringData',
        'WrongPasswordAttemptsCounter',
        'ODB-Info',
        'CAMEL-SubscriptionInfo',
        'AnyTimeModificationArg',
        'ModificationRequestFor-CW-Info',
        'ModificationRequestFor-CH-Info',
        'ModificationRequestFor-ECT-Info',
        'ModificationRequestFor-CLIR-Info',
        'ModificationRequestFor-CLIP-Info',
        'ModificationRequestFor-CSG',
        'RequestedServingNode',
        'ServingNode',
        'AnyTimeModificationRes',
        'ModificationRequestFor-CF-Info',
        'ModificationRequestFor-CB-Info',
        'ModificationRequestFor-ODB-data',
        'ModificationRequestFor-CSI',
        'ModificationRequestFor-IP-SM-GW-Data',
        'ModificationInstruction',
        'NoteSubscriberDataModifiedArg',
        'NoteSubscriberDataModifiedRes',
        'NoteMM-EventArg',
        'NoteMM-EventRes',
        'Ext-SS-InfoFor-CSE',
        'Ext-ForwardingInfoFor-CSE',
        'Ext-CallBarringInfoFor-CSE',
        'UpdateVcsgLocationArg',
        'UpdateVcsgLocationRes',
        'CancelVcsgLocationArg',
        'CancelVcsgLocationRes',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPermittedIntegrityProtectionAlgorithmsLength',
        'maxPermittedEncryptionAlgorithmsLength',
        'maxNumOfServiceHandovers',
        'maxNumOfRadioResources',
        'maxNrOfRABs',
        'maxNumOfRelocationNumber',
        'maxNumOfIntegrityInfo',
        'maxNumOfEncryptionInfo',
        'maxNumOfLIPAAllowedAPN',
        'maxNumOfAPN-Configurations',
        'maxNumOfSpecificAPNInfos',
        'maxNumOfGMLC',
        'maxNumOfPDP-Contexts',
        'maxNumOfLSAs',
        'maxNumOfBearerServices',
        'maxNumOfTeleservices',
        'maxNumOfCUG',
        'maxNumOfExt-BasicServiceGroups',
        'maxNumOfPrivacyClass',
        'maxNumOfExternalClient',
        'maxNumOfPLMNClient',
        'maxNumOfExt-ExternalClient',
        'maxNumOfServiceType',
        'maxNumOfMOLR-Class',
        'maxNumOfZoneCodes',
        'maxNumOfBasicServices',
        'maxNumOfTPDUTypes',
        'maxNumOfDP-AnalysedInfoCriteria',
        'maxNumOfCamelSSEvents',
        'maxNumOfCamelTDPData',
        'maxNumOfISDN-AddressDigits',
        'maxNumOfCamelDestinationNumbers',
        'maxNumOfCamelDestinationNumberLengths',
        'maxNumOfCamelBasicServiceCriteria',
        'maxNumOfCAMEL-O-CauseValueCriteria',
        'maxNumOfCAMEL-T-CauseValueCriteria',
        'maxNumOfMobilityTriggers',
        'maxNumOfVBSGroupIds',
        'maxNumOfVGCSGroupIds',
        'maxNumOfMSISDN',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< UpdateLocationArg >-----#
    UpdateLocationArg = SEQ(name='UpdateLocationArg', mode=MODE_TYPE)
    _UpdateLocationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateLocationArg_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _UpdateLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationArg_vlr_Capability = SEQ(name='vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _UpdateLocationArg_informPreviousNetworkEntity = NULL(name='informPreviousNetworkEntity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_cs_LCS_NotSupportedByUE = NULL(name='cs-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_v_gmlc_Address = OCT_STR(name='v-gmlc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateLocationArg_add_info = SEQ(name='add-info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateLocationArg_pagingArea = SEQ_OF(name='pagingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _UpdateLocationArg_skipSubscriberDataUpdate = NULL(name='skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_restorationIndicator = NULL(name='restorationIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_eplmn_List = SEQ_OF(name='eplmn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateLocationArg_mme_DiameterAddress = SEQ(name='mme-DiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    UpdateLocationArg._cont = ASN1Dict([
        ('imsi', _UpdateLocationArg_imsi),
        ('msc-Number', _UpdateLocationArg_msc_Number),
        ('vlr-Number', _UpdateLocationArg_vlr_Number),
        ('lmsi', _UpdateLocationArg_lmsi),
        ('extensionContainer', _UpdateLocationArg_extensionContainer),
        ('vlr-Capability', _UpdateLocationArg_vlr_Capability),
        ('informPreviousNetworkEntity', _UpdateLocationArg_informPreviousNetworkEntity),
        ('cs-LCS-NotSupportedByUE', _UpdateLocationArg_cs_LCS_NotSupportedByUE),
        ('v-gmlc-Address', _UpdateLocationArg_v_gmlc_Address),
        ('add-info', _UpdateLocationArg_add_info),
        ('pagingArea', _UpdateLocationArg_pagingArea),
        ('skipSubscriberDataUpdate', _UpdateLocationArg_skipSubscriberDataUpdate),
        ('restorationIndicator', _UpdateLocationArg_restorationIndicator),
        ('eplmn-List', _UpdateLocationArg_eplmn_List),
        ('mme-DiameterAddress', _UpdateLocationArg_mme_DiameterAddress),
        ])
    UpdateLocationArg._ext = ['vlr-Capability', 'informPreviousNetworkEntity', 'cs-LCS-NotSupportedByUE', 'v-gmlc-Address', 'add-info', 'pagingArea', 'skipSubscriberDataUpdate', 'restorationIndicator', 'eplmn-List', 'mme-DiameterAddress']
    
    #-----< VLR-Capability >-----#
    VLR_Capability = SEQ(name='VLR-Capability', mode=MODE_TYPE)
    _VLR_Capability_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _VLR_Capability_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VLR_Capability_solsaSupportIndicator = NULL(name='solsaSupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_istSupportIndicator = ENUM(name='istSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _VLR_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name='superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _VLR_Capability_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_supportedLCS_CapabilitySets = BIT_STR(name='supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _VLR_Capability_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _VLR_Capability_supportedRAT_TypesIndicator = BIT_STR(name='supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _VLR_Capability_longGroupID_Supported = NULL(name='longGroupID-Supported', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_mtRoamingForwardingSupported = NULL(name='mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_msisdn_lessOperation_Supported = NULL(name='msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_reset_ids_Supported = NULL(name='reset-ids-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    VLR_Capability._cont = ASN1Dict([
        ('supportedCamelPhases', _VLR_Capability_supportedCamelPhases),
        ('extensionContainer', _VLR_Capability_extensionContainer),
        ('solsaSupportIndicator', _VLR_Capability_solsaSupportIndicator),
        ('istSupportIndicator', _VLR_Capability_istSupportIndicator),
        ('superChargerSupportedInServingNetworkEntity', _VLR_Capability_superChargerSupportedInServingNetworkEntity),
        ('longFTN-Supported', _VLR_Capability_longFTN_Supported),
        ('supportedLCS-CapabilitySets', _VLR_Capability_supportedLCS_CapabilitySets),
        ('offeredCamel4CSIs', _VLR_Capability_offeredCamel4CSIs),
        ('supportedRAT-TypesIndicator', _VLR_Capability_supportedRAT_TypesIndicator),
        ('longGroupID-Supported', _VLR_Capability_longGroupID_Supported),
        ('mtRoamingForwardingSupported', _VLR_Capability_mtRoamingForwardingSupported),
        ('msisdn-lessOperation-Supported', _VLR_Capability_msisdn_lessOperation_Supported),
        ('reset-ids-Supported', _VLR_Capability_reset_ids_Supported),
        ])
    VLR_Capability._ext = ['solsaSupportIndicator', 'istSupportIndicator', 'superChargerSupportedInServingNetworkEntity', 'longFTN-Supported', 'supportedLCS-CapabilitySets', 'offeredCamel4CSIs', 'supportedRAT-TypesIndicator', 'longGroupID-Supported', 'mtRoamingForwardingSupported', 'msisdn-lessOperation-Supported', 'reset-ids-Supported']
    
    #-----< SupportedRAT-Types >-----#
    SupportedRAT_Types = BIT_STR(name='SupportedRAT-Types', mode=MODE_TYPE)
    SupportedRAT_Types._cont = ASN1Dict([('utran', 0), ('geran', 1), ('gan', 2), ('i-hspa-evolution', 3), ('e-utran', 4), ('nb-iot', 5)])
    SupportedRAT_Types._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< SuperChargerInfo >-----#
    SuperChargerInfo = CHOICE(name='SuperChargerInfo', mode=MODE_TYPE)
    _SuperChargerInfo_sendSubscriberData = NULL(name='sendSubscriberData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SuperChargerInfo_subscriberDataStored = OCT_STR(name='subscriberDataStored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')))
    SuperChargerInfo._cont = ASN1Dict([
        ('sendSubscriberData', _SuperChargerInfo_sendSubscriberData),
        ('subscriberDataStored', _SuperChargerInfo_subscriberDataStored),
        ])
    SuperChargerInfo._ext = None
    
    #-----< AgeIndicator >-----#
    AgeIndicator = OCT_STR(name='AgeIndicator', mode=MODE_TYPE)
    AgeIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< IST-SupportIndicator >-----#
    IST_SupportIndicator = ENUM(name='IST-SupportIndicator', mode=MODE_TYPE)
    IST_SupportIndicator._cont = ASN1Dict([('basicISTSupported', 0), ('istCommandSupported', 1)])
    IST_SupportIndicator._ext = []
    
    #-----< SupportedLCS-CapabilitySets >-----#
    SupportedLCS_CapabilitySets = BIT_STR(name='SupportedLCS-CapabilitySets', mode=MODE_TYPE)
    SupportedLCS_CapabilitySets._cont = ASN1Dict([('lcsCapabilitySet1', 0), ('lcsCapabilitySet2', 1), ('lcsCapabilitySet3', 2), ('lcsCapabilitySet4', 3), ('lcsCapabilitySet5', 4)])
    SupportedLCS_CapabilitySets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< UpdateLocationRes >-----#
    UpdateLocationRes = SEQ(name='UpdateLocationRes', mode=MODE_TYPE)
    _UpdateLocationRes_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationRes_add_Capability = NULL(name='add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateLocationRes_pagingArea_Capability = NULL(name='pagingArea-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateLocationRes._cont = ASN1Dict([
        ('hlr-Number', _UpdateLocationRes_hlr_Number),
        ('extensionContainer', _UpdateLocationRes_extensionContainer),
        ('add-Capability', _UpdateLocationRes_add_Capability),
        ('pagingArea-Capability', _UpdateLocationRes_pagingArea_Capability),
        ])
    UpdateLocationRes._ext = ['add-Capability', 'pagingArea-Capability']
    
    #-----< ADD-Info >-----#
    ADD_Info = SEQ(name='ADD-Info', mode=MODE_TYPE)
    _ADD_Info_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _ADD_Info_skipSubscriberDataUpdate = NULL(name='skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ADD_Info._cont = ASN1Dict([
        ('imeisv', _ADD_Info_imeisv),
        ('skipSubscriberDataUpdate', _ADD_Info_skipSubscriberDataUpdate),
        ])
    ADD_Info._ext = []
    
    #-----< PagingArea >-----#
    PagingArea = SEQ_OF(name='PagingArea', mode=MODE_TYPE)
    _PagingArea__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationArea')))
    PagingArea._cont = _PagingArea__item_
    PagingArea._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< LocationArea >-----#
    LocationArea = CHOICE(name='LocationArea', mode=MODE_TYPE)
    _LocationArea_laiFixedLength = OCT_STR(name='laiFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _LocationArea_lac = OCT_STR(name='lac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LAC')))
    LocationArea._cont = ASN1Dict([
        ('laiFixedLength', _LocationArea_laiFixedLength),
        ('lac', _LocationArea_lac),
        ])
    LocationArea._ext = None
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CancelLocationArg >-----#
    CancelLocationArg = SEQ(name='CancelLocationArg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CancelLocationArg_identity = CHOICE(name='identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelLocationArg_cancellationType = ENUM(name='cancellationType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CancellationType')), opt=True)
    _CancelLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CancelLocationArg_typeOfUpdate = ENUM(name='typeOfUpdate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TypeOfUpdate')), opt=True)
    _CancelLocationArg_mtrf_SupportedAndAuthorized = NULL(name='mtrf-SupportedAndAuthorized', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_mtrf_SupportedAndNotAuthorized = NULL(name='mtrf-SupportedAndNotAuthorized', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_newMSC_Number = OCT_STR(name='newMSC-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_newVLR_Number = OCT_STR(name='newVLR-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_new_lmsi = OCT_STR(name='new-lmsi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _CancelLocationArg_reattach_Required = NULL(name='reattach-Required', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CancelLocationArg._cont = ASN1Dict([
        ('identity', _CancelLocationArg_identity),
        ('cancellationType', _CancelLocationArg_cancellationType),
        ('extensionContainer', _CancelLocationArg_extensionContainer),
        ('typeOfUpdate', _CancelLocationArg_typeOfUpdate),
        ('mtrf-SupportedAndAuthorized', _CancelLocationArg_mtrf_SupportedAndAuthorized),
        ('mtrf-SupportedAndNotAuthorized', _CancelLocationArg_mtrf_SupportedAndNotAuthorized),
        ('newMSC-Number', _CancelLocationArg_newMSC_Number),
        ('newVLR-Number', _CancelLocationArg_newVLR_Number),
        ('new-lmsi', _CancelLocationArg_new_lmsi),
        ('reattach-Required', _CancelLocationArg_reattach_Required),
        ])
    CancelLocationArg._ext = ['typeOfUpdate', 'mtrf-SupportedAndAuthorized', 'mtrf-SupportedAndNotAuthorized', 'newMSC-Number', 'newVLR-Number', 'new-lmsi', 'reattach-Required']
    
    #-----< TypeOfUpdate >-----#
    TypeOfUpdate = ENUM(name='TypeOfUpdate', mode=MODE_TYPE)
    TypeOfUpdate._cont = ASN1Dict([('sgsn-change', 0), ('mme-change', 1)])
    TypeOfUpdate._ext = []
    
    #-----< CancellationType >-----#
    CancellationType = ENUM(name='CancellationType', mode=MODE_TYPE)
    CancellationType._cont = ASN1Dict([('updateProcedure', 0), ('subscriptionWithdraw', 1), ('initialAttachProcedure', 2)])
    CancellationType._ext = ['initialAttachProcedure']
    
    #-----< CancelLocationRes >-----#
    CancelLocationRes = SEQ(name='CancelLocationRes', mode=MODE_TYPE)
    _CancelLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelLocationRes._cont = ASN1Dict([
        ('extensionContainer', _CancelLocationRes_extensionContainer),
        ])
    CancelLocationRes._ext = []
    
    #-----< PurgeMS-Arg >-----#
    PurgeMS_Arg = SEQ(name='PurgeMS-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PurgeMS_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _PurgeMS_Arg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Arg_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _PurgeMS_Arg_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _PurgeMS_Arg_locationInformationEPS = SEQ(name='locationInformationEPS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    PurgeMS_Arg._cont = ASN1Dict([
        ('imsi', _PurgeMS_Arg_imsi),
        ('vlr-Number', _PurgeMS_Arg_vlr_Number),
        ('sgsn-Number', _PurgeMS_Arg_sgsn_Number),
        ('extensionContainer', _PurgeMS_Arg_extensionContainer),
        ('locationInformation', _PurgeMS_Arg_locationInformation),
        ('locationInformationGPRS', _PurgeMS_Arg_locationInformationGPRS),
        ('locationInformationEPS', _PurgeMS_Arg_locationInformationEPS),
        ])
    PurgeMS_Arg._ext = ['locationInformation', 'locationInformationGPRS', 'locationInformationEPS']
    
    #-----< PurgeMS-Res >-----#
    PurgeMS_Res = SEQ(name='PurgeMS-Res', mode=MODE_TYPE)
    _PurgeMS_Res_freezeTMSI = NULL(name='freezeTMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_freezeP_TMSI = NULL(name='freezeP-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Res_freezeM_TMSI = NULL(name='freezeM-TMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PurgeMS_Res._cont = ASN1Dict([
        ('freezeTMSI', _PurgeMS_Res_freezeTMSI),
        ('freezeP-TMSI', _PurgeMS_Res_freezeP_TMSI),
        ('extensionContainer', _PurgeMS_Res_extensionContainer),
        ('freezeM-TMSI', _PurgeMS_Res_freezeM_TMSI),
        ])
    PurgeMS_Res._ext = ['freezeM-TMSI']
    
    #-----< SendIdentificationArg >-----#
    SendIdentificationArg = SEQ(name='SendIdentificationArg', mode=MODE_TYPE)
    _SendIdentificationArg_tmsi = OCT_STR(name='tmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    _SendIdentificationArg_numberOfRequestedVectors = INT(name='numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendIdentificationArg_segmentationProhibited = NULL(name='segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendIdentificationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationArg_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_previous_LAI = OCT_STR(name='previous-LAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')), opt=True)
    _SendIdentificationArg_hopCounter = INT(name='hopCounter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'HopCounter')), opt=True)
    _SendIdentificationArg_mtRoamingForwardingSupported = NULL(name='mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendIdentificationArg_newVLR_Number = OCT_STR(name='newVLR-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_new_lmsi = OCT_STR(name='new-lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    SendIdentificationArg._cont = ASN1Dict([
        ('tmsi', _SendIdentificationArg_tmsi),
        ('numberOfRequestedVectors', _SendIdentificationArg_numberOfRequestedVectors),
        ('segmentationProhibited', _SendIdentificationArg_segmentationProhibited),
        ('extensionContainer', _SendIdentificationArg_extensionContainer),
        ('msc-Number', _SendIdentificationArg_msc_Number),
        ('previous-LAI', _SendIdentificationArg_previous_LAI),
        ('hopCounter', _SendIdentificationArg_hopCounter),
        ('mtRoamingForwardingSupported', _SendIdentificationArg_mtRoamingForwardingSupported),
        ('newVLR-Number', _SendIdentificationArg_newVLR_Number),
        ('new-lmsi', _SendIdentificationArg_new_lmsi),
        ])
    SendIdentificationArg._ext = ['msc-Number', 'previous-LAI', 'hopCounter', 'mtRoamingForwardingSupported', 'newVLR-Number', 'new-lmsi']
    
    #-----< HopCounter >-----#
    HopCounter = INT(name='HopCounter', mode=MODE_TYPE)
    HopCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< SendIdentificationRes >-----#
    SendIdentificationRes = SEQ(name='SendIdentificationRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendIdentificationRes_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendIdentificationRes_authenticationSetList = CHOICE(name='authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendIdentificationRes_currentSecurityContext = CHOICE(name='currentSecurityContext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CurrentSecurityContext')), opt=True)
    _SendIdentificationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationRes_lastUsedLtePLMN_Id = OCT_STR(name='lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendIdentificationRes_mtCallPendingFlag = NULL(name='mtCallPendingFlag', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendIdentificationRes._cont = ASN1Dict([
        ('imsi', _SendIdentificationRes_imsi),
        ('authenticationSetList', _SendIdentificationRes_authenticationSetList),
        ('currentSecurityContext', _SendIdentificationRes_currentSecurityContext),
        ('extensionContainer', _SendIdentificationRes_extensionContainer),
        ('lastUsedLtePLMN-Id', _SendIdentificationRes_lastUsedLtePLMN_Id),
        ('mtCallPendingFlag', _SendIdentificationRes_mtCallPendingFlag),
        ])
    SendIdentificationRes._ext = ['lastUsedLtePLMN-Id', 'mtCallPendingFlag']
    
    #-----< AuthenticationSetList >-----#
    AuthenticationSetList = CHOICE(name='AuthenticationSetList', mode=MODE_TYPE)
    _AuthenticationSetList_tripletList = SEQ_OF(name='tripletList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TripletList')))
    _AuthenticationSetList_quintupletList = SEQ_OF(name='quintupletList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QuintupletList')))
    AuthenticationSetList._cont = ASN1Dict([
        ('tripletList', _AuthenticationSetList_tripletList),
        ('quintupletList', _AuthenticationSetList_quintupletList),
        ])
    AuthenticationSetList._ext = None
    
    #-----< TripletList >-----#
    TripletList = SEQ_OF(name='TripletList', mode=MODE_TYPE)
    _TripletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationTriplet')))
    TripletList._cont = _TripletList__item_
    TripletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< QuintupletList >-----#
    QuintupletList = SEQ_OF(name='QuintupletList', mode=MODE_TYPE)
    _QuintupletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationQuintuplet')))
    QuintupletList._cont = _QuintupletList__item_
    QuintupletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AuthenticationTriplet >-----#
    AuthenticationTriplet = SEQ(name='AuthenticationTriplet', mode=MODE_TYPE)
    _AuthenticationTriplet_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationTriplet_sres = OCT_STR(name='sres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SRES')))
    _AuthenticationTriplet_kc = OCT_STR(name='kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    AuthenticationTriplet._cont = ASN1Dict([
        ('rand', _AuthenticationTriplet_rand),
        ('sres', _AuthenticationTriplet_sres),
        ('kc', _AuthenticationTriplet_kc),
        ])
    AuthenticationTriplet._ext = []
    
    #-----< AuthenticationQuintuplet >-----#
    AuthenticationQuintuplet = SEQ(name='AuthenticationQuintuplet', mode=MODE_TYPE)
    _AuthenticationQuintuplet_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationQuintuplet_xres = OCT_STR(name='xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _AuthenticationQuintuplet_ck = OCT_STR(name='ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _AuthenticationQuintuplet_ik = OCT_STR(name='ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _AuthenticationQuintuplet_autn = OCT_STR(name='autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    AuthenticationQuintuplet._cont = ASN1Dict([
        ('rand', _AuthenticationQuintuplet_rand),
        ('xres', _AuthenticationQuintuplet_xres),
        ('ck', _AuthenticationQuintuplet_ck),
        ('ik', _AuthenticationQuintuplet_ik),
        ('autn', _AuthenticationQuintuplet_autn),
        ])
    AuthenticationQuintuplet._ext = []
    
    #-----< CurrentSecurityContext >-----#
    CurrentSecurityContext = CHOICE(name='CurrentSecurityContext', mode=MODE_TYPE)
    _CurrentSecurityContext_gsm_SecurityContextData = SEQ(name='gsm-SecurityContextData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GSM-SecurityContextData')))
    _CurrentSecurityContext_umts_SecurityContextData = SEQ(name='umts-SecurityContextData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UMTS-SecurityContextData')))
    CurrentSecurityContext._cont = ASN1Dict([
        ('gsm-SecurityContextData', _CurrentSecurityContext_gsm_SecurityContextData),
        ('umts-SecurityContextData', _CurrentSecurityContext_umts_SecurityContextData),
        ])
    CurrentSecurityContext._ext = None
    
    #-----< GSM-SecurityContextData >-----#
    GSM_SecurityContextData = SEQ(name='GSM-SecurityContextData', mode=MODE_TYPE)
    _GSM_SecurityContextData_kc = OCT_STR(name='kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    _GSM_SecurityContextData_cksn = OCT_STR(name='cksn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Cksn')))
    GSM_SecurityContextData._cont = ASN1Dict([
        ('kc', _GSM_SecurityContextData_kc),
        ('cksn', _GSM_SecurityContextData_cksn),
        ])
    GSM_SecurityContextData._ext = []
    
    #-----< UMTS-SecurityContextData >-----#
    UMTS_SecurityContextData = SEQ(name='UMTS-SecurityContextData', mode=MODE_TYPE)
    _UMTS_SecurityContextData_ck = OCT_STR(name='ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _UMTS_SecurityContextData_ik = OCT_STR(name='ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _UMTS_SecurityContextData_ksi = OCT_STR(name='ksi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KSI')))
    UMTS_SecurityContextData._cont = ASN1Dict([
        ('ck', _UMTS_SecurityContextData_ck),
        ('ik', _UMTS_SecurityContextData_ik),
        ('ksi', _UMTS_SecurityContextData_ksi),
        ])
    UMTS_SecurityContextData._ext = []
    
    #-----< RAND >-----#
    RAND = OCT_STR(name='RAND', mode=MODE_TYPE)
    RAND._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SRES >-----#
    SRES = OCT_STR(name='SRES', mode=MODE_TYPE)
    SRES._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< Kc >-----#
    Kc = OCT_STR(name='Kc', mode=MODE_TYPE)
    Kc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< XRES >-----#
    XRES = OCT_STR(name='XRES', mode=MODE_TYPE)
    XRES._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< CK >-----#
    CK = OCT_STR(name='CK', mode=MODE_TYPE)
    CK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IK >-----#
    IK = OCT_STR(name='IK', mode=MODE_TYPE)
    IK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTN >-----#
    AUTN = OCT_STR(name='AUTN', mode=MODE_TYPE)
    AUTN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTS >-----#
    AUTS = OCT_STR(name='AUTS', mode=MODE_TYPE)
    AUTS._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< Cksn >-----#
    Cksn = OCT_STR(name='Cksn', mode=MODE_TYPE)
    Cksn._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< KSI >-----#
    KSI = OCT_STR(name='KSI', mode=MODE_TYPE)
    KSI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AuthenticationFailureReportArg >-----#
    AuthenticationFailureReportArg = SEQ(name='AuthenticationFailureReportArg', mode=MODE_TYPE)
    _AuthenticationFailureReportArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _AuthenticationFailureReportArg_failureCause = ENUM(name='failureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'FailureCause')))
    _AuthenticationFailureReportArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AuthenticationFailureReportArg_re_attempt = BOOL(name='re-attempt', mode=MODE_TYPE, opt=True)
    _AuthenticationFailureReportArg_accessType = ENUM(name='accessType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessType')), opt=True)
    _AuthenticationFailureReportArg_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')), opt=True)
    _AuthenticationFailureReportArg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AuthenticationFailureReportArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    AuthenticationFailureReportArg._cont = ASN1Dict([
        ('imsi', _AuthenticationFailureReportArg_imsi),
        ('failureCause', _AuthenticationFailureReportArg_failureCause),
        ('extensionContainer', _AuthenticationFailureReportArg_extensionContainer),
        ('re-attempt', _AuthenticationFailureReportArg_re_attempt),
        ('accessType', _AuthenticationFailureReportArg_accessType),
        ('rand', _AuthenticationFailureReportArg_rand),
        ('vlr-Number', _AuthenticationFailureReportArg_vlr_Number),
        ('sgsn-Number', _AuthenticationFailureReportArg_sgsn_Number),
        ])
    AuthenticationFailureReportArg._ext = ['re-attempt', 'accessType', 'rand', 'vlr-Number', 'sgsn-Number']
    
    #-----< AccessType >-----#
    AccessType = ENUM(name='AccessType', mode=MODE_TYPE)
    AccessType._cont = ASN1Dict([('call', 0), ('emergencyCall', 1), ('locationUpdating', 2), ('supplementaryService', 3), ('shortMessage', 4), ('gprsAttach', 5), ('routingAreaUpdating', 6), ('serviceRequest', 7), ('pdpContextActivation', 8), ('pdpContextDeactivation', 9), ('gprsDetach', 10)])
    AccessType._ext = ['gprsDetach']
    
    #-----< AuthenticationFailureReportRes >-----#
    AuthenticationFailureReportRes = SEQ(name='AuthenticationFailureReportRes', mode=MODE_TYPE)
    _AuthenticationFailureReportRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AuthenticationFailureReportRes._cont = ASN1Dict([
        ('extensionContainer', _AuthenticationFailureReportRes_extensionContainer),
        ])
    AuthenticationFailureReportRes._ext = []
    
    #-----< FailureCause >-----#
    FailureCause = ENUM(name='FailureCause', mode=MODE_TYPE)
    FailureCause._cont = ASN1Dict([('wrongUserResponse', 0), ('wrongNetworkSignature', 1)])
    FailureCause._ext = None
    
    #-----< UpdateGprsLocationArg >-----#
    UpdateGprsLocationArg = SEQ(name='UpdateGprsLocationArg', mode=MODE_TYPE)
    _UpdateGprsLocationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateGprsLocationArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationArg_sgsn_Address = OCT_STR(name='sgsn-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _UpdateGprsLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationArg_sgsn_Capability = SEQ(name='sgsn-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-Capability')), opt=True)
    _UpdateGprsLocationArg_informPreviousNetworkEntity = NULL(name='informPreviousNetworkEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE = NULL(name='ps-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_v_gmlc_Address = OCT_STR(name='v-gmlc-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateGprsLocationArg_add_info = SEQ(name='add-info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateGprsLocationArg_eps_info = CHOICE(name='eps-info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-Info')), opt=True)
    _UpdateGprsLocationArg_servingNodeTypeIndicator = NULL(name='servingNodeTypeIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_skipSubscriberDataUpdate = NULL(name='skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_usedRAT_Type = ENUM(name='usedRAT-Type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded = NULL(name='gprsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_nodeTypeIndicator = NULL(name='nodeTypeIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_areaRestricted = NULL(name='areaRestricted', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_reachableIndicator = NULL(name='ue-reachableIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded = NULL(name='epsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_srvcc_Capability = ENUM(name='ue-srvcc-Capability', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-SRVCC-Capability')), opt=True)
    _UpdateGprsLocationArg_eplmn_List = SEQ_OF(name='eplmn-List', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateGprsLocationArg_mmeNumberforMTSMS = OCT_STR(name='mmeNumberforMTSMS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateGprsLocationArg_smsRegisterRequest = ENUM(name='smsRegisterRequest', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMSRegisterRequest')), opt=True)
    _UpdateGprsLocationArg_sms_Only = NULL(name='sms-Only', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_removalofMMERegistrationforSMS = NULL(name='removalofMMERegistrationforSMS', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_sgsn_Name = OCT_STR(name='sgsn-Name', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_sgsn_Realm = OCT_STR(name='sgsn-Realm', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_lgd_supportIndicator = NULL(name='lgd-supportIndicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_adjacentPLMN_List = SEQ_OF(name='adjacentPLMN-List', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentPLMN-List')), opt=True)
    UpdateGprsLocationArg._cont = ASN1Dict([
        ('imsi', _UpdateGprsLocationArg_imsi),
        ('sgsn-Number', _UpdateGprsLocationArg_sgsn_Number),
        ('sgsn-Address', _UpdateGprsLocationArg_sgsn_Address),
        ('extensionContainer', _UpdateGprsLocationArg_extensionContainer),
        ('sgsn-Capability', _UpdateGprsLocationArg_sgsn_Capability),
        ('informPreviousNetworkEntity', _UpdateGprsLocationArg_informPreviousNetworkEntity),
        ('ps-LCS-NotSupportedByUE', _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE),
        ('v-gmlc-Address', _UpdateGprsLocationArg_v_gmlc_Address),
        ('add-info', _UpdateGprsLocationArg_add_info),
        ('eps-info', _UpdateGprsLocationArg_eps_info),
        ('servingNodeTypeIndicator', _UpdateGprsLocationArg_servingNodeTypeIndicator),
        ('skipSubscriberDataUpdate', _UpdateGprsLocationArg_skipSubscriberDataUpdate),
        ('usedRAT-Type', _UpdateGprsLocationArg_usedRAT_Type),
        ('gprsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded),
        ('nodeTypeIndicator', _UpdateGprsLocationArg_nodeTypeIndicator),
        ('areaRestricted', _UpdateGprsLocationArg_areaRestricted),
        ('ue-reachableIndicator', _UpdateGprsLocationArg_ue_reachableIndicator),
        ('epsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded),
        ('ue-srvcc-Capability', _UpdateGprsLocationArg_ue_srvcc_Capability),
        ('eplmn-List', _UpdateGprsLocationArg_eplmn_List),
        ('mmeNumberforMTSMS', _UpdateGprsLocationArg_mmeNumberforMTSMS),
        ('smsRegisterRequest', _UpdateGprsLocationArg_smsRegisterRequest),
        ('sms-Only', _UpdateGprsLocationArg_sms_Only),
        ('removalofMMERegistrationforSMS', _UpdateGprsLocationArg_removalofMMERegistrationforSMS),
        ('sgsn-Name', _UpdateGprsLocationArg_sgsn_Name),
        ('sgsn-Realm', _UpdateGprsLocationArg_sgsn_Realm),
        ('lgd-supportIndicator', _UpdateGprsLocationArg_lgd_supportIndicator),
        ('adjacentPLMN-List', _UpdateGprsLocationArg_adjacentPLMN_List),
        ])
    UpdateGprsLocationArg._ext = ['sgsn-Capability', 'informPreviousNetworkEntity', 'ps-LCS-NotSupportedByUE', 'v-gmlc-Address', 'add-info', 'eps-info', 'servingNodeTypeIndicator', 'skipSubscriberDataUpdate', 'usedRAT-Type', 'gprsSubscriptionDataNotNeeded', 'nodeTypeIndicator', 'areaRestricted', 'ue-reachableIndicator', 'epsSubscriptionDataNotNeeded', 'ue-srvcc-Capability', 'eplmn-List', 'mmeNumberforMTSMS', 'smsRegisterRequest', 'sms-Only', 'removalofMMERegistrationforSMS', 'sgsn-Name', 'sgsn-Realm', 'lgd-supportIndicator', 'adjacentPLMN-List']
    
    #-----< SMSRegisterRequest >-----#
    SMSRegisterRequest = ENUM(name='SMSRegisterRequest', mode=MODE_TYPE)
    SMSRegisterRequest._cont = ASN1Dict([('sms-registration-required', 0), ('sms-registration-not-preferred', 1), ('no-preference', 2)])
    SMSRegisterRequest._ext = []
    
    #-----< Used-RAT-Type >-----#
    Used_RAT_Type = ENUM(name='Used-RAT-Type', mode=MODE_TYPE)
    Used_RAT_Type._cont = ASN1Dict([('utran', 0), ('geran', 1), ('gan', 2), ('i-hspa-evolution', 3), ('e-utran', 4), ('nb-iot', 5)])
    Used_RAT_Type._ext = ['nb-iot']
    
    #-----< EPS-Info >-----#
    EPS_Info = CHOICE(name='EPS-Info', mode=MODE_TYPE)
    _EPS_Info_pdn_gw_update = SEQ(name='pdn-gw-update', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Update')))
    _EPS_Info_isr_Information = BIT_STR(name='isr-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ISR-Information')))
    EPS_Info._cont = ASN1Dict([
        ('pdn-gw-update', _EPS_Info_pdn_gw_update),
        ('isr-Information', _EPS_Info_isr_Information),
        ])
    EPS_Info._ext = None
    
    #-----< PDN-GW-Update >-----#
    PDN_GW_Update = SEQ(name='PDN-GW-Update', mode=MODE_TYPE)
    _PDN_GW_Update_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDN_GW_Update_pdn_gw_Identity = SEQ(name='pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _PDN_GW_Update_contextId = INT(name='contextId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    _PDN_GW_Update_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Update._cont = ASN1Dict([
        ('apn', _PDN_GW_Update_apn),
        ('pdn-gw-Identity', _PDN_GW_Update_pdn_gw_Identity),
        ('contextId', _PDN_GW_Update_contextId),
        ('extensionContainer', _PDN_GW_Update_extensionContainer),
        ])
    PDN_GW_Update._ext = []
    
    #-----< ISR-Information >-----#
    ISR_Information = BIT_STR(name='ISR-Information', mode=MODE_TYPE)
    ISR_Information._cont = ASN1Dict([('updateLocation', 0), ('cancelSGSN', 1), ('initialAttachIndicator', 2)])
    ISR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-Capability >-----#
    SGSN_Capability = SEQ(name='SGSN-Capability', mode=MODE_TYPE)
    _SGSN_Capability_solsaSupportIndicator = NULL(name='solsaSupportIndicator', mode=MODE_TYPE, opt=True)
    _SGSN_Capability_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name='superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _SGSN_Capability_gprsEnhancementsSupportIndicator = NULL(name='gprsEnhancementsSupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SGSN_Capability_supportedLCS_CapabilitySets = BIT_STR(name='supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _SGSN_Capability_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SGSN_Capability_smsCallBarringSupportIndicator = NULL(name='smsCallBarringSupportIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedRAT_TypesIndicator = BIT_STR(name='supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _SGSN_Capability_supportedFeatures = BIT_STR(name='supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _SGSN_Capability_t_adsDataRetrieval = NULL(name='t-adsDataRetrieval', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions = BOOL(name='homogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_cancellationTypeInitialAttach = NULL(name='cancellationTypeInitialAttach', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_msisdn_lessOperation_Supported = NULL(name='msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions = NULL(name='updateofHomogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_reset_ids_Supported = NULL(name='reset-ids-Supported', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_ext_SupportedFeatures = BIT_STR(name='ext-SupportedFeatures', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    SGSN_Capability._cont = ASN1Dict([
        ('solsaSupportIndicator', _SGSN_Capability_solsaSupportIndicator),
        ('extensionContainer', _SGSN_Capability_extensionContainer),
        ('superChargerSupportedInServingNetworkEntity', _SGSN_Capability_superChargerSupportedInServingNetworkEntity),
        ('gprsEnhancementsSupportIndicator', _SGSN_Capability_gprsEnhancementsSupportIndicator),
        ('supportedCamelPhases', _SGSN_Capability_supportedCamelPhases),
        ('supportedLCS-CapabilitySets', _SGSN_Capability_supportedLCS_CapabilitySets),
        ('offeredCamel4CSIs', _SGSN_Capability_offeredCamel4CSIs),
        ('smsCallBarringSupportIndicator', _SGSN_Capability_smsCallBarringSupportIndicator),
        ('supportedRAT-TypesIndicator', _SGSN_Capability_supportedRAT_TypesIndicator),
        ('supportedFeatures', _SGSN_Capability_supportedFeatures),
        ('t-adsDataRetrieval', _SGSN_Capability_t_adsDataRetrieval),
        ('homogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions),
        ('cancellationTypeInitialAttach', _SGSN_Capability_cancellationTypeInitialAttach),
        ('msisdn-lessOperation-Supported', _SGSN_Capability_msisdn_lessOperation_Supported),
        ('updateofHomogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions),
        ('reset-ids-Supported', _SGSN_Capability_reset_ids_Supported),
        ('ext-SupportedFeatures', _SGSN_Capability_ext_SupportedFeatures),
        ])
    SGSN_Capability._ext = ['superChargerSupportedInServingNetworkEntity', 'gprsEnhancementsSupportIndicator', 'supportedCamelPhases', 'supportedLCS-CapabilitySets', 'offeredCamel4CSIs', 'smsCallBarringSupportIndicator', 'supportedRAT-TypesIndicator', 'supportedFeatures', 't-adsDataRetrieval', 'homogeneousSupportOfIMSVoiceOverPSSessions', 'cancellationTypeInitialAttach', 'msisdn-lessOperation-Supported', 'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', 'reset-ids-Supported', 'ext-SupportedFeatures']
    
    #-----< SupportedFeatures >-----#
    SupportedFeatures = BIT_STR(name='SupportedFeatures', mode=MODE_TYPE)
    SupportedFeatures._cont = ASN1Dict([('odb-all-apn', 0), ('odb-HPLMN-APN', 1), ('odb-VPLMN-APN', 2), ('odb-all-og', 3), ('odb-all-international-og', 4), ('odb-all-int-og-not-to-HPLMN-country', 5), ('odb-all-interzonal-og', 6), ('odb-all-interzonal-og-not-to-HPLMN-country', 7), ('odb-all-interzonal-og-and-internat-og-not-to-HPLMN-country', 8), ('regSub', 9), ('trace', 10), ('lcs-all-PrivExcep', 11), ('lcs-universal', 12), ('lcs-CallSessionRelated', 13), ('lcs-CallSessionUnrelated', 14), ('lcs-PLMN-operator', 15), ('lcs-ServiceType', 16), ('lcs-all-MOLR-SS', 17), ('lcs-basicSelfLocation', 18), ('lcs-autonomousSelfLocation', 19), ('lcs-transferToThirdParty', 20), ('sm-mo-pp', 21), ('barring-OutgoingCalls', 22), ('baoc', 23), ('boic', 24), ('boicExHC', 25), ('localTimeZoneRetrieval', 26), ('additionalMsisdn', 27), ('smsInMME', 28), ('smsInSGSN', 29), ('ue-Reachability-Notification', 30), ('state-Location-Information-Retrieval', 31), ('partialPurge', 32), ('gddInSGSN', 33), ('sgsnCAMELCapability', 34), ('pcscf-Restoration', 35), ('dedicatedCoreNetworks', 36), ('non-IP-PDN-Type-APNs', 37), ('non-IP-PDP-Type-APNs', 38), ('nrAsSecondaryRAT', 39)])
    SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=26, ub=40)], ev=None, er=[])
    
    #-----< Ext-SupportedFeatures >-----#
    Ext_SupportedFeatures = BIT_STR(name='Ext-SupportedFeatures', mode=MODE_TYPE)
    Ext_SupportedFeatures._cont = ASN1Dict([('unlicensedSpectrumAsSecondaryRAT', 0)])
    Ext_SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< UE-SRVCC-Capability >-----#
    UE_SRVCC_Capability = ENUM(name='UE-SRVCC-Capability', mode=MODE_TYPE)
    UE_SRVCC_Capability._cont = ASN1Dict([('ue-srvcc-not-supported', 0), ('ue-srvcc-supported', 1)])
    UE_SRVCC_Capability._ext = []
    
    #-----< UpdateGprsLocationRes >-----#
    UpdateGprsLocationRes = SEQ(name='UpdateGprsLocationRes', mode=MODE_TYPE)
    _UpdateGprsLocationRes_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationRes_add_Capability = NULL(name='add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateGprsLocationRes_sgsn_mmeSeparationSupported = NULL(name='sgsn-mmeSeparationSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationRes_mmeRegisteredforSMS = NULL(name='mmeRegisteredforSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateGprsLocationRes._cont = ASN1Dict([
        ('hlr-Number', _UpdateGprsLocationRes_hlr_Number),
        ('extensionContainer', _UpdateGprsLocationRes_extensionContainer),
        ('add-Capability', _UpdateGprsLocationRes_add_Capability),
        ('sgsn-mmeSeparationSupported', _UpdateGprsLocationRes_sgsn_mmeSeparationSupported),
        ('mmeRegisteredforSMS', _UpdateGprsLocationRes_mmeRegisteredforSMS),
        ])
    UpdateGprsLocationRes._ext = ['add-Capability', 'sgsn-mmeSeparationSupported', 'mmeRegisteredforSMS']
    
    #-----< EPLMN-List >-----#
    EPLMN_List = SEQ_OF(name='EPLMN-List', mode=MODE_TYPE)
    _EPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    EPLMN_List._cont = _EPLMN_List__item_
    EPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentPLMN-List >-----#
    AdjacentPLMN_List = SEQ_OF(name='AdjacentPLMN-List', mode=MODE_TYPE)
    _AdjacentPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    AdjacentPLMN_List._cont = _AdjacentPLMN_List__item_
    AdjacentPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< ForwardAccessSignalling-Arg >-----#
    ForwardAccessSignalling_Arg = SEQ(name='ForwardAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ForwardAccessSignalling_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ForwardAccessSignalling_Arg_integrityProtectionInfo = OCT_STR(name='integrityProtectionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_encryptionInfo = OCT_STR(name='encryptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_keyStatus = ENUM(name='keyStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'KeyStatus')), opt=True)
    _ForwardAccessSignalling_Arg_allowedGSM_Algorithms = OCT_STR(name='allowedGSM-Algorithms', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms = SEQ(name='allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceInformation = OCT_STR(name='radioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceList = SEQ_OF(name='radioResourceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandover = OCT_STR(name='bssmap-ServiceHandover', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_ranap_ServiceHandover = OCT_STR(name='ranap-ServiceHandover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList = SEQ_OF(name='bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _ForwardAccessSignalling_Arg_currentlyUsedCodec = OCT_STR(name='currentlyUsedCodec', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_iuSupportedCodecsList = SEQ(name='iuSupportedCodecsList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator = NULL(name='rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardAccessSignalling_Arg_iuSelectedCodec = OCT_STR(name='iuSelectedCodec', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_alternativeChannelType = OCT_STR(name='alternativeChannelType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_tracePropagationList = SEQ(name='tracePropagationList', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor = SEQ(name='aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name='aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ForwardAccessSignalling_Arg_uesbi_Iu = SEQ(name='uesbi-Iu', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _ForwardAccessSignalling_Arg_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ForwardAccessSignalling_Arg._cont = ASN1Dict([
        ('an-APDU', _ForwardAccessSignalling_Arg_an_APDU),
        ('integrityProtectionInfo', _ForwardAccessSignalling_Arg_integrityProtectionInfo),
        ('encryptionInfo', _ForwardAccessSignalling_Arg_encryptionInfo),
        ('keyStatus', _ForwardAccessSignalling_Arg_keyStatus),
        ('allowedGSM-Algorithms', _ForwardAccessSignalling_Arg_allowedGSM_Algorithms),
        ('allowedUMTS-Algorithms', _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms),
        ('radioResourceInformation', _ForwardAccessSignalling_Arg_radioResourceInformation),
        ('extensionContainer', _ForwardAccessSignalling_Arg_extensionContainer),
        ('radioResourceList', _ForwardAccessSignalling_Arg_radioResourceList),
        ('bssmap-ServiceHandover', _ForwardAccessSignalling_Arg_bssmap_ServiceHandover),
        ('ranap-ServiceHandover', _ForwardAccessSignalling_Arg_ranap_ServiceHandover),
        ('bssmap-ServiceHandoverList', _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList),
        ('currentlyUsedCodec', _ForwardAccessSignalling_Arg_currentlyUsedCodec),
        ('iuSupportedCodecsList', _ForwardAccessSignalling_Arg_iuSupportedCodecsList),
        ('rab-ConfigurationIndicator', _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator),
        ('iuSelectedCodec', _ForwardAccessSignalling_Arg_iuSelectedCodec),
        ('alternativeChannelType', _ForwardAccessSignalling_Arg_alternativeChannelType),
        ('tracePropagationList', _ForwardAccessSignalling_Arg_tracePropagationList),
        ('aoipSupportedCodecsListAnchor', _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor),
        ('aoipSelectedCodecTarget', _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget),
        ('uesbi-Iu', _ForwardAccessSignalling_Arg_uesbi_Iu),
        ('imeisv', _ForwardAccessSignalling_Arg_imeisv),
        ])
    ForwardAccessSignalling_Arg._ext = ['radioResourceList', 'bssmap-ServiceHandover', 'ranap-ServiceHandover', 'bssmap-ServiceHandoverList', 'currentlyUsedCodec', 'iuSupportedCodecsList', 'rab-ConfigurationIndicator', 'iuSelectedCodec', 'alternativeChannelType', 'tracePropagationList', 'aoipSupportedCodecsListAnchor', 'aoipSelectedCodecTarget', 'uesbi-Iu', 'imeisv']
    
    #-----< AllowedGSM-Algorithms >-----#
    AllowedGSM_Algorithms = OCT_STR(name='AllowedGSM-Algorithms', mode=MODE_TYPE)
    AllowedGSM_Algorithms._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AllowedUMTS-Algorithms >-----#
    AllowedUMTS_Algorithms = SEQ(name='AllowedUMTS-Algorithms', mode=MODE_TYPE)
    _AllowedUMTS_Algorithms_integrityProtectionAlgorithms = OCT_STR(name='integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedIntegrityProtectionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_encryptionAlgorithms = OCT_STR(name='encryptionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedEncryptionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AllowedUMTS_Algorithms._cont = ASN1Dict([
        ('integrityProtectionAlgorithms', _AllowedUMTS_Algorithms_integrityProtectionAlgorithms),
        ('encryptionAlgorithms', _AllowedUMTS_Algorithms_encryptionAlgorithms),
        ('extensionContainer', _AllowedUMTS_Algorithms_extensionContainer),
        ])
    AllowedUMTS_Algorithms._ext = []
    
    #-----< PermittedIntegrityProtectionAlgorithms >-----#
    PermittedIntegrityProtectionAlgorithms = OCT_STR(name='PermittedIntegrityProtectionAlgorithms', mode=MODE_TYPE)
    PermittedIntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedIntegrityProtectionAlgorithmsLength >-----#
    maxPermittedIntegrityProtectionAlgorithmsLength = INT(name='maxPermittedIntegrityProtectionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedIntegrityProtectionAlgorithmsLength._val = 9
    
    #-----< PermittedEncryptionAlgorithms >-----#
    PermittedEncryptionAlgorithms = OCT_STR(name='PermittedEncryptionAlgorithms', mode=MODE_TYPE)
    PermittedEncryptionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedEncryptionAlgorithmsLength >-----#
    maxPermittedEncryptionAlgorithmsLength = INT(name='maxPermittedEncryptionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedEncryptionAlgorithmsLength._val = 9
    
    #-----< KeyStatus >-----#
    KeyStatus = ENUM(name='KeyStatus', mode=MODE_TYPE)
    KeyStatus._cont = ASN1Dict([('old', 0), ('new', 1)])
    KeyStatus._ext = []
    
    #-----< PrepareHO-Arg >-----#
    PrepareHO_Arg = SEQ(name='PrepareHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Arg_targetCellId = OCT_STR(name='targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareHO_Arg_ho_NumberNotRequired = NULL(name='ho-NumberNotRequired', mode=MODE_TYPE, opt=True)
    _PrepareHO_Arg_targetRNCId = OCT_STR(name='targetRNCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareHO_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Arg_multipleBearerRequested = NULL(name='multipleBearerRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PrepareHO_Arg_integrityProtectionInfo = OCT_STR(name='integrityProtectionInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _PrepareHO_Arg_encryptionInfo = OCT_STR(name='encryptionInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _PrepareHO_Arg_radioResourceInformation = OCT_STR(name='radioResourceInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_allowedGSM_Algorithms = OCT_STR(name='allowedGSM-Algorithms', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _PrepareHO_Arg_allowedUMTS_Algorithms = SEQ(name='allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _PrepareHO_Arg_radioResourceList = SEQ_OF(name='radioResourceList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _PrepareHO_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Arg_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandover = OCT_STR(name='bssmap-ServiceHandover', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_ranap_ServiceHandover = OCT_STR(name='ranap-ServiceHandover', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandoverList = SEQ_OF(name='bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _PrepareHO_Arg_asciCallReference = OCT_STR(name='asciCallReference', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ASCI-CallReference')), opt=True)
    _PrepareHO_Arg_geran_classmark = OCT_STR(name='geran-classmark', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareHO_Arg_iuCurrentlyUsedCodec = OCT_STR(name='iuCurrentlyUsedCodec', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Arg_iuSupportedCodecsList = SEQ(name='iuSupportedCodecsList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _PrepareHO_Arg_rab_ConfigurationIndicator = NULL(name='rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_uesbi_Iu = SEQ(name='uesbi-Iu', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _PrepareHO_Arg_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _PrepareHO_Arg_alternativeChannelType = OCT_STR(name='alternativeChannelType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_tracePropagationList = SEQ(name='tracePropagationList', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _PrepareHO_Arg_aoipSupportedCodecsListAnchor = SEQ(name='aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _PrepareHO_Arg_regionalSubscriptionData = SEQ_OF(name='regionalSubscriptionData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _PrepareHO_Arg_lclsGlobalCallReference = OCT_STR(name='lclsGlobalCallReference', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-GlobalCallReference')), opt=True)
    _PrepareHO_Arg_lcls_Negotiation = BIT_STR(name='lcls-Negotiation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-Negotiation')), opt=True)
    _PrepareHO_Arg_lcls_Configuration_Preference = BIT_STR(name='lcls-Configuration-Preference', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-ConfigurationPreference')), opt=True)
    _PrepareHO_Arg_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    PrepareHO_Arg._cont = ASN1Dict([
        ('targetCellId', _PrepareHO_Arg_targetCellId),
        ('ho-NumberNotRequired', _PrepareHO_Arg_ho_NumberNotRequired),
        ('targetRNCId', _PrepareHO_Arg_targetRNCId),
        ('an-APDU', _PrepareHO_Arg_an_APDU),
        ('multipleBearerRequested', _PrepareHO_Arg_multipleBearerRequested),
        ('imsi', _PrepareHO_Arg_imsi),
        ('integrityProtectionInfo', _PrepareHO_Arg_integrityProtectionInfo),
        ('encryptionInfo', _PrepareHO_Arg_encryptionInfo),
        ('radioResourceInformation', _PrepareHO_Arg_radioResourceInformation),
        ('allowedGSM-Algorithms', _PrepareHO_Arg_allowedGSM_Algorithms),
        ('allowedUMTS-Algorithms', _PrepareHO_Arg_allowedUMTS_Algorithms),
        ('radioResourceList', _PrepareHO_Arg_radioResourceList),
        ('extensionContainer', _PrepareHO_Arg_extensionContainer),
        ('rab-Id', _PrepareHO_Arg_rab_Id),
        ('bssmap-ServiceHandover', _PrepareHO_Arg_bssmap_ServiceHandover),
        ('ranap-ServiceHandover', _PrepareHO_Arg_ranap_ServiceHandover),
        ('bssmap-ServiceHandoverList', _PrepareHO_Arg_bssmap_ServiceHandoverList),
        ('asciCallReference', _PrepareHO_Arg_asciCallReference),
        ('geran-classmark', _PrepareHO_Arg_geran_classmark),
        ('iuCurrentlyUsedCodec', _PrepareHO_Arg_iuCurrentlyUsedCodec),
        ('iuSupportedCodecsList', _PrepareHO_Arg_iuSupportedCodecsList),
        ('rab-ConfigurationIndicator', _PrepareHO_Arg_rab_ConfigurationIndicator),
        ('uesbi-Iu', _PrepareHO_Arg_uesbi_Iu),
        ('imeisv', _PrepareHO_Arg_imeisv),
        ('alternativeChannelType', _PrepareHO_Arg_alternativeChannelType),
        ('tracePropagationList', _PrepareHO_Arg_tracePropagationList),
        ('aoipSupportedCodecsListAnchor', _PrepareHO_Arg_aoipSupportedCodecsListAnchor),
        ('regionalSubscriptionData', _PrepareHO_Arg_regionalSubscriptionData),
        ('lclsGlobalCallReference', _PrepareHO_Arg_lclsGlobalCallReference),
        ('lcls-Negotiation', _PrepareHO_Arg_lcls_Negotiation),
        ('lcls-Configuration-Preference', _PrepareHO_Arg_lcls_Configuration_Preference),
        ('csg-SubscriptionDataList', _PrepareHO_Arg_csg_SubscriptionDataList),
        ])
    PrepareHO_Arg._ext = ['rab-Id', 'bssmap-ServiceHandover', 'ranap-ServiceHandover', 'bssmap-ServiceHandoverList', 'asciCallReference', 'geran-classmark', 'iuCurrentlyUsedCodec', 'iuSupportedCodecsList', 'rab-ConfigurationIndicator', 'uesbi-Iu', 'imeisv', 'alternativeChannelType', 'tracePropagationList', 'aoipSupportedCodecsListAnchor', 'regionalSubscriptionData', 'lclsGlobalCallReference', 'lcls-Negotiation', 'lcls-Configuration-Preference', 'csg-SubscriptionDataList']
    
    #-----< LCLS-GlobalCallReference >-----#
    LCLS_GlobalCallReference = OCT_STR(name='LCLS-GlobalCallReference', mode=MODE_TYPE)
    LCLS_GlobalCallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=13, ub=15)], ev=None, er=[])
    
    #-----< LCLS-Negotiation >-----#
    LCLS_Negotiation = BIT_STR(name='LCLS-Negotiation', mode=MODE_TYPE)
    LCLS_Negotiation._cont = ASN1Dict([('permission-indicator-not-allowed-bit', 0), ('permission-indicator-spare-bit', 1)])
    LCLS_Negotiation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< LCLS-ConfigurationPreference >-----#
    LCLS_ConfigurationPreference = BIT_STR(name='LCLS-ConfigurationPreference', mode=MODE_TYPE)
    LCLS_ConfigurationPreference._cont = ASN1Dict([('forward-data-sending-indicator', 0), ('backward-data-sending-indicator', 1), ('forward-data-reception-indicator', 2), ('backward-data-reception-indicator', 3)])
    LCLS_ConfigurationPreference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverList >-----#
    BSSMAP_ServiceHandoverList = SEQ_OF(name='BSSMAP-ServiceHandoverList', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverInfo')))
    BSSMAP_ServiceHandoverList._cont = _BSSMAP_ServiceHandoverList__item_
    BSSMAP_ServiceHandoverList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverInfo >-----#
    BSSMAP_ServiceHandoverInfo = SEQ(name='BSSMAP-ServiceHandoverInfo', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover = OCT_STR(name='bssmap-ServiceHandover', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')))
    _BSSMAP_ServiceHandoverInfo_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    BSSMAP_ServiceHandoverInfo._cont = ASN1Dict([
        ('bssmap-ServiceHandover', _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover),
        ('rab-Id', _BSSMAP_ServiceHandoverInfo_rab_Id),
        ])
    BSSMAP_ServiceHandoverInfo._ext = []
    
    #-----< maxNumOfServiceHandovers >-----#
    maxNumOfServiceHandovers = INT(name='maxNumOfServiceHandovers', mode=MODE_VALUE)
    maxNumOfServiceHandovers._val = 7
    
    #-----< BSSMAP-ServiceHandover >-----#
    BSSMAP_ServiceHandover = OCT_STR(name='BSSMAP-ServiceHandover', mode=MODE_TYPE)
    BSSMAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RANAP-ServiceHandover >-----#
    RANAP_ServiceHandover = OCT_STR(name='RANAP-ServiceHandover', mode=MODE_TYPE)
    RANAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RadioResourceList >-----#
    RadioResourceList = SEQ_OF(name='RadioResourceList', mode=MODE_TYPE)
    _RadioResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResource')))
    RadioResourceList._cont = _RadioResourceList__item_
    RadioResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RadioResource >-----#
    RadioResource = SEQ(name='RadioResource', mode=MODE_TYPE)
    _RadioResource_radioResourceInformation = OCT_STR(name='radioResourceInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')))
    _RadioResource_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RadioResource._cont = ASN1Dict([
        ('radioResourceInformation', _RadioResource_radioResourceInformation),
        ('rab-Id', _RadioResource_rab_Id),
        ])
    RadioResource._ext = []
    
    #-----< maxNumOfRadioResources >-----#
    maxNumOfRadioResources = INT(name='maxNumOfRadioResources', mode=MODE_VALUE)
    maxNumOfRadioResources._val = 7
    
    #-----< PrepareHO-Res >-----#
    PrepareHO_Res = SEQ(name='PrepareHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Res_handoverNumber = OCT_STR(name='handoverNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PrepareHO_Res_relocationNumberList = SEQ_OF(name='relocationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumberList')), opt=True)
    _PrepareHO_Res_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Res_multicallBearerInfo = INT(name='multicallBearerInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MulticallBearerInfo')), opt=True)
    _PrepareHO_Res_multipleBearerNotSupported = NULL(name='multipleBearerNotSupported', mode=MODE_TYPE, opt=True)
    _PrepareHO_Res_selectedUMTS_Algorithms = SEQ(name='selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _PrepareHO_Res_chosenRadioResourceInformation = SEQ(name='chosenRadioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _PrepareHO_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Res_iuSelectedCodec = OCT_STR(name='iuSelectedCodec', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Res_iuAvailableCodecsList = SEQ(name='iuAvailableCodecsList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _PrepareHO_Res_aoipSelectedCodecTarget = OCT_STR(name='aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _PrepareHO_Res_aoipAvailableCodecsListMap = SEQ(name='aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    PrepareHO_Res._cont = ASN1Dict([
        ('handoverNumber', _PrepareHO_Res_handoverNumber),
        ('relocationNumberList', _PrepareHO_Res_relocationNumberList),
        ('an-APDU', _PrepareHO_Res_an_APDU),
        ('multicallBearerInfo', _PrepareHO_Res_multicallBearerInfo),
        ('multipleBearerNotSupported', _PrepareHO_Res_multipleBearerNotSupported),
        ('selectedUMTS-Algorithms', _PrepareHO_Res_selectedUMTS_Algorithms),
        ('chosenRadioResourceInformation', _PrepareHO_Res_chosenRadioResourceInformation),
        ('extensionContainer', _PrepareHO_Res_extensionContainer),
        ('iuSelectedCodec', _PrepareHO_Res_iuSelectedCodec),
        ('iuAvailableCodecsList', _PrepareHO_Res_iuAvailableCodecsList),
        ('aoipSelectedCodecTarget', _PrepareHO_Res_aoipSelectedCodecTarget),
        ('aoipAvailableCodecsListMap', _PrepareHO_Res_aoipAvailableCodecsListMap),
        ])
    PrepareHO_Res._ext = ['iuSelectedCodec', 'iuAvailableCodecsList', 'aoipSelectedCodecTarget', 'aoipAvailableCodecsListMap']
    
    #-----< SelectedUMTS-Algorithms >-----#
    SelectedUMTS_Algorithms = SEQ(name='SelectedUMTS-Algorithms', mode=MODE_TYPE)
    _SelectedUMTS_Algorithms_integrityProtectionAlgorithm = OCT_STR(name='integrityProtectionAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenIntegrityProtectionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_encryptionAlgorithm = OCT_STR(name='encryptionAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenEncryptionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SelectedUMTS_Algorithms._cont = ASN1Dict([
        ('integrityProtectionAlgorithm', _SelectedUMTS_Algorithms_integrityProtectionAlgorithm),
        ('encryptionAlgorithm', _SelectedUMTS_Algorithms_encryptionAlgorithm),
        ('extensionContainer', _SelectedUMTS_Algorithms_extensionContainer),
        ])
    SelectedUMTS_Algorithms._ext = []
    
    #-----< ChosenIntegrityProtectionAlgorithm >-----#
    ChosenIntegrityProtectionAlgorithm = OCT_STR(name='ChosenIntegrityProtectionAlgorithm', mode=MODE_TYPE)
    ChosenIntegrityProtectionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenEncryptionAlgorithm >-----#
    ChosenEncryptionAlgorithm = OCT_STR(name='ChosenEncryptionAlgorithm', mode=MODE_TYPE)
    ChosenEncryptionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenRadioResourceInformation >-----#
    ChosenRadioResourceInformation = SEQ(name='ChosenRadioResourceInformation', mode=MODE_TYPE)
    _ChosenRadioResourceInformation_chosenChannelInfo = OCT_STR(name='chosenChannelInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenChannelInfo')), opt=True)
    _ChosenRadioResourceInformation_chosenSpeechVersion = OCT_STR(name='chosenSpeechVersion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenSpeechVersion')), opt=True)
    ChosenRadioResourceInformation._cont = ASN1Dict([
        ('chosenChannelInfo', _ChosenRadioResourceInformation_chosenChannelInfo),
        ('chosenSpeechVersion', _ChosenRadioResourceInformation_chosenSpeechVersion),
        ])
    ChosenRadioResourceInformation._ext = []
    
    #-----< ChosenChannelInfo >-----#
    ChosenChannelInfo = OCT_STR(name='ChosenChannelInfo', mode=MODE_TYPE)
    ChosenChannelInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenSpeechVersion >-----#
    ChosenSpeechVersion = OCT_STR(name='ChosenSpeechVersion', mode=MODE_TYPE)
    ChosenSpeechVersion._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PrepareSubsequentHO-Arg >-----#
    PrepareSubsequentHO_Arg = SEQ(name='PrepareSubsequentHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Arg_targetCellId = OCT_STR(name='targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareSubsequentHO_Arg_targetMSC_Number = OCT_STR(name='targetMSC-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _PrepareSubsequentHO_Arg_targetRNCId = OCT_STR(name='targetRNCId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareSubsequentHO_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareSubsequentHO_Arg_selectedRab_Id = INT(name='selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareSubsequentHO_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareSubsequentHO_Arg_geran_classmark = OCT_STR(name='geran-classmark', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator = NULL(name='rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrepareSubsequentHO_Arg._cont = ASN1Dict([
        ('targetCellId', _PrepareSubsequentHO_Arg_targetCellId),
        ('targetMSC-Number', _PrepareSubsequentHO_Arg_targetMSC_Number),
        ('targetRNCId', _PrepareSubsequentHO_Arg_targetRNCId),
        ('an-APDU', _PrepareSubsequentHO_Arg_an_APDU),
        ('selectedRab-Id', _PrepareSubsequentHO_Arg_selectedRab_Id),
        ('extensionContainer', _PrepareSubsequentHO_Arg_extensionContainer),
        ('geran-classmark', _PrepareSubsequentHO_Arg_geran_classmark),
        ('rab-ConfigurationIndicator', _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator),
        ])
    PrepareSubsequentHO_Arg._ext = ['geran-classmark', 'rab-ConfigurationIndicator']
    
    #-----< PrepareSubsequentHO-Res >-----#
    PrepareSubsequentHO_Res = SEQ(name='PrepareSubsequentHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Res_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _PrepareSubsequentHO_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PrepareSubsequentHO_Res._cont = ASN1Dict([
        ('an-APDU', _PrepareSubsequentHO_Res_an_APDU),
        ('extensionContainer', _PrepareSubsequentHO_Res_extensionContainer),
        ])
    PrepareSubsequentHO_Res._ext = []
    
    #-----< ProcessAccessSignalling-Arg >-----#
    ProcessAccessSignalling_Arg = SEQ(name='ProcessAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProcessAccessSignalling_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms = SEQ(name='selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _ProcessAccessSignalling_Arg_selectedGSM_Algorithm = OCT_STR(name='selectedGSM-Algorithm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedGSM-Algorithm')), opt=True)
    _ProcessAccessSignalling_Arg_chosenRadioResourceInformation = SEQ(name='chosenRadioResourceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _ProcessAccessSignalling_Arg_selectedRab_Id = INT(name='selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _ProcessAccessSignalling_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProcessAccessSignalling_Arg_iUSelectedCodec = OCT_STR(name='iUSelectedCodec', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ProcessAccessSignalling_Arg_iuAvailableCodecsList = SEQ(name='iuAvailableCodecsList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name='aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap = SEQ(name='aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    ProcessAccessSignalling_Arg._cont = ASN1Dict([
        ('an-APDU', _ProcessAccessSignalling_Arg_an_APDU),
        ('selectedUMTS-Algorithms', _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms),
        ('selectedGSM-Algorithm', _ProcessAccessSignalling_Arg_selectedGSM_Algorithm),
        ('chosenRadioResourceInformation', _ProcessAccessSignalling_Arg_chosenRadioResourceInformation),
        ('selectedRab-Id', _ProcessAccessSignalling_Arg_selectedRab_Id),
        ('extensionContainer', _ProcessAccessSignalling_Arg_extensionContainer),
        ('iUSelectedCodec', _ProcessAccessSignalling_Arg_iUSelectedCodec),
        ('iuAvailableCodecsList', _ProcessAccessSignalling_Arg_iuAvailableCodecsList),
        ('aoipSelectedCodecTarget', _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget),
        ('aoipAvailableCodecsListMap', _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap),
        ])
    ProcessAccessSignalling_Arg._ext = ['iUSelectedCodec', 'iuAvailableCodecsList', 'aoipSelectedCodecTarget', 'aoipAvailableCodecsListMap']
    
    #-----< AoIPCodecsList >-----#
    AoIPCodecsList = SEQ(name='AoIPCodecsList', mode=MODE_TYPE)
    _AoIPCodecsList_codec1 = OCT_STR(name='codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')))
    _AoIPCodecsList_codec2 = OCT_STR(name='codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec3 = OCT_STR(name='codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec4 = OCT_STR(name='codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec5 = OCT_STR(name='codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec6 = OCT_STR(name='codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec7 = OCT_STR(name='codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec8 = OCT_STR(name='codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AoIPCodecsList._cont = ASN1Dict([
        ('codec1', _AoIPCodecsList_codec1),
        ('codec2', _AoIPCodecsList_codec2),
        ('codec3', _AoIPCodecsList_codec3),
        ('codec4', _AoIPCodecsList_codec4),
        ('codec5', _AoIPCodecsList_codec5),
        ('codec6', _AoIPCodecsList_codec6),
        ('codec7', _AoIPCodecsList_codec7),
        ('codec8', _AoIPCodecsList_codec8),
        ('extensionContainer', _AoIPCodecsList_extensionContainer),
        ])
    AoIPCodecsList._ext = []
    
    #-----< AoIPCodec >-----#
    AoIPCodec = OCT_STR(name='AoIPCodec', mode=MODE_TYPE)
    AoIPCodec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SupportedCodecsList >-----#
    SupportedCodecsList = SEQ(name='SupportedCodecsList', mode=MODE_TYPE)
    _SupportedCodecsList_utranCodecList = SEQ(name='utranCodecList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_geranCodecList = SEQ(name='geranCodecList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SupportedCodecsList._cont = ASN1Dict([
        ('utranCodecList', _SupportedCodecsList_utranCodecList),
        ('geranCodecList', _SupportedCodecsList_geranCodecList),
        ('extensionContainer', _SupportedCodecsList_extensionContainer),
        ])
    SupportedCodecsList._ext = []
    
    #-----< CodecList >-----#
    CodecList = SEQ(name='CodecList', mode=MODE_TYPE)
    _CodecList_codec1 = OCT_STR(name='codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')))
    _CodecList_codec2 = OCT_STR(name='codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec3 = OCT_STR(name='codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec4 = OCT_STR(name='codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec5 = OCT_STR(name='codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec6 = OCT_STR(name='codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec7 = OCT_STR(name='codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec8 = OCT_STR(name='codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CodecList._cont = ASN1Dict([
        ('codec1', _CodecList_codec1),
        ('codec2', _CodecList_codec2),
        ('codec3', _CodecList_codec3),
        ('codec4', _CodecList_codec4),
        ('codec5', _CodecList_codec5),
        ('codec6', _CodecList_codec6),
        ('codec7', _CodecList_codec7),
        ('codec8', _CodecList_codec8),
        ('extensionContainer', _CodecList_extensionContainer),
        ])
    CodecList._ext = []
    
    #-----< Codec >-----#
    Codec = OCT_STR(name='Codec', mode=MODE_TYPE)
    Codec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name='GERAN-Classmark', mode=MODE_TYPE)
    GERAN_Classmark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=87)], ev=None, er=[])
    
    #-----< SelectedGSM-Algorithm >-----#
    SelectedGSM_Algorithm = OCT_STR(name='SelectedGSM-Algorithm', mode=MODE_TYPE)
    SelectedGSM_Algorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendEndSignal-Arg >-----#
    SendEndSignal_Arg = SEQ(name='SendEndSignal-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendEndSignal_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _SendEndSignal_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Arg._cont = ASN1Dict([
        ('an-APDU', _SendEndSignal_Arg_an_APDU),
        ('extensionContainer', _SendEndSignal_Arg_extensionContainer),
        ])
    SendEndSignal_Arg._ext = []
    
    #-----< SendEndSignal-Res >-----#
    SendEndSignal_Res = SEQ(name='SendEndSignal-Res', mode=MODE_TYPE)
    _SendEndSignal_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Res._cont = ASN1Dict([
        ('extensionContainer', _SendEndSignal_Res_extensionContainer),
        ])
    SendEndSignal_Res._ext = []
    
    #-----< RNCId >-----#
    RNCId = OCT_STR(name='RNCId', mode=MODE_TYPE)
    RNCId._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< RelocationNumberList >-----#
    RelocationNumberList = SEQ_OF(name='RelocationNumberList', mode=MODE_TYPE)
    _RelocationNumberList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumber')))
    RelocationNumberList._cont = _RelocationNumberList__item_
    RelocationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MulticallBearerInfo >-----#
    MulticallBearerInfo = INT(name='MulticallBearerInfo', mode=MODE_TYPE)
    MulticallBearerInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RelocationNumber >-----#
    RelocationNumber = SEQ(name='RelocationNumber', mode=MODE_TYPE)
    _RelocationNumber_handoverNumber = OCT_STR(name='handoverNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RelocationNumber_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RelocationNumber._cont = ASN1Dict([
        ('handoverNumber', _RelocationNumber_handoverNumber),
        ('rab-Id', _RelocationNumber_rab_Id),
        ])
    RelocationNumber._ext = []
    
    #-----< RAB-Id >-----#
    RAB_Id = INT(name='RAB-Id', mode=MODE_TYPE)
    RAB_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< maxNrOfRABs >-----#
    maxNrOfRABs = INT(name='maxNrOfRABs', mode=MODE_VALUE)
    maxNrOfRABs._val = 255
    
    #-----< maxNumOfRelocationNumber >-----#
    maxNumOfRelocationNumber = INT(name='maxNumOfRelocationNumber', mode=MODE_VALUE)
    maxNumOfRelocationNumber._val = 7
    
    #-----< RadioResourceInformation >-----#
    RadioResourceInformation = OCT_STR(name='RadioResourceInformation', mode=MODE_TYPE)
    RadioResourceInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=13)], ev=None, er=[])
    
    #-----< IntegrityProtectionInformation >-----#
    IntegrityProtectionInformation = OCT_STR(name='IntegrityProtectionInformation', mode=MODE_TYPE)
    IntegrityProtectionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfIntegrityInfo >-----#
    maxNumOfIntegrityInfo = INT(name='maxNumOfIntegrityInfo', mode=MODE_VALUE)
    maxNumOfIntegrityInfo._val = 100
    
    #-----< EncryptionInformation >-----#
    EncryptionInformation = OCT_STR(name='EncryptionInformation', mode=MODE_TYPE)
    EncryptionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfEncryptionInfo >-----#
    maxNumOfEncryptionInfo = INT(name='maxNumOfEncryptionInfo', mode=MODE_VALUE)
    maxNumOfEncryptionInfo._val = 100
    
    #-----< SendAuthenticationInfoArg >-----#
    SendAuthenticationInfoArg = SEQ(name='SendAuthenticationInfoArg', mode=MODE_TYPE)
    _SendAuthenticationInfoArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendAuthenticationInfoArg_numberOfRequestedVectors = INT(name='numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')))
    _SendAuthenticationInfoArg_segmentationProhibited = NULL(name='segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendAuthenticationInfoArg_immediateResponsePreferred = NULL(name='immediateResponsePreferred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_re_synchronisationInfo = SEQ(name='re-synchronisationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Re-synchronisationInfo')), opt=True)
    _SendAuthenticationInfoArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoArg_requestingNodeType = ENUM(name='requestingNodeType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestingNodeType')), opt=True)
    _SendAuthenticationInfoArg_requestingPLMN_Id = OCT_STR(name='requestingPLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors = INT(name='numberOfRequestedAdditional-Vectors', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendAuthenticationInfoArg_additionalVectorsAreForEPS = NULL(name='additionalVectorsAreForEPS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_ueUsageTypeRequestIndication = NULL(name='ueUsageTypeRequestIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendAuthenticationInfoArg._cont = ASN1Dict([
        ('imsi', _SendAuthenticationInfoArg_imsi),
        ('numberOfRequestedVectors', _SendAuthenticationInfoArg_numberOfRequestedVectors),
        ('segmentationProhibited', _SendAuthenticationInfoArg_segmentationProhibited),
        ('immediateResponsePreferred', _SendAuthenticationInfoArg_immediateResponsePreferred),
        ('re-synchronisationInfo', _SendAuthenticationInfoArg_re_synchronisationInfo),
        ('extensionContainer', _SendAuthenticationInfoArg_extensionContainer),
        ('requestingNodeType', _SendAuthenticationInfoArg_requestingNodeType),
        ('requestingPLMN-Id', _SendAuthenticationInfoArg_requestingPLMN_Id),
        ('numberOfRequestedAdditional-Vectors', _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors),
        ('additionalVectorsAreForEPS', _SendAuthenticationInfoArg_additionalVectorsAreForEPS),
        ('ueUsageTypeRequestIndication', _SendAuthenticationInfoArg_ueUsageTypeRequestIndication),
        ])
    SendAuthenticationInfoArg._ext = ['requestingNodeType', 'requestingPLMN-Id', 'numberOfRequestedAdditional-Vectors', 'additionalVectorsAreForEPS', 'ueUsageTypeRequestIndication']
    
    #-----< NumberOfRequestedVectors >-----#
    NumberOfRequestedVectors = INT(name='NumberOfRequestedVectors', mode=MODE_TYPE)
    NumberOfRequestedVectors._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Re-synchronisationInfo >-----#
    Re_synchronisationInfo = SEQ(name='Re-synchronisationInfo', mode=MODE_TYPE)
    _Re_synchronisationInfo_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _Re_synchronisationInfo_auts = OCT_STR(name='auts', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTS')))
    Re_synchronisationInfo._cont = ASN1Dict([
        ('rand', _Re_synchronisationInfo_rand),
        ('auts', _Re_synchronisationInfo_auts),
        ])
    Re_synchronisationInfo._ext = []
    
    #-----< SendAuthenticationInfoRes >-----#
    SendAuthenticationInfoRes = SEQ(name='SendAuthenticationInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendAuthenticationInfoRes_authenticationSetList = CHOICE(name='authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoRes_eps_AuthenticationSetList = SEQ_OF(name='eps-AuthenticationSetList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_ueUsageType = OCT_STR(name='ueUsageType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    SendAuthenticationInfoRes._cont = ASN1Dict([
        ('authenticationSetList', _SendAuthenticationInfoRes_authenticationSetList),
        ('extensionContainer', _SendAuthenticationInfoRes_extensionContainer),
        ('eps-AuthenticationSetList', _SendAuthenticationInfoRes_eps_AuthenticationSetList),
        ('ueUsageType', _SendAuthenticationInfoRes_ueUsageType),
        ])
    SendAuthenticationInfoRes._ext = ['eps-AuthenticationSetList', 'ueUsageType']
    
    #-----< EPS-AuthenticationSetList >-----#
    EPS_AuthenticationSetList = SEQ_OF(name='EPS-AuthenticationSetList', mode=MODE_TYPE)
    _EPS_AuthenticationSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPC-AV')))
    EPS_AuthenticationSetList._cont = _EPS_AuthenticationSetList__item_
    EPS_AuthenticationSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< UE-UsageType >-----#
    UE_UsageType = OCT_STR(name='UE-UsageType', mode=MODE_TYPE)
    UE_UsageType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< EPC-AV >-----#
    EPC_AV = SEQ(name='EPC-AV', mode=MODE_TYPE)
    _EPC_AV_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _EPC_AV_xres = OCT_STR(name='xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _EPC_AV_autn = OCT_STR(name='autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    _EPC_AV_kasme = OCT_STR(name='kasme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KASME')))
    _EPC_AV_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPC_AV._cont = ASN1Dict([
        ('rand', _EPC_AV_rand),
        ('xres', _EPC_AV_xres),
        ('autn', _EPC_AV_autn),
        ('kasme', _EPC_AV_kasme),
        ('extensionContainer', _EPC_AV_extensionContainer),
        ])
    EPC_AV._ext = []
    
    #-----< KASME >-----#
    KASME = OCT_STR(name='KASME', mode=MODE_TYPE)
    KASME._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< RequestingNodeType >-----#
    RequestingNodeType = ENUM(name='RequestingNodeType', mode=MODE_TYPE)
    RequestingNodeType._cont = ASN1Dict([('vlr', 0), ('sgsn', 1), ('s-cscf', 2), ('bsf', 3), ('gan-aaa-server', 4), ('wlan-aaa-server', 5), ('mme', 16), ('mme-sgsn', 17)])
    RequestingNodeType._ext = ['s-cscf', 'bsf', 'gan-aaa-server', 'wlan-aaa-server', 'mme', 'mme-sgsn']
    
    #-----< CheckIMEI-Arg >-----#
    CheckIMEI_Arg = SEQ(name='CheckIMEI-Arg', mode=MODE_TYPE)
    _CheckIMEI_Arg_imei = OCT_STR(name='imei', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _CheckIMEI_Arg_requestedEquipmentInfo = BIT_STR(name='requestedEquipmentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedEquipmentInfo')))
    _CheckIMEI_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Arg._cont = ASN1Dict([
        ('imei', _CheckIMEI_Arg_imei),
        ('requestedEquipmentInfo', _CheckIMEI_Arg_requestedEquipmentInfo),
        ('extensionContainer', _CheckIMEI_Arg_extensionContainer),
        ])
    CheckIMEI_Arg._ext = []
    
    #-----< CheckIMEI-Res >-----#
    CheckIMEI_Res = SEQ(name='CheckIMEI-Res', mode=MODE_TYPE)
    _CheckIMEI_Res_equipmentStatus = ENUM(name='equipmentStatus', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EquipmentStatus')), opt=True)
    _CheckIMEI_Res_bmuef = SEQ(name='bmuef', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _CheckIMEI_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Res._cont = ASN1Dict([
        ('equipmentStatus', _CheckIMEI_Res_equipmentStatus),
        ('bmuef', _CheckIMEI_Res_bmuef),
        ('extensionContainer', _CheckIMEI_Res_extensionContainer),
        ])
    CheckIMEI_Res._ext = []
    
    #-----< RequestedEquipmentInfo >-----#
    RequestedEquipmentInfo = BIT_STR(name='RequestedEquipmentInfo', mode=MODE_TYPE)
    RequestedEquipmentInfo._cont = ASN1Dict([('equipmentStatus', 0), ('bmuef', 1)])
    RequestedEquipmentInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UESBI-Iu >-----#
    UESBI_Iu = SEQ(name='UESBI-Iu', mode=MODE_TYPE)
    _UESBI_Iu_uesbi_IuA = BIT_STR(name='uesbi-IuA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuA')), opt=True)
    _UESBI_Iu_uesbi_IuB = BIT_STR(name='uesbi-IuB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuB')), opt=True)
    UESBI_Iu._cont = ASN1Dict([
        ('uesbi-IuA', _UESBI_Iu_uesbi_IuA),
        ('uesbi-IuB', _UESBI_Iu_uesbi_IuB),
        ])
    UESBI_Iu._ext = []
    
    #-----< UESBI-IuA >-----#
    UESBI_IuA = BIT_STR(name='UESBI-IuA', mode=MODE_TYPE)
    UESBI_IuA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UESBI-IuB >-----#
    UESBI_IuB = BIT_STR(name='UESBI-IuB', mode=MODE_TYPE)
    UESBI_IuB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< EquipmentStatus >-----#
    EquipmentStatus = ENUM(name='EquipmentStatus', mode=MODE_TYPE)
    EquipmentStatus._cont = ASN1Dict([('whiteListed', 0), ('blackListed', 1), ('greyListed', 2)])
    EquipmentStatus._ext = None
    
    #-----< InsertSubscriberDataArg >-----#
    InsertSubscriberDataArg = SEQ(name='InsertSubscriberDataArg', mode=MODE_TYPE)
    _InsertSubscriberDataArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _InsertSubscriberDataArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_category = OCT_STR(name='category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _InsertSubscriberDataArg_subscriberStatus = ENUM(name='subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _InsertSubscriberDataArg_bearerServiceList = SEQ_OF(name='bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataArg_teleserviceList = SEQ_OF(name='teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataArg_provisionedSS = SEQ_OF(name='provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _InsertSubscriberDataArg_odb_Data = SEQ(name='odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name='roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_regionalSubscriptionData = SEQ_OF(name='regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _InsertSubscriberDataArg_vbsSubscriptionData = SEQ_OF(name='vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _InsertSubscriberDataArg_vgcsSubscriptionData = SEQ_OF(name='vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _InsertSubscriberDataArg_vlrCamelSubscriptionInfo = SEQ(name='vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataArg_naea_PreferredCI = SEQ(name='naea-PreferredCI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _InsertSubscriberDataArg_gprsSubscriptionData = SEQ(name='gprsSubscriptionData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionData')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature = NULL(name='roamingRestrictedInSgsnDueToUnsupportedFeature', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_networkAccessMode = ENUM(name='networkAccessMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NetworkAccessMode')), opt=True)
    _InsertSubscriberDataArg_lsaInformation = SEQ(name='lsaInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformation')), opt=True)
    _InsertSubscriberDataArg_lmu_Indicator = NULL(name='lmu-Indicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_lcsInformation = SEQ(name='lcsInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCSInformation')), opt=True)
    _InsertSubscriberDataArg_istAlertTimer = INT(name='istAlertTimer', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _InsertSubscriberDataArg_superChargerSupportedInHLR = OCT_STR(name='superChargerSupportedInHLR', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')), opt=True)
    _InsertSubscriberDataArg_mc_SS_Info = SEQ(name='mc-SS-Info', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-SS-Info')), opt=True)
    _InsertSubscriberDataArg_cs_AllocationRetentionPriority = OCT_STR(name='cs-AllocationRetentionPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CS-AllocationRetentionPriority')), opt=True)
    _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo = SEQ(name='sgsn-CAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-CAMEL-SubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _InsertSubscriberDataArg_accessRestrictionData = BIT_STR(name='accessRestrictionData', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_ics_Indicator = BOOL(name='ics-Indicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_eps_SubscriptionData = SEQ(name='eps-SubscriptionData', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionData')), opt=True)
    _InsertSubscriberDataArg_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator = NULL(name='ue-ReachabilityRequestIndicator', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_mme_Name = OCT_STR(name='mme-Name', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer = INT(name='subscribedPeriodicRAUTAUtimer', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicRAUTAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmnLIPAAllowed = NULL(name='vplmnLIPAAllowed', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_mdtUserConsent = BOOL(name='mdtUserConsent', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicLAUtimer = INT(name='subscribedPeriodicLAUtimer', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicLAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList = SEQ_OF(name='vplmn-Csg-SubscriptionDataList', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VPLMN-CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_additionalMSISDN = OCT_STR(name='additionalMSISDN', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision = NULL(name='psAndSMS-OnlyServiceProvision', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_smsInSGSNAllowed = NULL(name='smsInSGSNAllowed', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator = NULL(name='cs-to-ps-SRVCC-Allowed-Indicator', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_pcscf_Restoration_Request = NULL(name='pcscf-Restoration-Request', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_adjacentAccessRestrictionDataList = SEQ_OF(name='adjacentAccessRestrictionDataList', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionDataList')), opt=True)
    _InsertSubscriberDataArg_imsi_Group_Id_List = SEQ_OF(name='imsi-Group-Id-List', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupIdList')), opt=True)
    _InsertSubscriberDataArg_ueUsageType = OCT_STR(name='ueUsageType', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator = NULL(name='userPlaneIntegrityProtectionIndicator', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count = INT(name='dl-Buffering-Suggested-Packet-Count', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DL-Buffering-Suggested-Packet-Count')), opt=True)
    _InsertSubscriberDataArg_reset_Id_List = SEQ_OF(name='reset-Id-List', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _InsertSubscriberDataArg_eDRX_Cycle_Length_List = SEQ_OF(name='eDRX-Cycle-Length-List', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-List')), opt=True)
    _InsertSubscriberDataArg_ext_AccessRestrictionData = BIT_STR(name='ext-AccessRestrictionData', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator = NULL(name='iab-Operation-Allowed-Indicator', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    InsertSubscriberDataArg._cont = ASN1Dict([
        ('imsi', _InsertSubscriberDataArg_imsi),
        ('msisdn', _InsertSubscriberDataArg_msisdn),
        ('category', _InsertSubscriberDataArg_category),
        ('subscriberStatus', _InsertSubscriberDataArg_subscriberStatus),
        ('bearerServiceList', _InsertSubscriberDataArg_bearerServiceList),
        ('teleserviceList', _InsertSubscriberDataArg_teleserviceList),
        ('provisionedSS', _InsertSubscriberDataArg_provisionedSS),
        ('odb-Data', _InsertSubscriberDataArg_odb_Data),
        ('roamingRestrictionDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        ('regionalSubscriptionData', _InsertSubscriberDataArg_regionalSubscriptionData),
        ('vbsSubscriptionData', _InsertSubscriberDataArg_vbsSubscriptionData),
        ('vgcsSubscriptionData', _InsertSubscriberDataArg_vgcsSubscriptionData),
        ('vlrCamelSubscriptionInfo', _InsertSubscriberDataArg_vlrCamelSubscriptionInfo),
        ('extensionContainer', _InsertSubscriberDataArg_extensionContainer),
        ('naea-PreferredCI', _InsertSubscriberDataArg_naea_PreferredCI),
        ('gprsSubscriptionData', _InsertSubscriberDataArg_gprsSubscriptionData),
        ('roamingRestrictedInSgsnDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature),
        ('networkAccessMode', _InsertSubscriberDataArg_networkAccessMode),
        ('lsaInformation', _InsertSubscriberDataArg_lsaInformation),
        ('lmu-Indicator', _InsertSubscriberDataArg_lmu_Indicator),
        ('lcsInformation', _InsertSubscriberDataArg_lcsInformation),
        ('istAlertTimer', _InsertSubscriberDataArg_istAlertTimer),
        ('superChargerSupportedInHLR', _InsertSubscriberDataArg_superChargerSupportedInHLR),
        ('mc-SS-Info', _InsertSubscriberDataArg_mc_SS_Info),
        ('cs-AllocationRetentionPriority', _InsertSubscriberDataArg_cs_AllocationRetentionPriority),
        ('sgsn-CAMEL-SubscriptionInfo', _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo),
        ('chargingCharacteristics', _InsertSubscriberDataArg_chargingCharacteristics),
        ('accessRestrictionData', _InsertSubscriberDataArg_accessRestrictionData),
        ('ics-Indicator', _InsertSubscriberDataArg_ics_Indicator),
        ('eps-SubscriptionData', _InsertSubscriberDataArg_eps_SubscriptionData),
        ('csg-SubscriptionDataList', _InsertSubscriberDataArg_csg_SubscriptionDataList),
        ('ue-ReachabilityRequestIndicator', _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator),
        ('sgsn-Number', _InsertSubscriberDataArg_sgsn_Number),
        ('mme-Name', _InsertSubscriberDataArg_mme_Name),
        ('subscribedPeriodicRAUTAUtimer', _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer),
        ('vplmnLIPAAllowed', _InsertSubscriberDataArg_vplmnLIPAAllowed),
        ('mdtUserConsent', _InsertSubscriberDataArg_mdtUserConsent),
        ('subscribedPeriodicLAUtimer', _InsertSubscriberDataArg_subscribedPeriodicLAUtimer),
        ('vplmn-Csg-SubscriptionDataList', _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList),
        ('additionalMSISDN', _InsertSubscriberDataArg_additionalMSISDN),
        ('psAndSMS-OnlyServiceProvision', _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision),
        ('smsInSGSNAllowed', _InsertSubscriberDataArg_smsInSGSNAllowed),
        ('cs-to-ps-SRVCC-Allowed-Indicator', _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator),
        ('pcscf-Restoration-Request', _InsertSubscriberDataArg_pcscf_Restoration_Request),
        ('adjacentAccessRestrictionDataList', _InsertSubscriberDataArg_adjacentAccessRestrictionDataList),
        ('imsi-Group-Id-List', _InsertSubscriberDataArg_imsi_Group_Id_List),
        ('ueUsageType', _InsertSubscriberDataArg_ueUsageType),
        ('userPlaneIntegrityProtectionIndicator', _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator),
        ('dl-Buffering-Suggested-Packet-Count', _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count),
        ('reset-Id-List', _InsertSubscriberDataArg_reset_Id_List),
        ('eDRX-Cycle-Length-List', _InsertSubscriberDataArg_eDRX_Cycle_Length_List),
        ('ext-AccessRestrictionData', _InsertSubscriberDataArg_ext_AccessRestrictionData),
        ('iab-Operation-Allowed-Indicator', _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator),
        ])
    InsertSubscriberDataArg._ext = ['naea-PreferredCI', 'gprsSubscriptionData', 'roamingRestrictedInSgsnDueToUnsupportedFeature', 'networkAccessMode', 'lsaInformation', 'lmu-Indicator', 'lcsInformation', 'istAlertTimer', 'superChargerSupportedInHLR', 'mc-SS-Info', 'cs-AllocationRetentionPriority', 'sgsn-CAMEL-SubscriptionInfo', 'chargingCharacteristics', 'accessRestrictionData', 'ics-Indicator', 'eps-SubscriptionData', 'csg-SubscriptionDataList', 'ue-ReachabilityRequestIndicator', 'sgsn-Number', 'mme-Name', 'subscribedPeriodicRAUTAUtimer', 'vplmnLIPAAllowed', 'mdtUserConsent', 'subscribedPeriodicLAUtimer', 'vplmn-Csg-SubscriptionDataList', 'additionalMSISDN', 'psAndSMS-OnlyServiceProvision', 'smsInSGSNAllowed', 'cs-to-ps-SRVCC-Allowed-Indicator', 'pcscf-Restoration-Request', 'adjacentAccessRestrictionDataList', 'imsi-Group-Id-List', 'ueUsageType', 'userPlaneIntegrityProtectionIndicator', 'dl-Buffering-Suggested-Packet-Count', 'reset-Id-List', 'eDRX-Cycle-Length-List', 'ext-AccessRestrictionData', 'iab-Operation-Allowed-Indicator']
    
    #-----< EDRX-Cycle-Length-List >-----#
    EDRX_Cycle_Length_List = SEQ_OF(name='EDRX-Cycle-Length-List', mode=MODE_TYPE)
    _EDRX_Cycle_Length_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length')))
    EDRX_Cycle_Length_List._cont = _EDRX_Cycle_Length_List__item_
    EDRX_Cycle_Length_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDRX-Cycle-Length >-----#
    EDRX_Cycle_Length = SEQ(name='EDRX-Cycle-Length', mode=MODE_TYPE)
    _EDRX_Cycle_Length_rat_Type = ENUM(name='rat-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')))
    _EDRX_Cycle_Length_eDRX_Cycle_Length_Value = OCT_STR(name='eDRX-Cycle-Length-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-Value')))
    EDRX_Cycle_Length._cont = ASN1Dict([
        ('rat-Type', _EDRX_Cycle_Length_rat_Type),
        ('eDRX-Cycle-Length-Value', _EDRX_Cycle_Length_eDRX_Cycle_Length_Value),
        ])
    EDRX_Cycle_Length._ext = []
    
    #-----< EDRX-Cycle-Length-Value >-----#
    EDRX_Cycle_Length_Value = OCT_STR(name='EDRX-Cycle-Length-Value', mode=MODE_TYPE)
    EDRX_Cycle_Length_Value._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Reset-Id-List >-----#
    Reset_Id_List = SEQ_OF(name='Reset-Id-List', mode=MODE_TYPE)
    _Reset_Id_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id')))
    Reset_Id_List._cont = _Reset_Id_List__item_
    Reset_Id_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< Reset-Id >-----#
    Reset_Id = OCT_STR(name='Reset-Id', mode=MODE_TYPE)
    Reset_Id._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DL-Buffering-Suggested-Packet-Count >-----#
    DL_Buffering_Suggested_Packet_Count = INT(name='DL-Buffering-Suggested-Packet-Count', mode=MODE_TYPE)
    DL_Buffering_Suggested_Packet_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=2147483647)], ev=None, er=[])
    
    #-----< Group-Service-ID >-----#
    Group_Service_ID = INT(name='Group-Service-ID', mode=MODE_TYPE)
    Group_Service_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< Local-GroupID >-----#
    Local_GroupID = OCT_STR(name='Local-GroupID', mode=MODE_TYPE)
    Local_GroupID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< IMSI-GroupIdList >-----#
    IMSI_GroupIdList = SEQ_OF(name='IMSI-GroupIdList', mode=MODE_TYPE)
    _IMSI_GroupIdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupId')))
    IMSI_GroupIdList._cont = _IMSI_GroupIdList__item_
    IMSI_GroupIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< IMSI-GroupId >-----#
    IMSI_GroupId = SEQ(name='IMSI-GroupId', mode=MODE_TYPE)
    _IMSI_GroupId_group_Service_Id = INT(name='group-Service-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Group-Service-ID')))
    _IMSI_GroupId_plmnId = OCT_STR(name='plmnId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _IMSI_GroupId_local_Group_ID = OCT_STR(name='local-Group-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Local-GroupID')))
    IMSI_GroupId._cont = ASN1Dict([
        ('group-Service-Id', _IMSI_GroupId_group_Service_Id),
        ('plmnId', _IMSI_GroupId_plmnId),
        ('local-Group-ID', _IMSI_GroupId_local_Group_ID),
        ])
    IMSI_GroupId._ext = []
    
    #-----< SubscribedPeriodicRAUTAUtimer >-----#
    SubscribedPeriodicRAUTAUtimer = INT(name='SubscribedPeriodicRAUTAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicRAUTAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SubscribedPeriodicLAUtimer >-----#
    SubscribedPeriodicLAUtimer = INT(name='SubscribedPeriodicLAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicLAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< CSG-SubscriptionDataList >-----#
    CSG_SubscriptionDataList = SEQ_OF(name='CSG-SubscriptionDataList', mode=MODE_TYPE)
    _CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    CSG_SubscriptionDataList._cont = _CSG_SubscriptionDataList__item_
    CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-SubscriptionData >-----#
    CSG_SubscriptionData = SEQ(name='CSG-SubscriptionData', mode=MODE_TYPE)
    _CSG_SubscriptionData_csg_Id = BIT_STR(name='csg-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _CSG_SubscriptionData_expirationDate = OCT_STR(name='expirationDate', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _CSG_SubscriptionData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CSG_SubscriptionData_lipa_AllowedAPNList = SEQ_OF(name='lipa-AllowedAPNList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-AllowedAPNList')), opt=True)
    _CSG_SubscriptionData_plmn_Id = OCT_STR(name='plmn-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    CSG_SubscriptionData._cont = ASN1Dict([
        ('csg-Id', _CSG_SubscriptionData_csg_Id),
        ('expirationDate', _CSG_SubscriptionData_expirationDate),
        ('extensionContainer', _CSG_SubscriptionData_extensionContainer),
        ('lipa-AllowedAPNList', _CSG_SubscriptionData_lipa_AllowedAPNList),
        ('plmn-Id', _CSG_SubscriptionData_plmn_Id),
        ])
    CSG_SubscriptionData._ext = ['lipa-AllowedAPNList', 'plmn-Id']
    
    #-----< VPLMN-CSG-SubscriptionDataList >-----#
    VPLMN_CSG_SubscriptionDataList = SEQ_OF(name='VPLMN-CSG-SubscriptionDataList', mode=MODE_TYPE)
    _VPLMN_CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    VPLMN_CSG_SubscriptionDataList._cont = _VPLMN_CSG_SubscriptionDataList__item_
    VPLMN_CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name='CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< LIPA-AllowedAPNList >-----#
    LIPA_AllowedAPNList = SEQ_OF(name='LIPA-AllowedAPNList', mode=MODE_TYPE)
    _LIPA_AllowedAPNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    LIPA_AllowedAPNList._cont = _LIPA_AllowedAPNList__item_
    LIPA_AllowedAPNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfLIPAAllowedAPN >-----#
    maxNumOfLIPAAllowedAPN = INT(name='maxNumOfLIPAAllowedAPN', mode=MODE_VALUE)
    maxNumOfLIPAAllowedAPN._val = 50
    
    #-----< EPS-SubscriptionData >-----#
    EPS_SubscriptionData = SEQ(name='EPS-SubscriptionData', mode=MODE_TYPE)
    _EPS_SubscriptionData_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _EPS_SubscriptionData_rfsp_id = INT(name='rfsp-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RFSP-ID')), opt=True)
    _EPS_SubscriptionData_ambr = SEQ(name='ambr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _EPS_SubscriptionData_apn_ConfigurationProfile = SEQ(name='apn-ConfigurationProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-ConfigurationProfile')), opt=True)
    _EPS_SubscriptionData_stn_sr = OCT_STR(name='stn-sr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _EPS_SubscriptionData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _EPS_SubscriptionData_mps_CSPriority = NULL(name='mps-CSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_mps_EPSPriority = NULL(name='mps-EPSPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_subscribed_vsrvcc = NULL(name='subscribed-vsrvcc', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPS_SubscriptionData._cont = ASN1Dict([
        ('apn-oi-Replacement', _EPS_SubscriptionData_apn_oi_Replacement),
        ('rfsp-id', _EPS_SubscriptionData_rfsp_id),
        ('ambr', _EPS_SubscriptionData_ambr),
        ('apn-ConfigurationProfile', _EPS_SubscriptionData_apn_ConfigurationProfile),
        ('stn-sr', _EPS_SubscriptionData_stn_sr),
        ('extensionContainer', _EPS_SubscriptionData_extensionContainer),
        ('mps-CSPriority', _EPS_SubscriptionData_mps_CSPriority),
        ('mps-EPSPriority', _EPS_SubscriptionData_mps_EPSPriority),
        ('subscribed-vsrvcc', _EPS_SubscriptionData_subscribed_vsrvcc),
        ])
    EPS_SubscriptionData._ext = ['mps-CSPriority', 'mps-EPSPriority', 'subscribed-vsrvcc']
    
    #-----< APN-OI-Replacement >-----#
    APN_OI_Replacement = OCT_STR(name='APN-OI-Replacement', mode=MODE_TYPE)
    APN_OI_Replacement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=100)], ev=None, er=[])
    
    #-----< RFSP-ID >-----#
    RFSP_ID = INT(name='RFSP-ID', mode=MODE_TYPE)
    RFSP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< APN-ConfigurationProfile >-----#
    APN_ConfigurationProfile = SEQ(name='APN-ConfigurationProfile', mode=MODE_TYPE)
    _APN_ConfigurationProfile_defaultContext = INT(name='defaultContext', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_ConfigurationProfile_completeDataListIncluded = NULL(name='completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _APN_ConfigurationProfile_epsDataList = SEQ_OF(name='epsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-DataList')))
    _APN_ConfigurationProfile_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_ConfigurationProfile_additionalDefaultContext = INT(name='additionalDefaultContext', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    APN_ConfigurationProfile._cont = ASN1Dict([
        ('defaultContext', _APN_ConfigurationProfile_defaultContext),
        ('completeDataListIncluded', _APN_ConfigurationProfile_completeDataListIncluded),
        ('epsDataList', _APN_ConfigurationProfile_epsDataList),
        ('extensionContainer', _APN_ConfigurationProfile_extensionContainer),
        ('additionalDefaultContext', _APN_ConfigurationProfile_additionalDefaultContext),
        ])
    APN_ConfigurationProfile._ext = ['additionalDefaultContext']
    
    #-----< EPS-DataList >-----#
    EPS_DataList = SEQ_OF(name='EPS-DataList', mode=MODE_TYPE)
    _EPS_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-Configuration')))
    EPS_DataList._cont = _EPS_DataList__item_
    EPS_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfAPN-Configurations >-----#
    maxNumOfAPN_Configurations = INT(name='maxNumOfAPN-Configurations', mode=MODE_VALUE)
    maxNumOfAPN_Configurations._val = 50
    
    #-----< APN-Configuration >-----#
    APN_Configuration = SEQ(name='APN-Configuration', mode=MODE_TYPE)
    _APN_Configuration_contextId = INT(name='contextId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_Configuration_pdn_Type = OCT_STR(name='pdn-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-Type')))
    _APN_Configuration_servedPartyIP_IPv4_Address = OCT_STR(name='servedPartyIP-IPv4-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _APN_Configuration_eps_qos_Subscribed = SEQ(name='eps-qos-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-QoS-Subscribed')))
    _APN_Configuration_pdn_gw_Identity = SEQ(name='pdn-gw-Identity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _APN_Configuration_pdn_gw_AllocationType = ENUM(name='pdn-gw-AllocationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-AllocationType')), opt=True)
    _APN_Configuration_vplmnAddressAllowed = NULL(name='vplmnAddressAllowed', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _APN_Configuration_ambr = SEQ(name='ambr', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _APN_Configuration_specificAPNInfoList = SEQ_OF(name='specificAPNInfoList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfoList')), opt=True)
    _APN_Configuration_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_Configuration_servedPartyIP_IPv6_Address = OCT_STR(name='servedPartyIP-IPv6-Address', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _APN_Configuration_sipto_Permission = ENUM(name='sipto-Permission', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _APN_Configuration_lipa_Permission = ENUM(name='lipa-Permission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _APN_Configuration_restoration_Priority = OCT_STR(name='restoration-Priority', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _APN_Configuration_sipto_local_network_Permission = ENUM(name='sipto-local-network-Permission', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _APN_Configuration_wlan_offloadability = SEQ(name='wlan-offloadability', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability')), opt=True)
    _APN_Configuration_non_IP_PDN_Type_Indicator = NULL(name='non-IP-PDN-Type-Indicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_nIDD_Mechanism = ENUM(name='nIDD-Mechanism', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _APN_Configuration_sCEF_ID = OCT_STR(name='sCEF-ID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _APN_Configuration_pdn_ConnectionContinuity = ENUM(name='pdn-ConnectionContinuity', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-ConnectionContinuity')), opt=True)
    APN_Configuration._cont = ASN1Dict([
        ('contextId', _APN_Configuration_contextId),
        ('pdn-Type', _APN_Configuration_pdn_Type),
        ('servedPartyIP-IPv4-Address', _APN_Configuration_servedPartyIP_IPv4_Address),
        ('apn', _APN_Configuration_apn),
        ('eps-qos-Subscribed', _APN_Configuration_eps_qos_Subscribed),
        ('pdn-gw-Identity', _APN_Configuration_pdn_gw_Identity),
        ('pdn-gw-AllocationType', _APN_Configuration_pdn_gw_AllocationType),
        ('vplmnAddressAllowed', _APN_Configuration_vplmnAddressAllowed),
        ('chargingCharacteristics', _APN_Configuration_chargingCharacteristics),
        ('ambr', _APN_Configuration_ambr),
        ('specificAPNInfoList', _APN_Configuration_specificAPNInfoList),
        ('extensionContainer', _APN_Configuration_extensionContainer),
        ('servedPartyIP-IPv6-Address', _APN_Configuration_servedPartyIP_IPv6_Address),
        ('apn-oi-Replacement', _APN_Configuration_apn_oi_Replacement),
        ('sipto-Permission', _APN_Configuration_sipto_Permission),
        ('lipa-Permission', _APN_Configuration_lipa_Permission),
        ('restoration-Priority', _APN_Configuration_restoration_Priority),
        ('sipto-local-network-Permission', _APN_Configuration_sipto_local_network_Permission),
        ('wlan-offloadability', _APN_Configuration_wlan_offloadability),
        ('non-IP-PDN-Type-Indicator', _APN_Configuration_non_IP_PDN_Type_Indicator),
        ('nIDD-Mechanism', _APN_Configuration_nIDD_Mechanism),
        ('sCEF-ID', _APN_Configuration_sCEF_ID),
        ('pdn-ConnectionContinuity', _APN_Configuration_pdn_ConnectionContinuity),
        ])
    APN_Configuration._ext = ['apn-oi-Replacement', 'sipto-Permission', 'lipa-Permission', 'restoration-Priority', 'sipto-local-network-Permission', 'wlan-offloadability', 'non-IP-PDN-Type-Indicator', 'nIDD-Mechanism', 'sCEF-ID', 'pdn-ConnectionContinuity']
    
    #-----< PDN-ConnectionContinuity >-----#
    PDN_ConnectionContinuity = ENUM(name='PDN-ConnectionContinuity', mode=MODE_TYPE)
    PDN_ConnectionContinuity._cont = ASN1Dict([('maintainPDN-Connection', 0), ('disconnectPDN-ConnectionWithReactivationRequest', 1), ('disconnectPDN-ConnectionWithoutReactivationRequest', 2)])
    PDN_ConnectionContinuity._ext = None
    
    #-----< NIDD-Mechanism >-----#
    NIDD_Mechanism = ENUM(name='NIDD-Mechanism', mode=MODE_TYPE)
    NIDD_Mechanism._cont = ASN1Dict([('sGi-based-data-delivery', 0), ('sCEF-based-data-delivery', 1)])
    NIDD_Mechanism._ext = None
    
    #-----< PDN-Type >-----#
    PDN_Type = OCT_STR(name='PDN-Type', mode=MODE_TYPE)
    PDN_Type._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EPS-QoS-Subscribed >-----#
    EPS_QoS_Subscribed = SEQ(name='EPS-QoS-Subscribed', mode=MODE_TYPE)
    _EPS_QoS_Subscribed_qos_Class_Identifier = INT(name='qos-Class-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Class-Identifier')))
    _EPS_QoS_Subscribed_allocation_Retention_Priority = SEQ(name='allocation-Retention-Priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Allocation-Retention-Priority')))
    _EPS_QoS_Subscribed_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPS_QoS_Subscribed._cont = ASN1Dict([
        ('qos-Class-Identifier', _EPS_QoS_Subscribed_qos_Class_Identifier),
        ('allocation-Retention-Priority', _EPS_QoS_Subscribed_allocation_Retention_Priority),
        ('extensionContainer', _EPS_QoS_Subscribed_extensionContainer),
        ])
    EPS_QoS_Subscribed._ext = []
    
    #-----< AMBR >-----#
    AMBR = SEQ(name='AMBR', mode=MODE_TYPE)
    _AMBR_max_RequestedBandwidth_UL = INT(name='max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_max_RequestedBandwidth_DL = INT(name='max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_UL = INT(name='extended-Max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_DL = INT(name='extended-Max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    AMBR._cont = ASN1Dict([
        ('max-RequestedBandwidth-UL', _AMBR_max_RequestedBandwidth_UL),
        ('max-RequestedBandwidth-DL', _AMBR_max_RequestedBandwidth_DL),
        ('extensionContainer', _AMBR_extensionContainer),
        ('extended-Max-RequestedBandwidth-UL', _AMBR_extended_Max_RequestedBandwidth_UL),
        ('extended-Max-RequestedBandwidth-DL', _AMBR_extended_Max_RequestedBandwidth_DL),
        ])
    AMBR._ext = ['extended-Max-RequestedBandwidth-UL', 'extended-Max-RequestedBandwidth-DL']
    
    #-----< SpecificAPNInfoList >-----#
    SpecificAPNInfoList = SEQ_OF(name='SpecificAPNInfoList', mode=MODE_TYPE)
    _SpecificAPNInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfo')))
    SpecificAPNInfoList._cont = _SpecificAPNInfoList__item_
    SpecificAPNInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfSpecificAPNInfos >-----#
    maxNumOfSpecificAPNInfos = INT(name='maxNumOfSpecificAPNInfos', mode=MODE_VALUE)
    maxNumOfSpecificAPNInfos._val = 50
    
    #-----< SpecificAPNInfo >-----#
    SpecificAPNInfo = SEQ(name='SpecificAPNInfo', mode=MODE_TYPE)
    _SpecificAPNInfo_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _SpecificAPNInfo_pdn_gw_Identity = SEQ(name='pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')))
    _SpecificAPNInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SpecificAPNInfo._cont = ASN1Dict([
        ('apn', _SpecificAPNInfo_apn),
        ('pdn-gw-Identity', _SpecificAPNInfo_pdn_gw_Identity),
        ('extensionContainer', _SpecificAPNInfo_extensionContainer),
        ])
    SpecificAPNInfo._ext = []
    
    #-----< Bandwidth >-----#
    Bandwidth = INT(name='Bandwidth', mode=MODE_TYPE)
    
    #-----< BandwidthExt >-----#
    BandwidthExt = INT(name='BandwidthExt', mode=MODE_TYPE)
    
    #-----< QoS-Class-Identifier >-----#
    QoS_Class_Identifier = INT(name='QoS-Class-Identifier', mode=MODE_TYPE)
    QoS_Class_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Allocation-Retention-Priority >-----#
    Allocation_Retention_Priority = SEQ(name='Allocation-Retention-Priority', mode=MODE_TYPE)
    _Allocation_Retention_Priority_priority_level = INT(name='priority-level', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Allocation_Retention_Priority_pre_emption_capability = BOOL(name='pre-emption-capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_pre_emption_vulnerability = BOOL(name='pre-emption-vulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Allocation_Retention_Priority._cont = ASN1Dict([
        ('priority-level', _Allocation_Retention_Priority_priority_level),
        ('pre-emption-capability', _Allocation_Retention_Priority_pre_emption_capability),
        ('pre-emption-vulnerability', _Allocation_Retention_Priority_pre_emption_vulnerability),
        ('extensionContainer', _Allocation_Retention_Priority_extensionContainer),
        ])
    Allocation_Retention_Priority._ext = []
    
    #-----< PDN-GW-Identity >-----#
    PDN_GW_Identity = SEQ(name='PDN-GW-Identity', mode=MODE_TYPE)
    _PDN_GW_Identity_pdn_gw_ipv4_Address = OCT_STR(name='pdn-gw-ipv4-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_ipv6_Address = OCT_STR(name='pdn-gw-ipv6-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_name = OCT_STR(name='pdn-gw-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _PDN_GW_Identity_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Identity._cont = ASN1Dict([
        ('pdn-gw-ipv4-Address', _PDN_GW_Identity_pdn_gw_ipv4_Address),
        ('pdn-gw-ipv6-Address', _PDN_GW_Identity_pdn_gw_ipv6_Address),
        ('pdn-gw-name', _PDN_GW_Identity_pdn_gw_name),
        ('extensionContainer', _PDN_GW_Identity_extensionContainer),
        ])
    PDN_GW_Identity._ext = []
    
    #-----< FQDN >-----#
    FQDN = OCT_STR(name='FQDN', mode=MODE_TYPE)
    FQDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< PDN-GW-AllocationType >-----#
    PDN_GW_AllocationType = ENUM(name='PDN-GW-AllocationType', mode=MODE_TYPE)
    PDN_GW_AllocationType._cont = ASN1Dict([('static', 0), ('dynamic', 1)])
    PDN_GW_AllocationType._ext = None
    
    #-----< WLAN-Offloadability >-----#
    WLAN_Offloadability = SEQ(name='WLAN-Offloadability', mode=MODE_TYPE)
    _WLAN_Offloadability_wlan_offloadability_EUTRAN = ENUM(name='wlan-offloadability-EUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_wlan_offloadability_UTRAN = ENUM(name='wlan-offloadability-UTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    WLAN_Offloadability._cont = ASN1Dict([
        ('wlan-offloadability-EUTRAN', _WLAN_Offloadability_wlan_offloadability_EUTRAN),
        ('wlan-offloadability-UTRAN', _WLAN_Offloadability_wlan_offloadability_UTRAN),
        ('extensionContainer', _WLAN_Offloadability_extensionContainer),
        ])
    WLAN_Offloadability._ext = []
    
    #-----< WLAN-Offloadability-Indication >-----#
    WLAN_Offloadability_Indication = ENUM(name='WLAN-Offloadability-Indication', mode=MODE_TYPE)
    WLAN_Offloadability_Indication._cont = ASN1Dict([('notAllowed', 0), ('allowed', 1)])
    WLAN_Offloadability_Indication._ext = None
    
    #-----< AccessRestrictionData >-----#
    AccessRestrictionData = BIT_STR(name='AccessRestrictionData', mode=MODE_TYPE)
    AccessRestrictionData._cont = ASN1Dict([('utranNotAllowed', 0), ('geranNotAllowed', 1), ('ganNotAllowed', 2), ('i-hspa-evolutionNotAllowed', 3), ('wb-e-utranNotAllowed', 4), ('ho-toNon3GPP-AccessNotAllowed', 5), ('nb-iotNotAllowed', 6), ('enhancedCoverageNotAllowed', 7)])
    AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< Ext-AccessRestrictionData >-----#
    Ext_AccessRestrictionData = BIT_STR(name='Ext-AccessRestrictionData', mode=MODE_TYPE)
    Ext_AccessRestrictionData._cont = ASN1Dict([('nrAsSecondaryRATNotAllowed', 0), ('unlicensedSpectrumAsSecondaryRATNotAllowed', 1)])
    Ext_AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionDataList >-----#
    AdjacentAccessRestrictionDataList = SEQ_OF(name='AdjacentAccessRestrictionDataList', mode=MODE_TYPE)
    _AdjacentAccessRestrictionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionData')))
    AdjacentAccessRestrictionDataList._cont = _AdjacentAccessRestrictionDataList__item_
    AdjacentAccessRestrictionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionData >-----#
    AdjacentAccessRestrictionData = SEQ(name='AdjacentAccessRestrictionData', mode=MODE_TYPE)
    _AdjacentAccessRestrictionData_plmnId = OCT_STR(name='plmnId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _AdjacentAccessRestrictionData_accessRestrictionData = BIT_STR(name='accessRestrictionData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')))
    _AdjacentAccessRestrictionData_ext_AccessRestrictionData = BIT_STR(name='ext-AccessRestrictionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    AdjacentAccessRestrictionData._cont = ASN1Dict([
        ('plmnId', _AdjacentAccessRestrictionData_plmnId),
        ('accessRestrictionData', _AdjacentAccessRestrictionData_accessRestrictionData),
        ('ext-AccessRestrictionData', _AdjacentAccessRestrictionData_ext_AccessRestrictionData),
        ])
    AdjacentAccessRestrictionData._ext = ['ext-AccessRestrictionData']
    
    #-----< CS-AllocationRetentionPriority >-----#
    CS_AllocationRetentionPriority = OCT_STR(name='CS-AllocationRetentionPriority', mode=MODE_TYPE)
    CS_AllocationRetentionPriority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< IST-AlertTimerValue >-----#
    IST_AlertTimerValue = INT(name='IST-AlertTimerValue', mode=MODE_TYPE)
    IST_AlertTimerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=255)], ev=None, er=[])
    
    #-----< LCSInformation >-----#
    LCSInformation = SEQ(name='LCSInformation', mode=MODE_TYPE)
    _LCSInformation_gmlc_List = SEQ_OF(name='gmlc-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-List')), opt=True)
    _LCSInformation_lcs_PrivacyExceptionList = SEQ_OF(name='lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    _LCSInformation_molr_List = SEQ_OF(name='molr-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-List')), opt=True)
    _LCSInformation_add_lcs_PrivacyExceptionList = SEQ_OF(name='add-lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    LCSInformation._cont = ASN1Dict([
        ('gmlc-List', _LCSInformation_gmlc_List),
        ('lcs-PrivacyExceptionList', _LCSInformation_lcs_PrivacyExceptionList),
        ('molr-List', _LCSInformation_molr_List),
        ('add-lcs-PrivacyExceptionList', _LCSInformation_add_lcs_PrivacyExceptionList),
        ])
    LCSInformation._ext = ['add-lcs-PrivacyExceptionList']
    
    #-----< GMLC-List >-----#
    GMLC_List = SEQ_OF(name='GMLC-List', mode=MODE_TYPE)
    _GMLC_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    GMLC_List._cont = _GMLC_List__item_
    GMLC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfGMLC >-----#
    maxNumOfGMLC = INT(name='maxNumOfGMLC', mode=MODE_VALUE)
    maxNumOfGMLC._val = 5
    
    #-----< NetworkAccessMode >-----#
    NetworkAccessMode = ENUM(name='NetworkAccessMode', mode=MODE_TYPE)
    NetworkAccessMode._cont = ASN1Dict([('packetAndCircuit', 0), ('onlyCircuit', 1), ('onlyPacket', 2)])
    NetworkAccessMode._ext = []
    
    #-----< GPRSDataList >-----#
    GPRSDataList = SEQ_OF(name='GPRSDataList', mode=MODE_TYPE)
    _GPRSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Context')))
    GPRSDataList._cont = _GPRSDataList__item_
    GPRSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfPDP-Contexts >-----#
    maxNumOfPDP_Contexts = INT(name='maxNumOfPDP-Contexts', mode=MODE_VALUE)
    maxNumOfPDP_Contexts._val = 50
    
    #-----< PDP-Context >-----#
    PDP_Context = SEQ(name='PDP-Context', mode=MODE_TYPE)
    _PDP_Context_pdp_ContextId = INT(name='pdp-ContextId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_Context_pdp_Type = OCT_STR(name='pdp-Type', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_Context_pdp_Address = OCT_STR(name='pdp-Address', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_qos_Subscribed = OCT_STR(name='qos-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _PDP_Context_vplmnAddressAllowed = NULL(name='vplmnAddressAllowed', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_Context_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _PDP_Context_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_Context_ext_QoS_Subscribed = OCT_STR(name='ext-QoS-Subscribed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_Context_pdp_ChargingCharacteristics = OCT_STR(name='pdp-ChargingCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_Context_ext2_QoS_Subscribed = OCT_STR(name='ext2-QoS-Subscribed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_Context_ext3_QoS_Subscribed = OCT_STR(name='ext3-QoS-Subscribed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_Context_ext4_QoS_Subscribed = OCT_STR(name='ext4-QoS-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_Context_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _PDP_Context_ext_pdp_Type = OCT_STR(name='ext-pdp-Type', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_Context_ext_pdp_Address = OCT_STR(name='ext-pdp-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_ambr = SEQ(name='ambr', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _PDP_Context_sipto_Permission = ENUM(name='sipto-Permission', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _PDP_Context_lipa_Permission = ENUM(name='lipa-Permission', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _PDP_Context_restoration_Priority = OCT_STR(name='restoration-Priority', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _PDP_Context_sipto_local_network_Permission = ENUM(name='sipto-local-network-Permission', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _PDP_Context_nIDD_Mechanism = ENUM(name='nIDD-Mechanism', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _PDP_Context_sCEF_ID = OCT_STR(name='sCEF-ID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    PDP_Context._cont = ASN1Dict([
        ('pdp-ContextId', _PDP_Context_pdp_ContextId),
        ('pdp-Type', _PDP_Context_pdp_Type),
        ('pdp-Address', _PDP_Context_pdp_Address),
        ('qos-Subscribed', _PDP_Context_qos_Subscribed),
        ('vplmnAddressAllowed', _PDP_Context_vplmnAddressAllowed),
        ('apn', _PDP_Context_apn),
        ('extensionContainer', _PDP_Context_extensionContainer),
        ('ext-QoS-Subscribed', _PDP_Context_ext_QoS_Subscribed),
        ('pdp-ChargingCharacteristics', _PDP_Context_pdp_ChargingCharacteristics),
        ('ext2-QoS-Subscribed', _PDP_Context_ext2_QoS_Subscribed),
        ('ext3-QoS-Subscribed', _PDP_Context_ext3_QoS_Subscribed),
        ('ext4-QoS-Subscribed', _PDP_Context_ext4_QoS_Subscribed),
        ('apn-oi-Replacement', _PDP_Context_apn_oi_Replacement),
        ('ext-pdp-Type', _PDP_Context_ext_pdp_Type),
        ('ext-pdp-Address', _PDP_Context_ext_pdp_Address),
        ('ambr', _PDP_Context_ambr),
        ('sipto-Permission', _PDP_Context_sipto_Permission),
        ('lipa-Permission', _PDP_Context_lipa_Permission),
        ('restoration-Priority', _PDP_Context_restoration_Priority),
        ('sipto-local-network-Permission', _PDP_Context_sipto_local_network_Permission),
        ('nIDD-Mechanism', _PDP_Context_nIDD_Mechanism),
        ('sCEF-ID', _PDP_Context_sCEF_ID),
        ])
    PDP_Context._ext = ['ext-QoS-Subscribed', 'pdp-ChargingCharacteristics', 'ext2-QoS-Subscribed', 'ext3-QoS-Subscribed', 'ext4-QoS-Subscribed', 'apn-oi-Replacement', 'ext-pdp-Type', 'ext-pdp-Address', 'ambr', 'sipto-Permission', 'lipa-Permission', 'restoration-Priority', 'sipto-local-network-Permission', 'nIDD-Mechanism', 'sCEF-ID']
    
    #-----< Restoration-Priority >-----#
    Restoration_Priority = OCT_STR(name='Restoration-Priority', mode=MODE_TYPE)
    Restoration_Priority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SIPTO-Permission >-----#
    SIPTO_Permission = ENUM(name='SIPTO-Permission', mode=MODE_TYPE)
    SIPTO_Permission._cont = ASN1Dict([('siptoAboveRanAllowed', 0), ('siptoAboveRanNotAllowed', 1)])
    SIPTO_Permission._ext = None
    
    #-----< SIPTO-Local-Network-Permission >-----#
    SIPTO_Local_Network_Permission = ENUM(name='SIPTO-Local-Network-Permission', mode=MODE_TYPE)
    SIPTO_Local_Network_Permission._cont = ASN1Dict([('siptoAtLocalNetworkAllowed', 0), ('siptoAtLocalNetworkNotAllowed', 1)])
    SIPTO_Local_Network_Permission._ext = None
    
    #-----< LIPA-Permission >-----#
    LIPA_Permission = ENUM(name='LIPA-Permission', mode=MODE_TYPE)
    LIPA_Permission._cont = ASN1Dict([('lipaProhibited', 0), ('lipaOnly', 1), ('lipaConditional', 2)])
    LIPA_Permission._ext = None
    
    #-----< ContextId >-----#
    ContextId = INT(name='ContextId', mode=MODE_TYPE)
    ContextId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< GPRSSubscriptionData >-----#
    GPRSSubscriptionData = SEQ(name='GPRSSubscriptionData', mode=MODE_TYPE)
    _GPRSSubscriptionData_completeDataListIncluded = NULL(name='completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _GPRSSubscriptionData_gprsDataList = SEQ_OF(name='gprsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSDataList')))
    _GPRSSubscriptionData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRSSubscriptionData_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    GPRSSubscriptionData._cont = ASN1Dict([
        ('completeDataListIncluded', _GPRSSubscriptionData_completeDataListIncluded),
        ('gprsDataList', _GPRSSubscriptionData_gprsDataList),
        ('extensionContainer', _GPRSSubscriptionData_extensionContainer),
        ('apn-oi-Replacement', _GPRSSubscriptionData_apn_oi_Replacement),
        ])
    GPRSSubscriptionData._ext = ['apn-oi-Replacement']
    
    #-----< SGSN-CAMEL-SubscriptionInfo >-----#
    SGSN_CAMEL_SubscriptionInfo = SEQ(name='SGSN-CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _SGSN_CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name='gprs-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name='mo-sms-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name='mt-sms-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name='mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mg_csi = SEQ(name='mg-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    SGSN_CAMEL_SubscriptionInfo._cont = ASN1Dict([
        ('gprs-CSI', _SGSN_CAMEL_SubscriptionInfo_gprs_CSI),
        ('mo-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI),
        ('extensionContainer', _SGSN_CAMEL_SubscriptionInfo_extensionContainer),
        ('mt-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI),
        ('mt-smsCAMELTDP-CriteriaList', _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ('mg-csi', _SGSN_CAMEL_SubscriptionInfo_mg_csi),
        ])
    SGSN_CAMEL_SubscriptionInfo._ext = ['mt-sms-CSI', 'mt-smsCAMELTDP-CriteriaList', 'mg-csi']
    
    #-----< GPRS-CSI >-----#
    GPRS_CSI = SEQ(name='GPRS-CSI', mode=MODE_TYPE)
    _GPRS_CSI_gprs_CamelTDPDataList = SEQ_OF(name='gprs-CamelTDPDataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPDataList')), opt=True)
    _GPRS_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _GPRS_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRS_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GPRS_CSI._cont = ASN1Dict([
        ('gprs-CamelTDPDataList', _GPRS_CSI_gprs_CamelTDPDataList),
        ('camelCapabilityHandling', _GPRS_CSI_camelCapabilityHandling),
        ('extensionContainer', _GPRS_CSI_extensionContainer),
        ('notificationToCSE', _GPRS_CSI_notificationToCSE),
        ('csi-Active', _GPRS_CSI_csi_Active),
        ])
    GPRS_CSI._ext = []
    
    #-----< GPRS-CamelTDPDataList >-----#
    GPRS_CamelTDPDataList = SEQ_OF(name='GPRS-CamelTDPDataList', mode=MODE_TYPE)
    _GPRS_CamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPData')))
    GPRS_CamelTDPDataList._cont = _GPRS_CamelTDPDataList__item_
    GPRS_CamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< GPRS-CamelTDPData >-----#
    GPRS_CamelTDPData = SEQ(name='GPRS-CamelTDPData', mode=MODE_TYPE)
    _GPRS_CamelTDPData_gprs_TriggerDetectionPoint = ENUM(name='gprs-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-TriggerDetectionPoint')))
    _GPRS_CamelTDPData_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _GPRS_CamelTDPData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _GPRS_CamelTDPData_defaultSessionHandling = ENUM(name='defaultSessionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')))
    _GPRS_CamelTDPData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    GPRS_CamelTDPData._cont = ASN1Dict([
        ('gprs-TriggerDetectionPoint', _GPRS_CamelTDPData_gprs_TriggerDetectionPoint),
        ('serviceKey', _GPRS_CamelTDPData_serviceKey),
        ('gsmSCF-Address', _GPRS_CamelTDPData_gsmSCF_Address),
        ('defaultSessionHandling', _GPRS_CamelTDPData_defaultSessionHandling),
        ('extensionContainer', _GPRS_CamelTDPData_extensionContainer),
        ])
    GPRS_CamelTDPData._ext = []
    
    #-----< DefaultGPRS-Handling >-----#
    DefaultGPRS_Handling = ENUM(name='DefaultGPRS-Handling', mode=MODE_TYPE)
    DefaultGPRS_Handling._cont = ASN1Dict([('continueTransaction', 0), ('releaseTransaction', 1)])
    DefaultGPRS_Handling._ext = []
    
    #-----< GPRS-TriggerDetectionPoint >-----#
    GPRS_TriggerDetectionPoint = ENUM(name='GPRS-TriggerDetectionPoint', mode=MODE_TYPE)
    GPRS_TriggerDetectionPoint._cont = ASN1Dict([('attach', 1), ('attachChangeOfPosition', 2), ('pdp-ContextEstablishment', 11), ('pdp-ContextEstablishmentAcknowledgement', 12), ('pdp-ContextChangeOfPosition', 14)])
    GPRS_TriggerDetectionPoint._ext = []
    
    #-----< APN >-----#
    APN = OCT_STR(name='APN', mode=MODE_TYPE)
    APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=63)], ev=None, er=[])
    
    #-----< PDP-Type >-----#
    PDP_Type = OCT_STR(name='PDP-Type', mode=MODE_TYPE)
    PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Ext-PDP-Type >-----#
    Ext_PDP_Type = OCT_STR(name='Ext-PDP-Type', mode=MODE_TYPE)
    Ext_PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PDP-Address >-----#
    PDP_Address = OCT_STR(name='PDP-Address', mode=MODE_TYPE)
    PDP_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< QoS-Subscribed >-----#
    QoS_Subscribed = OCT_STR(name='QoS-Subscribed', mode=MODE_TYPE)
    QoS_Subscribed._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Ext-QoS-Subscribed >-----#
    Ext_QoS_Subscribed = OCT_STR(name='Ext-QoS-Subscribed', mode=MODE_TYPE)
    Ext_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Ext2-QoS-Subscribed >-----#
    Ext2_QoS_Subscribed = OCT_STR(name='Ext2-QoS-Subscribed', mode=MODE_TYPE)
    Ext2_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Ext3-QoS-Subscribed >-----#
    Ext3_QoS_Subscribed = OCT_STR(name='Ext3-QoS-Subscribed', mode=MODE_TYPE)
    Ext3_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ext4-QoS-Subscribed >-----#
    Ext4_QoS_Subscribed = OCT_STR(name='Ext4-QoS-Subscribed', mode=MODE_TYPE)
    Ext4_QoS_Subscribed._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = OCT_STR(name='ChargingCharacteristics', mode=MODE_TYPE)
    ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LSAOnlyAccessIndicator >-----#
    LSAOnlyAccessIndicator = ENUM(name='LSAOnlyAccessIndicator', mode=MODE_TYPE)
    LSAOnlyAccessIndicator._cont = ASN1Dict([('accessOutsideLSAsAllowed', 0), ('accessOutsideLSAsRestricted', 1)])
    LSAOnlyAccessIndicator._ext = None
    
    #-----< LSADataList >-----#
    LSADataList = SEQ_OF(name='LSADataList', mode=MODE_TYPE)
    _LSADataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAData')))
    LSADataList._cont = _LSADataList__item_
    LSADataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfLSAs >-----#
    maxNumOfLSAs = INT(name='maxNumOfLSAs', mode=MODE_VALUE)
    maxNumOfLSAs._val = 20
    
    #-----< LSAData >-----#
    LSAData = SEQ(name='LSAData', mode=MODE_TYPE)
    _LSAData_lsaIdentity = OCT_STR(name='lsaIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    _LSAData_lsaAttributes = OCT_STR(name='lsaAttributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAAttributes')))
    _LSAData_lsaActiveModeIndicator = NULL(name='lsaActiveModeIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LSAData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAData._cont = ASN1Dict([
        ('lsaIdentity', _LSAData_lsaIdentity),
        ('lsaAttributes', _LSAData_lsaAttributes),
        ('lsaActiveModeIndicator', _LSAData_lsaActiveModeIndicator),
        ('extensionContainer', _LSAData_extensionContainer),
        ])
    LSAData._ext = []
    
    #-----< LSAInformation >-----#
    LSAInformation = SEQ(name='LSAInformation', mode=MODE_TYPE)
    _LSAInformation_completeDataListIncluded = NULL(name='completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _LSAInformation_lsaOnlyAccessIndicator = ENUM(name='lsaOnlyAccessIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAOnlyAccessIndicator')), opt=True)
    _LSAInformation_lsaDataList = SEQ_OF(name='lsaDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSADataList')), opt=True)
    _LSAInformation_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAInformation._cont = ASN1Dict([
        ('completeDataListIncluded', _LSAInformation_completeDataListIncluded),
        ('lsaOnlyAccessIndicator', _LSAInformation_lsaOnlyAccessIndicator),
        ('lsaDataList', _LSAInformation_lsaDataList),
        ('extensionContainer', _LSAInformation_extensionContainer),
        ])
    LSAInformation._ext = []
    
    #-----< LSAIdentity >-----#
    LSAIdentity = OCT_STR(name='LSAIdentity', mode=MODE_TYPE)
    LSAIdentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< LSAAttributes >-----#
    LSAAttributes = OCT_STR(name='LSAAttributes', mode=MODE_TYPE)
    LSAAttributes._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberData >-----#
    SubscriberData = SEQ(name='SubscriberData', mode=MODE_TYPE)
    _SubscriberData_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberData_category = OCT_STR(name='category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _SubscriberData_subscriberStatus = ENUM(name='subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _SubscriberData_bearerServiceList = SEQ_OF(name='bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _SubscriberData_teleserviceList = SEQ_OF(name='teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _SubscriberData_provisionedSS = SEQ_OF(name='provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _SubscriberData_odb_Data = SEQ(name='odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _SubscriberData_roamingRestrictionDueToUnsupportedFeature = NULL(name='roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberData_regionalSubscriptionData = SEQ_OF(name='regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _SubscriberData_vbsSubscriptionData = SEQ_OF(name='vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _SubscriberData_vgcsSubscriptionData = SEQ_OF(name='vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _SubscriberData_vlrCamelSubscriptionInfo = SEQ(name='vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    SubscriberData._cont = ASN1Dict([
        ('msisdn', _SubscriberData_msisdn),
        ('category', _SubscriberData_category),
        ('subscriberStatus', _SubscriberData_subscriberStatus),
        ('bearerServiceList', _SubscriberData_bearerServiceList),
        ('teleserviceList', _SubscriberData_teleserviceList),
        ('provisionedSS', _SubscriberData_provisionedSS),
        ('odb-Data', _SubscriberData_odb_Data),
        ('roamingRestrictionDueToUnsupportedFeature', _SubscriberData_roamingRestrictionDueToUnsupportedFeature),
        ('regionalSubscriptionData', _SubscriberData_regionalSubscriptionData),
        ('vbsSubscriptionData', _SubscriberData_vbsSubscriptionData),
        ('vgcsSubscriptionData', _SubscriberData_vgcsSubscriptionData),
        ('vlrCamelSubscriptionInfo', _SubscriberData_vlrCamelSubscriptionInfo),
        ])
    SubscriberData._ext = None
    
    #-----< Category >-----#
    Category = OCT_STR(name='Category', mode=MODE_TYPE)
    Category._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberStatus >-----#
    SubscriberStatus = ENUM(name='SubscriberStatus', mode=MODE_TYPE)
    SubscriberStatus._cont = ASN1Dict([('serviceGranted', 0), ('operatorDeterminedBarring', 1)])
    SubscriberStatus._ext = None
    
    #-----< BearerServiceList >-----#
    BearerServiceList = SEQ_OF(name='BearerServiceList', mode=MODE_TYPE)
    _BearerServiceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    BearerServiceList._cont = _BearerServiceList__item_
    BearerServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfBearerServices >-----#
    maxNumOfBearerServices = INT(name='maxNumOfBearerServices', mode=MODE_VALUE)
    maxNumOfBearerServices._val = 50
    
    #-----< TeleserviceList >-----#
    TeleserviceList = SEQ_OF(name='TeleserviceList', mode=MODE_TYPE)
    _TeleserviceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    TeleserviceList._cont = _TeleserviceList__item_
    TeleserviceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfTeleservices >-----#
    maxNumOfTeleservices = INT(name='maxNumOfTeleservices', mode=MODE_VALUE)
    maxNumOfTeleservices._val = 20
    
    #-----< ODB-Data >-----#
    ODB_Data = SEQ(name='ODB-Data', mode=MODE_TYPE)
    _ODB_Data_odb_GeneralData = BIT_STR(name='odb-GeneralData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')))
    _ODB_Data_odb_HPLMN_Data = BIT_STR(name='odb-HPLMN-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-HPLMN-Data')), opt=True)
    _ODB_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Data._cont = ASN1Dict([
        ('odb-GeneralData', _ODB_Data_odb_GeneralData),
        ('odb-HPLMN-Data', _ODB_Data_odb_HPLMN_Data),
        ('extensionContainer', _ODB_Data_extensionContainer),
        ])
    ODB_Data._ext = []
    
    #-----< ODB-GeneralData >-----#
    ODB_GeneralData = BIT_STR(name='ODB-GeneralData', mode=MODE_TYPE)
    ODB_GeneralData._cont = ASN1Dict([('allOG-CallsBarred', 0), ('internationalOGCallsBarred', 1), ('internationalOGCallsNotToHPLMN-CountryBarred', 2), ('interzonalOGCallsBarred', 6), ('interzonalOGCallsNotToHPLMN-CountryBarred', 7), ('interzonalOGCallsAndInternationalOGCallsNotToHPLMN-CountryBarred', 8), ('premiumRateInformationOGCallsBarred', 3), ('premiumRateEntertainementOGCallsBarred', 4), ('ss-AccessBarred', 5), ('allECT-Barred', 9), ('chargeableECT-Barred', 10), ('internationalECT-Barred', 11), ('interzonalECT-Barred', 12), ('doublyChargeableECT-Barred', 13), ('multipleECT-Barred', 14), ('allPacketOrientedServicesBarred', 15), ('roamerAccessToHPLMN-AP-Barred', 16), ('roamerAccessToVPLMN-AP-Barred', 17), ('roamingOutsidePLMNOG-CallsBarred', 18), ('allIC-CallsBarred', 19), ('roamingOutsidePLMNIC-CallsBarred', 20), ('roamingOutsidePLMNICountryIC-CallsBarred', 21), ('roamingOutsidePLMN-Barred', 22), ('roamingOutsidePLMN-CountryBarred', 23), ('registrationAllCF-Barred', 24), ('registrationCFNotToHPLMN-Barred', 25), ('registrationInterzonalCF-Barred', 26), ('registrationInterzonalCFNotToHPLMN-Barred', 27), ('registrationInternationalCF-Barred', 28)])
    ODB_GeneralData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=32)], ev=None, er=[])
    
    #-----< ODB-HPLMN-Data >-----#
    ODB_HPLMN_Data = BIT_STR(name='ODB-HPLMN-Data', mode=MODE_TYPE)
    ODB_HPLMN_Data._cont = ASN1Dict([('plmn-SpecificBarringType1', 0), ('plmn-SpecificBarringType2', 1), ('plmn-SpecificBarringType3', 2), ('plmn-SpecificBarringType4', 3)])
    ODB_HPLMN_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=32)], ev=None, er=[])
    
    #-----< Ext-SS-InfoList >-----#
    Ext_SS_InfoList = SEQ_OF(name='Ext-SS-InfoList', mode=MODE_TYPE)
    _Ext_SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Info')))
    Ext_SS_InfoList._cont = _Ext_SS_InfoList__item_
    Ext_SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< Ext-SS-Info >-----#
    Ext_SS_Info = CHOICE(name='Ext-SS-Info', mode=MODE_TYPE)
    _Ext_SS_Info_forwardingInfo = SEQ(name='forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwInfo')))
    _Ext_SS_Info_callBarringInfo = SEQ(name='callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarInfo')))
    _Ext_SS_Info_cug_Info = SEQ(name='cug-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Info')))
    _Ext_SS_Info_ss_Data = SEQ(name='ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Data')))
    _Ext_SS_Info_emlpp_Info = SEQ(name='emlpp-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Info')))
    Ext_SS_Info._cont = ASN1Dict([
        ('forwardingInfo', _Ext_SS_Info_forwardingInfo),
        ('callBarringInfo', _Ext_SS_Info_callBarringInfo),
        ('cug-Info', _Ext_SS_Info_cug_Info),
        ('ss-Data', _Ext_SS_Info_ss_Data),
        ('emlpp-Info', _Ext_SS_Info_emlpp_Info),
        ])
    Ext_SS_Info._ext = None
    
    #-----< Ext-ForwInfo >-----#
    Ext_ForwInfo = SEQ(name='Ext-ForwInfo', mode=MODE_TYPE)
    _Ext_ForwInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwInfo_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwInfo._cont = ASN1Dict([
        ('ss-Code', _Ext_ForwInfo_ss_Code),
        ('forwardingFeatureList', _Ext_ForwInfo_forwardingFeatureList),
        ('extensionContainer', _Ext_ForwInfo_extensionContainer),
        ])
    Ext_ForwInfo._ext = []
    
    #-----< Ext-ForwFeatureList >-----#
    Ext_ForwFeatureList = SEQ_OF(name='Ext-ForwFeatureList', mode=MODE_TYPE)
    _Ext_ForwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeature')))
    Ext_ForwFeatureList._cont = _Ext_ForwFeatureList__item_
    Ext_ForwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-ForwFeature >-----#
    Ext_ForwFeature = SEQ(name='Ext-ForwFeature', mode=MODE_TYPE)
    _Ext_ForwFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_ForwFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_ForwFeature_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _Ext_ForwFeature_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _Ext_ForwFeature_forwardingOptions = OCT_STR(name='forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwOptions')), opt=True)
    _Ext_ForwFeature_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _Ext_ForwFeature_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _Ext_ForwFeature_longForwardedToNumber = OCT_STR(name='longForwardedToNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    Ext_ForwFeature._cont = ASN1Dict([
        ('basicService', _Ext_ForwFeature_basicService),
        ('ss-Status', _Ext_ForwFeature_ss_Status),
        ('forwardedToNumber', _Ext_ForwFeature_forwardedToNumber),
        ('forwardedToSubaddress', _Ext_ForwFeature_forwardedToSubaddress),
        ('forwardingOptions', _Ext_ForwFeature_forwardingOptions),
        ('noReplyConditionTime', _Ext_ForwFeature_noReplyConditionTime),
        ('extensionContainer', _Ext_ForwFeature_extensionContainer),
        ('longForwardedToNumber', _Ext_ForwFeature_longForwardedToNumber),
        ])
    Ext_ForwFeature._ext = ['longForwardedToNumber']
    
    #-----< Ext-ForwOptions >-----#
    Ext_ForwOptions = OCT_STR(name='Ext-ForwOptions', mode=MODE_TYPE)
    Ext_ForwOptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Ext-NoRepCondTime >-----#
    Ext_NoRepCondTime = INT(name='Ext-NoRepCondTime', mode=MODE_TYPE)
    Ext_NoRepCondTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< Ext-CallBarInfo >-----#
    Ext_CallBarInfo = SEQ(name='Ext-CallBarInfo', mode=MODE_TYPE)
    _Ext_CallBarInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarInfo_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarInfo._cont = ASN1Dict([
        ('ss-Code', _Ext_CallBarInfo_ss_Code),
        ('callBarringFeatureList', _Ext_CallBarInfo_callBarringFeatureList),
        ('extensionContainer', _Ext_CallBarInfo_extensionContainer),
        ])
    Ext_CallBarInfo._ext = []
    
    #-----< Ext-CallBarFeatureList >-----#
    Ext_CallBarFeatureList = SEQ_OF(name='Ext-CallBarFeatureList', mode=MODE_TYPE)
    _Ext_CallBarFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringFeature')))
    Ext_CallBarFeatureList._cont = _Ext_CallBarFeatureList__item_
    Ext_CallBarFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CallBarringFeature >-----#
    Ext_CallBarringFeature = SEQ(name='Ext-CallBarringFeature', mode=MODE_TYPE)
    _Ext_CallBarringFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_CallBarringFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_CallBarringFeature_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringFeature._cont = ASN1Dict([
        ('basicService', _Ext_CallBarringFeature_basicService),
        ('ss-Status', _Ext_CallBarringFeature_ss_Status),
        ('extensionContainer', _Ext_CallBarringFeature_extensionContainer),
        ])
    Ext_CallBarringFeature._ext = []
    
    #-----< CUG-Info >-----#
    CUG_Info = SEQ(name='CUG-Info', mode=MODE_TYPE)
    _CUG_Info_cug_SubscriptionList = SEQ_OF(name='cug-SubscriptionList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-SubscriptionList')))
    _CUG_Info_cug_FeatureList = SEQ_OF(name='cug-FeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-FeatureList')), opt=True)
    _CUG_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Info._cont = ASN1Dict([
        ('cug-SubscriptionList', _CUG_Info_cug_SubscriptionList),
        ('cug-FeatureList', _CUG_Info_cug_FeatureList),
        ('extensionContainer', _CUG_Info_extensionContainer),
        ])
    CUG_Info._ext = []
    
    #-----< CUG-SubscriptionList >-----#
    CUG_SubscriptionList = SEQ_OF(name='CUG-SubscriptionList', mode=MODE_TYPE)
    _CUG_SubscriptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Subscription')))
    CUG_SubscriptionList._cont = _CUG_SubscriptionList__item_
    CUG_SubscriptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CUG-Subscription >-----#
    CUG_Subscription = SEQ(name='CUG-Subscription', mode=MODE_TYPE)
    _CUG_Subscription_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')))
    _CUG_Subscription_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_Subscription_intraCUG_Options = ENUM(name='intraCUG-Options', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntraCUG-Options')))
    _CUG_Subscription_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _CUG_Subscription_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Subscription._cont = ASN1Dict([
        ('cug-Index', _CUG_Subscription_cug_Index),
        ('cug-Interlock', _CUG_Subscription_cug_Interlock),
        ('intraCUG-Options', _CUG_Subscription_intraCUG_Options),
        ('basicServiceGroupList', _CUG_Subscription_basicServiceGroupList),
        ('extensionContainer', _CUG_Subscription_extensionContainer),
        ])
    CUG_Subscription._ext = []
    
    #-----< CUG-Index >-----#
    CUG_Index = INT(name='CUG-Index', mode=MODE_TYPE)
    CUG_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< CUG-Interlock >-----#
    CUG_Interlock = OCT_STR(name='CUG-Interlock', mode=MODE_TYPE)
    CUG_Interlock._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IntraCUG-Options >-----#
    IntraCUG_Options = ENUM(name='IntraCUG-Options', mode=MODE_TYPE)
    IntraCUG_Options._cont = ASN1Dict([('noCUG-Restrictions', 0), ('cugIC-CallBarred', 1), ('cugOG-CallBarred', 2)])
    IntraCUG_Options._ext = None
    
    #-----< maxNumOfCUG >-----#
    maxNumOfCUG = INT(name='maxNumOfCUG', mode=MODE_VALUE)
    maxNumOfCUG._val = 10
    
    #-----< CUG-FeatureList >-----#
    CUG_FeatureList = SEQ_OF(name='CUG-FeatureList', mode=MODE_TYPE)
    _CUG_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Feature')))
    CUG_FeatureList._cont = _CUG_FeatureList__item_
    CUG_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-BasicServiceGroupList >-----#
    Ext_BasicServiceGroupList = SEQ_OF(name='Ext-BasicServiceGroupList', mode=MODE_TYPE)
    _Ext_BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    Ext_BasicServiceGroupList._cont = _Ext_BasicServiceGroupList__item_
    Ext_BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfExt-BasicServiceGroups >-----#
    maxNumOfExt_BasicServiceGroups = INT(name='maxNumOfExt-BasicServiceGroups', mode=MODE_VALUE)
    maxNumOfExt_BasicServiceGroups._val = 32
    
    #-----< CUG-Feature >-----#
    CUG_Feature = SEQ(name='CUG-Feature', mode=MODE_TYPE)
    _CUG_Feature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _CUG_Feature_preferentialCUG_Indicator = INT(name='preferentialCUG-Indicator', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _CUG_Feature_interCUG_Restrictions = OCT_STR(name='interCUG-Restrictions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'InterCUG-Restrictions')))
    _CUG_Feature_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Feature._cont = ASN1Dict([
        ('basicService', _CUG_Feature_basicService),
        ('preferentialCUG-Indicator', _CUG_Feature_preferentialCUG_Indicator),
        ('interCUG-Restrictions', _CUG_Feature_interCUG_Restrictions),
        ('extensionContainer', _CUG_Feature_extensionContainer),
        ])
    CUG_Feature._ext = []
    
    #-----< InterCUG-Restrictions >-----#
    InterCUG_Restrictions = OCT_STR(name='InterCUG-Restrictions', mode=MODE_TYPE)
    InterCUG_Restrictions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-SS-Data >-----#
    Ext_SS_Data = SEQ(name='Ext-SS-Data', mode=MODE_TYPE)
    _Ext_SS_Data_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_SS_Data_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_SS_Data_ss_SubscriptionOption = CHOICE(name='ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _Ext_SS_Data_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _Ext_SS_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_SS_Data._cont = ASN1Dict([
        ('ss-Code', _Ext_SS_Data_ss_Code),
        ('ss-Status', _Ext_SS_Data_ss_Status),
        ('ss-SubscriptionOption', _Ext_SS_Data_ss_SubscriptionOption),
        ('basicServiceGroupList', _Ext_SS_Data_basicServiceGroupList),
        ('extensionContainer', _Ext_SS_Data_extensionContainer),
        ])
    Ext_SS_Data._ext = []
    
    #-----< LCS-PrivacyExceptionList >-----#
    LCS_PrivacyExceptionList = SEQ_OF(name='LCS-PrivacyExceptionList', mode=MODE_TYPE)
    _LCS_PrivacyExceptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyClass')))
    LCS_PrivacyExceptionList._cont = _LCS_PrivacyExceptionList__item_
    LCS_PrivacyExceptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< maxNumOfPrivacyClass >-----#
    maxNumOfPrivacyClass = INT(name='maxNumOfPrivacyClass', mode=MODE_VALUE)
    maxNumOfPrivacyClass._val = 4
    
    #-----< LCS-PrivacyClass >-----#
    LCS_PrivacyClass = SEQ(name='LCS-PrivacyClass', mode=MODE_TYPE)
    _LCS_PrivacyClass_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _LCS_PrivacyClass_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _LCS_PrivacyClass_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _LCS_PrivacyClass_externalClientList = SEQ_OF(name='externalClientList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClientList')), opt=True)
    _LCS_PrivacyClass_plmnClientList = SEQ_OF(name='plmnClientList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PLMNClientList')), opt=True)
    _LCS_PrivacyClass_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCS_PrivacyClass_ext_externalClientList = SEQ_OF(name='ext-externalClientList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ExternalClientList')), opt=True)
    _LCS_PrivacyClass_serviceTypeList = SEQ_OF(name='serviceTypeList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceTypeList')), opt=True)
    LCS_PrivacyClass._cont = ASN1Dict([
        ('ss-Code', _LCS_PrivacyClass_ss_Code),
        ('ss-Status', _LCS_PrivacyClass_ss_Status),
        ('notificationToMSUser', _LCS_PrivacyClass_notificationToMSUser),
        ('externalClientList', _LCS_PrivacyClass_externalClientList),
        ('plmnClientList', _LCS_PrivacyClass_plmnClientList),
        ('extensionContainer', _LCS_PrivacyClass_extensionContainer),
        ('ext-externalClientList', _LCS_PrivacyClass_ext_externalClientList),
        ('serviceTypeList', _LCS_PrivacyClass_serviceTypeList),
        ])
    LCS_PrivacyClass._ext = ['ext-externalClientList', 'serviceTypeList']
    
    #-----< ExternalClientList >-----#
    ExternalClientList = SEQ_OF(name='ExternalClientList', mode=MODE_TYPE)
    _ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    ExternalClientList._cont = _ExternalClientList__item_
    ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfExternalClient >-----#
    maxNumOfExternalClient = INT(name='maxNumOfExternalClient', mode=MODE_VALUE)
    maxNumOfExternalClient._val = 5
    
    #-----< PLMNClientList >-----#
    PLMNClientList = SEQ_OF(name='PLMNClientList', mode=MODE_TYPE)
    _PLMNClientList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')))
    PLMNClientList._cont = _PLMNClientList__item_
    PLMNClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfPLMNClient >-----#
    maxNumOfPLMNClient = INT(name='maxNumOfPLMNClient', mode=MODE_VALUE)
    maxNumOfPLMNClient._val = 5
    
    #-----< Ext-ExternalClientList >-----#
    Ext_ExternalClientList = SEQ_OF(name='Ext-ExternalClientList', mode=MODE_TYPE)
    _Ext_ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    Ext_ExternalClientList._cont = _Ext_ExternalClientList__item_
    Ext_ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=35)], ev=None, er=[])
    
    #-----< maxNumOfExt-ExternalClient >-----#
    maxNumOfExt_ExternalClient = INT(name='maxNumOfExt-ExternalClient', mode=MODE_VALUE)
    maxNumOfExt_ExternalClient._val = 35
    
    #-----< ExternalClient >-----#
    ExternalClient = SEQ(name='ExternalClient', mode=MODE_TYPE)
    _ExternalClient_clientIdentity = SEQ(name='clientIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')))
    _ExternalClient_gmlc_Restriction = ENUM(name='gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ExternalClient_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ExternalClient_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalClient._cont = ASN1Dict([
        ('clientIdentity', _ExternalClient_clientIdentity),
        ('gmlc-Restriction', _ExternalClient_gmlc_Restriction),
        ('notificationToMSUser', _ExternalClient_notificationToMSUser),
        ('extensionContainer', _ExternalClient_extensionContainer),
        ])
    ExternalClient._ext = []
    
    #-----< GMLC-Restriction >-----#
    GMLC_Restriction = ENUM(name='GMLC-Restriction', mode=MODE_TYPE)
    GMLC_Restriction._cont = ASN1Dict([('gmlc-List', 0), ('home-Country', 1)])
    GMLC_Restriction._ext = []
    
    #-----< NotificationToMSUser >-----#
    NotificationToMSUser = ENUM(name='NotificationToMSUser', mode=MODE_TYPE)
    NotificationToMSUser._cont = ASN1Dict([('notifyLocationAllowed', 0), ('notifyAndVerify-LocationAllowedIfNoResponse', 1), ('notifyAndVerify-LocationNotAllowedIfNoResponse', 2), ('locationNotAllowed', 3)])
    NotificationToMSUser._ext = ['locationNotAllowed']
    
    #-----< ServiceTypeList >-----#
    ServiceTypeList = SEQ_OF(name='ServiceTypeList', mode=MODE_TYPE)
    _ServiceTypeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceType')))
    ServiceTypeList._cont = _ServiceTypeList__item_
    ServiceTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfServiceType >-----#
    maxNumOfServiceType = INT(name='maxNumOfServiceType', mode=MODE_VALUE)
    maxNumOfServiceType._val = 32
    
    #-----< ServiceType >-----#
    ServiceType = SEQ(name='ServiceType', mode=MODE_TYPE)
    _ServiceType_serviceTypeIdentity = INT(name='serviceTypeIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    _ServiceType_gmlc_Restriction = ENUM(name='gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ServiceType_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ServiceType_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ServiceType._cont = ASN1Dict([
        ('serviceTypeIdentity', _ServiceType_serviceTypeIdentity),
        ('gmlc-Restriction', _ServiceType_gmlc_Restriction),
        ('notificationToMSUser', _ServiceType_notificationToMSUser),
        ('extensionContainer', _ServiceType_extensionContainer),
        ])
    ServiceType._ext = []
    
    #-----< MOLR-List >-----#
    MOLR_List = SEQ_OF(name='MOLR-List', mode=MODE_TYPE)
    _MOLR_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-Class')))
    MOLR_List._cont = _MOLR_List__item_
    MOLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< maxNumOfMOLR-Class >-----#
    maxNumOfMOLR_Class = INT(name='maxNumOfMOLR-Class', mode=MODE_VALUE)
    maxNumOfMOLR_Class._val = 3
    
    #-----< MOLR-Class >-----#
    MOLR_Class = SEQ(name='MOLR-Class', mode=MODE_TYPE)
    _MOLR_Class_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MOLR_Class_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MOLR_Class_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MOLR_Class._cont = ASN1Dict([
        ('ss-Code', _MOLR_Class_ss_Code),
        ('ss-Status', _MOLR_Class_ss_Status),
        ('extensionContainer', _MOLR_Class_extensionContainer),
        ])
    MOLR_Class._ext = []
    
    #-----< ZoneCodeList >-----#
    ZoneCodeList = SEQ_OF(name='ZoneCodeList', mode=MODE_TYPE)
    _ZoneCodeList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')))
    ZoneCodeList._cont = _ZoneCodeList__item_
    ZoneCodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< ZoneCode >-----#
    ZoneCode = OCT_STR(name='ZoneCode', mode=MODE_TYPE)
    ZoneCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< maxNumOfZoneCodes >-----#
    maxNumOfZoneCodes = INT(name='maxNumOfZoneCodes', mode=MODE_VALUE)
    maxNumOfZoneCodes._val = 10
    
    #-----< InsertSubscriberDataRes >-----#
    InsertSubscriberDataRes = SEQ(name='InsertSubscriberDataRes', mode=MODE_TYPE)
    _InsertSubscriberDataRes_teleserviceList = SEQ_OF(name='teleserviceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataRes_bearerServiceList = SEQ_OF(name='bearerServiceList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataRes_ss_List = SEQ_OF(name='ss-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _InsertSubscriberDataRes_odb_GeneralData = BIT_STR(name='odb-GeneralData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')), opt=True)
    _InsertSubscriberDataRes_regionalSubscriptionResponse = ENUM(name='regionalSubscriptionResponse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _InsertSubscriberDataRes_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _InsertSubscriberDataRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataRes_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _InsertSubscriberDataRes_supportedFeatures = BIT_STR(name='supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _InsertSubscriberDataRes_ext_SupportedFeatures = BIT_STR(name='ext-SupportedFeatures', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    InsertSubscriberDataRes._cont = ASN1Dict([
        ('teleserviceList', _InsertSubscriberDataRes_teleserviceList),
        ('bearerServiceList', _InsertSubscriberDataRes_bearerServiceList),
        ('ss-List', _InsertSubscriberDataRes_ss_List),
        ('odb-GeneralData', _InsertSubscriberDataRes_odb_GeneralData),
        ('regionalSubscriptionResponse', _InsertSubscriberDataRes_regionalSubscriptionResponse),
        ('supportedCamelPhases', _InsertSubscriberDataRes_supportedCamelPhases),
        ('extensionContainer', _InsertSubscriberDataRes_extensionContainer),
        ('offeredCamel4CSIs', _InsertSubscriberDataRes_offeredCamel4CSIs),
        ('supportedFeatures', _InsertSubscriberDataRes_supportedFeatures),
        ('ext-SupportedFeatures', _InsertSubscriberDataRes_ext_SupportedFeatures),
        ])
    InsertSubscriberDataRes._ext = ['offeredCamel4CSIs', 'supportedFeatures', 'ext-SupportedFeatures']
    
    #-----< RegionalSubscriptionResponse >-----#
    RegionalSubscriptionResponse = ENUM(name='RegionalSubscriptionResponse', mode=MODE_TYPE)
    RegionalSubscriptionResponse._cont = ASN1Dict([('networkNode-AreaRestricted', 0), ('tooManyZoneCodes', 1), ('zoneCodesConflict', 2), ('regionalSubscNotSupported', 3)])
    RegionalSubscriptionResponse._ext = None
    
    #-----< DeleteSubscriberDataArg >-----#
    DeleteSubscriberDataArg = SEQ(name='DeleteSubscriberDataArg', mode=MODE_TYPE)
    _DeleteSubscriberDataArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _DeleteSubscriberDataArg_basicServiceList = SEQ_OF(name='basicServiceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _DeleteSubscriberDataArg_ss_List = SEQ_OF(name='ss-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name='roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_regionalSubscriptionIdentifier = OCT_STR(name='regionalSubscriptionIdentifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')), opt=True)
    _DeleteSubscriberDataArg_vbsGroupIndication = NULL(name='vbsGroupIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vgcsGroupIndication = NULL(name='vgcsGroupIndication', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw = NULL(name='camelSubscriptionInfoWithdraw', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw = CHOICE(name='gprsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature = NULL(name='roamingRestrictedInSgsnDueToUnsuppportedFeature', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_lsaInformationWithdraw = CHOICE(name='lsaInformationWithdraw', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformationWithdraw')), opt=True)
    _DeleteSubscriberDataArg_gmlc_ListWithdraw = NULL(name='gmlc-ListWithdraw', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_istInformationWithdraw = NULL(name='istInformationWithdraw', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_specificCSI_Withdraw = BIT_STR(name='specificCSI-Withdraw', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw = NULL(name='chargingCharacteristicsWithdraw', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_stn_srWithdraw = NULL(name='stn-srWithdraw', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw = CHOICE(name='epsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_apn_oi_replacementWithdraw = NULL(name='apn-oi-replacementWithdraw', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_csg_SubscriptionDeleted = NULL(name='csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw = NULL(name='subscribedPeriodicTAU-RAU-TimerWithdraw', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw = NULL(name='subscribedPeriodicLAU-TimerWithdraw', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw = NULL(name='subscribed-vsrvccWithdraw', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted = NULL(name='vplmn-Csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_additionalMSISDN_Withdraw = NULL(name='additionalMSISDN-Withdraw', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw = NULL(name='cs-to-ps-SRVCC-Withdraw', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw = NULL(name='imsiGroupIdList-Withdraw', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw = NULL(name='userPlaneIntegrityProtectionWithdraw', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw = NULL(name='dl-Buffering-Suggested-Packet-Count-Withdraw', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_ue_UsageTypeWithdraw = NULL(name='ue-UsageTypeWithdraw', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_reset_idsWithdraw = NULL(name='reset-idsWithdraw', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_iab_OperationWithdraw = NULL(name='iab-OperationWithdraw', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    DeleteSubscriberDataArg._cont = ASN1Dict([
        ('imsi', _DeleteSubscriberDataArg_imsi),
        ('basicServiceList', _DeleteSubscriberDataArg_basicServiceList),
        ('ss-List', _DeleteSubscriberDataArg_ss_List),
        ('roamingRestrictionDueToUnsupportedFeature', _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        ('regionalSubscriptionIdentifier', _DeleteSubscriberDataArg_regionalSubscriptionIdentifier),
        ('vbsGroupIndication', _DeleteSubscriberDataArg_vbsGroupIndication),
        ('vgcsGroupIndication', _DeleteSubscriberDataArg_vgcsGroupIndication),
        ('camelSubscriptionInfoWithdraw', _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw),
        ('extensionContainer', _DeleteSubscriberDataArg_extensionContainer),
        ('gprsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw),
        ('roamingRestrictedInSgsnDueToUnsuppportedFeature', _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature),
        ('lsaInformationWithdraw', _DeleteSubscriberDataArg_lsaInformationWithdraw),
        ('gmlc-ListWithdraw', _DeleteSubscriberDataArg_gmlc_ListWithdraw),
        ('istInformationWithdraw', _DeleteSubscriberDataArg_istInformationWithdraw),
        ('specificCSI-Withdraw', _DeleteSubscriberDataArg_specificCSI_Withdraw),
        ('chargingCharacteristicsWithdraw', _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw),
        ('stn-srWithdraw', _DeleteSubscriberDataArg_stn_srWithdraw),
        ('epsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw),
        ('apn-oi-replacementWithdraw', _DeleteSubscriberDataArg_apn_oi_replacementWithdraw),
        ('csg-SubscriptionDeleted', _DeleteSubscriberDataArg_csg_SubscriptionDeleted),
        ('subscribedPeriodicTAU-RAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw),
        ('subscribedPeriodicLAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw),
        ('subscribed-vsrvccWithdraw', _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw),
        ('vplmn-Csg-SubscriptionDeleted', _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted),
        ('additionalMSISDN-Withdraw', _DeleteSubscriberDataArg_additionalMSISDN_Withdraw),
        ('cs-to-ps-SRVCC-Withdraw', _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw),
        ('imsiGroupIdList-Withdraw', _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw),
        ('userPlaneIntegrityProtectionWithdraw', _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw),
        ('dl-Buffering-Suggested-Packet-Count-Withdraw', _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw),
        ('ue-UsageTypeWithdraw', _DeleteSubscriberDataArg_ue_UsageTypeWithdraw),
        ('reset-idsWithdraw', _DeleteSubscriberDataArg_reset_idsWithdraw),
        ('iab-OperationWithdraw', _DeleteSubscriberDataArg_iab_OperationWithdraw),
        ])
    DeleteSubscriberDataArg._ext = ['gprsSubscriptionDataWithdraw', 'roamingRestrictedInSgsnDueToUnsuppportedFeature', 'lsaInformationWithdraw', 'gmlc-ListWithdraw', 'istInformationWithdraw', 'specificCSI-Withdraw', 'chargingCharacteristicsWithdraw', 'stn-srWithdraw', 'epsSubscriptionDataWithdraw', 'apn-oi-replacementWithdraw', 'csg-SubscriptionDeleted', 'subscribedPeriodicTAU-RAU-TimerWithdraw', 'subscribedPeriodicLAU-TimerWithdraw', 'subscribed-vsrvccWithdraw', 'vplmn-Csg-SubscriptionDeleted', 'additionalMSISDN-Withdraw', 'cs-to-ps-SRVCC-Withdraw', 'imsiGroupIdList-Withdraw', 'userPlaneIntegrityProtectionWithdraw', 'dl-Buffering-Suggested-Packet-Count-Withdraw', 'ue-UsageTypeWithdraw', 'reset-idsWithdraw', 'iab-OperationWithdraw']
    
    #-----< SpecificCSI-Withdraw >-----#
    SpecificCSI_Withdraw = BIT_STR(name='SpecificCSI-Withdraw', mode=MODE_TYPE)
    SpecificCSI_Withdraw._cont = ASN1Dict([('o-csi', 0), ('ss-csi', 1), ('tif-csi', 2), ('d-csi', 3), ('vt-csi', 4), ('mo-sms-csi', 5), ('m-csi', 6), ('gprs-csi', 7), ('t-csi', 8), ('mt-sms-csi', 9), ('mg-csi', 10), ('o-IM-CSI', 11), ('d-IM-CSI', 12), ('vt-IM-CSI', 13)])
    SpecificCSI_Withdraw._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=32)], ev=None, er=[])
    
    #-----< GPRSSubscriptionDataWithdraw >-----#
    GPRSSubscriptionDataWithdraw = CHOICE(name='GPRSSubscriptionDataWithdraw', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_allGPRSData = NULL(name='allGPRSData', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_contextIdList = SEQ_OF(name='contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    GPRSSubscriptionDataWithdraw._cont = ASN1Dict([
        ('allGPRSData', _GPRSSubscriptionDataWithdraw_allGPRSData),
        ('contextIdList', _GPRSSubscriptionDataWithdraw_contextIdList),
        ])
    GPRSSubscriptionDataWithdraw._ext = None
    
    #-----< EPS-SubscriptionDataWithdraw >-----#
    EPS_SubscriptionDataWithdraw = CHOICE(name='EPS-SubscriptionDataWithdraw', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_allEPS_Data = NULL(name='allEPS-Data', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_contextIdList = SEQ_OF(name='contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    EPS_SubscriptionDataWithdraw._cont = ASN1Dict([
        ('allEPS-Data', _EPS_SubscriptionDataWithdraw_allEPS_Data),
        ('contextIdList', _EPS_SubscriptionDataWithdraw_contextIdList),
        ])
    EPS_SubscriptionDataWithdraw._ext = None
    
    #-----< ContextIdList >-----#
    ContextIdList = SEQ_OF(name='ContextIdList', mode=MODE_TYPE)
    _ContextIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    ContextIdList._cont = _ContextIdList__item_
    ContextIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< LSAInformationWithdraw >-----#
    LSAInformationWithdraw = CHOICE(name='LSAInformationWithdraw', mode=MODE_TYPE)
    _LSAInformationWithdraw_allLSAData = NULL(name='allLSAData', mode=MODE_TYPE)
    _LSAInformationWithdraw_lsaIdentityList = SEQ_OF(name='lsaIdentityList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentityList')))
    LSAInformationWithdraw._cont = ASN1Dict([
        ('allLSAData', _LSAInformationWithdraw_allLSAData),
        ('lsaIdentityList', _LSAInformationWithdraw_lsaIdentityList),
        ])
    LSAInformationWithdraw._ext = None
    
    #-----< LSAIdentityList >-----#
    LSAIdentityList = SEQ_OF(name='LSAIdentityList', mode=MODE_TYPE)
    _LSAIdentityList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    LSAIdentityList._cont = _LSAIdentityList__item_
    LSAIdentityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< BasicServiceList >-----#
    BasicServiceList = SEQ_OF(name='BasicServiceList', mode=MODE_TYPE)
    _BasicServiceList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceList._cont = _BasicServiceList__item_
    BasicServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=None, er=[])
    
    #-----< maxNumOfBasicServices >-----#
    maxNumOfBasicServices = INT(name='maxNumOfBasicServices', mode=MODE_VALUE)
    maxNumOfBasicServices._val = 70
    
    #-----< DeleteSubscriberDataRes >-----#
    DeleteSubscriberDataRes = SEQ(name='DeleteSubscriberDataRes', mode=MODE_TYPE)
    _DeleteSubscriberDataRes_regionalSubscriptionResponse = ENUM(name='regionalSubscriptionResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _DeleteSubscriberDataRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeleteSubscriberDataRes._cont = ASN1Dict([
        ('regionalSubscriptionResponse', _DeleteSubscriberDataRes_regionalSubscriptionResponse),
        ('extensionContainer', _DeleteSubscriberDataRes_extensionContainer),
        ])
    DeleteSubscriberDataRes._ext = []
    
    #-----< VlrCamelSubscriptionInfo >-----#
    VlrCamelSubscriptionInfo = SEQ(name='VlrCamelSubscriptionInfo', mode=MODE_TYPE)
    _VlrCamelSubscriptionInfo_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VlrCamelSubscriptionInfo_ss_CSI = SEQ(name='ss-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_tif_CSI = NULL(name='tif-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VlrCamelSubscriptionInfo_m_CSI = SEQ(name='m-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mo_sms_CSI = SEQ(name='mo-sms-CSI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_vt_CSI = SEQ(name='vt-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='t-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_d_CSI = SEQ(name='d-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_sms_CSI = SEQ(name='mt-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name='mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    VlrCamelSubscriptionInfo._cont = ASN1Dict([
        ('o-CSI', _VlrCamelSubscriptionInfo_o_CSI),
        ('extensionContainer', _VlrCamelSubscriptionInfo_extensionContainer),
        ('ss-CSI', _VlrCamelSubscriptionInfo_ss_CSI),
        ('o-BcsmCamelTDP-CriteriaList', _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        ('tif-CSI', _VlrCamelSubscriptionInfo_tif_CSI),
        ('m-CSI', _VlrCamelSubscriptionInfo_m_CSI),
        ('mo-sms-CSI', _VlrCamelSubscriptionInfo_mo_sms_CSI),
        ('vt-CSI', _VlrCamelSubscriptionInfo_vt_CSI),
        ('t-BCSM-CAMEL-TDP-CriteriaList', _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        ('d-CSI', _VlrCamelSubscriptionInfo_d_CSI),
        ('mt-sms-CSI', _VlrCamelSubscriptionInfo_mt_sms_CSI),
        ('mt-smsCAMELTDP-CriteriaList', _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ])
    VlrCamelSubscriptionInfo._ext = ['ss-CSI', 'o-BcsmCamelTDP-CriteriaList', 'tif-CSI', 'm-CSI', 'mo-sms-CSI', 'vt-CSI', 't-BCSM-CAMEL-TDP-CriteriaList', 'd-CSI', 'mt-sms-CSI', 'mt-smsCAMELTDP-CriteriaList']
    
    #-----< MT-smsCAMELTDP-CriteriaList >-----#
    MT_smsCAMELTDP_CriteriaList = SEQ_OF(name='MT-smsCAMELTDP-CriteriaList', mode=MODE_TYPE)
    _MT_smsCAMELTDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-Criteria')))
    MT_smsCAMELTDP_CriteriaList._cont = _MT_smsCAMELTDP_CriteriaList__item_
    MT_smsCAMELTDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< MT-smsCAMELTDP-Criteria >-----#
    MT_smsCAMELTDP_Criteria = SEQ(name='MT-smsCAMELTDP-Criteria', mode=MODE_TYPE)
    _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint = ENUM(name='sms-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion = SEQ_OF(name='tpdu-TypeCriterion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TPDU-TypeCriterion')), opt=True)
    MT_smsCAMELTDP_Criteria._cont = ASN1Dict([
        ('sms-TriggerDetectionPoint', _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint),
        ('tpdu-TypeCriterion', _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion),
        ])
    MT_smsCAMELTDP_Criteria._ext = []
    
    #-----< TPDU-TypeCriterion >-----#
    TPDU_TypeCriterion = SEQ_OF(name='TPDU-TypeCriterion', mode=MODE_TYPE)
    _TPDU_TypeCriterion__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-SMS-TPDU-Type')))
    TPDU_TypeCriterion._cont = _TPDU_TypeCriterion__item_
    TPDU_TypeCriterion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfTPDUTypes >-----#
    maxNumOfTPDUTypes = INT(name='maxNumOfTPDUTypes', mode=MODE_VALUE)
    maxNumOfTPDUTypes._val = 5
    
    #-----< MT-SMS-TPDU-Type >-----#
    MT_SMS_TPDU_Type = ENUM(name='MT-SMS-TPDU-Type', mode=MODE_TYPE)
    MT_SMS_TPDU_Type._cont = ASN1Dict([('sms-DELIVER', 0), ('sms-SUBMIT-REPORT', 1), ('sms-STATUS-REPORT', 2)])
    MT_SMS_TPDU_Type._ext = []
    
    #-----< D-CSI >-----#
    D_CSI = SEQ(name='D-CSI', mode=MODE_TYPE)
    _D_CSI_dp_AnalysedInfoCriteriaList = SEQ_OF(name='dp-AnalysedInfoCriteriaList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriteriaList')), opt=True)
    _D_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _D_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _D_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _D_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    D_CSI._cont = ASN1Dict([
        ('dp-AnalysedInfoCriteriaList', _D_CSI_dp_AnalysedInfoCriteriaList),
        ('camelCapabilityHandling', _D_CSI_camelCapabilityHandling),
        ('extensionContainer', _D_CSI_extensionContainer),
        ('notificationToCSE', _D_CSI_notificationToCSE),
        ('csi-Active', _D_CSI_csi_Active),
        ])
    D_CSI._ext = []
    
    #-----< DP-AnalysedInfoCriteriaList >-----#
    DP_AnalysedInfoCriteriaList = SEQ_OF(name='DP-AnalysedInfoCriteriaList', mode=MODE_TYPE)
    _DP_AnalysedInfoCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriterium')))
    DP_AnalysedInfoCriteriaList._cont = _DP_AnalysedInfoCriteriaList__item_
    DP_AnalysedInfoCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfDP-AnalysedInfoCriteria >-----#
    maxNumOfDP_AnalysedInfoCriteria = INT(name='maxNumOfDP-AnalysedInfoCriteria', mode=MODE_VALUE)
    maxNumOfDP_AnalysedInfoCriteria._val = 10
    
    #-----< DP-AnalysedInfoCriterium >-----#
    DP_AnalysedInfoCriterium = SEQ(name='DP-AnalysedInfoCriterium', mode=MODE_TYPE)
    _DP_AnalysedInfoCriterium_dialledNumber = OCT_STR(name='dialledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _DP_AnalysedInfoCriterium_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _DP_AnalysedInfoCriterium_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DP_AnalysedInfoCriterium._cont = ASN1Dict([
        ('dialledNumber', _DP_AnalysedInfoCriterium_dialledNumber),
        ('serviceKey', _DP_AnalysedInfoCriterium_serviceKey),
        ('gsmSCF-Address', _DP_AnalysedInfoCriterium_gsmSCF_Address),
        ('defaultCallHandling', _DP_AnalysedInfoCriterium_defaultCallHandling),
        ('extensionContainer', _DP_AnalysedInfoCriterium_extensionContainer),
        ])
    DP_AnalysedInfoCriterium._ext = []
    
    #-----< SS-CSI >-----#
    SS_CSI = SEQ(name='SS-CSI', mode=MODE_TYPE)
    _SS_CSI_ss_CamelData = SEQ(name='ss-CamelData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CamelData')))
    _SS_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SS_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_CSI._cont = ASN1Dict([
        ('ss-CamelData', _SS_CSI_ss_CamelData),
        ('extensionContainer', _SS_CSI_extensionContainer),
        ('notificationToCSE', _SS_CSI_notificationToCSE),
        ('csi-Active', _SS_CSI_csi_Active),
        ])
    SS_CSI._ext = ['notificationToCSE', 'csi-Active']
    
    #-----< SS-CamelData >-----#
    SS_CamelData = SEQ(name='SS-CamelData', mode=MODE_TYPE)
    _SS_CamelData_ss_EventList = SEQ_OF(name='ss-EventList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-EventList')))
    _SS_CamelData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_CamelData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_CamelData._cont = ASN1Dict([
        ('ss-EventList', _SS_CamelData_ss_EventList),
        ('gsmSCF-Address', _SS_CamelData_gsmSCF_Address),
        ('extensionContainer', _SS_CamelData_extensionContainer),
        ])
    SS_CamelData._ext = []
    
    #-----< SS-EventList >-----#
    SS_EventList = SEQ_OF(name='SS-EventList', mode=MODE_TYPE)
    _SS_EventList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_EventList._cont = _SS_EventList__item_
    SS_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelSSEvents >-----#
    maxNumOfCamelSSEvents = INT(name='maxNumOfCamelSSEvents', mode=MODE_VALUE)
    maxNumOfCamelSSEvents._val = 10
    
    #-----< O-CSI >-----#
    O_CSI = SEQ(name='O-CSI', mode=MODE_TYPE)
    _O_CSI_o_BcsmCamelTDPDataList = SEQ_OF(name='o-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPDataList')))
    _O_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _O_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _O_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _O_CSI_csiActive = NULL(name='csiActive', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    O_CSI._cont = ASN1Dict([
        ('o-BcsmCamelTDPDataList', _O_CSI_o_BcsmCamelTDPDataList),
        ('extensionContainer', _O_CSI_extensionContainer),
        ('camelCapabilityHandling', _O_CSI_camelCapabilityHandling),
        ('notificationToCSE', _O_CSI_notificationToCSE),
        ('csiActive', _O_CSI_csiActive),
        ])
    O_CSI._ext = ['camelCapabilityHandling', 'notificationToCSE', 'csiActive']
    
    #-----< O-BcsmCamelTDPDataList >-----#
    O_BcsmCamelTDPDataList = SEQ_OF(name='O-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _O_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPData')))
    O_BcsmCamelTDPDataList._cont = _O_BcsmCamelTDPDataList__item_
    O_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelTDPData >-----#
    maxNumOfCamelTDPData = INT(name='maxNumOfCamelTDPData', mode=MODE_VALUE)
    maxNumOfCamelTDPData._val = 10
    
    #-----< O-BcsmCamelTDPData >-----#
    O_BcsmCamelTDPData = SEQ(name='O-BcsmCamelTDPData', mode=MODE_TYPE)
    _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint = ENUM(name='o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDPData_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _O_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _O_BcsmCamelTDPData_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _O_BcsmCamelTDPData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDPData._cont = ASN1Dict([
        ('o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint),
        ('serviceKey', _O_BcsmCamelTDPData_serviceKey),
        ('gsmSCF-Address', _O_BcsmCamelTDPData_gsmSCF_Address),
        ('defaultCallHandling', _O_BcsmCamelTDPData_defaultCallHandling),
        ('extensionContainer', _O_BcsmCamelTDPData_extensionContainer),
        ])
    O_BcsmCamelTDPData._ext = []
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name='ServiceKey', mode=MODE_TYPE)
    ServiceKey._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< O-BcsmTriggerDetectionPoint >-----#
    O_BcsmTriggerDetectionPoint = ENUM(name='O-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    O_BcsmTriggerDetectionPoint._cont = ASN1Dict([('collectedInfo', 2), ('routeSelectFailure', 4)])
    O_BcsmTriggerDetectionPoint._ext = ['routeSelectFailure']
    
    #-----< O-BcsmCamelTDPCriteriaList >-----#
    O_BcsmCamelTDPCriteriaList = SEQ_OF(name='O-BcsmCamelTDPCriteriaList', mode=MODE_TYPE)
    _O_BcsmCamelTDPCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDP-Criteria')))
    O_BcsmCamelTDPCriteriaList._cont = _O_BcsmCamelTDPCriteriaList__item_
    O_BcsmCamelTDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BCSM-CAMEL-TDP-CriteriaList >-----#
    T_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='T-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-Criteria')))
    T_BCSM_CAMEL_TDP_CriteriaList._cont = _T_BCSM_CAMEL_TDP_CriteriaList__item_
    T_BCSM_CAMEL_TDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< O-BcsmCamelTDP-Criteria >-----#
    O_BcsmCamelTDP_Criteria = SEQ(name='O-BcsmCamelTDP-Criteria', mode=MODE_TYPE)
    _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint = ENUM(name='o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDP_Criteria_destinationNumberCriteria = SEQ(name='destinationNumberCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_basicServiceCriteria = SEQ_OF(name='basicServiceCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_callTypeCriteria = ENUM(name='callTypeCriteria', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallTypeCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria = SEQ_OF(name='o-CauseValueCriteria', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CauseValueCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDP_Criteria._cont = ASN1Dict([
        ('o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint),
        ('destinationNumberCriteria', _O_BcsmCamelTDP_Criteria_destinationNumberCriteria),
        ('basicServiceCriteria', _O_BcsmCamelTDP_Criteria_basicServiceCriteria),
        ('callTypeCriteria', _O_BcsmCamelTDP_Criteria_callTypeCriteria),
        ('o-CauseValueCriteria', _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria),
        ('extensionContainer', _O_BcsmCamelTDP_Criteria_extensionContainer),
        ])
    O_BcsmCamelTDP_Criteria._ext = ['o-CauseValueCriteria', 'extensionContainer']
    
    #-----< T-BCSM-CAMEL-TDP-Criteria >-----#
    T_BCSM_CAMEL_TDP_Criteria = SEQ(name='T-BCSM-CAMEL-TDP-Criteria', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint = ENUM(name='t-BCSM-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria = SEQ_OF(name='basicServiceCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria = SEQ_OF(name='t-CauseValueCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CauseValueCriteria')), opt=True)
    T_BCSM_CAMEL_TDP_Criteria._cont = ASN1Dict([
        ('t-BCSM-TriggerDetectionPoint', _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint),
        ('basicServiceCriteria', _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria),
        ('t-CauseValueCriteria', _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria),
        ])
    T_BCSM_CAMEL_TDP_Criteria._ext = []
    
    #-----< DestinationNumberCriteria >-----#
    DestinationNumberCriteria = SEQ(name='DestinationNumberCriteria', mode=MODE_TYPE)
    _DestinationNumberCriteria_matchType = ENUM(name='matchType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MatchType')))
    _DestinationNumberCriteria_destinationNumberList = SEQ_OF(name='destinationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberList')), opt=True)
    _DestinationNumberCriteria_destinationNumberLengthList = SEQ_OF(name='destinationNumberLengthList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberLengthList')), opt=True)
    DestinationNumberCriteria._cont = ASN1Dict([
        ('matchType', _DestinationNumberCriteria_matchType),
        ('destinationNumberList', _DestinationNumberCriteria_destinationNumberList),
        ('destinationNumberLengthList', _DestinationNumberCriteria_destinationNumberLengthList),
        ])
    DestinationNumberCriteria._ext = []
    
    #-----< DestinationNumberList >-----#
    DestinationNumberList = SEQ_OF(name='DestinationNumberList', mode=MODE_TYPE)
    _DestinationNumberList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    DestinationNumberList._cont = _DestinationNumberList__item_
    DestinationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< DestinationNumberLengthList >-----#
    DestinationNumberLengthList = SEQ_OF(name='DestinationNumberLengthList', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_ = INT(name='_item_', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    DestinationNumberLengthList._cont = _DestinationNumberLengthList__item_
    DestinationNumberLengthList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< BasicServiceCriteria >-----#
    BasicServiceCriteria = SEQ_OF(name='BasicServiceCriteria', mode=MODE_TYPE)
    _BasicServiceCriteria__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceCriteria._cont = _BasicServiceCriteria__item_
    BasicServiceCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfISDN-AddressDigits >-----#
    maxNumOfISDN_AddressDigits = INT(name='maxNumOfISDN-AddressDigits', mode=MODE_VALUE)
    maxNumOfISDN_AddressDigits._val = 15
    
    #-----< maxNumOfCamelDestinationNumbers >-----#
    maxNumOfCamelDestinationNumbers = INT(name='maxNumOfCamelDestinationNumbers', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumbers._val = 10
    
    #-----< maxNumOfCamelDestinationNumberLengths >-----#
    maxNumOfCamelDestinationNumberLengths = INT(name='maxNumOfCamelDestinationNumberLengths', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumberLengths._val = 3
    
    #-----< maxNumOfCamelBasicServiceCriteria >-----#
    maxNumOfCamelBasicServiceCriteria = INT(name='maxNumOfCamelBasicServiceCriteria', mode=MODE_VALUE)
    maxNumOfCamelBasicServiceCriteria._val = 5
    
    #-----< CallTypeCriteria >-----#
    CallTypeCriteria = ENUM(name='CallTypeCriteria', mode=MODE_TYPE)
    CallTypeCriteria._cont = ASN1Dict([('forwarded', 0), ('notForwarded', 1)])
    CallTypeCriteria._ext = None
    
    #-----< MatchType >-----#
    MatchType = ENUM(name='MatchType', mode=MODE_TYPE)
    MatchType._cont = ASN1Dict([('inhibiting', 0), ('enabling', 1)])
    MatchType._ext = None
    
    #-----< O-CauseValueCriteria >-----#
    O_CauseValueCriteria = SEQ_OF(name='O-CauseValueCriteria', mode=MODE_TYPE)
    _O_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    O_CauseValueCriteria._cont = _O_CauseValueCriteria__item_
    O_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< T-CauseValueCriteria >-----#
    T_CauseValueCriteria = SEQ_OF(name='T-CauseValueCriteria', mode=MODE_TYPE)
    _T_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    T_CauseValueCriteria._cont = _T_CauseValueCriteria__item_
    T_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCAMEL-O-CauseValueCriteria >-----#
    maxNumOfCAMEL_O_CauseValueCriteria = INT(name='maxNumOfCAMEL-O-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_O_CauseValueCriteria._val = 5
    
    #-----< maxNumOfCAMEL-T-CauseValueCriteria >-----#
    maxNumOfCAMEL_T_CauseValueCriteria = INT(name='maxNumOfCAMEL-T-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_T_CauseValueCriteria._val = 5
    
    #-----< CauseValue >-----#
    CauseValue = OCT_STR(name='CauseValue', mode=MODE_TYPE)
    CauseValue._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< DefaultCallHandling >-----#
    DefaultCallHandling = ENUM(name='DefaultCallHandling', mode=MODE_TYPE)
    DefaultCallHandling._cont = ASN1Dict([('continueCall', 0), ('releaseCall', 1)])
    DefaultCallHandling._ext = []
    
    #-----< CamelCapabilityHandling >-----#
    CamelCapabilityHandling = INT(name='CamelCapabilityHandling', mode=MODE_TYPE)
    CamelCapabilityHandling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SupportedCamelPhases >-----#
    SupportedCamelPhases = BIT_STR(name='SupportedCamelPhases', mode=MODE_TYPE)
    SupportedCamelPhases._cont = ASN1Dict([('phase1', 0), ('phase2', 1), ('phase3', 2), ('phase4', 3)])
    SupportedCamelPhases._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4CSIs >-----#
    OfferedCamel4CSIs = BIT_STR(name='OfferedCamel4CSIs', mode=MODE_TYPE)
    OfferedCamel4CSIs._cont = ASN1Dict([('o-csi', 0), ('d-csi', 1), ('vt-csi', 2), ('t-csi', 3), ('mt-sms-csi', 4), ('mg-csi', 5), ('psi-enhancements', 6)])
    OfferedCamel4CSIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4Functionalities >-----#
    OfferedCamel4Functionalities = BIT_STR(name='OfferedCamel4Functionalities', mode=MODE_TYPE)
    OfferedCamel4Functionalities._cont = ASN1Dict([('initiateCallAttempt', 0), ('splitLeg', 1), ('moveLeg', 2), ('disconnectLeg', 3), ('entityReleased', 4), ('dfc-WithArgument', 5), ('playTone', 6), ('dtmf-MidCall', 7), ('chargingIndicator', 8), ('alertingDP', 9), ('locationAtAlerting', 10), ('changeOfPositionDP', 11), ('or-Interactions', 12), ('warningToneEnhancements', 13), ('cf-Enhancements', 14), ('subscribedEnhancedDialledServices', 15), ('servingNetworkEnhancedDialledServices', 16), ('criteriaForChangeOfPositionDP', 17), ('serviceChangeDP', 18), ('collectInformation', 19)])
    OfferedCamel4Functionalities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=64)], ev=None, er=[])
    
    #-----< SMS-CSI >-----#
    SMS_CSI = SEQ(name='SMS-CSI', mode=MODE_TYPE)
    _SMS_CSI_sms_CAMEL_TDP_DataList = SEQ_OF(name='sms-CAMEL-TDP-DataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-DataList')), opt=True)
    _SMS_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _SMS_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SMS_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMS_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SMS_CSI._cont = ASN1Dict([
        ('sms-CAMEL-TDP-DataList', _SMS_CSI_sms_CAMEL_TDP_DataList),
        ('camelCapabilityHandling', _SMS_CSI_camelCapabilityHandling),
        ('extensionContainer', _SMS_CSI_extensionContainer),
        ('notificationToCSE', _SMS_CSI_notificationToCSE),
        ('csi-Active', _SMS_CSI_csi_Active),
        ])
    SMS_CSI._ext = []
    
    #-----< SMS-CAMEL-TDP-DataList >-----#
    SMS_CAMEL_TDP_DataList = SEQ_OF(name='SMS-CAMEL-TDP-DataList', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-Data')))
    SMS_CAMEL_TDP_DataList._cont = _SMS_CAMEL_TDP_DataList__item_
    SMS_CAMEL_TDP_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SMS-CAMEL-TDP-Data >-----#
    SMS_CAMEL_TDP_Data = SEQ(name='SMS-CAMEL-TDP-Data', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint = ENUM(name='sms-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _SMS_CAMEL_TDP_Data_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _SMS_CAMEL_TDP_Data_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SMS_CAMEL_TDP_Data_defaultSMS_Handling = ENUM(name='defaultSMS-Handling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')))
    _SMS_CAMEL_TDP_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SMS_CAMEL_TDP_Data._cont = ASN1Dict([
        ('sms-TriggerDetectionPoint', _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint),
        ('serviceKey', _SMS_CAMEL_TDP_Data_serviceKey),
        ('gsmSCF-Address', _SMS_CAMEL_TDP_Data_gsmSCF_Address),
        ('defaultSMS-Handling', _SMS_CAMEL_TDP_Data_defaultSMS_Handling),
        ('extensionContainer', _SMS_CAMEL_TDP_Data_extensionContainer),
        ])
    SMS_CAMEL_TDP_Data._ext = []
    
    #-----< SMS-TriggerDetectionPoint >-----#
    SMS_TriggerDetectionPoint = ENUM(name='SMS-TriggerDetectionPoint', mode=MODE_TYPE)
    SMS_TriggerDetectionPoint._cont = ASN1Dict([('sms-CollectedInfo', 1), ('sms-DeliveryRequest', 2)])
    SMS_TriggerDetectionPoint._ext = ['sms-DeliveryRequest']
    
    #-----< DefaultSMS-Handling >-----#
    DefaultSMS_Handling = ENUM(name='DefaultSMS-Handling', mode=MODE_TYPE)
    DefaultSMS_Handling._cont = ASN1Dict([('continueTransaction', 0), ('releaseTransaction', 1)])
    DefaultSMS_Handling._ext = []
    
    #-----< M-CSI >-----#
    M_CSI = SEQ(name='M-CSI', mode=MODE_TYPE)
    _M_CSI_mobilityTriggers = SEQ_OF(name='mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _M_CSI_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _M_CSI_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _M_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _M_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _M_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    M_CSI._cont = ASN1Dict([
        ('mobilityTriggers', _M_CSI_mobilityTriggers),
        ('serviceKey', _M_CSI_serviceKey),
        ('gsmSCF-Address', _M_CSI_gsmSCF_Address),
        ('extensionContainer', _M_CSI_extensionContainer),
        ('notificationToCSE', _M_CSI_notificationToCSE),
        ('csi-Active', _M_CSI_csi_Active),
        ])
    M_CSI._ext = []
    
    #-----< MG-CSI >-----#
    MG_CSI = SEQ(name='MG-CSI', mode=MODE_TYPE)
    _MG_CSI_mobilityTriggers = SEQ_OF(name='mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _MG_CSI_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _MG_CSI_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MG_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MG_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MG_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MG_CSI._cont = ASN1Dict([
        ('mobilityTriggers', _MG_CSI_mobilityTriggers),
        ('serviceKey', _MG_CSI_serviceKey),
        ('gsmSCF-Address', _MG_CSI_gsmSCF_Address),
        ('extensionContainer', _MG_CSI_extensionContainer),
        ('notificationToCSE', _MG_CSI_notificationToCSE),
        ('csi-Active', _MG_CSI_csi_Active),
        ])
    MG_CSI._ext = []
    
    #-----< MobilityTriggers >-----#
    MobilityTriggers = SEQ_OF(name='MobilityTriggers', mode=MODE_TYPE)
    _MobilityTriggers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    MobilityTriggers._cont = _MobilityTriggers__item_
    MobilityTriggers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfMobilityTriggers >-----#
    maxNumOfMobilityTriggers = INT(name='maxNumOfMobilityTriggers', mode=MODE_VALUE)
    maxNumOfMobilityTriggers._val = 10
    
    #-----< MM-Code >-----#
    MM_Code = OCT_STR(name='MM-Code', mode=MODE_TYPE)
    MM_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< T-CSI >-----#
    T_CSI = SEQ(name='T-CSI', mode=MODE_TYPE)
    _T_CSI_t_BcsmCamelTDPDataList = SEQ_OF(name='t-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPDataList')))
    _T_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _T_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _T_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _T_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    T_CSI._cont = ASN1Dict([
        ('t-BcsmCamelTDPDataList', _T_CSI_t_BcsmCamelTDPDataList),
        ('extensionContainer', _T_CSI_extensionContainer),
        ('camelCapabilityHandling', _T_CSI_camelCapabilityHandling),
        ('notificationToCSE', _T_CSI_notificationToCSE),
        ('csi-Active', _T_CSI_csi_Active),
        ])
    T_CSI._ext = ['camelCapabilityHandling', 'notificationToCSE', 'csi-Active']
    
    #-----< T-BcsmCamelTDPDataList >-----#
    T_BcsmCamelTDPDataList = SEQ_OF(name='T-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _T_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPData')))
    T_BcsmCamelTDPDataList._cont = _T_BcsmCamelTDPDataList__item_
    T_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BcsmCamelTDPData >-----#
    T_BcsmCamelTDPData = SEQ(name='T-BcsmCamelTDPData', mode=MODE_TYPE)
    _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint = ENUM(name='t-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BcsmCamelTDPData_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _T_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _T_BcsmCamelTDPData_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _T_BcsmCamelTDPData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    T_BcsmCamelTDPData._cont = ASN1Dict([
        ('t-BcsmTriggerDetectionPoint', _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint),
        ('serviceKey', _T_BcsmCamelTDPData_serviceKey),
        ('gsmSCF-Address', _T_BcsmCamelTDPData_gsmSCF_Address),
        ('defaultCallHandling', _T_BcsmCamelTDPData_defaultCallHandling),
        ('extensionContainer', _T_BcsmCamelTDPData_extensionContainer),
        ])
    T_BcsmCamelTDPData._ext = []
    
    #-----< T-BcsmTriggerDetectionPoint >-----#
    T_BcsmTriggerDetectionPoint = ENUM(name='T-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    T_BcsmTriggerDetectionPoint._cont = ASN1Dict([('termAttemptAuthorized', 12), ('tBusy', 13), ('tNoAnswer', 14)])
    T_BcsmTriggerDetectionPoint._ext = ['tBusy', 'tNoAnswer']
    
    #-----< SendRoutingInfoForGprsArg >-----#
    SendRoutingInfoForGprsArg = SEQ(name='SendRoutingInfoForGprsArg', mode=MODE_TYPE)
    _SendRoutingInfoForGprsArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendRoutingInfoForGprsArg_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsArg_ggsn_Number = OCT_STR(name='ggsn-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoForGprsArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsArg._cont = ASN1Dict([
        ('imsi', _SendRoutingInfoForGprsArg_imsi),
        ('ggsn-Address', _SendRoutingInfoForGprsArg_ggsn_Address),
        ('ggsn-Number', _SendRoutingInfoForGprsArg_ggsn_Number),
        ('extensionContainer', _SendRoutingInfoForGprsArg_extensionContainer),
        ])
    SendRoutingInfoForGprsArg._ext = []
    
    #-----< SendRoutingInfoForGprsRes >-----#
    SendRoutingInfoForGprsRes = SEQ(name='SendRoutingInfoForGprsRes', mode=MODE_TYPE)
    _SendRoutingInfoForGprsRes_sgsn_Address = OCT_STR(name='sgsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _SendRoutingInfoForGprsRes_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsRes_mobileNotReachableReason = INT(name='mobileNotReachableReason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _SendRoutingInfoForGprsRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsRes._cont = ASN1Dict([
        ('sgsn-Address', _SendRoutingInfoForGprsRes_sgsn_Address),
        ('ggsn-Address', _SendRoutingInfoForGprsRes_ggsn_Address),
        ('mobileNotReachableReason', _SendRoutingInfoForGprsRes_mobileNotReachableReason),
        ('extensionContainer', _SendRoutingInfoForGprsRes_extensionContainer),
        ])
    SendRoutingInfoForGprsRes._ext = []
    
    #-----< FailureReportArg >-----#
    FailureReportArg = SEQ(name='FailureReportArg', mode=MODE_TYPE)
    _FailureReportArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _FailureReportArg_ggsn_Number = OCT_STR(name='ggsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _FailureReportArg_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportArg._cont = ASN1Dict([
        ('imsi', _FailureReportArg_imsi),
        ('ggsn-Number', _FailureReportArg_ggsn_Number),
        ('ggsn-Address', _FailureReportArg_ggsn_Address),
        ('extensionContainer', _FailureReportArg_extensionContainer),
        ])
    FailureReportArg._ext = []
    
    #-----< FailureReportRes >-----#
    FailureReportRes = SEQ(name='FailureReportRes', mode=MODE_TYPE)
    _FailureReportRes_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportRes._cont = ASN1Dict([
        ('ggsn-Address', _FailureReportRes_ggsn_Address),
        ('extensionContainer', _FailureReportRes_extensionContainer),
        ])
    FailureReportRes._ext = []
    
    #-----< NoteMsPresentForGprsArg >-----#
    NoteMsPresentForGprsArg = SEQ(name='NoteMsPresentForGprsArg', mode=MODE_TYPE)
    _NoteMsPresentForGprsArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMsPresentForGprsArg_sgsn_Address = OCT_STR(name='sgsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _NoteMsPresentForGprsArg_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _NoteMsPresentForGprsArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsArg._cont = ASN1Dict([
        ('imsi', _NoteMsPresentForGprsArg_imsi),
        ('sgsn-Address', _NoteMsPresentForGprsArg_sgsn_Address),
        ('ggsn-Address', _NoteMsPresentForGprsArg_ggsn_Address),
        ('extensionContainer', _NoteMsPresentForGprsArg_extensionContainer),
        ])
    NoteMsPresentForGprsArg._ext = []
    
    #-----< NoteMsPresentForGprsRes >-----#
    NoteMsPresentForGprsRes = SEQ(name='NoteMsPresentForGprsRes', mode=MODE_TYPE)
    _NoteMsPresentForGprsRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsRes._cont = ASN1Dict([
        ('extensionContainer', _NoteMsPresentForGprsRes_extensionContainer),
        ])
    NoteMsPresentForGprsRes._ext = []
    
    #-----< ResetArg >-----#
    ResetArg = SEQ(name='ResetArg', mode=MODE_TYPE)
    _ResetArg_sendingNodenumber = CHOICE(name='sendingNodenumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SendingNode-Number')))
    _ResetArg_hlr_List = SEQ_OF(name='hlr-List', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-List')), opt=True)
    _ResetArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResetArg_reset_Id_List = SEQ_OF(name='reset-Id-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _ResetArg_subscriptionData = SEQ(name='subscriptionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'InsertSubscriberDataArg')), opt=True)
    _ResetArg_subscriptionDataDeletion = SEQ(name='subscriptionDataDeletion', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DeleteSubscriberDataArg')), opt=True)
    ResetArg._cont = ASN1Dict([
        ('sendingNodenumber', _ResetArg_sendingNodenumber),
        ('hlr-List', _ResetArg_hlr_List),
        ('extensionContainer', _ResetArg_extensionContainer),
        ('reset-Id-List', _ResetArg_reset_Id_List),
        ('subscriptionData', _ResetArg_subscriptionData),
        ('subscriptionDataDeletion', _ResetArg_subscriptionDataDeletion),
        ])
    ResetArg._ext = ['reset-Id-List', 'subscriptionData', 'subscriptionDataDeletion']
    
    #-----< SendingNode-Number >-----#
    SendingNode_Number = CHOICE(name='SendingNode-Number', mode=MODE_TYPE)
    _SendingNode_Number_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendingNode_Number_css_Number = OCT_STR(name='css-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SendingNode_Number._cont = ASN1Dict([
        ('hlr-Number', _SendingNode_Number_hlr_Number),
        ('css-Number', _SendingNode_Number_css_Number),
        ])
    SendingNode_Number._ext = None
    
    #-----< RestoreDataArg >-----#
    RestoreDataArg = SEQ(name='RestoreDataArg', mode=MODE_TYPE)
    _RestoreDataArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RestoreDataArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _RestoreDataArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RestoreDataArg_vlr_Capability = SEQ(name='vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _RestoreDataArg_restorationIndicator = NULL(name='restorationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RestoreDataArg._cont = ASN1Dict([
        ('imsi', _RestoreDataArg_imsi),
        ('lmsi', _RestoreDataArg_lmsi),
        ('extensionContainer', _RestoreDataArg_extensionContainer),
        ('vlr-Capability', _RestoreDataArg_vlr_Capability),
        ('restorationIndicator', _RestoreDataArg_restorationIndicator),
        ])
    RestoreDataArg._ext = ['vlr-Capability', 'restorationIndicator']
    
    #-----< RestoreDataRes >-----#
    RestoreDataRes = SEQ(name='RestoreDataRes', mode=MODE_TYPE)
    _RestoreDataRes_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RestoreDataRes_msNotReachable = NULL(name='msNotReachable', mode=MODE_TYPE, opt=True)
    _RestoreDataRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RestoreDataRes._cont = ASN1Dict([
        ('hlr-Number', _RestoreDataRes_hlr_Number),
        ('msNotReachable', _RestoreDataRes_msNotReachable),
        ('extensionContainer', _RestoreDataRes_extensionContainer),
        ])
    RestoreDataRes._ext = []
    
    #-----< VBSDataList >-----#
    VBSDataList = SEQ_OF(name='VBSDataList', mode=MODE_TYPE)
    _VBSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceBroadcastData')))
    VBSDataList._cont = _VBSDataList__item_
    VBSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< VGCSDataList >-----#
    VGCSDataList = SEQ_OF(name='VGCSDataList', mode=MODE_TYPE)
    _VGCSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceGroupCallData')))
    VGCSDataList._cont = _VGCSDataList__item_
    VGCSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfVBSGroupIds >-----#
    maxNumOfVBSGroupIds = INT(name='maxNumOfVBSGroupIds', mode=MODE_VALUE)
    maxNumOfVBSGroupIds._val = 50
    
    #-----< maxNumOfVGCSGroupIds >-----#
    maxNumOfVGCSGroupIds = INT(name='maxNumOfVGCSGroupIds', mode=MODE_VALUE)
    maxNumOfVGCSGroupIds._val = 50
    
    #-----< VoiceGroupCallData >-----#
    VoiceGroupCallData = SEQ(name='VoiceGroupCallData', mode=MODE_TYPE)
    _VoiceGroupCallData_groupId = OCT_STR(name='groupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceGroupCallData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceGroupCallData_additionalSubscriptions = BIT_STR(name='additionalSubscriptions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalSubscriptions')), opt=True)
    _VoiceGroupCallData_additionalInfo = BIT_STR(name='additionalInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalInfo')), opt=True)
    _VoiceGroupCallData_longGroupId = OCT_STR(name='longGroupId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceGroupCallData._cont = ASN1Dict([
        ('groupId', _VoiceGroupCallData_groupId),
        ('extensionContainer', _VoiceGroupCallData_extensionContainer),
        ('additionalSubscriptions', _VoiceGroupCallData_additionalSubscriptions),
        ('additionalInfo', _VoiceGroupCallData_additionalInfo),
        ('longGroupId', _VoiceGroupCallData_longGroupId),
        ])
    VoiceGroupCallData._ext = ['additionalSubscriptions', 'additionalInfo', 'longGroupId']
    
    #-----< AdditionalInfo >-----#
    AdditionalInfo = BIT_STR(name='AdditionalInfo', mode=MODE_TYPE)
    AdditionalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=136)], ev=None, er=[])
    
    #-----< AdditionalSubscriptions >-----#
    AdditionalSubscriptions = BIT_STR(name='AdditionalSubscriptions', mode=MODE_TYPE)
    AdditionalSubscriptions._cont = ASN1Dict([('privilegedUplinkRequest', 0), ('emergencyUplinkRequest', 1), ('emergencyReset', 2)])
    AdditionalSubscriptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< VoiceBroadcastData >-----#
    VoiceBroadcastData = SEQ(name='VoiceBroadcastData', mode=MODE_TYPE)
    _VoiceBroadcastData_groupid = OCT_STR(name='groupid', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceBroadcastData_broadcastInitEntitlement = NULL(name='broadcastInitEntitlement', mode=MODE_TYPE, opt=True)
    _VoiceBroadcastData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceBroadcastData_longGroupId = OCT_STR(name='longGroupId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceBroadcastData._cont = ASN1Dict([
        ('groupid', _VoiceBroadcastData_groupid),
        ('broadcastInitEntitlement', _VoiceBroadcastData_broadcastInitEntitlement),
        ('extensionContainer', _VoiceBroadcastData_extensionContainer),
        ('longGroupId', _VoiceBroadcastData_longGroupId),
        ])
    VoiceBroadcastData._ext = ['longGroupId']
    
    #-----< GroupId >-----#
    GroupId = OCT_STR(name='GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    GroupId._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Long-GroupId >-----#
    Long_GroupId = OCT_STR(name='Long-GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    Long_GroupId._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ProvideSubscriberInfoArg >-----#
    ProvideSubscriberInfoArg = SEQ(name='ProvideSubscriberInfoArg', mode=MODE_TYPE)
    _ProvideSubscriberInfoArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideSubscriberInfoArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideSubscriberInfoArg_requestedInfo = SEQ(name='requestedInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _ProvideSubscriberInfoArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberInfoArg_callPriority = INT(name='callPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    ProvideSubscriberInfoArg._cont = ASN1Dict([
        ('imsi', _ProvideSubscriberInfoArg_imsi),
        ('lmsi', _ProvideSubscriberInfoArg_lmsi),
        ('requestedInfo', _ProvideSubscriberInfoArg_requestedInfo),
        ('extensionContainer', _ProvideSubscriberInfoArg_extensionContainer),
        ('callPriority', _ProvideSubscriberInfoArg_callPriority),
        ])
    ProvideSubscriberInfoArg._ext = ['callPriority']
    
    #-----< ProvideSubscriberInfoRes >-----#
    ProvideSubscriberInfoRes = SEQ(name='ProvideSubscriberInfoRes', mode=MODE_TYPE)
    _ProvideSubscriberInfoRes_subscriberInfo = SEQ(name='subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _ProvideSubscriberInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ProvideSubscriberInfoRes._cont = ASN1Dict([
        ('subscriberInfo', _ProvideSubscriberInfoRes_subscriberInfo),
        ('extensionContainer', _ProvideSubscriberInfoRes_extensionContainer),
        ])
    ProvideSubscriberInfoRes._ext = []
    
    #-----< SubscriberInfo >-----#
    SubscriberInfo = SEQ(name='SubscriberInfo', mode=MODE_TYPE)
    _SubscriberInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _SubscriberInfo_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _SubscriberInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubscriberInfo_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _SubscriberInfo_ps_SubscriberState = CHOICE(name='ps-SubscriberState', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_imei = OCT_STR(name='imei', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SubscriberInfo_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _SubscriberInfo_gprs_MS_Class = SEQ(name='gprs-MS-Class', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _SubscriberInfo_mnpInfoRes = SEQ(name='mnpInfoRes', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MNPInfoRes')), opt=True)
    _SubscriberInfo_imsVoiceOverPS_SessionsIndication = ENUM(name='imsVoiceOverPS-SessionsIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMS-VoiceOverPS-SessionsInd')), opt=True)
    _SubscriberInfo_lastUE_ActivityTime = OCT_STR(name='lastUE-ActivityTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _SubscriberInfo_lastRAT_Type = ENUM(name='lastRAT-Type', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _SubscriberInfo_eps_SubscriberState = CHOICE(name='eps-SubscriberState', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_locationInformationEPS = SEQ(name='locationInformationEPS', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _SubscriberInfo_timeZone = OCT_STR(name='timeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _SubscriberInfo_daylightSavingTime = ENUM(name='daylightSavingTime', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DaylightSavingTime')), opt=True)
    _SubscriberInfo_locationInformation5GS = SEQ(name='locationInformation5GS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation5GS')), opt=True)
    SubscriberInfo._cont = ASN1Dict([
        ('locationInformation', _SubscriberInfo_locationInformation),
        ('subscriberState', _SubscriberInfo_subscriberState),
        ('extensionContainer', _SubscriberInfo_extensionContainer),
        ('locationInformationGPRS', _SubscriberInfo_locationInformationGPRS),
        ('ps-SubscriberState', _SubscriberInfo_ps_SubscriberState),
        ('imei', _SubscriberInfo_imei),
        ('ms-Classmark2', _SubscriberInfo_ms_Classmark2),
        ('gprs-MS-Class', _SubscriberInfo_gprs_MS_Class),
        ('mnpInfoRes', _SubscriberInfo_mnpInfoRes),
        ('imsVoiceOverPS-SessionsIndication', _SubscriberInfo_imsVoiceOverPS_SessionsIndication),
        ('lastUE-ActivityTime', _SubscriberInfo_lastUE_ActivityTime),
        ('lastRAT-Type', _SubscriberInfo_lastRAT_Type),
        ('eps-SubscriberState', _SubscriberInfo_eps_SubscriberState),
        ('locationInformationEPS', _SubscriberInfo_locationInformationEPS),
        ('timeZone', _SubscriberInfo_timeZone),
        ('daylightSavingTime', _SubscriberInfo_daylightSavingTime),
        ('locationInformation5GS', _SubscriberInfo_locationInformation5GS),
        ])
    SubscriberInfo._ext = ['locationInformationGPRS', 'ps-SubscriberState', 'imei', 'ms-Classmark2', 'gprs-MS-Class', 'mnpInfoRes', 'imsVoiceOverPS-SessionsIndication', 'lastUE-ActivityTime', 'lastRAT-Type', 'eps-SubscriberState', 'locationInformationEPS', 'timeZone', 'daylightSavingTime', 'locationInformation5GS']
    
    #-----< IMS-VoiceOverPS-SessionsInd >-----#
    IMS_VoiceOverPS_SessionsInd = ENUM(name='IMS-VoiceOverPS-SessionsInd', mode=MODE_TYPE)
    IMS_VoiceOverPS_SessionsInd._cont = ASN1Dict([('imsVoiceOverPS-SessionsNotSupported', 0), ('imsVoiceOverPS-SessionsSupported', 1), ('unknown', 2)])
    IMS_VoiceOverPS_SessionsInd._ext = None
    
    #-----< TimeZone >-----#
    TimeZone = OCT_STR(name='TimeZone', mode=MODE_TYPE)
    TimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< DaylightSavingTime >-----#
    DaylightSavingTime = ENUM(name='DaylightSavingTime', mode=MODE_TYPE)
    DaylightSavingTime._cont = ASN1Dict([('noAdjustment', 0), ('plusOneHourAdjustment', 1), ('plusTwoHoursAdjustment', 2)])
    DaylightSavingTime._ext = None
    
    #-----< MNPInfoRes >-----#
    MNPInfoRes = SEQ(name='MNPInfoRes', mode=MODE_TYPE)
    _MNPInfoRes_routeingNumber = OCT_STR(name='routeingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RouteingNumber')), opt=True)
    _MNPInfoRes_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MNPInfoRes_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MNPInfoRes_numberPortabilityStatus = ENUM(name='numberPortabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _MNPInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MNPInfoRes._cont = ASN1Dict([
        ('routeingNumber', _MNPInfoRes_routeingNumber),
        ('imsi', _MNPInfoRes_imsi),
        ('msisdn', _MNPInfoRes_msisdn),
        ('numberPortabilityStatus', _MNPInfoRes_numberPortabilityStatus),
        ('extensionContainer', _MNPInfoRes_extensionContainer),
        ])
    MNPInfoRes._ext = []
    
    #-----< RouteingNumber >-----#
    RouteingNumber = OCT_STR(name='RouteingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    RouteingNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NumberPortabilityStatus >-----#
    NumberPortabilityStatus = ENUM(name='NumberPortabilityStatus', mode=MODE_TYPE)
    NumberPortabilityStatus._cont = ASN1Dict([('notKnownToBePorted', 0), ('ownNumberPortedOut', 1), ('foreignNumberPortedToForeignNetwork', 2), ('ownNumberNotPortedOut', 4), ('foreignNumberPortedIn', 5)])
    NumberPortabilityStatus._ext = ['ownNumberNotPortedOut', 'foreignNumberPortedIn']
    
    #-----< MS-Classmark2 >-----#
    MS_Classmark2 = OCT_STR(name='MS-Classmark2', mode=MODE_TYPE)
    MS_Classmark2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< GPRSMSClass >-----#
    GPRSMSClass = SEQ(name='GPRSMSClass', mode=MODE_TYPE)
    _GPRSMSClass_mSNetworkCapability = OCT_STR(name='mSNetworkCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSNetworkCapability')))
    _GPRSMSClass_mSRadioAccessCapability = OCT_STR(name='mSRadioAccessCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSRadioAccessCapability')), opt=True)
    GPRSMSClass._cont = ASN1Dict([
        ('mSNetworkCapability', _GPRSMSClass_mSNetworkCapability),
        ('mSRadioAccessCapability', _GPRSMSClass_mSRadioAccessCapability),
        ])
    GPRSMSClass._ext = None
    
    #-----< MSNetworkCapability >-----#
    MSNetworkCapability = OCT_STR(name='MSNetworkCapability', mode=MODE_TYPE)
    MSNetworkCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MSRadioAccessCapability >-----#
    MSRadioAccessCapability = OCT_STR(name='MSRadioAccessCapability', mode=MODE_TYPE)
    MSRadioAccessCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< RequestedInfo >-----#
    RequestedInfo = SEQ(name='RequestedInfo', mode=MODE_TYPE)
    _RequestedInfo_locationInformation = NULL(name='locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_subscriberState = NULL(name='subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedInfo_currentLocation = NULL(name='currentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedDomain = ENUM(name='requestedDomain', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DomainType')), opt=True)
    _RequestedInfo_imei = NULL(name='imei', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_ms_classmark = NULL(name='ms-classmark', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_mnpRequestedInfo = NULL(name='mnpRequestedInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_locationInformationEPS_Supported = NULL(name='locationInformationEPS-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_t_adsData = NULL(name='t-adsData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedNodes = BIT_STR(name='requestedNodes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedNodes')), opt=True)
    _RequestedInfo_servingNodeIndication = NULL(name='servingNodeIndication', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_localTimeZoneRequest = NULL(name='localTimeZoneRequest', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedInfo._cont = ASN1Dict([
        ('locationInformation', _RequestedInfo_locationInformation),
        ('subscriberState', _RequestedInfo_subscriberState),
        ('extensionContainer', _RequestedInfo_extensionContainer),
        ('currentLocation', _RequestedInfo_currentLocation),
        ('requestedDomain', _RequestedInfo_requestedDomain),
        ('imei', _RequestedInfo_imei),
        ('ms-classmark', _RequestedInfo_ms_classmark),
        ('mnpRequestedInfo', _RequestedInfo_mnpRequestedInfo),
        ('locationInformationEPS-Supported', _RequestedInfo_locationInformationEPS_Supported),
        ('t-adsData', _RequestedInfo_t_adsData),
        ('requestedNodes', _RequestedInfo_requestedNodes),
        ('servingNodeIndication', _RequestedInfo_servingNodeIndication),
        ('localTimeZoneRequest', _RequestedInfo_localTimeZoneRequest),
        ])
    RequestedInfo._ext = ['currentLocation', 'requestedDomain', 'imei', 'ms-classmark', 'mnpRequestedInfo', 'locationInformationEPS-Supported', 't-adsData', 'requestedNodes', 'servingNodeIndication', 'localTimeZoneRequest']
    
    #-----< DomainType >-----#
    DomainType = ENUM(name='DomainType', mode=MODE_TYPE)
    DomainType._cont = ASN1Dict([('cs-Domain', 0), ('ps-Domain', 1)])
    DomainType._ext = []
    
    #-----< RequestedNodes >-----#
    RequestedNodes = BIT_STR(name='RequestedNodes', mode=MODE_TYPE)
    RequestedNodes._cont = ASN1Dict([('mme', 0), ('sgsn', 1)])
    RequestedNodes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationInformation >-----#
    LocationInformation = SEQ(name='LocationInformation', mode=MODE_TYPE)
    _LocationInformation_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation_vlr_number = OCT_STR(name='vlr-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationNumber')), opt=True)
    _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name='cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformation_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation_selectedLSA_Id = OCT_STR(name='selectedLSA-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformation_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_locationInformationEPS = SEQ(name='locationInformationEPS', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _LocationInformation_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformation._cont = ASN1Dict([
        ('ageOfLocationInformation', _LocationInformation_ageOfLocationInformation),
        ('geographicalInformation', _LocationInformation_geographicalInformation),
        ('vlr-number', _LocationInformation_vlr_number),
        ('locationNumber', _LocationInformation_locationNumber),
        ('cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI),
        ('extensionContainer', _LocationInformation_extensionContainer),
        ('selectedLSA-Id', _LocationInformation_selectedLSA_Id),
        ('msc-Number', _LocationInformation_msc_Number),
        ('geodeticInformation', _LocationInformation_geodeticInformation),
        ('currentLocationRetrieved', _LocationInformation_currentLocationRetrieved),
        ('sai-Present', _LocationInformation_sai_Present),
        ('locationInformationEPS', _LocationInformation_locationInformationEPS),
        ('userCSGInformation', _LocationInformation_userCSGInformation),
        ])
    LocationInformation._ext = ['selectedLSA-Id', 'msc-Number', 'geodeticInformation', 'currentLocationRetrieved', 'sai-Present', 'locationInformationEPS', 'userCSGInformation']
    
    #-----< LocationInformationEPS >-----#
    LocationInformationEPS = SEQ(name='LocationInformationEPS', mode=MODE_TYPE)
    _LocationInformationEPS_e_utranCellGlobalIdentity = OCT_STR(name='e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformationEPS_trackingAreaIdentity = OCT_STR(name='trackingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformationEPS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationEPS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationEPS_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationEPS_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationEPS_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationEPS_mme_Name = OCT_STR(name='mme-Name', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    LocationInformationEPS._cont = ASN1Dict([
        ('e-utranCellGlobalIdentity', _LocationInformationEPS_e_utranCellGlobalIdentity),
        ('trackingAreaIdentity', _LocationInformationEPS_trackingAreaIdentity),
        ('extensionContainer', _LocationInformationEPS_extensionContainer),
        ('geographicalInformation', _LocationInformationEPS_geographicalInformation),
        ('geodeticInformation', _LocationInformationEPS_geodeticInformation),
        ('currentLocationRetrieved', _LocationInformationEPS_currentLocationRetrieved),
        ('ageOfLocationInformation', _LocationInformationEPS_ageOfLocationInformation),
        ('mme-Name', _LocationInformationEPS_mme_Name),
        ])
    LocationInformationEPS._ext = ['mme-Name']
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name='LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name='cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name='selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationGPRS_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        ('cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        ('routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        ('geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        ('sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        ('selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        ('extensionContainer', _LocationInformationGPRS_extensionContainer),
        ('sai-Present', _LocationInformationGPRS_sai_Present),
        ('geodeticInformation', _LocationInformationGPRS_geodeticInformation),
        ('currentLocationRetrieved', _LocationInformationGPRS_currentLocationRetrieved),
        ('ageOfLocationInformation', _LocationInformationGPRS_ageOfLocationInformation),
        ('userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = ['sai-Present', 'geodeticInformation', 'currentLocationRetrieved', 'ageOfLocationInformation', 'userCSGInformation']
    
    #-----< LocationInformation5GS >-----#
    LocationInformation5GS = SEQ(name='LocationInformation5GS', mode=MODE_TYPE)
    _LocationInformation5GS_nrCellGlobalIdentity = OCT_STR(name='nrCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-CGI')), opt=True)
    _LocationInformation5GS_e_utranCellGlobalIdentity = OCT_STR(name='e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformation5GS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation5GS_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation5GS_amf_address = OCT_STR(name='amf-address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _LocationInformation5GS_trackingAreaIdentity = OCT_STR(name='trackingAreaIdentity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformation5GS_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation5GS_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation5GS_vplmnId = OCT_STR(name='vplmnId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _LocationInformation5GS_localtimeZone = OCT_STR(name='localtimeZone', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _LocationInformation5GS_rat_Type = ENUM(name='rat-Type', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _LocationInformation5GS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation5GS_nrTrackingAreaIdentity = OCT_STR(name='nrTrackingAreaIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-TA-Id')), opt=True)
    LocationInformation5GS._cont = ASN1Dict([
        ('nrCellGlobalIdentity', _LocationInformation5GS_nrCellGlobalIdentity),
        ('e-utranCellGlobalIdentity', _LocationInformation5GS_e_utranCellGlobalIdentity),
        ('geographicalInformation', _LocationInformation5GS_geographicalInformation),
        ('geodeticInformation', _LocationInformation5GS_geodeticInformation),
        ('amf-address', _LocationInformation5GS_amf_address),
        ('trackingAreaIdentity', _LocationInformation5GS_trackingAreaIdentity),
        ('currentLocationRetrieved', _LocationInformation5GS_currentLocationRetrieved),
        ('ageOfLocationInformation', _LocationInformation5GS_ageOfLocationInformation),
        ('vplmnId', _LocationInformation5GS_vplmnId),
        ('localtimeZone', _LocationInformation5GS_localtimeZone),
        ('rat-Type', _LocationInformation5GS_rat_Type),
        ('extensionContainer', _LocationInformation5GS_extensionContainer),
        ('nrTrackingAreaIdentity', _LocationInformation5GS_nrTrackingAreaIdentity),
        ])
    LocationInformation5GS._ext = ['nrTrackingAreaIdentity']
    
    #-----< UserCSGInformation >-----#
    UserCSGInformation = SEQ(name='UserCSGInformation', mode=MODE_TYPE)
    _UserCSGInformation_csg_Id = BIT_STR(name='csg-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _UserCSGInformation_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UserCSGInformation_accessMode = OCT_STR(name='accessMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_accessMode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _UserCSGInformation_cmi = OCT_STR(name='cmi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_cmi._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    UserCSGInformation._cont = ASN1Dict([
        ('csg-Id', _UserCSGInformation_csg_Id),
        ('extensionContainer', _UserCSGInformation_extensionContainer),
        ('accessMode', _UserCSGInformation_accessMode),
        ('cmi', _UserCSGInformation_cmi),
        ])
    UserCSGInformation._ext = ['accessMode', 'cmi']
    
    #-----< GeographicalInformation >-----#
    GeographicalInformation = OCT_STR(name='GeographicalInformation', mode=MODE_TYPE)
    GeographicalInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GeodeticInformation >-----#
    GeodeticInformation = OCT_STR(name='GeodeticInformation', mode=MODE_TYPE)
    GeodeticInformation._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name='LocationNumber', mode=MODE_TYPE)
    LocationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< SubscriberState >-----#
    SubscriberState = CHOICE(name='SubscriberState', mode=MODE_TYPE)
    _SubscriberState_assumedIdle = NULL(name='assumedIdle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_camelBusy = NULL(name='camelBusy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_netDetNotReachable = ENUM(name='netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    _SubscriberState_notProvidedFromVLR = NULL(name='notProvidedFromVLR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriberState._cont = ASN1Dict([
        ('assumedIdle', _SubscriberState_assumedIdle),
        ('camelBusy', _SubscriberState_camelBusy),
        ('netDetNotReachable', _SubscriberState_netDetNotReachable),
        ('notProvidedFromVLR', _SubscriberState_notProvidedFromVLR),
        ])
    SubscriberState._ext = None
    
    #-----< PS-SubscriberState >-----#
    PS_SubscriberState = CHOICE(name='PS-SubscriberState', mode=MODE_TYPE)
    _PS_SubscriberState_notProvidedFromSGSNorMME = NULL(name='notProvidedFromSGSNorMME', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_Detached = NULL(name='ps-Detached', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedNotReachableForPaging = NULL(name='ps-AttachedNotReachableForPaging', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedReachableForPaging = NULL(name='ps-AttachedReachableForPaging', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging = SEQ_OF(name='ps-PDP-ActiveNotReachableForPaging', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_ps_PDP_ActiveReachableForPaging = SEQ_OF(name='ps-PDP-ActiveReachableForPaging', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_netDetNotReachable = ENUM(name='netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    PS_SubscriberState._cont = ASN1Dict([
        ('notProvidedFromSGSNorMME', _PS_SubscriberState_notProvidedFromSGSNorMME),
        ('ps-Detached', _PS_SubscriberState_ps_Detached),
        ('ps-AttachedNotReachableForPaging', _PS_SubscriberState_ps_AttachedNotReachableForPaging),
        ('ps-AttachedReachableForPaging', _PS_SubscriberState_ps_AttachedReachableForPaging),
        ('ps-PDP-ActiveNotReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging),
        ('ps-PDP-ActiveReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveReachableForPaging),
        ('netDetNotReachable', _PS_SubscriberState_netDetNotReachable),
        ])
    PS_SubscriberState._ext = None
    
    #-----< PDP-ContextInfoList >-----#
    PDP_ContextInfoList = SEQ_OF(name='PDP-ContextInfoList', mode=MODE_TYPE)
    _PDP_ContextInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfo')))
    PDP_ContextInfoList._cont = _PDP_ContextInfoList__item_
    PDP_ContextInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< PDP-ContextInfo >-----#
    PDP_ContextInfo = SEQ(name='PDP-ContextInfo', mode=MODE_TYPE)
    _PDP_ContextInfo_pdp_ContextIdentifier = INT(name='pdp-ContextIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_ContextInfo_pdp_ContextActive = NULL(name='pdp-ContextActive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_ContextInfo_pdp_Type = OCT_STR(name='pdp-Type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_ContextInfo_pdp_Address = OCT_STR(name='pdp-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_ContextInfo_apn_Subscribed = OCT_STR(name='apn-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_apn_InUse = OCT_STR(name='apn-InUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_nsapi = INT(name='nsapi', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NSAPI')), opt=True)
    _PDP_ContextInfo_transactionId = OCT_STR(name='transactionId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TransactionId')), opt=True)
    _PDP_ContextInfo_teid_ForGnAndGp = OCT_STR(name='teid-ForGnAndGp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_teid_ForIu = OCT_STR(name='teid-ForIu', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_qos_Subscribed = OCT_STR(name='qos-Subscribed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Requested = OCT_STR(name='qos-Requested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Negotiated = OCT_STR(name='qos-Negotiated', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_chargingId = OCT_STR(name='chargingId', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _PDP_ContextInfo_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_ContextInfo_rnc_Address = OCT_STR(name='rnc-Address', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_ContextInfo_qos2_Subscribed = OCT_STR(name='qos2-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Requested = OCT_STR(name='qos2-Requested', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Negotiated = OCT_STR(name='qos2-Negotiated', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Subscribed = OCT_STR(name='qos3-Subscribed', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Requested = OCT_STR(name='qos3-Requested', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Negotiated = OCT_STR(name='qos3-Negotiated', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Subscribed = OCT_STR(name='qos4-Subscribed', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Requested = OCT_STR(name='qos4-Requested', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Negotiated = OCT_STR(name='qos4-Negotiated', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_ext_pdp_Type = OCT_STR(name='ext-pdp-Type', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_ContextInfo_ext_pdp_Address = OCT_STR(name='ext-pdp-Address', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    PDP_ContextInfo._cont = ASN1Dict([
        ('pdp-ContextIdentifier', _PDP_ContextInfo_pdp_ContextIdentifier),
        ('pdp-ContextActive', _PDP_ContextInfo_pdp_ContextActive),
        ('pdp-Type', _PDP_ContextInfo_pdp_Type),
        ('pdp-Address', _PDP_ContextInfo_pdp_Address),
        ('apn-Subscribed', _PDP_ContextInfo_apn_Subscribed),
        ('apn-InUse', _PDP_ContextInfo_apn_InUse),
        ('nsapi', _PDP_ContextInfo_nsapi),
        ('transactionId', _PDP_ContextInfo_transactionId),
        ('teid-ForGnAndGp', _PDP_ContextInfo_teid_ForGnAndGp),
        ('teid-ForIu', _PDP_ContextInfo_teid_ForIu),
        ('ggsn-Address', _PDP_ContextInfo_ggsn_Address),
        ('qos-Subscribed', _PDP_ContextInfo_qos_Subscribed),
        ('qos-Requested', _PDP_ContextInfo_qos_Requested),
        ('qos-Negotiated', _PDP_ContextInfo_qos_Negotiated),
        ('chargingId', _PDP_ContextInfo_chargingId),
        ('chargingCharacteristics', _PDP_ContextInfo_chargingCharacteristics),
        ('rnc-Address', _PDP_ContextInfo_rnc_Address),
        ('extensionContainer', _PDP_ContextInfo_extensionContainer),
        ('qos2-Subscribed', _PDP_ContextInfo_qos2_Subscribed),
        ('qos2-Requested', _PDP_ContextInfo_qos2_Requested),
        ('qos2-Negotiated', _PDP_ContextInfo_qos2_Negotiated),
        ('qos3-Subscribed', _PDP_ContextInfo_qos3_Subscribed),
        ('qos3-Requested', _PDP_ContextInfo_qos3_Requested),
        ('qos3-Negotiated', _PDP_ContextInfo_qos3_Negotiated),
        ('qos4-Subscribed', _PDP_ContextInfo_qos4_Subscribed),
        ('qos4-Requested', _PDP_ContextInfo_qos4_Requested),
        ('qos4-Negotiated', _PDP_ContextInfo_qos4_Negotiated),
        ('ext-pdp-Type', _PDP_ContextInfo_ext_pdp_Type),
        ('ext-pdp-Address', _PDP_ContextInfo_ext_pdp_Address),
        ])
    PDP_ContextInfo._ext = ['qos2-Subscribed', 'qos2-Requested', 'qos2-Negotiated', 'qos3-Subscribed', 'qos3-Requested', 'qos3-Negotiated', 'qos4-Subscribed', 'qos4-Requested', 'qos4-Negotiated', 'ext-pdp-Type', 'ext-pdp-Address']
    
    #-----< NSAPI >-----#
    NSAPI = INT(name='NSAPI', mode=MODE_TYPE)
    NSAPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< TransactionId >-----#
    TransactionId = OCT_STR(name='TransactionId', mode=MODE_TYPE)
    TransactionId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TEID >-----#
    TEID = OCT_STR(name='TEID', mode=MODE_TYPE)
    TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GPRSChargingID >-----#
    GPRSChargingID = OCT_STR(name='GPRSChargingID', mode=MODE_TYPE)
    GPRSChargingID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< NotReachableReason >-----#
    NotReachableReason = ENUM(name='NotReachableReason', mode=MODE_TYPE)
    NotReachableReason._cont = ASN1Dict([('msPurged', 0), ('imsiDetached', 1), ('restrictedArea', 2), ('notRegistered', 3)])
    NotReachableReason._ext = None
    
    #-----< AnyTimeInterrogationArg >-----#
    AnyTimeInterrogationArg = SEQ(name='AnyTimeInterrogationArg', mode=MODE_TYPE)
    _AnyTimeInterrogationArg_subscriberIdentity = CHOICE(name='subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeInterrogationArg_requestedInfo = SEQ(name='requestedInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _AnyTimeInterrogationArg_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeInterrogationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationArg._cont = ASN1Dict([
        ('subscriberIdentity', _AnyTimeInterrogationArg_subscriberIdentity),
        ('requestedInfo', _AnyTimeInterrogationArg_requestedInfo),
        ('gsmSCF-Address', _AnyTimeInterrogationArg_gsmSCF_Address),
        ('extensionContainer', _AnyTimeInterrogationArg_extensionContainer),
        ])
    AnyTimeInterrogationArg._ext = []
    
    #-----< AnyTimeInterrogationRes >-----#
    AnyTimeInterrogationRes = SEQ(name='AnyTimeInterrogationRes', mode=MODE_TYPE)
    _AnyTimeInterrogationRes_subscriberInfo = SEQ(name='subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _AnyTimeInterrogationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationRes._cont = ASN1Dict([
        ('subscriberInfo', _AnyTimeInterrogationRes_subscriberInfo),
        ('extensionContainer', _AnyTimeInterrogationRes_extensionContainer),
        ])
    AnyTimeInterrogationRes._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationArg >-----#
    AnyTimeSubscriptionInterrogationArg = SEQ(name='AnyTimeSubscriptionInterrogationArg', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationArg_subscriberIdentity = CHOICE(name='subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo = SEQ(name='requestedSubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedSubscriptionInfo')))
    _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeSubscriptionInterrogationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AnyTimeSubscriptionInterrogationArg._cont = ASN1Dict([
        ('subscriberIdentity', _AnyTimeSubscriptionInterrogationArg_subscriberIdentity),
        ('requestedSubscriptionInfo', _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo),
        ('gsmSCF-Address', _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address),
        ('extensionContainer', _AnyTimeSubscriptionInterrogationArg_extensionContainer),
        ('longFTN-Supported', _AnyTimeSubscriptionInterrogationArg_longFTN_Supported),
        ])
    AnyTimeSubscriptionInterrogationArg._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationRes >-----#
    AnyTimeSubscriptionInterrogationRes = SEQ(name='AnyTimeSubscriptionInterrogationRes', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationRes_callForwardingData = SEQ(name='callForwardingData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallForwardingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_callBarringData = SEQ(name='callBarringData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallBarringData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_odb_Info = SEQ(name='odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo = SEQ(name='camel-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases = BIT_STR(name='supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases = BIT_STR(name='supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR = BIT_STR(name='offeredCamel4CSIsInVLR', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN = BIT_STR(name='offeredCamel4CSIsInSGSN', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List = SEQ_OF(name='msisdn-BS-List', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS-List')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_cw_Data = SEQ(name='cw-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ch_Data = SEQ(name='ch-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clip_Data = SEQ(name='clip-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clir_Data = SEQ(name='clir-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ect_data = SEQ(name='ect-data', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    AnyTimeSubscriptionInterrogationRes._cont = ASN1Dict([
        ('callForwardingData', _AnyTimeSubscriptionInterrogationRes_callForwardingData),
        ('callBarringData', _AnyTimeSubscriptionInterrogationRes_callBarringData),
        ('odb-Info', _AnyTimeSubscriptionInterrogationRes_odb_Info),
        ('camel-SubscriptionInfo', _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo),
        ('supportedVLR-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases),
        ('supportedSGSN-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases),
        ('extensionContainer', _AnyTimeSubscriptionInterrogationRes_extensionContainer),
        ('offeredCamel4CSIsInVLR', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR),
        ('offeredCamel4CSIsInSGSN', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN),
        ('msisdn-BS-List', _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List),
        ('csg-SubscriptionDataList', _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList),
        ('cw-Data', _AnyTimeSubscriptionInterrogationRes_cw_Data),
        ('ch-Data', _AnyTimeSubscriptionInterrogationRes_ch_Data),
        ('clip-Data', _AnyTimeSubscriptionInterrogationRes_clip_Data),
        ('clir-Data', _AnyTimeSubscriptionInterrogationRes_clir_Data),
        ('ect-data', _AnyTimeSubscriptionInterrogationRes_ect_data),
        ])
    AnyTimeSubscriptionInterrogationRes._ext = ['offeredCamel4CSIsInVLR', 'offeredCamel4CSIsInSGSN', 'msisdn-BS-List', 'csg-SubscriptionDataList', 'cw-Data', 'ch-Data', 'clip-Data', 'clir-Data', 'ect-data']
    
    #-----< CallWaitingData >-----#
    CallWaitingData = SEQ(name='CallWaitingData', mode=MODE_TYPE)
    _CallWaitingData_cwFeatureList = SEQ_OF(name='cwFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeatureList')))
    _CallWaitingData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallWaitingData._cont = ASN1Dict([
        ('cwFeatureList', _CallWaitingData_cwFeatureList),
        ('notificationToCSE', _CallWaitingData_notificationToCSE),
        ])
    CallWaitingData._ext = []
    
    #-----< Ext-CwFeatureList >-----#
    Ext_CwFeatureList = SEQ_OF(name='Ext-CwFeatureList', mode=MODE_TYPE)
    _Ext_CwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeature')))
    Ext_CwFeatureList._cont = _Ext_CwFeatureList__item_
    Ext_CwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CwFeature >-----#
    Ext_CwFeature = SEQ(name='Ext-CwFeature', mode=MODE_TYPE)
    _Ext_CwFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    _Ext_CwFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    Ext_CwFeature._cont = ASN1Dict([
        ('basicService', _Ext_CwFeature_basicService),
        ('ss-Status', _Ext_CwFeature_ss_Status),
        ])
    Ext_CwFeature._ext = []
    
    #-----< ClipData >-----#
    ClipData = SEQ(name='ClipData', mode=MODE_TYPE)
    _ClipData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClipData_overrideCategory = ENUM(name='overrideCategory', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    _ClipData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClipData._cont = ASN1Dict([
        ('ss-Status', _ClipData_ss_Status),
        ('overrideCategory', _ClipData_overrideCategory),
        ('notificationToCSE', _ClipData_notificationToCSE),
        ])
    ClipData._ext = []
    
    #-----< ClirData >-----#
    ClirData = SEQ(name='ClirData', mode=MODE_TYPE)
    _ClirData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClirData_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ClirData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClirData._cont = ASN1Dict([
        ('ss-Status', _ClirData_ss_Status),
        ('cliRestrictionOption', _ClirData_cliRestrictionOption),
        ('notificationToCSE', _ClirData_notificationToCSE),
        ])
    ClirData._ext = []
    
    #-----< CallHoldData >-----#
    CallHoldData = SEQ(name='CallHoldData', mode=MODE_TYPE)
    _CallHoldData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _CallHoldData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallHoldData._cont = ASN1Dict([
        ('ss-Status', _CallHoldData_ss_Status),
        ('notificationToCSE', _CallHoldData_notificationToCSE),
        ])
    CallHoldData._ext = []
    
    #-----< EctData >-----#
    EctData = SEQ(name='EctData', mode=MODE_TYPE)
    _EctData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _EctData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EctData._cont = ASN1Dict([
        ('ss-Status', _EctData_ss_Status),
        ('notificationToCSE', _EctData_notificationToCSE),
        ])
    EctData._ext = []
    
    #-----< RequestedSubscriptionInfo >-----#
    RequestedSubscriptionInfo = SEQ(name='RequestedSubscriptionInfo', mode=MODE_TYPE)
    _RequestedSubscriptionInfo_requestedSS_Info = SEQ(name='requestedSS-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-ForBS-Code')), opt=True)
    _RequestedSubscriptionInfo_odb = NULL(name='odb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo = ENUM(name='requestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases = NULL(name='supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases = NULL(name='supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name='additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_msisdn_BS_List = NULL(name='msisdn-BS-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_csg_SubscriptionDataRequested = NULL(name='csg-SubscriptionDataRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_cw_Info = NULL(name='cw-Info', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clip_Info = NULL(name='clip-Info', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clir_Info = NULL(name='clir-Info', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_hold_Info = NULL(name='hold-Info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_ect_Info = NULL(name='ect-Info', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedSubscriptionInfo._cont = ASN1Dict([
        ('requestedSS-Info', _RequestedSubscriptionInfo_requestedSS_Info),
        ('odb', _RequestedSubscriptionInfo_odb),
        ('requestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo),
        ('supportedVLR-CAMEL-Phases', _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases),
        ('supportedSGSN-CAMEL-Phases', _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases),
        ('extensionContainer', _RequestedSubscriptionInfo_extensionContainer),
        ('additionalRequestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo),
        ('msisdn-BS-List', _RequestedSubscriptionInfo_msisdn_BS_List),
        ('csg-SubscriptionDataRequested', _RequestedSubscriptionInfo_csg_SubscriptionDataRequested),
        ('cw-Info', _RequestedSubscriptionInfo_cw_Info),
        ('clip-Info', _RequestedSubscriptionInfo_clip_Info),
        ('clir-Info', _RequestedSubscriptionInfo_clir_Info),
        ('hold-Info', _RequestedSubscriptionInfo_hold_Info),
        ('ect-Info', _RequestedSubscriptionInfo_ect_Info),
        ])
    RequestedSubscriptionInfo._ext = ['additionalRequestedCAMEL-SubscriptionInfo', 'msisdn-BS-List', 'csg-SubscriptionDataRequested', 'cw-Info', 'clip-Info', 'clir-Info', 'hold-Info', 'ect-Info']
    
    #-----< MSISDN-BS-List >-----#
    MSISDN_BS_List = SEQ_OF(name='MSISDN-BS-List', mode=MODE_TYPE)
    _MSISDN_BS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS')))
    MSISDN_BS_List._cont = _MSISDN_BS_List__item_
    MSISDN_BS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfMSISDN >-----#
    maxNumOfMSISDN = INT(name='maxNumOfMSISDN', mode=MODE_VALUE)
    maxNumOfMSISDN._val = 50
    
    #-----< MSISDN-BS >-----#
    MSISDN_BS = SEQ(name='MSISDN-BS', mode=MODE_TYPE)
    _MSISDN_BS_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MSISDN_BS_basicServiceList = SEQ_OF(name='basicServiceList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _MSISDN_BS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MSISDN_BS._cont = ASN1Dict([
        ('msisdn', _MSISDN_BS_msisdn),
        ('basicServiceList', _MSISDN_BS_basicServiceList),
        ('extensionContainer', _MSISDN_BS_extensionContainer),
        ])
    MSISDN_BS._ext = []
    
    #-----< RequestedCAMEL-SubscriptionInfo >-----#
    RequestedCAMEL_SubscriptionInfo = ENUM(name='RequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    RequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([('o-CSI', 0), ('t-CSI', 1), ('vt-CSI', 2), ('tif-CSI', 3), ('gprs-CSI', 4), ('mo-sms-CSI', 5), ('ss-CSI', 6), ('m-CSI', 7), ('d-csi', 8)])
    RequestedCAMEL_SubscriptionInfo._ext = None
    
    #-----< AdditionalRequestedCAMEL-SubscriptionInfo >-----#
    AdditionalRequestedCAMEL_SubscriptionInfo = ENUM(name='AdditionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    AdditionalRequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([('mt-sms-CSI', 0), ('mg-csi', 1), ('o-IM-CSI', 2), ('d-IM-CSI', 3), ('vt-IM-CSI', 4)])
    AdditionalRequestedCAMEL_SubscriptionInfo._ext = []
    
    #-----< CallForwardingData >-----#
    CallForwardingData = SEQ(name='CallForwardingData', mode=MODE_TYPE)
    _CallForwardingData_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _CallForwardingData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallForwardingData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallForwardingData._cont = ASN1Dict([
        ('forwardingFeatureList', _CallForwardingData_forwardingFeatureList),
        ('notificationToCSE', _CallForwardingData_notificationToCSE),
        ('extensionContainer', _CallForwardingData_extensionContainer),
        ])
    CallForwardingData._ext = []
    
    #-----< CallBarringData >-----#
    CallBarringData = SEQ(name='CallBarringData', mode=MODE_TYPE)
    _CallBarringData_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _CallBarringData_password = STR_NUM(name='password', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _CallBarringData_password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    _CallBarringData_wrongPasswordAttemptsCounter = INT(name='wrongPasswordAttemptsCounter', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _CallBarringData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallBarringData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallBarringData._cont = ASN1Dict([
        ('callBarringFeatureList', _CallBarringData_callBarringFeatureList),
        ('password', _CallBarringData_password),
        ('wrongPasswordAttemptsCounter', _CallBarringData_wrongPasswordAttemptsCounter),
        ('notificationToCSE', _CallBarringData_notificationToCSE),
        ('extensionContainer', _CallBarringData_extensionContainer),
        ])
    CallBarringData._ext = []
    
    #-----< WrongPasswordAttemptsCounter >-----#
    WrongPasswordAttemptsCounter = INT(name='WrongPasswordAttemptsCounter', mode=MODE_TYPE)
    WrongPasswordAttemptsCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< ODB-Info >-----#
    ODB_Info = SEQ(name='ODB-Info', mode=MODE_TYPE)
    _ODB_Info_odb_Data = SEQ(name='odb-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')))
    _ODB_Info_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, opt=True)
    _ODB_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Info._cont = ASN1Dict([
        ('odb-Data', _ODB_Info_odb_Data),
        ('notificationToCSE', _ODB_Info_notificationToCSE),
        ('extensionContainer', _ODB_Info_extensionContainer),
        ])
    ODB_Info._ext = []
    
    #-----< CAMEL-SubscriptionInfo >-----#
    CAMEL_SubscriptionInfo = SEQ(name='CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _CAMEL_SubscriptionInfo_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_CSI = SEQ(name='d-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_CSI = SEQ(name='t-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='t-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_vt_CSI = SEQ(name='vt-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='vt-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI = NULL(name='tif-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE = NULL(name='tif-CSI-NotificationToCSE', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name='gprs-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name='mo-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_ss_CSI = SEQ(name='ss-CSI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_m_CSI = SEQ(name='m-CSI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CAMEL_SubscriptionInfo_specificCSIDeletedList = BIT_STR(name='specificCSIDeletedList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name='mt-sms-CSI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name='mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_mg_csi = SEQ(name='mg-csi', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_CSI = SEQ(name='o-IM-CSI', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-IM-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_IM_CSI = SEQ(name='d-IM-CSI', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_CSI = SEQ(name='vt-IM-CSI', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='vt-IM-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    CAMEL_SubscriptionInfo._cont = ASN1Dict([
        ('o-CSI', _CAMEL_SubscriptionInfo_o_CSI),
        ('o-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        ('d-CSI', _CAMEL_SubscriptionInfo_d_CSI),
        ('t-CSI', _CAMEL_SubscriptionInfo_t_CSI),
        ('t-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        ('vt-CSI', _CAMEL_SubscriptionInfo_vt_CSI),
        ('vt-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList),
        ('tif-CSI', _CAMEL_SubscriptionInfo_tif_CSI),
        ('tif-CSI-NotificationToCSE', _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE),
        ('gprs-CSI', _CAMEL_SubscriptionInfo_gprs_CSI),
        ('mo-sms-CSI', _CAMEL_SubscriptionInfo_mo_sms_CSI),
        ('ss-CSI', _CAMEL_SubscriptionInfo_ss_CSI),
        ('m-CSI', _CAMEL_SubscriptionInfo_m_CSI),
        ('extensionContainer', _CAMEL_SubscriptionInfo_extensionContainer),
        ('specificCSIDeletedList', _CAMEL_SubscriptionInfo_specificCSIDeletedList),
        ('mt-sms-CSI', _CAMEL_SubscriptionInfo_mt_sms_CSI),
        ('mt-smsCAMELTDP-CriteriaList', _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ('mg-csi', _CAMEL_SubscriptionInfo_mg_csi),
        ('o-IM-CSI', _CAMEL_SubscriptionInfo_o_IM_CSI),
        ('o-IM-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList),
        ('d-IM-CSI', _CAMEL_SubscriptionInfo_d_IM_CSI),
        ('vt-IM-CSI', _CAMEL_SubscriptionInfo_vt_IM_CSI),
        ('vt-IM-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList),
        ])
    CAMEL_SubscriptionInfo._ext = ['specificCSIDeletedList', 'mt-sms-CSI', 'mt-smsCAMELTDP-CriteriaList', 'mg-csi', 'o-IM-CSI', 'o-IM-BcsmCamelTDP-CriteriaList', 'd-IM-CSI', 'vt-IM-CSI', 'vt-IM-BCSM-CAMEL-TDP-CriteriaList']
    
    #-----< AnyTimeModificationArg >-----#
    AnyTimeModificationArg = SEQ(name='AnyTimeModificationArg', mode=MODE_TYPE)
    _AnyTimeModificationArg_subscriberIdentity = CHOICE(name='subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeModificationArg_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeModificationArg_modificationRequestFor_CF_Info = SEQ(name='modificationRequestFor-CF-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CF-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CB_Info = SEQ(name='modificationRequestFor-CB-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CB-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSI = SEQ(name='modificationRequestFor-CSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSI')), opt=True)
    _AnyTimeModificationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ODB_data = SEQ(name='modificationRequestFor-ODB-data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ODB-data')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data = SEQ(name='modificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-IP-SM-GW-Data')), opt=True)
    _AnyTimeModificationArg_activationRequestForUE_reachability = BIT_STR(name='activationRequestForUE-reachability', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedServingNode')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSG = SEQ(name='modificationRequestFor-CSG', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSG')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CW_Data = SEQ(name='modificationRequestFor-CW-Data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CW-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIP_Data = SEQ(name='modificationRequestFor-CLIP-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIP-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIR_Data = SEQ(name='modificationRequestFor-CLIR-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIR-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_HOLD_Data = SEQ(name='modificationRequestFor-HOLD-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CH-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ECT_Data = SEQ(name='modificationRequestFor-ECT-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ECT-Info')), opt=True)
    AnyTimeModificationArg._cont = ASN1Dict([
        ('subscriberIdentity', _AnyTimeModificationArg_subscriberIdentity),
        ('gsmSCF-Address', _AnyTimeModificationArg_gsmSCF_Address),
        ('modificationRequestFor-CF-Info', _AnyTimeModificationArg_modificationRequestFor_CF_Info),
        ('modificationRequestFor-CB-Info', _AnyTimeModificationArg_modificationRequestFor_CB_Info),
        ('modificationRequestFor-CSI', _AnyTimeModificationArg_modificationRequestFor_CSI),
        ('extensionContainer', _AnyTimeModificationArg_extensionContainer),
        ('longFTN-Supported', _AnyTimeModificationArg_longFTN_Supported),
        ('modificationRequestFor-ODB-data', _AnyTimeModificationArg_modificationRequestFor_ODB_data),
        ('modificationRequestFor-IP-SM-GW-Data', _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data),
        ('activationRequestForUE-reachability', _AnyTimeModificationArg_activationRequestForUE_reachability),
        ('modificationRequestFor-CSG', _AnyTimeModificationArg_modificationRequestFor_CSG),
        ('modificationRequestFor-CW-Data', _AnyTimeModificationArg_modificationRequestFor_CW_Data),
        ('modificationRequestFor-CLIP-Data', _AnyTimeModificationArg_modificationRequestFor_CLIP_Data),
        ('modificationRequestFor-CLIR-Data', _AnyTimeModificationArg_modificationRequestFor_CLIR_Data),
        ('modificationRequestFor-HOLD-Data', _AnyTimeModificationArg_modificationRequestFor_HOLD_Data),
        ('modificationRequestFor-ECT-Data', _AnyTimeModificationArg_modificationRequestFor_ECT_Data),
        ])
    AnyTimeModificationArg._ext = ['modificationRequestFor-ODB-data', 'modificationRequestFor-IP-SM-GW-Data', 'activationRequestForUE-reachability', 'modificationRequestFor-CSG', 'modificationRequestFor-CW-Data', 'modificationRequestFor-CLIP-Data', 'modificationRequestFor-CLIR-Data', 'modificationRequestFor-HOLD-Data', 'modificationRequestFor-ECT-Data']
    
    #-----< ModificationRequestFor-CW-Info >-----#
    ModificationRequestFor_CW_Info = SEQ(name='ModificationRequestFor-CW-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CW_Info_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CW_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CW_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CW_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CW_Info._cont = ASN1Dict([
        ('basicService', _ModificationRequestFor_CW_Info_basicService),
        ('ss-Status', _ModificationRequestFor_CW_Info_ss_Status),
        ('modifyNotificationToCSE', _ModificationRequestFor_CW_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CW_Info_extensionContainer),
        ])
    ModificationRequestFor_CW_Info._ext = []
    
    #-----< ModificationRequestFor-CH-Info >-----#
    ModificationRequestFor_CH_Info = SEQ(name='ModificationRequestFor-CH-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CH_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CH_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CH_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CH_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_CH_Info_ss_Status),
        ('modifyNotificationToCSE', _ModificationRequestFor_CH_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CH_Info_extensionContainer),
        ])
    ModificationRequestFor_CH_Info._ext = []
    
    #-----< ModificationRequestFor-ECT-Info >-----#
    ModificationRequestFor_ECT_Info = SEQ(name='ModificationRequestFor-ECT-Info', mode=MODE_TYPE)
    _ModificationRequestFor_ECT_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_ECT_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ECT_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ECT_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_ECT_Info_ss_Status),
        ('modifyNotificationToCSE', _ModificationRequestFor_ECT_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_ECT_Info_extensionContainer),
        ])
    ModificationRequestFor_ECT_Info._ext = []
    
    #-----< ModificationRequestFor-CLIR-Info >-----#
    ModificationRequestFor_CLIR_Info = SEQ(name='ModificationRequestFor-CLIR-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIR_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIR_Info_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIR_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIR_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_CLIR_Info_ss_Status),
        ('cliRestrictionOption', _ModificationRequestFor_CLIR_Info_cliRestrictionOption),
        ('modifyNotificationToCSE', _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CLIR_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIR_Info._ext = []
    
    #-----< ModificationRequestFor-CLIP-Info >-----#
    ModificationRequestFor_CLIP_Info = SEQ(name='ModificationRequestFor-CLIP-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIP_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIP_Info_overrideCategory = ENUM(name='overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')), opt=True)
    _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIP_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIP_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_CLIP_Info_ss_Status),
        ('overrideCategory', _ModificationRequestFor_CLIP_Info_overrideCategory),
        ('modifyNotificationToCSE', _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CLIP_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIP_Info._ext = []
    
    #-----< ModificationRequestFor-CSG >-----#
    ModificationRequestFor_CSG = SEQ(name='ModificationRequestFor-CSG', mode=MODE_TYPE)
    _ModificationRequestFor_CSG_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSG_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CSG._cont = ASN1Dict([
        ('modifyNotificationToCSE', _ModificationRequestFor_CSG_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CSG_extensionContainer),
        ])
    ModificationRequestFor_CSG._ext = []
    
    #-----< RequestedServingNode >-----#
    RequestedServingNode = BIT_STR(name='RequestedServingNode', mode=MODE_TYPE)
    RequestedServingNode._cont = ASN1Dict([('mmeAndSgsn', 0)])
    RequestedServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServingNode >-----#
    ServingNode = BIT_STR(name='ServingNode', mode=MODE_TYPE)
    ServingNode._cont = ASN1Dict([('mme', 0), ('sgsn', 1)])
    ServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< AnyTimeModificationRes >-----#
    AnyTimeModificationRes = SEQ(name='AnyTimeModificationRes', mode=MODE_TYPE)
    _AnyTimeModificationRes_ss_InfoFor_CSE = CHOICE(name='ss-InfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoFor-CSE')), opt=True)
    _AnyTimeModificationRes_camel_SubscriptionInfo = SEQ(name='camel-SubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeModificationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationRes_odb_Info = SEQ(name='odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeModificationRes_cw_Data = SEQ(name='cw-Data', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeModificationRes_ch_Data = SEQ(name='ch-Data', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeModificationRes_clip_Data = SEQ(name='clip-Data', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeModificationRes_clir_Data = SEQ(name='clir-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeModificationRes_ect_data = SEQ(name='ect-data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    _AnyTimeModificationRes_serviceCentreAddress = OCT_STR(name='serviceCentreAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    AnyTimeModificationRes._cont = ASN1Dict([
        ('ss-InfoFor-CSE', _AnyTimeModificationRes_ss_InfoFor_CSE),
        ('camel-SubscriptionInfo', _AnyTimeModificationRes_camel_SubscriptionInfo),
        ('extensionContainer', _AnyTimeModificationRes_extensionContainer),
        ('odb-Info', _AnyTimeModificationRes_odb_Info),
        ('cw-Data', _AnyTimeModificationRes_cw_Data),
        ('ch-Data', _AnyTimeModificationRes_ch_Data),
        ('clip-Data', _AnyTimeModificationRes_clip_Data),
        ('clir-Data', _AnyTimeModificationRes_clir_Data),
        ('ect-data', _AnyTimeModificationRes_ect_data),
        ('serviceCentreAddress', _AnyTimeModificationRes_serviceCentreAddress),
        ])
    AnyTimeModificationRes._ext = ['odb-Info', 'cw-Data', 'ch-Data', 'clip-Data', 'clir-Data', 'ect-data', 'serviceCentreAddress']
    
    #-----< ModificationRequestFor-CF-Info >-----#
    ModificationRequestFor_CF_Info = SEQ(name='ModificationRequestFor-CF-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CF_Info_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CF_Info_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CF_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ModificationRequestFor_CF_Info_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _ModificationRequestFor_CF_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CF_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CF_Info._cont = ASN1Dict([
        ('ss-Code', _ModificationRequestFor_CF_Info_ss_Code),
        ('basicService', _ModificationRequestFor_CF_Info_basicService),
        ('ss-Status', _ModificationRequestFor_CF_Info_ss_Status),
        ('forwardedToNumber', _ModificationRequestFor_CF_Info_forwardedToNumber),
        ('forwardedToSubaddress', _ModificationRequestFor_CF_Info_forwardedToSubaddress),
        ('noReplyConditionTime', _ModificationRequestFor_CF_Info_noReplyConditionTime),
        ('modifyNotificationToCSE', _ModificationRequestFor_CF_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CF_Info_extensionContainer),
        ])
    ModificationRequestFor_CF_Info._ext = []
    
    #-----< ModificationRequestFor-CB-Info >-----#
    ModificationRequestFor_CB_Info = SEQ(name='ModificationRequestFor-CB-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CB_Info_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CB_Info_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CB_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CB_Info_password = STR_NUM(name='password', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _ModificationRequestFor_CB_Info_password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter = INT(name='wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _ModificationRequestFor_CB_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CB_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CB_Info._cont = ASN1Dict([
        ('ss-Code', _ModificationRequestFor_CB_Info_ss_Code),
        ('basicService', _ModificationRequestFor_CB_Info_basicService),
        ('ss-Status', _ModificationRequestFor_CB_Info_ss_Status),
        ('password', _ModificationRequestFor_CB_Info_password),
        ('wrongPasswordAttemptsCounter', _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter),
        ('modifyNotificationToCSE', _ModificationRequestFor_CB_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CB_Info_extensionContainer),
        ])
    ModificationRequestFor_CB_Info._ext = []
    
    #-----< ModificationRequestFor-ODB-data >-----#
    ModificationRequestFor_ODB_data = SEQ(name='ModificationRequestFor-ODB-data', mode=MODE_TYPE)
    _ModificationRequestFor_ODB_data_odb_data = SEQ(name='odb-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _ModificationRequestFor_ODB_data_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ODB_data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ODB_data._cont = ASN1Dict([
        ('odb-data', _ModificationRequestFor_ODB_data_odb_data),
        ('modifyNotificationToCSE', _ModificationRequestFor_ODB_data_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_ODB_data_extensionContainer),
        ])
    ModificationRequestFor_ODB_data._ext = []
    
    #-----< ModificationRequestFor-CSI >-----#
    ModificationRequestFor_CSI = SEQ(name='ModificationRequestFor-CSI', mode=MODE_TYPE)
    _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo = ENUM(name='requestedCamel-SubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')))
    _ModificationRequestFor_CSI_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_modifyCSI_State = ENUM(name='modifyCSI-State', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name='additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    ModificationRequestFor_CSI._cont = ASN1Dict([
        ('requestedCamel-SubscriptionInfo', _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo),
        ('modifyNotificationToCSE', _ModificationRequestFor_CSI_modifyNotificationToCSE),
        ('modifyCSI-State', _ModificationRequestFor_CSI_modifyCSI_State),
        ('extensionContainer', _ModificationRequestFor_CSI_extensionContainer),
        ('additionalRequestedCAMEL-SubscriptionInfo', _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo),
        ])
    ModificationRequestFor_CSI._ext = ['additionalRequestedCAMEL-SubscriptionInfo']
    
    #-----< ModificationRequestFor-IP-SM-GW-Data >-----#
    ModificationRequestFor_IP_SM_GW_Data = SEQ(name='ModificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE)
    _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus = ENUM(name='modifyRegistrationStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress = SEQ(name='ip-sm-gw-DiameterAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    ModificationRequestFor_IP_SM_GW_Data._cont = ASN1Dict([
        ('modifyRegistrationStatus', _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus),
        ('extensionContainer', _ModificationRequestFor_IP_SM_GW_Data_extensionContainer),
        ('ip-sm-gw-DiameterAddress', _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress),
        ])
    ModificationRequestFor_IP_SM_GW_Data._ext = ['ip-sm-gw-DiameterAddress']
    
    #-----< ModificationInstruction >-----#
    ModificationInstruction = ENUM(name='ModificationInstruction', mode=MODE_TYPE)
    ModificationInstruction._cont = ASN1Dict([('deactivate', 0), ('activate', 1)])
    ModificationInstruction._ext = None
    
    #-----< NoteSubscriberDataModifiedArg >-----#
    NoteSubscriberDataModifiedArg = SEQ(name='NoteSubscriberDataModifiedArg', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteSubscriberDataModifiedArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE = SEQ(name='forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE = SEQ(name='callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_odb_Info = SEQ(name='odb-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo = SEQ(name='camel-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _NoteSubscriberDataModifiedArg_allInformationSent = NULL(name='allInformationSent', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NoteSubscriberDataModifiedArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteSubscriberDataModifiedArg_ue_reachable = BIT_STR(name='ue-reachable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServingNode')), opt=True)
    _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _NoteSubscriberDataModifiedArg_cw_Data = SEQ(name='cw-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _NoteSubscriberDataModifiedArg_ch_Data = SEQ(name='ch-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _NoteSubscriberDataModifiedArg_clip_Data = SEQ(name='clip-Data', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _NoteSubscriberDataModifiedArg_clir_Data = SEQ(name='clir-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _NoteSubscriberDataModifiedArg_ect_data = SEQ(name='ect-data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    NoteSubscriberDataModifiedArg._cont = ASN1Dict([
        ('imsi', _NoteSubscriberDataModifiedArg_imsi),
        ('msisdn', _NoteSubscriberDataModifiedArg_msisdn),
        ('forwardingInfoFor-CSE', _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE),
        ('callBarringInfoFor-CSE', _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE),
        ('odb-Info', _NoteSubscriberDataModifiedArg_odb_Info),
        ('camel-SubscriptionInfo', _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo),
        ('allInformationSent', _NoteSubscriberDataModifiedArg_allInformationSent),
        ('extensionContainer', _NoteSubscriberDataModifiedArg_extensionContainer),
        ('ue-reachable', _NoteSubscriberDataModifiedArg_ue_reachable),
        ('csg-SubscriptionDataList', _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList),
        ('cw-Data', _NoteSubscriberDataModifiedArg_cw_Data),
        ('ch-Data', _NoteSubscriberDataModifiedArg_ch_Data),
        ('clip-Data', _NoteSubscriberDataModifiedArg_clip_Data),
        ('clir-Data', _NoteSubscriberDataModifiedArg_clir_Data),
        ('ect-data', _NoteSubscriberDataModifiedArg_ect_data),
        ])
    NoteSubscriberDataModifiedArg._ext = ['ue-reachable', 'csg-SubscriptionDataList', 'cw-Data', 'ch-Data', 'clip-Data', 'clir-Data', 'ect-data']
    
    #-----< NoteSubscriberDataModifiedRes >-----#
    NoteSubscriberDataModifiedRes = SEQ(name='NoteSubscriberDataModifiedRes', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteSubscriberDataModifiedRes._cont = ASN1Dict([
        ('extensionContainer', _NoteSubscriberDataModifiedRes_extensionContainer),
        ])
    NoteSubscriberDataModifiedRes._ext = []
    
    #-----< NoteMM-EventArg >-----#
    NoteMM_EventArg = SEQ(name='NoteMM-EventArg', mode=MODE_TYPE)
    _NoteMM_EventArg_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _NoteMM_EventArg_eventMet = OCT_STR(name='eventMet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    _NoteMM_EventArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMM_EventArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteMM_EventArg_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _NoteMM_EventArg_supportedCAMELPhases = BIT_STR(name='supportedCAMELPhases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _NoteMM_EventArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteMM_EventArg_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _NoteMM_EventArg_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    NoteMM_EventArg._cont = ASN1Dict([
        ('serviceKey', _NoteMM_EventArg_serviceKey),
        ('eventMet', _NoteMM_EventArg_eventMet),
        ('imsi', _NoteMM_EventArg_imsi),
        ('msisdn', _NoteMM_EventArg_msisdn),
        ('locationInformation', _NoteMM_EventArg_locationInformation),
        ('supportedCAMELPhases', _NoteMM_EventArg_supportedCAMELPhases),
        ('extensionContainer', _NoteMM_EventArg_extensionContainer),
        ('locationInformationGPRS', _NoteMM_EventArg_locationInformationGPRS),
        ('offeredCamel4Functionalities', _NoteMM_EventArg_offeredCamel4Functionalities),
        ])
    NoteMM_EventArg._ext = ['locationInformationGPRS', 'offeredCamel4Functionalities']
    
    #-----< NoteMM-EventRes >-----#
    NoteMM_EventRes = SEQ(name='NoteMM-EventRes', mode=MODE_TYPE)
    _NoteMM_EventRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMM_EventRes._cont = ASN1Dict([
        ('extensionContainer', _NoteMM_EventRes_extensionContainer),
        ])
    NoteMM_EventRes._ext = []
    
    #-----< Ext-SS-InfoFor-CSE >-----#
    Ext_SS_InfoFor_CSE = CHOICE(name='Ext-SS-InfoFor-CSE', mode=MODE_TYPE)
    _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE = SEQ(name='forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')))
    _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE = SEQ(name='callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')))
    Ext_SS_InfoFor_CSE._cont = ASN1Dict([
        ('forwardingInfoFor-CSE', _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE),
        ('callBarringInfoFor-CSE', _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE),
        ])
    Ext_SS_InfoFor_CSE._ext = None
    
    #-----< Ext-ForwardingInfoFor-CSE >-----#
    Ext_ForwardingInfoFor_CSE = SEQ(name='Ext-ForwardingInfoFor-CSE', mode=MODE_TYPE)
    _Ext_ForwardingInfoFor_CSE_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwardingInfoFor_CSE_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwardingInfoFor_CSE_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_ForwardingInfoFor_CSE_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwardingInfoFor_CSE._cont = ASN1Dict([
        ('ss-Code', _Ext_ForwardingInfoFor_CSE_ss_Code),
        ('forwardingFeatureList', _Ext_ForwardingInfoFor_CSE_forwardingFeatureList),
        ('notificationToCSE', _Ext_ForwardingInfoFor_CSE_notificationToCSE),
        ('extensionContainer', _Ext_ForwardingInfoFor_CSE_extensionContainer),
        ])
    Ext_ForwardingInfoFor_CSE._ext = []
    
    #-----< Ext-CallBarringInfoFor-CSE >-----#
    Ext_CallBarringInfoFor_CSE = SEQ(name='Ext-CallBarringInfoFor-CSE', mode=MODE_TYPE)
    _Ext_CallBarringInfoFor_CSE_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarringInfoFor_CSE_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarringInfoFor_CSE_password = STR_NUM(name='password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _Ext_CallBarringInfoFor_CSE_password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter = INT(name='wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _Ext_CallBarringInfoFor_CSE_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_CallBarringInfoFor_CSE_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringInfoFor_CSE._cont = ASN1Dict([
        ('ss-Code', _Ext_CallBarringInfoFor_CSE_ss_Code),
        ('callBarringFeatureList', _Ext_CallBarringInfoFor_CSE_callBarringFeatureList),
        ('password', _Ext_CallBarringInfoFor_CSE_password),
        ('wrongPasswordAttemptsCounter', _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter),
        ('notificationToCSE', _Ext_CallBarringInfoFor_CSE_notificationToCSE),
        ('extensionContainer', _Ext_CallBarringInfoFor_CSE_extensionContainer),
        ])
    Ext_CallBarringInfoFor_CSE._ext = []
    
    #-----< UpdateVcsgLocationArg >-----#
    UpdateVcsgLocationArg = SEQ(name='UpdateVcsgLocationArg', mode=MODE_TYPE)
    _UpdateVcsgLocationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateVcsgLocationArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationArg._cont = ASN1Dict([
        ('imsi', _UpdateVcsgLocationArg_imsi),
        ('msisdn', _UpdateVcsgLocationArg_msisdn),
        ('vlr-Number', _UpdateVcsgLocationArg_vlr_Number),
        ('sgsn-Number', _UpdateVcsgLocationArg_sgsn_Number),
        ('extensionContainer', _UpdateVcsgLocationArg_extensionContainer),
        ])
    UpdateVcsgLocationArg._ext = []
    
    #-----< UpdateVcsgLocationRes >-----#
    UpdateVcsgLocationRes = SEQ(name='UpdateVcsgLocationRes', mode=MODE_TYPE)
    _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator = NULL(name='temporaryEmptySubscriptiondataIndicator', mode=MODE_TYPE, opt=True)
    _UpdateVcsgLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationRes._cont = ASN1Dict([
        ('temporaryEmptySubscriptiondataIndicator', _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator),
        ('extensionContainer', _UpdateVcsgLocationRes_extensionContainer),
        ])
    UpdateVcsgLocationRes._ext = []
    
    #-----< CancelVcsgLocationArg >-----#
    CancelVcsgLocationArg = SEQ(name='CancelVcsgLocationArg', mode=MODE_TYPE)
    _CancelVcsgLocationArg_identity = CHOICE(name='identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelVcsgLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationArg._cont = ASN1Dict([
        ('identity', _CancelVcsgLocationArg_identity),
        ('extensionContainer', _CancelVcsgLocationArg_extensionContainer),
        ])
    CancelVcsgLocationArg._ext = []
    
    #-----< CancelVcsgLocationRes >-----#
    CancelVcsgLocationRes = SEQ(name='CancelVcsgLocationRes', mode=MODE_TYPE)
    _CancelVcsgLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationRes._cont = ASN1Dict([
        ('extensionContainer', _CancelVcsgLocationRes_extensionContainer),
        ])
    CancelVcsgLocationRes._ext = []
    
    _all_ = [
        _UpdateLocationArg_imsi,
        _UpdateLocationArg_msc_Number,
        _UpdateLocationArg_vlr_Number,
        _UpdateLocationArg_lmsi,
        _UpdateLocationArg_extensionContainer,
        _UpdateLocationArg_vlr_Capability,
        _UpdateLocationArg_informPreviousNetworkEntity,
        _UpdateLocationArg_cs_LCS_NotSupportedByUE,
        _UpdateLocationArg_v_gmlc_Address,
        _UpdateLocationArg_add_info,
        _UpdateLocationArg_pagingArea,
        _UpdateLocationArg_skipSubscriberDataUpdate,
        _UpdateLocationArg_restorationIndicator,
        _UpdateLocationArg_eplmn_List,
        _UpdateLocationArg_mme_DiameterAddress,
        UpdateLocationArg,
        _VLR_Capability_supportedCamelPhases,
        _VLR_Capability_extensionContainer,
        _VLR_Capability_solsaSupportIndicator,
        _VLR_Capability_istSupportIndicator,
        _VLR_Capability_superChargerSupportedInServingNetworkEntity,
        _VLR_Capability_longFTN_Supported,
        _VLR_Capability_supportedLCS_CapabilitySets,
        _VLR_Capability_offeredCamel4CSIs,
        _VLR_Capability_supportedRAT_TypesIndicator,
        _VLR_Capability_longGroupID_Supported,
        _VLR_Capability_mtRoamingForwardingSupported,
        _VLR_Capability_msisdn_lessOperation_Supported,
        _VLR_Capability_reset_ids_Supported,
        VLR_Capability,
        SupportedRAT_Types,
        _SuperChargerInfo_sendSubscriberData,
        _SuperChargerInfo_subscriberDataStored,
        SuperChargerInfo,
        AgeIndicator,
        IST_SupportIndicator,
        SupportedLCS_CapabilitySets,
        _UpdateLocationRes_hlr_Number,
        _UpdateLocationRes_extensionContainer,
        _UpdateLocationRes_add_Capability,
        _UpdateLocationRes_pagingArea_Capability,
        UpdateLocationRes,
        _ADD_Info_imeisv,
        _ADD_Info_skipSubscriberDataUpdate,
        ADD_Info,
        _PagingArea__item_,
        PagingArea,
        _LocationArea_laiFixedLength,
        _LocationArea_lac,
        LocationArea,
        LAC,
        _CancelLocationArg_identity,
        _CancelLocationArg_cancellationType,
        _CancelLocationArg_extensionContainer,
        _CancelLocationArg_typeOfUpdate,
        _CancelLocationArg_mtrf_SupportedAndAuthorized,
        _CancelLocationArg_mtrf_SupportedAndNotAuthorized,
        _CancelLocationArg_newMSC_Number,
        _CancelLocationArg_newVLR_Number,
        _CancelLocationArg_new_lmsi,
        _CancelLocationArg_reattach_Required,
        CancelLocationArg,
        TypeOfUpdate,
        CancellationType,
        _CancelLocationRes_extensionContainer,
        CancelLocationRes,
        _PurgeMS_Arg_imsi,
        _PurgeMS_Arg_vlr_Number,
        _PurgeMS_Arg_sgsn_Number,
        _PurgeMS_Arg_extensionContainer,
        _PurgeMS_Arg_locationInformation,
        _PurgeMS_Arg_locationInformationGPRS,
        _PurgeMS_Arg_locationInformationEPS,
        PurgeMS_Arg,
        _PurgeMS_Res_freezeTMSI,
        _PurgeMS_Res_freezeP_TMSI,
        _PurgeMS_Res_extensionContainer,
        _PurgeMS_Res_freezeM_TMSI,
        PurgeMS_Res,
        _SendIdentificationArg_tmsi,
        _SendIdentificationArg_numberOfRequestedVectors,
        _SendIdentificationArg_segmentationProhibited,
        _SendIdentificationArg_extensionContainer,
        _SendIdentificationArg_msc_Number,
        _SendIdentificationArg_previous_LAI,
        _SendIdentificationArg_hopCounter,
        _SendIdentificationArg_mtRoamingForwardingSupported,
        _SendIdentificationArg_newVLR_Number,
        _SendIdentificationArg_new_lmsi,
        SendIdentificationArg,
        HopCounter,
        _SendIdentificationRes_imsi,
        _SendIdentificationRes_authenticationSetList,
        _SendIdentificationRes_currentSecurityContext,
        _SendIdentificationRes_extensionContainer,
        _SendIdentificationRes_lastUsedLtePLMN_Id,
        _SendIdentificationRes_mtCallPendingFlag,
        SendIdentificationRes,
        _AuthenticationSetList_tripletList,
        _AuthenticationSetList_quintupletList,
        AuthenticationSetList,
        _TripletList__item_,
        TripletList,
        _QuintupletList__item_,
        QuintupletList,
        _AuthenticationTriplet_rand,
        _AuthenticationTriplet_sres,
        _AuthenticationTriplet_kc,
        AuthenticationTriplet,
        _AuthenticationQuintuplet_rand,
        _AuthenticationQuintuplet_xres,
        _AuthenticationQuintuplet_ck,
        _AuthenticationQuintuplet_ik,
        _AuthenticationQuintuplet_autn,
        AuthenticationQuintuplet,
        _CurrentSecurityContext_gsm_SecurityContextData,
        _CurrentSecurityContext_umts_SecurityContextData,
        CurrentSecurityContext,
        _GSM_SecurityContextData_kc,
        _GSM_SecurityContextData_cksn,
        GSM_SecurityContextData,
        _UMTS_SecurityContextData_ck,
        _UMTS_SecurityContextData_ik,
        _UMTS_SecurityContextData_ksi,
        UMTS_SecurityContextData,
        RAND,
        SRES,
        Kc,
        XRES,
        CK,
        IK,
        AUTN,
        AUTS,
        Cksn,
        KSI,
        _AuthenticationFailureReportArg_imsi,
        _AuthenticationFailureReportArg_failureCause,
        _AuthenticationFailureReportArg_extensionContainer,
        _AuthenticationFailureReportArg_re_attempt,
        _AuthenticationFailureReportArg_accessType,
        _AuthenticationFailureReportArg_rand,
        _AuthenticationFailureReportArg_vlr_Number,
        _AuthenticationFailureReportArg_sgsn_Number,
        AuthenticationFailureReportArg,
        AccessType,
        _AuthenticationFailureReportRes_extensionContainer,
        AuthenticationFailureReportRes,
        FailureCause,
        _UpdateGprsLocationArg_imsi,
        _UpdateGprsLocationArg_sgsn_Number,
        _UpdateGprsLocationArg_sgsn_Address,
        _UpdateGprsLocationArg_extensionContainer,
        _UpdateGprsLocationArg_sgsn_Capability,
        _UpdateGprsLocationArg_informPreviousNetworkEntity,
        _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE,
        _UpdateGprsLocationArg_v_gmlc_Address,
        _UpdateGprsLocationArg_add_info,
        _UpdateGprsLocationArg_eps_info,
        _UpdateGprsLocationArg_servingNodeTypeIndicator,
        _UpdateGprsLocationArg_skipSubscriberDataUpdate,
        _UpdateGprsLocationArg_usedRAT_Type,
        _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_nodeTypeIndicator,
        _UpdateGprsLocationArg_areaRestricted,
        _UpdateGprsLocationArg_ue_reachableIndicator,
        _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_ue_srvcc_Capability,
        _UpdateGprsLocationArg_eplmn_List,
        _UpdateGprsLocationArg_mmeNumberforMTSMS,
        _UpdateGprsLocationArg_smsRegisterRequest,
        _UpdateGprsLocationArg_sms_Only,
        _UpdateGprsLocationArg_removalofMMERegistrationforSMS,
        _UpdateGprsLocationArg_sgsn_Name,
        _UpdateGprsLocationArg_sgsn_Realm,
        _UpdateGprsLocationArg_lgd_supportIndicator,
        _UpdateGprsLocationArg_adjacentPLMN_List,
        UpdateGprsLocationArg,
        SMSRegisterRequest,
        Used_RAT_Type,
        _EPS_Info_pdn_gw_update,
        _EPS_Info_isr_Information,
        EPS_Info,
        _PDN_GW_Update_apn,
        _PDN_GW_Update_pdn_gw_Identity,
        _PDN_GW_Update_contextId,
        _PDN_GW_Update_extensionContainer,
        PDN_GW_Update,
        ISR_Information,
        _SGSN_Capability_solsaSupportIndicator,
        _SGSN_Capability_extensionContainer,
        _SGSN_Capability_superChargerSupportedInServingNetworkEntity,
        _SGSN_Capability_gprsEnhancementsSupportIndicator,
        _SGSN_Capability_supportedCamelPhases,
        _SGSN_Capability_supportedLCS_CapabilitySets,
        _SGSN_Capability_offeredCamel4CSIs,
        _SGSN_Capability_smsCallBarringSupportIndicator,
        _SGSN_Capability_supportedRAT_TypesIndicator,
        _SGSN_Capability_supportedFeatures,
        _SGSN_Capability_t_adsDataRetrieval,
        _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_cancellationTypeInitialAttach,
        _SGSN_Capability_msisdn_lessOperation_Supported,
        _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_reset_ids_Supported,
        _SGSN_Capability_ext_SupportedFeatures,
        SGSN_Capability,
        SupportedFeatures,
        Ext_SupportedFeatures,
        UE_SRVCC_Capability,
        _UpdateGprsLocationRes_hlr_Number,
        _UpdateGprsLocationRes_extensionContainer,
        _UpdateGprsLocationRes_add_Capability,
        _UpdateGprsLocationRes_sgsn_mmeSeparationSupported,
        _UpdateGprsLocationRes_mmeRegisteredforSMS,
        UpdateGprsLocationRes,
        _EPLMN_List__item_,
        EPLMN_List,
        _AdjacentPLMN_List__item_,
        AdjacentPLMN_List,
        _ForwardAccessSignalling_Arg_an_APDU,
        _ForwardAccessSignalling_Arg_integrityProtectionInfo,
        _ForwardAccessSignalling_Arg_encryptionInfo,
        _ForwardAccessSignalling_Arg_keyStatus,
        _ForwardAccessSignalling_Arg_allowedGSM_Algorithms,
        _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms,
        _ForwardAccessSignalling_Arg_radioResourceInformation,
        _ForwardAccessSignalling_Arg_extensionContainer,
        _ForwardAccessSignalling_Arg_radioResourceList,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandover,
        _ForwardAccessSignalling_Arg_ranap_ServiceHandover,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList,
        _ForwardAccessSignalling_Arg_currentlyUsedCodec,
        _ForwardAccessSignalling_Arg_iuSupportedCodecsList,
        _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator,
        _ForwardAccessSignalling_Arg_iuSelectedCodec,
        _ForwardAccessSignalling_Arg_alternativeChannelType,
        _ForwardAccessSignalling_Arg_tracePropagationList,
        _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor,
        _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ForwardAccessSignalling_Arg_uesbi_Iu,
        _ForwardAccessSignalling_Arg_imeisv,
        ForwardAccessSignalling_Arg,
        AllowedGSM_Algorithms,
        _AllowedUMTS_Algorithms_integrityProtectionAlgorithms,
        _AllowedUMTS_Algorithms_encryptionAlgorithms,
        _AllowedUMTS_Algorithms_extensionContainer,
        AllowedUMTS_Algorithms,
        PermittedIntegrityProtectionAlgorithms,
        maxPermittedIntegrityProtectionAlgorithmsLength,
        PermittedEncryptionAlgorithms,
        maxPermittedEncryptionAlgorithmsLength,
        KeyStatus,
        _PrepareHO_Arg_targetCellId,
        _PrepareHO_Arg_ho_NumberNotRequired,
        _PrepareHO_Arg_targetRNCId,
        _PrepareHO_Arg_an_APDU,
        _PrepareHO_Arg_multipleBearerRequested,
        _PrepareHO_Arg_imsi,
        _PrepareHO_Arg_integrityProtectionInfo,
        _PrepareHO_Arg_encryptionInfo,
        _PrepareHO_Arg_radioResourceInformation,
        _PrepareHO_Arg_allowedGSM_Algorithms,
        _PrepareHO_Arg_allowedUMTS_Algorithms,
        _PrepareHO_Arg_radioResourceList,
        _PrepareHO_Arg_extensionContainer,
        _PrepareHO_Arg_rab_Id,
        _PrepareHO_Arg_bssmap_ServiceHandover,
        _PrepareHO_Arg_ranap_ServiceHandover,
        _PrepareHO_Arg_bssmap_ServiceHandoverList,
        _PrepareHO_Arg_asciCallReference,
        _PrepareHO_Arg_geran_classmark,
        _PrepareHO_Arg_iuCurrentlyUsedCodec,
        _PrepareHO_Arg_iuSupportedCodecsList,
        _PrepareHO_Arg_rab_ConfigurationIndicator,
        _PrepareHO_Arg_uesbi_Iu,
        _PrepareHO_Arg_imeisv,
        _PrepareHO_Arg_alternativeChannelType,
        _PrepareHO_Arg_tracePropagationList,
        _PrepareHO_Arg_aoipSupportedCodecsListAnchor,
        _PrepareHO_Arg_regionalSubscriptionData,
        _PrepareHO_Arg_lclsGlobalCallReference,
        _PrepareHO_Arg_lcls_Negotiation,
        _PrepareHO_Arg_lcls_Configuration_Preference,
        _PrepareHO_Arg_csg_SubscriptionDataList,
        PrepareHO_Arg,
        LCLS_GlobalCallReference,
        LCLS_Negotiation,
        LCLS_ConfigurationPreference,
        _BSSMAP_ServiceHandoverList__item_,
        BSSMAP_ServiceHandoverList,
        _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover,
        _BSSMAP_ServiceHandoverInfo_rab_Id,
        BSSMAP_ServiceHandoverInfo,
        maxNumOfServiceHandovers,
        BSSMAP_ServiceHandover,
        RANAP_ServiceHandover,
        _RadioResourceList__item_,
        RadioResourceList,
        _RadioResource_radioResourceInformation,
        _RadioResource_rab_Id,
        RadioResource,
        maxNumOfRadioResources,
        _PrepareHO_Res_handoverNumber,
        _PrepareHO_Res_relocationNumberList,
        _PrepareHO_Res_an_APDU,
        _PrepareHO_Res_multicallBearerInfo,
        _PrepareHO_Res_multipleBearerNotSupported,
        _PrepareHO_Res_selectedUMTS_Algorithms,
        _PrepareHO_Res_chosenRadioResourceInformation,
        _PrepareHO_Res_extensionContainer,
        _PrepareHO_Res_iuSelectedCodec,
        _PrepareHO_Res_iuAvailableCodecsList,
        _PrepareHO_Res_aoipSelectedCodecTarget,
        _PrepareHO_Res_aoipAvailableCodecsListMap,
        PrepareHO_Res,
        _SelectedUMTS_Algorithms_integrityProtectionAlgorithm,
        _SelectedUMTS_Algorithms_encryptionAlgorithm,
        _SelectedUMTS_Algorithms_extensionContainer,
        SelectedUMTS_Algorithms,
        ChosenIntegrityProtectionAlgorithm,
        ChosenEncryptionAlgorithm,
        _ChosenRadioResourceInformation_chosenChannelInfo,
        _ChosenRadioResourceInformation_chosenSpeechVersion,
        ChosenRadioResourceInformation,
        ChosenChannelInfo,
        ChosenSpeechVersion,
        _PrepareSubsequentHO_Arg_targetCellId,
        _PrepareSubsequentHO_Arg_targetMSC_Number,
        _PrepareSubsequentHO_Arg_targetRNCId,
        _PrepareSubsequentHO_Arg_an_APDU,
        _PrepareSubsequentHO_Arg_selectedRab_Id,
        _PrepareSubsequentHO_Arg_extensionContainer,
        _PrepareSubsequentHO_Arg_geran_classmark,
        _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator,
        PrepareSubsequentHO_Arg,
        _PrepareSubsequentHO_Res_an_APDU,
        _PrepareSubsequentHO_Res_extensionContainer,
        PrepareSubsequentHO_Res,
        _ProcessAccessSignalling_Arg_an_APDU,
        _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms,
        _ProcessAccessSignalling_Arg_selectedGSM_Algorithm,
        _ProcessAccessSignalling_Arg_chosenRadioResourceInformation,
        _ProcessAccessSignalling_Arg_selectedRab_Id,
        _ProcessAccessSignalling_Arg_extensionContainer,
        _ProcessAccessSignalling_Arg_iUSelectedCodec,
        _ProcessAccessSignalling_Arg_iuAvailableCodecsList,
        _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap,
        ProcessAccessSignalling_Arg,
        _AoIPCodecsList_codec1,
        _AoIPCodecsList_codec2,
        _AoIPCodecsList_codec3,
        _AoIPCodecsList_codec4,
        _AoIPCodecsList_codec5,
        _AoIPCodecsList_codec6,
        _AoIPCodecsList_codec7,
        _AoIPCodecsList_codec8,
        _AoIPCodecsList_extensionContainer,
        AoIPCodecsList,
        AoIPCodec,
        _SupportedCodecsList_utranCodecList,
        _SupportedCodecsList_geranCodecList,
        _SupportedCodecsList_extensionContainer,
        SupportedCodecsList,
        _CodecList_codec1,
        _CodecList_codec2,
        _CodecList_codec3,
        _CodecList_codec4,
        _CodecList_codec5,
        _CodecList_codec6,
        _CodecList_codec7,
        _CodecList_codec8,
        _CodecList_extensionContainer,
        CodecList,
        Codec,
        GERAN_Classmark,
        SelectedGSM_Algorithm,
        _SendEndSignal_Arg_an_APDU,
        _SendEndSignal_Arg_extensionContainer,
        SendEndSignal_Arg,
        _SendEndSignal_Res_extensionContainer,
        SendEndSignal_Res,
        RNCId,
        _RelocationNumberList__item_,
        RelocationNumberList,
        MulticallBearerInfo,
        _RelocationNumber_handoverNumber,
        _RelocationNumber_rab_Id,
        RelocationNumber,
        RAB_Id,
        maxNrOfRABs,
        maxNumOfRelocationNumber,
        RadioResourceInformation,
        IntegrityProtectionInformation,
        maxNumOfIntegrityInfo,
        EncryptionInformation,
        maxNumOfEncryptionInfo,
        _SendAuthenticationInfoArg_imsi,
        _SendAuthenticationInfoArg_numberOfRequestedVectors,
        _SendAuthenticationInfoArg_segmentationProhibited,
        _SendAuthenticationInfoArg_immediateResponsePreferred,
        _SendAuthenticationInfoArg_re_synchronisationInfo,
        _SendAuthenticationInfoArg_extensionContainer,
        _SendAuthenticationInfoArg_requestingNodeType,
        _SendAuthenticationInfoArg_requestingPLMN_Id,
        _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors,
        _SendAuthenticationInfoArg_additionalVectorsAreForEPS,
        _SendAuthenticationInfoArg_ueUsageTypeRequestIndication,
        SendAuthenticationInfoArg,
        NumberOfRequestedVectors,
        _Re_synchronisationInfo_rand,
        _Re_synchronisationInfo_auts,
        Re_synchronisationInfo,
        _SendAuthenticationInfoRes_authenticationSetList,
        _SendAuthenticationInfoRes_extensionContainer,
        _SendAuthenticationInfoRes_eps_AuthenticationSetList,
        _SendAuthenticationInfoRes_ueUsageType,
        SendAuthenticationInfoRes,
        _EPS_AuthenticationSetList__item_,
        EPS_AuthenticationSetList,
        UE_UsageType,
        _EPC_AV_rand,
        _EPC_AV_xres,
        _EPC_AV_autn,
        _EPC_AV_kasme,
        _EPC_AV_extensionContainer,
        EPC_AV,
        KASME,
        RequestingNodeType,
        _CheckIMEI_Arg_imei,
        _CheckIMEI_Arg_requestedEquipmentInfo,
        _CheckIMEI_Arg_extensionContainer,
        CheckIMEI_Arg,
        _CheckIMEI_Res_equipmentStatus,
        _CheckIMEI_Res_bmuef,
        _CheckIMEI_Res_extensionContainer,
        CheckIMEI_Res,
        RequestedEquipmentInfo,
        _UESBI_Iu_uesbi_IuA,
        _UESBI_Iu_uesbi_IuB,
        UESBI_Iu,
        UESBI_IuA,
        UESBI_IuB,
        EquipmentStatus,
        _InsertSubscriberDataArg_imsi,
        _InsertSubscriberDataArg_msisdn,
        _InsertSubscriberDataArg_category,
        _InsertSubscriberDataArg_subscriberStatus,
        _InsertSubscriberDataArg_bearerServiceList,
        _InsertSubscriberDataArg_teleserviceList,
        _InsertSubscriberDataArg_provisionedSS,
        _InsertSubscriberDataArg_odb_Data,
        _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _InsertSubscriberDataArg_regionalSubscriptionData,
        _InsertSubscriberDataArg_vbsSubscriptionData,
        _InsertSubscriberDataArg_vgcsSubscriptionData,
        _InsertSubscriberDataArg_vlrCamelSubscriptionInfo,
        _InsertSubscriberDataArg_extensionContainer,
        _InsertSubscriberDataArg_naea_PreferredCI,
        _InsertSubscriberDataArg_gprsSubscriptionData,
        _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature,
        _InsertSubscriberDataArg_networkAccessMode,
        _InsertSubscriberDataArg_lsaInformation,
        _InsertSubscriberDataArg_lmu_Indicator,
        _InsertSubscriberDataArg_lcsInformation,
        _InsertSubscriberDataArg_istAlertTimer,
        _InsertSubscriberDataArg_superChargerSupportedInHLR,
        _InsertSubscriberDataArg_mc_SS_Info,
        _InsertSubscriberDataArg_cs_AllocationRetentionPriority,
        _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo,
        _InsertSubscriberDataArg_chargingCharacteristics,
        _InsertSubscriberDataArg_accessRestrictionData,
        _InsertSubscriberDataArg_ics_Indicator,
        _InsertSubscriberDataArg_eps_SubscriptionData,
        _InsertSubscriberDataArg_csg_SubscriptionDataList,
        _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator,
        _InsertSubscriberDataArg_sgsn_Number,
        _InsertSubscriberDataArg_mme_Name,
        _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer,
        _InsertSubscriberDataArg_vplmnLIPAAllowed,
        _InsertSubscriberDataArg_mdtUserConsent,
        _InsertSubscriberDataArg_subscribedPeriodicLAUtimer,
        _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList,
        _InsertSubscriberDataArg_additionalMSISDN,
        _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision,
        _InsertSubscriberDataArg_smsInSGSNAllowed,
        _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator,
        _InsertSubscriberDataArg_pcscf_Restoration_Request,
        _InsertSubscriberDataArg_adjacentAccessRestrictionDataList,
        _InsertSubscriberDataArg_imsi_Group_Id_List,
        _InsertSubscriberDataArg_ueUsageType,
        _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator,
        _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count,
        _InsertSubscriberDataArg_reset_Id_List,
        _InsertSubscriberDataArg_eDRX_Cycle_Length_List,
        _InsertSubscriberDataArg_ext_AccessRestrictionData,
        _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator,
        InsertSubscriberDataArg,
        _EDRX_Cycle_Length_List__item_,
        EDRX_Cycle_Length_List,
        _EDRX_Cycle_Length_rat_Type,
        _EDRX_Cycle_Length_eDRX_Cycle_Length_Value,
        EDRX_Cycle_Length,
        EDRX_Cycle_Length_Value,
        _Reset_Id_List__item_,
        Reset_Id_List,
        Reset_Id,
        DL_Buffering_Suggested_Packet_Count,
        Group_Service_ID,
        Local_GroupID,
        _IMSI_GroupIdList__item_,
        IMSI_GroupIdList,
        _IMSI_GroupId_group_Service_Id,
        _IMSI_GroupId_plmnId,
        _IMSI_GroupId_local_Group_ID,
        IMSI_GroupId,
        SubscribedPeriodicRAUTAUtimer,
        SubscribedPeriodicLAUtimer,
        _CSG_SubscriptionDataList__item_,
        CSG_SubscriptionDataList,
        _CSG_SubscriptionData_csg_Id,
        _CSG_SubscriptionData_expirationDate,
        _CSG_SubscriptionData_extensionContainer,
        _CSG_SubscriptionData_lipa_AllowedAPNList,
        _CSG_SubscriptionData_plmn_Id,
        CSG_SubscriptionData,
        _VPLMN_CSG_SubscriptionDataList__item_,
        VPLMN_CSG_SubscriptionDataList,
        CSG_Id,
        _LIPA_AllowedAPNList__item_,
        LIPA_AllowedAPNList,
        maxNumOfLIPAAllowedAPN,
        _EPS_SubscriptionData_apn_oi_Replacement,
        _EPS_SubscriptionData_rfsp_id,
        _EPS_SubscriptionData_ambr,
        _EPS_SubscriptionData_apn_ConfigurationProfile,
        _EPS_SubscriptionData_stn_sr,
        _EPS_SubscriptionData_extensionContainer,
        _EPS_SubscriptionData_mps_CSPriority,
        _EPS_SubscriptionData_mps_EPSPriority,
        _EPS_SubscriptionData_subscribed_vsrvcc,
        EPS_SubscriptionData,
        APN_OI_Replacement,
        RFSP_ID,
        _APN_ConfigurationProfile_defaultContext,
        _APN_ConfigurationProfile_completeDataListIncluded,
        _APN_ConfigurationProfile_epsDataList,
        _APN_ConfigurationProfile_extensionContainer,
        _APN_ConfigurationProfile_additionalDefaultContext,
        APN_ConfigurationProfile,
        _EPS_DataList__item_,
        EPS_DataList,
        maxNumOfAPN_Configurations,
        _APN_Configuration_contextId,
        _APN_Configuration_pdn_Type,
        _APN_Configuration_servedPartyIP_IPv4_Address,
        _APN_Configuration_apn,
        _APN_Configuration_eps_qos_Subscribed,
        _APN_Configuration_pdn_gw_Identity,
        _APN_Configuration_pdn_gw_AllocationType,
        _APN_Configuration_vplmnAddressAllowed,
        _APN_Configuration_chargingCharacteristics,
        _APN_Configuration_ambr,
        _APN_Configuration_specificAPNInfoList,
        _APN_Configuration_extensionContainer,
        _APN_Configuration_servedPartyIP_IPv6_Address,
        _APN_Configuration_apn_oi_Replacement,
        _APN_Configuration_sipto_Permission,
        _APN_Configuration_lipa_Permission,
        _APN_Configuration_restoration_Priority,
        _APN_Configuration_sipto_local_network_Permission,
        _APN_Configuration_wlan_offloadability,
        _APN_Configuration_non_IP_PDN_Type_Indicator,
        _APN_Configuration_nIDD_Mechanism,
        _APN_Configuration_sCEF_ID,
        _APN_Configuration_pdn_ConnectionContinuity,
        APN_Configuration,
        PDN_ConnectionContinuity,
        NIDD_Mechanism,
        PDN_Type,
        _EPS_QoS_Subscribed_qos_Class_Identifier,
        _EPS_QoS_Subscribed_allocation_Retention_Priority,
        _EPS_QoS_Subscribed_extensionContainer,
        EPS_QoS_Subscribed,
        _AMBR_max_RequestedBandwidth_UL,
        _AMBR_max_RequestedBandwidth_DL,
        _AMBR_extensionContainer,
        _AMBR_extended_Max_RequestedBandwidth_UL,
        _AMBR_extended_Max_RequestedBandwidth_DL,
        AMBR,
        _SpecificAPNInfoList__item_,
        SpecificAPNInfoList,
        maxNumOfSpecificAPNInfos,
        _SpecificAPNInfo_apn,
        _SpecificAPNInfo_pdn_gw_Identity,
        _SpecificAPNInfo_extensionContainer,
        SpecificAPNInfo,
        Bandwidth,
        BandwidthExt,
        QoS_Class_Identifier,
        _Allocation_Retention_Priority_priority_level,
        _Allocation_Retention_Priority_pre_emption_capability,
        _Allocation_Retention_Priority_pre_emption_vulnerability,
        _Allocation_Retention_Priority_extensionContainer,
        Allocation_Retention_Priority,
        _PDN_GW_Identity_pdn_gw_ipv4_Address,
        _PDN_GW_Identity_pdn_gw_ipv6_Address,
        _PDN_GW_Identity_pdn_gw_name,
        _PDN_GW_Identity_extensionContainer,
        PDN_GW_Identity,
        FQDN,
        PDN_GW_AllocationType,
        _WLAN_Offloadability_wlan_offloadability_EUTRAN,
        _WLAN_Offloadability_wlan_offloadability_UTRAN,
        _WLAN_Offloadability_extensionContainer,
        WLAN_Offloadability,
        WLAN_Offloadability_Indication,
        AccessRestrictionData,
        Ext_AccessRestrictionData,
        _AdjacentAccessRestrictionDataList__item_,
        AdjacentAccessRestrictionDataList,
        _AdjacentAccessRestrictionData_plmnId,
        _AdjacentAccessRestrictionData_accessRestrictionData,
        _AdjacentAccessRestrictionData_ext_AccessRestrictionData,
        AdjacentAccessRestrictionData,
        CS_AllocationRetentionPriority,
        IST_AlertTimerValue,
        _LCSInformation_gmlc_List,
        _LCSInformation_lcs_PrivacyExceptionList,
        _LCSInformation_molr_List,
        _LCSInformation_add_lcs_PrivacyExceptionList,
        LCSInformation,
        _GMLC_List__item_,
        GMLC_List,
        maxNumOfGMLC,
        NetworkAccessMode,
        _GPRSDataList__item_,
        GPRSDataList,
        maxNumOfPDP_Contexts,
        _PDP_Context_pdp_ContextId,
        _PDP_Context_pdp_Type,
        _PDP_Context_pdp_Address,
        _PDP_Context_qos_Subscribed,
        _PDP_Context_vplmnAddressAllowed,
        _PDP_Context_apn,
        _PDP_Context_extensionContainer,
        _PDP_Context_ext_QoS_Subscribed,
        _PDP_Context_pdp_ChargingCharacteristics,
        _PDP_Context_ext2_QoS_Subscribed,
        _PDP_Context_ext3_QoS_Subscribed,
        _PDP_Context_ext4_QoS_Subscribed,
        _PDP_Context_apn_oi_Replacement,
        _PDP_Context_ext_pdp_Type,
        _PDP_Context_ext_pdp_Address,
        _PDP_Context_ambr,
        _PDP_Context_sipto_Permission,
        _PDP_Context_lipa_Permission,
        _PDP_Context_restoration_Priority,
        _PDP_Context_sipto_local_network_Permission,
        _PDP_Context_nIDD_Mechanism,
        _PDP_Context_sCEF_ID,
        PDP_Context,
        Restoration_Priority,
        SIPTO_Permission,
        SIPTO_Local_Network_Permission,
        LIPA_Permission,
        ContextId,
        _GPRSSubscriptionData_completeDataListIncluded,
        _GPRSSubscriptionData_gprsDataList,
        _GPRSSubscriptionData_extensionContainer,
        _GPRSSubscriptionData_apn_oi_Replacement,
        GPRSSubscriptionData,
        _SGSN_CAMEL_SubscriptionInfo_gprs_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_extensionContainer,
        _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _SGSN_CAMEL_SubscriptionInfo_mg_csi,
        SGSN_CAMEL_SubscriptionInfo,
        _GPRS_CSI_gprs_CamelTDPDataList,
        _GPRS_CSI_camelCapabilityHandling,
        _GPRS_CSI_extensionContainer,
        _GPRS_CSI_notificationToCSE,
        _GPRS_CSI_csi_Active,
        GPRS_CSI,
        _GPRS_CamelTDPDataList__item_,
        GPRS_CamelTDPDataList,
        _GPRS_CamelTDPData_gprs_TriggerDetectionPoint,
        _GPRS_CamelTDPData_serviceKey,
        _GPRS_CamelTDPData_gsmSCF_Address,
        _GPRS_CamelTDPData_defaultSessionHandling,
        _GPRS_CamelTDPData_extensionContainer,
        GPRS_CamelTDPData,
        DefaultGPRS_Handling,
        GPRS_TriggerDetectionPoint,
        APN,
        PDP_Type,
        Ext_PDP_Type,
        PDP_Address,
        QoS_Subscribed,
        Ext_QoS_Subscribed,
        Ext2_QoS_Subscribed,
        Ext3_QoS_Subscribed,
        Ext4_QoS_Subscribed,
        ChargingCharacteristics,
        LSAOnlyAccessIndicator,
        _LSADataList__item_,
        LSADataList,
        maxNumOfLSAs,
        _LSAData_lsaIdentity,
        _LSAData_lsaAttributes,
        _LSAData_lsaActiveModeIndicator,
        _LSAData_extensionContainer,
        LSAData,
        _LSAInformation_completeDataListIncluded,
        _LSAInformation_lsaOnlyAccessIndicator,
        _LSAInformation_lsaDataList,
        _LSAInformation_extensionContainer,
        LSAInformation,
        LSAIdentity,
        LSAAttributes,
        _SubscriberData_msisdn,
        _SubscriberData_category,
        _SubscriberData_subscriberStatus,
        _SubscriberData_bearerServiceList,
        _SubscriberData_teleserviceList,
        _SubscriberData_provisionedSS,
        _SubscriberData_odb_Data,
        _SubscriberData_roamingRestrictionDueToUnsupportedFeature,
        _SubscriberData_regionalSubscriptionData,
        _SubscriberData_vbsSubscriptionData,
        _SubscriberData_vgcsSubscriptionData,
        _SubscriberData_vlrCamelSubscriptionInfo,
        SubscriberData,
        Category,
        SubscriberStatus,
        _BearerServiceList__item_,
        BearerServiceList,
        maxNumOfBearerServices,
        _TeleserviceList__item_,
        TeleserviceList,
        maxNumOfTeleservices,
        _ODB_Data_odb_GeneralData,
        _ODB_Data_odb_HPLMN_Data,
        _ODB_Data_extensionContainer,
        ODB_Data,
        ODB_GeneralData,
        ODB_HPLMN_Data,
        _Ext_SS_InfoList__item_,
        Ext_SS_InfoList,
        _Ext_SS_Info_forwardingInfo,
        _Ext_SS_Info_callBarringInfo,
        _Ext_SS_Info_cug_Info,
        _Ext_SS_Info_ss_Data,
        _Ext_SS_Info_emlpp_Info,
        Ext_SS_Info,
        _Ext_ForwInfo_ss_Code,
        _Ext_ForwInfo_forwardingFeatureList,
        _Ext_ForwInfo_extensionContainer,
        Ext_ForwInfo,
        _Ext_ForwFeatureList__item_,
        Ext_ForwFeatureList,
        _Ext_ForwFeature_basicService,
        _Ext_ForwFeature_ss_Status,
        _Ext_ForwFeature_forwardedToNumber,
        _Ext_ForwFeature_forwardedToSubaddress,
        _Ext_ForwFeature_forwardingOptions,
        _Ext_ForwFeature_noReplyConditionTime,
        _Ext_ForwFeature_extensionContainer,
        _Ext_ForwFeature_longForwardedToNumber,
        Ext_ForwFeature,
        Ext_ForwOptions,
        Ext_NoRepCondTime,
        _Ext_CallBarInfo_ss_Code,
        _Ext_CallBarInfo_callBarringFeatureList,
        _Ext_CallBarInfo_extensionContainer,
        Ext_CallBarInfo,
        _Ext_CallBarFeatureList__item_,
        Ext_CallBarFeatureList,
        _Ext_CallBarringFeature_basicService,
        _Ext_CallBarringFeature_ss_Status,
        _Ext_CallBarringFeature_extensionContainer,
        Ext_CallBarringFeature,
        _CUG_Info_cug_SubscriptionList,
        _CUG_Info_cug_FeatureList,
        _CUG_Info_extensionContainer,
        CUG_Info,
        _CUG_SubscriptionList__item_,
        CUG_SubscriptionList,
        _CUG_Subscription_cug_Index,
        _CUG_Subscription_cug_Interlock,
        _CUG_Subscription_intraCUG_Options,
        _CUG_Subscription_basicServiceGroupList,
        _CUG_Subscription_extensionContainer,
        CUG_Subscription,
        CUG_Index,
        CUG_Interlock,
        IntraCUG_Options,
        maxNumOfCUG,
        _CUG_FeatureList__item_,
        CUG_FeatureList,
        _Ext_BasicServiceGroupList__item_,
        Ext_BasicServiceGroupList,
        maxNumOfExt_BasicServiceGroups,
        _CUG_Feature_basicService,
        _CUG_Feature_preferentialCUG_Indicator,
        _CUG_Feature_interCUG_Restrictions,
        _CUG_Feature_extensionContainer,
        CUG_Feature,
        InterCUG_Restrictions,
        _Ext_SS_Data_ss_Code,
        _Ext_SS_Data_ss_Status,
        _Ext_SS_Data_ss_SubscriptionOption,
        _Ext_SS_Data_basicServiceGroupList,
        _Ext_SS_Data_extensionContainer,
        Ext_SS_Data,
        _LCS_PrivacyExceptionList__item_,
        LCS_PrivacyExceptionList,
        maxNumOfPrivacyClass,
        _LCS_PrivacyClass_ss_Code,
        _LCS_PrivacyClass_ss_Status,
        _LCS_PrivacyClass_notificationToMSUser,
        _LCS_PrivacyClass_externalClientList,
        _LCS_PrivacyClass_plmnClientList,
        _LCS_PrivacyClass_extensionContainer,
        _LCS_PrivacyClass_ext_externalClientList,
        _LCS_PrivacyClass_serviceTypeList,
        LCS_PrivacyClass,
        _ExternalClientList__item_,
        ExternalClientList,
        maxNumOfExternalClient,
        _PLMNClientList__item_,
        PLMNClientList,
        maxNumOfPLMNClient,
        _Ext_ExternalClientList__item_,
        Ext_ExternalClientList,
        maxNumOfExt_ExternalClient,
        _ExternalClient_clientIdentity,
        _ExternalClient_gmlc_Restriction,
        _ExternalClient_notificationToMSUser,
        _ExternalClient_extensionContainer,
        ExternalClient,
        GMLC_Restriction,
        NotificationToMSUser,
        _ServiceTypeList__item_,
        ServiceTypeList,
        maxNumOfServiceType,
        _ServiceType_serviceTypeIdentity,
        _ServiceType_gmlc_Restriction,
        _ServiceType_notificationToMSUser,
        _ServiceType_extensionContainer,
        ServiceType,
        _MOLR_List__item_,
        MOLR_List,
        maxNumOfMOLR_Class,
        _MOLR_Class_ss_Code,
        _MOLR_Class_ss_Status,
        _MOLR_Class_extensionContainer,
        MOLR_Class,
        _ZoneCodeList__item_,
        ZoneCodeList,
        ZoneCode,
        maxNumOfZoneCodes,
        _InsertSubscriberDataRes_teleserviceList,
        _InsertSubscriberDataRes_bearerServiceList,
        _InsertSubscriberDataRes_ss_List,
        _InsertSubscriberDataRes_odb_GeneralData,
        _InsertSubscriberDataRes_regionalSubscriptionResponse,
        _InsertSubscriberDataRes_supportedCamelPhases,
        _InsertSubscriberDataRes_extensionContainer,
        _InsertSubscriberDataRes_offeredCamel4CSIs,
        _InsertSubscriberDataRes_supportedFeatures,
        _InsertSubscriberDataRes_ext_SupportedFeatures,
        InsertSubscriberDataRes,
        RegionalSubscriptionResponse,
        _DeleteSubscriberDataArg_imsi,
        _DeleteSubscriberDataArg_basicServiceList,
        _DeleteSubscriberDataArg_ss_List,
        _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _DeleteSubscriberDataArg_regionalSubscriptionIdentifier,
        _DeleteSubscriberDataArg_vbsGroupIndication,
        _DeleteSubscriberDataArg_vgcsGroupIndication,
        _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw,
        _DeleteSubscriberDataArg_extensionContainer,
        _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature,
        _DeleteSubscriberDataArg_lsaInformationWithdraw,
        _DeleteSubscriberDataArg_gmlc_ListWithdraw,
        _DeleteSubscriberDataArg_istInformationWithdraw,
        _DeleteSubscriberDataArg_specificCSI_Withdraw,
        _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw,
        _DeleteSubscriberDataArg_stn_srWithdraw,
        _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_apn_oi_replacementWithdraw,
        _DeleteSubscriberDataArg_csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw,
        _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_additionalMSISDN_Withdraw,
        _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw,
        _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw,
        _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw,
        _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw,
        _DeleteSubscriberDataArg_ue_UsageTypeWithdraw,
        _DeleteSubscriberDataArg_reset_idsWithdraw,
        _DeleteSubscriberDataArg_iab_OperationWithdraw,
        DeleteSubscriberDataArg,
        SpecificCSI_Withdraw,
        _GPRSSubscriptionDataWithdraw_allGPRSData,
        _GPRSSubscriptionDataWithdraw_contextIdList,
        GPRSSubscriptionDataWithdraw,
        _EPS_SubscriptionDataWithdraw_allEPS_Data,
        _EPS_SubscriptionDataWithdraw_contextIdList,
        EPS_SubscriptionDataWithdraw,
        _ContextIdList__item_,
        ContextIdList,
        _LSAInformationWithdraw_allLSAData,
        _LSAInformationWithdraw_lsaIdentityList,
        LSAInformationWithdraw,
        _LSAIdentityList__item_,
        LSAIdentityList,
        _BasicServiceList__item_,
        BasicServiceList,
        maxNumOfBasicServices,
        _DeleteSubscriberDataRes_regionalSubscriptionResponse,
        _DeleteSubscriberDataRes_extensionContainer,
        DeleteSubscriberDataRes,
        _VlrCamelSubscriptionInfo_o_CSI,
        _VlrCamelSubscriptionInfo_extensionContainer,
        _VlrCamelSubscriptionInfo_ss_CSI,
        _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _VlrCamelSubscriptionInfo_tif_CSI,
        _VlrCamelSubscriptionInfo_m_CSI,
        _VlrCamelSubscriptionInfo_mo_sms_CSI,
        _VlrCamelSubscriptionInfo_vt_CSI,
        _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _VlrCamelSubscriptionInfo_d_CSI,
        _VlrCamelSubscriptionInfo_mt_sms_CSI,
        _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        VlrCamelSubscriptionInfo,
        _MT_smsCAMELTDP_CriteriaList__item_,
        MT_smsCAMELTDP_CriteriaList,
        _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint,
        _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion,
        MT_smsCAMELTDP_Criteria,
        _TPDU_TypeCriterion__item_,
        TPDU_TypeCriterion,
        maxNumOfTPDUTypes,
        MT_SMS_TPDU_Type,
        _D_CSI_dp_AnalysedInfoCriteriaList,
        _D_CSI_camelCapabilityHandling,
        _D_CSI_extensionContainer,
        _D_CSI_notificationToCSE,
        _D_CSI_csi_Active,
        D_CSI,
        _DP_AnalysedInfoCriteriaList__item_,
        DP_AnalysedInfoCriteriaList,
        maxNumOfDP_AnalysedInfoCriteria,
        _DP_AnalysedInfoCriterium_dialledNumber,
        _DP_AnalysedInfoCriterium_serviceKey,
        _DP_AnalysedInfoCriterium_gsmSCF_Address,
        _DP_AnalysedInfoCriterium_defaultCallHandling,
        _DP_AnalysedInfoCriterium_extensionContainer,
        DP_AnalysedInfoCriterium,
        _SS_CSI_ss_CamelData,
        _SS_CSI_extensionContainer,
        _SS_CSI_notificationToCSE,
        _SS_CSI_csi_Active,
        SS_CSI,
        _SS_CamelData_ss_EventList,
        _SS_CamelData_gsmSCF_Address,
        _SS_CamelData_extensionContainer,
        SS_CamelData,
        _SS_EventList__item_,
        SS_EventList,
        maxNumOfCamelSSEvents,
        _O_CSI_o_BcsmCamelTDPDataList,
        _O_CSI_extensionContainer,
        _O_CSI_camelCapabilityHandling,
        _O_CSI_notificationToCSE,
        _O_CSI_csiActive,
        O_CSI,
        _O_BcsmCamelTDPDataList__item_,
        O_BcsmCamelTDPDataList,
        maxNumOfCamelTDPData,
        _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPData_serviceKey,
        _O_BcsmCamelTDPData_gsmSCF_Address,
        _O_BcsmCamelTDPData_defaultCallHandling,
        _O_BcsmCamelTDPData_extensionContainer,
        O_BcsmCamelTDPData,
        ServiceKey,
        O_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPCriteriaList__item_,
        O_BcsmCamelTDPCriteriaList,
        _T_BCSM_CAMEL_TDP_CriteriaList__item_,
        T_BCSM_CAMEL_TDP_CriteriaList,
        _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDP_Criteria_destinationNumberCriteria,
        _O_BcsmCamelTDP_Criteria_basicServiceCriteria,
        _O_BcsmCamelTDP_Criteria_callTypeCriteria,
        _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria,
        _O_BcsmCamelTDP_Criteria_extensionContainer,
        O_BcsmCamelTDP_Criteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint,
        _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria,
        T_BCSM_CAMEL_TDP_Criteria,
        _DestinationNumberCriteria_matchType,
        _DestinationNumberCriteria_destinationNumberList,
        _DestinationNumberCriteria_destinationNumberLengthList,
        DestinationNumberCriteria,
        _DestinationNumberList__item_,
        DestinationNumberList,
        _DestinationNumberLengthList__item_,
        DestinationNumberLengthList,
        _BasicServiceCriteria__item_,
        BasicServiceCriteria,
        maxNumOfISDN_AddressDigits,
        maxNumOfCamelDestinationNumbers,
        maxNumOfCamelDestinationNumberLengths,
        maxNumOfCamelBasicServiceCriteria,
        CallTypeCriteria,
        MatchType,
        _O_CauseValueCriteria__item_,
        O_CauseValueCriteria,
        _T_CauseValueCriteria__item_,
        T_CauseValueCriteria,
        maxNumOfCAMEL_O_CauseValueCriteria,
        maxNumOfCAMEL_T_CauseValueCriteria,
        CauseValue,
        DefaultCallHandling,
        CamelCapabilityHandling,
        SupportedCamelPhases,
        OfferedCamel4CSIs,
        OfferedCamel4Functionalities,
        _SMS_CSI_sms_CAMEL_TDP_DataList,
        _SMS_CSI_camelCapabilityHandling,
        _SMS_CSI_extensionContainer,
        _SMS_CSI_notificationToCSE,
        _SMS_CSI_csi_Active,
        SMS_CSI,
        _SMS_CAMEL_TDP_DataList__item_,
        SMS_CAMEL_TDP_DataList,
        _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint,
        _SMS_CAMEL_TDP_Data_serviceKey,
        _SMS_CAMEL_TDP_Data_gsmSCF_Address,
        _SMS_CAMEL_TDP_Data_defaultSMS_Handling,
        _SMS_CAMEL_TDP_Data_extensionContainer,
        SMS_CAMEL_TDP_Data,
        SMS_TriggerDetectionPoint,
        DefaultSMS_Handling,
        _M_CSI_mobilityTriggers,
        _M_CSI_serviceKey,
        _M_CSI_gsmSCF_Address,
        _M_CSI_extensionContainer,
        _M_CSI_notificationToCSE,
        _M_CSI_csi_Active,
        M_CSI,
        _MG_CSI_mobilityTriggers,
        _MG_CSI_serviceKey,
        _MG_CSI_gsmSCF_Address,
        _MG_CSI_extensionContainer,
        _MG_CSI_notificationToCSE,
        _MG_CSI_csi_Active,
        MG_CSI,
        _MobilityTriggers__item_,
        MobilityTriggers,
        maxNumOfMobilityTriggers,
        MM_Code,
        _T_CSI_t_BcsmCamelTDPDataList,
        _T_CSI_extensionContainer,
        _T_CSI_camelCapabilityHandling,
        _T_CSI_notificationToCSE,
        _T_CSI_csi_Active,
        T_CSI,
        _T_BcsmCamelTDPDataList__item_,
        T_BcsmCamelTDPDataList,
        _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint,
        _T_BcsmCamelTDPData_serviceKey,
        _T_BcsmCamelTDPData_gsmSCF_Address,
        _T_BcsmCamelTDPData_defaultCallHandling,
        _T_BcsmCamelTDPData_extensionContainer,
        T_BcsmCamelTDPData,
        T_BcsmTriggerDetectionPoint,
        _SendRoutingInfoForGprsArg_imsi,
        _SendRoutingInfoForGprsArg_ggsn_Address,
        _SendRoutingInfoForGprsArg_ggsn_Number,
        _SendRoutingInfoForGprsArg_extensionContainer,
        SendRoutingInfoForGprsArg,
        _SendRoutingInfoForGprsRes_sgsn_Address,
        _SendRoutingInfoForGprsRes_ggsn_Address,
        _SendRoutingInfoForGprsRes_mobileNotReachableReason,
        _SendRoutingInfoForGprsRes_extensionContainer,
        SendRoutingInfoForGprsRes,
        _FailureReportArg_imsi,
        _FailureReportArg_ggsn_Number,
        _FailureReportArg_ggsn_Address,
        _FailureReportArg_extensionContainer,
        FailureReportArg,
        _FailureReportRes_ggsn_Address,
        _FailureReportRes_extensionContainer,
        FailureReportRes,
        _NoteMsPresentForGprsArg_imsi,
        _NoteMsPresentForGprsArg_sgsn_Address,
        _NoteMsPresentForGprsArg_ggsn_Address,
        _NoteMsPresentForGprsArg_extensionContainer,
        NoteMsPresentForGprsArg,
        _NoteMsPresentForGprsRes_extensionContainer,
        NoteMsPresentForGprsRes,
        _ResetArg_sendingNodenumber,
        _ResetArg_hlr_List,
        _ResetArg_extensionContainer,
        _ResetArg_reset_Id_List,
        _ResetArg_subscriptionData,
        _ResetArg_subscriptionDataDeletion,
        ResetArg,
        _SendingNode_Number_hlr_Number,
        _SendingNode_Number_css_Number,
        SendingNode_Number,
        _RestoreDataArg_imsi,
        _RestoreDataArg_lmsi,
        _RestoreDataArg_extensionContainer,
        _RestoreDataArg_vlr_Capability,
        _RestoreDataArg_restorationIndicator,
        RestoreDataArg,
        _RestoreDataRes_hlr_Number,
        _RestoreDataRes_msNotReachable,
        _RestoreDataRes_extensionContainer,
        RestoreDataRes,
        _VBSDataList__item_,
        VBSDataList,
        _VGCSDataList__item_,
        VGCSDataList,
        maxNumOfVBSGroupIds,
        maxNumOfVGCSGroupIds,
        _VoiceGroupCallData_groupId,
        _VoiceGroupCallData_extensionContainer,
        _VoiceGroupCallData_additionalSubscriptions,
        _VoiceGroupCallData_additionalInfo,
        _VoiceGroupCallData_longGroupId,
        VoiceGroupCallData,
        AdditionalInfo,
        AdditionalSubscriptions,
        _VoiceBroadcastData_groupid,
        _VoiceBroadcastData_broadcastInitEntitlement,
        _VoiceBroadcastData_extensionContainer,
        _VoiceBroadcastData_longGroupId,
        VoiceBroadcastData,
        GroupId,
        Long_GroupId,
        _ProvideSubscriberInfoArg_imsi,
        _ProvideSubscriberInfoArg_lmsi,
        _ProvideSubscriberInfoArg_requestedInfo,
        _ProvideSubscriberInfoArg_extensionContainer,
        _ProvideSubscriberInfoArg_callPriority,
        ProvideSubscriberInfoArg,
        _ProvideSubscriberInfoRes_subscriberInfo,
        _ProvideSubscriberInfoRes_extensionContainer,
        ProvideSubscriberInfoRes,
        _SubscriberInfo_locationInformation,
        _SubscriberInfo_subscriberState,
        _SubscriberInfo_extensionContainer,
        _SubscriberInfo_locationInformationGPRS,
        _SubscriberInfo_ps_SubscriberState,
        _SubscriberInfo_imei,
        _SubscriberInfo_ms_Classmark2,
        _SubscriberInfo_gprs_MS_Class,
        _SubscriberInfo_mnpInfoRes,
        _SubscriberInfo_imsVoiceOverPS_SessionsIndication,
        _SubscriberInfo_lastUE_ActivityTime,
        _SubscriberInfo_lastRAT_Type,
        _SubscriberInfo_eps_SubscriberState,
        _SubscriberInfo_locationInformationEPS,
        _SubscriberInfo_timeZone,
        _SubscriberInfo_daylightSavingTime,
        _SubscriberInfo_locationInformation5GS,
        SubscriberInfo,
        IMS_VoiceOverPS_SessionsInd,
        TimeZone,
        DaylightSavingTime,
        _MNPInfoRes_routeingNumber,
        _MNPInfoRes_imsi,
        _MNPInfoRes_msisdn,
        _MNPInfoRes_numberPortabilityStatus,
        _MNPInfoRes_extensionContainer,
        MNPInfoRes,
        RouteingNumber,
        NumberPortabilityStatus,
        MS_Classmark2,
        _GPRSMSClass_mSNetworkCapability,
        _GPRSMSClass_mSRadioAccessCapability,
        GPRSMSClass,
        MSNetworkCapability,
        MSRadioAccessCapability,
        _RequestedInfo_locationInformation,
        _RequestedInfo_subscriberState,
        _RequestedInfo_extensionContainer,
        _RequestedInfo_currentLocation,
        _RequestedInfo_requestedDomain,
        _RequestedInfo_imei,
        _RequestedInfo_ms_classmark,
        _RequestedInfo_mnpRequestedInfo,
        _RequestedInfo_locationInformationEPS_Supported,
        _RequestedInfo_t_adsData,
        _RequestedInfo_requestedNodes,
        _RequestedInfo_servingNodeIndication,
        _RequestedInfo_localTimeZoneRequest,
        RequestedInfo,
        DomainType,
        RequestedNodes,
        _LocationInformation_ageOfLocationInformation,
        _LocationInformation_geographicalInformation,
        _LocationInformation_vlr_number,
        _LocationInformation_locationNumber,
        _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformation_extensionContainer,
        _LocationInformation_selectedLSA_Id,
        _LocationInformation_msc_Number,
        _LocationInformation_geodeticInformation,
        _LocationInformation_currentLocationRetrieved,
        _LocationInformation_sai_Present,
        _LocationInformation_locationInformationEPS,
        _LocationInformation_userCSGInformation,
        LocationInformation,
        _LocationInformationEPS_e_utranCellGlobalIdentity,
        _LocationInformationEPS_trackingAreaIdentity,
        _LocationInformationEPS_extensionContainer,
        _LocationInformationEPS_geographicalInformation,
        _LocationInformationEPS_geodeticInformation,
        _LocationInformationEPS_currentLocationRetrieved,
        _LocationInformationEPS_ageOfLocationInformation,
        _LocationInformationEPS_mme_Name,
        LocationInformationEPS,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_geodeticInformation,
        _LocationInformationGPRS_currentLocationRetrieved,
        _LocationInformationGPRS_ageOfLocationInformation,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _LocationInformation5GS_nrCellGlobalIdentity,
        _LocationInformation5GS_e_utranCellGlobalIdentity,
        _LocationInformation5GS_geographicalInformation,
        _LocationInformation5GS_geodeticInformation,
        _LocationInformation5GS_amf_address,
        _LocationInformation5GS_trackingAreaIdentity,
        _LocationInformation5GS_currentLocationRetrieved,
        _LocationInformation5GS_ageOfLocationInformation,
        _LocationInformation5GS_vplmnId,
        _LocationInformation5GS_localtimeZone,
        _LocationInformation5GS_rat_Type,
        _LocationInformation5GS_extensionContainer,
        _LocationInformation5GS_nrTrackingAreaIdentity,
        LocationInformation5GS,
        _UserCSGInformation_csg_Id,
        _UserCSGInformation_extensionContainer,
        _UserCSGInformation_accessMode,
        _UserCSGInformation_cmi,
        UserCSGInformation,
        GeographicalInformation,
        GeodeticInformation,
        LocationNumber,
        _SubscriberState_assumedIdle,
        _SubscriberState_camelBusy,
        _SubscriberState_netDetNotReachable,
        _SubscriberState_notProvidedFromVLR,
        SubscriberState,
        _PS_SubscriberState_notProvidedFromSGSNorMME,
        _PS_SubscriberState_ps_Detached,
        _PS_SubscriberState_ps_AttachedNotReachableForPaging,
        _PS_SubscriberState_ps_AttachedReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveReachableForPaging,
        _PS_SubscriberState_netDetNotReachable,
        PS_SubscriberState,
        _PDP_ContextInfoList__item_,
        PDP_ContextInfoList,
        _PDP_ContextInfo_pdp_ContextIdentifier,
        _PDP_ContextInfo_pdp_ContextActive,
        _PDP_ContextInfo_pdp_Type,
        _PDP_ContextInfo_pdp_Address,
        _PDP_ContextInfo_apn_Subscribed,
        _PDP_ContextInfo_apn_InUse,
        _PDP_ContextInfo_nsapi,
        _PDP_ContextInfo_transactionId,
        _PDP_ContextInfo_teid_ForGnAndGp,
        _PDP_ContextInfo_teid_ForIu,
        _PDP_ContextInfo_ggsn_Address,
        _PDP_ContextInfo_qos_Subscribed,
        _PDP_ContextInfo_qos_Requested,
        _PDP_ContextInfo_qos_Negotiated,
        _PDP_ContextInfo_chargingId,
        _PDP_ContextInfo_chargingCharacteristics,
        _PDP_ContextInfo_rnc_Address,
        _PDP_ContextInfo_extensionContainer,
        _PDP_ContextInfo_qos2_Subscribed,
        _PDP_ContextInfo_qos2_Requested,
        _PDP_ContextInfo_qos2_Negotiated,
        _PDP_ContextInfo_qos3_Subscribed,
        _PDP_ContextInfo_qos3_Requested,
        _PDP_ContextInfo_qos3_Negotiated,
        _PDP_ContextInfo_qos4_Subscribed,
        _PDP_ContextInfo_qos4_Requested,
        _PDP_ContextInfo_qos4_Negotiated,
        _PDP_ContextInfo_ext_pdp_Type,
        _PDP_ContextInfo_ext_pdp_Address,
        PDP_ContextInfo,
        NSAPI,
        TransactionId,
        TEID,
        GPRSChargingID,
        NotReachableReason,
        _AnyTimeInterrogationArg_subscriberIdentity,
        _AnyTimeInterrogationArg_requestedInfo,
        _AnyTimeInterrogationArg_gsmSCF_Address,
        _AnyTimeInterrogationArg_extensionContainer,
        AnyTimeInterrogationArg,
        _AnyTimeInterrogationRes_subscriberInfo,
        _AnyTimeInterrogationRes_extensionContainer,
        AnyTimeInterrogationRes,
        _AnyTimeSubscriptionInterrogationArg_subscriberIdentity,
        _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo,
        _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address,
        _AnyTimeSubscriptionInterrogationArg_extensionContainer,
        _AnyTimeSubscriptionInterrogationArg_longFTN_Supported,
        AnyTimeSubscriptionInterrogationArg,
        _AnyTimeSubscriptionInterrogationRes_callForwardingData,
        _AnyTimeSubscriptionInterrogationRes_callBarringData,
        _AnyTimeSubscriptionInterrogationRes_odb_Info,
        _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo,
        _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_extensionContainer,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN,
        _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List,
        _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList,
        _AnyTimeSubscriptionInterrogationRes_cw_Data,
        _AnyTimeSubscriptionInterrogationRes_ch_Data,
        _AnyTimeSubscriptionInterrogationRes_clip_Data,
        _AnyTimeSubscriptionInterrogationRes_clir_Data,
        _AnyTimeSubscriptionInterrogationRes_ect_data,
        AnyTimeSubscriptionInterrogationRes,
        _CallWaitingData_cwFeatureList,
        _CallWaitingData_notificationToCSE,
        CallWaitingData,
        _Ext_CwFeatureList__item_,
        Ext_CwFeatureList,
        _Ext_CwFeature_basicService,
        _Ext_CwFeature_ss_Status,
        Ext_CwFeature,
        _ClipData_ss_Status,
        _ClipData_overrideCategory,
        _ClipData_notificationToCSE,
        ClipData,
        _ClirData_ss_Status,
        _ClirData_cliRestrictionOption,
        _ClirData_notificationToCSE,
        ClirData,
        _CallHoldData_ss_Status,
        _CallHoldData_notificationToCSE,
        CallHoldData,
        _EctData_ss_Status,
        _EctData_notificationToCSE,
        EctData,
        _RequestedSubscriptionInfo_requestedSS_Info,
        _RequestedSubscriptionInfo_odb,
        _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases,
        _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases,
        _RequestedSubscriptionInfo_extensionContainer,
        _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_msisdn_BS_List,
        _RequestedSubscriptionInfo_csg_SubscriptionDataRequested,
        _RequestedSubscriptionInfo_cw_Info,
        _RequestedSubscriptionInfo_clip_Info,
        _RequestedSubscriptionInfo_clir_Info,
        _RequestedSubscriptionInfo_hold_Info,
        _RequestedSubscriptionInfo_ect_Info,
        RequestedSubscriptionInfo,
        _MSISDN_BS_List__item_,
        MSISDN_BS_List,
        maxNumOfMSISDN,
        _MSISDN_BS_msisdn,
        _MSISDN_BS_basicServiceList,
        _MSISDN_BS_extensionContainer,
        MSISDN_BS,
        RequestedCAMEL_SubscriptionInfo,
        AdditionalRequestedCAMEL_SubscriptionInfo,
        _CallForwardingData_forwardingFeatureList,
        _CallForwardingData_notificationToCSE,
        _CallForwardingData_extensionContainer,
        CallForwardingData,
        _CallBarringData_callBarringFeatureList,
        _CallBarringData_password,
        _CallBarringData_wrongPasswordAttemptsCounter,
        _CallBarringData_notificationToCSE,
        _CallBarringData_extensionContainer,
        CallBarringData,
        WrongPasswordAttemptsCounter,
        _ODB_Info_odb_Data,
        _ODB_Info_notificationToCSE,
        _ODB_Info_extensionContainer,
        ODB_Info,
        _CAMEL_SubscriptionInfo_o_CSI,
        _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_CSI,
        _CAMEL_SubscriptionInfo_t_CSI,
        _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_vt_CSI,
        _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_tif_CSI,
        _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE,
        _CAMEL_SubscriptionInfo_gprs_CSI,
        _CAMEL_SubscriptionInfo_mo_sms_CSI,
        _CAMEL_SubscriptionInfo_ss_CSI,
        _CAMEL_SubscriptionInfo_m_CSI,
        _CAMEL_SubscriptionInfo_extensionContainer,
        _CAMEL_SubscriptionInfo_specificCSIDeletedList,
        _CAMEL_SubscriptionInfo_mt_sms_CSI,
        _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_mg_csi,
        _CAMEL_SubscriptionInfo_o_IM_CSI,
        _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList,
        CAMEL_SubscriptionInfo,
        _AnyTimeModificationArg_subscriberIdentity,
        _AnyTimeModificationArg_gsmSCF_Address,
        _AnyTimeModificationArg_modificationRequestFor_CF_Info,
        _AnyTimeModificationArg_modificationRequestFor_CB_Info,
        _AnyTimeModificationArg_modificationRequestFor_CSI,
        _AnyTimeModificationArg_extensionContainer,
        _AnyTimeModificationArg_longFTN_Supported,
        _AnyTimeModificationArg_modificationRequestFor_ODB_data,
        _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data,
        _AnyTimeModificationArg_activationRequestForUE_reachability,
        _AnyTimeModificationArg_modificationRequestFor_CSG,
        _AnyTimeModificationArg_modificationRequestFor_CW_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIP_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIR_Data,
        _AnyTimeModificationArg_modificationRequestFor_HOLD_Data,
        _AnyTimeModificationArg_modificationRequestFor_ECT_Data,
        AnyTimeModificationArg,
        _ModificationRequestFor_CW_Info_basicService,
        _ModificationRequestFor_CW_Info_ss_Status,
        _ModificationRequestFor_CW_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CW_Info_extensionContainer,
        ModificationRequestFor_CW_Info,
        _ModificationRequestFor_CH_Info_ss_Status,
        _ModificationRequestFor_CH_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CH_Info_extensionContainer,
        ModificationRequestFor_CH_Info,
        _ModificationRequestFor_ECT_Info_ss_Status,
        _ModificationRequestFor_ECT_Info_modifyNotificationToCSE,
        _ModificationRequestFor_ECT_Info_extensionContainer,
        ModificationRequestFor_ECT_Info,
        _ModificationRequestFor_CLIR_Info_ss_Status,
        _ModificationRequestFor_CLIR_Info_cliRestrictionOption,
        _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIR_Info_extensionContainer,
        ModificationRequestFor_CLIR_Info,
        _ModificationRequestFor_CLIP_Info_ss_Status,
        _ModificationRequestFor_CLIP_Info_overrideCategory,
        _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIP_Info_extensionContainer,
        ModificationRequestFor_CLIP_Info,
        _ModificationRequestFor_CSG_modifyNotificationToCSE,
        _ModificationRequestFor_CSG_extensionContainer,
        ModificationRequestFor_CSG,
        RequestedServingNode,
        ServingNode,
        _AnyTimeModificationRes_ss_InfoFor_CSE,
        _AnyTimeModificationRes_camel_SubscriptionInfo,
        _AnyTimeModificationRes_extensionContainer,
        _AnyTimeModificationRes_odb_Info,
        _AnyTimeModificationRes_cw_Data,
        _AnyTimeModificationRes_ch_Data,
        _AnyTimeModificationRes_clip_Data,
        _AnyTimeModificationRes_clir_Data,
        _AnyTimeModificationRes_ect_data,
        _AnyTimeModificationRes_serviceCentreAddress,
        AnyTimeModificationRes,
        _ModificationRequestFor_CF_Info_ss_Code,
        _ModificationRequestFor_CF_Info_basicService,
        _ModificationRequestFor_CF_Info_ss_Status,
        _ModificationRequestFor_CF_Info_forwardedToNumber,
        _ModificationRequestFor_CF_Info_forwardedToSubaddress,
        _ModificationRequestFor_CF_Info_noReplyConditionTime,
        _ModificationRequestFor_CF_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CF_Info_extensionContainer,
        ModificationRequestFor_CF_Info,
        _ModificationRequestFor_CB_Info_ss_Code,
        _ModificationRequestFor_CB_Info_basicService,
        _ModificationRequestFor_CB_Info_ss_Status,
        _ModificationRequestFor_CB_Info_password,
        _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter,
        _ModificationRequestFor_CB_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CB_Info_extensionContainer,
        ModificationRequestFor_CB_Info,
        _ModificationRequestFor_ODB_data_odb_data,
        _ModificationRequestFor_ODB_data_modifyNotificationToCSE,
        _ModificationRequestFor_ODB_data_extensionContainer,
        ModificationRequestFor_ODB_data,
        _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo,
        _ModificationRequestFor_CSI_modifyNotificationToCSE,
        _ModificationRequestFor_CSI_modifyCSI_State,
        _ModificationRequestFor_CSI_extensionContainer,
        _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo,
        ModificationRequestFor_CSI,
        _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus,
        _ModificationRequestFor_IP_SM_GW_Data_extensionContainer,
        _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress,
        ModificationRequestFor_IP_SM_GW_Data,
        ModificationInstruction,
        _NoteSubscriberDataModifiedArg_imsi,
        _NoteSubscriberDataModifiedArg_msisdn,
        _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_odb_Info,
        _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo,
        _NoteSubscriberDataModifiedArg_allInformationSent,
        _NoteSubscriberDataModifiedArg_extensionContainer,
        _NoteSubscriberDataModifiedArg_ue_reachable,
        _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList,
        _NoteSubscriberDataModifiedArg_cw_Data,
        _NoteSubscriberDataModifiedArg_ch_Data,
        _NoteSubscriberDataModifiedArg_clip_Data,
        _NoteSubscriberDataModifiedArg_clir_Data,
        _NoteSubscriberDataModifiedArg_ect_data,
        NoteSubscriberDataModifiedArg,
        _NoteSubscriberDataModifiedRes_extensionContainer,
        NoteSubscriberDataModifiedRes,
        _NoteMM_EventArg_serviceKey,
        _NoteMM_EventArg_eventMet,
        _NoteMM_EventArg_imsi,
        _NoteMM_EventArg_msisdn,
        _NoteMM_EventArg_locationInformation,
        _NoteMM_EventArg_supportedCAMELPhases,
        _NoteMM_EventArg_extensionContainer,
        _NoteMM_EventArg_locationInformationGPRS,
        _NoteMM_EventArg_offeredCamel4Functionalities,
        NoteMM_EventArg,
        _NoteMM_EventRes_extensionContainer,
        NoteMM_EventRes,
        _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE,
        _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE,
        Ext_SS_InfoFor_CSE,
        _Ext_ForwardingInfoFor_CSE_ss_Code,
        _Ext_ForwardingInfoFor_CSE_forwardingFeatureList,
        _Ext_ForwardingInfoFor_CSE_notificationToCSE,
        _Ext_ForwardingInfoFor_CSE_extensionContainer,
        Ext_ForwardingInfoFor_CSE,
        _Ext_CallBarringInfoFor_CSE_ss_Code,
        _Ext_CallBarringInfoFor_CSE_callBarringFeatureList,
        _Ext_CallBarringInfoFor_CSE_password,
        _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter,
        _Ext_CallBarringInfoFor_CSE_notificationToCSE,
        _Ext_CallBarringInfoFor_CSE_extensionContainer,
        Ext_CallBarringInfoFor_CSE,
        _UpdateVcsgLocationArg_imsi,
        _UpdateVcsgLocationArg_msisdn,
        _UpdateVcsgLocationArg_vlr_Number,
        _UpdateVcsgLocationArg_sgsn_Number,
        _UpdateVcsgLocationArg_extensionContainer,
        UpdateVcsgLocationArg,
        _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator,
        _UpdateVcsgLocationRes_extensionContainer,
        UpdateVcsgLocationRes,
        _CancelVcsgLocationArg_identity,
        _CancelVcsgLocationArg_extensionContainer,
        CancelVcsgLocationArg,
        _CancelVcsgLocationRes_extensionContainer,
        CancelVcsgLocationRes,
    ]

class MAP_OM_DataTypes:

    _name_  = 'MAP-OM-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 12, 19]
    
    _obj_ = [
        'ActivateTraceModeArg',
        'MDT-Configuration',
        'MDT-Allowed-PLMNId-List',
        'PeriodUMTS',
        'PeriodLTE',
        'PositioningMethod',
        'MeasurementQuantity',
        'EventThreshold1F',
        'EventThreshold1I',
        'JobType',
        'AreaScope',
        'CGI-List',
        'E-UTRAN-CGI-List',
        'RoutingAreaId-List',
        'LocationAreaId-List',
        'TrackingAreaId-List',
        'ListOfMeasurements',
        'ReportingTrigger',
        'ReportInterval',
        'ReportAmount',
        'EventThresholdRSRP',
        'EventThresholdRSRQ',
        'LoggingInterval',
        'LoggingDuration',
        'TraceReference',
        'TraceReference2',
        'TraceRecordingSessionReference',
        'TraceType',
        'TraceDepthList',
        'TraceDepth',
        'TraceDepthExtension',
        'TraceNE-TypeList',
        'TraceInterfaceList',
        'MSC-S-InterfaceList',
        'MGW-InterfaceList',
        'SGSN-InterfaceList',
        'GGSN-InterfaceList',
        'RNC-InterfaceList',
        'BMSC-InterfaceList',
        'MME-InterfaceList',
        'SGW-InterfaceList',
        'PGW-InterfaceList',
        'ENB-InterfaceList',
        'TraceEventList',
        'MSC-S-EventList',
        'MGW-EventList',
        'SGSN-EventList',
        'GGSN-EventList',
        'BMSC-EventList',
        'MME-EventList',
        'SGW-EventList',
        'PGW-EventList',
        'TracePropagationList',
        'ActivateTraceModeRes',
        'DeactivateTraceModeArg',
        'DeactivateTraceModeRes',
        ]
    _type_ = [
        'ActivateTraceModeArg',
        'MDT-Configuration',
        'MDT-Allowed-PLMNId-List',
        'PeriodUMTS',
        'PeriodLTE',
        'PositioningMethod',
        'MeasurementQuantity',
        'EventThreshold1F',
        'EventThreshold1I',
        'JobType',
        'AreaScope',
        'CGI-List',
        'E-UTRAN-CGI-List',
        'RoutingAreaId-List',
        'LocationAreaId-List',
        'TrackingAreaId-List',
        'ListOfMeasurements',
        'ReportingTrigger',
        'ReportInterval',
        'ReportAmount',
        'EventThresholdRSRP',
        'EventThresholdRSRQ',
        'LoggingInterval',
        'LoggingDuration',
        'TraceReference',
        'TraceReference2',
        'TraceRecordingSessionReference',
        'TraceType',
        'TraceDepthList',
        'TraceDepth',
        'TraceDepthExtension',
        'TraceNE-TypeList',
        'TraceInterfaceList',
        'MSC-S-InterfaceList',
        'MGW-InterfaceList',
        'SGSN-InterfaceList',
        'GGSN-InterfaceList',
        'RNC-InterfaceList',
        'BMSC-InterfaceList',
        'MME-InterfaceList',
        'SGW-InterfaceList',
        'PGW-InterfaceList',
        'ENB-InterfaceList',
        'TraceEventList',
        'MSC-S-EventList',
        'MGW-EventList',
        'SGSN-EventList',
        'GGSN-EventList',
        'BMSC-EventList',
        'MME-EventList',
        'SGW-EventList',
        'PGW-EventList',
        'TracePropagationList',
        'ActivateTraceModeRes',
        'DeactivateTraceModeArg',
        'DeactivateTraceModeRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ActivateTraceModeArg >-----#
    ActivateTraceModeArg = SEQ(name='ActivateTraceModeArg', mode=MODE_TYPE)
    _ActivateTraceModeArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ActivateTraceModeArg_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _ActivateTraceModeArg_traceType = INT(name='traceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')))
    _ActivateTraceModeArg_omc_Id = OCT_STR(name='omc-Id', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ActivateTraceModeArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeArg_traceReference2 = OCT_STR(name='traceReference2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _ActivateTraceModeArg_traceDepthList = SEQ(name='traceDepthList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthList')), opt=True)
    _ActivateTraceModeArg_traceNE_TypeList = BIT_STR(name='traceNE-TypeList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceNE-TypeList')), opt=True)
    _ActivateTraceModeArg_traceInterfaceList = SEQ(name='traceInterfaceList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceInterfaceList')), opt=True)
    _ActivateTraceModeArg_traceEventList = SEQ(name='traceEventList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceEventList')), opt=True)
    _ActivateTraceModeArg_traceCollectionEntity = OCT_STR(name='traceCollectionEntity', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _ActivateTraceModeArg_mdt_Configuration = SEQ(name='mdt-Configuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Configuration')), opt=True)
    ActivateTraceModeArg._cont = ASN1Dict([
        ('imsi', _ActivateTraceModeArg_imsi),
        ('traceReference', _ActivateTraceModeArg_traceReference),
        ('traceType', _ActivateTraceModeArg_traceType),
        ('omc-Id', _ActivateTraceModeArg_omc_Id),
        ('extensionContainer', _ActivateTraceModeArg_extensionContainer),
        ('traceReference2', _ActivateTraceModeArg_traceReference2),
        ('traceDepthList', _ActivateTraceModeArg_traceDepthList),
        ('traceNE-TypeList', _ActivateTraceModeArg_traceNE_TypeList),
        ('traceInterfaceList', _ActivateTraceModeArg_traceInterfaceList),
        ('traceEventList', _ActivateTraceModeArg_traceEventList),
        ('traceCollectionEntity', _ActivateTraceModeArg_traceCollectionEntity),
        ('mdt-Configuration', _ActivateTraceModeArg_mdt_Configuration),
        ])
    ActivateTraceModeArg._ext = ['traceReference2', 'traceDepthList', 'traceNE-TypeList', 'traceInterfaceList', 'traceEventList', 'traceCollectionEntity', 'mdt-Configuration']
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_jobType = ENUM(name='jobType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'JobType')))
    _MDT_Configuration_areaScope = SEQ(name='areaScope', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'AreaScope')), opt=True)
    _MDT_Configuration_listOfMeasurements = OCT_STR(name='listOfMeasurements', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ListOfMeasurements')), opt=True)
    _MDT_Configuration_reportingTrigger = OCT_STR(name='reportingTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportingTrigger')), opt=True)
    _MDT_Configuration_reportInterval = ENUM(name='reportInterval', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportInterval')), opt=True)
    _MDT_Configuration_reportAmount = ENUM(name='reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportAmount')), opt=True)
    _MDT_Configuration_eventThresholdRSRP = INT(name='eventThresholdRSRP', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRP')), opt=True)
    _MDT_Configuration_eventThresholdRSRQ = INT(name='eventThresholdRSRQ', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRQ')), opt=True)
    _MDT_Configuration_loggingInterval = ENUM(name='loggingInterval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingInterval')), opt=True)
    _MDT_Configuration_loggingDuration = ENUM(name='loggingDuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingDuration')), opt=True)
    _MDT_Configuration_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MDT_Configuration_measurementPeriodUMTS = ENUM(name='measurementPeriodUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_measurementPeriodLTE = ENUM(name='measurementPeriodLTE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_UMTS = ENUM(name='collectionPeriodRRM-UMTS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_LTE = ENUM(name='collectionPeriodRRM-LTE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_positioningMethod = OCT_STR(name='positioningMethod', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PositioningMethod')), opt=True)
    _MDT_Configuration_measurementQuantity = OCT_STR(name='measurementQuantity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MeasurementQuantity')), opt=True)
    _MDT_Configuration_eventThreshold1F = INT(name='eventThreshold1F', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1F')), opt=True)
    _MDT_Configuration_eventThreshold1I = INT(name='eventThreshold1I', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1I')), opt=True)
    _MDT_Configuration_mdt_Allowed_PLMN_List = SEQ_OF(name='mdt-Allowed-PLMN-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Allowed-PLMNId-List')), opt=True)
    MDT_Configuration._cont = ASN1Dict([
        ('jobType', _MDT_Configuration_jobType),
        ('areaScope', _MDT_Configuration_areaScope),
        ('listOfMeasurements', _MDT_Configuration_listOfMeasurements),
        ('reportingTrigger', _MDT_Configuration_reportingTrigger),
        ('reportInterval', _MDT_Configuration_reportInterval),
        ('reportAmount', _MDT_Configuration_reportAmount),
        ('eventThresholdRSRP', _MDT_Configuration_eventThresholdRSRP),
        ('eventThresholdRSRQ', _MDT_Configuration_eventThresholdRSRQ),
        ('loggingInterval', _MDT_Configuration_loggingInterval),
        ('loggingDuration', _MDT_Configuration_loggingDuration),
        ('extensionContainer', _MDT_Configuration_extensionContainer),
        ('measurementPeriodUMTS', _MDT_Configuration_measurementPeriodUMTS),
        ('measurementPeriodLTE', _MDT_Configuration_measurementPeriodLTE),
        ('collectionPeriodRRM-UMTS', _MDT_Configuration_collectionPeriodRRM_UMTS),
        ('collectionPeriodRRM-LTE', _MDT_Configuration_collectionPeriodRRM_LTE),
        ('positioningMethod', _MDT_Configuration_positioningMethod),
        ('measurementQuantity', _MDT_Configuration_measurementQuantity),
        ('eventThreshold1F', _MDT_Configuration_eventThreshold1F),
        ('eventThreshold1I', _MDT_Configuration_eventThreshold1I),
        ('mdt-Allowed-PLMN-List', _MDT_Configuration_mdt_Allowed_PLMN_List),
        ])
    MDT_Configuration._ext = ['measurementPeriodUMTS', 'measurementPeriodLTE', 'collectionPeriodRRM-UMTS', 'collectionPeriodRRM-LTE', 'positioningMethod', 'measurementQuantity', 'eventThreshold1F', 'eventThreshold1I', 'mdt-Allowed-PLMN-List']
    
    #-----< MDT-Allowed-PLMNId-List >-----#
    MDT_Allowed_PLMNId_List = SEQ_OF(name='MDT-Allowed-PLMNId-List', mode=MODE_TYPE)
    _MDT_Allowed_PLMNId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    MDT_Allowed_PLMNId_List._cont = _MDT_Allowed_PLMNId_List__item_
    MDT_Allowed_PLMNId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodUMTS >-----#
    PeriodUMTS = ENUM(name='PeriodUMTS', mode=MODE_TYPE)
    PeriodUMTS._cont = ASN1Dict([('d250ms', 0), ('d500ms', 1), ('d1000ms', 2), ('d2000ms', 3), ('d3000ms', 4), ('d4000ms', 5), ('d6000ms', 6), ('d8000ms', 7), ('d12000ms', 8), ('d16000ms', 9), ('d20000ms', 10), ('d24000ms', 11), ('d28000ms', 12), ('d32000ms', 13), ('d64000ms', 14)])
    PeriodUMTS._ext = None
    
    #-----< PeriodLTE >-----#
    PeriodLTE = ENUM(name='PeriodLTE', mode=MODE_TYPE)
    PeriodLTE._cont = ASN1Dict([('d1024ms', 0), ('d1280ms', 1), ('d2048ms', 2), ('d2560ms', 3), ('d5120ms', 4), ('d10240ms', 5), ('d1min', 6)])
    PeriodLTE._ext = None
    
    #-----< PositioningMethod >-----#
    PositioningMethod = OCT_STR(name='PositioningMethod', mode=MODE_TYPE)
    PositioningMethod._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = OCT_STR(name='MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EventThreshold1F >-----#
    EventThreshold1F = INT(name='EventThreshold1F', mode=MODE_TYPE)
    EventThreshold1F._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    
    #-----< EventThreshold1I >-----#
    EventThreshold1I = INT(name='EventThreshold1I', mode=MODE_TYPE)
    EventThreshold1I._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    
    #-----< JobType >-----#
    JobType = ENUM(name='JobType', mode=MODE_TYPE)
    JobType._cont = ASN1Dict([('immediate-MDT-only', 0), ('logged-MDT-only', 1), ('trace-only', 2), ('immediate-MDT-and-trace', 3)])
    JobType._ext = None
    
    #-----< AreaScope >-----#
    AreaScope = SEQ(name='AreaScope', mode=MODE_TYPE)
    _AreaScope_cgi_List = SEQ_OF(name='cgi-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'CGI-List')), opt=True)
    _AreaScope_e_utran_cgi_List = SEQ_OF(name='e-utran-cgi-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'E-UTRAN-CGI-List')), opt=True)
    _AreaScope_routingAreaId_List = SEQ_OF(name='routingAreaId-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RoutingAreaId-List')), opt=True)
    _AreaScope_locationAreaId_List = SEQ_OF(name='locationAreaId-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LocationAreaId-List')), opt=True)
    _AreaScope_trackingAreaId_List = SEQ_OF(name='trackingAreaId-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TrackingAreaId-List')), opt=True)
    _AreaScope_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AreaScope._cont = ASN1Dict([
        ('cgi-List', _AreaScope_cgi_List),
        ('e-utran-cgi-List', _AreaScope_e_utran_cgi_List),
        ('routingAreaId-List', _AreaScope_routingAreaId_List),
        ('locationAreaId-List', _AreaScope_locationAreaId_List),
        ('trackingAreaId-List', _AreaScope_trackingAreaId_List),
        ('extensionContainer', _AreaScope_extensionContainer),
        ])
    AreaScope._ext = []
    
    #-----< CGI-List >-----#
    CGI_List = SEQ_OF(name='CGI-List', mode=MODE_TYPE)
    _CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')))
    CGI_List._cont = _CGI_List__item_
    CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-UTRAN-CGI-List >-----#
    E_UTRAN_CGI_List = SEQ_OF(name='E-UTRAN-CGI-List', mode=MODE_TYPE)
    _E_UTRAN_CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')))
    E_UTRAN_CGI_List._cont = _E_UTRAN_CGI_List__item_
    E_UTRAN_CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< RoutingAreaId-List >-----#
    RoutingAreaId_List = SEQ_OF(name='RoutingAreaId-List', mode=MODE_TYPE)
    _RoutingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')))
    RoutingAreaId_List._cont = _RoutingAreaId_List__item_
    RoutingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationAreaId-List >-----#
    LocationAreaId_List = SEQ_OF(name='LocationAreaId-List', mode=MODE_TYPE)
    _LocationAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    LocationAreaId_List._cont = _LocationAreaId_List__item_
    LocationAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TrackingAreaId-List >-----#
    TrackingAreaId_List = SEQ_OF(name='TrackingAreaId-List', mode=MODE_TYPE)
    _TrackingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')))
    TrackingAreaId_List._cont = _TrackingAreaId_List__item_
    TrackingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ListOfMeasurements >-----#
    ListOfMeasurements = OCT_STR(name='ListOfMeasurements', mode=MODE_TYPE)
    ListOfMeasurements._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ReportingTrigger >-----#
    ReportingTrigger = OCT_STR(name='ReportingTrigger', mode=MODE_TYPE)
    ReportingTrigger._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name='ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([('umts250ms', 0), ('umts500ms', 1), ('umts1000ms', 2), ('umts2000ms', 3), ('umts3000ms', 4), ('umts4000ms', 5), ('umts6000ms', 6), ('umts8000ms', 7), ('umts12000ms', 8), ('umts16000ms', 9), ('umts20000ms', 10), ('umts24000ms', 11), ('umts28000ms', 12), ('umts32000ms', 13), ('umts64000ms', 14), ('lte120ms', 15), ('lte240ms', 16), ('lte480ms', 17), ('lte640ms', 18), ('lte1024ms', 19), ('lte2048ms', 20), ('lte5120ms', 21), ('lte10240ms', 22), ('lte1min', 23), ('lte6min', 24), ('lte12min', 25), ('lte30min', 26), ('lte60min', 27)])
    ReportInterval._ext = None
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name='ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([('d1', 0), ('d2', 1), ('d4', 2), ('d8', 3), ('d16', 4), ('d32', 5), ('d64', 6), ('infinity', 7)])
    ReportAmount._ext = None
    
    #-----< EventThresholdRSRP >-----#
    EventThresholdRSRP = INT(name='EventThresholdRSRP', mode=MODE_TYPE)
    EventThresholdRSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< EventThresholdRSRQ >-----#
    EventThresholdRSRQ = INT(name='EventThresholdRSRQ', mode=MODE_TYPE)
    EventThresholdRSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name='LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([('d1dot28', 0), ('d2dot56', 1), ('d5dot12', 2), ('d10dot24', 3), ('d20dot48', 4), ('d30dot72', 5), ('d40dot96', 6), ('d61dot44', 7)])
    LoggingInterval._ext = None
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name='LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([('d600sec', 0), ('d1200sec', 1), ('d2400sec', 2), ('d3600sec', 3), ('d5400sec', 4), ('d7200sec', 5)])
    LoggingDuration._ext = None
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name='TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TraceReference2 >-----#
    TraceReference2 = OCT_STR(name='TraceReference2', mode=MODE_TYPE)
    TraceReference2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = OCT_STR(name='TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TraceType >-----#
    TraceType = INT(name='TraceType', mode=MODE_TYPE)
    TraceType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TraceDepthList >-----#
    TraceDepthList = SEQ(name='TraceDepthList', mode=MODE_TYPE)
    _TraceDepthList_msc_s_TraceDepth = ENUM(name='msc-s-TraceDepth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mgw_TraceDepth = ENUM(name='mgw-TraceDepth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgsn_TraceDepth = ENUM(name='sgsn-TraceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_ggsn_TraceDepth = ENUM(name='ggsn-TraceDepth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_rnc_TraceDepth = ENUM(name='rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_bmsc_TraceDepth = ENUM(name='bmsc-TraceDepth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mme_TraceDepth = ENUM(name='mme-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgw_TraceDepth = ENUM(name='sgw-TraceDepth', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_pgw_TraceDepth = ENUM(name='pgw-TraceDepth', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_eNB_TraceDepth = ENUM(name='eNB-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_msc_s_TraceDepthExtension = ENUM(name='msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mgw_TraceDepthExtension = ENUM(name='mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgsn_TraceDepthExtension = ENUM(name='sgsn-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_ggsn_TraceDepthExtension = ENUM(name='ggsn-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_rnc_TraceDepthExtension = ENUM(name='rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_bmsc_TraceDepthExtension = ENUM(name='bmsc-TraceDepthExtension', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mme_TraceDepthExtension = ENUM(name='mme-TraceDepthExtension', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgw_TraceDepthExtension = ENUM(name='sgw-TraceDepthExtension', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_pgw_TraceDepthExtension = ENUM(name='pgw-TraceDepthExtension', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_eNB_TraceDepthExtension = ENUM(name='eNB-TraceDepthExtension', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TraceDepthList._cont = ASN1Dict([
        ('msc-s-TraceDepth', _TraceDepthList_msc_s_TraceDepth),
        ('mgw-TraceDepth', _TraceDepthList_mgw_TraceDepth),
        ('sgsn-TraceDepth', _TraceDepthList_sgsn_TraceDepth),
        ('ggsn-TraceDepth', _TraceDepthList_ggsn_TraceDepth),
        ('rnc-TraceDepth', _TraceDepthList_rnc_TraceDepth),
        ('bmsc-TraceDepth', _TraceDepthList_bmsc_TraceDepth),
        ('mme-TraceDepth', _TraceDepthList_mme_TraceDepth),
        ('sgw-TraceDepth', _TraceDepthList_sgw_TraceDepth),
        ('pgw-TraceDepth', _TraceDepthList_pgw_TraceDepth),
        ('eNB-TraceDepth', _TraceDepthList_eNB_TraceDepth),
        ('msc-s-TraceDepthExtension', _TraceDepthList_msc_s_TraceDepthExtension),
        ('mgw-TraceDepthExtension', _TraceDepthList_mgw_TraceDepthExtension),
        ('sgsn-TraceDepthExtension', _TraceDepthList_sgsn_TraceDepthExtension),
        ('ggsn-TraceDepthExtension', _TraceDepthList_ggsn_TraceDepthExtension),
        ('rnc-TraceDepthExtension', _TraceDepthList_rnc_TraceDepthExtension),
        ('bmsc-TraceDepthExtension', _TraceDepthList_bmsc_TraceDepthExtension),
        ('mme-TraceDepthExtension', _TraceDepthList_mme_TraceDepthExtension),
        ('sgw-TraceDepthExtension', _TraceDepthList_sgw_TraceDepthExtension),
        ('pgw-TraceDepthExtension', _TraceDepthList_pgw_TraceDepthExtension),
        ('eNB-TraceDepthExtension', _TraceDepthList_eNB_TraceDepthExtension),
        ])
    TraceDepthList._ext = ['mme-TraceDepth', 'sgw-TraceDepth', 'pgw-TraceDepth', 'eNB-TraceDepth', 'msc-s-TraceDepthExtension', 'mgw-TraceDepthExtension', 'sgsn-TraceDepthExtension', 'ggsn-TraceDepthExtension', 'rnc-TraceDepthExtension', 'bmsc-TraceDepthExtension', 'mme-TraceDepthExtension', 'sgw-TraceDepthExtension', 'pgw-TraceDepthExtension', 'eNB-TraceDepthExtension']
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceDepthExtension >-----#
    TraceDepthExtension = ENUM(name='TraceDepthExtension', mode=MODE_TYPE)
    TraceDepthExtension._cont = ASN1Dict([('minimumWithoutVendorSpecificExtension', 0), ('mediumWithoutVendorSpecificExtension', 1), ('maximumWithoutVendorSpecificExtension', 2)])
    TraceDepthExtension._ext = []
    
    #-----< TraceNE-TypeList >-----#
    TraceNE_TypeList = BIT_STR(name='TraceNE-TypeList', mode=MODE_TYPE)
    TraceNE_TypeList._cont = ASN1Dict([('msc-s', 0), ('mgw', 1), ('sgsn', 2), ('ggsn', 3), ('rnc', 4), ('bm-sc', 5), ('mme', 6), ('sgw', 7), ('pgw', 8), ('eNB', 9)])
    TraceNE_TypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=16)], ev=None, er=[])
    
    #-----< TraceInterfaceList >-----#
    TraceInterfaceList = SEQ(name='TraceInterfaceList', mode=MODE_TYPE)
    _TraceInterfaceList_msc_s_List = BIT_STR(name='msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TraceInterfaceList_mgw_List = BIT_STR(name='mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TraceInterfaceList_sgsn_List = BIT_STR(name='sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_ggsn_List = BIT_STR(name='ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_rnc_List = BIT_STR(name='rnc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TraceInterfaceList_bmsc_List = BIT_STR(name='bmsc-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-InterfaceList')), opt=True)
    _TraceInterfaceList_mme_List = BIT_STR(name='mme-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-InterfaceList')), opt=True)
    _TraceInterfaceList_sgw_List = BIT_STR(name='sgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-InterfaceList')), opt=True)
    _TraceInterfaceList_pgw_List = BIT_STR(name='pgw-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-InterfaceList')), opt=True)
    _TraceInterfaceList_eNB_List = BIT_STR(name='eNB-List', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ENB-InterfaceList')), opt=True)
    TraceInterfaceList._cont = ASN1Dict([
        ('msc-s-List', _TraceInterfaceList_msc_s_List),
        ('mgw-List', _TraceInterfaceList_mgw_List),
        ('sgsn-List', _TraceInterfaceList_sgsn_List),
        ('ggsn-List', _TraceInterfaceList_ggsn_List),
        ('rnc-List', _TraceInterfaceList_rnc_List),
        ('bmsc-List', _TraceInterfaceList_bmsc_List),
        ('mme-List', _TraceInterfaceList_mme_List),
        ('sgw-List', _TraceInterfaceList_sgw_List),
        ('pgw-List', _TraceInterfaceList_pgw_List),
        ('eNB-List', _TraceInterfaceList_eNB_List),
        ])
    TraceInterfaceList._ext = ['mme-List', 'sgw-List', 'pgw-List', 'eNB-List']
    
    #-----< MSC-S-InterfaceList >-----#
    MSC_S_InterfaceList = BIT_STR(name='MSC-S-InterfaceList', mode=MODE_TYPE)
    MSC_S_InterfaceList._cont = ASN1Dict([('a', 0), ('iu', 1), ('mc', 2), ('map-g', 3), ('map-b', 4), ('map-e', 5), ('map-f', 6), ('cap', 7), ('map-d', 8), ('map-c', 9)])
    MSC_S_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=16)], ev=None, er=[])
    
    #-----< MGW-InterfaceList >-----#
    MGW_InterfaceList = BIT_STR(name='MGW-InterfaceList', mode=MODE_TYPE)
    MGW_InterfaceList._cont = ASN1Dict([('mc', 0), ('nb-up', 1), ('iu-up', 2)])
    MGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-InterfaceList >-----#
    SGSN_InterfaceList = BIT_STR(name='SGSN-InterfaceList', mode=MODE_TYPE)
    SGSN_InterfaceList._cont = ASN1Dict([('gb', 0), ('iu', 1), ('gn', 2), ('map-gr', 3), ('map-gd', 4), ('map-gf', 5), ('gs', 6), ('ge', 7), ('s3', 8), ('s4', 9), ('s6d', 10)])
    SGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< GGSN-InterfaceList >-----#
    GGSN_InterfaceList = BIT_STR(name='GGSN-InterfaceList', mode=MODE_TYPE)
    GGSN_InterfaceList._cont = ASN1Dict([('gn', 0), ('gi', 1), ('gmb', 2)])
    GGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< RNC-InterfaceList >-----#
    RNC_InterfaceList = BIT_STR(name='RNC-InterfaceList', mode=MODE_TYPE)
    RNC_InterfaceList._cont = ASN1Dict([('iu', 0), ('iur', 1), ('iub', 2), ('uu', 3)])
    RNC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BMSC-InterfaceList >-----#
    BMSC_InterfaceList = BIT_STR(name='BMSC-InterfaceList', mode=MODE_TYPE)
    BMSC_InterfaceList._cont = ASN1Dict([('gmb', 0)])
    BMSC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-InterfaceList >-----#
    MME_InterfaceList = BIT_STR(name='MME-InterfaceList', mode=MODE_TYPE)
    MME_InterfaceList._cont = ASN1Dict([('s1-mme', 0), ('s3', 1), ('s6a', 2), ('s10', 3), ('s11', 4)])
    MME_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< SGW-InterfaceList >-----#
    SGW_InterfaceList = BIT_STR(name='SGW-InterfaceList', mode=MODE_TYPE)
    SGW_InterfaceList._cont = ASN1Dict([('s4', 0), ('s5', 1), ('s8b', 2), ('s11', 3), ('gxc', 4)])
    SGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< PGW-InterfaceList >-----#
    PGW_InterfaceList = BIT_STR(name='PGW-InterfaceList', mode=MODE_TYPE)
    PGW_InterfaceList._cont = ASN1Dict([('s2a', 0), ('s2b', 1), ('s2c', 2), ('s5', 3), ('s6b', 4), ('gx', 5), ('s8b', 6), ('sgi', 7)])
    PGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< ENB-InterfaceList >-----#
    ENB_InterfaceList = BIT_STR(name='ENB-InterfaceList', mode=MODE_TYPE)
    ENB_InterfaceList._cont = ASN1Dict([('s1-mme', 0), ('x2', 1), ('uu', 2)])
    ENB_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TraceEventList >-----#
    TraceEventList = SEQ(name='TraceEventList', mode=MODE_TYPE)
    _TraceEventList_msc_s_List = BIT_STR(name='msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TraceEventList_mgw_List = BIT_STR(name='mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TraceEventList_sgsn_List = BIT_STR(name='sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-EventList')), opt=True)
    _TraceEventList_ggsn_List = BIT_STR(name='ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-EventList')), opt=True)
    _TraceEventList_bmsc_List = BIT_STR(name='bmsc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-EventList')), opt=True)
    _TraceEventList_mme_List = BIT_STR(name='mme-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-EventList')), opt=True)
    _TraceEventList_sgw_List = BIT_STR(name='sgw-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-EventList')), opt=True)
    _TraceEventList_pgw_List = BIT_STR(name='pgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-EventList')), opt=True)
    TraceEventList._cont = ASN1Dict([
        ('msc-s-List', _TraceEventList_msc_s_List),
        ('mgw-List', _TraceEventList_mgw_List),
        ('sgsn-List', _TraceEventList_sgsn_List),
        ('ggsn-List', _TraceEventList_ggsn_List),
        ('bmsc-List', _TraceEventList_bmsc_List),
        ('mme-List', _TraceEventList_mme_List),
        ('sgw-List', _TraceEventList_sgw_List),
        ('pgw-List', _TraceEventList_pgw_List),
        ])
    TraceEventList._ext = ['mme-List', 'sgw-List', 'pgw-List']
    
    #-----< MSC-S-EventList >-----#
    MSC_S_EventList = BIT_STR(name='MSC-S-EventList', mode=MODE_TYPE)
    MSC_S_EventList._cont = ASN1Dict([('mo-mtCall', 0), ('mo-mt-sms', 1), ('lu-imsiAttach-imsiDetach', 2), ('handovers', 3), ('ss', 4)])
    MSC_S_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=16)], ev=None, er=[])
    
    #-----< MGW-EventList >-----#
    MGW_EventList = BIT_STR(name='MGW-EventList', mode=MODE_TYPE)
    MGW_EventList._cont = ASN1Dict([('context', 0)])
    MGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SGSN-EventList >-----#
    SGSN_EventList = BIT_STR(name='SGSN-EventList', mode=MODE_TYPE)
    SGSN_EventList._cont = ASN1Dict([('pdpContext', 0), ('mo-mt-sms', 1), ('rau-gprsAttach-gprsDetach', 2), ('mbmsContext', 3)])
    SGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< GGSN-EventList >-----#
    GGSN_EventList = BIT_STR(name='GGSN-EventList', mode=MODE_TYPE)
    GGSN_EventList._cont = ASN1Dict([('pdpContext', 0), ('mbmsContext', 1)])
    GGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< BMSC-EventList >-----#
    BMSC_EventList = BIT_STR(name='BMSC-EventList', mode=MODE_TYPE)
    BMSC_EventList._cont = ASN1Dict([('mbmsMulticastServiceActivation', 0)])
    BMSC_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-EventList >-----#
    MME_EventList = BIT_STR(name='MME-EventList', mode=MODE_TYPE)
    MME_EventList._cont = ASN1Dict([('ue-initiatedPDNconectivityRequest', 0), ('serviceRequestts', 1), ('initialAttachTrackingAreaUpdateDetach', 2), ('ue-initiatedPDNdisconnection', 3), ('bearerActivationModificationDeletion', 4), ('handover', 5)])
    MME_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=8)], ev=None, er=[])
    
    #-----< SGW-EventList >-----#
    SGW_EventList = BIT_STR(name='SGW-EventList', mode=MODE_TYPE)
    SGW_EventList._cont = ASN1Dict([('pdn-connectionCreation', 0), ('pdn-connectionTermination', 1), ('bearerActivationModificationDeletion', 2)])
    SGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< PGW-EventList >-----#
    PGW_EventList = BIT_STR(name='PGW-EventList', mode=MODE_TYPE)
    PGW_EventList._cont = ASN1Dict([('pdn-connectionCreation', 0), ('pdn-connectionTermination', 1), ('bearerActivationModificationDeletion', 2)])
    PGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TracePropagationList >-----#
    TracePropagationList = SEQ(name='TracePropagationList', mode=MODE_TYPE)
    _TracePropagationList_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')), opt=True)
    _TracePropagationList_traceType = INT(name='traceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')), opt=True)
    _TracePropagationList_traceReference2 = OCT_STR(name='traceReference2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _TracePropagationList_traceRecordingSessionReference = OCT_STR(name='traceRecordingSessionReference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceRecordingSessionReference')), opt=True)
    _TracePropagationList_rnc_TraceDepth = ENUM(name='rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_rnc_InterfaceList = BIT_STR(name='rnc-InterfaceList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_TraceDepth = ENUM(name='msc-s-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_msc_s_InterfaceList = BIT_STR(name='msc-s-InterfaceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_EventList = BIT_STR(name='msc-s-EventList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TracePropagationList_mgw_TraceDepth = ENUM(name='mgw-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_mgw_InterfaceList = BIT_STR(name='mgw-InterfaceList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TracePropagationList_mgw_EventList = BIT_STR(name='mgw-EventList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TracePropagationList_rnc_TraceDepthExtension = ENUM(name='rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_msc_s_TraceDepthExtension = ENUM(name='msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_mgw_TraceDepthExtension = ENUM(name='mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TracePropagationList._cont = ASN1Dict([
        ('traceReference', _TracePropagationList_traceReference),
        ('traceType', _TracePropagationList_traceType),
        ('traceReference2', _TracePropagationList_traceReference2),
        ('traceRecordingSessionReference', _TracePropagationList_traceRecordingSessionReference),
        ('rnc-TraceDepth', _TracePropagationList_rnc_TraceDepth),
        ('rnc-InterfaceList', _TracePropagationList_rnc_InterfaceList),
        ('msc-s-TraceDepth', _TracePropagationList_msc_s_TraceDepth),
        ('msc-s-InterfaceList', _TracePropagationList_msc_s_InterfaceList),
        ('msc-s-EventList', _TracePropagationList_msc_s_EventList),
        ('mgw-TraceDepth', _TracePropagationList_mgw_TraceDepth),
        ('mgw-InterfaceList', _TracePropagationList_mgw_InterfaceList),
        ('mgw-EventList', _TracePropagationList_mgw_EventList),
        ('rnc-TraceDepthExtension', _TracePropagationList_rnc_TraceDepthExtension),
        ('msc-s-TraceDepthExtension', _TracePropagationList_msc_s_TraceDepthExtension),
        ('mgw-TraceDepthExtension', _TracePropagationList_mgw_TraceDepthExtension),
        ])
    TracePropagationList._ext = ['rnc-TraceDepthExtension', 'msc-s-TraceDepthExtension', 'mgw-TraceDepthExtension']
    
    #-----< ActivateTraceModeRes >-----#
    ActivateTraceModeRes = SEQ(name='ActivateTraceModeRes', mode=MODE_TYPE)
    _ActivateTraceModeRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeRes_traceSupportIndicator = NULL(name='traceSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ActivateTraceModeRes._cont = ASN1Dict([
        ('extensionContainer', _ActivateTraceModeRes_extensionContainer),
        ('traceSupportIndicator', _ActivateTraceModeRes_traceSupportIndicator),
        ])
    ActivateTraceModeRes._ext = ['traceSupportIndicator']
    
    #-----< DeactivateTraceModeArg >-----#
    DeactivateTraceModeArg = SEQ(name='DeactivateTraceModeArg', mode=MODE_TYPE)
    _DeactivateTraceModeArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _DeactivateTraceModeArg_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _DeactivateTraceModeArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeactivateTraceModeArg_traceReference2 = OCT_STR(name='traceReference2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    DeactivateTraceModeArg._cont = ASN1Dict([
        ('imsi', _DeactivateTraceModeArg_imsi),
        ('traceReference', _DeactivateTraceModeArg_traceReference),
        ('extensionContainer', _DeactivateTraceModeArg_extensionContainer),
        ('traceReference2', _DeactivateTraceModeArg_traceReference2),
        ])
    DeactivateTraceModeArg._ext = ['traceReference2']
    
    #-----< DeactivateTraceModeRes >-----#
    DeactivateTraceModeRes = SEQ(name='DeactivateTraceModeRes', mode=MODE_TYPE)
    _DeactivateTraceModeRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeactivateTraceModeRes._cont = ASN1Dict([
        ('extensionContainer', _DeactivateTraceModeRes_extensionContainer),
        ])
    DeactivateTraceModeRes._ext = []
    
    _all_ = [
        _ActivateTraceModeArg_imsi,
        _ActivateTraceModeArg_traceReference,
        _ActivateTraceModeArg_traceType,
        _ActivateTraceModeArg_omc_Id,
        _ActivateTraceModeArg_extensionContainer,
        _ActivateTraceModeArg_traceReference2,
        _ActivateTraceModeArg_traceDepthList,
        _ActivateTraceModeArg_traceNE_TypeList,
        _ActivateTraceModeArg_traceInterfaceList,
        _ActivateTraceModeArg_traceEventList,
        _ActivateTraceModeArg_traceCollectionEntity,
        _ActivateTraceModeArg_mdt_Configuration,
        ActivateTraceModeArg,
        _MDT_Configuration_jobType,
        _MDT_Configuration_areaScope,
        _MDT_Configuration_listOfMeasurements,
        _MDT_Configuration_reportingTrigger,
        _MDT_Configuration_reportInterval,
        _MDT_Configuration_reportAmount,
        _MDT_Configuration_eventThresholdRSRP,
        _MDT_Configuration_eventThresholdRSRQ,
        _MDT_Configuration_loggingInterval,
        _MDT_Configuration_loggingDuration,
        _MDT_Configuration_extensionContainer,
        _MDT_Configuration_measurementPeriodUMTS,
        _MDT_Configuration_measurementPeriodLTE,
        _MDT_Configuration_collectionPeriodRRM_UMTS,
        _MDT_Configuration_collectionPeriodRRM_LTE,
        _MDT_Configuration_positioningMethod,
        _MDT_Configuration_measurementQuantity,
        _MDT_Configuration_eventThreshold1F,
        _MDT_Configuration_eventThreshold1I,
        _MDT_Configuration_mdt_Allowed_PLMN_List,
        MDT_Configuration,
        _MDT_Allowed_PLMNId_List__item_,
        MDT_Allowed_PLMNId_List,
        PeriodUMTS,
        PeriodLTE,
        PositioningMethod,
        MeasurementQuantity,
        EventThreshold1F,
        EventThreshold1I,
        JobType,
        _AreaScope_cgi_List,
        _AreaScope_e_utran_cgi_List,
        _AreaScope_routingAreaId_List,
        _AreaScope_locationAreaId_List,
        _AreaScope_trackingAreaId_List,
        _AreaScope_extensionContainer,
        AreaScope,
        _CGI_List__item_,
        CGI_List,
        _E_UTRAN_CGI_List__item_,
        E_UTRAN_CGI_List,
        _RoutingAreaId_List__item_,
        RoutingAreaId_List,
        _LocationAreaId_List__item_,
        LocationAreaId_List,
        _TrackingAreaId_List__item_,
        TrackingAreaId_List,
        ListOfMeasurements,
        ReportingTrigger,
        ReportInterval,
        ReportAmount,
        EventThresholdRSRP,
        EventThresholdRSRQ,
        LoggingInterval,
        LoggingDuration,
        TraceReference,
        TraceReference2,
        TraceRecordingSessionReference,
        TraceType,
        _TraceDepthList_msc_s_TraceDepth,
        _TraceDepthList_mgw_TraceDepth,
        _TraceDepthList_sgsn_TraceDepth,
        _TraceDepthList_ggsn_TraceDepth,
        _TraceDepthList_rnc_TraceDepth,
        _TraceDepthList_bmsc_TraceDepth,
        _TraceDepthList_mme_TraceDepth,
        _TraceDepthList_sgw_TraceDepth,
        _TraceDepthList_pgw_TraceDepth,
        _TraceDepthList_eNB_TraceDepth,
        _TraceDepthList_msc_s_TraceDepthExtension,
        _TraceDepthList_mgw_TraceDepthExtension,
        _TraceDepthList_sgsn_TraceDepthExtension,
        _TraceDepthList_ggsn_TraceDepthExtension,
        _TraceDepthList_rnc_TraceDepthExtension,
        _TraceDepthList_bmsc_TraceDepthExtension,
        _TraceDepthList_mme_TraceDepthExtension,
        _TraceDepthList_sgw_TraceDepthExtension,
        _TraceDepthList_pgw_TraceDepthExtension,
        _TraceDepthList_eNB_TraceDepthExtension,
        TraceDepthList,
        TraceDepth,
        TraceDepthExtension,
        TraceNE_TypeList,
        _TraceInterfaceList_msc_s_List,
        _TraceInterfaceList_mgw_List,
        _TraceInterfaceList_sgsn_List,
        _TraceInterfaceList_ggsn_List,
        _TraceInterfaceList_rnc_List,
        _TraceInterfaceList_bmsc_List,
        _TraceInterfaceList_mme_List,
        _TraceInterfaceList_sgw_List,
        _TraceInterfaceList_pgw_List,
        _TraceInterfaceList_eNB_List,
        TraceInterfaceList,
        MSC_S_InterfaceList,
        MGW_InterfaceList,
        SGSN_InterfaceList,
        GGSN_InterfaceList,
        RNC_InterfaceList,
        BMSC_InterfaceList,
        MME_InterfaceList,
        SGW_InterfaceList,
        PGW_InterfaceList,
        ENB_InterfaceList,
        _TraceEventList_msc_s_List,
        _TraceEventList_mgw_List,
        _TraceEventList_sgsn_List,
        _TraceEventList_ggsn_List,
        _TraceEventList_bmsc_List,
        _TraceEventList_mme_List,
        _TraceEventList_sgw_List,
        _TraceEventList_pgw_List,
        TraceEventList,
        MSC_S_EventList,
        MGW_EventList,
        SGSN_EventList,
        GGSN_EventList,
        BMSC_EventList,
        MME_EventList,
        SGW_EventList,
        PGW_EventList,
        _TracePropagationList_traceReference,
        _TracePropagationList_traceType,
        _TracePropagationList_traceReference2,
        _TracePropagationList_traceRecordingSessionReference,
        _TracePropagationList_rnc_TraceDepth,
        _TracePropagationList_rnc_InterfaceList,
        _TracePropagationList_msc_s_TraceDepth,
        _TracePropagationList_msc_s_InterfaceList,
        _TracePropagationList_msc_s_EventList,
        _TracePropagationList_mgw_TraceDepth,
        _TracePropagationList_mgw_InterfaceList,
        _TracePropagationList_mgw_EventList,
        _TracePropagationList_rnc_TraceDepthExtension,
        _TracePropagationList_msc_s_TraceDepthExtension,
        _TracePropagationList_mgw_TraceDepthExtension,
        TracePropagationList,
        _ActivateTraceModeRes_extensionContainer,
        _ActivateTraceModeRes_traceSupportIndicator,
        ActivateTraceModeRes,
        _DeactivateTraceModeArg_imsi,
        _DeactivateTraceModeArg_traceReference,
        _DeactivateTraceModeArg_extensionContainer,
        _DeactivateTraceModeArg_traceReference2,
        DeactivateTraceModeArg,
        _DeactivateTraceModeRes_extensionContainer,
        DeactivateTraceModeRes,
    ]

class MAP_CH_DataTypes:

    _name_  = 'MAP-CH-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 13, 19]
    
    _obj_ = [
        'CUG-CheckInfo',
        'NumberOfForwarding',
        'SendRoutingInfoArg',
        'SuppressionOfAnnouncement',
        'SuppressMTSS',
        'InterrogationType',
        'OR-Phase',
        'CallReferenceNumber',
        'ForwardingReason',
        'SupportedCCBS-Phase',
        'CallDiversionTreatmentIndicator',
        'SendRoutingInfoRes',
        'AllowedServices',
        'UnavailabilityCause',
        'CCBS-Indicators',
        'RoutingInfo',
        'ForwardingData',
        'ProvideRoamingNumberArg',
        'ProvideRoamingNumberRes',
        'ResumeCallHandlingArg',
        'UU-Data',
        'UUIndicator',
        'UUI',
        'ResumeCallHandlingRes',
        'CamelInfo',
        'ExtendedRoutingInfo',
        'CamelRoutingInfo',
        'GmscCamelSubscriptionInfo',
        'SetReportingStateArg',
        'ReportingState',
        'SetReportingStateRes',
        'CCBS-SubscriberStatus',
        'StatusReportArg',
        'EventReportData',
        'CallReportData',
        'MonitoringMode',
        'CallOutcome',
        'StatusReportRes',
        'RemoteUserFreeArg',
        'RemoteUserFreeRes',
        'RUF-Outcome',
        'IST-AlertArg',
        'IST-AlertRes',
        'IST-CommandArg',
        'IST-CommandRes',
        'CallTerminationIndicator',
        'ReleaseResourcesArg',
        'ReleaseResourcesRes',
        ]
    _type_ = [
        'CUG-CheckInfo',
        'NumberOfForwarding',
        'SendRoutingInfoArg',
        'SuppressionOfAnnouncement',
        'SuppressMTSS',
        'InterrogationType',
        'OR-Phase',
        'CallReferenceNumber',
        'ForwardingReason',
        'SupportedCCBS-Phase',
        'CallDiversionTreatmentIndicator',
        'SendRoutingInfoRes',
        'AllowedServices',
        'UnavailabilityCause',
        'CCBS-Indicators',
        'RoutingInfo',
        'ForwardingData',
        'ProvideRoamingNumberArg',
        'ProvideRoamingNumberRes',
        'ResumeCallHandlingArg',
        'UU-Data',
        'UUIndicator',
        'UUI',
        'ResumeCallHandlingRes',
        'CamelInfo',
        'ExtendedRoutingInfo',
        'CamelRoutingInfo',
        'GmscCamelSubscriptionInfo',
        'SetReportingStateArg',
        'ReportingState',
        'SetReportingStateRes',
        'CCBS-SubscriberStatus',
        'StatusReportArg',
        'EventReportData',
        'CallReportData',
        'MonitoringMode',
        'CallOutcome',
        'StatusReportRes',
        'RemoteUserFreeArg',
        'RemoteUserFreeRes',
        'RUF-Outcome',
        'IST-AlertArg',
        'IST-AlertRes',
        'IST-CommandArg',
        'IST-CommandRes',
        'CallTerminationIndicator',
        'ReleaseResourcesArg',
        'ReleaseResourcesRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CUG-CheckInfo >-----#
    CUG_CheckInfo = SEQ(name='CUG-CheckInfo', mode=MODE_TYPE)
    _CUG_CheckInfo_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_CheckInfo_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, opt=True)
    _CUG_CheckInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_CheckInfo._cont = ASN1Dict([
        ('cug-Interlock', _CUG_CheckInfo_cug_Interlock),
        ('cug-OutgoingAccess', _CUG_CheckInfo_cug_OutgoingAccess),
        ('extensionContainer', _CUG_CheckInfo_extensionContainer),
        ])
    CUG_CheckInfo._ext = []
    
    #-----< NumberOfForwarding >-----#
    NumberOfForwarding = INT(name='NumberOfForwarding', mode=MODE_TYPE)
    NumberOfForwarding._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< SendRoutingInfoArg >-----#
    SendRoutingInfoArg = SEQ(name='SendRoutingInfoArg', mode=MODE_TYPE)
    _SendRoutingInfoArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_cug_CheckInfo = SEQ(name='cug-CheckInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoArg_numberOfForwarding = INT(name='numberOfForwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    _SendRoutingInfoArg_interrogationType = ENUM(name='interrogationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'InterrogationType')))
    _SendRoutingInfoArg_or_Interrogation = NULL(name='or-Interrogation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_or_Capability = INT(name='or-Capability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'OR-Phase')), opt=True)
    _SendRoutingInfoArg_gmsc_OrGsmSCF_Address = OCT_STR(name='gmsc-OrGsmSCF-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _SendRoutingInfoArg_forwardingReason = ENUM(name='forwardingReason', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingReason')), opt=True)
    _SendRoutingInfoArg_basicServiceGroup = CHOICE(name='basicServiceGroup', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo = SEQ(name='networkSignalInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_camelInfo = SEQ(name='camelInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelInfo')), opt=True)
    _SendRoutingInfoArg_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _SendRoutingInfoArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoArg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _SendRoutingInfoArg_ccbs_Call = NULL(name='ccbs-Call', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_supportedCCBS_Phase = INT(name='supportedCCBS-Phase', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SupportedCCBS-Phase')), opt=True)
    _SendRoutingInfoArg_additionalSignalInfo = SEQ(name='additionalSignalInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_istSupportIndicator = ENUM(name='istSupportIndicator', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _SendRoutingInfoArg_pre_pagingSupported = NULL(name='pre-pagingSupported', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callDiversionTreatmentIndicator = OCT_STR(name='callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallDiversionTreatmentIndicator')), opt=True)
    _SendRoutingInfoArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppress_VT_CSI = NULL(name='suppress-VT-CSI', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppressIncomingCallBarring = NULL(name='suppressIncomingCallBarring', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_gsmSCF_InitiatedCall = NULL(name='gsmSCF-InitiatedCall', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_basicServiceGroup2 = CHOICE(name='basicServiceGroup2', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo2 = SEQ(name='networkSignalInfo2', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_suppressMTSS = BIT_STR(name='suppressMTSS', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressMTSS')), opt=True)
    _SendRoutingInfoArg_mtRoamingRetrySupported = NULL(name='mtRoamingRetrySupported', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callPriority = INT(name='callPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    SendRoutingInfoArg._cont = ASN1Dict([
        ('msisdn', _SendRoutingInfoArg_msisdn),
        ('cug-CheckInfo', _SendRoutingInfoArg_cug_CheckInfo),
        ('numberOfForwarding', _SendRoutingInfoArg_numberOfForwarding),
        ('interrogationType', _SendRoutingInfoArg_interrogationType),
        ('or-Interrogation', _SendRoutingInfoArg_or_Interrogation),
        ('or-Capability', _SendRoutingInfoArg_or_Capability),
        ('gmsc-OrGsmSCF-Address', _SendRoutingInfoArg_gmsc_OrGsmSCF_Address),
        ('callReferenceNumber', _SendRoutingInfoArg_callReferenceNumber),
        ('forwardingReason', _SendRoutingInfoArg_forwardingReason),
        ('basicServiceGroup', _SendRoutingInfoArg_basicServiceGroup),
        ('networkSignalInfo', _SendRoutingInfoArg_networkSignalInfo),
        ('camelInfo', _SendRoutingInfoArg_camelInfo),
        ('suppressionOfAnnouncement', _SendRoutingInfoArg_suppressionOfAnnouncement),
        ('extensionContainer', _SendRoutingInfoArg_extensionContainer),
        ('alertingPattern', _SendRoutingInfoArg_alertingPattern),
        ('ccbs-Call', _SendRoutingInfoArg_ccbs_Call),
        ('supportedCCBS-Phase', _SendRoutingInfoArg_supportedCCBS_Phase),
        ('additionalSignalInfo', _SendRoutingInfoArg_additionalSignalInfo),
        ('istSupportIndicator', _SendRoutingInfoArg_istSupportIndicator),
        ('pre-pagingSupported', _SendRoutingInfoArg_pre_pagingSupported),
        ('callDiversionTreatmentIndicator', _SendRoutingInfoArg_callDiversionTreatmentIndicator),
        ('longFTN-Supported', _SendRoutingInfoArg_longFTN_Supported),
        ('suppress-VT-CSI', _SendRoutingInfoArg_suppress_VT_CSI),
        ('suppressIncomingCallBarring', _SendRoutingInfoArg_suppressIncomingCallBarring),
        ('gsmSCF-InitiatedCall', _SendRoutingInfoArg_gsmSCF_InitiatedCall),
        ('basicServiceGroup2', _SendRoutingInfoArg_basicServiceGroup2),
        ('networkSignalInfo2', _SendRoutingInfoArg_networkSignalInfo2),
        ('suppressMTSS', _SendRoutingInfoArg_suppressMTSS),
        ('mtRoamingRetrySupported', _SendRoutingInfoArg_mtRoamingRetrySupported),
        ('callPriority', _SendRoutingInfoArg_callPriority),
        ])
    SendRoutingInfoArg._ext = ['alertingPattern', 'ccbs-Call', 'supportedCCBS-Phase', 'additionalSignalInfo', 'istSupportIndicator', 'pre-pagingSupported', 'callDiversionTreatmentIndicator', 'longFTN-Supported', 'suppress-VT-CSI', 'suppressIncomingCallBarring', 'gsmSCF-InitiatedCall', 'basicServiceGroup2', 'networkSignalInfo2', 'suppressMTSS', 'mtRoamingRetrySupported', 'callPriority']
    
    #-----< SuppressionOfAnnouncement >-----#
    SuppressionOfAnnouncement = NULL(name='SuppressionOfAnnouncement', mode=MODE_TYPE)
    
    #-----< SuppressMTSS >-----#
    SuppressMTSS = BIT_STR(name='SuppressMTSS', mode=MODE_TYPE)
    SuppressMTSS._cont = ASN1Dict([('suppressCUG', 0), ('suppressCCBS', 1)])
    SuppressMTSS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< InterrogationType >-----#
    InterrogationType = ENUM(name='InterrogationType', mode=MODE_TYPE)
    InterrogationType._cont = ASN1Dict([('basicCall', 0), ('forwarding', 1)])
    InterrogationType._ext = None
    
    #-----< OR-Phase >-----#
    OR_Phase = INT(name='OR-Phase', mode=MODE_TYPE)
    OR_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallReferenceNumber >-----#
    CallReferenceNumber = OCT_STR(name='CallReferenceNumber', mode=MODE_TYPE)
    CallReferenceNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ForwardingReason >-----#
    ForwardingReason = ENUM(name='ForwardingReason', mode=MODE_TYPE)
    ForwardingReason._cont = ASN1Dict([('notReachable', 0), ('busy', 1), ('noReply', 2)])
    ForwardingReason._ext = None
    
    #-----< SupportedCCBS-Phase >-----#
    SupportedCCBS_Phase = INT(name='SupportedCCBS-Phase', mode=MODE_TYPE)
    SupportedCCBS_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallDiversionTreatmentIndicator >-----#
    CallDiversionTreatmentIndicator = OCT_STR(name='CallDiversionTreatmentIndicator', mode=MODE_TYPE)
    CallDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendRoutingInfoRes >-----#
    SendRoutingInfoRes = SEQ(name='SendRoutingInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendRoutingInfoRes_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendRoutingInfoRes_extendedRoutingInfo = CHOICE(name='extendedRoutingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ExtendedRoutingInfo')), opt=True)
    _SendRoutingInfoRes_cug_CheckInfo = SEQ(name='cug-CheckInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoRes_cugSubscriptionFlag = NULL(name='cugSubscriptionFlag', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_subscriberInfo = SEQ(name='subscriberInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')), opt=True)
    _SendRoutingInfoRes_ss_List = SEQ_OF(name='ss-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_forwardingInterrogationRequired = NULL(name='forwardingInterrogationRequired', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_vmsc_Address = OCT_STR(name='vmsc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoRes_naea_PreferredCI = SEQ(name='naea-PreferredCI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _SendRoutingInfoRes_ccbs_Indicators = SEQ(name='ccbs-Indicators', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-Indicators')), opt=True)
    _SendRoutingInfoRes_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_numberPortabilityStatus = ENUM(name='numberPortabilityStatus', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _SendRoutingInfoRes_istAlertTimer = INT(name='istAlertTimer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _SendRoutingInfoRes_supportedCamelPhasesInVMSC = BIT_STR(name='supportedCamelPhasesInVMSC', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SendRoutingInfoRes_offeredCamel4CSIsInVMSC = BIT_STR(name='offeredCamel4CSIsInVMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SendRoutingInfoRes_routingInfo2 = CHOICE(name='routingInfo2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')), opt=True)
    _SendRoutingInfoRes_ss_List2 = SEQ_OF(name='ss-List2', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService2 = CHOICE(name='basicService2', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_allowedServices = BIT_STR(name='allowedServices', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'AllowedServices')), opt=True)
    _SendRoutingInfoRes_unavailabilityCause = ENUM(name='unavailabilityCause', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UnavailabilityCause')), opt=True)
    _SendRoutingInfoRes_releaseResourcesSupported = NULL(name='releaseResourcesSupported', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_gsm_BearerCapability = SEQ(name='gsm-BearerCapability', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    SendRoutingInfoRes._cont = ASN1Dict([
        ('imsi', _SendRoutingInfoRes_imsi),
        ('extendedRoutingInfo', _SendRoutingInfoRes_extendedRoutingInfo),
        ('cug-CheckInfo', _SendRoutingInfoRes_cug_CheckInfo),
        ('cugSubscriptionFlag', _SendRoutingInfoRes_cugSubscriptionFlag),
        ('subscriberInfo', _SendRoutingInfoRes_subscriberInfo),
        ('ss-List', _SendRoutingInfoRes_ss_List),
        ('basicService', _SendRoutingInfoRes_basicService),
        ('forwardingInterrogationRequired', _SendRoutingInfoRes_forwardingInterrogationRequired),
        ('vmsc-Address', _SendRoutingInfoRes_vmsc_Address),
        ('extensionContainer', _SendRoutingInfoRes_extensionContainer),
        ('naea-PreferredCI', _SendRoutingInfoRes_naea_PreferredCI),
        ('ccbs-Indicators', _SendRoutingInfoRes_ccbs_Indicators),
        ('msisdn', _SendRoutingInfoRes_msisdn),
        ('numberPortabilityStatus', _SendRoutingInfoRes_numberPortabilityStatus),
        ('istAlertTimer', _SendRoutingInfoRes_istAlertTimer),
        ('supportedCamelPhasesInVMSC', _SendRoutingInfoRes_supportedCamelPhasesInVMSC),
        ('offeredCamel4CSIsInVMSC', _SendRoutingInfoRes_offeredCamel4CSIsInVMSC),
        ('routingInfo2', _SendRoutingInfoRes_routingInfo2),
        ('ss-List2', _SendRoutingInfoRes_ss_List2),
        ('basicService2', _SendRoutingInfoRes_basicService2),
        ('allowedServices', _SendRoutingInfoRes_allowedServices),
        ('unavailabilityCause', _SendRoutingInfoRes_unavailabilityCause),
        ('releaseResourcesSupported', _SendRoutingInfoRes_releaseResourcesSupported),
        ('gsm-BearerCapability', _SendRoutingInfoRes_gsm_BearerCapability),
        ])
    SendRoutingInfoRes._ext = ['naea-PreferredCI', 'ccbs-Indicators', 'msisdn', 'numberPortabilityStatus', 'istAlertTimer', 'supportedCamelPhasesInVMSC', 'offeredCamel4CSIsInVMSC', 'routingInfo2', 'ss-List2', 'basicService2', 'allowedServices', 'unavailabilityCause', 'releaseResourcesSupported', 'gsm-BearerCapability']
    
    #-----< AllowedServices >-----#
    AllowedServices = BIT_STR(name='AllowedServices', mode=MODE_TYPE)
    AllowedServices._cont = ASN1Dict([('firstServiceAllowed', 0), ('secondServiceAllowed', 1)])
    AllowedServices._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UnavailabilityCause >-----#
    UnavailabilityCause = ENUM(name='UnavailabilityCause', mode=MODE_TYPE)
    UnavailabilityCause._cont = ASN1Dict([('bearerServiceNotProvisioned', 1), ('teleserviceNotProvisioned', 2), ('absentSubscriber', 3), ('busySubscriber', 4), ('callBarred', 5), ('cug-Reject', 6)])
    UnavailabilityCause._ext = []
    
    #-----< CCBS-Indicators >-----#
    CCBS_Indicators = SEQ(name='CCBS-Indicators', mode=MODE_TYPE)
    _CCBS_Indicators_ccbs_Possible = NULL(name='ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_keepCCBS_CallIndicator = NULL(name='keepCCBS-CallIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CCBS_Indicators._cont = ASN1Dict([
        ('ccbs-Possible', _CCBS_Indicators_ccbs_Possible),
        ('keepCCBS-CallIndicator', _CCBS_Indicators_keepCCBS_CallIndicator),
        ('extensionContainer', _CCBS_Indicators_extensionContainer),
        ])
    CCBS_Indicators._ext = []
    
    #-----< RoutingInfo >-----#
    RoutingInfo = CHOICE(name='RoutingInfo', mode=MODE_TYPE)
    _RoutingInfo_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfo_forwardingData = SEQ(name='forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')))
    RoutingInfo._cont = ASN1Dict([
        ('roamingNumber', _RoutingInfo_roamingNumber),
        ('forwardingData', _RoutingInfo_forwardingData),
        ])
    RoutingInfo._ext = None
    
    #-----< ForwardingData >-----#
    ForwardingData = SEQ(name='ForwardingData', mode=MODE_TYPE)
    _ForwardingData_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingData_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingData_forwardingOptions = OCT_STR(name='forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardingData_longForwardedToNumber = OCT_STR(name='longForwardedToNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingData._cont = ASN1Dict([
        ('forwardedToNumber', _ForwardingData_forwardedToNumber),
        ('forwardedToSubaddress', _ForwardingData_forwardedToSubaddress),
        ('forwardingOptions', _ForwardingData_forwardingOptions),
        ('extensionContainer', _ForwardingData_extensionContainer),
        ('longForwardedToNumber', _ForwardingData_longForwardedToNumber),
        ])
    ForwardingData._ext = ['longForwardedToNumber']
    
    #-----< ProvideRoamingNumberArg >-----#
    ProvideRoamingNumberArg = SEQ(name='ProvideRoamingNumberArg', mode=MODE_TYPE)
    _ProvideRoamingNumberArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideRoamingNumberArg_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideRoamingNumberArg_gsm_BearerCapability = SEQ(name='gsm-BearerCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_networkSignalInfo = SEQ(name='networkSignalInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _ProvideRoamingNumberArg_gmsc_Address = OCT_STR(name='gmsc-Address', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ProvideRoamingNumberArg_or_Interrogation = NULL(name='or-Interrogation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberArg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _ProvideRoamingNumberArg_ccbs_Call = NULL(name='ccbs-Call', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode = BIT_STR(name='supportedCamelPhasesInInterrogatingNode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _ProvideRoamingNumberArg_additionalSignalInfo = SEQ(name='additionalSignalInfo', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_orNotSupportedInGMSC = NULL(name='orNotSupportedInGMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pre_pagingSupported = NULL(name='pre-pagingSupported', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_suppress_VT_CSI = NULL(name='suppress-VT-CSI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode = BIT_STR(name='offeredCamel4CSIsInInterrogatingNode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _ProvideRoamingNumberArg_mtRoamingRetrySupported = NULL(name='mtRoamingRetrySupported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pagingArea = SEQ_OF(name='pagingArea', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _ProvideRoamingNumberArg_callPriority = INT(name='callPriority', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _ProvideRoamingNumberArg_mtrf_Indicator = NULL(name='mtrf-Indicator', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_oldMSC_Number = OCT_STR(name='oldMSC-Number', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lastUsedLtePLMN_Id = OCT_STR(name='lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    ProvideRoamingNumberArg._cont = ASN1Dict([
        ('imsi', _ProvideRoamingNumberArg_imsi),
        ('msc-Number', _ProvideRoamingNumberArg_msc_Number),
        ('msisdn', _ProvideRoamingNumberArg_msisdn),
        ('lmsi', _ProvideRoamingNumberArg_lmsi),
        ('gsm-BearerCapability', _ProvideRoamingNumberArg_gsm_BearerCapability),
        ('networkSignalInfo', _ProvideRoamingNumberArg_networkSignalInfo),
        ('suppressionOfAnnouncement', _ProvideRoamingNumberArg_suppressionOfAnnouncement),
        ('gmsc-Address', _ProvideRoamingNumberArg_gmsc_Address),
        ('callReferenceNumber', _ProvideRoamingNumberArg_callReferenceNumber),
        ('or-Interrogation', _ProvideRoamingNumberArg_or_Interrogation),
        ('extensionContainer', _ProvideRoamingNumberArg_extensionContainer),
        ('alertingPattern', _ProvideRoamingNumberArg_alertingPattern),
        ('ccbs-Call', _ProvideRoamingNumberArg_ccbs_Call),
        ('supportedCamelPhasesInInterrogatingNode', _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode),
        ('additionalSignalInfo', _ProvideRoamingNumberArg_additionalSignalInfo),
        ('orNotSupportedInGMSC', _ProvideRoamingNumberArg_orNotSupportedInGMSC),
        ('pre-pagingSupported', _ProvideRoamingNumberArg_pre_pagingSupported),
        ('longFTN-Supported', _ProvideRoamingNumberArg_longFTN_Supported),
        ('suppress-VT-CSI', _ProvideRoamingNumberArg_suppress_VT_CSI),
        ('offeredCamel4CSIsInInterrogatingNode', _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode),
        ('mtRoamingRetrySupported', _ProvideRoamingNumberArg_mtRoamingRetrySupported),
        ('pagingArea', _ProvideRoamingNumberArg_pagingArea),
        ('callPriority', _ProvideRoamingNumberArg_callPriority),
        ('mtrf-Indicator', _ProvideRoamingNumberArg_mtrf_Indicator),
        ('oldMSC-Number', _ProvideRoamingNumberArg_oldMSC_Number),
        ('lastUsedLtePLMN-Id', _ProvideRoamingNumberArg_lastUsedLtePLMN_Id),
        ])
    ProvideRoamingNumberArg._ext = ['alertingPattern', 'ccbs-Call', 'supportedCamelPhasesInInterrogatingNode', 'additionalSignalInfo', 'orNotSupportedInGMSC', 'pre-pagingSupported', 'longFTN-Supported', 'suppress-VT-CSI', 'offeredCamel4CSIsInInterrogatingNode', 'mtRoamingRetrySupported', 'pagingArea', 'callPriority', 'mtrf-Indicator', 'oldMSC-Number', 'lastUsedLtePLMN-Id']
    
    #-----< ProvideRoamingNumberRes >-----#
    ProvideRoamingNumberRes = SEQ(name='ProvideRoamingNumberRes', mode=MODE_TYPE)
    _ProvideRoamingNumberRes_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberRes_releaseResourcesSupported = NULL(name='releaseResourcesSupported', mode=MODE_TYPE, opt=True)
    _ProvideRoamingNumberRes_vmsc_Address = OCT_STR(name='vmsc-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ProvideRoamingNumberRes._cont = ASN1Dict([
        ('roamingNumber', _ProvideRoamingNumberRes_roamingNumber),
        ('extensionContainer', _ProvideRoamingNumberRes_extensionContainer),
        ('releaseResourcesSupported', _ProvideRoamingNumberRes_releaseResourcesSupported),
        ('vmsc-Address', _ProvideRoamingNumberRes_vmsc_Address),
        ])
    ProvideRoamingNumberRes._ext = ['releaseResourcesSupported', 'vmsc-Address']
    
    #-----< ResumeCallHandlingArg >-----#
    ResumeCallHandlingArg = SEQ(name='ResumeCallHandlingArg', mode=MODE_TYPE)
    _ResumeCallHandlingArg_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup = CHOICE(name='basicServiceGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_forwardingData = SEQ(name='forwardingData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _ResumeCallHandlingArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ResumeCallHandlingArg_cug_CheckInfo = SEQ(name='cug-CheckInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _ResumeCallHandlingArg_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _ResumeCallHandlingArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResumeCallHandlingArg_ccbs_Possible = NULL(name='ccbs-Possible', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ResumeCallHandlingArg_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    _ResumeCallHandlingArg_allInformationSent = NULL(name='allInformationSent', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_d_csi = SEQ(name='d-csi', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList = SEQ_OF(name='o-BcsmCamelTDPCriteriaList', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup2 = CHOICE(name='basicServiceGroup2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_mtRoamingRetry = NULL(name='mtRoamingRetry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ResumeCallHandlingArg._cont = ASN1Dict([
        ('callReferenceNumber', _ResumeCallHandlingArg_callReferenceNumber),
        ('basicServiceGroup', _ResumeCallHandlingArg_basicServiceGroup),
        ('forwardingData', _ResumeCallHandlingArg_forwardingData),
        ('imsi', _ResumeCallHandlingArg_imsi),
        ('cug-CheckInfo', _ResumeCallHandlingArg_cug_CheckInfo),
        ('o-CSI', _ResumeCallHandlingArg_o_CSI),
        ('extensionContainer', _ResumeCallHandlingArg_extensionContainer),
        ('ccbs-Possible', _ResumeCallHandlingArg_ccbs_Possible),
        ('msisdn', _ResumeCallHandlingArg_msisdn),
        ('uu-Data', _ResumeCallHandlingArg_uu_Data),
        ('allInformationSent', _ResumeCallHandlingArg_allInformationSent),
        ('d-csi', _ResumeCallHandlingArg_d_csi),
        ('o-BcsmCamelTDPCriteriaList', _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList),
        ('basicServiceGroup2', _ResumeCallHandlingArg_basicServiceGroup2),
        ('mtRoamingRetry', _ResumeCallHandlingArg_mtRoamingRetry),
        ])
    ResumeCallHandlingArg._ext = ['d-csi', 'o-BcsmCamelTDPCriteriaList', 'basicServiceGroup2', 'mtRoamingRetry']
    
    #-----< UU-Data >-----#
    UU_Data = SEQ(name='UU-Data', mode=MODE_TYPE)
    _UU_Data_uuIndicator = OCT_STR(name='uuIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUIndicator')), opt=True)
    _UU_Data_uui = OCT_STR(name='uui', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUI')), opt=True)
    _UU_Data_uusCFInteraction = NULL(name='uusCFInteraction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UU_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UU_Data._cont = ASN1Dict([
        ('uuIndicator', _UU_Data_uuIndicator),
        ('uui', _UU_Data_uui),
        ('uusCFInteraction', _UU_Data_uusCFInteraction),
        ('extensionContainer', _UU_Data_extensionContainer),
        ])
    UU_Data._ext = []
    
    #-----< UUIndicator >-----#
    UUIndicator = OCT_STR(name='UUIndicator', mode=MODE_TYPE)
    UUIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< UUI >-----#
    UUI = OCT_STR(name='UUI', mode=MODE_TYPE)
    UUI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131)], ev=None, er=[])
    
    #-----< ResumeCallHandlingRes >-----#
    ResumeCallHandlingRes = SEQ(name='ResumeCallHandlingRes', mode=MODE_TYPE)
    _ResumeCallHandlingRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResumeCallHandlingRes._cont = ASN1Dict([
        ('extensionContainer', _ResumeCallHandlingRes_extensionContainer),
        ])
    ResumeCallHandlingRes._ext = []
    
    #-----< CamelInfo >-----#
    CamelInfo = SEQ(name='CamelInfo', mode=MODE_TYPE)
    _CamelInfo_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')))
    _CamelInfo_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, opt=True)
    _CamelInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CamelInfo_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    CamelInfo._cont = ASN1Dict([
        ('supportedCamelPhases', _CamelInfo_supportedCamelPhases),
        ('suppress-T-CSI', _CamelInfo_suppress_T_CSI),
        ('extensionContainer', _CamelInfo_extensionContainer),
        ('offeredCamel4CSIs', _CamelInfo_offeredCamel4CSIs),
        ])
    CamelInfo._ext = ['offeredCamel4CSIs']
    
    #-----< ExtendedRoutingInfo >-----#
    ExtendedRoutingInfo = CHOICE(name='ExtendedRoutingInfo', mode=MODE_TYPE)
    _ExtendedRoutingInfo_routingInfo = CHOICE(name='routingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')))
    _ExtendedRoutingInfo_camelRoutingInfo = SEQ(name='camelRoutingInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelRoutingInfo')))
    ExtendedRoutingInfo._cont = ASN1Dict([
        ('routingInfo', _ExtendedRoutingInfo_routingInfo),
        ('camelRoutingInfo', _ExtendedRoutingInfo_camelRoutingInfo),
        ])
    ExtendedRoutingInfo._ext = None
    
    #-----< CamelRoutingInfo >-----#
    CamelRoutingInfo = SEQ(name='CamelRoutingInfo', mode=MODE_TYPE)
    _CamelRoutingInfo_forwardingData = SEQ(name='forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _CamelRoutingInfo_gmscCamelSubscriptionInfo = SEQ(name='gmscCamelSubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'GmscCamelSubscriptionInfo')))
    _CamelRoutingInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CamelRoutingInfo._cont = ASN1Dict([
        ('forwardingData', _CamelRoutingInfo_forwardingData),
        ('gmscCamelSubscriptionInfo', _CamelRoutingInfo_gmscCamelSubscriptionInfo),
        ('extensionContainer', _CamelRoutingInfo_extensionContainer),
        ])
    CamelRoutingInfo._ext = []
    
    #-----< GmscCamelSubscriptionInfo >-----#
    GmscCamelSubscriptionInfo = SEQ(name='GmscCamelSubscriptionInfo', mode=MODE_TYPE)
    _GmscCamelSubscriptionInfo_t_CSI = SEQ(name='t-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='t-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_d_csi = SEQ(name='d-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    GmscCamelSubscriptionInfo._cont = ASN1Dict([
        ('t-CSI', _GmscCamelSubscriptionInfo_t_CSI),
        ('o-CSI', _GmscCamelSubscriptionInfo_o_CSI),
        ('extensionContainer', _GmscCamelSubscriptionInfo_extensionContainer),
        ('o-BcsmCamelTDP-CriteriaList', _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        ('t-BCSM-CAMEL-TDP-CriteriaList', _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        ('d-csi', _GmscCamelSubscriptionInfo_d_csi),
        ])
    GmscCamelSubscriptionInfo._ext = ['o-BcsmCamelTDP-CriteriaList', 't-BCSM-CAMEL-TDP-CriteriaList', 'd-csi']
    
    #-----< SetReportingStateArg >-----#
    SetReportingStateArg = SEQ(name='SetReportingStateArg', mode=MODE_TYPE)
    _SetReportingStateArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SetReportingStateArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _SetReportingStateArg_ccbs_Monitoring = ENUM(name='ccbs-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ReportingState')), opt=True)
    _SetReportingStateArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateArg._cont = ASN1Dict([
        ('imsi', _SetReportingStateArg_imsi),
        ('lmsi', _SetReportingStateArg_lmsi),
        ('ccbs-Monitoring', _SetReportingStateArg_ccbs_Monitoring),
        ('extensionContainer', _SetReportingStateArg_extensionContainer),
        ])
    SetReportingStateArg._ext = []
    
    #-----< ReportingState >-----#
    ReportingState = ENUM(name='ReportingState', mode=MODE_TYPE)
    ReportingState._cont = ASN1Dict([('stopMonitoring', 0), ('startMonitoring', 1)])
    ReportingState._ext = []
    
    #-----< SetReportingStateRes >-----#
    SetReportingStateRes = SEQ(name='SetReportingStateRes', mode=MODE_TYPE)
    _SetReportingStateRes_ccbs_SubscriberStatus = ENUM(name='ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _SetReportingStateRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateRes._cont = ASN1Dict([
        ('ccbs-SubscriberStatus', _SetReportingStateRes_ccbs_SubscriberStatus),
        ('extensionContainer', _SetReportingStateRes_extensionContainer),
        ])
    SetReportingStateRes._ext = []
    
    #-----< CCBS-SubscriberStatus >-----#
    CCBS_SubscriberStatus = ENUM(name='CCBS-SubscriberStatus', mode=MODE_TYPE)
    CCBS_SubscriberStatus._cont = ASN1Dict([('ccbsNotIdle', 0), ('ccbsIdle', 1), ('ccbsNotReachable', 2)])
    CCBS_SubscriberStatus._ext = []
    
    #-----< StatusReportArg >-----#
    StatusReportArg = SEQ(name='StatusReportArg', mode=MODE_TYPE)
    _StatusReportArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _StatusReportArg_eventReportData = SEQ(name='eventReportData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'EventReportData')), opt=True)
    _StatusReportArg_callReportdata = SEQ(name='callReportdata', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReportData')), opt=True)
    _StatusReportArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportArg._cont = ASN1Dict([
        ('imsi', _StatusReportArg_imsi),
        ('eventReportData', _StatusReportArg_eventReportData),
        ('callReportdata', _StatusReportArg_callReportdata),
        ('extensionContainer', _StatusReportArg_extensionContainer),
        ])
    StatusReportArg._ext = []
    
    #-----< EventReportData >-----#
    EventReportData = SEQ(name='EventReportData', mode=MODE_TYPE)
    _EventReportData_ccbs_SubscriberStatus = ENUM(name='ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _EventReportData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EventReportData._cont = ASN1Dict([
        ('ccbs-SubscriberStatus', _EventReportData_ccbs_SubscriberStatus),
        ('extensionContainer', _EventReportData_extensionContainer),
        ])
    EventReportData._ext = []
    
    #-----< CallReportData >-----#
    CallReportData = SEQ(name='CallReportData', mode=MODE_TYPE)
    _CallReportData_monitoringMode = ENUM(name='monitoringMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'MonitoringMode')), opt=True)
    _CallReportData_callOutcome = ENUM(name='callOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallOutcome')), opt=True)
    _CallReportData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallReportData._cont = ASN1Dict([
        ('monitoringMode', _CallReportData_monitoringMode),
        ('callOutcome', _CallReportData_callOutcome),
        ('extensionContainer', _CallReportData_extensionContainer),
        ])
    CallReportData._ext = []
    
    #-----< MonitoringMode >-----#
    MonitoringMode = ENUM(name='MonitoringMode', mode=MODE_TYPE)
    MonitoringMode._cont = ASN1Dict([('a-side', 0), ('b-side', 1)])
    MonitoringMode._ext = []
    
    #-----< CallOutcome >-----#
    CallOutcome = ENUM(name='CallOutcome', mode=MODE_TYPE)
    CallOutcome._cont = ASN1Dict([('success', 0), ('failure', 1), ('busy', 2)])
    CallOutcome._ext = []
    
    #-----< StatusReportRes >-----#
    StatusReportRes = SEQ(name='StatusReportRes', mode=MODE_TYPE)
    _StatusReportRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportRes._cont = ASN1Dict([
        ('extensionContainer', _StatusReportRes_extensionContainer),
        ])
    StatusReportRes._ext = []
    
    #-----< RemoteUserFreeArg >-----#
    RemoteUserFreeArg = SEQ(name='RemoteUserFreeArg', mode=MODE_TYPE)
    _RemoteUserFreeArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RemoteUserFreeArg_callInfo = SEQ(name='callInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _RemoteUserFreeArg_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _RemoteUserFreeArg_translatedB_Number = OCT_STR(name='translatedB-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RemoteUserFreeArg_replaceB_Number = NULL(name='replaceB-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RemoteUserFreeArg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _RemoteUserFreeArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeArg._cont = ASN1Dict([
        ('imsi', _RemoteUserFreeArg_imsi),
        ('callInfo', _RemoteUserFreeArg_callInfo),
        ('ccbs-Feature', _RemoteUserFreeArg_ccbs_Feature),
        ('translatedB-Number', _RemoteUserFreeArg_translatedB_Number),
        ('replaceB-Number', _RemoteUserFreeArg_replaceB_Number),
        ('alertingPattern', _RemoteUserFreeArg_alertingPattern),
        ('extensionContainer', _RemoteUserFreeArg_extensionContainer),
        ])
    RemoteUserFreeArg._ext = []
    
    #-----< RemoteUserFreeRes >-----#
    RemoteUserFreeRes = SEQ(name='RemoteUserFreeRes', mode=MODE_TYPE)
    _RemoteUserFreeRes_ruf_Outcome = ENUM(name='ruf-Outcome', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RUF-Outcome')))
    _RemoteUserFreeRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeRes._cont = ASN1Dict([
        ('ruf-Outcome', _RemoteUserFreeRes_ruf_Outcome),
        ('extensionContainer', _RemoteUserFreeRes_extensionContainer),
        ])
    RemoteUserFreeRes._ext = []
    
    #-----< RUF-Outcome >-----#
    RUF_Outcome = ENUM(name='RUF-Outcome', mode=MODE_TYPE)
    RUF_Outcome._cont = ASN1Dict([('accepted', 0), ('rejected', 1), ('noResponseFromFreeMS', 2), ('noResponseFromBusyMS', 3), ('udubFromFreeMS', 4), ('udubFromBusyMS', 5)])
    RUF_Outcome._ext = []
    
    #-----< IST-AlertArg >-----#
    IST_AlertArg = SEQ(name='IST-AlertArg', mode=MODE_TYPE)
    _IST_AlertArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_AlertArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertArg._cont = ASN1Dict([
        ('imsi', _IST_AlertArg_imsi),
        ('extensionContainer', _IST_AlertArg_extensionContainer),
        ])
    IST_AlertArg._ext = []
    
    #-----< IST-AlertRes >-----#
    IST_AlertRes = SEQ(name='IST-AlertRes', mode=MODE_TYPE)
    _IST_AlertRes_istAlertTimer = INT(name='istAlertTimer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _IST_AlertRes_istInformationWithdraw = NULL(name='istInformationWithdraw', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IST_AlertRes_callTerminationIndicator = ENUM(name='callTerminationIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallTerminationIndicator')), opt=True)
    _IST_AlertRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertRes._cont = ASN1Dict([
        ('istAlertTimer', _IST_AlertRes_istAlertTimer),
        ('istInformationWithdraw', _IST_AlertRes_istInformationWithdraw),
        ('callTerminationIndicator', _IST_AlertRes_callTerminationIndicator),
        ('extensionContainer', _IST_AlertRes_extensionContainer),
        ])
    IST_AlertRes._ext = []
    
    #-----< IST-CommandArg >-----#
    IST_CommandArg = SEQ(name='IST-CommandArg', mode=MODE_TYPE)
    _IST_CommandArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_CommandArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandArg._cont = ASN1Dict([
        ('imsi', _IST_CommandArg_imsi),
        ('extensionContainer', _IST_CommandArg_extensionContainer),
        ])
    IST_CommandArg._ext = []
    
    #-----< IST-CommandRes >-----#
    IST_CommandRes = SEQ(name='IST-CommandRes', mode=MODE_TYPE)
    _IST_CommandRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandRes._cont = ASN1Dict([
        ('extensionContainer', _IST_CommandRes_extensionContainer),
        ])
    IST_CommandRes._ext = []
    
    #-----< CallTerminationIndicator >-----#
    CallTerminationIndicator = ENUM(name='CallTerminationIndicator', mode=MODE_TYPE)
    CallTerminationIndicator._cont = ASN1Dict([('terminateCallActivityReferred', 0), ('terminateAllCallActivities', 1)])
    CallTerminationIndicator._ext = []
    
    #-----< ReleaseResourcesArg >-----#
    ReleaseResourcesArg = SEQ(name='ReleaseResourcesArg', mode=MODE_TYPE)
    _ReleaseResourcesArg_msrn = OCT_STR(name='msrn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ReleaseResourcesArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesArg._cont = ASN1Dict([
        ('msrn', _ReleaseResourcesArg_msrn),
        ('extensionContainer', _ReleaseResourcesArg_extensionContainer),
        ])
    ReleaseResourcesArg._ext = []
    
    #-----< ReleaseResourcesRes >-----#
    ReleaseResourcesRes = SEQ(name='ReleaseResourcesRes', mode=MODE_TYPE)
    _ReleaseResourcesRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesRes._cont = ASN1Dict([
        ('extensionContainer', _ReleaseResourcesRes_extensionContainer),
        ])
    ReleaseResourcesRes._ext = []
    
    _all_ = [
        _CUG_CheckInfo_cug_Interlock,
        _CUG_CheckInfo_cug_OutgoingAccess,
        _CUG_CheckInfo_extensionContainer,
        CUG_CheckInfo,
        NumberOfForwarding,
        _SendRoutingInfoArg_msisdn,
        _SendRoutingInfoArg_cug_CheckInfo,
        _SendRoutingInfoArg_numberOfForwarding,
        _SendRoutingInfoArg_interrogationType,
        _SendRoutingInfoArg_or_Interrogation,
        _SendRoutingInfoArg_or_Capability,
        _SendRoutingInfoArg_gmsc_OrGsmSCF_Address,
        _SendRoutingInfoArg_callReferenceNumber,
        _SendRoutingInfoArg_forwardingReason,
        _SendRoutingInfoArg_basicServiceGroup,
        _SendRoutingInfoArg_networkSignalInfo,
        _SendRoutingInfoArg_camelInfo,
        _SendRoutingInfoArg_suppressionOfAnnouncement,
        _SendRoutingInfoArg_extensionContainer,
        _SendRoutingInfoArg_alertingPattern,
        _SendRoutingInfoArg_ccbs_Call,
        _SendRoutingInfoArg_supportedCCBS_Phase,
        _SendRoutingInfoArg_additionalSignalInfo,
        _SendRoutingInfoArg_istSupportIndicator,
        _SendRoutingInfoArg_pre_pagingSupported,
        _SendRoutingInfoArg_callDiversionTreatmentIndicator,
        _SendRoutingInfoArg_longFTN_Supported,
        _SendRoutingInfoArg_suppress_VT_CSI,
        _SendRoutingInfoArg_suppressIncomingCallBarring,
        _SendRoutingInfoArg_gsmSCF_InitiatedCall,
        _SendRoutingInfoArg_basicServiceGroup2,
        _SendRoutingInfoArg_networkSignalInfo2,
        _SendRoutingInfoArg_suppressMTSS,
        _SendRoutingInfoArg_mtRoamingRetrySupported,
        _SendRoutingInfoArg_callPriority,
        SendRoutingInfoArg,
        SuppressionOfAnnouncement,
        SuppressMTSS,
        InterrogationType,
        OR_Phase,
        CallReferenceNumber,
        ForwardingReason,
        SupportedCCBS_Phase,
        CallDiversionTreatmentIndicator,
        _SendRoutingInfoRes_imsi,
        _SendRoutingInfoRes_extendedRoutingInfo,
        _SendRoutingInfoRes_cug_CheckInfo,
        _SendRoutingInfoRes_cugSubscriptionFlag,
        _SendRoutingInfoRes_subscriberInfo,
        _SendRoutingInfoRes_ss_List,
        _SendRoutingInfoRes_basicService,
        _SendRoutingInfoRes_forwardingInterrogationRequired,
        _SendRoutingInfoRes_vmsc_Address,
        _SendRoutingInfoRes_extensionContainer,
        _SendRoutingInfoRes_naea_PreferredCI,
        _SendRoutingInfoRes_ccbs_Indicators,
        _SendRoutingInfoRes_msisdn,
        _SendRoutingInfoRes_numberPortabilityStatus,
        _SendRoutingInfoRes_istAlertTimer,
        _SendRoutingInfoRes_supportedCamelPhasesInVMSC,
        _SendRoutingInfoRes_offeredCamel4CSIsInVMSC,
        _SendRoutingInfoRes_routingInfo2,
        _SendRoutingInfoRes_ss_List2,
        _SendRoutingInfoRes_basicService2,
        _SendRoutingInfoRes_allowedServices,
        _SendRoutingInfoRes_unavailabilityCause,
        _SendRoutingInfoRes_releaseResourcesSupported,
        _SendRoutingInfoRes_gsm_BearerCapability,
        SendRoutingInfoRes,
        AllowedServices,
        UnavailabilityCause,
        _CCBS_Indicators_ccbs_Possible,
        _CCBS_Indicators_keepCCBS_CallIndicator,
        _CCBS_Indicators_extensionContainer,
        CCBS_Indicators,
        _RoutingInfo_roamingNumber,
        _RoutingInfo_forwardingData,
        RoutingInfo,
        _ForwardingData_forwardedToNumber,
        _ForwardingData_forwardedToSubaddress,
        _ForwardingData_forwardingOptions,
        _ForwardingData_extensionContainer,
        _ForwardingData_longForwardedToNumber,
        ForwardingData,
        _ProvideRoamingNumberArg_imsi,
        _ProvideRoamingNumberArg_msc_Number,
        _ProvideRoamingNumberArg_msisdn,
        _ProvideRoamingNumberArg_lmsi,
        _ProvideRoamingNumberArg_gsm_BearerCapability,
        _ProvideRoamingNumberArg_networkSignalInfo,
        _ProvideRoamingNumberArg_suppressionOfAnnouncement,
        _ProvideRoamingNumberArg_gmsc_Address,
        _ProvideRoamingNumberArg_callReferenceNumber,
        _ProvideRoamingNumberArg_or_Interrogation,
        _ProvideRoamingNumberArg_extensionContainer,
        _ProvideRoamingNumberArg_alertingPattern,
        _ProvideRoamingNumberArg_ccbs_Call,
        _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode,
        _ProvideRoamingNumberArg_additionalSignalInfo,
        _ProvideRoamingNumberArg_orNotSupportedInGMSC,
        _ProvideRoamingNumberArg_pre_pagingSupported,
        _ProvideRoamingNumberArg_longFTN_Supported,
        _ProvideRoamingNumberArg_suppress_VT_CSI,
        _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode,
        _ProvideRoamingNumberArg_mtRoamingRetrySupported,
        _ProvideRoamingNumberArg_pagingArea,
        _ProvideRoamingNumberArg_callPriority,
        _ProvideRoamingNumberArg_mtrf_Indicator,
        _ProvideRoamingNumberArg_oldMSC_Number,
        _ProvideRoamingNumberArg_lastUsedLtePLMN_Id,
        ProvideRoamingNumberArg,
        _ProvideRoamingNumberRes_roamingNumber,
        _ProvideRoamingNumberRes_extensionContainer,
        _ProvideRoamingNumberRes_releaseResourcesSupported,
        _ProvideRoamingNumberRes_vmsc_Address,
        ProvideRoamingNumberRes,
        _ResumeCallHandlingArg_callReferenceNumber,
        _ResumeCallHandlingArg_basicServiceGroup,
        _ResumeCallHandlingArg_forwardingData,
        _ResumeCallHandlingArg_imsi,
        _ResumeCallHandlingArg_cug_CheckInfo,
        _ResumeCallHandlingArg_o_CSI,
        _ResumeCallHandlingArg_extensionContainer,
        _ResumeCallHandlingArg_ccbs_Possible,
        _ResumeCallHandlingArg_msisdn,
        _ResumeCallHandlingArg_uu_Data,
        _ResumeCallHandlingArg_allInformationSent,
        _ResumeCallHandlingArg_d_csi,
        _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList,
        _ResumeCallHandlingArg_basicServiceGroup2,
        _ResumeCallHandlingArg_mtRoamingRetry,
        ResumeCallHandlingArg,
        _UU_Data_uuIndicator,
        _UU_Data_uui,
        _UU_Data_uusCFInteraction,
        _UU_Data_extensionContainer,
        UU_Data,
        UUIndicator,
        UUI,
        _ResumeCallHandlingRes_extensionContainer,
        ResumeCallHandlingRes,
        _CamelInfo_supportedCamelPhases,
        _CamelInfo_suppress_T_CSI,
        _CamelInfo_extensionContainer,
        _CamelInfo_offeredCamel4CSIs,
        CamelInfo,
        _ExtendedRoutingInfo_routingInfo,
        _ExtendedRoutingInfo_camelRoutingInfo,
        ExtendedRoutingInfo,
        _CamelRoutingInfo_forwardingData,
        _CamelRoutingInfo_gmscCamelSubscriptionInfo,
        _CamelRoutingInfo_extensionContainer,
        CamelRoutingInfo,
        _GmscCamelSubscriptionInfo_t_CSI,
        _GmscCamelSubscriptionInfo_o_CSI,
        _GmscCamelSubscriptionInfo_extensionContainer,
        _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _GmscCamelSubscriptionInfo_d_csi,
        GmscCamelSubscriptionInfo,
        _SetReportingStateArg_imsi,
        _SetReportingStateArg_lmsi,
        _SetReportingStateArg_ccbs_Monitoring,
        _SetReportingStateArg_extensionContainer,
        SetReportingStateArg,
        ReportingState,
        _SetReportingStateRes_ccbs_SubscriberStatus,
        _SetReportingStateRes_extensionContainer,
        SetReportingStateRes,
        CCBS_SubscriberStatus,
        _StatusReportArg_imsi,
        _StatusReportArg_eventReportData,
        _StatusReportArg_callReportdata,
        _StatusReportArg_extensionContainer,
        StatusReportArg,
        _EventReportData_ccbs_SubscriberStatus,
        _EventReportData_extensionContainer,
        EventReportData,
        _CallReportData_monitoringMode,
        _CallReportData_callOutcome,
        _CallReportData_extensionContainer,
        CallReportData,
        MonitoringMode,
        CallOutcome,
        _StatusReportRes_extensionContainer,
        StatusReportRes,
        _RemoteUserFreeArg_imsi,
        _RemoteUserFreeArg_callInfo,
        _RemoteUserFreeArg_ccbs_Feature,
        _RemoteUserFreeArg_translatedB_Number,
        _RemoteUserFreeArg_replaceB_Number,
        _RemoteUserFreeArg_alertingPattern,
        _RemoteUserFreeArg_extensionContainer,
        RemoteUserFreeArg,
        _RemoteUserFreeRes_ruf_Outcome,
        _RemoteUserFreeRes_extensionContainer,
        RemoteUserFreeRes,
        RUF_Outcome,
        _IST_AlertArg_imsi,
        _IST_AlertArg_extensionContainer,
        IST_AlertArg,
        _IST_AlertRes_istAlertTimer,
        _IST_AlertRes_istInformationWithdraw,
        _IST_AlertRes_callTerminationIndicator,
        _IST_AlertRes_extensionContainer,
        IST_AlertRes,
        _IST_CommandArg_imsi,
        _IST_CommandArg_extensionContainer,
        IST_CommandArg,
        _IST_CommandRes_extensionContainer,
        IST_CommandRes,
        CallTerminationIndicator,
        _ReleaseResourcesArg_msrn,
        _ReleaseResourcesArg_extensionContainer,
        ReleaseResourcesArg,
        _ReleaseResourcesRes_extensionContainer,
        ReleaseResourcesRes,
    ]

class MAP_SS_DataTypes:

    _name_  = 'MAP-SS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 14, 19]
    
    _obj_ = [
        'RegisterSS-Arg',
        'NoReplyConditionTime',
        'SS-Info',
        'ForwardingInfo',
        'ForwardingFeatureList',
        'ForwardingFeature',
        'SS-Status',
        'ForwardingOptions',
        'CallBarringInfo',
        'CallBarringFeatureList',
        'CallBarringFeature',
        'SS-Data',
        'SS-SubscriptionOption',
        'CliRestrictionOption',
        'OverrideCategory',
        'SS-ForBS-Code',
        'GenericServiceInfo',
        'CCBS-FeatureList',
        'maxNumOfCCBS-Requests',
        'CCBS-Feature',
        'CCBS-Index',
        'InterrogateSS-Res',
        'USSD-Arg',
        'USSD-Res',
        'USSD-DataCodingScheme',
        'USSD-String',
        'maxUSSD-StringLength',
        'Password',
        'GuidanceInfo',
        'SS-List',
        'maxNumOfSS',
        'SS-InfoList',
        'BasicServiceGroupList',
        'maxNumOfBasicServiceGroups',
        'SS-InvocationNotificationArg',
        'CCBS-RequestState',
        'SS-InvocationNotificationRes',
        'SS-EventSpecification',
        'maxEventSpecification',
        'RegisterCC-EntryArg',
        'CCBS-Data',
        'ServiceIndicator',
        'RegisterCC-EntryRes',
        'EraseCC-EntryArg',
        'EraseCC-EntryRes',
        ]
    _type_ = [
        'RegisterSS-Arg',
        'NoReplyConditionTime',
        'SS-Info',
        'ForwardingInfo',
        'ForwardingFeatureList',
        'ForwardingFeature',
        'SS-Status',
        'ForwardingOptions',
        'CallBarringInfo',
        'CallBarringFeatureList',
        'CallBarringFeature',
        'SS-Data',
        'SS-SubscriptionOption',
        'CliRestrictionOption',
        'OverrideCategory',
        'SS-ForBS-Code',
        'GenericServiceInfo',
        'CCBS-FeatureList',
        'CCBS-Feature',
        'CCBS-Index',
        'InterrogateSS-Res',
        'USSD-Arg',
        'USSD-Res',
        'USSD-DataCodingScheme',
        'USSD-String',
        'Password',
        'GuidanceInfo',
        'SS-List',
        'SS-InfoList',
        'BasicServiceGroupList',
        'SS-InvocationNotificationArg',
        'CCBS-RequestState',
        'SS-InvocationNotificationRes',
        'SS-EventSpecification',
        'RegisterCC-EntryArg',
        'CCBS-Data',
        'ServiceIndicator',
        'RegisterCC-EntryRes',
        'EraseCC-EntryArg',
        'EraseCC-EntryRes',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxNumOfCCBS-Requests',
        'maxUSSD-StringLength',
        'maxNumOfSS',
        'maxNumOfBasicServiceGroups',
        'maxEventSpecification',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RegisterSS-Arg >-----#
    RegisterSS_Arg = SEQ(name='RegisterSS-Arg', mode=MODE_TYPE)
    _RegisterSS_Arg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterSS_Arg_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _RegisterSS_Arg_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _RegisterSS_Arg_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _RegisterSS_Arg_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _RegisterSS_Arg_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _RegisterSS_Arg_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _RegisterSS_Arg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RegisterSS_Arg._cont = ASN1Dict([
        ('ss-Code', _RegisterSS_Arg_ss_Code),
        ('basicService', _RegisterSS_Arg_basicService),
        ('forwardedToNumber', _RegisterSS_Arg_forwardedToNumber),
        ('forwardedToSubaddress', _RegisterSS_Arg_forwardedToSubaddress),
        ('noReplyConditionTime', _RegisterSS_Arg_noReplyConditionTime),
        ('defaultPriority', _RegisterSS_Arg_defaultPriority),
        ('nbrUser', _RegisterSS_Arg_nbrUser),
        ('longFTN-Supported', _RegisterSS_Arg_longFTN_Supported),
        ])
    RegisterSS_Arg._ext = ['defaultPriority', 'nbrUser', 'longFTN-Supported']
    
    #-----< NoReplyConditionTime >-----#
    NoReplyConditionTime = INT(name='NoReplyConditionTime', mode=MODE_TYPE)
    NoReplyConditionTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=30)], ev=None, er=[])
    
    #-----< SS-Info >-----#
    SS_Info = CHOICE(name='SS-Info', mode=MODE_TYPE)
    _SS_Info_forwardingInfo = SEQ(name='forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingInfo')))
    _SS_Info_callBarringInfo = SEQ(name='callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringInfo')))
    _SS_Info_ss_Data = SEQ(name='ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Data')))
    SS_Info._cont = ASN1Dict([
        ('forwardingInfo', _SS_Info_forwardingInfo),
        ('callBarringInfo', _SS_Info_callBarringInfo),
        ('ss-Data', _SS_Info_ss_Data),
        ])
    SS_Info._ext = None
    
    #-----< ForwardingInfo >-----#
    ForwardingInfo = SEQ(name='ForwardingInfo', mode=MODE_TYPE)
    _ForwardingInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _ForwardingInfo_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    ForwardingInfo._cont = ASN1Dict([
        ('ss-Code', _ForwardingInfo_ss_Code),
        ('forwardingFeatureList', _ForwardingInfo_forwardingFeatureList),
        ])
    ForwardingInfo._ext = []
    
    #-----< ForwardingFeatureList >-----#
    ForwardingFeatureList = SEQ_OF(name='ForwardingFeatureList', mode=MODE_TYPE)
    _ForwardingFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeature')))
    ForwardingFeatureList._cont = _ForwardingFeatureList__item_
    ForwardingFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< ForwardingFeature >-----#
    ForwardingFeature = SEQ(name='ForwardingFeature', mode=MODE_TYPE)
    _ForwardingFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _ForwardingFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _ForwardingFeature_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingFeature_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingFeature_forwardingOptions = OCT_STR(name='forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingFeature_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _ForwardingFeature_longForwardedToNumber = OCT_STR(name='longForwardedToNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingFeature._cont = ASN1Dict([
        ('basicService', _ForwardingFeature_basicService),
        ('ss-Status', _ForwardingFeature_ss_Status),
        ('forwardedToNumber', _ForwardingFeature_forwardedToNumber),
        ('forwardedToSubaddress', _ForwardingFeature_forwardedToSubaddress),
        ('forwardingOptions', _ForwardingFeature_forwardingOptions),
        ('noReplyConditionTime', _ForwardingFeature_noReplyConditionTime),
        ('longForwardedToNumber', _ForwardingFeature_longForwardedToNumber),
        ])
    ForwardingFeature._ext = ['longForwardedToNumber']
    
    #-----< SS-Status >-----#
    SS_Status = OCT_STR(name='SS-Status', mode=MODE_TYPE)
    SS_Status._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ForwardingOptions >-----#
    ForwardingOptions = OCT_STR(name='ForwardingOptions', mode=MODE_TYPE)
    ForwardingOptions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< CallBarringInfo >-----#
    CallBarringInfo = SEQ(name='CallBarringInfo', mode=MODE_TYPE)
    _CallBarringInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _CallBarringInfo_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeatureList')))
    CallBarringInfo._cont = ASN1Dict([
        ('ss-Code', _CallBarringInfo_ss_Code),
        ('callBarringFeatureList', _CallBarringInfo_callBarringFeatureList),
        ])
    CallBarringInfo._ext = []
    
    #-----< CallBarringFeatureList >-----#
    CallBarringFeatureList = SEQ_OF(name='CallBarringFeatureList', mode=MODE_TYPE)
    _CallBarringFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeature')))
    CallBarringFeatureList._cont = _CallBarringFeatureList__item_
    CallBarringFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< CallBarringFeature >-----#
    CallBarringFeature = SEQ(name='CallBarringFeature', mode=MODE_TYPE)
    _CallBarringFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _CallBarringFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    CallBarringFeature._cont = ASN1Dict([
        ('basicService', _CallBarringFeature_basicService),
        ('ss-Status', _CallBarringFeature_ss_Status),
        ])
    CallBarringFeature._ext = []
    
    #-----< SS-Data >-----#
    SS_Data = SEQ(name='SS-Data', mode=MODE_TYPE)
    _SS_Data_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_Data_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _SS_Data_ss_SubscriptionOption = CHOICE(name='ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _SS_Data_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')), opt=True)
    _SS_Data_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _SS_Data_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    SS_Data._cont = ASN1Dict([
        ('ss-Code', _SS_Data_ss_Code),
        ('ss-Status', _SS_Data_ss_Status),
        ('ss-SubscriptionOption', _SS_Data_ss_SubscriptionOption),
        ('basicServiceGroupList', _SS_Data_basicServiceGroupList),
        ('defaultPriority', _SS_Data_defaultPriority),
        ('nbrUser', _SS_Data_nbrUser),
        ])
    SS_Data._ext = ['defaultPriority', 'nbrUser']
    
    #-----< SS-SubscriptionOption >-----#
    SS_SubscriptionOption = CHOICE(name='SS-SubscriptionOption', mode=MODE_TYPE)
    _SS_SubscriptionOption_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')))
    _SS_SubscriptionOption_overrideCategory = ENUM(name='overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    SS_SubscriptionOption._cont = ASN1Dict([
        ('cliRestrictionOption', _SS_SubscriptionOption_cliRestrictionOption),
        ('overrideCategory', _SS_SubscriptionOption_overrideCategory),
        ])
    SS_SubscriptionOption._ext = None
    
    #-----< CliRestrictionOption >-----#
    CliRestrictionOption = ENUM(name='CliRestrictionOption', mode=MODE_TYPE)
    CliRestrictionOption._cont = ASN1Dict([('permanent', 0), ('temporaryDefaultRestricted', 1), ('temporaryDefaultAllowed', 2)])
    CliRestrictionOption._ext = None
    
    #-----< OverrideCategory >-----#
    OverrideCategory = ENUM(name='OverrideCategory', mode=MODE_TYPE)
    OverrideCategory._cont = ASN1Dict([('overrideEnabled', 0), ('overrideDisabled', 1)])
    OverrideCategory._ext = None
    
    #-----< SS-ForBS-Code >-----#
    SS_ForBS_Code = SEQ(name='SS-ForBS-Code', mode=MODE_TYPE)
    _SS_ForBS_Code_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_ForBS_Code_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_ForBS_Code_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_ForBS_Code._cont = ASN1Dict([
        ('ss-Code', _SS_ForBS_Code_ss_Code),
        ('basicService', _SS_ForBS_Code_basicService),
        ('longFTN-Supported', _SS_ForBS_Code_longFTN_Supported),
        ])
    SS_ForBS_Code._ext = ['longFTN-Supported']
    
    #-----< GenericServiceInfo >-----#
    GenericServiceInfo = SEQ(name='GenericServiceInfo', mode=MODE_TYPE)
    _GenericServiceInfo_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _GenericServiceInfo_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _GenericServiceInfo_maximumEntitledPriority = INT(name='maximumEntitledPriority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_ccbs_FeatureList = SEQ_OF(name='ccbs-FeatureList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-FeatureList')), opt=True)
    _GenericServiceInfo_nbrSB = INT(name='nbrSB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')), opt=True)
    _GenericServiceInfo_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _GenericServiceInfo_nbrSN = INT(name='nbrSN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    GenericServiceInfo._cont = ASN1Dict([
        ('ss-Status', _GenericServiceInfo_ss_Status),
        ('cliRestrictionOption', _GenericServiceInfo_cliRestrictionOption),
        ('maximumEntitledPriority', _GenericServiceInfo_maximumEntitledPriority),
        ('defaultPriority', _GenericServiceInfo_defaultPriority),
        ('ccbs-FeatureList', _GenericServiceInfo_ccbs_FeatureList),
        ('nbrSB', _GenericServiceInfo_nbrSB),
        ('nbrUser', _GenericServiceInfo_nbrUser),
        ('nbrSN', _GenericServiceInfo_nbrSN),
        ])
    GenericServiceInfo._ext = ['maximumEntitledPriority', 'defaultPriority', 'ccbs-FeatureList', 'nbrSB', 'nbrUser', 'nbrSN']
    
    #-----< CCBS-FeatureList >-----#
    CCBS_FeatureList = SEQ_OF(name='CCBS-FeatureList', mode=MODE_TYPE)
    _CCBS_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    CCBS_FeatureList._cont = _CCBS_FeatureList__item_
    CCBS_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCCBS-Requests >-----#
    maxNumOfCCBS_Requests = INT(name='maxNumOfCCBS-Requests', mode=MODE_VALUE)
    maxNumOfCCBS_Requests._val = 5
    
    #-----< CCBS-Feature >-----#
    CCBS_Feature = SEQ(name='CCBS-Feature', mode=MODE_TYPE)
    _CCBS_Feature_ccbs_Index = INT(name='ccbs-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    _CCBS_Feature_b_subscriberNumber = OCT_STR(name='b-subscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CCBS_Feature_b_subscriberSubaddress = OCT_STR(name='b-subscriberSubaddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _CCBS_Feature_basicServiceGroup = CHOICE(name='basicServiceGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    CCBS_Feature._cont = ASN1Dict([
        ('ccbs-Index', _CCBS_Feature_ccbs_Index),
        ('b-subscriberNumber', _CCBS_Feature_b_subscriberNumber),
        ('b-subscriberSubaddress', _CCBS_Feature_b_subscriberSubaddress),
        ('basicServiceGroup', _CCBS_Feature_basicServiceGroup),
        ])
    CCBS_Feature._ext = []
    
    #-----< CCBS-Index >-----#
    CCBS_Index = INT(name='CCBS-Index', mode=MODE_TYPE)
    CCBS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< InterrogateSS-Res >-----#
    InterrogateSS_Res = CHOICE(name='InterrogateSS-Res', mode=MODE_TYPE)
    _InterrogateSS_Res_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _InterrogateSS_Res_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')))
    _InterrogateSS_Res_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    _InterrogateSS_Res_genericServiceInfo = SEQ(name='genericServiceInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'GenericServiceInfo')))
    InterrogateSS_Res._cont = ASN1Dict([
        ('ss-Status', _InterrogateSS_Res_ss_Status),
        ('basicServiceGroupList', _InterrogateSS_Res_basicServiceGroupList),
        ('forwardingFeatureList', _InterrogateSS_Res_forwardingFeatureList),
        ('genericServiceInfo', _InterrogateSS_Res_genericServiceInfo),
        ])
    InterrogateSS_Res._ext = None
    
    #-----< USSD-Arg >-----#
    USSD_Arg = SEQ(name='USSD-Arg', mode=MODE_TYPE)
    _USSD_Arg_ussd_DataCodingScheme = OCT_STR(name='ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Arg_ussd_String = OCT_STR(name='ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    _USSD_Arg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _USSD_Arg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    USSD_Arg._cont = ASN1Dict([
        ('ussd-DataCodingScheme', _USSD_Arg_ussd_DataCodingScheme),
        ('ussd-String', _USSD_Arg_ussd_String),
        ('alertingPattern', _USSD_Arg_alertingPattern),
        ('msisdn', _USSD_Arg_msisdn),
        ])
    USSD_Arg._ext = ['alertingPattern', 'msisdn']
    
    #-----< USSD-Res >-----#
    USSD_Res = SEQ(name='USSD-Res', mode=MODE_TYPE)
    _USSD_Res_ussd_DataCodingScheme = OCT_STR(name='ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Res_ussd_String = OCT_STR(name='ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    USSD_Res._cont = ASN1Dict([
        ('ussd-DataCodingScheme', _USSD_Res_ussd_DataCodingScheme),
        ('ussd-String', _USSD_Res_ussd_String),
        ])
    USSD_Res._ext = []
    
    #-----< USSD-DataCodingScheme >-----#
    USSD_DataCodingScheme = OCT_STR(name='USSD-DataCodingScheme', mode=MODE_TYPE)
    USSD_DataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< USSD-String >-----#
    USSD_String = OCT_STR(name='USSD-String', mode=MODE_TYPE)
    USSD_String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< maxUSSD-StringLength >-----#
    maxUSSD_StringLength = INT(name='maxUSSD-StringLength', mode=MODE_VALUE)
    maxUSSD_StringLength._val = 160
    
    #-----< Password >-----#
    Password = STR_NUM(name='Password', mode=MODE_TYPE)
    Password._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    Password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    
    #-----< GuidanceInfo >-----#
    GuidanceInfo = ENUM(name='GuidanceInfo', mode=MODE_TYPE)
    GuidanceInfo._cont = ASN1Dict([('enterPW', 0), ('enterNewPW', 1), ('enterNewPW-Again', 2)])
    GuidanceInfo._ext = None
    
    #-----< SS-List >-----#
    SS_List = SEQ_OF(name='SS-List', mode=MODE_TYPE)
    _SS_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_List._cont = _SS_List__item_
    SS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< maxNumOfSS >-----#
    maxNumOfSS = INT(name='maxNumOfSS', mode=MODE_VALUE)
    maxNumOfSS._val = 30
    
    #-----< SS-InfoList >-----#
    SS_InfoList = SEQ_OF(name='SS-InfoList', mode=MODE_TYPE)
    _SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Info')))
    SS_InfoList._cont = _SS_InfoList__item_
    SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< BasicServiceGroupList >-----#
    BasicServiceGroupList = SEQ_OF(name='BasicServiceGroupList', mode=MODE_TYPE)
    _BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    BasicServiceGroupList._cont = _BasicServiceGroupList__item_
    BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< maxNumOfBasicServiceGroups >-----#
    maxNumOfBasicServiceGroups = INT(name='maxNumOfBasicServiceGroups', mode=MODE_VALUE)
    maxNumOfBasicServiceGroups._val = 13
    
    #-----< SS-InvocationNotificationArg >-----#
    SS_InvocationNotificationArg = SEQ(name='SS-InvocationNotificationArg', mode=MODE_TYPE)
    _SS_InvocationNotificationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SS_InvocationNotificationArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_InvocationNotificationArg_ss_Event = OCT_STR(name='ss-Event', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_InvocationNotificationArg_ss_EventSpecification = SEQ_OF(name='ss-EventSpecification', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-EventSpecification')), opt=True)
    _SS_InvocationNotificationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_InvocationNotificationArg_b_subscriberNumber = OCT_STR(name='b-subscriberNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SS_InvocationNotificationArg_ccbs_RequestState = ENUM(name='ccbs-RequestState', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-RequestState')), opt=True)
    SS_InvocationNotificationArg._cont = ASN1Dict([
        ('imsi', _SS_InvocationNotificationArg_imsi),
        ('msisdn', _SS_InvocationNotificationArg_msisdn),
        ('ss-Event', _SS_InvocationNotificationArg_ss_Event),
        ('ss-EventSpecification', _SS_InvocationNotificationArg_ss_EventSpecification),
        ('extensionContainer', _SS_InvocationNotificationArg_extensionContainer),
        ('b-subscriberNumber', _SS_InvocationNotificationArg_b_subscriberNumber),
        ('ccbs-RequestState', _SS_InvocationNotificationArg_ccbs_RequestState),
        ])
    SS_InvocationNotificationArg._ext = ['b-subscriberNumber', 'ccbs-RequestState']
    
    #-----< CCBS-RequestState >-----#
    CCBS_RequestState = ENUM(name='CCBS-RequestState', mode=MODE_TYPE)
    CCBS_RequestState._cont = ASN1Dict([('request', 0), ('recall', 1), ('active', 2), ('completed', 3), ('suspended', 4), ('frozen', 5), ('deleted', 6)])
    CCBS_RequestState._ext = None
    
    #-----< SS-InvocationNotificationRes >-----#
    SS_InvocationNotificationRes = SEQ(name='SS-InvocationNotificationRes', mode=MODE_TYPE)
    _SS_InvocationNotificationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_InvocationNotificationRes._cont = ASN1Dict([
        ('extensionContainer', _SS_InvocationNotificationRes_extensionContainer),
        ])
    SS_InvocationNotificationRes._ext = []
    
    #-----< SS-EventSpecification >-----#
    SS_EventSpecification = SEQ_OF(name='SS-EventSpecification', mode=MODE_TYPE)
    _SS_EventSpecification__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SS_EventSpecification._cont = _SS_EventSpecification__item_
    SS_EventSpecification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< maxEventSpecification >-----#
    maxEventSpecification = INT(name='maxEventSpecification', mode=MODE_VALUE)
    maxEventSpecification._val = 2
    
    #-----< RegisterCC-EntryArg >-----#
    RegisterCC_EntryArg = SEQ(name='RegisterCC-EntryArg', mode=MODE_TYPE)
    _RegisterCC_EntryArg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterCC_EntryArg_ccbs_Data = SEQ(name='ccbs-Data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Data')), opt=True)
    RegisterCC_EntryArg._cont = ASN1Dict([
        ('ss-Code', _RegisterCC_EntryArg_ss_Code),
        ('ccbs-Data', _RegisterCC_EntryArg_ccbs_Data),
        ])
    RegisterCC_EntryArg._ext = []
    
    #-----< CCBS-Data >-----#
    CCBS_Data = SEQ(name='CCBS-Data', mode=MODE_TYPE)
    _CCBS_Data_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _CCBS_Data_translatedB_Number = OCT_STR(name='translatedB-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _CCBS_Data_serviceIndicator = BIT_STR(name='serviceIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ServiceIndicator')), opt=True)
    _CCBS_Data_callInfo = SEQ(name='callInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _CCBS_Data_networkSignalInfo = SEQ(name='networkSignalInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    CCBS_Data._cont = ASN1Dict([
        ('ccbs-Feature', _CCBS_Data_ccbs_Feature),
        ('translatedB-Number', _CCBS_Data_translatedB_Number),
        ('serviceIndicator', _CCBS_Data_serviceIndicator),
        ('callInfo', _CCBS_Data_callInfo),
        ('networkSignalInfo', _CCBS_Data_networkSignalInfo),
        ])
    CCBS_Data._ext = []
    
    #-----< ServiceIndicator >-----#
    ServiceIndicator = BIT_STR(name='ServiceIndicator', mode=MODE_TYPE)
    ServiceIndicator._cont = ASN1Dict([('clir-invoked', 0), ('camel-invoked', 1)])
    ServiceIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    
    #-----< RegisterCC-EntryRes >-----#
    RegisterCC_EntryRes = SEQ(name='RegisterCC-EntryRes', mode=MODE_TYPE)
    _RegisterCC_EntryRes_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')), opt=True)
    RegisterCC_EntryRes._cont = ASN1Dict([
        ('ccbs-Feature', _RegisterCC_EntryRes_ccbs_Feature),
        ])
    RegisterCC_EntryRes._ext = []
    
    #-----< EraseCC-EntryArg >-----#
    EraseCC_EntryArg = SEQ(name='EraseCC-EntryArg', mode=MODE_TYPE)
    _EraseCC_EntryArg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryArg_ccbs_Index = INT(name='ccbs-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    EraseCC_EntryArg._cont = ASN1Dict([
        ('ss-Code', _EraseCC_EntryArg_ss_Code),
        ('ccbs-Index', _EraseCC_EntryArg_ccbs_Index),
        ])
    EraseCC_EntryArg._ext = []
    
    #-----< EraseCC-EntryRes >-----#
    EraseCC_EntryRes = SEQ(name='EraseCC-EntryRes', mode=MODE_TYPE)
    _EraseCC_EntryRes_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryRes_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    EraseCC_EntryRes._cont = ASN1Dict([
        ('ss-Code', _EraseCC_EntryRes_ss_Code),
        ('ss-Status', _EraseCC_EntryRes_ss_Status),
        ])
    EraseCC_EntryRes._ext = []
    
    _all_ = [
        _RegisterSS_Arg_ss_Code,
        _RegisterSS_Arg_basicService,
        _RegisterSS_Arg_forwardedToNumber,
        _RegisterSS_Arg_forwardedToSubaddress,
        _RegisterSS_Arg_noReplyConditionTime,
        _RegisterSS_Arg_defaultPriority,
        _RegisterSS_Arg_nbrUser,
        _RegisterSS_Arg_longFTN_Supported,
        RegisterSS_Arg,
        NoReplyConditionTime,
        _SS_Info_forwardingInfo,
        _SS_Info_callBarringInfo,
        _SS_Info_ss_Data,
        SS_Info,
        _ForwardingInfo_ss_Code,
        _ForwardingInfo_forwardingFeatureList,
        ForwardingInfo,
        _ForwardingFeatureList__item_,
        ForwardingFeatureList,
        _ForwardingFeature_basicService,
        _ForwardingFeature_ss_Status,
        _ForwardingFeature_forwardedToNumber,
        _ForwardingFeature_forwardedToSubaddress,
        _ForwardingFeature_forwardingOptions,
        _ForwardingFeature_noReplyConditionTime,
        _ForwardingFeature_longForwardedToNumber,
        ForwardingFeature,
        SS_Status,
        ForwardingOptions,
        _CallBarringInfo_ss_Code,
        _CallBarringInfo_callBarringFeatureList,
        CallBarringInfo,
        _CallBarringFeatureList__item_,
        CallBarringFeatureList,
        _CallBarringFeature_basicService,
        _CallBarringFeature_ss_Status,
        CallBarringFeature,
        _SS_Data_ss_Code,
        _SS_Data_ss_Status,
        _SS_Data_ss_SubscriptionOption,
        _SS_Data_basicServiceGroupList,
        _SS_Data_defaultPriority,
        _SS_Data_nbrUser,
        SS_Data,
        _SS_SubscriptionOption_cliRestrictionOption,
        _SS_SubscriptionOption_overrideCategory,
        SS_SubscriptionOption,
        CliRestrictionOption,
        OverrideCategory,
        _SS_ForBS_Code_ss_Code,
        _SS_ForBS_Code_basicService,
        _SS_ForBS_Code_longFTN_Supported,
        SS_ForBS_Code,
        _GenericServiceInfo_ss_Status,
        _GenericServiceInfo_cliRestrictionOption,
        _GenericServiceInfo_maximumEntitledPriority,
        _GenericServiceInfo_defaultPriority,
        _GenericServiceInfo_ccbs_FeatureList,
        _GenericServiceInfo_nbrSB,
        _GenericServiceInfo_nbrUser,
        _GenericServiceInfo_nbrSN,
        GenericServiceInfo,
        _CCBS_FeatureList__item_,
        CCBS_FeatureList,
        maxNumOfCCBS_Requests,
        _CCBS_Feature_ccbs_Index,
        _CCBS_Feature_b_subscriberNumber,
        _CCBS_Feature_b_subscriberSubaddress,
        _CCBS_Feature_basicServiceGroup,
        CCBS_Feature,
        CCBS_Index,
        _InterrogateSS_Res_ss_Status,
        _InterrogateSS_Res_basicServiceGroupList,
        _InterrogateSS_Res_forwardingFeatureList,
        _InterrogateSS_Res_genericServiceInfo,
        InterrogateSS_Res,
        _USSD_Arg_ussd_DataCodingScheme,
        _USSD_Arg_ussd_String,
        _USSD_Arg_alertingPattern,
        _USSD_Arg_msisdn,
        USSD_Arg,
        _USSD_Res_ussd_DataCodingScheme,
        _USSD_Res_ussd_String,
        USSD_Res,
        USSD_DataCodingScheme,
        USSD_String,
        maxUSSD_StringLength,
        Password,
        GuidanceInfo,
        _SS_List__item_,
        SS_List,
        maxNumOfSS,
        _SS_InfoList__item_,
        SS_InfoList,
        _BasicServiceGroupList__item_,
        BasicServiceGroupList,
        maxNumOfBasicServiceGroups,
        _SS_InvocationNotificationArg_imsi,
        _SS_InvocationNotificationArg_msisdn,
        _SS_InvocationNotificationArg_ss_Event,
        _SS_InvocationNotificationArg_ss_EventSpecification,
        _SS_InvocationNotificationArg_extensionContainer,
        _SS_InvocationNotificationArg_b_subscriberNumber,
        _SS_InvocationNotificationArg_ccbs_RequestState,
        SS_InvocationNotificationArg,
        CCBS_RequestState,
        _SS_InvocationNotificationRes_extensionContainer,
        SS_InvocationNotificationRes,
        _SS_EventSpecification__item_,
        SS_EventSpecification,
        maxEventSpecification,
        _RegisterCC_EntryArg_ss_Code,
        _RegisterCC_EntryArg_ccbs_Data,
        RegisterCC_EntryArg,
        _CCBS_Data_ccbs_Feature,
        _CCBS_Data_translatedB_Number,
        _CCBS_Data_serviceIndicator,
        _CCBS_Data_callInfo,
        _CCBS_Data_networkSignalInfo,
        CCBS_Data,
        ServiceIndicator,
        _RegisterCC_EntryRes_ccbs_Feature,
        RegisterCC_EntryRes,
        _EraseCC_EntryArg_ss_Code,
        _EraseCC_EntryArg_ccbs_Index,
        EraseCC_EntryArg,
        _EraseCC_EntryRes_ss_Code,
        _EraseCC_EntryRes_ss_Status,
        EraseCC_EntryRes,
    ]

class MAP_ER_DataTypes:

    _name_  = 'MAP-ER-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 17, 19]
    
    _obj_ = [
        'RoamingNotAllowedParam',
        'AdditionalRoamingNotAllowedCause',
        'RoamingNotAllowedCause',
        'CallBarredParam',
        'CallBarringCause',
        'ExtensibleCallBarredParam',
        'CUG-RejectParam',
        'CUG-RejectCause',
        'SS-IncompatibilityCause',
        'PW-RegistrationFailureCause',
        'SM-EnumeratedDeliveryFailureCause',
        'SM-DeliveryFailureCause',
        'AbsentSubscriberSM-Param',
        'AbsentSubscriberDiagnosticSM',
        'SystemFailureParam',
        'ExtensibleSystemFailureParam',
        'FailureCauseParam',
        'DataMissingParam',
        'UnexpectedDataParam',
        'FacilityNotSupParam',
        'OR-NotAllowedParam',
        'UnknownSubscriberParam',
        'UnknownSubscriberDiagnostic',
        'NumberChangedParam',
        'UnidentifiedSubParam',
        'IllegalSubscriberParam',
        'IllegalEquipmentParam',
        'BearerServNotProvParam',
        'TeleservNotProvParam',
        'TracingBufferFullParam',
        'NoRoamingNbParam',
        'AbsentSubscriberParam',
        'AbsentSubscriberReason',
        'BusySubscriberParam',
        'NoSubscriberReplyParam',
        'ForwardingViolationParam',
        'ForwardingFailedParam',
        'ATI-NotAllowedParam',
        'ATSI-NotAllowedParam',
        'ATM-NotAllowedParam',
        'IllegalSS-OperationParam',
        'SS-NotAvailableParam',
        'SS-SubscriptionViolationParam',
        'InformationNotAvailableParam',
        'SubBusyForMT-SMS-Param',
        'MessageWaitListFullParam',
        'ResourceLimitationParam',
        'NoGroupCallNbParam',
        'IncompatibleTerminalParam',
        'ShortTermDenialParam',
        'LongTermDenialParam',
        'UnauthorizedRequestingNetwork-Param',
        'UnauthorizedLCSClient-Param',
        'UnauthorizedLCSClient-Diagnostic',
        'PositionMethodFailure-Param',
        'PositionMethodFailure-Diagnostic',
        'UnknownOrUnreachableLCSClient-Param',
        'MM-EventNotSupported-Param',
        'TargetCellOutsideGCA-Param',
        'OngoingGroupCallParam',
        ]
    _type_ = [
        'RoamingNotAllowedParam',
        'AdditionalRoamingNotAllowedCause',
        'RoamingNotAllowedCause',
        'CallBarredParam',
        'CallBarringCause',
        'ExtensibleCallBarredParam',
        'CUG-RejectParam',
        'CUG-RejectCause',
        'SS-IncompatibilityCause',
        'PW-RegistrationFailureCause',
        'SM-EnumeratedDeliveryFailureCause',
        'SM-DeliveryFailureCause',
        'AbsentSubscriberSM-Param',
        'AbsentSubscriberDiagnosticSM',
        'SystemFailureParam',
        'ExtensibleSystemFailureParam',
        'FailureCauseParam',
        'DataMissingParam',
        'UnexpectedDataParam',
        'FacilityNotSupParam',
        'OR-NotAllowedParam',
        'UnknownSubscriberParam',
        'UnknownSubscriberDiagnostic',
        'NumberChangedParam',
        'UnidentifiedSubParam',
        'IllegalSubscriberParam',
        'IllegalEquipmentParam',
        'BearerServNotProvParam',
        'TeleservNotProvParam',
        'TracingBufferFullParam',
        'NoRoamingNbParam',
        'AbsentSubscriberParam',
        'AbsentSubscriberReason',
        'BusySubscriberParam',
        'NoSubscriberReplyParam',
        'ForwardingViolationParam',
        'ForwardingFailedParam',
        'ATI-NotAllowedParam',
        'ATSI-NotAllowedParam',
        'ATM-NotAllowedParam',
        'IllegalSS-OperationParam',
        'SS-NotAvailableParam',
        'SS-SubscriptionViolationParam',
        'InformationNotAvailableParam',
        'SubBusyForMT-SMS-Param',
        'MessageWaitListFullParam',
        'ResourceLimitationParam',
        'NoGroupCallNbParam',
        'IncompatibleTerminalParam',
        'ShortTermDenialParam',
        'LongTermDenialParam',
        'UnauthorizedRequestingNetwork-Param',
        'UnauthorizedLCSClient-Param',
        'UnauthorizedLCSClient-Diagnostic',
        'PositionMethodFailure-Param',
        'PositionMethodFailure-Diagnostic',
        'UnknownOrUnreachableLCSClient-Param',
        'MM-EventNotSupported-Param',
        'TargetCellOutsideGCA-Param',
        'OngoingGroupCallParam',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoamingNotAllowedParam >-----#
    RoamingNotAllowedParam = SEQ(name='RoamingNotAllowedParam', mode=MODE_TYPE)
    _RoamingNotAllowedParam_roamingNotAllowedCause = ENUM(name='roamingNotAllowedCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'RoamingNotAllowedCause')))
    _RoamingNotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoamingNotAllowedParam_additionalRoamingNotAllowedCause = ENUM(name='additionalRoamingNotAllowedCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AdditionalRoamingNotAllowedCause')), opt=True)
    RoamingNotAllowedParam._cont = ASN1Dict([
        ('roamingNotAllowedCause', _RoamingNotAllowedParam_roamingNotAllowedCause),
        ('extensionContainer', _RoamingNotAllowedParam_extensionContainer),
        ('additionalRoamingNotAllowedCause', _RoamingNotAllowedParam_additionalRoamingNotAllowedCause),
        ])
    RoamingNotAllowedParam._ext = ['additionalRoamingNotAllowedCause']
    
    #-----< AdditionalRoamingNotAllowedCause >-----#
    AdditionalRoamingNotAllowedCause = ENUM(name='AdditionalRoamingNotAllowedCause', mode=MODE_TYPE)
    AdditionalRoamingNotAllowedCause._cont = ASN1Dict([('supportedRAT-TypesNotAllowed', 0)])
    AdditionalRoamingNotAllowedCause._ext = []
    
    #-----< RoamingNotAllowedCause >-----#
    RoamingNotAllowedCause = ENUM(name='RoamingNotAllowedCause', mode=MODE_TYPE)
    RoamingNotAllowedCause._cont = ASN1Dict([('plmnRoamingNotAllowed', 0), ('operatorDeterminedBarring', 3)])
    RoamingNotAllowedCause._ext = None
    
    #-----< CallBarredParam >-----#
    CallBarredParam = CHOICE(name='CallBarredParam', mode=MODE_TYPE)
    _CallBarredParam_callBarringCause = ENUM(name='callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')))
    _CallBarredParam_extensibleCallBarredParam = SEQ(name='extensibleCallBarredParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleCallBarredParam')))
    CallBarredParam._cont = ASN1Dict([
        ('callBarringCause', _CallBarredParam_callBarringCause),
        ('extensibleCallBarredParam', _CallBarredParam_extensibleCallBarredParam),
        ])
    CallBarredParam._ext = None
    
    #-----< CallBarringCause >-----#
    CallBarringCause = ENUM(name='CallBarringCause', mode=MODE_TYPE)
    CallBarringCause._cont = ASN1Dict([('barringServiceActive', 0), ('operatorBarring', 1)])
    CallBarringCause._ext = None
    
    #-----< ExtensibleCallBarredParam >-----#
    ExtensibleCallBarredParam = SEQ(name='ExtensibleCallBarredParam', mode=MODE_TYPE)
    _ExtensibleCallBarredParam_callBarringCause = ENUM(name='callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')), opt=True)
    _ExtensibleCallBarredParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleCallBarredParam_unauthorisedMessageOriginator = NULL(name='unauthorisedMessageOriginator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtensibleCallBarredParam_anonymousCallRejection = NULL(name='anonymousCallRejection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtensibleCallBarredParam._cont = ASN1Dict([
        ('callBarringCause', _ExtensibleCallBarredParam_callBarringCause),
        ('extensionContainer', _ExtensibleCallBarredParam_extensionContainer),
        ('unauthorisedMessageOriginator', _ExtensibleCallBarredParam_unauthorisedMessageOriginator),
        ('anonymousCallRejection', _ExtensibleCallBarredParam_anonymousCallRejection),
        ])
    ExtensibleCallBarredParam._ext = ['unauthorisedMessageOriginator', 'anonymousCallRejection']
    
    #-----< CUG-RejectParam >-----#
    CUG_RejectParam = SEQ(name='CUG-RejectParam', mode=MODE_TYPE)
    _CUG_RejectParam_cug_RejectCause = ENUM(name='cug-RejectCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CUG-RejectCause')), opt=True)
    _CUG_RejectParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_RejectParam._cont = ASN1Dict([
        ('cug-RejectCause', _CUG_RejectParam_cug_RejectCause),
        ('extensionContainer', _CUG_RejectParam_extensionContainer),
        ])
    CUG_RejectParam._ext = []
    
    #-----< CUG-RejectCause >-----#
    CUG_RejectCause = ENUM(name='CUG-RejectCause', mode=MODE_TYPE)
    CUG_RejectCause._cont = ASN1Dict([('incomingCallsBarredWithinCUG', 0), ('subscriberNotMemberOfCUG', 1), ('requestedBasicServiceViolatesCUG-Constraints', 5), ('calledPartySS-InteractionViolation', 7)])
    CUG_RejectCause._ext = None
    
    #-----< SS-IncompatibilityCause >-----#
    SS_IncompatibilityCause = SEQ(name='SS-IncompatibilityCause', mode=MODE_TYPE)
    _SS_IncompatibilityCause_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_IncompatibilityCause_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_IncompatibilityCause_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    SS_IncompatibilityCause._cont = ASN1Dict([
        ('ss-Code', _SS_IncompatibilityCause_ss_Code),
        ('basicService', _SS_IncompatibilityCause_basicService),
        ('ss-Status', _SS_IncompatibilityCause_ss_Status),
        ])
    SS_IncompatibilityCause._ext = []
    
    #-----< PW-RegistrationFailureCause >-----#
    PW_RegistrationFailureCause = ENUM(name='PW-RegistrationFailureCause', mode=MODE_TYPE)
    PW_RegistrationFailureCause._cont = ASN1Dict([('undetermined', 0), ('invalidFormat', 1), ('newPasswordsMismatch', 2)])
    PW_RegistrationFailureCause._ext = None
    
    #-----< SM-EnumeratedDeliveryFailureCause >-----#
    SM_EnumeratedDeliveryFailureCause = ENUM(name='SM-EnumeratedDeliveryFailureCause', mode=MODE_TYPE)
    SM_EnumeratedDeliveryFailureCause._cont = ASN1Dict([('memoryCapacityExceeded', 0), ('equipmentProtocolError', 1), ('equipmentNotSM-Equipped', 2), ('unknownServiceCentre', 3), ('sc-Congestion', 4), ('invalidSME-Address', 5), ('subscriberNotSC-Subscriber', 6)])
    SM_EnumeratedDeliveryFailureCause._ext = None
    
    #-----< SM-DeliveryFailureCause >-----#
    SM_DeliveryFailureCause = SEQ(name='SM-DeliveryFailureCause', mode=MODE_TYPE)
    _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause = ENUM(name='sm-EnumeratedDeliveryFailureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'SM-EnumeratedDeliveryFailureCause')))
    _SM_DeliveryFailureCause_diagnosticInfo = OCT_STR(name='diagnosticInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _SM_DeliveryFailureCause_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SM_DeliveryFailureCause._cont = ASN1Dict([
        ('sm-EnumeratedDeliveryFailureCause', _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause),
        ('diagnosticInfo', _SM_DeliveryFailureCause_diagnosticInfo),
        ('extensionContainer', _SM_DeliveryFailureCause_extensionContainer),
        ])
    SM_DeliveryFailureCause._ext = []
    
    #-----< AbsentSubscriberSM-Param >-----#
    AbsentSubscriberSM_Param = SEQ(name='AbsentSubscriberSM-Param', mode=MODE_TYPE)
    _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM = INT(name='absentSubscriberDiagnosticSM', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM = INT(name='additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _AbsentSubscriberSM_Param_requestedRetransmissionTime = OCT_STR(name='requestedRetransmissionTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _AbsentSubscriberSM_Param_userIdentifierAlert = OCT_STR(name='userIdentifierAlert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    AbsentSubscriberSM_Param._cont = ASN1Dict([
        ('absentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM),
        ('extensionContainer', _AbsentSubscriberSM_Param_extensionContainer),
        ('additionalAbsentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM),
        ('imsi', _AbsentSubscriberSM_Param_imsi),
        ('requestedRetransmissionTime', _AbsentSubscriberSM_Param_requestedRetransmissionTime),
        ('userIdentifierAlert', _AbsentSubscriberSM_Param_userIdentifierAlert),
        ])
    AbsentSubscriberSM_Param._ext = ['additionalAbsentSubscriberDiagnosticSM', 'imsi', 'requestedRetransmissionTime', 'userIdentifierAlert']
    
    #-----< AbsentSubscriberDiagnosticSM >-----#
    AbsentSubscriberDiagnosticSM = INT(name='AbsentSubscriberDiagnosticSM', mode=MODE_TYPE)
    AbsentSubscriberDiagnosticSM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SystemFailureParam >-----#
    SystemFailureParam = CHOICE(name='SystemFailureParam', mode=MODE_TYPE)
    _SystemFailureParam_networkResource = ENUM(name='networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')))
    _SystemFailureParam_extensibleSystemFailureParam = SEQ(name='extensibleSystemFailureParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleSystemFailureParam')))
    SystemFailureParam._cont = ASN1Dict([
        ('networkResource', _SystemFailureParam_networkResource),
        ('extensibleSystemFailureParam', _SystemFailureParam_extensibleSystemFailureParam),
        ])
    SystemFailureParam._ext = None
    
    #-----< ExtensibleSystemFailureParam >-----#
    ExtensibleSystemFailureParam = SEQ(name='ExtensibleSystemFailureParam', mode=MODE_TYPE)
    _ExtensibleSystemFailureParam_networkResource = ENUM(name='networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleSystemFailureParam_additionalNetworkResource = ENUM(name='additionalNetworkResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AdditionalNetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_failureCauseParam = ENUM(name='failureCauseParam', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'FailureCauseParam')), opt=True)
    ExtensibleSystemFailureParam._cont = ASN1Dict([
        ('networkResource', _ExtensibleSystemFailureParam_networkResource),
        ('extensionContainer', _ExtensibleSystemFailureParam_extensionContainer),
        ('additionalNetworkResource', _ExtensibleSystemFailureParam_additionalNetworkResource),
        ('failureCauseParam', _ExtensibleSystemFailureParam_failureCauseParam),
        ])
    ExtensibleSystemFailureParam._ext = ['additionalNetworkResource', 'failureCauseParam']
    
    #-----< FailureCauseParam >-----#
    FailureCauseParam = ENUM(name='FailureCauseParam', mode=MODE_TYPE)
    FailureCauseParam._cont = ASN1Dict([('limitReachedOnNumberOfConcurrentLocationRequests', 0)])
    FailureCauseParam._ext = []
    
    #-----< DataMissingParam >-----#
    DataMissingParam = SEQ(name='DataMissingParam', mode=MODE_TYPE)
    _DataMissingParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DataMissingParam._cont = ASN1Dict([
        ('extensionContainer', _DataMissingParam_extensionContainer),
        ])
    DataMissingParam._ext = []
    
    #-----< UnexpectedDataParam >-----#
    UnexpectedDataParam = SEQ(name='UnexpectedDataParam', mode=MODE_TYPE)
    _UnexpectedDataParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnexpectedDataParam_unexpectedSubscriber = NULL(name='unexpectedSubscriber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UnexpectedDataParam._cont = ASN1Dict([
        ('extensionContainer', _UnexpectedDataParam_extensionContainer),
        ('unexpectedSubscriber', _UnexpectedDataParam_unexpectedSubscriber),
        ])
    UnexpectedDataParam._ext = ['unexpectedSubscriber']
    
    #-----< FacilityNotSupParam >-----#
    FacilityNotSupParam = SEQ(name='FacilityNotSupParam', mode=MODE_TYPE)
    _FacilityNotSupParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _FacilityNotSupParam_shapeOfLocationEstimateNotSupported = NULL(name='shapeOfLocationEstimateNotSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode = NULL(name='neededLcsCapabilityNotSupportedInServingNode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    FacilityNotSupParam._cont = ASN1Dict([
        ('extensionContainer', _FacilityNotSupParam_extensionContainer),
        ('shapeOfLocationEstimateNotSupported', _FacilityNotSupParam_shapeOfLocationEstimateNotSupported),
        ('neededLcsCapabilityNotSupportedInServingNode', _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode),
        ])
    FacilityNotSupParam._ext = ['shapeOfLocationEstimateNotSupported', 'neededLcsCapabilityNotSupportedInServingNode']
    
    #-----< OR-NotAllowedParam >-----#
    OR_NotAllowedParam = SEQ(name='OR-NotAllowedParam', mode=MODE_TYPE)
    _OR_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OR_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _OR_NotAllowedParam_extensionContainer),
        ])
    OR_NotAllowedParam._ext = []
    
    #-----< UnknownSubscriberParam >-----#
    UnknownSubscriberParam = SEQ(name='UnknownSubscriberParam', mode=MODE_TYPE)
    _UnknownSubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnknownSubscriberParam_unknownSubscriberDiagnostic = ENUM(name='unknownSubscriberDiagnostic', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnknownSubscriberDiagnostic')), opt=True)
    UnknownSubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _UnknownSubscriberParam_extensionContainer),
        ('unknownSubscriberDiagnostic', _UnknownSubscriberParam_unknownSubscriberDiagnostic),
        ])
    UnknownSubscriberParam._ext = ['unknownSubscriberDiagnostic']
    
    #-----< UnknownSubscriberDiagnostic >-----#
    UnknownSubscriberDiagnostic = ENUM(name='UnknownSubscriberDiagnostic', mode=MODE_TYPE)
    UnknownSubscriberDiagnostic._cont = ASN1Dict([('imsiUnknown', 0), ('gprs-eps-SubscriptionUnknown', 1), ('npdbMismatch', 2)])
    UnknownSubscriberDiagnostic._ext = ['npdbMismatch']
    
    #-----< NumberChangedParam >-----#
    NumberChangedParam = SEQ(name='NumberChangedParam', mode=MODE_TYPE)
    _NumberChangedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NumberChangedParam._cont = ASN1Dict([
        ('extensionContainer', _NumberChangedParam_extensionContainer),
        ])
    NumberChangedParam._ext = []
    
    #-----< UnidentifiedSubParam >-----#
    UnidentifiedSubParam = SEQ(name='UnidentifiedSubParam', mode=MODE_TYPE)
    _UnidentifiedSubParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnidentifiedSubParam._cont = ASN1Dict([
        ('extensionContainer', _UnidentifiedSubParam_extensionContainer),
        ])
    UnidentifiedSubParam._ext = []
    
    #-----< IllegalSubscriberParam >-----#
    IllegalSubscriberParam = SEQ(name='IllegalSubscriberParam', mode=MODE_TYPE)
    _IllegalSubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _IllegalSubscriberParam_extensionContainer),
        ])
    IllegalSubscriberParam._ext = []
    
    #-----< IllegalEquipmentParam >-----#
    IllegalEquipmentParam = SEQ(name='IllegalEquipmentParam', mode=MODE_TYPE)
    _IllegalEquipmentParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalEquipmentParam._cont = ASN1Dict([
        ('extensionContainer', _IllegalEquipmentParam_extensionContainer),
        ])
    IllegalEquipmentParam._ext = []
    
    #-----< BearerServNotProvParam >-----#
    BearerServNotProvParam = SEQ(name='BearerServNotProvParam', mode=MODE_TYPE)
    _BearerServNotProvParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    BearerServNotProvParam._cont = ASN1Dict([
        ('extensionContainer', _BearerServNotProvParam_extensionContainer),
        ])
    BearerServNotProvParam._ext = []
    
    #-----< TeleservNotProvParam >-----#
    TeleservNotProvParam = SEQ(name='TeleservNotProvParam', mode=MODE_TYPE)
    _TeleservNotProvParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TeleservNotProvParam._cont = ASN1Dict([
        ('extensionContainer', _TeleservNotProvParam_extensionContainer),
        ])
    TeleservNotProvParam._ext = []
    
    #-----< TracingBufferFullParam >-----#
    TracingBufferFullParam = SEQ(name='TracingBufferFullParam', mode=MODE_TYPE)
    _TracingBufferFullParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TracingBufferFullParam._cont = ASN1Dict([
        ('extensionContainer', _TracingBufferFullParam_extensionContainer),
        ])
    TracingBufferFullParam._ext = []
    
    #-----< NoRoamingNbParam >-----#
    NoRoamingNbParam = SEQ(name='NoRoamingNbParam', mode=MODE_TYPE)
    _NoRoamingNbParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoRoamingNbParam._cont = ASN1Dict([
        ('extensionContainer', _NoRoamingNbParam_extensionContainer),
        ])
    NoRoamingNbParam._ext = []
    
    #-----< AbsentSubscriberParam >-----#
    AbsentSubscriberParam = SEQ(name='AbsentSubscriberParam', mode=MODE_TYPE)
    _AbsentSubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberParam_absentSubscriberReason = ENUM(name='absentSubscriberReason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberReason')), opt=True)
    AbsentSubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _AbsentSubscriberParam_extensionContainer),
        ('absentSubscriberReason', _AbsentSubscriberParam_absentSubscriberReason),
        ])
    AbsentSubscriberParam._ext = ['absentSubscriberReason']
    
    #-----< AbsentSubscriberReason >-----#
    AbsentSubscriberReason = ENUM(name='AbsentSubscriberReason', mode=MODE_TYPE)
    AbsentSubscriberReason._cont = ASN1Dict([('imsiDetach', 0), ('restrictedArea', 1), ('noPageResponse', 2), ('purgedMS', 3), ('mtRoamingRetry', 4), ('busySubscriber', 5)])
    AbsentSubscriberReason._ext = ['purgedMS', 'mtRoamingRetry', 'busySubscriber']
    
    #-----< BusySubscriberParam >-----#
    BusySubscriberParam = SEQ(name='BusySubscriberParam', mode=MODE_TYPE)
    _BusySubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _BusySubscriberParam_ccbs_Possible = NULL(name='ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BusySubscriberParam_ccbs_Busy = NULL(name='ccbs-Busy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BusySubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _BusySubscriberParam_extensionContainer),
        ('ccbs-Possible', _BusySubscriberParam_ccbs_Possible),
        ('ccbs-Busy', _BusySubscriberParam_ccbs_Busy),
        ])
    BusySubscriberParam._ext = ['ccbs-Possible', 'ccbs-Busy']
    
    #-----< NoSubscriberReplyParam >-----#
    NoSubscriberReplyParam = SEQ(name='NoSubscriberReplyParam', mode=MODE_TYPE)
    _NoSubscriberReplyParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoSubscriberReplyParam._cont = ASN1Dict([
        ('extensionContainer', _NoSubscriberReplyParam_extensionContainer),
        ])
    NoSubscriberReplyParam._ext = []
    
    #-----< ForwardingViolationParam >-----#
    ForwardingViolationParam = SEQ(name='ForwardingViolationParam', mode=MODE_TYPE)
    _ForwardingViolationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingViolationParam._cont = ASN1Dict([
        ('extensionContainer', _ForwardingViolationParam_extensionContainer),
        ])
    ForwardingViolationParam._ext = []
    
    #-----< ForwardingFailedParam >-----#
    ForwardingFailedParam = SEQ(name='ForwardingFailedParam', mode=MODE_TYPE)
    _ForwardingFailedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingFailedParam._cont = ASN1Dict([
        ('extensionContainer', _ForwardingFailedParam_extensionContainer),
        ])
    ForwardingFailedParam._ext = []
    
    #-----< ATI-NotAllowedParam >-----#
    ATI_NotAllowedParam = SEQ(name='ATI-NotAllowedParam', mode=MODE_TYPE)
    _ATI_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATI_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _ATI_NotAllowedParam_extensionContainer),
        ])
    ATI_NotAllowedParam._ext = []
    
    #-----< ATSI-NotAllowedParam >-----#
    ATSI_NotAllowedParam = SEQ(name='ATSI-NotAllowedParam', mode=MODE_TYPE)
    _ATSI_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATSI_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _ATSI_NotAllowedParam_extensionContainer),
        ])
    ATSI_NotAllowedParam._ext = []
    
    #-----< ATM-NotAllowedParam >-----#
    ATM_NotAllowedParam = SEQ(name='ATM-NotAllowedParam', mode=MODE_TYPE)
    _ATM_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATM_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _ATM_NotAllowedParam_extensionContainer),
        ])
    ATM_NotAllowedParam._ext = []
    
    #-----< IllegalSS-OperationParam >-----#
    IllegalSS_OperationParam = SEQ(name='IllegalSS-OperationParam', mode=MODE_TYPE)
    _IllegalSS_OperationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSS_OperationParam._cont = ASN1Dict([
        ('extensionContainer', _IllegalSS_OperationParam_extensionContainer),
        ])
    IllegalSS_OperationParam._ext = []
    
    #-----< SS-NotAvailableParam >-----#
    SS_NotAvailableParam = SEQ(name='SS-NotAvailableParam', mode=MODE_TYPE)
    _SS_NotAvailableParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_NotAvailableParam._cont = ASN1Dict([
        ('extensionContainer', _SS_NotAvailableParam_extensionContainer),
        ])
    SS_NotAvailableParam._ext = []
    
    #-----< SS-SubscriptionViolationParam >-----#
    SS_SubscriptionViolationParam = SEQ(name='SS-SubscriptionViolationParam', mode=MODE_TYPE)
    _SS_SubscriptionViolationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_SubscriptionViolationParam._cont = ASN1Dict([
        ('extensionContainer', _SS_SubscriptionViolationParam_extensionContainer),
        ])
    SS_SubscriptionViolationParam._ext = []
    
    #-----< InformationNotAvailableParam >-----#
    InformationNotAvailableParam = SEQ(name='InformationNotAvailableParam', mode=MODE_TYPE)
    _InformationNotAvailableParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    InformationNotAvailableParam._cont = ASN1Dict([
        ('extensionContainer', _InformationNotAvailableParam_extensionContainer),
        ])
    InformationNotAvailableParam._ext = []
    
    #-----< SubBusyForMT-SMS-Param >-----#
    SubBusyForMT_SMS_Param = SEQ(name='SubBusyForMT-SMS-Param', mode=MODE_TYPE)
    _SubBusyForMT_SMS_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubBusyForMT_SMS_Param_gprsConnectionSuspended = NULL(name='gprsConnectionSuspended', mode=MODE_TYPE, opt=True)
    SubBusyForMT_SMS_Param._cont = ASN1Dict([
        ('extensionContainer', _SubBusyForMT_SMS_Param_extensionContainer),
        ('gprsConnectionSuspended', _SubBusyForMT_SMS_Param_gprsConnectionSuspended),
        ])
    SubBusyForMT_SMS_Param._ext = ['gprsConnectionSuspended']
    
    #-----< MessageWaitListFullParam >-----#
    MessageWaitListFullParam = SEQ(name='MessageWaitListFullParam', mode=MODE_TYPE)
    _MessageWaitListFullParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MessageWaitListFullParam._cont = ASN1Dict([
        ('extensionContainer', _MessageWaitListFullParam_extensionContainer),
        ])
    MessageWaitListFullParam._ext = []
    
    #-----< ResourceLimitationParam >-----#
    ResourceLimitationParam = SEQ(name='ResourceLimitationParam', mode=MODE_TYPE)
    _ResourceLimitationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResourceLimitationParam._cont = ASN1Dict([
        ('extensionContainer', _ResourceLimitationParam_extensionContainer),
        ])
    ResourceLimitationParam._ext = []
    
    #-----< NoGroupCallNbParam >-----#
    NoGroupCallNbParam = SEQ(name='NoGroupCallNbParam', mode=MODE_TYPE)
    _NoGroupCallNbParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoGroupCallNbParam._cont = ASN1Dict([
        ('extensionContainer', _NoGroupCallNbParam_extensionContainer),
        ])
    NoGroupCallNbParam._ext = []
    
    #-----< IncompatibleTerminalParam >-----#
    IncompatibleTerminalParam = SEQ(name='IncompatibleTerminalParam', mode=MODE_TYPE)
    _IncompatibleTerminalParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IncompatibleTerminalParam._cont = ASN1Dict([
        ('extensionContainer', _IncompatibleTerminalParam_extensionContainer),
        ])
    IncompatibleTerminalParam._ext = []
    
    #-----< ShortTermDenialParam >-----#
    ShortTermDenialParam = SEQ(name='ShortTermDenialParam', mode=MODE_TYPE)
    ShortTermDenialParam._cont = ASN1Dict([
        ])
    ShortTermDenialParam._ext = []
    
    #-----< LongTermDenialParam >-----#
    LongTermDenialParam = SEQ(name='LongTermDenialParam', mode=MODE_TYPE)
    LongTermDenialParam._cont = ASN1Dict([
        ])
    LongTermDenialParam._ext = []
    
    #-----< UnauthorizedRequestingNetwork-Param >-----#
    UnauthorizedRequestingNetwork_Param = SEQ(name='UnauthorizedRequestingNetwork-Param', mode=MODE_TYPE)
    _UnauthorizedRequestingNetwork_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedRequestingNetwork_Param._cont = ASN1Dict([
        ('extensionContainer', _UnauthorizedRequestingNetwork_Param_extensionContainer),
        ])
    UnauthorizedRequestingNetwork_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Param >-----#
    UnauthorizedLCSClient_Param = SEQ(name='UnauthorizedLCSClient-Param', mode=MODE_TYPE)
    _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic = ENUM(name='unauthorizedLCSClient-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnauthorizedLCSClient-Diagnostic')), opt=True)
    _UnauthorizedLCSClient_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedLCSClient_Param._cont = ASN1Dict([
        ('unauthorizedLCSClient-Diagnostic', _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic),
        ('extensionContainer', _UnauthorizedLCSClient_Param_extensionContainer),
        ])
    UnauthorizedLCSClient_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Diagnostic >-----#
    UnauthorizedLCSClient_Diagnostic = ENUM(name='UnauthorizedLCSClient-Diagnostic', mode=MODE_TYPE)
    UnauthorizedLCSClient_Diagnostic._cont = ASN1Dict([('noAdditionalInformation', 0), ('clientNotInMSPrivacyExceptionList', 1), ('callToClientNotSetup', 2), ('privacyOverrideNotApplicable', 3), ('disallowedByLocalRegulatoryRequirements', 4), ('unauthorizedPrivacyClass', 5), ('unauthorizedCallSessionUnrelatedExternalClient', 6), ('unauthorizedCallSessionRelatedExternalClient', 7)])
    UnauthorizedLCSClient_Diagnostic._ext = ['unauthorizedPrivacyClass', 'unauthorizedCallSessionUnrelatedExternalClient', 'unauthorizedCallSessionRelatedExternalClient']
    
    #-----< PositionMethodFailure-Param >-----#
    PositionMethodFailure_Param = SEQ(name='PositionMethodFailure-Param', mode=MODE_TYPE)
    _PositionMethodFailure_Param_positionMethodFailure_Diagnostic = ENUM(name='positionMethodFailure-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'PositionMethodFailure-Diagnostic')), opt=True)
    _PositionMethodFailure_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PositionMethodFailure_Param._cont = ASN1Dict([
        ('positionMethodFailure-Diagnostic', _PositionMethodFailure_Param_positionMethodFailure_Diagnostic),
        ('extensionContainer', _PositionMethodFailure_Param_extensionContainer),
        ])
    PositionMethodFailure_Param._ext = []
    
    #-----< PositionMethodFailure-Diagnostic >-----#
    PositionMethodFailure_Diagnostic = ENUM(name='PositionMethodFailure-Diagnostic', mode=MODE_TYPE)
    PositionMethodFailure_Diagnostic._cont = ASN1Dict([('congestion', 0), ('insufficientResources', 1), ('insufficientMeasurementData', 2), ('inconsistentMeasurementData', 3), ('locationProcedureNotCompleted', 4), ('locationProcedureNotSupportedByTargetMS', 5), ('qoSNotAttainable', 6), ('positionMethodNotAvailableInNetwork', 7), ('positionMethodNotAvailableInLocationArea', 8)])
    PositionMethodFailure_Diagnostic._ext = []
    
    #-----< UnknownOrUnreachableLCSClient-Param >-----#
    UnknownOrUnreachableLCSClient_Param = SEQ(name='UnknownOrUnreachableLCSClient-Param', mode=MODE_TYPE)
    _UnknownOrUnreachableLCSClient_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnknownOrUnreachableLCSClient_Param._cont = ASN1Dict([
        ('extensionContainer', _UnknownOrUnreachableLCSClient_Param_extensionContainer),
        ])
    UnknownOrUnreachableLCSClient_Param._ext = []
    
    #-----< MM-EventNotSupported-Param >-----#
    MM_EventNotSupported_Param = SEQ(name='MM-EventNotSupported-Param', mode=MODE_TYPE)
    _MM_EventNotSupported_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MM_EventNotSupported_Param._cont = ASN1Dict([
        ('extensionContainer', _MM_EventNotSupported_Param_extensionContainer),
        ])
    MM_EventNotSupported_Param._ext = []
    
    #-----< TargetCellOutsideGCA-Param >-----#
    TargetCellOutsideGCA_Param = SEQ(name='TargetCellOutsideGCA-Param', mode=MODE_TYPE)
    _TargetCellOutsideGCA_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TargetCellOutsideGCA_Param._cont = ASN1Dict([
        ('extensionContainer', _TargetCellOutsideGCA_Param_extensionContainer),
        ])
    TargetCellOutsideGCA_Param._ext = []
    
    #-----< OngoingGroupCallParam >-----#
    OngoingGroupCallParam = SEQ(name='OngoingGroupCallParam', mode=MODE_TYPE)
    _OngoingGroupCallParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OngoingGroupCallParam._cont = ASN1Dict([
        ('extensionContainer', _OngoingGroupCallParam_extensionContainer),
        ])
    OngoingGroupCallParam._ext = []
    
    _all_ = [
        _RoamingNotAllowedParam_roamingNotAllowedCause,
        _RoamingNotAllowedParam_extensionContainer,
        _RoamingNotAllowedParam_additionalRoamingNotAllowedCause,
        RoamingNotAllowedParam,
        AdditionalRoamingNotAllowedCause,
        RoamingNotAllowedCause,
        _CallBarredParam_callBarringCause,
        _CallBarredParam_extensibleCallBarredParam,
        CallBarredParam,
        CallBarringCause,
        _ExtensibleCallBarredParam_callBarringCause,
        _ExtensibleCallBarredParam_extensionContainer,
        _ExtensibleCallBarredParam_unauthorisedMessageOriginator,
        _ExtensibleCallBarredParam_anonymousCallRejection,
        ExtensibleCallBarredParam,
        _CUG_RejectParam_cug_RejectCause,
        _CUG_RejectParam_extensionContainer,
        CUG_RejectParam,
        CUG_RejectCause,
        _SS_IncompatibilityCause_ss_Code,
        _SS_IncompatibilityCause_basicService,
        _SS_IncompatibilityCause_ss_Status,
        SS_IncompatibilityCause,
        PW_RegistrationFailureCause,
        SM_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_diagnosticInfo,
        _SM_DeliveryFailureCause_extensionContainer,
        SM_DeliveryFailureCause,
        _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_extensionContainer,
        _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_imsi,
        _AbsentSubscriberSM_Param_requestedRetransmissionTime,
        _AbsentSubscriberSM_Param_userIdentifierAlert,
        AbsentSubscriberSM_Param,
        AbsentSubscriberDiagnosticSM,
        _SystemFailureParam_networkResource,
        _SystemFailureParam_extensibleSystemFailureParam,
        SystemFailureParam,
        _ExtensibleSystemFailureParam_networkResource,
        _ExtensibleSystemFailureParam_extensionContainer,
        _ExtensibleSystemFailureParam_additionalNetworkResource,
        _ExtensibleSystemFailureParam_failureCauseParam,
        ExtensibleSystemFailureParam,
        FailureCauseParam,
        _DataMissingParam_extensionContainer,
        DataMissingParam,
        _UnexpectedDataParam_extensionContainer,
        _UnexpectedDataParam_unexpectedSubscriber,
        UnexpectedDataParam,
        _FacilityNotSupParam_extensionContainer,
        _FacilityNotSupParam_shapeOfLocationEstimateNotSupported,
        _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode,
        FacilityNotSupParam,
        _OR_NotAllowedParam_extensionContainer,
        OR_NotAllowedParam,
        _UnknownSubscriberParam_extensionContainer,
        _UnknownSubscriberParam_unknownSubscriberDiagnostic,
        UnknownSubscriberParam,
        UnknownSubscriberDiagnostic,
        _NumberChangedParam_extensionContainer,
        NumberChangedParam,
        _UnidentifiedSubParam_extensionContainer,
        UnidentifiedSubParam,
        _IllegalSubscriberParam_extensionContainer,
        IllegalSubscriberParam,
        _IllegalEquipmentParam_extensionContainer,
        IllegalEquipmentParam,
        _BearerServNotProvParam_extensionContainer,
        BearerServNotProvParam,
        _TeleservNotProvParam_extensionContainer,
        TeleservNotProvParam,
        _TracingBufferFullParam_extensionContainer,
        TracingBufferFullParam,
        _NoRoamingNbParam_extensionContainer,
        NoRoamingNbParam,
        _AbsentSubscriberParam_extensionContainer,
        _AbsentSubscriberParam_absentSubscriberReason,
        AbsentSubscriberParam,
        AbsentSubscriberReason,
        _BusySubscriberParam_extensionContainer,
        _BusySubscriberParam_ccbs_Possible,
        _BusySubscriberParam_ccbs_Busy,
        BusySubscriberParam,
        _NoSubscriberReplyParam_extensionContainer,
        NoSubscriberReplyParam,
        _ForwardingViolationParam_extensionContainer,
        ForwardingViolationParam,
        _ForwardingFailedParam_extensionContainer,
        ForwardingFailedParam,
        _ATI_NotAllowedParam_extensionContainer,
        ATI_NotAllowedParam,
        _ATSI_NotAllowedParam_extensionContainer,
        ATSI_NotAllowedParam,
        _ATM_NotAllowedParam_extensionContainer,
        ATM_NotAllowedParam,
        _IllegalSS_OperationParam_extensionContainer,
        IllegalSS_OperationParam,
        _SS_NotAvailableParam_extensionContainer,
        SS_NotAvailableParam,
        _SS_SubscriptionViolationParam_extensionContainer,
        SS_SubscriptionViolationParam,
        _InformationNotAvailableParam_extensionContainer,
        InformationNotAvailableParam,
        _SubBusyForMT_SMS_Param_extensionContainer,
        _SubBusyForMT_SMS_Param_gprsConnectionSuspended,
        SubBusyForMT_SMS_Param,
        _MessageWaitListFullParam_extensionContainer,
        MessageWaitListFullParam,
        _ResourceLimitationParam_extensionContainer,
        ResourceLimitationParam,
        _NoGroupCallNbParam_extensionContainer,
        NoGroupCallNbParam,
        _IncompatibleTerminalParam_extensionContainer,
        IncompatibleTerminalParam,
        ShortTermDenialParam,
        LongTermDenialParam,
        _UnauthorizedRequestingNetwork_Param_extensionContainer,
        UnauthorizedRequestingNetwork_Param,
        _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic,
        _UnauthorizedLCSClient_Param_extensionContainer,
        UnauthorizedLCSClient_Param,
        UnauthorizedLCSClient_Diagnostic,
        _PositionMethodFailure_Param_positionMethodFailure_Diagnostic,
        _PositionMethodFailure_Param_extensionContainer,
        PositionMethodFailure_Param,
        PositionMethodFailure_Diagnostic,
        _UnknownOrUnreachableLCSClient_Param_extensionContainer,
        UnknownOrUnreachableLCSClient_Param,
        _MM_EventNotSupported_Param_extensionContainer,
        MM_EventNotSupported_Param,
        _TargetCellOutsideGCA_Param_extensionContainer,
        TargetCellOutsideGCA_Param,
        _OngoingGroupCallParam_extensionContainer,
        OngoingGroupCallParam,
    ]

class CAP_U_ABORT_Data:

    _name_  = 'CAP-U-ABORT-Data'
    _oid_   = [0, 4, 0, 0, 1, 3, 110, 7]
    
    _obj_ = [
        'id-CAP-U-ABORT-Reason',
        'cAP-U-ABORT-Reason-Abstract-Syntax',
        'CAP-U-ABORT-REASON',
        ]
    _type_ = [
        'CAP-U-ABORT-REASON',
        ]
    _set_ = [
        ]
    _val_ = [
        'id-CAP-U-ABORT-Reason',
        'cAP-U-ABORT-Reason-Abstract-Syntax',
        ]
    _class_ = [
        'cAP-U-ABORT-Reason-Abstract-Syntax',
        ]
    _param_ = [
        ]
    
    #-----< id-CAP-U-ABORT-Reason >-----#
    id_CAP_U_ABORT_Reason = OID(name='id-CAP-U-ABORT-Reason', mode=MODE_VALUE)
    id_CAP_U_ABORT_Reason._val = (0, 4, 0, 0, 1, 1, 2, 2)
    
    #-----< cAP-U-ABORT-Reason-Abstract-Syntax >-----#
    cAP_U_ABORT_Reason_Abstract_Syntax = CLASS(name='cAP-U-ABORT-Reason-Abstract-Syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _cAP_U_ABORT_Reason_Abstract_Syntax_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-U-ABORT-Data', 'CAP-U-ABORT-REASON')))
    cAP_U_ABORT_Reason_Abstract_Syntax._val = dict([('Type', _cAP_U_ABORT_Reason_Abstract_Syntax_val_Type), ('id', (0, 4, 0, 0, 1, 1, 2, 2))])
    
    #-----< CAP-U-ABORT-REASON >-----#
    CAP_U_ABORT_REASON = ENUM(name='CAP-U-ABORT-REASON', mode=MODE_TYPE)
    CAP_U_ABORT_REASON._cont = ASN1Dict([('no-reason-given', 1), ('application-timer-expired', 2), ('not-allowed-procedures', 3), ('abnormal-processing', 4), ('congestion', 5), ('invalid-reference', 6), ('missing-reference', 7), ('overlapping-dialogue', 8)])
    CAP_U_ABORT_REASON._ext = None
    
    _all_ = [
        id_CAP_U_ABORT_Reason,
        cAP_U_ABORT_Reason_Abstract_Syntax,
        _cAP_U_ABORT_Reason_Abstract_Syntax_val_Type,
        CAP_U_ABORT_REASON,
    ]

class CAP_object_identifiers:

    _name_  = 'CAP-object-identifiers'
    _oid_   = [0, 4, 0, 0, 1, 3, 100, 7]
    
    _obj_ = [
        'tc-Messages',
        'tc-NotationExtensions',
        'ros-InformationObjects',
        'datatypes',
        'errortypes',
        'operationcodes',
        'errorcodes',
        'classes',
        'gsmSSF-gsmSCF-Operations',
        'gsmSSF-gsmSCF-Protocol',
        'gsmSCF-gsmSRF-Operations',
        'gsmSCF-gsmSRF-Protocol',
        'sms-Operations',
        'smsSSF-gsmSCF-Protocol',
        'gprsSSF-gsmSCF-Operations',
        'gprsSSF-gsmSCF-Protocol',
        'id-CAP',
        'id-CAP3',
        'id-CAPOE',
        'id-CAP3OE',
        'id-ac',
        'id-acE',
        'id-ac3E',
        'id-as',
        'id-asE',
        'id-rosObject',
        'id-contract',
        'id-contract3',
        'id-contractE',
        'id-package',
        'id-packageE',
        'id-rosObject-gsmSCF',
        'id-rosObject-gsmSSF',
        'id-rosObject-gsmSRF',
        'id-rosObject-gprsSSF',
        'id-rosObject-smsSSF-V3',
        'id-rosObject-smsSSF-V4',
        'id-ac-CAP-gsmSSF-scfGenericAC',
        'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        'id-ac-CAP-scf-gsmSSFGenericAC',
        'id-ac-gsmSRF-gsmSCF',
        'id-ac-CAP-gprsSSF-gsmSCF-AC',
        'id-ac-CAP-gsmSCF-gprsSSF-AC',
        'id-ac-cap3-sms-AC',
        'id-ac-cap4-sms-AC',
        'id-CAPSsfToScfGeneric',
        'id-CAPAssistHandoffssfToScf',
        'id-CAPScfToSsfGeneric',
        'id-contract-gsmSRF-gsmSCF',
        'id-capGprsSsfTogsmScf',
        'id-capGsmScfToGprsSsf',
        'id-cap3SmsSsfTogsmScf',
        'id-cap4SmsSsfTogsmScf',
        'id-package-scfActivation',
        'id-package-gsmSRF-scfActivationOfAssist',
        'id-package-assistConnectionEstablishment',
        'id-package-genericDisconnectResource',
        'id-package-nonAssistedConnectionEstablishment',
        'id-package-connect',
        'id-package-callHandling',
        'id-package-bcsmEventHandling',
        'id-package-ssfCallProcessing',
        'id-package-scfCallInitiation',
        'id-package-timer',
        'id-package-billing',
        'id-package-charging',
        'id-package-trafficManagement',
        'id-package-callReport',
        'id-package-signallingControl',
        'id-package-activityTest',
        'id-package-cancel',
        'id-package-cphResponse',
        'id-package-exceptionInform',
        'id-package-playTone',
        'id-package-specializedResourceControl',
        'id-package-gsmSRF-scfCancel',
        'id-package-gprsContinue',
        'id-package-gprsExceptionInformation',
        'id-package-gprsScfActivation',
        'id-package-gprsConnect',
        'id-package-gprsRelease',
        'id-package-gprsEventHandling',
        'id-package-gprsTimer',
        'id-package-gprsBilling',
        'id-package-gprsCharging',
        'id-package-gprsActivityTest',
        'id-package-gprsCancel',
        'id-package-gprsChargeAdvice',
        'id-package-smsActivation',
        'id-package-smsConnect',
        'id-package-smsContinue',
        'id-package-smsRelease',
        'id-package-smsEventHandling',
        'id-package-smsBilling',
        'id-package-smsTimer',
        'id-as-gsmSSF-scfGenericAS',
        'id-as-assistHandoff-gsmSSF-scfAS',
        'id-as-scf-gsmSSFGenericAS',
        'id-as-basic-gsmSRF-gsmSCF',
        'id-as-gprsSSF-gsmSCF-AS',
        'id-as-gsmSCF-gprsSSF-AS',
        'id-as-smsSSF-gsmSCF-AS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'tc-Messages',
        'tc-NotationExtensions',
        'ros-InformationObjects',
        'datatypes',
        'errortypes',
        'operationcodes',
        'errorcodes',
        'classes',
        'gsmSSF-gsmSCF-Operations',
        'gsmSSF-gsmSCF-Protocol',
        'gsmSCF-gsmSRF-Operations',
        'gsmSCF-gsmSRF-Protocol',
        'sms-Operations',
        'smsSSF-gsmSCF-Protocol',
        'gprsSSF-gsmSCF-Operations',
        'gprsSSF-gsmSCF-Protocol',
        'id-CAP',
        'id-CAP3',
        'id-CAPOE',
        'id-CAP3OE',
        'id-ac',
        'id-acE',
        'id-ac3E',
        'id-as',
        'id-asE',
        'id-rosObject',
        'id-contract',
        'id-contract3',
        'id-contractE',
        'id-package',
        'id-packageE',
        'id-rosObject-gsmSCF',
        'id-rosObject-gsmSSF',
        'id-rosObject-gsmSRF',
        'id-rosObject-gprsSSF',
        'id-rosObject-smsSSF-V3',
        'id-rosObject-smsSSF-V4',
        'id-ac-CAP-gsmSSF-scfGenericAC',
        'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        'id-ac-CAP-scf-gsmSSFGenericAC',
        'id-ac-gsmSRF-gsmSCF',
        'id-ac-CAP-gprsSSF-gsmSCF-AC',
        'id-ac-CAP-gsmSCF-gprsSSF-AC',
        'id-ac-cap3-sms-AC',
        'id-ac-cap4-sms-AC',
        'id-CAPSsfToScfGeneric',
        'id-CAPAssistHandoffssfToScf',
        'id-CAPScfToSsfGeneric',
        'id-contract-gsmSRF-gsmSCF',
        'id-capGprsSsfTogsmScf',
        'id-capGsmScfToGprsSsf',
        'id-cap3SmsSsfTogsmScf',
        'id-cap4SmsSsfTogsmScf',
        'id-package-scfActivation',
        'id-package-gsmSRF-scfActivationOfAssist',
        'id-package-assistConnectionEstablishment',
        'id-package-genericDisconnectResource',
        'id-package-nonAssistedConnectionEstablishment',
        'id-package-connect',
        'id-package-callHandling',
        'id-package-bcsmEventHandling',
        'id-package-ssfCallProcessing',
        'id-package-scfCallInitiation',
        'id-package-timer',
        'id-package-billing',
        'id-package-charging',
        'id-package-trafficManagement',
        'id-package-callReport',
        'id-package-signallingControl',
        'id-package-activityTest',
        'id-package-cancel',
        'id-package-cphResponse',
        'id-package-exceptionInform',
        'id-package-playTone',
        'id-package-specializedResourceControl',
        'id-package-gsmSRF-scfCancel',
        'id-package-gprsContinue',
        'id-package-gprsExceptionInformation',
        'id-package-gprsScfActivation',
        'id-package-gprsConnect',
        'id-package-gprsRelease',
        'id-package-gprsEventHandling',
        'id-package-gprsTimer',
        'id-package-gprsBilling',
        'id-package-gprsCharging',
        'id-package-gprsActivityTest',
        'id-package-gprsCancel',
        'id-package-gprsChargeAdvice',
        'id-package-smsActivation',
        'id-package-smsConnect',
        'id-package-smsContinue',
        'id-package-smsRelease',
        'id-package-smsEventHandling',
        'id-package-smsBilling',
        'id-package-smsTimer',
        'id-as-gsmSSF-scfGenericAS',
        'id-as-assistHandoff-gsmSSF-scfAS',
        'id-as-scf-gsmSSFGenericAS',
        'id-as-basic-gsmSRF-gsmSCF',
        'id-as-gprsSSF-gsmSCF-AS',
        'id-as-gsmSCF-gprsSSF-AS',
        'id-as-smsSSF-gsmSCF-AS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< tc-Messages >-----#
    tc_Messages = OID(name='tc-Messages', mode=MODE_VALUE)
    tc_Messages._val = (0, 0, 17, 773, 2, 1, 3)
    
    #-----< tc-NotationExtensions >-----#
    tc_NotationExtensions = OID(name='tc-NotationExtensions', mode=MODE_VALUE)
    tc_NotationExtensions._val = (0, 0, 17, 775, 2, 4, 1)
    
    #-----< ros-InformationObjects >-----#
    ros_InformationObjects = OID(name='ros-InformationObjects', mode=MODE_VALUE)
    ros_InformationObjects._val = (2, 4, 5, 0)
    
    #-----< datatypes >-----#
    datatypes = OID(name='datatypes', mode=MODE_VALUE)
    datatypes._val = (0, 4, 0, 0, 1, 3, 52, 7)
    
    #-----< errortypes >-----#
    errortypes = OID(name='errortypes', mode=MODE_VALUE)
    errortypes._val = (0, 4, 0, 0, 1, 3, 51, 7)
    
    #-----< operationcodes >-----#
    operationcodes = OID(name='operationcodes', mode=MODE_VALUE)
    operationcodes._val = (0, 4, 0, 0, 1, 3, 53, 7)
    
    #-----< errorcodes >-----#
    errorcodes = OID(name='errorcodes', mode=MODE_VALUE)
    errorcodes._val = (0, 4, 0, 0, 1, 3, 57, 7)
    
    #-----< classes >-----#
    classes = OID(name='classes', mode=MODE_VALUE)
    classes._val = (0, 4, 0, 0, 1, 3, 54, 7)
    
    #-----< gsmSSF-gsmSCF-Operations >-----#
    gsmSSF_gsmSCF_Operations = OID(name='gsmSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 101, 7)
    
    #-----< gsmSSF-gsmSCF-Protocol >-----#
    gsmSSF_gsmSCF_Protocol = OID(name='gsmSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 102, 7)
    
    #-----< gsmSCF-gsmSRF-Operations >-----#
    gsmSCF_gsmSRF_Operations = OID(name='gsmSCF-gsmSRF-Operations', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Operations._val = (0, 4, 0, 0, 1, 3, 103, 7)
    
    #-----< gsmSCF-gsmSRF-Protocol >-----#
    gsmSCF_gsmSRF_Protocol = OID(name='gsmSCF-gsmSRF-Protocol', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Protocol._val = (0, 4, 0, 0, 1, 3, 104, 7)
    
    #-----< sms-Operations >-----#
    sms_Operations = OID(name='sms-Operations', mode=MODE_VALUE)
    sms_Operations._val = (0, 4, 0, 0, 1, 3, 105, 7)
    
    #-----< smsSSF-gsmSCF-Protocol >-----#
    smsSSF_gsmSCF_Protocol = OID(name='smsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    smsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 106, 7)
    
    #-----< gprsSSF-gsmSCF-Operations >-----#
    gprsSSF_gsmSCF_Operations = OID(name='gprsSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 107, 7)
    
    #-----< gprsSSF-gsmSCF-Protocol >-----#
    gprsSSF_gsmSCF_Protocol = OID(name='gprsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 108, 7)
    
    #-----< id-CAP >-----#
    id_CAP = OID(name='id-CAP', mode=MODE_VALUE)
    id_CAP._val = (0, 4, 0, 0, 1, 22)
    
    #-----< id-CAP3 >-----#
    id_CAP3 = OID(name='id-CAP3', mode=MODE_VALUE)
    id_CAP3._val = (0, 4, 0, 0, 1, 20)
    
    #-----< id-CAPOE >-----#
    id_CAPOE = OID(name='id-CAPOE', mode=MODE_VALUE)
    id_CAPOE._val = (0, 4, 0, 0, 1, 23)
    
    #-----< id-CAP3OE >-----#
    id_CAP3OE = OID(name='id-CAP3OE', mode=MODE_VALUE)
    id_CAP3OE._val = (0, 4, 0, 0, 1, 21)
    
    #-----< id-ac >-----#
    id_ac = OID(name='id-ac', mode=MODE_VALUE)
    id_ac._val = (0, 4, 0, 0, 1, 22, 3)
    
    #-----< id-acE >-----#
    id_acE = OID(name='id-acE', mode=MODE_VALUE)
    id_acE._val = (0, 4, 0, 0, 1, 23, 3)
    
    #-----< id-ac3E >-----#
    id_ac3E = OID(name='id-ac3E', mode=MODE_VALUE)
    id_ac3E._val = (0, 4, 0, 0, 1, 21, 3)
    
    #-----< id-as >-----#
    id_as = OID(name='id-as', mode=MODE_VALUE)
    id_as._val = (0, 4, 0, 0, 1, 22, 5)
    
    #-----< id-asE >-----#
    id_asE = OID(name='id-asE', mode=MODE_VALUE)
    id_asE._val = (0, 4, 0, 0, 1, 23, 5)
    
    #-----< id-rosObject >-----#
    id_rosObject = OID(name='id-rosObject', mode=MODE_VALUE)
    id_rosObject._val = (0, 4, 0, 0, 1, 22, 25)
    
    #-----< id-contract >-----#
    id_contract = OID(name='id-contract', mode=MODE_VALUE)
    id_contract._val = (0, 4, 0, 0, 1, 22, 26)
    
    #-----< id-contract3 >-----#
    id_contract3 = OID(name='id-contract3', mode=MODE_VALUE)
    id_contract3._val = (0, 4, 0, 0, 1, 20, 26)
    
    #-----< id-contractE >-----#
    id_contractE = OID(name='id-contractE', mode=MODE_VALUE)
    id_contractE._val = (0, 4, 0, 0, 1, 23, 26)
    
    #-----< id-package >-----#
    id_package = OID(name='id-package', mode=MODE_VALUE)
    id_package._val = (0, 4, 0, 0, 1, 22, 27)
    
    #-----< id-packageE >-----#
    id_packageE = OID(name='id-packageE', mode=MODE_VALUE)
    id_packageE._val = (0, 4, 0, 0, 1, 23, 27)
    
    #-----< id-rosObject-gsmSCF >-----#
    id_rosObject_gsmSCF = OID(name='id-rosObject-gsmSCF', mode=MODE_VALUE)
    id_rosObject_gsmSCF._val = (0, 4, 0, 0, 1, 22, 25, 4)
    
    #-----< id-rosObject-gsmSSF >-----#
    id_rosObject_gsmSSF = OID(name='id-rosObject-gsmSSF', mode=MODE_VALUE)
    id_rosObject_gsmSSF._val = (0, 4, 0, 0, 1, 22, 25, 5)
    
    #-----< id-rosObject-gsmSRF >-----#
    id_rosObject_gsmSRF = OID(name='id-rosObject-gsmSRF', mode=MODE_VALUE)
    id_rosObject_gsmSRF._val = (0, 4, 0, 0, 1, 22, 25, 6)
    
    #-----< id-rosObject-gprsSSF >-----#
    id_rosObject_gprsSSF = OID(name='id-rosObject-gprsSSF', mode=MODE_VALUE)
    id_rosObject_gprsSSF._val = (0, 4, 0, 0, 1, 22, 25, 7)
    
    #-----< id-rosObject-smsSSF-V3 >-----#
    id_rosObject_smsSSF_V3 = OID(name='id-rosObject-smsSSF-V3', mode=MODE_VALUE)
    id_rosObject_smsSSF_V3._val = (0, 4, 0, 0, 1, 22, 25, 8)
    
    #-----< id-rosObject-smsSSF-V4 >-----#
    id_rosObject_smsSSF_V4 = OID(name='id-rosObject-smsSSF-V4', mode=MODE_VALUE)
    id_rosObject_smsSSF_V4._val = (0, 4, 0, 0, 1, 22, 25, 9)
    
    #-----< id-ac-CAP-gsmSSF-scfGenericAC >-----#
    id_ac_CAP_gsmSSF_scfGenericAC = OID(name='id-ac-CAP-gsmSSF-scfGenericAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 4)
    
    #-----< id-ac-CAP-gsmSSF-scfAssistHandoffAC >-----#
    id_ac_CAP_gsmSSF_scfAssistHandoffAC = OID(name='id-ac-CAP-gsmSSF-scfAssistHandoffAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfAssistHandoffAC._val = (0, 4, 0, 0, 1, 23, 3, 6)
    
    #-----< id-ac-CAP-scf-gsmSSFGenericAC >-----#
    id_ac_CAP_scf_gsmSSFGenericAC = OID(name='id-ac-CAP-scf-gsmSSFGenericAC', mode=MODE_VALUE)
    id_ac_CAP_scf_gsmSSFGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 8)
    
    #-----< id-ac-gsmSRF-gsmSCF >-----#
    id_ac_gsmSRF_gsmSCF = OID(name='id-ac-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_ac_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 3, 14)
    
    #-----< id-ac-CAP-gprsSSF-gsmSCF-AC >-----#
    id_ac_CAP_gprsSSF_gsmSCF_AC = OID(name='id-ac-CAP-gprsSSF-gsmSCF-AC', mode=MODE_VALUE)
    id_ac_CAP_gprsSSF_gsmSCF_AC._val = (0, 4, 0, 0, 1, 21, 3, 50)
    
    #-----< id-ac-CAP-gsmSCF-gprsSSF-AC >-----#
    id_ac_CAP_gsmSCF_gprsSSF_AC = OID(name='id-ac-CAP-gsmSCF-gprsSSF-AC', mode=MODE_VALUE)
    id_ac_CAP_gsmSCF_gprsSSF_AC._val = (0, 4, 0, 0, 1, 21, 3, 51)
    
    #-----< id-ac-cap3-sms-AC >-----#
    id_ac_cap3_sms_AC = OID(name='id-ac-cap3-sms-AC', mode=MODE_VALUE)
    id_ac_cap3_sms_AC._val = (0, 4, 0, 0, 1, 21, 3, 61)
    
    #-----< id-ac-cap4-sms-AC >-----#
    id_ac_cap4_sms_AC = OID(name='id-ac-cap4-sms-AC', mode=MODE_VALUE)
    id_ac_cap4_sms_AC._val = (0, 4, 0, 0, 1, 23, 3, 61)
    
    #-----< id-CAPSsfToScfGeneric >-----#
    id_CAPSsfToScfGeneric = OID(name='id-CAPSsfToScfGeneric', mode=MODE_VALUE)
    id_CAPSsfToScfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 3)
    
    #-----< id-CAPAssistHandoffssfToScf >-----#
    id_CAPAssistHandoffssfToScf = OID(name='id-CAPAssistHandoffssfToScf', mode=MODE_VALUE)
    id_CAPAssistHandoffssfToScf._val = (0, 4, 0, 0, 1, 23, 26, 5)
    
    #-----< id-CAPScfToSsfGeneric >-----#
    id_CAPScfToSsfGeneric = OID(name='id-CAPScfToSsfGeneric', mode=MODE_VALUE)
    id_CAPScfToSsfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 6)
    
    #-----< id-contract-gsmSRF-gsmSCF >-----#
    id_contract_gsmSRF_gsmSCF = OID(name='id-contract-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_contract_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 26, 13)
    
    #-----< id-capGprsSsfTogsmScf >-----#
    id_capGprsSsfTogsmScf = OID(name='id-capGprsSsfTogsmScf', mode=MODE_VALUE)
    id_capGprsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 14)
    
    #-----< id-capGsmScfToGprsSsf >-----#
    id_capGsmScfToGprsSsf = OID(name='id-capGsmScfToGprsSsf', mode=MODE_VALUE)
    id_capGsmScfToGprsSsf._val = (0, 4, 0, 0, 1, 22, 26, 15)
    
    #-----< id-cap3SmsSsfTogsmScf >-----#
    id_cap3SmsSsfTogsmScf = OID(name='id-cap3SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap3SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 20, 26, 16)
    
    #-----< id-cap4SmsSsfTogsmScf >-----#
    id_cap4SmsSsfTogsmScf = OID(name='id-cap4SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap4SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 16)
    
    #-----< id-package-scfActivation >-----#
    id_package_scfActivation = OID(name='id-package-scfActivation', mode=MODE_VALUE)
    id_package_scfActivation._val = (0, 4, 0, 0, 1, 22, 27, 11)
    
    #-----< id-package-gsmSRF-scfActivationOfAssist >-----#
    id_package_gsmSRF_scfActivationOfAssist = OID(name='id-package-gsmSRF-scfActivationOfAssist', mode=MODE_VALUE)
    id_package_gsmSRF_scfActivationOfAssist._val = (0, 4, 0, 0, 1, 22, 27, 15)
    
    #-----< id-package-assistConnectionEstablishment >-----#
    id_package_assistConnectionEstablishment = OID(name='id-package-assistConnectionEstablishment', mode=MODE_VALUE)
    id_package_assistConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 16)
    
    #-----< id-package-genericDisconnectResource >-----#
    id_package_genericDisconnectResource = OID(name='id-package-genericDisconnectResource', mode=MODE_VALUE)
    id_package_genericDisconnectResource._val = (0, 4, 0, 0, 1, 22, 27, 17)
    
    #-----< id-package-nonAssistedConnectionEstablishment >-----#
    id_package_nonAssistedConnectionEstablishment = OID(name='id-package-nonAssistedConnectionEstablishment', mode=MODE_VALUE)
    id_package_nonAssistedConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 18)
    
    #-----< id-package-connect >-----#
    id_package_connect = OID(name='id-package-connect', mode=MODE_VALUE)
    id_package_connect._val = (0, 4, 0, 0, 1, 22, 27, 19)
    
    #-----< id-package-callHandling >-----#
    id_package_callHandling = OID(name='id-package-callHandling', mode=MODE_VALUE)
    id_package_callHandling._val = (0, 4, 0, 0, 1, 23, 27, 20)
    
    #-----< id-package-bcsmEventHandling >-----#
    id_package_bcsmEventHandling = OID(name='id-package-bcsmEventHandling', mode=MODE_VALUE)
    id_package_bcsmEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 21)
    
    #-----< id-package-ssfCallProcessing >-----#
    id_package_ssfCallProcessing = OID(name='id-package-ssfCallProcessing', mode=MODE_VALUE)
    id_package_ssfCallProcessing._val = (0, 4, 0, 0, 1, 23, 27, 24)
    
    #-----< id-package-scfCallInitiation >-----#
    id_package_scfCallInitiation = OID(name='id-package-scfCallInitiation', mode=MODE_VALUE)
    id_package_scfCallInitiation._val = (0, 4, 0, 0, 1, 22, 27, 25)
    
    #-----< id-package-timer >-----#
    id_package_timer = OID(name='id-package-timer', mode=MODE_VALUE)
    id_package_timer._val = (0, 4, 0, 0, 1, 22, 27, 26)
    
    #-----< id-package-billing >-----#
    id_package_billing = OID(name='id-package-billing', mode=MODE_VALUE)
    id_package_billing._val = (0, 4, 0, 0, 1, 22, 27, 27)
    
    #-----< id-package-charging >-----#
    id_package_charging = OID(name='id-package-charging', mode=MODE_VALUE)
    id_package_charging._val = (0, 4, 0, 0, 1, 22, 27, 28)
    
    #-----< id-package-trafficManagement >-----#
    id_package_trafficManagement = OID(name='id-package-trafficManagement', mode=MODE_VALUE)
    id_package_trafficManagement._val = (0, 4, 0, 0, 1, 22, 27, 29)
    
    #-----< id-package-callReport >-----#
    id_package_callReport = OID(name='id-package-callReport', mode=MODE_VALUE)
    id_package_callReport._val = (0, 4, 0, 0, 1, 22, 27, 32)
    
    #-----< id-package-signallingControl >-----#
    id_package_signallingControl = OID(name='id-package-signallingControl', mode=MODE_VALUE)
    id_package_signallingControl._val = (0, 4, 0, 0, 1, 22, 27, 33)
    
    #-----< id-package-activityTest >-----#
    id_package_activityTest = OID(name='id-package-activityTest', mode=MODE_VALUE)
    id_package_activityTest._val = (0, 4, 0, 0, 1, 22, 27, 34)
    
    #-----< id-package-cancel >-----#
    id_package_cancel = OID(name='id-package-cancel', mode=MODE_VALUE)
    id_package_cancel._val = (0, 4, 0, 0, 1, 23, 27, 36)
    
    #-----< id-package-cphResponse >-----#
    id_package_cphResponse = OID(name='id-package-cphResponse', mode=MODE_VALUE)
    id_package_cphResponse._val = (0, 4, 0, 0, 1, 22, 27, 37)
    
    #-----< id-package-exceptionInform >-----#
    id_package_exceptionInform = OID(name='id-package-exceptionInform', mode=MODE_VALUE)
    id_package_exceptionInform._val = (0, 4, 0, 0, 1, 22, 27, 38)
    
    #-----< id-package-playTone >-----#
    id_package_playTone = OID(name='id-package-playTone', mode=MODE_VALUE)
    id_package_playTone._val = (0, 4, 0, 0, 1, 22, 27, 39)
    
    #-----< id-package-specializedResourceControl >-----#
    id_package_specializedResourceControl = OID(name='id-package-specializedResourceControl', mode=MODE_VALUE)
    id_package_specializedResourceControl._val = (0, 4, 0, 0, 1, 22, 27, 42)
    
    #-----< id-package-gsmSRF-scfCancel >-----#
    id_package_gsmSRF_scfCancel = OID(name='id-package-gsmSRF-scfCancel', mode=MODE_VALUE)
    id_package_gsmSRF_scfCancel._val = (0, 4, 0, 0, 1, 22, 27, 43)
    
    #-----< id-package-gprsContinue >-----#
    id_package_gprsContinue = OID(name='id-package-gprsContinue', mode=MODE_VALUE)
    id_package_gprsContinue._val = (0, 4, 0, 0, 1, 22, 27, 49)
    
    #-----< id-package-gprsExceptionInformation >-----#
    id_package_gprsExceptionInformation = OID(name='id-package-gprsExceptionInformation', mode=MODE_VALUE)
    id_package_gprsExceptionInformation._val = (0, 4, 0, 0, 1, 22, 27, 50)
    
    #-----< id-package-gprsScfActivation >-----#
    id_package_gprsScfActivation = OID(name='id-package-gprsScfActivation', mode=MODE_VALUE)
    id_package_gprsScfActivation._val = (0, 4, 0, 0, 1, 22, 27, 51)
    
    #-----< id-package-gprsConnect >-----#
    id_package_gprsConnect = OID(name='id-package-gprsConnect', mode=MODE_VALUE)
    id_package_gprsConnect._val = (0, 4, 0, 0, 1, 22, 27, 52)
    
    #-----< id-package-gprsRelease >-----#
    id_package_gprsRelease = OID(name='id-package-gprsRelease', mode=MODE_VALUE)
    id_package_gprsRelease._val = (0, 4, 0, 0, 1, 22, 27, 53)
    
    #-----< id-package-gprsEventHandling >-----#
    id_package_gprsEventHandling = OID(name='id-package-gprsEventHandling', mode=MODE_VALUE)
    id_package_gprsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 54)
    
    #-----< id-package-gprsTimer >-----#
    id_package_gprsTimer = OID(name='id-package-gprsTimer', mode=MODE_VALUE)
    id_package_gprsTimer._val = (0, 4, 0, 0, 1, 22, 27, 55)
    
    #-----< id-package-gprsBilling >-----#
    id_package_gprsBilling = OID(name='id-package-gprsBilling', mode=MODE_VALUE)
    id_package_gprsBilling._val = (0, 4, 0, 0, 1, 22, 27, 56)
    
    #-----< id-package-gprsCharging >-----#
    id_package_gprsCharging = OID(name='id-package-gprsCharging', mode=MODE_VALUE)
    id_package_gprsCharging._val = (0, 4, 0, 0, 1, 22, 27, 57)
    
    #-----< id-package-gprsActivityTest >-----#
    id_package_gprsActivityTest = OID(name='id-package-gprsActivityTest', mode=MODE_VALUE)
    id_package_gprsActivityTest._val = (0, 4, 0, 0, 1, 22, 27, 58)
    
    #-----< id-package-gprsCancel >-----#
    id_package_gprsCancel = OID(name='id-package-gprsCancel', mode=MODE_VALUE)
    id_package_gprsCancel._val = (0, 4, 0, 0, 1, 22, 27, 59)
    
    #-----< id-package-gprsChargeAdvice >-----#
    id_package_gprsChargeAdvice = OID(name='id-package-gprsChargeAdvice', mode=MODE_VALUE)
    id_package_gprsChargeAdvice._val = (0, 4, 0, 0, 1, 22, 27, 60)
    
    #-----< id-package-smsActivation >-----#
    id_package_smsActivation = OID(name='id-package-smsActivation', mode=MODE_VALUE)
    id_package_smsActivation._val = (0, 4, 0, 0, 1, 22, 27, 61)
    
    #-----< id-package-smsConnect >-----#
    id_package_smsConnect = OID(name='id-package-smsConnect', mode=MODE_VALUE)
    id_package_smsConnect._val = (0, 4, 0, 0, 1, 22, 27, 62)
    
    #-----< id-package-smsContinue >-----#
    id_package_smsContinue = OID(name='id-package-smsContinue', mode=MODE_VALUE)
    id_package_smsContinue._val = (0, 4, 0, 0, 1, 22, 27, 63)
    
    #-----< id-package-smsRelease >-----#
    id_package_smsRelease = OID(name='id-package-smsRelease', mode=MODE_VALUE)
    id_package_smsRelease._val = (0, 4, 0, 0, 1, 22, 27, 64)
    
    #-----< id-package-smsEventHandling >-----#
    id_package_smsEventHandling = OID(name='id-package-smsEventHandling', mode=MODE_VALUE)
    id_package_smsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 65)
    
    #-----< id-package-smsBilling >-----#
    id_package_smsBilling = OID(name='id-package-smsBilling', mode=MODE_VALUE)
    id_package_smsBilling._val = (0, 4, 0, 0, 1, 22, 27, 66)
    
    #-----< id-package-smsTimer >-----#
    id_package_smsTimer = OID(name='id-package-smsTimer', mode=MODE_VALUE)
    id_package_smsTimer._val = (0, 4, 0, 0, 1, 22, 27, 67)
    
    #-----< id-as-gsmSSF-scfGenericAS >-----#
    id_as_gsmSSF_scfGenericAS = OID(name='id-as-gsmSSF-scfGenericAS', mode=MODE_VALUE)
    id_as_gsmSSF_scfGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 4)
    
    #-----< id-as-assistHandoff-gsmSSF-scfAS >-----#
    id_as_assistHandoff_gsmSSF_scfAS = OID(name='id-as-assistHandoff-gsmSSF-scfAS', mode=MODE_VALUE)
    id_as_assistHandoff_gsmSSF_scfAS._val = (0, 4, 0, 0, 1, 23, 5, 6)
    
    #-----< id-as-scf-gsmSSFGenericAS >-----#
    id_as_scf_gsmSSFGenericAS = OID(name='id-as-scf-gsmSSFGenericAS', mode=MODE_VALUE)
    id_as_scf_gsmSSFGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 7)
    
    #-----< id-as-basic-gsmSRF-gsmSCF >-----#
    id_as_basic_gsmSRF_gsmSCF = OID(name='id-as-basic-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_as_basic_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 5, 14)
    
    #-----< id-as-gprsSSF-gsmSCF-AS >-----#
    id_as_gprsSSF_gsmSCF_AS = OID(name='id-as-gprsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_gprsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 50)
    
    #-----< id-as-gsmSCF-gprsSSF-AS >-----#
    id_as_gsmSCF_gprsSSF_AS = OID(name='id-as-gsmSCF-gprsSSF-AS', mode=MODE_VALUE)
    id_as_gsmSCF_gprsSSF_AS._val = (0, 4, 0, 0, 1, 22, 5, 51)
    
    #-----< id-as-smsSSF-gsmSCF-AS >-----#
    id_as_smsSSF_gsmSCF_AS = OID(name='id-as-smsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_smsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 61)
    
    _all_ = [
        tc_Messages,
        tc_NotationExtensions,
        ros_InformationObjects,
        datatypes,
        errortypes,
        operationcodes,
        errorcodes,
        classes,
        gsmSSF_gsmSCF_Operations,
        gsmSSF_gsmSCF_Protocol,
        gsmSCF_gsmSRF_Operations,
        gsmSCF_gsmSRF_Protocol,
        sms_Operations,
        smsSSF_gsmSCF_Protocol,
        gprsSSF_gsmSCF_Operations,
        gprsSSF_gsmSCF_Protocol,
        id_CAP,
        id_CAP3,
        id_CAPOE,
        id_CAP3OE,
        id_ac,
        id_acE,
        id_ac3E,
        id_as,
        id_asE,
        id_rosObject,
        id_contract,
        id_contract3,
        id_contractE,
        id_package,
        id_packageE,
        id_rosObject_gsmSCF,
        id_rosObject_gsmSSF,
        id_rosObject_gsmSRF,
        id_rosObject_gprsSSF,
        id_rosObject_smsSSF_V3,
        id_rosObject_smsSSF_V4,
        id_ac_CAP_gsmSSF_scfGenericAC,
        id_ac_CAP_gsmSSF_scfAssistHandoffAC,
        id_ac_CAP_scf_gsmSSFGenericAC,
        id_ac_gsmSRF_gsmSCF,
        id_ac_CAP_gprsSSF_gsmSCF_AC,
        id_ac_CAP_gsmSCF_gprsSSF_AC,
        id_ac_cap3_sms_AC,
        id_ac_cap4_sms_AC,
        id_CAPSsfToScfGeneric,
        id_CAPAssistHandoffssfToScf,
        id_CAPScfToSsfGeneric,
        id_contract_gsmSRF_gsmSCF,
        id_capGprsSsfTogsmScf,
        id_capGsmScfToGprsSsf,
        id_cap3SmsSsfTogsmScf,
        id_cap4SmsSsfTogsmScf,
        id_package_scfActivation,
        id_package_gsmSRF_scfActivationOfAssist,
        id_package_assistConnectionEstablishment,
        id_package_genericDisconnectResource,
        id_package_nonAssistedConnectionEstablishment,
        id_package_connect,
        id_package_callHandling,
        id_package_bcsmEventHandling,
        id_package_ssfCallProcessing,
        id_package_scfCallInitiation,
        id_package_timer,
        id_package_billing,
        id_package_charging,
        id_package_trafficManagement,
        id_package_callReport,
        id_package_signallingControl,
        id_package_activityTest,
        id_package_cancel,
        id_package_cphResponse,
        id_package_exceptionInform,
        id_package_playTone,
        id_package_specializedResourceControl,
        id_package_gsmSRF_scfCancel,
        id_package_gprsContinue,
        id_package_gprsExceptionInformation,
        id_package_gprsScfActivation,
        id_package_gprsConnect,
        id_package_gprsRelease,
        id_package_gprsEventHandling,
        id_package_gprsTimer,
        id_package_gprsBilling,
        id_package_gprsCharging,
        id_package_gprsActivityTest,
        id_package_gprsCancel,
        id_package_gprsChargeAdvice,
        id_package_smsActivation,
        id_package_smsConnect,
        id_package_smsContinue,
        id_package_smsRelease,
        id_package_smsEventHandling,
        id_package_smsBilling,
        id_package_smsTimer,
        id_as_gsmSSF_scfGenericAS,
        id_as_assistHandoff_gsmSSF_scfAS,
        id_as_scf_gsmSSFGenericAS,
        id_as_basic_gsmSRF_gsmSCF,
        id_as_gprsSSF_gsmSCF_AS,
        id_as_gsmSCF_gprsSSF_AS,
        id_as_smsSSF_gsmSCF_AS,
    ]

class CAP_operationcodes:

    _name_  = 'CAP-operationcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 53, 7]
    
    _obj_ = [
        'opcode-initialDP',
        'opcode-assistRequestInstructions',
        'opcode-establishTemporaryConnection',
        'opcode-disconnectForwardConnection',
        'opcode-dFCWithArgument',
        'opcode-connectToResource',
        'opcode-connect',
        'opcode-releaseCall',
        'opcode-requestReportBCSMEvent',
        'opcode-eventReportBCSM',
        'opcode-collectInformation',
        'opcode-continue',
        'opcode-initiateCallAttempt',
        'opcode-resetTimer',
        'opcode-furnishChargingInformation',
        'opcode-applyCharging',
        'opcode-applyChargingReport',
        'opcode-callGap',
        'opcode-callInformationReport',
        'opcode-callInformationRequest',
        'opcode-sendChargingInformation',
        'opcode-playAnnouncement',
        'opcode-promptAndCollectUserInformation',
        'opcode-specializedResourceReport',
        'opcode-cancel',
        'opcode-activityTest',
        'opcode-continueWithArgument',
        'opcode-disconnectLeg',
        'opcode-moveLeg',
        'opcode-splitLeg',
        'opcode-entityReleased',
        'opcode-playTone',
        'opcode-initialDPSMS',
        'opcode-furnishChargingInformationSMS',
        'opcode-connectSMS',
        'opcode-requestReportSMSEvent',
        'opcode-eventReportSMS',
        'opcode-continueSMS',
        'opcode-releaseSMS',
        'opcode-resetTimerSMS',
        'opcode-activityTestGPRS',
        'opcode-applyChargingGPRS',
        'opcode-applyChargingReportGPRS',
        'opcode-cancelGPRS',
        'opcode-connectGPRS',
        'opcode-continueGPRS',
        'opcode-entityReleasedGPRS',
        'opcode-furnishChargingInformationGPRS',
        'opcode-initialDPGPRS',
        'opcode-releaseGPRS',
        'opcode-eventReportGPRS',
        'opcode-requestReportGPRSEvent',
        'opcode-resetTimerGPRS',
        'opcode-sendChargingInformationGPRS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'opcode-initialDP',
        'opcode-assistRequestInstructions',
        'opcode-establishTemporaryConnection',
        'opcode-disconnectForwardConnection',
        'opcode-dFCWithArgument',
        'opcode-connectToResource',
        'opcode-connect',
        'opcode-releaseCall',
        'opcode-requestReportBCSMEvent',
        'opcode-eventReportBCSM',
        'opcode-collectInformation',
        'opcode-continue',
        'opcode-initiateCallAttempt',
        'opcode-resetTimer',
        'opcode-furnishChargingInformation',
        'opcode-applyCharging',
        'opcode-applyChargingReport',
        'opcode-callGap',
        'opcode-callInformationReport',
        'opcode-callInformationRequest',
        'opcode-sendChargingInformation',
        'opcode-playAnnouncement',
        'opcode-promptAndCollectUserInformation',
        'opcode-specializedResourceReport',
        'opcode-cancel',
        'opcode-activityTest',
        'opcode-continueWithArgument',
        'opcode-disconnectLeg',
        'opcode-moveLeg',
        'opcode-splitLeg',
        'opcode-entityReleased',
        'opcode-playTone',
        'opcode-initialDPSMS',
        'opcode-furnishChargingInformationSMS',
        'opcode-connectSMS',
        'opcode-requestReportSMSEvent',
        'opcode-eventReportSMS',
        'opcode-continueSMS',
        'opcode-releaseSMS',
        'opcode-resetTimerSMS',
        'opcode-activityTestGPRS',
        'opcode-applyChargingGPRS',
        'opcode-applyChargingReportGPRS',
        'opcode-cancelGPRS',
        'opcode-connectGPRS',
        'opcode-continueGPRS',
        'opcode-entityReleasedGPRS',
        'opcode-furnishChargingInformationGPRS',
        'opcode-initialDPGPRS',
        'opcode-releaseGPRS',
        'opcode-eventReportGPRS',
        'opcode-requestReportGPRSEvent',
        'opcode-resetTimerGPRS',
        'opcode-sendChargingInformationGPRS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< opcode-initialDP >-----#
    opcode_initialDP = CHOICE(name='opcode-initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDP._val = ('local', 0)
    
    #-----< opcode-assistRequestInstructions >-----#
    opcode_assistRequestInstructions = CHOICE(name='opcode-assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_assistRequestInstructions._val = ('local', 16)
    
    #-----< opcode-establishTemporaryConnection >-----#
    opcode_establishTemporaryConnection = CHOICE(name='opcode-establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_establishTemporaryConnection._val = ('local', 17)
    
    #-----< opcode-disconnectForwardConnection >-----#
    opcode_disconnectForwardConnection = CHOICE(name='opcode-disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectForwardConnection._val = ('local', 18)
    
    #-----< opcode-dFCWithArgument >-----#
    opcode_dFCWithArgument = CHOICE(name='opcode-dFCWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_dFCWithArgument._val = ('local', 86)
    
    #-----< opcode-connectToResource >-----#
    opcode_connectToResource = CHOICE(name='opcode-connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectToResource._val = ('local', 19)
    
    #-----< opcode-connect >-----#
    opcode_connect = CHOICE(name='opcode-connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connect._val = ('local', 20)
    
    #-----< opcode-releaseCall >-----#
    opcode_releaseCall = CHOICE(name='opcode-releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseCall._val = ('local', 22)
    
    #-----< opcode-requestReportBCSMEvent >-----#
    opcode_requestReportBCSMEvent = CHOICE(name='opcode-requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportBCSMEvent._val = ('local', 23)
    
    #-----< opcode-eventReportBCSM >-----#
    opcode_eventReportBCSM = CHOICE(name='opcode-eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportBCSM._val = ('local', 24)
    
    #-----< opcode-collectInformation >-----#
    opcode_collectInformation = CHOICE(name='opcode-collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_collectInformation._val = ('local', 27)
    
    #-----< opcode-continue >-----#
    opcode_continue = CHOICE(name='opcode-continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continue._val = ('local', 31)
    
    #-----< opcode-initiateCallAttempt >-----#
    opcode_initiateCallAttempt = CHOICE(name='opcode-initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initiateCallAttempt._val = ('local', 32)
    
    #-----< opcode-resetTimer >-----#
    opcode_resetTimer = CHOICE(name='opcode-resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimer._val = ('local', 33)
    
    #-----< opcode-furnishChargingInformation >-----#
    opcode_furnishChargingInformation = CHOICE(name='opcode-furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformation._val = ('local', 34)
    
    #-----< opcode-applyCharging >-----#
    opcode_applyCharging = CHOICE(name='opcode-applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyCharging._val = ('local', 35)
    
    #-----< opcode-applyChargingReport >-----#
    opcode_applyChargingReport = CHOICE(name='opcode-applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReport._val = ('local', 36)
    
    #-----< opcode-callGap >-----#
    opcode_callGap = CHOICE(name='opcode-callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callGap._val = ('local', 41)
    
    #-----< opcode-callInformationReport >-----#
    opcode_callInformationReport = CHOICE(name='opcode-callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationReport._val = ('local', 44)
    
    #-----< opcode-callInformationRequest >-----#
    opcode_callInformationRequest = CHOICE(name='opcode-callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationRequest._val = ('local', 45)
    
    #-----< opcode-sendChargingInformation >-----#
    opcode_sendChargingInformation = CHOICE(name='opcode-sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformation._val = ('local', 46)
    
    #-----< opcode-playAnnouncement >-----#
    opcode_playAnnouncement = CHOICE(name='opcode-playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playAnnouncement._val = ('local', 47)
    
    #-----< opcode-promptAndCollectUserInformation >-----#
    opcode_promptAndCollectUserInformation = CHOICE(name='opcode-promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_promptAndCollectUserInformation._val = ('local', 48)
    
    #-----< opcode-specializedResourceReport >-----#
    opcode_specializedResourceReport = CHOICE(name='opcode-specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_specializedResourceReport._val = ('local', 49)
    
    #-----< opcode-cancel >-----#
    opcode_cancel = CHOICE(name='opcode-cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancel._val = ('local', 53)
    
    #-----< opcode-activityTest >-----#
    opcode_activityTest = CHOICE(name='opcode-activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTest._val = ('local', 55)
    
    #-----< opcode-continueWithArgument >-----#
    opcode_continueWithArgument = CHOICE(name='opcode-continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueWithArgument._val = ('local', 88)
    
    #-----< opcode-disconnectLeg >-----#
    opcode_disconnectLeg = CHOICE(name='opcode-disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectLeg._val = ('local', 90)
    
    #-----< opcode-moveLeg >-----#
    opcode_moveLeg = CHOICE(name='opcode-moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_moveLeg._val = ('local', 93)
    
    #-----< opcode-splitLeg >-----#
    opcode_splitLeg = CHOICE(name='opcode-splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_splitLeg._val = ('local', 95)
    
    #-----< opcode-entityReleased >-----#
    opcode_entityReleased = CHOICE(name='opcode-entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleased._val = ('local', 96)
    
    #-----< opcode-playTone >-----#
    opcode_playTone = CHOICE(name='opcode-playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playTone._val = ('local', 97)
    
    #-----< opcode-initialDPSMS >-----#
    opcode_initialDPSMS = CHOICE(name='opcode-initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPSMS._val = ('local', 60)
    
    #-----< opcode-furnishChargingInformationSMS >-----#
    opcode_furnishChargingInformationSMS = CHOICE(name='opcode-furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationSMS._val = ('local', 61)
    
    #-----< opcode-connectSMS >-----#
    opcode_connectSMS = CHOICE(name='opcode-connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectSMS._val = ('local', 62)
    
    #-----< opcode-requestReportSMSEvent >-----#
    opcode_requestReportSMSEvent = CHOICE(name='opcode-requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportSMSEvent._val = ('local', 63)
    
    #-----< opcode-eventReportSMS >-----#
    opcode_eventReportSMS = CHOICE(name='opcode-eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportSMS._val = ('local', 64)
    
    #-----< opcode-continueSMS >-----#
    opcode_continueSMS = CHOICE(name='opcode-continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueSMS._val = ('local', 65)
    
    #-----< opcode-releaseSMS >-----#
    opcode_releaseSMS = CHOICE(name='opcode-releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseSMS._val = ('local', 66)
    
    #-----< opcode-resetTimerSMS >-----#
    opcode_resetTimerSMS = CHOICE(name='opcode-resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerSMS._val = ('local', 67)
    
    #-----< opcode-activityTestGPRS >-----#
    opcode_activityTestGPRS = CHOICE(name='opcode-activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTestGPRS._val = ('local', 70)
    
    #-----< opcode-applyChargingGPRS >-----#
    opcode_applyChargingGPRS = CHOICE(name='opcode-applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingGPRS._val = ('local', 71)
    
    #-----< opcode-applyChargingReportGPRS >-----#
    opcode_applyChargingReportGPRS = CHOICE(name='opcode-applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReportGPRS._val = ('local', 72)
    
    #-----< opcode-cancelGPRS >-----#
    opcode_cancelGPRS = CHOICE(name='opcode-cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancelGPRS._val = ('local', 73)
    
    #-----< opcode-connectGPRS >-----#
    opcode_connectGPRS = CHOICE(name='opcode-connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectGPRS._val = ('local', 74)
    
    #-----< opcode-continueGPRS >-----#
    opcode_continueGPRS = CHOICE(name='opcode-continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueGPRS._val = ('local', 75)
    
    #-----< opcode-entityReleasedGPRS >-----#
    opcode_entityReleasedGPRS = CHOICE(name='opcode-entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleasedGPRS._val = ('local', 76)
    
    #-----< opcode-furnishChargingInformationGPRS >-----#
    opcode_furnishChargingInformationGPRS = CHOICE(name='opcode-furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationGPRS._val = ('local', 77)
    
    #-----< opcode-initialDPGPRS >-----#
    opcode_initialDPGPRS = CHOICE(name='opcode-initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPGPRS._val = ('local', 78)
    
    #-----< opcode-releaseGPRS >-----#
    opcode_releaseGPRS = CHOICE(name='opcode-releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseGPRS._val = ('local', 79)
    
    #-----< opcode-eventReportGPRS >-----#
    opcode_eventReportGPRS = CHOICE(name='opcode-eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportGPRS._val = ('local', 80)
    
    #-----< opcode-requestReportGPRSEvent >-----#
    opcode_requestReportGPRSEvent = CHOICE(name='opcode-requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportGPRSEvent._val = ('local', 81)
    
    #-----< opcode-resetTimerGPRS >-----#
    opcode_resetTimerGPRS = CHOICE(name='opcode-resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerGPRS._val = ('local', 82)
    
    #-----< opcode-sendChargingInformationGPRS >-----#
    opcode_sendChargingInformationGPRS = CHOICE(name='opcode-sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformationGPRS._val = ('local', 83)
    
    _all_ = [
        opcode_initialDP,
        opcode_assistRequestInstructions,
        opcode_establishTemporaryConnection,
        opcode_disconnectForwardConnection,
        opcode_dFCWithArgument,
        opcode_connectToResource,
        opcode_connect,
        opcode_releaseCall,
        opcode_requestReportBCSMEvent,
        opcode_eventReportBCSM,
        opcode_collectInformation,
        opcode_continue,
        opcode_initiateCallAttempt,
        opcode_resetTimer,
        opcode_furnishChargingInformation,
        opcode_applyCharging,
        opcode_applyChargingReport,
        opcode_callGap,
        opcode_callInformationReport,
        opcode_callInformationRequest,
        opcode_sendChargingInformation,
        opcode_playAnnouncement,
        opcode_promptAndCollectUserInformation,
        opcode_specializedResourceReport,
        opcode_cancel,
        opcode_activityTest,
        opcode_continueWithArgument,
        opcode_disconnectLeg,
        opcode_moveLeg,
        opcode_splitLeg,
        opcode_entityReleased,
        opcode_playTone,
        opcode_initialDPSMS,
        opcode_furnishChargingInformationSMS,
        opcode_connectSMS,
        opcode_requestReportSMSEvent,
        opcode_eventReportSMS,
        opcode_continueSMS,
        opcode_releaseSMS,
        opcode_resetTimerSMS,
        opcode_activityTestGPRS,
        opcode_applyChargingGPRS,
        opcode_applyChargingReportGPRS,
        opcode_cancelGPRS,
        opcode_connectGPRS,
        opcode_continueGPRS,
        opcode_entityReleasedGPRS,
        opcode_furnishChargingInformationGPRS,
        opcode_initialDPGPRS,
        opcode_releaseGPRS,
        opcode_eventReportGPRS,
        opcode_requestReportGPRSEvent,
        opcode_resetTimerGPRS,
        opcode_sendChargingInformationGPRS,
    ]

class CAP_errorcodes:

    _name_  = 'CAP-errorcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 57, 7]
    
    _obj_ = [
        'errcode-canceled',
        'errcode-cancelFailed',
        'errcode-eTCFailed',
        'errcode-improperCallerResponse',
        'errcode-missingCustomerRecord',
        'errcode-missingParameter',
        'errcode-parameterOutOfRange',
        'errcode-requestedInfoError',
        'errcode-systemFailure',
        'errcode-taskRefused',
        'errcode-unavailableResource',
        'errcode-unexpectedComponentSequence',
        'errcode-unexpectedDataValue',
        'errcode-unexpectedParameter',
        'errcode-unknownLegID',
        'errcode-unknownPDPID',
        'errcode-unknownCSID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'errcode-canceled',
        'errcode-cancelFailed',
        'errcode-eTCFailed',
        'errcode-improperCallerResponse',
        'errcode-missingCustomerRecord',
        'errcode-missingParameter',
        'errcode-parameterOutOfRange',
        'errcode-requestedInfoError',
        'errcode-systemFailure',
        'errcode-taskRefused',
        'errcode-unavailableResource',
        'errcode-unexpectedComponentSequence',
        'errcode-unexpectedDataValue',
        'errcode-unexpectedParameter',
        'errcode-unknownLegID',
        'errcode-unknownPDPID',
        'errcode-unknownCSID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< errcode-canceled >-----#
    errcode_canceled = CHOICE(name='errcode-canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_canceled._val = ('local', 0)
    
    #-----< errcode-cancelFailed >-----#
    errcode_cancelFailed = CHOICE(name='errcode-cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_cancelFailed._val = ('local', 1)
    
    #-----< errcode-eTCFailed >-----#
    errcode_eTCFailed = CHOICE(name='errcode-eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_eTCFailed._val = ('local', 3)
    
    #-----< errcode-improperCallerResponse >-----#
    errcode_improperCallerResponse = CHOICE(name='errcode-improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_improperCallerResponse._val = ('local', 4)
    
    #-----< errcode-missingCustomerRecord >-----#
    errcode_missingCustomerRecord = CHOICE(name='errcode-missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingCustomerRecord._val = ('local', 6)
    
    #-----< errcode-missingParameter >-----#
    errcode_missingParameter = CHOICE(name='errcode-missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingParameter._val = ('local', 7)
    
    #-----< errcode-parameterOutOfRange >-----#
    errcode_parameterOutOfRange = CHOICE(name='errcode-parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_parameterOutOfRange._val = ('local', 8)
    
    #-----< errcode-requestedInfoError >-----#
    errcode_requestedInfoError = CHOICE(name='errcode-requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_requestedInfoError._val = ('local', 10)
    
    #-----< errcode-systemFailure >-----#
    errcode_systemFailure = CHOICE(name='errcode-systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_systemFailure._val = ('local', 11)
    
    #-----< errcode-taskRefused >-----#
    errcode_taskRefused = CHOICE(name='errcode-taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_taskRefused._val = ('local', 12)
    
    #-----< errcode-unavailableResource >-----#
    errcode_unavailableResource = CHOICE(name='errcode-unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unavailableResource._val = ('local', 13)
    
    #-----< errcode-unexpectedComponentSequence >-----#
    errcode_unexpectedComponentSequence = CHOICE(name='errcode-unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedComponentSequence._val = ('local', 14)
    
    #-----< errcode-unexpectedDataValue >-----#
    errcode_unexpectedDataValue = CHOICE(name='errcode-unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedDataValue._val = ('local', 15)
    
    #-----< errcode-unexpectedParameter >-----#
    errcode_unexpectedParameter = CHOICE(name='errcode-unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedParameter._val = ('local', 16)
    
    #-----< errcode-unknownLegID >-----#
    errcode_unknownLegID = CHOICE(name='errcode-unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownLegID._val = ('local', 17)
    
    #-----< errcode-unknownPDPID >-----#
    errcode_unknownPDPID = CHOICE(name='errcode-unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownPDPID._val = ('local', 50)
    
    #-----< errcode-unknownCSID >-----#
    errcode_unknownCSID = CHOICE(name='errcode-unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownCSID._val = ('local', 51)
    
    _all_ = [
        errcode_canceled,
        errcode_cancelFailed,
        errcode_eTCFailed,
        errcode_improperCallerResponse,
        errcode_missingCustomerRecord,
        errcode_missingParameter,
        errcode_parameterOutOfRange,
        errcode_requestedInfoError,
        errcode_systemFailure,
        errcode_taskRefused,
        errcode_unavailableResource,
        errcode_unexpectedComponentSequence,
        errcode_unexpectedDataValue,
        errcode_unexpectedParameter,
        errcode_unknownLegID,
        errcode_unknownPDPID,
        errcode_unknownCSID,
    ]

class CAP_errortypes:

    _name_  = 'CAP-errortypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 51, 7]
    
    _obj_ = [
        'canceled',
        'cancelFailed',
        'eTCFailed',
        'improperCallerResponse',
        'missingCustomerRecord',
        'missingParameter',
        'parameterOutOfRange',
        'requestedInfoError',
        'systemFailure',
        'taskRefused',
        'unavailableResource',
        'unexpectedComponentSequence',
        'unexpectedDataValue',
        'unexpectedParameter',
        'unknownLegID',
        'unknownCSID',
        'unknownPDPID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'canceled',
        'cancelFailed',
        'eTCFailed',
        'improperCallerResponse',
        'missingCustomerRecord',
        'missingParameter',
        'parameterOutOfRange',
        'requestedInfoError',
        'systemFailure',
        'taskRefused',
        'unavailableResource',
        'unexpectedComponentSequence',
        'unexpectedDataValue',
        'unexpectedParameter',
        'unknownLegID',
        'unknownCSID',
        'unknownPDPID',
        ]
    _class_ = [
        'canceled',
        'cancelFailed',
        'eTCFailed',
        'improperCallerResponse',
        'missingCustomerRecord',
        'missingParameter',
        'parameterOutOfRange',
        'requestedInfoError',
        'systemFailure',
        'taskRefused',
        'unavailableResource',
        'unexpectedComponentSequence',
        'unexpectedDataValue',
        'unexpectedParameter',
        'unknownLegID',
        'unknownCSID',
        'unknownPDPID',
        ]
    _param_ = [
        ]
    
    #-----< canceled >-----#
    canceled = CLASS(name='canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    canceled._val = dict([('errorCode', ('local', 0))])
    
    #-----< cancelFailed >-----#
    cancelFailed = CLASS(name='cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _cancelFailed_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE)
    __cancelFailed_val_ParameterType_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __cancelFailed_val_ParameterType_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    __cancelFailed_val_ParameterType_problem._ext = None
    __cancelFailed_val_ParameterType_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _cancelFailed_val_ParameterType._cont = ASN1Dict([
        ('problem', __cancelFailed_val_ParameterType_problem),
        ('operation', __cancelFailed_val_ParameterType_operation),
        ])
    _cancelFailed_val_ParameterType._ext = []
    cancelFailed._val = dict([('ParameterType', _cancelFailed_val_ParameterType), ('errorCode', ('local', 1))])
    
    #-----< eTCFailed >-----#
    eTCFailed = CLASS(name='eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    eTCFailed._val = dict([('errorCode', ('local', 3))])
    
    #-----< improperCallerResponse >-----#
    improperCallerResponse = CLASS(name='improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    improperCallerResponse._val = dict([('errorCode', ('local', 4))])
    
    #-----< missingCustomerRecord >-----#
    missingCustomerRecord = CLASS(name='missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingCustomerRecord._val = dict([('errorCode', ('local', 6))])
    
    #-----< missingParameter >-----#
    missingParameter = CLASS(name='missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingParameter._val = dict([('errorCode', ('local', 7))])
    
    #-----< parameterOutOfRange >-----#
    parameterOutOfRange = CLASS(name='parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    parameterOutOfRange._val = dict([('errorCode', ('local', 8))])
    
    #-----< requestedInfoError >-----#
    requestedInfoError = CLASS(name='requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _requestedInfoError_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE)
    _requestedInfoError_val_ParameterType._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    _requestedInfoError_val_ParameterType._ext = None
    requestedInfoError._val = dict([('ParameterType', _requestedInfoError_val_ParameterType), ('errorCode', ('local', 10))])
    
    #-----< systemFailure >-----#
    systemFailure = CLASS(name='systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _systemFailure_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    systemFailure._val = dict([('ParameterType', _systemFailure_val_ParameterType), ('errorCode', ('local', 11))])
    
    #-----< taskRefused >-----#
    taskRefused = CLASS(name='taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _taskRefused_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE)
    _taskRefused_val_ParameterType._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _taskRefused_val_ParameterType._ext = None
    taskRefused._val = dict([('ParameterType', _taskRefused_val_ParameterType), ('errorCode', ('local', 12))])
    
    #-----< unavailableResource >-----#
    unavailableResource = CLASS(name='unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unavailableResource._val = dict([('errorCode', ('local', 13))])
    
    #-----< unexpectedComponentSequence >-----#
    unexpectedComponentSequence = CLASS(name='unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedComponentSequence._val = dict([('errorCode', ('local', 14))])
    
    #-----< unexpectedDataValue >-----#
    unexpectedDataValue = CLASS(name='unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedDataValue._val = dict([('errorCode', ('local', 15))])
    
    #-----< unexpectedParameter >-----#
    unexpectedParameter = CLASS(name='unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedParameter._val = dict([('errorCode', ('local', 16))])
    
    #-----< unknownLegID >-----#
    unknownLegID = CLASS(name='unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownLegID._val = dict([('errorCode', ('local', 17))])
    
    #-----< unknownCSID >-----#
    unknownCSID = CLASS(name='unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownCSID._val = dict([('errorCode', ('local', 51))])
    
    #-----< unknownPDPID >-----#
    unknownPDPID = CLASS(name='unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownPDPID._val = dict([('errorCode', ('local', 50))])
    
    _all_ = [
        canceled,
        cancelFailed,
        __cancelFailed_val_ParameterType_problem,
        __cancelFailed_val_ParameterType_operation,
        _cancelFailed_val_ParameterType,
        eTCFailed,
        improperCallerResponse,
        missingCustomerRecord,
        missingParameter,
        parameterOutOfRange,
        requestedInfoError,
        _requestedInfoError_val_ParameterType,
        systemFailure,
        _systemFailure_val_ParameterType,
        taskRefused,
        _taskRefused_val_ParameterType,
        unavailableResource,
        unexpectedComponentSequence,
        unexpectedDataValue,
        unexpectedParameter,
        unknownLegID,
        unknownCSID,
        unknownPDPID,
    ]

class CAP_datatypes:

    _name_  = 'CAP-datatypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 52, 7]
    
    _obj_ = [
        'AccessPointName',
        'AChBillingChargingCharacteristics',
        'AChChargingAddress',
        'AdditionalCallingPartyNumber',
        'AlertingPattern',
        'AOCBeforeAnswer',
        'AOCGPRS',
        'AOCSubsequent',
        'AppendFreeFormatData',
        'ApplicationTimer',
        'AssistingSSPIPRoutingAddress',
        'AudibleIndicator',
        'BackwardServiceInteractionInd',
        'BasicGapCriteria',
        'BCSMEvent',
        'BCSM-Failure',
        'BearerCapability',
        'Burst',
        'BurstList',
        'CAI-GSM0224',
        'CalledPartyBCDNumber',
        'CalledPartyNumber',
        'CallingPartyNumber',
        'CallResult',
        'CallSegmentFailure',
        'CallSegmentID',
        'CallSegmentToCancel',
        'CAMEL-AChBillingChargingCharacteristics',
        'CAMEL-CallResult',
        'CAMEL-FCIBillingChargingCharacteristics',
        'CAMEL-FCIGPRSBillingChargingCharacteristics',
        'CAMEL-FCISMSBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristicsAlt',
        'CAMEL-SCIGPRSBillingChargingCharacteristics',
        'Carrier',
        'Cause',
        'CGEncountered',
        'ChangeOfPositionControlInfo',
        'ChangeOfLocation',
        'ChangeOfLocationAlt',
        'ChargeIndicator',
        'ChargeNumber',
        'ChargingCharacteristics',
        'ChargingResult',
        'ChargingRollOver',
        'CollectedDigits',
        'CollectedInfo',
        'ConnectedNumberTreatmentInd',
        'ControlType',
        'CompoundCriteria',
        'CorrelationID',
        'DateAndTime',
        'DestinationRoutingAddress',
        'Digits',
        'DpSpecificCriteria',
        'DpSpecificCriteriaAlt',
        'DpSpecificInfoAlt',
        'ElapsedTime',
        'ElapsedTimeRollOver',
        'EndUserAddress',
        'ErrorTreatment',
        'EventSpecificInformationBCSM',
        'EventSpecificInformationSMS',
        'EventTypeBCSM',
        'EventTypeSMS',
        'Extensions',
        'ExtensionField',
        'FCIBillingChargingCharacteristics',
        'FCIGPRSBillingChargingCharacteristics',
        'FCISMSBillingChargingCharacteristics',
        'ForwardServiceInteractionInd',
        'GapCriteria',
        'GapIndicators',
        'GapOnService',
        'GapTreatment',
        'GenericNumber',
        'GenericNumbers',
        'GPRS-QoS',
        'GPRS-QoS-Extension',
        'GPRSCause',
        'GPRSEvent',
        'GPRSEventSpecificInformation',
        'GPRSEventType',
        'InbandInfo',
        'InformationToSend',
        'InitiatingEntity',
        'InitiatorOfServiceChange',
        'InvokeID',
        'IPRoutingAddress',
        'IPSSPCapabilities',
        'LegOrCallSegment',
        'LegType',
        'leg1',
        'leg2',
        'LocationInformationGPRS',
        'LocationNumber',
        'LowLayerCompatibility',
        'MessageID',
        'MetDPCriteriaList',
        'MetDPCriterion',
        'MetDPCriterionAlt',
        'MidCallControlInfo',
        'MonitorMode',
        'MO-SMSCause',
        'MT-SMSCause',
        'NAOliInfo',
        'NatureOfServiceChange',
        'NumberOfDigits',
        'OCSIApplicable',
        'OriginalCalledPartyID',
        'PDPID',
        'PDPInitiationType',
        'QualityOfService',
        'ReceivingSideID',
        'RedirectingPartyID',
        'RequestedInformationList',
        'RequestedInformationTypeList',
        'RequestedInformation',
        'RequestedInformationType',
        'RequestedInformationValue',
        'RPCause',
        'ScfID',
        'SCIBillingChargingCharacteristics',
        'SCIGPRSBillingChargingCharacteristics',
        'SendingSideID',
        'ServiceInteractionIndicatorsTwo',
        'SGSNCapabilities',
        'SMS-AddressString',
        'maxSMS-AddressStringLength',
        'SMSEvent',
        'TariffSwitchInterval',
        'TimeAndTimezone',
        'TimeIfNoTariffSwitch',
        'TimeIfTariffSwitch',
        'TimeInformation',
        'TimerID',
        'TimerValue',
        'Tone',
        'TPDataCodingScheme',
        'TPProtocolIdentifier',
        'TPShortMessageSpecificInfo',
        'TPValidityPeriod',
        'TransferredVolume',
        'TransferredVolumeRollOver',
        'UnavailableNetworkResource',
        'VariablePart',
        'numOfInfoItems',
        ]
    _type_ = [
        'AccessPointName',
        'AChBillingChargingCharacteristics',
        'AChChargingAddress',
        'AdditionalCallingPartyNumber',
        'AlertingPattern',
        'AOCBeforeAnswer',
        'AOCGPRS',
        'AOCSubsequent',
        'AppendFreeFormatData',
        'ApplicationTimer',
        'AssistingSSPIPRoutingAddress',
        'AudibleIndicator',
        'BackwardServiceInteractionInd',
        'BasicGapCriteria',
        'BCSMEvent',
        'BCSM-Failure',
        'BearerCapability',
        'Burst',
        'BurstList',
        'CAI-GSM0224',
        'CalledPartyBCDNumber',
        'CalledPartyNumber',
        'CallingPartyNumber',
        'CallResult',
        'CallSegmentFailure',
        'CallSegmentID',
        'CallSegmentToCancel',
        'CAMEL-AChBillingChargingCharacteristics',
        'CAMEL-CallResult',
        'CAMEL-FCIBillingChargingCharacteristics',
        'CAMEL-FCIGPRSBillingChargingCharacteristics',
        'CAMEL-FCISMSBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristicsAlt',
        'CAMEL-SCIGPRSBillingChargingCharacteristics',
        'Carrier',
        'Cause',
        'CGEncountered',
        'ChangeOfPositionControlInfo',
        'ChangeOfLocation',
        'ChangeOfLocationAlt',
        'ChargeIndicator',
        'ChargeNumber',
        'ChargingCharacteristics',
        'ChargingResult',
        'ChargingRollOver',
        'CollectedDigits',
        'CollectedInfo',
        'ConnectedNumberTreatmentInd',
        'ControlType',
        'CompoundCriteria',
        'CorrelationID',
        'DateAndTime',
        'DestinationRoutingAddress',
        'Digits',
        'DpSpecificCriteria',
        'DpSpecificCriteriaAlt',
        'DpSpecificInfoAlt',
        'ElapsedTime',
        'ElapsedTimeRollOver',
        'EndUserAddress',
        'ErrorTreatment',
        'EventSpecificInformationBCSM',
        'EventSpecificInformationSMS',
        'EventTypeBCSM',
        'EventTypeSMS',
        'Extensions',
        'ExtensionField',
        'FCIBillingChargingCharacteristics',
        'FCIGPRSBillingChargingCharacteristics',
        'FCISMSBillingChargingCharacteristics',
        'ForwardServiceInteractionInd',
        'GapCriteria',
        'GapIndicators',
        'GapOnService',
        'GapTreatment',
        'GenericNumber',
        'GenericNumbers',
        'GPRS-QoS',
        'GPRS-QoS-Extension',
        'GPRSCause',
        'GPRSEvent',
        'GPRSEventSpecificInformation',
        'GPRSEventType',
        'InbandInfo',
        'InformationToSend',
        'InitiatingEntity',
        'InitiatorOfServiceChange',
        'InvokeID',
        'IPRoutingAddress',
        'IPSSPCapabilities',
        'LegOrCallSegment',
        'LegType',
        'LocationInformationGPRS',
        'LocationNumber',
        'LowLayerCompatibility',
        'MessageID',
        'MetDPCriteriaList',
        'MetDPCriterion',
        'MetDPCriterionAlt',
        'MidCallControlInfo',
        'MonitorMode',
        'MO-SMSCause',
        'MT-SMSCause',
        'NAOliInfo',
        'NatureOfServiceChange',
        'NumberOfDigits',
        'OCSIApplicable',
        'OriginalCalledPartyID',
        'PDPID',
        'PDPInitiationType',
        'QualityOfService',
        'ReceivingSideID',
        'RedirectingPartyID',
        'RequestedInformationList',
        'RequestedInformationTypeList',
        'RequestedInformation',
        'RequestedInformationType',
        'RequestedInformationValue',
        'RPCause',
        'ScfID',
        'SCIBillingChargingCharacteristics',
        'SCIGPRSBillingChargingCharacteristics',
        'SendingSideID',
        'ServiceInteractionIndicatorsTwo',
        'SGSNCapabilities',
        'SMS-AddressString',
        'SMSEvent',
        'TariffSwitchInterval',
        'TimeAndTimezone',
        'TimeIfNoTariffSwitch',
        'TimeIfTariffSwitch',
        'TimeInformation',
        'TimerID',
        'TimerValue',
        'Tone',
        'TPDataCodingScheme',
        'TPProtocolIdentifier',
        'TPShortMessageSpecificInfo',
        'TPValidityPeriod',
        'TransferredVolume',
        'TransferredVolumeRollOver',
        'UnavailableNetworkResource',
        'VariablePart',
        ]
    _set_ = [
        ]
    _val_ = [
        'leg1',
        'leg2',
        'maxSMS-AddressStringLength',
        'numOfInfoItems',
        ]
    _class_ = [
        ]
    _param_ = [
        'AccessPointName',
        'AChBillingChargingCharacteristics',
        'AChChargingAddress',
        'AdditionalCallingPartyNumber',
        'AssistingSSPIPRoutingAddress',
        'BasicGapCriteria',
        'BCSMEvent',
        'BCSM-Failure',
        'BearerCapability',
        'CalledPartyBCDNumber',
        'CalledPartyNumber',
        'CallingPartyNumber',
        'CallResult',
        'CallSegmentFailure',
        'CallSegmentID',
        'CallSegmentToCancel',
        'CAMEL-AChBillingChargingCharacteristics',
        'CAMEL-CallResult',
        'CAMEL-FCIBillingChargingCharacteristics',
        'CAMEL-FCIGPRSBillingChargingCharacteristics',
        'CAMEL-FCISMSBillingChargingCharacteristics',
        'Carrier',
        'Cause',
        'ChangeOfPositionControlInfo',
        'ChangeOfLocation',
        'ChangeOfLocationAlt',
        'ChargeNumber',
        'CompoundCriteria',
        'CorrelationID',
        'DestinationRoutingAddress',
        'Digits',
        'DpSpecificCriteria',
        'DpSpecificCriteriaAlt',
        'DpSpecificInfoAlt',
        'EndUserAddress',
        'EventSpecificInformationBCSM',
        'Extensions',
        'FCIBillingChargingCharacteristics',
        'FCIGPRSBillingChargingCharacteristics',
        'FCISMSBillingChargingCharacteristics',
        'GapCriteria',
        'GapTreatment',
        'GenericNumber',
        'GenericNumbers',
        'GPRSCause',
        'GPRSEventSpecificInformation',
        'InbandInfo',
        'InformationToSend',
        'IPRoutingAddress',
        'IPSSPCapabilities',
        'LegOrCallSegment',
        'LocationNumber',
        'LowLayerCompatibility',
        'MessageID',
        'MetDPCriteriaList',
        'MetDPCriterion',
        'MetDPCriterionAlt',
        'OriginalCalledPartyID',
        'RedirectingPartyID',
        'RequestedInformationList',
        'RequestedInformation',
        'RequestedInformationValue',
        'ScfID',
        'SCIBillingChargingCharacteristics',
        'SCIGPRSBillingChargingCharacteristics',
        'TimeAndTimezone',
        'VariablePart',
        ]
    
    #-----< AccessPointName >-----#
    AccessPointName = OCT_STR(name='AccessPointName', mode=MODE_TYPE, param=True)
    
    #-----< AChBillingChargingCharacteristics >-----#
    AChBillingChargingCharacteristics = OCT_STR(name='AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< AChChargingAddress >-----#
    AChChargingAddress = CHOICE(name='AChChargingAddress', mode=MODE_TYPE, param=True)
    
    #-----< AdditionalCallingPartyNumber >-----#
    AdditionalCallingPartyNumber = OCT_STR(name='AdditionalCallingPartyNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name='AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< AOCBeforeAnswer >-----#
    AOCBeforeAnswer = SEQ(name='AOCBeforeAnswer', mode=MODE_TYPE)
    _AOCBeforeAnswer_aOCInitial = SEQ(name='aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCBeforeAnswer_aOCSubsequent = SEQ(name='aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCBeforeAnswer._cont = ASN1Dict([
        ('aOCInitial', _AOCBeforeAnswer_aOCInitial),
        ('aOCSubsequent', _AOCBeforeAnswer_aOCSubsequent),
        ])
    AOCBeforeAnswer._ext = None
    
    #-----< AOCGPRS >-----#
    AOCGPRS = SEQ(name='AOCGPRS', mode=MODE_TYPE)
    _AOCGPRS_aOCInitial = SEQ(name='aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCGPRS_aOCSubsequent = SEQ(name='aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCGPRS._cont = ASN1Dict([
        ('aOCInitial', _AOCGPRS_aOCInitial),
        ('aOCSubsequent', _AOCGPRS_aOCSubsequent),
        ])
    AOCGPRS._ext = None
    
    #-----< AOCSubsequent >-----#
    AOCSubsequent = SEQ(name='AOCSubsequent', mode=MODE_TYPE)
    _AOCSubsequent_cAI_GSM0224 = SEQ(name='cAI-GSM0224', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCSubsequent_tariffSwitchInterval = INT(name='tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AOCSubsequent_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    AOCSubsequent._cont = ASN1Dict([
        ('cAI-GSM0224', _AOCSubsequent_cAI_GSM0224),
        ('tariffSwitchInterval', _AOCSubsequent_tariffSwitchInterval),
        ])
    AOCSubsequent._ext = None
    
    #-----< AppendFreeFormatData >-----#
    AppendFreeFormatData = ENUM(name='AppendFreeFormatData', mode=MODE_TYPE)
    AppendFreeFormatData._cont = ASN1Dict([('overwrite', 0), ('append', 1)])
    AppendFreeFormatData._ext = None
    
    #-----< ApplicationTimer >-----#
    ApplicationTimer = INT(name='ApplicationTimer', mode=MODE_TYPE)
    ApplicationTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< AssistingSSPIPRoutingAddress >-----#
    AssistingSSPIPRoutingAddress = OCT_STR(name='AssistingSSPIPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AudibleIndicator >-----#
    AudibleIndicator = CHOICE(name='AudibleIndicator', mode=MODE_TYPE)
    _AudibleIndicator_tone = BOOL(name='tone', mode=MODE_TYPE)
    _AudibleIndicator_burstList = SEQ(name='burstList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BurstList')))
    AudibleIndicator._cont = ASN1Dict([
        ('tone', _AudibleIndicator_tone),
        ('burstList', _AudibleIndicator_burstList),
        ])
    AudibleIndicator._ext = None
    
    #-----< BackwardServiceInteractionInd >-----#
    BackwardServiceInteractionInd = SEQ(name='BackwardServiceInteractionInd', mode=MODE_TYPE)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name='conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator = OCT_STR(name='callCompletionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    BackwardServiceInteractionInd._cont = ASN1Dict([
        ('conferenceTreatmentIndicator', _BackwardServiceInteractionInd_conferenceTreatmentIndicator),
        ('callCompletionTreatmentIndicator', _BackwardServiceInteractionInd_callCompletionTreatmentIndicator),
        ])
    BackwardServiceInteractionInd._ext = []
    
    #-----< BasicGapCriteria >-----#
    BasicGapCriteria = CHOICE(name='BasicGapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< BCSMEvent >-----#
    BCSMEvent = SEQ(name='BCSMEvent', mode=MODE_TYPE, param=True)
    
    #-----< BCSM-Failure >-----#
    BCSM_Failure = SEQ(name='BCSM-Failure', mode=MODE_TYPE, param=True)
    
    #-----< BearerCapability >-----#
    BearerCapability = CHOICE(name='BearerCapability', mode=MODE_TYPE, param=True)
    
    #-----< Burst >-----#
    Burst = SEQ(name='Burst', mode=MODE_TYPE)
    _Burst_numberOfBursts = INT(name='numberOfBursts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _Burst_numberOfBursts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_burstInterval = INT(name='burstInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_burstInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _Burst_numberOfTonesInBurst = INT(name='numberOfTonesInBurst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=3)
    _Burst_numberOfTonesInBurst._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_toneDuration = INT(name='toneDuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _Burst_toneInterval = INT(name='toneInterval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    Burst._cont = ASN1Dict([
        ('numberOfBursts', _Burst_numberOfBursts),
        ('burstInterval', _Burst_burstInterval),
        ('numberOfTonesInBurst', _Burst_numberOfTonesInBurst),
        ('toneDuration', _Burst_toneDuration),
        ('toneInterval', _Burst_toneInterval),
        ])
    Burst._ext = []
    
    #-----< BurstList >-----#
    BurstList = SEQ(name='BurstList', mode=MODE_TYPE)
    _BurstList_warningPeriod = INT(name='warningPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _BurstList_warningPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _BurstList_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    BurstList._cont = ASN1Dict([
        ('warningPeriod', _BurstList_warningPeriod),
        ('bursts', _BurstList_bursts),
        ])
    BurstList._ext = []
    
    #-----< CAI-GSM0224 >-----#
    CAI_GSM0224 = SEQ(name='CAI-GSM0224', mode=MODE_TYPE)
    _CAI_GSM0224_e1 = INT(name='e1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e2 = INT(name='e2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e3 = INT(name='e3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e4 = INT(name='e4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e5 = INT(name='e5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e6 = INT(name='e6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e6._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e7 = INT(name='e7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    CAI_GSM0224._cont = ASN1Dict([
        ('e1', _CAI_GSM0224_e1),
        ('e2', _CAI_GSM0224_e2),
        ('e3', _CAI_GSM0224_e3),
        ('e4', _CAI_GSM0224_e4),
        ('e5', _CAI_GSM0224_e5),
        ('e6', _CAI_GSM0224_e6),
        ('e7', _CAI_GSM0224_e7),
        ])
    CAI_GSM0224._ext = None
    
    #-----< CalledPartyBCDNumber >-----#
    CalledPartyBCDNumber = OCT_STR(name='CalledPartyBCDNumber', mode=MODE_TYPE, param=True)
    
    #-----< CalledPartyNumber >-----#
    CalledPartyNumber = OCT_STR(name='CalledPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallingPartyNumber >-----#
    CallingPartyNumber = OCT_STR(name='CallingPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallResult >-----#
    CallResult = OCT_STR(name='CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentFailure >-----#
    CallSegmentFailure = SEQ(name='CallSegmentFailure', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentID >-----#
    CallSegmentID = INT(name='CallSegmentID', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentToCancel >-----#
    CallSegmentToCancel = SEQ(name='CallSegmentToCancel', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-AChBillingChargingCharacteristics >-----#
    CAMEL_AChBillingChargingCharacteristics = CHOICE(name='CAMEL-AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-CallResult >-----#
    CAMEL_CallResult = CHOICE(name='CAMEL-CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIBillingChargingCharacteristics >-----#
    CAMEL_FCIBillingChargingCharacteristics = CHOICE(name='CAMEL-FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_FCIGPRSBillingChargingCharacteristics = SEQ(name='CAMEL-FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCISMSBillingChargingCharacteristics >-----#
    CAMEL_FCISMSBillingChargingCharacteristics = CHOICE(name='CAMEL-FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-SCIBillingChargingCharacteristics >-----#
    CAMEL_SCIBillingChargingCharacteristics = CHOICE(name='CAMEL-SCIBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer = SEQ(name='aOCBeforeAnswer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCBeforeAnswer')))
    _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer = SEQ(name='aOCAfterAnswer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')))
    _CAMEL_SCIBillingChargingCharacteristics_aOC_extension = SEQ(name='aOC-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAMEL-SCIBillingChargingCharacteristicsAlt')))
    CAMEL_SCIBillingChargingCharacteristics._cont = ASN1Dict([
        ('aOCBeforeAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer),
        ('aOCAfterAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer),
        ('aOC-extension', _CAMEL_SCIBillingChargingCharacteristics_aOC_extension),
        ])
    CAMEL_SCIBillingChargingCharacteristics._ext = None
    
    #-----< CAMEL-SCIBillingChargingCharacteristicsAlt >-----#
    CAMEL_SCIBillingChargingCharacteristicsAlt = SEQ(name='CAMEL-SCIBillingChargingCharacteristicsAlt', mode=MODE_TYPE)
    CAMEL_SCIBillingChargingCharacteristicsAlt._cont = ASN1Dict([
        ])
    CAMEL_SCIBillingChargingCharacteristicsAlt._ext = []
    
    #-----< CAMEL-SCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_SCIGPRSBillingChargingCharacteristics = SEQ(name='CAMEL-SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS = SEQ(name='aOCGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCGPRS')))
    _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CAMEL_SCIGPRSBillingChargingCharacteristics._cont = ASN1Dict([
        ('aOCGPRS', _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS),
        ('pDPID', _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID),
        ])
    CAMEL_SCIGPRSBillingChargingCharacteristics._ext = []
    
    #-----< Carrier >-----#
    Carrier = OCT_STR(name='Carrier', mode=MODE_TYPE, param=True)
    
    #-----< Cause >-----#
    Cause = OCT_STR(name='Cause', mode=MODE_TYPE, param=True)
    
    #-----< CGEncountered >-----#
    CGEncountered = ENUM(name='CGEncountered', mode=MODE_TYPE)
    CGEncountered._cont = ASN1Dict([('noCGencountered', 0), ('manualCGencountered', 1), ('scpOverload', 2)])
    CGEncountered._ext = None
    
    #-----< ChangeOfPositionControlInfo >-----#
    ChangeOfPositionControlInfo = SEQ_OF(name='ChangeOfPositionControlInfo', mode=MODE_TYPE, param=True)
    
    #-----< ChangeOfLocation >-----#
    ChangeOfLocation = CHOICE(name='ChangeOfLocation', mode=MODE_TYPE)
    _ChangeOfLocation_cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _ChangeOfLocation_inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _ChangeOfLocation_changeOfLocationAlt._cont = ASN1Dict([
        ])
    _ChangeOfLocation_changeOfLocationAlt._ext = []
    ChangeOfLocation._cont = ASN1Dict([
        ('cellGlobalId', _ChangeOfLocation_cellGlobalId),
        ('serviceAreaId', _ChangeOfLocation_serviceAreaId),
        ('locationAreaId', _ChangeOfLocation_locationAreaId),
        ('inter-SystemHandOver', _ChangeOfLocation_inter_SystemHandOver),
        ('inter-PLMNHandOver', _ChangeOfLocation_inter_PLMNHandOver),
        ('inter-MSCHandOver', _ChangeOfLocation_inter_MSCHandOver),
        ('changeOfLocationAlt', _ChangeOfLocation_changeOfLocationAlt),
        ])
    ChangeOfLocation._ext = None
    
    #-----< ChangeOfLocationAlt >-----#
    ChangeOfLocationAlt = SEQ(name='ChangeOfLocationAlt', mode=MODE_TYPE)
    ChangeOfLocationAlt._cont = ASN1Dict([
        ])
    ChangeOfLocationAlt._ext = []
    
    #-----< ChargeIndicator >-----#
    ChargeIndicator = OCT_STR(name='ChargeIndicator', mode=MODE_TYPE)
    ChargeIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargeNumber >-----#
    ChargeNumber = OCT_STR(name='ChargeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), param=True)
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = CHOICE(name='ChargingCharacteristics', mode=MODE_TYPE)
    _ChargingCharacteristics_maxTransferredVolume = INT(name='maxTransferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxTransferredVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _ChargingCharacteristics_maxElapsedTime = INT(name='maxElapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxElapsedTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    ChargingCharacteristics._cont = ASN1Dict([
        ('maxTransferredVolume', _ChargingCharacteristics_maxTransferredVolume),
        ('maxElapsedTime', _ChargingCharacteristics_maxElapsedTime),
        ])
    ChargingCharacteristics._ext = None
    
    #-----< ChargingResult >-----#
    ChargingResult = CHOICE(name='ChargingResult', mode=MODE_TYPE)
    _ChargingResult_transferredVolume = CHOICE(name='transferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolume')))
    _ChargingResult_elapsedTime = CHOICE(name='elapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTime')))
    ChargingResult._cont = ASN1Dict([
        ('transferredVolume', _ChargingResult_transferredVolume),
        ('elapsedTime', _ChargingResult_elapsedTime),
        ])
    ChargingResult._ext = None
    
    #-----< ChargingRollOver >-----#
    ChargingRollOver = CHOICE(name='ChargingRollOver', mode=MODE_TYPE)
    _ChargingRollOver_transferredVolumeRollOver = CHOICE(name='transferredVolumeRollOver', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolumeRollOver')))
    _ChargingRollOver_elapsedTimeRollOver = CHOICE(name='elapsedTimeRollOver', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTimeRollOver')))
    ChargingRollOver._cont = ASN1Dict([
        ('transferredVolumeRollOver', _ChargingRollOver_transferredVolumeRollOver),
        ('elapsedTimeRollOver', _ChargingRollOver_elapsedTimeRollOver),
        ])
    ChargingRollOver._ext = None
    
    #-----< CollectedDigits >-----#
    CollectedDigits = SEQ(name='CollectedDigits', mode=MODE_TYPE)
    _CollectedDigits_minimumNbOfDigits = INT(name='minimumNbOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _CollectedDigits_minimumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_maximumNbOfDigits = INT(name='maximumNbOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CollectedDigits_maximumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_endOfReplyDigit = OCT_STR(name='endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_cancelDigit = OCT_STR(name='cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_startDigit = OCT_STR(name='startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_firstDigitTimeOut = INT(name='firstDigitTimeOut', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_firstDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_interDigitTimeOut = INT(name='interDigitTimeOut', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_interDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_errorTreatment = ENUM(name='errorTreatment', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ErrorTreatment')), default='stdErrorAndInfo')
    _CollectedDigits_interruptableAnnInd = BOOL(name='interruptableAnnInd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _CollectedDigits_voiceInformation = BOOL(name='voiceInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _CollectedDigits_voiceBack = BOOL(name='voiceBack', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    CollectedDigits._cont = ASN1Dict([
        ('minimumNbOfDigits', _CollectedDigits_minimumNbOfDigits),
        ('maximumNbOfDigits', _CollectedDigits_maximumNbOfDigits),
        ('endOfReplyDigit', _CollectedDigits_endOfReplyDigit),
        ('cancelDigit', _CollectedDigits_cancelDigit),
        ('startDigit', _CollectedDigits_startDigit),
        ('firstDigitTimeOut', _CollectedDigits_firstDigitTimeOut),
        ('interDigitTimeOut', _CollectedDigits_interDigitTimeOut),
        ('errorTreatment', _CollectedDigits_errorTreatment),
        ('interruptableAnnInd', _CollectedDigits_interruptableAnnInd),
        ('voiceInformation', _CollectedDigits_voiceInformation),
        ('voiceBack', _CollectedDigits_voiceBack),
        ])
    CollectedDigits._ext = None
    
    #-----< CollectedInfo >-----#
    CollectedInfo = CHOICE(name='CollectedInfo', mode=MODE_TYPE)
    _CollectedInfo_collectedDigits = SEQ(name='collectedDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedDigits')))
    CollectedInfo._cont = ASN1Dict([
        ('collectedDigits', _CollectedInfo_collectedDigits),
        ])
    CollectedInfo._ext = None
    
    #-----< ConnectedNumberTreatmentInd >-----#
    ConnectedNumberTreatmentInd = ENUM(name='ConnectedNumberTreatmentInd', mode=MODE_TYPE)
    ConnectedNumberTreatmentInd._cont = ASN1Dict([('noINImpact', 0), ('presentationRestricted', 1), ('presentCalledINNumber', 2), ('presentCallINNumberRestricted', 3)])
    ConnectedNumberTreatmentInd._ext = None
    
    #-----< ControlType >-----#
    ControlType = ENUM(name='ControlType', mode=MODE_TYPE)
    ControlType._cont = ASN1Dict([('sCPOverloaded', 0), ('manuallyInitiated', 1)])
    ControlType._ext = None
    
    #-----< CompoundCriteria >-----#
    CompoundCriteria = SEQ(name='CompoundCriteria', mode=MODE_TYPE, param=True)
    
    #-----< CorrelationID >-----#
    CorrelationID = OCT_STR(name='CorrelationID', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< DateAndTime >-----#
    DateAndTime = OCT_STR(name='DateAndTime', mode=MODE_TYPE)
    DateAndTime._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< DestinationRoutingAddress >-----#
    DestinationRoutingAddress = SEQ_OF(name='DestinationRoutingAddress', mode=MODE_TYPE, param=True)
    
    #-----< Digits >-----#
    Digits = OCT_STR(name='Digits', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteria >-----#
    DpSpecificCriteria = CHOICE(name='DpSpecificCriteria', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteriaAlt >-----#
    DpSpecificCriteriaAlt = SEQ(name='DpSpecificCriteriaAlt', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificInfoAlt >-----#
    DpSpecificInfoAlt = SEQ(name='DpSpecificInfoAlt', mode=MODE_TYPE, param=True)
    
    #-----< ElapsedTime >-----#
    ElapsedTime = CHOICE(name='ElapsedTime', mode=MODE_TYPE)
    _ElapsedTime_timeGPRSIfNoTariffSwitch = INT(name='timeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTime_timeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch = SEQ(name='timeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch = INT(name='timeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval = INT(name='timeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch._cont = ASN1Dict([
        ('timeGPRSSinceLastTariffSwitch', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch),
        ('timeGPRSTariffSwitchInterval', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval),
        ])
    _ElapsedTime_timeGPRSIfTariffSwitch._ext = None
    ElapsedTime._cont = ASN1Dict([
        ('timeGPRSIfNoTariffSwitch', _ElapsedTime_timeGPRSIfNoTariffSwitch),
        ('timeGPRSIfTariffSwitch', _ElapsedTime_timeGPRSIfTariffSwitch),
        ])
    ElapsedTime._ext = None
    
    #-----< ElapsedTimeRollOver >-----#
    ElapsedTimeRollOver = CHOICE(name='ElapsedTimeRollOver', mode=MODE_TYPE)
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch = INT(name='rO-TimeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch = SEQ(name='rO-TimeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch = INT(name='rO-TimeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval = INT(name='rO-TimeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._cont = ASN1Dict([
        ('rO-TimeGPRSSinceLastTariffSwitch', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch),
        ('rO-TimeGPRSTariffSwitchInterval', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval),
        ])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._ext = None
    ElapsedTimeRollOver._cont = ASN1Dict([
        ('rO-TimeGPRSIfNoTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch),
        ('rO-TimeGPRSIfTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch),
        ])
    ElapsedTimeRollOver._ext = None
    
    #-----< EndUserAddress >-----#
    EndUserAddress = SEQ(name='EndUserAddress', mode=MODE_TYPE, param=True)
    
    #-----< ErrorTreatment >-----#
    ErrorTreatment = ENUM(name='ErrorTreatment', mode=MODE_TYPE)
    ErrorTreatment._cont = ASN1Dict([('stdErrorAndInfo', 0), ('help', 1), ('repeatPrompt', 2)])
    ErrorTreatment._ext = None
    
    #-----< EventSpecificInformationBCSM >-----#
    EventSpecificInformationBCSM = CHOICE(name='EventSpecificInformationBCSM', mode=MODE_TYPE, param=True)
    
    #-----< EventSpecificInformationSMS >-----#
    EventSpecificInformationSMS = CHOICE(name='EventSpecificInformationSMS', mode=MODE_TYPE)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo = SEQ(name='o-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause = ENUM(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MO-SMSCause')), opt=True)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo = SEQ(name='o-smsSubmissionSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo = SEQ(name='t-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MT-SMSCause')), opt=True)
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo = SEQ(name='t-smsDeliverySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._ext = []
    EventSpecificInformationSMS._cont = ASN1Dict([
        ('o-smsFailureSpecificInfo', _EventSpecificInformationSMS_o_smsFailureSpecificInfo),
        ('o-smsSubmissionSpecificInfo', _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo),
        ('t-smsFailureSpecificInfo', _EventSpecificInformationSMS_t_smsFailureSpecificInfo),
        ('t-smsDeliverySpecificInfo', _EventSpecificInformationSMS_t_smsDeliverySpecificInfo),
        ])
    EventSpecificInformationSMS._ext = None
    
    #-----< EventTypeBCSM >-----#
    EventTypeBCSM = ENUM(name='EventTypeBCSM', mode=MODE_TYPE)
    EventTypeBCSM._cont = ASN1Dict([('collectedInfo', 2), ('analyzedInformation', 3), ('routeSelectFailure', 4), ('oCalledPartyBusy', 5), ('oNoAnswer', 6), ('oAnswer', 7), ('oMidCall', 8), ('oDisconnect', 9), ('oAbandon', 10), ('termAttemptAuthorized', 12), ('tBusy', 13), ('tNoAnswer', 14), ('tAnswer', 15), ('tMidCall', 16), ('tDisconnect', 17), ('tAbandon', 18), ('oTermSeized', 19), ('callAccepted', 27), ('oChangeOfPosition', 50), ('tChangeOfPosition', 51), ('oServiceChange', 52), ('tServiceChange', 53)])
    EventTypeBCSM._ext = ['oServiceChange', 'tServiceChange']
    
    #-----< EventTypeSMS >-----#
    EventTypeSMS = ENUM(name='EventTypeSMS', mode=MODE_TYPE)
    EventTypeSMS._cont = ASN1Dict([('sms-CollectedInfo', 1), ('o-smsFailure', 2), ('o-smsSubmission', 3), ('sms-DeliveryRequested', 11), ('t-smsFailure', 12), ('t-smsDelivery', 13)])
    EventTypeSMS._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name='Extensions', mode=MODE_TYPE, param=True)
    
    #-----< ExtensionField >-----#
    ExtensionField = SEQ(name='ExtensionField', mode=MODE_TYPE)
    _ExtensionField_type = CHOICE(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), ['id']))
    __ExtensionField_type_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    ___ExtensionField_type_tab_val_ExtensionType_0 = NULL(name='ExtensionType', mode=MODE_TYPE)
    __ExtensionField_type_tab._val = ASN1Set(rv=[dict([('ExtensionType', ___ExtensionField_type_tab_val_ExtensionType_0), ('criticality', 'ignore'), ('id', ('global', (0, 4, 0, 1, 2)))])], rr=[], ev=None, er=[])
    _ExtensionField_type._const_tab = __ExtensionField_type_tab
    _ExtensionField_type._const_tab_at = None
    _ExtensionField_type._const_tab_id = 'id'
    _ExtensionField_criticality = ENUM(name='criticality', mode=MODE_TYPE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default='ignore')
    _ExtensionField_value = OPEN(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), ['ExtensionType']))
    _ExtensionField_value._const_tab = __ExtensionField_type_tab
    _ExtensionField_value._const_tab_at = ('..', 'type')
    _ExtensionField_value._const_tab_id = 'ExtensionType'
    ExtensionField._cont = ASN1Dict([
        ('type', _ExtensionField_type),
        ('criticality', _ExtensionField_criticality),
        ('value', _ExtensionField_value),
        ])
    ExtensionField._ext = []
    
    #-----< FCIBillingChargingCharacteristics >-----#
    FCIBillingChargingCharacteristics = OCT_STR(name='FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCIGPRSBillingChargingCharacteristics >-----#
    FCIGPRSBillingChargingCharacteristics = OCT_STR(name='FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCISMSBillingChargingCharacteristics >-----#
    FCISMSBillingChargingCharacteristics = OCT_STR(name='FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< ForwardServiceInteractionInd >-----#
    ForwardServiceInteractionInd = SEQ(name='ForwardServiceInteractionInd', mode=MODE_TYPE)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name='conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator = OCT_STR(name='callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator = OCT_STR(name='callingPartyRestrictionIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ForwardServiceInteractionInd._cont = ASN1Dict([
        ('conferenceTreatmentIndicator', _ForwardServiceInteractionInd_conferenceTreatmentIndicator),
        ('callDiversionTreatmentIndicator', _ForwardServiceInteractionInd_callDiversionTreatmentIndicator),
        ('callingPartyRestrictionIndicator', _ForwardServiceInteractionInd_callingPartyRestrictionIndicator),
        ])
    ForwardServiceInteractionInd._ext = []
    
    #-----< GapCriteria >-----#
    GapCriteria = CHOICE(name='GapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< GapIndicators >-----#
    GapIndicators = SEQ(name='GapIndicators', mode=MODE_TYPE)
    _GapIndicators_duration = INT(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Duration')))
    _GapIndicators_gapInterval = INT(name='gapInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Interval')))
    GapIndicators._cont = ASN1Dict([
        ('duration', _GapIndicators_duration),
        ('gapInterval', _GapIndicators_gapInterval),
        ])
    GapIndicators._ext = []
    
    #-----< GapOnService >-----#
    GapOnService = SEQ(name='GapOnService', mode=MODE_TYPE)
    _GapOnService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    GapOnService._cont = ASN1Dict([
        ('serviceKey', _GapOnService_serviceKey),
        ])
    GapOnService._ext = []
    
    #-----< GapTreatment >-----#
    GapTreatment = CHOICE(name='GapTreatment', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumber >-----#
    GenericNumber = OCT_STR(name='GenericNumber', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumbers >-----#
    GenericNumbers = SET_OF(name='GenericNumbers', mode=MODE_TYPE, param=True)
    
    #-----< GPRS-QoS >-----#
    GPRS_QoS = CHOICE(name='GPRS-QoS', mode=MODE_TYPE)
    _GPRS_QoS_short_QoS_format = OCT_STR(name='short-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _GPRS_QoS_long_QoS_format = OCT_STR(name='long-QoS-format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')))
    GPRS_QoS._cont = ASN1Dict([
        ('short-QoS-format', _GPRS_QoS_short_QoS_format),
        ('long-QoS-format', _GPRS_QoS_long_QoS_format),
        ])
    GPRS_QoS._ext = None
    
    #-----< GPRS-QoS-Extension >-----#
    GPRS_QoS_Extension = SEQ(name='GPRS-QoS-Extension', mode=MODE_TYPE)
    _GPRS_QoS_Extension_supplement_to_long_QoS_format = OCT_STR(name='supplement-to-long-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')))
    _GPRS_QoS_Extension_additionalSupplement = OCT_STR(name='additionalSupplement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    GPRS_QoS_Extension._cont = ASN1Dict([
        ('supplement-to-long-QoS-format', _GPRS_QoS_Extension_supplement_to_long_QoS_format),
        ('additionalSupplement', _GPRS_QoS_Extension_additionalSupplement),
        ])
    GPRS_QoS_Extension._ext = ['additionalSupplement']
    
    #-----< GPRSCause >-----#
    GPRSCause = OCT_STR(name='GPRSCause', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEvent >-----#
    GPRSEvent = SEQ(name='GPRSEvent', mode=MODE_TYPE)
    _GPRSEvent_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _GPRSEvent_monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    GPRSEvent._cont = ASN1Dict([
        ('gPRSEventType', _GPRSEvent_gPRSEventType),
        ('monitorMode', _GPRSEvent_monitorMode),
        ])
    GPRSEvent._ext = None
    
    #-----< GPRSEventSpecificInformation >-----#
    GPRSEventSpecificInformation = CHOICE(name='GPRSEventSpecificInformation', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEventType >-----#
    GPRSEventType = ENUM(name='GPRSEventType', mode=MODE_TYPE)
    GPRSEventType._cont = ASN1Dict([('attach', 1), ('attachChangeOfPosition', 2), ('detached', 3), ('pdp-ContextEstablishment', 11), ('pdp-ContextEstablishmentAcknowledgement', 12), ('disonnect', 13), ('pdp-ContextChangeOfPosition', 14)])
    GPRSEventType._ext = None
    
    #-----< InbandInfo >-----#
    InbandInfo = SEQ(name='InbandInfo', mode=MODE_TYPE, param=True)
    
    #-----< InformationToSend >-----#
    InformationToSend = CHOICE(name='InformationToSend', mode=MODE_TYPE, param=True)
    
    #-----< InitiatingEntity >-----#
    InitiatingEntity = ENUM(name='InitiatingEntity', mode=MODE_TYPE)
    InitiatingEntity._cont = ASN1Dict([('mobileStation', 0), ('sgsn', 1), ('hlr', 2), ('ggsn', 3)])
    InitiatingEntity._ext = None
    
    #-----< InitiatorOfServiceChange >-----#
    InitiatorOfServiceChange = ENUM(name='InitiatorOfServiceChange', mode=MODE_TYPE)
    InitiatorOfServiceChange._cont = ASN1Dict([('a-side', 0), ('b-side', 1)])
    InitiatorOfServiceChange._ext = None
    
    #-----< InvokeID >-----#
    InvokeID = INT(name='InvokeID', mode=MODE_TYPE)
    InvokeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< IPRoutingAddress >-----#
    IPRoutingAddress = OCT_STR(name='IPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), param=True)
    
    #-----< IPSSPCapabilities >-----#
    IPSSPCapabilities = OCT_STR(name='IPSSPCapabilities', mode=MODE_TYPE, param=True)
    
    #-----< LegOrCallSegment >-----#
    LegOrCallSegment = CHOICE(name='LegOrCallSegment', mode=MODE_TYPE, param=True)
    
    #-----< LegType >-----#
    LegType = OCT_STR(name='LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< leg1 >-----#
    leg1 = OCT_STR(name='leg1', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg1._val = b'\x01'
    
    #-----< leg2 >-----#
    leg2 = OCT_STR(name='leg2', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg2._val = b'\x02'
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name='LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = OCT_STR(name='cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name='selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        ('cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        ('routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        ('geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        ('sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        ('selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        ('extensionContainer', _LocationInformationGPRS_extensionContainer),
        ('sai-Present', _LocationInformationGPRS_sai_Present),
        ('userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = ['sai-Present', 'userCSGInformation']
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name='LocationNumber', mode=MODE_TYPE, param=True)
    
    #-----< LowLayerCompatibility >-----#
    LowLayerCompatibility = OCT_STR(name='LowLayerCompatibility', mode=MODE_TYPE, param=True)
    
    #-----< MessageID >-----#
    MessageID = CHOICE(name='MessageID', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriteriaList >-----#
    MetDPCriteriaList = SEQ_OF(name='MetDPCriteriaList', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriterion >-----#
    MetDPCriterion = CHOICE(name='MetDPCriterion', mode=MODE_TYPE)
    _MetDPCriterion_enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _MetDPCriterion_metDPCriterionAlt._cont = ASN1Dict([
        ])
    _MetDPCriterion_metDPCriterionAlt._ext = []
    MetDPCriterion._cont = ASN1Dict([
        ('enteringCellGlobalId', _MetDPCriterion_enteringCellGlobalId),
        ('leavingCellGlobalId', _MetDPCriterion_leavingCellGlobalId),
        ('enteringServiceAreaId', _MetDPCriterion_enteringServiceAreaId),
        ('leavingServiceAreaId', _MetDPCriterion_leavingServiceAreaId),
        ('enteringLocationAreaId', _MetDPCriterion_enteringLocationAreaId),
        ('leavingLocationAreaId', _MetDPCriterion_leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _MetDPCriterion_inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _MetDPCriterion_inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _MetDPCriterion_inter_PLMNHandOver),
        ('inter-MSCHandOver', _MetDPCriterion_inter_MSCHandOver),
        ('metDPCriterionAlt', _MetDPCriterion_metDPCriterionAlt),
        ])
    MetDPCriterion._ext = None
    
    #-----< MetDPCriterionAlt >-----#
    MetDPCriterionAlt = SEQ(name='MetDPCriterionAlt', mode=MODE_TYPE)
    MetDPCriterionAlt._cont = ASN1Dict([
        ])
    MetDPCriterionAlt._ext = []
    
    #-----< MidCallControlInfo >-----#
    MidCallControlInfo = SEQ(name='MidCallControlInfo', mode=MODE_TYPE)
    _MidCallControlInfo_minimumNumberOfDigits = INT(name='minimumNumberOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _MidCallControlInfo_minimumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_maximumNumberOfDigits = INT(name='maximumNumberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _MidCallControlInfo_maximumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_endOfReplyDigit = OCT_STR(name='endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_cancelDigit = OCT_STR(name='cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_startDigit = OCT_STR(name='startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=10)
    _MidCallControlInfo_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    MidCallControlInfo._cont = ASN1Dict([
        ('minimumNumberOfDigits', _MidCallControlInfo_minimumNumberOfDigits),
        ('maximumNumberOfDigits', _MidCallControlInfo_maximumNumberOfDigits),
        ('endOfReplyDigit', _MidCallControlInfo_endOfReplyDigit),
        ('cancelDigit', _MidCallControlInfo_cancelDigit),
        ('startDigit', _MidCallControlInfo_startDigit),
        ('interDigitTimeout', _MidCallControlInfo_interDigitTimeout),
        ])
    MidCallControlInfo._ext = []
    
    #-----< MonitorMode >-----#
    MonitorMode = ENUM(name='MonitorMode', mode=MODE_TYPE)
    MonitorMode._cont = ASN1Dict([('interrupted', 0), ('notifyAndContinue', 1), ('transparent', 2)])
    MonitorMode._ext = None
    
    #-----< MO-SMSCause >-----#
    MO_SMSCause = ENUM(name='MO-SMSCause', mode=MODE_TYPE)
    MO_SMSCause._cont = ASN1Dict([('systemFailure', 0), ('unexpectedDataValue', 1), ('facilityNotSupported', 2), ('sM-DeliveryFailure', 3), ('releaseFromRadioInterface', 4)])
    MO_SMSCause._ext = None
    
    #-----< MT-SMSCause >-----#
    MT_SMSCause = OCT_STR(name='MT-SMSCause', mode=MODE_TYPE)
    MT_SMSCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NAOliInfo >-----#
    NAOliInfo = OCT_STR(name='NAOliInfo', mode=MODE_TYPE)
    NAOliInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NatureOfServiceChange >-----#
    NatureOfServiceChange = ENUM(name='NatureOfServiceChange', mode=MODE_TYPE)
    NatureOfServiceChange._cont = ASN1Dict([('userInitiated', 0), ('networkInitiated', 1)])
    NatureOfServiceChange._ext = None
    
    #-----< NumberOfDigits >-----#
    NumberOfDigits = INT(name='NumberOfDigits', mode=MODE_TYPE)
    NumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< OCSIApplicable >-----#
    OCSIApplicable = NULL(name='OCSIApplicable', mode=MODE_TYPE)
    
    #-----< OriginalCalledPartyID >-----#
    OriginalCalledPartyID = OCT_STR(name='OriginalCalledPartyID', mode=MODE_TYPE, param=True)
    
    #-----< PDPID >-----#
    PDPID = OCT_STR(name='PDPID', mode=MODE_TYPE)
    PDPID._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PDPInitiationType >-----#
    PDPInitiationType = ENUM(name='PDPInitiationType', mode=MODE_TYPE)
    PDPInitiationType._cont = ASN1Dict([('mSInitiated', 0), ('networkInitiated', 1)])
    PDPInitiationType._ext = None
    
    #-----< QualityOfService >-----#
    QualityOfService = SEQ(name='QualityOfService', mode=MODE_TYPE)
    _QualityOfService_requested_QoS = CHOICE(name='requested-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_subscribed_QoS = CHOICE(name='subscribed-QoS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_negotiated_QoS = CHOICE(name='negotiated-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_requested_QoS_Extension = SEQ(name='requested-QoS-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_subscribed_QoS_Extension = SEQ(name='subscribed-QoS-Extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_negotiated_QoS_Extension = SEQ(name='negotiated-QoS-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    QualityOfService._cont = ASN1Dict([
        ('requested-QoS', _QualityOfService_requested_QoS),
        ('subscribed-QoS', _QualityOfService_subscribed_QoS),
        ('negotiated-QoS', _QualityOfService_negotiated_QoS),
        ('requested-QoS-Extension', _QualityOfService_requested_QoS_Extension),
        ('subscribed-QoS-Extension', _QualityOfService_subscribed_QoS_Extension),
        ('negotiated-QoS-Extension', _QualityOfService_negotiated_QoS_Extension),
        ])
    QualityOfService._ext = ['requested-QoS-Extension', 'subscribed-QoS-Extension', 'negotiated-QoS-Extension']
    
    #-----< ReceivingSideID >-----#
    ReceivingSideID = CHOICE(name='ReceivingSideID', mode=MODE_TYPE)
    _ReceivingSideID_receivingSideID = OCT_STR(name='receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    ReceivingSideID._cont = ASN1Dict([
        ('receivingSideID', _ReceivingSideID_receivingSideID),
        ])
    ReceivingSideID._ext = None
    
    #-----< RedirectingPartyID >-----#
    RedirectingPartyID = OCT_STR(name='RedirectingPartyID', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationList >-----#
    RequestedInformationList = SEQ_OF(name='RequestedInformationList', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationTypeList >-----#
    RequestedInformationTypeList = SEQ_OF(name='RequestedInformationTypeList', mode=MODE_TYPE)
    _RequestedInformationTypeList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    RequestedInformationTypeList._cont = _RequestedInformationTypeList__item_
    RequestedInformationTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< RequestedInformation >-----#
    RequestedInformation = SEQ(name='RequestedInformation', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationType >-----#
    RequestedInformationType = ENUM(name='RequestedInformationType', mode=MODE_TYPE)
    RequestedInformationType._cont = ASN1Dict([('callAttemptElapsedTime', 0), ('callStopTime', 1), ('callConnectedElapsedTime', 2), ('releaseCause', 30)])
    RequestedInformationType._ext = None
    
    #-----< RequestedInformationValue >-----#
    RequestedInformationValue = CHOICE(name='RequestedInformationValue', mode=MODE_TYPE, param=True)
    
    #-----< RPCause >-----#
    RPCause = OCT_STR(name='RPCause', mode=MODE_TYPE)
    RPCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ScfID >-----#
    ScfID = OCT_STR(name='ScfID', mode=MODE_TYPE, param=True)
    
    #-----< SCIBillingChargingCharacteristics >-----#
    SCIBillingChargingCharacteristics = OCT_STR(name='SCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SCIGPRSBillingChargingCharacteristics >-----#
    SCIGPRSBillingChargingCharacteristics = OCT_STR(name='SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SendingSideID >-----#
    SendingSideID = CHOICE(name='SendingSideID', mode=MODE_TYPE)
    _SendingSideID_sendingSideID = OCT_STR(name='sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    SendingSideID._cont = ASN1Dict([
        ('sendingSideID', _SendingSideID_sendingSideID),
        ])
    SendingSideID._ext = None
    
    #-----< ServiceInteractionIndicatorsTwo >-----#
    ServiceInteractionIndicatorsTwo = SEQ(name='ServiceInteractionIndicatorsTwo', mode=MODE_TYPE)
    _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd = SEQ(name='forwardServiceInteractionInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ForwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd = SEQ(name='backwardServiceInteractionInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BackwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd = ENUM(name='bothwayThroughConnectionInd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'BothwayThroughConnectionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd = ENUM(name='connectedNumberTreatmentInd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ConnectedNumberTreatmentInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_nonCUGCall = NULL(name='nonCUGCall', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator = OCT_STR(name='holdTreatmentIndicator', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator = OCT_STR(name='cwTreatmentIndicator', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator = OCT_STR(name='ectTreatmentIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ServiceInteractionIndicatorsTwo._cont = ASN1Dict([
        ('forwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd),
        ('backwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd),
        ('bothwayThroughConnectionInd', _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd),
        ('connectedNumberTreatmentInd', _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd),
        ('nonCUGCall', _ServiceInteractionIndicatorsTwo_nonCUGCall),
        ('holdTreatmentIndicator', _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator),
        ('cwTreatmentIndicator', _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator),
        ('ectTreatmentIndicator', _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator),
        ])
    ServiceInteractionIndicatorsTwo._ext = []
    
    #-----< SGSNCapabilities >-----#
    SGSNCapabilities = OCT_STR(name='SGSNCapabilities', mode=MODE_TYPE)
    SGSNCapabilities._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SMS-AddressString >-----#
    SMS_AddressString = OCT_STR(name='SMS-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SMS_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< maxSMS-AddressStringLength >-----#
    maxSMS_AddressStringLength = INT(name='maxSMS-AddressStringLength', mode=MODE_VALUE)
    maxSMS_AddressStringLength._val = 11
    
    #-----< SMSEvent >-----#
    SMSEvent = SEQ(name='SMSEvent', mode=MODE_TYPE)
    _SMSEvent_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _SMSEvent_monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    SMSEvent._cont = ASN1Dict([
        ('eventTypeSMS', _SMSEvent_eventTypeSMS),
        ('monitorMode', _SMSEvent_monitorMode),
        ])
    SMSEvent._ext = None
    
    #-----< TariffSwitchInterval >-----#
    TariffSwitchInterval = INT(name='TariffSwitchInterval', mode=MODE_TYPE)
    TariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    
    #-----< TimeAndTimezone >-----#
    TimeAndTimezone = OCT_STR(name='TimeAndTimezone', mode=MODE_TYPE, param=True)
    
    #-----< TimeIfNoTariffSwitch >-----#
    TimeIfNoTariffSwitch = INT(name='TimeIfNoTariffSwitch', mode=MODE_TYPE)
    TimeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    
    #-----< TimeIfTariffSwitch >-----#
    TimeIfTariffSwitch = SEQ(name='TimeIfTariffSwitch', mode=MODE_TYPE)
    _TimeIfTariffSwitch_timeSinceTariffSwitch = INT(name='timeSinceTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeIfTariffSwitch_timeSinceTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    _TimeIfTariffSwitch_tariffSwitchInterval = INT(name='tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TimeIfTariffSwitch_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=864000)], ev=None, er=[])
    TimeIfTariffSwitch._cont = ASN1Dict([
        ('timeSinceTariffSwitch', _TimeIfTariffSwitch_timeSinceTariffSwitch),
        ('tariffSwitchInterval', _TimeIfTariffSwitch_tariffSwitchInterval),
        ])
    TimeIfTariffSwitch._ext = None
    
    #-----< TimeInformation >-----#
    TimeInformation = CHOICE(name='TimeInformation', mode=MODE_TYPE)
    _TimeInformation_timeIfNoTariffSwitch = INT(name='timeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfNoTariffSwitch')))
    _TimeInformation_timeIfTariffSwitch = SEQ(name='timeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfTariffSwitch')))
    TimeInformation._cont = ASN1Dict([
        ('timeIfNoTariffSwitch', _TimeInformation_timeIfNoTariffSwitch),
        ('timeIfTariffSwitch', _TimeInformation_timeIfTariffSwitch),
        ])
    TimeInformation._ext = None
    
    #-----< TimerID >-----#
    TimerID = ENUM(name='TimerID', mode=MODE_TYPE)
    TimerID._cont = ASN1Dict([('tssf', 0)])
    TimerID._ext = None
    
    #-----< TimerValue >-----#
    TimerValue = INT(name='TimerValue', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< Tone >-----#
    Tone = SEQ(name='Tone', mode=MODE_TYPE)
    _Tone_toneID = INT(name='toneID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _Tone_duration = INT(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    Tone._cont = ASN1Dict([
        ('toneID', _Tone_toneID),
        ('duration', _Tone_duration),
        ])
    Tone._ext = []
    
    #-----< TPDataCodingScheme >-----#
    TPDataCodingScheme = OCT_STR(name='TPDataCodingScheme', mode=MODE_TYPE)
    TPDataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPProtocolIdentifier >-----#
    TPProtocolIdentifier = OCT_STR(name='TPProtocolIdentifier', mode=MODE_TYPE)
    TPProtocolIdentifier._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPShortMessageSpecificInfo >-----#
    TPShortMessageSpecificInfo = OCT_STR(name='TPShortMessageSpecificInfo', mode=MODE_TYPE)
    TPShortMessageSpecificInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPValidityPeriod >-----#
    TPValidityPeriod = OCT_STR(name='TPValidityPeriod', mode=MODE_TYPE)
    TPValidityPeriod._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TransferredVolume >-----#
    TransferredVolume = CHOICE(name='TransferredVolume', mode=MODE_TYPE)
    _TransferredVolume_volumeIfNoTariffSwitch = INT(name='volumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolume_volumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch = SEQ(name='volumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch = INT(name='volumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval = INT(name='volumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch._cont = ASN1Dict([
        ('volumeSinceLastTariffSwitch', __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch),
        ('volumeTariffSwitchInterval', __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval),
        ])
    _TransferredVolume_volumeIfTariffSwitch._ext = None
    TransferredVolume._cont = ASN1Dict([
        ('volumeIfNoTariffSwitch', _TransferredVolume_volumeIfNoTariffSwitch),
        ('volumeIfTariffSwitch', _TransferredVolume_volumeIfTariffSwitch),
        ])
    TransferredVolume._ext = None
    
    #-----< TransferredVolumeRollOver >-----#
    TransferredVolumeRollOver = CHOICE(name='TransferredVolumeRollOver', mode=MODE_TYPE)
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch = INT(name='rO-VolumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch = SEQ(name='rO-VolumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch = INT(name='rO-VolumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval = INT(name='rO-VolumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._cont = ASN1Dict([
        ('rO-VolumeSinceLastTariffSwitch', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch),
        ('rO-VolumeTariffSwitchInterval', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval),
        ])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._ext = None
    TransferredVolumeRollOver._cont = ASN1Dict([
        ('rO-VolumeIfNoTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch),
        ('rO-VolumeIfTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch),
        ])
    TransferredVolumeRollOver._ext = None
    
    #-----< UnavailableNetworkResource >-----#
    UnavailableNetworkResource = ENUM(name='UnavailableNetworkResource', mode=MODE_TYPE)
    UnavailableNetworkResource._cont = ASN1Dict([('unavailableResources', 0), ('componentFailure', 1), ('basicCallProcessingException', 2), ('resourceStatusFailure', 3), ('endUserFailure', 4)])
    UnavailableNetworkResource._ext = None
    
    #-----< VariablePart >-----#
    VariablePart = CHOICE(name='VariablePart', mode=MODE_TYPE, param=True)
    
    #-----< numOfInfoItems >-----#
    numOfInfoItems = INT(name='numOfInfoItems', mode=MODE_VALUE)
    numOfInfoItems._val = 4
    
    _all_ = [
        AlertingPattern,
        _AOCBeforeAnswer_aOCInitial,
        _AOCBeforeAnswer_aOCSubsequent,
        AOCBeforeAnswer,
        _AOCGPRS_aOCInitial,
        _AOCGPRS_aOCSubsequent,
        AOCGPRS,
        _AOCSubsequent_cAI_GSM0224,
        _AOCSubsequent_tariffSwitchInterval,
        AOCSubsequent,
        AppendFreeFormatData,
        ApplicationTimer,
        _AudibleIndicator_tone,
        _AudibleIndicator_burstList,
        AudibleIndicator,
        _BackwardServiceInteractionInd_conferenceTreatmentIndicator,
        _BackwardServiceInteractionInd_callCompletionTreatmentIndicator,
        BackwardServiceInteractionInd,
        _Burst_numberOfBursts,
        _Burst_burstInterval,
        _Burst_numberOfTonesInBurst,
        _Burst_toneDuration,
        _Burst_toneInterval,
        Burst,
        _BurstList_warningPeriod,
        _BurstList_bursts,
        BurstList,
        _CAI_GSM0224_e1,
        _CAI_GSM0224_e2,
        _CAI_GSM0224_e3,
        _CAI_GSM0224_e4,
        _CAI_GSM0224_e5,
        _CAI_GSM0224_e6,
        _CAI_GSM0224_e7,
        CAI_GSM0224,
        _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOC_extension,
        CAMEL_SCIBillingChargingCharacteristics,
        CAMEL_SCIBillingChargingCharacteristicsAlt,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID,
        CAMEL_SCIGPRSBillingChargingCharacteristics,
        CGEncountered,
        _ChangeOfLocation_cellGlobalId,
        _ChangeOfLocation_serviceAreaId,
        _ChangeOfLocation_locationAreaId,
        _ChangeOfLocation_inter_SystemHandOver,
        _ChangeOfLocation_inter_PLMNHandOver,
        _ChangeOfLocation_inter_MSCHandOver,
        _ChangeOfLocation_changeOfLocationAlt,
        ChangeOfLocation,
        ChangeOfLocationAlt,
        ChargeIndicator,
        _ChargingCharacteristics_maxTransferredVolume,
        _ChargingCharacteristics_maxElapsedTime,
        ChargingCharacteristics,
        _ChargingResult_transferredVolume,
        _ChargingResult_elapsedTime,
        ChargingResult,
        _ChargingRollOver_transferredVolumeRollOver,
        _ChargingRollOver_elapsedTimeRollOver,
        ChargingRollOver,
        _CollectedDigits_minimumNbOfDigits,
        _CollectedDigits_maximumNbOfDigits,
        _CollectedDigits_endOfReplyDigit,
        _CollectedDigits_cancelDigit,
        _CollectedDigits_startDigit,
        _CollectedDigits_firstDigitTimeOut,
        _CollectedDigits_interDigitTimeOut,
        _CollectedDigits_errorTreatment,
        _CollectedDigits_interruptableAnnInd,
        _CollectedDigits_voiceInformation,
        _CollectedDigits_voiceBack,
        CollectedDigits,
        _CollectedInfo_collectedDigits,
        CollectedInfo,
        ConnectedNumberTreatmentInd,
        ControlType,
        DateAndTime,
        _ElapsedTime_timeGPRSIfNoTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval,
        _ElapsedTime_timeGPRSIfTariffSwitch,
        ElapsedTime,
        _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval,
        _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch,
        ElapsedTimeRollOver,
        ErrorTreatment,
        __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_o_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo,
        __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_t_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_t_smsDeliverySpecificInfo,
        EventSpecificInformationSMS,
        EventTypeBCSM,
        EventTypeSMS,
        __ExtensionField_type_tab,
        ___ExtensionField_type_tab_val_ExtensionType_0,
        _ExtensionField_type,
        _ExtensionField_criticality,
        _ExtensionField_value,
        ExtensionField,
        _ForwardServiceInteractionInd_conferenceTreatmentIndicator,
        _ForwardServiceInteractionInd_callDiversionTreatmentIndicator,
        _ForwardServiceInteractionInd_callingPartyRestrictionIndicator,
        ForwardServiceInteractionInd,
        _GapIndicators_duration,
        _GapIndicators_gapInterval,
        GapIndicators,
        _GapOnService_serviceKey,
        GapOnService,
        _GPRS_QoS_short_QoS_format,
        _GPRS_QoS_long_QoS_format,
        GPRS_QoS,
        _GPRS_QoS_Extension_supplement_to_long_QoS_format,
        _GPRS_QoS_Extension_additionalSupplement,
        GPRS_QoS_Extension,
        _GPRSEvent_gPRSEventType,
        _GPRSEvent_monitorMode,
        GPRSEvent,
        GPRSEventType,
        InitiatingEntity,
        InitiatorOfServiceChange,
        InvokeID,
        LegType,
        leg1,
        leg2,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _MetDPCriterion_enteringCellGlobalId,
        _MetDPCriterion_leavingCellGlobalId,
        _MetDPCriterion_enteringServiceAreaId,
        _MetDPCriterion_leavingServiceAreaId,
        _MetDPCriterion_enteringLocationAreaId,
        _MetDPCriterion_leavingLocationAreaId,
        _MetDPCriterion_inter_SystemHandOverToUMTS,
        _MetDPCriterion_inter_SystemHandOverToGSM,
        _MetDPCriterion_inter_PLMNHandOver,
        _MetDPCriterion_inter_MSCHandOver,
        _MetDPCriterion_metDPCriterionAlt,
        MetDPCriterion,
        MetDPCriterionAlt,
        _MidCallControlInfo_minimumNumberOfDigits,
        _MidCallControlInfo_maximumNumberOfDigits,
        _MidCallControlInfo_endOfReplyDigit,
        _MidCallControlInfo_cancelDigit,
        _MidCallControlInfo_startDigit,
        _MidCallControlInfo_interDigitTimeout,
        MidCallControlInfo,
        MonitorMode,
        MO_SMSCause,
        MT_SMSCause,
        NAOliInfo,
        NatureOfServiceChange,
        NumberOfDigits,
        OCSIApplicable,
        PDPID,
        PDPInitiationType,
        _QualityOfService_requested_QoS,
        _QualityOfService_subscribed_QoS,
        _QualityOfService_negotiated_QoS,
        _QualityOfService_requested_QoS_Extension,
        _QualityOfService_subscribed_QoS_Extension,
        _QualityOfService_negotiated_QoS_Extension,
        QualityOfService,
        _ReceivingSideID_receivingSideID,
        ReceivingSideID,
        _RequestedInformationTypeList__item_,
        RequestedInformationTypeList,
        RequestedInformationType,
        RPCause,
        _SendingSideID_sendingSideID,
        SendingSideID,
        _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd,
        _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd,
        _ServiceInteractionIndicatorsTwo_nonCUGCall,
        _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator,
        ServiceInteractionIndicatorsTwo,
        SGSNCapabilities,
        SMS_AddressString,
        maxSMS_AddressStringLength,
        _SMSEvent_eventTypeSMS,
        _SMSEvent_monitorMode,
        SMSEvent,
        TariffSwitchInterval,
        TimeIfNoTariffSwitch,
        _TimeIfTariffSwitch_timeSinceTariffSwitch,
        _TimeIfTariffSwitch_tariffSwitchInterval,
        TimeIfTariffSwitch,
        _TimeInformation_timeIfNoTariffSwitch,
        _TimeInformation_timeIfTariffSwitch,
        TimeInformation,
        TimerID,
        TimerValue,
        _Tone_toneID,
        _Tone_duration,
        Tone,
        TPDataCodingScheme,
        TPProtocolIdentifier,
        TPShortMessageSpecificInfo,
        TPValidityPeriod,
        _TransferredVolume_volumeIfNoTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval,
        _TransferredVolume_volumeIfTariffSwitch,
        TransferredVolume,
        _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval,
        _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch,
        TransferredVolumeRollOver,
        UnavailableNetworkResource,
        numOfInfoItems,
    ]

class CAP_classes:

    _name_  = 'CAP-classes'
    _oid_   = [0, 4, 0, 0, 1, 3, 54, 7]
    
    _obj_ = [
        'gsmSSF',
        'gsmSRF',
        'smsSSF-V3',
        'smsSSF-V4',
        'gprsSSF',
        'EXTENSION',
        'firstExtension',
        'SupportedExtensions',
        'PARAMETERS-BOUND',
        'cAPSpecificBoundSet',
        ]
    _type_ = [
        'EXTENSION',
        'PARAMETERS-BOUND',
        ]
    _set_ = [
        'SupportedExtensions',
        ]
    _val_ = [
        'gsmSSF',
        'gsmSRF',
        'smsSSF-V3',
        'smsSSF-V4',
        'gprsSSF',
        'firstExtension',
        'cAPSpecificBoundSet',
        ]
    _class_ = [
        'gsmSSF',
        'gsmSRF',
        'smsSSF-V3',
        'smsSSF-V4',
        'gprsSSF',
        'EXTENSION',
        'firstExtension',
        'SupportedExtensions',
        'PARAMETERS-BOUND',
        'cAPSpecificBoundSet',
        ]
    _param_ = [
        ]
    
    #-----< gsmSSF >-----#
    gsmSSF = CLASS(name='gsmSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure),
        ('bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey),
        ('calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        ('cGEncountered', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered),
        ('iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        ('locationNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        ('highLayerCompatibility', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        ('additionalCallingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        ('bearerCapability', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability),
        ('eventTypeBCSM', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        ('redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        ('redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation),
        ('cause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier),
        ('cug-Index', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI),
        ('subscriberState', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState),
        ('locationInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation),
        ('ext-basicServiceCode', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        ('callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        ('mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress),
        ('calledPartyBCDNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        ('timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        ('callForwardingSS-Pending', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        ('initialDPArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID),
        ('scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._ext = ['originalCalledPartyID', 'callingPartyNumber']
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM),
        ('eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        ('allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments),
        ('allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions),
        ('legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        ('requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name='ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        ('operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        ('srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        ('partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions),
        ('aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._ext = []
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_7 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_8 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_8._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_8._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        ('redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        ('redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber),
        ('legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        ('oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        ('suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._ext = ['suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        ('legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased),
        ('releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._ext = []
    __OPERATION_Errors_val_ParameterType_1_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        ('legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        ('legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._ext = []
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        ('none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        ('resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        ('legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        ('bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        ('partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._ext = []
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        ('tone', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        ('releaseCause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        ('gapCriteria', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria),
        ('gapIndicators', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators),
        ('controlType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType),
        ('gapTreatment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions),
        ('legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        ('callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        ('gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        ('suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._cont = ASN1Dict([
        ('supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions),
        ('releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._ext = ['releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID),
        ('iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        ('none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        ('resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID),
        ('scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._ext = ['originalCalledPartyID', 'callingPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        ('bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        ('eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        ('eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        ('allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        ('allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        ('requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions),
        ('legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        ('requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        ('srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        ('partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions),
        ('aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        ('redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        ('redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        ('legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        ('oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        ('suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._ext = ['suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        ('legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased),
        ('releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        ('legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        ('legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        ('none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        ('resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        ('legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        ('bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions),
        ('legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        ('callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        ('gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        ('suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        ('supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions),
        ('releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._ext = ['releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        ('callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        ('bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._ext = None
    gsmSSF._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 3))]), dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 5))])], rr=[], ev=None, er=[])), ('Responds', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 6))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 5))])
    
    #-----< gsmSRF >-----#
    gsmSRF = CLASS(name='gsmSRF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39._cont = ASN1Dict([
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID),
        ('iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_2._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_2._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41._ext = None
    gsmSRF._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_2), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 13))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 6))])
    
    #-----< smsSSF-V3 >-----#
    smsSSF_V3 = CLASS(name='smsSSF-V3', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_serviceKey),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber),
        ('eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMSI),
        ('locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC),
        ('locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress),
        ('timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone),
        ('tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier),
        ('tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme),
        ('tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions),
        ('smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber),
        ('mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_mscAddress),
        ('sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number),
        ('ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2),
        ('gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass),
        ('iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMEI),
        ('calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43._cont = ASN1Dict([
        ('callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45._cont = ASN1Dict([
        ('sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6._cont = ASN1Dict([
        ('eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventTypeSMS),
        ('eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V3._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 20, 26, 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 8))])
    
    #-----< smsSSF-V4 >-----#
    smsSSF_V4 = CLASS(name='smsSSF-V4', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_serviceKey),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber),
        ('eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMSI),
        ('locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC),
        ('locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress),
        ('timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone),
        ('tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier),
        ('tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme),
        ('tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions),
        ('smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber),
        ('mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_mscAddress),
        ('sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number),
        ('ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2),
        ('gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass),
        ('iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMEI),
        ('calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49._cont = ASN1Dict([
        ('callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50._cont = ASN1Dict([
        ('sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7._cont = ASN1Dict([
        ('eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventTypeSMS),
        ('eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V4._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 9))])
    
    #-----< gprsSSF >-----#
    gprsSSF = CLASS(name='gprsSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_serviceKey),
        ('gPRSEventType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType),
        ('mSISDN', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_mSISDN),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMSI),
        ('timeAndTimeZone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone),
        ('gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass),
        ('endUserAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress),
        ('qualityOfService', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService),
        ('accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName),
        ('routeingAreaIdentity', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity),
        ('chargingID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_chargingID),
        ('sGSNCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities),
        ('locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS),
        ('pDPInitiationType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions),
        ('gGSNAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress),
        ('secondaryPDP-context', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context),
        ('iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMEI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54._cont = ASN1Dict([
        ('gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8._cont = ASN1Dict([
        ('gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventType),
        ('miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_miscGPRSInfo),
        ('gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation),
        ('pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56._cont = ASN1Dict([
        ('gPRSCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57._cont = ASN1Dict([
        ('accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName),
        ('pdpID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_pdpID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________58 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59._cont = ASN1Dict([
        ('gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60._cont = ASN1Dict([
        ('gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10._cont = ASN1Dict([
        ('gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventType),
        ('miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_miscGPRSInfo),
        ('gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation),
        ('pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________________61 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65._cont = ASN1Dict([
        ('gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66._cont = ASN1Dict([
        ('gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11._cont = ASN1Dict([
        ('gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventType),
        ('miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_miscGPRSInfo),
        ('gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation),
        ('pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68._ext = []
    gprsSSF._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________58), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________________61), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 14))])], rr=[], ev=None, er=[])), ('Responds', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 15))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 7))])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name='EXTENSION', mode=MODE_TYPE)
    _EXTENSION_ExtensionType = OPEN(name='ExtensionType', mode=MODE_TYPE)
    _EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default='ignore')
    _EXTENSION_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    EXTENSION._cont = ASN1Dict([
        ('ExtensionType', _EXTENSION_ExtensionType),
        ('criticality', _EXTENSION_criticality),
        ('id', _EXTENSION_id),
        ])
    
    #-----< firstExtension >-----#
    firstExtension = CLASS(name='firstExtension', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _firstExtension_val_ExtensionType = NULL(name='ExtensionType', mode=MODE_TYPE)
    firstExtension._val = dict([('ExtensionType', _firstExtension_val_ExtensionType), ('criticality', 'ignore'), ('id', ('global', (0, 4, 0, 1, 2)))])
    
    #-----< SupportedExtensions >-----#
    SupportedExtensions = CLASS(name='SupportedExtensions', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _SupportedExtensions_val_ExtensionType_0 = NULL(name='ExtensionType', mode=MODE_TYPE)
    SupportedExtensions._val = ASN1Set(rv=[dict([('ExtensionType', _SupportedExtensions_val_ExtensionType_0), ('criticality', 'ignore'), ('id', ('global', (0, 4, 0, 1, 2)))])], rr=[], ev=[], er=[])
    
    #-----< PARAMETERS-BOUND >-----#
    PARAMETERS_BOUND = CLASS(name='PARAMETERS-BOUND', mode=MODE_TYPE)
    _PARAMETERS_BOUND_minAccessPointNameLength = INT(name='minAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAccessPointNameLength = INT(name='maxAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAChBillingChargingLength = INT(name='minAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAChBillingChargingLength = INT(name='maxAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAttributesLength = INT(name='minAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAttributesLength = INT(name='maxAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxBearerCapabilityLength = INT(name='maxBearerCapabilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyBCDNumberLength = INT(name='minCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength = INT(name='maxCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyNumberLength = INT(name='minCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyNumberLength = INT(name='maxCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallingPartyNumberLength = INT(name='minCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallingPartyNumberLength = INT(name='maxCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallResultLength = INT(name='minCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallResultLength = INT(name='maxCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCarrierLength = INT(name='minCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCarrierLength = INT(name='maxCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCauseLength = INT(name='minCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCauseLength = INT(name='maxCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minDigitsLength = INT(name='minDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxDigitsLength = INT(name='maxDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingDataLength = INT(name='minFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingDataLength = INT(name='maxFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingLength = INT(name='minFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingLength = INT(name='maxFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGenericNumberLength = INT(name='minGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGenericNumberLength = INT(name='maxGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGPRSCauseLength = INT(name='minGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGPRSCauseLength = INT(name='maxGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minIPSSPCapabilitiesLength = INT(name='minIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength = INT(name='maxIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLocationNumberLength = INT(name='minLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLocationNumberLength = INT(name='maxLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLowLayerCompatibilityLength = INT(name='minLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLowLayerCompatibilityLength = INT(name='maxLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minMessageContentLength = INT(name='minMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxMessageContentLength = INT(name='maxMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minOriginalCalledPartyIDLength = INT(name='minOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength = INT(name='maxOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minPDPAddressLength = INT(name='minPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxPDPAddressLength = INT(name='maxPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minRedirectingPartyIDLength = INT(name='minRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxRedirectingPartyIDLength = INT(name='maxRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minScfIDLength = INT(name='minScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxScfIDLength = INT(name='maxScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minSCIBillingChargingLength = INT(name='minSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxSCIBillingChargingLength = INT(name='maxSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minTimeAndTimezoneLength = INT(name='minTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxTimeAndTimezoneLength = INT(name='maxTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfBCSMEvents = INT(name='numOfBCSMEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo = INT(name='numOfChangeOfPositionControlInfo', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfCSs = INT(name='numOfCSs', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfSMSEvents = INT(name='numOfSMSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGPRSEvents = INT(name='numOfGPRSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfExtensions = INT(name='numOfExtensions', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGenericNumbers = INT(name='numOfGenericNumbers', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfMessageIDs = INT(name='numOfMessageIDs', mode=MODE_VALUE)
    PARAMETERS_BOUND._cont = ASN1Dict([
        ('minAccessPointNameLength', _PARAMETERS_BOUND_minAccessPointNameLength),
        ('maxAccessPointNameLength', _PARAMETERS_BOUND_maxAccessPointNameLength),
        ('minAChBillingChargingLength', _PARAMETERS_BOUND_minAChBillingChargingLength),
        ('maxAChBillingChargingLength', _PARAMETERS_BOUND_maxAChBillingChargingLength),
        ('minAttributesLength', _PARAMETERS_BOUND_minAttributesLength),
        ('maxAttributesLength', _PARAMETERS_BOUND_maxAttributesLength),
        ('maxBearerCapabilityLength', _PARAMETERS_BOUND_maxBearerCapabilityLength),
        ('minCalledPartyBCDNumberLength', _PARAMETERS_BOUND_minCalledPartyBCDNumberLength),
        ('maxCalledPartyBCDNumberLength', _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength),
        ('minCalledPartyNumberLength', _PARAMETERS_BOUND_minCalledPartyNumberLength),
        ('maxCalledPartyNumberLength', _PARAMETERS_BOUND_maxCalledPartyNumberLength),
        ('minCallingPartyNumberLength', _PARAMETERS_BOUND_minCallingPartyNumberLength),
        ('maxCallingPartyNumberLength', _PARAMETERS_BOUND_maxCallingPartyNumberLength),
        ('minCallResultLength', _PARAMETERS_BOUND_minCallResultLength),
        ('maxCallResultLength', _PARAMETERS_BOUND_maxCallResultLength),
        ('minCarrierLength', _PARAMETERS_BOUND_minCarrierLength),
        ('maxCarrierLength', _PARAMETERS_BOUND_maxCarrierLength),
        ('minCauseLength', _PARAMETERS_BOUND_minCauseLength),
        ('maxCauseLength', _PARAMETERS_BOUND_maxCauseLength),
        ('minDigitsLength', _PARAMETERS_BOUND_minDigitsLength),
        ('maxDigitsLength', _PARAMETERS_BOUND_maxDigitsLength),
        ('minFCIBillingChargingDataLength', _PARAMETERS_BOUND_minFCIBillingChargingDataLength),
        ('maxFCIBillingChargingDataLength', _PARAMETERS_BOUND_maxFCIBillingChargingDataLength),
        ('minFCIBillingChargingLength', _PARAMETERS_BOUND_minFCIBillingChargingLength),
        ('maxFCIBillingChargingLength', _PARAMETERS_BOUND_maxFCIBillingChargingLength),
        ('minGenericNumberLength', _PARAMETERS_BOUND_minGenericNumberLength),
        ('maxGenericNumberLength', _PARAMETERS_BOUND_maxGenericNumberLength),
        ('minGPRSCauseLength', _PARAMETERS_BOUND_minGPRSCauseLength),
        ('maxGPRSCauseLength', _PARAMETERS_BOUND_maxGPRSCauseLength),
        ('minIPSSPCapabilitiesLength', _PARAMETERS_BOUND_minIPSSPCapabilitiesLength),
        ('maxIPSSPCapabilitiesLength', _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength),
        ('minLocationNumberLength', _PARAMETERS_BOUND_minLocationNumberLength),
        ('maxLocationNumberLength', _PARAMETERS_BOUND_maxLocationNumberLength),
        ('minLowLayerCompatibilityLength', _PARAMETERS_BOUND_minLowLayerCompatibilityLength),
        ('maxLowLayerCompatibilityLength', _PARAMETERS_BOUND_maxLowLayerCompatibilityLength),
        ('minMessageContentLength', _PARAMETERS_BOUND_minMessageContentLength),
        ('maxMessageContentLength', _PARAMETERS_BOUND_maxMessageContentLength),
        ('minOriginalCalledPartyIDLength', _PARAMETERS_BOUND_minOriginalCalledPartyIDLength),
        ('maxOriginalCalledPartyIDLength', _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength),
        ('minPDPAddressLength', _PARAMETERS_BOUND_minPDPAddressLength),
        ('maxPDPAddressLength', _PARAMETERS_BOUND_maxPDPAddressLength),
        ('minRedirectingPartyIDLength', _PARAMETERS_BOUND_minRedirectingPartyIDLength),
        ('maxRedirectingPartyIDLength', _PARAMETERS_BOUND_maxRedirectingPartyIDLength),
        ('minScfIDLength', _PARAMETERS_BOUND_minScfIDLength),
        ('maxScfIDLength', _PARAMETERS_BOUND_maxScfIDLength),
        ('minSCIBillingChargingLength', _PARAMETERS_BOUND_minSCIBillingChargingLength),
        ('maxSCIBillingChargingLength', _PARAMETERS_BOUND_maxSCIBillingChargingLength),
        ('minTimeAndTimezoneLength', _PARAMETERS_BOUND_minTimeAndTimezoneLength),
        ('maxTimeAndTimezoneLength', _PARAMETERS_BOUND_maxTimeAndTimezoneLength),
        ('numOfBCSMEvents', _PARAMETERS_BOUND_numOfBCSMEvents),
        ('numOfChangeOfPositionControlInfo', _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo),
        ('numOfCSs', _PARAMETERS_BOUND_numOfCSs),
        ('numOfSMSEvents', _PARAMETERS_BOUND_numOfSMSEvents),
        ('numOfGPRSEvents', _PARAMETERS_BOUND_numOfGPRSEvents),
        ('numOfExtensions', _PARAMETERS_BOUND_numOfExtensions),
        ('numOfGenericNumbers', _PARAMETERS_BOUND_numOfGenericNumbers),
        ('numOfMessageIDs', _PARAMETERS_BOUND_numOfMessageIDs),
        ])
    
    #-----< cAPSpecificBoundSet >-----#
    cAPSpecificBoundSet = CLASS(name='cAPSpecificBoundSet', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'PARAMETERS-BOUND')))
    cAPSpecificBoundSet._val = dict([('minAccessPointNameLength', 1), ('maxAccessPointNameLength', 100), ('minAChBillingChargingLength', 5), ('maxAChBillingChargingLength', 177), ('minAttributesLength', 2), ('maxAttributesLength', 10), ('maxBearerCapabilityLength', 11), ('minCalledPartyBCDNumberLength', 1), ('maxCalledPartyBCDNumberLength', 41), ('minCalledPartyNumberLength', 2), ('maxCalledPartyNumberLength', 18), ('minCallingPartyNumberLength', 2), ('maxCallingPartyNumberLength', 10), ('minCallResultLength', 12), ('maxCallResultLength', 193), ('minCarrierLength', 4), ('maxCarrierLength', 4), ('minCauseLength', 2), ('maxCauseLength', 32), ('minDigitsLength', 2), ('maxDigitsLength', 16), ('minFCIBillingChargingDataLength', 1), ('maxFCIBillingChargingDataLength', 160), ('minFCIBillingChargingLength', 5), ('maxFCIBillingChargingLength', 225), ('minGenericNumberLength', 3), ('maxGenericNumberLength', 11), ('minGPRSCauseLength', 1), ('maxGPRSCauseLength', 1), ('minIPSSPCapabilitiesLength', 1), ('maxIPSSPCapabilitiesLength', 4), ('minLocationNumberLength', 2), ('maxLocationNumberLength', 10), ('minLowLayerCompatibilityLength', 1), ('maxLowLayerCompatibilityLength', 16), ('minMessageContentLength', 1), ('maxMessageContentLength', 127), ('minOriginalCalledPartyIDLength', 2), ('maxOriginalCalledPartyIDLength', 10), ('minPDPAddressLength', 1), ('maxPDPAddressLength', 63), ('minRedirectingPartyIDLength', 2), ('maxRedirectingPartyIDLength', 10), ('minScfIDLength', 2), ('maxScfIDLength', 25), ('minSCIBillingChargingLength', 4), ('maxSCIBillingChargingLength', 225), ('minTimeAndTimezoneLength', 8), ('maxTimeAndTimezoneLength', 8), ('numOfBCSMEvents', 30), ('numOfChangeOfPositionControlInfo', 10), ('numOfCSs', 127), ('numOfSMSEvents', 10), ('numOfGPRSEvents', 10), ('numOfExtensions', 10), ('numOfGenericNumbers', 5), ('numOfMessageIDs', 16)])
    
    _all_ = [
        gsmSSF,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        __OPERATION_Errors_val_ParameterType_2_0,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_7,
        __OPERATION_Errors_val_ParameterType_8,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13,
        __OPERATION_Linked_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0_0,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_1,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38,
        gsmSRF,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41,
        smsSSF_V3,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47,
        smsSSF_V4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52,
        gprsSSF,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_mSISDN,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_chargingID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMEI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_pdpID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________58,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________________61,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68,
        _EXTENSION_ExtensionType,
        _EXTENSION_criticality,
        _EXTENSION_id,
        EXTENSION,
        firstExtension,
        _firstExtension_val_ExtensionType,
        SupportedExtensions,
        _SupportedExtensions_val_ExtensionType_0,
        _PARAMETERS_BOUND_minAccessPointNameLength,
        _PARAMETERS_BOUND_maxAccessPointNameLength,
        _PARAMETERS_BOUND_minAChBillingChargingLength,
        _PARAMETERS_BOUND_maxAChBillingChargingLength,
        _PARAMETERS_BOUND_minAttributesLength,
        _PARAMETERS_BOUND_maxAttributesLength,
        _PARAMETERS_BOUND_maxBearerCapabilityLength,
        _PARAMETERS_BOUND_minCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_minCalledPartyNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyNumberLength,
        _PARAMETERS_BOUND_minCallingPartyNumberLength,
        _PARAMETERS_BOUND_maxCallingPartyNumberLength,
        _PARAMETERS_BOUND_minCallResultLength,
        _PARAMETERS_BOUND_maxCallResultLength,
        _PARAMETERS_BOUND_minCarrierLength,
        _PARAMETERS_BOUND_maxCarrierLength,
        _PARAMETERS_BOUND_minCauseLength,
        _PARAMETERS_BOUND_maxCauseLength,
        _PARAMETERS_BOUND_minDigitsLength,
        _PARAMETERS_BOUND_maxDigitsLength,
        _PARAMETERS_BOUND_minFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_minFCIBillingChargingLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingLength,
        _PARAMETERS_BOUND_minGenericNumberLength,
        _PARAMETERS_BOUND_maxGenericNumberLength,
        _PARAMETERS_BOUND_minGPRSCauseLength,
        _PARAMETERS_BOUND_maxGPRSCauseLength,
        _PARAMETERS_BOUND_minIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_minLocationNumberLength,
        _PARAMETERS_BOUND_maxLocationNumberLength,
        _PARAMETERS_BOUND_minLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_maxLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_minMessageContentLength,
        _PARAMETERS_BOUND_maxMessageContentLength,
        _PARAMETERS_BOUND_minOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_minPDPAddressLength,
        _PARAMETERS_BOUND_maxPDPAddressLength,
        _PARAMETERS_BOUND_minRedirectingPartyIDLength,
        _PARAMETERS_BOUND_maxRedirectingPartyIDLength,
        _PARAMETERS_BOUND_minScfIDLength,
        _PARAMETERS_BOUND_maxScfIDLength,
        _PARAMETERS_BOUND_minSCIBillingChargingLength,
        _PARAMETERS_BOUND_maxSCIBillingChargingLength,
        _PARAMETERS_BOUND_minTimeAndTimezoneLength,
        _PARAMETERS_BOUND_maxTimeAndTimezoneLength,
        _PARAMETERS_BOUND_numOfBCSMEvents,
        _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo,
        _PARAMETERS_BOUND_numOfCSs,
        _PARAMETERS_BOUND_numOfSMSEvents,
        _PARAMETERS_BOUND_numOfGPRSEvents,
        _PARAMETERS_BOUND_numOfExtensions,
        _PARAMETERS_BOUND_numOfGenericNumbers,
        _PARAMETERS_BOUND_numOfMessageIDs,
        PARAMETERS_BOUND,
        cAPSpecificBoundSet,
    ]

class CAP_gsmSSF_gsmSCF_ops_args:

    _name_  = 'CAP-gsmSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 101, 7]
    
    _obj_ = [
        'activityTest',
        'applyCharging',
        'ApplyChargingArg',
        'applyChargingReport',
        'ApplyChargingReportArg',
        'assistRequestInstructions',
        'AssistRequestInstructionsArg',
        'callGap',
        'CallGapArg',
        'callInformationReport',
        'CallInformationReportArg',
        'callInformationRequest',
        'CallInformationRequestArg',
        'cancel',
        'CancelArg',
        'collectInformation',
        'CollectInformationArg',
        'connect',
        'ConnectArg',
        'connectToResource',
        'ConnectToResourceArg',
        'continue',
        'continueWithArgument',
        'ContinueWithArgumentArg',
        'ContinueWithArgumentArgExtension',
        'disconnectForwardConnection',
        'disconnectForwardConnectionWithArgument',
        'DisconnectForwardConnectionWithArgumentArg',
        'disconnectLeg',
        'DisconnectLegArg',
        'entityReleased',
        'EntityReleasedArg',
        'establishTemporaryConnection',
        'EstablishTemporaryConnectionArg',
        'eventReportBCSM',
        'EventReportBCSMArg',
        'furnishChargingInformation',
        'FurnishChargingInformationArg',
        'initialDP',
        'InitialDPArg',
        'InitialDPArgExtension',
        'initiateCallAttempt',
        'InitiateCallAttemptArg',
        'InitiateCallAttemptRes',
        'moveLeg',
        'MoveLegArg',
        'playTone',
        'PlayToneArg',
        'releaseCall',
        'ReleaseCallArg',
        'AllCallSegments',
        'AllCallSegmentsWithExtension',
        'requestReportBCSMEvent',
        'RequestReportBCSMEventArg',
        'resetTimer',
        'ResetTimerArg',
        'sendChargingInformation',
        'SendChargingInformationArg',
        'splitLeg',
        'SplitLegArg',
        ]
    _type_ = [
        'ApplyChargingArg',
        'ApplyChargingReportArg',
        'AssistRequestInstructionsArg',
        'CallGapArg',
        'CallInformationReportArg',
        'CallInformationRequestArg',
        'CancelArg',
        'CollectInformationArg',
        'ConnectArg',
        'ConnectToResourceArg',
        'ContinueWithArgumentArg',
        'ContinueWithArgumentArgExtension',
        'DisconnectForwardConnectionWithArgumentArg',
        'DisconnectLegArg',
        'EntityReleasedArg',
        'EstablishTemporaryConnectionArg',
        'EventReportBCSMArg',
        'FurnishChargingInformationArg',
        'InitialDPArg',
        'InitialDPArgExtension',
        'InitiateCallAttemptArg',
        'InitiateCallAttemptRes',
        'MoveLegArg',
        'PlayToneArg',
        'ReleaseCallArg',
        'AllCallSegments',
        'AllCallSegmentsWithExtension',
        'RequestReportBCSMEventArg',
        'ResetTimerArg',
        'SendChargingInformationArg',
        'SplitLegArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'activityTest',
        'applyCharging',
        'applyChargingReport',
        'assistRequestInstructions',
        'callGap',
        'callInformationReport',
        'callInformationRequest',
        'cancel',
        'collectInformation',
        'connect',
        'connectToResource',
        'continue',
        'continueWithArgument',
        'disconnectForwardConnection',
        'disconnectForwardConnectionWithArgument',
        'disconnectLeg',
        'entityReleased',
        'establishTemporaryConnection',
        'eventReportBCSM',
        'furnishChargingInformation',
        'initialDP',
        'initiateCallAttempt',
        'moveLeg',
        'playTone',
        'releaseCall',
        'requestReportBCSMEvent',
        'resetTimer',
        'sendChargingInformation',
        'splitLeg',
        ]
    _class_ = [
        'activityTest',
        'applyCharging',
        'applyChargingReport',
        'assistRequestInstructions',
        'callGap',
        'callInformationReport',
        'callInformationRequest',
        'cancel',
        'collectInformation',
        'connect',
        'connectToResource',
        'continue',
        'continueWithArgument',
        'disconnectForwardConnection',
        'disconnectForwardConnectionWithArgument',
        'disconnectLeg',
        'entityReleased',
        'establishTemporaryConnection',
        'eventReportBCSM',
        'furnishChargingInformation',
        'initialDP',
        'initiateCallAttempt',
        'moveLeg',
        'playTone',
        'releaseCall',
        'requestReportBCSMEvent',
        'resetTimer',
        'sendChargingInformation',
        'splitLeg',
        ]
    _param_ = [
        'applyCharging',
        'ApplyChargingArg',
        'applyChargingReport',
        'ApplyChargingReportArg',
        'assistRequestInstructions',
        'AssistRequestInstructionsArg',
        'callGap',
        'CallGapArg',
        'callInformationReport',
        'CallInformationReportArg',
        'callInformationRequest',
        'CallInformationRequestArg',
        'cancel',
        'CancelArg',
        'collectInformation',
        'CollectInformationArg',
        'connect',
        'ConnectArg',
        'connectToResource',
        'ConnectToResourceArg',
        'continueWithArgument',
        'ContinueWithArgumentArg',
        'ContinueWithArgumentArgExtension',
        'disconnectForwardConnectionWithArgument',
        'DisconnectForwardConnectionWithArgumentArg',
        'disconnectLeg',
        'DisconnectLegArg',
        'entityReleased',
        'EntityReleasedArg',
        'establishTemporaryConnection',
        'EstablishTemporaryConnectionArg',
        'eventReportBCSM',
        'EventReportBCSMArg',
        'furnishChargingInformation',
        'FurnishChargingInformationArg',
        'initialDP',
        'InitialDPArg',
        'InitialDPArgExtension',
        'initiateCallAttempt',
        'InitiateCallAttemptArg',
        'InitiateCallAttemptRes',
        'moveLeg',
        'MoveLegArg',
        'playTone',
        'PlayToneArg',
        'releaseCall',
        'ReleaseCallArg',
        'AllCallSegments',
        'AllCallSegmentsWithExtension',
        'requestReportBCSMEvent',
        'RequestReportBCSMEventArg',
        'resetTimer',
        'ResetTimerArg',
        'sendChargingInformation',
        'SendChargingInformationArg',
        'splitLeg',
        'SplitLegArg',
        ]
    
    #-----< activityTest >-----#
    activityTest = CLASS(name='activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTest._val = dict([('returnResult', True), ('operationCode', ('local', 55))])
    
    #-----< applyCharging >-----#
    applyCharging = CLASS(name='applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingArg >-----#
    ApplyChargingArg = SEQ(name='ApplyChargingArg', mode=MODE_TYPE, param=True)
    
    #-----< applyChargingReport >-----#
    applyChargingReport = CLASS(name='applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingReportArg >-----#
    ApplyChargingReportArg = OCT_STR(name='ApplyChargingReportArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CallResult')), param=True)
    
    #-----< assistRequestInstructions >-----#
    assistRequestInstructions = CLASS(name='assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AssistRequestInstructionsArg >-----#
    AssistRequestInstructionsArg = SEQ(name='AssistRequestInstructionsArg', mode=MODE_TYPE, param=True)
    
    #-----< callGap >-----#
    callGap = CLASS(name='callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallGapArg >-----#
    CallGapArg = SEQ(name='CallGapArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationReport >-----#
    callInformationReport = CLASS(name='callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationReportArg >-----#
    CallInformationReportArg = SEQ(name='CallInformationReportArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationRequest >-----#
    callInformationRequest = CLASS(name='callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationRequestArg >-----#
    CallInformationRequestArg = SEQ(name='CallInformationRequestArg', mode=MODE_TYPE, param=True)
    
    #-----< cancel >-----#
    cancel = CLASS(name='cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CancelArg >-----#
    CancelArg = CHOICE(name='CancelArg', mode=MODE_TYPE, param=True)
    
    #-----< collectInformation >-----#
    collectInformation = CLASS(name='collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CollectInformationArg >-----#
    CollectInformationArg = SEQ(name='CollectInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< connect >-----#
    connect = CLASS(name='connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectArg >-----#
    ConnectArg = SEQ(name='ConnectArg', mode=MODE_TYPE, param=True)
    
    #-----< connectToResource >-----#
    connectToResource = CLASS(name='connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectToResourceArg >-----#
    ConnectToResourceArg = SEQ(name='ConnectToResourceArg', mode=MODE_TYPE, param=True)
    
    #-----< continue >-----#
    continue_ = CLASS(name='continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continue_._val = dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])
    
    #-----< continueWithArgument >-----#
    continueWithArgument = CLASS(name='continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ContinueWithArgumentArg >-----#
    ContinueWithArgumentArg = SEQ(name='ContinueWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< ContinueWithArgumentArgExtension >-----#
    ContinueWithArgumentArgExtension = SEQ(name='ContinueWithArgumentArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< disconnectForwardConnection >-----#
    disconnectForwardConnection = CLASS(name='disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    __OPERATION_Errors_val_ParameterType_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    disconnectForwardConnection._val = dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))])
    
    #-----< disconnectForwardConnectionWithArgument >-----#
    disconnectForwardConnectionWithArgument = CLASS(name='disconnectForwardConnectionWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectForwardConnectionWithArgumentArg >-----#
    DisconnectForwardConnectionWithArgumentArg = SEQ(name='DisconnectForwardConnectionWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< disconnectLeg >-----#
    disconnectLeg = CLASS(name='disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectLegArg >-----#
    DisconnectLegArg = SEQ(name='DisconnectLegArg', mode=MODE_TYPE, param=True)
    
    #-----< entityReleased >-----#
    entityReleased = CLASS(name='entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedArg >-----#
    EntityReleasedArg = CHOICE(name='EntityReleasedArg', mode=MODE_TYPE, param=True)
    
    #-----< establishTemporaryConnection >-----#
    establishTemporaryConnection = CLASS(name='establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EstablishTemporaryConnectionArg >-----#
    EstablishTemporaryConnectionArg = SEQ(name='EstablishTemporaryConnectionArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportBCSM >-----#
    eventReportBCSM = CLASS(name='eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportBCSMArg >-----#
    EventReportBCSMArg = SEQ(name='EventReportBCSMArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformation >-----#
    furnishChargingInformation = CLASS(name='furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationArg >-----#
    FurnishChargingInformationArg = OCT_STR(name='FurnishChargingInformationArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIBillingChargingCharacteristics')), param=True)
    
    #-----< initialDP >-----#
    initialDP = CLASS(name='initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPArg >-----#
    InitialDPArg = SEQ(name='InitialDPArg', mode=MODE_TYPE, param=True)
    
    #-----< InitialDPArgExtension >-----#
    InitialDPArgExtension = SEQ(name='InitialDPArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< initiateCallAttempt >-----#
    initiateCallAttempt = CLASS(name='initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitiateCallAttemptArg >-----#
    InitiateCallAttemptArg = SEQ(name='InitiateCallAttemptArg', mode=MODE_TYPE, param=True)
    
    #-----< InitiateCallAttemptRes >-----#
    InitiateCallAttemptRes = SEQ(name='InitiateCallAttemptRes', mode=MODE_TYPE, param=True)
    
    #-----< moveLeg >-----#
    moveLeg = CLASS(name='moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< MoveLegArg >-----#
    MoveLegArg = SEQ(name='MoveLegArg', mode=MODE_TYPE, param=True)
    
    #-----< playTone >-----#
    playTone = CLASS(name='playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayToneArg >-----#
    PlayToneArg = SEQ(name='PlayToneArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseCall >-----#
    releaseCall = CLASS(name='releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseCallArg >-----#
    ReleaseCallArg = CHOICE(name='ReleaseCallArg', mode=MODE_TYPE, param=True)
    
    #-----< AllCallSegments >-----#
    AllCallSegments = OCT_STR(name='AllCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Cause')), param=True)
    
    #-----< AllCallSegmentsWithExtension >-----#
    AllCallSegmentsWithExtension = SEQ(name='AllCallSegmentsWithExtension', mode=MODE_TYPE, param=True)
    
    #-----< requestReportBCSMEvent >-----#
    requestReportBCSMEvent = CLASS(name='requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportBCSMEventArg >-----#
    RequestReportBCSMEventArg = SEQ(name='RequestReportBCSMEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimer >-----#
    resetTimer = CLASS(name='resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerArg >-----#
    ResetTimerArg = SEQ(name='ResetTimerArg', mode=MODE_TYPE, param=True)
    
    #-----< sendChargingInformation >-----#
    sendChargingInformation = CLASS(name='sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationArg >-----#
    SendChargingInformationArg = SEQ(name='SendChargingInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< splitLeg >-----#
    splitLeg = CLASS(name='splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SplitLegArg >-----#
    SplitLegArg = SEQ(name='SplitLegArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTest,
        continue_,
        disconnectForwardConnection,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_1,
    ]

class CAP_gsmSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = 'CAP-gsmSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 102, 7]
    
    _obj_ = [
        'capssf-scfGenericAC',
        'capssf-scfAssistHandoffAC',
        'capscf-ssfGenericAC',
        'capSsfToScfGeneric',
        'capAssistHandoffssfToScf',
        'capScfToSsfGeneric',
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'activityTestPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        'gsmSSF-scfGenericAbstractSyntax',
        'GenericSSF-gsmSCF-PDUs',
        'SsfToScfGenericInvokable',
        'SsfToScfGenericReturnable',
        'assistHandoff-gsmSSF-scfAbstractSyntax',
        'AssistHandoffsSF-gsmSCF-PDUs',
        'AssistHandoffssfToScfInvokable',
        'AssistHandoffssfToScfReturnable',
        'scf-gsmSSFGenericAbstractSyntax',
        'GenericSCF-gsmSSF-PDUs',
        'ScfToSsfGenericInvokable',
        'ScfToSsfGenericReturnable',
        ]
    _type_ = [
        'GenericSSF-gsmSCF-PDUs',
        'AssistHandoffsSF-gsmSCF-PDUs',
        'GenericSCF-gsmSSF-PDUs',
        ]
    _set_ = [
        'SsfToScfGenericInvokable',
        'SsfToScfGenericReturnable',
        'AssistHandoffssfToScfInvokable',
        'AssistHandoffssfToScfReturnable',
        'ScfToSsfGenericInvokable',
        'ScfToSsfGenericReturnable',
        ]
    _val_ = [
        'capssf-scfGenericAC',
        'capssf-scfAssistHandoffAC',
        'capscf-ssfGenericAC',
        'capSsfToScfGeneric',
        'capAssistHandoffssfToScf',
        'capScfToSsfGeneric',
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'activityTestPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        'gsmSSF-scfGenericAbstractSyntax',
        'assistHandoff-gsmSSF-scfAbstractSyntax',
        'scf-gsmSSFGenericAbstractSyntax',
        ]
    _class_ = [
        'capssf-scfGenericAC',
        'capssf-scfAssistHandoffAC',
        'capscf-ssfGenericAC',
        'capSsfToScfGeneric',
        'capAssistHandoffssfToScf',
        'capScfToSsfGeneric',
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'activityTestPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        'gsmSSF-scfGenericAbstractSyntax',
        'SsfToScfGenericInvokable',
        'SsfToScfGenericReturnable',
        'assistHandoff-gsmSSF-scfAbstractSyntax',
        'AssistHandoffssfToScfInvokable',
        'AssistHandoffssfToScfReturnable',
        'scf-gsmSSFGenericAbstractSyntax',
        'ScfToSsfGenericInvokable',
        'ScfToSsfGenericReturnable',
        ]
    _param_ = [
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        ]
    
    #-----< capssf-scfGenericAC >-----#
    capssf_scfGenericAC = CLASS(name='capssf-scfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure),
        ('bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey),
        ('calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        ('cGEncountered', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered),
        ('iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        ('locationNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        ('highLayerCompatibility', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        ('additionalCallingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        ('bearerCapability', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability),
        ('eventTypeBCSM', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        ('redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        ('redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation),
        ('cause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier),
        ('cug-Index', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI),
        ('subscriberState', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState),
        ('locationInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation),
        ('ext-basicServiceCode', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        ('callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        ('mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress),
        ('calledPartyBCDNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        ('timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        ('callForwardingSS-Pending', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        ('initialDPArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID),
        ('scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._ext = ['originalCalledPartyID', 'callingPartyNumber']
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM),
        ('eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        ('allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments),
        ('allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions),
        ('legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        ('requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name='ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        ('operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        ('srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        ('partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions),
        ('aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._ext = []
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_7 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_8 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_8._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_8._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        ('redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        ('redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber),
        ('legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        ('oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        ('suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._ext = ['suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        ('legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased),
        ('releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._ext = []
    __OPERATION_Errors_val_ParameterType_1_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        ('legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        ('legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._ext = []
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        ('none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        ('resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        ('legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        ('bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        ('partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._ext = []
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        ('tone', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        ('releaseCause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        ('gapCriteria', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria),
        ('gapIndicators', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators),
        ('controlType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType),
        ('gapTreatment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions),
        ('legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        ('callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        ('gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        ('suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._cont = ASN1Dict([
        ('supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions),
        ('releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._ext = ['releaseCallArgExtensionAllowed']
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    capssf_scfGenericAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 3))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 4))])
    
    #-----< capssf-scfAssistHandoffAC >-----#
    capssf_scfAssistHandoffAC = CLASS(name='capssf-scfAssistHandoffAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID),
        ('iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        ('none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        ('resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._ext = []
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    capssf_scfAssistHandoffAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 5))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 6))])
    
    #-----< capscf-ssfGenericAC >-----#
    capscf_ssfGenericAC = CLASS(name='capscf-ssfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID),
        ('scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._ext = ['originalCalledPartyID', 'callingPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        ('bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        ('eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        ('eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        ('allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        ('allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        ('requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions),
        ('legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        ('requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions),
        ('legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        ('srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        ('partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions),
        ('aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        ('originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        ('redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        ('redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        ('legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        ('oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        ('suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._ext = ['suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        ('legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased),
        ('releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        ('legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        ('legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        ('none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        ('resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        ('legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        ('bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        ('destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions),
        ('legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        ('newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        ('callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        ('gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        ('suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        ('supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions),
        ('releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._ext = ['releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        ('alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions),
        ('serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        ('genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers),
        ('cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock),
        ('cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        ('chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber),
        ('carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier),
        ('suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        ('naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo),
        ('bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        ('suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        ('continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        ('legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        ('cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        ('callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        ('bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._ext = None
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    capscf_ssfGenericAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 6))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_1), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 8))])
    
    #-----< capSsfToScfGeneric >-----#
    capSsfToScfGeneric = CLASS(name='capSsfToScfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capSsfToScfGeneric._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 3))])
    
    #-----< capAssistHandoffssfToScf >-----#
    capAssistHandoffssfToScf = CLASS(name='capAssistHandoffssfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capAssistHandoffssfToScf._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 5))])
    
    #-----< capScfToSsfGeneric >-----#
    capScfToSsfGeneric = CLASS(name='capScfToSsfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capScfToSsfGeneric._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 6))])
    
    #-----< scfActivationPackage >-----#
    scfActivationPackage = CLASS(name='scfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfActivationOfAssistPackage >-----#
    gsmSRF_scfActivationOfAssistPackage = CLASS(name='gsmSRF-scfActivationOfAssistPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< assistConnectionEstablishmentPackage >-----#
    assistConnectionEstablishmentPackage = CLASS(name='assistConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< genericDisconnectResourcePackage >-----#
    genericDisconnectResourcePackage = CLASS(name='genericDisconnectResourcePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< nonAssistedConnectionEstablishmentPackage >-----#
    nonAssistedConnectionEstablishmentPackage = CLASS(name='nonAssistedConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< connectPackage >-----#
    connectPackage = CLASS(name='connectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callHandlingPackage >-----#
    callHandlingPackage = CLASS(name='callHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< bcsmEventHandlingPackage >-----#
    bcsmEventHandlingPackage = CLASS(name='bcsmEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ssfCallProcessingPackage >-----#
    ssfCallProcessingPackage = CLASS(name='ssfCallProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< scfCallInitiationPackage >-----#
    scfCallInitiationPackage = CLASS(name='scfCallInitiationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< timerPackage >-----#
    timerPackage = CLASS(name='timerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< billingPackage >-----#
    billingPackage = CLASS(name='billingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< chargingPackage >-----#
    chargingPackage = CLASS(name='chargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< trafficManagementPackage >-----#
    trafficManagementPackage = CLASS(name='trafficManagementPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callReportPackage >-----#
    callReportPackage = CLASS(name='callReportPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< signallingControlPackage >-----#
    signallingControlPackage = CLASS(name='signallingControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name='activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< cancelPackage >-----#
    cancelPackage = CLASS(name='cancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< cphResponsePackage >-----#
    cphResponsePackage = CLASS(name='cphResponsePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< exceptionInformPackage >-----#
    exceptionInformPackage = CLASS(name='exceptionInformPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< playTonePackage >-----#
    playTonePackage = CLASS(name='playTonePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSSF-scfGenericAbstractSyntax >-----#
    gsmSSF_scfGenericAbstractSyntax = CLASS(name='gsmSSF-scfGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gsmSSF_scfGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    gsmSSF_scfGenericAbstractSyntax._val = dict([('Type', _gsmSSF_scfGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])
    
    #-----< GenericSSF-gsmSCF-PDUs >-----#
    GenericSSF_gsmSCF_PDUs = CHOICE(name='GenericSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSSF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ('legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID),
        ('allRequests', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory),
        ('genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers),
        ('cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess),
        ('chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier),
        ('suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement),
        ('naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested),
        ('suppress-O-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        ('none', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('resourceAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        ('cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID),
        ('cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('callSegmentFailure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure),
        ('bCSM-Failure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        ('correlationID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID),
        ('scfID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID),
        ('naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo),
        ('chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber),
        ('originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID),
        ('callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._ext = ['originalCalledPartyID', 'callingPartyNumber']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM),
        ('eventSpecificInformationBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM),
        ('legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID),
        ('miscCallInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation),
        ('cause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier),
        ('cug-Index', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI),
        ('subscriberState', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState),
        ('locationInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions),
        ('legToBeCreated', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID),
        ('timervalue', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        ('bursts', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), ('ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27), ('ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        ('tone', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend),
        ('releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('gapCriteria', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria),
        ('gapIndicators', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators),
        ('controlType', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType),
        ('gapTreatment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        ('allRequests', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory),
        ('genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers),
        ('cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess),
        ('chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier),
        ('suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement),
        ('naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo),
        ('bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested),
        ('suppress-O-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('legToBeReleased', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased),
        ('releaseCause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        ('cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID),
        ('cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        ('callSegmentFailure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure),
        ('bCSM-Failure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        ('correlationID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID),
        ('scfID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID),
        ('naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo),
        ('chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber),
        ('originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID),
        ('callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation),
        ('cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier),
        ('cug-Index', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI),
        ('subscriberState', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState),
        ('locationInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        ('legToBeCreated', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID),
        ('timervalue', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        ('bursts', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), ('ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27), ('ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        ('problem', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        ('operation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), ('errorCode', ('local', 10))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericSSF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_begin_components._cont = ___GenericSSF_gsmSCF_PDUs_begin_components__item_
    __GenericSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericSSF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericSSF_gsmSCF_PDUs_begin._ext = None
    _GenericSSF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_end_components._cont = ___GenericSSF_gsmSCF_PDUs_end_components__item_
    __GenericSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericSSF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericSSF_gsmSCF_PDUs_end._ext = None
    _GenericSSF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_continue__components._cont = ___GenericSSF_gsmSCF_PDUs_continue__components__item_
    __GenericSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericSSF_gsmSCF_PDUs_continue__otid),
        ('dtid', __GenericSSF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericSSF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSSF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericSSF_gsmSCF_PDUs_unidirectional),
        ('begin', _GenericSSF_gsmSCF_PDUs_begin),
        ('end', _GenericSSF_gsmSCF_PDUs_end),
        ('continue', _GenericSSF_gsmSCF_PDUs_continue_),
        ('abort', _GenericSSF_gsmSCF_PDUs_abort),
        ])
    GenericSSF_gsmSCF_PDUs._ext = None
    
    #-----< SsfToScfGenericInvokable >-----#
    SsfToScfGenericInvokable = CLASS(name='SsfToScfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_1._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_3_extensions),
        ('legID', __SsfToScfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_3._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_4_extensions),
        ('legID', __SsfToScfGenericInvokable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_4._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID),
        ('allRequests', __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_5._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_6_extensions),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _SsfToScfGenericInvokable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        ('alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory),
        ('genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers),
        ('cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess),
        ('chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_7_carrier),
        ('suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement),
        ('naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested),
        ('suppress-O-CSI', __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_7._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        ('none', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_8._cont = ASN1Dict([
        ('resourceAddress', __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_8_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_8._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_9_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_9._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_11._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_12._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        ('cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID),
        ('cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        ('callSegmentFailure', __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure),
        ('bCSM-Failure', __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_13._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_14._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        ('correlationID', __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID),
        ('scfID', __SsfToScfGenericInvokable_val_ArgumentType_14_scfID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_14_extensions),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_14_carrier),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID),
        ('naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo),
        ('chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber),
        ('originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID),
        ('callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_14._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _SsfToScfGenericInvokable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_15_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        ('eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM),
        ('eventSpecificInformationBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM),
        ('legID', __SsfToScfGenericInvokable_val_ArgumentType_15_legID),
        ('miscCallInfo', __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_15_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_15._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation),
        ('cause', __SsfToScfGenericInvokable_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_17_carrier),
        ('cug-Index', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI),
        ('subscriberState', __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState),
        ('locationInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_17._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_18_extensions),
        ('legToBeCreated', __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_18._ext = []
    _SsfToScfGenericInvokable_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', __SsfToScfGenericInvokable_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericInvokable_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_19._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_20._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_21._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', __SsfToScfGenericInvokable_val_ArgumentType_22_timerID),
        ('timervalue', __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_22_extensions),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_22._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_23._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_24._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_25_extensions),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_25._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment),
        ('bursts', __SsfToScfGenericInvokable_val_ArgumentType_26_bursts),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_26._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_27_extensions),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_27._ext = []
    _SsfToScfGenericInvokable_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericInvokable_val_ResultType_27._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    SsfToScfGenericInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_15), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_18), ('ResultType', _SsfToScfGenericInvokable_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_27), ('ResultType', _SsfToScfGenericInvokable_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_28), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    #-----< SsfToScfGenericReturnable >-----#
    SsfToScfGenericReturnable = CLASS(name='SsfToScfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_1._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        ('tone', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend),
        ('releaseCause', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('gapCriteria', __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria),
        ('gapIndicators', __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators),
        ('controlType', __SsfToScfGenericReturnable_val_ArgumentType_3_controlType),
        ('gapTreatment', __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_3_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_3._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _SsfToScfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_4_extensions),
        ('legID', __SsfToScfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_4._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID),
        ('allRequests', __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_5._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_6_extensions),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _SsfToScfGenericReturnable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_7._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_8._cont = ASN1Dict([
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_8_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_8._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        ('alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_10_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory),
        ('genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers),
        ('cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess),
        ('chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_10_carrier),
        ('suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement),
        ('naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested),
        ('suppress-O-CSI', __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_10._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_12._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        ('legToBeReleased', __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased),
        ('releaseCause', __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_13._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        ('cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID),
        ('cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14._cont = ASN1Dict([
        ('callSegmentFailure', __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure),
        ('bCSM-Failure', __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_14._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        ('correlationID', __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID),
        ('scfID', __SsfToScfGenericReturnable_val_ArgumentType_15_scfID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_15_extensions),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_15_carrier),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID),
        ('naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo),
        ('chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber),
        ('originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID),
        ('callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_15._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _SsfToScfGenericReturnable_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation),
        ('cause', __SsfToScfGenericReturnable_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_17_carrier),
        ('cug-Index', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI),
        ('subscriberState', __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState),
        ('locationInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_17._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_18_extensions),
        ('legToBeCreated', __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_18._ext = []
    _SsfToScfGenericReturnable_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', __SsfToScfGenericReturnable_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericReturnable_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_19._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_20._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_21._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', __SsfToScfGenericReturnable_val_ArgumentType_22_timerID),
        ('timervalue', __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_22_extensions),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_22._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_23._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_24._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_25_extensions),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_25._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment),
        ('bursts', __SsfToScfGenericReturnable_val_ArgumentType_26_bursts),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_26._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_27_extensions),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_27._ext = []
    _SsfToScfGenericReturnable_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericReturnable_val_ResultType_27._ext = None
    SsfToScfGenericReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_13), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_14), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_18), ('ResultType', _SsfToScfGenericReturnable_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_27), ('ResultType', _SsfToScfGenericReturnable_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    
    #-----< assistHandoff-gsmSSF-scfAbstractSyntax >-----#
    assistHandoff_gsmSSF_scfAbstractSyntax = CLASS(name='assistHandoff-gsmSSF-scfAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    assistHandoff_gsmSSF_scfAbstractSyntax._val = dict([('Type', _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])
    
    #-----< AssistHandoffsSF-gsmSCF-PDUs >-----#
    AssistHandoffsSF_gsmSCF_PDUs = CHOICE(name='AssistHandoffsSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID),
        ('timervalue', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('ResultType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID),
        ('timervalue', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('ResultType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        ('problem', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        ('operation', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __AssistHandoffsSF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_begin_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __AssistHandoffsSF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_end_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_end._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __AssistHandoffsSF_gsmSCF_PDUs_continue__otid),
        ('dtid', __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_continue__components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    AssistHandoffsSF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _AssistHandoffsSF_gsmSCF_PDUs_unidirectional),
        ('begin', _AssistHandoffsSF_gsmSCF_PDUs_begin),
        ('end', _AssistHandoffsSF_gsmSCF_PDUs_end),
        ('continue', _AssistHandoffsSF_gsmSCF_PDUs_continue_),
        ('abort', _AssistHandoffsSF_gsmSCF_PDUs_abort),
        ])
    AssistHandoffsSF_gsmSCF_PDUs._ext = None
    
    #-----< AssistHandoffssfToScfInvokable >-----#
    AssistHandoffssfToScfInvokable = CLASS(name='AssistHandoffssfToScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID),
        ('allRequests', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfInvokable_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID),
        ('timervalue', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    AssistHandoffssfToScfInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_6), ('ResultType', _AssistHandoffssfToScfInvokable_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_8), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    #-----< AssistHandoffssfToScfReturnable >-----#
    AssistHandoffssfToScfReturnable = CLASS(name='AssistHandoffssfToScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID),
        ('allRequests', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfReturnable_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID),
        ('timervalue', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._ext = []
    AssistHandoffssfToScfReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_6), ('ResultType', _AssistHandoffssfToScfReturnable_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])
    
    #-----< scf-gsmSSFGenericAbstractSyntax >-----#
    scf_gsmSSFGenericAbstractSyntax = CLASS(name='scf-gsmSSFGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _scf_gsmSSFGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    scf_gsmSSFGenericAbstractSyntax._val = dict([('Type', _scf_gsmSSFGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])
    
    #-----< GenericSCF-gsmSSF-PDUs >-----#
    GenericSCF_gsmSSF_PDUs = CHOICE(name='GenericSCF-gsmSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSCF_gsmSSF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationTypeList', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('legID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('invokeID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID),
        ('allRequests', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests),
        ('callSegmentToCancel', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory),
        ('genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers),
        ('cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess),
        ('chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber),
        ('carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier),
        ('suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement),
        ('naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested),
        ('suppress-O-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        ('correlationID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID),
        ('scfID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions),
        ('carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID),
        ('naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo),
        ('chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber),
        ('originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID),
        ('callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = ['originalCalledPartyID', 'callingPartyNumber']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        ('legToBeCreated', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('legOrCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment),
        ('bursts', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('allCallSegments', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments),
        ('allCallSegmentsWithExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('bcsmEvents', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('timerID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID),
        ('timervalue', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('legToBeSplit', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit),
        ('newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend),
        ('disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo),
        ('tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        ('collectedInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo),
        ('disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden),
        ('informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._cont = ASN1Dict([
        ('digitsResponse', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._ext = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), ('ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), ('ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        ('allRequests', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('legToBeReleased', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased),
        ('releaseCause', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        ('cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID),
        ('cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentFailure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure),
        ('bCSM-Failure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        ('correlationID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID),
        ('scfID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ('carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier),
        ('serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        ('naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo),
        ('chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber),
        ('originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID),
        ('callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('eventTypeBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM),
        ('eventSpecificInformationBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID),
        ('miscCallInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        ('legToBeCreated', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        ('legID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('bcsmEvents', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('timerID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID),
        ('timervalue', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('legToBeSplit', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit),
        ('newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo),
        ('tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend),
        ('disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment),
        ('bursts', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('collectedInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo),
        ('disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        ('informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._cont = ASN1Dict([
        ('digitsResponse', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), ('ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), ('ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        ('problem', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        ('operation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), ('errorCode', ('local', 10))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._cont = ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_unidirectional_components),
        ])
    _GenericSCF_gsmSSF_PDUs_unidirectional._ext = None
    _GenericSCF_gsmSSF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSCF_gsmSSF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_begin_components._cont = ___GenericSCF_gsmSSF_PDUs_begin_components__item_
    __GenericSCF_gsmSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericSCF_gsmSSF_PDUs_begin_otid),
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_begin_components),
        ])
    _GenericSCF_gsmSSF_PDUs_begin._ext = None
    _GenericSCF_gsmSSF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSCF_gsmSSF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_end_components._cont = ___GenericSCF_gsmSSF_PDUs_end_components__item_
    __GenericSCF_gsmSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericSCF_gsmSSF_PDUs_end_dtid),
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_end_dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_end_components),
        ])
    _GenericSCF_gsmSSF_PDUs_end._ext = None
    _GenericSCF_gsmSSF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSCF_gsmSSF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_continue__components._cont = ___GenericSCF_gsmSSF_PDUs_continue__components__item_
    __GenericSCF_gsmSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericSCF_gsmSSF_PDUs_continue__otid),
        ('dtid', __GenericSCF_gsmSSF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_continue__components),
        ])
    _GenericSCF_gsmSSF_PDUs_continue_._ext = None
    _GenericSCF_gsmSSF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSCF_gsmSSF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericSCF_gsmSSF_PDUs_unidirectional),
        ('begin', _GenericSCF_gsmSSF_PDUs_begin),
        ('end', _GenericSCF_gsmSSF_PDUs_end),
        ('continue', _GenericSCF_gsmSSF_PDUs_continue_),
        ('abort', _GenericSCF_gsmSSF_PDUs_abort),
        ])
    GenericSCF_gsmSSF_PDUs._ext = None
    
    #-----< ScfToSsfGenericInvokable >-----#
    ScfToSsfGenericInvokable = CLASS(name='ScfToSsfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _ScfToSsfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationTypeList', __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions),
        ('legID', __ScfToSsfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID),
        ('callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('invokeID', __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID),
        ('allRequests', __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests),
        ('callSegmentToCancel', __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_4._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions),
        ('carrier', __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _ScfToSsfGenericInvokable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        ('alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory),
        ('genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers),
        ('cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock),
        ('cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess),
        ('chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber),
        ('carrier', __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier),
        ('suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement),
        ('naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo),
        ('bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested),
        ('suppress-O-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        ('correlationID', __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID),
        ('scfID', __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions),
        ('carrier', __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID),
        ('naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo),
        ('chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber),
        ('originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID),
        ('callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _ScfToSsfGenericInvokable_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions),
        ('legToBeCreated', __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', __ScfToSsfGenericInvokable_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    _ScfToSsfGenericInvokable_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        ('legID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        ('legOrCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment),
        ('bursts', __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_18 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        ('allCallSegments', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments),
        ('allCallSegmentsWithExtension', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_18._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        ('legID', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._ext = []
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        ('bcsmEvents', __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        ('timerID', __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID),
        ('timervalue', __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        ('legToBeSplit', __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit),
        ('newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        ('informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend),
        ('disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        ('collectedInfo', __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo),
        ('disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden),
        ('informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_24._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_24 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ResultType_24._cont = ASN1Dict([
        ('digitsResponse', __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_24._ext = None
    ScfToSsfGenericInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_15), ('ResultType', _ScfToSsfGenericInvokable_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_18), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_22), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_24), ('ResultType', _ScfToSsfGenericInvokable_val_ResultType_24), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    
    #-----< ScfToSsfGenericReturnable >-----#
    ScfToSsfGenericReturnable = CLASS(name='ScfToSsfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions),
        ('legID', __ScfToSsfGenericReturnable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions),
        ('legID', __ScfToSsfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_4._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID),
        ('allRequests', __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_5._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions),
        ('carrier', __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _ScfToSsfGenericReturnable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._cont = ASN1Dict([
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        ('legToBeReleased', __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased),
        ('releaseCause', __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        ('cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID),
        ('cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentFailure', __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure),
        ('bCSM-Failure', __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_11._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        ('correlationID', __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID),
        ('scfID', __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions),
        ('carrier', __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID),
        ('naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo),
        ('chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber),
        ('originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID),
        ('callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _ScfToSsfGenericReturnable_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_13_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        ('eventTypeBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM),
        ('eventSpecificInformationBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM),
        ('legID', __ScfToSsfGenericReturnable_val_ArgumentType_13_legID),
        ('miscCallInfo', __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions),
        ('legToBeCreated', __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', __ScfToSsfGenericReturnable_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    _ScfToSsfGenericReturnable_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        ('legID', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        ('bcsmEvents', __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        ('timerID', __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID),
        ('timervalue', __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        ('legToBeSplit', __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit),
        ('newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        ('informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend),
        ('disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        ('legID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        ('legOrCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment),
        ('bursts', __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        ('collectedInfo', __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo),
        ('disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden),
        ('informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_23 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ResultType_23._cont = ASN1Dict([
        ('digitsResponse', __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_23._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_24 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ScfToSsfGenericReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_10), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_11), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_15), ('ResultType', _ScfToSsfGenericReturnable_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_20), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_23), ('ResultType', _ScfToSsfGenericReturnable_val_ResultType_23), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_24), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    _all_ = [
        capssf_scfGenericAC,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        __OPERATION_Errors_val_ParameterType_2_0,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_7,
        __OPERATION_Errors_val_ParameterType_8,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13,
        __OPERATION_Linked_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1,
        capssf_scfAssistHandoffAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_0,
        capscf_ssfGenericAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0_0,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_1,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_1,
        capSsfToScfGeneric,
        capAssistHandoffssfToScf,
        capScfToSsfGeneric,
        activityTestPackage,
        gsmSSF_scfGenericAbstractSyntax,
        _gsmSSF_scfGenericAbstractSyntax_val_Type,
        __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericSSF_gsmSCF_PDUs_unidirectional,
        __GenericSSF_gsmSCF_PDUs_begin_otid,
        __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericSSF_gsmSCF_PDUs_begin_components,
        _GenericSSF_gsmSCF_PDUs_begin,
        __GenericSSF_gsmSCF_PDUs_end_dtid,
        __GenericSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_end_components__item_,
        __GenericSSF_gsmSCF_PDUs_end_components,
        _GenericSSF_gsmSCF_PDUs_end,
        __GenericSSF_gsmSCF_PDUs_continue__otid,
        __GenericSSF_gsmSCF_PDUs_continue__dtid,
        __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericSSF_gsmSCF_PDUs_continue__components,
        _GenericSSF_gsmSCF_PDUs_continue_,
        _GenericSSF_gsmSCF_PDUs_abort,
        GenericSSF_gsmSCF_PDUs,
        SsfToScfGenericInvokable,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericInvokable_val_ArgumentType_1,
        _SsfToScfGenericInvokable_val_ArgumentType_2,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_3_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_3,
        __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_4_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_4_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_4,
        __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericInvokable_val_ArgumentType_5,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_6_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_6,
        __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_7_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_7,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none,
        __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_8_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_8,
        ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_9_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_9,
        __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_11_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_11,
        __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_12_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_12,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure,
        _SsfToScfGenericInvokable_val_ArgumentType_13,
        __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_scfID,
        ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_14_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_14_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber,
        _SsfToScfGenericInvokable_val_ArgumentType_14,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_15_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_15_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_15,
        _SsfToScfGenericInvokable_val_ArgumentType_16,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_17_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_17_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_17,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_18,
        __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ResultType_18_extensions,
        __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericInvokable_val_ResultType_18,
        __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_19_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_19,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_20,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_21,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timerID,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_22_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_22,
        __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_23_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_23,
        __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_24_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_24,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_25_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_25,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_26_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_26,
        __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_27_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_27,
        __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericInvokable_val_ResultType_27,
        _SsfToScfGenericInvokable_val_ArgumentType_28,
        SsfToScfGenericReturnable,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericReturnable_val_ArgumentType_1,
        _SsfToScfGenericReturnable_val_ArgumentType_2,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators,
        __SsfToScfGenericReturnable_val_ArgumentType_3_controlType,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_3_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_3,
        __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_4_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_4_legID,
        _SsfToScfGenericReturnable_val_ArgumentType_4,
        __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericReturnable_val_ArgumentType_5,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_6_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_6,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_7_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_7,
        ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_8_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_8,
        __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_10_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_10,
        __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_12_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_12,
        __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased,
        __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause,
        ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_13_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_13,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure,
        _SsfToScfGenericReturnable_val_ArgumentType_14,
        __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_15_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_15_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        _SsfToScfGenericReturnable_val_ArgumentType_15,
        _SsfToScfGenericReturnable_val_ArgumentType_16,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_17_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_17_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_17,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_18,
        __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ResultType_18_extensions,
        __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericReturnable_val_ResultType_18,
        __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_19_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_19,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_20,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_21,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timerID,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_22_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_22,
        __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_23_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_23,
        __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_24_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_24,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_25_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_25,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_26_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_26,
        __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_27_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_27,
        __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericReturnable_val_ResultType_27,
        assistHandoff_gsmSSF_scfAbstractSyntax,
        _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components,
        _AssistHandoffsSF_gsmSCF_PDUs_unidirectional,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_otid,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_components,
        _AssistHandoffsSF_gsmSCF_PDUs_begin,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_end_components,
        _AssistHandoffsSF_gsmSCF_PDUs_end,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__otid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__components,
        _AssistHandoffsSF_gsmSCF_PDUs_continue_,
        _AssistHandoffsSF_gsmSCF_PDUs_abort,
        AssistHandoffsSF_gsmSCF_PDUs,
        AssistHandoffssfToScfInvokable,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_1,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_2,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_3,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_5,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_6,
        __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfInvokable_val_ResultType_6,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_7,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_8,
        AssistHandoffssfToScfReturnable,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_1,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_2,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_3,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_5,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_6,
        __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfReturnable_val_ResultType_6,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_7,
        scf_gsmSSFGenericAbstractSyntax,
        _scf_gsmSSFGenericAbstractSyntax_val_Type,
        __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_,
        __GenericSCF_gsmSSF_PDUs_unidirectional_components,
        _GenericSCF_gsmSSF_PDUs_unidirectional,
        __GenericSCF_gsmSSF_PDUs_begin_otid,
        __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_begin_components__item_,
        __GenericSCF_gsmSSF_PDUs_begin_components,
        _GenericSCF_gsmSSF_PDUs_begin,
        __GenericSCF_gsmSSF_PDUs_end_dtid,
        __GenericSCF_gsmSSF_PDUs_end_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_end_components__item_,
        __GenericSCF_gsmSSF_PDUs_end_components,
        _GenericSCF_gsmSSF_PDUs_end,
        __GenericSCF_gsmSSF_PDUs_continue__otid,
        __GenericSCF_gsmSSF_PDUs_continue__dtid,
        __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_continue__components__item_,
        __GenericSCF_gsmSSF_PDUs_continue__components,
        _GenericSCF_gsmSSF_PDUs_continue_,
        _GenericSCF_gsmSSF_PDUs_abort,
        GenericSCF_gsmSSF_PDUs,
        ScfToSsfGenericInvokable,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericInvokable_val_ArgumentType_1,
        _ScfToSsfGenericInvokable_val_ArgumentType_2,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList,
        ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_legID,
        _ScfToSsfGenericInvokable_val_ArgumentType_3,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel,
        _ScfToSsfGenericInvokable_val_ArgumentType_4,
        ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_5,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_6,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_7,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_9,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_11,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_12,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber,
        _ScfToSsfGenericInvokable_val_ArgumentType_13,
        _ScfToSsfGenericInvokable_val_ArgumentType_14,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_15,
        __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ResultType_15_extensions,
        __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericInvokable_val_ResultType_15,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_16,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_17,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_18,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_19,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue,
        ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_20,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_21,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment,
        ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_22,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_23,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_24,
        __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse,
        _ScfToSsfGenericInvokable_val_ResultType_24,
        ScfToSsfGenericReturnable,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericReturnable_val_ArgumentType_1,
        _ScfToSsfGenericReturnable_val_ArgumentType_2,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_3,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_4,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _ScfToSsfGenericReturnable_val_ArgumentType_5,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_6,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_7,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_9,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_10,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure,
        _ScfToSsfGenericReturnable_val_ArgumentType_11,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber,
        _ScfToSsfGenericReturnable_val_ArgumentType_12,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_13,
        _ScfToSsfGenericReturnable_val_ArgumentType_14,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_15,
        __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ResultType_15_extensions,
        __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericReturnable_val_ResultType_15,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_16,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_17,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_18,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_19,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment,
        ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_20,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_21,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_22,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_23,
        __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse,
        _ScfToSsfGenericReturnable_val_ResultType_23,
        _ScfToSsfGenericReturnable_val_ArgumentType_24,
    ]

class CAP_gsmSCF_gsmSRF_ops_args:

    _name_  = 'CAP-gsmSCF-gsmSRF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 103, 7]
    
    _obj_ = [
        'playAnnouncement',
        'PlayAnnouncementArg',
        'promptAndCollectUserInformation',
        'PromptAndCollectUserInformationArg',
        'ReceivedInformationArg',
        'specializedResourceReport',
        'SpecializedResourceReportArg',
        ]
    _type_ = [
        'PlayAnnouncementArg',
        'PromptAndCollectUserInformationArg',
        'ReceivedInformationArg',
        'SpecializedResourceReportArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'playAnnouncement',
        'promptAndCollectUserInformation',
        'specializedResourceReport',
        ]
    _class_ = [
        'playAnnouncement',
        'promptAndCollectUserInformation',
        'specializedResourceReport',
        ]
    _param_ = [
        'playAnnouncement',
        'PlayAnnouncementArg',
        'promptAndCollectUserInformation',
        'PromptAndCollectUserInformationArg',
        'ReceivedInformationArg',
        ]
    
    #-----< playAnnouncement >-----#
    playAnnouncement = CLASS(name='playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayAnnouncementArg >-----#
    PlayAnnouncementArg = SEQ(name='PlayAnnouncementArg', mode=MODE_TYPE, param=True)
    
    #-----< promptAndCollectUserInformation >-----#
    promptAndCollectUserInformation = CLASS(name='promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PromptAndCollectUserInformationArg >-----#
    PromptAndCollectUserInformationArg = SEQ(name='PromptAndCollectUserInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< ReceivedInformationArg >-----#
    ReceivedInformationArg = CHOICE(name='ReceivedInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< specializedResourceReport >-----#
    specializedResourceReport = CLASS(name='specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _specializedResourceReport_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    specializedResourceReport._val = dict([('ArgumentType', _specializedResourceReport_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])
    
    #-----< SpecializedResourceReportArg >-----#
    SpecializedResourceReportArg = CHOICE(name='SpecializedResourceReportArg', mode=MODE_TYPE)
    _SpecializedResourceReportArg_allAnnouncementsComplete = NULL(name='allAnnouncementsComplete', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SpecializedResourceReportArg_firstAnnouncementStarted = NULL(name='firstAnnouncementStarted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SpecializedResourceReportArg._cont = ASN1Dict([
        ('allAnnouncementsComplete', _SpecializedResourceReportArg_allAnnouncementsComplete),
        ('firstAnnouncementStarted', _SpecializedResourceReportArg_firstAnnouncementStarted),
        ])
    SpecializedResourceReportArg._ext = None
    
    _all_ = [
        specializedResourceReport,
        _specializedResourceReport_val_ArgumentType,
        _SpecializedResourceReportArg_allAnnouncementsComplete,
        _SpecializedResourceReportArg_firstAnnouncementStarted,
        SpecializedResourceReportArg,
    ]

class CAP_gsmSCF_gsmSRF_pkgs_contracts_acs:

    _name_  = 'CAP-gsmSCF-gsmSRF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 104, 7]
    
    _obj_ = [
        'gsmSRF-gsmSCF-ac',
        'gsmSRF-gsmSCF-contract',
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        'activityTestPackage',
        'gsmSRF-gsmSCF-abstract-syntax',
        'BASIC-gsmSRF-gsmSCF-PDUs',
        'GsmSRFgsmSCFInvokable',
        'GsmSRFgsmSCFReturnable',
        ]
    _type_ = [
        'BASIC-gsmSRF-gsmSCF-PDUs',
        ]
    _set_ = [
        'GsmSRFgsmSCFInvokable',
        'GsmSRFgsmSCFReturnable',
        ]
    _val_ = [
        'gsmSRF-gsmSCF-ac',
        'gsmSRF-gsmSCF-contract',
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        'activityTestPackage',
        'gsmSRF-gsmSCF-abstract-syntax',
        ]
    _class_ = [
        'gsmSRF-gsmSCF-ac',
        'gsmSRF-gsmSCF-contract',
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        'activityTestPackage',
        'gsmSRF-gsmSCF-abstract-syntax',
        'GsmSRFgsmSCFInvokable',
        'GsmSRFgsmSCFReturnable',
        ]
    _param_ = [
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        ]
    
    #-----< gsmSRF-gsmSCF-ac >-----#
    gsmSRF_gsmSCF_ac = CLASS(name='gsmSRF-gsmSCF-ac', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID),
        ('iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration),
        ('interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo),
        ('tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        ('collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_collectedInfo),
        ('disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_disconnectFromIPForbidden),
        ('informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions),
        ('callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID),
        ('requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._cont = ASN1Dict([
        ('digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID),
        ('callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        ('invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_invokeID),
        ('allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_allRequests),
        ('callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name='ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        ('operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_ac._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 13))])), ('dialogueMode', 'structured'), ('termination', 'basic'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 22, 3, 14))])
    
    #-----< gsmSRF-gsmSCF-contract >-----#
    gsmSRF_gsmSCF_contract = CLASS(name='gsmSRF-gsmSCF-contract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    gsmSRF_gsmSCF_contract._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), ('ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 13))])
    
    #-----< specializedResourceControlPackage >-----#
    specializedResourceControlPackage = CLASS(name='specializedResourceControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfCancelPackage >-----#
    gsmSRF_scfCancelPackage = CLASS(name='gsmSRF-scfCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name='activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< gsmSRF-gsmSCF-abstract-syntax >-----#
    gsmSRF_gsmSCF_abstract_syntax = CLASS(name='gsmSRF-gsmSCF-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gsmSRF_gsmSCF_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_abstract_syntax._val = dict([('Type', _gsmSRF_gsmSCF_abstract_syntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])
    
    #-----< BASIC-gsmSRF-gsmSCF-PDUs >-----#
    BASIC_gsmSRF_gsmSCF_PDUs = CHOICE(name='BASIC-gsmSRF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend),
        ('extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ('callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('ResultType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend),
        ('extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        ('callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('ResultType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        ('problem', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        ('operation', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_begin_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_end_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid),
        ('dtid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_continue__components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    BASIC_gsmSRF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional),
        ('begin', _BASIC_gsmSRF_gsmSCF_PDUs_begin),
        ('end', _BASIC_gsmSRF_gsmSCF_PDUs_end),
        ('continue', _BASIC_gsmSRF_gsmSCF_PDUs_continue_),
        ('abort', _BASIC_gsmSRF_gsmSCF_PDUs_abort),
        ])
    BASIC_gsmSRF_gsmSCF_PDUs._ext = None
    
    #-----< GsmSRFgsmSCFInvokable >-----#
    GsmSRFgsmSCFInvokable = CLASS(name='GsmSRFgsmSCFInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID),
        ('allRequests', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions),
        ('callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend),
        ('extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions),
        ('callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFInvokable_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    GsmSRFgsmSCFInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_4), ('ResultType', _GsmSRFgsmSCFInvokable_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_5), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    #-----< GsmSRFgsmSCFReturnable >-----#
    GsmSRFgsmSCFReturnable = CLASS(name='GsmSRFgsmSCFReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID),
        ('allRequests', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions),
        ('callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend),
        ('extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions),
        ('callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFReturnable_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._ext = None
    GsmSRFgsmSCFReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_4), ('ResultType', _GsmSRFgsmSCFReturnable_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    
    _all_ = [
        gsmSRF_gsmSCF_ac,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_3_0,
        __OPERATION_Errors_val_ParameterType_4,
        __OPERATION_Linked_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1,
        gsmSRF_gsmSCF_contract,
        activityTestPackage,
        gsmSRF_gsmSCF_abstract_syntax,
        _gsmSRF_gsmSCF_abstract_syntax_val_Type,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_begin,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_end,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__components,
        _BASIC_gsmSRF_gsmSCF_PDUs_continue_,
        _BASIC_gsmSRF_gsmSCF_PDUs_abort,
        BASIC_gsmSRF_gsmSCF_PDUs,
        GsmSRFgsmSCFInvokable,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_1,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_2,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_3,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_4,
        __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFInvokable_val_ResultType_4,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_5,
        GsmSRFgsmSCFReturnable,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_1,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_2,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_3,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_4,
        __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFReturnable_val_ResultType_4,
    ]

class CAP_SMS_ops_args:

    _name_  = 'CAP-SMS-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 105, 7]
    
    _obj_ = [
        'connectSMS',
        'ConnectSMSArg',
        'continueSMS',
        'eventReportSMS',
        'EventReportSMSArg',
        'furnishChargingInformationSMS',
        'FurnishChargingInformationSMSArg',
        'initialDPSMS',
        'InitialDPSMSArg',
        'releaseSMS',
        'ReleaseSMSArg',
        'requestReportSMSEvent',
        'RequestReportSMSEventArg',
        'resetTimerSMS',
        'ResetTimerSMSArg',
        ]
    _type_ = [
        'ConnectSMSArg',
        'EventReportSMSArg',
        'FurnishChargingInformationSMSArg',
        'InitialDPSMSArg',
        'ReleaseSMSArg',
        'RequestReportSMSEventArg',
        'ResetTimerSMSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'connectSMS',
        'continueSMS',
        'eventReportSMS',
        'furnishChargingInformationSMS',
        'initialDPSMS',
        'releaseSMS',
        'requestReportSMSEvent',
        'resetTimerSMS',
        ]
    _class_ = [
        'connectSMS',
        'continueSMS',
        'eventReportSMS',
        'furnishChargingInformationSMS',
        'initialDPSMS',
        'releaseSMS',
        'requestReportSMSEvent',
        'resetTimerSMS',
        ]
    _param_ = [
        'connectSMS',
        'ConnectSMSArg',
        'eventReportSMS',
        'EventReportSMSArg',
        'furnishChargingInformationSMS',
        'FurnishChargingInformationSMSArg',
        'initialDPSMS',
        'InitialDPSMSArg',
        'requestReportSMSEvent',
        'RequestReportSMSEventArg',
        'resetTimerSMS',
        'ResetTimerSMSArg',
        ]
    
    #-----< connectSMS >-----#
    connectSMS = CLASS(name='connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectSMSArg >-----#
    ConnectSMSArg = SEQ(name='ConnectSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueSMS >-----#
    continueSMS = CLASS(name='continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continueSMS._val = dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])
    
    #-----< eventReportSMS >-----#
    eventReportSMS = CLASS(name='eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportSMSArg >-----#
    EventReportSMSArg = SEQ(name='EventReportSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationSMS >-----#
    furnishChargingInformationSMS = CLASS(name='furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationSMSArg >-----#
    FurnishChargingInformationSMSArg = OCT_STR(name='FurnishChargingInformationSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCISMSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPSMS >-----#
    initialDPSMS = CLASS(name='initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPSMSArg >-----#
    InitialDPSMSArg = SEQ(name='InitialDPSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseSMS >-----#
    releaseSMS = CLASS(name='releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _releaseSMS_val_ArgumentType = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    releaseSMS._val = dict([('ArgumentType', _releaseSMS_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])
    
    #-----< ReleaseSMSArg >-----#
    ReleaseSMSArg = OCT_STR(name='ReleaseSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RPCause')))
    
    #-----< requestReportSMSEvent >-----#
    requestReportSMSEvent = CLASS(name='requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportSMSEventArg >-----#
    RequestReportSMSEventArg = SEQ(name='RequestReportSMSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerSMS >-----#
    resetTimerSMS = CLASS(name='resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerSMSArg >-----#
    ResetTimerSMSArg = SEQ(name='ResetTimerSMSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        continueSMS,
        releaseSMS,
        _releaseSMS_val_ArgumentType,
        ReleaseSMSArg,
    ]

class CAP_smsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = 'CAP-smsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 106, 7]
    
    _obj_ = [
        'cap3-sms-AC',
        'cap4-sms-AC',
        'cap3SMS',
        'cap4SMS',
        'smsActivationPackage',
        'smsConnectPackage',
        'smsProcessingPackage',
        'smsReleasePackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        'sms-AbstractSyntax',
        'Generic-sms-PDUs',
        'SmsInvokable',
        'SmsReturnable',
        ]
    _type_ = [
        'Generic-sms-PDUs',
        ]
    _set_ = [
        'SmsInvokable',
        'SmsReturnable',
        ]
    _val_ = [
        'cap3-sms-AC',
        'cap4-sms-AC',
        'cap3SMS',
        'cap4SMS',
        'smsActivationPackage',
        'smsConnectPackage',
        'smsProcessingPackage',
        'smsReleasePackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        'sms-AbstractSyntax',
        ]
    _class_ = [
        'cap3-sms-AC',
        'cap4-sms-AC',
        'cap3SMS',
        'cap4SMS',
        'smsActivationPackage',
        'smsConnectPackage',
        'smsProcessingPackage',
        'smsReleasePackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        'sms-AbstractSyntax',
        'SmsInvokable',
        'SmsReturnable',
        ]
    _param_ = [
        'smsActivationPackage',
        'smsConnectPackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        ]
    
    #-----< cap3-sms-AC >-----#
    cap3_sms_AC = CLASS(name='cap3-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callingPartyNumber),
        ('eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_eventTypeSMS),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI),
        ('locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationMSC),
        ('locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sMSCAddress),
        ('timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone),
        ('tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPProtocolIdentifier),
        ('tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPDataCodingScheme),
        ('tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPValidityPeriod),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions),
        ('smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_smsReferenceNumber),
        ('mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mscAddress),
        ('sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sgsn_Number),
        ('ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_ms_Classmark2),
        ('gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass),
        ('iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI),
        ('calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysNumber),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_sMSCAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeSMS),
        ('eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationSMS),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    cap3_sms_AC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 20, 26, 16))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 21, 3, 61))])
    
    #-----< cap4-sms-AC >-----#
    cap4_sms_AC = CLASS(name='cap4-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_serviceKey),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber),
        ('callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_callingPartyNumber),
        ('eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_eventTypeSMS),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMSI),
        ('locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationMSC),
        ('locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationGPRS),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sMSCAddress),
        ('timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone),
        ('tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier),
        ('tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPDataCodingScheme),
        ('tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPValidityPeriod),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions),
        ('smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_smsReferenceNumber),
        ('mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_mscAddress),
        ('sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sgsn_Number),
        ('ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_ms_Classmark2),
        ('gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gPRSMSClass),
        ('iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMEI),
        ('calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callingPartysNumber),
        ('destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber),
        ('sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_sMSCAddress),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        ('sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        ('eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventTypeSMS),
        ('eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS),
        ('miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_miscCallInfo),
        ('extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        ('timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timerID),
        ('timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timervalue),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    cap4_sms_AC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 16))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 61))])
    
    #-----< cap3SMS >-----#
    cap3SMS = CLASS(name='cap3SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap3SMS._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 20, 26, 16))])
    
    #-----< cap4SMS >-----#
    cap4SMS = CLASS(name='cap4SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap4SMS._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 16))])
    
    #-----< smsActivationPackage >-----#
    smsActivationPackage = CLASS(name='smsActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsConnectPackage >-----#
    smsConnectPackage = CLASS(name='smsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsProcessingPackage >-----#
    smsProcessingPackage = CLASS(name='smsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsProcessingPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])
    
    #-----< smsReleasePackage >-----#
    smsReleasePackage = CLASS(name='smsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsReleasePackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))])
    
    #-----< smsEventHandlingPackage >-----#
    smsEventHandlingPackage = CLASS(name='smsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsBillingPackage >-----#
    smsBillingPackage = CLASS(name='smsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsTimerPackage >-----#
    smsTimerPackage = CLASS(name='smsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< sms-AbstractSyntax >-----#
    sms_AbstractSyntax = CLASS(name='sms-AbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _sms_AbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    sms_AbstractSyntax._val = dict([('Type', _sms_AbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])
    
    #-----< Generic-sms-PDUs >-----#
    Generic_sms_PDUs = CHOICE(name='Generic-sms-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _Generic_sms_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __Generic_sms_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___Generic_sms_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS),
        ('eventSpecificInformationSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS),
        ('miscCallInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('sMSEvents', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('timerID', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID),
        ('timervalue', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('sMSEvents', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('timerID', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID),
        ('timervalue', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 6))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_unidirectional_components__item_._ext = None
    __Generic_sms_PDUs_unidirectional_components._cont = ___Generic_sms_PDUs_unidirectional_components__item_
    __Generic_sms_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __Generic_sms_PDUs_unidirectional_dialoguePortion),
        ('components', __Generic_sms_PDUs_unidirectional_components),
        ])
    _Generic_sms_PDUs_unidirectional._ext = None
    _Generic_sms_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __Generic_sms_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_begin_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_begin_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_begin_components__item_._ext = None
    __Generic_sms_PDUs_begin_components._cont = ___Generic_sms_PDUs_begin_components__item_
    __Generic_sms_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_begin._cont = ASN1Dict([
        ('otid', __Generic_sms_PDUs_begin_otid),
        ('dialoguePortion', __Generic_sms_PDUs_begin_dialoguePortion),
        ('components', __Generic_sms_PDUs_begin_components),
        ])
    _Generic_sms_PDUs_begin._ext = None
    _Generic_sms_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __Generic_sms_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_end_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_end_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_end_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_end_components__item_._ext = None
    __Generic_sms_PDUs_end_components._cont = ___Generic_sms_PDUs_end_components__item_
    __Generic_sms_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_end._cont = ASN1Dict([
        ('dtid', __Generic_sms_PDUs_end_dtid),
        ('dialoguePortion', __Generic_sms_PDUs_end_dialoguePortion),
        ('components', __Generic_sms_PDUs_end_components),
        ])
    _Generic_sms_PDUs_end._ext = None
    _Generic_sms_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __Generic_sms_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_continue__components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_continue__components__item__basicROS._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_continue__components__item_._ext = None
    __Generic_sms_PDUs_continue__components._cont = ___Generic_sms_PDUs_continue__components__item_
    __Generic_sms_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_continue_._cont = ASN1Dict([
        ('otid', __Generic_sms_PDUs_continue__otid),
        ('dtid', __Generic_sms_PDUs_continue__dtid),
        ('dialoguePortion', __Generic_sms_PDUs_continue__dialoguePortion),
        ('components', __Generic_sms_PDUs_continue__components),
        ])
    _Generic_sms_PDUs_continue_._ext = None
    _Generic_sms_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    Generic_sms_PDUs._cont = ASN1Dict([
        ('unidirectional', _Generic_sms_PDUs_unidirectional),
        ('begin', _Generic_sms_PDUs_begin),
        ('end', _Generic_sms_PDUs_end),
        ('continue', _Generic_sms_PDUs_continue_),
        ('abort', _Generic_sms_PDUs_abort),
        ])
    Generic_sms_PDUs._ext = None
    
    #-----< SmsInvokable >-----#
    SmsInvokable = CLASS(name='SmsInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsInvokable_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsInvokable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_0_extensions._cont = ___SmsInvokable_val_ArgumentType_0_extensions__item_
    __SmsInvokable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', __SmsInvokable_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', __SmsInvokable_val_ArgumentType_0_sMSCAddress),
        ('extensions', __SmsInvokable_val_ArgumentType_0_extensions),
        ])
    _SmsInvokable_val_ArgumentType_0._ext = []
    _SmsInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    __SmsInvokable_val_ArgumentType_1_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_1_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __SmsInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_1_extensions._cont = ___SmsInvokable_val_ArgumentType_1_extensions__item_
    __SmsInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('eventTypeSMS', __SmsInvokable_val_ArgumentType_1_eventTypeSMS),
        ('eventSpecificInformationSMS', __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS),
        ('miscCallInfo', __SmsInvokable_val_ArgumentType_1_miscCallInfo),
        ('extensions', __SmsInvokable_val_ArgumentType_1_extensions),
        ])
    _SmsInvokable_val_ArgumentType_1._ext = []
    _SmsInvokable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsInvokable_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_3_extensions._cont = ___SmsInvokable_val_ArgumentType_3_extensions__item_
    __SmsInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsInvokable_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', __SmsInvokable_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', __SmsInvokable_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', __SmsInvokable_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', __SmsInvokable_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', __SmsInvokable_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', __SmsInvokable_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', __SmsInvokable_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', __SmsInvokable_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', __SmsInvokable_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', __SmsInvokable_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', __SmsInvokable_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', __SmsInvokable_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', __SmsInvokable_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', __SmsInvokable_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', __SmsInvokable_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', __SmsInvokable_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', __SmsInvokable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsInvokable_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _SmsInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents._cont = ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_
    __SmsInvokable_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_4_extensions._cont = ___SmsInvokable_val_ArgumentType_4_extensions__item_
    __SmsInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('sMSEvents', __SmsInvokable_val_ArgumentType_4_sMSEvents),
        ('extensions', __SmsInvokable_val_ArgumentType_4_extensions),
        ])
    _SmsInvokable_val_ArgumentType_4._ext = []
    _SmsInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsInvokable_val_ArgumentType_5_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SmsInvokable_val_ArgumentType_5_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsInvokable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_5_extensions._cont = ___SmsInvokable_val_ArgumentType_5_extensions__item_
    __SmsInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('timerID', __SmsInvokable_val_ArgumentType_5_timerID),
        ('timervalue', __SmsInvokable_val_ArgumentType_5_timervalue),
        ('extensions', __SmsInvokable_val_ArgumentType_5_extensions),
        ])
    _SmsInvokable_val_ArgumentType_5._ext = []
    SmsInvokable._val = ASN1Set(rv=[dict([('ArgumentType', _SmsInvokable_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    
    #-----< SmsReturnable >-----#
    SmsReturnable = CLASS(name='SmsReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsReturnable_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsReturnable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_0_extensions._cont = ___SmsReturnable_val_ArgumentType_0_extensions__item_
    __SmsReturnable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', __SmsReturnable_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', __SmsReturnable_val_ArgumentType_0_sMSCAddress),
        ('extensions', __SmsReturnable_val_ArgumentType_0_extensions),
        ])
    _SmsReturnable_val_ArgumentType_0._ext = []
    _SmsReturnable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsReturnable_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_3_extensions._cont = ___SmsReturnable_val_ArgumentType_3_extensions__item_
    __SmsReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsReturnable_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', __SmsReturnable_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', __SmsReturnable_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', __SmsReturnable_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', __SmsReturnable_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', __SmsReturnable_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', __SmsReturnable_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', __SmsReturnable_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', __SmsReturnable_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', __SmsReturnable_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', __SmsReturnable_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', __SmsReturnable_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', __SmsReturnable_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', __SmsReturnable_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', __SmsReturnable_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', __SmsReturnable_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', __SmsReturnable_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', __SmsReturnable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsReturnable_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _SmsReturnable_val_ArgumentType_4 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _SmsReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents._cont = ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_
    __SmsReturnable_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_5_extensions._cont = ___SmsReturnable_val_ArgumentType_5_extensions__item_
    __SmsReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('sMSEvents', __SmsReturnable_val_ArgumentType_5_sMSEvents),
        ('extensions', __SmsReturnable_val_ArgumentType_5_extensions),
        ])
    _SmsReturnable_val_ArgumentType_5._ext = []
    _SmsReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsReturnable_val_ArgumentType_6_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SmsReturnable_val_ArgumentType_6_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_6_extensions._cont = ___SmsReturnable_val_ArgumentType_6_extensions__item_
    __SmsReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('timerID', __SmsReturnable_val_ArgumentType_6_timerID),
        ('timervalue', __SmsReturnable_val_ArgumentType_6_timervalue),
        ('extensions', __SmsReturnable_val_ArgumentType_6_extensions),
        ])
    _SmsReturnable_val_ArgumentType_6._ext = []
    SmsReturnable._val = ASN1Set(rv=[dict([('ArgumentType', _SmsReturnable_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap3_sms_AC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_Errors_val_ParameterType_2_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        __OPERATION_Errors_val_ParameterType_1,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1,
        cap4_sms_AC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        cap3SMS,
        cap4SMS,
        smsProcessingPackage,
        smsReleasePackage,
        sms_AbstractSyntax,
        _sms_AbstractSyntax_val_Type,
        __Generic_sms_PDUs_unidirectional_dialoguePortion,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject,
        ____Generic_sms_PDUs_unidirectional_components__item__basicROS,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_unidirectional_components__item_,
        __Generic_sms_PDUs_unidirectional_components,
        _Generic_sms_PDUs_unidirectional,
        __Generic_sms_PDUs_begin_otid,
        __Generic_sms_PDUs_begin_dialoguePortion,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_begin_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_begin_components__item__basicROS_reject,
        ____Generic_sms_PDUs_begin_components__item__basicROS,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_begin_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_begin_components__item_,
        __Generic_sms_PDUs_begin_components,
        _Generic_sms_PDUs_begin,
        __Generic_sms_PDUs_end_dtid,
        __Generic_sms_PDUs_end_dialoguePortion,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_end_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_end_components__item__basicROS_reject,
        ____Generic_sms_PDUs_end_components__item__basicROS,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_end_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_end_components__item_,
        __Generic_sms_PDUs_end_components,
        _Generic_sms_PDUs_end,
        __Generic_sms_PDUs_continue__otid,
        __Generic_sms_PDUs_continue__dtid,
        __Generic_sms_PDUs_continue__dialoguePortion,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_continue__components__item__basicROS_invoke,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnError,
        _____Generic_sms_PDUs_continue__components__item__basicROS_reject,
        ____Generic_sms_PDUs_continue__components__item__basicROS,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_continue__components__item__returnResultNotLast,
        ___Generic_sms_PDUs_continue__components__item_,
        __Generic_sms_PDUs_continue__components,
        _Generic_sms_PDUs_continue_,
        _Generic_sms_PDUs_abort,
        Generic_sms_PDUs,
        SmsInvokable,
        __SmsInvokable_val_ArgumentType_0_callingPartysNumber,
        __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_0_sMSCAddress,
        ___SmsInvokable_val_ArgumentType_0_extensions__item_,
        __SmsInvokable_val_ArgumentType_0_extensions,
        _SmsInvokable_val_ArgumentType_0,
        __SmsInvokable_val_ArgumentType_1_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS,
        __SmsInvokable_val_ArgumentType_1_miscCallInfo,
        ___SmsInvokable_val_ArgumentType_1_extensions__item_,
        __SmsInvokable_val_ArgumentType_1_extensions,
        _SmsInvokable_val_ArgumentType_1,
        _SmsInvokable_val_ArgumentType_2,
        __SmsInvokable_val_ArgumentType_3_serviceKey,
        __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_3_callingPartyNumber,
        __SmsInvokable_val_ArgumentType_3_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_3_iMSI,
        __SmsInvokable_val_ArgumentType_3_locationInformationMSC,
        __SmsInvokable_val_ArgumentType_3_locationInformationGPRS,
        __SmsInvokable_val_ArgumentType_3_sMSCAddress,
        __SmsInvokable_val_ArgumentType_3_timeAndTimezone,
        __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsInvokable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsInvokable_val_ArgumentType_3_extensions__item_,
        __SmsInvokable_val_ArgumentType_3_extensions,
        __SmsInvokable_val_ArgumentType_3_smsReferenceNumber,
        __SmsInvokable_val_ArgumentType_3_mscAddress,
        __SmsInvokable_val_ArgumentType_3_sgsn_Number,
        __SmsInvokable_val_ArgumentType_3_ms_Classmark2,
        __SmsInvokable_val_ArgumentType_3_gPRSMSClass,
        __SmsInvokable_val_ArgumentType_3_iMEI,
        __SmsInvokable_val_ArgumentType_3_calledPartyNumber,
        _SmsInvokable_val_ArgumentType_3,
        ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_,
        __SmsInvokable_val_ArgumentType_4_sMSEvents,
        ___SmsInvokable_val_ArgumentType_4_extensions__item_,
        __SmsInvokable_val_ArgumentType_4_extensions,
        _SmsInvokable_val_ArgumentType_4,
        __SmsInvokable_val_ArgumentType_5_timerID,
        __SmsInvokable_val_ArgumentType_5_timervalue,
        ___SmsInvokable_val_ArgumentType_5_extensions__item_,
        __SmsInvokable_val_ArgumentType_5_extensions,
        _SmsInvokable_val_ArgumentType_5,
        SmsReturnable,
        __SmsReturnable_val_ArgumentType_0_callingPartysNumber,
        __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_0_sMSCAddress,
        ___SmsReturnable_val_ArgumentType_0_extensions__item_,
        __SmsReturnable_val_ArgumentType_0_extensions,
        _SmsReturnable_val_ArgumentType_0,
        _SmsReturnable_val_ArgumentType_2,
        __SmsReturnable_val_ArgumentType_3_serviceKey,
        __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_3_callingPartyNumber,
        __SmsReturnable_val_ArgumentType_3_eventTypeSMS,
        __SmsReturnable_val_ArgumentType_3_iMSI,
        __SmsReturnable_val_ArgumentType_3_locationInformationMSC,
        __SmsReturnable_val_ArgumentType_3_locationInformationGPRS,
        __SmsReturnable_val_ArgumentType_3_sMSCAddress,
        __SmsReturnable_val_ArgumentType_3_timeAndTimezone,
        __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsReturnable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsReturnable_val_ArgumentType_3_extensions__item_,
        __SmsReturnable_val_ArgumentType_3_extensions,
        __SmsReturnable_val_ArgumentType_3_smsReferenceNumber,
        __SmsReturnable_val_ArgumentType_3_mscAddress,
        __SmsReturnable_val_ArgumentType_3_sgsn_Number,
        __SmsReturnable_val_ArgumentType_3_ms_Classmark2,
        __SmsReturnable_val_ArgumentType_3_gPRSMSClass,
        __SmsReturnable_val_ArgumentType_3_iMEI,
        __SmsReturnable_val_ArgumentType_3_calledPartyNumber,
        _SmsReturnable_val_ArgumentType_3,
        _SmsReturnable_val_ArgumentType_4,
        ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_,
        __SmsReturnable_val_ArgumentType_5_sMSEvents,
        ___SmsReturnable_val_ArgumentType_5_extensions__item_,
        __SmsReturnable_val_ArgumentType_5_extensions,
        _SmsReturnable_val_ArgumentType_5,
        __SmsReturnable_val_ArgumentType_6_timerID,
        __SmsReturnable_val_ArgumentType_6_timervalue,
        ___SmsReturnable_val_ArgumentType_6_extensions__item_,
        __SmsReturnable_val_ArgumentType_6_extensions,
        _SmsReturnable_val_ArgumentType_6,
    ]

class CAP_gprsSSF_gsmSCF_ops_args:

    _name_  = 'CAP-gprsSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 107, 7]
    
    _obj_ = [
        'activityTestGPRS',
        'applyChargingGPRS',
        'ApplyChargingGPRSArg',
        'applyChargingReportGPRS',
        'ApplyChargingReportGPRSArg',
        'cancelGPRS',
        'CancelGPRSArg',
        'connectGPRS',
        'ConnectGPRSArg',
        'continueGPRS',
        'ContinueGPRSArg',
        'entityReleasedGPRS',
        'EntityReleasedGPRSArg',
        'eventReportGPRS',
        'EventReportGPRSArg',
        'furnishChargingInformationGPRS',
        'FurnishChargingInformationGPRSArg',
        'initialDPGPRS',
        'InitialDPGPRSArg',
        'releaseGPRS',
        'ReleaseGPRSArg',
        'requestReportGPRSEvent',
        'RequestReportGPRSEventArg',
        'resetTimerGPRS',
        'ResetTimerGPRSArg',
        'sendChargingInformationGPRS',
        'SendChargingInformationGPRSArg',
        ]
    _type_ = [
        'ApplyChargingGPRSArg',
        'ApplyChargingReportGPRSArg',
        'CancelGPRSArg',
        'ConnectGPRSArg',
        'ContinueGPRSArg',
        'EntityReleasedGPRSArg',
        'EventReportGPRSArg',
        'FurnishChargingInformationGPRSArg',
        'InitialDPGPRSArg',
        'ReleaseGPRSArg',
        'RequestReportGPRSEventArg',
        'ResetTimerGPRSArg',
        'SendChargingInformationGPRSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'activityTestGPRS',
        'applyChargingGPRS',
        'applyChargingReportGPRS',
        'cancelGPRS',
        'connectGPRS',
        'continueGPRS',
        'entityReleasedGPRS',
        'eventReportGPRS',
        'furnishChargingInformationGPRS',
        'initialDPGPRS',
        'releaseGPRS',
        'requestReportGPRSEvent',
        'resetTimerGPRS',
        'sendChargingInformationGPRS',
        ]
    _class_ = [
        'activityTestGPRS',
        'applyChargingGPRS',
        'applyChargingReportGPRS',
        'cancelGPRS',
        'connectGPRS',
        'continueGPRS',
        'entityReleasedGPRS',
        'eventReportGPRS',
        'furnishChargingInformationGPRS',
        'initialDPGPRS',
        'releaseGPRS',
        'requestReportGPRSEvent',
        'resetTimerGPRS',
        'sendChargingInformationGPRS',
        ]
    _param_ = [
        'connectGPRS',
        'ConnectGPRSArg',
        'entityReleasedGPRS',
        'EntityReleasedGPRSArg',
        'eventReportGPRS',
        'EventReportGPRSArg',
        'furnishChargingInformationGPRS',
        'FurnishChargingInformationGPRSArg',
        'initialDPGPRS',
        'InitialDPGPRSArg',
        'releaseGPRS',
        'ReleaseGPRSArg',
        'requestReportGPRSEvent',
        'RequestReportGPRSEventArg',
        'sendChargingInformationGPRS',
        'SendChargingInformationGPRSArg',
        ]
    
    #-----< activityTestGPRS >-----#
    activityTestGPRS = CLASS(name='activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTestGPRS._val = dict([('returnResult', True), ('operationCode', ('local', 70))])
    
    #-----< applyChargingGPRS >-----#
    applyChargingGPRS = CLASS(name='applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    applyChargingGPRS._val = dict([('ArgumentType', _applyChargingGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])
    
    #-----< ApplyChargingGPRSArg >-----#
    ApplyChargingGPRSArg = SEQ(name='ApplyChargingGPRSArg', mode=MODE_TYPE)
    _ApplyChargingGPRSArg_chargingCharacteristics = CHOICE(name='chargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingCharacteristics')))
    _ApplyChargingGPRSArg_tariffSwitchInterval = INT(name='tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ApplyChargingGPRSArg_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    _ApplyChargingGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ApplyChargingGPRSArg._cont = ASN1Dict([
        ('chargingCharacteristics', _ApplyChargingGPRSArg_chargingCharacteristics),
        ('tariffSwitchInterval', _ApplyChargingGPRSArg_tariffSwitchInterval),
        ('pDPID', _ApplyChargingGPRSArg_pDPID),
        ])
    ApplyChargingGPRSArg._ext = []
    
    #-----< applyChargingReportGPRS >-----#
    applyChargingReportGPRS = CLASS(name='applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingReportGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    applyChargingReportGPRS._val = dict([('ArgumentType', _applyChargingReportGPRS_val_ArgumentType), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])
    
    #-----< ApplyChargingReportGPRSArg >-----#
    ApplyChargingReportGPRSArg = SEQ(name='ApplyChargingReportGPRSArg', mode=MODE_TYPE)
    _ApplyChargingReportGPRSArg_chargingResult = CHOICE(name='chargingResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingResult')))
    _ApplyChargingReportGPRSArg_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _ApplyChargingReportGPRSArg_active = BOOL(name='active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _ApplyChargingReportGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _ApplyChargingReportGPRSArg_chargingRollOver = CHOICE(name='chargingRollOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingRollOver')), opt=True)
    ApplyChargingReportGPRSArg._cont = ASN1Dict([
        ('chargingResult', _ApplyChargingReportGPRSArg_chargingResult),
        ('qualityOfService', _ApplyChargingReportGPRSArg_qualityOfService),
        ('active', _ApplyChargingReportGPRSArg_active),
        ('pDPID', _ApplyChargingReportGPRSArg_pDPID),
        ('chargingRollOver', _ApplyChargingReportGPRSArg_chargingRollOver),
        ])
    ApplyChargingReportGPRSArg._ext = ['chargingRollOver']
    
    #-----< cancelGPRS >-----#
    cancelGPRS = CLASS(name='cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _cancelGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    cancelGPRS._val = dict([('ArgumentType', _cancelGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])
    
    #-----< CancelGPRSArg >-----#
    CancelGPRSArg = SEQ(name='CancelGPRSArg', mode=MODE_TYPE)
    _CancelGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CancelGPRSArg._cont = ASN1Dict([
        ('pDPID', _CancelGPRSArg_pDPID),
        ])
    CancelGPRSArg._ext = []
    
    #-----< connectGPRS >-----#
    connectGPRS = CLASS(name='connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectGPRSArg >-----#
    ConnectGPRSArg = SEQ(name='ConnectGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueGPRS >-----#
    continueGPRS = CLASS(name='continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _continueGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    continueGPRS._val = dict([('ArgumentType', _continueGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])
    
    #-----< ContinueGPRSArg >-----#
    ContinueGPRSArg = SEQ(name='ContinueGPRSArg', mode=MODE_TYPE)
    _ContinueGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ContinueGPRSArg._cont = ASN1Dict([
        ('pDPID', _ContinueGPRSArg_pDPID),
        ])
    ContinueGPRSArg._ext = []
    
    #-----< entityReleasedGPRS >-----#
    entityReleasedGPRS = CLASS(name='entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedGPRSArg >-----#
    EntityReleasedGPRSArg = SEQ(name='EntityReleasedGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportGPRS >-----#
    eventReportGPRS = CLASS(name='eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportGPRSArg >-----#
    EventReportGPRSArg = SEQ(name='EventReportGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationGPRS >-----#
    furnishChargingInformationGPRS = CLASS(name='furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationGPRSArg >-----#
    FurnishChargingInformationGPRSArg = OCT_STR(name='FurnishChargingInformationGPRSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIGPRSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPGPRS >-----#
    initialDPGPRS = CLASS(name='initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPGPRSArg >-----#
    InitialDPGPRSArg = SEQ(name='InitialDPGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseGPRS >-----#
    releaseGPRS = CLASS(name='releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseGPRSArg >-----#
    ReleaseGPRSArg = SEQ(name='ReleaseGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< requestReportGPRSEvent >-----#
    requestReportGPRSEvent = CLASS(name='requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportGPRSEventArg >-----#
    RequestReportGPRSEventArg = SEQ(name='RequestReportGPRSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerGPRS >-----#
    resetTimerGPRS = CLASS(name='resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _resetTimerGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    resetTimerGPRS._val = dict([('ArgumentType', _resetTimerGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])
    
    #-----< ResetTimerGPRSArg >-----#
    ResetTimerGPRSArg = SEQ(name='ResetTimerGPRSArg', mode=MODE_TYPE)
    _ResetTimerGPRSArg_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _ResetTimerGPRSArg_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ResetTimerGPRSArg._cont = ASN1Dict([
        ('timerID', _ResetTimerGPRSArg_timerID),
        ('timervalue', _ResetTimerGPRSArg_timervalue),
        ])
    ResetTimerGPRSArg._ext = []
    
    #-----< sendChargingInformationGPRS >-----#
    sendChargingInformationGPRS = CLASS(name='sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationGPRSArg >-----#
    SendChargingInformationGPRSArg = SEQ(name='SendChargingInformationGPRSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTestGPRS,
        applyChargingGPRS,
        _applyChargingGPRS_val_ArgumentType,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        _ApplyChargingGPRSArg_chargingCharacteristics,
        _ApplyChargingGPRSArg_tariffSwitchInterval,
        _ApplyChargingGPRSArg_pDPID,
        ApplyChargingGPRSArg,
        applyChargingReportGPRS,
        _applyChargingReportGPRS_val_ArgumentType,
        _ApplyChargingReportGPRSArg_chargingResult,
        _ApplyChargingReportGPRSArg_qualityOfService,
        _ApplyChargingReportGPRSArg_active,
        _ApplyChargingReportGPRSArg_pDPID,
        _ApplyChargingReportGPRSArg_chargingRollOver,
        ApplyChargingReportGPRSArg,
        cancelGPRS,
        _cancelGPRS_val_ArgumentType,
        __OPERATION_Errors_val_ParameterType_1,
        _CancelGPRSArg_pDPID,
        CancelGPRSArg,
        continueGPRS,
        _continueGPRS_val_ArgumentType,
        _ContinueGPRSArg_pDPID,
        ContinueGPRSArg,
        resetTimerGPRS,
        _resetTimerGPRS_val_ArgumentType,
        __OPERATION_Errors_val_ParameterType_2,
        _ResetTimerGPRSArg_timerID,
        _ResetTimerGPRSArg_timervalue,
        ResetTimerGPRSArg,
    ]

class CAP_GPRS_ReferenceNumber:

    _name_  = 'CAP-GPRS-ReferenceNumber'
    _oid_   = [0, 4, 0, 0, 1, 3, 111, 7]
    
    _obj_ = [
        'id-CAP-GPRS-ReferenceNumber',
        'cAP-GPRS-ReferenceNumber-Abstract-Syntax',
        'CAP-GPRS-ReferenceNumber',
        ]
    _type_ = [
        'CAP-GPRS-ReferenceNumber',
        ]
    _set_ = [
        ]
    _val_ = [
        'id-CAP-GPRS-ReferenceNumber',
        'cAP-GPRS-ReferenceNumber-Abstract-Syntax',
        ]
    _class_ = [
        'cAP-GPRS-ReferenceNumber-Abstract-Syntax',
        ]
    _param_ = [
        ]
    
    #-----< id-CAP-GPRS-ReferenceNumber >-----#
    id_CAP_GPRS_ReferenceNumber = OID(name='id-CAP-GPRS-ReferenceNumber', mode=MODE_VALUE)
    id_CAP_GPRS_ReferenceNumber._val = (0, 4, 0, 0, 1, 1, 5, 2)
    
    #-----< cAP-GPRS-ReferenceNumber-Abstract-Syntax >-----#
    cAP_GPRS_ReferenceNumber_Abstract_Syntax = CLASS(name='cAP-GPRS-ReferenceNumber-Abstract-Syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _cAP_GPRS_ReferenceNumber_Abstract_Syntax_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-GPRS-ReferenceNumber', 'CAP-GPRS-ReferenceNumber')))
    cAP_GPRS_ReferenceNumber_Abstract_Syntax._val = dict([('Type', _cAP_GPRS_ReferenceNumber_Abstract_Syntax_val_Type), ('id', (0, 4, 0, 0, 1, 1, 5, 2))])
    
    #-----< CAP-GPRS-ReferenceNumber >-----#
    CAP_GPRS_ReferenceNumber = SEQ(name='CAP-GPRS-ReferenceNumber', mode=MODE_TYPE)
    _CAP_GPRS_ReferenceNumber_destinationReference = INT(name='destinationReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    _CAP_GPRS_ReferenceNumber_originationReference = INT(name='originationReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    CAP_GPRS_ReferenceNumber._cont = ASN1Dict([
        ('destinationReference', _CAP_GPRS_ReferenceNumber_destinationReference),
        ('originationReference', _CAP_GPRS_ReferenceNumber_originationReference),
        ])
    CAP_GPRS_ReferenceNumber._ext = None
    
    _all_ = [
        id_CAP_GPRS_ReferenceNumber,
        cAP_GPRS_ReferenceNumber_Abstract_Syntax,
        _cAP_GPRS_ReferenceNumber_Abstract_Syntax_val_Type,
        _CAP_GPRS_ReferenceNumber_destinationReference,
        _CAP_GPRS_ReferenceNumber_originationReference,
        CAP_GPRS_ReferenceNumber,
    ]

class CAP_gprsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = 'CAP-gprsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 108, 7]
    
    _obj_ = [
        'cap-gprssf-scfAC',
        'cap-gsmscf-gprsssfAC',
        'capGprsSsfToScf',
        'capGsmScfToGprsSsf',
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsProcessingPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsTimerPackage',
        'gprsBillingPackage',
        'gprsChargingPackage',
        'gprsChargeAdvicePackage',
        'gprsActivityTestPackage',
        'gprsCancelPackage',
        'gprsSSF-gsmSCFAbstractSyntax',
        'GenericGprsSSF-gsmSCF-PDUs',
        'GprsSsfToGsmScfInvokable',
        'GprsSsfToGsmScfReturnable',
        'gsmSCF-gprsSSFAbstractSyntax',
        'GenericGsmSCF-gprsSSF-PDUs',
        'GsmScfToGprsSsfInvokable',
        'GsmScfToGprsSsfReturnable',
        ]
    _type_ = [
        'GenericGprsSSF-gsmSCF-PDUs',
        'GenericGsmSCF-gprsSSF-PDUs',
        ]
    _set_ = [
        'GprsSsfToGsmScfInvokable',
        'GprsSsfToGsmScfReturnable',
        'GsmScfToGprsSsfInvokable',
        'GsmScfToGprsSsfReturnable',
        ]
    _val_ = [
        'cap-gprssf-scfAC',
        'cap-gsmscf-gprsssfAC',
        'capGprsSsfToScf',
        'capGsmScfToGprsSsf',
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsProcessingPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsTimerPackage',
        'gprsBillingPackage',
        'gprsChargingPackage',
        'gprsChargeAdvicePackage',
        'gprsActivityTestPackage',
        'gprsCancelPackage',
        'gprsSSF-gsmSCFAbstractSyntax',
        'gsmSCF-gprsSSFAbstractSyntax',
        ]
    _class_ = [
        'cap-gprssf-scfAC',
        'cap-gsmscf-gprsssfAC',
        'capGprsSsfToScf',
        'capGsmScfToGprsSsf',
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsProcessingPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsTimerPackage',
        'gprsBillingPackage',
        'gprsChargingPackage',
        'gprsChargeAdvicePackage',
        'gprsActivityTestPackage',
        'gprsCancelPackage',
        'gprsSSF-gsmSCFAbstractSyntax',
        'GprsSsfToGsmScfInvokable',
        'GprsSsfToGsmScfReturnable',
        'gsmSCF-gprsSSFAbstractSyntax',
        'GsmScfToGprsSsfInvokable',
        'GsmScfToGprsSsfReturnable',
        ]
    _param_ = [
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsBillingPackage',
        'gprsChargeAdvicePackage',
        ]
    
    #-----< cap-gprssf-scfAC >-----#
    cap_gprssf_scfAC = CLASS(name='cap-gprssf-scfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey),
        ('gPRSEventType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSEventType),
        ('mSISDN', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mSISDN),
        ('iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI),
        ('timeAndTimeZone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone),
        ('gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass),
        ('endUserAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress),
        ('qualityOfService', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_qualityOfService),
        ('accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName),
        ('routeingAreaIdentity', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_routeingAreaIdentity),
        ('chargingID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_chargingID),
        ('sGSNCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sGSNCapabilities),
        ('locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS),
        ('pDPInitiationType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_pDPInitiationType),
        ('extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions),
        ('gGSNAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gGSNAddress),
        ('secondaryPDP-context', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_secondaryPDP_context),
        ('iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventType),
        ('miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscGPRSInfo),
        ('gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation),
        ('pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('gPRSCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        ('accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName),
        ('pdpID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_pdpID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._cont = ASN1Dict([
        ('gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventType),
        ('miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_miscGPRSInfo),
        ('gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation),
        ('pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._ext = []
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    cap_gprssf_scfAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 14))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 21, 3, 50))])
    
    #-----< cap-gsmscf-gprsssfAC >-----#
    cap_gsmscf_gprsssfAC = CLASS(name='cap-gsmscf-gprsssfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        ('gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        ('gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent),
        ('pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2._cont = ASN1Dict([
        ('gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventType),
        ('miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_miscGPRSInfo),
        ('gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation),
        ('pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._ext = []
    __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    cap_gsmscf_gprsssfAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 15))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 21, 3, 51))])
    
    #-----< capGprsSsfToScf >-----#
    capGprsSsfToScf = CLASS(name='capGprsSsfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGprsSsfToScf._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 14))])
    
    #-----< capGsmScfToGprsSsf >-----#
    capGsmScfToGprsSsf = CLASS(name='capGsmScfToGprsSsf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGsmScfToGprsSsf._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 15))])
    
    #-----< gprsScfActivationPackage >-----#
    gprsScfActivationPackage = CLASS(name='gprsScfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsConnectPackage >-----#
    gprsConnectPackage = CLASS(name='gprsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsProcessingPackage >-----#
    gprsProcessingPackage = CLASS(name='gprsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsProcessingPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))])
    
    #-----< gprsReleasePackage >-----#
    gprsReleasePackage = CLASS(name='gprsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsEventHandlingPackage >-----#
    gprsEventHandlingPackage = CLASS(name='gprsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsExceptionInformationPackage >-----#
    gprsExceptionInformationPackage = CLASS(name='gprsExceptionInformationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsTimerPackage >-----#
    gprsTimerPackage = CLASS(name='gprsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsTimerPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))])
    
    #-----< gprsBillingPackage >-----#
    gprsBillingPackage = CLASS(name='gprsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsChargingPackage >-----#
    gprsChargingPackage = CLASS(name='gprsChargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsChargingPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))])
    
    #-----< gprsChargeAdvicePackage >-----#
    gprsChargeAdvicePackage = CLASS(name='gprsChargeAdvicePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsActivityTestPackage >-----#
    gprsActivityTestPackage = CLASS(name='gprsActivityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsActivityTestPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))])
    
    #-----< gprsCancelPackage >-----#
    gprsCancelPackage = CLASS(name='gprsCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsCancelPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))])
    
    #-----< gprsSSF-gsmSCFAbstractSyntax >-----#
    gprsSSF_gsmSCFAbstractSyntax = CLASS(name='gprsSSF-gsmSCFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gprsSSF_gsmSCFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    gprsSSF_gsmSCFAbstractSyntax._val = dict([('Type', _gprsSSF_gsmSCFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])
    
    #-----< GenericGprsSSF-gsmSCF-PDUs >-----#
    GenericGprsSSF_gsmSCF_PDUs = CHOICE(name='GenericGprsSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName),
        ('pdpID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType),
        ('miscGPRSInfo', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN),
        ('iMSI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService),
        ('accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        ('extensions', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        ('gGSNAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName),
        ('pdpID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause),
        ('pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN),
        ('iMSI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService),
        ('accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        ('extensions', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        ('gGSNAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause),
        ('pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent),
        ('pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 6))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericGprsSSF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_begin._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_end_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericGprsSSF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_end._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._cont = ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericGprsSSF_gsmSCF_PDUs_continue__otid),
        ('dtid', __GenericGprsSSF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGprsSSF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericGprsSSF_gsmSCF_PDUs_unidirectional),
        ('begin', _GenericGprsSSF_gsmSCF_PDUs_begin),
        ('end', _GenericGprsSSF_gsmSCF_PDUs_end),
        ('continue', _GenericGprsSSF_gsmSCF_PDUs_continue_),
        ('abort', _GenericGprsSSF_gsmSCF_PDUs_abort),
        ])
    GenericGprsSSF_gsmSCF_PDUs._ext = None
    
    #-----< GprsSsfToGsmScfInvokable >-----#
    GprsSsfToGsmScfInvokable = CLASS(name='GprsSsfToGsmScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName),
        ('pdpID', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType),
        ('miscGPRSInfo', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo),
        ('gPRSEventSpecificInformation', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN),
        ('iMSI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService),
        ('accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType),
        ('extensions', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions),
        ('gGSNAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GprsSsfToGsmScfReturnable >-----#
    GprsSsfToGsmScfReturnable = CLASS(name='GprsSsfToGsmScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName),
        ('pdpID', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause),
        ('pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN),
        ('iMSI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService),
        ('accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType),
        ('extensions', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions),
        ('gGSNAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause),
        ('pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent),
        ('pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    #-----< gsmSCF-gprsSSFAbstractSyntax >-----#
    gsmSCF_gprsSSFAbstractSyntax = CLASS(name='gsmSCF-gprsSSFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gsmSCF_gprsSSFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    gsmSCF_gprsSSFAbstractSyntax._val = dict([('Type', _gsmSCF_gprsSSFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])
    
    #-----< GenericGsmSCF-gprsSSF-PDUs >-----#
    GenericGsmSCF_gprsSSF_PDUs = CHOICE(name='GenericGsmSCF-gprsSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause),
        ('pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent),
        ('pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause),
        ('pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent),
        ('pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericGsmSCF_gprsSSF_PDUs_begin_otid),
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_begin_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_begin._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_end_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericGsmSCF_gprsSSF_PDUs_end_dtid),
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_end_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_end._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._cont = ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericGsmSCF_gprsSSF_PDUs_continue__otid),
        ('dtid', __GenericGsmSCF_gprsSSF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_continue__components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGsmSCF_gprsSSF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericGsmSCF_gprsSSF_PDUs_unidirectional),
        ('begin', _GenericGsmSCF_gprsSSF_PDUs_begin),
        ('end', _GenericGsmSCF_gprsSSF_PDUs_end),
        ('continue', _GenericGsmSCF_gprsSSF_PDUs_continue_),
        ('abort', _GenericGsmSCF_gprsSSF_PDUs_abort),
        ])
    GenericGsmSCF_gprsSSF_PDUs._ext = None
    
    #-----< GsmScfToGprsSsfInvokable >-----#
    GsmScfToGprsSsfInvokable = CLASS(name='GsmScfToGprsSsfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause),
        ('pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent),
        ('pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GsmScfToGprsSsfReturnable >-----#
    GsmScfToGprsSsfReturnable = CLASS(name='GsmScfToGprsSsfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause),
        ('pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent),
        ('pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap_gprssf_scfAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSEventType,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mSISDN,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_qualityOfService,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_routeingAreaIdentity,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_chargingID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sGSNCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_pDPInitiationType,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gGSNAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_secondaryPDP_context,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_pdpID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        __OPERATION_Errors_val_ParameterType_2_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_0,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1,
        cap_gsmscf_gprsssfAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14,
        __APPLICATION_CONTEXT_AbstractSyntaxes_val_Type_1_0,
        capGprsSsfToScf,
        capGsmScfToGprsSsf,
        gprsProcessingPackage,
        gprsTimerPackage,
        gprsChargingPackage,
        gprsActivityTestPackage,
        gprsCancelPackage,
        gprsSSF_gsmSCFAbstractSyntax,
        _gprsSSF_gsmSCFAbstractSyntax_val_Type,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericGprsSSF_gsmSCF_PDUs_unidirectional,
        __GenericGprsSSF_gsmSCF_PDUs_begin_otid,
        __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_begin_components,
        _GenericGprsSSF_gsmSCF_PDUs_begin,
        __GenericGprsSSF_gsmSCF_PDUs_end_dtid,
        __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_end_components,
        _GenericGprsSSF_gsmSCF_PDUs_end,
        __GenericGprsSSF_gsmSCF_PDUs_continue__otid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dtid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_continue__components,
        _GenericGprsSSF_gsmSCF_PDUs_continue_,
        _GenericGprsSSF_gsmSCF_PDUs_abort,
        GenericGprsSSF_gsmSCF_PDUs,
        GprsSsfToGsmScfInvokable,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_1,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_2,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_3,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_4,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_5,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_6,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_7,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_8,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_9,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_10,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_11,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_12,
        GprsSsfToGsmScfReturnable,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_1,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_2,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_3,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_4,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_5,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_6,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_7,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_8,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_9,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_10,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_11,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_12,
        gsmSCF_gprsSSFAbstractSyntax,
        _gsmSCF_gprsSSFAbstractSyntax_val_Type,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components,
        _GenericGsmSCF_gprsSSF_PDUs_unidirectional,
        __GenericGsmSCF_gprsSSF_PDUs_begin_otid,
        __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_begin_components,
        _GenericGsmSCF_gprsSSF_PDUs_begin,
        __GenericGsmSCF_gprsSSF_PDUs_end_dtid,
        __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_end_components,
        _GenericGsmSCF_gprsSSF_PDUs_end,
        __GenericGsmSCF_gprsSSF_PDUs_continue__otid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dtid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_continue__components,
        _GenericGsmSCF_gprsSSF_PDUs_continue_,
        _GenericGsmSCF_gprsSSF_PDUs_abort,
        GenericGsmSCF_gprsSSF_PDUs,
        GsmScfToGprsSsfInvokable,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_1,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_2,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_3,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_4,
        ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_5,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_6,
        GsmScfToGprsSsfReturnable,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_1,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_2,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_3,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_4,
        ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_5,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_6,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(DialoguePDUs, UnidialoguePDUs, Remote_Operations_Information_Objects, Remote_Operations_Generic_ROS_PDUs, Remote_Operations_Useful_Definitions, TCAPMessages, TC_Notation_Extensions, CS1_DataTypes, CS2_datatypes, MAP_TS_Code, MAP_BS_Code, MAP_SS_Code, MAP_CommonDataTypes, MAP_ExtensionDataTypes, MAP_MS_DataTypes, MAP_OM_DataTypes, MAP_CH_DataTypes, MAP_SS_DataTypes, MAP_ER_DataTypes, CAP_U_ABORT_Data, CAP_object_identifiers, CAP_operationcodes, CAP_errorcodes, CAP_errortypes, CAP_datatypes, CAP_classes, CAP_gsmSSF_gsmSCF_ops_args, CAP_gsmSSF_gsmSCF_pkgs_contracts_acs, CAP_gsmSCF_gsmSRF_ops_args, CAP_gsmSCF_gsmSRF_pkgs_contracts_acs, CAP_SMS_ops_args, CAP_smsSSF_gsmSCF_pkgs_contracts_acs, CAP_gprsSSF_gsmSCF_ops_args, CAP_GPRS_ReferenceNumber, CAP_gprsSSF_gsmSCF_pkgs_contracts_acs, _IMPL_)
