# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class RNA_CommonDataTypes:

    _name_  = 'RNA-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 7, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2), ('outcome', 3)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class RNA_Constants:

    _name_  = 'RNA-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 7, 1, 4]
    
    _obj_ = [
        'id-IurhSetup',
        'id-Connect',
        'id-DirectTransfer',
        'id-Disconnect',
        'id-ConnectionlessTransfer',
        'id-ErrorIndication',
        'id-privateMessage',
        'maxNrOfErrors',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-RNSAP-Message',
        'id-BackoffTimer',
        'id-Senders-HNB-RNL-ID',
        'id-Receivers-HNB-RNL-ID',
        'id-Iurh-Signalling-Context-ID',
        'id-HNB-RNL-ID',
        'id-HNB-Cell-Identifier',
        'id-GlobalRNC-ID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-IurhSetup',
        'id-Connect',
        'id-DirectTransfer',
        'id-Disconnect',
        'id-ConnectionlessTransfer',
        'id-ErrorIndication',
        'id-privateMessage',
        'maxNrOfErrors',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-RNSAP-Message',
        'id-BackoffTimer',
        'id-Senders-HNB-RNL-ID',
        'id-Receivers-HNB-RNL-ID',
        'id-Iurh-Signalling-Context-ID',
        'id-HNB-RNL-ID',
        'id-HNB-Cell-Identifier',
        'id-GlobalRNC-ID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-IurhSetup >-----#
    id_IurhSetup = INT(name='id-IurhSetup', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_IurhSetup._val = 1
    
    #-----< id-Connect >-----#
    id_Connect = INT(name='id-Connect', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_Connect._val = 2
    
    #-----< id-DirectTransfer >-----#
    id_DirectTransfer = INT(name='id-DirectTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_DirectTransfer._val = 3
    
    #-----< id-Disconnect >-----#
    id_Disconnect = INT(name='id-Disconnect', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_Disconnect._val = 4
    
    #-----< id-ConnectionlessTransfer >-----#
    id_ConnectionlessTransfer = INT(name='id-ConnectionlessTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_ConnectionlessTransfer._val = 5
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 6
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 7
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 1
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 2
    
    #-----< id-RNSAP-Message >-----#
    id_RNSAP_Message = INT(name='id-RNSAP-Message', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RNSAP_Message._val = 3
    
    #-----< id-BackoffTimer >-----#
    id_BackoffTimer = INT(name='id-BackoffTimer', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_BackoffTimer._val = 4
    
    #-----< id-Senders-HNB-RNL-ID >-----#
    id_Senders_HNB_RNL_ID = INT(name='id-Senders-HNB-RNL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Senders_HNB_RNL_ID._val = 5
    
    #-----< id-Receivers-HNB-RNL-ID >-----#
    id_Receivers_HNB_RNL_ID = INT(name='id-Receivers-HNB-RNL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Receivers_HNB_RNL_ID._val = 6
    
    #-----< id-Iurh-Signalling-Context-ID >-----#
    id_Iurh_Signalling_Context_ID = INT(name='id-Iurh-Signalling-Context-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Iurh_Signalling_Context_ID._val = 7
    
    #-----< id-HNB-RNL-ID >-----#
    id_HNB_RNL_ID = INT(name='id-HNB-RNL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_RNL_ID._val = 8
    
    #-----< id-HNB-Cell-Identifier >-----#
    id_HNB_Cell_Identifier = INT(name='id-HNB-Cell-Identifier', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_Cell_Identifier._val = 9
    
    #-----< id-GlobalRNC-ID >-----#
    id_GlobalRNC_ID = INT(name='id-GlobalRNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalRNC_ID._val = 10
    
    _all_ = [
        id_IurhSetup,
        id_Connect,
        id_DirectTransfer,
        id_Disconnect,
        id_ConnectionlessTransfer,
        id_ErrorIndication,
        id_privateMessage,
        maxNrOfErrors,
        id_Cause,
        id_CriticalityDiagnostics,
        id_RNSAP_Message,
        id_BackoffTimer,
        id_Senders_HNB_RNL_ID,
        id_Receivers_HNB_RNL_ID,
        id_Iurh_Signalling_Context_ID,
        id_HNB_RNL_ID,
        id_HNB_Cell_Identifier,
        id_GlobalRNC_ID,
    ]

class RNA_Containers:

    _name_  = 'RNA-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 7, 1, 5]
    
    _obj_ = [
        'RNA-PROTOCOL-IES',
        'RNA-PROTOCOL-EXTENSION',
        'RNA-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'RNA-PROTOCOL-IES',
        'RNA-PROTOCOL-EXTENSION',
        'RNA-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'RNA-PROTOCOL-IES',
        'RNA-PROTOCOL-EXTENSION',
        'RNA-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< RNA-PROTOCOL-IES >-----#
    RNA_PROTOCOL_IES = CLASS(name='RNA-PROTOCOL-IES', mode=MODE_TYPE)
    _RNA_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RNA_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Criticality')))
    _RNA_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _RNA_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Presence')))
    RNA_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _RNA_PROTOCOL_IES_id),
        ('criticality', _RNA_PROTOCOL_IES_criticality),
        ('Value', _RNA_PROTOCOL_IES_Value),
        ('presence', _RNA_PROTOCOL_IES_presence),
        ])
    
    #-----< RNA-PROTOCOL-EXTENSION >-----#
    RNA_PROTOCOL_EXTENSION = CLASS(name='RNA-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _RNA_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RNA_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Criticality')))
    _RNA_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _RNA_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Presence')))
    RNA_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _RNA_PROTOCOL_EXTENSION_id),
        ('criticality', _RNA_PROTOCOL_EXTENSION_criticality),
        ('Extension', _RNA_PROTOCOL_EXTENSION_Extension),
        ('presence', _RNA_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< RNA-PRIVATE-IES >-----#
    RNA_PRIVATE_IES = CLASS(name='RNA-PRIVATE-IES', mode=MODE_TYPE)
    _RNA_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'PrivateIE-ID')))
    _RNA_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Criticality')))
    _RNA_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _RNA_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Presence')))
    RNA_PRIVATE_IES._cont = ASN1Dict([
        ('id', _RNA_PRIVATE_IES_id),
        ('criticality', _RNA_PRIVATE_IES_criticality),
        ('Value', _RNA_PRIVATE_IES_Value),
        ('presence', _RNA_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _RNA_PROTOCOL_IES_id,
        _RNA_PROTOCOL_IES_criticality,
        _RNA_PROTOCOL_IES_Value,
        _RNA_PROTOCOL_IES_presence,
        RNA_PROTOCOL_IES,
        _RNA_PROTOCOL_EXTENSION_id,
        _RNA_PROTOCOL_EXTENSION_criticality,
        _RNA_PROTOCOL_EXTENSION_Extension,
        _RNA_PROTOCOL_EXTENSION_presence,
        RNA_PROTOCOL_EXTENSION,
        _RNA_PRIVATE_IES_id,
        _RNA_PRIVATE_IES_criticality,
        _RNA_PRIVATE_IES_Value,
        _RNA_PRIVATE_IES_presence,
        RNA_PRIVATE_IES,
    ]

class RNA_IEs:

    _name_  = 'RNA-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 7, 1, 2]
    
    _obj_ = [
        'BackoffTimer',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CellIdentity',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'HNB-RNL-ID',
        'Extension-HNB-RNL-ID',
        'Extension-HNB-RNL-ID-IE',
        'HNB-Cell-Identifier',
        'HNB-Cell-Identifier-ExtIEs',
        'Iurh-Signalling-Context-ID',
        'PLMN-ID',
        'GlobalRNC-ID',
        'GlobalRNC-ID-ExtIEs',
        'RNSAP-Message',
        'TypeOfError',
        ]
    _type_ = [
        'BackoffTimer',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CellIdentity',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'HNB-RNL-ID',
        'Extension-HNB-RNL-ID',
        'HNB-Cell-Identifier',
        'Iurh-Signalling-Context-ID',
        'PLMN-ID',
        'GlobalRNC-ID',
        'RNSAP-Message',
        'TypeOfError',
        ]
    _set_ = [
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'Extension-HNB-RNL-ID-IE',
        'HNB-Cell-Identifier-ExtIEs',
        'GlobalRNC-ID-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'Extension-HNB-RNL-ID-IE',
        'HNB-Cell-Identifier-ExtIEs',
        'GlobalRNC-ID-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< BackoffTimer >-----#
    BackoffTimer = INT(name='BackoffTimer', mode=MODE_TYPE)
    BackoffTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3600)], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('normal', 0), ('connect-failed', 1), ('network-release', 2), ('unknown-or-already-allocated-Iurh-Context-ID', 3), ('unspecificed', 4), ('peer-RNC-not-available', 5)])
    CauseRadioNetwork._ext = ['peer-RNC-not-available']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('processing-overload', 0), ('hardware-failure', 1), ('o-and-m-intervention', 2), ('unspecified', 3)])
    CauseMisc._ext = []
    
    #-----< CellIdentity >-----#
    CellIdentity = BIT_STR(name='CellIdentity', mode=MODE_TYPE)
    CellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNB-RNL-ID >-----#
    HNB_RNL_ID = CHOICE(name='HNB-RNL-ID', mode=MODE_TYPE)
    _HNB_RNL_ID_hNB_Identity_as_Global_Cell_Identifier = SEQ(name='hNB-Identity-as-Global-Cell-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'HNB-Cell-Identifier')))
    _HNB_RNL_ID_extension_HNB_RNL_ID = SEQ(name='extension-HNB-RNL-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'Extension-HNB-RNL-ID')))
    HNB_RNL_ID._cont = ASN1Dict([
        ('hNB-Identity-as-Global-Cell-Identifier', _HNB_RNL_ID_hNB_Identity_as_Global_Cell_Identifier),
        ('extension-HNB-RNL-ID', _HNB_RNL_ID_extension_HNB_RNL_ID),
        ])
    HNB_RNL_ID._ext = ['extension-HNB-RNL-ID']
    
    #-----< Extension-HNB-RNL-ID >-----#
    Extension_HNB_RNL_ID = SEQ(name='Extension-HNB-RNL-ID', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Single-Container')))
    _Extension_HNB_RNL_ID_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    __Extension_HNB_RNL_ID_id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    ___Extension_HNB_RNL_ID_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'GlobalRNC-ID')))
    __Extension_HNB_RNL_ID_id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', ___Extension_HNB_RNL_ID_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_HNB_RNL_ID_id._const_tab = __Extension_HNB_RNL_ID_id_tab
    _Extension_HNB_RNL_ID_id._const_tab_at = None
    _Extension_HNB_RNL_ID_id._const_tab_id = 'id'
    _Extension_HNB_RNL_ID_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    _Extension_HNB_RNL_ID_criticality._const_tab = __Extension_HNB_RNL_ID_id_tab
    _Extension_HNB_RNL_ID_criticality._const_tab_at = ('..', 'id')
    _Extension_HNB_RNL_ID_criticality._const_tab_id = 'criticality'
    _Extension_HNB_RNL_ID_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    _Extension_HNB_RNL_ID_value._const_tab = __Extension_HNB_RNL_ID_id_tab
    _Extension_HNB_RNL_ID_value._const_tab_at = ('..', 'id')
    _Extension_HNB_RNL_ID_value._const_tab_id = 'Value'
    Extension_HNB_RNL_ID._cont = ASN1Dict([
        ('id', _Extension_HNB_RNL_ID_id),
        ('criticality', _Extension_HNB_RNL_ID_criticality),
        ('value', _Extension_HNB_RNL_ID_value),
        ])
    Extension_HNB_RNL_ID._ext = None
    
    #-----< Extension-HNB-RNL-ID-IE >-----#
    Extension_HNB_RNL_ID_IE = CLASS(name='Extension-HNB-RNL-ID-IE', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _Extension_HNB_RNL_ID_IE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'GlobalRNC-ID')))
    Extension_HNB_RNL_ID_IE._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _Extension_HNB_RNL_ID_IE_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HNB-Cell-Identifier >-----#
    HNB_Cell_Identifier = SEQ(name='HNB-Cell-Identifier', mode=MODE_TYPE)
    _HNB_Cell_Identifier_pLMN_ID = OCT_STR(name='pLMN-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'PLMN-ID')))
    _HNB_Cell_Identifier_cell_ID = BIT_STR(name='cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'CellIdentity')))
    _HNB_Cell_Identifier_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNB_Cell_Identifier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___HNB_Cell_Identifier_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____HNB_Cell_Identifier_iE_Extensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____HNB_Cell_Identifier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Cell_Identifier_iE_Extensions__item__id._const_tab = ____HNB_Cell_Identifier_iE_Extensions__item__id_tab
    ___HNB_Cell_Identifier_iE_Extensions__item__id._const_tab_at = None
    ___HNB_Cell_Identifier_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality._const_tab = ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue._const_tab = ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNB_Cell_Identifier_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNB_Cell_Identifier_iE_Extensions__item__id),
        ('criticality', ___HNB_Cell_Identifier_iE_Extensions__item__criticality),
        ('extensionValue', ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue),
        ])
    __HNB_Cell_Identifier_iE_Extensions__item_._ext = None
    _HNB_Cell_Identifier_iE_Extensions._cont = __HNB_Cell_Identifier_iE_Extensions__item_
    _HNB_Cell_Identifier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNB_Cell_Identifier._cont = ASN1Dict([
        ('pLMN-ID', _HNB_Cell_Identifier_pLMN_ID),
        ('cell-ID', _HNB_Cell_Identifier_cell_ID),
        ('iE-Extensions', _HNB_Cell_Identifier_iE_Extensions),
        ])
    HNB_Cell_Identifier._ext = []
    
    #-----< HNB-Cell-Identifier-ExtIEs >-----#
    HNB_Cell_Identifier_ExtIEs = CLASS(name='HNB-Cell-Identifier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    HNB_Cell_Identifier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Iurh-Signalling-Context-ID >-----#
    Iurh_Signalling_Context_ID = BIT_STR(name='Iurh-Signalling-Context-ID', mode=MODE_TYPE)
    Iurh_Signalling_Context_ID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< PLMN-ID >-----#
    PLMN_ID = OCT_STR(name='PLMN-ID', mode=MODE_TYPE)
    PLMN_ID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< GlobalRNC-ID >-----#
    GlobalRNC_ID = SEQ(name='GlobalRNC-ID', mode=MODE_TYPE)
    _GlobalRNC_ID_pLMN_ID = OCT_STR(name='pLMN-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-IEs', 'PLMN-ID')))
    _GlobalRNC_ID_rnc_ID = INT(name='rnc-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GlobalRNC_ID_rnc_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GlobalRNC_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___GlobalRNC_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____GlobalRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalRNC_ID_iE_Extensions__item__id._const_tab = ____GlobalRNC_ID_iE_Extensions__item__id_tab
    ___GlobalRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalRNC_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalRNC_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalRNC_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____GlobalRNC_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalRNC_ID_iE_Extensions__item__criticality._const_tab = ____GlobalRNC_ID_iE_Extensions__item__criticality_tab
    ___GlobalRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalRNC_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalRNC_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalRNC_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____GlobalRNC_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalRNC_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalRNC_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalRNC_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalRNC_ID_iE_Extensions__item_._ext = None
    _GlobalRNC_ID_iE_Extensions._cont = __GlobalRNC_ID_iE_Extensions__item_
    _GlobalRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalRNC_ID._cont = ASN1Dict([
        ('pLMN-ID', _GlobalRNC_ID_pLMN_ID),
        ('rnc-ID', _GlobalRNC_ID_rnc_ID),
        ('iE-Extensions', _GlobalRNC_ID_iE_Extensions),
        ])
    GlobalRNC_ID._ext = []
    
    #-----< GlobalRNC-ID-ExtIEs >-----#
    GlobalRNC_ID_ExtIEs = CLASS(name='GlobalRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    GlobalRNC_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RNSAP-Message >-----#
    RNSAP_Message = OCT_STR(name='RNSAP-Message', mode=MODE_TYPE)
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    _all_ = [
        BackoffTimer,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseRadioNetwork,
        CauseTransport,
        CauseProtocol,
        CauseMisc,
        CellIdentity,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        CriticalityDiagnostics_ExtIEs,
        _HNB_RNL_ID_hNB_Identity_as_Global_Cell_Identifier,
        _HNB_RNL_ID_extension_HNB_RNL_ID,
        HNB_RNL_ID,
        __Extension_HNB_RNL_ID_id_tab,
        ___Extension_HNB_RNL_ID_id_tab_val_Value_0,
        _Extension_HNB_RNL_ID_id,
        _Extension_HNB_RNL_ID_criticality,
        _Extension_HNB_RNL_ID_value,
        Extension_HNB_RNL_ID,
        Extension_HNB_RNL_ID_IE,
        _Extension_HNB_RNL_ID_IE_val_Value_0,
        _HNB_Cell_Identifier_pLMN_ID,
        _HNB_Cell_Identifier_cell_ID,
        ____HNB_Cell_Identifier_iE_Extensions__item__id_tab,
        ___HNB_Cell_Identifier_iE_Extensions__item__id,
        ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab,
        ___HNB_Cell_Identifier_iE_Extensions__item__criticality,
        ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab,
        ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue,
        __HNB_Cell_Identifier_iE_Extensions__item_,
        _HNB_Cell_Identifier_iE_Extensions,
        HNB_Cell_Identifier,
        HNB_Cell_Identifier_ExtIEs,
        Iurh_Signalling_Context_ID,
        PLMN_ID,
        _GlobalRNC_ID_pLMN_ID,
        _GlobalRNC_ID_rnc_ID,
        ____GlobalRNC_ID_iE_Extensions__item__id_tab,
        ___GlobalRNC_ID_iE_Extensions__item__id,
        ____GlobalRNC_ID_iE_Extensions__item__criticality_tab,
        ___GlobalRNC_ID_iE_Extensions__item__criticality,
        ____GlobalRNC_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalRNC_ID_iE_Extensions__item__extensionValue,
        __GlobalRNC_ID_iE_Extensions__item_,
        _GlobalRNC_ID_iE_Extensions,
        GlobalRNC_ID,
        GlobalRNC_ID_ExtIEs,
        RNSAP_Message,
        TypeOfError,
    ]

class RNA_PDU_Contents:

    _name_  = 'RNA-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 7, 1, 1]
    
    _obj_ = [
        'IurhSetupRequest',
        'IurhSetupRequestIEs',
        'IurhSetupRequestExtensions',
        'IurhSetupResponse',
        'IurhSetupResponseIEs',
        'IurhSetupResponseExtensions',
        'IurhSetupFailure',
        'IurhSetupFailureIEs',
        'IurhSetupFailureExtensions',
        'Connect',
        'ConnectIEs',
        'ConnectExtensions',
        'DirectTransfer',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'Disconnect',
        'DisconnectIEs',
        'DisconnectExtensions',
        'ConnectionlessTransfer',
        'ConnectionlessTransferIEs',
        'ConnectionlessTransferExtensions',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage',
        'PrivateMessage-IEs',
        ]
    _type_ = [
        'IurhSetupRequest',
        'IurhSetupResponse',
        'IurhSetupFailure',
        'Connect',
        'DirectTransfer',
        'Disconnect',
        'ConnectionlessTransfer',
        'ErrorIndication',
        'PrivateMessage',
        ]
    _set_ = [
        'IurhSetupRequestIEs',
        'IurhSetupRequestExtensions',
        'IurhSetupResponseIEs',
        'IurhSetupResponseExtensions',
        'IurhSetupFailureIEs',
        'IurhSetupFailureExtensions',
        'ConnectIEs',
        'ConnectExtensions',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'DisconnectIEs',
        'DisconnectExtensions',
        'ConnectionlessTransferIEs',
        'ConnectionlessTransferExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage-IEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'IurhSetupRequestIEs',
        'IurhSetupRequestExtensions',
        'IurhSetupResponseIEs',
        'IurhSetupResponseExtensions',
        'IurhSetupFailureIEs',
        'IurhSetupFailureExtensions',
        'ConnectIEs',
        'ConnectExtensions',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'DisconnectIEs',
        'DisconnectExtensions',
        'ConnectionlessTransferIEs',
        'ConnectionlessTransferExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage-IEs',
        ]
    _param_ = [
        ]
    
    #-----< IurhSetupRequest >-----#
    IurhSetupRequest = SEQ(name='IurhSetupRequest', mode=MODE_TYPE)
    _IurhSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __IurhSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___IurhSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____IurhSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____IurhSetupRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _____IurhSetupRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____IurhSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _____IurhSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____IurhSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___IurhSetupRequest_protocolIEs__item__id._const_tab = ____IurhSetupRequest_protocolIEs__item__id_tab
    ___IurhSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___IurhSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___IurhSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___IurhSetupRequest_protocolIEs__item__criticality._const_tab = ____IurhSetupRequest_protocolIEs__item__id_tab
    ___IurhSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IurhSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IurhSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___IurhSetupRequest_protocolIEs__item__value._const_tab = ____IurhSetupRequest_protocolIEs__item__id_tab
    ___IurhSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IurhSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __IurhSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IurhSetupRequest_protocolIEs__item__id),
        ('criticality', ___IurhSetupRequest_protocolIEs__item__criticality),
        ('value', ___IurhSetupRequest_protocolIEs__item__value),
        ])
    __IurhSetupRequest_protocolIEs__item_._ext = None
    _IurhSetupRequest_protocolIEs._cont = __IurhSetupRequest_protocolIEs__item_
    _IurhSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _IurhSetupRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IurhSetupRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___IurhSetupRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____IurhSetupRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupRequest_protocolExtensions__item__id._const_tab = ____IurhSetupRequest_protocolExtensions__item__id_tab
    ___IurhSetupRequest_protocolExtensions__item__id._const_tab_at = None
    ___IurhSetupRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___IurhSetupRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____IurhSetupRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupRequest_protocolExtensions__item__criticality._const_tab = ____IurhSetupRequest_protocolExtensions__item__criticality_tab
    ___IurhSetupRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___IurhSetupRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___IurhSetupRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____IurhSetupRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupRequest_protocolExtensions__item__extensionValue._const_tab = ____IurhSetupRequest_protocolExtensions__item__extensionValue_tab
    ___IurhSetupRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IurhSetupRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __IurhSetupRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___IurhSetupRequest_protocolExtensions__item__id),
        ('criticality', ___IurhSetupRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___IurhSetupRequest_protocolExtensions__item__extensionValue),
        ])
    __IurhSetupRequest_protocolExtensions__item_._ext = None
    _IurhSetupRequest_protocolExtensions._cont = __IurhSetupRequest_protocolExtensions__item_
    _IurhSetupRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IurhSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _IurhSetupRequest_protocolIEs),
        ('protocolExtensions', _IurhSetupRequest_protocolExtensions),
        ])
    IurhSetupRequest._ext = []
    
    #-----< IurhSetupRequestIEs >-----#
    IurhSetupRequestIEs = CLASS(name='IurhSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _IurhSetupRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _IurhSetupRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    IurhSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _IurhSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _IurhSetupRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IurhSetupRequestExtensions >-----#
    IurhSetupRequestExtensions = CLASS(name='IurhSetupRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    IurhSetupRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IurhSetupResponse >-----#
    IurhSetupResponse = SEQ(name='IurhSetupResponse', mode=MODE_TYPE)
    _IurhSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __IurhSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___IurhSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____IurhSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____IurhSetupResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _____IurhSetupResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____IurhSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _____IurhSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____IurhSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___IurhSetupResponse_protocolIEs__item__id._const_tab = ____IurhSetupResponse_protocolIEs__item__id_tab
    ___IurhSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___IurhSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___IurhSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___IurhSetupResponse_protocolIEs__item__criticality._const_tab = ____IurhSetupResponse_protocolIEs__item__id_tab
    ___IurhSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IurhSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IurhSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___IurhSetupResponse_protocolIEs__item__value._const_tab = ____IurhSetupResponse_protocolIEs__item__id_tab
    ___IurhSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IurhSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __IurhSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IurhSetupResponse_protocolIEs__item__id),
        ('criticality', ___IurhSetupResponse_protocolIEs__item__criticality),
        ('value', ___IurhSetupResponse_protocolIEs__item__value),
        ])
    __IurhSetupResponse_protocolIEs__item_._ext = None
    _IurhSetupResponse_protocolIEs._cont = __IurhSetupResponse_protocolIEs__item_
    _IurhSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _IurhSetupResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IurhSetupResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___IurhSetupResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____IurhSetupResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupResponse_protocolExtensions__item__id._const_tab = ____IurhSetupResponse_protocolExtensions__item__id_tab
    ___IurhSetupResponse_protocolExtensions__item__id._const_tab_at = None
    ___IurhSetupResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___IurhSetupResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____IurhSetupResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupResponse_protocolExtensions__item__criticality._const_tab = ____IurhSetupResponse_protocolExtensions__item__criticality_tab
    ___IurhSetupResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___IurhSetupResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___IurhSetupResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____IurhSetupResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupResponse_protocolExtensions__item__extensionValue._const_tab = ____IurhSetupResponse_protocolExtensions__item__extensionValue_tab
    ___IurhSetupResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IurhSetupResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __IurhSetupResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___IurhSetupResponse_protocolExtensions__item__id),
        ('criticality', ___IurhSetupResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___IurhSetupResponse_protocolExtensions__item__extensionValue),
        ])
    __IurhSetupResponse_protocolExtensions__item_._ext = None
    _IurhSetupResponse_protocolExtensions._cont = __IurhSetupResponse_protocolExtensions__item_
    _IurhSetupResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IurhSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _IurhSetupResponse_protocolIEs),
        ('protocolExtensions', _IurhSetupResponse_protocolExtensions),
        ])
    IurhSetupResponse._ext = []
    
    #-----< IurhSetupResponseIEs >-----#
    IurhSetupResponseIEs = CLASS(name='IurhSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _IurhSetupResponseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _IurhSetupResponseIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    IurhSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _IurhSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _IurhSetupResponseIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IurhSetupResponseExtensions >-----#
    IurhSetupResponseExtensions = CLASS(name='IurhSetupResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    IurhSetupResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IurhSetupFailure >-----#
    IurhSetupFailure = SEQ(name='IurhSetupFailure', mode=MODE_TYPE)
    _IurhSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __IurhSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___IurhSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____IurhSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Cause')))
    _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'BackoffTimer')))
    _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'CriticalityDiagnostics')))
    _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____IurhSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___IurhSetupFailure_protocolIEs__item__id._const_tab = ____IurhSetupFailure_protocolIEs__item__id_tab
    ___IurhSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___IurhSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___IurhSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___IurhSetupFailure_protocolIEs__item__criticality._const_tab = ____IurhSetupFailure_protocolIEs__item__id_tab
    ___IurhSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IurhSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IurhSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___IurhSetupFailure_protocolIEs__item__value._const_tab = ____IurhSetupFailure_protocolIEs__item__id_tab
    ___IurhSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IurhSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __IurhSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IurhSetupFailure_protocolIEs__item__id),
        ('criticality', ___IurhSetupFailure_protocolIEs__item__criticality),
        ('value', ___IurhSetupFailure_protocolIEs__item__value),
        ])
    __IurhSetupFailure_protocolIEs__item_._ext = None
    _IurhSetupFailure_protocolIEs._cont = __IurhSetupFailure_protocolIEs__item_
    _IurhSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _IurhSetupFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IurhSetupFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___IurhSetupFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____IurhSetupFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupFailure_protocolExtensions__item__id._const_tab = ____IurhSetupFailure_protocolExtensions__item__id_tab
    ___IurhSetupFailure_protocolExtensions__item__id._const_tab_at = None
    ___IurhSetupFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___IurhSetupFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____IurhSetupFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupFailure_protocolExtensions__item__criticality._const_tab = ____IurhSetupFailure_protocolExtensions__item__criticality_tab
    ___IurhSetupFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___IurhSetupFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___IurhSetupFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____IurhSetupFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____IurhSetupFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurhSetupFailure_protocolExtensions__item__extensionValue._const_tab = ____IurhSetupFailure_protocolExtensions__item__extensionValue_tab
    ___IurhSetupFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IurhSetupFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __IurhSetupFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___IurhSetupFailure_protocolExtensions__item__id),
        ('criticality', ___IurhSetupFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___IurhSetupFailure_protocolExtensions__item__extensionValue),
        ])
    __IurhSetupFailure_protocolExtensions__item_._ext = None
    _IurhSetupFailure_protocolExtensions._cont = __IurhSetupFailure_protocolExtensions__item_
    _IurhSetupFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IurhSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _IurhSetupFailure_protocolIEs),
        ('protocolExtensions', _IurhSetupFailure_protocolExtensions),
        ])
    IurhSetupFailure._ext = []
    
    #-----< IurhSetupFailureIEs >-----#
    IurhSetupFailureIEs = CLASS(name='IurhSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _IurhSetupFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Cause')))
    _IurhSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'BackoffTimer')))
    _IurhSetupFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'CriticalityDiagnostics')))
    _IurhSetupFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _IurhSetupFailureIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    IurhSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _IurhSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _IurhSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _IurhSetupFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _IurhSetupFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _IurhSetupFailureIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IurhSetupFailureExtensions >-----#
    IurhSetupFailureExtensions = CLASS(name='IurhSetupFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    IurhSetupFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Connect >-----#
    Connect = SEQ(name='Connect', mode=MODE_TYPE)
    _Connect_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __Connect_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___Connect_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____Connect_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____Connect_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _____Connect_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _____Connect_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _____Connect_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____Connect_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____Connect_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Connect_protocolIEs__item__id._const_tab = ____Connect_protocolIEs__item__id_tab
    ___Connect_protocolIEs__item__id._const_tab_at = None
    ___Connect_protocolIEs__item__id._const_tab_id = 'id'
    ___Connect_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___Connect_protocolIEs__item__criticality._const_tab = ____Connect_protocolIEs__item__id_tab
    ___Connect_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Connect_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Connect_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___Connect_protocolIEs__item__value._const_tab = ____Connect_protocolIEs__item__id_tab
    ___Connect_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Connect_protocolIEs__item__value._const_tab_id = 'Value'
    __Connect_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Connect_protocolIEs__item__id),
        ('criticality', ___Connect_protocolIEs__item__criticality),
        ('value', ___Connect_protocolIEs__item__value),
        ])
    __Connect_protocolIEs__item_._ext = None
    _Connect_protocolIEs._cont = __Connect_protocolIEs__item_
    _Connect_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Connect_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Connect_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___Connect_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____Connect_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____Connect_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Connect_protocolExtensions__item__id._const_tab = ____Connect_protocolExtensions__item__id_tab
    ___Connect_protocolExtensions__item__id._const_tab_at = None
    ___Connect_protocolExtensions__item__id._const_tab_id = 'id'
    ___Connect_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Connect_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____Connect_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Connect_protocolExtensions__item__criticality._const_tab = ____Connect_protocolExtensions__item__criticality_tab
    ___Connect_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Connect_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Connect_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Connect_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____Connect_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Connect_protocolExtensions__item__extensionValue._const_tab = ____Connect_protocolExtensions__item__extensionValue_tab
    ___Connect_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Connect_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Connect_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Connect_protocolExtensions__item__id),
        ('criticality', ___Connect_protocolExtensions__item__criticality),
        ('extensionValue', ___Connect_protocolExtensions__item__extensionValue),
        ])
    __Connect_protocolExtensions__item_._ext = None
    _Connect_protocolExtensions._cont = __Connect_protocolExtensions__item_
    _Connect_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Connect._cont = ASN1Dict([
        ('protocolIEs', _Connect_protocolIEs),
        ('protocolExtensions', _Connect_protocolExtensions),
        ])
    Connect._ext = []
    
    #-----< ConnectIEs >-----#
    ConnectIEs = CLASS(name='ConnectIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _ConnectIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _ConnectIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _ConnectIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _ConnectIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ConnectIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _ConnectIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ConnectExtensions >-----#
    ConnectExtensions = CLASS(name='ConnectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ConnectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DirectTransfer >-----#
    DirectTransfer = SEQ(name='DirectTransfer', mode=MODE_TYPE)
    _DirectTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __DirectTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___DirectTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____DirectTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____DirectTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolIEs__item__id._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DirectTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___DirectTransfer_protocolIEs__item__criticality._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DirectTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___DirectTransfer_protocolIEs__item__value._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DirectTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DirectTransfer_protocolIEs__item__id),
        ('criticality', ___DirectTransfer_protocolIEs__item__criticality),
        ('value', ___DirectTransfer_protocolIEs__item__value),
        ])
    __DirectTransfer_protocolIEs__item_._ext = None
    _DirectTransfer_protocolIEs._cont = __DirectTransfer_protocolIEs__item_
    _DirectTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectTransfer_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___DirectTransfer_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____DirectTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____DirectTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__id._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectTransfer_protocolExtensions__item__id._const_tab_id = 'id'
    ___DirectTransfer_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DirectTransfer_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____DirectTransfer_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab = ____DirectTransfer_protocolExtensions__item__criticality_tab
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DirectTransfer_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DirectTransfer_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____DirectTransfer_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectTransfer_protocolExtensions__item__extensionValue_tab
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DirectTransfer_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DirectTransfer_protocolExtensions__item__id),
        ('criticality', ___DirectTransfer_protocolExtensions__item__criticality),
        ('extensionValue', ___DirectTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectTransfer_protocolExtensions__item_._ext = None
    _DirectTransfer_protocolExtensions._cont = __DirectTransfer_protocolExtensions__item_
    _DirectTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectTransfer._cont = ASN1Dict([
        ('protocolIEs', _DirectTransfer_protocolIEs),
        ('protocolExtensions', _DirectTransfer_protocolExtensions),
        ])
    DirectTransfer._ext = []
    
    #-----< DirectTransferIEs >-----#
    DirectTransferIEs = CLASS(name='DirectTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _DirectTransferIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _DirectTransferIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _DirectTransferIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    DirectTransferIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _DirectTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DirectTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _DirectTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferExtensions >-----#
    DirectTransferExtensions = CLASS(name='DirectTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    DirectTransferExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Disconnect >-----#
    Disconnect = SEQ(name='Disconnect', mode=MODE_TYPE)
    _Disconnect_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __Disconnect_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___Disconnect_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____Disconnect_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Cause')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _____Disconnect_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____Disconnect_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____Disconnect_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Disconnect_protocolIEs__item__id._const_tab = ____Disconnect_protocolIEs__item__id_tab
    ___Disconnect_protocolIEs__item__id._const_tab_at = None
    ___Disconnect_protocolIEs__item__id._const_tab_id = 'id'
    ___Disconnect_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___Disconnect_protocolIEs__item__criticality._const_tab = ____Disconnect_protocolIEs__item__id_tab
    ___Disconnect_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Disconnect_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Disconnect_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___Disconnect_protocolIEs__item__value._const_tab = ____Disconnect_protocolIEs__item__id_tab
    ___Disconnect_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Disconnect_protocolIEs__item__value._const_tab_id = 'Value'
    __Disconnect_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Disconnect_protocolIEs__item__id),
        ('criticality', ___Disconnect_protocolIEs__item__criticality),
        ('value', ___Disconnect_protocolIEs__item__value),
        ])
    __Disconnect_protocolIEs__item_._ext = None
    _Disconnect_protocolIEs._cont = __Disconnect_protocolIEs__item_
    _Disconnect_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Disconnect_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Disconnect_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___Disconnect_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____Disconnect_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____Disconnect_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Disconnect_protocolExtensions__item__id._const_tab = ____Disconnect_protocolExtensions__item__id_tab
    ___Disconnect_protocolExtensions__item__id._const_tab_at = None
    ___Disconnect_protocolExtensions__item__id._const_tab_id = 'id'
    ___Disconnect_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Disconnect_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____Disconnect_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Disconnect_protocolExtensions__item__criticality._const_tab = ____Disconnect_protocolExtensions__item__criticality_tab
    ___Disconnect_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Disconnect_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Disconnect_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Disconnect_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____Disconnect_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Disconnect_protocolExtensions__item__extensionValue._const_tab = ____Disconnect_protocolExtensions__item__extensionValue_tab
    ___Disconnect_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Disconnect_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Disconnect_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Disconnect_protocolExtensions__item__id),
        ('criticality', ___Disconnect_protocolExtensions__item__criticality),
        ('extensionValue', ___Disconnect_protocolExtensions__item__extensionValue),
        ])
    __Disconnect_protocolExtensions__item_._ext = None
    _Disconnect_protocolExtensions._cont = __Disconnect_protocolExtensions__item_
    _Disconnect_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Disconnect._cont = ASN1Dict([
        ('protocolIEs', _Disconnect_protocolIEs),
        ('protocolExtensions', _Disconnect_protocolExtensions),
        ])
    Disconnect._ext = []
    
    #-----< DisconnectIEs >-----#
    DisconnectIEs = CLASS(name='DisconnectIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _DisconnectIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _DisconnectIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Cause')))
    _DisconnectIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _DisconnectIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    DisconnectIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _DisconnectIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DisconnectExtensions >-----#
    DisconnectExtensions = CLASS(name='DisconnectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    DisconnectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ConnectionlessTransfer >-----#
    ConnectionlessTransfer = SEQ(name='ConnectionlessTransfer', mode=MODE_TYPE)
    _ConnectionlessTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __ConnectionlessTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___ConnectionlessTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____ConnectionlessTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____ConnectionlessTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolIEs__item__id._const_tab = ____ConnectionlessTransfer_protocolIEs__item__id_tab
    ___ConnectionlessTransfer_protocolIEs__item__id._const_tab_at = None
    ___ConnectionlessTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ConnectionlessTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___ConnectionlessTransfer_protocolIEs__item__criticality._const_tab = ____ConnectionlessTransfer_protocolIEs__item__id_tab
    ___ConnectionlessTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ConnectionlessTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___ConnectionlessTransfer_protocolIEs__item__value._const_tab = ____ConnectionlessTransfer_protocolIEs__item__id_tab
    ___ConnectionlessTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ConnectionlessTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ConnectionlessTransfer_protocolIEs__item__id),
        ('criticality', ___ConnectionlessTransfer_protocolIEs__item__criticality),
        ('value', ___ConnectionlessTransfer_protocolIEs__item__value),
        ])
    __ConnectionlessTransfer_protocolIEs__item_._ext = None
    _ConnectionlessTransfer_protocolIEs._cont = __ConnectionlessTransfer_protocolIEs__item_
    _ConnectionlessTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ConnectionlessTransfer_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConnectionlessTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___ConnectionlessTransfer_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____ConnectionlessTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____ConnectionlessTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolExtensions__item__id._const_tab = ____ConnectionlessTransfer_protocolExtensions__item__id_tab
    ___ConnectionlessTransfer_protocolExtensions__item__id._const_tab_at = None
    ___ConnectionlessTransfer_protocolExtensions__item__id._const_tab_id = 'id'
    ___ConnectionlessTransfer_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolExtensions__item__criticality._const_tab = ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab
    ___ConnectionlessTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue._const_tab = ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ConnectionlessTransfer_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ConnectionlessTransfer_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ConnectionlessTransfer_protocolExtensions__item__id),
        ('criticality', ___ConnectionlessTransfer_protocolExtensions__item__criticality),
        ('extensionValue', ___ConnectionlessTransfer_protocolExtensions__item__extensionValue),
        ])
    __ConnectionlessTransfer_protocolExtensions__item_._ext = None
    _ConnectionlessTransfer_protocolExtensions._cont = __ConnectionlessTransfer_protocolExtensions__item_
    _ConnectionlessTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConnectionlessTransfer._cont = ASN1Dict([
        ('protocolIEs', _ConnectionlessTransfer_protocolIEs),
        ('protocolExtensions', _ConnectionlessTransfer_protocolExtensions),
        ])
    ConnectionlessTransfer._ext = []
    
    #-----< ConnectionlessTransferIEs >-----#
    ConnectionlessTransferIEs = CLASS(name='ConnectionlessTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _ConnectionlessTransferIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'RNSAP-Message')))
    _ConnectionlessTransferIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    _ConnectionlessTransferIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ConnectionlessTransferIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _ConnectionlessTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _ConnectionlessTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _ConnectionlessTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ConnectionlessTransferExtensions >-----#
    ConnectionlessTransferExtensions = CLASS(name='ConnectionlessTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ConnectionlessTransferExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ErrorIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__criticality_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__extensionValue_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolExtensions__item__id),
        ('criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ('protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'Iurh-Signalling-Context-ID')))
    _ErrorIndicationIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-IEs', 'HNB-RNL-ID')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndicationExtensions >-----#
    ErrorIndicationExtensions = CLASS(name='ErrorIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PROTOCOL-EXTENSION')))
    ErrorIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_RNA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_RNA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-Containers', 'RNA-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_RNA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNA-Containers', 'RNA-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____IurhSetupRequest_protocolIEs__item__id_tab,
        _____IurhSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____IurhSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        ___IurhSetupRequest_protocolIEs__item__id,
        ___IurhSetupRequest_protocolIEs__item__criticality,
        ___IurhSetupRequest_protocolIEs__item__value,
        __IurhSetupRequest_protocolIEs__item_,
        _IurhSetupRequest_protocolIEs,
        ____IurhSetupRequest_protocolExtensions__item__id_tab,
        ___IurhSetupRequest_protocolExtensions__item__id,
        ____IurhSetupRequest_protocolExtensions__item__criticality_tab,
        ___IurhSetupRequest_protocolExtensions__item__criticality,
        ____IurhSetupRequest_protocolExtensions__item__extensionValue_tab,
        ___IurhSetupRequest_protocolExtensions__item__extensionValue,
        __IurhSetupRequest_protocolExtensions__item_,
        _IurhSetupRequest_protocolExtensions,
        IurhSetupRequest,
        IurhSetupRequestIEs,
        _IurhSetupRequestIEs_val_Value_0,
        _IurhSetupRequestIEs_val_Value_1,
        IurhSetupRequestExtensions,
        ____IurhSetupResponse_protocolIEs__item__id_tab,
        _____IurhSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____IurhSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        ___IurhSetupResponse_protocolIEs__item__id,
        ___IurhSetupResponse_protocolIEs__item__criticality,
        ___IurhSetupResponse_protocolIEs__item__value,
        __IurhSetupResponse_protocolIEs__item_,
        _IurhSetupResponse_protocolIEs,
        ____IurhSetupResponse_protocolExtensions__item__id_tab,
        ___IurhSetupResponse_protocolExtensions__item__id,
        ____IurhSetupResponse_protocolExtensions__item__criticality_tab,
        ___IurhSetupResponse_protocolExtensions__item__criticality,
        ____IurhSetupResponse_protocolExtensions__item__extensionValue_tab,
        ___IurhSetupResponse_protocolExtensions__item__extensionValue,
        __IurhSetupResponse_protocolExtensions__item_,
        _IurhSetupResponse_protocolExtensions,
        IurhSetupResponse,
        IurhSetupResponseIEs,
        _IurhSetupResponseIEs_val_Value_0,
        _IurhSetupResponseIEs_val_Value_1,
        IurhSetupResponseExtensions,
        ____IurhSetupFailure_protocolIEs__item__id_tab,
        _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____IurhSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___IurhSetupFailure_protocolIEs__item__id,
        ___IurhSetupFailure_protocolIEs__item__criticality,
        ___IurhSetupFailure_protocolIEs__item__value,
        __IurhSetupFailure_protocolIEs__item_,
        _IurhSetupFailure_protocolIEs,
        ____IurhSetupFailure_protocolExtensions__item__id_tab,
        ___IurhSetupFailure_protocolExtensions__item__id,
        ____IurhSetupFailure_protocolExtensions__item__criticality_tab,
        ___IurhSetupFailure_protocolExtensions__item__criticality,
        ____IurhSetupFailure_protocolExtensions__item__extensionValue_tab,
        ___IurhSetupFailure_protocolExtensions__item__extensionValue,
        __IurhSetupFailure_protocolExtensions__item_,
        _IurhSetupFailure_protocolExtensions,
        IurhSetupFailure,
        IurhSetupFailureIEs,
        _IurhSetupFailureIEs_val_Value_0,
        _IurhSetupFailureIEs_val_Value_1,
        _IurhSetupFailureIEs_val_Value_2,
        _IurhSetupFailureIEs_val_Value_3,
        _IurhSetupFailureIEs_val_Value_4,
        IurhSetupFailureExtensions,
        ____Connect_protocolIEs__item__id_tab,
        _____Connect_protocolIEs__item__id_tab_val_Value_0,
        _____Connect_protocolIEs__item__id_tab_val_Value_1,
        _____Connect_protocolIEs__item__id_tab_val_Value_2,
        _____Connect_protocolIEs__item__id_tab_val_Value_3,
        ___Connect_protocolIEs__item__id,
        ___Connect_protocolIEs__item__criticality,
        ___Connect_protocolIEs__item__value,
        __Connect_protocolIEs__item_,
        _Connect_protocolIEs,
        ____Connect_protocolExtensions__item__id_tab,
        ___Connect_protocolExtensions__item__id,
        ____Connect_protocolExtensions__item__criticality_tab,
        ___Connect_protocolExtensions__item__criticality,
        ____Connect_protocolExtensions__item__extensionValue_tab,
        ___Connect_protocolExtensions__item__extensionValue,
        __Connect_protocolExtensions__item_,
        _Connect_protocolExtensions,
        Connect,
        ConnectIEs,
        _ConnectIEs_val_Value_0,
        _ConnectIEs_val_Value_1,
        _ConnectIEs_val_Value_2,
        _ConnectIEs_val_Value_3,
        ConnectExtensions,
        ____DirectTransfer_protocolIEs__item__id_tab,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DirectTransfer_protocolIEs__item__id,
        ___DirectTransfer_protocolIEs__item__criticality,
        ___DirectTransfer_protocolIEs__item__value,
        __DirectTransfer_protocolIEs__item_,
        _DirectTransfer_protocolIEs,
        ____DirectTransfer_protocolExtensions__item__id_tab,
        ___DirectTransfer_protocolExtensions__item__id,
        ____DirectTransfer_protocolExtensions__item__criticality_tab,
        ___DirectTransfer_protocolExtensions__item__criticality,
        ____DirectTransfer_protocolExtensions__item__extensionValue_tab,
        ___DirectTransfer_protocolExtensions__item__extensionValue,
        __DirectTransfer_protocolExtensions__item_,
        _DirectTransfer_protocolExtensions,
        DirectTransfer,
        DirectTransferIEs,
        _DirectTransferIEs_val_Value_0,
        _DirectTransferIEs_val_Value_1,
        _DirectTransferIEs_val_Value_2,
        DirectTransferExtensions,
        ____Disconnect_protocolIEs__item__id_tab,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_0,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_1,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_2,
        _____Disconnect_protocolIEs__item__id_tab_val_Value_3,
        ___Disconnect_protocolIEs__item__id,
        ___Disconnect_protocolIEs__item__criticality,
        ___Disconnect_protocolIEs__item__value,
        __Disconnect_protocolIEs__item_,
        _Disconnect_protocolIEs,
        ____Disconnect_protocolExtensions__item__id_tab,
        ___Disconnect_protocolExtensions__item__id,
        ____Disconnect_protocolExtensions__item__criticality_tab,
        ___Disconnect_protocolExtensions__item__criticality,
        ____Disconnect_protocolExtensions__item__extensionValue_tab,
        ___Disconnect_protocolExtensions__item__extensionValue,
        __Disconnect_protocolExtensions__item_,
        _Disconnect_protocolExtensions,
        Disconnect,
        DisconnectIEs,
        _DisconnectIEs_val_Value_0,
        _DisconnectIEs_val_Value_1,
        _DisconnectIEs_val_Value_2,
        _DisconnectIEs_val_Value_3,
        DisconnectExtensions,
        ____ConnectionlessTransfer_protocolIEs__item__id_tab,
        _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ConnectionlessTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ConnectionlessTransfer_protocolIEs__item__id,
        ___ConnectionlessTransfer_protocolIEs__item__criticality,
        ___ConnectionlessTransfer_protocolIEs__item__value,
        __ConnectionlessTransfer_protocolIEs__item_,
        _ConnectionlessTransfer_protocolIEs,
        ____ConnectionlessTransfer_protocolExtensions__item__id_tab,
        ___ConnectionlessTransfer_protocolExtensions__item__id,
        ____ConnectionlessTransfer_protocolExtensions__item__criticality_tab,
        ___ConnectionlessTransfer_protocolExtensions__item__criticality,
        ____ConnectionlessTransfer_protocolExtensions__item__extensionValue_tab,
        ___ConnectionlessTransfer_protocolExtensions__item__extensionValue,
        __ConnectionlessTransfer_protocolExtensions__item_,
        _ConnectionlessTransfer_protocolExtensions,
        ConnectionlessTransfer,
        ConnectionlessTransferIEs,
        _ConnectionlessTransferIEs_val_Value_0,
        _ConnectionlessTransferIEs_val_Value_1,
        _ConnectionlessTransferIEs_val_Value_2,
        ConnectionlessTransferExtensions,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        ___ErrorIndication_protocolExtensions__item__id,
        ____ErrorIndication_protocolExtensions__item__criticality_tab,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ____ErrorIndication_protocolExtensions__item__extensionValue_tab,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        ErrorIndicationExtensions,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
    ]

class RNA_PDU_Descriptions:

    _name_  = 'RNA-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 7, 1, 0]
    
    _obj_ = [
        'RNA-ELEMENTARY-PROCEDURE',
        'RNA-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'RNA-ELEMENTARY-PROCEDURES',
        'RNA-ELEMENTARY-PROCEDURES-CLASS-1',
        'RNA-ELEMENTARY-PROCEDURES-CLASS-2',
        'iurhsetup',
        'connect',
        'directTransfer',
        'disconnect',
        'connectionlessTransfer',
        'errorIndication',
        'privateMessage',
        ]
    _type_ = [
        'RNA-ELEMENTARY-PROCEDURE',
        'RNA-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'RNA-ELEMENTARY-PROCEDURES',
        'RNA-ELEMENTARY-PROCEDURES-CLASS-1',
        'RNA-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'iurhsetup',
        'connect',
        'directTransfer',
        'disconnect',
        'connectionlessTransfer',
        'errorIndication',
        'privateMessage',
        ]
    _class_ = [
        'RNA-ELEMENTARY-PROCEDURE',
        'RNA-ELEMENTARY-PROCEDURES',
        'RNA-ELEMENTARY-PROCEDURES-CLASS-1',
        'RNA-ELEMENTARY-PROCEDURES-CLASS-2',
        'iurhsetup',
        'connect',
        'directTransfer',
        'disconnect',
        'connectionlessTransfer',
        'errorIndication',
        'privateMessage',
        ]
    _param_ = [
        ]
    
    #-----< RNA-ELEMENTARY-PROCEDURE >-----#
    RNA_ELEMENTARY_PROCEDURE = CLASS(name='RNA-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _RNA_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _RNA_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RNA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RNA_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _RNA_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-CommonDataTypes', 'Criticality')), default='ignore')
    RNA_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _RNA_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _RNA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _RNA_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _RNA_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< RNA-PDU >-----#
    RNA_PDU = CHOICE(name='RNA-PDU', mode=MODE_TYPE)
    _RNA_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-PDU-Descriptions', 'InitiatingMessage')))
    _RNA_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-PDU-Descriptions', 'SuccessfulOutcome')))
    _RNA_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNA-PDU-Descriptions', 'UnsuccessfulOutcome')))
    RNA_PDU._cont = ASN1Dict([
        ('initiatingMessage', _RNA_PDU_initiatingMessage),
        ('successfulOutcome', _RNA_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _RNA_PDU_unsuccessfulOutcome),
        ])
    RNA_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_RNA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Connect')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'DirectTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Disconnect')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ConnectionlessTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'PrivateMessage')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RNA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Connect')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'DirectTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Disconnect')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ConnectionlessTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'PrivateMessage')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RNA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Connect')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'DirectTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Disconnect')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ConnectionlessTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'PrivateMessage')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< RNA-ELEMENTARY-PROCEDURES >-----#
    RNA_ELEMENTARY_PROCEDURES = CLASS(name='RNA-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupRequest')))
    _RNA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupResponse')))
    _RNA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupFailure')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Connect')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'DirectTransfer')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Disconnect')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ConnectionlessTransfer')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ErrorIndication')))
    _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'PrivateMessage')))
    RNA_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _RNA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _RNA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< RNA-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    RNA_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='RNA-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupRequest')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupResponse')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupFailure')))
    RNA_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< RNA-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    RNA_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='RNA-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Connect')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'DirectTransfer')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Disconnect')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ConnectionlessTransfer')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ErrorIndication')))
    _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'PrivateMessage')))
    RNA_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< iurhsetup >-----#
    iurhsetup = CLASS(name='iurhsetup', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _iurhsetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupRequest')))
    _iurhsetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupResponse')))
    _iurhsetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'IurhSetupFailure')))
    iurhsetup._val = dict([('InitiatingMessage', _iurhsetup_val_InitiatingMessage), ('SuccessfulOutcome', _iurhsetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _iurhsetup_val_UnsuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< connect >-----#
    connect = CLASS(name='connect', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _connect_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Connect')))
    connect._val = dict([('InitiatingMessage', _connect_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< directTransfer >-----#
    directTransfer = CLASS(name='directTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _directTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'DirectTransfer')))
    directTransfer._val = dict([('InitiatingMessage', _directTransfer_val_InitiatingMessage), ('procedureCode', 3), ('criticality', 'ignore')])
    
    #-----< disconnect >-----#
    disconnect = CLASS(name='disconnect', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _disconnect_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'Disconnect')))
    disconnect._val = dict([('InitiatingMessage', _disconnect_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< connectionlessTransfer >-----#
    connectionlessTransfer = CLASS(name='connectionlessTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _connectionlessTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ConnectionlessTransfer')))
    connectionlessTransfer._val = dict([('InitiatingMessage', _connectionlessTransfer_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 6), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RNA-PDU-Descriptions', 'RNA-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNA-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 7), ('criticality', 'ignore')])
    
    _all_ = [
        _RNA_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _RNA_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _RNA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _RNA_ELEMENTARY_PROCEDURE_procedureCode,
        _RNA_ELEMENTARY_PROCEDURE_criticality,
        RNA_ELEMENTARY_PROCEDURE,
        _RNA_PDU_initiatingMessage,
        _RNA_PDU_successfulOutcome,
        _RNA_PDU_unsuccessfulOutcome,
        RNA_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        RNA_ELEMENTARY_PROCEDURES,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _RNA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _RNA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _RNA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        RNA_ELEMENTARY_PROCEDURES_CLASS_1,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        RNA_ELEMENTARY_PROCEDURES_CLASS_2,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _RNA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        iurhsetup,
        _iurhsetup_val_InitiatingMessage,
        _iurhsetup_val_SuccessfulOutcome,
        _iurhsetup_val_UnsuccessfulOutcome,
        connect,
        _connect_val_InitiatingMessage,
        directTransfer,
        _directTransfer_val_InitiatingMessage,
        disconnect,
        _disconnect_val_InitiatingMessage,
        connectionlessTransfer,
        _connectionlessTransfer_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
    ]

init_modules(RNA_CommonDataTypes, RNA_Constants, RNA_Containers, RNA_IEs, RNA_PDU_Contents, RNA_PDU_Descriptions)
