# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class E2AP_CommonDataTypes:

    _name_  = 'E2AP-CommonDataTypes'
    _oid_   = [1, 3, 6, 1, 4, 1, 53148, 1, 2, 1, 3]
    
    _obj_ = [
        'Criticality',
        'Presence',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessfull-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class E2AP_Constants:

    _name_  = 'E2AP-Constants'
    _oid_   = [1, 3, 6, 1, 4, 1, 53148, 1, 2, 1, 4]
    
    _obj_ = [
        'id-E2setup',
        'id-ErrorIndication',
        'id-Reset',
        'id-RICcontrol',
        'id-RICindication',
        'id-RICserviceQuery',
        'id-RICserviceUpdate',
        'id-RICsubscription',
        'id-RICsubscriptionDelete',
        'id-E2nodeConfigurationUpdate',
        'id-E2connectionUpdate',
        'id-RICsubscriptionDeleteRequired',
        'id-E2removal',
        'id-RICsubscriptionModification',
        'id-RICsubscriptionModificationRequired',
        'id-RICquery',
        'id-RICsubscriptionAudit',
        'maxProtocolIEs',
        'maxnoofErrors',
        'maxofE2nodeComponents',
        'maxofRANfunctionID',
        'maxofRICactionID',
        'maxofTNLA',
        'maxofRICrequestID',
        'maxofRICsubscriptions',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-GlobalE2node-ID',
        'id-GlobalRIC-ID',
        'id-RANfunctionID',
        'id-RANfunctionID-Item',
        'id-RANfunctionIEcause-Item',
        'id-RANfunction-Item',
        'id-RANfunctionsAccepted',
        'id-RANfunctionsAdded',
        'id-RANfunctionsDeleted',
        'id-RANfunctionsModified',
        'id-RANfunctionsRejected',
        'id-RICaction-Admitted-Item',
        'id-RICactionID',
        'id-RICaction-NotAdmitted-Item',
        'id-RICactions-Admitted',
        'id-RICactions-NotAdmitted',
        'id-RICaction-ToBeSetup-Item',
        'id-RICcallProcessID',
        'id-RICcontrolAckRequest',
        'id-RICcontrolHeader',
        'id-RICcontrolMessage',
        'id-RICcontrolStatus',
        'id-RICindicationHeader',
        'id-RICindicationMessage',
        'id-RICindicationSN',
        'id-RICindicationType',
        'id-RICrequestID',
        'id-RICsubscriptionDetails',
        'id-TimeToWait',
        'id-RICcontrolOutcome',
        'id-E2nodeComponentConfigUpdate',
        'id-E2nodeComponentConfigUpdate-Item',
        'id-E2nodeComponentConfigUpdateAck',
        'id-E2nodeComponentConfigUpdateAck-Item',
        'id-E2connectionSetup',
        'id-E2connectionSetupFailed',
        'id-E2connectionSetupFailed-Item',
        'id-E2connectionFailed-Item',
        'id-E2connectionUpdate-Item',
        'id-E2connectionUpdateAdd',
        'id-E2connectionUpdateModify',
        'id-E2connectionUpdateRemove',
        'id-E2connectionUpdateRemove-Item',
        'id-TNLinformation',
        'id-TransactionID',
        'id-E2nodeComponentConfigAddition',
        'id-E2nodeComponentConfigAddition-Item',
        'id-E2nodeComponentConfigAdditionAck',
        'id-E2nodeComponentConfigAdditionAck-Item',
        'id-E2nodeComponentConfigRemoval',
        'id-E2nodeComponentConfigRemoval-Item',
        'id-E2nodeComponentConfigRemovalAck',
        'id-E2nodeComponentConfigRemovalAck-Item',
        'id-E2nodeTNLassociationRemoval',
        'id-E2nodeTNLassociationRemoval-Item',
        'id-RICsubscriptionToBeRemoved',
        'id-RICsubscription-withCause-Item',
        'id-RICsubscriptionStartTime',
        'id-RICsubscriptionEndTime',
        'id-RICeventTriggerDefinitionToBeModified',
        'id-RICactionsToBeRemovedForModification-List',
        'id-RICaction-ToBeRemovedForModification-Item',
        'id-RICactionsToBeModifiedForModification-List',
        'id-RICaction-ToBeModifiedForModification-Item',
        'id-RICactionsToBeAddedForModification-List',
        'id-RICaction-ToBeAddedForModification-Item',
        'id-RICactionsRemovedForModification-List',
        'id-RICaction-RemovedForModification-Item',
        'id-RICactionsFailedToBeRemovedForModification-List',
        'id-RICaction-FailedToBeRemovedForModification-Item',
        'id-RICactionsModifiedForModification-List',
        'id-RICaction-ModifiedForModification-Item',
        'id-RICactionsFailedToBeModifiedForModification-List',
        'id-RICaction-FailedToBeModifiedForModification-Item',
        'id-RICactionsAddedForModification-List',
        'id-RICaction-AddedForModification-Item',
        'id-RICactionsFailedToBeAddedForModification-List',
        'id-RICaction-FailedToBeAddedForModification-Item',
        'id-RICactionsRequiredToBeModified-List',
        'id-RICaction-RequiredToBeModified-Item',
        'id-RICactionsRequiredToBeRemoved-List',
        'id-RICaction-RequiredToBeRemoved-Item',
        'id-RICactionsConfirmedForModification-List',
        'id-RICaction-ConfirmedForModification-Item',
        'id-RICactionsRefusedToBeModified-List',
        'id-RICaction-RefusedToBeModified-Item',
        'id-RICactionsConfirmedForRemoval-List',
        'id-RICaction-ConfirmedForRemoval-Item',
        'id-RICactionsRefusedToBeRemoved-List',
        'id-RICaction-RefusedToBeRemoved-Item',
        'id-RICqueryHeader',
        'id-RICqueryDefinition',
        'id-RICqueryOutcome',
        'id-RICsubscriptionAuditFlag',
        'id-RICsubscriptionAuditList',
        'id-RICsubscriptionAudit-Item',
        'id-RICsubscriptionAuditAction-Item',
        'id-RICsubscriptionAuditConfirmedList',
        'id-RICsubscriptionAuditMissingList',
        'id-RICsubscriptionAuditUnkownList',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-E2setup',
        'id-ErrorIndication',
        'id-Reset',
        'id-RICcontrol',
        'id-RICindication',
        'id-RICserviceQuery',
        'id-RICserviceUpdate',
        'id-RICsubscription',
        'id-RICsubscriptionDelete',
        'id-E2nodeConfigurationUpdate',
        'id-E2connectionUpdate',
        'id-RICsubscriptionDeleteRequired',
        'id-E2removal',
        'id-RICsubscriptionModification',
        'id-RICsubscriptionModificationRequired',
        'id-RICquery',
        'id-RICsubscriptionAudit',
        'maxProtocolIEs',
        'maxnoofErrors',
        'maxofE2nodeComponents',
        'maxofRANfunctionID',
        'maxofRICactionID',
        'maxofTNLA',
        'maxofRICrequestID',
        'maxofRICsubscriptions',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-GlobalE2node-ID',
        'id-GlobalRIC-ID',
        'id-RANfunctionID',
        'id-RANfunctionID-Item',
        'id-RANfunctionIEcause-Item',
        'id-RANfunction-Item',
        'id-RANfunctionsAccepted',
        'id-RANfunctionsAdded',
        'id-RANfunctionsDeleted',
        'id-RANfunctionsModified',
        'id-RANfunctionsRejected',
        'id-RICaction-Admitted-Item',
        'id-RICactionID',
        'id-RICaction-NotAdmitted-Item',
        'id-RICactions-Admitted',
        'id-RICactions-NotAdmitted',
        'id-RICaction-ToBeSetup-Item',
        'id-RICcallProcessID',
        'id-RICcontrolAckRequest',
        'id-RICcontrolHeader',
        'id-RICcontrolMessage',
        'id-RICcontrolStatus',
        'id-RICindicationHeader',
        'id-RICindicationMessage',
        'id-RICindicationSN',
        'id-RICindicationType',
        'id-RICrequestID',
        'id-RICsubscriptionDetails',
        'id-TimeToWait',
        'id-RICcontrolOutcome',
        'id-E2nodeComponentConfigUpdate',
        'id-E2nodeComponentConfigUpdate-Item',
        'id-E2nodeComponentConfigUpdateAck',
        'id-E2nodeComponentConfigUpdateAck-Item',
        'id-E2connectionSetup',
        'id-E2connectionSetupFailed',
        'id-E2connectionSetupFailed-Item',
        'id-E2connectionFailed-Item',
        'id-E2connectionUpdate-Item',
        'id-E2connectionUpdateAdd',
        'id-E2connectionUpdateModify',
        'id-E2connectionUpdateRemove',
        'id-E2connectionUpdateRemove-Item',
        'id-TNLinformation',
        'id-TransactionID',
        'id-E2nodeComponentConfigAddition',
        'id-E2nodeComponentConfigAddition-Item',
        'id-E2nodeComponentConfigAdditionAck',
        'id-E2nodeComponentConfigAdditionAck-Item',
        'id-E2nodeComponentConfigRemoval',
        'id-E2nodeComponentConfigRemoval-Item',
        'id-E2nodeComponentConfigRemovalAck',
        'id-E2nodeComponentConfigRemovalAck-Item',
        'id-E2nodeTNLassociationRemoval',
        'id-E2nodeTNLassociationRemoval-Item',
        'id-RICsubscriptionToBeRemoved',
        'id-RICsubscription-withCause-Item',
        'id-RICsubscriptionStartTime',
        'id-RICsubscriptionEndTime',
        'id-RICeventTriggerDefinitionToBeModified',
        'id-RICactionsToBeRemovedForModification-List',
        'id-RICaction-ToBeRemovedForModification-Item',
        'id-RICactionsToBeModifiedForModification-List',
        'id-RICaction-ToBeModifiedForModification-Item',
        'id-RICactionsToBeAddedForModification-List',
        'id-RICaction-ToBeAddedForModification-Item',
        'id-RICactionsRemovedForModification-List',
        'id-RICaction-RemovedForModification-Item',
        'id-RICactionsFailedToBeRemovedForModification-List',
        'id-RICaction-FailedToBeRemovedForModification-Item',
        'id-RICactionsModifiedForModification-List',
        'id-RICaction-ModifiedForModification-Item',
        'id-RICactionsFailedToBeModifiedForModification-List',
        'id-RICaction-FailedToBeModifiedForModification-Item',
        'id-RICactionsAddedForModification-List',
        'id-RICaction-AddedForModification-Item',
        'id-RICactionsFailedToBeAddedForModification-List',
        'id-RICaction-FailedToBeAddedForModification-Item',
        'id-RICactionsRequiredToBeModified-List',
        'id-RICaction-RequiredToBeModified-Item',
        'id-RICactionsRequiredToBeRemoved-List',
        'id-RICaction-RequiredToBeRemoved-Item',
        'id-RICactionsConfirmedForModification-List',
        'id-RICaction-ConfirmedForModification-Item',
        'id-RICactionsRefusedToBeModified-List',
        'id-RICaction-RefusedToBeModified-Item',
        'id-RICactionsConfirmedForRemoval-List',
        'id-RICaction-ConfirmedForRemoval-Item',
        'id-RICactionsRefusedToBeRemoved-List',
        'id-RICaction-RefusedToBeRemoved-Item',
        'id-RICqueryHeader',
        'id-RICqueryDefinition',
        'id-RICqueryOutcome',
        'id-RICsubscriptionAuditFlag',
        'id-RICsubscriptionAuditList',
        'id-RICsubscriptionAudit-Item',
        'id-RICsubscriptionAuditAction-Item',
        'id-RICsubscriptionAuditConfirmedList',
        'id-RICsubscriptionAuditMissingList',
        'id-RICsubscriptionAuditUnkownList',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-E2setup >-----#
    id_E2setup = INT(name='id-E2setup', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_E2setup._val = 1
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 2
    
    #-----< id-Reset >-----#
    id_Reset = INT(name='id-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_Reset._val = 3
    
    #-----< id-RICcontrol >-----#
    id_RICcontrol = INT(name='id-RICcontrol', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICcontrol._val = 4
    
    #-----< id-RICindication >-----#
    id_RICindication = INT(name='id-RICindication', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICindication._val = 5
    
    #-----< id-RICserviceQuery >-----#
    id_RICserviceQuery = INT(name='id-RICserviceQuery', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICserviceQuery._val = 6
    
    #-----< id-RICserviceUpdate >-----#
    id_RICserviceUpdate = INT(name='id-RICserviceUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICserviceUpdate._val = 7
    
    #-----< id-RICsubscription >-----#
    id_RICsubscription = INT(name='id-RICsubscription', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICsubscription._val = 8
    
    #-----< id-RICsubscriptionDelete >-----#
    id_RICsubscriptionDelete = INT(name='id-RICsubscriptionDelete', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICsubscriptionDelete._val = 9
    
    #-----< id-E2nodeConfigurationUpdate >-----#
    id_E2nodeConfigurationUpdate = INT(name='id-E2nodeConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_E2nodeConfigurationUpdate._val = 10
    
    #-----< id-E2connectionUpdate >-----#
    id_E2connectionUpdate = INT(name='id-E2connectionUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_E2connectionUpdate._val = 11
    
    #-----< id-RICsubscriptionDeleteRequired >-----#
    id_RICsubscriptionDeleteRequired = INT(name='id-RICsubscriptionDeleteRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICsubscriptionDeleteRequired._val = 12
    
    #-----< id-E2removal >-----#
    id_E2removal = INT(name='id-E2removal', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_E2removal._val = 13
    
    #-----< id-RICsubscriptionModification >-----#
    id_RICsubscriptionModification = INT(name='id-RICsubscriptionModification', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICsubscriptionModification._val = 14
    
    #-----< id-RICsubscriptionModificationRequired >-----#
    id_RICsubscriptionModificationRequired = INT(name='id-RICsubscriptionModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICsubscriptionModificationRequired._val = 15
    
    #-----< id-RICquery >-----#
    id_RICquery = INT(name='id-RICquery', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICquery._val = 16
    
    #-----< id-RICsubscriptionAudit >-----#
    id_RICsubscriptionAudit = INT(name='id-RICsubscriptionAudit', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')))
    id_RICsubscriptionAudit._val = 17
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name='maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxofE2nodeComponents >-----#
    maxofE2nodeComponents = INT(name='maxofE2nodeComponents', mode=MODE_VALUE)
    maxofE2nodeComponents._val = 1024
    
    #-----< maxofRANfunctionID >-----#
    maxofRANfunctionID = INT(name='maxofRANfunctionID', mode=MODE_VALUE)
    maxofRANfunctionID._val = 256
    
    #-----< maxofRICactionID >-----#
    maxofRICactionID = INT(name='maxofRICactionID', mode=MODE_VALUE)
    maxofRICactionID._val = 16
    
    #-----< maxofTNLA >-----#
    maxofTNLA = INT(name='maxofTNLA', mode=MODE_VALUE)
    maxofTNLA._val = 32
    
    #-----< maxofRICrequestID >-----#
    maxofRICrequestID = INT(name='maxofRICrequestID', mode=MODE_VALUE)
    maxofRICrequestID._val = 1024
    
    #-----< maxofRICsubscriptions >-----#
    maxofRICsubscriptions = INT(name='maxofRICsubscriptions', mode=MODE_VALUE)
    maxofRICsubscriptions._val = 2147483648
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 1
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 2
    
    #-----< id-GlobalE2node-ID >-----#
    id_GlobalE2node_ID = INT(name='id-GlobalE2node-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalE2node_ID._val = 3
    
    #-----< id-GlobalRIC-ID >-----#
    id_GlobalRIC_ID = INT(name='id-GlobalRIC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalRIC_ID._val = 4
    
    #-----< id-RANfunctionID >-----#
    id_RANfunctionID = INT(name='id-RANfunctionID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionID._val = 5
    
    #-----< id-RANfunctionID-Item >-----#
    id_RANfunctionID_Item = INT(name='id-RANfunctionID-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionID_Item._val = 6
    
    #-----< id-RANfunctionIEcause-Item >-----#
    id_RANfunctionIEcause_Item = INT(name='id-RANfunctionIEcause-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionIEcause_Item._val = 7
    
    #-----< id-RANfunction-Item >-----#
    id_RANfunction_Item = INT(name='id-RANfunction-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunction_Item._val = 8
    
    #-----< id-RANfunctionsAccepted >-----#
    id_RANfunctionsAccepted = INT(name='id-RANfunctionsAccepted', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionsAccepted._val = 9
    
    #-----< id-RANfunctionsAdded >-----#
    id_RANfunctionsAdded = INT(name='id-RANfunctionsAdded', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionsAdded._val = 10
    
    #-----< id-RANfunctionsDeleted >-----#
    id_RANfunctionsDeleted = INT(name='id-RANfunctionsDeleted', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionsDeleted._val = 11
    
    #-----< id-RANfunctionsModified >-----#
    id_RANfunctionsModified = INT(name='id-RANfunctionsModified', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionsModified._val = 12
    
    #-----< id-RANfunctionsRejected >-----#
    id_RANfunctionsRejected = INT(name='id-RANfunctionsRejected', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANfunctionsRejected._val = 13
    
    #-----< id-RICaction-Admitted-Item >-----#
    id_RICaction_Admitted_Item = INT(name='id-RICaction-Admitted-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_Admitted_Item._val = 14
    
    #-----< id-RICactionID >-----#
    id_RICactionID = INT(name='id-RICactionID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionID._val = 15
    
    #-----< id-RICaction-NotAdmitted-Item >-----#
    id_RICaction_NotAdmitted_Item = INT(name='id-RICaction-NotAdmitted-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_NotAdmitted_Item._val = 16
    
    #-----< id-RICactions-Admitted >-----#
    id_RICactions_Admitted = INT(name='id-RICactions-Admitted', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactions_Admitted._val = 17
    
    #-----< id-RICactions-NotAdmitted >-----#
    id_RICactions_NotAdmitted = INT(name='id-RICactions-NotAdmitted', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactions_NotAdmitted._val = 18
    
    #-----< id-RICaction-ToBeSetup-Item >-----#
    id_RICaction_ToBeSetup_Item = INT(name='id-RICaction-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ToBeSetup_Item._val = 19
    
    #-----< id-RICcallProcessID >-----#
    id_RICcallProcessID = INT(name='id-RICcallProcessID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICcallProcessID._val = 20
    
    #-----< id-RICcontrolAckRequest >-----#
    id_RICcontrolAckRequest = INT(name='id-RICcontrolAckRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICcontrolAckRequest._val = 21
    
    #-----< id-RICcontrolHeader >-----#
    id_RICcontrolHeader = INT(name='id-RICcontrolHeader', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICcontrolHeader._val = 22
    
    #-----< id-RICcontrolMessage >-----#
    id_RICcontrolMessage = INT(name='id-RICcontrolMessage', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICcontrolMessage._val = 23
    
    #-----< id-RICcontrolStatus >-----#
    id_RICcontrolStatus = INT(name='id-RICcontrolStatus', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICcontrolStatus._val = 24
    
    #-----< id-RICindicationHeader >-----#
    id_RICindicationHeader = INT(name='id-RICindicationHeader', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICindicationHeader._val = 25
    
    #-----< id-RICindicationMessage >-----#
    id_RICindicationMessage = INT(name='id-RICindicationMessage', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICindicationMessage._val = 26
    
    #-----< id-RICindicationSN >-----#
    id_RICindicationSN = INT(name='id-RICindicationSN', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICindicationSN._val = 27
    
    #-----< id-RICindicationType >-----#
    id_RICindicationType = INT(name='id-RICindicationType', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICindicationType._val = 28
    
    #-----< id-RICrequestID >-----#
    id_RICrequestID = INT(name='id-RICrequestID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICrequestID._val = 29
    
    #-----< id-RICsubscriptionDetails >-----#
    id_RICsubscriptionDetails = INT(name='id-RICsubscriptionDetails', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionDetails._val = 30
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name='id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 31
    
    #-----< id-RICcontrolOutcome >-----#
    id_RICcontrolOutcome = INT(name='id-RICcontrolOutcome', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICcontrolOutcome._val = 32
    
    #-----< id-E2nodeComponentConfigUpdate >-----#
    id_E2nodeComponentConfigUpdate = INT(name='id-E2nodeComponentConfigUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigUpdate._val = 33
    
    #-----< id-E2nodeComponentConfigUpdate-Item >-----#
    id_E2nodeComponentConfigUpdate_Item = INT(name='id-E2nodeComponentConfigUpdate-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigUpdate_Item._val = 34
    
    #-----< id-E2nodeComponentConfigUpdateAck >-----#
    id_E2nodeComponentConfigUpdateAck = INT(name='id-E2nodeComponentConfigUpdateAck', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigUpdateAck._val = 35
    
    #-----< id-E2nodeComponentConfigUpdateAck-Item >-----#
    id_E2nodeComponentConfigUpdateAck_Item = INT(name='id-E2nodeComponentConfigUpdateAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigUpdateAck_Item._val = 36
    
    #-----< id-E2connectionSetup >-----#
    id_E2connectionSetup = INT(name='id-E2connectionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionSetup._val = 39
    
    #-----< id-E2connectionSetupFailed >-----#
    id_E2connectionSetupFailed = INT(name='id-E2connectionSetupFailed', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionSetupFailed._val = 40
    
    #-----< id-E2connectionSetupFailed-Item >-----#
    id_E2connectionSetupFailed_Item = INT(name='id-E2connectionSetupFailed-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionSetupFailed_Item._val = 41
    
    #-----< id-E2connectionFailed-Item >-----#
    id_E2connectionFailed_Item = INT(name='id-E2connectionFailed-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionFailed_Item._val = 42
    
    #-----< id-E2connectionUpdate-Item >-----#
    id_E2connectionUpdate_Item = INT(name='id-E2connectionUpdate-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionUpdate_Item._val = 43
    
    #-----< id-E2connectionUpdateAdd >-----#
    id_E2connectionUpdateAdd = INT(name='id-E2connectionUpdateAdd', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionUpdateAdd._val = 44
    
    #-----< id-E2connectionUpdateModify >-----#
    id_E2connectionUpdateModify = INT(name='id-E2connectionUpdateModify', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionUpdateModify._val = 45
    
    #-----< id-E2connectionUpdateRemove >-----#
    id_E2connectionUpdateRemove = INT(name='id-E2connectionUpdateRemove', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionUpdateRemove._val = 46
    
    #-----< id-E2connectionUpdateRemove-Item >-----#
    id_E2connectionUpdateRemove_Item = INT(name='id-E2connectionUpdateRemove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2connectionUpdateRemove_Item._val = 47
    
    #-----< id-TNLinformation >-----#
    id_TNLinformation = INT(name='id-TNLinformation', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLinformation._val = 48
    
    #-----< id-TransactionID >-----#
    id_TransactionID = INT(name='id-TransactionID', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransactionID._val = 49
    
    #-----< id-E2nodeComponentConfigAddition >-----#
    id_E2nodeComponentConfigAddition = INT(name='id-E2nodeComponentConfigAddition', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigAddition._val = 50
    
    #-----< id-E2nodeComponentConfigAddition-Item >-----#
    id_E2nodeComponentConfigAddition_Item = INT(name='id-E2nodeComponentConfigAddition-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigAddition_Item._val = 51
    
    #-----< id-E2nodeComponentConfigAdditionAck >-----#
    id_E2nodeComponentConfigAdditionAck = INT(name='id-E2nodeComponentConfigAdditionAck', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigAdditionAck._val = 52
    
    #-----< id-E2nodeComponentConfigAdditionAck-Item >-----#
    id_E2nodeComponentConfigAdditionAck_Item = INT(name='id-E2nodeComponentConfigAdditionAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigAdditionAck_Item._val = 53
    
    #-----< id-E2nodeComponentConfigRemoval >-----#
    id_E2nodeComponentConfigRemoval = INT(name='id-E2nodeComponentConfigRemoval', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigRemoval._val = 54
    
    #-----< id-E2nodeComponentConfigRemoval-Item >-----#
    id_E2nodeComponentConfigRemoval_Item = INT(name='id-E2nodeComponentConfigRemoval-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigRemoval_Item._val = 55
    
    #-----< id-E2nodeComponentConfigRemovalAck >-----#
    id_E2nodeComponentConfigRemovalAck = INT(name='id-E2nodeComponentConfigRemovalAck', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigRemovalAck._val = 56
    
    #-----< id-E2nodeComponentConfigRemovalAck-Item >-----#
    id_E2nodeComponentConfigRemovalAck_Item = INT(name='id-E2nodeComponentConfigRemovalAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeComponentConfigRemovalAck_Item._val = 57
    
    #-----< id-E2nodeTNLassociationRemoval >-----#
    id_E2nodeTNLassociationRemoval = INT(name='id-E2nodeTNLassociationRemoval', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeTNLassociationRemoval._val = 58
    
    #-----< id-E2nodeTNLassociationRemoval-Item >-----#
    id_E2nodeTNLassociationRemoval_Item = INT(name='id-E2nodeTNLassociationRemoval-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E2nodeTNLassociationRemoval_Item._val = 59
    
    #-----< id-RICsubscriptionToBeRemoved >-----#
    id_RICsubscriptionToBeRemoved = INT(name='id-RICsubscriptionToBeRemoved', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionToBeRemoved._val = 60
    
    #-----< id-RICsubscription-withCause-Item >-----#
    id_RICsubscription_withCause_Item = INT(name='id-RICsubscription-withCause-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscription_withCause_Item._val = 61
    
    #-----< id-RICsubscriptionStartTime >-----#
    id_RICsubscriptionStartTime = INT(name='id-RICsubscriptionStartTime', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionStartTime._val = 62
    
    #-----< id-RICsubscriptionEndTime >-----#
    id_RICsubscriptionEndTime = INT(name='id-RICsubscriptionEndTime', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionEndTime._val = 63
    
    #-----< id-RICeventTriggerDefinitionToBeModified >-----#
    id_RICeventTriggerDefinitionToBeModified = INT(name='id-RICeventTriggerDefinitionToBeModified', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICeventTriggerDefinitionToBeModified._val = 64
    
    #-----< id-RICactionsToBeRemovedForModification-List >-----#
    id_RICactionsToBeRemovedForModification_List = INT(name='id-RICactionsToBeRemovedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsToBeRemovedForModification_List._val = 65
    
    #-----< id-RICaction-ToBeRemovedForModification-Item >-----#
    id_RICaction_ToBeRemovedForModification_Item = INT(name='id-RICaction-ToBeRemovedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ToBeRemovedForModification_Item._val = 66
    
    #-----< id-RICactionsToBeModifiedForModification-List >-----#
    id_RICactionsToBeModifiedForModification_List = INT(name='id-RICactionsToBeModifiedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsToBeModifiedForModification_List._val = 67
    
    #-----< id-RICaction-ToBeModifiedForModification-Item >-----#
    id_RICaction_ToBeModifiedForModification_Item = INT(name='id-RICaction-ToBeModifiedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ToBeModifiedForModification_Item._val = 68
    
    #-----< id-RICactionsToBeAddedForModification-List >-----#
    id_RICactionsToBeAddedForModification_List = INT(name='id-RICactionsToBeAddedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsToBeAddedForModification_List._val = 69
    
    #-----< id-RICaction-ToBeAddedForModification-Item >-----#
    id_RICaction_ToBeAddedForModification_Item = INT(name='id-RICaction-ToBeAddedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ToBeAddedForModification_Item._val = 70
    
    #-----< id-RICactionsRemovedForModification-List >-----#
    id_RICactionsRemovedForModification_List = INT(name='id-RICactionsRemovedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsRemovedForModification_List._val = 71
    
    #-----< id-RICaction-RemovedForModification-Item >-----#
    id_RICaction_RemovedForModification_Item = INT(name='id-RICaction-RemovedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_RemovedForModification_Item._val = 72
    
    #-----< id-RICactionsFailedToBeRemovedForModification-List >-----#
    id_RICactionsFailedToBeRemovedForModification_List = INT(name='id-RICactionsFailedToBeRemovedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsFailedToBeRemovedForModification_List._val = 73
    
    #-----< id-RICaction-FailedToBeRemovedForModification-Item >-----#
    id_RICaction_FailedToBeRemovedForModification_Item = INT(name='id-RICaction-FailedToBeRemovedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_FailedToBeRemovedForModification_Item._val = 74
    
    #-----< id-RICactionsModifiedForModification-List >-----#
    id_RICactionsModifiedForModification_List = INT(name='id-RICactionsModifiedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsModifiedForModification_List._val = 75
    
    #-----< id-RICaction-ModifiedForModification-Item >-----#
    id_RICaction_ModifiedForModification_Item = INT(name='id-RICaction-ModifiedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ModifiedForModification_Item._val = 76
    
    #-----< id-RICactionsFailedToBeModifiedForModification-List >-----#
    id_RICactionsFailedToBeModifiedForModification_List = INT(name='id-RICactionsFailedToBeModifiedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsFailedToBeModifiedForModification_List._val = 77
    
    #-----< id-RICaction-FailedToBeModifiedForModification-Item >-----#
    id_RICaction_FailedToBeModifiedForModification_Item = INT(name='id-RICaction-FailedToBeModifiedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_FailedToBeModifiedForModification_Item._val = 78
    
    #-----< id-RICactionsAddedForModification-List >-----#
    id_RICactionsAddedForModification_List = INT(name='id-RICactionsAddedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsAddedForModification_List._val = 79
    
    #-----< id-RICaction-AddedForModification-Item >-----#
    id_RICaction_AddedForModification_Item = INT(name='id-RICaction-AddedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_AddedForModification_Item._val = 80
    
    #-----< id-RICactionsFailedToBeAddedForModification-List >-----#
    id_RICactionsFailedToBeAddedForModification_List = INT(name='id-RICactionsFailedToBeAddedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsFailedToBeAddedForModification_List._val = 81
    
    #-----< id-RICaction-FailedToBeAddedForModification-Item >-----#
    id_RICaction_FailedToBeAddedForModification_Item = INT(name='id-RICaction-FailedToBeAddedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_FailedToBeAddedForModification_Item._val = 82
    
    #-----< id-RICactionsRequiredToBeModified-List >-----#
    id_RICactionsRequiredToBeModified_List = INT(name='id-RICactionsRequiredToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsRequiredToBeModified_List._val = 83
    
    #-----< id-RICaction-RequiredToBeModified-Item >-----#
    id_RICaction_RequiredToBeModified_Item = INT(name='id-RICaction-RequiredToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_RequiredToBeModified_Item._val = 84
    
    #-----< id-RICactionsRequiredToBeRemoved-List >-----#
    id_RICactionsRequiredToBeRemoved_List = INT(name='id-RICactionsRequiredToBeRemoved-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsRequiredToBeRemoved_List._val = 85
    
    #-----< id-RICaction-RequiredToBeRemoved-Item >-----#
    id_RICaction_RequiredToBeRemoved_Item = INT(name='id-RICaction-RequiredToBeRemoved-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_RequiredToBeRemoved_Item._val = 86
    
    #-----< id-RICactionsConfirmedForModification-List >-----#
    id_RICactionsConfirmedForModification_List = INT(name='id-RICactionsConfirmedForModification-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsConfirmedForModification_List._val = 87
    
    #-----< id-RICaction-ConfirmedForModification-Item >-----#
    id_RICaction_ConfirmedForModification_Item = INT(name='id-RICaction-ConfirmedForModification-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ConfirmedForModification_Item._val = 88
    
    #-----< id-RICactionsRefusedToBeModified-List >-----#
    id_RICactionsRefusedToBeModified_List = INT(name='id-RICactionsRefusedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsRefusedToBeModified_List._val = 89
    
    #-----< id-RICaction-RefusedToBeModified-Item >-----#
    id_RICaction_RefusedToBeModified_Item = INT(name='id-RICaction-RefusedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_RefusedToBeModified_Item._val = 90
    
    #-----< id-RICactionsConfirmedForRemoval-List >-----#
    id_RICactionsConfirmedForRemoval_List = INT(name='id-RICactionsConfirmedForRemoval-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsConfirmedForRemoval_List._val = 91
    
    #-----< id-RICaction-ConfirmedForRemoval-Item >-----#
    id_RICaction_ConfirmedForRemoval_Item = INT(name='id-RICaction-ConfirmedForRemoval-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_ConfirmedForRemoval_Item._val = 92
    
    #-----< id-RICactionsRefusedToBeRemoved-List >-----#
    id_RICactionsRefusedToBeRemoved_List = INT(name='id-RICactionsRefusedToBeRemoved-List', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICactionsRefusedToBeRemoved_List._val = 93
    
    #-----< id-RICaction-RefusedToBeRemoved-Item >-----#
    id_RICaction_RefusedToBeRemoved_Item = INT(name='id-RICaction-RefusedToBeRemoved-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICaction_RefusedToBeRemoved_Item._val = 94
    
    #-----< id-RICqueryHeader >-----#
    id_RICqueryHeader = INT(name='id-RICqueryHeader', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICqueryHeader._val = 95
    
    #-----< id-RICqueryDefinition >-----#
    id_RICqueryDefinition = INT(name='id-RICqueryDefinition', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICqueryDefinition._val = 96
    
    #-----< id-RICqueryOutcome >-----#
    id_RICqueryOutcome = INT(name='id-RICqueryOutcome', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICqueryOutcome._val = 97
    
    #-----< id-RICsubscriptionAuditFlag >-----#
    id_RICsubscriptionAuditFlag = INT(name='id-RICsubscriptionAuditFlag', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAuditFlag._val = 98
    
    #-----< id-RICsubscriptionAuditList >-----#
    id_RICsubscriptionAuditList = INT(name='id-RICsubscriptionAuditList', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAuditList._val = 99
    
    #-----< id-RICsubscriptionAudit-Item >-----#
    id_RICsubscriptionAudit_Item = INT(name='id-RICsubscriptionAudit-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAudit_Item._val = 100
    
    #-----< id-RICsubscriptionAuditAction-Item >-----#
    id_RICsubscriptionAuditAction_Item = INT(name='id-RICsubscriptionAuditAction-Item', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAuditAction_Item._val = 101
    
    #-----< id-RICsubscriptionAuditConfirmedList >-----#
    id_RICsubscriptionAuditConfirmedList = INT(name='id-RICsubscriptionAuditConfirmedList', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAuditConfirmedList._val = 102
    
    #-----< id-RICsubscriptionAuditMissingList >-----#
    id_RICsubscriptionAuditMissingList = INT(name='id-RICsubscriptionAuditMissingList', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAuditMissingList._val = 103
    
    #-----< id-RICsubscriptionAuditUnkownList >-----#
    id_RICsubscriptionAuditUnkownList = INT(name='id-RICsubscriptionAuditUnkownList', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RICsubscriptionAuditUnkownList._val = 104
    
    _all_ = [
        id_E2setup,
        id_ErrorIndication,
        id_Reset,
        id_RICcontrol,
        id_RICindication,
        id_RICserviceQuery,
        id_RICserviceUpdate,
        id_RICsubscription,
        id_RICsubscriptionDelete,
        id_E2nodeConfigurationUpdate,
        id_E2connectionUpdate,
        id_RICsubscriptionDeleteRequired,
        id_E2removal,
        id_RICsubscriptionModification,
        id_RICsubscriptionModificationRequired,
        id_RICquery,
        id_RICsubscriptionAudit,
        maxProtocolIEs,
        maxnoofErrors,
        maxofE2nodeComponents,
        maxofRANfunctionID,
        maxofRICactionID,
        maxofTNLA,
        maxofRICrequestID,
        maxofRICsubscriptions,
        id_Cause,
        id_CriticalityDiagnostics,
        id_GlobalE2node_ID,
        id_GlobalRIC_ID,
        id_RANfunctionID,
        id_RANfunctionID_Item,
        id_RANfunctionIEcause_Item,
        id_RANfunction_Item,
        id_RANfunctionsAccepted,
        id_RANfunctionsAdded,
        id_RANfunctionsDeleted,
        id_RANfunctionsModified,
        id_RANfunctionsRejected,
        id_RICaction_Admitted_Item,
        id_RICactionID,
        id_RICaction_NotAdmitted_Item,
        id_RICactions_Admitted,
        id_RICactions_NotAdmitted,
        id_RICaction_ToBeSetup_Item,
        id_RICcallProcessID,
        id_RICcontrolAckRequest,
        id_RICcontrolHeader,
        id_RICcontrolMessage,
        id_RICcontrolStatus,
        id_RICindicationHeader,
        id_RICindicationMessage,
        id_RICindicationSN,
        id_RICindicationType,
        id_RICrequestID,
        id_RICsubscriptionDetails,
        id_TimeToWait,
        id_RICcontrolOutcome,
        id_E2nodeComponentConfigUpdate,
        id_E2nodeComponentConfigUpdate_Item,
        id_E2nodeComponentConfigUpdateAck,
        id_E2nodeComponentConfigUpdateAck_Item,
        id_E2connectionSetup,
        id_E2connectionSetupFailed,
        id_E2connectionSetupFailed_Item,
        id_E2connectionFailed_Item,
        id_E2connectionUpdate_Item,
        id_E2connectionUpdateAdd,
        id_E2connectionUpdateModify,
        id_E2connectionUpdateRemove,
        id_E2connectionUpdateRemove_Item,
        id_TNLinformation,
        id_TransactionID,
        id_E2nodeComponentConfigAddition,
        id_E2nodeComponentConfigAddition_Item,
        id_E2nodeComponentConfigAdditionAck,
        id_E2nodeComponentConfigAdditionAck_Item,
        id_E2nodeComponentConfigRemoval,
        id_E2nodeComponentConfigRemoval_Item,
        id_E2nodeComponentConfigRemovalAck,
        id_E2nodeComponentConfigRemovalAck_Item,
        id_E2nodeTNLassociationRemoval,
        id_E2nodeTNLassociationRemoval_Item,
        id_RICsubscriptionToBeRemoved,
        id_RICsubscription_withCause_Item,
        id_RICsubscriptionStartTime,
        id_RICsubscriptionEndTime,
        id_RICeventTriggerDefinitionToBeModified,
        id_RICactionsToBeRemovedForModification_List,
        id_RICaction_ToBeRemovedForModification_Item,
        id_RICactionsToBeModifiedForModification_List,
        id_RICaction_ToBeModifiedForModification_Item,
        id_RICactionsToBeAddedForModification_List,
        id_RICaction_ToBeAddedForModification_Item,
        id_RICactionsRemovedForModification_List,
        id_RICaction_RemovedForModification_Item,
        id_RICactionsFailedToBeRemovedForModification_List,
        id_RICaction_FailedToBeRemovedForModification_Item,
        id_RICactionsModifiedForModification_List,
        id_RICaction_ModifiedForModification_Item,
        id_RICactionsFailedToBeModifiedForModification_List,
        id_RICaction_FailedToBeModifiedForModification_Item,
        id_RICactionsAddedForModification_List,
        id_RICaction_AddedForModification_Item,
        id_RICactionsFailedToBeAddedForModification_List,
        id_RICaction_FailedToBeAddedForModification_Item,
        id_RICactionsRequiredToBeModified_List,
        id_RICaction_RequiredToBeModified_Item,
        id_RICactionsRequiredToBeRemoved_List,
        id_RICaction_RequiredToBeRemoved_Item,
        id_RICactionsConfirmedForModification_List,
        id_RICaction_ConfirmedForModification_Item,
        id_RICactionsRefusedToBeModified_List,
        id_RICaction_RefusedToBeModified_Item,
        id_RICactionsConfirmedForRemoval_List,
        id_RICaction_ConfirmedForRemoval_Item,
        id_RICactionsRefusedToBeRemoved_List,
        id_RICaction_RefusedToBeRemoved_Item,
        id_RICqueryHeader,
        id_RICqueryDefinition,
        id_RICqueryOutcome,
        id_RICsubscriptionAuditFlag,
        id_RICsubscriptionAuditList,
        id_RICsubscriptionAudit_Item,
        id_RICsubscriptionAuditAction_Item,
        id_RICsubscriptionAuditConfirmedList,
        id_RICsubscriptionAuditMissingList,
        id_RICsubscriptionAuditUnkownList,
    ]

class E2AP_Containers:

    _name_  = 'E2AP-Containers'
    _oid_   = [1, 3, 6, 1, 4, 1, 53148, 1, 2, 1, 5]
    
    _obj_ = [
        'E2AP-PROTOCOL-IES',
        'E2AP-PROTOCOL-IES-PAIR',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        ]
    _type_ = [
        'E2AP-PROTOCOL-IES',
        'E2AP-PROTOCOL-IES-PAIR',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'E2AP-PROTOCOL-IES',
        'E2AP-PROTOCOL-IES-PAIR',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        ]
    
    #-----< E2AP-PROTOCOL-IES >-----#
    E2AP_PROTOCOL_IES = CLASS(name='E2AP-PROTOCOL-IES', mode=MODE_TYPE)
    _E2AP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _E2AP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Criticality')))
    _E2AP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _E2AP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Presence')))
    E2AP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _E2AP_PROTOCOL_IES_id),
        ('criticality', _E2AP_PROTOCOL_IES_criticality),
        ('Value', _E2AP_PROTOCOL_IES_Value),
        ('presence', _E2AP_PROTOCOL_IES_presence),
        ])
    
    #-----< E2AP-PROTOCOL-IES-PAIR >-----#
    E2AP_PROTOCOL_IES_PAIR = CLASS(name='E2AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _E2AP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _E2AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Criticality')))
    _E2AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _E2AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Criticality')))
    _E2AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _E2AP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Presence')))
    E2AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _E2AP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _E2AP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _E2AP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _E2AP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _E2AP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _E2AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name='ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name='ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _E2AP_PROTOCOL_IES_id,
        _E2AP_PROTOCOL_IES_criticality,
        _E2AP_PROTOCOL_IES_Value,
        _E2AP_PROTOCOL_IES_presence,
        E2AP_PROTOCOL_IES,
        _E2AP_PROTOCOL_IES_PAIR_id,
        _E2AP_PROTOCOL_IES_PAIR_firstCriticality,
        _E2AP_PROTOCOL_IES_PAIR_FirstValue,
        _E2AP_PROTOCOL_IES_PAIR_secondCriticality,
        _E2AP_PROTOCOL_IES_PAIR_SecondValue,
        _E2AP_PROTOCOL_IES_PAIR_presence,
        E2AP_PROTOCOL_IES_PAIR,
    ]

class E2AP_IEs:

    _name_  = 'E2AP-IEs'
    _oid_   = [1, 3, 6, 1, 4, 1, 53148, 1, 2, 1, 2]
    
    _obj_ = [
        'AMFName',
        'Cause',
        'CauseE2node',
        'CauseMisc',
        'CauseProtocol',
        'CauseRICrequest',
        'CauseRICservice',
        'CauseTransport',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'E2nodeComponentConfiguration',
        'E2nodeComponentConfigurationAck',
        'E2nodeComponentInterfaceType',
        'E2nodeComponentID',
        'E2nodeComponentInterfaceE1',
        'E2nodeComponentInterfaceF1',
        'E2nodeComponentInterfaceNG',
        'E2nodeComponentInterfaceS1',
        'E2nodeComponentInterfaceX2',
        'E2nodeComponentInterfaceXn',
        'E2nodeComponentInterfaceW1',
        'ENB-ID',
        'ENB-ID-Choice',
        'ENGNB-ID',
        'GlobalE2node-ID',
        'GlobalE2node-en-gNB-ID',
        'GlobalE2node-eNB-ID',
        'GlobalE2node-gNB-ID',
        'GlobalE2node-ng-eNB-ID',
        'GlobalENB-ID',
        'GlobalenGNB-ID',
        'GlobalgNB-ID',
        'GlobalngeNB-ID',
        'GlobalNG-RANNode-ID',
        'GlobalRIC-ID',
        'GNB-CU-UP-ID',
        'GNB-DU-ID',
        'GNB-ID-Choice',
        'ListedRecordsOnly',
        'MMEname',
        'NGENB-DU-ID',
        'PLMN-Identity',
        'RANfunctionDefinition',
        'RANfunctionID',
        'RANfunctionOID',
        'RANfunctionRevision',
        'RICactionDefinition',
        'RICactionExecutionOrder',
        'RICactionID',
        'RICactionType',
        'RICcallProcessID',
        'RICcontrolAckRequest',
        'RICcontrolHeader',
        'RICcontrolMessage',
        'RICcontrolOutcome',
        'RICeventTriggerDefinition',
        'RICindicationHeader',
        'RICindicationMessage',
        'RICindicationSN',
        'RICindicationType',
        'RICrequestID',
        'RICsubscriptionTime',
        'RICsubsequentAction',
        'RICsubscriptionAuditFlag',
        'RICsubsequentActionType',
        'RICqueryHeader',
        'RICqueryDefinition',
        'RICqueryOutcome',
        'RICtimeToWait',
        'TimeToWait',
        'TNLinformation',
        'TNLusage',
        'TransactionID',
        'TypeOfError',
        ]
    _type_ = [
        'AMFName',
        'Cause',
        'CauseE2node',
        'CauseMisc',
        'CauseProtocol',
        'CauseRICrequest',
        'CauseRICservice',
        'CauseTransport',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'E2nodeComponentConfiguration',
        'E2nodeComponentConfigurationAck',
        'E2nodeComponentInterfaceType',
        'E2nodeComponentID',
        'E2nodeComponentInterfaceE1',
        'E2nodeComponentInterfaceF1',
        'E2nodeComponentInterfaceNG',
        'E2nodeComponentInterfaceS1',
        'E2nodeComponentInterfaceX2',
        'E2nodeComponentInterfaceXn',
        'E2nodeComponentInterfaceW1',
        'ENB-ID',
        'ENB-ID-Choice',
        'ENGNB-ID',
        'GlobalE2node-ID',
        'GlobalE2node-en-gNB-ID',
        'GlobalE2node-eNB-ID',
        'GlobalE2node-gNB-ID',
        'GlobalE2node-ng-eNB-ID',
        'GlobalENB-ID',
        'GlobalenGNB-ID',
        'GlobalgNB-ID',
        'GlobalngeNB-ID',
        'GlobalNG-RANNode-ID',
        'GlobalRIC-ID',
        'GNB-CU-UP-ID',
        'GNB-DU-ID',
        'GNB-ID-Choice',
        'ListedRecordsOnly',
        'MMEname',
        'NGENB-DU-ID',
        'PLMN-Identity',
        'RANfunctionDefinition',
        'RANfunctionID',
        'RANfunctionOID',
        'RANfunctionRevision',
        'RICactionDefinition',
        'RICactionExecutionOrder',
        'RICactionID',
        'RICactionType',
        'RICcallProcessID',
        'RICcontrolAckRequest',
        'RICcontrolHeader',
        'RICcontrolMessage',
        'RICcontrolOutcome',
        'RICeventTriggerDefinition',
        'RICindicationHeader',
        'RICindicationMessage',
        'RICindicationSN',
        'RICindicationType',
        'RICrequestID',
        'RICsubscriptionTime',
        'RICsubsequentAction',
        'RICsubscriptionAuditFlag',
        'RICsubsequentActionType',
        'RICqueryHeader',
        'RICqueryDefinition',
        'RICqueryOutcome',
        'RICtimeToWait',
        'TimeToWait',
        'TNLinformation',
        'TNLusage',
        'TransactionID',
        'TypeOfError',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< AMFName >-----#
    AMFName = STR_PRINT(name='AMFName', mode=MODE_TYPE)
    AMFName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_ricRequest = ENUM(name='ricRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CauseRICrequest')))
    _Cause_ricService = ENUM(name='ricService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CauseRICservice')))
    _Cause_e2Node = ENUM(name='e2Node', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CauseE2node')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('ricRequest', _Cause_ricRequest),
        ('ricService', _Cause_ricService),
        ('e2Node', _Cause_e2Node),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseE2node >-----#
    CauseE2node = ENUM(name='CauseE2node', mode=MODE_TYPE)
    CauseE2node._cont = ASN1Dict([('e2node-component-unknown', 0)])
    CauseE2node._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('hardware-failure', 1), ('om-intervention', 2), ('unspecified', 3)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('abstract-syntax-error-falsely-constructed-message', 5), ('unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRICrequest >-----#
    CauseRICrequest = ENUM(name='CauseRICrequest', mode=MODE_TYPE)
    CauseRICrequest._cont = ASN1Dict([('ran-function-id-invalid', 0), ('action-not-supported', 1), ('excessive-actions', 2), ('duplicate-action', 3), ('duplicate-event-trigger', 4), ('function-resource-limit', 5), ('request-id-unknown', 6), ('inconsistent-action-subsequent-action-sequence', 7), ('control-message-invalid', 8), ('ric-call-process-id-invalid', 9), ('control-timer-expired', 10), ('control-failed-to-execute', 11), ('system-not-ready', 12), ('unspecified', 13), ('ric-subscription-end-time-expired', 14), ('ric-subscription-end-time-invalid', 15), ('duplicate-ric-request-id', 16), ('eventTriggerNotSupported', 17), ('requested-information-unavailable', 18), ('invalid-information-request', 19)])
    CauseRICrequest._ext = ['ric-subscription-end-time-expired', 'ric-subscription-end-time-invalid', 'duplicate-ric-request-id', 'eventTriggerNotSupported', 'requested-information-unavailable', 'invalid-information-request']
    
    #-----< CauseRICservice >-----#
    CauseRICservice = ENUM(name='CauseRICservice', mode=MODE_TYPE)
    CauseRICservice._cont = ASN1Dict([('ran-function-not-supported', 0), ('excessive-functions', 1), ('ric-resource-limit', 2)])
    CauseRICservice._ext = []
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('unspecified', 0), ('transport-resource-unavailable', 1)])
    CauseTransport._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_ricRequestorID = SEQ(name='ricRequestorID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('ricRequestorID', _CriticalityDiagnostics_ricRequestorID),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name='CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TypeOfError')))
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        ('iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        ('iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        ('typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< E2nodeComponentConfiguration >-----#
    E2nodeComponentConfiguration = SEQ(name='E2nodeComponentConfiguration', mode=MODE_TYPE)
    _E2nodeComponentConfiguration_e2nodeComponentRequestPart = OCT_STR(name='e2nodeComponentRequestPart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E2nodeComponentConfiguration_e2nodeComponentResponsePart = OCT_STR(name='e2nodeComponentResponsePart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    E2nodeComponentConfiguration._cont = ASN1Dict([
        ('e2nodeComponentRequestPart', _E2nodeComponentConfiguration_e2nodeComponentRequestPart),
        ('e2nodeComponentResponsePart', _E2nodeComponentConfiguration_e2nodeComponentResponsePart),
        ])
    E2nodeComponentConfiguration._ext = []
    
    #-----< E2nodeComponentConfigurationAck >-----#
    E2nodeComponentConfigurationAck = SEQ(name='E2nodeComponentConfigurationAck', mode=MODE_TYPE)
    _E2nodeComponentConfigurationAck_updateOutcome = ENUM(name='updateOutcome', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E2nodeComponentConfigurationAck_updateOutcome._cont = ASN1Dict([('success', 0), ('failure', 1)])
    _E2nodeComponentConfigurationAck_updateOutcome._ext = []
    _E2nodeComponentConfigurationAck_failureCause = CHOICE(name='failureCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')), opt=True)
    E2nodeComponentConfigurationAck._cont = ASN1Dict([
        ('updateOutcome', _E2nodeComponentConfigurationAck_updateOutcome),
        ('failureCause', _E2nodeComponentConfigurationAck_failureCause),
        ])
    E2nodeComponentConfigurationAck._ext = []
    
    #-----< E2nodeComponentInterfaceType >-----#
    E2nodeComponentInterfaceType = ENUM(name='E2nodeComponentInterfaceType', mode=MODE_TYPE)
    E2nodeComponentInterfaceType._cont = ASN1Dict([('ng', 0), ('xn', 1), ('e1', 2), ('f1', 3), ('w1', 4), ('s1', 5), ('x2', 6)])
    E2nodeComponentInterfaceType._ext = []
    
    #-----< E2nodeComponentID >-----#
    E2nodeComponentID = CHOICE(name='E2nodeComponentID', mode=MODE_TYPE)
    _E2nodeComponentID_e2nodeComponentInterfaceTypeNG = SEQ(name='e2nodeComponentInterfaceTypeNG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceNG')))
    _E2nodeComponentID_e2nodeComponentInterfaceTypeXn = SEQ(name='e2nodeComponentInterfaceTypeXn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceXn')))
    _E2nodeComponentID_e2nodeComponentInterfaceTypeE1 = SEQ(name='e2nodeComponentInterfaceTypeE1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceE1')))
    _E2nodeComponentID_e2nodeComponentInterfaceTypeF1 = SEQ(name='e2nodeComponentInterfaceTypeF1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceF1')))
    _E2nodeComponentID_e2nodeComponentInterfaceTypeW1 = SEQ(name='e2nodeComponentInterfaceTypeW1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceW1')))
    _E2nodeComponentID_e2nodeComponentInterfaceTypeS1 = SEQ(name='e2nodeComponentInterfaceTypeS1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceS1')))
    _E2nodeComponentID_e2nodeComponentInterfaceTypeX2 = SEQ(name='e2nodeComponentInterfaceTypeX2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceX2')))
    E2nodeComponentID._cont = ASN1Dict([
        ('e2nodeComponentInterfaceTypeNG', _E2nodeComponentID_e2nodeComponentInterfaceTypeNG),
        ('e2nodeComponentInterfaceTypeXn', _E2nodeComponentID_e2nodeComponentInterfaceTypeXn),
        ('e2nodeComponentInterfaceTypeE1', _E2nodeComponentID_e2nodeComponentInterfaceTypeE1),
        ('e2nodeComponentInterfaceTypeF1', _E2nodeComponentID_e2nodeComponentInterfaceTypeF1),
        ('e2nodeComponentInterfaceTypeW1', _E2nodeComponentID_e2nodeComponentInterfaceTypeW1),
        ('e2nodeComponentInterfaceTypeS1', _E2nodeComponentID_e2nodeComponentInterfaceTypeS1),
        ('e2nodeComponentInterfaceTypeX2', _E2nodeComponentID_e2nodeComponentInterfaceTypeX2),
        ])
    E2nodeComponentID._ext = []
    
    #-----< E2nodeComponentInterfaceE1 >-----#
    E2nodeComponentInterfaceE1 = SEQ(name='E2nodeComponentInterfaceE1', mode=MODE_TYPE)
    _E2nodeComponentInterfaceE1_gNB_CU_UP_ID = INT(name='gNB-CU-UP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-CU-UP-ID')))
    E2nodeComponentInterfaceE1._cont = ASN1Dict([
        ('gNB-CU-UP-ID', _E2nodeComponentInterfaceE1_gNB_CU_UP_ID),
        ])
    E2nodeComponentInterfaceE1._ext = []
    
    #-----< E2nodeComponentInterfaceF1 >-----#
    E2nodeComponentInterfaceF1 = SEQ(name='E2nodeComponentInterfaceF1', mode=MODE_TYPE)
    _E2nodeComponentInterfaceF1_gNB_DU_ID = INT(name='gNB-DU-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-DU-ID')))
    E2nodeComponentInterfaceF1._cont = ASN1Dict([
        ('gNB-DU-ID', _E2nodeComponentInterfaceF1_gNB_DU_ID),
        ])
    E2nodeComponentInterfaceF1._ext = []
    
    #-----< E2nodeComponentInterfaceNG >-----#
    E2nodeComponentInterfaceNG = SEQ(name='E2nodeComponentInterfaceNG', mode=MODE_TYPE)
    _E2nodeComponentInterfaceNG_amf_name = STR_PRINT(name='amf-name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'AMFName')))
    E2nodeComponentInterfaceNG._cont = ASN1Dict([
        ('amf-name', _E2nodeComponentInterfaceNG_amf_name),
        ])
    E2nodeComponentInterfaceNG._ext = []
    
    #-----< E2nodeComponentInterfaceS1 >-----#
    E2nodeComponentInterfaceS1 = SEQ(name='E2nodeComponentInterfaceS1', mode=MODE_TYPE)
    _E2nodeComponentInterfaceS1_mme_name = STR_PRINT(name='mme-name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'MMEname')))
    E2nodeComponentInterfaceS1._cont = ASN1Dict([
        ('mme-name', _E2nodeComponentInterfaceS1_mme_name),
        ])
    E2nodeComponentInterfaceS1._ext = []
    
    #-----< E2nodeComponentInterfaceX2 >-----#
    E2nodeComponentInterfaceX2 = SEQ(name='E2nodeComponentInterfaceX2', mode=MODE_TYPE)
    _E2nodeComponentInterfaceX2_global_eNB_ID = SEQ(name='global-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalENB-ID')), opt=True)
    _E2nodeComponentInterfaceX2_global_en_gNB_ID = SEQ(name='global-en-gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalenGNB-ID')), opt=True)
    E2nodeComponentInterfaceX2._cont = ASN1Dict([
        ('global-eNB-ID', _E2nodeComponentInterfaceX2_global_eNB_ID),
        ('global-en-gNB-ID', _E2nodeComponentInterfaceX2_global_en_gNB_ID),
        ])
    E2nodeComponentInterfaceX2._ext = []
    
    #-----< E2nodeComponentInterfaceXn >-----#
    E2nodeComponentInterfaceXn = SEQ(name='E2nodeComponentInterfaceXn', mode=MODE_TYPE)
    _E2nodeComponentInterfaceXn_global_NG_RAN_Node_ID = CHOICE(name='global-NG-RAN-Node-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalNG-RANNode-ID')))
    E2nodeComponentInterfaceXn._cont = ASN1Dict([
        ('global-NG-RAN-Node-ID', _E2nodeComponentInterfaceXn_global_NG_RAN_Node_ID),
        ])
    E2nodeComponentInterfaceXn._ext = []
    
    #-----< E2nodeComponentInterfaceW1 >-----#
    E2nodeComponentInterfaceW1 = SEQ(name='E2nodeComponentInterfaceW1', mode=MODE_TYPE)
    _E2nodeComponentInterfaceW1_ng_eNB_DU_ID = INT(name='ng-eNB-DU-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'NGENB-DU-ID')))
    E2nodeComponentInterfaceW1._cont = ASN1Dict([
        ('ng-eNB-DU-ID', _E2nodeComponentInterfaceW1_ng_eNB_DU_ID),
        ])
    E2nodeComponentInterfaceW1._ext = []
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name='ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macro_eNB_ID = BIT_STR(name='macro-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macro_eNB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_home_eNB_ID = BIT_STR(name='home-eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_home_eNB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_Macro_eNB_ID = BIT_STR(name='short-Macro-eNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_Macro_eNB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_Macro_eNB_ID = BIT_STR(name='long-Macro-eNB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_Macro_eNB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        ('macro-eNB-ID', _ENB_ID_macro_eNB_ID),
        ('home-eNB-ID', _ENB_ID_home_eNB_ID),
        ('short-Macro-eNB-ID', _ENB_ID_short_Macro_eNB_ID),
        ('long-Macro-eNB-ID', _ENB_ID_long_Macro_eNB_ID),
        ])
    ENB_ID._ext = ['short-Macro-eNB-ID', 'long-Macro-eNB-ID']
    
    #-----< ENB-ID-Choice >-----#
    ENB_ID_Choice = CHOICE(name='ENB-ID-Choice', mode=MODE_TYPE)
    _ENB_ID_Choice_enb_ID_macro = BIT_STR(name='enb-ID-macro', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_Choice_enb_ID_macro._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_Choice_enb_ID_shortmacro = BIT_STR(name='enb-ID-shortmacro', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_Choice_enb_ID_shortmacro._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_Choice_enb_ID_longmacro = BIT_STR(name='enb-ID-longmacro', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_Choice_enb_ID_longmacro._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID_Choice._cont = ASN1Dict([
        ('enb-ID-macro', _ENB_ID_Choice_enb_ID_macro),
        ('enb-ID-shortmacro', _ENB_ID_Choice_enb_ID_shortmacro),
        ('enb-ID-longmacro', _ENB_ID_Choice_enb_ID_longmacro),
        ])
    ENB_ID_Choice._ext = []
    
    #-----< ENGNB-ID >-----#
    ENGNB_ID = CHOICE(name='ENGNB-ID', mode=MODE_TYPE)
    _ENGNB_ID_gNB_ID = BIT_STR(name='gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENGNB_ID_gNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    ENGNB_ID._cont = ASN1Dict([
        ('gNB-ID', _ENGNB_ID_gNB_ID),
        ])
    ENGNB_ID._ext = []
    
    #-----< GlobalE2node-ID >-----#
    GlobalE2node_ID = CHOICE(name='GlobalE2node-ID', mode=MODE_TYPE)
    _GlobalE2node_ID_gNB = SEQ(name='gNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-gNB-ID')))
    _GlobalE2node_ID_en_gNB = SEQ(name='en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-en-gNB-ID')))
    _GlobalE2node_ID_ng_eNB = SEQ(name='ng-eNB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-ng-eNB-ID')))
    _GlobalE2node_ID_eNB = SEQ(name='eNB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-eNB-ID')))
    GlobalE2node_ID._cont = ASN1Dict([
        ('gNB', _GlobalE2node_ID_gNB),
        ('en-gNB', _GlobalE2node_ID_en_gNB),
        ('ng-eNB', _GlobalE2node_ID_ng_eNB),
        ('eNB', _GlobalE2node_ID_eNB),
        ])
    GlobalE2node_ID._ext = []
    
    #-----< GlobalE2node-en-gNB-ID >-----#
    GlobalE2node_en_gNB_ID = SEQ(name='GlobalE2node-en-gNB-ID', mode=MODE_TYPE)
    _GlobalE2node_en_gNB_ID_global_en_gNB_ID = SEQ(name='global-en-gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalenGNB-ID')))
    _GlobalE2node_en_gNB_ID_en_gNB_CU_UP_ID = INT(name='en-gNB-CU-UP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-CU-UP-ID')), opt=True)
    _GlobalE2node_en_gNB_ID_en_gNB_DU_ID = INT(name='en-gNB-DU-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-DU-ID')), opt=True)
    GlobalE2node_en_gNB_ID._cont = ASN1Dict([
        ('global-en-gNB-ID', _GlobalE2node_en_gNB_ID_global_en_gNB_ID),
        ('en-gNB-CU-UP-ID', _GlobalE2node_en_gNB_ID_en_gNB_CU_UP_ID),
        ('en-gNB-DU-ID', _GlobalE2node_en_gNB_ID_en_gNB_DU_ID),
        ])
    GlobalE2node_en_gNB_ID._ext = []
    
    #-----< GlobalE2node-eNB-ID >-----#
    GlobalE2node_eNB_ID = SEQ(name='GlobalE2node-eNB-ID', mode=MODE_TYPE)
    _GlobalE2node_eNB_ID_global_eNB_ID = SEQ(name='global-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalENB-ID')))
    GlobalE2node_eNB_ID._cont = ASN1Dict([
        ('global-eNB-ID', _GlobalE2node_eNB_ID_global_eNB_ID),
        ])
    GlobalE2node_eNB_ID._ext = []
    
    #-----< GlobalE2node-gNB-ID >-----#
    GlobalE2node_gNB_ID = SEQ(name='GlobalE2node-gNB-ID', mode=MODE_TYPE)
    _GlobalE2node_gNB_ID_global_gNB_ID = SEQ(name='global-gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalgNB-ID')))
    _GlobalE2node_gNB_ID_global_en_gNB_ID = SEQ(name='global-en-gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalenGNB-ID')), opt=True)
    _GlobalE2node_gNB_ID_gNB_CU_UP_ID = INT(name='gNB-CU-UP-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-CU-UP-ID')), opt=True)
    _GlobalE2node_gNB_ID_gNB_DU_ID = INT(name='gNB-DU-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-DU-ID')), opt=True)
    GlobalE2node_gNB_ID._cont = ASN1Dict([
        ('global-gNB-ID', _GlobalE2node_gNB_ID_global_gNB_ID),
        ('global-en-gNB-ID', _GlobalE2node_gNB_ID_global_en_gNB_ID),
        ('gNB-CU-UP-ID', _GlobalE2node_gNB_ID_gNB_CU_UP_ID),
        ('gNB-DU-ID', _GlobalE2node_gNB_ID_gNB_DU_ID),
        ])
    GlobalE2node_gNB_ID._ext = []
    
    #-----< GlobalE2node-ng-eNB-ID >-----#
    GlobalE2node_ng_eNB_ID = SEQ(name='GlobalE2node-ng-eNB-ID', mode=MODE_TYPE)
    _GlobalE2node_ng_eNB_ID_global_ng_eNB_ID = SEQ(name='global-ng-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalngeNB-ID')))
    _GlobalE2node_ng_eNB_ID_global_eNB_ID = SEQ(name='global-eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalENB-ID')), opt=True)
    _GlobalE2node_ng_eNB_ID_ngENB_DU_ID = INT(name='ngENB-DU-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'NGENB-DU-ID')), opt=True)
    GlobalE2node_ng_eNB_ID._cont = ASN1Dict([
        ('global-ng-eNB-ID', _GlobalE2node_ng_eNB_ID_global_ng_eNB_ID),
        ('global-eNB-ID', _GlobalE2node_ng_eNB_ID_global_eNB_ID),
        ('ngENB-DU-ID', _GlobalE2node_ng_eNB_ID_ngENB_DU_ID),
        ])
    GlobalE2node_ng_eNB_ID._ext = []
    
    #-----< GlobalENB-ID >-----#
    GlobalENB_ID = SEQ(name='GlobalENB-ID', mode=MODE_TYPE)
    _GlobalENB_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'PLMN-Identity')))
    _GlobalENB_ID_eNB_ID = CHOICE(name='eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'ENB-ID')))
    GlobalENB_ID._cont = ASN1Dict([
        ('pLMN-Identity', _GlobalENB_ID_pLMN_Identity),
        ('eNB-ID', _GlobalENB_ID_eNB_ID),
        ])
    GlobalENB_ID._ext = []
    
    #-----< GlobalenGNB-ID >-----#
    GlobalenGNB_ID = SEQ(name='GlobalenGNB-ID', mode=MODE_TYPE)
    _GlobalenGNB_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'PLMN-Identity')))
    _GlobalenGNB_ID_gNB_ID = CHOICE(name='gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'ENGNB-ID')))
    GlobalenGNB_ID._cont = ASN1Dict([
        ('pLMN-Identity', _GlobalenGNB_ID_pLMN_Identity),
        ('gNB-ID', _GlobalenGNB_ID_gNB_ID),
        ])
    GlobalenGNB_ID._ext = []
    
    #-----< GlobalgNB-ID >-----#
    GlobalgNB_ID = SEQ(name='GlobalgNB-ID', mode=MODE_TYPE)
    _GlobalgNB_ID_plmn_id = OCT_STR(name='plmn-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'PLMN-Identity')))
    _GlobalgNB_ID_gnb_id = CHOICE(name='gnb-id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GNB-ID-Choice')))
    GlobalgNB_ID._cont = ASN1Dict([
        ('plmn-id', _GlobalgNB_ID_plmn_id),
        ('gnb-id', _GlobalgNB_ID_gnb_id),
        ])
    GlobalgNB_ID._ext = []
    
    #-----< GlobalngeNB-ID >-----#
    GlobalngeNB_ID = SEQ(name='GlobalngeNB-ID', mode=MODE_TYPE)
    _GlobalngeNB_ID_plmn_id = OCT_STR(name='plmn-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'PLMN-Identity')))
    _GlobalngeNB_ID_enb_id = CHOICE(name='enb-id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'ENB-ID-Choice')))
    GlobalngeNB_ID._cont = ASN1Dict([
        ('plmn-id', _GlobalngeNB_ID_plmn_id),
        ('enb-id', _GlobalngeNB_ID_enb_id),
        ])
    GlobalngeNB_ID._ext = []
    
    #-----< GlobalNG-RANNode-ID >-----#
    GlobalNG_RANNode_ID = CHOICE(name='GlobalNG-RANNode-ID', mode=MODE_TYPE)
    _GlobalNG_RANNode_ID_gNB = SEQ(name='gNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalgNB-ID')))
    _GlobalNG_RANNode_ID_ng_eNB = SEQ(name='ng-eNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'GlobalngeNB-ID')))
    GlobalNG_RANNode_ID._cont = ASN1Dict([
        ('gNB', _GlobalNG_RANNode_ID_gNB),
        ('ng-eNB', _GlobalNG_RANNode_ID_ng_eNB),
        ])
    GlobalNG_RANNode_ID._ext = []
    
    #-----< GlobalRIC-ID >-----#
    GlobalRIC_ID = SEQ(name='GlobalRIC-ID', mode=MODE_TYPE)
    _GlobalRIC_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'PLMN-Identity')))
    _GlobalRIC_ID_ric_ID = BIT_STR(name='ric-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GlobalRIC_ID_ric_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    GlobalRIC_ID._cont = ASN1Dict([
        ('pLMN-Identity', _GlobalRIC_ID_pLMN_Identity),
        ('ric-ID', _GlobalRIC_ID_ric_ID),
        ])
    GlobalRIC_ID._ext = []
    
    #-----< GNB-CU-UP-ID >-----#
    GNB_CU_UP_ID = INT(name='GNB-CU-UP-ID', mode=MODE_TYPE)
    GNB_CU_UP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< GNB-DU-ID >-----#
    GNB_DU_ID = INT(name='GNB-DU-ID', mode=MODE_TYPE)
    GNB_DU_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< GNB-ID-Choice >-----#
    GNB_ID_Choice = CHOICE(name='GNB-ID-Choice', mode=MODE_TYPE)
    _GNB_ID_Choice_gnb_ID = BIT_STR(name='gnb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNB_ID_Choice_gnb_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    GNB_ID_Choice._cont = ASN1Dict([
        ('gnb-ID', _GNB_ID_Choice_gnb_ID),
        ])
    GNB_ID_Choice._ext = []
    
    #-----< ListedRecordsOnly >-----#
    ListedRecordsOnly = ENUM(name='ListedRecordsOnly', mode=MODE_TYPE)
    ListedRecordsOnly._cont = ASN1Dict([('true', 0)])
    ListedRecordsOnly._ext = []
    
    #-----< MMEname >-----#
    MMEname = STR_PRINT(name='MMEname', mode=MODE_TYPE)
    MMEname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< NGENB-DU-ID >-----#
    NGENB_DU_ID = INT(name='NGENB-DU-ID', mode=MODE_TYPE)
    NGENB_DU_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name='PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< RANfunctionDefinition >-----#
    RANfunctionDefinition = OCT_STR(name='RANfunctionDefinition', mode=MODE_TYPE)
    
    #-----< RANfunctionID >-----#
    RANfunctionID = INT(name='RANfunctionID', mode=MODE_TYPE)
    RANfunctionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RANfunctionOID >-----#
    RANfunctionOID = STR_PRINT(name='RANfunctionOID', mode=MODE_TYPE)
    RANfunctionOID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=[], er=[])
    
    #-----< RANfunctionRevision >-----#
    RANfunctionRevision = INT(name='RANfunctionRevision', mode=MODE_TYPE)
    RANfunctionRevision._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RICactionDefinition >-----#
    RICactionDefinition = OCT_STR(name='RICactionDefinition', mode=MODE_TYPE)
    
    #-----< RICactionExecutionOrder >-----#
    RICactionExecutionOrder = INT(name='RICactionExecutionOrder', mode=MODE_TYPE)
    RICactionExecutionOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< RICactionID >-----#
    RICactionID = INT(name='RICactionID', mode=MODE_TYPE)
    RICactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RICactionType >-----#
    RICactionType = ENUM(name='RICactionType', mode=MODE_TYPE)
    RICactionType._cont = ASN1Dict([('report', 0), ('insert', 1), ('policy', 2)])
    RICactionType._ext = []
    
    #-----< RICcallProcessID >-----#
    RICcallProcessID = OCT_STR(name='RICcallProcessID', mode=MODE_TYPE)
    
    #-----< RICcontrolAckRequest >-----#
    RICcontrolAckRequest = ENUM(name='RICcontrolAckRequest', mode=MODE_TYPE)
    RICcontrolAckRequest._cont = ASN1Dict([('noAck', 0), ('ack', 1)])
    RICcontrolAckRequest._ext = []
    
    #-----< RICcontrolHeader >-----#
    RICcontrolHeader = OCT_STR(name='RICcontrolHeader', mode=MODE_TYPE)
    
    #-----< RICcontrolMessage >-----#
    RICcontrolMessage = OCT_STR(name='RICcontrolMessage', mode=MODE_TYPE)
    
    #-----< RICcontrolOutcome >-----#
    RICcontrolOutcome = OCT_STR(name='RICcontrolOutcome', mode=MODE_TYPE)
    
    #-----< RICeventTriggerDefinition >-----#
    RICeventTriggerDefinition = OCT_STR(name='RICeventTriggerDefinition', mode=MODE_TYPE)
    
    #-----< RICindicationHeader >-----#
    RICindicationHeader = OCT_STR(name='RICindicationHeader', mode=MODE_TYPE)
    
    #-----< RICindicationMessage >-----#
    RICindicationMessage = OCT_STR(name='RICindicationMessage', mode=MODE_TYPE)
    
    #-----< RICindicationSN >-----#
    RICindicationSN = INT(name='RICindicationSN', mode=MODE_TYPE)
    RICindicationSN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< RICindicationType >-----#
    RICindicationType = ENUM(name='RICindicationType', mode=MODE_TYPE)
    RICindicationType._cont = ASN1Dict([('report', 0), ('insert', 1)])
    RICindicationType._ext = []
    
    #-----< RICrequestID >-----#
    RICrequestID = SEQ(name='RICrequestID', mode=MODE_TYPE)
    _RICrequestID_ricRequestorID = INT(name='ricRequestorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RICrequestID_ricRequestorID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RICrequestID_ricInstanceID = INT(name='ricInstanceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RICrequestID_ricInstanceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICrequestID._cont = ASN1Dict([
        ('ricRequestorID', _RICrequestID_ricRequestorID),
        ('ricInstanceID', _RICrequestID_ricInstanceID),
        ])
    RICrequestID._ext = []
    
    #-----< RICsubscriptionTime >-----#
    RICsubscriptionTime = OCT_STR(name='RICsubscriptionTime', mode=MODE_TYPE)
    RICsubscriptionTime._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RICsubsequentAction >-----#
    RICsubsequentAction = SEQ(name='RICsubsequentAction', mode=MODE_TYPE)
    _RICsubsequentAction_ricSubsequentActionType = ENUM(name='ricSubsequentActionType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICsubsequentActionType')))
    _RICsubsequentAction_ricTimeToWait = ENUM(name='ricTimeToWait', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICtimeToWait')))
    RICsubsequentAction._cont = ASN1Dict([
        ('ricSubsequentActionType', _RICsubsequentAction_ricSubsequentActionType),
        ('ricTimeToWait', _RICsubsequentAction_ricTimeToWait),
        ])
    RICsubsequentAction._ext = []
    
    #-----< RICsubscriptionAuditFlag >-----#
    RICsubscriptionAuditFlag = SEQ(name='RICsubscriptionAuditFlag', mode=MODE_TYPE)
    _RICsubscriptionAuditFlag_listedRecordsOnly = ENUM(name='listedRecordsOnly', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'ListedRecordsOnly')), opt=True)
    RICsubscriptionAuditFlag._cont = ASN1Dict([
        ('listedRecordsOnly', _RICsubscriptionAuditFlag_listedRecordsOnly),
        ])
    RICsubscriptionAuditFlag._ext = []
    
    #-----< RICsubsequentActionType >-----#
    RICsubsequentActionType = ENUM(name='RICsubsequentActionType', mode=MODE_TYPE)
    RICsubsequentActionType._cont = ASN1Dict([('continue', 0), ('wait', 1)])
    RICsubsequentActionType._ext = []
    
    #-----< RICqueryHeader >-----#
    RICqueryHeader = OCT_STR(name='RICqueryHeader', mode=MODE_TYPE)
    
    #-----< RICqueryDefinition >-----#
    RICqueryDefinition = OCT_STR(name='RICqueryDefinition', mode=MODE_TYPE)
    
    #-----< RICqueryOutcome >-----#
    RICqueryOutcome = OCT_STR(name='RICqueryOutcome', mode=MODE_TYPE)
    
    #-----< RICtimeToWait >-----#
    RICtimeToWait = ENUM(name='RICtimeToWait', mode=MODE_TYPE)
    RICtimeToWait._cont = ASN1Dict([('w1ms', 0), ('w2ms', 1), ('w5ms', 2), ('w10ms', 3), ('w20ms', 4), ('w30ms', 5), ('w40ms', 6), ('w50ms', 7), ('w100ms', 8), ('w200ms', 9), ('w500ms', 10), ('w1s', 11), ('w2s', 12), ('w5s', 13), ('w10s', 14), ('w20s', 15), ('w60s', 16)])
    RICtimeToWait._ext = []
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name='TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([('v1s', 0), ('v2s', 1), ('v5s', 2), ('v10s', 3), ('v20s', 4), ('v60s', 5)])
    TimeToWait._ext = []
    
    #-----< TNLinformation >-----#
    TNLinformation = SEQ(name='TNLinformation', mode=MODE_TYPE)
    _TNLinformation_tnlAddress = BIT_STR(name='tnlAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLinformation_tnlAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    _TNLinformation_tnlPort = BIT_STR(name='tnlPort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TNLinformation_tnlPort._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    TNLinformation._cont = ASN1Dict([
        ('tnlAddress', _TNLinformation_tnlAddress),
        ('tnlPort', _TNLinformation_tnlPort),
        ])
    TNLinformation._ext = []
    
    #-----< TNLusage >-----#
    TNLusage = ENUM(name='TNLusage', mode=MODE_TYPE)
    TNLusage._cont = ASN1Dict([('ric-service', 0), ('support-function', 1), ('both', 2)])
    TNLusage._ext = []
    
    #-----< TransactionID >-----#
    TransactionID = INT(name='TransactionID', mode=MODE_TYPE)
    TransactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    _all_ = [
        AMFName,
        _Cause_ricRequest,
        _Cause_ricService,
        _Cause_e2Node,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseE2node,
        CauseMisc,
        CauseProtocol,
        CauseRICrequest,
        CauseRICservice,
        CauseTransport,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_ricRequestorID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        CriticalityDiagnostics,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        CriticalityDiagnostics_IE_Item,
        _E2nodeComponentConfiguration_e2nodeComponentRequestPart,
        _E2nodeComponentConfiguration_e2nodeComponentResponsePart,
        E2nodeComponentConfiguration,
        _E2nodeComponentConfigurationAck_updateOutcome,
        _E2nodeComponentConfigurationAck_failureCause,
        E2nodeComponentConfigurationAck,
        E2nodeComponentInterfaceType,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeNG,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeXn,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeE1,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeF1,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeW1,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeS1,
        _E2nodeComponentID_e2nodeComponentInterfaceTypeX2,
        E2nodeComponentID,
        _E2nodeComponentInterfaceE1_gNB_CU_UP_ID,
        E2nodeComponentInterfaceE1,
        _E2nodeComponentInterfaceF1_gNB_DU_ID,
        E2nodeComponentInterfaceF1,
        _E2nodeComponentInterfaceNG_amf_name,
        E2nodeComponentInterfaceNG,
        _E2nodeComponentInterfaceS1_mme_name,
        E2nodeComponentInterfaceS1,
        _E2nodeComponentInterfaceX2_global_eNB_ID,
        _E2nodeComponentInterfaceX2_global_en_gNB_ID,
        E2nodeComponentInterfaceX2,
        _E2nodeComponentInterfaceXn_global_NG_RAN_Node_ID,
        E2nodeComponentInterfaceXn,
        _E2nodeComponentInterfaceW1_ng_eNB_DU_ID,
        E2nodeComponentInterfaceW1,
        _ENB_ID_macro_eNB_ID,
        _ENB_ID_home_eNB_ID,
        _ENB_ID_short_Macro_eNB_ID,
        _ENB_ID_long_Macro_eNB_ID,
        ENB_ID,
        _ENB_ID_Choice_enb_ID_macro,
        _ENB_ID_Choice_enb_ID_shortmacro,
        _ENB_ID_Choice_enb_ID_longmacro,
        ENB_ID_Choice,
        _ENGNB_ID_gNB_ID,
        ENGNB_ID,
        _GlobalE2node_ID_gNB,
        _GlobalE2node_ID_en_gNB,
        _GlobalE2node_ID_ng_eNB,
        _GlobalE2node_ID_eNB,
        GlobalE2node_ID,
        _GlobalE2node_en_gNB_ID_global_en_gNB_ID,
        _GlobalE2node_en_gNB_ID_en_gNB_CU_UP_ID,
        _GlobalE2node_en_gNB_ID_en_gNB_DU_ID,
        GlobalE2node_en_gNB_ID,
        _GlobalE2node_eNB_ID_global_eNB_ID,
        GlobalE2node_eNB_ID,
        _GlobalE2node_gNB_ID_global_gNB_ID,
        _GlobalE2node_gNB_ID_global_en_gNB_ID,
        _GlobalE2node_gNB_ID_gNB_CU_UP_ID,
        _GlobalE2node_gNB_ID_gNB_DU_ID,
        GlobalE2node_gNB_ID,
        _GlobalE2node_ng_eNB_ID_global_ng_eNB_ID,
        _GlobalE2node_ng_eNB_ID_global_eNB_ID,
        _GlobalE2node_ng_eNB_ID_ngENB_DU_ID,
        GlobalE2node_ng_eNB_ID,
        _GlobalENB_ID_pLMN_Identity,
        _GlobalENB_ID_eNB_ID,
        GlobalENB_ID,
        _GlobalenGNB_ID_pLMN_Identity,
        _GlobalenGNB_ID_gNB_ID,
        GlobalenGNB_ID,
        _GlobalgNB_ID_plmn_id,
        _GlobalgNB_ID_gnb_id,
        GlobalgNB_ID,
        _GlobalngeNB_ID_plmn_id,
        _GlobalngeNB_ID_enb_id,
        GlobalngeNB_ID,
        _GlobalNG_RANNode_ID_gNB,
        _GlobalNG_RANNode_ID_ng_eNB,
        GlobalNG_RANNode_ID,
        _GlobalRIC_ID_pLMN_Identity,
        _GlobalRIC_ID_ric_ID,
        GlobalRIC_ID,
        GNB_CU_UP_ID,
        GNB_DU_ID,
        _GNB_ID_Choice_gnb_ID,
        GNB_ID_Choice,
        ListedRecordsOnly,
        MMEname,
        NGENB_DU_ID,
        PLMN_Identity,
        RANfunctionDefinition,
        RANfunctionID,
        RANfunctionOID,
        RANfunctionRevision,
        RICactionDefinition,
        RICactionExecutionOrder,
        RICactionID,
        RICactionType,
        RICcallProcessID,
        RICcontrolAckRequest,
        RICcontrolHeader,
        RICcontrolMessage,
        RICcontrolOutcome,
        RICeventTriggerDefinition,
        RICindicationHeader,
        RICindicationMessage,
        RICindicationSN,
        RICindicationType,
        _RICrequestID_ricRequestorID,
        _RICrequestID_ricInstanceID,
        RICrequestID,
        RICsubscriptionTime,
        _RICsubsequentAction_ricSubsequentActionType,
        _RICsubsequentAction_ricTimeToWait,
        RICsubsequentAction,
        _RICsubscriptionAuditFlag_listedRecordsOnly,
        RICsubscriptionAuditFlag,
        RICsubsequentActionType,
        RICqueryHeader,
        RICqueryDefinition,
        RICqueryOutcome,
        RICtimeToWait,
        TimeToWait,
        _TNLinformation_tnlAddress,
        _TNLinformation_tnlPort,
        TNLinformation,
        TNLusage,
        TransactionID,
        TypeOfError,
    ]

class E2AP_PDU_Contents:

    _name_  = 'E2AP-PDU-Contents'
    _oid_   = [1, 3, 6, 1, 4, 1, 53148, 1, 2, 1, 1]
    
    _obj_ = [
        'RICsubscriptionRequest',
        'RICsubscriptionRequest-IEs',
        'RICsubscriptionDetails',
        'RICactions-ToBeSetup-List',
        'RICaction-ToBeSetup-ItemIEs',
        'RICaction-ToBeSetup-Item',
        'RICsubscriptionResponse',
        'RICsubscriptionResponse-IEs',
        'RICaction-Admitted-List',
        'RICaction-Admitted-ItemIEs',
        'RICaction-Admitted-Item',
        'RICaction-NotAdmitted-List',
        'RICaction-NotAdmitted-ItemIEs',
        'RICaction-NotAdmitted-Item',
        'RICsubscriptionFailure',
        'RICsubscriptionFailure-IEs',
        'RICsubscriptionAuditRequest',
        'RICsubscriptionAuditRequest-IEs',
        'RICsubscriptionAuditList',
        'RICsubscriptionAudit-ItemIEs',
        'RICsubscriptionAudit-Item',
        'RICsubscriptionAuditResponse',
        'RICsubscriptionAuditResponse-IEs',
        'RICsubscriptionAuditActionList',
        'RICsubscriptionAuditAction-ItemIEs',
        'RICsubscriptionAuditAction-Item',
        'RICsubscriptionAuditFailure',
        'RICsubscriptionAuditFailure-IEs',
        'RICsubscriptionDeleteRequest',
        'RICsubscriptionDeleteRequest-IEs',
        'RICsubscriptionDeleteResponse',
        'RICsubscriptionDeleteResponse-IEs',
        'RICsubscriptionDeleteFailure',
        'RICsubscriptionDeleteFailure-IEs',
        'RICsubscriptionDeleteRequired',
        'RICsubscriptionDeleteRequired-IEs',
        'RICsubscription-List-withCause',
        'RICsubscription-withCause-ItemIEs',
        'RICsubscription-withCause-Item',
        'RICsubscriptionModificationRequest',
        'RICsubscriptionModificationRequest-IEs',
        'RICactions-ToBeRemovedForModification-List',
        'RICaction-ToBeRemovedForModification-ItemIEs',
        'RICaction-ToBeRemovedForModification-Item',
        'RICactions-ToBeModifiedForModification-List',
        'RICaction-ToBeModifiedForModification-ItemIEs',
        'RICaction-ToBeModifiedForModification-Item',
        'RICactions-ToBeAddedForModification-List',
        'RICaction-ToBeAddedForModification-ItemIEs',
        'RICaction-ToBeAddedForModification-Item',
        'RICsubscriptionModificationResponse',
        'RICsubscriptionModificationResponse-IEs',
        'RICactions-RemovedForModification-List',
        'RICaction-RemovedForModification-ItemIEs',
        'RICaction-RemovedForModification-Item',
        'RICactions-FailedToBeRemovedForModification-List',
        'RICaction-FailedToBeRemovedForModification-ItemIEs',
        'RICaction-FailedToBeRemovedForModification-Item',
        'RICactions-ModifiedForModification-List',
        'RICaction-ModifiedForModification-ItemIEs',
        'RICaction-ModifiedForModification-Item',
        'RICactions-FailedToBeModifiedForModification-List',
        'RICaction-FailedToBeModifiedForModification-ItemIEs',
        'RICaction-FailedToBeModifiedForModification-Item',
        'RICactions-AddedForModification-List',
        'RICaction-AddedForModification-ItemIEs',
        'RICaction-AddedForModification-Item',
        'RICactions-FailedToBeAddedForModification-List',
        'RICaction-FailedToBeAddedForModification-ItemIEs',
        'RICaction-FailedToBeAddedForModification-Item',
        'RICsubscriptionModificationFailure',
        'RICsubscriptionModificationFailure-IEs',
        'RICsubscriptionModificationRequired',
        'RICsubscriptionModificationRequired-IEs',
        'RICactions-RequiredToBeModified-List',
        'RICaction-RequiredToBeModified-ItemIEs',
        'RICaction-RequiredToBeModified-Item',
        'RICactions-RequiredToBeRemoved-List',
        'RICaction-RequiredToBeRemoved-ItemIEs',
        'RICaction-RequiredToBeRemoved-Item',
        'RICsubscriptionModificationConfirm',
        'RICsubscriptionModificationConfirm-IEs',
        'RICactions-ConfirmedForModification-List',
        'RICaction-ConfirmedForModification-ItemIEs',
        'RICaction-ConfirmedForModification-Item',
        'RICactions-RefusedToBeModified-List',
        'RICaction-RefusedToBeModified-ItemIEs',
        'RICaction-RefusedToBeModified-Item',
        'RICactions-ConfirmedForRemoval-List',
        'RICaction-ConfirmedForRemoval-ItemIEs',
        'RICaction-ConfirmedForRemoval-Item',
        'RICactions-RefusedToBeRemoved-List',
        'RICaction-RefusedToBeRemoved-ItemIEs',
        'RICaction-RefusedToBeRemoved-Item',
        'RICsubscriptionModificationRefuse',
        'RICsubscriptionModificationRefuse-IEs',
        'RICindication',
        'RICindication-IEs',
        'RICcontrolRequest',
        'RICcontrolRequest-IEs',
        'RICcontrolAcknowledge',
        'RICcontrolAcknowledge-IEs',
        'RICcontrolFailure',
        'RICcontrolFailure-IEs',
        'RICqueryRequest',
        'RICqueryRequest-IEs',
        'RICqueryResponse',
        'RICqueryResponse-IEs',
        'RICqueryFailure',
        'RICqueryFailure-IEs',
        'ErrorIndication',
        'ErrorIndication-IEs',
        'E2setupRequest',
        'E2setupRequestIEs',
        'E2setupResponse',
        'E2setupResponseIEs',
        'E2setupFailure',
        'E2setupFailureIEs',
        'E2connectionUpdate',
        'E2connectionUpdate-IEs',
        'E2connectionUpdate-List',
        'E2connectionUpdate-ItemIEs',
        'E2connectionUpdate-Item',
        'E2connectionUpdateRemove-List',
        'E2connectionUpdateRemove-ItemIEs',
        'E2connectionUpdateRemove-Item',
        'E2connectionUpdateAcknowledge',
        'E2connectionUpdateAck-IEs',
        'E2connectionSetupFailed-List',
        'E2connectionSetupFailed-ItemIEs',
        'E2connectionSetupFailed-Item',
        'E2connectionUpdateFailure',
        'E2connectionUpdateFailure-IEs',
        'E2nodeConfigurationUpdate',
        'E2nodeConfigurationUpdate-IEs',
        'E2nodeComponentConfigAddition-List',
        'E2nodeComponentConfigAddition-ItemIEs',
        'E2nodeComponentConfigAddition-Item',
        'E2nodeComponentConfigUpdate-List',
        'E2nodeComponentConfigUpdate-ItemIEs',
        'E2nodeComponentConfigUpdate-Item',
        'E2nodeComponentConfigRemoval-List',
        'E2nodeComponentConfigRemoval-ItemIEs',
        'E2nodeComponentConfigRemoval-Item',
        'E2nodeTNLassociationRemoval-List',
        'E2nodeTNLassociationRemoval-ItemIEs',
        'E2nodeTNLassociationRemoval-Item',
        'E2nodeConfigurationUpdateAcknowledge',
        'E2nodeConfigurationUpdateAcknowledge-IEs',
        'E2nodeComponentConfigAdditionAck-List',
        'E2nodeComponentConfigAdditionAck-ItemIEs',
        'E2nodeComponentConfigAdditionAck-Item',
        'E2nodeComponentConfigUpdateAck-List',
        'E2nodeComponentConfigUpdateAck-ItemIEs',
        'E2nodeComponentConfigUpdateAck-Item',
        'E2nodeComponentConfigRemovalAck-List',
        'E2nodeComponentConfigRemovalAck-ItemIEs',
        'E2nodeComponentConfigRemovalAck-Item',
        'E2nodeConfigurationUpdateFailure',
        'E2nodeConfigurationUpdateFailure-IEs',
        'ResetRequest',
        'ResetRequestIEs',
        'ResetResponse',
        'ResetResponseIEs',
        'RICserviceUpdate',
        'RICserviceUpdate-IEs',
        'RANfunctions-List',
        'RANfunction-ItemIEs',
        'RANfunction-Item',
        'RANfunctionsID-List',
        'RANfunctionID-ItemIEs',
        'RANfunctionID-Item',
        'RICserviceUpdateAcknowledge',
        'RICserviceUpdateAcknowledge-IEs',
        'RANfunctionsIDcause-List',
        'RANfunctionIDcause-ItemIEs',
        'RANfunctionIDcause-Item',
        'RICserviceUpdateFailure',
        'RICserviceUpdateFailure-IEs',
        'RICserviceQuery',
        'RICserviceQuery-IEs',
        'E2RemovalRequest',
        'E2RemovalRequestIEs',
        'E2RemovalResponse',
        'E2RemovalResponseIEs',
        'E2RemovalFailure',
        'E2RemovalFailureIEs',
        ]
    _type_ = [
        'RICsubscriptionRequest',
        'RICsubscriptionDetails',
        'RICactions-ToBeSetup-List',
        'RICaction-ToBeSetup-Item',
        'RICsubscriptionResponse',
        'RICaction-Admitted-List',
        'RICaction-Admitted-Item',
        'RICaction-NotAdmitted-List',
        'RICaction-NotAdmitted-Item',
        'RICsubscriptionFailure',
        'RICsubscriptionAuditRequest',
        'RICsubscriptionAuditList',
        'RICsubscriptionAudit-Item',
        'RICsubscriptionAuditResponse',
        'RICsubscriptionAuditActionList',
        'RICsubscriptionAuditAction-Item',
        'RICsubscriptionAuditFailure',
        'RICsubscriptionDeleteRequest',
        'RICsubscriptionDeleteResponse',
        'RICsubscriptionDeleteFailure',
        'RICsubscriptionDeleteRequired',
        'RICsubscription-List-withCause',
        'RICsubscription-withCause-Item',
        'RICsubscriptionModificationRequest',
        'RICactions-ToBeRemovedForModification-List',
        'RICaction-ToBeRemovedForModification-Item',
        'RICactions-ToBeModifiedForModification-List',
        'RICaction-ToBeModifiedForModification-Item',
        'RICactions-ToBeAddedForModification-List',
        'RICaction-ToBeAddedForModification-Item',
        'RICsubscriptionModificationResponse',
        'RICactions-RemovedForModification-List',
        'RICaction-RemovedForModification-Item',
        'RICactions-FailedToBeRemovedForModification-List',
        'RICaction-FailedToBeRemovedForModification-Item',
        'RICactions-ModifiedForModification-List',
        'RICaction-ModifiedForModification-Item',
        'RICactions-FailedToBeModifiedForModification-List',
        'RICaction-FailedToBeModifiedForModification-Item',
        'RICactions-AddedForModification-List',
        'RICaction-AddedForModification-Item',
        'RICactions-FailedToBeAddedForModification-List',
        'RICaction-FailedToBeAddedForModification-Item',
        'RICsubscriptionModificationFailure',
        'RICsubscriptionModificationRequired',
        'RICactions-RequiredToBeModified-List',
        'RICaction-RequiredToBeModified-Item',
        'RICactions-RequiredToBeRemoved-List',
        'RICaction-RequiredToBeRemoved-Item',
        'RICsubscriptionModificationConfirm',
        'RICactions-ConfirmedForModification-List',
        'RICaction-ConfirmedForModification-Item',
        'RICactions-RefusedToBeModified-List',
        'RICaction-RefusedToBeModified-Item',
        'RICactions-ConfirmedForRemoval-List',
        'RICaction-ConfirmedForRemoval-Item',
        'RICactions-RefusedToBeRemoved-List',
        'RICaction-RefusedToBeRemoved-Item',
        'RICsubscriptionModificationRefuse',
        'RICindication',
        'RICcontrolRequest',
        'RICcontrolAcknowledge',
        'RICcontrolFailure',
        'RICqueryRequest',
        'RICqueryResponse',
        'RICqueryFailure',
        'ErrorIndication',
        'E2setupRequest',
        'E2setupResponse',
        'E2setupFailure',
        'E2connectionUpdate',
        'E2connectionUpdate-List',
        'E2connectionUpdate-Item',
        'E2connectionUpdateRemove-List',
        'E2connectionUpdateRemove-Item',
        'E2connectionUpdateAcknowledge',
        'E2connectionSetupFailed-List',
        'E2connectionSetupFailed-Item',
        'E2connectionUpdateFailure',
        'E2nodeConfigurationUpdate',
        'E2nodeComponentConfigAddition-List',
        'E2nodeComponentConfigAddition-Item',
        'E2nodeComponentConfigUpdate-List',
        'E2nodeComponentConfigUpdate-Item',
        'E2nodeComponentConfigRemoval-List',
        'E2nodeComponentConfigRemoval-Item',
        'E2nodeTNLassociationRemoval-List',
        'E2nodeTNLassociationRemoval-Item',
        'E2nodeConfigurationUpdateAcknowledge',
        'E2nodeComponentConfigAdditionAck-List',
        'E2nodeComponentConfigAdditionAck-Item',
        'E2nodeComponentConfigUpdateAck-List',
        'E2nodeComponentConfigUpdateAck-Item',
        'E2nodeComponentConfigRemovalAck-List',
        'E2nodeComponentConfigRemovalAck-Item',
        'E2nodeConfigurationUpdateFailure',
        'ResetRequest',
        'ResetResponse',
        'RICserviceUpdate',
        'RANfunctions-List',
        'RANfunction-Item',
        'RANfunctionsID-List',
        'RANfunctionID-Item',
        'RICserviceUpdateAcknowledge',
        'RANfunctionsIDcause-List',
        'RANfunctionIDcause-Item',
        'RICserviceUpdateFailure',
        'RICserviceQuery',
        'E2RemovalRequest',
        'E2RemovalResponse',
        'E2RemovalFailure',
        ]
    _set_ = [
        'RICsubscriptionRequest-IEs',
        'RICaction-ToBeSetup-ItemIEs',
        'RICsubscriptionResponse-IEs',
        'RICaction-Admitted-ItemIEs',
        'RICaction-NotAdmitted-ItemIEs',
        'RICsubscriptionFailure-IEs',
        'RICsubscriptionAuditRequest-IEs',
        'RICsubscriptionAudit-ItemIEs',
        'RICsubscriptionAuditResponse-IEs',
        'RICsubscriptionAuditAction-ItemIEs',
        'RICsubscriptionAuditFailure-IEs',
        'RICsubscriptionDeleteRequest-IEs',
        'RICsubscriptionDeleteResponse-IEs',
        'RICsubscriptionDeleteFailure-IEs',
        'RICsubscriptionDeleteRequired-IEs',
        'RICsubscription-withCause-ItemIEs',
        'RICsubscriptionModificationRequest-IEs',
        'RICaction-ToBeRemovedForModification-ItemIEs',
        'RICaction-ToBeModifiedForModification-ItemIEs',
        'RICaction-ToBeAddedForModification-ItemIEs',
        'RICsubscriptionModificationResponse-IEs',
        'RICaction-RemovedForModification-ItemIEs',
        'RICaction-FailedToBeRemovedForModification-ItemIEs',
        'RICaction-ModifiedForModification-ItemIEs',
        'RICaction-FailedToBeModifiedForModification-ItemIEs',
        'RICaction-AddedForModification-ItemIEs',
        'RICaction-FailedToBeAddedForModification-ItemIEs',
        'RICsubscriptionModificationFailure-IEs',
        'RICsubscriptionModificationRequired-IEs',
        'RICaction-RequiredToBeModified-ItemIEs',
        'RICaction-RequiredToBeRemoved-ItemIEs',
        'RICsubscriptionModificationConfirm-IEs',
        'RICaction-ConfirmedForModification-ItemIEs',
        'RICaction-RefusedToBeModified-ItemIEs',
        'RICaction-ConfirmedForRemoval-ItemIEs',
        'RICaction-RefusedToBeRemoved-ItemIEs',
        'RICsubscriptionModificationRefuse-IEs',
        'RICindication-IEs',
        'RICcontrolRequest-IEs',
        'RICcontrolAcknowledge-IEs',
        'RICcontrolFailure-IEs',
        'RICqueryRequest-IEs',
        'RICqueryResponse-IEs',
        'RICqueryFailure-IEs',
        'ErrorIndication-IEs',
        'E2setupRequestIEs',
        'E2setupResponseIEs',
        'E2setupFailureIEs',
        'E2connectionUpdate-IEs',
        'E2connectionUpdate-ItemIEs',
        'E2connectionUpdateRemove-ItemIEs',
        'E2connectionUpdateAck-IEs',
        'E2connectionSetupFailed-ItemIEs',
        'E2connectionUpdateFailure-IEs',
        'E2nodeConfigurationUpdate-IEs',
        'E2nodeComponentConfigAddition-ItemIEs',
        'E2nodeComponentConfigUpdate-ItemIEs',
        'E2nodeComponentConfigRemoval-ItemIEs',
        'E2nodeTNLassociationRemoval-ItemIEs',
        'E2nodeConfigurationUpdateAcknowledge-IEs',
        'E2nodeComponentConfigAdditionAck-ItemIEs',
        'E2nodeComponentConfigUpdateAck-ItemIEs',
        'E2nodeComponentConfigRemovalAck-ItemIEs',
        'E2nodeConfigurationUpdateFailure-IEs',
        'ResetRequestIEs',
        'ResetResponseIEs',
        'RICserviceUpdate-IEs',
        'RANfunction-ItemIEs',
        'RANfunctionID-ItemIEs',
        'RICserviceUpdateAcknowledge-IEs',
        'RANfunctionIDcause-ItemIEs',
        'RICserviceUpdateFailure-IEs',
        'RICserviceQuery-IEs',
        'E2RemovalRequestIEs',
        'E2RemovalResponseIEs',
        'E2RemovalFailureIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'RICsubscriptionRequest-IEs',
        'RICaction-ToBeSetup-ItemIEs',
        'RICsubscriptionResponse-IEs',
        'RICaction-Admitted-ItemIEs',
        'RICaction-NotAdmitted-ItemIEs',
        'RICsubscriptionFailure-IEs',
        'RICsubscriptionAuditRequest-IEs',
        'RICsubscriptionAudit-ItemIEs',
        'RICsubscriptionAuditResponse-IEs',
        'RICsubscriptionAuditAction-ItemIEs',
        'RICsubscriptionAuditFailure-IEs',
        'RICsubscriptionDeleteRequest-IEs',
        'RICsubscriptionDeleteResponse-IEs',
        'RICsubscriptionDeleteFailure-IEs',
        'RICsubscriptionDeleteRequired-IEs',
        'RICsubscription-withCause-ItemIEs',
        'RICsubscriptionModificationRequest-IEs',
        'RICaction-ToBeRemovedForModification-ItemIEs',
        'RICaction-ToBeModifiedForModification-ItemIEs',
        'RICaction-ToBeAddedForModification-ItemIEs',
        'RICsubscriptionModificationResponse-IEs',
        'RICaction-RemovedForModification-ItemIEs',
        'RICaction-FailedToBeRemovedForModification-ItemIEs',
        'RICaction-ModifiedForModification-ItemIEs',
        'RICaction-FailedToBeModifiedForModification-ItemIEs',
        'RICaction-AddedForModification-ItemIEs',
        'RICaction-FailedToBeAddedForModification-ItemIEs',
        'RICsubscriptionModificationFailure-IEs',
        'RICsubscriptionModificationRequired-IEs',
        'RICaction-RequiredToBeModified-ItemIEs',
        'RICaction-RequiredToBeRemoved-ItemIEs',
        'RICsubscriptionModificationConfirm-IEs',
        'RICaction-ConfirmedForModification-ItemIEs',
        'RICaction-RefusedToBeModified-ItemIEs',
        'RICaction-ConfirmedForRemoval-ItemIEs',
        'RICaction-RefusedToBeRemoved-ItemIEs',
        'RICsubscriptionModificationRefuse-IEs',
        'RICindication-IEs',
        'RICcontrolRequest-IEs',
        'RICcontrolAcknowledge-IEs',
        'RICcontrolFailure-IEs',
        'RICqueryRequest-IEs',
        'RICqueryResponse-IEs',
        'RICqueryFailure-IEs',
        'ErrorIndication-IEs',
        'E2setupRequestIEs',
        'E2setupResponseIEs',
        'E2setupFailureIEs',
        'E2connectionUpdate-IEs',
        'E2connectionUpdate-ItemIEs',
        'E2connectionUpdateRemove-ItemIEs',
        'E2connectionUpdateAck-IEs',
        'E2connectionSetupFailed-ItemIEs',
        'E2connectionUpdateFailure-IEs',
        'E2nodeConfigurationUpdate-IEs',
        'E2nodeComponentConfigAddition-ItemIEs',
        'E2nodeComponentConfigUpdate-ItemIEs',
        'E2nodeComponentConfigRemoval-ItemIEs',
        'E2nodeTNLassociationRemoval-ItemIEs',
        'E2nodeConfigurationUpdateAcknowledge-IEs',
        'E2nodeComponentConfigAdditionAck-ItemIEs',
        'E2nodeComponentConfigUpdateAck-ItemIEs',
        'E2nodeComponentConfigRemovalAck-ItemIEs',
        'E2nodeConfigurationUpdateFailure-IEs',
        'ResetRequestIEs',
        'ResetResponseIEs',
        'RICserviceUpdate-IEs',
        'RANfunction-ItemIEs',
        'RANfunctionID-ItemIEs',
        'RICserviceUpdateAcknowledge-IEs',
        'RANfunctionIDcause-ItemIEs',
        'RICserviceUpdateFailure-IEs',
        'RICserviceQuery-IEs',
        'E2RemovalRequestIEs',
        'E2RemovalResponseIEs',
        'E2RemovalFailureIEs',
        ]
    _param_ = [
        ]
    
    #-----< RICsubscriptionRequest >-----#
    RICsubscriptionRequest = SEQ(name='RICsubscriptionRequest', mode=MODE_TYPE)
    _RICsubscriptionRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDetails')))
    _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICsubscriptionTime')))
    _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICsubscriptionTime')))
    ____RICsubscriptionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[dict([('id', 62), ('criticality', 'reject'), ('Value', _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], er=[])
    ___RICsubscriptionRequest_protocolIEs__item__id._const_tab = ____RICsubscriptionRequest_protocolIEs__item__id_tab
    ___RICsubscriptionRequest_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionRequest_protocolIEs__item__criticality._const_tab = ____RICsubscriptionRequest_protocolIEs__item__id_tab
    ___RICsubscriptionRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionRequest_protocolIEs__item__value._const_tab = ____RICsubscriptionRequest_protocolIEs__item__id_tab
    ___RICsubscriptionRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionRequest_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionRequest_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionRequest_protocolIEs__item__value),
        ])
    __RICsubscriptionRequest_protocolIEs__item_._ext = None
    _RICsubscriptionRequest_protocolIEs._cont = __RICsubscriptionRequest_protocolIEs__item_
    _RICsubscriptionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionRequest._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionRequest_protocolIEs),
        ])
    RICsubscriptionRequest._ext = []
    
    #-----< RICsubscriptionRequest-IEs >-----#
    RICsubscriptionRequest_IEs = CLASS(name='RICsubscriptionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionRequest_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDetails')))
    _RICsubscriptionRequest_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICsubscriptionTime')))
    _RICsubscriptionRequest_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICsubscriptionTime')))
    RICsubscriptionRequest_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _RICsubscriptionRequest_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[dict([('id', 62), ('criticality', 'reject'), ('Value', _RICsubscriptionRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _RICsubscriptionRequest_IEs_val_Value_4), ('presence', 'optional')])], er=[])
    
    #-----< RICsubscriptionDetails >-----#
    RICsubscriptionDetails = SEQ(name='RICsubscriptionDetails', mode=MODE_TYPE)
    _RICsubscriptionDetails_ricEventTriggerDefinition = OCT_STR(name='ricEventTriggerDefinition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICeventTriggerDefinition')))
    _RICsubscriptionDetails_ricAction_ToBeSetup_List = SEQ_OF(name='ricAction-ToBeSetup-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeSetup-List')))
    RICsubscriptionDetails._cont = ASN1Dict([
        ('ricEventTriggerDefinition', _RICsubscriptionDetails_ricEventTriggerDefinition),
        ('ricAction-ToBeSetup-List', _RICsubscriptionDetails_ricAction_ToBeSetup_List),
        ])
    RICsubscriptionDetails._ext = []
    
    #-----< RICactions-ToBeSetup-List >-----#
    RICactions_ToBeSetup_List = SEQ_OF(name='RICactions-ToBeSetup-List', mode=MODE_TYPE)
    _RICactions_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ToBeSetup_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeSetup-Item')))
    ___RICactions_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Value', ____RICactions_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ToBeSetup_List__item__id._const_tab = ___RICactions_ToBeSetup_List__item__id_tab
    __RICactions_ToBeSetup_List__item__id._const_tab_at = None
    __RICactions_ToBeSetup_List__item__id._const_tab_id = 'id'
    __RICactions_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ToBeSetup_List__item__criticality._const_tab = ___RICactions_ToBeSetup_List__item__id_tab
    __RICactions_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ToBeSetup_List__item__value._const_tab = ___RICactions_ToBeSetup_List__item__id_tab
    __RICactions_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _RICactions_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ToBeSetup_List__item__id),
        ('criticality', __RICactions_ToBeSetup_List__item__criticality),
        ('value', __RICactions_ToBeSetup_List__item__value),
        ])
    _RICactions_ToBeSetup_List__item_._ext = None
    RICactions_ToBeSetup_List._cont = _RICactions_ToBeSetup_List__item_
    RICactions_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ToBeSetup-ItemIEs >-----#
    RICaction_ToBeSetup_ItemIEs = CLASS(name='RICaction-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeSetup-Item')))
    RICaction_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Value', _RICaction_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ToBeSetup-Item >-----#
    RICaction_ToBeSetup_Item = SEQ(name='RICaction-ToBeSetup-Item', mode=MODE_TYPE)
    _RICaction_ToBeSetup_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_ToBeSetup_Item_ricActionType = ENUM(name='ricActionType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionType')))
    _RICaction_ToBeSetup_Item_ricActionDefinition = OCT_STR(name='ricActionDefinition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionDefinition')), opt=True)
    _RICaction_ToBeSetup_Item_ricSubsequentAction = SEQ(name='ricSubsequentAction', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICsubsequentAction')), opt=True)
    _RICaction_ToBeSetup_Item_ricActionExecutionOrder = INT(name='ricActionExecutionOrder', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionExecutionOrder')), opt=True)
    RICaction_ToBeSetup_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ToBeSetup_Item_ricActionID),
        ('ricActionType', _RICaction_ToBeSetup_Item_ricActionType),
        ('ricActionDefinition', _RICaction_ToBeSetup_Item_ricActionDefinition),
        ('ricSubsequentAction', _RICaction_ToBeSetup_Item_ricSubsequentAction),
        ('ricActionExecutionOrder', _RICaction_ToBeSetup_Item_ricActionExecutionOrder),
        ])
    RICaction_ToBeSetup_Item._ext = ['ricActionExecutionOrder']
    
    #-----< RICsubscriptionResponse >-----#
    RICsubscriptionResponse = SEQ(name='RICsubscriptionResponse', mode=MODE_TYPE)
    _RICsubscriptionResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-Admitted-List')))
    _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-NotAdmitted-List')))
    ____RICsubscriptionResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'reject'), ('Value', _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionResponse_protocolIEs__item__id._const_tab = ____RICsubscriptionResponse_protocolIEs__item__id_tab
    ___RICsubscriptionResponse_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionResponse_protocolIEs__item__criticality._const_tab = ____RICsubscriptionResponse_protocolIEs__item__id_tab
    ___RICsubscriptionResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionResponse_protocolIEs__item__value._const_tab = ____RICsubscriptionResponse_protocolIEs__item__id_tab
    ___RICsubscriptionResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionResponse_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionResponse_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionResponse_protocolIEs__item__value),
        ])
    __RICsubscriptionResponse_protocolIEs__item_._ext = None
    _RICsubscriptionResponse_protocolIEs._cont = __RICsubscriptionResponse_protocolIEs__item_
    _RICsubscriptionResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionResponse._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionResponse_protocolIEs),
        ])
    RICsubscriptionResponse._ext = []
    
    #-----< RICsubscriptionResponse-IEs >-----#
    RICsubscriptionResponse_IEs = CLASS(name='RICsubscriptionResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionResponse_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-Admitted-List')))
    _RICsubscriptionResponse_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-NotAdmitted-List')))
    RICsubscriptionResponse_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _RICsubscriptionResponse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'reject'), ('Value', _RICsubscriptionResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-Admitted-List >-----#
    RICaction_Admitted_List = SEQ_OF(name='RICaction-Admitted-List', mode=MODE_TYPE)
    _RICaction_Admitted_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICaction_Admitted_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICaction_Admitted_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICaction_Admitted_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-Admitted-Item')))
    ___RICaction_Admitted_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', ____RICaction_Admitted_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICaction_Admitted_List__item__id._const_tab = ___RICaction_Admitted_List__item__id_tab
    __RICaction_Admitted_List__item__id._const_tab_at = None
    __RICaction_Admitted_List__item__id._const_tab_id = 'id'
    __RICaction_Admitted_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICaction_Admitted_List__item__criticality._const_tab = ___RICaction_Admitted_List__item__id_tab
    __RICaction_Admitted_List__item__criticality._const_tab_at = ('..', 'id')
    __RICaction_Admitted_List__item__criticality._const_tab_id = 'criticality'
    __RICaction_Admitted_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICaction_Admitted_List__item__value._const_tab = ___RICaction_Admitted_List__item__id_tab
    __RICaction_Admitted_List__item__value._const_tab_at = ('..', 'id')
    __RICaction_Admitted_List__item__value._const_tab_id = 'Value'
    _RICaction_Admitted_List__item_._cont = ASN1Dict([
        ('id', __RICaction_Admitted_List__item__id),
        ('criticality', __RICaction_Admitted_List__item__criticality),
        ('value', __RICaction_Admitted_List__item__value),
        ])
    _RICaction_Admitted_List__item_._ext = None
    RICaction_Admitted_List._cont = _RICaction_Admitted_List__item_
    RICaction_Admitted_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RICaction-Admitted-ItemIEs >-----#
    RICaction_Admitted_ItemIEs = CLASS(name='RICaction-Admitted-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_Admitted_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-Admitted-Item')))
    RICaction_Admitted_ItemIEs._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', _RICaction_Admitted_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-Admitted-Item >-----#
    RICaction_Admitted_Item = SEQ(name='RICaction-Admitted-Item', mode=MODE_TYPE)
    _RICaction_Admitted_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_Admitted_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_Admitted_Item_ricActionID),
        ])
    RICaction_Admitted_Item._ext = []
    
    #-----< RICaction-NotAdmitted-List >-----#
    RICaction_NotAdmitted_List = SEQ_OF(name='RICaction-NotAdmitted-List', mode=MODE_TYPE)
    _RICaction_NotAdmitted_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICaction_NotAdmitted_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICaction_NotAdmitted_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICaction_NotAdmitted_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-NotAdmitted-Item')))
    ___RICaction_NotAdmitted_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', ____RICaction_NotAdmitted_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICaction_NotAdmitted_List__item__id._const_tab = ___RICaction_NotAdmitted_List__item__id_tab
    __RICaction_NotAdmitted_List__item__id._const_tab_at = None
    __RICaction_NotAdmitted_List__item__id._const_tab_id = 'id'
    __RICaction_NotAdmitted_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICaction_NotAdmitted_List__item__criticality._const_tab = ___RICaction_NotAdmitted_List__item__id_tab
    __RICaction_NotAdmitted_List__item__criticality._const_tab_at = ('..', 'id')
    __RICaction_NotAdmitted_List__item__criticality._const_tab_id = 'criticality'
    __RICaction_NotAdmitted_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICaction_NotAdmitted_List__item__value._const_tab = ___RICaction_NotAdmitted_List__item__id_tab
    __RICaction_NotAdmitted_List__item__value._const_tab_at = ('..', 'id')
    __RICaction_NotAdmitted_List__item__value._const_tab_id = 'Value'
    _RICaction_NotAdmitted_List__item_._cont = ASN1Dict([
        ('id', __RICaction_NotAdmitted_List__item__id),
        ('criticality', __RICaction_NotAdmitted_List__item__criticality),
        ('value', __RICaction_NotAdmitted_List__item__value),
        ])
    _RICaction_NotAdmitted_List__item_._ext = None
    RICaction_NotAdmitted_List._cont = _RICaction_NotAdmitted_List__item_
    RICaction_NotAdmitted_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-NotAdmitted-ItemIEs >-----#
    RICaction_NotAdmitted_ItemIEs = CLASS(name='RICaction-NotAdmitted-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_NotAdmitted_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-NotAdmitted-Item')))
    RICaction_NotAdmitted_ItemIEs._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', _RICaction_NotAdmitted_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-NotAdmitted-Item >-----#
    RICaction_NotAdmitted_Item = SEQ(name='RICaction-NotAdmitted-Item', mode=MODE_TYPE)
    _RICaction_NotAdmitted_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_NotAdmitted_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_NotAdmitted_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_NotAdmitted_Item_ricActionID),
        ('cause', _RICaction_NotAdmitted_Item_cause),
        ])
    RICaction_NotAdmitted_Item._ext = []
    
    #-----< RICsubscriptionFailure >-----#
    RICsubscriptionFailure = SEQ(name='RICsubscriptionFailure', mode=MODE_TYPE)
    _RICsubscriptionFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICsubscriptionFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionFailure_protocolIEs__item__id._const_tab = ____RICsubscriptionFailure_protocolIEs__item__id_tab
    ___RICsubscriptionFailure_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionFailure_protocolIEs__item__criticality._const_tab = ____RICsubscriptionFailure_protocolIEs__item__id_tab
    ___RICsubscriptionFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionFailure_protocolIEs__item__value._const_tab = ____RICsubscriptionFailure_protocolIEs__item__id_tab
    ___RICsubscriptionFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionFailure_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionFailure_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionFailure_protocolIEs__item__value),
        ])
    __RICsubscriptionFailure_protocolIEs__item_._ext = None
    _RICsubscriptionFailure_protocolIEs._cont = __RICsubscriptionFailure_protocolIEs__item_
    _RICsubscriptionFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionFailure._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionFailure_protocolIEs),
        ])
    RICsubscriptionFailure._ext = []
    
    #-----< RICsubscriptionFailure-IEs >-----#
    RICsubscriptionFailure_IEs = CLASS(name='RICsubscriptionFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICsubscriptionFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICsubscriptionFailure_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _RICsubscriptionFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICsubscriptionFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionAuditRequest >-----#
    RICsubscriptionAuditRequest = SEQ(name='RICsubscriptionAuditRequest', mode=MODE_TYPE)
    _RICsubscriptionAuditRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionAuditRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionAuditRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionAuditRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICsubscriptionAuditFlag')))
    _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditList')))
    ____RICsubscriptionAuditRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionAuditRequest_protocolIEs__item__id._const_tab = ____RICsubscriptionAuditRequest_protocolIEs__item__id_tab
    ___RICsubscriptionAuditRequest_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionAuditRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionAuditRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionAuditRequest_protocolIEs__item__criticality._const_tab = ____RICsubscriptionAuditRequest_protocolIEs__item__id_tab
    ___RICsubscriptionAuditRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionAuditRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionAuditRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionAuditRequest_protocolIEs__item__value._const_tab = ____RICsubscriptionAuditRequest_protocolIEs__item__id_tab
    ___RICsubscriptionAuditRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionAuditRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionAuditRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionAuditRequest_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionAuditRequest_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionAuditRequest_protocolIEs__item__value),
        ])
    __RICsubscriptionAuditRequest_protocolIEs__item_._ext = None
    _RICsubscriptionAuditRequest_protocolIEs._cont = __RICsubscriptionAuditRequest_protocolIEs__item_
    _RICsubscriptionAuditRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionAuditRequest._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionAuditRequest_protocolIEs),
        ])
    RICsubscriptionAuditRequest._ext = []
    
    #-----< RICsubscriptionAuditRequest-IEs >-----#
    RICsubscriptionAuditRequest_IEs = CLASS(name='RICsubscriptionAuditRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionAuditRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionAuditRequest_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICsubscriptionAuditFlag')))
    _RICsubscriptionAuditRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditList')))
    RICsubscriptionAuditRequest_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditRequest_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionAuditList >-----#
    RICsubscriptionAuditList = SEQ_OF(name='RICsubscriptionAuditList', mode=MODE_TYPE)
    _RICsubscriptionAuditList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICsubscriptionAuditList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICsubscriptionAuditList__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICsubscriptionAuditList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAudit-Item')))
    ___RICsubscriptionAuditList__item__id_tab._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Value', ____RICsubscriptionAuditList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICsubscriptionAuditList__item__id._const_tab = ___RICsubscriptionAuditList__item__id_tab
    __RICsubscriptionAuditList__item__id._const_tab_at = None
    __RICsubscriptionAuditList__item__id._const_tab_id = 'id'
    __RICsubscriptionAuditList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICsubscriptionAuditList__item__criticality._const_tab = ___RICsubscriptionAuditList__item__id_tab
    __RICsubscriptionAuditList__item__criticality._const_tab_at = ('..', 'id')
    __RICsubscriptionAuditList__item__criticality._const_tab_id = 'criticality'
    __RICsubscriptionAuditList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICsubscriptionAuditList__item__value._const_tab = ___RICsubscriptionAuditList__item__id_tab
    __RICsubscriptionAuditList__item__value._const_tab_at = ('..', 'id')
    __RICsubscriptionAuditList__item__value._const_tab_id = 'Value'
    _RICsubscriptionAuditList__item_._cont = ASN1Dict([
        ('id', __RICsubscriptionAuditList__item__id),
        ('criticality', __RICsubscriptionAuditList__item__criticality),
        ('value', __RICsubscriptionAuditList__item__value),
        ])
    _RICsubscriptionAuditList__item_._ext = None
    RICsubscriptionAuditList._cont = _RICsubscriptionAuditList__item_
    RICsubscriptionAuditList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2147483648)], ev=None, er=[])
    
    #-----< RICsubscriptionAudit-ItemIEs >-----#
    RICsubscriptionAudit_ItemIEs = CLASS(name='RICsubscriptionAudit-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionAudit_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAudit-Item')))
    RICsubscriptionAudit_ItemIEs._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Value', _RICsubscriptionAudit_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionAudit-Item >-----#
    RICsubscriptionAudit_Item = SEQ(name='RICsubscriptionAudit-Item', mode=MODE_TYPE)
    _RICsubscriptionAudit_Item_ricRequestID = SEQ(name='ricRequestID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionAudit_Item_ranFunctionID = INT(name='ranFunctionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    RICsubscriptionAudit_Item._cont = ASN1Dict([
        ('ricRequestID', _RICsubscriptionAudit_Item_ricRequestID),
        ('ranFunctionID', _RICsubscriptionAudit_Item_ranFunctionID),
        ])
    RICsubscriptionAudit_Item._ext = []
    
    #-----< RICsubscriptionAuditResponse >-----#
    RICsubscriptionAuditResponse = SEQ(name='RICsubscriptionAuditResponse', mode=MODE_TYPE)
    _RICsubscriptionAuditResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionAuditResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionAuditResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionAuditResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditActionList')))
    _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditList')))
    _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditActionList')))
    ____RICsubscriptionAuditResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionAuditResponse_protocolIEs__item__id._const_tab = ____RICsubscriptionAuditResponse_protocolIEs__item__id_tab
    ___RICsubscriptionAuditResponse_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionAuditResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionAuditResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionAuditResponse_protocolIEs__item__criticality._const_tab = ____RICsubscriptionAuditResponse_protocolIEs__item__id_tab
    ___RICsubscriptionAuditResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionAuditResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionAuditResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionAuditResponse_protocolIEs__item__value._const_tab = ____RICsubscriptionAuditResponse_protocolIEs__item__id_tab
    ___RICsubscriptionAuditResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionAuditResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionAuditResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionAuditResponse_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionAuditResponse_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionAuditResponse_protocolIEs__item__value),
        ])
    __RICsubscriptionAuditResponse_protocolIEs__item_._ext = None
    _RICsubscriptionAuditResponse_protocolIEs._cont = __RICsubscriptionAuditResponse_protocolIEs__item_
    _RICsubscriptionAuditResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionAuditResponse._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionAuditResponse_protocolIEs),
        ])
    RICsubscriptionAuditResponse._ext = []
    
    #-----< RICsubscriptionAuditResponse-IEs >-----#
    RICsubscriptionAuditResponse_IEs = CLASS(name='RICsubscriptionAuditResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionAuditResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionAuditResponse_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditActionList')))
    _RICsubscriptionAuditResponse_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditList')))
    _RICsubscriptionAuditResponse_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditActionList')))
    RICsubscriptionAuditResponse_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionAuditActionList >-----#
    RICsubscriptionAuditActionList = SEQ_OF(name='RICsubscriptionAuditActionList', mode=MODE_TYPE)
    _RICsubscriptionAuditActionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICsubscriptionAuditActionList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICsubscriptionAuditActionList__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICsubscriptionAuditActionList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditAction-Item')))
    ___RICsubscriptionAuditActionList__item__id_tab._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'ignore'), ('Value', ____RICsubscriptionAuditActionList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICsubscriptionAuditActionList__item__id._const_tab = ___RICsubscriptionAuditActionList__item__id_tab
    __RICsubscriptionAuditActionList__item__id._const_tab_at = None
    __RICsubscriptionAuditActionList__item__id._const_tab_id = 'id'
    __RICsubscriptionAuditActionList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICsubscriptionAuditActionList__item__criticality._const_tab = ___RICsubscriptionAuditActionList__item__id_tab
    __RICsubscriptionAuditActionList__item__criticality._const_tab_at = ('..', 'id')
    __RICsubscriptionAuditActionList__item__criticality._const_tab_id = 'criticality'
    __RICsubscriptionAuditActionList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICsubscriptionAuditActionList__item__value._const_tab = ___RICsubscriptionAuditActionList__item__id_tab
    __RICsubscriptionAuditActionList__item__value._const_tab_at = ('..', 'id')
    __RICsubscriptionAuditActionList__item__value._const_tab_id = 'Value'
    _RICsubscriptionAuditActionList__item_._cont = ASN1Dict([
        ('id', __RICsubscriptionAuditActionList__item__id),
        ('criticality', __RICsubscriptionAuditActionList__item__criticality),
        ('value', __RICsubscriptionAuditActionList__item__value),
        ])
    _RICsubscriptionAuditActionList__item_._ext = None
    RICsubscriptionAuditActionList._cont = _RICsubscriptionAuditActionList__item_
    RICsubscriptionAuditActionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2147483648)], ev=None, er=[])
    
    #-----< RICsubscriptionAuditAction-ItemIEs >-----#
    RICsubscriptionAuditAction_ItemIEs = CLASS(name='RICsubscriptionAuditAction-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionAuditAction_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditAction-Item')))
    RICsubscriptionAuditAction_ItemIEs._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'ignore'), ('Value', _RICsubscriptionAuditAction_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionAuditAction-Item >-----#
    RICsubscriptionAuditAction_Item = SEQ(name='RICsubscriptionAuditAction-Item', mode=MODE_TYPE)
    _RICsubscriptionAuditAction_Item_ricRequestID = SEQ(name='ricRequestID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionAuditAction_Item_ranFunctionID = INT(name='ranFunctionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionAuditAction_Item_ricAction_Admitted_List = SEQ_OF(name='ricAction-Admitted-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-Admitted-List')))
    RICsubscriptionAuditAction_Item._cont = ASN1Dict([
        ('ricRequestID', _RICsubscriptionAuditAction_Item_ricRequestID),
        ('ranFunctionID', _RICsubscriptionAuditAction_Item_ranFunctionID),
        ('ricAction-Admitted-List', _RICsubscriptionAuditAction_Item_ricAction_Admitted_List),
        ])
    RICsubscriptionAuditAction_Item._ext = []
    
    #-----< RICsubscriptionAuditFailure >-----#
    RICsubscriptionAuditFailure = SEQ(name='RICsubscriptionAuditFailure', mode=MODE_TYPE)
    _RICsubscriptionAuditFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionAuditFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionAuditFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionAuditFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICsubscriptionAuditFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionAuditFailure_protocolIEs__item__id._const_tab = ____RICsubscriptionAuditFailure_protocolIEs__item__id_tab
    ___RICsubscriptionAuditFailure_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionAuditFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionAuditFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionAuditFailure_protocolIEs__item__criticality._const_tab = ____RICsubscriptionAuditFailure_protocolIEs__item__id_tab
    ___RICsubscriptionAuditFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionAuditFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionAuditFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionAuditFailure_protocolIEs__item__value._const_tab = ____RICsubscriptionAuditFailure_protocolIEs__item__id_tab
    ___RICsubscriptionAuditFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionAuditFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionAuditFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionAuditFailure_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionAuditFailure_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionAuditFailure_protocolIEs__item__value),
        ])
    __RICsubscriptionAuditFailure_protocolIEs__item_._ext = None
    _RICsubscriptionAuditFailure_protocolIEs._cont = __RICsubscriptionAuditFailure_protocolIEs__item_
    _RICsubscriptionAuditFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionAuditFailure._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionAuditFailure_protocolIEs),
        ])
    RICsubscriptionAuditFailure._ext = []
    
    #-----< RICsubscriptionAuditFailure-IEs >-----#
    RICsubscriptionAuditFailure_IEs = CLASS(name='RICsubscriptionAuditFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionAuditFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionAuditFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICsubscriptionAuditFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICsubscriptionAuditFailure_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _RICsubscriptionAuditFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICsubscriptionAuditFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionDeleteRequest >-----#
    RICsubscriptionDeleteRequest = SEQ(name='RICsubscriptionDeleteRequest', mode=MODE_TYPE)
    _RICsubscriptionDeleteRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionDeleteRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionDeleteRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    ____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RICsubscriptionDeleteRequest_protocolIEs__item__id._const_tab = ____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteRequest_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionDeleteRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionDeleteRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionDeleteRequest_protocolIEs__item__criticality._const_tab = ____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionDeleteRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionDeleteRequest_protocolIEs__item__value._const_tab = ____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionDeleteRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionDeleteRequest_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionDeleteRequest_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionDeleteRequest_protocolIEs__item__value),
        ])
    __RICsubscriptionDeleteRequest_protocolIEs__item_._ext = None
    _RICsubscriptionDeleteRequest_protocolIEs._cont = __RICsubscriptionDeleteRequest_protocolIEs__item_
    _RICsubscriptionDeleteRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionDeleteRequest._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionDeleteRequest_protocolIEs),
        ])
    RICsubscriptionDeleteRequest._ext = []
    
    #-----< RICsubscriptionDeleteRequest-IEs >-----#
    RICsubscriptionDeleteRequest_IEs = CLASS(name='RICsubscriptionDeleteRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionDeleteRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionDeleteRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    RICsubscriptionDeleteRequest_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionDeleteRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionDeleteRequest_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionDeleteResponse >-----#
    RICsubscriptionDeleteResponse = SEQ(name='RICsubscriptionDeleteResponse', mode=MODE_TYPE)
    _RICsubscriptionDeleteResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionDeleteResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionDeleteResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    ____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RICsubscriptionDeleteResponse_protocolIEs__item__id._const_tab = ____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteResponse_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionDeleteResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionDeleteResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionDeleteResponse_protocolIEs__item__criticality._const_tab = ____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionDeleteResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionDeleteResponse_protocolIEs__item__value._const_tab = ____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionDeleteResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionDeleteResponse_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionDeleteResponse_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionDeleteResponse_protocolIEs__item__value),
        ])
    __RICsubscriptionDeleteResponse_protocolIEs__item_._ext = None
    _RICsubscriptionDeleteResponse_protocolIEs._cont = __RICsubscriptionDeleteResponse_protocolIEs__item_
    _RICsubscriptionDeleteResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionDeleteResponse._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionDeleteResponse_protocolIEs),
        ])
    RICsubscriptionDeleteResponse._ext = []
    
    #-----< RICsubscriptionDeleteResponse-IEs >-----#
    RICsubscriptionDeleteResponse_IEs = CLASS(name='RICsubscriptionDeleteResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionDeleteResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionDeleteResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    RICsubscriptionDeleteResponse_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionDeleteResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionDeleteResponse_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionDeleteFailure >-----#
    RICsubscriptionDeleteFailure = SEQ(name='RICsubscriptionDeleteFailure', mode=MODE_TYPE)
    _RICsubscriptionDeleteFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionDeleteFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionDeleteFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionDeleteFailure_protocolIEs__item__id._const_tab = ____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteFailure_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionDeleteFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionDeleteFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionDeleteFailure_protocolIEs__item__criticality._const_tab = ____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionDeleteFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionDeleteFailure_protocolIEs__item__value._const_tab = ____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionDeleteFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionDeleteFailure_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionDeleteFailure_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionDeleteFailure_protocolIEs__item__value),
        ])
    __RICsubscriptionDeleteFailure_protocolIEs__item_._ext = None
    _RICsubscriptionDeleteFailure_protocolIEs._cont = __RICsubscriptionDeleteFailure_protocolIEs__item_
    _RICsubscriptionDeleteFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionDeleteFailure._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionDeleteFailure_protocolIEs),
        ])
    RICsubscriptionDeleteFailure._ext = []
    
    #-----< RICsubscriptionDeleteFailure-IEs >-----#
    RICsubscriptionDeleteFailure_IEs = CLASS(name='RICsubscriptionDeleteFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionDeleteFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionDeleteFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionDeleteFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICsubscriptionDeleteFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICsubscriptionDeleteFailure_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionDeleteFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionDeleteFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _RICsubscriptionDeleteFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICsubscriptionDeleteFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionDeleteRequired >-----#
    RICsubscriptionDeleteRequired = SEQ(name='RICsubscriptionDeleteRequired', mode=MODE_TYPE)
    _RICsubscriptionDeleteRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionDeleteRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionDeleteRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscription-List-withCause')))
    ____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Value', _____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RICsubscriptionDeleteRequired_protocolIEs__item__id._const_tab = ____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteRequired_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionDeleteRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionDeleteRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionDeleteRequired_protocolIEs__item__criticality._const_tab = ____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionDeleteRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionDeleteRequired_protocolIEs__item__value._const_tab = ____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab
    ___RICsubscriptionDeleteRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionDeleteRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionDeleteRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionDeleteRequired_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionDeleteRequired_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionDeleteRequired_protocolIEs__item__value),
        ])
    __RICsubscriptionDeleteRequired_protocolIEs__item_._ext = None
    _RICsubscriptionDeleteRequired_protocolIEs._cont = __RICsubscriptionDeleteRequired_protocolIEs__item_
    _RICsubscriptionDeleteRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionDeleteRequired._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionDeleteRequired_protocolIEs),
        ])
    RICsubscriptionDeleteRequired._ext = []
    
    #-----< RICsubscriptionDeleteRequired-IEs >-----#
    RICsubscriptionDeleteRequired_IEs = CLASS(name='RICsubscriptionDeleteRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionDeleteRequired_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscription-List-withCause')))
    RICsubscriptionDeleteRequired_IEs._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Value', _RICsubscriptionDeleteRequired_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscription-List-withCause >-----#
    RICsubscription_List_withCause = SEQ_OF(name='RICsubscription-List-withCause', mode=MODE_TYPE)
    _RICsubscription_List_withCause__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICsubscription_List_withCause__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICsubscription_List_withCause__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICsubscription_List_withCause__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscription-withCause-Item')))
    ___RICsubscription_List_withCause__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', ____RICsubscription_List_withCause__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICsubscription_List_withCause__item__id._const_tab = ___RICsubscription_List_withCause__item__id_tab
    __RICsubscription_List_withCause__item__id._const_tab_at = None
    __RICsubscription_List_withCause__item__id._const_tab_id = 'id'
    __RICsubscription_List_withCause__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICsubscription_List_withCause__item__criticality._const_tab = ___RICsubscription_List_withCause__item__id_tab
    __RICsubscription_List_withCause__item__criticality._const_tab_at = ('..', 'id')
    __RICsubscription_List_withCause__item__criticality._const_tab_id = 'criticality'
    __RICsubscription_List_withCause__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICsubscription_List_withCause__item__value._const_tab = ___RICsubscription_List_withCause__item__id_tab
    __RICsubscription_List_withCause__item__value._const_tab_at = ('..', 'id')
    __RICsubscription_List_withCause__item__value._const_tab_id = 'Value'
    _RICsubscription_List_withCause__item_._cont = ASN1Dict([
        ('id', __RICsubscription_List_withCause__item__id),
        ('criticality', __RICsubscription_List_withCause__item__criticality),
        ('value', __RICsubscription_List_withCause__item__value),
        ])
    _RICsubscription_List_withCause__item_._ext = None
    RICsubscription_List_withCause._cont = _RICsubscription_List_withCause__item_
    RICsubscription_List_withCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< RICsubscription-withCause-ItemIEs >-----#
    RICsubscription_withCause_ItemIEs = CLASS(name='RICsubscription-withCause-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscription_withCause_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscription-withCause-Item')))
    RICsubscription_withCause_ItemIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _RICsubscription_withCause_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscription-withCause-Item >-----#
    RICsubscription_withCause_Item = SEQ(name='RICsubscription-withCause-Item', mode=MODE_TYPE)
    _RICsubscription_withCause_Item_ricRequestID = SEQ(name='ricRequestID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscription_withCause_Item_ranFunctionID = INT(name='ranFunctionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscription_withCause_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICsubscription_withCause_Item._cont = ASN1Dict([
        ('ricRequestID', _RICsubscription_withCause_Item_ricRequestID),
        ('ranFunctionID', _RICsubscription_withCause_Item_ranFunctionID),
        ('cause', _RICsubscription_withCause_Item_cause),
        ])
    RICsubscription_withCause_Item._ext = []
    
    #-----< RICsubscriptionModificationRequest >-----#
    RICsubscriptionModificationRequest = SEQ(name='RICsubscriptionModificationRequest', mode=MODE_TYPE)
    _RICsubscriptionModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICeventTriggerDefinition')))
    _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeRemovedForModification-List')))
    _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeModifiedForModification-List')))
    _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeAddedForModification-List')))
    ____RICsubscriptionModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionModificationRequest_protocolIEs__item__id._const_tab = ____RICsubscriptionModificationRequest_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionModificationRequest_protocolIEs__item__criticality._const_tab = ____RICsubscriptionModificationRequest_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionModificationRequest_protocolIEs__item__value._const_tab = ____RICsubscriptionModificationRequest_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionModificationRequest_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionModificationRequest_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionModificationRequest_protocolIEs__item__value),
        ])
    __RICsubscriptionModificationRequest_protocolIEs__item_._ext = None
    _RICsubscriptionModificationRequest_protocolIEs._cont = __RICsubscriptionModificationRequest_protocolIEs__item_
    _RICsubscriptionModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionModificationRequest_protocolIEs),
        ])
    RICsubscriptionModificationRequest._ext = []
    
    #-----< RICsubscriptionModificationRequest-IEs >-----#
    RICsubscriptionModificationRequest_IEs = CLASS(name='RICsubscriptionModificationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionModificationRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionModificationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionModificationRequest_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICeventTriggerDefinition')))
    _RICsubscriptionModificationRequest_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeRemovedForModification-List')))
    _RICsubscriptionModificationRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeModifiedForModification-List')))
    _RICsubscriptionModificationRequest_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ToBeAddedForModification-List')))
    RICsubscriptionModificationRequest_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRequest_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICactions-ToBeRemovedForModification-List >-----#
    RICactions_ToBeRemovedForModification_List = SEQ_OF(name='RICactions-ToBeRemovedForModification-List', mode=MODE_TYPE)
    _RICactions_ToBeRemovedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ToBeRemovedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ToBeRemovedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ToBeRemovedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeRemovedForModification-Item')))
    ___RICactions_ToBeRemovedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 66), ('criticality', 'ignore'), ('Value', ____RICactions_ToBeRemovedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ToBeRemovedForModification_List__item__id._const_tab = ___RICactions_ToBeRemovedForModification_List__item__id_tab
    __RICactions_ToBeRemovedForModification_List__item__id._const_tab_at = None
    __RICactions_ToBeRemovedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_ToBeRemovedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ToBeRemovedForModification_List__item__criticality._const_tab = ___RICactions_ToBeRemovedForModification_List__item__id_tab
    __RICactions_ToBeRemovedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ToBeRemovedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ToBeRemovedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ToBeRemovedForModification_List__item__value._const_tab = ___RICactions_ToBeRemovedForModification_List__item__id_tab
    __RICactions_ToBeRemovedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ToBeRemovedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_ToBeRemovedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ToBeRemovedForModification_List__item__id),
        ('criticality', __RICactions_ToBeRemovedForModification_List__item__criticality),
        ('value', __RICactions_ToBeRemovedForModification_List__item__value),
        ])
    _RICactions_ToBeRemovedForModification_List__item_._ext = None
    RICactions_ToBeRemovedForModification_List._cont = _RICactions_ToBeRemovedForModification_List__item_
    RICactions_ToBeRemovedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ToBeRemovedForModification-ItemIEs >-----#
    RICaction_ToBeRemovedForModification_ItemIEs = CLASS(name='RICaction-ToBeRemovedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ToBeRemovedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeRemovedForModification-Item')))
    RICaction_ToBeRemovedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 66), ('criticality', 'ignore'), ('Value', _RICaction_ToBeRemovedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ToBeRemovedForModification-Item >-----#
    RICaction_ToBeRemovedForModification_Item = SEQ(name='RICaction-ToBeRemovedForModification-Item', mode=MODE_TYPE)
    _RICaction_ToBeRemovedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_ToBeRemovedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ToBeRemovedForModification_Item_ricActionID),
        ])
    RICaction_ToBeRemovedForModification_Item._ext = []
    
    #-----< RICactions-ToBeModifiedForModification-List >-----#
    RICactions_ToBeModifiedForModification_List = SEQ_OF(name='RICactions-ToBeModifiedForModification-List', mode=MODE_TYPE)
    _RICactions_ToBeModifiedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ToBeModifiedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ToBeModifiedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ToBeModifiedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeModifiedForModification-Item')))
    ___RICactions_ToBeModifiedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 68), ('criticality', 'ignore'), ('Value', ____RICactions_ToBeModifiedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ToBeModifiedForModification_List__item__id._const_tab = ___RICactions_ToBeModifiedForModification_List__item__id_tab
    __RICactions_ToBeModifiedForModification_List__item__id._const_tab_at = None
    __RICactions_ToBeModifiedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_ToBeModifiedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ToBeModifiedForModification_List__item__criticality._const_tab = ___RICactions_ToBeModifiedForModification_List__item__id_tab
    __RICactions_ToBeModifiedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ToBeModifiedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ToBeModifiedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ToBeModifiedForModification_List__item__value._const_tab = ___RICactions_ToBeModifiedForModification_List__item__id_tab
    __RICactions_ToBeModifiedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ToBeModifiedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_ToBeModifiedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ToBeModifiedForModification_List__item__id),
        ('criticality', __RICactions_ToBeModifiedForModification_List__item__criticality),
        ('value', __RICactions_ToBeModifiedForModification_List__item__value),
        ])
    _RICactions_ToBeModifiedForModification_List__item_._ext = None
    RICactions_ToBeModifiedForModification_List._cont = _RICactions_ToBeModifiedForModification_List__item_
    RICactions_ToBeModifiedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ToBeModifiedForModification-ItemIEs >-----#
    RICaction_ToBeModifiedForModification_ItemIEs = CLASS(name='RICaction-ToBeModifiedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ToBeModifiedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeModifiedForModification-Item')))
    RICaction_ToBeModifiedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 68), ('criticality', 'ignore'), ('Value', _RICaction_ToBeModifiedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ToBeModifiedForModification-Item >-----#
    RICaction_ToBeModifiedForModification_Item = SEQ(name='RICaction-ToBeModifiedForModification-Item', mode=MODE_TYPE)
    _RICaction_ToBeModifiedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_ToBeModifiedForModification_Item_ricActionDefinition = OCT_STR(name='ricActionDefinition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionDefinition')), opt=True)
    _RICaction_ToBeModifiedForModification_Item_ricActionExecutionOrder = INT(name='ricActionExecutionOrder', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionExecutionOrder')), opt=True)
    _RICaction_ToBeModifiedForModification_Item_ricSubsequentAction = SEQ(name='ricSubsequentAction', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICsubsequentAction')), opt=True)
    RICaction_ToBeModifiedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ToBeModifiedForModification_Item_ricActionID),
        ('ricActionDefinition', _RICaction_ToBeModifiedForModification_Item_ricActionDefinition),
        ('ricActionExecutionOrder', _RICaction_ToBeModifiedForModification_Item_ricActionExecutionOrder),
        ('ricSubsequentAction', _RICaction_ToBeModifiedForModification_Item_ricSubsequentAction),
        ])
    RICaction_ToBeModifiedForModification_Item._ext = []
    
    #-----< RICactions-ToBeAddedForModification-List >-----#
    RICactions_ToBeAddedForModification_List = SEQ_OF(name='RICactions-ToBeAddedForModification-List', mode=MODE_TYPE)
    _RICactions_ToBeAddedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ToBeAddedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ToBeAddedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ToBeAddedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeAddedForModification-Item')))
    ___RICactions_ToBeAddedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 70), ('criticality', 'ignore'), ('Value', ____RICactions_ToBeAddedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ToBeAddedForModification_List__item__id._const_tab = ___RICactions_ToBeAddedForModification_List__item__id_tab
    __RICactions_ToBeAddedForModification_List__item__id._const_tab_at = None
    __RICactions_ToBeAddedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_ToBeAddedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ToBeAddedForModification_List__item__criticality._const_tab = ___RICactions_ToBeAddedForModification_List__item__id_tab
    __RICactions_ToBeAddedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ToBeAddedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ToBeAddedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ToBeAddedForModification_List__item__value._const_tab = ___RICactions_ToBeAddedForModification_List__item__id_tab
    __RICactions_ToBeAddedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ToBeAddedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_ToBeAddedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ToBeAddedForModification_List__item__id),
        ('criticality', __RICactions_ToBeAddedForModification_List__item__criticality),
        ('value', __RICactions_ToBeAddedForModification_List__item__value),
        ])
    _RICactions_ToBeAddedForModification_List__item_._ext = None
    RICactions_ToBeAddedForModification_List._cont = _RICactions_ToBeAddedForModification_List__item_
    RICactions_ToBeAddedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ToBeAddedForModification-ItemIEs >-----#
    RICaction_ToBeAddedForModification_ItemIEs = CLASS(name='RICaction-ToBeAddedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ToBeAddedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ToBeAddedForModification-Item')))
    RICaction_ToBeAddedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 70), ('criticality', 'ignore'), ('Value', _RICaction_ToBeAddedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ToBeAddedForModification-Item >-----#
    RICaction_ToBeAddedForModification_Item = SEQ(name='RICaction-ToBeAddedForModification-Item', mode=MODE_TYPE)
    _RICaction_ToBeAddedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_ToBeAddedForModification_Item_ricActionType = ENUM(name='ricActionType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionType')))
    _RICaction_ToBeAddedForModification_Item_ricActionDefinition = OCT_STR(name='ricActionDefinition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionDefinition')))
    _RICaction_ToBeAddedForModification_Item_ricActionExecutionOrder = INT(name='ricActionExecutionOrder', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionExecutionOrder')))
    _RICaction_ToBeAddedForModification_Item_ricSubsequentAction = SEQ(name='ricSubsequentAction', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICsubsequentAction')), opt=True)
    RICaction_ToBeAddedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ToBeAddedForModification_Item_ricActionID),
        ('ricActionType', _RICaction_ToBeAddedForModification_Item_ricActionType),
        ('ricActionDefinition', _RICaction_ToBeAddedForModification_Item_ricActionDefinition),
        ('ricActionExecutionOrder', _RICaction_ToBeAddedForModification_Item_ricActionExecutionOrder),
        ('ricSubsequentAction', _RICaction_ToBeAddedForModification_Item_ricSubsequentAction),
        ])
    RICaction_ToBeAddedForModification_Item._ext = []
    
    #-----< RICsubscriptionModificationResponse >-----#
    RICsubscriptionModificationResponse = SEQ(name='RICsubscriptionModificationResponse', mode=MODE_TYPE)
    _RICsubscriptionModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RemovedForModification-List')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-FailedToBeRemovedForModification-List')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ModifiedForModification-List')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-FailedToBeModifiedForModification-List')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-AddedForModification-List')))
    _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-FailedToBeAddedForModification-List')))
    ____RICsubscriptionModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionModificationResponse_protocolIEs__item__id._const_tab = ____RICsubscriptionModificationResponse_protocolIEs__item__id_tab
    ___RICsubscriptionModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionModificationResponse_protocolIEs__item__criticality._const_tab = ____RICsubscriptionModificationResponse_protocolIEs__item__id_tab
    ___RICsubscriptionModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionModificationResponse_protocolIEs__item__value._const_tab = ____RICsubscriptionModificationResponse_protocolIEs__item__id_tab
    ___RICsubscriptionModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionModificationResponse_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionModificationResponse_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionModificationResponse_protocolIEs__item__value),
        ])
    __RICsubscriptionModificationResponse_protocolIEs__item_._ext = None
    _RICsubscriptionModificationResponse_protocolIEs._cont = __RICsubscriptionModificationResponse_protocolIEs__item_
    _RICsubscriptionModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionModificationResponse_protocolIEs),
        ])
    RICsubscriptionModificationResponse._ext = []
    
    #-----< RICsubscriptionModificationResponse-IEs >-----#
    RICsubscriptionModificationResponse_IEs = CLASS(name='RICsubscriptionModificationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionModificationResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionModificationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionModificationResponse_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RemovedForModification-List')))
    _RICsubscriptionModificationResponse_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-FailedToBeRemovedForModification-List')))
    _RICsubscriptionModificationResponse_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ModifiedForModification-List')))
    _RICsubscriptionModificationResponse_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-FailedToBeModifiedForModification-List')))
    _RICsubscriptionModificationResponse_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-AddedForModification-List')))
    _RICsubscriptionModificationResponse_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-FailedToBeAddedForModification-List')))
    RICsubscriptionModificationResponse_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationResponse_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICactions-RemovedForModification-List >-----#
    RICactions_RemovedForModification_List = SEQ_OF(name='RICactions-RemovedForModification-List', mode=MODE_TYPE)
    _RICactions_RemovedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_RemovedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_RemovedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_RemovedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RemovedForModification-Item')))
    ___RICactions_RemovedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Value', ____RICactions_RemovedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_RemovedForModification_List__item__id._const_tab = ___RICactions_RemovedForModification_List__item__id_tab
    __RICactions_RemovedForModification_List__item__id._const_tab_at = None
    __RICactions_RemovedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_RemovedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_RemovedForModification_List__item__criticality._const_tab = ___RICactions_RemovedForModification_List__item__id_tab
    __RICactions_RemovedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_RemovedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_RemovedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_RemovedForModification_List__item__value._const_tab = ___RICactions_RemovedForModification_List__item__id_tab
    __RICactions_RemovedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_RemovedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_RemovedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_RemovedForModification_List__item__id),
        ('criticality', __RICactions_RemovedForModification_List__item__criticality),
        ('value', __RICactions_RemovedForModification_List__item__value),
        ])
    _RICactions_RemovedForModification_List__item_._ext = None
    RICactions_RemovedForModification_List._cont = _RICactions_RemovedForModification_List__item_
    RICactions_RemovedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-RemovedForModification-ItemIEs >-----#
    RICaction_RemovedForModification_ItemIEs = CLASS(name='RICaction-RemovedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_RemovedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RemovedForModification-Item')))
    RICaction_RemovedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Value', _RICaction_RemovedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-RemovedForModification-Item >-----#
    RICaction_RemovedForModification_Item = SEQ(name='RICaction-RemovedForModification-Item', mode=MODE_TYPE)
    _RICaction_RemovedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_RemovedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_RemovedForModification_Item_ricActionID),
        ])
    RICaction_RemovedForModification_Item._ext = []
    
    #-----< RICactions-FailedToBeRemovedForModification-List >-----#
    RICactions_FailedToBeRemovedForModification_List = SEQ_OF(name='RICactions-FailedToBeRemovedForModification-List', mode=MODE_TYPE)
    _RICactions_FailedToBeRemovedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_FailedToBeRemovedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_FailedToBeRemovedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_FailedToBeRemovedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-FailedToBeRemovedForModification-Item')))
    ___RICactions_FailedToBeRemovedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Value', ____RICactions_FailedToBeRemovedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_FailedToBeRemovedForModification_List__item__id._const_tab = ___RICactions_FailedToBeRemovedForModification_List__item__id_tab
    __RICactions_FailedToBeRemovedForModification_List__item__id._const_tab_at = None
    __RICactions_FailedToBeRemovedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_FailedToBeRemovedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_FailedToBeRemovedForModification_List__item__criticality._const_tab = ___RICactions_FailedToBeRemovedForModification_List__item__id_tab
    __RICactions_FailedToBeRemovedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_FailedToBeRemovedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_FailedToBeRemovedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_FailedToBeRemovedForModification_List__item__value._const_tab = ___RICactions_FailedToBeRemovedForModification_List__item__id_tab
    __RICactions_FailedToBeRemovedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_FailedToBeRemovedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_FailedToBeRemovedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_FailedToBeRemovedForModification_List__item__id),
        ('criticality', __RICactions_FailedToBeRemovedForModification_List__item__criticality),
        ('value', __RICactions_FailedToBeRemovedForModification_List__item__value),
        ])
    _RICactions_FailedToBeRemovedForModification_List__item_._ext = None
    RICactions_FailedToBeRemovedForModification_List._cont = _RICactions_FailedToBeRemovedForModification_List__item_
    RICactions_FailedToBeRemovedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-FailedToBeRemovedForModification-ItemIEs >-----#
    RICaction_FailedToBeRemovedForModification_ItemIEs = CLASS(name='RICaction-FailedToBeRemovedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_FailedToBeRemovedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-FailedToBeRemovedForModification-Item')))
    RICaction_FailedToBeRemovedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Value', _RICaction_FailedToBeRemovedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-FailedToBeRemovedForModification-Item >-----#
    RICaction_FailedToBeRemovedForModification_Item = SEQ(name='RICaction-FailedToBeRemovedForModification-Item', mode=MODE_TYPE)
    _RICaction_FailedToBeRemovedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_FailedToBeRemovedForModification_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_FailedToBeRemovedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_FailedToBeRemovedForModification_Item_ricActionID),
        ('cause', _RICaction_FailedToBeRemovedForModification_Item_cause),
        ])
    RICaction_FailedToBeRemovedForModification_Item._ext = []
    
    #-----< RICactions-ModifiedForModification-List >-----#
    RICactions_ModifiedForModification_List = SEQ_OF(name='RICactions-ModifiedForModification-List', mode=MODE_TYPE)
    _RICactions_ModifiedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ModifiedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ModifiedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ModifiedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ModifiedForModification-Item')))
    ___RICactions_ModifiedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Value', ____RICactions_ModifiedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ModifiedForModification_List__item__id._const_tab = ___RICactions_ModifiedForModification_List__item__id_tab
    __RICactions_ModifiedForModification_List__item__id._const_tab_at = None
    __RICactions_ModifiedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_ModifiedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ModifiedForModification_List__item__criticality._const_tab = ___RICactions_ModifiedForModification_List__item__id_tab
    __RICactions_ModifiedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ModifiedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ModifiedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ModifiedForModification_List__item__value._const_tab = ___RICactions_ModifiedForModification_List__item__id_tab
    __RICactions_ModifiedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ModifiedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_ModifiedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ModifiedForModification_List__item__id),
        ('criticality', __RICactions_ModifiedForModification_List__item__criticality),
        ('value', __RICactions_ModifiedForModification_List__item__value),
        ])
    _RICactions_ModifiedForModification_List__item_._ext = None
    RICactions_ModifiedForModification_List._cont = _RICactions_ModifiedForModification_List__item_
    RICactions_ModifiedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ModifiedForModification-ItemIEs >-----#
    RICaction_ModifiedForModification_ItemIEs = CLASS(name='RICaction-ModifiedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ModifiedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ModifiedForModification-Item')))
    RICaction_ModifiedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Value', _RICaction_ModifiedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ModifiedForModification-Item >-----#
    RICaction_ModifiedForModification_Item = SEQ(name='RICaction-ModifiedForModification-Item', mode=MODE_TYPE)
    _RICaction_ModifiedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_ModifiedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ModifiedForModification_Item_ricActionID),
        ])
    RICaction_ModifiedForModification_Item._ext = []
    
    #-----< RICactions-FailedToBeModifiedForModification-List >-----#
    RICactions_FailedToBeModifiedForModification_List = SEQ_OF(name='RICactions-FailedToBeModifiedForModification-List', mode=MODE_TYPE)
    _RICactions_FailedToBeModifiedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_FailedToBeModifiedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_FailedToBeModifiedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_FailedToBeModifiedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-FailedToBeModifiedForModification-Item')))
    ___RICactions_FailedToBeModifiedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', ____RICactions_FailedToBeModifiedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_FailedToBeModifiedForModification_List__item__id._const_tab = ___RICactions_FailedToBeModifiedForModification_List__item__id_tab
    __RICactions_FailedToBeModifiedForModification_List__item__id._const_tab_at = None
    __RICactions_FailedToBeModifiedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_FailedToBeModifiedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_FailedToBeModifiedForModification_List__item__criticality._const_tab = ___RICactions_FailedToBeModifiedForModification_List__item__id_tab
    __RICactions_FailedToBeModifiedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_FailedToBeModifiedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_FailedToBeModifiedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_FailedToBeModifiedForModification_List__item__value._const_tab = ___RICactions_FailedToBeModifiedForModification_List__item__id_tab
    __RICactions_FailedToBeModifiedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_FailedToBeModifiedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_FailedToBeModifiedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_FailedToBeModifiedForModification_List__item__id),
        ('criticality', __RICactions_FailedToBeModifiedForModification_List__item__criticality),
        ('value', __RICactions_FailedToBeModifiedForModification_List__item__value),
        ])
    _RICactions_FailedToBeModifiedForModification_List__item_._ext = None
    RICactions_FailedToBeModifiedForModification_List._cont = _RICactions_FailedToBeModifiedForModification_List__item_
    RICactions_FailedToBeModifiedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-FailedToBeModifiedForModification-ItemIEs >-----#
    RICaction_FailedToBeModifiedForModification_ItemIEs = CLASS(name='RICaction-FailedToBeModifiedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_FailedToBeModifiedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-FailedToBeModifiedForModification-Item')))
    RICaction_FailedToBeModifiedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', _RICaction_FailedToBeModifiedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-FailedToBeModifiedForModification-Item >-----#
    RICaction_FailedToBeModifiedForModification_Item = SEQ(name='RICaction-FailedToBeModifiedForModification-Item', mode=MODE_TYPE)
    _RICaction_FailedToBeModifiedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_FailedToBeModifiedForModification_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_FailedToBeModifiedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_FailedToBeModifiedForModification_Item_ricActionID),
        ('cause', _RICaction_FailedToBeModifiedForModification_Item_cause),
        ])
    RICaction_FailedToBeModifiedForModification_Item._ext = []
    
    #-----< RICactions-AddedForModification-List >-----#
    RICactions_AddedForModification_List = SEQ_OF(name='RICactions-AddedForModification-List', mode=MODE_TYPE)
    _RICactions_AddedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_AddedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_AddedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_AddedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-AddedForModification-Item')))
    ___RICactions_AddedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', ____RICactions_AddedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_AddedForModification_List__item__id._const_tab = ___RICactions_AddedForModification_List__item__id_tab
    __RICactions_AddedForModification_List__item__id._const_tab_at = None
    __RICactions_AddedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_AddedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_AddedForModification_List__item__criticality._const_tab = ___RICactions_AddedForModification_List__item__id_tab
    __RICactions_AddedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_AddedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_AddedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_AddedForModification_List__item__value._const_tab = ___RICactions_AddedForModification_List__item__id_tab
    __RICactions_AddedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_AddedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_AddedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_AddedForModification_List__item__id),
        ('criticality', __RICactions_AddedForModification_List__item__criticality),
        ('value', __RICactions_AddedForModification_List__item__value),
        ])
    _RICactions_AddedForModification_List__item_._ext = None
    RICactions_AddedForModification_List._cont = _RICactions_AddedForModification_List__item_
    RICactions_AddedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-AddedForModification-ItemIEs >-----#
    RICaction_AddedForModification_ItemIEs = CLASS(name='RICaction-AddedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_AddedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-AddedForModification-Item')))
    RICaction_AddedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', _RICaction_AddedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-AddedForModification-Item >-----#
    RICaction_AddedForModification_Item = SEQ(name='RICaction-AddedForModification-Item', mode=MODE_TYPE)
    _RICaction_AddedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_AddedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_AddedForModification_Item_ricActionID),
        ])
    RICaction_AddedForModification_Item._ext = []
    
    #-----< RICactions-FailedToBeAddedForModification-List >-----#
    RICactions_FailedToBeAddedForModification_List = SEQ_OF(name='RICactions-FailedToBeAddedForModification-List', mode=MODE_TYPE)
    _RICactions_FailedToBeAddedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_FailedToBeAddedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_FailedToBeAddedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_FailedToBeAddedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-FailedToBeAddedForModification-Item')))
    ___RICactions_FailedToBeAddedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Value', ____RICactions_FailedToBeAddedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_FailedToBeAddedForModification_List__item__id._const_tab = ___RICactions_FailedToBeAddedForModification_List__item__id_tab
    __RICactions_FailedToBeAddedForModification_List__item__id._const_tab_at = None
    __RICactions_FailedToBeAddedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_FailedToBeAddedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_FailedToBeAddedForModification_List__item__criticality._const_tab = ___RICactions_FailedToBeAddedForModification_List__item__id_tab
    __RICactions_FailedToBeAddedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_FailedToBeAddedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_FailedToBeAddedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_FailedToBeAddedForModification_List__item__value._const_tab = ___RICactions_FailedToBeAddedForModification_List__item__id_tab
    __RICactions_FailedToBeAddedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_FailedToBeAddedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_FailedToBeAddedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_FailedToBeAddedForModification_List__item__id),
        ('criticality', __RICactions_FailedToBeAddedForModification_List__item__criticality),
        ('value', __RICactions_FailedToBeAddedForModification_List__item__value),
        ])
    _RICactions_FailedToBeAddedForModification_List__item_._ext = None
    RICactions_FailedToBeAddedForModification_List._cont = _RICactions_FailedToBeAddedForModification_List__item_
    RICactions_FailedToBeAddedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-FailedToBeAddedForModification-ItemIEs >-----#
    RICaction_FailedToBeAddedForModification_ItemIEs = CLASS(name='RICaction-FailedToBeAddedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_FailedToBeAddedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-FailedToBeAddedForModification-Item')))
    RICaction_FailedToBeAddedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Value', _RICaction_FailedToBeAddedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-FailedToBeAddedForModification-Item >-----#
    RICaction_FailedToBeAddedForModification_Item = SEQ(name='RICaction-FailedToBeAddedForModification-Item', mode=MODE_TYPE)
    _RICaction_FailedToBeAddedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_FailedToBeAddedForModification_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_FailedToBeAddedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_FailedToBeAddedForModification_Item_ricActionID),
        ('cause', _RICaction_FailedToBeAddedForModification_Item_cause),
        ])
    RICaction_FailedToBeAddedForModification_Item._ext = []
    
    #-----< RICsubscriptionModificationFailure >-----#
    RICsubscriptionModificationFailure = SEQ(name='RICsubscriptionModificationFailure', mode=MODE_TYPE)
    _RICsubscriptionModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICsubscriptionModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionModificationFailure_protocolIEs__item__id._const_tab = ____RICsubscriptionModificationFailure_protocolIEs__item__id_tab
    ___RICsubscriptionModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionModificationFailure_protocolIEs__item__criticality._const_tab = ____RICsubscriptionModificationFailure_protocolIEs__item__id_tab
    ___RICsubscriptionModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionModificationFailure_protocolIEs__item__value._const_tab = ____RICsubscriptionModificationFailure_protocolIEs__item__id_tab
    ___RICsubscriptionModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionModificationFailure_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionModificationFailure_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionModificationFailure_protocolIEs__item__value),
        ])
    __RICsubscriptionModificationFailure_protocolIEs__item_._ext = None
    _RICsubscriptionModificationFailure_protocolIEs._cont = __RICsubscriptionModificationFailure_protocolIEs__item_
    _RICsubscriptionModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionModificationFailure_protocolIEs),
        ])
    RICsubscriptionModificationFailure._ext = []
    
    #-----< RICsubscriptionModificationFailure-IEs >-----#
    RICsubscriptionModificationFailure_IEs = CLASS(name='RICsubscriptionModificationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionModificationFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionModificationFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionModificationFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICsubscriptionModificationFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICsubscriptionModificationFailure_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICsubscriptionModificationRequired >-----#
    RICsubscriptionModificationRequired = SEQ(name='RICsubscriptionModificationRequired', mode=MODE_TYPE)
    _RICsubscriptionModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RequiredToBeModified-List')))
    _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RequiredToBeRemoved-List')))
    ____RICsubscriptionModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionModificationRequired_protocolIEs__item__id._const_tab = ____RICsubscriptionModificationRequired_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionModificationRequired_protocolIEs__item__criticality._const_tab = ____RICsubscriptionModificationRequired_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionModificationRequired_protocolIEs__item__value._const_tab = ____RICsubscriptionModificationRequired_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionModificationRequired_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionModificationRequired_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionModificationRequired_protocolIEs__item__value),
        ])
    __RICsubscriptionModificationRequired_protocolIEs__item_._ext = None
    _RICsubscriptionModificationRequired_protocolIEs._cont = __RICsubscriptionModificationRequired_protocolIEs__item_
    _RICsubscriptionModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionModificationRequired_protocolIEs),
        ])
    RICsubscriptionModificationRequired._ext = []
    
    #-----< RICsubscriptionModificationRequired-IEs >-----#
    RICsubscriptionModificationRequired_IEs = CLASS(name='RICsubscriptionModificationRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionModificationRequired_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionModificationRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionModificationRequired_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RequiredToBeModified-List')))
    _RICsubscriptionModificationRequired_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RequiredToBeRemoved-List')))
    RICsubscriptionModificationRequired_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRequired_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRequired_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICactions-RequiredToBeModified-List >-----#
    RICactions_RequiredToBeModified_List = SEQ_OF(name='RICactions-RequiredToBeModified-List', mode=MODE_TYPE)
    _RICactions_RequiredToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_RequiredToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_RequiredToBeModified_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_RequiredToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RequiredToBeModified-Item')))
    ___RICactions_RequiredToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', ____RICactions_RequiredToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_RequiredToBeModified_List__item__id._const_tab = ___RICactions_RequiredToBeModified_List__item__id_tab
    __RICactions_RequiredToBeModified_List__item__id._const_tab_at = None
    __RICactions_RequiredToBeModified_List__item__id._const_tab_id = 'id'
    __RICactions_RequiredToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_RequiredToBeModified_List__item__criticality._const_tab = ___RICactions_RequiredToBeModified_List__item__id_tab
    __RICactions_RequiredToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_RequiredToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_RequiredToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_RequiredToBeModified_List__item__value._const_tab = ___RICactions_RequiredToBeModified_List__item__id_tab
    __RICactions_RequiredToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_RequiredToBeModified_List__item__value._const_tab_id = 'Value'
    _RICactions_RequiredToBeModified_List__item_._cont = ASN1Dict([
        ('id', __RICactions_RequiredToBeModified_List__item__id),
        ('criticality', __RICactions_RequiredToBeModified_List__item__criticality),
        ('value', __RICactions_RequiredToBeModified_List__item__value),
        ])
    _RICactions_RequiredToBeModified_List__item_._ext = None
    RICactions_RequiredToBeModified_List._cont = _RICactions_RequiredToBeModified_List__item_
    RICactions_RequiredToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-RequiredToBeModified-ItemIEs >-----#
    RICaction_RequiredToBeModified_ItemIEs = CLASS(name='RICaction-RequiredToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_RequiredToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RequiredToBeModified-Item')))
    RICaction_RequiredToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', _RICaction_RequiredToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-RequiredToBeModified-Item >-----#
    RICaction_RequiredToBeModified_Item = SEQ(name='RICaction-RequiredToBeModified-Item', mode=MODE_TYPE)
    _RICaction_RequiredToBeModified_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_RequiredToBeModified_Item_ricTimeToWait = ENUM(name='ricTimeToWait', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICtimeToWait')))
    RICaction_RequiredToBeModified_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_RequiredToBeModified_Item_ricActionID),
        ('ricTimeToWait', _RICaction_RequiredToBeModified_Item_ricTimeToWait),
        ])
    RICaction_RequiredToBeModified_Item._ext = []
    
    #-----< RICactions-RequiredToBeRemoved-List >-----#
    RICactions_RequiredToBeRemoved_List = SEQ_OF(name='RICactions-RequiredToBeRemoved-List', mode=MODE_TYPE)
    _RICactions_RequiredToBeRemoved_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_RequiredToBeRemoved_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_RequiredToBeRemoved_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_RequiredToBeRemoved_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RequiredToBeRemoved-Item')))
    ___RICactions_RequiredToBeRemoved_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 86), ('criticality', 'ignore'), ('Value', ____RICactions_RequiredToBeRemoved_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_RequiredToBeRemoved_List__item__id._const_tab = ___RICactions_RequiredToBeRemoved_List__item__id_tab
    __RICactions_RequiredToBeRemoved_List__item__id._const_tab_at = None
    __RICactions_RequiredToBeRemoved_List__item__id._const_tab_id = 'id'
    __RICactions_RequiredToBeRemoved_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_RequiredToBeRemoved_List__item__criticality._const_tab = ___RICactions_RequiredToBeRemoved_List__item__id_tab
    __RICactions_RequiredToBeRemoved_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_RequiredToBeRemoved_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_RequiredToBeRemoved_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_RequiredToBeRemoved_List__item__value._const_tab = ___RICactions_RequiredToBeRemoved_List__item__id_tab
    __RICactions_RequiredToBeRemoved_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_RequiredToBeRemoved_List__item__value._const_tab_id = 'Value'
    _RICactions_RequiredToBeRemoved_List__item_._cont = ASN1Dict([
        ('id', __RICactions_RequiredToBeRemoved_List__item__id),
        ('criticality', __RICactions_RequiredToBeRemoved_List__item__criticality),
        ('value', __RICactions_RequiredToBeRemoved_List__item__value),
        ])
    _RICactions_RequiredToBeRemoved_List__item_._ext = None
    RICactions_RequiredToBeRemoved_List._cont = _RICactions_RequiredToBeRemoved_List__item_
    RICactions_RequiredToBeRemoved_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-RequiredToBeRemoved-ItemIEs >-----#
    RICaction_RequiredToBeRemoved_ItemIEs = CLASS(name='RICaction-RequiredToBeRemoved-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_RequiredToBeRemoved_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RequiredToBeRemoved-Item')))
    RICaction_RequiredToBeRemoved_ItemIEs._val = ASN1Set(rv=[dict([('id', 86), ('criticality', 'ignore'), ('Value', _RICaction_RequiredToBeRemoved_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-RequiredToBeRemoved-Item >-----#
    RICaction_RequiredToBeRemoved_Item = SEQ(name='RICaction-RequiredToBeRemoved-Item', mode=MODE_TYPE)
    _RICaction_RequiredToBeRemoved_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_RequiredToBeRemoved_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_RequiredToBeRemoved_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_RequiredToBeRemoved_Item_ricActionID),
        ('cause', _RICaction_RequiredToBeRemoved_Item_cause),
        ])
    RICaction_RequiredToBeRemoved_Item._ext = []
    
    #-----< RICsubscriptionModificationConfirm >-----#
    RICsubscriptionModificationConfirm = SEQ(name='RICsubscriptionModificationConfirm', mode=MODE_TYPE)
    _RICsubscriptionModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ConfirmedForModification-List')))
    _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RefusedToBeModified-List')))
    _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ConfirmedForRemoval-List')))
    _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RefusedToBeRemoved-List')))
    ____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 87), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionModificationConfirm_protocolIEs__item__id._const_tab = ____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab
    ___RICsubscriptionModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionModificationConfirm_protocolIEs__item__criticality._const_tab = ____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab
    ___RICsubscriptionModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionModificationConfirm_protocolIEs__item__value._const_tab = ____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab
    ___RICsubscriptionModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionModificationConfirm_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionModificationConfirm_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionModificationConfirm_protocolIEs__item__value),
        ])
    __RICsubscriptionModificationConfirm_protocolIEs__item_._ext = None
    _RICsubscriptionModificationConfirm_protocolIEs._cont = __RICsubscriptionModificationConfirm_protocolIEs__item_
    _RICsubscriptionModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionModificationConfirm_protocolIEs),
        ])
    RICsubscriptionModificationConfirm._ext = []
    
    #-----< RICsubscriptionModificationConfirm-IEs >-----#
    RICsubscriptionModificationConfirm_IEs = CLASS(name='RICsubscriptionModificationConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionModificationConfirm_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionModificationConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionModificationConfirm_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ConfirmedForModification-List')))
    _RICsubscriptionModificationConfirm_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RefusedToBeModified-List')))
    _RICsubscriptionModificationConfirm_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-ConfirmedForRemoval-List')))
    _RICsubscriptionModificationConfirm_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICactions-RefusedToBeRemoved-List')))
    RICsubscriptionModificationConfirm_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 87), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationConfirm_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationConfirm_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationConfirm_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICactions-ConfirmedForModification-List >-----#
    RICactions_ConfirmedForModification_List = SEQ_OF(name='RICactions-ConfirmedForModification-List', mode=MODE_TYPE)
    _RICactions_ConfirmedForModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ConfirmedForModification_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ConfirmedForModification_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ConfirmedForModification_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ConfirmedForModification-Item')))
    ___RICactions_ConfirmedForModification_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Value', ____RICactions_ConfirmedForModification_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ConfirmedForModification_List__item__id._const_tab = ___RICactions_ConfirmedForModification_List__item__id_tab
    __RICactions_ConfirmedForModification_List__item__id._const_tab_at = None
    __RICactions_ConfirmedForModification_List__item__id._const_tab_id = 'id'
    __RICactions_ConfirmedForModification_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ConfirmedForModification_List__item__criticality._const_tab = ___RICactions_ConfirmedForModification_List__item__id_tab
    __RICactions_ConfirmedForModification_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ConfirmedForModification_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ConfirmedForModification_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ConfirmedForModification_List__item__value._const_tab = ___RICactions_ConfirmedForModification_List__item__id_tab
    __RICactions_ConfirmedForModification_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ConfirmedForModification_List__item__value._const_tab_id = 'Value'
    _RICactions_ConfirmedForModification_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ConfirmedForModification_List__item__id),
        ('criticality', __RICactions_ConfirmedForModification_List__item__criticality),
        ('value', __RICactions_ConfirmedForModification_List__item__value),
        ])
    _RICactions_ConfirmedForModification_List__item_._ext = None
    RICactions_ConfirmedForModification_List._cont = _RICactions_ConfirmedForModification_List__item_
    RICactions_ConfirmedForModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ConfirmedForModification-ItemIEs >-----#
    RICaction_ConfirmedForModification_ItemIEs = CLASS(name='RICaction-ConfirmedForModification-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ConfirmedForModification_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ConfirmedForModification-Item')))
    RICaction_ConfirmedForModification_ItemIEs._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Value', _RICaction_ConfirmedForModification_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ConfirmedForModification-Item >-----#
    RICaction_ConfirmedForModification_Item = SEQ(name='RICaction-ConfirmedForModification-Item', mode=MODE_TYPE)
    _RICaction_ConfirmedForModification_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_ConfirmedForModification_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ConfirmedForModification_Item_ricActionID),
        ])
    RICaction_ConfirmedForModification_Item._ext = []
    
    #-----< RICactions-RefusedToBeModified-List >-----#
    RICactions_RefusedToBeModified_List = SEQ_OF(name='RICactions-RefusedToBeModified-List', mode=MODE_TYPE)
    _RICactions_RefusedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_RefusedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_RefusedToBeModified_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_RefusedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RefusedToBeModified-Item')))
    ___RICactions_RefusedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Value', ____RICactions_RefusedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_RefusedToBeModified_List__item__id._const_tab = ___RICactions_RefusedToBeModified_List__item__id_tab
    __RICactions_RefusedToBeModified_List__item__id._const_tab_at = None
    __RICactions_RefusedToBeModified_List__item__id._const_tab_id = 'id'
    __RICactions_RefusedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_RefusedToBeModified_List__item__criticality._const_tab = ___RICactions_RefusedToBeModified_List__item__id_tab
    __RICactions_RefusedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_RefusedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_RefusedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_RefusedToBeModified_List__item__value._const_tab = ___RICactions_RefusedToBeModified_List__item__id_tab
    __RICactions_RefusedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_RefusedToBeModified_List__item__value._const_tab_id = 'Value'
    _RICactions_RefusedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __RICactions_RefusedToBeModified_List__item__id),
        ('criticality', __RICactions_RefusedToBeModified_List__item__criticality),
        ('value', __RICactions_RefusedToBeModified_List__item__value),
        ])
    _RICactions_RefusedToBeModified_List__item_._ext = None
    RICactions_RefusedToBeModified_List._cont = _RICactions_RefusedToBeModified_List__item_
    RICactions_RefusedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-RefusedToBeModified-ItemIEs >-----#
    RICaction_RefusedToBeModified_ItemIEs = CLASS(name='RICaction-RefusedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_RefusedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RefusedToBeModified-Item')))
    RICaction_RefusedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Value', _RICaction_RefusedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-RefusedToBeModified-Item >-----#
    RICaction_RefusedToBeModified_Item = SEQ(name='RICaction-RefusedToBeModified-Item', mode=MODE_TYPE)
    _RICaction_RefusedToBeModified_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_RefusedToBeModified_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_RefusedToBeModified_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_RefusedToBeModified_Item_ricActionID),
        ('cause', _RICaction_RefusedToBeModified_Item_cause),
        ])
    RICaction_RefusedToBeModified_Item._ext = []
    
    #-----< RICactions-ConfirmedForRemoval-List >-----#
    RICactions_ConfirmedForRemoval_List = SEQ_OF(name='RICactions-ConfirmedForRemoval-List', mode=MODE_TYPE)
    _RICactions_ConfirmedForRemoval_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_ConfirmedForRemoval_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_ConfirmedForRemoval_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_ConfirmedForRemoval_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ConfirmedForRemoval-Item')))
    ___RICactions_ConfirmedForRemoval_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 92), ('criticality', 'ignore'), ('Value', ____RICactions_ConfirmedForRemoval_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_ConfirmedForRemoval_List__item__id._const_tab = ___RICactions_ConfirmedForRemoval_List__item__id_tab
    __RICactions_ConfirmedForRemoval_List__item__id._const_tab_at = None
    __RICactions_ConfirmedForRemoval_List__item__id._const_tab_id = 'id'
    __RICactions_ConfirmedForRemoval_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_ConfirmedForRemoval_List__item__criticality._const_tab = ___RICactions_ConfirmedForRemoval_List__item__id_tab
    __RICactions_ConfirmedForRemoval_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_ConfirmedForRemoval_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_ConfirmedForRemoval_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_ConfirmedForRemoval_List__item__value._const_tab = ___RICactions_ConfirmedForRemoval_List__item__id_tab
    __RICactions_ConfirmedForRemoval_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_ConfirmedForRemoval_List__item__value._const_tab_id = 'Value'
    _RICactions_ConfirmedForRemoval_List__item_._cont = ASN1Dict([
        ('id', __RICactions_ConfirmedForRemoval_List__item__id),
        ('criticality', __RICactions_ConfirmedForRemoval_List__item__criticality),
        ('value', __RICactions_ConfirmedForRemoval_List__item__value),
        ])
    _RICactions_ConfirmedForRemoval_List__item_._ext = None
    RICactions_ConfirmedForRemoval_List._cont = _RICactions_ConfirmedForRemoval_List__item_
    RICactions_ConfirmedForRemoval_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-ConfirmedForRemoval-ItemIEs >-----#
    RICaction_ConfirmedForRemoval_ItemIEs = CLASS(name='RICaction-ConfirmedForRemoval-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_ConfirmedForRemoval_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-ConfirmedForRemoval-Item')))
    RICaction_ConfirmedForRemoval_ItemIEs._val = ASN1Set(rv=[dict([('id', 92), ('criticality', 'ignore'), ('Value', _RICaction_ConfirmedForRemoval_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-ConfirmedForRemoval-Item >-----#
    RICaction_ConfirmedForRemoval_Item = SEQ(name='RICaction-ConfirmedForRemoval-Item', mode=MODE_TYPE)
    _RICaction_ConfirmedForRemoval_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    RICaction_ConfirmedForRemoval_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_ConfirmedForRemoval_Item_ricActionID),
        ])
    RICaction_ConfirmedForRemoval_Item._ext = []
    
    #-----< RICactions-RefusedToBeRemoved-List >-----#
    RICactions_RefusedToBeRemoved_List = SEQ_OF(name='RICactions-RefusedToBeRemoved-List', mode=MODE_TYPE)
    _RICactions_RefusedToBeRemoved_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RICactions_RefusedToBeRemoved_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RICactions_RefusedToBeRemoved_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RICactions_RefusedToBeRemoved_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RefusedToBeRemoved-Item')))
    ___RICactions_RefusedToBeRemoved_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 94), ('criticality', 'ignore'), ('Value', ____RICactions_RefusedToBeRemoved_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RICactions_RefusedToBeRemoved_List__item__id._const_tab = ___RICactions_RefusedToBeRemoved_List__item__id_tab
    __RICactions_RefusedToBeRemoved_List__item__id._const_tab_at = None
    __RICactions_RefusedToBeRemoved_List__item__id._const_tab_id = 'id'
    __RICactions_RefusedToBeRemoved_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RICactions_RefusedToBeRemoved_List__item__criticality._const_tab = ___RICactions_RefusedToBeRemoved_List__item__id_tab
    __RICactions_RefusedToBeRemoved_List__item__criticality._const_tab_at = ('..', 'id')
    __RICactions_RefusedToBeRemoved_List__item__criticality._const_tab_id = 'criticality'
    __RICactions_RefusedToBeRemoved_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RICactions_RefusedToBeRemoved_List__item__value._const_tab = ___RICactions_RefusedToBeRemoved_List__item__id_tab
    __RICactions_RefusedToBeRemoved_List__item__value._const_tab_at = ('..', 'id')
    __RICactions_RefusedToBeRemoved_List__item__value._const_tab_id = 'Value'
    _RICactions_RefusedToBeRemoved_List__item_._cont = ASN1Dict([
        ('id', __RICactions_RefusedToBeRemoved_List__item__id),
        ('criticality', __RICactions_RefusedToBeRemoved_List__item__criticality),
        ('value', __RICactions_RefusedToBeRemoved_List__item__value),
        ])
    _RICactions_RefusedToBeRemoved_List__item_._ext = None
    RICactions_RefusedToBeRemoved_List._cont = _RICactions_RefusedToBeRemoved_List__item_
    RICactions_RefusedToBeRemoved_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RICaction-RefusedToBeRemoved-ItemIEs >-----#
    RICaction_RefusedToBeRemoved_ItemIEs = CLASS(name='RICaction-RefusedToBeRemoved-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICaction_RefusedToBeRemoved_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICaction-RefusedToBeRemoved-Item')))
    RICaction_RefusedToBeRemoved_ItemIEs._val = ASN1Set(rv=[dict([('id', 94), ('criticality', 'ignore'), ('Value', _RICaction_RefusedToBeRemoved_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICaction-RefusedToBeRemoved-Item >-----#
    RICaction_RefusedToBeRemoved_Item = SEQ(name='RICaction-RefusedToBeRemoved-Item', mode=MODE_TYPE)
    _RICaction_RefusedToBeRemoved_Item_ricActionID = INT(name='ricActionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICaction_RefusedToBeRemoved_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RICaction_RefusedToBeRemoved_Item._cont = ASN1Dict([
        ('ricActionID', _RICaction_RefusedToBeRemoved_Item_ricActionID),
        ('cause', _RICaction_RefusedToBeRemoved_Item_cause),
        ])
    RICaction_RefusedToBeRemoved_Item._ext = []
    
    #-----< RICsubscriptionModificationRefuse >-----#
    RICsubscriptionModificationRefuse = SEQ(name='RICsubscriptionModificationRefuse', mode=MODE_TYPE)
    _RICsubscriptionModificationRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICsubscriptionModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICsubscriptionModificationRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICsubscriptionModificationRefuse_protocolIEs__item__id._const_tab = ____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___RICsubscriptionModificationRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___RICsubscriptionModificationRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICsubscriptionModificationRefuse_protocolIEs__item__criticality._const_tab = ____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICsubscriptionModificationRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICsubscriptionModificationRefuse_protocolIEs__item__value._const_tab = ____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab
    ___RICsubscriptionModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICsubscriptionModificationRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __RICsubscriptionModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICsubscriptionModificationRefuse_protocolIEs__item__id),
        ('criticality', ___RICsubscriptionModificationRefuse_protocolIEs__item__criticality),
        ('value', ___RICsubscriptionModificationRefuse_protocolIEs__item__value),
        ])
    __RICsubscriptionModificationRefuse_protocolIEs__item_._ext = None
    _RICsubscriptionModificationRefuse_protocolIEs._cont = __RICsubscriptionModificationRefuse_protocolIEs__item_
    _RICsubscriptionModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICsubscriptionModificationRefuse._cont = ASN1Dict([
        ('protocolIEs', _RICsubscriptionModificationRefuse_protocolIEs),
        ])
    RICsubscriptionModificationRefuse._ext = []
    
    #-----< RICsubscriptionModificationRefuse-IEs >-----#
    RICsubscriptionModificationRefuse_IEs = CLASS(name='RICsubscriptionModificationRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICsubscriptionModificationRefuse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICsubscriptionModificationRefuse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICsubscriptionModificationRefuse_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICsubscriptionModificationRefuse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICsubscriptionModificationRefuse_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRefuse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRefuse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _RICsubscriptionModificationRefuse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICsubscriptionModificationRefuse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICindication >-----#
    RICindication = SEQ(name='RICindication', mode=MODE_TYPE)
    _RICindication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICindication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICindication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICindication_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationSN')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationType')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationHeader')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationMessage')))
    _____RICindication_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    ____RICindication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____RICindication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICindication_protocolIEs__item__id._const_tab = ____RICindication_protocolIEs__item__id_tab
    ___RICindication_protocolIEs__item__id._const_tab_at = None
    ___RICindication_protocolIEs__item__id._const_tab_id = 'id'
    ___RICindication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICindication_protocolIEs__item__criticality._const_tab = ____RICindication_protocolIEs__item__id_tab
    ___RICindication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICindication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICindication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICindication_protocolIEs__item__value._const_tab = ____RICindication_protocolIEs__item__id_tab
    ___RICindication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICindication_protocolIEs__item__value._const_tab_id = 'Value'
    __RICindication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICindication_protocolIEs__item__id),
        ('criticality', ___RICindication_protocolIEs__item__criticality),
        ('value', ___RICindication_protocolIEs__item__value),
        ])
    __RICindication_protocolIEs__item_._ext = None
    _RICindication_protocolIEs._cont = __RICindication_protocolIEs__item_
    _RICindication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICindication._cont = ASN1Dict([
        ('protocolIEs', _RICindication_protocolIEs),
        ])
    RICindication._ext = []
    
    #-----< RICindication-IEs >-----#
    RICindication_IEs = CLASS(name='RICindication-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICindication_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICindication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICindication_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICactionID')))
    _RICindication_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationSN')))
    _RICindication_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationType')))
    _RICindication_IEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationHeader')))
    _RICindication_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICindicationMessage')))
    _RICindication_IEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    RICindication_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _RICindication_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICcontrolRequest >-----#
    RICcontrolRequest = SEQ(name='RICcontrolRequest', mode=MODE_TYPE)
    _RICcontrolRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICcontrolRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICcontrolRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICcontrolRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolHeader')))
    _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolMessage')))
    _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolAckRequest')))
    ____RICcontrolRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'reject'), ('Value', _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'reject'), ('Value', _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICcontrolRequest_protocolIEs__item__id._const_tab = ____RICcontrolRequest_protocolIEs__item__id_tab
    ___RICcontrolRequest_protocolIEs__item__id._const_tab_at = None
    ___RICcontrolRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RICcontrolRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICcontrolRequest_protocolIEs__item__criticality._const_tab = ____RICcontrolRequest_protocolIEs__item__id_tab
    ___RICcontrolRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICcontrolRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICcontrolRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICcontrolRequest_protocolIEs__item__value._const_tab = ____RICcontrolRequest_protocolIEs__item__id_tab
    ___RICcontrolRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICcontrolRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RICcontrolRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICcontrolRequest_protocolIEs__item__id),
        ('criticality', ___RICcontrolRequest_protocolIEs__item__criticality),
        ('value', ___RICcontrolRequest_protocolIEs__item__value),
        ])
    __RICcontrolRequest_protocolIEs__item_._ext = None
    _RICcontrolRequest_protocolIEs._cont = __RICcontrolRequest_protocolIEs__item_
    _RICcontrolRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICcontrolRequest._cont = ASN1Dict([
        ('protocolIEs', _RICcontrolRequest_protocolIEs),
        ])
    RICcontrolRequest._ext = []
    
    #-----< RICcontrolRequest-IEs >-----#
    RICcontrolRequest_IEs = CLASS(name='RICcontrolRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICcontrolRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICcontrolRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICcontrolRequest_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    _RICcontrolRequest_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolHeader')))
    _RICcontrolRequest_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolMessage')))
    _RICcontrolRequest_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolAckRequest')))
    RICcontrolRequest_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICcontrolRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICcontrolRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _RICcontrolRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'reject'), ('Value', _RICcontrolRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _RICcontrolRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'reject'), ('Value', _RICcontrolRequest_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICcontrolAcknowledge >-----#
    RICcontrolAcknowledge = SEQ(name='RICcontrolAcknowledge', mode=MODE_TYPE)
    _RICcontrolAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICcontrolAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICcontrolAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICcontrolAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolOutcome')))
    ____RICcontrolAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'reject'), ('Value', _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICcontrolAcknowledge_protocolIEs__item__id._const_tab = ____RICcontrolAcknowledge_protocolIEs__item__id_tab
    ___RICcontrolAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RICcontrolAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___RICcontrolAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICcontrolAcknowledge_protocolIEs__item__criticality._const_tab = ____RICcontrolAcknowledge_protocolIEs__item__id_tab
    ___RICcontrolAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICcontrolAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICcontrolAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICcontrolAcknowledge_protocolIEs__item__value._const_tab = ____RICcontrolAcknowledge_protocolIEs__item__id_tab
    ___RICcontrolAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICcontrolAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __RICcontrolAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICcontrolAcknowledge_protocolIEs__item__id),
        ('criticality', ___RICcontrolAcknowledge_protocolIEs__item__criticality),
        ('value', ___RICcontrolAcknowledge_protocolIEs__item__value),
        ])
    __RICcontrolAcknowledge_protocolIEs__item_._ext = None
    _RICcontrolAcknowledge_protocolIEs._cont = __RICcontrolAcknowledge_protocolIEs__item_
    _RICcontrolAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICcontrolAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _RICcontrolAcknowledge_protocolIEs),
        ])
    RICcontrolAcknowledge._ext = []
    
    #-----< RICcontrolAcknowledge-IEs >-----#
    RICcontrolAcknowledge_IEs = CLASS(name='RICcontrolAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICcontrolAcknowledge_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICcontrolAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICcontrolAcknowledge_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    _RICcontrolAcknowledge_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolOutcome')))
    RICcontrolAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICcontrolAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICcontrolAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _RICcontrolAcknowledge_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'reject'), ('Value', _RICcontrolAcknowledge_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICcontrolFailure >-----#
    RICcontrolFailure = SEQ(name='RICcontrolFailure', mode=MODE_TYPE)
    _RICcontrolFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICcontrolFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICcontrolFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICcontrolFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolOutcome')))
    _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICcontrolFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'reject'), ('Value', _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], er=[])
    ___RICcontrolFailure_protocolIEs__item__id._const_tab = ____RICcontrolFailure_protocolIEs__item__id_tab
    ___RICcontrolFailure_protocolIEs__item__id._const_tab_at = None
    ___RICcontrolFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICcontrolFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICcontrolFailure_protocolIEs__item__criticality._const_tab = ____RICcontrolFailure_protocolIEs__item__id_tab
    ___RICcontrolFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICcontrolFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICcontrolFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICcontrolFailure_protocolIEs__item__value._const_tab = ____RICcontrolFailure_protocolIEs__item__id_tab
    ___RICcontrolFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICcontrolFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICcontrolFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICcontrolFailure_protocolIEs__item__id),
        ('criticality', ___RICcontrolFailure_protocolIEs__item__criticality),
        ('value', ___RICcontrolFailure_protocolIEs__item__value),
        ])
    __RICcontrolFailure_protocolIEs__item_._ext = None
    _RICcontrolFailure_protocolIEs._cont = __RICcontrolFailure_protocolIEs__item_
    _RICcontrolFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICcontrolFailure._cont = ASN1Dict([
        ('protocolIEs', _RICcontrolFailure_protocolIEs),
        ])
    RICcontrolFailure._ext = []
    
    #-----< RICcontrolFailure-IEs >-----#
    RICcontrolFailure_IEs = CLASS(name='RICcontrolFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICcontrolFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICcontrolFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICcontrolFailure_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcallProcessID')))
    _RICcontrolFailure_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICcontrolFailure_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICcontrolOutcome')))
    _RICcontrolFailure_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICcontrolFailure_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICcontrolFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICcontrolFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _RICcontrolFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _RICcontrolFailure_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'reject'), ('Value', _RICcontrolFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICcontrolFailure_IEs_val_Value_5), ('presence', 'optional')])], er=[])
    
    #-----< RICqueryRequest >-----#
    RICqueryRequest = SEQ(name='RICqueryRequest', mode=MODE_TYPE)
    _RICqueryRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICqueryRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICqueryRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICqueryRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICqueryHeader')))
    _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICqueryDefinition')))
    ____RICqueryRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RICqueryRequest_protocolIEs__item__id._const_tab = ____RICqueryRequest_protocolIEs__item__id_tab
    ___RICqueryRequest_protocolIEs__item__id._const_tab_at = None
    ___RICqueryRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RICqueryRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICqueryRequest_protocolIEs__item__criticality._const_tab = ____RICqueryRequest_protocolIEs__item__id_tab
    ___RICqueryRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICqueryRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICqueryRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICqueryRequest_protocolIEs__item__value._const_tab = ____RICqueryRequest_protocolIEs__item__id_tab
    ___RICqueryRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICqueryRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RICqueryRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICqueryRequest_protocolIEs__item__id),
        ('criticality', ___RICqueryRequest_protocolIEs__item__criticality),
        ('value', ___RICqueryRequest_protocolIEs__item__value),
        ])
    __RICqueryRequest_protocolIEs__item_._ext = None
    _RICqueryRequest_protocolIEs._cont = __RICqueryRequest_protocolIEs__item_
    _RICqueryRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICqueryRequest._cont = ASN1Dict([
        ('protocolIEs', _RICqueryRequest_protocolIEs),
        ])
    RICqueryRequest._ext = []
    
    #-----< RICqueryRequest-IEs >-----#
    RICqueryRequest_IEs = CLASS(name='RICqueryRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICqueryRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICqueryRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICqueryRequest_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICqueryHeader')))
    _RICqueryRequest_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICqueryDefinition')))
    RICqueryRequest_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICqueryRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICqueryRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _RICqueryRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _RICqueryRequest_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICqueryResponse >-----#
    RICqueryResponse = SEQ(name='RICqueryResponse', mode=MODE_TYPE)
    _RICqueryResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICqueryResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICqueryResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICqueryResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICqueryOutcome')))
    ____RICqueryResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RICqueryResponse_protocolIEs__item__id._const_tab = ____RICqueryResponse_protocolIEs__item__id_tab
    ___RICqueryResponse_protocolIEs__item__id._const_tab_at = None
    ___RICqueryResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RICqueryResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICqueryResponse_protocolIEs__item__criticality._const_tab = ____RICqueryResponse_protocolIEs__item__id_tab
    ___RICqueryResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICqueryResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICqueryResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICqueryResponse_protocolIEs__item__value._const_tab = ____RICqueryResponse_protocolIEs__item__id_tab
    ___RICqueryResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICqueryResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RICqueryResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICqueryResponse_protocolIEs__item__id),
        ('criticality', ___RICqueryResponse_protocolIEs__item__criticality),
        ('value', ___RICqueryResponse_protocolIEs__item__value),
        ])
    __RICqueryResponse_protocolIEs__item_._ext = None
    _RICqueryResponse_protocolIEs._cont = __RICqueryResponse_protocolIEs__item_
    _RICqueryResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICqueryResponse._cont = ASN1Dict([
        ('protocolIEs', _RICqueryResponse_protocolIEs),
        ])
    RICqueryResponse._ext = []
    
    #-----< RICqueryResponse-IEs >-----#
    RICqueryResponse_IEs = CLASS(name='RICqueryResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICqueryResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICqueryResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICqueryResponse_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICqueryOutcome')))
    RICqueryResponse_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICqueryResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICqueryResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _RICqueryResponse_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RICqueryFailure >-----#
    RICqueryFailure = SEQ(name='RICqueryFailure', mode=MODE_TYPE)
    _RICqueryFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICqueryFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICqueryFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICqueryFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICqueryFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICqueryFailure_protocolIEs__item__id._const_tab = ____RICqueryFailure_protocolIEs__item__id_tab
    ___RICqueryFailure_protocolIEs__item__id._const_tab_at = None
    ___RICqueryFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICqueryFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICqueryFailure_protocolIEs__item__criticality._const_tab = ____RICqueryFailure_protocolIEs__item__id_tab
    ___RICqueryFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICqueryFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICqueryFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICqueryFailure_protocolIEs__item__value._const_tab = ____RICqueryFailure_protocolIEs__item__id_tab
    ___RICqueryFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICqueryFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICqueryFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICqueryFailure_protocolIEs__item__id),
        ('criticality', ___RICqueryFailure_protocolIEs__item__criticality),
        ('value', ___RICqueryFailure_protocolIEs__item__value),
        ])
    __RICqueryFailure_protocolIEs__item_._ext = None
    _RICqueryFailure_protocolIEs._cont = __RICqueryFailure_protocolIEs__item_
    _RICqueryFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICqueryFailure._cont = ASN1Dict([
        ('protocolIEs', _RICqueryFailure_protocolIEs),
        ])
    RICqueryFailure._ext = []
    
    #-----< RICqueryFailure-IEs >-----#
    RICqueryFailure_IEs = CLASS(name='RICqueryFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICqueryFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _RICqueryFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RICqueryFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICqueryFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICqueryFailure_IEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'reject'), ('Value', _RICqueryFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _RICqueryFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _RICqueryFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICqueryFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name='ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _ErrorIndication_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RICrequestID')))
    _ErrorIndication_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _ErrorIndication_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _ErrorIndication_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _ErrorIndication_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _ErrorIndication_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2setupRequest >-----#
    E2setupRequest = SEQ(name='E2setupRequest', mode=MODE_TYPE)
    _E2setupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2setupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2setupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2setupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2setupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2setupRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-ID')))
    _____E2setupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctions-List')))
    _____E2setupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAddition-List')))
    ____E2setupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2setupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____E2setupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____E2setupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____E2setupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E2setupRequest_protocolIEs__item__id._const_tab = ____E2setupRequest_protocolIEs__item__id_tab
    ___E2setupRequest_protocolIEs__item__id._const_tab_at = None
    ___E2setupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E2setupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2setupRequest_protocolIEs__item__criticality._const_tab = ____E2setupRequest_protocolIEs__item__id_tab
    ___E2setupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2setupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2setupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2setupRequest_protocolIEs__item__value._const_tab = ____E2setupRequest_protocolIEs__item__id_tab
    ___E2setupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2setupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E2setupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2setupRequest_protocolIEs__item__id),
        ('criticality', ___E2setupRequest_protocolIEs__item__criticality),
        ('value', ___E2setupRequest_protocolIEs__item__value),
        ])
    __E2setupRequest_protocolIEs__item_._ext = None
    _E2setupRequest_protocolIEs._cont = __E2setupRequest_protocolIEs__item_
    _E2setupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2setupRequest._cont = ASN1Dict([
        ('protocolIEs', _E2setupRequest_protocolIEs),
        ])
    E2setupRequest._ext = []
    
    #-----< E2setupRequestIEs >-----#
    E2setupRequestIEs = CLASS(name='E2setupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2setupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2setupRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-ID')))
    _E2setupRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctions-List')))
    _E2setupRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAddition-List')))
    E2setupRequestIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2setupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _E2setupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _E2setupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _E2setupRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2setupResponse >-----#
    E2setupResponse = SEQ(name='E2setupResponse', mode=MODE_TYPE)
    _E2setupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2setupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2setupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2setupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2setupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2setupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'GlobalRIC-ID')))
    _____E2setupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    _____E2setupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsIDcause-List')))
    _____E2setupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAdditionAck-List')))
    ____E2setupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2setupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____E2setupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____E2setupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _____E2setupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _____E2setupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E2setupResponse_protocolIEs__item__id._const_tab = ____E2setupResponse_protocolIEs__item__id_tab
    ___E2setupResponse_protocolIEs__item__id._const_tab_at = None
    ___E2setupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E2setupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2setupResponse_protocolIEs__item__criticality._const_tab = ____E2setupResponse_protocolIEs__item__id_tab
    ___E2setupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2setupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2setupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2setupResponse_protocolIEs__item__value._const_tab = ____E2setupResponse_protocolIEs__item__id_tab
    ___E2setupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2setupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E2setupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2setupResponse_protocolIEs__item__id),
        ('criticality', ___E2setupResponse_protocolIEs__item__criticality),
        ('value', ___E2setupResponse_protocolIEs__item__value),
        ])
    __E2setupResponse_protocolIEs__item_._ext = None
    _E2setupResponse_protocolIEs._cont = __E2setupResponse_protocolIEs__item_
    _E2setupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2setupResponse._cont = ASN1Dict([
        ('protocolIEs', _E2setupResponse_protocolIEs),
        ])
    E2setupResponse._ext = []
    
    #-----< E2setupResponseIEs >-----#
    E2setupResponseIEs = CLASS(name='E2setupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2setupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2setupResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'GlobalRIC-ID')))
    _E2setupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    _E2setupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsIDcause-List')))
    _E2setupResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAdditionAck-List')))
    E2setupResponseIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2setupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _E2setupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _E2setupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _E2setupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _E2setupResponseIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2setupFailure >-----#
    E2setupFailure = SEQ(name='E2setupFailure', mode=MODE_TYPE)
    _E2setupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2setupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2setupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2setupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2setupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2setupFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____E2setupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _____E2setupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    _____E2setupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    ____E2setupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2setupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____E2setupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____E2setupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____E2setupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'ignore'), ('Value', _____E2setupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2setupFailure_protocolIEs__item__id._const_tab = ____E2setupFailure_protocolIEs__item__id_tab
    ___E2setupFailure_protocolIEs__item__id._const_tab_at = None
    ___E2setupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___E2setupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2setupFailure_protocolIEs__item__criticality._const_tab = ____E2setupFailure_protocolIEs__item__id_tab
    ___E2setupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2setupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2setupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2setupFailure_protocolIEs__item__value._const_tab = ____E2setupFailure_protocolIEs__item__id_tab
    ___E2setupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2setupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __E2setupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2setupFailure_protocolIEs__item__id),
        ('criticality', ___E2setupFailure_protocolIEs__item__criticality),
        ('value', ___E2setupFailure_protocolIEs__item__value),
        ])
    __E2setupFailure_protocolIEs__item_._ext = None
    _E2setupFailure_protocolIEs._cont = __E2setupFailure_protocolIEs__item_
    _E2setupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2setupFailure._cont = ASN1Dict([
        ('protocolIEs', _E2setupFailure_protocolIEs),
        ])
    E2setupFailure._ext = []
    
    #-----< E2setupFailureIEs >-----#
    E2setupFailureIEs = CLASS(name='E2setupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2setupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2setupFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _E2setupFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _E2setupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    _E2setupFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    E2setupFailureIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2setupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _E2setupFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _E2setupFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _E2setupFailureIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'ignore'), ('Value', _E2setupFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2connectionUpdate >-----#
    E2connectionUpdate = SEQ(name='E2connectionUpdate', mode=MODE_TYPE)
    _E2connectionUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2connectionUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2connectionUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2connectionUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-List')))
    _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateRemove-List')))
    _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-List')))
    ____E2connectionUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'reject'), ('Value', _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2connectionUpdate_protocolIEs__item__id._const_tab = ____E2connectionUpdate_protocolIEs__item__id_tab
    ___E2connectionUpdate_protocolIEs__item__id._const_tab_at = None
    ___E2connectionUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___E2connectionUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2connectionUpdate_protocolIEs__item__criticality._const_tab = ____E2connectionUpdate_protocolIEs__item__id_tab
    ___E2connectionUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2connectionUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2connectionUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2connectionUpdate_protocolIEs__item__value._const_tab = ____E2connectionUpdate_protocolIEs__item__id_tab
    ___E2connectionUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2connectionUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __E2connectionUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2connectionUpdate_protocolIEs__item__id),
        ('criticality', ___E2connectionUpdate_protocolIEs__item__criticality),
        ('value', ___E2connectionUpdate_protocolIEs__item__value),
        ])
    __E2connectionUpdate_protocolIEs__item_._ext = None
    _E2connectionUpdate_protocolIEs._cont = __E2connectionUpdate_protocolIEs__item_
    _E2connectionUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2connectionUpdate._cont = ASN1Dict([
        ('protocolIEs', _E2connectionUpdate_protocolIEs),
        ])
    E2connectionUpdate._ext = []
    
    #-----< E2connectionUpdate-IEs >-----#
    E2connectionUpdate_IEs = CLASS(name='E2connectionUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2connectionUpdate_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2connectionUpdate_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-List')))
    _E2connectionUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateRemove-List')))
    _E2connectionUpdate_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-List')))
    E2connectionUpdate_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2connectionUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _E2connectionUpdate_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _E2connectionUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'reject'), ('Value', _E2connectionUpdate_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2connectionUpdate-List >-----#
    E2connectionUpdate_List = SEQ_OF(name='E2connectionUpdate-List', mode=MODE_TYPE)
    _E2connectionUpdate_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2connectionUpdate_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2connectionUpdate_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2connectionUpdate_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-Item')))
    ___E2connectionUpdate_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'ignore'), ('Value', ____E2connectionUpdate_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2connectionUpdate_List__item__id._const_tab = ___E2connectionUpdate_List__item__id_tab
    __E2connectionUpdate_List__item__id._const_tab_at = None
    __E2connectionUpdate_List__item__id._const_tab_id = 'id'
    __E2connectionUpdate_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2connectionUpdate_List__item__criticality._const_tab = ___E2connectionUpdate_List__item__id_tab
    __E2connectionUpdate_List__item__criticality._const_tab_at = ('..', 'id')
    __E2connectionUpdate_List__item__criticality._const_tab_id = 'criticality'
    __E2connectionUpdate_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2connectionUpdate_List__item__value._const_tab = ___E2connectionUpdate_List__item__id_tab
    __E2connectionUpdate_List__item__value._const_tab_at = ('..', 'id')
    __E2connectionUpdate_List__item__value._const_tab_id = 'Value'
    _E2connectionUpdate_List__item_._cont = ASN1Dict([
        ('id', __E2connectionUpdate_List__item__id),
        ('criticality', __E2connectionUpdate_List__item__criticality),
        ('value', __E2connectionUpdate_List__item__value),
        ])
    _E2connectionUpdate_List__item_._ext = None
    E2connectionUpdate_List._cont = _E2connectionUpdate_List__item_
    E2connectionUpdate_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E2connectionUpdate-ItemIEs >-----#
    E2connectionUpdate_ItemIEs = CLASS(name='E2connectionUpdate-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2connectionUpdate_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-Item')))
    E2connectionUpdate_ItemIEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'ignore'), ('Value', _E2connectionUpdate_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2connectionUpdate-Item >-----#
    E2connectionUpdate_Item = SEQ(name='E2connectionUpdate-Item', mode=MODE_TYPE)
    _E2connectionUpdate_Item_tnlInformation = SEQ(name='tnlInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    _E2connectionUpdate_Item_tnlUsage = ENUM(name='tnlUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TNLusage')))
    E2connectionUpdate_Item._cont = ASN1Dict([
        ('tnlInformation', _E2connectionUpdate_Item_tnlInformation),
        ('tnlUsage', _E2connectionUpdate_Item_tnlUsage),
        ])
    E2connectionUpdate_Item._ext = []
    
    #-----< E2connectionUpdateRemove-List >-----#
    E2connectionUpdateRemove_List = SEQ_OF(name='E2connectionUpdateRemove-List', mode=MODE_TYPE)
    _E2connectionUpdateRemove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2connectionUpdateRemove_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2connectionUpdateRemove_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2connectionUpdateRemove_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateRemove-Item')))
    ___E2connectionUpdateRemove_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', ____E2connectionUpdateRemove_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2connectionUpdateRemove_List__item__id._const_tab = ___E2connectionUpdateRemove_List__item__id_tab
    __E2connectionUpdateRemove_List__item__id._const_tab_at = None
    __E2connectionUpdateRemove_List__item__id._const_tab_id = 'id'
    __E2connectionUpdateRemove_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2connectionUpdateRemove_List__item__criticality._const_tab = ___E2connectionUpdateRemove_List__item__id_tab
    __E2connectionUpdateRemove_List__item__criticality._const_tab_at = ('..', 'id')
    __E2connectionUpdateRemove_List__item__criticality._const_tab_id = 'criticality'
    __E2connectionUpdateRemove_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2connectionUpdateRemove_List__item__value._const_tab = ___E2connectionUpdateRemove_List__item__id_tab
    __E2connectionUpdateRemove_List__item__value._const_tab_at = ('..', 'id')
    __E2connectionUpdateRemove_List__item__value._const_tab_id = 'Value'
    _E2connectionUpdateRemove_List__item_._cont = ASN1Dict([
        ('id', __E2connectionUpdateRemove_List__item__id),
        ('criticality', __E2connectionUpdateRemove_List__item__criticality),
        ('value', __E2connectionUpdateRemove_List__item__value),
        ])
    _E2connectionUpdateRemove_List__item_._ext = None
    E2connectionUpdateRemove_List._cont = _E2connectionUpdateRemove_List__item_
    E2connectionUpdateRemove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E2connectionUpdateRemove-ItemIEs >-----#
    E2connectionUpdateRemove_ItemIEs = CLASS(name='E2connectionUpdateRemove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2connectionUpdateRemove_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateRemove-Item')))
    E2connectionUpdateRemove_ItemIEs._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', _E2connectionUpdateRemove_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2connectionUpdateRemove-Item >-----#
    E2connectionUpdateRemove_Item = SEQ(name='E2connectionUpdateRemove-Item', mode=MODE_TYPE)
    _E2connectionUpdateRemove_Item_tnlInformation = SEQ(name='tnlInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    E2connectionUpdateRemove_Item._cont = ASN1Dict([
        ('tnlInformation', _E2connectionUpdateRemove_Item_tnlInformation),
        ])
    E2connectionUpdateRemove_Item._ext = []
    
    #-----< E2connectionUpdateAcknowledge >-----#
    E2connectionUpdateAcknowledge = SEQ(name='E2connectionUpdateAcknowledge', mode=MODE_TYPE)
    _E2connectionUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2connectionUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2connectionUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-List')))
    _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionSetupFailed-List')))
    ____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2connectionUpdateAcknowledge_protocolIEs__item__id._const_tab = ____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab
    ___E2connectionUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___E2connectionUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___E2connectionUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2connectionUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab
    ___E2connectionUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2connectionUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2connectionUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2connectionUpdateAcknowledge_protocolIEs__item__value._const_tab = ____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab
    ___E2connectionUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2connectionUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __E2connectionUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2connectionUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___E2connectionUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___E2connectionUpdateAcknowledge_protocolIEs__item__value),
        ])
    __E2connectionUpdateAcknowledge_protocolIEs__item_._ext = None
    _E2connectionUpdateAcknowledge_protocolIEs._cont = __E2connectionUpdateAcknowledge_protocolIEs__item_
    _E2connectionUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2connectionUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _E2connectionUpdateAcknowledge_protocolIEs),
        ])
    E2connectionUpdateAcknowledge._ext = []
    
    #-----< E2connectionUpdateAck-IEs >-----#
    E2connectionUpdateAck_IEs = CLASS(name='E2connectionUpdateAck-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2connectionUpdateAck_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2connectionUpdateAck_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate-List')))
    _E2connectionUpdateAck_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionSetupFailed-List')))
    E2connectionUpdateAck_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2connectionUpdateAck_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _E2connectionUpdateAck_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _E2connectionUpdateAck_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2connectionSetupFailed-List >-----#
    E2connectionSetupFailed_List = SEQ_OF(name='E2connectionSetupFailed-List', mode=MODE_TYPE)
    _E2connectionSetupFailed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2connectionSetupFailed_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2connectionSetupFailed_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2connectionSetupFailed_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionSetupFailed-Item')))
    ___E2connectionSetupFailed_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Value', ____E2connectionSetupFailed_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2connectionSetupFailed_List__item__id._const_tab = ___E2connectionSetupFailed_List__item__id_tab
    __E2connectionSetupFailed_List__item__id._const_tab_at = None
    __E2connectionSetupFailed_List__item__id._const_tab_id = 'id'
    __E2connectionSetupFailed_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2connectionSetupFailed_List__item__criticality._const_tab = ___E2connectionSetupFailed_List__item__id_tab
    __E2connectionSetupFailed_List__item__criticality._const_tab_at = ('..', 'id')
    __E2connectionSetupFailed_List__item__criticality._const_tab_id = 'criticality'
    __E2connectionSetupFailed_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2connectionSetupFailed_List__item__value._const_tab = ___E2connectionSetupFailed_List__item__id_tab
    __E2connectionSetupFailed_List__item__value._const_tab_at = ('..', 'id')
    __E2connectionSetupFailed_List__item__value._const_tab_id = 'Value'
    _E2connectionSetupFailed_List__item_._cont = ASN1Dict([
        ('id', __E2connectionSetupFailed_List__item__id),
        ('criticality', __E2connectionSetupFailed_List__item__criticality),
        ('value', __E2connectionSetupFailed_List__item__value),
        ])
    _E2connectionSetupFailed_List__item_._ext = None
    E2connectionSetupFailed_List._cont = _E2connectionSetupFailed_List__item_
    E2connectionSetupFailed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E2connectionSetupFailed-ItemIEs >-----#
    E2connectionSetupFailed_ItemIEs = CLASS(name='E2connectionSetupFailed-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2connectionSetupFailed_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionSetupFailed-Item')))
    E2connectionSetupFailed_ItemIEs._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Value', _E2connectionSetupFailed_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2connectionSetupFailed-Item >-----#
    E2connectionSetupFailed_Item = SEQ(name='E2connectionSetupFailed-Item', mode=MODE_TYPE)
    _E2connectionSetupFailed_Item_tnlInformation = SEQ(name='tnlInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    _E2connectionSetupFailed_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    E2connectionSetupFailed_Item._cont = ASN1Dict([
        ('tnlInformation', _E2connectionSetupFailed_Item_tnlInformation),
        ('cause', _E2connectionSetupFailed_Item_cause),
        ])
    E2connectionSetupFailed_Item._ext = []
    
    #-----< E2connectionUpdateFailure >-----#
    E2connectionUpdateFailure = SEQ(name='E2connectionUpdateFailure', mode=MODE_TYPE)
    _E2connectionUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2connectionUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2connectionUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2connectionUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____E2connectionUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2connectionUpdateFailure_protocolIEs__item__id._const_tab = ____E2connectionUpdateFailure_protocolIEs__item__id_tab
    ___E2connectionUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___E2connectionUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___E2connectionUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2connectionUpdateFailure_protocolIEs__item__criticality._const_tab = ____E2connectionUpdateFailure_protocolIEs__item__id_tab
    ___E2connectionUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2connectionUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2connectionUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2connectionUpdateFailure_protocolIEs__item__value._const_tab = ____E2connectionUpdateFailure_protocolIEs__item__id_tab
    ___E2connectionUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2connectionUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __E2connectionUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2connectionUpdateFailure_protocolIEs__item__id),
        ('criticality', ___E2connectionUpdateFailure_protocolIEs__item__criticality),
        ('value', ___E2connectionUpdateFailure_protocolIEs__item__value),
        ])
    __E2connectionUpdateFailure_protocolIEs__item_._ext = None
    _E2connectionUpdateFailure_protocolIEs._cont = __E2connectionUpdateFailure_protocolIEs__item_
    _E2connectionUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2connectionUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _E2connectionUpdateFailure_protocolIEs),
        ])
    E2connectionUpdateFailure._ext = []
    
    #-----< E2connectionUpdateFailure-IEs >-----#
    E2connectionUpdateFailure_IEs = CLASS(name='E2connectionUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2connectionUpdateFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2connectionUpdateFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _E2connectionUpdateFailure_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _E2connectionUpdateFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    E2connectionUpdateFailure_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2connectionUpdateFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _E2connectionUpdateFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _E2connectionUpdateFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _E2connectionUpdateFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeConfigurationUpdate >-----#
    E2nodeConfigurationUpdate = SEQ(name='E2nodeConfigurationUpdate', mode=MODE_TYPE)
    _E2nodeConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2nodeConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2nodeConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2nodeConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-ID')))
    _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAddition-List')))
    _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdate-List')))
    _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemoval-List')))
    _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeTNLassociationRemoval-List')))
    ____E2nodeConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2nodeConfigurationUpdate_protocolIEs__item__id._const_tab = ____E2nodeConfigurationUpdate_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___E2nodeConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___E2nodeConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2nodeConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____E2nodeConfigurationUpdate_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2nodeConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2nodeConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2nodeConfigurationUpdate_protocolIEs__item__value._const_tab = ____E2nodeConfigurationUpdate_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2nodeConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __E2nodeConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2nodeConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___E2nodeConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___E2nodeConfigurationUpdate_protocolIEs__item__value),
        ])
    __E2nodeConfigurationUpdate_protocolIEs__item_._ext = None
    _E2nodeConfigurationUpdate_protocolIEs._cont = __E2nodeConfigurationUpdate_protocolIEs__item_
    _E2nodeConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2nodeConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _E2nodeConfigurationUpdate_protocolIEs),
        ])
    E2nodeConfigurationUpdate._ext = []
    
    #-----< E2nodeConfigurationUpdate-IEs >-----#
    E2nodeConfigurationUpdate_IEs = CLASS(name='E2nodeConfigurationUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeConfigurationUpdate_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2nodeConfigurationUpdate_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'GlobalE2node-ID')))
    _E2nodeConfigurationUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAddition-List')))
    _E2nodeConfigurationUpdate_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdate-List')))
    _E2nodeConfigurationUpdate_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemoval-List')))
    _E2nodeConfigurationUpdate_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeTNLassociationRemoval-List')))
    E2nodeConfigurationUpdate_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdate_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdate_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdate_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdate_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigAddition-List >-----#
    E2nodeComponentConfigAddition_List = SEQ_OF(name='E2nodeComponentConfigAddition-List', mode=MODE_TYPE)
    _E2nodeComponentConfigAddition_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeComponentConfigAddition_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeComponentConfigAddition_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeComponentConfigAddition_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAddition-Item')))
    ___E2nodeComponentConfigAddition_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'reject'), ('Value', ____E2nodeComponentConfigAddition_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeComponentConfigAddition_List__item__id._const_tab = ___E2nodeComponentConfigAddition_List__item__id_tab
    __E2nodeComponentConfigAddition_List__item__id._const_tab_at = None
    __E2nodeComponentConfigAddition_List__item__id._const_tab_id = 'id'
    __E2nodeComponentConfigAddition_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeComponentConfigAddition_List__item__criticality._const_tab = ___E2nodeComponentConfigAddition_List__item__id_tab
    __E2nodeComponentConfigAddition_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigAddition_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeComponentConfigAddition_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeComponentConfigAddition_List__item__value._const_tab = ___E2nodeComponentConfigAddition_List__item__id_tab
    __E2nodeComponentConfigAddition_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigAddition_List__item__value._const_tab_id = 'Value'
    _E2nodeComponentConfigAddition_List__item_._cont = ASN1Dict([
        ('id', __E2nodeComponentConfigAddition_List__item__id),
        ('criticality', __E2nodeComponentConfigAddition_List__item__criticality),
        ('value', __E2nodeComponentConfigAddition_List__item__value),
        ])
    _E2nodeComponentConfigAddition_List__item_._ext = None
    E2nodeComponentConfigAddition_List._cont = _E2nodeComponentConfigAddition_List__item_
    E2nodeComponentConfigAddition_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< E2nodeComponentConfigAddition-ItemIEs >-----#
    E2nodeComponentConfigAddition_ItemIEs = CLASS(name='E2nodeComponentConfigAddition-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeComponentConfigAddition_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAddition-Item')))
    E2nodeComponentConfigAddition_ItemIEs._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'reject'), ('Value', _E2nodeComponentConfigAddition_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigAddition-Item >-----#
    E2nodeComponentConfigAddition_Item = SEQ(name='E2nodeComponentConfigAddition-Item', mode=MODE_TYPE)
    _E2nodeComponentConfigAddition_Item_e2nodeComponentInterfaceType = ENUM(name='e2nodeComponentInterfaceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceType')))
    _E2nodeComponentConfigAddition_Item_e2nodeComponentID = CHOICE(name='e2nodeComponentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentID')))
    _E2nodeComponentConfigAddition_Item_e2nodeComponentConfiguration = SEQ(name='e2nodeComponentConfiguration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentConfiguration')))
    E2nodeComponentConfigAddition_Item._cont = ASN1Dict([
        ('e2nodeComponentInterfaceType', _E2nodeComponentConfigAddition_Item_e2nodeComponentInterfaceType),
        ('e2nodeComponentID', _E2nodeComponentConfigAddition_Item_e2nodeComponentID),
        ('e2nodeComponentConfiguration', _E2nodeComponentConfigAddition_Item_e2nodeComponentConfiguration),
        ])
    E2nodeComponentConfigAddition_Item._ext = []
    
    #-----< E2nodeComponentConfigUpdate-List >-----#
    E2nodeComponentConfigUpdate_List = SEQ_OF(name='E2nodeComponentConfigUpdate-List', mode=MODE_TYPE)
    _E2nodeComponentConfigUpdate_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeComponentConfigUpdate_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeComponentConfigUpdate_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeComponentConfigUpdate_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdate-Item')))
    ___E2nodeComponentConfigUpdate_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'reject'), ('Value', ____E2nodeComponentConfigUpdate_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeComponentConfigUpdate_List__item__id._const_tab = ___E2nodeComponentConfigUpdate_List__item__id_tab
    __E2nodeComponentConfigUpdate_List__item__id._const_tab_at = None
    __E2nodeComponentConfigUpdate_List__item__id._const_tab_id = 'id'
    __E2nodeComponentConfigUpdate_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeComponentConfigUpdate_List__item__criticality._const_tab = ___E2nodeComponentConfigUpdate_List__item__id_tab
    __E2nodeComponentConfigUpdate_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigUpdate_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeComponentConfigUpdate_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeComponentConfigUpdate_List__item__value._const_tab = ___E2nodeComponentConfigUpdate_List__item__id_tab
    __E2nodeComponentConfigUpdate_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigUpdate_List__item__value._const_tab_id = 'Value'
    _E2nodeComponentConfigUpdate_List__item_._cont = ASN1Dict([
        ('id', __E2nodeComponentConfigUpdate_List__item__id),
        ('criticality', __E2nodeComponentConfigUpdate_List__item__criticality),
        ('value', __E2nodeComponentConfigUpdate_List__item__value),
        ])
    _E2nodeComponentConfigUpdate_List__item_._ext = None
    E2nodeComponentConfigUpdate_List._cont = _E2nodeComponentConfigUpdate_List__item_
    E2nodeComponentConfigUpdate_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< E2nodeComponentConfigUpdate-ItemIEs >-----#
    E2nodeComponentConfigUpdate_ItemIEs = CLASS(name='E2nodeComponentConfigUpdate-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeComponentConfigUpdate_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdate-Item')))
    E2nodeComponentConfigUpdate_ItemIEs._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'reject'), ('Value', _E2nodeComponentConfigUpdate_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigUpdate-Item >-----#
    E2nodeComponentConfigUpdate_Item = SEQ(name='E2nodeComponentConfigUpdate-Item', mode=MODE_TYPE)
    _E2nodeComponentConfigUpdate_Item_e2nodeComponentInterfaceType = ENUM(name='e2nodeComponentInterfaceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceType')))
    _E2nodeComponentConfigUpdate_Item_e2nodeComponentID = CHOICE(name='e2nodeComponentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentID')))
    _E2nodeComponentConfigUpdate_Item_e2nodeComponentConfiguration = SEQ(name='e2nodeComponentConfiguration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentConfiguration')))
    E2nodeComponentConfigUpdate_Item._cont = ASN1Dict([
        ('e2nodeComponentInterfaceType', _E2nodeComponentConfigUpdate_Item_e2nodeComponentInterfaceType),
        ('e2nodeComponentID', _E2nodeComponentConfigUpdate_Item_e2nodeComponentID),
        ('e2nodeComponentConfiguration', _E2nodeComponentConfigUpdate_Item_e2nodeComponentConfiguration),
        ])
    E2nodeComponentConfigUpdate_Item._ext = []
    
    #-----< E2nodeComponentConfigRemoval-List >-----#
    E2nodeComponentConfigRemoval_List = SEQ_OF(name='E2nodeComponentConfigRemoval-List', mode=MODE_TYPE)
    _E2nodeComponentConfigRemoval_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeComponentConfigRemoval_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeComponentConfigRemoval_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeComponentConfigRemoval_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemoval-Item')))
    ___E2nodeComponentConfigRemoval_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'reject'), ('Value', ____E2nodeComponentConfigRemoval_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeComponentConfigRemoval_List__item__id._const_tab = ___E2nodeComponentConfigRemoval_List__item__id_tab
    __E2nodeComponentConfigRemoval_List__item__id._const_tab_at = None
    __E2nodeComponentConfigRemoval_List__item__id._const_tab_id = 'id'
    __E2nodeComponentConfigRemoval_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeComponentConfigRemoval_List__item__criticality._const_tab = ___E2nodeComponentConfigRemoval_List__item__id_tab
    __E2nodeComponentConfigRemoval_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigRemoval_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeComponentConfigRemoval_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeComponentConfigRemoval_List__item__value._const_tab = ___E2nodeComponentConfigRemoval_List__item__id_tab
    __E2nodeComponentConfigRemoval_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigRemoval_List__item__value._const_tab_id = 'Value'
    _E2nodeComponentConfigRemoval_List__item_._cont = ASN1Dict([
        ('id', __E2nodeComponentConfigRemoval_List__item__id),
        ('criticality', __E2nodeComponentConfigRemoval_List__item__criticality),
        ('value', __E2nodeComponentConfigRemoval_List__item__value),
        ])
    _E2nodeComponentConfigRemoval_List__item_._ext = None
    E2nodeComponentConfigRemoval_List._cont = _E2nodeComponentConfigRemoval_List__item_
    E2nodeComponentConfigRemoval_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< E2nodeComponentConfigRemoval-ItemIEs >-----#
    E2nodeComponentConfigRemoval_ItemIEs = CLASS(name='E2nodeComponentConfigRemoval-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeComponentConfigRemoval_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemoval-Item')))
    E2nodeComponentConfigRemoval_ItemIEs._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'reject'), ('Value', _E2nodeComponentConfigRemoval_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigRemoval-Item >-----#
    E2nodeComponentConfigRemoval_Item = SEQ(name='E2nodeComponentConfigRemoval-Item', mode=MODE_TYPE)
    _E2nodeComponentConfigRemoval_Item_e2nodeComponentInterfaceType = ENUM(name='e2nodeComponentInterfaceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceType')))
    _E2nodeComponentConfigRemoval_Item_e2nodeComponentID = CHOICE(name='e2nodeComponentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentID')))
    E2nodeComponentConfigRemoval_Item._cont = ASN1Dict([
        ('e2nodeComponentInterfaceType', _E2nodeComponentConfigRemoval_Item_e2nodeComponentInterfaceType),
        ('e2nodeComponentID', _E2nodeComponentConfigRemoval_Item_e2nodeComponentID),
        ])
    E2nodeComponentConfigRemoval_Item._ext = []
    
    #-----< E2nodeTNLassociationRemoval-List >-----#
    E2nodeTNLassociationRemoval_List = SEQ_OF(name='E2nodeTNLassociationRemoval-List', mode=MODE_TYPE)
    _E2nodeTNLassociationRemoval_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeTNLassociationRemoval_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeTNLassociationRemoval_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeTNLassociationRemoval_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeTNLassociationRemoval-Item')))
    ___E2nodeTNLassociationRemoval_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'reject'), ('Value', ____E2nodeTNLassociationRemoval_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeTNLassociationRemoval_List__item__id._const_tab = ___E2nodeTNLassociationRemoval_List__item__id_tab
    __E2nodeTNLassociationRemoval_List__item__id._const_tab_at = None
    __E2nodeTNLassociationRemoval_List__item__id._const_tab_id = 'id'
    __E2nodeTNLassociationRemoval_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeTNLassociationRemoval_List__item__criticality._const_tab = ___E2nodeTNLassociationRemoval_List__item__id_tab
    __E2nodeTNLassociationRemoval_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeTNLassociationRemoval_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeTNLassociationRemoval_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeTNLassociationRemoval_List__item__value._const_tab = ___E2nodeTNLassociationRemoval_List__item__id_tab
    __E2nodeTNLassociationRemoval_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeTNLassociationRemoval_List__item__value._const_tab_id = 'Value'
    _E2nodeTNLassociationRemoval_List__item_._cont = ASN1Dict([
        ('id', __E2nodeTNLassociationRemoval_List__item__id),
        ('criticality', __E2nodeTNLassociationRemoval_List__item__criticality),
        ('value', __E2nodeTNLassociationRemoval_List__item__value),
        ])
    _E2nodeTNLassociationRemoval_List__item_._ext = None
    E2nodeTNLassociationRemoval_List._cont = _E2nodeTNLassociationRemoval_List__item_
    E2nodeTNLassociationRemoval_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E2nodeTNLassociationRemoval-ItemIEs >-----#
    E2nodeTNLassociationRemoval_ItemIEs = CLASS(name='E2nodeTNLassociationRemoval-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeTNLassociationRemoval_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeTNLassociationRemoval-Item')))
    E2nodeTNLassociationRemoval_ItemIEs._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'reject'), ('Value', _E2nodeTNLassociationRemoval_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeTNLassociationRemoval-Item >-----#
    E2nodeTNLassociationRemoval_Item = SEQ(name='E2nodeTNLassociationRemoval-Item', mode=MODE_TYPE)
    _E2nodeTNLassociationRemoval_Item_tnlInformation = SEQ(name='tnlInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    _E2nodeTNLassociationRemoval_Item_tnlInformationRIC = SEQ(name='tnlInformationRIC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'TNLinformation')))
    E2nodeTNLassociationRemoval_Item._cont = ASN1Dict([
        ('tnlInformation', _E2nodeTNLassociationRemoval_Item_tnlInformation),
        ('tnlInformationRIC', _E2nodeTNLassociationRemoval_Item_tnlInformationRIC),
        ])
    E2nodeTNLassociationRemoval_Item._ext = []
    
    #-----< E2nodeConfigurationUpdateAcknowledge >-----#
    E2nodeConfigurationUpdateAcknowledge = SEQ(name='E2nodeConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _E2nodeConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2nodeConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAdditionAck-List')))
    _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdateAck-List')))
    _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemovalAck-List')))
    ____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __E2nodeConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __E2nodeConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _E2nodeConfigurationUpdateAcknowledge_protocolIEs._cont = __E2nodeConfigurationUpdateAcknowledge_protocolIEs__item_
    _E2nodeConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2nodeConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _E2nodeConfigurationUpdateAcknowledge_protocolIEs),
        ])
    E2nodeConfigurationUpdateAcknowledge._ext = []
    
    #-----< E2nodeConfigurationUpdateAcknowledge-IEs >-----#
    E2nodeConfigurationUpdateAcknowledge_IEs = CLASS(name='E2nodeConfigurationUpdateAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAdditionAck-List')))
    _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdateAck-List')))
    _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemovalAck-List')))
    E2nodeConfigurationUpdateAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigAdditionAck-List >-----#
    E2nodeComponentConfigAdditionAck_List = SEQ_OF(name='E2nodeComponentConfigAdditionAck-List', mode=MODE_TYPE)
    _E2nodeComponentConfigAdditionAck_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeComponentConfigAdditionAck_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeComponentConfigAdditionAck_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeComponentConfigAdditionAck_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAdditionAck-Item')))
    ___E2nodeComponentConfigAdditionAck_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 53), ('criticality', 'reject'), ('Value', ____E2nodeComponentConfigAdditionAck_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeComponentConfigAdditionAck_List__item__id._const_tab = ___E2nodeComponentConfigAdditionAck_List__item__id_tab
    __E2nodeComponentConfigAdditionAck_List__item__id._const_tab_at = None
    __E2nodeComponentConfigAdditionAck_List__item__id._const_tab_id = 'id'
    __E2nodeComponentConfigAdditionAck_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeComponentConfigAdditionAck_List__item__criticality._const_tab = ___E2nodeComponentConfigAdditionAck_List__item__id_tab
    __E2nodeComponentConfigAdditionAck_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigAdditionAck_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeComponentConfigAdditionAck_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeComponentConfigAdditionAck_List__item__value._const_tab = ___E2nodeComponentConfigAdditionAck_List__item__id_tab
    __E2nodeComponentConfigAdditionAck_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigAdditionAck_List__item__value._const_tab_id = 'Value'
    _E2nodeComponentConfigAdditionAck_List__item_._cont = ASN1Dict([
        ('id', __E2nodeComponentConfigAdditionAck_List__item__id),
        ('criticality', __E2nodeComponentConfigAdditionAck_List__item__criticality),
        ('value', __E2nodeComponentConfigAdditionAck_List__item__value),
        ])
    _E2nodeComponentConfigAdditionAck_List__item_._ext = None
    E2nodeComponentConfigAdditionAck_List._cont = _E2nodeComponentConfigAdditionAck_List__item_
    E2nodeComponentConfigAdditionAck_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< E2nodeComponentConfigAdditionAck-ItemIEs >-----#
    E2nodeComponentConfigAdditionAck_ItemIEs = CLASS(name='E2nodeComponentConfigAdditionAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeComponentConfigAdditionAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigAdditionAck-Item')))
    E2nodeComponentConfigAdditionAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 53), ('criticality', 'reject'), ('Value', _E2nodeComponentConfigAdditionAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigAdditionAck-Item >-----#
    E2nodeComponentConfigAdditionAck_Item = SEQ(name='E2nodeComponentConfigAdditionAck-Item', mode=MODE_TYPE)
    _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentInterfaceType = ENUM(name='e2nodeComponentInterfaceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceType')))
    _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentID = CHOICE(name='e2nodeComponentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentID')))
    _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentConfigurationAck = SEQ(name='e2nodeComponentConfigurationAck', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentConfigurationAck')))
    E2nodeComponentConfigAdditionAck_Item._cont = ASN1Dict([
        ('e2nodeComponentInterfaceType', _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentInterfaceType),
        ('e2nodeComponentID', _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentID),
        ('e2nodeComponentConfigurationAck', _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentConfigurationAck),
        ])
    E2nodeComponentConfigAdditionAck_Item._ext = []
    
    #-----< E2nodeComponentConfigUpdateAck-List >-----#
    E2nodeComponentConfigUpdateAck_List = SEQ_OF(name='E2nodeComponentConfigUpdateAck-List', mode=MODE_TYPE)
    _E2nodeComponentConfigUpdateAck_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeComponentConfigUpdateAck_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeComponentConfigUpdateAck_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeComponentConfigUpdateAck_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdateAck-Item')))
    ___E2nodeComponentConfigUpdateAck_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 36), ('criticality', 'reject'), ('Value', ____E2nodeComponentConfigUpdateAck_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeComponentConfigUpdateAck_List__item__id._const_tab = ___E2nodeComponentConfigUpdateAck_List__item__id_tab
    __E2nodeComponentConfigUpdateAck_List__item__id._const_tab_at = None
    __E2nodeComponentConfigUpdateAck_List__item__id._const_tab_id = 'id'
    __E2nodeComponentConfigUpdateAck_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeComponentConfigUpdateAck_List__item__criticality._const_tab = ___E2nodeComponentConfigUpdateAck_List__item__id_tab
    __E2nodeComponentConfigUpdateAck_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigUpdateAck_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeComponentConfigUpdateAck_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeComponentConfigUpdateAck_List__item__value._const_tab = ___E2nodeComponentConfigUpdateAck_List__item__id_tab
    __E2nodeComponentConfigUpdateAck_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigUpdateAck_List__item__value._const_tab_id = 'Value'
    _E2nodeComponentConfigUpdateAck_List__item_._cont = ASN1Dict([
        ('id', __E2nodeComponentConfigUpdateAck_List__item__id),
        ('criticality', __E2nodeComponentConfigUpdateAck_List__item__criticality),
        ('value', __E2nodeComponentConfigUpdateAck_List__item__value),
        ])
    _E2nodeComponentConfigUpdateAck_List__item_._ext = None
    E2nodeComponentConfigUpdateAck_List._cont = _E2nodeComponentConfigUpdateAck_List__item_
    E2nodeComponentConfigUpdateAck_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< E2nodeComponentConfigUpdateAck-ItemIEs >-----#
    E2nodeComponentConfigUpdateAck_ItemIEs = CLASS(name='E2nodeComponentConfigUpdateAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeComponentConfigUpdateAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigUpdateAck-Item')))
    E2nodeComponentConfigUpdateAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 36), ('criticality', 'reject'), ('Value', _E2nodeComponentConfigUpdateAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigUpdateAck-Item >-----#
    E2nodeComponentConfigUpdateAck_Item = SEQ(name='E2nodeComponentConfigUpdateAck-Item', mode=MODE_TYPE)
    _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentInterfaceType = ENUM(name='e2nodeComponentInterfaceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceType')))
    _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentID = CHOICE(name='e2nodeComponentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentID')))
    _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentConfigurationAck = SEQ(name='e2nodeComponentConfigurationAck', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentConfigurationAck')))
    E2nodeComponentConfigUpdateAck_Item._cont = ASN1Dict([
        ('e2nodeComponentInterfaceType', _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentInterfaceType),
        ('e2nodeComponentID', _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentID),
        ('e2nodeComponentConfigurationAck', _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentConfigurationAck),
        ])
    E2nodeComponentConfigUpdateAck_Item._ext = []
    
    #-----< E2nodeComponentConfigRemovalAck-List >-----#
    E2nodeComponentConfigRemovalAck_List = SEQ_OF(name='E2nodeComponentConfigRemovalAck-List', mode=MODE_TYPE)
    _E2nodeComponentConfigRemovalAck_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __E2nodeComponentConfigRemovalAck_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___E2nodeComponentConfigRemovalAck_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____E2nodeComponentConfigRemovalAck_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemovalAck-Item')))
    ___E2nodeComponentConfigRemovalAck_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', ____E2nodeComponentConfigRemovalAck_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E2nodeComponentConfigRemovalAck_List__item__id._const_tab = ___E2nodeComponentConfigRemovalAck_List__item__id_tab
    __E2nodeComponentConfigRemovalAck_List__item__id._const_tab_at = None
    __E2nodeComponentConfigRemovalAck_List__item__id._const_tab_id = 'id'
    __E2nodeComponentConfigRemovalAck_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __E2nodeComponentConfigRemovalAck_List__item__criticality._const_tab = ___E2nodeComponentConfigRemovalAck_List__item__id_tab
    __E2nodeComponentConfigRemovalAck_List__item__criticality._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigRemovalAck_List__item__criticality._const_tab_id = 'criticality'
    __E2nodeComponentConfigRemovalAck_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __E2nodeComponentConfigRemovalAck_List__item__value._const_tab = ___E2nodeComponentConfigRemovalAck_List__item__id_tab
    __E2nodeComponentConfigRemovalAck_List__item__value._const_tab_at = ('..', 'id')
    __E2nodeComponentConfigRemovalAck_List__item__value._const_tab_id = 'Value'
    _E2nodeComponentConfigRemovalAck_List__item_._cont = ASN1Dict([
        ('id', __E2nodeComponentConfigRemovalAck_List__item__id),
        ('criticality', __E2nodeComponentConfigRemovalAck_List__item__criticality),
        ('value', __E2nodeComponentConfigRemovalAck_List__item__value),
        ])
    _E2nodeComponentConfigRemovalAck_List__item_._ext = None
    E2nodeComponentConfigRemovalAck_List._cont = _E2nodeComponentConfigRemovalAck_List__item_
    E2nodeComponentConfigRemovalAck_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< E2nodeComponentConfigRemovalAck-ItemIEs >-----#
    E2nodeComponentConfigRemovalAck_ItemIEs = CLASS(name='E2nodeComponentConfigRemovalAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeComponentConfigRemovalAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeComponentConfigRemovalAck-Item')))
    E2nodeComponentConfigRemovalAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _E2nodeComponentConfigRemovalAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2nodeComponentConfigRemovalAck-Item >-----#
    E2nodeComponentConfigRemovalAck_Item = SEQ(name='E2nodeComponentConfigRemovalAck-Item', mode=MODE_TYPE)
    _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentInterfaceType = ENUM(name='e2nodeComponentInterfaceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentInterfaceType')))
    _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentID = CHOICE(name='e2nodeComponentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentID')))
    _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentConfigurationAck = SEQ(name='e2nodeComponentConfigurationAck', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'E2nodeComponentConfigurationAck')))
    E2nodeComponentConfigRemovalAck_Item._cont = ASN1Dict([
        ('e2nodeComponentInterfaceType', _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentInterfaceType),
        ('e2nodeComponentID', _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentID),
        ('e2nodeComponentConfigurationAck', _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentConfigurationAck),
        ])
    E2nodeComponentConfigRemovalAck_Item._ext = []
    
    #-----< E2nodeConfigurationUpdateFailure >-----#
    E2nodeConfigurationUpdateFailure = SEQ(name='E2nodeConfigurationUpdateFailure', mode=MODE_TYPE)
    _E2nodeConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2nodeConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2nodeConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __E2nodeConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2nodeConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___E2nodeConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___E2nodeConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __E2nodeConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _E2nodeConfigurationUpdateFailure_protocolIEs._cont = __E2nodeConfigurationUpdateFailure_protocolIEs__item_
    _E2nodeConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2nodeConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _E2nodeConfigurationUpdateFailure_protocolIEs),
        ])
    E2nodeConfigurationUpdateFailure._ext = []
    
    #-----< E2nodeConfigurationUpdateFailure-IEs >-----#
    E2nodeConfigurationUpdateFailure_IEs = CLASS(name='E2nodeConfigurationUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2nodeConfigurationUpdateFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2nodeConfigurationUpdateFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _E2nodeConfigurationUpdateFailure_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _E2nodeConfigurationUpdateFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    E2nodeConfigurationUpdateFailure_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2nodeConfigurationUpdateFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _E2nodeConfigurationUpdateFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _E2nodeConfigurationUpdateFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _E2nodeConfigurationUpdateFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetRequest >-----#
    ResetRequest = SEQ(name='ResetRequest', mode=MODE_TYPE)
    _ResetRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __ResetRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___ResetRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____ResetRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    ____ResetRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ResetRequest_protocolIEs__item__id._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__id._const_tab_at = None
    ___ResetRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___ResetRequest_protocolIEs__item__criticality._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___ResetRequest_protocolIEs__item__value._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetRequest_protocolIEs__item__id),
        ('criticality', ___ResetRequest_protocolIEs__item__criticality),
        ('value', ___ResetRequest_protocolIEs__item__value),
        ])
    __ResetRequest_protocolIEs__item_._ext = None
    _ResetRequest_protocolIEs._cont = __ResetRequest_protocolIEs__item_
    _ResetRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetRequest._cont = ASN1Dict([
        ('protocolIEs', _ResetRequest_protocolIEs),
        ])
    ResetRequest._ext = []
    
    #-----< ResetRequestIEs >-----#
    ResetRequestIEs = CLASS(name='ResetRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _ResetRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _ResetRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    ResetRequestIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _ResetRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ResetRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse >-----#
    ResetResponse = SEQ(name='ResetResponse', mode=MODE_TYPE)
    _ResetResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __ResetResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___ResetResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____ResetResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____ResetResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolIEs__item__id._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__id._const_tab_at = None
    ___ResetResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___ResetResponse_protocolIEs__item__criticality._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___ResetResponse_protocolIEs__item__value._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetResponse_protocolIEs__item__id),
        ('criticality', ___ResetResponse_protocolIEs__item__criticality),
        ('value', ___ResetResponse_protocolIEs__item__value),
        ])
    __ResetResponse_protocolIEs__item_._ext = None
    _ResetResponse_protocolIEs._cont = __ResetResponse_protocolIEs__item_
    _ResetResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResponse._cont = ASN1Dict([
        ('protocolIEs', _ResetResponse_protocolIEs),
        ])
    ResetResponse._ext = []
    
    #-----< ResetResponseIEs >-----#
    ResetResponseIEs = CLASS(name='ResetResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _ResetResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _ResetResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ResetResponseIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _ResetResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ResetResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICserviceUpdate >-----#
    RICserviceUpdate = SEQ(name='RICserviceUpdate', mode=MODE_TYPE)
    _RICserviceUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICserviceUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICserviceUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICserviceUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctions-List')))
    _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctions-List')))
    _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    ____RICserviceUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 12), ('criticality', 'reject'), ('Value', _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICserviceUpdate_protocolIEs__item__id._const_tab = ____RICserviceUpdate_protocolIEs__item__id_tab
    ___RICserviceUpdate_protocolIEs__item__id._const_tab_at = None
    ___RICserviceUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___RICserviceUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICserviceUpdate_protocolIEs__item__criticality._const_tab = ____RICserviceUpdate_protocolIEs__item__id_tab
    ___RICserviceUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICserviceUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICserviceUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICserviceUpdate_protocolIEs__item__value._const_tab = ____RICserviceUpdate_protocolIEs__item__id_tab
    ___RICserviceUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICserviceUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __RICserviceUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICserviceUpdate_protocolIEs__item__id),
        ('criticality', ___RICserviceUpdate_protocolIEs__item__criticality),
        ('value', ___RICserviceUpdate_protocolIEs__item__value),
        ])
    __RICserviceUpdate_protocolIEs__item_._ext = None
    _RICserviceUpdate_protocolIEs._cont = __RICserviceUpdate_protocolIEs__item_
    _RICserviceUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICserviceUpdate._cont = ASN1Dict([
        ('protocolIEs', _RICserviceUpdate_protocolIEs),
        ])
    RICserviceUpdate._ext = []
    
    #-----< RICserviceUpdate-IEs >-----#
    RICserviceUpdate_IEs = CLASS(name='RICserviceUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICserviceUpdate_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _RICserviceUpdate_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctions-List')))
    _RICserviceUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctions-List')))
    _RICserviceUpdate_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    RICserviceUpdate_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _RICserviceUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _RICserviceUpdate_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 12), ('criticality', 'reject'), ('Value', _RICserviceUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _RICserviceUpdate_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANfunctions-List >-----#
    RANfunctions_List = SEQ_OF(name='RANfunctions-List', mode=MODE_TYPE)
    _RANfunctions_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RANfunctions_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RANfunctions_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RANfunctions_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunction-Item')))
    ___RANfunctions_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'ignore'), ('Value', ____RANfunctions_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RANfunctions_List__item__id._const_tab = ___RANfunctions_List__item__id_tab
    __RANfunctions_List__item__id._const_tab_at = None
    __RANfunctions_List__item__id._const_tab_id = 'id'
    __RANfunctions_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RANfunctions_List__item__criticality._const_tab = ___RANfunctions_List__item__id_tab
    __RANfunctions_List__item__criticality._const_tab_at = ('..', 'id')
    __RANfunctions_List__item__criticality._const_tab_id = 'criticality'
    __RANfunctions_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RANfunctions_List__item__value._const_tab = ___RANfunctions_List__item__id_tab
    __RANfunctions_List__item__value._const_tab_at = ('..', 'id')
    __RANfunctions_List__item__value._const_tab_id = 'Value'
    _RANfunctions_List__item_._cont = ASN1Dict([
        ('id', __RANfunctions_List__item__id),
        ('criticality', __RANfunctions_List__item__criticality),
        ('value', __RANfunctions_List__item__value),
        ])
    _RANfunctions_List__item_._ext = None
    RANfunctions_List._cont = _RANfunctions_List__item_
    RANfunctions_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RANfunction-ItemIEs >-----#
    RANfunction_ItemIEs = CLASS(name='RANfunction-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RANfunction_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunction-Item')))
    RANfunction_ItemIEs._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'ignore'), ('Value', _RANfunction_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RANfunction-Item >-----#
    RANfunction_Item = SEQ(name='RANfunction-Item', mode=MODE_TYPE)
    _RANfunction_Item_ranFunctionID = INT(name='ranFunctionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RANfunction_Item_ranFunctionDefinition = OCT_STR(name='ranFunctionDefinition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionDefinition')))
    _RANfunction_Item_ranFunctionRevision = INT(name='ranFunctionRevision', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionRevision')))
    _RANfunction_Item_ranFunctionOID = STR_PRINT(name='ranFunctionOID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionOID')))
    RANfunction_Item._cont = ASN1Dict([
        ('ranFunctionID', _RANfunction_Item_ranFunctionID),
        ('ranFunctionDefinition', _RANfunction_Item_ranFunctionDefinition),
        ('ranFunctionRevision', _RANfunction_Item_ranFunctionRevision),
        ('ranFunctionOID', _RANfunction_Item_ranFunctionOID),
        ])
    RANfunction_Item._ext = []
    
    #-----< RANfunctionsID-List >-----#
    RANfunctionsID_List = SEQ_OF(name='RANfunctionsID-List', mode=MODE_TYPE)
    _RANfunctionsID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RANfunctionsID_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RANfunctionsID_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RANfunctionsID_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionID-Item')))
    ___RANfunctionsID_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'ignore'), ('Value', ____RANfunctionsID_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RANfunctionsID_List__item__id._const_tab = ___RANfunctionsID_List__item__id_tab
    __RANfunctionsID_List__item__id._const_tab_at = None
    __RANfunctionsID_List__item__id._const_tab_id = 'id'
    __RANfunctionsID_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RANfunctionsID_List__item__criticality._const_tab = ___RANfunctionsID_List__item__id_tab
    __RANfunctionsID_List__item__criticality._const_tab_at = ('..', 'id')
    __RANfunctionsID_List__item__criticality._const_tab_id = 'criticality'
    __RANfunctionsID_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RANfunctionsID_List__item__value._const_tab = ___RANfunctionsID_List__item__id_tab
    __RANfunctionsID_List__item__value._const_tab_at = ('..', 'id')
    __RANfunctionsID_List__item__value._const_tab_id = 'Value'
    _RANfunctionsID_List__item_._cont = ASN1Dict([
        ('id', __RANfunctionsID_List__item__id),
        ('criticality', __RANfunctionsID_List__item__criticality),
        ('value', __RANfunctionsID_List__item__value),
        ])
    _RANfunctionsID_List__item_._ext = None
    RANfunctionsID_List._cont = _RANfunctionsID_List__item_
    RANfunctionsID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RANfunctionID-ItemIEs >-----#
    RANfunctionID_ItemIEs = CLASS(name='RANfunctionID-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RANfunctionID_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionID-Item')))
    RANfunctionID_ItemIEs._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'ignore'), ('Value', _RANfunctionID_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RANfunctionID-Item >-----#
    RANfunctionID_Item = SEQ(name='RANfunctionID-Item', mode=MODE_TYPE)
    _RANfunctionID_Item_ranFunctionID = INT(name='ranFunctionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RANfunctionID_Item_ranFunctionRevision = INT(name='ranFunctionRevision', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionRevision')))
    RANfunctionID_Item._cont = ASN1Dict([
        ('ranFunctionID', _RANfunctionID_Item_ranFunctionID),
        ('ranFunctionRevision', _RANfunctionID_Item_ranFunctionRevision),
        ])
    RANfunctionID_Item._ext = []
    
    #-----< RICserviceUpdateAcknowledge >-----#
    RICserviceUpdateAcknowledge = SEQ(name='RICserviceUpdateAcknowledge', mode=MODE_TYPE)
    _RICserviceUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICserviceUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICserviceUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsIDcause-List')))
    ____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICserviceUpdateAcknowledge_protocolIEs__item__id._const_tab = ____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab
    ___RICserviceUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RICserviceUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___RICserviceUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICserviceUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab
    ___RICserviceUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICserviceUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICserviceUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICserviceUpdateAcknowledge_protocolIEs__item__value._const_tab = ____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab
    ___RICserviceUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICserviceUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __RICserviceUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICserviceUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___RICserviceUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___RICserviceUpdateAcknowledge_protocolIEs__item__value),
        ])
    __RICserviceUpdateAcknowledge_protocolIEs__item_._ext = None
    _RICserviceUpdateAcknowledge_protocolIEs._cont = __RICserviceUpdateAcknowledge_protocolIEs__item_
    _RICserviceUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICserviceUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _RICserviceUpdateAcknowledge_protocolIEs),
        ])
    RICserviceUpdateAcknowledge._ext = []
    
    #-----< RICserviceUpdateAcknowledge-IEs >-----#
    RICserviceUpdateAcknowledge_IEs = CLASS(name='RICserviceUpdateAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICserviceUpdateAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _RICserviceUpdateAcknowledge_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    _RICserviceUpdateAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsIDcause-List')))
    RICserviceUpdateAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _RICserviceUpdateAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _RICserviceUpdateAcknowledge_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _RICserviceUpdateAcknowledge_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANfunctionsIDcause-List >-----#
    RANfunctionsIDcause_List = SEQ_OF(name='RANfunctionsIDcause-List', mode=MODE_TYPE)
    _RANfunctionsIDcause_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-SingleContainer')))
    __RANfunctionsIDcause_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ___RANfunctionsIDcause_List__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    ____RANfunctionsIDcause_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionIDcause-Item')))
    ___RANfunctionsIDcause_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', ____RANfunctionsIDcause_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RANfunctionsIDcause_List__item__id._const_tab = ___RANfunctionsIDcause_List__item__id_tab
    __RANfunctionsIDcause_List__item__id._const_tab_at = None
    __RANfunctionsIDcause_List__item__id._const_tab_id = 'id'
    __RANfunctionsIDcause_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    __RANfunctionsIDcause_List__item__criticality._const_tab = ___RANfunctionsIDcause_List__item__id_tab
    __RANfunctionsIDcause_List__item__criticality._const_tab_at = ('..', 'id')
    __RANfunctionsIDcause_List__item__criticality._const_tab_id = 'criticality'
    __RANfunctionsIDcause_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    __RANfunctionsIDcause_List__item__value._const_tab = ___RANfunctionsIDcause_List__item__id_tab
    __RANfunctionsIDcause_List__item__value._const_tab_at = ('..', 'id')
    __RANfunctionsIDcause_List__item__value._const_tab_id = 'Value'
    _RANfunctionsIDcause_List__item_._cont = ASN1Dict([
        ('id', __RANfunctionsIDcause_List__item__id),
        ('criticality', __RANfunctionsIDcause_List__item__criticality),
        ('value', __RANfunctionsIDcause_List__item__value),
        ])
    _RANfunctionsIDcause_List__item_._ext = None
    RANfunctionsIDcause_List._cont = _RANfunctionsIDcause_List__item_
    RANfunctionsIDcause_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RANfunctionIDcause-ItemIEs >-----#
    RANfunctionIDcause_ItemIEs = CLASS(name='RANfunctionIDcause-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RANfunctionIDcause_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionIDcause-Item')))
    RANfunctionIDcause_ItemIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', _RANfunctionIDcause_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RANfunctionIDcause-Item >-----#
    RANfunctionIDcause_Item = SEQ(name='RANfunctionIDcause-Item', mode=MODE_TYPE)
    _RANfunctionIDcause_Item_ranFunctionID = INT(name='ranFunctionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'RANfunctionID')))
    _RANfunctionIDcause_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    RANfunctionIDcause_Item._cont = ASN1Dict([
        ('ranFunctionID', _RANfunctionIDcause_Item_ranFunctionID),
        ('cause', _RANfunctionIDcause_Item_cause),
        ])
    RANfunctionIDcause_Item._ext = []
    
    #-----< RICserviceUpdateFailure >-----#
    RICserviceUpdateFailure = SEQ(name='RICserviceUpdateFailure', mode=MODE_TYPE)
    _RICserviceUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICserviceUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICserviceUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICserviceUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____RICserviceUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICserviceUpdateFailure_protocolIEs__item__id._const_tab = ____RICserviceUpdateFailure_protocolIEs__item__id_tab
    ___RICserviceUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___RICserviceUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RICserviceUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICserviceUpdateFailure_protocolIEs__item__criticality._const_tab = ____RICserviceUpdateFailure_protocolIEs__item__id_tab
    ___RICserviceUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICserviceUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICserviceUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICserviceUpdateFailure_protocolIEs__item__value._const_tab = ____RICserviceUpdateFailure_protocolIEs__item__id_tab
    ___RICserviceUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICserviceUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RICserviceUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICserviceUpdateFailure_protocolIEs__item__id),
        ('criticality', ___RICserviceUpdateFailure_protocolIEs__item__criticality),
        ('value', ___RICserviceUpdateFailure_protocolIEs__item__value),
        ])
    __RICserviceUpdateFailure_protocolIEs__item_._ext = None
    _RICserviceUpdateFailure_protocolIEs._cont = __RICserviceUpdateFailure_protocolIEs__item_
    _RICserviceUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICserviceUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _RICserviceUpdateFailure_protocolIEs),
        ])
    RICserviceUpdateFailure._ext = []
    
    #-----< RICserviceUpdateFailure-IEs >-----#
    RICserviceUpdateFailure_IEs = CLASS(name='RICserviceUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICserviceUpdateFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _RICserviceUpdateFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _RICserviceUpdateFailure_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TimeToWait')))
    _RICserviceUpdateFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    RICserviceUpdateFailure_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _RICserviceUpdateFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _RICserviceUpdateFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _RICserviceUpdateFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _RICserviceUpdateFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RICserviceQuery >-----#
    RICserviceQuery = SEQ(name='RICserviceQuery', mode=MODE_TYPE)
    _RICserviceQuery_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __RICserviceQuery_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___RICserviceQuery_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____RICserviceQuery_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____RICserviceQuery_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____RICserviceQuery_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    ____RICserviceQuery_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____RICserviceQuery_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____RICserviceQuery_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RICserviceQuery_protocolIEs__item__id._const_tab = ____RICserviceQuery_protocolIEs__item__id_tab
    ___RICserviceQuery_protocolIEs__item__id._const_tab_at = None
    ___RICserviceQuery_protocolIEs__item__id._const_tab_id = 'id'
    ___RICserviceQuery_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___RICserviceQuery_protocolIEs__item__criticality._const_tab = ____RICserviceQuery_protocolIEs__item__id_tab
    ___RICserviceQuery_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RICserviceQuery_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RICserviceQuery_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___RICserviceQuery_protocolIEs__item__value._const_tab = ____RICserviceQuery_protocolIEs__item__id_tab
    ___RICserviceQuery_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RICserviceQuery_protocolIEs__item__value._const_tab_id = 'Value'
    __RICserviceQuery_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RICserviceQuery_protocolIEs__item__id),
        ('criticality', ___RICserviceQuery_protocolIEs__item__criticality),
        ('value', ___RICserviceQuery_protocolIEs__item__value),
        ])
    __RICserviceQuery_protocolIEs__item_._ext = None
    _RICserviceQuery_protocolIEs._cont = __RICserviceQuery_protocolIEs__item_
    _RICserviceQuery_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RICserviceQuery._cont = ASN1Dict([
        ('protocolIEs', _RICserviceQuery_protocolIEs),
        ])
    RICserviceQuery._ext = []
    
    #-----< RICserviceQuery-IEs >-----#
    RICserviceQuery_IEs = CLASS(name='RICserviceQuery-IEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _RICserviceQuery_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _RICserviceQuery_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RANfunctionsID-List')))
    RICserviceQuery_IEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _RICserviceQuery_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _RICserviceQuery_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2RemovalRequest >-----#
    E2RemovalRequest = SEQ(name='E2RemovalRequest', mode=MODE_TYPE)
    _E2RemovalRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2RemovalRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2RemovalRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2RemovalRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2RemovalRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    ____E2RemovalRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2RemovalRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E2RemovalRequest_protocolIEs__item__id._const_tab = ____E2RemovalRequest_protocolIEs__item__id_tab
    ___E2RemovalRequest_protocolIEs__item__id._const_tab_at = None
    ___E2RemovalRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E2RemovalRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2RemovalRequest_protocolIEs__item__criticality._const_tab = ____E2RemovalRequest_protocolIEs__item__id_tab
    ___E2RemovalRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2RemovalRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2RemovalRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2RemovalRequest_protocolIEs__item__value._const_tab = ____E2RemovalRequest_protocolIEs__item__id_tab
    ___E2RemovalRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2RemovalRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E2RemovalRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2RemovalRequest_protocolIEs__item__id),
        ('criticality', ___E2RemovalRequest_protocolIEs__item__criticality),
        ('value', ___E2RemovalRequest_protocolIEs__item__value),
        ])
    __E2RemovalRequest_protocolIEs__item_._ext = None
    _E2RemovalRequest_protocolIEs._cont = __E2RemovalRequest_protocolIEs__item_
    _E2RemovalRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2RemovalRequest._cont = ASN1Dict([
        ('protocolIEs', _E2RemovalRequest_protocolIEs),
        ])
    E2RemovalRequest._ext = []
    
    #-----< E2RemovalRequestIEs >-----#
    E2RemovalRequestIEs = CLASS(name='E2RemovalRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2RemovalRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    E2RemovalRequestIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2RemovalRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E2RemovalResponse >-----#
    E2RemovalResponse = SEQ(name='E2RemovalResponse', mode=MODE_TYPE)
    _E2RemovalResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2RemovalResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2RemovalResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2RemovalResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2RemovalResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2RemovalResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____E2RemovalResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2RemovalResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____E2RemovalResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2RemovalResponse_protocolIEs__item__id._const_tab = ____E2RemovalResponse_protocolIEs__item__id_tab
    ___E2RemovalResponse_protocolIEs__item__id._const_tab_at = None
    ___E2RemovalResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E2RemovalResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2RemovalResponse_protocolIEs__item__criticality._const_tab = ____E2RemovalResponse_protocolIEs__item__id_tab
    ___E2RemovalResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2RemovalResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2RemovalResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2RemovalResponse_protocolIEs__item__value._const_tab = ____E2RemovalResponse_protocolIEs__item__id_tab
    ___E2RemovalResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2RemovalResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E2RemovalResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2RemovalResponse_protocolIEs__item__id),
        ('criticality', ___E2RemovalResponse_protocolIEs__item__criticality),
        ('value', ___E2RemovalResponse_protocolIEs__item__value),
        ])
    __E2RemovalResponse_protocolIEs__item_._ext = None
    _E2RemovalResponse_protocolIEs._cont = __E2RemovalResponse_protocolIEs__item_
    _E2RemovalResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2RemovalResponse._cont = ASN1Dict([
        ('protocolIEs', _E2RemovalResponse_protocolIEs),
        ])
    E2RemovalResponse._ext = []
    
    #-----< E2RemovalResponseIEs >-----#
    E2RemovalResponseIEs = CLASS(name='E2RemovalResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2RemovalResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2RemovalResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    E2RemovalResponseIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2RemovalResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _E2RemovalResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E2RemovalFailure >-----#
    E2RemovalFailure = SEQ(name='E2RemovalFailure', mode=MODE_TYPE)
    _E2RemovalFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Container')))
    __E2RemovalFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-Containers', 'ProtocolIE-Field')))
    ___E2RemovalFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['id']))
    ____E2RemovalFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    ____E2RemovalFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E2RemovalFailure_protocolIEs__item__id._const_tab = ____E2RemovalFailure_protocolIEs__item__id_tab
    ___E2RemovalFailure_protocolIEs__item__id._const_tab_at = None
    ___E2RemovalFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___E2RemovalFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['criticality']))
    ___E2RemovalFailure_protocolIEs__item__criticality._const_tab = ____E2RemovalFailure_protocolIEs__item__id_tab
    ___E2RemovalFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E2RemovalFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E2RemovalFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-Containers', 'E2AP-PROTOCOL-IES'), ['Value']))
    ___E2RemovalFailure_protocolIEs__item__value._const_tab = ____E2RemovalFailure_protocolIEs__item__id_tab
    ___E2RemovalFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E2RemovalFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __E2RemovalFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E2RemovalFailure_protocolIEs__item__id),
        ('criticality', ___E2RemovalFailure_protocolIEs__item__criticality),
        ('value', ___E2RemovalFailure_protocolIEs__item__value),
        ])
    __E2RemovalFailure_protocolIEs__item_._ext = None
    _E2RemovalFailure_protocolIEs._cont = __E2RemovalFailure_protocolIEs__item_
    _E2RemovalFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E2RemovalFailure._cont = ASN1Dict([
        ('protocolIEs', _E2RemovalFailure_protocolIEs),
        ])
    E2RemovalFailure._ext = []
    
    #-----< E2RemovalFailureIEs >-----#
    E2RemovalFailureIEs = CLASS(name='E2RemovalFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E2AP-Containers', 'E2AP-PROTOCOL-IES')))
    _E2RemovalFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'TransactionID')))
    _E2RemovalFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'Cause')))
    _E2RemovalFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-IEs', 'CriticalityDiagnostics')))
    E2RemovalFailureIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _E2RemovalFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _E2RemovalFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _E2RemovalFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____RICsubscriptionRequest_protocolIEs__item__id_tab,
        _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RICsubscriptionRequest_protocolIEs__item__id_tab_val_Value_4,
        ___RICsubscriptionRequest_protocolIEs__item__id,
        ___RICsubscriptionRequest_protocolIEs__item__criticality,
        ___RICsubscriptionRequest_protocolIEs__item__value,
        __RICsubscriptionRequest_protocolIEs__item_,
        _RICsubscriptionRequest_protocolIEs,
        RICsubscriptionRequest,
        RICsubscriptionRequest_IEs,
        _RICsubscriptionRequest_IEs_val_Value_0,
        _RICsubscriptionRequest_IEs_val_Value_1,
        _RICsubscriptionRequest_IEs_val_Value_2,
        _RICsubscriptionRequest_IEs_val_Value_3,
        _RICsubscriptionRequest_IEs_val_Value_4,
        _RICsubscriptionDetails_ricEventTriggerDefinition,
        _RICsubscriptionDetails_ricAction_ToBeSetup_List,
        RICsubscriptionDetails,
        ___RICactions_ToBeSetup_List__item__id_tab,
        ____RICactions_ToBeSetup_List__item__id_tab_val_Value_0,
        __RICactions_ToBeSetup_List__item__id,
        __RICactions_ToBeSetup_List__item__criticality,
        __RICactions_ToBeSetup_List__item__value,
        _RICactions_ToBeSetup_List__item_,
        RICactions_ToBeSetup_List,
        RICaction_ToBeSetup_ItemIEs,
        _RICaction_ToBeSetup_ItemIEs_val_Value_0,
        _RICaction_ToBeSetup_Item_ricActionID,
        _RICaction_ToBeSetup_Item_ricActionType,
        _RICaction_ToBeSetup_Item_ricActionDefinition,
        _RICaction_ToBeSetup_Item_ricSubsequentAction,
        _RICaction_ToBeSetup_Item_ricActionExecutionOrder,
        RICaction_ToBeSetup_Item,
        ____RICsubscriptionResponse_protocolIEs__item__id_tab,
        _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionResponse_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionResponse_protocolIEs__item__id,
        ___RICsubscriptionResponse_protocolIEs__item__criticality,
        ___RICsubscriptionResponse_protocolIEs__item__value,
        __RICsubscriptionResponse_protocolIEs__item_,
        _RICsubscriptionResponse_protocolIEs,
        RICsubscriptionResponse,
        RICsubscriptionResponse_IEs,
        _RICsubscriptionResponse_IEs_val_Value_0,
        _RICsubscriptionResponse_IEs_val_Value_1,
        _RICsubscriptionResponse_IEs_val_Value_2,
        _RICsubscriptionResponse_IEs_val_Value_3,
        ___RICaction_Admitted_List__item__id_tab,
        ____RICaction_Admitted_List__item__id_tab_val_Value_0,
        __RICaction_Admitted_List__item__id,
        __RICaction_Admitted_List__item__criticality,
        __RICaction_Admitted_List__item__value,
        _RICaction_Admitted_List__item_,
        RICaction_Admitted_List,
        RICaction_Admitted_ItemIEs,
        _RICaction_Admitted_ItemIEs_val_Value_0,
        _RICaction_Admitted_Item_ricActionID,
        RICaction_Admitted_Item,
        ___RICaction_NotAdmitted_List__item__id_tab,
        ____RICaction_NotAdmitted_List__item__id_tab_val_Value_0,
        __RICaction_NotAdmitted_List__item__id,
        __RICaction_NotAdmitted_List__item__criticality,
        __RICaction_NotAdmitted_List__item__value,
        _RICaction_NotAdmitted_List__item_,
        RICaction_NotAdmitted_List,
        RICaction_NotAdmitted_ItemIEs,
        _RICaction_NotAdmitted_ItemIEs_val_Value_0,
        _RICaction_NotAdmitted_Item_ricActionID,
        _RICaction_NotAdmitted_Item_cause,
        RICaction_NotAdmitted_Item,
        ____RICsubscriptionFailure_protocolIEs__item__id_tab,
        _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionFailure_protocolIEs__item__id,
        ___RICsubscriptionFailure_protocolIEs__item__criticality,
        ___RICsubscriptionFailure_protocolIEs__item__value,
        __RICsubscriptionFailure_protocolIEs__item_,
        _RICsubscriptionFailure_protocolIEs,
        RICsubscriptionFailure,
        RICsubscriptionFailure_IEs,
        _RICsubscriptionFailure_IEs_val_Value_0,
        _RICsubscriptionFailure_IEs_val_Value_1,
        _RICsubscriptionFailure_IEs_val_Value_2,
        _RICsubscriptionFailure_IEs_val_Value_3,
        ____RICsubscriptionAuditRequest_protocolIEs__item__id_tab,
        _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionAuditRequest_protocolIEs__item__id_tab_val_Value_2,
        ___RICsubscriptionAuditRequest_protocolIEs__item__id,
        ___RICsubscriptionAuditRequest_protocolIEs__item__criticality,
        ___RICsubscriptionAuditRequest_protocolIEs__item__value,
        __RICsubscriptionAuditRequest_protocolIEs__item_,
        _RICsubscriptionAuditRequest_protocolIEs,
        RICsubscriptionAuditRequest,
        RICsubscriptionAuditRequest_IEs,
        _RICsubscriptionAuditRequest_IEs_val_Value_0,
        _RICsubscriptionAuditRequest_IEs_val_Value_1,
        _RICsubscriptionAuditRequest_IEs_val_Value_2,
        ___RICsubscriptionAuditList__item__id_tab,
        ____RICsubscriptionAuditList__item__id_tab_val_Value_0,
        __RICsubscriptionAuditList__item__id,
        __RICsubscriptionAuditList__item__criticality,
        __RICsubscriptionAuditList__item__value,
        _RICsubscriptionAuditList__item_,
        RICsubscriptionAuditList,
        RICsubscriptionAudit_ItemIEs,
        _RICsubscriptionAudit_ItemIEs_val_Value_0,
        _RICsubscriptionAudit_Item_ricRequestID,
        _RICsubscriptionAudit_Item_ranFunctionID,
        RICsubscriptionAudit_Item,
        ____RICsubscriptionAuditResponse_protocolIEs__item__id_tab,
        _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionAuditResponse_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionAuditResponse_protocolIEs__item__id,
        ___RICsubscriptionAuditResponse_protocolIEs__item__criticality,
        ___RICsubscriptionAuditResponse_protocolIEs__item__value,
        __RICsubscriptionAuditResponse_protocolIEs__item_,
        _RICsubscriptionAuditResponse_protocolIEs,
        RICsubscriptionAuditResponse,
        RICsubscriptionAuditResponse_IEs,
        _RICsubscriptionAuditResponse_IEs_val_Value_0,
        _RICsubscriptionAuditResponse_IEs_val_Value_1,
        _RICsubscriptionAuditResponse_IEs_val_Value_2,
        _RICsubscriptionAuditResponse_IEs_val_Value_3,
        ___RICsubscriptionAuditActionList__item__id_tab,
        ____RICsubscriptionAuditActionList__item__id_tab_val_Value_0,
        __RICsubscriptionAuditActionList__item__id,
        __RICsubscriptionAuditActionList__item__criticality,
        __RICsubscriptionAuditActionList__item__value,
        _RICsubscriptionAuditActionList__item_,
        RICsubscriptionAuditActionList,
        RICsubscriptionAuditAction_ItemIEs,
        _RICsubscriptionAuditAction_ItemIEs_val_Value_0,
        _RICsubscriptionAuditAction_Item_ricRequestID,
        _RICsubscriptionAuditAction_Item_ranFunctionID,
        _RICsubscriptionAuditAction_Item_ricAction_Admitted_List,
        RICsubscriptionAuditAction_Item,
        ____RICsubscriptionAuditFailure_protocolIEs__item__id_tab,
        _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionAuditFailure_protocolIEs__item__id_tab_val_Value_2,
        ___RICsubscriptionAuditFailure_protocolIEs__item__id,
        ___RICsubscriptionAuditFailure_protocolIEs__item__criticality,
        ___RICsubscriptionAuditFailure_protocolIEs__item__value,
        __RICsubscriptionAuditFailure_protocolIEs__item_,
        _RICsubscriptionAuditFailure_protocolIEs,
        RICsubscriptionAuditFailure,
        RICsubscriptionAuditFailure_IEs,
        _RICsubscriptionAuditFailure_IEs_val_Value_0,
        _RICsubscriptionAuditFailure_IEs_val_Value_1,
        _RICsubscriptionAuditFailure_IEs_val_Value_2,
        ____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab,
        _____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionDeleteRequest_protocolIEs__item__id_tab_val_Value_1,
        ___RICsubscriptionDeleteRequest_protocolIEs__item__id,
        ___RICsubscriptionDeleteRequest_protocolIEs__item__criticality,
        ___RICsubscriptionDeleteRequest_protocolIEs__item__value,
        __RICsubscriptionDeleteRequest_protocolIEs__item_,
        _RICsubscriptionDeleteRequest_protocolIEs,
        RICsubscriptionDeleteRequest,
        RICsubscriptionDeleteRequest_IEs,
        _RICsubscriptionDeleteRequest_IEs_val_Value_0,
        _RICsubscriptionDeleteRequest_IEs_val_Value_1,
        ____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab,
        _____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionDeleteResponse_protocolIEs__item__id_tab_val_Value_1,
        ___RICsubscriptionDeleteResponse_protocolIEs__item__id,
        ___RICsubscriptionDeleteResponse_protocolIEs__item__criticality,
        ___RICsubscriptionDeleteResponse_protocolIEs__item__value,
        __RICsubscriptionDeleteResponse_protocolIEs__item_,
        _RICsubscriptionDeleteResponse_protocolIEs,
        RICsubscriptionDeleteResponse,
        RICsubscriptionDeleteResponse_IEs,
        _RICsubscriptionDeleteResponse_IEs_val_Value_0,
        _RICsubscriptionDeleteResponse_IEs_val_Value_1,
        ____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab,
        _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionDeleteFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionDeleteFailure_protocolIEs__item__id,
        ___RICsubscriptionDeleteFailure_protocolIEs__item__criticality,
        ___RICsubscriptionDeleteFailure_protocolIEs__item__value,
        __RICsubscriptionDeleteFailure_protocolIEs__item_,
        _RICsubscriptionDeleteFailure_protocolIEs,
        RICsubscriptionDeleteFailure,
        RICsubscriptionDeleteFailure_IEs,
        _RICsubscriptionDeleteFailure_IEs_val_Value_0,
        _RICsubscriptionDeleteFailure_IEs_val_Value_1,
        _RICsubscriptionDeleteFailure_IEs_val_Value_2,
        _RICsubscriptionDeleteFailure_IEs_val_Value_3,
        ____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab,
        _____RICsubscriptionDeleteRequired_protocolIEs__item__id_tab_val_Value_0,
        ___RICsubscriptionDeleteRequired_protocolIEs__item__id,
        ___RICsubscriptionDeleteRequired_protocolIEs__item__criticality,
        ___RICsubscriptionDeleteRequired_protocolIEs__item__value,
        __RICsubscriptionDeleteRequired_protocolIEs__item_,
        _RICsubscriptionDeleteRequired_protocolIEs,
        RICsubscriptionDeleteRequired,
        RICsubscriptionDeleteRequired_IEs,
        _RICsubscriptionDeleteRequired_IEs_val_Value_0,
        ___RICsubscription_List_withCause__item__id_tab,
        ____RICsubscription_List_withCause__item__id_tab_val_Value_0,
        __RICsubscription_List_withCause__item__id,
        __RICsubscription_List_withCause__item__criticality,
        __RICsubscription_List_withCause__item__value,
        _RICsubscription_List_withCause__item_,
        RICsubscription_List_withCause,
        RICsubscription_withCause_ItemIEs,
        _RICsubscription_withCause_ItemIEs_val_Value_0,
        _RICsubscription_withCause_Item_ricRequestID,
        _RICsubscription_withCause_Item_ranFunctionID,
        _RICsubscription_withCause_Item_cause,
        RICsubscription_withCause_Item,
        ____RICsubscriptionModificationRequest_protocolIEs__item__id_tab,
        _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RICsubscriptionModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        ___RICsubscriptionModificationRequest_protocolIEs__item__id,
        ___RICsubscriptionModificationRequest_protocolIEs__item__criticality,
        ___RICsubscriptionModificationRequest_protocolIEs__item__value,
        __RICsubscriptionModificationRequest_protocolIEs__item_,
        _RICsubscriptionModificationRequest_protocolIEs,
        RICsubscriptionModificationRequest,
        RICsubscriptionModificationRequest_IEs,
        _RICsubscriptionModificationRequest_IEs_val_Value_0,
        _RICsubscriptionModificationRequest_IEs_val_Value_1,
        _RICsubscriptionModificationRequest_IEs_val_Value_2,
        _RICsubscriptionModificationRequest_IEs_val_Value_3,
        _RICsubscriptionModificationRequest_IEs_val_Value_4,
        _RICsubscriptionModificationRequest_IEs_val_Value_5,
        ___RICactions_ToBeRemovedForModification_List__item__id_tab,
        ____RICactions_ToBeRemovedForModification_List__item__id_tab_val_Value_0,
        __RICactions_ToBeRemovedForModification_List__item__id,
        __RICactions_ToBeRemovedForModification_List__item__criticality,
        __RICactions_ToBeRemovedForModification_List__item__value,
        _RICactions_ToBeRemovedForModification_List__item_,
        RICactions_ToBeRemovedForModification_List,
        RICaction_ToBeRemovedForModification_ItemIEs,
        _RICaction_ToBeRemovedForModification_ItemIEs_val_Value_0,
        _RICaction_ToBeRemovedForModification_Item_ricActionID,
        RICaction_ToBeRemovedForModification_Item,
        ___RICactions_ToBeModifiedForModification_List__item__id_tab,
        ____RICactions_ToBeModifiedForModification_List__item__id_tab_val_Value_0,
        __RICactions_ToBeModifiedForModification_List__item__id,
        __RICactions_ToBeModifiedForModification_List__item__criticality,
        __RICactions_ToBeModifiedForModification_List__item__value,
        _RICactions_ToBeModifiedForModification_List__item_,
        RICactions_ToBeModifiedForModification_List,
        RICaction_ToBeModifiedForModification_ItemIEs,
        _RICaction_ToBeModifiedForModification_ItemIEs_val_Value_0,
        _RICaction_ToBeModifiedForModification_Item_ricActionID,
        _RICaction_ToBeModifiedForModification_Item_ricActionDefinition,
        _RICaction_ToBeModifiedForModification_Item_ricActionExecutionOrder,
        _RICaction_ToBeModifiedForModification_Item_ricSubsequentAction,
        RICaction_ToBeModifiedForModification_Item,
        ___RICactions_ToBeAddedForModification_List__item__id_tab,
        ____RICactions_ToBeAddedForModification_List__item__id_tab_val_Value_0,
        __RICactions_ToBeAddedForModification_List__item__id,
        __RICactions_ToBeAddedForModification_List__item__criticality,
        __RICactions_ToBeAddedForModification_List__item__value,
        _RICactions_ToBeAddedForModification_List__item_,
        RICactions_ToBeAddedForModification_List,
        RICaction_ToBeAddedForModification_ItemIEs,
        _RICaction_ToBeAddedForModification_ItemIEs_val_Value_0,
        _RICaction_ToBeAddedForModification_Item_ricActionID,
        _RICaction_ToBeAddedForModification_Item_ricActionType,
        _RICaction_ToBeAddedForModification_Item_ricActionDefinition,
        _RICaction_ToBeAddedForModification_Item_ricActionExecutionOrder,
        _RICaction_ToBeAddedForModification_Item_ricSubsequentAction,
        RICaction_ToBeAddedForModification_Item,
        ____RICsubscriptionModificationResponse_protocolIEs__item__id_tab,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_6,
        _____RICsubscriptionModificationResponse_protocolIEs__item__id_tab_val_Value_7,
        ___RICsubscriptionModificationResponse_protocolIEs__item__id,
        ___RICsubscriptionModificationResponse_protocolIEs__item__criticality,
        ___RICsubscriptionModificationResponse_protocolIEs__item__value,
        __RICsubscriptionModificationResponse_protocolIEs__item_,
        _RICsubscriptionModificationResponse_protocolIEs,
        RICsubscriptionModificationResponse,
        RICsubscriptionModificationResponse_IEs,
        _RICsubscriptionModificationResponse_IEs_val_Value_0,
        _RICsubscriptionModificationResponse_IEs_val_Value_1,
        _RICsubscriptionModificationResponse_IEs_val_Value_2,
        _RICsubscriptionModificationResponse_IEs_val_Value_3,
        _RICsubscriptionModificationResponse_IEs_val_Value_4,
        _RICsubscriptionModificationResponse_IEs_val_Value_5,
        _RICsubscriptionModificationResponse_IEs_val_Value_6,
        _RICsubscriptionModificationResponse_IEs_val_Value_7,
        ___RICactions_RemovedForModification_List__item__id_tab,
        ____RICactions_RemovedForModification_List__item__id_tab_val_Value_0,
        __RICactions_RemovedForModification_List__item__id,
        __RICactions_RemovedForModification_List__item__criticality,
        __RICactions_RemovedForModification_List__item__value,
        _RICactions_RemovedForModification_List__item_,
        RICactions_RemovedForModification_List,
        RICaction_RemovedForModification_ItemIEs,
        _RICaction_RemovedForModification_ItemIEs_val_Value_0,
        _RICaction_RemovedForModification_Item_ricActionID,
        RICaction_RemovedForModification_Item,
        ___RICactions_FailedToBeRemovedForModification_List__item__id_tab,
        ____RICactions_FailedToBeRemovedForModification_List__item__id_tab_val_Value_0,
        __RICactions_FailedToBeRemovedForModification_List__item__id,
        __RICactions_FailedToBeRemovedForModification_List__item__criticality,
        __RICactions_FailedToBeRemovedForModification_List__item__value,
        _RICactions_FailedToBeRemovedForModification_List__item_,
        RICactions_FailedToBeRemovedForModification_List,
        RICaction_FailedToBeRemovedForModification_ItemIEs,
        _RICaction_FailedToBeRemovedForModification_ItemIEs_val_Value_0,
        _RICaction_FailedToBeRemovedForModification_Item_ricActionID,
        _RICaction_FailedToBeRemovedForModification_Item_cause,
        RICaction_FailedToBeRemovedForModification_Item,
        ___RICactions_ModifiedForModification_List__item__id_tab,
        ____RICactions_ModifiedForModification_List__item__id_tab_val_Value_0,
        __RICactions_ModifiedForModification_List__item__id,
        __RICactions_ModifiedForModification_List__item__criticality,
        __RICactions_ModifiedForModification_List__item__value,
        _RICactions_ModifiedForModification_List__item_,
        RICactions_ModifiedForModification_List,
        RICaction_ModifiedForModification_ItemIEs,
        _RICaction_ModifiedForModification_ItemIEs_val_Value_0,
        _RICaction_ModifiedForModification_Item_ricActionID,
        RICaction_ModifiedForModification_Item,
        ___RICactions_FailedToBeModifiedForModification_List__item__id_tab,
        ____RICactions_FailedToBeModifiedForModification_List__item__id_tab_val_Value_0,
        __RICactions_FailedToBeModifiedForModification_List__item__id,
        __RICactions_FailedToBeModifiedForModification_List__item__criticality,
        __RICactions_FailedToBeModifiedForModification_List__item__value,
        _RICactions_FailedToBeModifiedForModification_List__item_,
        RICactions_FailedToBeModifiedForModification_List,
        RICaction_FailedToBeModifiedForModification_ItemIEs,
        _RICaction_FailedToBeModifiedForModification_ItemIEs_val_Value_0,
        _RICaction_FailedToBeModifiedForModification_Item_ricActionID,
        _RICaction_FailedToBeModifiedForModification_Item_cause,
        RICaction_FailedToBeModifiedForModification_Item,
        ___RICactions_AddedForModification_List__item__id_tab,
        ____RICactions_AddedForModification_List__item__id_tab_val_Value_0,
        __RICactions_AddedForModification_List__item__id,
        __RICactions_AddedForModification_List__item__criticality,
        __RICactions_AddedForModification_List__item__value,
        _RICactions_AddedForModification_List__item_,
        RICactions_AddedForModification_List,
        RICaction_AddedForModification_ItemIEs,
        _RICaction_AddedForModification_ItemIEs_val_Value_0,
        _RICaction_AddedForModification_Item_ricActionID,
        RICaction_AddedForModification_Item,
        ___RICactions_FailedToBeAddedForModification_List__item__id_tab,
        ____RICactions_FailedToBeAddedForModification_List__item__id_tab_val_Value_0,
        __RICactions_FailedToBeAddedForModification_List__item__id,
        __RICactions_FailedToBeAddedForModification_List__item__criticality,
        __RICactions_FailedToBeAddedForModification_List__item__value,
        _RICactions_FailedToBeAddedForModification_List__item_,
        RICactions_FailedToBeAddedForModification_List,
        RICaction_FailedToBeAddedForModification_ItemIEs,
        _RICaction_FailedToBeAddedForModification_ItemIEs_val_Value_0,
        _RICaction_FailedToBeAddedForModification_Item_ricActionID,
        _RICaction_FailedToBeAddedForModification_Item_cause,
        RICaction_FailedToBeAddedForModification_Item,
        ____RICsubscriptionModificationFailure_protocolIEs__item__id_tab,
        _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionModificationFailure_protocolIEs__item__id,
        ___RICsubscriptionModificationFailure_protocolIEs__item__criticality,
        ___RICsubscriptionModificationFailure_protocolIEs__item__value,
        __RICsubscriptionModificationFailure_protocolIEs__item_,
        _RICsubscriptionModificationFailure_protocolIEs,
        RICsubscriptionModificationFailure,
        RICsubscriptionModificationFailure_IEs,
        _RICsubscriptionModificationFailure_IEs_val_Value_0,
        _RICsubscriptionModificationFailure_IEs_val_Value_1,
        _RICsubscriptionModificationFailure_IEs_val_Value_2,
        _RICsubscriptionModificationFailure_IEs_val_Value_3,
        ____RICsubscriptionModificationRequired_protocolIEs__item__id_tab,
        _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionModificationRequired_protocolIEs__item__id,
        ___RICsubscriptionModificationRequired_protocolIEs__item__criticality,
        ___RICsubscriptionModificationRequired_protocolIEs__item__value,
        __RICsubscriptionModificationRequired_protocolIEs__item_,
        _RICsubscriptionModificationRequired_protocolIEs,
        RICsubscriptionModificationRequired,
        RICsubscriptionModificationRequired_IEs,
        _RICsubscriptionModificationRequired_IEs_val_Value_0,
        _RICsubscriptionModificationRequired_IEs_val_Value_1,
        _RICsubscriptionModificationRequired_IEs_val_Value_2,
        _RICsubscriptionModificationRequired_IEs_val_Value_3,
        ___RICactions_RequiredToBeModified_List__item__id_tab,
        ____RICactions_RequiredToBeModified_List__item__id_tab_val_Value_0,
        __RICactions_RequiredToBeModified_List__item__id,
        __RICactions_RequiredToBeModified_List__item__criticality,
        __RICactions_RequiredToBeModified_List__item__value,
        _RICactions_RequiredToBeModified_List__item_,
        RICactions_RequiredToBeModified_List,
        RICaction_RequiredToBeModified_ItemIEs,
        _RICaction_RequiredToBeModified_ItemIEs_val_Value_0,
        _RICaction_RequiredToBeModified_Item_ricActionID,
        _RICaction_RequiredToBeModified_Item_ricTimeToWait,
        RICaction_RequiredToBeModified_Item,
        ___RICactions_RequiredToBeRemoved_List__item__id_tab,
        ____RICactions_RequiredToBeRemoved_List__item__id_tab_val_Value_0,
        __RICactions_RequiredToBeRemoved_List__item__id,
        __RICactions_RequiredToBeRemoved_List__item__criticality,
        __RICactions_RequiredToBeRemoved_List__item__value,
        _RICactions_RequiredToBeRemoved_List__item_,
        RICactions_RequiredToBeRemoved_List,
        RICaction_RequiredToBeRemoved_ItemIEs,
        _RICaction_RequiredToBeRemoved_ItemIEs_val_Value_0,
        _RICaction_RequiredToBeRemoved_Item_ricActionID,
        _RICaction_RequiredToBeRemoved_Item_cause,
        RICaction_RequiredToBeRemoved_Item,
        ____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab,
        _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____RICsubscriptionModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        ___RICsubscriptionModificationConfirm_protocolIEs__item__id,
        ___RICsubscriptionModificationConfirm_protocolIEs__item__criticality,
        ___RICsubscriptionModificationConfirm_protocolIEs__item__value,
        __RICsubscriptionModificationConfirm_protocolIEs__item_,
        _RICsubscriptionModificationConfirm_protocolIEs,
        RICsubscriptionModificationConfirm,
        RICsubscriptionModificationConfirm_IEs,
        _RICsubscriptionModificationConfirm_IEs_val_Value_0,
        _RICsubscriptionModificationConfirm_IEs_val_Value_1,
        _RICsubscriptionModificationConfirm_IEs_val_Value_2,
        _RICsubscriptionModificationConfirm_IEs_val_Value_3,
        _RICsubscriptionModificationConfirm_IEs_val_Value_4,
        _RICsubscriptionModificationConfirm_IEs_val_Value_5,
        ___RICactions_ConfirmedForModification_List__item__id_tab,
        ____RICactions_ConfirmedForModification_List__item__id_tab_val_Value_0,
        __RICactions_ConfirmedForModification_List__item__id,
        __RICactions_ConfirmedForModification_List__item__criticality,
        __RICactions_ConfirmedForModification_List__item__value,
        _RICactions_ConfirmedForModification_List__item_,
        RICactions_ConfirmedForModification_List,
        RICaction_ConfirmedForModification_ItemIEs,
        _RICaction_ConfirmedForModification_ItemIEs_val_Value_0,
        _RICaction_ConfirmedForModification_Item_ricActionID,
        RICaction_ConfirmedForModification_Item,
        ___RICactions_RefusedToBeModified_List__item__id_tab,
        ____RICactions_RefusedToBeModified_List__item__id_tab_val_Value_0,
        __RICactions_RefusedToBeModified_List__item__id,
        __RICactions_RefusedToBeModified_List__item__criticality,
        __RICactions_RefusedToBeModified_List__item__value,
        _RICactions_RefusedToBeModified_List__item_,
        RICactions_RefusedToBeModified_List,
        RICaction_RefusedToBeModified_ItemIEs,
        _RICaction_RefusedToBeModified_ItemIEs_val_Value_0,
        _RICaction_RefusedToBeModified_Item_ricActionID,
        _RICaction_RefusedToBeModified_Item_cause,
        RICaction_RefusedToBeModified_Item,
        ___RICactions_ConfirmedForRemoval_List__item__id_tab,
        ____RICactions_ConfirmedForRemoval_List__item__id_tab_val_Value_0,
        __RICactions_ConfirmedForRemoval_List__item__id,
        __RICactions_ConfirmedForRemoval_List__item__criticality,
        __RICactions_ConfirmedForRemoval_List__item__value,
        _RICactions_ConfirmedForRemoval_List__item_,
        RICactions_ConfirmedForRemoval_List,
        RICaction_ConfirmedForRemoval_ItemIEs,
        _RICaction_ConfirmedForRemoval_ItemIEs_val_Value_0,
        _RICaction_ConfirmedForRemoval_Item_ricActionID,
        RICaction_ConfirmedForRemoval_Item,
        ___RICactions_RefusedToBeRemoved_List__item__id_tab,
        ____RICactions_RefusedToBeRemoved_List__item__id_tab_val_Value_0,
        __RICactions_RefusedToBeRemoved_List__item__id,
        __RICactions_RefusedToBeRemoved_List__item__criticality,
        __RICactions_RefusedToBeRemoved_List__item__value,
        _RICactions_RefusedToBeRemoved_List__item_,
        RICactions_RefusedToBeRemoved_List,
        RICaction_RefusedToBeRemoved_ItemIEs,
        _RICaction_RefusedToBeRemoved_ItemIEs_val_Value_0,
        _RICaction_RefusedToBeRemoved_Item_ricActionID,
        _RICaction_RefusedToBeRemoved_Item_cause,
        RICaction_RefusedToBeRemoved_Item,
        ____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab,
        _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____RICsubscriptionModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        ___RICsubscriptionModificationRefuse_protocolIEs__item__id,
        ___RICsubscriptionModificationRefuse_protocolIEs__item__criticality,
        ___RICsubscriptionModificationRefuse_protocolIEs__item__value,
        __RICsubscriptionModificationRefuse_protocolIEs__item_,
        _RICsubscriptionModificationRefuse_protocolIEs,
        RICsubscriptionModificationRefuse,
        RICsubscriptionModificationRefuse_IEs,
        _RICsubscriptionModificationRefuse_IEs_val_Value_0,
        _RICsubscriptionModificationRefuse_IEs_val_Value_1,
        _RICsubscriptionModificationRefuse_IEs_val_Value_2,
        _RICsubscriptionModificationRefuse_IEs_val_Value_3,
        ____RICindication_protocolIEs__item__id_tab,
        _____RICindication_protocolIEs__item__id_tab_val_Value_0,
        _____RICindication_protocolIEs__item__id_tab_val_Value_1,
        _____RICindication_protocolIEs__item__id_tab_val_Value_2,
        _____RICindication_protocolIEs__item__id_tab_val_Value_3,
        _____RICindication_protocolIEs__item__id_tab_val_Value_4,
        _____RICindication_protocolIEs__item__id_tab_val_Value_5,
        _____RICindication_protocolIEs__item__id_tab_val_Value_6,
        _____RICindication_protocolIEs__item__id_tab_val_Value_7,
        ___RICindication_protocolIEs__item__id,
        ___RICindication_protocolIEs__item__criticality,
        ___RICindication_protocolIEs__item__value,
        __RICindication_protocolIEs__item_,
        _RICindication_protocolIEs,
        RICindication,
        RICindication_IEs,
        _RICindication_IEs_val_Value_0,
        _RICindication_IEs_val_Value_1,
        _RICindication_IEs_val_Value_2,
        _RICindication_IEs_val_Value_3,
        _RICindication_IEs_val_Value_4,
        _RICindication_IEs_val_Value_5,
        _RICindication_IEs_val_Value_6,
        _RICindication_IEs_val_Value_7,
        ____RICcontrolRequest_protocolIEs__item__id_tab,
        _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RICcontrolRequest_protocolIEs__item__id_tab_val_Value_5,
        ___RICcontrolRequest_protocolIEs__item__id,
        ___RICcontrolRequest_protocolIEs__item__criticality,
        ___RICcontrolRequest_protocolIEs__item__value,
        __RICcontrolRequest_protocolIEs__item_,
        _RICcontrolRequest_protocolIEs,
        RICcontrolRequest,
        RICcontrolRequest_IEs,
        _RICcontrolRequest_IEs_val_Value_0,
        _RICcontrolRequest_IEs_val_Value_1,
        _RICcontrolRequest_IEs_val_Value_2,
        _RICcontrolRequest_IEs_val_Value_3,
        _RICcontrolRequest_IEs_val_Value_4,
        _RICcontrolRequest_IEs_val_Value_5,
        ____RICcontrolAcknowledge_protocolIEs__item__id_tab,
        _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____RICcontrolAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        ___RICcontrolAcknowledge_protocolIEs__item__id,
        ___RICcontrolAcknowledge_protocolIEs__item__criticality,
        ___RICcontrolAcknowledge_protocolIEs__item__value,
        __RICcontrolAcknowledge_protocolIEs__item_,
        _RICcontrolAcknowledge_protocolIEs,
        RICcontrolAcknowledge,
        RICcontrolAcknowledge_IEs,
        _RICcontrolAcknowledge_IEs_val_Value_0,
        _RICcontrolAcknowledge_IEs_val_Value_1,
        _RICcontrolAcknowledge_IEs_val_Value_2,
        _RICcontrolAcknowledge_IEs_val_Value_3,
        ____RICcontrolFailure_protocolIEs__item__id_tab,
        _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_3,
        _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_4,
        _____RICcontrolFailure_protocolIEs__item__id_tab_val_Value_5,
        ___RICcontrolFailure_protocolIEs__item__id,
        ___RICcontrolFailure_protocolIEs__item__criticality,
        ___RICcontrolFailure_protocolIEs__item__value,
        __RICcontrolFailure_protocolIEs__item_,
        _RICcontrolFailure_protocolIEs,
        RICcontrolFailure,
        RICcontrolFailure_IEs,
        _RICcontrolFailure_IEs_val_Value_0,
        _RICcontrolFailure_IEs_val_Value_1,
        _RICcontrolFailure_IEs_val_Value_2,
        _RICcontrolFailure_IEs_val_Value_3,
        _RICcontrolFailure_IEs_val_Value_4,
        _RICcontrolFailure_IEs_val_Value_5,
        ____RICqueryRequest_protocolIEs__item__id_tab,
        _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RICqueryRequest_protocolIEs__item__id_tab_val_Value_3,
        ___RICqueryRequest_protocolIEs__item__id,
        ___RICqueryRequest_protocolIEs__item__criticality,
        ___RICqueryRequest_protocolIEs__item__value,
        __RICqueryRequest_protocolIEs__item_,
        _RICqueryRequest_protocolIEs,
        RICqueryRequest,
        RICqueryRequest_IEs,
        _RICqueryRequest_IEs_val_Value_0,
        _RICqueryRequest_IEs_val_Value_1,
        _RICqueryRequest_IEs_val_Value_2,
        _RICqueryRequest_IEs_val_Value_3,
        ____RICqueryResponse_protocolIEs__item__id_tab,
        _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RICqueryResponse_protocolIEs__item__id_tab_val_Value_2,
        ___RICqueryResponse_protocolIEs__item__id,
        ___RICqueryResponse_protocolIEs__item__criticality,
        ___RICqueryResponse_protocolIEs__item__value,
        __RICqueryResponse_protocolIEs__item_,
        _RICqueryResponse_protocolIEs,
        RICqueryResponse,
        RICqueryResponse_IEs,
        _RICqueryResponse_IEs_val_Value_0,
        _RICqueryResponse_IEs_val_Value_1,
        _RICqueryResponse_IEs_val_Value_2,
        ____RICqueryFailure_protocolIEs__item__id_tab,
        _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RICqueryFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RICqueryFailure_protocolIEs__item__id,
        ___RICqueryFailure_protocolIEs__item__criticality,
        ___RICqueryFailure_protocolIEs__item__value,
        __RICqueryFailure_protocolIEs__item_,
        _RICqueryFailure_protocolIEs,
        RICqueryFailure,
        RICqueryFailure_IEs,
        _RICqueryFailure_IEs_val_Value_0,
        _RICqueryFailure_IEs_val_Value_1,
        _RICqueryFailure_IEs_val_Value_2,
        _RICqueryFailure_IEs_val_Value_3,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        _ErrorIndication_IEs_val_Value_2,
        _ErrorIndication_IEs_val_Value_3,
        _ErrorIndication_IEs_val_Value_4,
        ____E2setupRequest_protocolIEs__item__id_tab,
        _____E2setupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E2setupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E2setupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E2setupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___E2setupRequest_protocolIEs__item__id,
        ___E2setupRequest_protocolIEs__item__criticality,
        ___E2setupRequest_protocolIEs__item__value,
        __E2setupRequest_protocolIEs__item_,
        _E2setupRequest_protocolIEs,
        E2setupRequest,
        E2setupRequestIEs,
        _E2setupRequestIEs_val_Value_0,
        _E2setupRequestIEs_val_Value_1,
        _E2setupRequestIEs_val_Value_2,
        _E2setupRequestIEs_val_Value_3,
        ____E2setupResponse_protocolIEs__item__id_tab,
        _____E2setupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E2setupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E2setupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E2setupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E2setupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___E2setupResponse_protocolIEs__item__id,
        ___E2setupResponse_protocolIEs__item__criticality,
        ___E2setupResponse_protocolIEs__item__value,
        __E2setupResponse_protocolIEs__item_,
        _E2setupResponse_protocolIEs,
        E2setupResponse,
        E2setupResponseIEs,
        _E2setupResponseIEs_val_Value_0,
        _E2setupResponseIEs_val_Value_1,
        _E2setupResponseIEs_val_Value_2,
        _E2setupResponseIEs_val_Value_3,
        _E2setupResponseIEs_val_Value_4,
        ____E2setupFailure_protocolIEs__item__id_tab,
        _____E2setupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E2setupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E2setupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____E2setupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____E2setupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___E2setupFailure_protocolIEs__item__id,
        ___E2setupFailure_protocolIEs__item__criticality,
        ___E2setupFailure_protocolIEs__item__value,
        __E2setupFailure_protocolIEs__item_,
        _E2setupFailure_protocolIEs,
        E2setupFailure,
        E2setupFailureIEs,
        _E2setupFailureIEs_val_Value_0,
        _E2setupFailureIEs_val_Value_1,
        _E2setupFailureIEs_val_Value_2,
        _E2setupFailureIEs_val_Value_3,
        _E2setupFailureIEs_val_Value_4,
        ____E2connectionUpdate_protocolIEs__item__id_tab,
        _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____E2connectionUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___E2connectionUpdate_protocolIEs__item__id,
        ___E2connectionUpdate_protocolIEs__item__criticality,
        ___E2connectionUpdate_protocolIEs__item__value,
        __E2connectionUpdate_protocolIEs__item_,
        _E2connectionUpdate_protocolIEs,
        E2connectionUpdate,
        E2connectionUpdate_IEs,
        _E2connectionUpdate_IEs_val_Value_0,
        _E2connectionUpdate_IEs_val_Value_1,
        _E2connectionUpdate_IEs_val_Value_2,
        _E2connectionUpdate_IEs_val_Value_3,
        ___E2connectionUpdate_List__item__id_tab,
        ____E2connectionUpdate_List__item__id_tab_val_Value_0,
        __E2connectionUpdate_List__item__id,
        __E2connectionUpdate_List__item__criticality,
        __E2connectionUpdate_List__item__value,
        _E2connectionUpdate_List__item_,
        E2connectionUpdate_List,
        E2connectionUpdate_ItemIEs,
        _E2connectionUpdate_ItemIEs_val_Value_0,
        _E2connectionUpdate_Item_tnlInformation,
        _E2connectionUpdate_Item_tnlUsage,
        E2connectionUpdate_Item,
        ___E2connectionUpdateRemove_List__item__id_tab,
        ____E2connectionUpdateRemove_List__item__id_tab_val_Value_0,
        __E2connectionUpdateRemove_List__item__id,
        __E2connectionUpdateRemove_List__item__criticality,
        __E2connectionUpdateRemove_List__item__value,
        _E2connectionUpdateRemove_List__item_,
        E2connectionUpdateRemove_List,
        E2connectionUpdateRemove_ItemIEs,
        _E2connectionUpdateRemove_ItemIEs_val_Value_0,
        _E2connectionUpdateRemove_Item_tnlInformation,
        E2connectionUpdateRemove_Item,
        ____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab,
        _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____E2connectionUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___E2connectionUpdateAcknowledge_protocolIEs__item__id,
        ___E2connectionUpdateAcknowledge_protocolIEs__item__criticality,
        ___E2connectionUpdateAcknowledge_protocolIEs__item__value,
        __E2connectionUpdateAcknowledge_protocolIEs__item_,
        _E2connectionUpdateAcknowledge_protocolIEs,
        E2connectionUpdateAcknowledge,
        E2connectionUpdateAck_IEs,
        _E2connectionUpdateAck_IEs_val_Value_0,
        _E2connectionUpdateAck_IEs_val_Value_1,
        _E2connectionUpdateAck_IEs_val_Value_2,
        ___E2connectionSetupFailed_List__item__id_tab,
        ____E2connectionSetupFailed_List__item__id_tab_val_Value_0,
        __E2connectionSetupFailed_List__item__id,
        __E2connectionSetupFailed_List__item__criticality,
        __E2connectionSetupFailed_List__item__value,
        _E2connectionSetupFailed_List__item_,
        E2connectionSetupFailed_List,
        E2connectionSetupFailed_ItemIEs,
        _E2connectionSetupFailed_ItemIEs_val_Value_0,
        _E2connectionSetupFailed_Item_tnlInformation,
        _E2connectionSetupFailed_Item_cause,
        E2connectionSetupFailed_Item,
        ____E2connectionUpdateFailure_protocolIEs__item__id_tab,
        _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____E2connectionUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___E2connectionUpdateFailure_protocolIEs__item__id,
        ___E2connectionUpdateFailure_protocolIEs__item__criticality,
        ___E2connectionUpdateFailure_protocolIEs__item__value,
        __E2connectionUpdateFailure_protocolIEs__item_,
        _E2connectionUpdateFailure_protocolIEs,
        E2connectionUpdateFailure,
        E2connectionUpdateFailure_IEs,
        _E2connectionUpdateFailure_IEs_val_Value_0,
        _E2connectionUpdateFailure_IEs_val_Value_1,
        _E2connectionUpdateFailure_IEs_val_Value_2,
        _E2connectionUpdateFailure_IEs_val_Value_3,
        ____E2nodeConfigurationUpdate_protocolIEs__item__id_tab,
        _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____E2nodeConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___E2nodeConfigurationUpdate_protocolIEs__item__id,
        ___E2nodeConfigurationUpdate_protocolIEs__item__criticality,
        ___E2nodeConfigurationUpdate_protocolIEs__item__value,
        __E2nodeConfigurationUpdate_protocolIEs__item_,
        _E2nodeConfigurationUpdate_protocolIEs,
        E2nodeConfigurationUpdate,
        E2nodeConfigurationUpdate_IEs,
        _E2nodeConfigurationUpdate_IEs_val_Value_0,
        _E2nodeConfigurationUpdate_IEs_val_Value_1,
        _E2nodeConfigurationUpdate_IEs_val_Value_2,
        _E2nodeConfigurationUpdate_IEs_val_Value_3,
        _E2nodeConfigurationUpdate_IEs_val_Value_4,
        _E2nodeConfigurationUpdate_IEs_val_Value_5,
        ___E2nodeComponentConfigAddition_List__item__id_tab,
        ____E2nodeComponentConfigAddition_List__item__id_tab_val_Value_0,
        __E2nodeComponentConfigAddition_List__item__id,
        __E2nodeComponentConfigAddition_List__item__criticality,
        __E2nodeComponentConfigAddition_List__item__value,
        _E2nodeComponentConfigAddition_List__item_,
        E2nodeComponentConfigAddition_List,
        E2nodeComponentConfigAddition_ItemIEs,
        _E2nodeComponentConfigAddition_ItemIEs_val_Value_0,
        _E2nodeComponentConfigAddition_Item_e2nodeComponentInterfaceType,
        _E2nodeComponentConfigAddition_Item_e2nodeComponentID,
        _E2nodeComponentConfigAddition_Item_e2nodeComponentConfiguration,
        E2nodeComponentConfigAddition_Item,
        ___E2nodeComponentConfigUpdate_List__item__id_tab,
        ____E2nodeComponentConfigUpdate_List__item__id_tab_val_Value_0,
        __E2nodeComponentConfigUpdate_List__item__id,
        __E2nodeComponentConfigUpdate_List__item__criticality,
        __E2nodeComponentConfigUpdate_List__item__value,
        _E2nodeComponentConfigUpdate_List__item_,
        E2nodeComponentConfigUpdate_List,
        E2nodeComponentConfigUpdate_ItemIEs,
        _E2nodeComponentConfigUpdate_ItemIEs_val_Value_0,
        _E2nodeComponentConfigUpdate_Item_e2nodeComponentInterfaceType,
        _E2nodeComponentConfigUpdate_Item_e2nodeComponentID,
        _E2nodeComponentConfigUpdate_Item_e2nodeComponentConfiguration,
        E2nodeComponentConfigUpdate_Item,
        ___E2nodeComponentConfigRemoval_List__item__id_tab,
        ____E2nodeComponentConfigRemoval_List__item__id_tab_val_Value_0,
        __E2nodeComponentConfigRemoval_List__item__id,
        __E2nodeComponentConfigRemoval_List__item__criticality,
        __E2nodeComponentConfigRemoval_List__item__value,
        _E2nodeComponentConfigRemoval_List__item_,
        E2nodeComponentConfigRemoval_List,
        E2nodeComponentConfigRemoval_ItemIEs,
        _E2nodeComponentConfigRemoval_ItemIEs_val_Value_0,
        _E2nodeComponentConfigRemoval_Item_e2nodeComponentInterfaceType,
        _E2nodeComponentConfigRemoval_Item_e2nodeComponentID,
        E2nodeComponentConfigRemoval_Item,
        ___E2nodeTNLassociationRemoval_List__item__id_tab,
        ____E2nodeTNLassociationRemoval_List__item__id_tab_val_Value_0,
        __E2nodeTNLassociationRemoval_List__item__id,
        __E2nodeTNLassociationRemoval_List__item__criticality,
        __E2nodeTNLassociationRemoval_List__item__value,
        _E2nodeTNLassociationRemoval_List__item_,
        E2nodeTNLassociationRemoval_List,
        E2nodeTNLassociationRemoval_ItemIEs,
        _E2nodeTNLassociationRemoval_ItemIEs_val_Value_0,
        _E2nodeTNLassociationRemoval_Item_tnlInformation,
        _E2nodeTNLassociationRemoval_Item_tnlInformationRIC,
        E2nodeTNLassociationRemoval_Item,
        ____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___E2nodeConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __E2nodeConfigurationUpdateAcknowledge_protocolIEs__item_,
        _E2nodeConfigurationUpdateAcknowledge_protocolIEs,
        E2nodeConfigurationUpdateAcknowledge,
        E2nodeConfigurationUpdateAcknowledge_IEs,
        _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_0,
        _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_1,
        _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_2,
        _E2nodeConfigurationUpdateAcknowledge_IEs_val_Value_3,
        ___E2nodeComponentConfigAdditionAck_List__item__id_tab,
        ____E2nodeComponentConfigAdditionAck_List__item__id_tab_val_Value_0,
        __E2nodeComponentConfigAdditionAck_List__item__id,
        __E2nodeComponentConfigAdditionAck_List__item__criticality,
        __E2nodeComponentConfigAdditionAck_List__item__value,
        _E2nodeComponentConfigAdditionAck_List__item_,
        E2nodeComponentConfigAdditionAck_List,
        E2nodeComponentConfigAdditionAck_ItemIEs,
        _E2nodeComponentConfigAdditionAck_ItemIEs_val_Value_0,
        _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentInterfaceType,
        _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentID,
        _E2nodeComponentConfigAdditionAck_Item_e2nodeComponentConfigurationAck,
        E2nodeComponentConfigAdditionAck_Item,
        ___E2nodeComponentConfigUpdateAck_List__item__id_tab,
        ____E2nodeComponentConfigUpdateAck_List__item__id_tab_val_Value_0,
        __E2nodeComponentConfigUpdateAck_List__item__id,
        __E2nodeComponentConfigUpdateAck_List__item__criticality,
        __E2nodeComponentConfigUpdateAck_List__item__value,
        _E2nodeComponentConfigUpdateAck_List__item_,
        E2nodeComponentConfigUpdateAck_List,
        E2nodeComponentConfigUpdateAck_ItemIEs,
        _E2nodeComponentConfigUpdateAck_ItemIEs_val_Value_0,
        _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentInterfaceType,
        _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentID,
        _E2nodeComponentConfigUpdateAck_Item_e2nodeComponentConfigurationAck,
        E2nodeComponentConfigUpdateAck_Item,
        ___E2nodeComponentConfigRemovalAck_List__item__id_tab,
        ____E2nodeComponentConfigRemovalAck_List__item__id_tab_val_Value_0,
        __E2nodeComponentConfigRemovalAck_List__item__id,
        __E2nodeComponentConfigRemovalAck_List__item__criticality,
        __E2nodeComponentConfigRemovalAck_List__item__value,
        _E2nodeComponentConfigRemovalAck_List__item_,
        E2nodeComponentConfigRemovalAck_List,
        E2nodeComponentConfigRemovalAck_ItemIEs,
        _E2nodeComponentConfigRemovalAck_ItemIEs_val_Value_0,
        _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentInterfaceType,
        _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentID,
        _E2nodeComponentConfigRemovalAck_Item_e2nodeComponentConfigurationAck,
        E2nodeComponentConfigRemovalAck_Item,
        ____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____E2nodeConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___E2nodeConfigurationUpdateFailure_protocolIEs__item__id,
        ___E2nodeConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___E2nodeConfigurationUpdateFailure_protocolIEs__item__value,
        __E2nodeConfigurationUpdateFailure_protocolIEs__item_,
        _E2nodeConfigurationUpdateFailure_protocolIEs,
        E2nodeConfigurationUpdateFailure,
        E2nodeConfigurationUpdateFailure_IEs,
        _E2nodeConfigurationUpdateFailure_IEs_val_Value_0,
        _E2nodeConfigurationUpdateFailure_IEs_val_Value_1,
        _E2nodeConfigurationUpdateFailure_IEs_val_Value_2,
        _E2nodeConfigurationUpdateFailure_IEs_val_Value_3,
        ____ResetRequest_protocolIEs__item__id_tab,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_1,
        ___ResetRequest_protocolIEs__item__id,
        ___ResetRequest_protocolIEs__item__criticality,
        ___ResetRequest_protocolIEs__item__value,
        __ResetRequest_protocolIEs__item_,
        _ResetRequest_protocolIEs,
        ResetRequest,
        ResetRequestIEs,
        _ResetRequestIEs_val_Value_0,
        _ResetRequestIEs_val_Value_1,
        ____ResetResponse_protocolIEs__item__id_tab,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_1,
        ___ResetResponse_protocolIEs__item__id,
        ___ResetResponse_protocolIEs__item__criticality,
        ___ResetResponse_protocolIEs__item__value,
        __ResetResponse_protocolIEs__item_,
        _ResetResponse_protocolIEs,
        ResetResponse,
        ResetResponseIEs,
        _ResetResponseIEs_val_Value_0,
        _ResetResponseIEs_val_Value_1,
        ____RICserviceUpdate_protocolIEs__item__id_tab,
        _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____RICserviceUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___RICserviceUpdate_protocolIEs__item__id,
        ___RICserviceUpdate_protocolIEs__item__criticality,
        ___RICserviceUpdate_protocolIEs__item__value,
        __RICserviceUpdate_protocolIEs__item_,
        _RICserviceUpdate_protocolIEs,
        RICserviceUpdate,
        RICserviceUpdate_IEs,
        _RICserviceUpdate_IEs_val_Value_0,
        _RICserviceUpdate_IEs_val_Value_1,
        _RICserviceUpdate_IEs_val_Value_2,
        _RICserviceUpdate_IEs_val_Value_3,
        ___RANfunctions_List__item__id_tab,
        ____RANfunctions_List__item__id_tab_val_Value_0,
        __RANfunctions_List__item__id,
        __RANfunctions_List__item__criticality,
        __RANfunctions_List__item__value,
        _RANfunctions_List__item_,
        RANfunctions_List,
        RANfunction_ItemIEs,
        _RANfunction_ItemIEs_val_Value_0,
        _RANfunction_Item_ranFunctionID,
        _RANfunction_Item_ranFunctionDefinition,
        _RANfunction_Item_ranFunctionRevision,
        _RANfunction_Item_ranFunctionOID,
        RANfunction_Item,
        ___RANfunctionsID_List__item__id_tab,
        ____RANfunctionsID_List__item__id_tab_val_Value_0,
        __RANfunctionsID_List__item__id,
        __RANfunctionsID_List__item__criticality,
        __RANfunctionsID_List__item__value,
        _RANfunctionsID_List__item_,
        RANfunctionsID_List,
        RANfunctionID_ItemIEs,
        _RANfunctionID_ItemIEs_val_Value_0,
        _RANfunctionID_Item_ranFunctionID,
        _RANfunctionID_Item_ranFunctionRevision,
        RANfunctionID_Item,
        ____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab,
        _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____RICserviceUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___RICserviceUpdateAcknowledge_protocolIEs__item__id,
        ___RICserviceUpdateAcknowledge_protocolIEs__item__criticality,
        ___RICserviceUpdateAcknowledge_protocolIEs__item__value,
        __RICserviceUpdateAcknowledge_protocolIEs__item_,
        _RICserviceUpdateAcknowledge_protocolIEs,
        RICserviceUpdateAcknowledge,
        RICserviceUpdateAcknowledge_IEs,
        _RICserviceUpdateAcknowledge_IEs_val_Value_0,
        _RICserviceUpdateAcknowledge_IEs_val_Value_1,
        _RICserviceUpdateAcknowledge_IEs_val_Value_2,
        ___RANfunctionsIDcause_List__item__id_tab,
        ____RANfunctionsIDcause_List__item__id_tab_val_Value_0,
        __RANfunctionsIDcause_List__item__id,
        __RANfunctionsIDcause_List__item__criticality,
        __RANfunctionsIDcause_List__item__value,
        _RANfunctionsIDcause_List__item_,
        RANfunctionsIDcause_List,
        RANfunctionIDcause_ItemIEs,
        _RANfunctionIDcause_ItemIEs_val_Value_0,
        _RANfunctionIDcause_Item_ranFunctionID,
        _RANfunctionIDcause_Item_cause,
        RANfunctionIDcause_Item,
        ____RICserviceUpdateFailure_protocolIEs__item__id_tab,
        _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RICserviceUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RICserviceUpdateFailure_protocolIEs__item__id,
        ___RICserviceUpdateFailure_protocolIEs__item__criticality,
        ___RICserviceUpdateFailure_protocolIEs__item__value,
        __RICserviceUpdateFailure_protocolIEs__item_,
        _RICserviceUpdateFailure_protocolIEs,
        RICserviceUpdateFailure,
        RICserviceUpdateFailure_IEs,
        _RICserviceUpdateFailure_IEs_val_Value_0,
        _RICserviceUpdateFailure_IEs_val_Value_1,
        _RICserviceUpdateFailure_IEs_val_Value_2,
        _RICserviceUpdateFailure_IEs_val_Value_3,
        ____RICserviceQuery_protocolIEs__item__id_tab,
        _____RICserviceQuery_protocolIEs__item__id_tab_val_Value_0,
        _____RICserviceQuery_protocolIEs__item__id_tab_val_Value_1,
        ___RICserviceQuery_protocolIEs__item__id,
        ___RICserviceQuery_protocolIEs__item__criticality,
        ___RICserviceQuery_protocolIEs__item__value,
        __RICserviceQuery_protocolIEs__item_,
        _RICserviceQuery_protocolIEs,
        RICserviceQuery,
        RICserviceQuery_IEs,
        _RICserviceQuery_IEs_val_Value_0,
        _RICserviceQuery_IEs_val_Value_1,
        ____E2RemovalRequest_protocolIEs__item__id_tab,
        _____E2RemovalRequest_protocolIEs__item__id_tab_val_Value_0,
        ___E2RemovalRequest_protocolIEs__item__id,
        ___E2RemovalRequest_protocolIEs__item__criticality,
        ___E2RemovalRequest_protocolIEs__item__value,
        __E2RemovalRequest_protocolIEs__item_,
        _E2RemovalRequest_protocolIEs,
        E2RemovalRequest,
        E2RemovalRequestIEs,
        _E2RemovalRequestIEs_val_Value_0,
        ____E2RemovalResponse_protocolIEs__item__id_tab,
        _____E2RemovalResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E2RemovalResponse_protocolIEs__item__id_tab_val_Value_1,
        ___E2RemovalResponse_protocolIEs__item__id,
        ___E2RemovalResponse_protocolIEs__item__criticality,
        ___E2RemovalResponse_protocolIEs__item__value,
        __E2RemovalResponse_protocolIEs__item_,
        _E2RemovalResponse_protocolIEs,
        E2RemovalResponse,
        E2RemovalResponseIEs,
        _E2RemovalResponseIEs_val_Value_0,
        _E2RemovalResponseIEs_val_Value_1,
        ____E2RemovalFailure_protocolIEs__item__id_tab,
        _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E2RemovalFailure_protocolIEs__item__id_tab_val_Value_2,
        ___E2RemovalFailure_protocolIEs__item__id,
        ___E2RemovalFailure_protocolIEs__item__criticality,
        ___E2RemovalFailure_protocolIEs__item__value,
        __E2RemovalFailure_protocolIEs__item_,
        _E2RemovalFailure_protocolIEs,
        E2RemovalFailure,
        E2RemovalFailureIEs,
        _E2RemovalFailureIEs_val_Value_0,
        _E2RemovalFailureIEs_val_Value_1,
        _E2RemovalFailureIEs_val_Value_2,
    ]

class E2AP_PDU_Descriptions:

    _name_  = 'E2AP-PDU-Descriptions'
    _oid_   = [1, 3, 6, 1, 4, 1, 53148, 1, 2, 1, 0]
    
    _obj_ = [
        'E2AP-ELEMENTARY-PROCEDURE',
        'E2AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'E2AP-ELEMENTARY-PROCEDURES',
        'E2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'E2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'e2connectionUpdate',
        'e2nodeConfigurationUpdate',
        'e2removal',
        'e2setup',
        'errorIndication',
        'reset',
        'ricControl',
        'ricIndication',
        'ricServiceQuery',
        'ricServiceUpdate',
        'ricSubscription',
        'ricSubscriptionAudit',
        'ricSubscriptionDelete',
        'ricSubscriptionDeleteRequired',
        'ricSubscriptionModification',
        'ricSubscriptionModificationRequired',
        'ricQuery',
        ]
    _type_ = [
        'E2AP-ELEMENTARY-PROCEDURE',
        'E2AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'E2AP-ELEMENTARY-PROCEDURES',
        'E2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'E2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'e2connectionUpdate',
        'e2nodeConfigurationUpdate',
        'e2removal',
        'e2setup',
        'errorIndication',
        'reset',
        'ricControl',
        'ricIndication',
        'ricServiceQuery',
        'ricServiceUpdate',
        'ricSubscription',
        'ricSubscriptionAudit',
        'ricSubscriptionDelete',
        'ricSubscriptionDeleteRequired',
        'ricSubscriptionModification',
        'ricSubscriptionModificationRequired',
        'ricQuery',
        ]
    _class_ = [
        'E2AP-ELEMENTARY-PROCEDURE',
        'E2AP-ELEMENTARY-PROCEDURES',
        'E2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'E2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'e2connectionUpdate',
        'e2nodeConfigurationUpdate',
        'e2removal',
        'e2setup',
        'errorIndication',
        'reset',
        'ricControl',
        'ricIndication',
        'ricServiceQuery',
        'ricServiceUpdate',
        'ricSubscription',
        'ricSubscriptionAudit',
        'ricSubscriptionDelete',
        'ricSubscriptionDeleteRequired',
        'ricSubscriptionModification',
        'ricSubscriptionModificationRequired',
        'ricQuery',
        ]
    _param_ = [
        ]
    
    #-----< E2AP-ELEMENTARY-PROCEDURE >-----#
    E2AP_ELEMENTARY_PROCEDURE = CLASS(name='E2AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _E2AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _E2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _E2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _E2AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _E2AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-CommonDataTypes', 'Criticality')), default='ignore')
    E2AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _E2AP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _E2AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< E2AP-PDU >-----#
    E2AP_PDU = CHOICE(name='E2AP-PDU', mode=MODE_TYPE)
    _E2AP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'InitiatingMessage')))
    _E2AP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _E2AP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    E2AP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _E2AP_PDU_initiatingMessage),
        ('successfulOutcome', _E2AP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _E2AP_PDU_unsuccessfulOutcome),
        ])
    E2AP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_E2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICindication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceQuery')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequired')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_E2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICindication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceQuery')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequired')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_E2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICindication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceQuery')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequired')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< E2AP-ELEMENTARY-PROCEDURES >-----#
    E2AP_ELEMENTARY_PROCEDURES = CLASS(name='E2AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequired')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationConfirm')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRefuse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdate')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdate')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICindication')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceQuery')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ErrorIndication')))
    _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequired')))
    E2AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< E2AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    E2AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='E2AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequired')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationConfirm')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRefuse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdate')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdate')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateAcknowledge')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateFailure')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalRequest')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalResponse')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalFailure')))
    E2AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('procedureCode', 13), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< E2AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    E2AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='E2AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICindication')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceQuery')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ErrorIndication')))
    _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequired')))
    E2AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 12), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< e2connectionUpdate >-----#
    e2connectionUpdate = CLASS(name='e2connectionUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _e2connectionUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdate')))
    _e2connectionUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateAcknowledge')))
    _e2connectionUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2connectionUpdateFailure')))
    e2connectionUpdate._val = dict([('InitiatingMessage', _e2connectionUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _e2connectionUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _e2connectionUpdate_val_UnsuccessfulOutcome), ('procedureCode', 11), ('criticality', 'reject')])
    
    #-----< e2nodeConfigurationUpdate >-----#
    e2nodeConfigurationUpdate = CLASS(name='e2nodeConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _e2nodeConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdate')))
    _e2nodeConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateAcknowledge')))
    _e2nodeConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2nodeConfigurationUpdateFailure')))
    e2nodeConfigurationUpdate._val = dict([('InitiatingMessage', _e2nodeConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _e2nodeConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _e2nodeConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 10), ('criticality', 'reject')])
    
    #-----< e2removal >-----#
    e2removal = CLASS(name='e2removal', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _e2removal_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalRequest')))
    _e2removal_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalResponse')))
    _e2removal_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2RemovalFailure')))
    e2removal._val = dict([('InitiatingMessage', _e2removal_val_InitiatingMessage), ('SuccessfulOutcome', _e2removal_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _e2removal_val_UnsuccessfulOutcome), ('procedureCode', 13), ('criticality', 'reject')])
    
    #-----< e2setup >-----#
    e2setup = CLASS(name='e2setup', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _e2setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupRequest')))
    _e2setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupResponse')))
    _e2setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'E2setupFailure')))
    e2setup._val = dict([('InitiatingMessage', _e2setup_val_InitiatingMessage), ('SuccessfulOutcome', _e2setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _e2setup_val_UnsuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetRequest')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'ResetResponse')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('procedureCode', 3), ('criticality', 'reject')])
    
    #-----< ricControl >-----#
    ricControl = CLASS(name='ricControl', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolRequest')))
    _ricControl_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolAcknowledge')))
    _ricControl_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICcontrolFailure')))
    ricControl._val = dict([('InitiatingMessage', _ricControl_val_InitiatingMessage), ('SuccessfulOutcome', _ricControl_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricControl_val_UnsuccessfulOutcome), ('procedureCode', 4), ('criticality', 'reject')])
    
    #-----< ricIndication >-----#
    ricIndication = CLASS(name='ricIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICindication')))
    ricIndication._val = dict([('InitiatingMessage', _ricIndication_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< ricServiceQuery >-----#
    ricServiceQuery = CLASS(name='ricServiceQuery', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricServiceQuery_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceQuery')))
    ricServiceQuery._val = dict([('InitiatingMessage', _ricServiceQuery_val_InitiatingMessage), ('procedureCode', 6), ('criticality', 'ignore')])
    
    #-----< ricServiceUpdate >-----#
    ricServiceUpdate = CLASS(name='ricServiceUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricServiceUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdate')))
    _ricServiceUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateAcknowledge')))
    _ricServiceUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICserviceUpdateFailure')))
    ricServiceUpdate._val = dict([('InitiatingMessage', _ricServiceUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _ricServiceUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricServiceUpdate_val_UnsuccessfulOutcome), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< ricSubscription >-----#
    ricSubscription = CLASS(name='ricSubscription', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricSubscription_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionRequest')))
    _ricSubscription_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionResponse')))
    _ricSubscription_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionFailure')))
    ricSubscription._val = dict([('InitiatingMessage', _ricSubscription_val_InitiatingMessage), ('SuccessfulOutcome', _ricSubscription_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricSubscription_val_UnsuccessfulOutcome), ('procedureCode', 8), ('criticality', 'reject')])
    
    #-----< ricSubscriptionAudit >-----#
    ricSubscriptionAudit = CLASS(name='ricSubscriptionAudit', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricSubscriptionAudit_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditRequest')))
    _ricSubscriptionAudit_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditResponse')))
    _ricSubscriptionAudit_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionAuditFailure')))
    ricSubscriptionAudit._val = dict([('InitiatingMessage', _ricSubscriptionAudit_val_InitiatingMessage), ('SuccessfulOutcome', _ricSubscriptionAudit_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricSubscriptionAudit_val_UnsuccessfulOutcome), ('procedureCode', 17), ('criticality', 'reject')])
    
    #-----< ricSubscriptionDelete >-----#
    ricSubscriptionDelete = CLASS(name='ricSubscriptionDelete', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricSubscriptionDelete_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequest')))
    _ricSubscriptionDelete_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteResponse')))
    _ricSubscriptionDelete_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteFailure')))
    ricSubscriptionDelete._val = dict([('InitiatingMessage', _ricSubscriptionDelete_val_InitiatingMessage), ('SuccessfulOutcome', _ricSubscriptionDelete_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricSubscriptionDelete_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< ricSubscriptionDeleteRequired >-----#
    ricSubscriptionDeleteRequired = CLASS(name='ricSubscriptionDeleteRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricSubscriptionDeleteRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionDeleteRequired')))
    ricSubscriptionDeleteRequired._val = dict([('InitiatingMessage', _ricSubscriptionDeleteRequired_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< ricSubscriptionModification >-----#
    ricSubscriptionModification = CLASS(name='ricSubscriptionModification', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricSubscriptionModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequest')))
    _ricSubscriptionModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationResponse')))
    _ricSubscriptionModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationFailure')))
    ricSubscriptionModification._val = dict([('InitiatingMessage', _ricSubscriptionModification_val_InitiatingMessage), ('SuccessfulOutcome', _ricSubscriptionModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricSubscriptionModification_val_UnsuccessfulOutcome), ('procedureCode', 14), ('criticality', 'reject')])
    
    #-----< ricSubscriptionModificationRequired >-----#
    ricSubscriptionModificationRequired = CLASS(name='ricSubscriptionModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricSubscriptionModificationRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRequired')))
    _ricSubscriptionModificationRequired_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationConfirm')))
    _ricSubscriptionModificationRequired_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICsubscriptionModificationRefuse')))
    ricSubscriptionModificationRequired._val = dict([('InitiatingMessage', _ricSubscriptionModificationRequired_val_InitiatingMessage), ('SuccessfulOutcome', _ricSubscriptionModificationRequired_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricSubscriptionModificationRequired_val_UnsuccessfulOutcome), ('procedureCode', 15), ('criticality', 'reject')])
    
    #-----< ricQuery >-----#
    ricQuery = CLASS(name='ricQuery', mode=MODE_VALUE, typeref=ASN1RefType(('E2AP-PDU-Descriptions', 'E2AP-ELEMENTARY-PROCEDURE')))
    _ricQuery_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryRequest')))
    _ricQuery_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryResponse')))
    _ricQuery_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E2AP-PDU-Contents', 'RICqueryFailure')))
    ricQuery._val = dict([('InitiatingMessage', _ricQuery_val_InitiatingMessage), ('SuccessfulOutcome', _ricQuery_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _ricQuery_val_UnsuccessfulOutcome), ('procedureCode', 16), ('criticality', 'reject')])
    
    _all_ = [
        _E2AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _E2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _E2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _E2AP_ELEMENTARY_PROCEDURE_procedureCode,
        _E2AP_ELEMENTARY_PROCEDURE_criticality,
        E2AP_ELEMENTARY_PROCEDURE,
        _E2AP_PDU_initiatingMessage,
        _E2AP_PDU_successfulOutcome,
        _E2AP_PDU_unsuccessfulOutcome,
        E2AP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        E2AP_ELEMENTARY_PROCEDURES,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _E2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _E2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _E2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        E2AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        E2AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _E2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        e2connectionUpdate,
        _e2connectionUpdate_val_InitiatingMessage,
        _e2connectionUpdate_val_SuccessfulOutcome,
        _e2connectionUpdate_val_UnsuccessfulOutcome,
        e2nodeConfigurationUpdate,
        _e2nodeConfigurationUpdate_val_InitiatingMessage,
        _e2nodeConfigurationUpdate_val_SuccessfulOutcome,
        _e2nodeConfigurationUpdate_val_UnsuccessfulOutcome,
        e2removal,
        _e2removal_val_InitiatingMessage,
        _e2removal_val_SuccessfulOutcome,
        _e2removal_val_UnsuccessfulOutcome,
        e2setup,
        _e2setup_val_InitiatingMessage,
        _e2setup_val_SuccessfulOutcome,
        _e2setup_val_UnsuccessfulOutcome,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        ricControl,
        _ricControl_val_InitiatingMessage,
        _ricControl_val_SuccessfulOutcome,
        _ricControl_val_UnsuccessfulOutcome,
        ricIndication,
        _ricIndication_val_InitiatingMessage,
        ricServiceQuery,
        _ricServiceQuery_val_InitiatingMessage,
        ricServiceUpdate,
        _ricServiceUpdate_val_InitiatingMessage,
        _ricServiceUpdate_val_SuccessfulOutcome,
        _ricServiceUpdate_val_UnsuccessfulOutcome,
        ricSubscription,
        _ricSubscription_val_InitiatingMessage,
        _ricSubscription_val_SuccessfulOutcome,
        _ricSubscription_val_UnsuccessfulOutcome,
        ricSubscriptionAudit,
        _ricSubscriptionAudit_val_InitiatingMessage,
        _ricSubscriptionAudit_val_SuccessfulOutcome,
        _ricSubscriptionAudit_val_UnsuccessfulOutcome,
        ricSubscriptionDelete,
        _ricSubscriptionDelete_val_InitiatingMessage,
        _ricSubscriptionDelete_val_SuccessfulOutcome,
        _ricSubscriptionDelete_val_UnsuccessfulOutcome,
        ricSubscriptionDeleteRequired,
        _ricSubscriptionDeleteRequired_val_InitiatingMessage,
        ricSubscriptionModification,
        _ricSubscriptionModification_val_InitiatingMessage,
        _ricSubscriptionModification_val_SuccessfulOutcome,
        _ricSubscriptionModification_val_UnsuccessfulOutcome,
        ricSubscriptionModificationRequired,
        _ricSubscriptionModificationRequired_val_InitiatingMessage,
        _ricSubscriptionModificationRequired_val_SuccessfulOutcome,
        _ricSubscriptionModificationRequired_val_UnsuccessfulOutcome,
        ricQuery,
        _ricQuery_val_InitiatingMessage,
        _ricQuery_val_SuccessfulOutcome,
        _ricQuery_val_UnsuccessfulOutcome,
    ]

init_modules(E2AP_CommonDataTypes, E2AP_Constants, E2AP_Containers, E2AP_IEs, E2AP_PDU_Contents, E2AP_PDU_Descriptions)
