# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class MULTIMEDIA_SYSTEM_CONTROL:

    _name_  = 'MULTIMEDIA-SYSTEM-CONTROL'
    _oid_   = [0, 0, 8, 245, 0, 16, 0]
    
    _obj_ = [
        'MultimediaSystemControlMessage',
        'RequestMessage',
        'ResponseMessage',
        'CommandMessage',
        'IndicationMessage',
        'SequenceNumber',
        'GenericMessage',
        'GenericInformation',
        'NonStandardMessage',
        'NonStandardParameter',
        'NonStandardIdentifier',
        'MasterSlaveDetermination',
        'MasterSlaveDeterminationAck',
        'MasterSlaveDeterminationReject',
        'MasterSlaveDeterminationRelease',
        'TerminalCapabilitySet',
        'CapabilityTableEntry',
        'CapabilityDescriptor',
        'AlternativeCapabilitySet',
        'CapabilityTableEntryNumber',
        'CapabilityDescriptorNumber',
        'TerminalCapabilitySetAck',
        'TerminalCapabilitySetReject',
        'TerminalCapabilitySetRelease',
        'Capability',
        'H235SecurityCapability',
        'MultiplexCapability',
        'H222Capability',
        'VCCapability',
        'H223Capability',
        'H223AnnexCCapability',
        'V76Capability',
        'V75Capability',
        'H2250Capability',
        'MediaPacketizationCapability',
        'RSVPParameters',
        'QOSMode',
        'ATMParameters',
        'ServicePriorityValue',
        'ServicePriority',
        'AuthorizationParameters',
        'QOSType',
        'QOSClass',
        'QOSDescriptor',
        'GenericTransportParameters',
        'QOSCapability',
        'MediaTransportType',
        'MediaChannelCapability',
        'TransportCapability',
        'RedundancyEncodingCapability',
        'RedundancyEncodingMethod',
        'RTPH263VideoRedundancyEncoding',
        'RTPH263VideoRedundancyFrameMapping',
        'MultipointCapability',
        'MediaDistributionCapability',
        'VideoCapability',
        'ExtendedVideoCapability',
        'H261VideoCapability',
        'H262VideoCapability',
        'H263VideoCapability',
        'EnhancementLayerInfo',
        'BEnhancementParameters',
        'EnhancementOptions',
        'H263Options',
        'TransparencyParameters',
        'RefPictureSelection',
        'CustomPictureClockFrequency',
        'CustomPictureFormat',
        'H263VideoModeCombos',
        'H263ModeComboFlags',
        'H263Version3Options',
        'IS11172VideoCapability',
        'AudioCapability',
        'G729Extensions',
        'G7231AnnexCCapability',
        'IS11172AudioCapability',
        'IS13818AudioCapability',
        'GSMAudioCapability',
        'VBDCapability',
        'DataApplicationCapability',
        'DataProtocolCapability',
        'CompressionType',
        'V42bis',
        'T84Profile',
        'T38FaxProfile',
        'T38FaxRateManagement',
        'T38FaxUdpOptions',
        'T38FaxTcpOptions',
        'EncryptionAuthenticationAndIntegrity',
        'EncryptionCapability',
        'MediaEncryptionAlgorithm',
        'AuthenticationCapability',
        'IntegrityCapability',
        'UserInputCapability',
        'ConferenceCapability',
        'GenericCapability',
        'CapabilityIdentifier',
        'GenericParameter',
        'ParameterIdentifier',
        'ParameterValue',
        'MultiplexedStreamCapability',
        'MultiplexFormat',
        'AudioTelephonyEventCapability',
        'AudioToneCapability',
        'NoPTAudioTelephonyEventCapability',
        'NoPTAudioToneCapability',
        'MultiplePayloadStreamCapability',
        'DepFECCapability',
        'FECCapability',
        'MaxRedundancy',
        'OpenLogicalChannel',
        'LogicalChannelNumber',
        'NetworkAccessParameters',
        'Q2931Address',
        'V75Parameters',
        'DataType',
        'H235Media',
        'MultiplexedStreamParameter',
        'H222LogicalChannelParameters',
        'H223LogicalChannelParameters',
        'H223AL1MParameters',
        'H223AL2MParameters',
        'H223AL3MParameters',
        'H223AnnexCArqParameters',
        'V76LogicalChannelParameters',
        'V76HDLCParameters',
        'CRCLength',
        'H2250LogicalChannelParameters',
        'RTPPayloadType',
        'RedundancyEncoding',
        'RedundancyEncodingElement',
        'MultiplePayloadStream',
        'MultiplePayloadStreamElement',
        'DepFECData',
        'FECData',
        'TransportAddress',
        'UnicastAddress',
        'MulticastAddress',
        'EncryptionSync',
        'EscrowData',
        'OpenLogicalChannelAck',
        'OpenLogicalChannelReject',
        'OpenLogicalChannelConfirm',
        'H2250LogicalChannelAckParameters',
        'CloseLogicalChannel',
        'CloseLogicalChannelAck',
        'RequestChannelClose',
        'RequestChannelCloseAck',
        'RequestChannelCloseReject',
        'RequestChannelCloseRelease',
        'MultiplexEntrySend',
        'MultiplexEntryDescriptor',
        'MultiplexElement',
        'MultiplexTableEntryNumber',
        'MultiplexEntrySendAck',
        'MultiplexEntrySendReject',
        'MultiplexEntryRejectionDescriptions',
        'MultiplexEntrySendRelease',
        'RequestMultiplexEntry',
        'RequestMultiplexEntryAck',
        'RequestMultiplexEntryReject',
        'RequestMultiplexEntryRejectionDescriptions',
        'RequestMultiplexEntryRelease',
        'RequestMode',
        'RequestModeAck',
        'RequestModeReject',
        'RequestModeRelease',
        'ModeDescription',
        'ModeElementType',
        'ModeElement',
        'H235Mode',
        'MultiplexedStreamModeParameters',
        'RedundancyEncodingDTMode',
        'RedundancyEncodingDTModeElement',
        'MultiplePayloadStreamMode',
        'MultiplePayloadStreamElementMode',
        'DepFECMode',
        'FECMode',
        'H223ModeParameters',
        'V76ModeParameters',
        'H2250ModeParameters',
        'RedundancyEncodingMode',
        'VideoMode',
        'H261VideoMode',
        'H262VideoMode',
        'H263VideoMode',
        'IS11172VideoMode',
        'AudioMode',
        'IS11172AudioMode',
        'IS13818AudioMode',
        'G7231AnnexCMode',
        'VBDMode',
        'DataMode',
        'EncryptionMode',
        'RoundTripDelayRequest',
        'RoundTripDelayResponse',
        'MaintenanceLoopRequest',
        'MaintenanceLoopAck',
        'MaintenanceLoopReject',
        'MaintenanceLoopOffCommand',
        'CommunicationModeCommand',
        'CommunicationModeRequest',
        'CommunicationModeResponse',
        'CommunicationModeTableEntry',
        'ConferenceRequest',
        'CertSelectionCriteria',
        'Criteria',
        'TerminalLabel',
        'McuNumber',
        'TerminalNumber',
        'ConferenceResponse',
        'TerminalID',
        'ConferenceID',
        'Password',
        'RequestAllTerminalIDsResponse',
        'TerminalInformation',
        'RemoteMCRequest',
        'RemoteMCResponse',
        'MultilinkRequest',
        'MultilinkResponse',
        'MultilinkIndication',
        'DialingInformation',
        'DialingInformationNumber',
        'DialingInformationNetworkType',
        'ConnectionIdentifier',
        'MaximumBitRate',
        'LogicalChannelRateRequest',
        'LogicalChannelRateAcknowledge',
        'LogicalChannelRateReject',
        'LogicalChannelRateRejectReason',
        'LogicalChannelRateRelease',
        'SendTerminalCapabilitySet',
        'EncryptionCommand',
        'FlowControlCommand',
        'EndSessionCommand',
        'ConferenceCommand',
        'SubstituteConferenceIDCommand',
        'EncryptionUpdateDirection',
        'MiscellaneousCommand',
        'KeyProtectionMethod',
        'EncryptionUpdateRequest',
        'PictureReference',
        'H223MultiplexReconfiguration',
        'NewATMVCCommand',
        'MobileMultilinkReconfigurationCommand',
        'FunctionNotUnderstood',
        'FunctionNotSupported',
        'ConferenceIndication',
        'TerminalYouAreSeeingInSubPictureNumber',
        'VideoIndicateCompose',
        'MiscellaneousIndication',
        'JitterIndication',
        'H223SkewIndication',
        'H2250MaximumSkewIndication',
        'MCLocationIndication',
        'VendorIdentification',
        'NewATMVCIndication',
        'IV8',
        'IV16',
        'Params',
        'UserInputIndication',
        'FlowControlIndication',
        'MobileMultilinkReconfigurationIndication',
        ]
    _type_ = [
        'MultimediaSystemControlMessage',
        'RequestMessage',
        'ResponseMessage',
        'CommandMessage',
        'IndicationMessage',
        'SequenceNumber',
        'GenericMessage',
        'GenericInformation',
        'NonStandardMessage',
        'NonStandardParameter',
        'NonStandardIdentifier',
        'MasterSlaveDetermination',
        'MasterSlaveDeterminationAck',
        'MasterSlaveDeterminationReject',
        'MasterSlaveDeterminationRelease',
        'TerminalCapabilitySet',
        'CapabilityTableEntry',
        'CapabilityDescriptor',
        'AlternativeCapabilitySet',
        'CapabilityTableEntryNumber',
        'CapabilityDescriptorNumber',
        'TerminalCapabilitySetAck',
        'TerminalCapabilitySetReject',
        'TerminalCapabilitySetRelease',
        'Capability',
        'H235SecurityCapability',
        'MultiplexCapability',
        'H222Capability',
        'VCCapability',
        'H223Capability',
        'H223AnnexCCapability',
        'V76Capability',
        'V75Capability',
        'H2250Capability',
        'MediaPacketizationCapability',
        'RSVPParameters',
        'QOSMode',
        'ATMParameters',
        'ServicePriorityValue',
        'ServicePriority',
        'AuthorizationParameters',
        'QOSType',
        'QOSClass',
        'QOSDescriptor',
        'GenericTransportParameters',
        'QOSCapability',
        'MediaTransportType',
        'MediaChannelCapability',
        'TransportCapability',
        'RedundancyEncodingCapability',
        'RedundancyEncodingMethod',
        'RTPH263VideoRedundancyEncoding',
        'RTPH263VideoRedundancyFrameMapping',
        'MultipointCapability',
        'MediaDistributionCapability',
        'VideoCapability',
        'ExtendedVideoCapability',
        'H261VideoCapability',
        'H262VideoCapability',
        'H263VideoCapability',
        'EnhancementLayerInfo',
        'BEnhancementParameters',
        'EnhancementOptions',
        'H263Options',
        'TransparencyParameters',
        'RefPictureSelection',
        'CustomPictureClockFrequency',
        'CustomPictureFormat',
        'H263VideoModeCombos',
        'H263ModeComboFlags',
        'H263Version3Options',
        'IS11172VideoCapability',
        'AudioCapability',
        'G729Extensions',
        'G7231AnnexCCapability',
        'IS11172AudioCapability',
        'IS13818AudioCapability',
        'GSMAudioCapability',
        'VBDCapability',
        'DataApplicationCapability',
        'DataProtocolCapability',
        'CompressionType',
        'V42bis',
        'T84Profile',
        'T38FaxProfile',
        'T38FaxRateManagement',
        'T38FaxUdpOptions',
        'T38FaxTcpOptions',
        'EncryptionAuthenticationAndIntegrity',
        'EncryptionCapability',
        'MediaEncryptionAlgorithm',
        'AuthenticationCapability',
        'IntegrityCapability',
        'UserInputCapability',
        'ConferenceCapability',
        'GenericCapability',
        'CapabilityIdentifier',
        'GenericParameter',
        'ParameterIdentifier',
        'ParameterValue',
        'MultiplexedStreamCapability',
        'MultiplexFormat',
        'AudioTelephonyEventCapability',
        'AudioToneCapability',
        'NoPTAudioTelephonyEventCapability',
        'NoPTAudioToneCapability',
        'MultiplePayloadStreamCapability',
        'DepFECCapability',
        'FECCapability',
        'MaxRedundancy',
        'OpenLogicalChannel',
        'LogicalChannelNumber',
        'NetworkAccessParameters',
        'Q2931Address',
        'V75Parameters',
        'DataType',
        'H235Media',
        'MultiplexedStreamParameter',
        'H222LogicalChannelParameters',
        'H223LogicalChannelParameters',
        'H223AL1MParameters',
        'H223AL2MParameters',
        'H223AL3MParameters',
        'H223AnnexCArqParameters',
        'V76LogicalChannelParameters',
        'V76HDLCParameters',
        'CRCLength',
        'H2250LogicalChannelParameters',
        'RTPPayloadType',
        'RedundancyEncoding',
        'RedundancyEncodingElement',
        'MultiplePayloadStream',
        'MultiplePayloadStreamElement',
        'DepFECData',
        'FECData',
        'TransportAddress',
        'UnicastAddress',
        'MulticastAddress',
        'EncryptionSync',
        'EscrowData',
        'OpenLogicalChannelAck',
        'OpenLogicalChannelReject',
        'OpenLogicalChannelConfirm',
        'H2250LogicalChannelAckParameters',
        'CloseLogicalChannel',
        'CloseLogicalChannelAck',
        'RequestChannelClose',
        'RequestChannelCloseAck',
        'RequestChannelCloseReject',
        'RequestChannelCloseRelease',
        'MultiplexEntrySend',
        'MultiplexEntryDescriptor',
        'MultiplexElement',
        'MultiplexTableEntryNumber',
        'MultiplexEntrySendAck',
        'MultiplexEntrySendReject',
        'MultiplexEntryRejectionDescriptions',
        'MultiplexEntrySendRelease',
        'RequestMultiplexEntry',
        'RequestMultiplexEntryAck',
        'RequestMultiplexEntryReject',
        'RequestMultiplexEntryRejectionDescriptions',
        'RequestMultiplexEntryRelease',
        'RequestMode',
        'RequestModeAck',
        'RequestModeReject',
        'RequestModeRelease',
        'ModeDescription',
        'ModeElementType',
        'ModeElement',
        'H235Mode',
        'MultiplexedStreamModeParameters',
        'RedundancyEncodingDTMode',
        'RedundancyEncodingDTModeElement',
        'MultiplePayloadStreamMode',
        'MultiplePayloadStreamElementMode',
        'DepFECMode',
        'FECMode',
        'H223ModeParameters',
        'V76ModeParameters',
        'H2250ModeParameters',
        'RedundancyEncodingMode',
        'VideoMode',
        'H261VideoMode',
        'H262VideoMode',
        'H263VideoMode',
        'IS11172VideoMode',
        'AudioMode',
        'IS11172AudioMode',
        'IS13818AudioMode',
        'G7231AnnexCMode',
        'VBDMode',
        'DataMode',
        'EncryptionMode',
        'RoundTripDelayRequest',
        'RoundTripDelayResponse',
        'MaintenanceLoopRequest',
        'MaintenanceLoopAck',
        'MaintenanceLoopReject',
        'MaintenanceLoopOffCommand',
        'CommunicationModeCommand',
        'CommunicationModeRequest',
        'CommunicationModeResponse',
        'CommunicationModeTableEntry',
        'ConferenceRequest',
        'CertSelectionCriteria',
        'Criteria',
        'TerminalLabel',
        'McuNumber',
        'TerminalNumber',
        'ConferenceResponse',
        'TerminalID',
        'ConferenceID',
        'Password',
        'RequestAllTerminalIDsResponse',
        'TerminalInformation',
        'RemoteMCRequest',
        'RemoteMCResponse',
        'MultilinkRequest',
        'MultilinkResponse',
        'MultilinkIndication',
        'DialingInformation',
        'DialingInformationNumber',
        'DialingInformationNetworkType',
        'ConnectionIdentifier',
        'MaximumBitRate',
        'LogicalChannelRateRequest',
        'LogicalChannelRateAcknowledge',
        'LogicalChannelRateReject',
        'LogicalChannelRateRejectReason',
        'LogicalChannelRateRelease',
        'SendTerminalCapabilitySet',
        'EncryptionCommand',
        'FlowControlCommand',
        'EndSessionCommand',
        'ConferenceCommand',
        'SubstituteConferenceIDCommand',
        'EncryptionUpdateDirection',
        'MiscellaneousCommand',
        'KeyProtectionMethod',
        'EncryptionUpdateRequest',
        'PictureReference',
        'H223MultiplexReconfiguration',
        'NewATMVCCommand',
        'MobileMultilinkReconfigurationCommand',
        'FunctionNotUnderstood',
        'FunctionNotSupported',
        'ConferenceIndication',
        'TerminalYouAreSeeingInSubPictureNumber',
        'VideoIndicateCompose',
        'MiscellaneousIndication',
        'JitterIndication',
        'H223SkewIndication',
        'H2250MaximumSkewIndication',
        'MCLocationIndication',
        'VendorIdentification',
        'NewATMVCIndication',
        'IV8',
        'IV16',
        'Params',
        'UserInputIndication',
        'FlowControlIndication',
        'MobileMultilinkReconfigurationIndication',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MultimediaSystemControlMessage >-----#
    MultimediaSystemControlMessage = CHOICE(name='MultimediaSystemControlMessage', mode=MODE_TYPE)
    _MultimediaSystemControlMessage_request = CHOICE(name='request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMessage')))
    _MultimediaSystemControlMessage_response = CHOICE(name='response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ResponseMessage')))
    _MultimediaSystemControlMessage_command = CHOICE(name='command', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommandMessage')))
    _MultimediaSystemControlMessage_indication = CHOICE(name='indication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IndicationMessage')))
    MultimediaSystemControlMessage._cont = ASN1Dict([
        ('request', _MultimediaSystemControlMessage_request),
        ('response', _MultimediaSystemControlMessage_response),
        ('command', _MultimediaSystemControlMessage_command),
        ('indication', _MultimediaSystemControlMessage_indication),
        ])
    MultimediaSystemControlMessage._ext = []
    
    #-----< RequestMessage >-----#
    RequestMessage = CHOICE(name='RequestMessage', mode=MODE_TYPE)
    _RequestMessage_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _RequestMessage_masterSlaveDetermination = SEQ(name='masterSlaveDetermination', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MasterSlaveDetermination')))
    _RequestMessage_terminalCapabilitySet = SEQ(name='terminalCapabilitySet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalCapabilitySet')))
    _RequestMessage_openLogicalChannel = SEQ(name='openLogicalChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'OpenLogicalChannel')))
    _RequestMessage_closeLogicalChannel = SEQ(name='closeLogicalChannel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CloseLogicalChannel')))
    _RequestMessage_requestChannelClose = SEQ(name='requestChannelClose', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestChannelClose')))
    _RequestMessage_multiplexEntrySend = SEQ(name='multiplexEntrySend', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexEntrySend')))
    _RequestMessage_requestMultiplexEntry = SEQ(name='requestMultiplexEntry', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMultiplexEntry')))
    _RequestMessage_requestMode = SEQ(name='requestMode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMode')))
    _RequestMessage_roundTripDelayRequest = SEQ(name='roundTripDelayRequest', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RoundTripDelayRequest')))
    _RequestMessage_maintenanceLoopRequest = SEQ(name='maintenanceLoopRequest', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaintenanceLoopRequest')))
    _RequestMessage_communicationModeRequest = SEQ(name='communicationModeRequest', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommunicationModeRequest')))
    _RequestMessage_conferenceRequest = CHOICE(name='conferenceRequest', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConferenceRequest')))
    _RequestMessage_multilinkRequest = CHOICE(name='multilinkRequest', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultilinkRequest')))
    _RequestMessage_logicalChannelRateRequest = SEQ(name='logicalChannelRateRequest', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelRateRequest')))
    _RequestMessage_genericRequest = SEQ(name='genericRequest', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericMessage')))
    RequestMessage._cont = ASN1Dict([
        ('nonStandard', _RequestMessage_nonStandard),
        ('masterSlaveDetermination', _RequestMessage_masterSlaveDetermination),
        ('terminalCapabilitySet', _RequestMessage_terminalCapabilitySet),
        ('openLogicalChannel', _RequestMessage_openLogicalChannel),
        ('closeLogicalChannel', _RequestMessage_closeLogicalChannel),
        ('requestChannelClose', _RequestMessage_requestChannelClose),
        ('multiplexEntrySend', _RequestMessage_multiplexEntrySend),
        ('requestMultiplexEntry', _RequestMessage_requestMultiplexEntry),
        ('requestMode', _RequestMessage_requestMode),
        ('roundTripDelayRequest', _RequestMessage_roundTripDelayRequest),
        ('maintenanceLoopRequest', _RequestMessage_maintenanceLoopRequest),
        ('communicationModeRequest', _RequestMessage_communicationModeRequest),
        ('conferenceRequest', _RequestMessage_conferenceRequest),
        ('multilinkRequest', _RequestMessage_multilinkRequest),
        ('logicalChannelRateRequest', _RequestMessage_logicalChannelRateRequest),
        ('genericRequest', _RequestMessage_genericRequest),
        ])
    RequestMessage._ext = ['communicationModeRequest', 'conferenceRequest', 'multilinkRequest', 'logicalChannelRateRequest', 'genericRequest']
    
    #-----< ResponseMessage >-----#
    ResponseMessage = CHOICE(name='ResponseMessage', mode=MODE_TYPE)
    _ResponseMessage_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _ResponseMessage_masterSlaveDeterminationAck = SEQ(name='masterSlaveDeterminationAck', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MasterSlaveDeterminationAck')))
    _ResponseMessage_masterSlaveDeterminationReject = SEQ(name='masterSlaveDeterminationReject', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MasterSlaveDeterminationReject')))
    _ResponseMessage_terminalCapabilitySetAck = SEQ(name='terminalCapabilitySetAck', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalCapabilitySetAck')))
    _ResponseMessage_terminalCapabilitySetReject = SEQ(name='terminalCapabilitySetReject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalCapabilitySetReject')))
    _ResponseMessage_openLogicalChannelAck = SEQ(name='openLogicalChannelAck', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'OpenLogicalChannelAck')))
    _ResponseMessage_openLogicalChannelReject = SEQ(name='openLogicalChannelReject', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'OpenLogicalChannelReject')))
    _ResponseMessage_closeLogicalChannelAck = SEQ(name='closeLogicalChannelAck', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CloseLogicalChannelAck')))
    _ResponseMessage_requestChannelCloseAck = SEQ(name='requestChannelCloseAck', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestChannelCloseAck')))
    _ResponseMessage_requestChannelCloseReject = SEQ(name='requestChannelCloseReject', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestChannelCloseReject')))
    _ResponseMessage_multiplexEntrySendAck = SEQ(name='multiplexEntrySendAck', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexEntrySendAck')))
    _ResponseMessage_multiplexEntrySendReject = SEQ(name='multiplexEntrySendReject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexEntrySendReject')))
    _ResponseMessage_requestMultiplexEntryAck = SEQ(name='requestMultiplexEntryAck', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMultiplexEntryAck')))
    _ResponseMessage_requestMultiplexEntryReject = SEQ(name='requestMultiplexEntryReject', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMultiplexEntryReject')))
    _ResponseMessage_requestModeAck = SEQ(name='requestModeAck', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestModeAck')))
    _ResponseMessage_requestModeReject = SEQ(name='requestModeReject', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestModeReject')))
    _ResponseMessage_roundTripDelayResponse = SEQ(name='roundTripDelayResponse', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RoundTripDelayResponse')))
    _ResponseMessage_maintenanceLoopAck = SEQ(name='maintenanceLoopAck', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaintenanceLoopAck')))
    _ResponseMessage_maintenanceLoopReject = SEQ(name='maintenanceLoopReject', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaintenanceLoopReject')))
    _ResponseMessage_communicationModeResponse = CHOICE(name='communicationModeResponse', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommunicationModeResponse')))
    _ResponseMessage_conferenceResponse = CHOICE(name='conferenceResponse', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConferenceResponse')))
    _ResponseMessage_multilinkResponse = CHOICE(name='multilinkResponse', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultilinkResponse')))
    _ResponseMessage_logicalChannelRateAcknowledge = SEQ(name='logicalChannelRateAcknowledge', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelRateAcknowledge')))
    _ResponseMessage_logicalChannelRateReject = SEQ(name='logicalChannelRateReject', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelRateReject')))
    _ResponseMessage_genericResponse = SEQ(name='genericResponse', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericMessage')))
    ResponseMessage._cont = ASN1Dict([
        ('nonStandard', _ResponseMessage_nonStandard),
        ('masterSlaveDeterminationAck', _ResponseMessage_masterSlaveDeterminationAck),
        ('masterSlaveDeterminationReject', _ResponseMessage_masterSlaveDeterminationReject),
        ('terminalCapabilitySetAck', _ResponseMessage_terminalCapabilitySetAck),
        ('terminalCapabilitySetReject', _ResponseMessage_terminalCapabilitySetReject),
        ('openLogicalChannelAck', _ResponseMessage_openLogicalChannelAck),
        ('openLogicalChannelReject', _ResponseMessage_openLogicalChannelReject),
        ('closeLogicalChannelAck', _ResponseMessage_closeLogicalChannelAck),
        ('requestChannelCloseAck', _ResponseMessage_requestChannelCloseAck),
        ('requestChannelCloseReject', _ResponseMessage_requestChannelCloseReject),
        ('multiplexEntrySendAck', _ResponseMessage_multiplexEntrySendAck),
        ('multiplexEntrySendReject', _ResponseMessage_multiplexEntrySendReject),
        ('requestMultiplexEntryAck', _ResponseMessage_requestMultiplexEntryAck),
        ('requestMultiplexEntryReject', _ResponseMessage_requestMultiplexEntryReject),
        ('requestModeAck', _ResponseMessage_requestModeAck),
        ('requestModeReject', _ResponseMessage_requestModeReject),
        ('roundTripDelayResponse', _ResponseMessage_roundTripDelayResponse),
        ('maintenanceLoopAck', _ResponseMessage_maintenanceLoopAck),
        ('maintenanceLoopReject', _ResponseMessage_maintenanceLoopReject),
        ('communicationModeResponse', _ResponseMessage_communicationModeResponse),
        ('conferenceResponse', _ResponseMessage_conferenceResponse),
        ('multilinkResponse', _ResponseMessage_multilinkResponse),
        ('logicalChannelRateAcknowledge', _ResponseMessage_logicalChannelRateAcknowledge),
        ('logicalChannelRateReject', _ResponseMessage_logicalChannelRateReject),
        ('genericResponse', _ResponseMessage_genericResponse),
        ])
    ResponseMessage._ext = ['communicationModeResponse', 'conferenceResponse', 'multilinkResponse', 'logicalChannelRateAcknowledge', 'logicalChannelRateReject', 'genericResponse']
    
    #-----< CommandMessage >-----#
    CommandMessage = CHOICE(name='CommandMessage', mode=MODE_TYPE)
    _CommandMessage_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _CommandMessage_maintenanceLoopOffCommand = SEQ(name='maintenanceLoopOffCommand', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaintenanceLoopOffCommand')))
    _CommandMessage_sendTerminalCapabilitySet = CHOICE(name='sendTerminalCapabilitySet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SendTerminalCapabilitySet')))
    _CommandMessage_encryptionCommand = CHOICE(name='encryptionCommand', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionCommand')))
    _CommandMessage_flowControlCommand = SEQ(name='flowControlCommand', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FlowControlCommand')))
    _CommandMessage_endSessionCommand = CHOICE(name='endSessionCommand', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EndSessionCommand')))
    _CommandMessage_miscellaneousCommand = SEQ(name='miscellaneousCommand', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MiscellaneousCommand')))
    _CommandMessage_communicationModeCommand = SEQ(name='communicationModeCommand', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommunicationModeCommand')))
    _CommandMessage_conferenceCommand = CHOICE(name='conferenceCommand', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConferenceCommand')))
    _CommandMessage_h223MultiplexReconfiguration = CHOICE(name='h223MultiplexReconfiguration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223MultiplexReconfiguration')))
    _CommandMessage_newATMVCCommand = SEQ(name='newATMVCCommand', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NewATMVCCommand')))
    _CommandMessage_mobileMultilinkReconfigurationCommand = SEQ(name='mobileMultilinkReconfigurationCommand', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MobileMultilinkReconfigurationCommand')))
    _CommandMessage_genericCommand = SEQ(name='genericCommand', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericMessage')))
    CommandMessage._cont = ASN1Dict([
        ('nonStandard', _CommandMessage_nonStandard),
        ('maintenanceLoopOffCommand', _CommandMessage_maintenanceLoopOffCommand),
        ('sendTerminalCapabilitySet', _CommandMessage_sendTerminalCapabilitySet),
        ('encryptionCommand', _CommandMessage_encryptionCommand),
        ('flowControlCommand', _CommandMessage_flowControlCommand),
        ('endSessionCommand', _CommandMessage_endSessionCommand),
        ('miscellaneousCommand', _CommandMessage_miscellaneousCommand),
        ('communicationModeCommand', _CommandMessage_communicationModeCommand),
        ('conferenceCommand', _CommandMessage_conferenceCommand),
        ('h223MultiplexReconfiguration', _CommandMessage_h223MultiplexReconfiguration),
        ('newATMVCCommand', _CommandMessage_newATMVCCommand),
        ('mobileMultilinkReconfigurationCommand', _CommandMessage_mobileMultilinkReconfigurationCommand),
        ('genericCommand', _CommandMessage_genericCommand),
        ])
    CommandMessage._ext = ['communicationModeCommand', 'conferenceCommand', 'h223MultiplexReconfiguration', 'newATMVCCommand', 'mobileMultilinkReconfigurationCommand', 'genericCommand']
    
    #-----< IndicationMessage >-----#
    IndicationMessage = CHOICE(name='IndicationMessage', mode=MODE_TYPE)
    _IndicationMessage_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _IndicationMessage_functionNotUnderstood = CHOICE(name='functionNotUnderstood', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FunctionNotUnderstood')))
    _IndicationMessage_masterSlaveDeterminationRelease = SEQ(name='masterSlaveDeterminationRelease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MasterSlaveDeterminationRelease')))
    _IndicationMessage_terminalCapabilitySetRelease = SEQ(name='terminalCapabilitySetRelease', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalCapabilitySetRelease')))
    _IndicationMessage_openLogicalChannelConfirm = SEQ(name='openLogicalChannelConfirm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'OpenLogicalChannelConfirm')))
    _IndicationMessage_requestChannelCloseRelease = SEQ(name='requestChannelCloseRelease', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestChannelCloseRelease')))
    _IndicationMessage_multiplexEntrySendRelease = SEQ(name='multiplexEntrySendRelease', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexEntrySendRelease')))
    _IndicationMessage_requestMultiplexEntryRelease = SEQ(name='requestMultiplexEntryRelease', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMultiplexEntryRelease')))
    _IndicationMessage_requestModeRelease = SEQ(name='requestModeRelease', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestModeRelease')))
    _IndicationMessage_miscellaneousIndication = SEQ(name='miscellaneousIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MiscellaneousIndication')))
    _IndicationMessage_jitterIndication = SEQ(name='jitterIndication', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'JitterIndication')))
    _IndicationMessage_h223SkewIndication = SEQ(name='h223SkewIndication', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223SkewIndication')))
    _IndicationMessage_newATMVCIndication = SEQ(name='newATMVCIndication', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NewATMVCIndication')))
    _IndicationMessage_userInput = CHOICE(name='userInput', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'UserInputIndication')))
    _IndicationMessage_h2250MaximumSkewIndication = SEQ(name='h2250MaximumSkewIndication', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250MaximumSkewIndication')))
    _IndicationMessage_mcLocationIndication = SEQ(name='mcLocationIndication', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MCLocationIndication')))
    _IndicationMessage_conferenceIndication = CHOICE(name='conferenceIndication', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConferenceIndication')))
    _IndicationMessage_vendorIdentification = SEQ(name='vendorIdentification', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VendorIdentification')))
    _IndicationMessage_functionNotSupported = SEQ(name='functionNotSupported', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FunctionNotSupported')))
    _IndicationMessage_multilinkIndication = CHOICE(name='multilinkIndication', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultilinkIndication')))
    _IndicationMessage_logicalChannelRateRelease = SEQ(name='logicalChannelRateRelease', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelRateRelease')))
    _IndicationMessage_flowControlIndication = SEQ(name='flowControlIndication', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FlowControlIndication')))
    _IndicationMessage_mobileMultilinkReconfigurationIndication = SEQ(name='mobileMultilinkReconfigurationIndication', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MobileMultilinkReconfigurationIndication')))
    _IndicationMessage_genericIndication = SEQ(name='genericIndication', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericMessage')))
    IndicationMessage._cont = ASN1Dict([
        ('nonStandard', _IndicationMessage_nonStandard),
        ('functionNotUnderstood', _IndicationMessage_functionNotUnderstood),
        ('masterSlaveDeterminationRelease', _IndicationMessage_masterSlaveDeterminationRelease),
        ('terminalCapabilitySetRelease', _IndicationMessage_terminalCapabilitySetRelease),
        ('openLogicalChannelConfirm', _IndicationMessage_openLogicalChannelConfirm),
        ('requestChannelCloseRelease', _IndicationMessage_requestChannelCloseRelease),
        ('multiplexEntrySendRelease', _IndicationMessage_multiplexEntrySendRelease),
        ('requestMultiplexEntryRelease', _IndicationMessage_requestMultiplexEntryRelease),
        ('requestModeRelease', _IndicationMessage_requestModeRelease),
        ('miscellaneousIndication', _IndicationMessage_miscellaneousIndication),
        ('jitterIndication', _IndicationMessage_jitterIndication),
        ('h223SkewIndication', _IndicationMessage_h223SkewIndication),
        ('newATMVCIndication', _IndicationMessage_newATMVCIndication),
        ('userInput', _IndicationMessage_userInput),
        ('h2250MaximumSkewIndication', _IndicationMessage_h2250MaximumSkewIndication),
        ('mcLocationIndication', _IndicationMessage_mcLocationIndication),
        ('conferenceIndication', _IndicationMessage_conferenceIndication),
        ('vendorIdentification', _IndicationMessage_vendorIdentification),
        ('functionNotSupported', _IndicationMessage_functionNotSupported),
        ('multilinkIndication', _IndicationMessage_multilinkIndication),
        ('logicalChannelRateRelease', _IndicationMessage_logicalChannelRateRelease),
        ('flowControlIndication', _IndicationMessage_flowControlIndication),
        ('mobileMultilinkReconfigurationIndication', _IndicationMessage_mobileMultilinkReconfigurationIndication),
        ('genericIndication', _IndicationMessage_genericIndication),
        ])
    IndicationMessage._ext = ['h2250MaximumSkewIndication', 'mcLocationIndication', 'conferenceIndication', 'vendorIdentification', 'functionNotSupported', 'multilinkIndication', 'logicalChannelRateRelease', 'flowControlIndication', 'mobileMultilinkReconfigurationIndication', 'genericIndication']
    
    #-----< SequenceNumber >-----#
    SequenceNumber = INT(name='SequenceNumber', mode=MODE_TYPE)
    SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< GenericMessage >-----#
    GenericMessage = SEQ(name='GenericMessage', mode=MODE_TYPE)
    _GenericMessage_messageIdentifier = CHOICE(name='messageIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityIdentifier')))
    _GenericMessage_subMessageIdentifier = INT(name='subMessageIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericMessage_subMessageIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GenericMessage_messageContent = SEQ_OF(name='messageContent', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GenericMessage_messageContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericParameter')))
    _GenericMessage_messageContent._cont = __GenericMessage_messageContent__item_
    GenericMessage._cont = ASN1Dict([
        ('messageIdentifier', _GenericMessage_messageIdentifier),
        ('subMessageIdentifier', _GenericMessage_subMessageIdentifier),
        ('messageContent', _GenericMessage_messageContent),
        ])
    GenericMessage._ext = []
    
    #-----< GenericInformation >-----#
    GenericInformation = SEQ(name='GenericInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericMessage')))
    
    #-----< NonStandardMessage >-----#
    NonStandardMessage = SEQ(name='NonStandardMessage', mode=MODE_TYPE)
    _NonStandardMessage_nonStandardData = SEQ(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    NonStandardMessage._cont = ASN1Dict([
        ('nonStandardData', _NonStandardMessage_nonStandardData),
        ])
    NonStandardMessage._ext = []
    
    #-----< NonStandardParameter >-----#
    NonStandardParameter = SEQ(name='NonStandardParameter', mode=MODE_TYPE)
    _NonStandardParameter_nonStandardIdentifier = CHOICE(name='nonStandardIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardIdentifier')))
    _NonStandardParameter_data = OCT_STR(name='data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    NonStandardParameter._cont = ASN1Dict([
        ('nonStandardIdentifier', _NonStandardParameter_nonStandardIdentifier),
        ('data', _NonStandardParameter_data),
        ])
    NonStandardParameter._ext = None
    
    #-----< NonStandardIdentifier >-----#
    NonStandardIdentifier = CHOICE(name='NonStandardIdentifier', mode=MODE_TYPE)
    _NonStandardIdentifier_object = OID(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NonStandardIdentifier_h221NonStandard = SEQ(name='h221NonStandard', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NonStandardIdentifier_h221NonStandard_t35CountryCode = INT(name='t35CountryCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NonStandardIdentifier_h221NonStandard_t35CountryCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __NonStandardIdentifier_h221NonStandard_t35Extension = INT(name='t35Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NonStandardIdentifier_h221NonStandard_t35Extension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __NonStandardIdentifier_h221NonStandard_manufacturerCode = INT(name='manufacturerCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NonStandardIdentifier_h221NonStandard_manufacturerCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _NonStandardIdentifier_h221NonStandard._cont = ASN1Dict([
        ('t35CountryCode', __NonStandardIdentifier_h221NonStandard_t35CountryCode),
        ('t35Extension', __NonStandardIdentifier_h221NonStandard_t35Extension),
        ('manufacturerCode', __NonStandardIdentifier_h221NonStandard_manufacturerCode),
        ])
    _NonStandardIdentifier_h221NonStandard._ext = None
    NonStandardIdentifier._cont = ASN1Dict([
        ('object', _NonStandardIdentifier_object),
        ('h221NonStandard', _NonStandardIdentifier_h221NonStandard),
        ])
    NonStandardIdentifier._ext = None
    
    #-----< MasterSlaveDetermination >-----#
    MasterSlaveDetermination = SEQ(name='MasterSlaveDetermination', mode=MODE_TYPE)
    _MasterSlaveDetermination_terminalType = INT(name='terminalType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MasterSlaveDetermination_terminalType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _MasterSlaveDetermination_statusDeterminationNumber = INT(name='statusDeterminationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MasterSlaveDetermination_statusDeterminationNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    MasterSlaveDetermination._cont = ASN1Dict([
        ('terminalType', _MasterSlaveDetermination_terminalType),
        ('statusDeterminationNumber', _MasterSlaveDetermination_statusDeterminationNumber),
        ])
    MasterSlaveDetermination._ext = []
    
    #-----< MasterSlaveDeterminationAck >-----#
    MasterSlaveDeterminationAck = SEQ(name='MasterSlaveDeterminationAck', mode=MODE_TYPE)
    _MasterSlaveDeterminationAck_decision = CHOICE(name='decision', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MasterSlaveDeterminationAck_decision_master = NULL(name='master', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MasterSlaveDeterminationAck_decision_slave = NULL(name='slave', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MasterSlaveDeterminationAck_decision._cont = ASN1Dict([
        ('master', __MasterSlaveDeterminationAck_decision_master),
        ('slave', __MasterSlaveDeterminationAck_decision_slave),
        ])
    _MasterSlaveDeterminationAck_decision._ext = None
    MasterSlaveDeterminationAck._cont = ASN1Dict([
        ('decision', _MasterSlaveDeterminationAck_decision),
        ])
    MasterSlaveDeterminationAck._ext = []
    
    #-----< MasterSlaveDeterminationReject >-----#
    MasterSlaveDeterminationReject = SEQ(name='MasterSlaveDeterminationReject', mode=MODE_TYPE)
    _MasterSlaveDeterminationReject_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MasterSlaveDeterminationReject_cause_identicalNumbers = NULL(name='identicalNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MasterSlaveDeterminationReject_cause._cont = ASN1Dict([
        ('identicalNumbers', __MasterSlaveDeterminationReject_cause_identicalNumbers),
        ])
    _MasterSlaveDeterminationReject_cause._ext = []
    MasterSlaveDeterminationReject._cont = ASN1Dict([
        ('cause', _MasterSlaveDeterminationReject_cause),
        ])
    MasterSlaveDeterminationReject._ext = []
    
    #-----< MasterSlaveDeterminationRelease >-----#
    MasterSlaveDeterminationRelease = SEQ(name='MasterSlaveDeterminationRelease', mode=MODE_TYPE)
    MasterSlaveDeterminationRelease._cont = ASN1Dict([
        ])
    MasterSlaveDeterminationRelease._ext = []
    
    #-----< TerminalCapabilitySet >-----#
    TerminalCapabilitySet = SEQ(name='TerminalCapabilitySet', mode=MODE_TYPE)
    _TerminalCapabilitySet_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _TerminalCapabilitySet_protocolIdentifier = OID(name='protocolIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TerminalCapabilitySet_multiplexCapability = CHOICE(name='multiplexCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexCapability')), opt=True)
    _TerminalCapabilitySet_capabilityTable = SET_OF(name='capabilityTable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TerminalCapabilitySet_capabilityTable__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntry')))
    _TerminalCapabilitySet_capabilityTable._cont = __TerminalCapabilitySet_capabilityTable__item_
    _TerminalCapabilitySet_capabilityTable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TerminalCapabilitySet_capabilityDescriptors = SET_OF(name='capabilityDescriptors', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TerminalCapabilitySet_capabilityDescriptors__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityDescriptor')))
    _TerminalCapabilitySet_capabilityDescriptors._cont = __TerminalCapabilitySet_capabilityDescriptors__item_
    _TerminalCapabilitySet_capabilityDescriptors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TerminalCapabilitySet_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TerminalCapabilitySet_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _TerminalCapabilitySet_genericInformation._cont = __TerminalCapabilitySet_genericInformation__item_
    TerminalCapabilitySet._cont = ASN1Dict([
        ('sequenceNumber', _TerminalCapabilitySet_sequenceNumber),
        ('protocolIdentifier', _TerminalCapabilitySet_protocolIdentifier),
        ('multiplexCapability', _TerminalCapabilitySet_multiplexCapability),
        ('capabilityTable', _TerminalCapabilitySet_capabilityTable),
        ('capabilityDescriptors', _TerminalCapabilitySet_capabilityDescriptors),
        ('genericInformation', _TerminalCapabilitySet_genericInformation),
        ])
    TerminalCapabilitySet._ext = ['genericInformation']
    
    #-----< CapabilityTableEntry >-----#
    CapabilityTableEntry = SEQ(name='CapabilityTableEntry', mode=MODE_TYPE)
    _CapabilityTableEntry_capabilityTableEntryNumber = INT(name='capabilityTableEntryNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    _CapabilityTableEntry_capability = CHOICE(name='capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Capability')), opt=True)
    CapabilityTableEntry._cont = ASN1Dict([
        ('capabilityTableEntryNumber', _CapabilityTableEntry_capabilityTableEntryNumber),
        ('capability', _CapabilityTableEntry_capability),
        ])
    CapabilityTableEntry._ext = None
    
    #-----< CapabilityDescriptor >-----#
    CapabilityDescriptor = SEQ(name='CapabilityDescriptor', mode=MODE_TYPE)
    _CapabilityDescriptor_capabilityDescriptorNumber = INT(name='capabilityDescriptorNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityDescriptorNumber')))
    _CapabilityDescriptor_simultaneousCapabilities = SET_OF(name='simultaneousCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CapabilityDescriptor_simultaneousCapabilities__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AlternativeCapabilitySet')))
    _CapabilityDescriptor_simultaneousCapabilities._cont = __CapabilityDescriptor_simultaneousCapabilities__item_
    _CapabilityDescriptor_simultaneousCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    CapabilityDescriptor._cont = ASN1Dict([
        ('capabilityDescriptorNumber', _CapabilityDescriptor_capabilityDescriptorNumber),
        ('simultaneousCapabilities', _CapabilityDescriptor_simultaneousCapabilities),
        ])
    CapabilityDescriptor._ext = None
    
    #-----< AlternativeCapabilitySet >-----#
    AlternativeCapabilitySet = SEQ_OF(name='AlternativeCapabilitySet', mode=MODE_TYPE)
    _AlternativeCapabilitySet__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    AlternativeCapabilitySet._cont = _AlternativeCapabilitySet__item_
    AlternativeCapabilitySet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CapabilityTableEntryNumber >-----#
    CapabilityTableEntryNumber = INT(name='CapabilityTableEntryNumber', mode=MODE_TYPE)
    CapabilityTableEntryNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CapabilityDescriptorNumber >-----#
    CapabilityDescriptorNumber = INT(name='CapabilityDescriptorNumber', mode=MODE_TYPE)
    CapabilityDescriptorNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TerminalCapabilitySetAck >-----#
    TerminalCapabilitySetAck = SEQ(name='TerminalCapabilitySetAck', mode=MODE_TYPE)
    _TerminalCapabilitySetAck_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _TerminalCapabilitySetAck_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TerminalCapabilitySetAck_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _TerminalCapabilitySetAck_genericInformation._cont = __TerminalCapabilitySetAck_genericInformation__item_
    TerminalCapabilitySetAck._cont = ASN1Dict([
        ('sequenceNumber', _TerminalCapabilitySetAck_sequenceNumber),
        ('genericInformation', _TerminalCapabilitySetAck_genericInformation),
        ])
    TerminalCapabilitySetAck._ext = ['genericInformation']
    
    #-----< TerminalCapabilitySetReject >-----#
    TerminalCapabilitySetReject = SEQ(name='TerminalCapabilitySetReject', mode=MODE_TYPE)
    _TerminalCapabilitySetReject_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _TerminalCapabilitySetReject_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TerminalCapabilitySetReject_cause_unspecified = NULL(name='unspecified', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TerminalCapabilitySetReject_cause_undefinedTableEntryUsed = NULL(name='undefinedTableEntryUsed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TerminalCapabilitySetReject_cause_descriptorCapacityExceeded = NULL(name='descriptorCapacityExceeded', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded = CHOICE(name='tableEntryCapacityExceeded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded_highestEntryNumberProcessed = INT(name='highestEntryNumberProcessed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    ___TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded_noneProcessed = NULL(name='noneProcessed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded._cont = ASN1Dict([
        ('highestEntryNumberProcessed', ___TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded_highestEntryNumberProcessed),
        ('noneProcessed', ___TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded_noneProcessed),
        ])
    __TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded._ext = None
    _TerminalCapabilitySetReject_cause._cont = ASN1Dict([
        ('unspecified', __TerminalCapabilitySetReject_cause_unspecified),
        ('undefinedTableEntryUsed', __TerminalCapabilitySetReject_cause_undefinedTableEntryUsed),
        ('descriptorCapacityExceeded', __TerminalCapabilitySetReject_cause_descriptorCapacityExceeded),
        ('tableEntryCapacityExceeded', __TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded),
        ])
    _TerminalCapabilitySetReject_cause._ext = []
    _TerminalCapabilitySetReject_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TerminalCapabilitySetReject_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _TerminalCapabilitySetReject_genericInformation._cont = __TerminalCapabilitySetReject_genericInformation__item_
    TerminalCapabilitySetReject._cont = ASN1Dict([
        ('sequenceNumber', _TerminalCapabilitySetReject_sequenceNumber),
        ('cause', _TerminalCapabilitySetReject_cause),
        ('genericInformation', _TerminalCapabilitySetReject_genericInformation),
        ])
    TerminalCapabilitySetReject._ext = ['genericInformation']
    
    #-----< TerminalCapabilitySetRelease >-----#
    TerminalCapabilitySetRelease = SEQ(name='TerminalCapabilitySetRelease', mode=MODE_TYPE)
    _TerminalCapabilitySetRelease_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TerminalCapabilitySetRelease_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _TerminalCapabilitySetRelease_genericInformation._cont = __TerminalCapabilitySetRelease_genericInformation__item_
    TerminalCapabilitySetRelease._cont = ASN1Dict([
        ('genericInformation', _TerminalCapabilitySetRelease_genericInformation),
        ])
    TerminalCapabilitySetRelease._ext = ['genericInformation']
    
    #-----< Capability >-----#
    Capability = CHOICE(name='Capability', mode=MODE_TYPE)
    _Capability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _Capability_receiveVideoCapability = CHOICE(name='receiveVideoCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    _Capability_transmitVideoCapability = CHOICE(name='transmitVideoCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    _Capability_receiveAndTransmitVideoCapability = CHOICE(name='receiveAndTransmitVideoCapability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    _Capability_receiveAudioCapability = CHOICE(name='receiveAudioCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    _Capability_transmitAudioCapability = CHOICE(name='transmitAudioCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    _Capability_receiveAndTransmitAudioCapability = CHOICE(name='receiveAndTransmitAudioCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    _Capability_receiveDataApplicationCapability = SEQ(name='receiveDataApplicationCapability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _Capability_transmitDataApplicationCapability = SEQ(name='transmitDataApplicationCapability', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _Capability_receiveAndTransmitDataApplicationCapability = SEQ(name='receiveAndTransmitDataApplicationCapability', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _Capability_h233EncryptionTransmitCapability = BOOL(name='h233EncryptionTransmitCapability', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Capability_h233EncryptionReceiveCapability = SEQ(name='h233EncryptionReceiveCapability', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Capability_h233EncryptionReceiveCapability_h233IVResponseTime = INT(name='h233IVResponseTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Capability_h233EncryptionReceiveCapability_h233IVResponseTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _Capability_h233EncryptionReceiveCapability._cont = ASN1Dict([
        ('h233IVResponseTime', __Capability_h233EncryptionReceiveCapability_h233IVResponseTime),
        ])
    _Capability_h233EncryptionReceiveCapability._ext = []
    _Capability_conferenceCapability = SEQ(name='conferenceCapability', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConferenceCapability')))
    _Capability_h235SecurityCapability = SEQ(name='h235SecurityCapability', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H235SecurityCapability')))
    _Capability_maxPendingReplacementFor = INT(name='maxPendingReplacementFor', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Capability_maxPendingReplacementFor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _Capability_receiveUserInputCapability = CHOICE(name='receiveUserInputCapability', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'UserInputCapability')))
    _Capability_transmitUserInputCapability = CHOICE(name='transmitUserInputCapability', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'UserInputCapability')))
    _Capability_receiveAndTransmitUserInputCapability = CHOICE(name='receiveAndTransmitUserInputCapability', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'UserInputCapability')))
    _Capability_genericControlCapability = SEQ(name='genericControlCapability', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _Capability_receiveMultiplexedStreamCapability = SEQ(name='receiveMultiplexedStreamCapability', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexedStreamCapability')))
    _Capability_transmitMultiplexedStreamCapability = SEQ(name='transmitMultiplexedStreamCapability', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexedStreamCapability')))
    _Capability_receiveAndTransmitMultiplexedStreamCapability = SEQ(name='receiveAndTransmitMultiplexedStreamCapability', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexedStreamCapability')))
    _Capability_receiveRTPAudioTelephonyEventCapability = SEQ(name='receiveRTPAudioTelephonyEventCapability', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioTelephonyEventCapability')))
    _Capability_receiveRTPAudioToneCapability = SEQ(name='receiveRTPAudioToneCapability', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioToneCapability')))
    _Capability_depFecCapability = CHOICE(name='depFecCapability', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DepFECCapability')))
    _Capability_multiplePayloadStreamCapability = SEQ(name='multiplePayloadStreamCapability', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStreamCapability')))
    _Capability_fecCapability = SEQ(name='fecCapability', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FECCapability')))
    _Capability_redundancyEncodingCap = SEQ(name='redundancyEncodingCap', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingCapability')))
    _Capability_oneOfCapabilities = SEQ_OF(name='oneOfCapabilities', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AlternativeCapabilitySet')))
    Capability._cont = ASN1Dict([
        ('nonStandard', _Capability_nonStandard),
        ('receiveVideoCapability', _Capability_receiveVideoCapability),
        ('transmitVideoCapability', _Capability_transmitVideoCapability),
        ('receiveAndTransmitVideoCapability', _Capability_receiveAndTransmitVideoCapability),
        ('receiveAudioCapability', _Capability_receiveAudioCapability),
        ('transmitAudioCapability', _Capability_transmitAudioCapability),
        ('receiveAndTransmitAudioCapability', _Capability_receiveAndTransmitAudioCapability),
        ('receiveDataApplicationCapability', _Capability_receiveDataApplicationCapability),
        ('transmitDataApplicationCapability', _Capability_transmitDataApplicationCapability),
        ('receiveAndTransmitDataApplicationCapability', _Capability_receiveAndTransmitDataApplicationCapability),
        ('h233EncryptionTransmitCapability', _Capability_h233EncryptionTransmitCapability),
        ('h233EncryptionReceiveCapability', _Capability_h233EncryptionReceiveCapability),
        ('conferenceCapability', _Capability_conferenceCapability),
        ('h235SecurityCapability', _Capability_h235SecurityCapability),
        ('maxPendingReplacementFor', _Capability_maxPendingReplacementFor),
        ('receiveUserInputCapability', _Capability_receiveUserInputCapability),
        ('transmitUserInputCapability', _Capability_transmitUserInputCapability),
        ('receiveAndTransmitUserInputCapability', _Capability_receiveAndTransmitUserInputCapability),
        ('genericControlCapability', _Capability_genericControlCapability),
        ('receiveMultiplexedStreamCapability', _Capability_receiveMultiplexedStreamCapability),
        ('transmitMultiplexedStreamCapability', _Capability_transmitMultiplexedStreamCapability),
        ('receiveAndTransmitMultiplexedStreamCapability', _Capability_receiveAndTransmitMultiplexedStreamCapability),
        ('receiveRTPAudioTelephonyEventCapability', _Capability_receiveRTPAudioTelephonyEventCapability),
        ('receiveRTPAudioToneCapability', _Capability_receiveRTPAudioToneCapability),
        ('depFecCapability', _Capability_depFecCapability),
        ('multiplePayloadStreamCapability', _Capability_multiplePayloadStreamCapability),
        ('fecCapability', _Capability_fecCapability),
        ('redundancyEncodingCap', _Capability_redundancyEncodingCap),
        ('oneOfCapabilities', _Capability_oneOfCapabilities),
        ])
    Capability._ext = ['conferenceCapability', 'h235SecurityCapability', 'maxPendingReplacementFor', 'receiveUserInputCapability', 'transmitUserInputCapability', 'receiveAndTransmitUserInputCapability', 'genericControlCapability', 'receiveMultiplexedStreamCapability', 'transmitMultiplexedStreamCapability', 'receiveAndTransmitMultiplexedStreamCapability', 'receiveRTPAudioTelephonyEventCapability', 'receiveRTPAudioToneCapability', 'depFecCapability', 'multiplePayloadStreamCapability', 'fecCapability', 'redundancyEncodingCap', 'oneOfCapabilities']
    
    #-----< H235SecurityCapability >-----#
    H235SecurityCapability = SEQ(name='H235SecurityCapability', mode=MODE_TYPE)
    _H235SecurityCapability_encryptionAuthenticationAndIntegrity = SEQ(name='encryptionAuthenticationAndIntegrity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionAuthenticationAndIntegrity')))
    _H235SecurityCapability_mediaCapability = INT(name='mediaCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    H235SecurityCapability._cont = ASN1Dict([
        ('encryptionAuthenticationAndIntegrity', _H235SecurityCapability_encryptionAuthenticationAndIntegrity),
        ('mediaCapability', _H235SecurityCapability_mediaCapability),
        ])
    H235SecurityCapability._ext = []
    
    #-----< MultiplexCapability >-----#
    MultiplexCapability = CHOICE(name='MultiplexCapability', mode=MODE_TYPE)
    _MultiplexCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _MultiplexCapability_h222Capability = SEQ(name='h222Capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H222Capability')))
    _MultiplexCapability_h223Capability = SEQ(name='h223Capability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223Capability')))
    _MultiplexCapability_v76Capability = SEQ(name='v76Capability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V76Capability')))
    _MultiplexCapability_h2250Capability = SEQ(name='h2250Capability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250Capability')))
    _MultiplexCapability_genericMultiplexCapability = SEQ(name='genericMultiplexCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    MultiplexCapability._cont = ASN1Dict([
        ('nonStandard', _MultiplexCapability_nonStandard),
        ('h222Capability', _MultiplexCapability_h222Capability),
        ('h223Capability', _MultiplexCapability_h223Capability),
        ('v76Capability', _MultiplexCapability_v76Capability),
        ('h2250Capability', _MultiplexCapability_h2250Capability),
        ('genericMultiplexCapability', _MultiplexCapability_genericMultiplexCapability),
        ])
    MultiplexCapability._ext = ['h2250Capability', 'genericMultiplexCapability']
    
    #-----< H222Capability >-----#
    H222Capability = SEQ(name='H222Capability', mode=MODE_TYPE)
    _H222Capability_numberOfVCs = INT(name='numberOfVCs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H222Capability_numberOfVCs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _H222Capability_vcCapability = SET_OF(name='vcCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H222Capability_vcCapability__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VCCapability')))
    _H222Capability_vcCapability._cont = __H222Capability_vcCapability__item_
    H222Capability._cont = ASN1Dict([
        ('numberOfVCs', _H222Capability_numberOfVCs),
        ('vcCapability', _H222Capability_vcCapability),
        ])
    H222Capability._ext = []
    
    #-----< VCCapability >-----#
    VCCapability = SEQ(name='VCCapability', mode=MODE_TYPE)
    _VCCapability_aal1 = SEQ(name='aal1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __VCCapability_aal1_nullClockRecovery = BOOL(name='nullClockRecovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_srtsClockRecovery = BOOL(name='srtsClockRecovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_adaptiveClockRecovery = BOOL(name='adaptiveClockRecovery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_nullErrorCorrection = BOOL(name='nullErrorCorrection', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_longInterleaver = BOOL(name='longInterleaver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_shortInterleaver = BOOL(name='shortInterleaver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_errorCorrectionOnly = BOOL(name='errorCorrectionOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_structuredDataTransfer = BOOL(name='structuredDataTransfer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1_partiallyFilledCells = BOOL(name='partiallyFilledCells', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VCCapability_aal1._cont = ASN1Dict([
        ('nullClockRecovery', __VCCapability_aal1_nullClockRecovery),
        ('srtsClockRecovery', __VCCapability_aal1_srtsClockRecovery),
        ('adaptiveClockRecovery', __VCCapability_aal1_adaptiveClockRecovery),
        ('nullErrorCorrection', __VCCapability_aal1_nullErrorCorrection),
        ('longInterleaver', __VCCapability_aal1_longInterleaver),
        ('shortInterleaver', __VCCapability_aal1_shortInterleaver),
        ('errorCorrectionOnly', __VCCapability_aal1_errorCorrectionOnly),
        ('structuredDataTransfer', __VCCapability_aal1_structuredDataTransfer),
        ('partiallyFilledCells', __VCCapability_aal1_partiallyFilledCells),
        ])
    _VCCapability_aal1._ext = []
    _VCCapability_aal5 = SEQ(name='aal5', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __VCCapability_aal5_forwardMaximumSDUSize = INT(name='forwardMaximumSDUSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal5_forwardMaximumSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __VCCapability_aal5_backwardMaximumSDUSize = INT(name='backwardMaximumSDUSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal5_backwardMaximumSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _VCCapability_aal5._cont = ASN1Dict([
        ('forwardMaximumSDUSize', __VCCapability_aal5_forwardMaximumSDUSize),
        ('backwardMaximumSDUSize', __VCCapability_aal5_backwardMaximumSDUSize),
        ])
    _VCCapability_aal5._ext = []
    _VCCapability_transportStream = BOOL(name='transportStream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VCCapability_programStream = BOOL(name='programStream', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VCCapability_availableBitRates = SEQ(name='availableBitRates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_availableBitRates_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___VCCapability_availableBitRates_type_singleBitRate = INT(name='singleBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___VCCapability_availableBitRates_type_singleBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ___VCCapability_availableBitRates_type_rangeOfBitRates = SEQ(name='rangeOfBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____VCCapability_availableBitRates_type_rangeOfBitRates_lowerBitRate = INT(name='lowerBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____VCCapability_availableBitRates_type_rangeOfBitRates_lowerBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ____VCCapability_availableBitRates_type_rangeOfBitRates_higherBitRate = INT(name='higherBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____VCCapability_availableBitRates_type_rangeOfBitRates_higherBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ___VCCapability_availableBitRates_type_rangeOfBitRates._cont = ASN1Dict([
        ('lowerBitRate', ____VCCapability_availableBitRates_type_rangeOfBitRates_lowerBitRate),
        ('higherBitRate', ____VCCapability_availableBitRates_type_rangeOfBitRates_higherBitRate),
        ])
    ___VCCapability_availableBitRates_type_rangeOfBitRates._ext = None
    __VCCapability_availableBitRates_type._cont = ASN1Dict([
        ('singleBitRate', ___VCCapability_availableBitRates_type_singleBitRate),
        ('rangeOfBitRates', ___VCCapability_availableBitRates_type_rangeOfBitRates),
        ])
    __VCCapability_availableBitRates_type._ext = None
    _VCCapability_availableBitRates._cont = ASN1Dict([
        ('type', __VCCapability_availableBitRates_type),
        ])
    _VCCapability_availableBitRates._ext = []
    _VCCapability_aal1ViaGateway = SEQ(name='aal1ViaGateway', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __VCCapability_aal1ViaGateway_gatewayAddress = SET_OF(name='gatewayAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___VCCapability_aal1ViaGateway_gatewayAddress__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Q2931Address')))
    __VCCapability_aal1ViaGateway_gatewayAddress._cont = ___VCCapability_aal1ViaGateway_gatewayAddress__item_
    __VCCapability_aal1ViaGateway_gatewayAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __VCCapability_aal1ViaGateway_nullClockRecovery = BOOL(name='nullClockRecovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_srtsClockRecovery = BOOL(name='srtsClockRecovery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_adaptiveClockRecovery = BOOL(name='adaptiveClockRecovery', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_nullErrorCorrection = BOOL(name='nullErrorCorrection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_longInterleaver = BOOL(name='longInterleaver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_shortInterleaver = BOOL(name='shortInterleaver', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_errorCorrectionOnly = BOOL(name='errorCorrectionOnly', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_structuredDataTransfer = BOOL(name='structuredDataTransfer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __VCCapability_aal1ViaGateway_partiallyFilledCells = BOOL(name='partiallyFilledCells', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VCCapability_aal1ViaGateway._cont = ASN1Dict([
        ('gatewayAddress', __VCCapability_aal1ViaGateway_gatewayAddress),
        ('nullClockRecovery', __VCCapability_aal1ViaGateway_nullClockRecovery),
        ('srtsClockRecovery', __VCCapability_aal1ViaGateway_srtsClockRecovery),
        ('adaptiveClockRecovery', __VCCapability_aal1ViaGateway_adaptiveClockRecovery),
        ('nullErrorCorrection', __VCCapability_aal1ViaGateway_nullErrorCorrection),
        ('longInterleaver', __VCCapability_aal1ViaGateway_longInterleaver),
        ('shortInterleaver', __VCCapability_aal1ViaGateway_shortInterleaver),
        ('errorCorrectionOnly', __VCCapability_aal1ViaGateway_errorCorrectionOnly),
        ('structuredDataTransfer', __VCCapability_aal1ViaGateway_structuredDataTransfer),
        ('partiallyFilledCells', __VCCapability_aal1ViaGateway_partiallyFilledCells),
        ])
    _VCCapability_aal1ViaGateway._ext = []
    VCCapability._cont = ASN1Dict([
        ('aal1', _VCCapability_aal1),
        ('aal5', _VCCapability_aal5),
        ('transportStream', _VCCapability_transportStream),
        ('programStream', _VCCapability_programStream),
        ('availableBitRates', _VCCapability_availableBitRates),
        ('aal1ViaGateway', _VCCapability_aal1ViaGateway),
        ])
    VCCapability._ext = ['aal1ViaGateway']
    
    #-----< H223Capability >-----#
    H223Capability = SEQ(name='H223Capability', mode=MODE_TYPE)
    _H223Capability_transportWithI_frames = BOOL(name='transportWithI-frames', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_videoWithAL1 = BOOL(name='videoWithAL1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_videoWithAL2 = BOOL(name='videoWithAL2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_videoWithAL3 = BOOL(name='videoWithAL3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_audioWithAL1 = BOOL(name='audioWithAL1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_audioWithAL2 = BOOL(name='audioWithAL2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_audioWithAL3 = BOOL(name='audioWithAL3', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_dataWithAL1 = BOOL(name='dataWithAL1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_dataWithAL2 = BOOL(name='dataWithAL2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_dataWithAL3 = BOOL(name='dataWithAL3', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_maximumAl2SDUSize = INT(name='maximumAl2SDUSize', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_maximumAl2SDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H223Capability_maximumAl3SDUSize = INT(name='maximumAl3SDUSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_maximumAl3SDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H223Capability_maximumDelayJitter = INT(name='maximumDelayJitter', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_maximumDelayJitter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _H223Capability_h223MultiplexTableCapability = CHOICE(name='h223MultiplexTableCapability', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223Capability_h223MultiplexTableCapability_basic = NULL(name='basic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_h223MultiplexTableCapability_enhanced = SEQ(name='enhanced', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223Capability_h223MultiplexTableCapability_enhanced_maximumNestingDepth = INT(name='maximumNestingDepth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223Capability_h223MultiplexTableCapability_enhanced_maximumNestingDepth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    ___H223Capability_h223MultiplexTableCapability_enhanced_maximumElementListSize = INT(name='maximumElementListSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223Capability_h223MultiplexTableCapability_enhanced_maximumElementListSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=255)], ev=None, er=[])
    ___H223Capability_h223MultiplexTableCapability_enhanced_maximumSubElementListSize = INT(name='maximumSubElementListSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223Capability_h223MultiplexTableCapability_enhanced_maximumSubElementListSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=255)], ev=None, er=[])
    __H223Capability_h223MultiplexTableCapability_enhanced._cont = ASN1Dict([
        ('maximumNestingDepth', ___H223Capability_h223MultiplexTableCapability_enhanced_maximumNestingDepth),
        ('maximumElementListSize', ___H223Capability_h223MultiplexTableCapability_enhanced_maximumElementListSize),
        ('maximumSubElementListSize', ___H223Capability_h223MultiplexTableCapability_enhanced_maximumSubElementListSize),
        ])
    __H223Capability_h223MultiplexTableCapability_enhanced._ext = []
    _H223Capability_h223MultiplexTableCapability._cont = ASN1Dict([
        ('basic', __H223Capability_h223MultiplexTableCapability_basic),
        ('enhanced', __H223Capability_h223MultiplexTableCapability_enhanced),
        ])
    _H223Capability_h223MultiplexTableCapability._ext = None
    _H223Capability_maxMUXPDUSizeCapability = BOOL(name='maxMUXPDUSizeCapability', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_nsrpSupport = BOOL(name='nsrpSupport', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_mobileOperationTransmitCapability = SEQ(name='mobileOperationTransmitCapability', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H223Capability_mobileOperationTransmitCapability_modeChangeCapability = BOOL(name='modeChangeCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_mobileOperationTransmitCapability_h223AnnexA = BOOL(name='h223AnnexA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_mobileOperationTransmitCapability_h223AnnexADoubleFlag = BOOL(name='h223AnnexADoubleFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_mobileOperationTransmitCapability_h223AnnexB = BOOL(name='h223AnnexB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_mobileOperationTransmitCapability_h223AnnexBwithHeader = BOOL(name='h223AnnexBwithHeader', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223Capability_mobileOperationTransmitCapability._cont = ASN1Dict([
        ('modeChangeCapability', __H223Capability_mobileOperationTransmitCapability_modeChangeCapability),
        ('h223AnnexA', __H223Capability_mobileOperationTransmitCapability_h223AnnexA),
        ('h223AnnexADoubleFlag', __H223Capability_mobileOperationTransmitCapability_h223AnnexADoubleFlag),
        ('h223AnnexB', __H223Capability_mobileOperationTransmitCapability_h223AnnexB),
        ('h223AnnexBwithHeader', __H223Capability_mobileOperationTransmitCapability_h223AnnexBwithHeader),
        ])
    _H223Capability_mobileOperationTransmitCapability._ext = []
    _H223Capability_h223AnnexCCapability = SEQ(name='h223AnnexCCapability', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AnnexCCapability')), opt=True)
    _H223Capability_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H223Capability_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=19200)], ev=None, er=[])
    _H223Capability_mobileMultilinkFrameCapability = SEQ(name='mobileMultilinkFrameCapability', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H223Capability_mobileMultilinkFrameCapability_maximumSampleSize = INT(name='maximumSampleSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_mobileMultilinkFrameCapability_maximumSampleSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    __H223Capability_mobileMultilinkFrameCapability_maximumPayloadLength = INT(name='maximumPayloadLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223Capability_mobileMultilinkFrameCapability_maximumPayloadLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65025)], ev=None, er=[])
    _H223Capability_mobileMultilinkFrameCapability._cont = ASN1Dict([
        ('maximumSampleSize', __H223Capability_mobileMultilinkFrameCapability_maximumSampleSize),
        ('maximumPayloadLength', __H223Capability_mobileMultilinkFrameCapability_maximumPayloadLength),
        ])
    _H223Capability_mobileMultilinkFrameCapability._ext = []
    H223Capability._cont = ASN1Dict([
        ('transportWithI-frames', _H223Capability_transportWithI_frames),
        ('videoWithAL1', _H223Capability_videoWithAL1),
        ('videoWithAL2', _H223Capability_videoWithAL2),
        ('videoWithAL3', _H223Capability_videoWithAL3),
        ('audioWithAL1', _H223Capability_audioWithAL1),
        ('audioWithAL2', _H223Capability_audioWithAL2),
        ('audioWithAL3', _H223Capability_audioWithAL3),
        ('dataWithAL1', _H223Capability_dataWithAL1),
        ('dataWithAL2', _H223Capability_dataWithAL2),
        ('dataWithAL3', _H223Capability_dataWithAL3),
        ('maximumAl2SDUSize', _H223Capability_maximumAl2SDUSize),
        ('maximumAl3SDUSize', _H223Capability_maximumAl3SDUSize),
        ('maximumDelayJitter', _H223Capability_maximumDelayJitter),
        ('h223MultiplexTableCapability', _H223Capability_h223MultiplexTableCapability),
        ('maxMUXPDUSizeCapability', _H223Capability_maxMUXPDUSizeCapability),
        ('nsrpSupport', _H223Capability_nsrpSupport),
        ('mobileOperationTransmitCapability', _H223Capability_mobileOperationTransmitCapability),
        ('h223AnnexCCapability', _H223Capability_h223AnnexCCapability),
        ('bitRate', _H223Capability_bitRate),
        ('mobileMultilinkFrameCapability', _H223Capability_mobileMultilinkFrameCapability),
        ])
    H223Capability._ext = ['maxMUXPDUSizeCapability', 'nsrpSupport', 'mobileOperationTransmitCapability', 'h223AnnexCCapability', 'bitRate', 'mobileMultilinkFrameCapability']
    
    #-----< H223AnnexCCapability >-----#
    H223AnnexCCapability = SEQ(name='H223AnnexCCapability', mode=MODE_TYPE)
    _H223AnnexCCapability_videoWithAL1M = BOOL(name='videoWithAL1M', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_videoWithAL2M = BOOL(name='videoWithAL2M', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_videoWithAL3M = BOOL(name='videoWithAL3M', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_audioWithAL1M = BOOL(name='audioWithAL1M', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_audioWithAL2M = BOOL(name='audioWithAL2M', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_audioWithAL3M = BOOL(name='audioWithAL3M', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_dataWithAL1M = BOOL(name='dataWithAL1M', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_dataWithAL2M = BOOL(name='dataWithAL2M', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_dataWithAL3M = BOOL(name='dataWithAL3M', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_alpduInterleaving = BOOL(name='alpduInterleaving', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_maximumAL1MPDUSize = INT(name='maximumAL1MPDUSize', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_maximumAL1MPDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H223AnnexCCapability_maximumAL2MSDUSize = INT(name='maximumAL2MSDUSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_maximumAL2MSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H223AnnexCCapability_maximumAL3MSDUSize = INT(name='maximumAL3MSDUSize', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCCapability_maximumAL3MSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H223AnnexCCapability_rsCodeCapability = BOOL(name='rsCodeCapability', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    H223AnnexCCapability._cont = ASN1Dict([
        ('videoWithAL1M', _H223AnnexCCapability_videoWithAL1M),
        ('videoWithAL2M', _H223AnnexCCapability_videoWithAL2M),
        ('videoWithAL3M', _H223AnnexCCapability_videoWithAL3M),
        ('audioWithAL1M', _H223AnnexCCapability_audioWithAL1M),
        ('audioWithAL2M', _H223AnnexCCapability_audioWithAL2M),
        ('audioWithAL3M', _H223AnnexCCapability_audioWithAL3M),
        ('dataWithAL1M', _H223AnnexCCapability_dataWithAL1M),
        ('dataWithAL2M', _H223AnnexCCapability_dataWithAL2M),
        ('dataWithAL3M', _H223AnnexCCapability_dataWithAL3M),
        ('alpduInterleaving', _H223AnnexCCapability_alpduInterleaving),
        ('maximumAL1MPDUSize', _H223AnnexCCapability_maximumAL1MPDUSize),
        ('maximumAL2MSDUSize', _H223AnnexCCapability_maximumAL2MSDUSize),
        ('maximumAL3MSDUSize', _H223AnnexCCapability_maximumAL3MSDUSize),
        ('rsCodeCapability', _H223AnnexCCapability_rsCodeCapability),
        ])
    H223AnnexCCapability._ext = ['rsCodeCapability']
    
    #-----< V76Capability >-----#
    V76Capability = SEQ(name='V76Capability', mode=MODE_TYPE)
    _V76Capability_suspendResumeCapabilitywAddress = BOOL(name='suspendResumeCapabilitywAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_suspendResumeCapabilitywoAddress = BOOL(name='suspendResumeCapabilitywoAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_rejCapability = BOOL(name='rejCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_sREJCapability = BOOL(name='sREJCapability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_mREJCapability = BOOL(name='mREJCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_crc8bitCapability = BOOL(name='crc8bitCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_crc16bitCapability = BOOL(name='crc16bitCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_crc32bitCapability = BOOL(name='crc32bitCapability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_uihCapability = BOOL(name='uihCapability', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_numOfDLCS = INT(name='numOfDLCS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_numOfDLCS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8191)], ev=None, er=[])
    _V76Capability_twoOctetAddressFieldCapability = BOOL(name='twoOctetAddressFieldCapability', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_loopBackTestCapability = BOOL(name='loopBackTestCapability', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_n401Capability = INT(name='n401Capability', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_n401Capability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=None, er=[])
    _V76Capability_maxWindowSizeCapability = INT(name='maxWindowSizeCapability', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76Capability_maxWindowSizeCapability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _V76Capability_v75Capability = SEQ(name='v75Capability', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V75Capability')))
    V76Capability._cont = ASN1Dict([
        ('suspendResumeCapabilitywAddress', _V76Capability_suspendResumeCapabilitywAddress),
        ('suspendResumeCapabilitywoAddress', _V76Capability_suspendResumeCapabilitywoAddress),
        ('rejCapability', _V76Capability_rejCapability),
        ('sREJCapability', _V76Capability_sREJCapability),
        ('mREJCapability', _V76Capability_mREJCapability),
        ('crc8bitCapability', _V76Capability_crc8bitCapability),
        ('crc16bitCapability', _V76Capability_crc16bitCapability),
        ('crc32bitCapability', _V76Capability_crc32bitCapability),
        ('uihCapability', _V76Capability_uihCapability),
        ('numOfDLCS', _V76Capability_numOfDLCS),
        ('twoOctetAddressFieldCapability', _V76Capability_twoOctetAddressFieldCapability),
        ('loopBackTestCapability', _V76Capability_loopBackTestCapability),
        ('n401Capability', _V76Capability_n401Capability),
        ('maxWindowSizeCapability', _V76Capability_maxWindowSizeCapability),
        ('v75Capability', _V76Capability_v75Capability),
        ])
    V76Capability._ext = []
    
    #-----< V75Capability >-----#
    V75Capability = SEQ(name='V75Capability', mode=MODE_TYPE)
    _V75Capability_audioHeader = BOOL(name='audioHeader', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    V75Capability._cont = ASN1Dict([
        ('audioHeader', _V75Capability_audioHeader),
        ])
    V75Capability._ext = []
    
    #-----< H2250Capability >-----#
    H2250Capability = SEQ(name='H2250Capability', mode=MODE_TYPE)
    _H2250Capability_maximumAudioDelayJitter = INT(name='maximumAudioDelayJitter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250Capability_maximumAudioDelayJitter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _H2250Capability_receiveMultipointCapability = SEQ(name='receiveMultipointCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultipointCapability')))
    _H2250Capability_transmitMultipointCapability = SEQ(name='transmitMultipointCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultipointCapability')))
    _H2250Capability_receiveAndTransmitMultipointCapability = SEQ(name='receiveAndTransmitMultipointCapability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultipointCapability')))
    _H2250Capability_mcCapability = SEQ(name='mcCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H2250Capability_mcCapability_centralizedConferenceMC = BOOL(name='centralizedConferenceMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H2250Capability_mcCapability_decentralizedConferenceMC = BOOL(name='decentralizedConferenceMC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250Capability_mcCapability._cont = ASN1Dict([
        ('centralizedConferenceMC', __H2250Capability_mcCapability_centralizedConferenceMC),
        ('decentralizedConferenceMC', __H2250Capability_mcCapability_decentralizedConferenceMC),
        ])
    _H2250Capability_mcCapability._ext = []
    _H2250Capability_rtcpVideoControlCapability = BOOL(name='rtcpVideoControlCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250Capability_mediaPacketizationCapability = SEQ(name='mediaPacketizationCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MediaPacketizationCapability')))
    _H2250Capability_transportCapability = SEQ(name='transportCapability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportCapability')), opt=True)
    _H2250Capability_redundancyEncodingCapability = SEQ_OF(name='redundancyEncodingCapability', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H2250Capability_redundancyEncodingCapability__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingCapability')))
    _H2250Capability_redundancyEncodingCapability._cont = __H2250Capability_redundancyEncodingCapability__item_
    _H2250Capability_redundancyEncodingCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _H2250Capability_logicalChannelSwitchingCapability = BOOL(name='logicalChannelSwitchingCapability', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250Capability_t120DynamicPortCapability = BOOL(name='t120DynamicPortCapability', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H2250Capability._cont = ASN1Dict([
        ('maximumAudioDelayJitter', _H2250Capability_maximumAudioDelayJitter),
        ('receiveMultipointCapability', _H2250Capability_receiveMultipointCapability),
        ('transmitMultipointCapability', _H2250Capability_transmitMultipointCapability),
        ('receiveAndTransmitMultipointCapability', _H2250Capability_receiveAndTransmitMultipointCapability),
        ('mcCapability', _H2250Capability_mcCapability),
        ('rtcpVideoControlCapability', _H2250Capability_rtcpVideoControlCapability),
        ('mediaPacketizationCapability', _H2250Capability_mediaPacketizationCapability),
        ('transportCapability', _H2250Capability_transportCapability),
        ('redundancyEncodingCapability', _H2250Capability_redundancyEncodingCapability),
        ('logicalChannelSwitchingCapability', _H2250Capability_logicalChannelSwitchingCapability),
        ('t120DynamicPortCapability', _H2250Capability_t120DynamicPortCapability),
        ])
    H2250Capability._ext = ['transportCapability', 'redundancyEncodingCapability', 'logicalChannelSwitchingCapability', 't120DynamicPortCapability']
    
    #-----< MediaPacketizationCapability >-----#
    MediaPacketizationCapability = SEQ(name='MediaPacketizationCapability', mode=MODE_TYPE)
    _MediaPacketizationCapability_h261aVideoPacketization = BOOL(name='h261aVideoPacketization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaPacketizationCapability_rtpPayloadType = SEQ_OF(name='rtpPayloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MediaPacketizationCapability_rtpPayloadType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RTPPayloadType')))
    _MediaPacketizationCapability_rtpPayloadType._cont = __MediaPacketizationCapability_rtpPayloadType__item_
    _MediaPacketizationCapability_rtpPayloadType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MediaPacketizationCapability._cont = ASN1Dict([
        ('h261aVideoPacketization', _MediaPacketizationCapability_h261aVideoPacketization),
        ('rtpPayloadType', _MediaPacketizationCapability_rtpPayloadType),
        ])
    MediaPacketizationCapability._ext = ['rtpPayloadType']
    
    #-----< RSVPParameters >-----#
    RSVPParameters = SEQ(name='RSVPParameters', mode=MODE_TYPE)
    _RSVPParameters_qosMode = CHOICE(name='qosMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'QOSMode')), opt=True)
    _RSVPParameters_tokenRate = INT(name='tokenRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RSVPParameters_tokenRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _RSVPParameters_bucketSize = INT(name='bucketSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RSVPParameters_bucketSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _RSVPParameters_peakRate = INT(name='peakRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RSVPParameters_peakRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _RSVPParameters_minPoliced = INT(name='minPoliced', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RSVPParameters_minPoliced._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _RSVPParameters_maxPktSize = INT(name='maxPktSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RSVPParameters_maxPktSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    RSVPParameters._cont = ASN1Dict([
        ('qosMode', _RSVPParameters_qosMode),
        ('tokenRate', _RSVPParameters_tokenRate),
        ('bucketSize', _RSVPParameters_bucketSize),
        ('peakRate', _RSVPParameters_peakRate),
        ('minPoliced', _RSVPParameters_minPoliced),
        ('maxPktSize', _RSVPParameters_maxPktSize),
        ])
    RSVPParameters._ext = []
    
    #-----< QOSMode >-----#
    QOSMode = CHOICE(name='QOSMode', mode=MODE_TYPE)
    _QOSMode_guaranteedQOS = NULL(name='guaranteedQOS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSMode_controlledLoad = NULL(name='controlledLoad', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    QOSMode._cont = ASN1Dict([
        ('guaranteedQOS', _QOSMode_guaranteedQOS),
        ('controlledLoad', _QOSMode_controlledLoad),
        ])
    QOSMode._ext = []
    
    #-----< ATMParameters >-----#
    ATMParameters = SEQ(name='ATMParameters', mode=MODE_TYPE)
    _ATMParameters_maxNTUSize = INT(name='maxNTUSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ATMParameters_maxNTUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ATMParameters_atmUBR = BOOL(name='atmUBR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ATMParameters_atmrtVBR = BOOL(name='atmrtVBR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ATMParameters_atmnrtVBR = BOOL(name='atmnrtVBR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ATMParameters_atmABR = BOOL(name='atmABR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ATMParameters_atmCBR = BOOL(name='atmCBR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ATMParameters._cont = ASN1Dict([
        ('maxNTUSize', _ATMParameters_maxNTUSize),
        ('atmUBR', _ATMParameters_atmUBR),
        ('atmrtVBR', _ATMParameters_atmrtVBR),
        ('atmnrtVBR', _ATMParameters_atmnrtVBR),
        ('atmABR', _ATMParameters_atmABR),
        ('atmCBR', _ATMParameters_atmCBR),
        ])
    ATMParameters._ext = []
    
    #-----< ServicePriorityValue >-----#
    ServicePriorityValue = SEQ(name='ServicePriorityValue', mode=MODE_TYPE)
    _ServicePriorityValue_nonStandardParameter = SEQ(name='nonStandardParameter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _ServicePriorityValue_value = INT(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServicePriorityValue_value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ServicePriorityValue._cont = ASN1Dict([
        ('nonStandardParameter', _ServicePriorityValue_nonStandardParameter),
        ('value', _ServicePriorityValue_value),
        ])
    ServicePriorityValue._ext = ['value']
    
    #-----< ServicePriority >-----#
    ServicePriority = SEQ(name='ServicePriority', mode=MODE_TYPE)
    _ServicePriority_nonStandardData = SEQ(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _ServicePriority_servicePrioritySignalled = BOOL(name='servicePrioritySignalled', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServicePriority_servicePriorityValue = SEQ(name='servicePriorityValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ServicePriorityValue')), opt=True)
    _ServicePriority_serviceClass = INT(name='serviceClass', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServicePriority_serviceClass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _ServicePriority_serviceSubclass = INT(name='serviceSubclass', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServicePriority_serviceSubclass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ServicePriority._cont = ASN1Dict([
        ('nonStandardData', _ServicePriority_nonStandardData),
        ('servicePrioritySignalled', _ServicePriority_servicePrioritySignalled),
        ('servicePriorityValue', _ServicePriority_servicePriorityValue),
        ('serviceClass', _ServicePriority_serviceClass),
        ('serviceSubclass', _ServicePriority_serviceSubclass),
        ])
    ServicePriority._ext = ['serviceClass', 'serviceSubclass']
    
    #-----< AuthorizationParameters >-----#
    AuthorizationParameters = SEQ(name='AuthorizationParameters', mode=MODE_TYPE)
    _AuthorizationParameters_nonStandardData = SEQ(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    AuthorizationParameters._cont = ASN1Dict([
        ('nonStandardData', _AuthorizationParameters_nonStandardData),
        ])
    AuthorizationParameters._ext = []
    
    #-----< QOSType >-----#
    QOSType = CHOICE(name='QOSType', mode=MODE_TYPE)
    _QOSType_desired = NULL(name='desired', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSType_required = NULL(name='required', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    QOSType._cont = ASN1Dict([
        ('desired', _QOSType_desired),
        ('required', _QOSType_required),
        ])
    QOSType._ext = []
    
    #-----< QOSClass >-----#
    QOSClass = CHOICE(name='QOSClass', mode=MODE_TYPE)
    _QOSClass_class0 = NULL(name='class0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSClass_class1 = NULL(name='class1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSClass_class2 = NULL(name='class2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSClass_class3 = NULL(name='class3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSClass_class4 = NULL(name='class4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QOSClass_class5 = NULL(name='class5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    QOSClass._cont = ASN1Dict([
        ('class0', _QOSClass_class0),
        ('class1', _QOSClass_class1),
        ('class2', _QOSClass_class2),
        ('class3', _QOSClass_class3),
        ('class4', _QOSClass_class4),
        ('class5', _QOSClass_class5),
        ])
    QOSClass._ext = []
    
    #-----< QOSDescriptor >-----#
    QOSDescriptor = SEQ(name='QOSDescriptor', mode=MODE_TYPE)
    _QOSDescriptor_nonStandardData = SEQ(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _QOSDescriptor_qosType = CHOICE(name='qosType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'QOSType')))
    _QOSDescriptor_qosClass = CHOICE(name='qosClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'QOSClass')))
    QOSDescriptor._cont = ASN1Dict([
        ('nonStandardData', _QOSDescriptor_nonStandardData),
        ('qosType', _QOSDescriptor_qosType),
        ('qosClass', _QOSDescriptor_qosClass),
        ])
    QOSDescriptor._ext = []
    
    #-----< GenericTransportParameters >-----#
    GenericTransportParameters = SEQ(name='GenericTransportParameters', mode=MODE_TYPE)
    _GenericTransportParameters_nonStandardData = SEQ(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _GenericTransportParameters_averageRate = INT(name='averageRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericTransportParameters_averageRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _GenericTransportParameters_burst = INT(name='burst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericTransportParameters_burst._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _GenericTransportParameters_peakRate = INT(name='peakRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericTransportParameters_peakRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _GenericTransportParameters_maxPktSize = INT(name='maxPktSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericTransportParameters_maxPktSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    GenericTransportParameters._cont = ASN1Dict([
        ('nonStandardData', _GenericTransportParameters_nonStandardData),
        ('averageRate', _GenericTransportParameters_averageRate),
        ('burst', _GenericTransportParameters_burst),
        ('peakRate', _GenericTransportParameters_peakRate),
        ('maxPktSize', _GenericTransportParameters_maxPktSize),
        ])
    GenericTransportParameters._ext = []
    
    #-----< QOSCapability >-----#
    QOSCapability = SEQ(name='QOSCapability', mode=MODE_TYPE)
    _QOSCapability_nonStandardData = SEQ(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _QOSCapability_rsvpParameters = SEQ(name='rsvpParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RSVPParameters')), opt=True)
    _QOSCapability_atmParameters = SEQ(name='atmParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ATMParameters')), opt=True)
    _QOSCapability_localQoS = BOOL(name='localQoS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QOSCapability_genericTransportParameters = SEQ(name='genericTransportParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericTransportParameters')), opt=True)
    _QOSCapability_servicePriority = SEQ(name='servicePriority', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ServicePriority')), opt=True)
    _QOSCapability_authorizationParameter = SEQ(name='authorizationParameter', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AuthorizationParameters')), opt=True)
    _QOSCapability_qosDescriptor = SEQ(name='qosDescriptor', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'QOSDescriptor')), opt=True)
    _QOSCapability_dscpValue = INT(name='dscpValue', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QOSCapability_dscpValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    QOSCapability._cont = ASN1Dict([
        ('nonStandardData', _QOSCapability_nonStandardData),
        ('rsvpParameters', _QOSCapability_rsvpParameters),
        ('atmParameters', _QOSCapability_atmParameters),
        ('localQoS', _QOSCapability_localQoS),
        ('genericTransportParameters', _QOSCapability_genericTransportParameters),
        ('servicePriority', _QOSCapability_servicePriority),
        ('authorizationParameter', _QOSCapability_authorizationParameter),
        ('qosDescriptor', _QOSCapability_qosDescriptor),
        ('dscpValue', _QOSCapability_dscpValue),
        ])
    QOSCapability._ext = ['localQoS', 'genericTransportParameters', 'servicePriority', 'authorizationParameter', 'qosDescriptor', 'dscpValue']
    
    #-----< MediaTransportType >-----#
    MediaTransportType = CHOICE(name='MediaTransportType', mode=MODE_TYPE)
    _MediaTransportType_ip_UDP = NULL(name='ip-UDP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaTransportType_ip_TCP = NULL(name='ip-TCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaTransportType_atm_AAL5_UNIDIR = NULL(name='atm-AAL5-UNIDIR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaTransportType_atm_AAL5_BIDIR = NULL(name='atm-AAL5-BIDIR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaTransportType_atm_AAL5_compressed = SEQ(name='atm-AAL5-compressed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MediaTransportType_atm_AAL5_compressed_variable_delta = BOOL(name='variable-delta', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaTransportType_atm_AAL5_compressed._cont = ASN1Dict([
        ('variable-delta', __MediaTransportType_atm_AAL5_compressed_variable_delta),
        ])
    _MediaTransportType_atm_AAL5_compressed._ext = []
    MediaTransportType._cont = ASN1Dict([
        ('ip-UDP', _MediaTransportType_ip_UDP),
        ('ip-TCP', _MediaTransportType_ip_TCP),
        ('atm-AAL5-UNIDIR', _MediaTransportType_atm_AAL5_UNIDIR),
        ('atm-AAL5-BIDIR', _MediaTransportType_atm_AAL5_BIDIR),
        ('atm-AAL5-compressed', _MediaTransportType_atm_AAL5_compressed),
        ])
    MediaTransportType._ext = ['atm-AAL5-compressed']
    
    #-----< MediaChannelCapability >-----#
    MediaChannelCapability = SEQ(name='MediaChannelCapability', mode=MODE_TYPE)
    _MediaChannelCapability_mediaTransport = CHOICE(name='mediaTransport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MediaTransportType')), opt=True)
    MediaChannelCapability._cont = ASN1Dict([
        ('mediaTransport', _MediaChannelCapability_mediaTransport),
        ])
    MediaChannelCapability._ext = []
    
    #-----< TransportCapability >-----#
    TransportCapability = SEQ(name='TransportCapability', mode=MODE_TYPE)
    _TransportCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _TransportCapability_qOSCapabilities = SEQ_OF(name='qOSCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransportCapability_qOSCapabilities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'QOSCapability')))
    _TransportCapability_qOSCapabilities._cont = __TransportCapability_qOSCapabilities__item_
    _TransportCapability_qOSCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TransportCapability_mediaChannelCapabilities = SEQ_OF(name='mediaChannelCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransportCapability_mediaChannelCapabilities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MediaChannelCapability')))
    _TransportCapability_mediaChannelCapabilities._cont = __TransportCapability_mediaChannelCapabilities__item_
    _TransportCapability_mediaChannelCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    TransportCapability._cont = ASN1Dict([
        ('nonStandard', _TransportCapability_nonStandard),
        ('qOSCapabilities', _TransportCapability_qOSCapabilities),
        ('mediaChannelCapabilities', _TransportCapability_mediaChannelCapabilities),
        ])
    TransportCapability._ext = []
    
    #-----< RedundancyEncodingCapability >-----#
    RedundancyEncodingCapability = SEQ(name='RedundancyEncodingCapability', mode=MODE_TYPE)
    _RedundancyEncodingCapability_redundancyEncodingMethod = CHOICE(name='redundancyEncodingMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingMethod')))
    _RedundancyEncodingCapability_primaryEncoding = INT(name='primaryEncoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    _RedundancyEncodingCapability_secondaryEncoding = SEQ_OF(name='secondaryEncoding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RedundancyEncodingCapability_secondaryEncoding__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    _RedundancyEncodingCapability_secondaryEncoding._cont = __RedundancyEncodingCapability_secondaryEncoding__item_
    _RedundancyEncodingCapability_secondaryEncoding._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    RedundancyEncodingCapability._cont = ASN1Dict([
        ('redundancyEncodingMethod', _RedundancyEncodingCapability_redundancyEncodingMethod),
        ('primaryEncoding', _RedundancyEncodingCapability_primaryEncoding),
        ('secondaryEncoding', _RedundancyEncodingCapability_secondaryEncoding),
        ])
    RedundancyEncodingCapability._ext = []
    
    #-----< RedundancyEncodingMethod >-----#
    RedundancyEncodingMethod = CHOICE(name='RedundancyEncodingMethod', mode=MODE_TYPE)
    _RedundancyEncodingMethod_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _RedundancyEncodingMethod_rtpAudioRedundancyEncoding = NULL(name='rtpAudioRedundancyEncoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RedundancyEncodingMethod_rtpH263VideoRedundancyEncoding = SEQ(name='rtpH263VideoRedundancyEncoding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RTPH263VideoRedundancyEncoding')))
    RedundancyEncodingMethod._cont = ASN1Dict([
        ('nonStandard', _RedundancyEncodingMethod_nonStandard),
        ('rtpAudioRedundancyEncoding', _RedundancyEncodingMethod_rtpAudioRedundancyEncoding),
        ('rtpH263VideoRedundancyEncoding', _RedundancyEncodingMethod_rtpH263VideoRedundancyEncoding),
        ])
    RedundancyEncodingMethod._ext = ['rtpH263VideoRedundancyEncoding']
    
    #-----< RTPH263VideoRedundancyEncoding >-----#
    RTPH263VideoRedundancyEncoding = SEQ(name='RTPH263VideoRedundancyEncoding', mode=MODE_TYPE)
    _RTPH263VideoRedundancyEncoding_numberOfThreads = INT(name='numberOfThreads', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTPH263VideoRedundancyEncoding_numberOfThreads._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _RTPH263VideoRedundancyEncoding_framesBetweenSyncPoints = INT(name='framesBetweenSyncPoints', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTPH263VideoRedundancyEncoding_framesBetweenSyncPoints._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _RTPH263VideoRedundancyEncoding_frameToThreadMapping = CHOICE(name='frameToThreadMapping', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RTPH263VideoRedundancyEncoding_frameToThreadMapping_roundrobin = NULL(name='roundrobin', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom = SEQ_OF(name='custom', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RTPH263VideoRedundancyFrameMapping')))
    __RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom._cont = ___RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom__item_
    __RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _RTPH263VideoRedundancyEncoding_frameToThreadMapping._cont = ASN1Dict([
        ('roundrobin', __RTPH263VideoRedundancyEncoding_frameToThreadMapping_roundrobin),
        ('custom', __RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom),
        ])
    _RTPH263VideoRedundancyEncoding_frameToThreadMapping._ext = []
    _RTPH263VideoRedundancyEncoding_containedThreads = SEQ_OF(name='containedThreads', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RTPH263VideoRedundancyEncoding_containedThreads__item_ = INT(name='_item_', mode=MODE_TYPE)
    __RTPH263VideoRedundancyEncoding_containedThreads__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _RTPH263VideoRedundancyEncoding_containedThreads._cont = __RTPH263VideoRedundancyEncoding_containedThreads__item_
    _RTPH263VideoRedundancyEncoding_containedThreads._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    RTPH263VideoRedundancyEncoding._cont = ASN1Dict([
        ('numberOfThreads', _RTPH263VideoRedundancyEncoding_numberOfThreads),
        ('framesBetweenSyncPoints', _RTPH263VideoRedundancyEncoding_framesBetweenSyncPoints),
        ('frameToThreadMapping', _RTPH263VideoRedundancyEncoding_frameToThreadMapping),
        ('containedThreads', _RTPH263VideoRedundancyEncoding_containedThreads),
        ])
    RTPH263VideoRedundancyEncoding._ext = []
    
    #-----< RTPH263VideoRedundancyFrameMapping >-----#
    RTPH263VideoRedundancyFrameMapping = SEQ(name='RTPH263VideoRedundancyFrameMapping', mode=MODE_TYPE)
    _RTPH263VideoRedundancyFrameMapping_threadNumber = INT(name='threadNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTPH263VideoRedundancyFrameMapping_threadNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _RTPH263VideoRedundancyFrameMapping_frameSequence = SEQ_OF(name='frameSequence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RTPH263VideoRedundancyFrameMapping_frameSequence__item_ = INT(name='_item_', mode=MODE_TYPE)
    __RTPH263VideoRedundancyFrameMapping_frameSequence__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _RTPH263VideoRedundancyFrameMapping_frameSequence._cont = __RTPH263VideoRedundancyFrameMapping_frameSequence__item_
    _RTPH263VideoRedundancyFrameMapping_frameSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    RTPH263VideoRedundancyFrameMapping._cont = ASN1Dict([
        ('threadNumber', _RTPH263VideoRedundancyFrameMapping_threadNumber),
        ('frameSequence', _RTPH263VideoRedundancyFrameMapping_frameSequence),
        ])
    RTPH263VideoRedundancyFrameMapping._ext = []
    
    #-----< MultipointCapability >-----#
    MultipointCapability = SEQ(name='MultipointCapability', mode=MODE_TYPE)
    _MultipointCapability_multicastCapability = BOOL(name='multicastCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultipointCapability_multiUniCastConference = BOOL(name='multiUniCastConference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultipointCapability_mediaDistributionCapability = SEQ_OF(name='mediaDistributionCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultipointCapability_mediaDistributionCapability__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MediaDistributionCapability')))
    _MultipointCapability_mediaDistributionCapability._cont = __MultipointCapability_mediaDistributionCapability__item_
    MultipointCapability._cont = ASN1Dict([
        ('multicastCapability', _MultipointCapability_multicastCapability),
        ('multiUniCastConference', _MultipointCapability_multiUniCastConference),
        ('mediaDistributionCapability', _MultipointCapability_mediaDistributionCapability),
        ])
    MultipointCapability._ext = []
    
    #-----< MediaDistributionCapability >-----#
    MediaDistributionCapability = SEQ(name='MediaDistributionCapability', mode=MODE_TYPE)
    _MediaDistributionCapability_centralizedControl = BOOL(name='centralizedControl', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaDistributionCapability_distributedControl = BOOL(name='distributedControl', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaDistributionCapability_centralizedAudio = BOOL(name='centralizedAudio', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaDistributionCapability_distributedAudio = BOOL(name='distributedAudio', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaDistributionCapability_centralizedVideo = BOOL(name='centralizedVideo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaDistributionCapability_distributedVideo = BOOL(name='distributedVideo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaDistributionCapability_centralizedData = SEQ_OF(name='centralizedData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MediaDistributionCapability_centralizedData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _MediaDistributionCapability_centralizedData._cont = __MediaDistributionCapability_centralizedData__item_
    _MediaDistributionCapability_distributedData = SEQ_OF(name='distributedData', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MediaDistributionCapability_distributedData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _MediaDistributionCapability_distributedData._cont = __MediaDistributionCapability_distributedData__item_
    MediaDistributionCapability._cont = ASN1Dict([
        ('centralizedControl', _MediaDistributionCapability_centralizedControl),
        ('distributedControl', _MediaDistributionCapability_distributedControl),
        ('centralizedAudio', _MediaDistributionCapability_centralizedAudio),
        ('distributedAudio', _MediaDistributionCapability_distributedAudio),
        ('centralizedVideo', _MediaDistributionCapability_centralizedVideo),
        ('distributedVideo', _MediaDistributionCapability_distributedVideo),
        ('centralizedData', _MediaDistributionCapability_centralizedData),
        ('distributedData', _MediaDistributionCapability_distributedData),
        ])
    MediaDistributionCapability._ext = []
    
    #-----< VideoCapability >-----#
    VideoCapability = CHOICE(name='VideoCapability', mode=MODE_TYPE)
    _VideoCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _VideoCapability_h261VideoCapability = SEQ(name='h261VideoCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H261VideoCapability')))
    _VideoCapability_h262VideoCapability = SEQ(name='h262VideoCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H262VideoCapability')))
    _VideoCapability_h263VideoCapability = SEQ(name='h263VideoCapability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263VideoCapability')))
    _VideoCapability_is11172VideoCapability = SEQ(name='is11172VideoCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IS11172VideoCapability')))
    _VideoCapability_genericVideoCapability = SEQ(name='genericVideoCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _VideoCapability_extendedVideoCapability = SEQ(name='extendedVideoCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ExtendedVideoCapability')))
    VideoCapability._cont = ASN1Dict([
        ('nonStandard', _VideoCapability_nonStandard),
        ('h261VideoCapability', _VideoCapability_h261VideoCapability),
        ('h262VideoCapability', _VideoCapability_h262VideoCapability),
        ('h263VideoCapability', _VideoCapability_h263VideoCapability),
        ('is11172VideoCapability', _VideoCapability_is11172VideoCapability),
        ('genericVideoCapability', _VideoCapability_genericVideoCapability),
        ('extendedVideoCapability', _VideoCapability_extendedVideoCapability),
        ])
    VideoCapability._ext = ['genericVideoCapability', 'extendedVideoCapability']
    
    #-----< ExtendedVideoCapability >-----#
    ExtendedVideoCapability = SEQ(name='ExtendedVideoCapability', mode=MODE_TYPE)
    _ExtendedVideoCapability_videoCapability = SEQ_OF(name='videoCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ExtendedVideoCapability_videoCapability__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    _ExtendedVideoCapability_videoCapability._cont = __ExtendedVideoCapability_videoCapability__item_
    _ExtendedVideoCapability_videoCapabilityExtension = SEQ_OF(name='videoCapabilityExtension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ExtendedVideoCapability_videoCapabilityExtension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _ExtendedVideoCapability_videoCapabilityExtension._cont = __ExtendedVideoCapability_videoCapabilityExtension__item_
    ExtendedVideoCapability._cont = ASN1Dict([
        ('videoCapability', _ExtendedVideoCapability_videoCapability),
        ('videoCapabilityExtension', _ExtendedVideoCapability_videoCapabilityExtension),
        ])
    ExtendedVideoCapability._ext = []
    
    #-----< H261VideoCapability >-----#
    H261VideoCapability = SEQ(name='H261VideoCapability', mode=MODE_TYPE)
    _H261VideoCapability_qcifMPI = INT(name='qcifMPI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H261VideoCapability_qcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _H261VideoCapability_cifMPI = INT(name='cifMPI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H261VideoCapability_cifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _H261VideoCapability_temporalSpatialTradeOffCapability = BOOL(name='temporalSpatialTradeOffCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H261VideoCapability_maxBitRate = INT(name='maxBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H261VideoCapability_maxBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=19200)], ev=None, er=[])
    _H261VideoCapability_stillImageTransmission = BOOL(name='stillImageTransmission', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H261VideoCapability_videoBadMBsCap = BOOL(name='videoBadMBsCap', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H261VideoCapability._cont = ASN1Dict([
        ('qcifMPI', _H261VideoCapability_qcifMPI),
        ('cifMPI', _H261VideoCapability_cifMPI),
        ('temporalSpatialTradeOffCapability', _H261VideoCapability_temporalSpatialTradeOffCapability),
        ('maxBitRate', _H261VideoCapability_maxBitRate),
        ('stillImageTransmission', _H261VideoCapability_stillImageTransmission),
        ('videoBadMBsCap', _H261VideoCapability_videoBadMBsCap),
        ])
    H261VideoCapability._ext = ['videoBadMBsCap']
    
    #-----< H262VideoCapability >-----#
    H262VideoCapability = SEQ(name='H262VideoCapability', mode=MODE_TYPE)
    _H262VideoCapability_profileAndLevel_SPatML = BOOL(name='profileAndLevel-SPatML', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_MPatLL = BOOL(name='profileAndLevel-MPatLL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_MPatML = BOOL(name='profileAndLevel-MPatML', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_MPatH_14 = BOOL(name='profileAndLevel-MPatH-14', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_MPatHL = BOOL(name='profileAndLevel-MPatHL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_SNRatLL = BOOL(name='profileAndLevel-SNRatLL', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_SNRatML = BOOL(name='profileAndLevel-SNRatML', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_SpatialatH_14 = BOOL(name='profileAndLevel-SpatialatH-14', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_HPatML = BOOL(name='profileAndLevel-HPatML', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_HPatH_14 = BOOL(name='profileAndLevel-HPatH-14', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_profileAndLevel_HPatHL = BOOL(name='profileAndLevel-HPatHL', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoCapability_videoBitRate = INT(name='videoBitRate', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoCapability_videoBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1073741823)], ev=None, er=[])
    _H262VideoCapability_vbvBufferSize = INT(name='vbvBufferSize', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoCapability_vbvBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _H262VideoCapability_samplesPerLine = INT(name='samplesPerLine', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoCapability_samplesPerLine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _H262VideoCapability_linesPerFrame = INT(name='linesPerFrame', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoCapability_linesPerFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _H262VideoCapability_framesPerSecond = INT(name='framesPerSecond', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoCapability_framesPerSecond._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _H262VideoCapability_luminanceSampleRate = INT(name='luminanceSampleRate', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoCapability_luminanceSampleRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _H262VideoCapability_videoBadMBsCap = BOOL(name='videoBadMBsCap', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H262VideoCapability._cont = ASN1Dict([
        ('profileAndLevel-SPatML', _H262VideoCapability_profileAndLevel_SPatML),
        ('profileAndLevel-MPatLL', _H262VideoCapability_profileAndLevel_MPatLL),
        ('profileAndLevel-MPatML', _H262VideoCapability_profileAndLevel_MPatML),
        ('profileAndLevel-MPatH-14', _H262VideoCapability_profileAndLevel_MPatH_14),
        ('profileAndLevel-MPatHL', _H262VideoCapability_profileAndLevel_MPatHL),
        ('profileAndLevel-SNRatLL', _H262VideoCapability_profileAndLevel_SNRatLL),
        ('profileAndLevel-SNRatML', _H262VideoCapability_profileAndLevel_SNRatML),
        ('profileAndLevel-SpatialatH-14', _H262VideoCapability_profileAndLevel_SpatialatH_14),
        ('profileAndLevel-HPatML', _H262VideoCapability_profileAndLevel_HPatML),
        ('profileAndLevel-HPatH-14', _H262VideoCapability_profileAndLevel_HPatH_14),
        ('profileAndLevel-HPatHL', _H262VideoCapability_profileAndLevel_HPatHL),
        ('videoBitRate', _H262VideoCapability_videoBitRate),
        ('vbvBufferSize', _H262VideoCapability_vbvBufferSize),
        ('samplesPerLine', _H262VideoCapability_samplesPerLine),
        ('linesPerFrame', _H262VideoCapability_linesPerFrame),
        ('framesPerSecond', _H262VideoCapability_framesPerSecond),
        ('luminanceSampleRate', _H262VideoCapability_luminanceSampleRate),
        ('videoBadMBsCap', _H262VideoCapability_videoBadMBsCap),
        ])
    H262VideoCapability._ext = None
    
    #-----< H263VideoCapability >-----#
    H263VideoCapability = SEQ(name='H263VideoCapability', mode=MODE_TYPE)
    _H263VideoCapability_sqcifMPI = INT(name='sqcifMPI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_sqcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _H263VideoCapability_qcifMPI = INT(name='qcifMPI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_qcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _H263VideoCapability_cifMPI = INT(name='cifMPI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_cifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _H263VideoCapability_cif4MPI = INT(name='cif4MPI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_cif4MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _H263VideoCapability_cif16MPI = INT(name='cif16MPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_cif16MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _H263VideoCapability_maxBitRate = INT(name='maxBitRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_maxBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=192400)], ev=None, er=[])
    _H263VideoCapability_unrestrictedVector = BOOL(name='unrestrictedVector', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_arithmeticCoding = BOOL(name='arithmeticCoding', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_advancedPrediction = BOOL(name='advancedPrediction', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_pbFrames = BOOL(name='pbFrames', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_temporalSpatialTradeOffCapability = BOOL(name='temporalSpatialTradeOffCapability', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_hrd_B = INT(name='hrd-B', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_hrd_B._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=524287)], ev=None, er=[])
    _H263VideoCapability_bppMaxKb = INT(name='bppMaxKb', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_bppMaxKb._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H263VideoCapability_slowSqcifMPI = INT(name='slowSqcifMPI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_slowSqcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _H263VideoCapability_slowQcifMPI = INT(name='slowQcifMPI', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_slowQcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _H263VideoCapability_slowCifMPI = INT(name='slowCifMPI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_slowCifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _H263VideoCapability_slowCif4MPI = INT(name='slowCif4MPI', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_slowCif4MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _H263VideoCapability_slowCif16MPI = INT(name='slowCif16MPI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H263VideoCapability_slowCif16MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _H263VideoCapability_errorCompensation = BOOL(name='errorCompensation', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoCapability_enhancementLayerInfo = SEQ(name='enhancementLayerInfo', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EnhancementLayerInfo')), opt=True)
    _H263VideoCapability_h263Options = SEQ(name='h263Options', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263Options')), opt=True)
    H263VideoCapability._cont = ASN1Dict([
        ('sqcifMPI', _H263VideoCapability_sqcifMPI),
        ('qcifMPI', _H263VideoCapability_qcifMPI),
        ('cifMPI', _H263VideoCapability_cifMPI),
        ('cif4MPI', _H263VideoCapability_cif4MPI),
        ('cif16MPI', _H263VideoCapability_cif16MPI),
        ('maxBitRate', _H263VideoCapability_maxBitRate),
        ('unrestrictedVector', _H263VideoCapability_unrestrictedVector),
        ('arithmeticCoding', _H263VideoCapability_arithmeticCoding),
        ('advancedPrediction', _H263VideoCapability_advancedPrediction),
        ('pbFrames', _H263VideoCapability_pbFrames),
        ('temporalSpatialTradeOffCapability', _H263VideoCapability_temporalSpatialTradeOffCapability),
        ('hrd-B', _H263VideoCapability_hrd_B),
        ('bppMaxKb', _H263VideoCapability_bppMaxKb),
        ('slowSqcifMPI', _H263VideoCapability_slowSqcifMPI),
        ('slowQcifMPI', _H263VideoCapability_slowQcifMPI),
        ('slowCifMPI', _H263VideoCapability_slowCifMPI),
        ('slowCif4MPI', _H263VideoCapability_slowCif4MPI),
        ('slowCif16MPI', _H263VideoCapability_slowCif16MPI),
        ('errorCompensation', _H263VideoCapability_errorCompensation),
        ('enhancementLayerInfo', _H263VideoCapability_enhancementLayerInfo),
        ('h263Options', _H263VideoCapability_h263Options),
        ])
    H263VideoCapability._ext = ['slowSqcifMPI', 'slowQcifMPI', 'slowCifMPI', 'slowCif4MPI', 'slowCif16MPI', 'errorCompensation', 'enhancementLayerInfo', 'h263Options']
    
    #-----< EnhancementLayerInfo >-----#
    EnhancementLayerInfo = SEQ(name='EnhancementLayerInfo', mode=MODE_TYPE)
    _EnhancementLayerInfo_baseBitRateConstrained = BOOL(name='baseBitRateConstrained', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancementLayerInfo_snrEnhancement = SET_OF(name='snrEnhancement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EnhancementLayerInfo_snrEnhancement__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EnhancementOptions')))
    _EnhancementLayerInfo_snrEnhancement._cont = __EnhancementLayerInfo_snrEnhancement__item_
    _EnhancementLayerInfo_snrEnhancement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    _EnhancementLayerInfo_spatialEnhancement = SET_OF(name='spatialEnhancement', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EnhancementLayerInfo_spatialEnhancement__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EnhancementOptions')))
    _EnhancementLayerInfo_spatialEnhancement._cont = __EnhancementLayerInfo_spatialEnhancement__item_
    _EnhancementLayerInfo_spatialEnhancement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    _EnhancementLayerInfo_bPictureEnhancement = SET_OF(name='bPictureEnhancement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EnhancementLayerInfo_bPictureEnhancement__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'BEnhancementParameters')))
    _EnhancementLayerInfo_bPictureEnhancement._cont = __EnhancementLayerInfo_bPictureEnhancement__item_
    _EnhancementLayerInfo_bPictureEnhancement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    EnhancementLayerInfo._cont = ASN1Dict([
        ('baseBitRateConstrained', _EnhancementLayerInfo_baseBitRateConstrained),
        ('snrEnhancement', _EnhancementLayerInfo_snrEnhancement),
        ('spatialEnhancement', _EnhancementLayerInfo_spatialEnhancement),
        ('bPictureEnhancement', _EnhancementLayerInfo_bPictureEnhancement),
        ])
    EnhancementLayerInfo._ext = []
    
    #-----< BEnhancementParameters >-----#
    BEnhancementParameters = SEQ(name='BEnhancementParameters', mode=MODE_TYPE)
    _BEnhancementParameters_enhancementOptions = SEQ(name='enhancementOptions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EnhancementOptions')))
    _BEnhancementParameters_numberOfBPictures = INT(name='numberOfBPictures', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BEnhancementParameters_numberOfBPictures._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    BEnhancementParameters._cont = ASN1Dict([
        ('enhancementOptions', _BEnhancementParameters_enhancementOptions),
        ('numberOfBPictures', _BEnhancementParameters_numberOfBPictures),
        ])
    BEnhancementParameters._ext = []
    
    #-----< EnhancementOptions >-----#
    EnhancementOptions = SEQ(name='EnhancementOptions', mode=MODE_TYPE)
    _EnhancementOptions_sqcifMPI = INT(name='sqcifMPI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_sqcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _EnhancementOptions_qcifMPI = INT(name='qcifMPI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_qcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _EnhancementOptions_cifMPI = INT(name='cifMPI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_cifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _EnhancementOptions_cif4MPI = INT(name='cif4MPI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_cif4MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _EnhancementOptions_cif16MPI = INT(name='cif16MPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_cif16MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _EnhancementOptions_maxBitRate = INT(name='maxBitRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancementOptions_maxBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=192400)], ev=None, er=[])
    _EnhancementOptions_unrestrictedVector = BOOL(name='unrestrictedVector', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancementOptions_arithmeticCoding = BOOL(name='arithmeticCoding', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancementOptions_temporalSpatialTradeOffCapability = BOOL(name='temporalSpatialTradeOffCapability', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancementOptions_slowSqcifMPI = INT(name='slowSqcifMPI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_slowSqcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _EnhancementOptions_slowQcifMPI = INT(name='slowQcifMPI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_slowQcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _EnhancementOptions_slowCifMPI = INT(name='slowCifMPI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_slowCifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _EnhancementOptions_slowCif4MPI = INT(name='slowCif4MPI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_slowCif4MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _EnhancementOptions_slowCif16MPI = INT(name='slowCif16MPI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancementOptions_slowCif16MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _EnhancementOptions_errorCompensation = BOOL(name='errorCompensation', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancementOptions_h263Options = SEQ(name='h263Options', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263Options')), opt=True)
    EnhancementOptions._cont = ASN1Dict([
        ('sqcifMPI', _EnhancementOptions_sqcifMPI),
        ('qcifMPI', _EnhancementOptions_qcifMPI),
        ('cifMPI', _EnhancementOptions_cifMPI),
        ('cif4MPI', _EnhancementOptions_cif4MPI),
        ('cif16MPI', _EnhancementOptions_cif16MPI),
        ('maxBitRate', _EnhancementOptions_maxBitRate),
        ('unrestrictedVector', _EnhancementOptions_unrestrictedVector),
        ('arithmeticCoding', _EnhancementOptions_arithmeticCoding),
        ('temporalSpatialTradeOffCapability', _EnhancementOptions_temporalSpatialTradeOffCapability),
        ('slowSqcifMPI', _EnhancementOptions_slowSqcifMPI),
        ('slowQcifMPI', _EnhancementOptions_slowQcifMPI),
        ('slowCifMPI', _EnhancementOptions_slowCifMPI),
        ('slowCif4MPI', _EnhancementOptions_slowCif4MPI),
        ('slowCif16MPI', _EnhancementOptions_slowCif16MPI),
        ('errorCompensation', _EnhancementOptions_errorCompensation),
        ('h263Options', _EnhancementOptions_h263Options),
        ])
    EnhancementOptions._ext = []
    
    #-----< H263Options >-----#
    H263Options = SEQ(name='H263Options', mode=MODE_TYPE)
    _H263Options_advancedIntraCodingMode = BOOL(name='advancedIntraCodingMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_deblockingFilterMode = BOOL(name='deblockingFilterMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_improvedPBFramesMode = BOOL(name='improvedPBFramesMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_unlimitedMotionVectors = BOOL(name='unlimitedMotionVectors', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_fullPictureFreeze = BOOL(name='fullPictureFreeze', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_partialPictureFreezeAndRelease = BOOL(name='partialPictureFreezeAndRelease', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_resizingPartPicFreezeAndRelease = BOOL(name='resizingPartPicFreezeAndRelease', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_fullPictureSnapshot = BOOL(name='fullPictureSnapshot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_partialPictureSnapshot = BOOL(name='partialPictureSnapshot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_videoSegmentTagging = BOOL(name='videoSegmentTagging', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_progressiveRefinement = BOOL(name='progressiveRefinement', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_dynamicPictureResizingByFour = BOOL(name='dynamicPictureResizingByFour', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_dynamicPictureResizingSixteenthPel = BOOL(name='dynamicPictureResizingSixteenthPel', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_dynamicWarpingHalfPel = BOOL(name='dynamicWarpingHalfPel', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_dynamicWarpingSixteenthPel = BOOL(name='dynamicWarpingSixteenthPel', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_independentSegmentDecoding = BOOL(name='independentSegmentDecoding', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_slicesInOrder_NonRect = BOOL(name='slicesInOrder-NonRect', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_slicesInOrder_Rect = BOOL(name='slicesInOrder-Rect', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_slicesNoOrder_NonRect = BOOL(name='slicesNoOrder-NonRect', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_slicesNoOrder_Rect = BOOL(name='slicesNoOrder-Rect', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_alternateInterVLCMode = BOOL(name='alternateInterVLCMode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_modifiedQuantizationMode = BOOL(name='modifiedQuantizationMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_reducedResolutionUpdate = BOOL(name='reducedResolutionUpdate', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_transparencyParameters = SEQ(name='transparencyParameters', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransparencyParameters')), opt=True)
    _H263Options_separateVideoBackChannel = BOOL(name='separateVideoBackChannel', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_refPictureSelection = SEQ(name='refPictureSelection', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RefPictureSelection')), opt=True)
    _H263Options_customPictureClockFrequency = SET_OF(name='customPictureClockFrequency', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H263Options_customPictureClockFrequency__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CustomPictureClockFrequency')))
    _H263Options_customPictureClockFrequency._cont = __H263Options_customPictureClockFrequency__item_
    _H263Options_customPictureClockFrequency._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _H263Options_customPictureFormat = SET_OF(name='customPictureFormat', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H263Options_customPictureFormat__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CustomPictureFormat')))
    _H263Options_customPictureFormat._cont = __H263Options_customPictureFormat__item_
    _H263Options_customPictureFormat._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _H263Options_modeCombos = SET_OF(name='modeCombos', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H263Options_modeCombos__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263VideoModeCombos')))
    _H263Options_modeCombos._cont = __H263Options_modeCombos__item_
    _H263Options_modeCombos._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _H263Options_videoBadMBsCap = BOOL(name='videoBadMBsCap', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Options_h263Version3Options = SEQ(name='h263Version3Options', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263Version3Options')))
    H263Options._cont = ASN1Dict([
        ('advancedIntraCodingMode', _H263Options_advancedIntraCodingMode),
        ('deblockingFilterMode', _H263Options_deblockingFilterMode),
        ('improvedPBFramesMode', _H263Options_improvedPBFramesMode),
        ('unlimitedMotionVectors', _H263Options_unlimitedMotionVectors),
        ('fullPictureFreeze', _H263Options_fullPictureFreeze),
        ('partialPictureFreezeAndRelease', _H263Options_partialPictureFreezeAndRelease),
        ('resizingPartPicFreezeAndRelease', _H263Options_resizingPartPicFreezeAndRelease),
        ('fullPictureSnapshot', _H263Options_fullPictureSnapshot),
        ('partialPictureSnapshot', _H263Options_partialPictureSnapshot),
        ('videoSegmentTagging', _H263Options_videoSegmentTagging),
        ('progressiveRefinement', _H263Options_progressiveRefinement),
        ('dynamicPictureResizingByFour', _H263Options_dynamicPictureResizingByFour),
        ('dynamicPictureResizingSixteenthPel', _H263Options_dynamicPictureResizingSixteenthPel),
        ('dynamicWarpingHalfPel', _H263Options_dynamicWarpingHalfPel),
        ('dynamicWarpingSixteenthPel', _H263Options_dynamicWarpingSixteenthPel),
        ('independentSegmentDecoding', _H263Options_independentSegmentDecoding),
        ('slicesInOrder-NonRect', _H263Options_slicesInOrder_NonRect),
        ('slicesInOrder-Rect', _H263Options_slicesInOrder_Rect),
        ('slicesNoOrder-NonRect', _H263Options_slicesNoOrder_NonRect),
        ('slicesNoOrder-Rect', _H263Options_slicesNoOrder_Rect),
        ('alternateInterVLCMode', _H263Options_alternateInterVLCMode),
        ('modifiedQuantizationMode', _H263Options_modifiedQuantizationMode),
        ('reducedResolutionUpdate', _H263Options_reducedResolutionUpdate),
        ('transparencyParameters', _H263Options_transparencyParameters),
        ('separateVideoBackChannel', _H263Options_separateVideoBackChannel),
        ('refPictureSelection', _H263Options_refPictureSelection),
        ('customPictureClockFrequency', _H263Options_customPictureClockFrequency),
        ('customPictureFormat', _H263Options_customPictureFormat),
        ('modeCombos', _H263Options_modeCombos),
        ('videoBadMBsCap', _H263Options_videoBadMBsCap),
        ('h263Version3Options', _H263Options_h263Version3Options),
        ])
    H263Options._ext = ['videoBadMBsCap', 'h263Version3Options']
    
    #-----< TransparencyParameters >-----#
    TransparencyParameters = SEQ(name='TransparencyParameters', mode=MODE_TYPE)
    _TransparencyParameters_presentationOrder = INT(name='presentationOrder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransparencyParameters_presentationOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TransparencyParameters_offset_x = INT(name='offset-x', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransparencyParameters_offset_x._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-262144, ub=262143)], ev=None, er=[])
    _TransparencyParameters_offset_y = INT(name='offset-y', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransparencyParameters_offset_y._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-262144, ub=262143)], ev=None, er=[])
    _TransparencyParameters_scale_x = INT(name='scale-x', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransparencyParameters_scale_x._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _TransparencyParameters_scale_y = INT(name='scale-y', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransparencyParameters_scale_y._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    TransparencyParameters._cont = ASN1Dict([
        ('presentationOrder', _TransparencyParameters_presentationOrder),
        ('offset-x', _TransparencyParameters_offset_x),
        ('offset-y', _TransparencyParameters_offset_y),
        ('scale-x', _TransparencyParameters_scale_x),
        ('scale-y', _TransparencyParameters_scale_y),
        ])
    TransparencyParameters._ext = []
    
    #-----< RefPictureSelection >-----#
    RefPictureSelection = SEQ(name='RefPictureSelection', mode=MODE_TYPE)
    _RefPictureSelection_additionalPictureMemory = SEQ(name='additionalPictureMemory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_sqcifAdditionalPictureMemory = INT(name='sqcifAdditionalPictureMemory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_sqcifAdditionalPictureMemory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __RefPictureSelection_additionalPictureMemory_qcifAdditionalPictureMemory = INT(name='qcifAdditionalPictureMemory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_qcifAdditionalPictureMemory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __RefPictureSelection_additionalPictureMemory_cifAdditionalPictureMemory = INT(name='cifAdditionalPictureMemory', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_cifAdditionalPictureMemory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __RefPictureSelection_additionalPictureMemory_cif4AdditionalPictureMemory = INT(name='cif4AdditionalPictureMemory', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_cif4AdditionalPictureMemory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __RefPictureSelection_additionalPictureMemory_cif16AdditionalPictureMemory = INT(name='cif16AdditionalPictureMemory', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_cif16AdditionalPictureMemory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __RefPictureSelection_additionalPictureMemory_bigCpfAdditionalPictureMemory = INT(name='bigCpfAdditionalPictureMemory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RefPictureSelection_additionalPictureMemory_bigCpfAdditionalPictureMemory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _RefPictureSelection_additionalPictureMemory._cont = ASN1Dict([
        ('sqcifAdditionalPictureMemory', __RefPictureSelection_additionalPictureMemory_sqcifAdditionalPictureMemory),
        ('qcifAdditionalPictureMemory', __RefPictureSelection_additionalPictureMemory_qcifAdditionalPictureMemory),
        ('cifAdditionalPictureMemory', __RefPictureSelection_additionalPictureMemory_cifAdditionalPictureMemory),
        ('cif4AdditionalPictureMemory', __RefPictureSelection_additionalPictureMemory_cif4AdditionalPictureMemory),
        ('cif16AdditionalPictureMemory', __RefPictureSelection_additionalPictureMemory_cif16AdditionalPictureMemory),
        ('bigCpfAdditionalPictureMemory', __RefPictureSelection_additionalPictureMemory_bigCpfAdditionalPictureMemory),
        ])
    _RefPictureSelection_additionalPictureMemory._ext = []
    _RefPictureSelection_videoMux = BOOL(name='videoMux', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RefPictureSelection_videoBackChannelSend = CHOICE(name='videoBackChannelSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RefPictureSelection_videoBackChannelSend_none = NULL(name='none', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RefPictureSelection_videoBackChannelSend_ackMessageOnly = NULL(name='ackMessageOnly', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RefPictureSelection_videoBackChannelSend_nackMessageOnly = NULL(name='nackMessageOnly', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RefPictureSelection_videoBackChannelSend_ackOrNackMessageOnly = NULL(name='ackOrNackMessageOnly', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RefPictureSelection_videoBackChannelSend_ackAndNackMessage = NULL(name='ackAndNackMessage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RefPictureSelection_videoBackChannelSend._cont = ASN1Dict([
        ('none', __RefPictureSelection_videoBackChannelSend_none),
        ('ackMessageOnly', __RefPictureSelection_videoBackChannelSend_ackMessageOnly),
        ('nackMessageOnly', __RefPictureSelection_videoBackChannelSend_nackMessageOnly),
        ('ackOrNackMessageOnly', __RefPictureSelection_videoBackChannelSend_ackOrNackMessageOnly),
        ('ackAndNackMessage', __RefPictureSelection_videoBackChannelSend_ackAndNackMessage),
        ])
    _RefPictureSelection_videoBackChannelSend._ext = []
    _RefPictureSelection_enhancedReferencePicSelect = SEQ(name='enhancedReferencePicSelect', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters = SEQ(name='subPictureRemovalParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuHorizMBs = INT(name='mpuHorizMBs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuHorizMBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuVertMBs = INT(name='mpuVertMBs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuVertMBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=72)], ev=None, er=[])
    ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuTotalNumber = INT(name='mpuTotalNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuTotalNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    __RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters._cont = ASN1Dict([
        ('mpuHorizMBs', ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuHorizMBs),
        ('mpuVertMBs', ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuVertMBs),
        ('mpuTotalNumber', ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuTotalNumber),
        ])
    __RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters._ext = []
    _RefPictureSelection_enhancedReferencePicSelect._cont = ASN1Dict([
        ('subPictureRemovalParameters', __RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters),
        ])
    _RefPictureSelection_enhancedReferencePicSelect._ext = []
    RefPictureSelection._cont = ASN1Dict([
        ('additionalPictureMemory', _RefPictureSelection_additionalPictureMemory),
        ('videoMux', _RefPictureSelection_videoMux),
        ('videoBackChannelSend', _RefPictureSelection_videoBackChannelSend),
        ('enhancedReferencePicSelect', _RefPictureSelection_enhancedReferencePicSelect),
        ])
    RefPictureSelection._ext = ['enhancedReferencePicSelect']
    
    #-----< CustomPictureClockFrequency >-----#
    CustomPictureClockFrequency = SEQ(name='CustomPictureClockFrequency', mode=MODE_TYPE)
    _CustomPictureClockFrequency_clockConversionCode = INT(name='clockConversionCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CustomPictureClockFrequency_clockConversionCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1000, ub=1001)], ev=None, er=[])
    _CustomPictureClockFrequency_clockDivisor = INT(name='clockDivisor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CustomPictureClockFrequency_clockDivisor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CustomPictureClockFrequency_sqcifMPI = INT(name='sqcifMPI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CustomPictureClockFrequency_sqcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureClockFrequency_qcifMPI = INT(name='qcifMPI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CustomPictureClockFrequency_qcifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureClockFrequency_cifMPI = INT(name='cifMPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CustomPictureClockFrequency_cifMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureClockFrequency_cif4MPI = INT(name='cif4MPI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CustomPictureClockFrequency_cif4MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureClockFrequency_cif16MPI = INT(name='cif16MPI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CustomPictureClockFrequency_cif16MPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    CustomPictureClockFrequency._cont = ASN1Dict([
        ('clockConversionCode', _CustomPictureClockFrequency_clockConversionCode),
        ('clockDivisor', _CustomPictureClockFrequency_clockDivisor),
        ('sqcifMPI', _CustomPictureClockFrequency_sqcifMPI),
        ('qcifMPI', _CustomPictureClockFrequency_qcifMPI),
        ('cifMPI', _CustomPictureClockFrequency_cifMPI),
        ('cif4MPI', _CustomPictureClockFrequency_cif4MPI),
        ('cif16MPI', _CustomPictureClockFrequency_cif16MPI),
        ])
    CustomPictureClockFrequency._ext = []
    
    #-----< CustomPictureFormat >-----#
    CustomPictureFormat = SEQ(name='CustomPictureFormat', mode=MODE_TYPE)
    _CustomPictureFormat_maxCustomPictureWidth = INT(name='maxCustomPictureWidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CustomPictureFormat_maxCustomPictureWidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureFormat_maxCustomPictureHeight = INT(name='maxCustomPictureHeight', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CustomPictureFormat_maxCustomPictureHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureFormat_minCustomPictureWidth = INT(name='minCustomPictureWidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CustomPictureFormat_minCustomPictureWidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureFormat_minCustomPictureHeight = INT(name='minCustomPictureHeight', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CustomPictureFormat_minCustomPictureHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _CustomPictureFormat_mPI = SEQ(name='mPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CustomPictureFormat_mPI_standardMPI = INT(name='standardMPI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CustomPictureFormat_mPI_standardMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=None, er=[])
    __CustomPictureFormat_mPI_customPCF = SET_OF(name='customPCF', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___CustomPictureFormat_mPI_customPCF__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____CustomPictureFormat_mPI_customPCF__item__clockConversionCode = INT(name='clockConversionCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____CustomPictureFormat_mPI_customPCF__item__clockConversionCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1000, ub=1001)], ev=None, er=[])
    ____CustomPictureFormat_mPI_customPCF__item__clockDivisor = INT(name='clockDivisor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____CustomPictureFormat_mPI_customPCF__item__clockDivisor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____CustomPictureFormat_mPI_customPCF__item__customMPI = INT(name='customMPI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____CustomPictureFormat_mPI_customPCF__item__customMPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    ___CustomPictureFormat_mPI_customPCF__item_._cont = ASN1Dict([
        ('clockConversionCode', ____CustomPictureFormat_mPI_customPCF__item__clockConversionCode),
        ('clockDivisor', ____CustomPictureFormat_mPI_customPCF__item__clockDivisor),
        ('customMPI', ____CustomPictureFormat_mPI_customPCF__item__customMPI),
        ])
    ___CustomPictureFormat_mPI_customPCF__item_._ext = []
    __CustomPictureFormat_mPI_customPCF._cont = ___CustomPictureFormat_mPI_customPCF__item_
    __CustomPictureFormat_mPI_customPCF._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _CustomPictureFormat_mPI._cont = ASN1Dict([
        ('standardMPI', __CustomPictureFormat_mPI_standardMPI),
        ('customPCF', __CustomPictureFormat_mPI_customPCF),
        ])
    _CustomPictureFormat_mPI._ext = []
    _CustomPictureFormat_pixelAspectInformation = CHOICE(name='pixelAspectInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CustomPictureFormat_pixelAspectInformation_anyPixelAspectRatio = BOOL(name='anyPixelAspectRatio', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CustomPictureFormat_pixelAspectInformation_pixelAspectCode = SET_OF(name='pixelAspectCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CustomPictureFormat_pixelAspectInformation_pixelAspectCode__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___CustomPictureFormat_pixelAspectInformation_pixelAspectCode__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    __CustomPictureFormat_pixelAspectInformation_pixelAspectCode._cont = ___CustomPictureFormat_pixelAspectInformation_pixelAspectCode__item_
    __CustomPictureFormat_pixelAspectInformation_pixelAspectCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    __CustomPictureFormat_pixelAspectInformation_extendedPAR = SET_OF(name='extendedPAR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CustomPictureFormat_pixelAspectInformation_extendedPAR__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__width = INT(name='width', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__width._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__height = INT(name='height', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__height._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    ___CustomPictureFormat_pixelAspectInformation_extendedPAR__item_._cont = ASN1Dict([
        ('width', ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__width),
        ('height', ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__height),
        ])
    ___CustomPictureFormat_pixelAspectInformation_extendedPAR__item_._ext = []
    __CustomPictureFormat_pixelAspectInformation_extendedPAR._cont = ___CustomPictureFormat_pixelAspectInformation_extendedPAR__item_
    __CustomPictureFormat_pixelAspectInformation_extendedPAR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _CustomPictureFormat_pixelAspectInformation._cont = ASN1Dict([
        ('anyPixelAspectRatio', __CustomPictureFormat_pixelAspectInformation_anyPixelAspectRatio),
        ('pixelAspectCode', __CustomPictureFormat_pixelAspectInformation_pixelAspectCode),
        ('extendedPAR', __CustomPictureFormat_pixelAspectInformation_extendedPAR),
        ])
    _CustomPictureFormat_pixelAspectInformation._ext = []
    CustomPictureFormat._cont = ASN1Dict([
        ('maxCustomPictureWidth', _CustomPictureFormat_maxCustomPictureWidth),
        ('maxCustomPictureHeight', _CustomPictureFormat_maxCustomPictureHeight),
        ('minCustomPictureWidth', _CustomPictureFormat_minCustomPictureWidth),
        ('minCustomPictureHeight', _CustomPictureFormat_minCustomPictureHeight),
        ('mPI', _CustomPictureFormat_mPI),
        ('pixelAspectInformation', _CustomPictureFormat_pixelAspectInformation),
        ])
    CustomPictureFormat._ext = []
    
    #-----< H263VideoModeCombos >-----#
    H263VideoModeCombos = SEQ(name='H263VideoModeCombos', mode=MODE_TYPE)
    _H263VideoModeCombos_h263VideoUncoupledModes = SEQ(name='h263VideoUncoupledModes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263ModeComboFlags')))
    _H263VideoModeCombos_h263VideoCoupledModes = SET_OF(name='h263VideoCoupledModes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H263VideoModeCombos_h263VideoCoupledModes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263ModeComboFlags')))
    _H263VideoModeCombos_h263VideoCoupledModes._cont = __H263VideoModeCombos_h263VideoCoupledModes__item_
    _H263VideoModeCombos_h263VideoCoupledModes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    H263VideoModeCombos._cont = ASN1Dict([
        ('h263VideoUncoupledModes', _H263VideoModeCombos_h263VideoUncoupledModes),
        ('h263VideoCoupledModes', _H263VideoModeCombos_h263VideoCoupledModes),
        ])
    H263VideoModeCombos._ext = []
    
    #-----< H263ModeComboFlags >-----#
    H263ModeComboFlags = SEQ(name='H263ModeComboFlags', mode=MODE_TYPE)
    _H263ModeComboFlags_unrestrictedVector = BOOL(name='unrestrictedVector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_arithmeticCoding = BOOL(name='arithmeticCoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_advancedPrediction = BOOL(name='advancedPrediction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_pbFrames = BOOL(name='pbFrames', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_advancedIntraCodingMode = BOOL(name='advancedIntraCodingMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_deblockingFilterMode = BOOL(name='deblockingFilterMode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_unlimitedMotionVectors = BOOL(name='unlimitedMotionVectors', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_slicesInOrder_NonRect = BOOL(name='slicesInOrder-NonRect', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_slicesInOrder_Rect = BOOL(name='slicesInOrder-Rect', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_slicesNoOrder_NonRect = BOOL(name='slicesNoOrder-NonRect', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_slicesNoOrder_Rect = BOOL(name='slicesNoOrder-Rect', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_improvedPBFramesMode = BOOL(name='improvedPBFramesMode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_referencePicSelect = BOOL(name='referencePicSelect', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_dynamicPictureResizingByFour = BOOL(name='dynamicPictureResizingByFour', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_dynamicPictureResizingSixteenthPel = BOOL(name='dynamicPictureResizingSixteenthPel', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_dynamicWarpingHalfPel = BOOL(name='dynamicWarpingHalfPel', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_dynamicWarpingSixteenthPel = BOOL(name='dynamicWarpingSixteenthPel', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_reducedResolutionUpdate = BOOL(name='reducedResolutionUpdate', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_independentSegmentDecoding = BOOL(name='independentSegmentDecoding', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_alternateInterVLCMode = BOOL(name='alternateInterVLCMode', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_modifiedQuantizationMode = BOOL(name='modifiedQuantizationMode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_enhancedReferencePicSelect = BOOL(name='enhancedReferencePicSelect', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263ModeComboFlags_h263Version3Options = SEQ(name='h263Version3Options', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263Version3Options')))
    H263ModeComboFlags._cont = ASN1Dict([
        ('unrestrictedVector', _H263ModeComboFlags_unrestrictedVector),
        ('arithmeticCoding', _H263ModeComboFlags_arithmeticCoding),
        ('advancedPrediction', _H263ModeComboFlags_advancedPrediction),
        ('pbFrames', _H263ModeComboFlags_pbFrames),
        ('advancedIntraCodingMode', _H263ModeComboFlags_advancedIntraCodingMode),
        ('deblockingFilterMode', _H263ModeComboFlags_deblockingFilterMode),
        ('unlimitedMotionVectors', _H263ModeComboFlags_unlimitedMotionVectors),
        ('slicesInOrder-NonRect', _H263ModeComboFlags_slicesInOrder_NonRect),
        ('slicesInOrder-Rect', _H263ModeComboFlags_slicesInOrder_Rect),
        ('slicesNoOrder-NonRect', _H263ModeComboFlags_slicesNoOrder_NonRect),
        ('slicesNoOrder-Rect', _H263ModeComboFlags_slicesNoOrder_Rect),
        ('improvedPBFramesMode', _H263ModeComboFlags_improvedPBFramesMode),
        ('referencePicSelect', _H263ModeComboFlags_referencePicSelect),
        ('dynamicPictureResizingByFour', _H263ModeComboFlags_dynamicPictureResizingByFour),
        ('dynamicPictureResizingSixteenthPel', _H263ModeComboFlags_dynamicPictureResizingSixteenthPel),
        ('dynamicWarpingHalfPel', _H263ModeComboFlags_dynamicWarpingHalfPel),
        ('dynamicWarpingSixteenthPel', _H263ModeComboFlags_dynamicWarpingSixteenthPel),
        ('reducedResolutionUpdate', _H263ModeComboFlags_reducedResolutionUpdate),
        ('independentSegmentDecoding', _H263ModeComboFlags_independentSegmentDecoding),
        ('alternateInterVLCMode', _H263ModeComboFlags_alternateInterVLCMode),
        ('modifiedQuantizationMode', _H263ModeComboFlags_modifiedQuantizationMode),
        ('enhancedReferencePicSelect', _H263ModeComboFlags_enhancedReferencePicSelect),
        ('h263Version3Options', _H263ModeComboFlags_h263Version3Options),
        ])
    H263ModeComboFlags._ext = ['enhancedReferencePicSelect', 'h263Version3Options']
    
    #-----< H263Version3Options >-----#
    H263Version3Options = SEQ(name='H263Version3Options', mode=MODE_TYPE)
    _H263Version3Options_dataPartitionedSlices = BOOL(name='dataPartitionedSlices', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_fixedPointIDCT0 = BOOL(name='fixedPointIDCT0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_interlacedFields = BOOL(name='interlacedFields', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_currentPictureHeaderRepetition = BOOL(name='currentPictureHeaderRepetition', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_previousPictureHeaderRepetition = BOOL(name='previousPictureHeaderRepetition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_nextPictureHeaderRepetition = BOOL(name='nextPictureHeaderRepetition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_pictureNumber = BOOL(name='pictureNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263Version3Options_spareReferencePictures = BOOL(name='spareReferencePictures', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H263Version3Options._cont = ASN1Dict([
        ('dataPartitionedSlices', _H263Version3Options_dataPartitionedSlices),
        ('fixedPointIDCT0', _H263Version3Options_fixedPointIDCT0),
        ('interlacedFields', _H263Version3Options_interlacedFields),
        ('currentPictureHeaderRepetition', _H263Version3Options_currentPictureHeaderRepetition),
        ('previousPictureHeaderRepetition', _H263Version3Options_previousPictureHeaderRepetition),
        ('nextPictureHeaderRepetition', _H263Version3Options_nextPictureHeaderRepetition),
        ('pictureNumber', _H263Version3Options_pictureNumber),
        ('spareReferencePictures', _H263Version3Options_spareReferencePictures),
        ])
    H263Version3Options._ext = []
    
    #-----< IS11172VideoCapability >-----#
    IS11172VideoCapability = SEQ(name='IS11172VideoCapability', mode=MODE_TYPE)
    _IS11172VideoCapability_constrainedBitstream = BOOL(name='constrainedBitstream', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172VideoCapability_videoBitRate = INT(name='videoBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoCapability_videoBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1073741823)], ev=None, er=[])
    _IS11172VideoCapability_vbvBufferSize = INT(name='vbvBufferSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoCapability_vbvBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _IS11172VideoCapability_samplesPerLine = INT(name='samplesPerLine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoCapability_samplesPerLine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _IS11172VideoCapability_linesPerFrame = INT(name='linesPerFrame', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoCapability_linesPerFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _IS11172VideoCapability_pictureRate = INT(name='pictureRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoCapability_pictureRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _IS11172VideoCapability_luminanceSampleRate = INT(name='luminanceSampleRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoCapability_luminanceSampleRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _IS11172VideoCapability_videoBadMBsCap = BOOL(name='videoBadMBsCap', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    IS11172VideoCapability._cont = ASN1Dict([
        ('constrainedBitstream', _IS11172VideoCapability_constrainedBitstream),
        ('videoBitRate', _IS11172VideoCapability_videoBitRate),
        ('vbvBufferSize', _IS11172VideoCapability_vbvBufferSize),
        ('samplesPerLine', _IS11172VideoCapability_samplesPerLine),
        ('linesPerFrame', _IS11172VideoCapability_linesPerFrame),
        ('pictureRate', _IS11172VideoCapability_pictureRate),
        ('luminanceSampleRate', _IS11172VideoCapability_luminanceSampleRate),
        ('videoBadMBsCap', _IS11172VideoCapability_videoBadMBsCap),
        ])
    IS11172VideoCapability._ext = ['videoBadMBsCap']
    
    #-----< AudioCapability >-----#
    AudioCapability = CHOICE(name='AudioCapability', mode=MODE_TYPE)
    _AudioCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _AudioCapability_g711Alaw64k = INT(name='g711Alaw64k', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g711Alaw64k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g711Alaw56k = INT(name='g711Alaw56k', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g711Alaw56k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g711Ulaw64k = INT(name='g711Ulaw64k', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g711Ulaw64k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g711Ulaw56k = INT(name='g711Ulaw56k', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g711Ulaw56k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g722_64k = INT(name='g722-64k', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g722_64k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g722_56k = INT(name='g722-56k', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g722_56k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g722_48k = INT(name='g722-48k', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g722_48k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g7231 = SEQ(name='g7231', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AudioCapability_g7231_maxAl_sduAudioFrames = INT(name='maxAl-sduAudioFrames', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AudioCapability_g7231_maxAl_sduAudioFrames._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    __AudioCapability_g7231_silenceSuppression = BOOL(name='silenceSuppression', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g7231._cont = ASN1Dict([
        ('maxAl-sduAudioFrames', __AudioCapability_g7231_maxAl_sduAudioFrames),
        ('silenceSuppression', __AudioCapability_g7231_silenceSuppression),
        ])
    _AudioCapability_g7231._ext = None
    _AudioCapability_g728 = INT(name='g728', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g728._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g729 = INT(name='g729', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g729._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g729AnnexA = INT(name='g729AnnexA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g729AnnexA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_is11172AudioCapability = SEQ(name='is11172AudioCapability', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IS11172AudioCapability')))
    _AudioCapability_is13818AudioCapability = SEQ(name='is13818AudioCapability', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IS13818AudioCapability')))
    _AudioCapability_g729wAnnexB = INT(name='g729wAnnexB', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g729wAnnexB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g729AnnexAwAnnexB = INT(name='g729AnnexAwAnnexB', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioCapability_g729AnnexAwAnnexB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioCapability_g7231AnnexCCapability = SEQ(name='g7231AnnexCCapability', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'G7231AnnexCCapability')))
    _AudioCapability_gsmFullRate = SEQ(name='gsmFullRate', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GSMAudioCapability')))
    _AudioCapability_gsmHalfRate = SEQ(name='gsmHalfRate', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GSMAudioCapability')))
    _AudioCapability_gsmEnhancedFullRate = SEQ(name='gsmEnhancedFullRate', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GSMAudioCapability')))
    _AudioCapability_genericAudioCapability = SEQ(name='genericAudioCapability', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _AudioCapability_g729Extensions = SEQ(name='g729Extensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'G729Extensions')))
    _AudioCapability_vbd = SEQ(name='vbd', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VBDCapability')))
    _AudioCapability_audioTelephonyEvent = SEQ(name='audioTelephonyEvent', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NoPTAudioTelephonyEventCapability')))
    _AudioCapability_audioTone = SEQ(name='audioTone', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NoPTAudioToneCapability')))
    AudioCapability._cont = ASN1Dict([
        ('nonStandard', _AudioCapability_nonStandard),
        ('g711Alaw64k', _AudioCapability_g711Alaw64k),
        ('g711Alaw56k', _AudioCapability_g711Alaw56k),
        ('g711Ulaw64k', _AudioCapability_g711Ulaw64k),
        ('g711Ulaw56k', _AudioCapability_g711Ulaw56k),
        ('g722-64k', _AudioCapability_g722_64k),
        ('g722-56k', _AudioCapability_g722_56k),
        ('g722-48k', _AudioCapability_g722_48k),
        ('g7231', _AudioCapability_g7231),
        ('g728', _AudioCapability_g728),
        ('g729', _AudioCapability_g729),
        ('g729AnnexA', _AudioCapability_g729AnnexA),
        ('is11172AudioCapability', _AudioCapability_is11172AudioCapability),
        ('is13818AudioCapability', _AudioCapability_is13818AudioCapability),
        ('g729wAnnexB', _AudioCapability_g729wAnnexB),
        ('g729AnnexAwAnnexB', _AudioCapability_g729AnnexAwAnnexB),
        ('g7231AnnexCCapability', _AudioCapability_g7231AnnexCCapability),
        ('gsmFullRate', _AudioCapability_gsmFullRate),
        ('gsmHalfRate', _AudioCapability_gsmHalfRate),
        ('gsmEnhancedFullRate', _AudioCapability_gsmEnhancedFullRate),
        ('genericAudioCapability', _AudioCapability_genericAudioCapability),
        ('g729Extensions', _AudioCapability_g729Extensions),
        ('vbd', _AudioCapability_vbd),
        ('audioTelephonyEvent', _AudioCapability_audioTelephonyEvent),
        ('audioTone', _AudioCapability_audioTone),
        ])
    AudioCapability._ext = ['g729wAnnexB', 'g729AnnexAwAnnexB', 'g7231AnnexCCapability', 'gsmFullRate', 'gsmHalfRate', 'gsmEnhancedFullRate', 'genericAudioCapability', 'g729Extensions', 'vbd', 'audioTelephonyEvent', 'audioTone']
    
    #-----< G729Extensions >-----#
    G729Extensions = SEQ(name='G729Extensions', mode=MODE_TYPE)
    _G729Extensions_audioUnit = INT(name='audioUnit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _G729Extensions_audioUnit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _G729Extensions_annexA = BOOL(name='annexA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G729Extensions_annexB = BOOL(name='annexB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G729Extensions_annexD = BOOL(name='annexD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G729Extensions_annexE = BOOL(name='annexE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G729Extensions_annexF = BOOL(name='annexF', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G729Extensions_annexG = BOOL(name='annexG', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G729Extensions_annexH = BOOL(name='annexH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    G729Extensions._cont = ASN1Dict([
        ('audioUnit', _G729Extensions_audioUnit),
        ('annexA', _G729Extensions_annexA),
        ('annexB', _G729Extensions_annexB),
        ('annexD', _G729Extensions_annexD),
        ('annexE', _G729Extensions_annexE),
        ('annexF', _G729Extensions_annexF),
        ('annexG', _G729Extensions_annexG),
        ('annexH', _G729Extensions_annexH),
        ])
    G729Extensions._ext = []
    
    #-----< G7231AnnexCCapability >-----#
    G7231AnnexCCapability = SEQ(name='G7231AnnexCCapability', mode=MODE_TYPE)
    _G7231AnnexCCapability_maxAl_sduAudioFrames = INT(name='maxAl-sduAudioFrames', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G7231AnnexCCapability_maxAl_sduAudioFrames._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _G7231AnnexCCapability_silenceSuppression = BOOL(name='silenceSuppression', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G7231AnnexCCapability_g723AnnexCAudioMode = SEQ(name='g723AnnexCAudioMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode0 = INT(name='highRateMode0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=27, ub=78)], ev=None, er=[])
    __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode1 = INT(name='highRateMode1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=27, ub=78)], ev=None, er=[])
    __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode0 = INT(name='lowRateMode0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=23, ub=66)], ev=None, er=[])
    __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode1 = INT(name='lowRateMode1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=23, ub=66)], ev=None, er=[])
    __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode0 = INT(name='sidMode0', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=17)], ev=None, er=[])
    __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode1 = INT(name='sidMode1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=17)], ev=None, er=[])
    _G7231AnnexCCapability_g723AnnexCAudioMode._cont = ASN1Dict([
        ('highRateMode0', __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode0),
        ('highRateMode1', __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode1),
        ('lowRateMode0', __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode0),
        ('lowRateMode1', __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode1),
        ('sidMode0', __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode0),
        ('sidMode1', __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode1),
        ])
    _G7231AnnexCCapability_g723AnnexCAudioMode._ext = []
    G7231AnnexCCapability._cont = ASN1Dict([
        ('maxAl-sduAudioFrames', _G7231AnnexCCapability_maxAl_sduAudioFrames),
        ('silenceSuppression', _G7231AnnexCCapability_silenceSuppression),
        ('g723AnnexCAudioMode', _G7231AnnexCCapability_g723AnnexCAudioMode),
        ])
    G7231AnnexCCapability._ext = []
    
    #-----< IS11172AudioCapability >-----#
    IS11172AudioCapability = SEQ(name='IS11172AudioCapability', mode=MODE_TYPE)
    _IS11172AudioCapability_audioLayer1 = BOOL(name='audioLayer1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_audioLayer2 = BOOL(name='audioLayer2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_audioLayer3 = BOOL(name='audioLayer3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_audioSampling32k = BOOL(name='audioSampling32k', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_audioSampling44k1 = BOOL(name='audioSampling44k1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_audioSampling48k = BOOL(name='audioSampling48k', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_singleChannel = BOOL(name='singleChannel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_twoChannels = BOOL(name='twoChannels', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioCapability_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=448)], ev=None, er=[])
    IS11172AudioCapability._cont = ASN1Dict([
        ('audioLayer1', _IS11172AudioCapability_audioLayer1),
        ('audioLayer2', _IS11172AudioCapability_audioLayer2),
        ('audioLayer3', _IS11172AudioCapability_audioLayer3),
        ('audioSampling32k', _IS11172AudioCapability_audioSampling32k),
        ('audioSampling44k1', _IS11172AudioCapability_audioSampling44k1),
        ('audioSampling48k', _IS11172AudioCapability_audioSampling48k),
        ('singleChannel', _IS11172AudioCapability_singleChannel),
        ('twoChannels', _IS11172AudioCapability_twoChannels),
        ('bitRate', _IS11172AudioCapability_bitRate),
        ])
    IS11172AudioCapability._ext = []
    
    #-----< IS13818AudioCapability >-----#
    IS13818AudioCapability = SEQ(name='IS13818AudioCapability', mode=MODE_TYPE)
    _IS13818AudioCapability_audioLayer1 = BOOL(name='audioLayer1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioLayer2 = BOOL(name='audioLayer2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioLayer3 = BOOL(name='audioLayer3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioSampling16k = BOOL(name='audioSampling16k', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioSampling22k05 = BOOL(name='audioSampling22k05', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioSampling24k = BOOL(name='audioSampling24k', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioSampling32k = BOOL(name='audioSampling32k', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioSampling44k1 = BOOL(name='audioSampling44k1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_audioSampling48k = BOOL(name='audioSampling48k', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_singleChannel = BOOL(name='singleChannel', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_twoChannels = BOOL(name='twoChannels', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_threeChannels2_1 = BOOL(name='threeChannels2-1', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_threeChannels3_0 = BOOL(name='threeChannels3-0', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_fourChannels2_0_2_0 = BOOL(name='fourChannels2-0-2-0', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_fourChannels2_2 = BOOL(name='fourChannels2-2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_fourChannels3_1 = BOOL(name='fourChannels3-1', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_fiveChannels3_0_2_0 = BOOL(name='fiveChannels3-0-2-0', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_fiveChannels3_2 = BOOL(name='fiveChannels3-2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_lowFrequencyEnhancement = BOOL(name='lowFrequencyEnhancement', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_multilingual = BOOL(name='multilingual', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioCapability_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1130)], ev=None, er=[])
    IS13818AudioCapability._cont = ASN1Dict([
        ('audioLayer1', _IS13818AudioCapability_audioLayer1),
        ('audioLayer2', _IS13818AudioCapability_audioLayer2),
        ('audioLayer3', _IS13818AudioCapability_audioLayer3),
        ('audioSampling16k', _IS13818AudioCapability_audioSampling16k),
        ('audioSampling22k05', _IS13818AudioCapability_audioSampling22k05),
        ('audioSampling24k', _IS13818AudioCapability_audioSampling24k),
        ('audioSampling32k', _IS13818AudioCapability_audioSampling32k),
        ('audioSampling44k1', _IS13818AudioCapability_audioSampling44k1),
        ('audioSampling48k', _IS13818AudioCapability_audioSampling48k),
        ('singleChannel', _IS13818AudioCapability_singleChannel),
        ('twoChannels', _IS13818AudioCapability_twoChannels),
        ('threeChannels2-1', _IS13818AudioCapability_threeChannels2_1),
        ('threeChannels3-0', _IS13818AudioCapability_threeChannels3_0),
        ('fourChannels2-0-2-0', _IS13818AudioCapability_fourChannels2_0_2_0),
        ('fourChannels2-2', _IS13818AudioCapability_fourChannels2_2),
        ('fourChannels3-1', _IS13818AudioCapability_fourChannels3_1),
        ('fiveChannels3-0-2-0', _IS13818AudioCapability_fiveChannels3_0_2_0),
        ('fiveChannels3-2', _IS13818AudioCapability_fiveChannels3_2),
        ('lowFrequencyEnhancement', _IS13818AudioCapability_lowFrequencyEnhancement),
        ('multilingual', _IS13818AudioCapability_multilingual),
        ('bitRate', _IS13818AudioCapability_bitRate),
        ])
    IS13818AudioCapability._ext = []
    
    #-----< GSMAudioCapability >-----#
    GSMAudioCapability = SEQ(name='GSMAudioCapability', mode=MODE_TYPE)
    _GSMAudioCapability_audioUnitSize = INT(name='audioUnitSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GSMAudioCapability_audioUnitSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _GSMAudioCapability_comfortNoise = BOOL(name='comfortNoise', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GSMAudioCapability_scrambled = BOOL(name='scrambled', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GSMAudioCapability._cont = ASN1Dict([
        ('audioUnitSize', _GSMAudioCapability_audioUnitSize),
        ('comfortNoise', _GSMAudioCapability_comfortNoise),
        ('scrambled', _GSMAudioCapability_scrambled),
        ])
    GSMAudioCapability._ext = []
    
    #-----< VBDCapability >-----#
    VBDCapability = SEQ(name='VBDCapability', mode=MODE_TYPE)
    _VBDCapability_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    VBDCapability._cont = ASN1Dict([
        ('type', _VBDCapability_type),
        ])
    VBDCapability._ext = []
    
    #-----< DataApplicationCapability >-----#
    DataApplicationCapability = SEQ(name='DataApplicationCapability', mode=MODE_TYPE)
    _DataApplicationCapability_application = CHOICE(name='application', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __DataApplicationCapability_application_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __DataApplicationCapability_application_t120 = CHOICE(name='t120', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_dsm_cc = CHOICE(name='dsm-cc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_userData = CHOICE(name='userData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_t84 = SEQ(name='t84', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DataApplicationCapability_application_t84_t84Protocol = CHOICE(name='t84Protocol', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    ___DataApplicationCapability_application_t84_t84Profile = CHOICE(name='t84Profile', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'T84Profile')))
    __DataApplicationCapability_application_t84._cont = ASN1Dict([
        ('t84Protocol', ___DataApplicationCapability_application_t84_t84Protocol),
        ('t84Profile', ___DataApplicationCapability_application_t84_t84Profile),
        ])
    __DataApplicationCapability_application_t84._ext = None
    __DataApplicationCapability_application_t434 = CHOICE(name='t434', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_h224 = CHOICE(name='h224', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_nlpid = SEQ(name='nlpid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DataApplicationCapability_application_nlpid_nlpidProtocol = CHOICE(name='nlpidProtocol', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    ___DataApplicationCapability_application_nlpid_nlpidData = OCT_STR(name='nlpidData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DataApplicationCapability_application_nlpid._cont = ASN1Dict([
        ('nlpidProtocol', ___DataApplicationCapability_application_nlpid_nlpidProtocol),
        ('nlpidData', ___DataApplicationCapability_application_nlpid_nlpidData),
        ])
    __DataApplicationCapability_application_nlpid._ext = None
    __DataApplicationCapability_application_dsvdControl = NULL(name='dsvdControl', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DataApplicationCapability_application_h222DataPartitioning = CHOICE(name='h222DataPartitioning', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_t30fax = CHOICE(name='t30fax', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_t140 = CHOICE(name='t140', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataApplicationCapability_application_t38fax = SEQ(name='t38fax', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DataApplicationCapability_application_t38fax_t38FaxProtocol = CHOICE(name='t38FaxProtocol', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    ___DataApplicationCapability_application_t38fax_t38FaxProfile = SEQ(name='t38FaxProfile', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'T38FaxProfile')))
    __DataApplicationCapability_application_t38fax._cont = ASN1Dict([
        ('t38FaxProtocol', ___DataApplicationCapability_application_t38fax_t38FaxProtocol),
        ('t38FaxProfile', ___DataApplicationCapability_application_t38fax_t38FaxProfile),
        ])
    __DataApplicationCapability_application_t38fax._ext = None
    __DataApplicationCapability_application_genericDataCapability = SEQ(name='genericDataCapability', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _DataApplicationCapability_application._cont = ASN1Dict([
        ('nonStandard', __DataApplicationCapability_application_nonStandard),
        ('t120', __DataApplicationCapability_application_t120),
        ('dsm-cc', __DataApplicationCapability_application_dsm_cc),
        ('userData', __DataApplicationCapability_application_userData),
        ('t84', __DataApplicationCapability_application_t84),
        ('t434', __DataApplicationCapability_application_t434),
        ('h224', __DataApplicationCapability_application_h224),
        ('nlpid', __DataApplicationCapability_application_nlpid),
        ('dsvdControl', __DataApplicationCapability_application_dsvdControl),
        ('h222DataPartitioning', __DataApplicationCapability_application_h222DataPartitioning),
        ('t30fax', __DataApplicationCapability_application_t30fax),
        ('t140', __DataApplicationCapability_application_t140),
        ('t38fax', __DataApplicationCapability_application_t38fax),
        ('genericDataCapability', __DataApplicationCapability_application_genericDataCapability),
        ])
    _DataApplicationCapability_application._ext = ['t30fax', 't140', 't38fax', 'genericDataCapability']
    _DataApplicationCapability_maxBitRate = INT(name='maxBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataApplicationCapability_maxBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    DataApplicationCapability._cont = ASN1Dict([
        ('application', _DataApplicationCapability_application),
        ('maxBitRate', _DataApplicationCapability_maxBitRate),
        ])
    DataApplicationCapability._ext = []
    
    #-----< DataProtocolCapability >-----#
    DataProtocolCapability = CHOICE(name='DataProtocolCapability', mode=MODE_TYPE)
    _DataProtocolCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _DataProtocolCapability_v14buffered = NULL(name='v14buffered', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_v42lapm = NULL(name='v42lapm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_hdlcFrameTunnelling = NULL(name='hdlcFrameTunnelling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_h310SeparateVCStack = NULL(name='h310SeparateVCStack', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_h310SingleVCStack = NULL(name='h310SingleVCStack', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_transparent = NULL(name='transparent', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_segmentationAndReassembly = NULL(name='segmentationAndReassembly', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_hdlcFrameTunnelingwSAR = NULL(name='hdlcFrameTunnelingwSAR', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_v120 = NULL(name='v120', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_separateLANStack = NULL(name='separateLANStack', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_v76wCompression = CHOICE(name='v76wCompression', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __DataProtocolCapability_v76wCompression_transmitCompression = CHOICE(name='transmitCompression', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CompressionType')))
    __DataProtocolCapability_v76wCompression_receiveCompression = CHOICE(name='receiveCompression', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CompressionType')))
    __DataProtocolCapability_v76wCompression_transmitAndReceiveCompression = CHOICE(name='transmitAndReceiveCompression', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CompressionType')))
    _DataProtocolCapability_v76wCompression._cont = ASN1Dict([
        ('transmitCompression', __DataProtocolCapability_v76wCompression_transmitCompression),
        ('receiveCompression', __DataProtocolCapability_v76wCompression_receiveCompression),
        ('transmitAndReceiveCompression', __DataProtocolCapability_v76wCompression_transmitAndReceiveCompression),
        ])
    _DataProtocolCapability_v76wCompression._ext = []
    _DataProtocolCapability_tcp = NULL(name='tcp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataProtocolCapability_udp = NULL(name='udp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DataProtocolCapability._cont = ASN1Dict([
        ('nonStandard', _DataProtocolCapability_nonStandard),
        ('v14buffered', _DataProtocolCapability_v14buffered),
        ('v42lapm', _DataProtocolCapability_v42lapm),
        ('hdlcFrameTunnelling', _DataProtocolCapability_hdlcFrameTunnelling),
        ('h310SeparateVCStack', _DataProtocolCapability_h310SeparateVCStack),
        ('h310SingleVCStack', _DataProtocolCapability_h310SingleVCStack),
        ('transparent', _DataProtocolCapability_transparent),
        ('segmentationAndReassembly', _DataProtocolCapability_segmentationAndReassembly),
        ('hdlcFrameTunnelingwSAR', _DataProtocolCapability_hdlcFrameTunnelingwSAR),
        ('v120', _DataProtocolCapability_v120),
        ('separateLANStack', _DataProtocolCapability_separateLANStack),
        ('v76wCompression', _DataProtocolCapability_v76wCompression),
        ('tcp', _DataProtocolCapability_tcp),
        ('udp', _DataProtocolCapability_udp),
        ])
    DataProtocolCapability._ext = ['segmentationAndReassembly', 'hdlcFrameTunnelingwSAR', 'v120', 'separateLANStack', 'v76wCompression', 'tcp', 'udp']
    
    #-----< CompressionType >-----#
    CompressionType = CHOICE(name='CompressionType', mode=MODE_TYPE)
    _CompressionType_v42bis = SEQ(name='v42bis', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V42bis')))
    CompressionType._cont = ASN1Dict([
        ('v42bis', _CompressionType_v42bis),
        ])
    CompressionType._ext = []
    
    #-----< V42bis >-----#
    V42bis = SEQ(name='V42bis', mode=MODE_TYPE)
    _V42bis_numberOfCodewords = INT(name='numberOfCodewords', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V42bis_numberOfCodewords._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    _V42bis_maximumStringLength = INT(name='maximumStringLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V42bis_maximumStringLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    V42bis._cont = ASN1Dict([
        ('numberOfCodewords', _V42bis_numberOfCodewords),
        ('maximumStringLength', _V42bis_maximumStringLength),
        ])
    V42bis._ext = []
    
    #-----< T84Profile >-----#
    T84Profile = CHOICE(name='T84Profile', mode=MODE_TYPE)
    _T84Profile_t84Unrestricted = NULL(name='t84Unrestricted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T84Profile_t84Restricted = SEQ(name='t84Restricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_qcif = BOOL(name='qcif', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_cif = BOOL(name='cif', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_ccir601Seq = BOOL(name='ccir601Seq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_ccir601Prog = BOOL(name='ccir601Prog', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_hdtvSeq = BOOL(name='hdtvSeq', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_hdtvProg = BOOL(name='hdtvProg', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_g3FacsMH200x100 = BOOL(name='g3FacsMH200x100', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_g3FacsMH200x200 = BOOL(name='g3FacsMH200x200', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_g4FacsMMR200x100 = BOOL(name='g4FacsMMR200x100', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_g4FacsMMR200x200 = BOOL(name='g4FacsMMR200x200', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_jbig200x200Seq = BOOL(name='jbig200x200Seq', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_jbig200x200Prog = BOOL(name='jbig200x200Prog', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_jbig300x300Seq = BOOL(name='jbig300x300Seq', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_jbig300x300Prog = BOOL(name='jbig300x300Prog', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_digPhotoLow = BOOL(name='digPhotoLow', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_digPhotoMedSeq = BOOL(name='digPhotoMedSeq', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_digPhotoMedProg = BOOL(name='digPhotoMedProg', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_digPhotoHighSeq = BOOL(name='digPhotoHighSeq', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T84Profile_t84Restricted_digPhotoHighProg = BOOL(name='digPhotoHighProg', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T84Profile_t84Restricted._cont = ASN1Dict([
        ('qcif', __T84Profile_t84Restricted_qcif),
        ('cif', __T84Profile_t84Restricted_cif),
        ('ccir601Seq', __T84Profile_t84Restricted_ccir601Seq),
        ('ccir601Prog', __T84Profile_t84Restricted_ccir601Prog),
        ('hdtvSeq', __T84Profile_t84Restricted_hdtvSeq),
        ('hdtvProg', __T84Profile_t84Restricted_hdtvProg),
        ('g3FacsMH200x100', __T84Profile_t84Restricted_g3FacsMH200x100),
        ('g3FacsMH200x200', __T84Profile_t84Restricted_g3FacsMH200x200),
        ('g4FacsMMR200x100', __T84Profile_t84Restricted_g4FacsMMR200x100),
        ('g4FacsMMR200x200', __T84Profile_t84Restricted_g4FacsMMR200x200),
        ('jbig200x200Seq', __T84Profile_t84Restricted_jbig200x200Seq),
        ('jbig200x200Prog', __T84Profile_t84Restricted_jbig200x200Prog),
        ('jbig300x300Seq', __T84Profile_t84Restricted_jbig300x300Seq),
        ('jbig300x300Prog', __T84Profile_t84Restricted_jbig300x300Prog),
        ('digPhotoLow', __T84Profile_t84Restricted_digPhotoLow),
        ('digPhotoMedSeq', __T84Profile_t84Restricted_digPhotoMedSeq),
        ('digPhotoMedProg', __T84Profile_t84Restricted_digPhotoMedProg),
        ('digPhotoHighSeq', __T84Profile_t84Restricted_digPhotoHighSeq),
        ('digPhotoHighProg', __T84Profile_t84Restricted_digPhotoHighProg),
        ])
    _T84Profile_t84Restricted._ext = []
    T84Profile._cont = ASN1Dict([
        ('t84Unrestricted', _T84Profile_t84Unrestricted),
        ('t84Restricted', _T84Profile_t84Restricted),
        ])
    T84Profile._ext = None
    
    #-----< T38FaxProfile >-----#
    T38FaxProfile = SEQ(name='T38FaxProfile', mode=MODE_TYPE)
    _T38FaxProfile_fillBitRemoval = BOOL(name='fillBitRemoval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T38FaxProfile_transcodingJBIG = BOOL(name='transcodingJBIG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T38FaxProfile_transcodingMMR = BOOL(name='transcodingMMR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T38FaxProfile_version = INT(name='version', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T38FaxProfile_version._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _T38FaxProfile_t38FaxRateManagement = CHOICE(name='t38FaxRateManagement', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'T38FaxRateManagement')))
    _T38FaxProfile_t38FaxUdpOptions = SEQ(name='t38FaxUdpOptions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'T38FaxUdpOptions')), opt=True)
    _T38FaxProfile_t38FaxTcpOptions = SEQ(name='t38FaxTcpOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'T38FaxTcpOptions')), opt=True)
    T38FaxProfile._cont = ASN1Dict([
        ('fillBitRemoval', _T38FaxProfile_fillBitRemoval),
        ('transcodingJBIG', _T38FaxProfile_transcodingJBIG),
        ('transcodingMMR', _T38FaxProfile_transcodingMMR),
        ('version', _T38FaxProfile_version),
        ('t38FaxRateManagement', _T38FaxProfile_t38FaxRateManagement),
        ('t38FaxUdpOptions', _T38FaxProfile_t38FaxUdpOptions),
        ('t38FaxTcpOptions', _T38FaxProfile_t38FaxTcpOptions),
        ])
    T38FaxProfile._ext = ['version', 't38FaxRateManagement', 't38FaxUdpOptions', 't38FaxTcpOptions']
    
    #-----< T38FaxRateManagement >-----#
    T38FaxRateManagement = CHOICE(name='T38FaxRateManagement', mode=MODE_TYPE)
    _T38FaxRateManagement_localTCF = NULL(name='localTCF', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T38FaxRateManagement_transferredTCF = NULL(name='transferredTCF', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    T38FaxRateManagement._cont = ASN1Dict([
        ('localTCF', _T38FaxRateManagement_localTCF),
        ('transferredTCF', _T38FaxRateManagement_transferredTCF),
        ])
    T38FaxRateManagement._ext = []
    
    #-----< T38FaxUdpOptions >-----#
    T38FaxUdpOptions = SEQ(name='T38FaxUdpOptions', mode=MODE_TYPE)
    _T38FaxUdpOptions_t38FaxMaxBuffer = INT(name='t38FaxMaxBuffer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _T38FaxUdpOptions_t38FaxMaxDatagram = INT(name='t38FaxMaxDatagram', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _T38FaxUdpOptions_t38FaxUdpEC = CHOICE(name='t38FaxUdpEC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __T38FaxUdpOptions_t38FaxUdpEC_t38UDPFEC = NULL(name='t38UDPFEC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __T38FaxUdpOptions_t38FaxUdpEC_t38UDPRedundancy = NULL(name='t38UDPRedundancy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _T38FaxUdpOptions_t38FaxUdpEC._cont = ASN1Dict([
        ('t38UDPFEC', __T38FaxUdpOptions_t38FaxUdpEC_t38UDPFEC),
        ('t38UDPRedundancy', __T38FaxUdpOptions_t38FaxUdpEC_t38UDPRedundancy),
        ])
    _T38FaxUdpOptions_t38FaxUdpEC._ext = []
    T38FaxUdpOptions._cont = ASN1Dict([
        ('t38FaxMaxBuffer', _T38FaxUdpOptions_t38FaxMaxBuffer),
        ('t38FaxMaxDatagram', _T38FaxUdpOptions_t38FaxMaxDatagram),
        ('t38FaxUdpEC', _T38FaxUdpOptions_t38FaxUdpEC),
        ])
    T38FaxUdpOptions._ext = None
    
    #-----< T38FaxTcpOptions >-----#
    T38FaxTcpOptions = SEQ(name='T38FaxTcpOptions', mode=MODE_TYPE)
    _T38FaxTcpOptions_t38TCPBidirectionalMode = BOOL(name='t38TCPBidirectionalMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    T38FaxTcpOptions._cont = ASN1Dict([
        ('t38TCPBidirectionalMode', _T38FaxTcpOptions_t38TCPBidirectionalMode),
        ])
    T38FaxTcpOptions._ext = []
    
    #-----< EncryptionAuthenticationAndIntegrity >-----#
    EncryptionAuthenticationAndIntegrity = SEQ(name='EncryptionAuthenticationAndIntegrity', mode=MODE_TYPE)
    _EncryptionAuthenticationAndIntegrity_encryptionCapability = SEQ_OF(name='encryptionCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionCapability')), opt=True)
    _EncryptionAuthenticationAndIntegrity_authenticationCapability = SEQ(name='authenticationCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AuthenticationCapability')), opt=True)
    _EncryptionAuthenticationAndIntegrity_integrityCapability = SEQ(name='integrityCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IntegrityCapability')), opt=True)
    _EncryptionAuthenticationAndIntegrity_genericH235SecurityCapability = SEQ(name='genericH235SecurityCapability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')), opt=True)
    EncryptionAuthenticationAndIntegrity._cont = ASN1Dict([
        ('encryptionCapability', _EncryptionAuthenticationAndIntegrity_encryptionCapability),
        ('authenticationCapability', _EncryptionAuthenticationAndIntegrity_authenticationCapability),
        ('integrityCapability', _EncryptionAuthenticationAndIntegrity_integrityCapability),
        ('genericH235SecurityCapability', _EncryptionAuthenticationAndIntegrity_genericH235SecurityCapability),
        ])
    EncryptionAuthenticationAndIntegrity._ext = ['genericH235SecurityCapability']
    
    #-----< EncryptionCapability >-----#
    EncryptionCapability = SEQ_OF(name='EncryptionCapability', mode=MODE_TYPE)
    _EncryptionCapability__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MediaEncryptionAlgorithm')))
    EncryptionCapability._cont = _EncryptionCapability__item_
    EncryptionCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MediaEncryptionAlgorithm >-----#
    MediaEncryptionAlgorithm = CHOICE(name='MediaEncryptionAlgorithm', mode=MODE_TYPE)
    _MediaEncryptionAlgorithm_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _MediaEncryptionAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MediaEncryptionAlgorithm._cont = ASN1Dict([
        ('nonStandard', _MediaEncryptionAlgorithm_nonStandard),
        ('algorithm', _MediaEncryptionAlgorithm_algorithm),
        ])
    MediaEncryptionAlgorithm._ext = []
    
    #-----< AuthenticationCapability >-----#
    AuthenticationCapability = SEQ(name='AuthenticationCapability', mode=MODE_TYPE)
    _AuthenticationCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _AuthenticationCapability_antiSpamAlgorithm = OID(name='antiSpamAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AuthenticationCapability._cont = ASN1Dict([
        ('nonStandard', _AuthenticationCapability_nonStandard),
        ('antiSpamAlgorithm', _AuthenticationCapability_antiSpamAlgorithm),
        ])
    AuthenticationCapability._ext = ['antiSpamAlgorithm']
    
    #-----< IntegrityCapability >-----#
    IntegrityCapability = SEQ(name='IntegrityCapability', mode=MODE_TYPE)
    _IntegrityCapability_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    IntegrityCapability._cont = ASN1Dict([
        ('nonStandard', _IntegrityCapability_nonStandard),
        ])
    IntegrityCapability._ext = []
    
    #-----< UserInputCapability >-----#
    UserInputCapability = CHOICE(name='UserInputCapability', mode=MODE_TYPE)
    _UserInputCapability_nonStandard = SEQ_OF(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputCapability_nonStandard__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _UserInputCapability_nonStandard._cont = __UserInputCapability_nonStandard__item_
    _UserInputCapability_nonStandard._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _UserInputCapability_basicString = NULL(name='basicString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_iA5String = NULL(name='iA5String', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_generalString = NULL(name='generalString', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_dtmf = NULL(name='dtmf', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_hookflash = NULL(name='hookflash', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_extendedAlphanumeric = NULL(name='extendedAlphanumeric', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_encryptedBasicString = NULL(name='encryptedBasicString', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_encryptedIA5String = NULL(name='encryptedIA5String', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_encryptedGeneralString = NULL(name='encryptedGeneralString', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_secureDTMF = NULL(name='secureDTMF', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputCapability_genericUserInputCapability = SEQ(name='genericUserInputCapability', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    UserInputCapability._cont = ASN1Dict([
        ('nonStandard', _UserInputCapability_nonStandard),
        ('basicString', _UserInputCapability_basicString),
        ('iA5String', _UserInputCapability_iA5String),
        ('generalString', _UserInputCapability_generalString),
        ('dtmf', _UserInputCapability_dtmf),
        ('hookflash', _UserInputCapability_hookflash),
        ('extendedAlphanumeric', _UserInputCapability_extendedAlphanumeric),
        ('encryptedBasicString', _UserInputCapability_encryptedBasicString),
        ('encryptedIA5String', _UserInputCapability_encryptedIA5String),
        ('encryptedGeneralString', _UserInputCapability_encryptedGeneralString),
        ('secureDTMF', _UserInputCapability_secureDTMF),
        ('genericUserInputCapability', _UserInputCapability_genericUserInputCapability),
        ])
    UserInputCapability._ext = ['extendedAlphanumeric', 'encryptedBasicString', 'encryptedIA5String', 'encryptedGeneralString', 'secureDTMF', 'genericUserInputCapability']
    
    #-----< ConferenceCapability >-----#
    ConferenceCapability = SEQ(name='ConferenceCapability', mode=MODE_TYPE)
    _ConferenceCapability_nonStandardData = SEQ_OF(name='nonStandardData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ConferenceCapability_nonStandardData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _ConferenceCapability_nonStandardData._cont = __ConferenceCapability_nonStandardData__item_
    _ConferenceCapability_chairControlCapability = BOOL(name='chairControlCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceCapability_videoIndicateMixingCapability = BOOL(name='videoIndicateMixingCapability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceCapability_multipointVisualizationCapability = BOOL(name='multipointVisualizationCapability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ConferenceCapability._cont = ASN1Dict([
        ('nonStandardData', _ConferenceCapability_nonStandardData),
        ('chairControlCapability', _ConferenceCapability_chairControlCapability),
        ('videoIndicateMixingCapability', _ConferenceCapability_videoIndicateMixingCapability),
        ('multipointVisualizationCapability', _ConferenceCapability_multipointVisualizationCapability),
        ])
    ConferenceCapability._ext = ['videoIndicateMixingCapability', 'multipointVisualizationCapability']
    
    #-----< GenericCapability >-----#
    GenericCapability = SEQ(name='GenericCapability', mode=MODE_TYPE)
    _GenericCapability_capabilityIdentifier = CHOICE(name='capabilityIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityIdentifier')))
    _GenericCapability_maxBitRate = INT(name='maxBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericCapability_maxBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _GenericCapability_collapsing = SEQ_OF(name='collapsing', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GenericCapability_collapsing__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericParameter')))
    _GenericCapability_collapsing._cont = __GenericCapability_collapsing__item_
    _GenericCapability_nonCollapsing = SEQ_OF(name='nonCollapsing', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GenericCapability_nonCollapsing__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericParameter')))
    _GenericCapability_nonCollapsing._cont = __GenericCapability_nonCollapsing__item_
    _GenericCapability_nonCollapsingRaw = OCT_STR(name='nonCollapsingRaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GenericCapability_transport = CHOICE(name='transport', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')), opt=True)
    GenericCapability._cont = ASN1Dict([
        ('capabilityIdentifier', _GenericCapability_capabilityIdentifier),
        ('maxBitRate', _GenericCapability_maxBitRate),
        ('collapsing', _GenericCapability_collapsing),
        ('nonCollapsing', _GenericCapability_nonCollapsing),
        ('nonCollapsingRaw', _GenericCapability_nonCollapsingRaw),
        ('transport', _GenericCapability_transport),
        ])
    GenericCapability._ext = []
    
    #-----< CapabilityIdentifier >-----#
    CapabilityIdentifier = CHOICE(name='CapabilityIdentifier', mode=MODE_TYPE)
    _CapabilityIdentifier_standard = OID(name='standard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CapabilityIdentifier_h221NonStandard = SEQ(name='h221NonStandard', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _CapabilityIdentifier_uuid = OCT_STR(name='uuid', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CapabilityIdentifier_uuid._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _CapabilityIdentifier_domainBased = STR_IA5(name='domainBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CapabilityIdentifier_domainBased._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    CapabilityIdentifier._cont = ASN1Dict([
        ('standard', _CapabilityIdentifier_standard),
        ('h221NonStandard', _CapabilityIdentifier_h221NonStandard),
        ('uuid', _CapabilityIdentifier_uuid),
        ('domainBased', _CapabilityIdentifier_domainBased),
        ])
    CapabilityIdentifier._ext = []
    
    #-----< GenericParameter >-----#
    GenericParameter = SEQ(name='GenericParameter', mode=MODE_TYPE)
    _GenericParameter_parameterIdentifier = CHOICE(name='parameterIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ParameterIdentifier')))
    _GenericParameter_parameterValue = CHOICE(name='parameterValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ParameterValue')))
    _GenericParameter_supersedes = SEQ_OF(name='supersedes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GenericParameter_supersedes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ParameterIdentifier')))
    _GenericParameter_supersedes._cont = __GenericParameter_supersedes__item_
    GenericParameter._cont = ASN1Dict([
        ('parameterIdentifier', _GenericParameter_parameterIdentifier),
        ('parameterValue', _GenericParameter_parameterValue),
        ('supersedes', _GenericParameter_supersedes),
        ])
    GenericParameter._ext = []
    
    #-----< ParameterIdentifier >-----#
    ParameterIdentifier = CHOICE(name='ParameterIdentifier', mode=MODE_TYPE)
    _ParameterIdentifier_standard = INT(name='standard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterIdentifier_standard._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _ParameterIdentifier_h221NonStandard = SEQ(name='h221NonStandard', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _ParameterIdentifier_uuid = OCT_STR(name='uuid', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterIdentifier_uuid._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _ParameterIdentifier_domainBased = STR_IA5(name='domainBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterIdentifier_domainBased._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ParameterIdentifier._cont = ASN1Dict([
        ('standard', _ParameterIdentifier_standard),
        ('h221NonStandard', _ParameterIdentifier_h221NonStandard),
        ('uuid', _ParameterIdentifier_uuid),
        ('domainBased', _ParameterIdentifier_domainBased),
        ])
    ParameterIdentifier._ext = []
    
    #-----< ParameterValue >-----#
    ParameterValue = CHOICE(name='ParameterValue', mode=MODE_TYPE)
    _ParameterValue_logical = NULL(name='logical', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_booleanArray = INT(name='booleanArray', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_booleanArray._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ParameterValue_unsignedMin = INT(name='unsignedMin', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_unsignedMin._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ParameterValue_unsignedMax = INT(name='unsignedMax', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_unsignedMax._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ParameterValue_unsigned32Min = INT(name='unsigned32Min', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_unsigned32Min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _ParameterValue_unsigned32Max = INT(name='unsigned32Max', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_unsigned32Max._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _ParameterValue_octetString = OCT_STR(name='octetString', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_genericParameter = SEQ_OF(name='genericParameter', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ParameterValue_genericParameter__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericParameter')))
    _ParameterValue_genericParameter._cont = __ParameterValue_genericParameter__item_
    ParameterValue._cont = ASN1Dict([
        ('logical', _ParameterValue_logical),
        ('booleanArray', _ParameterValue_booleanArray),
        ('unsignedMin', _ParameterValue_unsignedMin),
        ('unsignedMax', _ParameterValue_unsignedMax),
        ('unsigned32Min', _ParameterValue_unsigned32Min),
        ('unsigned32Max', _ParameterValue_unsigned32Max),
        ('octetString', _ParameterValue_octetString),
        ('genericParameter', _ParameterValue_genericParameter),
        ])
    ParameterValue._ext = []
    
    #-----< MultiplexedStreamCapability >-----#
    MultiplexedStreamCapability = SEQ(name='MultiplexedStreamCapability', mode=MODE_TYPE)
    _MultiplexedStreamCapability_multiplexFormat = CHOICE(name='multiplexFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexFormat')))
    _MultiplexedStreamCapability_controlOnMuxStream = BOOL(name='controlOnMuxStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiplexedStreamCapability_capabilityOnMuxStream = SET_OF(name='capabilityOnMuxStream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MultiplexedStreamCapability_capabilityOnMuxStream__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AlternativeCapabilitySet')))
    _MultiplexedStreamCapability_capabilityOnMuxStream._cont = __MultiplexedStreamCapability_capabilityOnMuxStream__item_
    _MultiplexedStreamCapability_capabilityOnMuxStream._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MultiplexedStreamCapability._cont = ASN1Dict([
        ('multiplexFormat', _MultiplexedStreamCapability_multiplexFormat),
        ('controlOnMuxStream', _MultiplexedStreamCapability_controlOnMuxStream),
        ('capabilityOnMuxStream', _MultiplexedStreamCapability_capabilityOnMuxStream),
        ])
    MultiplexedStreamCapability._ext = []
    
    #-----< MultiplexFormat >-----#
    MultiplexFormat = CHOICE(name='MultiplexFormat', mode=MODE_TYPE)
    _MultiplexFormat_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _MultiplexFormat_h222Capability = SEQ(name='h222Capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H222Capability')))
    _MultiplexFormat_h223Capability = SEQ(name='h223Capability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223Capability')))
    MultiplexFormat._cont = ASN1Dict([
        ('nonStandard', _MultiplexFormat_nonStandard),
        ('h222Capability', _MultiplexFormat_h222Capability),
        ('h223Capability', _MultiplexFormat_h223Capability),
        ])
    MultiplexFormat._ext = []
    
    #-----< AudioTelephonyEventCapability >-----#
    AudioTelephonyEventCapability = SEQ(name='AudioTelephonyEventCapability', mode=MODE_TYPE)
    _AudioTelephonyEventCapability_dynamicRTPPayloadType = INT(name='dynamicRTPPayloadType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioTelephonyEventCapability_dynamicRTPPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=96, ub=127)], ev=None, er=[])
    _AudioTelephonyEventCapability_audioTelephoneEvent = STR_GENE(name='audioTelephoneEvent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AudioTelephonyEventCapability._cont = ASN1Dict([
        ('dynamicRTPPayloadType', _AudioTelephonyEventCapability_dynamicRTPPayloadType),
        ('audioTelephoneEvent', _AudioTelephonyEventCapability_audioTelephoneEvent),
        ])
    AudioTelephonyEventCapability._ext = []
    
    #-----< AudioToneCapability >-----#
    AudioToneCapability = SEQ(name='AudioToneCapability', mode=MODE_TYPE)
    _AudioToneCapability_dynamicRTPPayloadType = INT(name='dynamicRTPPayloadType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioToneCapability_dynamicRTPPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=96, ub=127)], ev=None, er=[])
    AudioToneCapability._cont = ASN1Dict([
        ('dynamicRTPPayloadType', _AudioToneCapability_dynamicRTPPayloadType),
        ])
    AudioToneCapability._ext = []
    
    #-----< NoPTAudioTelephonyEventCapability >-----#
    NoPTAudioTelephonyEventCapability = SEQ(name='NoPTAudioTelephonyEventCapability', mode=MODE_TYPE)
    _NoPTAudioTelephonyEventCapability_audioTelephoneEvent = STR_GENE(name='audioTelephoneEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    NoPTAudioTelephonyEventCapability._cont = ASN1Dict([
        ('audioTelephoneEvent', _NoPTAudioTelephonyEventCapability_audioTelephoneEvent),
        ])
    NoPTAudioTelephonyEventCapability._ext = []
    
    #-----< NoPTAudioToneCapability >-----#
    NoPTAudioToneCapability = SEQ(name='NoPTAudioToneCapability', mode=MODE_TYPE)
    NoPTAudioToneCapability._cont = ASN1Dict([
        ])
    NoPTAudioToneCapability._ext = []
    
    #-----< MultiplePayloadStreamCapability >-----#
    MultiplePayloadStreamCapability = SEQ(name='MultiplePayloadStreamCapability', mode=MODE_TYPE)
    _MultiplePayloadStreamCapability_capabilities = SET_OF(name='capabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplePayloadStreamCapability_capabilities__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AlternativeCapabilitySet')))
    _MultiplePayloadStreamCapability_capabilities._cont = __MultiplePayloadStreamCapability_capabilities__item_
    _MultiplePayloadStreamCapability_capabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MultiplePayloadStreamCapability._cont = ASN1Dict([
        ('capabilities', _MultiplePayloadStreamCapability_capabilities),
        ])
    MultiplePayloadStreamCapability._ext = []
    
    #-----< DepFECCapability >-----#
    DepFECCapability = CHOICE(name='DepFECCapability', mode=MODE_TYPE)
    _DepFECCapability_rfc2733 = SEQ(name='rfc2733', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DepFECCapability_rfc2733_redundancyEncoding = BOOL(name='redundancyEncoding', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DepFECCapability_rfc2733_separateStream = SEQ(name='separateStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DepFECCapability_rfc2733_separateStream_separatePort = BOOL(name='separatePort', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DepFECCapability_rfc2733_separateStream_samePort = BOOL(name='samePort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DepFECCapability_rfc2733_separateStream._cont = ASN1Dict([
        ('separatePort', ___DepFECCapability_rfc2733_separateStream_separatePort),
        ('samePort', ___DepFECCapability_rfc2733_separateStream_samePort),
        ])
    __DepFECCapability_rfc2733_separateStream._ext = []
    _DepFECCapability_rfc2733._cont = ASN1Dict([
        ('redundancyEncoding', __DepFECCapability_rfc2733_redundancyEncoding),
        ('separateStream', __DepFECCapability_rfc2733_separateStream),
        ])
    _DepFECCapability_rfc2733._ext = []
    DepFECCapability._cont = ASN1Dict([
        ('rfc2733', _DepFECCapability_rfc2733),
        ])
    DepFECCapability._ext = []
    
    #-----< FECCapability >-----#
    FECCapability = SEQ(name='FECCapability', mode=MODE_TYPE)
    _FECCapability_protectedCapability = INT(name='protectedCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    _FECCapability_fecScheme = OID(name='fecScheme', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FECCapability_rfc2733Format = CHOICE(name='rfc2733Format', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __FECCapability_rfc2733Format_rfc2733rfc2198 = INT(name='rfc2733rfc2198', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaxRedundancy')))
    __FECCapability_rfc2733Format_rfc2733sameport = INT(name='rfc2733sameport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaxRedundancy')))
    __FECCapability_rfc2733Format_rfc2733diffport = INT(name='rfc2733diffport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaxRedundancy')))
    _FECCapability_rfc2733Format._cont = ASN1Dict([
        ('rfc2733rfc2198', __FECCapability_rfc2733Format_rfc2733rfc2198),
        ('rfc2733sameport', __FECCapability_rfc2733Format_rfc2733sameport),
        ('rfc2733diffport', __FECCapability_rfc2733Format_rfc2733diffport),
        ])
    _FECCapability_rfc2733Format._ext = None
    FECCapability._cont = ASN1Dict([
        ('protectedCapability', _FECCapability_protectedCapability),
        ('fecScheme', _FECCapability_fecScheme),
        ('rfc2733Format', _FECCapability_rfc2733Format),
        ])
    FECCapability._ext = []
    
    #-----< MaxRedundancy >-----#
    MaxRedundancy = INT(name='MaxRedundancy', mode=MODE_TYPE)
    MaxRedundancy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< OpenLogicalChannel >-----#
    OpenLogicalChannel = SEQ(name='OpenLogicalChannel', mode=MODE_TYPE)
    _OpenLogicalChannel_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _OpenLogicalChannel_forwardLogicalChannelParameters = SEQ(name='forwardLogicalChannelParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannel_forwardLogicalChannelParameters_portNumber = INT(name='portNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannel_forwardLogicalChannelParameters_portNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __OpenLogicalChannel_forwardLogicalChannelParameters_dataType = CHOICE(name='dataType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataType')))
    __OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters = CHOICE(name='multiplexParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h222LogicalChannelParameters = SEQ(name='h222LogicalChannelParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H222LogicalChannelParameters')))
    ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h223LogicalChannelParameters = SEQ(name='h223LogicalChannelParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223LogicalChannelParameters')))
    ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_v76LogicalChannelParameters = SEQ(name='v76LogicalChannelParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V76LogicalChannelParameters')))
    ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters = SEQ(name='h2250LogicalChannelParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250LogicalChannelParameters')))
    ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_none = NULL(name='none', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters._cont = ASN1Dict([
        ('h222LogicalChannelParameters', ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h222LogicalChannelParameters),
        ('h223LogicalChannelParameters', ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h223LogicalChannelParameters),
        ('v76LogicalChannelParameters', ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_v76LogicalChannelParameters),
        ('h2250LogicalChannelParameters', ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters),
        ('none', ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_none),
        ])
    __OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters._ext = ['h2250LogicalChannelParameters', 'none']
    __OpenLogicalChannel_forwardLogicalChannelParameters_forwardLogicalChannelDependency = INT(name='forwardLogicalChannelDependency', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')), opt=True)
    __OpenLogicalChannel_forwardLogicalChannelParameters_replacementFor = INT(name='replacementFor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')), opt=True)
    _OpenLogicalChannel_forwardLogicalChannelParameters._cont = ASN1Dict([
        ('portNumber', __OpenLogicalChannel_forwardLogicalChannelParameters_portNumber),
        ('dataType', __OpenLogicalChannel_forwardLogicalChannelParameters_dataType),
        ('multiplexParameters', __OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters),
        ('forwardLogicalChannelDependency', __OpenLogicalChannel_forwardLogicalChannelParameters_forwardLogicalChannelDependency),
        ('replacementFor', __OpenLogicalChannel_forwardLogicalChannelParameters_replacementFor),
        ])
    _OpenLogicalChannel_forwardLogicalChannelParameters._ext = ['forwardLogicalChannelDependency', 'replacementFor']
    _OpenLogicalChannel_reverseLogicalChannelParameters = SEQ(name='reverseLogicalChannelParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannel_reverseLogicalChannelParameters_dataType = CHOICE(name='dataType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataType')))
    __OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters = CHOICE(name='multiplexParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_h223LogicalChannelParameters = SEQ(name='h223LogicalChannelParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223LogicalChannelParameters')))
    ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_v76LogicalChannelParameters = SEQ(name='v76LogicalChannelParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V76LogicalChannelParameters')))
    ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters = SEQ(name='h2250LogicalChannelParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250LogicalChannelParameters')))
    __OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters._cont = ASN1Dict([
        ('h223LogicalChannelParameters', ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_h223LogicalChannelParameters),
        ('v76LogicalChannelParameters', ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_v76LogicalChannelParameters),
        ('h2250LogicalChannelParameters', ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters),
        ])
    __OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters._ext = ['h2250LogicalChannelParameters']
    __OpenLogicalChannel_reverseLogicalChannelParameters_reverseLogicalChannelDependency = INT(name='reverseLogicalChannelDependency', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')), opt=True)
    __OpenLogicalChannel_reverseLogicalChannelParameters_replacementFor = INT(name='replacementFor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')), opt=True)
    _OpenLogicalChannel_reverseLogicalChannelParameters._cont = ASN1Dict([
        ('dataType', __OpenLogicalChannel_reverseLogicalChannelParameters_dataType),
        ('multiplexParameters', __OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters),
        ('reverseLogicalChannelDependency', __OpenLogicalChannel_reverseLogicalChannelParameters_reverseLogicalChannelDependency),
        ('replacementFor', __OpenLogicalChannel_reverseLogicalChannelParameters_replacementFor),
        ])
    _OpenLogicalChannel_reverseLogicalChannelParameters._ext = ['reverseLogicalChannelDependency', 'replacementFor']
    _OpenLogicalChannel_separateStack = SEQ(name='separateStack', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NetworkAccessParameters')), opt=True)
    _OpenLogicalChannel_encryptionSync = SEQ(name='encryptionSync', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionSync')), opt=True)
    _OpenLogicalChannel_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannel_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _OpenLogicalChannel_genericInformation._cont = __OpenLogicalChannel_genericInformation__item_
    OpenLogicalChannel._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _OpenLogicalChannel_forwardLogicalChannelNumber),
        ('forwardLogicalChannelParameters', _OpenLogicalChannel_forwardLogicalChannelParameters),
        ('reverseLogicalChannelParameters', _OpenLogicalChannel_reverseLogicalChannelParameters),
        ('separateStack', _OpenLogicalChannel_separateStack),
        ('encryptionSync', _OpenLogicalChannel_encryptionSync),
        ('genericInformation', _OpenLogicalChannel_genericInformation),
        ])
    OpenLogicalChannel._ext = ['separateStack', 'encryptionSync', 'genericInformation']
    
    #-----< LogicalChannelNumber >-----#
    LogicalChannelNumber = INT(name='LogicalChannelNumber', mode=MODE_TYPE)
    LogicalChannelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< NetworkAccessParameters >-----#
    NetworkAccessParameters = SEQ(name='NetworkAccessParameters', mode=MODE_TYPE)
    _NetworkAccessParameters_distribution = CHOICE(name='distribution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NetworkAccessParameters_distribution_unicast = NULL(name='unicast', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAccessParameters_distribution_multicast = NULL(name='multicast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NetworkAccessParameters_distribution._cont = ASN1Dict([
        ('unicast', __NetworkAccessParameters_distribution_unicast),
        ('multicast', __NetworkAccessParameters_distribution_multicast),
        ])
    _NetworkAccessParameters_distribution._ext = []
    _NetworkAccessParameters_networkAddress = CHOICE(name='networkAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NetworkAccessParameters_networkAddress_q2931Address = SEQ(name='q2931Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Q2931Address')))
    __NetworkAccessParameters_networkAddress_e164Address = STR_IA5(name='e164Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAccessParameters_networkAddress_e164Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __NetworkAccessParameters_networkAddress_e164Address._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '#', '*', ','], rr=[], ev=None, er=[])
    __NetworkAccessParameters_networkAddress_localAreaAddress = CHOICE(name='localAreaAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')))
    _NetworkAccessParameters_networkAddress._cont = ASN1Dict([
        ('q2931Address', __NetworkAccessParameters_networkAddress_q2931Address),
        ('e164Address', __NetworkAccessParameters_networkAddress_e164Address),
        ('localAreaAddress', __NetworkAccessParameters_networkAddress_localAreaAddress),
        ])
    _NetworkAccessParameters_networkAddress._ext = []
    _NetworkAccessParameters_associateConference = BOOL(name='associateConference', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NetworkAccessParameters_externalReference = OCT_STR(name='externalReference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NetworkAccessParameters_externalReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _NetworkAccessParameters_t120SetupProcedure = CHOICE(name='t120SetupProcedure', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NetworkAccessParameters_t120SetupProcedure_originateCall = NULL(name='originateCall', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAccessParameters_t120SetupProcedure_waitForCall = NULL(name='waitForCall', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAccessParameters_t120SetupProcedure_issueQuery = NULL(name='issueQuery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NetworkAccessParameters_t120SetupProcedure._cont = ASN1Dict([
        ('originateCall', __NetworkAccessParameters_t120SetupProcedure_originateCall),
        ('waitForCall', __NetworkAccessParameters_t120SetupProcedure_waitForCall),
        ('issueQuery', __NetworkAccessParameters_t120SetupProcedure_issueQuery),
        ])
    _NetworkAccessParameters_t120SetupProcedure._ext = []
    NetworkAccessParameters._cont = ASN1Dict([
        ('distribution', _NetworkAccessParameters_distribution),
        ('networkAddress', _NetworkAccessParameters_networkAddress),
        ('associateConference', _NetworkAccessParameters_associateConference),
        ('externalReference', _NetworkAccessParameters_externalReference),
        ('t120SetupProcedure', _NetworkAccessParameters_t120SetupProcedure),
        ])
    NetworkAccessParameters._ext = ['t120SetupProcedure']
    
    #-----< Q2931Address >-----#
    Q2931Address = SEQ(name='Q2931Address', mode=MODE_TYPE)
    _Q2931Address_address = CHOICE(name='address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Q2931Address_address_internationalNumber = STR_NUM(name='internationalNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Q2931Address_address_internationalNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __Q2931Address_address_nsapAddress = OCT_STR(name='nsapAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Q2931Address_address_nsapAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _Q2931Address_address._cont = ASN1Dict([
        ('internationalNumber', __Q2931Address_address_internationalNumber),
        ('nsapAddress', __Q2931Address_address_nsapAddress),
        ])
    _Q2931Address_address._ext = []
    _Q2931Address_subaddress = OCT_STR(name='subaddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Q2931Address_subaddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    Q2931Address._cont = ASN1Dict([
        ('address', _Q2931Address_address),
        ('subaddress', _Q2931Address_subaddress),
        ])
    Q2931Address._ext = []
    
    #-----< V75Parameters >-----#
    V75Parameters = SEQ(name='V75Parameters', mode=MODE_TYPE)
    _V75Parameters_audioHeaderPresent = BOOL(name='audioHeaderPresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    V75Parameters._cont = ASN1Dict([
        ('audioHeaderPresent', _V75Parameters_audioHeaderPresent),
        ])
    V75Parameters._ext = []
    
    #-----< DataType >-----#
    DataType = CHOICE(name='DataType', mode=MODE_TYPE)
    _DataType_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _DataType_nullData = NULL(name='nullData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataType_videoData = CHOICE(name='videoData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    _DataType_audioData = CHOICE(name='audioData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    _DataType_data = SEQ(name='data', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _DataType_encryptionData = CHOICE(name='encryptionData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionMode')))
    _DataType_h235Control = SEQ(name='h235Control', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _DataType_h235Media = SEQ(name='h235Media', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H235Media')))
    _DataType_multiplexedStream = SEQ(name='multiplexedStream', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexedStreamParameter')))
    _DataType_redundancyEncoding = SEQ(name='redundancyEncoding', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncoding')))
    _DataType_multiplePayloadStream = SEQ(name='multiplePayloadStream', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStream')))
    _DataType_depFec = CHOICE(name='depFec', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DepFECData')))
    _DataType_fec = CHOICE(name='fec', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FECData')))
    DataType._cont = ASN1Dict([
        ('nonStandard', _DataType_nonStandard),
        ('nullData', _DataType_nullData),
        ('videoData', _DataType_videoData),
        ('audioData', _DataType_audioData),
        ('data', _DataType_data),
        ('encryptionData', _DataType_encryptionData),
        ('h235Control', _DataType_h235Control),
        ('h235Media', _DataType_h235Media),
        ('multiplexedStream', _DataType_multiplexedStream),
        ('redundancyEncoding', _DataType_redundancyEncoding),
        ('multiplePayloadStream', _DataType_multiplePayloadStream),
        ('depFec', _DataType_depFec),
        ('fec', _DataType_fec),
        ])
    DataType._ext = ['h235Control', 'h235Media', 'multiplexedStream', 'redundancyEncoding', 'multiplePayloadStream', 'depFec', 'fec']
    
    #-----< H235Media >-----#
    H235Media = SEQ(name='H235Media', mode=MODE_TYPE)
    _H235Media_encryptionAuthenticationAndIntegrity = SEQ(name='encryptionAuthenticationAndIntegrity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionAuthenticationAndIntegrity')))
    _H235Media_mediaType = CHOICE(name='mediaType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H235Media_mediaType_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __H235Media_mediaType_videoData = CHOICE(name='videoData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    __H235Media_mediaType_audioData = CHOICE(name='audioData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    __H235Media_mediaType_data = SEQ(name='data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    __H235Media_mediaType_redundancyEncoding = SEQ(name='redundancyEncoding', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncoding')))
    __H235Media_mediaType_multiplePayloadStream = SEQ(name='multiplePayloadStream', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStream')))
    __H235Media_mediaType_depFec = CHOICE(name='depFec', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DepFECData')))
    __H235Media_mediaType_fec = CHOICE(name='fec', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FECData')))
    _H235Media_mediaType._cont = ASN1Dict([
        ('nonStandard', __H235Media_mediaType_nonStandard),
        ('videoData', __H235Media_mediaType_videoData),
        ('audioData', __H235Media_mediaType_audioData),
        ('data', __H235Media_mediaType_data),
        ('redundancyEncoding', __H235Media_mediaType_redundancyEncoding),
        ('multiplePayloadStream', __H235Media_mediaType_multiplePayloadStream),
        ('depFec', __H235Media_mediaType_depFec),
        ('fec', __H235Media_mediaType_fec),
        ])
    _H235Media_mediaType._ext = ['redundancyEncoding', 'multiplePayloadStream', 'depFec', 'fec']
    H235Media._cont = ASN1Dict([
        ('encryptionAuthenticationAndIntegrity', _H235Media_encryptionAuthenticationAndIntegrity),
        ('mediaType', _H235Media_mediaType),
        ])
    H235Media._ext = []
    
    #-----< MultiplexedStreamParameter >-----#
    MultiplexedStreamParameter = SEQ(name='MultiplexedStreamParameter', mode=MODE_TYPE)
    _MultiplexedStreamParameter_multiplexFormat = CHOICE(name='multiplexFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexFormat')))
    _MultiplexedStreamParameter_controlOnMuxStream = BOOL(name='controlOnMuxStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MultiplexedStreamParameter._cont = ASN1Dict([
        ('multiplexFormat', _MultiplexedStreamParameter_multiplexFormat),
        ('controlOnMuxStream', _MultiplexedStreamParameter_controlOnMuxStream),
        ])
    MultiplexedStreamParameter._ext = []
    
    #-----< H222LogicalChannelParameters >-----#
    H222LogicalChannelParameters = SEQ(name='H222LogicalChannelParameters', mode=MODE_TYPE)
    _H222LogicalChannelParameters_resourceID = INT(name='resourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H222LogicalChannelParameters_resourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H222LogicalChannelParameters_subChannelID = INT(name='subChannelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H222LogicalChannelParameters_subChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _H222LogicalChannelParameters_pcr_pid = INT(name='pcr-pid', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H222LogicalChannelParameters_pcr_pid._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _H222LogicalChannelParameters_programDescriptors = OCT_STR(name='programDescriptors', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H222LogicalChannelParameters_streamDescriptors = OCT_STR(name='streamDescriptors', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    H222LogicalChannelParameters._cont = ASN1Dict([
        ('resourceID', _H222LogicalChannelParameters_resourceID),
        ('subChannelID', _H222LogicalChannelParameters_subChannelID),
        ('pcr-pid', _H222LogicalChannelParameters_pcr_pid),
        ('programDescriptors', _H222LogicalChannelParameters_programDescriptors),
        ('streamDescriptors', _H222LogicalChannelParameters_streamDescriptors),
        ])
    H222LogicalChannelParameters._ext = []
    
    #-----< H223LogicalChannelParameters >-----#
    H223LogicalChannelParameters = SEQ(name='H223LogicalChannelParameters', mode=MODE_TYPE)
    _H223LogicalChannelParameters_adaptationLayerType = CHOICE(name='adaptationLayerType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223LogicalChannelParameters_adaptationLayerType_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __H223LogicalChannelParameters_adaptationLayerType_al1Framed = NULL(name='al1Framed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223LogicalChannelParameters_adaptationLayerType_al1NotFramed = NULL(name='al1NotFramed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223LogicalChannelParameters_adaptationLayerType_al2WithoutSequenceNumbers = NULL(name='al2WithoutSequenceNumbers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223LogicalChannelParameters_adaptationLayerType_al2WithSequenceNumbers = NULL(name='al2WithSequenceNumbers', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223LogicalChannelParameters_adaptationLayerType_al3 = SEQ(name='al3', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223LogicalChannelParameters_adaptationLayerType_al3_controlFieldOctets = INT(name='controlFieldOctets', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223LogicalChannelParameters_adaptationLayerType_al3_controlFieldOctets._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=None, er=[])
    ___H223LogicalChannelParameters_adaptationLayerType_al3_sendBufferSize = INT(name='sendBufferSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223LogicalChannelParameters_adaptationLayerType_al3_sendBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    __H223LogicalChannelParameters_adaptationLayerType_al3._cont = ASN1Dict([
        ('controlFieldOctets', ___H223LogicalChannelParameters_adaptationLayerType_al3_controlFieldOctets),
        ('sendBufferSize', ___H223LogicalChannelParameters_adaptationLayerType_al3_sendBufferSize),
        ])
    __H223LogicalChannelParameters_adaptationLayerType_al3._ext = None
    __H223LogicalChannelParameters_adaptationLayerType_al1M = SEQ(name='al1M', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AL1MParameters')))
    __H223LogicalChannelParameters_adaptationLayerType_al2M = SEQ(name='al2M', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AL2MParameters')))
    __H223LogicalChannelParameters_adaptationLayerType_al3M = SEQ(name='al3M', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AL3MParameters')))
    _H223LogicalChannelParameters_adaptationLayerType._cont = ASN1Dict([
        ('nonStandard', __H223LogicalChannelParameters_adaptationLayerType_nonStandard),
        ('al1Framed', __H223LogicalChannelParameters_adaptationLayerType_al1Framed),
        ('al1NotFramed', __H223LogicalChannelParameters_adaptationLayerType_al1NotFramed),
        ('al2WithoutSequenceNumbers', __H223LogicalChannelParameters_adaptationLayerType_al2WithoutSequenceNumbers),
        ('al2WithSequenceNumbers', __H223LogicalChannelParameters_adaptationLayerType_al2WithSequenceNumbers),
        ('al3', __H223LogicalChannelParameters_adaptationLayerType_al3),
        ('al1M', __H223LogicalChannelParameters_adaptationLayerType_al1M),
        ('al2M', __H223LogicalChannelParameters_adaptationLayerType_al2M),
        ('al3M', __H223LogicalChannelParameters_adaptationLayerType_al3M),
        ])
    _H223LogicalChannelParameters_adaptationLayerType._ext = ['al1M', 'al2M', 'al3M']
    _H223LogicalChannelParameters_segmentableFlag = BOOL(name='segmentableFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H223LogicalChannelParameters._cont = ASN1Dict([
        ('adaptationLayerType', _H223LogicalChannelParameters_adaptationLayerType),
        ('segmentableFlag', _H223LogicalChannelParameters_segmentableFlag),
        ])
    H223LogicalChannelParameters._ext = []
    
    #-----< H223AL1MParameters >-----#
    H223AL1MParameters = SEQ(name='H223AL1MParameters', mode=MODE_TYPE)
    _H223AL1MParameters_transferMode = CHOICE(name='transferMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL1MParameters_transferMode_framed = NULL(name='framed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_transferMode_unframed = NULL(name='unframed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL1MParameters_transferMode._cont = ASN1Dict([
        ('framed', __H223AL1MParameters_transferMode_framed),
        ('unframed', __H223AL1MParameters_transferMode_unframed),
        ])
    _H223AL1MParameters_transferMode._ext = []
    _H223AL1MParameters_headerFEC = CHOICE(name='headerFEC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL1MParameters_headerFEC_sebch16_7 = NULL(name='sebch16-7', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_headerFEC_golay24_12 = NULL(name='golay24-12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL1MParameters_headerFEC._cont = ASN1Dict([
        ('sebch16-7', __H223AL1MParameters_headerFEC_sebch16_7),
        ('golay24-12', __H223AL1MParameters_headerFEC_golay24_12),
        ])
    _H223AL1MParameters_headerFEC._ext = []
    _H223AL1MParameters_crcLength = CHOICE(name='crcLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL1MParameters_crcLength_crc4bit = NULL(name='crc4bit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crc12bit = NULL(name='crc12bit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crc20bit = NULL(name='crc20bit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crc28bit = NULL(name='crc28bit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crc8bit = NULL(name='crc8bit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crc16bit = NULL(name='crc16bit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crc32bit = NULL(name='crc32bit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_crcLength_crcNotUsed = NULL(name='crcNotUsed', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL1MParameters_crcLength._cont = ASN1Dict([
        ('crc4bit', __H223AL1MParameters_crcLength_crc4bit),
        ('crc12bit', __H223AL1MParameters_crcLength_crc12bit),
        ('crc20bit', __H223AL1MParameters_crcLength_crc20bit),
        ('crc28bit', __H223AL1MParameters_crcLength_crc28bit),
        ('crc8bit', __H223AL1MParameters_crcLength_crc8bit),
        ('crc16bit', __H223AL1MParameters_crcLength_crc16bit),
        ('crc32bit', __H223AL1MParameters_crcLength_crc32bit),
        ('crcNotUsed', __H223AL1MParameters_crcLength_crcNotUsed),
        ])
    _H223AL1MParameters_crcLength._ext = ['crc8bit', 'crc16bit', 'crc32bit', 'crcNotUsed']
    _H223AL1MParameters_rcpcCodeRate = INT(name='rcpcCodeRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL1MParameters_rcpcCodeRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=32)], ev=None, er=[])
    _H223AL1MParameters_arqType = CHOICE(name='arqType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL1MParameters_arqType_noArq = NULL(name='noArq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL1MParameters_arqType_typeIArq = SEQ(name='typeIArq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AnnexCArqParameters')))
    __H223AL1MParameters_arqType_typeIIArq = SEQ(name='typeIIArq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AnnexCArqParameters')))
    _H223AL1MParameters_arqType._cont = ASN1Dict([
        ('noArq', __H223AL1MParameters_arqType_noArq),
        ('typeIArq', __H223AL1MParameters_arqType_typeIArq),
        ('typeIIArq', __H223AL1MParameters_arqType_typeIIArq),
        ])
    _H223AL1MParameters_arqType._ext = []
    _H223AL1MParameters_alpduInterleaving = BOOL(name='alpduInterleaving', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL1MParameters_alsduSplitting = BOOL(name='alsduSplitting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL1MParameters_rsCodeCorrection = INT(name='rsCodeCorrection', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H223AL1MParameters_rsCodeCorrection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    H223AL1MParameters._cont = ASN1Dict([
        ('transferMode', _H223AL1MParameters_transferMode),
        ('headerFEC', _H223AL1MParameters_headerFEC),
        ('crcLength', _H223AL1MParameters_crcLength),
        ('rcpcCodeRate', _H223AL1MParameters_rcpcCodeRate),
        ('arqType', _H223AL1MParameters_arqType),
        ('alpduInterleaving', _H223AL1MParameters_alpduInterleaving),
        ('alsduSplitting', _H223AL1MParameters_alsduSplitting),
        ('rsCodeCorrection', _H223AL1MParameters_rsCodeCorrection),
        ])
    H223AL1MParameters._ext = ['rsCodeCorrection']
    
    #-----< H223AL2MParameters >-----#
    H223AL2MParameters = SEQ(name='H223AL2MParameters', mode=MODE_TYPE)
    _H223AL2MParameters_headerFEC = CHOICE(name='headerFEC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL2MParameters_headerFEC_sebch16_5 = NULL(name='sebch16-5', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL2MParameters_headerFEC_golay24_12 = NULL(name='golay24-12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL2MParameters_headerFEC._cont = ASN1Dict([
        ('sebch16-5', __H223AL2MParameters_headerFEC_sebch16_5),
        ('golay24-12', __H223AL2MParameters_headerFEC_golay24_12),
        ])
    _H223AL2MParameters_headerFEC._ext = []
    _H223AL2MParameters_alpduInterleaving = BOOL(name='alpduInterleaving', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H223AL2MParameters._cont = ASN1Dict([
        ('headerFEC', _H223AL2MParameters_headerFEC),
        ('alpduInterleaving', _H223AL2MParameters_alpduInterleaving),
        ])
    H223AL2MParameters._ext = []
    
    #-----< H223AL3MParameters >-----#
    H223AL3MParameters = SEQ(name='H223AL3MParameters', mode=MODE_TYPE)
    _H223AL3MParameters_headerFormat = CHOICE(name='headerFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL3MParameters_headerFormat_sebch16_7 = NULL(name='sebch16-7', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_headerFormat_golay24_12 = NULL(name='golay24-12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL3MParameters_headerFormat._cont = ASN1Dict([
        ('sebch16-7', __H223AL3MParameters_headerFormat_sebch16_7),
        ('golay24-12', __H223AL3MParameters_headerFormat_golay24_12),
        ])
    _H223AL3MParameters_headerFormat._ext = []
    _H223AL3MParameters_crcLength = CHOICE(name='crcLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL3MParameters_crcLength_crc4bit = NULL(name='crc4bit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crc12bit = NULL(name='crc12bit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crc20bit = NULL(name='crc20bit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crc28bit = NULL(name='crc28bit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crc8bit = NULL(name='crc8bit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crc16bit = NULL(name='crc16bit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crc32bit = NULL(name='crc32bit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_crcLength_crcNotUsed = NULL(name='crcNotUsed', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL3MParameters_crcLength._cont = ASN1Dict([
        ('crc4bit', __H223AL3MParameters_crcLength_crc4bit),
        ('crc12bit', __H223AL3MParameters_crcLength_crc12bit),
        ('crc20bit', __H223AL3MParameters_crcLength_crc20bit),
        ('crc28bit', __H223AL3MParameters_crcLength_crc28bit),
        ('crc8bit', __H223AL3MParameters_crcLength_crc8bit),
        ('crc16bit', __H223AL3MParameters_crcLength_crc16bit),
        ('crc32bit', __H223AL3MParameters_crcLength_crc32bit),
        ('crcNotUsed', __H223AL3MParameters_crcLength_crcNotUsed),
        ])
    _H223AL3MParameters_crcLength._ext = ['crc8bit', 'crc16bit', 'crc32bit', 'crcNotUsed']
    _H223AL3MParameters_rcpcCodeRate = INT(name='rcpcCodeRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL3MParameters_rcpcCodeRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=32)], ev=None, er=[])
    _H223AL3MParameters_arqType = CHOICE(name='arqType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AL3MParameters_arqType_noArq = NULL(name='noArq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AL3MParameters_arqType_typeIArq = SEQ(name='typeIArq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AnnexCArqParameters')))
    __H223AL3MParameters_arqType_typeIIArq = SEQ(name='typeIIArq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AnnexCArqParameters')))
    _H223AL3MParameters_arqType._cont = ASN1Dict([
        ('noArq', __H223AL3MParameters_arqType_noArq),
        ('typeIArq', __H223AL3MParameters_arqType_typeIArq),
        ('typeIIArq', __H223AL3MParameters_arqType_typeIIArq),
        ])
    _H223AL3MParameters_arqType._ext = []
    _H223AL3MParameters_alpduInterleaving = BOOL(name='alpduInterleaving', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AL3MParameters_rsCodeCorrection = INT(name='rsCodeCorrection', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H223AL3MParameters_rsCodeCorrection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    H223AL3MParameters._cont = ASN1Dict([
        ('headerFormat', _H223AL3MParameters_headerFormat),
        ('crcLength', _H223AL3MParameters_crcLength),
        ('rcpcCodeRate', _H223AL3MParameters_rcpcCodeRate),
        ('arqType', _H223AL3MParameters_arqType),
        ('alpduInterleaving', _H223AL3MParameters_alpduInterleaving),
        ('rsCodeCorrection', _H223AL3MParameters_rsCodeCorrection),
        ])
    H223AL3MParameters._ext = ['rsCodeCorrection']
    
    #-----< H223AnnexCArqParameters >-----#
    H223AnnexCArqParameters = SEQ(name='H223AnnexCArqParameters', mode=MODE_TYPE)
    _H223AnnexCArqParameters_numberOfRetransmissions = CHOICE(name='numberOfRetransmissions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223AnnexCArqParameters_numberOfRetransmissions_finite = INT(name='finite', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223AnnexCArqParameters_numberOfRetransmissions_finite._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    __H223AnnexCArqParameters_numberOfRetransmissions_infinite = NULL(name='infinite', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCArqParameters_numberOfRetransmissions._cont = ASN1Dict([
        ('finite', __H223AnnexCArqParameters_numberOfRetransmissions_finite),
        ('infinite', __H223AnnexCArqParameters_numberOfRetransmissions_infinite),
        ])
    _H223AnnexCArqParameters_numberOfRetransmissions._ext = []
    _H223AnnexCArqParameters_sendBufferSize = INT(name='sendBufferSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223AnnexCArqParameters_sendBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    H223AnnexCArqParameters._cont = ASN1Dict([
        ('numberOfRetransmissions', _H223AnnexCArqParameters_numberOfRetransmissions),
        ('sendBufferSize', _H223AnnexCArqParameters_sendBufferSize),
        ])
    H223AnnexCArqParameters._ext = []
    
    #-----< V76LogicalChannelParameters >-----#
    V76LogicalChannelParameters = SEQ(name='V76LogicalChannelParameters', mode=MODE_TYPE)
    _V76LogicalChannelParameters_hdlcParameters = SEQ(name='hdlcParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V76HDLCParameters')))
    _V76LogicalChannelParameters_suspendResume = CHOICE(name='suspendResume', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __V76LogicalChannelParameters_suspendResume_noSuspendResume = NULL(name='noSuspendResume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __V76LogicalChannelParameters_suspendResume_suspendResumewAddress = NULL(name='suspendResumewAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __V76LogicalChannelParameters_suspendResume_suspendResumewoAddress = NULL(name='suspendResumewoAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76LogicalChannelParameters_suspendResume._cont = ASN1Dict([
        ('noSuspendResume', __V76LogicalChannelParameters_suspendResume_noSuspendResume),
        ('suspendResumewAddress', __V76LogicalChannelParameters_suspendResume_suspendResumewAddress),
        ('suspendResumewoAddress', __V76LogicalChannelParameters_suspendResume_suspendResumewoAddress),
        ])
    _V76LogicalChannelParameters_suspendResume._ext = []
    _V76LogicalChannelParameters_uIH = BOOL(name='uIH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76LogicalChannelParameters_mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __V76LogicalChannelParameters_mode_eRM = SEQ(name='eRM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___V76LogicalChannelParameters_mode_eRM_windowSize = INT(name='windowSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___V76LogicalChannelParameters_mode_eRM_windowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___V76LogicalChannelParameters_mode_eRM_recovery = CHOICE(name='recovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____V76LogicalChannelParameters_mode_eRM_recovery_rej = NULL(name='rej', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____V76LogicalChannelParameters_mode_eRM_recovery_sREJ = NULL(name='sREJ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____V76LogicalChannelParameters_mode_eRM_recovery_mSREJ = NULL(name='mSREJ', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___V76LogicalChannelParameters_mode_eRM_recovery._cont = ASN1Dict([
        ('rej', ____V76LogicalChannelParameters_mode_eRM_recovery_rej),
        ('sREJ', ____V76LogicalChannelParameters_mode_eRM_recovery_sREJ),
        ('mSREJ', ____V76LogicalChannelParameters_mode_eRM_recovery_mSREJ),
        ])
    ___V76LogicalChannelParameters_mode_eRM_recovery._ext = []
    __V76LogicalChannelParameters_mode_eRM._cont = ASN1Dict([
        ('windowSize', ___V76LogicalChannelParameters_mode_eRM_windowSize),
        ('recovery', ___V76LogicalChannelParameters_mode_eRM_recovery),
        ])
    __V76LogicalChannelParameters_mode_eRM._ext = []
    __V76LogicalChannelParameters_mode_uNERM = NULL(name='uNERM', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76LogicalChannelParameters_mode._cont = ASN1Dict([
        ('eRM', __V76LogicalChannelParameters_mode_eRM),
        ('uNERM', __V76LogicalChannelParameters_mode_uNERM),
        ])
    _V76LogicalChannelParameters_mode._ext = []
    _V76LogicalChannelParameters_v75Parameters = SEQ(name='v75Parameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V75Parameters')))
    V76LogicalChannelParameters._cont = ASN1Dict([
        ('hdlcParameters', _V76LogicalChannelParameters_hdlcParameters),
        ('suspendResume', _V76LogicalChannelParameters_suspendResume),
        ('uIH', _V76LogicalChannelParameters_uIH),
        ('mode', _V76LogicalChannelParameters_mode),
        ('v75Parameters', _V76LogicalChannelParameters_v75Parameters),
        ])
    V76LogicalChannelParameters._ext = []
    
    #-----< V76HDLCParameters >-----#
    V76HDLCParameters = SEQ(name='V76HDLCParameters', mode=MODE_TYPE)
    _V76HDLCParameters_crcLength = CHOICE(name='crcLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CRCLength')))
    _V76HDLCParameters_n401 = INT(name='n401', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76HDLCParameters_n401._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=None, er=[])
    _V76HDLCParameters_loopbackTestProcedure = BOOL(name='loopbackTestProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    V76HDLCParameters._cont = ASN1Dict([
        ('crcLength', _V76HDLCParameters_crcLength),
        ('n401', _V76HDLCParameters_n401),
        ('loopbackTestProcedure', _V76HDLCParameters_loopbackTestProcedure),
        ])
    V76HDLCParameters._ext = []
    
    #-----< CRCLength >-----#
    CRCLength = CHOICE(name='CRCLength', mode=MODE_TYPE)
    _CRCLength_crc8bit = NULL(name='crc8bit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CRCLength_crc16bit = NULL(name='crc16bit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CRCLength_crc32bit = NULL(name='crc32bit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CRCLength._cont = ASN1Dict([
        ('crc8bit', _CRCLength_crc8bit),
        ('crc16bit', _CRCLength_crc16bit),
        ('crc32bit', _CRCLength_crc32bit),
        ])
    CRCLength._ext = []
    
    #-----< H2250LogicalChannelParameters >-----#
    H2250LogicalChannelParameters = SEQ(name='H2250LogicalChannelParameters', mode=MODE_TYPE)
    _H2250LogicalChannelParameters_nonStandard = SEQ_OF(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H2250LogicalChannelParameters_nonStandard__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _H2250LogicalChannelParameters_nonStandard._cont = __H2250LogicalChannelParameters_nonStandard__item_
    _H2250LogicalChannelParameters_sessionID = INT(name='sessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250LogicalChannelParameters_sessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _H2250LogicalChannelParameters_associatedSessionID = INT(name='associatedSessionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelParameters_associatedSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _H2250LogicalChannelParameters_mediaChannel = CHOICE(name='mediaChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')), opt=True)
    _H2250LogicalChannelParameters_mediaGuaranteedDelivery = BOOL(name='mediaGuaranteedDelivery', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelParameters_mediaControlChannel = CHOICE(name='mediaControlChannel', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')), opt=True)
    _H2250LogicalChannelParameters_mediaControlGuaranteedDelivery = BOOL(name='mediaControlGuaranteedDelivery', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelParameters_silenceSuppression = BOOL(name='silenceSuppression', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelParameters_destination = SEQ(name='destination', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')), opt=True)
    _H2250LogicalChannelParameters_dynamicRTPPayloadType = INT(name='dynamicRTPPayloadType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelParameters_dynamicRTPPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=96, ub=127)], ev=None, er=[])
    _H2250LogicalChannelParameters_mediaPacketization = CHOICE(name='mediaPacketization', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __H2250LogicalChannelParameters_mediaPacketization_h261aVideoPacketization = NULL(name='h261aVideoPacketization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H2250LogicalChannelParameters_mediaPacketization_rtpPayloadType = SEQ(name='rtpPayloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RTPPayloadType')))
    _H2250LogicalChannelParameters_mediaPacketization._cont = ASN1Dict([
        ('h261aVideoPacketization', __H2250LogicalChannelParameters_mediaPacketization_h261aVideoPacketization),
        ('rtpPayloadType', __H2250LogicalChannelParameters_mediaPacketization_rtpPayloadType),
        ])
    _H2250LogicalChannelParameters_mediaPacketization._ext = ['rtpPayloadType']
    _H2250LogicalChannelParameters_transportCapability = SEQ(name='transportCapability', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportCapability')), opt=True)
    _H2250LogicalChannelParameters_redundancyEncoding = SEQ(name='redundancyEncoding', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncoding')), opt=True)
    _H2250LogicalChannelParameters_source = SEQ(name='source', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')), opt=True)
    H2250LogicalChannelParameters._cont = ASN1Dict([
        ('nonStandard', _H2250LogicalChannelParameters_nonStandard),
        ('sessionID', _H2250LogicalChannelParameters_sessionID),
        ('associatedSessionID', _H2250LogicalChannelParameters_associatedSessionID),
        ('mediaChannel', _H2250LogicalChannelParameters_mediaChannel),
        ('mediaGuaranteedDelivery', _H2250LogicalChannelParameters_mediaGuaranteedDelivery),
        ('mediaControlChannel', _H2250LogicalChannelParameters_mediaControlChannel),
        ('mediaControlGuaranteedDelivery', _H2250LogicalChannelParameters_mediaControlGuaranteedDelivery),
        ('silenceSuppression', _H2250LogicalChannelParameters_silenceSuppression),
        ('destination', _H2250LogicalChannelParameters_destination),
        ('dynamicRTPPayloadType', _H2250LogicalChannelParameters_dynamicRTPPayloadType),
        ('mediaPacketization', _H2250LogicalChannelParameters_mediaPacketization),
        ('transportCapability', _H2250LogicalChannelParameters_transportCapability),
        ('redundancyEncoding', _H2250LogicalChannelParameters_redundancyEncoding),
        ('source', _H2250LogicalChannelParameters_source),
        ])
    H2250LogicalChannelParameters._ext = ['transportCapability', 'redundancyEncoding', 'source']
    
    #-----< RTPPayloadType >-----#
    RTPPayloadType = SEQ(name='RTPPayloadType', mode=MODE_TYPE)
    _RTPPayloadType_payloadDescriptor = CHOICE(name='payloadDescriptor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RTPPayloadType_payloadDescriptor_nonStandardIdentifier = SEQ(name='nonStandardIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __RTPPayloadType_payloadDescriptor_rfc_number = INT(name='rfc-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RTPPayloadType_payloadDescriptor_rfc_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=[], er=[])
    __RTPPayloadType_payloadDescriptor_oid = OID(name='oid', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTPPayloadType_payloadDescriptor._cont = ASN1Dict([
        ('nonStandardIdentifier', __RTPPayloadType_payloadDescriptor_nonStandardIdentifier),
        ('rfc-number', __RTPPayloadType_payloadDescriptor_rfc_number),
        ('oid', __RTPPayloadType_payloadDescriptor_oid),
        ])
    _RTPPayloadType_payloadDescriptor._ext = []
    _RTPPayloadType_payloadType = INT(name='payloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RTPPayloadType_payloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    RTPPayloadType._cont = ASN1Dict([
        ('payloadDescriptor', _RTPPayloadType_payloadDescriptor),
        ('payloadType', _RTPPayloadType_payloadType),
        ])
    RTPPayloadType._ext = []
    
    #-----< RedundancyEncoding >-----#
    RedundancyEncoding = SEQ(name='RedundancyEncoding', mode=MODE_TYPE)
    _RedundancyEncoding_redundancyEncodingMethod = CHOICE(name='redundancyEncodingMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingMethod')))
    _RedundancyEncoding_secondaryEncoding = CHOICE(name='secondaryEncoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataType')), opt=True)
    _RedundancyEncoding_rtpRedundancyEncoding = SEQ(name='rtpRedundancyEncoding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RedundancyEncoding_rtpRedundancyEncoding_primary = SEQ(name='primary', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingElement')), opt=True)
    __RedundancyEncoding_rtpRedundancyEncoding_secondary = SEQ_OF(name='secondary', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___RedundancyEncoding_rtpRedundancyEncoding_secondary__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingElement')))
    __RedundancyEncoding_rtpRedundancyEncoding_secondary._cont = ___RedundancyEncoding_rtpRedundancyEncoding_secondary__item_
    _RedundancyEncoding_rtpRedundancyEncoding._cont = ASN1Dict([
        ('primary', __RedundancyEncoding_rtpRedundancyEncoding_primary),
        ('secondary', __RedundancyEncoding_rtpRedundancyEncoding_secondary),
        ])
    _RedundancyEncoding_rtpRedundancyEncoding._ext = []
    RedundancyEncoding._cont = ASN1Dict([
        ('redundancyEncodingMethod', _RedundancyEncoding_redundancyEncodingMethod),
        ('secondaryEncoding', _RedundancyEncoding_secondaryEncoding),
        ('rtpRedundancyEncoding', _RedundancyEncoding_rtpRedundancyEncoding),
        ])
    RedundancyEncoding._ext = ['rtpRedundancyEncoding']
    
    #-----< RedundancyEncodingElement >-----#
    RedundancyEncodingElement = SEQ(name='RedundancyEncodingElement', mode=MODE_TYPE)
    _RedundancyEncodingElement_dataType = CHOICE(name='dataType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataType')))
    _RedundancyEncodingElement_payloadType = INT(name='payloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RedundancyEncodingElement_payloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    RedundancyEncodingElement._cont = ASN1Dict([
        ('dataType', _RedundancyEncodingElement_dataType),
        ('payloadType', _RedundancyEncodingElement_payloadType),
        ])
    RedundancyEncodingElement._ext = []
    
    #-----< MultiplePayloadStream >-----#
    MultiplePayloadStream = SEQ(name='MultiplePayloadStream', mode=MODE_TYPE)
    _MultiplePayloadStream_elements = SEQ_OF(name='elements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplePayloadStream_elements__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStreamElement')))
    _MultiplePayloadStream_elements._cont = __MultiplePayloadStream_elements__item_
    MultiplePayloadStream._cont = ASN1Dict([
        ('elements', _MultiplePayloadStream_elements),
        ])
    MultiplePayloadStream._ext = []
    
    #-----< MultiplePayloadStreamElement >-----#
    MultiplePayloadStreamElement = SEQ(name='MultiplePayloadStreamElement', mode=MODE_TYPE)
    _MultiplePayloadStreamElement_dataType = CHOICE(name='dataType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataType')))
    _MultiplePayloadStreamElement_payloadType = INT(name='payloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MultiplePayloadStreamElement_payloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    MultiplePayloadStreamElement._cont = ASN1Dict([
        ('dataType', _MultiplePayloadStreamElement_dataType),
        ('payloadType', _MultiplePayloadStreamElement_payloadType),
        ])
    MultiplePayloadStreamElement._ext = []
    
    #-----< DepFECData >-----#
    DepFECData = CHOICE(name='DepFECData', mode=MODE_TYPE)
    _DepFECData_rfc2733 = SEQ(name='rfc2733', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DepFECData_rfc2733_mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___DepFECData_rfc2733_mode_redundancyEncoding = NULL(name='redundancyEncoding', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DepFECData_rfc2733_mode_separateStream = CHOICE(name='separateStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____DepFECData_rfc2733_mode_separateStream_differentPort = SEQ(name='differentPort', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedSessionID = INT(name='protectedSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedPayloadType = INT(name='protectedPayloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ____DepFECData_rfc2733_mode_separateStream_differentPort._cont = ASN1Dict([
        ('protectedSessionID', _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedSessionID),
        ('protectedPayloadType', _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedPayloadType),
        ])
    ____DepFECData_rfc2733_mode_separateStream_differentPort._ext = []
    ____DepFECData_rfc2733_mode_separateStream_samePort = SEQ(name='samePort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECData_rfc2733_mode_separateStream_samePort_protectedPayloadType = INT(name='protectedPayloadType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECData_rfc2733_mode_separateStream_samePort_protectedPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ____DepFECData_rfc2733_mode_separateStream_samePort._cont = ASN1Dict([
        ('protectedPayloadType', _____DepFECData_rfc2733_mode_separateStream_samePort_protectedPayloadType),
        ])
    ____DepFECData_rfc2733_mode_separateStream_samePort._ext = []
    ___DepFECData_rfc2733_mode_separateStream._cont = ASN1Dict([
        ('differentPort', ____DepFECData_rfc2733_mode_separateStream_differentPort),
        ('samePort', ____DepFECData_rfc2733_mode_separateStream_samePort),
        ])
    ___DepFECData_rfc2733_mode_separateStream._ext = []
    __DepFECData_rfc2733_mode._cont = ASN1Dict([
        ('redundancyEncoding', ___DepFECData_rfc2733_mode_redundancyEncoding),
        ('separateStream', ___DepFECData_rfc2733_mode_separateStream),
        ])
    __DepFECData_rfc2733_mode._ext = []
    _DepFECData_rfc2733._cont = ASN1Dict([
        ('mode', __DepFECData_rfc2733_mode),
        ])
    _DepFECData_rfc2733._ext = []
    DepFECData._cont = ASN1Dict([
        ('rfc2733', _DepFECData_rfc2733),
        ])
    DepFECData._ext = None
    
    #-----< FECData >-----#
    FECData = CHOICE(name='FECData', mode=MODE_TYPE)
    _FECData_rfc2733 = SEQ(name='rfc2733', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FECData_rfc2733_protectedPayloadType = INT(name='protectedPayloadType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FECData_rfc2733_protectedPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    __FECData_rfc2733_fecScheme = OID(name='fecScheme', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __FECData_rfc2733_pktMode = CHOICE(name='pktMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___FECData_rfc2733_pktMode_rfc2198coding = NULL(name='rfc2198coding', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___FECData_rfc2733_pktMode_rfc2733sameport = SEQ(name='rfc2733sameport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___FECData_rfc2733_pktMode_rfc2733sameport._cont = ASN1Dict([
        ])
    ___FECData_rfc2733_pktMode_rfc2733sameport._ext = []
    ___FECData_rfc2733_pktMode_rfc2733diffport = SEQ(name='rfc2733diffport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____FECData_rfc2733_pktMode_rfc2733diffport_protectedChannel = INT(name='protectedChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    ___FECData_rfc2733_pktMode_rfc2733diffport._cont = ASN1Dict([
        ('protectedChannel', ____FECData_rfc2733_pktMode_rfc2733diffport_protectedChannel),
        ])
    ___FECData_rfc2733_pktMode_rfc2733diffport._ext = []
    __FECData_rfc2733_pktMode._cont = ASN1Dict([
        ('rfc2198coding', ___FECData_rfc2733_pktMode_rfc2198coding),
        ('rfc2733sameport', ___FECData_rfc2733_pktMode_rfc2733sameport),
        ('rfc2733diffport', ___FECData_rfc2733_pktMode_rfc2733diffport),
        ])
    __FECData_rfc2733_pktMode._ext = []
    _FECData_rfc2733._cont = ASN1Dict([
        ('protectedPayloadType', __FECData_rfc2733_protectedPayloadType),
        ('fecScheme', __FECData_rfc2733_fecScheme),
        ('pktMode', __FECData_rfc2733_pktMode),
        ])
    _FECData_rfc2733._ext = []
    FECData._cont = ASN1Dict([
        ('rfc2733', _FECData_rfc2733),
        ])
    FECData._ext = []
    
    #-----< TransportAddress >-----#
    TransportAddress = CHOICE(name='TransportAddress', mode=MODE_TYPE)
    _TransportAddress_unicastAddress = CHOICE(name='unicastAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'UnicastAddress')))
    _TransportAddress_multicastAddress = CHOICE(name='multicastAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MulticastAddress')))
    TransportAddress._cont = ASN1Dict([
        ('unicastAddress', _TransportAddress_unicastAddress),
        ('multicastAddress', _TransportAddress_multicastAddress),
        ])
    TransportAddress._ext = []
    
    #-----< UnicastAddress >-----#
    UnicastAddress = CHOICE(name='UnicastAddress', mode=MODE_TYPE)
    _UnicastAddress_iPAddress = SEQ(name='iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPAddress_network = OCT_STR(name='network', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPAddress_network._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __UnicastAddress_iPAddress_tsapIdentifier = INT(name='tsapIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPAddress_tsapIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UnicastAddress_iPAddress._cont = ASN1Dict([
        ('network', __UnicastAddress_iPAddress_network),
        ('tsapIdentifier', __UnicastAddress_iPAddress_tsapIdentifier),
        ])
    _UnicastAddress_iPAddress._ext = []
    _UnicastAddress_iPXAddress = SEQ(name='iPXAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPXAddress_node = OCT_STR(name='node', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPXAddress_node._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    __UnicastAddress_iPXAddress_netnum = OCT_STR(name='netnum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPXAddress_netnum._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __UnicastAddress_iPXAddress_tsapIdentifier = OCT_STR(name='tsapIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPXAddress_tsapIdentifier._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UnicastAddress_iPXAddress._cont = ASN1Dict([
        ('node', __UnicastAddress_iPXAddress_node),
        ('netnum', __UnicastAddress_iPXAddress_netnum),
        ('tsapIdentifier', __UnicastAddress_iPXAddress_tsapIdentifier),
        ])
    _UnicastAddress_iPXAddress._ext = []
    _UnicastAddress_iP6Address = SEQ(name='iP6Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iP6Address_network = OCT_STR(name='network', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iP6Address_network._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __UnicastAddress_iP6Address_tsapIdentifier = INT(name='tsapIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iP6Address_tsapIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UnicastAddress_iP6Address._cont = ASN1Dict([
        ('network', __UnicastAddress_iP6Address_network),
        ('tsapIdentifier', __UnicastAddress_iP6Address_tsapIdentifier),
        ])
    _UnicastAddress_iP6Address._ext = []
    _UnicastAddress_netBios = OCT_STR(name='netBios', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UnicastAddress_netBios._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _UnicastAddress_iPSourceRouteAddress = SEQ(name='iPSourceRouteAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPSourceRouteAddress_routing = CHOICE(name='routing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___UnicastAddress_iPSourceRouteAddress_routing_strict = NULL(name='strict', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UnicastAddress_iPSourceRouteAddress_routing_loose = NULL(name='loose', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPSourceRouteAddress_routing._cont = ASN1Dict([
        ('strict', ___UnicastAddress_iPSourceRouteAddress_routing_strict),
        ('loose', ___UnicastAddress_iPSourceRouteAddress_routing_loose),
        ])
    __UnicastAddress_iPSourceRouteAddress_routing._ext = None
    __UnicastAddress_iPSourceRouteAddress_network = OCT_STR(name='network', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPSourceRouteAddress_network._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __UnicastAddress_iPSourceRouteAddress_tsapIdentifier = INT(name='tsapIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UnicastAddress_iPSourceRouteAddress_tsapIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __UnicastAddress_iPSourceRouteAddress_route = SEQ_OF(name='route', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UnicastAddress_iPSourceRouteAddress_route__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    ___UnicastAddress_iPSourceRouteAddress_route__item_._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __UnicastAddress_iPSourceRouteAddress_route._cont = ___UnicastAddress_iPSourceRouteAddress_route__item_
    _UnicastAddress_iPSourceRouteAddress._cont = ASN1Dict([
        ('routing', __UnicastAddress_iPSourceRouteAddress_routing),
        ('network', __UnicastAddress_iPSourceRouteAddress_network),
        ('tsapIdentifier', __UnicastAddress_iPSourceRouteAddress_tsapIdentifier),
        ('route', __UnicastAddress_iPSourceRouteAddress_route),
        ])
    _UnicastAddress_iPSourceRouteAddress._ext = []
    _UnicastAddress_nsap = OCT_STR(name='nsap', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UnicastAddress_nsap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _UnicastAddress_nonStandardAddress = SEQ(name='nonStandardAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    UnicastAddress._cont = ASN1Dict([
        ('iPAddress', _UnicastAddress_iPAddress),
        ('iPXAddress', _UnicastAddress_iPXAddress),
        ('iP6Address', _UnicastAddress_iP6Address),
        ('netBios', _UnicastAddress_netBios),
        ('iPSourceRouteAddress', _UnicastAddress_iPSourceRouteAddress),
        ('nsap', _UnicastAddress_nsap),
        ('nonStandardAddress', _UnicastAddress_nonStandardAddress),
        ])
    UnicastAddress._ext = ['nsap', 'nonStandardAddress']
    
    #-----< MulticastAddress >-----#
    MulticastAddress = CHOICE(name='MulticastAddress', mode=MODE_TYPE)
    _MulticastAddress_iPAddress = SEQ(name='iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MulticastAddress_iPAddress_network = OCT_STR(name='network', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MulticastAddress_iPAddress_network._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __MulticastAddress_iPAddress_tsapIdentifier = INT(name='tsapIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MulticastAddress_iPAddress_tsapIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MulticastAddress_iPAddress._cont = ASN1Dict([
        ('network', __MulticastAddress_iPAddress_network),
        ('tsapIdentifier', __MulticastAddress_iPAddress_tsapIdentifier),
        ])
    _MulticastAddress_iPAddress._ext = []
    _MulticastAddress_iP6Address = SEQ(name='iP6Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MulticastAddress_iP6Address_network = OCT_STR(name='network', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MulticastAddress_iP6Address_network._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __MulticastAddress_iP6Address_tsapIdentifier = INT(name='tsapIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MulticastAddress_iP6Address_tsapIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MulticastAddress_iP6Address._cont = ASN1Dict([
        ('network', __MulticastAddress_iP6Address_network),
        ('tsapIdentifier', __MulticastAddress_iP6Address_tsapIdentifier),
        ])
    _MulticastAddress_iP6Address._ext = []
    _MulticastAddress_nsap = OCT_STR(name='nsap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MulticastAddress_nsap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _MulticastAddress_nonStandardAddress = SEQ(name='nonStandardAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    MulticastAddress._cont = ASN1Dict([
        ('iPAddress', _MulticastAddress_iPAddress),
        ('iP6Address', _MulticastAddress_iP6Address),
        ('nsap', _MulticastAddress_nsap),
        ('nonStandardAddress', _MulticastAddress_nonStandardAddress),
        ])
    MulticastAddress._ext = ['nsap', 'nonStandardAddress']
    
    #-----< EncryptionSync >-----#
    EncryptionSync = SEQ(name='EncryptionSync', mode=MODE_TYPE)
    _EncryptionSync_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')), opt=True)
    _EncryptionSync_synchFlag = INT(name='synchFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncryptionSync_synchFlag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _EncryptionSync_h235Key = OCT_STR(name='h235Key', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncryptionSync_h235Key._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _EncryptionSync_escrowentry = SEQ_OF(name='escrowentry', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EncryptionSync_escrowentry__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EscrowData')))
    _EncryptionSync_escrowentry._cont = __EncryptionSync_escrowentry__item_
    _EncryptionSync_escrowentry._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _EncryptionSync_genericParameter = SEQ(name='genericParameter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericParameter')), opt=True)
    EncryptionSync._cont = ASN1Dict([
        ('nonStandard', _EncryptionSync_nonStandard),
        ('synchFlag', _EncryptionSync_synchFlag),
        ('h235Key', _EncryptionSync_h235Key),
        ('escrowentry', _EncryptionSync_escrowentry),
        ('genericParameter', _EncryptionSync_genericParameter),
        ])
    EncryptionSync._ext = ['genericParameter']
    
    #-----< EscrowData >-----#
    EscrowData = SEQ(name='EscrowData', mode=MODE_TYPE)
    _EscrowData_escrowID = OID(name='escrowID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EscrowData_escrowValue = BIT_STR(name='escrowValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EscrowData_escrowValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EscrowData._cont = ASN1Dict([
        ('escrowID', _EscrowData_escrowID),
        ('escrowValue', _EscrowData_escrowValue),
        ])
    EscrowData._ext = []
    
    #-----< OpenLogicalChannelAck >-----#
    OpenLogicalChannelAck = SEQ(name='OpenLogicalChannelAck', mode=MODE_TYPE)
    _OpenLogicalChannelAck_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _OpenLogicalChannelAck_reverseLogicalChannelParameters = SEQ(name='reverseLogicalChannelParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_reverseLogicalChannelNumber = INT(name='reverseLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_portNumber = INT(name='portNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_portNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters = CHOICE(name='multiplexParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters_h222LogicalChannelParameters = SEQ(name='h222LogicalChannelParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H222LogicalChannelParameters')))
    ___OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters = SEQ(name='h2250LogicalChannelParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250LogicalChannelParameters')))
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters._cont = ASN1Dict([
        ('h222LogicalChannelParameters', ___OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters_h222LogicalChannelParameters),
        ('h2250LogicalChannelParameters', ___OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters),
        ])
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters._ext = ['h2250LogicalChannelParameters']
    __OpenLogicalChannelAck_reverseLogicalChannelParameters_replacementFor = INT(name='replacementFor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')), opt=True)
    _OpenLogicalChannelAck_reverseLogicalChannelParameters._cont = ASN1Dict([
        ('reverseLogicalChannelNumber', __OpenLogicalChannelAck_reverseLogicalChannelParameters_reverseLogicalChannelNumber),
        ('portNumber', __OpenLogicalChannelAck_reverseLogicalChannelParameters_portNumber),
        ('multiplexParameters', __OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters),
        ('replacementFor', __OpenLogicalChannelAck_reverseLogicalChannelParameters_replacementFor),
        ])
    _OpenLogicalChannelAck_reverseLogicalChannelParameters._ext = ['replacementFor']
    _OpenLogicalChannelAck_separateStack = SEQ(name='separateStack', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NetworkAccessParameters')), opt=True)
    _OpenLogicalChannelAck_forwardMultiplexAckParameters = CHOICE(name='forwardMultiplexAckParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OpenLogicalChannelAck_forwardMultiplexAckParameters_h2250LogicalChannelAckParameters = SEQ(name='h2250LogicalChannelAckParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250LogicalChannelAckParameters')))
    _OpenLogicalChannelAck_forwardMultiplexAckParameters._cont = ASN1Dict([
        ('h2250LogicalChannelAckParameters', __OpenLogicalChannelAck_forwardMultiplexAckParameters_h2250LogicalChannelAckParameters),
        ])
    _OpenLogicalChannelAck_forwardMultiplexAckParameters._ext = []
    _OpenLogicalChannelAck_encryptionSync = SEQ(name='encryptionSync', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionSync')), opt=True)
    _OpenLogicalChannelAck_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannelAck_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _OpenLogicalChannelAck_genericInformation._cont = __OpenLogicalChannelAck_genericInformation__item_
    OpenLogicalChannelAck._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _OpenLogicalChannelAck_forwardLogicalChannelNumber),
        ('reverseLogicalChannelParameters', _OpenLogicalChannelAck_reverseLogicalChannelParameters),
        ('separateStack', _OpenLogicalChannelAck_separateStack),
        ('forwardMultiplexAckParameters', _OpenLogicalChannelAck_forwardMultiplexAckParameters),
        ('encryptionSync', _OpenLogicalChannelAck_encryptionSync),
        ('genericInformation', _OpenLogicalChannelAck_genericInformation),
        ])
    OpenLogicalChannelAck._ext = ['separateStack', 'forwardMultiplexAckParameters', 'encryptionSync', 'genericInformation']
    
    #-----< OpenLogicalChannelReject >-----#
    OpenLogicalChannelReject = SEQ(name='OpenLogicalChannelReject', mode=MODE_TYPE)
    _OpenLogicalChannelReject_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _OpenLogicalChannelReject_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OpenLogicalChannelReject_cause_unspecified = NULL(name='unspecified', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_unsuitableReverseParameters = NULL(name='unsuitableReverseParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_dataTypeNotSupported = NULL(name='dataTypeNotSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_dataTypeNotAvailable = NULL(name='dataTypeNotAvailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_unknownDataType = NULL(name='unknownDataType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_dataTypeALCombinationNotSupported = NULL(name='dataTypeALCombinationNotSupported', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_multicastChannelNotAllowed = NULL(name='multicastChannelNotAllowed', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_insufficientBandwidth = NULL(name='insufficientBandwidth', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_separateStackEstablishmentFailed = NULL(name='separateStackEstablishmentFailed', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_invalidSessionID = NULL(name='invalidSessionID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_masterSlaveConflict = NULL(name='masterSlaveConflict', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_waitForCommunicationMode = NULL(name='waitForCommunicationMode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_invalidDependentChannel = NULL(name='invalidDependentChannel', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_replacementForRejected = NULL(name='replacementForRejected', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_securityDenied = NULL(name='securityDenied', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OpenLogicalChannelReject_cause_qoSControlNotSupported = NULL(name='qoSControlNotSupported', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OpenLogicalChannelReject_cause._cont = ASN1Dict([
        ('unspecified', __OpenLogicalChannelReject_cause_unspecified),
        ('unsuitableReverseParameters', __OpenLogicalChannelReject_cause_unsuitableReverseParameters),
        ('dataTypeNotSupported', __OpenLogicalChannelReject_cause_dataTypeNotSupported),
        ('dataTypeNotAvailable', __OpenLogicalChannelReject_cause_dataTypeNotAvailable),
        ('unknownDataType', __OpenLogicalChannelReject_cause_unknownDataType),
        ('dataTypeALCombinationNotSupported', __OpenLogicalChannelReject_cause_dataTypeALCombinationNotSupported),
        ('multicastChannelNotAllowed', __OpenLogicalChannelReject_cause_multicastChannelNotAllowed),
        ('insufficientBandwidth', __OpenLogicalChannelReject_cause_insufficientBandwidth),
        ('separateStackEstablishmentFailed', __OpenLogicalChannelReject_cause_separateStackEstablishmentFailed),
        ('invalidSessionID', __OpenLogicalChannelReject_cause_invalidSessionID),
        ('masterSlaveConflict', __OpenLogicalChannelReject_cause_masterSlaveConflict),
        ('waitForCommunicationMode', __OpenLogicalChannelReject_cause_waitForCommunicationMode),
        ('invalidDependentChannel', __OpenLogicalChannelReject_cause_invalidDependentChannel),
        ('replacementForRejected', __OpenLogicalChannelReject_cause_replacementForRejected),
        ('securityDenied', __OpenLogicalChannelReject_cause_securityDenied),
        ('qoSControlNotSupported', __OpenLogicalChannelReject_cause_qoSControlNotSupported),
        ])
    _OpenLogicalChannelReject_cause._ext = ['multicastChannelNotAllowed', 'insufficientBandwidth', 'separateStackEstablishmentFailed', 'invalidSessionID', 'masterSlaveConflict', 'waitForCommunicationMode', 'invalidDependentChannel', 'replacementForRejected', 'securityDenied', 'qoSControlNotSupported']
    _OpenLogicalChannelReject_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannelReject_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _OpenLogicalChannelReject_genericInformation._cont = __OpenLogicalChannelReject_genericInformation__item_
    OpenLogicalChannelReject._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _OpenLogicalChannelReject_forwardLogicalChannelNumber),
        ('cause', _OpenLogicalChannelReject_cause),
        ('genericInformation', _OpenLogicalChannelReject_genericInformation),
        ])
    OpenLogicalChannelReject._ext = ['genericInformation']
    
    #-----< OpenLogicalChannelConfirm >-----#
    OpenLogicalChannelConfirm = SEQ(name='OpenLogicalChannelConfirm', mode=MODE_TYPE)
    _OpenLogicalChannelConfirm_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _OpenLogicalChannelConfirm_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OpenLogicalChannelConfirm_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _OpenLogicalChannelConfirm_genericInformation._cont = __OpenLogicalChannelConfirm_genericInformation__item_
    OpenLogicalChannelConfirm._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _OpenLogicalChannelConfirm_forwardLogicalChannelNumber),
        ('genericInformation', _OpenLogicalChannelConfirm_genericInformation),
        ])
    OpenLogicalChannelConfirm._ext = ['genericInformation']
    
    #-----< H2250LogicalChannelAckParameters >-----#
    H2250LogicalChannelAckParameters = SEQ(name='H2250LogicalChannelAckParameters', mode=MODE_TYPE)
    _H2250LogicalChannelAckParameters_nonStandard = SEQ_OF(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __H2250LogicalChannelAckParameters_nonStandard__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _H2250LogicalChannelAckParameters_nonStandard._cont = __H2250LogicalChannelAckParameters_nonStandard__item_
    _H2250LogicalChannelAckParameters_sessionID = INT(name='sessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelAckParameters_sessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _H2250LogicalChannelAckParameters_mediaChannel = CHOICE(name='mediaChannel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')), opt=True)
    _H2250LogicalChannelAckParameters_mediaControlChannel = CHOICE(name='mediaControlChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')), opt=True)
    _H2250LogicalChannelAckParameters_dynamicRTPPayloadType = INT(name='dynamicRTPPayloadType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelAckParameters_dynamicRTPPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=96, ub=127)], ev=None, er=[])
    _H2250LogicalChannelAckParameters_flowControlToZero = BOOL(name='flowControlToZero', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250LogicalChannelAckParameters_portNumber = INT(name='portNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H2250LogicalChannelAckParameters_portNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _H2250LogicalChannelAckParameters_multiplePayloadStream = SEQ(name='multiplePayloadStream', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStream')), opt=True)
    H2250LogicalChannelAckParameters._cont = ASN1Dict([
        ('nonStandard', _H2250LogicalChannelAckParameters_nonStandard),
        ('sessionID', _H2250LogicalChannelAckParameters_sessionID),
        ('mediaChannel', _H2250LogicalChannelAckParameters_mediaChannel),
        ('mediaControlChannel', _H2250LogicalChannelAckParameters_mediaControlChannel),
        ('dynamicRTPPayloadType', _H2250LogicalChannelAckParameters_dynamicRTPPayloadType),
        ('flowControlToZero', _H2250LogicalChannelAckParameters_flowControlToZero),
        ('portNumber', _H2250LogicalChannelAckParameters_portNumber),
        ('multiplePayloadStream', _H2250LogicalChannelAckParameters_multiplePayloadStream),
        ])
    H2250LogicalChannelAckParameters._ext = ['flowControlToZero', 'portNumber', 'multiplePayloadStream']
    
    #-----< CloseLogicalChannel >-----#
    CloseLogicalChannel = SEQ(name='CloseLogicalChannel', mode=MODE_TYPE)
    _CloseLogicalChannel_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _CloseLogicalChannel_source = CHOICE(name='source', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CloseLogicalChannel_source_user = NULL(name='user', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CloseLogicalChannel_source_lcse = NULL(name='lcse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CloseLogicalChannel_source._cont = ASN1Dict([
        ('user', __CloseLogicalChannel_source_user),
        ('lcse', __CloseLogicalChannel_source_lcse),
        ])
    _CloseLogicalChannel_source._ext = None
    _CloseLogicalChannel_reason = CHOICE(name='reason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CloseLogicalChannel_reason_unknown = NULL(name='unknown', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CloseLogicalChannel_reason_reopen = NULL(name='reopen', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CloseLogicalChannel_reason_reservationFailure = NULL(name='reservationFailure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CloseLogicalChannel_reason_networkErrorCode = INT(name='networkErrorCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CloseLogicalChannel_reason_networkErrorCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _CloseLogicalChannel_reason._cont = ASN1Dict([
        ('unknown', __CloseLogicalChannel_reason_unknown),
        ('reopen', __CloseLogicalChannel_reason_reopen),
        ('reservationFailure', __CloseLogicalChannel_reason_reservationFailure),
        ('networkErrorCode', __CloseLogicalChannel_reason_networkErrorCode),
        ])
    _CloseLogicalChannel_reason._ext = ['networkErrorCode']
    CloseLogicalChannel._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _CloseLogicalChannel_forwardLogicalChannelNumber),
        ('source', _CloseLogicalChannel_source),
        ('reason', _CloseLogicalChannel_reason),
        ])
    CloseLogicalChannel._ext = ['reason']
    
    #-----< CloseLogicalChannelAck >-----#
    CloseLogicalChannelAck = SEQ(name='CloseLogicalChannelAck', mode=MODE_TYPE)
    _CloseLogicalChannelAck_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    CloseLogicalChannelAck._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _CloseLogicalChannelAck_forwardLogicalChannelNumber),
        ])
    CloseLogicalChannelAck._ext = []
    
    #-----< RequestChannelClose >-----#
    RequestChannelClose = SEQ(name='RequestChannelClose', mode=MODE_TYPE)
    _RequestChannelClose_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _RequestChannelClose_qosCapability = SEQ(name='qosCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'QOSCapability')), opt=True)
    _RequestChannelClose_reason = CHOICE(name='reason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestChannelClose_reason_unknown = NULL(name='unknown', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestChannelClose_reason_normal = NULL(name='normal', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestChannelClose_reason_reopen = NULL(name='reopen', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestChannelClose_reason_reservationFailure = NULL(name='reservationFailure', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestChannelClose_reason_networkErrorCode = INT(name='networkErrorCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestChannelClose_reason_networkErrorCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _RequestChannelClose_reason._cont = ASN1Dict([
        ('unknown', __RequestChannelClose_reason_unknown),
        ('normal', __RequestChannelClose_reason_normal),
        ('reopen', __RequestChannelClose_reason_reopen),
        ('reservationFailure', __RequestChannelClose_reason_reservationFailure),
        ('networkErrorCode', __RequestChannelClose_reason_networkErrorCode),
        ])
    _RequestChannelClose_reason._ext = ['networkErrorCode']
    RequestChannelClose._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _RequestChannelClose_forwardLogicalChannelNumber),
        ('qosCapability', _RequestChannelClose_qosCapability),
        ('reason', _RequestChannelClose_reason),
        ])
    RequestChannelClose._ext = ['qosCapability', 'reason']
    
    #-----< RequestChannelCloseAck >-----#
    RequestChannelCloseAck = SEQ(name='RequestChannelCloseAck', mode=MODE_TYPE)
    _RequestChannelCloseAck_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    RequestChannelCloseAck._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _RequestChannelCloseAck_forwardLogicalChannelNumber),
        ])
    RequestChannelCloseAck._ext = []
    
    #-----< RequestChannelCloseReject >-----#
    RequestChannelCloseReject = SEQ(name='RequestChannelCloseReject', mode=MODE_TYPE)
    _RequestChannelCloseReject_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _RequestChannelCloseReject_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestChannelCloseReject_cause_unspecified = NULL(name='unspecified', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestChannelCloseReject_cause._cont = ASN1Dict([
        ('unspecified', __RequestChannelCloseReject_cause_unspecified),
        ])
    _RequestChannelCloseReject_cause._ext = []
    RequestChannelCloseReject._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _RequestChannelCloseReject_forwardLogicalChannelNumber),
        ('cause', _RequestChannelCloseReject_cause),
        ])
    RequestChannelCloseReject._ext = []
    
    #-----< RequestChannelCloseRelease >-----#
    RequestChannelCloseRelease = SEQ(name='RequestChannelCloseRelease', mode=MODE_TYPE)
    _RequestChannelCloseRelease_forwardLogicalChannelNumber = INT(name='forwardLogicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    RequestChannelCloseRelease._cont = ASN1Dict([
        ('forwardLogicalChannelNumber', _RequestChannelCloseRelease_forwardLogicalChannelNumber),
        ])
    RequestChannelCloseRelease._ext = []
    
    #-----< MultiplexEntrySend >-----#
    MultiplexEntrySend = SEQ(name='MultiplexEntrySend', mode=MODE_TYPE)
    _MultiplexEntrySend_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _MultiplexEntrySend_multiplexEntryDescriptors = SET_OF(name='multiplexEntryDescriptors', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexEntrySend_multiplexEntryDescriptors__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexEntryDescriptor')))
    _MultiplexEntrySend_multiplexEntryDescriptors._cont = __MultiplexEntrySend_multiplexEntryDescriptors__item_
    _MultiplexEntrySend_multiplexEntryDescriptors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    MultiplexEntrySend._cont = ASN1Dict([
        ('sequenceNumber', _MultiplexEntrySend_sequenceNumber),
        ('multiplexEntryDescriptors', _MultiplexEntrySend_multiplexEntryDescriptors),
        ])
    MultiplexEntrySend._ext = []
    
    #-----< MultiplexEntryDescriptor >-----#
    MultiplexEntryDescriptor = SEQ(name='MultiplexEntryDescriptor', mode=MODE_TYPE)
    _MultiplexEntryDescriptor_multiplexTableEntryNumber = INT(name='multiplexTableEntryNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _MultiplexEntryDescriptor_elementList = SEQ_OF(name='elementList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MultiplexEntryDescriptor_elementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexElement')))
    _MultiplexEntryDescriptor_elementList._cont = __MultiplexEntryDescriptor_elementList__item_
    _MultiplexEntryDescriptor_elementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MultiplexEntryDescriptor._cont = ASN1Dict([
        ('multiplexTableEntryNumber', _MultiplexEntryDescriptor_multiplexTableEntryNumber),
        ('elementList', _MultiplexEntryDescriptor_elementList),
        ])
    MultiplexEntryDescriptor._ext = None
    
    #-----< MultiplexElement >-----#
    MultiplexElement = SEQ(name='MultiplexElement', mode=MODE_TYPE)
    _MultiplexElement_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MultiplexElement_type_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexElement_type_logicalChannelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __MultiplexElement_type_subElementList = SEQ_OF(name='subElementList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MultiplexElement_type_subElementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexElement')))
    __MultiplexElement_type_subElementList._cont = ___MultiplexElement_type_subElementList__item_
    __MultiplexElement_type_subElementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=255)], ev=None, er=[])
    _MultiplexElement_type._cont = ASN1Dict([
        ('logicalChannelNumber', __MultiplexElement_type_logicalChannelNumber),
        ('subElementList', __MultiplexElement_type_subElementList),
        ])
    _MultiplexElement_type._ext = None
    _MultiplexElement_repeatCount = CHOICE(name='repeatCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MultiplexElement_repeatCount_finite = INT(name='finite', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexElement_repeatCount_finite._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __MultiplexElement_repeatCount_untilClosingFlag = NULL(name='untilClosingFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiplexElement_repeatCount._cont = ASN1Dict([
        ('finite', __MultiplexElement_repeatCount_finite),
        ('untilClosingFlag', __MultiplexElement_repeatCount_untilClosingFlag),
        ])
    _MultiplexElement_repeatCount._ext = None
    MultiplexElement._cont = ASN1Dict([
        ('type', _MultiplexElement_type),
        ('repeatCount', _MultiplexElement_repeatCount),
        ])
    MultiplexElement._ext = None
    
    #-----< MultiplexTableEntryNumber >-----#
    MultiplexTableEntryNumber = INT(name='MultiplexTableEntryNumber', mode=MODE_TYPE)
    MultiplexTableEntryNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< MultiplexEntrySendAck >-----#
    MultiplexEntrySendAck = SEQ(name='MultiplexEntrySendAck', mode=MODE_TYPE)
    _MultiplexEntrySendAck_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _MultiplexEntrySendAck_multiplexTableEntryNumber = SET_OF(name='multiplexTableEntryNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexEntrySendAck_multiplexTableEntryNumber__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _MultiplexEntrySendAck_multiplexTableEntryNumber._cont = __MultiplexEntrySendAck_multiplexTableEntryNumber__item_
    _MultiplexEntrySendAck_multiplexTableEntryNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    MultiplexEntrySendAck._cont = ASN1Dict([
        ('sequenceNumber', _MultiplexEntrySendAck_sequenceNumber),
        ('multiplexTableEntryNumber', _MultiplexEntrySendAck_multiplexTableEntryNumber),
        ])
    MultiplexEntrySendAck._ext = []
    
    #-----< MultiplexEntrySendReject >-----#
    MultiplexEntrySendReject = SEQ(name='MultiplexEntrySendReject', mode=MODE_TYPE)
    _MultiplexEntrySendReject_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _MultiplexEntrySendReject_rejectionDescriptions = SET_OF(name='rejectionDescriptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexEntrySendReject_rejectionDescriptions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexEntryRejectionDescriptions')))
    _MultiplexEntrySendReject_rejectionDescriptions._cont = __MultiplexEntrySendReject_rejectionDescriptions__item_
    _MultiplexEntrySendReject_rejectionDescriptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    MultiplexEntrySendReject._cont = ASN1Dict([
        ('sequenceNumber', _MultiplexEntrySendReject_sequenceNumber),
        ('rejectionDescriptions', _MultiplexEntrySendReject_rejectionDescriptions),
        ])
    MultiplexEntrySendReject._ext = []
    
    #-----< MultiplexEntryRejectionDescriptions >-----#
    MultiplexEntryRejectionDescriptions = SEQ(name='MultiplexEntryRejectionDescriptions', mode=MODE_TYPE)
    _MultiplexEntryRejectionDescriptions_multiplexTableEntryNumber = INT(name='multiplexTableEntryNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _MultiplexEntryRejectionDescriptions_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MultiplexEntryRejectionDescriptions_cause_unspecifiedCause = NULL(name='unspecifiedCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexEntryRejectionDescriptions_cause_descriptorTooComplex = NULL(name='descriptorTooComplex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiplexEntryRejectionDescriptions_cause._cont = ASN1Dict([
        ('unspecifiedCause', __MultiplexEntryRejectionDescriptions_cause_unspecifiedCause),
        ('descriptorTooComplex', __MultiplexEntryRejectionDescriptions_cause_descriptorTooComplex),
        ])
    _MultiplexEntryRejectionDescriptions_cause._ext = []
    MultiplexEntryRejectionDescriptions._cont = ASN1Dict([
        ('multiplexTableEntryNumber', _MultiplexEntryRejectionDescriptions_multiplexTableEntryNumber),
        ('cause', _MultiplexEntryRejectionDescriptions_cause),
        ])
    MultiplexEntryRejectionDescriptions._ext = []
    
    #-----< MultiplexEntrySendRelease >-----#
    MultiplexEntrySendRelease = SEQ(name='MultiplexEntrySendRelease', mode=MODE_TYPE)
    _MultiplexEntrySendRelease_multiplexTableEntryNumber = SET_OF(name='multiplexTableEntryNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplexEntrySendRelease_multiplexTableEntryNumber__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _MultiplexEntrySendRelease_multiplexTableEntryNumber._cont = __MultiplexEntrySendRelease_multiplexTableEntryNumber__item_
    _MultiplexEntrySendRelease_multiplexTableEntryNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    MultiplexEntrySendRelease._cont = ASN1Dict([
        ('multiplexTableEntryNumber', _MultiplexEntrySendRelease_multiplexTableEntryNumber),
        ])
    MultiplexEntrySendRelease._ext = []
    
    #-----< RequestMultiplexEntry >-----#
    RequestMultiplexEntry = SEQ(name='RequestMultiplexEntry', mode=MODE_TYPE)
    _RequestMultiplexEntry_entryNumbers = SET_OF(name='entryNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestMultiplexEntry_entryNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _RequestMultiplexEntry_entryNumbers._cont = __RequestMultiplexEntry_entryNumbers__item_
    _RequestMultiplexEntry_entryNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    RequestMultiplexEntry._cont = ASN1Dict([
        ('entryNumbers', _RequestMultiplexEntry_entryNumbers),
        ])
    RequestMultiplexEntry._ext = []
    
    #-----< RequestMultiplexEntryAck >-----#
    RequestMultiplexEntryAck = SEQ(name='RequestMultiplexEntryAck', mode=MODE_TYPE)
    _RequestMultiplexEntryAck_entryNumbers = SET_OF(name='entryNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestMultiplexEntryAck_entryNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _RequestMultiplexEntryAck_entryNumbers._cont = __RequestMultiplexEntryAck_entryNumbers__item_
    _RequestMultiplexEntryAck_entryNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    RequestMultiplexEntryAck._cont = ASN1Dict([
        ('entryNumbers', _RequestMultiplexEntryAck_entryNumbers),
        ])
    RequestMultiplexEntryAck._ext = []
    
    #-----< RequestMultiplexEntryReject >-----#
    RequestMultiplexEntryReject = SEQ(name='RequestMultiplexEntryReject', mode=MODE_TYPE)
    _RequestMultiplexEntryReject_entryNumbers = SET_OF(name='entryNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestMultiplexEntryReject_entryNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _RequestMultiplexEntryReject_entryNumbers._cont = __RequestMultiplexEntryReject_entryNumbers__item_
    _RequestMultiplexEntryReject_entryNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    _RequestMultiplexEntryReject_rejectionDescriptions = SET_OF(name='rejectionDescriptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestMultiplexEntryReject_rejectionDescriptions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMultiplexEntryRejectionDescriptions')))
    _RequestMultiplexEntryReject_rejectionDescriptions._cont = __RequestMultiplexEntryReject_rejectionDescriptions__item_
    _RequestMultiplexEntryReject_rejectionDescriptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    RequestMultiplexEntryReject._cont = ASN1Dict([
        ('entryNumbers', _RequestMultiplexEntryReject_entryNumbers),
        ('rejectionDescriptions', _RequestMultiplexEntryReject_rejectionDescriptions),
        ])
    RequestMultiplexEntryReject._ext = []
    
    #-----< RequestMultiplexEntryRejectionDescriptions >-----#
    RequestMultiplexEntryRejectionDescriptions = SEQ(name='RequestMultiplexEntryRejectionDescriptions', mode=MODE_TYPE)
    _RequestMultiplexEntryRejectionDescriptions_multiplexTableEntryNumber = INT(name='multiplexTableEntryNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _RequestMultiplexEntryRejectionDescriptions_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestMultiplexEntryRejectionDescriptions_cause_unspecifiedCause = NULL(name='unspecifiedCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestMultiplexEntryRejectionDescriptions_cause._cont = ASN1Dict([
        ('unspecifiedCause', __RequestMultiplexEntryRejectionDescriptions_cause_unspecifiedCause),
        ])
    _RequestMultiplexEntryRejectionDescriptions_cause._ext = []
    RequestMultiplexEntryRejectionDescriptions._cont = ASN1Dict([
        ('multiplexTableEntryNumber', _RequestMultiplexEntryRejectionDescriptions_multiplexTableEntryNumber),
        ('cause', _RequestMultiplexEntryRejectionDescriptions_cause),
        ])
    RequestMultiplexEntryRejectionDescriptions._ext = []
    
    #-----< RequestMultiplexEntryRelease >-----#
    RequestMultiplexEntryRelease = SEQ(name='RequestMultiplexEntryRelease', mode=MODE_TYPE)
    _RequestMultiplexEntryRelease_entryNumbers = SET_OF(name='entryNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestMultiplexEntryRelease_entryNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexTableEntryNumber')))
    _RequestMultiplexEntryRelease_entryNumbers._cont = __RequestMultiplexEntryRelease_entryNumbers__item_
    _RequestMultiplexEntryRelease_entryNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    RequestMultiplexEntryRelease._cont = ASN1Dict([
        ('entryNumbers', _RequestMultiplexEntryRelease_entryNumbers),
        ])
    RequestMultiplexEntryRelease._ext = []
    
    #-----< RequestMode >-----#
    RequestMode = SEQ(name='RequestMode', mode=MODE_TYPE)
    _RequestMode_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _RequestMode_requestedModes = SEQ_OF(name='requestedModes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestMode_requestedModes__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ModeDescription')))
    _RequestMode_requestedModes._cont = __RequestMode_requestedModes__item_
    _RequestMode_requestedModes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    RequestMode._cont = ASN1Dict([
        ('sequenceNumber', _RequestMode_sequenceNumber),
        ('requestedModes', _RequestMode_requestedModes),
        ])
    RequestMode._ext = []
    
    #-----< RequestModeAck >-----#
    RequestModeAck = SEQ(name='RequestModeAck', mode=MODE_TYPE)
    _RequestModeAck_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _RequestModeAck_response = CHOICE(name='response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestModeAck_response_willTransmitMostPreferredMode = NULL(name='willTransmitMostPreferredMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestModeAck_response_willTransmitLessPreferredMode = NULL(name='willTransmitLessPreferredMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestModeAck_response._cont = ASN1Dict([
        ('willTransmitMostPreferredMode', __RequestModeAck_response_willTransmitMostPreferredMode),
        ('willTransmitLessPreferredMode', __RequestModeAck_response_willTransmitLessPreferredMode),
        ])
    _RequestModeAck_response._ext = []
    RequestModeAck._cont = ASN1Dict([
        ('sequenceNumber', _RequestModeAck_sequenceNumber),
        ('response', _RequestModeAck_response),
        ])
    RequestModeAck._ext = []
    
    #-----< RequestModeReject >-----#
    RequestModeReject = SEQ(name='RequestModeReject', mode=MODE_TYPE)
    _RequestModeReject_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _RequestModeReject_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestModeReject_cause_modeUnavailable = NULL(name='modeUnavailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestModeReject_cause_multipointConstraint = NULL(name='multipointConstraint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestModeReject_cause_requestDenied = NULL(name='requestDenied', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestModeReject_cause._cont = ASN1Dict([
        ('modeUnavailable', __RequestModeReject_cause_modeUnavailable),
        ('multipointConstraint', __RequestModeReject_cause_multipointConstraint),
        ('requestDenied', __RequestModeReject_cause_requestDenied),
        ])
    _RequestModeReject_cause._ext = []
    RequestModeReject._cont = ASN1Dict([
        ('sequenceNumber', _RequestModeReject_sequenceNumber),
        ('cause', _RequestModeReject_cause),
        ])
    RequestModeReject._ext = []
    
    #-----< RequestModeRelease >-----#
    RequestModeRelease = SEQ(name='RequestModeRelease', mode=MODE_TYPE)
    RequestModeRelease._cont = ASN1Dict([
        ])
    RequestModeRelease._ext = []
    
    #-----< ModeDescription >-----#
    ModeDescription = SET_OF(name='ModeDescription', mode=MODE_TYPE)
    _ModeDescription__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ModeElement')))
    ModeDescription._cont = _ModeDescription__item_
    ModeDescription._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ModeElementType >-----#
    ModeElementType = CHOICE(name='ModeElementType', mode=MODE_TYPE)
    _ModeElementType_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _ModeElementType_videoMode = CHOICE(name='videoMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoMode')))
    _ModeElementType_audioMode = CHOICE(name='audioMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioMode')))
    _ModeElementType_dataMode = SEQ(name='dataMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataMode')))
    _ModeElementType_encryptionMode = CHOICE(name='encryptionMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionMode')))
    _ModeElementType_h235Mode = SEQ(name='h235Mode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H235Mode')))
    _ModeElementType_multiplexedStreamMode = SEQ(name='multiplexedStreamMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexedStreamParameter')))
    _ModeElementType_redundancyEncodingDTMode = SEQ(name='redundancyEncodingDTMode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingDTMode')))
    _ModeElementType_multiplePayloadStreamMode = SEQ(name='multiplePayloadStreamMode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStreamMode')))
    _ModeElementType_depFecMode = CHOICE(name='depFecMode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DepFECMode')))
    _ModeElementType_fecMode = SEQ(name='fecMode', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FECMode')))
    ModeElementType._cont = ASN1Dict([
        ('nonStandard', _ModeElementType_nonStandard),
        ('videoMode', _ModeElementType_videoMode),
        ('audioMode', _ModeElementType_audioMode),
        ('dataMode', _ModeElementType_dataMode),
        ('encryptionMode', _ModeElementType_encryptionMode),
        ('h235Mode', _ModeElementType_h235Mode),
        ('multiplexedStreamMode', _ModeElementType_multiplexedStreamMode),
        ('redundancyEncodingDTMode', _ModeElementType_redundancyEncodingDTMode),
        ('multiplePayloadStreamMode', _ModeElementType_multiplePayloadStreamMode),
        ('depFecMode', _ModeElementType_depFecMode),
        ('fecMode', _ModeElementType_fecMode),
        ])
    ModeElementType._ext = ['h235Mode', 'multiplexedStreamMode', 'redundancyEncodingDTMode', 'multiplePayloadStreamMode', 'depFecMode', 'fecMode']
    
    #-----< ModeElement >-----#
    ModeElement = SEQ(name='ModeElement', mode=MODE_TYPE)
    _ModeElement_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ModeElementType')))
    _ModeElement_h223ModeParameters = SEQ(name='h223ModeParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223ModeParameters')), opt=True)
    _ModeElement_v76ModeParameters = CHOICE(name='v76ModeParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'V76ModeParameters')), opt=True)
    _ModeElement_h2250ModeParameters = SEQ(name='h2250ModeParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H2250ModeParameters')), opt=True)
    _ModeElement_genericModeParameters = SEQ(name='genericModeParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')), opt=True)
    _ModeElement_multiplexedStreamModeParameters = SEQ(name='multiplexedStreamModeParameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplexedStreamModeParameters')), opt=True)
    _ModeElement_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')), opt=True)
    ModeElement._cont = ASN1Dict([
        ('type', _ModeElement_type),
        ('h223ModeParameters', _ModeElement_h223ModeParameters),
        ('v76ModeParameters', _ModeElement_v76ModeParameters),
        ('h2250ModeParameters', _ModeElement_h2250ModeParameters),
        ('genericModeParameters', _ModeElement_genericModeParameters),
        ('multiplexedStreamModeParameters', _ModeElement_multiplexedStreamModeParameters),
        ('logicalChannelNumber', _ModeElement_logicalChannelNumber),
        ])
    ModeElement._ext = ['v76ModeParameters', 'h2250ModeParameters', 'genericModeParameters', 'multiplexedStreamModeParameters', 'logicalChannelNumber']
    
    #-----< H235Mode >-----#
    H235Mode = SEQ(name='H235Mode', mode=MODE_TYPE)
    _H235Mode_encryptionAuthenticationAndIntegrity = SEQ(name='encryptionAuthenticationAndIntegrity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionAuthenticationAndIntegrity')))
    _H235Mode_mediaMode = CHOICE(name='mediaMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H235Mode_mediaMode_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __H235Mode_mediaMode_videoMode = CHOICE(name='videoMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoMode')))
    __H235Mode_mediaMode_audioMode = CHOICE(name='audioMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioMode')))
    __H235Mode_mediaMode_dataMode = SEQ(name='dataMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataMode')))
    _H235Mode_mediaMode._cont = ASN1Dict([
        ('nonStandard', __H235Mode_mediaMode_nonStandard),
        ('videoMode', __H235Mode_mediaMode_videoMode),
        ('audioMode', __H235Mode_mediaMode_audioMode),
        ('dataMode', __H235Mode_mediaMode_dataMode),
        ])
    _H235Mode_mediaMode._ext = []
    H235Mode._cont = ASN1Dict([
        ('encryptionAuthenticationAndIntegrity', _H235Mode_encryptionAuthenticationAndIntegrity),
        ('mediaMode', _H235Mode_mediaMode),
        ])
    H235Mode._ext = []
    
    #-----< MultiplexedStreamModeParameters >-----#
    MultiplexedStreamModeParameters = SEQ(name='MultiplexedStreamModeParameters', mode=MODE_TYPE)
    _MultiplexedStreamModeParameters_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    MultiplexedStreamModeParameters._cont = ASN1Dict([
        ('logicalChannelNumber', _MultiplexedStreamModeParameters_logicalChannelNumber),
        ])
    MultiplexedStreamModeParameters._ext = []
    
    #-----< RedundancyEncodingDTMode >-----#
    RedundancyEncodingDTMode = SEQ(name='RedundancyEncodingDTMode', mode=MODE_TYPE)
    _RedundancyEncodingDTMode_redundancyEncodingMethod = CHOICE(name='redundancyEncodingMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingMethod')))
    _RedundancyEncodingDTMode_primary = SEQ(name='primary', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingDTModeElement')))
    _RedundancyEncodingDTMode_secondary = SEQ_OF(name='secondary', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RedundancyEncodingDTMode_secondary__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingDTModeElement')))
    _RedundancyEncodingDTMode_secondary._cont = __RedundancyEncodingDTMode_secondary__item_
    RedundancyEncodingDTMode._cont = ASN1Dict([
        ('redundancyEncodingMethod', _RedundancyEncodingDTMode_redundancyEncodingMethod),
        ('primary', _RedundancyEncodingDTMode_primary),
        ('secondary', _RedundancyEncodingDTMode_secondary),
        ])
    RedundancyEncodingDTMode._ext = []
    
    #-----< RedundancyEncodingDTModeElement >-----#
    RedundancyEncodingDTModeElement = SEQ(name='RedundancyEncodingDTModeElement', mode=MODE_TYPE)
    _RedundancyEncodingDTModeElement_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RedundancyEncodingDTModeElement_type_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __RedundancyEncodingDTModeElement_type_videoMode = CHOICE(name='videoMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoMode')))
    __RedundancyEncodingDTModeElement_type_audioMode = CHOICE(name='audioMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioMode')))
    __RedundancyEncodingDTModeElement_type_dataMode = SEQ(name='dataMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataMode')))
    __RedundancyEncodingDTModeElement_type_encryptionMode = CHOICE(name='encryptionMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionMode')))
    __RedundancyEncodingDTModeElement_type_h235Mode = SEQ(name='h235Mode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H235Mode')))
    __RedundancyEncodingDTModeElement_type_fecMode = SEQ(name='fecMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'FECMode')))
    _RedundancyEncodingDTModeElement_type._cont = ASN1Dict([
        ('nonStandard', __RedundancyEncodingDTModeElement_type_nonStandard),
        ('videoMode', __RedundancyEncodingDTModeElement_type_videoMode),
        ('audioMode', __RedundancyEncodingDTModeElement_type_audioMode),
        ('dataMode', __RedundancyEncodingDTModeElement_type_dataMode),
        ('encryptionMode', __RedundancyEncodingDTModeElement_type_encryptionMode),
        ('h235Mode', __RedundancyEncodingDTModeElement_type_h235Mode),
        ('fecMode', __RedundancyEncodingDTModeElement_type_fecMode),
        ])
    _RedundancyEncodingDTModeElement_type._ext = ['fecMode']
    RedundancyEncodingDTModeElement._cont = ASN1Dict([
        ('type', _RedundancyEncodingDTModeElement_type),
        ])
    RedundancyEncodingDTModeElement._ext = []
    
    #-----< MultiplePayloadStreamMode >-----#
    MultiplePayloadStreamMode = SEQ(name='MultiplePayloadStreamMode', mode=MODE_TYPE)
    _MultiplePayloadStreamMode_elements = SEQ_OF(name='elements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultiplePayloadStreamMode_elements__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStreamElementMode')))
    _MultiplePayloadStreamMode_elements._cont = __MultiplePayloadStreamMode_elements__item_
    MultiplePayloadStreamMode._cont = ASN1Dict([
        ('elements', _MultiplePayloadStreamMode_elements),
        ])
    MultiplePayloadStreamMode._ext = []
    
    #-----< MultiplePayloadStreamElementMode >-----#
    MultiplePayloadStreamElementMode = SEQ(name='MultiplePayloadStreamElementMode', mode=MODE_TYPE)
    _MultiplePayloadStreamElementMode_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ModeElementType')))
    MultiplePayloadStreamElementMode._cont = ASN1Dict([
        ('type', _MultiplePayloadStreamElementMode_type),
        ])
    MultiplePayloadStreamElementMode._ext = []
    
    #-----< DepFECMode >-----#
    DepFECMode = CHOICE(name='DepFECMode', mode=MODE_TYPE)
    _DepFECMode_rfc2733Mode = SEQ(name='rfc2733Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DepFECMode_rfc2733Mode_mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___DepFECMode_rfc2733Mode_mode_redundancyEncoding = NULL(name='redundancyEncoding', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DepFECMode_rfc2733Mode_mode_separateStream = CHOICE(name='separateStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____DepFECMode_rfc2733Mode_mode_separateStream_differentPort = SEQ(name='differentPort', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedSessionID = INT(name='protectedSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedPayloadType = INT(name='protectedPayloadType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedPayloadType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ____DepFECMode_rfc2733Mode_mode_separateStream_differentPort._cont = ASN1Dict([
        ('protectedSessionID', _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedSessionID),
        ('protectedPayloadType', _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedPayloadType),
        ])
    ____DepFECMode_rfc2733Mode_mode_separateStream_differentPort._ext = []
    ____DepFECMode_rfc2733Mode_mode_separateStream_samePort = SEQ(name='samePort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DepFECMode_rfc2733Mode_mode_separateStream_samePort_protectedType = CHOICE(name='protectedType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ModeElementType')))
    ____DepFECMode_rfc2733Mode_mode_separateStream_samePort._cont = ASN1Dict([
        ('protectedType', _____DepFECMode_rfc2733Mode_mode_separateStream_samePort_protectedType),
        ])
    ____DepFECMode_rfc2733Mode_mode_separateStream_samePort._ext = []
    ___DepFECMode_rfc2733Mode_mode_separateStream._cont = ASN1Dict([
        ('differentPort', ____DepFECMode_rfc2733Mode_mode_separateStream_differentPort),
        ('samePort', ____DepFECMode_rfc2733Mode_mode_separateStream_samePort),
        ])
    ___DepFECMode_rfc2733Mode_mode_separateStream._ext = []
    __DepFECMode_rfc2733Mode_mode._cont = ASN1Dict([
        ('redundancyEncoding', ___DepFECMode_rfc2733Mode_mode_redundancyEncoding),
        ('separateStream', ___DepFECMode_rfc2733Mode_mode_separateStream),
        ])
    __DepFECMode_rfc2733Mode_mode._ext = []
    _DepFECMode_rfc2733Mode._cont = ASN1Dict([
        ('mode', __DepFECMode_rfc2733Mode_mode),
        ])
    _DepFECMode_rfc2733Mode._ext = []
    DepFECMode._cont = ASN1Dict([
        ('rfc2733Mode', _DepFECMode_rfc2733Mode),
        ])
    DepFECMode._ext = []
    
    #-----< FECMode >-----#
    FECMode = SEQ(name='FECMode', mode=MODE_TYPE)
    _FECMode_protectedElement = CHOICE(name='protectedElement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ModeElementType')))
    _FECMode_fecScheme = OID(name='fecScheme', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FECMode_rfc2733Format = CHOICE(name='rfc2733Format', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __FECMode_rfc2733Format_rfc2733rfc2198 = INT(name='rfc2733rfc2198', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaxRedundancy')))
    __FECMode_rfc2733Format_rfc2733sameport = INT(name='rfc2733sameport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaxRedundancy')))
    __FECMode_rfc2733Format_rfc2733diffport = INT(name='rfc2733diffport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaxRedundancy')))
    _FECMode_rfc2733Format._cont = ASN1Dict([
        ('rfc2733rfc2198', __FECMode_rfc2733Format_rfc2733rfc2198),
        ('rfc2733sameport', __FECMode_rfc2733Format_rfc2733sameport),
        ('rfc2733diffport', __FECMode_rfc2733Format_rfc2733diffport),
        ])
    _FECMode_rfc2733Format._ext = None
    FECMode._cont = ASN1Dict([
        ('protectedElement', _FECMode_protectedElement),
        ('fecScheme', _FECMode_fecScheme),
        ('rfc2733Format', _FECMode_rfc2733Format),
        ])
    FECMode._ext = []
    
    #-----< H223ModeParameters >-----#
    H223ModeParameters = SEQ(name='H223ModeParameters', mode=MODE_TYPE)
    _H223ModeParameters_adaptationLayerType = CHOICE(name='adaptationLayerType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223ModeParameters_adaptationLayerType_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __H223ModeParameters_adaptationLayerType_al1Framed = NULL(name='al1Framed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223ModeParameters_adaptationLayerType_al1NotFramed = NULL(name='al1NotFramed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223ModeParameters_adaptationLayerType_al2WithoutSequenceNumbers = NULL(name='al2WithoutSequenceNumbers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223ModeParameters_adaptationLayerType_al2WithSequenceNumbers = NULL(name='al2WithSequenceNumbers', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223ModeParameters_adaptationLayerType_al3 = SEQ(name='al3', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223ModeParameters_adaptationLayerType_al3_controlFieldOctets = INT(name='controlFieldOctets', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223ModeParameters_adaptationLayerType_al3_controlFieldOctets._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=None, er=[])
    ___H223ModeParameters_adaptationLayerType_al3_sendBufferSize = INT(name='sendBufferSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___H223ModeParameters_adaptationLayerType_al3_sendBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    __H223ModeParameters_adaptationLayerType_al3._cont = ASN1Dict([
        ('controlFieldOctets', ___H223ModeParameters_adaptationLayerType_al3_controlFieldOctets),
        ('sendBufferSize', ___H223ModeParameters_adaptationLayerType_al3_sendBufferSize),
        ])
    __H223ModeParameters_adaptationLayerType_al3._ext = None
    __H223ModeParameters_adaptationLayerType_al1M = SEQ(name='al1M', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AL1MParameters')))
    __H223ModeParameters_adaptationLayerType_al2M = SEQ(name='al2M', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AL2MParameters')))
    __H223ModeParameters_adaptationLayerType_al3M = SEQ(name='al3M', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H223AL3MParameters')))
    _H223ModeParameters_adaptationLayerType._cont = ASN1Dict([
        ('nonStandard', __H223ModeParameters_adaptationLayerType_nonStandard),
        ('al1Framed', __H223ModeParameters_adaptationLayerType_al1Framed),
        ('al1NotFramed', __H223ModeParameters_adaptationLayerType_al1NotFramed),
        ('al2WithoutSequenceNumbers', __H223ModeParameters_adaptationLayerType_al2WithoutSequenceNumbers),
        ('al2WithSequenceNumbers', __H223ModeParameters_adaptationLayerType_al2WithSequenceNumbers),
        ('al3', __H223ModeParameters_adaptationLayerType_al3),
        ('al1M', __H223ModeParameters_adaptationLayerType_al1M),
        ('al2M', __H223ModeParameters_adaptationLayerType_al2M),
        ('al3M', __H223ModeParameters_adaptationLayerType_al3M),
        ])
    _H223ModeParameters_adaptationLayerType._ext = ['al1M', 'al2M', 'al3M']
    _H223ModeParameters_segmentableFlag = BOOL(name='segmentableFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H223ModeParameters._cont = ASN1Dict([
        ('adaptationLayerType', _H223ModeParameters_adaptationLayerType),
        ('segmentableFlag', _H223ModeParameters_segmentableFlag),
        ])
    H223ModeParameters._ext = []
    
    #-----< V76ModeParameters >-----#
    V76ModeParameters = CHOICE(name='V76ModeParameters', mode=MODE_TYPE)
    _V76ModeParameters_suspendResumewAddress = NULL(name='suspendResumewAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _V76ModeParameters_suspendResumewoAddress = NULL(name='suspendResumewoAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    V76ModeParameters._cont = ASN1Dict([
        ('suspendResumewAddress', _V76ModeParameters_suspendResumewAddress),
        ('suspendResumewoAddress', _V76ModeParameters_suspendResumewoAddress),
        ])
    V76ModeParameters._ext = []
    
    #-----< H2250ModeParameters >-----#
    H2250ModeParameters = SEQ(name='H2250ModeParameters', mode=MODE_TYPE)
    _H2250ModeParameters_redundancyEncodingMode = SEQ(name='redundancyEncodingMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingMode')), opt=True)
    H2250ModeParameters._cont = ASN1Dict([
        ('redundancyEncodingMode', _H2250ModeParameters_redundancyEncodingMode),
        ])
    H2250ModeParameters._ext = []
    
    #-----< RedundancyEncodingMode >-----#
    RedundancyEncodingMode = SEQ(name='RedundancyEncodingMode', mode=MODE_TYPE)
    _RedundancyEncodingMode_redundancyEncodingMethod = CHOICE(name='redundancyEncodingMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncodingMethod')))
    _RedundancyEncodingMode_secondaryEncoding = CHOICE(name='secondaryEncoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RedundancyEncodingMode_secondaryEncoding_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __RedundancyEncodingMode_secondaryEncoding_audioData = CHOICE(name='audioData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioMode')))
    _RedundancyEncodingMode_secondaryEncoding._cont = ASN1Dict([
        ('nonStandard', __RedundancyEncodingMode_secondaryEncoding_nonStandard),
        ('audioData', __RedundancyEncodingMode_secondaryEncoding_audioData),
        ])
    _RedundancyEncodingMode_secondaryEncoding._ext = []
    RedundancyEncodingMode._cont = ASN1Dict([
        ('redundancyEncodingMethod', _RedundancyEncodingMode_redundancyEncodingMethod),
        ('secondaryEncoding', _RedundancyEncodingMode_secondaryEncoding),
        ])
    RedundancyEncodingMode._ext = []
    
    #-----< VideoMode >-----#
    VideoMode = CHOICE(name='VideoMode', mode=MODE_TYPE)
    _VideoMode_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _VideoMode_h261VideoMode = SEQ(name='h261VideoMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H261VideoMode')))
    _VideoMode_h262VideoMode = SEQ(name='h262VideoMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H262VideoMode')))
    _VideoMode_h263VideoMode = SEQ(name='h263VideoMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263VideoMode')))
    _VideoMode_is11172VideoMode = SEQ(name='is11172VideoMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IS11172VideoMode')))
    _VideoMode_genericVideoMode = SEQ(name='genericVideoMode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    VideoMode._cont = ASN1Dict([
        ('nonStandard', _VideoMode_nonStandard),
        ('h261VideoMode', _VideoMode_h261VideoMode),
        ('h262VideoMode', _VideoMode_h262VideoMode),
        ('h263VideoMode', _VideoMode_h263VideoMode),
        ('is11172VideoMode', _VideoMode_is11172VideoMode),
        ('genericVideoMode', _VideoMode_genericVideoMode),
        ])
    VideoMode._ext = ['genericVideoMode']
    
    #-----< H261VideoMode >-----#
    H261VideoMode = SEQ(name='H261VideoMode', mode=MODE_TYPE)
    _H261VideoMode_resolution = CHOICE(name='resolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H261VideoMode_resolution_qcif = NULL(name='qcif', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H261VideoMode_resolution_cif = NULL(name='cif', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H261VideoMode_resolution._cont = ASN1Dict([
        ('qcif', __H261VideoMode_resolution_qcif),
        ('cif', __H261VideoMode_resolution_cif),
        ])
    _H261VideoMode_resolution._ext = None
    _H261VideoMode_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H261VideoMode_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=19200)], ev=None, er=[])
    _H261VideoMode_stillImageTransmission = BOOL(name='stillImageTransmission', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    H261VideoMode._cont = ASN1Dict([
        ('resolution', _H261VideoMode_resolution),
        ('bitRate', _H261VideoMode_bitRate),
        ('stillImageTransmission', _H261VideoMode_stillImageTransmission),
        ])
    H261VideoMode._ext = []
    
    #-----< H262VideoMode >-----#
    H262VideoMode = SEQ(name='H262VideoMode', mode=MODE_TYPE)
    _H262VideoMode_profileAndLevel = CHOICE(name='profileAndLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_SPatML = NULL(name='profileAndLevel-SPatML', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_MPatLL = NULL(name='profileAndLevel-MPatLL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_MPatML = NULL(name='profileAndLevel-MPatML', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_MPatH_14 = NULL(name='profileAndLevel-MPatH-14', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_MPatHL = NULL(name='profileAndLevel-MPatHL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_SNRatLL = NULL(name='profileAndLevel-SNRatLL', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_SNRatML = NULL(name='profileAndLevel-SNRatML', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_SpatialatH_14 = NULL(name='profileAndLevel-SpatialatH-14', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_HPatML = NULL(name='profileAndLevel-HPatML', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_HPatH_14 = NULL(name='profileAndLevel-HPatH-14', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H262VideoMode_profileAndLevel_profileAndLevel_HPatHL = NULL(name='profileAndLevel-HPatHL', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H262VideoMode_profileAndLevel._cont = ASN1Dict([
        ('profileAndLevel-SPatML', __H262VideoMode_profileAndLevel_profileAndLevel_SPatML),
        ('profileAndLevel-MPatLL', __H262VideoMode_profileAndLevel_profileAndLevel_MPatLL),
        ('profileAndLevel-MPatML', __H262VideoMode_profileAndLevel_profileAndLevel_MPatML),
        ('profileAndLevel-MPatH-14', __H262VideoMode_profileAndLevel_profileAndLevel_MPatH_14),
        ('profileAndLevel-MPatHL', __H262VideoMode_profileAndLevel_profileAndLevel_MPatHL),
        ('profileAndLevel-SNRatLL', __H262VideoMode_profileAndLevel_profileAndLevel_SNRatLL),
        ('profileAndLevel-SNRatML', __H262VideoMode_profileAndLevel_profileAndLevel_SNRatML),
        ('profileAndLevel-SpatialatH-14', __H262VideoMode_profileAndLevel_profileAndLevel_SpatialatH_14),
        ('profileAndLevel-HPatML', __H262VideoMode_profileAndLevel_profileAndLevel_HPatML),
        ('profileAndLevel-HPatH-14', __H262VideoMode_profileAndLevel_profileAndLevel_HPatH_14),
        ('profileAndLevel-HPatHL', __H262VideoMode_profileAndLevel_profileAndLevel_HPatHL),
        ])
    _H262VideoMode_profileAndLevel._ext = []
    _H262VideoMode_videoBitRate = INT(name='videoBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoMode_videoBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1073741823)], ev=None, er=[])
    _H262VideoMode_vbvBufferSize = INT(name='vbvBufferSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoMode_vbvBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _H262VideoMode_samplesPerLine = INT(name='samplesPerLine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoMode_samplesPerLine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _H262VideoMode_linesPerFrame = INT(name='linesPerFrame', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoMode_linesPerFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _H262VideoMode_framesPerSecond = INT(name='framesPerSecond', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoMode_framesPerSecond._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _H262VideoMode_luminanceSampleRate = INT(name='luminanceSampleRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _H262VideoMode_luminanceSampleRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    H262VideoMode._cont = ASN1Dict([
        ('profileAndLevel', _H262VideoMode_profileAndLevel),
        ('videoBitRate', _H262VideoMode_videoBitRate),
        ('vbvBufferSize', _H262VideoMode_vbvBufferSize),
        ('samplesPerLine', _H262VideoMode_samplesPerLine),
        ('linesPerFrame', _H262VideoMode_linesPerFrame),
        ('framesPerSecond', _H262VideoMode_framesPerSecond),
        ('luminanceSampleRate', _H262VideoMode_luminanceSampleRate),
        ])
    H262VideoMode._ext = []
    
    #-----< H263VideoMode >-----#
    H263VideoMode = SEQ(name='H263VideoMode', mode=MODE_TYPE)
    _H263VideoMode_resolution = CHOICE(name='resolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H263VideoMode_resolution_sqcif = NULL(name='sqcif', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H263VideoMode_resolution_qcif = NULL(name='qcif', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H263VideoMode_resolution_cif = NULL(name='cif', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H263VideoMode_resolution_cif4 = NULL(name='cif4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H263VideoMode_resolution_cif16 = NULL(name='cif16', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H263VideoMode_resolution_custom = NULL(name='custom', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_resolution._cont = ASN1Dict([
        ('sqcif', __H263VideoMode_resolution_sqcif),
        ('qcif', __H263VideoMode_resolution_qcif),
        ('cif', __H263VideoMode_resolution_cif),
        ('cif4', __H263VideoMode_resolution_cif4),
        ('cif16', __H263VideoMode_resolution_cif16),
        ('custom', __H263VideoMode_resolution_custom),
        ])
    _H263VideoMode_resolution._ext = ['custom']
    _H263VideoMode_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=19200)], ev=None, er=[])
    _H263VideoMode_unrestrictedVector = BOOL(name='unrestrictedVector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_arithmeticCoding = BOOL(name='arithmeticCoding', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_advancedPrediction = BOOL(name='advancedPrediction', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_pbFrames = BOOL(name='pbFrames', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_errorCompensation = BOOL(name='errorCompensation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H263VideoMode_enhancementLayerInfo = SEQ(name='enhancementLayerInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EnhancementLayerInfo')), opt=True)
    _H263VideoMode_h263Options = SEQ(name='h263Options', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'H263Options')), opt=True)
    H263VideoMode._cont = ASN1Dict([
        ('resolution', _H263VideoMode_resolution),
        ('bitRate', _H263VideoMode_bitRate),
        ('unrestrictedVector', _H263VideoMode_unrestrictedVector),
        ('arithmeticCoding', _H263VideoMode_arithmeticCoding),
        ('advancedPrediction', _H263VideoMode_advancedPrediction),
        ('pbFrames', _H263VideoMode_pbFrames),
        ('errorCompensation', _H263VideoMode_errorCompensation),
        ('enhancementLayerInfo', _H263VideoMode_enhancementLayerInfo),
        ('h263Options', _H263VideoMode_h263Options),
        ])
    H263VideoMode._ext = ['errorCompensation', 'enhancementLayerInfo', 'h263Options']
    
    #-----< IS11172VideoMode >-----#
    IS11172VideoMode = SEQ(name='IS11172VideoMode', mode=MODE_TYPE)
    _IS11172VideoMode_constrainedBitstream = BOOL(name='constrainedBitstream', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172VideoMode_videoBitRate = INT(name='videoBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoMode_videoBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1073741823)], ev=None, er=[])
    _IS11172VideoMode_vbvBufferSize = INT(name='vbvBufferSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoMode_vbvBufferSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _IS11172VideoMode_samplesPerLine = INT(name='samplesPerLine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoMode_samplesPerLine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _IS11172VideoMode_linesPerFrame = INT(name='linesPerFrame', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoMode_linesPerFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _IS11172VideoMode_pictureRate = INT(name='pictureRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoMode_pictureRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _IS11172VideoMode_luminanceSampleRate = INT(name='luminanceSampleRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IS11172VideoMode_luminanceSampleRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    IS11172VideoMode._cont = ASN1Dict([
        ('constrainedBitstream', _IS11172VideoMode_constrainedBitstream),
        ('videoBitRate', _IS11172VideoMode_videoBitRate),
        ('vbvBufferSize', _IS11172VideoMode_vbvBufferSize),
        ('samplesPerLine', _IS11172VideoMode_samplesPerLine),
        ('linesPerFrame', _IS11172VideoMode_linesPerFrame),
        ('pictureRate', _IS11172VideoMode_pictureRate),
        ('luminanceSampleRate', _IS11172VideoMode_luminanceSampleRate),
        ])
    IS11172VideoMode._ext = []
    
    #-----< AudioMode >-----#
    AudioMode = CHOICE(name='AudioMode', mode=MODE_TYPE)
    _AudioMode_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _AudioMode_g711Alaw64k = NULL(name='g711Alaw64k', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g711Alaw56k = NULL(name='g711Alaw56k', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g711Ulaw64k = NULL(name='g711Ulaw64k', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g711Ulaw56k = NULL(name='g711Ulaw56k', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g722_64k = NULL(name='g722-64k', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g722_56k = NULL(name='g722-56k', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g722_48k = NULL(name='g722-48k', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g728 = NULL(name='g728', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g729 = NULL(name='g729', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g729AnnexA = NULL(name='g729AnnexA', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g7231 = CHOICE(name='g7231', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AudioMode_g7231_noSilenceSuppressionLowRate = NULL(name='noSilenceSuppressionLowRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AudioMode_g7231_noSilenceSuppressionHighRate = NULL(name='noSilenceSuppressionHighRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AudioMode_g7231_silenceSuppressionLowRate = NULL(name='silenceSuppressionLowRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AudioMode_g7231_silenceSuppressionHighRate = NULL(name='silenceSuppressionHighRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g7231._cont = ASN1Dict([
        ('noSilenceSuppressionLowRate', __AudioMode_g7231_noSilenceSuppressionLowRate),
        ('noSilenceSuppressionHighRate', __AudioMode_g7231_noSilenceSuppressionHighRate),
        ('silenceSuppressionLowRate', __AudioMode_g7231_silenceSuppressionLowRate),
        ('silenceSuppressionHighRate', __AudioMode_g7231_silenceSuppressionHighRate),
        ])
    _AudioMode_g7231._ext = None
    _AudioMode_is11172AudioMode = SEQ(name='is11172AudioMode', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IS11172AudioMode')))
    _AudioMode_is13818AudioMode = SEQ(name='is13818AudioMode', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IS13818AudioMode')))
    _AudioMode_g729wAnnexB = INT(name='g729wAnnexB', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g729wAnnexB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioMode_g729AnnexAwAnnexB = INT(name='g729AnnexAwAnnexB', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AudioMode_g729AnnexAwAnnexB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _AudioMode_g7231AnnexCMode = SEQ(name='g7231AnnexCMode', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'G7231AnnexCMode')))
    _AudioMode_gsmFullRate = SEQ(name='gsmFullRate', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GSMAudioCapability')))
    _AudioMode_gsmHalfRate = SEQ(name='gsmHalfRate', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GSMAudioCapability')))
    _AudioMode_gsmEnhancedFullRate = SEQ(name='gsmEnhancedFullRate', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GSMAudioCapability')))
    _AudioMode_genericAudioMode = SEQ(name='genericAudioMode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _AudioMode_g729Extensions = SEQ(name='g729Extensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'G729Extensions')))
    _AudioMode_vbd = SEQ(name='vbd', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VBDMode')))
    AudioMode._cont = ASN1Dict([
        ('nonStandard', _AudioMode_nonStandard),
        ('g711Alaw64k', _AudioMode_g711Alaw64k),
        ('g711Alaw56k', _AudioMode_g711Alaw56k),
        ('g711Ulaw64k', _AudioMode_g711Ulaw64k),
        ('g711Ulaw56k', _AudioMode_g711Ulaw56k),
        ('g722-64k', _AudioMode_g722_64k),
        ('g722-56k', _AudioMode_g722_56k),
        ('g722-48k', _AudioMode_g722_48k),
        ('g728', _AudioMode_g728),
        ('g729', _AudioMode_g729),
        ('g729AnnexA', _AudioMode_g729AnnexA),
        ('g7231', _AudioMode_g7231),
        ('is11172AudioMode', _AudioMode_is11172AudioMode),
        ('is13818AudioMode', _AudioMode_is13818AudioMode),
        ('g729wAnnexB', _AudioMode_g729wAnnexB),
        ('g729AnnexAwAnnexB', _AudioMode_g729AnnexAwAnnexB),
        ('g7231AnnexCMode', _AudioMode_g7231AnnexCMode),
        ('gsmFullRate', _AudioMode_gsmFullRate),
        ('gsmHalfRate', _AudioMode_gsmHalfRate),
        ('gsmEnhancedFullRate', _AudioMode_gsmEnhancedFullRate),
        ('genericAudioMode', _AudioMode_genericAudioMode),
        ('g729Extensions', _AudioMode_g729Extensions),
        ('vbd', _AudioMode_vbd),
        ])
    AudioMode._ext = ['g729wAnnexB', 'g729AnnexAwAnnexB', 'g7231AnnexCMode', 'gsmFullRate', 'gsmHalfRate', 'gsmEnhancedFullRate', 'genericAudioMode', 'g729Extensions', 'vbd']
    
    #-----< IS11172AudioMode >-----#
    IS11172AudioMode = SEQ(name='IS11172AudioMode', mode=MODE_TYPE)
    _IS11172AudioMode_audioLayer = CHOICE(name='audioLayer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IS11172AudioMode_audioLayer_audioLayer1 = NULL(name='audioLayer1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS11172AudioMode_audioLayer_audioLayer2 = NULL(name='audioLayer2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS11172AudioMode_audioLayer_audioLayer3 = NULL(name='audioLayer3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioMode_audioLayer._cont = ASN1Dict([
        ('audioLayer1', __IS11172AudioMode_audioLayer_audioLayer1),
        ('audioLayer2', __IS11172AudioMode_audioLayer_audioLayer2),
        ('audioLayer3', __IS11172AudioMode_audioLayer_audioLayer3),
        ])
    _IS11172AudioMode_audioLayer._ext = None
    _IS11172AudioMode_audioSampling = CHOICE(name='audioSampling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IS11172AudioMode_audioSampling_audioSampling32k = NULL(name='audioSampling32k', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS11172AudioMode_audioSampling_audioSampling44k1 = NULL(name='audioSampling44k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS11172AudioMode_audioSampling_audioSampling48k = NULL(name='audioSampling48k', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioMode_audioSampling._cont = ASN1Dict([
        ('audioSampling32k', __IS11172AudioMode_audioSampling_audioSampling32k),
        ('audioSampling44k1', __IS11172AudioMode_audioSampling_audioSampling44k1),
        ('audioSampling48k', __IS11172AudioMode_audioSampling_audioSampling48k),
        ])
    _IS11172AudioMode_audioSampling._ext = None
    _IS11172AudioMode_multichannelType = CHOICE(name='multichannelType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IS11172AudioMode_multichannelType_singleChannel = NULL(name='singleChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS11172AudioMode_multichannelType_twoChannelStereo = NULL(name='twoChannelStereo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS11172AudioMode_multichannelType_twoChannelDual = NULL(name='twoChannelDual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioMode_multichannelType._cont = ASN1Dict([
        ('singleChannel', __IS11172AudioMode_multichannelType_singleChannel),
        ('twoChannelStereo', __IS11172AudioMode_multichannelType_twoChannelStereo),
        ('twoChannelDual', __IS11172AudioMode_multichannelType_twoChannelDual),
        ])
    _IS11172AudioMode_multichannelType._ext = None
    _IS11172AudioMode_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS11172AudioMode_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=448)], ev=None, er=[])
    IS11172AudioMode._cont = ASN1Dict([
        ('audioLayer', _IS11172AudioMode_audioLayer),
        ('audioSampling', _IS11172AudioMode_audioSampling),
        ('multichannelType', _IS11172AudioMode_multichannelType),
        ('bitRate', _IS11172AudioMode_bitRate),
        ])
    IS11172AudioMode._ext = []
    
    #-----< IS13818AudioMode >-----#
    IS13818AudioMode = SEQ(name='IS13818AudioMode', mode=MODE_TYPE)
    _IS13818AudioMode_audioLayer = CHOICE(name='audioLayer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IS13818AudioMode_audioLayer_audioLayer1 = NULL(name='audioLayer1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioLayer_audioLayer2 = NULL(name='audioLayer2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioLayer_audioLayer3 = NULL(name='audioLayer3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioMode_audioLayer._cont = ASN1Dict([
        ('audioLayer1', __IS13818AudioMode_audioLayer_audioLayer1),
        ('audioLayer2', __IS13818AudioMode_audioLayer_audioLayer2),
        ('audioLayer3', __IS13818AudioMode_audioLayer_audioLayer3),
        ])
    _IS13818AudioMode_audioLayer._ext = None
    _IS13818AudioMode_audioSampling = CHOICE(name='audioSampling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IS13818AudioMode_audioSampling_audioSampling16k = NULL(name='audioSampling16k', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioSampling_audioSampling22k05 = NULL(name='audioSampling22k05', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioSampling_audioSampling24k = NULL(name='audioSampling24k', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioSampling_audioSampling32k = NULL(name='audioSampling32k', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioSampling_audioSampling44k1 = NULL(name='audioSampling44k1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_audioSampling_audioSampling48k = NULL(name='audioSampling48k', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioMode_audioSampling._cont = ASN1Dict([
        ('audioSampling16k', __IS13818AudioMode_audioSampling_audioSampling16k),
        ('audioSampling22k05', __IS13818AudioMode_audioSampling_audioSampling22k05),
        ('audioSampling24k', __IS13818AudioMode_audioSampling_audioSampling24k),
        ('audioSampling32k', __IS13818AudioMode_audioSampling_audioSampling32k),
        ('audioSampling44k1', __IS13818AudioMode_audioSampling_audioSampling44k1),
        ('audioSampling48k', __IS13818AudioMode_audioSampling_audioSampling48k),
        ])
    _IS13818AudioMode_audioSampling._ext = None
    _IS13818AudioMode_multichannelType = CHOICE(name='multichannelType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IS13818AudioMode_multichannelType_singleChannel = NULL(name='singleChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_twoChannelStereo = NULL(name='twoChannelStereo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_twoChannelDual = NULL(name='twoChannelDual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_threeChannels2_1 = NULL(name='threeChannels2-1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_threeChannels3_0 = NULL(name='threeChannels3-0', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_fourChannels2_0_2_0 = NULL(name='fourChannels2-0-2-0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_fourChannels2_2 = NULL(name='fourChannels2-2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_fourChannels3_1 = NULL(name='fourChannels3-1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_fiveChannels3_0_2_0 = NULL(name='fiveChannels3-0-2-0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IS13818AudioMode_multichannelType_fiveChannels3_2 = NULL(name='fiveChannels3-2', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioMode_multichannelType._cont = ASN1Dict([
        ('singleChannel', __IS13818AudioMode_multichannelType_singleChannel),
        ('twoChannelStereo', __IS13818AudioMode_multichannelType_twoChannelStereo),
        ('twoChannelDual', __IS13818AudioMode_multichannelType_twoChannelDual),
        ('threeChannels2-1', __IS13818AudioMode_multichannelType_threeChannels2_1),
        ('threeChannels3-0', __IS13818AudioMode_multichannelType_threeChannels3_0),
        ('fourChannels2-0-2-0', __IS13818AudioMode_multichannelType_fourChannels2_0_2_0),
        ('fourChannels2-2', __IS13818AudioMode_multichannelType_fourChannels2_2),
        ('fourChannels3-1', __IS13818AudioMode_multichannelType_fourChannels3_1),
        ('fiveChannels3-0-2-0', __IS13818AudioMode_multichannelType_fiveChannels3_0_2_0),
        ('fiveChannels3-2', __IS13818AudioMode_multichannelType_fiveChannels3_2),
        ])
    _IS13818AudioMode_multichannelType._ext = None
    _IS13818AudioMode_lowFrequencyEnhancement = BOOL(name='lowFrequencyEnhancement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioMode_multilingual = BOOL(name='multilingual', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioMode_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IS13818AudioMode_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1130)], ev=None, er=[])
    IS13818AudioMode._cont = ASN1Dict([
        ('audioLayer', _IS13818AudioMode_audioLayer),
        ('audioSampling', _IS13818AudioMode_audioSampling),
        ('multichannelType', _IS13818AudioMode_multichannelType),
        ('lowFrequencyEnhancement', _IS13818AudioMode_lowFrequencyEnhancement),
        ('multilingual', _IS13818AudioMode_multilingual),
        ('bitRate', _IS13818AudioMode_bitRate),
        ])
    IS13818AudioMode._ext = []
    
    #-----< G7231AnnexCMode >-----#
    G7231AnnexCMode = SEQ(name='G7231AnnexCMode', mode=MODE_TYPE)
    _G7231AnnexCMode_maxAl_sduAudioFrames = INT(name='maxAl-sduAudioFrames', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G7231AnnexCMode_maxAl_sduAudioFrames._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _G7231AnnexCMode_silenceSuppression = BOOL(name='silenceSuppression', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _G7231AnnexCMode_g723AnnexCAudioMode = SEQ(name='g723AnnexCAudioMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode0 = INT(name='highRateMode0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=27, ub=78)], ev=None, er=[])
    __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode1 = INT(name='highRateMode1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=27, ub=78)], ev=None, er=[])
    __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode0 = INT(name='lowRateMode0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=23, ub=66)], ev=None, er=[])
    __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode1 = INT(name='lowRateMode1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=23, ub=66)], ev=None, er=[])
    __G7231AnnexCMode_g723AnnexCAudioMode_sidMode0 = INT(name='sidMode0', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_sidMode0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=17)], ev=None, er=[])
    __G7231AnnexCMode_g723AnnexCAudioMode_sidMode1 = INT(name='sidMode1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __G7231AnnexCMode_g723AnnexCAudioMode_sidMode1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=17)], ev=None, er=[])
    _G7231AnnexCMode_g723AnnexCAudioMode._cont = ASN1Dict([
        ('highRateMode0', __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode0),
        ('highRateMode1', __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode1),
        ('lowRateMode0', __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode0),
        ('lowRateMode1', __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode1),
        ('sidMode0', __G7231AnnexCMode_g723AnnexCAudioMode_sidMode0),
        ('sidMode1', __G7231AnnexCMode_g723AnnexCAudioMode_sidMode1),
        ])
    _G7231AnnexCMode_g723AnnexCAudioMode._ext = []
    G7231AnnexCMode._cont = ASN1Dict([
        ('maxAl-sduAudioFrames', _G7231AnnexCMode_maxAl_sduAudioFrames),
        ('silenceSuppression', _G7231AnnexCMode_silenceSuppression),
        ('g723AnnexCAudioMode', _G7231AnnexCMode_g723AnnexCAudioMode),
        ])
    G7231AnnexCMode._ext = []
    
    #-----< VBDMode >-----#
    VBDMode = SEQ(name='VBDMode', mode=MODE_TYPE)
    _VBDMode_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioMode')))
    VBDMode._cont = ASN1Dict([
        ('type', _VBDMode_type),
        ])
    VBDMode._ext = []
    
    #-----< DataMode >-----#
    DataMode = SEQ(name='DataMode', mode=MODE_TYPE)
    _DataMode_application = CHOICE(name='application', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __DataMode_application_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __DataMode_application_t120 = CHOICE(name='t120', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_dsm_cc = CHOICE(name='dsm-cc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_userData = CHOICE(name='userData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_t84 = CHOICE(name='t84', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_t434 = CHOICE(name='t434', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_h224 = CHOICE(name='h224', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_nlpid = SEQ(name='nlpid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DataMode_application_nlpid_nlpidProtocol = CHOICE(name='nlpidProtocol', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    ___DataMode_application_nlpid_nlpidData = OCT_STR(name='nlpidData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DataMode_application_nlpid._cont = ASN1Dict([
        ('nlpidProtocol', ___DataMode_application_nlpid_nlpidProtocol),
        ('nlpidData', ___DataMode_application_nlpid_nlpidData),
        ])
    __DataMode_application_nlpid._ext = None
    __DataMode_application_dsvdControl = NULL(name='dsvdControl', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DataMode_application_h222DataPartitioning = CHOICE(name='h222DataPartitioning', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_t30fax = CHOICE(name='t30fax', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_t140 = CHOICE(name='t140', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    __DataMode_application_t38fax = SEQ(name='t38fax', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DataMode_application_t38fax_t38FaxProtocol = CHOICE(name='t38FaxProtocol', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataProtocolCapability')))
    ___DataMode_application_t38fax_t38FaxProfile = SEQ(name='t38FaxProfile', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'T38FaxProfile')))
    __DataMode_application_t38fax._cont = ASN1Dict([
        ('t38FaxProtocol', ___DataMode_application_t38fax_t38FaxProtocol),
        ('t38FaxProfile', ___DataMode_application_t38fax_t38FaxProfile),
        ])
    __DataMode_application_t38fax._ext = None
    __DataMode_application_genericDataMode = SEQ(name='genericDataMode', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericCapability')))
    _DataMode_application._cont = ASN1Dict([
        ('nonStandard', __DataMode_application_nonStandard),
        ('t120', __DataMode_application_t120),
        ('dsm-cc', __DataMode_application_dsm_cc),
        ('userData', __DataMode_application_userData),
        ('t84', __DataMode_application_t84),
        ('t434', __DataMode_application_t434),
        ('h224', __DataMode_application_h224),
        ('nlpid', __DataMode_application_nlpid),
        ('dsvdControl', __DataMode_application_dsvdControl),
        ('h222DataPartitioning', __DataMode_application_h222DataPartitioning),
        ('t30fax', __DataMode_application_t30fax),
        ('t140', __DataMode_application_t140),
        ('t38fax', __DataMode_application_t38fax),
        ('genericDataMode', __DataMode_application_genericDataMode),
        ])
    _DataMode_application._ext = ['t30fax', 't140', 't38fax', 'genericDataMode']
    _DataMode_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataMode_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    DataMode._cont = ASN1Dict([
        ('application', _DataMode_application),
        ('bitRate', _DataMode_bitRate),
        ])
    DataMode._ext = []
    
    #-----< EncryptionMode >-----#
    EncryptionMode = CHOICE(name='EncryptionMode', mode=MODE_TYPE)
    _EncryptionMode_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _EncryptionMode_h233Encryption = NULL(name='h233Encryption', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    EncryptionMode._cont = ASN1Dict([
        ('nonStandard', _EncryptionMode_nonStandard),
        ('h233Encryption', _EncryptionMode_h233Encryption),
        ])
    EncryptionMode._ext = []
    
    #-----< RoundTripDelayRequest >-----#
    RoundTripDelayRequest = SEQ(name='RoundTripDelayRequest', mode=MODE_TYPE)
    _RoundTripDelayRequest_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    RoundTripDelayRequest._cont = ASN1Dict([
        ('sequenceNumber', _RoundTripDelayRequest_sequenceNumber),
        ])
    RoundTripDelayRequest._ext = []
    
    #-----< RoundTripDelayResponse >-----#
    RoundTripDelayResponse = SEQ(name='RoundTripDelayResponse', mode=MODE_TYPE)
    _RoundTripDelayResponse_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    RoundTripDelayResponse._cont = ASN1Dict([
        ('sequenceNumber', _RoundTripDelayResponse_sequenceNumber),
        ])
    RoundTripDelayResponse._ext = []
    
    #-----< MaintenanceLoopRequest >-----#
    MaintenanceLoopRequest = SEQ(name='MaintenanceLoopRequest', mode=MODE_TYPE)
    _MaintenanceLoopRequest_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MaintenanceLoopRequest_type_systemLoop = NULL(name='systemLoop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MaintenanceLoopRequest_type_mediaLoop = INT(name='mediaLoop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __MaintenanceLoopRequest_type_logicalChannelLoop = INT(name='logicalChannelLoop', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _MaintenanceLoopRequest_type._cont = ASN1Dict([
        ('systemLoop', __MaintenanceLoopRequest_type_systemLoop),
        ('mediaLoop', __MaintenanceLoopRequest_type_mediaLoop),
        ('logicalChannelLoop', __MaintenanceLoopRequest_type_logicalChannelLoop),
        ])
    _MaintenanceLoopRequest_type._ext = []
    MaintenanceLoopRequest._cont = ASN1Dict([
        ('type', _MaintenanceLoopRequest_type),
        ])
    MaintenanceLoopRequest._ext = []
    
    #-----< MaintenanceLoopAck >-----#
    MaintenanceLoopAck = SEQ(name='MaintenanceLoopAck', mode=MODE_TYPE)
    _MaintenanceLoopAck_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MaintenanceLoopAck_type_systemLoop = NULL(name='systemLoop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MaintenanceLoopAck_type_mediaLoop = INT(name='mediaLoop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __MaintenanceLoopAck_type_logicalChannelLoop = INT(name='logicalChannelLoop', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _MaintenanceLoopAck_type._cont = ASN1Dict([
        ('systemLoop', __MaintenanceLoopAck_type_systemLoop),
        ('mediaLoop', __MaintenanceLoopAck_type_mediaLoop),
        ('logicalChannelLoop', __MaintenanceLoopAck_type_logicalChannelLoop),
        ])
    _MaintenanceLoopAck_type._ext = []
    MaintenanceLoopAck._cont = ASN1Dict([
        ('type', _MaintenanceLoopAck_type),
        ])
    MaintenanceLoopAck._ext = []
    
    #-----< MaintenanceLoopReject >-----#
    MaintenanceLoopReject = SEQ(name='MaintenanceLoopReject', mode=MODE_TYPE)
    _MaintenanceLoopReject_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MaintenanceLoopReject_type_systemLoop = NULL(name='systemLoop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MaintenanceLoopReject_type_mediaLoop = INT(name='mediaLoop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __MaintenanceLoopReject_type_logicalChannelLoop = INT(name='logicalChannelLoop', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _MaintenanceLoopReject_type._cont = ASN1Dict([
        ('systemLoop', __MaintenanceLoopReject_type_systemLoop),
        ('mediaLoop', __MaintenanceLoopReject_type_mediaLoop),
        ('logicalChannelLoop', __MaintenanceLoopReject_type_logicalChannelLoop),
        ])
    _MaintenanceLoopReject_type._ext = []
    _MaintenanceLoopReject_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MaintenanceLoopReject_cause_canNotPerformLoop = NULL(name='canNotPerformLoop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MaintenanceLoopReject_cause._cont = ASN1Dict([
        ('canNotPerformLoop', __MaintenanceLoopReject_cause_canNotPerformLoop),
        ])
    _MaintenanceLoopReject_cause._ext = []
    MaintenanceLoopReject._cont = ASN1Dict([
        ('type', _MaintenanceLoopReject_type),
        ('cause', _MaintenanceLoopReject_cause),
        ])
    MaintenanceLoopReject._ext = []
    
    #-----< MaintenanceLoopOffCommand >-----#
    MaintenanceLoopOffCommand = SEQ(name='MaintenanceLoopOffCommand', mode=MODE_TYPE)
    MaintenanceLoopOffCommand._cont = ASN1Dict([
        ])
    MaintenanceLoopOffCommand._ext = []
    
    #-----< CommunicationModeCommand >-----#
    CommunicationModeCommand = SEQ(name='CommunicationModeCommand', mode=MODE_TYPE)
    _CommunicationModeCommand_communicationModeTable = SET_OF(name='communicationModeTable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CommunicationModeCommand_communicationModeTable__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommunicationModeTableEntry')))
    _CommunicationModeCommand_communicationModeTable._cont = __CommunicationModeCommand_communicationModeTable__item_
    _CommunicationModeCommand_communicationModeTable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    CommunicationModeCommand._cont = ASN1Dict([
        ('communicationModeTable', _CommunicationModeCommand_communicationModeTable),
        ])
    CommunicationModeCommand._ext = []
    
    #-----< CommunicationModeRequest >-----#
    CommunicationModeRequest = SEQ(name='CommunicationModeRequest', mode=MODE_TYPE)
    CommunicationModeRequest._cont = ASN1Dict([
        ])
    CommunicationModeRequest._ext = []
    
    #-----< CommunicationModeResponse >-----#
    CommunicationModeResponse = CHOICE(name='CommunicationModeResponse', mode=MODE_TYPE)
    _CommunicationModeResponse_communicationModeTable = SET_OF(name='communicationModeTable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CommunicationModeResponse_communicationModeTable__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommunicationModeTableEntry')))
    _CommunicationModeResponse_communicationModeTable._cont = __CommunicationModeResponse_communicationModeTable__item_
    _CommunicationModeResponse_communicationModeTable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    CommunicationModeResponse._cont = ASN1Dict([
        ('communicationModeTable', _CommunicationModeResponse_communicationModeTable),
        ])
    CommunicationModeResponse._ext = []
    
    #-----< CommunicationModeTableEntry >-----#
    CommunicationModeTableEntry = SEQ(name='CommunicationModeTableEntry', mode=MODE_TYPE)
    _CommunicationModeTableEntry_nonStandard = SEQ_OF(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CommunicationModeTableEntry_nonStandard__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _CommunicationModeTableEntry_nonStandard._cont = __CommunicationModeTableEntry_nonStandard__item_
    _CommunicationModeTableEntry_sessionID = INT(name='sessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommunicationModeTableEntry_sessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _CommunicationModeTableEntry_associatedSessionID = INT(name='associatedSessionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationModeTableEntry_associatedSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _CommunicationModeTableEntry_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')), opt=True)
    _CommunicationModeTableEntry_sessionDescription = STR_BMP(name='sessionDescription', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommunicationModeTableEntry_sessionDescription._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _CommunicationModeTableEntry_dataType = CHOICE(name='dataType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CommunicationModeTableEntry_dataType_videoData = CHOICE(name='videoData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoCapability')))
    __CommunicationModeTableEntry_dataType_audioData = CHOICE(name='audioData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'AudioCapability')))
    __CommunicationModeTableEntry_dataType_data = SEQ(name='data', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DataApplicationCapability')))
    _CommunicationModeTableEntry_dataType._cont = ASN1Dict([
        ('videoData', __CommunicationModeTableEntry_dataType_videoData),
        ('audioData', __CommunicationModeTableEntry_dataType_audioData),
        ('data', __CommunicationModeTableEntry_dataType_data),
        ])
    _CommunicationModeTableEntry_dataType._ext = []
    _CommunicationModeTableEntry_mediaChannel = CHOICE(name='mediaChannel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')), opt=True)
    _CommunicationModeTableEntry_mediaGuaranteedDelivery = BOOL(name='mediaGuaranteedDelivery', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationModeTableEntry_mediaControlChannel = CHOICE(name='mediaControlChannel', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')), opt=True)
    _CommunicationModeTableEntry_mediaControlGuaranteedDelivery = BOOL(name='mediaControlGuaranteedDelivery', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationModeTableEntry_redundancyEncoding = SEQ(name='redundancyEncoding', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RedundancyEncoding')), opt=True)
    _CommunicationModeTableEntry_sessionDependency = INT(name='sessionDependency', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationModeTableEntry_sessionDependency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _CommunicationModeTableEntry_destination = SEQ(name='destination', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')), opt=True)
    CommunicationModeTableEntry._cont = ASN1Dict([
        ('nonStandard', _CommunicationModeTableEntry_nonStandard),
        ('sessionID', _CommunicationModeTableEntry_sessionID),
        ('associatedSessionID', _CommunicationModeTableEntry_associatedSessionID),
        ('terminalLabel', _CommunicationModeTableEntry_terminalLabel),
        ('sessionDescription', _CommunicationModeTableEntry_sessionDescription),
        ('dataType', _CommunicationModeTableEntry_dataType),
        ('mediaChannel', _CommunicationModeTableEntry_mediaChannel),
        ('mediaGuaranteedDelivery', _CommunicationModeTableEntry_mediaGuaranteedDelivery),
        ('mediaControlChannel', _CommunicationModeTableEntry_mediaControlChannel),
        ('mediaControlGuaranteedDelivery', _CommunicationModeTableEntry_mediaControlGuaranteedDelivery),
        ('redundancyEncoding', _CommunicationModeTableEntry_redundancyEncoding),
        ('sessionDependency', _CommunicationModeTableEntry_sessionDependency),
        ('destination', _CommunicationModeTableEntry_destination),
        ])
    CommunicationModeTableEntry._ext = ['redundancyEncoding', 'sessionDependency', 'destination']
    
    #-----< ConferenceRequest >-----#
    ConferenceRequest = CHOICE(name='ConferenceRequest', mode=MODE_TYPE)
    _ConferenceRequest_terminalListRequest = NULL(name='terminalListRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_makeMeChair = NULL(name='makeMeChair', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_cancelMakeMeChair = NULL(name='cancelMakeMeChair', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_dropTerminal = SEQ(name='dropTerminal', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceRequest_requestTerminalID = SEQ(name='requestTerminalID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceRequest_enterH243Password = NULL(name='enterH243Password', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_enterH243TerminalID = NULL(name='enterH243TerminalID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_enterH243ConferenceID = NULL(name='enterH243ConferenceID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_enterExtensionAddress = NULL(name='enterExtensionAddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_requestChairTokenOwner = NULL(name='requestChairTokenOwner', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_requestTerminalCertificate = SEQ(name='requestTerminalCertificate', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceRequest_requestTerminalCertificate_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')), opt=True)
    __ConferenceRequest_requestTerminalCertificate_certSelectionCriteria = SEQ_OF(name='certSelectionCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CertSelectionCriteria')), opt=True)
    __ConferenceRequest_requestTerminalCertificate_sRandom = INT(name='sRandom', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ConferenceRequest_requestTerminalCertificate_sRandom._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _ConferenceRequest_requestTerminalCertificate._cont = ASN1Dict([
        ('terminalLabel', __ConferenceRequest_requestTerminalCertificate_terminalLabel),
        ('certSelectionCriteria', __ConferenceRequest_requestTerminalCertificate_certSelectionCriteria),
        ('sRandom', __ConferenceRequest_requestTerminalCertificate_sRandom),
        ])
    _ConferenceRequest_requestTerminalCertificate._ext = []
    _ConferenceRequest_broadcastMyLogicalChannel = INT(name='broadcastMyLogicalChannel', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _ConferenceRequest_makeTerminalBroadcaster = SEQ(name='makeTerminalBroadcaster', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceRequest_sendThisSource = SEQ(name='sendThisSource', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceRequest_requestAllTerminalIDs = NULL(name='requestAllTerminalIDs', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceRequest_remoteMCRequest = CHOICE(name='remoteMCRequest', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RemoteMCRequest')))
    ConferenceRequest._cont = ASN1Dict([
        ('terminalListRequest', _ConferenceRequest_terminalListRequest),
        ('makeMeChair', _ConferenceRequest_makeMeChair),
        ('cancelMakeMeChair', _ConferenceRequest_cancelMakeMeChair),
        ('dropTerminal', _ConferenceRequest_dropTerminal),
        ('requestTerminalID', _ConferenceRequest_requestTerminalID),
        ('enterH243Password', _ConferenceRequest_enterH243Password),
        ('enterH243TerminalID', _ConferenceRequest_enterH243TerminalID),
        ('enterH243ConferenceID', _ConferenceRequest_enterH243ConferenceID),
        ('enterExtensionAddress', _ConferenceRequest_enterExtensionAddress),
        ('requestChairTokenOwner', _ConferenceRequest_requestChairTokenOwner),
        ('requestTerminalCertificate', _ConferenceRequest_requestTerminalCertificate),
        ('broadcastMyLogicalChannel', _ConferenceRequest_broadcastMyLogicalChannel),
        ('makeTerminalBroadcaster', _ConferenceRequest_makeTerminalBroadcaster),
        ('sendThisSource', _ConferenceRequest_sendThisSource),
        ('requestAllTerminalIDs', _ConferenceRequest_requestAllTerminalIDs),
        ('remoteMCRequest', _ConferenceRequest_remoteMCRequest),
        ])
    ConferenceRequest._ext = ['enterExtensionAddress', 'requestChairTokenOwner', 'requestTerminalCertificate', 'broadcastMyLogicalChannel', 'makeTerminalBroadcaster', 'sendThisSource', 'requestAllTerminalIDs', 'remoteMCRequest']
    
    #-----< CertSelectionCriteria >-----#
    CertSelectionCriteria = SEQ_OF(name='CertSelectionCriteria', mode=MODE_TYPE)
    _CertSelectionCriteria__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Criteria')))
    CertSelectionCriteria._cont = _CertSelectionCriteria__item_
    CertSelectionCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Criteria >-----#
    Criteria = SEQ(name='Criteria', mode=MODE_TYPE)
    _Criteria_field = OID(name='field', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Criteria_value = OCT_STR(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Criteria_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Criteria._cont = ASN1Dict([
        ('field', _Criteria_field),
        ('value', _Criteria_value),
        ])
    Criteria._ext = []
    
    #-----< TerminalLabel >-----#
    TerminalLabel = SEQ(name='TerminalLabel', mode=MODE_TYPE)
    _TerminalLabel_mcuNumber = INT(name='mcuNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'McuNumber')))
    _TerminalLabel_terminalNumber = INT(name='terminalNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalNumber')))
    TerminalLabel._cont = ASN1Dict([
        ('mcuNumber', _TerminalLabel_mcuNumber),
        ('terminalNumber', _TerminalLabel_terminalNumber),
        ])
    TerminalLabel._ext = []
    
    #-----< McuNumber >-----#
    McuNumber = INT(name='McuNumber', mode=MODE_TYPE)
    McuNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=192)], ev=None, er=[])
    
    #-----< TerminalNumber >-----#
    TerminalNumber = INT(name='TerminalNumber', mode=MODE_TYPE)
    TerminalNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=192)], ev=None, er=[])
    
    #-----< ConferenceResponse >-----#
    ConferenceResponse = CHOICE(name='ConferenceResponse', mode=MODE_TYPE)
    _ConferenceResponse_mCTerminalIDResponse = SEQ(name='mCTerminalIDResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_mCTerminalIDResponse_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    __ConferenceResponse_mCTerminalIDResponse_terminalID = OCT_STR(name='terminalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalID')))
    _ConferenceResponse_mCTerminalIDResponse._cont = ASN1Dict([
        ('terminalLabel', __ConferenceResponse_mCTerminalIDResponse_terminalLabel),
        ('terminalID', __ConferenceResponse_mCTerminalIDResponse_terminalID),
        ])
    _ConferenceResponse_mCTerminalIDResponse._ext = []
    _ConferenceResponse_terminalIDResponse = SEQ(name='terminalIDResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_terminalIDResponse_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    __ConferenceResponse_terminalIDResponse_terminalID = OCT_STR(name='terminalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalID')))
    _ConferenceResponse_terminalIDResponse._cont = ASN1Dict([
        ('terminalLabel', __ConferenceResponse_terminalIDResponse_terminalLabel),
        ('terminalID', __ConferenceResponse_terminalIDResponse_terminalID),
        ])
    _ConferenceResponse_terminalIDResponse._ext = []
    _ConferenceResponse_conferenceIDResponse = SEQ(name='conferenceIDResponse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_conferenceIDResponse_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    __ConferenceResponse_conferenceIDResponse_conferenceID = OCT_STR(name='conferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConferenceID')))
    _ConferenceResponse_conferenceIDResponse._cont = ASN1Dict([
        ('terminalLabel', __ConferenceResponse_conferenceIDResponse_terminalLabel),
        ('conferenceID', __ConferenceResponse_conferenceIDResponse_conferenceID),
        ])
    _ConferenceResponse_conferenceIDResponse._ext = []
    _ConferenceResponse_passwordResponse = SEQ(name='passwordResponse', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_passwordResponse_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    __ConferenceResponse_passwordResponse_password = OCT_STR(name='password', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Password')))
    _ConferenceResponse_passwordResponse._cont = ASN1Dict([
        ('terminalLabel', __ConferenceResponse_passwordResponse_terminalLabel),
        ('password', __ConferenceResponse_passwordResponse_password),
        ])
    _ConferenceResponse_passwordResponse._ext = []
    _ConferenceResponse_terminalListResponse = SET_OF(name='terminalListResponse', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_terminalListResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceResponse_terminalListResponse._cont = __ConferenceResponse_terminalListResponse__item_
    _ConferenceResponse_terminalListResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _ConferenceResponse_videoCommandReject = NULL(name='videoCommandReject', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceResponse_terminalDropReject = NULL(name='terminalDropReject', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceResponse_makeMeChairResponse = CHOICE(name='makeMeChairResponse', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ConferenceResponse_makeMeChairResponse_grantedChairToken = NULL(name='grantedChairToken', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_makeMeChairResponse_deniedChairToken = NULL(name='deniedChairToken', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceResponse_makeMeChairResponse._cont = ASN1Dict([
        ('grantedChairToken', __ConferenceResponse_makeMeChairResponse_grantedChairToken),
        ('deniedChairToken', __ConferenceResponse_makeMeChairResponse_deniedChairToken),
        ])
    _ConferenceResponse_makeMeChairResponse._ext = []
    _ConferenceResponse_extensionAddressResponse = SEQ(name='extensionAddressResponse', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_extensionAddressResponse_extensionAddress = OCT_STR(name='extensionAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalID')))
    _ConferenceResponse_extensionAddressResponse._cont = ASN1Dict([
        ('extensionAddress', __ConferenceResponse_extensionAddressResponse_extensionAddress),
        ])
    _ConferenceResponse_extensionAddressResponse._ext = []
    _ConferenceResponse_chairTokenOwnerResponse = SEQ(name='chairTokenOwnerResponse', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_chairTokenOwnerResponse_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    __ConferenceResponse_chairTokenOwnerResponse_terminalID = OCT_STR(name='terminalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalID')))
    _ConferenceResponse_chairTokenOwnerResponse._cont = ASN1Dict([
        ('terminalLabel', __ConferenceResponse_chairTokenOwnerResponse_terminalLabel),
        ('terminalID', __ConferenceResponse_chairTokenOwnerResponse_terminalID),
        ])
    _ConferenceResponse_chairTokenOwnerResponse._ext = []
    _ConferenceResponse_terminalCertificateResponse = SEQ(name='terminalCertificateResponse', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_terminalCertificateResponse_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')), opt=True)
    __ConferenceResponse_terminalCertificateResponse_certificateResponse = OCT_STR(name='certificateResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ConferenceResponse_terminalCertificateResponse_certificateResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _ConferenceResponse_terminalCertificateResponse._cont = ASN1Dict([
        ('terminalLabel', __ConferenceResponse_terminalCertificateResponse_terminalLabel),
        ('certificateResponse', __ConferenceResponse_terminalCertificateResponse_certificateResponse),
        ])
    _ConferenceResponse_terminalCertificateResponse._ext = []
    _ConferenceResponse_broadcastMyLogicalChannelResponse = CHOICE(name='broadcastMyLogicalChannelResponse', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ConferenceResponse_broadcastMyLogicalChannelResponse_grantedBroadcastMyLogicalChannel = NULL(name='grantedBroadcastMyLogicalChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_broadcastMyLogicalChannelResponse_deniedBroadcastMyLogicalChannel = NULL(name='deniedBroadcastMyLogicalChannel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceResponse_broadcastMyLogicalChannelResponse._cont = ASN1Dict([
        ('grantedBroadcastMyLogicalChannel', __ConferenceResponse_broadcastMyLogicalChannelResponse_grantedBroadcastMyLogicalChannel),
        ('deniedBroadcastMyLogicalChannel', __ConferenceResponse_broadcastMyLogicalChannelResponse_deniedBroadcastMyLogicalChannel),
        ])
    _ConferenceResponse_broadcastMyLogicalChannelResponse._ext = []
    _ConferenceResponse_makeTerminalBroadcasterResponse = CHOICE(name='makeTerminalBroadcasterResponse', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ConferenceResponse_makeTerminalBroadcasterResponse_grantedMakeTerminalBroadcaster = NULL(name='grantedMakeTerminalBroadcaster', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_makeTerminalBroadcasterResponse_deniedMakeTerminalBroadcaster = NULL(name='deniedMakeTerminalBroadcaster', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceResponse_makeTerminalBroadcasterResponse._cont = ASN1Dict([
        ('grantedMakeTerminalBroadcaster', __ConferenceResponse_makeTerminalBroadcasterResponse_grantedMakeTerminalBroadcaster),
        ('deniedMakeTerminalBroadcaster', __ConferenceResponse_makeTerminalBroadcasterResponse_deniedMakeTerminalBroadcaster),
        ])
    _ConferenceResponse_makeTerminalBroadcasterResponse._ext = []
    _ConferenceResponse_sendThisSourceResponse = CHOICE(name='sendThisSourceResponse', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ConferenceResponse_sendThisSourceResponse_grantedSendThisSource = NULL(name='grantedSendThisSource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ConferenceResponse_sendThisSourceResponse_deniedSendThisSource = NULL(name='deniedSendThisSource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceResponse_sendThisSourceResponse._cont = ASN1Dict([
        ('grantedSendThisSource', __ConferenceResponse_sendThisSourceResponse_grantedSendThisSource),
        ('deniedSendThisSource', __ConferenceResponse_sendThisSourceResponse_deniedSendThisSource),
        ])
    _ConferenceResponse_sendThisSourceResponse._ext = []
    _ConferenceResponse_requestAllTerminalIDsResponse = SEQ(name='requestAllTerminalIDsResponse', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestAllTerminalIDsResponse')))
    _ConferenceResponse_remoteMCResponse = CHOICE(name='remoteMCResponse', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RemoteMCResponse')))
    ConferenceResponse._cont = ASN1Dict([
        ('mCTerminalIDResponse', _ConferenceResponse_mCTerminalIDResponse),
        ('terminalIDResponse', _ConferenceResponse_terminalIDResponse),
        ('conferenceIDResponse', _ConferenceResponse_conferenceIDResponse),
        ('passwordResponse', _ConferenceResponse_passwordResponse),
        ('terminalListResponse', _ConferenceResponse_terminalListResponse),
        ('videoCommandReject', _ConferenceResponse_videoCommandReject),
        ('terminalDropReject', _ConferenceResponse_terminalDropReject),
        ('makeMeChairResponse', _ConferenceResponse_makeMeChairResponse),
        ('extensionAddressResponse', _ConferenceResponse_extensionAddressResponse),
        ('chairTokenOwnerResponse', _ConferenceResponse_chairTokenOwnerResponse),
        ('terminalCertificateResponse', _ConferenceResponse_terminalCertificateResponse),
        ('broadcastMyLogicalChannelResponse', _ConferenceResponse_broadcastMyLogicalChannelResponse),
        ('makeTerminalBroadcasterResponse', _ConferenceResponse_makeTerminalBroadcasterResponse),
        ('sendThisSourceResponse', _ConferenceResponse_sendThisSourceResponse),
        ('requestAllTerminalIDsResponse', _ConferenceResponse_requestAllTerminalIDsResponse),
        ('remoteMCResponse', _ConferenceResponse_remoteMCResponse),
        ])
    ConferenceResponse._ext = ['extensionAddressResponse', 'chairTokenOwnerResponse', 'terminalCertificateResponse', 'broadcastMyLogicalChannelResponse', 'makeTerminalBroadcasterResponse', 'sendThisSourceResponse', 'requestAllTerminalIDsResponse', 'remoteMCResponse']
    
    #-----< TerminalID >-----#
    TerminalID = OCT_STR(name='TerminalID', mode=MODE_TYPE)
    TerminalID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< ConferenceID >-----#
    ConferenceID = OCT_STR(name='ConferenceID', mode=MODE_TYPE)
    ConferenceID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Password >-----#
    Password = OCT_STR(name='Password', mode=MODE_TYPE)
    Password._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< RequestAllTerminalIDsResponse >-----#
    RequestAllTerminalIDsResponse = SEQ(name='RequestAllTerminalIDsResponse', mode=MODE_TYPE)
    _RequestAllTerminalIDsResponse_terminalInformation = SEQ_OF(name='terminalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestAllTerminalIDsResponse_terminalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalInformation')))
    _RequestAllTerminalIDsResponse_terminalInformation._cont = __RequestAllTerminalIDsResponse_terminalInformation__item_
    RequestAllTerminalIDsResponse._cont = ASN1Dict([
        ('terminalInformation', _RequestAllTerminalIDsResponse_terminalInformation),
        ])
    RequestAllTerminalIDsResponse._ext = []
    
    #-----< TerminalInformation >-----#
    TerminalInformation = SEQ(name='TerminalInformation', mode=MODE_TYPE)
    _TerminalInformation_terminalLabel = SEQ(name='terminalLabel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _TerminalInformation_terminalID = OCT_STR(name='terminalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalID')))
    TerminalInformation._cont = ASN1Dict([
        ('terminalLabel', _TerminalInformation_terminalLabel),
        ('terminalID', _TerminalInformation_terminalID),
        ])
    TerminalInformation._ext = []
    
    #-----< RemoteMCRequest >-----#
    RemoteMCRequest = CHOICE(name='RemoteMCRequest', mode=MODE_TYPE)
    _RemoteMCRequest_masterActivate = NULL(name='masterActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RemoteMCRequest_slaveActivate = NULL(name='slaveActivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RemoteMCRequest_deActivate = NULL(name='deActivate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RemoteMCRequest._cont = ASN1Dict([
        ('masterActivate', _RemoteMCRequest_masterActivate),
        ('slaveActivate', _RemoteMCRequest_slaveActivate),
        ('deActivate', _RemoteMCRequest_deActivate),
        ])
    RemoteMCRequest._ext = []
    
    #-----< RemoteMCResponse >-----#
    RemoteMCResponse = CHOICE(name='RemoteMCResponse', mode=MODE_TYPE)
    _RemoteMCResponse_accept = NULL(name='accept', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RemoteMCResponse_reject = CHOICE(name='reject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RemoteMCResponse_reject_unspecified = NULL(name='unspecified', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RemoteMCResponse_reject_functionNotSupported = NULL(name='functionNotSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RemoteMCResponse_reject._cont = ASN1Dict([
        ('unspecified', __RemoteMCResponse_reject_unspecified),
        ('functionNotSupported', __RemoteMCResponse_reject_functionNotSupported),
        ])
    _RemoteMCResponse_reject._ext = []
    RemoteMCResponse._cont = ASN1Dict([
        ('accept', _RemoteMCResponse_accept),
        ('reject', _RemoteMCResponse_reject),
        ])
    RemoteMCResponse._ext = []
    
    #-----< MultilinkRequest >-----#
    MultilinkRequest = CHOICE(name='MultilinkRequest', mode=MODE_TYPE)
    _MultilinkRequest_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _MultilinkRequest_callInformation = SEQ(name='callInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkRequest_callInformation_maxNumberOfAdditionalConnections = INT(name='maxNumberOfAdditionalConnections', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkRequest_callInformation_maxNumberOfAdditionalConnections._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _MultilinkRequest_callInformation._cont = ASN1Dict([
        ('maxNumberOfAdditionalConnections', __MultilinkRequest_callInformation_maxNumberOfAdditionalConnections),
        ])
    _MultilinkRequest_callInformation._ext = []
    _MultilinkRequest_addConnection = SEQ(name='addConnection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkRequest_addConnection_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    __MultilinkRequest_addConnection_dialingInformation = CHOICE(name='dialingInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DialingInformation')))
    _MultilinkRequest_addConnection._cont = ASN1Dict([
        ('sequenceNumber', __MultilinkRequest_addConnection_sequenceNumber),
        ('dialingInformation', __MultilinkRequest_addConnection_dialingInformation),
        ])
    _MultilinkRequest_addConnection._ext = []
    _MultilinkRequest_removeConnection = SEQ(name='removeConnection', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkRequest_removeConnection_connectionIdentifier = SEQ(name='connectionIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConnectionIdentifier')))
    _MultilinkRequest_removeConnection._cont = ASN1Dict([
        ('connectionIdentifier', __MultilinkRequest_removeConnection_connectionIdentifier),
        ])
    _MultilinkRequest_removeConnection._ext = []
    _MultilinkRequest_maximumHeaderInterval = SEQ(name='maximumHeaderInterval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkRequest_maximumHeaderInterval_requestType = CHOICE(name='requestType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MultilinkRequest_maximumHeaderInterval_requestType_currentIntervalInformation = NULL(name='currentIntervalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MultilinkRequest_maximumHeaderInterval_requestType_requestedInterval = INT(name='requestedInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MultilinkRequest_maximumHeaderInterval_requestType_requestedInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __MultilinkRequest_maximumHeaderInterval_requestType._cont = ASN1Dict([
        ('currentIntervalInformation', ___MultilinkRequest_maximumHeaderInterval_requestType_currentIntervalInformation),
        ('requestedInterval', ___MultilinkRequest_maximumHeaderInterval_requestType_requestedInterval),
        ])
    __MultilinkRequest_maximumHeaderInterval_requestType._ext = []
    _MultilinkRequest_maximumHeaderInterval._cont = ASN1Dict([
        ('requestType', __MultilinkRequest_maximumHeaderInterval_requestType),
        ])
    _MultilinkRequest_maximumHeaderInterval._ext = []
    MultilinkRequest._cont = ASN1Dict([
        ('nonStandard', _MultilinkRequest_nonStandard),
        ('callInformation', _MultilinkRequest_callInformation),
        ('addConnection', _MultilinkRequest_addConnection),
        ('removeConnection', _MultilinkRequest_removeConnection),
        ('maximumHeaderInterval', _MultilinkRequest_maximumHeaderInterval),
        ])
    MultilinkRequest._ext = []
    
    #-----< MultilinkResponse >-----#
    MultilinkResponse = CHOICE(name='MultilinkResponse', mode=MODE_TYPE)
    _MultilinkResponse_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _MultilinkResponse_callInformation = SEQ(name='callInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkResponse_callInformation_dialingInformation = CHOICE(name='dialingInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DialingInformation')))
    __MultilinkResponse_callInformation_callAssociationNumber = INT(name='callAssociationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkResponse_callInformation_callAssociationNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _MultilinkResponse_callInformation._cont = ASN1Dict([
        ('dialingInformation', __MultilinkResponse_callInformation_dialingInformation),
        ('callAssociationNumber', __MultilinkResponse_callInformation_callAssociationNumber),
        ])
    _MultilinkResponse_callInformation._ext = []
    _MultilinkResponse_addConnection = SEQ(name='addConnection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkResponse_addConnection_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    __MultilinkResponse_addConnection_responseCode = CHOICE(name='responseCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MultilinkResponse_addConnection_responseCode_accepted = NULL(name='accepted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MultilinkResponse_addConnection_responseCode_rejected = CHOICE(name='rejected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____MultilinkResponse_addConnection_responseCode_rejected_connectionsNotAvailable = NULL(name='connectionsNotAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____MultilinkResponse_addConnection_responseCode_rejected_userRejected = NULL(name='userRejected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MultilinkResponse_addConnection_responseCode_rejected._cont = ASN1Dict([
        ('connectionsNotAvailable', ____MultilinkResponse_addConnection_responseCode_rejected_connectionsNotAvailable),
        ('userRejected', ____MultilinkResponse_addConnection_responseCode_rejected_userRejected),
        ])
    ___MultilinkResponse_addConnection_responseCode_rejected._ext = []
    __MultilinkResponse_addConnection_responseCode._cont = ASN1Dict([
        ('accepted', ___MultilinkResponse_addConnection_responseCode_accepted),
        ('rejected', ___MultilinkResponse_addConnection_responseCode_rejected),
        ])
    __MultilinkResponse_addConnection_responseCode._ext = []
    _MultilinkResponse_addConnection._cont = ASN1Dict([
        ('sequenceNumber', __MultilinkResponse_addConnection_sequenceNumber),
        ('responseCode', __MultilinkResponse_addConnection_responseCode),
        ])
    _MultilinkResponse_addConnection._ext = []
    _MultilinkResponse_removeConnection = SEQ(name='removeConnection', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkResponse_removeConnection_connectionIdentifier = SEQ(name='connectionIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConnectionIdentifier')))
    _MultilinkResponse_removeConnection._cont = ASN1Dict([
        ('connectionIdentifier', __MultilinkResponse_removeConnection_connectionIdentifier),
        ])
    _MultilinkResponse_removeConnection._ext = []
    _MultilinkResponse_maximumHeaderInterval = SEQ(name='maximumHeaderInterval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkResponse_maximumHeaderInterval_currentInterval = INT(name='currentInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkResponse_maximumHeaderInterval_currentInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MultilinkResponse_maximumHeaderInterval._cont = ASN1Dict([
        ('currentInterval', __MultilinkResponse_maximumHeaderInterval_currentInterval),
        ])
    _MultilinkResponse_maximumHeaderInterval._ext = []
    MultilinkResponse._cont = ASN1Dict([
        ('nonStandard', _MultilinkResponse_nonStandard),
        ('callInformation', _MultilinkResponse_callInformation),
        ('addConnection', _MultilinkResponse_addConnection),
        ('removeConnection', _MultilinkResponse_removeConnection),
        ('maximumHeaderInterval', _MultilinkResponse_maximumHeaderInterval),
        ])
    MultilinkResponse._ext = []
    
    #-----< MultilinkIndication >-----#
    MultilinkIndication = CHOICE(name='MultilinkIndication', mode=MODE_TYPE)
    _MultilinkIndication_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _MultilinkIndication_crcDesired = SEQ(name='crcDesired', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultilinkIndication_crcDesired._cont = ASN1Dict([
        ])
    _MultilinkIndication_crcDesired._ext = []
    _MultilinkIndication_excessiveError = SEQ(name='excessiveError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MultilinkIndication_excessiveError_connectionIdentifier = SEQ(name='connectionIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ConnectionIdentifier')))
    _MultilinkIndication_excessiveError._cont = ASN1Dict([
        ('connectionIdentifier', __MultilinkIndication_excessiveError_connectionIdentifier),
        ])
    _MultilinkIndication_excessiveError._ext = []
    MultilinkIndication._cont = ASN1Dict([
        ('nonStandard', _MultilinkIndication_nonStandard),
        ('crcDesired', _MultilinkIndication_crcDesired),
        ('excessiveError', _MultilinkIndication_excessiveError),
        ])
    MultilinkIndication._ext = []
    
    #-----< DialingInformation >-----#
    DialingInformation = CHOICE(name='DialingInformation', mode=MODE_TYPE)
    _DialingInformation_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _DialingInformation_differential = SET_OF(name='differential', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DialingInformation_differential__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DialingInformationNumber')))
    _DialingInformation_differential._cont = __DialingInformation_differential__item_
    _DialingInformation_differential._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _DialingInformation_infoNotAvailable = INT(name='infoNotAvailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DialingInformation_infoNotAvailable._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DialingInformation._cont = ASN1Dict([
        ('nonStandard', _DialingInformation_nonStandard),
        ('differential', _DialingInformation_differential),
        ('infoNotAvailable', _DialingInformation_infoNotAvailable),
        ])
    DialingInformation._ext = []
    
    #-----< DialingInformationNumber >-----#
    DialingInformationNumber = SEQ(name='DialingInformationNumber', mode=MODE_TYPE)
    _DialingInformationNumber_networkAddress = STR_NUM(name='networkAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DialingInformationNumber_networkAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40)], ev=None, er=[])
    _DialingInformationNumber_subAddress = STR_IA5(name='subAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DialingInformationNumber_subAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _DialingInformationNumber_networkType = SET_OF(name='networkType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DialingInformationNumber_networkType__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'DialingInformationNetworkType')))
    _DialingInformationNumber_networkType._cont = __DialingInformationNumber_networkType__item_
    _DialingInformationNumber_networkType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    DialingInformationNumber._cont = ASN1Dict([
        ('networkAddress', _DialingInformationNumber_networkAddress),
        ('subAddress', _DialingInformationNumber_subAddress),
        ('networkType', _DialingInformationNumber_networkType),
        ])
    DialingInformationNumber._ext = []
    
    #-----< DialingInformationNetworkType >-----#
    DialingInformationNetworkType = CHOICE(name='DialingInformationNetworkType', mode=MODE_TYPE)
    _DialingInformationNetworkType_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardMessage')))
    _DialingInformationNetworkType_n_isdn = NULL(name='n-isdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DialingInformationNetworkType_gstn = NULL(name='gstn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DialingInformationNetworkType_mobile = NULL(name='mobile', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DialingInformationNetworkType._cont = ASN1Dict([
        ('nonStandard', _DialingInformationNetworkType_nonStandard),
        ('n-isdn', _DialingInformationNetworkType_n_isdn),
        ('gstn', _DialingInformationNetworkType_gstn),
        ('mobile', _DialingInformationNetworkType_mobile),
        ])
    DialingInformationNetworkType._ext = ['mobile']
    
    #-----< ConnectionIdentifier >-----#
    ConnectionIdentifier = SEQ(name='ConnectionIdentifier', mode=MODE_TYPE)
    _ConnectionIdentifier_channelTag = INT(name='channelTag', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConnectionIdentifier_channelTag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _ConnectionIdentifier_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConnectionIdentifier_sequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    ConnectionIdentifier._cont = ASN1Dict([
        ('channelTag', _ConnectionIdentifier_channelTag),
        ('sequenceNumber', _ConnectionIdentifier_sequenceNumber),
        ])
    ConnectionIdentifier._ext = []
    
    #-----< MaximumBitRate >-----#
    MaximumBitRate = INT(name='MaximumBitRate', mode=MODE_TYPE)
    MaximumBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< LogicalChannelRateRequest >-----#
    LogicalChannelRateRequest = SEQ(name='LogicalChannelRateRequest', mode=MODE_TYPE)
    _LogicalChannelRateRequest_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _LogicalChannelRateRequest_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _LogicalChannelRateRequest_maximumBitRate = INT(name='maximumBitRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaximumBitRate')))
    LogicalChannelRateRequest._cont = ASN1Dict([
        ('sequenceNumber', _LogicalChannelRateRequest_sequenceNumber),
        ('logicalChannelNumber', _LogicalChannelRateRequest_logicalChannelNumber),
        ('maximumBitRate', _LogicalChannelRateRequest_maximumBitRate),
        ])
    LogicalChannelRateRequest._ext = []
    
    #-----< LogicalChannelRateAcknowledge >-----#
    LogicalChannelRateAcknowledge = SEQ(name='LogicalChannelRateAcknowledge', mode=MODE_TYPE)
    _LogicalChannelRateAcknowledge_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _LogicalChannelRateAcknowledge_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _LogicalChannelRateAcknowledge_maximumBitRate = INT(name='maximumBitRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaximumBitRate')))
    LogicalChannelRateAcknowledge._cont = ASN1Dict([
        ('sequenceNumber', _LogicalChannelRateAcknowledge_sequenceNumber),
        ('logicalChannelNumber', _LogicalChannelRateAcknowledge_logicalChannelNumber),
        ('maximumBitRate', _LogicalChannelRateAcknowledge_maximumBitRate),
        ])
    LogicalChannelRateAcknowledge._ext = []
    
    #-----< LogicalChannelRateReject >-----#
    LogicalChannelRateReject = SEQ(name='LogicalChannelRateReject', mode=MODE_TYPE)
    _LogicalChannelRateReject_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    _LogicalChannelRateReject_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _LogicalChannelRateReject_rejectReason = CHOICE(name='rejectReason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelRateRejectReason')))
    _LogicalChannelRateReject_currentMaximumBitRate = INT(name='currentMaximumBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MaximumBitRate')), opt=True)
    LogicalChannelRateReject._cont = ASN1Dict([
        ('sequenceNumber', _LogicalChannelRateReject_sequenceNumber),
        ('logicalChannelNumber', _LogicalChannelRateReject_logicalChannelNumber),
        ('rejectReason', _LogicalChannelRateReject_rejectReason),
        ('currentMaximumBitRate', _LogicalChannelRateReject_currentMaximumBitRate),
        ])
    LogicalChannelRateReject._ext = []
    
    #-----< LogicalChannelRateRejectReason >-----#
    LogicalChannelRateRejectReason = CHOICE(name='LogicalChannelRateRejectReason', mode=MODE_TYPE)
    _LogicalChannelRateRejectReason_undefinedReason = NULL(name='undefinedReason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LogicalChannelRateRejectReason_insufficientResources = NULL(name='insufficientResources', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LogicalChannelRateRejectReason._cont = ASN1Dict([
        ('undefinedReason', _LogicalChannelRateRejectReason_undefinedReason),
        ('insufficientResources', _LogicalChannelRateRejectReason_insufficientResources),
        ])
    LogicalChannelRateRejectReason._ext = []
    
    #-----< LogicalChannelRateRelease >-----#
    LogicalChannelRateRelease = SEQ(name='LogicalChannelRateRelease', mode=MODE_TYPE)
    LogicalChannelRateRelease._cont = ASN1Dict([
        ])
    LogicalChannelRateRelease._ext = []
    
    #-----< SendTerminalCapabilitySet >-----#
    SendTerminalCapabilitySet = CHOICE(name='SendTerminalCapabilitySet', mode=MODE_TYPE)
    _SendTerminalCapabilitySet_specificRequest = SEQ(name='specificRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SendTerminalCapabilitySet_specificRequest_multiplexCapability = BOOL(name='multiplexCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers = SET_OF(name='capabilityTableEntryNumbers', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityTableEntryNumber')))
    __SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers._cont = ___SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers__item_
    __SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers = SET_OF(name='capabilityDescriptorNumbers', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CapabilityDescriptorNumber')))
    __SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers._cont = ___SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers__item_
    __SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _SendTerminalCapabilitySet_specificRequest._cont = ASN1Dict([
        ('multiplexCapability', __SendTerminalCapabilitySet_specificRequest_multiplexCapability),
        ('capabilityTableEntryNumbers', __SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers),
        ('capabilityDescriptorNumbers', __SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers),
        ])
    _SendTerminalCapabilitySet_specificRequest._ext = []
    _SendTerminalCapabilitySet_genericRequest = NULL(name='genericRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SendTerminalCapabilitySet._cont = ASN1Dict([
        ('specificRequest', _SendTerminalCapabilitySet_specificRequest),
        ('genericRequest', _SendTerminalCapabilitySet_genericRequest),
        ])
    SendTerminalCapabilitySet._ext = []
    
    #-----< EncryptionCommand >-----#
    EncryptionCommand = CHOICE(name='EncryptionCommand', mode=MODE_TYPE)
    _EncryptionCommand_encryptionSE = OCT_STR(name='encryptionSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncryptionCommand_encryptionIVRequest = NULL(name='encryptionIVRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncryptionCommand_encryptionAlgorithmID = SEQ(name='encryptionAlgorithmID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EncryptionCommand_encryptionAlgorithmID_h233AlgorithmIdentifier = INT(name='h233AlgorithmIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SequenceNumber')))
    __EncryptionCommand_encryptionAlgorithmID_associatedAlgorithm = SEQ(name='associatedAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _EncryptionCommand_encryptionAlgorithmID._cont = ASN1Dict([
        ('h233AlgorithmIdentifier', __EncryptionCommand_encryptionAlgorithmID_h233AlgorithmIdentifier),
        ('associatedAlgorithm', __EncryptionCommand_encryptionAlgorithmID_associatedAlgorithm),
        ])
    _EncryptionCommand_encryptionAlgorithmID._ext = None
    EncryptionCommand._cont = ASN1Dict([
        ('encryptionSE', _EncryptionCommand_encryptionSE),
        ('encryptionIVRequest', _EncryptionCommand_encryptionIVRequest),
        ('encryptionAlgorithmID', _EncryptionCommand_encryptionAlgorithmID),
        ])
    EncryptionCommand._ext = []
    
    #-----< FlowControlCommand >-----#
    FlowControlCommand = SEQ(name='FlowControlCommand', mode=MODE_TYPE)
    _FlowControlCommand_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FlowControlCommand_scope_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __FlowControlCommand_scope_resourceID = INT(name='resourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FlowControlCommand_scope_resourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __FlowControlCommand_scope_wholeMultiplex = NULL(name='wholeMultiplex', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FlowControlCommand_scope._cont = ASN1Dict([
        ('logicalChannelNumber', __FlowControlCommand_scope_logicalChannelNumber),
        ('resourceID', __FlowControlCommand_scope_resourceID),
        ('wholeMultiplex', __FlowControlCommand_scope_wholeMultiplex),
        ])
    _FlowControlCommand_scope._ext = None
    _FlowControlCommand_restriction = CHOICE(name='restriction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FlowControlCommand_restriction_maximumBitRate = INT(name='maximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FlowControlCommand_restriction_maximumBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    __FlowControlCommand_restriction_noRestriction = NULL(name='noRestriction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FlowControlCommand_restriction._cont = ASN1Dict([
        ('maximumBitRate', __FlowControlCommand_restriction_maximumBitRate),
        ('noRestriction', __FlowControlCommand_restriction_noRestriction),
        ])
    _FlowControlCommand_restriction._ext = None
    FlowControlCommand._cont = ASN1Dict([
        ('scope', _FlowControlCommand_scope),
        ('restriction', _FlowControlCommand_restriction),
        ])
    FlowControlCommand._ext = []
    
    #-----< EndSessionCommand >-----#
    EndSessionCommand = CHOICE(name='EndSessionCommand', mode=MODE_TYPE)
    _EndSessionCommand_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _EndSessionCommand_disconnect = NULL(name='disconnect', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EndSessionCommand_gstnOptions = CHOICE(name='gstnOptions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EndSessionCommand_gstnOptions_telephonyMode = NULL(name='telephonyMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_gstnOptions_v8bis = NULL(name='v8bis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_gstnOptions_v34DSVD = NULL(name='v34DSVD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_gstnOptions_v34DuplexFAX = NULL(name='v34DuplexFAX', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_gstnOptions_v34H324 = NULL(name='v34H324', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EndSessionCommand_gstnOptions._cont = ASN1Dict([
        ('telephonyMode', __EndSessionCommand_gstnOptions_telephonyMode),
        ('v8bis', __EndSessionCommand_gstnOptions_v8bis),
        ('v34DSVD', __EndSessionCommand_gstnOptions_v34DSVD),
        ('v34DuplexFAX', __EndSessionCommand_gstnOptions_v34DuplexFAX),
        ('v34H324', __EndSessionCommand_gstnOptions_v34H324),
        ])
    _EndSessionCommand_gstnOptions._ext = []
    _EndSessionCommand_isdnOptions = CHOICE(name='isdnOptions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EndSessionCommand_isdnOptions_telephonyMode = NULL(name='telephonyMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_isdnOptions_v140 = NULL(name='v140', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_isdnOptions_terminalOnHold = NULL(name='terminalOnHold', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EndSessionCommand_isdnOptions._cont = ASN1Dict([
        ('telephonyMode', __EndSessionCommand_isdnOptions_telephonyMode),
        ('v140', __EndSessionCommand_isdnOptions_v140),
        ('terminalOnHold', __EndSessionCommand_isdnOptions_terminalOnHold),
        ])
    _EndSessionCommand_isdnOptions._ext = []
    _EndSessionCommand_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EndSessionCommand_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _EndSessionCommand_genericInformation._cont = __EndSessionCommand_genericInformation__item_
    EndSessionCommand._cont = ASN1Dict([
        ('nonStandard', _EndSessionCommand_nonStandard),
        ('disconnect', _EndSessionCommand_disconnect),
        ('gstnOptions', _EndSessionCommand_gstnOptions),
        ('isdnOptions', _EndSessionCommand_isdnOptions),
        ('genericInformation', _EndSessionCommand_genericInformation),
        ])
    EndSessionCommand._ext = ['isdnOptions', 'genericInformation']
    
    #-----< ConferenceCommand >-----#
    ConferenceCommand = CHOICE(name='ConferenceCommand', mode=MODE_TYPE)
    _ConferenceCommand_broadcastMyLogicalChannel = INT(name='broadcastMyLogicalChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _ConferenceCommand_cancelBroadcastMyLogicalChannel = INT(name='cancelBroadcastMyLogicalChannel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _ConferenceCommand_makeTerminalBroadcaster = SEQ(name='makeTerminalBroadcaster', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceCommand_cancelMakeTerminalBroadcaster = NULL(name='cancelMakeTerminalBroadcaster', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceCommand_sendThisSource = SEQ(name='sendThisSource', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceCommand_cancelSendThisSource = NULL(name='cancelSendThisSource', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceCommand_dropConference = NULL(name='dropConference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceCommand_substituteConferenceIDCommand = SEQ(name='substituteConferenceIDCommand', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'SubstituteConferenceIDCommand')))
    ConferenceCommand._cont = ASN1Dict([
        ('broadcastMyLogicalChannel', _ConferenceCommand_broadcastMyLogicalChannel),
        ('cancelBroadcastMyLogicalChannel', _ConferenceCommand_cancelBroadcastMyLogicalChannel),
        ('makeTerminalBroadcaster', _ConferenceCommand_makeTerminalBroadcaster),
        ('cancelMakeTerminalBroadcaster', _ConferenceCommand_cancelMakeTerminalBroadcaster),
        ('sendThisSource', _ConferenceCommand_sendThisSource),
        ('cancelSendThisSource', _ConferenceCommand_cancelSendThisSource),
        ('dropConference', _ConferenceCommand_dropConference),
        ('substituteConferenceIDCommand', _ConferenceCommand_substituteConferenceIDCommand),
        ])
    ConferenceCommand._ext = ['substituteConferenceIDCommand']
    
    #-----< SubstituteConferenceIDCommand >-----#
    SubstituteConferenceIDCommand = SEQ(name='SubstituteConferenceIDCommand', mode=MODE_TYPE)
    _SubstituteConferenceIDCommand_conferenceIdentifier = OCT_STR(name='conferenceIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubstituteConferenceIDCommand_conferenceIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    SubstituteConferenceIDCommand._cont = ASN1Dict([
        ('conferenceIdentifier', _SubstituteConferenceIDCommand_conferenceIdentifier),
        ])
    SubstituteConferenceIDCommand._ext = []
    
    #-----< EncryptionUpdateDirection >-----#
    EncryptionUpdateDirection = CHOICE(name='EncryptionUpdateDirection', mode=MODE_TYPE)
    _EncryptionUpdateDirection_masterToSlave = NULL(name='masterToSlave', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncryptionUpdateDirection_slaveToMaster = NULL(name='slaveToMaster', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    EncryptionUpdateDirection._cont = ASN1Dict([
        ('masterToSlave', _EncryptionUpdateDirection_masterToSlave),
        ('slaveToMaster', _EncryptionUpdateDirection_slaveToMaster),
        ])
    EncryptionUpdateDirection._ext = []
    
    #-----< MiscellaneousCommand >-----#
    MiscellaneousCommand = SEQ(name='MiscellaneousCommand', mode=MODE_TYPE)
    _MiscellaneousCommand_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _MiscellaneousCommand_type = CHOICE(name='type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MiscellaneousCommand_type_equaliseDelay = NULL(name='equaliseDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_zeroDelay = NULL(name='zeroDelay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_multipointModeCommand = NULL(name='multipointModeCommand', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_cancelMultipointModeCommand = NULL(name='cancelMultipointModeCommand', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoFreezePicture = NULL(name='videoFreezePicture', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoFastUpdatePicture = NULL(name='videoFastUpdatePicture', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoFastUpdateGOB = SEQ(name='videoFastUpdateGOB', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoFastUpdateGOB_firstGOB = INT(name='firstGOB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoFastUpdateGOB_firstGOB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=17)], ev=None, er=[])
    ___MiscellaneousCommand_type_videoFastUpdateGOB_numberOfGOBs = INT(name='numberOfGOBs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoFastUpdateGOB_numberOfGOBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=18)], ev=None, er=[])
    __MiscellaneousCommand_type_videoFastUpdateGOB._cont = ASN1Dict([
        ('firstGOB', ___MiscellaneousCommand_type_videoFastUpdateGOB_firstGOB),
        ('numberOfGOBs', ___MiscellaneousCommand_type_videoFastUpdateGOB_numberOfGOBs),
        ])
    __MiscellaneousCommand_type_videoFastUpdateGOB._ext = None
    __MiscellaneousCommand_type_videoTemporalSpatialTradeOff = INT(name='videoTemporalSpatialTradeOff', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoTemporalSpatialTradeOff._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    __MiscellaneousCommand_type_videoSendSyncEveryGOB = NULL(name='videoSendSyncEveryGOB', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoSendSyncEveryGOBCancel = NULL(name='videoSendSyncEveryGOBCancel', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoFastUpdateMB = SEQ(name='videoFastUpdateMB', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoFastUpdateMB_firstGOB = INT(name='firstGOB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___MiscellaneousCommand_type_videoFastUpdateMB_firstGOB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ___MiscellaneousCommand_type_videoFastUpdateMB_firstMB = INT(name='firstMB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___MiscellaneousCommand_type_videoFastUpdateMB_firstMB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    ___MiscellaneousCommand_type_videoFastUpdateMB_numberOfMBs = INT(name='numberOfMBs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoFastUpdateMB_numberOfMBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    __MiscellaneousCommand_type_videoFastUpdateMB._cont = ASN1Dict([
        ('firstGOB', ___MiscellaneousCommand_type_videoFastUpdateMB_firstGOB),
        ('firstMB', ___MiscellaneousCommand_type_videoFastUpdateMB_firstMB),
        ('numberOfMBs', ___MiscellaneousCommand_type_videoFastUpdateMB_numberOfMBs),
        ])
    __MiscellaneousCommand_type_videoFastUpdateMB._ext = []
    __MiscellaneousCommand_type_maxH223MUXPDUsize = INT(name='maxH223MUXPDUsize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_maxH223MUXPDUsize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __MiscellaneousCommand_type_encryptionUpdate = SEQ(name='encryptionUpdate', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionSync')))
    __MiscellaneousCommand_type_encryptionUpdateRequest = SEQ(name='encryptionUpdateRequest', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionUpdateRequest')))
    __MiscellaneousCommand_type_switchReceiveMediaOff = NULL(name='switchReceiveMediaOff', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_switchReceiveMediaOn = NULL(name='switchReceiveMediaOn', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_progressiveRefinementStart = SEQ(name='progressiveRefinementStart', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_progressiveRefinementStart_repeatCount = CHOICE(name='repeatCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doOneProgression = NULL(name='doOneProgression', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doContinuousProgressions = NULL(name='doContinuousProgressions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doOneIndependentProgression = NULL(name='doOneIndependentProgression', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doContinuousIndependentProgressions = NULL(name='doContinuousIndependentProgressions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_progressiveRefinementStart_repeatCount._cont = ASN1Dict([
        ('doOneProgression', ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doOneProgression),
        ('doContinuousProgressions', ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doContinuousProgressions),
        ('doOneIndependentProgression', ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doOneIndependentProgression),
        ('doContinuousIndependentProgressions', ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doContinuousIndependentProgressions),
        ])
    ___MiscellaneousCommand_type_progressiveRefinementStart_repeatCount._ext = []
    __MiscellaneousCommand_type_progressiveRefinementStart._cont = ASN1Dict([
        ('repeatCount', ___MiscellaneousCommand_type_progressiveRefinementStart_repeatCount),
        ])
    __MiscellaneousCommand_type_progressiveRefinementStart._ext = []
    __MiscellaneousCommand_type_progressiveRefinementAbortOne = NULL(name='progressiveRefinementAbortOne', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_progressiveRefinementAbortContinuous = NULL(name='progressiveRefinementAbortContinuous', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousCommand_type_videoBadMBs = SEQ(name='videoBadMBs', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoBadMBs_firstMB = INT(name='firstMB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoBadMBs_firstMB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9216)], ev=None, er=[])
    ___MiscellaneousCommand_type_videoBadMBs_numberOfMBs = INT(name='numberOfMBs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoBadMBs_numberOfMBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9216)], ev=None, er=[])
    ___MiscellaneousCommand_type_videoBadMBs_temporalReference = INT(name='temporalReference', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_videoBadMBs_temporalReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    __MiscellaneousCommand_type_videoBadMBs._cont = ASN1Dict([
        ('firstMB', ___MiscellaneousCommand_type_videoBadMBs_firstMB),
        ('numberOfMBs', ___MiscellaneousCommand_type_videoBadMBs_numberOfMBs),
        ('temporalReference', ___MiscellaneousCommand_type_videoBadMBs_temporalReference),
        ])
    __MiscellaneousCommand_type_videoBadMBs._ext = []
    __MiscellaneousCommand_type_lostPicture = SEQ_OF(name='lostPicture', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_lostPicture__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'PictureReference')))
    __MiscellaneousCommand_type_lostPicture._cont = ___MiscellaneousCommand_type_lostPicture__item_
    __MiscellaneousCommand_type_lostPartialPicture = SEQ(name='lostPartialPicture', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_lostPartialPicture_pictureReference = CHOICE(name='pictureReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'PictureReference')))
    ___MiscellaneousCommand_type_lostPartialPicture_firstMB = INT(name='firstMB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_lostPartialPicture_firstMB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9216)], ev=None, er=[])
    ___MiscellaneousCommand_type_lostPartialPicture_numberOfMBs = INT(name='numberOfMBs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_lostPartialPicture_numberOfMBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9216)], ev=None, er=[])
    __MiscellaneousCommand_type_lostPartialPicture._cont = ASN1Dict([
        ('pictureReference', ___MiscellaneousCommand_type_lostPartialPicture_pictureReference),
        ('firstMB', ___MiscellaneousCommand_type_lostPartialPicture_firstMB),
        ('numberOfMBs', ___MiscellaneousCommand_type_lostPartialPicture_numberOfMBs),
        ])
    __MiscellaneousCommand_type_lostPartialPicture._ext = []
    __MiscellaneousCommand_type_recoveryReferencePicture = SEQ_OF(name='recoveryReferencePicture', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_recoveryReferencePicture__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'PictureReference')))
    __MiscellaneousCommand_type_recoveryReferencePicture._cont = ___MiscellaneousCommand_type_recoveryReferencePicture__item_
    __MiscellaneousCommand_type_encryptionUpdateCommand = SEQ(name='encryptionUpdateCommand', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_encryptionUpdateCommand_encryptionSync = SEQ(name='encryptionSync', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionSync')))
    ___MiscellaneousCommand_type_encryptionUpdateCommand_multiplePayloadStream = SEQ(name='multiplePayloadStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'MultiplePayloadStream')), opt=True)
    __MiscellaneousCommand_type_encryptionUpdateCommand._cont = ASN1Dict([
        ('encryptionSync', ___MiscellaneousCommand_type_encryptionUpdateCommand_encryptionSync),
        ('multiplePayloadStream', ___MiscellaneousCommand_type_encryptionUpdateCommand_multiplePayloadStream),
        ])
    __MiscellaneousCommand_type_encryptionUpdateCommand._ext = []
    __MiscellaneousCommand_type_encryptionUpdateAck = SEQ(name='encryptionUpdateAck', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_encryptionUpdateAck_synchFlag = INT(name='synchFlag', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousCommand_type_encryptionUpdateAck_synchFlag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __MiscellaneousCommand_type_encryptionUpdateAck._cont = ASN1Dict([
        ('synchFlag', ___MiscellaneousCommand_type_encryptionUpdateAck_synchFlag),
        ])
    __MiscellaneousCommand_type_encryptionUpdateAck._ext = []
    _MiscellaneousCommand_type._cont = ASN1Dict([
        ('equaliseDelay', __MiscellaneousCommand_type_equaliseDelay),
        ('zeroDelay', __MiscellaneousCommand_type_zeroDelay),
        ('multipointModeCommand', __MiscellaneousCommand_type_multipointModeCommand),
        ('cancelMultipointModeCommand', __MiscellaneousCommand_type_cancelMultipointModeCommand),
        ('videoFreezePicture', __MiscellaneousCommand_type_videoFreezePicture),
        ('videoFastUpdatePicture', __MiscellaneousCommand_type_videoFastUpdatePicture),
        ('videoFastUpdateGOB', __MiscellaneousCommand_type_videoFastUpdateGOB),
        ('videoTemporalSpatialTradeOff', __MiscellaneousCommand_type_videoTemporalSpatialTradeOff),
        ('videoSendSyncEveryGOB', __MiscellaneousCommand_type_videoSendSyncEveryGOB),
        ('videoSendSyncEveryGOBCancel', __MiscellaneousCommand_type_videoSendSyncEveryGOBCancel),
        ('videoFastUpdateMB', __MiscellaneousCommand_type_videoFastUpdateMB),
        ('maxH223MUXPDUsize', __MiscellaneousCommand_type_maxH223MUXPDUsize),
        ('encryptionUpdate', __MiscellaneousCommand_type_encryptionUpdate),
        ('encryptionUpdateRequest', __MiscellaneousCommand_type_encryptionUpdateRequest),
        ('switchReceiveMediaOff', __MiscellaneousCommand_type_switchReceiveMediaOff),
        ('switchReceiveMediaOn', __MiscellaneousCommand_type_switchReceiveMediaOn),
        ('progressiveRefinementStart', __MiscellaneousCommand_type_progressiveRefinementStart),
        ('progressiveRefinementAbortOne', __MiscellaneousCommand_type_progressiveRefinementAbortOne),
        ('progressiveRefinementAbortContinuous', __MiscellaneousCommand_type_progressiveRefinementAbortContinuous),
        ('videoBadMBs', __MiscellaneousCommand_type_videoBadMBs),
        ('lostPicture', __MiscellaneousCommand_type_lostPicture),
        ('lostPartialPicture', __MiscellaneousCommand_type_lostPartialPicture),
        ('recoveryReferencePicture', __MiscellaneousCommand_type_recoveryReferencePicture),
        ('encryptionUpdateCommand', __MiscellaneousCommand_type_encryptionUpdateCommand),
        ('encryptionUpdateAck', __MiscellaneousCommand_type_encryptionUpdateAck),
        ])
    _MiscellaneousCommand_type._ext = ['videoFastUpdateMB', 'maxH223MUXPDUsize', 'encryptionUpdate', 'encryptionUpdateRequest', 'switchReceiveMediaOff', 'switchReceiveMediaOn', 'progressiveRefinementStart', 'progressiveRefinementAbortOne', 'progressiveRefinementAbortContinuous', 'videoBadMBs', 'lostPicture', 'lostPartialPicture', 'recoveryReferencePicture', 'encryptionUpdateCommand', 'encryptionUpdateAck']
    _MiscellaneousCommand_direction = CHOICE(name='direction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'EncryptionUpdateDirection')), opt=True)
    MiscellaneousCommand._cont = ASN1Dict([
        ('logicalChannelNumber', _MiscellaneousCommand_logicalChannelNumber),
        ('type', _MiscellaneousCommand_type),
        ('direction', _MiscellaneousCommand_direction),
        ])
    MiscellaneousCommand._ext = ['direction']
    
    #-----< KeyProtectionMethod >-----#
    KeyProtectionMethod = SEQ(name='KeyProtectionMethod', mode=MODE_TYPE)
    _KeyProtectionMethod_secureChannel = BOOL(name='secureChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KeyProtectionMethod_sharedSecret = BOOL(name='sharedSecret', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KeyProtectionMethod_certProtectedKey = BOOL(name='certProtectedKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    KeyProtectionMethod._cont = ASN1Dict([
        ('secureChannel', _KeyProtectionMethod_secureChannel),
        ('sharedSecret', _KeyProtectionMethod_sharedSecret),
        ('certProtectedKey', _KeyProtectionMethod_certProtectedKey),
        ])
    KeyProtectionMethod._ext = []
    
    #-----< EncryptionUpdateRequest >-----#
    EncryptionUpdateRequest = SEQ(name='EncryptionUpdateRequest', mode=MODE_TYPE)
    _EncryptionUpdateRequest_keyProtectionMethod = SEQ(name='keyProtectionMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'KeyProtectionMethod')), opt=True)
    _EncryptionUpdateRequest_synchFlag = INT(name='synchFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EncryptionUpdateRequest_synchFlag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    EncryptionUpdateRequest._cont = ASN1Dict([
        ('keyProtectionMethod', _EncryptionUpdateRequest_keyProtectionMethod),
        ('synchFlag', _EncryptionUpdateRequest_synchFlag),
        ])
    EncryptionUpdateRequest._ext = ['synchFlag']
    
    #-----< PictureReference >-----#
    PictureReference = CHOICE(name='PictureReference', mode=MODE_TYPE)
    _PictureReference_pictureNumber = INT(name='pictureNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PictureReference_pictureNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _PictureReference_longTermPictureIndex = INT(name='longTermPictureIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PictureReference_longTermPictureIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    PictureReference._cont = ASN1Dict([
        ('pictureNumber', _PictureReference_pictureNumber),
        ('longTermPictureIndex', _PictureReference_longTermPictureIndex),
        ])
    PictureReference._ext = []
    
    #-----< H223MultiplexReconfiguration >-----#
    H223MultiplexReconfiguration = CHOICE(name='H223MultiplexReconfiguration', mode=MODE_TYPE)
    _H223MultiplexReconfiguration_h223ModeChange = CHOICE(name='h223ModeChange', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223MultiplexReconfiguration_h223ModeChange_toLevel0 = NULL(name='toLevel0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223MultiplexReconfiguration_h223ModeChange_toLevel1 = NULL(name='toLevel1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223MultiplexReconfiguration_h223ModeChange_toLevel2 = NULL(name='toLevel2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223MultiplexReconfiguration_h223ModeChange_toLevel2withOptionalHeader = NULL(name='toLevel2withOptionalHeader', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223MultiplexReconfiguration_h223ModeChange._cont = ASN1Dict([
        ('toLevel0', __H223MultiplexReconfiguration_h223ModeChange_toLevel0),
        ('toLevel1', __H223MultiplexReconfiguration_h223ModeChange_toLevel1),
        ('toLevel2', __H223MultiplexReconfiguration_h223ModeChange_toLevel2),
        ('toLevel2withOptionalHeader', __H223MultiplexReconfiguration_h223ModeChange_toLevel2withOptionalHeader),
        ])
    _H223MultiplexReconfiguration_h223ModeChange._ext = []
    _H223MultiplexReconfiguration_h223AnnexADoubleFlag = CHOICE(name='h223AnnexADoubleFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __H223MultiplexReconfiguration_h223AnnexADoubleFlag_start = NULL(name='start', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __H223MultiplexReconfiguration_h223AnnexADoubleFlag_stop = NULL(name='stop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223MultiplexReconfiguration_h223AnnexADoubleFlag._cont = ASN1Dict([
        ('start', __H223MultiplexReconfiguration_h223AnnexADoubleFlag_start),
        ('stop', __H223MultiplexReconfiguration_h223AnnexADoubleFlag_stop),
        ])
    _H223MultiplexReconfiguration_h223AnnexADoubleFlag._ext = []
    H223MultiplexReconfiguration._cont = ASN1Dict([
        ('h223ModeChange', _H223MultiplexReconfiguration_h223ModeChange),
        ('h223AnnexADoubleFlag', _H223MultiplexReconfiguration_h223AnnexADoubleFlag),
        ])
    H223MultiplexReconfiguration._ext = []
    
    #-----< NewATMVCCommand >-----#
    NewATMVCCommand = SEQ(name='NewATMVCCommand', mode=MODE_TYPE)
    _NewATMVCCommand_resourceID = INT(name='resourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCCommand_resourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _NewATMVCCommand_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCCommand_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _NewATMVCCommand_bitRateLockedToPCRClock = BOOL(name='bitRateLockedToPCRClock', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCCommand_bitRateLockedToNetworkClock = BOOL(name='bitRateLockedToNetworkClock', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCCommand_aal = CHOICE(name='aal', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NewATMVCCommand_aal_aal1 = SEQ(name='aal1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal1_clockRecovery = CHOICE(name='clockRecovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____NewATMVCCommand_aal_aal1_clockRecovery_nullClockRecovery = NULL(name='nullClockRecovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCCommand_aal_aal1_clockRecovery_srtsClockRecovery = NULL(name='srtsClockRecovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCCommand_aal_aal1_clockRecovery_adaptiveClockRecovery = NULL(name='adaptiveClockRecovery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal1_clockRecovery._cont = ASN1Dict([
        ('nullClockRecovery', ____NewATMVCCommand_aal_aal1_clockRecovery_nullClockRecovery),
        ('srtsClockRecovery', ____NewATMVCCommand_aal_aal1_clockRecovery_srtsClockRecovery),
        ('adaptiveClockRecovery', ____NewATMVCCommand_aal_aal1_clockRecovery_adaptiveClockRecovery),
        ])
    ___NewATMVCCommand_aal_aal1_clockRecovery._ext = []
    ___NewATMVCCommand_aal_aal1_errorCorrection = CHOICE(name='errorCorrection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____NewATMVCCommand_aal_aal1_errorCorrection_nullErrorCorrection = NULL(name='nullErrorCorrection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCCommand_aal_aal1_errorCorrection_longInterleaver = NULL(name='longInterleaver', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCCommand_aal_aal1_errorCorrection_shortInterleaver = NULL(name='shortInterleaver', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCCommand_aal_aal1_errorCorrection_errorCorrectionOnly = NULL(name='errorCorrectionOnly', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal1_errorCorrection._cont = ASN1Dict([
        ('nullErrorCorrection', ____NewATMVCCommand_aal_aal1_errorCorrection_nullErrorCorrection),
        ('longInterleaver', ____NewATMVCCommand_aal_aal1_errorCorrection_longInterleaver),
        ('shortInterleaver', ____NewATMVCCommand_aal_aal1_errorCorrection_shortInterleaver),
        ('errorCorrectionOnly', ____NewATMVCCommand_aal_aal1_errorCorrection_errorCorrectionOnly),
        ])
    ___NewATMVCCommand_aal_aal1_errorCorrection._ext = []
    ___NewATMVCCommand_aal_aal1_structuredDataTransfer = BOOL(name='structuredDataTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal1_partiallyFilledCells = BOOL(name='partiallyFilledCells', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_aal_aal1._cont = ASN1Dict([
        ('clockRecovery', ___NewATMVCCommand_aal_aal1_clockRecovery),
        ('errorCorrection', ___NewATMVCCommand_aal_aal1_errorCorrection),
        ('structuredDataTransfer', ___NewATMVCCommand_aal_aal1_structuredDataTransfer),
        ('partiallyFilledCells', ___NewATMVCCommand_aal_aal1_partiallyFilledCells),
        ])
    __NewATMVCCommand_aal_aal1._ext = []
    __NewATMVCCommand_aal_aal5 = SEQ(name='aal5', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal5_forwardMaximumSDUSize = INT(name='forwardMaximumSDUSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal5_forwardMaximumSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ___NewATMVCCommand_aal_aal5_backwardMaximumSDUSize = INT(name='backwardMaximumSDUSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_aal_aal5_backwardMaximumSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __NewATMVCCommand_aal_aal5._cont = ASN1Dict([
        ('forwardMaximumSDUSize', ___NewATMVCCommand_aal_aal5_forwardMaximumSDUSize),
        ('backwardMaximumSDUSize', ___NewATMVCCommand_aal_aal5_backwardMaximumSDUSize),
        ])
    __NewATMVCCommand_aal_aal5._ext = []
    _NewATMVCCommand_aal._cont = ASN1Dict([
        ('aal1', __NewATMVCCommand_aal_aal1),
        ('aal5', __NewATMVCCommand_aal_aal5),
        ])
    _NewATMVCCommand_aal._ext = []
    _NewATMVCCommand_multiplex = CHOICE(name='multiplex', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NewATMVCCommand_multiplex_noMultiplex = NULL(name='noMultiplex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_multiplex_transportStream = NULL(name='transportStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_multiplex_programStream = NULL(name='programStream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCCommand_multiplex._cont = ASN1Dict([
        ('noMultiplex', __NewATMVCCommand_multiplex_noMultiplex),
        ('transportStream', __NewATMVCCommand_multiplex_transportStream),
        ('programStream', __NewATMVCCommand_multiplex_programStream),
        ])
    _NewATMVCCommand_multiplex._ext = []
    _NewATMVCCommand_reverseParameters = SEQ(name='reverseParameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_reverseParameters_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_reverseParameters_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __NewATMVCCommand_reverseParameters_bitRateLockedToPCRClock = BOOL(name='bitRateLockedToPCRClock', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_reverseParameters_bitRateLockedToNetworkClock = BOOL(name='bitRateLockedToNetworkClock', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_reverseParameters_multiplex = CHOICE(name='multiplex', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___NewATMVCCommand_reverseParameters_multiplex_noMultiplex = NULL(name='noMultiplex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_reverseParameters_multiplex_transportStream = NULL(name='transportStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCCommand_reverseParameters_multiplex_programStream = NULL(name='programStream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCCommand_reverseParameters_multiplex._cont = ASN1Dict([
        ('noMultiplex', ___NewATMVCCommand_reverseParameters_multiplex_noMultiplex),
        ('transportStream', ___NewATMVCCommand_reverseParameters_multiplex_transportStream),
        ('programStream', ___NewATMVCCommand_reverseParameters_multiplex_programStream),
        ])
    __NewATMVCCommand_reverseParameters_multiplex._ext = []
    _NewATMVCCommand_reverseParameters._cont = ASN1Dict([
        ('bitRate', __NewATMVCCommand_reverseParameters_bitRate),
        ('bitRateLockedToPCRClock', __NewATMVCCommand_reverseParameters_bitRateLockedToPCRClock),
        ('bitRateLockedToNetworkClock', __NewATMVCCommand_reverseParameters_bitRateLockedToNetworkClock),
        ('multiplex', __NewATMVCCommand_reverseParameters_multiplex),
        ])
    _NewATMVCCommand_reverseParameters._ext = []
    NewATMVCCommand._cont = ASN1Dict([
        ('resourceID', _NewATMVCCommand_resourceID),
        ('bitRate', _NewATMVCCommand_bitRate),
        ('bitRateLockedToPCRClock', _NewATMVCCommand_bitRateLockedToPCRClock),
        ('bitRateLockedToNetworkClock', _NewATMVCCommand_bitRateLockedToNetworkClock),
        ('aal', _NewATMVCCommand_aal),
        ('multiplex', _NewATMVCCommand_multiplex),
        ('reverseParameters', _NewATMVCCommand_reverseParameters),
        ])
    NewATMVCCommand._ext = []
    
    #-----< MobileMultilinkReconfigurationCommand >-----#
    MobileMultilinkReconfigurationCommand = SEQ(name='MobileMultilinkReconfigurationCommand', mode=MODE_TYPE)
    _MobileMultilinkReconfigurationCommand_sampleSize = INT(name='sampleSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobileMultilinkReconfigurationCommand_sampleSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _MobileMultilinkReconfigurationCommand_samplesPerFrame = INT(name='samplesPerFrame', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobileMultilinkReconfigurationCommand_samplesPerFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _MobileMultilinkReconfigurationCommand_status = CHOICE(name='status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MobileMultilinkReconfigurationCommand_status_synchronized = NULL(name='synchronized', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MobileMultilinkReconfigurationCommand_status_reconfiguration = NULL(name='reconfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobileMultilinkReconfigurationCommand_status._cont = ASN1Dict([
        ('synchronized', __MobileMultilinkReconfigurationCommand_status_synchronized),
        ('reconfiguration', __MobileMultilinkReconfigurationCommand_status_reconfiguration),
        ])
    _MobileMultilinkReconfigurationCommand_status._ext = []
    MobileMultilinkReconfigurationCommand._cont = ASN1Dict([
        ('sampleSize', _MobileMultilinkReconfigurationCommand_sampleSize),
        ('samplesPerFrame', _MobileMultilinkReconfigurationCommand_samplesPerFrame),
        ('status', _MobileMultilinkReconfigurationCommand_status),
        ])
    MobileMultilinkReconfigurationCommand._ext = []
    
    #-----< FunctionNotUnderstood >-----#
    FunctionNotUnderstood = CHOICE(name='FunctionNotUnderstood', mode=MODE_TYPE)
    _FunctionNotUnderstood_request = CHOICE(name='request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'RequestMessage')))
    _FunctionNotUnderstood_response = CHOICE(name='response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'ResponseMessage')))
    _FunctionNotUnderstood_command = CHOICE(name='command', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'CommandMessage')))
    FunctionNotUnderstood._cont = ASN1Dict([
        ('request', _FunctionNotUnderstood_request),
        ('response', _FunctionNotUnderstood_response),
        ('command', _FunctionNotUnderstood_command),
        ])
    FunctionNotUnderstood._ext = None
    
    #-----< FunctionNotSupported >-----#
    FunctionNotSupported = SEQ(name='FunctionNotSupported', mode=MODE_TYPE)
    _FunctionNotSupported_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FunctionNotSupported_cause_syntaxError = NULL(name='syntaxError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FunctionNotSupported_cause_semanticError = NULL(name='semanticError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FunctionNotSupported_cause_unknownFunction = NULL(name='unknownFunction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FunctionNotSupported_cause._cont = ASN1Dict([
        ('syntaxError', __FunctionNotSupported_cause_syntaxError),
        ('semanticError', __FunctionNotSupported_cause_semanticError),
        ('unknownFunction', __FunctionNotSupported_cause_unknownFunction),
        ])
    _FunctionNotSupported_cause._ext = []
    _FunctionNotSupported_returnedFunction = OCT_STR(name='returnedFunction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    FunctionNotSupported._cont = ASN1Dict([
        ('cause', _FunctionNotSupported_cause),
        ('returnedFunction', _FunctionNotSupported_returnedFunction),
        ])
    FunctionNotSupported._ext = []
    
    #-----< ConferenceIndication >-----#
    ConferenceIndication = CHOICE(name='ConferenceIndication', mode=MODE_TYPE)
    _ConferenceIndication_sbeNumber = INT(name='sbeNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_sbeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _ConferenceIndication_terminalNumberAssign = SEQ(name='terminalNumberAssign', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceIndication_terminalJoinedConference = SEQ(name='terminalJoinedConference', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceIndication_terminalLeftConference = SEQ(name='terminalLeftConference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceIndication_seenByAtLeastOneOther = NULL(name='seenByAtLeastOneOther', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_cancelSeenByAtLeastOneOther = NULL(name='cancelSeenByAtLeastOneOther', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_seenByAll = NULL(name='seenByAll', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_cancelSeenByAll = NULL(name='cancelSeenByAll', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_terminalYouAreSeeing = SEQ(name='terminalYouAreSeeing', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceIndication_requestForFloor = NULL(name='requestForFloor', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_withdrawChairToken = NULL(name='withdrawChairToken', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_floorRequested = SEQ(name='floorRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalLabel')))
    _ConferenceIndication_terminalYouAreSeeingInSubPictureNumber = SEQ(name='terminalYouAreSeeingInSubPictureNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalYouAreSeeingInSubPictureNumber')))
    _ConferenceIndication_videoIndicateCompose = SEQ(name='videoIndicateCompose', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'VideoIndicateCompose')))
    _ConferenceIndication_masterMCU = NULL(name='masterMCU', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConferenceIndication_cancelMasterMCU = NULL(name='cancelMasterMCU', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ConferenceIndication._cont = ASN1Dict([
        ('sbeNumber', _ConferenceIndication_sbeNumber),
        ('terminalNumberAssign', _ConferenceIndication_terminalNumberAssign),
        ('terminalJoinedConference', _ConferenceIndication_terminalJoinedConference),
        ('terminalLeftConference', _ConferenceIndication_terminalLeftConference),
        ('seenByAtLeastOneOther', _ConferenceIndication_seenByAtLeastOneOther),
        ('cancelSeenByAtLeastOneOther', _ConferenceIndication_cancelSeenByAtLeastOneOther),
        ('seenByAll', _ConferenceIndication_seenByAll),
        ('cancelSeenByAll', _ConferenceIndication_cancelSeenByAll),
        ('terminalYouAreSeeing', _ConferenceIndication_terminalYouAreSeeing),
        ('requestForFloor', _ConferenceIndication_requestForFloor),
        ('withdrawChairToken', _ConferenceIndication_withdrawChairToken),
        ('floorRequested', _ConferenceIndication_floorRequested),
        ('terminalYouAreSeeingInSubPictureNumber', _ConferenceIndication_terminalYouAreSeeingInSubPictureNumber),
        ('videoIndicateCompose', _ConferenceIndication_videoIndicateCompose),
        ('masterMCU', _ConferenceIndication_masterMCU),
        ('cancelMasterMCU', _ConferenceIndication_cancelMasterMCU),
        ])
    ConferenceIndication._ext = ['withdrawChairToken', 'floorRequested', 'terminalYouAreSeeingInSubPictureNumber', 'videoIndicateCompose', 'masterMCU', 'cancelMasterMCU']
    
    #-----< TerminalYouAreSeeingInSubPictureNumber >-----#
    TerminalYouAreSeeingInSubPictureNumber = SEQ(name='TerminalYouAreSeeingInSubPictureNumber', mode=MODE_TYPE)
    _TerminalYouAreSeeingInSubPictureNumber_terminalNumber = INT(name='terminalNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TerminalNumber')))
    _TerminalYouAreSeeingInSubPictureNumber_subPictureNumber = INT(name='subPictureNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TerminalYouAreSeeingInSubPictureNumber_subPictureNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TerminalYouAreSeeingInSubPictureNumber_mcuNumber = INT(name='mcuNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'McuNumber')))
    TerminalYouAreSeeingInSubPictureNumber._cont = ASN1Dict([
        ('terminalNumber', _TerminalYouAreSeeingInSubPictureNumber_terminalNumber),
        ('subPictureNumber', _TerminalYouAreSeeingInSubPictureNumber_subPictureNumber),
        ('mcuNumber', _TerminalYouAreSeeingInSubPictureNumber_mcuNumber),
        ])
    TerminalYouAreSeeingInSubPictureNumber._ext = ['mcuNumber']
    
    #-----< VideoIndicateCompose >-----#
    VideoIndicateCompose = SEQ(name='VideoIndicateCompose', mode=MODE_TYPE)
    _VideoIndicateCompose_compositionNumber = INT(name='compositionNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VideoIndicateCompose_compositionNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    VideoIndicateCompose._cont = ASN1Dict([
        ('compositionNumber', _VideoIndicateCompose_compositionNumber),
        ])
    VideoIndicateCompose._ext = []
    
    #-----< MiscellaneousIndication >-----#
    MiscellaneousIndication = SEQ(name='MiscellaneousIndication', mode=MODE_TYPE)
    _MiscellaneousIndication_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _MiscellaneousIndication_type = CHOICE(name='type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MiscellaneousIndication_type_logicalChannelActive = NULL(name='logicalChannelActive', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_logicalChannelInactive = NULL(name='logicalChannelInactive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_multipointConference = NULL(name='multipointConference', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_cancelMultipointConference = NULL(name='cancelMultipointConference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_multipointZeroComm = NULL(name='multipointZeroComm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_cancelMultipointZeroComm = NULL(name='cancelMultipointZeroComm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_multipointSecondaryStatus = NULL(name='multipointSecondaryStatus', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_cancelMultipointSecondaryStatus = NULL(name='cancelMultipointSecondaryStatus', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_videoIndicateReadyToActivate = NULL(name='videoIndicateReadyToActivate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_videoTemporalSpatialTradeOff = INT(name='videoTemporalSpatialTradeOff', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MiscellaneousIndication_type_videoTemporalSpatialTradeOff._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    __MiscellaneousIndication_type_videoNotDecodedMBs = SEQ(name='videoNotDecodedMBs', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousIndication_type_videoNotDecodedMBs_firstMB = INT(name='firstMB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousIndication_type_videoNotDecodedMBs_firstMB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    ___MiscellaneousIndication_type_videoNotDecodedMBs_numberOfMBs = INT(name='numberOfMBs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousIndication_type_videoNotDecodedMBs_numberOfMBs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    ___MiscellaneousIndication_type_videoNotDecodedMBs_temporalReference = INT(name='temporalReference', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MiscellaneousIndication_type_videoNotDecodedMBs_temporalReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __MiscellaneousIndication_type_videoNotDecodedMBs._cont = ASN1Dict([
        ('firstMB', ___MiscellaneousIndication_type_videoNotDecodedMBs_firstMB),
        ('numberOfMBs', ___MiscellaneousIndication_type_videoNotDecodedMBs_numberOfMBs),
        ('temporalReference', ___MiscellaneousIndication_type_videoNotDecodedMBs_temporalReference),
        ])
    __MiscellaneousIndication_type_videoNotDecodedMBs._ext = []
    __MiscellaneousIndication_type_transportCapability = SEQ(name='transportCapability', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportCapability')))
    _MiscellaneousIndication_type._cont = ASN1Dict([
        ('logicalChannelActive', __MiscellaneousIndication_type_logicalChannelActive),
        ('logicalChannelInactive', __MiscellaneousIndication_type_logicalChannelInactive),
        ('multipointConference', __MiscellaneousIndication_type_multipointConference),
        ('cancelMultipointConference', __MiscellaneousIndication_type_cancelMultipointConference),
        ('multipointZeroComm', __MiscellaneousIndication_type_multipointZeroComm),
        ('cancelMultipointZeroComm', __MiscellaneousIndication_type_cancelMultipointZeroComm),
        ('multipointSecondaryStatus', __MiscellaneousIndication_type_multipointSecondaryStatus),
        ('cancelMultipointSecondaryStatus', __MiscellaneousIndication_type_cancelMultipointSecondaryStatus),
        ('videoIndicateReadyToActivate', __MiscellaneousIndication_type_videoIndicateReadyToActivate),
        ('videoTemporalSpatialTradeOff', __MiscellaneousIndication_type_videoTemporalSpatialTradeOff),
        ('videoNotDecodedMBs', __MiscellaneousIndication_type_videoNotDecodedMBs),
        ('transportCapability', __MiscellaneousIndication_type_transportCapability),
        ])
    _MiscellaneousIndication_type._ext = ['videoNotDecodedMBs', 'transportCapability']
    MiscellaneousIndication._cont = ASN1Dict([
        ('logicalChannelNumber', _MiscellaneousIndication_logicalChannelNumber),
        ('type', _MiscellaneousIndication_type),
        ])
    MiscellaneousIndication._ext = []
    
    #-----< JitterIndication >-----#
    JitterIndication = SEQ(name='JitterIndication', mode=MODE_TYPE)
    _JitterIndication_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __JitterIndication_scope_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __JitterIndication_scope_resourceID = INT(name='resourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __JitterIndication_scope_resourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __JitterIndication_scope_wholeMultiplex = NULL(name='wholeMultiplex', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _JitterIndication_scope._cont = ASN1Dict([
        ('logicalChannelNumber', __JitterIndication_scope_logicalChannelNumber),
        ('resourceID', __JitterIndication_scope_resourceID),
        ('wholeMultiplex', __JitterIndication_scope_wholeMultiplex),
        ])
    _JitterIndication_scope._ext = None
    _JitterIndication_estimatedReceivedJitterMantissa = INT(name='estimatedReceivedJitterMantissa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _JitterIndication_estimatedReceivedJitterMantissa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _JitterIndication_estimatedReceivedJitterExponent = INT(name='estimatedReceivedJitterExponent', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _JitterIndication_estimatedReceivedJitterExponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _JitterIndication_skippedFrameCount = INT(name='skippedFrameCount', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _JitterIndication_skippedFrameCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _JitterIndication_additionalDecoderBuffer = INT(name='additionalDecoderBuffer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _JitterIndication_additionalDecoderBuffer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    JitterIndication._cont = ASN1Dict([
        ('scope', _JitterIndication_scope),
        ('estimatedReceivedJitterMantissa', _JitterIndication_estimatedReceivedJitterMantissa),
        ('estimatedReceivedJitterExponent', _JitterIndication_estimatedReceivedJitterExponent),
        ('skippedFrameCount', _JitterIndication_skippedFrameCount),
        ('additionalDecoderBuffer', _JitterIndication_additionalDecoderBuffer),
        ])
    JitterIndication._ext = []
    
    #-----< H223SkewIndication >-----#
    H223SkewIndication = SEQ(name='H223SkewIndication', mode=MODE_TYPE)
    _H223SkewIndication_logicalChannelNumber1 = INT(name='logicalChannelNumber1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _H223SkewIndication_logicalChannelNumber2 = INT(name='logicalChannelNumber2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _H223SkewIndication_skew = INT(name='skew', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H223SkewIndication_skew._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    H223SkewIndication._cont = ASN1Dict([
        ('logicalChannelNumber1', _H223SkewIndication_logicalChannelNumber1),
        ('logicalChannelNumber2', _H223SkewIndication_logicalChannelNumber2),
        ('skew', _H223SkewIndication_skew),
        ])
    H223SkewIndication._ext = []
    
    #-----< H2250MaximumSkewIndication >-----#
    H2250MaximumSkewIndication = SEQ(name='H2250MaximumSkewIndication', mode=MODE_TYPE)
    _H2250MaximumSkewIndication_logicalChannelNumber1 = INT(name='logicalChannelNumber1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _H2250MaximumSkewIndication_logicalChannelNumber2 = INT(name='logicalChannelNumber2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    _H2250MaximumSkewIndication_maximumSkew = INT(name='maximumSkew', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _H2250MaximumSkewIndication_maximumSkew._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    H2250MaximumSkewIndication._cont = ASN1Dict([
        ('logicalChannelNumber1', _H2250MaximumSkewIndication_logicalChannelNumber1),
        ('logicalChannelNumber2', _H2250MaximumSkewIndication_logicalChannelNumber2),
        ('maximumSkew', _H2250MaximumSkewIndication_maximumSkew),
        ])
    H2250MaximumSkewIndication._ext = []
    
    #-----< MCLocationIndication >-----#
    MCLocationIndication = SEQ(name='MCLocationIndication', mode=MODE_TYPE)
    _MCLocationIndication_signalAddress = CHOICE(name='signalAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'TransportAddress')))
    MCLocationIndication._cont = ASN1Dict([
        ('signalAddress', _MCLocationIndication_signalAddress),
        ])
    MCLocationIndication._ext = []
    
    #-----< VendorIdentification >-----#
    VendorIdentification = SEQ(name='VendorIdentification', mode=MODE_TYPE)
    _VendorIdentification_vendor = CHOICE(name='vendor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardIdentifier')))
    _VendorIdentification_productNumber = OCT_STR(name='productNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VendorIdentification_productNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _VendorIdentification_versionNumber = OCT_STR(name='versionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VendorIdentification_versionNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    VendorIdentification._cont = ASN1Dict([
        ('vendor', _VendorIdentification_vendor),
        ('productNumber', _VendorIdentification_productNumber),
        ('versionNumber', _VendorIdentification_versionNumber),
        ])
    VendorIdentification._ext = []
    
    #-----< NewATMVCIndication >-----#
    NewATMVCIndication = SEQ(name='NewATMVCIndication', mode=MODE_TYPE)
    _NewATMVCIndication_resourceID = INT(name='resourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCIndication_resourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _NewATMVCIndication_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCIndication_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _NewATMVCIndication_bitRateLockedToPCRClock = BOOL(name='bitRateLockedToPCRClock', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCIndication_bitRateLockedToNetworkClock = BOOL(name='bitRateLockedToNetworkClock', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCIndication_aal = CHOICE(name='aal', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NewATMVCIndication_aal_aal1 = SEQ(name='aal1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal1_clockRecovery = CHOICE(name='clockRecovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____NewATMVCIndication_aal_aal1_clockRecovery_nullClockRecovery = NULL(name='nullClockRecovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCIndication_aal_aal1_clockRecovery_srtsClockRecovery = NULL(name='srtsClockRecovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCIndication_aal_aal1_clockRecovery_adaptiveClockRecovery = NULL(name='adaptiveClockRecovery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal1_clockRecovery._cont = ASN1Dict([
        ('nullClockRecovery', ____NewATMVCIndication_aal_aal1_clockRecovery_nullClockRecovery),
        ('srtsClockRecovery', ____NewATMVCIndication_aal_aal1_clockRecovery_srtsClockRecovery),
        ('adaptiveClockRecovery', ____NewATMVCIndication_aal_aal1_clockRecovery_adaptiveClockRecovery),
        ])
    ___NewATMVCIndication_aal_aal1_clockRecovery._ext = []
    ___NewATMVCIndication_aal_aal1_errorCorrection = CHOICE(name='errorCorrection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____NewATMVCIndication_aal_aal1_errorCorrection_nullErrorCorrection = NULL(name='nullErrorCorrection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCIndication_aal_aal1_errorCorrection_longInterleaver = NULL(name='longInterleaver', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCIndication_aal_aal1_errorCorrection_shortInterleaver = NULL(name='shortInterleaver', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____NewATMVCIndication_aal_aal1_errorCorrection_errorCorrectionOnly = NULL(name='errorCorrectionOnly', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal1_errorCorrection._cont = ASN1Dict([
        ('nullErrorCorrection', ____NewATMVCIndication_aal_aal1_errorCorrection_nullErrorCorrection),
        ('longInterleaver', ____NewATMVCIndication_aal_aal1_errorCorrection_longInterleaver),
        ('shortInterleaver', ____NewATMVCIndication_aal_aal1_errorCorrection_shortInterleaver),
        ('errorCorrectionOnly', ____NewATMVCIndication_aal_aal1_errorCorrection_errorCorrectionOnly),
        ])
    ___NewATMVCIndication_aal_aal1_errorCorrection._ext = []
    ___NewATMVCIndication_aal_aal1_structuredDataTransfer = BOOL(name='structuredDataTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal1_partiallyFilledCells = BOOL(name='partiallyFilledCells', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_aal_aal1._cont = ASN1Dict([
        ('clockRecovery', ___NewATMVCIndication_aal_aal1_clockRecovery),
        ('errorCorrection', ___NewATMVCIndication_aal_aal1_errorCorrection),
        ('structuredDataTransfer', ___NewATMVCIndication_aal_aal1_structuredDataTransfer),
        ('partiallyFilledCells', ___NewATMVCIndication_aal_aal1_partiallyFilledCells),
        ])
    __NewATMVCIndication_aal_aal1._ext = []
    __NewATMVCIndication_aal_aal5 = SEQ(name='aal5', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal5_forwardMaximumSDUSize = INT(name='forwardMaximumSDUSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal5_forwardMaximumSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ___NewATMVCIndication_aal_aal5_backwardMaximumSDUSize = INT(name='backwardMaximumSDUSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_aal_aal5_backwardMaximumSDUSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __NewATMVCIndication_aal_aal5._cont = ASN1Dict([
        ('forwardMaximumSDUSize', ___NewATMVCIndication_aal_aal5_forwardMaximumSDUSize),
        ('backwardMaximumSDUSize', ___NewATMVCIndication_aal_aal5_backwardMaximumSDUSize),
        ])
    __NewATMVCIndication_aal_aal5._ext = []
    _NewATMVCIndication_aal._cont = ASN1Dict([
        ('aal1', __NewATMVCIndication_aal_aal1),
        ('aal5', __NewATMVCIndication_aal_aal5),
        ])
    _NewATMVCIndication_aal._ext = []
    _NewATMVCIndication_multiplex = CHOICE(name='multiplex', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NewATMVCIndication_multiplex_noMultiplex = NULL(name='noMultiplex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_multiplex_transportStream = NULL(name='transportStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_multiplex_programStream = NULL(name='programStream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NewATMVCIndication_multiplex._cont = ASN1Dict([
        ('noMultiplex', __NewATMVCIndication_multiplex_noMultiplex),
        ('transportStream', __NewATMVCIndication_multiplex_transportStream),
        ('programStream', __NewATMVCIndication_multiplex_programStream),
        ])
    _NewATMVCIndication_multiplex._ext = []
    _NewATMVCIndication_reverseParameters = SEQ(name='reverseParameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_reverseParameters_bitRate = INT(name='bitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_reverseParameters_bitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __NewATMVCIndication_reverseParameters_bitRateLockedToPCRClock = BOOL(name='bitRateLockedToPCRClock', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_reverseParameters_bitRateLockedToNetworkClock = BOOL(name='bitRateLockedToNetworkClock', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_reverseParameters_multiplex = CHOICE(name='multiplex', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___NewATMVCIndication_reverseParameters_multiplex_noMultiplex = NULL(name='noMultiplex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_reverseParameters_multiplex_transportStream = NULL(name='transportStream', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NewATMVCIndication_reverseParameters_multiplex_programStream = NULL(name='programStream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NewATMVCIndication_reverseParameters_multiplex._cont = ASN1Dict([
        ('noMultiplex', ___NewATMVCIndication_reverseParameters_multiplex_noMultiplex),
        ('transportStream', ___NewATMVCIndication_reverseParameters_multiplex_transportStream),
        ('programStream', ___NewATMVCIndication_reverseParameters_multiplex_programStream),
        ])
    __NewATMVCIndication_reverseParameters_multiplex._ext = []
    _NewATMVCIndication_reverseParameters._cont = ASN1Dict([
        ('bitRate', __NewATMVCIndication_reverseParameters_bitRate),
        ('bitRateLockedToPCRClock', __NewATMVCIndication_reverseParameters_bitRateLockedToPCRClock),
        ('bitRateLockedToNetworkClock', __NewATMVCIndication_reverseParameters_bitRateLockedToNetworkClock),
        ('multiplex', __NewATMVCIndication_reverseParameters_multiplex),
        ])
    _NewATMVCIndication_reverseParameters._ext = []
    NewATMVCIndication._cont = ASN1Dict([
        ('resourceID', _NewATMVCIndication_resourceID),
        ('bitRate', _NewATMVCIndication_bitRate),
        ('bitRateLockedToPCRClock', _NewATMVCIndication_bitRateLockedToPCRClock),
        ('bitRateLockedToNetworkClock', _NewATMVCIndication_bitRateLockedToNetworkClock),
        ('aal', _NewATMVCIndication_aal),
        ('multiplex', _NewATMVCIndication_multiplex),
        ('reverseParameters', _NewATMVCIndication_reverseParameters),
        ])
    NewATMVCIndication._ext = ['reverseParameters']
    
    #-----< IV8 >-----#
    IV8 = OCT_STR(name='IV8', mode=MODE_TYPE)
    IV8._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IV16 >-----#
    IV16 = OCT_STR(name='IV16', mode=MODE_TYPE)
    IV16._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< Params >-----#
    Params = SEQ(name='Params', mode=MODE_TYPE)
    _Params_iv8 = OCT_STR(name='iv8', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IV8')), opt=True)
    _Params_iv16 = OCT_STR(name='iv16', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'IV16')), opt=True)
    _Params_iv = OCT_STR(name='iv', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Params._cont = ASN1Dict([
        ('iv8', _Params_iv8),
        ('iv16', _Params_iv16),
        ('iv', _Params_iv),
        ])
    Params._ext = []
    
    #-----< UserInputIndication >-----#
    UserInputIndication = CHOICE(name='UserInputIndication', mode=MODE_TYPE)
    _UserInputIndication_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    _UserInputIndication_alphanumeric = STR_GENE(name='alphanumeric', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputIndication_userInputSupportIndication = CHOICE(name='userInputSupportIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UserInputIndication_userInputSupportIndication_nonStandard = SEQ(name='nonStandard', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'NonStandardParameter')))
    __UserInputIndication_userInputSupportIndication_basicString = NULL(name='basicString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_userInputSupportIndication_iA5String = NULL(name='iA5String', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_userInputSupportIndication_generalString = NULL(name='generalString', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_userInputSupportIndication_encryptedBasicString = NULL(name='encryptedBasicString', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_userInputSupportIndication_encryptedIA5String = NULL(name='encryptedIA5String', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_userInputSupportIndication_encryptedGeneralString = NULL(name='encryptedGeneralString', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputIndication_userInputSupportIndication._cont = ASN1Dict([
        ('nonStandard', __UserInputIndication_userInputSupportIndication_nonStandard),
        ('basicString', __UserInputIndication_userInputSupportIndication_basicString),
        ('iA5String', __UserInputIndication_userInputSupportIndication_iA5String),
        ('generalString', __UserInputIndication_userInputSupportIndication_generalString),
        ('encryptedBasicString', __UserInputIndication_userInputSupportIndication_encryptedBasicString),
        ('encryptedIA5String', __UserInputIndication_userInputSupportIndication_encryptedIA5String),
        ('encryptedGeneralString', __UserInputIndication_userInputSupportIndication_encryptedGeneralString),
        ])
    _UserInputIndication_userInputSupportIndication._ext = ['encryptedBasicString', 'encryptedIA5String', 'encryptedGeneralString']
    _UserInputIndication_signal = SEQ(name='signal', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_signal_signalType = STR_IA5(name='signalType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_signal_signalType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __UserInputIndication_signal_signalType._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '#', '*', 'A', 'B', 'C', 'D', '!'], rr=[], ev=None, er=[])
    __UserInputIndication_signal_duration = INT(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UserInputIndication_signal_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __UserInputIndication_signal_rtp = SEQ(name='rtp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UserInputIndication_signal_rtp_timestamp = INT(name='timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UserInputIndication_signal_rtp_timestamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    ___UserInputIndication_signal_rtp_expirationTime = INT(name='expirationTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UserInputIndication_signal_rtp_expirationTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    ___UserInputIndication_signal_rtp_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __UserInputIndication_signal_rtp._cont = ASN1Dict([
        ('timestamp', ___UserInputIndication_signal_rtp_timestamp),
        ('expirationTime', ___UserInputIndication_signal_rtp_expirationTime),
        ('logicalChannelNumber', ___UserInputIndication_signal_rtp_logicalChannelNumber),
        ])
    __UserInputIndication_signal_rtp._ext = []
    __UserInputIndication_signal_rtpPayloadIndication = NULL(name='rtpPayloadIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UserInputIndication_signal_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Params')), opt=True)
    __UserInputIndication_signal_encryptedSignalType = OCT_STR(name='encryptedSignalType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UserInputIndication_signal_encryptedSignalType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __UserInputIndication_signal_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserInputIndication_signal._cont = ASN1Dict([
        ('signalType', __UserInputIndication_signal_signalType),
        ('duration', __UserInputIndication_signal_duration),
        ('rtp', __UserInputIndication_signal_rtp),
        ('rtpPayloadIndication', __UserInputIndication_signal_rtpPayloadIndication),
        ('paramS', __UserInputIndication_signal_paramS),
        ('encryptedSignalType', __UserInputIndication_signal_encryptedSignalType),
        ('algorithmOID', __UserInputIndication_signal_algorithmOID),
        ])
    _UserInputIndication_signal._ext = ['rtpPayloadIndication', 'paramS', 'encryptedSignalType', 'algorithmOID']
    _UserInputIndication_signalUpdate = SEQ(name='signalUpdate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_signalUpdate_duration = INT(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_signalUpdate_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __UserInputIndication_signalUpdate_rtp = SEQ(name='rtp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UserInputIndication_signalUpdate_rtp_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __UserInputIndication_signalUpdate_rtp._cont = ASN1Dict([
        ('logicalChannelNumber', ___UserInputIndication_signalUpdate_rtp_logicalChannelNumber),
        ])
    __UserInputIndication_signalUpdate_rtp._ext = []
    _UserInputIndication_signalUpdate._cont = ASN1Dict([
        ('duration', __UserInputIndication_signalUpdate_duration),
        ('rtp', __UserInputIndication_signalUpdate_rtp),
        ])
    _UserInputIndication_signalUpdate._ext = []
    _UserInputIndication_extendedAlphanumeric = SEQ(name='extendedAlphanumeric', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_extendedAlphanumeric_alphanumeric = STR_GENE(name='alphanumeric', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_extendedAlphanumeric_rtpPayloadIndication = NULL(name='rtpPayloadIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric = SEQ(name='encryptedAlphanumeric', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Params')), opt=True)
    ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_encrypted = OCT_STR(name='encrypted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric._cont = ASN1Dict([
        ('algorithmOID', ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_algorithmOID),
        ('paramS', ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_paramS),
        ('encrypted', ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_encrypted),
        ])
    __UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric._ext = []
    _UserInputIndication_extendedAlphanumeric._cont = ASN1Dict([
        ('alphanumeric', __UserInputIndication_extendedAlphanumeric_alphanumeric),
        ('rtpPayloadIndication', __UserInputIndication_extendedAlphanumeric_rtpPayloadIndication),
        ('encryptedAlphanumeric', __UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric),
        ])
    _UserInputIndication_extendedAlphanumeric._ext = ['encryptedAlphanumeric']
    _UserInputIndication_encryptedAlphanumeric = SEQ(name='encryptedAlphanumeric', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_encryptedAlphanumeric_algorithmOID = OID(name='algorithmOID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_encryptedAlphanumeric_paramS = SEQ(name='paramS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'Params')), opt=True)
    __UserInputIndication_encryptedAlphanumeric_encrypted = OCT_STR(name='encrypted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserInputIndication_encryptedAlphanumeric._cont = ASN1Dict([
        ('algorithmOID', __UserInputIndication_encryptedAlphanumeric_algorithmOID),
        ('paramS', __UserInputIndication_encryptedAlphanumeric_paramS),
        ('encrypted', __UserInputIndication_encryptedAlphanumeric_encrypted),
        ])
    _UserInputIndication_encryptedAlphanumeric._ext = []
    _UserInputIndication_genericInformation = SEQ_OF(name='genericInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UserInputIndication_genericInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'GenericInformation')))
    _UserInputIndication_genericInformation._cont = __UserInputIndication_genericInformation__item_
    UserInputIndication._cont = ASN1Dict([
        ('nonStandard', _UserInputIndication_nonStandard),
        ('alphanumeric', _UserInputIndication_alphanumeric),
        ('userInputSupportIndication', _UserInputIndication_userInputSupportIndication),
        ('signal', _UserInputIndication_signal),
        ('signalUpdate', _UserInputIndication_signalUpdate),
        ('extendedAlphanumeric', _UserInputIndication_extendedAlphanumeric),
        ('encryptedAlphanumeric', _UserInputIndication_encryptedAlphanumeric),
        ('genericInformation', _UserInputIndication_genericInformation),
        ])
    UserInputIndication._ext = ['userInputSupportIndication', 'signal', 'signalUpdate', 'extendedAlphanumeric', 'encryptedAlphanumeric', 'genericInformation']
    
    #-----< FlowControlIndication >-----#
    FlowControlIndication = SEQ(name='FlowControlIndication', mode=MODE_TYPE)
    _FlowControlIndication_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FlowControlIndication_scope_logicalChannelNumber = INT(name='logicalChannelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MULTIMEDIA-SYSTEM-CONTROL', 'LogicalChannelNumber')))
    __FlowControlIndication_scope_resourceID = INT(name='resourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FlowControlIndication_scope_resourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __FlowControlIndication_scope_wholeMultiplex = NULL(name='wholeMultiplex', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FlowControlIndication_scope._cont = ASN1Dict([
        ('logicalChannelNumber', __FlowControlIndication_scope_logicalChannelNumber),
        ('resourceID', __FlowControlIndication_scope_resourceID),
        ('wholeMultiplex', __FlowControlIndication_scope_wholeMultiplex),
        ])
    _FlowControlIndication_scope._ext = None
    _FlowControlIndication_restriction = CHOICE(name='restriction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FlowControlIndication_restriction_maximumBitRate = INT(name='maximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FlowControlIndication_restriction_maximumBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    __FlowControlIndication_restriction_noRestriction = NULL(name='noRestriction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FlowControlIndication_restriction._cont = ASN1Dict([
        ('maximumBitRate', __FlowControlIndication_restriction_maximumBitRate),
        ('noRestriction', __FlowControlIndication_restriction_noRestriction),
        ])
    _FlowControlIndication_restriction._ext = None
    FlowControlIndication._cont = ASN1Dict([
        ('scope', _FlowControlIndication_scope),
        ('restriction', _FlowControlIndication_restriction),
        ])
    FlowControlIndication._ext = []
    
    #-----< MobileMultilinkReconfigurationIndication >-----#
    MobileMultilinkReconfigurationIndication = SEQ(name='MobileMultilinkReconfigurationIndication', mode=MODE_TYPE)
    _MobileMultilinkReconfigurationIndication_sampleSize = INT(name='sampleSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobileMultilinkReconfigurationIndication_sampleSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _MobileMultilinkReconfigurationIndication_samplesPerFrame = INT(name='samplesPerFrame', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobileMultilinkReconfigurationIndication_samplesPerFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    MobileMultilinkReconfigurationIndication._cont = ASN1Dict([
        ('sampleSize', _MobileMultilinkReconfigurationIndication_sampleSize),
        ('samplesPerFrame', _MobileMultilinkReconfigurationIndication_samplesPerFrame),
        ])
    MobileMultilinkReconfigurationIndication._ext = []
    
    _all_ = [
        _MultimediaSystemControlMessage_request,
        _MultimediaSystemControlMessage_response,
        _MultimediaSystemControlMessage_command,
        _MultimediaSystemControlMessage_indication,
        MultimediaSystemControlMessage,
        _RequestMessage_nonStandard,
        _RequestMessage_masterSlaveDetermination,
        _RequestMessage_terminalCapabilitySet,
        _RequestMessage_openLogicalChannel,
        _RequestMessage_closeLogicalChannel,
        _RequestMessage_requestChannelClose,
        _RequestMessage_multiplexEntrySend,
        _RequestMessage_requestMultiplexEntry,
        _RequestMessage_requestMode,
        _RequestMessage_roundTripDelayRequest,
        _RequestMessage_maintenanceLoopRequest,
        _RequestMessage_communicationModeRequest,
        _RequestMessage_conferenceRequest,
        _RequestMessage_multilinkRequest,
        _RequestMessage_logicalChannelRateRequest,
        _RequestMessage_genericRequest,
        RequestMessage,
        _ResponseMessage_nonStandard,
        _ResponseMessage_masterSlaveDeterminationAck,
        _ResponseMessage_masterSlaveDeterminationReject,
        _ResponseMessage_terminalCapabilitySetAck,
        _ResponseMessage_terminalCapabilitySetReject,
        _ResponseMessage_openLogicalChannelAck,
        _ResponseMessage_openLogicalChannelReject,
        _ResponseMessage_closeLogicalChannelAck,
        _ResponseMessage_requestChannelCloseAck,
        _ResponseMessage_requestChannelCloseReject,
        _ResponseMessage_multiplexEntrySendAck,
        _ResponseMessage_multiplexEntrySendReject,
        _ResponseMessage_requestMultiplexEntryAck,
        _ResponseMessage_requestMultiplexEntryReject,
        _ResponseMessage_requestModeAck,
        _ResponseMessage_requestModeReject,
        _ResponseMessage_roundTripDelayResponse,
        _ResponseMessage_maintenanceLoopAck,
        _ResponseMessage_maintenanceLoopReject,
        _ResponseMessage_communicationModeResponse,
        _ResponseMessage_conferenceResponse,
        _ResponseMessage_multilinkResponse,
        _ResponseMessage_logicalChannelRateAcknowledge,
        _ResponseMessage_logicalChannelRateReject,
        _ResponseMessage_genericResponse,
        ResponseMessage,
        _CommandMessage_nonStandard,
        _CommandMessage_maintenanceLoopOffCommand,
        _CommandMessage_sendTerminalCapabilitySet,
        _CommandMessage_encryptionCommand,
        _CommandMessage_flowControlCommand,
        _CommandMessage_endSessionCommand,
        _CommandMessage_miscellaneousCommand,
        _CommandMessage_communicationModeCommand,
        _CommandMessage_conferenceCommand,
        _CommandMessage_h223MultiplexReconfiguration,
        _CommandMessage_newATMVCCommand,
        _CommandMessage_mobileMultilinkReconfigurationCommand,
        _CommandMessage_genericCommand,
        CommandMessage,
        _IndicationMessage_nonStandard,
        _IndicationMessage_functionNotUnderstood,
        _IndicationMessage_masterSlaveDeterminationRelease,
        _IndicationMessage_terminalCapabilitySetRelease,
        _IndicationMessage_openLogicalChannelConfirm,
        _IndicationMessage_requestChannelCloseRelease,
        _IndicationMessage_multiplexEntrySendRelease,
        _IndicationMessage_requestMultiplexEntryRelease,
        _IndicationMessage_requestModeRelease,
        _IndicationMessage_miscellaneousIndication,
        _IndicationMessage_jitterIndication,
        _IndicationMessage_h223SkewIndication,
        _IndicationMessage_newATMVCIndication,
        _IndicationMessage_userInput,
        _IndicationMessage_h2250MaximumSkewIndication,
        _IndicationMessage_mcLocationIndication,
        _IndicationMessage_conferenceIndication,
        _IndicationMessage_vendorIdentification,
        _IndicationMessage_functionNotSupported,
        _IndicationMessage_multilinkIndication,
        _IndicationMessage_logicalChannelRateRelease,
        _IndicationMessage_flowControlIndication,
        _IndicationMessage_mobileMultilinkReconfigurationIndication,
        _IndicationMessage_genericIndication,
        IndicationMessage,
        SequenceNumber,
        _GenericMessage_messageIdentifier,
        _GenericMessage_subMessageIdentifier,
        __GenericMessage_messageContent__item_,
        _GenericMessage_messageContent,
        GenericMessage,
        GenericInformation,
        _NonStandardMessage_nonStandardData,
        NonStandardMessage,
        _NonStandardParameter_nonStandardIdentifier,
        _NonStandardParameter_data,
        NonStandardParameter,
        _NonStandardIdentifier_object,
        __NonStandardIdentifier_h221NonStandard_t35CountryCode,
        __NonStandardIdentifier_h221NonStandard_t35Extension,
        __NonStandardIdentifier_h221NonStandard_manufacturerCode,
        _NonStandardIdentifier_h221NonStandard,
        NonStandardIdentifier,
        _MasterSlaveDetermination_terminalType,
        _MasterSlaveDetermination_statusDeterminationNumber,
        MasterSlaveDetermination,
        __MasterSlaveDeterminationAck_decision_master,
        __MasterSlaveDeterminationAck_decision_slave,
        _MasterSlaveDeterminationAck_decision,
        MasterSlaveDeterminationAck,
        __MasterSlaveDeterminationReject_cause_identicalNumbers,
        _MasterSlaveDeterminationReject_cause,
        MasterSlaveDeterminationReject,
        MasterSlaveDeterminationRelease,
        _TerminalCapabilitySet_sequenceNumber,
        _TerminalCapabilitySet_protocolIdentifier,
        _TerminalCapabilitySet_multiplexCapability,
        __TerminalCapabilitySet_capabilityTable__item_,
        _TerminalCapabilitySet_capabilityTable,
        __TerminalCapabilitySet_capabilityDescriptors__item_,
        _TerminalCapabilitySet_capabilityDescriptors,
        __TerminalCapabilitySet_genericInformation__item_,
        _TerminalCapabilitySet_genericInformation,
        TerminalCapabilitySet,
        _CapabilityTableEntry_capabilityTableEntryNumber,
        _CapabilityTableEntry_capability,
        CapabilityTableEntry,
        _CapabilityDescriptor_capabilityDescriptorNumber,
        __CapabilityDescriptor_simultaneousCapabilities__item_,
        _CapabilityDescriptor_simultaneousCapabilities,
        CapabilityDescriptor,
        _AlternativeCapabilitySet__item_,
        AlternativeCapabilitySet,
        CapabilityTableEntryNumber,
        CapabilityDescriptorNumber,
        _TerminalCapabilitySetAck_sequenceNumber,
        __TerminalCapabilitySetAck_genericInformation__item_,
        _TerminalCapabilitySetAck_genericInformation,
        TerminalCapabilitySetAck,
        _TerminalCapabilitySetReject_sequenceNumber,
        __TerminalCapabilitySetReject_cause_unspecified,
        __TerminalCapabilitySetReject_cause_undefinedTableEntryUsed,
        __TerminalCapabilitySetReject_cause_descriptorCapacityExceeded,
        ___TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded_highestEntryNumberProcessed,
        ___TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded_noneProcessed,
        __TerminalCapabilitySetReject_cause_tableEntryCapacityExceeded,
        _TerminalCapabilitySetReject_cause,
        __TerminalCapabilitySetReject_genericInformation__item_,
        _TerminalCapabilitySetReject_genericInformation,
        TerminalCapabilitySetReject,
        __TerminalCapabilitySetRelease_genericInformation__item_,
        _TerminalCapabilitySetRelease_genericInformation,
        TerminalCapabilitySetRelease,
        _Capability_nonStandard,
        _Capability_receiveVideoCapability,
        _Capability_transmitVideoCapability,
        _Capability_receiveAndTransmitVideoCapability,
        _Capability_receiveAudioCapability,
        _Capability_transmitAudioCapability,
        _Capability_receiveAndTransmitAudioCapability,
        _Capability_receiveDataApplicationCapability,
        _Capability_transmitDataApplicationCapability,
        _Capability_receiveAndTransmitDataApplicationCapability,
        _Capability_h233EncryptionTransmitCapability,
        __Capability_h233EncryptionReceiveCapability_h233IVResponseTime,
        _Capability_h233EncryptionReceiveCapability,
        _Capability_conferenceCapability,
        _Capability_h235SecurityCapability,
        _Capability_maxPendingReplacementFor,
        _Capability_receiveUserInputCapability,
        _Capability_transmitUserInputCapability,
        _Capability_receiveAndTransmitUserInputCapability,
        _Capability_genericControlCapability,
        _Capability_receiveMultiplexedStreamCapability,
        _Capability_transmitMultiplexedStreamCapability,
        _Capability_receiveAndTransmitMultiplexedStreamCapability,
        _Capability_receiveRTPAudioTelephonyEventCapability,
        _Capability_receiveRTPAudioToneCapability,
        _Capability_depFecCapability,
        _Capability_multiplePayloadStreamCapability,
        _Capability_fecCapability,
        _Capability_redundancyEncodingCap,
        _Capability_oneOfCapabilities,
        Capability,
        _H235SecurityCapability_encryptionAuthenticationAndIntegrity,
        _H235SecurityCapability_mediaCapability,
        H235SecurityCapability,
        _MultiplexCapability_nonStandard,
        _MultiplexCapability_h222Capability,
        _MultiplexCapability_h223Capability,
        _MultiplexCapability_v76Capability,
        _MultiplexCapability_h2250Capability,
        _MultiplexCapability_genericMultiplexCapability,
        MultiplexCapability,
        _H222Capability_numberOfVCs,
        __H222Capability_vcCapability__item_,
        _H222Capability_vcCapability,
        H222Capability,
        __VCCapability_aal1_nullClockRecovery,
        __VCCapability_aal1_srtsClockRecovery,
        __VCCapability_aal1_adaptiveClockRecovery,
        __VCCapability_aal1_nullErrorCorrection,
        __VCCapability_aal1_longInterleaver,
        __VCCapability_aal1_shortInterleaver,
        __VCCapability_aal1_errorCorrectionOnly,
        __VCCapability_aal1_structuredDataTransfer,
        __VCCapability_aal1_partiallyFilledCells,
        _VCCapability_aal1,
        __VCCapability_aal5_forwardMaximumSDUSize,
        __VCCapability_aal5_backwardMaximumSDUSize,
        _VCCapability_aal5,
        _VCCapability_transportStream,
        _VCCapability_programStream,
        ___VCCapability_availableBitRates_type_singleBitRate,
        ____VCCapability_availableBitRates_type_rangeOfBitRates_lowerBitRate,
        ____VCCapability_availableBitRates_type_rangeOfBitRates_higherBitRate,
        ___VCCapability_availableBitRates_type_rangeOfBitRates,
        __VCCapability_availableBitRates_type,
        _VCCapability_availableBitRates,
        ___VCCapability_aal1ViaGateway_gatewayAddress__item_,
        __VCCapability_aal1ViaGateway_gatewayAddress,
        __VCCapability_aal1ViaGateway_nullClockRecovery,
        __VCCapability_aal1ViaGateway_srtsClockRecovery,
        __VCCapability_aal1ViaGateway_adaptiveClockRecovery,
        __VCCapability_aal1ViaGateway_nullErrorCorrection,
        __VCCapability_aal1ViaGateway_longInterleaver,
        __VCCapability_aal1ViaGateway_shortInterleaver,
        __VCCapability_aal1ViaGateway_errorCorrectionOnly,
        __VCCapability_aal1ViaGateway_structuredDataTransfer,
        __VCCapability_aal1ViaGateway_partiallyFilledCells,
        _VCCapability_aal1ViaGateway,
        VCCapability,
        _H223Capability_transportWithI_frames,
        _H223Capability_videoWithAL1,
        _H223Capability_videoWithAL2,
        _H223Capability_videoWithAL3,
        _H223Capability_audioWithAL1,
        _H223Capability_audioWithAL2,
        _H223Capability_audioWithAL3,
        _H223Capability_dataWithAL1,
        _H223Capability_dataWithAL2,
        _H223Capability_dataWithAL3,
        _H223Capability_maximumAl2SDUSize,
        _H223Capability_maximumAl3SDUSize,
        _H223Capability_maximumDelayJitter,
        __H223Capability_h223MultiplexTableCapability_basic,
        ___H223Capability_h223MultiplexTableCapability_enhanced_maximumNestingDepth,
        ___H223Capability_h223MultiplexTableCapability_enhanced_maximumElementListSize,
        ___H223Capability_h223MultiplexTableCapability_enhanced_maximumSubElementListSize,
        __H223Capability_h223MultiplexTableCapability_enhanced,
        _H223Capability_h223MultiplexTableCapability,
        _H223Capability_maxMUXPDUSizeCapability,
        _H223Capability_nsrpSupport,
        __H223Capability_mobileOperationTransmitCapability_modeChangeCapability,
        __H223Capability_mobileOperationTransmitCapability_h223AnnexA,
        __H223Capability_mobileOperationTransmitCapability_h223AnnexADoubleFlag,
        __H223Capability_mobileOperationTransmitCapability_h223AnnexB,
        __H223Capability_mobileOperationTransmitCapability_h223AnnexBwithHeader,
        _H223Capability_mobileOperationTransmitCapability,
        _H223Capability_h223AnnexCCapability,
        _H223Capability_bitRate,
        __H223Capability_mobileMultilinkFrameCapability_maximumSampleSize,
        __H223Capability_mobileMultilinkFrameCapability_maximumPayloadLength,
        _H223Capability_mobileMultilinkFrameCapability,
        H223Capability,
        _H223AnnexCCapability_videoWithAL1M,
        _H223AnnexCCapability_videoWithAL2M,
        _H223AnnexCCapability_videoWithAL3M,
        _H223AnnexCCapability_audioWithAL1M,
        _H223AnnexCCapability_audioWithAL2M,
        _H223AnnexCCapability_audioWithAL3M,
        _H223AnnexCCapability_dataWithAL1M,
        _H223AnnexCCapability_dataWithAL2M,
        _H223AnnexCCapability_dataWithAL3M,
        _H223AnnexCCapability_alpduInterleaving,
        _H223AnnexCCapability_maximumAL1MPDUSize,
        _H223AnnexCCapability_maximumAL2MSDUSize,
        _H223AnnexCCapability_maximumAL3MSDUSize,
        _H223AnnexCCapability_rsCodeCapability,
        H223AnnexCCapability,
        _V76Capability_suspendResumeCapabilitywAddress,
        _V76Capability_suspendResumeCapabilitywoAddress,
        _V76Capability_rejCapability,
        _V76Capability_sREJCapability,
        _V76Capability_mREJCapability,
        _V76Capability_crc8bitCapability,
        _V76Capability_crc16bitCapability,
        _V76Capability_crc32bitCapability,
        _V76Capability_uihCapability,
        _V76Capability_numOfDLCS,
        _V76Capability_twoOctetAddressFieldCapability,
        _V76Capability_loopBackTestCapability,
        _V76Capability_n401Capability,
        _V76Capability_maxWindowSizeCapability,
        _V76Capability_v75Capability,
        V76Capability,
        _V75Capability_audioHeader,
        V75Capability,
        _H2250Capability_maximumAudioDelayJitter,
        _H2250Capability_receiveMultipointCapability,
        _H2250Capability_transmitMultipointCapability,
        _H2250Capability_receiveAndTransmitMultipointCapability,
        __H2250Capability_mcCapability_centralizedConferenceMC,
        __H2250Capability_mcCapability_decentralizedConferenceMC,
        _H2250Capability_mcCapability,
        _H2250Capability_rtcpVideoControlCapability,
        _H2250Capability_mediaPacketizationCapability,
        _H2250Capability_transportCapability,
        __H2250Capability_redundancyEncodingCapability__item_,
        _H2250Capability_redundancyEncodingCapability,
        _H2250Capability_logicalChannelSwitchingCapability,
        _H2250Capability_t120DynamicPortCapability,
        H2250Capability,
        _MediaPacketizationCapability_h261aVideoPacketization,
        __MediaPacketizationCapability_rtpPayloadType__item_,
        _MediaPacketizationCapability_rtpPayloadType,
        MediaPacketizationCapability,
        _RSVPParameters_qosMode,
        _RSVPParameters_tokenRate,
        _RSVPParameters_bucketSize,
        _RSVPParameters_peakRate,
        _RSVPParameters_minPoliced,
        _RSVPParameters_maxPktSize,
        RSVPParameters,
        _QOSMode_guaranteedQOS,
        _QOSMode_controlledLoad,
        QOSMode,
        _ATMParameters_maxNTUSize,
        _ATMParameters_atmUBR,
        _ATMParameters_atmrtVBR,
        _ATMParameters_atmnrtVBR,
        _ATMParameters_atmABR,
        _ATMParameters_atmCBR,
        ATMParameters,
        _ServicePriorityValue_nonStandardParameter,
        _ServicePriorityValue_value,
        ServicePriorityValue,
        _ServicePriority_nonStandardData,
        _ServicePriority_servicePrioritySignalled,
        _ServicePriority_servicePriorityValue,
        _ServicePriority_serviceClass,
        _ServicePriority_serviceSubclass,
        ServicePriority,
        _AuthorizationParameters_nonStandardData,
        AuthorizationParameters,
        _QOSType_desired,
        _QOSType_required,
        QOSType,
        _QOSClass_class0,
        _QOSClass_class1,
        _QOSClass_class2,
        _QOSClass_class3,
        _QOSClass_class4,
        _QOSClass_class5,
        QOSClass,
        _QOSDescriptor_nonStandardData,
        _QOSDescriptor_qosType,
        _QOSDescriptor_qosClass,
        QOSDescriptor,
        _GenericTransportParameters_nonStandardData,
        _GenericTransportParameters_averageRate,
        _GenericTransportParameters_burst,
        _GenericTransportParameters_peakRate,
        _GenericTransportParameters_maxPktSize,
        GenericTransportParameters,
        _QOSCapability_nonStandardData,
        _QOSCapability_rsvpParameters,
        _QOSCapability_atmParameters,
        _QOSCapability_localQoS,
        _QOSCapability_genericTransportParameters,
        _QOSCapability_servicePriority,
        _QOSCapability_authorizationParameter,
        _QOSCapability_qosDescriptor,
        _QOSCapability_dscpValue,
        QOSCapability,
        _MediaTransportType_ip_UDP,
        _MediaTransportType_ip_TCP,
        _MediaTransportType_atm_AAL5_UNIDIR,
        _MediaTransportType_atm_AAL5_BIDIR,
        __MediaTransportType_atm_AAL5_compressed_variable_delta,
        _MediaTransportType_atm_AAL5_compressed,
        MediaTransportType,
        _MediaChannelCapability_mediaTransport,
        MediaChannelCapability,
        _TransportCapability_nonStandard,
        __TransportCapability_qOSCapabilities__item_,
        _TransportCapability_qOSCapabilities,
        __TransportCapability_mediaChannelCapabilities__item_,
        _TransportCapability_mediaChannelCapabilities,
        TransportCapability,
        _RedundancyEncodingCapability_redundancyEncodingMethod,
        _RedundancyEncodingCapability_primaryEncoding,
        __RedundancyEncodingCapability_secondaryEncoding__item_,
        _RedundancyEncodingCapability_secondaryEncoding,
        RedundancyEncodingCapability,
        _RedundancyEncodingMethod_nonStandard,
        _RedundancyEncodingMethod_rtpAudioRedundancyEncoding,
        _RedundancyEncodingMethod_rtpH263VideoRedundancyEncoding,
        RedundancyEncodingMethod,
        _RTPH263VideoRedundancyEncoding_numberOfThreads,
        _RTPH263VideoRedundancyEncoding_framesBetweenSyncPoints,
        __RTPH263VideoRedundancyEncoding_frameToThreadMapping_roundrobin,
        ___RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom__item_,
        __RTPH263VideoRedundancyEncoding_frameToThreadMapping_custom,
        _RTPH263VideoRedundancyEncoding_frameToThreadMapping,
        __RTPH263VideoRedundancyEncoding_containedThreads__item_,
        _RTPH263VideoRedundancyEncoding_containedThreads,
        RTPH263VideoRedundancyEncoding,
        _RTPH263VideoRedundancyFrameMapping_threadNumber,
        __RTPH263VideoRedundancyFrameMapping_frameSequence__item_,
        _RTPH263VideoRedundancyFrameMapping_frameSequence,
        RTPH263VideoRedundancyFrameMapping,
        _MultipointCapability_multicastCapability,
        _MultipointCapability_multiUniCastConference,
        __MultipointCapability_mediaDistributionCapability__item_,
        _MultipointCapability_mediaDistributionCapability,
        MultipointCapability,
        _MediaDistributionCapability_centralizedControl,
        _MediaDistributionCapability_distributedControl,
        _MediaDistributionCapability_centralizedAudio,
        _MediaDistributionCapability_distributedAudio,
        _MediaDistributionCapability_centralizedVideo,
        _MediaDistributionCapability_distributedVideo,
        __MediaDistributionCapability_centralizedData__item_,
        _MediaDistributionCapability_centralizedData,
        __MediaDistributionCapability_distributedData__item_,
        _MediaDistributionCapability_distributedData,
        MediaDistributionCapability,
        _VideoCapability_nonStandard,
        _VideoCapability_h261VideoCapability,
        _VideoCapability_h262VideoCapability,
        _VideoCapability_h263VideoCapability,
        _VideoCapability_is11172VideoCapability,
        _VideoCapability_genericVideoCapability,
        _VideoCapability_extendedVideoCapability,
        VideoCapability,
        __ExtendedVideoCapability_videoCapability__item_,
        _ExtendedVideoCapability_videoCapability,
        __ExtendedVideoCapability_videoCapabilityExtension__item_,
        _ExtendedVideoCapability_videoCapabilityExtension,
        ExtendedVideoCapability,
        _H261VideoCapability_qcifMPI,
        _H261VideoCapability_cifMPI,
        _H261VideoCapability_temporalSpatialTradeOffCapability,
        _H261VideoCapability_maxBitRate,
        _H261VideoCapability_stillImageTransmission,
        _H261VideoCapability_videoBadMBsCap,
        H261VideoCapability,
        _H262VideoCapability_profileAndLevel_SPatML,
        _H262VideoCapability_profileAndLevel_MPatLL,
        _H262VideoCapability_profileAndLevel_MPatML,
        _H262VideoCapability_profileAndLevel_MPatH_14,
        _H262VideoCapability_profileAndLevel_MPatHL,
        _H262VideoCapability_profileAndLevel_SNRatLL,
        _H262VideoCapability_profileAndLevel_SNRatML,
        _H262VideoCapability_profileAndLevel_SpatialatH_14,
        _H262VideoCapability_profileAndLevel_HPatML,
        _H262VideoCapability_profileAndLevel_HPatH_14,
        _H262VideoCapability_profileAndLevel_HPatHL,
        _H262VideoCapability_videoBitRate,
        _H262VideoCapability_vbvBufferSize,
        _H262VideoCapability_samplesPerLine,
        _H262VideoCapability_linesPerFrame,
        _H262VideoCapability_framesPerSecond,
        _H262VideoCapability_luminanceSampleRate,
        _H262VideoCapability_videoBadMBsCap,
        H262VideoCapability,
        _H263VideoCapability_sqcifMPI,
        _H263VideoCapability_qcifMPI,
        _H263VideoCapability_cifMPI,
        _H263VideoCapability_cif4MPI,
        _H263VideoCapability_cif16MPI,
        _H263VideoCapability_maxBitRate,
        _H263VideoCapability_unrestrictedVector,
        _H263VideoCapability_arithmeticCoding,
        _H263VideoCapability_advancedPrediction,
        _H263VideoCapability_pbFrames,
        _H263VideoCapability_temporalSpatialTradeOffCapability,
        _H263VideoCapability_hrd_B,
        _H263VideoCapability_bppMaxKb,
        _H263VideoCapability_slowSqcifMPI,
        _H263VideoCapability_slowQcifMPI,
        _H263VideoCapability_slowCifMPI,
        _H263VideoCapability_slowCif4MPI,
        _H263VideoCapability_slowCif16MPI,
        _H263VideoCapability_errorCompensation,
        _H263VideoCapability_enhancementLayerInfo,
        _H263VideoCapability_h263Options,
        H263VideoCapability,
        _EnhancementLayerInfo_baseBitRateConstrained,
        __EnhancementLayerInfo_snrEnhancement__item_,
        _EnhancementLayerInfo_snrEnhancement,
        __EnhancementLayerInfo_spatialEnhancement__item_,
        _EnhancementLayerInfo_spatialEnhancement,
        __EnhancementLayerInfo_bPictureEnhancement__item_,
        _EnhancementLayerInfo_bPictureEnhancement,
        EnhancementLayerInfo,
        _BEnhancementParameters_enhancementOptions,
        _BEnhancementParameters_numberOfBPictures,
        BEnhancementParameters,
        _EnhancementOptions_sqcifMPI,
        _EnhancementOptions_qcifMPI,
        _EnhancementOptions_cifMPI,
        _EnhancementOptions_cif4MPI,
        _EnhancementOptions_cif16MPI,
        _EnhancementOptions_maxBitRate,
        _EnhancementOptions_unrestrictedVector,
        _EnhancementOptions_arithmeticCoding,
        _EnhancementOptions_temporalSpatialTradeOffCapability,
        _EnhancementOptions_slowSqcifMPI,
        _EnhancementOptions_slowQcifMPI,
        _EnhancementOptions_slowCifMPI,
        _EnhancementOptions_slowCif4MPI,
        _EnhancementOptions_slowCif16MPI,
        _EnhancementOptions_errorCompensation,
        _EnhancementOptions_h263Options,
        EnhancementOptions,
        _H263Options_advancedIntraCodingMode,
        _H263Options_deblockingFilterMode,
        _H263Options_improvedPBFramesMode,
        _H263Options_unlimitedMotionVectors,
        _H263Options_fullPictureFreeze,
        _H263Options_partialPictureFreezeAndRelease,
        _H263Options_resizingPartPicFreezeAndRelease,
        _H263Options_fullPictureSnapshot,
        _H263Options_partialPictureSnapshot,
        _H263Options_videoSegmentTagging,
        _H263Options_progressiveRefinement,
        _H263Options_dynamicPictureResizingByFour,
        _H263Options_dynamicPictureResizingSixteenthPel,
        _H263Options_dynamicWarpingHalfPel,
        _H263Options_dynamicWarpingSixteenthPel,
        _H263Options_independentSegmentDecoding,
        _H263Options_slicesInOrder_NonRect,
        _H263Options_slicesInOrder_Rect,
        _H263Options_slicesNoOrder_NonRect,
        _H263Options_slicesNoOrder_Rect,
        _H263Options_alternateInterVLCMode,
        _H263Options_modifiedQuantizationMode,
        _H263Options_reducedResolutionUpdate,
        _H263Options_transparencyParameters,
        _H263Options_separateVideoBackChannel,
        _H263Options_refPictureSelection,
        __H263Options_customPictureClockFrequency__item_,
        _H263Options_customPictureClockFrequency,
        __H263Options_customPictureFormat__item_,
        _H263Options_customPictureFormat,
        __H263Options_modeCombos__item_,
        _H263Options_modeCombos,
        _H263Options_videoBadMBsCap,
        _H263Options_h263Version3Options,
        H263Options,
        _TransparencyParameters_presentationOrder,
        _TransparencyParameters_offset_x,
        _TransparencyParameters_offset_y,
        _TransparencyParameters_scale_x,
        _TransparencyParameters_scale_y,
        TransparencyParameters,
        __RefPictureSelection_additionalPictureMemory_sqcifAdditionalPictureMemory,
        __RefPictureSelection_additionalPictureMemory_qcifAdditionalPictureMemory,
        __RefPictureSelection_additionalPictureMemory_cifAdditionalPictureMemory,
        __RefPictureSelection_additionalPictureMemory_cif4AdditionalPictureMemory,
        __RefPictureSelection_additionalPictureMemory_cif16AdditionalPictureMemory,
        __RefPictureSelection_additionalPictureMemory_bigCpfAdditionalPictureMemory,
        _RefPictureSelection_additionalPictureMemory,
        _RefPictureSelection_videoMux,
        __RefPictureSelection_videoBackChannelSend_none,
        __RefPictureSelection_videoBackChannelSend_ackMessageOnly,
        __RefPictureSelection_videoBackChannelSend_nackMessageOnly,
        __RefPictureSelection_videoBackChannelSend_ackOrNackMessageOnly,
        __RefPictureSelection_videoBackChannelSend_ackAndNackMessage,
        _RefPictureSelection_videoBackChannelSend,
        ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuHorizMBs,
        ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuVertMBs,
        ___RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters_mpuTotalNumber,
        __RefPictureSelection_enhancedReferencePicSelect_subPictureRemovalParameters,
        _RefPictureSelection_enhancedReferencePicSelect,
        RefPictureSelection,
        _CustomPictureClockFrequency_clockConversionCode,
        _CustomPictureClockFrequency_clockDivisor,
        _CustomPictureClockFrequency_sqcifMPI,
        _CustomPictureClockFrequency_qcifMPI,
        _CustomPictureClockFrequency_cifMPI,
        _CustomPictureClockFrequency_cif4MPI,
        _CustomPictureClockFrequency_cif16MPI,
        CustomPictureClockFrequency,
        _CustomPictureFormat_maxCustomPictureWidth,
        _CustomPictureFormat_maxCustomPictureHeight,
        _CustomPictureFormat_minCustomPictureWidth,
        _CustomPictureFormat_minCustomPictureHeight,
        __CustomPictureFormat_mPI_standardMPI,
        ____CustomPictureFormat_mPI_customPCF__item__clockConversionCode,
        ____CustomPictureFormat_mPI_customPCF__item__clockDivisor,
        ____CustomPictureFormat_mPI_customPCF__item__customMPI,
        ___CustomPictureFormat_mPI_customPCF__item_,
        __CustomPictureFormat_mPI_customPCF,
        _CustomPictureFormat_mPI,
        __CustomPictureFormat_pixelAspectInformation_anyPixelAspectRatio,
        ___CustomPictureFormat_pixelAspectInformation_pixelAspectCode__item_,
        __CustomPictureFormat_pixelAspectInformation_pixelAspectCode,
        ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__width,
        ____CustomPictureFormat_pixelAspectInformation_extendedPAR__item__height,
        ___CustomPictureFormat_pixelAspectInformation_extendedPAR__item_,
        __CustomPictureFormat_pixelAspectInformation_extendedPAR,
        _CustomPictureFormat_pixelAspectInformation,
        CustomPictureFormat,
        _H263VideoModeCombos_h263VideoUncoupledModes,
        __H263VideoModeCombos_h263VideoCoupledModes__item_,
        _H263VideoModeCombos_h263VideoCoupledModes,
        H263VideoModeCombos,
        _H263ModeComboFlags_unrestrictedVector,
        _H263ModeComboFlags_arithmeticCoding,
        _H263ModeComboFlags_advancedPrediction,
        _H263ModeComboFlags_pbFrames,
        _H263ModeComboFlags_advancedIntraCodingMode,
        _H263ModeComboFlags_deblockingFilterMode,
        _H263ModeComboFlags_unlimitedMotionVectors,
        _H263ModeComboFlags_slicesInOrder_NonRect,
        _H263ModeComboFlags_slicesInOrder_Rect,
        _H263ModeComboFlags_slicesNoOrder_NonRect,
        _H263ModeComboFlags_slicesNoOrder_Rect,
        _H263ModeComboFlags_improvedPBFramesMode,
        _H263ModeComboFlags_referencePicSelect,
        _H263ModeComboFlags_dynamicPictureResizingByFour,
        _H263ModeComboFlags_dynamicPictureResizingSixteenthPel,
        _H263ModeComboFlags_dynamicWarpingHalfPel,
        _H263ModeComboFlags_dynamicWarpingSixteenthPel,
        _H263ModeComboFlags_reducedResolutionUpdate,
        _H263ModeComboFlags_independentSegmentDecoding,
        _H263ModeComboFlags_alternateInterVLCMode,
        _H263ModeComboFlags_modifiedQuantizationMode,
        _H263ModeComboFlags_enhancedReferencePicSelect,
        _H263ModeComboFlags_h263Version3Options,
        H263ModeComboFlags,
        _H263Version3Options_dataPartitionedSlices,
        _H263Version3Options_fixedPointIDCT0,
        _H263Version3Options_interlacedFields,
        _H263Version3Options_currentPictureHeaderRepetition,
        _H263Version3Options_previousPictureHeaderRepetition,
        _H263Version3Options_nextPictureHeaderRepetition,
        _H263Version3Options_pictureNumber,
        _H263Version3Options_spareReferencePictures,
        H263Version3Options,
        _IS11172VideoCapability_constrainedBitstream,
        _IS11172VideoCapability_videoBitRate,
        _IS11172VideoCapability_vbvBufferSize,
        _IS11172VideoCapability_samplesPerLine,
        _IS11172VideoCapability_linesPerFrame,
        _IS11172VideoCapability_pictureRate,
        _IS11172VideoCapability_luminanceSampleRate,
        _IS11172VideoCapability_videoBadMBsCap,
        IS11172VideoCapability,
        _AudioCapability_nonStandard,
        _AudioCapability_g711Alaw64k,
        _AudioCapability_g711Alaw56k,
        _AudioCapability_g711Ulaw64k,
        _AudioCapability_g711Ulaw56k,
        _AudioCapability_g722_64k,
        _AudioCapability_g722_56k,
        _AudioCapability_g722_48k,
        __AudioCapability_g7231_maxAl_sduAudioFrames,
        __AudioCapability_g7231_silenceSuppression,
        _AudioCapability_g7231,
        _AudioCapability_g728,
        _AudioCapability_g729,
        _AudioCapability_g729AnnexA,
        _AudioCapability_is11172AudioCapability,
        _AudioCapability_is13818AudioCapability,
        _AudioCapability_g729wAnnexB,
        _AudioCapability_g729AnnexAwAnnexB,
        _AudioCapability_g7231AnnexCCapability,
        _AudioCapability_gsmFullRate,
        _AudioCapability_gsmHalfRate,
        _AudioCapability_gsmEnhancedFullRate,
        _AudioCapability_genericAudioCapability,
        _AudioCapability_g729Extensions,
        _AudioCapability_vbd,
        _AudioCapability_audioTelephonyEvent,
        _AudioCapability_audioTone,
        AudioCapability,
        _G729Extensions_audioUnit,
        _G729Extensions_annexA,
        _G729Extensions_annexB,
        _G729Extensions_annexD,
        _G729Extensions_annexE,
        _G729Extensions_annexF,
        _G729Extensions_annexG,
        _G729Extensions_annexH,
        G729Extensions,
        _G7231AnnexCCapability_maxAl_sduAudioFrames,
        _G7231AnnexCCapability_silenceSuppression,
        __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode0,
        __G7231AnnexCCapability_g723AnnexCAudioMode_highRateMode1,
        __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode0,
        __G7231AnnexCCapability_g723AnnexCAudioMode_lowRateMode1,
        __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode0,
        __G7231AnnexCCapability_g723AnnexCAudioMode_sidMode1,
        _G7231AnnexCCapability_g723AnnexCAudioMode,
        G7231AnnexCCapability,
        _IS11172AudioCapability_audioLayer1,
        _IS11172AudioCapability_audioLayer2,
        _IS11172AudioCapability_audioLayer3,
        _IS11172AudioCapability_audioSampling32k,
        _IS11172AudioCapability_audioSampling44k1,
        _IS11172AudioCapability_audioSampling48k,
        _IS11172AudioCapability_singleChannel,
        _IS11172AudioCapability_twoChannels,
        _IS11172AudioCapability_bitRate,
        IS11172AudioCapability,
        _IS13818AudioCapability_audioLayer1,
        _IS13818AudioCapability_audioLayer2,
        _IS13818AudioCapability_audioLayer3,
        _IS13818AudioCapability_audioSampling16k,
        _IS13818AudioCapability_audioSampling22k05,
        _IS13818AudioCapability_audioSampling24k,
        _IS13818AudioCapability_audioSampling32k,
        _IS13818AudioCapability_audioSampling44k1,
        _IS13818AudioCapability_audioSampling48k,
        _IS13818AudioCapability_singleChannel,
        _IS13818AudioCapability_twoChannels,
        _IS13818AudioCapability_threeChannels2_1,
        _IS13818AudioCapability_threeChannels3_0,
        _IS13818AudioCapability_fourChannels2_0_2_0,
        _IS13818AudioCapability_fourChannels2_2,
        _IS13818AudioCapability_fourChannels3_1,
        _IS13818AudioCapability_fiveChannels3_0_2_0,
        _IS13818AudioCapability_fiveChannels3_2,
        _IS13818AudioCapability_lowFrequencyEnhancement,
        _IS13818AudioCapability_multilingual,
        _IS13818AudioCapability_bitRate,
        IS13818AudioCapability,
        _GSMAudioCapability_audioUnitSize,
        _GSMAudioCapability_comfortNoise,
        _GSMAudioCapability_scrambled,
        GSMAudioCapability,
        _VBDCapability_type,
        VBDCapability,
        __DataApplicationCapability_application_nonStandard,
        __DataApplicationCapability_application_t120,
        __DataApplicationCapability_application_dsm_cc,
        __DataApplicationCapability_application_userData,
        ___DataApplicationCapability_application_t84_t84Protocol,
        ___DataApplicationCapability_application_t84_t84Profile,
        __DataApplicationCapability_application_t84,
        __DataApplicationCapability_application_t434,
        __DataApplicationCapability_application_h224,
        ___DataApplicationCapability_application_nlpid_nlpidProtocol,
        ___DataApplicationCapability_application_nlpid_nlpidData,
        __DataApplicationCapability_application_nlpid,
        __DataApplicationCapability_application_dsvdControl,
        __DataApplicationCapability_application_h222DataPartitioning,
        __DataApplicationCapability_application_t30fax,
        __DataApplicationCapability_application_t140,
        ___DataApplicationCapability_application_t38fax_t38FaxProtocol,
        ___DataApplicationCapability_application_t38fax_t38FaxProfile,
        __DataApplicationCapability_application_t38fax,
        __DataApplicationCapability_application_genericDataCapability,
        _DataApplicationCapability_application,
        _DataApplicationCapability_maxBitRate,
        DataApplicationCapability,
        _DataProtocolCapability_nonStandard,
        _DataProtocolCapability_v14buffered,
        _DataProtocolCapability_v42lapm,
        _DataProtocolCapability_hdlcFrameTunnelling,
        _DataProtocolCapability_h310SeparateVCStack,
        _DataProtocolCapability_h310SingleVCStack,
        _DataProtocolCapability_transparent,
        _DataProtocolCapability_segmentationAndReassembly,
        _DataProtocolCapability_hdlcFrameTunnelingwSAR,
        _DataProtocolCapability_v120,
        _DataProtocolCapability_separateLANStack,
        __DataProtocolCapability_v76wCompression_transmitCompression,
        __DataProtocolCapability_v76wCompression_receiveCompression,
        __DataProtocolCapability_v76wCompression_transmitAndReceiveCompression,
        _DataProtocolCapability_v76wCompression,
        _DataProtocolCapability_tcp,
        _DataProtocolCapability_udp,
        DataProtocolCapability,
        _CompressionType_v42bis,
        CompressionType,
        _V42bis_numberOfCodewords,
        _V42bis_maximumStringLength,
        V42bis,
        _T84Profile_t84Unrestricted,
        __T84Profile_t84Restricted_qcif,
        __T84Profile_t84Restricted_cif,
        __T84Profile_t84Restricted_ccir601Seq,
        __T84Profile_t84Restricted_ccir601Prog,
        __T84Profile_t84Restricted_hdtvSeq,
        __T84Profile_t84Restricted_hdtvProg,
        __T84Profile_t84Restricted_g3FacsMH200x100,
        __T84Profile_t84Restricted_g3FacsMH200x200,
        __T84Profile_t84Restricted_g4FacsMMR200x100,
        __T84Profile_t84Restricted_g4FacsMMR200x200,
        __T84Profile_t84Restricted_jbig200x200Seq,
        __T84Profile_t84Restricted_jbig200x200Prog,
        __T84Profile_t84Restricted_jbig300x300Seq,
        __T84Profile_t84Restricted_jbig300x300Prog,
        __T84Profile_t84Restricted_digPhotoLow,
        __T84Profile_t84Restricted_digPhotoMedSeq,
        __T84Profile_t84Restricted_digPhotoMedProg,
        __T84Profile_t84Restricted_digPhotoHighSeq,
        __T84Profile_t84Restricted_digPhotoHighProg,
        _T84Profile_t84Restricted,
        T84Profile,
        _T38FaxProfile_fillBitRemoval,
        _T38FaxProfile_transcodingJBIG,
        _T38FaxProfile_transcodingMMR,
        _T38FaxProfile_version,
        _T38FaxProfile_t38FaxRateManagement,
        _T38FaxProfile_t38FaxUdpOptions,
        _T38FaxProfile_t38FaxTcpOptions,
        T38FaxProfile,
        _T38FaxRateManagement_localTCF,
        _T38FaxRateManagement_transferredTCF,
        T38FaxRateManagement,
        _T38FaxUdpOptions_t38FaxMaxBuffer,
        _T38FaxUdpOptions_t38FaxMaxDatagram,
        __T38FaxUdpOptions_t38FaxUdpEC_t38UDPFEC,
        __T38FaxUdpOptions_t38FaxUdpEC_t38UDPRedundancy,
        _T38FaxUdpOptions_t38FaxUdpEC,
        T38FaxUdpOptions,
        _T38FaxTcpOptions_t38TCPBidirectionalMode,
        T38FaxTcpOptions,
        _EncryptionAuthenticationAndIntegrity_encryptionCapability,
        _EncryptionAuthenticationAndIntegrity_authenticationCapability,
        _EncryptionAuthenticationAndIntegrity_integrityCapability,
        _EncryptionAuthenticationAndIntegrity_genericH235SecurityCapability,
        EncryptionAuthenticationAndIntegrity,
        _EncryptionCapability__item_,
        EncryptionCapability,
        _MediaEncryptionAlgorithm_nonStandard,
        _MediaEncryptionAlgorithm_algorithm,
        MediaEncryptionAlgorithm,
        _AuthenticationCapability_nonStandard,
        _AuthenticationCapability_antiSpamAlgorithm,
        AuthenticationCapability,
        _IntegrityCapability_nonStandard,
        IntegrityCapability,
        __UserInputCapability_nonStandard__item_,
        _UserInputCapability_nonStandard,
        _UserInputCapability_basicString,
        _UserInputCapability_iA5String,
        _UserInputCapability_generalString,
        _UserInputCapability_dtmf,
        _UserInputCapability_hookflash,
        _UserInputCapability_extendedAlphanumeric,
        _UserInputCapability_encryptedBasicString,
        _UserInputCapability_encryptedIA5String,
        _UserInputCapability_encryptedGeneralString,
        _UserInputCapability_secureDTMF,
        _UserInputCapability_genericUserInputCapability,
        UserInputCapability,
        __ConferenceCapability_nonStandardData__item_,
        _ConferenceCapability_nonStandardData,
        _ConferenceCapability_chairControlCapability,
        _ConferenceCapability_videoIndicateMixingCapability,
        _ConferenceCapability_multipointVisualizationCapability,
        ConferenceCapability,
        _GenericCapability_capabilityIdentifier,
        _GenericCapability_maxBitRate,
        __GenericCapability_collapsing__item_,
        _GenericCapability_collapsing,
        __GenericCapability_nonCollapsing__item_,
        _GenericCapability_nonCollapsing,
        _GenericCapability_nonCollapsingRaw,
        _GenericCapability_transport,
        GenericCapability,
        _CapabilityIdentifier_standard,
        _CapabilityIdentifier_h221NonStandard,
        _CapabilityIdentifier_uuid,
        _CapabilityIdentifier_domainBased,
        CapabilityIdentifier,
        _GenericParameter_parameterIdentifier,
        _GenericParameter_parameterValue,
        __GenericParameter_supersedes__item_,
        _GenericParameter_supersedes,
        GenericParameter,
        _ParameterIdentifier_standard,
        _ParameterIdentifier_h221NonStandard,
        _ParameterIdentifier_uuid,
        _ParameterIdentifier_domainBased,
        ParameterIdentifier,
        _ParameterValue_logical,
        _ParameterValue_booleanArray,
        _ParameterValue_unsignedMin,
        _ParameterValue_unsignedMax,
        _ParameterValue_unsigned32Min,
        _ParameterValue_unsigned32Max,
        _ParameterValue_octetString,
        __ParameterValue_genericParameter__item_,
        _ParameterValue_genericParameter,
        ParameterValue,
        _MultiplexedStreamCapability_multiplexFormat,
        _MultiplexedStreamCapability_controlOnMuxStream,
        __MultiplexedStreamCapability_capabilityOnMuxStream__item_,
        _MultiplexedStreamCapability_capabilityOnMuxStream,
        MultiplexedStreamCapability,
        _MultiplexFormat_nonStandard,
        _MultiplexFormat_h222Capability,
        _MultiplexFormat_h223Capability,
        MultiplexFormat,
        _AudioTelephonyEventCapability_dynamicRTPPayloadType,
        _AudioTelephonyEventCapability_audioTelephoneEvent,
        AudioTelephonyEventCapability,
        _AudioToneCapability_dynamicRTPPayloadType,
        AudioToneCapability,
        _NoPTAudioTelephonyEventCapability_audioTelephoneEvent,
        NoPTAudioTelephonyEventCapability,
        NoPTAudioToneCapability,
        __MultiplePayloadStreamCapability_capabilities__item_,
        _MultiplePayloadStreamCapability_capabilities,
        MultiplePayloadStreamCapability,
        __DepFECCapability_rfc2733_redundancyEncoding,
        ___DepFECCapability_rfc2733_separateStream_separatePort,
        ___DepFECCapability_rfc2733_separateStream_samePort,
        __DepFECCapability_rfc2733_separateStream,
        _DepFECCapability_rfc2733,
        DepFECCapability,
        _FECCapability_protectedCapability,
        _FECCapability_fecScheme,
        __FECCapability_rfc2733Format_rfc2733rfc2198,
        __FECCapability_rfc2733Format_rfc2733sameport,
        __FECCapability_rfc2733Format_rfc2733diffport,
        _FECCapability_rfc2733Format,
        FECCapability,
        MaxRedundancy,
        _OpenLogicalChannel_forwardLogicalChannelNumber,
        __OpenLogicalChannel_forwardLogicalChannelParameters_portNumber,
        __OpenLogicalChannel_forwardLogicalChannelParameters_dataType,
        ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h222LogicalChannelParameters,
        ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h223LogicalChannelParameters,
        ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_v76LogicalChannelParameters,
        ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters,
        ___OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters_none,
        __OpenLogicalChannel_forwardLogicalChannelParameters_multiplexParameters,
        __OpenLogicalChannel_forwardLogicalChannelParameters_forwardLogicalChannelDependency,
        __OpenLogicalChannel_forwardLogicalChannelParameters_replacementFor,
        _OpenLogicalChannel_forwardLogicalChannelParameters,
        __OpenLogicalChannel_reverseLogicalChannelParameters_dataType,
        ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_h223LogicalChannelParameters,
        ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_v76LogicalChannelParameters,
        ___OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters,
        __OpenLogicalChannel_reverseLogicalChannelParameters_multiplexParameters,
        __OpenLogicalChannel_reverseLogicalChannelParameters_reverseLogicalChannelDependency,
        __OpenLogicalChannel_reverseLogicalChannelParameters_replacementFor,
        _OpenLogicalChannel_reverseLogicalChannelParameters,
        _OpenLogicalChannel_separateStack,
        _OpenLogicalChannel_encryptionSync,
        __OpenLogicalChannel_genericInformation__item_,
        _OpenLogicalChannel_genericInformation,
        OpenLogicalChannel,
        LogicalChannelNumber,
        __NetworkAccessParameters_distribution_unicast,
        __NetworkAccessParameters_distribution_multicast,
        _NetworkAccessParameters_distribution,
        __NetworkAccessParameters_networkAddress_q2931Address,
        __NetworkAccessParameters_networkAddress_e164Address,
        __NetworkAccessParameters_networkAddress_localAreaAddress,
        _NetworkAccessParameters_networkAddress,
        _NetworkAccessParameters_associateConference,
        _NetworkAccessParameters_externalReference,
        __NetworkAccessParameters_t120SetupProcedure_originateCall,
        __NetworkAccessParameters_t120SetupProcedure_waitForCall,
        __NetworkAccessParameters_t120SetupProcedure_issueQuery,
        _NetworkAccessParameters_t120SetupProcedure,
        NetworkAccessParameters,
        __Q2931Address_address_internationalNumber,
        __Q2931Address_address_nsapAddress,
        _Q2931Address_address,
        _Q2931Address_subaddress,
        Q2931Address,
        _V75Parameters_audioHeaderPresent,
        V75Parameters,
        _DataType_nonStandard,
        _DataType_nullData,
        _DataType_videoData,
        _DataType_audioData,
        _DataType_data,
        _DataType_encryptionData,
        _DataType_h235Control,
        _DataType_h235Media,
        _DataType_multiplexedStream,
        _DataType_redundancyEncoding,
        _DataType_multiplePayloadStream,
        _DataType_depFec,
        _DataType_fec,
        DataType,
        _H235Media_encryptionAuthenticationAndIntegrity,
        __H235Media_mediaType_nonStandard,
        __H235Media_mediaType_videoData,
        __H235Media_mediaType_audioData,
        __H235Media_mediaType_data,
        __H235Media_mediaType_redundancyEncoding,
        __H235Media_mediaType_multiplePayloadStream,
        __H235Media_mediaType_depFec,
        __H235Media_mediaType_fec,
        _H235Media_mediaType,
        H235Media,
        _MultiplexedStreamParameter_multiplexFormat,
        _MultiplexedStreamParameter_controlOnMuxStream,
        MultiplexedStreamParameter,
        _H222LogicalChannelParameters_resourceID,
        _H222LogicalChannelParameters_subChannelID,
        _H222LogicalChannelParameters_pcr_pid,
        _H222LogicalChannelParameters_programDescriptors,
        _H222LogicalChannelParameters_streamDescriptors,
        H222LogicalChannelParameters,
        __H223LogicalChannelParameters_adaptationLayerType_nonStandard,
        __H223LogicalChannelParameters_adaptationLayerType_al1Framed,
        __H223LogicalChannelParameters_adaptationLayerType_al1NotFramed,
        __H223LogicalChannelParameters_adaptationLayerType_al2WithoutSequenceNumbers,
        __H223LogicalChannelParameters_adaptationLayerType_al2WithSequenceNumbers,
        ___H223LogicalChannelParameters_adaptationLayerType_al3_controlFieldOctets,
        ___H223LogicalChannelParameters_adaptationLayerType_al3_sendBufferSize,
        __H223LogicalChannelParameters_adaptationLayerType_al3,
        __H223LogicalChannelParameters_adaptationLayerType_al1M,
        __H223LogicalChannelParameters_adaptationLayerType_al2M,
        __H223LogicalChannelParameters_adaptationLayerType_al3M,
        _H223LogicalChannelParameters_adaptationLayerType,
        _H223LogicalChannelParameters_segmentableFlag,
        H223LogicalChannelParameters,
        __H223AL1MParameters_transferMode_framed,
        __H223AL1MParameters_transferMode_unframed,
        _H223AL1MParameters_transferMode,
        __H223AL1MParameters_headerFEC_sebch16_7,
        __H223AL1MParameters_headerFEC_golay24_12,
        _H223AL1MParameters_headerFEC,
        __H223AL1MParameters_crcLength_crc4bit,
        __H223AL1MParameters_crcLength_crc12bit,
        __H223AL1MParameters_crcLength_crc20bit,
        __H223AL1MParameters_crcLength_crc28bit,
        __H223AL1MParameters_crcLength_crc8bit,
        __H223AL1MParameters_crcLength_crc16bit,
        __H223AL1MParameters_crcLength_crc32bit,
        __H223AL1MParameters_crcLength_crcNotUsed,
        _H223AL1MParameters_crcLength,
        _H223AL1MParameters_rcpcCodeRate,
        __H223AL1MParameters_arqType_noArq,
        __H223AL1MParameters_arqType_typeIArq,
        __H223AL1MParameters_arqType_typeIIArq,
        _H223AL1MParameters_arqType,
        _H223AL1MParameters_alpduInterleaving,
        _H223AL1MParameters_alsduSplitting,
        _H223AL1MParameters_rsCodeCorrection,
        H223AL1MParameters,
        __H223AL2MParameters_headerFEC_sebch16_5,
        __H223AL2MParameters_headerFEC_golay24_12,
        _H223AL2MParameters_headerFEC,
        _H223AL2MParameters_alpduInterleaving,
        H223AL2MParameters,
        __H223AL3MParameters_headerFormat_sebch16_7,
        __H223AL3MParameters_headerFormat_golay24_12,
        _H223AL3MParameters_headerFormat,
        __H223AL3MParameters_crcLength_crc4bit,
        __H223AL3MParameters_crcLength_crc12bit,
        __H223AL3MParameters_crcLength_crc20bit,
        __H223AL3MParameters_crcLength_crc28bit,
        __H223AL3MParameters_crcLength_crc8bit,
        __H223AL3MParameters_crcLength_crc16bit,
        __H223AL3MParameters_crcLength_crc32bit,
        __H223AL3MParameters_crcLength_crcNotUsed,
        _H223AL3MParameters_crcLength,
        _H223AL3MParameters_rcpcCodeRate,
        __H223AL3MParameters_arqType_noArq,
        __H223AL3MParameters_arqType_typeIArq,
        __H223AL3MParameters_arqType_typeIIArq,
        _H223AL3MParameters_arqType,
        _H223AL3MParameters_alpduInterleaving,
        _H223AL3MParameters_rsCodeCorrection,
        H223AL3MParameters,
        __H223AnnexCArqParameters_numberOfRetransmissions_finite,
        __H223AnnexCArqParameters_numberOfRetransmissions_infinite,
        _H223AnnexCArqParameters_numberOfRetransmissions,
        _H223AnnexCArqParameters_sendBufferSize,
        H223AnnexCArqParameters,
        _V76LogicalChannelParameters_hdlcParameters,
        __V76LogicalChannelParameters_suspendResume_noSuspendResume,
        __V76LogicalChannelParameters_suspendResume_suspendResumewAddress,
        __V76LogicalChannelParameters_suspendResume_suspendResumewoAddress,
        _V76LogicalChannelParameters_suspendResume,
        _V76LogicalChannelParameters_uIH,
        ___V76LogicalChannelParameters_mode_eRM_windowSize,
        ____V76LogicalChannelParameters_mode_eRM_recovery_rej,
        ____V76LogicalChannelParameters_mode_eRM_recovery_sREJ,
        ____V76LogicalChannelParameters_mode_eRM_recovery_mSREJ,
        ___V76LogicalChannelParameters_mode_eRM_recovery,
        __V76LogicalChannelParameters_mode_eRM,
        __V76LogicalChannelParameters_mode_uNERM,
        _V76LogicalChannelParameters_mode,
        _V76LogicalChannelParameters_v75Parameters,
        V76LogicalChannelParameters,
        _V76HDLCParameters_crcLength,
        _V76HDLCParameters_n401,
        _V76HDLCParameters_loopbackTestProcedure,
        V76HDLCParameters,
        _CRCLength_crc8bit,
        _CRCLength_crc16bit,
        _CRCLength_crc32bit,
        CRCLength,
        __H2250LogicalChannelParameters_nonStandard__item_,
        _H2250LogicalChannelParameters_nonStandard,
        _H2250LogicalChannelParameters_sessionID,
        _H2250LogicalChannelParameters_associatedSessionID,
        _H2250LogicalChannelParameters_mediaChannel,
        _H2250LogicalChannelParameters_mediaGuaranteedDelivery,
        _H2250LogicalChannelParameters_mediaControlChannel,
        _H2250LogicalChannelParameters_mediaControlGuaranteedDelivery,
        _H2250LogicalChannelParameters_silenceSuppression,
        _H2250LogicalChannelParameters_destination,
        _H2250LogicalChannelParameters_dynamicRTPPayloadType,
        __H2250LogicalChannelParameters_mediaPacketization_h261aVideoPacketization,
        __H2250LogicalChannelParameters_mediaPacketization_rtpPayloadType,
        _H2250LogicalChannelParameters_mediaPacketization,
        _H2250LogicalChannelParameters_transportCapability,
        _H2250LogicalChannelParameters_redundancyEncoding,
        _H2250LogicalChannelParameters_source,
        H2250LogicalChannelParameters,
        __RTPPayloadType_payloadDescriptor_nonStandardIdentifier,
        __RTPPayloadType_payloadDescriptor_rfc_number,
        __RTPPayloadType_payloadDescriptor_oid,
        _RTPPayloadType_payloadDescriptor,
        _RTPPayloadType_payloadType,
        RTPPayloadType,
        _RedundancyEncoding_redundancyEncodingMethod,
        _RedundancyEncoding_secondaryEncoding,
        __RedundancyEncoding_rtpRedundancyEncoding_primary,
        ___RedundancyEncoding_rtpRedundancyEncoding_secondary__item_,
        __RedundancyEncoding_rtpRedundancyEncoding_secondary,
        _RedundancyEncoding_rtpRedundancyEncoding,
        RedundancyEncoding,
        _RedundancyEncodingElement_dataType,
        _RedundancyEncodingElement_payloadType,
        RedundancyEncodingElement,
        __MultiplePayloadStream_elements__item_,
        _MultiplePayloadStream_elements,
        MultiplePayloadStream,
        _MultiplePayloadStreamElement_dataType,
        _MultiplePayloadStreamElement_payloadType,
        MultiplePayloadStreamElement,
        ___DepFECData_rfc2733_mode_redundancyEncoding,
        _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedSessionID,
        _____DepFECData_rfc2733_mode_separateStream_differentPort_protectedPayloadType,
        ____DepFECData_rfc2733_mode_separateStream_differentPort,
        _____DepFECData_rfc2733_mode_separateStream_samePort_protectedPayloadType,
        ____DepFECData_rfc2733_mode_separateStream_samePort,
        ___DepFECData_rfc2733_mode_separateStream,
        __DepFECData_rfc2733_mode,
        _DepFECData_rfc2733,
        DepFECData,
        __FECData_rfc2733_protectedPayloadType,
        __FECData_rfc2733_fecScheme,
        ___FECData_rfc2733_pktMode_rfc2198coding,
        ___FECData_rfc2733_pktMode_rfc2733sameport,
        ____FECData_rfc2733_pktMode_rfc2733diffport_protectedChannel,
        ___FECData_rfc2733_pktMode_rfc2733diffport,
        __FECData_rfc2733_pktMode,
        _FECData_rfc2733,
        FECData,
        _TransportAddress_unicastAddress,
        _TransportAddress_multicastAddress,
        TransportAddress,
        __UnicastAddress_iPAddress_network,
        __UnicastAddress_iPAddress_tsapIdentifier,
        _UnicastAddress_iPAddress,
        __UnicastAddress_iPXAddress_node,
        __UnicastAddress_iPXAddress_netnum,
        __UnicastAddress_iPXAddress_tsapIdentifier,
        _UnicastAddress_iPXAddress,
        __UnicastAddress_iP6Address_network,
        __UnicastAddress_iP6Address_tsapIdentifier,
        _UnicastAddress_iP6Address,
        _UnicastAddress_netBios,
        ___UnicastAddress_iPSourceRouteAddress_routing_strict,
        ___UnicastAddress_iPSourceRouteAddress_routing_loose,
        __UnicastAddress_iPSourceRouteAddress_routing,
        __UnicastAddress_iPSourceRouteAddress_network,
        __UnicastAddress_iPSourceRouteAddress_tsapIdentifier,
        ___UnicastAddress_iPSourceRouteAddress_route__item_,
        __UnicastAddress_iPSourceRouteAddress_route,
        _UnicastAddress_iPSourceRouteAddress,
        _UnicastAddress_nsap,
        _UnicastAddress_nonStandardAddress,
        UnicastAddress,
        __MulticastAddress_iPAddress_network,
        __MulticastAddress_iPAddress_tsapIdentifier,
        _MulticastAddress_iPAddress,
        __MulticastAddress_iP6Address_network,
        __MulticastAddress_iP6Address_tsapIdentifier,
        _MulticastAddress_iP6Address,
        _MulticastAddress_nsap,
        _MulticastAddress_nonStandardAddress,
        MulticastAddress,
        _EncryptionSync_nonStandard,
        _EncryptionSync_synchFlag,
        _EncryptionSync_h235Key,
        __EncryptionSync_escrowentry__item_,
        _EncryptionSync_escrowentry,
        _EncryptionSync_genericParameter,
        EncryptionSync,
        _EscrowData_escrowID,
        _EscrowData_escrowValue,
        EscrowData,
        _OpenLogicalChannelAck_forwardLogicalChannelNumber,
        __OpenLogicalChannelAck_reverseLogicalChannelParameters_reverseLogicalChannelNumber,
        __OpenLogicalChannelAck_reverseLogicalChannelParameters_portNumber,
        ___OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters_h222LogicalChannelParameters,
        ___OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters_h2250LogicalChannelParameters,
        __OpenLogicalChannelAck_reverseLogicalChannelParameters_multiplexParameters,
        __OpenLogicalChannelAck_reverseLogicalChannelParameters_replacementFor,
        _OpenLogicalChannelAck_reverseLogicalChannelParameters,
        _OpenLogicalChannelAck_separateStack,
        __OpenLogicalChannelAck_forwardMultiplexAckParameters_h2250LogicalChannelAckParameters,
        _OpenLogicalChannelAck_forwardMultiplexAckParameters,
        _OpenLogicalChannelAck_encryptionSync,
        __OpenLogicalChannelAck_genericInformation__item_,
        _OpenLogicalChannelAck_genericInformation,
        OpenLogicalChannelAck,
        _OpenLogicalChannelReject_forwardLogicalChannelNumber,
        __OpenLogicalChannelReject_cause_unspecified,
        __OpenLogicalChannelReject_cause_unsuitableReverseParameters,
        __OpenLogicalChannelReject_cause_dataTypeNotSupported,
        __OpenLogicalChannelReject_cause_dataTypeNotAvailable,
        __OpenLogicalChannelReject_cause_unknownDataType,
        __OpenLogicalChannelReject_cause_dataTypeALCombinationNotSupported,
        __OpenLogicalChannelReject_cause_multicastChannelNotAllowed,
        __OpenLogicalChannelReject_cause_insufficientBandwidth,
        __OpenLogicalChannelReject_cause_separateStackEstablishmentFailed,
        __OpenLogicalChannelReject_cause_invalidSessionID,
        __OpenLogicalChannelReject_cause_masterSlaveConflict,
        __OpenLogicalChannelReject_cause_waitForCommunicationMode,
        __OpenLogicalChannelReject_cause_invalidDependentChannel,
        __OpenLogicalChannelReject_cause_replacementForRejected,
        __OpenLogicalChannelReject_cause_securityDenied,
        __OpenLogicalChannelReject_cause_qoSControlNotSupported,
        _OpenLogicalChannelReject_cause,
        __OpenLogicalChannelReject_genericInformation__item_,
        _OpenLogicalChannelReject_genericInformation,
        OpenLogicalChannelReject,
        _OpenLogicalChannelConfirm_forwardLogicalChannelNumber,
        __OpenLogicalChannelConfirm_genericInformation__item_,
        _OpenLogicalChannelConfirm_genericInformation,
        OpenLogicalChannelConfirm,
        __H2250LogicalChannelAckParameters_nonStandard__item_,
        _H2250LogicalChannelAckParameters_nonStandard,
        _H2250LogicalChannelAckParameters_sessionID,
        _H2250LogicalChannelAckParameters_mediaChannel,
        _H2250LogicalChannelAckParameters_mediaControlChannel,
        _H2250LogicalChannelAckParameters_dynamicRTPPayloadType,
        _H2250LogicalChannelAckParameters_flowControlToZero,
        _H2250LogicalChannelAckParameters_portNumber,
        _H2250LogicalChannelAckParameters_multiplePayloadStream,
        H2250LogicalChannelAckParameters,
        _CloseLogicalChannel_forwardLogicalChannelNumber,
        __CloseLogicalChannel_source_user,
        __CloseLogicalChannel_source_lcse,
        _CloseLogicalChannel_source,
        __CloseLogicalChannel_reason_unknown,
        __CloseLogicalChannel_reason_reopen,
        __CloseLogicalChannel_reason_reservationFailure,
        __CloseLogicalChannel_reason_networkErrorCode,
        _CloseLogicalChannel_reason,
        CloseLogicalChannel,
        _CloseLogicalChannelAck_forwardLogicalChannelNumber,
        CloseLogicalChannelAck,
        _RequestChannelClose_forwardLogicalChannelNumber,
        _RequestChannelClose_qosCapability,
        __RequestChannelClose_reason_unknown,
        __RequestChannelClose_reason_normal,
        __RequestChannelClose_reason_reopen,
        __RequestChannelClose_reason_reservationFailure,
        __RequestChannelClose_reason_networkErrorCode,
        _RequestChannelClose_reason,
        RequestChannelClose,
        _RequestChannelCloseAck_forwardLogicalChannelNumber,
        RequestChannelCloseAck,
        _RequestChannelCloseReject_forwardLogicalChannelNumber,
        __RequestChannelCloseReject_cause_unspecified,
        _RequestChannelCloseReject_cause,
        RequestChannelCloseReject,
        _RequestChannelCloseRelease_forwardLogicalChannelNumber,
        RequestChannelCloseRelease,
        _MultiplexEntrySend_sequenceNumber,
        __MultiplexEntrySend_multiplexEntryDescriptors__item_,
        _MultiplexEntrySend_multiplexEntryDescriptors,
        MultiplexEntrySend,
        _MultiplexEntryDescriptor_multiplexTableEntryNumber,
        __MultiplexEntryDescriptor_elementList__item_,
        _MultiplexEntryDescriptor_elementList,
        MultiplexEntryDescriptor,
        __MultiplexElement_type_logicalChannelNumber,
        ___MultiplexElement_type_subElementList__item_,
        __MultiplexElement_type_subElementList,
        _MultiplexElement_type,
        __MultiplexElement_repeatCount_finite,
        __MultiplexElement_repeatCount_untilClosingFlag,
        _MultiplexElement_repeatCount,
        MultiplexElement,
        MultiplexTableEntryNumber,
        _MultiplexEntrySendAck_sequenceNumber,
        __MultiplexEntrySendAck_multiplexTableEntryNumber__item_,
        _MultiplexEntrySendAck_multiplexTableEntryNumber,
        MultiplexEntrySendAck,
        _MultiplexEntrySendReject_sequenceNumber,
        __MultiplexEntrySendReject_rejectionDescriptions__item_,
        _MultiplexEntrySendReject_rejectionDescriptions,
        MultiplexEntrySendReject,
        _MultiplexEntryRejectionDescriptions_multiplexTableEntryNumber,
        __MultiplexEntryRejectionDescriptions_cause_unspecifiedCause,
        __MultiplexEntryRejectionDescriptions_cause_descriptorTooComplex,
        _MultiplexEntryRejectionDescriptions_cause,
        MultiplexEntryRejectionDescriptions,
        __MultiplexEntrySendRelease_multiplexTableEntryNumber__item_,
        _MultiplexEntrySendRelease_multiplexTableEntryNumber,
        MultiplexEntrySendRelease,
        __RequestMultiplexEntry_entryNumbers__item_,
        _RequestMultiplexEntry_entryNumbers,
        RequestMultiplexEntry,
        __RequestMultiplexEntryAck_entryNumbers__item_,
        _RequestMultiplexEntryAck_entryNumbers,
        RequestMultiplexEntryAck,
        __RequestMultiplexEntryReject_entryNumbers__item_,
        _RequestMultiplexEntryReject_entryNumbers,
        __RequestMultiplexEntryReject_rejectionDescriptions__item_,
        _RequestMultiplexEntryReject_rejectionDescriptions,
        RequestMultiplexEntryReject,
        _RequestMultiplexEntryRejectionDescriptions_multiplexTableEntryNumber,
        __RequestMultiplexEntryRejectionDescriptions_cause_unspecifiedCause,
        _RequestMultiplexEntryRejectionDescriptions_cause,
        RequestMultiplexEntryRejectionDescriptions,
        __RequestMultiplexEntryRelease_entryNumbers__item_,
        _RequestMultiplexEntryRelease_entryNumbers,
        RequestMultiplexEntryRelease,
        _RequestMode_sequenceNumber,
        __RequestMode_requestedModes__item_,
        _RequestMode_requestedModes,
        RequestMode,
        _RequestModeAck_sequenceNumber,
        __RequestModeAck_response_willTransmitMostPreferredMode,
        __RequestModeAck_response_willTransmitLessPreferredMode,
        _RequestModeAck_response,
        RequestModeAck,
        _RequestModeReject_sequenceNumber,
        __RequestModeReject_cause_modeUnavailable,
        __RequestModeReject_cause_multipointConstraint,
        __RequestModeReject_cause_requestDenied,
        _RequestModeReject_cause,
        RequestModeReject,
        RequestModeRelease,
        _ModeDescription__item_,
        ModeDescription,
        _ModeElementType_nonStandard,
        _ModeElementType_videoMode,
        _ModeElementType_audioMode,
        _ModeElementType_dataMode,
        _ModeElementType_encryptionMode,
        _ModeElementType_h235Mode,
        _ModeElementType_multiplexedStreamMode,
        _ModeElementType_redundancyEncodingDTMode,
        _ModeElementType_multiplePayloadStreamMode,
        _ModeElementType_depFecMode,
        _ModeElementType_fecMode,
        ModeElementType,
        _ModeElement_type,
        _ModeElement_h223ModeParameters,
        _ModeElement_v76ModeParameters,
        _ModeElement_h2250ModeParameters,
        _ModeElement_genericModeParameters,
        _ModeElement_multiplexedStreamModeParameters,
        _ModeElement_logicalChannelNumber,
        ModeElement,
        _H235Mode_encryptionAuthenticationAndIntegrity,
        __H235Mode_mediaMode_nonStandard,
        __H235Mode_mediaMode_videoMode,
        __H235Mode_mediaMode_audioMode,
        __H235Mode_mediaMode_dataMode,
        _H235Mode_mediaMode,
        H235Mode,
        _MultiplexedStreamModeParameters_logicalChannelNumber,
        MultiplexedStreamModeParameters,
        _RedundancyEncodingDTMode_redundancyEncodingMethod,
        _RedundancyEncodingDTMode_primary,
        __RedundancyEncodingDTMode_secondary__item_,
        _RedundancyEncodingDTMode_secondary,
        RedundancyEncodingDTMode,
        __RedundancyEncodingDTModeElement_type_nonStandard,
        __RedundancyEncodingDTModeElement_type_videoMode,
        __RedundancyEncodingDTModeElement_type_audioMode,
        __RedundancyEncodingDTModeElement_type_dataMode,
        __RedundancyEncodingDTModeElement_type_encryptionMode,
        __RedundancyEncodingDTModeElement_type_h235Mode,
        __RedundancyEncodingDTModeElement_type_fecMode,
        _RedundancyEncodingDTModeElement_type,
        RedundancyEncodingDTModeElement,
        __MultiplePayloadStreamMode_elements__item_,
        _MultiplePayloadStreamMode_elements,
        MultiplePayloadStreamMode,
        _MultiplePayloadStreamElementMode_type,
        MultiplePayloadStreamElementMode,
        ___DepFECMode_rfc2733Mode_mode_redundancyEncoding,
        _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedSessionID,
        _____DepFECMode_rfc2733Mode_mode_separateStream_differentPort_protectedPayloadType,
        ____DepFECMode_rfc2733Mode_mode_separateStream_differentPort,
        _____DepFECMode_rfc2733Mode_mode_separateStream_samePort_protectedType,
        ____DepFECMode_rfc2733Mode_mode_separateStream_samePort,
        ___DepFECMode_rfc2733Mode_mode_separateStream,
        __DepFECMode_rfc2733Mode_mode,
        _DepFECMode_rfc2733Mode,
        DepFECMode,
        _FECMode_protectedElement,
        _FECMode_fecScheme,
        __FECMode_rfc2733Format_rfc2733rfc2198,
        __FECMode_rfc2733Format_rfc2733sameport,
        __FECMode_rfc2733Format_rfc2733diffport,
        _FECMode_rfc2733Format,
        FECMode,
        __H223ModeParameters_adaptationLayerType_nonStandard,
        __H223ModeParameters_adaptationLayerType_al1Framed,
        __H223ModeParameters_adaptationLayerType_al1NotFramed,
        __H223ModeParameters_adaptationLayerType_al2WithoutSequenceNumbers,
        __H223ModeParameters_adaptationLayerType_al2WithSequenceNumbers,
        ___H223ModeParameters_adaptationLayerType_al3_controlFieldOctets,
        ___H223ModeParameters_adaptationLayerType_al3_sendBufferSize,
        __H223ModeParameters_adaptationLayerType_al3,
        __H223ModeParameters_adaptationLayerType_al1M,
        __H223ModeParameters_adaptationLayerType_al2M,
        __H223ModeParameters_adaptationLayerType_al3M,
        _H223ModeParameters_adaptationLayerType,
        _H223ModeParameters_segmentableFlag,
        H223ModeParameters,
        _V76ModeParameters_suspendResumewAddress,
        _V76ModeParameters_suspendResumewoAddress,
        V76ModeParameters,
        _H2250ModeParameters_redundancyEncodingMode,
        H2250ModeParameters,
        _RedundancyEncodingMode_redundancyEncodingMethod,
        __RedundancyEncodingMode_secondaryEncoding_nonStandard,
        __RedundancyEncodingMode_secondaryEncoding_audioData,
        _RedundancyEncodingMode_secondaryEncoding,
        RedundancyEncodingMode,
        _VideoMode_nonStandard,
        _VideoMode_h261VideoMode,
        _VideoMode_h262VideoMode,
        _VideoMode_h263VideoMode,
        _VideoMode_is11172VideoMode,
        _VideoMode_genericVideoMode,
        VideoMode,
        __H261VideoMode_resolution_qcif,
        __H261VideoMode_resolution_cif,
        _H261VideoMode_resolution,
        _H261VideoMode_bitRate,
        _H261VideoMode_stillImageTransmission,
        H261VideoMode,
        __H262VideoMode_profileAndLevel_profileAndLevel_SPatML,
        __H262VideoMode_profileAndLevel_profileAndLevel_MPatLL,
        __H262VideoMode_profileAndLevel_profileAndLevel_MPatML,
        __H262VideoMode_profileAndLevel_profileAndLevel_MPatH_14,
        __H262VideoMode_profileAndLevel_profileAndLevel_MPatHL,
        __H262VideoMode_profileAndLevel_profileAndLevel_SNRatLL,
        __H262VideoMode_profileAndLevel_profileAndLevel_SNRatML,
        __H262VideoMode_profileAndLevel_profileAndLevel_SpatialatH_14,
        __H262VideoMode_profileAndLevel_profileAndLevel_HPatML,
        __H262VideoMode_profileAndLevel_profileAndLevel_HPatH_14,
        __H262VideoMode_profileAndLevel_profileAndLevel_HPatHL,
        _H262VideoMode_profileAndLevel,
        _H262VideoMode_videoBitRate,
        _H262VideoMode_vbvBufferSize,
        _H262VideoMode_samplesPerLine,
        _H262VideoMode_linesPerFrame,
        _H262VideoMode_framesPerSecond,
        _H262VideoMode_luminanceSampleRate,
        H262VideoMode,
        __H263VideoMode_resolution_sqcif,
        __H263VideoMode_resolution_qcif,
        __H263VideoMode_resolution_cif,
        __H263VideoMode_resolution_cif4,
        __H263VideoMode_resolution_cif16,
        __H263VideoMode_resolution_custom,
        _H263VideoMode_resolution,
        _H263VideoMode_bitRate,
        _H263VideoMode_unrestrictedVector,
        _H263VideoMode_arithmeticCoding,
        _H263VideoMode_advancedPrediction,
        _H263VideoMode_pbFrames,
        _H263VideoMode_errorCompensation,
        _H263VideoMode_enhancementLayerInfo,
        _H263VideoMode_h263Options,
        H263VideoMode,
        _IS11172VideoMode_constrainedBitstream,
        _IS11172VideoMode_videoBitRate,
        _IS11172VideoMode_vbvBufferSize,
        _IS11172VideoMode_samplesPerLine,
        _IS11172VideoMode_linesPerFrame,
        _IS11172VideoMode_pictureRate,
        _IS11172VideoMode_luminanceSampleRate,
        IS11172VideoMode,
        _AudioMode_nonStandard,
        _AudioMode_g711Alaw64k,
        _AudioMode_g711Alaw56k,
        _AudioMode_g711Ulaw64k,
        _AudioMode_g711Ulaw56k,
        _AudioMode_g722_64k,
        _AudioMode_g722_56k,
        _AudioMode_g722_48k,
        _AudioMode_g728,
        _AudioMode_g729,
        _AudioMode_g729AnnexA,
        __AudioMode_g7231_noSilenceSuppressionLowRate,
        __AudioMode_g7231_noSilenceSuppressionHighRate,
        __AudioMode_g7231_silenceSuppressionLowRate,
        __AudioMode_g7231_silenceSuppressionHighRate,
        _AudioMode_g7231,
        _AudioMode_is11172AudioMode,
        _AudioMode_is13818AudioMode,
        _AudioMode_g729wAnnexB,
        _AudioMode_g729AnnexAwAnnexB,
        _AudioMode_g7231AnnexCMode,
        _AudioMode_gsmFullRate,
        _AudioMode_gsmHalfRate,
        _AudioMode_gsmEnhancedFullRate,
        _AudioMode_genericAudioMode,
        _AudioMode_g729Extensions,
        _AudioMode_vbd,
        AudioMode,
        __IS11172AudioMode_audioLayer_audioLayer1,
        __IS11172AudioMode_audioLayer_audioLayer2,
        __IS11172AudioMode_audioLayer_audioLayer3,
        _IS11172AudioMode_audioLayer,
        __IS11172AudioMode_audioSampling_audioSampling32k,
        __IS11172AudioMode_audioSampling_audioSampling44k1,
        __IS11172AudioMode_audioSampling_audioSampling48k,
        _IS11172AudioMode_audioSampling,
        __IS11172AudioMode_multichannelType_singleChannel,
        __IS11172AudioMode_multichannelType_twoChannelStereo,
        __IS11172AudioMode_multichannelType_twoChannelDual,
        _IS11172AudioMode_multichannelType,
        _IS11172AudioMode_bitRate,
        IS11172AudioMode,
        __IS13818AudioMode_audioLayer_audioLayer1,
        __IS13818AudioMode_audioLayer_audioLayer2,
        __IS13818AudioMode_audioLayer_audioLayer3,
        _IS13818AudioMode_audioLayer,
        __IS13818AudioMode_audioSampling_audioSampling16k,
        __IS13818AudioMode_audioSampling_audioSampling22k05,
        __IS13818AudioMode_audioSampling_audioSampling24k,
        __IS13818AudioMode_audioSampling_audioSampling32k,
        __IS13818AudioMode_audioSampling_audioSampling44k1,
        __IS13818AudioMode_audioSampling_audioSampling48k,
        _IS13818AudioMode_audioSampling,
        __IS13818AudioMode_multichannelType_singleChannel,
        __IS13818AudioMode_multichannelType_twoChannelStereo,
        __IS13818AudioMode_multichannelType_twoChannelDual,
        __IS13818AudioMode_multichannelType_threeChannels2_1,
        __IS13818AudioMode_multichannelType_threeChannels3_0,
        __IS13818AudioMode_multichannelType_fourChannels2_0_2_0,
        __IS13818AudioMode_multichannelType_fourChannels2_2,
        __IS13818AudioMode_multichannelType_fourChannels3_1,
        __IS13818AudioMode_multichannelType_fiveChannels3_0_2_0,
        __IS13818AudioMode_multichannelType_fiveChannels3_2,
        _IS13818AudioMode_multichannelType,
        _IS13818AudioMode_lowFrequencyEnhancement,
        _IS13818AudioMode_multilingual,
        _IS13818AudioMode_bitRate,
        IS13818AudioMode,
        _G7231AnnexCMode_maxAl_sduAudioFrames,
        _G7231AnnexCMode_silenceSuppression,
        __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode0,
        __G7231AnnexCMode_g723AnnexCAudioMode_highRateMode1,
        __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode0,
        __G7231AnnexCMode_g723AnnexCAudioMode_lowRateMode1,
        __G7231AnnexCMode_g723AnnexCAudioMode_sidMode0,
        __G7231AnnexCMode_g723AnnexCAudioMode_sidMode1,
        _G7231AnnexCMode_g723AnnexCAudioMode,
        G7231AnnexCMode,
        _VBDMode_type,
        VBDMode,
        __DataMode_application_nonStandard,
        __DataMode_application_t120,
        __DataMode_application_dsm_cc,
        __DataMode_application_userData,
        __DataMode_application_t84,
        __DataMode_application_t434,
        __DataMode_application_h224,
        ___DataMode_application_nlpid_nlpidProtocol,
        ___DataMode_application_nlpid_nlpidData,
        __DataMode_application_nlpid,
        __DataMode_application_dsvdControl,
        __DataMode_application_h222DataPartitioning,
        __DataMode_application_t30fax,
        __DataMode_application_t140,
        ___DataMode_application_t38fax_t38FaxProtocol,
        ___DataMode_application_t38fax_t38FaxProfile,
        __DataMode_application_t38fax,
        __DataMode_application_genericDataMode,
        _DataMode_application,
        _DataMode_bitRate,
        DataMode,
        _EncryptionMode_nonStandard,
        _EncryptionMode_h233Encryption,
        EncryptionMode,
        _RoundTripDelayRequest_sequenceNumber,
        RoundTripDelayRequest,
        _RoundTripDelayResponse_sequenceNumber,
        RoundTripDelayResponse,
        __MaintenanceLoopRequest_type_systemLoop,
        __MaintenanceLoopRequest_type_mediaLoop,
        __MaintenanceLoopRequest_type_logicalChannelLoop,
        _MaintenanceLoopRequest_type,
        MaintenanceLoopRequest,
        __MaintenanceLoopAck_type_systemLoop,
        __MaintenanceLoopAck_type_mediaLoop,
        __MaintenanceLoopAck_type_logicalChannelLoop,
        _MaintenanceLoopAck_type,
        MaintenanceLoopAck,
        __MaintenanceLoopReject_type_systemLoop,
        __MaintenanceLoopReject_type_mediaLoop,
        __MaintenanceLoopReject_type_logicalChannelLoop,
        _MaintenanceLoopReject_type,
        __MaintenanceLoopReject_cause_canNotPerformLoop,
        _MaintenanceLoopReject_cause,
        MaintenanceLoopReject,
        MaintenanceLoopOffCommand,
        __CommunicationModeCommand_communicationModeTable__item_,
        _CommunicationModeCommand_communicationModeTable,
        CommunicationModeCommand,
        CommunicationModeRequest,
        __CommunicationModeResponse_communicationModeTable__item_,
        _CommunicationModeResponse_communicationModeTable,
        CommunicationModeResponse,
        __CommunicationModeTableEntry_nonStandard__item_,
        _CommunicationModeTableEntry_nonStandard,
        _CommunicationModeTableEntry_sessionID,
        _CommunicationModeTableEntry_associatedSessionID,
        _CommunicationModeTableEntry_terminalLabel,
        _CommunicationModeTableEntry_sessionDescription,
        __CommunicationModeTableEntry_dataType_videoData,
        __CommunicationModeTableEntry_dataType_audioData,
        __CommunicationModeTableEntry_dataType_data,
        _CommunicationModeTableEntry_dataType,
        _CommunicationModeTableEntry_mediaChannel,
        _CommunicationModeTableEntry_mediaGuaranteedDelivery,
        _CommunicationModeTableEntry_mediaControlChannel,
        _CommunicationModeTableEntry_mediaControlGuaranteedDelivery,
        _CommunicationModeTableEntry_redundancyEncoding,
        _CommunicationModeTableEntry_sessionDependency,
        _CommunicationModeTableEntry_destination,
        CommunicationModeTableEntry,
        _ConferenceRequest_terminalListRequest,
        _ConferenceRequest_makeMeChair,
        _ConferenceRequest_cancelMakeMeChair,
        _ConferenceRequest_dropTerminal,
        _ConferenceRequest_requestTerminalID,
        _ConferenceRequest_enterH243Password,
        _ConferenceRequest_enterH243TerminalID,
        _ConferenceRequest_enterH243ConferenceID,
        _ConferenceRequest_enterExtensionAddress,
        _ConferenceRequest_requestChairTokenOwner,
        __ConferenceRequest_requestTerminalCertificate_terminalLabel,
        __ConferenceRequest_requestTerminalCertificate_certSelectionCriteria,
        __ConferenceRequest_requestTerminalCertificate_sRandom,
        _ConferenceRequest_requestTerminalCertificate,
        _ConferenceRequest_broadcastMyLogicalChannel,
        _ConferenceRequest_makeTerminalBroadcaster,
        _ConferenceRequest_sendThisSource,
        _ConferenceRequest_requestAllTerminalIDs,
        _ConferenceRequest_remoteMCRequest,
        ConferenceRequest,
        _CertSelectionCriteria__item_,
        CertSelectionCriteria,
        _Criteria_field,
        _Criteria_value,
        Criteria,
        _TerminalLabel_mcuNumber,
        _TerminalLabel_terminalNumber,
        TerminalLabel,
        McuNumber,
        TerminalNumber,
        __ConferenceResponse_mCTerminalIDResponse_terminalLabel,
        __ConferenceResponse_mCTerminalIDResponse_terminalID,
        _ConferenceResponse_mCTerminalIDResponse,
        __ConferenceResponse_terminalIDResponse_terminalLabel,
        __ConferenceResponse_terminalIDResponse_terminalID,
        _ConferenceResponse_terminalIDResponse,
        __ConferenceResponse_conferenceIDResponse_terminalLabel,
        __ConferenceResponse_conferenceIDResponse_conferenceID,
        _ConferenceResponse_conferenceIDResponse,
        __ConferenceResponse_passwordResponse_terminalLabel,
        __ConferenceResponse_passwordResponse_password,
        _ConferenceResponse_passwordResponse,
        __ConferenceResponse_terminalListResponse__item_,
        _ConferenceResponse_terminalListResponse,
        _ConferenceResponse_videoCommandReject,
        _ConferenceResponse_terminalDropReject,
        __ConferenceResponse_makeMeChairResponse_grantedChairToken,
        __ConferenceResponse_makeMeChairResponse_deniedChairToken,
        _ConferenceResponse_makeMeChairResponse,
        __ConferenceResponse_extensionAddressResponse_extensionAddress,
        _ConferenceResponse_extensionAddressResponse,
        __ConferenceResponse_chairTokenOwnerResponse_terminalLabel,
        __ConferenceResponse_chairTokenOwnerResponse_terminalID,
        _ConferenceResponse_chairTokenOwnerResponse,
        __ConferenceResponse_terminalCertificateResponse_terminalLabel,
        __ConferenceResponse_terminalCertificateResponse_certificateResponse,
        _ConferenceResponse_terminalCertificateResponse,
        __ConferenceResponse_broadcastMyLogicalChannelResponse_grantedBroadcastMyLogicalChannel,
        __ConferenceResponse_broadcastMyLogicalChannelResponse_deniedBroadcastMyLogicalChannel,
        _ConferenceResponse_broadcastMyLogicalChannelResponse,
        __ConferenceResponse_makeTerminalBroadcasterResponse_grantedMakeTerminalBroadcaster,
        __ConferenceResponse_makeTerminalBroadcasterResponse_deniedMakeTerminalBroadcaster,
        _ConferenceResponse_makeTerminalBroadcasterResponse,
        __ConferenceResponse_sendThisSourceResponse_grantedSendThisSource,
        __ConferenceResponse_sendThisSourceResponse_deniedSendThisSource,
        _ConferenceResponse_sendThisSourceResponse,
        _ConferenceResponse_requestAllTerminalIDsResponse,
        _ConferenceResponse_remoteMCResponse,
        ConferenceResponse,
        TerminalID,
        ConferenceID,
        Password,
        __RequestAllTerminalIDsResponse_terminalInformation__item_,
        _RequestAllTerminalIDsResponse_terminalInformation,
        RequestAllTerminalIDsResponse,
        _TerminalInformation_terminalLabel,
        _TerminalInformation_terminalID,
        TerminalInformation,
        _RemoteMCRequest_masterActivate,
        _RemoteMCRequest_slaveActivate,
        _RemoteMCRequest_deActivate,
        RemoteMCRequest,
        _RemoteMCResponse_accept,
        __RemoteMCResponse_reject_unspecified,
        __RemoteMCResponse_reject_functionNotSupported,
        _RemoteMCResponse_reject,
        RemoteMCResponse,
        _MultilinkRequest_nonStandard,
        __MultilinkRequest_callInformation_maxNumberOfAdditionalConnections,
        _MultilinkRequest_callInformation,
        __MultilinkRequest_addConnection_sequenceNumber,
        __MultilinkRequest_addConnection_dialingInformation,
        _MultilinkRequest_addConnection,
        __MultilinkRequest_removeConnection_connectionIdentifier,
        _MultilinkRequest_removeConnection,
        ___MultilinkRequest_maximumHeaderInterval_requestType_currentIntervalInformation,
        ___MultilinkRequest_maximumHeaderInterval_requestType_requestedInterval,
        __MultilinkRequest_maximumHeaderInterval_requestType,
        _MultilinkRequest_maximumHeaderInterval,
        MultilinkRequest,
        _MultilinkResponse_nonStandard,
        __MultilinkResponse_callInformation_dialingInformation,
        __MultilinkResponse_callInformation_callAssociationNumber,
        _MultilinkResponse_callInformation,
        __MultilinkResponse_addConnection_sequenceNumber,
        ___MultilinkResponse_addConnection_responseCode_accepted,
        ____MultilinkResponse_addConnection_responseCode_rejected_connectionsNotAvailable,
        ____MultilinkResponse_addConnection_responseCode_rejected_userRejected,
        ___MultilinkResponse_addConnection_responseCode_rejected,
        __MultilinkResponse_addConnection_responseCode,
        _MultilinkResponse_addConnection,
        __MultilinkResponse_removeConnection_connectionIdentifier,
        _MultilinkResponse_removeConnection,
        __MultilinkResponse_maximumHeaderInterval_currentInterval,
        _MultilinkResponse_maximumHeaderInterval,
        MultilinkResponse,
        _MultilinkIndication_nonStandard,
        _MultilinkIndication_crcDesired,
        __MultilinkIndication_excessiveError_connectionIdentifier,
        _MultilinkIndication_excessiveError,
        MultilinkIndication,
        _DialingInformation_nonStandard,
        __DialingInformation_differential__item_,
        _DialingInformation_differential,
        _DialingInformation_infoNotAvailable,
        DialingInformation,
        _DialingInformationNumber_networkAddress,
        _DialingInformationNumber_subAddress,
        __DialingInformationNumber_networkType__item_,
        _DialingInformationNumber_networkType,
        DialingInformationNumber,
        _DialingInformationNetworkType_nonStandard,
        _DialingInformationNetworkType_n_isdn,
        _DialingInformationNetworkType_gstn,
        _DialingInformationNetworkType_mobile,
        DialingInformationNetworkType,
        _ConnectionIdentifier_channelTag,
        _ConnectionIdentifier_sequenceNumber,
        ConnectionIdentifier,
        MaximumBitRate,
        _LogicalChannelRateRequest_sequenceNumber,
        _LogicalChannelRateRequest_logicalChannelNumber,
        _LogicalChannelRateRequest_maximumBitRate,
        LogicalChannelRateRequest,
        _LogicalChannelRateAcknowledge_sequenceNumber,
        _LogicalChannelRateAcknowledge_logicalChannelNumber,
        _LogicalChannelRateAcknowledge_maximumBitRate,
        LogicalChannelRateAcknowledge,
        _LogicalChannelRateReject_sequenceNumber,
        _LogicalChannelRateReject_logicalChannelNumber,
        _LogicalChannelRateReject_rejectReason,
        _LogicalChannelRateReject_currentMaximumBitRate,
        LogicalChannelRateReject,
        _LogicalChannelRateRejectReason_undefinedReason,
        _LogicalChannelRateRejectReason_insufficientResources,
        LogicalChannelRateRejectReason,
        LogicalChannelRateRelease,
        __SendTerminalCapabilitySet_specificRequest_multiplexCapability,
        ___SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers__item_,
        __SendTerminalCapabilitySet_specificRequest_capabilityTableEntryNumbers,
        ___SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers__item_,
        __SendTerminalCapabilitySet_specificRequest_capabilityDescriptorNumbers,
        _SendTerminalCapabilitySet_specificRequest,
        _SendTerminalCapabilitySet_genericRequest,
        SendTerminalCapabilitySet,
        _EncryptionCommand_encryptionSE,
        _EncryptionCommand_encryptionIVRequest,
        __EncryptionCommand_encryptionAlgorithmID_h233AlgorithmIdentifier,
        __EncryptionCommand_encryptionAlgorithmID_associatedAlgorithm,
        _EncryptionCommand_encryptionAlgorithmID,
        EncryptionCommand,
        __FlowControlCommand_scope_logicalChannelNumber,
        __FlowControlCommand_scope_resourceID,
        __FlowControlCommand_scope_wholeMultiplex,
        _FlowControlCommand_scope,
        __FlowControlCommand_restriction_maximumBitRate,
        __FlowControlCommand_restriction_noRestriction,
        _FlowControlCommand_restriction,
        FlowControlCommand,
        _EndSessionCommand_nonStandard,
        _EndSessionCommand_disconnect,
        __EndSessionCommand_gstnOptions_telephonyMode,
        __EndSessionCommand_gstnOptions_v8bis,
        __EndSessionCommand_gstnOptions_v34DSVD,
        __EndSessionCommand_gstnOptions_v34DuplexFAX,
        __EndSessionCommand_gstnOptions_v34H324,
        _EndSessionCommand_gstnOptions,
        __EndSessionCommand_isdnOptions_telephonyMode,
        __EndSessionCommand_isdnOptions_v140,
        __EndSessionCommand_isdnOptions_terminalOnHold,
        _EndSessionCommand_isdnOptions,
        __EndSessionCommand_genericInformation__item_,
        _EndSessionCommand_genericInformation,
        EndSessionCommand,
        _ConferenceCommand_broadcastMyLogicalChannel,
        _ConferenceCommand_cancelBroadcastMyLogicalChannel,
        _ConferenceCommand_makeTerminalBroadcaster,
        _ConferenceCommand_cancelMakeTerminalBroadcaster,
        _ConferenceCommand_sendThisSource,
        _ConferenceCommand_cancelSendThisSource,
        _ConferenceCommand_dropConference,
        _ConferenceCommand_substituteConferenceIDCommand,
        ConferenceCommand,
        _SubstituteConferenceIDCommand_conferenceIdentifier,
        SubstituteConferenceIDCommand,
        _EncryptionUpdateDirection_masterToSlave,
        _EncryptionUpdateDirection_slaveToMaster,
        EncryptionUpdateDirection,
        _MiscellaneousCommand_logicalChannelNumber,
        __MiscellaneousCommand_type_equaliseDelay,
        __MiscellaneousCommand_type_zeroDelay,
        __MiscellaneousCommand_type_multipointModeCommand,
        __MiscellaneousCommand_type_cancelMultipointModeCommand,
        __MiscellaneousCommand_type_videoFreezePicture,
        __MiscellaneousCommand_type_videoFastUpdatePicture,
        ___MiscellaneousCommand_type_videoFastUpdateGOB_firstGOB,
        ___MiscellaneousCommand_type_videoFastUpdateGOB_numberOfGOBs,
        __MiscellaneousCommand_type_videoFastUpdateGOB,
        __MiscellaneousCommand_type_videoTemporalSpatialTradeOff,
        __MiscellaneousCommand_type_videoSendSyncEveryGOB,
        __MiscellaneousCommand_type_videoSendSyncEveryGOBCancel,
        ___MiscellaneousCommand_type_videoFastUpdateMB_firstGOB,
        ___MiscellaneousCommand_type_videoFastUpdateMB_firstMB,
        ___MiscellaneousCommand_type_videoFastUpdateMB_numberOfMBs,
        __MiscellaneousCommand_type_videoFastUpdateMB,
        __MiscellaneousCommand_type_maxH223MUXPDUsize,
        __MiscellaneousCommand_type_encryptionUpdate,
        __MiscellaneousCommand_type_encryptionUpdateRequest,
        __MiscellaneousCommand_type_switchReceiveMediaOff,
        __MiscellaneousCommand_type_switchReceiveMediaOn,
        ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doOneProgression,
        ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doContinuousProgressions,
        ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doOneIndependentProgression,
        ____MiscellaneousCommand_type_progressiveRefinementStart_repeatCount_doContinuousIndependentProgressions,
        ___MiscellaneousCommand_type_progressiveRefinementStart_repeatCount,
        __MiscellaneousCommand_type_progressiveRefinementStart,
        __MiscellaneousCommand_type_progressiveRefinementAbortOne,
        __MiscellaneousCommand_type_progressiveRefinementAbortContinuous,
        ___MiscellaneousCommand_type_videoBadMBs_firstMB,
        ___MiscellaneousCommand_type_videoBadMBs_numberOfMBs,
        ___MiscellaneousCommand_type_videoBadMBs_temporalReference,
        __MiscellaneousCommand_type_videoBadMBs,
        ___MiscellaneousCommand_type_lostPicture__item_,
        __MiscellaneousCommand_type_lostPicture,
        ___MiscellaneousCommand_type_lostPartialPicture_pictureReference,
        ___MiscellaneousCommand_type_lostPartialPicture_firstMB,
        ___MiscellaneousCommand_type_lostPartialPicture_numberOfMBs,
        __MiscellaneousCommand_type_lostPartialPicture,
        ___MiscellaneousCommand_type_recoveryReferencePicture__item_,
        __MiscellaneousCommand_type_recoveryReferencePicture,
        ___MiscellaneousCommand_type_encryptionUpdateCommand_encryptionSync,
        ___MiscellaneousCommand_type_encryptionUpdateCommand_multiplePayloadStream,
        __MiscellaneousCommand_type_encryptionUpdateCommand,
        ___MiscellaneousCommand_type_encryptionUpdateAck_synchFlag,
        __MiscellaneousCommand_type_encryptionUpdateAck,
        _MiscellaneousCommand_type,
        _MiscellaneousCommand_direction,
        MiscellaneousCommand,
        _KeyProtectionMethod_secureChannel,
        _KeyProtectionMethod_sharedSecret,
        _KeyProtectionMethod_certProtectedKey,
        KeyProtectionMethod,
        _EncryptionUpdateRequest_keyProtectionMethod,
        _EncryptionUpdateRequest_synchFlag,
        EncryptionUpdateRequest,
        _PictureReference_pictureNumber,
        _PictureReference_longTermPictureIndex,
        PictureReference,
        __H223MultiplexReconfiguration_h223ModeChange_toLevel0,
        __H223MultiplexReconfiguration_h223ModeChange_toLevel1,
        __H223MultiplexReconfiguration_h223ModeChange_toLevel2,
        __H223MultiplexReconfiguration_h223ModeChange_toLevel2withOptionalHeader,
        _H223MultiplexReconfiguration_h223ModeChange,
        __H223MultiplexReconfiguration_h223AnnexADoubleFlag_start,
        __H223MultiplexReconfiguration_h223AnnexADoubleFlag_stop,
        _H223MultiplexReconfiguration_h223AnnexADoubleFlag,
        H223MultiplexReconfiguration,
        _NewATMVCCommand_resourceID,
        _NewATMVCCommand_bitRate,
        _NewATMVCCommand_bitRateLockedToPCRClock,
        _NewATMVCCommand_bitRateLockedToNetworkClock,
        ____NewATMVCCommand_aal_aal1_clockRecovery_nullClockRecovery,
        ____NewATMVCCommand_aal_aal1_clockRecovery_srtsClockRecovery,
        ____NewATMVCCommand_aal_aal1_clockRecovery_adaptiveClockRecovery,
        ___NewATMVCCommand_aal_aal1_clockRecovery,
        ____NewATMVCCommand_aal_aal1_errorCorrection_nullErrorCorrection,
        ____NewATMVCCommand_aal_aal1_errorCorrection_longInterleaver,
        ____NewATMVCCommand_aal_aal1_errorCorrection_shortInterleaver,
        ____NewATMVCCommand_aal_aal1_errorCorrection_errorCorrectionOnly,
        ___NewATMVCCommand_aal_aal1_errorCorrection,
        ___NewATMVCCommand_aal_aal1_structuredDataTransfer,
        ___NewATMVCCommand_aal_aal1_partiallyFilledCells,
        __NewATMVCCommand_aal_aal1,
        ___NewATMVCCommand_aal_aal5_forwardMaximumSDUSize,
        ___NewATMVCCommand_aal_aal5_backwardMaximumSDUSize,
        __NewATMVCCommand_aal_aal5,
        _NewATMVCCommand_aal,
        __NewATMVCCommand_multiplex_noMultiplex,
        __NewATMVCCommand_multiplex_transportStream,
        __NewATMVCCommand_multiplex_programStream,
        _NewATMVCCommand_multiplex,
        __NewATMVCCommand_reverseParameters_bitRate,
        __NewATMVCCommand_reverseParameters_bitRateLockedToPCRClock,
        __NewATMVCCommand_reverseParameters_bitRateLockedToNetworkClock,
        ___NewATMVCCommand_reverseParameters_multiplex_noMultiplex,
        ___NewATMVCCommand_reverseParameters_multiplex_transportStream,
        ___NewATMVCCommand_reverseParameters_multiplex_programStream,
        __NewATMVCCommand_reverseParameters_multiplex,
        _NewATMVCCommand_reverseParameters,
        NewATMVCCommand,
        _MobileMultilinkReconfigurationCommand_sampleSize,
        _MobileMultilinkReconfigurationCommand_samplesPerFrame,
        __MobileMultilinkReconfigurationCommand_status_synchronized,
        __MobileMultilinkReconfigurationCommand_status_reconfiguration,
        _MobileMultilinkReconfigurationCommand_status,
        MobileMultilinkReconfigurationCommand,
        _FunctionNotUnderstood_request,
        _FunctionNotUnderstood_response,
        _FunctionNotUnderstood_command,
        FunctionNotUnderstood,
        __FunctionNotSupported_cause_syntaxError,
        __FunctionNotSupported_cause_semanticError,
        __FunctionNotSupported_cause_unknownFunction,
        _FunctionNotSupported_cause,
        _FunctionNotSupported_returnedFunction,
        FunctionNotSupported,
        _ConferenceIndication_sbeNumber,
        _ConferenceIndication_terminalNumberAssign,
        _ConferenceIndication_terminalJoinedConference,
        _ConferenceIndication_terminalLeftConference,
        _ConferenceIndication_seenByAtLeastOneOther,
        _ConferenceIndication_cancelSeenByAtLeastOneOther,
        _ConferenceIndication_seenByAll,
        _ConferenceIndication_cancelSeenByAll,
        _ConferenceIndication_terminalYouAreSeeing,
        _ConferenceIndication_requestForFloor,
        _ConferenceIndication_withdrawChairToken,
        _ConferenceIndication_floorRequested,
        _ConferenceIndication_terminalYouAreSeeingInSubPictureNumber,
        _ConferenceIndication_videoIndicateCompose,
        _ConferenceIndication_masterMCU,
        _ConferenceIndication_cancelMasterMCU,
        ConferenceIndication,
        _TerminalYouAreSeeingInSubPictureNumber_terminalNumber,
        _TerminalYouAreSeeingInSubPictureNumber_subPictureNumber,
        _TerminalYouAreSeeingInSubPictureNumber_mcuNumber,
        TerminalYouAreSeeingInSubPictureNumber,
        _VideoIndicateCompose_compositionNumber,
        VideoIndicateCompose,
        _MiscellaneousIndication_logicalChannelNumber,
        __MiscellaneousIndication_type_logicalChannelActive,
        __MiscellaneousIndication_type_logicalChannelInactive,
        __MiscellaneousIndication_type_multipointConference,
        __MiscellaneousIndication_type_cancelMultipointConference,
        __MiscellaneousIndication_type_multipointZeroComm,
        __MiscellaneousIndication_type_cancelMultipointZeroComm,
        __MiscellaneousIndication_type_multipointSecondaryStatus,
        __MiscellaneousIndication_type_cancelMultipointSecondaryStatus,
        __MiscellaneousIndication_type_videoIndicateReadyToActivate,
        __MiscellaneousIndication_type_videoTemporalSpatialTradeOff,
        ___MiscellaneousIndication_type_videoNotDecodedMBs_firstMB,
        ___MiscellaneousIndication_type_videoNotDecodedMBs_numberOfMBs,
        ___MiscellaneousIndication_type_videoNotDecodedMBs_temporalReference,
        __MiscellaneousIndication_type_videoNotDecodedMBs,
        __MiscellaneousIndication_type_transportCapability,
        _MiscellaneousIndication_type,
        MiscellaneousIndication,
        __JitterIndication_scope_logicalChannelNumber,
        __JitterIndication_scope_resourceID,
        __JitterIndication_scope_wholeMultiplex,
        _JitterIndication_scope,
        _JitterIndication_estimatedReceivedJitterMantissa,
        _JitterIndication_estimatedReceivedJitterExponent,
        _JitterIndication_skippedFrameCount,
        _JitterIndication_additionalDecoderBuffer,
        JitterIndication,
        _H223SkewIndication_logicalChannelNumber1,
        _H223SkewIndication_logicalChannelNumber2,
        _H223SkewIndication_skew,
        H223SkewIndication,
        _H2250MaximumSkewIndication_logicalChannelNumber1,
        _H2250MaximumSkewIndication_logicalChannelNumber2,
        _H2250MaximumSkewIndication_maximumSkew,
        H2250MaximumSkewIndication,
        _MCLocationIndication_signalAddress,
        MCLocationIndication,
        _VendorIdentification_vendor,
        _VendorIdentification_productNumber,
        _VendorIdentification_versionNumber,
        VendorIdentification,
        _NewATMVCIndication_resourceID,
        _NewATMVCIndication_bitRate,
        _NewATMVCIndication_bitRateLockedToPCRClock,
        _NewATMVCIndication_bitRateLockedToNetworkClock,
        ____NewATMVCIndication_aal_aal1_clockRecovery_nullClockRecovery,
        ____NewATMVCIndication_aal_aal1_clockRecovery_srtsClockRecovery,
        ____NewATMVCIndication_aal_aal1_clockRecovery_adaptiveClockRecovery,
        ___NewATMVCIndication_aal_aal1_clockRecovery,
        ____NewATMVCIndication_aal_aal1_errorCorrection_nullErrorCorrection,
        ____NewATMVCIndication_aal_aal1_errorCorrection_longInterleaver,
        ____NewATMVCIndication_aal_aal1_errorCorrection_shortInterleaver,
        ____NewATMVCIndication_aal_aal1_errorCorrection_errorCorrectionOnly,
        ___NewATMVCIndication_aal_aal1_errorCorrection,
        ___NewATMVCIndication_aal_aal1_structuredDataTransfer,
        ___NewATMVCIndication_aal_aal1_partiallyFilledCells,
        __NewATMVCIndication_aal_aal1,
        ___NewATMVCIndication_aal_aal5_forwardMaximumSDUSize,
        ___NewATMVCIndication_aal_aal5_backwardMaximumSDUSize,
        __NewATMVCIndication_aal_aal5,
        _NewATMVCIndication_aal,
        __NewATMVCIndication_multiplex_noMultiplex,
        __NewATMVCIndication_multiplex_transportStream,
        __NewATMVCIndication_multiplex_programStream,
        _NewATMVCIndication_multiplex,
        __NewATMVCIndication_reverseParameters_bitRate,
        __NewATMVCIndication_reverseParameters_bitRateLockedToPCRClock,
        __NewATMVCIndication_reverseParameters_bitRateLockedToNetworkClock,
        ___NewATMVCIndication_reverseParameters_multiplex_noMultiplex,
        ___NewATMVCIndication_reverseParameters_multiplex_transportStream,
        ___NewATMVCIndication_reverseParameters_multiplex_programStream,
        __NewATMVCIndication_reverseParameters_multiplex,
        _NewATMVCIndication_reverseParameters,
        NewATMVCIndication,
        IV8,
        IV16,
        _Params_iv8,
        _Params_iv16,
        _Params_iv,
        Params,
        _UserInputIndication_nonStandard,
        _UserInputIndication_alphanumeric,
        __UserInputIndication_userInputSupportIndication_nonStandard,
        __UserInputIndication_userInputSupportIndication_basicString,
        __UserInputIndication_userInputSupportIndication_iA5String,
        __UserInputIndication_userInputSupportIndication_generalString,
        __UserInputIndication_userInputSupportIndication_encryptedBasicString,
        __UserInputIndication_userInputSupportIndication_encryptedIA5String,
        __UserInputIndication_userInputSupportIndication_encryptedGeneralString,
        _UserInputIndication_userInputSupportIndication,
        __UserInputIndication_signal_signalType,
        __UserInputIndication_signal_duration,
        ___UserInputIndication_signal_rtp_timestamp,
        ___UserInputIndication_signal_rtp_expirationTime,
        ___UserInputIndication_signal_rtp_logicalChannelNumber,
        __UserInputIndication_signal_rtp,
        __UserInputIndication_signal_rtpPayloadIndication,
        __UserInputIndication_signal_paramS,
        __UserInputIndication_signal_encryptedSignalType,
        __UserInputIndication_signal_algorithmOID,
        _UserInputIndication_signal,
        __UserInputIndication_signalUpdate_duration,
        ___UserInputIndication_signalUpdate_rtp_logicalChannelNumber,
        __UserInputIndication_signalUpdate_rtp,
        _UserInputIndication_signalUpdate,
        __UserInputIndication_extendedAlphanumeric_alphanumeric,
        __UserInputIndication_extendedAlphanumeric_rtpPayloadIndication,
        ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_algorithmOID,
        ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_paramS,
        ___UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric_encrypted,
        __UserInputIndication_extendedAlphanumeric_encryptedAlphanumeric,
        _UserInputIndication_extendedAlphanumeric,
        __UserInputIndication_encryptedAlphanumeric_algorithmOID,
        __UserInputIndication_encryptedAlphanumeric_paramS,
        __UserInputIndication_encryptedAlphanumeric_encrypted,
        _UserInputIndication_encryptedAlphanumeric,
        __UserInputIndication_genericInformation__item_,
        _UserInputIndication_genericInformation,
        UserInputIndication,
        __FlowControlIndication_scope_logicalChannelNumber,
        __FlowControlIndication_scope_resourceID,
        __FlowControlIndication_scope_wholeMultiplex,
        _FlowControlIndication_scope,
        __FlowControlIndication_restriction_maximumBitRate,
        __FlowControlIndication_restriction_noRestriction,
        _FlowControlIndication_restriction,
        FlowControlIndication,
        _MobileMultilinkReconfigurationIndication_sampleSize,
        _MobileMultilinkReconfigurationIndication_samplesPerFrame,
        MobileMultilinkReconfigurationIndication,
    ]

init_modules(MULTIMEDIA_SYSTEM_CONTROL)
