# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class HNBAP_CommonDataTypes:

    _name_  = 'HNBAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 6, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class HNBAP_Constants:

    _name_  = 'HNBAP-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 6, 1, 4]
    
    _obj_ = [
        'id-HNBRegister',
        'id-HNBDe-Register',
        'id-UERegister',
        'id-UEDe-Register',
        'id-ErrorIndication',
        'id-privateMessage',
        'id-CSGMembershipUpdate',
        'id-TNLUpdate',
        'id-HNBConfigTransfer',
        'id-RelocationComplete',
        'id-U-RNTIQuery',
        'maxNrOfErrors',
        'maxnoofRABs',
        'maxnoofAdditionalNeighbours',
        'maxnoofURAIdentities',
        'maxnoofNeighbours',
        'maxnoofIurhAddresses',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-HNB-Identity',
        'id-Context-ID',
        'id-UE-Identity',
        'id-LAC',
        'id-RAC',
        'id-HNB-Location-Information',
        'id-PLMNidentity',
        'id-SAC',
        'id-CellIdentity',
        'id-Registration-Cause',
        'id-UE-Capabilities',
        'id-RNC-ID',
        'id-CSG-ID',
        'id-BackoffTimer',
        'id-HNB-Internet-Information',
        'id-HNB-Cell-Access-Mode',
        'id-MuxPortNumber',
        'id-Service-Area-For-Broadcast',
        'id-CSGMembershipStatus',
        'id-RABList',
        'id-HNBConfigInfo',
        'id-AccessResult',
        'id-Update-cause',
        'id-NeighbourInfoList',
        'id-NeighbourInfoRequestList',
        'id-Iurh-Signalling-TNL-Address',
        'id-PSC',
        'id-HNB-Cell-Identifier',
        'id-Tunnel-Information',
        'id-CELL-FACHMobilitySupport',
        'id-S-RNTIPrefix',
        'id-URAIdentity',
        'id-NeighbourIdentity',
        'id-HNBCapacity',
        'id-NeighbourCellIdentityList',
        'id-AdditionalNeighbourInfoList',
        'id-U-RNTI',
        'id-UnknownU-RNTIIndication',
        'id-HNB-GWResponse',
        'id-URAIdentityList',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-HNBRegister',
        'id-HNBDe-Register',
        'id-UERegister',
        'id-UEDe-Register',
        'id-ErrorIndication',
        'id-privateMessage',
        'id-CSGMembershipUpdate',
        'id-TNLUpdate',
        'id-HNBConfigTransfer',
        'id-RelocationComplete',
        'id-U-RNTIQuery',
        'maxNrOfErrors',
        'maxnoofRABs',
        'maxnoofAdditionalNeighbours',
        'maxnoofURAIdentities',
        'maxnoofNeighbours',
        'maxnoofIurhAddresses',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-HNB-Identity',
        'id-Context-ID',
        'id-UE-Identity',
        'id-LAC',
        'id-RAC',
        'id-HNB-Location-Information',
        'id-PLMNidentity',
        'id-SAC',
        'id-CellIdentity',
        'id-Registration-Cause',
        'id-UE-Capabilities',
        'id-RNC-ID',
        'id-CSG-ID',
        'id-BackoffTimer',
        'id-HNB-Internet-Information',
        'id-HNB-Cell-Access-Mode',
        'id-MuxPortNumber',
        'id-Service-Area-For-Broadcast',
        'id-CSGMembershipStatus',
        'id-RABList',
        'id-HNBConfigInfo',
        'id-AccessResult',
        'id-Update-cause',
        'id-NeighbourInfoList',
        'id-NeighbourInfoRequestList',
        'id-Iurh-Signalling-TNL-Address',
        'id-PSC',
        'id-HNB-Cell-Identifier',
        'id-Tunnel-Information',
        'id-CELL-FACHMobilitySupport',
        'id-S-RNTIPrefix',
        'id-URAIdentity',
        'id-NeighbourIdentity',
        'id-HNBCapacity',
        'id-NeighbourCellIdentityList',
        'id-AdditionalNeighbourInfoList',
        'id-U-RNTI',
        'id-UnknownU-RNTIIndication',
        'id-HNB-GWResponse',
        'id-URAIdentityList',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-HNBRegister >-----#
    id_HNBRegister = INT(name='id-HNBRegister', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_HNBRegister._val = 1
    
    #-----< id-HNBDe-Register >-----#
    id_HNBDe_Register = INT(name='id-HNBDe-Register', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_HNBDe_Register._val = 2
    
    #-----< id-UERegister >-----#
    id_UERegister = INT(name='id-UERegister', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_UERegister._val = 3
    
    #-----< id-UEDe-Register >-----#
    id_UEDe_Register = INT(name='id-UEDe-Register', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_UEDe_Register._val = 4
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 5
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 6
    
    #-----< id-CSGMembershipUpdate >-----#
    id_CSGMembershipUpdate = INT(name='id-CSGMembershipUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_CSGMembershipUpdate._val = 7
    
    #-----< id-TNLUpdate >-----#
    id_TNLUpdate = INT(name='id-TNLUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_TNLUpdate._val = 9
    
    #-----< id-HNBConfigTransfer >-----#
    id_HNBConfigTransfer = INT(name='id-HNBConfigTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_HNBConfigTransfer._val = 10
    
    #-----< id-RelocationComplete >-----#
    id_RelocationComplete = INT(name='id-RelocationComplete', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_RelocationComplete._val = 11
    
    #-----< id-U-RNTIQuery >-----#
    id_U_RNTIQuery = INT(name='id-U-RNTIQuery', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')))
    id_U_RNTIQuery._val = 14
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxnoofRABs >-----#
    maxnoofRABs = INT(name='maxnoofRABs', mode=MODE_VALUE)
    maxnoofRABs._val = 256
    
    #-----< maxnoofAdditionalNeighbours >-----#
    maxnoofAdditionalNeighbours = INT(name='maxnoofAdditionalNeighbours', mode=MODE_VALUE)
    maxnoofAdditionalNeighbours._val = 128
    
    #-----< maxnoofURAIdentities >-----#
    maxnoofURAIdentities = INT(name='maxnoofURAIdentities', mode=MODE_VALUE)
    maxnoofURAIdentities._val = 8
    
    #-----< maxnoofNeighbours >-----#
    maxnoofNeighbours = INT(name='maxnoofNeighbours', mode=MODE_VALUE)
    maxnoofNeighbours._val = 32
    
    #-----< maxnoofIurhAddresses >-----#
    maxnoofIurhAddresses = INT(name='maxnoofIurhAddresses', mode=MODE_VALUE)
    maxnoofIurhAddresses._val = 3
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 1
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 2
    
    #-----< id-HNB-Identity >-----#
    id_HNB_Identity = INT(name='id-HNB-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_Identity._val = 3
    
    #-----< id-Context-ID >-----#
    id_Context_ID = INT(name='id-Context-ID', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Context_ID._val = 4
    
    #-----< id-UE-Identity >-----#
    id_UE_Identity = INT(name='id-UE-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Identity._val = 5
    
    #-----< id-LAC >-----#
    id_LAC = INT(name='id-LAC', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LAC._val = 6
    
    #-----< id-RAC >-----#
    id_RAC = INT(name='id-RAC', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAC._val = 7
    
    #-----< id-HNB-Location-Information >-----#
    id_HNB_Location_Information = INT(name='id-HNB-Location-Information', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_Location_Information._val = 8
    
    #-----< id-PLMNidentity >-----#
    id_PLMNidentity = INT(name='id-PLMNidentity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLMNidentity._val = 9
    
    #-----< id-SAC >-----#
    id_SAC = INT(name='id-SAC', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SAC._val = 10
    
    #-----< id-CellIdentity >-----#
    id_CellIdentity = INT(name='id-CellIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellIdentity._val = 11
    
    #-----< id-Registration-Cause >-----#
    id_Registration_Cause = INT(name='id-Registration-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Registration_Cause._val = 12
    
    #-----< id-UE-Capabilities >-----#
    id_UE_Capabilities = INT(name='id-UE-Capabilities', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Capabilities._val = 13
    
    #-----< id-RNC-ID >-----#
    id_RNC_ID = INT(name='id-RNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RNC_ID._val = 14
    
    #-----< id-CSG-ID >-----#
    id_CSG_ID = INT(name='id-CSG-ID', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_ID._val = 15
    
    #-----< id-BackoffTimer >-----#
    id_BackoffTimer = INT(name='id-BackoffTimer', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BackoffTimer._val = 16
    
    #-----< id-HNB-Internet-Information >-----#
    id_HNB_Internet_Information = INT(name='id-HNB-Internet-Information', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_Internet_Information._val = 17
    
    #-----< id-HNB-Cell-Access-Mode >-----#
    id_HNB_Cell_Access_Mode = INT(name='id-HNB-Cell-Access-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_Cell_Access_Mode._val = 18
    
    #-----< id-MuxPortNumber >-----#
    id_MuxPortNumber = INT(name='id-MuxPortNumber', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MuxPortNumber._val = 19
    
    #-----< id-Service-Area-For-Broadcast >-----#
    id_Service_Area_For_Broadcast = INT(name='id-Service-Area-For-Broadcast', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Service_Area_For_Broadcast._val = 20
    
    #-----< id-CSGMembershipStatus >-----#
    id_CSGMembershipStatus = INT(name='id-CSGMembershipStatus', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipStatus._val = 21
    
    #-----< id-RABList >-----#
    id_RABList = INT(name='id-RABList', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RABList._val = 22
    
    #-----< id-HNBConfigInfo >-----#
    id_HNBConfigInfo = INT(name='id-HNBConfigInfo', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNBConfigInfo._val = 23
    
    #-----< id-AccessResult >-----#
    id_AccessResult = INT(name='id-AccessResult', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AccessResult._val = 25
    
    #-----< id-Update-cause >-----#
    id_Update_cause = INT(name='id-Update-cause', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Update_cause._val = 26
    
    #-----< id-NeighbourInfoList >-----#
    id_NeighbourInfoList = INT(name='id-NeighbourInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbourInfoList._val = 27
    
    #-----< id-NeighbourInfoRequestList >-----#
    id_NeighbourInfoRequestList = INT(name='id-NeighbourInfoRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbourInfoRequestList._val = 28
    
    #-----< id-Iurh-Signalling-TNL-Address >-----#
    id_Iurh_Signalling_TNL_Address = INT(name='id-Iurh-Signalling-TNL-Address', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Iurh_Signalling_TNL_Address._val = 29
    
    #-----< id-PSC >-----#
    id_PSC = INT(name='id-PSC', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSC._val = 30
    
    #-----< id-HNB-Cell-Identifier >-----#
    id_HNB_Cell_Identifier = INT(name='id-HNB-Cell-Identifier', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_Cell_Identifier._val = 31
    
    #-----< id-Tunnel-Information >-----#
    id_Tunnel_Information = INT(name='id-Tunnel-Information', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Tunnel_Information._val = 41
    
    #-----< id-CELL-FACHMobilitySupport >-----#
    id_CELL_FACHMobilitySupport = INT(name='id-CELL-FACHMobilitySupport', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CELL_FACHMobilitySupport._val = 42
    
    #-----< id-S-RNTIPrefix >-----#
    id_S_RNTIPrefix = INT(name='id-S-RNTIPrefix', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_RNTIPrefix._val = 43
    
    #-----< id-URAIdentity >-----#
    id_URAIdentity = INT(name='id-URAIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_URAIdentity._val = 44
    
    #-----< id-NeighbourIdentity >-----#
    id_NeighbourIdentity = INT(name='id-NeighbourIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbourIdentity._val = 45
    
    #-----< id-HNBCapacity >-----#
    id_HNBCapacity = INT(name='id-HNBCapacity', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNBCapacity._val = 46
    
    #-----< id-NeighbourCellIdentityList >-----#
    id_NeighbourCellIdentityList = INT(name='id-NeighbourCellIdentityList', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbourCellIdentityList._val = 47
    
    #-----< id-AdditionalNeighbourInfoList >-----#
    id_AdditionalNeighbourInfoList = INT(name='id-AdditionalNeighbourInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalNeighbourInfoList._val = 48
    
    #-----< id-U-RNTI >-----#
    id_U_RNTI = INT(name='id-U-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_U_RNTI._val = 49
    
    #-----< id-UnknownU-RNTIIndication >-----#
    id_UnknownU_RNTIIndication = INT(name='id-UnknownU-RNTIIndication', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnknownU_RNTIIndication._val = 50
    
    #-----< id-HNB-GWResponse >-----#
    id_HNB_GWResponse = INT(name='id-HNB-GWResponse', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HNB_GWResponse._val = 51
    
    #-----< id-URAIdentityList >-----#
    id_URAIdentityList = INT(name='id-URAIdentityList', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_URAIdentityList._val = 52
    
    _all_ = [
        id_HNBRegister,
        id_HNBDe_Register,
        id_UERegister,
        id_UEDe_Register,
        id_ErrorIndication,
        id_privateMessage,
        id_CSGMembershipUpdate,
        id_TNLUpdate,
        id_HNBConfigTransfer,
        id_RelocationComplete,
        id_U_RNTIQuery,
        maxNrOfErrors,
        maxnoofRABs,
        maxnoofAdditionalNeighbours,
        maxnoofURAIdentities,
        maxnoofNeighbours,
        maxnoofIurhAddresses,
        id_Cause,
        id_CriticalityDiagnostics,
        id_HNB_Identity,
        id_Context_ID,
        id_UE_Identity,
        id_LAC,
        id_RAC,
        id_HNB_Location_Information,
        id_PLMNidentity,
        id_SAC,
        id_CellIdentity,
        id_Registration_Cause,
        id_UE_Capabilities,
        id_RNC_ID,
        id_CSG_ID,
        id_BackoffTimer,
        id_HNB_Internet_Information,
        id_HNB_Cell_Access_Mode,
        id_MuxPortNumber,
        id_Service_Area_For_Broadcast,
        id_CSGMembershipStatus,
        id_RABList,
        id_HNBConfigInfo,
        id_AccessResult,
        id_Update_cause,
        id_NeighbourInfoList,
        id_NeighbourInfoRequestList,
        id_Iurh_Signalling_TNL_Address,
        id_PSC,
        id_HNB_Cell_Identifier,
        id_Tunnel_Information,
        id_CELL_FACHMobilitySupport,
        id_S_RNTIPrefix,
        id_URAIdentity,
        id_NeighbourIdentity,
        id_HNBCapacity,
        id_NeighbourCellIdentityList,
        id_AdditionalNeighbourInfoList,
        id_U_RNTI,
        id_UnknownU_RNTIIndication,
        id_HNB_GWResponse,
        id_URAIdentityList,
    ]

class HNBAP_Containers:

    _name_  = 'HNBAP-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 6, 1, 5]
    
    _obj_ = [
        'HNBAP-PROTOCOL-IES',
        'HNBAP-PROTOCOL-EXTENSION',
        'HNBAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'HNBAP-PROTOCOL-IES',
        'HNBAP-PROTOCOL-EXTENSION',
        'HNBAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'HNBAP-PROTOCOL-IES',
        'HNBAP-PROTOCOL-EXTENSION',
        'HNBAP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< HNBAP-PROTOCOL-IES >-----#
    HNBAP_PROTOCOL_IES = CLASS(name='HNBAP-PROTOCOL-IES', mode=MODE_TYPE)
    _HNBAP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _HNBAP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Criticality')))
    _HNBAP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _HNBAP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Presence')))
    HNBAP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _HNBAP_PROTOCOL_IES_id),
        ('criticality', _HNBAP_PROTOCOL_IES_criticality),
        ('Value', _HNBAP_PROTOCOL_IES_Value),
        ('presence', _HNBAP_PROTOCOL_IES_presence),
        ])
    
    #-----< HNBAP-PROTOCOL-EXTENSION >-----#
    HNBAP_PROTOCOL_EXTENSION = CLASS(name='HNBAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _HNBAP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _HNBAP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Criticality')))
    _HNBAP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _HNBAP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Presence')))
    HNBAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _HNBAP_PROTOCOL_EXTENSION_id),
        ('criticality', _HNBAP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _HNBAP_PROTOCOL_EXTENSION_Extension),
        ('presence', _HNBAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< HNBAP-PRIVATE-IES >-----#
    HNBAP_PRIVATE_IES = CLASS(name='HNBAP-PRIVATE-IES', mode=MODE_TYPE)
    _HNBAP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'PrivateIE-ID')))
    _HNBAP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Criticality')))
    _HNBAP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _HNBAP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Presence')))
    HNBAP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _HNBAP_PRIVATE_IES_id),
        ('criticality', _HNBAP_PRIVATE_IES_criticality),
        ('Value', _HNBAP_PRIVATE_IES_Value),
        ('presence', _HNBAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _HNBAP_PROTOCOL_IES_id,
        _HNBAP_PROTOCOL_IES_criticality,
        _HNBAP_PROTOCOL_IES_Value,
        _HNBAP_PROTOCOL_IES_presence,
        HNBAP_PROTOCOL_IES,
        _HNBAP_PROTOCOL_EXTENSION_id,
        _HNBAP_PROTOCOL_EXTENSION_criticality,
        _HNBAP_PROTOCOL_EXTENSION_Extension,
        _HNBAP_PROTOCOL_EXTENSION_presence,
        HNBAP_PROTOCOL_EXTENSION,
        _HNBAP_PRIVATE_IES_id,
        _HNBAP_PRIVATE_IES_criticality,
        _HNBAP_PRIVATE_IES_Value,
        _HNBAP_PRIVATE_IES_presence,
        HNBAP_PRIVATE_IES,
    ]

class HNBAP_IEs:

    _name_  = 'HNBAP-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 6, 1, 2]
    
    _obj_ = [
        'Access-stratum-release-indicator',
        'AccessResult',
        'AltitudeAndDirection',
        'BackoffTimer',
        'BindingID',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CellIdentity',
        'CELL-FACHMobilitySupport',
        'Context-ID',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CSG-ID',
        'CSG-Capability',
        'CSGMembershipStatus',
        'CGI',
        'CGI-ExtIEs',
        'CI',
        'CN-DomainIndicator',
        'ESN',
        'GeographicalLocation',
        'GeographicLocation-ExtIEs',
        'GeographicalCoordinates',
        'GeographicalCoordinates-ExtIEs',
        'GTP-TEI',
        'HNBCapacity',
        'HNB-Cell-Access-Mode',
        'HNB-Cell-Identifier',
        'HNB-Cell-Identifier-ExtIEs',
        'HNB-GWResponse',
        'HNB-RNL-Identity',
        'HNBConfigInfo',
        'HNBConfigInfo-ExtIEs',
        'ConfigurationInformation',
        'HNBConfigurationInformationProvided',
        'HNBConfigurationInformationProvided-ExtIEs',
        'HNBConfigurationInformationMissing',
        'HNBConfigurationInformationMissing-ExtIEs',
        'HNB-Location-Information',
        'HNB-Location-Information-ExtIEs',
        'HNB-Identity',
        'HNB-Identity-ExtIEs',
        'HNB-Identity-Info',
        'IMEI',
        'IMSI',
        'IMSIDS41',
        'IMSIESN',
        'IP-Address',
        'IP-Address-ExtIEs',
        'Ipv4Address',
        'Ipv6Address',
        'Iurh-Signalling-TNL-AddressList',
        'LAC',
        'LAI',
        'MacroCoverageInformation',
        'MacroCoverageInformation-ExtIEs',
        'MacroCellID',
        'MuxPortNumber',
        'NeighbourCellIdentityList',
        'NeighbourIdentity',
        'NeighbourInfoList',
        'AdditionalNeighbourInfoList',
        'NeighbourInfoRequestList',
        'NeighbourInfoRequestItem',
        'NeighbourInfoRequestItem-ExtIEs',
        'PLMNidentity',
        'PSC',
        'PTMSI',
        'PTMSIRAI',
        'RAB-ID',
        'RABList',
        'RABListItem',
        'RABListItem-ExtIEs',
        'RAC',
        'RAI',
        'Registration-Cause',
        'RNC-ID',
        'SAC',
        'S-RNTIPrefix',
        'TMSILAI',
        'TMSIDS41',
        'TransportInfo',
        'TransportInfo-ExtIEs',
        'TransportLayerAddress',
        'Tunnel-Information',
        'Tunnel-Information-ExtIEs',
        'TypeOfError',
        'UDP-Port-Number',
        'UE-Capabilities',
        'UE-Capabilities-ExtIEs',
        'UTRANCellID',
        'UTRANCellID-ExtIEs',
        'UE-Identity',
        'Update-cause',
        'URAIdentityList',
        'URAIdentity',
        'U-RNTI',
        'UnknownU-RNTIIndication',
        ]
    _type_ = [
        'Access-stratum-release-indicator',
        'AccessResult',
        'AltitudeAndDirection',
        'BackoffTimer',
        'BindingID',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CellIdentity',
        'CELL-FACHMobilitySupport',
        'Context-ID',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CSG-ID',
        'CSG-Capability',
        'CSGMembershipStatus',
        'CGI',
        'CI',
        'CN-DomainIndicator',
        'ESN',
        'GeographicalLocation',
        'GeographicalCoordinates',
        'GTP-TEI',
        'HNBCapacity',
        'HNB-Cell-Access-Mode',
        'HNB-Cell-Identifier',
        'HNB-GWResponse',
        'HNB-RNL-Identity',
        'HNBConfigInfo',
        'ConfigurationInformation',
        'HNBConfigurationInformationProvided',
        'HNBConfigurationInformationMissing',
        'HNB-Location-Information',
        'HNB-Identity',
        'HNB-Identity-Info',
        'IMEI',
        'IMSI',
        'IMSIDS41',
        'IMSIESN',
        'IP-Address',
        'Ipv4Address',
        'Ipv6Address',
        'Iurh-Signalling-TNL-AddressList',
        'LAC',
        'LAI',
        'MacroCoverageInformation',
        'MacroCellID',
        'MuxPortNumber',
        'NeighbourCellIdentityList',
        'NeighbourIdentity',
        'NeighbourInfoList',
        'AdditionalNeighbourInfoList',
        'NeighbourInfoRequestList',
        'NeighbourInfoRequestItem',
        'PLMNidentity',
        'PSC',
        'PTMSI',
        'PTMSIRAI',
        'RAB-ID',
        'RABList',
        'RABListItem',
        'RAC',
        'RAI',
        'Registration-Cause',
        'RNC-ID',
        'SAC',
        'S-RNTIPrefix',
        'TMSILAI',
        'TMSIDS41',
        'TransportInfo',
        'TransportLayerAddress',
        'Tunnel-Information',
        'TypeOfError',
        'UDP-Port-Number',
        'UE-Capabilities',
        'UTRANCellID',
        'UE-Identity',
        'Update-cause',
        'URAIdentityList',
        'URAIdentity',
        'U-RNTI',
        'UnknownU-RNTIIndication',
        ]
    _set_ = [
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CGI-ExtIEs',
        'GeographicLocation-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'HNB-Cell-Identifier-ExtIEs',
        'HNBConfigInfo-ExtIEs',
        'HNBConfigurationInformationProvided-ExtIEs',
        'HNBConfigurationInformationMissing-ExtIEs',
        'HNB-Location-Information-ExtIEs',
        'HNB-Identity-ExtIEs',
        'IP-Address-ExtIEs',
        'MacroCoverageInformation-ExtIEs',
        'NeighbourInfoRequestItem-ExtIEs',
        'RABListItem-ExtIEs',
        'TransportInfo-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UE-Capabilities-ExtIEs',
        'UTRANCellID-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CGI-ExtIEs',
        'GeographicLocation-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'HNB-Cell-Identifier-ExtIEs',
        'HNBConfigInfo-ExtIEs',
        'HNBConfigurationInformationProvided-ExtIEs',
        'HNBConfigurationInformationMissing-ExtIEs',
        'HNB-Location-Information-ExtIEs',
        'HNB-Identity-ExtIEs',
        'IP-Address-ExtIEs',
        'MacroCoverageInformation-ExtIEs',
        'NeighbourInfoRequestItem-ExtIEs',
        'RABListItem-ExtIEs',
        'TransportInfo-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UE-Capabilities-ExtIEs',
        'UTRANCellID-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< Access-stratum-release-indicator >-----#
    Access_stratum_release_indicator = ENUM(name='Access-stratum-release-indicator', mode=MODE_TYPE)
    Access_stratum_release_indicator._cont = ASN1Dict([('r99', 0), ('rel-4', 1), ('rel-5', 2), ('rel-6', 3), ('rel-7', 4), ('rel-8-and-beyond', 5)])
    Access_stratum_release_indicator._ext = []
    
    #-----< AccessResult >-----#
    AccessResult = ENUM(name='AccessResult', mode=MODE_TYPE)
    AccessResult._cont = ASN1Dict([('allowed', 0), ('notAllowed', 1)])
    AccessResult._ext = []
    
    #-----< AltitudeAndDirection >-----#
    AltitudeAndDirection = SEQ(name='AltitudeAndDirection', mode=MODE_TYPE)
    _AltitudeAndDirection_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AltitudeAndDirection_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _AltitudeAndDirection_directionOfAltitude._ext = None
    _AltitudeAndDirection_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AltitudeAndDirection_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    AltitudeAndDirection._cont = ASN1Dict([
        ('directionOfAltitude', _AltitudeAndDirection_directionOfAltitude),
        ('altitude', _AltitudeAndDirection_altitude),
        ])
    AltitudeAndDirection._ext = []
    
    #-----< BackoffTimer >-----#
    BackoffTimer = INT(name='BackoffTimer', mode=MODE_TYPE)
    BackoffTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3600)], ev=None, er=[])
    
    #-----< BindingID >-----#
    BindingID = OCT_STR(name='BindingID', mode=MODE_TYPE)
    BindingID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('overload', 0), ('unauthorised-Location', 1), ('unauthorised-HNB', 2), ('hNB-parameter-mismatch', 3), ('invalid-UE-identity', 4), ('uE-not-allowed-on-this-HNB', 5), ('uE-unauthorised', 6), ('connection-with-UE-lost', 7), ('ue-RRC-release', 8), ('hNB-not-registered', 9), ('unspecified', 10), ('normal', 11), ('uE-relocated', 12), ('ue-registered-in-another-HNB', 13), ('no-neighbour-information-available', 14), ('iurh-connection-to-that-neighbour-not-Allowed', 15)])
    CauseRadioNetwork._ext = ['no-neighbour-information-available', 'iurh-connection-to-that-neighbour-not-Allowed']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('processing-overload', 0), ('hardware-failure', 1), ('o-and-m-intervention', 2), ('unspecified', 3)])
    CauseMisc._ext = []
    
    #-----< CellIdentity >-----#
    CellIdentity = BIT_STR(name='CellIdentity', mode=MODE_TYPE)
    CellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< CELL-FACHMobilitySupport >-----#
    CELL_FACHMobilitySupport = ENUM(name='CELL-FACHMobilitySupport', mode=MODE_TYPE)
    CELL_FACHMobilitySupport._cont = ASN1Dict([('supported', 0)])
    CELL_FACHMobilitySupport._ext = []
    
    #-----< Context-ID >-----#
    Context_ID = BIT_STR(name='Context-ID', mode=MODE_TYPE)
    Context_ID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSG-ID >-----#
    CSG_ID = BIT_STR(name='CSG-ID', mode=MODE_TYPE)
    CSG_ID._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSG-Capability >-----#
    CSG_Capability = ENUM(name='CSG-Capability', mode=MODE_TYPE)
    CSG_Capability._cont = ASN1Dict([('csg-capable', 0), ('not-csg-capable', 1)])
    CSG_Capability._ext = []
    
    #-----< CSGMembershipStatus >-----#
    CSGMembershipStatus = ENUM(name='CSGMembershipStatus', mode=MODE_TYPE)
    CSGMembershipStatus._cont = ASN1Dict([('member', 0), ('non-member', 1)])
    CSGMembershipStatus._ext = []
    
    #-----< CGI >-----#
    CGI = SEQ(name='CGI', mode=MODE_TYPE)
    _CGI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PLMNidentity')))
    _CGI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'LAC')))
    _CGI_cI = OCT_STR(name='cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CI')))
    _CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__id._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__id._const_tab_at = None
    ___CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__criticality._const_tab = ____CGI_iE_Extensions__item__criticality_tab
    ___CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__extensionValue._const_tab = ____CGI_iE_Extensions__item__extensionValue_tab
    ___CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CGI_iE_Extensions__item__id),
        ('criticality', ___CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___CGI_iE_Extensions__item__extensionValue),
        ])
    __CGI_iE_Extensions__item_._ext = None
    _CGI_iE_Extensions._cont = __CGI_iE_Extensions__item_
    _CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI._cont = ASN1Dict([
        ('pLMNidentity', _CGI_pLMNidentity),
        ('lAC', _CGI_lAC),
        ('cI', _CGI_cI),
        ('iE-Extensions', _CGI_iE_Extensions),
        ])
    CGI._ext = None
    
    #-----< CGI-ExtIEs >-----#
    CGI_ExtIEs = CLASS(name='CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CI >-----#
    CI = OCT_STR(name='CI', mode=MODE_TYPE)
    CI._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CN-DomainIndicator >-----#
    CN_DomainIndicator = ENUM(name='CN-DomainIndicator', mode=MODE_TYPE)
    CN_DomainIndicator._cont = ASN1Dict([('cs-domain', 0), ('ps-domain', 1)])
    CN_DomainIndicator._ext = None
    
    #-----< ESN >-----#
    ESN = BIT_STR(name='ESN', mode=MODE_TYPE)
    ESN._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< GeographicalLocation >-----#
    GeographicalLocation = SEQ(name='GeographicalLocation', mode=MODE_TYPE)
    _GeographicalLocation_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'GeographicalCoordinates')))
    _GeographicalLocation_altitudeAndDirection = SEQ(name='altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'AltitudeAndDirection')))
    _GeographicalLocation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalLocation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___GeographicalLocation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeographicalLocation_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____GeographicalLocation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalLocation_iE_Extensions__item__id._const_tab = ____GeographicalLocation_iE_Extensions__item__id_tab
    ___GeographicalLocation_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalLocation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeographicalLocation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeographicalLocation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____GeographicalLocation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalLocation_iE_Extensions__item__criticality._const_tab = ____GeographicalLocation_iE_Extensions__item__criticality_tab
    ___GeographicalLocation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeographicalLocation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeographicalLocation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeographicalLocation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____GeographicalLocation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalLocation_iE_Extensions__item__extensionValue._const_tab = ____GeographicalLocation_iE_Extensions__item__extensionValue_tab
    ___GeographicalLocation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeographicalLocation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeographicalLocation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeographicalLocation_iE_Extensions__item__id),
        ('criticality', ___GeographicalLocation_iE_Extensions__item__criticality),
        ('extensionValue', ___GeographicalLocation_iE_Extensions__item__extensionValue),
        ])
    __GeographicalLocation_iE_Extensions__item_._ext = None
    _GeographicalLocation_iE_Extensions._cont = __GeographicalLocation_iE_Extensions__item_
    _GeographicalLocation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalLocation._cont = ASN1Dict([
        ('geographicalCoordinates', _GeographicalLocation_geographicalCoordinates),
        ('altitudeAndDirection', _GeographicalLocation_altitudeAndDirection),
        ('iE-Extensions', _GeographicalLocation_iE_Extensions),
        ])
    GeographicalLocation._ext = []
    
    #-----< GeographicLocation-ExtIEs >-----#
    GeographicLocation_ExtIEs = CLASS(name='GeographicLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    GeographicLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name='GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeographicalCoordinates_iE_Extensions__item__id),
        ('criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        ('latitudeSign', _GeographicalCoordinates_latitudeSign),
        ('latitude', _GeographicalCoordinates_latitude),
        ('longitude', _GeographicalCoordinates_longitude),
        ('iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name='GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTP-TEI >-----#
    GTP_TEI = OCT_STR(name='GTP-TEI', mode=MODE_TYPE)
    GTP_TEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< HNBCapacity >-----#
    HNBCapacity = INT(name='HNBCapacity', mode=MODE_TYPE)
    HNBCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< HNB-Cell-Access-Mode >-----#
    HNB_Cell_Access_Mode = ENUM(name='HNB-Cell-Access-Mode', mode=MODE_TYPE)
    HNB_Cell_Access_Mode._cont = ASN1Dict([('closed', 0), ('hybrid', 1), ('open', 2)])
    HNB_Cell_Access_Mode._ext = []
    
    #-----< HNB-Cell-Identifier >-----#
    HNB_Cell_Identifier = SEQ(name='HNB-Cell-Identifier', mode=MODE_TYPE)
    _HNB_Cell_Identifier_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PLMNidentity')))
    _HNB_Cell_Identifier_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CellIdentity')))
    _HNB_Cell_Identifier_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNB_Cell_Identifier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNB_Cell_Identifier_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNB_Cell_Identifier_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNB_Cell_Identifier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Cell_Identifier_iE_Extensions__item__id._const_tab = ____HNB_Cell_Identifier_iE_Extensions__item__id_tab
    ___HNB_Cell_Identifier_iE_Extensions__item__id._const_tab_at = None
    ___HNB_Cell_Identifier_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality._const_tab = ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNB_Cell_Identifier_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue._const_tab = ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNB_Cell_Identifier_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNB_Cell_Identifier_iE_Extensions__item__id),
        ('criticality', ___HNB_Cell_Identifier_iE_Extensions__item__criticality),
        ('extensionValue', ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue),
        ])
    __HNB_Cell_Identifier_iE_Extensions__item_._ext = None
    _HNB_Cell_Identifier_iE_Extensions._cont = __HNB_Cell_Identifier_iE_Extensions__item_
    _HNB_Cell_Identifier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNB_Cell_Identifier._cont = ASN1Dict([
        ('pLMNidentity', _HNB_Cell_Identifier_pLMNidentity),
        ('cellIdentity', _HNB_Cell_Identifier_cellIdentity),
        ('iE-Extensions', _HNB_Cell_Identifier_iE_Extensions),
        ])
    HNB_Cell_Identifier._ext = []
    
    #-----< HNB-Cell-Identifier-ExtIEs >-----#
    HNB_Cell_Identifier_ExtIEs = CLASS(name='HNB-Cell-Identifier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNB_Cell_Identifier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNB-GWResponse >-----#
    HNB_GWResponse = CHOICE(name='HNB-GWResponse', mode=MODE_TYPE)
    _HNB_GWResponse_hNB = SEQ(name='hNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNBConfigInfo')))
    _HNB_GWResponse_macroRNC = INT(name='macroRNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'RNC-ID')))
    _HNB_GWResponse_unknownU_RNTIIndication = ENUM(name='unknownU-RNTIIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'UnknownU-RNTIIndication')))
    HNB_GWResponse._cont = ASN1Dict([
        ('hNB', _HNB_GWResponse_hNB),
        ('macroRNC', _HNB_GWResponse_macroRNC),
        ('unknownU-RNTIIndication', _HNB_GWResponse_unknownU_RNTIIndication),
        ])
    HNB_GWResponse._ext = []
    
    #-----< HNB-RNL-Identity >-----#
    HNB_RNL_Identity = CHOICE(name='HNB-RNL-Identity', mode=MODE_TYPE)
    _HNB_RNL_Identity_hNB_Identity_as_Cell_Identifier = SEQ(name='hNB-Identity-as-Cell-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Cell-Identifier')))
    HNB_RNL_Identity._cont = ASN1Dict([
        ('hNB-Identity-as-Cell-Identifier', _HNB_RNL_Identity_hNB_Identity_as_Cell_Identifier),
        ])
    HNB_RNL_Identity._ext = []
    
    #-----< HNBConfigInfo >-----#
    HNBConfigInfo = SEQ(name='HNBConfigInfo', mode=MODE_TYPE)
    _HNBConfigInfo_hnb_RNL_Identity = CHOICE(name='hnb-RNL-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNB-RNL-Identity')))
    _HNBConfigInfo_configurationInformation = CHOICE(name='configurationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'ConfigurationInformation')))
    _HNBConfigInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBConfigInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBConfigInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBConfigInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigInfo_iE_Extensions__item__id._const_tab = ____HNBConfigInfo_iE_Extensions__item__id_tab
    ___HNBConfigInfo_iE_Extensions__item__id._const_tab_at = None
    ___HNBConfigInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNBConfigInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNBConfigInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigInfo_iE_Extensions__item__criticality._const_tab = ____HNBConfigInfo_iE_Extensions__item__criticality_tab
    ___HNBConfigInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNBConfigInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigInfo_iE_Extensions__item__extensionValue._const_tab = ____HNBConfigInfo_iE_Extensions__item__extensionValue_tab
    ___HNBConfigInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBConfigInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBConfigInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNBConfigInfo_iE_Extensions__item__id),
        ('criticality', ___HNBConfigInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___HNBConfigInfo_iE_Extensions__item__extensionValue),
        ])
    __HNBConfigInfo_iE_Extensions__item_._ext = None
    _HNBConfigInfo_iE_Extensions._cont = __HNBConfigInfo_iE_Extensions__item_
    _HNBConfigInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBConfigInfo._cont = ASN1Dict([
        ('hnb-RNL-Identity', _HNBConfigInfo_hnb_RNL_Identity),
        ('configurationInformation', _HNBConfigInfo_configurationInformation),
        ('iE-Extensions', _HNBConfigInfo_iE_Extensions),
        ])
    HNBConfigInfo._ext = []
    
    #-----< HNBConfigInfo-ExtIEs >-----#
    HNBConfigInfo_ExtIEs = CLASS(name='HNBConfigInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNBConfigInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ConfigurationInformation >-----#
    ConfigurationInformation = CHOICE(name='ConfigurationInformation', mode=MODE_TYPE)
    _ConfigurationInformation_provided = SEQ(name='provided', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNBConfigurationInformationProvided')))
    _ConfigurationInformation_missing = SEQ(name='missing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNBConfigurationInformationMissing')))
    ConfigurationInformation._cont = ASN1Dict([
        ('provided', _ConfigurationInformation_provided),
        ('missing', _ConfigurationInformation_missing),
        ])
    ConfigurationInformation._ext = []
    
    #-----< HNBConfigurationInformationProvided >-----#
    HNBConfigurationInformationProvided = SEQ(name='HNBConfigurationInformationProvided', mode=MODE_TYPE)
    _HNBConfigurationInformationProvided_psc = BIT_STR(name='psc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PSC')), opt=True)
    _HNBConfigurationInformationProvided_cSG_ID = BIT_STR(name='cSG-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CSG-ID')), opt=True)
    _HNBConfigurationInformationProvided_hNB_Cell_Access_Mode = ENUM(name='hNB-Cell-Access-Mode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Cell-Access-Mode')))
    _HNBConfigurationInformationProvided_iurh_Signalling_TNL_AddressList = SEQ_OF(name='iurh-Signalling-TNL-AddressList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'Iurh-Signalling-TNL-AddressList')))
    _HNBConfigurationInformationProvided_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBConfigurationInformationProvided_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBConfigurationInformationProvided_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'S-RNTIPrefix')))
    _____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'URAIdentityList')))
    ____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'ignore'), ('Extension', _____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'ignore'), ('Extension', _____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HNBConfigurationInformationProvided_iE_Extensions__item__id._const_tab = ____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab
    ___HNBConfigurationInformationProvided_iE_Extensions__item__id._const_tab_at = None
    ___HNBConfigurationInformationProvided_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNBConfigurationInformationProvided_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HNBConfigurationInformationProvided_iE_Extensions__item__criticality._const_tab = ____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab
    ___HNBConfigurationInformationProvided_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigurationInformationProvided_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigurationInformationProvided_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HNBConfigurationInformationProvided_iE_Extensions__item__extensionValue._const_tab = ____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab
    ___HNBConfigurationInformationProvided_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBConfigurationInformationProvided_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBConfigurationInformationProvided_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNBConfigurationInformationProvided_iE_Extensions__item__id),
        ('criticality', ___HNBConfigurationInformationProvided_iE_Extensions__item__criticality),
        ('extensionValue', ___HNBConfigurationInformationProvided_iE_Extensions__item__extensionValue),
        ])
    __HNBConfigurationInformationProvided_iE_Extensions__item_._ext = None
    _HNBConfigurationInformationProvided_iE_Extensions._cont = __HNBConfigurationInformationProvided_iE_Extensions__item_
    _HNBConfigurationInformationProvided_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBConfigurationInformationProvided._cont = ASN1Dict([
        ('psc', _HNBConfigurationInformationProvided_psc),
        ('cSG-ID', _HNBConfigurationInformationProvided_cSG_ID),
        ('hNB-Cell-Access-Mode', _HNBConfigurationInformationProvided_hNB_Cell_Access_Mode),
        ('iurh-Signalling-TNL-AddressList', _HNBConfigurationInformationProvided_iurh_Signalling_TNL_AddressList),
        ('iE-Extensions', _HNBConfigurationInformationProvided_iE_Extensions),
        ])
    HNBConfigurationInformationProvided._ext = []
    
    #-----< HNBConfigurationInformationProvided-ExtIEs >-----#
    HNBConfigurationInformationProvided_ExtIEs = CLASS(name='HNBConfigurationInformationProvided-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _HNBConfigurationInformationProvided_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'S-RNTIPrefix')))
    _HNBConfigurationInformationProvided_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'URAIdentityList')))
    HNBConfigurationInformationProvided_ExtIEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'ignore'), ('Extension', _HNBConfigurationInformationProvided_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'ignore'), ('Extension', _HNBConfigurationInformationProvided_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HNBConfigurationInformationMissing >-----#
    HNBConfigurationInformationMissing = SEQ(name='HNBConfigurationInformationMissing', mode=MODE_TYPE)
    _HNBConfigurationInformationMissing_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _HNBConfigurationInformationMissing_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBConfigurationInformationMissing_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBConfigurationInformationMissing_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBConfigurationInformationMissing_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigurationInformationMissing_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigurationInformationMissing_iE_Extensions__item__id._const_tab = ____HNBConfigurationInformationMissing_iE_Extensions__item__id_tab
    ___HNBConfigurationInformationMissing_iE_Extensions__item__id._const_tab_at = None
    ___HNBConfigurationInformationMissing_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNBConfigurationInformationMissing_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNBConfigurationInformationMissing_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigurationInformationMissing_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigurationInformationMissing_iE_Extensions__item__criticality._const_tab = ____HNBConfigurationInformationMissing_iE_Extensions__item__criticality_tab
    ___HNBConfigurationInformationMissing_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigurationInformationMissing_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue._const_tab = ____HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue_tab
    ___HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBConfigurationInformationMissing_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNBConfigurationInformationMissing_iE_Extensions__item__id),
        ('criticality', ___HNBConfigurationInformationMissing_iE_Extensions__item__criticality),
        ('extensionValue', ___HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue),
        ])
    __HNBConfigurationInformationMissing_iE_Extensions__item_._ext = None
    _HNBConfigurationInformationMissing_iE_Extensions._cont = __HNBConfigurationInformationMissing_iE_Extensions__item_
    _HNBConfigurationInformationMissing_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBConfigurationInformationMissing._cont = ASN1Dict([
        ('cause', _HNBConfigurationInformationMissing_cause),
        ('iE-Extensions', _HNBConfigurationInformationMissing_iE_Extensions),
        ])
    HNBConfigurationInformationMissing._ext = []
    
    #-----< HNBConfigurationInformationMissing-ExtIEs >-----#
    HNBConfigurationInformationMissing_ExtIEs = CLASS(name='HNBConfigurationInformationMissing-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNBConfigurationInformationMissing_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNB-Location-Information >-----#
    HNB_Location_Information = SEQ(name='HNB-Location-Information', mode=MODE_TYPE)
    _HNB_Location_Information_macroCoverageInfo = SEQ(name='macroCoverageInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'MacroCoverageInformation')), opt=True)
    _HNB_Location_Information_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'GeographicalLocation')), opt=True)
    _HNB_Location_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNB_Location_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNB_Location_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNB_Location_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____HNB_Location_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    ____HNB_Location_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'reject'), ('Extension', _____HNB_Location_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HNB_Location_Information_iE_Extensions__item__id._const_tab = ____HNB_Location_Information_iE_Extensions__item__id_tab
    ___HNB_Location_Information_iE_Extensions__item__id._const_tab_at = None
    ___HNB_Location_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNB_Location_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HNB_Location_Information_iE_Extensions__item__criticality._const_tab = ____HNB_Location_Information_iE_Extensions__item__id_tab
    ___HNB_Location_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNB_Location_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNB_Location_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HNB_Location_Information_iE_Extensions__item__extensionValue._const_tab = ____HNB_Location_Information_iE_Extensions__item__id_tab
    ___HNB_Location_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNB_Location_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNB_Location_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNB_Location_Information_iE_Extensions__item__id),
        ('criticality', ___HNB_Location_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HNB_Location_Information_iE_Extensions__item__extensionValue),
        ])
    __HNB_Location_Information_iE_Extensions__item_._ext = None
    _HNB_Location_Information_iE_Extensions._cont = __HNB_Location_Information_iE_Extensions__item_
    _HNB_Location_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNB_Location_Information._cont = ASN1Dict([
        ('macroCoverageInfo', _HNB_Location_Information_macroCoverageInfo),
        ('geographicalCoordinates', _HNB_Location_Information_geographicalCoordinates),
        ('iE-Extensions', _HNB_Location_Information_iE_Extensions),
        ])
    HNB_Location_Information._ext = []
    
    #-----< HNB-Location-Information-ExtIEs >-----#
    HNB_Location_Information_ExtIEs = CLASS(name='HNB-Location-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _HNB_Location_Information_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    HNB_Location_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'reject'), ('Extension', _HNB_Location_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HNB-Identity >-----#
    HNB_Identity = SEQ(name='HNB-Identity', mode=MODE_TYPE)
    _HNB_Identity_hNB_Identity_Info = OCT_STR(name='hNB-Identity-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Identity-Info')))
    _HNB_Identity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNB_Identity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNB_Identity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNB_Identity_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNB_Identity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Identity_iE_Extensions__item__id._const_tab = ____HNB_Identity_iE_Extensions__item__id_tab
    ___HNB_Identity_iE_Extensions__item__id._const_tab_at = None
    ___HNB_Identity_iE_Extensions__item__id._const_tab_id = 'id'
    ___HNB_Identity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNB_Identity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNB_Identity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Identity_iE_Extensions__item__criticality._const_tab = ____HNB_Identity_iE_Extensions__item__criticality_tab
    ___HNB_Identity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNB_Identity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HNB_Identity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNB_Identity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNB_Identity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNB_Identity_iE_Extensions__item__extensionValue._const_tab = ____HNB_Identity_iE_Extensions__item__extensionValue_tab
    ___HNB_Identity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNB_Identity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HNB_Identity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HNB_Identity_iE_Extensions__item__id),
        ('criticality', ___HNB_Identity_iE_Extensions__item__criticality),
        ('extensionValue', ___HNB_Identity_iE_Extensions__item__extensionValue),
        ])
    __HNB_Identity_iE_Extensions__item_._ext = None
    _HNB_Identity_iE_Extensions._cont = __HNB_Identity_iE_Extensions__item_
    _HNB_Identity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNB_Identity._cont = ASN1Dict([
        ('hNB-Identity-Info', _HNB_Identity_hNB_Identity_Info),
        ('iE-Extensions', _HNB_Identity_iE_Extensions),
        ])
    HNB_Identity._ext = []
    
    #-----< HNB-Identity-ExtIEs >-----#
    HNB_Identity_ExtIEs = CLASS(name='HNB-Identity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNB_Identity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNB-Identity-Info >-----#
    HNB_Identity_Info = OCT_STR(name='HNB-Identity-Info', mode=MODE_TYPE)
    HNB_Identity_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< IMEI >-----#
    IMEI = BIT_STR(name='IMEI', mode=MODE_TYPE)
    IMEI._const_sz = ASN1Set(rv=[60], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name='IMSI', mode=MODE_TYPE)
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< IMSIDS41 >-----#
    IMSIDS41 = OCT_STR(name='IMSIDS41', mode=MODE_TYPE)
    IMSIDS41._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< IMSIESN >-----#
    IMSIESN = SEQ(name='IMSIESN', mode=MODE_TYPE)
    _IMSIESN_iMSIDS41 = OCT_STR(name='iMSIDS41', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'IMSIDS41')))
    _IMSIESN_eSN = BIT_STR(name='eSN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'ESN')))
    IMSIESN._cont = ASN1Dict([
        ('iMSIDS41', _IMSIESN_iMSIDS41),
        ('eSN', _IMSIESN_eSN),
        ])
    IMSIESN._ext = None
    
    #-----< IP-Address >-----#
    IP_Address = SEQ(name='IP-Address', mode=MODE_TYPE)
    _IP_Address_ipaddress = CHOICE(name='ipaddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __IP_Address_ipaddress_ipv4info = OCT_STR(name='ipv4info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'Ipv4Address')))
    __IP_Address_ipaddress_ipv6info = OCT_STR(name='ipv6info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'Ipv6Address')))
    _IP_Address_ipaddress._cont = ASN1Dict([
        ('ipv4info', __IP_Address_ipaddress_ipv4info),
        ('ipv6info', __IP_Address_ipaddress_ipv6info),
        ])
    _IP_Address_ipaddress._ext = []
    _IP_Address_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IP_Address_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___IP_Address_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IP_Address_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____IP_Address_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IP_Address_iE_Extensions__item__id._const_tab = ____IP_Address_iE_Extensions__item__id_tab
    ___IP_Address_iE_Extensions__item__id._const_tab_at = None
    ___IP_Address_iE_Extensions__item__id._const_tab_id = 'id'
    ___IP_Address_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IP_Address_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____IP_Address_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IP_Address_iE_Extensions__item__criticality._const_tab = ____IP_Address_iE_Extensions__item__criticality_tab
    ___IP_Address_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IP_Address_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IP_Address_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IP_Address_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____IP_Address_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IP_Address_iE_Extensions__item__extensionValue._const_tab = ____IP_Address_iE_Extensions__item__extensionValue_tab
    ___IP_Address_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IP_Address_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IP_Address_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IP_Address_iE_Extensions__item__id),
        ('criticality', ___IP_Address_iE_Extensions__item__criticality),
        ('extensionValue', ___IP_Address_iE_Extensions__item__extensionValue),
        ])
    __IP_Address_iE_Extensions__item_._ext = None
    _IP_Address_iE_Extensions._cont = __IP_Address_iE_Extensions__item_
    _IP_Address_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IP_Address._cont = ASN1Dict([
        ('ipaddress', _IP_Address_ipaddress),
        ('iE-Extensions', _IP_Address_iE_Extensions),
        ])
    IP_Address._ext = []
    
    #-----< IP-Address-ExtIEs >-----#
    IP_Address_ExtIEs = CLASS(name='IP-Address-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    IP_Address_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ipv4Address >-----#
    Ipv4Address = OCT_STR(name='Ipv4Address', mode=MODE_TYPE)
    Ipv4Address._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< Ipv6Address >-----#
    Ipv6Address = OCT_STR(name='Ipv6Address', mode=MODE_TYPE)
    Ipv6Address._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< Iurh-Signalling-TNL-AddressList >-----#
    Iurh_Signalling_TNL_AddressList = SEQ_OF(name='Iurh-Signalling-TNL-AddressList', mode=MODE_TYPE)
    _Iurh_Signalling_TNL_AddressList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    Iurh_Signalling_TNL_AddressList._cont = _Iurh_Signalling_TNL_AddressList__item_
    Iurh_Signalling_TNL_AddressList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name='LAI', mode=MODE_TYPE)
    _LAI_pLMNID = OCT_STR(name='pLMNID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PLMNidentity')))
    _LAI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'LAC')))
    LAI._cont = ASN1Dict([
        ('pLMNID', _LAI_pLMNID),
        ('lAC', _LAI_lAC),
        ])
    LAI._ext = []
    
    #-----< MacroCoverageInformation >-----#
    MacroCoverageInformation = SEQ(name='MacroCoverageInformation', mode=MODE_TYPE)
    _MacroCoverageInformation_cellIdentity = CHOICE(name='cellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'MacroCellID')))
    _MacroCoverageInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MacroCoverageInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___MacroCoverageInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MacroCoverageInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____MacroCoverageInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MacroCoverageInformation_iE_Extensions__item__id._const_tab = ____MacroCoverageInformation_iE_Extensions__item__id_tab
    ___MacroCoverageInformation_iE_Extensions__item__id._const_tab_at = None
    ___MacroCoverageInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MacroCoverageInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MacroCoverageInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____MacroCoverageInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MacroCoverageInformation_iE_Extensions__item__criticality._const_tab = ____MacroCoverageInformation_iE_Extensions__item__criticality_tab
    ___MacroCoverageInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MacroCoverageInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MacroCoverageInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MacroCoverageInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____MacroCoverageInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MacroCoverageInformation_iE_Extensions__item__extensionValue._const_tab = ____MacroCoverageInformation_iE_Extensions__item__extensionValue_tab
    ___MacroCoverageInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MacroCoverageInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MacroCoverageInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MacroCoverageInformation_iE_Extensions__item__id),
        ('criticality', ___MacroCoverageInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MacroCoverageInformation_iE_Extensions__item__extensionValue),
        ])
    __MacroCoverageInformation_iE_Extensions__item_._ext = None
    _MacroCoverageInformation_iE_Extensions._cont = __MacroCoverageInformation_iE_Extensions__item_
    _MacroCoverageInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MacroCoverageInformation._cont = ASN1Dict([
        ('cellIdentity', _MacroCoverageInformation_cellIdentity),
        ('iE-Extensions', _MacroCoverageInformation_iE_Extensions),
        ])
    MacroCoverageInformation._ext = []
    
    #-----< MacroCoverageInformation-ExtIEs >-----#
    MacroCoverageInformation_ExtIEs = CLASS(name='MacroCoverageInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    MacroCoverageInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MacroCellID >-----#
    MacroCellID = CHOICE(name='MacroCellID', mode=MODE_TYPE)
    _MacroCellID_uTRANCellID = SEQ(name='uTRANCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'UTRANCellID')))
    _MacroCellID_gERANCellID = SEQ(name='gERANCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CGI')))
    MacroCellID._cont = ASN1Dict([
        ('uTRANCellID', _MacroCellID_uTRANCellID),
        ('gERANCellID', _MacroCellID_gERANCellID),
        ])
    MacroCellID._ext = []
    
    #-----< MuxPortNumber >-----#
    MuxPortNumber = INT(name='MuxPortNumber', mode=MODE_TYPE)
    MuxPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1024, ub=65535)], ev=None, er=[])
    
    #-----< NeighbourCellIdentityList >-----#
    NeighbourCellIdentityList = SEQ_OF(name='NeighbourCellIdentityList', mode=MODE_TYPE)
    _NeighbourCellIdentityList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourIdentity')))
    NeighbourCellIdentityList._cont = _NeighbourCellIdentityList__item_
    NeighbourCellIdentityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=128)], ev=None, er=[])
    
    #-----< NeighbourIdentity >-----#
    NeighbourIdentity = CHOICE(name='NeighbourIdentity', mode=MODE_TYPE)
    _NeighbourIdentity_hNB_RNL_Identity = CHOICE(name='hNB-RNL-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNB-RNL-Identity')))
    _NeighbourIdentity_cell_ID = BIT_STR(name='cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CellIdentity')))
    NeighbourIdentity._cont = ASN1Dict([
        ('hNB-RNL-Identity', _NeighbourIdentity_hNB_RNL_Identity),
        ('cell-ID', _NeighbourIdentity_cell_ID),
        ])
    NeighbourIdentity._ext = []
    
    #-----< NeighbourInfoList >-----#
    NeighbourInfoList = SEQ_OF(name='NeighbourInfoList', mode=MODE_TYPE)
    _NeighbourInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNBConfigInfo')))
    NeighbourInfoList._cont = _NeighbourInfoList__item_
    NeighbourInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AdditionalNeighbourInfoList >-----#
    AdditionalNeighbourInfoList = SEQ_OF(name='AdditionalNeighbourInfoList', mode=MODE_TYPE)
    _AdditionalNeighbourInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNBConfigInfo')))
    AdditionalNeighbourInfoList._cont = _AdditionalNeighbourInfoList__item_
    AdditionalNeighbourInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< NeighbourInfoRequestList >-----#
    NeighbourInfoRequestList = SEQ_OF(name='NeighbourInfoRequestList', mode=MODE_TYPE)
    _NeighbourInfoRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourInfoRequestItem')))
    NeighbourInfoRequestList._cont = _NeighbourInfoRequestList__item_
    NeighbourInfoRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NeighbourInfoRequestItem >-----#
    NeighbourInfoRequestItem = SEQ(name='NeighbourInfoRequestItem', mode=MODE_TYPE)
    _NeighbourInfoRequestItem_hnb_RNL_Identity = CHOICE(name='hnb-RNL-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'HNB-RNL-Identity')))
    _NeighbourInfoRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbourInfoRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___NeighbourInfoRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NeighbourInfoRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____NeighbourInfoRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbourInfoRequestItem_iE_Extensions__item__id._const_tab = ____NeighbourInfoRequestItem_iE_Extensions__item__id_tab
    ___NeighbourInfoRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___NeighbourInfoRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NeighbourInfoRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NeighbourInfoRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____NeighbourInfoRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbourInfoRequestItem_iE_Extensions__item__criticality._const_tab = ____NeighbourInfoRequestItem_iE_Extensions__item__criticality_tab
    ___NeighbourInfoRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NeighbourInfoRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NeighbourInfoRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NeighbourInfoRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____NeighbourInfoRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbourInfoRequestItem_iE_Extensions__item__extensionValue._const_tab = ____NeighbourInfoRequestItem_iE_Extensions__item__extensionValue_tab
    ___NeighbourInfoRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NeighbourInfoRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NeighbourInfoRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NeighbourInfoRequestItem_iE_Extensions__item__id),
        ('criticality', ___NeighbourInfoRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NeighbourInfoRequestItem_iE_Extensions__item__extensionValue),
        ])
    __NeighbourInfoRequestItem_iE_Extensions__item_._ext = None
    _NeighbourInfoRequestItem_iE_Extensions._cont = __NeighbourInfoRequestItem_iE_Extensions__item_
    _NeighbourInfoRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbourInfoRequestItem._cont = ASN1Dict([
        ('hnb-RNL-Identity', _NeighbourInfoRequestItem_hnb_RNL_Identity),
        ('iE-Extensions', _NeighbourInfoRequestItem_iE_Extensions),
        ])
    NeighbourInfoRequestItem._ext = []
    
    #-----< NeighbourInfoRequestItem-ExtIEs >-----#
    NeighbourInfoRequestItem_ExtIEs = CLASS(name='NeighbourInfoRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    NeighbourInfoRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNidentity >-----#
    PLMNidentity = OCT_STR(name='PLMNidentity', mode=MODE_TYPE)
    PLMNidentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PSC >-----#
    PSC = BIT_STR(name='PSC', mode=MODE_TYPE)
    PSC._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    
    #-----< PTMSI >-----#
    PTMSI = BIT_STR(name='PTMSI', mode=MODE_TYPE)
    PTMSI._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< PTMSIRAI >-----#
    PTMSIRAI = SEQ(name='PTMSIRAI', mode=MODE_TYPE)
    _PTMSIRAI_pTMSI = BIT_STR(name='pTMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PTMSI')))
    _PTMSIRAI_rAI = SEQ(name='rAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'RAI')))
    PTMSIRAI._cont = ASN1Dict([
        ('pTMSI', _PTMSIRAI_pTMSI),
        ('rAI', _PTMSIRAI_rAI),
        ])
    PTMSIRAI._ext = []
    
    #-----< RAB-ID >-----#
    RAB_ID = BIT_STR(name='RAB-ID', mode=MODE_TYPE)
    RAB_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RABList >-----#
    RABList = SEQ_OF(name='RABList', mode=MODE_TYPE)
    _RABList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RABListItem')))
    RABList._cont = _RABList__item_
    RABList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABListItem >-----#
    RABListItem = SEQ(name='RABListItem', mode=MODE_TYPE)
    _RABListItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'RAB-ID')))
    _RABListItem_old_transport_Info = SEQ(name='old-transport-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'TransportInfo')))
    _RABListItem_new_transport_Info = SEQ(name='new-transport-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'TransportInfo')))
    _RABListItem_cn_domain_indicator = ENUM(name='cn-domain-indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CN-DomainIndicator')))
    _RABListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___RABListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RABListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____RABListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABListItem_iE_Extensions__item__id._const_tab = ____RABListItem_iE_Extensions__item__id_tab
    ___RABListItem_iE_Extensions__item__id._const_tab_at = None
    ___RABListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RABListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RABListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____RABListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABListItem_iE_Extensions__item__criticality._const_tab = ____RABListItem_iE_Extensions__item__criticality_tab
    ___RABListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RABListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RABListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RABListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____RABListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABListItem_iE_Extensions__item__extensionValue._const_tab = ____RABListItem_iE_Extensions__item__extensionValue_tab
    ___RABListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RABListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RABListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RABListItem_iE_Extensions__item__id),
        ('criticality', ___RABListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RABListItem_iE_Extensions__item__extensionValue),
        ])
    __RABListItem_iE_Extensions__item_._ext = None
    _RABListItem_iE_Extensions._cont = __RABListItem_iE_Extensions__item_
    _RABListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABListItem._cont = ASN1Dict([
        ('rAB-ID', _RABListItem_rAB_ID),
        ('old-transport-Info', _RABListItem_old_transport_Info),
        ('new-transport-Info', _RABListItem_new_transport_Info),
        ('cn-domain-indicator', _RABListItem_cn_domain_indicator),
        ('iE-Extensions', _RABListItem_iE_Extensions),
        ])
    RABListItem._ext = []
    
    #-----< RABListItem-ExtIEs >-----#
    RABListItem_ExtIEs = CLASS(name='RABListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    RABListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAC >-----#
    RAC = OCT_STR(name='RAC', mode=MODE_TYPE)
    RAC._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RAI >-----#
    RAI = SEQ(name='RAI', mode=MODE_TYPE)
    _RAI_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'LAI')))
    _RAI_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'RAC')))
    RAI._cont = ASN1Dict([
        ('lAI', _RAI_lAI),
        ('rAC', _RAI_rAC),
        ])
    RAI._ext = []
    
    #-----< Registration-Cause >-----#
    Registration_Cause = ENUM(name='Registration-Cause', mode=MODE_TYPE)
    Registration_Cause._cont = ASN1Dict([('emergency-call', 0), ('normal', 1), ('ue-relocation', 2)])
    Registration_Cause._ext = ['ue-relocation']
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name='RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< SAC >-----#
    SAC = OCT_STR(name='SAC', mode=MODE_TYPE)
    SAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< S-RNTIPrefix >-----#
    S_RNTIPrefix = BIT_STR(name='S-RNTIPrefix', mode=MODE_TYPE)
    S_RNTIPrefix._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< TMSILAI >-----#
    TMSILAI = SEQ(name='TMSILAI', mode=MODE_TYPE)
    _TMSILAI_tMSI = BIT_STR(name='tMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TMSILAI_tMSI._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _TMSILAI_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'LAI')))
    TMSILAI._cont = ASN1Dict([
        ('tMSI', _TMSILAI_tMSI),
        ('lAI', _TMSILAI_lAI),
        ])
    TMSILAI._ext = None
    
    #-----< TMSIDS41 >-----#
    TMSIDS41 = OCT_STR(name='TMSIDS41', mode=MODE_TYPE)
    TMSIDS41._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=17)], ev=None, er=[])
    
    #-----< TransportInfo >-----#
    TransportInfo = SEQ(name='TransportInfo', mode=MODE_TYPE)
    _TransportInfo_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'TransportLayerAddress')))
    _TransportInfo_transportAssociation = CHOICE(name='transportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TransportInfo_transportAssociation_gtp_TEI = OCT_STR(name='gtp-TEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'GTP-TEI')))
    __TransportInfo_transportAssociation_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'BindingID')))
    _TransportInfo_transportAssociation._cont = ASN1Dict([
        ('gtp-TEI', __TransportInfo_transportAssociation_gtp_TEI),
        ('bindingID', __TransportInfo_transportAssociation_bindingID),
        ])
    _TransportInfo_transportAssociation._ext = []
    _TransportInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___TransportInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransportInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TransportInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportInfo_iE_Extensions__item__id._const_tab = ____TransportInfo_iE_Extensions__item__id_tab
    ___TransportInfo_iE_Extensions__item__id._const_tab_at = None
    ___TransportInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransportInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransportInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TransportInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportInfo_iE_Extensions__item__criticality._const_tab = ____TransportInfo_iE_Extensions__item__criticality_tab
    ___TransportInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransportInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransportInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransportInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TransportInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportInfo_iE_Extensions__item__extensionValue._const_tab = ____TransportInfo_iE_Extensions__item__extensionValue_tab
    ___TransportInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransportInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransportInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransportInfo_iE_Extensions__item__id),
        ('criticality', ___TransportInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TransportInfo_iE_Extensions__item__extensionValue),
        ])
    __TransportInfo_iE_Extensions__item_._ext = None
    _TransportInfo_iE_Extensions._cont = __TransportInfo_iE_Extensions__item_
    _TransportInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportInfo._cont = ASN1Dict([
        ('transportLayerAddress', _TransportInfo_transportLayerAddress),
        ('transportAssociation', _TransportInfo_transportAssociation),
        ('iE-Extensions', _TransportInfo_iE_Extensions),
        ])
    TransportInfo._ext = []
    
    #-----< TransportInfo-ExtIEs >-----#
    TransportInfo_ExtIEs = CLASS(name='TransportInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    TransportInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< Tunnel-Information >-----#
    Tunnel_Information = SEQ(name='Tunnel-Information', mode=MODE_TYPE)
    _Tunnel_Information_iP_Address = SEQ(name='iP-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    _Tunnel_Information_uDP_Port_Number = OCT_STR(name='uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'UDP-Port-Number')), opt=True)
    _Tunnel_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Tunnel_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___Tunnel_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Tunnel_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____Tunnel_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Tunnel_Information_iE_Extensions__item__id._const_tab = ____Tunnel_Information_iE_Extensions__item__id_tab
    ___Tunnel_Information_iE_Extensions__item__id._const_tab_at = None
    ___Tunnel_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Tunnel_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Tunnel_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____Tunnel_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Tunnel_Information_iE_Extensions__item__criticality._const_tab = ____Tunnel_Information_iE_Extensions__item__criticality_tab
    ___Tunnel_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Tunnel_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Tunnel_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Tunnel_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____Tunnel_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Tunnel_Information_iE_Extensions__item__extensionValue._const_tab = ____Tunnel_Information_iE_Extensions__item__extensionValue_tab
    ___Tunnel_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Tunnel_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Tunnel_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Tunnel_Information_iE_Extensions__item__id),
        ('criticality', ___Tunnel_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Tunnel_Information_iE_Extensions__item__extensionValue),
        ])
    __Tunnel_Information_iE_Extensions__item_._ext = None
    _Tunnel_Information_iE_Extensions._cont = __Tunnel_Information_iE_Extensions__item_
    _Tunnel_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Tunnel_Information._cont = ASN1Dict([
        ('iP-Address', _Tunnel_Information_iP_Address),
        ('uDP-Port-Number', _Tunnel_Information_uDP_Port_Number),
        ('iE-Extensions', _Tunnel_Information_iE_Extensions),
        ])
    Tunnel_Information._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name='Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< UDP-Port-Number >-----#
    UDP_Port_Number = OCT_STR(name='UDP-Port-Number', mode=MODE_TYPE)
    UDP_Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< UE-Capabilities >-----#
    UE_Capabilities = SEQ(name='UE-Capabilities', mode=MODE_TYPE)
    _UE_Capabilities_access_stratum_release_indicator = ENUM(name='access-stratum-release-indicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'Access-stratum-release-indicator')))
    _UE_Capabilities_csg_capability = ENUM(name='csg-capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CSG-Capability')))
    _UE_Capabilities_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Capabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___UE_Capabilities_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Capabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UE_Capabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Capabilities_iE_Extensions__item__id._const_tab = ____UE_Capabilities_iE_Extensions__item__id_tab
    ___UE_Capabilities_iE_Extensions__item__id._const_tab_at = None
    ___UE_Capabilities_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Capabilities_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_Capabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UE_Capabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Capabilities_iE_Extensions__item__criticality._const_tab = ____UE_Capabilities_iE_Extensions__item__criticality_tab
    ___UE_Capabilities_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Capabilities_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Capabilities_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_Capabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UE_Capabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Capabilities_iE_Extensions__item__extensionValue._const_tab = ____UE_Capabilities_iE_Extensions__item__extensionValue_tab
    ___UE_Capabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Capabilities_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Capabilities_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Capabilities_iE_Extensions__item__id),
        ('criticality', ___UE_Capabilities_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Capabilities_iE_Extensions__item__extensionValue),
        ])
    __UE_Capabilities_iE_Extensions__item_._ext = None
    _UE_Capabilities_iE_Extensions._cont = __UE_Capabilities_iE_Extensions__item_
    _UE_Capabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Capabilities._cont = ASN1Dict([
        ('access-stratum-release-indicator', _UE_Capabilities_access_stratum_release_indicator),
        ('csg-capability', _UE_Capabilities_csg_capability),
        ('iE-Extensions', _UE_Capabilities_iE_Extensions),
        ])
    UE_Capabilities._ext = []
    
    #-----< UE-Capabilities-ExtIEs >-----#
    UE_Capabilities_ExtIEs = CLASS(name='UE-Capabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    UE_Capabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTRANCellID >-----#
    UTRANCellID = SEQ(name='UTRANCellID', mode=MODE_TYPE)
    _UTRANCellID_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'LAC')))
    _UTRANCellID_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'RAC')))
    _UTRANCellID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PLMNidentity')))
    _UTRANCellID_uTRANcellID = BIT_STR(name='uTRANcellID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'CellIdentity')))
    _UTRANCellID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRANCellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___UTRANCellID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRANCellID_iE_Extensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UTRANCellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRANCellID_iE_Extensions__item__id._const_tab = ____UTRANCellID_iE_Extensions__item__id_tab
    ___UTRANCellID_iE_Extensions__item__id._const_tab_at = None
    ___UTRANCellID_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTRANCellID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRANCellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UTRANCellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRANCellID_iE_Extensions__item__criticality._const_tab = ____UTRANCellID_iE_Extensions__item__criticality_tab
    ___UTRANCellID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRANCellID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRANCellID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRANCellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UTRANCellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRANCellID_iE_Extensions__item__extensionValue._const_tab = ____UTRANCellID_iE_Extensions__item__extensionValue_tab
    ___UTRANCellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRANCellID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRANCellID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRANCellID_iE_Extensions__item__id),
        ('criticality', ___UTRANCellID_iE_Extensions__item__criticality),
        ('extensionValue', ___UTRANCellID_iE_Extensions__item__extensionValue),
        ])
    __UTRANCellID_iE_Extensions__item_._ext = None
    _UTRANCellID_iE_Extensions._cont = __UTRANCellID_iE_Extensions__item_
    _UTRANCellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRANCellID._cont = ASN1Dict([
        ('lAC', _UTRANCellID_lAC),
        ('rAC', _UTRANCellID_rAC),
        ('pLMNidentity', _UTRANCellID_pLMNidentity),
        ('uTRANcellID', _UTRANCellID_uTRANcellID),
        ('iE-Extensions', _UTRANCellID_iE_Extensions),
        ])
    UTRANCellID._ext = None
    
    #-----< UTRANCellID-ExtIEs >-----#
    UTRANCellID_ExtIEs = CLASS(name='UTRANCellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    UTRANCellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Identity >-----#
    UE_Identity = CHOICE(name='UE-Identity', mode=MODE_TYPE)
    _UE_Identity_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'IMSI')))
    _UE_Identity_tMSILAI = SEQ(name='tMSILAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'TMSILAI')))
    _UE_Identity_pTMSIRAI = SEQ(name='pTMSIRAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'PTMSIRAI')))
    _UE_Identity_iMEI = BIT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'IMEI')))
    _UE_Identity_eSN = BIT_STR(name='eSN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'ESN')))
    _UE_Identity_iMSIDS41 = OCT_STR(name='iMSIDS41', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'IMSIDS41')))
    _UE_Identity_iMSIESN = SEQ(name='iMSIESN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'IMSIESN')))
    _UE_Identity_tMSIDS41 = OCT_STR(name='tMSIDS41', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-IEs', 'TMSIDS41')))
    UE_Identity._cont = ASN1Dict([
        ('iMSI', _UE_Identity_iMSI),
        ('tMSILAI', _UE_Identity_tMSILAI),
        ('pTMSIRAI', _UE_Identity_pTMSIRAI),
        ('iMEI', _UE_Identity_iMEI),
        ('eSN', _UE_Identity_eSN),
        ('iMSIDS41', _UE_Identity_iMSIDS41),
        ('iMSIESN', _UE_Identity_iMSIESN),
        ('tMSIDS41', _UE_Identity_tMSIDS41),
        ])
    UE_Identity._ext = []
    
    #-----< Update-cause >-----#
    Update_cause = ENUM(name='Update-cause', mode=MODE_TYPE)
    Update_cause._cont = ASN1Dict([('relocation-preparation', 0)])
    Update_cause._ext = []
    
    #-----< URAIdentityList >-----#
    URAIdentityList = SEQ_OF(name='URAIdentityList', mode=MODE_TYPE)
    _URAIdentityList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'URAIdentity')))
    URAIdentityList._cont = _URAIdentityList__item_
    URAIdentityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< URAIdentity >-----#
    URAIdentity = INT(name='URAIdentity', mode=MODE_TYPE)
    URAIdentity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< U-RNTI >-----#
    U_RNTI = BIT_STR(name='U-RNTI', mode=MODE_TYPE)
    U_RNTI._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< UnknownU-RNTIIndication >-----#
    UnknownU_RNTIIndication = ENUM(name='UnknownU-RNTIIndication', mode=MODE_TYPE)
    UnknownU_RNTIIndication._cont = ASN1Dict([('unknown', 0)])
    UnknownU_RNTIIndication._ext = []
    
    _all_ = [
        Access_stratum_release_indicator,
        AccessResult,
        _AltitudeAndDirection_directionOfAltitude,
        _AltitudeAndDirection_altitude,
        AltitudeAndDirection,
        BackoffTimer,
        BindingID,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseRadioNetwork,
        CauseTransport,
        CauseProtocol,
        CauseMisc,
        CellIdentity,
        CELL_FACHMobilitySupport,
        Context_ID,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        CriticalityDiagnostics_ExtIEs,
        CSG_ID,
        CSG_Capability,
        CSGMembershipStatus,
        _CGI_pLMNidentity,
        _CGI_lAC,
        _CGI_cI,
        ____CGI_iE_Extensions__item__id_tab,
        ___CGI_iE_Extensions__item__id,
        ____CGI_iE_Extensions__item__criticality_tab,
        ___CGI_iE_Extensions__item__criticality,
        ____CGI_iE_Extensions__item__extensionValue_tab,
        ___CGI_iE_Extensions__item__extensionValue,
        __CGI_iE_Extensions__item_,
        _CGI_iE_Extensions,
        CGI,
        CGI_ExtIEs,
        CI,
        CN_DomainIndicator,
        ESN,
        _GeographicalLocation_geographicalCoordinates,
        _GeographicalLocation_altitudeAndDirection,
        ____GeographicalLocation_iE_Extensions__item__id_tab,
        ___GeographicalLocation_iE_Extensions__item__id,
        ____GeographicalLocation_iE_Extensions__item__criticality_tab,
        ___GeographicalLocation_iE_Extensions__item__criticality,
        ____GeographicalLocation_iE_Extensions__item__extensionValue_tab,
        ___GeographicalLocation_iE_Extensions__item__extensionValue,
        __GeographicalLocation_iE_Extensions__item_,
        _GeographicalLocation_iE_Extensions,
        GeographicalLocation,
        GeographicLocation_ExtIEs,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ____GeographicalCoordinates_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        GTP_TEI,
        HNBCapacity,
        HNB_Cell_Access_Mode,
        _HNB_Cell_Identifier_pLMNidentity,
        _HNB_Cell_Identifier_cellIdentity,
        ____HNB_Cell_Identifier_iE_Extensions__item__id_tab,
        ___HNB_Cell_Identifier_iE_Extensions__item__id,
        ____HNB_Cell_Identifier_iE_Extensions__item__criticality_tab,
        ___HNB_Cell_Identifier_iE_Extensions__item__criticality,
        ____HNB_Cell_Identifier_iE_Extensions__item__extensionValue_tab,
        ___HNB_Cell_Identifier_iE_Extensions__item__extensionValue,
        __HNB_Cell_Identifier_iE_Extensions__item_,
        _HNB_Cell_Identifier_iE_Extensions,
        HNB_Cell_Identifier,
        HNB_Cell_Identifier_ExtIEs,
        _HNB_GWResponse_hNB,
        _HNB_GWResponse_macroRNC,
        _HNB_GWResponse_unknownU_RNTIIndication,
        HNB_GWResponse,
        _HNB_RNL_Identity_hNB_Identity_as_Cell_Identifier,
        HNB_RNL_Identity,
        _HNBConfigInfo_hnb_RNL_Identity,
        _HNBConfigInfo_configurationInformation,
        ____HNBConfigInfo_iE_Extensions__item__id_tab,
        ___HNBConfigInfo_iE_Extensions__item__id,
        ____HNBConfigInfo_iE_Extensions__item__criticality_tab,
        ___HNBConfigInfo_iE_Extensions__item__criticality,
        ____HNBConfigInfo_iE_Extensions__item__extensionValue_tab,
        ___HNBConfigInfo_iE_Extensions__item__extensionValue,
        __HNBConfigInfo_iE_Extensions__item_,
        _HNBConfigInfo_iE_Extensions,
        HNBConfigInfo,
        HNBConfigInfo_ExtIEs,
        _ConfigurationInformation_provided,
        _ConfigurationInformation_missing,
        ConfigurationInformation,
        _HNBConfigurationInformationProvided_psc,
        _HNBConfigurationInformationProvided_cSG_ID,
        _HNBConfigurationInformationProvided_hNB_Cell_Access_Mode,
        _HNBConfigurationInformationProvided_iurh_Signalling_TNL_AddressList,
        ____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab,
        _____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab_val_Extension_0,
        _____HNBConfigurationInformationProvided_iE_Extensions__item__id_tab_val_Extension_1,
        ___HNBConfigurationInformationProvided_iE_Extensions__item__id,
        ___HNBConfigurationInformationProvided_iE_Extensions__item__criticality,
        ___HNBConfigurationInformationProvided_iE_Extensions__item__extensionValue,
        __HNBConfigurationInformationProvided_iE_Extensions__item_,
        _HNBConfigurationInformationProvided_iE_Extensions,
        HNBConfigurationInformationProvided,
        HNBConfigurationInformationProvided_ExtIEs,
        _HNBConfigurationInformationProvided_ExtIEs_val_Extension_0,
        _HNBConfigurationInformationProvided_ExtIEs_val_Extension_1,
        _HNBConfigurationInformationMissing_cause,
        ____HNBConfigurationInformationMissing_iE_Extensions__item__id_tab,
        ___HNBConfigurationInformationMissing_iE_Extensions__item__id,
        ____HNBConfigurationInformationMissing_iE_Extensions__item__criticality_tab,
        ___HNBConfigurationInformationMissing_iE_Extensions__item__criticality,
        ____HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue_tab,
        ___HNBConfigurationInformationMissing_iE_Extensions__item__extensionValue,
        __HNBConfigurationInformationMissing_iE_Extensions__item_,
        _HNBConfigurationInformationMissing_iE_Extensions,
        HNBConfigurationInformationMissing,
        HNBConfigurationInformationMissing_ExtIEs,
        _HNB_Location_Information_macroCoverageInfo,
        _HNB_Location_Information_geographicalCoordinates,
        ____HNB_Location_Information_iE_Extensions__item__id_tab,
        _____HNB_Location_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___HNB_Location_Information_iE_Extensions__item__id,
        ___HNB_Location_Information_iE_Extensions__item__criticality,
        ___HNB_Location_Information_iE_Extensions__item__extensionValue,
        __HNB_Location_Information_iE_Extensions__item_,
        _HNB_Location_Information_iE_Extensions,
        HNB_Location_Information,
        HNB_Location_Information_ExtIEs,
        _HNB_Location_Information_ExtIEs_val_Extension_0,
        _HNB_Identity_hNB_Identity_Info,
        ____HNB_Identity_iE_Extensions__item__id_tab,
        ___HNB_Identity_iE_Extensions__item__id,
        ____HNB_Identity_iE_Extensions__item__criticality_tab,
        ___HNB_Identity_iE_Extensions__item__criticality,
        ____HNB_Identity_iE_Extensions__item__extensionValue_tab,
        ___HNB_Identity_iE_Extensions__item__extensionValue,
        __HNB_Identity_iE_Extensions__item_,
        _HNB_Identity_iE_Extensions,
        HNB_Identity,
        HNB_Identity_ExtIEs,
        HNB_Identity_Info,
        IMEI,
        IMSI,
        IMSIDS41,
        _IMSIESN_iMSIDS41,
        _IMSIESN_eSN,
        IMSIESN,
        __IP_Address_ipaddress_ipv4info,
        __IP_Address_ipaddress_ipv6info,
        _IP_Address_ipaddress,
        ____IP_Address_iE_Extensions__item__id_tab,
        ___IP_Address_iE_Extensions__item__id,
        ____IP_Address_iE_Extensions__item__criticality_tab,
        ___IP_Address_iE_Extensions__item__criticality,
        ____IP_Address_iE_Extensions__item__extensionValue_tab,
        ___IP_Address_iE_Extensions__item__extensionValue,
        __IP_Address_iE_Extensions__item_,
        _IP_Address_iE_Extensions,
        IP_Address,
        IP_Address_ExtIEs,
        Ipv4Address,
        Ipv6Address,
        _Iurh_Signalling_TNL_AddressList__item_,
        Iurh_Signalling_TNL_AddressList,
        LAC,
        _LAI_pLMNID,
        _LAI_lAC,
        LAI,
        _MacroCoverageInformation_cellIdentity,
        ____MacroCoverageInformation_iE_Extensions__item__id_tab,
        ___MacroCoverageInformation_iE_Extensions__item__id,
        ____MacroCoverageInformation_iE_Extensions__item__criticality_tab,
        ___MacroCoverageInformation_iE_Extensions__item__criticality,
        ____MacroCoverageInformation_iE_Extensions__item__extensionValue_tab,
        ___MacroCoverageInformation_iE_Extensions__item__extensionValue,
        __MacroCoverageInformation_iE_Extensions__item_,
        _MacroCoverageInformation_iE_Extensions,
        MacroCoverageInformation,
        MacroCoverageInformation_ExtIEs,
        _MacroCellID_uTRANCellID,
        _MacroCellID_gERANCellID,
        MacroCellID,
        MuxPortNumber,
        _NeighbourCellIdentityList__item_,
        NeighbourCellIdentityList,
        _NeighbourIdentity_hNB_RNL_Identity,
        _NeighbourIdentity_cell_ID,
        NeighbourIdentity,
        _NeighbourInfoList__item_,
        NeighbourInfoList,
        _AdditionalNeighbourInfoList__item_,
        AdditionalNeighbourInfoList,
        _NeighbourInfoRequestList__item_,
        NeighbourInfoRequestList,
        _NeighbourInfoRequestItem_hnb_RNL_Identity,
        ____NeighbourInfoRequestItem_iE_Extensions__item__id_tab,
        ___NeighbourInfoRequestItem_iE_Extensions__item__id,
        ____NeighbourInfoRequestItem_iE_Extensions__item__criticality_tab,
        ___NeighbourInfoRequestItem_iE_Extensions__item__criticality,
        ____NeighbourInfoRequestItem_iE_Extensions__item__extensionValue_tab,
        ___NeighbourInfoRequestItem_iE_Extensions__item__extensionValue,
        __NeighbourInfoRequestItem_iE_Extensions__item_,
        _NeighbourInfoRequestItem_iE_Extensions,
        NeighbourInfoRequestItem,
        NeighbourInfoRequestItem_ExtIEs,
        PLMNidentity,
        PSC,
        PTMSI,
        _PTMSIRAI_pTMSI,
        _PTMSIRAI_rAI,
        PTMSIRAI,
        RAB_ID,
        _RABList__item_,
        RABList,
        _RABListItem_rAB_ID,
        _RABListItem_old_transport_Info,
        _RABListItem_new_transport_Info,
        _RABListItem_cn_domain_indicator,
        ____RABListItem_iE_Extensions__item__id_tab,
        ___RABListItem_iE_Extensions__item__id,
        ____RABListItem_iE_Extensions__item__criticality_tab,
        ___RABListItem_iE_Extensions__item__criticality,
        ____RABListItem_iE_Extensions__item__extensionValue_tab,
        ___RABListItem_iE_Extensions__item__extensionValue,
        __RABListItem_iE_Extensions__item_,
        _RABListItem_iE_Extensions,
        RABListItem,
        RABListItem_ExtIEs,
        RAC,
        _RAI_lAI,
        _RAI_rAC,
        RAI,
        Registration_Cause,
        RNC_ID,
        SAC,
        S_RNTIPrefix,
        _TMSILAI_tMSI,
        _TMSILAI_lAI,
        TMSILAI,
        TMSIDS41,
        _TransportInfo_transportLayerAddress,
        __TransportInfo_transportAssociation_gtp_TEI,
        __TransportInfo_transportAssociation_bindingID,
        _TransportInfo_transportAssociation,
        ____TransportInfo_iE_Extensions__item__id_tab,
        ___TransportInfo_iE_Extensions__item__id,
        ____TransportInfo_iE_Extensions__item__criticality_tab,
        ___TransportInfo_iE_Extensions__item__criticality,
        ____TransportInfo_iE_Extensions__item__extensionValue_tab,
        ___TransportInfo_iE_Extensions__item__extensionValue,
        __TransportInfo_iE_Extensions__item_,
        _TransportInfo_iE_Extensions,
        TransportInfo,
        TransportInfo_ExtIEs,
        TransportLayerAddress,
        _Tunnel_Information_iP_Address,
        _Tunnel_Information_uDP_Port_Number,
        ____Tunnel_Information_iE_Extensions__item__id_tab,
        ___Tunnel_Information_iE_Extensions__item__id,
        ____Tunnel_Information_iE_Extensions__item__criticality_tab,
        ___Tunnel_Information_iE_Extensions__item__criticality,
        ____Tunnel_Information_iE_Extensions__item__extensionValue_tab,
        ___Tunnel_Information_iE_Extensions__item__extensionValue,
        __Tunnel_Information_iE_Extensions__item_,
        _Tunnel_Information_iE_Extensions,
        Tunnel_Information,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        UDP_Port_Number,
        _UE_Capabilities_access_stratum_release_indicator,
        _UE_Capabilities_csg_capability,
        ____UE_Capabilities_iE_Extensions__item__id_tab,
        ___UE_Capabilities_iE_Extensions__item__id,
        ____UE_Capabilities_iE_Extensions__item__criticality_tab,
        ___UE_Capabilities_iE_Extensions__item__criticality,
        ____UE_Capabilities_iE_Extensions__item__extensionValue_tab,
        ___UE_Capabilities_iE_Extensions__item__extensionValue,
        __UE_Capabilities_iE_Extensions__item_,
        _UE_Capabilities_iE_Extensions,
        UE_Capabilities,
        UE_Capabilities_ExtIEs,
        _UTRANCellID_lAC,
        _UTRANCellID_rAC,
        _UTRANCellID_pLMNidentity,
        _UTRANCellID_uTRANcellID,
        ____UTRANCellID_iE_Extensions__item__id_tab,
        ___UTRANCellID_iE_Extensions__item__id,
        ____UTRANCellID_iE_Extensions__item__criticality_tab,
        ___UTRANCellID_iE_Extensions__item__criticality,
        ____UTRANCellID_iE_Extensions__item__extensionValue_tab,
        ___UTRANCellID_iE_Extensions__item__extensionValue,
        __UTRANCellID_iE_Extensions__item_,
        _UTRANCellID_iE_Extensions,
        UTRANCellID,
        UTRANCellID_ExtIEs,
        _UE_Identity_iMSI,
        _UE_Identity_tMSILAI,
        _UE_Identity_pTMSIRAI,
        _UE_Identity_iMEI,
        _UE_Identity_eSN,
        _UE_Identity_iMSIDS41,
        _UE_Identity_iMSIESN,
        _UE_Identity_tMSIDS41,
        UE_Identity,
        Update_cause,
        _URAIdentityList__item_,
        URAIdentityList,
        URAIdentity,
        U_RNTI,
        UnknownU_RNTIIndication,
    ]

class HNBAP_PDU_Contents:

    _name_  = 'HNBAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 6, 1, 1]
    
    _obj_ = [
        'HNBRegisterRequest',
        'HNBRegisterRequestIEs',
        'HNBRegisterRequestExtensions',
        'HNBRegisterAccept',
        'HNBRegisterResponseIEs',
        'HNBRegisterResponseExtensions',
        'HNBRegisterReject',
        'HNBRegisterRejectIEs',
        'HNBRegisterRejectExtensions',
        'HNBDe-Register',
        'HNBDe-RegisterIEs',
        'HNBDe-RegisterExtensions',
        'UERegisterRequest',
        'UERegisterRequestIEs',
        'UERegisterRequestExtensions',
        'UERegisterAccept',
        'UERegisterAcceptIEs',
        'UERegisterAcceptExtensions',
        'UERegisterReject',
        'UERegisterRejectIEs',
        'UERegisterRejectExtensions',
        'UEDe-Register',
        'UEDe-RegisterIEs',
        'UEDe-RegisterExtensions',
        'CSGMembershipUpdate',
        'CSGMembershipUpdateIEs',
        'CSGMembershipUpdateExtensions',
        'TNLUpdateRequest',
        'TNLUpdateRequestIEs',
        'TNLUpdateExtensions',
        'TNLUpdateResponse',
        'TNLUpdateResponseIEs',
        'TNLUpdateResponseExtensions',
        'TNLUpdateFailure',
        'TNLUpdateFailureIEs',
        'TNLUpdateFailureExtensions',
        'HNBConfigTransferRequest',
        'HNBConfigTransferRequestIEs',
        'HNBConfigTransferRequestExtensions',
        'HNBConfigTransferResponse',
        'HNBConfigTransferResponseIEs',
        'HNBConfigTransferResponseExtensions',
        'RelocationComplete',
        'RelocationCompleteIEs',
        'RelocationCompleteExtensions',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'U-RNTIQueryRequest',
        'U-RNTIQueryRequestIEs',
        'U-RNTIQueryRequestExtensions',
        'U-RNTIQueryResponse',
        'U-RNTIQueryResponseIEs',
        'U-RNTIQueryResponseExtensions',
        ]
    _type_ = [
        'HNBRegisterRequest',
        'HNBRegisterAccept',
        'HNBRegisterReject',
        'HNBDe-Register',
        'UERegisterRequest',
        'UERegisterAccept',
        'UERegisterReject',
        'UEDe-Register',
        'CSGMembershipUpdate',
        'TNLUpdateRequest',
        'TNLUpdateResponse',
        'TNLUpdateFailure',
        'HNBConfigTransferRequest',
        'HNBConfigTransferResponse',
        'RelocationComplete',
        'ErrorIndication',
        'PrivateMessage',
        'U-RNTIQueryRequest',
        'U-RNTIQueryResponse',
        ]
    _set_ = [
        'HNBRegisterRequestIEs',
        'HNBRegisterRequestExtensions',
        'HNBRegisterResponseIEs',
        'HNBRegisterResponseExtensions',
        'HNBRegisterRejectIEs',
        'HNBRegisterRejectExtensions',
        'HNBDe-RegisterIEs',
        'HNBDe-RegisterExtensions',
        'UERegisterRequestIEs',
        'UERegisterRequestExtensions',
        'UERegisterAcceptIEs',
        'UERegisterAcceptExtensions',
        'UERegisterRejectIEs',
        'UERegisterRejectExtensions',
        'UEDe-RegisterIEs',
        'UEDe-RegisterExtensions',
        'CSGMembershipUpdateIEs',
        'CSGMembershipUpdateExtensions',
        'TNLUpdateRequestIEs',
        'TNLUpdateExtensions',
        'TNLUpdateResponseIEs',
        'TNLUpdateResponseExtensions',
        'TNLUpdateFailureIEs',
        'TNLUpdateFailureExtensions',
        'HNBConfigTransferRequestIEs',
        'HNBConfigTransferRequestExtensions',
        'HNBConfigTransferResponseIEs',
        'HNBConfigTransferResponseExtensions',
        'RelocationCompleteIEs',
        'RelocationCompleteExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage-IEs',
        'U-RNTIQueryRequestIEs',
        'U-RNTIQueryRequestExtensions',
        'U-RNTIQueryResponseIEs',
        'U-RNTIQueryResponseExtensions',
        ]
    _val_ = [
        ]
    _class_ = [
        'HNBRegisterRequestIEs',
        'HNBRegisterRequestExtensions',
        'HNBRegisterResponseIEs',
        'HNBRegisterResponseExtensions',
        'HNBRegisterRejectIEs',
        'HNBRegisterRejectExtensions',
        'HNBDe-RegisterIEs',
        'HNBDe-RegisterExtensions',
        'UERegisterRequestIEs',
        'UERegisterRequestExtensions',
        'UERegisterAcceptIEs',
        'UERegisterAcceptExtensions',
        'UERegisterRejectIEs',
        'UERegisterRejectExtensions',
        'UEDe-RegisterIEs',
        'UEDe-RegisterExtensions',
        'CSGMembershipUpdateIEs',
        'CSGMembershipUpdateExtensions',
        'TNLUpdateRequestIEs',
        'TNLUpdateExtensions',
        'TNLUpdateResponseIEs',
        'TNLUpdateResponseExtensions',
        'TNLUpdateFailureIEs',
        'TNLUpdateFailureExtensions',
        'HNBConfigTransferRequestIEs',
        'HNBConfigTransferRequestExtensions',
        'HNBConfigTransferResponseIEs',
        'HNBConfigTransferResponseExtensions',
        'RelocationCompleteIEs',
        'RelocationCompleteExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PrivateMessage-IEs',
        'U-RNTIQueryRequestIEs',
        'U-RNTIQueryRequestExtensions',
        'U-RNTIQueryResponseIEs',
        'U-RNTIQueryResponseExtensions',
        ]
    _param_ = [
        ]
    
    #-----< HNBRegisterRequest >-----#
    HNBRegisterRequest = SEQ(name='HNBRegisterRequest', mode=MODE_TYPE)
    _HNBRegisterRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __HNBRegisterRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___HNBRegisterRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____HNBRegisterRequest_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Identity')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Location-Information')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'PLMNidentity')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CellIdentity')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'LAC')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RAC')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'SAC')))
    _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CSG-ID')))
    ____HNBRegisterRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'reject'), ('Value', _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HNBRegisterRequest_protocolIEs__item__id._const_tab = ____HNBRegisterRequest_protocolIEs__item__id_tab
    ___HNBRegisterRequest_protocolIEs__item__id._const_tab_at = None
    ___HNBRegisterRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___HNBRegisterRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___HNBRegisterRequest_protocolIEs__item__criticality._const_tab = ____HNBRegisterRequest_protocolIEs__item__id_tab
    ___HNBRegisterRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HNBRegisterRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HNBRegisterRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___HNBRegisterRequest_protocolIEs__item__value._const_tab = ____HNBRegisterRequest_protocolIEs__item__id_tab
    ___HNBRegisterRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HNBRegisterRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __HNBRegisterRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HNBRegisterRequest_protocolIEs__item__id),
        ('criticality', ___HNBRegisterRequest_protocolIEs__item__criticality),
        ('value', ___HNBRegisterRequest_protocolIEs__item__value),
        ])
    __HNBRegisterRequest_protocolIEs__item_._ext = None
    _HNBRegisterRequest_protocolIEs._cont = __HNBRegisterRequest_protocolIEs__item_
    _HNBRegisterRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HNBRegisterRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBRegisterRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBRegisterRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBRegisterRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'SAC')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Cell-Access-Mode')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'PSC')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Tunnel-Information')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CELL-FACHMobilitySupport')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourCellIdentityList')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'URAIdentityList')))
    _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNBCapacity')))
    ____HNBRegisterRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 18), ('criticality', 'reject'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 30), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 47), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 46), ('criticality', 'ignore'), ('Extension', _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HNBRegisterRequest_protocolExtensions__item__id._const_tab = ____HNBRegisterRequest_protocolExtensions__item__id_tab
    ___HNBRegisterRequest_protocolExtensions__item__id._const_tab_at = None
    ___HNBRegisterRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___HNBRegisterRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HNBRegisterRequest_protocolExtensions__item__criticality._const_tab = ____HNBRegisterRequest_protocolExtensions__item__id_tab
    ___HNBRegisterRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBRegisterRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___HNBRegisterRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HNBRegisterRequest_protocolExtensions__item__extensionValue._const_tab = ____HNBRegisterRequest_protocolExtensions__item__id_tab
    ___HNBRegisterRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBRegisterRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBRegisterRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___HNBRegisterRequest_protocolExtensions__item__id),
        ('criticality', ___HNBRegisterRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___HNBRegisterRequest_protocolExtensions__item__extensionValue),
        ])
    __HNBRegisterRequest_protocolExtensions__item_._ext = None
    _HNBRegisterRequest_protocolExtensions._cont = __HNBRegisterRequest_protocolExtensions__item_
    _HNBRegisterRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBRegisterRequest._cont = ASN1Dict([
        ('protocolIEs', _HNBRegisterRequest_protocolIEs),
        ('protocolExtensions', _HNBRegisterRequest_protocolExtensions),
        ])
    HNBRegisterRequest._ext = []
    
    #-----< HNBRegisterRequestIEs >-----#
    HNBRegisterRequestIEs = CLASS(name='HNBRegisterRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _HNBRegisterRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Identity')))
    _HNBRegisterRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Location-Information')))
    _HNBRegisterRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'PLMNidentity')))
    _HNBRegisterRequestIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CellIdentity')))
    _HNBRegisterRequestIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'LAC')))
    _HNBRegisterRequestIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RAC')))
    _HNBRegisterRequestIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'SAC')))
    _HNBRegisterRequestIEs_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CSG-ID')))
    HNBRegisterRequestIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'reject'), ('Value', _HNBRegisterRequestIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HNBRegisterRequestExtensions >-----#
    HNBRegisterRequestExtensions = CLASS(name='HNBRegisterRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _HNBRegisterRequestExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'SAC')))
    _HNBRegisterRequestExtensions_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-Cell-Access-Mode')))
    _HNBRegisterRequestExtensions_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'PSC')))
    _HNBRegisterRequestExtensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    _HNBRegisterRequestExtensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Tunnel-Information')))
    _HNBRegisterRequestExtensions_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CELL-FACHMobilitySupport')))
    _HNBRegisterRequestExtensions_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourCellIdentityList')))
    _HNBRegisterRequestExtensions_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'URAIdentityList')))
    _HNBRegisterRequestExtensions_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNBCapacity')))
    HNBRegisterRequestExtensions._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 18), ('criticality', 'reject'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 30), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 47), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 46), ('criticality', 'ignore'), ('Extension', _HNBRegisterRequestExtensions_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HNBRegisterAccept >-----#
    HNBRegisterAccept = SEQ(name='HNBRegisterAccept', mode=MODE_TYPE)
    _HNBRegisterAccept_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __HNBRegisterAccept_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___HNBRegisterAccept_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____HNBRegisterAccept_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____HNBRegisterAccept_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RNC-ID')))
    ____HNBRegisterAccept_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'reject'), ('Value', _____HNBRegisterAccept_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HNBRegisterAccept_protocolIEs__item__id._const_tab = ____HNBRegisterAccept_protocolIEs__item__id_tab
    ___HNBRegisterAccept_protocolIEs__item__id._const_tab_at = None
    ___HNBRegisterAccept_protocolIEs__item__id._const_tab_id = 'id'
    ___HNBRegisterAccept_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___HNBRegisterAccept_protocolIEs__item__criticality._const_tab = ____HNBRegisterAccept_protocolIEs__item__id_tab
    ___HNBRegisterAccept_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HNBRegisterAccept_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HNBRegisterAccept_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___HNBRegisterAccept_protocolIEs__item__value._const_tab = ____HNBRegisterAccept_protocolIEs__item__id_tab
    ___HNBRegisterAccept_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HNBRegisterAccept_protocolIEs__item__value._const_tab_id = 'Value'
    __HNBRegisterAccept_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HNBRegisterAccept_protocolIEs__item__id),
        ('criticality', ___HNBRegisterAccept_protocolIEs__item__criticality),
        ('value', ___HNBRegisterAccept_protocolIEs__item__value),
        ])
    __HNBRegisterAccept_protocolIEs__item_._ext = None
    _HNBRegisterAccept_protocolIEs._cont = __HNBRegisterAccept_protocolIEs__item_
    _HNBRegisterAccept_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HNBRegisterAccept_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBRegisterAccept_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBRegisterAccept_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBRegisterAccept_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'MuxPortNumber')))
    _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'S-RNTIPrefix')))
    ____HNBRegisterAccept_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Extension', _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Extension', _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'ignore'), ('Extension', _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HNBRegisterAccept_protocolExtensions__item__id._const_tab = ____HNBRegisterAccept_protocolExtensions__item__id_tab
    ___HNBRegisterAccept_protocolExtensions__item__id._const_tab_at = None
    ___HNBRegisterAccept_protocolExtensions__item__id._const_tab_id = 'id'
    ___HNBRegisterAccept_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HNBRegisterAccept_protocolExtensions__item__criticality._const_tab = ____HNBRegisterAccept_protocolExtensions__item__id_tab
    ___HNBRegisterAccept_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBRegisterAccept_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___HNBRegisterAccept_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HNBRegisterAccept_protocolExtensions__item__extensionValue._const_tab = ____HNBRegisterAccept_protocolExtensions__item__id_tab
    ___HNBRegisterAccept_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBRegisterAccept_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBRegisterAccept_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___HNBRegisterAccept_protocolExtensions__item__id),
        ('criticality', ___HNBRegisterAccept_protocolExtensions__item__criticality),
        ('extensionValue', ___HNBRegisterAccept_protocolExtensions__item__extensionValue),
        ])
    __HNBRegisterAccept_protocolExtensions__item_._ext = None
    _HNBRegisterAccept_protocolExtensions._cont = __HNBRegisterAccept_protocolExtensions__item_
    _HNBRegisterAccept_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBRegisterAccept._cont = ASN1Dict([
        ('protocolIEs', _HNBRegisterAccept_protocolIEs),
        ('protocolExtensions', _HNBRegisterAccept_protocolExtensions),
        ])
    HNBRegisterAccept._ext = []
    
    #-----< HNBRegisterResponseIEs >-----#
    HNBRegisterResponseIEs = CLASS(name='HNBRegisterResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _HNBRegisterResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RNC-ID')))
    HNBRegisterResponseIEs._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'reject'), ('Value', _HNBRegisterResponseIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HNBRegisterResponseExtensions >-----#
    HNBRegisterResponseExtensions = CLASS(name='HNBRegisterResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _HNBRegisterResponseExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'MuxPortNumber')))
    _HNBRegisterResponseExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'IP-Address')))
    _HNBRegisterResponseExtensions_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'S-RNTIPrefix')))
    HNBRegisterResponseExtensions._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Extension', _HNBRegisterResponseExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Extension', _HNBRegisterResponseExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'ignore'), ('Extension', _HNBRegisterResponseExtensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HNBRegisterReject >-----#
    HNBRegisterReject = SEQ(name='HNBRegisterReject', mode=MODE_TYPE)
    _HNBRegisterReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __HNBRegisterReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___HNBRegisterReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____HNBRegisterReject_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'BackoffTimer')))
    ____HNBRegisterReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 16), ('criticality', 'reject'), ('Value', _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___HNBRegisterReject_protocolIEs__item__id._const_tab = ____HNBRegisterReject_protocolIEs__item__id_tab
    ___HNBRegisterReject_protocolIEs__item__id._const_tab_at = None
    ___HNBRegisterReject_protocolIEs__item__id._const_tab_id = 'id'
    ___HNBRegisterReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___HNBRegisterReject_protocolIEs__item__criticality._const_tab = ____HNBRegisterReject_protocolIEs__item__id_tab
    ___HNBRegisterReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HNBRegisterReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HNBRegisterReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___HNBRegisterReject_protocolIEs__item__value._const_tab = ____HNBRegisterReject_protocolIEs__item__id_tab
    ___HNBRegisterReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HNBRegisterReject_protocolIEs__item__value._const_tab_id = 'Value'
    __HNBRegisterReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HNBRegisterReject_protocolIEs__item__id),
        ('criticality', ___HNBRegisterReject_protocolIEs__item__criticality),
        ('value', ___HNBRegisterReject_protocolIEs__item__value),
        ])
    __HNBRegisterReject_protocolIEs__item_._ext = None
    _HNBRegisterReject_protocolIEs._cont = __HNBRegisterReject_protocolIEs__item_
    _HNBRegisterReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HNBRegisterReject_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBRegisterReject_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBRegisterReject_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBRegisterReject_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBRegisterReject_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBRegisterReject_protocolExtensions__item__id._const_tab = ____HNBRegisterReject_protocolExtensions__item__id_tab
    ___HNBRegisterReject_protocolExtensions__item__id._const_tab_at = None
    ___HNBRegisterReject_protocolExtensions__item__id._const_tab_id = 'id'
    ___HNBRegisterReject_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNBRegisterReject_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBRegisterReject_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBRegisterReject_protocolExtensions__item__criticality._const_tab = ____HNBRegisterReject_protocolExtensions__item__criticality_tab
    ___HNBRegisterReject_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBRegisterReject_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___HNBRegisterReject_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNBRegisterReject_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBRegisterReject_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBRegisterReject_protocolExtensions__item__extensionValue._const_tab = ____HNBRegisterReject_protocolExtensions__item__extensionValue_tab
    ___HNBRegisterReject_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBRegisterReject_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBRegisterReject_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___HNBRegisterReject_protocolExtensions__item__id),
        ('criticality', ___HNBRegisterReject_protocolExtensions__item__criticality),
        ('extensionValue', ___HNBRegisterReject_protocolExtensions__item__extensionValue),
        ])
    __HNBRegisterReject_protocolExtensions__item_._ext = None
    _HNBRegisterReject_protocolExtensions._cont = __HNBRegisterReject_protocolExtensions__item_
    _HNBRegisterReject_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBRegisterReject._cont = ASN1Dict([
        ('protocolIEs', _HNBRegisterReject_protocolIEs),
        ('protocolExtensions', _HNBRegisterReject_protocolExtensions),
        ])
    HNBRegisterReject._ext = []
    
    #-----< HNBRegisterRejectIEs >-----#
    HNBRegisterRejectIEs = CLASS(name='HNBRegisterRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _HNBRegisterRejectIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _HNBRegisterRejectIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    _HNBRegisterRejectIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'BackoffTimer')))
    HNBRegisterRejectIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _HNBRegisterRejectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _HNBRegisterRejectIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 16), ('criticality', 'reject'), ('Value', _HNBRegisterRejectIEs_val_Value_2), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< HNBRegisterRejectExtensions >-----#
    HNBRegisterRejectExtensions = CLASS(name='HNBRegisterRejectExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNBRegisterRejectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNBDe-Register >-----#
    HNBDe_Register = SEQ(name='HNBDe-Register', mode=MODE_TYPE)
    _HNBDe_Register_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __HNBDe_Register_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___HNBDe_Register_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____HNBDe_Register_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____HNBDe_Register_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _____HNBDe_Register_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'BackoffTimer')))
    ____HNBDe_Register_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____HNBDe_Register_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 16), ('criticality', 'reject'), ('Value', _____HNBDe_Register_protocolIEs__item__id_tab_val_Value_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___HNBDe_Register_protocolIEs__item__id._const_tab = ____HNBDe_Register_protocolIEs__item__id_tab
    ___HNBDe_Register_protocolIEs__item__id._const_tab_at = None
    ___HNBDe_Register_protocolIEs__item__id._const_tab_id = 'id'
    ___HNBDe_Register_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___HNBDe_Register_protocolIEs__item__criticality._const_tab = ____HNBDe_Register_protocolIEs__item__id_tab
    ___HNBDe_Register_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HNBDe_Register_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HNBDe_Register_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___HNBDe_Register_protocolIEs__item__value._const_tab = ____HNBDe_Register_protocolIEs__item__id_tab
    ___HNBDe_Register_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HNBDe_Register_protocolIEs__item__value._const_tab_id = 'Value'
    __HNBDe_Register_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HNBDe_Register_protocolIEs__item__id),
        ('criticality', ___HNBDe_Register_protocolIEs__item__criticality),
        ('value', ___HNBDe_Register_protocolIEs__item__value),
        ])
    __HNBDe_Register_protocolIEs__item_._ext = None
    _HNBDe_Register_protocolIEs._cont = __HNBDe_Register_protocolIEs__item_
    _HNBDe_Register_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HNBDe_Register_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBDe_Register_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBDe_Register_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBDe_Register_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBDe_Register_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBDe_Register_protocolExtensions__item__id._const_tab = ____HNBDe_Register_protocolExtensions__item__id_tab
    ___HNBDe_Register_protocolExtensions__item__id._const_tab_at = None
    ___HNBDe_Register_protocolExtensions__item__id._const_tab_id = 'id'
    ___HNBDe_Register_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNBDe_Register_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBDe_Register_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBDe_Register_protocolExtensions__item__criticality._const_tab = ____HNBDe_Register_protocolExtensions__item__criticality_tab
    ___HNBDe_Register_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBDe_Register_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___HNBDe_Register_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNBDe_Register_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBDe_Register_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBDe_Register_protocolExtensions__item__extensionValue._const_tab = ____HNBDe_Register_protocolExtensions__item__extensionValue_tab
    ___HNBDe_Register_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBDe_Register_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBDe_Register_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___HNBDe_Register_protocolExtensions__item__id),
        ('criticality', ___HNBDe_Register_protocolExtensions__item__criticality),
        ('extensionValue', ___HNBDe_Register_protocolExtensions__item__extensionValue),
        ])
    __HNBDe_Register_protocolExtensions__item_._ext = None
    _HNBDe_Register_protocolExtensions._cont = __HNBDe_Register_protocolExtensions__item_
    _HNBDe_Register_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBDe_Register._cont = ASN1Dict([
        ('protocolIEs', _HNBDe_Register_protocolIEs),
        ('protocolExtensions', _HNBDe_Register_protocolExtensions),
        ])
    HNBDe_Register._ext = []
    
    #-----< HNBDe-RegisterIEs >-----#
    HNBDe_RegisterIEs = CLASS(name='HNBDe-RegisterIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _HNBDe_RegisterIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _HNBDe_RegisterIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'BackoffTimer')))
    HNBDe_RegisterIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _HNBDe_RegisterIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 16), ('criticality', 'reject'), ('Value', _HNBDe_RegisterIEs_val_Value_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< HNBDe-RegisterExtensions >-----#
    HNBDe_RegisterExtensions = CLASS(name='HNBDe-RegisterExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNBDe_RegisterExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UERegisterRequest >-----#
    UERegisterRequest = SEQ(name='UERegisterRequest', mode=MODE_TYPE)
    _UERegisterRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __UERegisterRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___UERegisterRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____UERegisterRequest_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Identity')))
    _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Registration-Cause')))
    _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Capabilities')))
    ____UERegisterRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UERegisterRequest_protocolIEs__item__id._const_tab = ____UERegisterRequest_protocolIEs__item__id_tab
    ___UERegisterRequest_protocolIEs__item__id._const_tab_at = None
    ___UERegisterRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UERegisterRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___UERegisterRequest_protocolIEs__item__criticality._const_tab = ____UERegisterRequest_protocolIEs__item__id_tab
    ___UERegisterRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERegisterRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERegisterRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___UERegisterRequest_protocolIEs__item__value._const_tab = ____UERegisterRequest_protocolIEs__item__id_tab
    ___UERegisterRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERegisterRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UERegisterRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERegisterRequest_protocolIEs__item__id),
        ('criticality', ___UERegisterRequest_protocolIEs__item__criticality),
        ('value', ___UERegisterRequest_protocolIEs__item__value),
        ])
    __UERegisterRequest_protocolIEs__item_._ext = None
    _UERegisterRequest_protocolIEs._cont = __UERegisterRequest_protocolIEs__item_
    _UERegisterRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UERegisterRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UERegisterRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___UERegisterRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UERegisterRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UERegisterRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UERegisterRequest_protocolExtensions__item__id._const_tab = ____UERegisterRequest_protocolExtensions__item__id_tab
    ___UERegisterRequest_protocolExtensions__item__id._const_tab_at = None
    ___UERegisterRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___UERegisterRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UERegisterRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UERegisterRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UERegisterRequest_protocolExtensions__item__criticality._const_tab = ____UERegisterRequest_protocolExtensions__item__criticality_tab
    ___UERegisterRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UERegisterRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UERegisterRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UERegisterRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UERegisterRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UERegisterRequest_protocolExtensions__item__extensionValue._const_tab = ____UERegisterRequest_protocolExtensions__item__extensionValue_tab
    ___UERegisterRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UERegisterRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UERegisterRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UERegisterRequest_protocolExtensions__item__id),
        ('criticality', ___UERegisterRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___UERegisterRequest_protocolExtensions__item__extensionValue),
        ])
    __UERegisterRequest_protocolExtensions__item_._ext = None
    _UERegisterRequest_protocolExtensions._cont = __UERegisterRequest_protocolExtensions__item_
    _UERegisterRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UERegisterRequest._cont = ASN1Dict([
        ('protocolIEs', _UERegisterRequest_protocolIEs),
        ('protocolExtensions', _UERegisterRequest_protocolExtensions),
        ])
    UERegisterRequest._ext = []
    
    #-----< UERegisterRequestIEs >-----#
    UERegisterRequestIEs = CLASS(name='UERegisterRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _UERegisterRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Identity')))
    _UERegisterRequestIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Registration-Cause')))
    _UERegisterRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Capabilities')))
    UERegisterRequestIEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _UERegisterRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _UERegisterRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _UERegisterRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERegisterRequestExtensions >-----#
    UERegisterRequestExtensions = CLASS(name='UERegisterRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    UERegisterRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UERegisterAccept >-----#
    UERegisterAccept = SEQ(name='UERegisterAccept', mode=MODE_TYPE)
    _UERegisterAccept_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __UERegisterAccept_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___UERegisterAccept_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____UERegisterAccept_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____UERegisterAccept_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Identity')))
    _____UERegisterAccept_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    ____UERegisterAccept_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _____UERegisterAccept_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____UERegisterAccept_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UERegisterAccept_protocolIEs__item__id._const_tab = ____UERegisterAccept_protocolIEs__item__id_tab
    ___UERegisterAccept_protocolIEs__item__id._const_tab_at = None
    ___UERegisterAccept_protocolIEs__item__id._const_tab_id = 'id'
    ___UERegisterAccept_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___UERegisterAccept_protocolIEs__item__criticality._const_tab = ____UERegisterAccept_protocolIEs__item__id_tab
    ___UERegisterAccept_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERegisterAccept_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERegisterAccept_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___UERegisterAccept_protocolIEs__item__value._const_tab = ____UERegisterAccept_protocolIEs__item__id_tab
    ___UERegisterAccept_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERegisterAccept_protocolIEs__item__value._const_tab_id = 'Value'
    __UERegisterAccept_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERegisterAccept_protocolIEs__item__id),
        ('criticality', ___UERegisterAccept_protocolIEs__item__criticality),
        ('value', ___UERegisterAccept_protocolIEs__item__value),
        ])
    __UERegisterAccept_protocolIEs__item_._ext = None
    _UERegisterAccept_protocolIEs._cont = __UERegisterAccept_protocolIEs__item_
    _UERegisterAccept_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UERegisterAccept_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UERegisterAccept_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___UERegisterAccept_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UERegisterAccept_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____UERegisterAccept_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CSGMembershipStatus')))
    ____UERegisterAccept_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Extension', _____UERegisterAccept_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERegisterAccept_protocolExtensions__item__id._const_tab = ____UERegisterAccept_protocolExtensions__item__id_tab
    ___UERegisterAccept_protocolExtensions__item__id._const_tab_at = None
    ___UERegisterAccept_protocolExtensions__item__id._const_tab_id = 'id'
    ___UERegisterAccept_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UERegisterAccept_protocolExtensions__item__criticality._const_tab = ____UERegisterAccept_protocolExtensions__item__id_tab
    ___UERegisterAccept_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UERegisterAccept_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UERegisterAccept_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UERegisterAccept_protocolExtensions__item__extensionValue._const_tab = ____UERegisterAccept_protocolExtensions__item__id_tab
    ___UERegisterAccept_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UERegisterAccept_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UERegisterAccept_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UERegisterAccept_protocolExtensions__item__id),
        ('criticality', ___UERegisterAccept_protocolExtensions__item__criticality),
        ('extensionValue', ___UERegisterAccept_protocolExtensions__item__extensionValue),
        ])
    __UERegisterAccept_protocolExtensions__item_._ext = None
    _UERegisterAccept_protocolExtensions._cont = __UERegisterAccept_protocolExtensions__item_
    _UERegisterAccept_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UERegisterAccept._cont = ASN1Dict([
        ('protocolIEs', _UERegisterAccept_protocolIEs),
        ('protocolExtensions', _UERegisterAccept_protocolExtensions),
        ])
    UERegisterAccept._ext = []
    
    #-----< UERegisterAcceptIEs >-----#
    UERegisterAcceptIEs = CLASS(name='UERegisterAcceptIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _UERegisterAcceptIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Identity')))
    _UERegisterAcceptIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    UERegisterAcceptIEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _UERegisterAcceptIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _UERegisterAcceptIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERegisterAcceptExtensions >-----#
    UERegisterAcceptExtensions = CLASS(name='UERegisterAcceptExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _UERegisterAcceptExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CSGMembershipStatus')))
    UERegisterAcceptExtensions._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Extension', _UERegisterAcceptExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERegisterReject >-----#
    UERegisterReject = SEQ(name='UERegisterReject', mode=MODE_TYPE)
    _UERegisterReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __UERegisterReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___UERegisterReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____UERegisterReject_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____UERegisterReject_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Identity')))
    _____UERegisterReject_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _____UERegisterReject_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    ____UERegisterReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _____UERegisterReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____UERegisterReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____UERegisterReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERegisterReject_protocolIEs__item__id._const_tab = ____UERegisterReject_protocolIEs__item__id_tab
    ___UERegisterReject_protocolIEs__item__id._const_tab_at = None
    ___UERegisterReject_protocolIEs__item__id._const_tab_id = 'id'
    ___UERegisterReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___UERegisterReject_protocolIEs__item__criticality._const_tab = ____UERegisterReject_protocolIEs__item__id_tab
    ___UERegisterReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERegisterReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERegisterReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___UERegisterReject_protocolIEs__item__value._const_tab = ____UERegisterReject_protocolIEs__item__id_tab
    ___UERegisterReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERegisterReject_protocolIEs__item__value._const_tab_id = 'Value'
    __UERegisterReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERegisterReject_protocolIEs__item__id),
        ('criticality', ___UERegisterReject_protocolIEs__item__criticality),
        ('value', ___UERegisterReject_protocolIEs__item__value),
        ])
    __UERegisterReject_protocolIEs__item_._ext = None
    _UERegisterReject_protocolIEs._cont = __UERegisterReject_protocolIEs__item_
    _UERegisterReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UERegisterReject_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UERegisterReject_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___UERegisterReject_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UERegisterReject_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UERegisterReject_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UERegisterReject_protocolExtensions__item__id._const_tab = ____UERegisterReject_protocolExtensions__item__id_tab
    ___UERegisterReject_protocolExtensions__item__id._const_tab_at = None
    ___UERegisterReject_protocolExtensions__item__id._const_tab_id = 'id'
    ___UERegisterReject_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UERegisterReject_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UERegisterReject_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UERegisterReject_protocolExtensions__item__criticality._const_tab = ____UERegisterReject_protocolExtensions__item__criticality_tab
    ___UERegisterReject_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UERegisterReject_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UERegisterReject_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UERegisterReject_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UERegisterReject_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UERegisterReject_protocolExtensions__item__extensionValue._const_tab = ____UERegisterReject_protocolExtensions__item__extensionValue_tab
    ___UERegisterReject_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UERegisterReject_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UERegisterReject_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UERegisterReject_protocolExtensions__item__id),
        ('criticality', ___UERegisterReject_protocolExtensions__item__criticality),
        ('extensionValue', ___UERegisterReject_protocolExtensions__item__extensionValue),
        ])
    __UERegisterReject_protocolExtensions__item_._ext = None
    _UERegisterReject_protocolExtensions._cont = __UERegisterReject_protocolExtensions__item_
    _UERegisterReject_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UERegisterReject._cont = ASN1Dict([
        ('protocolIEs', _UERegisterReject_protocolIEs),
        ('protocolExtensions', _UERegisterReject_protocolExtensions),
        ])
    UERegisterReject._ext = []
    
    #-----< UERegisterRejectIEs >-----#
    UERegisterRejectIEs = CLASS(name='UERegisterRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _UERegisterRejectIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'UE-Identity')))
    _UERegisterRejectIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _UERegisterRejectIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    UERegisterRejectIEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _UERegisterRejectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _UERegisterRejectIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _UERegisterRejectIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERegisterRejectExtensions >-----#
    UERegisterRejectExtensions = CLASS(name='UERegisterRejectExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    UERegisterRejectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEDe-Register >-----#
    UEDe_Register = SEQ(name='UEDe-Register', mode=MODE_TYPE)
    _UEDe_Register_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __UEDe_Register_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___UEDe_Register_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____UEDe_Register_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____UEDe_Register_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _____UEDe_Register_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    ____UEDe_Register_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____UEDe_Register_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____UEDe_Register_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEDe_Register_protocolIEs__item__id._const_tab = ____UEDe_Register_protocolIEs__item__id_tab
    ___UEDe_Register_protocolIEs__item__id._const_tab_at = None
    ___UEDe_Register_protocolIEs__item__id._const_tab_id = 'id'
    ___UEDe_Register_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___UEDe_Register_protocolIEs__item__criticality._const_tab = ____UEDe_Register_protocolIEs__item__id_tab
    ___UEDe_Register_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEDe_Register_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEDe_Register_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___UEDe_Register_protocolIEs__item__value._const_tab = ____UEDe_Register_protocolIEs__item__id_tab
    ___UEDe_Register_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEDe_Register_protocolIEs__item__value._const_tab_id = 'Value'
    __UEDe_Register_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEDe_Register_protocolIEs__item__id),
        ('criticality', ___UEDe_Register_protocolIEs__item__criticality),
        ('value', ___UEDe_Register_protocolIEs__item__value),
        ])
    __UEDe_Register_protocolIEs__item_._ext = None
    _UEDe_Register_protocolIEs._cont = __UEDe_Register_protocolIEs__item_
    _UEDe_Register_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEDe_Register_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEDe_Register_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___UEDe_Register_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEDe_Register_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UEDe_Register_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEDe_Register_protocolExtensions__item__id._const_tab = ____UEDe_Register_protocolExtensions__item__id_tab
    ___UEDe_Register_protocolExtensions__item__id._const_tab_at = None
    ___UEDe_Register_protocolExtensions__item__id._const_tab_id = 'id'
    ___UEDe_Register_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEDe_Register_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UEDe_Register_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEDe_Register_protocolExtensions__item__criticality._const_tab = ____UEDe_Register_protocolExtensions__item__criticality_tab
    ___UEDe_Register_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEDe_Register_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UEDe_Register_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEDe_Register_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____UEDe_Register_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEDe_Register_protocolExtensions__item__extensionValue._const_tab = ____UEDe_Register_protocolExtensions__item__extensionValue_tab
    ___UEDe_Register_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEDe_Register_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UEDe_Register_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UEDe_Register_protocolExtensions__item__id),
        ('criticality', ___UEDe_Register_protocolExtensions__item__criticality),
        ('extensionValue', ___UEDe_Register_protocolExtensions__item__extensionValue),
        ])
    __UEDe_Register_protocolExtensions__item_._ext = None
    _UEDe_Register_protocolExtensions._cont = __UEDe_Register_protocolExtensions__item_
    _UEDe_Register_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEDe_Register._cont = ASN1Dict([
        ('protocolIEs', _UEDe_Register_protocolIEs),
        ('protocolExtensions', _UEDe_Register_protocolExtensions),
        ])
    UEDe_Register._ext = []
    
    #-----< UEDe-RegisterIEs >-----#
    UEDe_RegisterIEs = CLASS(name='UEDe-RegisterIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _UEDe_RegisterIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _UEDe_RegisterIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    UEDe_RegisterIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _UEDe_RegisterIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _UEDe_RegisterIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEDe-RegisterExtensions >-----#
    UEDe_RegisterExtensions = CLASS(name='UEDe-RegisterExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    UEDe_RegisterExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSGMembershipUpdate >-----#
    CSGMembershipUpdate = SEQ(name='CSGMembershipUpdate', mode=MODE_TYPE)
    _CSGMembershipUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __CSGMembershipUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___CSGMembershipUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____CSGMembershipUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____CSGMembershipUpdate_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _____CSGMembershipUpdate_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CSGMembershipStatus')))
    ____CSGMembershipUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____CSGMembershipUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'reject'), ('Value', _____CSGMembershipUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CSGMembershipUpdate_protocolIEs__item__id._const_tab = ____CSGMembershipUpdate_protocolIEs__item__id_tab
    ___CSGMembershipUpdate_protocolIEs__item__id._const_tab_at = None
    ___CSGMembershipUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___CSGMembershipUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___CSGMembershipUpdate_protocolIEs__item__criticality._const_tab = ____CSGMembershipUpdate_protocolIEs__item__id_tab
    ___CSGMembershipUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CSGMembershipUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CSGMembershipUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___CSGMembershipUpdate_protocolIEs__item__value._const_tab = ____CSGMembershipUpdate_protocolIEs__item__id_tab
    ___CSGMembershipUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CSGMembershipUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __CSGMembershipUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CSGMembershipUpdate_protocolIEs__item__id),
        ('criticality', ___CSGMembershipUpdate_protocolIEs__item__criticality),
        ('value', ___CSGMembershipUpdate_protocolIEs__item__value),
        ])
    __CSGMembershipUpdate_protocolIEs__item_._ext = None
    _CSGMembershipUpdate_protocolIEs._cont = __CSGMembershipUpdate_protocolIEs__item_
    _CSGMembershipUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CSGMembershipUpdate_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSGMembershipUpdate_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___CSGMembershipUpdate_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CSGMembershipUpdate_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CSGMembershipUpdate_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipUpdate_protocolExtensions__item__id._const_tab = ____CSGMembershipUpdate_protocolExtensions__item__id_tab
    ___CSGMembershipUpdate_protocolExtensions__item__id._const_tab_at = None
    ___CSGMembershipUpdate_protocolExtensions__item__id._const_tab_id = 'id'
    ___CSGMembershipUpdate_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CSGMembershipUpdate_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CSGMembershipUpdate_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipUpdate_protocolExtensions__item__criticality._const_tab = ____CSGMembershipUpdate_protocolExtensions__item__criticality_tab
    ___CSGMembershipUpdate_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CSGMembershipUpdate_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CSGMembershipUpdate_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CSGMembershipUpdate_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____CSGMembershipUpdate_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipUpdate_protocolExtensions__item__extensionValue._const_tab = ____CSGMembershipUpdate_protocolExtensions__item__extensionValue_tab
    ___CSGMembershipUpdate_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CSGMembershipUpdate_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CSGMembershipUpdate_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CSGMembershipUpdate_protocolExtensions__item__id),
        ('criticality', ___CSGMembershipUpdate_protocolExtensions__item__criticality),
        ('extensionValue', ___CSGMembershipUpdate_protocolExtensions__item__extensionValue),
        ])
    __CSGMembershipUpdate_protocolExtensions__item_._ext = None
    _CSGMembershipUpdate_protocolExtensions._cont = __CSGMembershipUpdate_protocolExtensions__item_
    _CSGMembershipUpdate_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSGMembershipUpdate._cont = ASN1Dict([
        ('protocolIEs', _CSGMembershipUpdate_protocolIEs),
        ('protocolExtensions', _CSGMembershipUpdate_protocolExtensions),
        ])
    CSGMembershipUpdate._ext = []
    
    #-----< CSGMembershipUpdateIEs >-----#
    CSGMembershipUpdateIEs = CLASS(name='CSGMembershipUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _CSGMembershipUpdateIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _CSGMembershipUpdateIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CSGMembershipStatus')))
    CSGMembershipUpdateIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _CSGMembershipUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'reject'), ('Value', _CSGMembershipUpdateIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CSGMembershipUpdateExtensions >-----#
    CSGMembershipUpdateExtensions = CLASS(name='CSGMembershipUpdateExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    CSGMembershipUpdateExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLUpdateRequest >-----#
    TNLUpdateRequest = SEQ(name='TNLUpdateRequest', mode=MODE_TYPE)
    _TNLUpdateRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __TNLUpdateRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___TNLUpdateRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____TNLUpdateRequest_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RABList')))
    _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Update-cause')))
    ____TNLUpdateRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'reject'), ('Value', _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TNLUpdateRequest_protocolIEs__item__id._const_tab = ____TNLUpdateRequest_protocolIEs__item__id_tab
    ___TNLUpdateRequest_protocolIEs__item__id._const_tab_at = None
    ___TNLUpdateRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___TNLUpdateRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___TNLUpdateRequest_protocolIEs__item__criticality._const_tab = ____TNLUpdateRequest_protocolIEs__item__id_tab
    ___TNLUpdateRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TNLUpdateRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TNLUpdateRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___TNLUpdateRequest_protocolIEs__item__value._const_tab = ____TNLUpdateRequest_protocolIEs__item__id_tab
    ___TNLUpdateRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TNLUpdateRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __TNLUpdateRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TNLUpdateRequest_protocolIEs__item__id),
        ('criticality', ___TNLUpdateRequest_protocolIEs__item__criticality),
        ('value', ___TNLUpdateRequest_protocolIEs__item__value),
        ])
    __TNLUpdateRequest_protocolIEs__item_._ext = None
    _TNLUpdateRequest_protocolIEs._cont = __TNLUpdateRequest_protocolIEs__item_
    _TNLUpdateRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _TNLUpdateRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLUpdateRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___TNLUpdateRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLUpdateRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateRequest_protocolExtensions__item__id._const_tab = ____TNLUpdateRequest_protocolExtensions__item__id_tab
    ___TNLUpdateRequest_protocolExtensions__item__id._const_tab_at = None
    ___TNLUpdateRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___TNLUpdateRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLUpdateRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateRequest_protocolExtensions__item__criticality._const_tab = ____TNLUpdateRequest_protocolExtensions__item__criticality_tab
    ___TNLUpdateRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLUpdateRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___TNLUpdateRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLUpdateRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateRequest_protocolExtensions__item__extensionValue._const_tab = ____TNLUpdateRequest_protocolExtensions__item__extensionValue_tab
    ___TNLUpdateRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLUpdateRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLUpdateRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___TNLUpdateRequest_protocolExtensions__item__id),
        ('criticality', ___TNLUpdateRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___TNLUpdateRequest_protocolExtensions__item__extensionValue),
        ])
    __TNLUpdateRequest_protocolExtensions__item_._ext = None
    _TNLUpdateRequest_protocolExtensions._cont = __TNLUpdateRequest_protocolExtensions__item_
    _TNLUpdateRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLUpdateRequest._cont = ASN1Dict([
        ('protocolIEs', _TNLUpdateRequest_protocolIEs),
        ('protocolExtensions', _TNLUpdateRequest_protocolExtensions),
        ])
    TNLUpdateRequest._ext = []
    
    #-----< TNLUpdateRequestIEs >-----#
    TNLUpdateRequestIEs = CLASS(name='TNLUpdateRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _TNLUpdateRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _TNLUpdateRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'RABList')))
    _TNLUpdateRequestIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Update-cause')))
    TNLUpdateRequestIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _TNLUpdateRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'reject'), ('Value', _TNLUpdateRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _TNLUpdateRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TNLUpdateExtensions >-----#
    TNLUpdateExtensions = CLASS(name='TNLUpdateExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    TNLUpdateExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLUpdateResponse >-----#
    TNLUpdateResponse = SEQ(name='TNLUpdateResponse', mode=MODE_TYPE)
    _TNLUpdateResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __TNLUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___TNLUpdateResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____TNLUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____TNLUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    ____TNLUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____TNLUpdateResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TNLUpdateResponse_protocolIEs__item__id._const_tab = ____TNLUpdateResponse_protocolIEs__item__id_tab
    ___TNLUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___TNLUpdateResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___TNLUpdateResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___TNLUpdateResponse_protocolIEs__item__criticality._const_tab = ____TNLUpdateResponse_protocolIEs__item__id_tab
    ___TNLUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TNLUpdateResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TNLUpdateResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___TNLUpdateResponse_protocolIEs__item__value._const_tab = ____TNLUpdateResponse_protocolIEs__item__id_tab
    ___TNLUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TNLUpdateResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __TNLUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TNLUpdateResponse_protocolIEs__item__id),
        ('criticality', ___TNLUpdateResponse_protocolIEs__item__criticality),
        ('value', ___TNLUpdateResponse_protocolIEs__item__value),
        ])
    __TNLUpdateResponse_protocolIEs__item_._ext = None
    _TNLUpdateResponse_protocolIEs._cont = __TNLUpdateResponse_protocolIEs__item_
    _TNLUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _TNLUpdateResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLUpdateResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___TNLUpdateResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLUpdateResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateResponse_protocolExtensions__item__id._const_tab = ____TNLUpdateResponse_protocolExtensions__item__id_tab
    ___TNLUpdateResponse_protocolExtensions__item__id._const_tab_at = None
    ___TNLUpdateResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___TNLUpdateResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLUpdateResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateResponse_protocolExtensions__item__criticality._const_tab = ____TNLUpdateResponse_protocolExtensions__item__criticality_tab
    ___TNLUpdateResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLUpdateResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___TNLUpdateResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLUpdateResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateResponse_protocolExtensions__item__extensionValue._const_tab = ____TNLUpdateResponse_protocolExtensions__item__extensionValue_tab
    ___TNLUpdateResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLUpdateResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLUpdateResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___TNLUpdateResponse_protocolExtensions__item__id),
        ('criticality', ___TNLUpdateResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___TNLUpdateResponse_protocolExtensions__item__extensionValue),
        ])
    __TNLUpdateResponse_protocolExtensions__item_._ext = None
    _TNLUpdateResponse_protocolExtensions._cont = __TNLUpdateResponse_protocolExtensions__item_
    _TNLUpdateResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLUpdateResponse._cont = ASN1Dict([
        ('protocolIEs', _TNLUpdateResponse_protocolIEs),
        ('protocolExtensions', _TNLUpdateResponse_protocolExtensions),
        ])
    TNLUpdateResponse._ext = []
    
    #-----< TNLUpdateResponseIEs >-----#
    TNLUpdateResponseIEs = CLASS(name='TNLUpdateResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _TNLUpdateResponseIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    TNLUpdateResponseIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _TNLUpdateResponseIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TNLUpdateResponseExtensions >-----#
    TNLUpdateResponseExtensions = CLASS(name='TNLUpdateResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    TNLUpdateResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLUpdateFailure >-----#
    TNLUpdateFailure = SEQ(name='TNLUpdateFailure', mode=MODE_TYPE)
    _TNLUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __TNLUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___TNLUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____TNLUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    ____TNLUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TNLUpdateFailure_protocolIEs__item__id._const_tab = ____TNLUpdateFailure_protocolIEs__item__id_tab
    ___TNLUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___TNLUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___TNLUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___TNLUpdateFailure_protocolIEs__item__criticality._const_tab = ____TNLUpdateFailure_protocolIEs__item__id_tab
    ___TNLUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TNLUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TNLUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___TNLUpdateFailure_protocolIEs__item__value._const_tab = ____TNLUpdateFailure_protocolIEs__item__id_tab
    ___TNLUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TNLUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __TNLUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TNLUpdateFailure_protocolIEs__item__id),
        ('criticality', ___TNLUpdateFailure_protocolIEs__item__criticality),
        ('value', ___TNLUpdateFailure_protocolIEs__item__value),
        ])
    __TNLUpdateFailure_protocolIEs__item_._ext = None
    _TNLUpdateFailure_protocolIEs._cont = __TNLUpdateFailure_protocolIEs__item_
    _TNLUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _TNLUpdateFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLUpdateFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___TNLUpdateFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLUpdateFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateFailure_protocolExtensions__item__id._const_tab = ____TNLUpdateFailure_protocolExtensions__item__id_tab
    ___TNLUpdateFailure_protocolExtensions__item__id._const_tab_at = None
    ___TNLUpdateFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___TNLUpdateFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLUpdateFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateFailure_protocolExtensions__item__criticality._const_tab = ____TNLUpdateFailure_protocolExtensions__item__criticality_tab
    ___TNLUpdateFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLUpdateFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___TNLUpdateFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLUpdateFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____TNLUpdateFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLUpdateFailure_protocolExtensions__item__extensionValue._const_tab = ____TNLUpdateFailure_protocolExtensions__item__extensionValue_tab
    ___TNLUpdateFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLUpdateFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLUpdateFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___TNLUpdateFailure_protocolExtensions__item__id),
        ('criticality', ___TNLUpdateFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___TNLUpdateFailure_protocolExtensions__item__extensionValue),
        ])
    __TNLUpdateFailure_protocolExtensions__item_._ext = None
    _TNLUpdateFailure_protocolExtensions._cont = __TNLUpdateFailure_protocolExtensions__item_
    _TNLUpdateFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _TNLUpdateFailure_protocolIEs),
        ('protocolExtensions', _TNLUpdateFailure_protocolExtensions),
        ])
    TNLUpdateFailure._ext = []
    
    #-----< TNLUpdateFailureIEs >-----#
    TNLUpdateFailureIEs = CLASS(name='TNLUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _TNLUpdateFailureIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    _TNLUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _TNLUpdateFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    TNLUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _TNLUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _TNLUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _TNLUpdateFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TNLUpdateFailureExtensions >-----#
    TNLUpdateFailureExtensions = CLASS(name='TNLUpdateFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    TNLUpdateFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNBConfigTransferRequest >-----#
    HNBConfigTransferRequest = SEQ(name='HNBConfigTransferRequest', mode=MODE_TYPE)
    _HNBConfigTransferRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __HNBConfigTransferRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___HNBConfigTransferRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____HNBConfigTransferRequest_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____HNBConfigTransferRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourInfoRequestList')))
    ____HNBConfigTransferRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'reject'), ('Value', _____HNBConfigTransferRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HNBConfigTransferRequest_protocolIEs__item__id._const_tab = ____HNBConfigTransferRequest_protocolIEs__item__id_tab
    ___HNBConfigTransferRequest_protocolIEs__item__id._const_tab_at = None
    ___HNBConfigTransferRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___HNBConfigTransferRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___HNBConfigTransferRequest_protocolIEs__item__criticality._const_tab = ____HNBConfigTransferRequest_protocolIEs__item__id_tab
    ___HNBConfigTransferRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigTransferRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigTransferRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___HNBConfigTransferRequest_protocolIEs__item__value._const_tab = ____HNBConfigTransferRequest_protocolIEs__item__id_tab
    ___HNBConfigTransferRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HNBConfigTransferRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __HNBConfigTransferRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HNBConfigTransferRequest_protocolIEs__item__id),
        ('criticality', ___HNBConfigTransferRequest_protocolIEs__item__criticality),
        ('value', ___HNBConfigTransferRequest_protocolIEs__item__value),
        ])
    __HNBConfigTransferRequest_protocolIEs__item_._ext = None
    _HNBConfigTransferRequest_protocolIEs._cont = __HNBConfigTransferRequest_protocolIEs__item_
    _HNBConfigTransferRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HNBConfigTransferRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBConfigTransferRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBConfigTransferRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBConfigTransferRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigTransferRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigTransferRequest_protocolExtensions__item__id._const_tab = ____HNBConfigTransferRequest_protocolExtensions__item__id_tab
    ___HNBConfigTransferRequest_protocolExtensions__item__id._const_tab_at = None
    ___HNBConfigTransferRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___HNBConfigTransferRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HNBConfigTransferRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigTransferRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigTransferRequest_protocolExtensions__item__criticality._const_tab = ____HNBConfigTransferRequest_protocolExtensions__item__criticality_tab
    ___HNBConfigTransferRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigTransferRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigTransferRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HNBConfigTransferRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____HNBConfigTransferRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HNBConfigTransferRequest_protocolExtensions__item__extensionValue._const_tab = ____HNBConfigTransferRequest_protocolExtensions__item__extensionValue_tab
    ___HNBConfigTransferRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBConfigTransferRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBConfigTransferRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___HNBConfigTransferRequest_protocolExtensions__item__id),
        ('criticality', ___HNBConfigTransferRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___HNBConfigTransferRequest_protocolExtensions__item__extensionValue),
        ])
    __HNBConfigTransferRequest_protocolExtensions__item_._ext = None
    _HNBConfigTransferRequest_protocolExtensions._cont = __HNBConfigTransferRequest_protocolExtensions__item_
    _HNBConfigTransferRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBConfigTransferRequest._cont = ASN1Dict([
        ('protocolIEs', _HNBConfigTransferRequest_protocolIEs),
        ('protocolExtensions', _HNBConfigTransferRequest_protocolExtensions),
        ])
    HNBConfigTransferRequest._ext = []
    
    #-----< HNBConfigTransferRequestIEs >-----#
    HNBConfigTransferRequestIEs = CLASS(name='HNBConfigTransferRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _HNBConfigTransferRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourInfoRequestList')))
    HNBConfigTransferRequestIEs._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'reject'), ('Value', _HNBConfigTransferRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HNBConfigTransferRequestExtensions >-----#
    HNBConfigTransferRequestExtensions = CLASS(name='HNBConfigTransferRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    HNBConfigTransferRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HNBConfigTransferResponse >-----#
    HNBConfigTransferResponse = SEQ(name='HNBConfigTransferResponse', mode=MODE_TYPE)
    _HNBConfigTransferResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __HNBConfigTransferResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___HNBConfigTransferResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____HNBConfigTransferResponse_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____HNBConfigTransferResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourInfoList')))
    ____HNBConfigTransferResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _____HNBConfigTransferResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HNBConfigTransferResponse_protocolIEs__item__id._const_tab = ____HNBConfigTransferResponse_protocolIEs__item__id_tab
    ___HNBConfigTransferResponse_protocolIEs__item__id._const_tab_at = None
    ___HNBConfigTransferResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___HNBConfigTransferResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___HNBConfigTransferResponse_protocolIEs__item__criticality._const_tab = ____HNBConfigTransferResponse_protocolIEs__item__id_tab
    ___HNBConfigTransferResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigTransferResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigTransferResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___HNBConfigTransferResponse_protocolIEs__item__value._const_tab = ____HNBConfigTransferResponse_protocolIEs__item__id_tab
    ___HNBConfigTransferResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HNBConfigTransferResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __HNBConfigTransferResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HNBConfigTransferResponse_protocolIEs__item__id),
        ('criticality', ___HNBConfigTransferResponse_protocolIEs__item__criticality),
        ('value', ___HNBConfigTransferResponse_protocolIEs__item__value),
        ])
    __HNBConfigTransferResponse_protocolIEs__item_._ext = None
    _HNBConfigTransferResponse_protocolIEs._cont = __HNBConfigTransferResponse_protocolIEs__item_
    _HNBConfigTransferResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HNBConfigTransferResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HNBConfigTransferResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___HNBConfigTransferResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HNBConfigTransferResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _____HNBConfigTransferResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'AdditionalNeighbourInfoList')))
    ____HNBConfigTransferResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'ignore'), ('Extension', _____HNBConfigTransferResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HNBConfigTransferResponse_protocolExtensions__item__id._const_tab = ____HNBConfigTransferResponse_protocolExtensions__item__id_tab
    ___HNBConfigTransferResponse_protocolExtensions__item__id._const_tab_at = None
    ___HNBConfigTransferResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___HNBConfigTransferResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HNBConfigTransferResponse_protocolExtensions__item__criticality._const_tab = ____HNBConfigTransferResponse_protocolExtensions__item__id_tab
    ___HNBConfigTransferResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___HNBConfigTransferResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___HNBConfigTransferResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HNBConfigTransferResponse_protocolExtensions__item__extensionValue._const_tab = ____HNBConfigTransferResponse_protocolExtensions__item__id_tab
    ___HNBConfigTransferResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HNBConfigTransferResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __HNBConfigTransferResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___HNBConfigTransferResponse_protocolExtensions__item__id),
        ('criticality', ___HNBConfigTransferResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___HNBConfigTransferResponse_protocolExtensions__item__extensionValue),
        ])
    __HNBConfigTransferResponse_protocolExtensions__item_._ext = None
    _HNBConfigTransferResponse_protocolExtensions._cont = __HNBConfigTransferResponse_protocolExtensions__item_
    _HNBConfigTransferResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HNBConfigTransferResponse._cont = ASN1Dict([
        ('protocolIEs', _HNBConfigTransferResponse_protocolIEs),
        ('protocolExtensions', _HNBConfigTransferResponse_protocolExtensions),
        ])
    HNBConfigTransferResponse._ext = []
    
    #-----< HNBConfigTransferResponseIEs >-----#
    HNBConfigTransferResponseIEs = CLASS(name='HNBConfigTransferResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _HNBConfigTransferResponseIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'NeighbourInfoList')))
    HNBConfigTransferResponseIEs._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _HNBConfigTransferResponseIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HNBConfigTransferResponseExtensions >-----#
    HNBConfigTransferResponseExtensions = CLASS(name='HNBConfigTransferResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    _HNBConfigTransferResponseExtensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'AdditionalNeighbourInfoList')))
    HNBConfigTransferResponseExtensions._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'ignore'), ('Extension', _HNBConfigTransferResponseExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationComplete >-----#
    RelocationComplete = SEQ(name='RelocationComplete', mode=MODE_TYPE)
    _RelocationComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __RelocationComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___RelocationComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____RelocationComplete_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____RelocationComplete_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    ____RelocationComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____RelocationComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__id._const_tab = ____RelocationComplete_protocolIEs__item__id_tab
    ___RelocationComplete_protocolIEs__item__id._const_tab_at = None
    ___RelocationComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationComplete_protocolIEs__item__criticality._const_tab = ____RelocationComplete_protocolIEs__item__id_tab
    ___RelocationComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___RelocationComplete_protocolIEs__item__value._const_tab = ____RelocationComplete_protocolIEs__item__id_tab
    ___RelocationComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationComplete_protocolIEs__item__id),
        ('criticality', ___RelocationComplete_protocolIEs__item__criticality),
        ('value', ___RelocationComplete_protocolIEs__item__value),
        ])
    __RelocationComplete_protocolIEs__item_._ext = None
    _RelocationComplete_protocolIEs._cont = __RelocationComplete_protocolIEs__item_
    _RelocationComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationComplete_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___RelocationComplete_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____RelocationComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolExtensions__item__id._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__id._const_tab_at = None
    ___RelocationComplete_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationComplete_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelocationComplete_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____RelocationComplete_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab = ____RelocationComplete_protocolExtensions__item__criticality_tab
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationComplete_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelocationComplete_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____RelocationComplete_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab = ____RelocationComplete_protocolExtensions__item__extensionValue_tab
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationComplete_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationComplete_protocolExtensions__item__id),
        ('criticality', ___RelocationComplete_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationComplete_protocolExtensions__item__extensionValue),
        ])
    __RelocationComplete_protocolExtensions__item_._ext = None
    _RelocationComplete_protocolExtensions._cont = __RelocationComplete_protocolExtensions__item_
    _RelocationComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationComplete._cont = ASN1Dict([
        ('protocolIEs', _RelocationComplete_protocolIEs),
        ('protocolExtensions', _RelocationComplete_protocolExtensions),
        ])
    RelocationComplete._ext = []
    
    #-----< RelocationCompleteIEs >-----#
    RelocationCompleteIEs = CLASS(name='RelocationCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _RelocationCompleteIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Context-ID')))
    RelocationCompleteIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _RelocationCompleteIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCompleteExtensions >-----#
    RelocationCompleteExtensions = CLASS(name='RelocationCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    RelocationCompleteExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ErrorIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__criticality_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__extensionValue_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolExtensions__item__id),
        ('criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ('protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'CriticalityDiagnostics')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndicationExtensions >-----#
    ErrorIndicationExtensions = CLASS(name='ErrorIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ErrorIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_HNBAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_HNBAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_HNBAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< U-RNTIQueryRequest >-----#
    U_RNTIQueryRequest = SEQ(name='U-RNTIQueryRequest', mode=MODE_TYPE)
    _U_RNTIQueryRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __U_RNTIQueryRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___U_RNTIQueryRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____U_RNTIQueryRequest_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____U_RNTIQueryRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'U-RNTI')))
    ____U_RNTIQueryRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _____U_RNTIQueryRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___U_RNTIQueryRequest_protocolIEs__item__id._const_tab = ____U_RNTIQueryRequest_protocolIEs__item__id_tab
    ___U_RNTIQueryRequest_protocolIEs__item__id._const_tab_at = None
    ___U_RNTIQueryRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___U_RNTIQueryRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___U_RNTIQueryRequest_protocolIEs__item__criticality._const_tab = ____U_RNTIQueryRequest_protocolIEs__item__id_tab
    ___U_RNTIQueryRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___U_RNTIQueryRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___U_RNTIQueryRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___U_RNTIQueryRequest_protocolIEs__item__value._const_tab = ____U_RNTIQueryRequest_protocolIEs__item__id_tab
    ___U_RNTIQueryRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___U_RNTIQueryRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __U_RNTIQueryRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___U_RNTIQueryRequest_protocolIEs__item__id),
        ('criticality', ___U_RNTIQueryRequest_protocolIEs__item__criticality),
        ('value', ___U_RNTIQueryRequest_protocolIEs__item__value),
        ])
    __U_RNTIQueryRequest_protocolIEs__item_._ext = None
    _U_RNTIQueryRequest_protocolIEs._cont = __U_RNTIQueryRequest_protocolIEs__item_
    _U_RNTIQueryRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _U_RNTIQueryRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __U_RNTIQueryRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___U_RNTIQueryRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____U_RNTIQueryRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____U_RNTIQueryRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___U_RNTIQueryRequest_protocolExtensions__item__id._const_tab = ____U_RNTIQueryRequest_protocolExtensions__item__id_tab
    ___U_RNTIQueryRequest_protocolExtensions__item__id._const_tab_at = None
    ___U_RNTIQueryRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___U_RNTIQueryRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____U_RNTIQueryRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____U_RNTIQueryRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___U_RNTIQueryRequest_protocolExtensions__item__criticality._const_tab = ____U_RNTIQueryRequest_protocolExtensions__item__criticality_tab
    ___U_RNTIQueryRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___U_RNTIQueryRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___U_RNTIQueryRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____U_RNTIQueryRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____U_RNTIQueryRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___U_RNTIQueryRequest_protocolExtensions__item__extensionValue._const_tab = ____U_RNTIQueryRequest_protocolExtensions__item__extensionValue_tab
    ___U_RNTIQueryRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___U_RNTIQueryRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __U_RNTIQueryRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___U_RNTIQueryRequest_protocolExtensions__item__id),
        ('criticality', ___U_RNTIQueryRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___U_RNTIQueryRequest_protocolExtensions__item__extensionValue),
        ])
    __U_RNTIQueryRequest_protocolExtensions__item_._ext = None
    _U_RNTIQueryRequest_protocolExtensions._cont = __U_RNTIQueryRequest_protocolExtensions__item_
    _U_RNTIQueryRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    U_RNTIQueryRequest._cont = ASN1Dict([
        ('protocolIEs', _U_RNTIQueryRequest_protocolIEs),
        ('protocolExtensions', _U_RNTIQueryRequest_protocolExtensions),
        ])
    U_RNTIQueryRequest._ext = []
    
    #-----< U-RNTIQueryRequestIEs >-----#
    U_RNTIQueryRequestIEs = CLASS(name='U-RNTIQueryRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _U_RNTIQueryRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'U-RNTI')))
    U_RNTIQueryRequestIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'reject'), ('Value', _U_RNTIQueryRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< U-RNTIQueryRequestExtensions >-----#
    U_RNTIQueryRequestExtensions = CLASS(name='U-RNTIQueryRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    U_RNTIQueryRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< U-RNTIQueryResponse >-----#
    U_RNTIQueryResponse = SEQ(name='U-RNTIQueryResponse', mode=MODE_TYPE)
    _U_RNTIQueryResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Container')))
    __U_RNTIQueryResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolIE-Field')))
    ___U_RNTIQueryResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['id']))
    ____U_RNTIQueryResponse_protocolIEs__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _____U_RNTIQueryResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-GWResponse')))
    ____U_RNTIQueryResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'reject'), ('Value', _____U_RNTIQueryResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___U_RNTIQueryResponse_protocolIEs__item__id._const_tab = ____U_RNTIQueryResponse_protocolIEs__item__id_tab
    ___U_RNTIQueryResponse_protocolIEs__item__id._const_tab_at = None
    ___U_RNTIQueryResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___U_RNTIQueryResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['criticality']))
    ___U_RNTIQueryResponse_protocolIEs__item__criticality._const_tab = ____U_RNTIQueryResponse_protocolIEs__item__id_tab
    ___U_RNTIQueryResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___U_RNTIQueryResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___U_RNTIQueryResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES'), ['Value']))
    ___U_RNTIQueryResponse_protocolIEs__item__value._const_tab = ____U_RNTIQueryResponse_protocolIEs__item__id_tab
    ___U_RNTIQueryResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___U_RNTIQueryResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __U_RNTIQueryResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___U_RNTIQueryResponse_protocolIEs__item__id),
        ('criticality', ___U_RNTIQueryResponse_protocolIEs__item__criticality),
        ('value', ___U_RNTIQueryResponse_protocolIEs__item__value),
        ])
    __U_RNTIQueryResponse_protocolIEs__item_._ext = None
    _U_RNTIQueryResponse_protocolIEs._cont = __U_RNTIQueryResponse_protocolIEs__item_
    _U_RNTIQueryResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _U_RNTIQueryResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __U_RNTIQueryResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-Containers', 'ProtocolExtensionField')))
    ___U_RNTIQueryResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['id']))
    ____U_RNTIQueryResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____U_RNTIQueryResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___U_RNTIQueryResponse_protocolExtensions__item__id._const_tab = ____U_RNTIQueryResponse_protocolExtensions__item__id_tab
    ___U_RNTIQueryResponse_protocolExtensions__item__id._const_tab_at = None
    ___U_RNTIQueryResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___U_RNTIQueryResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____U_RNTIQueryResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____U_RNTIQueryResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___U_RNTIQueryResponse_protocolExtensions__item__criticality._const_tab = ____U_RNTIQueryResponse_protocolExtensions__item__criticality_tab
    ___U_RNTIQueryResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___U_RNTIQueryResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___U_RNTIQueryResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____U_RNTIQueryResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_HNBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    ____U_RNTIQueryResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___U_RNTIQueryResponse_protocolExtensions__item__extensionValue._const_tab = ____U_RNTIQueryResponse_protocolExtensions__item__extensionValue_tab
    ___U_RNTIQueryResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___U_RNTIQueryResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __U_RNTIQueryResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___U_RNTIQueryResponse_protocolExtensions__item__id),
        ('criticality', ___U_RNTIQueryResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___U_RNTIQueryResponse_protocolExtensions__item__extensionValue),
        ])
    __U_RNTIQueryResponse_protocolExtensions__item_._ext = None
    _U_RNTIQueryResponse_protocolExtensions._cont = __U_RNTIQueryResponse_protocolExtensions__item_
    _U_RNTIQueryResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    U_RNTIQueryResponse._cont = ASN1Dict([
        ('protocolIEs', _U_RNTIQueryResponse_protocolIEs),
        ('protocolExtensions', _U_RNTIQueryResponse_protocolExtensions),
        ])
    U_RNTIQueryResponse._ext = []
    
    #-----< U-RNTIQueryResponseIEs >-----#
    U_RNTIQueryResponseIEs = CLASS(name='U-RNTIQueryResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-IES')))
    _U_RNTIQueryResponseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-IEs', 'HNB-GWResponse')))
    U_RNTIQueryResponseIEs._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'reject'), ('Value', _U_RNTIQueryResponseIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< U-RNTIQueryResponseExtensions >-----#
    U_RNTIQueryResponseExtensions = CLASS(name='U-RNTIQueryResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-Containers', 'HNBAP-PROTOCOL-EXTENSION')))
    U_RNTIQueryResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____HNBRegisterRequest_protocolIEs__item__id_tab,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HNBRegisterRequest_protocolIEs__item__id_tab_val_Value_7,
        ___HNBRegisterRequest_protocolIEs__item__id,
        ___HNBRegisterRequest_protocolIEs__item__criticality,
        ___HNBRegisterRequest_protocolIEs__item__value,
        __HNBRegisterRequest_protocolIEs__item_,
        _HNBRegisterRequest_protocolIEs,
        ____HNBRegisterRequest_protocolExtensions__item__id_tab,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_6,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_7,
        _____HNBRegisterRequest_protocolExtensions__item__id_tab_val_Extension_8,
        ___HNBRegisterRequest_protocolExtensions__item__id,
        ___HNBRegisterRequest_protocolExtensions__item__criticality,
        ___HNBRegisterRequest_protocolExtensions__item__extensionValue,
        __HNBRegisterRequest_protocolExtensions__item_,
        _HNBRegisterRequest_protocolExtensions,
        HNBRegisterRequest,
        HNBRegisterRequestIEs,
        _HNBRegisterRequestIEs_val_Value_0,
        _HNBRegisterRequestIEs_val_Value_1,
        _HNBRegisterRequestIEs_val_Value_2,
        _HNBRegisterRequestIEs_val_Value_3,
        _HNBRegisterRequestIEs_val_Value_4,
        _HNBRegisterRequestIEs_val_Value_5,
        _HNBRegisterRequestIEs_val_Value_6,
        _HNBRegisterRequestIEs_val_Value_7,
        HNBRegisterRequestExtensions,
        _HNBRegisterRequestExtensions_val_Extension_0,
        _HNBRegisterRequestExtensions_val_Extension_1,
        _HNBRegisterRequestExtensions_val_Extension_2,
        _HNBRegisterRequestExtensions_val_Extension_3,
        _HNBRegisterRequestExtensions_val_Extension_4,
        _HNBRegisterRequestExtensions_val_Extension_5,
        _HNBRegisterRequestExtensions_val_Extension_6,
        _HNBRegisterRequestExtensions_val_Extension_7,
        _HNBRegisterRequestExtensions_val_Extension_8,
        ____HNBRegisterAccept_protocolIEs__item__id_tab,
        _____HNBRegisterAccept_protocolIEs__item__id_tab_val_Value_0,
        ___HNBRegisterAccept_protocolIEs__item__id,
        ___HNBRegisterAccept_protocolIEs__item__criticality,
        ___HNBRegisterAccept_protocolIEs__item__value,
        __HNBRegisterAccept_protocolIEs__item_,
        _HNBRegisterAccept_protocolIEs,
        ____HNBRegisterAccept_protocolExtensions__item__id_tab,
        _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_0,
        _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_1,
        _____HNBRegisterAccept_protocolExtensions__item__id_tab_val_Extension_2,
        ___HNBRegisterAccept_protocolExtensions__item__id,
        ___HNBRegisterAccept_protocolExtensions__item__criticality,
        ___HNBRegisterAccept_protocolExtensions__item__extensionValue,
        __HNBRegisterAccept_protocolExtensions__item_,
        _HNBRegisterAccept_protocolExtensions,
        HNBRegisterAccept,
        HNBRegisterResponseIEs,
        _HNBRegisterResponseIEs_val_Value_0,
        HNBRegisterResponseExtensions,
        _HNBRegisterResponseExtensions_val_Extension_0,
        _HNBRegisterResponseExtensions_val_Extension_1,
        _HNBRegisterResponseExtensions_val_Extension_2,
        ____HNBRegisterReject_protocolIEs__item__id_tab,
        _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_0,
        _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_1,
        _____HNBRegisterReject_protocolIEs__item__id_tab_val_Value_2,
        ___HNBRegisterReject_protocolIEs__item__id,
        ___HNBRegisterReject_protocolIEs__item__criticality,
        ___HNBRegisterReject_protocolIEs__item__value,
        __HNBRegisterReject_protocolIEs__item_,
        _HNBRegisterReject_protocolIEs,
        ____HNBRegisterReject_protocolExtensions__item__id_tab,
        ___HNBRegisterReject_protocolExtensions__item__id,
        ____HNBRegisterReject_protocolExtensions__item__criticality_tab,
        ___HNBRegisterReject_protocolExtensions__item__criticality,
        ____HNBRegisterReject_protocolExtensions__item__extensionValue_tab,
        ___HNBRegisterReject_protocolExtensions__item__extensionValue,
        __HNBRegisterReject_protocolExtensions__item_,
        _HNBRegisterReject_protocolExtensions,
        HNBRegisterReject,
        HNBRegisterRejectIEs,
        _HNBRegisterRejectIEs_val_Value_0,
        _HNBRegisterRejectIEs_val_Value_1,
        _HNBRegisterRejectIEs_val_Value_2,
        HNBRegisterRejectExtensions,
        ____HNBDe_Register_protocolIEs__item__id_tab,
        _____HNBDe_Register_protocolIEs__item__id_tab_val_Value_0,
        _____HNBDe_Register_protocolIEs__item__id_tab_val_Value_1,
        ___HNBDe_Register_protocolIEs__item__id,
        ___HNBDe_Register_protocolIEs__item__criticality,
        ___HNBDe_Register_protocolIEs__item__value,
        __HNBDe_Register_protocolIEs__item_,
        _HNBDe_Register_protocolIEs,
        ____HNBDe_Register_protocolExtensions__item__id_tab,
        ___HNBDe_Register_protocolExtensions__item__id,
        ____HNBDe_Register_protocolExtensions__item__criticality_tab,
        ___HNBDe_Register_protocolExtensions__item__criticality,
        ____HNBDe_Register_protocolExtensions__item__extensionValue_tab,
        ___HNBDe_Register_protocolExtensions__item__extensionValue,
        __HNBDe_Register_protocolExtensions__item_,
        _HNBDe_Register_protocolExtensions,
        HNBDe_Register,
        HNBDe_RegisterIEs,
        _HNBDe_RegisterIEs_val_Value_0,
        _HNBDe_RegisterIEs_val_Value_1,
        HNBDe_RegisterExtensions,
        ____UERegisterRequest_protocolIEs__item__id_tab,
        _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UERegisterRequest_protocolIEs__item__id_tab_val_Value_2,
        ___UERegisterRequest_protocolIEs__item__id,
        ___UERegisterRequest_protocolIEs__item__criticality,
        ___UERegisterRequest_protocolIEs__item__value,
        __UERegisterRequest_protocolIEs__item_,
        _UERegisterRequest_protocolIEs,
        ____UERegisterRequest_protocolExtensions__item__id_tab,
        ___UERegisterRequest_protocolExtensions__item__id,
        ____UERegisterRequest_protocolExtensions__item__criticality_tab,
        ___UERegisterRequest_protocolExtensions__item__criticality,
        ____UERegisterRequest_protocolExtensions__item__extensionValue_tab,
        ___UERegisterRequest_protocolExtensions__item__extensionValue,
        __UERegisterRequest_protocolExtensions__item_,
        _UERegisterRequest_protocolExtensions,
        UERegisterRequest,
        UERegisterRequestIEs,
        _UERegisterRequestIEs_val_Value_0,
        _UERegisterRequestIEs_val_Value_1,
        _UERegisterRequestIEs_val_Value_2,
        UERegisterRequestExtensions,
        ____UERegisterAccept_protocolIEs__item__id_tab,
        _____UERegisterAccept_protocolIEs__item__id_tab_val_Value_0,
        _____UERegisterAccept_protocolIEs__item__id_tab_val_Value_1,
        ___UERegisterAccept_protocolIEs__item__id,
        ___UERegisterAccept_protocolIEs__item__criticality,
        ___UERegisterAccept_protocolIEs__item__value,
        __UERegisterAccept_protocolIEs__item_,
        _UERegisterAccept_protocolIEs,
        ____UERegisterAccept_protocolExtensions__item__id_tab,
        _____UERegisterAccept_protocolExtensions__item__id_tab_val_Extension_0,
        ___UERegisterAccept_protocolExtensions__item__id,
        ___UERegisterAccept_protocolExtensions__item__criticality,
        ___UERegisterAccept_protocolExtensions__item__extensionValue,
        __UERegisterAccept_protocolExtensions__item_,
        _UERegisterAccept_protocolExtensions,
        UERegisterAccept,
        UERegisterAcceptIEs,
        _UERegisterAcceptIEs_val_Value_0,
        _UERegisterAcceptIEs_val_Value_1,
        UERegisterAcceptExtensions,
        _UERegisterAcceptExtensions_val_Extension_0,
        ____UERegisterReject_protocolIEs__item__id_tab,
        _____UERegisterReject_protocolIEs__item__id_tab_val_Value_0,
        _____UERegisterReject_protocolIEs__item__id_tab_val_Value_1,
        _____UERegisterReject_protocolIEs__item__id_tab_val_Value_2,
        ___UERegisterReject_protocolIEs__item__id,
        ___UERegisterReject_protocolIEs__item__criticality,
        ___UERegisterReject_protocolIEs__item__value,
        __UERegisterReject_protocolIEs__item_,
        _UERegisterReject_protocolIEs,
        ____UERegisterReject_protocolExtensions__item__id_tab,
        ___UERegisterReject_protocolExtensions__item__id,
        ____UERegisterReject_protocolExtensions__item__criticality_tab,
        ___UERegisterReject_protocolExtensions__item__criticality,
        ____UERegisterReject_protocolExtensions__item__extensionValue_tab,
        ___UERegisterReject_protocolExtensions__item__extensionValue,
        __UERegisterReject_protocolExtensions__item_,
        _UERegisterReject_protocolExtensions,
        UERegisterReject,
        UERegisterRejectIEs,
        _UERegisterRejectIEs_val_Value_0,
        _UERegisterRejectIEs_val_Value_1,
        _UERegisterRejectIEs_val_Value_2,
        UERegisterRejectExtensions,
        ____UEDe_Register_protocolIEs__item__id_tab,
        _____UEDe_Register_protocolIEs__item__id_tab_val_Value_0,
        _____UEDe_Register_protocolIEs__item__id_tab_val_Value_1,
        ___UEDe_Register_protocolIEs__item__id,
        ___UEDe_Register_protocolIEs__item__criticality,
        ___UEDe_Register_protocolIEs__item__value,
        __UEDe_Register_protocolIEs__item_,
        _UEDe_Register_protocolIEs,
        ____UEDe_Register_protocolExtensions__item__id_tab,
        ___UEDe_Register_protocolExtensions__item__id,
        ____UEDe_Register_protocolExtensions__item__criticality_tab,
        ___UEDe_Register_protocolExtensions__item__criticality,
        ____UEDe_Register_protocolExtensions__item__extensionValue_tab,
        ___UEDe_Register_protocolExtensions__item__extensionValue,
        __UEDe_Register_protocolExtensions__item_,
        _UEDe_Register_protocolExtensions,
        UEDe_Register,
        UEDe_RegisterIEs,
        _UEDe_RegisterIEs_val_Value_0,
        _UEDe_RegisterIEs_val_Value_1,
        UEDe_RegisterExtensions,
        ____CSGMembershipUpdate_protocolIEs__item__id_tab,
        _____CSGMembershipUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____CSGMembershipUpdate_protocolIEs__item__id_tab_val_Value_1,
        ___CSGMembershipUpdate_protocolIEs__item__id,
        ___CSGMembershipUpdate_protocolIEs__item__criticality,
        ___CSGMembershipUpdate_protocolIEs__item__value,
        __CSGMembershipUpdate_protocolIEs__item_,
        _CSGMembershipUpdate_protocolIEs,
        ____CSGMembershipUpdate_protocolExtensions__item__id_tab,
        ___CSGMembershipUpdate_protocolExtensions__item__id,
        ____CSGMembershipUpdate_protocolExtensions__item__criticality_tab,
        ___CSGMembershipUpdate_protocolExtensions__item__criticality,
        ____CSGMembershipUpdate_protocolExtensions__item__extensionValue_tab,
        ___CSGMembershipUpdate_protocolExtensions__item__extensionValue,
        __CSGMembershipUpdate_protocolExtensions__item_,
        _CSGMembershipUpdate_protocolExtensions,
        CSGMembershipUpdate,
        CSGMembershipUpdateIEs,
        _CSGMembershipUpdateIEs_val_Value_0,
        _CSGMembershipUpdateIEs_val_Value_1,
        CSGMembershipUpdateExtensions,
        ____TNLUpdateRequest_protocolIEs__item__id_tab,
        _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_0,
        _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_1,
        _____TNLUpdateRequest_protocolIEs__item__id_tab_val_Value_2,
        ___TNLUpdateRequest_protocolIEs__item__id,
        ___TNLUpdateRequest_protocolIEs__item__criticality,
        ___TNLUpdateRequest_protocolIEs__item__value,
        __TNLUpdateRequest_protocolIEs__item_,
        _TNLUpdateRequest_protocolIEs,
        ____TNLUpdateRequest_protocolExtensions__item__id_tab,
        ___TNLUpdateRequest_protocolExtensions__item__id,
        ____TNLUpdateRequest_protocolExtensions__item__criticality_tab,
        ___TNLUpdateRequest_protocolExtensions__item__criticality,
        ____TNLUpdateRequest_protocolExtensions__item__extensionValue_tab,
        ___TNLUpdateRequest_protocolExtensions__item__extensionValue,
        __TNLUpdateRequest_protocolExtensions__item_,
        _TNLUpdateRequest_protocolExtensions,
        TNLUpdateRequest,
        TNLUpdateRequestIEs,
        _TNLUpdateRequestIEs_val_Value_0,
        _TNLUpdateRequestIEs_val_Value_1,
        _TNLUpdateRequestIEs_val_Value_2,
        TNLUpdateExtensions,
        ____TNLUpdateResponse_protocolIEs__item__id_tab,
        _____TNLUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        ___TNLUpdateResponse_protocolIEs__item__id,
        ___TNLUpdateResponse_protocolIEs__item__criticality,
        ___TNLUpdateResponse_protocolIEs__item__value,
        __TNLUpdateResponse_protocolIEs__item_,
        _TNLUpdateResponse_protocolIEs,
        ____TNLUpdateResponse_protocolExtensions__item__id_tab,
        ___TNLUpdateResponse_protocolExtensions__item__id,
        ____TNLUpdateResponse_protocolExtensions__item__criticality_tab,
        ___TNLUpdateResponse_protocolExtensions__item__criticality,
        ____TNLUpdateResponse_protocolExtensions__item__extensionValue_tab,
        ___TNLUpdateResponse_protocolExtensions__item__extensionValue,
        __TNLUpdateResponse_protocolExtensions__item_,
        _TNLUpdateResponse_protocolExtensions,
        TNLUpdateResponse,
        TNLUpdateResponseIEs,
        _TNLUpdateResponseIEs_val_Value_0,
        TNLUpdateResponseExtensions,
        ____TNLUpdateFailure_protocolIEs__item__id_tab,
        _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____TNLUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___TNLUpdateFailure_protocolIEs__item__id,
        ___TNLUpdateFailure_protocolIEs__item__criticality,
        ___TNLUpdateFailure_protocolIEs__item__value,
        __TNLUpdateFailure_protocolIEs__item_,
        _TNLUpdateFailure_protocolIEs,
        ____TNLUpdateFailure_protocolExtensions__item__id_tab,
        ___TNLUpdateFailure_protocolExtensions__item__id,
        ____TNLUpdateFailure_protocolExtensions__item__criticality_tab,
        ___TNLUpdateFailure_protocolExtensions__item__criticality,
        ____TNLUpdateFailure_protocolExtensions__item__extensionValue_tab,
        ___TNLUpdateFailure_protocolExtensions__item__extensionValue,
        __TNLUpdateFailure_protocolExtensions__item_,
        _TNLUpdateFailure_protocolExtensions,
        TNLUpdateFailure,
        TNLUpdateFailureIEs,
        _TNLUpdateFailureIEs_val_Value_0,
        _TNLUpdateFailureIEs_val_Value_1,
        _TNLUpdateFailureIEs_val_Value_2,
        TNLUpdateFailureExtensions,
        ____HNBConfigTransferRequest_protocolIEs__item__id_tab,
        _____HNBConfigTransferRequest_protocolIEs__item__id_tab_val_Value_0,
        ___HNBConfigTransferRequest_protocolIEs__item__id,
        ___HNBConfigTransferRequest_protocolIEs__item__criticality,
        ___HNBConfigTransferRequest_protocolIEs__item__value,
        __HNBConfigTransferRequest_protocolIEs__item_,
        _HNBConfigTransferRequest_protocolIEs,
        ____HNBConfigTransferRequest_protocolExtensions__item__id_tab,
        ___HNBConfigTransferRequest_protocolExtensions__item__id,
        ____HNBConfigTransferRequest_protocolExtensions__item__criticality_tab,
        ___HNBConfigTransferRequest_protocolExtensions__item__criticality,
        ____HNBConfigTransferRequest_protocolExtensions__item__extensionValue_tab,
        ___HNBConfigTransferRequest_protocolExtensions__item__extensionValue,
        __HNBConfigTransferRequest_protocolExtensions__item_,
        _HNBConfigTransferRequest_protocolExtensions,
        HNBConfigTransferRequest,
        HNBConfigTransferRequestIEs,
        _HNBConfigTransferRequestIEs_val_Value_0,
        HNBConfigTransferRequestExtensions,
        ____HNBConfigTransferResponse_protocolIEs__item__id_tab,
        _____HNBConfigTransferResponse_protocolIEs__item__id_tab_val_Value_0,
        ___HNBConfigTransferResponse_protocolIEs__item__id,
        ___HNBConfigTransferResponse_protocolIEs__item__criticality,
        ___HNBConfigTransferResponse_protocolIEs__item__value,
        __HNBConfigTransferResponse_protocolIEs__item_,
        _HNBConfigTransferResponse_protocolIEs,
        ____HNBConfigTransferResponse_protocolExtensions__item__id_tab,
        _____HNBConfigTransferResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___HNBConfigTransferResponse_protocolExtensions__item__id,
        ___HNBConfigTransferResponse_protocolExtensions__item__criticality,
        ___HNBConfigTransferResponse_protocolExtensions__item__extensionValue,
        __HNBConfigTransferResponse_protocolExtensions__item_,
        _HNBConfigTransferResponse_protocolExtensions,
        HNBConfigTransferResponse,
        HNBConfigTransferResponseIEs,
        _HNBConfigTransferResponseIEs_val_Value_0,
        HNBConfigTransferResponseExtensions,
        _HNBConfigTransferResponseExtensions_val_Extension_0,
        ____RelocationComplete_protocolIEs__item__id_tab,
        _____RelocationComplete_protocolIEs__item__id_tab_val_Value_0,
        ___RelocationComplete_protocolIEs__item__id,
        ___RelocationComplete_protocolIEs__item__criticality,
        ___RelocationComplete_protocolIEs__item__value,
        __RelocationComplete_protocolIEs__item_,
        _RelocationComplete_protocolIEs,
        ____RelocationComplete_protocolExtensions__item__id_tab,
        ___RelocationComplete_protocolExtensions__item__id,
        ____RelocationComplete_protocolExtensions__item__criticality_tab,
        ___RelocationComplete_protocolExtensions__item__criticality,
        ____RelocationComplete_protocolExtensions__item__extensionValue_tab,
        ___RelocationComplete_protocolExtensions__item__extensionValue,
        __RelocationComplete_protocolExtensions__item_,
        _RelocationComplete_protocolExtensions,
        RelocationComplete,
        RelocationCompleteIEs,
        _RelocationCompleteIEs_val_Value_0,
        RelocationCompleteExtensions,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        ___ErrorIndication_protocolExtensions__item__id,
        ____ErrorIndication_protocolExtensions__item__criticality_tab,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ____ErrorIndication_protocolExtensions__item__extensionValue_tab,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        ErrorIndicationExtensions,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____U_RNTIQueryRequest_protocolIEs__item__id_tab,
        _____U_RNTIQueryRequest_protocolIEs__item__id_tab_val_Value_0,
        ___U_RNTIQueryRequest_protocolIEs__item__id,
        ___U_RNTIQueryRequest_protocolIEs__item__criticality,
        ___U_RNTIQueryRequest_protocolIEs__item__value,
        __U_RNTIQueryRequest_protocolIEs__item_,
        _U_RNTIQueryRequest_protocolIEs,
        ____U_RNTIQueryRequest_protocolExtensions__item__id_tab,
        ___U_RNTIQueryRequest_protocolExtensions__item__id,
        ____U_RNTIQueryRequest_protocolExtensions__item__criticality_tab,
        ___U_RNTIQueryRequest_protocolExtensions__item__criticality,
        ____U_RNTIQueryRequest_protocolExtensions__item__extensionValue_tab,
        ___U_RNTIQueryRequest_protocolExtensions__item__extensionValue,
        __U_RNTIQueryRequest_protocolExtensions__item_,
        _U_RNTIQueryRequest_protocolExtensions,
        U_RNTIQueryRequest,
        U_RNTIQueryRequestIEs,
        _U_RNTIQueryRequestIEs_val_Value_0,
        U_RNTIQueryRequestExtensions,
        ____U_RNTIQueryResponse_protocolIEs__item__id_tab,
        _____U_RNTIQueryResponse_protocolIEs__item__id_tab_val_Value_0,
        ___U_RNTIQueryResponse_protocolIEs__item__id,
        ___U_RNTIQueryResponse_protocolIEs__item__criticality,
        ___U_RNTIQueryResponse_protocolIEs__item__value,
        __U_RNTIQueryResponse_protocolIEs__item_,
        _U_RNTIQueryResponse_protocolIEs,
        ____U_RNTIQueryResponse_protocolExtensions__item__id_tab,
        ___U_RNTIQueryResponse_protocolExtensions__item__id,
        ____U_RNTIQueryResponse_protocolExtensions__item__criticality_tab,
        ___U_RNTIQueryResponse_protocolExtensions__item__criticality,
        ____U_RNTIQueryResponse_protocolExtensions__item__extensionValue_tab,
        ___U_RNTIQueryResponse_protocolExtensions__item__extensionValue,
        __U_RNTIQueryResponse_protocolExtensions__item_,
        _U_RNTIQueryResponse_protocolExtensions,
        U_RNTIQueryResponse,
        U_RNTIQueryResponseIEs,
        _U_RNTIQueryResponseIEs_val_Value_0,
        U_RNTIQueryResponseExtensions,
    ]

class HNBAP_PDU_Descriptions:

    _name_  = 'HNBAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 6, 1, 0]
    
    _obj_ = [
        'HNBAP-ELEMENTARY-PROCEDURE',
        'HNBAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'HNBAP-ELEMENTARY-PROCEDURES',
        'HNBAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'HNBAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'hNBRegister',
        'uERegister',
        'uEDe-Register',
        'hNBDe-Register',
        'errorIndication',
        'csg-membership-update',
        'tnlUpdate',
        'hNBConfigTransfer',
        'relocationComplete',
        'u-RNTIQuery',
        'privateMessage',
        ]
    _type_ = [
        'HNBAP-ELEMENTARY-PROCEDURE',
        'HNBAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'HNBAP-ELEMENTARY-PROCEDURES',
        'HNBAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'HNBAP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'hNBRegister',
        'uERegister',
        'uEDe-Register',
        'hNBDe-Register',
        'errorIndication',
        'csg-membership-update',
        'tnlUpdate',
        'hNBConfigTransfer',
        'relocationComplete',
        'u-RNTIQuery',
        'privateMessage',
        ]
    _class_ = [
        'HNBAP-ELEMENTARY-PROCEDURE',
        'HNBAP-ELEMENTARY-PROCEDURES',
        'HNBAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'HNBAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'hNBRegister',
        'uERegister',
        'uEDe-Register',
        'hNBDe-Register',
        'errorIndication',
        'csg-membership-update',
        'tnlUpdate',
        'hNBConfigTransfer',
        'relocationComplete',
        'u-RNTIQuery',
        'privateMessage',
        ]
    _param_ = [
        ]
    
    #-----< HNBAP-ELEMENTARY-PROCEDURE >-----#
    HNBAP_ELEMENTARY_PROCEDURE = CLASS(name='HNBAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _HNBAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _HNBAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _HNBAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _HNBAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _HNBAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-CommonDataTypes', 'Criticality')), default='ignore')
    HNBAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _HNBAP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _HNBAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< HNBAP-PDU >-----#
    HNBAP_PDU = CHOICE(name='HNBAP-PDU', mode=MODE_TYPE)
    _HNBAP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'InitiatingMessage')))
    _HNBAP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _HNBAP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    HNBAP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _HNBAP_PDU_initiatingMessage),
        ('successfulOutcome', _HNBAP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _HNBAP_PDU_unsuccessfulOutcome),
        ])
    HNBAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_HNBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterAccept')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterAccept')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UEDe-Register')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBDe-Register')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'CSGMembershipUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'RelocationComplete')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')])], er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_HNBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterAccept')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterAccept')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UEDe-Register')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBDe-Register')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'CSGMembershipUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'RelocationComplete')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')])], er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_HNBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterAccept')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterAccept')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UEDe-Register')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBDe-Register')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'CSGMembershipUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'RelocationComplete')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')])], er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< HNBAP-ELEMENTARY-PROCEDURES >-----#
    HNBAP_ELEMENTARY_PROCEDURES = CLASS(name='HNBAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterAccept')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterReject')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterAccept')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterReject')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UEDe-Register')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBDe-Register')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'ErrorIndication')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'PrivateMessage')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateResponse')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateFailure')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferResponse')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryResponse')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'CSGMembershipUpdate')))
    _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'RelocationComplete')))
    HNBAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')])], er=[])
    
    #-----< HNBAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    HNBAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='HNBAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterAccept')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterReject')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterAccept')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterReject')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateResponse')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateFailure')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferResponse')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryRequest')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryResponse')))
    HNBAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('procedureCode', 14), ('criticality', 'reject')])], er=[])
    
    #-----< HNBAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    HNBAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='HNBAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UEDe-Register')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBDe-Register')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'ErrorIndication')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'PrivateMessage')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'CSGMembershipUpdate')))
    _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'RelocationComplete')))
    HNBAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 6), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 11), ('criticality', 'ignore')])], er=[])
    
    #-----< hNBRegister >-----#
    hNBRegister = CLASS(name='hNBRegister', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _hNBRegister_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterRequest')))
    _hNBRegister_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterAccept')))
    _hNBRegister_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBRegisterReject')))
    hNBRegister._val = dict([('InitiatingMessage', _hNBRegister_val_InitiatingMessage), ('SuccessfulOutcome', _hNBRegister_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _hNBRegister_val_UnsuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< uERegister >-----#
    uERegister = CLASS(name='uERegister', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _uERegister_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterRequest')))
    _uERegister_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterAccept')))
    _uERegister_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UERegisterReject')))
    uERegister._val = dict([('InitiatingMessage', _uERegister_val_InitiatingMessage), ('SuccessfulOutcome', _uERegister_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uERegister_val_UnsuccessfulOutcome), ('procedureCode', 3), ('criticality', 'reject')])
    
    #-----< uEDe-Register >-----#
    uEDe_Register = CLASS(name='uEDe-Register', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _uEDe_Register_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'UEDe-Register')))
    uEDe_Register._val = dict([('InitiatingMessage', _uEDe_Register_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< hNBDe-Register >-----#
    hNBDe_Register = CLASS(name='hNBDe-Register', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _hNBDe_Register_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBDe-Register')))
    hNBDe_Register._val = dict([('InitiatingMessage', _hNBDe_Register_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< csg-membership-update >-----#
    csg_membership_update = CLASS(name='csg-membership-update', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _csg_membership_update_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'CSGMembershipUpdate')))
    csg_membership_update._val = dict([('InitiatingMessage', _csg_membership_update_val_InitiatingMessage), ('procedureCode', 7), ('criticality', 'ignore')])
    
    #-----< tnlUpdate >-----#
    tnlUpdate = CLASS(name='tnlUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _tnlUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateRequest')))
    _tnlUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateResponse')))
    _tnlUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'TNLUpdateFailure')))
    tnlUpdate._val = dict([('InitiatingMessage', _tnlUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _tnlUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _tnlUpdate_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< hNBConfigTransfer >-----#
    hNBConfigTransfer = CLASS(name='hNBConfigTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _hNBConfigTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferRequest')))
    _hNBConfigTransfer_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'HNBConfigTransferResponse')))
    hNBConfigTransfer._val = dict([('InitiatingMessage', _hNBConfigTransfer_val_InitiatingMessage), ('SuccessfulOutcome', _hNBConfigTransfer_val_SuccessfulOutcome), ('procedureCode', 10), ('criticality', 'reject')])
    
    #-----< relocationComplete >-----#
    relocationComplete = CLASS(name='relocationComplete', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _relocationComplete_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'RelocationComplete')))
    relocationComplete._val = dict([('InitiatingMessage', _relocationComplete_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< u-RNTIQuery >-----#
    u_RNTIQuery = CLASS(name='u-RNTIQuery', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _u_RNTIQuery_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryRequest')))
    _u_RNTIQuery_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'U-RNTIQueryResponse')))
    u_RNTIQuery._val = dict([('InitiatingMessage', _u_RNTIQuery_val_InitiatingMessage), ('SuccessfulOutcome', _u_RNTIQuery_val_SuccessfulOutcome), ('procedureCode', 14), ('criticality', 'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('HNBAP-PDU-Descriptions', 'HNBAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('HNBAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 6), ('criticality', 'ignore')])
    
    _all_ = [
        _HNBAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _HNBAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _HNBAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _HNBAP_ELEMENTARY_PROCEDURE_procedureCode,
        _HNBAP_ELEMENTARY_PROCEDURE_criticality,
        HNBAP_ELEMENTARY_PROCEDURE,
        _HNBAP_PDU_initiatingMessage,
        _HNBAP_PDU_successfulOutcome,
        _HNBAP_PDU_unsuccessfulOutcome,
        HNBAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        HNBAP_ELEMENTARY_PROCEDURES,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _HNBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _HNBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _HNBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        HNBAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        HNBAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _HNBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        hNBRegister,
        _hNBRegister_val_InitiatingMessage,
        _hNBRegister_val_SuccessfulOutcome,
        _hNBRegister_val_UnsuccessfulOutcome,
        uERegister,
        _uERegister_val_InitiatingMessage,
        _uERegister_val_SuccessfulOutcome,
        _uERegister_val_UnsuccessfulOutcome,
        uEDe_Register,
        _uEDe_Register_val_InitiatingMessage,
        hNBDe_Register,
        _hNBDe_Register_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        csg_membership_update,
        _csg_membership_update_val_InitiatingMessage,
        tnlUpdate,
        _tnlUpdate_val_InitiatingMessage,
        _tnlUpdate_val_SuccessfulOutcome,
        _tnlUpdate_val_UnsuccessfulOutcome,
        hNBConfigTransfer,
        _hNBConfigTransfer_val_InitiatingMessage,
        _hNBConfigTransfer_val_SuccessfulOutcome,
        relocationComplete,
        _relocationComplete_val_InitiatingMessage,
        u_RNTIQuery,
        _u_RNTIQuery_val_InitiatingMessage,
        _u_RNTIQuery_val_SuccessfulOutcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
    ]

init_modules(HNBAP_CommonDataTypes, HNBAP_Constants, HNBAP_Containers, HNBAP_IEs, HNBAP_PDU_Contents, HNBAP_PDU_Descriptions)
