# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class LPP_PDU_Definitions:

    _name_  = 'LPP-PDU-Definitions'
    _oid_   = [0, 4, 0, 0, 21, 3, 7, 1, 1]
    
    _obj_ = [
        'LPP-Message',
        'SequenceNumber',
        'Acknowledgement',
        'LPP-MessageBody',
        'LPP-TransactionID',
        'Initiator',
        'TransactionNumber',
        'RequestCapabilities',
        'RequestCapabilities-r9-IEs',
        'ProvideCapabilities',
        'ProvideCapabilities-r9-IEs',
        'RequestAssistanceData',
        'RequestAssistanceData-r9-IEs',
        'ProvideAssistanceData',
        'ProvideAssistanceData-r9-IEs',
        'RequestLocationInformation',
        'RequestLocationInformation-r9-IEs',
        'ProvideLocationInformation',
        'ProvideLocationInformation-r9-IEs',
        'Abort',
        'Abort-r9-IEs',
        'Error',
        'Error-r9-IEs',
        'AccessTypes',
        'ARFCN-ValueEUTRA',
        'ARFCN-ValueEUTRA-v9a0',
        'maxEARFCN',
        'maxEARFCN-Plus1',
        'maxEARFCN2',
        'ARFCN-ValueUTRA',
        'CellGlobalIdEUTRA-AndUTRA',
        'CellGlobalIdGERAN',
        'ECGI',
        'Ellipsoid-Point',
        'Ellipsoid-PointWithUncertaintyCircle',
        'EllipsoidPointWithUncertaintyEllipse',
        'EllipsoidPointWithAltitude',
        'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid',
        'EllipsoidArc',
        'EPDU-Sequence',
        'maxEPDU',
        'EPDU',
        'EPDU-Identifier',
        'EPDU-ID',
        'EPDU-Name',
        'EPDU-Body',
        'HorizontalVelocity',
        'HorizontalWithVerticalVelocity',
        'HorizontalVelocityWithUncertainty',
        'HorizontalWithVerticalVelocityAndUncertainty',
        'LocationCoordinateTypes',
        'Polygon',
        'PolygonPoints',
        'PositioningModes',
        'VelocityTypes',
        'CommonIEsRequestCapabilities',
        'CommonIEsProvideCapabilities',
        'CommonIEsRequestAssistanceData',
        'CommonIEsProvideAssistanceData',
        'CommonIEsRequestLocationInformation',
        'LocationInformationType',
        'PeriodicalReportingCriteria',
        'TriggeredReportingCriteria',
        'ReportingDuration',
        'AdditionalInformation',
        'QoS',
        'HorizontalAccuracy',
        'VerticalAccuracy',
        'ResponseTime',
        'Environment',
        'CommonIEsProvideLocationInformation',
        'LocationCoordinates',
        'Velocity',
        'LocationError',
        'LocationFailureCause',
        'EarlyFixReport-r12',
        'LocationSource-r13',
        'CommonIEsAbort',
        'CommonIEsError',
        'OTDOA-ProvideAssistanceData',
        'OTDOA-ReferenceCellInfo',
        'PRS-Info',
        'OTDOA-NeighbourCellInfoList',
        'OTDOA-NeighbourFreqInfo',
        'OTDOA-NeighbourCellInfoElement',
        'maxFreqLayers',
        'OTDOA-RequestAssistanceData',
        'OTDOA-ProvideLocationInformation',
        'OTDOA-SignalMeasurementInformation',
        'NeighbourMeasurementList',
        'NeighbourMeasurementElement',
        'OTDOA-MeasQuality',
        'OTDOA-RequestLocationInformation',
        'OTDOA-ProvideCapabilities',
        'maxBands',
        'SupportedBandEUTRA',
        'SupportedBandEUTRA-v9a0',
        'maxFBI',
        'maxFBI-Plus1',
        'maxFBI2',
        'OTDOA-RequestCapabilities',
        'OTDOA-Error',
        'OTDOA-LocationServerErrorCauses',
        'OTDOA-TargetDeviceErrorCauses',
        'A-GNSS-ProvideAssistanceData',
        'GNSS-CommonAssistData',
        'GNSS-GenericAssistData',
        'GNSS-GenericAssistDataElement',
        'GNSS-ReferenceTime',
        'GNSS-ReferenceTimeForOneCell',
        'GNSS-SystemTime',
        'GPS-TOW-Assist',
        'GPS-TOW-AssistElement',
        'NetworkTime',
        'GNSS-ReferenceLocation',
        'GNSS-IonosphericModel',
        'KlobucharModelParameter',
        'NeQuickModelParameter',
        'GNSS-EarthOrientationParameters',
        'GNSS-TimeModelList',
        'GNSS-TimeModelElement',
        'GNSS-DifferentialCorrections',
        'DGNSS-SgnTypeList',
        'DGNSS-SgnTypeElement',
        'DGNSS-SatList',
        'DGNSS-CorrectionsElement',
        'GNSS-NavigationModel',
        'GNSS-NavModelSatelliteList',
        'GNSS-NavModelSatelliteElement',
        'GNSS-ClockModel',
        'GNSS-OrbitModel',
        'StandardClockModelList',
        'StandardClockModelElement',
        'NAV-ClockModel',
        'CNAV-ClockModel',
        'GLONASS-ClockModel',
        'SBAS-ClockModel',
        'BDS-ClockModel-r12',
        'NavModelKeplerianSet',
        'NavModelNAV-KeplerianSet',
        'NavModelCNAV-KeplerianSet',
        'NavModel-GLONASS-ECEF',
        'NavModel-SBAS-ECEF',
        'NavModel-BDS-KeplerianSet-r12',
        'GNSS-RealTimeIntegrity',
        'GNSS-BadSignalList',
        'BadSignalElement',
        'GNSS-DataBitAssistance',
        'GNSS-DataBitsSatList',
        'GNSS-DataBitsSatElement',
        'GNSS-DataBitsSgnList',
        'GNSS-DataBitsSgnElement',
        'GNSS-AcquisitionAssistance',
        'GNSS-AcquisitionAssistList',
        'GNSS-AcquisitionAssistElement',
        'GNSS-Almanac',
        'GNSS-AlmanacList',
        'GNSS-AlmanacElement',
        'AlmanacKeplerianSet',
        'AlmanacNAV-KeplerianSet',
        'AlmanacReducedKeplerianSet',
        'AlmanacMidiAlmanacSet',
        'AlmanacGLONASS-AlmanacSet',
        'AlmanacECEF-SBAS-AlmanacSet',
        'AlmanacBDS-AlmanacSet-r12',
        'GNSS-UTC-Model',
        'UTC-ModelSet1',
        'UTC-ModelSet2',
        'UTC-ModelSet3',
        'UTC-ModelSet4',
        'UTC-ModelSet5-r12',
        'GNSS-AuxiliaryInformation',
        'GNSS-ID-GPS',
        'GNSS-ID-GPS-SatElement',
        'GNSS-ID-GLONASS',
        'GNSS-ID-GLONASS-SatElement',
        'BDS-DifferentialCorrections-r12',
        'BDS-SgnTypeList-r12',
        'BDS-SgnTypeElement-r12',
        'DBDS-CorrectionList-r12',
        'DBDS-CorrectionElement-r12',
        'BDS-GridModelParameter-r12',
        'GridIonList-r12',
        'GridIonElement-r12',
        'A-GNSS-RequestAssistanceData',
        'GNSS-CommonAssistDataReq',
        'GNSS-GenericAssistDataReq',
        'GNSS-GenericAssistDataReqElement',
        'GNSS-ReferenceTimeReq',
        'GNSS-ReferenceLocationReq',
        'GNSS-IonosphericModelReq',
        'GNSS-EarthOrientationParametersReq',
        'GNSS-TimeModelListReq',
        'GNSS-TimeModelElementReq',
        'GNSS-DifferentialCorrectionsReq',
        'GNSS-NavigationModelReq',
        'StoredNavListInfo',
        'SatListRelatedDataList',
        'SatListRelatedDataElement',
        'ReqNavListInfo',
        'GNSS-RealTimeIntegrityReq',
        'GNSS-DataBitAssistanceReq',
        'GNSS-DataBitsReqSatList',
        'GNSS-DataBitsReqSatElement',
        'GNSS-AcquisitionAssistanceReq',
        'GNSS-AlmanacReq',
        'GNSS-UTC-ModelReq',
        'GNSS-AuxiliaryInformationReq',
        'BDS-DifferentialCorrectionsReq-r12',
        'BDS-GridModelReq-r12',
        'A-GNSS-ProvideLocationInformation',
        'GNSS-SignalMeasurementInformation',
        'MeasurementReferenceTime',
        'GNSS-MeasurementList',
        'GNSS-MeasurementForOneGNSS',
        'GNSS-SgnMeasList',
        'GNSS-SgnMeasElement',
        'GNSS-SatMeasList',
        'GNSS-SatMeasElement',
        'GNSS-LocationInformation',
        'A-GNSS-RequestLocationInformation',
        'GNSS-PositioningInstructions',
        'A-GNSS-ProvideCapabilities',
        'GNSS-SupportList',
        'GNSS-SupportElement',
        'AssistanceDataSupportList',
        'GNSS-CommonAssistanceDataSupport',
        'GNSS-ReferenceTimeSupport',
        'GNSS-ReferenceLocationSupport',
        'GNSS-IonosphericModelSupport',
        'GNSS-EarthOrientationParametersSupport',
        'GNSS-GenericAssistanceDataSupport',
        'GNSS-GenericAssistDataSupportElement',
        'GNSS-TimeModelListSupport',
        'GNSS-DifferentialCorrectionsSupport',
        'GNSS-NavigationModelSupport',
        'GNSS-RealTimeIntegritySupport',
        'GNSS-DataBitAssistanceSupport',
        'GNSS-AcquisitionAssistanceSupport',
        'GNSS-AlmanacSupport',
        'GNSS-UTC-ModelSupport',
        'GNSS-AuxiliaryInformationSupport',
        'BDS-DifferentialCorrectionsSupport-r12',
        'BDS-GridModelSupport-r12',
        'A-GNSS-RequestCapabilities',
        'A-GNSS-Error',
        'GNSS-LocationServerErrorCauses',
        'GNSS-TargetDeviceErrorCauses',
        'GNSS-ID',
        'GNSS-ID-Bitmap',
        'GNSS-SignalID',
        'GNSS-SignalIDs',
        'SBAS-ID',
        'SBAS-IDs',
        'SV-ID',
        'ECID-ProvideLocationInformation',
        'ECID-SignalMeasurementInformation',
        'MeasuredResultsList',
        'MeasuredResultsElement',
        'ECID-RequestLocationInformation',
        'ECID-ProvideCapabilities',
        'ECID-RequestCapabilities',
        'ECID-Error',
        'ECID-LocationServerErrorCauses',
        'ECID-TargetDeviceErrorCauses',
        'TBS-ProvideLocationInformation-r13',
        'TBS-MeasurementInformation-r13',
        'MBS-BeaconMeasList-r13',
        'MBS-BeaconMeasElement-r13',
        'TBS-RequestLocationInformation-r13',
        'TBS-ProvideCapabilities-r13',
        'TBS-RequestCapabilities-r13',
        'TBS-Error-r13',
        'TBS-LocationServerErrorCauses-r13',
        'TBS-TargetDeviceErrorCauses-r13',
        'Sensor-ProvideLocationInformation-r13',
        'Sensor-MeasurementInformation-r13',
        'Sensor-RequestLocationInformation-r13',
        'Sensor-ProvideCapabilities-r13',
        'Sensor-RequestCapabilities-r13',
        'Sensor-Error-r13',
        'Sensor-LocationServerErrorCauses-r13',
        'Sensor-TargetDeviceErrorCauses-r13',
        'WLAN-ProvideLocationInformation-r13',
        'WLAN-MeasurementInformation-r13',
        'WLAN-MeasurementList-r13',
        'WLAN-MeasurementElement-r13',
        'WLAN-AP-Identifier-r13',
        'WLAN-RTT-r13',
        'maxWLAN-AP-r13',
        'WLAN-RequestLocationInformation-r13',
        'WLAN-ProvideCapabilities-r13',
        'WLAN-RequestCapabilities-r13',
        'WLAN-Error-r13',
        'WLAN-LocationServerErrorCauses-r13',
        'WLAN-TargetDeviceErrorCauses-r13',
        'BT-ProvideLocationInformation-r13',
        'BT-MeasurementInformation-r13',
        'BT-MeasurementList-r13',
        'BT-MeasurementElement-r13',
        'maxBT-Beacon-r13',
        'BT-RequestLocationInformation-r13',
        'BT-ProvideCapabilities-r13',
        'BT-RequestCapabilities-r13',
        'BT-Error-r13',
        'BT-LocationServerErrorCauses-r13',
        'BT-TargetDeviceErrorCauses-r13',
        ]
    _type_ = [
        'LPP-Message',
        'SequenceNumber',
        'Acknowledgement',
        'LPP-MessageBody',
        'LPP-TransactionID',
        'Initiator',
        'TransactionNumber',
        'RequestCapabilities',
        'RequestCapabilities-r9-IEs',
        'ProvideCapabilities',
        'ProvideCapabilities-r9-IEs',
        'RequestAssistanceData',
        'RequestAssistanceData-r9-IEs',
        'ProvideAssistanceData',
        'ProvideAssistanceData-r9-IEs',
        'RequestLocationInformation',
        'RequestLocationInformation-r9-IEs',
        'ProvideLocationInformation',
        'ProvideLocationInformation-r9-IEs',
        'Abort',
        'Abort-r9-IEs',
        'Error',
        'Error-r9-IEs',
        'AccessTypes',
        'ARFCN-ValueEUTRA',
        'ARFCN-ValueEUTRA-v9a0',
        'ARFCN-ValueUTRA',
        'CellGlobalIdEUTRA-AndUTRA',
        'CellGlobalIdGERAN',
        'ECGI',
        'Ellipsoid-Point',
        'Ellipsoid-PointWithUncertaintyCircle',
        'EllipsoidPointWithUncertaintyEllipse',
        'EllipsoidPointWithAltitude',
        'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid',
        'EllipsoidArc',
        'EPDU-Sequence',
        'EPDU',
        'EPDU-Identifier',
        'EPDU-ID',
        'EPDU-Name',
        'EPDU-Body',
        'HorizontalVelocity',
        'HorizontalWithVerticalVelocity',
        'HorizontalVelocityWithUncertainty',
        'HorizontalWithVerticalVelocityAndUncertainty',
        'LocationCoordinateTypes',
        'Polygon',
        'PolygonPoints',
        'PositioningModes',
        'VelocityTypes',
        'CommonIEsRequestCapabilities',
        'CommonIEsProvideCapabilities',
        'CommonIEsRequestAssistanceData',
        'CommonIEsProvideAssistanceData',
        'CommonIEsRequestLocationInformation',
        'LocationInformationType',
        'PeriodicalReportingCriteria',
        'TriggeredReportingCriteria',
        'ReportingDuration',
        'AdditionalInformation',
        'QoS',
        'HorizontalAccuracy',
        'VerticalAccuracy',
        'ResponseTime',
        'Environment',
        'CommonIEsProvideLocationInformation',
        'LocationCoordinates',
        'Velocity',
        'LocationError',
        'LocationFailureCause',
        'EarlyFixReport-r12',
        'LocationSource-r13',
        'CommonIEsAbort',
        'CommonIEsError',
        'OTDOA-ProvideAssistanceData',
        'OTDOA-ReferenceCellInfo',
        'PRS-Info',
        'OTDOA-NeighbourCellInfoList',
        'OTDOA-NeighbourFreqInfo',
        'OTDOA-NeighbourCellInfoElement',
        'OTDOA-RequestAssistanceData',
        'OTDOA-ProvideLocationInformation',
        'OTDOA-SignalMeasurementInformation',
        'NeighbourMeasurementList',
        'NeighbourMeasurementElement',
        'OTDOA-MeasQuality',
        'OTDOA-RequestLocationInformation',
        'OTDOA-ProvideCapabilities',
        'SupportedBandEUTRA',
        'SupportedBandEUTRA-v9a0',
        'OTDOA-RequestCapabilities',
        'OTDOA-Error',
        'OTDOA-LocationServerErrorCauses',
        'OTDOA-TargetDeviceErrorCauses',
        'A-GNSS-ProvideAssistanceData',
        'GNSS-CommonAssistData',
        'GNSS-GenericAssistData',
        'GNSS-GenericAssistDataElement',
        'GNSS-ReferenceTime',
        'GNSS-ReferenceTimeForOneCell',
        'GNSS-SystemTime',
        'GPS-TOW-Assist',
        'GPS-TOW-AssistElement',
        'NetworkTime',
        'GNSS-ReferenceLocation',
        'GNSS-IonosphericModel',
        'KlobucharModelParameter',
        'NeQuickModelParameter',
        'GNSS-EarthOrientationParameters',
        'GNSS-TimeModelList',
        'GNSS-TimeModelElement',
        'GNSS-DifferentialCorrections',
        'DGNSS-SgnTypeList',
        'DGNSS-SgnTypeElement',
        'DGNSS-SatList',
        'DGNSS-CorrectionsElement',
        'GNSS-NavigationModel',
        'GNSS-NavModelSatelliteList',
        'GNSS-NavModelSatelliteElement',
        'GNSS-ClockModel',
        'GNSS-OrbitModel',
        'StandardClockModelList',
        'StandardClockModelElement',
        'NAV-ClockModel',
        'CNAV-ClockModel',
        'GLONASS-ClockModel',
        'SBAS-ClockModel',
        'BDS-ClockModel-r12',
        'NavModelKeplerianSet',
        'NavModelNAV-KeplerianSet',
        'NavModelCNAV-KeplerianSet',
        'NavModel-GLONASS-ECEF',
        'NavModel-SBAS-ECEF',
        'NavModel-BDS-KeplerianSet-r12',
        'GNSS-RealTimeIntegrity',
        'GNSS-BadSignalList',
        'BadSignalElement',
        'GNSS-DataBitAssistance',
        'GNSS-DataBitsSatList',
        'GNSS-DataBitsSatElement',
        'GNSS-DataBitsSgnList',
        'GNSS-DataBitsSgnElement',
        'GNSS-AcquisitionAssistance',
        'GNSS-AcquisitionAssistList',
        'GNSS-AcquisitionAssistElement',
        'GNSS-Almanac',
        'GNSS-AlmanacList',
        'GNSS-AlmanacElement',
        'AlmanacKeplerianSet',
        'AlmanacNAV-KeplerianSet',
        'AlmanacReducedKeplerianSet',
        'AlmanacMidiAlmanacSet',
        'AlmanacGLONASS-AlmanacSet',
        'AlmanacECEF-SBAS-AlmanacSet',
        'AlmanacBDS-AlmanacSet-r12',
        'GNSS-UTC-Model',
        'UTC-ModelSet1',
        'UTC-ModelSet2',
        'UTC-ModelSet3',
        'UTC-ModelSet4',
        'UTC-ModelSet5-r12',
        'GNSS-AuxiliaryInformation',
        'GNSS-ID-GPS',
        'GNSS-ID-GPS-SatElement',
        'GNSS-ID-GLONASS',
        'GNSS-ID-GLONASS-SatElement',
        'BDS-DifferentialCorrections-r12',
        'BDS-SgnTypeList-r12',
        'BDS-SgnTypeElement-r12',
        'DBDS-CorrectionList-r12',
        'DBDS-CorrectionElement-r12',
        'BDS-GridModelParameter-r12',
        'GridIonList-r12',
        'GridIonElement-r12',
        'A-GNSS-RequestAssistanceData',
        'GNSS-CommonAssistDataReq',
        'GNSS-GenericAssistDataReq',
        'GNSS-GenericAssistDataReqElement',
        'GNSS-ReferenceTimeReq',
        'GNSS-ReferenceLocationReq',
        'GNSS-IonosphericModelReq',
        'GNSS-EarthOrientationParametersReq',
        'GNSS-TimeModelListReq',
        'GNSS-TimeModelElementReq',
        'GNSS-DifferentialCorrectionsReq',
        'GNSS-NavigationModelReq',
        'StoredNavListInfo',
        'SatListRelatedDataList',
        'SatListRelatedDataElement',
        'ReqNavListInfo',
        'GNSS-RealTimeIntegrityReq',
        'GNSS-DataBitAssistanceReq',
        'GNSS-DataBitsReqSatList',
        'GNSS-DataBitsReqSatElement',
        'GNSS-AcquisitionAssistanceReq',
        'GNSS-AlmanacReq',
        'GNSS-UTC-ModelReq',
        'GNSS-AuxiliaryInformationReq',
        'BDS-DifferentialCorrectionsReq-r12',
        'BDS-GridModelReq-r12',
        'A-GNSS-ProvideLocationInformation',
        'GNSS-SignalMeasurementInformation',
        'MeasurementReferenceTime',
        'GNSS-MeasurementList',
        'GNSS-MeasurementForOneGNSS',
        'GNSS-SgnMeasList',
        'GNSS-SgnMeasElement',
        'GNSS-SatMeasList',
        'GNSS-SatMeasElement',
        'GNSS-LocationInformation',
        'A-GNSS-RequestLocationInformation',
        'GNSS-PositioningInstructions',
        'A-GNSS-ProvideCapabilities',
        'GNSS-SupportList',
        'GNSS-SupportElement',
        'AssistanceDataSupportList',
        'GNSS-CommonAssistanceDataSupport',
        'GNSS-ReferenceTimeSupport',
        'GNSS-ReferenceLocationSupport',
        'GNSS-IonosphericModelSupport',
        'GNSS-EarthOrientationParametersSupport',
        'GNSS-GenericAssistanceDataSupport',
        'GNSS-GenericAssistDataSupportElement',
        'GNSS-TimeModelListSupport',
        'GNSS-DifferentialCorrectionsSupport',
        'GNSS-NavigationModelSupport',
        'GNSS-RealTimeIntegritySupport',
        'GNSS-DataBitAssistanceSupport',
        'GNSS-AcquisitionAssistanceSupport',
        'GNSS-AlmanacSupport',
        'GNSS-UTC-ModelSupport',
        'GNSS-AuxiliaryInformationSupport',
        'BDS-DifferentialCorrectionsSupport-r12',
        'BDS-GridModelSupport-r12',
        'A-GNSS-RequestCapabilities',
        'A-GNSS-Error',
        'GNSS-LocationServerErrorCauses',
        'GNSS-TargetDeviceErrorCauses',
        'GNSS-ID',
        'GNSS-ID-Bitmap',
        'GNSS-SignalID',
        'GNSS-SignalIDs',
        'SBAS-ID',
        'SBAS-IDs',
        'SV-ID',
        'ECID-ProvideLocationInformation',
        'ECID-SignalMeasurementInformation',
        'MeasuredResultsList',
        'MeasuredResultsElement',
        'ECID-RequestLocationInformation',
        'ECID-ProvideCapabilities',
        'ECID-RequestCapabilities',
        'ECID-Error',
        'ECID-LocationServerErrorCauses',
        'ECID-TargetDeviceErrorCauses',
        'TBS-ProvideLocationInformation-r13',
        'TBS-MeasurementInformation-r13',
        'MBS-BeaconMeasList-r13',
        'MBS-BeaconMeasElement-r13',
        'TBS-RequestLocationInformation-r13',
        'TBS-ProvideCapabilities-r13',
        'TBS-RequestCapabilities-r13',
        'TBS-Error-r13',
        'TBS-LocationServerErrorCauses-r13',
        'TBS-TargetDeviceErrorCauses-r13',
        'Sensor-ProvideLocationInformation-r13',
        'Sensor-MeasurementInformation-r13',
        'Sensor-RequestLocationInformation-r13',
        'Sensor-ProvideCapabilities-r13',
        'Sensor-RequestCapabilities-r13',
        'Sensor-Error-r13',
        'Sensor-LocationServerErrorCauses-r13',
        'Sensor-TargetDeviceErrorCauses-r13',
        'WLAN-ProvideLocationInformation-r13',
        'WLAN-MeasurementInformation-r13',
        'WLAN-MeasurementList-r13',
        'WLAN-MeasurementElement-r13',
        'WLAN-AP-Identifier-r13',
        'WLAN-RTT-r13',
        'WLAN-RequestLocationInformation-r13',
        'WLAN-ProvideCapabilities-r13',
        'WLAN-RequestCapabilities-r13',
        'WLAN-Error-r13',
        'WLAN-LocationServerErrorCauses-r13',
        'WLAN-TargetDeviceErrorCauses-r13',
        'BT-ProvideLocationInformation-r13',
        'BT-MeasurementInformation-r13',
        'BT-MeasurementList-r13',
        'BT-MeasurementElement-r13',
        'BT-RequestLocationInformation-r13',
        'BT-ProvideCapabilities-r13',
        'BT-RequestCapabilities-r13',
        'BT-Error-r13',
        'BT-LocationServerErrorCauses-r13',
        'BT-TargetDeviceErrorCauses-r13',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxEARFCN',
        'maxEARFCN-Plus1',
        'maxEARFCN2',
        'maxEPDU',
        'maxFreqLayers',
        'maxBands',
        'maxFBI',
        'maxFBI-Plus1',
        'maxFBI2',
        'maxWLAN-AP-r13',
        'maxBT-Beacon-r13',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LPP-Message >-----#
    LPP_Message = SEQ(name='LPP-Message', mode=MODE_TYPE)
    _LPP_Message_transactionID = SEQ(name='transactionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LPP-TransactionID')), opt=True)
    _LPP_Message_endTransaction = BOOL(name='endTransaction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LPP_Message_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SequenceNumber')), opt=True)
    _LPP_Message_acknowledgement = SEQ(name='acknowledgement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Acknowledgement')), opt=True)
    _LPP_Message_lpp_MessageBody = CHOICE(name='lpp-MessageBody', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LPP-MessageBody')), opt=True)
    LPP_Message._cont = ASN1Dict([
        ('transactionID', _LPP_Message_transactionID),
        ('endTransaction', _LPP_Message_endTransaction),
        ('sequenceNumber', _LPP_Message_sequenceNumber),
        ('acknowledgement', _LPP_Message_acknowledgement),
        ('lpp-MessageBody', _LPP_Message_lpp_MessageBody),
        ])
    LPP_Message._ext = None
    
    #-----< SequenceNumber >-----#
    SequenceNumber = INT(name='SequenceNumber', mode=MODE_TYPE)
    SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Acknowledgement >-----#
    Acknowledgement = SEQ(name='Acknowledgement', mode=MODE_TYPE)
    _Acknowledgement_ackRequested = BOOL(name='ackRequested', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Acknowledgement_ackIndicator = INT(name='ackIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SequenceNumber')), opt=True)
    Acknowledgement._cont = ASN1Dict([
        ('ackRequested', _Acknowledgement_ackRequested),
        ('ackIndicator', _Acknowledgement_ackIndicator),
        ])
    Acknowledgement._ext = None
    
    #-----< LPP-MessageBody >-----#
    LPP_MessageBody = CHOICE(name='LPP-MessageBody', mode=MODE_TYPE)
    _LPP_MessageBody_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __LPP_MessageBody_c1_requestCapabilities = SEQ(name='requestCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'RequestCapabilities')))
    __LPP_MessageBody_c1_provideCapabilities = SEQ(name='provideCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ProvideCapabilities')))
    __LPP_MessageBody_c1_requestAssistanceData = SEQ(name='requestAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'RequestAssistanceData')))
    __LPP_MessageBody_c1_provideAssistanceData = SEQ(name='provideAssistanceData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ProvideAssistanceData')))
    __LPP_MessageBody_c1_requestLocationInformation = SEQ(name='requestLocationInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'RequestLocationInformation')))
    __LPP_MessageBody_c1_provideLocationInformation = SEQ(name='provideLocationInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ProvideLocationInformation')))
    __LPP_MessageBody_c1_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Abort')))
    __LPP_MessageBody_c1_error = CHOICE(name='error', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Error')))
    __LPP_MessageBody_c1_spare7 = NULL(name='spare7', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare6 = NULL(name='spare6', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare5 = NULL(name='spare5', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare4 = NULL(name='spare4', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LPP_MessageBody_c1_spare0 = NULL(name='spare0', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LPP_MessageBody_c1._cont = ASN1Dict([
        ('requestCapabilities', __LPP_MessageBody_c1_requestCapabilities),
        ('provideCapabilities', __LPP_MessageBody_c1_provideCapabilities),
        ('requestAssistanceData', __LPP_MessageBody_c1_requestAssistanceData),
        ('provideAssistanceData', __LPP_MessageBody_c1_provideAssistanceData),
        ('requestLocationInformation', __LPP_MessageBody_c1_requestLocationInformation),
        ('provideLocationInformation', __LPP_MessageBody_c1_provideLocationInformation),
        ('abort', __LPP_MessageBody_c1_abort),
        ('error', __LPP_MessageBody_c1_error),
        ('spare7', __LPP_MessageBody_c1_spare7),
        ('spare6', __LPP_MessageBody_c1_spare6),
        ('spare5', __LPP_MessageBody_c1_spare5),
        ('spare4', __LPP_MessageBody_c1_spare4),
        ('spare3', __LPP_MessageBody_c1_spare3),
        ('spare2', __LPP_MessageBody_c1_spare2),
        ('spare1', __LPP_MessageBody_c1_spare1),
        ('spare0', __LPP_MessageBody_c1_spare0),
        ])
    _LPP_MessageBody_c1._ext = None
    _LPP_MessageBody_messageClassExtension = SEQ(name='messageClassExtension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LPP_MessageBody_messageClassExtension._cont = ASN1Dict([
        ])
    _LPP_MessageBody_messageClassExtension._ext = None
    LPP_MessageBody._cont = ASN1Dict([
        ('c1', _LPP_MessageBody_c1),
        ('messageClassExtension', _LPP_MessageBody_messageClassExtension),
        ])
    LPP_MessageBody._ext = None
    
    #-----< LPP-TransactionID >-----#
    LPP_TransactionID = SEQ(name='LPP-TransactionID', mode=MODE_TYPE)
    _LPP_TransactionID_initiator = ENUM(name='initiator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Initiator')))
    _LPP_TransactionID_transactionNumber = INT(name='transactionNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TransactionNumber')))
    LPP_TransactionID._cont = ASN1Dict([
        ('initiator', _LPP_TransactionID_initiator),
        ('transactionNumber', _LPP_TransactionID_transactionNumber),
        ])
    LPP_TransactionID._ext = []
    
    #-----< Initiator >-----#
    Initiator = ENUM(name='Initiator', mode=MODE_TYPE)
    Initiator._cont = ASN1Dict([('locationServer', 0), ('targetDevice', 1)])
    Initiator._ext = []
    
    #-----< TransactionNumber >-----#
    TransactionNumber = INT(name='TransactionNumber', mode=MODE_TYPE)
    TransactionNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RequestCapabilities >-----#
    RequestCapabilities = SEQ(name='RequestCapabilities', mode=MODE_TYPE)
    _RequestCapabilities_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestCapabilities_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___RequestCapabilities_criticalExtensions_c1_requestCapabilities_r9 = SEQ(name='requestCapabilities-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'RequestCapabilities-r9-IEs')))
    ___RequestCapabilities_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RequestCapabilities_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RequestCapabilities_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestCapabilities_criticalExtensions_c1._cont = ASN1Dict([
        ('requestCapabilities-r9', ___RequestCapabilities_criticalExtensions_c1_requestCapabilities_r9),
        ('spare3', ___RequestCapabilities_criticalExtensions_c1_spare3),
        ('spare2', ___RequestCapabilities_criticalExtensions_c1_spare2),
        ('spare1', ___RequestCapabilities_criticalExtensions_c1_spare1),
        ])
    __RequestCapabilities_criticalExtensions_c1._ext = None
    __RequestCapabilities_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestCapabilities_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __RequestCapabilities_criticalExtensions_criticalExtensionsFuture._ext = None
    _RequestCapabilities_criticalExtensions._cont = ASN1Dict([
        ('c1', __RequestCapabilities_criticalExtensions_c1),
        ('criticalExtensionsFuture', __RequestCapabilities_criticalExtensions_criticalExtensionsFuture),
        ])
    _RequestCapabilities_criticalExtensions._ext = None
    RequestCapabilities._cont = ASN1Dict([
        ('criticalExtensions', _RequestCapabilities_criticalExtensions),
        ])
    RequestCapabilities._ext = None
    
    #-----< RequestCapabilities-r9-IEs >-----#
    RequestCapabilities_r9_IEs = SEQ(name='RequestCapabilities-r9-IEs', mode=MODE_TYPE)
    _RequestCapabilities_r9_IEs_commonIEsRequestCapabilities = SEQ(name='commonIEsRequestCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsRequestCapabilities')), opt=True)
    _RequestCapabilities_r9_IEs_a_gnss_RequestCapabilities = SEQ(name='a-gnss-RequestCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-RequestCapabilities')), opt=True)
    _RequestCapabilities_r9_IEs_otdoa_RequestCapabilities = SEQ(name='otdoa-RequestCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-RequestCapabilities')), opt=True)
    _RequestCapabilities_r9_IEs_ecid_RequestCapabilities = SEQ(name='ecid-RequestCapabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-RequestCapabilities')), opt=True)
    _RequestCapabilities_r9_IEs_epdu_RequestCapabilities = SEQ_OF(name='epdu-RequestCapabilities', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    _RequestCapabilities_r9_IEs_sensor_RequestCapabilities_r13 = SEQ(name='sensor-RequestCapabilities-r13', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-RequestCapabilities-r13')), opt=True, group=0)
    _RequestCapabilities_r9_IEs_tbs_RequestCapabilities_r13 = SEQ(name='tbs-RequestCapabilities-r13', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-RequestCapabilities-r13')), opt=True, group=0)
    _RequestCapabilities_r9_IEs_wlan_RequestCapabilities_r13 = SEQ(name='wlan-RequestCapabilities-r13', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-RequestCapabilities-r13')), opt=True, group=0)
    _RequestCapabilities_r9_IEs_bt_RequestCapabilities_r13 = SEQ(name='bt-RequestCapabilities-r13', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-RequestCapabilities-r13')), opt=True, group=0)
    RequestCapabilities_r9_IEs._cont = ASN1Dict([
        ('commonIEsRequestCapabilities', _RequestCapabilities_r9_IEs_commonIEsRequestCapabilities),
        ('a-gnss-RequestCapabilities', _RequestCapabilities_r9_IEs_a_gnss_RequestCapabilities),
        ('otdoa-RequestCapabilities', _RequestCapabilities_r9_IEs_otdoa_RequestCapabilities),
        ('ecid-RequestCapabilities', _RequestCapabilities_r9_IEs_ecid_RequestCapabilities),
        ('epdu-RequestCapabilities', _RequestCapabilities_r9_IEs_epdu_RequestCapabilities),
        ('sensor-RequestCapabilities-r13', _RequestCapabilities_r9_IEs_sensor_RequestCapabilities_r13),
        ('tbs-RequestCapabilities-r13', _RequestCapabilities_r9_IEs_tbs_RequestCapabilities_r13),
        ('wlan-RequestCapabilities-r13', _RequestCapabilities_r9_IEs_wlan_RequestCapabilities_r13),
        ('bt-RequestCapabilities-r13', _RequestCapabilities_r9_IEs_bt_RequestCapabilities_r13),
        ])
    RequestCapabilities_r9_IEs._ext = ['sensor-RequestCapabilities-r13', 'tbs-RequestCapabilities-r13', 'wlan-RequestCapabilities-r13', 'bt-RequestCapabilities-r13']
    
    #-----< ProvideCapabilities >-----#
    ProvideCapabilities = SEQ(name='ProvideCapabilities', mode=MODE_TYPE)
    _ProvideCapabilities_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ProvideCapabilities_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ProvideCapabilities_criticalExtensions_c1_provideCapabilities_r9 = SEQ(name='provideCapabilities-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ProvideCapabilities-r9-IEs')))
    ___ProvideCapabilities_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ProvideCapabilities_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ProvideCapabilities_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ProvideCapabilities_criticalExtensions_c1._cont = ASN1Dict([
        ('provideCapabilities-r9', ___ProvideCapabilities_criticalExtensions_c1_provideCapabilities_r9),
        ('spare3', ___ProvideCapabilities_criticalExtensions_c1_spare3),
        ('spare2', ___ProvideCapabilities_criticalExtensions_c1_spare2),
        ('spare1', ___ProvideCapabilities_criticalExtensions_c1_spare1),
        ])
    __ProvideCapabilities_criticalExtensions_c1._ext = None
    __ProvideCapabilities_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ProvideCapabilities_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __ProvideCapabilities_criticalExtensions_criticalExtensionsFuture._ext = None
    _ProvideCapabilities_criticalExtensions._cont = ASN1Dict([
        ('c1', __ProvideCapabilities_criticalExtensions_c1),
        ('criticalExtensionsFuture', __ProvideCapabilities_criticalExtensions_criticalExtensionsFuture),
        ])
    _ProvideCapabilities_criticalExtensions._ext = None
    ProvideCapabilities._cont = ASN1Dict([
        ('criticalExtensions', _ProvideCapabilities_criticalExtensions),
        ])
    ProvideCapabilities._ext = None
    
    #-----< ProvideCapabilities-r9-IEs >-----#
    ProvideCapabilities_r9_IEs = SEQ(name='ProvideCapabilities-r9-IEs', mode=MODE_TYPE)
    _ProvideCapabilities_r9_IEs_commonIEsProvideCapabilities = SEQ(name='commonIEsProvideCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsProvideCapabilities')), opt=True)
    _ProvideCapabilities_r9_IEs_a_gnss_ProvideCapabilities = SEQ(name='a-gnss-ProvideCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-ProvideCapabilities')), opt=True)
    _ProvideCapabilities_r9_IEs_otdoa_ProvideCapabilities = SEQ(name='otdoa-ProvideCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-ProvideCapabilities')), opt=True)
    _ProvideCapabilities_r9_IEs_ecid_ProvideCapabilities = SEQ(name='ecid-ProvideCapabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-ProvideCapabilities')), opt=True)
    _ProvideCapabilities_r9_IEs_epdu_ProvideCapabilities = SEQ_OF(name='epdu-ProvideCapabilities', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    _ProvideCapabilities_r9_IEs_sensor_ProvideCapabilities_r13 = SEQ(name='sensor-ProvideCapabilities-r13', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-ProvideCapabilities-r13')), opt=True, group=0)
    _ProvideCapabilities_r9_IEs_tbs_ProvideCapabilities_r13 = SEQ(name='tbs-ProvideCapabilities-r13', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-ProvideCapabilities-r13')), opt=True, group=0)
    _ProvideCapabilities_r9_IEs_wlan_ProvideCapabilities_r13 = SEQ(name='wlan-ProvideCapabilities-r13', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-ProvideCapabilities-r13')), opt=True, group=0)
    _ProvideCapabilities_r9_IEs_bt_ProvideCapabilities_r13 = SEQ(name='bt-ProvideCapabilities-r13', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-ProvideCapabilities-r13')), opt=True, group=0)
    ProvideCapabilities_r9_IEs._cont = ASN1Dict([
        ('commonIEsProvideCapabilities', _ProvideCapabilities_r9_IEs_commonIEsProvideCapabilities),
        ('a-gnss-ProvideCapabilities', _ProvideCapabilities_r9_IEs_a_gnss_ProvideCapabilities),
        ('otdoa-ProvideCapabilities', _ProvideCapabilities_r9_IEs_otdoa_ProvideCapabilities),
        ('ecid-ProvideCapabilities', _ProvideCapabilities_r9_IEs_ecid_ProvideCapabilities),
        ('epdu-ProvideCapabilities', _ProvideCapabilities_r9_IEs_epdu_ProvideCapabilities),
        ('sensor-ProvideCapabilities-r13', _ProvideCapabilities_r9_IEs_sensor_ProvideCapabilities_r13),
        ('tbs-ProvideCapabilities-r13', _ProvideCapabilities_r9_IEs_tbs_ProvideCapabilities_r13),
        ('wlan-ProvideCapabilities-r13', _ProvideCapabilities_r9_IEs_wlan_ProvideCapabilities_r13),
        ('bt-ProvideCapabilities-r13', _ProvideCapabilities_r9_IEs_bt_ProvideCapabilities_r13),
        ])
    ProvideCapabilities_r9_IEs._ext = ['sensor-ProvideCapabilities-r13', 'tbs-ProvideCapabilities-r13', 'wlan-ProvideCapabilities-r13', 'bt-ProvideCapabilities-r13']
    
    #-----< RequestAssistanceData >-----#
    RequestAssistanceData = SEQ(name='RequestAssistanceData', mode=MODE_TYPE)
    _RequestAssistanceData_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestAssistanceData_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___RequestAssistanceData_criticalExtensions_c1_requestAssistanceData_r9 = SEQ(name='requestAssistanceData-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'RequestAssistanceData-r9-IEs')))
    ___RequestAssistanceData_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RequestAssistanceData_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RequestAssistanceData_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestAssistanceData_criticalExtensions_c1._cont = ASN1Dict([
        ('requestAssistanceData-r9', ___RequestAssistanceData_criticalExtensions_c1_requestAssistanceData_r9),
        ('spare3', ___RequestAssistanceData_criticalExtensions_c1_spare3),
        ('spare2', ___RequestAssistanceData_criticalExtensions_c1_spare2),
        ('spare1', ___RequestAssistanceData_criticalExtensions_c1_spare1),
        ])
    __RequestAssistanceData_criticalExtensions_c1._ext = None
    __RequestAssistanceData_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestAssistanceData_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __RequestAssistanceData_criticalExtensions_criticalExtensionsFuture._ext = None
    _RequestAssistanceData_criticalExtensions._cont = ASN1Dict([
        ('c1', __RequestAssistanceData_criticalExtensions_c1),
        ('criticalExtensionsFuture', __RequestAssistanceData_criticalExtensions_criticalExtensionsFuture),
        ])
    _RequestAssistanceData_criticalExtensions._ext = None
    RequestAssistanceData._cont = ASN1Dict([
        ('criticalExtensions', _RequestAssistanceData_criticalExtensions),
        ])
    RequestAssistanceData._ext = None
    
    #-----< RequestAssistanceData-r9-IEs >-----#
    RequestAssistanceData_r9_IEs = SEQ(name='RequestAssistanceData-r9-IEs', mode=MODE_TYPE)
    _RequestAssistanceData_r9_IEs_commonIEsRequestAssistanceData = SEQ(name='commonIEsRequestAssistanceData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsRequestAssistanceData')), opt=True)
    _RequestAssistanceData_r9_IEs_a_gnss_RequestAssistanceData = SEQ(name='a-gnss-RequestAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-RequestAssistanceData')), opt=True)
    _RequestAssistanceData_r9_IEs_otdoa_RequestAssistanceData = SEQ(name='otdoa-RequestAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-RequestAssistanceData')), opt=True)
    _RequestAssistanceData_r9_IEs_epdu_RequestAssistanceData = SEQ_OF(name='epdu-RequestAssistanceData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    RequestAssistanceData_r9_IEs._cont = ASN1Dict([
        ('commonIEsRequestAssistanceData', _RequestAssistanceData_r9_IEs_commonIEsRequestAssistanceData),
        ('a-gnss-RequestAssistanceData', _RequestAssistanceData_r9_IEs_a_gnss_RequestAssistanceData),
        ('otdoa-RequestAssistanceData', _RequestAssistanceData_r9_IEs_otdoa_RequestAssistanceData),
        ('epdu-RequestAssistanceData', _RequestAssistanceData_r9_IEs_epdu_RequestAssistanceData),
        ])
    RequestAssistanceData_r9_IEs._ext = []
    
    #-----< ProvideAssistanceData >-----#
    ProvideAssistanceData = SEQ(name='ProvideAssistanceData', mode=MODE_TYPE)
    _ProvideAssistanceData_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ProvideAssistanceData_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ProvideAssistanceData_criticalExtensions_c1_provideAssistanceData_r9 = SEQ(name='provideAssistanceData-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ProvideAssistanceData-r9-IEs')))
    ___ProvideAssistanceData_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ProvideAssistanceData_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ProvideAssistanceData_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ProvideAssistanceData_criticalExtensions_c1._cont = ASN1Dict([
        ('provideAssistanceData-r9', ___ProvideAssistanceData_criticalExtensions_c1_provideAssistanceData_r9),
        ('spare3', ___ProvideAssistanceData_criticalExtensions_c1_spare3),
        ('spare2', ___ProvideAssistanceData_criticalExtensions_c1_spare2),
        ('spare1', ___ProvideAssistanceData_criticalExtensions_c1_spare1),
        ])
    __ProvideAssistanceData_criticalExtensions_c1._ext = None
    __ProvideAssistanceData_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ProvideAssistanceData_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __ProvideAssistanceData_criticalExtensions_criticalExtensionsFuture._ext = None
    _ProvideAssistanceData_criticalExtensions._cont = ASN1Dict([
        ('c1', __ProvideAssistanceData_criticalExtensions_c1),
        ('criticalExtensionsFuture', __ProvideAssistanceData_criticalExtensions_criticalExtensionsFuture),
        ])
    _ProvideAssistanceData_criticalExtensions._ext = None
    ProvideAssistanceData._cont = ASN1Dict([
        ('criticalExtensions', _ProvideAssistanceData_criticalExtensions),
        ])
    ProvideAssistanceData._ext = None
    
    #-----< ProvideAssistanceData-r9-IEs >-----#
    ProvideAssistanceData_r9_IEs = SEQ(name='ProvideAssistanceData-r9-IEs', mode=MODE_TYPE)
    _ProvideAssistanceData_r9_IEs_commonIEsProvideAssistanceData = SEQ(name='commonIEsProvideAssistanceData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsProvideAssistanceData')), opt=True)
    _ProvideAssistanceData_r9_IEs_a_gnss_ProvideAssistanceData = SEQ(name='a-gnss-ProvideAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-ProvideAssistanceData')), opt=True)
    _ProvideAssistanceData_r9_IEs_otdoa_ProvideAssistanceData = SEQ(name='otdoa-ProvideAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-ProvideAssistanceData')), opt=True)
    _ProvideAssistanceData_r9_IEs_epdu_Provide_Assistance_Data = SEQ_OF(name='epdu-Provide-Assistance-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    ProvideAssistanceData_r9_IEs._cont = ASN1Dict([
        ('commonIEsProvideAssistanceData', _ProvideAssistanceData_r9_IEs_commonIEsProvideAssistanceData),
        ('a-gnss-ProvideAssistanceData', _ProvideAssistanceData_r9_IEs_a_gnss_ProvideAssistanceData),
        ('otdoa-ProvideAssistanceData', _ProvideAssistanceData_r9_IEs_otdoa_ProvideAssistanceData),
        ('epdu-Provide-Assistance-Data', _ProvideAssistanceData_r9_IEs_epdu_Provide_Assistance_Data),
        ])
    ProvideAssistanceData_r9_IEs._ext = []
    
    #-----< RequestLocationInformation >-----#
    RequestLocationInformation = SEQ(name='RequestLocationInformation', mode=MODE_TYPE)
    _RequestLocationInformation_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __RequestLocationInformation_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___RequestLocationInformation_criticalExtensions_c1_requestLocationInformation_r9 = SEQ(name='requestLocationInformation-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'RequestLocationInformation-r9-IEs')))
    ___RequestLocationInformation_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RequestLocationInformation_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___RequestLocationInformation_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestLocationInformation_criticalExtensions_c1._cont = ASN1Dict([
        ('requestLocationInformation-r9', ___RequestLocationInformation_criticalExtensions_c1_requestLocationInformation_r9),
        ('spare3', ___RequestLocationInformation_criticalExtensions_c1_spare3),
        ('spare2', ___RequestLocationInformation_criticalExtensions_c1_spare2),
        ('spare1', ___RequestLocationInformation_criticalExtensions_c1_spare1),
        ])
    __RequestLocationInformation_criticalExtensions_c1._ext = None
    __RequestLocationInformation_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestLocationInformation_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __RequestLocationInformation_criticalExtensions_criticalExtensionsFuture._ext = None
    _RequestLocationInformation_criticalExtensions._cont = ASN1Dict([
        ('c1', __RequestLocationInformation_criticalExtensions_c1),
        ('criticalExtensionsFuture', __RequestLocationInformation_criticalExtensions_criticalExtensionsFuture),
        ])
    _RequestLocationInformation_criticalExtensions._ext = None
    RequestLocationInformation._cont = ASN1Dict([
        ('criticalExtensions', _RequestLocationInformation_criticalExtensions),
        ])
    RequestLocationInformation._ext = None
    
    #-----< RequestLocationInformation-r9-IEs >-----#
    RequestLocationInformation_r9_IEs = SEQ(name='RequestLocationInformation-r9-IEs', mode=MODE_TYPE)
    _RequestLocationInformation_r9_IEs_commonIEsRequestLocationInformation = SEQ(name='commonIEsRequestLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsRequestLocationInformation')), opt=True)
    _RequestLocationInformation_r9_IEs_a_gnss_RequestLocationInformation = SEQ(name='a-gnss-RequestLocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-RequestLocationInformation')), opt=True)
    _RequestLocationInformation_r9_IEs_otdoa_RequestLocationInformation = SEQ(name='otdoa-RequestLocationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-RequestLocationInformation')), opt=True)
    _RequestLocationInformation_r9_IEs_ecid_RequestLocationInformation = SEQ(name='ecid-RequestLocationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-RequestLocationInformation')), opt=True)
    _RequestLocationInformation_r9_IEs_epdu_RequestLocationInformation = SEQ_OF(name='epdu-RequestLocationInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    _RequestLocationInformation_r9_IEs_sensor_RequestLocationInformation_r13 = SEQ(name='sensor-RequestLocationInformation-r13', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-RequestLocationInformation-r13')), opt=True, group=0)
    _RequestLocationInformation_r9_IEs_tbs_RequestLocationInformation_r13 = SEQ(name='tbs-RequestLocationInformation-r13', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-RequestLocationInformation-r13')), opt=True, group=0)
    _RequestLocationInformation_r9_IEs_wlan_RequestLocationInformation_r13 = SEQ(name='wlan-RequestLocationInformation-r13', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-RequestLocationInformation-r13')), opt=True, group=0)
    _RequestLocationInformation_r9_IEs_bt_RequestLocationInformation_r13 = SEQ(name='bt-RequestLocationInformation-r13', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-RequestLocationInformation-r13')), opt=True, group=0)
    RequestLocationInformation_r9_IEs._cont = ASN1Dict([
        ('commonIEsRequestLocationInformation', _RequestLocationInformation_r9_IEs_commonIEsRequestLocationInformation),
        ('a-gnss-RequestLocationInformation', _RequestLocationInformation_r9_IEs_a_gnss_RequestLocationInformation),
        ('otdoa-RequestLocationInformation', _RequestLocationInformation_r9_IEs_otdoa_RequestLocationInformation),
        ('ecid-RequestLocationInformation', _RequestLocationInformation_r9_IEs_ecid_RequestLocationInformation),
        ('epdu-RequestLocationInformation', _RequestLocationInformation_r9_IEs_epdu_RequestLocationInformation),
        ('sensor-RequestLocationInformation-r13', _RequestLocationInformation_r9_IEs_sensor_RequestLocationInformation_r13),
        ('tbs-RequestLocationInformation-r13', _RequestLocationInformation_r9_IEs_tbs_RequestLocationInformation_r13),
        ('wlan-RequestLocationInformation-r13', _RequestLocationInformation_r9_IEs_wlan_RequestLocationInformation_r13),
        ('bt-RequestLocationInformation-r13', _RequestLocationInformation_r9_IEs_bt_RequestLocationInformation_r13),
        ])
    RequestLocationInformation_r9_IEs._ext = ['sensor-RequestLocationInformation-r13', 'tbs-RequestLocationInformation-r13', 'wlan-RequestLocationInformation-r13', 'bt-RequestLocationInformation-r13']
    
    #-----< ProvideLocationInformation >-----#
    ProvideLocationInformation = SEQ(name='ProvideLocationInformation', mode=MODE_TYPE)
    _ProvideLocationInformation_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ProvideLocationInformation_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ProvideLocationInformation_criticalExtensions_c1_provideLocationInformation_r9 = SEQ(name='provideLocationInformation-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ProvideLocationInformation-r9-IEs')))
    ___ProvideLocationInformation_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ProvideLocationInformation_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ProvideLocationInformation_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ProvideLocationInformation_criticalExtensions_c1._cont = ASN1Dict([
        ('provideLocationInformation-r9', ___ProvideLocationInformation_criticalExtensions_c1_provideLocationInformation_r9),
        ('spare3', ___ProvideLocationInformation_criticalExtensions_c1_spare3),
        ('spare2', ___ProvideLocationInformation_criticalExtensions_c1_spare2),
        ('spare1', ___ProvideLocationInformation_criticalExtensions_c1_spare1),
        ])
    __ProvideLocationInformation_criticalExtensions_c1._ext = None
    __ProvideLocationInformation_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ProvideLocationInformation_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __ProvideLocationInformation_criticalExtensions_criticalExtensionsFuture._ext = None
    _ProvideLocationInformation_criticalExtensions._cont = ASN1Dict([
        ('c1', __ProvideLocationInformation_criticalExtensions_c1),
        ('criticalExtensionsFuture', __ProvideLocationInformation_criticalExtensions_criticalExtensionsFuture),
        ])
    _ProvideLocationInformation_criticalExtensions._ext = None
    ProvideLocationInformation._cont = ASN1Dict([
        ('criticalExtensions', _ProvideLocationInformation_criticalExtensions),
        ])
    ProvideLocationInformation._ext = None
    
    #-----< ProvideLocationInformation-r9-IEs >-----#
    ProvideLocationInformation_r9_IEs = SEQ(name='ProvideLocationInformation-r9-IEs', mode=MODE_TYPE)
    _ProvideLocationInformation_r9_IEs_commonIEsProvideLocationInformation = SEQ(name='commonIEsProvideLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsProvideLocationInformation')), opt=True)
    _ProvideLocationInformation_r9_IEs_a_gnss_ProvideLocationInformation = SEQ(name='a-gnss-ProvideLocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-ProvideLocationInformation')), opt=True)
    _ProvideLocationInformation_r9_IEs_otdoa_ProvideLocationInformation = SEQ(name='otdoa-ProvideLocationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-ProvideLocationInformation')), opt=True)
    _ProvideLocationInformation_r9_IEs_ecid_ProvideLocationInformation = SEQ(name='ecid-ProvideLocationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-ProvideLocationInformation')), opt=True)
    _ProvideLocationInformation_r9_IEs_epdu_ProvideLocationInformation = SEQ_OF(name='epdu-ProvideLocationInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    _ProvideLocationInformation_r9_IEs_sensor_ProvideLocationInformation_r13 = SEQ(name='sensor-ProvideLocationInformation-r13', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-ProvideLocationInformation-r13')), opt=True, group=0)
    _ProvideLocationInformation_r9_IEs_tbs_ProvideLocationInformation_r13 = SEQ(name='tbs-ProvideLocationInformation-r13', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-ProvideLocationInformation-r13')), opt=True, group=0)
    _ProvideLocationInformation_r9_IEs_wlan_ProvideLocationInformation_r13 = SEQ(name='wlan-ProvideLocationInformation-r13', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-ProvideLocationInformation-r13')), opt=True, group=0)
    _ProvideLocationInformation_r9_IEs_bt_ProvideLocationInformation_r13 = SEQ(name='bt-ProvideLocationInformation-r13', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-ProvideLocationInformation-r13')), opt=True, group=0)
    ProvideLocationInformation_r9_IEs._cont = ASN1Dict([
        ('commonIEsProvideLocationInformation', _ProvideLocationInformation_r9_IEs_commonIEsProvideLocationInformation),
        ('a-gnss-ProvideLocationInformation', _ProvideLocationInformation_r9_IEs_a_gnss_ProvideLocationInformation),
        ('otdoa-ProvideLocationInformation', _ProvideLocationInformation_r9_IEs_otdoa_ProvideLocationInformation),
        ('ecid-ProvideLocationInformation', _ProvideLocationInformation_r9_IEs_ecid_ProvideLocationInformation),
        ('epdu-ProvideLocationInformation', _ProvideLocationInformation_r9_IEs_epdu_ProvideLocationInformation),
        ('sensor-ProvideLocationInformation-r13', _ProvideLocationInformation_r9_IEs_sensor_ProvideLocationInformation_r13),
        ('tbs-ProvideLocationInformation-r13', _ProvideLocationInformation_r9_IEs_tbs_ProvideLocationInformation_r13),
        ('wlan-ProvideLocationInformation-r13', _ProvideLocationInformation_r9_IEs_wlan_ProvideLocationInformation_r13),
        ('bt-ProvideLocationInformation-r13', _ProvideLocationInformation_r9_IEs_bt_ProvideLocationInformation_r13),
        ])
    ProvideLocationInformation_r9_IEs._ext = ['sensor-ProvideLocationInformation-r13', 'tbs-ProvideLocationInformation-r13', 'wlan-ProvideLocationInformation-r13', 'bt-ProvideLocationInformation-r13']
    
    #-----< Abort >-----#
    Abort = SEQ(name='Abort', mode=MODE_TYPE)
    _Abort_criticalExtensions = CHOICE(name='criticalExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Abort_criticalExtensions_c1 = CHOICE(name='c1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___Abort_criticalExtensions_c1_abort_r9 = SEQ(name='abort-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Abort-r9-IEs')))
    ___Abort_criticalExtensions_c1_spare3 = NULL(name='spare3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Abort_criticalExtensions_c1_spare2 = NULL(name='spare2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___Abort_criticalExtensions_c1_spare1 = NULL(name='spare1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Abort_criticalExtensions_c1._cont = ASN1Dict([
        ('abort-r9', ___Abort_criticalExtensions_c1_abort_r9),
        ('spare3', ___Abort_criticalExtensions_c1_spare3),
        ('spare2', ___Abort_criticalExtensions_c1_spare2),
        ('spare1', ___Abort_criticalExtensions_c1_spare1),
        ])
    __Abort_criticalExtensions_c1._ext = None
    __Abort_criticalExtensions_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Abort_criticalExtensions_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    __Abort_criticalExtensions_criticalExtensionsFuture._ext = None
    _Abort_criticalExtensions._cont = ASN1Dict([
        ('c1', __Abort_criticalExtensions_c1),
        ('criticalExtensionsFuture', __Abort_criticalExtensions_criticalExtensionsFuture),
        ])
    _Abort_criticalExtensions._ext = None
    Abort._cont = ASN1Dict([
        ('criticalExtensions', _Abort_criticalExtensions),
        ])
    Abort._ext = None
    
    #-----< Abort-r9-IEs >-----#
    Abort_r9_IEs = SEQ(name='Abort-r9-IEs', mode=MODE_TYPE)
    _Abort_r9_IEs_commonIEsAbort = SEQ(name='commonIEsAbort', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsAbort')), opt=True)
    _Abort_r9_IEs_epdu_Abort = SEQ_OF(name='epdu-Abort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    Abort_r9_IEs._cont = ASN1Dict([
        ('commonIEsAbort', _Abort_r9_IEs_commonIEsAbort),
        ('epdu-Abort', _Abort_r9_IEs_epdu_Abort),
        ])
    Abort_r9_IEs._ext = ['epdu-Abort']
    
    #-----< Error >-----#
    Error = CHOICE(name='Error', mode=MODE_TYPE)
    _Error_error_r9 = SEQ(name='error-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Error-r9-IEs')))
    _Error_criticalExtensionsFuture = SEQ(name='criticalExtensionsFuture', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Error_criticalExtensionsFuture._cont = ASN1Dict([
        ])
    _Error_criticalExtensionsFuture._ext = None
    Error._cont = ASN1Dict([
        ('error-r9', _Error_error_r9),
        ('criticalExtensionsFuture', _Error_criticalExtensionsFuture),
        ])
    Error._ext = None
    
    #-----< Error-r9-IEs >-----#
    Error_r9_IEs = SEQ(name='Error-r9-IEs', mode=MODE_TYPE)
    _Error_r9_IEs_commonIEsError = SEQ(name='commonIEsError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CommonIEsError')), opt=True)
    _Error_r9_IEs_epdu_Error = SEQ_OF(name='epdu-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Sequence')), opt=True)
    Error_r9_IEs._cont = ASN1Dict([
        ('commonIEsError', _Error_r9_IEs_commonIEsError),
        ('epdu-Error', _Error_r9_IEs_epdu_Error),
        ])
    Error_r9_IEs._ext = ['epdu-Error']
    
    #-----< AccessTypes >-----#
    AccessTypes = SEQ(name='AccessTypes', mode=MODE_TYPE)
    _AccessTypes_accessTypes = BIT_STR(name='accessTypes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessTypes_accessTypes._cont = ASN1Dict([('eutra', 0), ('utra', 1), ('gsm', 2)])
    _AccessTypes_accessTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    AccessTypes._cont = ASN1Dict([
        ('accessTypes', _AccessTypes_accessTypes),
        ])
    AccessTypes._ext = []
    
    #-----< ARFCN-ValueEUTRA >-----#
    ARFCN_ValueEUTRA = INT(name='ARFCN-ValueEUTRA', mode=MODE_TYPE)
    ARFCN_ValueEUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ARFCN-ValueEUTRA-v9a0 >-----#
    ARFCN_ValueEUTRA_v9a0 = INT(name='ARFCN-ValueEUTRA-v9a0', mode=MODE_TYPE)
    ARFCN_ValueEUTRA_v9a0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=None, er=[])
    
    #-----< maxEARFCN >-----#
    maxEARFCN = INT(name='maxEARFCN', mode=MODE_VALUE)
    maxEARFCN._val = 65535
    
    #-----< maxEARFCN-Plus1 >-----#
    maxEARFCN_Plus1 = INT(name='maxEARFCN-Plus1', mode=MODE_VALUE)
    maxEARFCN_Plus1._val = 65536
    
    #-----< maxEARFCN2 >-----#
    maxEARFCN2 = INT(name='maxEARFCN2', mode=MODE_VALUE)
    maxEARFCN2._val = 262143
    
    #-----< ARFCN-ValueUTRA >-----#
    ARFCN_ValueUTRA = INT(name='ARFCN-ValueUTRA', mode=MODE_TYPE)
    ARFCN_ValueUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< CellGlobalIdEUTRA-AndUTRA >-----#
    CellGlobalIdEUTRA_AndUTRA = SEQ(name='CellGlobalIdEUTRA-AndUTRA', mode=MODE_TYPE)
    _CellGlobalIdEUTRA_AndUTRA_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc._cont = ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc__item_
    __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc._cont = ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc__item_
    __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _CellGlobalIdEUTRA_AndUTRA_plmn_Identity._cont = ASN1Dict([
        ('mcc', __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc),
        ('mnc', __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc),
        ])
    _CellGlobalIdEUTRA_AndUTRA_plmn_Identity._ext = None
    _CellGlobalIdEUTRA_AndUTRA_cellIdentity = CHOICE(name='cellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CellGlobalIdEUTRA_AndUTRA_cellIdentity_eutra = BIT_STR(name='eutra', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CellGlobalIdEUTRA_AndUTRA_cellIdentity_eutra._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    __CellGlobalIdEUTRA_AndUTRA_cellIdentity_utra = BIT_STR(name='utra', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CellGlobalIdEUTRA_AndUTRA_cellIdentity_utra._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _CellGlobalIdEUTRA_AndUTRA_cellIdentity._cont = ASN1Dict([
        ('eutra', __CellGlobalIdEUTRA_AndUTRA_cellIdentity_eutra),
        ('utra', __CellGlobalIdEUTRA_AndUTRA_cellIdentity_utra),
        ])
    _CellGlobalIdEUTRA_AndUTRA_cellIdentity._ext = None
    CellGlobalIdEUTRA_AndUTRA._cont = ASN1Dict([
        ('plmn-Identity', _CellGlobalIdEUTRA_AndUTRA_plmn_Identity),
        ('cellIdentity', _CellGlobalIdEUTRA_AndUTRA_cellIdentity),
        ])
    CellGlobalIdEUTRA_AndUTRA._ext = []
    
    #-----< CellGlobalIdGERAN >-----#
    CellGlobalIdGERAN = SEQ(name='CellGlobalIdGERAN', mode=MODE_TYPE)
    _CellGlobalIdGERAN_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CellGlobalIdGERAN_plmn_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CellGlobalIdGERAN_plmn_Identity_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___CellGlobalIdGERAN_plmn_Identity_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __CellGlobalIdGERAN_plmn_Identity_mcc._cont = ___CellGlobalIdGERAN_plmn_Identity_mcc__item_
    __CellGlobalIdGERAN_plmn_Identity_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __CellGlobalIdGERAN_plmn_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CellGlobalIdGERAN_plmn_Identity_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___CellGlobalIdGERAN_plmn_Identity_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __CellGlobalIdGERAN_plmn_Identity_mnc._cont = ___CellGlobalIdGERAN_plmn_Identity_mnc__item_
    __CellGlobalIdGERAN_plmn_Identity_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _CellGlobalIdGERAN_plmn_Identity._cont = ASN1Dict([
        ('mcc', __CellGlobalIdGERAN_plmn_Identity_mcc),
        ('mnc', __CellGlobalIdGERAN_plmn_Identity_mnc),
        ])
    _CellGlobalIdGERAN_plmn_Identity._ext = None
    _CellGlobalIdGERAN_locationAreaCode = BIT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellGlobalIdGERAN_locationAreaCode._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _CellGlobalIdGERAN_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellGlobalIdGERAN_cellIdentity._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    CellGlobalIdGERAN._cont = ASN1Dict([
        ('plmn-Identity', _CellGlobalIdGERAN_plmn_Identity),
        ('locationAreaCode', _CellGlobalIdGERAN_locationAreaCode),
        ('cellIdentity', _CellGlobalIdGERAN_cellIdentity),
        ])
    CellGlobalIdGERAN._ext = []
    
    #-----< ECGI >-----#
    ECGI = SEQ(name='ECGI', mode=MODE_TYPE)
    _ECGI_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECGI_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    __ECGI_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _ECGI_mcc._cont = __ECGI_mcc__item_
    _ECGI_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _ECGI_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ECGI_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    __ECGI_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _ECGI_mnc._cont = __ECGI_mnc__item_
    _ECGI_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _ECGI_cellidentity = BIT_STR(name='cellidentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECGI_cellidentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    ECGI._cont = ASN1Dict([
        ('mcc', _ECGI_mcc),
        ('mnc', _ECGI_mnc),
        ('cellidentity', _ECGI_cellidentity),
        ])
    ECGI._ext = None
    
    #-----< Ellipsoid-Point >-----#
    Ellipsoid_Point = SEQ(name='Ellipsoid-Point', mode=MODE_TYPE)
    _Ellipsoid_Point_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_Point_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _Ellipsoid_Point_latitudeSign._ext = None
    _Ellipsoid_Point_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_Point_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _Ellipsoid_Point_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_Point_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    Ellipsoid_Point._cont = ASN1Dict([
        ('latitudeSign', _Ellipsoid_Point_latitudeSign),
        ('degreesLatitude', _Ellipsoid_Point_degreesLatitude),
        ('degreesLongitude', _Ellipsoid_Point_degreesLongitude),
        ])
    Ellipsoid_Point._ext = None
    
    #-----< Ellipsoid-PointWithUncertaintyCircle >-----#
    Ellipsoid_PointWithUncertaintyCircle = SEQ(name='Ellipsoid-PointWithUncertaintyCircle', mode=MODE_TYPE)
    _Ellipsoid_PointWithUncertaintyCircle_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_PointWithUncertaintyCircle_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _Ellipsoid_PointWithUncertaintyCircle_latitudeSign._ext = None
    _Ellipsoid_PointWithUncertaintyCircle_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_PointWithUncertaintyCircle_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _Ellipsoid_PointWithUncertaintyCircle_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_PointWithUncertaintyCircle_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _Ellipsoid_PointWithUncertaintyCircle_uncertainty = INT(name='uncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ellipsoid_PointWithUncertaintyCircle_uncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    Ellipsoid_PointWithUncertaintyCircle._cont = ASN1Dict([
        ('latitudeSign', _Ellipsoid_PointWithUncertaintyCircle_latitudeSign),
        ('degreesLatitude', _Ellipsoid_PointWithUncertaintyCircle_degreesLatitude),
        ('degreesLongitude', _Ellipsoid_PointWithUncertaintyCircle_degreesLongitude),
        ('uncertainty', _Ellipsoid_PointWithUncertaintyCircle_uncertainty),
        ])
    Ellipsoid_PointWithUncertaintyCircle._ext = None
    
    #-----< EllipsoidPointWithUncertaintyEllipse >-----#
    EllipsoidPointWithUncertaintyEllipse = SEQ(name='EllipsoidPointWithUncertaintyEllipse', mode=MODE_TYPE)
    _EllipsoidPointWithUncertaintyEllipse_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _EllipsoidPointWithUncertaintyEllipse_latitudeSign._ext = None
    _EllipsoidPointWithUncertaintyEllipse_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _EllipsoidPointWithUncertaintyEllipse_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMajor = INT(name='uncertaintySemiMajor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMinor = INT(name='uncertaintySemiMinor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMinor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _EllipsoidPointWithUncertaintyEllipse_orientationMajorAxis = INT(name='orientationMajorAxis', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_orientationMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _EllipsoidPointWithUncertaintyEllipse_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithUncertaintyEllipse_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    EllipsoidPointWithUncertaintyEllipse._cont = ASN1Dict([
        ('latitudeSign', _EllipsoidPointWithUncertaintyEllipse_latitudeSign),
        ('degreesLatitude', _EllipsoidPointWithUncertaintyEllipse_degreesLatitude),
        ('degreesLongitude', _EllipsoidPointWithUncertaintyEllipse_degreesLongitude),
        ('uncertaintySemiMajor', _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMajor),
        ('uncertaintySemiMinor', _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMinor),
        ('orientationMajorAxis', _EllipsoidPointWithUncertaintyEllipse_orientationMajorAxis),
        ('confidence', _EllipsoidPointWithUncertaintyEllipse_confidence),
        ])
    EllipsoidPointWithUncertaintyEllipse._ext = None
    
    #-----< EllipsoidPointWithAltitude >-----#
    EllipsoidPointWithAltitude = SEQ(name='EllipsoidPointWithAltitude', mode=MODE_TYPE)
    _EllipsoidPointWithAltitude_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitude_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _EllipsoidPointWithAltitude_latitudeSign._ext = None
    _EllipsoidPointWithAltitude_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitude_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _EllipsoidPointWithAltitude_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitude_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _EllipsoidPointWithAltitude_altitudeDirection = ENUM(name='altitudeDirection', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitude_altitudeDirection._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _EllipsoidPointWithAltitude_altitudeDirection._ext = None
    _EllipsoidPointWithAltitude_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitude_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    EllipsoidPointWithAltitude._cont = ASN1Dict([
        ('latitudeSign', _EllipsoidPointWithAltitude_latitudeSign),
        ('degreesLatitude', _EllipsoidPointWithAltitude_degreesLatitude),
        ('degreesLongitude', _EllipsoidPointWithAltitude_degreesLongitude),
        ('altitudeDirection', _EllipsoidPointWithAltitude_altitudeDirection),
        ('altitude', _EllipsoidPointWithAltitude_altitude),
        ])
    EllipsoidPointWithAltitude._ext = None
    
    #-----< EllipsoidPointWithAltitudeAndUncertaintyEllipsoid >-----#
    EllipsoidPointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='EllipsoidPointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE)
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_latitudeSign._ext = None
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitudeDirection = ENUM(name='altitudeDirection', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitudeDirection._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitudeDirection._ext = None
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMajor = INT(name='uncertaintySemiMajor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMinor = INT(name='uncertaintySemiMinor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMinor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_orientationMajorAxis = INT(name='orientationMajorAxis', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_orientationMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    EllipsoidPointWithAltitudeAndUncertaintyEllipsoid._cont = ASN1Dict([
        ('latitudeSign', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_latitudeSign),
        ('degreesLatitude', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLatitude),
        ('degreesLongitude', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLongitude),
        ('altitudeDirection', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitudeDirection),
        ('altitude', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitude),
        ('uncertaintySemiMajor', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMajor),
        ('uncertaintySemiMinor', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMinor),
        ('orientationMajorAxis', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_orientationMajorAxis),
        ('uncertaintyAltitude', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude),
        ('confidence', _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_confidence),
        ])
    EllipsoidPointWithAltitudeAndUncertaintyEllipsoid._ext = None
    
    #-----< EllipsoidArc >-----#
    EllipsoidArc = SEQ(name='EllipsoidArc', mode=MODE_TYPE)
    _EllipsoidArc_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _EllipsoidArc_latitudeSign._ext = None
    _EllipsoidArc_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _EllipsoidArc_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _EllipsoidArc_innerRadius = INT(name='innerRadius', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_innerRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EllipsoidArc_uncertaintyRadius = INT(name='uncertaintyRadius', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_uncertaintyRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _EllipsoidArc_offsetAngle = INT(name='offsetAngle', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_offsetAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _EllipsoidArc_includedAngle = INT(name='includedAngle', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_includedAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _EllipsoidArc_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipsoidArc_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    EllipsoidArc._cont = ASN1Dict([
        ('latitudeSign', _EllipsoidArc_latitudeSign),
        ('degreesLatitude', _EllipsoidArc_degreesLatitude),
        ('degreesLongitude', _EllipsoidArc_degreesLongitude),
        ('innerRadius', _EllipsoidArc_innerRadius),
        ('uncertaintyRadius', _EllipsoidArc_uncertaintyRadius),
        ('offsetAngle', _EllipsoidArc_offsetAngle),
        ('includedAngle', _EllipsoidArc_includedAngle),
        ('confidence', _EllipsoidArc_confidence),
        ])
    EllipsoidArc._ext = None
    
    #-----< EPDU-Sequence >-----#
    EPDU_Sequence = SEQ_OF(name='EPDU-Sequence', mode=MODE_TYPE)
    _EPDU_Sequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU')))
    EPDU_Sequence._cont = _EPDU_Sequence__item_
    EPDU_Sequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< maxEPDU >-----#
    maxEPDU = INT(name='maxEPDU', mode=MODE_VALUE)
    maxEPDU._val = 16
    
    #-----< EPDU >-----#
    EPDU = SEQ(name='EPDU', mode=MODE_TYPE)
    _EPDU_ePDU_Identifier = SEQ(name='ePDU-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Identifier')))
    _EPDU_ePDU_Body = OCT_STR(name='ePDU-Body', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Body')))
    EPDU._cont = ASN1Dict([
        ('ePDU-Identifier', _EPDU_ePDU_Identifier),
        ('ePDU-Body', _EPDU_ePDU_Body),
        ])
    EPDU._ext = None
    
    #-----< EPDU-Identifier >-----#
    EPDU_Identifier = SEQ(name='EPDU-Identifier', mode=MODE_TYPE)
    _EPDU_Identifier_ePDU_ID = INT(name='ePDU-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-ID')))
    _EPDU_Identifier_ePDU_Name = STR_VIS(name='ePDU-Name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EPDU-Name')), opt=True)
    EPDU_Identifier._cont = ASN1Dict([
        ('ePDU-ID', _EPDU_Identifier_ePDU_ID),
        ('ePDU-Name', _EPDU_Identifier_ePDU_Name),
        ])
    EPDU_Identifier._ext = []
    
    #-----< EPDU-ID >-----#
    EPDU_ID = INT(name='EPDU-ID', mode=MODE_TYPE)
    EPDU_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EPDU-Name >-----#
    EPDU_Name = STR_VIS(name='EPDU-Name', mode=MODE_TYPE)
    EPDU_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< EPDU-Body >-----#
    EPDU_Body = OCT_STR(name='EPDU-Body', mode=MODE_TYPE)
    
    #-----< HorizontalVelocity >-----#
    HorizontalVelocity = SEQ(name='HorizontalVelocity', mode=MODE_TYPE)
    _HorizontalVelocity_bearing = INT(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocity_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalVelocity_horizontalSpeed = INT(name='horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocity_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    HorizontalVelocity._cont = ASN1Dict([
        ('bearing', _HorizontalVelocity_bearing),
        ('horizontalSpeed', _HorizontalVelocity_horizontalSpeed),
        ])
    HorizontalVelocity._ext = None
    
    #-----< HorizontalWithVerticalVelocity >-----#
    HorizontalWithVerticalVelocity = SEQ(name='HorizontalWithVerticalVelocity', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocity_bearing = INT(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocity_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalWithVerticalVelocity_horizontalSpeed = INT(name='horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocity_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _HorizontalWithVerticalVelocity_verticalDirection = ENUM(name='verticalDirection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocity_verticalDirection._cont = ASN1Dict([('upward', 0), ('downward', 1)])
    _HorizontalWithVerticalVelocity_verticalDirection._ext = None
    _HorizontalWithVerticalVelocity_verticalSpeed = INT(name='verticalSpeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocity_verticalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    HorizontalWithVerticalVelocity._cont = ASN1Dict([
        ('bearing', _HorizontalWithVerticalVelocity_bearing),
        ('horizontalSpeed', _HorizontalWithVerticalVelocity_horizontalSpeed),
        ('verticalDirection', _HorizontalWithVerticalVelocity_verticalDirection),
        ('verticalSpeed', _HorizontalWithVerticalVelocity_verticalSpeed),
        ])
    HorizontalWithVerticalVelocity._ext = None
    
    #-----< HorizontalVelocityWithUncertainty >-----#
    HorizontalVelocityWithUncertainty = SEQ(name='HorizontalVelocityWithUncertainty', mode=MODE_TYPE)
    _HorizontalVelocityWithUncertainty_bearing = INT(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocityWithUncertainty_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalVelocityWithUncertainty_horizontalSpeed = INT(name='horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocityWithUncertainty_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _HorizontalVelocityWithUncertainty_uncertaintySpeed = INT(name='uncertaintySpeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    HorizontalVelocityWithUncertainty._cont = ASN1Dict([
        ('bearing', _HorizontalVelocityWithUncertainty_bearing),
        ('horizontalSpeed', _HorizontalVelocityWithUncertainty_horizontalSpeed),
        ('uncertaintySpeed', _HorizontalVelocityWithUncertainty_uncertaintySpeed),
        ])
    HorizontalVelocityWithUncertainty._ext = None
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty >-----#
    HorizontalWithVerticalVelocityAndUncertainty = SEQ(name='HorizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocityAndUncertainty_bearing = INT(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeed = INT(name='horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_verticalDirection = ENUM(name='verticalDirection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalDirection._cont = ASN1Dict([('upward', 0), ('downward', 1)])
    _HorizontalWithVerticalVelocityAndUncertainty_verticalDirection._ext = None
    _HorizontalWithVerticalVelocityAndUncertainty_verticalSpeed = INT(name='verticalSpeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed = INT(name='horizontalUncertaintySpeed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed = INT(name='verticalUncertaintySpeed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    HorizontalWithVerticalVelocityAndUncertainty._cont = ASN1Dict([
        ('bearing', _HorizontalWithVerticalVelocityAndUncertainty_bearing),
        ('horizontalSpeed', _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeed),
        ('verticalDirection', _HorizontalWithVerticalVelocityAndUncertainty_verticalDirection),
        ('verticalSpeed', _HorizontalWithVerticalVelocityAndUncertainty_verticalSpeed),
        ('horizontalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed),
        ('verticalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed),
        ])
    HorizontalWithVerticalVelocityAndUncertainty._ext = None
    
    #-----< LocationCoordinateTypes >-----#
    LocationCoordinateTypes = SEQ(name='LocationCoordinateTypes', mode=MODE_TYPE)
    _LocationCoordinateTypes_ellipsoidPoint = BOOL(name='ellipsoidPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationCoordinateTypes_ellipsoidPointWithUncertaintyCircle = BOOL(name='ellipsoidPointWithUncertaintyCircle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationCoordinateTypes_ellipsoidPointWithUncertaintyEllipse = BOOL(name='ellipsoidPointWithUncertaintyEllipse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationCoordinateTypes_polygon = BOOL(name='polygon', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationCoordinateTypes_ellipsoidPointWithAltitude = BOOL(name='ellipsoidPointWithAltitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationCoordinateTypes_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid = BOOL(name='ellipsoidPointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationCoordinateTypes_ellipsoidArc = BOOL(name='ellipsoidArc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LocationCoordinateTypes._cont = ASN1Dict([
        ('ellipsoidPoint', _LocationCoordinateTypes_ellipsoidPoint),
        ('ellipsoidPointWithUncertaintyCircle', _LocationCoordinateTypes_ellipsoidPointWithUncertaintyCircle),
        ('ellipsoidPointWithUncertaintyEllipse', _LocationCoordinateTypes_ellipsoidPointWithUncertaintyEllipse),
        ('polygon', _LocationCoordinateTypes_polygon),
        ('ellipsoidPointWithAltitude', _LocationCoordinateTypes_ellipsoidPointWithAltitude),
        ('ellipsoidPointWithAltitudeAndUncertaintyEllipsoid', _LocationCoordinateTypes_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid),
        ('ellipsoidArc', _LocationCoordinateTypes_ellipsoidArc),
        ])
    LocationCoordinateTypes._ext = []
    
    #-----< Polygon >-----#
    Polygon = SEQ_OF(name='Polygon', mode=MODE_TYPE)
    _Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'PolygonPoints')))
    Polygon._cont = _Polygon__item_
    Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=15)], ev=None, er=[])
    
    #-----< PolygonPoints >-----#
    PolygonPoints = SEQ(name='PolygonPoints', mode=MODE_TYPE)
    _PolygonPoints_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PolygonPoints_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _PolygonPoints_latitudeSign._ext = None
    _PolygonPoints_degreesLatitude = INT(name='degreesLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PolygonPoints_degreesLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _PolygonPoints_degreesLongitude = INT(name='degreesLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PolygonPoints_degreesLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    PolygonPoints._cont = ASN1Dict([
        ('latitudeSign', _PolygonPoints_latitudeSign),
        ('degreesLatitude', _PolygonPoints_degreesLatitude),
        ('degreesLongitude', _PolygonPoints_degreesLongitude),
        ])
    PolygonPoints._ext = None
    
    #-----< PositioningModes >-----#
    PositioningModes = SEQ(name='PositioningModes', mode=MODE_TYPE)
    _PositioningModes_posModes = BIT_STR(name='posModes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PositioningModes_posModes._cont = ASN1Dict([('standalone', 0), ('ue-based', 1), ('ue-assisted', 2)])
    _PositioningModes_posModes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    PositioningModes._cont = ASN1Dict([
        ('posModes', _PositioningModes_posModes),
        ])
    PositioningModes._ext = []
    
    #-----< VelocityTypes >-----#
    VelocityTypes = SEQ(name='VelocityTypes', mode=MODE_TYPE)
    _VelocityTypes_horizontalVelocity = BOOL(name='horizontalVelocity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VelocityTypes_horizontalWithVerticalVelocity = BOOL(name='horizontalWithVerticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VelocityTypes_horizontalVelocityWithUncertainty = BOOL(name='horizontalVelocityWithUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VelocityTypes_horizontalWithVerticalVelocityAndUncertainty = BOOL(name='horizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    VelocityTypes._cont = ASN1Dict([
        ('horizontalVelocity', _VelocityTypes_horizontalVelocity),
        ('horizontalWithVerticalVelocity', _VelocityTypes_horizontalWithVerticalVelocity),
        ('horizontalVelocityWithUncertainty', _VelocityTypes_horizontalVelocityWithUncertainty),
        ('horizontalWithVerticalVelocityAndUncertainty', _VelocityTypes_horizontalWithVerticalVelocityAndUncertainty),
        ])
    VelocityTypes._ext = []
    
    #-----< CommonIEsRequestCapabilities >-----#
    CommonIEsRequestCapabilities = SEQ(name='CommonIEsRequestCapabilities', mode=MODE_TYPE)
    CommonIEsRequestCapabilities._cont = ASN1Dict([
        ])
    CommonIEsRequestCapabilities._ext = []
    
    #-----< CommonIEsProvideCapabilities >-----#
    CommonIEsProvideCapabilities = SEQ(name='CommonIEsProvideCapabilities', mode=MODE_TYPE)
    CommonIEsProvideCapabilities._cont = ASN1Dict([
        ])
    CommonIEsProvideCapabilities._ext = []
    
    #-----< CommonIEsRequestAssistanceData >-----#
    CommonIEsRequestAssistanceData = SEQ(name='CommonIEsRequestAssistanceData', mode=MODE_TYPE)
    _CommonIEsRequestAssistanceData_primaryCellID = SEQ(name='primaryCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECGI')), opt=True)
    CommonIEsRequestAssistanceData._cont = ASN1Dict([
        ('primaryCellID', _CommonIEsRequestAssistanceData_primaryCellID),
        ])
    CommonIEsRequestAssistanceData._ext = []
    
    #-----< CommonIEsProvideAssistanceData >-----#
    CommonIEsProvideAssistanceData = SEQ(name='CommonIEsProvideAssistanceData', mode=MODE_TYPE)
    CommonIEsProvideAssistanceData._cont = ASN1Dict([
        ])
    CommonIEsProvideAssistanceData._ext = []
    
    #-----< CommonIEsRequestLocationInformation >-----#
    CommonIEsRequestLocationInformation = SEQ(name='CommonIEsRequestLocationInformation', mode=MODE_TYPE)
    _CommonIEsRequestLocationInformation_locationInformationType = ENUM(name='locationInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationInformationType')))
    _CommonIEsRequestLocationInformation_triggeredReporting = SEQ(name='triggeredReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TriggeredReportingCriteria')), opt=True)
    _CommonIEsRequestLocationInformation_periodicalReporting = SEQ(name='periodicalReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'PeriodicalReportingCriteria')), opt=True)
    _CommonIEsRequestLocationInformation_additionalInformation = ENUM(name='additionalInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AdditionalInformation')), opt=True)
    _CommonIEsRequestLocationInformation_qos = SEQ(name='qos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'QoS')), opt=True)
    _CommonIEsRequestLocationInformation_environment = ENUM(name='environment', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Environment')), opt=True)
    _CommonIEsRequestLocationInformation_locationCoordinateTypes = SEQ(name='locationCoordinateTypes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationCoordinateTypes')), opt=True)
    _CommonIEsRequestLocationInformation_velocityTypes = SEQ(name='velocityTypes', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'VelocityTypes')), opt=True)
    CommonIEsRequestLocationInformation._cont = ASN1Dict([
        ('locationInformationType', _CommonIEsRequestLocationInformation_locationInformationType),
        ('triggeredReporting', _CommonIEsRequestLocationInformation_triggeredReporting),
        ('periodicalReporting', _CommonIEsRequestLocationInformation_periodicalReporting),
        ('additionalInformation', _CommonIEsRequestLocationInformation_additionalInformation),
        ('qos', _CommonIEsRequestLocationInformation_qos),
        ('environment', _CommonIEsRequestLocationInformation_environment),
        ('locationCoordinateTypes', _CommonIEsRequestLocationInformation_locationCoordinateTypes),
        ('velocityTypes', _CommonIEsRequestLocationInformation_velocityTypes),
        ])
    CommonIEsRequestLocationInformation._ext = []
    
    #-----< LocationInformationType >-----#
    LocationInformationType = ENUM(name='LocationInformationType', mode=MODE_TYPE)
    LocationInformationType._cont = ASN1Dict([('locationEstimateRequired', 0), ('locationMeasurementsRequired', 1), ('locationEstimatePreferred', 2), ('locationMeasurementsPreferred', 3)])
    LocationInformationType._ext = []
    
    #-----< PeriodicalReportingCriteria >-----#
    PeriodicalReportingCriteria = SEQ(name='PeriodicalReportingCriteria', mode=MODE_TYPE)
    _PeriodicalReportingCriteria_reportingAmount = ENUM(name='reportingAmount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default='ra-Infinity')
    _PeriodicalReportingCriteria_reportingAmount._cont = ASN1Dict([('ra1', 0), ('ra2', 1), ('ra4', 2), ('ra8', 3), ('ra16', 4), ('ra32', 5), ('ra64', 6), ('ra-Infinity', 7)])
    _PeriodicalReportingCriteria_reportingAmount._ext = None
    _PeriodicalReportingCriteria_reportingInterval = ENUM(name='reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicalReportingCriteria_reportingInterval._cont = ASN1Dict([('noPeriodicalReporting', 0), ('ri0-25', 1), ('ri0-5', 2), ('ri1', 3), ('ri2', 4), ('ri4', 5), ('ri8', 6), ('ri16', 7), ('ri32', 8), ('ri64', 9)])
    _PeriodicalReportingCriteria_reportingInterval._ext = None
    PeriodicalReportingCriteria._cont = ASN1Dict([
        ('reportingAmount', _PeriodicalReportingCriteria_reportingAmount),
        ('reportingInterval', _PeriodicalReportingCriteria_reportingInterval),
        ])
    PeriodicalReportingCriteria._ext = None
    
    #-----< TriggeredReportingCriteria >-----#
    TriggeredReportingCriteria = SEQ(name='TriggeredReportingCriteria', mode=MODE_TYPE)
    _TriggeredReportingCriteria_cellChange = BOOL(name='cellChange', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TriggeredReportingCriteria_reportingDuration = INT(name='reportingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ReportingDuration')))
    TriggeredReportingCriteria._cont = ASN1Dict([
        ('cellChange', _TriggeredReportingCriteria_cellChange),
        ('reportingDuration', _TriggeredReportingCriteria_reportingDuration),
        ])
    TriggeredReportingCriteria._ext = []
    
    #-----< ReportingDuration >-----#
    ReportingDuration = INT(name='ReportingDuration', mode=MODE_TYPE)
    ReportingDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< AdditionalInformation >-----#
    AdditionalInformation = ENUM(name='AdditionalInformation', mode=MODE_TYPE)
    AdditionalInformation._cont = ASN1Dict([('onlyReturnInformationRequested', 0), ('mayReturnAditionalInformation', 1)])
    AdditionalInformation._ext = []
    
    #-----< QoS >-----#
    QoS = SEQ(name='QoS', mode=MODE_TYPE)
    _QoS_horizontalAccuracy = SEQ(name='horizontalAccuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'HorizontalAccuracy')), opt=True)
    _QoS_verticalCoordinateRequest = BOOL(name='verticalCoordinateRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QoS_verticalAccuracy = SEQ(name='verticalAccuracy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'VerticalAccuracy')), opt=True)
    _QoS_responseTime = SEQ(name='responseTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ResponseTime')), opt=True)
    _QoS_velocityRequest = BOOL(name='velocityRequest', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    QoS._cont = ASN1Dict([
        ('horizontalAccuracy', _QoS_horizontalAccuracy),
        ('verticalCoordinateRequest', _QoS_verticalCoordinateRequest),
        ('verticalAccuracy', _QoS_verticalAccuracy),
        ('responseTime', _QoS_responseTime),
        ('velocityRequest', _QoS_velocityRequest),
        ])
    QoS._ext = []
    
    #-----< HorizontalAccuracy >-----#
    HorizontalAccuracy = SEQ(name='HorizontalAccuracy', mode=MODE_TYPE)
    _HorizontalAccuracy_accuracy = INT(name='accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalAccuracy_accuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _HorizontalAccuracy_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalAccuracy_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    HorizontalAccuracy._cont = ASN1Dict([
        ('accuracy', _HorizontalAccuracy_accuracy),
        ('confidence', _HorizontalAccuracy_confidence),
        ])
    HorizontalAccuracy._ext = []
    
    #-----< VerticalAccuracy >-----#
    VerticalAccuracy = SEQ(name='VerticalAccuracy', mode=MODE_TYPE)
    _VerticalAccuracy_accuracy = INT(name='accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VerticalAccuracy_accuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _VerticalAccuracy_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VerticalAccuracy_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    VerticalAccuracy._cont = ASN1Dict([
        ('accuracy', _VerticalAccuracy_accuracy),
        ('confidence', _VerticalAccuracy_confidence),
        ])
    VerticalAccuracy._ext = []
    
    #-----< ResponseTime >-----#
    ResponseTime = SEQ(name='ResponseTime', mode=MODE_TYPE)
    _ResponseTime_time = INT(name='time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResponseTime_time._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _ResponseTime_responseTimeEarlyFix_r12 = INT(name='responseTimeEarlyFix-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True, group=0)
    _ResponseTime_responseTimeEarlyFix_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ResponseTime._cont = ASN1Dict([
        ('time', _ResponseTime_time),
        ('responseTimeEarlyFix-r12', _ResponseTime_responseTimeEarlyFix_r12),
        ])
    ResponseTime._ext = ['responseTimeEarlyFix-r12']
    
    #-----< Environment >-----#
    Environment = ENUM(name='Environment', mode=MODE_TYPE)
    Environment._cont = ASN1Dict([('badArea', 0), ('notBadArea', 1), ('mixedArea', 2)])
    Environment._ext = []
    
    #-----< CommonIEsProvideLocationInformation >-----#
    CommonIEsProvideLocationInformation = SEQ(name='CommonIEsProvideLocationInformation', mode=MODE_TYPE)
    _CommonIEsProvideLocationInformation_locationEstimate = CHOICE(name='locationEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationCoordinates')), opt=True)
    _CommonIEsProvideLocationInformation_velocityEstimate = CHOICE(name='velocityEstimate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Velocity')), opt=True)
    _CommonIEsProvideLocationInformation_locationError = SEQ(name='locationError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationError')), opt=True)
    _CommonIEsProvideLocationInformation_earlyFixReport_r12 = ENUM(name='earlyFixReport-r12', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EarlyFixReport-r12')), opt=True, group=0)
    _CommonIEsProvideLocationInformation_locationSource_r13 = BIT_STR(name='locationSource-r13', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationSource-r13')), opt=True, group=1)
    _CommonIEsProvideLocationInformation_locationTimestamp_r13 = TIME_UTC(name='locationTimestamp-r13', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True, group=1)
    CommonIEsProvideLocationInformation._cont = ASN1Dict([
        ('locationEstimate', _CommonIEsProvideLocationInformation_locationEstimate),
        ('velocityEstimate', _CommonIEsProvideLocationInformation_velocityEstimate),
        ('locationError', _CommonIEsProvideLocationInformation_locationError),
        ('earlyFixReport-r12', _CommonIEsProvideLocationInformation_earlyFixReport_r12),
        ('locationSource-r13', _CommonIEsProvideLocationInformation_locationSource_r13),
        ('locationTimestamp-r13', _CommonIEsProvideLocationInformation_locationTimestamp_r13),
        ])
    CommonIEsProvideLocationInformation._ext = ['earlyFixReport-r12', 'locationSource-r13', 'locationTimestamp-r13']
    
    #-----< LocationCoordinates >-----#
    LocationCoordinates = CHOICE(name='LocationCoordinates', mode=MODE_TYPE)
    _LocationCoordinates_ellipsoidPoint = SEQ(name='ellipsoidPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')))
    _LocationCoordinates_ellipsoidPointWithUncertaintyCircle = SEQ(name='ellipsoidPointWithUncertaintyCircle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-PointWithUncertaintyCircle')))
    _LocationCoordinates_ellipsoidPointWithUncertaintyEllipse = SEQ(name='ellipsoidPointWithUncertaintyEllipse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithUncertaintyEllipse')))
    _LocationCoordinates_polygon = SEQ_OF(name='polygon', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Polygon')))
    _LocationCoordinates_ellipsoidPointWithAltitude = SEQ(name='ellipsoidPointWithAltitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitude')))
    _LocationCoordinates_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='ellipsoidPointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')))
    _LocationCoordinates_ellipsoidArc = SEQ(name='ellipsoidArc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidArc')))
    LocationCoordinates._cont = ASN1Dict([
        ('ellipsoidPoint', _LocationCoordinates_ellipsoidPoint),
        ('ellipsoidPointWithUncertaintyCircle', _LocationCoordinates_ellipsoidPointWithUncertaintyCircle),
        ('ellipsoidPointWithUncertaintyEllipse', _LocationCoordinates_ellipsoidPointWithUncertaintyEllipse),
        ('polygon', _LocationCoordinates_polygon),
        ('ellipsoidPointWithAltitude', _LocationCoordinates_ellipsoidPointWithAltitude),
        ('ellipsoidPointWithAltitudeAndUncertaintyEllipsoid', _LocationCoordinates_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid),
        ('ellipsoidArc', _LocationCoordinates_ellipsoidArc),
        ])
    LocationCoordinates._ext = []
    
    #-----< Velocity >-----#
    Velocity = CHOICE(name='Velocity', mode=MODE_TYPE)
    _Velocity_horizontalVelocity = SEQ(name='horizontalVelocity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'HorizontalVelocity')))
    _Velocity_horizontalWithVerticalVelocity = SEQ(name='horizontalWithVerticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'HorizontalWithVerticalVelocity')))
    _Velocity_horizontalVelocityWithUncertainty = SEQ(name='horizontalVelocityWithUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'HorizontalVelocityWithUncertainty')))
    _Velocity_horizontalWithVerticalVelocityAndUncertainty = SEQ(name='horizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'HorizontalWithVerticalVelocityAndUncertainty')))
    Velocity._cont = ASN1Dict([
        ('horizontalVelocity', _Velocity_horizontalVelocity),
        ('horizontalWithVerticalVelocity', _Velocity_horizontalWithVerticalVelocity),
        ('horizontalVelocityWithUncertainty', _Velocity_horizontalVelocityWithUncertainty),
        ('horizontalWithVerticalVelocityAndUncertainty', _Velocity_horizontalWithVerticalVelocityAndUncertainty),
        ])
    Velocity._ext = []
    
    #-----< LocationError >-----#
    LocationError = SEQ(name='LocationError', mode=MODE_TYPE)
    _LocationError_locationfailurecause = ENUM(name='locationfailurecause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationFailureCause')))
    LocationError._cont = ASN1Dict([
        ('locationfailurecause', _LocationError_locationfailurecause),
        ])
    LocationError._ext = []
    
    #-----< LocationFailureCause >-----#
    LocationFailureCause = ENUM(name='LocationFailureCause', mode=MODE_TYPE)
    LocationFailureCause._cont = ASN1Dict([('undefined', 0), ('requestedMethodNotSupported', 1), ('positionMethodFailure', 2), ('periodicLocationMeasurementsNotAvailable', 3)])
    LocationFailureCause._ext = []
    
    #-----< EarlyFixReport-r12 >-----#
    EarlyFixReport_r12 = ENUM(name='EarlyFixReport-r12', mode=MODE_TYPE)
    EarlyFixReport_r12._cont = ASN1Dict([('noMoreMessages', 0), ('moreMessagesOnTheWay', 1)])
    EarlyFixReport_r12._ext = None
    
    #-----< LocationSource-r13 >-----#
    LocationSource_r13 = BIT_STR(name='LocationSource-r13', mode=MODE_TYPE)
    LocationSource_r13._cont = ASN1Dict([('a-gnss', 0), ('wlan', 1), ('bt', 2), ('tbs', 3), ('sensor', 4)])
    LocationSource_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CommonIEsAbort >-----#
    CommonIEsAbort = SEQ(name='CommonIEsAbort', mode=MODE_TYPE)
    _CommonIEsAbort_abortCause = ENUM(name='abortCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonIEsAbort_abortCause._cont = ASN1Dict([('undefined', 0), ('stopPeriodicReporting', 1), ('targetDeviceAbort', 2), ('networkAbort', 3)])
    _CommonIEsAbort_abortCause._ext = []
    CommonIEsAbort._cont = ASN1Dict([
        ('abortCause', _CommonIEsAbort_abortCause),
        ])
    CommonIEsAbort._ext = None
    
    #-----< CommonIEsError >-----#
    CommonIEsError = SEQ(name='CommonIEsError', mode=MODE_TYPE)
    _CommonIEsError_errorCause = ENUM(name='errorCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonIEsError_errorCause._cont = ASN1Dict([('undefined', 0), ('lppMessageHeaderError', 1), ('lppMessageBodyError', 2), ('epduError', 3), ('incorrectDataValue', 4)])
    _CommonIEsError_errorCause._ext = []
    CommonIEsError._cont = ASN1Dict([
        ('errorCause', _CommonIEsError_errorCause),
        ])
    CommonIEsError._ext = None
    
    #-----< OTDOA-ProvideAssistanceData >-----#
    OTDOA_ProvideAssistanceData = SEQ(name='OTDOA-ProvideAssistanceData', mode=MODE_TYPE)
    _OTDOA_ProvideAssistanceData_otdoa_ReferenceCellInfo = SEQ(name='otdoa-ReferenceCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-ReferenceCellInfo')), opt=True)
    _OTDOA_ProvideAssistanceData_otdoa_NeighbourCellInfo = SEQ_OF(name='otdoa-NeighbourCellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-NeighbourCellInfoList')), opt=True)
    _OTDOA_ProvideAssistanceData_otdoa_Error = CHOICE(name='otdoa-Error', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-Error')), opt=True)
    OTDOA_ProvideAssistanceData._cont = ASN1Dict([
        ('otdoa-ReferenceCellInfo', _OTDOA_ProvideAssistanceData_otdoa_ReferenceCellInfo),
        ('otdoa-NeighbourCellInfo', _OTDOA_ProvideAssistanceData_otdoa_NeighbourCellInfo),
        ('otdoa-Error', _OTDOA_ProvideAssistanceData_otdoa_Error),
        ])
    OTDOA_ProvideAssistanceData._ext = []
    
    #-----< OTDOA-ReferenceCellInfo >-----#
    OTDOA_ReferenceCellInfo = SEQ(name='OTDOA-ReferenceCellInfo', mode=MODE_TYPE)
    _OTDOA_ReferenceCellInfo_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_ReferenceCellInfo_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _OTDOA_ReferenceCellInfo_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECGI')), opt=True)
    _OTDOA_ReferenceCellInfo_earfcnRef = INT(name='earfcnRef', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')), opt=True)
    _OTDOA_ReferenceCellInfo_antennaPortConfig = ENUM(name='antennaPortConfig', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_ReferenceCellInfo_antennaPortConfig._cont = ASN1Dict([('ports1-or-2', 0), ('ports4', 1)])
    _OTDOA_ReferenceCellInfo_antennaPortConfig._ext = []
    _OTDOA_ReferenceCellInfo_cpLength = ENUM(name='cpLength', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_ReferenceCellInfo_cpLength._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _OTDOA_ReferenceCellInfo_cpLength._ext = []
    _OTDOA_ReferenceCellInfo_prsInfo = SEQ(name='prsInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'PRS-Info')), opt=True)
    _OTDOA_ReferenceCellInfo_earfcnRef_v9a0 = INT(name='earfcnRef-v9a0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA-v9a0')), opt=True, group=0)
    OTDOA_ReferenceCellInfo._cont = ASN1Dict([
        ('physCellId', _OTDOA_ReferenceCellInfo_physCellId),
        ('cellGlobalId', _OTDOA_ReferenceCellInfo_cellGlobalId),
        ('earfcnRef', _OTDOA_ReferenceCellInfo_earfcnRef),
        ('antennaPortConfig', _OTDOA_ReferenceCellInfo_antennaPortConfig),
        ('cpLength', _OTDOA_ReferenceCellInfo_cpLength),
        ('prsInfo', _OTDOA_ReferenceCellInfo_prsInfo),
        ('earfcnRef-v9a0', _OTDOA_ReferenceCellInfo_earfcnRef_v9a0),
        ])
    OTDOA_ReferenceCellInfo._ext = ['earfcnRef-v9a0']
    
    #-----< PRS-Info >-----#
    PRS_Info = SEQ(name='PRS-Info', mode=MODE_TYPE)
    _PRS_Info_prs_Bandwidth = ENUM(name='prs-Bandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Info_prs_Bandwidth._cont = ASN1Dict([('n6', 0), ('n15', 1), ('n25', 2), ('n50', 3), ('n75', 4), ('n100', 5)])
    _PRS_Info_prs_Bandwidth._ext = []
    _PRS_Info_prs_ConfigurationIndex = INT(name='prs-ConfigurationIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Info_prs_ConfigurationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _PRS_Info_numDL_Frames = ENUM(name='numDL-Frames', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Info_numDL_Frames._cont = ASN1Dict([('sf-1', 0), ('sf-2', 1), ('sf-4', 2), ('sf-6', 3)])
    _PRS_Info_numDL_Frames._ext = []
    _PRS_Info_prs_MutingInfo_r9 = CHOICE(name='prs-MutingInfo-r9', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PRS_Info_prs_MutingInfo_r9_po2_r9 = BIT_STR(name='po2-r9', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRS_Info_prs_MutingInfo_r9_po2_r9._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __PRS_Info_prs_MutingInfo_r9_po4_r9 = BIT_STR(name='po4-r9', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRS_Info_prs_MutingInfo_r9_po4_r9._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __PRS_Info_prs_MutingInfo_r9_po8_r9 = BIT_STR(name='po8-r9', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRS_Info_prs_MutingInfo_r9_po8_r9._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __PRS_Info_prs_MutingInfo_r9_po16_r9 = BIT_STR(name='po16-r9', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRS_Info_prs_MutingInfo_r9_po16_r9._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _PRS_Info_prs_MutingInfo_r9._cont = ASN1Dict([
        ('po2-r9', __PRS_Info_prs_MutingInfo_r9_po2_r9),
        ('po4-r9', __PRS_Info_prs_MutingInfo_r9_po4_r9),
        ('po8-r9', __PRS_Info_prs_MutingInfo_r9_po8_r9),
        ('po16-r9', __PRS_Info_prs_MutingInfo_r9_po16_r9),
        ])
    _PRS_Info_prs_MutingInfo_r9._ext = []
    PRS_Info._cont = ASN1Dict([
        ('prs-Bandwidth', _PRS_Info_prs_Bandwidth),
        ('prs-ConfigurationIndex', _PRS_Info_prs_ConfigurationIndex),
        ('numDL-Frames', _PRS_Info_numDL_Frames),
        ('prs-MutingInfo-r9', _PRS_Info_prs_MutingInfo_r9),
        ])
    PRS_Info._ext = ['prs-MutingInfo-r9']
    
    #-----< OTDOA-NeighbourCellInfoList >-----#
    OTDOA_NeighbourCellInfoList = SEQ_OF(name='OTDOA-NeighbourCellInfoList', mode=MODE_TYPE)
    _OTDOA_NeighbourCellInfoList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-NeighbourFreqInfo')))
    OTDOA_NeighbourCellInfoList._cont = _OTDOA_NeighbourCellInfoList__item_
    OTDOA_NeighbourCellInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< OTDOA-NeighbourFreqInfo >-----#
    OTDOA_NeighbourFreqInfo = SEQ_OF(name='OTDOA-NeighbourFreqInfo', mode=MODE_TYPE)
    _OTDOA_NeighbourFreqInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-NeighbourCellInfoElement')))
    OTDOA_NeighbourFreqInfo._cont = _OTDOA_NeighbourFreqInfo__item_
    OTDOA_NeighbourFreqInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< OTDOA-NeighbourCellInfoElement >-----#
    OTDOA_NeighbourCellInfoElement = SEQ(name='OTDOA-NeighbourCellInfoElement', mode=MODE_TYPE)
    _OTDOA_NeighbourCellInfoElement_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_NeighbourCellInfoElement_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _OTDOA_NeighbourCellInfoElement_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECGI')), opt=True)
    _OTDOA_NeighbourCellInfoElement_earfcn = INT(name='earfcn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')), opt=True)
    _OTDOA_NeighbourCellInfoElement_cpLength = ENUM(name='cpLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_NeighbourCellInfoElement_cpLength._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _OTDOA_NeighbourCellInfoElement_cpLength._ext = []
    _OTDOA_NeighbourCellInfoElement_prsInfo = SEQ(name='prsInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'PRS-Info')), opt=True)
    _OTDOA_NeighbourCellInfoElement_antennaPortConfig = ENUM(name='antennaPortConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_NeighbourCellInfoElement_antennaPortConfig._cont = ASN1Dict([('ports-1-or-2', 0), ('ports-4', 1)])
    _OTDOA_NeighbourCellInfoElement_antennaPortConfig._ext = []
    _OTDOA_NeighbourCellInfoElement_slotNumberOffset = INT(name='slotNumberOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_NeighbourCellInfoElement_slotNumberOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    _OTDOA_NeighbourCellInfoElement_prs_SubframeOffset = INT(name='prs-SubframeOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_NeighbourCellInfoElement_prs_SubframeOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1279)], ev=None, er=[])
    _OTDOA_NeighbourCellInfoElement_expectedRSTD = INT(name='expectedRSTD', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_NeighbourCellInfoElement_expectedRSTD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _OTDOA_NeighbourCellInfoElement_expectedRSTD_Uncertainty = INT(name='expectedRSTD-Uncertainty', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_NeighbourCellInfoElement_expectedRSTD_Uncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _OTDOA_NeighbourCellInfoElement_earfcn_v9a0 = INT(name='earfcn-v9a0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA-v9a0')), opt=True, group=0)
    OTDOA_NeighbourCellInfoElement._cont = ASN1Dict([
        ('physCellId', _OTDOA_NeighbourCellInfoElement_physCellId),
        ('cellGlobalId', _OTDOA_NeighbourCellInfoElement_cellGlobalId),
        ('earfcn', _OTDOA_NeighbourCellInfoElement_earfcn),
        ('cpLength', _OTDOA_NeighbourCellInfoElement_cpLength),
        ('prsInfo', _OTDOA_NeighbourCellInfoElement_prsInfo),
        ('antennaPortConfig', _OTDOA_NeighbourCellInfoElement_antennaPortConfig),
        ('slotNumberOffset', _OTDOA_NeighbourCellInfoElement_slotNumberOffset),
        ('prs-SubframeOffset', _OTDOA_NeighbourCellInfoElement_prs_SubframeOffset),
        ('expectedRSTD', _OTDOA_NeighbourCellInfoElement_expectedRSTD),
        ('expectedRSTD-Uncertainty', _OTDOA_NeighbourCellInfoElement_expectedRSTD_Uncertainty),
        ('earfcn-v9a0', _OTDOA_NeighbourCellInfoElement_earfcn_v9a0),
        ])
    OTDOA_NeighbourCellInfoElement._ext = ['earfcn-v9a0']
    
    #-----< maxFreqLayers >-----#
    maxFreqLayers = INT(name='maxFreqLayers', mode=MODE_VALUE)
    maxFreqLayers._val = 3
    
    #-----< OTDOA-RequestAssistanceData >-----#
    OTDOA_RequestAssistanceData = SEQ(name='OTDOA-RequestAssistanceData', mode=MODE_TYPE)
    _OTDOA_RequestAssistanceData_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_RequestAssistanceData_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    OTDOA_RequestAssistanceData._cont = ASN1Dict([
        ('physCellId', _OTDOA_RequestAssistanceData_physCellId),
        ])
    OTDOA_RequestAssistanceData._ext = []
    
    #-----< OTDOA-ProvideLocationInformation >-----#
    OTDOA_ProvideLocationInformation = SEQ(name='OTDOA-ProvideLocationInformation', mode=MODE_TYPE)
    _OTDOA_ProvideLocationInformation_otdoaSignalMeasurementInformation = SEQ(name='otdoaSignalMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-SignalMeasurementInformation')), opt=True)
    _OTDOA_ProvideLocationInformation_otdoa_Error = CHOICE(name='otdoa-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-Error')), opt=True)
    OTDOA_ProvideLocationInformation._cont = ASN1Dict([
        ('otdoaSignalMeasurementInformation', _OTDOA_ProvideLocationInformation_otdoaSignalMeasurementInformation),
        ('otdoa-Error', _OTDOA_ProvideLocationInformation_otdoa_Error),
        ])
    OTDOA_ProvideLocationInformation._ext = []
    
    #-----< OTDOA-SignalMeasurementInformation >-----#
    OTDOA_SignalMeasurementInformation = SEQ(name='OTDOA-SignalMeasurementInformation', mode=MODE_TYPE)
    _OTDOA_SignalMeasurementInformation_systemFrameNumber = BIT_STR(name='systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_SignalMeasurementInformation_systemFrameNumber._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _OTDOA_SignalMeasurementInformation_physCellIdRef = INT(name='physCellIdRef', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_SignalMeasurementInformation_physCellIdRef._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _OTDOA_SignalMeasurementInformation_cellGlobalIdRef = SEQ(name='cellGlobalIdRef', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECGI')), opt=True)
    _OTDOA_SignalMeasurementInformation_earfcnRef = INT(name='earfcnRef', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')), opt=True)
    _OTDOA_SignalMeasurementInformation_referenceQuality = SEQ(name='referenceQuality', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-MeasQuality')), opt=True)
    _OTDOA_SignalMeasurementInformation_neighbourMeasurementList = SEQ_OF(name='neighbourMeasurementList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NeighbourMeasurementList')))
    _OTDOA_SignalMeasurementInformation_earfcnRef_v9a0 = INT(name='earfcnRef-v9a0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA-v9a0')), opt=True, group=0)
    OTDOA_SignalMeasurementInformation._cont = ASN1Dict([
        ('systemFrameNumber', _OTDOA_SignalMeasurementInformation_systemFrameNumber),
        ('physCellIdRef', _OTDOA_SignalMeasurementInformation_physCellIdRef),
        ('cellGlobalIdRef', _OTDOA_SignalMeasurementInformation_cellGlobalIdRef),
        ('earfcnRef', _OTDOA_SignalMeasurementInformation_earfcnRef),
        ('referenceQuality', _OTDOA_SignalMeasurementInformation_referenceQuality),
        ('neighbourMeasurementList', _OTDOA_SignalMeasurementInformation_neighbourMeasurementList),
        ('earfcnRef-v9a0', _OTDOA_SignalMeasurementInformation_earfcnRef_v9a0),
        ])
    OTDOA_SignalMeasurementInformation._ext = ['earfcnRef-v9a0']
    
    #-----< NeighbourMeasurementList >-----#
    NeighbourMeasurementList = SEQ_OF(name='NeighbourMeasurementList', mode=MODE_TYPE)
    _NeighbourMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'NeighbourMeasurementElement')))
    NeighbourMeasurementList._cont = _NeighbourMeasurementList__item_
    NeighbourMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< NeighbourMeasurementElement >-----#
    NeighbourMeasurementElement = SEQ(name='NeighbourMeasurementElement', mode=MODE_TYPE)
    _NeighbourMeasurementElement_physCellIdNeighbour = INT(name='physCellIdNeighbour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NeighbourMeasurementElement_physCellIdNeighbour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _NeighbourMeasurementElement_cellGlobalIdNeighbour = SEQ(name='cellGlobalIdNeighbour', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECGI')), opt=True)
    _NeighbourMeasurementElement_earfcnNeighbour = INT(name='earfcnNeighbour', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')), opt=True)
    _NeighbourMeasurementElement_rstd = INT(name='rstd', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NeighbourMeasurementElement_rstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12711)], ev=None, er=[])
    _NeighbourMeasurementElement_rstd_Quality = SEQ(name='rstd-Quality', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-MeasQuality')))
    _NeighbourMeasurementElement_earfcnNeighbour_v9a0 = INT(name='earfcnNeighbour-v9a0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA-v9a0')), opt=True, group=0)
    NeighbourMeasurementElement._cont = ASN1Dict([
        ('physCellIdNeighbour', _NeighbourMeasurementElement_physCellIdNeighbour),
        ('cellGlobalIdNeighbour', _NeighbourMeasurementElement_cellGlobalIdNeighbour),
        ('earfcnNeighbour', _NeighbourMeasurementElement_earfcnNeighbour),
        ('rstd', _NeighbourMeasurementElement_rstd),
        ('rstd-Quality', _NeighbourMeasurementElement_rstd_Quality),
        ('earfcnNeighbour-v9a0', _NeighbourMeasurementElement_earfcnNeighbour_v9a0),
        ])
    NeighbourMeasurementElement._ext = ['earfcnNeighbour-v9a0']
    
    #-----< OTDOA-MeasQuality >-----#
    OTDOA_MeasQuality = SEQ(name='OTDOA-MeasQuality', mode=MODE_TYPE)
    _OTDOA_MeasQuality_error_Resolution = BIT_STR(name='error-Resolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_MeasQuality_error_Resolution._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _OTDOA_MeasQuality_error_Value = BIT_STR(name='error-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_MeasQuality_error_Value._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _OTDOA_MeasQuality_error_NumSamples = BIT_STR(name='error-NumSamples', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_MeasQuality_error_NumSamples._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    OTDOA_MeasQuality._cont = ASN1Dict([
        ('error-Resolution', _OTDOA_MeasQuality_error_Resolution),
        ('error-Value', _OTDOA_MeasQuality_error_Value),
        ('error-NumSamples', _OTDOA_MeasQuality_error_NumSamples),
        ])
    OTDOA_MeasQuality._ext = []
    
    #-----< OTDOA-RequestLocationInformation >-----#
    OTDOA_RequestLocationInformation = SEQ(name='OTDOA-RequestLocationInformation', mode=MODE_TYPE)
    _OTDOA_RequestLocationInformation_assistanceAvailability = BOOL(name='assistanceAvailability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OTDOA_RequestLocationInformation._cont = ASN1Dict([
        ('assistanceAvailability', _OTDOA_RequestLocationInformation_assistanceAvailability),
        ])
    OTDOA_RequestLocationInformation._ext = []
    
    #-----< OTDOA-ProvideCapabilities >-----#
    OTDOA_ProvideCapabilities = SEQ(name='OTDOA-ProvideCapabilities', mode=MODE_TYPE)
    _OTDOA_ProvideCapabilities_otdoa_Mode = BIT_STR(name='otdoa-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_ProvideCapabilities_otdoa_Mode._cont = ASN1Dict([('ue-assisted', 0)])
    _OTDOA_ProvideCapabilities_otdoa_Mode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OTDOA_ProvideCapabilities_supportedBandListEUTRA = SEQ_OF(name='supportedBandListEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OTDOA_ProvideCapabilities_supportedBandListEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'SupportedBandEUTRA')))
    _OTDOA_ProvideCapabilities_supportedBandListEUTRA._cont = __OTDOA_ProvideCapabilities_supportedBandListEUTRA__item_
    _OTDOA_ProvideCapabilities_supportedBandListEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0 = SEQ_OF(name='supportedBandListEUTRA-v9a0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'SupportedBandEUTRA-v9a0')))
    _OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0._cont = __OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0__item_
    _OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OTDOA_ProvideCapabilities_interFreqRSTDmeasurement_r10 = ENUM(name='interFreqRSTDmeasurement-r10', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_ProvideCapabilities_interFreqRSTDmeasurement_r10._cont = ASN1Dict([('supported', 0)])
    _OTDOA_ProvideCapabilities_interFreqRSTDmeasurement_r10._ext = None
    _OTDOA_ProvideCapabilities_additionalNeighbourCellInfoList_r10 = ENUM(name='additionalNeighbourCellInfoList-r10', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OTDOA_ProvideCapabilities_additionalNeighbourCellInfoList_r10._cont = ASN1Dict([('supported', 0)])
    _OTDOA_ProvideCapabilities_additionalNeighbourCellInfoList_r10._ext = None
    OTDOA_ProvideCapabilities._cont = ASN1Dict([
        ('otdoa-Mode', _OTDOA_ProvideCapabilities_otdoa_Mode),
        ('supportedBandListEUTRA', _OTDOA_ProvideCapabilities_supportedBandListEUTRA),
        ('supportedBandListEUTRA-v9a0', _OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0),
        ('interFreqRSTDmeasurement-r10', _OTDOA_ProvideCapabilities_interFreqRSTDmeasurement_r10),
        ('additionalNeighbourCellInfoList-r10', _OTDOA_ProvideCapabilities_additionalNeighbourCellInfoList_r10),
        ])
    OTDOA_ProvideCapabilities._ext = ['supportedBandListEUTRA', 'supportedBandListEUTRA-v9a0', 'interFreqRSTDmeasurement-r10', 'additionalNeighbourCellInfoList-r10']
    
    #-----< maxBands >-----#
    maxBands = INT(name='maxBands', mode=MODE_VALUE)
    maxBands._val = 64
    
    #-----< SupportedBandEUTRA >-----#
    SupportedBandEUTRA = SEQ(name='SupportedBandEUTRA', mode=MODE_TYPE)
    _SupportedBandEUTRA_bandEUTRA = INT(name='bandEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBandEUTRA_bandEUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    SupportedBandEUTRA._cont = ASN1Dict([
        ('bandEUTRA', _SupportedBandEUTRA_bandEUTRA),
        ])
    SupportedBandEUTRA._ext = None
    
    #-----< SupportedBandEUTRA-v9a0 >-----#
    SupportedBandEUTRA_v9a0 = SEQ(name='SupportedBandEUTRA-v9a0', mode=MODE_TYPE)
    _SupportedBandEUTRA_v9a0_bandEUTRA_v9a0 = INT(name='bandEUTRA-v9a0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupportedBandEUTRA_v9a0_bandEUTRA_v9a0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65, ub=256)], ev=None, er=[])
    SupportedBandEUTRA_v9a0._cont = ASN1Dict([
        ('bandEUTRA-v9a0', _SupportedBandEUTRA_v9a0_bandEUTRA_v9a0),
        ])
    SupportedBandEUTRA_v9a0._ext = None
    
    #-----< maxFBI >-----#
    maxFBI = INT(name='maxFBI', mode=MODE_VALUE)
    maxFBI._val = 64
    
    #-----< maxFBI-Plus1 >-----#
    maxFBI_Plus1 = INT(name='maxFBI-Plus1', mode=MODE_VALUE)
    maxFBI_Plus1._val = 65
    
    #-----< maxFBI2 >-----#
    maxFBI2 = INT(name='maxFBI2', mode=MODE_VALUE)
    maxFBI2._val = 256
    
    #-----< OTDOA-RequestCapabilities >-----#
    OTDOA_RequestCapabilities = SEQ(name='OTDOA-RequestCapabilities', mode=MODE_TYPE)
    OTDOA_RequestCapabilities._cont = ASN1Dict([
        ])
    OTDOA_RequestCapabilities._ext = []
    
    #-----< OTDOA-Error >-----#
    OTDOA_Error = CHOICE(name='OTDOA-Error', mode=MODE_TYPE)
    _OTDOA_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-LocationServerErrorCauses')))
    _OTDOA_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-TargetDeviceErrorCauses')))
    OTDOA_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OTDOA_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OTDOA_Error_targetDeviceErrorCauses),
        ])
    OTDOA_Error._ext = []
    
    #-----< OTDOA-LocationServerErrorCauses >-----#
    OTDOA_LocationServerErrorCauses = SEQ(name='OTDOA-LocationServerErrorCauses', mode=MODE_TYPE)
    _OTDOA_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('assistanceDataNotSupportedByServer', 1), ('assistanceDataSupportedButCurrentlyNotAvailableByServer', 2)])
    _OTDOA_LocationServerErrorCauses_cause._ext = []
    OTDOA_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OTDOA_LocationServerErrorCauses_cause),
        ])
    OTDOA_LocationServerErrorCauses._ext = []
    
    #-----< OTDOA-TargetDeviceErrorCauses >-----#
    OTDOA_TargetDeviceErrorCauses = SEQ(name='OTDOA-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OTDOA_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OTDOA_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('assistance-data-missing', 1), ('unableToMeasureReferenceCell', 2), ('unableToMeasureAnyNeighbourCell', 3), ('attemptedButUnableToMeasureSomeNeighbourCells', 4)])
    _OTDOA_TargetDeviceErrorCauses_cause._ext = []
    OTDOA_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OTDOA_TargetDeviceErrorCauses_cause),
        ])
    OTDOA_TargetDeviceErrorCauses._ext = []
    
    #-----< A-GNSS-ProvideAssistanceData >-----#
    A_GNSS_ProvideAssistanceData = SEQ(name='A-GNSS-ProvideAssistanceData', mode=MODE_TYPE)
    _A_GNSS_ProvideAssistanceData_gnss_CommonAssistData = SEQ(name='gnss-CommonAssistData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-CommonAssistData')), opt=True)
    _A_GNSS_ProvideAssistanceData_gnss_GenericAssistData = SEQ_OF(name='gnss-GenericAssistData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-GenericAssistData')), opt=True)
    _A_GNSS_ProvideAssistanceData_gnss_Error = CHOICE(name='gnss-Error', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-Error')), opt=True)
    A_GNSS_ProvideAssistanceData._cont = ASN1Dict([
        ('gnss-CommonAssistData', _A_GNSS_ProvideAssistanceData_gnss_CommonAssistData),
        ('gnss-GenericAssistData', _A_GNSS_ProvideAssistanceData_gnss_GenericAssistData),
        ('gnss-Error', _A_GNSS_ProvideAssistanceData_gnss_Error),
        ])
    A_GNSS_ProvideAssistanceData._ext = []
    
    #-----< GNSS-CommonAssistData >-----#
    GNSS_CommonAssistData = SEQ(name='GNSS-CommonAssistData', mode=MODE_TYPE)
    _GNSS_CommonAssistData_gnss_ReferenceTime = SEQ(name='gnss-ReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceTime')), opt=True)
    _GNSS_CommonAssistData_gnss_ReferenceLocation = SEQ(name='gnss-ReferenceLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceLocation')), opt=True)
    _GNSS_CommonAssistData_gnss_IonosphericModel = SEQ(name='gnss-IonosphericModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-IonosphericModel')), opt=True)
    _GNSS_CommonAssistData_gnss_EarthOrientationParameters = SEQ(name='gnss-EarthOrientationParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-EarthOrientationParameters')), opt=True)
    GNSS_CommonAssistData._cont = ASN1Dict([
        ('gnss-ReferenceTime', _GNSS_CommonAssistData_gnss_ReferenceTime),
        ('gnss-ReferenceLocation', _GNSS_CommonAssistData_gnss_ReferenceLocation),
        ('gnss-IonosphericModel', _GNSS_CommonAssistData_gnss_IonosphericModel),
        ('gnss-EarthOrientationParameters', _GNSS_CommonAssistData_gnss_EarthOrientationParameters),
        ])
    GNSS_CommonAssistData._ext = []
    
    #-----< GNSS-GenericAssistData >-----#
    GNSS_GenericAssistData = SEQ_OF(name='GNSS-GenericAssistData', mode=MODE_TYPE)
    _GNSS_GenericAssistData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-GenericAssistDataElement')))
    GNSS_GenericAssistData._cont = _GNSS_GenericAssistData__item_
    GNSS_GenericAssistData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GNSS-GenericAssistDataElement >-----#
    GNSS_GenericAssistDataElement = SEQ(name='GNSS-GenericAssistDataElement', mode=MODE_TYPE)
    _GNSS_GenericAssistDataElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_GenericAssistDataElement_sbas_ID = SEQ(name='sbas-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SBAS-ID')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_TimeModels = SEQ_OF(name='gnss-TimeModels', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-TimeModelList')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_DifferentialCorrections = SEQ(name='gnss-DifferentialCorrections', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DifferentialCorrections')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_NavigationModel = SEQ(name='gnss-NavigationModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-NavigationModel')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_RealTimeIntegrity = SEQ(name='gnss-RealTimeIntegrity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-RealTimeIntegrity')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_DataBitAssistance = SEQ(name='gnss-DataBitAssistance', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitAssistance')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_AcquisitionAssistance = SEQ(name='gnss-AcquisitionAssistance', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AcquisitionAssistance')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_Almanac = SEQ(name='gnss-Almanac', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-Almanac')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_UTC_Model = CHOICE(name='gnss-UTC-Model', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-UTC-Model')), opt=True)
    _GNSS_GenericAssistDataElement_gnss_AuxiliaryInformation = CHOICE(name='gnss-AuxiliaryInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AuxiliaryInformation')), opt=True)
    _GNSS_GenericAssistDataElement_bds_DifferentialCorrections_r12 = SEQ(name='bds-DifferentialCorrections-r12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-DifferentialCorrections-r12')), opt=True, group=0)
    _GNSS_GenericAssistDataElement_bds_GridModel_r12 = SEQ(name='bds-GridModel-r12', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-GridModelParameter-r12')), opt=True, group=0)
    GNSS_GenericAssistDataElement._cont = ASN1Dict([
        ('gnss-ID', _GNSS_GenericAssistDataElement_gnss_ID),
        ('sbas-ID', _GNSS_GenericAssistDataElement_sbas_ID),
        ('gnss-TimeModels', _GNSS_GenericAssistDataElement_gnss_TimeModels),
        ('gnss-DifferentialCorrections', _GNSS_GenericAssistDataElement_gnss_DifferentialCorrections),
        ('gnss-NavigationModel', _GNSS_GenericAssistDataElement_gnss_NavigationModel),
        ('gnss-RealTimeIntegrity', _GNSS_GenericAssistDataElement_gnss_RealTimeIntegrity),
        ('gnss-DataBitAssistance', _GNSS_GenericAssistDataElement_gnss_DataBitAssistance),
        ('gnss-AcquisitionAssistance', _GNSS_GenericAssistDataElement_gnss_AcquisitionAssistance),
        ('gnss-Almanac', _GNSS_GenericAssistDataElement_gnss_Almanac),
        ('gnss-UTC-Model', _GNSS_GenericAssistDataElement_gnss_UTC_Model),
        ('gnss-AuxiliaryInformation', _GNSS_GenericAssistDataElement_gnss_AuxiliaryInformation),
        ('bds-DifferentialCorrections-r12', _GNSS_GenericAssistDataElement_bds_DifferentialCorrections_r12),
        ('bds-GridModel-r12', _GNSS_GenericAssistDataElement_bds_GridModel_r12),
        ])
    GNSS_GenericAssistDataElement._ext = ['bds-DifferentialCorrections-r12', 'bds-GridModel-r12']
    
    #-----< GNSS-ReferenceTime >-----#
    GNSS_ReferenceTime = SEQ(name='GNSS-ReferenceTime', mode=MODE_TYPE)
    _GNSS_ReferenceTime_gnss_SystemTime = SEQ(name='gnss-SystemTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    _GNSS_ReferenceTime_referenceTimeUnc = INT(name='referenceTimeUnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_ReferenceTime_referenceTimeUnc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GNSS_ReferenceTime_gnss_ReferenceTimeForCells = SEQ_OF(name='gnss-ReferenceTimeForCells', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GNSS_ReferenceTime_gnss_ReferenceTimeForCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceTimeForOneCell')))
    _GNSS_ReferenceTime_gnss_ReferenceTimeForCells._cont = __GNSS_ReferenceTime_gnss_ReferenceTimeForCells__item_
    _GNSS_ReferenceTime_gnss_ReferenceTimeForCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    GNSS_ReferenceTime._cont = ASN1Dict([
        ('gnss-SystemTime', _GNSS_ReferenceTime_gnss_SystemTime),
        ('referenceTimeUnc', _GNSS_ReferenceTime_referenceTimeUnc),
        ('gnss-ReferenceTimeForCells', _GNSS_ReferenceTime_gnss_ReferenceTimeForCells),
        ])
    GNSS_ReferenceTime._ext = []
    
    #-----< GNSS-ReferenceTimeForOneCell >-----#
    GNSS_ReferenceTimeForOneCell = SEQ(name='GNSS-ReferenceTimeForOneCell', mode=MODE_TYPE)
    _GNSS_ReferenceTimeForOneCell_networkTime = SEQ(name='networkTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NetworkTime')))
    _GNSS_ReferenceTimeForOneCell_referenceTimeUnc = INT(name='referenceTimeUnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_ReferenceTimeForOneCell_referenceTimeUnc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GNSS_ReferenceTimeForOneCell_bsAlign = ENUM(name='bsAlign', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_ReferenceTimeForOneCell_bsAlign._cont = ASN1Dict([('true', 0)])
    _GNSS_ReferenceTimeForOneCell_bsAlign._ext = None
    GNSS_ReferenceTimeForOneCell._cont = ASN1Dict([
        ('networkTime', _GNSS_ReferenceTimeForOneCell_networkTime),
        ('referenceTimeUnc', _GNSS_ReferenceTimeForOneCell_referenceTimeUnc),
        ('bsAlign', _GNSS_ReferenceTimeForOneCell_bsAlign),
        ])
    GNSS_ReferenceTimeForOneCell._ext = []
    
    #-----< GNSS-SystemTime >-----#
    GNSS_SystemTime = SEQ(name='GNSS-SystemTime', mode=MODE_TYPE)
    _GNSS_SystemTime_gnss_TimeID = SEQ(name='gnss-TimeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_SystemTime_gnss_DayNumber = INT(name='gnss-DayNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SystemTime_gnss_DayNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _GNSS_SystemTime_gnss_TimeOfDay = INT(name='gnss-TimeOfDay', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SystemTime_gnss_TimeOfDay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GNSS_SystemTime_gnss_TimeOfDayFrac_msec = INT(name='gnss-TimeOfDayFrac-msec', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SystemTime_gnss_TimeOfDayFrac_msec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GNSS_SystemTime_notificationOfLeapSecond = BIT_STR(name='notificationOfLeapSecond', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SystemTime_notificationOfLeapSecond._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GNSS_SystemTime_gps_TOW_Assist = SEQ_OF(name='gps-TOW-Assist', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GPS-TOW-Assist')), opt=True)
    GNSS_SystemTime._cont = ASN1Dict([
        ('gnss-TimeID', _GNSS_SystemTime_gnss_TimeID),
        ('gnss-DayNumber', _GNSS_SystemTime_gnss_DayNumber),
        ('gnss-TimeOfDay', _GNSS_SystemTime_gnss_TimeOfDay),
        ('gnss-TimeOfDayFrac-msec', _GNSS_SystemTime_gnss_TimeOfDayFrac_msec),
        ('notificationOfLeapSecond', _GNSS_SystemTime_notificationOfLeapSecond),
        ('gps-TOW-Assist', _GNSS_SystemTime_gps_TOW_Assist),
        ])
    GNSS_SystemTime._ext = []
    
    #-----< GPS-TOW-Assist >-----#
    GPS_TOW_Assist = SEQ_OF(name='GPS-TOW-Assist', mode=MODE_TYPE)
    _GPS_TOW_Assist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GPS-TOW-AssistElement')))
    GPS_TOW_Assist._cont = _GPS_TOW_Assist__item_
    GPS_TOW_Assist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GPS-TOW-AssistElement >-----#
    GPS_TOW_AssistElement = SEQ(name='GPS-TOW-AssistElement', mode=MODE_TYPE)
    _GPS_TOW_AssistElement_satelliteID = INT(name='satelliteID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_AssistElement_satelliteID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _GPS_TOW_AssistElement_tlmWord = INT(name='tlmWord', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_AssistElement_tlmWord._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _GPS_TOW_AssistElement_antiSpoof = INT(name='antiSpoof', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_AssistElement_antiSpoof._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _GPS_TOW_AssistElement_alert = INT(name='alert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_AssistElement_alert._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _GPS_TOW_AssistElement_tlmRsvdBits = INT(name='tlmRsvdBits', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_AssistElement_tlmRsvdBits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    GPS_TOW_AssistElement._cont = ASN1Dict([
        ('satelliteID', _GPS_TOW_AssistElement_satelliteID),
        ('tlmWord', _GPS_TOW_AssistElement_tlmWord),
        ('antiSpoof', _GPS_TOW_AssistElement_antiSpoof),
        ('alert', _GPS_TOW_AssistElement_alert),
        ('tlmRsvdBits', _GPS_TOW_AssistElement_tlmRsvdBits),
        ])
    GPS_TOW_AssistElement._ext = []
    
    #-----< NetworkTime >-----#
    NetworkTime = SEQ(name='NetworkTime', mode=MODE_TYPE)
    _NetworkTime_secondsFromFrameStructureStart = INT(name='secondsFromFrameStructureStart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NetworkTime_secondsFromFrameStructureStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12533)], ev=None, er=[])
    _NetworkTime_fractionalSecondsFromFrameStructureStart = INT(name='fractionalSecondsFromFrameStructureStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NetworkTime_fractionalSecondsFromFrameStructureStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3999999)], ev=None, er=[])
    _NetworkTime_frameDrift = INT(name='frameDrift', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NetworkTime_frameDrift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _NetworkTime_cellID = CHOICE(name='cellID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NetworkTime_cellID_eUTRA = SEQ(name='eUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NetworkTime_cellID_eUTRA_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NetworkTime_cellID_eUTRA_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    ___NetworkTime_cellID_eUTRA_cellGlobalIdEUTRA = SEQ(name='cellGlobalIdEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    ___NetworkTime_cellID_eUTRA_earfcn = INT(name='earfcn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')))
    ___NetworkTime_cellID_eUTRA_earfcn_v9a0 = INT(name='earfcn-v9a0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA-v9a0')), opt=True, group=0)
    __NetworkTime_cellID_eUTRA._cont = ASN1Dict([
        ('physCellId', ___NetworkTime_cellID_eUTRA_physCellId),
        ('cellGlobalIdEUTRA', ___NetworkTime_cellID_eUTRA_cellGlobalIdEUTRA),
        ('earfcn', ___NetworkTime_cellID_eUTRA_earfcn),
        ('earfcn-v9a0', ___NetworkTime_cellID_eUTRA_earfcn_v9a0),
        ])
    __NetworkTime_cellID_eUTRA._ext = ['earfcn-v9a0']
    __NetworkTime_cellID_uTRA = SEQ(name='uTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NetworkTime_cellID_uTRA_mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____NetworkTime_cellID_uTRA_mode_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____NetworkTime_cellID_uTRA_mode_fdd_primary_CPICH_Info = INT(name='primary-CPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____NetworkTime_cellID_uTRA_mode_fdd_primary_CPICH_Info._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    ____NetworkTime_cellID_uTRA_mode_fdd._cont = ASN1Dict([
        ('primary-CPICH-Info', _____NetworkTime_cellID_uTRA_mode_fdd_primary_CPICH_Info),
        ])
    ____NetworkTime_cellID_uTRA_mode_fdd._ext = []
    ____NetworkTime_cellID_uTRA_mode_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____NetworkTime_cellID_uTRA_mode_tdd_cellParameters = INT(name='cellParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____NetworkTime_cellID_uTRA_mode_tdd_cellParameters._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ____NetworkTime_cellID_uTRA_mode_tdd._cont = ASN1Dict([
        ('cellParameters', _____NetworkTime_cellID_uTRA_mode_tdd_cellParameters),
        ])
    ____NetworkTime_cellID_uTRA_mode_tdd._ext = []
    ___NetworkTime_cellID_uTRA_mode._cont = ASN1Dict([
        ('fdd', ____NetworkTime_cellID_uTRA_mode_fdd),
        ('tdd', ____NetworkTime_cellID_uTRA_mode_tdd),
        ])
    ___NetworkTime_cellID_uTRA_mode._ext = None
    ___NetworkTime_cellID_uTRA_cellGlobalIdUTRA = SEQ(name='cellGlobalIdUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    ___NetworkTime_cellID_uTRA_uarfcn = INT(name='uarfcn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')))
    __NetworkTime_cellID_uTRA._cont = ASN1Dict([
        ('mode', ___NetworkTime_cellID_uTRA_mode),
        ('cellGlobalIdUTRA', ___NetworkTime_cellID_uTRA_cellGlobalIdUTRA),
        ('uarfcn', ___NetworkTime_cellID_uTRA_uarfcn),
        ])
    __NetworkTime_cellID_uTRA._ext = []
    __NetworkTime_cellID_gSM = SEQ(name='gSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NetworkTime_cellID_gSM_bcchCarrier = INT(name='bcchCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NetworkTime_cellID_gSM_bcchCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    ___NetworkTime_cellID_gSM_bsic = INT(name='bsic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NetworkTime_cellID_gSM_bsic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    ___NetworkTime_cellID_gSM_cellGlobalIdGERAN = SEQ(name='cellGlobalIdGERAN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdGERAN')), opt=True)
    __NetworkTime_cellID_gSM._cont = ASN1Dict([
        ('bcchCarrier', ___NetworkTime_cellID_gSM_bcchCarrier),
        ('bsic', ___NetworkTime_cellID_gSM_bsic),
        ('cellGlobalIdGERAN', ___NetworkTime_cellID_gSM_cellGlobalIdGERAN),
        ])
    __NetworkTime_cellID_gSM._ext = []
    _NetworkTime_cellID._cont = ASN1Dict([
        ('eUTRA', __NetworkTime_cellID_eUTRA),
        ('uTRA', __NetworkTime_cellID_uTRA),
        ('gSM', __NetworkTime_cellID_gSM),
        ])
    _NetworkTime_cellID._ext = []
    NetworkTime._cont = ASN1Dict([
        ('secondsFromFrameStructureStart', _NetworkTime_secondsFromFrameStructureStart),
        ('fractionalSecondsFromFrameStructureStart', _NetworkTime_fractionalSecondsFromFrameStructureStart),
        ('frameDrift', _NetworkTime_frameDrift),
        ('cellID', _NetworkTime_cellID),
        ])
    NetworkTime._ext = []
    
    #-----< GNSS-ReferenceLocation >-----#
    GNSS_ReferenceLocation = SEQ(name='GNSS-ReferenceLocation', mode=MODE_TYPE)
    _GNSS_ReferenceLocation_threeDlocation = SEQ(name='threeDlocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')))
    GNSS_ReferenceLocation._cont = ASN1Dict([
        ('threeDlocation', _GNSS_ReferenceLocation_threeDlocation),
        ])
    GNSS_ReferenceLocation._ext = []
    
    #-----< GNSS-IonosphericModel >-----#
    GNSS_IonosphericModel = SEQ(name='GNSS-IonosphericModel', mode=MODE_TYPE)
    _GNSS_IonosphericModel_klobucharModel = SEQ(name='klobucharModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'KlobucharModelParameter')), opt=True)
    _GNSS_IonosphericModel_neQuickModel = SEQ(name='neQuickModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NeQuickModelParameter')), opt=True)
    GNSS_IonosphericModel._cont = ASN1Dict([
        ('klobucharModel', _GNSS_IonosphericModel_klobucharModel),
        ('neQuickModel', _GNSS_IonosphericModel_neQuickModel),
        ])
    GNSS_IonosphericModel._ext = []
    
    #-----< KlobucharModelParameter >-----#
    KlobucharModelParameter = SEQ(name='KlobucharModelParameter', mode=MODE_TYPE)
    _KlobucharModelParameter_dataID = BIT_STR(name='dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_dataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _KlobucharModelParameter_alfa0 = INT(name='alfa0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_alfa0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_alfa1 = INT(name='alfa1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_alfa1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_alfa2 = INT(name='alfa2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_alfa2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_alfa3 = INT(name='alfa3', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_alfa3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_beta0 = INT(name='beta0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_beta0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_beta1 = INT(name='beta1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_beta1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_beta2 = INT(name='beta2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_beta2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _KlobucharModelParameter_beta3 = INT(name='beta3', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _KlobucharModelParameter_beta3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    KlobucharModelParameter._cont = ASN1Dict([
        ('dataID', _KlobucharModelParameter_dataID),
        ('alfa0', _KlobucharModelParameter_alfa0),
        ('alfa1', _KlobucharModelParameter_alfa1),
        ('alfa2', _KlobucharModelParameter_alfa2),
        ('alfa3', _KlobucharModelParameter_alfa3),
        ('beta0', _KlobucharModelParameter_beta0),
        ('beta1', _KlobucharModelParameter_beta1),
        ('beta2', _KlobucharModelParameter_beta2),
        ('beta3', _KlobucharModelParameter_beta3),
        ])
    KlobucharModelParameter._ext = []
    
    #-----< NeQuickModelParameter >-----#
    NeQuickModelParameter = SEQ(name='NeQuickModelParameter', mode=MODE_TYPE)
    _NeQuickModelParameter_ai0 = INT(name='ai0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NeQuickModelParameter_ai0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _NeQuickModelParameter_ai1 = INT(name='ai1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NeQuickModelParameter_ai1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _NeQuickModelParameter_ai2 = INT(name='ai2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NeQuickModelParameter_ai2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8192, ub=8191)], ev=None, er=[])
    _NeQuickModelParameter_ionoStormFlag1 = INT(name='ionoStormFlag1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NeQuickModelParameter_ionoStormFlag1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _NeQuickModelParameter_ionoStormFlag2 = INT(name='ionoStormFlag2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NeQuickModelParameter_ionoStormFlag2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _NeQuickModelParameter_ionoStormFlag3 = INT(name='ionoStormFlag3', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NeQuickModelParameter_ionoStormFlag3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _NeQuickModelParameter_ionoStormFlag4 = INT(name='ionoStormFlag4', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NeQuickModelParameter_ionoStormFlag4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _NeQuickModelParameter_ionoStormFlag5 = INT(name='ionoStormFlag5', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NeQuickModelParameter_ionoStormFlag5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    NeQuickModelParameter._cont = ASN1Dict([
        ('ai0', _NeQuickModelParameter_ai0),
        ('ai1', _NeQuickModelParameter_ai1),
        ('ai2', _NeQuickModelParameter_ai2),
        ('ionoStormFlag1', _NeQuickModelParameter_ionoStormFlag1),
        ('ionoStormFlag2', _NeQuickModelParameter_ionoStormFlag2),
        ('ionoStormFlag3', _NeQuickModelParameter_ionoStormFlag3),
        ('ionoStormFlag4', _NeQuickModelParameter_ionoStormFlag4),
        ('ionoStormFlag5', _NeQuickModelParameter_ionoStormFlag5),
        ])
    NeQuickModelParameter._ext = []
    
    #-----< GNSS-EarthOrientationParameters >-----#
    GNSS_EarthOrientationParameters = SEQ(name='GNSS-EarthOrientationParameters', mode=MODE_TYPE)
    _GNSS_EarthOrientationParameters_teop = INT(name='teop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_teop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GNSS_EarthOrientationParameters_pmX = INT(name='pmX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_pmX._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1048576, ub=1048575)], ev=None, er=[])
    _GNSS_EarthOrientationParameters_pmXdot = INT(name='pmXdot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_pmXdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16384, ub=16383)], ev=None, er=[])
    _GNSS_EarthOrientationParameters_pmY = INT(name='pmY', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_pmY._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1048576, ub=1048575)], ev=None, er=[])
    _GNSS_EarthOrientationParameters_pmYdot = INT(name='pmYdot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_pmYdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16384, ub=16383)], ev=None, er=[])
    _GNSS_EarthOrientationParameters_deltaUT1 = INT(name='deltaUT1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_deltaUT1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1073741824, ub=1073741823)], ev=None, er=[])
    _GNSS_EarthOrientationParameters_deltaUT1dot = INT(name='deltaUT1dot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_EarthOrientationParameters_deltaUT1dot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-262144, ub=262143)], ev=None, er=[])
    GNSS_EarthOrientationParameters._cont = ASN1Dict([
        ('teop', _GNSS_EarthOrientationParameters_teop),
        ('pmX', _GNSS_EarthOrientationParameters_pmX),
        ('pmXdot', _GNSS_EarthOrientationParameters_pmXdot),
        ('pmY', _GNSS_EarthOrientationParameters_pmY),
        ('pmYdot', _GNSS_EarthOrientationParameters_pmYdot),
        ('deltaUT1', _GNSS_EarthOrientationParameters_deltaUT1),
        ('deltaUT1dot', _GNSS_EarthOrientationParameters_deltaUT1dot),
        ])
    GNSS_EarthOrientationParameters._ext = []
    
    #-----< GNSS-TimeModelList >-----#
    GNSS_TimeModelList = SEQ_OF(name='GNSS-TimeModelList', mode=MODE_TYPE)
    _GNSS_TimeModelList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-TimeModelElement')))
    GNSS_TimeModelList._cont = _GNSS_TimeModelList__item_
    GNSS_TimeModelList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< GNSS-TimeModelElement >-----#
    GNSS_TimeModelElement = SEQ(name='GNSS-TimeModelElement', mode=MODE_TYPE)
    _GNSS_TimeModelElement_gnss_TimeModelRefTime = INT(name='gnss-TimeModelRefTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_TimeModelElement_gnss_TimeModelRefTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GNSS_TimeModelElement_tA0 = INT(name='tA0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_TimeModelElement_tA0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-67108864, ub=67108863)], ev=None, er=[])
    _GNSS_TimeModelElement_tA1 = INT(name='tA1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_TimeModelElement_tA1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _GNSS_TimeModelElement_tA2 = INT(name='tA2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_TimeModelElement_tA2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _GNSS_TimeModelElement_gnss_TO_ID = INT(name='gnss-TO-ID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_TimeModelElement_gnss_TO_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    _GNSS_TimeModelElement_weekNumber = INT(name='weekNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_TimeModelElement_weekNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GNSS_TimeModelElement_deltaT = INT(name='deltaT', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_TimeModelElement_deltaT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    GNSS_TimeModelElement._cont = ASN1Dict([
        ('gnss-TimeModelRefTime', _GNSS_TimeModelElement_gnss_TimeModelRefTime),
        ('tA0', _GNSS_TimeModelElement_tA0),
        ('tA1', _GNSS_TimeModelElement_tA1),
        ('tA2', _GNSS_TimeModelElement_tA2),
        ('gnss-TO-ID', _GNSS_TimeModelElement_gnss_TO_ID),
        ('weekNumber', _GNSS_TimeModelElement_weekNumber),
        ('deltaT', _GNSS_TimeModelElement_deltaT),
        ])
    GNSS_TimeModelElement._ext = []
    
    #-----< GNSS-DifferentialCorrections >-----#
    GNSS_DifferentialCorrections = SEQ(name='GNSS-DifferentialCorrections', mode=MODE_TYPE)
    _GNSS_DifferentialCorrections_dgnss_RefTime = INT(name='dgnss-RefTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_DifferentialCorrections_dgnss_RefTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _GNSS_DifferentialCorrections_dgnss_SgnTypeList = SEQ_OF(name='dgnss-SgnTypeList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'DGNSS-SgnTypeList')))
    GNSS_DifferentialCorrections._cont = ASN1Dict([
        ('dgnss-RefTime', _GNSS_DifferentialCorrections_dgnss_RefTime),
        ('dgnss-SgnTypeList', _GNSS_DifferentialCorrections_dgnss_SgnTypeList),
        ])
    GNSS_DifferentialCorrections._ext = []
    
    #-----< DGNSS-SgnTypeList >-----#
    DGNSS_SgnTypeList = SEQ_OF(name='DGNSS-SgnTypeList', mode=MODE_TYPE)
    _DGNSS_SgnTypeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'DGNSS-SgnTypeElement')))
    DGNSS_SgnTypeList._cont = _DGNSS_SgnTypeList__item_
    DGNSS_SgnTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< DGNSS-SgnTypeElement >-----#
    DGNSS_SgnTypeElement = SEQ(name='DGNSS-SgnTypeElement', mode=MODE_TYPE)
    _DGNSS_SgnTypeElement_gnss_SignalID = SEQ(name='gnss-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _DGNSS_SgnTypeElement_gnss_StatusHealth = INT(name='gnss-StatusHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGNSS_SgnTypeElement_gnss_StatusHealth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _DGNSS_SgnTypeElement_dgnss_SatList = SEQ_OF(name='dgnss-SatList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'DGNSS-SatList')))
    DGNSS_SgnTypeElement._cont = ASN1Dict([
        ('gnss-SignalID', _DGNSS_SgnTypeElement_gnss_SignalID),
        ('gnss-StatusHealth', _DGNSS_SgnTypeElement_gnss_StatusHealth),
        ('dgnss-SatList', _DGNSS_SgnTypeElement_dgnss_SatList),
        ])
    DGNSS_SgnTypeElement._ext = []
    
    #-----< DGNSS-SatList >-----#
    DGNSS_SatList = SEQ_OF(name='DGNSS-SatList', mode=MODE_TYPE)
    _DGNSS_SatList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'DGNSS-CorrectionsElement')))
    DGNSS_SatList._cont = _DGNSS_SatList__item_
    DGNSS_SatList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DGNSS-CorrectionsElement >-----#
    DGNSS_CorrectionsElement = SEQ(name='DGNSS-CorrectionsElement', mode=MODE_TYPE)
    _DGNSS_CorrectionsElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _DGNSS_CorrectionsElement_iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGNSS_CorrectionsElement_iod._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _DGNSS_CorrectionsElement_udre = INT(name='udre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGNSS_CorrectionsElement_udre._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _DGNSS_CorrectionsElement_pseudoRangeCor = INT(name='pseudoRangeCor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGNSS_CorrectionsElement_pseudoRangeCor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    _DGNSS_CorrectionsElement_rangeRateCor = INT(name='rangeRateCor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGNSS_CorrectionsElement_rangeRateCor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    _DGNSS_CorrectionsElement_udreGrowthRate = INT(name='udreGrowthRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DGNSS_CorrectionsElement_udreGrowthRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _DGNSS_CorrectionsElement_udreValidityTime = INT(name='udreValidityTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DGNSS_CorrectionsElement_udreValidityTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    DGNSS_CorrectionsElement._cont = ASN1Dict([
        ('svID', _DGNSS_CorrectionsElement_svID),
        ('iod', _DGNSS_CorrectionsElement_iod),
        ('udre', _DGNSS_CorrectionsElement_udre),
        ('pseudoRangeCor', _DGNSS_CorrectionsElement_pseudoRangeCor),
        ('rangeRateCor', _DGNSS_CorrectionsElement_rangeRateCor),
        ('udreGrowthRate', _DGNSS_CorrectionsElement_udreGrowthRate),
        ('udreValidityTime', _DGNSS_CorrectionsElement_udreValidityTime),
        ])
    DGNSS_CorrectionsElement._ext = []
    
    #-----< GNSS-NavigationModel >-----#
    GNSS_NavigationModel = SEQ(name='GNSS-NavigationModel', mode=MODE_TYPE)
    _GNSS_NavigationModel_nonBroadcastIndFlag = INT(name='nonBroadcastIndFlag', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_NavigationModel_nonBroadcastIndFlag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _GNSS_NavigationModel_gnss_SatelliteList = SEQ_OF(name='gnss-SatelliteList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-NavModelSatelliteList')))
    GNSS_NavigationModel._cont = ASN1Dict([
        ('nonBroadcastIndFlag', _GNSS_NavigationModel_nonBroadcastIndFlag),
        ('gnss-SatelliteList', _GNSS_NavigationModel_gnss_SatelliteList),
        ])
    GNSS_NavigationModel._ext = []
    
    #-----< GNSS-NavModelSatelliteList >-----#
    GNSS_NavModelSatelliteList = SEQ_OF(name='GNSS-NavModelSatelliteList', mode=MODE_TYPE)
    _GNSS_NavModelSatelliteList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-NavModelSatelliteElement')))
    GNSS_NavModelSatelliteList._cont = _GNSS_NavModelSatelliteList__item_
    GNSS_NavModelSatelliteList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-NavModelSatelliteElement >-----#
    GNSS_NavModelSatelliteElement = SEQ(name='GNSS-NavModelSatelliteElement', mode=MODE_TYPE)
    _GNSS_NavModelSatelliteElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _GNSS_NavModelSatelliteElement_svHealth = BIT_STR(name='svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_NavModelSatelliteElement_svHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GNSS_NavModelSatelliteElement_iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_NavModelSatelliteElement_iod._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GNSS_NavModelSatelliteElement_gnss_ClockModel = CHOICE(name='gnss-ClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ClockModel')))
    _GNSS_NavModelSatelliteElement_gnss_OrbitModel = CHOICE(name='gnss-OrbitModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-OrbitModel')))
    _GNSS_NavModelSatelliteElement_svHealthExt_v1240 = BIT_STR(name='svHealthExt-v1240', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True, group=0)
    _GNSS_NavModelSatelliteElement_svHealthExt_v1240._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    GNSS_NavModelSatelliteElement._cont = ASN1Dict([
        ('svID', _GNSS_NavModelSatelliteElement_svID),
        ('svHealth', _GNSS_NavModelSatelliteElement_svHealth),
        ('iod', _GNSS_NavModelSatelliteElement_iod),
        ('gnss-ClockModel', _GNSS_NavModelSatelliteElement_gnss_ClockModel),
        ('gnss-OrbitModel', _GNSS_NavModelSatelliteElement_gnss_OrbitModel),
        ('svHealthExt-v1240', _GNSS_NavModelSatelliteElement_svHealthExt_v1240),
        ])
    GNSS_NavModelSatelliteElement._ext = ['svHealthExt-v1240']
    
    #-----< GNSS-ClockModel >-----#
    GNSS_ClockModel = CHOICE(name='GNSS-ClockModel', mode=MODE_TYPE)
    _GNSS_ClockModel_standardClockModelList = SEQ_OF(name='standardClockModelList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'StandardClockModelList')))
    _GNSS_ClockModel_nav_ClockModel = SEQ(name='nav-ClockModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NAV-ClockModel')))
    _GNSS_ClockModel_cnav_ClockModel = SEQ(name='cnav-ClockModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CNAV-ClockModel')))
    _GNSS_ClockModel_glonass_ClockModel = SEQ(name='glonass-ClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GLONASS-ClockModel')))
    _GNSS_ClockModel_sbas_ClockModel = SEQ(name='sbas-ClockModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SBAS-ClockModel')))
    _GNSS_ClockModel_bds_ClockModel_r12 = SEQ(name='bds-ClockModel-r12', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-ClockModel-r12')))
    GNSS_ClockModel._cont = ASN1Dict([
        ('standardClockModelList', _GNSS_ClockModel_standardClockModelList),
        ('nav-ClockModel', _GNSS_ClockModel_nav_ClockModel),
        ('cnav-ClockModel', _GNSS_ClockModel_cnav_ClockModel),
        ('glonass-ClockModel', _GNSS_ClockModel_glonass_ClockModel),
        ('sbas-ClockModel', _GNSS_ClockModel_sbas_ClockModel),
        ('bds-ClockModel-r12', _GNSS_ClockModel_bds_ClockModel_r12),
        ])
    GNSS_ClockModel._ext = ['bds-ClockModel-r12']
    
    #-----< GNSS-OrbitModel >-----#
    GNSS_OrbitModel = CHOICE(name='GNSS-OrbitModel', mode=MODE_TYPE)
    _GNSS_OrbitModel_keplerianSet = SEQ(name='keplerianSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NavModelKeplerianSet')))
    _GNSS_OrbitModel_nav_KeplerianSet = SEQ(name='nav-KeplerianSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NavModelNAV-KeplerianSet')))
    _GNSS_OrbitModel_cnav_KeplerianSet = SEQ(name='cnav-KeplerianSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NavModelCNAV-KeplerianSet')))
    _GNSS_OrbitModel_glonass_ECEF = SEQ(name='glonass-ECEF', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NavModel-GLONASS-ECEF')))
    _GNSS_OrbitModel_sbas_ECEF = SEQ(name='sbas-ECEF', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NavModel-SBAS-ECEF')))
    _GNSS_OrbitModel_bds_KeplerianSet_r12 = SEQ(name='bds-KeplerianSet-r12', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NavModel-BDS-KeplerianSet-r12')))
    GNSS_OrbitModel._cont = ASN1Dict([
        ('keplerianSet', _GNSS_OrbitModel_keplerianSet),
        ('nav-KeplerianSet', _GNSS_OrbitModel_nav_KeplerianSet),
        ('cnav-KeplerianSet', _GNSS_OrbitModel_cnav_KeplerianSet),
        ('glonass-ECEF', _GNSS_OrbitModel_glonass_ECEF),
        ('sbas-ECEF', _GNSS_OrbitModel_sbas_ECEF),
        ('bds-KeplerianSet-r12', _GNSS_OrbitModel_bds_KeplerianSet_r12),
        ])
    GNSS_OrbitModel._ext = ['bds-KeplerianSet-r12']
    
    #-----< StandardClockModelList >-----#
    StandardClockModelList = SEQ_OF(name='StandardClockModelList', mode=MODE_TYPE)
    _StandardClockModelList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'StandardClockModelElement')))
    StandardClockModelList._cont = _StandardClockModelList__item_
    StandardClockModelList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< StandardClockModelElement >-----#
    StandardClockModelElement = SEQ(name='StandardClockModelElement', mode=MODE_TYPE)
    _StandardClockModelElement_stanClockToc = INT(name='stanClockToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StandardClockModelElement_stanClockToc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _StandardClockModelElement_stanClockAF2 = INT(name='stanClockAF2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StandardClockModelElement_stanClockAF2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32, ub=31)], ev=None, er=[])
    _StandardClockModelElement_stanClockAF1 = INT(name='stanClockAF1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StandardClockModelElement_stanClockAF1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1048576, ub=1048575)], ev=None, er=[])
    _StandardClockModelElement_stanClockAF0 = INT(name='stanClockAF0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StandardClockModelElement_stanClockAF0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1073741824, ub=1073741823)], ev=None, er=[])
    _StandardClockModelElement_stanClockTgd = INT(name='stanClockTgd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _StandardClockModelElement_stanClockTgd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _StandardClockModelElement_sisa = INT(name='sisa', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StandardClockModelElement_sisa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _StandardClockModelElement_stanModelID = INT(name='stanModelID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _StandardClockModelElement_stanModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    StandardClockModelElement._cont = ASN1Dict([
        ('stanClockToc', _StandardClockModelElement_stanClockToc),
        ('stanClockAF2', _StandardClockModelElement_stanClockAF2),
        ('stanClockAF1', _StandardClockModelElement_stanClockAF1),
        ('stanClockAF0', _StandardClockModelElement_stanClockAF0),
        ('stanClockTgd', _StandardClockModelElement_stanClockTgd),
        ('sisa', _StandardClockModelElement_sisa),
        ('stanModelID', _StandardClockModelElement_stanModelID),
        ])
    StandardClockModelElement._ext = []
    
    #-----< NAV-ClockModel >-----#
    NAV_ClockModel = SEQ(name='NAV-ClockModel', mode=MODE_TYPE)
    _NAV_ClockModel_navToc = INT(name='navToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAV_ClockModel_navToc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37799)], ev=None, er=[])
    _NAV_ClockModel_navaf2 = INT(name='navaf2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAV_ClockModel_navaf2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _NAV_ClockModel_navaf1 = INT(name='navaf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAV_ClockModel_navaf1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NAV_ClockModel_navaf0 = INT(name='navaf0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAV_ClockModel_navaf0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2097152, ub=2097151)], ev=None, er=[])
    _NAV_ClockModel_navTgd = INT(name='navTgd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAV_ClockModel_navTgd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    NAV_ClockModel._cont = ASN1Dict([
        ('navToc', _NAV_ClockModel_navToc),
        ('navaf2', _NAV_ClockModel_navaf2),
        ('navaf1', _NAV_ClockModel_navaf1),
        ('navaf0', _NAV_ClockModel_navaf0),
        ('navTgd', _NAV_ClockModel_navTgd),
        ])
    NAV_ClockModel._ext = []
    
    #-----< CNAV-ClockModel >-----#
    CNAV_ClockModel = SEQ(name='CNAV-ClockModel', mode=MODE_TYPE)
    _CNAV_ClockModel_cnavToc = INT(name='cnavToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavToc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2015)], ev=None, er=[])
    _CNAV_ClockModel_cnavTop = INT(name='cnavTop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavTop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2015)], ev=None, er=[])
    _CNAV_ClockModel_cnavURA0 = INT(name='cnavURA0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavURA0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=15)], ev=None, er=[])
    _CNAV_ClockModel_cnavURA1 = INT(name='cnavURA1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavURA1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _CNAV_ClockModel_cnavURA2 = INT(name='cnavURA2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavURA2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _CNAV_ClockModel_cnavAf2 = INT(name='cnavAf2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavAf2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _CNAV_ClockModel_cnavAf1 = INT(name='cnavAf1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavAf1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-524288, ub=524287)], ev=None, er=[])
    _CNAV_ClockModel_cnavAf0 = INT(name='cnavAf0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavAf0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-33554432, ub=33554431)], ev=None, er=[])
    _CNAV_ClockModel_cnavTgd = INT(name='cnavTgd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAV_ClockModel_cnavTgd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _CNAV_ClockModel_cnavISCl1cp = INT(name='cnavISCl1cp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAV_ClockModel_cnavISCl1cp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _CNAV_ClockModel_cnavISCl1cd = INT(name='cnavISCl1cd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAV_ClockModel_cnavISCl1cd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _CNAV_ClockModel_cnavISCl1ca = INT(name='cnavISCl1ca', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAV_ClockModel_cnavISCl1ca._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _CNAV_ClockModel_cnavISCl2c = INT(name='cnavISCl2c', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAV_ClockModel_cnavISCl2c._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _CNAV_ClockModel_cnavISCl5i5 = INT(name='cnavISCl5i5', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAV_ClockModel_cnavISCl5i5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _CNAV_ClockModel_cnavISCl5q5 = INT(name='cnavISCl5q5', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAV_ClockModel_cnavISCl5q5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    CNAV_ClockModel._cont = ASN1Dict([
        ('cnavToc', _CNAV_ClockModel_cnavToc),
        ('cnavTop', _CNAV_ClockModel_cnavTop),
        ('cnavURA0', _CNAV_ClockModel_cnavURA0),
        ('cnavURA1', _CNAV_ClockModel_cnavURA1),
        ('cnavURA2', _CNAV_ClockModel_cnavURA2),
        ('cnavAf2', _CNAV_ClockModel_cnavAf2),
        ('cnavAf1', _CNAV_ClockModel_cnavAf1),
        ('cnavAf0', _CNAV_ClockModel_cnavAf0),
        ('cnavTgd', _CNAV_ClockModel_cnavTgd),
        ('cnavISCl1cp', _CNAV_ClockModel_cnavISCl1cp),
        ('cnavISCl1cd', _CNAV_ClockModel_cnavISCl1cd),
        ('cnavISCl1ca', _CNAV_ClockModel_cnavISCl1ca),
        ('cnavISCl2c', _CNAV_ClockModel_cnavISCl2c),
        ('cnavISCl5i5', _CNAV_ClockModel_cnavISCl5i5),
        ('cnavISCl5q5', _CNAV_ClockModel_cnavISCl5q5),
        ])
    CNAV_ClockModel._ext = []
    
    #-----< GLONASS-ClockModel >-----#
    GLONASS_ClockModel = SEQ(name='GLONASS-ClockModel', mode=MODE_TYPE)
    _GLONASS_ClockModel_gloTau = INT(name='gloTau', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GLONASS_ClockModel_gloTau._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2097152, ub=2097151)], ev=None, er=[])
    _GLONASS_ClockModel_gloGamma = INT(name='gloGamma', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GLONASS_ClockModel_gloGamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _GLONASS_ClockModel_gloDeltaTau = INT(name='gloDeltaTau', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GLONASS_ClockModel_gloDeltaTau._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=15)], ev=None, er=[])
    GLONASS_ClockModel._cont = ASN1Dict([
        ('gloTau', _GLONASS_ClockModel_gloTau),
        ('gloGamma', _GLONASS_ClockModel_gloGamma),
        ('gloDeltaTau', _GLONASS_ClockModel_gloDeltaTau),
        ])
    GLONASS_ClockModel._ext = []
    
    #-----< SBAS-ClockModel >-----#
    SBAS_ClockModel = SEQ(name='SBAS-ClockModel', mode=MODE_TYPE)
    _SBAS_ClockModel_sbasTo = INT(name='sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBAS_ClockModel_sbasTo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5399)], ev=None, er=[])
    _SBAS_ClockModel_sbasAgfo = INT(name='sbasAgfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBAS_ClockModel_sbasAgfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2048, ub=2047)], ev=None, er=[])
    _SBAS_ClockModel_sbasAgf1 = INT(name='sbasAgf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBAS_ClockModel_sbasAgf1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    SBAS_ClockModel._cont = ASN1Dict([
        ('sbasTo', _SBAS_ClockModel_sbasTo),
        ('sbasAgfo', _SBAS_ClockModel_sbasAgfo),
        ('sbasAgf1', _SBAS_ClockModel_sbasAgf1),
        ])
    SBAS_ClockModel._ext = []
    
    #-----< BDS-ClockModel-r12 >-----#
    BDS_ClockModel_r12 = SEQ(name='BDS-ClockModel-r12', mode=MODE_TYPE)
    _BDS_ClockModel_r12_bdsAODC_r12 = INT(name='bdsAODC-r12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_ClockModel_r12_bdsAODC_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _BDS_ClockModel_r12_bdsToc_r12 = INT(name='bdsToc-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_ClockModel_r12_bdsToc_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    _BDS_ClockModel_r12_bdsA0_r12 = INT(name='bdsA0-r12', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_ClockModel_r12_bdsA0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _BDS_ClockModel_r12_bdsA1_r12 = INT(name='bdsA1-r12', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_ClockModel_r12_bdsA1_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2097152, ub=2097151)], ev=None, er=[])
    _BDS_ClockModel_r12_bdsA2_r12 = INT(name='bdsA2-r12', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_ClockModel_r12_bdsA2_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _BDS_ClockModel_r12_bdsTgd1_r12 = INT(name='bdsTgd1-r12', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_ClockModel_r12_bdsTgd1_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    BDS_ClockModel_r12._cont = ASN1Dict([
        ('bdsAODC-r12', _BDS_ClockModel_r12_bdsAODC_r12),
        ('bdsToc-r12', _BDS_ClockModel_r12_bdsToc_r12),
        ('bdsA0-r12', _BDS_ClockModel_r12_bdsA0_r12),
        ('bdsA1-r12', _BDS_ClockModel_r12_bdsA1_r12),
        ('bdsA2-r12', _BDS_ClockModel_r12_bdsA2_r12),
        ('bdsTgd1-r12', _BDS_ClockModel_r12_bdsTgd1_r12),
        ])
    BDS_ClockModel_r12._ext = []
    
    #-----< NavModelKeplerianSet >-----#
    NavModelKeplerianSet = SEQ(name='NavModelKeplerianSet', mode=MODE_TYPE)
    _NavModelKeplerianSet_keplerToe = INT(name='keplerToe', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerToe._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _NavModelKeplerianSet_keplerW = INT(name='keplerW', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerW._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelKeplerianSet_keplerDeltaN = INT(name='keplerDeltaN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerDeltaN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelKeplerianSet_keplerM0 = INT(name='keplerM0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerM0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelKeplerianSet_keplerOmegaDot = INT(name='keplerOmegaDot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerOmegaDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModelKeplerianSet_keplerE = INT(name='keplerE', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _NavModelKeplerianSet_keplerIDot = INT(name='keplerIDot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerIDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8192, ub=8191)], ev=None, er=[])
    _NavModelKeplerianSet_keplerAPowerHalf = INT(name='keplerAPowerHalf', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerAPowerHalf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _NavModelKeplerianSet_keplerI0 = INT(name='keplerI0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerI0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelKeplerianSet_keplerOmega0 = INT(name='keplerOmega0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerOmega0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelKeplerianSet_keplerCrs = INT(name='keplerCrs', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerCrs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelKeplerianSet_keplerCis = INT(name='keplerCis', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerCis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelKeplerianSet_keplerCus = INT(name='keplerCus', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerCus._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelKeplerianSet_keplerCrc = INT(name='keplerCrc', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerCrc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelKeplerianSet_keplerCic = INT(name='keplerCic', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerCic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelKeplerianSet_keplerCuc = INT(name='keplerCuc', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelKeplerianSet_keplerCuc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    NavModelKeplerianSet._cont = ASN1Dict([
        ('keplerToe', _NavModelKeplerianSet_keplerToe),
        ('keplerW', _NavModelKeplerianSet_keplerW),
        ('keplerDeltaN', _NavModelKeplerianSet_keplerDeltaN),
        ('keplerM0', _NavModelKeplerianSet_keplerM0),
        ('keplerOmegaDot', _NavModelKeplerianSet_keplerOmegaDot),
        ('keplerE', _NavModelKeplerianSet_keplerE),
        ('keplerIDot', _NavModelKeplerianSet_keplerIDot),
        ('keplerAPowerHalf', _NavModelKeplerianSet_keplerAPowerHalf),
        ('keplerI0', _NavModelKeplerianSet_keplerI0),
        ('keplerOmega0', _NavModelKeplerianSet_keplerOmega0),
        ('keplerCrs', _NavModelKeplerianSet_keplerCrs),
        ('keplerCis', _NavModelKeplerianSet_keplerCis),
        ('keplerCus', _NavModelKeplerianSet_keplerCus),
        ('keplerCrc', _NavModelKeplerianSet_keplerCrc),
        ('keplerCic', _NavModelKeplerianSet_keplerCic),
        ('keplerCuc', _NavModelKeplerianSet_keplerCuc),
        ])
    NavModelKeplerianSet._ext = []
    
    #-----< NavModelNAV-KeplerianSet >-----#
    NavModelNAV_KeplerianSet = SEQ(name='NavModelNAV-KeplerianSet', mode=MODE_TYPE)
    _NavModelNAV_KeplerianSet_navURA = INT(name='navURA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navURA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navFitFlag = INT(name='navFitFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navFitFlag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navToe = INT(name='navToe', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navToe._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37799)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navOmega = INT(name='navOmega', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navOmega._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navDeltaN = INT(name='navDeltaN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navDeltaN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navM0 = INT(name='navM0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navM0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navOmegaADot = INT(name='navOmegaADot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navOmegaADot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navE = INT(name='navE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navIDot = INT(name='navIDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navIDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8192, ub=8191)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navAPowerHalf = INT(name='navAPowerHalf', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navAPowerHalf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navI0 = INT(name='navI0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navI0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navOmegaA0 = INT(name='navOmegaA0', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navOmegaA0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navCrs = INT(name='navCrs', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navCrs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navCis = INT(name='navCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navCis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navCus = INT(name='navCus', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navCus._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navCrc = INT(name='navCrc', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navCrc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navCic = INT(name='navCic', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navCic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_navCuc = INT(name='navCuc', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelNAV_KeplerianSet_navCuc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_addNAVparam = SEQ(name='addNAVparam', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __NavModelNAV_KeplerianSet_addNAVparam_ephemCodeOnL2 = INT(name='ephemCodeOnL2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NavModelNAV_KeplerianSet_addNAVparam_ephemCodeOnL2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __NavModelNAV_KeplerianSet_addNAVparam_ephemL2Pflag = INT(name='ephemL2Pflag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NavModelNAV_KeplerianSet_addNAVparam_ephemL2Pflag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd = SEQ(name='ephemSF1Rsvd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved1 = INT(name='reserved1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved2 = INT(name='reserved2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved3 = INT(name='reserved3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved4 = INT(name='reserved4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd._cont = ASN1Dict([
        ('reserved1', ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved1),
        ('reserved2', ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved2),
        ('reserved3', ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved3),
        ('reserved4', ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved4),
        ])
    __NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd._ext = None
    __NavModelNAV_KeplerianSet_addNAVparam_ephemAODA = INT(name='ephemAODA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NavModelNAV_KeplerianSet_addNAVparam_ephemAODA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _NavModelNAV_KeplerianSet_addNAVparam._cont = ASN1Dict([
        ('ephemCodeOnL2', __NavModelNAV_KeplerianSet_addNAVparam_ephemCodeOnL2),
        ('ephemL2Pflag', __NavModelNAV_KeplerianSet_addNAVparam_ephemL2Pflag),
        ('ephemSF1Rsvd', __NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd),
        ('ephemAODA', __NavModelNAV_KeplerianSet_addNAVparam_ephemAODA),
        ])
    _NavModelNAV_KeplerianSet_addNAVparam._ext = None
    NavModelNAV_KeplerianSet._cont = ASN1Dict([
        ('navURA', _NavModelNAV_KeplerianSet_navURA),
        ('navFitFlag', _NavModelNAV_KeplerianSet_navFitFlag),
        ('navToe', _NavModelNAV_KeplerianSet_navToe),
        ('navOmega', _NavModelNAV_KeplerianSet_navOmega),
        ('navDeltaN', _NavModelNAV_KeplerianSet_navDeltaN),
        ('navM0', _NavModelNAV_KeplerianSet_navM0),
        ('navOmegaADot', _NavModelNAV_KeplerianSet_navOmegaADot),
        ('navE', _NavModelNAV_KeplerianSet_navE),
        ('navIDot', _NavModelNAV_KeplerianSet_navIDot),
        ('navAPowerHalf', _NavModelNAV_KeplerianSet_navAPowerHalf),
        ('navI0', _NavModelNAV_KeplerianSet_navI0),
        ('navOmegaA0', _NavModelNAV_KeplerianSet_navOmegaA0),
        ('navCrs', _NavModelNAV_KeplerianSet_navCrs),
        ('navCis', _NavModelNAV_KeplerianSet_navCis),
        ('navCus', _NavModelNAV_KeplerianSet_navCus),
        ('navCrc', _NavModelNAV_KeplerianSet_navCrc),
        ('navCic', _NavModelNAV_KeplerianSet_navCic),
        ('navCuc', _NavModelNAV_KeplerianSet_navCuc),
        ('addNAVparam', _NavModelNAV_KeplerianSet_addNAVparam),
        ])
    NavModelNAV_KeplerianSet._ext = []
    
    #-----< NavModelCNAV-KeplerianSet >-----#
    NavModelCNAV_KeplerianSet = SEQ(name='NavModelCNAV-KeplerianSet', mode=MODE_TYPE)
    _NavModelCNAV_KeplerianSet_cnavTop = INT(name='cnavTop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavTop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2015)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavURAindex = INT(name='cnavURAindex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavURAindex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=15)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavDeltaA = INT(name='cnavDeltaA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavDeltaA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-33554432, ub=33554431)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavAdot = INT(name='cnavAdot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavAdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16777216, ub=16777215)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavDeltaNo = INT(name='cnavDeltaNo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavDeltaNo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavDeltaNoDot = INT(name='cnavDeltaNoDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavDeltaNoDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4194304, ub=4194303)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavMo = INT(name='cnavMo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavMo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4294967296, ub=4294967295)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavE = INT(name='cnavE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8589934591)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavOmega = INT(name='cnavOmega', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavOmega._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4294967296, ub=4294967295)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavOMEGA0 = INT(name='cnavOMEGA0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavOMEGA0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4294967296, ub=4294967295)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavDeltaOmegaDot = INT(name='cnavDeltaOmegaDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavDeltaOmegaDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavIo = INT(name='cnavIo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavIo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4294967296, ub=4294967295)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavIoDot = INT(name='cnavIoDot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavIoDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16384, ub=16383)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavCis = INT(name='cnavCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavCis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavCic = INT(name='cnavCic', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavCic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavCrs = INT(name='cnavCrs', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavCrs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavCrc = INT(name='cnavCrc', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavCrc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavCus = INT(name='cnavCus', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavCus._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1048576, ub=1048575)], ev=None, er=[])
    _NavModelCNAV_KeplerianSet_cnavCuc = INT(name='cnavCuc', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelCNAV_KeplerianSet_cnavCuc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1048576, ub=1048575)], ev=None, er=[])
    NavModelCNAV_KeplerianSet._cont = ASN1Dict([
        ('cnavTop', _NavModelCNAV_KeplerianSet_cnavTop),
        ('cnavURAindex', _NavModelCNAV_KeplerianSet_cnavURAindex),
        ('cnavDeltaA', _NavModelCNAV_KeplerianSet_cnavDeltaA),
        ('cnavAdot', _NavModelCNAV_KeplerianSet_cnavAdot),
        ('cnavDeltaNo', _NavModelCNAV_KeplerianSet_cnavDeltaNo),
        ('cnavDeltaNoDot', _NavModelCNAV_KeplerianSet_cnavDeltaNoDot),
        ('cnavMo', _NavModelCNAV_KeplerianSet_cnavMo),
        ('cnavE', _NavModelCNAV_KeplerianSet_cnavE),
        ('cnavOmega', _NavModelCNAV_KeplerianSet_cnavOmega),
        ('cnavOMEGA0', _NavModelCNAV_KeplerianSet_cnavOMEGA0),
        ('cnavDeltaOmegaDot', _NavModelCNAV_KeplerianSet_cnavDeltaOmegaDot),
        ('cnavIo', _NavModelCNAV_KeplerianSet_cnavIo),
        ('cnavIoDot', _NavModelCNAV_KeplerianSet_cnavIoDot),
        ('cnavCis', _NavModelCNAV_KeplerianSet_cnavCis),
        ('cnavCic', _NavModelCNAV_KeplerianSet_cnavCic),
        ('cnavCrs', _NavModelCNAV_KeplerianSet_cnavCrs),
        ('cnavCrc', _NavModelCNAV_KeplerianSet_cnavCrc),
        ('cnavCus', _NavModelCNAV_KeplerianSet_cnavCus),
        ('cnavCuc', _NavModelCNAV_KeplerianSet_cnavCuc),
        ])
    NavModelCNAV_KeplerianSet._ext = []
    
    #-----< NavModel-GLONASS-ECEF >-----#
    NavModel_GLONASS_ECEF = SEQ(name='NavModel-GLONASS-ECEF', mode=MODE_TYPE)
    _NavModel_GLONASS_ECEF_gloEn = INT(name='gloEn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloEn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloP1 = BIT_STR(name='gloP1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloP1._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloP2 = BOOL(name='gloP2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloM = INT(name='gloM', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloX = INT(name='gloX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloX._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-67108864, ub=67108863)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloXdot = INT(name='gloXdot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloXdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloXdotdot = INT(name='gloXdotdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloXdotdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=15)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloY = INT(name='gloY', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloY._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-67108864, ub=67108863)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloYdot = INT(name='gloYdot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloYdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloYdotdot = INT(name='gloYdotdot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloYdotdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=15)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloZ = INT(name='gloZ', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloZ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-67108864, ub=67108863)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloZdot = INT(name='gloZdot', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloZdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModel_GLONASS_ECEF_gloZdotdot = INT(name='gloZdotdot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASS_ECEF_gloZdotdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=15)], ev=None, er=[])
    NavModel_GLONASS_ECEF._cont = ASN1Dict([
        ('gloEn', _NavModel_GLONASS_ECEF_gloEn),
        ('gloP1', _NavModel_GLONASS_ECEF_gloP1),
        ('gloP2', _NavModel_GLONASS_ECEF_gloP2),
        ('gloM', _NavModel_GLONASS_ECEF_gloM),
        ('gloX', _NavModel_GLONASS_ECEF_gloX),
        ('gloXdot', _NavModel_GLONASS_ECEF_gloXdot),
        ('gloXdotdot', _NavModel_GLONASS_ECEF_gloXdotdot),
        ('gloY', _NavModel_GLONASS_ECEF_gloY),
        ('gloYdot', _NavModel_GLONASS_ECEF_gloYdot),
        ('gloYdotdot', _NavModel_GLONASS_ECEF_gloYdotdot),
        ('gloZ', _NavModel_GLONASS_ECEF_gloZ),
        ('gloZdot', _NavModel_GLONASS_ECEF_gloZdot),
        ('gloZdotdot', _NavModel_GLONASS_ECEF_gloZdotdot),
        ])
    NavModel_GLONASS_ECEF._ext = []
    
    #-----< NavModel-SBAS-ECEF >-----#
    NavModel_SBAS_ECEF = SEQ(name='NavModel-SBAS-ECEF', mode=MODE_TYPE)
    _NavModel_SBAS_ECEF_sbasTo = INT(name='sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NavModel_SBAS_ECEF_sbasTo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5399)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasAccuracy = BIT_STR(name='sbasAccuracy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasAccuracy._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasXg = INT(name='sbasXg', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasXg._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-536870912, ub=536870911)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasYg = INT(name='sbasYg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasYg._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-536870912, ub=536870911)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasZg = INT(name='sbasZg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasZg._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16777216, ub=16777215)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasXgDot = INT(name='sbasXgDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasXgDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasYgDot = INT(name='sbasYgDot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasYgDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasZgDot = INT(name='sbasZgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasZgDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasXgDotDot = INT(name='sbasXgDotDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasXgDotDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbagYgDotDot = INT(name='sbagYgDotDot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbagYgDotDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _NavModel_SBAS_ECEF_sbasZgDotDot = INT(name='sbasZgDotDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBAS_ECEF_sbasZgDotDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    NavModel_SBAS_ECEF._cont = ASN1Dict([
        ('sbasTo', _NavModel_SBAS_ECEF_sbasTo),
        ('sbasAccuracy', _NavModel_SBAS_ECEF_sbasAccuracy),
        ('sbasXg', _NavModel_SBAS_ECEF_sbasXg),
        ('sbasYg', _NavModel_SBAS_ECEF_sbasYg),
        ('sbasZg', _NavModel_SBAS_ECEF_sbasZg),
        ('sbasXgDot', _NavModel_SBAS_ECEF_sbasXgDot),
        ('sbasYgDot', _NavModel_SBAS_ECEF_sbasYgDot),
        ('sbasZgDot', _NavModel_SBAS_ECEF_sbasZgDot),
        ('sbasXgDotDot', _NavModel_SBAS_ECEF_sbasXgDotDot),
        ('sbagYgDotDot', _NavModel_SBAS_ECEF_sbagYgDotDot),
        ('sbasZgDotDot', _NavModel_SBAS_ECEF_sbasZgDotDot),
        ])
    NavModel_SBAS_ECEF._ext = []
    
    #-----< NavModel-BDS-KeplerianSet-r12 >-----#
    NavModel_BDS_KeplerianSet_r12 = SEQ(name='NavModel-BDS-KeplerianSet-r12', mode=MODE_TYPE)
    _NavModel_BDS_KeplerianSet_r12_bdsAODE_r12 = INT(name='bdsAODE-r12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsAODE_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsURAI_r12 = INT(name='bdsURAI-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsURAI_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsToe_r12 = INT(name='bdsToe-r12', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsToe_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsAPowerHalf_r12 = INT(name='bdsAPowerHalf-r12', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsAPowerHalf_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsE_r12 = INT(name='bdsE-r12', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsE_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsW_r12 = INT(name='bdsW-r12', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsW_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsDeltaN_r12 = INT(name='bdsDeltaN-r12', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsDeltaN_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsM0_r12 = INT(name='bdsM0-r12', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsM0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsOmega0_r12 = INT(name='bdsOmega0-r12', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsOmega0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsOmegaDot_r12 = INT(name='bdsOmegaDot-r12', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsOmegaDot_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsI0_r12 = INT(name='bdsI0-r12', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsI0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsIDot_r12 = INT(name='bdsIDot-r12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsIDot_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8192, ub=8191)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsCuc_r12 = INT(name='bdsCuc-r12', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsCuc_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsCus_r12 = INT(name='bdsCus-r12', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsCus_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsCrc_r12 = INT(name='bdsCrc-r12', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsCrc_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsCrs_r12 = INT(name='bdsCrs-r12', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsCrs_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsCic_r12 = INT(name='bdsCic-r12', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsCic_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _NavModel_BDS_KeplerianSet_r12_bdsCis_r12 = INT(name='bdsCis-r12', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDS_KeplerianSet_r12_bdsCis_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    NavModel_BDS_KeplerianSet_r12._cont = ASN1Dict([
        ('bdsAODE-r12', _NavModel_BDS_KeplerianSet_r12_bdsAODE_r12),
        ('bdsURAI-r12', _NavModel_BDS_KeplerianSet_r12_bdsURAI_r12),
        ('bdsToe-r12', _NavModel_BDS_KeplerianSet_r12_bdsToe_r12),
        ('bdsAPowerHalf-r12', _NavModel_BDS_KeplerianSet_r12_bdsAPowerHalf_r12),
        ('bdsE-r12', _NavModel_BDS_KeplerianSet_r12_bdsE_r12),
        ('bdsW-r12', _NavModel_BDS_KeplerianSet_r12_bdsW_r12),
        ('bdsDeltaN-r12', _NavModel_BDS_KeplerianSet_r12_bdsDeltaN_r12),
        ('bdsM0-r12', _NavModel_BDS_KeplerianSet_r12_bdsM0_r12),
        ('bdsOmega0-r12', _NavModel_BDS_KeplerianSet_r12_bdsOmega0_r12),
        ('bdsOmegaDot-r12', _NavModel_BDS_KeplerianSet_r12_bdsOmegaDot_r12),
        ('bdsI0-r12', _NavModel_BDS_KeplerianSet_r12_bdsI0_r12),
        ('bdsIDot-r12', _NavModel_BDS_KeplerianSet_r12_bdsIDot_r12),
        ('bdsCuc-r12', _NavModel_BDS_KeplerianSet_r12_bdsCuc_r12),
        ('bdsCus-r12', _NavModel_BDS_KeplerianSet_r12_bdsCus_r12),
        ('bdsCrc-r12', _NavModel_BDS_KeplerianSet_r12_bdsCrc_r12),
        ('bdsCrs-r12', _NavModel_BDS_KeplerianSet_r12_bdsCrs_r12),
        ('bdsCic-r12', _NavModel_BDS_KeplerianSet_r12_bdsCic_r12),
        ('bdsCis-r12', _NavModel_BDS_KeplerianSet_r12_bdsCis_r12),
        ])
    NavModel_BDS_KeplerianSet_r12._ext = []
    
    #-----< GNSS-RealTimeIntegrity >-----#
    GNSS_RealTimeIntegrity = SEQ(name='GNSS-RealTimeIntegrity', mode=MODE_TYPE)
    _GNSS_RealTimeIntegrity_gnss_BadSignalList = SEQ_OF(name='gnss-BadSignalList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-BadSignalList')))
    GNSS_RealTimeIntegrity._cont = ASN1Dict([
        ('gnss-BadSignalList', _GNSS_RealTimeIntegrity_gnss_BadSignalList),
        ])
    GNSS_RealTimeIntegrity._ext = []
    
    #-----< GNSS-BadSignalList >-----#
    GNSS_BadSignalList = SEQ_OF(name='GNSS-BadSignalList', mode=MODE_TYPE)
    _GNSS_BadSignalList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'BadSignalElement')))
    GNSS_BadSignalList._cont = _GNSS_BadSignalList__item_
    GNSS_BadSignalList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BadSignalElement >-----#
    BadSignalElement = SEQ(name='BadSignalElement', mode=MODE_TYPE)
    _BadSignalElement_badSVID = SEQ(name='badSVID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _BadSignalElement_badSignalID = SEQ(name='badSignalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')), opt=True)
    BadSignalElement._cont = ASN1Dict([
        ('badSVID', _BadSignalElement_badSVID),
        ('badSignalID', _BadSignalElement_badSignalID),
        ])
    BadSignalElement._ext = []
    
    #-----< GNSS-DataBitAssistance >-----#
    GNSS_DataBitAssistance = SEQ(name='GNSS-DataBitAssistance', mode=MODE_TYPE)
    _GNSS_DataBitAssistance_gnss_TOD = INT(name='gnss-TOD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_DataBitAssistance_gnss_TOD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _GNSS_DataBitAssistance_gnss_TODfrac = INT(name='gnss-TODfrac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_DataBitAssistance_gnss_TODfrac._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GNSS_DataBitAssistance_gnss_DataBitsSatList = SEQ_OF(name='gnss-DataBitsSatList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitsSatList')))
    GNSS_DataBitAssistance._cont = ASN1Dict([
        ('gnss-TOD', _GNSS_DataBitAssistance_gnss_TOD),
        ('gnss-TODfrac', _GNSS_DataBitAssistance_gnss_TODfrac),
        ('gnss-DataBitsSatList', _GNSS_DataBitAssistance_gnss_DataBitsSatList),
        ])
    GNSS_DataBitAssistance._ext = []
    
    #-----< GNSS-DataBitsSatList >-----#
    GNSS_DataBitsSatList = SEQ_OF(name='GNSS-DataBitsSatList', mode=MODE_TYPE)
    _GNSS_DataBitsSatList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitsSatElement')))
    GNSS_DataBitsSatList._cont = _GNSS_DataBitsSatList__item_
    GNSS_DataBitsSatList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-DataBitsSatElement >-----#
    GNSS_DataBitsSatElement = SEQ(name='GNSS-DataBitsSatElement', mode=MODE_TYPE)
    _GNSS_DataBitsSatElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _GNSS_DataBitsSatElement_gnss_DataBitsSgnList = SEQ_OF(name='gnss-DataBitsSgnList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitsSgnList')))
    GNSS_DataBitsSatElement._cont = ASN1Dict([
        ('svID', _GNSS_DataBitsSatElement_svID),
        ('gnss-DataBitsSgnList', _GNSS_DataBitsSatElement_gnss_DataBitsSgnList),
        ])
    GNSS_DataBitsSatElement._ext = []
    
    #-----< GNSS-DataBitsSgnList >-----#
    GNSS_DataBitsSgnList = SEQ_OF(name='GNSS-DataBitsSgnList', mode=MODE_TYPE)
    _GNSS_DataBitsSgnList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitsSgnElement')))
    GNSS_DataBitsSgnList._cont = _GNSS_DataBitsSgnList__item_
    GNSS_DataBitsSgnList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GNSS-DataBitsSgnElement >-----#
    GNSS_DataBitsSgnElement = SEQ(name='GNSS-DataBitsSgnElement', mode=MODE_TYPE)
    _GNSS_DataBitsSgnElement_gnss_SignalType = SEQ(name='gnss-SignalType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _GNSS_DataBitsSgnElement_gnss_DataBits = BIT_STR(name='gnss-DataBits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_DataBitsSgnElement_gnss_DataBits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    GNSS_DataBitsSgnElement._cont = ASN1Dict([
        ('gnss-SignalType', _GNSS_DataBitsSgnElement_gnss_SignalType),
        ('gnss-DataBits', _GNSS_DataBitsSgnElement_gnss_DataBits),
        ])
    GNSS_DataBitsSgnElement._ext = []
    
    #-----< GNSS-AcquisitionAssistance >-----#
    GNSS_AcquisitionAssistance = SEQ(name='GNSS-AcquisitionAssistance', mode=MODE_TYPE)
    _GNSS_AcquisitionAssistance_gnss_SignalID = SEQ(name='gnss-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _GNSS_AcquisitionAssistance_gnss_AcquisitionAssistList = SEQ_OF(name='gnss-AcquisitionAssistList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AcquisitionAssistList')))
    _GNSS_AcquisitionAssistance_confidence_r10 = INT(name='confidence-r10', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AcquisitionAssistance_confidence_r10._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    GNSS_AcquisitionAssistance._cont = ASN1Dict([
        ('gnss-SignalID', _GNSS_AcquisitionAssistance_gnss_SignalID),
        ('gnss-AcquisitionAssistList', _GNSS_AcquisitionAssistance_gnss_AcquisitionAssistList),
        ('confidence-r10', _GNSS_AcquisitionAssistance_confidence_r10),
        ])
    GNSS_AcquisitionAssistance._ext = ['confidence-r10']
    
    #-----< GNSS-AcquisitionAssistList >-----#
    GNSS_AcquisitionAssistList = SEQ_OF(name='GNSS-AcquisitionAssistList', mode=MODE_TYPE)
    _GNSS_AcquisitionAssistList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AcquisitionAssistElement')))
    GNSS_AcquisitionAssistList._cont = _GNSS_AcquisitionAssistList__item_
    GNSS_AcquisitionAssistList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-AcquisitionAssistElement >-----#
    GNSS_AcquisitionAssistElement = SEQ(name='GNSS-AcquisitionAssistElement', mode=MODE_TYPE)
    _GNSS_AcquisitionAssistElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _GNSS_AcquisitionAssistElement_doppler0 = INT(name='doppler0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_doppler0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2048, ub=2047)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_doppler1 = INT(name='doppler1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_doppler1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_dopplerUncertainty = INT(name='dopplerUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_dopplerUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_codePhase = INT(name='codePhase', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_codePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_intCodePhase = INT(name='intCodePhase', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_intCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_codePhaseSearchWindow = INT(name='codePhaseSearchWindow', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_codePhaseSearchWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_azimuth = INT(name='azimuth', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_elevation = INT(name='elevation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_AcquisitionAssistElement_elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GNSS_AcquisitionAssistElement_codePhase1023 = BOOL(name='codePhase1023', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AcquisitionAssistElement_dopplerUncertaintyExt_r10 = ENUM(name='dopplerUncertaintyExt-r10', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AcquisitionAssistElement_dopplerUncertaintyExt_r10._cont = ASN1Dict([('d60', 0), ('d80', 1), ('d100', 2), ('d120', 3), ('noInformation', 4)])
    _GNSS_AcquisitionAssistElement_dopplerUncertaintyExt_r10._ext = []
    GNSS_AcquisitionAssistElement._cont = ASN1Dict([
        ('svID', _GNSS_AcquisitionAssistElement_svID),
        ('doppler0', _GNSS_AcquisitionAssistElement_doppler0),
        ('doppler1', _GNSS_AcquisitionAssistElement_doppler1),
        ('dopplerUncertainty', _GNSS_AcquisitionAssistElement_dopplerUncertainty),
        ('codePhase', _GNSS_AcquisitionAssistElement_codePhase),
        ('intCodePhase', _GNSS_AcquisitionAssistElement_intCodePhase),
        ('codePhaseSearchWindow', _GNSS_AcquisitionAssistElement_codePhaseSearchWindow),
        ('azimuth', _GNSS_AcquisitionAssistElement_azimuth),
        ('elevation', _GNSS_AcquisitionAssistElement_elevation),
        ('codePhase1023', _GNSS_AcquisitionAssistElement_codePhase1023),
        ('dopplerUncertaintyExt-r10', _GNSS_AcquisitionAssistElement_dopplerUncertaintyExt_r10),
        ])
    GNSS_AcquisitionAssistElement._ext = ['codePhase1023', 'dopplerUncertaintyExt-r10']
    
    #-----< GNSS-Almanac >-----#
    GNSS_Almanac = SEQ(name='GNSS-Almanac', mode=MODE_TYPE)
    _GNSS_Almanac_weekNumber = INT(name='weekNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_Almanac_weekNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GNSS_Almanac_toa = INT(name='toa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_Almanac_toa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GNSS_Almanac_ioda = INT(name='ioda', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_Almanac_ioda._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _GNSS_Almanac_completeAlmanacProvided = BOOL(name='completeAlmanacProvided', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_Almanac_gnss_AlmanacList = SEQ_OF(name='gnss-AlmanacList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AlmanacList')))
    _GNSS_Almanac_toa_ext_v1240 = INT(name='toa-ext-v1240', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True, group=0)
    _GNSS_Almanac_toa_ext_v1240._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=256, ub=1023)], ev=None, er=[])
    _GNSS_Almanac_ioda_ext_v1240 = INT(name='ioda-ext-v1240', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True, group=0)
    _GNSS_Almanac_ioda_ext_v1240._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=15)], ev=None, er=[])
    GNSS_Almanac._cont = ASN1Dict([
        ('weekNumber', _GNSS_Almanac_weekNumber),
        ('toa', _GNSS_Almanac_toa),
        ('ioda', _GNSS_Almanac_ioda),
        ('completeAlmanacProvided', _GNSS_Almanac_completeAlmanacProvided),
        ('gnss-AlmanacList', _GNSS_Almanac_gnss_AlmanacList),
        ('toa-ext-v1240', _GNSS_Almanac_toa_ext_v1240),
        ('ioda-ext-v1240', _GNSS_Almanac_ioda_ext_v1240),
        ])
    GNSS_Almanac._ext = ['toa-ext-v1240', 'ioda-ext-v1240']
    
    #-----< GNSS-AlmanacList >-----#
    GNSS_AlmanacList = SEQ_OF(name='GNSS-AlmanacList', mode=MODE_TYPE)
    _GNSS_AlmanacList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AlmanacElement')))
    GNSS_AlmanacList._cont = _GNSS_AlmanacList__item_
    GNSS_AlmanacList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-AlmanacElement >-----#
    GNSS_AlmanacElement = CHOICE(name='GNSS-AlmanacElement', mode=MODE_TYPE)
    _GNSS_AlmanacElement_keplerianAlmanacSet = SEQ(name='keplerianAlmanacSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacKeplerianSet')))
    _GNSS_AlmanacElement_keplerianNAV_Almanac = SEQ(name='keplerianNAV-Almanac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacNAV-KeplerianSet')))
    _GNSS_AlmanacElement_keplerianReducedAlmanac = SEQ(name='keplerianReducedAlmanac', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacReducedKeplerianSet')))
    _GNSS_AlmanacElement_keplerianMidiAlmanac = SEQ(name='keplerianMidiAlmanac', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacMidiAlmanacSet')))
    _GNSS_AlmanacElement_keplerianGLONASS = SEQ(name='keplerianGLONASS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacGLONASS-AlmanacSet')))
    _GNSS_AlmanacElement_ecef_SBAS_Almanac = SEQ(name='ecef-SBAS-Almanac', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacECEF-SBAS-AlmanacSet')))
    _GNSS_AlmanacElement_keplerianBDS_Almanac_r12 = SEQ(name='keplerianBDS-Almanac-r12', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AlmanacBDS-AlmanacSet-r12')))
    GNSS_AlmanacElement._cont = ASN1Dict([
        ('keplerianAlmanacSet', _GNSS_AlmanacElement_keplerianAlmanacSet),
        ('keplerianNAV-Almanac', _GNSS_AlmanacElement_keplerianNAV_Almanac),
        ('keplerianReducedAlmanac', _GNSS_AlmanacElement_keplerianReducedAlmanac),
        ('keplerianMidiAlmanac', _GNSS_AlmanacElement_keplerianMidiAlmanac),
        ('keplerianGLONASS', _GNSS_AlmanacElement_keplerianGLONASS),
        ('ecef-SBAS-Almanac', _GNSS_AlmanacElement_ecef_SBAS_Almanac),
        ('keplerianBDS-Almanac-r12', _GNSS_AlmanacElement_keplerianBDS_Almanac_r12),
        ])
    GNSS_AlmanacElement._ext = ['keplerianBDS-Almanac-r12']
    
    #-----< AlmanacKeplerianSet >-----#
    AlmanacKeplerianSet = SEQ(name='AlmanacKeplerianSet', mode=MODE_TYPE)
    _AlmanacKeplerianSet_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _AlmanacKeplerianSet_kepAlmanacE = INT(name='kepAlmanacE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacDeltaI = INT(name='kepAlmanacDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacDeltaI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacOmegaDot = INT(name='kepAlmanacOmegaDot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacOmegaDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacKeplerianSet_kepSV_StatusINAV = BIT_STR(name='kepSV-StatusINAV', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepSV_StatusINAV._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _AlmanacKeplerianSet_kepSV_StatusFNAV = BIT_STR(name='kepSV-StatusFNAV', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AlmanacKeplerianSet_kepSV_StatusFNAV._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacAPowerHalf = INT(name='kepAlmanacAPowerHalf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacAPowerHalf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacOmega0 = INT(name='kepAlmanacOmega0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacOmega0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacW = INT(name='kepAlmanacW', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacW._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacM0 = INT(name='kepAlmanacM0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacM0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacAF0 = INT(name='kepAlmanacAF0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacAF0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacKeplerianSet_kepAlmanacAF1 = INT(name='kepAlmanacAF1', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacKeplerianSet_kepAlmanacAF1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    AlmanacKeplerianSet._cont = ASN1Dict([
        ('svID', _AlmanacKeplerianSet_svID),
        ('kepAlmanacE', _AlmanacKeplerianSet_kepAlmanacE),
        ('kepAlmanacDeltaI', _AlmanacKeplerianSet_kepAlmanacDeltaI),
        ('kepAlmanacOmegaDot', _AlmanacKeplerianSet_kepAlmanacOmegaDot),
        ('kepSV-StatusINAV', _AlmanacKeplerianSet_kepSV_StatusINAV),
        ('kepSV-StatusFNAV', _AlmanacKeplerianSet_kepSV_StatusFNAV),
        ('kepAlmanacAPowerHalf', _AlmanacKeplerianSet_kepAlmanacAPowerHalf),
        ('kepAlmanacOmega0', _AlmanacKeplerianSet_kepAlmanacOmega0),
        ('kepAlmanacW', _AlmanacKeplerianSet_kepAlmanacW),
        ('kepAlmanacM0', _AlmanacKeplerianSet_kepAlmanacM0),
        ('kepAlmanacAF0', _AlmanacKeplerianSet_kepAlmanacAF0),
        ('kepAlmanacAF1', _AlmanacKeplerianSet_kepAlmanacAF1),
        ])
    AlmanacKeplerianSet._ext = []
    
    #-----< AlmanacNAV-KeplerianSet >-----#
    AlmanacNAV_KeplerianSet = SEQ(name='AlmanacNAV-KeplerianSet', mode=MODE_TYPE)
    _AlmanacNAV_KeplerianSet_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _AlmanacNAV_KeplerianSet_navAlmE = INT(name='navAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmDeltaI = INT(name='navAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmDeltaI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmOMEGADOT = INT(name='navAlmOMEGADOT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmOMEGADOT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmSVHealth = INT(name='navAlmSVHealth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmSVHealth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmSqrtA = INT(name='navAlmSqrtA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmSqrtA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmOMEGAo = INT(name='navAlmOMEGAo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmOMEGAo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmOmega = INT(name='navAlmOmega', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmOmega._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmMo = INT(name='navAlmMo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmMo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmaf0 = INT(name='navAlmaf0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmaf0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacNAV_KeplerianSet_navAlmaf1 = INT(name='navAlmaf1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacNAV_KeplerianSet_navAlmaf1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    AlmanacNAV_KeplerianSet._cont = ASN1Dict([
        ('svID', _AlmanacNAV_KeplerianSet_svID),
        ('navAlmE', _AlmanacNAV_KeplerianSet_navAlmE),
        ('navAlmDeltaI', _AlmanacNAV_KeplerianSet_navAlmDeltaI),
        ('navAlmOMEGADOT', _AlmanacNAV_KeplerianSet_navAlmOMEGADOT),
        ('navAlmSVHealth', _AlmanacNAV_KeplerianSet_navAlmSVHealth),
        ('navAlmSqrtA', _AlmanacNAV_KeplerianSet_navAlmSqrtA),
        ('navAlmOMEGAo', _AlmanacNAV_KeplerianSet_navAlmOMEGAo),
        ('navAlmOmega', _AlmanacNAV_KeplerianSet_navAlmOmega),
        ('navAlmMo', _AlmanacNAV_KeplerianSet_navAlmMo),
        ('navAlmaf0', _AlmanacNAV_KeplerianSet_navAlmaf0),
        ('navAlmaf1', _AlmanacNAV_KeplerianSet_navAlmaf1),
        ])
    AlmanacNAV_KeplerianSet._ext = []
    
    #-----< AlmanacReducedKeplerianSet >-----#
    AlmanacReducedKeplerianSet = SEQ(name='AlmanacReducedKeplerianSet', mode=MODE_TYPE)
    _AlmanacReducedKeplerianSet_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _AlmanacReducedKeplerianSet_redAlmDeltaA = INT(name='redAlmDeltaA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacReducedKeplerianSet_redAlmDeltaA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _AlmanacReducedKeplerianSet_redAlmOmega0 = INT(name='redAlmOmega0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacReducedKeplerianSet_redAlmOmega0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _AlmanacReducedKeplerianSet_redAlmPhi0 = INT(name='redAlmPhi0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacReducedKeplerianSet_redAlmPhi0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _AlmanacReducedKeplerianSet_redAlmL1Health = BOOL(name='redAlmL1Health', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacReducedKeplerianSet_redAlmL2Health = BOOL(name='redAlmL2Health', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacReducedKeplerianSet_redAlmL5Health = BOOL(name='redAlmL5Health', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AlmanacReducedKeplerianSet._cont = ASN1Dict([
        ('svID', _AlmanacReducedKeplerianSet_svID),
        ('redAlmDeltaA', _AlmanacReducedKeplerianSet_redAlmDeltaA),
        ('redAlmOmega0', _AlmanacReducedKeplerianSet_redAlmOmega0),
        ('redAlmPhi0', _AlmanacReducedKeplerianSet_redAlmPhi0),
        ('redAlmL1Health', _AlmanacReducedKeplerianSet_redAlmL1Health),
        ('redAlmL2Health', _AlmanacReducedKeplerianSet_redAlmL2Health),
        ('redAlmL5Health', _AlmanacReducedKeplerianSet_redAlmL5Health),
        ])
    AlmanacReducedKeplerianSet._ext = []
    
    #-----< AlmanacMidiAlmanacSet >-----#
    AlmanacMidiAlmanacSet = SEQ(name='AlmanacMidiAlmanacSet', mode=MODE_TYPE)
    _AlmanacMidiAlmanacSet_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _AlmanacMidiAlmanacSet_midiAlmE = INT(name='midiAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmDeltaI = INT(name='midiAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmDeltaI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmOmegaDot = INT(name='midiAlmOmegaDot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmOmegaDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmSqrtA = INT(name='midiAlmSqrtA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmSqrtA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmOmega0 = INT(name='midiAlmOmega0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmOmega0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmOmega = INT(name='midiAlmOmega', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmOmega._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmMo = INT(name='midiAlmMo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmMo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmaf0 = INT(name='midiAlmaf0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmaf0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmaf1 = INT(name='midiAlmaf1', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmaf1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _AlmanacMidiAlmanacSet_midiAlmL1Health = BOOL(name='midiAlmL1Health', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmL2Health = BOOL(name='midiAlmL2Health', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacMidiAlmanacSet_midiAlmL5Health = BOOL(name='midiAlmL5Health', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AlmanacMidiAlmanacSet._cont = ASN1Dict([
        ('svID', _AlmanacMidiAlmanacSet_svID),
        ('midiAlmE', _AlmanacMidiAlmanacSet_midiAlmE),
        ('midiAlmDeltaI', _AlmanacMidiAlmanacSet_midiAlmDeltaI),
        ('midiAlmOmegaDot', _AlmanacMidiAlmanacSet_midiAlmOmegaDot),
        ('midiAlmSqrtA', _AlmanacMidiAlmanacSet_midiAlmSqrtA),
        ('midiAlmOmega0', _AlmanacMidiAlmanacSet_midiAlmOmega0),
        ('midiAlmOmega', _AlmanacMidiAlmanacSet_midiAlmOmega),
        ('midiAlmMo', _AlmanacMidiAlmanacSet_midiAlmMo),
        ('midiAlmaf0', _AlmanacMidiAlmanacSet_midiAlmaf0),
        ('midiAlmaf1', _AlmanacMidiAlmanacSet_midiAlmaf1),
        ('midiAlmL1Health', _AlmanacMidiAlmanacSet_midiAlmL1Health),
        ('midiAlmL2Health', _AlmanacMidiAlmanacSet_midiAlmL2Health),
        ('midiAlmL5Health', _AlmanacMidiAlmanacSet_midiAlmL5Health),
        ])
    AlmanacMidiAlmanacSet._ext = []
    
    #-----< AlmanacGLONASS-AlmanacSet >-----#
    AlmanacGLONASS_AlmanacSet = SEQ(name='AlmanacGLONASS-AlmanacSet', mode=MODE_TYPE)
    _AlmanacGLONASS_AlmanacSet_gloAlm_NA = INT(name='gloAlm-NA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlm_NA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1461)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmnA = INT(name='gloAlmnA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmnA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmHA = INT(name='gloAlmHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmHA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmLambdaA = INT(name='gloAlmLambdaA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmLambdaA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1048576, ub=1048575)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmtlambdaA = INT(name='gloAlmtlambdaA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmtlambdaA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2097151)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmDeltaIa = INT(name='gloAlmDeltaIa', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmDeltaIa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-131072, ub=131071)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTA = INT(name='gloAlmDeltaTA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2097152, ub=2097151)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTdotA = INT(name='gloAlmDeltaTdotA', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTdotA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmEpsilonA = INT(name='gloAlmEpsilonA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmEpsilonA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmOmegaA = INT(name='gloAlmOmegaA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmOmegaA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmTauA = INT(name='gloAlmTauA', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmTauA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmCA = INT(name='gloAlmCA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacGLONASS_AlmanacSet_gloAlmCA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _AlmanacGLONASS_AlmanacSet_gloAlmMA = BIT_STR(name='gloAlmMA', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AlmanacGLONASS_AlmanacSet_gloAlmMA._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    AlmanacGLONASS_AlmanacSet._cont = ASN1Dict([
        ('gloAlm-NA', _AlmanacGLONASS_AlmanacSet_gloAlm_NA),
        ('gloAlmnA', _AlmanacGLONASS_AlmanacSet_gloAlmnA),
        ('gloAlmHA', _AlmanacGLONASS_AlmanacSet_gloAlmHA),
        ('gloAlmLambdaA', _AlmanacGLONASS_AlmanacSet_gloAlmLambdaA),
        ('gloAlmtlambdaA', _AlmanacGLONASS_AlmanacSet_gloAlmtlambdaA),
        ('gloAlmDeltaIa', _AlmanacGLONASS_AlmanacSet_gloAlmDeltaIa),
        ('gloAlmDeltaTA', _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTA),
        ('gloAlmDeltaTdotA', _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTdotA),
        ('gloAlmEpsilonA', _AlmanacGLONASS_AlmanacSet_gloAlmEpsilonA),
        ('gloAlmOmegaA', _AlmanacGLONASS_AlmanacSet_gloAlmOmegaA),
        ('gloAlmTauA', _AlmanacGLONASS_AlmanacSet_gloAlmTauA),
        ('gloAlmCA', _AlmanacGLONASS_AlmanacSet_gloAlmCA),
        ('gloAlmMA', _AlmanacGLONASS_AlmanacSet_gloAlmMA),
        ])
    AlmanacGLONASS_AlmanacSet._ext = []
    
    #-----< AlmanacECEF-SBAS-AlmanacSet >-----#
    AlmanacECEF_SBAS_AlmanacSet = SEQ(name='AlmanacECEF-SBAS-AlmanacSet', mode=MODE_TYPE)
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmDataID = INT(name='sbasAlmDataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmDataID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmHealth = BIT_STR(name='sbasAlmHealth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXg = INT(name='sbasAlmXg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXg._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16384, ub=16383)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYg = INT(name='sbasAlmYg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYg._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16384, ub=16383)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZg = INT(name='sbasAlmZg', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZg._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-256, ub=255)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXgdot = INT(name='sbasAlmXgdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXgdot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4, ub=3)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYgDot = INT(name='sbasAlmYgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYgDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4, ub=3)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZgDot = INT(name='sbasAlmZgDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZgDot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8, ub=7)], ev=None, er=[])
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmTo = INT(name='sbasAlmTo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacECEF_SBAS_AlmanacSet_sbasAlmTo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    AlmanacECEF_SBAS_AlmanacSet._cont = ASN1Dict([
        ('sbasAlmDataID', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmDataID),
        ('svID', _AlmanacECEF_SBAS_AlmanacSet_svID),
        ('sbasAlmHealth', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmHealth),
        ('sbasAlmXg', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXg),
        ('sbasAlmYg', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYg),
        ('sbasAlmZg', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZg),
        ('sbasAlmXgdot', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXgdot),
        ('sbasAlmYgDot', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYgDot),
        ('sbasAlmZgDot', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZgDot),
        ('sbasAlmTo', _AlmanacECEF_SBAS_AlmanacSet_sbasAlmTo),
        ])
    AlmanacECEF_SBAS_AlmanacSet._ext = []
    
    #-----< AlmanacBDS-AlmanacSet-r12 >-----#
    AlmanacBDS_AlmanacSet_r12 = SEQ(name='AlmanacBDS-AlmanacSet-r12', mode=MODE_TYPE)
    _AlmanacBDS_AlmanacSet_r12_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmToa_r12 = INT(name='bdsAlmToa-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AlmanacBDS_AlmanacSet_r12_bdsAlmToa_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmSqrtA_r12 = INT(name='bdsAlmSqrtA-r12', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmSqrtA_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmE_r12 = INT(name='bdsAlmE-r12', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmE_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmW_r12 = INT(name='bdsAlmW-r12', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmW_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmM0_r12 = INT(name='bdsAlmM0-r12', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmM0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmOmega0_r12 = INT(name='bdsAlmOmega0-r12', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmOmega0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmOmegaDot_r12 = INT(name='bdsAlmOmegaDot-r12', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmOmegaDot_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmDeltaI_r12 = INT(name='bdsAlmDeltaI-r12', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmDeltaI_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmA0_r12 = INT(name='bdsAlmA0-r12', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmA0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsAlmA1_r12 = INT(name='bdsAlmA1-r12', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacBDS_AlmanacSet_r12_bdsAlmA1_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _AlmanacBDS_AlmanacSet_r12_bdsSvHealth_r12 = BIT_STR(name='bdsSvHealth-r12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AlmanacBDS_AlmanacSet_r12_bdsSvHealth_r12._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    AlmanacBDS_AlmanacSet_r12._cont = ASN1Dict([
        ('svID', _AlmanacBDS_AlmanacSet_r12_svID),
        ('bdsAlmToa-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmToa_r12),
        ('bdsAlmSqrtA-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmSqrtA_r12),
        ('bdsAlmE-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmE_r12),
        ('bdsAlmW-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmW_r12),
        ('bdsAlmM0-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmM0_r12),
        ('bdsAlmOmega0-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmOmega0_r12),
        ('bdsAlmOmegaDot-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmOmegaDot_r12),
        ('bdsAlmDeltaI-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmDeltaI_r12),
        ('bdsAlmA0-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmA0_r12),
        ('bdsAlmA1-r12', _AlmanacBDS_AlmanacSet_r12_bdsAlmA1_r12),
        ('bdsSvHealth-r12', _AlmanacBDS_AlmanacSet_r12_bdsSvHealth_r12),
        ])
    AlmanacBDS_AlmanacSet_r12._ext = []
    
    #-----< GNSS-UTC-Model >-----#
    GNSS_UTC_Model = CHOICE(name='GNSS-UTC-Model', mode=MODE_TYPE)
    _GNSS_UTC_Model_utcModel1 = SEQ(name='utcModel1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'UTC-ModelSet1')))
    _GNSS_UTC_Model_utcModel2 = SEQ(name='utcModel2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'UTC-ModelSet2')))
    _GNSS_UTC_Model_utcModel3 = SEQ(name='utcModel3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'UTC-ModelSet3')))
    _GNSS_UTC_Model_utcModel4 = SEQ(name='utcModel4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'UTC-ModelSet4')))
    _GNSS_UTC_Model_utcModel5_r12 = SEQ(name='utcModel5-r12', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'UTC-ModelSet5-r12')))
    GNSS_UTC_Model._cont = ASN1Dict([
        ('utcModel1', _GNSS_UTC_Model_utcModel1),
        ('utcModel2', _GNSS_UTC_Model_utcModel2),
        ('utcModel3', _GNSS_UTC_Model_utcModel3),
        ('utcModel4', _GNSS_UTC_Model_utcModel4),
        ('utcModel5-r12', _GNSS_UTC_Model_utcModel5_r12),
        ])
    GNSS_UTC_Model._ext = ['utcModel5-r12']
    
    #-----< UTC-ModelSet1 >-----#
    UTC_ModelSet1 = SEQ(name='UTC-ModelSet1', mode=MODE_TYPE)
    _UTC_ModelSet1_gnss_Utc_A1 = INT(name='gnss-Utc-A1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_A1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_A0 = INT(name='gnss-Utc-A0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_A0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_Tot = INT(name='gnss-Utc-Tot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_Tot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_WNt = INT(name='gnss-Utc-WNt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_WNt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_DeltaTls = INT(name='gnss-Utc-DeltaTls', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_DeltaTls._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_WNlsf = INT(name='gnss-Utc-WNlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_WNlsf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_DN = INT(name='gnss-Utc-DN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_DN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet1_gnss_Utc_DeltaTlsf = INT(name='gnss-Utc-DeltaTlsf', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet1_gnss_Utc_DeltaTlsf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    UTC_ModelSet1._cont = ASN1Dict([
        ('gnss-Utc-A1', _UTC_ModelSet1_gnss_Utc_A1),
        ('gnss-Utc-A0', _UTC_ModelSet1_gnss_Utc_A0),
        ('gnss-Utc-Tot', _UTC_ModelSet1_gnss_Utc_Tot),
        ('gnss-Utc-WNt', _UTC_ModelSet1_gnss_Utc_WNt),
        ('gnss-Utc-DeltaTls', _UTC_ModelSet1_gnss_Utc_DeltaTls),
        ('gnss-Utc-WNlsf', _UTC_ModelSet1_gnss_Utc_WNlsf),
        ('gnss-Utc-DN', _UTC_ModelSet1_gnss_Utc_DN),
        ('gnss-Utc-DeltaTlsf', _UTC_ModelSet1_gnss_Utc_DeltaTlsf),
        ])
    UTC_ModelSet1._ext = []
    
    #-----< UTC-ModelSet2 >-----#
    UTC_ModelSet2 = SEQ(name='UTC-ModelSet2', mode=MODE_TYPE)
    _UTC_ModelSet2_utcA0 = INT(name='utcA0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcA0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _UTC_ModelSet2_utcA1 = INT(name='utcA1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcA1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _UTC_ModelSet2_utcA2 = INT(name='utcA2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcA2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _UTC_ModelSet2_utcDeltaTls = INT(name='utcDeltaTls', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcDeltaTls._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet2_utcTot = INT(name='utcTot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcTot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UTC_ModelSet2_utcWNot = INT(name='utcWNot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcWNot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _UTC_ModelSet2_utcWNlsf = INT(name='utcWNlsf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcWNlsf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet2_utcDN = BIT_STR(name='utcDN', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcDN._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _UTC_ModelSet2_utcDeltaTlsf = INT(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet2_utcDeltaTlsf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    UTC_ModelSet2._cont = ASN1Dict([
        ('utcA0', _UTC_ModelSet2_utcA0),
        ('utcA1', _UTC_ModelSet2_utcA1),
        ('utcA2', _UTC_ModelSet2_utcA2),
        ('utcDeltaTls', _UTC_ModelSet2_utcDeltaTls),
        ('utcTot', _UTC_ModelSet2_utcTot),
        ('utcWNot', _UTC_ModelSet2_utcWNot),
        ('utcWNlsf', _UTC_ModelSet2_utcWNlsf),
        ('utcDN', _UTC_ModelSet2_utcDN),
        ('utcDeltaTlsf', _UTC_ModelSet2_utcDeltaTlsf),
        ])
    UTC_ModelSet2._ext = []
    
    #-----< UTC-ModelSet3 >-----#
    UTC_ModelSet3 = SEQ(name='UTC-ModelSet3', mode=MODE_TYPE)
    _UTC_ModelSet3_nA = INT(name='nA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet3_nA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1461)], ev=None, er=[])
    _UTC_ModelSet3_tauC = INT(name='tauC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet3_tauC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _UTC_ModelSet3_b1 = INT(name='b1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTC_ModelSet3_b1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _UTC_ModelSet3_b2 = INT(name='b2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTC_ModelSet3_b2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    _UTC_ModelSet3_kp = BIT_STR(name='kp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTC_ModelSet3_kp._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    UTC_ModelSet3._cont = ASN1Dict([
        ('nA', _UTC_ModelSet3_nA),
        ('tauC', _UTC_ModelSet3_tauC),
        ('b1', _UTC_ModelSet3_b1),
        ('b2', _UTC_ModelSet3_b2),
        ('kp', _UTC_ModelSet3_kp),
        ])
    UTC_ModelSet3._ext = []
    
    #-----< UTC-ModelSet4 >-----#
    UTC_ModelSet4 = SEQ(name='UTC-ModelSet4', mode=MODE_TYPE)
    _UTC_ModelSet4_utcA1wnt = INT(name='utcA1wnt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcA1wnt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _UTC_ModelSet4_utcA0wnt = INT(name='utcA0wnt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcA0wnt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _UTC_ModelSet4_utcTot = INT(name='utcTot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcTot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet4_utcWNt = INT(name='utcWNt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcWNt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet4_utcDeltaTls = INT(name='utcDeltaTls', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcDeltaTls._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet4_utcWNlsf = INT(name='utcWNlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcWNlsf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet4_utcDN = INT(name='utcDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcDN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet4_utcDeltaTlsf = INT(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcDeltaTlsf._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet4_utcStandardID = INT(name='utcStandardID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet4_utcStandardID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    UTC_ModelSet4._cont = ASN1Dict([
        ('utcA1wnt', _UTC_ModelSet4_utcA1wnt),
        ('utcA0wnt', _UTC_ModelSet4_utcA0wnt),
        ('utcTot', _UTC_ModelSet4_utcTot),
        ('utcWNt', _UTC_ModelSet4_utcWNt),
        ('utcDeltaTls', _UTC_ModelSet4_utcDeltaTls),
        ('utcWNlsf', _UTC_ModelSet4_utcWNlsf),
        ('utcDN', _UTC_ModelSet4_utcDN),
        ('utcDeltaTlsf', _UTC_ModelSet4_utcDeltaTlsf),
        ('utcStandardID', _UTC_ModelSet4_utcStandardID),
        ])
    UTC_ModelSet4._ext = []
    
    #-----< UTC-ModelSet5-r12 >-----#
    UTC_ModelSet5_r12 = SEQ(name='UTC-ModelSet5-r12', mode=MODE_TYPE)
    _UTC_ModelSet5_r12_utcA0_r12 = INT(name='utcA0-r12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet5_r12_utcA0_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _UTC_ModelSet5_r12_utcA1_r12 = INT(name='utcA1-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet5_r12_utcA1_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _UTC_ModelSet5_r12_utcDeltaTls_r12 = INT(name='utcDeltaTls-r12', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet5_r12_utcDeltaTls_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _UTC_ModelSet5_r12_utcWNlsf_r12 = INT(name='utcWNlsf-r12', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet5_r12_utcWNlsf_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet5_r12_utcDN_r12 = INT(name='utcDN-r12', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet5_r12_utcDN_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _UTC_ModelSet5_r12_utcDeltaTlsf_r12 = INT(name='utcDeltaTlsf-r12', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTC_ModelSet5_r12_utcDeltaTlsf_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    UTC_ModelSet5_r12._cont = ASN1Dict([
        ('utcA0-r12', _UTC_ModelSet5_r12_utcA0_r12),
        ('utcA1-r12', _UTC_ModelSet5_r12_utcA1_r12),
        ('utcDeltaTls-r12', _UTC_ModelSet5_r12_utcDeltaTls_r12),
        ('utcWNlsf-r12', _UTC_ModelSet5_r12_utcWNlsf_r12),
        ('utcDN-r12', _UTC_ModelSet5_r12_utcDN_r12),
        ('utcDeltaTlsf-r12', _UTC_ModelSet5_r12_utcDeltaTlsf_r12),
        ])
    UTC_ModelSet5_r12._ext = []
    
    #-----< GNSS-AuxiliaryInformation >-----#
    GNSS_AuxiliaryInformation = CHOICE(name='GNSS-AuxiliaryInformation', mode=MODE_TYPE)
    _GNSS_AuxiliaryInformation_gnss_ID_GPS = SEQ_OF(name='gnss-ID-GPS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-GPS')))
    _GNSS_AuxiliaryInformation_gnss_ID_GLONASS = SEQ_OF(name='gnss-ID-GLONASS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-GLONASS')))
    GNSS_AuxiliaryInformation._cont = ASN1Dict([
        ('gnss-ID-GPS', _GNSS_AuxiliaryInformation_gnss_ID_GPS),
        ('gnss-ID-GLONASS', _GNSS_AuxiliaryInformation_gnss_ID_GLONASS),
        ])
    GNSS_AuxiliaryInformation._ext = []
    
    #-----< GNSS-ID-GPS >-----#
    GNSS_ID_GPS = SEQ_OF(name='GNSS-ID-GPS', mode=MODE_TYPE)
    _GNSS_ID_GPS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-GPS-SatElement')))
    GNSS_ID_GPS._cont = _GNSS_ID_GPS__item_
    GNSS_ID_GPS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-ID-GPS-SatElement >-----#
    GNSS_ID_GPS_SatElement = SEQ(name='GNSS-ID-GPS-SatElement', mode=MODE_TYPE)
    _GNSS_ID_GPS_SatElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _GNSS_ID_GPS_SatElement_signalsAvailable = SEQ(name='signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    GNSS_ID_GPS_SatElement._cont = ASN1Dict([
        ('svID', _GNSS_ID_GPS_SatElement_svID),
        ('signalsAvailable', _GNSS_ID_GPS_SatElement_signalsAvailable),
        ])
    GNSS_ID_GPS_SatElement._ext = []
    
    #-----< GNSS-ID-GLONASS >-----#
    GNSS_ID_GLONASS = SEQ_OF(name='GNSS-ID-GLONASS', mode=MODE_TYPE)
    _GNSS_ID_GLONASS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-GLONASS-SatElement')))
    GNSS_ID_GLONASS._cont = _GNSS_ID_GLONASS__item_
    GNSS_ID_GLONASS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-ID-GLONASS-SatElement >-----#
    GNSS_ID_GLONASS_SatElement = SEQ(name='GNSS-ID-GLONASS-SatElement', mode=MODE_TYPE)
    _GNSS_ID_GLONASS_SatElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _GNSS_ID_GLONASS_SatElement_signalsAvailable = SEQ(name='signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    _GNSS_ID_GLONASS_SatElement_channelNumber = INT(name='channelNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_ID_GLONASS_SatElement_channelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-7, ub=13)], ev=None, er=[])
    GNSS_ID_GLONASS_SatElement._cont = ASN1Dict([
        ('svID', _GNSS_ID_GLONASS_SatElement_svID),
        ('signalsAvailable', _GNSS_ID_GLONASS_SatElement_signalsAvailable),
        ('channelNumber', _GNSS_ID_GLONASS_SatElement_channelNumber),
        ])
    GNSS_ID_GLONASS_SatElement._ext = []
    
    #-----< BDS-DifferentialCorrections-r12 >-----#
    BDS_DifferentialCorrections_r12 = SEQ(name='BDS-DifferentialCorrections-r12', mode=MODE_TYPE)
    _BDS_DifferentialCorrections_r12_dbds_RefTime_r12 = INT(name='dbds-RefTime-r12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_DifferentialCorrections_r12_dbds_RefTime_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _BDS_DifferentialCorrections_r12_bds_SgnTypeList_r12 = SEQ_OF(name='bds-SgnTypeList-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-SgnTypeList-r12')))
    BDS_DifferentialCorrections_r12._cont = ASN1Dict([
        ('dbds-RefTime-r12', _BDS_DifferentialCorrections_r12_dbds_RefTime_r12),
        ('bds-SgnTypeList-r12', _BDS_DifferentialCorrections_r12_bds_SgnTypeList_r12),
        ])
    BDS_DifferentialCorrections_r12._ext = []
    
    #-----< BDS-SgnTypeList-r12 >-----#
    BDS_SgnTypeList_r12 = SEQ_OF(name='BDS-SgnTypeList-r12', mode=MODE_TYPE)
    _BDS_SgnTypeList_r12__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-SgnTypeElement-r12')))
    BDS_SgnTypeList_r12._cont = _BDS_SgnTypeList_r12__item_
    BDS_SgnTypeList_r12._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< BDS-SgnTypeElement-r12 >-----#
    BDS_SgnTypeElement_r12 = SEQ(name='BDS-SgnTypeElement-r12', mode=MODE_TYPE)
    _BDS_SgnTypeElement_r12_gnss_SignalID = SEQ(name='gnss-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')), opt=True)
    _BDS_SgnTypeElement_r12_dbds_CorrectionList_r12 = SEQ_OF(name='dbds-CorrectionList-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'DBDS-CorrectionList-r12')))
    BDS_SgnTypeElement_r12._cont = ASN1Dict([
        ('gnss-SignalID', _BDS_SgnTypeElement_r12_gnss_SignalID),
        ('dbds-CorrectionList-r12', _BDS_SgnTypeElement_r12_dbds_CorrectionList_r12),
        ])
    BDS_SgnTypeElement_r12._ext = []
    
    #-----< DBDS-CorrectionList-r12 >-----#
    DBDS_CorrectionList_r12 = SEQ_OF(name='DBDS-CorrectionList-r12', mode=MODE_TYPE)
    _DBDS_CorrectionList_r12__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'DBDS-CorrectionElement-r12')))
    DBDS_CorrectionList_r12._cont = _DBDS_CorrectionList_r12__item_
    DBDS_CorrectionList_r12._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DBDS-CorrectionElement-r12 >-----#
    DBDS_CorrectionElement_r12 = SEQ(name='DBDS-CorrectionElement-r12', mode=MODE_TYPE)
    _DBDS_CorrectionElement_r12_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _DBDS_CorrectionElement_r12_bds_UDREI_r12 = INT(name='bds-UDREI-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_CorrectionElement_r12_bds_UDREI_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _DBDS_CorrectionElement_r12_bds_RURAI_r12 = INT(name='bds-RURAI-r12', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_CorrectionElement_r12_bds_RURAI_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _DBDS_CorrectionElement_r12_bds_ECC_DeltaT_r12 = INT(name='bds-ECC-DeltaT-r12', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_CorrectionElement_r12_bds_ECC_DeltaT_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    DBDS_CorrectionElement_r12._cont = ASN1Dict([
        ('svID', _DBDS_CorrectionElement_r12_svID),
        ('bds-UDREI-r12', _DBDS_CorrectionElement_r12_bds_UDREI_r12),
        ('bds-RURAI-r12', _DBDS_CorrectionElement_r12_bds_RURAI_r12),
        ('bds-ECC-DeltaT-r12', _DBDS_CorrectionElement_r12_bds_ECC_DeltaT_r12),
        ])
    DBDS_CorrectionElement_r12._ext = []
    
    #-----< BDS-GridModelParameter-r12 >-----#
    BDS_GridModelParameter_r12 = SEQ(name='BDS-GridModelParameter-r12', mode=MODE_TYPE)
    _BDS_GridModelParameter_r12_bds_RefTime_r12 = INT(name='bds-RefTime-r12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_GridModelParameter_r12_bds_RefTime_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _BDS_GridModelParameter_r12_gridIonList_r12 = SEQ_OF(name='gridIonList-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GridIonList-r12')))
    BDS_GridModelParameter_r12._cont = ASN1Dict([
        ('bds-RefTime-r12', _BDS_GridModelParameter_r12_bds_RefTime_r12),
        ('gridIonList-r12', _BDS_GridModelParameter_r12_gridIonList_r12),
        ])
    BDS_GridModelParameter_r12._ext = []
    
    #-----< GridIonList-r12 >-----#
    GridIonList_r12 = SEQ_OF(name='GridIonList-r12', mode=MODE_TYPE)
    _GridIonList_r12__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GridIonElement-r12')))
    GridIonList_r12._cont = _GridIonList_r12__item_
    GridIonList_r12._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    
    #-----< GridIonElement-r12 >-----#
    GridIonElement_r12 = SEQ(name='GridIonElement-r12', mode=MODE_TYPE)
    _GridIonElement_r12_igp_ID_r12 = INT(name='igp-ID-r12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GridIonElement_r12_igp_ID_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    _GridIonElement_r12_dt_r12 = INT(name='dt-r12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GridIonElement_r12_dt_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _GridIonElement_r12_givei_r12 = INT(name='givei-r12', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GridIonElement_r12_givei_r12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    GridIonElement_r12._cont = ASN1Dict([
        ('igp-ID-r12', _GridIonElement_r12_igp_ID_r12),
        ('dt-r12', _GridIonElement_r12_dt_r12),
        ('givei-r12', _GridIonElement_r12_givei_r12),
        ])
    GridIonElement_r12._ext = []
    
    #-----< A-GNSS-RequestAssistanceData >-----#
    A_GNSS_RequestAssistanceData = SEQ(name='A-GNSS-RequestAssistanceData', mode=MODE_TYPE)
    _A_GNSS_RequestAssistanceData_gnss_CommonAssistDataReq = SEQ(name='gnss-CommonAssistDataReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-CommonAssistDataReq')), opt=True)
    _A_GNSS_RequestAssistanceData_gnss_GenericAssistDataReq = SEQ_OF(name='gnss-GenericAssistDataReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-GenericAssistDataReq')), opt=True)
    A_GNSS_RequestAssistanceData._cont = ASN1Dict([
        ('gnss-CommonAssistDataReq', _A_GNSS_RequestAssistanceData_gnss_CommonAssistDataReq),
        ('gnss-GenericAssistDataReq', _A_GNSS_RequestAssistanceData_gnss_GenericAssistDataReq),
        ])
    A_GNSS_RequestAssistanceData._ext = []
    
    #-----< GNSS-CommonAssistDataReq >-----#
    GNSS_CommonAssistDataReq = SEQ(name='GNSS-CommonAssistDataReq', mode=MODE_TYPE)
    _GNSS_CommonAssistDataReq_gnss_ReferenceTimeReq = SEQ(name='gnss-ReferenceTimeReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceTimeReq')), opt=True)
    _GNSS_CommonAssistDataReq_gnss_ReferenceLocationReq = SEQ(name='gnss-ReferenceLocationReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceLocationReq')), opt=True)
    _GNSS_CommonAssistDataReq_gnss_IonosphericModelReq = SEQ(name='gnss-IonosphericModelReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-IonosphericModelReq')), opt=True)
    _GNSS_CommonAssistDataReq_gnss_EarthOrientationParametersReq = SEQ(name='gnss-EarthOrientationParametersReq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-EarthOrientationParametersReq')), opt=True)
    GNSS_CommonAssistDataReq._cont = ASN1Dict([
        ('gnss-ReferenceTimeReq', _GNSS_CommonAssistDataReq_gnss_ReferenceTimeReq),
        ('gnss-ReferenceLocationReq', _GNSS_CommonAssistDataReq_gnss_ReferenceLocationReq),
        ('gnss-IonosphericModelReq', _GNSS_CommonAssistDataReq_gnss_IonosphericModelReq),
        ('gnss-EarthOrientationParametersReq', _GNSS_CommonAssistDataReq_gnss_EarthOrientationParametersReq),
        ])
    GNSS_CommonAssistDataReq._ext = []
    
    #-----< GNSS-GenericAssistDataReq >-----#
    GNSS_GenericAssistDataReq = SEQ_OF(name='GNSS-GenericAssistDataReq', mode=MODE_TYPE)
    _GNSS_GenericAssistDataReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-GenericAssistDataReqElement')))
    GNSS_GenericAssistDataReq._cont = _GNSS_GenericAssistDataReq__item_
    GNSS_GenericAssistDataReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GNSS-GenericAssistDataReqElement >-----#
    GNSS_GenericAssistDataReqElement = SEQ(name='GNSS-GenericAssistDataReqElement', mode=MODE_TYPE)
    _GNSS_GenericAssistDataReqElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_GenericAssistDataReqElement_sbas_ID = SEQ(name='sbas-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SBAS-ID')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_TimeModelsReq = SEQ_OF(name='gnss-TimeModelsReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-TimeModelListReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_DifferentialCorrectionsReq = SEQ(name='gnss-DifferentialCorrectionsReq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DifferentialCorrectionsReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_NavigationModelReq = CHOICE(name='gnss-NavigationModelReq', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-NavigationModelReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_RealTimeIntegrityReq = SEQ(name='gnss-RealTimeIntegrityReq', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-RealTimeIntegrityReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_DataBitAssistanceReq = SEQ(name='gnss-DataBitAssistanceReq', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitAssistanceReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_AcquisitionAssistanceReq = SEQ(name='gnss-AcquisitionAssistanceReq', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AcquisitionAssistanceReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_AlmanacReq = SEQ(name='gnss-AlmanacReq', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AlmanacReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_UTCModelReq = SEQ(name='gnss-UTCModelReq', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-UTC-ModelReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_gnss_AuxiliaryInformationReq = SEQ(name='gnss-AuxiliaryInformationReq', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AuxiliaryInformationReq')), opt=True)
    _GNSS_GenericAssistDataReqElement_bds_DifferentialCorrectionsReq_r12 = SEQ(name='bds-DifferentialCorrectionsReq-r12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-DifferentialCorrectionsReq-r12')), opt=True, group=0)
    _GNSS_GenericAssistDataReqElement_bds_GridModelReq_r12 = SEQ(name='bds-GridModelReq-r12', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-GridModelReq-r12')), opt=True, group=0)
    GNSS_GenericAssistDataReqElement._cont = ASN1Dict([
        ('gnss-ID', _GNSS_GenericAssistDataReqElement_gnss_ID),
        ('sbas-ID', _GNSS_GenericAssistDataReqElement_sbas_ID),
        ('gnss-TimeModelsReq', _GNSS_GenericAssistDataReqElement_gnss_TimeModelsReq),
        ('gnss-DifferentialCorrectionsReq', _GNSS_GenericAssistDataReqElement_gnss_DifferentialCorrectionsReq),
        ('gnss-NavigationModelReq', _GNSS_GenericAssistDataReqElement_gnss_NavigationModelReq),
        ('gnss-RealTimeIntegrityReq', _GNSS_GenericAssistDataReqElement_gnss_RealTimeIntegrityReq),
        ('gnss-DataBitAssistanceReq', _GNSS_GenericAssistDataReqElement_gnss_DataBitAssistanceReq),
        ('gnss-AcquisitionAssistanceReq', _GNSS_GenericAssistDataReqElement_gnss_AcquisitionAssistanceReq),
        ('gnss-AlmanacReq', _GNSS_GenericAssistDataReqElement_gnss_AlmanacReq),
        ('gnss-UTCModelReq', _GNSS_GenericAssistDataReqElement_gnss_UTCModelReq),
        ('gnss-AuxiliaryInformationReq', _GNSS_GenericAssistDataReqElement_gnss_AuxiliaryInformationReq),
        ('bds-DifferentialCorrectionsReq-r12', _GNSS_GenericAssistDataReqElement_bds_DifferentialCorrectionsReq_r12),
        ('bds-GridModelReq-r12', _GNSS_GenericAssistDataReqElement_bds_GridModelReq_r12),
        ])
    GNSS_GenericAssistDataReqElement._ext = ['bds-DifferentialCorrectionsReq-r12', 'bds-GridModelReq-r12']
    
    #-----< GNSS-ReferenceTimeReq >-----#
    GNSS_ReferenceTimeReq = SEQ(name='GNSS-ReferenceTimeReq', mode=MODE_TYPE)
    _GNSS_ReferenceTimeReq_gnss_TimeReqPrefList = SEQ_OF(name='gnss-TimeReqPrefList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GNSS_ReferenceTimeReq_gnss_TimeReqPrefList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_ReferenceTimeReq_gnss_TimeReqPrefList._cont = __GNSS_ReferenceTimeReq_gnss_TimeReqPrefList__item_
    _GNSS_ReferenceTimeReq_gnss_TimeReqPrefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _GNSS_ReferenceTimeReq_gps_TOW_assistReq = BOOL(name='gps-TOW-assistReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_ReferenceTimeReq_notOfLeapSecReq = BOOL(name='notOfLeapSecReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GNSS_ReferenceTimeReq._cont = ASN1Dict([
        ('gnss-TimeReqPrefList', _GNSS_ReferenceTimeReq_gnss_TimeReqPrefList),
        ('gps-TOW-assistReq', _GNSS_ReferenceTimeReq_gps_TOW_assistReq),
        ('notOfLeapSecReq', _GNSS_ReferenceTimeReq_notOfLeapSecReq),
        ])
    GNSS_ReferenceTimeReq._ext = []
    
    #-----< GNSS-ReferenceLocationReq >-----#
    GNSS_ReferenceLocationReq = SEQ(name='GNSS-ReferenceLocationReq', mode=MODE_TYPE)
    GNSS_ReferenceLocationReq._cont = ASN1Dict([
        ])
    GNSS_ReferenceLocationReq._ext = []
    
    #-----< GNSS-IonosphericModelReq >-----#
    GNSS_IonosphericModelReq = SEQ(name='GNSS-IonosphericModelReq', mode=MODE_TYPE)
    _GNSS_IonosphericModelReq_klobucharModelReq = BIT_STR(name='klobucharModelReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_IonosphericModelReq_klobucharModelReq._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GNSS_IonosphericModelReq_neQuickModelReq = NULL(name='neQuickModelReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GNSS_IonosphericModelReq._cont = ASN1Dict([
        ('klobucharModelReq', _GNSS_IonosphericModelReq_klobucharModelReq),
        ('neQuickModelReq', _GNSS_IonosphericModelReq_neQuickModelReq),
        ])
    GNSS_IonosphericModelReq._ext = []
    
    #-----< GNSS-EarthOrientationParametersReq >-----#
    GNSS_EarthOrientationParametersReq = SEQ(name='GNSS-EarthOrientationParametersReq', mode=MODE_TYPE)
    GNSS_EarthOrientationParametersReq._cont = ASN1Dict([
        ])
    GNSS_EarthOrientationParametersReq._ext = []
    
    #-----< GNSS-TimeModelListReq >-----#
    GNSS_TimeModelListReq = SEQ_OF(name='GNSS-TimeModelListReq', mode=MODE_TYPE)
    _GNSS_TimeModelListReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-TimeModelElementReq')))
    GNSS_TimeModelListReq._cont = _GNSS_TimeModelListReq__item_
    GNSS_TimeModelListReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< GNSS-TimeModelElementReq >-----#
    GNSS_TimeModelElementReq = SEQ(name='GNSS-TimeModelElementReq', mode=MODE_TYPE)
    _GNSS_TimeModelElementReq_gnss_TO_IDsReq = INT(name='gnss-TO-IDsReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_TimeModelElementReq_gnss_TO_IDsReq._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    _GNSS_TimeModelElementReq_deltaTreq = BOOL(name='deltaTreq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GNSS_TimeModelElementReq._cont = ASN1Dict([
        ('gnss-TO-IDsReq', _GNSS_TimeModelElementReq_gnss_TO_IDsReq),
        ('deltaTreq', _GNSS_TimeModelElementReq_deltaTreq),
        ])
    GNSS_TimeModelElementReq._ext = []
    
    #-----< GNSS-DifferentialCorrectionsReq >-----#
    GNSS_DifferentialCorrectionsReq = SEQ(name='GNSS-DifferentialCorrectionsReq', mode=MODE_TYPE)
    _GNSS_DifferentialCorrectionsReq_dgnss_SignalsReq = SEQ(name='dgnss-SignalsReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    _GNSS_DifferentialCorrectionsReq_dgnss_ValidityTimeReq = BOOL(name='dgnss-ValidityTimeReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GNSS_DifferentialCorrectionsReq._cont = ASN1Dict([
        ('dgnss-SignalsReq', _GNSS_DifferentialCorrectionsReq_dgnss_SignalsReq),
        ('dgnss-ValidityTimeReq', _GNSS_DifferentialCorrectionsReq_dgnss_ValidityTimeReq),
        ])
    GNSS_DifferentialCorrectionsReq._ext = []
    
    #-----< GNSS-NavigationModelReq >-----#
    GNSS_NavigationModelReq = CHOICE(name='GNSS-NavigationModelReq', mode=MODE_TYPE)
    _GNSS_NavigationModelReq_storedNavList = SEQ(name='storedNavList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'StoredNavListInfo')))
    _GNSS_NavigationModelReq_reqNavList = SEQ(name='reqNavList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ReqNavListInfo')))
    GNSS_NavigationModelReq._cont = ASN1Dict([
        ('storedNavList', _GNSS_NavigationModelReq_storedNavList),
        ('reqNavList', _GNSS_NavigationModelReq_reqNavList),
        ])
    GNSS_NavigationModelReq._ext = []
    
    #-----< StoredNavListInfo >-----#
    StoredNavListInfo = SEQ(name='StoredNavListInfo', mode=MODE_TYPE)
    _StoredNavListInfo_gnss_WeekOrDay = INT(name='gnss-WeekOrDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StoredNavListInfo_gnss_WeekOrDay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _StoredNavListInfo_gnss_Toe = INT(name='gnss-Toe', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StoredNavListInfo_gnss_Toe._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _StoredNavListInfo_t_toeLimit = INT(name='t-toeLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _StoredNavListInfo_t_toeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _StoredNavListInfo_satListRelatedDataList = SEQ_OF(name='satListRelatedDataList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SatListRelatedDataList')), opt=True)
    StoredNavListInfo._cont = ASN1Dict([
        ('gnss-WeekOrDay', _StoredNavListInfo_gnss_WeekOrDay),
        ('gnss-Toe', _StoredNavListInfo_gnss_Toe),
        ('t-toeLimit', _StoredNavListInfo_t_toeLimit),
        ('satListRelatedDataList', _StoredNavListInfo_satListRelatedDataList),
        ])
    StoredNavListInfo._ext = []
    
    #-----< SatListRelatedDataList >-----#
    SatListRelatedDataList = SEQ_OF(name='SatListRelatedDataList', mode=MODE_TYPE)
    _SatListRelatedDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'SatListRelatedDataElement')))
    SatListRelatedDataList._cont = _SatListRelatedDataList__item_
    SatListRelatedDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SatListRelatedDataElement >-----#
    SatListRelatedDataElement = SEQ(name='SatListRelatedDataElement', mode=MODE_TYPE)
    _SatListRelatedDataElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _SatListRelatedDataElement_iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatListRelatedDataElement_iod._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _SatListRelatedDataElement_clockModelID = INT(name='clockModelID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SatListRelatedDataElement_clockModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _SatListRelatedDataElement_orbitModelID = INT(name='orbitModelID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SatListRelatedDataElement_orbitModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    SatListRelatedDataElement._cont = ASN1Dict([
        ('svID', _SatListRelatedDataElement_svID),
        ('iod', _SatListRelatedDataElement_iod),
        ('clockModelID', _SatListRelatedDataElement_clockModelID),
        ('orbitModelID', _SatListRelatedDataElement_orbitModelID),
        ])
    SatListRelatedDataElement._ext = []
    
    #-----< ReqNavListInfo >-----#
    ReqNavListInfo = SEQ(name='ReqNavListInfo', mode=MODE_TYPE)
    _ReqNavListInfo_svReqList = BIT_STR(name='svReqList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReqNavListInfo_svReqList._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _ReqNavListInfo_clockModelID_PrefList = SEQ_OF(name='clockModelID-PrefList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ReqNavListInfo_clockModelID_PrefList__item_ = INT(name='_item_', mode=MODE_TYPE)
    __ReqNavListInfo_clockModelID_PrefList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _ReqNavListInfo_clockModelID_PrefList._cont = __ReqNavListInfo_clockModelID_PrefList__item_
    _ReqNavListInfo_clockModelID_PrefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _ReqNavListInfo_orbitModelID_PrefList = SEQ_OF(name='orbitModelID-PrefList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ReqNavListInfo_orbitModelID_PrefList__item_ = INT(name='_item_', mode=MODE_TYPE)
    __ReqNavListInfo_orbitModelID_PrefList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _ReqNavListInfo_orbitModelID_PrefList._cont = __ReqNavListInfo_orbitModelID_PrefList__item_
    _ReqNavListInfo_orbitModelID_PrefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _ReqNavListInfo_addNavparamReq = BOOL(name='addNavparamReq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ReqNavListInfo._cont = ASN1Dict([
        ('svReqList', _ReqNavListInfo_svReqList),
        ('clockModelID-PrefList', _ReqNavListInfo_clockModelID_PrefList),
        ('orbitModelID-PrefList', _ReqNavListInfo_orbitModelID_PrefList),
        ('addNavparamReq', _ReqNavListInfo_addNavparamReq),
        ])
    ReqNavListInfo._ext = []
    
    #-----< GNSS-RealTimeIntegrityReq >-----#
    GNSS_RealTimeIntegrityReq = SEQ(name='GNSS-RealTimeIntegrityReq', mode=MODE_TYPE)
    GNSS_RealTimeIntegrityReq._cont = ASN1Dict([
        ])
    GNSS_RealTimeIntegrityReq._ext = []
    
    #-----< GNSS-DataBitAssistanceReq >-----#
    GNSS_DataBitAssistanceReq = SEQ(name='GNSS-DataBitAssistanceReq', mode=MODE_TYPE)
    _GNSS_DataBitAssistanceReq_gnss_TOD_Req = INT(name='gnss-TOD-Req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_DataBitAssistanceReq_gnss_TOD_Req._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _GNSS_DataBitAssistanceReq_gnss_TOD_FracReq = INT(name='gnss-TOD-FracReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_DataBitAssistanceReq_gnss_TOD_FracReq._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GNSS_DataBitAssistanceReq_dataBitInterval = INT(name='dataBitInterval', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_DataBitAssistanceReq_dataBitInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GNSS_DataBitAssistanceReq_gnss_SignalType = SEQ(name='gnss-SignalType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    _GNSS_DataBitAssistanceReq_gnss_DataBitsReq = SEQ_OF(name='gnss-DataBitsReq', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitsReqSatList')), opt=True)
    GNSS_DataBitAssistanceReq._cont = ASN1Dict([
        ('gnss-TOD-Req', _GNSS_DataBitAssistanceReq_gnss_TOD_Req),
        ('gnss-TOD-FracReq', _GNSS_DataBitAssistanceReq_gnss_TOD_FracReq),
        ('dataBitInterval', _GNSS_DataBitAssistanceReq_dataBitInterval),
        ('gnss-SignalType', _GNSS_DataBitAssistanceReq_gnss_SignalType),
        ('gnss-DataBitsReq', _GNSS_DataBitAssistanceReq_gnss_DataBitsReq),
        ])
    GNSS_DataBitAssistanceReq._ext = []
    
    #-----< GNSS-DataBitsReqSatList >-----#
    GNSS_DataBitsReqSatList = SEQ_OF(name='GNSS-DataBitsReqSatList', mode=MODE_TYPE)
    _GNSS_DataBitsReqSatList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitsReqSatElement')))
    GNSS_DataBitsReqSatList._cont = _GNSS_DataBitsReqSatList__item_
    GNSS_DataBitsReqSatList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-DataBitsReqSatElement >-----#
    GNSS_DataBitsReqSatElement = SEQ(name='GNSS-DataBitsReqSatElement', mode=MODE_TYPE)
    _GNSS_DataBitsReqSatElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    GNSS_DataBitsReqSatElement._cont = ASN1Dict([
        ('svID', _GNSS_DataBitsReqSatElement_svID),
        ])
    GNSS_DataBitsReqSatElement._ext = []
    
    #-----< GNSS-AcquisitionAssistanceReq >-----#
    GNSS_AcquisitionAssistanceReq = SEQ(name='GNSS-AcquisitionAssistanceReq', mode=MODE_TYPE)
    _GNSS_AcquisitionAssistanceReq_gnss_SignalID_Req = SEQ(name='gnss-SignalID-Req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    GNSS_AcquisitionAssistanceReq._cont = ASN1Dict([
        ('gnss-SignalID-Req', _GNSS_AcquisitionAssistanceReq_gnss_SignalID_Req),
        ])
    GNSS_AcquisitionAssistanceReq._ext = []
    
    #-----< GNSS-AlmanacReq >-----#
    GNSS_AlmanacReq = SEQ(name='GNSS-AlmanacReq', mode=MODE_TYPE)
    _GNSS_AlmanacReq_modelID = INT(name='modelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AlmanacReq_modelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    GNSS_AlmanacReq._cont = ASN1Dict([
        ('modelID', _GNSS_AlmanacReq_modelID),
        ])
    GNSS_AlmanacReq._ext = []
    
    #-----< GNSS-UTC-ModelReq >-----#
    GNSS_UTC_ModelReq = SEQ(name='GNSS-UTC-ModelReq', mode=MODE_TYPE)
    _GNSS_UTC_ModelReq_modelID = INT(name='modelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_UTC_ModelReq_modelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    GNSS_UTC_ModelReq._cont = ASN1Dict([
        ('modelID', _GNSS_UTC_ModelReq_modelID),
        ])
    GNSS_UTC_ModelReq._ext = []
    
    #-----< GNSS-AuxiliaryInformationReq >-----#
    GNSS_AuxiliaryInformationReq = SEQ(name='GNSS-AuxiliaryInformationReq', mode=MODE_TYPE)
    GNSS_AuxiliaryInformationReq._cont = ASN1Dict([
        ])
    GNSS_AuxiliaryInformationReq._ext = []
    
    #-----< BDS-DifferentialCorrectionsReq-r12 >-----#
    BDS_DifferentialCorrectionsReq_r12 = SEQ(name='BDS-DifferentialCorrectionsReq-r12', mode=MODE_TYPE)
    _BDS_DifferentialCorrectionsReq_r12_dgnss_SignalsReq = SEQ(name='dgnss-SignalsReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    BDS_DifferentialCorrectionsReq_r12._cont = ASN1Dict([
        ('dgnss-SignalsReq', _BDS_DifferentialCorrectionsReq_r12_dgnss_SignalsReq),
        ])
    BDS_DifferentialCorrectionsReq_r12._ext = []
    
    #-----< BDS-GridModelReq-r12 >-----#
    BDS_GridModelReq_r12 = SEQ(name='BDS-GridModelReq-r12', mode=MODE_TYPE)
    BDS_GridModelReq_r12._cont = ASN1Dict([
        ])
    BDS_GridModelReq_r12._ext = []
    
    #-----< A-GNSS-ProvideLocationInformation >-----#
    A_GNSS_ProvideLocationInformation = SEQ(name='A-GNSS-ProvideLocationInformation', mode=MODE_TYPE)
    _A_GNSS_ProvideLocationInformation_gnss_SignalMeasurementInformation = SEQ(name='gnss-SignalMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalMeasurementInformation')), opt=True)
    _A_GNSS_ProvideLocationInformation_gnss_LocationInformation = SEQ(name='gnss-LocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-LocationInformation')), opt=True)
    _A_GNSS_ProvideLocationInformation_gnss_Error = CHOICE(name='gnss-Error', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'A-GNSS-Error')), opt=True)
    A_GNSS_ProvideLocationInformation._cont = ASN1Dict([
        ('gnss-SignalMeasurementInformation', _A_GNSS_ProvideLocationInformation_gnss_SignalMeasurementInformation),
        ('gnss-LocationInformation', _A_GNSS_ProvideLocationInformation_gnss_LocationInformation),
        ('gnss-Error', _A_GNSS_ProvideLocationInformation_gnss_Error),
        ])
    A_GNSS_ProvideLocationInformation._ext = []
    
    #-----< GNSS-SignalMeasurementInformation >-----#
    GNSS_SignalMeasurementInformation = SEQ(name='GNSS-SignalMeasurementInformation', mode=MODE_TYPE)
    _GNSS_SignalMeasurementInformation_measurementReferenceTime = SEQ(name='measurementReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'MeasurementReferenceTime')))
    _GNSS_SignalMeasurementInformation_gnss_MeasurementList = SEQ_OF(name='gnss-MeasurementList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-MeasurementList')))
    GNSS_SignalMeasurementInformation._cont = ASN1Dict([
        ('measurementReferenceTime', _GNSS_SignalMeasurementInformation_measurementReferenceTime),
        ('gnss-MeasurementList', _GNSS_SignalMeasurementInformation_gnss_MeasurementList),
        ])
    GNSS_SignalMeasurementInformation._ext = []
    
    #-----< MeasurementReferenceTime >-----#
    MeasurementReferenceTime = SEQ(name='MeasurementReferenceTime', mode=MODE_TYPE)
    _MeasurementReferenceTime_gnss_TOD_msec = INT(name='gnss-TOD-msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasurementReferenceTime_gnss_TOD_msec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599999)], ev=None, er=[])
    _MeasurementReferenceTime_gnss_TOD_frac = INT(name='gnss-TOD-frac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeasurementReferenceTime_gnss_TOD_frac._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3999)], ev=None, er=[])
    _MeasurementReferenceTime_gnss_TOD_unc = INT(name='gnss-TOD-unc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeasurementReferenceTime_gnss_TOD_unc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _MeasurementReferenceTime_gnss_TimeID = SEQ(name='gnss-TimeID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _MeasurementReferenceTime_networkTime = CHOICE(name='networkTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MeasurementReferenceTime_networkTime_eUTRA = SEQ(name='eUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_eUTRA_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_eUTRA_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    ___MeasurementReferenceTime_networkTime_eUTRA_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    ___MeasurementReferenceTime_networkTime_eUTRA_systemFrameNumber = BIT_STR(name='systemFrameNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_eUTRA_systemFrameNumber._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __MeasurementReferenceTime_networkTime_eUTRA._cont = ASN1Dict([
        ('physCellId', ___MeasurementReferenceTime_networkTime_eUTRA_physCellId),
        ('cellGlobalId', ___MeasurementReferenceTime_networkTime_eUTRA_cellGlobalId),
        ('systemFrameNumber', ___MeasurementReferenceTime_networkTime_eUTRA_systemFrameNumber),
        ])
    __MeasurementReferenceTime_networkTime_eUTRA._ext = []
    __MeasurementReferenceTime_networkTime_uTRA = SEQ(name='uTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_uTRA_mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____MeasurementReferenceTime_networkTime_uTRA_mode_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____MeasurementReferenceTime_networkTime_uTRA_mode_fdd_primary_CPICH_Info = INT(name='primary-CPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____MeasurementReferenceTime_networkTime_uTRA_mode_fdd_primary_CPICH_Info._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    ____MeasurementReferenceTime_networkTime_uTRA_mode_fdd._cont = ASN1Dict([
        ('primary-CPICH-Info', _____MeasurementReferenceTime_networkTime_uTRA_mode_fdd_primary_CPICH_Info),
        ])
    ____MeasurementReferenceTime_networkTime_uTRA_mode_fdd._ext = []
    ____MeasurementReferenceTime_networkTime_uTRA_mode_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____MeasurementReferenceTime_networkTime_uTRA_mode_tdd_cellParameters = INT(name='cellParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____MeasurementReferenceTime_networkTime_uTRA_mode_tdd_cellParameters._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ____MeasurementReferenceTime_networkTime_uTRA_mode_tdd._cont = ASN1Dict([
        ('cellParameters', _____MeasurementReferenceTime_networkTime_uTRA_mode_tdd_cellParameters),
        ])
    ____MeasurementReferenceTime_networkTime_uTRA_mode_tdd._ext = []
    ___MeasurementReferenceTime_networkTime_uTRA_mode._cont = ASN1Dict([
        ('fdd', ____MeasurementReferenceTime_networkTime_uTRA_mode_fdd),
        ('tdd', ____MeasurementReferenceTime_networkTime_uTRA_mode_tdd),
        ])
    ___MeasurementReferenceTime_networkTime_uTRA_mode._ext = None
    ___MeasurementReferenceTime_networkTime_uTRA_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    ___MeasurementReferenceTime_networkTime_uTRA_referenceSystemFrameNumber = INT(name='referenceSystemFrameNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_uTRA_referenceSystemFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    __MeasurementReferenceTime_networkTime_uTRA._cont = ASN1Dict([
        ('mode', ___MeasurementReferenceTime_networkTime_uTRA_mode),
        ('cellGlobalId', ___MeasurementReferenceTime_networkTime_uTRA_cellGlobalId),
        ('referenceSystemFrameNumber', ___MeasurementReferenceTime_networkTime_uTRA_referenceSystemFrameNumber),
        ])
    __MeasurementReferenceTime_networkTime_uTRA._ext = []
    __MeasurementReferenceTime_networkTime_gSM = SEQ(name='gSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_gSM_bcchCarrier = INT(name='bcchCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_gSM_bcchCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    ___MeasurementReferenceTime_networkTime_gSM_bsic = INT(name='bsic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MeasurementReferenceTime_networkTime_gSM_bsic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    ___MeasurementReferenceTime_networkTime_gSM_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdGERAN')), opt=True)
    ___MeasurementReferenceTime_networkTime_gSM_referenceFrame = SEQ(name='referenceFrame', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFN = INT(name='referenceFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFNMSB = INT(name='referenceFNMSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFNMSB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    ___MeasurementReferenceTime_networkTime_gSM_referenceFrame._cont = ASN1Dict([
        ('referenceFN', ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFN),
        ('referenceFNMSB', ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFNMSB),
        ])
    ___MeasurementReferenceTime_networkTime_gSM_referenceFrame._ext = []
    ___MeasurementReferenceTime_networkTime_gSM_deltaGNSS_TOD = INT(name='deltaGNSS-TOD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___MeasurementReferenceTime_networkTime_gSM_deltaGNSS_TOD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    __MeasurementReferenceTime_networkTime_gSM._cont = ASN1Dict([
        ('bcchCarrier', ___MeasurementReferenceTime_networkTime_gSM_bcchCarrier),
        ('bsic', ___MeasurementReferenceTime_networkTime_gSM_bsic),
        ('cellGlobalId', ___MeasurementReferenceTime_networkTime_gSM_cellGlobalId),
        ('referenceFrame', ___MeasurementReferenceTime_networkTime_gSM_referenceFrame),
        ('deltaGNSS-TOD', ___MeasurementReferenceTime_networkTime_gSM_deltaGNSS_TOD),
        ])
    __MeasurementReferenceTime_networkTime_gSM._ext = []
    _MeasurementReferenceTime_networkTime._cont = ASN1Dict([
        ('eUTRA', __MeasurementReferenceTime_networkTime_eUTRA),
        ('uTRA', __MeasurementReferenceTime_networkTime_uTRA),
        ('gSM', __MeasurementReferenceTime_networkTime_gSM),
        ])
    _MeasurementReferenceTime_networkTime._ext = []
    MeasurementReferenceTime._cont = ASN1Dict([
        ('gnss-TOD-msec', _MeasurementReferenceTime_gnss_TOD_msec),
        ('gnss-TOD-frac', _MeasurementReferenceTime_gnss_TOD_frac),
        ('gnss-TOD-unc', _MeasurementReferenceTime_gnss_TOD_unc),
        ('gnss-TimeID', _MeasurementReferenceTime_gnss_TimeID),
        ('networkTime', _MeasurementReferenceTime_networkTime),
        ])
    MeasurementReferenceTime._ext = []
    
    #-----< GNSS-MeasurementList >-----#
    GNSS_MeasurementList = SEQ_OF(name='GNSS-MeasurementList', mode=MODE_TYPE)
    _GNSS_MeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-MeasurementForOneGNSS')))
    GNSS_MeasurementList._cont = _GNSS_MeasurementList__item_
    GNSS_MeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GNSS-MeasurementForOneGNSS >-----#
    GNSS_MeasurementForOneGNSS = SEQ(name='GNSS-MeasurementForOneGNSS', mode=MODE_TYPE)
    _GNSS_MeasurementForOneGNSS_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_MeasurementForOneGNSS_gnss_SgnMeasList = SEQ_OF(name='gnss-SgnMeasList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SgnMeasList')))
    GNSS_MeasurementForOneGNSS._cont = ASN1Dict([
        ('gnss-ID', _GNSS_MeasurementForOneGNSS_gnss_ID),
        ('gnss-SgnMeasList', _GNSS_MeasurementForOneGNSS_gnss_SgnMeasList),
        ])
    GNSS_MeasurementForOneGNSS._ext = []
    
    #-----< GNSS-SgnMeasList >-----#
    GNSS_SgnMeasList = SEQ_OF(name='GNSS-SgnMeasList', mode=MODE_TYPE)
    _GNSS_SgnMeasList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SgnMeasElement')))
    GNSS_SgnMeasList._cont = _GNSS_SgnMeasList__item_
    GNSS_SgnMeasList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GNSS-SgnMeasElement >-----#
    GNSS_SgnMeasElement = SEQ(name='GNSS-SgnMeasElement', mode=MODE_TYPE)
    _GNSS_SgnMeasElement_gnss_SignalID = SEQ(name='gnss-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _GNSS_SgnMeasElement_gnss_CodePhaseAmbiguity = INT(name='gnss-CodePhaseAmbiguity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SgnMeasElement_gnss_CodePhaseAmbiguity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GNSS_SgnMeasElement_gnss_SatMeasList = SEQ_OF(name='gnss-SatMeasList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SatMeasList')))
    GNSS_SgnMeasElement._cont = ASN1Dict([
        ('gnss-SignalID', _GNSS_SgnMeasElement_gnss_SignalID),
        ('gnss-CodePhaseAmbiguity', _GNSS_SgnMeasElement_gnss_CodePhaseAmbiguity),
        ('gnss-SatMeasList', _GNSS_SgnMeasElement_gnss_SatMeasList),
        ])
    GNSS_SgnMeasElement._ext = []
    
    #-----< GNSS-SatMeasList >-----#
    GNSS_SatMeasList = SEQ_OF(name='GNSS-SatMeasList', mode=MODE_TYPE)
    _GNSS_SatMeasList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SatMeasElement')))
    GNSS_SatMeasList._cont = _GNSS_SatMeasList__item_
    GNSS_SatMeasList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GNSS-SatMeasElement >-----#
    GNSS_SatMeasElement = SEQ(name='GNSS-SatMeasElement', mode=MODE_TYPE)
    _GNSS_SatMeasElement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _GNSS_SatMeasElement_cNo = INT(name='cNo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SatMeasElement_cNo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GNSS_SatMeasElement_mpathDet = ENUM(name='mpathDet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SatMeasElement_mpathDet._cont = ASN1Dict([('notMeasured', 0), ('low', 1), ('medium', 2), ('high', 3)])
    _GNSS_SatMeasElement_mpathDet._ext = []
    _GNSS_SatMeasElement_carrierQualityInd = INT(name='carrierQualityInd', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SatMeasElement_carrierQualityInd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _GNSS_SatMeasElement_codePhase = INT(name='codePhase', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SatMeasElement_codePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2097151)], ev=None, er=[])
    _GNSS_SatMeasElement_integerCodePhase = INT(name='integerCodePhase', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SatMeasElement_integerCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GNSS_SatMeasElement_codePhaseRMSError = INT(name='codePhaseRMSError', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SatMeasElement_codePhaseRMSError._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GNSS_SatMeasElement_doppler = INT(name='doppler', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SatMeasElement_doppler._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _GNSS_SatMeasElement_adr = INT(name='adr', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_SatMeasElement_adr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=33554431)], ev=None, er=[])
    GNSS_SatMeasElement._cont = ASN1Dict([
        ('svID', _GNSS_SatMeasElement_svID),
        ('cNo', _GNSS_SatMeasElement_cNo),
        ('mpathDet', _GNSS_SatMeasElement_mpathDet),
        ('carrierQualityInd', _GNSS_SatMeasElement_carrierQualityInd),
        ('codePhase', _GNSS_SatMeasElement_codePhase),
        ('integerCodePhase', _GNSS_SatMeasElement_integerCodePhase),
        ('codePhaseRMSError', _GNSS_SatMeasElement_codePhaseRMSError),
        ('doppler', _GNSS_SatMeasElement_doppler),
        ('adr', _GNSS_SatMeasElement_adr),
        ])
    GNSS_SatMeasElement._ext = []
    
    #-----< GNSS-LocationInformation >-----#
    GNSS_LocationInformation = SEQ(name='GNSS-LocationInformation', mode=MODE_TYPE)
    _GNSS_LocationInformation_measurementReferenceTime = SEQ(name='measurementReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'MeasurementReferenceTime')))
    _GNSS_LocationInformation_agnss_List = SEQ(name='agnss-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-Bitmap')))
    GNSS_LocationInformation._cont = ASN1Dict([
        ('measurementReferenceTime', _GNSS_LocationInformation_measurementReferenceTime),
        ('agnss-List', _GNSS_LocationInformation_agnss_List),
        ])
    GNSS_LocationInformation._ext = []
    
    #-----< A-GNSS-RequestLocationInformation >-----#
    A_GNSS_RequestLocationInformation = SEQ(name='A-GNSS-RequestLocationInformation', mode=MODE_TYPE)
    _A_GNSS_RequestLocationInformation_gnss_PositioningInstructions = SEQ(name='gnss-PositioningInstructions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-PositioningInstructions')))
    A_GNSS_RequestLocationInformation._cont = ASN1Dict([
        ('gnss-PositioningInstructions', _A_GNSS_RequestLocationInformation_gnss_PositioningInstructions),
        ])
    A_GNSS_RequestLocationInformation._ext = []
    
    #-----< GNSS-PositioningInstructions >-----#
    GNSS_PositioningInstructions = SEQ(name='GNSS-PositioningInstructions', mode=MODE_TYPE)
    _GNSS_PositioningInstructions_gnss_Methods = SEQ(name='gnss-Methods', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-Bitmap')))
    _GNSS_PositioningInstructions_fineTimeAssistanceMeasReq = BOOL(name='fineTimeAssistanceMeasReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_PositioningInstructions_adrMeasReq = BOOL(name='adrMeasReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_PositioningInstructions_multiFreqMeasReq = BOOL(name='multiFreqMeasReq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_PositioningInstructions_assistanceAvailability = BOOL(name='assistanceAvailability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GNSS_PositioningInstructions._cont = ASN1Dict([
        ('gnss-Methods', _GNSS_PositioningInstructions_gnss_Methods),
        ('fineTimeAssistanceMeasReq', _GNSS_PositioningInstructions_fineTimeAssistanceMeasReq),
        ('adrMeasReq', _GNSS_PositioningInstructions_adrMeasReq),
        ('multiFreqMeasReq', _GNSS_PositioningInstructions_multiFreqMeasReq),
        ('assistanceAvailability', _GNSS_PositioningInstructions_assistanceAvailability),
        ])
    GNSS_PositioningInstructions._ext = []
    
    #-----< A-GNSS-ProvideCapabilities >-----#
    A_GNSS_ProvideCapabilities = SEQ(name='A-GNSS-ProvideCapabilities', mode=MODE_TYPE)
    _A_GNSS_ProvideCapabilities_gnss_SupportList = SEQ_OF(name='gnss-SupportList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SupportList')), opt=True)
    _A_GNSS_ProvideCapabilities_assistanceDataSupportList = SEQ(name='assistanceDataSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AssistanceDataSupportList')), opt=True)
    _A_GNSS_ProvideCapabilities_locationCoordinateTypes = SEQ(name='locationCoordinateTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'LocationCoordinateTypes')), opt=True)
    _A_GNSS_ProvideCapabilities_velocityTypes = SEQ(name='velocityTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'VelocityTypes')), opt=True)
    A_GNSS_ProvideCapabilities._cont = ASN1Dict([
        ('gnss-SupportList', _A_GNSS_ProvideCapabilities_gnss_SupportList),
        ('assistanceDataSupportList', _A_GNSS_ProvideCapabilities_assistanceDataSupportList),
        ('locationCoordinateTypes', _A_GNSS_ProvideCapabilities_locationCoordinateTypes),
        ('velocityTypes', _A_GNSS_ProvideCapabilities_velocityTypes),
        ])
    A_GNSS_ProvideCapabilities._ext = []
    
    #-----< GNSS-SupportList >-----#
    GNSS_SupportList = SEQ_OF(name='GNSS-SupportList', mode=MODE_TYPE)
    _GNSS_SupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SupportElement')))
    GNSS_SupportList._cont = _GNSS_SupportList__item_
    GNSS_SupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GNSS-SupportElement >-----#
    GNSS_SupportElement = SEQ(name='GNSS-SupportElement', mode=MODE_TYPE)
    _GNSS_SupportElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_SupportElement_sbas_IDs = SEQ(name='sbas-IDs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SBAS-IDs')), opt=True)
    _GNSS_SupportElement_agnss_Modes = SEQ(name='agnss-Modes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'PositioningModes')))
    _GNSS_SupportElement_gnss_Signals = SEQ(name='gnss-Signals', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    _GNSS_SupportElement_fta_MeasSupport = SEQ(name='fta-MeasSupport', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GNSS_SupportElement_fta_MeasSupport_cellTime = SEQ(name='cellTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AccessTypes')))
    __GNSS_SupportElement_fta_MeasSupport_mode = SEQ(name='mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'PositioningModes')))
    _GNSS_SupportElement_fta_MeasSupport._cont = ASN1Dict([
        ('cellTime', __GNSS_SupportElement_fta_MeasSupport_cellTime),
        ('mode', __GNSS_SupportElement_fta_MeasSupport_mode),
        ])
    _GNSS_SupportElement_fta_MeasSupport._ext = []
    _GNSS_SupportElement_adr_Support = BOOL(name='adr-Support', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SupportElement_velocityMeasurementSupport = BOOL(name='velocityMeasurementSupport', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GNSS_SupportElement._cont = ASN1Dict([
        ('gnss-ID', _GNSS_SupportElement_gnss_ID),
        ('sbas-IDs', _GNSS_SupportElement_sbas_IDs),
        ('agnss-Modes', _GNSS_SupportElement_agnss_Modes),
        ('gnss-Signals', _GNSS_SupportElement_gnss_Signals),
        ('fta-MeasSupport', _GNSS_SupportElement_fta_MeasSupport),
        ('adr-Support', _GNSS_SupportElement_adr_Support),
        ('velocityMeasurementSupport', _GNSS_SupportElement_velocityMeasurementSupport),
        ])
    GNSS_SupportElement._ext = []
    
    #-----< AssistanceDataSupportList >-----#
    AssistanceDataSupportList = SEQ(name='AssistanceDataSupportList', mode=MODE_TYPE)
    _AssistanceDataSupportList_gnss_CommonAssistanceDataSupport = SEQ(name='gnss-CommonAssistanceDataSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-CommonAssistanceDataSupport')))
    _AssistanceDataSupportList_gnss_GenericAssistanceDataSupport = SEQ_OF(name='gnss-GenericAssistanceDataSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-GenericAssistanceDataSupport')))
    AssistanceDataSupportList._cont = ASN1Dict([
        ('gnss-CommonAssistanceDataSupport', _AssistanceDataSupportList_gnss_CommonAssistanceDataSupport),
        ('gnss-GenericAssistanceDataSupport', _AssistanceDataSupportList_gnss_GenericAssistanceDataSupport),
        ])
    AssistanceDataSupportList._ext = []
    
    #-----< GNSS-CommonAssistanceDataSupport >-----#
    GNSS_CommonAssistanceDataSupport = SEQ(name='GNSS-CommonAssistanceDataSupport', mode=MODE_TYPE)
    _GNSS_CommonAssistanceDataSupport_gnss_ReferenceTimeSupport = SEQ(name='gnss-ReferenceTimeSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceTimeSupport')), opt=True)
    _GNSS_CommonAssistanceDataSupport_gnss_ReferenceLocationSupport = SEQ(name='gnss-ReferenceLocationSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceLocationSupport')), opt=True)
    _GNSS_CommonAssistanceDataSupport_gnss_IonosphericModelSupport = SEQ(name='gnss-IonosphericModelSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-IonosphericModelSupport')), opt=True)
    _GNSS_CommonAssistanceDataSupport_gnss_EarthOrientationParametersSupport = SEQ(name='gnss-EarthOrientationParametersSupport', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-EarthOrientationParametersSupport')), opt=True)
    GNSS_CommonAssistanceDataSupport._cont = ASN1Dict([
        ('gnss-ReferenceTimeSupport', _GNSS_CommonAssistanceDataSupport_gnss_ReferenceTimeSupport),
        ('gnss-ReferenceLocationSupport', _GNSS_CommonAssistanceDataSupport_gnss_ReferenceLocationSupport),
        ('gnss-IonosphericModelSupport', _GNSS_CommonAssistanceDataSupport_gnss_IonosphericModelSupport),
        ('gnss-EarthOrientationParametersSupport', _GNSS_CommonAssistanceDataSupport_gnss_EarthOrientationParametersSupport),
        ])
    GNSS_CommonAssistanceDataSupport._ext = []
    
    #-----< GNSS-ReferenceTimeSupport >-----#
    GNSS_ReferenceTimeSupport = SEQ(name='GNSS-ReferenceTimeSupport', mode=MODE_TYPE)
    _GNSS_ReferenceTimeSupport_gnss_SystemTime = SEQ(name='gnss-SystemTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-Bitmap')))
    _GNSS_ReferenceTimeSupport_fta_Support = SEQ(name='fta-Support', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'AccessTypes')), opt=True)
    GNSS_ReferenceTimeSupport._cont = ASN1Dict([
        ('gnss-SystemTime', _GNSS_ReferenceTimeSupport_gnss_SystemTime),
        ('fta-Support', _GNSS_ReferenceTimeSupport_fta_Support),
        ])
    GNSS_ReferenceTimeSupport._ext = []
    
    #-----< GNSS-ReferenceLocationSupport >-----#
    GNSS_ReferenceLocationSupport = SEQ(name='GNSS-ReferenceLocationSupport', mode=MODE_TYPE)
    GNSS_ReferenceLocationSupport._cont = ASN1Dict([
        ])
    GNSS_ReferenceLocationSupport._ext = []
    
    #-----< GNSS-IonosphericModelSupport >-----#
    GNSS_IonosphericModelSupport = SEQ(name='GNSS-IonosphericModelSupport', mode=MODE_TYPE)
    _GNSS_IonosphericModelSupport_ionoModel = BIT_STR(name='ionoModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_IonosphericModelSupport_ionoModel._cont = ASN1Dict([('klobuchar', 0), ('neQuick', 1)])
    _GNSS_IonosphericModelSupport_ionoModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    GNSS_IonosphericModelSupport._cont = ASN1Dict([
        ('ionoModel', _GNSS_IonosphericModelSupport_ionoModel),
        ])
    GNSS_IonosphericModelSupport._ext = []
    
    #-----< GNSS-EarthOrientationParametersSupport >-----#
    GNSS_EarthOrientationParametersSupport = SEQ(name='GNSS-EarthOrientationParametersSupport', mode=MODE_TYPE)
    GNSS_EarthOrientationParametersSupport._cont = ASN1Dict([
        ])
    GNSS_EarthOrientationParametersSupport._ext = []
    
    #-----< GNSS-GenericAssistanceDataSupport >-----#
    GNSS_GenericAssistanceDataSupport = SEQ_OF(name='GNSS-GenericAssistanceDataSupport', mode=MODE_TYPE)
    _GNSS_GenericAssistanceDataSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-GenericAssistDataSupportElement')))
    GNSS_GenericAssistanceDataSupport._cont = _GNSS_GenericAssistanceDataSupport__item_
    GNSS_GenericAssistanceDataSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GNSS-GenericAssistDataSupportElement >-----#
    GNSS_GenericAssistDataSupportElement = SEQ(name='GNSS-GenericAssistDataSupportElement', mode=MODE_TYPE)
    _GNSS_GenericAssistDataSupportElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _GNSS_GenericAssistDataSupportElement_sbas_ID = SEQ(name='sbas-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SBAS-ID')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_TimeModelsSupport = SEQ(name='gnss-TimeModelsSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-TimeModelListSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_DifferentialCorrectionsSupport = SEQ(name='gnss-DifferentialCorrectionsSupport', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DifferentialCorrectionsSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_NavigationModelSupport = SEQ(name='gnss-NavigationModelSupport', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-NavigationModelSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_RealTimeIntegritySupport = SEQ(name='gnss-RealTimeIntegritySupport', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-RealTimeIntegritySupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_DataBitAssistanceSupport = SEQ(name='gnss-DataBitAssistanceSupport', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-DataBitAssistanceSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_AcquisitionAssistanceSupport = SEQ(name='gnss-AcquisitionAssistanceSupport', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AcquisitionAssistanceSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_AlmanacSupport = SEQ(name='gnss-AlmanacSupport', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AlmanacSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_UTC_ModelSupport = SEQ(name='gnss-UTC-ModelSupport', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-UTC-ModelSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_gnss_AuxiliaryInformationSupport = SEQ(name='gnss-AuxiliaryInformationSupport', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-AuxiliaryInformationSupport')), opt=True)
    _GNSS_GenericAssistDataSupportElement_bds_DifferentialCorrectionsSupport_r12 = SEQ(name='bds-DifferentialCorrectionsSupport-r12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-DifferentialCorrectionsSupport-r12')), opt=True, group=0)
    _GNSS_GenericAssistDataSupportElement_bds_GridModelSupport_r12 = SEQ(name='bds-GridModelSupport-r12', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BDS-GridModelSupport-r12')), opt=True, group=0)
    GNSS_GenericAssistDataSupportElement._cont = ASN1Dict([
        ('gnss-ID', _GNSS_GenericAssistDataSupportElement_gnss_ID),
        ('sbas-ID', _GNSS_GenericAssistDataSupportElement_sbas_ID),
        ('gnss-TimeModelsSupport', _GNSS_GenericAssistDataSupportElement_gnss_TimeModelsSupport),
        ('gnss-DifferentialCorrectionsSupport', _GNSS_GenericAssistDataSupportElement_gnss_DifferentialCorrectionsSupport),
        ('gnss-NavigationModelSupport', _GNSS_GenericAssistDataSupportElement_gnss_NavigationModelSupport),
        ('gnss-RealTimeIntegritySupport', _GNSS_GenericAssistDataSupportElement_gnss_RealTimeIntegritySupport),
        ('gnss-DataBitAssistanceSupport', _GNSS_GenericAssistDataSupportElement_gnss_DataBitAssistanceSupport),
        ('gnss-AcquisitionAssistanceSupport', _GNSS_GenericAssistDataSupportElement_gnss_AcquisitionAssistanceSupport),
        ('gnss-AlmanacSupport', _GNSS_GenericAssistDataSupportElement_gnss_AlmanacSupport),
        ('gnss-UTC-ModelSupport', _GNSS_GenericAssistDataSupportElement_gnss_UTC_ModelSupport),
        ('gnss-AuxiliaryInformationSupport', _GNSS_GenericAssistDataSupportElement_gnss_AuxiliaryInformationSupport),
        ('bds-DifferentialCorrectionsSupport-r12', _GNSS_GenericAssistDataSupportElement_bds_DifferentialCorrectionsSupport_r12),
        ('bds-GridModelSupport-r12', _GNSS_GenericAssistDataSupportElement_bds_GridModelSupport_r12),
        ])
    GNSS_GenericAssistDataSupportElement._ext = ['bds-DifferentialCorrectionsSupport-r12', 'bds-GridModelSupport-r12']
    
    #-----< GNSS-TimeModelListSupport >-----#
    GNSS_TimeModelListSupport = SEQ(name='GNSS-TimeModelListSupport', mode=MODE_TYPE)
    GNSS_TimeModelListSupport._cont = ASN1Dict([
        ])
    GNSS_TimeModelListSupport._ext = []
    
    #-----< GNSS-DifferentialCorrectionsSupport >-----#
    GNSS_DifferentialCorrectionsSupport = SEQ(name='GNSS-DifferentialCorrectionsSupport', mode=MODE_TYPE)
    _GNSS_DifferentialCorrectionsSupport_gnssSignalIDs = SEQ(name='gnssSignalIDs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    _GNSS_DifferentialCorrectionsSupport_dgnss_ValidityTimeSup = BOOL(name='dgnss-ValidityTimeSup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GNSS_DifferentialCorrectionsSupport._cont = ASN1Dict([
        ('gnssSignalIDs', _GNSS_DifferentialCorrectionsSupport_gnssSignalIDs),
        ('dgnss-ValidityTimeSup', _GNSS_DifferentialCorrectionsSupport_dgnss_ValidityTimeSup),
        ])
    GNSS_DifferentialCorrectionsSupport._ext = []
    
    #-----< GNSS-NavigationModelSupport >-----#
    GNSS_NavigationModelSupport = SEQ(name='GNSS-NavigationModelSupport', mode=MODE_TYPE)
    _GNSS_NavigationModelSupport_clockModel = BIT_STR(name='clockModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_NavigationModelSupport_clockModel._cont = ASN1Dict([('model-1', 0), ('model-2', 1), ('model-3', 2), ('model-4', 3), ('model-5', 4), ('model-6', 5)])
    _GNSS_NavigationModelSupport_clockModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _GNSS_NavigationModelSupport_orbitModel = BIT_STR(name='orbitModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_NavigationModelSupport_orbitModel._cont = ASN1Dict([('model-1', 0), ('model-2', 1), ('model-3', 2), ('model-4', 3), ('model-5', 4), ('model-6', 5)])
    _GNSS_NavigationModelSupport_orbitModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    GNSS_NavigationModelSupport._cont = ASN1Dict([
        ('clockModel', _GNSS_NavigationModelSupport_clockModel),
        ('orbitModel', _GNSS_NavigationModelSupport_orbitModel),
        ])
    GNSS_NavigationModelSupport._ext = []
    
    #-----< GNSS-RealTimeIntegritySupport >-----#
    GNSS_RealTimeIntegritySupport = SEQ(name='GNSS-RealTimeIntegritySupport', mode=MODE_TYPE)
    GNSS_RealTimeIntegritySupport._cont = ASN1Dict([
        ])
    GNSS_RealTimeIntegritySupport._ext = []
    
    #-----< GNSS-DataBitAssistanceSupport >-----#
    GNSS_DataBitAssistanceSupport = SEQ(name='GNSS-DataBitAssistanceSupport', mode=MODE_TYPE)
    GNSS_DataBitAssistanceSupport._cont = ASN1Dict([
        ])
    GNSS_DataBitAssistanceSupport._ext = []
    
    #-----< GNSS-AcquisitionAssistanceSupport >-----#
    GNSS_AcquisitionAssistanceSupport = SEQ(name='GNSS-AcquisitionAssistanceSupport', mode=MODE_TYPE)
    _GNSS_AcquisitionAssistanceSupport_confidenceSupport_r10 = ENUM(name='confidenceSupport-r10', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AcquisitionAssistanceSupport_confidenceSupport_r10._cont = ASN1Dict([('true', 0)])
    _GNSS_AcquisitionAssistanceSupport_confidenceSupport_r10._ext = None
    _GNSS_AcquisitionAssistanceSupport_dopplerUncertaintyExtSupport_r10 = ENUM(name='dopplerUncertaintyExtSupport-r10', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AcquisitionAssistanceSupport_dopplerUncertaintyExtSupport_r10._cont = ASN1Dict([('true', 0)])
    _GNSS_AcquisitionAssistanceSupport_dopplerUncertaintyExtSupport_r10._ext = None
    GNSS_AcquisitionAssistanceSupport._cont = ASN1Dict([
        ('confidenceSupport-r10', _GNSS_AcquisitionAssistanceSupport_confidenceSupport_r10),
        ('dopplerUncertaintyExtSupport-r10', _GNSS_AcquisitionAssistanceSupport_dopplerUncertaintyExtSupport_r10),
        ])
    GNSS_AcquisitionAssistanceSupport._ext = ['confidenceSupport-r10', 'dopplerUncertaintyExtSupport-r10']
    
    #-----< GNSS-AlmanacSupport >-----#
    GNSS_AlmanacSupport = SEQ(name='GNSS-AlmanacSupport', mode=MODE_TYPE)
    _GNSS_AlmanacSupport_almanacModel = BIT_STR(name='almanacModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_AlmanacSupport_almanacModel._cont = ASN1Dict([('model-1', 0), ('model-2', 1), ('model-3', 2), ('model-4', 3), ('model-5', 4), ('model-6', 5), ('model-7', 6)])
    _GNSS_AlmanacSupport_almanacModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    GNSS_AlmanacSupport._cont = ASN1Dict([
        ('almanacModel', _GNSS_AlmanacSupport_almanacModel),
        ])
    GNSS_AlmanacSupport._ext = []
    
    #-----< GNSS-UTC-ModelSupport >-----#
    GNSS_UTC_ModelSupport = SEQ(name='GNSS-UTC-ModelSupport', mode=MODE_TYPE)
    _GNSS_UTC_ModelSupport_utc_Model = BIT_STR(name='utc-Model', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_UTC_ModelSupport_utc_Model._cont = ASN1Dict([('model-1', 0), ('model-2', 1), ('model-3', 2), ('model-4', 3), ('model-5', 4)])
    _GNSS_UTC_ModelSupport_utc_Model._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    GNSS_UTC_ModelSupport._cont = ASN1Dict([
        ('utc-Model', _GNSS_UTC_ModelSupport_utc_Model),
        ])
    GNSS_UTC_ModelSupport._ext = []
    
    #-----< GNSS-AuxiliaryInformationSupport >-----#
    GNSS_AuxiliaryInformationSupport = SEQ(name='GNSS-AuxiliaryInformationSupport', mode=MODE_TYPE)
    GNSS_AuxiliaryInformationSupport._cont = ASN1Dict([
        ])
    GNSS_AuxiliaryInformationSupport._ext = []
    
    #-----< BDS-DifferentialCorrectionsSupport-r12 >-----#
    BDS_DifferentialCorrectionsSupport_r12 = SEQ(name='BDS-DifferentialCorrectionsSupport-r12', mode=MODE_TYPE)
    _BDS_DifferentialCorrectionsSupport_r12_gnssSignalIDs = SEQ(name='gnssSignalIDs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    BDS_DifferentialCorrectionsSupport_r12._cont = ASN1Dict([
        ('gnssSignalIDs', _BDS_DifferentialCorrectionsSupport_r12_gnssSignalIDs),
        ])
    BDS_DifferentialCorrectionsSupport_r12._ext = []
    
    #-----< BDS-GridModelSupport-r12 >-----#
    BDS_GridModelSupport_r12 = SEQ(name='BDS-GridModelSupport-r12', mode=MODE_TYPE)
    BDS_GridModelSupport_r12._cont = ASN1Dict([
        ])
    BDS_GridModelSupport_r12._ext = []
    
    #-----< A-GNSS-RequestCapabilities >-----#
    A_GNSS_RequestCapabilities = SEQ(name='A-GNSS-RequestCapabilities', mode=MODE_TYPE)
    _A_GNSS_RequestCapabilities_gnss_SupportListReq = BOOL(name='gnss-SupportListReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _A_GNSS_RequestCapabilities_assistanceDataSupportListReq = BOOL(name='assistanceDataSupportListReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _A_GNSS_RequestCapabilities_locationVelocityTypesReq = BOOL(name='locationVelocityTypesReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    A_GNSS_RequestCapabilities._cont = ASN1Dict([
        ('gnss-SupportListReq', _A_GNSS_RequestCapabilities_gnss_SupportListReq),
        ('assistanceDataSupportListReq', _A_GNSS_RequestCapabilities_assistanceDataSupportListReq),
        ('locationVelocityTypesReq', _A_GNSS_RequestCapabilities_locationVelocityTypesReq),
        ])
    A_GNSS_RequestCapabilities._ext = []
    
    #-----< A-GNSS-Error >-----#
    A_GNSS_Error = CHOICE(name='A-GNSS-Error', mode=MODE_TYPE)
    _A_GNSS_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-LocationServerErrorCauses')))
    _A_GNSS_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-TargetDeviceErrorCauses')))
    A_GNSS_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _A_GNSS_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _A_GNSS_Error_targetDeviceErrorCauses),
        ])
    A_GNSS_Error._ext = []
    
    #-----< GNSS-LocationServerErrorCauses >-----#
    GNSS_LocationServerErrorCauses = SEQ(name='GNSS-LocationServerErrorCauses', mode=MODE_TYPE)
    _GNSS_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('undeliveredAssistanceDataIsNotSupportedByServer', 1), ('undeliveredAssistanceDataIsSupportedButCurrentlyNotAvailableByServer', 2), ('undeliveredAssistanceDataIsPartlyNotSupportedAndPartlyNotAvailableByServer', 3)])
    _GNSS_LocationServerErrorCauses_cause._ext = []
    GNSS_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _GNSS_LocationServerErrorCauses_cause),
        ])
    GNSS_LocationServerErrorCauses._ext = []
    
    #-----< GNSS-TargetDeviceErrorCauses >-----#
    GNSS_TargetDeviceErrorCauses = SEQ(name='GNSS-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _GNSS_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('thereWereNotEnoughSatellitesReceived', 1), ('assistanceDataMissing', 2), ('notAllRequestedMeasurementsPossible', 3)])
    _GNSS_TargetDeviceErrorCauses_cause._ext = []
    _GNSS_TargetDeviceErrorCauses_fineTimeAssistanceMeasurementsNotPossible = NULL(name='fineTimeAssistanceMeasurementsNotPossible', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_TargetDeviceErrorCauses_adrMeasurementsNotPossible = NULL(name='adrMeasurementsNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GNSS_TargetDeviceErrorCauses_multiFrequencyMeasurementsNotPossible = NULL(name='multiFrequencyMeasurementsNotPossible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GNSS_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _GNSS_TargetDeviceErrorCauses_cause),
        ('fineTimeAssistanceMeasurementsNotPossible', _GNSS_TargetDeviceErrorCauses_fineTimeAssistanceMeasurementsNotPossible),
        ('adrMeasurementsNotPossible', _GNSS_TargetDeviceErrorCauses_adrMeasurementsNotPossible),
        ('multiFrequencyMeasurementsNotPossible', _GNSS_TargetDeviceErrorCauses_multiFrequencyMeasurementsNotPossible),
        ])
    GNSS_TargetDeviceErrorCauses._ext = []
    
    #-----< GNSS-ID >-----#
    GNSS_ID = SEQ(name='GNSS-ID', mode=MODE_TYPE)
    _GNSS_ID_gnss_id = ENUM(name='gnss-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_ID_gnss_id._cont = ASN1Dict([('gps', 0), ('sbas', 1), ('qzss', 2), ('galileo', 3), ('glonass', 4), ('bds', 5)])
    _GNSS_ID_gnss_id._ext = ['bds']
    GNSS_ID._cont = ASN1Dict([
        ('gnss-id', _GNSS_ID_gnss_id),
        ])
    GNSS_ID._ext = []
    
    #-----< GNSS-ID-Bitmap >-----#
    GNSS_ID_Bitmap = SEQ(name='GNSS-ID-Bitmap', mode=MODE_TYPE)
    _GNSS_ID_Bitmap_gnss_ids = BIT_STR(name='gnss-ids', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_ID_Bitmap_gnss_ids._cont = ASN1Dict([('gps', 0), ('sbas', 1), ('qzss', 2), ('galileo', 3), ('glonass', 4), ('bds', 5)])
    _GNSS_ID_Bitmap_gnss_ids._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    GNSS_ID_Bitmap._cont = ASN1Dict([
        ('gnss-ids', _GNSS_ID_Bitmap_gnss_ids),
        ])
    GNSS_ID_Bitmap._ext = []
    
    #-----< GNSS-SignalID >-----#
    GNSS_SignalID = SEQ(name='GNSS-SignalID', mode=MODE_TYPE)
    _GNSS_SignalID_gnss_SignalID = INT(name='gnss-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SignalID_gnss_SignalID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    GNSS_SignalID._cont = ASN1Dict([
        ('gnss-SignalID', _GNSS_SignalID_gnss_SignalID),
        ])
    GNSS_SignalID._ext = []
    
    #-----< GNSS-SignalIDs >-----#
    GNSS_SignalIDs = SEQ(name='GNSS-SignalIDs', mode=MODE_TYPE)
    _GNSS_SignalIDs_gnss_SignalIDs = BIT_STR(name='gnss-SignalIDs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSS_SignalIDs_gnss_SignalIDs._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    GNSS_SignalIDs._cont = ASN1Dict([
        ('gnss-SignalIDs', _GNSS_SignalIDs_gnss_SignalIDs),
        ])
    GNSS_SignalIDs._ext = []
    
    #-----< SBAS-ID >-----#
    SBAS_ID = SEQ(name='SBAS-ID', mode=MODE_TYPE)
    _SBAS_ID_sbas_id = ENUM(name='sbas-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBAS_ID_sbas_id._cont = ASN1Dict([('waas', 0), ('egnos', 1), ('msas', 2), ('gagan', 3)])
    _SBAS_ID_sbas_id._ext = []
    SBAS_ID._cont = ASN1Dict([
        ('sbas-id', _SBAS_ID_sbas_id),
        ])
    SBAS_ID._ext = []
    
    #-----< SBAS-IDs >-----#
    SBAS_IDs = SEQ(name='SBAS-IDs', mode=MODE_TYPE)
    _SBAS_IDs_sbas_IDs = BIT_STR(name='sbas-IDs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBAS_IDs_sbas_IDs._cont = ASN1Dict([('waas', 0), ('egnos', 1), ('msas', 2), ('gagan', 3)])
    _SBAS_IDs_sbas_IDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    SBAS_IDs._cont = ASN1Dict([
        ('sbas-IDs', _SBAS_IDs_sbas_IDs),
        ])
    SBAS_IDs._ext = []
    
    #-----< SV-ID >-----#
    SV_ID = SEQ(name='SV-ID', mode=MODE_TYPE)
    _SV_ID_satellite_id = INT(name='satellite-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SV_ID_satellite_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    SV_ID._cont = ASN1Dict([
        ('satellite-id', _SV_ID_satellite_id),
        ])
    SV_ID._ext = []
    
    #-----< ECID-ProvideLocationInformation >-----#
    ECID_ProvideLocationInformation = SEQ(name='ECID-ProvideLocationInformation', mode=MODE_TYPE)
    _ECID_ProvideLocationInformation_ecid_SignalMeasurementInformation = SEQ(name='ecid-SignalMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-SignalMeasurementInformation')), opt=True)
    _ECID_ProvideLocationInformation_ecid_Error = CHOICE(name='ecid-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-Error')), opt=True)
    ECID_ProvideLocationInformation._cont = ASN1Dict([
        ('ecid-SignalMeasurementInformation', _ECID_ProvideLocationInformation_ecid_SignalMeasurementInformation),
        ('ecid-Error', _ECID_ProvideLocationInformation_ecid_Error),
        ])
    ECID_ProvideLocationInformation._ext = []
    
    #-----< ECID-SignalMeasurementInformation >-----#
    ECID_SignalMeasurementInformation = SEQ(name='ECID-SignalMeasurementInformation', mode=MODE_TYPE)
    _ECID_SignalMeasurementInformation_primaryCellMeasuredResults = SEQ(name='primaryCellMeasuredResults', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'MeasuredResultsElement')), opt=True)
    _ECID_SignalMeasurementInformation_measuredResultsList = SEQ_OF(name='measuredResultsList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'MeasuredResultsList')))
    ECID_SignalMeasurementInformation._cont = ASN1Dict([
        ('primaryCellMeasuredResults', _ECID_SignalMeasurementInformation_primaryCellMeasuredResults),
        ('measuredResultsList', _ECID_SignalMeasurementInformation_measuredResultsList),
        ])
    ECID_SignalMeasurementInformation._ext = []
    
    #-----< MeasuredResultsList >-----#
    MeasuredResultsList = SEQ_OF(name='MeasuredResultsList', mode=MODE_TYPE)
    _MeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'MeasuredResultsElement')))
    MeasuredResultsList._cont = _MeasuredResultsList__item_
    MeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MeasuredResultsElement >-----#
    MeasuredResultsElement = SEQ(name='MeasuredResultsElement', mode=MODE_TYPE)
    _MeasuredResultsElement_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsElement_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _MeasuredResultsElement_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    _MeasuredResultsElement_arfcnEUTRA = INT(name='arfcnEUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')))
    _MeasuredResultsElement_systemFrameNumber = BIT_STR(name='systemFrameNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeasuredResultsElement_systemFrameNumber._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _MeasuredResultsElement_rsrp_Result = INT(name='rsrp-Result', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeasuredResultsElement_rsrp_Result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    _MeasuredResultsElement_rsrq_Result = INT(name='rsrq-Result', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeasuredResultsElement_rsrq_Result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    _MeasuredResultsElement_ue_RxTxTimeDiff = INT(name='ue-RxTxTimeDiff', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeasuredResultsElement_ue_RxTxTimeDiff._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _MeasuredResultsElement_arfcnEUTRA_v9a0 = INT(name='arfcnEUTRA-v9a0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA-v9a0')), opt=True, group=0)
    MeasuredResultsElement._cont = ASN1Dict([
        ('physCellId', _MeasuredResultsElement_physCellId),
        ('cellGlobalId', _MeasuredResultsElement_cellGlobalId),
        ('arfcnEUTRA', _MeasuredResultsElement_arfcnEUTRA),
        ('systemFrameNumber', _MeasuredResultsElement_systemFrameNumber),
        ('rsrp-Result', _MeasuredResultsElement_rsrp_Result),
        ('rsrq-Result', _MeasuredResultsElement_rsrq_Result),
        ('ue-RxTxTimeDiff', _MeasuredResultsElement_ue_RxTxTimeDiff),
        ('arfcnEUTRA-v9a0', _MeasuredResultsElement_arfcnEUTRA_v9a0),
        ])
    MeasuredResultsElement._ext = ['arfcnEUTRA-v9a0']
    
    #-----< ECID-RequestLocationInformation >-----#
    ECID_RequestLocationInformation = SEQ(name='ECID-RequestLocationInformation', mode=MODE_TYPE)
    _ECID_RequestLocationInformation_requestedMeasurements = BIT_STR(name='requestedMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECID_RequestLocationInformation_requestedMeasurements._cont = ASN1Dict([('rsrpReq', 0), ('rsrqReq', 1), ('ueRxTxReq', 2)])
    _ECID_RequestLocationInformation_requestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    ECID_RequestLocationInformation._cont = ASN1Dict([
        ('requestedMeasurements', _ECID_RequestLocationInformation_requestedMeasurements),
        ])
    ECID_RequestLocationInformation._ext = []
    
    #-----< ECID-ProvideCapabilities >-----#
    ECID_ProvideCapabilities = SEQ(name='ECID-ProvideCapabilities', mode=MODE_TYPE)
    _ECID_ProvideCapabilities_ecid_MeasSupported = BIT_STR(name='ecid-MeasSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECID_ProvideCapabilities_ecid_MeasSupported._cont = ASN1Dict([('rsrpSup', 0), ('rsrqSup', 1), ('ueRxTxSup', 2)])
    _ECID_ProvideCapabilities_ecid_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    ECID_ProvideCapabilities._cont = ASN1Dict([
        ('ecid-MeasSupported', _ECID_ProvideCapabilities_ecid_MeasSupported),
        ])
    ECID_ProvideCapabilities._ext = []
    
    #-----< ECID-RequestCapabilities >-----#
    ECID_RequestCapabilities = SEQ(name='ECID-RequestCapabilities', mode=MODE_TYPE)
    ECID_RequestCapabilities._cont = ASN1Dict([
        ])
    ECID_RequestCapabilities._ext = []
    
    #-----< ECID-Error >-----#
    ECID_Error = CHOICE(name='ECID-Error', mode=MODE_TYPE)
    _ECID_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-LocationServerErrorCauses')))
    _ECID_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-TargetDeviceErrorCauses')))
    ECID_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _ECID_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _ECID_Error_targetDeviceErrorCauses),
        ])
    ECID_Error._ext = []
    
    #-----< ECID-LocationServerErrorCauses >-----#
    ECID_LocationServerErrorCauses = SEQ(name='ECID-LocationServerErrorCauses', mode=MODE_TYPE)
    _ECID_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECID_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0)])
    _ECID_LocationServerErrorCauses_cause._ext = []
    ECID_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _ECID_LocationServerErrorCauses_cause),
        ])
    ECID_LocationServerErrorCauses._ext = []
    
    #-----< ECID-TargetDeviceErrorCauses >-----#
    ECID_TargetDeviceErrorCauses = SEQ(name='ECID-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _ECID_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECID_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _ECID_TargetDeviceErrorCauses_cause._ext = []
    _ECID_TargetDeviceErrorCauses_rsrpMeasurementNotPossible = NULL(name='rsrpMeasurementNotPossible', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECID_TargetDeviceErrorCauses_rsrqMeasurementNotPossible = NULL(name='rsrqMeasurementNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECID_TargetDeviceErrorCauses_ueRxTxMeasurementNotPossible = NULL(name='ueRxTxMeasurementNotPossible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ECID_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _ECID_TargetDeviceErrorCauses_cause),
        ('rsrpMeasurementNotPossible', _ECID_TargetDeviceErrorCauses_rsrpMeasurementNotPossible),
        ('rsrqMeasurementNotPossible', _ECID_TargetDeviceErrorCauses_rsrqMeasurementNotPossible),
        ('ueRxTxMeasurementNotPossible', _ECID_TargetDeviceErrorCauses_ueRxTxMeasurementNotPossible),
        ])
    ECID_TargetDeviceErrorCauses._ext = []
    
    #-----< TBS-ProvideLocationInformation-r13 >-----#
    TBS_ProvideLocationInformation_r13 = SEQ(name='TBS-ProvideLocationInformation-r13', mode=MODE_TYPE)
    _TBS_ProvideLocationInformation_r13_tbs_MeasurementInformation_r13 = SEQ(name='tbs-MeasurementInformation-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-MeasurementInformation-r13')), opt=True)
    _TBS_ProvideLocationInformation_r13_tbs_Error_r13 = CHOICE(name='tbs-Error-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-Error-r13')), opt=True)
    TBS_ProvideLocationInformation_r13._cont = ASN1Dict([
        ('tbs-MeasurementInformation-r13', _TBS_ProvideLocationInformation_r13_tbs_MeasurementInformation_r13),
        ('tbs-Error-r13', _TBS_ProvideLocationInformation_r13_tbs_Error_r13),
        ])
    TBS_ProvideLocationInformation_r13._ext = []
    
    #-----< TBS-MeasurementInformation-r13 >-----#
    TBS_MeasurementInformation_r13 = SEQ(name='TBS-MeasurementInformation-r13', mode=MODE_TYPE)
    _TBS_MeasurementInformation_r13_measurementReferenceTime_r13 = TIME_UTC(name='measurementReferenceTime-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TBS_MeasurementInformation_r13_mbs_SgnMeasList_r13 = SEQ_OF(name='mbs-SgnMeasList-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'MBS-BeaconMeasList-r13')), opt=True)
    TBS_MeasurementInformation_r13._cont = ASN1Dict([
        ('measurementReferenceTime-r13', _TBS_MeasurementInformation_r13_measurementReferenceTime_r13),
        ('mbs-SgnMeasList-r13', _TBS_MeasurementInformation_r13_mbs_SgnMeasList_r13),
        ])
    TBS_MeasurementInformation_r13._ext = []
    
    #-----< MBS-BeaconMeasList-r13 >-----#
    MBS_BeaconMeasList_r13 = SEQ_OF(name='MBS-BeaconMeasList-r13', mode=MODE_TYPE)
    _MBS_BeaconMeasList_r13__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'MBS-BeaconMeasElement-r13')))
    MBS_BeaconMeasList_r13._cont = _MBS_BeaconMeasList_r13__item_
    MBS_BeaconMeasList_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBS-BeaconMeasElement-r13 >-----#
    MBS_BeaconMeasElement_r13 = SEQ(name='MBS-BeaconMeasElement-r13', mode=MODE_TYPE)
    _MBS_BeaconMeasElement_r13_transmitterID_r13 = INT(name='transmitterID-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBS_BeaconMeasElement_r13_transmitterID_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _MBS_BeaconMeasElement_r13_codePhase_r13 = INT(name='codePhase-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBS_BeaconMeasElement_r13_codePhase_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2097151)], ev=None, er=[])
    _MBS_BeaconMeasElement_r13_codePhaseRMSError_r13 = INT(name='codePhaseRMSError-r13', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBS_BeaconMeasElement_r13_codePhaseRMSError_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    MBS_BeaconMeasElement_r13._cont = ASN1Dict([
        ('transmitterID-r13', _MBS_BeaconMeasElement_r13_transmitterID_r13),
        ('codePhase-r13', _MBS_BeaconMeasElement_r13_codePhase_r13),
        ('codePhaseRMSError-r13', _MBS_BeaconMeasElement_r13_codePhaseRMSError_r13),
        ])
    MBS_BeaconMeasElement_r13._ext = []
    
    #-----< TBS-RequestLocationInformation-r13 >-----#
    TBS_RequestLocationInformation_r13 = SEQ(name='TBS-RequestLocationInformation-r13', mode=MODE_TYPE)
    _TBS_RequestLocationInformation_r13_mbsSgnMeasListReq_r13 = BOOL(name='mbsSgnMeasListReq-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TBS_RequestLocationInformation_r13._cont = ASN1Dict([
        ('mbsSgnMeasListReq-r13', _TBS_RequestLocationInformation_r13_mbsSgnMeasListReq_r13),
        ])
    TBS_RequestLocationInformation_r13._ext = []
    
    #-----< TBS-ProvideCapabilities-r13 >-----#
    TBS_ProvideCapabilities_r13 = SEQ(name='TBS-ProvideCapabilities-r13', mode=MODE_TYPE)
    _TBS_ProvideCapabilities_r13_tbs_Modes_r13 = BIT_STR(name='tbs-Modes-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TBS_ProvideCapabilities_r13_tbs_Modes_r13._cont = ASN1Dict([('standalone', 0), ('ue-assisted', 1)])
    _TBS_ProvideCapabilities_r13_tbs_Modes_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    TBS_ProvideCapabilities_r13._cont = ASN1Dict([
        ('tbs-Modes-r13', _TBS_ProvideCapabilities_r13_tbs_Modes_r13),
        ])
    TBS_ProvideCapabilities_r13._ext = []
    
    #-----< TBS-RequestCapabilities-r13 >-----#
    TBS_RequestCapabilities_r13 = SEQ(name='TBS-RequestCapabilities-r13', mode=MODE_TYPE)
    TBS_RequestCapabilities_r13._cont = ASN1Dict([
        ])
    TBS_RequestCapabilities_r13._ext = []
    
    #-----< TBS-Error-r13 >-----#
    TBS_Error_r13 = CHOICE(name='TBS-Error-r13', mode=MODE_TYPE)
    _TBS_Error_r13_locationServerErrorCauses_r13 = SEQ(name='locationServerErrorCauses-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-LocationServerErrorCauses-r13')))
    _TBS_Error_r13_targetDeviceErrorCauses_r13 = SEQ(name='targetDeviceErrorCauses-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'TBS-TargetDeviceErrorCauses-r13')))
    TBS_Error_r13._cont = ASN1Dict([
        ('locationServerErrorCauses-r13', _TBS_Error_r13_locationServerErrorCauses_r13),
        ('targetDeviceErrorCauses-r13', _TBS_Error_r13_targetDeviceErrorCauses_r13),
        ])
    TBS_Error_r13._ext = []
    
    #-----< TBS-LocationServerErrorCauses-r13 >-----#
    TBS_LocationServerErrorCauses_r13 = SEQ(name='TBS-LocationServerErrorCauses-r13', mode=MODE_TYPE)
    _TBS_LocationServerErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TBS_LocationServerErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0)])
    _TBS_LocationServerErrorCauses_r13_cause_r13._ext = []
    TBS_LocationServerErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _TBS_LocationServerErrorCauses_r13_cause_r13),
        ])
    TBS_LocationServerErrorCauses_r13._ext = []
    
    #-----< TBS-TargetDeviceErrorCauses-r13 >-----#
    TBS_TargetDeviceErrorCauses_r13 = SEQ(name='TBS-TargetDeviceErrorCauses-r13', mode=MODE_TYPE)
    _TBS_TargetDeviceErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TBS_TargetDeviceErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0), ('thereWereNotEnoughMBSBeaconsReceived', 1)])
    _TBS_TargetDeviceErrorCauses_r13_cause_r13._ext = []
    TBS_TargetDeviceErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _TBS_TargetDeviceErrorCauses_r13_cause_r13),
        ])
    TBS_TargetDeviceErrorCauses_r13._ext = []
    
    #-----< Sensor-ProvideLocationInformation-r13 >-----#
    Sensor_ProvideLocationInformation_r13 = SEQ(name='Sensor-ProvideLocationInformation-r13', mode=MODE_TYPE)
    _Sensor_ProvideLocationInformation_r13_sensor_MeasurementInformation_r13 = SEQ(name='sensor-MeasurementInformation-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-MeasurementInformation-r13')), opt=True)
    _Sensor_ProvideLocationInformation_r13_sensor_Error_r13 = CHOICE(name='sensor-Error-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-Error-r13')), opt=True)
    Sensor_ProvideLocationInformation_r13._cont = ASN1Dict([
        ('sensor-MeasurementInformation-r13', _Sensor_ProvideLocationInformation_r13_sensor_MeasurementInformation_r13),
        ('sensor-Error-r13', _Sensor_ProvideLocationInformation_r13_sensor_Error_r13),
        ])
    Sensor_ProvideLocationInformation_r13._ext = []
    
    #-----< Sensor-MeasurementInformation-r13 >-----#
    Sensor_MeasurementInformation_r13 = SEQ(name='Sensor-MeasurementInformation-r13', mode=MODE_TYPE)
    _Sensor_MeasurementInformation_r13_measurementReferenceTime_r13 = TIME_UTC(name='measurementReferenceTime-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Sensor_MeasurementInformation_r13_uncompensatedBarometricPressure_r13 = INT(name='uncompensatedBarometricPressure-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Sensor_MeasurementInformation_r13_uncompensatedBarometricPressure_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30000, ub=115000)], ev=None, er=[])
    Sensor_MeasurementInformation_r13._cont = ASN1Dict([
        ('measurementReferenceTime-r13', _Sensor_MeasurementInformation_r13_measurementReferenceTime_r13),
        ('uncompensatedBarometricPressure-r13', _Sensor_MeasurementInformation_r13_uncompensatedBarometricPressure_r13),
        ])
    Sensor_MeasurementInformation_r13._ext = []
    
    #-----< Sensor-RequestLocationInformation-r13 >-----#
    Sensor_RequestLocationInformation_r13 = SEQ(name='Sensor-RequestLocationInformation-r13', mode=MODE_TYPE)
    _Sensor_RequestLocationInformation_r13_uncompensatedBarometricPressureReq_r13 = BOOL(name='uncompensatedBarometricPressureReq-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Sensor_RequestLocationInformation_r13._cont = ASN1Dict([
        ('uncompensatedBarometricPressureReq-r13', _Sensor_RequestLocationInformation_r13_uncompensatedBarometricPressureReq_r13),
        ])
    Sensor_RequestLocationInformation_r13._ext = []
    
    #-----< Sensor-ProvideCapabilities-r13 >-----#
    Sensor_ProvideCapabilities_r13 = SEQ(name='Sensor-ProvideCapabilities-r13', mode=MODE_TYPE)
    _Sensor_ProvideCapabilities_r13_sensor_Modes_r13 = BIT_STR(name='sensor-Modes-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Sensor_ProvideCapabilities_r13_sensor_Modes_r13._cont = ASN1Dict([('standalone', 0), ('ue-assisted', 1)])
    _Sensor_ProvideCapabilities_r13_sensor_Modes_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    Sensor_ProvideCapabilities_r13._cont = ASN1Dict([
        ('sensor-Modes-r13', _Sensor_ProvideCapabilities_r13_sensor_Modes_r13),
        ])
    Sensor_ProvideCapabilities_r13._ext = []
    
    #-----< Sensor-RequestCapabilities-r13 >-----#
    Sensor_RequestCapabilities_r13 = SEQ(name='Sensor-RequestCapabilities-r13', mode=MODE_TYPE)
    Sensor_RequestCapabilities_r13._cont = ASN1Dict([
        ])
    Sensor_RequestCapabilities_r13._ext = []
    
    #-----< Sensor-Error-r13 >-----#
    Sensor_Error_r13 = CHOICE(name='Sensor-Error-r13', mode=MODE_TYPE)
    _Sensor_Error_r13_locationServerErrorCauses_r13 = SEQ(name='locationServerErrorCauses-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-LocationServerErrorCauses-r13')))
    _Sensor_Error_r13_targetDeviceErrorCauses_r13 = SEQ(name='targetDeviceErrorCauses-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Sensor-TargetDeviceErrorCauses-r13')))
    Sensor_Error_r13._cont = ASN1Dict([
        ('locationServerErrorCauses-r13', _Sensor_Error_r13_locationServerErrorCauses_r13),
        ('targetDeviceErrorCauses-r13', _Sensor_Error_r13_targetDeviceErrorCauses_r13),
        ])
    Sensor_Error_r13._ext = []
    
    #-----< Sensor-LocationServerErrorCauses-r13 >-----#
    Sensor_LocationServerErrorCauses_r13 = SEQ(name='Sensor-LocationServerErrorCauses-r13', mode=MODE_TYPE)
    _Sensor_LocationServerErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Sensor_LocationServerErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0)])
    _Sensor_LocationServerErrorCauses_r13_cause_r13._ext = []
    Sensor_LocationServerErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _Sensor_LocationServerErrorCauses_r13_cause_r13),
        ])
    Sensor_LocationServerErrorCauses_r13._ext = []
    
    #-----< Sensor-TargetDeviceErrorCauses-r13 >-----#
    Sensor_TargetDeviceErrorCauses_r13 = SEQ(name='Sensor-TargetDeviceErrorCauses-r13', mode=MODE_TYPE)
    _Sensor_TargetDeviceErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Sensor_TargetDeviceErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0)])
    _Sensor_TargetDeviceErrorCauses_r13_cause_r13._ext = []
    Sensor_TargetDeviceErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _Sensor_TargetDeviceErrorCauses_r13_cause_r13),
        ])
    Sensor_TargetDeviceErrorCauses_r13._ext = []
    
    #-----< WLAN-ProvideLocationInformation-r13 >-----#
    WLAN_ProvideLocationInformation_r13 = SEQ(name='WLAN-ProvideLocationInformation-r13', mode=MODE_TYPE)
    _WLAN_ProvideLocationInformation_r13_wlan_MeasurementInformation_r13 = SEQ(name='wlan-MeasurementInformation-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-MeasurementInformation-r13')), opt=True)
    _WLAN_ProvideLocationInformation_r13_wlan_Error_r13 = CHOICE(name='wlan-Error-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-Error-r13')), opt=True)
    WLAN_ProvideLocationInformation_r13._cont = ASN1Dict([
        ('wlan-MeasurementInformation-r13', _WLAN_ProvideLocationInformation_r13_wlan_MeasurementInformation_r13),
        ('wlan-Error-r13', _WLAN_ProvideLocationInformation_r13_wlan_Error_r13),
        ])
    WLAN_ProvideLocationInformation_r13._ext = []
    
    #-----< WLAN-MeasurementInformation-r13 >-----#
    WLAN_MeasurementInformation_r13 = SEQ(name='WLAN-MeasurementInformation-r13', mode=MODE_TYPE)
    _WLAN_MeasurementInformation_r13_measurementReferenceTime_r13 = TIME_UTC(name='measurementReferenceTime-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLAN_MeasurementInformation_r13_wlan_MeasurementList_r13 = SEQ_OF(name='wlan-MeasurementList-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-MeasurementList-r13')), opt=True)
    WLAN_MeasurementInformation_r13._cont = ASN1Dict([
        ('measurementReferenceTime-r13', _WLAN_MeasurementInformation_r13_measurementReferenceTime_r13),
        ('wlan-MeasurementList-r13', _WLAN_MeasurementInformation_r13_wlan_MeasurementList_r13),
        ])
    WLAN_MeasurementInformation_r13._ext = []
    
    #-----< WLAN-MeasurementList-r13 >-----#
    WLAN_MeasurementList_r13 = SEQ_OF(name='WLAN-MeasurementList-r13', mode=MODE_TYPE)
    _WLAN_MeasurementList_r13__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-MeasurementElement-r13')))
    WLAN_MeasurementList_r13._cont = _WLAN_MeasurementList_r13__item_
    WLAN_MeasurementList_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< WLAN-MeasurementElement-r13 >-----#
    WLAN_MeasurementElement_r13 = SEQ(name='WLAN-MeasurementElement-r13', mode=MODE_TYPE)
    _WLAN_MeasurementElement_r13_wlan_AP_Identifier_r13 = SEQ(name='wlan-AP-Identifier-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-AP-Identifier-r13')))
    _WLAN_MeasurementElement_r13_rssi_r13 = INT(name='rssi-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLAN_MeasurementElement_r13_rssi_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WLAN_MeasurementElement_r13_rtt_r13 = SEQ(name='rtt-r13', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-RTT-r13')), opt=True)
    _WLAN_MeasurementElement_r13_apChannelFrequency_r13 = INT(name='apChannelFrequency-r13', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLAN_MeasurementElement_r13_apChannelFrequency_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _WLAN_MeasurementElement_r13_servingFlag_r13 = BOOL(name='servingFlag-r13', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    WLAN_MeasurementElement_r13._cont = ASN1Dict([
        ('wlan-AP-Identifier-r13', _WLAN_MeasurementElement_r13_wlan_AP_Identifier_r13),
        ('rssi-r13', _WLAN_MeasurementElement_r13_rssi_r13),
        ('rtt-r13', _WLAN_MeasurementElement_r13_rtt_r13),
        ('apChannelFrequency-r13', _WLAN_MeasurementElement_r13_apChannelFrequency_r13),
        ('servingFlag-r13', _WLAN_MeasurementElement_r13_servingFlag_r13),
        ])
    WLAN_MeasurementElement_r13._ext = []
    
    #-----< WLAN-AP-Identifier-r13 >-----#
    WLAN_AP_Identifier_r13 = SEQ(name='WLAN-AP-Identifier-r13', mode=MODE_TYPE)
    _WLAN_AP_Identifier_r13_bssid_r13 = OCT_STR(name='bssid-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_AP_Identifier_r13_bssid_r13._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _WLAN_AP_Identifier_r13_ssid_r13 = OCT_STR(name='ssid-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLAN_AP_Identifier_r13_ssid_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    WLAN_AP_Identifier_r13._cont = ASN1Dict([
        ('bssid-r13', _WLAN_AP_Identifier_r13_bssid_r13),
        ('ssid-r13', _WLAN_AP_Identifier_r13_ssid_r13),
        ])
    WLAN_AP_Identifier_r13._ext = []
    
    #-----< WLAN-RTT-r13 >-----#
    WLAN_RTT_r13 = SEQ(name='WLAN-RTT-r13', mode=MODE_TYPE)
    _WLAN_RTT_r13_rttValue_r13 = INT(name='rttValue-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_RTT_r13_rttValue_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    _WLAN_RTT_r13_rttUnits_r13 = ENUM(name='rttUnits-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_RTT_r13_rttUnits_r13._cont = ASN1Dict([('microseconds', 0), ('hundredsofnanoseconds', 1), ('tensofnanoseconds', 2), ('nanoseconds', 3), ('tenthsofnanoseconds', 4)])
    _WLAN_RTT_r13_rttUnits_r13._ext = []
    _WLAN_RTT_r13_rttAccuracy_r13 = INT(name='rttAccuracy-r13', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLAN_RTT_r13_rttAccuracy_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    WLAN_RTT_r13._cont = ASN1Dict([
        ('rttValue-r13', _WLAN_RTT_r13_rttValue_r13),
        ('rttUnits-r13', _WLAN_RTT_r13_rttUnits_r13),
        ('rttAccuracy-r13', _WLAN_RTT_r13_rttAccuracy_r13),
        ])
    WLAN_RTT_r13._ext = []
    
    #-----< maxWLAN-AP-r13 >-----#
    maxWLAN_AP_r13 = INT(name='maxWLAN-AP-r13', mode=MODE_VALUE)
    maxWLAN_AP_r13._val = 64
    
    #-----< WLAN-RequestLocationInformation-r13 >-----#
    WLAN_RequestLocationInformation_r13 = SEQ(name='WLAN-RequestLocationInformation-r13', mode=MODE_TYPE)
    _WLAN_RequestLocationInformation_r13_requestedMeasurements_r13 = BIT_STR(name='requestedMeasurements-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_RequestLocationInformation_r13_requestedMeasurements_r13._cont = ASN1Dict([('rssi', 0), ('rtt', 1)])
    _WLAN_RequestLocationInformation_r13_requestedMeasurements_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    WLAN_RequestLocationInformation_r13._cont = ASN1Dict([
        ('requestedMeasurements-r13', _WLAN_RequestLocationInformation_r13_requestedMeasurements_r13),
        ])
    WLAN_RequestLocationInformation_r13._ext = []
    
    #-----< WLAN-ProvideCapabilities-r13 >-----#
    WLAN_ProvideCapabilities_r13 = SEQ(name='WLAN-ProvideCapabilities-r13', mode=MODE_TYPE)
    _WLAN_ProvideCapabilities_r13_wlan_Modes_r13 = BIT_STR(name='wlan-Modes-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_ProvideCapabilities_r13_wlan_Modes_r13._cont = ASN1Dict([('standalone', 0), ('ue-assisted', 1)])
    _WLAN_ProvideCapabilities_r13_wlan_Modes_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _WLAN_ProvideCapabilities_r13_wlan_MeasSupported_r13 = BIT_STR(name='wlan-MeasSupported-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_ProvideCapabilities_r13_wlan_MeasSupported_r13._cont = ASN1Dict([('rssi-r13', 0), ('rtt-r13', 1)])
    _WLAN_ProvideCapabilities_r13_wlan_MeasSupported_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    WLAN_ProvideCapabilities_r13._cont = ASN1Dict([
        ('wlan-Modes-r13', _WLAN_ProvideCapabilities_r13_wlan_Modes_r13),
        ('wlan-MeasSupported-r13', _WLAN_ProvideCapabilities_r13_wlan_MeasSupported_r13),
        ])
    WLAN_ProvideCapabilities_r13._ext = []
    
    #-----< WLAN-RequestCapabilities-r13 >-----#
    WLAN_RequestCapabilities_r13 = SEQ(name='WLAN-RequestCapabilities-r13', mode=MODE_TYPE)
    WLAN_RequestCapabilities_r13._cont = ASN1Dict([
        ])
    WLAN_RequestCapabilities_r13._ext = []
    
    #-----< WLAN-Error-r13 >-----#
    WLAN_Error_r13 = CHOICE(name='WLAN-Error-r13', mode=MODE_TYPE)
    _WLAN_Error_r13_locationServerErrorCauses_r13 = SEQ(name='locationServerErrorCauses-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-LocationServerErrorCauses-r13')))
    _WLAN_Error_r13_targetDeviceErrorCauses_r13 = SEQ(name='targetDeviceErrorCauses-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'WLAN-TargetDeviceErrorCauses-r13')))
    WLAN_Error_r13._cont = ASN1Dict([
        ('locationServerErrorCauses-r13', _WLAN_Error_r13_locationServerErrorCauses_r13),
        ('targetDeviceErrorCauses-r13', _WLAN_Error_r13_targetDeviceErrorCauses_r13),
        ])
    WLAN_Error_r13._ext = []
    
    #-----< WLAN-LocationServerErrorCauses-r13 >-----#
    WLAN_LocationServerErrorCauses_r13 = SEQ(name='WLAN-LocationServerErrorCauses-r13', mode=MODE_TYPE)
    _WLAN_LocationServerErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_LocationServerErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0)])
    _WLAN_LocationServerErrorCauses_r13_cause_r13._ext = []
    WLAN_LocationServerErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _WLAN_LocationServerErrorCauses_r13_cause_r13),
        ])
    WLAN_LocationServerErrorCauses_r13._ext = []
    
    #-----< WLAN-TargetDeviceErrorCauses-r13 >-----#
    WLAN_TargetDeviceErrorCauses_r13 = SEQ(name='WLAN-TargetDeviceErrorCauses-r13', mode=MODE_TYPE)
    _WLAN_TargetDeviceErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLAN_TargetDeviceErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _WLAN_TargetDeviceErrorCauses_r13_cause_r13._ext = []
    _WLAN_TargetDeviceErrorCauses_r13_wlan_AP_RSSI_MeasurementNotPossible_r13 = NULL(name='wlan-AP-RSSI-MeasurementNotPossible-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLAN_TargetDeviceErrorCauses_r13_wlan_AP_RTT_MeasurementNotPossible_r13 = NULL(name='wlan-AP-RTT-MeasurementNotPossible-r13', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    WLAN_TargetDeviceErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _WLAN_TargetDeviceErrorCauses_r13_cause_r13),
        ('wlan-AP-RSSI-MeasurementNotPossible-r13', _WLAN_TargetDeviceErrorCauses_r13_wlan_AP_RSSI_MeasurementNotPossible_r13),
        ('wlan-AP-RTT-MeasurementNotPossible-r13', _WLAN_TargetDeviceErrorCauses_r13_wlan_AP_RTT_MeasurementNotPossible_r13),
        ])
    WLAN_TargetDeviceErrorCauses_r13._ext = []
    
    #-----< BT-ProvideLocationInformation-r13 >-----#
    BT_ProvideLocationInformation_r13 = SEQ(name='BT-ProvideLocationInformation-r13', mode=MODE_TYPE)
    _BT_ProvideLocationInformation_r13_bt_MeasurementInformation_r13 = SEQ(name='bt-MeasurementInformation-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-MeasurementInformation-r13')), opt=True)
    _BT_ProvideLocationInformation_r13_bt_Error_r13 = CHOICE(name='bt-Error-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-Error-r13')), opt=True)
    BT_ProvideLocationInformation_r13._cont = ASN1Dict([
        ('bt-MeasurementInformation-r13', _BT_ProvideLocationInformation_r13_bt_MeasurementInformation_r13),
        ('bt-Error-r13', _BT_ProvideLocationInformation_r13_bt_Error_r13),
        ])
    BT_ProvideLocationInformation_r13._ext = []
    
    #-----< BT-MeasurementInformation-r13 >-----#
    BT_MeasurementInformation_r13 = SEQ(name='BT-MeasurementInformation-r13', mode=MODE_TYPE)
    _BT_MeasurementInformation_r13_measurementReferenceTime_r13 = TIME_UTC(name='measurementReferenceTime-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BT_MeasurementInformation_r13_bt_MeasurementList_r13 = SEQ_OF(name='bt-MeasurementList-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-MeasurementList-r13')), opt=True)
    BT_MeasurementInformation_r13._cont = ASN1Dict([
        ('measurementReferenceTime-r13', _BT_MeasurementInformation_r13_measurementReferenceTime_r13),
        ('bt-MeasurementList-r13', _BT_MeasurementInformation_r13_bt_MeasurementList_r13),
        ])
    BT_MeasurementInformation_r13._ext = []
    
    #-----< BT-MeasurementList-r13 >-----#
    BT_MeasurementList_r13 = SEQ_OF(name='BT-MeasurementList-r13', mode=MODE_TYPE)
    _BT_MeasurementList_r13__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-MeasurementElement-r13')))
    BT_MeasurementList_r13._cont = _BT_MeasurementList_r13__item_
    BT_MeasurementList_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BT-MeasurementElement-r13 >-----#
    BT_MeasurementElement_r13 = SEQ(name='BT-MeasurementElement-r13', mode=MODE_TYPE)
    _BT_MeasurementElement_r13_btAddr_r13 = BIT_STR(name='btAddr-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BT_MeasurementElement_r13_btAddr_r13._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    _BT_MeasurementElement_r13_rssi_r13 = INT(name='rssi-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BT_MeasurementElement_r13_rssi_r13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    BT_MeasurementElement_r13._cont = ASN1Dict([
        ('btAddr-r13', _BT_MeasurementElement_r13_btAddr_r13),
        ('rssi-r13', _BT_MeasurementElement_r13_rssi_r13),
        ])
    BT_MeasurementElement_r13._ext = []
    
    #-----< maxBT-Beacon-r13 >-----#
    maxBT_Beacon_r13 = INT(name='maxBT-Beacon-r13', mode=MODE_VALUE)
    maxBT_Beacon_r13._val = 32
    
    #-----< BT-RequestLocationInformation-r13 >-----#
    BT_RequestLocationInformation_r13 = SEQ(name='BT-RequestLocationInformation-r13', mode=MODE_TYPE)
    _BT_RequestLocationInformation_r13_requestedMeasurements_r13 = BIT_STR(name='requestedMeasurements-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BT_RequestLocationInformation_r13_requestedMeasurements_r13._cont = ASN1Dict([('rssi', 0)])
    _BT_RequestLocationInformation_r13_requestedMeasurements_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    BT_RequestLocationInformation_r13._cont = ASN1Dict([
        ('requestedMeasurements-r13', _BT_RequestLocationInformation_r13_requestedMeasurements_r13),
        ])
    BT_RequestLocationInformation_r13._ext = []
    
    #-----< BT-ProvideCapabilities-r13 >-----#
    BT_ProvideCapabilities_r13 = SEQ(name='BT-ProvideCapabilities-r13', mode=MODE_TYPE)
    _BT_ProvideCapabilities_r13_bt_Modes_r13 = BIT_STR(name='bt-Modes-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BT_ProvideCapabilities_r13_bt_Modes_r13._cont = ASN1Dict([('standalone', 0), ('ue-assisted', 1)])
    _BT_ProvideCapabilities_r13_bt_Modes_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _BT_ProvideCapabilities_r13_bt_MeasSupported_r13 = BIT_STR(name='bt-MeasSupported-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BT_ProvideCapabilities_r13_bt_MeasSupported_r13._cont = ASN1Dict([('rssi-r13', 0)])
    _BT_ProvideCapabilities_r13_bt_MeasSupported_r13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    BT_ProvideCapabilities_r13._cont = ASN1Dict([
        ('bt-Modes-r13', _BT_ProvideCapabilities_r13_bt_Modes_r13),
        ('bt-MeasSupported-r13', _BT_ProvideCapabilities_r13_bt_MeasSupported_r13),
        ])
    BT_ProvideCapabilities_r13._ext = []
    
    #-----< BT-RequestCapabilities-r13 >-----#
    BT_RequestCapabilities_r13 = SEQ(name='BT-RequestCapabilities-r13', mode=MODE_TYPE)
    BT_RequestCapabilities_r13._cont = ASN1Dict([
        ])
    BT_RequestCapabilities_r13._ext = []
    
    #-----< BT-Error-r13 >-----#
    BT_Error_r13 = CHOICE(name='BT-Error-r13', mode=MODE_TYPE)
    _BT_Error_r13_locationServerErrorCauses_r13 = SEQ(name='locationServerErrorCauses-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-LocationServerErrorCauses-r13')))
    _BT_Error_r13_targetDeviceErrorCauses_r13 = SEQ(name='targetDeviceErrorCauses-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'BT-TargetDeviceErrorCauses-r13')))
    BT_Error_r13._cont = ASN1Dict([
        ('locationServerErrorCauses-r13', _BT_Error_r13_locationServerErrorCauses_r13),
        ('targetDeviceErrorCauses-r13', _BT_Error_r13_targetDeviceErrorCauses_r13),
        ])
    BT_Error_r13._ext = []
    
    #-----< BT-LocationServerErrorCauses-r13 >-----#
    BT_LocationServerErrorCauses_r13 = SEQ(name='BT-LocationServerErrorCauses-r13', mode=MODE_TYPE)
    _BT_LocationServerErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BT_LocationServerErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0)])
    _BT_LocationServerErrorCauses_r13_cause_r13._ext = []
    BT_LocationServerErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _BT_LocationServerErrorCauses_r13_cause_r13),
        ])
    BT_LocationServerErrorCauses_r13._ext = []
    
    #-----< BT-TargetDeviceErrorCauses-r13 >-----#
    BT_TargetDeviceErrorCauses_r13 = SEQ(name='BT-TargetDeviceErrorCauses-r13', mode=MODE_TYPE)
    _BT_TargetDeviceErrorCauses_r13_cause_r13 = ENUM(name='cause-r13', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BT_TargetDeviceErrorCauses_r13_cause_r13._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _BT_TargetDeviceErrorCauses_r13_cause_r13._ext = []
    _BT_TargetDeviceErrorCauses_r13_bt_Beacon_rssiMeasurementNotPossible_r13 = NULL(name='bt-Beacon-rssiMeasurementNotPossible-r13', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BT_TargetDeviceErrorCauses_r13._cont = ASN1Dict([
        ('cause-r13', _BT_TargetDeviceErrorCauses_r13_cause_r13),
        ('bt-Beacon-rssiMeasurementNotPossible-r13', _BT_TargetDeviceErrorCauses_r13_bt_Beacon_rssiMeasurementNotPossible_r13),
        ])
    BT_TargetDeviceErrorCauses_r13._ext = []
    
    _all_ = [
        _LPP_Message_transactionID,
        _LPP_Message_endTransaction,
        _LPP_Message_sequenceNumber,
        _LPP_Message_acknowledgement,
        _LPP_Message_lpp_MessageBody,
        LPP_Message,
        SequenceNumber,
        _Acknowledgement_ackRequested,
        _Acknowledgement_ackIndicator,
        Acknowledgement,
        __LPP_MessageBody_c1_requestCapabilities,
        __LPP_MessageBody_c1_provideCapabilities,
        __LPP_MessageBody_c1_requestAssistanceData,
        __LPP_MessageBody_c1_provideAssistanceData,
        __LPP_MessageBody_c1_requestLocationInformation,
        __LPP_MessageBody_c1_provideLocationInformation,
        __LPP_MessageBody_c1_abort,
        __LPP_MessageBody_c1_error,
        __LPP_MessageBody_c1_spare7,
        __LPP_MessageBody_c1_spare6,
        __LPP_MessageBody_c1_spare5,
        __LPP_MessageBody_c1_spare4,
        __LPP_MessageBody_c1_spare3,
        __LPP_MessageBody_c1_spare2,
        __LPP_MessageBody_c1_spare1,
        __LPP_MessageBody_c1_spare0,
        _LPP_MessageBody_c1,
        _LPP_MessageBody_messageClassExtension,
        LPP_MessageBody,
        _LPP_TransactionID_initiator,
        _LPP_TransactionID_transactionNumber,
        LPP_TransactionID,
        Initiator,
        TransactionNumber,
        ___RequestCapabilities_criticalExtensions_c1_requestCapabilities_r9,
        ___RequestCapabilities_criticalExtensions_c1_spare3,
        ___RequestCapabilities_criticalExtensions_c1_spare2,
        ___RequestCapabilities_criticalExtensions_c1_spare1,
        __RequestCapabilities_criticalExtensions_c1,
        __RequestCapabilities_criticalExtensions_criticalExtensionsFuture,
        _RequestCapabilities_criticalExtensions,
        RequestCapabilities,
        _RequestCapabilities_r9_IEs_commonIEsRequestCapabilities,
        _RequestCapabilities_r9_IEs_a_gnss_RequestCapabilities,
        _RequestCapabilities_r9_IEs_otdoa_RequestCapabilities,
        _RequestCapabilities_r9_IEs_ecid_RequestCapabilities,
        _RequestCapabilities_r9_IEs_epdu_RequestCapabilities,
        _RequestCapabilities_r9_IEs_sensor_RequestCapabilities_r13,
        _RequestCapabilities_r9_IEs_tbs_RequestCapabilities_r13,
        _RequestCapabilities_r9_IEs_wlan_RequestCapabilities_r13,
        _RequestCapabilities_r9_IEs_bt_RequestCapabilities_r13,
        RequestCapabilities_r9_IEs,
        ___ProvideCapabilities_criticalExtensions_c1_provideCapabilities_r9,
        ___ProvideCapabilities_criticalExtensions_c1_spare3,
        ___ProvideCapabilities_criticalExtensions_c1_spare2,
        ___ProvideCapabilities_criticalExtensions_c1_spare1,
        __ProvideCapabilities_criticalExtensions_c1,
        __ProvideCapabilities_criticalExtensions_criticalExtensionsFuture,
        _ProvideCapabilities_criticalExtensions,
        ProvideCapabilities,
        _ProvideCapabilities_r9_IEs_commonIEsProvideCapabilities,
        _ProvideCapabilities_r9_IEs_a_gnss_ProvideCapabilities,
        _ProvideCapabilities_r9_IEs_otdoa_ProvideCapabilities,
        _ProvideCapabilities_r9_IEs_ecid_ProvideCapabilities,
        _ProvideCapabilities_r9_IEs_epdu_ProvideCapabilities,
        _ProvideCapabilities_r9_IEs_sensor_ProvideCapabilities_r13,
        _ProvideCapabilities_r9_IEs_tbs_ProvideCapabilities_r13,
        _ProvideCapabilities_r9_IEs_wlan_ProvideCapabilities_r13,
        _ProvideCapabilities_r9_IEs_bt_ProvideCapabilities_r13,
        ProvideCapabilities_r9_IEs,
        ___RequestAssistanceData_criticalExtensions_c1_requestAssistanceData_r9,
        ___RequestAssistanceData_criticalExtensions_c1_spare3,
        ___RequestAssistanceData_criticalExtensions_c1_spare2,
        ___RequestAssistanceData_criticalExtensions_c1_spare1,
        __RequestAssistanceData_criticalExtensions_c1,
        __RequestAssistanceData_criticalExtensions_criticalExtensionsFuture,
        _RequestAssistanceData_criticalExtensions,
        RequestAssistanceData,
        _RequestAssistanceData_r9_IEs_commonIEsRequestAssistanceData,
        _RequestAssistanceData_r9_IEs_a_gnss_RequestAssistanceData,
        _RequestAssistanceData_r9_IEs_otdoa_RequestAssistanceData,
        _RequestAssistanceData_r9_IEs_epdu_RequestAssistanceData,
        RequestAssistanceData_r9_IEs,
        ___ProvideAssistanceData_criticalExtensions_c1_provideAssistanceData_r9,
        ___ProvideAssistanceData_criticalExtensions_c1_spare3,
        ___ProvideAssistanceData_criticalExtensions_c1_spare2,
        ___ProvideAssistanceData_criticalExtensions_c1_spare1,
        __ProvideAssistanceData_criticalExtensions_c1,
        __ProvideAssistanceData_criticalExtensions_criticalExtensionsFuture,
        _ProvideAssistanceData_criticalExtensions,
        ProvideAssistanceData,
        _ProvideAssistanceData_r9_IEs_commonIEsProvideAssistanceData,
        _ProvideAssistanceData_r9_IEs_a_gnss_ProvideAssistanceData,
        _ProvideAssistanceData_r9_IEs_otdoa_ProvideAssistanceData,
        _ProvideAssistanceData_r9_IEs_epdu_Provide_Assistance_Data,
        ProvideAssistanceData_r9_IEs,
        ___RequestLocationInformation_criticalExtensions_c1_requestLocationInformation_r9,
        ___RequestLocationInformation_criticalExtensions_c1_spare3,
        ___RequestLocationInformation_criticalExtensions_c1_spare2,
        ___RequestLocationInformation_criticalExtensions_c1_spare1,
        __RequestLocationInformation_criticalExtensions_c1,
        __RequestLocationInformation_criticalExtensions_criticalExtensionsFuture,
        _RequestLocationInformation_criticalExtensions,
        RequestLocationInformation,
        _RequestLocationInformation_r9_IEs_commonIEsRequestLocationInformation,
        _RequestLocationInformation_r9_IEs_a_gnss_RequestLocationInformation,
        _RequestLocationInformation_r9_IEs_otdoa_RequestLocationInformation,
        _RequestLocationInformation_r9_IEs_ecid_RequestLocationInformation,
        _RequestLocationInformation_r9_IEs_epdu_RequestLocationInformation,
        _RequestLocationInformation_r9_IEs_sensor_RequestLocationInformation_r13,
        _RequestLocationInformation_r9_IEs_tbs_RequestLocationInformation_r13,
        _RequestLocationInformation_r9_IEs_wlan_RequestLocationInformation_r13,
        _RequestLocationInformation_r9_IEs_bt_RequestLocationInformation_r13,
        RequestLocationInformation_r9_IEs,
        ___ProvideLocationInformation_criticalExtensions_c1_provideLocationInformation_r9,
        ___ProvideLocationInformation_criticalExtensions_c1_spare3,
        ___ProvideLocationInformation_criticalExtensions_c1_spare2,
        ___ProvideLocationInformation_criticalExtensions_c1_spare1,
        __ProvideLocationInformation_criticalExtensions_c1,
        __ProvideLocationInformation_criticalExtensions_criticalExtensionsFuture,
        _ProvideLocationInformation_criticalExtensions,
        ProvideLocationInformation,
        _ProvideLocationInformation_r9_IEs_commonIEsProvideLocationInformation,
        _ProvideLocationInformation_r9_IEs_a_gnss_ProvideLocationInformation,
        _ProvideLocationInformation_r9_IEs_otdoa_ProvideLocationInformation,
        _ProvideLocationInformation_r9_IEs_ecid_ProvideLocationInformation,
        _ProvideLocationInformation_r9_IEs_epdu_ProvideLocationInformation,
        _ProvideLocationInformation_r9_IEs_sensor_ProvideLocationInformation_r13,
        _ProvideLocationInformation_r9_IEs_tbs_ProvideLocationInformation_r13,
        _ProvideLocationInformation_r9_IEs_wlan_ProvideLocationInformation_r13,
        _ProvideLocationInformation_r9_IEs_bt_ProvideLocationInformation_r13,
        ProvideLocationInformation_r9_IEs,
        ___Abort_criticalExtensions_c1_abort_r9,
        ___Abort_criticalExtensions_c1_spare3,
        ___Abort_criticalExtensions_c1_spare2,
        ___Abort_criticalExtensions_c1_spare1,
        __Abort_criticalExtensions_c1,
        __Abort_criticalExtensions_criticalExtensionsFuture,
        _Abort_criticalExtensions,
        Abort,
        _Abort_r9_IEs_commonIEsAbort,
        _Abort_r9_IEs_epdu_Abort,
        Abort_r9_IEs,
        _Error_error_r9,
        _Error_criticalExtensionsFuture,
        Error,
        _Error_r9_IEs_commonIEsError,
        _Error_r9_IEs_epdu_Error,
        Error_r9_IEs,
        _AccessTypes_accessTypes,
        AccessTypes,
        ARFCN_ValueEUTRA,
        ARFCN_ValueEUTRA_v9a0,
        maxEARFCN,
        maxEARFCN_Plus1,
        maxEARFCN2,
        ARFCN_ValueUTRA,
        ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc__item_,
        __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mcc,
        ___CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc__item_,
        __CellGlobalIdEUTRA_AndUTRA_plmn_Identity_mnc,
        _CellGlobalIdEUTRA_AndUTRA_plmn_Identity,
        __CellGlobalIdEUTRA_AndUTRA_cellIdentity_eutra,
        __CellGlobalIdEUTRA_AndUTRA_cellIdentity_utra,
        _CellGlobalIdEUTRA_AndUTRA_cellIdentity,
        CellGlobalIdEUTRA_AndUTRA,
        ___CellGlobalIdGERAN_plmn_Identity_mcc__item_,
        __CellGlobalIdGERAN_plmn_Identity_mcc,
        ___CellGlobalIdGERAN_plmn_Identity_mnc__item_,
        __CellGlobalIdGERAN_plmn_Identity_mnc,
        _CellGlobalIdGERAN_plmn_Identity,
        _CellGlobalIdGERAN_locationAreaCode,
        _CellGlobalIdGERAN_cellIdentity,
        CellGlobalIdGERAN,
        __ECGI_mcc__item_,
        _ECGI_mcc,
        __ECGI_mnc__item_,
        _ECGI_mnc,
        _ECGI_cellidentity,
        ECGI,
        _Ellipsoid_Point_latitudeSign,
        _Ellipsoid_Point_degreesLatitude,
        _Ellipsoid_Point_degreesLongitude,
        Ellipsoid_Point,
        _Ellipsoid_PointWithUncertaintyCircle_latitudeSign,
        _Ellipsoid_PointWithUncertaintyCircle_degreesLatitude,
        _Ellipsoid_PointWithUncertaintyCircle_degreesLongitude,
        _Ellipsoid_PointWithUncertaintyCircle_uncertainty,
        Ellipsoid_PointWithUncertaintyCircle,
        _EllipsoidPointWithUncertaintyEllipse_latitudeSign,
        _EllipsoidPointWithUncertaintyEllipse_degreesLatitude,
        _EllipsoidPointWithUncertaintyEllipse_degreesLongitude,
        _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMajor,
        _EllipsoidPointWithUncertaintyEllipse_uncertaintySemiMinor,
        _EllipsoidPointWithUncertaintyEllipse_orientationMajorAxis,
        _EllipsoidPointWithUncertaintyEllipse_confidence,
        EllipsoidPointWithUncertaintyEllipse,
        _EllipsoidPointWithAltitude_latitudeSign,
        _EllipsoidPointWithAltitude_degreesLatitude,
        _EllipsoidPointWithAltitude_degreesLongitude,
        _EllipsoidPointWithAltitude_altitudeDirection,
        _EllipsoidPointWithAltitude_altitude,
        EllipsoidPointWithAltitude,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_latitudeSign,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLatitude,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_degreesLongitude,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitudeDirection,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_altitude,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMajor,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintySemiMinor,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_orientationMajorAxis,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude,
        _EllipsoidPointWithAltitudeAndUncertaintyEllipsoid_confidence,
        EllipsoidPointWithAltitudeAndUncertaintyEllipsoid,
        _EllipsoidArc_latitudeSign,
        _EllipsoidArc_degreesLatitude,
        _EllipsoidArc_degreesLongitude,
        _EllipsoidArc_innerRadius,
        _EllipsoidArc_uncertaintyRadius,
        _EllipsoidArc_offsetAngle,
        _EllipsoidArc_includedAngle,
        _EllipsoidArc_confidence,
        EllipsoidArc,
        _EPDU_Sequence__item_,
        EPDU_Sequence,
        maxEPDU,
        _EPDU_ePDU_Identifier,
        _EPDU_ePDU_Body,
        EPDU,
        _EPDU_Identifier_ePDU_ID,
        _EPDU_Identifier_ePDU_Name,
        EPDU_Identifier,
        EPDU_ID,
        EPDU_Name,
        EPDU_Body,
        _HorizontalVelocity_bearing,
        _HorizontalVelocity_horizontalSpeed,
        HorizontalVelocity,
        _HorizontalWithVerticalVelocity_bearing,
        _HorizontalWithVerticalVelocity_horizontalSpeed,
        _HorizontalWithVerticalVelocity_verticalDirection,
        _HorizontalWithVerticalVelocity_verticalSpeed,
        HorizontalWithVerticalVelocity,
        _HorizontalVelocityWithUncertainty_bearing,
        _HorizontalVelocityWithUncertainty_horizontalSpeed,
        _HorizontalVelocityWithUncertainty_uncertaintySpeed,
        HorizontalVelocityWithUncertainty,
        _HorizontalWithVerticalVelocityAndUncertainty_bearing,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeed,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalDirection,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalSpeed,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed,
        HorizontalWithVerticalVelocityAndUncertainty,
        _LocationCoordinateTypes_ellipsoidPoint,
        _LocationCoordinateTypes_ellipsoidPointWithUncertaintyCircle,
        _LocationCoordinateTypes_ellipsoidPointWithUncertaintyEllipse,
        _LocationCoordinateTypes_polygon,
        _LocationCoordinateTypes_ellipsoidPointWithAltitude,
        _LocationCoordinateTypes_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid,
        _LocationCoordinateTypes_ellipsoidArc,
        LocationCoordinateTypes,
        _Polygon__item_,
        Polygon,
        _PolygonPoints_latitudeSign,
        _PolygonPoints_degreesLatitude,
        _PolygonPoints_degreesLongitude,
        PolygonPoints,
        _PositioningModes_posModes,
        PositioningModes,
        _VelocityTypes_horizontalVelocity,
        _VelocityTypes_horizontalWithVerticalVelocity,
        _VelocityTypes_horizontalVelocityWithUncertainty,
        _VelocityTypes_horizontalWithVerticalVelocityAndUncertainty,
        VelocityTypes,
        CommonIEsRequestCapabilities,
        CommonIEsProvideCapabilities,
        _CommonIEsRequestAssistanceData_primaryCellID,
        CommonIEsRequestAssistanceData,
        CommonIEsProvideAssistanceData,
        _CommonIEsRequestLocationInformation_locationInformationType,
        _CommonIEsRequestLocationInformation_triggeredReporting,
        _CommonIEsRequestLocationInformation_periodicalReporting,
        _CommonIEsRequestLocationInformation_additionalInformation,
        _CommonIEsRequestLocationInformation_qos,
        _CommonIEsRequestLocationInformation_environment,
        _CommonIEsRequestLocationInformation_locationCoordinateTypes,
        _CommonIEsRequestLocationInformation_velocityTypes,
        CommonIEsRequestLocationInformation,
        LocationInformationType,
        _PeriodicalReportingCriteria_reportingAmount,
        _PeriodicalReportingCriteria_reportingInterval,
        PeriodicalReportingCriteria,
        _TriggeredReportingCriteria_cellChange,
        _TriggeredReportingCriteria_reportingDuration,
        TriggeredReportingCriteria,
        ReportingDuration,
        AdditionalInformation,
        _QoS_horizontalAccuracy,
        _QoS_verticalCoordinateRequest,
        _QoS_verticalAccuracy,
        _QoS_responseTime,
        _QoS_velocityRequest,
        QoS,
        _HorizontalAccuracy_accuracy,
        _HorizontalAccuracy_confidence,
        HorizontalAccuracy,
        _VerticalAccuracy_accuracy,
        _VerticalAccuracy_confidence,
        VerticalAccuracy,
        _ResponseTime_time,
        _ResponseTime_responseTimeEarlyFix_r12,
        ResponseTime,
        Environment,
        _CommonIEsProvideLocationInformation_locationEstimate,
        _CommonIEsProvideLocationInformation_velocityEstimate,
        _CommonIEsProvideLocationInformation_locationError,
        _CommonIEsProvideLocationInformation_earlyFixReport_r12,
        _CommonIEsProvideLocationInformation_locationSource_r13,
        _CommonIEsProvideLocationInformation_locationTimestamp_r13,
        CommonIEsProvideLocationInformation,
        _LocationCoordinates_ellipsoidPoint,
        _LocationCoordinates_ellipsoidPointWithUncertaintyCircle,
        _LocationCoordinates_ellipsoidPointWithUncertaintyEllipse,
        _LocationCoordinates_polygon,
        _LocationCoordinates_ellipsoidPointWithAltitude,
        _LocationCoordinates_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid,
        _LocationCoordinates_ellipsoidArc,
        LocationCoordinates,
        _Velocity_horizontalVelocity,
        _Velocity_horizontalWithVerticalVelocity,
        _Velocity_horizontalVelocityWithUncertainty,
        _Velocity_horizontalWithVerticalVelocityAndUncertainty,
        Velocity,
        _LocationError_locationfailurecause,
        LocationError,
        LocationFailureCause,
        EarlyFixReport_r12,
        LocationSource_r13,
        _CommonIEsAbort_abortCause,
        CommonIEsAbort,
        _CommonIEsError_errorCause,
        CommonIEsError,
        _OTDOA_ProvideAssistanceData_otdoa_ReferenceCellInfo,
        _OTDOA_ProvideAssistanceData_otdoa_NeighbourCellInfo,
        _OTDOA_ProvideAssistanceData_otdoa_Error,
        OTDOA_ProvideAssistanceData,
        _OTDOA_ReferenceCellInfo_physCellId,
        _OTDOA_ReferenceCellInfo_cellGlobalId,
        _OTDOA_ReferenceCellInfo_earfcnRef,
        _OTDOA_ReferenceCellInfo_antennaPortConfig,
        _OTDOA_ReferenceCellInfo_cpLength,
        _OTDOA_ReferenceCellInfo_prsInfo,
        _OTDOA_ReferenceCellInfo_earfcnRef_v9a0,
        OTDOA_ReferenceCellInfo,
        _PRS_Info_prs_Bandwidth,
        _PRS_Info_prs_ConfigurationIndex,
        _PRS_Info_numDL_Frames,
        __PRS_Info_prs_MutingInfo_r9_po2_r9,
        __PRS_Info_prs_MutingInfo_r9_po4_r9,
        __PRS_Info_prs_MutingInfo_r9_po8_r9,
        __PRS_Info_prs_MutingInfo_r9_po16_r9,
        _PRS_Info_prs_MutingInfo_r9,
        PRS_Info,
        _OTDOA_NeighbourCellInfoList__item_,
        OTDOA_NeighbourCellInfoList,
        _OTDOA_NeighbourFreqInfo__item_,
        OTDOA_NeighbourFreqInfo,
        _OTDOA_NeighbourCellInfoElement_physCellId,
        _OTDOA_NeighbourCellInfoElement_cellGlobalId,
        _OTDOA_NeighbourCellInfoElement_earfcn,
        _OTDOA_NeighbourCellInfoElement_cpLength,
        _OTDOA_NeighbourCellInfoElement_prsInfo,
        _OTDOA_NeighbourCellInfoElement_antennaPortConfig,
        _OTDOA_NeighbourCellInfoElement_slotNumberOffset,
        _OTDOA_NeighbourCellInfoElement_prs_SubframeOffset,
        _OTDOA_NeighbourCellInfoElement_expectedRSTD,
        _OTDOA_NeighbourCellInfoElement_expectedRSTD_Uncertainty,
        _OTDOA_NeighbourCellInfoElement_earfcn_v9a0,
        OTDOA_NeighbourCellInfoElement,
        maxFreqLayers,
        _OTDOA_RequestAssistanceData_physCellId,
        OTDOA_RequestAssistanceData,
        _OTDOA_ProvideLocationInformation_otdoaSignalMeasurementInformation,
        _OTDOA_ProvideLocationInformation_otdoa_Error,
        OTDOA_ProvideLocationInformation,
        _OTDOA_SignalMeasurementInformation_systemFrameNumber,
        _OTDOA_SignalMeasurementInformation_physCellIdRef,
        _OTDOA_SignalMeasurementInformation_cellGlobalIdRef,
        _OTDOA_SignalMeasurementInformation_earfcnRef,
        _OTDOA_SignalMeasurementInformation_referenceQuality,
        _OTDOA_SignalMeasurementInformation_neighbourMeasurementList,
        _OTDOA_SignalMeasurementInformation_earfcnRef_v9a0,
        OTDOA_SignalMeasurementInformation,
        _NeighbourMeasurementList__item_,
        NeighbourMeasurementList,
        _NeighbourMeasurementElement_physCellIdNeighbour,
        _NeighbourMeasurementElement_cellGlobalIdNeighbour,
        _NeighbourMeasurementElement_earfcnNeighbour,
        _NeighbourMeasurementElement_rstd,
        _NeighbourMeasurementElement_rstd_Quality,
        _NeighbourMeasurementElement_earfcnNeighbour_v9a0,
        NeighbourMeasurementElement,
        _OTDOA_MeasQuality_error_Resolution,
        _OTDOA_MeasQuality_error_Value,
        _OTDOA_MeasQuality_error_NumSamples,
        OTDOA_MeasQuality,
        _OTDOA_RequestLocationInformation_assistanceAvailability,
        OTDOA_RequestLocationInformation,
        _OTDOA_ProvideCapabilities_otdoa_Mode,
        __OTDOA_ProvideCapabilities_supportedBandListEUTRA__item_,
        _OTDOA_ProvideCapabilities_supportedBandListEUTRA,
        __OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0__item_,
        _OTDOA_ProvideCapabilities_supportedBandListEUTRA_v9a0,
        _OTDOA_ProvideCapabilities_interFreqRSTDmeasurement_r10,
        _OTDOA_ProvideCapabilities_additionalNeighbourCellInfoList_r10,
        OTDOA_ProvideCapabilities,
        maxBands,
        _SupportedBandEUTRA_bandEUTRA,
        SupportedBandEUTRA,
        _SupportedBandEUTRA_v9a0_bandEUTRA_v9a0,
        SupportedBandEUTRA_v9a0,
        maxFBI,
        maxFBI_Plus1,
        maxFBI2,
        OTDOA_RequestCapabilities,
        _OTDOA_Error_locationServerErrorCauses,
        _OTDOA_Error_targetDeviceErrorCauses,
        OTDOA_Error,
        _OTDOA_LocationServerErrorCauses_cause,
        OTDOA_LocationServerErrorCauses,
        _OTDOA_TargetDeviceErrorCauses_cause,
        OTDOA_TargetDeviceErrorCauses,
        _A_GNSS_ProvideAssistanceData_gnss_CommonAssistData,
        _A_GNSS_ProvideAssistanceData_gnss_GenericAssistData,
        _A_GNSS_ProvideAssistanceData_gnss_Error,
        A_GNSS_ProvideAssistanceData,
        _GNSS_CommonAssistData_gnss_ReferenceTime,
        _GNSS_CommonAssistData_gnss_ReferenceLocation,
        _GNSS_CommonAssistData_gnss_IonosphericModel,
        _GNSS_CommonAssistData_gnss_EarthOrientationParameters,
        GNSS_CommonAssistData,
        _GNSS_GenericAssistData__item_,
        GNSS_GenericAssistData,
        _GNSS_GenericAssistDataElement_gnss_ID,
        _GNSS_GenericAssistDataElement_sbas_ID,
        _GNSS_GenericAssistDataElement_gnss_TimeModels,
        _GNSS_GenericAssistDataElement_gnss_DifferentialCorrections,
        _GNSS_GenericAssistDataElement_gnss_NavigationModel,
        _GNSS_GenericAssistDataElement_gnss_RealTimeIntegrity,
        _GNSS_GenericAssistDataElement_gnss_DataBitAssistance,
        _GNSS_GenericAssistDataElement_gnss_AcquisitionAssistance,
        _GNSS_GenericAssistDataElement_gnss_Almanac,
        _GNSS_GenericAssistDataElement_gnss_UTC_Model,
        _GNSS_GenericAssistDataElement_gnss_AuxiliaryInformation,
        _GNSS_GenericAssistDataElement_bds_DifferentialCorrections_r12,
        _GNSS_GenericAssistDataElement_bds_GridModel_r12,
        GNSS_GenericAssistDataElement,
        _GNSS_ReferenceTime_gnss_SystemTime,
        _GNSS_ReferenceTime_referenceTimeUnc,
        __GNSS_ReferenceTime_gnss_ReferenceTimeForCells__item_,
        _GNSS_ReferenceTime_gnss_ReferenceTimeForCells,
        GNSS_ReferenceTime,
        _GNSS_ReferenceTimeForOneCell_networkTime,
        _GNSS_ReferenceTimeForOneCell_referenceTimeUnc,
        _GNSS_ReferenceTimeForOneCell_bsAlign,
        GNSS_ReferenceTimeForOneCell,
        _GNSS_SystemTime_gnss_TimeID,
        _GNSS_SystemTime_gnss_DayNumber,
        _GNSS_SystemTime_gnss_TimeOfDay,
        _GNSS_SystemTime_gnss_TimeOfDayFrac_msec,
        _GNSS_SystemTime_notificationOfLeapSecond,
        _GNSS_SystemTime_gps_TOW_Assist,
        GNSS_SystemTime,
        _GPS_TOW_Assist__item_,
        GPS_TOW_Assist,
        _GPS_TOW_AssistElement_satelliteID,
        _GPS_TOW_AssistElement_tlmWord,
        _GPS_TOW_AssistElement_antiSpoof,
        _GPS_TOW_AssistElement_alert,
        _GPS_TOW_AssistElement_tlmRsvdBits,
        GPS_TOW_AssistElement,
        _NetworkTime_secondsFromFrameStructureStart,
        _NetworkTime_fractionalSecondsFromFrameStructureStart,
        _NetworkTime_frameDrift,
        ___NetworkTime_cellID_eUTRA_physCellId,
        ___NetworkTime_cellID_eUTRA_cellGlobalIdEUTRA,
        ___NetworkTime_cellID_eUTRA_earfcn,
        ___NetworkTime_cellID_eUTRA_earfcn_v9a0,
        __NetworkTime_cellID_eUTRA,
        _____NetworkTime_cellID_uTRA_mode_fdd_primary_CPICH_Info,
        ____NetworkTime_cellID_uTRA_mode_fdd,
        _____NetworkTime_cellID_uTRA_mode_tdd_cellParameters,
        ____NetworkTime_cellID_uTRA_mode_tdd,
        ___NetworkTime_cellID_uTRA_mode,
        ___NetworkTime_cellID_uTRA_cellGlobalIdUTRA,
        ___NetworkTime_cellID_uTRA_uarfcn,
        __NetworkTime_cellID_uTRA,
        ___NetworkTime_cellID_gSM_bcchCarrier,
        ___NetworkTime_cellID_gSM_bsic,
        ___NetworkTime_cellID_gSM_cellGlobalIdGERAN,
        __NetworkTime_cellID_gSM,
        _NetworkTime_cellID,
        NetworkTime,
        _GNSS_ReferenceLocation_threeDlocation,
        GNSS_ReferenceLocation,
        _GNSS_IonosphericModel_klobucharModel,
        _GNSS_IonosphericModel_neQuickModel,
        GNSS_IonosphericModel,
        _KlobucharModelParameter_dataID,
        _KlobucharModelParameter_alfa0,
        _KlobucharModelParameter_alfa1,
        _KlobucharModelParameter_alfa2,
        _KlobucharModelParameter_alfa3,
        _KlobucharModelParameter_beta0,
        _KlobucharModelParameter_beta1,
        _KlobucharModelParameter_beta2,
        _KlobucharModelParameter_beta3,
        KlobucharModelParameter,
        _NeQuickModelParameter_ai0,
        _NeQuickModelParameter_ai1,
        _NeQuickModelParameter_ai2,
        _NeQuickModelParameter_ionoStormFlag1,
        _NeQuickModelParameter_ionoStormFlag2,
        _NeQuickModelParameter_ionoStormFlag3,
        _NeQuickModelParameter_ionoStormFlag4,
        _NeQuickModelParameter_ionoStormFlag5,
        NeQuickModelParameter,
        _GNSS_EarthOrientationParameters_teop,
        _GNSS_EarthOrientationParameters_pmX,
        _GNSS_EarthOrientationParameters_pmXdot,
        _GNSS_EarthOrientationParameters_pmY,
        _GNSS_EarthOrientationParameters_pmYdot,
        _GNSS_EarthOrientationParameters_deltaUT1,
        _GNSS_EarthOrientationParameters_deltaUT1dot,
        GNSS_EarthOrientationParameters,
        _GNSS_TimeModelList__item_,
        GNSS_TimeModelList,
        _GNSS_TimeModelElement_gnss_TimeModelRefTime,
        _GNSS_TimeModelElement_tA0,
        _GNSS_TimeModelElement_tA1,
        _GNSS_TimeModelElement_tA2,
        _GNSS_TimeModelElement_gnss_TO_ID,
        _GNSS_TimeModelElement_weekNumber,
        _GNSS_TimeModelElement_deltaT,
        GNSS_TimeModelElement,
        _GNSS_DifferentialCorrections_dgnss_RefTime,
        _GNSS_DifferentialCorrections_dgnss_SgnTypeList,
        GNSS_DifferentialCorrections,
        _DGNSS_SgnTypeList__item_,
        DGNSS_SgnTypeList,
        _DGNSS_SgnTypeElement_gnss_SignalID,
        _DGNSS_SgnTypeElement_gnss_StatusHealth,
        _DGNSS_SgnTypeElement_dgnss_SatList,
        DGNSS_SgnTypeElement,
        _DGNSS_SatList__item_,
        DGNSS_SatList,
        _DGNSS_CorrectionsElement_svID,
        _DGNSS_CorrectionsElement_iod,
        _DGNSS_CorrectionsElement_udre,
        _DGNSS_CorrectionsElement_pseudoRangeCor,
        _DGNSS_CorrectionsElement_rangeRateCor,
        _DGNSS_CorrectionsElement_udreGrowthRate,
        _DGNSS_CorrectionsElement_udreValidityTime,
        DGNSS_CorrectionsElement,
        _GNSS_NavigationModel_nonBroadcastIndFlag,
        _GNSS_NavigationModel_gnss_SatelliteList,
        GNSS_NavigationModel,
        _GNSS_NavModelSatelliteList__item_,
        GNSS_NavModelSatelliteList,
        _GNSS_NavModelSatelliteElement_svID,
        _GNSS_NavModelSatelliteElement_svHealth,
        _GNSS_NavModelSatelliteElement_iod,
        _GNSS_NavModelSatelliteElement_gnss_ClockModel,
        _GNSS_NavModelSatelliteElement_gnss_OrbitModel,
        _GNSS_NavModelSatelliteElement_svHealthExt_v1240,
        GNSS_NavModelSatelliteElement,
        _GNSS_ClockModel_standardClockModelList,
        _GNSS_ClockModel_nav_ClockModel,
        _GNSS_ClockModel_cnav_ClockModel,
        _GNSS_ClockModel_glonass_ClockModel,
        _GNSS_ClockModel_sbas_ClockModel,
        _GNSS_ClockModel_bds_ClockModel_r12,
        GNSS_ClockModel,
        _GNSS_OrbitModel_keplerianSet,
        _GNSS_OrbitModel_nav_KeplerianSet,
        _GNSS_OrbitModel_cnav_KeplerianSet,
        _GNSS_OrbitModel_glonass_ECEF,
        _GNSS_OrbitModel_sbas_ECEF,
        _GNSS_OrbitModel_bds_KeplerianSet_r12,
        GNSS_OrbitModel,
        _StandardClockModelList__item_,
        StandardClockModelList,
        _StandardClockModelElement_stanClockToc,
        _StandardClockModelElement_stanClockAF2,
        _StandardClockModelElement_stanClockAF1,
        _StandardClockModelElement_stanClockAF0,
        _StandardClockModelElement_stanClockTgd,
        _StandardClockModelElement_sisa,
        _StandardClockModelElement_stanModelID,
        StandardClockModelElement,
        _NAV_ClockModel_navToc,
        _NAV_ClockModel_navaf2,
        _NAV_ClockModel_navaf1,
        _NAV_ClockModel_navaf0,
        _NAV_ClockModel_navTgd,
        NAV_ClockModel,
        _CNAV_ClockModel_cnavToc,
        _CNAV_ClockModel_cnavTop,
        _CNAV_ClockModel_cnavURA0,
        _CNAV_ClockModel_cnavURA1,
        _CNAV_ClockModel_cnavURA2,
        _CNAV_ClockModel_cnavAf2,
        _CNAV_ClockModel_cnavAf1,
        _CNAV_ClockModel_cnavAf0,
        _CNAV_ClockModel_cnavTgd,
        _CNAV_ClockModel_cnavISCl1cp,
        _CNAV_ClockModel_cnavISCl1cd,
        _CNAV_ClockModel_cnavISCl1ca,
        _CNAV_ClockModel_cnavISCl2c,
        _CNAV_ClockModel_cnavISCl5i5,
        _CNAV_ClockModel_cnavISCl5q5,
        CNAV_ClockModel,
        _GLONASS_ClockModel_gloTau,
        _GLONASS_ClockModel_gloGamma,
        _GLONASS_ClockModel_gloDeltaTau,
        GLONASS_ClockModel,
        _SBAS_ClockModel_sbasTo,
        _SBAS_ClockModel_sbasAgfo,
        _SBAS_ClockModel_sbasAgf1,
        SBAS_ClockModel,
        _BDS_ClockModel_r12_bdsAODC_r12,
        _BDS_ClockModel_r12_bdsToc_r12,
        _BDS_ClockModel_r12_bdsA0_r12,
        _BDS_ClockModel_r12_bdsA1_r12,
        _BDS_ClockModel_r12_bdsA2_r12,
        _BDS_ClockModel_r12_bdsTgd1_r12,
        BDS_ClockModel_r12,
        _NavModelKeplerianSet_keplerToe,
        _NavModelKeplerianSet_keplerW,
        _NavModelKeplerianSet_keplerDeltaN,
        _NavModelKeplerianSet_keplerM0,
        _NavModelKeplerianSet_keplerOmegaDot,
        _NavModelKeplerianSet_keplerE,
        _NavModelKeplerianSet_keplerIDot,
        _NavModelKeplerianSet_keplerAPowerHalf,
        _NavModelKeplerianSet_keplerI0,
        _NavModelKeplerianSet_keplerOmega0,
        _NavModelKeplerianSet_keplerCrs,
        _NavModelKeplerianSet_keplerCis,
        _NavModelKeplerianSet_keplerCus,
        _NavModelKeplerianSet_keplerCrc,
        _NavModelKeplerianSet_keplerCic,
        _NavModelKeplerianSet_keplerCuc,
        NavModelKeplerianSet,
        _NavModelNAV_KeplerianSet_navURA,
        _NavModelNAV_KeplerianSet_navFitFlag,
        _NavModelNAV_KeplerianSet_navToe,
        _NavModelNAV_KeplerianSet_navOmega,
        _NavModelNAV_KeplerianSet_navDeltaN,
        _NavModelNAV_KeplerianSet_navM0,
        _NavModelNAV_KeplerianSet_navOmegaADot,
        _NavModelNAV_KeplerianSet_navE,
        _NavModelNAV_KeplerianSet_navIDot,
        _NavModelNAV_KeplerianSet_navAPowerHalf,
        _NavModelNAV_KeplerianSet_navI0,
        _NavModelNAV_KeplerianSet_navOmegaA0,
        _NavModelNAV_KeplerianSet_navCrs,
        _NavModelNAV_KeplerianSet_navCis,
        _NavModelNAV_KeplerianSet_navCus,
        _NavModelNAV_KeplerianSet_navCrc,
        _NavModelNAV_KeplerianSet_navCic,
        _NavModelNAV_KeplerianSet_navCuc,
        __NavModelNAV_KeplerianSet_addNAVparam_ephemCodeOnL2,
        __NavModelNAV_KeplerianSet_addNAVparam_ephemL2Pflag,
        ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved1,
        ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved2,
        ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved3,
        ___NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd_reserved4,
        __NavModelNAV_KeplerianSet_addNAVparam_ephemSF1Rsvd,
        __NavModelNAV_KeplerianSet_addNAVparam_ephemAODA,
        _NavModelNAV_KeplerianSet_addNAVparam,
        NavModelNAV_KeplerianSet,
        _NavModelCNAV_KeplerianSet_cnavTop,
        _NavModelCNAV_KeplerianSet_cnavURAindex,
        _NavModelCNAV_KeplerianSet_cnavDeltaA,
        _NavModelCNAV_KeplerianSet_cnavAdot,
        _NavModelCNAV_KeplerianSet_cnavDeltaNo,
        _NavModelCNAV_KeplerianSet_cnavDeltaNoDot,
        _NavModelCNAV_KeplerianSet_cnavMo,
        _NavModelCNAV_KeplerianSet_cnavE,
        _NavModelCNAV_KeplerianSet_cnavOmega,
        _NavModelCNAV_KeplerianSet_cnavOMEGA0,
        _NavModelCNAV_KeplerianSet_cnavDeltaOmegaDot,
        _NavModelCNAV_KeplerianSet_cnavIo,
        _NavModelCNAV_KeplerianSet_cnavIoDot,
        _NavModelCNAV_KeplerianSet_cnavCis,
        _NavModelCNAV_KeplerianSet_cnavCic,
        _NavModelCNAV_KeplerianSet_cnavCrs,
        _NavModelCNAV_KeplerianSet_cnavCrc,
        _NavModelCNAV_KeplerianSet_cnavCus,
        _NavModelCNAV_KeplerianSet_cnavCuc,
        NavModelCNAV_KeplerianSet,
        _NavModel_GLONASS_ECEF_gloEn,
        _NavModel_GLONASS_ECEF_gloP1,
        _NavModel_GLONASS_ECEF_gloP2,
        _NavModel_GLONASS_ECEF_gloM,
        _NavModel_GLONASS_ECEF_gloX,
        _NavModel_GLONASS_ECEF_gloXdot,
        _NavModel_GLONASS_ECEF_gloXdotdot,
        _NavModel_GLONASS_ECEF_gloY,
        _NavModel_GLONASS_ECEF_gloYdot,
        _NavModel_GLONASS_ECEF_gloYdotdot,
        _NavModel_GLONASS_ECEF_gloZ,
        _NavModel_GLONASS_ECEF_gloZdot,
        _NavModel_GLONASS_ECEF_gloZdotdot,
        NavModel_GLONASS_ECEF,
        _NavModel_SBAS_ECEF_sbasTo,
        _NavModel_SBAS_ECEF_sbasAccuracy,
        _NavModel_SBAS_ECEF_sbasXg,
        _NavModel_SBAS_ECEF_sbasYg,
        _NavModel_SBAS_ECEF_sbasZg,
        _NavModel_SBAS_ECEF_sbasXgDot,
        _NavModel_SBAS_ECEF_sbasYgDot,
        _NavModel_SBAS_ECEF_sbasZgDot,
        _NavModel_SBAS_ECEF_sbasXgDotDot,
        _NavModel_SBAS_ECEF_sbagYgDotDot,
        _NavModel_SBAS_ECEF_sbasZgDotDot,
        NavModel_SBAS_ECEF,
        _NavModel_BDS_KeplerianSet_r12_bdsAODE_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsURAI_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsToe_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsAPowerHalf_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsE_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsW_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsDeltaN_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsM0_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsOmega0_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsOmegaDot_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsI0_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsIDot_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsCuc_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsCus_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsCrc_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsCrs_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsCic_r12,
        _NavModel_BDS_KeplerianSet_r12_bdsCis_r12,
        NavModel_BDS_KeplerianSet_r12,
        _GNSS_RealTimeIntegrity_gnss_BadSignalList,
        GNSS_RealTimeIntegrity,
        _GNSS_BadSignalList__item_,
        GNSS_BadSignalList,
        _BadSignalElement_badSVID,
        _BadSignalElement_badSignalID,
        BadSignalElement,
        _GNSS_DataBitAssistance_gnss_TOD,
        _GNSS_DataBitAssistance_gnss_TODfrac,
        _GNSS_DataBitAssistance_gnss_DataBitsSatList,
        GNSS_DataBitAssistance,
        _GNSS_DataBitsSatList__item_,
        GNSS_DataBitsSatList,
        _GNSS_DataBitsSatElement_svID,
        _GNSS_DataBitsSatElement_gnss_DataBitsSgnList,
        GNSS_DataBitsSatElement,
        _GNSS_DataBitsSgnList__item_,
        GNSS_DataBitsSgnList,
        _GNSS_DataBitsSgnElement_gnss_SignalType,
        _GNSS_DataBitsSgnElement_gnss_DataBits,
        GNSS_DataBitsSgnElement,
        _GNSS_AcquisitionAssistance_gnss_SignalID,
        _GNSS_AcquisitionAssistance_gnss_AcquisitionAssistList,
        _GNSS_AcquisitionAssistance_confidence_r10,
        GNSS_AcquisitionAssistance,
        _GNSS_AcquisitionAssistList__item_,
        GNSS_AcquisitionAssistList,
        _GNSS_AcquisitionAssistElement_svID,
        _GNSS_AcquisitionAssistElement_doppler0,
        _GNSS_AcquisitionAssistElement_doppler1,
        _GNSS_AcquisitionAssistElement_dopplerUncertainty,
        _GNSS_AcquisitionAssistElement_codePhase,
        _GNSS_AcquisitionAssistElement_intCodePhase,
        _GNSS_AcquisitionAssistElement_codePhaseSearchWindow,
        _GNSS_AcquisitionAssistElement_azimuth,
        _GNSS_AcquisitionAssistElement_elevation,
        _GNSS_AcquisitionAssistElement_codePhase1023,
        _GNSS_AcquisitionAssistElement_dopplerUncertaintyExt_r10,
        GNSS_AcquisitionAssistElement,
        _GNSS_Almanac_weekNumber,
        _GNSS_Almanac_toa,
        _GNSS_Almanac_ioda,
        _GNSS_Almanac_completeAlmanacProvided,
        _GNSS_Almanac_gnss_AlmanacList,
        _GNSS_Almanac_toa_ext_v1240,
        _GNSS_Almanac_ioda_ext_v1240,
        GNSS_Almanac,
        _GNSS_AlmanacList__item_,
        GNSS_AlmanacList,
        _GNSS_AlmanacElement_keplerianAlmanacSet,
        _GNSS_AlmanacElement_keplerianNAV_Almanac,
        _GNSS_AlmanacElement_keplerianReducedAlmanac,
        _GNSS_AlmanacElement_keplerianMidiAlmanac,
        _GNSS_AlmanacElement_keplerianGLONASS,
        _GNSS_AlmanacElement_ecef_SBAS_Almanac,
        _GNSS_AlmanacElement_keplerianBDS_Almanac_r12,
        GNSS_AlmanacElement,
        _AlmanacKeplerianSet_svID,
        _AlmanacKeplerianSet_kepAlmanacE,
        _AlmanacKeplerianSet_kepAlmanacDeltaI,
        _AlmanacKeplerianSet_kepAlmanacOmegaDot,
        _AlmanacKeplerianSet_kepSV_StatusINAV,
        _AlmanacKeplerianSet_kepSV_StatusFNAV,
        _AlmanacKeplerianSet_kepAlmanacAPowerHalf,
        _AlmanacKeplerianSet_kepAlmanacOmega0,
        _AlmanacKeplerianSet_kepAlmanacW,
        _AlmanacKeplerianSet_kepAlmanacM0,
        _AlmanacKeplerianSet_kepAlmanacAF0,
        _AlmanacKeplerianSet_kepAlmanacAF1,
        AlmanacKeplerianSet,
        _AlmanacNAV_KeplerianSet_svID,
        _AlmanacNAV_KeplerianSet_navAlmE,
        _AlmanacNAV_KeplerianSet_navAlmDeltaI,
        _AlmanacNAV_KeplerianSet_navAlmOMEGADOT,
        _AlmanacNAV_KeplerianSet_navAlmSVHealth,
        _AlmanacNAV_KeplerianSet_navAlmSqrtA,
        _AlmanacNAV_KeplerianSet_navAlmOMEGAo,
        _AlmanacNAV_KeplerianSet_navAlmOmega,
        _AlmanacNAV_KeplerianSet_navAlmMo,
        _AlmanacNAV_KeplerianSet_navAlmaf0,
        _AlmanacNAV_KeplerianSet_navAlmaf1,
        AlmanacNAV_KeplerianSet,
        _AlmanacReducedKeplerianSet_svID,
        _AlmanacReducedKeplerianSet_redAlmDeltaA,
        _AlmanacReducedKeplerianSet_redAlmOmega0,
        _AlmanacReducedKeplerianSet_redAlmPhi0,
        _AlmanacReducedKeplerianSet_redAlmL1Health,
        _AlmanacReducedKeplerianSet_redAlmL2Health,
        _AlmanacReducedKeplerianSet_redAlmL5Health,
        AlmanacReducedKeplerianSet,
        _AlmanacMidiAlmanacSet_svID,
        _AlmanacMidiAlmanacSet_midiAlmE,
        _AlmanacMidiAlmanacSet_midiAlmDeltaI,
        _AlmanacMidiAlmanacSet_midiAlmOmegaDot,
        _AlmanacMidiAlmanacSet_midiAlmSqrtA,
        _AlmanacMidiAlmanacSet_midiAlmOmega0,
        _AlmanacMidiAlmanacSet_midiAlmOmega,
        _AlmanacMidiAlmanacSet_midiAlmMo,
        _AlmanacMidiAlmanacSet_midiAlmaf0,
        _AlmanacMidiAlmanacSet_midiAlmaf1,
        _AlmanacMidiAlmanacSet_midiAlmL1Health,
        _AlmanacMidiAlmanacSet_midiAlmL2Health,
        _AlmanacMidiAlmanacSet_midiAlmL5Health,
        AlmanacMidiAlmanacSet,
        _AlmanacGLONASS_AlmanacSet_gloAlm_NA,
        _AlmanacGLONASS_AlmanacSet_gloAlmnA,
        _AlmanacGLONASS_AlmanacSet_gloAlmHA,
        _AlmanacGLONASS_AlmanacSet_gloAlmLambdaA,
        _AlmanacGLONASS_AlmanacSet_gloAlmtlambdaA,
        _AlmanacGLONASS_AlmanacSet_gloAlmDeltaIa,
        _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTA,
        _AlmanacGLONASS_AlmanacSet_gloAlmDeltaTdotA,
        _AlmanacGLONASS_AlmanacSet_gloAlmEpsilonA,
        _AlmanacGLONASS_AlmanacSet_gloAlmOmegaA,
        _AlmanacGLONASS_AlmanacSet_gloAlmTauA,
        _AlmanacGLONASS_AlmanacSet_gloAlmCA,
        _AlmanacGLONASS_AlmanacSet_gloAlmMA,
        AlmanacGLONASS_AlmanacSet,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmDataID,
        _AlmanacECEF_SBAS_AlmanacSet_svID,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmHealth,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXg,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYg,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZg,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmXgdot,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmYgDot,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmZgDot,
        _AlmanacECEF_SBAS_AlmanacSet_sbasAlmTo,
        AlmanacECEF_SBAS_AlmanacSet,
        _AlmanacBDS_AlmanacSet_r12_svID,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmToa_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmSqrtA_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmE_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmW_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmM0_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmOmega0_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmOmegaDot_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmDeltaI_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmA0_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsAlmA1_r12,
        _AlmanacBDS_AlmanacSet_r12_bdsSvHealth_r12,
        AlmanacBDS_AlmanacSet_r12,
        _GNSS_UTC_Model_utcModel1,
        _GNSS_UTC_Model_utcModel2,
        _GNSS_UTC_Model_utcModel3,
        _GNSS_UTC_Model_utcModel4,
        _GNSS_UTC_Model_utcModel5_r12,
        GNSS_UTC_Model,
        _UTC_ModelSet1_gnss_Utc_A1,
        _UTC_ModelSet1_gnss_Utc_A0,
        _UTC_ModelSet1_gnss_Utc_Tot,
        _UTC_ModelSet1_gnss_Utc_WNt,
        _UTC_ModelSet1_gnss_Utc_DeltaTls,
        _UTC_ModelSet1_gnss_Utc_WNlsf,
        _UTC_ModelSet1_gnss_Utc_DN,
        _UTC_ModelSet1_gnss_Utc_DeltaTlsf,
        UTC_ModelSet1,
        _UTC_ModelSet2_utcA0,
        _UTC_ModelSet2_utcA1,
        _UTC_ModelSet2_utcA2,
        _UTC_ModelSet2_utcDeltaTls,
        _UTC_ModelSet2_utcTot,
        _UTC_ModelSet2_utcWNot,
        _UTC_ModelSet2_utcWNlsf,
        _UTC_ModelSet2_utcDN,
        _UTC_ModelSet2_utcDeltaTlsf,
        UTC_ModelSet2,
        _UTC_ModelSet3_nA,
        _UTC_ModelSet3_tauC,
        _UTC_ModelSet3_b1,
        _UTC_ModelSet3_b2,
        _UTC_ModelSet3_kp,
        UTC_ModelSet3,
        _UTC_ModelSet4_utcA1wnt,
        _UTC_ModelSet4_utcA0wnt,
        _UTC_ModelSet4_utcTot,
        _UTC_ModelSet4_utcWNt,
        _UTC_ModelSet4_utcDeltaTls,
        _UTC_ModelSet4_utcWNlsf,
        _UTC_ModelSet4_utcDN,
        _UTC_ModelSet4_utcDeltaTlsf,
        _UTC_ModelSet4_utcStandardID,
        UTC_ModelSet4,
        _UTC_ModelSet5_r12_utcA0_r12,
        _UTC_ModelSet5_r12_utcA1_r12,
        _UTC_ModelSet5_r12_utcDeltaTls_r12,
        _UTC_ModelSet5_r12_utcWNlsf_r12,
        _UTC_ModelSet5_r12_utcDN_r12,
        _UTC_ModelSet5_r12_utcDeltaTlsf_r12,
        UTC_ModelSet5_r12,
        _GNSS_AuxiliaryInformation_gnss_ID_GPS,
        _GNSS_AuxiliaryInformation_gnss_ID_GLONASS,
        GNSS_AuxiliaryInformation,
        _GNSS_ID_GPS__item_,
        GNSS_ID_GPS,
        _GNSS_ID_GPS_SatElement_svID,
        _GNSS_ID_GPS_SatElement_signalsAvailable,
        GNSS_ID_GPS_SatElement,
        _GNSS_ID_GLONASS__item_,
        GNSS_ID_GLONASS,
        _GNSS_ID_GLONASS_SatElement_svID,
        _GNSS_ID_GLONASS_SatElement_signalsAvailable,
        _GNSS_ID_GLONASS_SatElement_channelNumber,
        GNSS_ID_GLONASS_SatElement,
        _BDS_DifferentialCorrections_r12_dbds_RefTime_r12,
        _BDS_DifferentialCorrections_r12_bds_SgnTypeList_r12,
        BDS_DifferentialCorrections_r12,
        _BDS_SgnTypeList_r12__item_,
        BDS_SgnTypeList_r12,
        _BDS_SgnTypeElement_r12_gnss_SignalID,
        _BDS_SgnTypeElement_r12_dbds_CorrectionList_r12,
        BDS_SgnTypeElement_r12,
        _DBDS_CorrectionList_r12__item_,
        DBDS_CorrectionList_r12,
        _DBDS_CorrectionElement_r12_svID,
        _DBDS_CorrectionElement_r12_bds_UDREI_r12,
        _DBDS_CorrectionElement_r12_bds_RURAI_r12,
        _DBDS_CorrectionElement_r12_bds_ECC_DeltaT_r12,
        DBDS_CorrectionElement_r12,
        _BDS_GridModelParameter_r12_bds_RefTime_r12,
        _BDS_GridModelParameter_r12_gridIonList_r12,
        BDS_GridModelParameter_r12,
        _GridIonList_r12__item_,
        GridIonList_r12,
        _GridIonElement_r12_igp_ID_r12,
        _GridIonElement_r12_dt_r12,
        _GridIonElement_r12_givei_r12,
        GridIonElement_r12,
        _A_GNSS_RequestAssistanceData_gnss_CommonAssistDataReq,
        _A_GNSS_RequestAssistanceData_gnss_GenericAssistDataReq,
        A_GNSS_RequestAssistanceData,
        _GNSS_CommonAssistDataReq_gnss_ReferenceTimeReq,
        _GNSS_CommonAssistDataReq_gnss_ReferenceLocationReq,
        _GNSS_CommonAssistDataReq_gnss_IonosphericModelReq,
        _GNSS_CommonAssistDataReq_gnss_EarthOrientationParametersReq,
        GNSS_CommonAssistDataReq,
        _GNSS_GenericAssistDataReq__item_,
        GNSS_GenericAssistDataReq,
        _GNSS_GenericAssistDataReqElement_gnss_ID,
        _GNSS_GenericAssistDataReqElement_sbas_ID,
        _GNSS_GenericAssistDataReqElement_gnss_TimeModelsReq,
        _GNSS_GenericAssistDataReqElement_gnss_DifferentialCorrectionsReq,
        _GNSS_GenericAssistDataReqElement_gnss_NavigationModelReq,
        _GNSS_GenericAssistDataReqElement_gnss_RealTimeIntegrityReq,
        _GNSS_GenericAssistDataReqElement_gnss_DataBitAssistanceReq,
        _GNSS_GenericAssistDataReqElement_gnss_AcquisitionAssistanceReq,
        _GNSS_GenericAssistDataReqElement_gnss_AlmanacReq,
        _GNSS_GenericAssistDataReqElement_gnss_UTCModelReq,
        _GNSS_GenericAssistDataReqElement_gnss_AuxiliaryInformationReq,
        _GNSS_GenericAssistDataReqElement_bds_DifferentialCorrectionsReq_r12,
        _GNSS_GenericAssistDataReqElement_bds_GridModelReq_r12,
        GNSS_GenericAssistDataReqElement,
        __GNSS_ReferenceTimeReq_gnss_TimeReqPrefList__item_,
        _GNSS_ReferenceTimeReq_gnss_TimeReqPrefList,
        _GNSS_ReferenceTimeReq_gps_TOW_assistReq,
        _GNSS_ReferenceTimeReq_notOfLeapSecReq,
        GNSS_ReferenceTimeReq,
        GNSS_ReferenceLocationReq,
        _GNSS_IonosphericModelReq_klobucharModelReq,
        _GNSS_IonosphericModelReq_neQuickModelReq,
        GNSS_IonosphericModelReq,
        GNSS_EarthOrientationParametersReq,
        _GNSS_TimeModelListReq__item_,
        GNSS_TimeModelListReq,
        _GNSS_TimeModelElementReq_gnss_TO_IDsReq,
        _GNSS_TimeModelElementReq_deltaTreq,
        GNSS_TimeModelElementReq,
        _GNSS_DifferentialCorrectionsReq_dgnss_SignalsReq,
        _GNSS_DifferentialCorrectionsReq_dgnss_ValidityTimeReq,
        GNSS_DifferentialCorrectionsReq,
        _GNSS_NavigationModelReq_storedNavList,
        _GNSS_NavigationModelReq_reqNavList,
        GNSS_NavigationModelReq,
        _StoredNavListInfo_gnss_WeekOrDay,
        _StoredNavListInfo_gnss_Toe,
        _StoredNavListInfo_t_toeLimit,
        _StoredNavListInfo_satListRelatedDataList,
        StoredNavListInfo,
        _SatListRelatedDataList__item_,
        SatListRelatedDataList,
        _SatListRelatedDataElement_svID,
        _SatListRelatedDataElement_iod,
        _SatListRelatedDataElement_clockModelID,
        _SatListRelatedDataElement_orbitModelID,
        SatListRelatedDataElement,
        _ReqNavListInfo_svReqList,
        __ReqNavListInfo_clockModelID_PrefList__item_,
        _ReqNavListInfo_clockModelID_PrefList,
        __ReqNavListInfo_orbitModelID_PrefList__item_,
        _ReqNavListInfo_orbitModelID_PrefList,
        _ReqNavListInfo_addNavparamReq,
        ReqNavListInfo,
        GNSS_RealTimeIntegrityReq,
        _GNSS_DataBitAssistanceReq_gnss_TOD_Req,
        _GNSS_DataBitAssistanceReq_gnss_TOD_FracReq,
        _GNSS_DataBitAssistanceReq_dataBitInterval,
        _GNSS_DataBitAssistanceReq_gnss_SignalType,
        _GNSS_DataBitAssistanceReq_gnss_DataBitsReq,
        GNSS_DataBitAssistanceReq,
        _GNSS_DataBitsReqSatList__item_,
        GNSS_DataBitsReqSatList,
        _GNSS_DataBitsReqSatElement_svID,
        GNSS_DataBitsReqSatElement,
        _GNSS_AcquisitionAssistanceReq_gnss_SignalID_Req,
        GNSS_AcquisitionAssistanceReq,
        _GNSS_AlmanacReq_modelID,
        GNSS_AlmanacReq,
        _GNSS_UTC_ModelReq_modelID,
        GNSS_UTC_ModelReq,
        GNSS_AuxiliaryInformationReq,
        _BDS_DifferentialCorrectionsReq_r12_dgnss_SignalsReq,
        BDS_DifferentialCorrectionsReq_r12,
        BDS_GridModelReq_r12,
        _A_GNSS_ProvideLocationInformation_gnss_SignalMeasurementInformation,
        _A_GNSS_ProvideLocationInformation_gnss_LocationInformation,
        _A_GNSS_ProvideLocationInformation_gnss_Error,
        A_GNSS_ProvideLocationInformation,
        _GNSS_SignalMeasurementInformation_measurementReferenceTime,
        _GNSS_SignalMeasurementInformation_gnss_MeasurementList,
        GNSS_SignalMeasurementInformation,
        _MeasurementReferenceTime_gnss_TOD_msec,
        _MeasurementReferenceTime_gnss_TOD_frac,
        _MeasurementReferenceTime_gnss_TOD_unc,
        _MeasurementReferenceTime_gnss_TimeID,
        ___MeasurementReferenceTime_networkTime_eUTRA_physCellId,
        ___MeasurementReferenceTime_networkTime_eUTRA_cellGlobalId,
        ___MeasurementReferenceTime_networkTime_eUTRA_systemFrameNumber,
        __MeasurementReferenceTime_networkTime_eUTRA,
        _____MeasurementReferenceTime_networkTime_uTRA_mode_fdd_primary_CPICH_Info,
        ____MeasurementReferenceTime_networkTime_uTRA_mode_fdd,
        _____MeasurementReferenceTime_networkTime_uTRA_mode_tdd_cellParameters,
        ____MeasurementReferenceTime_networkTime_uTRA_mode_tdd,
        ___MeasurementReferenceTime_networkTime_uTRA_mode,
        ___MeasurementReferenceTime_networkTime_uTRA_cellGlobalId,
        ___MeasurementReferenceTime_networkTime_uTRA_referenceSystemFrameNumber,
        __MeasurementReferenceTime_networkTime_uTRA,
        ___MeasurementReferenceTime_networkTime_gSM_bcchCarrier,
        ___MeasurementReferenceTime_networkTime_gSM_bsic,
        ___MeasurementReferenceTime_networkTime_gSM_cellGlobalId,
        ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFN,
        ____MeasurementReferenceTime_networkTime_gSM_referenceFrame_referenceFNMSB,
        ___MeasurementReferenceTime_networkTime_gSM_referenceFrame,
        ___MeasurementReferenceTime_networkTime_gSM_deltaGNSS_TOD,
        __MeasurementReferenceTime_networkTime_gSM,
        _MeasurementReferenceTime_networkTime,
        MeasurementReferenceTime,
        _GNSS_MeasurementList__item_,
        GNSS_MeasurementList,
        _GNSS_MeasurementForOneGNSS_gnss_ID,
        _GNSS_MeasurementForOneGNSS_gnss_SgnMeasList,
        GNSS_MeasurementForOneGNSS,
        _GNSS_SgnMeasList__item_,
        GNSS_SgnMeasList,
        _GNSS_SgnMeasElement_gnss_SignalID,
        _GNSS_SgnMeasElement_gnss_CodePhaseAmbiguity,
        _GNSS_SgnMeasElement_gnss_SatMeasList,
        GNSS_SgnMeasElement,
        _GNSS_SatMeasList__item_,
        GNSS_SatMeasList,
        _GNSS_SatMeasElement_svID,
        _GNSS_SatMeasElement_cNo,
        _GNSS_SatMeasElement_mpathDet,
        _GNSS_SatMeasElement_carrierQualityInd,
        _GNSS_SatMeasElement_codePhase,
        _GNSS_SatMeasElement_integerCodePhase,
        _GNSS_SatMeasElement_codePhaseRMSError,
        _GNSS_SatMeasElement_doppler,
        _GNSS_SatMeasElement_adr,
        GNSS_SatMeasElement,
        _GNSS_LocationInformation_measurementReferenceTime,
        _GNSS_LocationInformation_agnss_List,
        GNSS_LocationInformation,
        _A_GNSS_RequestLocationInformation_gnss_PositioningInstructions,
        A_GNSS_RequestLocationInformation,
        _GNSS_PositioningInstructions_gnss_Methods,
        _GNSS_PositioningInstructions_fineTimeAssistanceMeasReq,
        _GNSS_PositioningInstructions_adrMeasReq,
        _GNSS_PositioningInstructions_multiFreqMeasReq,
        _GNSS_PositioningInstructions_assistanceAvailability,
        GNSS_PositioningInstructions,
        _A_GNSS_ProvideCapabilities_gnss_SupportList,
        _A_GNSS_ProvideCapabilities_assistanceDataSupportList,
        _A_GNSS_ProvideCapabilities_locationCoordinateTypes,
        _A_GNSS_ProvideCapabilities_velocityTypes,
        A_GNSS_ProvideCapabilities,
        _GNSS_SupportList__item_,
        GNSS_SupportList,
        _GNSS_SupportElement_gnss_ID,
        _GNSS_SupportElement_sbas_IDs,
        _GNSS_SupportElement_agnss_Modes,
        _GNSS_SupportElement_gnss_Signals,
        __GNSS_SupportElement_fta_MeasSupport_cellTime,
        __GNSS_SupportElement_fta_MeasSupport_mode,
        _GNSS_SupportElement_fta_MeasSupport,
        _GNSS_SupportElement_adr_Support,
        _GNSS_SupportElement_velocityMeasurementSupport,
        GNSS_SupportElement,
        _AssistanceDataSupportList_gnss_CommonAssistanceDataSupport,
        _AssistanceDataSupportList_gnss_GenericAssistanceDataSupport,
        AssistanceDataSupportList,
        _GNSS_CommonAssistanceDataSupport_gnss_ReferenceTimeSupport,
        _GNSS_CommonAssistanceDataSupport_gnss_ReferenceLocationSupport,
        _GNSS_CommonAssistanceDataSupport_gnss_IonosphericModelSupport,
        _GNSS_CommonAssistanceDataSupport_gnss_EarthOrientationParametersSupport,
        GNSS_CommonAssistanceDataSupport,
        _GNSS_ReferenceTimeSupport_gnss_SystemTime,
        _GNSS_ReferenceTimeSupport_fta_Support,
        GNSS_ReferenceTimeSupport,
        GNSS_ReferenceLocationSupport,
        _GNSS_IonosphericModelSupport_ionoModel,
        GNSS_IonosphericModelSupport,
        GNSS_EarthOrientationParametersSupport,
        _GNSS_GenericAssistanceDataSupport__item_,
        GNSS_GenericAssistanceDataSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_ID,
        _GNSS_GenericAssistDataSupportElement_sbas_ID,
        _GNSS_GenericAssistDataSupportElement_gnss_TimeModelsSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_DifferentialCorrectionsSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_NavigationModelSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_RealTimeIntegritySupport,
        _GNSS_GenericAssistDataSupportElement_gnss_DataBitAssistanceSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_AcquisitionAssistanceSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_AlmanacSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_UTC_ModelSupport,
        _GNSS_GenericAssistDataSupportElement_gnss_AuxiliaryInformationSupport,
        _GNSS_GenericAssistDataSupportElement_bds_DifferentialCorrectionsSupport_r12,
        _GNSS_GenericAssistDataSupportElement_bds_GridModelSupport_r12,
        GNSS_GenericAssistDataSupportElement,
        GNSS_TimeModelListSupport,
        _GNSS_DifferentialCorrectionsSupport_gnssSignalIDs,
        _GNSS_DifferentialCorrectionsSupport_dgnss_ValidityTimeSup,
        GNSS_DifferentialCorrectionsSupport,
        _GNSS_NavigationModelSupport_clockModel,
        _GNSS_NavigationModelSupport_orbitModel,
        GNSS_NavigationModelSupport,
        GNSS_RealTimeIntegritySupport,
        GNSS_DataBitAssistanceSupport,
        _GNSS_AcquisitionAssistanceSupport_confidenceSupport_r10,
        _GNSS_AcquisitionAssistanceSupport_dopplerUncertaintyExtSupport_r10,
        GNSS_AcquisitionAssistanceSupport,
        _GNSS_AlmanacSupport_almanacModel,
        GNSS_AlmanacSupport,
        _GNSS_UTC_ModelSupport_utc_Model,
        GNSS_UTC_ModelSupport,
        GNSS_AuxiliaryInformationSupport,
        _BDS_DifferentialCorrectionsSupport_r12_gnssSignalIDs,
        BDS_DifferentialCorrectionsSupport_r12,
        BDS_GridModelSupport_r12,
        _A_GNSS_RequestCapabilities_gnss_SupportListReq,
        _A_GNSS_RequestCapabilities_assistanceDataSupportListReq,
        _A_GNSS_RequestCapabilities_locationVelocityTypesReq,
        A_GNSS_RequestCapabilities,
        _A_GNSS_Error_locationServerErrorCauses,
        _A_GNSS_Error_targetDeviceErrorCauses,
        A_GNSS_Error,
        _GNSS_LocationServerErrorCauses_cause,
        GNSS_LocationServerErrorCauses,
        _GNSS_TargetDeviceErrorCauses_cause,
        _GNSS_TargetDeviceErrorCauses_fineTimeAssistanceMeasurementsNotPossible,
        _GNSS_TargetDeviceErrorCauses_adrMeasurementsNotPossible,
        _GNSS_TargetDeviceErrorCauses_multiFrequencyMeasurementsNotPossible,
        GNSS_TargetDeviceErrorCauses,
        _GNSS_ID_gnss_id,
        GNSS_ID,
        _GNSS_ID_Bitmap_gnss_ids,
        GNSS_ID_Bitmap,
        _GNSS_SignalID_gnss_SignalID,
        GNSS_SignalID,
        _GNSS_SignalIDs_gnss_SignalIDs,
        GNSS_SignalIDs,
        _SBAS_ID_sbas_id,
        SBAS_ID,
        _SBAS_IDs_sbas_IDs,
        SBAS_IDs,
        _SV_ID_satellite_id,
        SV_ID,
        _ECID_ProvideLocationInformation_ecid_SignalMeasurementInformation,
        _ECID_ProvideLocationInformation_ecid_Error,
        ECID_ProvideLocationInformation,
        _ECID_SignalMeasurementInformation_primaryCellMeasuredResults,
        _ECID_SignalMeasurementInformation_measuredResultsList,
        ECID_SignalMeasurementInformation,
        _MeasuredResultsList__item_,
        MeasuredResultsList,
        _MeasuredResultsElement_physCellId,
        _MeasuredResultsElement_cellGlobalId,
        _MeasuredResultsElement_arfcnEUTRA,
        _MeasuredResultsElement_systemFrameNumber,
        _MeasuredResultsElement_rsrp_Result,
        _MeasuredResultsElement_rsrq_Result,
        _MeasuredResultsElement_ue_RxTxTimeDiff,
        _MeasuredResultsElement_arfcnEUTRA_v9a0,
        MeasuredResultsElement,
        _ECID_RequestLocationInformation_requestedMeasurements,
        ECID_RequestLocationInformation,
        _ECID_ProvideCapabilities_ecid_MeasSupported,
        ECID_ProvideCapabilities,
        ECID_RequestCapabilities,
        _ECID_Error_locationServerErrorCauses,
        _ECID_Error_targetDeviceErrorCauses,
        ECID_Error,
        _ECID_LocationServerErrorCauses_cause,
        ECID_LocationServerErrorCauses,
        _ECID_TargetDeviceErrorCauses_cause,
        _ECID_TargetDeviceErrorCauses_rsrpMeasurementNotPossible,
        _ECID_TargetDeviceErrorCauses_rsrqMeasurementNotPossible,
        _ECID_TargetDeviceErrorCauses_ueRxTxMeasurementNotPossible,
        ECID_TargetDeviceErrorCauses,
        _TBS_ProvideLocationInformation_r13_tbs_MeasurementInformation_r13,
        _TBS_ProvideLocationInformation_r13_tbs_Error_r13,
        TBS_ProvideLocationInformation_r13,
        _TBS_MeasurementInformation_r13_measurementReferenceTime_r13,
        _TBS_MeasurementInformation_r13_mbs_SgnMeasList_r13,
        TBS_MeasurementInformation_r13,
        _MBS_BeaconMeasList_r13__item_,
        MBS_BeaconMeasList_r13,
        _MBS_BeaconMeasElement_r13_transmitterID_r13,
        _MBS_BeaconMeasElement_r13_codePhase_r13,
        _MBS_BeaconMeasElement_r13_codePhaseRMSError_r13,
        MBS_BeaconMeasElement_r13,
        _TBS_RequestLocationInformation_r13_mbsSgnMeasListReq_r13,
        TBS_RequestLocationInformation_r13,
        _TBS_ProvideCapabilities_r13_tbs_Modes_r13,
        TBS_ProvideCapabilities_r13,
        TBS_RequestCapabilities_r13,
        _TBS_Error_r13_locationServerErrorCauses_r13,
        _TBS_Error_r13_targetDeviceErrorCauses_r13,
        TBS_Error_r13,
        _TBS_LocationServerErrorCauses_r13_cause_r13,
        TBS_LocationServerErrorCauses_r13,
        _TBS_TargetDeviceErrorCauses_r13_cause_r13,
        TBS_TargetDeviceErrorCauses_r13,
        _Sensor_ProvideLocationInformation_r13_sensor_MeasurementInformation_r13,
        _Sensor_ProvideLocationInformation_r13_sensor_Error_r13,
        Sensor_ProvideLocationInformation_r13,
        _Sensor_MeasurementInformation_r13_measurementReferenceTime_r13,
        _Sensor_MeasurementInformation_r13_uncompensatedBarometricPressure_r13,
        Sensor_MeasurementInformation_r13,
        _Sensor_RequestLocationInformation_r13_uncompensatedBarometricPressureReq_r13,
        Sensor_RequestLocationInformation_r13,
        _Sensor_ProvideCapabilities_r13_sensor_Modes_r13,
        Sensor_ProvideCapabilities_r13,
        Sensor_RequestCapabilities_r13,
        _Sensor_Error_r13_locationServerErrorCauses_r13,
        _Sensor_Error_r13_targetDeviceErrorCauses_r13,
        Sensor_Error_r13,
        _Sensor_LocationServerErrorCauses_r13_cause_r13,
        Sensor_LocationServerErrorCauses_r13,
        _Sensor_TargetDeviceErrorCauses_r13_cause_r13,
        Sensor_TargetDeviceErrorCauses_r13,
        _WLAN_ProvideLocationInformation_r13_wlan_MeasurementInformation_r13,
        _WLAN_ProvideLocationInformation_r13_wlan_Error_r13,
        WLAN_ProvideLocationInformation_r13,
        _WLAN_MeasurementInformation_r13_measurementReferenceTime_r13,
        _WLAN_MeasurementInformation_r13_wlan_MeasurementList_r13,
        WLAN_MeasurementInformation_r13,
        _WLAN_MeasurementList_r13__item_,
        WLAN_MeasurementList_r13,
        _WLAN_MeasurementElement_r13_wlan_AP_Identifier_r13,
        _WLAN_MeasurementElement_r13_rssi_r13,
        _WLAN_MeasurementElement_r13_rtt_r13,
        _WLAN_MeasurementElement_r13_apChannelFrequency_r13,
        _WLAN_MeasurementElement_r13_servingFlag_r13,
        WLAN_MeasurementElement_r13,
        _WLAN_AP_Identifier_r13_bssid_r13,
        _WLAN_AP_Identifier_r13_ssid_r13,
        WLAN_AP_Identifier_r13,
        _WLAN_RTT_r13_rttValue_r13,
        _WLAN_RTT_r13_rttUnits_r13,
        _WLAN_RTT_r13_rttAccuracy_r13,
        WLAN_RTT_r13,
        maxWLAN_AP_r13,
        _WLAN_RequestLocationInformation_r13_requestedMeasurements_r13,
        WLAN_RequestLocationInformation_r13,
        _WLAN_ProvideCapabilities_r13_wlan_Modes_r13,
        _WLAN_ProvideCapabilities_r13_wlan_MeasSupported_r13,
        WLAN_ProvideCapabilities_r13,
        WLAN_RequestCapabilities_r13,
        _WLAN_Error_r13_locationServerErrorCauses_r13,
        _WLAN_Error_r13_targetDeviceErrorCauses_r13,
        WLAN_Error_r13,
        _WLAN_LocationServerErrorCauses_r13_cause_r13,
        WLAN_LocationServerErrorCauses_r13,
        _WLAN_TargetDeviceErrorCauses_r13_cause_r13,
        _WLAN_TargetDeviceErrorCauses_r13_wlan_AP_RSSI_MeasurementNotPossible_r13,
        _WLAN_TargetDeviceErrorCauses_r13_wlan_AP_RTT_MeasurementNotPossible_r13,
        WLAN_TargetDeviceErrorCauses_r13,
        _BT_ProvideLocationInformation_r13_bt_MeasurementInformation_r13,
        _BT_ProvideLocationInformation_r13_bt_Error_r13,
        BT_ProvideLocationInformation_r13,
        _BT_MeasurementInformation_r13_measurementReferenceTime_r13,
        _BT_MeasurementInformation_r13_bt_MeasurementList_r13,
        BT_MeasurementInformation_r13,
        _BT_MeasurementList_r13__item_,
        BT_MeasurementList_r13,
        _BT_MeasurementElement_r13_btAddr_r13,
        _BT_MeasurementElement_r13_rssi_r13,
        BT_MeasurementElement_r13,
        maxBT_Beacon_r13,
        _BT_RequestLocationInformation_r13_requestedMeasurements_r13,
        BT_RequestLocationInformation_r13,
        _BT_ProvideCapabilities_r13_bt_Modes_r13,
        _BT_ProvideCapabilities_r13_bt_MeasSupported_r13,
        BT_ProvideCapabilities_r13,
        BT_RequestCapabilities_r13,
        _BT_Error_r13_locationServerErrorCauses_r13,
        _BT_Error_r13_targetDeviceErrorCauses_r13,
        BT_Error_r13,
        _BT_LocationServerErrorCauses_r13_cause_r13,
        BT_LocationServerErrorCauses_r13,
        _BT_TargetDeviceErrorCauses_r13_cause_r13,
        _BT_TargetDeviceErrorCauses_r13_bt_Beacon_rssiMeasurementNotPossible_r13,
        BT_TargetDeviceErrorCauses_r13,
    ]

class OMA_LPPE:

    _name_  = 'OMA-LPPE'
    _oid_   = []
    
    _obj_ = [
        'OMA-LPPe-MessageExtension',
        'OMA-LPPe-LPPeCompatibilityLevel',
        'OMA-LPPe-LPPeVersion',
        'OMA-LPPe-LPPeMode',
        'OMA-LPPe-MessageExtensionBody',
        'OMA-LPPe-ver1-1-BroadcastContainer',
        'OMA-LPPe-ver1-1-BroadcastMessage',
        'OMA-LPPe-ver1-1-BroadcastControlIEs',
        'OMA-LPPe-ver1-1-CipheringIEs',
        'OMA-LPPe-ver1-1-DigitalSignature',
        'OMA-LPPe-RequestCapabilities',
        'OMA-LPPe-ProvideCapabilities',
        'OMA-LPPe-RequestAssistanceData',
        'OMA-LPPe-ProvideAssistanceData',
        'OMA-LPPe-RequestLocationInformation',
        'OMA-LPPe-ProvideLocationInformation',
        'OMA-LPPe-Abort',
        'OMA-LPPe-Error',
        'OMA-LPPe-AssistanceContainer-DataSerialNumber',
        'OMA-LPPe-AssistanceContainerID',
        'OMA-LPPe-AssistanceContainerProvideList',
        'maxAssistanceContainerList',
        'OMA-LPPe-AssistanceContainerProvide',
        'OMA-LPPe-AssistanceContainerData',
        'OMA-LPPe-AssistanceContainerProvideError',
        'OMA-LPPe-AssistanceContainerRequestList',
        'OMA-LPPe-AssistanceContainerRequest',
        'OMA-LPPe-AssistanceContainerCheckOrUpdateReq',
        'OMA-LPPe-CellLocalIdGERAN',
        'OMA-LPPe-CellNonUniqueIDGERAN',
        'OMA-LPPe-CharArray',
        'OMA-LPPe-CivicLocation',
        'OMA-LPPe-CivicAddressElementList',
        'OMA-LPPe-CivicAddressElement',
        'OMA-LPPe-Duration',
        'OMA-LPPe-FixedAccessTypes',
        'OMA-LPPe-ver1-1-GroundMorphologyModel',
        'OMA-LPPe-ver1-1-AltitudeModel',
        'OMA-LPPe-ver1-1-BuildingsHeightModel',
        'DeltaAltitudes',
        'DeltaHeight',
        'OMA-LPPe-ver1-1-CellGlobalID',
        'OMA-LPPe-HighAccuracy3Dposition',
        'OMA-LPPe-HighAccuracy3Dvelocity',
        'OMA-LPPe-LocationInformationContainerID',
        'OMA-LPPe-LocationInformationContainer',
        'OMA-LPPe-LocationInformationContainerDataList',
        'OMA-LPPe-LocationInformationContainerData',
        'OMA-LPPe-LocationInformationContainerRequest',
        'OMA-LPPe-LocationInformationContainerRequestList',
        'maxLocationInformationContainerDataList',
        'OMA-LPPe-LocationInformationContainerRequestItem',
        'OMA-LPPe-MapDataReference',
        'OMA-LPPe-Orientation',
        'OMA-LPPe-ReferencePoint',
        'OMA-LPPe-MapDataInformation',
        'OMA-LPPe-MapDataReferenceElement',
        'OMA-LPPe-ReferencePointRelationship',
        'OMA-LPPe-ReferencePointUniqueID',
        'OMA-LPPe-RelativeLocation',
        'OMA-LPPe-HorizontalUncertaintyAndConfidence',
        'OMA-LPPe-RelativeAltitude',
        'OMA-LPPe-GeodeticRelativeAltitude',
        'OMA-LPPe-GeodeticUncertaintyAndConfidence',
        'OMA-LPPe-CivicRelativeAltitude',
        'OMA-LPPe-CivicUncertaintyAndConfidence',
        'OMA-LPPe-Session-ID',
        'OMA-LPPe-Uri',
        'OMA-LPPe-ver1-1-BroadcastSystemID',
        'OMA-LPPe-ver1-1-BroadcastADTypes',
        'OMA-LPPe-ver1-1-LabelSet',
        'maxLevel1-element',
        'maxLevel2-element',
        'maxLevel3-element',
        'maxFinal-element',
        'maxLPPLabelSets',
        'maxLPPeLabelSets',
        'OMA-LPPe-ver1-1-AccessNetworkID',
        'OMA-LPPe-ver1-1-MCC-MNC',
        'OMA-LPPe-ver1-1-BSID',
        'OMA-LPPe-ver1-1-AuthenticationSetID',
        'OMA-LPPe-ver1-1-AuthenticationSet',
        'OMA-LPPe-ver1-1-CipherSetID',
        'OMA-LPPe-ver1-1-CipherSet',
        'OMA-LPPe-ver1-1-ServerID',
        'OMA-LPPe-ValidityArea',
        'OMA-LPPe-RleList',
        'OMA-LPPe-ValidityPeriod',
        'OMA-LPPe-VendorOrOperatorAssistanceDataIdentifier',
        'OMA-LPPe-VendorOrOperatorID',
        'OMA-LPPe-NonStandard-VendorOrOperatorID',
        'OMA-LPPe-WirelessAccessTypes',
        'OMA-LPPe-WLAN-AP-ID',
        'OMA-LPPe-WLAN-AP-Type',
        'OMA-LPPe-WLAN-AP-Type-List',
        'OMA-LPPe-WLANFemtoCoverageArea',
        'OMA-LPPe-WLANFemtoCoverageAreaElement',
        'OMA-LPPe-CommonIEsRequestCapabilities',
        'OMA-LPPe-IP-Address-RequestCapabilities',
        'OMA-LPPe-AssistanceContainerSupportReq',
        'OMA-LPPe-LocationInformationContainerSupportReq',
        'OMA-LPPe-VendorOrOperatorIDList',
        'maxVendorOrOperatorIDList',
        'OMA-LPPe-RelativeLocationChange-RequestCapabilities',
        'OMA-LPPe-HighAccuracyFormatCapabilitiesReq',
        'OMA-LPPe-SegmentedAssistanceData-ReqCapabilities',
        'OMA-LPPe-ReferencePointCapabilitiesReq',
        'OMA-LPPe-ScheduledLocation-RequestCapabilities',
        'OMA-LPPe-AccessCapabilitiesReq',
        'OMA-LPPe-SegmentedLocationInformation-ReqCapabilities',
        'OMA-LPPe-ver1-1-localCellInformation-ReqCapabilities',
        'OMA-LPPe-ver1-1-broadcast-ReqCapabilities',
        'OMA-LPPe-CommonIEsProvideCapabilities',
        'OMA-LPPe-IP-Address-Capabilities',
        'OMA-LPPe-AssistanceContainerSupport',
        'OMA-LPPe-VendorOrOperatorAssistanceContainerList',
        'OMA-LPPe-AssistanceContainerList',
        'OMA-LPPe-LocationInformationContainerSupport',
        'OMA-LPPe-VendorOrOperatorLocationInformationContainerList',
        'OMA-LPPe-LocationInformationContainerList',
        'maxLocationInformationContainerList',
        'OMA-LPPe-RelativeLocationChange-Capabilities',
        'OMA-LPPe-HighAccuracyFormatCapabilities',
        'OMA-LPPe-SegmentedAssistanceData-ProvideCapabs',
        'OMA-LPPe-ReferencePointCapabilities',
        'OMA-LPPe-ReferencePointProviderSupportElement',
        'OMA-LPPe-ScheduledLocation-Capabilities',
        'OMA-LPPe-AccessCapabilities',
        'OMA-LPPe-SegmentedLocationInformation-ProvideCapabs',
        'OMA-LPPe-ver1-1-localCellInformation-ProvideCapabilities',
        'OMA-LPPe-ver1-1-broadcast-ProvideCapabilities',
        'OMA-LPPe-ver1-1-BroadcastSystem-Capabs',
        'OMA-LPPe-ver1-1-point2pointAD',
        'OMA-LPPe-ver1-1-Ciphering',
        'OMA-LPPe-ver1-1-Authentication',
        'OMA-LPPe-CommonIEsRequestAssistanceData',
        'OMA-LPPe-RequestPeriodicADwithUpdate',
        'TypeOfADRequest',
        'OMA-LPPe-SegmentedADResume',
        'OMA-LPPe-ReferencePointAssistanceReq',
        'OMA-LPPe-ReferencePointAssistanceReqElement',
        'OMA-LPPe-ver1-1-GroundMorphologyModelReq',
        'OMA-LPPe-ver1-1-LocalCellInformationReq',
        'OMA-LPPe-ver1-1-BroadcastAssistanceDataReq',
        'OMA-LPPe-ver1-1-BroadcastSystem',
        'OMA-LPPe-CommonIEsProvideAssistanceData',
        'OMA-LPPe-ProvidePeriodicADwithUpdate',
        'OMA-LPPe-TypeOfADProvide',
        'OMA-LPPe-SegmentedADTransfer',
        'OMA-LPPe-ver1-1-LocalCellInformation',
        'maxCellSets',
        'maxCells',
        'OMA-LPPe-ver1-1-CellInformation',
        'OMA-LPPe-ver1-1-BroadcastAssistanceData',
        'OMA-LPPe-ver1-1-EncapsulatedMode',
        'OMA-LPPe-CommonIEsRequestLocationInformation',
        'OMA-LPPe-IP-Address-Request',
        'OMA-LPPe-RequestPeriodicLocInfoWithUpdate',
        'OMA-LPPe-TypeOfLocInfoRequest',
        'OMA-LPPe-RelativeLocationChange-Request',
        'OMA-LPPe-LocalPositionRequest',
        'OMA-LPPe-ScheduledLocation-Request',
        'OMA-LPPe-AccessTypeRequest',
        'OMA-LPPe-SegmentedLIResume',
        'OMA-LPPe-CommonIEsProvideLocationInformation',
        'OMA-LPPe-LocalPosition',
        'OMA-LPPe-IP-Address-List',
        'maxIPAddress',
        'OMA-LPPe-IP-Address',
        'OMA-LPPe-Bearer',
        'OMA-LPPe-ProvidePeriodicLocInfowithUpdate',
        'OMA-LPPe-TypeOfLocInfoProvide',
        'OMA-LPPe-RelativeLocationChangeList',
        'OMA-LPPe-RelativeLocationChange',
        'maxRelativeLocation',
        'OMA-LPPe-ScheduledLocation',
        'OMA-LPPe-AccessTypes',
        'OMA-LPPe-SegmentedLITransfer',
        'OMA-LPPe-TimeStamp',
        'OMA-LPPe-LocationSource',
        'OMA-LPPe-CommonIEsAbort',
        'OMA-LPPe-CommonIEsError',
        'OMA-LPPe-AGNSS-ProvideAssistanceData',
        'OMA-LPPe-AGNSS-CommonAssistData',
        'OMA-LPPe-AGNSS-GenericAssistData',
        'OMA-LPPe-AGNSS-GenericAssistDataElement',
        'OMA-LPPe-AGNSS-IonosphericModel',
        'OMA-LPPe-AGNSS-LocalKlobucharModelList',
        'OMA-LPPe-AGNSS-LocalKlobucharModelElement',
        'OMA-LPPe-AGNSS-LocalKlobucharModel',
        'OMA-LPPe-AGNSS-IonoStormIndication',
        'OMA-LPPe-AGNSS-StormList',
        'OMA-LPPe-AGNSS-StormElement',
        'OMA-LPPe-AGNSS-RleListIono',
        'OMA-LPPe-AGNSS-RleIonoElement',
        'OMA-LPPe-AGNSS-NoaaScales',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersProvide',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfaceCommon',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVlist',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVelement',
        'OMA-LPPe-AGNSS-TroposphereModel',
        'OMA-LPPe-AGNSS-LocalTroposphereDelayList',
        'OMA-LPPe-AGNSS-LocalTroposphereDelayAreaElement',
        'OMA-LPPe-AGNSS-LocalTroposphereDelayTimeElement',
        'OMA-LPPe-AGNSS-LocalSurfaceParametersList',
        'OMA-LPPe-AGNSS-LocalSurfaceParametersAreaElement',
        'OMA-LPPe-AGNSS-LocalSurfaceParametersTimeElement',
        'OMA-LPPe-AGNSS-MappingFunctionParameters',
        'OMA-LPPe-AGNSS-AltitudeAssistanceList',
        'OMA-LPPe-AGNSS-AltitudeAssistanceAreaElement',
        'OMA-LPPe-AGNSS-PressureAssistanceElement',
        'OMA-LPPe-AGNSS-SolarRadiation',
        'OMA-LPPe-AGNSS-MechanicsForAllSVs',
        'OMA-LPPe-AGNSS-MechanicsElement',
        'OMA-LPPe-AGNSS-PCOelement',
        'OMA-LPPe-AGNSS-SVtype',
        'OMA-LPPe-AGNSS-DCBsForAllSVs',
        'OMA-LPPe-AGNSS-DCBlistElement',
        'OMA-LPPe-AGNSS-DCBlist',
        'OMA-LPPe-AGNSS-DCBelement',
        'OMA-LPPe-AGNSS-NavModelDegradationModelList',
        'OMA-LPPe-AGNSS-NavModelDegradationModelElement',
        'OMA-LPPe-AGNSS-ClockModelDegradationModel',
        'OMA-LPPe-AGNSS-OrbitModelDegradationModel',
        'OMA-LPPe-AGNSS-CCPassistCommonProvide',
        'OMA-LPPe-AGNSS-CCPprovideCommonParameters',
        'OMA-LPPe-AGNSS-CCPprovideControlParameters',
        'OMA-LPPe-AGNSS-CCPsupportArea',
        'OMA-LPPe-AGNSS-CCPsignalSupport',
        'OMA-LPPe-AGNSS-CCPreferenceStationList',
        'OMA-LPPe-AGNSS-CCPreferenceStationElement',
        'OMA-LPPe-AGNSS-CCPassistGenericProvide',
        'OMA-LPPe-AGNSS-CCPassistGenericProvideElement',
        'OMA-LPPe-AGNSS-CCPperSignalElement',
        'OMA-LPPe-AGNSS-CCPperSVelement',
        'OMA-LPPe-AGNSS-CodePhaseError',
        'OMA-LPPe-AGNSS-NavModelList',
        'OMA-LPPe-AGNSS-NavModel-CoordinateBased',
        'OMA-LPPe-AGNSS-NavModel-CoordinateBasedElement',
        'OMA-LPPe-AGNSS-NavModel-PVTelement',
        'OMA-LPPe-AGNSS-NavModel-BigNumber',
        'OMA-LPPe-AGNSS-NavModel-STDmatrix',
        'OMA-LPPe-AGNSS-RequestAssistanceData',
        'OMA-LPPe-AGNSS-CommonAssistanceDataReq',
        'OMA-LPPe-AGNSS-GenericAssistanceDataReq',
        'OMA-LPPe-AGNSS-GenericAssistDataReqElement',
        'OMA-LPPe-AGNSS-IonosphericModelReq',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersRequest',
        'OMA-LPPe-AGNSS-TroposphereModelReq',
        'OMA-LPPe-AGNSS-AltitudeAssistanceReq',
        'OMA-LPPe-AGNSS-SolarRadiationReq',
        'OMA-LPPe-AGNSS-WaIonoSurfaceRequest',
        'OMA-LPPe-AGNSS-NavModelDegradationModelReq',
        'OMA-LPPe-AGNSS-DCBreq',
        'OMA-LPPe-AGNSS-MechanicsReq',
        'OMA-LPPe-AGNSS-CCPrequestControlParameters',
        'OMA-LPPe-AGNSS-ReferenceStationIDlist',
        'OMA-LPPe-AGNSS-QoR',
        'OMA-LPPe-AGNSS-CCPassistGenericReq',
        'OMA-LPPe-AGNSS-NavigationModelReq',
        'OMA-LPPe-AGNSS-ProvideLocationInformation',
        'OMA-LPPe-AGNSS-HAgnssProvide',
        'OMA-LPPe-AGNSS-HAgnssMeasurementElement',
        'OMA-LPPe-HAgnssPerSignalElement',
        'OMA-LPPe-HAgnssPerSVelement',
        'OMA-LPPe-AGNSS-IonosphereMeasurements',
        'OMA-LPPe-AGNSS-TECPerSV',
        'OMA-LPPe-AGNSS-TECPerSVElement',
        'OMA-LPPe-AGNSS-TECAtZenith',
        'OMA-LPPe-AGNSS-LocalSurfaceMeasurements',
        'OMA-LPPe-AGNSS-RequestLocationInformation',
        'OMA-LPPe-AGNSS-PositioningInstructions',
        'OMA-LPPe-AGNSS-LocalSurfaceMeasurementReq',
        'OMA-LPPe-AGNSS-HAgnssRequestControlParameters',
        'OMA-LPPe-AGNSS-HAgnssSignalReqElement',
        'OMA-LPPe-AGNSS-ProvideCapabilities',
        'OMA-LPPe-AGNSS-AssistanceDataSupportList',
        'OMA-LPPe-AGNSS-EnvironmentObservationSupportList',
        'OMA-LPPe-AGNSS-CommonAssistanceDataSupport',
        'OMA-LPPe-AGNSS-IonosphericModelSupport',
        'OMA-LPPe-AGNSS-TroposphereModelSupport',
        'OMA-LPPe-AGNSS-AltitudeAssistanceSupport',
        'OMA-LPPe-AGNSS-SolarRadiationSupport',
        'OMA-LPPe-AGNSS-CCPsupport',
        'OMA-LPPe-AGNSS-GenericAssistanceDataSupport',
        'OMA-LPPe-AGNSS-GenericAssistDataSupportElement',
        'OMA-LPPe-AGNSS-MechanicsSupport',
        'OMA-LPPe-AGNSS-DCBsupport',
        'OMA-LPPe-AGNSS-NavModelAccuracyModelDegradationSupport',
        'OMA-LPPe-AGNSS-NavModelSupport',
        'OMA-LPPe-AGNSS-HAgnssSupport',
        'OMA-LPPe-AGNSS-HAgnssPerGNSSsupport',
        'OMA-LPPe-AGNSS-RequestCapabilities',
        'OMA-LPPe-AGNSS-Error',
        'OMA-LPPe-AGNSS-LocationServerErrorCauses',
        'OMA-LPPe-AGNSS-TargetDeviceErrorCauses',
        'OMA-LPPe-AGNSS-CCPreferenceStationID',
        'maxReferenceStations',
        'OMA-LPPe-AGNSS-AntennaDescription',
        'OMA-LPPe-AGNSS-Abort',
        'OMA-LPPe-OTDOA-ProvideAssistanceData',
        'OMA-LPPe-OTDOA-ReferenceCellInfo',
        'OMA-LPPe-OTDOA-PositionCalculationInfoRef',
        'OMA-LPPe-OTDOA-NeighbourCellInfoList',
        'maxFreqLayers',
        'OMA-LPPe-OTDOA-NeighbourFreqCellInfoList',
        'OMA-LPPe-OTDOA-NeighbourCellInfoElement-eNB',
        'OMA-LPPe-OTDOA-NeighbourCellInfoElement-HeNB',
        'OMA-LPPe-OTDOA-CellData',
        'OMA-LPPe-OTDOA-RTDquality',
        'OMA-LPPe-OTDOA-RequestAssistanceData',
        'OMA-LPPe-OTDOA-ProvideLocationInformation',
        'OMA-LPPe-OTDOA-LocationInformation',
        'OMA-LPPe-OTDOA-RequestLocationInformation',
        'OMA-LPPe-OTDOA-ProvideCapabilities',
        'OMA-LPPe-OTDOA-RequestCapabilities',
        'OMA-LPPe-OTDOA-Error',
        'OMA-LPPe-OTDOA-LocationServerErrorCauses',
        'OMA-LPPe-OTDOA-TargetDeviceErrorCauses',
        'OMA-LPPe-EOTD-ProvideAssistanceData',
        'OMA-LPPe-EOTD-ReferenceBTSForAssistance',
        'OMA-LPPe-EOTD-MsrAssistDataList',
        'OMA-LPPe-EOTD-MsrAssistBTS',
        'OMA-LPPe-EOTD-SystemInfoAssistDataList',
        'OMA-LPPe-EOTD-SystemInfoAssistBTS',
        'OMA-LPPe-EOTD-AssistBTSData',
        'OMA-LPPe-EOTD-CalcAssistanceBTS',
        'OMA-LPPe-EOTD-relativePos',
        'OMA-LPPe-EOTD-FineRTD',
        'OMA-LPPe-EOTD-RelDistance',
        'OMA-LPPe-EOTD-RelativeAlt',
        'OMA-LPPe-EOTD-RequestAssistanceData',
        'OMA-LPPe-EOTD-ProvideLocationInformation',
        'OMA-LPPe-EOTD-MsrElement',
        'OMA-LPPe-EOTD-TOA-MeasurementsOfRef',
        'OMA-LPPe-EOTD-MeasurementWithID',
        'OMA-LPPe-EOTD-NeighborIdentity',
        'OMA-LPPe-EOTD-EOTDQuality',
        'OMA-LPPe-EOTD-OTDValue',
        'OMA-LPPe-EOTD-CellID',
        'OMA-LPPe-EOTD-RequestIndex',
        'OMA-LPPe-EOTD-SystemInfoIndex',
        'OMA-LPPe-EOTD-MultiFrameCarrier',
        'OMA-LPPe-EOTD-BCCHCarrier',
        'OMA-LPPe-EOTD-RequestLocationInformation',
        'OMA-LPPe-EOTD-ProvideCapabilities',
        'OMA-LPPe-EOTD-RequestCapabilities',
        'OMA-LPPe-EOTD-Error',
        'OMA-LPPe-EOTD-LocationServerErrorCauses',
        'OMA-LPPe-EOTD-TargetDeviceErrorCauses',
        'OMA-LPPe-EOTD-TimeSlotScheme',
        'OMA-LPPe-EOTD-MultiFrameOffset',
        'OMA-LPPe-EOTD-RoughRTD',
        'OMA-LPPe-EOTD-ExpectedOTD',
        'OMA-LPPe-EOTD-ModuloTimeSlot',
        'OMA-LPPe-OTDOA-UTRA-ProvideAssistanceData',
        'OMA-LPPe-OTDOA-UTRA-ReferenceCellInfo',
        'OMA-LPPe-OTDOA-UTRA-RefPosAssist',
        'OMA-LPPe-OTDOA-UTRA-NeighborCellList',
        'OMA-LPPe-OTDOA-UTRA-NeighborCellInfo',
        'OMA-LPPe-OTDOA-UTRA-SFN-SFN-RelTimeDifference1',
        'OMA-LPPe-OTDOA-UTRA-PositioningAssistance',
        'utra-maxCellMeas',
        'OMA-LPPe-OTDOA-UTRA-SFN-OffsetValidity',
        'OMA-LPPe-OTDOA-UTRA-SFN-SFN-Drift',
        'OMA-LPPe-OTDOA-UTRA-SearchWindowSize',
        'OMA-LPPe-OTDOA-UTRA-fineSFN-SFN',
        'OMA-LPPe-OTDOA-UTRA-IPDL-Parameters',
        'OMA-LPPe-OTDOA-UTRA-IP-Spacing',
        'OMA-LPPe-OTDOA-UTRA-IP-Length',
        'OMA-LPPe-OTDOA-UTRA-IP-Spacing-TDD',
        'OMA-LPPe-OTDOA-UTRA-IP-PCCPCH',
        'OMA-LPPe-OTDOA-UTRA-BurstModeParameters',
        'OMA-LPPe-OTDOA-UTRA-RequestAssistanceData',
        'OMA-LPPe-OTDOA-UTRA-ProvideLocationInformation',
        'OMA-LPPe-OTDOA-UTRA-Measurement',
        'OMA-LPPe-OTDOA-UTRA-UE-RX-TX-TimeDifferenceType2Info',
        'OMA-LPPe-OTDOA-UTRA-TimeDifferenceType2',
        'OMA-LPPe-OTDOA-UTRA-NeighborList',
        'OMA-LPPe-OTDOA-UTRA-Neighbor',
        'OMA-LPPe-OTDOA-UTRA-NeighborQuality',
        'OMA-LPPe-OTDOA-UTRA-SFN-SFN-ObsTimeDifference2',
        'OMA-LPPe-OTDOA-UTRA-Quality',
        'OMA-LPPe-OTDOA-UTRA-TimeStampData',
        'OMA-LPPe-OTDOA-UTRA-RequestLocationInformation',
        'OMA-LPPe-OTDOA-UTRA-ProvideCapabilities',
        'OMA-LPPe-OTDOA-UTRA-RequestCapabilities',
        'OMA-LPPe-OTDOA-UTRA-Error',
        'OMA-LPPe-OTDOA-UTRA-LocationServerErrorCauses',
        'OMA-LPPe-OTDOA-UTRA-TargetDeviceErrorCauses',
        'OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info',
        'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode',
        'OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity',
        'OMA-LPPe-OTDOA-UTRA-BurstType',
        'OMA-LPPe-OTDOA-UTRA-MidambleShiftLong',
        'OMA-LPPe-OTDOA-UTRA-TimeSlotNumber',
        'OMA-LPPe-OTDOA-UTRA-CellParametersID',
        'OMA-LPPe-ECID-LTE-ProvideAssistanceData',
        'maxLTENetworks',
        'OMA-LPPe-ECID-LTE-NetworkData',
        'maxLTEeNBs',
        'maxLTEHeNBs',
        'OMA-LPPe-ECID-LTE-eNodeBData',
        'maxLTEMacroCells',
        'OMA-LPPe-ECID-LTE-HeNBData',
        'OMA-LPPe-ECID-LTE-CellData',
        'OMA-LPPe-ECID-LTE-RequestAssistanceData',
        'OMA-LPPe-ECID-LTE-ProvideLocationInformation',
        'OMA-LPPe-ECID-LTE-LocationInformationList',
        'maxLTEECIDSize',
        'OMA-LPPe-ECID-LTE-LocationInformation',
        'OMA-LPPe-ECID-LTE-RequestLocationInformation',
        'OMA-LPPe-ECID-LTE-ProvideCapabilities',
        'OMA-LPPe-ECID-LTE-RequestCapabilities',
        'OMA-LPPe-ECID-LTE-Error',
        'OMA-LPPe-ECID-LTE-LocationServerErrorCauses',
        'OMA-LPPe-ECID-LTE-TargetDeviceErrorCauses',
        'OMA-LPPe-ECID-GSM-ProvideAssistanceData',
        'maxGSMNetworks',
        'OMA-LPPe-ECID-GSM-NetworkData',
        'maxGSMBaseStations',
        'OMA-LPPe-ECID-GSM-BaseStationData',
        'maxGSMCells',
        'OMA-LPPe-ECID-GSM-CellData',
        'OMA-LPPe-ECID-GSM-RequestAssistanceData',
        'OMA-LPPe-ECID-GSM-ProvideLocationInformation',
        'OMA-LPPe-ECID-GSM-LocationInformationList',
        'maxGSMECIDSize',
        'OMA-LPPe-ECID-GSM-LocationInformation',
        'OMA-LPPe-NMR-GERAN',
        'OMA-LPPe-ECID-GSM-RequestLocationInformation',
        'OMA-LPPe-ECID-GSM-ProvideCapabilities',
        'OMA-LPPe-ECID-GSM-RequestCapabilities',
        'OMA-LPPe-ECID-GSM-Error',
        'OMA-LPPe-ECID-GSM-LocationServerErrorCauses',
        'OMA-LPPe-ECID-GSM-TargetDeviceErrorCauses',
        'OMA-LPPe-ECID-UTRA-ProvideAssistanceData',
        'maxUTRANetworks',
        'OMA-LPPe-ECID-UTRA-NetworkData',
        'maxUTRAnodeBs',
        'maxUTRAHNBs',
        'OMA-LPPe-ECID-UTRA-NodeBData',
        'maxUTRAMacroCells',
        'OMA-LPPe-ECID-UTRA-HNBData',
        'OMA-LPPe-ECID-UTRA-CellData',
        'OMA-LPPe-ECID-UTRA-RequestAssistanceData',
        'OMA-LPPe-ECID-UTRA-ProvideLocationInformation',
        'OMA-LPPe-ECID-UTRA-LocationInformationList',
        'maxECIDUTRASize',
        'OMA-LPPe-ECID-UTRA-LocationInformation',
        'OMA-LPPe-ECID-UTRA-UTRATimingAdvance',
        'OMA-LPPe-ECID-UTRA-TAResolution',
        'OMA-LPPe-ECID-UTRA-ChipRate',
        'OMA-LPPe-UTRA-FrequencyInfo',
        'OMA-LPPe-UTRA-ModeSpecificInfo',
        'OMA-LPPe-UTRA-FrequencyInfoFDD',
        'OMA-LPPe-UTRA-FrequencyInfoTDD',
        'OMA-LPPe-ECID-UTRA-MeasuredResultsList',
        'OMA-LPPe-ECID-UTRA-MeasuredResults',
        'OMA-LPPe-ECID-UTRA-CellMeasuredResultsList',
        'OMA-LPPe-ECID-UTRA-CarrierRSSI',
        'OMA-LPPe-ECID-UTRA-CellMeasuredResults',
        'OMA-LPPe-ECID-UTRA-PrimaryCCPCH-RSCP',
        'OMA-LPPe-ECID-UTRA-CPICH-Ec-N0',
        'OMA-LPPe-ECID-UTRA-CPICH-RSCP',
        'OMA-LPPe-ECID-UTRA-Pathloss',
        'maxFreq',
        'OMA-LPPe-ECID-UTRA-RequestLocationInformation',
        'OMA-LPPe-ECID-UTRA-ProvideCapabilities',
        'OMA-LPPe-ECID-UTRA-RequestCapabilities',
        'OMA-LPPe-ECID-UTRA-Error',
        'OMA-LPPe-ECID-UTRA-LocationServerErrorCauses',
        'OMA-LPPe-ECID-UTRA-TargetDeviceErrorCauses',
        'OMA-LPPe-WLAN-AP-ProvideAssistanceData',
        'maxWLANDataSets',
        'OMA-LPPe-WLAN-DataSet',
        'maxWLANAPs',
        'Supported-Channels-11a',
        'Supported-Channels-11bg',
        'OMA-LPPe-WLAN-AP-Data',
        'maxWLANTypes',
        'OMA-LPPe-WLAN-AP-Type-Data',
        'OMA-LPPe-WLAN-AP-RequestAssistanceData',
        'OMA-LPPe-WLAN-AP-ProvideLocationInformation',
        'OMA-LPPe-WLAN-AP-LocationInformationList',
        'maxWLANAPSize',
        'OMA-LPPe-WLAN-AP-LocationInformation',
        'OMA-LPPe-WLAN-AP-PHY-Type',
        'OMA-LPPe-WLAN-RTD',
        'OMA-LPPe-WLAN-RTDUnits',
        'OMA-LPPe-WLAN-ReportedLocation',
        'OMA-LPPe-WLAN-LocationDataLCI',
        'OMA-LPPe-WLAN-AP-RequestLocationInformation',
        'OMA-LPPe-WLAN-AP-ProvideCapabilities',
        'OMA-LPPe-WLAN-AP-Capability',
        'OMA-LPPe-WLAN-AP-RequestCapabilities',
        'OMA-LPPe-WLAN-AP-Error',
        'OMA-LPPe-WLAN-AP-LocationServerErrorCauses',
        'OMA-LPPe-WLAN-AP-TargetDeviceErrorCauses',
        'OMA-LPPe-ECID-WiMax-ProvideLocationInformation',
        'OMA-LPPe-ECID-WiMax-LocationInformationList',
        'maxWiMaxECIDSize',
        'OMA-LPPe-ECID-WiMax-LocationInformation',
        'OMA-LPPe-ECID-WiMax-WimaxBsID',
        'OMA-LPPe-ECID-WiMax-WimaxRTD',
        'OMA-LPPe-ECID-WiMax-WimaxNMRList',
        'OMA-LPPe-ECID-WiMax-WimaxNMR',
        'maxWimaxBSMeas',
        'OMA-LPPe-ECID-WiMax-RequestLocationInformation',
        'OMA-LPPe-ECID-WiMax-ProvideCapabilities',
        'OMA-LPPe-ECID-WiMax-RequestCapabilities',
        'OMA-LPPe-ECID-WiMax-Error',
        'OMA-LPPe-ECID-WiMax-LocationServerErrorCauses',
        'OMA-LPPe-ECID-WiMax-TargetDeviceErrorCauses',
        'OMA-LPPe-Sensor-ProvideAssistanceData',
        'OMA-LPPe-AtmosphericPressureAD',
        'OMA-LPPe-PressureValidityArea',
        'OMA-LPPe-Sensor-RequestAssistanceData',
        'OMA-LPPe-PressureSensorAD',
        'OMA-LPPe-Sensor-ProvideLocationInformation',
        'OMA-LPPe-Sensor-MotionStateList',
        'OMA-LPPe-Sensor-MotionStateElement',
        'OMA-LPPe-Sensor-RequestLocationInformation',
        'OMA-LPPe-Sensor-MotionStateRequest',
        'OMA-LPPe-Sensor-ProvideCapabilities',
        'OMA-LPPe-Sensor-RequestCapabilities',
        'OMA-LPPe-Sensor-Error',
        'OMA-LPPe-Sensor-TargetError',
        'OMA-LPPe-SRN-ProvideAssistanceData',
        'OMA-LPPe-SRN-SRNgroupList',
        'OMA-LPPe-SRN-SRNgroup',
        'OMA-LPPe-SRN-SRNinfo',
        'OMA-LPPe-SRN-SRNgroupUpdateResponse',
        'OMA-LPPe-SRN-SRNgroupUpdateResponseElement',
        'OMA-LPPe-SRN-AntennaPattern',
        'OMA-LPPe-SRN-AntennaPatternElement',
        'OMA-LPPe-SRN-AntennaPatternForChannels',
        'OMA-LPPe-SRN-ChannelResponse',
        'OMA-LPPe-SRN-ResponseInElevation',
        'OMA-LPPe-SRN-ResponseInAzimuth',
        'OMA-LPPe-ComplexNumber',
        'maxChannels',
        'OMA-LPPe-SRN-RequestAssistanceData',
        'OMA-LPPe-SRN-SRNgroupRequest',
        'OMA-LPPe-SRN-SRNProvideList',
        'OMA-LPPe-SRN-SRNgroupUpdateRequest',
        'OMA-LPPe-SRN-SRNgroupUpdateRequestElement',
        'OMA-LPPe-SRN-AntennaPatternRequest',
        'OMA-LPPe-SRN-AntennaPatternRequestElement',
        'OMA-LPPe-SRN-ProvideLocationInformation',
        'OMA-LPPe-SRN-MeasurementElement',
        'OMA-LPPe-SRN-srnMeasurementElement',
        'OMA-LPPe-SRN-RequestLocationInformation',
        'OMA-LPPe-SRN-ReqLocInfo-Category',
        'OMA-LPPe-SRN-ProvideCapabilities',
        'OMA-LPPe-SRN-ProvideCapabilitiesElement',
        'OMA-LPPe-SRN-RequestCapabilities',
        'OMA-LPPe-SRN-Error',
        'OMA-LPPe-SRN-LocationServerErrorCauses',
        'OMA-LPPe-SRN-TargetDeviceErrorCauses',
        'OMA-LPPe-SRN-TargetDeviceError',
        'OMA-LPPe-SRN-SRNgroupUniqueID',
        'OMA-LPPe-SRN-SRNtype',
        'OMA-LPPe-SRN-Category',
        'OMA-LPPe-SRN-SRNid',
        'OMA-LPPe-SRN-Technologies',
        'OMA-LPPe-SRN-MeasurementMask',
        ]
    _type_ = [
        'OMA-LPPe-MessageExtension',
        'OMA-LPPe-LPPeCompatibilityLevel',
        'OMA-LPPe-LPPeVersion',
        'OMA-LPPe-LPPeMode',
        'OMA-LPPe-MessageExtensionBody',
        'OMA-LPPe-ver1-1-BroadcastContainer',
        'OMA-LPPe-ver1-1-BroadcastMessage',
        'OMA-LPPe-ver1-1-BroadcastControlIEs',
        'OMA-LPPe-ver1-1-CipheringIEs',
        'OMA-LPPe-ver1-1-DigitalSignature',
        'OMA-LPPe-RequestCapabilities',
        'OMA-LPPe-ProvideCapabilities',
        'OMA-LPPe-RequestAssistanceData',
        'OMA-LPPe-ProvideAssistanceData',
        'OMA-LPPe-RequestLocationInformation',
        'OMA-LPPe-ProvideLocationInformation',
        'OMA-LPPe-Abort',
        'OMA-LPPe-Error',
        'OMA-LPPe-AssistanceContainer-DataSerialNumber',
        'OMA-LPPe-AssistanceContainerID',
        'OMA-LPPe-AssistanceContainerProvideList',
        'OMA-LPPe-AssistanceContainerProvide',
        'OMA-LPPe-AssistanceContainerData',
        'OMA-LPPe-AssistanceContainerProvideError',
        'OMA-LPPe-AssistanceContainerRequestList',
        'OMA-LPPe-AssistanceContainerRequest',
        'OMA-LPPe-AssistanceContainerCheckOrUpdateReq',
        'OMA-LPPe-CellLocalIdGERAN',
        'OMA-LPPe-CellNonUniqueIDGERAN',
        'OMA-LPPe-CharArray',
        'OMA-LPPe-CivicLocation',
        'OMA-LPPe-CivicAddressElementList',
        'OMA-LPPe-CivicAddressElement',
        'OMA-LPPe-Duration',
        'OMA-LPPe-FixedAccessTypes',
        'OMA-LPPe-ver1-1-GroundMorphologyModel',
        'OMA-LPPe-ver1-1-AltitudeModel',
        'OMA-LPPe-ver1-1-BuildingsHeightModel',
        'DeltaAltitudes',
        'DeltaHeight',
        'OMA-LPPe-ver1-1-CellGlobalID',
        'OMA-LPPe-HighAccuracy3Dposition',
        'OMA-LPPe-HighAccuracy3Dvelocity',
        'OMA-LPPe-LocationInformationContainerID',
        'OMA-LPPe-LocationInformationContainer',
        'OMA-LPPe-LocationInformationContainerDataList',
        'OMA-LPPe-LocationInformationContainerData',
        'OMA-LPPe-LocationInformationContainerRequest',
        'OMA-LPPe-LocationInformationContainerRequestList',
        'OMA-LPPe-LocationInformationContainerRequestItem',
        'OMA-LPPe-MapDataReference',
        'OMA-LPPe-Orientation',
        'OMA-LPPe-ReferencePoint',
        'OMA-LPPe-MapDataInformation',
        'OMA-LPPe-MapDataReferenceElement',
        'OMA-LPPe-ReferencePointRelationship',
        'OMA-LPPe-ReferencePointUniqueID',
        'OMA-LPPe-RelativeLocation',
        'OMA-LPPe-HorizontalUncertaintyAndConfidence',
        'OMA-LPPe-RelativeAltitude',
        'OMA-LPPe-GeodeticRelativeAltitude',
        'OMA-LPPe-GeodeticUncertaintyAndConfidence',
        'OMA-LPPe-CivicRelativeAltitude',
        'OMA-LPPe-CivicUncertaintyAndConfidence',
        'OMA-LPPe-Session-ID',
        'OMA-LPPe-Uri',
        'OMA-LPPe-ver1-1-BroadcastSystemID',
        'OMA-LPPe-ver1-1-BroadcastADTypes',
        'OMA-LPPe-ver1-1-LabelSet',
        'OMA-LPPe-ver1-1-AccessNetworkID',
        'OMA-LPPe-ver1-1-MCC-MNC',
        'OMA-LPPe-ver1-1-BSID',
        'OMA-LPPe-ver1-1-AuthenticationSetID',
        'OMA-LPPe-ver1-1-AuthenticationSet',
        'OMA-LPPe-ver1-1-CipherSetID',
        'OMA-LPPe-ver1-1-CipherSet',
        'OMA-LPPe-ver1-1-ServerID',
        'OMA-LPPe-ValidityArea',
        'OMA-LPPe-RleList',
        'OMA-LPPe-ValidityPeriod',
        'OMA-LPPe-VendorOrOperatorAssistanceDataIdentifier',
        'OMA-LPPe-VendorOrOperatorID',
        'OMA-LPPe-NonStandard-VendorOrOperatorID',
        'OMA-LPPe-WirelessAccessTypes',
        'OMA-LPPe-WLAN-AP-ID',
        'OMA-LPPe-WLAN-AP-Type',
        'OMA-LPPe-WLAN-AP-Type-List',
        'OMA-LPPe-WLANFemtoCoverageArea',
        'OMA-LPPe-WLANFemtoCoverageAreaElement',
        'OMA-LPPe-CommonIEsRequestCapabilities',
        'OMA-LPPe-IP-Address-RequestCapabilities',
        'OMA-LPPe-AssistanceContainerSupportReq',
        'OMA-LPPe-LocationInformationContainerSupportReq',
        'OMA-LPPe-VendorOrOperatorIDList',
        'OMA-LPPe-RelativeLocationChange-RequestCapabilities',
        'OMA-LPPe-HighAccuracyFormatCapabilitiesReq',
        'OMA-LPPe-SegmentedAssistanceData-ReqCapabilities',
        'OMA-LPPe-ReferencePointCapabilitiesReq',
        'OMA-LPPe-ScheduledLocation-RequestCapabilities',
        'OMA-LPPe-AccessCapabilitiesReq',
        'OMA-LPPe-SegmentedLocationInformation-ReqCapabilities',
        'OMA-LPPe-ver1-1-localCellInformation-ReqCapabilities',
        'OMA-LPPe-ver1-1-broadcast-ReqCapabilities',
        'OMA-LPPe-CommonIEsProvideCapabilities',
        'OMA-LPPe-IP-Address-Capabilities',
        'OMA-LPPe-AssistanceContainerSupport',
        'OMA-LPPe-VendorOrOperatorAssistanceContainerList',
        'OMA-LPPe-AssistanceContainerList',
        'OMA-LPPe-LocationInformationContainerSupport',
        'OMA-LPPe-VendorOrOperatorLocationInformationContainerList',
        'OMA-LPPe-LocationInformationContainerList',
        'OMA-LPPe-RelativeLocationChange-Capabilities',
        'OMA-LPPe-HighAccuracyFormatCapabilities',
        'OMA-LPPe-SegmentedAssistanceData-ProvideCapabs',
        'OMA-LPPe-ReferencePointCapabilities',
        'OMA-LPPe-ReferencePointProviderSupportElement',
        'OMA-LPPe-ScheduledLocation-Capabilities',
        'OMA-LPPe-AccessCapabilities',
        'OMA-LPPe-SegmentedLocationInformation-ProvideCapabs',
        'OMA-LPPe-ver1-1-localCellInformation-ProvideCapabilities',
        'OMA-LPPe-ver1-1-broadcast-ProvideCapabilities',
        'OMA-LPPe-ver1-1-BroadcastSystem-Capabs',
        'OMA-LPPe-ver1-1-point2pointAD',
        'OMA-LPPe-ver1-1-Ciphering',
        'OMA-LPPe-ver1-1-Authentication',
        'OMA-LPPe-CommonIEsRequestAssistanceData',
        'OMA-LPPe-RequestPeriodicADwithUpdate',
        'TypeOfADRequest',
        'OMA-LPPe-SegmentedADResume',
        'OMA-LPPe-ReferencePointAssistanceReq',
        'OMA-LPPe-ReferencePointAssistanceReqElement',
        'OMA-LPPe-ver1-1-GroundMorphologyModelReq',
        'OMA-LPPe-ver1-1-LocalCellInformationReq',
        'OMA-LPPe-ver1-1-BroadcastAssistanceDataReq',
        'OMA-LPPe-ver1-1-BroadcastSystem',
        'OMA-LPPe-CommonIEsProvideAssistanceData',
        'OMA-LPPe-ProvidePeriodicADwithUpdate',
        'OMA-LPPe-TypeOfADProvide',
        'OMA-LPPe-SegmentedADTransfer',
        'OMA-LPPe-ver1-1-LocalCellInformation',
        'OMA-LPPe-ver1-1-CellInformation',
        'OMA-LPPe-ver1-1-BroadcastAssistanceData',
        'OMA-LPPe-ver1-1-EncapsulatedMode',
        'OMA-LPPe-CommonIEsRequestLocationInformation',
        'OMA-LPPe-IP-Address-Request',
        'OMA-LPPe-RequestPeriodicLocInfoWithUpdate',
        'OMA-LPPe-TypeOfLocInfoRequest',
        'OMA-LPPe-RelativeLocationChange-Request',
        'OMA-LPPe-LocalPositionRequest',
        'OMA-LPPe-ScheduledLocation-Request',
        'OMA-LPPe-AccessTypeRequest',
        'OMA-LPPe-SegmentedLIResume',
        'OMA-LPPe-CommonIEsProvideLocationInformation',
        'OMA-LPPe-LocalPosition',
        'OMA-LPPe-IP-Address-List',
        'OMA-LPPe-IP-Address',
        'OMA-LPPe-Bearer',
        'OMA-LPPe-ProvidePeriodicLocInfowithUpdate',
        'OMA-LPPe-TypeOfLocInfoProvide',
        'OMA-LPPe-RelativeLocationChangeList',
        'OMA-LPPe-RelativeLocationChange',
        'OMA-LPPe-ScheduledLocation',
        'OMA-LPPe-AccessTypes',
        'OMA-LPPe-SegmentedLITransfer',
        'OMA-LPPe-TimeStamp',
        'OMA-LPPe-LocationSource',
        'OMA-LPPe-CommonIEsAbort',
        'OMA-LPPe-CommonIEsError',
        'OMA-LPPe-AGNSS-ProvideAssistanceData',
        'OMA-LPPe-AGNSS-CommonAssistData',
        'OMA-LPPe-AGNSS-GenericAssistData',
        'OMA-LPPe-AGNSS-GenericAssistDataElement',
        'OMA-LPPe-AGNSS-IonosphericModel',
        'OMA-LPPe-AGNSS-LocalKlobucharModelList',
        'OMA-LPPe-AGNSS-LocalKlobucharModelElement',
        'OMA-LPPe-AGNSS-LocalKlobucharModel',
        'OMA-LPPe-AGNSS-IonoStormIndication',
        'OMA-LPPe-AGNSS-StormList',
        'OMA-LPPe-AGNSS-StormElement',
        'OMA-LPPe-AGNSS-RleListIono',
        'OMA-LPPe-AGNSS-RleIonoElement',
        'OMA-LPPe-AGNSS-NoaaScales',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersProvide',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfaceCommon',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVlist',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVelement',
        'OMA-LPPe-AGNSS-TroposphereModel',
        'OMA-LPPe-AGNSS-LocalTroposphereDelayList',
        'OMA-LPPe-AGNSS-LocalTroposphereDelayAreaElement',
        'OMA-LPPe-AGNSS-LocalTroposphereDelayTimeElement',
        'OMA-LPPe-AGNSS-LocalSurfaceParametersList',
        'OMA-LPPe-AGNSS-LocalSurfaceParametersAreaElement',
        'OMA-LPPe-AGNSS-LocalSurfaceParametersTimeElement',
        'OMA-LPPe-AGNSS-MappingFunctionParameters',
        'OMA-LPPe-AGNSS-AltitudeAssistanceList',
        'OMA-LPPe-AGNSS-AltitudeAssistanceAreaElement',
        'OMA-LPPe-AGNSS-PressureAssistanceElement',
        'OMA-LPPe-AGNSS-SolarRadiation',
        'OMA-LPPe-AGNSS-MechanicsForAllSVs',
        'OMA-LPPe-AGNSS-MechanicsElement',
        'OMA-LPPe-AGNSS-PCOelement',
        'OMA-LPPe-AGNSS-SVtype',
        'OMA-LPPe-AGNSS-DCBsForAllSVs',
        'OMA-LPPe-AGNSS-DCBlistElement',
        'OMA-LPPe-AGNSS-DCBlist',
        'OMA-LPPe-AGNSS-DCBelement',
        'OMA-LPPe-AGNSS-NavModelDegradationModelList',
        'OMA-LPPe-AGNSS-NavModelDegradationModelElement',
        'OMA-LPPe-AGNSS-ClockModelDegradationModel',
        'OMA-LPPe-AGNSS-OrbitModelDegradationModel',
        'OMA-LPPe-AGNSS-CCPassistCommonProvide',
        'OMA-LPPe-AGNSS-CCPprovideCommonParameters',
        'OMA-LPPe-AGNSS-CCPprovideControlParameters',
        'OMA-LPPe-AGNSS-CCPsupportArea',
        'OMA-LPPe-AGNSS-CCPsignalSupport',
        'OMA-LPPe-AGNSS-CCPreferenceStationList',
        'OMA-LPPe-AGNSS-CCPreferenceStationElement',
        'OMA-LPPe-AGNSS-CCPassistGenericProvide',
        'OMA-LPPe-AGNSS-CCPassistGenericProvideElement',
        'OMA-LPPe-AGNSS-CCPperSignalElement',
        'OMA-LPPe-AGNSS-CCPperSVelement',
        'OMA-LPPe-AGNSS-CodePhaseError',
        'OMA-LPPe-AGNSS-NavModelList',
        'OMA-LPPe-AGNSS-NavModel-CoordinateBased',
        'OMA-LPPe-AGNSS-NavModel-CoordinateBasedElement',
        'OMA-LPPe-AGNSS-NavModel-PVTelement',
        'OMA-LPPe-AGNSS-NavModel-BigNumber',
        'OMA-LPPe-AGNSS-NavModel-STDmatrix',
        'OMA-LPPe-AGNSS-RequestAssistanceData',
        'OMA-LPPe-AGNSS-CommonAssistanceDataReq',
        'OMA-LPPe-AGNSS-GenericAssistanceDataReq',
        'OMA-LPPe-AGNSS-GenericAssistDataReqElement',
        'OMA-LPPe-AGNSS-IonosphericModelReq',
        'OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersRequest',
        'OMA-LPPe-AGNSS-TroposphereModelReq',
        'OMA-LPPe-AGNSS-AltitudeAssistanceReq',
        'OMA-LPPe-AGNSS-SolarRadiationReq',
        'OMA-LPPe-AGNSS-WaIonoSurfaceRequest',
        'OMA-LPPe-AGNSS-NavModelDegradationModelReq',
        'OMA-LPPe-AGNSS-DCBreq',
        'OMA-LPPe-AGNSS-MechanicsReq',
        'OMA-LPPe-AGNSS-CCPrequestControlParameters',
        'OMA-LPPe-AGNSS-ReferenceStationIDlist',
        'OMA-LPPe-AGNSS-QoR',
        'OMA-LPPe-AGNSS-CCPassistGenericReq',
        'OMA-LPPe-AGNSS-NavigationModelReq',
        'OMA-LPPe-AGNSS-ProvideLocationInformation',
        'OMA-LPPe-AGNSS-HAgnssProvide',
        'OMA-LPPe-AGNSS-HAgnssMeasurementElement',
        'OMA-LPPe-HAgnssPerSignalElement',
        'OMA-LPPe-HAgnssPerSVelement',
        'OMA-LPPe-AGNSS-IonosphereMeasurements',
        'OMA-LPPe-AGNSS-TECPerSV',
        'OMA-LPPe-AGNSS-TECPerSVElement',
        'OMA-LPPe-AGNSS-TECAtZenith',
        'OMA-LPPe-AGNSS-LocalSurfaceMeasurements',
        'OMA-LPPe-AGNSS-RequestLocationInformation',
        'OMA-LPPe-AGNSS-PositioningInstructions',
        'OMA-LPPe-AGNSS-LocalSurfaceMeasurementReq',
        'OMA-LPPe-AGNSS-HAgnssRequestControlParameters',
        'OMA-LPPe-AGNSS-HAgnssSignalReqElement',
        'OMA-LPPe-AGNSS-ProvideCapabilities',
        'OMA-LPPe-AGNSS-AssistanceDataSupportList',
        'OMA-LPPe-AGNSS-EnvironmentObservationSupportList',
        'OMA-LPPe-AGNSS-CommonAssistanceDataSupport',
        'OMA-LPPe-AGNSS-IonosphericModelSupport',
        'OMA-LPPe-AGNSS-TroposphereModelSupport',
        'OMA-LPPe-AGNSS-AltitudeAssistanceSupport',
        'OMA-LPPe-AGNSS-SolarRadiationSupport',
        'OMA-LPPe-AGNSS-CCPsupport',
        'OMA-LPPe-AGNSS-GenericAssistanceDataSupport',
        'OMA-LPPe-AGNSS-GenericAssistDataSupportElement',
        'OMA-LPPe-AGNSS-MechanicsSupport',
        'OMA-LPPe-AGNSS-DCBsupport',
        'OMA-LPPe-AGNSS-NavModelAccuracyModelDegradationSupport',
        'OMA-LPPe-AGNSS-NavModelSupport',
        'OMA-LPPe-AGNSS-HAgnssSupport',
        'OMA-LPPe-AGNSS-HAgnssPerGNSSsupport',
        'OMA-LPPe-AGNSS-RequestCapabilities',
        'OMA-LPPe-AGNSS-Error',
        'OMA-LPPe-AGNSS-LocationServerErrorCauses',
        'OMA-LPPe-AGNSS-TargetDeviceErrorCauses',
        'OMA-LPPe-AGNSS-CCPreferenceStationID',
        'OMA-LPPe-AGNSS-AntennaDescription',
        'OMA-LPPe-AGNSS-Abort',
        'OMA-LPPe-OTDOA-ProvideAssistanceData',
        'OMA-LPPe-OTDOA-ReferenceCellInfo',
        'OMA-LPPe-OTDOA-PositionCalculationInfoRef',
        'OMA-LPPe-OTDOA-NeighbourCellInfoList',
        'OMA-LPPe-OTDOA-NeighbourFreqCellInfoList',
        'OMA-LPPe-OTDOA-NeighbourCellInfoElement-eNB',
        'OMA-LPPe-OTDOA-NeighbourCellInfoElement-HeNB',
        'OMA-LPPe-OTDOA-CellData',
        'OMA-LPPe-OTDOA-RTDquality',
        'OMA-LPPe-OTDOA-RequestAssistanceData',
        'OMA-LPPe-OTDOA-ProvideLocationInformation',
        'OMA-LPPe-OTDOA-LocationInformation',
        'OMA-LPPe-OTDOA-RequestLocationInformation',
        'OMA-LPPe-OTDOA-ProvideCapabilities',
        'OMA-LPPe-OTDOA-RequestCapabilities',
        'OMA-LPPe-OTDOA-Error',
        'OMA-LPPe-OTDOA-LocationServerErrorCauses',
        'OMA-LPPe-OTDOA-TargetDeviceErrorCauses',
        'OMA-LPPe-EOTD-ProvideAssistanceData',
        'OMA-LPPe-EOTD-ReferenceBTSForAssistance',
        'OMA-LPPe-EOTD-MsrAssistDataList',
        'OMA-LPPe-EOTD-MsrAssistBTS',
        'OMA-LPPe-EOTD-SystemInfoAssistDataList',
        'OMA-LPPe-EOTD-SystemInfoAssistBTS',
        'OMA-LPPe-EOTD-AssistBTSData',
        'OMA-LPPe-EOTD-CalcAssistanceBTS',
        'OMA-LPPe-EOTD-relativePos',
        'OMA-LPPe-EOTD-FineRTD',
        'OMA-LPPe-EOTD-RelDistance',
        'OMA-LPPe-EOTD-RelativeAlt',
        'OMA-LPPe-EOTD-RequestAssistanceData',
        'OMA-LPPe-EOTD-ProvideLocationInformation',
        'OMA-LPPe-EOTD-MsrElement',
        'OMA-LPPe-EOTD-TOA-MeasurementsOfRef',
        'OMA-LPPe-EOTD-MeasurementWithID',
        'OMA-LPPe-EOTD-NeighborIdentity',
        'OMA-LPPe-EOTD-EOTDQuality',
        'OMA-LPPe-EOTD-OTDValue',
        'OMA-LPPe-EOTD-CellID',
        'OMA-LPPe-EOTD-RequestIndex',
        'OMA-LPPe-EOTD-SystemInfoIndex',
        'OMA-LPPe-EOTD-MultiFrameCarrier',
        'OMA-LPPe-EOTD-BCCHCarrier',
        'OMA-LPPe-EOTD-RequestLocationInformation',
        'OMA-LPPe-EOTD-ProvideCapabilities',
        'OMA-LPPe-EOTD-RequestCapabilities',
        'OMA-LPPe-EOTD-Error',
        'OMA-LPPe-EOTD-LocationServerErrorCauses',
        'OMA-LPPe-EOTD-TargetDeviceErrorCauses',
        'OMA-LPPe-EOTD-TimeSlotScheme',
        'OMA-LPPe-EOTD-MultiFrameOffset',
        'OMA-LPPe-EOTD-RoughRTD',
        'OMA-LPPe-EOTD-ExpectedOTD',
        'OMA-LPPe-EOTD-ModuloTimeSlot',
        'OMA-LPPe-OTDOA-UTRA-ProvideAssistanceData',
        'OMA-LPPe-OTDOA-UTRA-ReferenceCellInfo',
        'OMA-LPPe-OTDOA-UTRA-RefPosAssist',
        'OMA-LPPe-OTDOA-UTRA-NeighborCellList',
        'OMA-LPPe-OTDOA-UTRA-NeighborCellInfo',
        'OMA-LPPe-OTDOA-UTRA-SFN-SFN-RelTimeDifference1',
        'OMA-LPPe-OTDOA-UTRA-PositioningAssistance',
        'OMA-LPPe-OTDOA-UTRA-SFN-OffsetValidity',
        'OMA-LPPe-OTDOA-UTRA-SFN-SFN-Drift',
        'OMA-LPPe-OTDOA-UTRA-SearchWindowSize',
        'OMA-LPPe-OTDOA-UTRA-fineSFN-SFN',
        'OMA-LPPe-OTDOA-UTRA-IPDL-Parameters',
        'OMA-LPPe-OTDOA-UTRA-IP-Spacing',
        'OMA-LPPe-OTDOA-UTRA-IP-Length',
        'OMA-LPPe-OTDOA-UTRA-IP-Spacing-TDD',
        'OMA-LPPe-OTDOA-UTRA-IP-PCCPCH',
        'OMA-LPPe-OTDOA-UTRA-BurstModeParameters',
        'OMA-LPPe-OTDOA-UTRA-RequestAssistanceData',
        'OMA-LPPe-OTDOA-UTRA-ProvideLocationInformation',
        'OMA-LPPe-OTDOA-UTRA-Measurement',
        'OMA-LPPe-OTDOA-UTRA-UE-RX-TX-TimeDifferenceType2Info',
        'OMA-LPPe-OTDOA-UTRA-TimeDifferenceType2',
        'OMA-LPPe-OTDOA-UTRA-NeighborList',
        'OMA-LPPe-OTDOA-UTRA-Neighbor',
        'OMA-LPPe-OTDOA-UTRA-NeighborQuality',
        'OMA-LPPe-OTDOA-UTRA-SFN-SFN-ObsTimeDifference2',
        'OMA-LPPe-OTDOA-UTRA-Quality',
        'OMA-LPPe-OTDOA-UTRA-TimeStampData',
        'OMA-LPPe-OTDOA-UTRA-RequestLocationInformation',
        'OMA-LPPe-OTDOA-UTRA-ProvideCapabilities',
        'OMA-LPPe-OTDOA-UTRA-RequestCapabilities',
        'OMA-LPPe-OTDOA-UTRA-Error',
        'OMA-LPPe-OTDOA-UTRA-LocationServerErrorCauses',
        'OMA-LPPe-OTDOA-UTRA-TargetDeviceErrorCauses',
        'OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info',
        'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode',
        'OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity',
        'OMA-LPPe-OTDOA-UTRA-BurstType',
        'OMA-LPPe-OTDOA-UTRA-MidambleShiftLong',
        'OMA-LPPe-OTDOA-UTRA-TimeSlotNumber',
        'OMA-LPPe-OTDOA-UTRA-CellParametersID',
        'OMA-LPPe-ECID-LTE-ProvideAssistanceData',
        'OMA-LPPe-ECID-LTE-NetworkData',
        'OMA-LPPe-ECID-LTE-eNodeBData',
        'OMA-LPPe-ECID-LTE-HeNBData',
        'OMA-LPPe-ECID-LTE-CellData',
        'OMA-LPPe-ECID-LTE-RequestAssistanceData',
        'OMA-LPPe-ECID-LTE-ProvideLocationInformation',
        'OMA-LPPe-ECID-LTE-LocationInformationList',
        'OMA-LPPe-ECID-LTE-LocationInformation',
        'OMA-LPPe-ECID-LTE-RequestLocationInformation',
        'OMA-LPPe-ECID-LTE-ProvideCapabilities',
        'OMA-LPPe-ECID-LTE-RequestCapabilities',
        'OMA-LPPe-ECID-LTE-Error',
        'OMA-LPPe-ECID-LTE-LocationServerErrorCauses',
        'OMA-LPPe-ECID-LTE-TargetDeviceErrorCauses',
        'OMA-LPPe-ECID-GSM-ProvideAssistanceData',
        'OMA-LPPe-ECID-GSM-NetworkData',
        'OMA-LPPe-ECID-GSM-BaseStationData',
        'OMA-LPPe-ECID-GSM-CellData',
        'OMA-LPPe-ECID-GSM-RequestAssistanceData',
        'OMA-LPPe-ECID-GSM-ProvideLocationInformation',
        'OMA-LPPe-ECID-GSM-LocationInformationList',
        'OMA-LPPe-ECID-GSM-LocationInformation',
        'OMA-LPPe-NMR-GERAN',
        'OMA-LPPe-ECID-GSM-RequestLocationInformation',
        'OMA-LPPe-ECID-GSM-ProvideCapabilities',
        'OMA-LPPe-ECID-GSM-RequestCapabilities',
        'OMA-LPPe-ECID-GSM-Error',
        'OMA-LPPe-ECID-GSM-LocationServerErrorCauses',
        'OMA-LPPe-ECID-GSM-TargetDeviceErrorCauses',
        'OMA-LPPe-ECID-UTRA-ProvideAssistanceData',
        'OMA-LPPe-ECID-UTRA-NetworkData',
        'OMA-LPPe-ECID-UTRA-NodeBData',
        'OMA-LPPe-ECID-UTRA-HNBData',
        'OMA-LPPe-ECID-UTRA-CellData',
        'OMA-LPPe-ECID-UTRA-RequestAssistanceData',
        'OMA-LPPe-ECID-UTRA-ProvideLocationInformation',
        'OMA-LPPe-ECID-UTRA-LocationInformationList',
        'OMA-LPPe-ECID-UTRA-LocationInformation',
        'OMA-LPPe-ECID-UTRA-UTRATimingAdvance',
        'OMA-LPPe-ECID-UTRA-TAResolution',
        'OMA-LPPe-ECID-UTRA-ChipRate',
        'OMA-LPPe-UTRA-FrequencyInfo',
        'OMA-LPPe-UTRA-ModeSpecificInfo',
        'OMA-LPPe-UTRA-FrequencyInfoFDD',
        'OMA-LPPe-UTRA-FrequencyInfoTDD',
        'OMA-LPPe-ECID-UTRA-MeasuredResultsList',
        'OMA-LPPe-ECID-UTRA-MeasuredResults',
        'OMA-LPPe-ECID-UTRA-CellMeasuredResultsList',
        'OMA-LPPe-ECID-UTRA-CarrierRSSI',
        'OMA-LPPe-ECID-UTRA-CellMeasuredResults',
        'OMA-LPPe-ECID-UTRA-PrimaryCCPCH-RSCP',
        'OMA-LPPe-ECID-UTRA-CPICH-Ec-N0',
        'OMA-LPPe-ECID-UTRA-CPICH-RSCP',
        'OMA-LPPe-ECID-UTRA-Pathloss',
        'OMA-LPPe-ECID-UTRA-RequestLocationInformation',
        'OMA-LPPe-ECID-UTRA-ProvideCapabilities',
        'OMA-LPPe-ECID-UTRA-RequestCapabilities',
        'OMA-LPPe-ECID-UTRA-Error',
        'OMA-LPPe-ECID-UTRA-LocationServerErrorCauses',
        'OMA-LPPe-ECID-UTRA-TargetDeviceErrorCauses',
        'OMA-LPPe-WLAN-AP-ProvideAssistanceData',
        'OMA-LPPe-WLAN-DataSet',
        'Supported-Channels-11a',
        'Supported-Channels-11bg',
        'OMA-LPPe-WLAN-AP-Data',
        'OMA-LPPe-WLAN-AP-Type-Data',
        'OMA-LPPe-WLAN-AP-RequestAssistanceData',
        'OMA-LPPe-WLAN-AP-ProvideLocationInformation',
        'OMA-LPPe-WLAN-AP-LocationInformationList',
        'OMA-LPPe-WLAN-AP-LocationInformation',
        'OMA-LPPe-WLAN-AP-PHY-Type',
        'OMA-LPPe-WLAN-RTD',
        'OMA-LPPe-WLAN-RTDUnits',
        'OMA-LPPe-WLAN-ReportedLocation',
        'OMA-LPPe-WLAN-LocationDataLCI',
        'OMA-LPPe-WLAN-AP-RequestLocationInformation',
        'OMA-LPPe-WLAN-AP-ProvideCapabilities',
        'OMA-LPPe-WLAN-AP-Capability',
        'OMA-LPPe-WLAN-AP-RequestCapabilities',
        'OMA-LPPe-WLAN-AP-Error',
        'OMA-LPPe-WLAN-AP-LocationServerErrorCauses',
        'OMA-LPPe-WLAN-AP-TargetDeviceErrorCauses',
        'OMA-LPPe-ECID-WiMax-ProvideLocationInformation',
        'OMA-LPPe-ECID-WiMax-LocationInformationList',
        'OMA-LPPe-ECID-WiMax-LocationInformation',
        'OMA-LPPe-ECID-WiMax-WimaxBsID',
        'OMA-LPPe-ECID-WiMax-WimaxRTD',
        'OMA-LPPe-ECID-WiMax-WimaxNMRList',
        'OMA-LPPe-ECID-WiMax-WimaxNMR',
        'OMA-LPPe-ECID-WiMax-RequestLocationInformation',
        'OMA-LPPe-ECID-WiMax-ProvideCapabilities',
        'OMA-LPPe-ECID-WiMax-RequestCapabilities',
        'OMA-LPPe-ECID-WiMax-Error',
        'OMA-LPPe-ECID-WiMax-LocationServerErrorCauses',
        'OMA-LPPe-ECID-WiMax-TargetDeviceErrorCauses',
        'OMA-LPPe-Sensor-ProvideAssistanceData',
        'OMA-LPPe-AtmosphericPressureAD',
        'OMA-LPPe-PressureValidityArea',
        'OMA-LPPe-Sensor-RequestAssistanceData',
        'OMA-LPPe-PressureSensorAD',
        'OMA-LPPe-Sensor-ProvideLocationInformation',
        'OMA-LPPe-Sensor-MotionStateList',
        'OMA-LPPe-Sensor-MotionStateElement',
        'OMA-LPPe-Sensor-RequestLocationInformation',
        'OMA-LPPe-Sensor-MotionStateRequest',
        'OMA-LPPe-Sensor-ProvideCapabilities',
        'OMA-LPPe-Sensor-RequestCapabilities',
        'OMA-LPPe-Sensor-Error',
        'OMA-LPPe-Sensor-TargetError',
        'OMA-LPPe-SRN-ProvideAssistanceData',
        'OMA-LPPe-SRN-SRNgroupList',
        'OMA-LPPe-SRN-SRNgroup',
        'OMA-LPPe-SRN-SRNinfo',
        'OMA-LPPe-SRN-SRNgroupUpdateResponse',
        'OMA-LPPe-SRN-SRNgroupUpdateResponseElement',
        'OMA-LPPe-SRN-AntennaPattern',
        'OMA-LPPe-SRN-AntennaPatternElement',
        'OMA-LPPe-SRN-AntennaPatternForChannels',
        'OMA-LPPe-SRN-ChannelResponse',
        'OMA-LPPe-SRN-ResponseInElevation',
        'OMA-LPPe-SRN-ResponseInAzimuth',
        'OMA-LPPe-ComplexNumber',
        'OMA-LPPe-SRN-RequestAssistanceData',
        'OMA-LPPe-SRN-SRNgroupRequest',
        'OMA-LPPe-SRN-SRNProvideList',
        'OMA-LPPe-SRN-SRNgroupUpdateRequest',
        'OMA-LPPe-SRN-SRNgroupUpdateRequestElement',
        'OMA-LPPe-SRN-AntennaPatternRequest',
        'OMA-LPPe-SRN-AntennaPatternRequestElement',
        'OMA-LPPe-SRN-ProvideLocationInformation',
        'OMA-LPPe-SRN-MeasurementElement',
        'OMA-LPPe-SRN-srnMeasurementElement',
        'OMA-LPPe-SRN-RequestLocationInformation',
        'OMA-LPPe-SRN-ReqLocInfo-Category',
        'OMA-LPPe-SRN-ProvideCapabilities',
        'OMA-LPPe-SRN-ProvideCapabilitiesElement',
        'OMA-LPPe-SRN-RequestCapabilities',
        'OMA-LPPe-SRN-Error',
        'OMA-LPPe-SRN-LocationServerErrorCauses',
        'OMA-LPPe-SRN-TargetDeviceErrorCauses',
        'OMA-LPPe-SRN-TargetDeviceError',
        'OMA-LPPe-SRN-SRNgroupUniqueID',
        'OMA-LPPe-SRN-SRNtype',
        'OMA-LPPe-SRN-Category',
        'OMA-LPPe-SRN-SRNid',
        'OMA-LPPe-SRN-Technologies',
        'OMA-LPPe-SRN-MeasurementMask',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxAssistanceContainerList',
        'maxLocationInformationContainerDataList',
        'maxLevel1-element',
        'maxLevel2-element',
        'maxLevel3-element',
        'maxFinal-element',
        'maxLPPLabelSets',
        'maxLPPeLabelSets',
        'maxVendorOrOperatorIDList',
        'maxLocationInformationContainerList',
        'maxCellSets',
        'maxCells',
        'maxIPAddress',
        'maxRelativeLocation',
        'maxReferenceStations',
        'maxFreqLayers',
        'utra-maxCellMeas',
        'maxLTENetworks',
        'maxLTEeNBs',
        'maxLTEHeNBs',
        'maxLTEMacroCells',
        'maxLTEECIDSize',
        'maxGSMNetworks',
        'maxGSMBaseStations',
        'maxGSMCells',
        'maxGSMECIDSize',
        'maxUTRANetworks',
        'maxUTRAnodeBs',
        'maxUTRAHNBs',
        'maxUTRAMacroCells',
        'maxECIDUTRASize',
        'maxFreq',
        'maxWLANDataSets',
        'maxWLANAPs',
        'maxWLANTypes',
        'maxWLANAPSize',
        'maxWiMaxECIDSize',
        'maxWimaxBSMeas',
        'maxChannels',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< OMA-LPPe-MessageExtension >-----#
    OMA_LPPe_MessageExtension = SEQ(name='OMA-LPPe-MessageExtension', mode=MODE_TYPE)
    _OMA_LPPe_MessageExtension_lppeCompatibilityLevel = INT(name='lppeCompatibilityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LPPeCompatibilityLevel')))
    _OMA_LPPe_MessageExtension_lppeVersion = SEQ(name='lppeVersion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LPPeVersion')))
    _OMA_LPPe_MessageExtension_lppeMode = ENUM(name='lppeMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LPPeMode')))
    _OMA_LPPe_MessageExtension_messageExtensionBody = CHOICE(name='messageExtensionBody', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-MessageExtensionBody')))
    OMA_LPPe_MessageExtension._cont = ASN1Dict([
        ('lppeCompatibilityLevel', _OMA_LPPe_MessageExtension_lppeCompatibilityLevel),
        ('lppeVersion', _OMA_LPPe_MessageExtension_lppeVersion),
        ('lppeMode', _OMA_LPPe_MessageExtension_lppeMode),
        ('messageExtensionBody', _OMA_LPPe_MessageExtension_messageExtensionBody),
        ])
    OMA_LPPe_MessageExtension._ext = []
    
    #-----< OMA-LPPe-LPPeCompatibilityLevel >-----#
    OMA_LPPe_LPPeCompatibilityLevel = INT(name='OMA-LPPe-LPPeCompatibilityLevel', mode=MODE_TYPE)
    OMA_LPPe_LPPeCompatibilityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< OMA-LPPe-LPPeVersion >-----#
    OMA_LPPe_LPPeVersion = SEQ(name='OMA-LPPe-LPPeVersion', mode=MODE_TYPE)
    _OMA_LPPe_LPPeVersion_majorVersion = INT(name='majorVersion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_LPPeVersion_majorVersion._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_LPPeVersion_minorVersion = INT(name='minorVersion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_LPPeVersion_minorVersion._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    OMA_LPPe_LPPeVersion._cont = ASN1Dict([
        ('majorVersion', _OMA_LPPe_LPPeVersion_majorVersion),
        ('minorVersion', _OMA_LPPe_LPPeVersion_minorVersion),
        ])
    OMA_LPPe_LPPeVersion._ext = None
    
    #-----< OMA-LPPe-LPPeMode >-----#
    OMA_LPPe_LPPeMode = ENUM(name='OMA-LPPe-LPPeMode', mode=MODE_TYPE)
    OMA_LPPe_LPPeMode._cont = ASN1Dict([('normal', 0), ('reversed', 1)])
    OMA_LPPe_LPPeMode._ext = []
    
    #-----< OMA-LPPe-MessageExtensionBody >-----#
    OMA_LPPe_MessageExtensionBody = CHOICE(name='OMA-LPPe-MessageExtensionBody', mode=MODE_TYPE)
    _OMA_LPPe_MessageExtensionBody_requestCapabilities = SEQ(name='requestCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RequestCapabilities')))
    _OMA_LPPe_MessageExtensionBody_provideCapabilities = SEQ(name='provideCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ProvideCapabilities')))
    _OMA_LPPe_MessageExtensionBody_requestAssistanceData = SEQ(name='requestAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RequestAssistanceData')))
    _OMA_LPPe_MessageExtensionBody_provideAssistanceData = SEQ(name='provideAssistanceData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ProvideAssistanceData')))
    _OMA_LPPe_MessageExtensionBody_requestLocationInformation = SEQ(name='requestLocationInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RequestLocationInformation')))
    _OMA_LPPe_MessageExtensionBody_provideLocationInformation = SEQ(name='provideLocationInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ProvideLocationInformation')))
    _OMA_LPPe_MessageExtensionBody_error = SEQ(name='error', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Error')))
    _OMA_LPPe_MessageExtensionBody_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Abort')))
    OMA_LPPe_MessageExtensionBody._cont = ASN1Dict([
        ('requestCapabilities', _OMA_LPPe_MessageExtensionBody_requestCapabilities),
        ('provideCapabilities', _OMA_LPPe_MessageExtensionBody_provideCapabilities),
        ('requestAssistanceData', _OMA_LPPe_MessageExtensionBody_requestAssistanceData),
        ('provideAssistanceData', _OMA_LPPe_MessageExtensionBody_provideAssistanceData),
        ('requestLocationInformation', _OMA_LPPe_MessageExtensionBody_requestLocationInformation),
        ('provideLocationInformation', _OMA_LPPe_MessageExtensionBody_provideLocationInformation),
        ('error', _OMA_LPPe_MessageExtensionBody_error),
        ('abort', _OMA_LPPe_MessageExtensionBody_abort),
        ])
    OMA_LPPe_MessageExtensionBody._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastContainer >-----#
    OMA_LPPe_ver1_1_BroadcastContainer = SEQ(name='OMA-LPPe-ver1-1-BroadcastContainer', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastContainer_digitalSignature = SEQ(name='digitalSignature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-DigitalSignature')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastContainer_messageContents = OCT_STR(name='messageContents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_ver1_1_BroadcastContainer._cont = ASN1Dict([
        ('digitalSignature', _OMA_LPPe_ver1_1_BroadcastContainer_digitalSignature),
        ('messageContents', _OMA_LPPe_ver1_1_BroadcastContainer_messageContents),
        ])
    OMA_LPPe_ver1_1_BroadcastContainer._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastMessage >-----#
    OMA_LPPe_ver1_1_BroadcastMessage = SEQ(name='OMA-LPPe-ver1-1-BroadcastMessage', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastMessage_broadcastControlIEs = SEQ(name='broadcastControlIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastControlIEs')))
    _OMA_LPPe_ver1_1_BroadcastMessage_cipheringIEs = SEQ(name='cipheringIEs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CipheringIEs')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastMessage_broadcastMessage = OCT_STR(name='broadcastMessage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_ver1_1_BroadcastMessage._cont = ASN1Dict([
        ('broadcastControlIEs', _OMA_LPPe_ver1_1_BroadcastMessage_broadcastControlIEs),
        ('cipheringIEs', _OMA_LPPe_ver1_1_BroadcastMessage_cipheringIEs),
        ('broadcastMessage', _OMA_LPPe_ver1_1_BroadcastMessage_broadcastMessage),
        ])
    OMA_LPPe_ver1_1_BroadcastMessage._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastControlIEs >-----#
    OMA_LPPe_ver1_1_BroadcastControlIEs = SEQ(name='OMA-LPPe-ver1-1-BroadcastControlIEs', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastControlIEs_serverID = SEQ(name='serverID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-ServerID')))
    _OMA_LPPe_ver1_1_BroadcastControlIEs_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ver1_1_BroadcastControlIEs_messageID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_ver1_1_BroadcastControlIEs_validity_time = SEQ(name='validity-time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastControlIEs_validity_area = SEQ(name='validity-area', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastControlIEs_broadcastADTypes = SEQ(name='broadcastADTypes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastADTypes')), opt=True)
    OMA_LPPe_ver1_1_BroadcastControlIEs._cont = ASN1Dict([
        ('serverID', _OMA_LPPe_ver1_1_BroadcastControlIEs_serverID),
        ('messageID', _OMA_LPPe_ver1_1_BroadcastControlIEs_messageID),
        ('validity-time', _OMA_LPPe_ver1_1_BroadcastControlIEs_validity_time),
        ('validity-area', _OMA_LPPe_ver1_1_BroadcastControlIEs_validity_area),
        ('broadcastADTypes', _OMA_LPPe_ver1_1_BroadcastControlIEs_broadcastADTypes),
        ])
    OMA_LPPe_ver1_1_BroadcastControlIEs._ext = []
    
    #-----< OMA-LPPe-ver1-1-CipheringIEs >-----#
    OMA_LPPe_ver1_1_CipheringIEs = SEQ(name='OMA-LPPe-ver1-1-CipheringIEs', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_CipheringIEs_cipherSetID = INT(name='cipherSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CipherSetID')))
    _OMA_LPPe_ver1_1_CipheringIEs_d0 = BIT_STR(name='d0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_CipheringIEs_d0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ver1_1_CipheringIEs._cont = ASN1Dict([
        ('cipherSetID', _OMA_LPPe_ver1_1_CipheringIEs_cipherSetID),
        ('d0', _OMA_LPPe_ver1_1_CipheringIEs_d0),
        ])
    OMA_LPPe_ver1_1_CipheringIEs._ext = []
    
    #-----< OMA-LPPe-ver1-1-DigitalSignature >-----#
    OMA_LPPe_ver1_1_DigitalSignature = SEQ(name='OMA-LPPe-ver1-1-DigitalSignature', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_DigitalSignature_authenticationSetID = INT(name='authenticationSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AuthenticationSetID')))
    _OMA_LPPe_ver1_1_DigitalSignature_signature = BIT_STR(name='signature', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_DigitalSignature_signature._const_sz = ASN1Set(rv=[2048], rr=[], ev=None, er=[])
    OMA_LPPe_ver1_1_DigitalSignature._cont = ASN1Dict([
        ('authenticationSetID', _OMA_LPPe_ver1_1_DigitalSignature_authenticationSetID),
        ('signature', _OMA_LPPe_ver1_1_DigitalSignature_signature),
        ])
    OMA_LPPe_ver1_1_DigitalSignature._ext = []
    
    #-----< OMA-LPPe-RequestCapabilities >-----#
    OMA_LPPe_RequestCapabilities = SEQ(name='OMA-LPPe-RequestCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_RequestCapabilities_commonIEsRequestCapabilities = SEQ(name='commonIEsRequestCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsRequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_agnss_RequestCapabilities = SEQ(name='agnss-RequestCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_otdoa_RequestCapabilities = SEQ(name='otdoa-RequestCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_eotd_RequestCapabilities = SEQ(name='eotd-RequestCapabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_otdoa_utra_RequestCapabilities = SEQ(name='otdoa-utra-RequestCapabilities', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_ecid_lte_RequestCapabilities = SEQ(name='ecid-lte-RequestCapabilities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_ecid_gsm_RequestCapabilities = SEQ(name='ecid-gsm-RequestCapabilities', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_ecid_utra_RequestCapabilities = SEQ(name='ecid-utra-RequestCapabilities', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_wlan_ap_RequestCapabilities = SEQ(name='wlan-ap-RequestCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_ecid_wimax_RequestCapabilities = SEQ(name='ecid-wimax-RequestCapabilities', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_sensor_RequestCapabilities = SEQ(name='sensor-RequestCapabilities', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-RequestCapabilities')), opt=True)
    _OMA_LPPe_RequestCapabilities_srn_RequestCapabilities = SEQ(name='srn-RequestCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-RequestCapabilities')), opt=True)
    OMA_LPPe_RequestCapabilities._cont = ASN1Dict([
        ('commonIEsRequestCapabilities', _OMA_LPPe_RequestCapabilities_commonIEsRequestCapabilities),
        ('agnss-RequestCapabilities', _OMA_LPPe_RequestCapabilities_agnss_RequestCapabilities),
        ('otdoa-RequestCapabilities', _OMA_LPPe_RequestCapabilities_otdoa_RequestCapabilities),
        ('eotd-RequestCapabilities', _OMA_LPPe_RequestCapabilities_eotd_RequestCapabilities),
        ('otdoa-utra-RequestCapabilities', _OMA_LPPe_RequestCapabilities_otdoa_utra_RequestCapabilities),
        ('ecid-lte-RequestCapabilities', _OMA_LPPe_RequestCapabilities_ecid_lte_RequestCapabilities),
        ('ecid-gsm-RequestCapabilities', _OMA_LPPe_RequestCapabilities_ecid_gsm_RequestCapabilities),
        ('ecid-utra-RequestCapabilities', _OMA_LPPe_RequestCapabilities_ecid_utra_RequestCapabilities),
        ('wlan-ap-RequestCapabilities', _OMA_LPPe_RequestCapabilities_wlan_ap_RequestCapabilities),
        ('ecid-wimax-RequestCapabilities', _OMA_LPPe_RequestCapabilities_ecid_wimax_RequestCapabilities),
        ('sensor-RequestCapabilities', _OMA_LPPe_RequestCapabilities_sensor_RequestCapabilities),
        ('srn-RequestCapabilities', _OMA_LPPe_RequestCapabilities_srn_RequestCapabilities),
        ])
    OMA_LPPe_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-ProvideCapabilities >-----#
    OMA_LPPe_ProvideCapabilities = SEQ(name='OMA-LPPe-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ProvideCapabilities_commonIEsProvideCapabilities = SEQ(name='commonIEsProvideCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_agnss_ProvideCapabilities = SEQ(name='agnss-ProvideCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_otdoa_ProvideCapabilities = SEQ(name='otdoa-ProvideCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_eotd_ProvideCapabilities = SEQ(name='eotd-ProvideCapabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_otdoa_utra_ProvideCapabilities = SEQ(name='otdoa-utra-ProvideCapabilities', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_ecid_lte_ProvideCapabilities = SEQ(name='ecid-lte-ProvideCapabilities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_ecid_gsm_ProvideCapabilities = SEQ(name='ecid-gsm-ProvideCapabilities', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_ecid_utra_ProvideCapabilities = SEQ(name='ecid-utra-ProvideCapabilities', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_wlan_ap_ProvideCapabilities = SEQ(name='wlan-ap-ProvideCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_ecid_wimax_ProvideCapabilities = SEQ(name='ecid-wimax-ProvideCapabilities', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_sensor_ProvideCapabilities = SEQ(name='sensor-ProvideCapabilities', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-ProvideCapabilities')), opt=True)
    _OMA_LPPe_ProvideCapabilities_srn_ProvideCapabilities = SEQ(name='srn-ProvideCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ProvideCapabilities')), opt=True)
    OMA_LPPe_ProvideCapabilities._cont = ASN1Dict([
        ('commonIEsProvideCapabilities', _OMA_LPPe_ProvideCapabilities_commonIEsProvideCapabilities),
        ('agnss-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_agnss_ProvideCapabilities),
        ('otdoa-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_otdoa_ProvideCapabilities),
        ('eotd-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_eotd_ProvideCapabilities),
        ('otdoa-utra-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_otdoa_utra_ProvideCapabilities),
        ('ecid-lte-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_ecid_lte_ProvideCapabilities),
        ('ecid-gsm-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_ecid_gsm_ProvideCapabilities),
        ('ecid-utra-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_ecid_utra_ProvideCapabilities),
        ('wlan-ap-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_wlan_ap_ProvideCapabilities),
        ('ecid-wimax-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_ecid_wimax_ProvideCapabilities),
        ('sensor-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_sensor_ProvideCapabilities),
        ('srn-ProvideCapabilities', _OMA_LPPe_ProvideCapabilities_srn_ProvideCapabilities),
        ])
    OMA_LPPe_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-RequestAssistanceData >-----#
    OMA_LPPe_RequestAssistanceData = SEQ(name='OMA-LPPe-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_RequestAssistanceData_commonIEsRequestAssistanceData = SEQ(name='commonIEsRequestAssistanceData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsRequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_agnss_RequestAssistanceData = SEQ(name='agnss-RequestAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_otdoa_RequestAssistanceData = SEQ(name='otdoa-RequestAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_eotd_RequestAssistanceData = SEQ(name='eotd-RequestAssistanceData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_otdoa_utra_RequestAssistanceData = SEQ(name='otdoa-utra-RequestAssistanceData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_ecid_lte_RequestAssistanceData = SEQ(name='ecid-lte-RequestAssistanceData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_ecid_gsm_RequestAssistanceData = SEQ(name='ecid-gsm-RequestAssistanceData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_ecid_utra_RequestAssistanceData = SEQ(name='ecid-utra-RequestAssistanceData', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_wlan_ap_RequestAssistanceData = SEQ(name='wlan-ap-RequestAssistanceData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_sensor_RequestAssistanceData = SEQ(name='sensor-RequestAssistanceData', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-RequestAssistanceData')), opt=True)
    _OMA_LPPe_RequestAssistanceData_srn_RequestAssistanceData = SEQ(name='srn-RequestAssistanceData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-RequestAssistanceData')), opt=True)
    OMA_LPPe_RequestAssistanceData._cont = ASN1Dict([
        ('commonIEsRequestAssistanceData', _OMA_LPPe_RequestAssistanceData_commonIEsRequestAssistanceData),
        ('agnss-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_agnss_RequestAssistanceData),
        ('otdoa-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_otdoa_RequestAssistanceData),
        ('eotd-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_eotd_RequestAssistanceData),
        ('otdoa-utra-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_otdoa_utra_RequestAssistanceData),
        ('ecid-lte-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_ecid_lte_RequestAssistanceData),
        ('ecid-gsm-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_ecid_gsm_RequestAssistanceData),
        ('ecid-utra-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_ecid_utra_RequestAssistanceData),
        ('wlan-ap-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_wlan_ap_RequestAssistanceData),
        ('sensor-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_sensor_RequestAssistanceData),
        ('srn-RequestAssistanceData', _OMA_LPPe_RequestAssistanceData_srn_RequestAssistanceData),
        ])
    OMA_LPPe_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-ProvideAssistanceData >-----#
    OMA_LPPe_ProvideAssistanceData = SEQ(name='OMA-LPPe-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ProvideAssistanceData_commonIEsProvideAssistanceData = SEQ(name='commonIEsProvideAssistanceData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_agnss_ProvideAssistanceData = SEQ(name='agnss-ProvideAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_otdoa_ProvideAssistanceData = SEQ(name='otdoa-ProvideAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_eotd_ProvideAssistanceData = SEQ(name='eotd-ProvideAssistanceData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_otdoa_utra_ProvideAssistanceData = SEQ(name='otdoa-utra-ProvideAssistanceData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_ecid_lte_ProvideAssistanceData = SEQ(name='ecid-lte-ProvideAssistanceData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_ecid_gsm_ProvideAssistanceData = SEQ(name='ecid-gsm-ProvideAssistanceData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_ecid_utra_ProvideAssistanceData = SEQ(name='ecid-utra-ProvideAssistanceData', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_wlan_ap_ProvideAssistanceData = SEQ(name='wlan-ap-ProvideAssistanceData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_sensor_ProvideAssistanceData = SEQ(name='sensor-ProvideAssistanceData', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-ProvideAssistanceData')), opt=True)
    _OMA_LPPe_ProvideAssistanceData_srn_ProvideAssistanceData = SEQ(name='srn-ProvideAssistanceData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ProvideAssistanceData')), opt=True)
    OMA_LPPe_ProvideAssistanceData._cont = ASN1Dict([
        ('commonIEsProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_commonIEsProvideAssistanceData),
        ('agnss-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_agnss_ProvideAssistanceData),
        ('otdoa-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_otdoa_ProvideAssistanceData),
        ('eotd-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_eotd_ProvideAssistanceData),
        ('otdoa-utra-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_otdoa_utra_ProvideAssistanceData),
        ('ecid-lte-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_ecid_lte_ProvideAssistanceData),
        ('ecid-gsm-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_ecid_gsm_ProvideAssistanceData),
        ('ecid-utra-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_ecid_utra_ProvideAssistanceData),
        ('wlan-ap-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_wlan_ap_ProvideAssistanceData),
        ('sensor-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_sensor_ProvideAssistanceData),
        ('srn-ProvideAssistanceData', _OMA_LPPe_ProvideAssistanceData_srn_ProvideAssistanceData),
        ])
    OMA_LPPe_ProvideAssistanceData._ext = []
    
    #-----< OMA-LPPe-RequestLocationInformation >-----#
    OMA_LPPe_RequestLocationInformation = SEQ(name='OMA-LPPe-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_RequestLocationInformation_commonIEsRequestLocationInformation = SEQ(name='commonIEsRequestLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsRequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_agnss_RequestLocationInformation = SEQ(name='agnss-RequestLocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_otdoa_RequestLocationInformation = SEQ(name='otdoa-RequestLocationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_eotd_RequestLocationInformation = SEQ(name='eotd-RequestLocationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_otdoa_utra_RequestLocationInformation = SEQ(name='otdoa-utra-RequestLocationInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_ecid_lte_RequestLocationInformation = SEQ(name='ecid-lte-RequestLocationInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_ecid_gsm_RequestLocationInformation = SEQ(name='ecid-gsm-RequestLocationInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_ecid_utra_RequestLocationInformation = SEQ(name='ecid-utra-RequestLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_wlan_ap_RequestLocationInformation = SEQ(name='wlan-ap-RequestLocationInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_ecid_wimax_RequestLocationInformation = SEQ(name='ecid-wimax-RequestLocationInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_sensor_RequestLocationInformation = SEQ(name='sensor-RequestLocationInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-RequestLocationInformation')), opt=True)
    _OMA_LPPe_RequestLocationInformation_srn_RequestLocationInformation = SEQ(name='srn-RequestLocationInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-RequestLocationInformation')), opt=True)
    OMA_LPPe_RequestLocationInformation._cont = ASN1Dict([
        ('commonIEsRequestLocationInformation', _OMA_LPPe_RequestLocationInformation_commonIEsRequestLocationInformation),
        ('agnss-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_agnss_RequestLocationInformation),
        ('otdoa-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_otdoa_RequestLocationInformation),
        ('eotd-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_eotd_RequestLocationInformation),
        ('otdoa-utra-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_otdoa_utra_RequestLocationInformation),
        ('ecid-lte-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_ecid_lte_RequestLocationInformation),
        ('ecid-gsm-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_ecid_gsm_RequestLocationInformation),
        ('ecid-utra-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_ecid_utra_RequestLocationInformation),
        ('wlan-ap-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_wlan_ap_RequestLocationInformation),
        ('ecid-wimax-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_ecid_wimax_RequestLocationInformation),
        ('sensor-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_sensor_RequestLocationInformation),
        ('srn-RequestLocationInformation', _OMA_LPPe_RequestLocationInformation_srn_RequestLocationInformation),
        ])
    OMA_LPPe_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-ProvideLocationInformation >-----#
    OMA_LPPe_ProvideLocationInformation = SEQ(name='OMA-LPPe-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ProvideLocationInformation_commonIEsProvideLocationInformation = SEQ(name='commonIEsProvideLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_agnss_ProvideLocationInformation = SEQ(name='agnss-ProvideLocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_otdoa_ProvideLocationInformation = SEQ(name='otdoa-ProvideLocationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_eotd_ProvideLocationInformation = SEQ(name='eotd-ProvideLocationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_otdoa_utra_ProvideLocationInformation = SEQ(name='otdoa-utra-ProvideLocationInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_ecid_lte_ProvideLocationInformation = SEQ(name='ecid-lte-ProvideLocationInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_ecid_gsm_ProvideLocationInformation = SEQ(name='ecid-gsm-ProvideLocationInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_ecid_utra_ProvideLocationInformation = SEQ(name='ecid-utra-ProvideLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_wlan_ap_ProvideLocationInformastion = SEQ(name='wlan-ap-ProvideLocationInformastion', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_ecid_wimax_ProvideLocationInformastion = SEQ(name='ecid-wimax-ProvideLocationInformastion', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_sensor_ProvideLocationInformation = SEQ(name='sensor-ProvideLocationInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-ProvideLocationInformation')), opt=True)
    _OMA_LPPe_ProvideLocationInformation_srn_ProvideLocationInformation = SEQ(name='srn-ProvideLocationInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ProvideLocationInformation')), opt=True)
    OMA_LPPe_ProvideLocationInformation._cont = ASN1Dict([
        ('commonIEsProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_commonIEsProvideLocationInformation),
        ('agnss-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_agnss_ProvideLocationInformation),
        ('otdoa-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_otdoa_ProvideLocationInformation),
        ('eotd-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_eotd_ProvideLocationInformation),
        ('otdoa-utra-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_otdoa_utra_ProvideLocationInformation),
        ('ecid-lte-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_ecid_lte_ProvideLocationInformation),
        ('ecid-gsm-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_ecid_gsm_ProvideLocationInformation),
        ('ecid-utra-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_ecid_utra_ProvideLocationInformation),
        ('wlan-ap-ProvideLocationInformastion', _OMA_LPPe_ProvideLocationInformation_wlan_ap_ProvideLocationInformastion),
        ('ecid-wimax-ProvideLocationInformastion', _OMA_LPPe_ProvideLocationInformation_ecid_wimax_ProvideLocationInformastion),
        ('sensor-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_sensor_ProvideLocationInformation),
        ('srn-ProvideLocationInformation', _OMA_LPPe_ProvideLocationInformation_srn_ProvideLocationInformation),
        ])
    OMA_LPPe_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-Abort >-----#
    OMA_LPPe_Abort = SEQ(name='OMA-LPPe-Abort', mode=MODE_TYPE)
    _OMA_LPPe_Abort_commonIEsAbort = SEQ(name='commonIEsAbort', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsAbort')), opt=True)
    _OMA_LPPe_Abort_agnssAbort = SEQ(name='agnssAbort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-Abort')), opt=True)
    OMA_LPPe_Abort._cont = ASN1Dict([
        ('commonIEsAbort', _OMA_LPPe_Abort_commonIEsAbort),
        ('agnssAbort', _OMA_LPPe_Abort_agnssAbort),
        ])
    OMA_LPPe_Abort._ext = []
    
    #-----< OMA-LPPe-Error >-----#
    OMA_LPPe_Error = SEQ(name='OMA-LPPe-Error', mode=MODE_TYPE)
    _OMA_LPPe_Error_commonIEsError = SEQ(name='commonIEsError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CommonIEsError')), opt=True)
    OMA_LPPe_Error._cont = ASN1Dict([
        ('commonIEsError', _OMA_LPPe_Error_commonIEsError),
        ])
    OMA_LPPe_Error._ext = []
    
    #-----< OMA-LPPe-AssistanceContainer-DataSerialNumber >-----#
    OMA_LPPe_AssistanceContainer_DataSerialNumber = SEQ(name='OMA-LPPe-AssistanceContainer-DataSerialNumber', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainer_DataSerialNumber_dataSerialNumber = INT(name='dataSerialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AssistanceContainer_DataSerialNumber_dataSerialNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    OMA_LPPe_AssistanceContainer_DataSerialNumber._cont = ASN1Dict([
        ('dataSerialNumber', _OMA_LPPe_AssistanceContainer_DataSerialNumber_dataSerialNumber),
        ])
    OMA_LPPe_AssistanceContainer_DataSerialNumber._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerID >-----#
    OMA_LPPe_AssistanceContainerID = SEQ(name='OMA-LPPe-AssistanceContainerID', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerID_containerID = INT(name='containerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AssistanceContainerID_containerID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OMA_LPPe_AssistanceContainerID._cont = ASN1Dict([
        ('containerID', _OMA_LPPe_AssistanceContainerID_containerID),
        ])
    OMA_LPPe_AssistanceContainerID._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerProvideList >-----#
    OMA_LPPe_AssistanceContainerProvideList = SEQ_OF(name='OMA-LPPe-AssistanceContainerProvideList', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerProvideList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerProvide')))
    OMA_LPPe_AssistanceContainerProvideList._cont = _OMA_LPPe_AssistanceContainerProvideList__item_
    OMA_LPPe_AssistanceContainerProvideList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< maxAssistanceContainerList >-----#
    maxAssistanceContainerList = INT(name='maxAssistanceContainerList', mode=MODE_VALUE)
    maxAssistanceContainerList._val = 16
    
    #-----< OMA-LPPe-AssistanceContainerProvide >-----#
    OMA_LPPe_AssistanceContainerProvide = SEQ(name='OMA-LPPe-AssistanceContainerProvide', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerProvide_dataIdentifier = SEQ(name='dataIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorAssistanceDataIdentifier')))
    _OMA_LPPe_AssistanceContainerProvide_checkOrUpdateOrError = ENUM(name='checkOrUpdateOrError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AssistanceContainerProvide_checkOrUpdateOrError._cont = ASN1Dict([('targetHasLatestData', 0), ('targetDataNotLatest', 1), ('targetDataNotLatestButServerCannotProvideLatestData', 2), ('targetHasValidData', 3), ('targetDataInvalidButServerCannotProvideValidData', 4), ('serverHasRequestedDataButUnableToProvideTemporarily', 5), ('serverDoesNotHaveRequestedData', 6), ('serverDoesNotRecognizeRequestedData', 7), ('undefined', 8)])
    _OMA_LPPe_AssistanceContainerProvide_checkOrUpdateOrError._ext = []
    _OMA_LPPe_AssistanceContainerProvide_dataResult = CHOICE(name='dataResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_AssistanceContainerProvide_dataResult_simulationResult = INT(name='simulationResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AssistanceContainerProvide_dataResult_simulationResult._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5000)], ev=None, er=[])
    __OMA_LPPe_AssistanceContainerProvide_dataResult_data = SEQ(name='data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerData')))
    _OMA_LPPe_AssistanceContainerProvide_dataResult._cont = ASN1Dict([
        ('simulationResult', __OMA_LPPe_AssistanceContainerProvide_dataResult_simulationResult),
        ('data', __OMA_LPPe_AssistanceContainerProvide_dataResult_data),
        ])
    _OMA_LPPe_AssistanceContainerProvide_dataResult._ext = []
    _OMA_LPPe_AssistanceContainerProvide_errorCode = SEQ(name='errorCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerProvideError')), opt=True)
    OMA_LPPe_AssistanceContainerProvide._cont = ASN1Dict([
        ('dataIdentifier', _OMA_LPPe_AssistanceContainerProvide_dataIdentifier),
        ('checkOrUpdateOrError', _OMA_LPPe_AssistanceContainerProvide_checkOrUpdateOrError),
        ('dataResult', _OMA_LPPe_AssistanceContainerProvide_dataResult),
        ('errorCode', _OMA_LPPe_AssistanceContainerProvide_errorCode),
        ])
    OMA_LPPe_AssistanceContainerProvide._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerData >-----#
    OMA_LPPe_AssistanceContainerData = SEQ(name='OMA-LPPe-AssistanceContainerData', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerData_dataSerialNumber = SEQ(name='dataSerialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainer-DataSerialNumber')), opt=True)
    _OMA_LPPe_AssistanceContainerData_data = OCT_STR(name='data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AssistanceContainerData_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')), opt=True)
    _OMA_LPPe_AssistanceContainerData_validityArea = SEQ(name='validityArea', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')), opt=True)
    OMA_LPPe_AssistanceContainerData._cont = ASN1Dict([
        ('dataSerialNumber', _OMA_LPPe_AssistanceContainerData_dataSerialNumber),
        ('data', _OMA_LPPe_AssistanceContainerData_data),
        ('validityPeriod', _OMA_LPPe_AssistanceContainerData_validityPeriod),
        ('validityArea', _OMA_LPPe_AssistanceContainerData_validityArea),
        ])
    OMA_LPPe_AssistanceContainerData._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerProvideError >-----#
    OMA_LPPe_AssistanceContainerProvideError = SEQ(name='OMA-LPPe-AssistanceContainerProvideError', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerProvideError_serverError = ENUM(name='serverError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AssistanceContainerProvideError_serverError._cont = ASN1Dict([('assistanceContainerUnknownDataIdentifier', 0), ('assistanceContainerUnknownDataSerialNumber', 1), ('assistanceContainerDataTemporarilyUnavailable', 2), ('assistanceContainerDataNoLongerSupported', 3), ('assistanceContainerVendorOrOperatorNotSupported', 4)])
    _OMA_LPPe_AssistanceContainerProvideError_serverError._ext = []
    OMA_LPPe_AssistanceContainerProvideError._cont = ASN1Dict([
        ('serverError', _OMA_LPPe_AssistanceContainerProvideError_serverError),
        ])
    OMA_LPPe_AssistanceContainerProvideError._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerRequestList >-----#
    OMA_LPPe_AssistanceContainerRequestList = SEQ_OF(name='OMA-LPPe-AssistanceContainerRequestList', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerRequest')))
    OMA_LPPe_AssistanceContainerRequestList._cont = _OMA_LPPe_AssistanceContainerRequestList__item_
    OMA_LPPe_AssistanceContainerRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AssistanceContainerRequest >-----#
    OMA_LPPe_AssistanceContainerRequest = SEQ(name='OMA-LPPe-AssistanceContainerRequest', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerRequest_dataIdentifier = SEQ(name='dataIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorAssistanceDataIdentifier')))
    _OMA_LPPe_AssistanceContainerRequest_simulatedReq = BOOL(name='simulatedReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AssistanceContainerRequest_checkOrUpdateReq = SEQ(name='checkOrUpdateReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerCheckOrUpdateReq')), opt=True)
    _OMA_LPPe_AssistanceContainerRequest_validityTimeRequest = SEQ(name='validityTimeRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')), opt=True)
    _OMA_LPPe_AssistanceContainerRequest_proprietaryRequestParameters = OCT_STR(name='proprietaryRequestParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_AssistanceContainerRequest._cont = ASN1Dict([
        ('dataIdentifier', _OMA_LPPe_AssistanceContainerRequest_dataIdentifier),
        ('simulatedReq', _OMA_LPPe_AssistanceContainerRequest_simulatedReq),
        ('checkOrUpdateReq', _OMA_LPPe_AssistanceContainerRequest_checkOrUpdateReq),
        ('validityTimeRequest', _OMA_LPPe_AssistanceContainerRequest_validityTimeRequest),
        ('proprietaryRequestParameters', _OMA_LPPe_AssistanceContainerRequest_proprietaryRequestParameters),
        ])
    OMA_LPPe_AssistanceContainerRequest._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerCheckOrUpdateReq >-----#
    OMA_LPPe_AssistanceContainerCheckOrUpdateReq = SEQ(name='OMA-LPPe-AssistanceContainerCheckOrUpdateReq', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_dataSerialNumber = SEQ(name='dataSerialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainer-DataSerialNumber')))
    _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_checkLatest = ENUM(name='checkLatest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_checkLatest._cont = ASN1Dict([('returnLatestIfCurrentNotLatest', 0), ('returnUpdateOnlyIfCurrentInvalid', 1)])
    _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_checkLatest._ext = []
    OMA_LPPe_AssistanceContainerCheckOrUpdateReq._cont = ASN1Dict([
        ('dataSerialNumber', _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_dataSerialNumber),
        ('checkLatest', _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_checkLatest),
        ])
    OMA_LPPe_AssistanceContainerCheckOrUpdateReq._ext = []
    
    #-----< OMA-LPPe-CellLocalIdGERAN >-----#
    OMA_LPPe_CellLocalIdGERAN = SEQ(name='OMA-LPPe-CellLocalIdGERAN', mode=MODE_TYPE)
    _OMA_LPPe_CellLocalIdGERAN_locationAreaCode = BIT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CellLocalIdGERAN_locationAreaCode._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _OMA_LPPe_CellLocalIdGERAN_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CellLocalIdGERAN_cellIdentity._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    OMA_LPPe_CellLocalIdGERAN._cont = ASN1Dict([
        ('locationAreaCode', _OMA_LPPe_CellLocalIdGERAN_locationAreaCode),
        ('cellIdentity', _OMA_LPPe_CellLocalIdGERAN_cellIdentity),
        ])
    OMA_LPPe_CellLocalIdGERAN._ext = []
    
    #-----< OMA-LPPe-CellNonUniqueIDGERAN >-----#
    OMA_LPPe_CellNonUniqueIDGERAN = SEQ(name='OMA-LPPe-CellNonUniqueIDGERAN', mode=MODE_TYPE)
    _OMA_LPPe_CellNonUniqueIDGERAN_bsic = INT(name='bsic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CellNonUniqueIDGERAN_bsic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_CellNonUniqueIDGERAN_bcch = INT(name='bcch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CellNonUniqueIDGERAN_bcch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    OMA_LPPe_CellNonUniqueIDGERAN._cont = ASN1Dict([
        ('bsic', _OMA_LPPe_CellNonUniqueIDGERAN_bsic),
        ('bcch', _OMA_LPPe_CellNonUniqueIDGERAN_bcch),
        ])
    OMA_LPPe_CellNonUniqueIDGERAN._ext = []
    
    #-----< OMA-LPPe-CharArray >-----#
    OMA_LPPe_CharArray = STR_VIS(name='OMA-LPPe-CharArray', mode=MODE_TYPE)
    OMA_LPPe_CharArray._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=None, er=[])
    OMA_LPPe_CharArray._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    
    #-----< OMA-LPPe-CivicLocation >-----#
    OMA_LPPe_CivicLocation = SEQ(name='OMA-LPPe-CivicLocation', mode=MODE_TYPE)
    _OMA_LPPe_CivicLocation_countryCode = OCT_STR(name='countryCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CivicLocation_countryCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _OMA_LPPe_CivicLocation_civicAddressElementList = SEQ_OF(name='civicAddressElementList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CivicAddressElementList')))
    OMA_LPPe_CivicLocation._cont = ASN1Dict([
        ('countryCode', _OMA_LPPe_CivicLocation_countryCode),
        ('civicAddressElementList', _OMA_LPPe_CivicLocation_civicAddressElementList),
        ])
    OMA_LPPe_CivicLocation._ext = []
    
    #-----< OMA-LPPe-CivicAddressElementList >-----#
    OMA_LPPe_CivicAddressElementList = SEQ_OF(name='OMA-LPPe-CivicAddressElementList', mode=MODE_TYPE)
    _OMA_LPPe_CivicAddressElementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CivicAddressElement')))
    OMA_LPPe_CivicAddressElementList._cont = _OMA_LPPe_CivicAddressElementList__item_
    OMA_LPPe_CivicAddressElementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< OMA-LPPe-CivicAddressElement >-----#
    OMA_LPPe_CivicAddressElement = SEQ(name='OMA-LPPe-CivicAddressElement', mode=MODE_TYPE)
    _OMA_LPPe_CivicAddressElement_caType = INT(name='caType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CivicAddressElement_caType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _OMA_LPPe_CivicAddressElement_caValue = OCT_STR(name='caValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CivicAddressElement_caValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    OMA_LPPe_CivicAddressElement._cont = ASN1Dict([
        ('caType', _OMA_LPPe_CivicAddressElement_caType),
        ('caValue', _OMA_LPPe_CivicAddressElement_caValue),
        ])
    OMA_LPPe_CivicAddressElement._ext = []
    
    #-----< OMA-LPPe-Duration >-----#
    OMA_LPPe_Duration = SEQ(name='OMA-LPPe-Duration', mode=MODE_TYPE)
    _OMA_LPPe_Duration_duration = INT(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_Duration_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _OMA_LPPe_Duration_durationLSB = INT(name='durationLSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_Duration_durationLSB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=89)], ev=None, er=[])
    OMA_LPPe_Duration._cont = ASN1Dict([
        ('duration', _OMA_LPPe_Duration_duration),
        ('durationLSB', _OMA_LPPe_Duration_durationLSB),
        ])
    OMA_LPPe_Duration._ext = []
    
    #-----< OMA-LPPe-FixedAccessTypes >-----#
    OMA_LPPe_FixedAccessTypes = BIT_STR(name='OMA-LPPe-FixedAccessTypes', mode=MODE_TYPE)
    OMA_LPPe_FixedAccessTypes._cont = ASN1Dict([('cable', 0), ('dsl', 1), ('lan', 2), ('pstn', 3), ('other', 4)])
    OMA_LPPe_FixedAccessTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-ver1-1-GroundMorphologyModel >-----#
    OMA_LPPe_ver1_1_GroundMorphologyModel = SEQ(name='OMA-LPPe-ver1-1-GroundMorphologyModel', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_GroundMorphologyModel_altitudeModel = SEQ(name='altitudeModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AltitudeModel')), opt=True)
    _OMA_LPPe_ver1_1_GroundMorphologyModel_buildingsProfileModel = SEQ(name='buildingsProfileModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BuildingsHeightModel')), opt=True)
    OMA_LPPe_ver1_1_GroundMorphologyModel._cont = ASN1Dict([
        ('altitudeModel', _OMA_LPPe_ver1_1_GroundMorphologyModel_altitudeModel),
        ('buildingsProfileModel', _OMA_LPPe_ver1_1_GroundMorphologyModel_buildingsProfileModel),
        ])
    OMA_LPPe_ver1_1_GroundMorphologyModel._ext = []
    
    #-----< OMA-LPPe-ver1-1-AltitudeModel >-----#
    OMA_LPPe_ver1_1_AltitudeModel = SEQ(name='OMA-LPPe-ver1-1-AltitudeModel', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_AltitudeModel_northWestCorner = SEQ(name='northWestCorner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')))
    _OMA_LPPe_ver1_1_AltitudeModel_northwestCornerAltitude = INT(name='northwestCornerAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AltitudeModel_northwestCornerAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-500, ub=9000)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AltitudeModel_nrows = INT(name='nrows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AltitudeModel_nrows._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=1012)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AltitudeModel_ncols = INT(name='ncols', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AltitudeModel_ncols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=1012)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AltitudeModel_spanX = INT(name='spanX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AltitudeModel_spanX._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=14)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AltitudeModel_spanY = INT(name='spanY', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AltitudeModel_spanY._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=14)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AltitudeModel_deltaAltUnits = INT(name='deltaAltUnits', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AltitudeModel_deltaAltUnits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid = SEQ_OF(name='altitudeGrid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'DeltaAltitudes')))
    _OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid._cont = __OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid__item_
    _OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10000)], ev=None, er=[])
    OMA_LPPe_ver1_1_AltitudeModel._cont = ASN1Dict([
        ('northWestCorner', _OMA_LPPe_ver1_1_AltitudeModel_northWestCorner),
        ('northwestCornerAltitude', _OMA_LPPe_ver1_1_AltitudeModel_northwestCornerAltitude),
        ('nrows', _OMA_LPPe_ver1_1_AltitudeModel_nrows),
        ('ncols', _OMA_LPPe_ver1_1_AltitudeModel_ncols),
        ('spanX', _OMA_LPPe_ver1_1_AltitudeModel_spanX),
        ('spanY', _OMA_LPPe_ver1_1_AltitudeModel_spanY),
        ('deltaAltUnits', _OMA_LPPe_ver1_1_AltitudeModel_deltaAltUnits),
        ('altitudeGrid', _OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid),
        ])
    OMA_LPPe_ver1_1_AltitudeModel._ext = []
    
    #-----< OMA-LPPe-ver1-1-BuildingsHeightModel >-----#
    OMA_LPPe_ver1_1_BuildingsHeightModel = SEQ(name='OMA-LPPe-ver1-1-BuildingsHeightModel', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BuildingsHeightModel_northWestCorner = SEQ(name='northWestCorner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_northwestCornerHeigth = INT(name='northwestCornerHeigth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_northwestCornerHeigth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BuildingsHeightModel_nrows = INT(name='nrows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_nrows._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=1012)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BuildingsHeightModel_ncols = INT(name='ncols', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_ncols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=1012)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BuildingsHeightModel_spanX = INT(name='spanX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_spanX._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=14)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BuildingsHeightModel_spanY = INT(name='spanY', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_spanY._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=14)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BuildingsHeightModel_deltaHeigthUnits = INT(name='deltaHeigthUnits', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_deltaHeigthUnits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid = SEQ_OF(name='buildingsHeigthGrid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'DeltaHeight')))
    _OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid._cont = __OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid__item_
    _OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10000)], ev=None, er=[])
    OMA_LPPe_ver1_1_BuildingsHeightModel._cont = ASN1Dict([
        ('northWestCorner', _OMA_LPPe_ver1_1_BuildingsHeightModel_northWestCorner),
        ('northwestCornerHeigth', _OMA_LPPe_ver1_1_BuildingsHeightModel_northwestCornerHeigth),
        ('nrows', _OMA_LPPe_ver1_1_BuildingsHeightModel_nrows),
        ('ncols', _OMA_LPPe_ver1_1_BuildingsHeightModel_ncols),
        ('spanX', _OMA_LPPe_ver1_1_BuildingsHeightModel_spanX),
        ('spanY', _OMA_LPPe_ver1_1_BuildingsHeightModel_spanY),
        ('deltaHeigthUnits', _OMA_LPPe_ver1_1_BuildingsHeightModel_deltaHeigthUnits),
        ('buildingsHeigthGrid', _OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid),
        ])
    OMA_LPPe_ver1_1_BuildingsHeightModel._ext = []
    
    #-----< DeltaAltitudes >-----#
    DeltaAltitudes = SEQ(name='DeltaAltitudes', mode=MODE_TYPE)
    _DeltaAltitudes_deltaAlt = INT(name='deltaAlt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeltaAltitudes_deltaAlt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-15, ub=16)], ev=None, er=[])
    _DeltaAltitudes_numGridPoints = INT(name='numGridPoints', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeltaAltitudes_numGridPoints._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    DeltaAltitudes._cont = ASN1Dict([
        ('deltaAlt', _DeltaAltitudes_deltaAlt),
        ('numGridPoints', _DeltaAltitudes_numGridPoints),
        ])
    DeltaAltitudes._ext = []
    
    #-----< DeltaHeight >-----#
    DeltaHeight = SEQ(name='DeltaHeight', mode=MODE_TYPE)
    _DeltaHeight_deltaHeight = INT(name='deltaHeight', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeltaHeight_deltaHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-15, ub=16)], ev=None, er=[])
    _DeltaHeight_numGridPoints = INT(name='numGridPoints', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeltaHeight_numGridPoints._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    DeltaHeight._cont = ASN1Dict([
        ('deltaHeight', _DeltaHeight_deltaHeight),
        ('numGridPoints', _DeltaHeight_numGridPoints),
        ])
    DeltaHeight._ext = []
    
    #-----< OMA-LPPe-ver1-1-CellGlobalID >-----#
    OMA_LPPe_ver1_1_CellGlobalID = CHOICE(name='OMA-LPPe-ver1-1-CellGlobalID', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_CellGlobalID_eUTRA = SEQ(name='eUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')))
    _OMA_LPPe_ver1_1_CellGlobalID_uTRA = SEQ(name='uTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')))
    _OMA_LPPe_ver1_1_CellGlobalID_gSM = SEQ(name='gSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdGERAN')))
    OMA_LPPe_ver1_1_CellGlobalID._cont = ASN1Dict([
        ('eUTRA', _OMA_LPPe_ver1_1_CellGlobalID_eUTRA),
        ('uTRA', _OMA_LPPe_ver1_1_CellGlobalID_uTRA),
        ('gSM', _OMA_LPPe_ver1_1_CellGlobalID_gSM),
        ])
    OMA_LPPe_ver1_1_CellGlobalID._ext = []
    
    #-----< OMA-LPPe-HighAccuracy3Dposition >-----#
    OMA_LPPe_HighAccuracy3Dposition = SEQ(name='OMA-LPPe-HighAccuracy3Dposition', mode=MODE_TYPE)
    _OMA_LPPe_HighAccuracy3Dposition_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dposition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dposition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_cep = INT(name='cep', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dposition_cep._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semimajor = INT(name='uncertainty-semimajor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semimajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semiminor = INT(name='uncertainty-semiminor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semiminor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_offset_angle = INT(name='offset-angle', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dposition_offset_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_confidenceHorizontal = INT(name='confidenceHorizontal', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dposition_confidenceHorizontal._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dposition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64000, ub=1280000)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_uncertainty_altitude = INT(name='uncertainty-altitude', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dposition_uncertainty_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dposition_confidenceVertical = INT(name='confidenceVertical', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dposition_confidenceVertical._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    OMA_LPPe_HighAccuracy3Dposition._cont = ASN1Dict([
        ('latitude', _OMA_LPPe_HighAccuracy3Dposition_latitude),
        ('longitude', _OMA_LPPe_HighAccuracy3Dposition_longitude),
        ('cep', _OMA_LPPe_HighAccuracy3Dposition_cep),
        ('uncertainty-semimajor', _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semimajor),
        ('uncertainty-semiminor', _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semiminor),
        ('offset-angle', _OMA_LPPe_HighAccuracy3Dposition_offset_angle),
        ('confidenceHorizontal', _OMA_LPPe_HighAccuracy3Dposition_confidenceHorizontal),
        ('altitude', _OMA_LPPe_HighAccuracy3Dposition_altitude),
        ('uncertainty-altitude', _OMA_LPPe_HighAccuracy3Dposition_uncertainty_altitude),
        ('confidenceVertical', _OMA_LPPe_HighAccuracy3Dposition_confidenceVertical),
        ])
    OMA_LPPe_HighAccuracy3Dposition._ext = []
    
    #-----< OMA-LPPe-HighAccuracy3Dvelocity >-----#
    OMA_LPPe_HighAccuracy3Dvelocity = SEQ(name='OMA-LPPe-HighAccuracy3Dvelocity', mode=MODE_TYPE)
    _OMA_LPPe_HighAccuracy3Dvelocity_enu_origin = SEQ(name='enu-origin', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracy3Dposition')), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_east_component = INT(name='east-component', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dvelocity_east_component._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_east = NULL(name='negative-sign-east', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_north_component = INT(name='north-component', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dvelocity_north_component._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_north = NULL(name='negative-sign-north', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_up_component = INT(name='up-component', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dvelocity_up_component._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_up = NULL(name='negative-sign-up', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_cep = INT(name='cep', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_cep._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semimajor = INT(name='uncertainty-semimajor', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semimajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semiminor = INT(name='uncertainty-semiminor', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semiminor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_offset_angle = INT(name='offset-angle', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_offset_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_confidenceHorizontal = INT(name='confidenceHorizontal', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_confidenceHorizontal._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_up_component = INT(name='uncertainty-up-component', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_up_component._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HighAccuracy3Dvelocity_confidenceUp = INT(name='confidenceUp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HighAccuracy3Dvelocity_confidenceUp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    OMA_LPPe_HighAccuracy3Dvelocity._cont = ASN1Dict([
        ('enu-origin', _OMA_LPPe_HighAccuracy3Dvelocity_enu_origin),
        ('east-component', _OMA_LPPe_HighAccuracy3Dvelocity_east_component),
        ('negative-sign-east', _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_east),
        ('north-component', _OMA_LPPe_HighAccuracy3Dvelocity_north_component),
        ('negative-sign-north', _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_north),
        ('up-component', _OMA_LPPe_HighAccuracy3Dvelocity_up_component),
        ('negative-sign-up', _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_up),
        ('cep', _OMA_LPPe_HighAccuracy3Dvelocity_cep),
        ('uncertainty-semimajor', _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semimajor),
        ('uncertainty-semiminor', _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semiminor),
        ('offset-angle', _OMA_LPPe_HighAccuracy3Dvelocity_offset_angle),
        ('confidenceHorizontal', _OMA_LPPe_HighAccuracy3Dvelocity_confidenceHorizontal),
        ('uncertainty-up-component', _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_up_component),
        ('confidenceUp', _OMA_LPPe_HighAccuracy3Dvelocity_confidenceUp),
        ])
    OMA_LPPe_HighAccuracy3Dvelocity._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainerID >-----#
    OMA_LPPe_LocationInformationContainerID = SEQ(name='OMA-LPPe-LocationInformationContainerID', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerID_containerID = INT(name='containerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_LocationInformationContainerID_containerID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OMA_LPPe_LocationInformationContainerID._cont = ASN1Dict([
        ('containerID', _OMA_LPPe_LocationInformationContainerID_containerID),
        ])
    OMA_LPPe_LocationInformationContainerID._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainer >-----#
    OMA_LPPe_LocationInformationContainer = SEQ(name='OMA-LPPe-LocationInformationContainer', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainer_vendorOrOperatorID = CHOICE(name='vendorOrOperatorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_LocationInformationContainer_locationInformationContainerDataList = SEQ_OF(name='locationInformationContainerDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerDataList')))
    OMA_LPPe_LocationInformationContainer._cont = ASN1Dict([
        ('vendorOrOperatorID', _OMA_LPPe_LocationInformationContainer_vendorOrOperatorID),
        ('locationInformationContainerDataList', _OMA_LPPe_LocationInformationContainer_locationInformationContainerDataList),
        ])
    OMA_LPPe_LocationInformationContainer._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainerDataList >-----#
    OMA_LPPe_LocationInformationContainerDataList = SEQ_OF(name='OMA-LPPe-LocationInformationContainerDataList', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerData')))
    OMA_LPPe_LocationInformationContainerDataList._cont = _OMA_LPPe_LocationInformationContainerDataList__item_
    OMA_LPPe_LocationInformationContainerDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< OMA-LPPe-LocationInformationContainerData >-----#
    OMA_LPPe_LocationInformationContainerData = SEQ(name='OMA-LPPe-LocationInformationContainerData', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerData_containerID = SEQ(name='containerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerID')))
    _OMA_LPPe_LocationInformationContainerData_containerData = OCT_STR(name='containerData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_LocationInformationContainerData._cont = ASN1Dict([
        ('containerID', _OMA_LPPe_LocationInformationContainerData_containerID),
        ('containerData', _OMA_LPPe_LocationInformationContainerData_containerData),
        ])
    OMA_LPPe_LocationInformationContainerData._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainerRequest >-----#
    OMA_LPPe_LocationInformationContainerRequest = SEQ(name='OMA-LPPe-LocationInformationContainerRequest', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerRequest_vendorOrOperatorID = CHOICE(name='vendorOrOperatorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_LocationInformationContainerRequest_locationInformationContainerRequestList = SEQ_OF(name='locationInformationContainerRequestList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerRequestList')))
    OMA_LPPe_LocationInformationContainerRequest._cont = ASN1Dict([
        ('vendorOrOperatorID', _OMA_LPPe_LocationInformationContainerRequest_vendorOrOperatorID),
        ('locationInformationContainerRequestList', _OMA_LPPe_LocationInformationContainerRequest_locationInformationContainerRequestList),
        ])
    OMA_LPPe_LocationInformationContainerRequest._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainerRequestList >-----#
    OMA_LPPe_LocationInformationContainerRequestList = SEQ_OF(name='OMA-LPPe-LocationInformationContainerRequestList', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerRequestItem')))
    OMA_LPPe_LocationInformationContainerRequestList._cont = _OMA_LPPe_LocationInformationContainerRequestList__item_
    OMA_LPPe_LocationInformationContainerRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxLocationInformationContainerDataList >-----#
    maxLocationInformationContainerDataList = INT(name='maxLocationInformationContainerDataList', mode=MODE_VALUE)
    maxLocationInformationContainerDataList._val = 10
    
    #-----< OMA-LPPe-LocationInformationContainerRequestItem >-----#
    OMA_LPPe_LocationInformationContainerRequestItem = SEQ(name='OMA-LPPe-LocationInformationContainerRequestItem', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerRequestItem_containerID = SEQ(name='containerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerID')))
    _OMA_LPPe_LocationInformationContainerRequestItem_additionalInformation = OCT_STR(name='additionalInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_LocationInformationContainerRequestItem._cont = ASN1Dict([
        ('containerID', _OMA_LPPe_LocationInformationContainerRequestItem_containerID),
        ('additionalInformation', _OMA_LPPe_LocationInformationContainerRequestItem_additionalInformation),
        ])
    OMA_LPPe_LocationInformationContainerRequestItem._ext = []
    
    #-----< OMA-LPPe-MapDataReference >-----#
    OMA_LPPe_MapDataReference = SEQ(name='OMA-LPPe-MapDataReference', mode=MODE_TYPE)
    _OMA_LPPe_MapDataReference_dataID = SEQ(name='dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerID')))
    _OMA_LPPe_MapDataReference_mapReference = OCT_STR(name='mapReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_MapDataReference_mapReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_MapDataReference_mapSize = INT(name='mapSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_MapDataReference_mapSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=None, er=[])
    OMA_LPPe_MapDataReference._cont = ASN1Dict([
        ('dataID', _OMA_LPPe_MapDataReference_dataID),
        ('mapReference', _OMA_LPPe_MapDataReference_mapReference),
        ('mapSize', _OMA_LPPe_MapDataReference_mapSize),
        ])
    OMA_LPPe_MapDataReference._ext = []
    
    #-----< OMA-LPPe-Orientation >-----#
    OMA_LPPe_Orientation = CHOICE(name='OMA-LPPe-Orientation', mode=MODE_TYPE)
    _OMA_LPPe_Orientation_eulerAngles = SEQ(name='eulerAngles', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_Orientation_eulerAngles_alpha = INT(name='alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_Orientation_eulerAngles_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    __OMA_LPPe_Orientation_eulerAngles_beta = INT(name='beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_Orientation_eulerAngles_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    __OMA_LPPe_Orientation_eulerAngles_gamma = INT(name='gamma', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_Orientation_eulerAngles_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _OMA_LPPe_Orientation_eulerAngles._cont = ASN1Dict([
        ('alpha', __OMA_LPPe_Orientation_eulerAngles_alpha),
        ('beta', __OMA_LPPe_Orientation_eulerAngles_beta),
        ('gamma', __OMA_LPPe_Orientation_eulerAngles_gamma),
        ])
    _OMA_LPPe_Orientation_eulerAngles._ext = []
    OMA_LPPe_Orientation._cont = ASN1Dict([
        ('eulerAngles', _OMA_LPPe_Orientation_eulerAngles),
        ])
    OMA_LPPe_Orientation._ext = []
    
    #-----< OMA-LPPe-ReferencePoint >-----#
    OMA_LPPe_ReferencePoint = SEQ(name='OMA-LPPe-ReferencePoint', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePoint_referencePointUniqueID = SEQ(name='referencePointUniqueID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointUniqueID')), opt=True)
    _OMA_LPPe_ReferencePoint_referencePointGeographicLocation = CHOICE(name='referencePointGeographicLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_location3D = SEQ(name='location3D', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitude')))
    __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_location3DwithUncertainty = SEQ(name='location3DwithUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')))
    __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_locationwithhighaccuracy = SEQ(name='locationwithhighaccuracy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracy3Dposition')))
    _OMA_LPPe_ReferencePoint_referencePointGeographicLocation._cont = ASN1Dict([
        ('location3D', __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_location3D),
        ('location3DwithUncertainty', __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_location3DwithUncertainty),
        ('locationwithhighaccuracy', __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_locationwithhighaccuracy),
        ])
    _OMA_LPPe_ReferencePoint_referencePointGeographicLocation._ext = []
    _OMA_LPPe_ReferencePoint_referencePointCivicLocation = SEQ(name='referencePointCivicLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CivicLocation')), opt=True)
    _OMA_LPPe_ReferencePoint_referencePointFloorLevel = INT(name='referencePointFloorLevel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ReferencePoint_referencePointFloorLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=235)], ev=None, er=[])
    _OMA_LPPe_ReferencePoint_relatedReferencePoints = SEQ_OF(name='relatedReferencePoints', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ReferencePoint_relatedReferencePoints__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointRelationship')))
    _OMA_LPPe_ReferencePoint_relatedReferencePoints._cont = __OMA_LPPe_ReferencePoint_relatedReferencePoints__item_
    _OMA_LPPe_ReferencePoint_relatedReferencePoints._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ReferencePoint_mapDataInformation = SEQ_OF(name='mapDataInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-MapDataInformation')), opt=True)
    OMA_LPPe_ReferencePoint._cont = ASN1Dict([
        ('referencePointUniqueID', _OMA_LPPe_ReferencePoint_referencePointUniqueID),
        ('referencePointGeographicLocation', _OMA_LPPe_ReferencePoint_referencePointGeographicLocation),
        ('referencePointCivicLocation', _OMA_LPPe_ReferencePoint_referencePointCivicLocation),
        ('referencePointFloorLevel', _OMA_LPPe_ReferencePoint_referencePointFloorLevel),
        ('relatedReferencePoints', _OMA_LPPe_ReferencePoint_relatedReferencePoints),
        ('mapDataInformation', _OMA_LPPe_ReferencePoint_mapDataInformation),
        ])
    OMA_LPPe_ReferencePoint._ext = []
    
    #-----< OMA-LPPe-MapDataInformation >-----#
    OMA_LPPe_MapDataInformation = SEQ_OF(name='OMA-LPPe-MapDataInformation', mode=MODE_TYPE)
    _OMA_LPPe_MapDataInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-MapDataReferenceElement')))
    OMA_LPPe_MapDataInformation._cont = _OMA_LPPe_MapDataInformation__item_
    OMA_LPPe_MapDataInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-MapDataReferenceElement >-----#
    OMA_LPPe_MapDataReferenceElement = SEQ(name='OMA-LPPe-MapDataReferenceElement', mode=MODE_TYPE)
    _OMA_LPPe_MapDataReferenceElement_mapDataUrl = CHOICE(name='mapDataUrl', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataUrl = STR_VIS(name='mapDataUrl', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Uri')))
    __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataUrl._const_alpha = ASN1Set(rv=[':', '/', '?', '#', '[', ']', '@', '!', '$', '&', "'", '(', ')', '*', '+', ',', ';', '=', '-', '.', '_', '~'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataRef = SEQ(name='mapDataRef', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-MapDataReference')))
    _OMA_LPPe_MapDataReferenceElement_mapDataUrl._cont = ASN1Dict([
        ('mapDataUrl', __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataUrl),
        ('mapDataRef', __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataRef),
        ])
    _OMA_LPPe_MapDataReferenceElement_mapDataUrl._ext = None
    _OMA_LPPe_MapDataReferenceElement_mapProvider = CHOICE(name='mapProvider', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_MapDataReferenceElement_mapProvider_sameAsRefPointProvider = NULL(name='sameAsRefPointProvider', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_MapDataReferenceElement_mapProvider_notSameAsRefPointProvider = CHOICE(name='notSameAsRefPointProvider', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_MapDataReferenceElement_mapProvider._cont = ASN1Dict([
        ('sameAsRefPointProvider', __OMA_LPPe_MapDataReferenceElement_mapProvider_sameAsRefPointProvider),
        ('notSameAsRefPointProvider', __OMA_LPPe_MapDataReferenceElement_mapProvider_notSameAsRefPointProvider),
        ])
    _OMA_LPPe_MapDataReferenceElement_mapProvider._ext = []
    _OMA_LPPe_MapDataReferenceElement_mapAssociation = CHOICE(name='mapAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_MapDataReferenceElement_mapAssociation_referencePointUniqueID = NULL(name='referencePointUniqueID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_MapDataReferenceElement_mapAssociation_otherID = STR_VIS(name='otherID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_MapDataReferenceElement_mapAssociation_otherID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __OMA_LPPe_MapDataReferenceElement_mapAssociation_mapOffset = SEQ(name='mapOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    __OMA_LPPe_MapDataReferenceElement_mapAssociation_origin = NULL(name='origin', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_MapDataReferenceElement_mapAssociation._cont = ASN1Dict([
        ('referencePointUniqueID', __OMA_LPPe_MapDataReferenceElement_mapAssociation_referencePointUniqueID),
        ('otherID', __OMA_LPPe_MapDataReferenceElement_mapAssociation_otherID),
        ('mapOffset', __OMA_LPPe_MapDataReferenceElement_mapAssociation_mapOffset),
        ('origin', __OMA_LPPe_MapDataReferenceElement_mapAssociation_origin),
        ])
    _OMA_LPPe_MapDataReferenceElement_mapAssociation._ext = []
    _OMA_LPPe_MapDataReferenceElement_mapHorizontalOrientation = INT(name='mapHorizontalOrientation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_MapDataReferenceElement_mapHorizontalOrientation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    OMA_LPPe_MapDataReferenceElement._cont = ASN1Dict([
        ('mapDataUrl', _OMA_LPPe_MapDataReferenceElement_mapDataUrl),
        ('mapProvider', _OMA_LPPe_MapDataReferenceElement_mapProvider),
        ('mapAssociation', _OMA_LPPe_MapDataReferenceElement_mapAssociation),
        ('mapHorizontalOrientation', _OMA_LPPe_MapDataReferenceElement_mapHorizontalOrientation),
        ])
    OMA_LPPe_MapDataReferenceElement._ext = []
    
    #-----< OMA-LPPe-ReferencePointRelationship >-----#
    OMA_LPPe_ReferencePointRelationship = SEQ(name='OMA-LPPe-ReferencePointRelationship', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointRelationship_referencePointUniqueID = SEQ(name='referencePointUniqueID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointUniqueID')))
    _OMA_LPPe_ReferencePointRelationship_relativeLocation = SEQ(name='relativeLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    OMA_LPPe_ReferencePointRelationship._cont = ASN1Dict([
        ('referencePointUniqueID', _OMA_LPPe_ReferencePointRelationship_referencePointUniqueID),
        ('relativeLocation', _OMA_LPPe_ReferencePointRelationship_relativeLocation),
        ])
    OMA_LPPe_ReferencePointRelationship._ext = []
    
    #-----< OMA-LPPe-ReferencePointUniqueID >-----#
    OMA_LPPe_ReferencePointUniqueID = SEQ(name='OMA-LPPe-ReferencePointUniqueID', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointUniqueID_providerID = CHOICE(name='providerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_ReferencePointUniqueID_providerAssignedID = OCT_STR(name='providerAssignedID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ReferencePointUniqueID_version = INT(name='version', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ReferencePointUniqueID_version._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_ReferencePointUniqueID._cont = ASN1Dict([
        ('providerID', _OMA_LPPe_ReferencePointUniqueID_providerID),
        ('providerAssignedID', _OMA_LPPe_ReferencePointUniqueID_providerAssignedID),
        ('version', _OMA_LPPe_ReferencePointUniqueID_version),
        ])
    OMA_LPPe_ReferencePointUniqueID._ext = []
    
    #-----< OMA-LPPe-RelativeLocation >-----#
    OMA_LPPe_RelativeLocation = SEQ(name='OMA-LPPe-RelativeLocation', mode=MODE_TYPE)
    _OMA_LPPe_RelativeLocation_units = ENUM(name='units', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_RelativeLocation_units._cont = ASN1Dict([('cm', 0), ('dm', 1), ('m10', 2)])
    _OMA_LPPe_RelativeLocation_units._ext = []
    _OMA_LPPe_RelativeLocation_arc_second_units = ENUM(name='arc-second-units', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_RelativeLocation_arc_second_units._cont = ASN1Dict([('as0-0003', 0), ('as0-003', 1), ('as0-03', 2), ('as0-3', 3)])
    _OMA_LPPe_RelativeLocation_arc_second_units._ext = []
    _OMA_LPPe_RelativeLocation_relativeNorth = INT(name='relativeNorth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_RelativeLocation_relativeNorth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-524288, ub=524287)], ev=None, er=[])
    _OMA_LPPe_RelativeLocation_relativeEast = INT(name='relativeEast', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_RelativeLocation_relativeEast._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-524288, ub=524287)], ev=None, er=[])
    _OMA_LPPe_RelativeLocation_relativeAltitude = SEQ(name='relativeAltitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeAltitude')), opt=True)
    _OMA_LPPe_RelativeLocation_horizontalUncertainty = SEQ(name='horizontalUncertainty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HorizontalUncertaintyAndConfidence')), opt=True)
    OMA_LPPe_RelativeLocation._cont = ASN1Dict([
        ('units', _OMA_LPPe_RelativeLocation_units),
        ('arc-second-units', _OMA_LPPe_RelativeLocation_arc_second_units),
        ('relativeNorth', _OMA_LPPe_RelativeLocation_relativeNorth),
        ('relativeEast', _OMA_LPPe_RelativeLocation_relativeEast),
        ('relativeAltitude', _OMA_LPPe_RelativeLocation_relativeAltitude),
        ('horizontalUncertainty', _OMA_LPPe_RelativeLocation_horizontalUncertainty),
        ])
    OMA_LPPe_RelativeLocation._ext = []
    
    #-----< OMA-LPPe-HorizontalUncertaintyAndConfidence >-----#
    OMA_LPPe_HorizontalUncertaintyAndConfidence = SEQ(name='OMA-LPPe-HorizontalUncertaintyAndConfidence', mode=MODE_TYPE)
    _OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape = CHOICE(name='uncShape', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_circle = INT(name='circle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_circle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse = SEQ(name='ellipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semimajor = INT(name='semimajor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semimajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semiminor = INT(name='semiminor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semiminor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_offsetAngle = INT(name='offsetAngle', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_offsetAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse._cont = ASN1Dict([
        ('semimajor', ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semimajor),
        ('semiminor', ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semiminor),
        ('offsetAngle', ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_offsetAngle),
        ])
    __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse._ext = None
    _OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape._cont = ASN1Dict([
        ('circle', __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_circle),
        ('ellipse', __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse),
        ])
    _OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape._ext = []
    _OMA_LPPe_HorizontalUncertaintyAndConfidence_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HorizontalUncertaintyAndConfidence_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    OMA_LPPe_HorizontalUncertaintyAndConfidence._cont = ASN1Dict([
        ('uncShape', _OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape),
        ('confidence', _OMA_LPPe_HorizontalUncertaintyAndConfidence_confidence),
        ])
    OMA_LPPe_HorizontalUncertaintyAndConfidence._ext = []
    
    #-----< OMA-LPPe-RelativeAltitude >-----#
    OMA_LPPe_RelativeAltitude = SEQ(name='OMA-LPPe-RelativeAltitude', mode=MODE_TYPE)
    _OMA_LPPe_RelativeAltitude_geodeticRelativeAltitude = SEQ(name='geodeticRelativeAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-GeodeticRelativeAltitude')), opt=True)
    _OMA_LPPe_RelativeAltitude_civicRelativeAltitude = SEQ(name='civicRelativeAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CivicRelativeAltitude')), opt=True)
    OMA_LPPe_RelativeAltitude._cont = ASN1Dict([
        ('geodeticRelativeAltitude', _OMA_LPPe_RelativeAltitude_geodeticRelativeAltitude),
        ('civicRelativeAltitude', _OMA_LPPe_RelativeAltitude_civicRelativeAltitude),
        ])
    OMA_LPPe_RelativeAltitude._ext = []
    
    #-----< OMA-LPPe-GeodeticRelativeAltitude >-----#
    OMA_LPPe_GeodeticRelativeAltitude = SEQ(name='OMA-LPPe-GeodeticRelativeAltitude', mode=MODE_TYPE)
    _OMA_LPPe_GeodeticRelativeAltitude_geodetic_height_depth = INT(name='geodetic-height-depth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_GeodeticRelativeAltitude_geodetic_height_depth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _OMA_LPPe_GeodeticRelativeAltitude_geodetic_uncertainty_and_confidence = SEQ(name='geodetic-uncertainty-and-confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-GeodeticUncertaintyAndConfidence')), opt=True)
    OMA_LPPe_GeodeticRelativeAltitude._cont = ASN1Dict([
        ('geodetic-height-depth', _OMA_LPPe_GeodeticRelativeAltitude_geodetic_height_depth),
        ('geodetic-uncertainty-and-confidence', _OMA_LPPe_GeodeticRelativeAltitude_geodetic_uncertainty_and_confidence),
        ])
    OMA_LPPe_GeodeticRelativeAltitude._ext = []
    
    #-----< OMA-LPPe-GeodeticUncertaintyAndConfidence >-----#
    OMA_LPPe_GeodeticUncertaintyAndConfidence = SEQ(name='OMA-LPPe-GeodeticUncertaintyAndConfidence', mode=MODE_TYPE)
    _OMA_LPPe_GeodeticUncertaintyAndConfidence_uncertainty = INT(name='uncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_GeodeticUncertaintyAndConfidence_uncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _OMA_LPPe_GeodeticUncertaintyAndConfidence_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_GeodeticUncertaintyAndConfidence_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    OMA_LPPe_GeodeticUncertaintyAndConfidence._cont = ASN1Dict([
        ('uncertainty', _OMA_LPPe_GeodeticUncertaintyAndConfidence_uncertainty),
        ('confidence', _OMA_LPPe_GeodeticUncertaintyAndConfidence_confidence),
        ])
    OMA_LPPe_GeodeticUncertaintyAndConfidence._ext = []
    
    #-----< OMA-LPPe-CivicRelativeAltitude >-----#
    OMA_LPPe_CivicRelativeAltitude = SEQ(name='OMA-LPPe-CivicRelativeAltitude', mode=MODE_TYPE)
    _OMA_LPPe_CivicRelativeAltitude_civic_floors = INT(name='civic-floors', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CivicRelativeAltitude_civic_floors._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-255, ub=256)], ev=None, er=[])
    _OMA_LPPe_CivicRelativeAltitude_civic_uncertainty_and_confidence = SEQ(name='civic-uncertainty-and-confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CivicUncertaintyAndConfidence')), opt=True)
    OMA_LPPe_CivicRelativeAltitude._cont = ASN1Dict([
        ('civic-floors', _OMA_LPPe_CivicRelativeAltitude_civic_floors),
        ('civic-uncertainty-and-confidence', _OMA_LPPe_CivicRelativeAltitude_civic_uncertainty_and_confidence),
        ])
    OMA_LPPe_CivicRelativeAltitude._ext = []
    
    #-----< OMA-LPPe-CivicUncertaintyAndConfidence >-----#
    OMA_LPPe_CivicUncertaintyAndConfidence = SEQ(name='OMA-LPPe-CivicUncertaintyAndConfidence', mode=MODE_TYPE)
    _OMA_LPPe_CivicUncertaintyAndConfidence_uncertainty = INT(name='uncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_CivicUncertaintyAndConfidence_uncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _OMA_LPPe_CivicUncertaintyAndConfidence_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_CivicUncertaintyAndConfidence_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    OMA_LPPe_CivicUncertaintyAndConfidence._cont = ASN1Dict([
        ('uncertainty', _OMA_LPPe_CivicUncertaintyAndConfidence_uncertainty),
        ('confidence', _OMA_LPPe_CivicUncertaintyAndConfidence_confidence),
        ])
    OMA_LPPe_CivicUncertaintyAndConfidence._ext = []
    
    #-----< OMA-LPPe-Session-ID >-----#
    OMA_LPPe_Session_ID = SEQ(name='OMA-LPPe-Session-ID', mode=MODE_TYPE)
    _OMA_LPPe_Session_ID_provider_ID = CHOICE(name='provider-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_Session_ID_server_ID = OCT_STR(name='server-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_Session_ID_server_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_Session_ID_session_ID = OCT_STR(name='session-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_Session_ID_session_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    OMA_LPPe_Session_ID._cont = ASN1Dict([
        ('provider-ID', _OMA_LPPe_Session_ID_provider_ID),
        ('server-ID', _OMA_LPPe_Session_ID_server_ID),
        ('session-ID', _OMA_LPPe_Session_ID_session_ID),
        ])
    OMA_LPPe_Session_ID._ext = []
    
    #-----< OMA-LPPe-Uri >-----#
    OMA_LPPe_Uri = STR_VIS(name='OMA-LPPe-Uri', mode=MODE_TYPE)
    OMA_LPPe_Uri._const_alpha = ASN1Set(rv=[':', '/', '?', '#', '[', ']', '@', '!', '$', '&', "'", '(', ')', '*', '+', ',', ';', '=', '-', '.', '_', '~'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    
    #-----< OMA-LPPe-ver1-1-BroadcastSystemID >-----#
    OMA_LPPe_ver1_1_BroadcastSystemID = CHOICE(name='OMA-LPPe-ver1-1-BroadcastSystemID', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastSystemID_standardSystemID = INT(name='standardSystemID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BroadcastSystemID_standardSystemID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID = SEQ(name='proprietarySystemID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_vendorOrOperator = CHOICE(name='vendorOrOperator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_proprietarySystemID = INT(name='proprietarySystemID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_proprietarySystemID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID._cont = ASN1Dict([
        ('vendorOrOperator', __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_vendorOrOperator),
        ('proprietarySystemID', __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_proprietarySystemID),
        ])
    _OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID._ext = None
    OMA_LPPe_ver1_1_BroadcastSystemID._cont = ASN1Dict([
        ('standardSystemID', _OMA_LPPe_ver1_1_BroadcastSystemID_standardSystemID),
        ('proprietarySystemID', _OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID),
        ])
    OMA_LPPe_ver1_1_BroadcastSystemID._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastADTypes >-----#
    OMA_LPPe_ver1_1_BroadcastADTypes = SEQ(name='OMA-LPPe-ver1-1-BroadcastADTypes', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels = SEQ_OF(name='lppLabels', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-LabelSet')))
    _OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels._cont = __OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels__item_
    _OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels = SEQ_OF(name='lppeLabels', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-LabelSet')))
    _OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels._cont = __OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels__item_
    _OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ver1_1_BroadcastADTypes._cont = ASN1Dict([
        ('lppLabels', _OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels),
        ('lppeLabels', _OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels),
        ])
    OMA_LPPe_ver1_1_BroadcastADTypes._ext = []
    
    #-----< OMA-LPPe-ver1-1-LabelSet >-----#
    OMA_LPPe_ver1_1_LabelSet = SEQ(name='OMA-LPPe-ver1-1-LabelSet', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_LabelSet_level1_element = SEQ(name='level1-element', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_LabelSet_level1_element_level1_element_value = INT(name='level1-element-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_LabelSet_level1_element_level1_element_value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    __OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element = SEQ(name='level2-element', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level2_element_value = INT(name='level2-element-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level2_element_value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element = SEQ(name='level3-element', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element_level3_element_value = INT(name='level3-element-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element_level3_element_value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element._cont = ASN1Dict([
        ('level3-element-value', ____OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element_level3_element_value),
        ])
    ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element._ext = []
    __OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element._cont = ASN1Dict([
        ('level2-element-value', ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level2_element_value),
        ('level3-element', ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element),
        ])
    __OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element._ext = []
    _OMA_LPPe_ver1_1_LabelSet_level1_element._cont = ASN1Dict([
        ('level1-element-value', __OMA_LPPe_ver1_1_LabelSet_level1_element_level1_element_value),
        ('level2-element', __OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element),
        ])
    _OMA_LPPe_ver1_1_LabelSet_level1_element._ext = []
    _OMA_LPPe_ver1_1_LabelSet_lastElements = BIT_STR(name='lastElements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_LabelSet_lastElements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _OMA_LPPe_ver1_1_LabelSet_additionalElements = ENUM(name='additionalElements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ver1_1_LabelSet_additionalElements._cont = ASN1Dict([('none', 0), ('all', 1)])
    _OMA_LPPe_ver1_1_LabelSet_additionalElements._ext = []
    OMA_LPPe_ver1_1_LabelSet._cont = ASN1Dict([
        ('level1-element', _OMA_LPPe_ver1_1_LabelSet_level1_element),
        ('lastElements', _OMA_LPPe_ver1_1_LabelSet_lastElements),
        ('additionalElements', _OMA_LPPe_ver1_1_LabelSet_additionalElements),
        ])
    OMA_LPPe_ver1_1_LabelSet._ext = []
    
    #-----< maxLevel1-element >-----#
    maxLevel1_element = INT(name='maxLevel1-element', mode=MODE_VALUE)
    maxLevel1_element._val = 32
    
    #-----< maxLevel2-element >-----#
    maxLevel2_element = INT(name='maxLevel2-element', mode=MODE_VALUE)
    maxLevel2_element._val = 32
    
    #-----< maxLevel3-element >-----#
    maxLevel3_element = INT(name='maxLevel3-element', mode=MODE_VALUE)
    maxLevel3_element._val = 32
    
    #-----< maxFinal-element >-----#
    maxFinal_element = INT(name='maxFinal-element', mode=MODE_VALUE)
    maxFinal_element._val = 32
    
    #-----< maxLPPLabelSets >-----#
    maxLPPLabelSets = INT(name='maxLPPLabelSets', mode=MODE_VALUE)
    maxLPPLabelSets._val = 64
    
    #-----< maxLPPeLabelSets >-----#
    maxLPPeLabelSets = INT(name='maxLPPeLabelSets', mode=MODE_VALUE)
    maxLPPeLabelSets._val = 128
    
    #-----< OMA-LPPe-ver1-1-AccessNetworkID >-----#
    OMA_LPPe_ver1_1_AccessNetworkID = CHOICE(name='OMA-LPPe-ver1-1-AccessNetworkID', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_AccessNetworkID_gSMAccess = SEQ(name='gSMAccess', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-MCC-MNC')))
    _OMA_LPPe_ver1_1_AccessNetworkID_wCDMAAccess = SEQ(name='wCDMAAccess', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-MCC-MNC')))
    _OMA_LPPe_ver1_1_AccessNetworkID_lTEAccess = SEQ(name='lTEAccess', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-MCC-MNC')))
    _OMA_LPPe_ver1_1_AccessNetworkID_wiMaxAccess = SEQ(name='wiMaxAccess', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BSID')))
    _OMA_LPPe_ver1_1_AccessNetworkID_wLANAccess = SEQ(name='wLANAccess', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ID')))
    OMA_LPPe_ver1_1_AccessNetworkID._cont = ASN1Dict([
        ('gSMAccess', _OMA_LPPe_ver1_1_AccessNetworkID_gSMAccess),
        ('wCDMAAccess', _OMA_LPPe_ver1_1_AccessNetworkID_wCDMAAccess),
        ('lTEAccess', _OMA_LPPe_ver1_1_AccessNetworkID_lTEAccess),
        ('wiMaxAccess', _OMA_LPPe_ver1_1_AccessNetworkID_wiMaxAccess),
        ('wLANAccess', _OMA_LPPe_ver1_1_AccessNetworkID_wLANAccess),
        ])
    OMA_LPPe_ver1_1_AccessNetworkID._ext = []
    
    #-----< OMA-LPPe-ver1-1-MCC-MNC >-----#
    OMA_LPPe_ver1_1_MCC_MNC = SEQ(name='OMA-LPPe-ver1-1-MCC-MNC', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_MCC_MNC_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_MCC_MNC_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    __OMA_LPPe_ver1_1_MCC_MNC_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _OMA_LPPe_ver1_1_MCC_MNC_mcc._cont = __OMA_LPPe_ver1_1_MCC_MNC_mcc__item_
    _OMA_LPPe_ver1_1_MCC_MNC_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _OMA_LPPe_ver1_1_MCC_MNC_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_MCC_MNC_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    __OMA_LPPe_ver1_1_MCC_MNC_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _OMA_LPPe_ver1_1_MCC_MNC_mnc._cont = __OMA_LPPe_ver1_1_MCC_MNC_mnc__item_
    _OMA_LPPe_ver1_1_MCC_MNC_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    OMA_LPPe_ver1_1_MCC_MNC._cont = ASN1Dict([
        ('mcc', _OMA_LPPe_ver1_1_MCC_MNC_mcc),
        ('mnc', _OMA_LPPe_ver1_1_MCC_MNC_mnc),
        ])
    OMA_LPPe_ver1_1_MCC_MNC._ext = []
    
    #-----< OMA-LPPe-ver1-1-BSID >-----#
    OMA_LPPe_ver1_1_BSID = SEQ(name='OMA-LPPe-ver1-1-BSID', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BSID_bsID_MSB = BIT_STR(name='bsID-MSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BSID_bsID_MSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _OMA_LPPe_ver1_1_BSID_bsID_LSB = BIT_STR(name='bsID-LSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_BSID_bsID_LSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    OMA_LPPe_ver1_1_BSID._cont = ASN1Dict([
        ('bsID-MSB', _OMA_LPPe_ver1_1_BSID_bsID_MSB),
        ('bsID-LSB', _OMA_LPPe_ver1_1_BSID_bsID_LSB),
        ])
    OMA_LPPe_ver1_1_BSID._ext = []
    
    #-----< OMA-LPPe-ver1-1-AuthenticationSetID >-----#
    OMA_LPPe_ver1_1_AuthenticationSetID = INT(name='OMA-LPPe-ver1-1-AuthenticationSetID', mode=MODE_TYPE)
    OMA_LPPe_ver1_1_AuthenticationSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< OMA-LPPe-ver1-1-AuthenticationSet >-----#
    OMA_LPPe_ver1_1_AuthenticationSet = SEQ(name='OMA-LPPe-ver1-1-AuthenticationSet', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_AuthenticationSet_authenticationSetID = INT(name='authenticationSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AuthenticationSetID')))
    _OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey = SEQ(name='rsaPublicKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_modulus = BIT_STR(name='modulus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_modulus._const_sz = ASN1Set(rv=[2048], rr=[], ev=None, er=[])
    __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_exponent = BIT_STR(name='exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_exponent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=2048)], ev=None, er=[])
    _OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey._cont = ASN1Dict([
        ('modulus', __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_modulus),
        ('exponent', __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_exponent),
        ])
    _OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey._ext = None
    _OMA_LPPe_ver1_1_AuthenticationSet_saltLength = INT(name='saltLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_AuthenticationSet_saltLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    OMA_LPPe_ver1_1_AuthenticationSet._cont = ASN1Dict([
        ('authenticationSetID', _OMA_LPPe_ver1_1_AuthenticationSet_authenticationSetID),
        ('rsaPublicKey', _OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey),
        ('saltLength', _OMA_LPPe_ver1_1_AuthenticationSet_saltLength),
        ])
    OMA_LPPe_ver1_1_AuthenticationSet._ext = []
    
    #-----< OMA-LPPe-ver1-1-CipherSetID >-----#
    OMA_LPPe_ver1_1_CipherSetID = INT(name='OMA-LPPe-ver1-1-CipherSetID', mode=MODE_TYPE)
    OMA_LPPe_ver1_1_CipherSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< OMA-LPPe-ver1-1-CipherSet >-----#
    OMA_LPPe_ver1_1_CipherSet = SEQ(name='OMA-LPPe-ver1-1-CipherSet', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_CipherSet_cipherSetID = INT(name='cipherSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CipherSetID')))
    _OMA_LPPe_ver1_1_CipherSet_cipherKey = BIT_STR(name='cipherKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_CipherSet_cipherKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _OMA_LPPe_ver1_1_CipherSet_c0 = BIT_STR(name='c0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_CipherSet_c0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ver1_1_CipherSet._cont = ASN1Dict([
        ('cipherSetID', _OMA_LPPe_ver1_1_CipherSet_cipherSetID),
        ('cipherKey', _OMA_LPPe_ver1_1_CipherSet_cipherKey),
        ('c0', _OMA_LPPe_ver1_1_CipherSet_c0),
        ])
    OMA_LPPe_ver1_1_CipherSet._ext = []
    
    #-----< OMA-LPPe-ver1-1-ServerID >-----#
    OMA_LPPe_ver1_1_ServerID = SEQ(name='OMA-LPPe-ver1-1-ServerID', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_ServerID_provider_ID = CHOICE(name='provider-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_ver1_1_ServerID_server_ID = OCT_STR(name='server-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_ServerID_server_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    OMA_LPPe_ver1_1_ServerID._cont = ASN1Dict([
        ('provider-ID', _OMA_LPPe_ver1_1_ServerID_provider_ID),
        ('server-ID', _OMA_LPPe_ver1_1_ServerID_server_ID),
        ])
    OMA_LPPe_ver1_1_ServerID._ext = []
    
    #-----< OMA-LPPe-ValidityArea >-----#
    OMA_LPPe_ValidityArea = SEQ(name='OMA-LPPe-ValidityArea', mode=MODE_TYPE)
    _OMA_LPPe_ValidityArea_regionSizeInv = INT(name='regionSizeInv', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ValidityArea_regionSizeInv._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _OMA_LPPe_ValidityArea_areaWidth = INT(name='areaWidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ValidityArea_areaWidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=9180)], ev=None, er=[])
    _OMA_LPPe_ValidityArea_codedLatOfNWCorner = INT(name='codedLatOfNWCorner', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ValidityArea_codedLatOfNWCorner._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4589)], ev=None, er=[])
    _OMA_LPPe_ValidityArea_codedLonOfNWCorner = INT(name='codedLonOfNWCorner', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ValidityArea_codedLonOfNWCorner._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9179)], ev=None, er=[])
    _OMA_LPPe_ValidityArea_rleList = SEQ_OF(name='rleList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RleList')), opt=True)
    OMA_LPPe_ValidityArea._cont = ASN1Dict([
        ('regionSizeInv', _OMA_LPPe_ValidityArea_regionSizeInv),
        ('areaWidth', _OMA_LPPe_ValidityArea_areaWidth),
        ('codedLatOfNWCorner', _OMA_LPPe_ValidityArea_codedLatOfNWCorner),
        ('codedLonOfNWCorner', _OMA_LPPe_ValidityArea_codedLonOfNWCorner),
        ('rleList', _OMA_LPPe_ValidityArea_rleList),
        ])
    OMA_LPPe_ValidityArea._ext = []
    
    #-----< OMA-LPPe-RleList >-----#
    OMA_LPPe_RleList = SEQ_OF(name='OMA-LPPe-RleList', mode=MODE_TYPE)
    _OMA_LPPe_RleList__item_ = INT(name='_item_', mode=MODE_TYPE)
    _OMA_LPPe_RleList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    OMA_LPPe_RleList._cont = _OMA_LPPe_RleList__item_
    OMA_LPPe_RleList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< OMA-LPPe-ValidityPeriod >-----#
    OMA_LPPe_ValidityPeriod = SEQ(name='OMA-LPPe-ValidityPeriod', mode=MODE_TYPE)
    _OMA_LPPe_ValidityPeriod_beginTime = SEQ(name='beginTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    _OMA_LPPe_ValidityPeriod_beginTimeAlt = INT(name='beginTimeAlt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ValidityPeriod_beginTimeAlt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2881)], ev=None, er=[])
    _OMA_LPPe_ValidityPeriod_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ValidityPeriod_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2881)], ev=None, er=[])
    OMA_LPPe_ValidityPeriod._cont = ASN1Dict([
        ('beginTime', _OMA_LPPe_ValidityPeriod_beginTime),
        ('beginTimeAlt', _OMA_LPPe_ValidityPeriod_beginTimeAlt),
        ('duration', _OMA_LPPe_ValidityPeriod_duration),
        ])
    OMA_LPPe_ValidityPeriod._ext = []
    
    #-----< OMA-LPPe-VendorOrOperatorAssistanceDataIdentifier >-----#
    OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier = SEQ(name='OMA-LPPe-VendorOrOperatorAssistanceDataIdentifier', mode=MODE_TYPE)
    _OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier_vendorOrOperatorID = CHOICE(name='vendorOrOperatorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier_assistanceDataID = SEQ(name='assistanceDataID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerID')))
    OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier._cont = ASN1Dict([
        ('vendorOrOperatorID', _OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier_vendorOrOperatorID),
        ('assistanceDataID', _OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier_assistanceDataID),
        ])
    OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier._ext = []
    
    #-----< OMA-LPPe-VendorOrOperatorID >-----#
    OMA_LPPe_VendorOrOperatorID = CHOICE(name='OMA-LPPe-VendorOrOperatorID', mode=MODE_TYPE)
    _OMA_LPPe_VendorOrOperatorID_standard_VendorOrOperatorID = INT(name='standard-VendorOrOperatorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_VendorOrOperatorID_standard_VendorOrOperatorID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _OMA_LPPe_VendorOrOperatorID_nonStandard_VendorOrOperatorID = SEQ(name='nonStandard-VendorOrOperatorID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-NonStandard-VendorOrOperatorID')))
    OMA_LPPe_VendorOrOperatorID._cont = ASN1Dict([
        ('standard-VendorOrOperatorID', _OMA_LPPe_VendorOrOperatorID_standard_VendorOrOperatorID),
        ('nonStandard-VendorOrOperatorID', _OMA_LPPe_VendorOrOperatorID_nonStandard_VendorOrOperatorID),
        ])
    OMA_LPPe_VendorOrOperatorID._ext = []
    
    #-----< OMA-LPPe-NonStandard-VendorOrOperatorID >-----#
    OMA_LPPe_NonStandard_VendorOrOperatorID = SEQ(name='OMA-LPPe-NonStandard-VendorOrOperatorID', mode=MODE_TYPE)
    _OMA_LPPe_NonStandard_VendorOrOperatorID_encodedID = INT(name='encodedID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_NonStandard_VendorOrOperatorID_encodedID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_NonStandard_VendorOrOperatorID_visibleIdentification = STR_VIS(name='visibleIdentification', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CharArray')), opt=True)
    _OMA_LPPe_NonStandard_VendorOrOperatorID_visibleIdentification._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    OMA_LPPe_NonStandard_VendorOrOperatorID._cont = ASN1Dict([
        ('encodedID', _OMA_LPPe_NonStandard_VendorOrOperatorID_encodedID),
        ('visibleIdentification', _OMA_LPPe_NonStandard_VendorOrOperatorID_visibleIdentification),
        ])
    OMA_LPPe_NonStandard_VendorOrOperatorID._ext = []
    
    #-----< OMA-LPPe-WirelessAccessTypes >-----#
    OMA_LPPe_WirelessAccessTypes = BIT_STR(name='OMA-LPPe-WirelessAccessTypes', mode=MODE_TYPE)
    OMA_LPPe_WirelessAccessTypes._cont = ASN1Dict([('gsm', 0), ('utra', 1), ('lte', 2), ('wimax', 3), ('wifi', 4), ('other', 5)])
    OMA_LPPe_WirelessAccessTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-WLAN-AP-ID >-----#
    OMA_LPPe_WLAN_AP_ID = SEQ(name='OMA-LPPe-WLAN-AP-ID', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_ID_apMacAddress = BIT_STR(name='apMacAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_ID_apMacAddress._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    OMA_LPPe_WLAN_AP_ID._cont = ASN1Dict([
        ('apMacAddress', _OMA_LPPe_WLAN_AP_ID_apMacAddress),
        ])
    OMA_LPPe_WLAN_AP_ID._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-Type >-----#
    OMA_LPPe_WLAN_AP_Type = ENUM(name='OMA-LPPe-WLAN-AP-Type', mode=MODE_TYPE)
    OMA_LPPe_WLAN_AP_Type._cont = ASN1Dict([('ieee802-11a', 0), ('ieee802-11b', 1), ('ieee802-11g', 2), ('ieee802-11n', 3), ('ieee802-11ac', 4), ('ieee802-11ad', 5)])
    OMA_LPPe_WLAN_AP_Type._ext = ['ieee802-11ac', 'ieee802-11ad']
    
    #-----< OMA-LPPe-WLAN-AP-Type-List >-----#
    OMA_LPPe_WLAN_AP_Type_List = BIT_STR(name='OMA-LPPe-WLAN-AP-Type-List', mode=MODE_TYPE)
    OMA_LPPe_WLAN_AP_Type_List._cont = ASN1Dict([('ieee802-11a', 0), ('ieee802-11b', 1), ('ieee802-11g', 2), ('ieee802-11n', 3), ('ieee802-11ac', 4), ('ieee802-11ad', 5)])
    OMA_LPPe_WLAN_AP_Type_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-WLANFemtoCoverageArea >-----#
    OMA_LPPe_WLANFemtoCoverageArea = SEQ(name='OMA-LPPe-WLANFemtoCoverageArea', mode=MODE_TYPE)
    _OMA_LPPe_WLANFemtoCoverageArea_truncation = INT(name='truncation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLANFemtoCoverageArea_truncation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLANFemtoCoverageArea_areaType = ENUM(name='areaType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLANFemtoCoverageArea_areaType._cont = ASN1Dict([('gaussian', 0), ('binaryDistribution', 1)])
    _OMA_LPPe_WLANFemtoCoverageArea_areaType._ext = []
    _OMA_LPPe_WLANFemtoCoverageArea_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLANFemtoCoverageArea_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    _OMA_LPPe_WLANFemtoCoverageArea_componentList = SEQ_OF(name='componentList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_WLANFemtoCoverageArea_componentList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLANFemtoCoverageAreaElement')))
    _OMA_LPPe_WLANFemtoCoverageArea_componentList._cont = __OMA_LPPe_WLANFemtoCoverageArea_componentList__item_
    _OMA_LPPe_WLANFemtoCoverageArea_componentList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_WLANFemtoCoverageArea._cont = ASN1Dict([
        ('truncation', _OMA_LPPe_WLANFemtoCoverageArea_truncation),
        ('areaType', _OMA_LPPe_WLANFemtoCoverageArea_areaType),
        ('confidence', _OMA_LPPe_WLANFemtoCoverageArea_confidence),
        ('componentList', _OMA_LPPe_WLANFemtoCoverageArea_componentList),
        ])
    OMA_LPPe_WLANFemtoCoverageArea._ext = []
    
    #-----< OMA-LPPe-WLANFemtoCoverageAreaElement >-----#
    OMA_LPPe_WLANFemtoCoverageAreaElement = SEQ(name='OMA-LPPe-WLANFemtoCoverageAreaElement', mode=MODE_TYPE)
    _OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea = SEQ(name='refPointAndArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referenceLocation = ENUM(name='referenceLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referenceLocation._cont = ASN1Dict([('antenna', 0), ('referencePoint', 1)])
    __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referenceLocation._ext = []
    __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referencePoint = SEQ(name='referencePoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointUniqueID')), opt=True)
    __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_locationAndArea = SEQ(name='locationAndArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    _OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea._cont = ASN1Dict([
        ('referenceLocation', __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referenceLocation),
        ('referencePoint', __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referencePoint),
        ('locationAndArea', __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_locationAndArea),
        ])
    _OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea._ext = []
    _OMA_LPPe_WLANFemtoCoverageAreaElement_type = ENUM(name='type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLANFemtoCoverageAreaElement_type._cont = ASN1Dict([('indoor', 0), ('outdoor', 1), ('mixed', 2)])
    _OMA_LPPe_WLANFemtoCoverageAreaElement_type._ext = []
    _OMA_LPPe_WLANFemtoCoverageAreaElement_weight = INT(name='weight', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLANFemtoCoverageAreaElement_weight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    OMA_LPPe_WLANFemtoCoverageAreaElement._cont = ASN1Dict([
        ('refPointAndArea', _OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea),
        ('type', _OMA_LPPe_WLANFemtoCoverageAreaElement_type),
        ('weight', _OMA_LPPe_WLANFemtoCoverageAreaElement_weight),
        ])
    OMA_LPPe_WLANFemtoCoverageAreaElement._ext = []
    
    #-----< OMA-LPPe-CommonIEsRequestCapabilities >-----#
    OMA_LPPe_CommonIEsRequestCapabilities = SEQ(name='OMA-LPPe-CommonIEsRequestCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsRequestCapabilities_iP_Address_RequestCapabilities = SEQ(name='iP-Address-RequestCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-IP-Address-RequestCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_assistanceContainerSupportReq = SEQ(name='assistanceContainerSupportReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerSupportReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_locationInformationContainerSupportReq = SEQ(name='locationInformationContainerSupportReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerSupportReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_relativeLocationChange_RequestCapabilities = SEQ(name='relativeLocationChange-RequestCapabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocationChange-RequestCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_highAccuracyFormatCapabilitiesReq = SEQ(name='highAccuracyFormatCapabilitiesReq', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracyFormatCapabilitiesReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_segmentedAssistanceData_ReqCapabilities = SEQ(name='segmentedAssistanceData-ReqCapabilities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedAssistanceData-ReqCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_referencePointCapabilitiesReq = SEQ(name='referencePointCapabilitiesReq', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointCapabilitiesReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_scheduledLocation_RequestCapabilities = SEQ(name='scheduledLocation-RequestCapabilities', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ScheduledLocation-RequestCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_accessCapabilitiesReq = SEQ(name='accessCapabilitiesReq', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AccessCapabilitiesReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_segmentedLocationInformation_ReqCapabilities = SEQ(name='segmentedLocationInformation-ReqCapabilities', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedLocationInformation-ReqCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_ver1_1_localCellInformation_ReqCapabilities = SEQ(name='ver1-1-localCellInformation-ReqCapabilities', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-localCellInformation-ReqCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsRequestCapabilities_ver1_1_broadcast_ReqCapabilities = SEQ(name='ver1-1-broadcast-ReqCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-broadcast-ReqCapabilities')), opt=True)
    OMA_LPPe_CommonIEsRequestCapabilities._cont = ASN1Dict([
        ('iP-Address-RequestCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_iP_Address_RequestCapabilities),
        ('assistanceContainerSupportReq', _OMA_LPPe_CommonIEsRequestCapabilities_assistanceContainerSupportReq),
        ('locationInformationContainerSupportReq', _OMA_LPPe_CommonIEsRequestCapabilities_locationInformationContainerSupportReq),
        ('relativeLocationChange-RequestCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_relativeLocationChange_RequestCapabilities),
        ('highAccuracyFormatCapabilitiesReq', _OMA_LPPe_CommonIEsRequestCapabilities_highAccuracyFormatCapabilitiesReq),
        ('segmentedAssistanceData-ReqCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_segmentedAssistanceData_ReqCapabilities),
        ('referencePointCapabilitiesReq', _OMA_LPPe_CommonIEsRequestCapabilities_referencePointCapabilitiesReq),
        ('scheduledLocation-RequestCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_scheduledLocation_RequestCapabilities),
        ('accessCapabilitiesReq', _OMA_LPPe_CommonIEsRequestCapabilities_accessCapabilitiesReq),
        ('segmentedLocationInformation-ReqCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_segmentedLocationInformation_ReqCapabilities),
        ('ver1-1-localCellInformation-ReqCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_ver1_1_localCellInformation_ReqCapabilities),
        ('ver1-1-broadcast-ReqCapabilities', _OMA_LPPe_CommonIEsRequestCapabilities_ver1_1_broadcast_ReqCapabilities),
        ])
    OMA_LPPe_CommonIEsRequestCapabilities._ext = ['ver1-1-localCellInformation-ReqCapabilities', 'ver1-1-broadcast-ReqCapabilities']
    
    #-----< OMA-LPPe-IP-Address-RequestCapabilities >-----#
    OMA_LPPe_IP_Address_RequestCapabilities = SEQ(name='OMA-LPPe-IP-Address-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_IP_Address_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_IP_Address_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerSupportReq >-----#
    OMA_LPPe_AssistanceContainerSupportReq = SEQ(name='OMA-LPPe-AssistanceContainerSupportReq', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerSupportReq_vendorOrOperatorIDList = SEQ_OF(name='vendorOrOperatorIDList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorIDList')), opt=True)
    OMA_LPPe_AssistanceContainerSupportReq._cont = ASN1Dict([
        ('vendorOrOperatorIDList', _OMA_LPPe_AssistanceContainerSupportReq_vendorOrOperatorIDList),
        ])
    OMA_LPPe_AssistanceContainerSupportReq._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainerSupportReq >-----#
    OMA_LPPe_LocationInformationContainerSupportReq = SEQ(name='OMA-LPPe-LocationInformationContainerSupportReq', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerSupportReq_vendorOrOperatorIDList = SEQ_OF(name='vendorOrOperatorIDList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorIDList')), opt=True)
    OMA_LPPe_LocationInformationContainerSupportReq._cont = ASN1Dict([
        ('vendorOrOperatorIDList', _OMA_LPPe_LocationInformationContainerSupportReq_vendorOrOperatorIDList),
        ])
    OMA_LPPe_LocationInformationContainerSupportReq._ext = []
    
    #-----< OMA-LPPe-VendorOrOperatorIDList >-----#
    OMA_LPPe_VendorOrOperatorIDList = SEQ_OF(name='OMA-LPPe-VendorOrOperatorIDList', mode=MODE_TYPE)
    _OMA_LPPe_VendorOrOperatorIDList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    OMA_LPPe_VendorOrOperatorIDList._cont = _OMA_LPPe_VendorOrOperatorIDList__item_
    OMA_LPPe_VendorOrOperatorIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxVendorOrOperatorIDList >-----#
    maxVendorOrOperatorIDList = INT(name='maxVendorOrOperatorIDList', mode=MODE_VALUE)
    maxVendorOrOperatorIDList._val = 32
    
    #-----< OMA-LPPe-RelativeLocationChange-RequestCapabilities >-----#
    OMA_LPPe_RelativeLocationChange_RequestCapabilities = SEQ(name='OMA-LPPe-RelativeLocationChange-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_RelativeLocationChange_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_RelativeLocationChange_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-HighAccuracyFormatCapabilitiesReq >-----#
    OMA_LPPe_HighAccuracyFormatCapabilitiesReq = SEQ(name='OMA-LPPe-HighAccuracyFormatCapabilitiesReq', mode=MODE_TYPE)
    OMA_LPPe_HighAccuracyFormatCapabilitiesReq._cont = ASN1Dict([
        ])
    OMA_LPPe_HighAccuracyFormatCapabilitiesReq._ext = []
    
    #-----< OMA-LPPe-SegmentedAssistanceData-ReqCapabilities >-----#
    OMA_LPPe_SegmentedAssistanceData_ReqCapabilities = SEQ(name='OMA-LPPe-SegmentedAssistanceData-ReqCapabilities', mode=MODE_TYPE)
    OMA_LPPe_SegmentedAssistanceData_ReqCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_SegmentedAssistanceData_ReqCapabilities._ext = []
    
    #-----< OMA-LPPe-ReferencePointCapabilitiesReq >-----#
    OMA_LPPe_ReferencePointCapabilitiesReq = SEQ(name='OMA-LPPe-ReferencePointCapabilitiesReq', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq = SEQ_OF(name='referencePointProviderSupportListReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq._cont = __OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq__item_
    _OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ReferencePointCapabilitiesReq._cont = ASN1Dict([
        ('referencePointProviderSupportListReq', _OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq),
        ])
    OMA_LPPe_ReferencePointCapabilitiesReq._ext = []
    
    #-----< OMA-LPPe-ScheduledLocation-RequestCapabilities >-----#
    OMA_LPPe_ScheduledLocation_RequestCapabilities = SEQ(name='OMA-LPPe-ScheduledLocation-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_ScheduledLocation_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_ScheduledLocation_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-AccessCapabilitiesReq >-----#
    OMA_LPPe_AccessCapabilitiesReq = SEQ(name='OMA-LPPe-AccessCapabilitiesReq', mode=MODE_TYPE)
    OMA_LPPe_AccessCapabilitiesReq._cont = ASN1Dict([
        ])
    OMA_LPPe_AccessCapabilitiesReq._ext = []
    
    #-----< OMA-LPPe-SegmentedLocationInformation-ReqCapabilities >-----#
    OMA_LPPe_SegmentedLocationInformation_ReqCapabilities = SEQ(name='OMA-LPPe-SegmentedLocationInformation-ReqCapabilities', mode=MODE_TYPE)
    OMA_LPPe_SegmentedLocationInformation_ReqCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_SegmentedLocationInformation_ReqCapabilities._ext = []
    
    #-----< OMA-LPPe-ver1-1-localCellInformation-ReqCapabilities >-----#
    OMA_LPPe_ver1_1_localCellInformation_ReqCapabilities = SEQ(name='OMA-LPPe-ver1-1-localCellInformation-ReqCapabilities', mode=MODE_TYPE)
    OMA_LPPe_ver1_1_localCellInformation_ReqCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_ver1_1_localCellInformation_ReqCapabilities._ext = []
    
    #-----< OMA-LPPe-ver1-1-broadcast-ReqCapabilities >-----#
    OMA_LPPe_ver1_1_broadcast_ReqCapabilities = SEQ(name='OMA-LPPe-ver1-1-broadcast-ReqCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems = SEQ_OF(name='broadcastSystems', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastSystemID')))
    _OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems._cont = __OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems__item_
    _OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ver1_1_broadcast_ReqCapabilities._cont = ASN1Dict([
        ('broadcastSystems', _OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems),
        ])
    OMA_LPPe_ver1_1_broadcast_ReqCapabilities._ext = []
    
    #-----< OMA-LPPe-CommonIEsProvideCapabilities >-----#
    OMA_LPPe_CommonIEsProvideCapabilities = SEQ(name='OMA-LPPe-CommonIEsProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsProvideCapabilities_iP_Address_Capabilities = SEQ(name='iP-Address-Capabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-IP-Address-Capabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_assistanceContainerSupport = SEQ_OF(name='assistanceContainerSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerSupport')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_locationInformationContainerSupport = SEQ_OF(name='locationInformationContainerSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerSupport')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_relativeLocationChange_Capabilities = SEQ(name='relativeLocationChange-Capabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocationChange-Capabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_highAccuracyFormatCapabilities = BIT_STR(name='highAccuracyFormatCapabilities', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracyFormatCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_segmentedAssistanceData_ProvideCapabs = SEQ(name='segmentedAssistanceData-ProvideCapabs', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedAssistanceData-ProvideCapabs')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_referencePointCapabilities = SEQ(name='referencePointCapabilities', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_scheduledLocation_Capabilities = SEQ(name='scheduledLocation-Capabilities', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ScheduledLocation-Capabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_accessCapabilities = SEQ(name='accessCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AccessCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_segmentedLocationInformation_ProvideCapabs = SEQ(name='segmentedLocationInformation-ProvideCapabs', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedLocationInformation-ProvideCapabs')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_ver1_1_localCellInformation_ProvideCapabilities = SEQ(name='ver1-1-localCellInformation-ProvideCapabilities', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-localCellInformation-ProvideCapabilities')), opt=True)
    _OMA_LPPe_CommonIEsProvideCapabilities_ver1_1_broadcast_ProvideCapabilities = SEQ_OF(name='ver1-1-broadcast-ProvideCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-broadcast-ProvideCapabilities')), opt=True)
    OMA_LPPe_CommonIEsProvideCapabilities._cont = ASN1Dict([
        ('iP-Address-Capabilities', _OMA_LPPe_CommonIEsProvideCapabilities_iP_Address_Capabilities),
        ('assistanceContainerSupport', _OMA_LPPe_CommonIEsProvideCapabilities_assistanceContainerSupport),
        ('locationInformationContainerSupport', _OMA_LPPe_CommonIEsProvideCapabilities_locationInformationContainerSupport),
        ('relativeLocationChange-Capabilities', _OMA_LPPe_CommonIEsProvideCapabilities_relativeLocationChange_Capabilities),
        ('highAccuracyFormatCapabilities', _OMA_LPPe_CommonIEsProvideCapabilities_highAccuracyFormatCapabilities),
        ('segmentedAssistanceData-ProvideCapabs', _OMA_LPPe_CommonIEsProvideCapabilities_segmentedAssistanceData_ProvideCapabs),
        ('referencePointCapabilities', _OMA_LPPe_CommonIEsProvideCapabilities_referencePointCapabilities),
        ('scheduledLocation-Capabilities', _OMA_LPPe_CommonIEsProvideCapabilities_scheduledLocation_Capabilities),
        ('accessCapabilities', _OMA_LPPe_CommonIEsProvideCapabilities_accessCapabilities),
        ('segmentedLocationInformation-ProvideCapabs', _OMA_LPPe_CommonIEsProvideCapabilities_segmentedLocationInformation_ProvideCapabs),
        ('ver1-1-localCellInformation-ProvideCapabilities', _OMA_LPPe_CommonIEsProvideCapabilities_ver1_1_localCellInformation_ProvideCapabilities),
        ('ver1-1-broadcast-ProvideCapabilities', _OMA_LPPe_CommonIEsProvideCapabilities_ver1_1_broadcast_ProvideCapabilities),
        ])
    OMA_LPPe_CommonIEsProvideCapabilities._ext = ['ver1-1-localCellInformation-ProvideCapabilities', 'ver1-1-broadcast-ProvideCapabilities']
    
    #-----< OMA-LPPe-IP-Address-Capabilities >-----#
    OMA_LPPe_IP_Address_Capabilities = SEQ(name='OMA-LPPe-IP-Address-Capabilities', mode=MODE_TYPE)
    _OMA_LPPe_IP_Address_Capabilities_iP_Address_support = BIT_STR(name='iP-Address-support', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_IP_Address_Capabilities_iP_Address_support._cont = ASN1Dict([('iPv4', 0), ('iPv6', 1), ('nat', 2)])
    _OMA_LPPe_IP_Address_Capabilities_iP_Address_support._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_IP_Address_Capabilities._cont = ASN1Dict([
        ('iP-Address-support', _OMA_LPPe_IP_Address_Capabilities_iP_Address_support),
        ])
    OMA_LPPe_IP_Address_Capabilities._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerSupport >-----#
    OMA_LPPe_AssistanceContainerSupport = SEQ_OF(name='OMA-LPPe-AssistanceContainerSupport', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorAssistanceContainerList')))
    OMA_LPPe_AssistanceContainerSupport._cont = _OMA_LPPe_AssistanceContainerSupport__item_
    OMA_LPPe_AssistanceContainerSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-VendorOrOperatorAssistanceContainerList >-----#
    OMA_LPPe_VendorOrOperatorAssistanceContainerList = SEQ(name='OMA-LPPe-VendorOrOperatorAssistanceContainerList', mode=MODE_TYPE)
    _OMA_LPPe_VendorOrOperatorAssistanceContainerList_vendorOrOperatorID = CHOICE(name='vendorOrOperatorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_VendorOrOperatorAssistanceContainerList_assistanceContainerList = SEQ_OF(name='assistanceContainerList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerList')))
    OMA_LPPe_VendorOrOperatorAssistanceContainerList._cont = ASN1Dict([
        ('vendorOrOperatorID', _OMA_LPPe_VendorOrOperatorAssistanceContainerList_vendorOrOperatorID),
        ('assistanceContainerList', _OMA_LPPe_VendorOrOperatorAssistanceContainerList_assistanceContainerList),
        ])
    OMA_LPPe_VendorOrOperatorAssistanceContainerList._ext = []
    
    #-----< OMA-LPPe-AssistanceContainerList >-----#
    OMA_LPPe_AssistanceContainerList = SEQ_OF(name='OMA-LPPe-AssistanceContainerList', mode=MODE_TYPE)
    _OMA_LPPe_AssistanceContainerList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerID')))
    OMA_LPPe_AssistanceContainerList._cont = _OMA_LPPe_AssistanceContainerList__item_
    OMA_LPPe_AssistanceContainerList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-LocationInformationContainerSupport >-----#
    OMA_LPPe_LocationInformationContainerSupport = SEQ_OF(name='OMA-LPPe-LocationInformationContainerSupport', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorLocationInformationContainerList')))
    OMA_LPPe_LocationInformationContainerSupport._cont = _OMA_LPPe_LocationInformationContainerSupport__item_
    OMA_LPPe_LocationInformationContainerSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-VendorOrOperatorLocationInformationContainerList >-----#
    OMA_LPPe_VendorOrOperatorLocationInformationContainerList = SEQ(name='OMA-LPPe-VendorOrOperatorLocationInformationContainerList', mode=MODE_TYPE)
    _OMA_LPPe_VendorOrOperatorLocationInformationContainerList_vendorOrOperatorID = CHOICE(name='vendorOrOperatorID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_VendorOrOperatorLocationInformationContainerList_locationInformationContainerList = SEQ_OF(name='locationInformationContainerList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerList')))
    OMA_LPPe_VendorOrOperatorLocationInformationContainerList._cont = ASN1Dict([
        ('vendorOrOperatorID', _OMA_LPPe_VendorOrOperatorLocationInformationContainerList_vendorOrOperatorID),
        ('locationInformationContainerList', _OMA_LPPe_VendorOrOperatorLocationInformationContainerList_locationInformationContainerList),
        ])
    OMA_LPPe_VendorOrOperatorLocationInformationContainerList._ext = []
    
    #-----< OMA-LPPe-LocationInformationContainerList >-----#
    OMA_LPPe_LocationInformationContainerList = SEQ_OF(name='OMA-LPPe-LocationInformationContainerList', mode=MODE_TYPE)
    _OMA_LPPe_LocationInformationContainerList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerID')))
    OMA_LPPe_LocationInformationContainerList._cont = _OMA_LPPe_LocationInformationContainerList__item_
    OMA_LPPe_LocationInformationContainerList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< maxLocationInformationContainerList >-----#
    maxLocationInformationContainerList = INT(name='maxLocationInformationContainerList', mode=MODE_VALUE)
    maxLocationInformationContainerList._val = 64
    
    #-----< OMA-LPPe-RelativeLocationChange-Capabilities >-----#
    OMA_LPPe_RelativeLocationChange_Capabilities = SEQ(name='OMA-LPPe-RelativeLocationChange-Capabilities', mode=MODE_TYPE)
    _OMA_LPPe_RelativeLocationChange_Capabilities_numberOfChanges = INT(name='numberOfChanges', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_RelativeLocationChange_Capabilities_numberOfChanges._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    OMA_LPPe_RelativeLocationChange_Capabilities._cont = ASN1Dict([
        ('numberOfChanges', _OMA_LPPe_RelativeLocationChange_Capabilities_numberOfChanges),
        ])
    OMA_LPPe_RelativeLocationChange_Capabilities._ext = []
    
    #-----< OMA-LPPe-HighAccuracyFormatCapabilities >-----#
    OMA_LPPe_HighAccuracyFormatCapabilities = BIT_STR(name='OMA-LPPe-HighAccuracyFormatCapabilities', mode=MODE_TYPE)
    OMA_LPPe_HighAccuracyFormatCapabilities._cont = ASN1Dict([('hAposition', 0), ('hAvelocity', 1)])
    OMA_LPPe_HighAccuracyFormatCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-SegmentedAssistanceData-ProvideCapabs >-----#
    OMA_LPPe_SegmentedAssistanceData_ProvideCapabs = SEQ(name='OMA-LPPe-SegmentedAssistanceData-ProvideCapabs', mode=MODE_TYPE)
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSegments = INT(name='maxSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSegments._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=4096)], ev=None, er=[])
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSize = INT(name='maxSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=None, er=[])
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_minSize = INT(name='minSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_minSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=None, er=[])
    _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_resume = NULL(name='resume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_SegmentedAssistanceData_ProvideCapabs._cont = ASN1Dict([
        ('maxSegments', _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSegments),
        ('maxSize', _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSize),
        ('minSize', _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_minSize),
        ('resume', _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_resume),
        ])
    OMA_LPPe_SegmentedAssistanceData_ProvideCapabs._ext = []
    
    #-----< OMA-LPPe-ReferencePointCapabilities >-----#
    OMA_LPPe_ReferencePointCapabilities = SEQ(name='OMA-LPPe-ReferencePointCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointCapabilities_relativeLocationReportingSupport = BIT_STR(name='relativeLocationReportingSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ReferencePointCapabilities_relativeLocationReportingSupport._cont = ASN1Dict([('geo', 0), ('civic', 1), ('otherProviders', 2)])
    _OMA_LPPe_ReferencePointCapabilities_relativeLocationReportingSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList = SEQ_OF(name='referencePointProviderSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointProviderSupportElement')))
    _OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList._cont = __OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList__item_
    _OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ReferencePointCapabilities._cont = ASN1Dict([
        ('relativeLocationReportingSupport', _OMA_LPPe_ReferencePointCapabilities_relativeLocationReportingSupport),
        ('referencePointProviderSupportList', _OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList),
        ])
    OMA_LPPe_ReferencePointCapabilities._ext = []
    
    #-----< OMA-LPPe-ReferencePointProviderSupportElement >-----#
    OMA_LPPe_ReferencePointProviderSupportElement = SEQ(name='OMA-LPPe-ReferencePointProviderSupportElement', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointProviderSupportElement_referencePointProvider = CHOICE(name='referencePointProvider', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport = SEQ(name='mapDataSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport_mapDataFormat = OCT_STR(name='mapDataFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport._cont = ASN1Dict([
        ('mapDataFormat', __OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport_mapDataFormat),
        ])
    _OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport._ext = []
    OMA_LPPe_ReferencePointProviderSupportElement._cont = ASN1Dict([
        ('referencePointProvider', _OMA_LPPe_ReferencePointProviderSupportElement_referencePointProvider),
        ('mapDataSupport', _OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport),
        ])
    OMA_LPPe_ReferencePointProviderSupportElement._ext = []
    
    #-----< OMA-LPPe-ScheduledLocation-Capabilities >-----#
    OMA_LPPe_ScheduledLocation_Capabilities = SEQ(name='OMA-LPPe-ScheduledLocation-Capabilities', mode=MODE_TYPE)
    _OMA_LPPe_ScheduledLocation_Capabilities_minimumWindow = INT(name='minimumWindow', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ScheduledLocation_Capabilities_minimumWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _OMA_LPPe_ScheduledLocation_Capabilities_gnssTimeReference = SEQ(name='gnssTimeReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID-Bitmap')), opt=True)
    _OMA_LPPe_ScheduledLocation_Capabilities_networkTimeReference = ENUM(name='networkTimeReference', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ScheduledLocation_Capabilities_networkTimeReference._cont = ASN1Dict([('serving', 0), ('servingOrNonServing', 1)])
    _OMA_LPPe_ScheduledLocation_Capabilities_networkTimeReference._ext = []
    OMA_LPPe_ScheduledLocation_Capabilities._cont = ASN1Dict([
        ('minimumWindow', _OMA_LPPe_ScheduledLocation_Capabilities_minimumWindow),
        ('gnssTimeReference', _OMA_LPPe_ScheduledLocation_Capabilities_gnssTimeReference),
        ('networkTimeReference', _OMA_LPPe_ScheduledLocation_Capabilities_networkTimeReference),
        ])
    OMA_LPPe_ScheduledLocation_Capabilities._ext = []
    
    #-----< OMA-LPPe-AccessCapabilities >-----#
    OMA_LPPe_AccessCapabilities = SEQ(name='OMA-LPPe-AccessCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_AccessCapabilities_accessTypeUnknown = NULL(name='accessTypeUnknown', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AccessCapabilities_fixedAccessTypes = BIT_STR(name='fixedAccessTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-FixedAccessTypes')), opt=True)
    _OMA_LPPe_AccessCapabilities_wirelessAccessTypes = BIT_STR(name='wirelessAccessTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WirelessAccessTypes')), opt=True)
    OMA_LPPe_AccessCapabilities._cont = ASN1Dict([
        ('accessTypeUnknown', _OMA_LPPe_AccessCapabilities_accessTypeUnknown),
        ('fixedAccessTypes', _OMA_LPPe_AccessCapabilities_fixedAccessTypes),
        ('wirelessAccessTypes', _OMA_LPPe_AccessCapabilities_wirelessAccessTypes),
        ])
    OMA_LPPe_AccessCapabilities._ext = []
    
    #-----< OMA-LPPe-SegmentedLocationInformation-ProvideCapabs >-----#
    OMA_LPPe_SegmentedLocationInformation_ProvideCapabs = SEQ(name='OMA-LPPe-SegmentedLocationInformation-ProvideCapabs', mode=MODE_TYPE)
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSegments = INT(name='maxSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSegments._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=4096)], ev=None, er=[])
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSize = INT(name='maxSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=None, er=[])
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_minSize = INT(name='minSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_minSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=None, er=[])
    _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_resume = NULL(name='resume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_SegmentedLocationInformation_ProvideCapabs._cont = ASN1Dict([
        ('maxSegments', _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSegments),
        ('maxSize', _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSize),
        ('minSize', _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_minSize),
        ('resume', _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_resume),
        ])
    OMA_LPPe_SegmentedLocationInformation_ProvideCapabs._ext = []
    
    #-----< OMA-LPPe-ver1-1-localCellInformation-ProvideCapabilities >-----#
    OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities = SEQ(name='OMA-LPPe-ver1-1-localCellInformation-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities_localCellInformation_Support = BIT_STR(name='localCellInformation-Support', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities_localCellInformation_Support._cont = ASN1Dict([('gnssTiming', 0), ('networkTiming', 1), ('coverage', 2), ('coordinates', 3), ('frequencyAccuracy', 4)])
    _OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities_localCellInformation_Support._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities._cont = ASN1Dict([
        ('localCellInformation-Support', _OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities_localCellInformation_Support),
        ])
    OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-ver1-1-broadcast-ProvideCapabilities >-----#
    OMA_LPPe_ver1_1_broadcast_ProvideCapabilities = SEQ_OF(name='OMA-LPPe-ver1-1-broadcast-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_broadcast_ProvideCapabilities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastSystem-Capabs')))
    OMA_LPPe_ver1_1_broadcast_ProvideCapabilities._cont = _OMA_LPPe_ver1_1_broadcast_ProvideCapabilities__item_
    OMA_LPPe_ver1_1_broadcast_ProvideCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-ver1-1-BroadcastSystem-Capabs >-----#
    OMA_LPPe_ver1_1_BroadcastSystem_Capabs = SEQ(name='OMA-LPPe-ver1-1-BroadcastSystem-Capabs', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_broadcastSystemID = CHOICE(name='broadcastSystemID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastSystemID')))
    _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_broadcastADTypes = SEQ(name='broadcastADTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastADTypes')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_point2pointAD = SEQ(name='point2pointAD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-point2pointAD')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_ciphering = SEQ(name='ciphering', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-Ciphering')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_authentication = SEQ(name='authentication', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-Authentication')), opt=True)
    OMA_LPPe_ver1_1_BroadcastSystem_Capabs._cont = ASN1Dict([
        ('broadcastSystemID', _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_broadcastSystemID),
        ('broadcastADTypes', _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_broadcastADTypes),
        ('point2pointAD', _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_point2pointAD),
        ('ciphering', _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_ciphering),
        ('authentication', _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_authentication),
        ])
    OMA_LPPe_ver1_1_BroadcastSystem_Capabs._ext = []
    
    #-----< OMA-LPPe-ver1-1-point2pointAD >-----#
    OMA_LPPe_ver1_1_point2pointAD = SEQ(name='OMA-LPPe-ver1-1-point2pointAD', mode=MODE_TYPE)
    OMA_LPPe_ver1_1_point2pointAD._cont = ASN1Dict([
        ])
    OMA_LPPe_ver1_1_point2pointAD._ext = []
    
    #-----< OMA-LPPe-ver1-1-Ciphering >-----#
    OMA_LPPe_ver1_1_Ciphering = SEQ(name='OMA-LPPe-ver1-1-Ciphering', mode=MODE_TYPE)
    OMA_LPPe_ver1_1_Ciphering._cont = ASN1Dict([
        ])
    OMA_LPPe_ver1_1_Ciphering._ext = []
    
    #-----< OMA-LPPe-ver1-1-Authentication >-----#
    OMA_LPPe_ver1_1_Authentication = SEQ(name='OMA-LPPe-ver1-1-Authentication', mode=MODE_TYPE)
    OMA_LPPe_ver1_1_Authentication._cont = ASN1Dict([
        ])
    OMA_LPPe_ver1_1_Authentication._ext = []
    
    #-----< OMA-LPPe-CommonIEsRequestAssistanceData >-----#
    OMA_LPPe_CommonIEsRequestAssistanceData = SEQ(name='OMA-LPPe-CommonIEsRequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsRequestAssistanceData_approximate_location = SEQ(name='approximate-location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_assistanceContainerRequestList = SEQ_OF(name='assistanceContainerRequestList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerRequestList')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_requestPeriodicADwithUpdate = SEQ(name='requestPeriodicADwithUpdate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RequestPeriodicADwithUpdate')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADpreference = ENUM(name='segmentedADpreference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADpreference._cont = ASN1Dict([('useBasic', 0), ('useResume', 1)])
    _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADpreference._ext = []
    _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADResume = SEQ(name='segmentedADResume', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedADResume')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_referencePointAssistanceReq = SEQ(name='referencePointAssistanceReq', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointAssistanceReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_localCellInformationReq = SEQ(name='ver1-1-localCellInformationReq', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-LocalCellInformationReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_BroadcastAssistanceDataReq = SEQ(name='ver1-1-BroadcastAssistanceDataReq', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastAssistanceDataReq')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_AccessNetwork = CHOICE(name='ver1-1-AccessNetwork', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AccessNetworkID')), opt=True)
    _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_groundMorphologyModelReq = SEQ(name='ver1-1-groundMorphologyModelReq', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-GroundMorphologyModelReq')), opt=True)
    OMA_LPPe_CommonIEsRequestAssistanceData._cont = ASN1Dict([
        ('approximate-location', _OMA_LPPe_CommonIEsRequestAssistanceData_approximate_location),
        ('assistanceContainerRequestList', _OMA_LPPe_CommonIEsRequestAssistanceData_assistanceContainerRequestList),
        ('requestPeriodicADwithUpdate', _OMA_LPPe_CommonIEsRequestAssistanceData_requestPeriodicADwithUpdate),
        ('segmentedADpreference', _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADpreference),
        ('segmentedADResume', _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADResume),
        ('referencePointAssistanceReq', _OMA_LPPe_CommonIEsRequestAssistanceData_referencePointAssistanceReq),
        ('ver1-1-localCellInformationReq', _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_localCellInformationReq),
        ('ver1-1-BroadcastAssistanceDataReq', _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_BroadcastAssistanceDataReq),
        ('ver1-1-AccessNetwork', _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_AccessNetwork),
        ('ver1-1-groundMorphologyModelReq', _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_groundMorphologyModelReq),
        ])
    OMA_LPPe_CommonIEsRequestAssistanceData._ext = ['ver1-1-localCellInformationReq', 'ver1-1-BroadcastAssistanceDataReq', 'ver1-1-AccessNetwork', 'ver1-1-groundMorphologyModelReq']
    
    #-----< OMA-LPPe-RequestPeriodicADwithUpdate >-----#
    OMA_LPPe_RequestPeriodicADwithUpdate = SEQ(name='OMA-LPPe-RequestPeriodicADwithUpdate', mode=MODE_TYPE)
    _OMA_LPPe_RequestPeriodicADwithUpdate_periodicAD_session_ID = OCT_STR(name='periodicAD-session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_RequestPeriodicADwithUpdate_periodicAD_session_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_RequestPeriodicADwithUpdate_typeOfADRequest = ENUM(name='typeOfADRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'TypeOfADRequest')))
    OMA_LPPe_RequestPeriodicADwithUpdate._cont = ASN1Dict([
        ('periodicAD-session-ID', _OMA_LPPe_RequestPeriodicADwithUpdate_periodicAD_session_ID),
        ('typeOfADRequest', _OMA_LPPe_RequestPeriodicADwithUpdate_typeOfADRequest),
        ])
    OMA_LPPe_RequestPeriodicADwithUpdate._ext = []
    
    #-----< TypeOfADRequest >-----#
    TypeOfADRequest = ENUM(name='TypeOfADRequest', mode=MODE_TYPE)
    TypeOfADRequest._cont = ASN1Dict([('initialRequest', 0), ('updateAndContinueIfUpdateFails', 1), ('updateAndAbortIfUpdateFails', 2)])
    TypeOfADRequest._ext = []
    
    #-----< OMA-LPPe-SegmentedADResume >-----#
    OMA_LPPe_SegmentedADResume = SEQ(name='OMA-LPPe-SegmentedADResume', mode=MODE_TYPE)
    _OMA_LPPe_SegmentedADResume_segmentedAD_session_ID = SEQ(name='segmentedAD-session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Session-ID')))
    _OMA_LPPe_SegmentedADResume_next_segment_number = INT(name='next-segment-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SegmentedADResume_next_segment_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    OMA_LPPe_SegmentedADResume._cont = ASN1Dict([
        ('segmentedAD-session-ID', _OMA_LPPe_SegmentedADResume_segmentedAD_session_ID),
        ('next-segment-number', _OMA_LPPe_SegmentedADResume_next_segment_number),
        ])
    OMA_LPPe_SegmentedADResume._ext = None
    
    #-----< OMA-LPPe-ReferencePointAssistanceReq >-----#
    OMA_LPPe_ReferencePointAssistanceReq = SEQ(name='OMA-LPPe-ReferencePointAssistanceReq', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointAssistanceReq_referencePointReq = SEQ_OF(name='referencePointReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ReferencePointAssistanceReq_referencePointReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointAssistanceReqElement')))
    _OMA_LPPe_ReferencePointAssistanceReq_referencePointReq._cont = __OMA_LPPe_ReferencePointAssistanceReq_referencePointReq__item_
    _OMA_LPPe_ReferencePointAssistanceReq_referencePointReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ReferencePointAssistanceReq._cont = ASN1Dict([
        ('referencePointReq', _OMA_LPPe_ReferencePointAssistanceReq_referencePointReq),
        ])
    OMA_LPPe_ReferencePointAssistanceReq._ext = []
    
    #-----< OMA-LPPe-ReferencePointAssistanceReqElement >-----#
    OMA_LPPe_ReferencePointAssistanceReqElement = SEQ(name='OMA-LPPe-ReferencePointAssistanceReqElement', mode=MODE_TYPE)
    _OMA_LPPe_ReferencePointAssistanceReqElement_referencePointProvider = CHOICE(name='referencePointProvider', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_ReferencePointAssistanceReqElement_mapDataReq = OCT_STR(name='mapDataReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ReferencePointAssistanceReqElement._cont = ASN1Dict([
        ('referencePointProvider', _OMA_LPPe_ReferencePointAssistanceReqElement_referencePointProvider),
        ('mapDataReq', _OMA_LPPe_ReferencePointAssistanceReqElement_mapDataReq),
        ])
    OMA_LPPe_ReferencePointAssistanceReqElement._ext = []
    
    #-----< OMA-LPPe-ver1-1-GroundMorphologyModelReq >-----#
    OMA_LPPe_ver1_1_GroundMorphologyModelReq = SEQ(name='OMA-LPPe-ver1-1-GroundMorphologyModelReq', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_GroundMorphologyModelReq_modelsReq = BIT_STR(name='modelsReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_GroundMorphologyModelReq_modelsReq._cont = ASN1Dict([('altitude', 0), ('buildings', 1)])
    _OMA_LPPe_ver1_1_GroundMorphologyModelReq_modelsReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam = SEQ(name='refAreaParam', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_northWestCorner = SEQ(name='northWestCorner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')), opt=True)
    __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanX = INT(name='spanX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanX._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=14)], ev=None, er=[])
    __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanY = INT(name='spanY', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanY._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=14)], ev=None, er=[])
    _OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam._cont = ASN1Dict([
        ('northWestCorner', __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_northWestCorner),
        ('spanX', __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanX),
        ('spanY', __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanY),
        ])
    _OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam._ext = []
    OMA_LPPe_ver1_1_GroundMorphologyModelReq._cont = ASN1Dict([
        ('modelsReq', _OMA_LPPe_ver1_1_GroundMorphologyModelReq_modelsReq),
        ('refAreaParam', _OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam),
        ])
    OMA_LPPe_ver1_1_GroundMorphologyModelReq._ext = []
    
    #-----< OMA-LPPe-ver1-1-LocalCellInformationReq >-----#
    OMA_LPPe_ver1_1_LocalCellInformationReq = SEQ(name='OMA-LPPe-ver1-1-LocalCellInformationReq', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellInformationReq = BIT_STR(name='localCellInformationReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellInformationReq._cont = ASN1Dict([('gnssTiming', 0), ('networkTiming', 1), ('coverage', 2), ('coordinates', 3), ('frequencyAccuracy', 4)])
    _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellInformationReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellID = CHOICE(name='localCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CellGlobalID')), opt=True)
    _OMA_LPPe_ver1_1_LocalCellInformationReq_numberOfCells = INT(name='numberOfCells', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ver1_1_LocalCellInformationReq_numberOfCells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    OMA_LPPe_ver1_1_LocalCellInformationReq._cont = ASN1Dict([
        ('localCellInformationReq', _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellInformationReq),
        ('localCellID', _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellID),
        ('numberOfCells', _OMA_LPPe_ver1_1_LocalCellInformationReq_numberOfCells),
        ])
    OMA_LPPe_ver1_1_LocalCellInformationReq._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastAssistanceDataReq >-----#
    OMA_LPPe_ver1_1_BroadcastAssistanceDataReq = SEQ(name='OMA-LPPe-ver1-1-BroadcastAssistanceDataReq', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastAssistanceDataReq_broadcastSystem = SEQ(name='broadcastSystem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastSystem')), opt=True)
    OMA_LPPe_ver1_1_BroadcastAssistanceDataReq._cont = ASN1Dict([
        ('broadcastSystem', _OMA_LPPe_ver1_1_BroadcastAssistanceDataReq_broadcastSystem),
        ])
    OMA_LPPe_ver1_1_BroadcastAssistanceDataReq._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastSystem >-----#
    OMA_LPPe_ver1_1_BroadcastSystem = SEQ(name='OMA-LPPe-ver1-1-BroadcastSystem', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastSystem_broadcastSystemID = CHOICE(name='broadcastSystemID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastSystemID')))
    _OMA_LPPe_ver1_1_BroadcastSystem_cipherSets = SEQ_OF(name='cipherSets', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_BroadcastSystem_cipherSets__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CipherSetID')))
    _OMA_LPPe_ver1_1_BroadcastSystem_cipherSets._cont = __OMA_LPPe_ver1_1_BroadcastSystem_cipherSets__item_
    _OMA_LPPe_ver1_1_BroadcastSystem_cipherSets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets = SEQ_OF(name='authenticationSets', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AuthenticationSetID')))
    _OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets._cont = __OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets__item_
    _OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    OMA_LPPe_ver1_1_BroadcastSystem._cont = ASN1Dict([
        ('broadcastSystemID', _OMA_LPPe_ver1_1_BroadcastSystem_broadcastSystemID),
        ('cipherSets', _OMA_LPPe_ver1_1_BroadcastSystem_cipherSets),
        ('authenticationSets', _OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets),
        ])
    OMA_LPPe_ver1_1_BroadcastSystem._ext = []
    
    #-----< OMA-LPPe-CommonIEsProvideAssistanceData >-----#
    OMA_LPPe_CommonIEsProvideAssistanceData = SEQ(name='OMA-LPPe-CommonIEsProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsProvideAssistanceData_assistanceContainerList = SEQ_OF(name='assistanceContainerList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AssistanceContainerProvideList')), opt=True)
    _OMA_LPPe_CommonIEsProvideAssistanceData_providePeriodicADwithUpdate = SEQ(name='providePeriodicADwithUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ProvidePeriodicADwithUpdate')), opt=True)
    _OMA_LPPe_CommonIEsProvideAssistanceData_segmentedADTransfer = SEQ(name='segmentedADTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedADTransfer')), opt=True)
    _OMA_LPPe_CommonIEsProvideAssistanceData_default_reference_point = SEQ(name='default-reference-point', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_localCellInformation = SEQ(name='ver1-1-localCellInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-LocalCellInformation')), opt=True)
    _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_BroadcastAssistanceData = SEQ(name='ver1-1-BroadcastAssistanceData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastAssistanceData')), opt=True)
    _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_groundMorphologyModel = SEQ(name='ver1-1-groundMorphologyModel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-GroundMorphologyModel')), opt=True)
    OMA_LPPe_CommonIEsProvideAssistanceData._cont = ASN1Dict([
        ('assistanceContainerList', _OMA_LPPe_CommonIEsProvideAssistanceData_assistanceContainerList),
        ('providePeriodicADwithUpdate', _OMA_LPPe_CommonIEsProvideAssistanceData_providePeriodicADwithUpdate),
        ('segmentedADTransfer', _OMA_LPPe_CommonIEsProvideAssistanceData_segmentedADTransfer),
        ('default-reference-point', _OMA_LPPe_CommonIEsProvideAssistanceData_default_reference_point),
        ('ver1-1-localCellInformation', _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_localCellInformation),
        ('ver1-1-BroadcastAssistanceData', _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_BroadcastAssistanceData),
        ('ver1-1-groundMorphologyModel', _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_groundMorphologyModel),
        ])
    OMA_LPPe_CommonIEsProvideAssistanceData._ext = ['ver1-1-localCellInformation', 'ver1-1-BroadcastAssistanceData', 'ver1-1-groundMorphologyModel']
    
    #-----< OMA-LPPe-ProvidePeriodicADwithUpdate >-----#
    OMA_LPPe_ProvidePeriodicADwithUpdate = SEQ(name='OMA-LPPe-ProvidePeriodicADwithUpdate', mode=MODE_TYPE)
    _OMA_LPPe_ProvidePeriodicADwithUpdate_periodicAD_session_ID = OCT_STR(name='periodicAD-session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ProvidePeriodicADwithUpdate_periodicAD_session_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_ProvidePeriodicADwithUpdate_typeOfADProvide = ENUM(name='typeOfADProvide', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-TypeOfADProvide')))
    OMA_LPPe_ProvidePeriodicADwithUpdate._cont = ASN1Dict([
        ('periodicAD-session-ID', _OMA_LPPe_ProvidePeriodicADwithUpdate_periodicAD_session_ID),
        ('typeOfADProvide', _OMA_LPPe_ProvidePeriodicADwithUpdate_typeOfADProvide),
        ])
    OMA_LPPe_ProvidePeriodicADwithUpdate._ext = []
    
    #-----< OMA-LPPe-TypeOfADProvide >-----#
    OMA_LPPe_TypeOfADProvide = ENUM(name='OMA-LPPe-TypeOfADProvide', mode=MODE_TYPE)
    OMA_LPPe_TypeOfADProvide._cont = ASN1Dict([('responseToInitialRequest', 0), ('providePeriodicAD', 1), ('responseToTargetUpdateRequest', 2), ('serverUpdate', 3)])
    OMA_LPPe_TypeOfADProvide._ext = []
    
    #-----< OMA-LPPe-SegmentedADTransfer >-----#
    OMA_LPPe_SegmentedADTransfer = SEQ(name='OMA-LPPe-SegmentedADTransfer', mode=MODE_TYPE)
    _OMA_LPPe_SegmentedADTransfer_segmentedAD_session_ID = SEQ(name='segmentedAD-session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Session-ID')))
    _OMA_LPPe_SegmentedADTransfer_segment_number = INT(name='segment-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SegmentedADTransfer_segment_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    OMA_LPPe_SegmentedADTransfer._cont = ASN1Dict([
        ('segmentedAD-session-ID', _OMA_LPPe_SegmentedADTransfer_segmentedAD_session_ID),
        ('segment-number', _OMA_LPPe_SegmentedADTransfer_segment_number),
        ])
    OMA_LPPe_SegmentedADTransfer._ext = []
    
    #-----< OMA-LPPe-ver1-1-LocalCellInformation >-----#
    OMA_LPPe_ver1_1_LocalCellInformation = SEQ(name='OMA-LPPe-ver1-1-LocalCellInformation', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation = SEQ_OF(name='ver1-1-timingInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ReferenceTime')))
    _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation._cont = __OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation__item_
    _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation = SEQ_OF(name='ver1-1-other-CellInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CellInformation')))
    _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation._cont = __OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation__item_
    _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ver1_1_LocalCellInformation._cont = ASN1Dict([
        ('ver1-1-timingInformation', _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation),
        ('ver1-1-other-CellInformation', _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation),
        ])
    OMA_LPPe_ver1_1_LocalCellInformation._ext = []
    
    #-----< maxCellSets >-----#
    maxCellSets = INT(name='maxCellSets', mode=MODE_VALUE)
    maxCellSets._val = 8
    
    #-----< maxCells >-----#
    maxCells = INT(name='maxCells', mode=MODE_VALUE)
    maxCells._val = 128
    
    #-----< OMA-LPPe-ver1-1-CellInformation >-----#
    OMA_LPPe_ver1_1_CellInformation = SEQ(name='OMA-LPPe-ver1-1-CellInformation', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_CellInformation_cellID = CHOICE(name='cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CellGlobalID')))
    _OMA_LPPe_ver1_1_CellInformation_coverage = CHOICE(name='coverage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_ver1_1_CellInformation_coverage_circle = SEQ(name='circle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-PointWithUncertaintyCircle')))
    __OMA_LPPe_ver1_1_CellInformation_coverage_ellipse = SEQ(name='ellipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithUncertaintyEllipse')))
    __OMA_LPPe_ver1_1_CellInformation_coverage_arc = SEQ(name='arc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidArc')))
    __OMA_LPPe_ver1_1_CellInformation_coverage_polygon = SEQ_OF(name='polygon', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Polygon')))
    _OMA_LPPe_ver1_1_CellInformation_coverage._cont = ASN1Dict([
        ('circle', __OMA_LPPe_ver1_1_CellInformation_coverage_circle),
        ('ellipse', __OMA_LPPe_ver1_1_CellInformation_coverage_ellipse),
        ('arc', __OMA_LPPe_ver1_1_CellInformation_coverage_arc),
        ('polygon', __OMA_LPPe_ver1_1_CellInformation_coverage_polygon),
        ])
    _OMA_LPPe_ver1_1_CellInformation_coverage._ext = []
    _OMA_LPPe_ver1_1_CellInformation_coordinates = SEQ(name='coordinates', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')), opt=True)
    _OMA_LPPe_ver1_1_CellInformation_frequencyAccuracy = INT(name='frequencyAccuracy', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ver1_1_CellInformation_frequencyAccuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    OMA_LPPe_ver1_1_CellInformation._cont = ASN1Dict([
        ('cellID', _OMA_LPPe_ver1_1_CellInformation_cellID),
        ('coverage', _OMA_LPPe_ver1_1_CellInformation_coverage),
        ('coordinates', _OMA_LPPe_ver1_1_CellInformation_coordinates),
        ('frequencyAccuracy', _OMA_LPPe_ver1_1_CellInformation_frequencyAccuracy),
        ])
    OMA_LPPe_ver1_1_CellInformation._ext = []
    
    #-----< OMA-LPPe-ver1-1-BroadcastAssistanceData >-----#
    OMA_LPPe_ver1_1_BroadcastAssistanceData = SEQ(name='OMA-LPPe-ver1-1-BroadcastAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastSystem = CHOICE(name='broadcastSystem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastSystemID')))
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks = SEQ_OF(name='accessNetworks', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AccessNetworkID')))
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks._cont = __OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks__item_
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea = CHOICE(name='coverageArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_circle = SEQ(name='circle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-PointWithUncertaintyCircle')))
    __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_ellipse = SEQ(name='ellipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithUncertaintyEllipse')))
    __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_polygon = SEQ_OF(name='polygon', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Polygon')))
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea._cont = ASN1Dict([
        ('circle', __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_circle),
        ('ellipse', __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_ellipse),
        ('polygon', __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_polygon),
        ])
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea._ext = []
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastADTypes = SEQ(name='broadcastADTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-BroadcastADTypes')), opt=True)
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode = CHOICE(name='broadcastMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode_unencapsulated = NULL(name='unencapsulated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode_encapsulated = SEQ(name='encapsulated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-EncapsulatedMode')))
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode._cont = ASN1Dict([
        ('unencapsulated', __OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode_unencapsulated),
        ('encapsulated', __OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode_encapsulated),
        ])
    _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode._ext = []
    OMA_LPPe_ver1_1_BroadcastAssistanceData._cont = ASN1Dict([
        ('broadcastSystem', _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastSystem),
        ('accessNetworks', _OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks),
        ('coverageArea', _OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea),
        ('broadcastADTypes', _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastADTypes),
        ('broadcastMode', _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode),
        ])
    OMA_LPPe_ver1_1_BroadcastAssistanceData._ext = []
    
    #-----< OMA-LPPe-ver1-1-EncapsulatedMode >-----#
    OMA_LPPe_ver1_1_EncapsulatedMode = SEQ(name='OMA-LPPe-ver1-1-EncapsulatedMode', mode=MODE_TYPE)
    _OMA_LPPe_ver1_1_EncapsulatedMode_serverID = SEQ(name='serverID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-ServerID')))
    _OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets = SEQ_OF(name='cipherSets', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-CipherSet')))
    _OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets._cont = __OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets__item_
    _OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ver1_1_EncapsulatedMode_authentication = SEQ_OF(name='authentication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ver1_1_EncapsulatedMode_authentication__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ver1-1-AuthenticationSet')))
    _OMA_LPPe_ver1_1_EncapsulatedMode_authentication._cont = __OMA_LPPe_ver1_1_EncapsulatedMode_authentication__item_
    _OMA_LPPe_ver1_1_EncapsulatedMode_authentication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    OMA_LPPe_ver1_1_EncapsulatedMode._cont = ASN1Dict([
        ('serverID', _OMA_LPPe_ver1_1_EncapsulatedMode_serverID),
        ('cipherSets', _OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets),
        ('authentication', _OMA_LPPe_ver1_1_EncapsulatedMode_authentication),
        ])
    OMA_LPPe_ver1_1_EncapsulatedMode._ext = []
    
    #-----< OMA-LPPe-CommonIEsRequestLocationInformation >-----#
    OMA_LPPe_CommonIEsRequestLocationInformation = SEQ(name='OMA-LPPe-CommonIEsRequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsRequestLocationInformation_iP_Address_Request = SEQ(name='iP-Address-Request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-IP-Address-Request')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_locationInformationContainerRequest = SEQ(name='locationInformationContainerRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainerRequest')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_requestPeriodicLocInfoWithUpdate = SEQ(name='requestPeriodicLocInfoWithUpdate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RequestPeriodicLocInfoWithUpdate')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_relativeLocationChange_Request = SEQ(name='relativeLocationChange-Request', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocationChange-Request')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_localPositionRequest = SEQ(name='localPositionRequest', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocalPositionRequest')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_scheduledLocation_Request = SEQ(name='scheduledLocation-Request', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ScheduledLocation-Request')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_accessTypeRequest = SEQ(name='accessTypeRequest', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AccessTypeRequest')), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIpreference = ENUM(name='segmentedLIpreference', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIpreference._cont = ASN1Dict([('useBasic', 0), ('useResume', 1)])
    _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIpreference._ext = []
    _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIResume = SEQ(name='segmentedLIResume', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedLIResume')), opt=True)
    OMA_LPPe_CommonIEsRequestLocationInformation._cont = ASN1Dict([
        ('iP-Address-Request', _OMA_LPPe_CommonIEsRequestLocationInformation_iP_Address_Request),
        ('locationInformationContainerRequest', _OMA_LPPe_CommonIEsRequestLocationInformation_locationInformationContainerRequest),
        ('requestPeriodicLocInfoWithUpdate', _OMA_LPPe_CommonIEsRequestLocationInformation_requestPeriodicLocInfoWithUpdate),
        ('relativeLocationChange-Request', _OMA_LPPe_CommonIEsRequestLocationInformation_relativeLocationChange_Request),
        ('localPositionRequest', _OMA_LPPe_CommonIEsRequestLocationInformation_localPositionRequest),
        ('scheduledLocation-Request', _OMA_LPPe_CommonIEsRequestLocationInformation_scheduledLocation_Request),
        ('accessTypeRequest', _OMA_LPPe_CommonIEsRequestLocationInformation_accessTypeRequest),
        ('segmentedLIpreference', _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIpreference),
        ('segmentedLIResume', _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIResume),
        ])
    OMA_LPPe_CommonIEsRequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-IP-Address-Request >-----#
    OMA_LPPe_IP_Address_Request = SEQ(name='OMA-LPPe-IP-Address-Request', mode=MODE_TYPE)
    OMA_LPPe_IP_Address_Request._cont = ASN1Dict([
        ])
    OMA_LPPe_IP_Address_Request._ext = []
    
    #-----< OMA-LPPe-RequestPeriodicLocInfoWithUpdate >-----#
    OMA_LPPe_RequestPeriodicLocInfoWithUpdate = SEQ(name='OMA-LPPe-RequestPeriodicLocInfoWithUpdate', mode=MODE_TYPE)
    _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_session_ID = OCT_STR(name='session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_session_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_typeOfLocInfoRequest = ENUM(name='typeOfLocInfoRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-TypeOfLocInfoRequest')))
    OMA_LPPe_RequestPeriodicLocInfoWithUpdate._cont = ASN1Dict([
        ('session-ID', _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_session_ID),
        ('typeOfLocInfoRequest', _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_typeOfLocInfoRequest),
        ])
    OMA_LPPe_RequestPeriodicLocInfoWithUpdate._ext = []
    
    #-----< OMA-LPPe-TypeOfLocInfoRequest >-----#
    OMA_LPPe_TypeOfLocInfoRequest = ENUM(name='OMA-LPPe-TypeOfLocInfoRequest', mode=MODE_TYPE)
    OMA_LPPe_TypeOfLocInfoRequest._cont = ASN1Dict([('initialRequest', 0), ('updateAndContinueIfUpdateFails', 1), ('updateAndAbortIfUpdateFails', 2)])
    OMA_LPPe_TypeOfLocInfoRequest._ext = []
    
    #-----< OMA-LPPe-RelativeLocationChange-Request >-----#
    OMA_LPPe_RelativeLocationChange_Request = SEQ(name='OMA-LPPe-RelativeLocationChange-Request', mode=MODE_TYPE)
    _OMA_LPPe_RelativeLocationChange_Request_numberOfChanges = INT(name='numberOfChanges', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_RelativeLocationChange_Request_numberOfChanges._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    OMA_LPPe_RelativeLocationChange_Request._cont = ASN1Dict([
        ('numberOfChanges', _OMA_LPPe_RelativeLocationChange_Request_numberOfChanges),
        ])
    OMA_LPPe_RelativeLocationChange_Request._ext = []
    
    #-----< OMA-LPPe-LocalPositionRequest >-----#
    OMA_LPPe_LocalPositionRequest = SEQ(name='OMA-LPPe-LocalPositionRequest', mode=MODE_TYPE)
    _OMA_LPPe_LocalPositionRequest_typeOfRequest = ENUM(name='typeOfRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_LocalPositionRequest_typeOfRequest._cont = ASN1Dict([('localOptional', 0), ('localMandatory', 1), ('localOnly', 2)])
    _OMA_LPPe_LocalPositionRequest_typeOfRequest._ext = []
    _OMA_LPPe_LocalPositionRequest_referencePointReq = SEQ_OF(name='referencePointReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_LocalPositionRequest_referencePointReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointUniqueID')))
    _OMA_LPPe_LocalPositionRequest_referencePointReq._cont = __OMA_LPPe_LocalPositionRequest_referencePointReq__item_
    _OMA_LPPe_LocalPositionRequest_referencePointReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_LocalPositionRequest._cont = ASN1Dict([
        ('typeOfRequest', _OMA_LPPe_LocalPositionRequest_typeOfRequest),
        ('referencePointReq', _OMA_LPPe_LocalPositionRequest_referencePointReq),
        ])
    OMA_LPPe_LocalPositionRequest._ext = []
    
    #-----< OMA-LPPe-ScheduledLocation-Request >-----#
    OMA_LPPe_ScheduledLocation_Request = SEQ(name='OMA-LPPe-ScheduledLocation-Request', mode=MODE_TYPE)
    _OMA_LPPe_ScheduledLocation_Request_gnssTime = SEQ(name='gnssTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')), opt=True)
    _OMA_LPPe_ScheduledLocation_Request_networkTime = SEQ(name='networkTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NetworkTime')), opt=True)
    _OMA_LPPe_ScheduledLocation_Request_relativeTime = INT(name='relativeTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ScheduledLocation_Request_relativeTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _OMA_LPPe_ScheduledLocation_Request_windowSize = INT(name='windowSize', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ScheduledLocation_Request_windowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    OMA_LPPe_ScheduledLocation_Request._cont = ASN1Dict([
        ('gnssTime', _OMA_LPPe_ScheduledLocation_Request_gnssTime),
        ('networkTime', _OMA_LPPe_ScheduledLocation_Request_networkTime),
        ('relativeTime', _OMA_LPPe_ScheduledLocation_Request_relativeTime),
        ('windowSize', _OMA_LPPe_ScheduledLocation_Request_windowSize),
        ])
    OMA_LPPe_ScheduledLocation_Request._ext = []
    
    #-----< OMA-LPPe-AccessTypeRequest >-----#
    OMA_LPPe_AccessTypeRequest = SEQ(name='OMA-LPPe-AccessTypeRequest', mode=MODE_TYPE)
    OMA_LPPe_AccessTypeRequest._cont = ASN1Dict([
        ])
    OMA_LPPe_AccessTypeRequest._ext = []
    
    #-----< OMA-LPPe-SegmentedLIResume >-----#
    OMA_LPPe_SegmentedLIResume = SEQ(name='OMA-LPPe-SegmentedLIResume', mode=MODE_TYPE)
    _OMA_LPPe_SegmentedLIResume_segmentedLI_session_ID = INT(name='segmentedLI-session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SegmentedLIResume_segmentedLI_session_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _OMA_LPPe_SegmentedLIResume_next_segment_number = INT(name='next-segment-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SegmentedLIResume_next_segment_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    OMA_LPPe_SegmentedLIResume._cont = ASN1Dict([
        ('segmentedLI-session-ID', _OMA_LPPe_SegmentedLIResume_segmentedLI_session_ID),
        ('next-segment-number', _OMA_LPPe_SegmentedLIResume_next_segment_number),
        ])
    OMA_LPPe_SegmentedLIResume._ext = None
    
    #-----< OMA-LPPe-CommonIEsProvideLocationInformation >-----#
    OMA_LPPe_CommonIEsProvideLocationInformation = SEQ(name='OMA-LPPe-CommonIEsProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsProvideLocationInformation_highAccuracy3Dposition = SEQ(name='highAccuracy3Dposition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracy3Dposition')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_localPosition = SEQ(name='localPosition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocalPosition')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_highAccuracy3Dvelocity = SEQ(name='highAccuracy3Dvelocity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracy3Dvelocity')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_iP_Address_List = SEQ_OF(name='iP-Address-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-IP-Address-List')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_locationInformationContainer = SEQ(name='locationInformationContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationInformationContainer')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_providePeriodicLocInfoWithUpdate = SEQ(name='providePeriodicLocInfoWithUpdate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ProvidePeriodicLocInfowithUpdate')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_relativeLocationChangeList = SEQ_OF(name='relativeLocationChangeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocationChangeList')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_scheduledLocation = SEQ(name='scheduledLocation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ScheduledLocation')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_accessTypes = SEQ(name='accessTypes', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AccessTypes')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_segmentedLITransfer = SEQ(name='segmentedLITransfer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SegmentedLITransfer')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_locationInformationTimeStamp = CHOICE(name='locationInformationTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-TimeStamp')), opt=True)
    _OMA_LPPe_CommonIEsProvideLocationInformation_locationSource = SEQ(name='locationSource', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-LocationSource')), opt=True)
    OMA_LPPe_CommonIEsProvideLocationInformation._cont = ASN1Dict([
        ('highAccuracy3Dposition', _OMA_LPPe_CommonIEsProvideLocationInformation_highAccuracy3Dposition),
        ('localPosition', _OMA_LPPe_CommonIEsProvideLocationInformation_localPosition),
        ('highAccuracy3Dvelocity', _OMA_LPPe_CommonIEsProvideLocationInformation_highAccuracy3Dvelocity),
        ('iP-Address-List', _OMA_LPPe_CommonIEsProvideLocationInformation_iP_Address_List),
        ('locationInformationContainer', _OMA_LPPe_CommonIEsProvideLocationInformation_locationInformationContainer),
        ('providePeriodicLocInfoWithUpdate', _OMA_LPPe_CommonIEsProvideLocationInformation_providePeriodicLocInfoWithUpdate),
        ('relativeLocationChangeList', _OMA_LPPe_CommonIEsProvideLocationInformation_relativeLocationChangeList),
        ('scheduledLocation', _OMA_LPPe_CommonIEsProvideLocationInformation_scheduledLocation),
        ('accessTypes', _OMA_LPPe_CommonIEsProvideLocationInformation_accessTypes),
        ('segmentedLITransfer', _OMA_LPPe_CommonIEsProvideLocationInformation_segmentedLITransfer),
        ('locationInformationTimeStamp', _OMA_LPPe_CommonIEsProvideLocationInformation_locationInformationTimeStamp),
        ('locationSource', _OMA_LPPe_CommonIEsProvideLocationInformation_locationSource),
        ])
    OMA_LPPe_CommonIEsProvideLocationInformation._ext = ['locationSource']
    
    #-----< OMA-LPPe-LocalPosition >-----#
    OMA_LPPe_LocalPosition = SEQ(name='OMA-LPPe-LocalPosition', mode=MODE_TYPE)
    _OMA_LPPe_LocalPosition_referencePoint = SEQ(name='referencePoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePointUniqueID')))
    _OMA_LPPe_LocalPosition_subjectLocation = SEQ(name='subjectLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    OMA_LPPe_LocalPosition._cont = ASN1Dict([
        ('referencePoint', _OMA_LPPe_LocalPosition_referencePoint),
        ('subjectLocation', _OMA_LPPe_LocalPosition_subjectLocation),
        ])
    OMA_LPPe_LocalPosition._ext = []
    
    #-----< OMA-LPPe-IP-Address-List >-----#
    OMA_LPPe_IP_Address_List = SEQ_OF(name='OMA-LPPe-IP-Address-List', mode=MODE_TYPE)
    _OMA_LPPe_IP_Address_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-IP-Address')))
    OMA_LPPe_IP_Address_List._cont = _OMA_LPPe_IP_Address_List__item_
    OMA_LPPe_IP_Address_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxIPAddress >-----#
    maxIPAddress = INT(name='maxIPAddress', mode=MODE_VALUE)
    maxIPAddress._val = 5
    
    #-----< OMA-LPPe-IP-Address >-----#
    OMA_LPPe_IP_Address = SEQ(name='OMA-LPPe-IP-Address', mode=MODE_TYPE)
    _OMA_LPPe_IP_Address_local_IP_Address = CHOICE(name='local-IP-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_IP_Address_local_IP_Address_iPv4 = BIT_STR(name='iPv4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_IP_Address_local_IP_Address_iPv4._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __OMA_LPPe_IP_Address_local_IP_Address_iPv6 = BIT_STR(name='iPv6', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_IP_Address_local_IP_Address_iPv6._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _OMA_LPPe_IP_Address_local_IP_Address._cont = ASN1Dict([
        ('iPv4', __OMA_LPPe_IP_Address_local_IP_Address_iPv4),
        ('iPv6', __OMA_LPPe_IP_Address_local_IP_Address_iPv6),
        ])
    _OMA_LPPe_IP_Address_local_IP_Address._ext = []
    _OMA_LPPe_IP_Address_bearer = ENUM(name='bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Bearer')))
    _OMA_LPPe_IP_Address_nat = BOOL(name='nat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_IP_Address._cont = ASN1Dict([
        ('local-IP-Address', _OMA_LPPe_IP_Address_local_IP_Address),
        ('bearer', _OMA_LPPe_IP_Address_bearer),
        ('nat', _OMA_LPPe_IP_Address_nat),
        ])
    OMA_LPPe_IP_Address._ext = []
    
    #-----< OMA-LPPe-Bearer >-----#
    OMA_LPPe_Bearer = ENUM(name='OMA-LPPe-Bearer', mode=MODE_TYPE)
    OMA_LPPe_Bearer._cont = ASN1Dict([('unknown', 0), ('gsm', 1), ('utran', 2), ('lte', 3), ('wlan', 4), ('wimax', 5), ('dsl', 6), ('pktcable', 7), ('other', 8)])
    OMA_LPPe_Bearer._ext = []
    
    #-----< OMA-LPPe-ProvidePeriodicLocInfowithUpdate >-----#
    OMA_LPPe_ProvidePeriodicLocInfowithUpdate = SEQ(name='OMA-LPPe-ProvidePeriodicLocInfowithUpdate', mode=MODE_TYPE)
    _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_session_ID = OCT_STR(name='session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_session_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_typeOfLocInfoProvide = ENUM(name='typeOfLocInfoProvide', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-TypeOfLocInfoProvide')))
    OMA_LPPe_ProvidePeriodicLocInfowithUpdate._cont = ASN1Dict([
        ('session-ID', _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_session_ID),
        ('typeOfLocInfoProvide', _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_typeOfLocInfoProvide),
        ])
    OMA_LPPe_ProvidePeriodicLocInfowithUpdate._ext = []
    
    #-----< OMA-LPPe-TypeOfLocInfoProvide >-----#
    OMA_LPPe_TypeOfLocInfoProvide = ENUM(name='OMA-LPPe-TypeOfLocInfoProvide', mode=MODE_TYPE)
    OMA_LPPe_TypeOfLocInfoProvide._cont = ASN1Dict([('responseToInitialRequest', 0), ('providePeriodicLocInfo', 1), ('responseToServerUpdateRequest', 2), ('targetUpdate', 3)])
    OMA_LPPe_TypeOfLocInfoProvide._ext = []
    
    #-----< OMA-LPPe-RelativeLocationChangeList >-----#
    OMA_LPPe_RelativeLocationChangeList = SEQ_OF(name='OMA-LPPe-RelativeLocationChangeList', mode=MODE_TYPE)
    _OMA_LPPe_RelativeLocationChangeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocationChange')))
    OMA_LPPe_RelativeLocationChangeList._cont = _OMA_LPPe_RelativeLocationChangeList__item_
    OMA_LPPe_RelativeLocationChangeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< OMA-LPPe-RelativeLocationChange >-----#
    OMA_LPPe_RelativeLocationChange = SEQ(name='OMA-LPPe-RelativeLocationChange', mode=MODE_TYPE)
    _OMA_LPPe_RelativeLocationChange_relativeTime = INT(name='relativeTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_RelativeLocationChange_relativeTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_RelativeLocationChange_transactionID = INT(name='transactionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_RelativeLocationChange_transactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_RelativeLocationChange_relativeLocation = SEQ(name='relativeLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    OMA_LPPe_RelativeLocationChange._cont = ASN1Dict([
        ('relativeTime', _OMA_LPPe_RelativeLocationChange_relativeTime),
        ('transactionID', _OMA_LPPe_RelativeLocationChange_transactionID),
        ('relativeLocation', _OMA_LPPe_RelativeLocationChange_relativeLocation),
        ])
    OMA_LPPe_RelativeLocationChange._ext = []
    
    #-----< maxRelativeLocation >-----#
    maxRelativeLocation = INT(name='maxRelativeLocation', mode=MODE_VALUE)
    maxRelativeLocation._val = 5
    
    #-----< OMA-LPPe-ScheduledLocation >-----#
    OMA_LPPe_ScheduledLocation = SEQ(name='OMA-LPPe-ScheduledLocation', mode=MODE_TYPE)
    _OMA_LPPe_ScheduledLocation_disposition = ENUM(name='disposition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ScheduledLocation_disposition._cont = ASN1Dict([('withinWindow', 0), ('outsideWindowOrNoWindow', 1), ('notSupportedDueToNoCapability', 2), ('notSupportedDueToNoTimeReference', 3), ('notSupportedDueToConflictWithAnotherRequest', 4), ('notSupportedForOtherReasons', 5)])
    _OMA_LPPe_ScheduledLocation_disposition._ext = []
    _OMA_LPPe_ScheduledLocation_actualWindow = SEQ(name='actualWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ScheduledLocation_actualWindow_start = INT(name='start', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ScheduledLocation_actualWindow_start._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-512, ub=511)], ev=None, er=[])
    __OMA_LPPe_ScheduledLocation_actualWindow_duration = INT(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ScheduledLocation_actualWindow_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    _OMA_LPPe_ScheduledLocation_actualWindow._cont = ASN1Dict([
        ('start', __OMA_LPPe_ScheduledLocation_actualWindow_start),
        ('duration', __OMA_LPPe_ScheduledLocation_actualWindow_duration),
        ])
    _OMA_LPPe_ScheduledLocation_actualWindow._ext = None
    OMA_LPPe_ScheduledLocation._cont = ASN1Dict([
        ('disposition', _OMA_LPPe_ScheduledLocation_disposition),
        ('actualWindow', _OMA_LPPe_ScheduledLocation_actualWindow),
        ])
    OMA_LPPe_ScheduledLocation._ext = []
    
    #-----< OMA-LPPe-AccessTypes >-----#
    OMA_LPPe_AccessTypes = SEQ(name='OMA-LPPe-AccessTypes', mode=MODE_TYPE)
    _OMA_LPPe_AccessTypes_accessTypeUnknown = NULL(name='accessTypeUnknown', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AccessTypes_fixedAccessTypes = BIT_STR(name='fixedAccessTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-FixedAccessTypes')), opt=True)
    _OMA_LPPe_AccessTypes_wirelessAccessTypes = BIT_STR(name='wirelessAccessTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WirelessAccessTypes')), opt=True)
    OMA_LPPe_AccessTypes._cont = ASN1Dict([
        ('accessTypeUnknown', _OMA_LPPe_AccessTypes_accessTypeUnknown),
        ('fixedAccessTypes', _OMA_LPPe_AccessTypes_fixedAccessTypes),
        ('wirelessAccessTypes', _OMA_LPPe_AccessTypes_wirelessAccessTypes),
        ])
    OMA_LPPe_AccessTypes._ext = []
    
    #-----< OMA-LPPe-SegmentedLITransfer >-----#
    OMA_LPPe_SegmentedLITransfer = SEQ(name='OMA-LPPe-SegmentedLITransfer', mode=MODE_TYPE)
    _OMA_LPPe_SegmentedLITransfer_segmentedLI_session_ID = INT(name='segmentedLI-session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SegmentedLITransfer_segmentedLI_session_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _OMA_LPPe_SegmentedLITransfer_segment_number = INT(name='segment-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SegmentedLITransfer_segment_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    OMA_LPPe_SegmentedLITransfer._cont = ASN1Dict([
        ('segmentedLI-session-ID', _OMA_LPPe_SegmentedLITransfer_segmentedLI_session_ID),
        ('segment-number', _OMA_LPPe_SegmentedLITransfer_segment_number),
        ])
    OMA_LPPe_SegmentedLITransfer._ext = []
    
    #-----< OMA-LPPe-TimeStamp >-----#
    OMA_LPPe_TimeStamp = CHOICE(name='OMA-LPPe-TimeStamp', mode=MODE_TYPE)
    _OMA_LPPe_TimeStamp_gnssTime = SEQ(name='gnssTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    _OMA_LPPe_TimeStamp_networkTime = SEQ(name='networkTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'NetworkTime')))
    _OMA_LPPe_TimeStamp_relativeTime = INT(name='relativeTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_TimeStamp_relativeTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1024)], ev=None, er=[])
    OMA_LPPe_TimeStamp._cont = ASN1Dict([
        ('gnssTime', _OMA_LPPe_TimeStamp_gnssTime),
        ('networkTime', _OMA_LPPe_TimeStamp_networkTime),
        ('relativeTime', _OMA_LPPe_TimeStamp_relativeTime),
        ])
    OMA_LPPe_TimeStamp._ext = []
    
    #-----< OMA-LPPe-LocationSource >-----#
    OMA_LPPe_LocationSource = SEQ(name='OMA-LPPe-LocationSource', mode=MODE_TYPE)
    _OMA_LPPe_LocationSource_agnss = NULL(name='agnss', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_otdoa = NULL(name='otdoa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_eotd = NULL(name='eotd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_otdoaUTRA = NULL(name='otdoaUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_ecidLTE = NULL(name='ecidLTE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_ecidGSM = NULL(name='ecidGSM', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_ecidUTRA = NULL(name='ecidUTRA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_wlanAP = NULL(name='wlanAP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_srn = NULL(name='srn', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_LocationSource_sensors = NULL(name='sensors', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_LocationSource._cont = ASN1Dict([
        ('agnss', _OMA_LPPe_LocationSource_agnss),
        ('otdoa', _OMA_LPPe_LocationSource_otdoa),
        ('eotd', _OMA_LPPe_LocationSource_eotd),
        ('otdoaUTRA', _OMA_LPPe_LocationSource_otdoaUTRA),
        ('ecidLTE', _OMA_LPPe_LocationSource_ecidLTE),
        ('ecidGSM', _OMA_LPPe_LocationSource_ecidGSM),
        ('ecidUTRA', _OMA_LPPe_LocationSource_ecidUTRA),
        ('wlanAP', _OMA_LPPe_LocationSource_wlanAP),
        ('srn', _OMA_LPPe_LocationSource_srn),
        ('sensors', _OMA_LPPe_LocationSource_sensors),
        ])
    OMA_LPPe_LocationSource._ext = []
    
    #-----< OMA-LPPe-CommonIEsAbort >-----#
    OMA_LPPe_CommonIEsAbort = SEQ(name='OMA-LPPe-CommonIEsAbort', mode=MODE_TYPE)
    _OMA_LPPe_CommonIEsAbort_abortCause = ENUM(name='abortCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_CommonIEsAbort_abortCause._cont = ASN1Dict([('periodicADsessionStop', 0), ('periodicADprocedureNotSupported', 1), ('periodicADprocedureNotAccepted', 2), ('periodicLocInfoSessionStop', 3), ('periodicLocInfoProcedureNotSupported', 4), ('periodicLocInfoProcedureNotAccepted', 5)])
    _OMA_LPPe_CommonIEsAbort_abortCause._ext = []
    _OMA_LPPe_CommonIEsAbort_periodicSessionIDtoAbort = OCT_STR(name='periodicSessionIDtoAbort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_CommonIEsAbort_periodicSessionIDtoAbort._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    OMA_LPPe_CommonIEsAbort._cont = ASN1Dict([
        ('abortCause', _OMA_LPPe_CommonIEsAbort_abortCause),
        ('periodicSessionIDtoAbort', _OMA_LPPe_CommonIEsAbort_periodicSessionIDtoAbort),
        ])
    OMA_LPPe_CommonIEsAbort._ext = []
    
    #-----< OMA-LPPe-CommonIEsError >-----#
    OMA_LPPe_CommonIEsError = SEQ(name='OMA-LPPe-CommonIEsError', mode=MODE_TYPE)
    OMA_LPPe_CommonIEsError._cont = ASN1Dict([
        ])
    OMA_LPPe_CommonIEsError._ext = []
    
    #-----< OMA-LPPe-AGNSS-ProvideAssistanceData >-----#
    OMA_LPPe_AGNSS_ProvideAssistanceData = SEQ(name='OMA-LPPe-AGNSS-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_ProvideAssistanceData_commonAssistData = SEQ(name='commonAssistData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CommonAssistData')), opt=True)
    _OMA_LPPe_AGNSS_ProvideAssistanceData_genericAssistData = SEQ_OF(name='genericAssistData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-GenericAssistData')), opt=True)
    _OMA_LPPe_AGNSS_ProvideAssistanceData_error = CHOICE(name='error', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-Error')), opt=True)
    OMA_LPPe_AGNSS_ProvideAssistanceData._cont = ASN1Dict([
        ('commonAssistData', _OMA_LPPe_AGNSS_ProvideAssistanceData_commonAssistData),
        ('genericAssistData', _OMA_LPPe_AGNSS_ProvideAssistanceData_genericAssistData),
        ('error', _OMA_LPPe_AGNSS_ProvideAssistanceData_error),
        ])
    OMA_LPPe_AGNSS_ProvideAssistanceData._ext = []
    
    #-----< OMA-LPPe-AGNSS-CommonAssistData >-----#
    OMA_LPPe_AGNSS_CommonAssistData = SEQ(name='OMA-LPPe-AGNSS-CommonAssistData', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CommonAssistData_ionosphericModel = CHOICE(name='ionosphericModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-IonosphericModel')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistData_troposphereModel = SEQ(name='troposphereModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TroposphereModel')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistData_altitudeAssistance = SEQ_OF(name='altitudeAssistance', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AltitudeAssistanceList')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistData_solarRadiation = SEQ(name='solarRadiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-SolarRadiation')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistData_ccpAssistCommonProvide = CHOICE(name='ccpAssistCommonProvide', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPassistCommonProvide')), opt=True)
    OMA_LPPe_AGNSS_CommonAssistData._cont = ASN1Dict([
        ('ionosphericModel', _OMA_LPPe_AGNSS_CommonAssistData_ionosphericModel),
        ('troposphereModel', _OMA_LPPe_AGNSS_CommonAssistData_troposphereModel),
        ('altitudeAssistance', _OMA_LPPe_AGNSS_CommonAssistData_altitudeAssistance),
        ('solarRadiation', _OMA_LPPe_AGNSS_CommonAssistData_solarRadiation),
        ('ccpAssistCommonProvide', _OMA_LPPe_AGNSS_CommonAssistData_ccpAssistCommonProvide),
        ])
    OMA_LPPe_AGNSS_CommonAssistData._ext = []
    
    #-----< OMA-LPPe-AGNSS-GenericAssistData >-----#
    OMA_LPPe_AGNSS_GenericAssistData = SEQ_OF(name='OMA-LPPe-AGNSS-GenericAssistData', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_GenericAssistData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-GenericAssistDataElement')))
    OMA_LPPe_AGNSS_GenericAssistData._cont = _OMA_LPPe_AGNSS_GenericAssistData__item_
    OMA_LPPe_AGNSS_GenericAssistData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-GenericAssistDataElement >-----#
    OMA_LPPe_AGNSS_GenericAssistDataElement = SEQ(name='OMA-LPPe-AGNSS-GenericAssistDataElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_GenericAssistDataElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_GenericAssistDataElement_wideAreaIonoSurfacePerSVlist = SEQ_OF(name='wideAreaIonoSurfacePerSVlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVlist')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataElement_mechanicsForAllSVs = SEQ_OF(name='mechanicsForAllSVs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-MechanicsForAllSVs')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataElement_dcbsForAllSVs = SEQ_OF(name='dcbsForAllSVs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-DCBsForAllSVs')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataElement_navModelDegradationModel = SEQ_OF(name='navModelDegradationModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModelDegradationModelList')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataElement_ccpAssistProvide = SEQ_OF(name='ccpAssistProvide', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPassistGenericProvide')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataElement_navModelList = SEQ(name='navModelList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModelList')), opt=True)
    OMA_LPPe_AGNSS_GenericAssistDataElement._cont = ASN1Dict([
        ('gnss-ID', _OMA_LPPe_AGNSS_GenericAssistDataElement_gnss_ID),
        ('wideAreaIonoSurfacePerSVlist', _OMA_LPPe_AGNSS_GenericAssistDataElement_wideAreaIonoSurfacePerSVlist),
        ('mechanicsForAllSVs', _OMA_LPPe_AGNSS_GenericAssistDataElement_mechanicsForAllSVs),
        ('dcbsForAllSVs', _OMA_LPPe_AGNSS_GenericAssistDataElement_dcbsForAllSVs),
        ('navModelDegradationModel', _OMA_LPPe_AGNSS_GenericAssistDataElement_navModelDegradationModel),
        ('ccpAssistProvide', _OMA_LPPe_AGNSS_GenericAssistDataElement_ccpAssistProvide),
        ('navModelList', _OMA_LPPe_AGNSS_GenericAssistDataElement_navModelList),
        ])
    OMA_LPPe_AGNSS_GenericAssistDataElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-IonosphericModel >-----#
    OMA_LPPe_AGNSS_IonosphericModel = CHOICE(name='OMA-LPPe-AGNSS-IonosphericModel', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_IonosphericModel_staticModels = SEQ(name='staticModels', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_IonosphericModel_staticModels_localKlobucharModelList = SEQ_OF(name='localKlobucharModelList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalKlobucharModelList')), opt=True)
    __OMA_LPPe_AGNSS_IonosphericModel_staticModels_ionoStormIndication = SEQ(name='ionoStormIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-IonoStormIndication')), opt=True)
    _OMA_LPPe_AGNSS_IonosphericModel_staticModels._cont = ASN1Dict([
        ('localKlobucharModelList', __OMA_LPPe_AGNSS_IonosphericModel_staticModels_localKlobucharModelList),
        ('ionoStormIndication', __OMA_LPPe_AGNSS_IonosphericModel_staticModels_ionoStormIndication),
        ])
    _OMA_LPPe_AGNSS_IonosphericModel_staticModels._ext = []
    _OMA_LPPe_AGNSS_IonosphericModel_waIono = CHOICE(name='waIono', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_AGNSS_IonosphericModel_waIono_controlParameters = SEQ(name='controlParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersProvide')))
    __OMA_LPPe_AGNSS_IonosphericModel_waIono_commonProvide = SEQ(name='commonProvide', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-WideAreaIonoSurfaceCommon')))
    _OMA_LPPe_AGNSS_IonosphericModel_waIono._cont = ASN1Dict([
        ('controlParameters', __OMA_LPPe_AGNSS_IonosphericModel_waIono_controlParameters),
        ('commonProvide', __OMA_LPPe_AGNSS_IonosphericModel_waIono_commonProvide),
        ])
    _OMA_LPPe_AGNSS_IonosphericModel_waIono._ext = []
    OMA_LPPe_AGNSS_IonosphericModel._cont = ASN1Dict([
        ('staticModels', _OMA_LPPe_AGNSS_IonosphericModel_staticModels),
        ('waIono', _OMA_LPPe_AGNSS_IonosphericModel_waIono),
        ])
    OMA_LPPe_AGNSS_IonosphericModel._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalKlobucharModelList >-----#
    OMA_LPPe_AGNSS_LocalKlobucharModelList = SEQ_OF(name='OMA-LPPe-AGNSS-LocalKlobucharModelList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalKlobucharModelList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalKlobucharModelElement')))
    OMA_LPPe_AGNSS_LocalKlobucharModelList._cont = _OMA_LPPe_AGNSS_LocalKlobucharModelList__item_
    OMA_LPPe_AGNSS_LocalKlobucharModelList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-LocalKlobucharModelElement >-----#
    OMA_LPPe_AGNSS_LocalKlobucharModelElement = SEQ(name='OMA-LPPe-AGNSS-LocalKlobucharModelElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalKlobucharModelElement_validityArea = SEQ(name='validityArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')))
    _OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel = SEQ_OF(name='klobucharModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalKlobucharModel')))
    _OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel._cont = __OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel__item_
    _OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_LocalKlobucharModelElement._cont = ASN1Dict([
        ('validityArea', _OMA_LPPe_AGNSS_LocalKlobucharModelElement_validityArea),
        ('klobucharModel', _OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel),
        ])
    OMA_LPPe_AGNSS_LocalKlobucharModelElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalKlobucharModel >-----#
    OMA_LPPe_AGNSS_LocalKlobucharModel = SEQ(name='OMA-LPPe-AGNSS-LocalKlobucharModel', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalKlobucharModel_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa0 = INT(name='alfa0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa1 = INT(name='alfa1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa2 = INT(name='alfa2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa3 = INT(name='alfa3', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta0 = INT(name='beta0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta1 = INT(name='beta1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta2 = INT(name='beta2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta3 = INT(name='beta3', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalKlobucharModel_beta3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    OMA_LPPe_AGNSS_LocalKlobucharModel._cont = ASN1Dict([
        ('validityPeriod', _OMA_LPPe_AGNSS_LocalKlobucharModel_validityPeriod),
        ('alfa0', _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa0),
        ('alfa1', _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa1),
        ('alfa2', _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa2),
        ('alfa3', _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa3),
        ('beta0', _OMA_LPPe_AGNSS_LocalKlobucharModel_beta0),
        ('beta1', _OMA_LPPe_AGNSS_LocalKlobucharModel_beta1),
        ('beta2', _OMA_LPPe_AGNSS_LocalKlobucharModel_beta2),
        ('beta3', _OMA_LPPe_AGNSS_LocalKlobucharModel_beta3),
        ])
    OMA_LPPe_AGNSS_LocalKlobucharModel._ext = []
    
    #-----< OMA-LPPe-AGNSS-IonoStormIndication >-----#
    OMA_LPPe_AGNSS_IonoStormIndication = SEQ(name='OMA-LPPe-AGNSS-IonoStormIndication', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_IonoStormIndication_area = SEQ(name='area', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')))
    _OMA_LPPe_AGNSS_IonoStormIndication_stormList = SEQ_OF(name='stormList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-StormList')))
    OMA_LPPe_AGNSS_IonoStormIndication._cont = ASN1Dict([
        ('area', _OMA_LPPe_AGNSS_IonoStormIndication_area),
        ('stormList', _OMA_LPPe_AGNSS_IonoStormIndication_stormList),
        ])
    OMA_LPPe_AGNSS_IonoStormIndication._ext = []
    
    #-----< OMA-LPPe-AGNSS-StormList >-----#
    OMA_LPPe_AGNSS_StormList = SEQ_OF(name='OMA-LPPe-AGNSS-StormList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_StormList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-StormElement')))
    OMA_LPPe_AGNSS_StormList._cont = _OMA_LPPe_AGNSS_StormList__item_
    OMA_LPPe_AGNSS_StormList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-StormElement >-----#
    OMA_LPPe_AGNSS_StormElement = SEQ(name='OMA-LPPe-AGNSS-StormElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_StormElement_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    _OMA_LPPe_AGNSS_StormElement_rleListIono = SEQ_OF(name='rleListIono', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-RleListIono')))
    OMA_LPPe_AGNSS_StormElement._cont = ASN1Dict([
        ('validityPeriod', _OMA_LPPe_AGNSS_StormElement_validityPeriod),
        ('rleListIono', _OMA_LPPe_AGNSS_StormElement_rleListIono),
        ])
    OMA_LPPe_AGNSS_StormElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-RleListIono >-----#
    OMA_LPPe_AGNSS_RleListIono = SEQ_OF(name='OMA-LPPe-AGNSS-RleListIono', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_RleListIono__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-RleIonoElement')))
    OMA_LPPe_AGNSS_RleListIono._cont = _OMA_LPPe_AGNSS_RleListIono__item_
    OMA_LPPe_AGNSS_RleListIono._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-RleIonoElement >-----#
    OMA_LPPe_AGNSS_RleIonoElement = SEQ(name='OMA-LPPe-AGNSS-RleIonoElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_RleIonoElement_regionCount = INT(name='regionCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_RleIonoElement_regionCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_AGNSS_RleIonoElement_ionoIndex = CHOICE(name='ionoIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_AGNSS_RleIonoElement_ionoIndex_noaaScales = ENUM(name='noaaScales', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NoaaScales')))
    _OMA_LPPe_AGNSS_RleIonoElement_ionoIndex._cont = ASN1Dict([
        ('noaaScales', __OMA_LPPe_AGNSS_RleIonoElement_ionoIndex_noaaScales),
        ])
    _OMA_LPPe_AGNSS_RleIonoElement_ionoIndex._ext = []
    OMA_LPPe_AGNSS_RleIonoElement._cont = ASN1Dict([
        ('regionCount', _OMA_LPPe_AGNSS_RleIonoElement_regionCount),
        ('ionoIndex', _OMA_LPPe_AGNSS_RleIonoElement_ionoIndex),
        ])
    OMA_LPPe_AGNSS_RleIonoElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-NoaaScales >-----#
    OMA_LPPe_AGNSS_NoaaScales = ENUM(name='OMA-LPPe-AGNSS-NoaaScales', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_NoaaScales._cont = ASN1Dict([('g1', 0), ('g2', 1), ('g3', 2), ('g4', 3), ('g5', 4), ('unknown', 5), ('none', 6)])
    OMA_LPPe_AGNSS_NoaaScales._ext = []
    
    #-----< OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersProvide >-----#
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide = SEQ(name='OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersProvide', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_rate = INT(name='rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_referencePosition = SEQ(name='referencePosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_validityArea = SEQ(name='validityArea', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')), opt=True)
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide._cont = ASN1Dict([
        ('duration', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_duration),
        ('rate', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_rate),
        ('referencePosition', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_referencePosition),
        ('validityArea', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_validityArea),
        ])
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide._ext = []
    
    #-----< OMA-LPPe-AGNSS-WideAreaIonoSurfaceCommon >-----#
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon = SEQ(name='OMA-LPPe-AGNSS-WideAreaIonoSurfaceCommon', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon._cont = ASN1Dict([
        ('validityPeriod', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon_validityPeriod),
        ])
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon._ext = []
    
    #-----< OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVlist >-----#
    OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist = SEQ_OF(name='OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVlist', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVelement')))
    OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist._cont = _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist__item_
    OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVelement >-----#
    OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement = SEQ(name='OMA-LPPe-AGNSS-WideAreaIonoSurfacePerSVelement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_a0 = INT(name='a0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_a0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e1 = INT(name='e1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n1 = INT(name='n1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e2 = INT(name='e2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n2 = INT(name='n2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_en = INT(name='en', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_en._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement._cont = ASN1Dict([
        ('svID', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_svID),
        ('a0', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_a0),
        ('e1', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e1),
        ('n1', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n1),
        ('e2', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e2),
        ('n2', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n2),
        ('en', _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_en),
        ])
    OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement._ext = []
    
    #-----< OMA-LPPe-AGNSS-TroposphereModel >-----#
    OMA_LPPe_AGNSS_TroposphereModel = SEQ(name='OMA-LPPe-AGNSS-TroposphereModel', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TroposphereModel_troposphereDelayList = SEQ_OF(name='troposphereDelayList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalTroposphereDelayList')), opt=True)
    _OMA_LPPe_AGNSS_TroposphereModel_surfaceParametersList = SEQ_OF(name='surfaceParametersList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalSurfaceParametersList')), opt=True)
    OMA_LPPe_AGNSS_TroposphereModel._cont = ASN1Dict([
        ('troposphereDelayList', _OMA_LPPe_AGNSS_TroposphereModel_troposphereDelayList),
        ('surfaceParametersList', _OMA_LPPe_AGNSS_TroposphereModel_surfaceParametersList),
        ])
    OMA_LPPe_AGNSS_TroposphereModel._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalTroposphereDelayList >-----#
    OMA_LPPe_AGNSS_LocalTroposphereDelayList = SEQ_OF(name='OMA-LPPe-AGNSS-LocalTroposphereDelayList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalTroposphereDelayAreaElement')))
    OMA_LPPe_AGNSS_LocalTroposphereDelayList._cont = _OMA_LPPe_AGNSS_LocalTroposphereDelayList__item_
    OMA_LPPe_AGNSS_LocalTroposphereDelayList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-LocalTroposphereDelayAreaElement >-----#
    OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement = SEQ(name='OMA-LPPe-AGNSS-LocalTroposphereDelayAreaElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_validityArea = SEQ(name='validityArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')))
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_refAltitude = INT(name='refAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_refAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1000, ub=8192)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_gradientReferencePosition = SEQ(name='gradientReferencePosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList = SEQ_OF(name='delayList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalTroposphereDelayTimeElement')))
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList._cont = __OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList__item_
    _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement._cont = ASN1Dict([
        ('validityArea', _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_validityArea),
        ('refAltitude', _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_refAltitude),
        ('gradientReferencePosition', _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_gradientReferencePosition),
        ('delayList', _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList),
        ])
    OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalTroposphereDelayTimeElement >-----#
    OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement = SEQ(name='OMA-LPPe-AGNSS-LocalTroposphereDelayTimeElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zh0 = INT(name='zh0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zh0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_eh = INT(name='eh', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_eh._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zw0 = INT(name='zw0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zw0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_ew = INT(name='ew', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_ew._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gN = INT(name='gN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8192, ub=8191)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gE = INT(name='gE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8192, ub=8191)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_mappingFunctionParameters = SEQ(name='mappingFunctionParameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-MappingFunctionParameters')))
    OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement._cont = ASN1Dict([
        ('validityPeriod', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_validityPeriod),
        ('zh0', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zh0),
        ('eh', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_eh),
        ('zw0', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zw0),
        ('ew', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_ew),
        ('gN', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gN),
        ('gE', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gE),
        ('mappingFunctionParameters', _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_mappingFunctionParameters),
        ])
    OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalSurfaceParametersList >-----#
    OMA_LPPe_AGNSS_LocalSurfaceParametersList = SEQ_OF(name='OMA-LPPe-AGNSS-LocalSurfaceParametersList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalSurfaceParametersAreaElement')))
    OMA_LPPe_AGNSS_LocalSurfaceParametersList._cont = _OMA_LPPe_AGNSS_LocalSurfaceParametersList__item_
    OMA_LPPe_AGNSS_LocalSurfaceParametersList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-LocalSurfaceParametersAreaElement >-----#
    OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement = SEQ(name='OMA-LPPe-AGNSS-LocalSurfaceParametersAreaElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_validityArea = SEQ(name='validityArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')))
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_refAltitude = INT(name='refAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_refAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1000, ub=8192)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_gradientReferencePosition = SEQ(name='gradientReferencePosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList = SEQ_OF(name='parameterList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalSurfaceParametersTimeElement')))
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList._cont = __OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList__item_
    _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement._cont = ASN1Dict([
        ('validityArea', _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_validityArea),
        ('refAltitude', _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_refAltitude),
        ('gradientReferencePosition', _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_gradientReferencePosition),
        ('parameterList', _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList),
        ])
    OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalSurfaceParametersTimeElement >-----#
    OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement = SEQ(name='OMA-LPPe-AGNSS-LocalSurfaceParametersTimeElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressure = INT(name='pressure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressureRate = INT(name='pressureRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressureRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_pressure = INT(name='gN-pressure', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_pressure = INT(name='gE-pressure', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperature = INT(name='temperature', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperature._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperatureRate = INT(name='temperatureRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperatureRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-16, ub=16)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_temperature = INT(name='gN-temperature', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_temperature._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8, ub=7)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_temperature = INT(name='gE-temperature', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_temperature._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8, ub=7)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_mappingFunctionParameters = SEQ(name='mappingFunctionParameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-MappingFunctionParameters')))
    OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement._cont = ASN1Dict([
        ('validityPeriod', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_validityPeriod),
        ('pressure', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressure),
        ('pressureRate', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressureRate),
        ('gN-pressure', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_pressure),
        ('gE-pressure', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_pressure),
        ('temperature', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperature),
        ('temperatureRate', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperatureRate),
        ('gN-temperature', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_temperature),
        ('gE-temperature', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_temperature),
        ('mappingFunctionParameters', _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_mappingFunctionParameters),
        ])
    OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-MappingFunctionParameters >-----#
    OMA_LPPe_AGNSS_MappingFunctionParameters = SEQ(name='OMA-LPPe-AGNSS-MappingFunctionParameters', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_MappingFunctionParameters_ah = INT(name='ah', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_MappingFunctionParameters_ah._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MappingFunctionParameters_bh = INT(name='bh', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MappingFunctionParameters_bh._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MappingFunctionParameters_ch = INT(name='ch', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MappingFunctionParameters_ch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MappingFunctionParameters_aw = INT(name='aw', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MappingFunctionParameters_aw._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MappingFunctionParameters_bw = INT(name='bw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MappingFunctionParameters_bw._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MappingFunctionParameters_cw = INT(name='cw', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MappingFunctionParameters_cw._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    OMA_LPPe_AGNSS_MappingFunctionParameters._cont = ASN1Dict([
        ('ah', _OMA_LPPe_AGNSS_MappingFunctionParameters_ah),
        ('bh', _OMA_LPPe_AGNSS_MappingFunctionParameters_bh),
        ('ch', _OMA_LPPe_AGNSS_MappingFunctionParameters_ch),
        ('aw', _OMA_LPPe_AGNSS_MappingFunctionParameters_aw),
        ('bw', _OMA_LPPe_AGNSS_MappingFunctionParameters_bw),
        ('cw', _OMA_LPPe_AGNSS_MappingFunctionParameters_cw),
        ])
    OMA_LPPe_AGNSS_MappingFunctionParameters._ext = []
    
    #-----< OMA-LPPe-AGNSS-AltitudeAssistanceList >-----#
    OMA_LPPe_AGNSS_AltitudeAssistanceList = SEQ_OF(name='OMA-LPPe-AGNSS-AltitudeAssistanceList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_AltitudeAssistanceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AltitudeAssistanceAreaElement')))
    OMA_LPPe_AGNSS_AltitudeAssistanceList._cont = _OMA_LPPe_AGNSS_AltitudeAssistanceList__item_
    OMA_LPPe_AGNSS_AltitudeAssistanceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-AltitudeAssistanceAreaElement >-----#
    OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement = SEQ(name='OMA-LPPe-AGNSS-AltitudeAssistanceAreaElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_validityArea = SEQ(name='validityArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')))
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_gradientReferencePosition = SEQ(name='gradientReferencePosition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')), opt=True)
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_refAltitude = INT(name='refAltitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_refAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1000, ub=8192)], ev=None, er=[])
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList = SEQ_OF(name='pressureAssistanceList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-PressureAssistanceElement')))
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList._cont = __OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList__item_
    _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement._cont = ASN1Dict([
        ('validityArea', _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_validityArea),
        ('gradientReferencePosition', _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_gradientReferencePosition),
        ('refAltitude', _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_refAltitude),
        ('pressureAssistanceList', _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList),
        ])
    OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-PressureAssistanceElement >-----#
    OMA_LPPe_AGNSS_PressureAssistanceElement = SEQ(name='OMA-LPPe-AGNSS-PressureAssistanceElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_PressureAssistanceElement_validityPeriod = SEQ(name='validityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    _OMA_LPPe_AGNSS_PressureAssistanceElement_pressure = INT(name='pressure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_PressureAssistanceElement_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _OMA_LPPe_AGNSS_PressureAssistanceElement_pressureRate = INT(name='pressureRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_PressureAssistanceElement_pressureRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_PressureAssistanceElement_gN = INT(name='gN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_PressureAssistanceElement_gN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_PressureAssistanceElement_gE = INT(name='gE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_PressureAssistanceElement_gE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    OMA_LPPe_AGNSS_PressureAssistanceElement._cont = ASN1Dict([
        ('validityPeriod', _OMA_LPPe_AGNSS_PressureAssistanceElement_validityPeriod),
        ('pressure', _OMA_LPPe_AGNSS_PressureAssistanceElement_pressure),
        ('pressureRate', _OMA_LPPe_AGNSS_PressureAssistanceElement_pressureRate),
        ('gN', _OMA_LPPe_AGNSS_PressureAssistanceElement_gN),
        ('gE', _OMA_LPPe_AGNSS_PressureAssistanceElement_gE),
        ])
    OMA_LPPe_AGNSS_PressureAssistanceElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-SolarRadiation >-----#
    OMA_LPPe_AGNSS_SolarRadiation = SEQ(name='OMA-LPPe-AGNSS-SolarRadiation', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_SolarRadiation_solarRadiation = INT(name='solarRadiation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_SolarRadiation_solarRadiation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1000, ub=2000)], ev=None, er=[])
    OMA_LPPe_AGNSS_SolarRadiation._cont = ASN1Dict([
        ('solarRadiation', _OMA_LPPe_AGNSS_SolarRadiation_solarRadiation),
        ])
    OMA_LPPe_AGNSS_SolarRadiation._ext = []
    
    #-----< OMA-LPPe-AGNSS-MechanicsForAllSVs >-----#
    OMA_LPPe_AGNSS_MechanicsForAllSVs = SEQ_OF(name='OMA-LPPe-AGNSS-MechanicsForAllSVs', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_MechanicsForAllSVs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-MechanicsElement')))
    OMA_LPPe_AGNSS_MechanicsForAllSVs._cont = _OMA_LPPe_AGNSS_MechanicsForAllSVs__item_
    OMA_LPPe_AGNSS_MechanicsForAllSVs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-MechanicsElement >-----#
    OMA_LPPe_AGNSS_MechanicsElement = SEQ(name='OMA-LPPe-AGNSS-MechanicsElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_MechanicsElement_svid = SEQ(name='svid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_AGNSS_MechanicsElement_mass = INT(name='mass', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MechanicsElement_mass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MechanicsElement_effectiveReflectivityArea = INT(name='effectiveReflectivityArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_MechanicsElement_effectiveReflectivityArea._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=511)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MechanicsElement_pco = SEQ(name='pco', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-PCOelement')), opt=True)
    _OMA_LPPe_AGNSS_MechanicsElement_svInfo = SEQ(name='svInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svType = ENUM(name='svType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-SVtype')))
    __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svNumber = INT(name='svNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_MechanicsElement_svInfo._cont = ASN1Dict([
        ('svType', __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svType),
        ('svNumber', __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svNumber),
        ])
    _OMA_LPPe_AGNSS_MechanicsElement_svInfo._ext = []
    OMA_LPPe_AGNSS_MechanicsElement._cont = ASN1Dict([
        ('svid', _OMA_LPPe_AGNSS_MechanicsElement_svid),
        ('mass', _OMA_LPPe_AGNSS_MechanicsElement_mass),
        ('effectiveReflectivityArea', _OMA_LPPe_AGNSS_MechanicsElement_effectiveReflectivityArea),
        ('pco', _OMA_LPPe_AGNSS_MechanicsElement_pco),
        ('svInfo', _OMA_LPPe_AGNSS_MechanicsElement_svInfo),
        ])
    OMA_LPPe_AGNSS_MechanicsElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-PCOelement >-----#
    OMA_LPPe_AGNSS_PCOelement = SEQ(name='OMA-LPPe-AGNSS-PCOelement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_PCOelement_xOffsetSBF = INT(name='xOffsetSBF', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_PCOelement_xOffsetSBF._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-30000, ub=30000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_PCOelement_yOffsetSBF = INT(name='yOffsetSBF', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_PCOelement_yOffsetSBF._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-30000, ub=30000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_PCOelement_zOffsetSBF = INT(name='zOffsetSBF', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_PCOelement_zOffsetSBF._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-30000, ub=30000)], ev=None, er=[])
    OMA_LPPe_AGNSS_PCOelement._cont = ASN1Dict([
        ('xOffsetSBF', _OMA_LPPe_AGNSS_PCOelement_xOffsetSBF),
        ('yOffsetSBF', _OMA_LPPe_AGNSS_PCOelement_yOffsetSBF),
        ('zOffsetSBF', _OMA_LPPe_AGNSS_PCOelement_zOffsetSBF),
        ])
    OMA_LPPe_AGNSS_PCOelement._ext = []
    
    #-----< OMA-LPPe-AGNSS-SVtype >-----#
    OMA_LPPe_AGNSS_SVtype = ENUM(name='OMA-LPPe-AGNSS-SVtype', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_SVtype._cont = ASN1Dict([('gpsIIR', 0), ('gpsIIRM', 1), ('gpsIIF', 2), ('gpsIII', 3), ('glonassM', 4), ('glonassK1', 5), ('glonassK2', 6), ('glonassKM', 7), ('unknown', 8)])
    OMA_LPPe_AGNSS_SVtype._ext = []
    
    #-----< OMA-LPPe-AGNSS-DCBsForAllSVs >-----#
    OMA_LPPe_AGNSS_DCBsForAllSVs = SEQ_OF(name='OMA-LPPe-AGNSS-DCBsForAllSVs', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_DCBsForAllSVs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-DCBlistElement')))
    OMA_LPPe_AGNSS_DCBsForAllSVs._cont = _OMA_LPPe_AGNSS_DCBsForAllSVs__item_
    OMA_LPPe_AGNSS_DCBsForAllSVs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-DCBlistElement >-----#
    OMA_LPPe_AGNSS_DCBlistElement = SEQ(name='OMA-LPPe-AGNSS-DCBlistElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_DCBlistElement_svid = SEQ(name='svid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_AGNSS_DCBlistElement_reference = SEQ(name='reference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_DCBlistElement_reference_signal = SEQ(name='signal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    __OMA_LPPe_AGNSS_DCBlistElement_reference_pd = ENUM(name='pd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_DCBlistElement_reference_pd._cont = ASN1Dict([('pilot', 0), ('data', 1), ('notapplicable', 2)])
    __OMA_LPPe_AGNSS_DCBlistElement_reference_pd._ext = []
    _OMA_LPPe_AGNSS_DCBlistElement_reference._cont = ASN1Dict([
        ('signal', __OMA_LPPe_AGNSS_DCBlistElement_reference_signal),
        ('pd', __OMA_LPPe_AGNSS_DCBlistElement_reference_pd),
        ])
    _OMA_LPPe_AGNSS_DCBlistElement_reference._ext = []
    _OMA_LPPe_AGNSS_DCBlistElement_dcbList = SEQ_OF(name='dcbList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-DCBlist')))
    OMA_LPPe_AGNSS_DCBlistElement._cont = ASN1Dict([
        ('svid', _OMA_LPPe_AGNSS_DCBlistElement_svid),
        ('reference', _OMA_LPPe_AGNSS_DCBlistElement_reference),
        ('dcbList', _OMA_LPPe_AGNSS_DCBlistElement_dcbList),
        ])
    OMA_LPPe_AGNSS_DCBlistElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-DCBlist >-----#
    OMA_LPPe_AGNSS_DCBlist = SEQ_OF(name='OMA-LPPe-AGNSS-DCBlist', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_DCBlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-DCBelement')))
    OMA_LPPe_AGNSS_DCBlist._cont = _OMA_LPPe_AGNSS_DCBlist__item_
    OMA_LPPe_AGNSS_DCBlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-DCBelement >-----#
    OMA_LPPe_AGNSS_DCBelement = SEQ(name='OMA-LPPe-AGNSS-DCBelement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_DCBelement_signal = SEQ(name='signal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _OMA_LPPe_AGNSS_DCBelement_pd = ENUM(name='pd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_DCBelement_pd._cont = ASN1Dict([('pilot', 0), ('data', 1), ('notapplicable', 2)])
    _OMA_LPPe_AGNSS_DCBelement_pd._ext = []
    _OMA_LPPe_AGNSS_DCBelement_dcb = INT(name='dcb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_DCBelement_dcb._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4096, ub=4095)], ev=None, er=[])
    OMA_LPPe_AGNSS_DCBelement._cont = ASN1Dict([
        ('signal', _OMA_LPPe_AGNSS_DCBelement_signal),
        ('pd', _OMA_LPPe_AGNSS_DCBelement_pd),
        ('dcb', _OMA_LPPe_AGNSS_DCBelement_dcb),
        ])
    OMA_LPPe_AGNSS_DCBelement._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModelDegradationModelList >-----#
    OMA_LPPe_AGNSS_NavModelDegradationModelList = SEQ_OF(name='OMA-LPPe-AGNSS-NavModelDegradationModelList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModelDegradationModelList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModelDegradationModelElement')))
    OMA_LPPe_AGNSS_NavModelDegradationModelList._cont = _OMA_LPPe_AGNSS_NavModelDegradationModelList__item_
    OMA_LPPe_AGNSS_NavModelDegradationModelList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-NavModelDegradationModelElement >-----#
    OMA_LPPe_AGNSS_NavModelDegradationModelElement = SEQ(name='OMA-LPPe-AGNSS-NavModelDegradationModelElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModelDegradationModelElement_svid = SEQ(name='svid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_AGNSS_NavModelDegradationModelElement_clockDegradationModel = SEQ(name='clockDegradationModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-ClockModelDegradationModel')))
    _OMA_LPPe_AGNSS_NavModelDegradationModelElement_orbitDegradationModel = SEQ(name='orbitDegradationModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-OrbitModelDegradationModel')))
    OMA_LPPe_AGNSS_NavModelDegradationModelElement._cont = ASN1Dict([
        ('svid', _OMA_LPPe_AGNSS_NavModelDegradationModelElement_svid),
        ('clockDegradationModel', _OMA_LPPe_AGNSS_NavModelDegradationModelElement_clockDegradationModel),
        ('orbitDegradationModel', _OMA_LPPe_AGNSS_NavModelDegradationModelElement_orbitDegradationModel),
        ])
    OMA_LPPe_AGNSS_NavModelDegradationModelElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-ClockModelDegradationModel >-----#
    OMA_LPPe_AGNSS_ClockModelDegradationModel = SEQ(name='OMA-LPPe-AGNSS-ClockModelDegradationModel', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS0 = INT(name='clockRMS0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS1 = INT(name='clockRMS1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    OMA_LPPe_AGNSS_ClockModelDegradationModel._cont = ASN1Dict([
        ('clockRMS0', _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS0),
        ('clockRMS1', _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS1),
        ])
    OMA_LPPe_AGNSS_ClockModelDegradationModel._ext = []
    
    #-----< OMA-LPPe-AGNSS-OrbitModelDegradationModel >-----#
    OMA_LPPe_AGNSS_OrbitModelDegradationModel = SEQ(name='OMA-LPPe-AGNSS-OrbitModelDegradationModel', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS0 = INT(name='orbitRMS0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS1 = INT(name='orbitRMS1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    OMA_LPPe_AGNSS_OrbitModelDegradationModel._cont = ASN1Dict([
        ('orbitRMS0', _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS0),
        ('orbitRMS1', _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS1),
        ])
    OMA_LPPe_AGNSS_OrbitModelDegradationModel._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPassistCommonProvide >-----#
    OMA_LPPe_AGNSS_CCPassistCommonProvide = CHOICE(name='OMA-LPPe-AGNSS-CCPassistCommonProvide', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPassistCommonProvide_ccpProvideCommonParameters = SEQ(name='ccpProvideCommonParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPprovideCommonParameters')))
    _OMA_LPPe_AGNSS_CCPassistCommonProvide_ccpProvideControlParameters = SEQ(name='ccpProvideControlParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPprovideControlParameters')))
    OMA_LPPe_AGNSS_CCPassistCommonProvide._cont = ASN1Dict([
        ('ccpProvideCommonParameters', _OMA_LPPe_AGNSS_CCPassistCommonProvide_ccpProvideCommonParameters),
        ('ccpProvideControlParameters', _OMA_LPPe_AGNSS_CCPassistCommonProvide_ccpProvideControlParameters),
        ])
    OMA_LPPe_AGNSS_CCPassistCommonProvide._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPprovideCommonParameters >-----#
    OMA_LPPe_AGNSS_CCPprovideCommonParameters = SEQ(name='OMA-LPPe-AGNSS-CCPprovideCommonParameters', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPprovideCommonParameters_ccpReferenceTime = SEQ(name='ccpReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    OMA_LPPe_AGNSS_CCPprovideCommonParameters._cont = ASN1Dict([
        ('ccpReferenceTime', _OMA_LPPe_AGNSS_CCPprovideCommonParameters_ccpReferenceTime),
        ])
    OMA_LPPe_AGNSS_CCPprovideCommonParameters._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPprovideControlParameters >-----#
    OMA_LPPe_AGNSS_CCPprovideControlParameters = SEQ(name='OMA-LPPe-AGNSS-CCPprovideControlParameters', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpSupportArea = SEQ(name='ccpSupportArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPsupportArea')), opt=True)
    _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpNeighborList = SEQ_OF(name='ccpNeighborList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPreferenceStationList')), opt=True)
    _OMA_LPPe_AGNSS_CCPprovideControlParameters_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')), opt=True)
    _OMA_LPPe_AGNSS_CCPprovideControlParameters_rate = INT(name='rate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_CCPprovideControlParameters_rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpReferenceStationList = SEQ_OF(name='ccpReferenceStationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPreferenceStationList')), opt=True)
    OMA_LPPe_AGNSS_CCPprovideControlParameters._cont = ASN1Dict([
        ('ccpSupportArea', _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpSupportArea),
        ('ccpNeighborList', _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpNeighborList),
        ('duration', _OMA_LPPe_AGNSS_CCPprovideControlParameters_duration),
        ('rate', _OMA_LPPe_AGNSS_CCPprovideControlParameters_rate),
        ('ccpReferenceStationList', _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpReferenceStationList),
        ])
    OMA_LPPe_AGNSS_CCPprovideControlParameters._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPsupportArea >-----#
    OMA_LPPe_AGNSS_CCPsupportArea = SEQ(name='OMA-LPPe-AGNSS-CCPsupportArea', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPsupportArea_areaDescription = SEQ(name='areaDescription', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityArea')))
    _OMA_LPPe_AGNSS_CCPsupportArea_signalSupport = SEQ_OF(name='signalSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_CCPsupportArea_signalSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPsignalSupport')))
    _OMA_LPPe_AGNSS_CCPsupportArea_signalSupport._cont = __OMA_LPPe_AGNSS_CCPsupportArea_signalSupport__item_
    _OMA_LPPe_AGNSS_CCPsupportArea_signalSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_CCPsupportArea._cont = ASN1Dict([
        ('areaDescription', _OMA_LPPe_AGNSS_CCPsupportArea_areaDescription),
        ('signalSupport', _OMA_LPPe_AGNSS_CCPsupportArea_signalSupport),
        ])
    OMA_LPPe_AGNSS_CCPsupportArea._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPsignalSupport >-----#
    OMA_LPPe_AGNSS_CCPsignalSupport = SEQ(name='OMA-LPPe-AGNSS-CCPsignalSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPsignalSupport_gnss = SEQ(name='gnss', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_CCPsignalSupport_signals = SEQ(name='signals', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    OMA_LPPe_AGNSS_CCPsignalSupport._cont = ASN1Dict([
        ('gnss', _OMA_LPPe_AGNSS_CCPsignalSupport_gnss),
        ('signals', _OMA_LPPe_AGNSS_CCPsignalSupport_signals),
        ])
    OMA_LPPe_AGNSS_CCPsignalSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPreferenceStationList >-----#
    OMA_LPPe_AGNSS_CCPreferenceStationList = SEQ_OF(name='OMA-LPPe-AGNSS-CCPreferenceStationList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPreferenceStationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPreferenceStationElement')))
    OMA_LPPe_AGNSS_CCPreferenceStationList._cont = _OMA_LPPe_AGNSS_CCPreferenceStationList__item_
    OMA_LPPe_AGNSS_CCPreferenceStationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-CCPreferenceStationElement >-----#
    OMA_LPPe_AGNSS_CCPreferenceStationElement = SEQ(name='OMA-LPPe-AGNSS-CCPreferenceStationElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPreferenceStationElement_referenceStationID = SEQ(name='referenceStationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPreferenceStationID')))
    _OMA_LPPe_AGNSS_CCPreferenceStationElement_referenceStationLocation = SEQ(name='referenceStationLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracy3Dposition')))
    _OMA_LPPe_AGNSS_CCPreferenceStationElement_antennaDescription = SEQ(name='antennaDescription', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AntennaDescription')), opt=True)
    OMA_LPPe_AGNSS_CCPreferenceStationElement._cont = ASN1Dict([
        ('referenceStationID', _OMA_LPPe_AGNSS_CCPreferenceStationElement_referenceStationID),
        ('referenceStationLocation', _OMA_LPPe_AGNSS_CCPreferenceStationElement_referenceStationLocation),
        ('antennaDescription', _OMA_LPPe_AGNSS_CCPreferenceStationElement_antennaDescription),
        ])
    OMA_LPPe_AGNSS_CCPreferenceStationElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPassistGenericProvide >-----#
    OMA_LPPe_AGNSS_CCPassistGenericProvide = SEQ_OF(name='OMA-LPPe-AGNSS-CCPassistGenericProvide', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPassistGenericProvide__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPassistGenericProvideElement')))
    OMA_LPPe_AGNSS_CCPassistGenericProvide._cont = _OMA_LPPe_AGNSS_CCPassistGenericProvide__item_
    OMA_LPPe_AGNSS_CCPassistGenericProvide._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-CCPassistGenericProvideElement >-----#
    OMA_LPPe_AGNSS_CCPassistGenericProvideElement = SEQ(name='OMA-LPPe-AGNSS-CCPassistGenericProvideElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_referenceStationID = SEQ(name='referenceStationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPreferenceStationID')))
    _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList = SEQ_OF(name='ccpPerSignalList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPperSignalElement')))
    _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList._cont = __OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList__item_
    _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_CCPassistGenericProvideElement._cont = ASN1Dict([
        ('referenceStationID', _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_referenceStationID),
        ('ccpPerSignalList', _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList),
        ])
    OMA_LPPe_AGNSS_CCPassistGenericProvideElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPperSignalElement >-----#
    OMA_LPPe_AGNSS_CCPperSignalElement = SEQ(name='OMA-LPPe-AGNSS-CCPperSignalElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPperSignalElement_signal_ID = SEQ(name='signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist = SEQ_OF(name='ccpPerSVlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPperSVelement')))
    _OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist._cont = __OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist__item_
    _OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_AGNSS_CCPperSignalElement._cont = ASN1Dict([
        ('signal-ID', _OMA_LPPe_AGNSS_CCPperSignalElement_signal_ID),
        ('ccpPerSVlist', _OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist),
        ])
    OMA_LPPe_AGNSS_CCPperSignalElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPperSVelement >-----#
    OMA_LPPe_AGNSS_CCPperSVelement = SEQ(name='OMA-LPPe-AGNSS-CCPperSVelement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPperSVelement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_AGNSS_CCPperSVelement_integerCodePhase = INT(name='integerCodePhase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_CCPperSVelement_integerCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_AGNSS_CCPperSVelement_codePhase = INT(name='codePhase', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_CCPperSVelement_codePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14989622)], ev=None, er=[])
    _OMA_LPPe_AGNSS_CCPperSVelement_codePhaseError = CHOICE(name='codePhaseError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CodePhaseError')), opt=True)
    _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeDelta = INT(name='phaseRangeDelta', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-524288, ub=524287)], ev=None, er=[])
    _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeRMSerror = INT(name='phaseRangeRMSerror', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeRMSerror._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_CCPperSVelement_lockIndicator = BOOL(name='lockIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_AGNSS_CCPperSVelement._cont = ASN1Dict([
        ('svID', _OMA_LPPe_AGNSS_CCPperSVelement_svID),
        ('integerCodePhase', _OMA_LPPe_AGNSS_CCPperSVelement_integerCodePhase),
        ('codePhase', _OMA_LPPe_AGNSS_CCPperSVelement_codePhase),
        ('codePhaseError', _OMA_LPPe_AGNSS_CCPperSVelement_codePhaseError),
        ('phaseRangeDelta', _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeDelta),
        ('phaseRangeRMSerror', _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeRMSerror),
        ('lockIndicator', _OMA_LPPe_AGNSS_CCPperSVelement_lockIndicator),
        ])
    OMA_LPPe_AGNSS_CCPperSVelement._ext = []
    
    #-----< OMA-LPPe-AGNSS-CodePhaseError >-----#
    OMA_LPPe_AGNSS_CodePhaseError = CHOICE(name='OMA-LPPe-AGNSS-CodePhaseError', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CodePhaseError_codePhaseRMSError = INT(name='codePhaseRMSError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_CodePhaseError_codePhaseRMSError._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_AGNSS_CodePhaseError_cnr = INT(name='cnr', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_CodePhaseError_cnr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    OMA_LPPe_AGNSS_CodePhaseError._cont = ASN1Dict([
        ('codePhaseRMSError', _OMA_LPPe_AGNSS_CodePhaseError_codePhaseRMSError),
        ('cnr', _OMA_LPPe_AGNSS_CodePhaseError_cnr),
        ])
    OMA_LPPe_AGNSS_CodePhaseError._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModelList >-----#
    OMA_LPPe_AGNSS_NavModelList = SEQ(name='OMA-LPPe-AGNSS-NavModelList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModelList_coordinateBased = SEQ(name='coordinateBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-CoordinateBased')), opt=True)
    OMA_LPPe_AGNSS_NavModelList._cont = ASN1Dict([
        ('coordinateBased', _OMA_LPPe_AGNSS_NavModelList_coordinateBased),
        ])
    OMA_LPPe_AGNSS_NavModelList._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModel-CoordinateBased >-----#
    OMA_LPPe_AGNSS_NavModel_CoordinateBased = SEQ(name='OMA-LPPe-AGNSS-NavModel-CoordinateBased', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval = SEQ(name='fixedInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_beginTime = SEQ(name='beginTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_interval = INT(name='interval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval._cont = ASN1Dict([
        ('beginTime', __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_beginTime),
        ('interval', __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_interval),
        ])
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval._ext = []
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases = SEQ(name='bases', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForPosVel = INT(name='baseForPosVel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForPosVel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100000000, ub=100000000)], ev=None, er=[])
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForCcRate = SEQ(name='baseForCcRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')), opt=True)
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases._cont = ASN1Dict([
        ('baseForPosVel', __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForPosVel),
        ('baseForCcRate', __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForCcRate),
        ])
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases._ext = []
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_referencedTo = ENUM(name='referencedTo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_referencedTo._cont = ASN1Dict([('centerOfMass', 0), ('antennaPhaseCenter', 1)])
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_referencedTo._ext = []
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList = SEQ_OF(name='pointList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-CoordinateBasedElement')))
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList._cont = __OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList__item_
    _OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=97)], ev=None, er=[])
    OMA_LPPe_AGNSS_NavModel_CoordinateBased._cont = ASN1Dict([
        ('fixedInterval', _OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval),
        ('bases', _OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases),
        ('referencedTo', _OMA_LPPe_AGNSS_NavModel_CoordinateBased_referencedTo),
        ('pointList', _OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList),
        ])
    OMA_LPPe_AGNSS_NavModel_CoordinateBased._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModel-CoordinateBasedElement >-----#
    OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement = SEQ(name='OMA-LPPe-AGNSS-NavModel-CoordinateBasedElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_time_of_record = SEQ(name='time-of-record', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')), opt=True)
    _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList = SEQ_OF(name='svIdList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-PVTelement')))
    _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList._cont = __OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList__item_
    _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement._cont = ASN1Dict([
        ('time-of-record', _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_time_of_record),
        ('svIdList', _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList),
        ])
    OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModel-PVTelement >-----#
    OMA_LPPe_AGNSS_NavModel_PVTelement = SEQ(name='OMA-LPPe-AGNSS-NavModel-PVTelement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModel_PVTelement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_svClockOffset = SEQ(name='svClockOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionX = SEQ(name='ecefPositionX', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionY = SEQ(name='ecefPositionY', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionZ = SEQ(name='ecefPositionZ', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_clockPosSTD = SEQ(name='clockPosSTD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-STDmatrix')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord = SEQ(name='rateRecord', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_svClockRate = SEQ(name='svClockRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityX = SEQ(name='ecefVelocityX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityY = SEQ(name='ecefVelocityY', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityZ = SEQ(name='ecefVelocityZ', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-BigNumber')))
    __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_clockRateVelSTD = SEQ(name='clockRateVelSTD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModel-STDmatrix')))
    _OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord._cont = ASN1Dict([
        ('svClockRate', __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_svClockRate),
        ('ecefVelocityX', __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityX),
        ('ecefVelocityY', __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityY),
        ('ecefVelocityZ', __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityZ),
        ('clockRateVelSTD', __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_clockRateVelSTD),
        ])
    _OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord._ext = []
    OMA_LPPe_AGNSS_NavModel_PVTelement._cont = ASN1Dict([
        ('svID', _OMA_LPPe_AGNSS_NavModel_PVTelement_svID),
        ('svClockOffset', _OMA_LPPe_AGNSS_NavModel_PVTelement_svClockOffset),
        ('ecefPositionX', _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionX),
        ('ecefPositionY', _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionY),
        ('ecefPositionZ', _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionZ),
        ('clockPosSTD', _OMA_LPPe_AGNSS_NavModel_PVTelement_clockPosSTD),
        ('rateRecord', _OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord),
        ])
    OMA_LPPe_AGNSS_NavModel_PVTelement._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModel-BigNumber >-----#
    OMA_LPPe_AGNSS_NavModel_BigNumber = SEQ(name='OMA-LPPe-AGNSS-NavModel-BigNumber', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModel_BigNumber_msb = INT(name='msb', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_NavModel_BigNumber_msb._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1000000000, ub=1000000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_BigNumber_lsb = INT(name='lsb', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_BigNumber_lsb._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    OMA_LPPe_AGNSS_NavModel_BigNumber._cont = ASN1Dict([
        ('msb', _OMA_LPPe_AGNSS_NavModel_BigNumber_msb),
        ('lsb', _OMA_LPPe_AGNSS_NavModel_BigNumber_lsb),
        ])
    OMA_LPPe_AGNSS_NavModel_BigNumber._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModel-STDmatrix >-----#
    OMA_LPPe_AGNSS_NavModel_STDmatrix = SEQ(name='OMA-LPPe-AGNSS-NavModel-STDmatrix', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e11 = INT(name='e11', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e11._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e22 = INT(name='e22', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e22._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e33 = INT(name='e33', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e33._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e44 = INT(name='e44', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e44._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e12 = INT(name='e12', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e13 = INT(name='e13', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e13._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e14 = INT(name='e14', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e14._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e23 = INT(name='e23', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e23._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e24 = INT(name='e24', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e24._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e34 = INT(name='e34', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_NavModel_STDmatrix_e34._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000)], ev=None, er=[])
    OMA_LPPe_AGNSS_NavModel_STDmatrix._cont = ASN1Dict([
        ('e11', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e11),
        ('e22', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e22),
        ('e33', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e33),
        ('e44', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e44),
        ('e12', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e12),
        ('e13', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e13),
        ('e14', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e14),
        ('e23', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e23),
        ('e24', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e24),
        ('e34', _OMA_LPPe_AGNSS_NavModel_STDmatrix_e34),
        ])
    OMA_LPPe_AGNSS_NavModel_STDmatrix._ext = []
    
    #-----< OMA-LPPe-AGNSS-RequestAssistanceData >-----#
    OMA_LPPe_AGNSS_RequestAssistanceData = SEQ(name='OMA-LPPe-AGNSS-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_RequestAssistanceData_commonAssistDataReq = SEQ(name='commonAssistDataReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CommonAssistanceDataReq')), opt=True)
    _OMA_LPPe_AGNSS_RequestAssistanceData_genericAssistDataReq = SEQ_OF(name='genericAssistDataReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-GenericAssistanceDataReq')), opt=True)
    OMA_LPPe_AGNSS_RequestAssistanceData._cont = ASN1Dict([
        ('commonAssistDataReq', _OMA_LPPe_AGNSS_RequestAssistanceData_commonAssistDataReq),
        ('genericAssistDataReq', _OMA_LPPe_AGNSS_RequestAssistanceData_genericAssistDataReq),
        ])
    OMA_LPPe_AGNSS_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-AGNSS-CommonAssistanceDataReq >-----#
    OMA_LPPe_AGNSS_CommonAssistanceDataReq = SEQ(name='OMA-LPPe-AGNSS-CommonAssistanceDataReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CommonAssistanceDataReq_ionosphericModelReq = CHOICE(name='ionosphericModelReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-IonosphericModelReq')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataReq_troposphereModelReq = SEQ(name='troposphereModelReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TroposphereModelReq')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataReq_altitudeAssistanceReq = SEQ(name='altitudeAssistanceReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AltitudeAssistanceReq')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataReq_solarRadiationRequest = SEQ(name='solarRadiationRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-SolarRadiationReq')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataReq_ccpRequestControlParameters = SEQ(name='ccpRequestControlParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPrequestControlParameters')), opt=True)
    OMA_LPPe_AGNSS_CommonAssistanceDataReq._cont = ASN1Dict([
        ('ionosphericModelReq', _OMA_LPPe_AGNSS_CommonAssistanceDataReq_ionosphericModelReq),
        ('troposphereModelReq', _OMA_LPPe_AGNSS_CommonAssistanceDataReq_troposphereModelReq),
        ('altitudeAssistanceReq', _OMA_LPPe_AGNSS_CommonAssistanceDataReq_altitudeAssistanceReq),
        ('solarRadiationRequest', _OMA_LPPe_AGNSS_CommonAssistanceDataReq_solarRadiationRequest),
        ('ccpRequestControlParameters', _OMA_LPPe_AGNSS_CommonAssistanceDataReq_ccpRequestControlParameters),
        ])
    OMA_LPPe_AGNSS_CommonAssistanceDataReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-GenericAssistanceDataReq >-----#
    OMA_LPPe_AGNSS_GenericAssistanceDataReq = SEQ_OF(name='OMA-LPPe-AGNSS-GenericAssistanceDataReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_GenericAssistanceDataReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-GenericAssistDataReqElement')))
    OMA_LPPe_AGNSS_GenericAssistanceDataReq._cont = _OMA_LPPe_AGNSS_GenericAssistanceDataReq__item_
    OMA_LPPe_AGNSS_GenericAssistanceDataReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-GenericAssistDataReqElement >-----#
    OMA_LPPe_AGNSS_GenericAssistDataReqElement = SEQ(name='OMA-LPPe-AGNSS-GenericAssistDataReqElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_waIonoSurfaceReq = SEQ(name='waIonoSurfaceReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-WaIonoSurfaceRequest')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_mechanicsReq = SEQ(name='mechanicsReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-MechanicsReq')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_dcbReq = SEQ(name='dcbReq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-DCBreq')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_navModelDegradationModelReq = SEQ(name='navModelDegradationModelReq', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModelDegradationModelReq')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_ccpAssistGenericReq = SEQ(name='ccpAssistGenericReq', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPassistGenericReq')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataReqElement_navigationModelReq = SEQ(name='navigationModelReq', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavigationModelReq')), opt=True)
    OMA_LPPe_AGNSS_GenericAssistDataReqElement._cont = ASN1Dict([
        ('gnss-ID', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_gnss_ID),
        ('waIonoSurfaceReq', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_waIonoSurfaceReq),
        ('mechanicsReq', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_mechanicsReq),
        ('dcbReq', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_dcbReq),
        ('navModelDegradationModelReq', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_navModelDegradationModelReq),
        ('ccpAssistGenericReq', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_ccpAssistGenericReq),
        ('navigationModelReq', _OMA_LPPe_AGNSS_GenericAssistDataReqElement_navigationModelReq),
        ])
    OMA_LPPe_AGNSS_GenericAssistDataReqElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-IonosphericModelReq >-----#
    OMA_LPPe_AGNSS_IonosphericModelReq = CHOICE(name='OMA-LPPe-AGNSS-IonosphericModelReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_IonosphericModelReq_staticModels = SEQ(name='staticModels', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_ionoreq = BIT_STR(name='ionoreq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_ionoreq._cont = ASN1Dict([('klobucharModel', 0), ('ionoStormWarning', 1)])
    __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_ionoreq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_requestBeginTime = SEQ(name='requestBeginTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')), opt=True)
    __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')))
    _OMA_LPPe_AGNSS_IonosphericModelReq_staticModels._cont = ASN1Dict([
        ('ionoreq', __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_ionoreq),
        ('requestBeginTime', __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_requestBeginTime),
        ('duration', __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_duration),
        ])
    _OMA_LPPe_AGNSS_IonosphericModelReq_staticModels._ext = []
    _OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels = SEQ(name='periodicModels', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels_waIonoSurface = SEQ(name='waIonoSurface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersRequest')))
    _OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels._cont = ASN1Dict([
        ('waIonoSurface', __OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels_waIonoSurface),
        ])
    _OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels._ext = []
    OMA_LPPe_AGNSS_IonosphericModelReq._cont = ASN1Dict([
        ('staticModels', _OMA_LPPe_AGNSS_IonosphericModelReq_staticModels),
        ('periodicModels', _OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels),
        ])
    OMA_LPPe_AGNSS_IonosphericModelReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersRequest >-----#
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest = SEQ(name='OMA-LPPe-AGNSS-WideAreaIonoSurfaceControlParametersRequest', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_rate = INT(name='rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest._cont = ASN1Dict([
        ('duration', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_duration),
        ('rate', _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_rate),
        ])
    OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest._ext = []
    
    #-----< OMA-LPPe-AGNSS-TroposphereModelReq >-----#
    OMA_LPPe_AGNSS_TroposphereModelReq = SEQ(name='OMA-LPPe-AGNSS-TroposphereModelReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TroposphereModelReq_troposphereModelReq = BIT_STR(name='troposphereModelReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TroposphereModelReq_troposphereModelReq._cont = ASN1Dict([('delay', 0), ('surface', 1)])
    _OMA_LPPe_AGNSS_TroposphereModelReq_troposphereModelReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_AGNSS_TroposphereModelReq_supportForMultipleGridPoints = BOOL(name='supportForMultipleGridPoints', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TroposphereModelReq_requestBeginTime = SEQ(name='requestBeginTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')), opt=True)
    _OMA_LPPe_AGNSS_TroposphereModelReq_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')))
    OMA_LPPe_AGNSS_TroposphereModelReq._cont = ASN1Dict([
        ('troposphereModelReq', _OMA_LPPe_AGNSS_TroposphereModelReq_troposphereModelReq),
        ('supportForMultipleGridPoints', _OMA_LPPe_AGNSS_TroposphereModelReq_supportForMultipleGridPoints),
        ('requestBeginTime', _OMA_LPPe_AGNSS_TroposphereModelReq_requestBeginTime),
        ('duration', _OMA_LPPe_AGNSS_TroposphereModelReq_duration),
        ])
    OMA_LPPe_AGNSS_TroposphereModelReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-AltitudeAssistanceReq >-----#
    OMA_LPPe_AGNSS_AltitudeAssistanceReq = SEQ(name='OMA-LPPe-AGNSS-AltitudeAssistanceReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_AltitudeAssistanceReq_requestBeginTime = SEQ(name='requestBeginTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')), opt=True)
    _OMA_LPPe_AGNSS_AltitudeAssistanceReq_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')), opt=True)
    OMA_LPPe_AGNSS_AltitudeAssistanceReq._cont = ASN1Dict([
        ('requestBeginTime', _OMA_LPPe_AGNSS_AltitudeAssistanceReq_requestBeginTime),
        ('duration', _OMA_LPPe_AGNSS_AltitudeAssistanceReq_duration),
        ])
    OMA_LPPe_AGNSS_AltitudeAssistanceReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-SolarRadiationReq >-----#
    OMA_LPPe_AGNSS_SolarRadiationReq = SEQ(name='OMA-LPPe-AGNSS-SolarRadiationReq', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_SolarRadiationReq._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_SolarRadiationReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-WaIonoSurfaceRequest >-----#
    OMA_LPPe_AGNSS_WaIonoSurfaceRequest = SEQ(name='OMA-LPPe-AGNSS-WaIonoSurfaceRequest', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_WaIonoSurfaceRequest._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_WaIonoSurfaceRequest._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModelDegradationModelReq >-----#
    OMA_LPPe_AGNSS_NavModelDegradationModelReq = SEQ(name='OMA-LPPe-AGNSS-NavModelDegradationModelReq', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_NavModelDegradationModelReq._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_NavModelDegradationModelReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-DCBreq >-----#
    OMA_LPPe_AGNSS_DCBreq = SEQ(name='OMA-LPPe-AGNSS-DCBreq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_DCBreq_reference = SEQ(name='reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_DCBreq_reference_signal = SEQ(name='signal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    __OMA_LPPe_AGNSS_DCBreq_reference_pd = ENUM(name='pd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_DCBreq_reference_pd._cont = ASN1Dict([('pilot', 0), ('data', 1), ('notapplicable', 2)])
    __OMA_LPPe_AGNSS_DCBreq_reference_pd._ext = []
    _OMA_LPPe_AGNSS_DCBreq_reference._cont = ASN1Dict([
        ('signal', __OMA_LPPe_AGNSS_DCBreq_reference_signal),
        ('pd', __OMA_LPPe_AGNSS_DCBreq_reference_pd),
        ])
    _OMA_LPPe_AGNSS_DCBreq_reference._ext = []
    OMA_LPPe_AGNSS_DCBreq._cont = ASN1Dict([
        ('reference', _OMA_LPPe_AGNSS_DCBreq_reference),
        ])
    OMA_LPPe_AGNSS_DCBreq._ext = []
    
    #-----< OMA-LPPe-AGNSS-MechanicsReq >-----#
    OMA_LPPe_AGNSS_MechanicsReq = SEQ(name='OMA-LPPe-AGNSS-MechanicsReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_MechanicsReq_massRequest = BOOL(name='massRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_MechanicsReq_effectiveReflectivityAreaRequest = BOOL(name='effectiveReflectivityAreaRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_MechanicsReq_pcoRequest = BOOL(name='pcoRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_MechanicsReq_svInfoRequest = BOOL(name='svInfoRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_AGNSS_MechanicsReq._cont = ASN1Dict([
        ('massRequest', _OMA_LPPe_AGNSS_MechanicsReq_massRequest),
        ('effectiveReflectivityAreaRequest', _OMA_LPPe_AGNSS_MechanicsReq_effectiveReflectivityAreaRequest),
        ('pcoRequest', _OMA_LPPe_AGNSS_MechanicsReq_pcoRequest),
        ('svInfoRequest', _OMA_LPPe_AGNSS_MechanicsReq_svInfoRequest),
        ])
    OMA_LPPe_AGNSS_MechanicsReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPrequestControlParameters >-----#
    OMA_LPPe_AGNSS_CCPrequestControlParameters = SEQ(name='OMA-LPPe-AGNSS-CCPrequestControlParameters', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpSupportAreaRequest = NULL(name='ccpSupportAreaRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpNeighborListRequest = NULL(name='ccpNeighborListRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest = SEQ(name='ccpCommonRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')), opt=True)
    __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_rate = INT(name='rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation = CHOICE(name='refStation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest = SEQ(name='posBasedReferenceStationRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest_requestedReferenceStationLocation = SEQ(name='requestedReferenceStationLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HighAccuracy3Dposition')))
    ____OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest_qor = ENUM(name='qor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-QoR')))
    ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest._cont = ASN1Dict([
        ('requestedReferenceStationLocation', ____OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest_requestedReferenceStationLocation),
        ('qor', ____OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest_qor),
        ])
    ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest._ext = []
    ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_idBasedReferenceStationRequest = SEQ_OF(name='idBasedReferenceStationRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-ReferenceStationIDlist')))
    ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_referenceStationKillList = SEQ_OF(name='referenceStationKillList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-ReferenceStationIDlist')))
    __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation._cont = ASN1Dict([
        ('posBasedReferenceStationRequest', ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest),
        ('idBasedReferenceStationRequest', ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_idBasedReferenceStationRequest),
        ('referenceStationKillList', ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_referenceStationKillList),
        ])
    __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation._ext = []
    _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest._cont = ASN1Dict([
        ('duration', __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_duration),
        ('rate', __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_rate),
        ('refStation', __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation),
        ])
    _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest._ext = []
    OMA_LPPe_AGNSS_CCPrequestControlParameters._cont = ASN1Dict([
        ('ccpSupportAreaRequest', _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpSupportAreaRequest),
        ('ccpNeighborListRequest', _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpNeighborListRequest),
        ('ccpCommonRequest', _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest),
        ])
    OMA_LPPe_AGNSS_CCPrequestControlParameters._ext = []
    
    #-----< OMA-LPPe-AGNSS-ReferenceStationIDlist >-----#
    OMA_LPPe_AGNSS_ReferenceStationIDlist = SEQ_OF(name='OMA-LPPe-AGNSS-ReferenceStationIDlist', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_ReferenceStationIDlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPreferenceStationID')))
    OMA_LPPe_AGNSS_ReferenceStationIDlist._cont = _OMA_LPPe_AGNSS_ReferenceStationIDlist__item_
    OMA_LPPe_AGNSS_ReferenceStationIDlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-QoR >-----#
    OMA_LPPe_AGNSS_QoR = ENUM(name='OMA-LPPe-AGNSS-QoR', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_QoR._cont = ASN1Dict([('m10', 0), ('km1', 1), ('km10', 2), ('km100', 3)])
    OMA_LPPe_AGNSS_QoR._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPassistGenericReq >-----#
    OMA_LPPe_AGNSS_CCPassistGenericReq = SEQ(name='OMA-LPPe-AGNSS-CCPassistGenericReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPassistGenericReq_ccpAssist_SignalsReq = SEQ(name='ccpAssist-SignalsReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    OMA_LPPe_AGNSS_CCPassistGenericReq._cont = ASN1Dict([
        ('ccpAssist-SignalsReq', _OMA_LPPe_AGNSS_CCPassistGenericReq_ccpAssist_SignalsReq),
        ])
    OMA_LPPe_AGNSS_CCPassistGenericReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavigationModelReq >-----#
    OMA_LPPe_AGNSS_NavigationModelReq = SEQ(name='OMA-LPPe-AGNSS-NavigationModelReq', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList = SEQ_OF(name='navModelID-PrefList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList__item_ = INT(name='_item_', mode=MODE_TYPE)
    __OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList._cont = __OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList__item_
    _OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_NavigationModelReq._cont = ASN1Dict([
        ('navModelID-PrefList', _OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList),
        ])
    OMA_LPPe_AGNSS_NavigationModelReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-ProvideLocationInformation >-----#
    OMA_LPPe_AGNSS_ProvideLocationInformation = SEQ(name='OMA-LPPe-AGNSS-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_ProvideLocationInformation_highAccuracyReferenceTime = SEQ(name='highAccuracyReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')), opt=True)
    _OMA_LPPe_AGNSS_ProvideLocationInformation_highAccuracyMeasurements = CHOICE(name='highAccuracyMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-HAgnssProvide')), opt=True)
    _OMA_LPPe_AGNSS_ProvideLocationInformation_ionosphereMeasurements = SEQ(name='ionosphereMeasurements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-IonosphereMeasurements')), opt=True)
    _OMA_LPPe_AGNSS_ProvideLocationInformation_localSurfaceMeasurements = SEQ(name='localSurfaceMeasurements', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalSurfaceMeasurements')), opt=True)
    _OMA_LPPe_AGNSS_ProvideLocationInformation_error = CHOICE(name='error', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-Error')), opt=True)
    OMA_LPPe_AGNSS_ProvideLocationInformation._cont = ASN1Dict([
        ('highAccuracyReferenceTime', _OMA_LPPe_AGNSS_ProvideLocationInformation_highAccuracyReferenceTime),
        ('highAccuracyMeasurements', _OMA_LPPe_AGNSS_ProvideLocationInformation_highAccuracyMeasurements),
        ('ionosphereMeasurements', _OMA_LPPe_AGNSS_ProvideLocationInformation_ionosphereMeasurements),
        ('localSurfaceMeasurements', _OMA_LPPe_AGNSS_ProvideLocationInformation_localSurfaceMeasurements),
        ('error', _OMA_LPPe_AGNSS_ProvideLocationInformation_error),
        ])
    OMA_LPPe_AGNSS_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-AGNSS-HAgnssProvide >-----#
    OMA_LPPe_AGNSS_HAgnssProvide = CHOICE(name='OMA-LPPe-AGNSS-HAgnssProvide', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_HAgnssProvide_controlParameters = SEQ(name='controlParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')))
    __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_rate = INT(name='rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_antennaDescription = SEQ(name='antennaDescription', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AntennaDescription')), opt=True)
    _OMA_LPPe_AGNSS_HAgnssProvide_controlParameters._cont = ASN1Dict([
        ('duration', __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_duration),
        ('rate', __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_rate),
        ('antennaDescription', __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_antennaDescription),
        ])
    _OMA_LPPe_AGNSS_HAgnssProvide_controlParameters._ext = []
    _OMA_LPPe_AGNSS_HAgnssProvide_measurements = SEQ(name='measurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_position = SEQ(name='position', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')), opt=True)
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_referenceTime = SEQ(name='referenceTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure = SEQ(name='localPressure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressure = INT(name='pressure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressureUncertainty = INT(name='pressureUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressureUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure._cont = ASN1Dict([
        ('pressure', ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressure),
        ('pressureUncertainty', ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressureUncertainty),
        ])
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure._ext = []
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_antennaOrientation = CHOICE(name='antennaOrientation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Orientation')), opt=True)
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements = SEQ_OF(name='signalMeasurements', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-HAgnssMeasurementElement')))
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements._cont = ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements__item_
    __OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_AGNSS_HAgnssProvide_measurements._cont = ASN1Dict([
        ('position', __OMA_LPPe_AGNSS_HAgnssProvide_measurements_position),
        ('referenceTime', __OMA_LPPe_AGNSS_HAgnssProvide_measurements_referenceTime),
        ('localPressure', __OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure),
        ('antennaOrientation', __OMA_LPPe_AGNSS_HAgnssProvide_measurements_antennaOrientation),
        ('signalMeasurements', __OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements),
        ])
    _OMA_LPPe_AGNSS_HAgnssProvide_measurements._ext = []
    OMA_LPPe_AGNSS_HAgnssProvide._cont = ASN1Dict([
        ('controlParameters', _OMA_LPPe_AGNSS_HAgnssProvide_controlParameters),
        ('measurements', _OMA_LPPe_AGNSS_HAgnssProvide_measurements),
        ])
    OMA_LPPe_AGNSS_HAgnssProvide._ext = []
    
    #-----< OMA-LPPe-AGNSS-HAgnssMeasurementElement >-----#
    OMA_LPPe_AGNSS_HAgnssMeasurementElement = SEQ(name='OMA-LPPe-AGNSS-HAgnssMeasurementElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_HAgnssMeasurementElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList = SEQ_OF(name='haGNSSperSignalList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HAgnssPerSignalElement')))
    _OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList._cont = __OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList__item_
    _OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_HAgnssMeasurementElement._cont = ASN1Dict([
        ('gnss-ID', _OMA_LPPe_AGNSS_HAgnssMeasurementElement_gnss_ID),
        ('haGNSSperSignalList', _OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList),
        ])
    OMA_LPPe_AGNSS_HAgnssMeasurementElement._ext = []
    
    #-----< OMA-LPPe-HAgnssPerSignalElement >-----#
    OMA_LPPe_HAgnssPerSignalElement = SEQ(name='OMA-LPPe-HAgnssPerSignalElement', mode=MODE_TYPE)
    _OMA_LPPe_HAgnssPerSignalElement_signal_ID = SEQ(name='signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalID')))
    _OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist = SEQ_OF(name='haGNSSperSVlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-HAgnssPerSVelement')))
    _OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist._cont = __OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist__item_
    _OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_HAgnssPerSignalElement._cont = ASN1Dict([
        ('signal-ID', _OMA_LPPe_HAgnssPerSignalElement_signal_ID),
        ('haGNSSperSVlist', _OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist),
        ])
    OMA_LPPe_HAgnssPerSignalElement._ext = []
    
    #-----< OMA-LPPe-HAgnssPerSVelement >-----#
    OMA_LPPe_HAgnssPerSVelement = SEQ(name='OMA-LPPe-HAgnssPerSVelement', mode=MODE_TYPE)
    _OMA_LPPe_HAgnssPerSVelement_svID = SEQ(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'SV-ID')))
    _OMA_LPPe_HAgnssPerSVelement_integerCodePhase = INT(name='integerCodePhase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_HAgnssPerSVelement_integerCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HAgnssPerSVelement_codePhase = INT(name='codePhase', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HAgnssPerSVelement_codePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14989622)], ev=None, er=[])
    _OMA_LPPe_HAgnssPerSVelement_codePhaseRMSError = INT(name='codePhaseRMSError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HAgnssPerSVelement_codePhaseRMSError._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_HAgnssPerSVelement_multipathDetection = ENUM(name='multipathDetection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HAgnssPerSVelement_multipathDetection._cont = ASN1Dict([('low', 0), ('moderate', 1), ('high', 2), ('notMeasured', 3)])
    _OMA_LPPe_HAgnssPerSVelement_multipathDetection._ext = []
    _OMA_LPPe_HAgnssPerSVelement_cnr = INT(name='cnr', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HAgnssPerSVelement_cnr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_HAgnssPerSVelement_adr = INT(name='adr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HAgnssPerSVelement_adr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=536870911)], ev=None, er=[])
    _OMA_LPPe_HAgnssPerSVelement_adrRMSerror = INT(name='adrRMSerror', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_HAgnssPerSVelement_adrRMSerror._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _OMA_LPPe_HAgnssPerSVelement_lockIndicator = BOOL(name='lockIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_HAgnssPerSVelement._cont = ASN1Dict([
        ('svID', _OMA_LPPe_HAgnssPerSVelement_svID),
        ('integerCodePhase', _OMA_LPPe_HAgnssPerSVelement_integerCodePhase),
        ('codePhase', _OMA_LPPe_HAgnssPerSVelement_codePhase),
        ('codePhaseRMSError', _OMA_LPPe_HAgnssPerSVelement_codePhaseRMSError),
        ('multipathDetection', _OMA_LPPe_HAgnssPerSVelement_multipathDetection),
        ('cnr', _OMA_LPPe_HAgnssPerSVelement_cnr),
        ('adr', _OMA_LPPe_HAgnssPerSVelement_adr),
        ('adrRMSerror', _OMA_LPPe_HAgnssPerSVelement_adrRMSerror),
        ('lockIndicator', _OMA_LPPe_HAgnssPerSVelement_lockIndicator),
        ])
    OMA_LPPe_HAgnssPerSVelement._ext = []
    
    #-----< OMA-LPPe-AGNSS-IonosphereMeasurements >-----#
    OMA_LPPe_AGNSS_IonosphereMeasurements = SEQ(name='OMA-LPPe-AGNSS-IonosphereMeasurements', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_IonosphereMeasurements_gnssTime = SEQ(name='gnssTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    _OMA_LPPe_AGNSS_IonosphereMeasurements_position = SEQ(name='position', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')))
    _OMA_LPPe_AGNSS_IonosphereMeasurements_tecPerSV = SEQ_OF(name='tecPerSV', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TECPerSV')), opt=True)
    _OMA_LPPe_AGNSS_IonosphereMeasurements_tecAtZenith = SEQ(name='tecAtZenith', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TECAtZenith')), opt=True)
    OMA_LPPe_AGNSS_IonosphereMeasurements._cont = ASN1Dict([
        ('gnssTime', _OMA_LPPe_AGNSS_IonosphereMeasurements_gnssTime),
        ('position', _OMA_LPPe_AGNSS_IonosphereMeasurements_position),
        ('tecPerSV', _OMA_LPPe_AGNSS_IonosphereMeasurements_tecPerSV),
        ('tecAtZenith', _OMA_LPPe_AGNSS_IonosphereMeasurements_tecAtZenith),
        ])
    OMA_LPPe_AGNSS_IonosphereMeasurements._ext = []
    
    #-----< OMA-LPPe-AGNSS-TECPerSV >-----#
    OMA_LPPe_AGNSS_TECPerSV = SEQ_OF(name='OMA-LPPe-AGNSS-TECPerSV', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TECPerSV__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TECPerSVElement')))
    OMA_LPPe_AGNSS_TECPerSV._cont = _OMA_LPPe_AGNSS_TECPerSV__item_
    OMA_LPPe_AGNSS_TECPerSV._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-TECPerSVElement >-----#
    OMA_LPPe_AGNSS_TECPerSVElement = SEQ(name='OMA-LPPe-AGNSS-TECPerSVElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TECPerSVElement_azimuth = INT(name='azimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TECPerSVElement_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _OMA_LPPe_AGNSS_TECPerSVElement_elevation = INT(name='elevation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TECPerSVElement_elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=90)], ev=None, er=[])
    _OMA_LPPe_AGNSS_TECPerSVElement_tecValue = INT(name='tecValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TECPerSVElement_tecValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _OMA_LPPe_AGNSS_TECPerSVElement_tecUncertainty = INT(name='tecUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TECPerSVElement_tecUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    OMA_LPPe_AGNSS_TECPerSVElement._cont = ASN1Dict([
        ('azimuth', _OMA_LPPe_AGNSS_TECPerSVElement_azimuth),
        ('elevation', _OMA_LPPe_AGNSS_TECPerSVElement_elevation),
        ('tecValue', _OMA_LPPe_AGNSS_TECPerSVElement_tecValue),
        ('tecUncertainty', _OMA_LPPe_AGNSS_TECPerSVElement_tecUncertainty),
        ])
    OMA_LPPe_AGNSS_TECPerSVElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-TECAtZenith >-----#
    OMA_LPPe_AGNSS_TECAtZenith = SEQ(name='OMA-LPPe-AGNSS-TECAtZenith', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TECAtZenith_tecValueAtZenith = INT(name='tecValueAtZenith', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TECAtZenith_tecValueAtZenith._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _OMA_LPPe_AGNSS_TECAtZenith_tecUncertaintyAtZenith = INT(name='tecUncertaintyAtZenith', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TECAtZenith_tecUncertaintyAtZenith._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    OMA_LPPe_AGNSS_TECAtZenith._cont = ASN1Dict([
        ('tecValueAtZenith', _OMA_LPPe_AGNSS_TECAtZenith_tecValueAtZenith),
        ('tecUncertaintyAtZenith', _OMA_LPPe_AGNSS_TECAtZenith_tecUncertaintyAtZenith),
        ])
    OMA_LPPe_AGNSS_TECAtZenith._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalSurfaceMeasurements >-----#
    OMA_LPPe_AGNSS_LocalSurfaceMeasurements = SEQ(name='OMA-LPPe-AGNSS-LocalSurfaceMeasurements', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_gnssTime = SEQ(name='gnssTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SystemTime')))
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_position = SEQ(name='position', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')))
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressure = INT(name='pressure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressureUncertainty = INT(name='pressureUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressureUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement = SEQ(name='temperatureMeasurement', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperature = INT(name='temperature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperature._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperatureUncertainty = INT(name='temperatureUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperatureUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement._cont = ASN1Dict([
        ('temperature', __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperature),
        ('temperatureUncertainty', __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperatureUncertainty),
        ])
    _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement._ext = []
    OMA_LPPe_AGNSS_LocalSurfaceMeasurements._cont = ASN1Dict([
        ('gnssTime', _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_gnssTime),
        ('position', _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_position),
        ('pressure', _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressure),
        ('pressureUncertainty', _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressureUncertainty),
        ('temperatureMeasurement', _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement),
        ])
    OMA_LPPe_AGNSS_LocalSurfaceMeasurements._ext = []
    
    #-----< OMA-LPPe-AGNSS-RequestLocationInformation >-----#
    OMA_LPPe_AGNSS_RequestLocationInformation = SEQ(name='OMA-LPPe-AGNSS-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_RequestLocationInformation_positioningInstructions = SEQ(name='positioningInstructions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-PositioningInstructions')), opt=True)
    _OMA_LPPe_AGNSS_RequestLocationInformation_ionosphereMeasurementsReq = BIT_STR(name='ionosphereMeasurementsReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_RequestLocationInformation_ionosphereMeasurementsReq._cont = ASN1Dict([('tecPerSV', 0), ('zenithTEC', 1)])
    _OMA_LPPe_AGNSS_RequestLocationInformation_ionosphereMeasurementsReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_AGNSS_RequestLocationInformation_localSurfaceMeasurementReq = SEQ(name='localSurfaceMeasurementReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocalSurfaceMeasurementReq')), opt=True)
    OMA_LPPe_AGNSS_RequestLocationInformation._cont = ASN1Dict([
        ('positioningInstructions', _OMA_LPPe_AGNSS_RequestLocationInformation_positioningInstructions),
        ('ionosphereMeasurementsReq', _OMA_LPPe_AGNSS_RequestLocationInformation_ionosphereMeasurementsReq),
        ('localSurfaceMeasurementReq', _OMA_LPPe_AGNSS_RequestLocationInformation_localSurfaceMeasurementReq),
        ])
    OMA_LPPe_AGNSS_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-AGNSS-PositioningInstructions >-----#
    OMA_LPPe_AGNSS_PositioningInstructions = SEQ(name='OMA-LPPe-AGNSS-PositioningInstructions', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_PositioningInstructions_highAccuracyMethodRequested = BOOL(name='highAccuracyMethodRequested', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_PositioningInstructions_haGNSSreq = SEQ(name='haGNSSreq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-HAgnssRequestControlParameters')), opt=True)
    OMA_LPPe_AGNSS_PositioningInstructions._cont = ASN1Dict([
        ('highAccuracyMethodRequested', _OMA_LPPe_AGNSS_PositioningInstructions_highAccuracyMethodRequested),
        ('haGNSSreq', _OMA_LPPe_AGNSS_PositioningInstructions_haGNSSreq),
        ])
    OMA_LPPe_AGNSS_PositioningInstructions._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocalSurfaceMeasurementReq >-----#
    OMA_LPPe_AGNSS_LocalSurfaceMeasurementReq = SEQ(name='OMA-LPPe-AGNSS-LocalSurfaceMeasurementReq', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_LocalSurfaceMeasurementReq._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_LocalSurfaceMeasurementReq._ext = []
    
    #-----< OMA-LPPe-AGNSS-HAgnssRequestControlParameters >-----#
    OMA_LPPe_AGNSS_HAgnssRequestControlParameters = SEQ(name='OMA-LPPe-AGNSS-HAgnssRequestControlParameters', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_duration = SEQ(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Duration')), opt=True)
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_rate = INT(name='rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_antennaInformationReq = ENUM(name='antennaInformationReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_antennaInformationReq._cont = ASN1Dict([('antennaDescriptionOnly', 0), ('antennaDescriptionAndOrientation', 1)])
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_antennaInformationReq._ext = []
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_pressureInformationReq = BOOL(name='pressureInformationReq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList = SEQ_OF(name='signalReqList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-HAgnssSignalReqElement')))
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList._cont = __OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList__item_
    _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_AGNSS_HAgnssRequestControlParameters._cont = ASN1Dict([
        ('duration', _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_duration),
        ('rate', _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_rate),
        ('antennaInformationReq', _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_antennaInformationReq),
        ('pressureInformationReq', _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_pressureInformationReq),
        ('signalReqList', _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList),
        ])
    OMA_LPPe_AGNSS_HAgnssRequestControlParameters._ext = []
    
    #-----< OMA-LPPe-AGNSS-HAgnssSignalReqElement >-----#
    OMA_LPPe_AGNSS_HAgnssSignalReqElement = SEQ(name='OMA-LPPe-AGNSS-HAgnssSignalReqElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_HAgnssSignalReqElement_gnssID = SEQ(name='gnssID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_HAgnssSignalReqElement_signals = SEQ(name='signals', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    OMA_LPPe_AGNSS_HAgnssSignalReqElement._cont = ASN1Dict([
        ('gnssID', _OMA_LPPe_AGNSS_HAgnssSignalReqElement_gnssID),
        ('signals', _OMA_LPPe_AGNSS_HAgnssSignalReqElement_signals),
        ])
    OMA_LPPe_AGNSS_HAgnssSignalReqElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-ProvideCapabilities >-----#
    OMA_LPPe_AGNSS_ProvideCapabilities = SEQ(name='OMA-LPPe-AGNSS-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_ProvideCapabilities_assistanceDataSupportList = SEQ(name='assistanceDataSupportList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AssistanceDataSupportList')), opt=True)
    _OMA_LPPe_AGNSS_ProvideCapabilities_environmentObservationSupportList = SEQ(name='environmentObservationSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-EnvironmentObservationSupportList')), opt=True)
    _OMA_LPPe_AGNSS_ProvideCapabilities_haGNSSsupport = SEQ(name='haGNSSsupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-HAgnssSupport')), opt=True)
    OMA_LPPe_AGNSS_ProvideCapabilities._cont = ASN1Dict([
        ('assistanceDataSupportList', _OMA_LPPe_AGNSS_ProvideCapabilities_assistanceDataSupportList),
        ('environmentObservationSupportList', _OMA_LPPe_AGNSS_ProvideCapabilities_environmentObservationSupportList),
        ('haGNSSsupport', _OMA_LPPe_AGNSS_ProvideCapabilities_haGNSSsupport),
        ])
    OMA_LPPe_AGNSS_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-AGNSS-AssistanceDataSupportList >-----#
    OMA_LPPe_AGNSS_AssistanceDataSupportList = SEQ(name='OMA-LPPe-AGNSS-AssistanceDataSupportList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_AssistanceDataSupportList_commonAssistanceDataSupport = SEQ(name='commonAssistanceDataSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CommonAssistanceDataSupport')))
    _OMA_LPPe_AGNSS_AssistanceDataSupportList_genericAssistanceDataSupport = SEQ_OF(name='genericAssistanceDataSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-GenericAssistanceDataSupport')))
    OMA_LPPe_AGNSS_AssistanceDataSupportList._cont = ASN1Dict([
        ('commonAssistanceDataSupport', _OMA_LPPe_AGNSS_AssistanceDataSupportList_commonAssistanceDataSupport),
        ('genericAssistanceDataSupport', _OMA_LPPe_AGNSS_AssistanceDataSupportList_genericAssistanceDataSupport),
        ])
    OMA_LPPe_AGNSS_AssistanceDataSupportList._ext = []
    
    #-----< OMA-LPPe-AGNSS-EnvironmentObservationSupportList >-----#
    OMA_LPPe_AGNSS_EnvironmentObservationSupportList = SEQ(name='OMA-LPPe-AGNSS-EnvironmentObservationSupportList', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_ionosphereMeasurementSupport = BIT_STR(name='ionosphereMeasurementSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_ionosphereMeasurementSupport._cont = ASN1Dict([('tecPerSVsupport', 0), ('zenithTecSupport', 1)])
    _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_ionosphereMeasurementSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_pressureMeasurementSupported = BOOL(name='pressureMeasurementSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_temperatureMeasurementSupported = BOOL(name='temperatureMeasurementSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_AGNSS_EnvironmentObservationSupportList._cont = ASN1Dict([
        ('ionosphereMeasurementSupport', _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_ionosphereMeasurementSupport),
        ('pressureMeasurementSupported', _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_pressureMeasurementSupported),
        ('temperatureMeasurementSupported', _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_temperatureMeasurementSupported),
        ])
    OMA_LPPe_AGNSS_EnvironmentObservationSupportList._ext = []
    
    #-----< OMA-LPPe-AGNSS-CommonAssistanceDataSupport >-----#
    OMA_LPPe_AGNSS_CommonAssistanceDataSupport = SEQ(name='OMA-LPPe-AGNSS-CommonAssistanceDataSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_ionosphericModelSupport = SEQ(name='ionosphericModelSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-IonosphericModelSupport')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_troposphereModelSupport = SEQ(name='troposphereModelSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TroposphereModelSupport')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_altitudeAssistanceSupport = SEQ(name='altitudeAssistanceSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-AltitudeAssistanceSupport')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_solarRadiationSupport = SEQ(name='solarRadiationSupport', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-SolarRadiationSupport')), opt=True)
    _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_ccpSupport = SEQ(name='ccpSupport', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-CCPsupport')), opt=True)
    OMA_LPPe_AGNSS_CommonAssistanceDataSupport._cont = ASN1Dict([
        ('ionosphericModelSupport', _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_ionosphericModelSupport),
        ('troposphereModelSupport', _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_troposphereModelSupport),
        ('altitudeAssistanceSupport', _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_altitudeAssistanceSupport),
        ('solarRadiationSupport', _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_solarRadiationSupport),
        ('ccpSupport', _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_ccpSupport),
        ])
    OMA_LPPe_AGNSS_CommonAssistanceDataSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-IonosphericModelSupport >-----#
    OMA_LPPe_AGNSS_IonosphericModelSupport = SEQ(name='OMA-LPPe-AGNSS-IonosphericModelSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_IonosphericModelSupport_ionoModel = BIT_STR(name='ionoModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_IonosphericModelSupport_ionoModel._cont = ASN1Dict([('localKlobuchar', 0), ('ionoStormWarning', 1), ('wideAreaIonoSurface', 2)])
    _OMA_LPPe_AGNSS_IonosphericModelSupport_ionoModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_IonosphericModelSupport._cont = ASN1Dict([
        ('ionoModel', _OMA_LPPe_AGNSS_IonosphericModelSupport_ionoModel),
        ])
    OMA_LPPe_AGNSS_IonosphericModelSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-TroposphereModelSupport >-----#
    OMA_LPPe_AGNSS_TroposphereModelSupport = SEQ(name='OMA-LPPe-AGNSS-TroposphereModelSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TroposphereModelSupport_tropoModel = BIT_STR(name='tropoModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_TroposphereModelSupport_tropoModel._cont = ASN1Dict([('localTroposphereDelay', 0), ('surfaceParameters', 1)])
    _OMA_LPPe_AGNSS_TroposphereModelSupport_tropoModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_AGNSS_TroposphereModelSupport_supportForMultipleGridPoints = BOOL(name='supportForMultipleGridPoints', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_AGNSS_TroposphereModelSupport._cont = ASN1Dict([
        ('tropoModel', _OMA_LPPe_AGNSS_TroposphereModelSupport_tropoModel),
        ('supportForMultipleGridPoints', _OMA_LPPe_AGNSS_TroposphereModelSupport_supportForMultipleGridPoints),
        ])
    OMA_LPPe_AGNSS_TroposphereModelSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-AltitudeAssistanceSupport >-----#
    OMA_LPPe_AGNSS_AltitudeAssistanceSupport = SEQ(name='OMA-LPPe-AGNSS-AltitudeAssistanceSupport', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_AltitudeAssistanceSupport._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_AltitudeAssistanceSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-SolarRadiationSupport >-----#
    OMA_LPPe_AGNSS_SolarRadiationSupport = SEQ(name='OMA-LPPe-AGNSS-SolarRadiationSupport', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_SolarRadiationSupport._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_SolarRadiationSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPsupport >-----#
    OMA_LPPe_AGNSS_CCPsupport = SEQ(name='OMA-LPPe-AGNSS-CCPsupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPsupport_supportAreaAssistanceSupported = BOOL(name='supportAreaAssistanceSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_CCPsupport_multiReferenceStationSupported = BOOL(name='multiReferenceStationSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_AGNSS_CCPsupport._cont = ASN1Dict([
        ('supportAreaAssistanceSupported', _OMA_LPPe_AGNSS_CCPsupport_supportAreaAssistanceSupported),
        ('multiReferenceStationSupported', _OMA_LPPe_AGNSS_CCPsupport_multiReferenceStationSupported),
        ])
    OMA_LPPe_AGNSS_CCPsupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-GenericAssistanceDataSupport >-----#
    OMA_LPPe_AGNSS_GenericAssistanceDataSupport = SEQ_OF(name='OMA-LPPe-AGNSS-GenericAssistanceDataSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_GenericAssistanceDataSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-GenericAssistDataSupportElement')))
    OMA_LPPe_AGNSS_GenericAssistanceDataSupport._cont = _OMA_LPPe_AGNSS_GenericAssistanceDataSupport__item_
    OMA_LPPe_AGNSS_GenericAssistanceDataSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-AGNSS-GenericAssistDataSupportElement >-----#
    OMA_LPPe_AGNSS_GenericAssistDataSupportElement = SEQ(name='OMA-LPPe-AGNSS-GenericAssistDataSupportElement', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_mechnanicsSupport = SEQ(name='mechnanicsSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-MechanicsSupport')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_dcbSupport = SEQ(name='dcbSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-DCBsupport')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_navModelAccuracyModelDegradationSupport = SEQ(name='navModelAccuracyModelDegradationSupport', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModelAccuracyModelDegradationSupport')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_ccpAssistanceSuppport = SEQ(name='ccpAssistanceSuppport', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')), opt=True)
    _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_navModelSupport = SEQ(name='navModelSupport', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-NavModelSupport')), opt=True)
    OMA_LPPe_AGNSS_GenericAssistDataSupportElement._cont = ASN1Dict([
        ('gnss-ID', _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_gnss_ID),
        ('mechnanicsSupport', _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_mechnanicsSupport),
        ('dcbSupport', _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_dcbSupport),
        ('navModelAccuracyModelDegradationSupport', _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_navModelAccuracyModelDegradationSupport),
        ('ccpAssistanceSuppport', _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_ccpAssistanceSuppport),
        ('navModelSupport', _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_navModelSupport),
        ])
    OMA_LPPe_AGNSS_GenericAssistDataSupportElement._ext = []
    
    #-----< OMA-LPPe-AGNSS-MechanicsSupport >-----#
    OMA_LPPe_AGNSS_MechanicsSupport = SEQ(name='OMA-LPPe-AGNSS-MechanicsSupport', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_MechanicsSupport._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_MechanicsSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-DCBsupport >-----#
    OMA_LPPe_AGNSS_DCBsupport = SEQ(name='OMA-LPPe-AGNSS-DCBsupport', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_DCBsupport._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_DCBsupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModelAccuracyModelDegradationSupport >-----#
    OMA_LPPe_AGNSS_NavModelAccuracyModelDegradationSupport = SEQ(name='OMA-LPPe-AGNSS-NavModelAccuracyModelDegradationSupport', mode=MODE_TYPE)
    OMA_LPPe_AGNSS_NavModelAccuracyModelDegradationSupport._cont = ASN1Dict([
        ])
    OMA_LPPe_AGNSS_NavModelAccuracyModelDegradationSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-NavModelSupport >-----#
    OMA_LPPe_AGNSS_NavModelSupport = SEQ(name='OMA-LPPe-AGNSS-NavModelSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_NavModelSupport_navModelSupport = SEQ_OF(name='navModelSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_NavModelSupport_navModelSupport__item_ = INT(name='_item_', mode=MODE_TYPE)
    __OMA_LPPe_AGNSS_NavModelSupport_navModelSupport__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_AGNSS_NavModelSupport_navModelSupport._cont = __OMA_LPPe_AGNSS_NavModelSupport_navModelSupport__item_
    _OMA_LPPe_AGNSS_NavModelSupport_navModelSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_NavModelSupport._cont = ASN1Dict([
        ('navModelSupport', _OMA_LPPe_AGNSS_NavModelSupport_navModelSupport),
        ])
    OMA_LPPe_AGNSS_NavModelSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-HAgnssSupport >-----#
    OMA_LPPe_AGNSS_HAgnssSupport = SEQ(name='OMA-LPPe-AGNSS-HAgnssSupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_HAgnssSupport_modeSupport = BIT_STR(name='modeSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_HAgnssSupport_modeSupport._cont = ASN1Dict([('ueBased', 0), ('ueAssisted', 1)])
    _OMA_LPPe_AGNSS_HAgnssSupport_modeSupport._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSpressureInformationSupport = BOOL(name='haGNSSpressureInformationSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSantennaInformationSupport = BIT_STR(name='haGNSSantennaInformationSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSantennaInformationSupport._cont = ASN1Dict([('antennaDescriptionSupported', 0), ('antennaOrientationSupported', 1)])
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSantennaInformationSupport._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport = SEQ_OF(name='haGNSSperGNSSsupport', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-HAgnssPerGNSSsupport')))
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport._cont = __OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport__item_
    _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_AGNSS_HAgnssSupport._cont = ASN1Dict([
        ('modeSupport', _OMA_LPPe_AGNSS_HAgnssSupport_modeSupport),
        ('haGNSSpressureInformationSupport', _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSpressureInformationSupport),
        ('haGNSSantennaInformationSupport', _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSantennaInformationSupport),
        ('haGNSSperGNSSsupport', _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport),
        ])
    OMA_LPPe_AGNSS_HAgnssSupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-HAgnssPerGNSSsupport >-----#
    OMA_LPPe_AGNSS_HAgnssPerGNSSsupport = SEQ(name='OMA-LPPe-AGNSS-HAgnssPerGNSSsupport', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_HAgnssPerGNSSsupport_gnss_ID = SEQ(name='gnss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-ID')))
    _OMA_LPPe_AGNSS_HAgnssPerGNSSsupport_haGNSSsignalSupport = SEQ(name='haGNSSsignalSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'GNSS-SignalIDs')))
    OMA_LPPe_AGNSS_HAgnssPerGNSSsupport._cont = ASN1Dict([
        ('gnss-ID', _OMA_LPPe_AGNSS_HAgnssPerGNSSsupport_gnss_ID),
        ('haGNSSsignalSupport', _OMA_LPPe_AGNSS_HAgnssPerGNSSsupport_haGNSSsignalSupport),
        ])
    OMA_LPPe_AGNSS_HAgnssPerGNSSsupport._ext = []
    
    #-----< OMA-LPPe-AGNSS-RequestCapabilities >-----#
    OMA_LPPe_AGNSS_RequestCapabilities = SEQ(name='OMA-LPPe-AGNSS-RequestCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_RequestCapabilities_assistanceDataSupportListReq = NULL(name='assistanceDataSupportListReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_RequestCapabilities_environmentObservationSupportListReq = NULL(name='environmentObservationSupportListReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_RequestCapabilities_haGNSSsupportReq = NULL(name='haGNSSsupportReq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_AGNSS_RequestCapabilities._cont = ASN1Dict([
        ('assistanceDataSupportListReq', _OMA_LPPe_AGNSS_RequestCapabilities_assistanceDataSupportListReq),
        ('environmentObservationSupportListReq', _OMA_LPPe_AGNSS_RequestCapabilities_environmentObservationSupportListReq),
        ('haGNSSsupportReq', _OMA_LPPe_AGNSS_RequestCapabilities_haGNSSsupportReq),
        ])
    OMA_LPPe_AGNSS_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-AGNSS-Error >-----#
    OMA_LPPe_AGNSS_Error = CHOICE(name='OMA-LPPe-AGNSS-Error', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_Error_agnss_locationServerErrorCauses = SEQ(name='agnss-locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-LocationServerErrorCauses')))
    _OMA_LPPe_AGNSS_Error_agnss_targetDeviceErrorCauses = SEQ(name='agnss-targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AGNSS-TargetDeviceErrorCauses')))
    OMA_LPPe_AGNSS_Error._cont = ASN1Dict([
        ('agnss-locationServerErrorCauses', _OMA_LPPe_AGNSS_Error_agnss_locationServerErrorCauses),
        ('agnss-targetDeviceErrorCauses', _OMA_LPPe_AGNSS_Error_agnss_targetDeviceErrorCauses),
        ])
    OMA_LPPe_AGNSS_Error._ext = []
    
    #-----< OMA-LPPe-AGNSS-LocationServerErrorCauses >-----#
    OMA_LPPe_AGNSS_LocationServerErrorCauses = SEQ(name='OMA-LPPe-AGNSS-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_LocationServerErrorCauses_waIonoErrorCauses = ENUM(name='waIonoErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocationServerErrorCauses_waIonoErrorCauses._cont = ASN1Dict([('undefined', 0), ('waIonoNotSupportedByServer', 1), ('waIonoNotSupportedInTargetArea', 2), ('waIonoNotSupportedForAnyRequestedGNSS', 3)])
    _OMA_LPPe_AGNSS_LocationServerErrorCauses_waIonoErrorCauses._ext = []
    _OMA_LPPe_AGNSS_LocationServerErrorCauses_ccpErrorCauses = ENUM(name='ccpErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_LocationServerErrorCauses_ccpErrorCauses._cont = ASN1Dict([('undefined', 0), ('ccpNotSupportedByServer', 1), ('ccpNotSupportedInTargetArea', 2), ('ccpNotSupportedForAnyRequestedSignal', 3), ('ccpQorCannotBeMet', 4), ('ccpUnableToModifyControlParameters', 5), ('ccpMultiReferenceStationNotSupported', 6), ('ccpNeighborListNotSupported', 7), ('ccpSupportAreaAssistanceNotSupported', 8)])
    _OMA_LPPe_AGNSS_LocationServerErrorCauses_ccpErrorCauses._ext = []
    OMA_LPPe_AGNSS_LocationServerErrorCauses._cont = ASN1Dict([
        ('waIonoErrorCauses', _OMA_LPPe_AGNSS_LocationServerErrorCauses_waIonoErrorCauses),
        ('ccpErrorCauses', _OMA_LPPe_AGNSS_LocationServerErrorCauses_ccpErrorCauses),
        ])
    OMA_LPPe_AGNSS_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-AGNSS-TargetDeviceErrorCauses >-----#
    OMA_LPPe_AGNSS_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-AGNSS-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_highAccuracyErrorCauses = ENUM(name='highAccuracyErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_highAccuracyErrorCauses._cont = ASN1Dict([('undefined', 0), ('highAccuracyMethodNotSupported', 1)])
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_highAccuracyErrorCauses._ext = []
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_ionosphereMeasurementErrorCauses = ENUM(name='ionosphereMeasurementErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_ionosphereMeasurementErrorCauses._cont = ASN1Dict([('undefined', 0), ('ionosphereMeasurementsNotSupported', 1), ('ionosphereMeasurementsNotAvailable', 2)])
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_ionosphereMeasurementErrorCauses._ext = []
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_environmentObservationErrorCauses = ENUM(name='environmentObservationErrorCauses', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_environmentObservationErrorCauses._cont = ASN1Dict([('undefined', 0), ('surfaceMeasurementsNotSupported', 1), ('surfaceMeasurementsNotAvailable', 2)])
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_environmentObservationErrorCauses._ext = []
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_haGNSSerrorCauses = ENUM(name='haGNSSerrorCauses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_haGNSSerrorCauses._cont = ASN1Dict([('undefined', 0), ('haGNSSnotSupportedByTarget', 1), ('haGNSSunavailableForAllRequestedSignals', 2), ('haGNSSantennaInformationNotSupported', 3), ('haGNSSantennaInformationNotAvailable', 4), ('haGNSSpressureInformationNotSupported', 5), ('haGNSSpressureInformationNotAvailable', 6), ('haGNSSunableToModifyControlParameters', 7)])
    _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_haGNSSerrorCauses._ext = []
    OMA_LPPe_AGNSS_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('highAccuracyErrorCauses', _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_highAccuracyErrorCauses),
        ('ionosphereMeasurementErrorCauses', _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_ionosphereMeasurementErrorCauses),
        ('environmentObservationErrorCauses', _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_environmentObservationErrorCauses),
        ('haGNSSerrorCauses', _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_haGNSSerrorCauses),
        ])
    OMA_LPPe_AGNSS_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-AGNSS-CCPreferenceStationID >-----#
    OMA_LPPe_AGNSS_CCPreferenceStationID = SEQ(name='OMA-LPPe-AGNSS-CCPreferenceStationID', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_CCPreferenceStationID_stationID = INT(name='stationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AGNSS_CCPreferenceStationID_stationID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OMA_LPPe_AGNSS_CCPreferenceStationID._cont = ASN1Dict([
        ('stationID', _OMA_LPPe_AGNSS_CCPreferenceStationID_stationID),
        ])
    OMA_LPPe_AGNSS_CCPreferenceStationID._ext = []
    
    #-----< maxReferenceStations >-----#
    maxReferenceStations = INT(name='maxReferenceStations', mode=MODE_VALUE)
    maxReferenceStations._val = 8
    
    #-----< OMA-LPPe-AGNSS-AntennaDescription >-----#
    OMA_LPPe_AGNSS_AntennaDescription = SEQ(name='OMA-LPPe-AGNSS-AntennaDescription', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_AntennaDescription_antennaDescription = CHOICE(name='antennaDescription', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_igsAntennaName = STR_VIS(name='igsAntennaName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CharArray')))
    __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_igsAntennaName._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_proprietaryName = STR_VIS(name='proprietaryName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CharArray')))
    __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_proprietaryName._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    _OMA_LPPe_AGNSS_AntennaDescription_antennaDescription._cont = ASN1Dict([
        ('igsAntennaName', __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_igsAntennaName),
        ('proprietaryName', __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_proprietaryName),
        ])
    _OMA_LPPe_AGNSS_AntennaDescription_antennaDescription._ext = []
    _OMA_LPPe_AGNSS_AntennaDescription_antennaSetupID = INT(name='antennaSetupID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_AGNSS_AntennaDescription_antennaSetupID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_AGNSS_AntennaDescription_antennaSerialNumber = STR_VIS(name='antennaSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CharArray')), opt=True)
    _OMA_LPPe_AGNSS_AntennaDescription_antennaSerialNumber._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    OMA_LPPe_AGNSS_AntennaDescription._cont = ASN1Dict([
        ('antennaDescription', _OMA_LPPe_AGNSS_AntennaDescription_antennaDescription),
        ('antennaSetupID', _OMA_LPPe_AGNSS_AntennaDescription_antennaSetupID),
        ('antennaSerialNumber', _OMA_LPPe_AGNSS_AntennaDescription_antennaSerialNumber),
        ])
    OMA_LPPe_AGNSS_AntennaDescription._ext = []
    
    #-----< OMA-LPPe-AGNSS-Abort >-----#
    OMA_LPPe_AGNSS_Abort = SEQ(name='OMA-LPPe-AGNSS-Abort', mode=MODE_TYPE)
    _OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses = SEQ(name='targetDeviceAbortCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_ccpAbort = ENUM(name='ccpAbort', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_ccpAbort._cont = ASN1Dict([('undefined', 0), ('ccpNotSupported', 1), ('ccpNotSupportedForProvidedSignals', 2)])
    __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_ccpAbort._ext = []
    __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_waIonoAbort = ENUM(name='waIonoAbort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_waIonoAbort._cont = ASN1Dict([('undefined', 0), ('waIonoNotSupported', 1), ('waIonoNotSupportedForProvidedGNSSs', 2)])
    __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_waIonoAbort._ext = []
    _OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses._cont = ASN1Dict([
        ('ccpAbort', __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_ccpAbort),
        ('waIonoAbort', __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_waIonoAbort),
        ])
    _OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses._ext = []
    OMA_LPPe_AGNSS_Abort._cont = ASN1Dict([
        ('targetDeviceAbortCauses', _OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses),
        ])
    OMA_LPPe_AGNSS_Abort._ext = []
    
    #-----< OMA-LPPe-OTDOA-ProvideAssistanceData >-----#
    OMA_LPPe_OTDOA_ProvideAssistanceData = SEQ(name='OMA-LPPe-OTDOA-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_ReferenceCellInfo = SEQ(name='otdoa-ReferenceCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-ReferenceCellInfo')), opt=True)
    _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_NeighbourCellInfo = SEQ_OF(name='otdoa-NeighbourCellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-NeighbourCellInfoList')), opt=True)
    _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_Error = CHOICE(name='otdoa-Error', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-Error')), opt=True)
    OMA_LPPe_OTDOA_ProvideAssistanceData._cont = ASN1Dict([
        ('otdoa-ReferenceCellInfo', _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_ReferenceCellInfo),
        ('otdoa-NeighbourCellInfo', _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_NeighbourCellInfo),
        ('otdoa-Error', _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_Error),
        ])
    OMA_LPPe_OTDOA_ProvideAssistanceData._ext = []
    
    #-----< OMA-LPPe-OTDOA-ReferenceCellInfo >-----#
    OMA_LPPe_OTDOA_ReferenceCellInfo = SEQ(name='OMA-LPPe-OTDOA-ReferenceCellInfo', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_ReferenceCellInfo_referenceCellInfo = SEQ(name='referenceCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-ReferenceCellInfo')))
    _OMA_LPPe_OTDOA_ReferenceCellInfo_positionCalculationInfoRef = SEQ(name='positionCalculationInfoRef', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-PositionCalculationInfoRef')))
    OMA_LPPe_OTDOA_ReferenceCellInfo._cont = ASN1Dict([
        ('referenceCellInfo', _OMA_LPPe_OTDOA_ReferenceCellInfo_referenceCellInfo),
        ('positionCalculationInfoRef', _OMA_LPPe_OTDOA_ReferenceCellInfo_positionCalculationInfoRef),
        ])
    OMA_LPPe_OTDOA_ReferenceCellInfo._ext = []
    
    #-----< OMA-LPPe-OTDOA-PositionCalculationInfoRef >-----#
    OMA_LPPe_OTDOA_PositionCalculationInfoRef = SEQ(name='OMA-LPPe-OTDOA-PositionCalculationInfoRef', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_systemFrameNumber = BIT_STR(name='systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_systemFrameNumber._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_rtdReferenceStd = SEQ(name='rtdReferenceStd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-RTDquality')), opt=True)
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation = SEQ(name='cellLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation_reference_point = SEQ(name='reference-point', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    __OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation._cont = ASN1Dict([
        ('reference-point', __OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation_reference_point),
        ('relative-location', __OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation_relative_location),
        ])
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation._ext = []
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo = SEQ(name='femtoCellInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo_location_reliability = INT(name='location-reliability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo_location_reliability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo._cont = ASN1Dict([
        ('location-reliability', __OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo_location_reliability),
        ])
    _OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo._ext = []
    OMA_LPPe_OTDOA_PositionCalculationInfoRef._cont = ASN1Dict([
        ('systemFrameNumber', _OMA_LPPe_OTDOA_PositionCalculationInfoRef_systemFrameNumber),
        ('rtdReferenceStd', _OMA_LPPe_OTDOA_PositionCalculationInfoRef_rtdReferenceStd),
        ('cellLocation', _OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation),
        ('femtoCellInfo', _OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo),
        ])
    OMA_LPPe_OTDOA_PositionCalculationInfoRef._ext = []
    
    #-----< OMA-LPPe-OTDOA-NeighbourCellInfoList >-----#
    OMA_LPPe_OTDOA_NeighbourCellInfoList = SEQ_OF(name='OMA-LPPe-OTDOA-NeighbourCellInfoList', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_NeighbourCellInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-NeighbourFreqCellInfoList')))
    OMA_LPPe_OTDOA_NeighbourCellInfoList._cont = _OMA_LPPe_OTDOA_NeighbourCellInfoList__item_
    OMA_LPPe_OTDOA_NeighbourCellInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< maxFreqLayers >-----#
    maxFreqLayers = INT(name='maxFreqLayers', mode=MODE_VALUE)
    maxFreqLayers._val = 3
    
    #-----< OMA-LPPe-OTDOA-NeighbourFreqCellInfoList >-----#
    OMA_LPPe_OTDOA_NeighbourFreqCellInfoList = SEQ(name='OMA-LPPe-OTDOA-NeighbourFreqCellInfoList', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB = SEQ_OF(name='neighbourCellInfoList-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-NeighbourCellInfoElement-eNB')))
    _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB._cont = __OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB__item_
    _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB = SEQ_OF(name='neighbourCellInfoList-HeNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-NeighbourCellInfoElement-HeNB')))
    _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB._cont = __OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB__item_
    _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_OTDOA_NeighbourFreqCellInfoList._cont = ASN1Dict([
        ('neighbourCellInfoList-eNB', _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB),
        ('neighbourCellInfoList-HeNB', _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB),
        ])
    OMA_LPPe_OTDOA_NeighbourFreqCellInfoList._ext = []
    
    #-----< OMA-LPPe-OTDOA-NeighbourCellInfoElement-eNB >-----#
    OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB = SEQ(name='OMA-LPPe-OTDOA-NeighbourCellInfoElement-eNB', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_relative_Location = SEQ(name='relative-Location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList = SEQ_OF(name='otdoa-eNB-CellDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-CellData')))
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList._cont = __OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList__item_
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB._cont = ASN1Dict([
        ('relative-Location', _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_relative_Location),
        ('otdoa-eNB-CellDataList', _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList),
        ])
    OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB._ext = []
    
    #-----< OMA-LPPe-OTDOA-NeighbourCellInfoElement-HeNB >-----#
    OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB = SEQ(name='OMA-LPPe-OTDOA-NeighbourCellInfoElement-HeNB', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_relative_Location = SEQ(name='relative-Location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_location_reliability = INT(name='location-reliability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_location_reliability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_otdoa_HeNB_CellDataList = SEQ(name='otdoa-HeNB-CellDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-CellData')))
    OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB._cont = ASN1Dict([
        ('relative-Location', _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_relative_Location),
        ('location-reliability', _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_location_reliability),
        ('otdoa-HeNB-CellDataList', _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_otdoa_HeNB_CellDataList),
        ])
    OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB._ext = []
    
    #-----< OMA-LPPe-OTDOA-CellData >-----#
    OMA_LPPe_OTDOA_CellData = SEQ(name='OMA-LPPe-OTDOA-CellData', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_CellData_otdoa_NeighbourCellInfoElement = SEQ(name='otdoa-NeighbourCellInfoElement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'OTDOA-NeighbourCellInfoElement')))
    _OMA_LPPe_OTDOA_CellData_rtdInfo = SEQ(name='rtdInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_OTDOA_CellData_rtdInfo_subframeOffset = INT(name='subframeOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_OTDOA_CellData_rtdInfo_subframeOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10229)], ev=None, er=[])
    __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTD = INT(name='fineRTD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99999)], ev=None, er=[])
    __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDstd = SEQ(name='fineRTDstd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-RTDquality')))
    __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDdriftRate = INT(name='fineRTDdriftRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDdriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=100)], ev=None, er=[])
    _OMA_LPPe_OTDOA_CellData_rtdInfo._cont = ASN1Dict([
        ('subframeOffset', __OMA_LPPe_OTDOA_CellData_rtdInfo_subframeOffset),
        ('fineRTD', __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTD),
        ('fineRTDstd', __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDstd),
        ('fineRTDdriftRate', __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDdriftRate),
        ])
    _OMA_LPPe_OTDOA_CellData_rtdInfo._ext = []
    OMA_LPPe_OTDOA_CellData._cont = ASN1Dict([
        ('otdoa-NeighbourCellInfoElement', _OMA_LPPe_OTDOA_CellData_otdoa_NeighbourCellInfoElement),
        ('rtdInfo', _OMA_LPPe_OTDOA_CellData_rtdInfo),
        ])
    OMA_LPPe_OTDOA_CellData._ext = []
    
    #-----< OMA-LPPe-OTDOA-RTDquality >-----#
    OMA_LPPe_OTDOA_RTDquality = SEQ(name='OMA-LPPe-OTDOA-RTDquality', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_RTDquality_resolution = ENUM(name='resolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_RTDquality_resolution._cont = ASN1Dict([('ns-5', 0), ('ns-10', 1), ('ns-50', 2), ('ns-100', 3)])
    _OMA_LPPe_OTDOA_RTDquality_resolution._ext = []
    _OMA_LPPe_OTDOA_RTDquality_quality = INT(name='quality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_RTDquality_quality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    OMA_LPPe_OTDOA_RTDquality._cont = ASN1Dict([
        ('resolution', _OMA_LPPe_OTDOA_RTDquality_resolution),
        ('quality', _OMA_LPPe_OTDOA_RTDquality_quality),
        ])
    OMA_LPPe_OTDOA_RTDquality._ext = []
    
    #-----< OMA-LPPe-OTDOA-RequestAssistanceData >-----#
    OMA_LPPe_OTDOA_RequestAssistanceData = SEQ(name='OMA-LPPe-OTDOA-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_RequestAssistanceData_lteCell = SEQ(name='lteCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')))
    __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_ecgi = SEQ(name='ecgi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    _OMA_LPPe_OTDOA_RequestAssistanceData_lteCell._cont = ASN1Dict([
        ('physCellId', __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_physCellId),
        ('eARFCN', __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_eARFCN),
        ('ecgi', __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_ecgi),
        ])
    _OMA_LPPe_OTDOA_RequestAssistanceData_lteCell._ext = []
    _OMA_LPPe_OTDOA_RequestAssistanceData_requestedCells = BIT_STR(name='requestedCells', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_RequestAssistanceData_requestedCells._cont = ASN1Dict([('eNBs', 0), ('heNBs', 1)])
    _OMA_LPPe_OTDOA_RequestAssistanceData_requestedCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_OTDOA_RequestAssistanceData._cont = ASN1Dict([
        ('lteCell', _OMA_LPPe_OTDOA_RequestAssistanceData_lteCell),
        ('requestedCells', _OMA_LPPe_OTDOA_RequestAssistanceData_requestedCells),
        ])
    OMA_LPPe_OTDOA_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-OTDOA-ProvideLocationInformation >-----#
    OMA_LPPe_OTDOA_ProvideLocationInformation = SEQ(name='OMA-LPPe-OTDOA-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_ProvideLocationInformation_otdoaLocationInformation = SEQ(name='otdoaLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-LocationInformation')), opt=True)
    _OMA_LPPe_OTDOA_ProvideLocationInformation_otdoaError = CHOICE(name='otdoaError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-Error')), opt=True)
    OMA_LPPe_OTDOA_ProvideLocationInformation._cont = ASN1Dict([
        ('otdoaLocationInformation', _OMA_LPPe_OTDOA_ProvideLocationInformation_otdoaLocationInformation),
        ('otdoaError', _OMA_LPPe_OTDOA_ProvideLocationInformation_otdoaError),
        ])
    OMA_LPPe_OTDOA_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-OTDOA-LocationInformation >-----#
    OMA_LPPe_OTDOA_LocationInformation = SEQ(name='OMA-LPPe-OTDOA-LocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_LocationInformation_systemFrameNumber = BIT_STR(name='systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_LocationInformation_systemFrameNumber._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _OMA_LPPe_OTDOA_LocationInformation_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_LocationInformation_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _OMA_LPPe_OTDOA_LocationInformation_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')), opt=True)
    OMA_LPPe_OTDOA_LocationInformation._cont = ASN1Dict([
        ('systemFrameNumber', _OMA_LPPe_OTDOA_LocationInformation_systemFrameNumber),
        ('physCellId', _OMA_LPPe_OTDOA_LocationInformation_physCellId),
        ('cellGlobalId', _OMA_LPPe_OTDOA_LocationInformation_cellGlobalId),
        ])
    OMA_LPPe_OTDOA_LocationInformation._ext = []
    
    #-----< OMA-LPPe-OTDOA-RequestLocationInformation >-----#
    OMA_LPPe_OTDOA_RequestLocationInformation = SEQ(name='OMA-LPPe-OTDOA-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_RequestLocationInformation_assistanceAvailability = BOOL(name='assistanceAvailability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_OTDOA_RequestLocationInformation._cont = ASN1Dict([
        ('assistanceAvailability', _OMA_LPPe_OTDOA_RequestLocationInformation_assistanceAvailability),
        ])
    OMA_LPPe_OTDOA_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-OTDOA-ProvideCapabilities >-----#
    OMA_LPPe_OTDOA_ProvideCapabilities = SEQ(name='OMA-LPPe-OTDOA-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_ProvideCapabilities_eNodeB_AD_sup = SEQ(name='eNodeB-AD-sup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_ProvideCapabilities_eNodeB_AD_sup._cont = ASN1Dict([
        ])
    _OMA_LPPe_OTDOA_ProvideCapabilities_eNodeB_AD_sup._ext = []
    _OMA_LPPe_OTDOA_ProvideCapabilities_home_eNodeB_AD_sup = SEQ(name='home-eNodeB-AD-sup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_ProvideCapabilities_home_eNodeB_AD_sup._cont = ASN1Dict([
        ])
    _OMA_LPPe_OTDOA_ProvideCapabilities_home_eNodeB_AD_sup._ext = []
    OMA_LPPe_OTDOA_ProvideCapabilities._cont = ASN1Dict([
        ('eNodeB-AD-sup', _OMA_LPPe_OTDOA_ProvideCapabilities_eNodeB_AD_sup),
        ('home-eNodeB-AD-sup', _OMA_LPPe_OTDOA_ProvideCapabilities_home_eNodeB_AD_sup),
        ])
    OMA_LPPe_OTDOA_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-OTDOA-RequestCapabilities >-----#
    OMA_LPPe_OTDOA_RequestCapabilities = SEQ(name='OMA-LPPe-OTDOA-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_OTDOA_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-OTDOA-Error >-----#
    OMA_LPPe_OTDOA_Error = CHOICE(name='OMA-LPPe-OTDOA-Error', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-LocationServerErrorCauses')))
    _OMA_LPPe_OTDOA_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-TargetDeviceErrorCauses')))
    OMA_LPPe_OTDOA_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_OTDOA_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_OTDOA_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_OTDOA_Error._ext = []
    
    #-----< OMA-LPPe-OTDOA-LocationServerErrorCauses >-----#
    OMA_LPPe_OTDOA_LocationServerErrorCauses = SEQ(name='OMA-LPPe-OTDOA-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('locationCalculationAssistanceDataNotSupported', 1), ('locationCalculationAssistanceDataSupportedButCurrentlyNotAvailable', 2)])
    _OMA_LPPe_OTDOA_LocationServerErrorCauses_cause._ext = []
    OMA_LPPe_OTDOA_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_OTDOA_LocationServerErrorCauses_cause),
        ])
    OMA_LPPe_OTDOA_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-OTDOA-TargetDeviceErrorCauses >-----#
    OMA_LPPe_OTDOA_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-OTDOA-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('there-were-not-enough-signals-received-for-ueBased-otdoa', 1), ('location-calculation-assistance-data-missing', 2)])
    _OMA_LPPe_OTDOA_TargetDeviceErrorCauses_cause._ext = []
    OMA_LPPe_OTDOA_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_OTDOA_TargetDeviceErrorCauses_cause),
        ])
    OMA_LPPe_OTDOA_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-EOTD-ProvideAssistanceData >-----#
    OMA_LPPe_EOTD_ProvideAssistanceData = SEQ(name='OMA-LPPe-EOTD-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_ProvideAssistanceData_referenceBTS = SEQ(name='referenceBTS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ReferenceBTSForAssistance')), opt=True)
    _OMA_LPPe_EOTD_ProvideAssistanceData_msrAssistDataList = SEQ_OF(name='msrAssistDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MsrAssistDataList')), opt=True)
    _OMA_LPPe_EOTD_ProvideAssistanceData_systemInfoAssistDataList = SEQ_OF(name='systemInfoAssistDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-SystemInfoAssistDataList')), opt=True)
    _OMA_LPPe_EOTD_ProvideAssistanceData_eotdError = CHOICE(name='eotdError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-Error')), opt=True)
    OMA_LPPe_EOTD_ProvideAssistanceData._cont = ASN1Dict([
        ('referenceBTS', _OMA_LPPe_EOTD_ProvideAssistanceData_referenceBTS),
        ('msrAssistDataList', _OMA_LPPe_EOTD_ProvideAssistanceData_msrAssistDataList),
        ('systemInfoAssistDataList', _OMA_LPPe_EOTD_ProvideAssistanceData_systemInfoAssistDataList),
        ('eotdError', _OMA_LPPe_EOTD_ProvideAssistanceData_eotdError),
        ])
    OMA_LPPe_EOTD_ProvideAssistanceData._ext = []
    
    #-----< OMA-LPPe-EOTD-ReferenceBTSForAssistance >-----#
    OMA_LPPe_EOTD_ReferenceBTSForAssistance = SEQ(name='OMA-LPPe-EOTD-ReferenceBTSForAssistance', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_ReferenceBTSForAssistance_bsicAndCarrier = SEQ(name='bsicAndCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellNonUniqueIDGERAN')))
    _OMA_LPPe_EOTD_ReferenceBTSForAssistance_timeSlotScheme = ENUM(name='timeSlotScheme', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-TimeSlotScheme')))
    _OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition = CHOICE(name='btsPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition_ellipsoidPoint = SEQ(name='ellipsoidPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')))
    __OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='ellipsoidPointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitudeAndUncertaintyEllipsoid')))
    _OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition._cont = ASN1Dict([
        ('ellipsoidPoint', __OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition_ellipsoidPoint),
        ('ellipsoidPointWithAltitudeAndUncertaintyEllipsoid', __OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid),
        ])
    _OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition._ext = []
    OMA_LPPe_EOTD_ReferenceBTSForAssistance._cont = ASN1Dict([
        ('bsicAndCarrier', _OMA_LPPe_EOTD_ReferenceBTSForAssistance_bsicAndCarrier),
        ('timeSlotScheme', _OMA_LPPe_EOTD_ReferenceBTSForAssistance_timeSlotScheme),
        ('btsPosition', _OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition),
        ])
    OMA_LPPe_EOTD_ReferenceBTSForAssistance._ext = []
    
    #-----< OMA-LPPe-EOTD-MsrAssistDataList >-----#
    OMA_LPPe_EOTD_MsrAssistDataList = SEQ_OF(name='OMA-LPPe-EOTD-MsrAssistDataList', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_MsrAssistDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MsrAssistBTS')))
    OMA_LPPe_EOTD_MsrAssistDataList._cont = _OMA_LPPe_EOTD_MsrAssistDataList__item_
    OMA_LPPe_EOTD_MsrAssistDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-MsrAssistBTS >-----#
    OMA_LPPe_EOTD_MsrAssistBTS = SEQ(name='OMA-LPPe-EOTD-MsrAssistBTS', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_MsrAssistBTS_bsicAndCarrier = SEQ(name='bsicAndCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellNonUniqueIDGERAN')))
    _OMA_LPPe_EOTD_MsrAssistBTS_multiFrameOffset = INT(name='multiFrameOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MultiFrameOffset')))
    _OMA_LPPe_EOTD_MsrAssistBTS_timeSlotScheme = ENUM(name='timeSlotScheme', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-TimeSlotScheme')))
    _OMA_LPPe_EOTD_MsrAssistBTS_roughRTD = INT(name='roughRTD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RoughRTD')))
    _OMA_LPPe_EOTD_MsrAssistBTS_expectedOTD = SEQ(name='expectedOTD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ExpectedOTD')))
    _OMA_LPPe_EOTD_MsrAssistBTS_calcAssistanceBTS = SEQ(name='calcAssistanceBTS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-CalcAssistanceBTS')), opt=True)
    OMA_LPPe_EOTD_MsrAssistBTS._cont = ASN1Dict([
        ('bsicAndCarrier', _OMA_LPPe_EOTD_MsrAssistBTS_bsicAndCarrier),
        ('multiFrameOffset', _OMA_LPPe_EOTD_MsrAssistBTS_multiFrameOffset),
        ('timeSlotScheme', _OMA_LPPe_EOTD_MsrAssistBTS_timeSlotScheme),
        ('roughRTD', _OMA_LPPe_EOTD_MsrAssistBTS_roughRTD),
        ('expectedOTD', _OMA_LPPe_EOTD_MsrAssistBTS_expectedOTD),
        ('calcAssistanceBTS', _OMA_LPPe_EOTD_MsrAssistBTS_calcAssistanceBTS),
        ])
    OMA_LPPe_EOTD_MsrAssistBTS._ext = []
    
    #-----< OMA-LPPe-EOTD-SystemInfoAssistDataList >-----#
    OMA_LPPe_EOTD_SystemInfoAssistDataList = SEQ_OF(name='OMA-LPPe-EOTD-SystemInfoAssistDataList', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_SystemInfoAssistDataList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-SystemInfoAssistBTS')))
    OMA_LPPe_EOTD_SystemInfoAssistDataList._cont = _OMA_LPPe_EOTD_SystemInfoAssistDataList__item_
    OMA_LPPe_EOTD_SystemInfoAssistDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-SystemInfoAssistBTS >-----#
    OMA_LPPe_EOTD_SystemInfoAssistBTS = CHOICE(name='OMA-LPPe-EOTD-SystemInfoAssistBTS', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_SystemInfoAssistBTS_notPresent = NULL(name='notPresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_SystemInfoAssistBTS_present = SEQ(name='present', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-AssistBTSData')))
    OMA_LPPe_EOTD_SystemInfoAssistBTS._cont = ASN1Dict([
        ('notPresent', _OMA_LPPe_EOTD_SystemInfoAssistBTS_notPresent),
        ('present', _OMA_LPPe_EOTD_SystemInfoAssistBTS_present),
        ])
    OMA_LPPe_EOTD_SystemInfoAssistBTS._ext = None
    
    #-----< OMA-LPPe-EOTD-AssistBTSData >-----#
    OMA_LPPe_EOTD_AssistBTSData = SEQ(name='OMA-LPPe-EOTD-AssistBTSData', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_AssistBTSData_bsic = INT(name='bsic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_AssistBTSData_bsic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_EOTD_AssistBTSData_multiFrameOffset = INT(name='multiFrameOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MultiFrameOffset')))
    _OMA_LPPe_EOTD_AssistBTSData_timeSlotScheme = ENUM(name='timeSlotScheme', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-TimeSlotScheme')))
    _OMA_LPPe_EOTD_AssistBTSData_roughRTD = INT(name='roughRTD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RoughRTD')))
    _OMA_LPPe_EOTD_AssistBTSData_expectedOTD = SEQ(name='expectedOTD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ExpectedOTD')), opt=True)
    _OMA_LPPe_EOTD_AssistBTSData_calcAssistanceBTS = SEQ(name='calcAssistanceBTS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-CalcAssistanceBTS')), opt=True)
    OMA_LPPe_EOTD_AssistBTSData._cont = ASN1Dict([
        ('bsic', _OMA_LPPe_EOTD_AssistBTSData_bsic),
        ('multiFrameOffset', _OMA_LPPe_EOTD_AssistBTSData_multiFrameOffset),
        ('timeSlotScheme', _OMA_LPPe_EOTD_AssistBTSData_timeSlotScheme),
        ('roughRTD', _OMA_LPPe_EOTD_AssistBTSData_roughRTD),
        ('expectedOTD', _OMA_LPPe_EOTD_AssistBTSData_expectedOTD),
        ('calcAssistanceBTS', _OMA_LPPe_EOTD_AssistBTSData_calcAssistanceBTS),
        ])
    OMA_LPPe_EOTD_AssistBTSData._ext = []
    
    #-----< OMA-LPPe-EOTD-CalcAssistanceBTS >-----#
    OMA_LPPe_EOTD_CalcAssistanceBTS = SEQ(name='OMA-LPPe-EOTD-CalcAssistanceBTS', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_CalcAssistanceBTS_fineRTD = INT(name='fineRTD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-FineRTD')))
    _OMA_LPPe_EOTD_CalcAssistanceBTS_relativePos = SEQ(name='relativePos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-relativePos')))
    OMA_LPPe_EOTD_CalcAssistanceBTS._cont = ASN1Dict([
        ('fineRTD', _OMA_LPPe_EOTD_CalcAssistanceBTS_fineRTD),
        ('relativePos', _OMA_LPPe_EOTD_CalcAssistanceBTS_relativePos),
        ])
    OMA_LPPe_EOTD_CalcAssistanceBTS._ext = []
    
    #-----< OMA-LPPe-EOTD-relativePos >-----#
    OMA_LPPe_EOTD_relativePos = SEQ(name='OMA-LPPe-EOTD-relativePos', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_relativePos_relativeNorth = INT(name='relativeNorth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RelDistance')))
    _OMA_LPPe_EOTD_relativePos_relativeEast = INT(name='relativeEast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RelDistance')))
    _OMA_LPPe_EOTD_relativePos_relativeAlt = INT(name='relativeAlt', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RelativeAlt')), opt=True)
    OMA_LPPe_EOTD_relativePos._cont = ASN1Dict([
        ('relativeNorth', _OMA_LPPe_EOTD_relativePos_relativeNorth),
        ('relativeEast', _OMA_LPPe_EOTD_relativePos_relativeEast),
        ('relativeAlt', _OMA_LPPe_EOTD_relativePos_relativeAlt),
        ])
    OMA_LPPe_EOTD_relativePos._ext = []
    
    #-----< OMA-LPPe-EOTD-FineRTD >-----#
    OMA_LPPe_EOTD_FineRTD = INT(name='OMA-LPPe-EOTD-FineRTD', mode=MODE_TYPE)
    OMA_LPPe_EOTD_FineRTD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-RelDistance >-----#
    OMA_LPPe_EOTD_RelDistance = INT(name='OMA-LPPe-EOTD-RelDistance', mode=MODE_TYPE)
    OMA_LPPe_EOTD_RelDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-200000, ub=200000)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-RelativeAlt >-----#
    OMA_LPPe_EOTD_RelativeAlt = INT(name='OMA-LPPe-EOTD-RelativeAlt', mode=MODE_TYPE)
    OMA_LPPe_EOTD_RelativeAlt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4000, ub=4000)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-RequestAssistanceData >-----#
    OMA_LPPe_EOTD_RequestAssistanceData = SEQ(name='OMA-LPPe-EOTD-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_RequestAssistanceData_eotdAssistanceReq = BIT_STR(name='eotdAssistanceReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_RequestAssistanceData_eotdAssistanceReq._cont = ASN1Dict([('ueAssisted', 0), ('ueBased', 1)])
    OMA_LPPe_EOTD_RequestAssistanceData._cont = ASN1Dict([
        ('eotdAssistanceReq', _OMA_LPPe_EOTD_RequestAssistanceData_eotdAssistanceReq),
        ])
    OMA_LPPe_EOTD_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-EOTD-ProvideLocationInformation >-----#
    OMA_LPPe_EOTD_ProvideLocationInformation = SEQ(name='OMA-LPPe-EOTD-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_ProvideLocationInformation_eotdMsrElement = SEQ(name='eotdMsrElement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MsrElement')), opt=True)
    _OMA_LPPe_EOTD_ProvideLocationInformation_eotdError = CHOICE(name='eotdError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-Error')), opt=True)
    OMA_LPPe_EOTD_ProvideLocationInformation._cont = ASN1Dict([
        ('eotdMsrElement', _OMA_LPPe_EOTD_ProvideLocationInformation_eotdMsrElement),
        ('eotdError', _OMA_LPPe_EOTD_ProvideLocationInformation_eotdError),
        ])
    OMA_LPPe_EOTD_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-EOTD-MsrElement >-----#
    OMA_LPPe_EOTD_MsrElement = SEQ(name='OMA-LPPe-EOTD-MsrElement', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_MsrElement_refFrameNumber = INT(name='refFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_MsrElement_refFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=42431)], ev=None, er=[])
    _OMA_LPPe_EOTD_MsrElement_referenceTimeSlot = INT(name='referenceTimeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ModuloTimeSlot')))
    _OMA_LPPe_EOTD_MsrElement_toaMeasurementsOfRef = SEQ(name='toaMeasurementsOfRef', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-TOA-MeasurementsOfRef')), opt=True)
    _OMA_LPPe_EOTD_MsrElement_stdResolution = BIT_STR(name='stdResolution', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_MsrElement_stdResolution._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _OMA_LPPe_EOTD_MsrElement_taCorrection = INT(name='taCorrection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_EOTD_MsrElement_taCorrection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=960)], ev=None, er=[])
    _OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs = SEQ_OF(name='otd-FirstSetMsrs', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MeasurementWithID')))
    _OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs._cont = __OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs__item_
    _OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    OMA_LPPe_EOTD_MsrElement._cont = ASN1Dict([
        ('refFrameNumber', _OMA_LPPe_EOTD_MsrElement_refFrameNumber),
        ('referenceTimeSlot', _OMA_LPPe_EOTD_MsrElement_referenceTimeSlot),
        ('toaMeasurementsOfRef', _OMA_LPPe_EOTD_MsrElement_toaMeasurementsOfRef),
        ('stdResolution', _OMA_LPPe_EOTD_MsrElement_stdResolution),
        ('taCorrection', _OMA_LPPe_EOTD_MsrElement_taCorrection),
        ('otd-FirstSetMsrs', _OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs),
        ])
    OMA_LPPe_EOTD_MsrElement._ext = []
    
    #-----< OMA-LPPe-EOTD-TOA-MeasurementsOfRef >-----#
    OMA_LPPe_EOTD_TOA_MeasurementsOfRef = SEQ(name='OMA-LPPe-EOTD-TOA-MeasurementsOfRef', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_refQuality = BIT_STR(name='refQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_refQuality._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_numOfMeasurements = BIT_STR(name='numOfMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_numOfMeasurements._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    OMA_LPPe_EOTD_TOA_MeasurementsOfRef._cont = ASN1Dict([
        ('refQuality', _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_refQuality),
        ('numOfMeasurements', _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_numOfMeasurements),
        ])
    OMA_LPPe_EOTD_TOA_MeasurementsOfRef._ext = []
    
    #-----< OMA-LPPe-EOTD-MeasurementWithID >-----#
    OMA_LPPe_EOTD_MeasurementWithID = SEQ(name='OMA-LPPe-EOTD-MeasurementWithID', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_MeasurementWithID_neighborIdentity = CHOICE(name='neighborIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-NeighborIdentity')))
    _OMA_LPPe_EOTD_MeasurementWithID_nborTimeSlot = INT(name='nborTimeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-ModuloTimeSlot')))
    _OMA_LPPe_EOTD_MeasurementWithID_eotdQuality = SEQ(name='eotdQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-EOTDQuality')))
    _OMA_LPPe_EOTD_MeasurementWithID_otdValue = INT(name='otdValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-OTDValue')))
    OMA_LPPe_EOTD_MeasurementWithID._cont = ASN1Dict([
        ('neighborIdentity', _OMA_LPPe_EOTD_MeasurementWithID_neighborIdentity),
        ('nborTimeSlot', _OMA_LPPe_EOTD_MeasurementWithID_nborTimeSlot),
        ('eotdQuality', _OMA_LPPe_EOTD_MeasurementWithID_eotdQuality),
        ('otdValue', _OMA_LPPe_EOTD_MeasurementWithID_otdValue),
        ])
    OMA_LPPe_EOTD_MeasurementWithID._ext = []
    
    #-----< OMA-LPPe-EOTD-NeighborIdentity >-----#
    OMA_LPPe_EOTD_NeighborIdentity = CHOICE(name='OMA-LPPe-EOTD-NeighborIdentity', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_NeighborIdentity_bsicAndCarrier = SEQ(name='bsicAndCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellNonUniqueIDGERAN')))
    _OMA_LPPe_EOTD_NeighborIdentity_ci = INT(name='ci', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-CellID')))
    _OMA_LPPe_EOTD_NeighborIdentity_multiFrameCarrier = SEQ(name='multiFrameCarrier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MultiFrameCarrier')))
    _OMA_LPPe_EOTD_NeighborIdentity_requestIndex = INT(name='requestIndex', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-RequestIndex')))
    _OMA_LPPe_EOTD_NeighborIdentity_systemInfoIndex = INT(name='systemInfoIndex', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-SystemInfoIndex')))
    _OMA_LPPe_EOTD_NeighborIdentity_ciAndLac = SEQ(name='ciAndLac', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellLocalIdGERAN')))
    OMA_LPPe_EOTD_NeighborIdentity._cont = ASN1Dict([
        ('bsicAndCarrier', _OMA_LPPe_EOTD_NeighborIdentity_bsicAndCarrier),
        ('ci', _OMA_LPPe_EOTD_NeighborIdentity_ci),
        ('multiFrameCarrier', _OMA_LPPe_EOTD_NeighborIdentity_multiFrameCarrier),
        ('requestIndex', _OMA_LPPe_EOTD_NeighborIdentity_requestIndex),
        ('systemInfoIndex', _OMA_LPPe_EOTD_NeighborIdentity_systemInfoIndex),
        ('ciAndLac', _OMA_LPPe_EOTD_NeighborIdentity_ciAndLac),
        ])
    OMA_LPPe_EOTD_NeighborIdentity._ext = []
    
    #-----< OMA-LPPe-EOTD-EOTDQuality >-----#
    OMA_LPPe_EOTD_EOTDQuality = SEQ(name='OMA-LPPe-EOTD-EOTDQuality', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_EOTDQuality_nbrOfMeasurements = BIT_STR(name='nbrOfMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_EOTDQuality_nbrOfMeasurements._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _OMA_LPPe_EOTD_EOTDQuality_stdOfEOTD = BIT_STR(name='stdOfEOTD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_EOTDQuality_stdOfEOTD._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    OMA_LPPe_EOTD_EOTDQuality._cont = ASN1Dict([
        ('nbrOfMeasurements', _OMA_LPPe_EOTD_EOTDQuality_nbrOfMeasurements),
        ('stdOfEOTD', _OMA_LPPe_EOTD_EOTDQuality_stdOfEOTD),
        ])
    OMA_LPPe_EOTD_EOTDQuality._ext = []
    
    #-----< OMA-LPPe-EOTD-OTDValue >-----#
    OMA_LPPe_EOTD_OTDValue = INT(name='OMA-LPPe-EOTD-OTDValue', mode=MODE_TYPE)
    OMA_LPPe_EOTD_OTDValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39999)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-CellID >-----#
    OMA_LPPe_EOTD_CellID = INT(name='OMA-LPPe-EOTD-CellID', mode=MODE_TYPE)
    OMA_LPPe_EOTD_CellID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-RequestIndex >-----#
    OMA_LPPe_EOTD_RequestIndex = INT(name='OMA-LPPe-EOTD-RequestIndex', mode=MODE_TYPE)
    OMA_LPPe_EOTD_RequestIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-SystemInfoIndex >-----#
    OMA_LPPe_EOTD_SystemInfoIndex = INT(name='OMA-LPPe-EOTD-SystemInfoIndex', mode=MODE_TYPE)
    OMA_LPPe_EOTD_SystemInfoIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-MultiFrameCarrier >-----#
    OMA_LPPe_EOTD_MultiFrameCarrier = SEQ(name='OMA-LPPe-EOTD-MultiFrameCarrier', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_MultiFrameCarrier_bcchCarrier = INT(name='bcchCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-BCCHCarrier')))
    _OMA_LPPe_EOTD_MultiFrameCarrier_multiFrameOffset = INT(name='multiFrameOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-MultiFrameOffset')))
    OMA_LPPe_EOTD_MultiFrameCarrier._cont = ASN1Dict([
        ('bcchCarrier', _OMA_LPPe_EOTD_MultiFrameCarrier_bcchCarrier),
        ('multiFrameOffset', _OMA_LPPe_EOTD_MultiFrameCarrier_multiFrameOffset),
        ])
    OMA_LPPe_EOTD_MultiFrameCarrier._ext = []
    
    #-----< OMA-LPPe-EOTD-BCCHCarrier >-----#
    OMA_LPPe_EOTD_BCCHCarrier = INT(name='OMA-LPPe-EOTD-BCCHCarrier', mode=MODE_TYPE)
    OMA_LPPe_EOTD_BCCHCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-RequestLocationInformation >-----#
    OMA_LPPe_EOTD_RequestLocationInformation = SEQ(name='OMA-LPPe-EOTD-RequestLocationInformation', mode=MODE_TYPE)
    OMA_LPPe_EOTD_RequestLocationInformation._cont = ASN1Dict([
        ])
    OMA_LPPe_EOTD_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-EOTD-ProvideCapabilities >-----#
    OMA_LPPe_EOTD_ProvideCapabilities = SEQ(name='OMA-LPPe-EOTD-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_ProvideCapabilities_eotdSupport = BIT_STR(name='eotdSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_ProvideCapabilities_eotdSupport._cont = ASN1Dict([('ueBased', 0), ('ueAssisted', 1)])
    OMA_LPPe_EOTD_ProvideCapabilities._cont = ASN1Dict([
        ('eotdSupport', _OMA_LPPe_EOTD_ProvideCapabilities_eotdSupport),
        ])
    OMA_LPPe_EOTD_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-EOTD-RequestCapabilities >-----#
    OMA_LPPe_EOTD_RequestCapabilities = SEQ(name='OMA-LPPe-EOTD-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_EOTD_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_EOTD_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-EOTD-Error >-----#
    OMA_LPPe_EOTD_Error = CHOICE(name='OMA-LPPe-EOTD-Error', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-LocationServerErrorCauses')))
    _OMA_LPPe_EOTD_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-EOTD-TargetDeviceErrorCauses')))
    OMA_LPPe_EOTD_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_EOTD_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_EOTD_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_EOTD_Error._ext = []
    
    #-----< OMA-LPPe-EOTD-LocationServerErrorCauses >-----#
    OMA_LPPe_EOTD_LocationServerErrorCauses = SEQ(name='OMA-LPPe-EOTD-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('assistanceDataForUEbasedEOTDnotAvailable', 1), ('assistanceDataForUEassistedEOTDnotAvailable', 2)])
    _OMA_LPPe_EOTD_LocationServerErrorCauses_cause._ext = []
    OMA_LPPe_EOTD_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_EOTD_LocationServerErrorCauses_cause),
        ])
    OMA_LPPe_EOTD_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-EOTD-TargetDeviceErrorCauses >-----#
    OMA_LPPe_EOTD_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-EOTD-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefinedError', 0), ('notEnoughBTsforEOTD', 1), ('assistanceDataMissing', 2), ('referenceCellNotServingCell', 3), ('eotdMeasurementsNotSupported', 4), ('eotdMeasurementsNotAvailable', 5), ('uebasedEOTDnotSupported', 6)])
    _OMA_LPPe_EOTD_TargetDeviceErrorCauses_cause._ext = []
    OMA_LPPe_EOTD_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_EOTD_TargetDeviceErrorCauses_cause),
        ])
    OMA_LPPe_EOTD_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-EOTD-TimeSlotScheme >-----#
    OMA_LPPe_EOTD_TimeSlotScheme = ENUM(name='OMA-LPPe-EOTD-TimeSlotScheme', mode=MODE_TYPE)
    OMA_LPPe_EOTD_TimeSlotScheme._cont = ASN1Dict([('equalLength', 0), ('variousLength', 1)])
    OMA_LPPe_EOTD_TimeSlotScheme._ext = None
    
    #-----< OMA-LPPe-EOTD-MultiFrameOffset >-----#
    OMA_LPPe_EOTD_MultiFrameOffset = INT(name='OMA-LPPe-EOTD-MultiFrameOffset', mode=MODE_TYPE)
    OMA_LPPe_EOTD_MultiFrameOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=51)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-RoughRTD >-----#
    OMA_LPPe_EOTD_RoughRTD = INT(name='OMA-LPPe-EOTD-RoughRTD', mode=MODE_TYPE)
    OMA_LPPe_EOTD_RoughRTD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1250)], ev=None, er=[])
    
    #-----< OMA-LPPe-EOTD-ExpectedOTD >-----#
    OMA_LPPe_EOTD_ExpectedOTD = SEQ(name='OMA-LPPe-EOTD-ExpectedOTD', mode=MODE_TYPE)
    _OMA_LPPe_EOTD_ExpectedOTD_expectedOTD = INT(name='expectedOTD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_ExpectedOTD_expectedOTD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1250)], ev=None, er=[])
    _OMA_LPPe_EOTD_ExpectedOTD_expOTDUncertainty = INT(name='expOTDUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_EOTD_ExpectedOTD_expOTDUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    OMA_LPPe_EOTD_ExpectedOTD._cont = ASN1Dict([
        ('expectedOTD', _OMA_LPPe_EOTD_ExpectedOTD_expectedOTD),
        ('expOTDUncertainty', _OMA_LPPe_EOTD_ExpectedOTD_expOTDUncertainty),
        ])
    OMA_LPPe_EOTD_ExpectedOTD._ext = []
    
    #-----< OMA-LPPe-EOTD-ModuloTimeSlot >-----#
    OMA_LPPe_EOTD_ModuloTimeSlot = INT(name='OMA-LPPe-EOTD-ModuloTimeSlot', mode=MODE_TYPE)
    OMA_LPPe_EOTD_ModuloTimeSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-ProvideAssistanceData >-----#
    OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData = SEQ(name='OMA-LPPe-OTDOA-UTRA-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_referenceCellInfo = SEQ(name='referenceCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-ReferenceCellInfo')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_neigborCellList = SEQ_OF(name='neigborCellList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-NeighborCellList')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_otdoaUtraError = CHOICE(name='otdoaUtraError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-Error')), opt=True)
    OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData._cont = ASN1Dict([
        ('referenceCellInfo', _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_referenceCellInfo),
        ('neigborCellList', _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_neigborCellList),
        ('otdoaUtraError', _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_otdoaUtraError),
        ])
    OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-ReferenceCellInfo >-----#
    OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo = SEQ(name='OMA-LPPe-OTDOA-UTRA-ReferenceCellInfo', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd_primaryCPICH_info = SEQ(name='primaryCPICH-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info')))
    __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-info', ___OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd_primaryCPICH_info),
        ])
    __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd._ext = None
    __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd_cellAndChannelIdentity = SEQ(name='cellAndChannelIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity')))
    __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellAndChannelIdentity', ___OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd_cellAndChannelIdentity),
        ])
    __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd._ext = None
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd),
        ('tdd', __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd),
        ])
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo._ext = None
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfo')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_refPosAssist = SEQ(name='refPosAssist', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-RefPosAssist')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_ipdl_parameters = SEQ(name='ipdl-parameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-IPDL-Parameters')), opt=True)
    OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo._cont = ASN1Dict([
        ('sfn', _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_sfn),
        ('modeSpecificInfo', _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo),
        ('frequencyInfo', _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_frequencyInfo),
        ('refPosAssist', _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_refPosAssist),
        ('ipdl-parameters', _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_ipdl_parameters),
        ])
    OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-RefPosAssist >-----#
    OMA_LPPe_OTDOA_UTRA_RefPosAssist = SEQ(name='OMA-LPPe-OTDOA-UTRA-RefPosAssist', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition = CHOICE(name='cellPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition_ellipsoidPoint = SEQ(name='ellipsoidPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')))
    __OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition_ellipsoidPointWithAltitude = SEQ(name='ellipsoidPointWithAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'EllipsoidPointWithAltitude')))
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition._cont = ASN1Dict([
        ('ellipsoidPoint', __OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition_ellipsoidPoint),
        ('ellipsoidPointWithAltitude', __OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition_ellipsoidPointWithAltitude),
        ])
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition._ext = []
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTimeExtension = INT(name='roundTripTimeExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTimeExtension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=70274)], ev=None, er=[])
    OMA_LPPe_OTDOA_UTRA_RefPosAssist._cont = ASN1Dict([
        ('cellPosition', _OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition),
        ('roundTripTime', _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTime),
        ('roundTripTimeExtension', _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTimeExtension),
        ])
    OMA_LPPe_OTDOA_UTRA_RefPosAssist._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-NeighborCellList >-----#
    OMA_LPPe_OTDOA_UTRA_NeighborCellList = SEQ_OF(name='OMA-LPPe-OTDOA-UTRA-NeighborCellList', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_NeighborCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-NeighborCellInfo')))
    OMA_LPPe_OTDOA_UTRA_NeighborCellList._cont = _OMA_LPPe_OTDOA_UTRA_NeighborCellList__item_
    OMA_LPPe_OTDOA_UTRA_NeighborCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-NeighborCellInfo >-----#
    OMA_LPPe_OTDOA_UTRA_NeighborCellInfo = SEQ(name='OMA-LPPe-OTDOA-UTRA-NeighborCellInfo', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd_primaryCPICH_info = SEQ(name='primaryCPICH-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info')))
    __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-info', ___OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd_primaryCPICH_info),
        ])
    __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd._ext = None
    __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd_cellAndChannelIdentity = SEQ(name='cellAndChannelIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity')))
    __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellAndChannelIdentity', ___OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd_cellAndChannelIdentity),
        ])
    __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd._ext = None
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd),
        ('tdd', __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd),
        ])
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo._ext = None
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfo')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_ipdl_parameters = SEQ(name='ipdl-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-IPDL-Parameters')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_SFN_relTimeDifference = SEQ(name='sfn-SFN-relTimeDifference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-SFN-SFN-RelTimeDifference1')))
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_offsetValidity = ENUM(name='sfn-offsetValidity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-SFN-OffsetValidity')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_SFN_drift = ENUM(name='sfn-SFN-drift', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-SFN-SFN-Drift')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_searchWindowSize = ENUM(name='searchWindowSize', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-SearchWindowSize')))
    _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_positioningAssistance = SEQ(name='positioningAssistance', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PositioningAssistance')), opt=True)
    OMA_LPPe_OTDOA_UTRA_NeighborCellInfo._cont = ASN1Dict([
        ('modeSpecificInfo', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo),
        ('frequencyInfo', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_frequencyInfo),
        ('ipdl-parameters', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_ipdl_parameters),
        ('sfn-SFN-relTimeDifference', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_SFN_relTimeDifference),
        ('sfn-offsetValidity', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_offsetValidity),
        ('sfn-SFN-drift', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_SFN_drift),
        ('searchWindowSize', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_searchWindowSize),
        ('positioningAssistance', _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_positioningAssistance),
        ])
    OMA_LPPe_OTDOA_UTRA_NeighborCellInfo._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-SFN-SFN-RelTimeDifference1 >-----#
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1 = SEQ(name='OMA-LPPe-OTDOA-UTRA-SFN-SFN-RelTimeDifference1', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_offset = INT(name='sfn-offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_sfn_relTimeDifference = INT(name='sfn-sfn-relTimeDifference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_sfn_relTimeDifference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38399)], ev=None, er=[])
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1._cont = ASN1Dict([
        ('sfn-offset', _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_offset),
        ('sfn-sfn-relTimeDifference', _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_sfn_relTimeDifference),
        ])
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-PositioningAssistance >-----#
    OMA_LPPe_OTDOA_UTRA_PositioningAssistance = SEQ(name='OMA-LPPe-OTDOA-UTRA-PositioningAssistance', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeNorth = INT(name='relativeNorth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeNorth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20000, ub=20000)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeEast = INT(name='relativeEast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeEast._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20000, ub=20000)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeAltitude = INT(name='relativeAltitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4000, ub=4000)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_fineSFN_SFN = INT(name='fineSFN-SFN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-fineSFN-SFN')))
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTimeExtension = INT(name='roundTripTimeExtension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTimeExtension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=70274)], ev=None, er=[])
    OMA_LPPe_OTDOA_UTRA_PositioningAssistance._cont = ASN1Dict([
        ('relativeNorth', _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeNorth),
        ('relativeEast', _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeEast),
        ('relativeAltitude', _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeAltitude),
        ('fineSFN-SFN', _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_fineSFN_SFN),
        ('roundTripTime', _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTime),
        ('roundTripTimeExtension', _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTimeExtension),
        ])
    OMA_LPPe_OTDOA_UTRA_PositioningAssistance._ext = []
    
    #-----< utra-maxCellMeas >-----#
    utra_maxCellMeas = INT(name='utra-maxCellMeas', mode=MODE_VALUE)
    utra_maxCellMeas._val = 32
    
    #-----< OMA-LPPe-OTDOA-UTRA-SFN-OffsetValidity >-----#
    OMA_LPPe_OTDOA_UTRA_SFN_OffsetValidity = ENUM(name='OMA-LPPe-OTDOA-UTRA-SFN-OffsetValidity', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_SFN_OffsetValidity._cont = ASN1Dict([('false', 0)])
    OMA_LPPe_OTDOA_UTRA_SFN_OffsetValidity._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-SFN-SFN-Drift >-----#
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_Drift = ENUM(name='OMA-LPPe-OTDOA-UTRA-SFN-SFN-Drift', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_Drift._cont = ASN1Dict([('sfnsfndrift0', 0), ('sfnsfndrift1', 1), ('sfnsfndrift2', 2), ('sfnsfndrift3', 3), ('sfnsfndrift4', 4), ('sfnsfndrift5', 5), ('sfnsfndrift8', 6), ('sfnsfndrift10', 7), ('sfnsfndrift15', 8), ('sfnsfndrift25', 9), ('sfnsfndrift35', 10), ('sfnsfndrift50', 11), ('sfnsfndrift65', 12), ('sfnsfndrift80', 13), ('sfnsfndrift100', 14), ('sfnsfndrift-1', 15), ('sfnsfndrift-2', 16), ('sfnsfndrift-3', 17), ('sfnsfndrift-4', 18), ('sfnsfndrift-5', 19), ('sfnsfndrift-8', 20), ('sfnsfndrift-10', 21), ('sfnsfndrift-15', 22), ('sfnsfndrift-25', 23), ('sfnsfndrift-35', 24), ('sfnsfndrift-50', 25), ('sfnsfndrift-65', 26), ('sfnsfndrift-80', 27), ('sfnsfndrift-100', 28)])
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_Drift._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-SearchWindowSize >-----#
    OMA_LPPe_OTDOA_UTRA_SearchWindowSize = ENUM(name='OMA-LPPe-OTDOA-UTRA-SearchWindowSize', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_SearchWindowSize._cont = ASN1Dict([('c20', 0), ('c40', 1), ('c80', 2), ('c160', 3), ('c320', 4), ('c640', 5), ('c1280', 6), ('moreThan1280', 7)])
    OMA_LPPe_OTDOA_UTRA_SearchWindowSize._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-fineSFN-SFN >-----#
    OMA_LPPe_OTDOA_UTRA_fineSFN_SFN = INT(name='OMA-LPPe-OTDOA-UTRA-fineSFN-SFN', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_fineSFN_SFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-IPDL-Parameters >-----#
    OMA_LPPe_OTDOA_UTRA_IPDL_Parameters = SEQ(name='OMA-LPPe-OTDOA-UTRA-IPDL-Parameters', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_spacing = ENUM(name='ip-spacing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-IP-Spacing')))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_length = ENUM(name='ip-length', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-IP-Length')))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset = INT(name='ip-Offset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_seed = INT(name='seed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_seed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_burstModeParameters = SEQ(name='burstModeParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-BurstModeParameters')), opt=True)
    __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('ip-spacing', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_spacing),
        ('ip-length', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_length),
        ('ip-Offset', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset),
        ('seed', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_seed),
        ('burstModeParameters', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_burstModeParameters),
        ])
    __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd._ext = None
    __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_spacing_tdd = ENUM(name='ip-spacing-tdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-IP-Spacing-TDD')))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_slot = INT(name='ip-slot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_slot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_start = INT(name='ip-start', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_start._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_PCCPCH = BOOL(name='ip-PCCPCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-IP-PCCPCH')), opt=True)
    ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_burstModeParameters = SEQ(name='burstModeParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-BurstModeParameters')))
    __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('ip-spacing-tdd', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_spacing_tdd),
        ('ip-slot', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_slot),
        ('ip-start', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_start),
        ('ip-PCCPCH', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_PCCPCH),
        ('burstModeParameters', ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_burstModeParameters),
        ])
    __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd._ext = None
    _OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd),
        ('tdd', __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd),
        ])
    _OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo._ext = None
    OMA_LPPe_OTDOA_UTRA_IPDL_Parameters._cont = ASN1Dict([
        ('modeSpecificInfo', _OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo),
        ])
    OMA_LPPe_OTDOA_UTRA_IPDL_Parameters._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-IP-Spacing >-----#
    OMA_LPPe_OTDOA_UTRA_IP_Spacing = ENUM(name='OMA-LPPe-OTDOA-UTRA-IP-Spacing', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_IP_Spacing._cont = ASN1Dict([('e5', 0), ('e7', 1), ('e10', 2), ('e15', 3), ('e20', 4), ('e30', 5), ('e40', 6), ('e50', 7)])
    OMA_LPPe_OTDOA_UTRA_IP_Spacing._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-IP-Length >-----#
    OMA_LPPe_OTDOA_UTRA_IP_Length = ENUM(name='OMA-LPPe-OTDOA-UTRA-IP-Length', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_IP_Length._cont = ASN1Dict([('ipl5', 0), ('ipl10', 1)])
    OMA_LPPe_OTDOA_UTRA_IP_Length._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-IP-Spacing-TDD >-----#
    OMA_LPPe_OTDOA_UTRA_IP_Spacing_TDD = ENUM(name='OMA-LPPe-OTDOA-UTRA-IP-Spacing-TDD', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_IP_Spacing_TDD._cont = ASN1Dict([('e30', 0), ('e40', 1), ('e50', 2), ('e70', 3), ('e100', 4)])
    OMA_LPPe_OTDOA_UTRA_IP_Spacing_TDD._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-IP-PCCPCH >-----#
    OMA_LPPe_OTDOA_UTRA_IP_PCCPCH = BOOL(name='OMA-LPPe-OTDOA-UTRA-IP-PCCPCH', mode=MODE_TYPE)
    
    #-----< OMA-LPPe-OTDOA-UTRA-BurstModeParameters >-----#
    OMA_LPPe_OTDOA_UTRA_BurstModeParameters = SEQ(name='OMA-LPPe-OTDOA-UTRA-BurstModeParameters', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstStart = INT(name='burstStart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstLength = INT(name='burstLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=25)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstFreq = INT(name='burstFreq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstFreq._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_OTDOA_UTRA_BurstModeParameters._cont = ASN1Dict([
        ('burstStart', _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstStart),
        ('burstLength', _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstLength),
        ('burstFreq', _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstFreq),
        ])
    OMA_LPPe_OTDOA_UTRA_BurstModeParameters._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-RequestAssistanceData >-----#
    OMA_LPPe_OTDOA_UTRA_RequestAssistanceData = SEQ(name='OMA-LPPe-OTDOA-UTRA-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_RequestAssistanceData_otdoaUtraAssistanceReq = BIT_STR(name='otdoaUtraAssistanceReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_RequestAssistanceData_otdoaUtraAssistanceReq._cont = ASN1Dict([('ueAssisted', 0), ('ueBased', 1)])
    _OMA_LPPe_OTDOA_UTRA_RequestAssistanceData_otdoaUtraAssistanceReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_OTDOA_UTRA_RequestAssistanceData._cont = ASN1Dict([
        ('otdoaUtraAssistanceReq', _OMA_LPPe_OTDOA_UTRA_RequestAssistanceData_otdoaUtraAssistanceReq),
        ])
    OMA_LPPe_OTDOA_UTRA_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-ProvideLocationInformation >-----#
    OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation = SEQ(name='OMA-LPPe-OTDOA-UTRA-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_otdoaUtraMeasurement = SEQ(name='otdoaUtraMeasurement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-Measurement')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_otdoaUtraError = CHOICE(name='otdoaUtraError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-Error')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_timeStampData = SEQ(name='timeStampData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-TimeStampData')), opt=True)
    OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation._cont = ASN1Dict([
        ('otdoaUtraMeasurement', _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_otdoaUtraMeasurement),
        ('otdoaUtraError', _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_otdoaUtraError),
        ('timeStampData', _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_timeStampData),
        ])
    OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-Measurement >-----#
    OMA_LPPe_OTDOA_UTRA_Measurement = SEQ(name='OMA-LPPe-OTDOA-UTRA-Measurement', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_Measurement_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_Measurement_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas = CHOICE(name='modeSpecificInfoMeas', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd_referenceCellIdentity = SEQ(name='referenceCellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info')))
    ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd_ue_RX_TX_TimeDifferenceType2Info = SEQ(name='ue-RX-TX-TimeDifferenceType2Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-UE-RX-TX-TimeDifferenceType2Info')))
    __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd._cont = ASN1Dict([
        ('referenceCellIdentity', ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd_referenceCellIdentity),
        ('ue-RX-TX-TimeDifferenceType2Info', ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd_ue_RX_TX_TimeDifferenceType2Info),
        ])
    __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd._ext = []
    __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd_cellAndChannelIdentity = SEQ(name='cellAndChannelIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity')))
    __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd._cont = ASN1Dict([
        ('cellAndChannelIdentity', ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd_cellAndChannelIdentity),
        ])
    __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd._ext = []
    _OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd),
        ('tdd', __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd),
        ])
    _OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas._ext = None
    _OMA_LPPe_OTDOA_UTRA_Measurement_neighborList = SEQ_OF(name='neighborList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-NeighborList')), opt=True)
    OMA_LPPe_OTDOA_UTRA_Measurement._cont = ASN1Dict([
        ('sfn', _OMA_LPPe_OTDOA_UTRA_Measurement_sfn),
        ('modeSpecificInfoMeas', _OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas),
        ('neighborList', _OMA_LPPe_OTDOA_UTRA_Measurement_neighborList),
        ])
    OMA_LPPe_OTDOA_UTRA_Measurement._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-UE-RX-TX-TimeDifferenceType2Info >-----#
    OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info = SEQ(name='OMA-LPPe-OTDOA-UTRA-UE-RX-TX-TimeDifferenceType2Info', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info_ue_RX_TX_timeDifferenceType2 = INT(name='ue-RX-TX-timeDifferenceType2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-TimeDifferenceType2')))
    _OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info_neighborQuality = SEQ(name='neighborQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-NeighborQuality')))
    OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info._cont = ASN1Dict([
        ('ue-RX-TX-timeDifferenceType2', _OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info_ue_RX_TX_timeDifferenceType2),
        ('neighborQuality', _OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info_neighborQuality),
        ])
    OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-TimeDifferenceType2 >-----#
    OMA_LPPe_OTDOA_UTRA_TimeDifferenceType2 = INT(name='OMA-LPPe-OTDOA-UTRA-TimeDifferenceType2', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_TimeDifferenceType2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-NeighborList >-----#
    OMA_LPPe_OTDOA_UTRA_NeighborList = SEQ_OF(name='OMA-LPPe-OTDOA-UTRA-NeighborList', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_NeighborList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-Neighbor')))
    OMA_LPPe_OTDOA_UTRA_NeighborList._cont = _OMA_LPPe_OTDOA_UTRA_NeighborList__item_
    OMA_LPPe_OTDOA_UTRA_NeighborList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-Neighbor >-----#
    OMA_LPPe_OTDOA_UTRA_Neighbor = SEQ(name='OMA-LPPe-OTDOA-UTRA-Neighbor', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd_neighborIdentity = SEQ(name='neighborIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info')), opt=True)
    ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd_ue_RX_TX_timeDifferenceType2Info = SEQ(name='ue-RX-TX-timeDifferenceType2Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-UE-RX-TX-TimeDifferenceType2Info')), opt=True)
    __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('neighborIdentity', ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd_neighborIdentity),
        ('ue-RX-TX-timeDifferenceType2Info', ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd_ue_RX_TX_timeDifferenceType2Info),
        ])
    __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd._ext = []
    __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd_cellAndChannelIdentity = SEQ(name='cellAndChannelIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity')), opt=True)
    ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd_uarfcn = INT(name='uarfcn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')), opt=True)
    __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellAndChannelIdentity', ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd_cellAndChannelIdentity),
        ('uarfcn', ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd_uarfcn),
        ])
    __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd._ext = []
    _OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd),
        ('tdd', __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd),
        ])
    _OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo._ext = None
    _OMA_LPPe_OTDOA_UTRA_Neighbor_neighborQuality = SEQ(name='neighborQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-NeighborQuality')))
    _OMA_LPPe_OTDOA_UTRA_Neighbor_sfn_sfn_ObsTimeDifference2 = INT(name='sfn-sfn-ObsTimeDifference2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-SFN-SFN-ObsTimeDifference2')))
    OMA_LPPe_OTDOA_UTRA_Neighbor._cont = ASN1Dict([
        ('modeSpecificInfo', _OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo),
        ('neighborQuality', _OMA_LPPe_OTDOA_UTRA_Neighbor_neighborQuality),
        ('sfn-sfn-ObsTimeDifference2', _OMA_LPPe_OTDOA_UTRA_Neighbor_sfn_sfn_ObsTimeDifference2),
        ])
    OMA_LPPe_OTDOA_UTRA_Neighbor._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-NeighborQuality >-----#
    OMA_LPPe_OTDOA_UTRA_NeighborQuality = SEQ(name='OMA-LPPe-OTDOA-UTRA-NeighborQuality', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_NeighborQuality_quality = SEQ(name='quality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-Quality')))
    OMA_LPPe_OTDOA_UTRA_NeighborQuality._cont = ASN1Dict([
        ('quality', _OMA_LPPe_OTDOA_UTRA_NeighborQuality_quality),
        ])
    OMA_LPPe_OTDOA_UTRA_NeighborQuality._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-SFN-SFN-ObsTimeDifference2 >-----#
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_ObsTimeDifference2 = INT(name='OMA-LPPe-OTDOA-UTRA-SFN-SFN-ObsTimeDifference2', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_SFN_SFN_ObsTimeDifference2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-Quality >-----#
    OMA_LPPe_OTDOA_UTRA_Quality = SEQ(name='OMA-LPPe-OTDOA-UTRA-Quality', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_Quality_stdResolution = BIT_STR(name='stdResolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_Quality_stdResolution._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_Quality_numberOfOTDOA_Measurements = BIT_STR(name='numberOfOTDOA-Measurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_Quality_numberOfOTDOA_Measurements._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_Quality_stdOfOTDOA_Measurements = BIT_STR(name='stdOfOTDOA-Measurements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_Quality_stdOfOTDOA_Measurements._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    OMA_LPPe_OTDOA_UTRA_Quality._cont = ASN1Dict([
        ('stdResolution', _OMA_LPPe_OTDOA_UTRA_Quality_stdResolution),
        ('numberOfOTDOA-Measurements', _OMA_LPPe_OTDOA_UTRA_Quality_numberOfOTDOA_Measurements),
        ('stdOfOTDOA-Measurements', _OMA_LPPe_OTDOA_UTRA_Quality_stdOfOTDOA_Measurements),
        ])
    OMA_LPPe_OTDOA_UTRA_Quality._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-TimeStampData >-----#
    OMA_LPPe_OTDOA_UTRA_TimeStampData = SEQ(name='OMA-LPPe-OTDOA-UTRA-TimeStampData', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_utraCellGlobalID = SEQ(name='utraCellGlobalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')))
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfo')), opt=True)
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID = CHOICE(name='nonUniqueCellID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode')))
    __OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID_cellParametersId = INT(name='cellParametersId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellParametersID')))
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID._cont = ASN1Dict([
        ('primaryScramblingCode', __OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID_primaryScramblingCode),
        ('cellParametersId', __OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID_cellParametersId),
        ])
    _OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID._ext = []
    OMA_LPPe_OTDOA_UTRA_TimeStampData._cont = ASN1Dict([
        ('sfn', _OMA_LPPe_OTDOA_UTRA_TimeStampData_sfn),
        ('utraCellGlobalID', _OMA_LPPe_OTDOA_UTRA_TimeStampData_utraCellGlobalID),
        ('frequencyInfo', _OMA_LPPe_OTDOA_UTRA_TimeStampData_frequencyInfo),
        ('nonUniqueCellID', _OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID),
        ])
    OMA_LPPe_OTDOA_UTRA_TimeStampData._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-RequestLocationInformation >-----#
    OMA_LPPe_OTDOA_UTRA_RequestLocationInformation = SEQ(name='OMA-LPPe-OTDOA-UTRA-RequestLocationInformation', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_RequestLocationInformation._cont = ASN1Dict([
        ])
    OMA_LPPe_OTDOA_UTRA_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-ProvideCapabilities >-----#
    OMA_LPPe_OTDOA_UTRA_ProvideCapabilities = SEQ(name='OMA-LPPe-OTDOA-UTRA-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ueBasedSupported = BOOL(name='ueBasedSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ueAssistedSupported = BOOL(name='ueAssistedSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ipdlSupported = BOOL(name='ipdlSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_OTDOA_UTRA_ProvideCapabilities._cont = ASN1Dict([
        ('ueBasedSupported', _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ueBasedSupported),
        ('ueAssistedSupported', _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ueAssistedSupported),
        ('ipdlSupported', _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ipdlSupported),
        ])
    OMA_LPPe_OTDOA_UTRA_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-RequestCapabilities >-----#
    OMA_LPPe_OTDOA_UTRA_RequestCapabilities = SEQ(name='OMA-LPPe-OTDOA-UTRA-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_OTDOA_UTRA_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-Error >-----#
    OMA_LPPe_OTDOA_UTRA_Error = CHOICE(name='OMA-LPPe-OTDOA-UTRA-Error', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-LocationServerErrorCauses')))
    _OMA_LPPe_OTDOA_UTRA_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-TargetDeviceErrorCauses')))
    OMA_LPPe_OTDOA_UTRA_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_OTDOA_UTRA_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_OTDOA_UTRA_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_OTDOA_UTRA_Error._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-LocationServerErrorCauses >-----#
    OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses = SEQ(name='OMA-LPPe-OTDOA-UTRA-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefinedError', 0), ('assistanceDataForUEbasedOTDOAnotAvailable', 1), ('assistanceDataForUEassistedOTDOAnotAvailable', 2)])
    _OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses_cause._ext = []
    OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses_cause),
        ])
    OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-TargetDeviceErrorCauses >-----#
    OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-OTDOA-UTRA-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefinedError', 0), ('notEnoughOTDOA-cells', 1), ('assistanceDataMissing', 2), ('referenceCellNotServingCell', 3), ('otdoaMeasurementsNotSupported', 4), ('otdoaMeasurementsNotAvailable', 5), ('uebasedOTDOAnotSupported', 6)])
    _OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses_cause._ext = []
    OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses_cause),
        ])
    OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info >-----#
    OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info = SEQ(name='OMA-LPPe-OTDOA-UTRA-PrimaryCPICH-Info', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode')))
    OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info._cont = ASN1Dict([
        ('primaryScramblingCode', _OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info_primaryScramblingCode),
        ])
    OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode >-----#
    OMA_LPPe_OTDOA_UTRA_PrimaryScramblingCode = INT(name='OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_PrimaryScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity >-----#
    OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity = SEQ(name='OMA-LPPe-OTDOA-UTRA-CellAndChannelIdentity', mode=MODE_TYPE)
    _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_burstType = ENUM(name='burstType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-BurstType')))
    _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_midambleShift = INT(name='midambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-MidambleShiftLong')))
    _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-TimeSlotNumber')))
    _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_cellParametersID = INT(name='cellParametersID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellParametersID')))
    OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity._cont = ASN1Dict([
        ('burstType', _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_burstType),
        ('midambleShift', _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_midambleShift),
        ('timeslot', _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_timeslot),
        ('cellParametersID', _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_cellParametersID),
        ])
    OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity._ext = []
    
    #-----< OMA-LPPe-OTDOA-UTRA-BurstType >-----#
    OMA_LPPe_OTDOA_UTRA_BurstType = ENUM(name='OMA-LPPe-OTDOA-UTRA-BurstType', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_BurstType._cont = ASN1Dict([('type1', 0), ('type2', 1)])
    OMA_LPPe_OTDOA_UTRA_BurstType._ext = None
    
    #-----< OMA-LPPe-OTDOA-UTRA-MidambleShiftLong >-----#
    OMA_LPPe_OTDOA_UTRA_MidambleShiftLong = INT(name='OMA-LPPe-OTDOA-UTRA-MidambleShiftLong', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_MidambleShiftLong._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-TimeSlotNumber >-----#
    OMA_LPPe_OTDOA_UTRA_TimeSlotNumber = INT(name='OMA-LPPe-OTDOA-UTRA-TimeSlotNumber', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_TimeSlotNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< OMA-LPPe-OTDOA-UTRA-CellParametersID >-----#
    OMA_LPPe_OTDOA_UTRA_CellParametersID = INT(name='OMA-LPPe-OTDOA-UTRA-CellParametersID', mode=MODE_TYPE)
    OMA_LPPe_OTDOA_UTRA_CellParametersID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-LTE-ProvideAssistanceData >-----#
    OMA_LPPe_ECID_LTE_ProvideAssistanceData = SEQ(name='OMA-LPPe-ECID-LTE-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData = SEQ_OF(name='ecid-LTE-NetworkData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-NetworkData')))
    _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData._cont = __OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData__item_
    _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_Error = CHOICE(name='ecid-LTE-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-Error')), opt=True)
    OMA_LPPe_ECID_LTE_ProvideAssistanceData._cont = ASN1Dict([
        ('ecid-LTE-NetworkData', _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData),
        ('ecid-LTE-Error', _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_Error),
        ])
    OMA_LPPe_ECID_LTE_ProvideAssistanceData._ext = []
    
    #-----< maxLTENetworks >-----#
    maxLTENetworks = INT(name='maxLTENetworks', mode=MODE_VALUE)
    maxLTENetworks._val = 8
    
    #-----< OMA-LPPe-ECID-LTE-NetworkData >-----#
    OMA_LPPe_ECID_LTE_NetworkData = SEQ(name='OMA-LPPe-ECID-LTE-NetworkData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc._cont = ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc__item_
    __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc._cont = ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc__item_
    __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity._cont = ASN1Dict([
        ('mcc', __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc),
        ('mnc', __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc),
        ])
    _OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity._ext = []
    _OMA_LPPe_ECID_LTE_NetworkData_multiple_PLMNs = BOOL(name='multiple-PLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_NetworkData_reference_location = SEQ(name='reference-location', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list = SEQ_OF(name='ecid-lte-eNodeB-list', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-eNodeBData')))
    _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list._cont = __OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list__item_
    _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list = SEQ_OF(name='ecid-lte-HeNB-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-HeNBData')))
    _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list._cont = __OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list__item_
    _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ECID_LTE_NetworkData._cont = ASN1Dict([
        ('plmn-Identity', _OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity),
        ('multiple-PLMNs', _OMA_LPPe_ECID_LTE_NetworkData_multiple_PLMNs),
        ('reference-location', _OMA_LPPe_ECID_LTE_NetworkData_reference_location),
        ('ecid-lte-eNodeB-list', _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list),
        ('ecid-lte-HeNB-list', _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list),
        ])
    OMA_LPPe_ECID_LTE_NetworkData._ext = []
    
    #-----< maxLTEeNBs >-----#
    maxLTEeNBs = INT(name='maxLTEeNBs', mode=MODE_VALUE)
    maxLTEeNBs._val = 32
    
    #-----< maxLTEHeNBs >-----#
    maxLTEHeNBs = INT(name='maxLTEHeNBs', mode=MODE_VALUE)
    maxLTEHeNBs._val = 128
    
    #-----< OMA-LPPe-ECID-LTE-eNodeBData >-----#
    OMA_LPPe_ECID_LTE_eNodeBData = SEQ(name='OMA-LPPe-ECID-LTE-eNodeBData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_eNodeBData_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData = SEQ_OF(name='ecid-lte-eNodeB-CellData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-CellData')))
    _OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData._cont = __OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData__item_
    _OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_ECID_LTE_eNodeBData._cont = ASN1Dict([
        ('relative-location', _OMA_LPPe_ECID_LTE_eNodeBData_relative_location),
        ('ecid-lte-eNodeB-CellData', _OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData),
        ])
    OMA_LPPe_ECID_LTE_eNodeBData._ext = []
    
    #-----< maxLTEMacroCells >-----#
    maxLTEMacroCells = INT(name='maxLTEMacroCells', mode=MODE_VALUE)
    maxLTEMacroCells._val = 8
    
    #-----< OMA-LPPe-ECID-LTE-HeNBData >-----#
    OMA_LPPe_ECID_LTE_HeNBData = SEQ(name='OMA-LPPe-ECID-LTE-HeNBData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_HeNBData_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_ECID_LTE_HeNBData_location_reliability = INT(name='location-reliability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_HeNBData_location_reliability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_HeNBData_coverageArea = SEQ(name='coverageArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLANFemtoCoverageArea')), opt=True)
    _OMA_LPPe_ECID_LTE_HeNBData_ecid_lte_HeNB_CellData = SEQ(name='ecid-lte-HeNB-CellData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-CellData')))
    OMA_LPPe_ECID_LTE_HeNBData._cont = ASN1Dict([
        ('relative-location', _OMA_LPPe_ECID_LTE_HeNBData_relative_location),
        ('location-reliability', _OMA_LPPe_ECID_LTE_HeNBData_location_reliability),
        ('coverageArea', _OMA_LPPe_ECID_LTE_HeNBData_coverageArea),
        ('ecid-lte-HeNB-CellData', _OMA_LPPe_ECID_LTE_HeNBData_ecid_lte_HeNB_CellData),
        ])
    OMA_LPPe_ECID_LTE_HeNBData._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-CellData >-----#
    OMA_LPPe_ECID_LTE_CellData = SEQ(name='OMA-LPPe-ECID-LTE-CellData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_CellData_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_physCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_CellData_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_cellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_CellData_dl_CarrierFreq = INT(name='dl-CarrierFreq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueEUTRA')))
    _OMA_LPPe_ECID_LTE_CellData_rs_transmit_power = INT(name='rs-transmit-power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_rs_transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_CellData_antennaPortConfig = ENUM(name='antennaPortConfig', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_antennaPortConfig._cont = ASN1Dict([('port1', 0), ('ports2', 1), ('ports4', 2)])
    _OMA_LPPe_ECID_LTE_CellData_antennaPortConfig._ext = []
    _OMA_LPPe_ECID_LTE_CellData_antenna_gain = INT(name='antenna-gain', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_antenna_gain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_CellData_beam_width = INT(name='beam-width', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_beam_width._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=360)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_CellData_transmit_direction = INT(name='transmit-direction', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_CellData_transmit_direction._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=360)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_CellData_frequency_accuracy = INT(name='frequency-accuracy', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_CellData_frequency_accuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    OMA_LPPe_ECID_LTE_CellData._cont = ASN1Dict([
        ('physCellId', _OMA_LPPe_ECID_LTE_CellData_physCellId),
        ('cellIdentity', _OMA_LPPe_ECID_LTE_CellData_cellIdentity),
        ('dl-CarrierFreq', _OMA_LPPe_ECID_LTE_CellData_dl_CarrierFreq),
        ('rs-transmit-power', _OMA_LPPe_ECID_LTE_CellData_rs_transmit_power),
        ('antennaPortConfig', _OMA_LPPe_ECID_LTE_CellData_antennaPortConfig),
        ('antenna-gain', _OMA_LPPe_ECID_LTE_CellData_antenna_gain),
        ('beam-width', _OMA_LPPe_ECID_LTE_CellData_beam_width),
        ('transmit-direction', _OMA_LPPe_ECID_LTE_CellData_transmit_direction),
        ('frequency-accuracy', _OMA_LPPe_ECID_LTE_CellData_frequency_accuracy),
        ])
    OMA_LPPe_ECID_LTE_CellData._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-RequestAssistanceData >-----#
    OMA_LPPe_ECID_LTE_RequestAssistanceData = SEQ(name='OMA-LPPe-ECID-LTE-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_RequestAssistanceData_eNBrequestedAD = BIT_STR(name='eNBrequestedAD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_RequestAssistanceData_eNBrequestedAD._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('transmit-power', 2), ('antennaPortConfig', 3), ('antenna-gain', 4), ('beam-width', 5), ('transmit-direction', 6), ('frequency-accuracy', 7), ('non-serving', 8)])
    _OMA_LPPe_ECID_LTE_RequestAssistanceData_eNBrequestedAD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_RequestAssistanceData_heNBrequestedAD = BIT_STR(name='heNBrequestedAD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_RequestAssistanceData_heNBrequestedAD._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('locationreliability', 2), ('transmit-power', 3), ('antennaPortConfig', 4), ('frequency-accuracy', 5), ('coveragearea', 6), ('non-serving', 7)])
    _OMA_LPPe_ECID_LTE_RequestAssistanceData_heNBrequestedAD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_LTE_RequestAssistanceData._cont = ASN1Dict([
        ('eNBrequestedAD', _OMA_LPPe_ECID_LTE_RequestAssistanceData_eNBrequestedAD),
        ('heNBrequestedAD', _OMA_LPPe_ECID_LTE_RequestAssistanceData_heNBrequestedAD),
        ])
    OMA_LPPe_ECID_LTE_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-ProvideLocationInformation >-----#
    OMA_LPPe_ECID_LTE_ProvideLocationInformation = SEQ(name='OMA-LPPe-ECID-LTE-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation = SEQ_OF(name='ecid-LTE-CombinedLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-LocationInformationList')))
    _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation._cont = __OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation__item_
    _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_Error = CHOICE(name='ecid-LTE-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-Error')), opt=True)
    OMA_LPPe_ECID_LTE_ProvideLocationInformation._cont = ASN1Dict([
        ('ecid-LTE-CombinedLocationInformation', _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation),
        ('ecid-LTE-Error', _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_Error),
        ])
    OMA_LPPe_ECID_LTE_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-LocationInformationList >-----#
    OMA_LPPe_ECID_LTE_LocationInformationList = SEQ(name='OMA-LPPe-ECID-LTE-LocationInformationList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_LocationInformationList_ecid_LTE_LocationInformation = SEQ(name='ecid-LTE-LocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-LocationInformation')))
    _OMA_LPPe_ECID_LTE_LocationInformationList_relativeTimeStamp = INT(name='relativeTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationInformationList_relativeTimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_LocationInformationList_servingFlag = BOOL(name='servingFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_ECID_LTE_LocationInformationList._cont = ASN1Dict([
        ('ecid-LTE-LocationInformation', _OMA_LPPe_ECID_LTE_LocationInformationList_ecid_LTE_LocationInformation),
        ('relativeTimeStamp', _OMA_LPPe_ECID_LTE_LocationInformationList_relativeTimeStamp),
        ('servingFlag', _OMA_LPPe_ECID_LTE_LocationInformationList_servingFlag),
        ])
    OMA_LPPe_ECID_LTE_LocationInformationList._ext = []
    
    #-----< maxLTEECIDSize >-----#
    maxLTEECIDSize = INT(name='maxLTEECIDSize', mode=MODE_VALUE)
    maxLTEECIDSize._val = 64
    
    #-----< OMA-LPPe-ECID-LTE-LocationInformation >-----#
    OMA_LPPe_ECID_LTE_LocationInformation = SEQ(name='OMA-LPPe-ECID-LTE-LocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_LocationInformation_lpp_ECID_SignalMeasurementInformation = SEQ(name='lpp-ECID-SignalMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ECID-SignalMeasurementInformation')))
    OMA_LPPe_ECID_LTE_LocationInformation._cont = ASN1Dict([
        ('lpp-ECID-SignalMeasurementInformation', _OMA_LPPe_ECID_LTE_LocationInformation_lpp_ECID_SignalMeasurementInformation),
        ])
    OMA_LPPe_ECID_LTE_LocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-RequestLocationInformation >-----#
    OMA_LPPe_ECID_LTE_RequestLocationInformation = SEQ(name='OMA-LPPe-ECID-LTE-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_RequestLocationInformation_requestedMeasurements = BIT_STR(name='requestedMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_RequestLocationInformation_requestedMeasurements._cont = ASN1Dict([('rsrp', 0), ('rsrq', 1), ('ueRxTx', 2), ('non-serving', 3), ('historic', 4)])
    _OMA_LPPe_ECID_LTE_RequestLocationInformation_requestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_ECID_LTE_RequestLocationInformation._cont = ASN1Dict([
        ('requestedMeasurements', _OMA_LPPe_ECID_LTE_RequestLocationInformation_requestedMeasurements),
        ])
    OMA_LPPe_ECID_LTE_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-ProvideCapabilities >-----#
    OMA_LPPe_ECID_LTE_ProvideCapabilities = SEQ(name='OMA-LPPe-ECID-LTE-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_MeasSupported = BIT_STR(name='ecid-lte-MeasSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_MeasSupported._cont = ASN1Dict([('rsrp', 0), ('rsrq', 1), ('ueRxTx', 2), ('non-serving', 3), ('historic', 4)])
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_eNodeB_ADSupported = BIT_STR(name='ecid-lte-eNodeB-ADSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_eNodeB_ADSupported._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('transmit-power', 2), ('antennaPortConfig', 3), ('antenna-gain', 4), ('beam-width', 5), ('transmit-direction', 6), ('frequency-accuracy', 7), ('non-serving', 8)])
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_eNodeB_ADSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_utra_HeNB_ADSupported = BIT_STR(name='ecid-utra-HeNB-ADSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_utra_HeNB_ADSupported._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('locationreliability', 2), ('transmit-power', 3), ('antennaPortConfig', 4), ('frequency-accuracy', 5), ('coveragearea', 6), ('non-serving', 7)])
    _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_utra_HeNB_ADSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_LTE_ProvideCapabilities._cont = ASN1Dict([
        ('ecid-lte-MeasSupported', _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_MeasSupported),
        ('ecid-lte-eNodeB-ADSupported', _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_eNodeB_ADSupported),
        ('ecid-utra-HeNB-ADSupported', _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_utra_HeNB_ADSupported),
        ])
    OMA_LPPe_ECID_LTE_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-RequestCapabilities >-----#
    OMA_LPPe_ECID_LTE_RequestCapabilities = SEQ(name='OMA-LPPe-ECID-LTE-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_ECID_LTE_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_ECID_LTE_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-Error >-----#
    OMA_LPPe_ECID_LTE_Error = CHOICE(name='OMA-LPPe-ECID-LTE-Error', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-LocationServerErrorCauses')))
    _OMA_LPPe_ECID_LTE_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-LTE-TargetDeviceErrorCauses')))
    OMA_LPPe_ECID_LTE_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_ECID_LTE_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_ECID_LTE_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_ECID_LTE_Error._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-LocationServerErrorCauses >-----#
    OMA_LPPe_ECID_LTE_LocationServerErrorCauses = SEQ(name='OMA-LPPe-ECID-LTE-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedADNotAvailable', 1), ('notAllrequestedADAvailable', 2)])
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBMandatoryDataUnavailable = NULL(name='eNodeBMandatoryDataUnavailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBLocationsUnavailable = NULL(name='eNodeBLocationsUnavailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellTransmitPowerUnavailable = NULL(name='eNodeBcellTransmitPowerUnavailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellAntennaPortConfigUnavailable = NULL(name='eNodeBcellAntennaPortConfigUnavailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcallAntennaGainUnavailable = NULL(name='eNodeBcallAntennaGainUnavailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellBeamWidthUnavailable = NULL(name='eNodeBcellBeamWidthUnavailable', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellTransmitDirectionUnavailable = NULL(name='eNodeBcellTransmitDirectionUnavailable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellFrequencyAccuracyUnavailable = NULL(name='eNodeBcellFrequencyAccuracyUnavailable', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBnonservingADUnavailable = NULL(name='eNodeBnonservingADUnavailable', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBMandatoryDataUnavailable = NULL(name='heNBMandatoryDataUnavailable', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBLocationUnavailable = NULL(name='heNBLocationUnavailable', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBLocationReliabilityUnavailable = NULL(name='heNBLocationReliabilityUnavailable', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellTransmitPowerUnavailable = NULL(name='heNBcellTransmitPowerUnavailable', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellAntennaPortConfigUnavailable = NULL(name='heNBcellAntennaPortConfigUnavailable', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellFrequencyAccuracyUnavailable = NULL(name='heNBcellFrequencyAccuracyUnavailable', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBCoverageAreaUnavailable = NULL(name='heNBCoverageAreaUnavailable', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBnonservingADUnavailable = NULL(name='heNBnonservingADUnavailable', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_LTE_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_cause),
        ('eNodeBMandatoryDataUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBMandatoryDataUnavailable),
        ('eNodeBLocationsUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBLocationsUnavailable),
        ('eNodeBcellTransmitPowerUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellTransmitPowerUnavailable),
        ('eNodeBcellAntennaPortConfigUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellAntennaPortConfigUnavailable),
        ('eNodeBcallAntennaGainUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcallAntennaGainUnavailable),
        ('eNodeBcellBeamWidthUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellBeamWidthUnavailable),
        ('eNodeBcellTransmitDirectionUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellTransmitDirectionUnavailable),
        ('eNodeBcellFrequencyAccuracyUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellFrequencyAccuracyUnavailable),
        ('eNodeBnonservingADUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBnonservingADUnavailable),
        ('heNBMandatoryDataUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBMandatoryDataUnavailable),
        ('heNBLocationUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBLocationUnavailable),
        ('heNBLocationReliabilityUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBLocationReliabilityUnavailable),
        ('heNBcellTransmitPowerUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellTransmitPowerUnavailable),
        ('heNBcellAntennaPortConfigUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellAntennaPortConfigUnavailable),
        ('heNBcellFrequencyAccuracyUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellFrequencyAccuracyUnavailable),
        ('heNBCoverageAreaUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBCoverageAreaUnavailable),
        ('heNBnonservingADUnavailable', _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBnonservingADUnavailable),
        ])
    OMA_LPPe_ECID_LTE_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-ECID-LTE-TargetDeviceErrorCauses >-----#
    OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-ECID-LTE-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_rsrpMeasurementNotPossible = NULL(name='rsrpMeasurementNotPossible', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_rsrqMeasurementNotPossible = NULL(name='rsrqMeasurementNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_ueRxTxMeasurementNotPossible = NULL(name='ueRxTxMeasurementNotPossible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable = NULL(name='non-servingMeasurementsNotAvailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_historicMeasurementsNotAvailable = NULL(name='historicMeasurementsNotAvailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_cause),
        ('rsrpMeasurementNotPossible', _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_rsrpMeasurementNotPossible),
        ('rsrqMeasurementNotPossible', _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_rsrqMeasurementNotPossible),
        ('ueRxTxMeasurementNotPossible', _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_ueRxTxMeasurementNotPossible),
        ('non-servingMeasurementsNotAvailable', _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable),
        ('historicMeasurementsNotAvailable', _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_historicMeasurementsNotAvailable),
        ])
    OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-ProvideAssistanceData >-----#
    OMA_LPPe_ECID_GSM_ProvideAssistanceData = SEQ(name='OMA-LPPe-ECID-GSM-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData = SEQ_OF(name='ecid-gsm-NetworkData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-NetworkData')))
    _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData._cont = __OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData__item_
    _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_Error = CHOICE(name='ecid-gsm-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-Error')), opt=True)
    OMA_LPPe_ECID_GSM_ProvideAssistanceData._cont = ASN1Dict([
        ('ecid-gsm-NetworkData', _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData),
        ('ecid-gsm-Error', _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_Error),
        ])
    OMA_LPPe_ECID_GSM_ProvideAssistanceData._ext = []
    
    #-----< maxGSMNetworks >-----#
    maxGSMNetworks = INT(name='maxGSMNetworks', mode=MODE_VALUE)
    maxGSMNetworks._val = 8
    
    #-----< OMA-LPPe-ECID-GSM-NetworkData >-----#
    OMA_LPPe_ECID_GSM_NetworkData = SEQ(name='OMA-LPPe-ECID-GSM-NetworkData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc._cont = ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc__item_
    __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc._cont = ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc__item_
    __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity._cont = ASN1Dict([
        ('mcc', __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc),
        ('mnc', __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc),
        ])
    _OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity._ext = None
    _OMA_LPPe_ECID_GSM_NetworkData_reference_location = SEQ(name='reference-location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_ECID_GSM_NetworkData_base_station_list = SEQ_OF(name='base-station-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_GSM_NetworkData_base_station_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-BaseStationData')))
    _OMA_LPPe_ECID_GSM_NetworkData_base_station_list._cont = __OMA_LPPe_ECID_GSM_NetworkData_base_station_list__item_
    _OMA_LPPe_ECID_GSM_NetworkData_base_station_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    OMA_LPPe_ECID_GSM_NetworkData._cont = ASN1Dict([
        ('plmn-Identity', _OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity),
        ('reference-location', _OMA_LPPe_ECID_GSM_NetworkData_reference_location),
        ('base-station-list', _OMA_LPPe_ECID_GSM_NetworkData_base_station_list),
        ])
    OMA_LPPe_ECID_GSM_NetworkData._ext = []
    
    #-----< maxGSMBaseStations >-----#
    maxGSMBaseStations = INT(name='maxGSMBaseStations', mode=MODE_VALUE)
    maxGSMBaseStations._val = 32
    
    #-----< OMA-LPPe-ECID-GSM-BaseStationData >-----#
    OMA_LPPe_ECID_GSM_BaseStationData = SEQ(name='OMA-LPPe-ECID-GSM-BaseStationData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_BaseStationData_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData = SEQ_OF(name='ecid-gsm-CellData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-CellData')))
    _OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData._cont = __OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData__item_
    _OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_ECID_GSM_BaseStationData._cont = ASN1Dict([
        ('relative-location', _OMA_LPPe_ECID_GSM_BaseStationData_relative_location),
        ('ecid-gsm-CellData', _OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData),
        ])
    OMA_LPPe_ECID_GSM_BaseStationData._ext = []
    
    #-----< maxGSMCells >-----#
    maxGSMCells = INT(name='maxGSMCells', mode=MODE_VALUE)
    maxGSMCells._val = 8
    
    #-----< OMA-LPPe-ECID-GSM-CellData >-----#
    OMA_LPPe_ECID_GSM_CellData = SEQ(name='OMA-LPPe-ECID-GSM-CellData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_CellData_cellNonUniqueIDGERAN = SEQ(name='cellNonUniqueIDGERAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellNonUniqueIDGERAN')), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_cellLocalIDGERAN = SEQ(name='cellLocalIDGERAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellLocalIdGERAN')), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_transmit_power = INT(name='transmit-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_CellData_antenna_gain = INT(name='antenna-gain', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_antenna_gain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_CellData_beam_width = INT(name='beam-width', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_beam_width._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=360)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_CellData_transmit_direction = INT(name='transmit-direction', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_transmit_direction._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=360)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_CellData_frequency_accuracy = INT(name='frequency-accuracy', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_CellData_frequency_accuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    OMA_LPPe_ECID_GSM_CellData._cont = ASN1Dict([
        ('cellNonUniqueIDGERAN', _OMA_LPPe_ECID_GSM_CellData_cellNonUniqueIDGERAN),
        ('cellLocalIDGERAN', _OMA_LPPe_ECID_GSM_CellData_cellLocalIDGERAN),
        ('transmit-power', _OMA_LPPe_ECID_GSM_CellData_transmit_power),
        ('antenna-gain', _OMA_LPPe_ECID_GSM_CellData_antenna_gain),
        ('beam-width', _OMA_LPPe_ECID_GSM_CellData_beam_width),
        ('transmit-direction', _OMA_LPPe_ECID_GSM_CellData_transmit_direction),
        ('frequency-accuracy', _OMA_LPPe_ECID_GSM_CellData_frequency_accuracy),
        ])
    OMA_LPPe_ECID_GSM_CellData._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-RequestAssistanceData >-----#
    OMA_LPPe_ECID_GSM_RequestAssistanceData = SEQ(name='OMA-LPPe-ECID-GSM-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_RequestAssistanceData_requestedAD = BIT_STR(name='requestedAD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_GSM_RequestAssistanceData_requestedAD._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('transmit-power', 2), ('antenna-gain', 3), ('beam-width', 4), ('transmit-direction', 5), ('frequency-accuracy', 6), ('non-serving', 7)])
    _OMA_LPPe_ECID_GSM_RequestAssistanceData_requestedAD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_GSM_RequestAssistanceData._cont = ASN1Dict([
        ('requestedAD', _OMA_LPPe_ECID_GSM_RequestAssistanceData_requestedAD),
        ])
    OMA_LPPe_ECID_GSM_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-ProvideLocationInformation >-----#
    OMA_LPPe_ECID_GSM_ProvideLocationInformation = SEQ(name='OMA-LPPe-ECID-GSM-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation = SEQ_OF(name='ecid-GSM-CombinedLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-LocationInformationList')))
    _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation._cont = __OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation__item_
    _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_Error = CHOICE(name='ecid-GSM-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-Error')), opt=True)
    OMA_LPPe_ECID_GSM_ProvideLocationInformation._cont = ASN1Dict([
        ('ecid-GSM-CombinedLocationInformation', _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation),
        ('ecid-GSM-Error', _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_Error),
        ])
    OMA_LPPe_ECID_GSM_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-LocationInformationList >-----#
    OMA_LPPe_ECID_GSM_LocationInformationList = SEQ(name='OMA-LPPe-ECID-GSM-LocationInformationList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_LocationInformationList_ecid_GSM_LocationInformation = SEQ(name='ecid-GSM-LocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-LocationInformation')))
    _OMA_LPPe_ECID_GSM_LocationInformationList_relativeTimeStamp = INT(name='relativeTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationInformationList_relativeTimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_LocationInformationList_servingFlag = BOOL(name='servingFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_ECID_GSM_LocationInformationList._cont = ASN1Dict([
        ('ecid-GSM-LocationInformation', _OMA_LPPe_ECID_GSM_LocationInformationList_ecid_GSM_LocationInformation),
        ('relativeTimeStamp', _OMA_LPPe_ECID_GSM_LocationInformationList_relativeTimeStamp),
        ('servingFlag', _OMA_LPPe_ECID_GSM_LocationInformationList_servingFlag),
        ])
    OMA_LPPe_ECID_GSM_LocationInformationList._ext = []
    
    #-----< maxGSMECIDSize >-----#
    maxGSMECIDSize = INT(name='maxGSMECIDSize', mode=MODE_VALUE)
    maxGSMECIDSize._val = 64
    
    #-----< OMA-LPPe-ECID-GSM-LocationInformation >-----#
    OMA_LPPe_ECID_GSM_LocationInformation = SEQ(name='OMA-LPPe-ECID-GSM-LocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_LocationInformation_cellGlobalIdGERAN = SEQ(name='cellGlobalIdGERAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdGERAN')))
    _OMA_LPPe_ECID_GSM_LocationInformation_rxLevel = INT(name='rxLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationInformation_rxLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_LocationInformation_tA = INT(name='tA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationInformation_tA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_LocationInformation_nMR_GERAN = SEQ_OF(name='nMR-GERAN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-NMR-GERAN')), opt=True)
    OMA_LPPe_ECID_GSM_LocationInformation._cont = ASN1Dict([
        ('cellGlobalIdGERAN', _OMA_LPPe_ECID_GSM_LocationInformation_cellGlobalIdGERAN),
        ('rxLevel', _OMA_LPPe_ECID_GSM_LocationInformation_rxLevel),
        ('tA', _OMA_LPPe_ECID_GSM_LocationInformation_tA),
        ('nMR-GERAN', _OMA_LPPe_ECID_GSM_LocationInformation_nMR_GERAN),
        ])
    OMA_LPPe_ECID_GSM_LocationInformation._ext = []
    
    #-----< OMA-LPPe-NMR-GERAN >-----#
    OMA_LPPe_NMR_GERAN = SEQ_OF(name='OMA-LPPe-NMR-GERAN', mode=MODE_TYPE)
    _OMA_LPPe_NMR_GERAN__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __OMA_LPPe_NMR_GERAN__item__cellNonUniqueIDGERAN = SEQ(name='cellNonUniqueIDGERAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellNonUniqueIDGERAN')))
    __OMA_LPPe_NMR_GERAN__item__cellLocalIDGERAN = SEQ(name='cellLocalIDGERAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-CellLocalIdGERAN')), opt=True)
    __OMA_LPPe_NMR_GERAN__item__rxLevel = INT(name='rxLevel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_NMR_GERAN__item__rxLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_NMR_GERAN__item_._cont = ASN1Dict([
        ('cellNonUniqueIDGERAN', __OMA_LPPe_NMR_GERAN__item__cellNonUniqueIDGERAN),
        ('cellLocalIDGERAN', __OMA_LPPe_NMR_GERAN__item__cellLocalIDGERAN),
        ('rxLevel', __OMA_LPPe_NMR_GERAN__item__rxLevel),
        ])
    _OMA_LPPe_NMR_GERAN__item_._ext = []
    OMA_LPPe_NMR_GERAN._cont = _OMA_LPPe_NMR_GERAN__item_
    OMA_LPPe_NMR_GERAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-GSM-RequestLocationInformation >-----#
    OMA_LPPe_ECID_GSM_RequestLocationInformation = SEQ(name='OMA-LPPe-ECID-GSM-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_RequestLocationInformation_requestedMeasurements = BIT_STR(name='requestedMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_GSM_RequestLocationInformation_requestedMeasurements._cont = ASN1Dict([('rxLevel', 0), ('tA', 1), ('nMR-GERAN', 2), ('non-serving', 3), ('historic', 4)])
    _OMA_LPPe_ECID_GSM_RequestLocationInformation_requestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_ECID_GSM_RequestLocationInformation._cont = ASN1Dict([
        ('requestedMeasurements', _OMA_LPPe_ECID_GSM_RequestLocationInformation_requestedMeasurements),
        ])
    OMA_LPPe_ECID_GSM_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-ProvideCapabilities >-----#
    OMA_LPPe_ECID_GSM_ProvideCapabilities = SEQ(name='OMA-LPPe-ECID-GSM-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_MeasSupported = BIT_STR(name='ecid-gsm-MeasSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_MeasSupported._cont = ASN1Dict([('rxLevel', 0), ('tA', 1), ('nMR-GERAN', 2), ('non-serving', 3), ('historic', 4)])
    _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_ADSupported = BIT_STR(name='ecid-gsm-ADSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_ADSupported._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('transmit-power', 2), ('antenna-gain', 3), ('beam-width', 4), ('transmit-direction', 5), ('frequency-accuracy', 6), ('non-serving', 7)])
    _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_ADSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_GSM_ProvideCapabilities._cont = ASN1Dict([
        ('ecid-gsm-MeasSupported', _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_MeasSupported),
        ('ecid-gsm-ADSupported', _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_ADSupported),
        ])
    OMA_LPPe_ECID_GSM_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-RequestCapabilities >-----#
    OMA_LPPe_ECID_GSM_RequestCapabilities = SEQ(name='OMA-LPPe-ECID-GSM-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_ECID_GSM_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_ECID_GSM_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-Error >-----#
    OMA_LPPe_ECID_GSM_Error = CHOICE(name='OMA-LPPe-ECID-GSM-Error', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-LocationServerErrorCauses')))
    _OMA_LPPe_ECID_GSM_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-GSM-TargetDeviceErrorCauses')))
    OMA_LPPe_ECID_GSM_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_ECID_GSM_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_ECID_GSM_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_ECID_GSM_Error._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-LocationServerErrorCauses >-----#
    OMA_LPPe_ECID_GSM_LocationServerErrorCauses = SEQ(name='OMA-LPPe-ECID-GSM-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedADNotAvailable', 1), ('notAllrequestedADAvailable', 2)])
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_mandatoryDataUnavailable = NULL(name='mandatoryDataUnavailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_bsLocationsUnavailable = NULL(name='bsLocationsUnavailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellTransmitPowerUnavailable = NULL(name='cellTransmitPowerUnavailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_callAntennaGainUnavailable = NULL(name='callAntennaGainUnavailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellBeamWidthUnavailable = NULL(name='cellBeamWidthUnavailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellTransmitDirectionUnavailable = NULL(name='cellTransmitDirectionUnavailable', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellFrequencyAccuracyUnavailable = NULL(name='cellFrequencyAccuracyUnavailable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_nonservingADUnavailable = NULL(name='nonservingADUnavailable', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_GSM_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cause),
        ('mandatoryDataUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_mandatoryDataUnavailable),
        ('bsLocationsUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_bsLocationsUnavailable),
        ('cellTransmitPowerUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellTransmitPowerUnavailable),
        ('callAntennaGainUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_callAntennaGainUnavailable),
        ('cellBeamWidthUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellBeamWidthUnavailable),
        ('cellTransmitDirectionUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellTransmitDirectionUnavailable),
        ('cellFrequencyAccuracyUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellFrequencyAccuracyUnavailable),
        ('nonservingADUnavailable', _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_nonservingADUnavailable),
        ])
    OMA_LPPe_ECID_GSM_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-ECID-GSM-TargetDeviceErrorCauses >-----#
    OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-ECID-GSM-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_rxLevelMeasurementNotPossible = NULL(name='rxLevelMeasurementNotPossible', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_taMeasurementNotPossible = NULL(name='taMeasurementNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_nMRMeasurementNotPossible = NULL(name='nMRMeasurementNotPossible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable = NULL(name='non-servingMeasurementsNotAvailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_historicMeasurementsNotAvailable = NULL(name='historicMeasurementsNotAvailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_cause),
        ('rxLevelMeasurementNotPossible', _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_rxLevelMeasurementNotPossible),
        ('taMeasurementNotPossible', _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_taMeasurementNotPossible),
        ('nMRMeasurementNotPossible', _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_nMRMeasurementNotPossible),
        ('non-servingMeasurementsNotAvailable', _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable),
        ('historicMeasurementsNotAvailable', _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_historicMeasurementsNotAvailable),
        ])
    OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-ProvideAssistanceData >-----#
    OMA_LPPe_ECID_UTRA_ProvideAssistanceData = SEQ(name='OMA-LPPe-ECID-UTRA-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData = SEQ_OF(name='ecid-UTRA-NetworkData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-NetworkData')))
    _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData._cont = __OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData__item_
    _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_Error = CHOICE(name='ecid-UTRA-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-Error')), opt=True)
    OMA_LPPe_ECID_UTRA_ProvideAssistanceData._cont = ASN1Dict([
        ('ecid-UTRA-NetworkData', _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData),
        ('ecid-UTRA-Error', _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_Error),
        ])
    OMA_LPPe_ECID_UTRA_ProvideAssistanceData._ext = []
    
    #-----< maxUTRANetworks >-----#
    maxUTRANetworks = INT(name='maxUTRANetworks', mode=MODE_VALUE)
    maxUTRANetworks._val = 8
    
    #-----< OMA-LPPe-ECID-UTRA-NetworkData >-----#
    OMA_LPPe_ECID_UTRA_NetworkData = SEQ(name='OMA-LPPe-ECID-UTRA-NetworkData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc._cont = ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc__item_
    __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc._cont = ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc__item_
    __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity._cont = ASN1Dict([
        ('mcc', __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc),
        ('mnc', __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc),
        ])
    _OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity._ext = None
    _OMA_LPPe_ECID_UTRA_NetworkData_multiple_PLMNs = BOOL(name='multiple-PLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_NetworkData_reference_location = SEQ(name='reference-location', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list = SEQ_OF(name='ecid-utra-nodeB-list', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-NodeBData')))
    _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list._cont = __OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list__item_
    _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list = SEQ_OF(name='ecid-utra-HNB-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-HNBData')))
    _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list._cont = __OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list__item_
    _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_ECID_UTRA_NetworkData._cont = ASN1Dict([
        ('plmn-Identity', _OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity),
        ('multiple-PLMNs', _OMA_LPPe_ECID_UTRA_NetworkData_multiple_PLMNs),
        ('reference-location', _OMA_LPPe_ECID_UTRA_NetworkData_reference_location),
        ('ecid-utra-nodeB-list', _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list),
        ('ecid-utra-HNB-list', _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list),
        ])
    OMA_LPPe_ECID_UTRA_NetworkData._ext = []
    
    #-----< maxUTRAnodeBs >-----#
    maxUTRAnodeBs = INT(name='maxUTRAnodeBs', mode=MODE_VALUE)
    maxUTRAnodeBs._val = 32
    
    #-----< maxUTRAHNBs >-----#
    maxUTRAHNBs = INT(name='maxUTRAHNBs', mode=MODE_VALUE)
    maxUTRAHNBs._val = 128
    
    #-----< OMA-LPPe-ECID-UTRA-NodeBData >-----#
    OMA_LPPe_ECID_UTRA_NodeBData = SEQ(name='OMA-LPPe-ECID-UTRA-NodeBData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_NodeBData_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData = SEQ_OF(name='ecid-utra-nodeB-CellData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CellData')))
    _OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData._cont = __OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData__item_
    _OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    OMA_LPPe_ECID_UTRA_NodeBData._cont = ASN1Dict([
        ('relative-location', _OMA_LPPe_ECID_UTRA_NodeBData_relative_location),
        ('ecid-utra-nodeB-CellData', _OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData),
        ])
    OMA_LPPe_ECID_UTRA_NodeBData._ext = []
    
    #-----< maxUTRAMacroCells >-----#
    maxUTRAMacroCells = INT(name='maxUTRAMacroCells', mode=MODE_VALUE)
    maxUTRAMacroCells._val = 8
    
    #-----< OMA-LPPe-ECID-UTRA-HNBData >-----#
    OMA_LPPe_ECID_UTRA_HNBData = SEQ(name='OMA-LPPe-ECID-UTRA-HNBData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_HNBData_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_ECID_UTRA_HNBData_location_reliability = INT(name='location-reliability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_HNBData_location_reliability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_HNBData_coverageArea = SEQ(name='coverageArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLANFemtoCoverageArea')), opt=True)
    _OMA_LPPe_ECID_UTRA_HNBData_ecid_utra_HNB_CellData = SEQ(name='ecid-utra-HNB-CellData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CellData')))
    OMA_LPPe_ECID_UTRA_HNBData._cont = ASN1Dict([
        ('relative-location', _OMA_LPPe_ECID_UTRA_HNBData_relative_location),
        ('location-reliability', _OMA_LPPe_ECID_UTRA_HNBData_location_reliability),
        ('coverageArea', _OMA_LPPe_ECID_UTRA_HNBData_coverageArea),
        ('ecid-utra-HNB-CellData', _OMA_LPPe_ECID_UTRA_HNBData_ecid_utra_HNB_CellData),
        ])
    OMA_LPPe_ECID_UTRA_HNBData._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-CellData >-----#
    OMA_LPPe_ECID_UTRA_CellData = SEQ(name='OMA-LPPe-ECID-UTRA-CellData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_CellData_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_CellData_cellIdentity._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Scrambling_Code = INT(name='primaryCPICH-Scrambling-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode')))
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Tx_Power = INT(name='primaryCPICH-Tx-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Tx_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_uarfcn_dl = INT(name='uarfcn-dl', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')))
    __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-Scrambling-Code', ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Scrambling_Code),
        ('primaryCPICH-Tx-Power', ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Tx_Power),
        ('uarfcn-dl', ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_uarfcn_dl),
        ])
    __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd._ext = []
    __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_cellParametersID = INT(name='cellParametersID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellParametersID')))
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_primaryCCPCH_Tx_Power = INT(name='primaryCCPCH-Tx-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_primaryCCPCH_Tx_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_uarfcn_nt = INT(name='uarfcn-nt', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')))
    __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellParametersID', ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_cellParametersID),
        ('primaryCCPCH-Tx-Power', ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_primaryCCPCH_Tx_Power),
        ('uarfcn-nt', ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_uarfcn_nt),
        ])
    __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd._ext = []
    _OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd),
        ('tdd', __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd),
        ])
    _OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo._ext = None
    _OMA_LPPe_ECID_UTRA_CellData_antenna_gain = INT(name='antenna-gain', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_CellData_antenna_gain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_CellData_beam_width = INT(name='beam-width', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_CellData_beam_width._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=360)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_CellData_transmit_direction = INT(name='transmit-direction', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_CellData_transmit_direction._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=360)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_CellData_frequency_accuracy = INT(name='frequency-accuracy', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_CellData_frequency_accuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    OMA_LPPe_ECID_UTRA_CellData._cont = ASN1Dict([
        ('cellIdentity', _OMA_LPPe_ECID_UTRA_CellData_cellIdentity),
        ('modeSpecificInfo', _OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo),
        ('antenna-gain', _OMA_LPPe_ECID_UTRA_CellData_antenna_gain),
        ('beam-width', _OMA_LPPe_ECID_UTRA_CellData_beam_width),
        ('transmit-direction', _OMA_LPPe_ECID_UTRA_CellData_transmit_direction),
        ('frequency-accuracy', _OMA_LPPe_ECID_UTRA_CellData_frequency_accuracy),
        ])
    OMA_LPPe_ECID_UTRA_CellData._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-RequestAssistanceData >-----#
    OMA_LPPe_ECID_UTRA_RequestAssistanceData = SEQ(name='OMA-LPPe-ECID-UTRA-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_RequestAssistanceData_nBrequestedAD = BIT_STR(name='nBrequestedAD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_RequestAssistanceData_nBrequestedAD._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('transmit-power', 2), ('antenna-gain', 3), ('beam-width', 4), ('transmit-direction', 5), ('frequency-accuracy', 6), ('non-serving', 7)])
    _OMA_LPPe_ECID_UTRA_RequestAssistanceData_nBrequestedAD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_RequestAssistanceData_hNBrequestedAD = BIT_STR(name='hNBrequestedAD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_RequestAssistanceData_hNBrequestedAD._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('locationreliability', 2), ('transmit-power', 3), ('frequency-accuracy', 4), ('coveragearea', 5), ('non-serving', 6)])
    _OMA_LPPe_ECID_UTRA_RequestAssistanceData_hNBrequestedAD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_UTRA_RequestAssistanceData._cont = ASN1Dict([
        ('nBrequestedAD', _OMA_LPPe_ECID_UTRA_RequestAssistanceData_nBrequestedAD),
        ('hNBrequestedAD', _OMA_LPPe_ECID_UTRA_RequestAssistanceData_hNBrequestedAD),
        ])
    OMA_LPPe_ECID_UTRA_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-ProvideLocationInformation >-----#
    OMA_LPPe_ECID_UTRA_ProvideLocationInformation = SEQ(name='OMA-LPPe-ECID-UTRA-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation = SEQ_OF(name='ecid-UTRA-CombinedLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-LocationInformationList')))
    _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation._cont = __OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation__item_
    _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_Error = CHOICE(name='ecid-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-Error')), opt=True)
    OMA_LPPe_ECID_UTRA_ProvideLocationInformation._cont = ASN1Dict([
        ('ecid-UTRA-CombinedLocationInformation', _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation),
        ('ecid-Error', _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_Error),
        ])
    OMA_LPPe_ECID_UTRA_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-LocationInformationList >-----#
    OMA_LPPe_ECID_UTRA_LocationInformationList = SEQ(name='OMA-LPPe-ECID-UTRA-LocationInformationList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_LocationInformationList_ecid_utra_LocationInformation = SEQ(name='ecid-utra-LocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-LocationInformation')))
    _OMA_LPPe_ECID_UTRA_LocationInformationList_relativeTimeStamp = INT(name='relativeTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationInformationList_relativeTimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_LocationInformationList_servingFlag = BOOL(name='servingFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_ECID_UTRA_LocationInformationList._cont = ASN1Dict([
        ('ecid-utra-LocationInformation', _OMA_LPPe_ECID_UTRA_LocationInformationList_ecid_utra_LocationInformation),
        ('relativeTimeStamp', _OMA_LPPe_ECID_UTRA_LocationInformationList_relativeTimeStamp),
        ('servingFlag', _OMA_LPPe_ECID_UTRA_LocationInformationList_servingFlag),
        ])
    OMA_LPPe_ECID_UTRA_LocationInformationList._ext = []
    
    #-----< maxECIDUTRASize >-----#
    maxECIDUTRASize = INT(name='maxECIDUTRASize', mode=MODE_VALUE)
    maxECIDUTRASize._val = 64
    
    #-----< OMA-LPPe-ECID-UTRA-LocationInformation >-----#
    OMA_LPPe_ECID_UTRA_LocationInformation = SEQ(name='OMA-LPPe-ECID-UTRA-LocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_LocationInformation_cellGlobalIdUTRA = SEQ(name='cellGlobalIdUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'CellGlobalIdEUTRA-AndUTRA')))
    _OMA_LPPe_ECID_UTRA_LocationInformation_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfo')), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationInformation_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode')), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationInformation_measuredResultsList = SEQ_OF(name='measuredResultsList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-MeasuredResultsList')), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationInformation_cellParametersId = INT(name='cellParametersId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellParametersID')), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationInformation_utratimingAdvance = SEQ(name='utratimingAdvance', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-UTRATimingAdvance')), opt=True)
    OMA_LPPe_ECID_UTRA_LocationInformation._cont = ASN1Dict([
        ('cellGlobalIdUTRA', _OMA_LPPe_ECID_UTRA_LocationInformation_cellGlobalIdUTRA),
        ('frequencyInfo', _OMA_LPPe_ECID_UTRA_LocationInformation_frequencyInfo),
        ('primaryScramblingCode', _OMA_LPPe_ECID_UTRA_LocationInformation_primaryScramblingCode),
        ('measuredResultsList', _OMA_LPPe_ECID_UTRA_LocationInformation_measuredResultsList),
        ('cellParametersId', _OMA_LPPe_ECID_UTRA_LocationInformation_cellParametersId),
        ('utratimingAdvance', _OMA_LPPe_ECID_UTRA_LocationInformation_utratimingAdvance),
        ])
    OMA_LPPe_ECID_UTRA_LocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-UTRATimingAdvance >-----#
    OMA_LPPe_ECID_UTRA_UTRATimingAdvance = SEQ(name='OMA-LPPe-ECID-UTRA-UTRATimingAdvance', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tA = INT(name='tA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tAResolution = ENUM(name='tAResolution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-TAResolution')), opt=True)
    _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_chipRate = ENUM(name='chipRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-ChipRate')), opt=True)
    OMA_LPPe_ECID_UTRA_UTRATimingAdvance._cont = ASN1Dict([
        ('tA', _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tA),
        ('tAResolution', _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tAResolution),
        ('chipRate', _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_chipRate),
        ])
    OMA_LPPe_ECID_UTRA_UTRATimingAdvance._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-TAResolution >-----#
    OMA_LPPe_ECID_UTRA_TAResolution = ENUM(name='OMA-LPPe-ECID-UTRA-TAResolution', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_TAResolution._cont = ASN1Dict([('res1-0chip', 0), ('res0-5chip', 1), ('res0-125chip', 2)])
    OMA_LPPe_ECID_UTRA_TAResolution._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-ChipRate >-----#
    OMA_LPPe_ECID_UTRA_ChipRate = ENUM(name='OMA-LPPe-ECID-UTRA-ChipRate', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_ChipRate._cont = ASN1Dict([('tdd128', 0), ('tdd384', 1), ('tdd768', 2)])
    OMA_LPPe_ECID_UTRA_ChipRate._ext = []
    
    #-----< OMA-LPPe-UTRA-FrequencyInfo >-----#
    OMA_LPPe_UTRA_FrequencyInfo = SEQ(name='OMA-LPPe-UTRA-FrequencyInfo', mode=MODE_TYPE)
    _OMA_LPPe_UTRA_FrequencyInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-ModeSpecificInfo')))
    OMA_LPPe_UTRA_FrequencyInfo._cont = ASN1Dict([
        ('modeSpecificInfo', _OMA_LPPe_UTRA_FrequencyInfo_modeSpecificInfo),
        ])
    OMA_LPPe_UTRA_FrequencyInfo._ext = []
    
    #-----< OMA-LPPe-UTRA-ModeSpecificInfo >-----#
    OMA_LPPe_UTRA_ModeSpecificInfo = CHOICE(name='OMA-LPPe-UTRA-ModeSpecificInfo', mode=MODE_TYPE)
    _OMA_LPPe_UTRA_ModeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfoFDD')))
    _OMA_LPPe_UTRA_ModeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfoTDD')))
    OMA_LPPe_UTRA_ModeSpecificInfo._cont = ASN1Dict([
        ('fdd', _OMA_LPPe_UTRA_ModeSpecificInfo_fdd),
        ('tdd', _OMA_LPPe_UTRA_ModeSpecificInfo_tdd),
        ])
    OMA_LPPe_UTRA_ModeSpecificInfo._ext = []
    
    #-----< OMA-LPPe-UTRA-FrequencyInfoFDD >-----#
    OMA_LPPe_UTRA_FrequencyInfoFDD = SEQ(name='OMA-LPPe-UTRA-FrequencyInfoFDD', mode=MODE_TYPE)
    _OMA_LPPe_UTRA_FrequencyInfoFDD_uarfcn_UL = INT(name='uarfcn-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')), opt=True)
    _OMA_LPPe_UTRA_FrequencyInfoFDD_uarfcn_DL = INT(name='uarfcn-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')))
    OMA_LPPe_UTRA_FrequencyInfoFDD._cont = ASN1Dict([
        ('uarfcn-UL', _OMA_LPPe_UTRA_FrequencyInfoFDD_uarfcn_UL),
        ('uarfcn-DL', _OMA_LPPe_UTRA_FrequencyInfoFDD_uarfcn_DL),
        ])
    OMA_LPPe_UTRA_FrequencyInfoFDD._ext = []
    
    #-----< OMA-LPPe-UTRA-FrequencyInfoTDD >-----#
    OMA_LPPe_UTRA_FrequencyInfoTDD = SEQ(name='OMA-LPPe-UTRA-FrequencyInfoTDD', mode=MODE_TYPE)
    _OMA_LPPe_UTRA_FrequencyInfoTDD_uarfcn_Nt = INT(name='uarfcn-Nt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'ARFCN-ValueUTRA')))
    OMA_LPPe_UTRA_FrequencyInfoTDD._cont = ASN1Dict([
        ('uarfcn-Nt', _OMA_LPPe_UTRA_FrequencyInfoTDD_uarfcn_Nt),
        ])
    OMA_LPPe_UTRA_FrequencyInfoTDD._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-MeasuredResultsList >-----#
    OMA_LPPe_ECID_UTRA_MeasuredResultsList = SEQ_OF(name='OMA-LPPe-ECID-UTRA-MeasuredResultsList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_MeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-MeasuredResults')))
    OMA_LPPe_ECID_UTRA_MeasuredResultsList._cont = _OMA_LPPe_ECID_UTRA_MeasuredResultsList__item_
    OMA_LPPe_ECID_UTRA_MeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-UTRA-MeasuredResults >-----#
    OMA_LPPe_ECID_UTRA_MeasuredResults = SEQ(name='OMA-LPPe-ECID-UTRA-MeasuredResults', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_MeasuredResults_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-UTRA-FrequencyInfo')))
    _OMA_LPPe_ECID_UTRA_MeasuredResults_utra_CarrierRSSI = INT(name='utra-CarrierRSSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CarrierRSSI')), opt=True)
    _OMA_LPPe_ECID_UTRA_MeasuredResults_cellMeasuredResultsList = SEQ_OF(name='cellMeasuredResultsList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CellMeasuredResultsList')), opt=True)
    OMA_LPPe_ECID_UTRA_MeasuredResults._cont = ASN1Dict([
        ('frequencyInfo', _OMA_LPPe_ECID_UTRA_MeasuredResults_frequencyInfo),
        ('utra-CarrierRSSI', _OMA_LPPe_ECID_UTRA_MeasuredResults_utra_CarrierRSSI),
        ('cellMeasuredResultsList', _OMA_LPPe_ECID_UTRA_MeasuredResults_cellMeasuredResultsList),
        ])
    OMA_LPPe_ECID_UTRA_MeasuredResults._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-CellMeasuredResultsList >-----#
    OMA_LPPe_ECID_UTRA_CellMeasuredResultsList = SEQ_OF(name='OMA-LPPe-ECID-UTRA-CellMeasuredResultsList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_CellMeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CellMeasuredResults')))
    OMA_LPPe_ECID_UTRA_CellMeasuredResultsList._cont = _OMA_LPPe_ECID_UTRA_CellMeasuredResultsList__item_
    OMA_LPPe_ECID_UTRA_CellMeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-UTRA-CarrierRSSI >-----#
    OMA_LPPe_ECID_UTRA_CarrierRSSI = INT(name='OMA-LPPe-ECID-UTRA-CarrierRSSI', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_CarrierRSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-UTRA-CellMeasuredResults >-----#
    OMA_LPPe_ECID_UTRA_CellMeasuredResults = SEQ(name='OMA-LPPe-ECID-UTRA-CellMeasuredResults', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_CellMeasuredResults_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_CellMeasuredResults_cellIdentity._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_primaryCPICH_Info = INT(name='primaryCPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-PrimaryScramblingCode')))
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_cpich_Ec_N0 = INT(name='cpich-Ec-N0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CPICH-Ec-N0')), opt=True)
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_cpich_RSCP = INT(name='cpich-RSCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-CPICH-RSCP')), opt=True)
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_pathloss = INT(name='pathloss', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-Pathloss')), opt=True)
    __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-Info', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_primaryCPICH_Info),
        ('cpich-Ec-N0', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_cpich_Ec_N0),
        ('cpich-RSCP', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_cpich_RSCP),
        ('pathloss', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_pathloss),
        ])
    __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd._ext = []
    __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_cellParametersID = INT(name='cellParametersID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-OTDOA-UTRA-CellParametersID')))
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_primaryCCPCH_RSCP = INT(name='primaryCCPCH-RSCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-PrimaryCCPCH-RSCP')), opt=True)
    ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_pathloss = INT(name='pathloss', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-Pathloss')), opt=True)
    __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellParametersID', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_cellParametersID),
        ('primaryCCPCH-RSCP', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_primaryCCPCH_RSCP),
        ('pathloss', ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_pathloss),
        ])
    __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd._ext = []
    _OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd),
        ('tdd', __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd),
        ])
    _OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo._ext = None
    OMA_LPPe_ECID_UTRA_CellMeasuredResults._cont = ASN1Dict([
        ('cellIdentity', _OMA_LPPe_ECID_UTRA_CellMeasuredResults_cellIdentity),
        ('modeSpecificInfo', _OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo),
        ])
    OMA_LPPe_ECID_UTRA_CellMeasuredResults._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-PrimaryCCPCH-RSCP >-----#
    OMA_LPPe_ECID_UTRA_PrimaryCCPCH_RSCP = INT(name='OMA-LPPe-ECID-UTRA-PrimaryCCPCH-RSCP', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_PrimaryCCPCH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-UTRA-CPICH-Ec-N0 >-----#
    OMA_LPPe_ECID_UTRA_CPICH_Ec_N0 = INT(name='OMA-LPPe-ECID-UTRA-CPICH-Ec-N0', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_CPICH_Ec_N0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-UTRA-CPICH-RSCP >-----#
    OMA_LPPe_ECID_UTRA_CPICH_RSCP = INT(name='OMA-LPPe-ECID-UTRA-CPICH-RSCP', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_CPICH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-UTRA-Pathloss >-----#
    OMA_LPPe_ECID_UTRA_Pathloss = INT(name='OMA-LPPe-ECID-UTRA-Pathloss', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_Pathloss._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=46, ub=173)], ev=None, er=[])
    
    #-----< maxFreq >-----#
    maxFreq = INT(name='maxFreq', mode=MODE_VALUE)
    maxFreq._val = 8
    
    #-----< OMA-LPPe-ECID-UTRA-RequestLocationInformation >-----#
    OMA_LPPe_ECID_UTRA_RequestLocationInformation = SEQ(name='OMA-LPPe-ECID-UTRA-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_RequestLocationInformation_requestedMeasurements = BIT_STR(name='requestedMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_RequestLocationInformation_requestedMeasurements._cont = ASN1Dict([('measuredResultsList', 0), ('tdd-timingAdvance', 1), ('mRL-utra-CarrierRSSI', 2), ('mRL-FDD-cpich-Ec-N0', 3), ('mRL-FDD-cpich-RSCP', 4), ('mRL-FDD-pathloss', 5), ('mRL-TDD-primaryCCPCH-RSCP', 6), ('mRL-TDD-pathloss', 7), ('non-serving', 8), ('historic', 9)])
    _OMA_LPPe_ECID_UTRA_RequestLocationInformation_requestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_UTRA_RequestLocationInformation._cont = ASN1Dict([
        ('requestedMeasurements', _OMA_LPPe_ECID_UTRA_RequestLocationInformation_requestedMeasurements),
        ])
    OMA_LPPe_ECID_UTRA_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-ProvideCapabilities >-----#
    OMA_LPPe_ECID_UTRA_ProvideCapabilities = SEQ(name='OMA-LPPe-ECID-UTRA-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_MeasSupported = BIT_STR(name='ecid-utra-MeasSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_MeasSupported._cont = ASN1Dict([('measuredResultsList', 0), ('tdd-timingAdvance', 1), ('mRL-utra-CarrierRSSI', 2), ('mRL-FDD-cpich-Ec-N0', 3), ('mRL-FDD-cpich-RSCP', 4), ('mRL-FDD-pathloss', 5), ('mRL-TDD-primaryCCPCH-RSCP', 6), ('mRL-TDD-pathloss', 7), ('non-serving', 8), ('historic', 9)])
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_nodeB_ADSupported = BIT_STR(name='ecid-utra-nodeB-ADSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_nodeB_ADSupported._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('transmit-power', 2), ('antenna-gain', 3), ('beam-width', 4), ('transmit-direction', 5), ('frequency-accuracy', 6), ('non-serving', 7)])
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_nodeB_ADSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_HNB_ADSupported = BIT_STR(name='ecid-utra-HNB-ADSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_HNB_ADSupported._cont = ASN1Dict([('bslist', 0), ('bslocation', 1), ('locationreliability', 2), ('transmit-power', 3), ('frequency-accuracy', 4), ('coveragearea', 5), ('non-serving', 6)])
    _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_HNB_ADSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_UTRA_ProvideCapabilities._cont = ASN1Dict([
        ('ecid-utra-MeasSupported', _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_MeasSupported),
        ('ecid-utra-nodeB-ADSupported', _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_nodeB_ADSupported),
        ('ecid-utra-HNB-ADSupported', _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_HNB_ADSupported),
        ])
    OMA_LPPe_ECID_UTRA_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-RequestCapabilities >-----#
    OMA_LPPe_ECID_UTRA_RequestCapabilities = SEQ(name='OMA-LPPe-ECID-UTRA-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_ECID_UTRA_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_ECID_UTRA_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-Error >-----#
    OMA_LPPe_ECID_UTRA_Error = CHOICE(name='OMA-LPPe-ECID-UTRA-Error', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-LocationServerErrorCauses')))
    _OMA_LPPe_ECID_UTRA_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-UTRA-TargetDeviceErrorCauses')))
    OMA_LPPe_ECID_UTRA_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_ECID_UTRA_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_ECID_UTRA_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_ECID_UTRA_Error._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-LocationServerErrorCauses >-----#
    OMA_LPPe_ECID_UTRA_LocationServerErrorCauses = SEQ(name='OMA-LPPe-ECID-UTRA-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedADNotAvailable', 1), ('notAllrequestedADAvailable', 2)])
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBMandatoryDataUnavailable = NULL(name='nodeBMandatoryDataUnavailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBLocationUnavailable = NULL(name='nodeBLocationUnavailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellTransmitPowerUnavailable = NULL(name='nodeBcellTransmitPowerUnavailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcallAntennaGainUnavailable = NULL(name='nodeBcallAntennaGainUnavailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellBeamWidthUnavailable = NULL(name='nodeBcellBeamWidthUnavailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellTransmitDirectionUnavailable = NULL(name='nodeBcellTransmitDirectionUnavailable', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellFrequencyAccuracyUnavailable = NULL(name='nodeBcellFrequencyAccuracyUnavailable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBnonservingADUnavailable = NULL(name='nodeBnonservingADUnavailable', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBMandatoryDataUnavailable = NULL(name='hNBMandatoryDataUnavailable', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBLocationUnavailable = NULL(name='hNBLocationUnavailable', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBLocationReliabilityUnavailable = NULL(name='hNBLocationReliabilityUnavailable', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBcellTransmitPowerUnavailable = NULL(name='hNBcellTransmitPowerUnavailable', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBcellFrequencyAccuracyUnavailable = NULL(name='hNBcellFrequencyAccuracyUnavailable', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBCoverageAreaUnavailable = NULL(name='hNBCoverageAreaUnavailable', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBnonservingADUnavailable = NULL(name='hNBnonservingADUnavailable', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_UTRA_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_cause),
        ('nodeBMandatoryDataUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBMandatoryDataUnavailable),
        ('nodeBLocationUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBLocationUnavailable),
        ('nodeBcellTransmitPowerUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellTransmitPowerUnavailable),
        ('nodeBcallAntennaGainUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcallAntennaGainUnavailable),
        ('nodeBcellBeamWidthUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellBeamWidthUnavailable),
        ('nodeBcellTransmitDirectionUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellTransmitDirectionUnavailable),
        ('nodeBcellFrequencyAccuracyUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellFrequencyAccuracyUnavailable),
        ('nodeBnonservingADUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBnonservingADUnavailable),
        ('hNBMandatoryDataUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBMandatoryDataUnavailable),
        ('hNBLocationUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBLocationUnavailable),
        ('hNBLocationReliabilityUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBLocationReliabilityUnavailable),
        ('hNBcellTransmitPowerUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBcellTransmitPowerUnavailable),
        ('hNBcellFrequencyAccuracyUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBcellFrequencyAccuracyUnavailable),
        ('hNBCoverageAreaUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBCoverageAreaUnavailable),
        ('hNBnonservingADUnavailable', _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBnonservingADUnavailable),
        ])
    OMA_LPPe_ECID_UTRA_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-ECID-UTRA-TargetDeviceErrorCauses >-----#
    OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-ECID-UTRA-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRLMeasurementsNotPossible = NULL(name='mRLMeasurementsNotPossible', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_tdd_timingAdvanceMeasurementNotPossible = NULL(name='tdd-timingAdvanceMeasurementNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_utra_CarrierRSSIMeasurementNotPossible = NULL(name='mRL-utra-CarrierRSSIMeasurementNotPossible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_cpich_Ec_N0MeasurementNotPossible = NULL(name='mRL-FDD-cpich-Ec-N0MeasurementNotPossible', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_cpich_RSCPMeasurementNotPossible = NULL(name='mRL-FDD-cpich-RSCPMeasurementNotPossible', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_pathlossMeasurementNotPossible = NULL(name='mRL-FDD-pathlossMeasurementNotPossible', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_TDD_primaryCCPCH_RSCPMeasurementNotPossible = NULL(name='mRL-TDD-primaryCCPCH-RSCPMeasurementNotPossible', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_TDD_pathlossMeasurementNotPossible = NULL(name='mRL-TDD-pathlossMeasurementNotPossible', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable = NULL(name='non-servingMeasurementsNotAvailable', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_historicMeasurementsNotAvailable = NULL(name='historicMeasurementsNotAvailable', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_cause),
        ('mRLMeasurementsNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRLMeasurementsNotPossible),
        ('tdd-timingAdvanceMeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_tdd_timingAdvanceMeasurementNotPossible),
        ('mRL-utra-CarrierRSSIMeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_utra_CarrierRSSIMeasurementNotPossible),
        ('mRL-FDD-cpich-Ec-N0MeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_cpich_Ec_N0MeasurementNotPossible),
        ('mRL-FDD-cpich-RSCPMeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_cpich_RSCPMeasurementNotPossible),
        ('mRL-FDD-pathlossMeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_pathlossMeasurementNotPossible),
        ('mRL-TDD-primaryCCPCH-RSCPMeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_TDD_primaryCCPCH_RSCPMeasurementNotPossible),
        ('mRL-TDD-pathlossMeasurementNotPossible', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_TDD_pathlossMeasurementNotPossible),
        ('non-servingMeasurementsNotAvailable', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable),
        ('historicMeasurementsNotAvailable', _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_historicMeasurementsNotAvailable),
        ])
    OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-ProvideAssistanceData >-----#
    OMA_LPPe_WLAN_AP_ProvideAssistanceData = SEQ(name='OMA-LPPe-WLAN-AP-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet = SEQ_OF(name='wlan-DataSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-DataSet')))
    _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet._cont = __OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet__item_
    _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_AP_Error = CHOICE(name='wlan-AP-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Error')), opt=True)
    OMA_LPPe_WLAN_AP_ProvideAssistanceData._cont = ASN1Dict([
        ('wlan-DataSet', _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet),
        ('wlan-AP-Error', _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_AP_Error),
        ])
    OMA_LPPe_WLAN_AP_ProvideAssistanceData._ext = []
    
    #-----< maxWLANDataSets >-----#
    maxWLANDataSets = INT(name='maxWLANDataSets', mode=MODE_VALUE)
    maxWLANDataSets._val = 8
    
    #-----< OMA-LPPe-WLAN-DataSet >-----#
    OMA_LPPe_WLAN_DataSet = SEQ(name='OMA-LPPe-WLAN-DataSet', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_DataSet_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc._cont = ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc__item_
    __OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc__item_ = INT(name='_item_', mode=MODE_TYPE)
    ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    __OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc._cont = ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc__item_
    __OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _OMA_LPPe_WLAN_DataSet_plmn_Identity._cont = ASN1Dict([
        ('mcc', __OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc),
        ('mnc', __OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc),
        ])
    _OMA_LPPe_WLAN_DataSet_plmn_Identity._ext = None
    _OMA_LPPe_WLAN_DataSet_reference_point = SEQ(name='reference-point', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_WLAN_DataSet_supported_channels_11a = SEQ(name='supported-channels-11a', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'Supported-Channels-11a')), opt=True)
    _OMA_LPPe_WLAN_DataSet_supported_channels_11bg = SEQ(name='supported-channels-11bg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'Supported-Channels-11bg')), opt=True)
    _OMA_LPPe_WLAN_DataSet_wlan_ap_list = SEQ_OF(name='wlan-ap-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_WLAN_DataSet_wlan_ap_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Data')))
    _OMA_LPPe_WLAN_DataSet_wlan_ap_list._cont = __OMA_LPPe_WLAN_DataSet_wlan_ap_list__item_
    _OMA_LPPe_WLAN_DataSet_wlan_ap_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_WLAN_DataSet._cont = ASN1Dict([
        ('plmn-Identity', _OMA_LPPe_WLAN_DataSet_plmn_Identity),
        ('reference-point', _OMA_LPPe_WLAN_DataSet_reference_point),
        ('supported-channels-11a', _OMA_LPPe_WLAN_DataSet_supported_channels_11a),
        ('supported-channels-11bg', _OMA_LPPe_WLAN_DataSet_supported_channels_11bg),
        ('wlan-ap-list', _OMA_LPPe_WLAN_DataSet_wlan_ap_list),
        ])
    OMA_LPPe_WLAN_DataSet._ext = []
    
    #-----< maxWLANAPs >-----#
    maxWLANAPs = INT(name='maxWLANAPs', mode=MODE_VALUE)
    maxWLANAPs._val = 128
    
    #-----< Supported-Channels-11a >-----#
    Supported_Channels_11a = SEQ(name='Supported-Channels-11a', mode=MODE_TYPE)
    _Supported_Channels_11a_ch34 = BOOL(name='ch34', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch36 = BOOL(name='ch36', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch38 = BOOL(name='ch38', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch40 = BOOL(name='ch40', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch42 = BOOL(name='ch42', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch44 = BOOL(name='ch44', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch46 = BOOL(name='ch46', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch48 = BOOL(name='ch48', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch52 = BOOL(name='ch52', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch56 = BOOL(name='ch56', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch60 = BOOL(name='ch60', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch64 = BOOL(name='ch64', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch149 = BOOL(name='ch149', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch153 = BOOL(name='ch153', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch157 = BOOL(name='ch157', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11a_ch161 = BOOL(name='ch161', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Supported_Channels_11a._cont = ASN1Dict([
        ('ch34', _Supported_Channels_11a_ch34),
        ('ch36', _Supported_Channels_11a_ch36),
        ('ch38', _Supported_Channels_11a_ch38),
        ('ch40', _Supported_Channels_11a_ch40),
        ('ch42', _Supported_Channels_11a_ch42),
        ('ch44', _Supported_Channels_11a_ch44),
        ('ch46', _Supported_Channels_11a_ch46),
        ('ch48', _Supported_Channels_11a_ch48),
        ('ch52', _Supported_Channels_11a_ch52),
        ('ch56', _Supported_Channels_11a_ch56),
        ('ch60', _Supported_Channels_11a_ch60),
        ('ch64', _Supported_Channels_11a_ch64),
        ('ch149', _Supported_Channels_11a_ch149),
        ('ch153', _Supported_Channels_11a_ch153),
        ('ch157', _Supported_Channels_11a_ch157),
        ('ch161', _Supported_Channels_11a_ch161),
        ])
    Supported_Channels_11a._ext = None
    
    #-----< Supported-Channels-11bg >-----#
    Supported_Channels_11bg = SEQ(name='Supported-Channels-11bg', mode=MODE_TYPE)
    _Supported_Channels_11bg_ch1 = BOOL(name='ch1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch2 = BOOL(name='ch2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch3 = BOOL(name='ch3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch4 = BOOL(name='ch4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch5 = BOOL(name='ch5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch6 = BOOL(name='ch6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch7 = BOOL(name='ch7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch8 = BOOL(name='ch8', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch9 = BOOL(name='ch9', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch10 = BOOL(name='ch10', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch11 = BOOL(name='ch11', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch12 = BOOL(name='ch12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch13 = BOOL(name='ch13', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported_Channels_11bg_ch14 = BOOL(name='ch14', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Supported_Channels_11bg._cont = ASN1Dict([
        ('ch1', _Supported_Channels_11bg_ch1),
        ('ch2', _Supported_Channels_11bg_ch2),
        ('ch3', _Supported_Channels_11bg_ch3),
        ('ch4', _Supported_Channels_11bg_ch4),
        ('ch5', _Supported_Channels_11bg_ch5),
        ('ch6', _Supported_Channels_11bg_ch6),
        ('ch7', _Supported_Channels_11bg_ch7),
        ('ch8', _Supported_Channels_11bg_ch8),
        ('ch9', _Supported_Channels_11bg_ch9),
        ('ch10', _Supported_Channels_11bg_ch10),
        ('ch11', _Supported_Channels_11bg_ch11),
        ('ch12', _Supported_Channels_11bg_ch12),
        ('ch13', _Supported_Channels_11bg_ch13),
        ('ch14', _Supported_Channels_11bg_ch14),
        ])
    Supported_Channels_11bg._ext = None
    
    #-----< OMA-LPPe-WLAN-AP-Data >-----#
    OMA_LPPe_WLAN_AP_Data = SEQ(name='OMA-LPPe-WLAN-AP-Data', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_Data_wlan_ap_id = SEQ(name='wlan-ap-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ID')))
    _OMA_LPPe_WLAN_AP_Data_relative_location = SEQ(name='relative-location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')), opt=True)
    _OMA_LPPe_WLAN_AP_Data_location_reliability = INT(name='location-reliability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_Data_location_reliability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data = SEQ_OF(name='wlan-ap-Type-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Type-Data')))
    _OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data._cont = __OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data__item_
    _OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_Data_coverageArea = SEQ(name='coverageArea', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLANFemtoCoverageArea')), opt=True)
    OMA_LPPe_WLAN_AP_Data._cont = ASN1Dict([
        ('wlan-ap-id', _OMA_LPPe_WLAN_AP_Data_wlan_ap_id),
        ('relative-location', _OMA_LPPe_WLAN_AP_Data_relative_location),
        ('location-reliability', _OMA_LPPe_WLAN_AP_Data_location_reliability),
        ('wlan-ap-Type-Data', _OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data),
        ('coverageArea', _OMA_LPPe_WLAN_AP_Data_coverageArea),
        ])
    OMA_LPPe_WLAN_AP_Data._ext = []
    
    #-----< maxWLANTypes >-----#
    maxWLANTypes = INT(name='maxWLANTypes', mode=MODE_VALUE)
    maxWLANTypes._val = 5
    
    #-----< OMA-LPPe-WLAN-AP-Type-Data >-----#
    OMA_LPPe_WLAN_AP_Type_Data = SEQ(name='OMA-LPPe-WLAN-AP-Type-Data', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_Type_Data_wlan_AP_Type = ENUM(name='wlan-AP-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Type')))
    _OMA_LPPe_WLAN_AP_Type_Data_transmit_power = INT(name='transmit-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_Type_Data_transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_Type_Data_antenna_gain = INT(name='antenna-gain', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_Type_Data_antenna_gain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_Type_Data_coverageArea = SEQ(name='coverageArea', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLANFemtoCoverageArea')), opt=True)
    OMA_LPPe_WLAN_AP_Type_Data._cont = ASN1Dict([
        ('wlan-AP-Type', _OMA_LPPe_WLAN_AP_Type_Data_wlan_AP_Type),
        ('transmit-power', _OMA_LPPe_WLAN_AP_Type_Data_transmit_power),
        ('antenna-gain', _OMA_LPPe_WLAN_AP_Type_Data_antenna_gain),
        ('coverageArea', _OMA_LPPe_WLAN_AP_Type_Data_coverageArea),
        ])
    OMA_LPPe_WLAN_AP_Type_Data._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-RequestAssistanceData >-----#
    OMA_LPPe_WLAN_AP_RequestAssistanceData = SEQ(name='OMA-LPPe-WLAN-AP-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAD = BIT_STR(name='requestedAD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAD._cont = ASN1Dict([('aplist', 0), ('aplocation', 1), ('locationreliability', 2), ('transmit-power', 3), ('antenna-gain', 4), ('coveragearea', 5), ('non-serving', 6)])
    _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAPTypes = BIT_STR(name='requestedAPTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Type-List')))
    OMA_LPPe_WLAN_AP_RequestAssistanceData._cont = ASN1Dict([
        ('requestedAD', _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAD),
        ('requestedAPTypes', _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAPTypes),
        ])
    OMA_LPPe_WLAN_AP_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-ProvideLocationInformation >-----#
    OMA_LPPe_WLAN_AP_ProvideLocationInformation = SEQ(name='OMA-LPPe-WLAN-AP-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation = SEQ_OF(name='wlan-AP-CombinedLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-LocationInformationList')))
    _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation._cont = __OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation__item_
    _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_Error = CHOICE(name='wlan-AP-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Error')), opt=True)
    OMA_LPPe_WLAN_AP_ProvideLocationInformation._cont = ASN1Dict([
        ('wlan-AP-CombinedLocationInformation', _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation),
        ('wlan-AP-Error', _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_Error),
        ])
    OMA_LPPe_WLAN_AP_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-LocationInformationList >-----#
    OMA_LPPe_WLAN_AP_LocationInformationList = SEQ(name='OMA-LPPe-WLAN-AP-LocationInformationList', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_LocationInformationList_wlan_AP_LocationInformation = SEQ(name='wlan-AP-LocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-LocationInformation')))
    _OMA_LPPe_WLAN_AP_LocationInformationList_relativeTimeStamp = INT(name='relativeTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformationList_relativeTimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformationList_servingFlag = BOOL(name='servingFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_WLAN_AP_LocationInformationList._cont = ASN1Dict([
        ('wlan-AP-LocationInformation', _OMA_LPPe_WLAN_AP_LocationInformationList_wlan_AP_LocationInformation),
        ('relativeTimeStamp', _OMA_LPPe_WLAN_AP_LocationInformationList_relativeTimeStamp),
        ('servingFlag', _OMA_LPPe_WLAN_AP_LocationInformationList_servingFlag),
        ])
    OMA_LPPe_WLAN_AP_LocationInformationList._ext = []
    
    #-----< maxWLANAPSize >-----#
    maxWLANAPSize = INT(name='maxWLANAPSize', mode=MODE_VALUE)
    maxWLANAPSize._val = 64
    
    #-----< OMA-LPPe-WLAN-AP-LocationInformation >-----#
    OMA_LPPe_WLAN_AP_LocationInformation = SEQ(name='OMA-LPPe-WLAN-AP-LocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_LocationInformation_apMACAddress = SEQ(name='apMACAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ID')))
    _OMA_LPPe_WLAN_AP_LocationInformation_apSSID = OCT_STR(name='apSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apSSID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoise = INT(name='apSignaltoNoise', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoise._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apDeviceType = ENUM(name='apDeviceType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Type')), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apPHYtype = ENUM(name='apPHYtype', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-PHY-Type')), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrength = INT(name='apSignalStrength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apChannelFrequency = INT(name='apChannelFrequency', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apChannelFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apRoundTripDelay = SEQ(name='apRoundTripDelay', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-RTD')), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueTransmitPower = INT(name='ueTransmitPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_ueAntennaGain = INT(name='ueAntennaGain', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueAntennaGain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apReportedLocation = SEQ(name='apReportedLocation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-ReportedLocation')), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apTransmitPower = INT(name='apTransmitPower', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apAntennaGain = INT(name='apAntennaGain', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apAntennaGain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoise = INT(name='ueSignaltoNoise', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoise._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrength = INT(name='ueSignalStrength', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrengthDelta = INT(name='apSignalStrengthDelta', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrengthDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrengthDelta = INT(name='ueSignalStrengthDelta', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrengthDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoiseDelta = INT(name='apSignaltoNoiseDelta', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoiseDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoiseDelta = INT(name='ueSignaltoNoiseDelta', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoiseDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_LocationInformation_operatingClass = INT(name='operatingClass', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationInformation_operatingClass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    OMA_LPPe_WLAN_AP_LocationInformation._cont = ASN1Dict([
        ('apMACAddress', _OMA_LPPe_WLAN_AP_LocationInformation_apMACAddress),
        ('apSSID', _OMA_LPPe_WLAN_AP_LocationInformation_apSSID),
        ('apSignaltoNoise', _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoise),
        ('apDeviceType', _OMA_LPPe_WLAN_AP_LocationInformation_apDeviceType),
        ('apPHYtype', _OMA_LPPe_WLAN_AP_LocationInformation_apPHYtype),
        ('apSignalStrength', _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrength),
        ('apChannelFrequency', _OMA_LPPe_WLAN_AP_LocationInformation_apChannelFrequency),
        ('apRoundTripDelay', _OMA_LPPe_WLAN_AP_LocationInformation_apRoundTripDelay),
        ('ueTransmitPower', _OMA_LPPe_WLAN_AP_LocationInformation_ueTransmitPower),
        ('ueAntennaGain', _OMA_LPPe_WLAN_AP_LocationInformation_ueAntennaGain),
        ('apReportedLocation', _OMA_LPPe_WLAN_AP_LocationInformation_apReportedLocation),
        ('apTransmitPower', _OMA_LPPe_WLAN_AP_LocationInformation_apTransmitPower),
        ('apAntennaGain', _OMA_LPPe_WLAN_AP_LocationInformation_apAntennaGain),
        ('ueSignaltoNoise', _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoise),
        ('ueSignalStrength', _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrength),
        ('apSignalStrengthDelta', _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrengthDelta),
        ('ueSignalStrengthDelta', _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrengthDelta),
        ('apSignaltoNoiseDelta', _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoiseDelta),
        ('ueSignaltoNoiseDelta', _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoiseDelta),
        ('operatingClass', _OMA_LPPe_WLAN_AP_LocationInformation_operatingClass),
        ])
    OMA_LPPe_WLAN_AP_LocationInformation._ext = ['apTransmitPower', 'apAntennaGain', 'ueSignaltoNoise', 'ueSignalStrength', 'apSignalStrengthDelta', 'ueSignalStrengthDelta', 'apSignaltoNoiseDelta', 'ueSignaltoNoiseDelta', 'operatingClass']
    
    #-----< OMA-LPPe-WLAN-AP-PHY-Type >-----#
    OMA_LPPe_WLAN_AP_PHY_Type = ENUM(name='OMA-LPPe-WLAN-AP-PHY-Type', mode=MODE_TYPE)
    OMA_LPPe_WLAN_AP_PHY_Type._cont = ASN1Dict([('unknown', 0), ('any', 1), ('fhss', 2), ('dsss', 3), ('irbaseband', 4), ('ofdm', 5), ('hrdsss', 6), ('erp', 7), ('ht', 8), ('ihv', 9)])
    OMA_LPPe_WLAN_AP_PHY_Type._ext = []
    
    #-----< OMA-LPPe-WLAN-RTD >-----#
    OMA_LPPe_WLAN_RTD = SEQ(name='OMA-LPPe-WLAN-RTD', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_RTD_rTDValue = INT(name='rTDValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_RTD_rTDValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    _OMA_LPPe_WLAN_RTD_rTDUnits = ENUM(name='rTDUnits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-RTDUnits')))
    _OMA_LPPe_WLAN_RTD_rTDAccuracy = INT(name='rTDAccuracy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_RTD_rTDAccuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    OMA_LPPe_WLAN_RTD._cont = ASN1Dict([
        ('rTDValue', _OMA_LPPe_WLAN_RTD_rTDValue),
        ('rTDUnits', _OMA_LPPe_WLAN_RTD_rTDUnits),
        ('rTDAccuracy', _OMA_LPPe_WLAN_RTD_rTDAccuracy),
        ])
    OMA_LPPe_WLAN_RTD._ext = []
    
    #-----< OMA-LPPe-WLAN-RTDUnits >-----#
    OMA_LPPe_WLAN_RTDUnits = ENUM(name='OMA-LPPe-WLAN-RTDUnits', mode=MODE_TYPE)
    OMA_LPPe_WLAN_RTDUnits._cont = ASN1Dict([('microseconds', 0), ('hundredsofnanoseconds', 1), ('tensofnanoseconds', 2), ('nanoseconds', 3), ('tenthsofnanoseconds', 4)])
    OMA_LPPe_WLAN_RTDUnits._ext = []
    
    #-----< OMA-LPPe-WLAN-ReportedLocation >-----#
    OMA_LPPe_WLAN_ReportedLocation = SEQ(name='OMA-LPPe-WLAN-ReportedLocation', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_ReportedLocation_locationDataLCI = SEQ(name='locationDataLCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-LocationDataLCI')), opt=True)
    OMA_LPPe_WLAN_ReportedLocation._cont = ASN1Dict([
        ('locationDataLCI', _OMA_LPPe_WLAN_ReportedLocation_locationDataLCI),
        ])
    OMA_LPPe_WLAN_ReportedLocation._ext = []
    
    #-----< OMA-LPPe-WLAN-LocationDataLCI >-----#
    OMA_LPPe_WLAN_LocationDataLCI = SEQ(name='OMA-LPPe-WLAN-LocationDataLCI', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_LocationDataLCI_latitudeResolution = BIT_STR(name='latitudeResolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_latitudeResolution._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_latitude = BIT_STR(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_latitude._const_sz = ASN1Set(rv=[34], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_longitudeResolution = BIT_STR(name='longitudeResolution', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_longitudeResolution._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_longitude = BIT_STR(name='longitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_longitude._const_sz = ASN1Set(rv=[34], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_altitudeType = BIT_STR(name='altitudeType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_altitudeType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_altitudeResolution = BIT_STR(name='altitudeResolution', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_altitudeResolution._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_altitude = BIT_STR(name='altitude', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_altitude._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _OMA_LPPe_WLAN_LocationDataLCI_datum = BIT_STR(name='datum', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_LocationDataLCI_datum._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    OMA_LPPe_WLAN_LocationDataLCI._cont = ASN1Dict([
        ('latitudeResolution', _OMA_LPPe_WLAN_LocationDataLCI_latitudeResolution),
        ('latitude', _OMA_LPPe_WLAN_LocationDataLCI_latitude),
        ('longitudeResolution', _OMA_LPPe_WLAN_LocationDataLCI_longitudeResolution),
        ('longitude', _OMA_LPPe_WLAN_LocationDataLCI_longitude),
        ('altitudeType', _OMA_LPPe_WLAN_LocationDataLCI_altitudeType),
        ('altitudeResolution', _OMA_LPPe_WLAN_LocationDataLCI_altitudeResolution),
        ('altitude', _OMA_LPPe_WLAN_LocationDataLCI_altitude),
        ('datum', _OMA_LPPe_WLAN_LocationDataLCI_datum),
        ])
    OMA_LPPe_WLAN_LocationDataLCI._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-RequestLocationInformation >-----#
    OMA_LPPe_WLAN_AP_RequestLocationInformation = SEQ(name='OMA-LPPe-WLAN-AP-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_RequestLocationInformation_requestedMeasurements = BIT_STR(name='requestedMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_RequestLocationInformation_requestedMeasurements._cont = ASN1Dict([('apSSID', 0), ('apSN', 1), ('apDevType', 2), ('apPhyType', 3), ('apRSSI', 4), ('apChanFreq', 5), ('apRTD', 6), ('ueTP', 7), ('ueAG', 8), ('apRepLoc', 9), ('non-serving', 10), ('historic', 11), ('apTP', 12), ('apAG', 13), ('ueSN', 14), ('ueRSSI', 15)])
    _OMA_LPPe_WLAN_AP_RequestLocationInformation_requestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_RequestLocationInformation_additionalRequestedMeasurements = BIT_STR(name='additionalRequestedMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_RequestLocationInformation_additionalRequestedMeasurements._cont = ASN1Dict([('oc', 0)])
    _OMA_LPPe_WLAN_AP_RequestLocationInformation_additionalRequestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_WLAN_AP_RequestLocationInformation._cont = ASN1Dict([
        ('requestedMeasurements', _OMA_LPPe_WLAN_AP_RequestLocationInformation_requestedMeasurements),
        ('additionalRequestedMeasurements', _OMA_LPPe_WLAN_AP_RequestLocationInformation_additionalRequestedMeasurements),
        ])
    OMA_LPPe_WLAN_AP_RequestLocationInformation._ext = ['additionalRequestedMeasurements']
    
    #-----< OMA-LPPe-WLAN-AP-ProvideCapabilities >-----#
    OMA_LPPe_WLAN_AP_ProvideCapabilities = SEQ(name='OMA-LPPe-WLAN-AP-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ecid_MeasSupported = BIT_STR(name='wlan-ecid-MeasSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ecid_MeasSupported._cont = ASN1Dict([('apSSID', 0), ('apSN', 1), ('apDevType', 2), ('apPhyType', 3), ('apRSSI', 4), ('apChanFreq', 5), ('apRTD', 6), ('ueTP', 7), ('ueAG', 8), ('apRepLoc', 9), ('non-serving', 10), ('historic', 11), ('apTP', 12), ('apAG', 13), ('ueSN', 14), ('ueRSSI', 15)])
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ecid_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_types_Supported = BIT_STR(name='wlan-types-Supported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Type-List')), opt=True)
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_ap_Capability = SEQ(name='ap-Capability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Capability')), opt=True)
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ap_ADSupported = BIT_STR(name='wlan-ap-ADSupported', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ap_ADSupported._cont = ASN1Dict([('aplist', 0), ('aplocation', 1), ('locationreliability', 2), ('transmit-power', 3), ('antenna-gain', 4), ('coveragearea', 5), ('non-serving', 6)])
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ap_ADSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_additional_wlan_ecid_MeasSupported = BIT_STR(name='additional-wlan-ecid-MeasSupported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_additional_wlan_ecid_MeasSupported._cont = ASN1Dict([('oc', 0)])
    _OMA_LPPe_WLAN_AP_ProvideCapabilities_additional_wlan_ecid_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_WLAN_AP_ProvideCapabilities._cont = ASN1Dict([
        ('wlan-ecid-MeasSupported', _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ecid_MeasSupported),
        ('wlan-types-Supported', _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_types_Supported),
        ('ap-Capability', _OMA_LPPe_WLAN_AP_ProvideCapabilities_ap_Capability),
        ('wlan-ap-ADSupported', _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ap_ADSupported),
        ('additional-wlan-ecid-MeasSupported', _OMA_LPPe_WLAN_AP_ProvideCapabilities_additional_wlan_ecid_MeasSupported),
        ])
    OMA_LPPe_WLAN_AP_ProvideCapabilities._ext = ['additional-wlan-ecid-MeasSupported']
    
    #-----< OMA-LPPe-WLAN-AP-Capability >-----#
    OMA_LPPe_WLAN_AP_Capability = SEQ(name='OMA-LPPe-WLAN-AP-Capability', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_Capability_apMACAddress = SEQ(name='apMACAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-ID')))
    _OMA_LPPe_WLAN_AP_Capability_apTypes = BIT_STR(name='apTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-Type-List')))
    OMA_LPPe_WLAN_AP_Capability._cont = ASN1Dict([
        ('apMACAddress', _OMA_LPPe_WLAN_AP_Capability_apMACAddress),
        ('apTypes', _OMA_LPPe_WLAN_AP_Capability_apTypes),
        ])
    OMA_LPPe_WLAN_AP_Capability._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-RequestCapabilities >-----#
    OMA_LPPe_WLAN_AP_RequestCapabilities = SEQ(name='OMA-LPPe-WLAN-AP-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_WLAN_AP_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_WLAN_AP_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-Error >-----#
    OMA_LPPe_WLAN_AP_Error = CHOICE(name='OMA-LPPe-WLAN-AP-Error', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-LocationServerErrorCauses')))
    _OMA_LPPe_WLAN_AP_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-AP-TargetDeviceErrorCauses')))
    OMA_LPPe_WLAN_AP_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_WLAN_AP_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_WLAN_AP_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_WLAN_AP_Error._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-LocationServerErrorCauses >-----#
    OMA_LPPe_WLAN_AP_LocationServerErrorCauses = SEQ(name='OMA-LPPe-WLAN-AP-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedADNotAvailable', 1), ('notAllrequestedADAvailable', 2)])
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_cause._ext = []
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apMandatoryDataUnavailable = NULL(name='apMandatoryDataUnavailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apLocationsUnavailable = NULL(name='apLocationsUnavailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apLocationReliabilityUnavailable = NULL(name='apLocationReliabilityUnavailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apTransmitPowerUnavailable = NULL(name='apTransmitPowerUnavailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apAntennaGainUnavailable = NULL(name='apAntennaGainUnavailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apCoverageAreaUnavailable = NULL(name='apCoverageAreaUnavailable', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_nonservingADUnavailable = NULL(name='nonservingADUnavailable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_WLAN_AP_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_cause),
        ('apMandatoryDataUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apMandatoryDataUnavailable),
        ('apLocationsUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apLocationsUnavailable),
        ('apLocationReliabilityUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apLocationReliabilityUnavailable),
        ('apTransmitPowerUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apTransmitPowerUnavailable),
        ('apAntennaGainUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apAntennaGainUnavailable),
        ('apCoverageAreaUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apCoverageAreaUnavailable),
        ('nonservingADUnavailable', _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_nonservingADUnavailable),
        ])
    OMA_LPPe_WLAN_AP_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-WLAN-AP-TargetDeviceErrorCauses >-----#
    OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-WLAN-AP-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_cause._ext = []
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apSSIDnotAvailable = NULL(name='apSSIDnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apSNMeasurementNotPossible = NULL(name='apSNMeasurementNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apDevTypeNotAvailable = NULL(name='apDevTypeNotAvailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apPhyTypeNotAvailable = NULL(name='apPhyTypeNotAvailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRSSIMeasurementNotPossible = NULL(name='apRSSIMeasurementNotPossible', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apChanFreqNotAvailable = NULL(name='apChanFreqNotAvailable', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRTDMeasurementNotPossible = NULL(name='apRTDMeasurementNotPossible', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueTPNotAvailable = NULL(name='ueTPNotAvailable', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueAGNotAvailable = NULL(name='ueAGNotAvailable', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRecLocNotAvailable = NULL(name='apRecLocNotAvailable', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable = NULL(name='non-servingMeasurementsNotAvailable', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_historicMeasurementsNotAvailable = NULL(name='historicMeasurementsNotAvailable', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apTPNotAvailable = NULL(name='apTPNotAvailable', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apAGNotAvailable = NULL(name='apAGNotAvailable', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueSNNotAvailable = NULL(name='ueSNNotAvailable', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueRSSINotAvailable = NULL(name='ueRSSINotAvailable', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ocNotAvailable = NULL(name='ocNotAvailable', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_cause),
        ('apSSIDnotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apSSIDnotAvailable),
        ('apSNMeasurementNotPossible', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apSNMeasurementNotPossible),
        ('apDevTypeNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apDevTypeNotAvailable),
        ('apPhyTypeNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apPhyTypeNotAvailable),
        ('apRSSIMeasurementNotPossible', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRSSIMeasurementNotPossible),
        ('apChanFreqNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apChanFreqNotAvailable),
        ('apRTDMeasurementNotPossible', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRTDMeasurementNotPossible),
        ('ueTPNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueTPNotAvailable),
        ('ueAGNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueAGNotAvailable),
        ('apRecLocNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRecLocNotAvailable),
        ('non-servingMeasurementsNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable),
        ('historicMeasurementsNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_historicMeasurementsNotAvailable),
        ('apTPNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apTPNotAvailable),
        ('apAGNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apAGNotAvailable),
        ('ueSNNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueSNNotAvailable),
        ('ueRSSINotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueRSSINotAvailable),
        ('ocNotAvailable', _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ocNotAvailable),
        ])
    OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses._ext = ['apTPNotAvailable', 'apAGNotAvailable', 'ueSNNotAvailable', 'ueRSSINotAvailable', 'ocNotAvailable']
    
    #-----< OMA-LPPe-ECID-WiMax-ProvideLocationInformation >-----#
    OMA_LPPe_ECID_WiMax_ProvideLocationInformation = SEQ(name='OMA-LPPe-ECID-WiMax-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation = SEQ_OF(name='ecid-wimax-CombinedLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-LocationInformationList')))
    _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation._cont = __OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation__item_
    _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1264)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_Error = CHOICE(name='ecid-wimax-Error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-Error')), opt=True)
    OMA_LPPe_ECID_WiMax_ProvideLocationInformation._cont = ASN1Dict([
        ('ecid-wimax-CombinedLocationInformation', _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation),
        ('ecid-wimax-Error', _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_Error),
        ])
    OMA_LPPe_ECID_WiMax_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-LocationInformationList >-----#
    OMA_LPPe_ECID_WiMax_LocationInformationList = SEQ(name='OMA-LPPe-ECID-WiMax-LocationInformationList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_LocationInformationList_ecid_wimax_LocationInformation = SEQ(name='ecid-wimax-LocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-LocationInformation')))
    _OMA_LPPe_ECID_WiMax_LocationInformationList_relativeTimeStamp = INT(name='relativeTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_LocationInformationList_relativeTimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_LocationInformationList_servingFlag = BOOL(name='servingFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    OMA_LPPe_ECID_WiMax_LocationInformationList._cont = ASN1Dict([
        ('ecid-wimax-LocationInformation', _OMA_LPPe_ECID_WiMax_LocationInformationList_ecid_wimax_LocationInformation),
        ('relativeTimeStamp', _OMA_LPPe_ECID_WiMax_LocationInformationList_relativeTimeStamp),
        ('servingFlag', _OMA_LPPe_ECID_WiMax_LocationInformationList_servingFlag),
        ])
    OMA_LPPe_ECID_WiMax_LocationInformationList._ext = []
    
    #-----< maxWiMaxECIDSize >-----#
    maxWiMaxECIDSize = INT(name='maxWiMaxECIDSize', mode=MODE_VALUE)
    maxWiMaxECIDSize._val = 1264
    
    #-----< OMA-LPPe-ECID-WiMax-LocationInformation >-----#
    OMA_LPPe_ECID_WiMax_LocationInformation = SEQ(name='OMA-LPPe-ECID-WiMax-LocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxBsID = SEQ(name='wimaxBsID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-WimaxBsID')))
    _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxRTD = SEQ(name='wimaxRTD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-WimaxRTD')), opt=True)
    _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxNMRList = SEQ_OF(name='wimaxNMRList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-WimaxNMRList')), opt=True)
    OMA_LPPe_ECID_WiMax_LocationInformation._cont = ASN1Dict([
        ('wimaxBsID', _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxBsID),
        ('wimaxRTD', _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxRTD),
        ('wimaxNMRList', _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxNMRList),
        ])
    OMA_LPPe_ECID_WiMax_LocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-WimaxBsID >-----#
    OMA_LPPe_ECID_WiMax_WimaxBsID = SEQ(name='OMA-LPPe-ECID-WiMax-WimaxBsID', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_MSB = BIT_STR(name='bsID-MSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_MSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_LSB = BIT_STR(name='bsID-LSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_LSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    OMA_LPPe_ECID_WiMax_WimaxBsID._cont = ASN1Dict([
        ('bsID-MSB', _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_MSB),
        ('bsID-LSB', _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_LSB),
        ])
    OMA_LPPe_ECID_WiMax_WimaxBsID._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-WimaxRTD >-----#
    OMA_LPPe_ECID_WiMax_WimaxRTD = SEQ(name='OMA-LPPe-ECID-WiMax-WimaxRTD', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_WimaxRTD_rTD = INT(name='rTD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_WiMax_WimaxRTD_rTD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxRTD_rTDstd = INT(name='rTDstd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxRTD_rTDstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    OMA_LPPe_ECID_WiMax_WimaxRTD._cont = ASN1Dict([
        ('rTD', _OMA_LPPe_ECID_WiMax_WimaxRTD_rTD),
        ('rTDstd', _OMA_LPPe_ECID_WiMax_WimaxRTD_rTDstd),
        ])
    OMA_LPPe_ECID_WiMax_WimaxRTD._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-WimaxNMRList >-----#
    OMA_LPPe_ECID_WiMax_WimaxNMRList = SEQ_OF(name='OMA-LPPe-ECID-WiMax-WimaxNMRList', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_WimaxNMRList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-WimaxNMR')))
    OMA_LPPe_ECID_WiMax_WimaxNMRList._cont = _OMA_LPPe_ECID_WiMax_WimaxNMRList__item_
    OMA_LPPe_ECID_WiMax_WimaxNMRList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OMA-LPPe-ECID-WiMax-WimaxNMR >-----#
    OMA_LPPe_ECID_WiMax_WimaxNMR = SEQ(name='OMA-LPPe-ECID-WiMax-WimaxNMR', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_wimaxBsID = SEQ(name='wimaxBsID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-WimaxBsID')))
    _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelay = INT(name='relDelay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelaystd = INT(name='relDelaystd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelaystd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSI = INT(name='rSSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSIstd = INT(name='rSSIstd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSIstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_bSTxPower = INT(name='bSTxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_bSTxPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_cINR = INT(name='cINR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_cINR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_cINRstd = INT(name='cINRstd', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_WimaxNMR_cINRstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _OMA_LPPe_ECID_WiMax_WimaxNMR_bSLocation = SEQ(name='bSLocation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-ReportedLocation')), opt=True)
    OMA_LPPe_ECID_WiMax_WimaxNMR._cont = ASN1Dict([
        ('wimaxBsID', _OMA_LPPe_ECID_WiMax_WimaxNMR_wimaxBsID),
        ('relDelay', _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelay),
        ('relDelaystd', _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelaystd),
        ('rSSI', _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSI),
        ('rSSIstd', _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSIstd),
        ('bSTxPower', _OMA_LPPe_ECID_WiMax_WimaxNMR_bSTxPower),
        ('cINR', _OMA_LPPe_ECID_WiMax_WimaxNMR_cINR),
        ('cINRstd', _OMA_LPPe_ECID_WiMax_WimaxNMR_cINRstd),
        ('bSLocation', _OMA_LPPe_ECID_WiMax_WimaxNMR_bSLocation),
        ])
    OMA_LPPe_ECID_WiMax_WimaxNMR._ext = []
    
    #-----< maxWimaxBSMeas >-----#
    maxWimaxBSMeas = INT(name='maxWimaxBSMeas', mode=MODE_VALUE)
    maxWimaxBSMeas._val = 32
    
    #-----< OMA-LPPe-ECID-WiMax-RequestLocationInformation >-----#
    OMA_LPPe_ECID_WiMax_RequestLocationInformation = SEQ(name='OMA-LPPe-ECID-WiMax-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_RequestLocationInformation_requestedMeasurements = BIT_STR(name='requestedMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_WiMax_RequestLocationInformation_requestedMeasurements._cont = ASN1Dict([('rTD', 0), ('rTDstd', 1), ('nMR', 2), ('nMRrelDelay', 3), ('nMRrelDelaystd', 4), ('nMRrSSI', 5), ('nMRrSSIstd', 6), ('nMRbSTxPower', 7), ('nMRcINR', 8), ('nMRcINRstd', 9), ('nMRbSLocation', 10), ('non-serving', 11), ('historic', 12)])
    _OMA_LPPe_ECID_WiMax_RequestLocationInformation_requestedMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_WiMax_RequestLocationInformation._cont = ASN1Dict([
        ('requestedMeasurements', _OMA_LPPe_ECID_WiMax_RequestLocationInformation_requestedMeasurements),
        ])
    OMA_LPPe_ECID_WiMax_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-ProvideCapabilities >-----#
    OMA_LPPe_ECID_WiMax_ProvideCapabilities = SEQ(name='OMA-LPPe-ECID-WiMax-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_ProvideCapabilities_ecid_wimax_MeasSupported = BIT_STR(name='ecid-wimax-MeasSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_WiMax_ProvideCapabilities_ecid_wimax_MeasSupported._cont = ASN1Dict([('rTD', 0), ('rTDstd', 1), ('nMR', 2), ('nMRrelDelay', 3), ('nMRrelDelaystd', 4), ('nMRrSSI', 5), ('nMRrSSIstd', 6), ('nMRbSTxPower', 7), ('nMRcINR', 8), ('nMRcINRstd', 9), ('nMRbSLocation', 10), ('non-serving', 11), ('historic', 12)])
    _OMA_LPPe_ECID_WiMax_ProvideCapabilities_ecid_wimax_MeasSupported._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_ECID_WiMax_ProvideCapabilities._cont = ASN1Dict([
        ('ecid-wimax-MeasSupported', _OMA_LPPe_ECID_WiMax_ProvideCapabilities_ecid_wimax_MeasSupported),
        ])
    OMA_LPPe_ECID_WiMax_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-RequestCapabilities >-----#
    OMA_LPPe_ECID_WiMax_RequestCapabilities = SEQ(name='OMA-LPPe-ECID-WiMax-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_ECID_WiMax_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_ECID_WiMax_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-Error >-----#
    OMA_LPPe_ECID_WiMax_Error = CHOICE(name='OMA-LPPe-ECID-WiMax-Error', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_Error_locationServerErrorCauses = SEQ(name='locationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-LocationServerErrorCauses')))
    _OMA_LPPe_ECID_WiMax_Error_targetDeviceErrorCauses = SEQ(name='targetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ECID-WiMax-TargetDeviceErrorCauses')))
    OMA_LPPe_ECID_WiMax_Error._cont = ASN1Dict([
        ('locationServerErrorCauses', _OMA_LPPe_ECID_WiMax_Error_locationServerErrorCauses),
        ('targetDeviceErrorCauses', _OMA_LPPe_ECID_WiMax_Error_targetDeviceErrorCauses),
        ])
    OMA_LPPe_ECID_WiMax_Error._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-LocationServerErrorCauses >-----#
    OMA_LPPe_ECID_WiMax_LocationServerErrorCauses = SEQ(name='OMA-LPPe-ECID-WiMax-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_LocationServerErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_WiMax_LocationServerErrorCauses_cause._cont = ASN1Dict([('undefined', 0)])
    _OMA_LPPe_ECID_WiMax_LocationServerErrorCauses_cause._ext = []
    OMA_LPPe_ECID_WiMax_LocationServerErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_WiMax_LocationServerErrorCauses_cause),
        ])
    OMA_LPPe_ECID_WiMax_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-ECID-WiMax-TargetDeviceErrorCauses >-----#
    OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-ECID-WiMax-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_cause = ENUM(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_cause._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2)])
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_cause._ext = []
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_rTDMeasurementNotPossible = NULL(name='rTDMeasurementNotPossible', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_rTDstdMeasurementNotPossible = NULL(name='rTDstdMeasurementNotPossible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRMeasurementNotPossible = NULL(name='nMRMeasurementNotPossible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrelDelayMeasurementNotPossible = NULL(name='nMRrelDelayMeasurementNotPossible', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrelDelaystdMeasurementNotPossible = NULL(name='nMRrelDelaystdMeasurementNotPossible', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrSSIMeasurementNotPossible = NULL(name='nMRrSSIMeasurementNotPossible', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrSSIstdMeasurementNotPossible = NULL(name='nMRrSSIstdMeasurementNotPossible', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRbSTxPowerMeasurementNotPossible = NULL(name='nMRbSTxPowerMeasurementNotPossible', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRcINRMeasurementNotPossible = NULL(name='nMRcINRMeasurementNotPossible', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRcINRstdMeasurementNotPossible = NULL(name='nMRcINRstdMeasurementNotPossible', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRbSLocationNotAvailable = NULL(name='nMRbSLocationNotAvailable', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable = NULL(name='non-servingMeasurementsNotAvailable', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_historicMeasurementsNotAvailable = NULL(name='historicMeasurementsNotAvailable', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('cause', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_cause),
        ('rTDMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_rTDMeasurementNotPossible),
        ('rTDstdMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_rTDstdMeasurementNotPossible),
        ('nMRMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRMeasurementNotPossible),
        ('nMRrelDelayMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrelDelayMeasurementNotPossible),
        ('nMRrelDelaystdMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrelDelaystdMeasurementNotPossible),
        ('nMRrSSIMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrSSIMeasurementNotPossible),
        ('nMRrSSIstdMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrSSIstdMeasurementNotPossible),
        ('nMRbSTxPowerMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRbSTxPowerMeasurementNotPossible),
        ('nMRcINRMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRcINRMeasurementNotPossible),
        ('nMRcINRstdMeasurementNotPossible', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRcINRstdMeasurementNotPossible),
        ('nMRbSLocationNotAvailable', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRbSLocationNotAvailable),
        ('non-servingMeasurementsNotAvailable', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable),
        ('historicMeasurementsNotAvailable', _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_historicMeasurementsNotAvailable),
        ])
    OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-Sensor-ProvideAssistanceData >-----#
    OMA_LPPe_Sensor_ProvideAssistanceData = SEQ(name='OMA-LPPe-Sensor-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_ProvideAssistanceData_atmosphericPressureAD = SEQ(name='atmosphericPressureAD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-AtmosphericPressureAD')), opt=True)
    OMA_LPPe_Sensor_ProvideAssistanceData._cont = ASN1Dict([
        ('atmosphericPressureAD', _OMA_LPPe_Sensor_ProvideAssistanceData_atmosphericPressureAD),
        ])
    OMA_LPPe_Sensor_ProvideAssistanceData._ext = ['atmosphericPressureAD']
    
    #-----< OMA-LPPe-AtmosphericPressureAD >-----#
    OMA_LPPe_AtmosphericPressureAD = SEQ(name='OMA-LPPe-AtmosphericPressureAD', mode=MODE_TYPE)
    _OMA_LPPe_AtmosphericPressureAD_referencePressure = INT(name='referencePressure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_AtmosphericPressureAD_referencePressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _OMA_LPPe_AtmosphericPressureAD_period = SEQ(name='period', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AtmosphericPressureAD_period_pressureValidityPeriod = SEQ(name='pressureValidityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ValidityPeriod')))
    __OMA_LPPe_AtmosphericPressureAD_period_referencePressureRate = INT(name='referencePressureRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AtmosphericPressureAD_period_referencePressureRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AtmosphericPressureAD_period._cont = ASN1Dict([
        ('pressureValidityPeriod', __OMA_LPPe_AtmosphericPressureAD_period_pressureValidityPeriod),
        ('referencePressureRate', __OMA_LPPe_AtmosphericPressureAD_period_referencePressureRate),
        ])
    _OMA_LPPe_AtmosphericPressureAD_period._ext = []
    _OMA_LPPe_AtmosphericPressureAD_area = SEQ(name='area', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AtmosphericPressureAD_area_pressureValidityArea = SEQ(name='pressureValidityArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-PressureValidityArea')))
    __OMA_LPPe_AtmosphericPressureAD_area_gN_pressure = INT(name='gN-pressure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AtmosphericPressureAD_area_gN_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    __OMA_LPPe_AtmosphericPressureAD_area_gE_pressure = INT(name='gE-pressure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_AtmosphericPressureAD_area_gE_pressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_AtmosphericPressureAD_area._cont = ASN1Dict([
        ('pressureValidityArea', __OMA_LPPe_AtmosphericPressureAD_area_pressureValidityArea),
        ('gN-pressure', __OMA_LPPe_AtmosphericPressureAD_area_gN_pressure),
        ('gE-pressure', __OMA_LPPe_AtmosphericPressureAD_area_gE_pressure),
        ])
    _OMA_LPPe_AtmosphericPressureAD_area._ext = []
    OMA_LPPe_AtmosphericPressureAD._cont = ASN1Dict([
        ('referencePressure', _OMA_LPPe_AtmosphericPressureAD_referencePressure),
        ('period', _OMA_LPPe_AtmosphericPressureAD_period),
        ('area', _OMA_LPPe_AtmosphericPressureAD_area),
        ])
    OMA_LPPe_AtmosphericPressureAD._ext = []
    
    #-----< OMA-LPPe-PressureValidityArea >-----#
    OMA_LPPe_PressureValidityArea = SEQ(name='OMA-LPPe-PressureValidityArea', mode=MODE_TYPE)
    _OMA_LPPe_PressureValidityArea_centerPoint = SEQ(name='centerPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LPP-PDU-Definitions', 'Ellipsoid-Point')))
    _OMA_LPPe_PressureValidityArea_validityAreaWidth = INT(name='validityAreaWidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_PressureValidityArea_validityAreaWidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _OMA_LPPe_PressureValidityArea_validityAreaHeight = INT(name='validityAreaHeight', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_PressureValidityArea_validityAreaHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    OMA_LPPe_PressureValidityArea._cont = ASN1Dict([
        ('centerPoint', _OMA_LPPe_PressureValidityArea_centerPoint),
        ('validityAreaWidth', _OMA_LPPe_PressureValidityArea_validityAreaWidth),
        ('validityAreaHeight', _OMA_LPPe_PressureValidityArea_validityAreaHeight),
        ])
    OMA_LPPe_PressureValidityArea._ext = []
    
    #-----< OMA-LPPe-Sensor-RequestAssistanceData >-----#
    OMA_LPPe_Sensor_RequestAssistanceData = SEQ(name='OMA-LPPe-Sensor-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_RequestAssistanceData_pressureSensorAD = SEQ(name='pressureSensorAD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-PressureSensorAD')), opt=True)
    OMA_LPPe_Sensor_RequestAssistanceData._cont = ASN1Dict([
        ('pressureSensorAD', _OMA_LPPe_Sensor_RequestAssistanceData_pressureSensorAD),
        ])
    OMA_LPPe_Sensor_RequestAssistanceData._ext = ['pressureSensorAD']
    
    #-----< OMA-LPPe-PressureSensorAD >-----#
    OMA_LPPe_PressureSensorAD = SEQ(name='OMA-LPPe-PressureSensorAD', mode=MODE_TYPE)
    OMA_LPPe_PressureSensorAD._cont = ASN1Dict([
        ])
    OMA_LPPe_PressureSensorAD._ext = []
    
    #-----< OMA-LPPe-Sensor-ProvideLocationInformation >-----#
    OMA_LPPe_Sensor_ProvideLocationInformation = SEQ(name='OMA-LPPe-Sensor-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_ProvideLocationInformation_motionStateList = SEQ_OF(name='motionStateList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-MotionStateList')), opt=True)
    _OMA_LPPe_Sensor_ProvideLocationInformation_sensorError = CHOICE(name='sensorError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-Error')), opt=True)
    OMA_LPPe_Sensor_ProvideLocationInformation._cont = ASN1Dict([
        ('motionStateList', _OMA_LPPe_Sensor_ProvideLocationInformation_motionStateList),
        ('sensorError', _OMA_LPPe_Sensor_ProvideLocationInformation_sensorError),
        ])
    OMA_LPPe_Sensor_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-Sensor-MotionStateList >-----#
    OMA_LPPe_Sensor_MotionStateList = SEQ_OF(name='OMA-LPPe-Sensor-MotionStateList', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_MotionStateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-MotionStateElement')))
    OMA_LPPe_Sensor_MotionStateList._cont = _OMA_LPPe_Sensor_MotionStateList__item_
    OMA_LPPe_Sensor_MotionStateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-Sensor-MotionStateElement >-----#
    OMA_LPPe_Sensor_MotionStateElement = SEQ(name='OMA-LPPe-Sensor-MotionStateElement', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_MotionStateElement_primaryMotionState = ENUM(name='primaryMotionState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_Sensor_MotionStateElement_primaryMotionState._cont = ASN1Dict([('unknown', 0), ('stationary', 1), ('pedestrian', 2), ('running', 3), ('cycling', 4), ('car', 5), ('train', 6), ('aeroplane', 7), ('boat', 8), ('fidgeting', 9)])
    _OMA_LPPe_Sensor_MotionStateElement_primaryMotionState._ext = []
    _OMA_LPPe_Sensor_MotionStateElement_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_Sensor_MotionStateElement_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=99)], ev=None, er=[])
    _OMA_LPPe_Sensor_MotionStateElement_secondaryMotionState = BIT_STR(name='secondaryMotionState', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_Sensor_MotionStateElement_secondaryMotionState._cont = ASN1Dict([('stationary', 0), ('pedestrian', 1), ('running', 2), ('cycling', 3), ('car', 4), ('train', 5), ('aeroplane', 6), ('boat', 7), ('fidgeting', 8)])
    _OMA_LPPe_Sensor_MotionStateElement_secondaryMotionState._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_Sensor_MotionStateElement._cont = ASN1Dict([
        ('primaryMotionState', _OMA_LPPe_Sensor_MotionStateElement_primaryMotionState),
        ('confidence', _OMA_LPPe_Sensor_MotionStateElement_confidence),
        ('secondaryMotionState', _OMA_LPPe_Sensor_MotionStateElement_secondaryMotionState),
        ])
    OMA_LPPe_Sensor_MotionStateElement._ext = []
    
    #-----< OMA-LPPe-Sensor-RequestLocationInformation >-----#
    OMA_LPPe_Sensor_RequestLocationInformation = SEQ(name='OMA-LPPe-Sensor-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_RequestLocationInformation_motionStateReq = SEQ(name='motionStateReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-MotionStateRequest')), opt=True)
    OMA_LPPe_Sensor_RequestLocationInformation._cont = ASN1Dict([
        ('motionStateReq', _OMA_LPPe_Sensor_RequestLocationInformation_motionStateReq),
        ])
    OMA_LPPe_Sensor_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-Sensor-MotionStateRequest >-----#
    OMA_LPPe_Sensor_MotionStateRequest = SEQ(name='OMA-LPPe-Sensor-MotionStateRequest', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_MotionStateRequest_secondaryMotionStateRequest = NULL(name='secondaryMotionStateRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_Sensor_MotionStateRequest._cont = ASN1Dict([
        ('secondaryMotionStateRequest', _OMA_LPPe_Sensor_MotionStateRequest_secondaryMotionStateRequest),
        ])
    OMA_LPPe_Sensor_MotionStateRequest._ext = []
    
    #-----< OMA-LPPe-Sensor-ProvideCapabilities >-----#
    OMA_LPPe_Sensor_ProvideCapabilities = SEQ(name='OMA-LPPe-Sensor-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_ProvideCapabilities_motionStateSupport = NULL(name='motionStateSupport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_Sensor_ProvideCapabilities_secondarySupport = NULL(name='secondarySupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_Sensor_ProvideCapabilities_barometricPressureSupport = NULL(name='barometricPressureSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_Sensor_ProvideCapabilities._cont = ASN1Dict([
        ('motionStateSupport', _OMA_LPPe_Sensor_ProvideCapabilities_motionStateSupport),
        ('secondarySupport', _OMA_LPPe_Sensor_ProvideCapabilities_secondarySupport),
        ('barometricPressureSupport', _OMA_LPPe_Sensor_ProvideCapabilities_barometricPressureSupport),
        ])
    OMA_LPPe_Sensor_ProvideCapabilities._ext = ['barometricPressureSupport']
    
    #-----< OMA-LPPe-Sensor-RequestCapabilities >-----#
    OMA_LPPe_Sensor_RequestCapabilities = SEQ(name='OMA-LPPe-Sensor-RequestCapabilities', mode=MODE_TYPE)
    OMA_LPPe_Sensor_RequestCapabilities._cont = ASN1Dict([
        ])
    OMA_LPPe_Sensor_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-Sensor-Error >-----#
    OMA_LPPe_Sensor_Error = CHOICE(name='OMA-LPPe-Sensor-Error', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_Error_targetError = SEQ(name='targetError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Sensor-TargetError')))
    OMA_LPPe_Sensor_Error._cont = ASN1Dict([
        ('targetError', _OMA_LPPe_Sensor_Error_targetError),
        ])
    OMA_LPPe_Sensor_Error._ext = []
    
    #-----< OMA-LPPe-Sensor-TargetError >-----#
    OMA_LPPe_Sensor_TargetError = SEQ(name='OMA-LPPe-Sensor-TargetError', mode=MODE_TYPE)
    _OMA_LPPe_Sensor_TargetError_motionStateError = ENUM(name='motionStateError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_Sensor_TargetError_motionStateError._cont = ASN1Dict([('primaryMotionStateNotAvailable', 0), ('primaryMotionStateNotSupported', 1)])
    _OMA_LPPe_Sensor_TargetError_motionStateError._ext = []
    _OMA_LPPe_Sensor_TargetError_secondaryMotionStateError = ENUM(name='secondaryMotionStateError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_Sensor_TargetError_secondaryMotionStateError._cont = ASN1Dict([('secondaryMotionStateNotAvailable', 0), ('secondaryMotionStateNotSupported', 1)])
    _OMA_LPPe_Sensor_TargetError_secondaryMotionStateError._ext = []
    OMA_LPPe_Sensor_TargetError._cont = ASN1Dict([
        ('motionStateError', _OMA_LPPe_Sensor_TargetError_motionStateError),
        ('secondaryMotionStateError', _OMA_LPPe_Sensor_TargetError_secondaryMotionStateError),
        ])
    OMA_LPPe_Sensor_TargetError._ext = []
    
    #-----< OMA-LPPe-SRN-ProvideAssistanceData >-----#
    OMA_LPPe_SRN_ProvideAssistanceData = SEQ(name='OMA-LPPe-SRN-ProvideAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ProvideAssistanceData_srnGroup = CHOICE(name='srnGroup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_SRN_ProvideAssistanceData_srnGroup_srnGroupList = SEQ(name='srnGroupList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupList')))
    __OMA_LPPe_SRN_ProvideAssistanceData_srnGroup_srnGroupUpdateResponse = SEQ_OF(name='srnGroupUpdateResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUpdateResponse')))
    _OMA_LPPe_SRN_ProvideAssistanceData_srnGroup._cont = ASN1Dict([
        ('srnGroupList', __OMA_LPPe_SRN_ProvideAssistanceData_srnGroup_srnGroupList),
        ('srnGroupUpdateResponse', __OMA_LPPe_SRN_ProvideAssistanceData_srnGroup_srnGroupUpdateResponse),
        ])
    _OMA_LPPe_SRN_ProvideAssistanceData_srnGroup._ext = []
    _OMA_LPPe_SRN_ProvideAssistanceData_antennaPattern = SEQ_OF(name='antennaPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-AntennaPattern')), opt=True)
    _OMA_LPPe_SRN_ProvideAssistanceData_srnError = CHOICE(name='srnError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Error')), opt=True)
    OMA_LPPe_SRN_ProvideAssistanceData._cont = ASN1Dict([
        ('srnGroup', _OMA_LPPe_SRN_ProvideAssistanceData_srnGroup),
        ('antennaPattern', _OMA_LPPe_SRN_ProvideAssistanceData_antennaPattern),
        ('srnError', _OMA_LPPe_SRN_ProvideAssistanceData_srnError),
        ])
    OMA_LPPe_SRN_ProvideAssistanceData._ext = []
    
    #-----< OMA-LPPe-SRN-SRNgroupList >-----#
    OMA_LPPe_SRN_SRNgroupList = SEQ(name='OMA-LPPe-SRN-SRNgroupList', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupList_incompleteFlag = BOOL(name='incompleteFlag', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_SRNgroupList_defaultReferencePoint = SEQ(name='defaultReferencePoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_SRN_SRNgroupList_groupList = SEQ_OF(name='groupList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_SRNgroupList_groupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroup')))
    _OMA_LPPe_SRN_SRNgroupList_groupList._cont = __OMA_LPPe_SRN_SRNgroupList_groupList__item_
    _OMA_LPPe_SRN_SRNgroupList_groupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_SRN_SRNgroupList._cont = ASN1Dict([
        ('incompleteFlag', _OMA_LPPe_SRN_SRNgroupList_incompleteFlag),
        ('defaultReferencePoint', _OMA_LPPe_SRN_SRNgroupList_defaultReferencePoint),
        ('groupList', _OMA_LPPe_SRN_SRNgroupList_groupList),
        ])
    OMA_LPPe_SRN_SRNgroupList._ext = []
    
    #-----< OMA-LPPe-SRN-SRNgroup >-----#
    OMA_LPPe_SRN_SRNgroup = SEQ(name='OMA-LPPe-SRN-SRNgroup', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroup_srnGroupID = SEQ(name='srnGroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUniqueID')), opt=True)
    _OMA_LPPe_SRN_SRNgroup_defaultSRNtype = SEQ(name='defaultSRNtype', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNtype')), opt=True)
    _OMA_LPPe_SRN_SRNgroup_referencePoint = SEQ(name='referencePoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ReferencePoint')), opt=True)
    _OMA_LPPe_SRN_SRNgroup_globalOrientation = NULL(name='globalOrientation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_SRNgroup_srnsInGroupList = SEQ_OF(name='srnsInGroupList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_SRNgroup_srnsInGroupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNinfo')))
    _OMA_LPPe_SRN_SRNgroup_srnsInGroupList._cont = __OMA_LPPe_SRN_SRNgroup_srnsInGroupList__item_
    _OMA_LPPe_SRN_SRNgroup_srnsInGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    OMA_LPPe_SRN_SRNgroup._cont = ASN1Dict([
        ('srnGroupID', _OMA_LPPe_SRN_SRNgroup_srnGroupID),
        ('defaultSRNtype', _OMA_LPPe_SRN_SRNgroup_defaultSRNtype),
        ('referencePoint', _OMA_LPPe_SRN_SRNgroup_referencePoint),
        ('globalOrientation', _OMA_LPPe_SRN_SRNgroup_globalOrientation),
        ('srnsInGroupList', _OMA_LPPe_SRN_SRNgroup_srnsInGroupList),
        ])
    OMA_LPPe_SRN_SRNgroup._ext = []
    
    #-----< OMA-LPPe-SRN-SRNinfo >-----#
    OMA_LPPe_SRN_SRNinfo = SEQ(name='OMA-LPPe-SRN-SRNinfo', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNinfo_srnID = SEQ(name='srnID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNid')))
    _OMA_LPPe_SRN_SRNinfo_srnType = SEQ(name='srnType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNtype')), opt=True)
    _OMA_LPPe_SRN_SRNinfo_relativePosition = SEQ(name='relativePosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-RelativeLocation')))
    _OMA_LPPe_SRN_SRNinfo_orientation = CHOICE(name='orientation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-Orientation')), opt=True)
    OMA_LPPe_SRN_SRNinfo._cont = ASN1Dict([
        ('srnID', _OMA_LPPe_SRN_SRNinfo_srnID),
        ('srnType', _OMA_LPPe_SRN_SRNinfo_srnType),
        ('relativePosition', _OMA_LPPe_SRN_SRNinfo_relativePosition),
        ('orientation', _OMA_LPPe_SRN_SRNinfo_orientation),
        ])
    OMA_LPPe_SRN_SRNinfo._ext = []
    
    #-----< OMA-LPPe-SRN-SRNgroupUpdateResponse >-----#
    OMA_LPPe_SRN_SRNgroupUpdateResponse = SEQ_OF(name='OMA-LPPe-SRN-SRNgroupUpdateResponse', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupUpdateResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUpdateResponseElement')))
    OMA_LPPe_SRN_SRNgroupUpdateResponse._cont = _OMA_LPPe_SRN_SRNgroupUpdateResponse__item_
    OMA_LPPe_SRN_SRNgroupUpdateResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-SRN-SRNgroupUpdateResponseElement >-----#
    OMA_LPPe_SRN_SRNgroupUpdateResponseElement = SEQ(name='OMA-LPPe-SRN-SRNgroupUpdateResponseElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_srnGroupID = SEQ(name='srnGroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUniqueID')), opt=True)
    _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_targetDataValidity = ENUM(name='targetDataValidity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_targetDataValidity._cont = ASN1Dict([('targetDataValid', 0), ('targetDataInValidAndUpdatedDataWillBeProvided', 1), ('targetDataInValidButServerWillNotProvideNewData', 2)])
    _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_targetDataValidity._ext = []
    _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_updatedSRNgroup = SEQ(name='updatedSRNgroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroup')), opt=True)
    OMA_LPPe_SRN_SRNgroupUpdateResponseElement._cont = ASN1Dict([
        ('srnGroupID', _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_srnGroupID),
        ('targetDataValidity', _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_targetDataValidity),
        ('updatedSRNgroup', _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_updatedSRNgroup),
        ])
    OMA_LPPe_SRN_SRNgroupUpdateResponseElement._ext = []
    
    #-----< OMA-LPPe-SRN-AntennaPattern >-----#
    OMA_LPPe_SRN_AntennaPattern = SEQ_OF(name='OMA-LPPe-SRN-AntennaPattern', mode=MODE_TYPE)
    _OMA_LPPe_SRN_AntennaPattern__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-AntennaPatternElement')))
    OMA_LPPe_SRN_AntennaPattern._cont = _OMA_LPPe_SRN_AntennaPattern__item_
    OMA_LPPe_SRN_AntennaPattern._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-SRN-AntennaPatternElement >-----#
    OMA_LPPe_SRN_AntennaPatternElement = SEQ(name='OMA-LPPe-SRN-AntennaPatternElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_AntennaPatternElement_identification = SEQ(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternElement_identification_vendorOrOperator = CHOICE(name='vendorOrOperator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    __OMA_LPPe_SRN_AntennaPatternElement_identification_antennaPatternID = INT(name='antennaPatternID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternElement_identification_antennaPatternID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_SRN_AntennaPatternElement_identification._cont = ASN1Dict([
        ('vendorOrOperator', __OMA_LPPe_SRN_AntennaPatternElement_identification_vendorOrOperator),
        ('antennaPatternID', __OMA_LPPe_SRN_AntennaPatternElement_identification_antennaPatternID),
        ])
    _OMA_LPPe_SRN_AntennaPatternElement_identification._ext = []
    _OMA_LPPe_SRN_AntennaPatternElement_antennaData = CHOICE(name='antennaData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_SRN_AntennaPatternElement_antennaData_antennaPattern = SEQ(name='antennaPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-AntennaPatternForChannels')))
    __OMA_LPPe_SRN_AntennaPatternElement_antennaData_antennaContainer = OCT_STR(name='antennaContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_AntennaPatternElement_antennaData._cont = ASN1Dict([
        ('antennaPattern', __OMA_LPPe_SRN_AntennaPatternElement_antennaData_antennaPattern),
        ('antennaContainer', __OMA_LPPe_SRN_AntennaPatternElement_antennaData_antennaContainer),
        ])
    _OMA_LPPe_SRN_AntennaPatternElement_antennaData._ext = []
    OMA_LPPe_SRN_AntennaPatternElement._cont = ASN1Dict([
        ('identification', _OMA_LPPe_SRN_AntennaPatternElement_identification),
        ('antennaData', _OMA_LPPe_SRN_AntennaPatternElement_antennaData),
        ])
    OMA_LPPe_SRN_AntennaPatternElement._ext = []
    
    #-----< OMA-LPPe-SRN-AntennaPatternForChannels >-----#
    OMA_LPPe_SRN_AntennaPatternForChannels = SEQ(name='OMA-LPPe-SRN-AntennaPatternForChannels', mode=MODE_TYPE)
    _OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid = SEQ(name='evenGrid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inAzimuth = INT(name='inAzimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inAzimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inElevation = INT(name='inElevation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inElevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=None, er=[])
    _OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid._cont = ASN1Dict([
        ('inAzimuth', __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inAzimuth),
        ('inElevation', __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inElevation),
        ])
    _OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid._ext = None
    _OMA_LPPe_SRN_AntennaPatternForChannels_patternList = SEQ_OF(name='patternList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternForChannels_patternList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ChannelResponse')))
    _OMA_LPPe_SRN_AntennaPatternForChannels_patternList._cont = __OMA_LPPe_SRN_AntennaPatternForChannels_patternList__item_
    _OMA_LPPe_SRN_AntennaPatternForChannels_patternList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    OMA_LPPe_SRN_AntennaPatternForChannels._cont = ASN1Dict([
        ('evenGrid', _OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid),
        ('patternList', _OMA_LPPe_SRN_AntennaPatternForChannels_patternList),
        ])
    OMA_LPPe_SRN_AntennaPatternForChannels._ext = []
    
    #-----< OMA-LPPe-SRN-ChannelResponse >-----#
    OMA_LPPe_SRN_ChannelResponse = SEQ(name='OMA-LPPe-SRN-ChannelResponse', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ChannelResponse_channelNumber = INT(name='channelNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_ChannelResponse_channelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    _OMA_LPPe_SRN_ChannelResponse_responseInElevation = SEQ_OF(name='responseInElevation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_ChannelResponse_responseInElevation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ResponseInElevation')))
    _OMA_LPPe_SRN_ChannelResponse_responseInElevation._cont = __OMA_LPPe_SRN_ChannelResponse_responseInElevation__item_
    _OMA_LPPe_SRN_ChannelResponse_responseInElevation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=901)], ev=None, er=[])
    OMA_LPPe_SRN_ChannelResponse._cont = ASN1Dict([
        ('channelNumber', _OMA_LPPe_SRN_ChannelResponse_channelNumber),
        ('responseInElevation', _OMA_LPPe_SRN_ChannelResponse_responseInElevation),
        ])
    OMA_LPPe_SRN_ChannelResponse._ext = []
    
    #-----< OMA-LPPe-SRN-ResponseInElevation >-----#
    OMA_LPPe_SRN_ResponseInElevation = SEQ(name='OMA-LPPe-SRN-ResponseInElevation', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ResponseInElevation_elevation = INT(name='elevation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_ResponseInElevation_elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=900)], ev=None, er=[])
    _OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth = SEQ_OF(name='responseInAzimuth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ResponseInAzimuth')))
    _OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth._cont = __OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth__item_
    _OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=3601)], ev=None, er=[])
    OMA_LPPe_SRN_ResponseInElevation._cont = ASN1Dict([
        ('elevation', _OMA_LPPe_SRN_ResponseInElevation_elevation),
        ('responseInAzimuth', _OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth),
        ])
    OMA_LPPe_SRN_ResponseInElevation._ext = []
    
    #-----< OMA-LPPe-SRN-ResponseInAzimuth >-----#
    OMA_LPPe_SRN_ResponseInAzimuth = SEQ(name='OMA-LPPe-SRN-ResponseInAzimuth', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ResponseInAzimuth_azimuth = INT(name='azimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_ResponseInAzimuth_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _OMA_LPPe_SRN_ResponseInAzimuth_response = SEQ(name='response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-ComplexNumber')))
    OMA_LPPe_SRN_ResponseInAzimuth._cont = ASN1Dict([
        ('azimuth', _OMA_LPPe_SRN_ResponseInAzimuth_azimuth),
        ('response', _OMA_LPPe_SRN_ResponseInAzimuth_response),
        ])
    OMA_LPPe_SRN_ResponseInAzimuth._ext = []
    
    #-----< OMA-LPPe-ComplexNumber >-----#
    OMA_LPPe_ComplexNumber = SEQ(name='OMA-LPPe-ComplexNumber', mode=MODE_TYPE)
    _OMA_LPPe_ComplexNumber_amplitude = INT(name='amplitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ComplexNumber_amplitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    _OMA_LPPe_ComplexNumber_phase = INT(name='phase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_ComplexNumber_phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1800, ub=1799)], ev=None, er=[])
    OMA_LPPe_ComplexNumber._cont = ASN1Dict([
        ('amplitude', _OMA_LPPe_ComplexNumber_amplitude),
        ('phase', _OMA_LPPe_ComplexNumber_phase),
        ])
    OMA_LPPe_ComplexNumber._ext = None
    
    #-----< maxChannels >-----#
    maxChannels = INT(name='maxChannels', mode=MODE_VALUE)
    maxChannels._val = 512
    
    #-----< OMA-LPPe-SRN-RequestAssistanceData >-----#
    OMA_LPPe_SRN_RequestAssistanceData = SEQ(name='OMA-LPPe-SRN-RequestAssistanceData', mode=MODE_TYPE)
    _OMA_LPPe_SRN_RequestAssistanceData_srnGroup = CHOICE(name='srnGroup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OMA_LPPe_SRN_RequestAssistanceData_srnGroup_srnGroupRequest = SEQ(name='srnGroupRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupRequest')))
    __OMA_LPPe_SRN_RequestAssistanceData_srnGroup_srnGroupUpdateRequest = SEQ_OF(name='srnGroupUpdateRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUpdateRequest')))
    _OMA_LPPe_SRN_RequestAssistanceData_srnGroup._cont = ASN1Dict([
        ('srnGroupRequest', __OMA_LPPe_SRN_RequestAssistanceData_srnGroup_srnGroupRequest),
        ('srnGroupUpdateRequest', __OMA_LPPe_SRN_RequestAssistanceData_srnGroup_srnGroupUpdateRequest),
        ])
    _OMA_LPPe_SRN_RequestAssistanceData_srnGroup._ext = []
    _OMA_LPPe_SRN_RequestAssistanceData_antennaPatternRequest = SEQ_OF(name='antennaPatternRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-AntennaPatternRequest')), opt=True)
    OMA_LPPe_SRN_RequestAssistanceData._cont = ASN1Dict([
        ('srnGroup', _OMA_LPPe_SRN_RequestAssistanceData_srnGroup),
        ('antennaPatternRequest', _OMA_LPPe_SRN_RequestAssistanceData_antennaPatternRequest),
        ])
    OMA_LPPe_SRN_RequestAssistanceData._ext = []
    
    #-----< OMA-LPPe-SRN-SRNgroupRequest >-----#
    OMA_LPPe_SRN_SRNgroupRequest = SEQ(name='OMA-LPPe-SRN-SRNgroupRequest', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupRequest_doNotProvideList = SEQ(name='doNotProvideList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNProvideList')), opt=True)
    _OMA_LPPe_SRN_SRNgroupRequest_doProvideList = SEQ(name='doProvideList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNProvideList')), opt=True)
    OMA_LPPe_SRN_SRNgroupRequest._cont = ASN1Dict([
        ('doNotProvideList', _OMA_LPPe_SRN_SRNgroupRequest_doNotProvideList),
        ('doProvideList', _OMA_LPPe_SRN_SRNgroupRequest_doProvideList),
        ])
    OMA_LPPe_SRN_SRNgroupRequest._ext = []
    
    #-----< OMA-LPPe-SRN-SRNProvideList >-----#
    OMA_LPPe_SRN_SRNProvideList = SEQ(name='OMA-LPPe-SRN-SRNProvideList', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNProvideList_groupList = SEQ_OF(name='groupList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_SRNProvideList_groupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUniqueID')))
    _OMA_LPPe_SRN_SRNProvideList_groupList._cont = __OMA_LPPe_SRN_SRNProvideList_groupList__item_
    _OMA_LPPe_SRN_SRNProvideList_groupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _OMA_LPPe_SRN_SRNProvideList_categoryList = SEQ_OF(name='categoryList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_SRNProvideList_categoryList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')))
    _OMA_LPPe_SRN_SRNProvideList_categoryList._cont = __OMA_LPPe_SRN_SRNProvideList_categoryList__item_
    _OMA_LPPe_SRN_SRNProvideList_categoryList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_SRN_SRNProvideList._cont = ASN1Dict([
        ('groupList', _OMA_LPPe_SRN_SRNProvideList_groupList),
        ('categoryList', _OMA_LPPe_SRN_SRNProvideList_categoryList),
        ])
    OMA_LPPe_SRN_SRNProvideList._ext = []
    
    #-----< OMA-LPPe-SRN-SRNgroupUpdateRequest >-----#
    OMA_LPPe_SRN_SRNgroupUpdateRequest = SEQ_OF(name='OMA-LPPe-SRN-SRNgroupUpdateRequest', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupUpdateRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUpdateRequestElement')))
    OMA_LPPe_SRN_SRNgroupUpdateRequest._cont = _OMA_LPPe_SRN_SRNgroupUpdateRequest__item_
    OMA_LPPe_SRN_SRNgroupUpdateRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OMA-LPPe-SRN-SRNgroupUpdateRequestElement >-----#
    OMA_LPPe_SRN_SRNgroupUpdateRequestElement = SEQ(name='OMA-LPPe-SRN-SRNgroupUpdateRequestElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_srnGroupID = SEQ(name='srnGroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUniqueID')))
    _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_provideIndicationOnly = NULL(name='provideIndicationOnly', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup = SEQ_OF(name='inTheGroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNid')))
    _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup._cont = __OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup__item_
    _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    OMA_LPPe_SRN_SRNgroupUpdateRequestElement._cont = ASN1Dict([
        ('srnGroupID', _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_srnGroupID),
        ('provideIndicationOnly', _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_provideIndicationOnly),
        ('inTheGroup', _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup),
        ])
    OMA_LPPe_SRN_SRNgroupUpdateRequestElement._ext = []
    
    #-----< OMA-LPPe-SRN-AntennaPatternRequest >-----#
    OMA_LPPe_SRN_AntennaPatternRequest = SEQ_OF(name='OMA-LPPe-SRN-AntennaPatternRequest', mode=MODE_TYPE)
    _OMA_LPPe_SRN_AntennaPatternRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-AntennaPatternRequestElement')))
    OMA_LPPe_SRN_AntennaPatternRequest._cont = _OMA_LPPe_SRN_AntennaPatternRequest__item_
    OMA_LPPe_SRN_AntennaPatternRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< OMA-LPPe-SRN-AntennaPatternRequestElement >-----#
    OMA_LPPe_SRN_AntennaPatternRequestElement = SEQ(name='OMA-LPPe-SRN-AntennaPatternRequestElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID = SEQ(name='antennaPatternID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_vendorOrOperator = CHOICE(name='vendorOrOperator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_antennaPatternID = INT(name='antennaPatternID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_antennaPatternID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID._cont = ASN1Dict([
        ('vendorOrOperator', __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_vendorOrOperator),
        ('antennaPatternID', __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_antennaPatternID),
        ])
    _OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID._ext = []
    OMA_LPPe_SRN_AntennaPatternRequestElement._cont = ASN1Dict([
        ('antennaPatternID', _OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID),
        ])
    OMA_LPPe_SRN_AntennaPatternRequestElement._ext = []
    
    #-----< OMA-LPPe-SRN-ProvideLocationInformation >-----#
    OMA_LPPe_SRN_ProvideLocationInformation = SEQ(name='OMA-LPPe-SRN-ProvideLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList = SEQ_OF(name='srnMeasurementList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-MeasurementElement')))
    _OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList._cont = __OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList__item_
    _OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _OMA_LPPe_SRN_ProvideLocationInformation_srnError = CHOICE(name='srnError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Error')), opt=True)
    OMA_LPPe_SRN_ProvideLocationInformation._cont = ASN1Dict([
        ('srnMeasurementList', _OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList),
        ('srnError', _OMA_LPPe_SRN_ProvideLocationInformation_srnError),
        ])
    OMA_LPPe_SRN_ProvideLocationInformation._ext = []
    
    #-----< OMA-LPPe-SRN-MeasurementElement >-----#
    OMA_LPPe_SRN_MeasurementElement = SEQ(name='OMA-LPPe-SRN-MeasurementElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_MeasurementElement_srnID = SEQ(name='srnID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNid')))
    _OMA_LPPe_SRN_MeasurementElement_srnCategory = SEQ(name='srnCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')), opt=True)
    _OMA_LPPe_SRN_MeasurementElement_srnGroupID = SEQ(name='srnGroupID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-SRNgroupUniqueID')), opt=True)
    _OMA_LPPe_SRN_MeasurementElement_measurementList = SEQ_OF(name='measurementList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_MeasurementElement_measurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-srnMeasurementElement')))
    _OMA_LPPe_SRN_MeasurementElement_measurementList._cont = __OMA_LPPe_SRN_MeasurementElement_measurementList__item_
    _OMA_LPPe_SRN_MeasurementElement_measurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    OMA_LPPe_SRN_MeasurementElement._cont = ASN1Dict([
        ('srnID', _OMA_LPPe_SRN_MeasurementElement_srnID),
        ('srnCategory', _OMA_LPPe_SRN_MeasurementElement_srnCategory),
        ('srnGroupID', _OMA_LPPe_SRN_MeasurementElement_srnGroupID),
        ('measurementList', _OMA_LPPe_SRN_MeasurementElement_measurementList),
        ])
    OMA_LPPe_SRN_MeasurementElement._ext = []
    
    #-----< OMA-LPPe-SRN-srnMeasurementElement >-----#
    OMA_LPPe_SRN_srnMeasurementElement = SEQ(name='OMA-LPPe-SRN-srnMeasurementElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_srnMeasurementElement_relativeTimeStamp = INT(name='relativeTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_srnMeasurementElement_relativeTimeStamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    _OMA_LPPe_SRN_srnMeasurementElement_rssi = INT(name='rssi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_srnMeasurementElement_rssi._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    _OMA_LPPe_SRN_srnMeasurementElement_rtd = SEQ(name='rtd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-WLAN-RTD')), opt=True)
    OMA_LPPe_SRN_srnMeasurementElement._cont = ASN1Dict([
        ('relativeTimeStamp', _OMA_LPPe_SRN_srnMeasurementElement_relativeTimeStamp),
        ('rssi', _OMA_LPPe_SRN_srnMeasurementElement_rssi),
        ('rtd', _OMA_LPPe_SRN_srnMeasurementElement_rtd),
        ])
    OMA_LPPe_SRN_srnMeasurementElement._ext = []
    
    #-----< OMA-LPPe-SRN-RequestLocationInformation >-----#
    OMA_LPPe_SRN_RequestLocationInformation = SEQ(name='OMA-LPPe-SRN-RequestLocationInformation', mode=MODE_TYPE)
    _OMA_LPPe_SRN_RequestLocationInformation_requestInfo = SEQ_OF(name='requestInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_RequestLocationInformation_requestInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ReqLocInfo-Category')))
    _OMA_LPPe_SRN_RequestLocationInformation_requestInfo._cont = __OMA_LPPe_SRN_RequestLocationInformation_requestInfo__item_
    _OMA_LPPe_SRN_RequestLocationInformation_requestInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_SRN_RequestLocationInformation._cont = ASN1Dict([
        ('requestInfo', _OMA_LPPe_SRN_RequestLocationInformation_requestInfo),
        ])
    OMA_LPPe_SRN_RequestLocationInformation._ext = []
    
    #-----< OMA-LPPe-SRN-ReqLocInfo-Category >-----#
    OMA_LPPe_SRN_ReqLocInfo_Category = SEQ(name='OMA-LPPe-SRN-ReqLocInfo-Category', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ReqLocInfo_Category_category = SEQ(name='category', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')))
    _OMA_LPPe_SRN_ReqLocInfo_Category_multipleMeasurements = ENUM(name='multipleMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_ReqLocInfo_Category_multipleMeasurements._cont = ASN1Dict([('forbidden', 0), ('allowed', 1), ('requested', 2)])
    _OMA_LPPe_SRN_ReqLocInfo_Category_multipleMeasurements._ext = []
    _OMA_LPPe_SRN_ReqLocInfo_Category_allowedMeasurements = SEQ(name='allowedMeasurements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-MeasurementMask')), opt=True)
    _OMA_LPPe_SRN_ReqLocInfo_Category_historicMeasurementsRequested = NULL(name='historicMeasurementsRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_SRN_ReqLocInfo_Category._cont = ASN1Dict([
        ('category', _OMA_LPPe_SRN_ReqLocInfo_Category_category),
        ('multipleMeasurements', _OMA_LPPe_SRN_ReqLocInfo_Category_multipleMeasurements),
        ('allowedMeasurements', _OMA_LPPe_SRN_ReqLocInfo_Category_allowedMeasurements),
        ('historicMeasurementsRequested', _OMA_LPPe_SRN_ReqLocInfo_Category_historicMeasurementsRequested),
        ])
    OMA_LPPe_SRN_ReqLocInfo_Category._ext = []
    
    #-----< OMA-LPPe-SRN-ProvideCapabilities >-----#
    OMA_LPPe_SRN_ProvideCapabilities = SEQ(name='OMA-LPPe-SRN-ProvideCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory = SEQ_OF(name='capabilitiesPerSRNCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-ProvideCapabilitiesElement')))
    _OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory._cont = __OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory__item_
    _OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_SRN_ProvideCapabilities._cont = ASN1Dict([
        ('capabilitiesPerSRNCategory', _OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory),
        ])
    OMA_LPPe_SRN_ProvideCapabilities._ext = []
    
    #-----< OMA-LPPe-SRN-ProvideCapabilitiesElement >-----#
    OMA_LPPe_SRN_ProvideCapabilitiesElement = SEQ(name='OMA-LPPe-SRN-ProvideCapabilitiesElement', mode=MODE_TYPE)
    _OMA_LPPe_SRN_ProvideCapabilitiesElement_srnCategory = SEQ(name='srnCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')))
    _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedMeasurements = SEQ(name='supportedMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-MeasurementMask')), opt=True)
    _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedAssistanceData = BIT_STR(name='supportedAssistanceData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedAssistanceData._cont = ASN1Dict([('srnGroup', 0), ('antennaPattern', 1)])
    _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _OMA_LPPe_SRN_ProvideCapabilitiesElement_historicMeasurementsSupported = NULL(name='historicMeasurementsSupported', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_SRN_ProvideCapabilitiesElement._cont = ASN1Dict([
        ('srnCategory', _OMA_LPPe_SRN_ProvideCapabilitiesElement_srnCategory),
        ('supportedMeasurements', _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedMeasurements),
        ('supportedAssistanceData', _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedAssistanceData),
        ('historicMeasurementsSupported', _OMA_LPPe_SRN_ProvideCapabilitiesElement_historicMeasurementsSupported),
        ])
    OMA_LPPe_SRN_ProvideCapabilitiesElement._ext = []
    
    #-----< OMA-LPPe-SRN-RequestCapabilities >-----#
    OMA_LPPe_SRN_RequestCapabilities = SEQ(name='OMA-LPPe-SRN-RequestCapabilities', mode=MODE_TYPE)
    _OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor = SEQ_OF(name='capabilitiesRequestedFor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')))
    _OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor._cont = __OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor__item_
    _OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_SRN_RequestCapabilities._cont = ASN1Dict([
        ('capabilitiesRequestedFor', _OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor),
        ])
    OMA_LPPe_SRN_RequestCapabilities._ext = []
    
    #-----< OMA-LPPe-SRN-Error >-----#
    OMA_LPPe_SRN_Error = CHOICE(name='OMA-LPPe-SRN-Error', mode=MODE_TYPE)
    _OMA_LPPe_SRN_Error_srnLocationServerErrorCauses = SEQ(name='srnLocationServerErrorCauses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-LocationServerErrorCauses')))
    _OMA_LPPe_SRN_Error_srnTargetDeviceErrorCauses = SEQ(name='srnTargetDeviceErrorCauses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-TargetDeviceErrorCauses')))
    OMA_LPPe_SRN_Error._cont = ASN1Dict([
        ('srnLocationServerErrorCauses', _OMA_LPPe_SRN_Error_srnLocationServerErrorCauses),
        ('srnTargetDeviceErrorCauses', _OMA_LPPe_SRN_Error_srnTargetDeviceErrorCauses),
        ])
    OMA_LPPe_SRN_Error._ext = []
    
    #-----< OMA-LPPe-SRN-LocationServerErrorCauses >-----#
    OMA_LPPe_SRN_LocationServerErrorCauses = SEQ(name='OMA-LPPe-SRN-LocationServerErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_SRN_LocationServerErrorCauses_groupErrors = ENUM(name='groupErrors', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_LocationServerErrorCauses_groupErrors._cont = ASN1Dict([('undefined', 0), ('someGroupOrCategoryOrSRNidUnknownOrUnsupported', 1), ('allGroupAndCategoryOrSRNidUnknownOrUnsupported', 2), ('noSRNgroupsNearby', 3)])
    _OMA_LPPe_SRN_LocationServerErrorCauses_groupErrors._ext = []
    _OMA_LPPe_SRN_LocationServerErrorCauses_groupUpdateErrors = ENUM(name='groupUpdateErrors', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_LocationServerErrorCauses_groupUpdateErrors._cont = ASN1Dict([('undefined', 0), ('allSRNgroupIDsUnknown', 1), ('allSRNgroupIDsknownButSomeSRNgroupVersionsUnknown', 2), ('allSRNgroupIDsknownAndAllSRNgroupVersionsUnknown', 3), ('someSRNgroupIDsUnknown', 4), ('someSRNgroupVersionsUnknownAndAllSRNGroupVersionsUnknown', 5), ('someSRNgroupIDsAndSomeSRNgroupVersionsUnknown', 6), ('inTheGroupInformationDoesNotMatchWithGroupID', 7)])
    _OMA_LPPe_SRN_LocationServerErrorCauses_groupUpdateErrors._ext = []
    _OMA_LPPe_SRN_LocationServerErrorCauses_srnAntennaErrors = ENUM(name='srnAntennaErrors', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_LocationServerErrorCauses_srnAntennaErrors._cont = ASN1Dict([('undefined', 0), ('someAntennaPatternIDsUnknown', 1), ('allAntennaPatternIDsUnknown', 2)])
    _OMA_LPPe_SRN_LocationServerErrorCauses_srnAntennaErrors._ext = []
    OMA_LPPe_SRN_LocationServerErrorCauses._cont = ASN1Dict([
        ('groupErrors', _OMA_LPPe_SRN_LocationServerErrorCauses_groupErrors),
        ('groupUpdateErrors', _OMA_LPPe_SRN_LocationServerErrorCauses_groupUpdateErrors),
        ('srnAntennaErrors', _OMA_LPPe_SRN_LocationServerErrorCauses_srnAntennaErrors),
        ])
    OMA_LPPe_SRN_LocationServerErrorCauses._ext = []
    
    #-----< OMA-LPPe-SRN-TargetDeviceErrorCauses >-----#
    OMA_LPPe_SRN_TargetDeviceErrorCauses = SEQ(name='OMA-LPPe-SRN-TargetDeviceErrorCauses', mode=MODE_TYPE)
    _OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory = SEQ_OF(name='srnErrorsPerCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-TargetDeviceError')))
    _OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory._cont = __OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory__item_
    _OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_SRN_TargetDeviceErrorCauses._cont = ASN1Dict([
        ('srnErrorsPerCategory', _OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory),
        ])
    OMA_LPPe_SRN_TargetDeviceErrorCauses._ext = []
    
    #-----< OMA-LPPe-SRN-TargetDeviceError >-----#
    OMA_LPPe_SRN_TargetDeviceError = SEQ(name='OMA-LPPe-SRN-TargetDeviceError', mode=MODE_TYPE)
    _OMA_LPPe_SRN_TargetDeviceError_category = SEQ(name='category', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')))
    _OMA_LPPe_SRN_TargetDeviceError_srnErrors = ENUM(name='srnErrors', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_TargetDeviceError_srnErrors._cont = ASN1Dict([('undefined', 0), ('requestedMeasurementsNotAvailable', 1), ('notAllrequestedMeasurementsPossible', 2), ('categoryNotSupported', 3)])
    _OMA_LPPe_SRN_TargetDeviceError_srnErrors._ext = []
    _OMA_LPPe_SRN_TargetDeviceError_rssiNotAvailable = NULL(name='rssiNotAvailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_TargetDeviceError_rtdNotAvailable = NULL(name='rtdNotAvailable', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_TargetDeviceError_multipleSetsNotAvailable = NULL(name='multipleSetsNotAvailable', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_TargetDeviceError_historicMeasurementsNotAvailable = NULL(name='historicMeasurementsNotAvailable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OMA_LPPe_SRN_TargetDeviceError._cont = ASN1Dict([
        ('category', _OMA_LPPe_SRN_TargetDeviceError_category),
        ('srnErrors', _OMA_LPPe_SRN_TargetDeviceError_srnErrors),
        ('rssiNotAvailable', _OMA_LPPe_SRN_TargetDeviceError_rssiNotAvailable),
        ('rtdNotAvailable', _OMA_LPPe_SRN_TargetDeviceError_rtdNotAvailable),
        ('multipleSetsNotAvailable', _OMA_LPPe_SRN_TargetDeviceError_multipleSetsNotAvailable),
        ('historicMeasurementsNotAvailable', _OMA_LPPe_SRN_TargetDeviceError_historicMeasurementsNotAvailable),
        ])
    OMA_LPPe_SRN_TargetDeviceError._ext = []
    
    #-----< OMA-LPPe-SRN-SRNgroupUniqueID >-----#
    OMA_LPPe_SRN_SRNgroupUniqueID = SEQ(name='OMA-LPPe-SRN-SRNgroupUniqueID', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNgroupUniqueID_providerID = CHOICE(name='providerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    _OMA_LPPe_SRN_SRNgroupUniqueID_providerAssignedID = OCT_STR(name='providerAssignedID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_SRNgroupUniqueID_srnDataVersion = INT(name='srnDataVersion', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_SRNgroupUniqueID_srnDataVersion._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    OMA_LPPe_SRN_SRNgroupUniqueID._cont = ASN1Dict([
        ('providerID', _OMA_LPPe_SRN_SRNgroupUniqueID_providerID),
        ('providerAssignedID', _OMA_LPPe_SRN_SRNgroupUniqueID_providerAssignedID),
        ('srnDataVersion', _OMA_LPPe_SRN_SRNgroupUniqueID_srnDataVersion),
        ])
    OMA_LPPe_SRN_SRNgroupUniqueID._ext = []
    
    #-----< OMA-LPPe-SRN-SRNtype >-----#
    OMA_LPPe_SRN_SRNtype = SEQ(name='OMA-LPPe-SRN-SRNtype', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNtype_srnCategory = SEQ(name='srnCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Category')))
    _OMA_LPPe_SRN_SRNtype_srnERP = INT(name='srnERP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_SRNtype_srnERP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-300, ub=500)], ev=None, er=[])
    _OMA_LPPe_SRN_SRNtype_srnAntennaInfo = SEQ(name='srnAntennaInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_antennaPatternID = INT(name='antennaPatternID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_antennaPatternID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_switchingPatternID = INT(name='switchingPatternID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_switchingPatternID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _OMA_LPPe_SRN_SRNtype_srnAntennaInfo._cont = ASN1Dict([
        ('antennaPatternID', __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_antennaPatternID),
        ('switchingPatternID', __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_switchingPatternID),
        ])
    _OMA_LPPe_SRN_SRNtype_srnAntennaInfo._ext = []
    OMA_LPPe_SRN_SRNtype._cont = ASN1Dict([
        ('srnCategory', _OMA_LPPe_SRN_SRNtype_srnCategory),
        ('srnERP', _OMA_LPPe_SRN_SRNtype_srnERP),
        ('srnAntennaInfo', _OMA_LPPe_SRN_SRNtype_srnAntennaInfo),
        ])
    OMA_LPPe_SRN_SRNtype._ext = []
    
    #-----< OMA-LPPe-SRN-Category >-----#
    OMA_LPPe_SRN_Category = SEQ(name='OMA-LPPe-SRN-Category', mode=MODE_TYPE)
    _OMA_LPPe_SRN_Category_srnTechnologyType = SEQ(name='srnTechnologyType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-SRN-Technologies')))
    _OMA_LPPe_SRN_Category_srnVendorInformation = SEQ(name='srnVendorInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OMA_LPPe_SRN_Category_srnVendorInformation_vendor = CHOICE(name='vendor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OMA-LPPE', 'OMA-LPPe-VendorOrOperatorID')))
    __OMA_LPPe_SRN_Category_srnVendorInformation_vendorInfo = OCT_STR(name='vendorInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OMA_LPPe_SRN_Category_srnVendorInformation._cont = ASN1Dict([
        ('vendor', __OMA_LPPe_SRN_Category_srnVendorInformation_vendor),
        ('vendorInfo', __OMA_LPPe_SRN_Category_srnVendorInformation_vendorInfo),
        ])
    _OMA_LPPe_SRN_Category_srnVendorInformation._ext = []
    OMA_LPPe_SRN_Category._cont = ASN1Dict([
        ('srnTechnologyType', _OMA_LPPe_SRN_Category_srnTechnologyType),
        ('srnVendorInformation', _OMA_LPPe_SRN_Category_srnVendorInformation),
        ])
    OMA_LPPe_SRN_Category._ext = []
    
    #-----< OMA-LPPe-SRN-SRNid >-----#
    OMA_LPPe_SRN_SRNid = SEQ(name='OMA-LPPe-SRN-SRNid', mode=MODE_TYPE)
    _OMA_LPPe_SRN_SRNid_srn_id = CHOICE(name='srn-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OMA_LPPe_SRN_SRNid_srn_id_mac = BIT_STR(name='mac', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __OMA_LPPe_SRN_SRNid_srn_id_mac._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    __OMA_LPPe_SRN_SRNid_srn_id_nfc = SEQ(name='nfc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_nfc_manufacturer = BIT_STR(name='manufacturer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_nfc_manufacturer._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    ___OMA_LPPe_SRN_SRNid_srn_id_nfc_uniqueNumber = BIT_STR(name='uniqueNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_nfc_uniqueNumber._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    __OMA_LPPe_SRN_SRNid_srn_id_nfc._cont = ASN1Dict([
        ('manufacturer', ___OMA_LPPe_SRN_SRNid_srn_id_nfc_manufacturer),
        ('uniqueNumber', ___OMA_LPPe_SRN_SRNid_srn_id_nfc_uniqueNumber),
        ])
    __OMA_LPPe_SRN_SRNid_srn_id_nfc._ext = []
    __OMA_LPPe_SRN_SRNid_srn_id_mobileCode = SEQ(name='mobileCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_registryID = BIT_STR(name='registryID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_registryID._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_remainingPart = OCT_STR(name='remainingPart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_remainingPart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_resolutionIdentifier = OCT_STR(name='resolutionIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_resolutionIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=18)], ev=None, er=[])
    __OMA_LPPe_SRN_SRNid_srn_id_mobileCode._cont = ASN1Dict([
        ('registryID', ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_registryID),
        ('remainingPart', ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_remainingPart),
        ('resolutionIdentifier', ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_resolutionIdentifier),
        ])
    __OMA_LPPe_SRN_SRNid_srn_id_mobileCode._ext = []
    __OMA_LPPe_SRN_SRNid_srn_id_other = OCT_STR(name='other', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_SRNid_srn_id._cont = ASN1Dict([
        ('mac', __OMA_LPPe_SRN_SRNid_srn_id_mac),
        ('nfc', __OMA_LPPe_SRN_SRNid_srn_id_nfc),
        ('mobileCode', __OMA_LPPe_SRN_SRNid_srn_id_mobileCode),
        ('other', __OMA_LPPe_SRN_SRNid_srn_id_other),
        ])
    _OMA_LPPe_SRN_SRNid_srn_id._ext = []
    OMA_LPPe_SRN_SRNid._cont = ASN1Dict([
        ('srn-id', _OMA_LPPe_SRN_SRNid_srn_id),
        ])
    OMA_LPPe_SRN_SRNid._ext = []
    
    #-----< OMA-LPPe-SRN-Technologies >-----#
    OMA_LPPe_SRN_Technologies = SEQ(name='OMA-LPPe-SRN-Technologies', mode=MODE_TYPE)
    _OMA_LPPe_SRN_Technologies_srnTechnologies = ENUM(name='srnTechnologies', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_Technologies_srnTechnologies._cont = ASN1Dict([('bt', 0), ('btle', 1), ('nfc', 2), ('mobileCode', 3), ('other', 4)])
    _OMA_LPPe_SRN_Technologies_srnTechnologies._ext = []
    OMA_LPPe_SRN_Technologies._cont = ASN1Dict([
        ('srnTechnologies', _OMA_LPPe_SRN_Technologies_srnTechnologies),
        ])
    OMA_LPPe_SRN_Technologies._ext = []
    
    #-----< OMA-LPPe-SRN-MeasurementMask >-----#
    OMA_LPPe_SRN_MeasurementMask = SEQ(name='OMA-LPPe-SRN-MeasurementMask', mode=MODE_TYPE)
    _OMA_LPPe_SRN_MeasurementMask_srnMeasurements = BIT_STR(name='srnMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OMA_LPPe_SRN_MeasurementMask_srnMeasurements._cont = ASN1Dict([('rssi', 0), ('rtd', 1)])
    _OMA_LPPe_SRN_MeasurementMask_srnMeasurements._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    OMA_LPPe_SRN_MeasurementMask._cont = ASN1Dict([
        ('srnMeasurements', _OMA_LPPe_SRN_MeasurementMask_srnMeasurements),
        ])
    OMA_LPPe_SRN_MeasurementMask._ext = []
    
    _all_ = [
        _OMA_LPPe_MessageExtension_lppeCompatibilityLevel,
        _OMA_LPPe_MessageExtension_lppeVersion,
        _OMA_LPPe_MessageExtension_lppeMode,
        _OMA_LPPe_MessageExtension_messageExtensionBody,
        OMA_LPPe_MessageExtension,
        OMA_LPPe_LPPeCompatibilityLevel,
        _OMA_LPPe_LPPeVersion_majorVersion,
        _OMA_LPPe_LPPeVersion_minorVersion,
        OMA_LPPe_LPPeVersion,
        OMA_LPPe_LPPeMode,
        _OMA_LPPe_MessageExtensionBody_requestCapabilities,
        _OMA_LPPe_MessageExtensionBody_provideCapabilities,
        _OMA_LPPe_MessageExtensionBody_requestAssistanceData,
        _OMA_LPPe_MessageExtensionBody_provideAssistanceData,
        _OMA_LPPe_MessageExtensionBody_requestLocationInformation,
        _OMA_LPPe_MessageExtensionBody_provideLocationInformation,
        _OMA_LPPe_MessageExtensionBody_error,
        _OMA_LPPe_MessageExtensionBody_abort,
        OMA_LPPe_MessageExtensionBody,
        _OMA_LPPe_ver1_1_BroadcastContainer_digitalSignature,
        _OMA_LPPe_ver1_1_BroadcastContainer_messageContents,
        OMA_LPPe_ver1_1_BroadcastContainer,
        _OMA_LPPe_ver1_1_BroadcastMessage_broadcastControlIEs,
        _OMA_LPPe_ver1_1_BroadcastMessage_cipheringIEs,
        _OMA_LPPe_ver1_1_BroadcastMessage_broadcastMessage,
        OMA_LPPe_ver1_1_BroadcastMessage,
        _OMA_LPPe_ver1_1_BroadcastControlIEs_serverID,
        _OMA_LPPe_ver1_1_BroadcastControlIEs_messageID,
        _OMA_LPPe_ver1_1_BroadcastControlIEs_validity_time,
        _OMA_LPPe_ver1_1_BroadcastControlIEs_validity_area,
        _OMA_LPPe_ver1_1_BroadcastControlIEs_broadcastADTypes,
        OMA_LPPe_ver1_1_BroadcastControlIEs,
        _OMA_LPPe_ver1_1_CipheringIEs_cipherSetID,
        _OMA_LPPe_ver1_1_CipheringIEs_d0,
        OMA_LPPe_ver1_1_CipheringIEs,
        _OMA_LPPe_ver1_1_DigitalSignature_authenticationSetID,
        _OMA_LPPe_ver1_1_DigitalSignature_signature,
        OMA_LPPe_ver1_1_DigitalSignature,
        _OMA_LPPe_RequestCapabilities_commonIEsRequestCapabilities,
        _OMA_LPPe_RequestCapabilities_agnss_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_otdoa_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_eotd_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_otdoa_utra_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_ecid_lte_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_ecid_gsm_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_ecid_utra_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_wlan_ap_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_ecid_wimax_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_sensor_RequestCapabilities,
        _OMA_LPPe_RequestCapabilities_srn_RequestCapabilities,
        OMA_LPPe_RequestCapabilities,
        _OMA_LPPe_ProvideCapabilities_commonIEsProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_agnss_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_otdoa_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_eotd_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_otdoa_utra_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_ecid_lte_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_ecid_gsm_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_ecid_utra_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_wlan_ap_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_ecid_wimax_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_sensor_ProvideCapabilities,
        _OMA_LPPe_ProvideCapabilities_srn_ProvideCapabilities,
        OMA_LPPe_ProvideCapabilities,
        _OMA_LPPe_RequestAssistanceData_commonIEsRequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_agnss_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_otdoa_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_eotd_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_otdoa_utra_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_ecid_lte_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_ecid_gsm_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_ecid_utra_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_wlan_ap_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_sensor_RequestAssistanceData,
        _OMA_LPPe_RequestAssistanceData_srn_RequestAssistanceData,
        OMA_LPPe_RequestAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_commonIEsProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_agnss_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_otdoa_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_eotd_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_otdoa_utra_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_ecid_lte_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_ecid_gsm_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_ecid_utra_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_wlan_ap_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_sensor_ProvideAssistanceData,
        _OMA_LPPe_ProvideAssistanceData_srn_ProvideAssistanceData,
        OMA_LPPe_ProvideAssistanceData,
        _OMA_LPPe_RequestLocationInformation_commonIEsRequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_agnss_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_otdoa_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_eotd_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_otdoa_utra_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_ecid_lte_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_ecid_gsm_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_ecid_utra_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_wlan_ap_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_ecid_wimax_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_sensor_RequestLocationInformation,
        _OMA_LPPe_RequestLocationInformation_srn_RequestLocationInformation,
        OMA_LPPe_RequestLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_commonIEsProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_agnss_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_otdoa_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_eotd_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_otdoa_utra_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_ecid_lte_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_ecid_gsm_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_ecid_utra_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_wlan_ap_ProvideLocationInformastion,
        _OMA_LPPe_ProvideLocationInformation_ecid_wimax_ProvideLocationInformastion,
        _OMA_LPPe_ProvideLocationInformation_sensor_ProvideLocationInformation,
        _OMA_LPPe_ProvideLocationInformation_srn_ProvideLocationInformation,
        OMA_LPPe_ProvideLocationInformation,
        _OMA_LPPe_Abort_commonIEsAbort,
        _OMA_LPPe_Abort_agnssAbort,
        OMA_LPPe_Abort,
        _OMA_LPPe_Error_commonIEsError,
        OMA_LPPe_Error,
        _OMA_LPPe_AssistanceContainer_DataSerialNumber_dataSerialNumber,
        OMA_LPPe_AssistanceContainer_DataSerialNumber,
        _OMA_LPPe_AssistanceContainerID_containerID,
        OMA_LPPe_AssistanceContainerID,
        _OMA_LPPe_AssistanceContainerProvideList__item_,
        OMA_LPPe_AssistanceContainerProvideList,
        maxAssistanceContainerList,
        _OMA_LPPe_AssistanceContainerProvide_dataIdentifier,
        _OMA_LPPe_AssistanceContainerProvide_checkOrUpdateOrError,
        __OMA_LPPe_AssistanceContainerProvide_dataResult_simulationResult,
        __OMA_LPPe_AssistanceContainerProvide_dataResult_data,
        _OMA_LPPe_AssistanceContainerProvide_dataResult,
        _OMA_LPPe_AssistanceContainerProvide_errorCode,
        OMA_LPPe_AssistanceContainerProvide,
        _OMA_LPPe_AssistanceContainerData_dataSerialNumber,
        _OMA_LPPe_AssistanceContainerData_data,
        _OMA_LPPe_AssistanceContainerData_validityPeriod,
        _OMA_LPPe_AssistanceContainerData_validityArea,
        OMA_LPPe_AssistanceContainerData,
        _OMA_LPPe_AssistanceContainerProvideError_serverError,
        OMA_LPPe_AssistanceContainerProvideError,
        _OMA_LPPe_AssistanceContainerRequestList__item_,
        OMA_LPPe_AssistanceContainerRequestList,
        _OMA_LPPe_AssistanceContainerRequest_dataIdentifier,
        _OMA_LPPe_AssistanceContainerRequest_simulatedReq,
        _OMA_LPPe_AssistanceContainerRequest_checkOrUpdateReq,
        _OMA_LPPe_AssistanceContainerRequest_validityTimeRequest,
        _OMA_LPPe_AssistanceContainerRequest_proprietaryRequestParameters,
        OMA_LPPe_AssistanceContainerRequest,
        _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_dataSerialNumber,
        _OMA_LPPe_AssistanceContainerCheckOrUpdateReq_checkLatest,
        OMA_LPPe_AssistanceContainerCheckOrUpdateReq,
        _OMA_LPPe_CellLocalIdGERAN_locationAreaCode,
        _OMA_LPPe_CellLocalIdGERAN_cellIdentity,
        OMA_LPPe_CellLocalIdGERAN,
        _OMA_LPPe_CellNonUniqueIDGERAN_bsic,
        _OMA_LPPe_CellNonUniqueIDGERAN_bcch,
        OMA_LPPe_CellNonUniqueIDGERAN,
        OMA_LPPe_CharArray,
        _OMA_LPPe_CivicLocation_countryCode,
        _OMA_LPPe_CivicLocation_civicAddressElementList,
        OMA_LPPe_CivicLocation,
        _OMA_LPPe_CivicAddressElementList__item_,
        OMA_LPPe_CivicAddressElementList,
        _OMA_LPPe_CivicAddressElement_caType,
        _OMA_LPPe_CivicAddressElement_caValue,
        OMA_LPPe_CivicAddressElement,
        _OMA_LPPe_Duration_duration,
        _OMA_LPPe_Duration_durationLSB,
        OMA_LPPe_Duration,
        OMA_LPPe_FixedAccessTypes,
        _OMA_LPPe_ver1_1_GroundMorphologyModel_altitudeModel,
        _OMA_LPPe_ver1_1_GroundMorphologyModel_buildingsProfileModel,
        OMA_LPPe_ver1_1_GroundMorphologyModel,
        _OMA_LPPe_ver1_1_AltitudeModel_northWestCorner,
        _OMA_LPPe_ver1_1_AltitudeModel_northwestCornerAltitude,
        _OMA_LPPe_ver1_1_AltitudeModel_nrows,
        _OMA_LPPe_ver1_1_AltitudeModel_ncols,
        _OMA_LPPe_ver1_1_AltitudeModel_spanX,
        _OMA_LPPe_ver1_1_AltitudeModel_spanY,
        _OMA_LPPe_ver1_1_AltitudeModel_deltaAltUnits,
        __OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid__item_,
        _OMA_LPPe_ver1_1_AltitudeModel_altitudeGrid,
        OMA_LPPe_ver1_1_AltitudeModel,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_northWestCorner,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_northwestCornerHeigth,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_nrows,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_ncols,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_spanX,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_spanY,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_deltaHeigthUnits,
        __OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid__item_,
        _OMA_LPPe_ver1_1_BuildingsHeightModel_buildingsHeigthGrid,
        OMA_LPPe_ver1_1_BuildingsHeightModel,
        _DeltaAltitudes_deltaAlt,
        _DeltaAltitudes_numGridPoints,
        DeltaAltitudes,
        _DeltaHeight_deltaHeight,
        _DeltaHeight_numGridPoints,
        DeltaHeight,
        _OMA_LPPe_ver1_1_CellGlobalID_eUTRA,
        _OMA_LPPe_ver1_1_CellGlobalID_uTRA,
        _OMA_LPPe_ver1_1_CellGlobalID_gSM,
        OMA_LPPe_ver1_1_CellGlobalID,
        _OMA_LPPe_HighAccuracy3Dposition_latitude,
        _OMA_LPPe_HighAccuracy3Dposition_longitude,
        _OMA_LPPe_HighAccuracy3Dposition_cep,
        _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semimajor,
        _OMA_LPPe_HighAccuracy3Dposition_uncertainty_semiminor,
        _OMA_LPPe_HighAccuracy3Dposition_offset_angle,
        _OMA_LPPe_HighAccuracy3Dposition_confidenceHorizontal,
        _OMA_LPPe_HighAccuracy3Dposition_altitude,
        _OMA_LPPe_HighAccuracy3Dposition_uncertainty_altitude,
        _OMA_LPPe_HighAccuracy3Dposition_confidenceVertical,
        OMA_LPPe_HighAccuracy3Dposition,
        _OMA_LPPe_HighAccuracy3Dvelocity_enu_origin,
        _OMA_LPPe_HighAccuracy3Dvelocity_east_component,
        _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_east,
        _OMA_LPPe_HighAccuracy3Dvelocity_north_component,
        _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_north,
        _OMA_LPPe_HighAccuracy3Dvelocity_up_component,
        _OMA_LPPe_HighAccuracy3Dvelocity_negative_sign_up,
        _OMA_LPPe_HighAccuracy3Dvelocity_cep,
        _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semimajor,
        _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_semiminor,
        _OMA_LPPe_HighAccuracy3Dvelocity_offset_angle,
        _OMA_LPPe_HighAccuracy3Dvelocity_confidenceHorizontal,
        _OMA_LPPe_HighAccuracy3Dvelocity_uncertainty_up_component,
        _OMA_LPPe_HighAccuracy3Dvelocity_confidenceUp,
        OMA_LPPe_HighAccuracy3Dvelocity,
        _OMA_LPPe_LocationInformationContainerID_containerID,
        OMA_LPPe_LocationInformationContainerID,
        _OMA_LPPe_LocationInformationContainer_vendorOrOperatorID,
        _OMA_LPPe_LocationInformationContainer_locationInformationContainerDataList,
        OMA_LPPe_LocationInformationContainer,
        _OMA_LPPe_LocationInformationContainerDataList__item_,
        OMA_LPPe_LocationInformationContainerDataList,
        _OMA_LPPe_LocationInformationContainerData_containerID,
        _OMA_LPPe_LocationInformationContainerData_containerData,
        OMA_LPPe_LocationInformationContainerData,
        _OMA_LPPe_LocationInformationContainerRequest_vendorOrOperatorID,
        _OMA_LPPe_LocationInformationContainerRequest_locationInformationContainerRequestList,
        OMA_LPPe_LocationInformationContainerRequest,
        _OMA_LPPe_LocationInformationContainerRequestList__item_,
        OMA_LPPe_LocationInformationContainerRequestList,
        maxLocationInformationContainerDataList,
        _OMA_LPPe_LocationInformationContainerRequestItem_containerID,
        _OMA_LPPe_LocationInformationContainerRequestItem_additionalInformation,
        OMA_LPPe_LocationInformationContainerRequestItem,
        _OMA_LPPe_MapDataReference_dataID,
        _OMA_LPPe_MapDataReference_mapReference,
        _OMA_LPPe_MapDataReference_mapSize,
        OMA_LPPe_MapDataReference,
        __OMA_LPPe_Orientation_eulerAngles_alpha,
        __OMA_LPPe_Orientation_eulerAngles_beta,
        __OMA_LPPe_Orientation_eulerAngles_gamma,
        _OMA_LPPe_Orientation_eulerAngles,
        OMA_LPPe_Orientation,
        _OMA_LPPe_ReferencePoint_referencePointUniqueID,
        __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_location3D,
        __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_location3DwithUncertainty,
        __OMA_LPPe_ReferencePoint_referencePointGeographicLocation_locationwithhighaccuracy,
        _OMA_LPPe_ReferencePoint_referencePointGeographicLocation,
        _OMA_LPPe_ReferencePoint_referencePointCivicLocation,
        _OMA_LPPe_ReferencePoint_referencePointFloorLevel,
        __OMA_LPPe_ReferencePoint_relatedReferencePoints__item_,
        _OMA_LPPe_ReferencePoint_relatedReferencePoints,
        _OMA_LPPe_ReferencePoint_mapDataInformation,
        OMA_LPPe_ReferencePoint,
        _OMA_LPPe_MapDataInformation__item_,
        OMA_LPPe_MapDataInformation,
        __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataUrl,
        __OMA_LPPe_MapDataReferenceElement_mapDataUrl_mapDataRef,
        _OMA_LPPe_MapDataReferenceElement_mapDataUrl,
        __OMA_LPPe_MapDataReferenceElement_mapProvider_sameAsRefPointProvider,
        __OMA_LPPe_MapDataReferenceElement_mapProvider_notSameAsRefPointProvider,
        _OMA_LPPe_MapDataReferenceElement_mapProvider,
        __OMA_LPPe_MapDataReferenceElement_mapAssociation_referencePointUniqueID,
        __OMA_LPPe_MapDataReferenceElement_mapAssociation_otherID,
        __OMA_LPPe_MapDataReferenceElement_mapAssociation_mapOffset,
        __OMA_LPPe_MapDataReferenceElement_mapAssociation_origin,
        _OMA_LPPe_MapDataReferenceElement_mapAssociation,
        _OMA_LPPe_MapDataReferenceElement_mapHorizontalOrientation,
        OMA_LPPe_MapDataReferenceElement,
        _OMA_LPPe_ReferencePointRelationship_referencePointUniqueID,
        _OMA_LPPe_ReferencePointRelationship_relativeLocation,
        OMA_LPPe_ReferencePointRelationship,
        _OMA_LPPe_ReferencePointUniqueID_providerID,
        _OMA_LPPe_ReferencePointUniqueID_providerAssignedID,
        _OMA_LPPe_ReferencePointUniqueID_version,
        OMA_LPPe_ReferencePointUniqueID,
        _OMA_LPPe_RelativeLocation_units,
        _OMA_LPPe_RelativeLocation_arc_second_units,
        _OMA_LPPe_RelativeLocation_relativeNorth,
        _OMA_LPPe_RelativeLocation_relativeEast,
        _OMA_LPPe_RelativeLocation_relativeAltitude,
        _OMA_LPPe_RelativeLocation_horizontalUncertainty,
        OMA_LPPe_RelativeLocation,
        __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_circle,
        ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semimajor,
        ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_semiminor,
        ___OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse_offsetAngle,
        __OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape_ellipse,
        _OMA_LPPe_HorizontalUncertaintyAndConfidence_uncShape,
        _OMA_LPPe_HorizontalUncertaintyAndConfidence_confidence,
        OMA_LPPe_HorizontalUncertaintyAndConfidence,
        _OMA_LPPe_RelativeAltitude_geodeticRelativeAltitude,
        _OMA_LPPe_RelativeAltitude_civicRelativeAltitude,
        OMA_LPPe_RelativeAltitude,
        _OMA_LPPe_GeodeticRelativeAltitude_geodetic_height_depth,
        _OMA_LPPe_GeodeticRelativeAltitude_geodetic_uncertainty_and_confidence,
        OMA_LPPe_GeodeticRelativeAltitude,
        _OMA_LPPe_GeodeticUncertaintyAndConfidence_uncertainty,
        _OMA_LPPe_GeodeticUncertaintyAndConfidence_confidence,
        OMA_LPPe_GeodeticUncertaintyAndConfidence,
        _OMA_LPPe_CivicRelativeAltitude_civic_floors,
        _OMA_LPPe_CivicRelativeAltitude_civic_uncertainty_and_confidence,
        OMA_LPPe_CivicRelativeAltitude,
        _OMA_LPPe_CivicUncertaintyAndConfidence_uncertainty,
        _OMA_LPPe_CivicUncertaintyAndConfidence_confidence,
        OMA_LPPe_CivicUncertaintyAndConfidence,
        _OMA_LPPe_Session_ID_provider_ID,
        _OMA_LPPe_Session_ID_server_ID,
        _OMA_LPPe_Session_ID_session_ID,
        OMA_LPPe_Session_ID,
        OMA_LPPe_Uri,
        _OMA_LPPe_ver1_1_BroadcastSystemID_standardSystemID,
        __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_vendorOrOperator,
        __OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID_proprietarySystemID,
        _OMA_LPPe_ver1_1_BroadcastSystemID_proprietarySystemID,
        OMA_LPPe_ver1_1_BroadcastSystemID,
        __OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels__item_,
        _OMA_LPPe_ver1_1_BroadcastADTypes_lppLabels,
        __OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels__item_,
        _OMA_LPPe_ver1_1_BroadcastADTypes_lppeLabels,
        OMA_LPPe_ver1_1_BroadcastADTypes,
        __OMA_LPPe_ver1_1_LabelSet_level1_element_level1_element_value,
        ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level2_element_value,
        ____OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element_level3_element_value,
        ___OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element_level3_element,
        __OMA_LPPe_ver1_1_LabelSet_level1_element_level2_element,
        _OMA_LPPe_ver1_1_LabelSet_level1_element,
        _OMA_LPPe_ver1_1_LabelSet_lastElements,
        _OMA_LPPe_ver1_1_LabelSet_additionalElements,
        OMA_LPPe_ver1_1_LabelSet,
        maxLevel1_element,
        maxLevel2_element,
        maxLevel3_element,
        maxFinal_element,
        maxLPPLabelSets,
        maxLPPeLabelSets,
        _OMA_LPPe_ver1_1_AccessNetworkID_gSMAccess,
        _OMA_LPPe_ver1_1_AccessNetworkID_wCDMAAccess,
        _OMA_LPPe_ver1_1_AccessNetworkID_lTEAccess,
        _OMA_LPPe_ver1_1_AccessNetworkID_wiMaxAccess,
        _OMA_LPPe_ver1_1_AccessNetworkID_wLANAccess,
        OMA_LPPe_ver1_1_AccessNetworkID,
        __OMA_LPPe_ver1_1_MCC_MNC_mcc__item_,
        _OMA_LPPe_ver1_1_MCC_MNC_mcc,
        __OMA_LPPe_ver1_1_MCC_MNC_mnc__item_,
        _OMA_LPPe_ver1_1_MCC_MNC_mnc,
        OMA_LPPe_ver1_1_MCC_MNC,
        _OMA_LPPe_ver1_1_BSID_bsID_MSB,
        _OMA_LPPe_ver1_1_BSID_bsID_LSB,
        OMA_LPPe_ver1_1_BSID,
        OMA_LPPe_ver1_1_AuthenticationSetID,
        _OMA_LPPe_ver1_1_AuthenticationSet_authenticationSetID,
        __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_modulus,
        __OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey_exponent,
        _OMA_LPPe_ver1_1_AuthenticationSet_rsaPublicKey,
        _OMA_LPPe_ver1_1_AuthenticationSet_saltLength,
        OMA_LPPe_ver1_1_AuthenticationSet,
        OMA_LPPe_ver1_1_CipherSetID,
        _OMA_LPPe_ver1_1_CipherSet_cipherSetID,
        _OMA_LPPe_ver1_1_CipherSet_cipherKey,
        _OMA_LPPe_ver1_1_CipherSet_c0,
        OMA_LPPe_ver1_1_CipherSet,
        _OMA_LPPe_ver1_1_ServerID_provider_ID,
        _OMA_LPPe_ver1_1_ServerID_server_ID,
        OMA_LPPe_ver1_1_ServerID,
        _OMA_LPPe_ValidityArea_regionSizeInv,
        _OMA_LPPe_ValidityArea_areaWidth,
        _OMA_LPPe_ValidityArea_codedLatOfNWCorner,
        _OMA_LPPe_ValidityArea_codedLonOfNWCorner,
        _OMA_LPPe_ValidityArea_rleList,
        OMA_LPPe_ValidityArea,
        _OMA_LPPe_RleList__item_,
        OMA_LPPe_RleList,
        _OMA_LPPe_ValidityPeriod_beginTime,
        _OMA_LPPe_ValidityPeriod_beginTimeAlt,
        _OMA_LPPe_ValidityPeriod_duration,
        OMA_LPPe_ValidityPeriod,
        _OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier_vendorOrOperatorID,
        _OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier_assistanceDataID,
        OMA_LPPe_VendorOrOperatorAssistanceDataIdentifier,
        _OMA_LPPe_VendorOrOperatorID_standard_VendorOrOperatorID,
        _OMA_LPPe_VendorOrOperatorID_nonStandard_VendorOrOperatorID,
        OMA_LPPe_VendorOrOperatorID,
        _OMA_LPPe_NonStandard_VendorOrOperatorID_encodedID,
        _OMA_LPPe_NonStandard_VendorOrOperatorID_visibleIdentification,
        OMA_LPPe_NonStandard_VendorOrOperatorID,
        OMA_LPPe_WirelessAccessTypes,
        _OMA_LPPe_WLAN_AP_ID_apMacAddress,
        OMA_LPPe_WLAN_AP_ID,
        OMA_LPPe_WLAN_AP_Type,
        OMA_LPPe_WLAN_AP_Type_List,
        _OMA_LPPe_WLANFemtoCoverageArea_truncation,
        _OMA_LPPe_WLANFemtoCoverageArea_areaType,
        _OMA_LPPe_WLANFemtoCoverageArea_confidence,
        __OMA_LPPe_WLANFemtoCoverageArea_componentList__item_,
        _OMA_LPPe_WLANFemtoCoverageArea_componentList,
        OMA_LPPe_WLANFemtoCoverageArea,
        __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referenceLocation,
        __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_referencePoint,
        __OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea_locationAndArea,
        _OMA_LPPe_WLANFemtoCoverageAreaElement_refPointAndArea,
        _OMA_LPPe_WLANFemtoCoverageAreaElement_type,
        _OMA_LPPe_WLANFemtoCoverageAreaElement_weight,
        OMA_LPPe_WLANFemtoCoverageAreaElement,
        _OMA_LPPe_CommonIEsRequestCapabilities_iP_Address_RequestCapabilities,
        _OMA_LPPe_CommonIEsRequestCapabilities_assistanceContainerSupportReq,
        _OMA_LPPe_CommonIEsRequestCapabilities_locationInformationContainerSupportReq,
        _OMA_LPPe_CommonIEsRequestCapabilities_relativeLocationChange_RequestCapabilities,
        _OMA_LPPe_CommonIEsRequestCapabilities_highAccuracyFormatCapabilitiesReq,
        _OMA_LPPe_CommonIEsRequestCapabilities_segmentedAssistanceData_ReqCapabilities,
        _OMA_LPPe_CommonIEsRequestCapabilities_referencePointCapabilitiesReq,
        _OMA_LPPe_CommonIEsRequestCapabilities_scheduledLocation_RequestCapabilities,
        _OMA_LPPe_CommonIEsRequestCapabilities_accessCapabilitiesReq,
        _OMA_LPPe_CommonIEsRequestCapabilities_segmentedLocationInformation_ReqCapabilities,
        _OMA_LPPe_CommonIEsRequestCapabilities_ver1_1_localCellInformation_ReqCapabilities,
        _OMA_LPPe_CommonIEsRequestCapabilities_ver1_1_broadcast_ReqCapabilities,
        OMA_LPPe_CommonIEsRequestCapabilities,
        OMA_LPPe_IP_Address_RequestCapabilities,
        _OMA_LPPe_AssistanceContainerSupportReq_vendorOrOperatorIDList,
        OMA_LPPe_AssistanceContainerSupportReq,
        _OMA_LPPe_LocationInformationContainerSupportReq_vendorOrOperatorIDList,
        OMA_LPPe_LocationInformationContainerSupportReq,
        _OMA_LPPe_VendorOrOperatorIDList__item_,
        OMA_LPPe_VendorOrOperatorIDList,
        maxVendorOrOperatorIDList,
        OMA_LPPe_RelativeLocationChange_RequestCapabilities,
        OMA_LPPe_HighAccuracyFormatCapabilitiesReq,
        OMA_LPPe_SegmentedAssistanceData_ReqCapabilities,
        __OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq__item_,
        _OMA_LPPe_ReferencePointCapabilitiesReq_referencePointProviderSupportListReq,
        OMA_LPPe_ReferencePointCapabilitiesReq,
        OMA_LPPe_ScheduledLocation_RequestCapabilities,
        OMA_LPPe_AccessCapabilitiesReq,
        OMA_LPPe_SegmentedLocationInformation_ReqCapabilities,
        OMA_LPPe_ver1_1_localCellInformation_ReqCapabilities,
        __OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems__item_,
        _OMA_LPPe_ver1_1_broadcast_ReqCapabilities_broadcastSystems,
        OMA_LPPe_ver1_1_broadcast_ReqCapabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_iP_Address_Capabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_assistanceContainerSupport,
        _OMA_LPPe_CommonIEsProvideCapabilities_locationInformationContainerSupport,
        _OMA_LPPe_CommonIEsProvideCapabilities_relativeLocationChange_Capabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_highAccuracyFormatCapabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_segmentedAssistanceData_ProvideCapabs,
        _OMA_LPPe_CommonIEsProvideCapabilities_referencePointCapabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_scheduledLocation_Capabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_accessCapabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_segmentedLocationInformation_ProvideCapabs,
        _OMA_LPPe_CommonIEsProvideCapabilities_ver1_1_localCellInformation_ProvideCapabilities,
        _OMA_LPPe_CommonIEsProvideCapabilities_ver1_1_broadcast_ProvideCapabilities,
        OMA_LPPe_CommonIEsProvideCapabilities,
        _OMA_LPPe_IP_Address_Capabilities_iP_Address_support,
        OMA_LPPe_IP_Address_Capabilities,
        _OMA_LPPe_AssistanceContainerSupport__item_,
        OMA_LPPe_AssistanceContainerSupport,
        _OMA_LPPe_VendorOrOperatorAssistanceContainerList_vendorOrOperatorID,
        _OMA_LPPe_VendorOrOperatorAssistanceContainerList_assistanceContainerList,
        OMA_LPPe_VendorOrOperatorAssistanceContainerList,
        _OMA_LPPe_AssistanceContainerList__item_,
        OMA_LPPe_AssistanceContainerList,
        _OMA_LPPe_LocationInformationContainerSupport__item_,
        OMA_LPPe_LocationInformationContainerSupport,
        _OMA_LPPe_VendorOrOperatorLocationInformationContainerList_vendorOrOperatorID,
        _OMA_LPPe_VendorOrOperatorLocationInformationContainerList_locationInformationContainerList,
        OMA_LPPe_VendorOrOperatorLocationInformationContainerList,
        _OMA_LPPe_LocationInformationContainerList__item_,
        OMA_LPPe_LocationInformationContainerList,
        maxLocationInformationContainerList,
        _OMA_LPPe_RelativeLocationChange_Capabilities_numberOfChanges,
        OMA_LPPe_RelativeLocationChange_Capabilities,
        OMA_LPPe_HighAccuracyFormatCapabilities,
        _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSegments,
        _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_maxSize,
        _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_minSize,
        _OMA_LPPe_SegmentedAssistanceData_ProvideCapabs_resume,
        OMA_LPPe_SegmentedAssistanceData_ProvideCapabs,
        _OMA_LPPe_ReferencePointCapabilities_relativeLocationReportingSupport,
        __OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList__item_,
        _OMA_LPPe_ReferencePointCapabilities_referencePointProviderSupportList,
        OMA_LPPe_ReferencePointCapabilities,
        _OMA_LPPe_ReferencePointProviderSupportElement_referencePointProvider,
        __OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport_mapDataFormat,
        _OMA_LPPe_ReferencePointProviderSupportElement_mapDataSupport,
        OMA_LPPe_ReferencePointProviderSupportElement,
        _OMA_LPPe_ScheduledLocation_Capabilities_minimumWindow,
        _OMA_LPPe_ScheduledLocation_Capabilities_gnssTimeReference,
        _OMA_LPPe_ScheduledLocation_Capabilities_networkTimeReference,
        OMA_LPPe_ScheduledLocation_Capabilities,
        _OMA_LPPe_AccessCapabilities_accessTypeUnknown,
        _OMA_LPPe_AccessCapabilities_fixedAccessTypes,
        _OMA_LPPe_AccessCapabilities_wirelessAccessTypes,
        OMA_LPPe_AccessCapabilities,
        _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSegments,
        _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_maxSize,
        _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_minSize,
        _OMA_LPPe_SegmentedLocationInformation_ProvideCapabs_resume,
        OMA_LPPe_SegmentedLocationInformation_ProvideCapabs,
        _OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities_localCellInformation_Support,
        OMA_LPPe_ver1_1_localCellInformation_ProvideCapabilities,
        _OMA_LPPe_ver1_1_broadcast_ProvideCapabilities__item_,
        OMA_LPPe_ver1_1_broadcast_ProvideCapabilities,
        _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_broadcastSystemID,
        _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_broadcastADTypes,
        _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_point2pointAD,
        _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_ciphering,
        _OMA_LPPe_ver1_1_BroadcastSystem_Capabs_authentication,
        OMA_LPPe_ver1_1_BroadcastSystem_Capabs,
        OMA_LPPe_ver1_1_point2pointAD,
        OMA_LPPe_ver1_1_Ciphering,
        OMA_LPPe_ver1_1_Authentication,
        _OMA_LPPe_CommonIEsRequestAssistanceData_approximate_location,
        _OMA_LPPe_CommonIEsRequestAssistanceData_assistanceContainerRequestList,
        _OMA_LPPe_CommonIEsRequestAssistanceData_requestPeriodicADwithUpdate,
        _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADpreference,
        _OMA_LPPe_CommonIEsRequestAssistanceData_segmentedADResume,
        _OMA_LPPe_CommonIEsRequestAssistanceData_referencePointAssistanceReq,
        _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_localCellInformationReq,
        _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_BroadcastAssistanceDataReq,
        _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_AccessNetwork,
        _OMA_LPPe_CommonIEsRequestAssistanceData_ver1_1_groundMorphologyModelReq,
        OMA_LPPe_CommonIEsRequestAssistanceData,
        _OMA_LPPe_RequestPeriodicADwithUpdate_periodicAD_session_ID,
        _OMA_LPPe_RequestPeriodicADwithUpdate_typeOfADRequest,
        OMA_LPPe_RequestPeriodicADwithUpdate,
        TypeOfADRequest,
        _OMA_LPPe_SegmentedADResume_segmentedAD_session_ID,
        _OMA_LPPe_SegmentedADResume_next_segment_number,
        OMA_LPPe_SegmentedADResume,
        __OMA_LPPe_ReferencePointAssistanceReq_referencePointReq__item_,
        _OMA_LPPe_ReferencePointAssistanceReq_referencePointReq,
        OMA_LPPe_ReferencePointAssistanceReq,
        _OMA_LPPe_ReferencePointAssistanceReqElement_referencePointProvider,
        _OMA_LPPe_ReferencePointAssistanceReqElement_mapDataReq,
        OMA_LPPe_ReferencePointAssistanceReqElement,
        _OMA_LPPe_ver1_1_GroundMorphologyModelReq_modelsReq,
        __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_northWestCorner,
        __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanX,
        __OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam_spanY,
        _OMA_LPPe_ver1_1_GroundMorphologyModelReq_refAreaParam,
        OMA_LPPe_ver1_1_GroundMorphologyModelReq,
        _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellInformationReq,
        _OMA_LPPe_ver1_1_LocalCellInformationReq_localCellID,
        _OMA_LPPe_ver1_1_LocalCellInformationReq_numberOfCells,
        OMA_LPPe_ver1_1_LocalCellInformationReq,
        _OMA_LPPe_ver1_1_BroadcastAssistanceDataReq_broadcastSystem,
        OMA_LPPe_ver1_1_BroadcastAssistanceDataReq,
        _OMA_LPPe_ver1_1_BroadcastSystem_broadcastSystemID,
        __OMA_LPPe_ver1_1_BroadcastSystem_cipherSets__item_,
        _OMA_LPPe_ver1_1_BroadcastSystem_cipherSets,
        __OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets__item_,
        _OMA_LPPe_ver1_1_BroadcastSystem_authenticationSets,
        OMA_LPPe_ver1_1_BroadcastSystem,
        _OMA_LPPe_CommonIEsProvideAssistanceData_assistanceContainerList,
        _OMA_LPPe_CommonIEsProvideAssistanceData_providePeriodicADwithUpdate,
        _OMA_LPPe_CommonIEsProvideAssistanceData_segmentedADTransfer,
        _OMA_LPPe_CommonIEsProvideAssistanceData_default_reference_point,
        _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_localCellInformation,
        _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_BroadcastAssistanceData,
        _OMA_LPPe_CommonIEsProvideAssistanceData_ver1_1_groundMorphologyModel,
        OMA_LPPe_CommonIEsProvideAssistanceData,
        _OMA_LPPe_ProvidePeriodicADwithUpdate_periodicAD_session_ID,
        _OMA_LPPe_ProvidePeriodicADwithUpdate_typeOfADProvide,
        OMA_LPPe_ProvidePeriodicADwithUpdate,
        OMA_LPPe_TypeOfADProvide,
        _OMA_LPPe_SegmentedADTransfer_segmentedAD_session_ID,
        _OMA_LPPe_SegmentedADTransfer_segment_number,
        OMA_LPPe_SegmentedADTransfer,
        __OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation__item_,
        _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_timingInformation,
        __OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation__item_,
        _OMA_LPPe_ver1_1_LocalCellInformation_ver1_1_other_CellInformation,
        OMA_LPPe_ver1_1_LocalCellInformation,
        maxCellSets,
        maxCells,
        _OMA_LPPe_ver1_1_CellInformation_cellID,
        __OMA_LPPe_ver1_1_CellInformation_coverage_circle,
        __OMA_LPPe_ver1_1_CellInformation_coverage_ellipse,
        __OMA_LPPe_ver1_1_CellInformation_coverage_arc,
        __OMA_LPPe_ver1_1_CellInformation_coverage_polygon,
        _OMA_LPPe_ver1_1_CellInformation_coverage,
        _OMA_LPPe_ver1_1_CellInformation_coordinates,
        _OMA_LPPe_ver1_1_CellInformation_frequencyAccuracy,
        OMA_LPPe_ver1_1_CellInformation,
        _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastSystem,
        __OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks__item_,
        _OMA_LPPe_ver1_1_BroadcastAssistanceData_accessNetworks,
        __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_circle,
        __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_ellipse,
        __OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea_polygon,
        _OMA_LPPe_ver1_1_BroadcastAssistanceData_coverageArea,
        _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastADTypes,
        __OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode_unencapsulated,
        __OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode_encapsulated,
        _OMA_LPPe_ver1_1_BroadcastAssistanceData_broadcastMode,
        OMA_LPPe_ver1_1_BroadcastAssistanceData,
        _OMA_LPPe_ver1_1_EncapsulatedMode_serverID,
        __OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets__item_,
        _OMA_LPPe_ver1_1_EncapsulatedMode_cipherSets,
        __OMA_LPPe_ver1_1_EncapsulatedMode_authentication__item_,
        _OMA_LPPe_ver1_1_EncapsulatedMode_authentication,
        OMA_LPPe_ver1_1_EncapsulatedMode,
        _OMA_LPPe_CommonIEsRequestLocationInformation_iP_Address_Request,
        _OMA_LPPe_CommonIEsRequestLocationInformation_locationInformationContainerRequest,
        _OMA_LPPe_CommonIEsRequestLocationInformation_requestPeriodicLocInfoWithUpdate,
        _OMA_LPPe_CommonIEsRequestLocationInformation_relativeLocationChange_Request,
        _OMA_LPPe_CommonIEsRequestLocationInformation_localPositionRequest,
        _OMA_LPPe_CommonIEsRequestLocationInformation_scheduledLocation_Request,
        _OMA_LPPe_CommonIEsRequestLocationInformation_accessTypeRequest,
        _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIpreference,
        _OMA_LPPe_CommonIEsRequestLocationInformation_segmentedLIResume,
        OMA_LPPe_CommonIEsRequestLocationInformation,
        OMA_LPPe_IP_Address_Request,
        _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_session_ID,
        _OMA_LPPe_RequestPeriodicLocInfoWithUpdate_typeOfLocInfoRequest,
        OMA_LPPe_RequestPeriodicLocInfoWithUpdate,
        OMA_LPPe_TypeOfLocInfoRequest,
        _OMA_LPPe_RelativeLocationChange_Request_numberOfChanges,
        OMA_LPPe_RelativeLocationChange_Request,
        _OMA_LPPe_LocalPositionRequest_typeOfRequest,
        __OMA_LPPe_LocalPositionRequest_referencePointReq__item_,
        _OMA_LPPe_LocalPositionRequest_referencePointReq,
        OMA_LPPe_LocalPositionRequest,
        _OMA_LPPe_ScheduledLocation_Request_gnssTime,
        _OMA_LPPe_ScheduledLocation_Request_networkTime,
        _OMA_LPPe_ScheduledLocation_Request_relativeTime,
        _OMA_LPPe_ScheduledLocation_Request_windowSize,
        OMA_LPPe_ScheduledLocation_Request,
        OMA_LPPe_AccessTypeRequest,
        _OMA_LPPe_SegmentedLIResume_segmentedLI_session_ID,
        _OMA_LPPe_SegmentedLIResume_next_segment_number,
        OMA_LPPe_SegmentedLIResume,
        _OMA_LPPe_CommonIEsProvideLocationInformation_highAccuracy3Dposition,
        _OMA_LPPe_CommonIEsProvideLocationInformation_localPosition,
        _OMA_LPPe_CommonIEsProvideLocationInformation_highAccuracy3Dvelocity,
        _OMA_LPPe_CommonIEsProvideLocationInformation_iP_Address_List,
        _OMA_LPPe_CommonIEsProvideLocationInformation_locationInformationContainer,
        _OMA_LPPe_CommonIEsProvideLocationInformation_providePeriodicLocInfoWithUpdate,
        _OMA_LPPe_CommonIEsProvideLocationInformation_relativeLocationChangeList,
        _OMA_LPPe_CommonIEsProvideLocationInformation_scheduledLocation,
        _OMA_LPPe_CommonIEsProvideLocationInformation_accessTypes,
        _OMA_LPPe_CommonIEsProvideLocationInformation_segmentedLITransfer,
        _OMA_LPPe_CommonIEsProvideLocationInformation_locationInformationTimeStamp,
        _OMA_LPPe_CommonIEsProvideLocationInformation_locationSource,
        OMA_LPPe_CommonIEsProvideLocationInformation,
        _OMA_LPPe_LocalPosition_referencePoint,
        _OMA_LPPe_LocalPosition_subjectLocation,
        OMA_LPPe_LocalPosition,
        _OMA_LPPe_IP_Address_List__item_,
        OMA_LPPe_IP_Address_List,
        maxIPAddress,
        __OMA_LPPe_IP_Address_local_IP_Address_iPv4,
        __OMA_LPPe_IP_Address_local_IP_Address_iPv6,
        _OMA_LPPe_IP_Address_local_IP_Address,
        _OMA_LPPe_IP_Address_bearer,
        _OMA_LPPe_IP_Address_nat,
        OMA_LPPe_IP_Address,
        OMA_LPPe_Bearer,
        _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_session_ID,
        _OMA_LPPe_ProvidePeriodicLocInfowithUpdate_typeOfLocInfoProvide,
        OMA_LPPe_ProvidePeriodicLocInfowithUpdate,
        OMA_LPPe_TypeOfLocInfoProvide,
        _OMA_LPPe_RelativeLocationChangeList__item_,
        OMA_LPPe_RelativeLocationChangeList,
        _OMA_LPPe_RelativeLocationChange_relativeTime,
        _OMA_LPPe_RelativeLocationChange_transactionID,
        _OMA_LPPe_RelativeLocationChange_relativeLocation,
        OMA_LPPe_RelativeLocationChange,
        maxRelativeLocation,
        _OMA_LPPe_ScheduledLocation_disposition,
        __OMA_LPPe_ScheduledLocation_actualWindow_start,
        __OMA_LPPe_ScheduledLocation_actualWindow_duration,
        _OMA_LPPe_ScheduledLocation_actualWindow,
        OMA_LPPe_ScheduledLocation,
        _OMA_LPPe_AccessTypes_accessTypeUnknown,
        _OMA_LPPe_AccessTypes_fixedAccessTypes,
        _OMA_LPPe_AccessTypes_wirelessAccessTypes,
        OMA_LPPe_AccessTypes,
        _OMA_LPPe_SegmentedLITransfer_segmentedLI_session_ID,
        _OMA_LPPe_SegmentedLITransfer_segment_number,
        OMA_LPPe_SegmentedLITransfer,
        _OMA_LPPe_TimeStamp_gnssTime,
        _OMA_LPPe_TimeStamp_networkTime,
        _OMA_LPPe_TimeStamp_relativeTime,
        OMA_LPPe_TimeStamp,
        _OMA_LPPe_LocationSource_agnss,
        _OMA_LPPe_LocationSource_otdoa,
        _OMA_LPPe_LocationSource_eotd,
        _OMA_LPPe_LocationSource_otdoaUTRA,
        _OMA_LPPe_LocationSource_ecidLTE,
        _OMA_LPPe_LocationSource_ecidGSM,
        _OMA_LPPe_LocationSource_ecidUTRA,
        _OMA_LPPe_LocationSource_wlanAP,
        _OMA_LPPe_LocationSource_srn,
        _OMA_LPPe_LocationSource_sensors,
        OMA_LPPe_LocationSource,
        _OMA_LPPe_CommonIEsAbort_abortCause,
        _OMA_LPPe_CommonIEsAbort_periodicSessionIDtoAbort,
        OMA_LPPe_CommonIEsAbort,
        OMA_LPPe_CommonIEsError,
        _OMA_LPPe_AGNSS_ProvideAssistanceData_commonAssistData,
        _OMA_LPPe_AGNSS_ProvideAssistanceData_genericAssistData,
        _OMA_LPPe_AGNSS_ProvideAssistanceData_error,
        OMA_LPPe_AGNSS_ProvideAssistanceData,
        _OMA_LPPe_AGNSS_CommonAssistData_ionosphericModel,
        _OMA_LPPe_AGNSS_CommonAssistData_troposphereModel,
        _OMA_LPPe_AGNSS_CommonAssistData_altitudeAssistance,
        _OMA_LPPe_AGNSS_CommonAssistData_solarRadiation,
        _OMA_LPPe_AGNSS_CommonAssistData_ccpAssistCommonProvide,
        OMA_LPPe_AGNSS_CommonAssistData,
        _OMA_LPPe_AGNSS_GenericAssistData__item_,
        OMA_LPPe_AGNSS_GenericAssistData,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_gnss_ID,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_wideAreaIonoSurfacePerSVlist,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_mechanicsForAllSVs,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_dcbsForAllSVs,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_navModelDegradationModel,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_ccpAssistProvide,
        _OMA_LPPe_AGNSS_GenericAssistDataElement_navModelList,
        OMA_LPPe_AGNSS_GenericAssistDataElement,
        __OMA_LPPe_AGNSS_IonosphericModel_staticModels_localKlobucharModelList,
        __OMA_LPPe_AGNSS_IonosphericModel_staticModels_ionoStormIndication,
        _OMA_LPPe_AGNSS_IonosphericModel_staticModels,
        __OMA_LPPe_AGNSS_IonosphericModel_waIono_controlParameters,
        __OMA_LPPe_AGNSS_IonosphericModel_waIono_commonProvide,
        _OMA_LPPe_AGNSS_IonosphericModel_waIono,
        OMA_LPPe_AGNSS_IonosphericModel,
        _OMA_LPPe_AGNSS_LocalKlobucharModelList__item_,
        OMA_LPPe_AGNSS_LocalKlobucharModelList,
        _OMA_LPPe_AGNSS_LocalKlobucharModelElement_validityArea,
        __OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel__item_,
        _OMA_LPPe_AGNSS_LocalKlobucharModelElement_klobucharModel,
        OMA_LPPe_AGNSS_LocalKlobucharModelElement,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_validityPeriod,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa0,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa1,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa2,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_alfa3,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_beta0,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_beta1,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_beta2,
        _OMA_LPPe_AGNSS_LocalKlobucharModel_beta3,
        OMA_LPPe_AGNSS_LocalKlobucharModel,
        _OMA_LPPe_AGNSS_IonoStormIndication_area,
        _OMA_LPPe_AGNSS_IonoStormIndication_stormList,
        OMA_LPPe_AGNSS_IonoStormIndication,
        _OMA_LPPe_AGNSS_StormList__item_,
        OMA_LPPe_AGNSS_StormList,
        _OMA_LPPe_AGNSS_StormElement_validityPeriod,
        _OMA_LPPe_AGNSS_StormElement_rleListIono,
        OMA_LPPe_AGNSS_StormElement,
        _OMA_LPPe_AGNSS_RleListIono__item_,
        OMA_LPPe_AGNSS_RleListIono,
        _OMA_LPPe_AGNSS_RleIonoElement_regionCount,
        __OMA_LPPe_AGNSS_RleIonoElement_ionoIndex_noaaScales,
        _OMA_LPPe_AGNSS_RleIonoElement_ionoIndex,
        OMA_LPPe_AGNSS_RleIonoElement,
        OMA_LPPe_AGNSS_NoaaScales,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_duration,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_rate,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_referencePosition,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide_validityArea,
        OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersProvide,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon_validityPeriod,
        OMA_LPPe_AGNSS_WideAreaIonoSurfaceCommon,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist__item_,
        OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVlist,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_svID,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_a0,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e1,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n1,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_e2,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_n2,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement_en,
        OMA_LPPe_AGNSS_WideAreaIonoSurfacePerSVelement,
        _OMA_LPPe_AGNSS_TroposphereModel_troposphereDelayList,
        _OMA_LPPe_AGNSS_TroposphereModel_surfaceParametersList,
        OMA_LPPe_AGNSS_TroposphereModel,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayList__item_,
        OMA_LPPe_AGNSS_LocalTroposphereDelayList,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_validityArea,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_refAltitude,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_gradientReferencePosition,
        __OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList__item_,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement_delayList,
        OMA_LPPe_AGNSS_LocalTroposphereDelayAreaElement,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_validityPeriod,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zh0,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_eh,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_zw0,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_ew,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gN,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_gE,
        _OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement_mappingFunctionParameters,
        OMA_LPPe_AGNSS_LocalTroposphereDelayTimeElement,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersList__item_,
        OMA_LPPe_AGNSS_LocalSurfaceParametersList,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_validityArea,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_refAltitude,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_gradientReferencePosition,
        __OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList__item_,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement_parameterList,
        OMA_LPPe_AGNSS_LocalSurfaceParametersAreaElement,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_validityPeriod,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressure,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_pressureRate,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_pressure,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_pressure,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperature,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_temperatureRate,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gN_temperature,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_gE_temperature,
        _OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement_mappingFunctionParameters,
        OMA_LPPe_AGNSS_LocalSurfaceParametersTimeElement,
        _OMA_LPPe_AGNSS_MappingFunctionParameters_ah,
        _OMA_LPPe_AGNSS_MappingFunctionParameters_bh,
        _OMA_LPPe_AGNSS_MappingFunctionParameters_ch,
        _OMA_LPPe_AGNSS_MappingFunctionParameters_aw,
        _OMA_LPPe_AGNSS_MappingFunctionParameters_bw,
        _OMA_LPPe_AGNSS_MappingFunctionParameters_cw,
        OMA_LPPe_AGNSS_MappingFunctionParameters,
        _OMA_LPPe_AGNSS_AltitudeAssistanceList__item_,
        OMA_LPPe_AGNSS_AltitudeAssistanceList,
        _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_validityArea,
        _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_gradientReferencePosition,
        _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_refAltitude,
        __OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList__item_,
        _OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement_pressureAssistanceList,
        OMA_LPPe_AGNSS_AltitudeAssistanceAreaElement,
        _OMA_LPPe_AGNSS_PressureAssistanceElement_validityPeriod,
        _OMA_LPPe_AGNSS_PressureAssistanceElement_pressure,
        _OMA_LPPe_AGNSS_PressureAssistanceElement_pressureRate,
        _OMA_LPPe_AGNSS_PressureAssistanceElement_gN,
        _OMA_LPPe_AGNSS_PressureAssistanceElement_gE,
        OMA_LPPe_AGNSS_PressureAssistanceElement,
        _OMA_LPPe_AGNSS_SolarRadiation_solarRadiation,
        OMA_LPPe_AGNSS_SolarRadiation,
        _OMA_LPPe_AGNSS_MechanicsForAllSVs__item_,
        OMA_LPPe_AGNSS_MechanicsForAllSVs,
        _OMA_LPPe_AGNSS_MechanicsElement_svid,
        _OMA_LPPe_AGNSS_MechanicsElement_mass,
        _OMA_LPPe_AGNSS_MechanicsElement_effectiveReflectivityArea,
        _OMA_LPPe_AGNSS_MechanicsElement_pco,
        __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svType,
        __OMA_LPPe_AGNSS_MechanicsElement_svInfo_svNumber,
        _OMA_LPPe_AGNSS_MechanicsElement_svInfo,
        OMA_LPPe_AGNSS_MechanicsElement,
        _OMA_LPPe_AGNSS_PCOelement_xOffsetSBF,
        _OMA_LPPe_AGNSS_PCOelement_yOffsetSBF,
        _OMA_LPPe_AGNSS_PCOelement_zOffsetSBF,
        OMA_LPPe_AGNSS_PCOelement,
        OMA_LPPe_AGNSS_SVtype,
        _OMA_LPPe_AGNSS_DCBsForAllSVs__item_,
        OMA_LPPe_AGNSS_DCBsForAllSVs,
        _OMA_LPPe_AGNSS_DCBlistElement_svid,
        __OMA_LPPe_AGNSS_DCBlistElement_reference_signal,
        __OMA_LPPe_AGNSS_DCBlistElement_reference_pd,
        _OMA_LPPe_AGNSS_DCBlistElement_reference,
        _OMA_LPPe_AGNSS_DCBlistElement_dcbList,
        OMA_LPPe_AGNSS_DCBlistElement,
        _OMA_LPPe_AGNSS_DCBlist__item_,
        OMA_LPPe_AGNSS_DCBlist,
        _OMA_LPPe_AGNSS_DCBelement_signal,
        _OMA_LPPe_AGNSS_DCBelement_pd,
        _OMA_LPPe_AGNSS_DCBelement_dcb,
        OMA_LPPe_AGNSS_DCBelement,
        _OMA_LPPe_AGNSS_NavModelDegradationModelList__item_,
        OMA_LPPe_AGNSS_NavModelDegradationModelList,
        _OMA_LPPe_AGNSS_NavModelDegradationModelElement_svid,
        _OMA_LPPe_AGNSS_NavModelDegradationModelElement_clockDegradationModel,
        _OMA_LPPe_AGNSS_NavModelDegradationModelElement_orbitDegradationModel,
        OMA_LPPe_AGNSS_NavModelDegradationModelElement,
        _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS0,
        _OMA_LPPe_AGNSS_ClockModelDegradationModel_clockRMS1,
        OMA_LPPe_AGNSS_ClockModelDegradationModel,
        _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS0,
        _OMA_LPPe_AGNSS_OrbitModelDegradationModel_orbitRMS1,
        OMA_LPPe_AGNSS_OrbitModelDegradationModel,
        _OMA_LPPe_AGNSS_CCPassistCommonProvide_ccpProvideCommonParameters,
        _OMA_LPPe_AGNSS_CCPassistCommonProvide_ccpProvideControlParameters,
        OMA_LPPe_AGNSS_CCPassistCommonProvide,
        _OMA_LPPe_AGNSS_CCPprovideCommonParameters_ccpReferenceTime,
        OMA_LPPe_AGNSS_CCPprovideCommonParameters,
        _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpSupportArea,
        _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpNeighborList,
        _OMA_LPPe_AGNSS_CCPprovideControlParameters_duration,
        _OMA_LPPe_AGNSS_CCPprovideControlParameters_rate,
        _OMA_LPPe_AGNSS_CCPprovideControlParameters_ccpReferenceStationList,
        OMA_LPPe_AGNSS_CCPprovideControlParameters,
        _OMA_LPPe_AGNSS_CCPsupportArea_areaDescription,
        __OMA_LPPe_AGNSS_CCPsupportArea_signalSupport__item_,
        _OMA_LPPe_AGNSS_CCPsupportArea_signalSupport,
        OMA_LPPe_AGNSS_CCPsupportArea,
        _OMA_LPPe_AGNSS_CCPsignalSupport_gnss,
        _OMA_LPPe_AGNSS_CCPsignalSupport_signals,
        OMA_LPPe_AGNSS_CCPsignalSupport,
        _OMA_LPPe_AGNSS_CCPreferenceStationList__item_,
        OMA_LPPe_AGNSS_CCPreferenceStationList,
        _OMA_LPPe_AGNSS_CCPreferenceStationElement_referenceStationID,
        _OMA_LPPe_AGNSS_CCPreferenceStationElement_referenceStationLocation,
        _OMA_LPPe_AGNSS_CCPreferenceStationElement_antennaDescription,
        OMA_LPPe_AGNSS_CCPreferenceStationElement,
        _OMA_LPPe_AGNSS_CCPassistGenericProvide__item_,
        OMA_LPPe_AGNSS_CCPassistGenericProvide,
        _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_referenceStationID,
        __OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList__item_,
        _OMA_LPPe_AGNSS_CCPassistGenericProvideElement_ccpPerSignalList,
        OMA_LPPe_AGNSS_CCPassistGenericProvideElement,
        _OMA_LPPe_AGNSS_CCPperSignalElement_signal_ID,
        __OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist__item_,
        _OMA_LPPe_AGNSS_CCPperSignalElement_ccpPerSVlist,
        OMA_LPPe_AGNSS_CCPperSignalElement,
        _OMA_LPPe_AGNSS_CCPperSVelement_svID,
        _OMA_LPPe_AGNSS_CCPperSVelement_integerCodePhase,
        _OMA_LPPe_AGNSS_CCPperSVelement_codePhase,
        _OMA_LPPe_AGNSS_CCPperSVelement_codePhaseError,
        _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeDelta,
        _OMA_LPPe_AGNSS_CCPperSVelement_phaseRangeRMSerror,
        _OMA_LPPe_AGNSS_CCPperSVelement_lockIndicator,
        OMA_LPPe_AGNSS_CCPperSVelement,
        _OMA_LPPe_AGNSS_CodePhaseError_codePhaseRMSError,
        _OMA_LPPe_AGNSS_CodePhaseError_cnr,
        OMA_LPPe_AGNSS_CodePhaseError,
        _OMA_LPPe_AGNSS_NavModelList_coordinateBased,
        OMA_LPPe_AGNSS_NavModelList,
        __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_beginTime,
        __OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval_interval,
        _OMA_LPPe_AGNSS_NavModel_CoordinateBased_fixedInterval,
        __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForPosVel,
        __OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases_baseForCcRate,
        _OMA_LPPe_AGNSS_NavModel_CoordinateBased_bases,
        _OMA_LPPe_AGNSS_NavModel_CoordinateBased_referencedTo,
        __OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList__item_,
        _OMA_LPPe_AGNSS_NavModel_CoordinateBased_pointList,
        OMA_LPPe_AGNSS_NavModel_CoordinateBased,
        _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_time_of_record,
        __OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList__item_,
        _OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement_svIdList,
        OMA_LPPe_AGNSS_NavModel_CoordinateBasedElement,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_svID,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_svClockOffset,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionX,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionY,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_ecefPositionZ,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_clockPosSTD,
        __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_svClockRate,
        __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityX,
        __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityY,
        __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_ecefVelocityZ,
        __OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord_clockRateVelSTD,
        _OMA_LPPe_AGNSS_NavModel_PVTelement_rateRecord,
        OMA_LPPe_AGNSS_NavModel_PVTelement,
        _OMA_LPPe_AGNSS_NavModel_BigNumber_msb,
        _OMA_LPPe_AGNSS_NavModel_BigNumber_lsb,
        OMA_LPPe_AGNSS_NavModel_BigNumber,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e11,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e22,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e33,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e44,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e12,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e13,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e14,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e23,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e24,
        _OMA_LPPe_AGNSS_NavModel_STDmatrix_e34,
        OMA_LPPe_AGNSS_NavModel_STDmatrix,
        _OMA_LPPe_AGNSS_RequestAssistanceData_commonAssistDataReq,
        _OMA_LPPe_AGNSS_RequestAssistanceData_genericAssistDataReq,
        OMA_LPPe_AGNSS_RequestAssistanceData,
        _OMA_LPPe_AGNSS_CommonAssistanceDataReq_ionosphericModelReq,
        _OMA_LPPe_AGNSS_CommonAssistanceDataReq_troposphereModelReq,
        _OMA_LPPe_AGNSS_CommonAssistanceDataReq_altitudeAssistanceReq,
        _OMA_LPPe_AGNSS_CommonAssistanceDataReq_solarRadiationRequest,
        _OMA_LPPe_AGNSS_CommonAssistanceDataReq_ccpRequestControlParameters,
        OMA_LPPe_AGNSS_CommonAssistanceDataReq,
        _OMA_LPPe_AGNSS_GenericAssistanceDataReq__item_,
        OMA_LPPe_AGNSS_GenericAssistanceDataReq,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_gnss_ID,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_waIonoSurfaceReq,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_mechanicsReq,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_dcbReq,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_navModelDegradationModelReq,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_ccpAssistGenericReq,
        _OMA_LPPe_AGNSS_GenericAssistDataReqElement_navigationModelReq,
        OMA_LPPe_AGNSS_GenericAssistDataReqElement,
        __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_ionoreq,
        __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_requestBeginTime,
        __OMA_LPPe_AGNSS_IonosphericModelReq_staticModels_duration,
        _OMA_LPPe_AGNSS_IonosphericModelReq_staticModels,
        __OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels_waIonoSurface,
        _OMA_LPPe_AGNSS_IonosphericModelReq_periodicModels,
        OMA_LPPe_AGNSS_IonosphericModelReq,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_duration,
        _OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest_rate,
        OMA_LPPe_AGNSS_WideAreaIonoSurfaceControlParametersRequest,
        _OMA_LPPe_AGNSS_TroposphereModelReq_troposphereModelReq,
        _OMA_LPPe_AGNSS_TroposphereModelReq_supportForMultipleGridPoints,
        _OMA_LPPe_AGNSS_TroposphereModelReq_requestBeginTime,
        _OMA_LPPe_AGNSS_TroposphereModelReq_duration,
        OMA_LPPe_AGNSS_TroposphereModelReq,
        _OMA_LPPe_AGNSS_AltitudeAssistanceReq_requestBeginTime,
        _OMA_LPPe_AGNSS_AltitudeAssistanceReq_duration,
        OMA_LPPe_AGNSS_AltitudeAssistanceReq,
        OMA_LPPe_AGNSS_SolarRadiationReq,
        OMA_LPPe_AGNSS_WaIonoSurfaceRequest,
        OMA_LPPe_AGNSS_NavModelDegradationModelReq,
        __OMA_LPPe_AGNSS_DCBreq_reference_signal,
        __OMA_LPPe_AGNSS_DCBreq_reference_pd,
        _OMA_LPPe_AGNSS_DCBreq_reference,
        OMA_LPPe_AGNSS_DCBreq,
        _OMA_LPPe_AGNSS_MechanicsReq_massRequest,
        _OMA_LPPe_AGNSS_MechanicsReq_effectiveReflectivityAreaRequest,
        _OMA_LPPe_AGNSS_MechanicsReq_pcoRequest,
        _OMA_LPPe_AGNSS_MechanicsReq_svInfoRequest,
        OMA_LPPe_AGNSS_MechanicsReq,
        _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpSupportAreaRequest,
        _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpNeighborListRequest,
        __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_duration,
        __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_rate,
        ____OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest_requestedReferenceStationLocation,
        ____OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest_qor,
        ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_posBasedReferenceStationRequest,
        ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_idBasedReferenceStationRequest,
        ___OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation_referenceStationKillList,
        __OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest_refStation,
        _OMA_LPPe_AGNSS_CCPrequestControlParameters_ccpCommonRequest,
        OMA_LPPe_AGNSS_CCPrequestControlParameters,
        _OMA_LPPe_AGNSS_ReferenceStationIDlist__item_,
        OMA_LPPe_AGNSS_ReferenceStationIDlist,
        OMA_LPPe_AGNSS_QoR,
        _OMA_LPPe_AGNSS_CCPassistGenericReq_ccpAssist_SignalsReq,
        OMA_LPPe_AGNSS_CCPassistGenericReq,
        __OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList__item_,
        _OMA_LPPe_AGNSS_NavigationModelReq_navModelID_PrefList,
        OMA_LPPe_AGNSS_NavigationModelReq,
        _OMA_LPPe_AGNSS_ProvideLocationInformation_highAccuracyReferenceTime,
        _OMA_LPPe_AGNSS_ProvideLocationInformation_highAccuracyMeasurements,
        _OMA_LPPe_AGNSS_ProvideLocationInformation_ionosphereMeasurements,
        _OMA_LPPe_AGNSS_ProvideLocationInformation_localSurfaceMeasurements,
        _OMA_LPPe_AGNSS_ProvideLocationInformation_error,
        OMA_LPPe_AGNSS_ProvideLocationInformation,
        __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_duration,
        __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_rate,
        __OMA_LPPe_AGNSS_HAgnssProvide_controlParameters_antennaDescription,
        _OMA_LPPe_AGNSS_HAgnssProvide_controlParameters,
        __OMA_LPPe_AGNSS_HAgnssProvide_measurements_position,
        __OMA_LPPe_AGNSS_HAgnssProvide_measurements_referenceTime,
        ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressure,
        ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure_pressureUncertainty,
        __OMA_LPPe_AGNSS_HAgnssProvide_measurements_localPressure,
        __OMA_LPPe_AGNSS_HAgnssProvide_measurements_antennaOrientation,
        ___OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements__item_,
        __OMA_LPPe_AGNSS_HAgnssProvide_measurements_signalMeasurements,
        _OMA_LPPe_AGNSS_HAgnssProvide_measurements,
        OMA_LPPe_AGNSS_HAgnssProvide,
        _OMA_LPPe_AGNSS_HAgnssMeasurementElement_gnss_ID,
        __OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList__item_,
        _OMA_LPPe_AGNSS_HAgnssMeasurementElement_haGNSSperSignalList,
        OMA_LPPe_AGNSS_HAgnssMeasurementElement,
        _OMA_LPPe_HAgnssPerSignalElement_signal_ID,
        __OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist__item_,
        _OMA_LPPe_HAgnssPerSignalElement_haGNSSperSVlist,
        OMA_LPPe_HAgnssPerSignalElement,
        _OMA_LPPe_HAgnssPerSVelement_svID,
        _OMA_LPPe_HAgnssPerSVelement_integerCodePhase,
        _OMA_LPPe_HAgnssPerSVelement_codePhase,
        _OMA_LPPe_HAgnssPerSVelement_codePhaseRMSError,
        _OMA_LPPe_HAgnssPerSVelement_multipathDetection,
        _OMA_LPPe_HAgnssPerSVelement_cnr,
        _OMA_LPPe_HAgnssPerSVelement_adr,
        _OMA_LPPe_HAgnssPerSVelement_adrRMSerror,
        _OMA_LPPe_HAgnssPerSVelement_lockIndicator,
        OMA_LPPe_HAgnssPerSVelement,
        _OMA_LPPe_AGNSS_IonosphereMeasurements_gnssTime,
        _OMA_LPPe_AGNSS_IonosphereMeasurements_position,
        _OMA_LPPe_AGNSS_IonosphereMeasurements_tecPerSV,
        _OMA_LPPe_AGNSS_IonosphereMeasurements_tecAtZenith,
        OMA_LPPe_AGNSS_IonosphereMeasurements,
        _OMA_LPPe_AGNSS_TECPerSV__item_,
        OMA_LPPe_AGNSS_TECPerSV,
        _OMA_LPPe_AGNSS_TECPerSVElement_azimuth,
        _OMA_LPPe_AGNSS_TECPerSVElement_elevation,
        _OMA_LPPe_AGNSS_TECPerSVElement_tecValue,
        _OMA_LPPe_AGNSS_TECPerSVElement_tecUncertainty,
        OMA_LPPe_AGNSS_TECPerSVElement,
        _OMA_LPPe_AGNSS_TECAtZenith_tecValueAtZenith,
        _OMA_LPPe_AGNSS_TECAtZenith_tecUncertaintyAtZenith,
        OMA_LPPe_AGNSS_TECAtZenith,
        _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_gnssTime,
        _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_position,
        _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressure,
        _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_pressureUncertainty,
        __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperature,
        __OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement_temperatureUncertainty,
        _OMA_LPPe_AGNSS_LocalSurfaceMeasurements_temperatureMeasurement,
        OMA_LPPe_AGNSS_LocalSurfaceMeasurements,
        _OMA_LPPe_AGNSS_RequestLocationInformation_positioningInstructions,
        _OMA_LPPe_AGNSS_RequestLocationInformation_ionosphereMeasurementsReq,
        _OMA_LPPe_AGNSS_RequestLocationInformation_localSurfaceMeasurementReq,
        OMA_LPPe_AGNSS_RequestLocationInformation,
        _OMA_LPPe_AGNSS_PositioningInstructions_highAccuracyMethodRequested,
        _OMA_LPPe_AGNSS_PositioningInstructions_haGNSSreq,
        OMA_LPPe_AGNSS_PositioningInstructions,
        OMA_LPPe_AGNSS_LocalSurfaceMeasurementReq,
        _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_duration,
        _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_rate,
        _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_antennaInformationReq,
        _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_pressureInformationReq,
        __OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList__item_,
        _OMA_LPPe_AGNSS_HAgnssRequestControlParameters_signalReqList,
        OMA_LPPe_AGNSS_HAgnssRequestControlParameters,
        _OMA_LPPe_AGNSS_HAgnssSignalReqElement_gnssID,
        _OMA_LPPe_AGNSS_HAgnssSignalReqElement_signals,
        OMA_LPPe_AGNSS_HAgnssSignalReqElement,
        _OMA_LPPe_AGNSS_ProvideCapabilities_assistanceDataSupportList,
        _OMA_LPPe_AGNSS_ProvideCapabilities_environmentObservationSupportList,
        _OMA_LPPe_AGNSS_ProvideCapabilities_haGNSSsupport,
        OMA_LPPe_AGNSS_ProvideCapabilities,
        _OMA_LPPe_AGNSS_AssistanceDataSupportList_commonAssistanceDataSupport,
        _OMA_LPPe_AGNSS_AssistanceDataSupportList_genericAssistanceDataSupport,
        OMA_LPPe_AGNSS_AssistanceDataSupportList,
        _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_ionosphereMeasurementSupport,
        _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_pressureMeasurementSupported,
        _OMA_LPPe_AGNSS_EnvironmentObservationSupportList_temperatureMeasurementSupported,
        OMA_LPPe_AGNSS_EnvironmentObservationSupportList,
        _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_ionosphericModelSupport,
        _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_troposphereModelSupport,
        _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_altitudeAssistanceSupport,
        _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_solarRadiationSupport,
        _OMA_LPPe_AGNSS_CommonAssistanceDataSupport_ccpSupport,
        OMA_LPPe_AGNSS_CommonAssistanceDataSupport,
        _OMA_LPPe_AGNSS_IonosphericModelSupport_ionoModel,
        OMA_LPPe_AGNSS_IonosphericModelSupport,
        _OMA_LPPe_AGNSS_TroposphereModelSupport_tropoModel,
        _OMA_LPPe_AGNSS_TroposphereModelSupport_supportForMultipleGridPoints,
        OMA_LPPe_AGNSS_TroposphereModelSupport,
        OMA_LPPe_AGNSS_AltitudeAssistanceSupport,
        OMA_LPPe_AGNSS_SolarRadiationSupport,
        _OMA_LPPe_AGNSS_CCPsupport_supportAreaAssistanceSupported,
        _OMA_LPPe_AGNSS_CCPsupport_multiReferenceStationSupported,
        OMA_LPPe_AGNSS_CCPsupport,
        _OMA_LPPe_AGNSS_GenericAssistanceDataSupport__item_,
        OMA_LPPe_AGNSS_GenericAssistanceDataSupport,
        _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_gnss_ID,
        _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_mechnanicsSupport,
        _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_dcbSupport,
        _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_navModelAccuracyModelDegradationSupport,
        _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_ccpAssistanceSuppport,
        _OMA_LPPe_AGNSS_GenericAssistDataSupportElement_navModelSupport,
        OMA_LPPe_AGNSS_GenericAssistDataSupportElement,
        OMA_LPPe_AGNSS_MechanicsSupport,
        OMA_LPPe_AGNSS_DCBsupport,
        OMA_LPPe_AGNSS_NavModelAccuracyModelDegradationSupport,
        __OMA_LPPe_AGNSS_NavModelSupport_navModelSupport__item_,
        _OMA_LPPe_AGNSS_NavModelSupport_navModelSupport,
        OMA_LPPe_AGNSS_NavModelSupport,
        _OMA_LPPe_AGNSS_HAgnssSupport_modeSupport,
        _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSpressureInformationSupport,
        _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSantennaInformationSupport,
        __OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport__item_,
        _OMA_LPPe_AGNSS_HAgnssSupport_haGNSSperGNSSsupport,
        OMA_LPPe_AGNSS_HAgnssSupport,
        _OMA_LPPe_AGNSS_HAgnssPerGNSSsupport_gnss_ID,
        _OMA_LPPe_AGNSS_HAgnssPerGNSSsupport_haGNSSsignalSupport,
        OMA_LPPe_AGNSS_HAgnssPerGNSSsupport,
        _OMA_LPPe_AGNSS_RequestCapabilities_assistanceDataSupportListReq,
        _OMA_LPPe_AGNSS_RequestCapabilities_environmentObservationSupportListReq,
        _OMA_LPPe_AGNSS_RequestCapabilities_haGNSSsupportReq,
        OMA_LPPe_AGNSS_RequestCapabilities,
        _OMA_LPPe_AGNSS_Error_agnss_locationServerErrorCauses,
        _OMA_LPPe_AGNSS_Error_agnss_targetDeviceErrorCauses,
        OMA_LPPe_AGNSS_Error,
        _OMA_LPPe_AGNSS_LocationServerErrorCauses_waIonoErrorCauses,
        _OMA_LPPe_AGNSS_LocationServerErrorCauses_ccpErrorCauses,
        OMA_LPPe_AGNSS_LocationServerErrorCauses,
        _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_highAccuracyErrorCauses,
        _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_ionosphereMeasurementErrorCauses,
        _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_environmentObservationErrorCauses,
        _OMA_LPPe_AGNSS_TargetDeviceErrorCauses_haGNSSerrorCauses,
        OMA_LPPe_AGNSS_TargetDeviceErrorCauses,
        _OMA_LPPe_AGNSS_CCPreferenceStationID_stationID,
        OMA_LPPe_AGNSS_CCPreferenceStationID,
        maxReferenceStations,
        __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_igsAntennaName,
        __OMA_LPPe_AGNSS_AntennaDescription_antennaDescription_proprietaryName,
        _OMA_LPPe_AGNSS_AntennaDescription_antennaDescription,
        _OMA_LPPe_AGNSS_AntennaDescription_antennaSetupID,
        _OMA_LPPe_AGNSS_AntennaDescription_antennaSerialNumber,
        OMA_LPPe_AGNSS_AntennaDescription,
        __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_ccpAbort,
        __OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses_waIonoAbort,
        _OMA_LPPe_AGNSS_Abort_targetDeviceAbortCauses,
        OMA_LPPe_AGNSS_Abort,
        _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_ReferenceCellInfo,
        _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_NeighbourCellInfo,
        _OMA_LPPe_OTDOA_ProvideAssistanceData_otdoa_Error,
        OMA_LPPe_OTDOA_ProvideAssistanceData,
        _OMA_LPPe_OTDOA_ReferenceCellInfo_referenceCellInfo,
        _OMA_LPPe_OTDOA_ReferenceCellInfo_positionCalculationInfoRef,
        OMA_LPPe_OTDOA_ReferenceCellInfo,
        _OMA_LPPe_OTDOA_PositionCalculationInfoRef_systemFrameNumber,
        _OMA_LPPe_OTDOA_PositionCalculationInfoRef_rtdReferenceStd,
        __OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation_reference_point,
        __OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation_relative_location,
        _OMA_LPPe_OTDOA_PositionCalculationInfoRef_cellLocation,
        __OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo_location_reliability,
        _OMA_LPPe_OTDOA_PositionCalculationInfoRef_femtoCellInfo,
        OMA_LPPe_OTDOA_PositionCalculationInfoRef,
        _OMA_LPPe_OTDOA_NeighbourCellInfoList__item_,
        OMA_LPPe_OTDOA_NeighbourCellInfoList,
        maxFreqLayers,
        __OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB__item_,
        _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_eNB,
        __OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB__item_,
        _OMA_LPPe_OTDOA_NeighbourFreqCellInfoList_neighbourCellInfoList_HeNB,
        OMA_LPPe_OTDOA_NeighbourFreqCellInfoList,
        _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_relative_Location,
        __OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList__item_,
        _OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB_otdoa_eNB_CellDataList,
        OMA_LPPe_OTDOA_NeighbourCellInfoElement_eNB,
        _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_relative_Location,
        _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_location_reliability,
        _OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB_otdoa_HeNB_CellDataList,
        OMA_LPPe_OTDOA_NeighbourCellInfoElement_HeNB,
        _OMA_LPPe_OTDOA_CellData_otdoa_NeighbourCellInfoElement,
        __OMA_LPPe_OTDOA_CellData_rtdInfo_subframeOffset,
        __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTD,
        __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDstd,
        __OMA_LPPe_OTDOA_CellData_rtdInfo_fineRTDdriftRate,
        _OMA_LPPe_OTDOA_CellData_rtdInfo,
        OMA_LPPe_OTDOA_CellData,
        _OMA_LPPe_OTDOA_RTDquality_resolution,
        _OMA_LPPe_OTDOA_RTDquality_quality,
        OMA_LPPe_OTDOA_RTDquality,
        __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_physCellId,
        __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_eARFCN,
        __OMA_LPPe_OTDOA_RequestAssistanceData_lteCell_ecgi,
        _OMA_LPPe_OTDOA_RequestAssistanceData_lteCell,
        _OMA_LPPe_OTDOA_RequestAssistanceData_requestedCells,
        OMA_LPPe_OTDOA_RequestAssistanceData,
        _OMA_LPPe_OTDOA_ProvideLocationInformation_otdoaLocationInformation,
        _OMA_LPPe_OTDOA_ProvideLocationInformation_otdoaError,
        OMA_LPPe_OTDOA_ProvideLocationInformation,
        _OMA_LPPe_OTDOA_LocationInformation_systemFrameNumber,
        _OMA_LPPe_OTDOA_LocationInformation_physCellId,
        _OMA_LPPe_OTDOA_LocationInformation_cellGlobalId,
        OMA_LPPe_OTDOA_LocationInformation,
        _OMA_LPPe_OTDOA_RequestLocationInformation_assistanceAvailability,
        OMA_LPPe_OTDOA_RequestLocationInformation,
        _OMA_LPPe_OTDOA_ProvideCapabilities_eNodeB_AD_sup,
        _OMA_LPPe_OTDOA_ProvideCapabilities_home_eNodeB_AD_sup,
        OMA_LPPe_OTDOA_ProvideCapabilities,
        OMA_LPPe_OTDOA_RequestCapabilities,
        _OMA_LPPe_OTDOA_Error_locationServerErrorCauses,
        _OMA_LPPe_OTDOA_Error_targetDeviceErrorCauses,
        OMA_LPPe_OTDOA_Error,
        _OMA_LPPe_OTDOA_LocationServerErrorCauses_cause,
        OMA_LPPe_OTDOA_LocationServerErrorCauses,
        _OMA_LPPe_OTDOA_TargetDeviceErrorCauses_cause,
        OMA_LPPe_OTDOA_TargetDeviceErrorCauses,
        _OMA_LPPe_EOTD_ProvideAssistanceData_referenceBTS,
        _OMA_LPPe_EOTD_ProvideAssistanceData_msrAssistDataList,
        _OMA_LPPe_EOTD_ProvideAssistanceData_systemInfoAssistDataList,
        _OMA_LPPe_EOTD_ProvideAssistanceData_eotdError,
        OMA_LPPe_EOTD_ProvideAssistanceData,
        _OMA_LPPe_EOTD_ReferenceBTSForAssistance_bsicAndCarrier,
        _OMA_LPPe_EOTD_ReferenceBTSForAssistance_timeSlotScheme,
        __OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition_ellipsoidPoint,
        __OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition_ellipsoidPointWithAltitudeAndUncertaintyEllipsoid,
        _OMA_LPPe_EOTD_ReferenceBTSForAssistance_btsPosition,
        OMA_LPPe_EOTD_ReferenceBTSForAssistance,
        _OMA_LPPe_EOTD_MsrAssistDataList__item_,
        OMA_LPPe_EOTD_MsrAssistDataList,
        _OMA_LPPe_EOTD_MsrAssistBTS_bsicAndCarrier,
        _OMA_LPPe_EOTD_MsrAssistBTS_multiFrameOffset,
        _OMA_LPPe_EOTD_MsrAssistBTS_timeSlotScheme,
        _OMA_LPPe_EOTD_MsrAssistBTS_roughRTD,
        _OMA_LPPe_EOTD_MsrAssistBTS_expectedOTD,
        _OMA_LPPe_EOTD_MsrAssistBTS_calcAssistanceBTS,
        OMA_LPPe_EOTD_MsrAssistBTS,
        _OMA_LPPe_EOTD_SystemInfoAssistDataList__item_,
        OMA_LPPe_EOTD_SystemInfoAssistDataList,
        _OMA_LPPe_EOTD_SystemInfoAssistBTS_notPresent,
        _OMA_LPPe_EOTD_SystemInfoAssistBTS_present,
        OMA_LPPe_EOTD_SystemInfoAssistBTS,
        _OMA_LPPe_EOTD_AssistBTSData_bsic,
        _OMA_LPPe_EOTD_AssistBTSData_multiFrameOffset,
        _OMA_LPPe_EOTD_AssistBTSData_timeSlotScheme,
        _OMA_LPPe_EOTD_AssistBTSData_roughRTD,
        _OMA_LPPe_EOTD_AssistBTSData_expectedOTD,
        _OMA_LPPe_EOTD_AssistBTSData_calcAssistanceBTS,
        OMA_LPPe_EOTD_AssistBTSData,
        _OMA_LPPe_EOTD_CalcAssistanceBTS_fineRTD,
        _OMA_LPPe_EOTD_CalcAssistanceBTS_relativePos,
        OMA_LPPe_EOTD_CalcAssistanceBTS,
        _OMA_LPPe_EOTD_relativePos_relativeNorth,
        _OMA_LPPe_EOTD_relativePos_relativeEast,
        _OMA_LPPe_EOTD_relativePos_relativeAlt,
        OMA_LPPe_EOTD_relativePos,
        OMA_LPPe_EOTD_FineRTD,
        OMA_LPPe_EOTD_RelDistance,
        OMA_LPPe_EOTD_RelativeAlt,
        _OMA_LPPe_EOTD_RequestAssistanceData_eotdAssistanceReq,
        OMA_LPPe_EOTD_RequestAssistanceData,
        _OMA_LPPe_EOTD_ProvideLocationInformation_eotdMsrElement,
        _OMA_LPPe_EOTD_ProvideLocationInformation_eotdError,
        OMA_LPPe_EOTD_ProvideLocationInformation,
        _OMA_LPPe_EOTD_MsrElement_refFrameNumber,
        _OMA_LPPe_EOTD_MsrElement_referenceTimeSlot,
        _OMA_LPPe_EOTD_MsrElement_toaMeasurementsOfRef,
        _OMA_LPPe_EOTD_MsrElement_stdResolution,
        _OMA_LPPe_EOTD_MsrElement_taCorrection,
        __OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs__item_,
        _OMA_LPPe_EOTD_MsrElement_otd_FirstSetMsrs,
        OMA_LPPe_EOTD_MsrElement,
        _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_refQuality,
        _OMA_LPPe_EOTD_TOA_MeasurementsOfRef_numOfMeasurements,
        OMA_LPPe_EOTD_TOA_MeasurementsOfRef,
        _OMA_LPPe_EOTD_MeasurementWithID_neighborIdentity,
        _OMA_LPPe_EOTD_MeasurementWithID_nborTimeSlot,
        _OMA_LPPe_EOTD_MeasurementWithID_eotdQuality,
        _OMA_LPPe_EOTD_MeasurementWithID_otdValue,
        OMA_LPPe_EOTD_MeasurementWithID,
        _OMA_LPPe_EOTD_NeighborIdentity_bsicAndCarrier,
        _OMA_LPPe_EOTD_NeighborIdentity_ci,
        _OMA_LPPe_EOTD_NeighborIdentity_multiFrameCarrier,
        _OMA_LPPe_EOTD_NeighborIdentity_requestIndex,
        _OMA_LPPe_EOTD_NeighborIdentity_systemInfoIndex,
        _OMA_LPPe_EOTD_NeighborIdentity_ciAndLac,
        OMA_LPPe_EOTD_NeighborIdentity,
        _OMA_LPPe_EOTD_EOTDQuality_nbrOfMeasurements,
        _OMA_LPPe_EOTD_EOTDQuality_stdOfEOTD,
        OMA_LPPe_EOTD_EOTDQuality,
        OMA_LPPe_EOTD_OTDValue,
        OMA_LPPe_EOTD_CellID,
        OMA_LPPe_EOTD_RequestIndex,
        OMA_LPPe_EOTD_SystemInfoIndex,
        _OMA_LPPe_EOTD_MultiFrameCarrier_bcchCarrier,
        _OMA_LPPe_EOTD_MultiFrameCarrier_multiFrameOffset,
        OMA_LPPe_EOTD_MultiFrameCarrier,
        OMA_LPPe_EOTD_BCCHCarrier,
        OMA_LPPe_EOTD_RequestLocationInformation,
        _OMA_LPPe_EOTD_ProvideCapabilities_eotdSupport,
        OMA_LPPe_EOTD_ProvideCapabilities,
        OMA_LPPe_EOTD_RequestCapabilities,
        _OMA_LPPe_EOTD_Error_locationServerErrorCauses,
        _OMA_LPPe_EOTD_Error_targetDeviceErrorCauses,
        OMA_LPPe_EOTD_Error,
        _OMA_LPPe_EOTD_LocationServerErrorCauses_cause,
        OMA_LPPe_EOTD_LocationServerErrorCauses,
        _OMA_LPPe_EOTD_TargetDeviceErrorCauses_cause,
        OMA_LPPe_EOTD_TargetDeviceErrorCauses,
        OMA_LPPe_EOTD_TimeSlotScheme,
        OMA_LPPe_EOTD_MultiFrameOffset,
        OMA_LPPe_EOTD_RoughRTD,
        _OMA_LPPe_EOTD_ExpectedOTD_expectedOTD,
        _OMA_LPPe_EOTD_ExpectedOTD_expOTDUncertainty,
        OMA_LPPe_EOTD_ExpectedOTD,
        OMA_LPPe_EOTD_ModuloTimeSlot,
        _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_referenceCellInfo,
        _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_neigborCellList,
        _OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData_otdoaUtraError,
        OMA_LPPe_OTDOA_UTRA_ProvideAssistanceData,
        _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_sfn,
        ___OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd_primaryCPICH_info,
        __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_fdd,
        ___OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd_cellAndChannelIdentity,
        __OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo_tdd,
        _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_modeSpecificInfo,
        _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_frequencyInfo,
        _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_refPosAssist,
        _OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo_ipdl_parameters,
        OMA_LPPe_OTDOA_UTRA_ReferenceCellInfo,
        __OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition_ellipsoidPoint,
        __OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition_ellipsoidPointWithAltitude,
        _OMA_LPPe_OTDOA_UTRA_RefPosAssist_cellPosition,
        _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTime,
        _OMA_LPPe_OTDOA_UTRA_RefPosAssist_roundTripTimeExtension,
        OMA_LPPe_OTDOA_UTRA_RefPosAssist,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellList__item_,
        OMA_LPPe_OTDOA_UTRA_NeighborCellList,
        ___OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd_primaryCPICH_info,
        __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_fdd,
        ___OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd_cellAndChannelIdentity,
        __OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo_tdd,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_modeSpecificInfo,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_frequencyInfo,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_ipdl_parameters,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_SFN_relTimeDifference,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_offsetValidity,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_sfn_SFN_drift,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_searchWindowSize,
        _OMA_LPPe_OTDOA_UTRA_NeighborCellInfo_positioningAssistance,
        OMA_LPPe_OTDOA_UTRA_NeighborCellInfo,
        _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_offset,
        _OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1_sfn_sfn_relTimeDifference,
        OMA_LPPe_OTDOA_UTRA_SFN_SFN_RelTimeDifference1,
        _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeNorth,
        _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeEast,
        _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_relativeAltitude,
        _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_fineSFN_SFN,
        _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTime,
        _OMA_LPPe_OTDOA_UTRA_PositioningAssistance_roundTripTimeExtension,
        OMA_LPPe_OTDOA_UTRA_PositioningAssistance,
        utra_maxCellMeas,
        OMA_LPPe_OTDOA_UTRA_SFN_OffsetValidity,
        OMA_LPPe_OTDOA_UTRA_SFN_SFN_Drift,
        OMA_LPPe_OTDOA_UTRA_SearchWindowSize,
        OMA_LPPe_OTDOA_UTRA_fineSFN_SFN,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_spacing,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_length,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_seed,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd_burstModeParameters,
        __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_fdd,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_spacing_tdd,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_slot,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_start,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_ip_PCCPCH,
        ___OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd_burstModeParameters,
        __OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo_tdd,
        _OMA_LPPe_OTDOA_UTRA_IPDL_Parameters_modeSpecificInfo,
        OMA_LPPe_OTDOA_UTRA_IPDL_Parameters,
        OMA_LPPe_OTDOA_UTRA_IP_Spacing,
        OMA_LPPe_OTDOA_UTRA_IP_Length,
        OMA_LPPe_OTDOA_UTRA_IP_Spacing_TDD,
        OMA_LPPe_OTDOA_UTRA_IP_PCCPCH,
        _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstStart,
        _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstLength,
        _OMA_LPPe_OTDOA_UTRA_BurstModeParameters_burstFreq,
        OMA_LPPe_OTDOA_UTRA_BurstModeParameters,
        _OMA_LPPe_OTDOA_UTRA_RequestAssistanceData_otdoaUtraAssistanceReq,
        OMA_LPPe_OTDOA_UTRA_RequestAssistanceData,
        _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_otdoaUtraMeasurement,
        _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_otdoaUtraError,
        _OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation_timeStampData,
        OMA_LPPe_OTDOA_UTRA_ProvideLocationInformation,
        _OMA_LPPe_OTDOA_UTRA_Measurement_sfn,
        ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd_referenceCellIdentity,
        ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd_ue_RX_TX_TimeDifferenceType2Info,
        __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_fdd,
        ___OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd_cellAndChannelIdentity,
        __OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas_tdd,
        _OMA_LPPe_OTDOA_UTRA_Measurement_modeSpecificInfoMeas,
        _OMA_LPPe_OTDOA_UTRA_Measurement_neighborList,
        OMA_LPPe_OTDOA_UTRA_Measurement,
        _OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info_ue_RX_TX_timeDifferenceType2,
        _OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info_neighborQuality,
        OMA_LPPe_OTDOA_UTRA_UE_RX_TX_TimeDifferenceType2Info,
        OMA_LPPe_OTDOA_UTRA_TimeDifferenceType2,
        _OMA_LPPe_OTDOA_UTRA_NeighborList__item_,
        OMA_LPPe_OTDOA_UTRA_NeighborList,
        ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd_neighborIdentity,
        ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd_ue_RX_TX_timeDifferenceType2Info,
        __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_fdd,
        ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd_cellAndChannelIdentity,
        ___OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd_uarfcn,
        __OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo_tdd,
        _OMA_LPPe_OTDOA_UTRA_Neighbor_modeSpecificInfo,
        _OMA_LPPe_OTDOA_UTRA_Neighbor_neighborQuality,
        _OMA_LPPe_OTDOA_UTRA_Neighbor_sfn_sfn_ObsTimeDifference2,
        OMA_LPPe_OTDOA_UTRA_Neighbor,
        _OMA_LPPe_OTDOA_UTRA_NeighborQuality_quality,
        OMA_LPPe_OTDOA_UTRA_NeighborQuality,
        OMA_LPPe_OTDOA_UTRA_SFN_SFN_ObsTimeDifference2,
        _OMA_LPPe_OTDOA_UTRA_Quality_stdResolution,
        _OMA_LPPe_OTDOA_UTRA_Quality_numberOfOTDOA_Measurements,
        _OMA_LPPe_OTDOA_UTRA_Quality_stdOfOTDOA_Measurements,
        OMA_LPPe_OTDOA_UTRA_Quality,
        _OMA_LPPe_OTDOA_UTRA_TimeStampData_sfn,
        _OMA_LPPe_OTDOA_UTRA_TimeStampData_utraCellGlobalID,
        _OMA_LPPe_OTDOA_UTRA_TimeStampData_frequencyInfo,
        __OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID_primaryScramblingCode,
        __OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID_cellParametersId,
        _OMA_LPPe_OTDOA_UTRA_TimeStampData_nonUniqueCellID,
        OMA_LPPe_OTDOA_UTRA_TimeStampData,
        OMA_LPPe_OTDOA_UTRA_RequestLocationInformation,
        _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ueBasedSupported,
        _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ueAssistedSupported,
        _OMA_LPPe_OTDOA_UTRA_ProvideCapabilities_ipdlSupported,
        OMA_LPPe_OTDOA_UTRA_ProvideCapabilities,
        OMA_LPPe_OTDOA_UTRA_RequestCapabilities,
        _OMA_LPPe_OTDOA_UTRA_Error_locationServerErrorCauses,
        _OMA_LPPe_OTDOA_UTRA_Error_targetDeviceErrorCauses,
        OMA_LPPe_OTDOA_UTRA_Error,
        _OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses_cause,
        OMA_LPPe_OTDOA_UTRA_LocationServerErrorCauses,
        _OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses_cause,
        OMA_LPPe_OTDOA_UTRA_TargetDeviceErrorCauses,
        _OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info_primaryScramblingCode,
        OMA_LPPe_OTDOA_UTRA_PrimaryCPICH_Info,
        OMA_LPPe_OTDOA_UTRA_PrimaryScramblingCode,
        _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_burstType,
        _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_midambleShift,
        _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_timeslot,
        _OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity_cellParametersID,
        OMA_LPPe_OTDOA_UTRA_CellAndChannelIdentity,
        OMA_LPPe_OTDOA_UTRA_BurstType,
        OMA_LPPe_OTDOA_UTRA_MidambleShiftLong,
        OMA_LPPe_OTDOA_UTRA_TimeSlotNumber,
        OMA_LPPe_OTDOA_UTRA_CellParametersID,
        __OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData__item_,
        _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_NetworkData,
        _OMA_LPPe_ECID_LTE_ProvideAssistanceData_ecid_LTE_Error,
        OMA_LPPe_ECID_LTE_ProvideAssistanceData,
        maxLTENetworks,
        ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc__item_,
        __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mcc,
        ___OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc__item_,
        __OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity_mnc,
        _OMA_LPPe_ECID_LTE_NetworkData_plmn_Identity,
        _OMA_LPPe_ECID_LTE_NetworkData_multiple_PLMNs,
        _OMA_LPPe_ECID_LTE_NetworkData_reference_location,
        __OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list__item_,
        _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_eNodeB_list,
        __OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list__item_,
        _OMA_LPPe_ECID_LTE_NetworkData_ecid_lte_HeNB_list,
        OMA_LPPe_ECID_LTE_NetworkData,
        maxLTEeNBs,
        maxLTEHeNBs,
        _OMA_LPPe_ECID_LTE_eNodeBData_relative_location,
        __OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData__item_,
        _OMA_LPPe_ECID_LTE_eNodeBData_ecid_lte_eNodeB_CellData,
        OMA_LPPe_ECID_LTE_eNodeBData,
        maxLTEMacroCells,
        _OMA_LPPe_ECID_LTE_HeNBData_relative_location,
        _OMA_LPPe_ECID_LTE_HeNBData_location_reliability,
        _OMA_LPPe_ECID_LTE_HeNBData_coverageArea,
        _OMA_LPPe_ECID_LTE_HeNBData_ecid_lte_HeNB_CellData,
        OMA_LPPe_ECID_LTE_HeNBData,
        _OMA_LPPe_ECID_LTE_CellData_physCellId,
        _OMA_LPPe_ECID_LTE_CellData_cellIdentity,
        _OMA_LPPe_ECID_LTE_CellData_dl_CarrierFreq,
        _OMA_LPPe_ECID_LTE_CellData_rs_transmit_power,
        _OMA_LPPe_ECID_LTE_CellData_antennaPortConfig,
        _OMA_LPPe_ECID_LTE_CellData_antenna_gain,
        _OMA_LPPe_ECID_LTE_CellData_beam_width,
        _OMA_LPPe_ECID_LTE_CellData_transmit_direction,
        _OMA_LPPe_ECID_LTE_CellData_frequency_accuracy,
        OMA_LPPe_ECID_LTE_CellData,
        _OMA_LPPe_ECID_LTE_RequestAssistanceData_eNBrequestedAD,
        _OMA_LPPe_ECID_LTE_RequestAssistanceData_heNBrequestedAD,
        OMA_LPPe_ECID_LTE_RequestAssistanceData,
        __OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation__item_,
        _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_CombinedLocationInformation,
        _OMA_LPPe_ECID_LTE_ProvideLocationInformation_ecid_LTE_Error,
        OMA_LPPe_ECID_LTE_ProvideLocationInformation,
        _OMA_LPPe_ECID_LTE_LocationInformationList_ecid_LTE_LocationInformation,
        _OMA_LPPe_ECID_LTE_LocationInformationList_relativeTimeStamp,
        _OMA_LPPe_ECID_LTE_LocationInformationList_servingFlag,
        OMA_LPPe_ECID_LTE_LocationInformationList,
        maxLTEECIDSize,
        _OMA_LPPe_ECID_LTE_LocationInformation_lpp_ECID_SignalMeasurementInformation,
        OMA_LPPe_ECID_LTE_LocationInformation,
        _OMA_LPPe_ECID_LTE_RequestLocationInformation_requestedMeasurements,
        OMA_LPPe_ECID_LTE_RequestLocationInformation,
        _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_MeasSupported,
        _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_lte_eNodeB_ADSupported,
        _OMA_LPPe_ECID_LTE_ProvideCapabilities_ecid_utra_HeNB_ADSupported,
        OMA_LPPe_ECID_LTE_ProvideCapabilities,
        OMA_LPPe_ECID_LTE_RequestCapabilities,
        _OMA_LPPe_ECID_LTE_Error_locationServerErrorCauses,
        _OMA_LPPe_ECID_LTE_Error_targetDeviceErrorCauses,
        OMA_LPPe_ECID_LTE_Error,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_cause,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBMandatoryDataUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBLocationsUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellTransmitPowerUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellAntennaPortConfigUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcallAntennaGainUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellBeamWidthUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellTransmitDirectionUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBcellFrequencyAccuracyUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_eNodeBnonservingADUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBMandatoryDataUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBLocationUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBLocationReliabilityUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellTransmitPowerUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellAntennaPortConfigUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBcellFrequencyAccuracyUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBCoverageAreaUnavailable,
        _OMA_LPPe_ECID_LTE_LocationServerErrorCauses_heNBnonservingADUnavailable,
        OMA_LPPe_ECID_LTE_LocationServerErrorCauses,
        _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_cause,
        _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_rsrpMeasurementNotPossible,
        _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_rsrqMeasurementNotPossible,
        _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_ueRxTxMeasurementNotPossible,
        _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable,
        _OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses_historicMeasurementsNotAvailable,
        OMA_LPPe_ECID_LTE_TargetDeviceErrorCauses,
        __OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData__item_,
        _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_NetworkData,
        _OMA_LPPe_ECID_GSM_ProvideAssistanceData_ecid_gsm_Error,
        OMA_LPPe_ECID_GSM_ProvideAssistanceData,
        maxGSMNetworks,
        ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc__item_,
        __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mcc,
        ___OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc__item_,
        __OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity_mnc,
        _OMA_LPPe_ECID_GSM_NetworkData_plmn_Identity,
        _OMA_LPPe_ECID_GSM_NetworkData_reference_location,
        __OMA_LPPe_ECID_GSM_NetworkData_base_station_list__item_,
        _OMA_LPPe_ECID_GSM_NetworkData_base_station_list,
        OMA_LPPe_ECID_GSM_NetworkData,
        maxGSMBaseStations,
        _OMA_LPPe_ECID_GSM_BaseStationData_relative_location,
        __OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData__item_,
        _OMA_LPPe_ECID_GSM_BaseStationData_ecid_gsm_CellData,
        OMA_LPPe_ECID_GSM_BaseStationData,
        maxGSMCells,
        _OMA_LPPe_ECID_GSM_CellData_cellNonUniqueIDGERAN,
        _OMA_LPPe_ECID_GSM_CellData_cellLocalIDGERAN,
        _OMA_LPPe_ECID_GSM_CellData_transmit_power,
        _OMA_LPPe_ECID_GSM_CellData_antenna_gain,
        _OMA_LPPe_ECID_GSM_CellData_beam_width,
        _OMA_LPPe_ECID_GSM_CellData_transmit_direction,
        _OMA_LPPe_ECID_GSM_CellData_frequency_accuracy,
        OMA_LPPe_ECID_GSM_CellData,
        _OMA_LPPe_ECID_GSM_RequestAssistanceData_requestedAD,
        OMA_LPPe_ECID_GSM_RequestAssistanceData,
        __OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation__item_,
        _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_CombinedLocationInformation,
        _OMA_LPPe_ECID_GSM_ProvideLocationInformation_ecid_GSM_Error,
        OMA_LPPe_ECID_GSM_ProvideLocationInformation,
        _OMA_LPPe_ECID_GSM_LocationInformationList_ecid_GSM_LocationInformation,
        _OMA_LPPe_ECID_GSM_LocationInformationList_relativeTimeStamp,
        _OMA_LPPe_ECID_GSM_LocationInformationList_servingFlag,
        OMA_LPPe_ECID_GSM_LocationInformationList,
        maxGSMECIDSize,
        _OMA_LPPe_ECID_GSM_LocationInformation_cellGlobalIdGERAN,
        _OMA_LPPe_ECID_GSM_LocationInformation_rxLevel,
        _OMA_LPPe_ECID_GSM_LocationInformation_tA,
        _OMA_LPPe_ECID_GSM_LocationInformation_nMR_GERAN,
        OMA_LPPe_ECID_GSM_LocationInformation,
        __OMA_LPPe_NMR_GERAN__item__cellNonUniqueIDGERAN,
        __OMA_LPPe_NMR_GERAN__item__cellLocalIDGERAN,
        __OMA_LPPe_NMR_GERAN__item__rxLevel,
        _OMA_LPPe_NMR_GERAN__item_,
        OMA_LPPe_NMR_GERAN,
        _OMA_LPPe_ECID_GSM_RequestLocationInformation_requestedMeasurements,
        OMA_LPPe_ECID_GSM_RequestLocationInformation,
        _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_MeasSupported,
        _OMA_LPPe_ECID_GSM_ProvideCapabilities_ecid_gsm_ADSupported,
        OMA_LPPe_ECID_GSM_ProvideCapabilities,
        OMA_LPPe_ECID_GSM_RequestCapabilities,
        _OMA_LPPe_ECID_GSM_Error_locationServerErrorCauses,
        _OMA_LPPe_ECID_GSM_Error_targetDeviceErrorCauses,
        OMA_LPPe_ECID_GSM_Error,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cause,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_mandatoryDataUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_bsLocationsUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellTransmitPowerUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_callAntennaGainUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellBeamWidthUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellTransmitDirectionUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_cellFrequencyAccuracyUnavailable,
        _OMA_LPPe_ECID_GSM_LocationServerErrorCauses_nonservingADUnavailable,
        OMA_LPPe_ECID_GSM_LocationServerErrorCauses,
        _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_cause,
        _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_rxLevelMeasurementNotPossible,
        _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_taMeasurementNotPossible,
        _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_nMRMeasurementNotPossible,
        _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable,
        _OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses_historicMeasurementsNotAvailable,
        OMA_LPPe_ECID_GSM_TargetDeviceErrorCauses,
        __OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData__item_,
        _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_NetworkData,
        _OMA_LPPe_ECID_UTRA_ProvideAssistanceData_ecid_UTRA_Error,
        OMA_LPPe_ECID_UTRA_ProvideAssistanceData,
        maxUTRANetworks,
        ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc__item_,
        __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mcc,
        ___OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc__item_,
        __OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity_mnc,
        _OMA_LPPe_ECID_UTRA_NetworkData_plmn_Identity,
        _OMA_LPPe_ECID_UTRA_NetworkData_multiple_PLMNs,
        _OMA_LPPe_ECID_UTRA_NetworkData_reference_location,
        __OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list__item_,
        _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_nodeB_list,
        __OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list__item_,
        _OMA_LPPe_ECID_UTRA_NetworkData_ecid_utra_HNB_list,
        OMA_LPPe_ECID_UTRA_NetworkData,
        maxUTRAnodeBs,
        maxUTRAHNBs,
        _OMA_LPPe_ECID_UTRA_NodeBData_relative_location,
        __OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData__item_,
        _OMA_LPPe_ECID_UTRA_NodeBData_ecid_utra_nodeB_CellData,
        OMA_LPPe_ECID_UTRA_NodeBData,
        maxUTRAMacroCells,
        _OMA_LPPe_ECID_UTRA_HNBData_relative_location,
        _OMA_LPPe_ECID_UTRA_HNBData_location_reliability,
        _OMA_LPPe_ECID_UTRA_HNBData_coverageArea,
        _OMA_LPPe_ECID_UTRA_HNBData_ecid_utra_HNB_CellData,
        OMA_LPPe_ECID_UTRA_HNBData,
        _OMA_LPPe_ECID_UTRA_CellData_cellIdentity,
        ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Scrambling_Code,
        ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_primaryCPICH_Tx_Power,
        ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd_uarfcn_dl,
        __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_fdd,
        ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_cellParametersID,
        ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_primaryCCPCH_Tx_Power,
        ___OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd_uarfcn_nt,
        __OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo_tdd,
        _OMA_LPPe_ECID_UTRA_CellData_modeSpecificInfo,
        _OMA_LPPe_ECID_UTRA_CellData_antenna_gain,
        _OMA_LPPe_ECID_UTRA_CellData_beam_width,
        _OMA_LPPe_ECID_UTRA_CellData_transmit_direction,
        _OMA_LPPe_ECID_UTRA_CellData_frequency_accuracy,
        OMA_LPPe_ECID_UTRA_CellData,
        _OMA_LPPe_ECID_UTRA_RequestAssistanceData_nBrequestedAD,
        _OMA_LPPe_ECID_UTRA_RequestAssistanceData_hNBrequestedAD,
        OMA_LPPe_ECID_UTRA_RequestAssistanceData,
        __OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation__item_,
        _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_UTRA_CombinedLocationInformation,
        _OMA_LPPe_ECID_UTRA_ProvideLocationInformation_ecid_Error,
        OMA_LPPe_ECID_UTRA_ProvideLocationInformation,
        _OMA_LPPe_ECID_UTRA_LocationInformationList_ecid_utra_LocationInformation,
        _OMA_LPPe_ECID_UTRA_LocationInformationList_relativeTimeStamp,
        _OMA_LPPe_ECID_UTRA_LocationInformationList_servingFlag,
        OMA_LPPe_ECID_UTRA_LocationInformationList,
        maxECIDUTRASize,
        _OMA_LPPe_ECID_UTRA_LocationInformation_cellGlobalIdUTRA,
        _OMA_LPPe_ECID_UTRA_LocationInformation_frequencyInfo,
        _OMA_LPPe_ECID_UTRA_LocationInformation_primaryScramblingCode,
        _OMA_LPPe_ECID_UTRA_LocationInformation_measuredResultsList,
        _OMA_LPPe_ECID_UTRA_LocationInformation_cellParametersId,
        _OMA_LPPe_ECID_UTRA_LocationInformation_utratimingAdvance,
        OMA_LPPe_ECID_UTRA_LocationInformation,
        _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tA,
        _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_tAResolution,
        _OMA_LPPe_ECID_UTRA_UTRATimingAdvance_chipRate,
        OMA_LPPe_ECID_UTRA_UTRATimingAdvance,
        OMA_LPPe_ECID_UTRA_TAResolution,
        OMA_LPPe_ECID_UTRA_ChipRate,
        _OMA_LPPe_UTRA_FrequencyInfo_modeSpecificInfo,
        OMA_LPPe_UTRA_FrequencyInfo,
        _OMA_LPPe_UTRA_ModeSpecificInfo_fdd,
        _OMA_LPPe_UTRA_ModeSpecificInfo_tdd,
        OMA_LPPe_UTRA_ModeSpecificInfo,
        _OMA_LPPe_UTRA_FrequencyInfoFDD_uarfcn_UL,
        _OMA_LPPe_UTRA_FrequencyInfoFDD_uarfcn_DL,
        OMA_LPPe_UTRA_FrequencyInfoFDD,
        _OMA_LPPe_UTRA_FrequencyInfoTDD_uarfcn_Nt,
        OMA_LPPe_UTRA_FrequencyInfoTDD,
        _OMA_LPPe_ECID_UTRA_MeasuredResultsList__item_,
        OMA_LPPe_ECID_UTRA_MeasuredResultsList,
        _OMA_LPPe_ECID_UTRA_MeasuredResults_frequencyInfo,
        _OMA_LPPe_ECID_UTRA_MeasuredResults_utra_CarrierRSSI,
        _OMA_LPPe_ECID_UTRA_MeasuredResults_cellMeasuredResultsList,
        OMA_LPPe_ECID_UTRA_MeasuredResults,
        _OMA_LPPe_ECID_UTRA_CellMeasuredResultsList__item_,
        OMA_LPPe_ECID_UTRA_CellMeasuredResultsList,
        OMA_LPPe_ECID_UTRA_CarrierRSSI,
        _OMA_LPPe_ECID_UTRA_CellMeasuredResults_cellIdentity,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_primaryCPICH_Info,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_cpich_Ec_N0,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_cpich_RSCP,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd_pathloss,
        __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_fdd,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_cellParametersID,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_primaryCCPCH_RSCP,
        ___OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd_pathloss,
        __OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo_tdd,
        _OMA_LPPe_ECID_UTRA_CellMeasuredResults_modeSpecificInfo,
        OMA_LPPe_ECID_UTRA_CellMeasuredResults,
        OMA_LPPe_ECID_UTRA_PrimaryCCPCH_RSCP,
        OMA_LPPe_ECID_UTRA_CPICH_Ec_N0,
        OMA_LPPe_ECID_UTRA_CPICH_RSCP,
        OMA_LPPe_ECID_UTRA_Pathloss,
        maxFreq,
        _OMA_LPPe_ECID_UTRA_RequestLocationInformation_requestedMeasurements,
        OMA_LPPe_ECID_UTRA_RequestLocationInformation,
        _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_MeasSupported,
        _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_nodeB_ADSupported,
        _OMA_LPPe_ECID_UTRA_ProvideCapabilities_ecid_utra_HNB_ADSupported,
        OMA_LPPe_ECID_UTRA_ProvideCapabilities,
        OMA_LPPe_ECID_UTRA_RequestCapabilities,
        _OMA_LPPe_ECID_UTRA_Error_locationServerErrorCauses,
        _OMA_LPPe_ECID_UTRA_Error_targetDeviceErrorCauses,
        OMA_LPPe_ECID_UTRA_Error,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_cause,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBMandatoryDataUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBLocationUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellTransmitPowerUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcallAntennaGainUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellBeamWidthUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellTransmitDirectionUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBcellFrequencyAccuracyUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_nodeBnonservingADUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBMandatoryDataUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBLocationUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBLocationReliabilityUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBcellTransmitPowerUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBcellFrequencyAccuracyUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBCoverageAreaUnavailable,
        _OMA_LPPe_ECID_UTRA_LocationServerErrorCauses_hNBnonservingADUnavailable,
        OMA_LPPe_ECID_UTRA_LocationServerErrorCauses,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_cause,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRLMeasurementsNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_tdd_timingAdvanceMeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_utra_CarrierRSSIMeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_cpich_Ec_N0MeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_cpich_RSCPMeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_FDD_pathlossMeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_TDD_primaryCCPCH_RSCPMeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_mRL_TDD_pathlossMeasurementNotPossible,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable,
        _OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses_historicMeasurementsNotAvailable,
        OMA_LPPe_ECID_UTRA_TargetDeviceErrorCauses,
        __OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet__item_,
        _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_DataSet,
        _OMA_LPPe_WLAN_AP_ProvideAssistanceData_wlan_AP_Error,
        OMA_LPPe_WLAN_AP_ProvideAssistanceData,
        maxWLANDataSets,
        ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc__item_,
        __OMA_LPPe_WLAN_DataSet_plmn_Identity_mcc,
        ___OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc__item_,
        __OMA_LPPe_WLAN_DataSet_plmn_Identity_mnc,
        _OMA_LPPe_WLAN_DataSet_plmn_Identity,
        _OMA_LPPe_WLAN_DataSet_reference_point,
        _OMA_LPPe_WLAN_DataSet_supported_channels_11a,
        _OMA_LPPe_WLAN_DataSet_supported_channels_11bg,
        __OMA_LPPe_WLAN_DataSet_wlan_ap_list__item_,
        _OMA_LPPe_WLAN_DataSet_wlan_ap_list,
        OMA_LPPe_WLAN_DataSet,
        maxWLANAPs,
        _Supported_Channels_11a_ch34,
        _Supported_Channels_11a_ch36,
        _Supported_Channels_11a_ch38,
        _Supported_Channels_11a_ch40,
        _Supported_Channels_11a_ch42,
        _Supported_Channels_11a_ch44,
        _Supported_Channels_11a_ch46,
        _Supported_Channels_11a_ch48,
        _Supported_Channels_11a_ch52,
        _Supported_Channels_11a_ch56,
        _Supported_Channels_11a_ch60,
        _Supported_Channels_11a_ch64,
        _Supported_Channels_11a_ch149,
        _Supported_Channels_11a_ch153,
        _Supported_Channels_11a_ch157,
        _Supported_Channels_11a_ch161,
        Supported_Channels_11a,
        _Supported_Channels_11bg_ch1,
        _Supported_Channels_11bg_ch2,
        _Supported_Channels_11bg_ch3,
        _Supported_Channels_11bg_ch4,
        _Supported_Channels_11bg_ch5,
        _Supported_Channels_11bg_ch6,
        _Supported_Channels_11bg_ch7,
        _Supported_Channels_11bg_ch8,
        _Supported_Channels_11bg_ch9,
        _Supported_Channels_11bg_ch10,
        _Supported_Channels_11bg_ch11,
        _Supported_Channels_11bg_ch12,
        _Supported_Channels_11bg_ch13,
        _Supported_Channels_11bg_ch14,
        Supported_Channels_11bg,
        _OMA_LPPe_WLAN_AP_Data_wlan_ap_id,
        _OMA_LPPe_WLAN_AP_Data_relative_location,
        _OMA_LPPe_WLAN_AP_Data_location_reliability,
        __OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data__item_,
        _OMA_LPPe_WLAN_AP_Data_wlan_ap_Type_Data,
        _OMA_LPPe_WLAN_AP_Data_coverageArea,
        OMA_LPPe_WLAN_AP_Data,
        maxWLANTypes,
        _OMA_LPPe_WLAN_AP_Type_Data_wlan_AP_Type,
        _OMA_LPPe_WLAN_AP_Type_Data_transmit_power,
        _OMA_LPPe_WLAN_AP_Type_Data_antenna_gain,
        _OMA_LPPe_WLAN_AP_Type_Data_coverageArea,
        OMA_LPPe_WLAN_AP_Type_Data,
        _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAD,
        _OMA_LPPe_WLAN_AP_RequestAssistanceData_requestedAPTypes,
        OMA_LPPe_WLAN_AP_RequestAssistanceData,
        __OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation__item_,
        _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_CombinedLocationInformation,
        _OMA_LPPe_WLAN_AP_ProvideLocationInformation_wlan_AP_Error,
        OMA_LPPe_WLAN_AP_ProvideLocationInformation,
        _OMA_LPPe_WLAN_AP_LocationInformationList_wlan_AP_LocationInformation,
        _OMA_LPPe_WLAN_AP_LocationInformationList_relativeTimeStamp,
        _OMA_LPPe_WLAN_AP_LocationInformationList_servingFlag,
        OMA_LPPe_WLAN_AP_LocationInformationList,
        maxWLANAPSize,
        _OMA_LPPe_WLAN_AP_LocationInformation_apMACAddress,
        _OMA_LPPe_WLAN_AP_LocationInformation_apSSID,
        _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoise,
        _OMA_LPPe_WLAN_AP_LocationInformation_apDeviceType,
        _OMA_LPPe_WLAN_AP_LocationInformation_apPHYtype,
        _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrength,
        _OMA_LPPe_WLAN_AP_LocationInformation_apChannelFrequency,
        _OMA_LPPe_WLAN_AP_LocationInformation_apRoundTripDelay,
        _OMA_LPPe_WLAN_AP_LocationInformation_ueTransmitPower,
        _OMA_LPPe_WLAN_AP_LocationInformation_ueAntennaGain,
        _OMA_LPPe_WLAN_AP_LocationInformation_apReportedLocation,
        _OMA_LPPe_WLAN_AP_LocationInformation_apTransmitPower,
        _OMA_LPPe_WLAN_AP_LocationInformation_apAntennaGain,
        _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoise,
        _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrength,
        _OMA_LPPe_WLAN_AP_LocationInformation_apSignalStrengthDelta,
        _OMA_LPPe_WLAN_AP_LocationInformation_ueSignalStrengthDelta,
        _OMA_LPPe_WLAN_AP_LocationInformation_apSignaltoNoiseDelta,
        _OMA_LPPe_WLAN_AP_LocationInformation_ueSignaltoNoiseDelta,
        _OMA_LPPe_WLAN_AP_LocationInformation_operatingClass,
        OMA_LPPe_WLAN_AP_LocationInformation,
        OMA_LPPe_WLAN_AP_PHY_Type,
        _OMA_LPPe_WLAN_RTD_rTDValue,
        _OMA_LPPe_WLAN_RTD_rTDUnits,
        _OMA_LPPe_WLAN_RTD_rTDAccuracy,
        OMA_LPPe_WLAN_RTD,
        OMA_LPPe_WLAN_RTDUnits,
        _OMA_LPPe_WLAN_ReportedLocation_locationDataLCI,
        OMA_LPPe_WLAN_ReportedLocation,
        _OMA_LPPe_WLAN_LocationDataLCI_latitudeResolution,
        _OMA_LPPe_WLAN_LocationDataLCI_latitude,
        _OMA_LPPe_WLAN_LocationDataLCI_longitudeResolution,
        _OMA_LPPe_WLAN_LocationDataLCI_longitude,
        _OMA_LPPe_WLAN_LocationDataLCI_altitudeType,
        _OMA_LPPe_WLAN_LocationDataLCI_altitudeResolution,
        _OMA_LPPe_WLAN_LocationDataLCI_altitude,
        _OMA_LPPe_WLAN_LocationDataLCI_datum,
        OMA_LPPe_WLAN_LocationDataLCI,
        _OMA_LPPe_WLAN_AP_RequestLocationInformation_requestedMeasurements,
        _OMA_LPPe_WLAN_AP_RequestLocationInformation_additionalRequestedMeasurements,
        OMA_LPPe_WLAN_AP_RequestLocationInformation,
        _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ecid_MeasSupported,
        _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_types_Supported,
        _OMA_LPPe_WLAN_AP_ProvideCapabilities_ap_Capability,
        _OMA_LPPe_WLAN_AP_ProvideCapabilities_wlan_ap_ADSupported,
        _OMA_LPPe_WLAN_AP_ProvideCapabilities_additional_wlan_ecid_MeasSupported,
        OMA_LPPe_WLAN_AP_ProvideCapabilities,
        _OMA_LPPe_WLAN_AP_Capability_apMACAddress,
        _OMA_LPPe_WLAN_AP_Capability_apTypes,
        OMA_LPPe_WLAN_AP_Capability,
        OMA_LPPe_WLAN_AP_RequestCapabilities,
        _OMA_LPPe_WLAN_AP_Error_locationServerErrorCauses,
        _OMA_LPPe_WLAN_AP_Error_targetDeviceErrorCauses,
        OMA_LPPe_WLAN_AP_Error,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_cause,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apMandatoryDataUnavailable,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apLocationsUnavailable,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apLocationReliabilityUnavailable,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apTransmitPowerUnavailable,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apAntennaGainUnavailable,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_apCoverageAreaUnavailable,
        _OMA_LPPe_WLAN_AP_LocationServerErrorCauses_nonservingADUnavailable,
        OMA_LPPe_WLAN_AP_LocationServerErrorCauses,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_cause,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apSSIDnotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apSNMeasurementNotPossible,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apDevTypeNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apPhyTypeNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRSSIMeasurementNotPossible,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apChanFreqNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRTDMeasurementNotPossible,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueTPNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueAGNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apRecLocNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_historicMeasurementsNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apTPNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_apAGNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueSNNotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ueRSSINotAvailable,
        _OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses_ocNotAvailable,
        OMA_LPPe_WLAN_AP_TargetDeviceErrorCauses,
        __OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation__item_,
        _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_CombinedLocationInformation,
        _OMA_LPPe_ECID_WiMax_ProvideLocationInformation_ecid_wimax_Error,
        OMA_LPPe_ECID_WiMax_ProvideLocationInformation,
        _OMA_LPPe_ECID_WiMax_LocationInformationList_ecid_wimax_LocationInformation,
        _OMA_LPPe_ECID_WiMax_LocationInformationList_relativeTimeStamp,
        _OMA_LPPe_ECID_WiMax_LocationInformationList_servingFlag,
        OMA_LPPe_ECID_WiMax_LocationInformationList,
        maxWiMaxECIDSize,
        _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxBsID,
        _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxRTD,
        _OMA_LPPe_ECID_WiMax_LocationInformation_wimaxNMRList,
        OMA_LPPe_ECID_WiMax_LocationInformation,
        _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_MSB,
        _OMA_LPPe_ECID_WiMax_WimaxBsID_bsID_LSB,
        OMA_LPPe_ECID_WiMax_WimaxBsID,
        _OMA_LPPe_ECID_WiMax_WimaxRTD_rTD,
        _OMA_LPPe_ECID_WiMax_WimaxRTD_rTDstd,
        OMA_LPPe_ECID_WiMax_WimaxRTD,
        _OMA_LPPe_ECID_WiMax_WimaxNMRList__item_,
        OMA_LPPe_ECID_WiMax_WimaxNMRList,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_wimaxBsID,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelay,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_relDelaystd,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSI,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_rSSIstd,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_bSTxPower,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_cINR,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_cINRstd,
        _OMA_LPPe_ECID_WiMax_WimaxNMR_bSLocation,
        OMA_LPPe_ECID_WiMax_WimaxNMR,
        maxWimaxBSMeas,
        _OMA_LPPe_ECID_WiMax_RequestLocationInformation_requestedMeasurements,
        OMA_LPPe_ECID_WiMax_RequestLocationInformation,
        _OMA_LPPe_ECID_WiMax_ProvideCapabilities_ecid_wimax_MeasSupported,
        OMA_LPPe_ECID_WiMax_ProvideCapabilities,
        OMA_LPPe_ECID_WiMax_RequestCapabilities,
        _OMA_LPPe_ECID_WiMax_Error_locationServerErrorCauses,
        _OMA_LPPe_ECID_WiMax_Error_targetDeviceErrorCauses,
        OMA_LPPe_ECID_WiMax_Error,
        _OMA_LPPe_ECID_WiMax_LocationServerErrorCauses_cause,
        OMA_LPPe_ECID_WiMax_LocationServerErrorCauses,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_cause,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_rTDMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_rTDstdMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrelDelayMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrelDelaystdMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrSSIMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRrSSIstdMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRbSTxPowerMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRcINRMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRcINRstdMeasurementNotPossible,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_nMRbSLocationNotAvailable,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_non_servingMeasurementsNotAvailable,
        _OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses_historicMeasurementsNotAvailable,
        OMA_LPPe_ECID_WiMax_TargetDeviceErrorCauses,
        _OMA_LPPe_Sensor_ProvideAssistanceData_atmosphericPressureAD,
        OMA_LPPe_Sensor_ProvideAssistanceData,
        _OMA_LPPe_AtmosphericPressureAD_referencePressure,
        __OMA_LPPe_AtmosphericPressureAD_period_pressureValidityPeriod,
        __OMA_LPPe_AtmosphericPressureAD_period_referencePressureRate,
        _OMA_LPPe_AtmosphericPressureAD_period,
        __OMA_LPPe_AtmosphericPressureAD_area_pressureValidityArea,
        __OMA_LPPe_AtmosphericPressureAD_area_gN_pressure,
        __OMA_LPPe_AtmosphericPressureAD_area_gE_pressure,
        _OMA_LPPe_AtmosphericPressureAD_area,
        OMA_LPPe_AtmosphericPressureAD,
        _OMA_LPPe_PressureValidityArea_centerPoint,
        _OMA_LPPe_PressureValidityArea_validityAreaWidth,
        _OMA_LPPe_PressureValidityArea_validityAreaHeight,
        OMA_LPPe_PressureValidityArea,
        _OMA_LPPe_Sensor_RequestAssistanceData_pressureSensorAD,
        OMA_LPPe_Sensor_RequestAssistanceData,
        OMA_LPPe_PressureSensorAD,
        _OMA_LPPe_Sensor_ProvideLocationInformation_motionStateList,
        _OMA_LPPe_Sensor_ProvideLocationInformation_sensorError,
        OMA_LPPe_Sensor_ProvideLocationInformation,
        _OMA_LPPe_Sensor_MotionStateList__item_,
        OMA_LPPe_Sensor_MotionStateList,
        _OMA_LPPe_Sensor_MotionStateElement_primaryMotionState,
        _OMA_LPPe_Sensor_MotionStateElement_confidence,
        _OMA_LPPe_Sensor_MotionStateElement_secondaryMotionState,
        OMA_LPPe_Sensor_MotionStateElement,
        _OMA_LPPe_Sensor_RequestLocationInformation_motionStateReq,
        OMA_LPPe_Sensor_RequestLocationInformation,
        _OMA_LPPe_Sensor_MotionStateRequest_secondaryMotionStateRequest,
        OMA_LPPe_Sensor_MotionStateRequest,
        _OMA_LPPe_Sensor_ProvideCapabilities_motionStateSupport,
        _OMA_LPPe_Sensor_ProvideCapabilities_secondarySupport,
        _OMA_LPPe_Sensor_ProvideCapabilities_barometricPressureSupport,
        OMA_LPPe_Sensor_ProvideCapabilities,
        OMA_LPPe_Sensor_RequestCapabilities,
        _OMA_LPPe_Sensor_Error_targetError,
        OMA_LPPe_Sensor_Error,
        _OMA_LPPe_Sensor_TargetError_motionStateError,
        _OMA_LPPe_Sensor_TargetError_secondaryMotionStateError,
        OMA_LPPe_Sensor_TargetError,
        __OMA_LPPe_SRN_ProvideAssistanceData_srnGroup_srnGroupList,
        __OMA_LPPe_SRN_ProvideAssistanceData_srnGroup_srnGroupUpdateResponse,
        _OMA_LPPe_SRN_ProvideAssistanceData_srnGroup,
        _OMA_LPPe_SRN_ProvideAssistanceData_antennaPattern,
        _OMA_LPPe_SRN_ProvideAssistanceData_srnError,
        OMA_LPPe_SRN_ProvideAssistanceData,
        _OMA_LPPe_SRN_SRNgroupList_incompleteFlag,
        _OMA_LPPe_SRN_SRNgroupList_defaultReferencePoint,
        __OMA_LPPe_SRN_SRNgroupList_groupList__item_,
        _OMA_LPPe_SRN_SRNgroupList_groupList,
        OMA_LPPe_SRN_SRNgroupList,
        _OMA_LPPe_SRN_SRNgroup_srnGroupID,
        _OMA_LPPe_SRN_SRNgroup_defaultSRNtype,
        _OMA_LPPe_SRN_SRNgroup_referencePoint,
        _OMA_LPPe_SRN_SRNgroup_globalOrientation,
        __OMA_LPPe_SRN_SRNgroup_srnsInGroupList__item_,
        _OMA_LPPe_SRN_SRNgroup_srnsInGroupList,
        OMA_LPPe_SRN_SRNgroup,
        _OMA_LPPe_SRN_SRNinfo_srnID,
        _OMA_LPPe_SRN_SRNinfo_srnType,
        _OMA_LPPe_SRN_SRNinfo_relativePosition,
        _OMA_LPPe_SRN_SRNinfo_orientation,
        OMA_LPPe_SRN_SRNinfo,
        _OMA_LPPe_SRN_SRNgroupUpdateResponse__item_,
        OMA_LPPe_SRN_SRNgroupUpdateResponse,
        _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_srnGroupID,
        _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_targetDataValidity,
        _OMA_LPPe_SRN_SRNgroupUpdateResponseElement_updatedSRNgroup,
        OMA_LPPe_SRN_SRNgroupUpdateResponseElement,
        _OMA_LPPe_SRN_AntennaPattern__item_,
        OMA_LPPe_SRN_AntennaPattern,
        __OMA_LPPe_SRN_AntennaPatternElement_identification_vendorOrOperator,
        __OMA_LPPe_SRN_AntennaPatternElement_identification_antennaPatternID,
        _OMA_LPPe_SRN_AntennaPatternElement_identification,
        __OMA_LPPe_SRN_AntennaPatternElement_antennaData_antennaPattern,
        __OMA_LPPe_SRN_AntennaPatternElement_antennaData_antennaContainer,
        _OMA_LPPe_SRN_AntennaPatternElement_antennaData,
        OMA_LPPe_SRN_AntennaPatternElement,
        __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inAzimuth,
        __OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid_inElevation,
        _OMA_LPPe_SRN_AntennaPatternForChannels_evenGrid,
        __OMA_LPPe_SRN_AntennaPatternForChannels_patternList__item_,
        _OMA_LPPe_SRN_AntennaPatternForChannels_patternList,
        OMA_LPPe_SRN_AntennaPatternForChannels,
        _OMA_LPPe_SRN_ChannelResponse_channelNumber,
        __OMA_LPPe_SRN_ChannelResponse_responseInElevation__item_,
        _OMA_LPPe_SRN_ChannelResponse_responseInElevation,
        OMA_LPPe_SRN_ChannelResponse,
        _OMA_LPPe_SRN_ResponseInElevation_elevation,
        __OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth__item_,
        _OMA_LPPe_SRN_ResponseInElevation_responseInAzimuth,
        OMA_LPPe_SRN_ResponseInElevation,
        _OMA_LPPe_SRN_ResponseInAzimuth_azimuth,
        _OMA_LPPe_SRN_ResponseInAzimuth_response,
        OMA_LPPe_SRN_ResponseInAzimuth,
        _OMA_LPPe_ComplexNumber_amplitude,
        _OMA_LPPe_ComplexNumber_phase,
        OMA_LPPe_ComplexNumber,
        maxChannels,
        __OMA_LPPe_SRN_RequestAssistanceData_srnGroup_srnGroupRequest,
        __OMA_LPPe_SRN_RequestAssistanceData_srnGroup_srnGroupUpdateRequest,
        _OMA_LPPe_SRN_RequestAssistanceData_srnGroup,
        _OMA_LPPe_SRN_RequestAssistanceData_antennaPatternRequest,
        OMA_LPPe_SRN_RequestAssistanceData,
        _OMA_LPPe_SRN_SRNgroupRequest_doNotProvideList,
        _OMA_LPPe_SRN_SRNgroupRequest_doProvideList,
        OMA_LPPe_SRN_SRNgroupRequest,
        __OMA_LPPe_SRN_SRNProvideList_groupList__item_,
        _OMA_LPPe_SRN_SRNProvideList_groupList,
        __OMA_LPPe_SRN_SRNProvideList_categoryList__item_,
        _OMA_LPPe_SRN_SRNProvideList_categoryList,
        OMA_LPPe_SRN_SRNProvideList,
        _OMA_LPPe_SRN_SRNgroupUpdateRequest__item_,
        OMA_LPPe_SRN_SRNgroupUpdateRequest,
        _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_srnGroupID,
        _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_provideIndicationOnly,
        __OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup__item_,
        _OMA_LPPe_SRN_SRNgroupUpdateRequestElement_inTheGroup,
        OMA_LPPe_SRN_SRNgroupUpdateRequestElement,
        _OMA_LPPe_SRN_AntennaPatternRequest__item_,
        OMA_LPPe_SRN_AntennaPatternRequest,
        __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_vendorOrOperator,
        __OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID_antennaPatternID,
        _OMA_LPPe_SRN_AntennaPatternRequestElement_antennaPatternID,
        OMA_LPPe_SRN_AntennaPatternRequestElement,
        __OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList__item_,
        _OMA_LPPe_SRN_ProvideLocationInformation_srnMeasurementList,
        _OMA_LPPe_SRN_ProvideLocationInformation_srnError,
        OMA_LPPe_SRN_ProvideLocationInformation,
        _OMA_LPPe_SRN_MeasurementElement_srnID,
        _OMA_LPPe_SRN_MeasurementElement_srnCategory,
        _OMA_LPPe_SRN_MeasurementElement_srnGroupID,
        __OMA_LPPe_SRN_MeasurementElement_measurementList__item_,
        _OMA_LPPe_SRN_MeasurementElement_measurementList,
        OMA_LPPe_SRN_MeasurementElement,
        _OMA_LPPe_SRN_srnMeasurementElement_relativeTimeStamp,
        _OMA_LPPe_SRN_srnMeasurementElement_rssi,
        _OMA_LPPe_SRN_srnMeasurementElement_rtd,
        OMA_LPPe_SRN_srnMeasurementElement,
        __OMA_LPPe_SRN_RequestLocationInformation_requestInfo__item_,
        _OMA_LPPe_SRN_RequestLocationInformation_requestInfo,
        OMA_LPPe_SRN_RequestLocationInformation,
        _OMA_LPPe_SRN_ReqLocInfo_Category_category,
        _OMA_LPPe_SRN_ReqLocInfo_Category_multipleMeasurements,
        _OMA_LPPe_SRN_ReqLocInfo_Category_allowedMeasurements,
        _OMA_LPPe_SRN_ReqLocInfo_Category_historicMeasurementsRequested,
        OMA_LPPe_SRN_ReqLocInfo_Category,
        __OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory__item_,
        _OMA_LPPe_SRN_ProvideCapabilities_capabilitiesPerSRNCategory,
        OMA_LPPe_SRN_ProvideCapabilities,
        _OMA_LPPe_SRN_ProvideCapabilitiesElement_srnCategory,
        _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedMeasurements,
        _OMA_LPPe_SRN_ProvideCapabilitiesElement_supportedAssistanceData,
        _OMA_LPPe_SRN_ProvideCapabilitiesElement_historicMeasurementsSupported,
        OMA_LPPe_SRN_ProvideCapabilitiesElement,
        __OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor__item_,
        _OMA_LPPe_SRN_RequestCapabilities_capabilitiesRequestedFor,
        OMA_LPPe_SRN_RequestCapabilities,
        _OMA_LPPe_SRN_Error_srnLocationServerErrorCauses,
        _OMA_LPPe_SRN_Error_srnTargetDeviceErrorCauses,
        OMA_LPPe_SRN_Error,
        _OMA_LPPe_SRN_LocationServerErrorCauses_groupErrors,
        _OMA_LPPe_SRN_LocationServerErrorCauses_groupUpdateErrors,
        _OMA_LPPe_SRN_LocationServerErrorCauses_srnAntennaErrors,
        OMA_LPPe_SRN_LocationServerErrorCauses,
        __OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory__item_,
        _OMA_LPPe_SRN_TargetDeviceErrorCauses_srnErrorsPerCategory,
        OMA_LPPe_SRN_TargetDeviceErrorCauses,
        _OMA_LPPe_SRN_TargetDeviceError_category,
        _OMA_LPPe_SRN_TargetDeviceError_srnErrors,
        _OMA_LPPe_SRN_TargetDeviceError_rssiNotAvailable,
        _OMA_LPPe_SRN_TargetDeviceError_rtdNotAvailable,
        _OMA_LPPe_SRN_TargetDeviceError_multipleSetsNotAvailable,
        _OMA_LPPe_SRN_TargetDeviceError_historicMeasurementsNotAvailable,
        OMA_LPPe_SRN_TargetDeviceError,
        _OMA_LPPe_SRN_SRNgroupUniqueID_providerID,
        _OMA_LPPe_SRN_SRNgroupUniqueID_providerAssignedID,
        _OMA_LPPe_SRN_SRNgroupUniqueID_srnDataVersion,
        OMA_LPPe_SRN_SRNgroupUniqueID,
        _OMA_LPPe_SRN_SRNtype_srnCategory,
        _OMA_LPPe_SRN_SRNtype_srnERP,
        __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_antennaPatternID,
        __OMA_LPPe_SRN_SRNtype_srnAntennaInfo_switchingPatternID,
        _OMA_LPPe_SRN_SRNtype_srnAntennaInfo,
        OMA_LPPe_SRN_SRNtype,
        _OMA_LPPe_SRN_Category_srnTechnologyType,
        __OMA_LPPe_SRN_Category_srnVendorInformation_vendor,
        __OMA_LPPe_SRN_Category_srnVendorInformation_vendorInfo,
        _OMA_LPPe_SRN_Category_srnVendorInformation,
        OMA_LPPe_SRN_Category,
        __OMA_LPPe_SRN_SRNid_srn_id_mac,
        ___OMA_LPPe_SRN_SRNid_srn_id_nfc_manufacturer,
        ___OMA_LPPe_SRN_SRNid_srn_id_nfc_uniqueNumber,
        __OMA_LPPe_SRN_SRNid_srn_id_nfc,
        ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_registryID,
        ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_remainingPart,
        ___OMA_LPPe_SRN_SRNid_srn_id_mobileCode_resolutionIdentifier,
        __OMA_LPPe_SRN_SRNid_srn_id_mobileCode,
        __OMA_LPPe_SRN_SRNid_srn_id_other,
        _OMA_LPPe_SRN_SRNid_srn_id,
        OMA_LPPe_SRN_SRNid,
        _OMA_LPPe_SRN_Technologies_srnTechnologies,
        OMA_LPPe_SRN_Technologies,
        _OMA_LPPe_SRN_MeasurementMask_srnMeasurements,
        OMA_LPPe_SRN_MeasurementMask,
    ]

init_modules(LPP_PDU_Definitions, OMA_LPPE)
